// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles

(function (modules, entry, mainEntry, parcelRequireName, globalName) {
  /* eslint-disable no-undef */
  var globalObject =
    typeof globalThis !== 'undefined'
      ? globalThis
      : typeof self !== 'undefined'
      ? self
      : typeof window !== 'undefined'
      ? window
      : typeof global !== 'undefined'
      ? global
      : {};
  /* eslint-enable no-undef */

  // Save the require from previous bundle to this closure if any
  var previousRequire =
    typeof globalObject[parcelRequireName] === 'function' &&
    globalObject[parcelRequireName];

  var cache = previousRequire.cache || {};
  // Do not use `require` to prevent Webpack from trying to bundle this call
  var nodeRequire =
    typeof module !== 'undefined' &&
    typeof module.require === 'function' &&
    module.require.bind(module);

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire =
          typeof globalObject[parcelRequireName] === 'function' &&
          globalObject[parcelRequireName];
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error("Cannot find module '" + name + "'");
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = (cache[name] = new newRequire.Module(name));

      modules[name][0].call(
        module.exports,
        localRequire,
        module,
        module.exports,
        this
      );
    }

    return cache[name].exports;

    function localRequire(x) {
      var res = localRequire.resolve(x);
      return res === false ? {} : newRequire(res);
    }

    function resolve(x) {
      var id = modules[name][1][x];
      return id != null ? id : x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [
      function (require, module) {
        module.exports = exports;
      },
      {},
    ];
  };

  Object.defineProperty(newRequire, 'root', {
    get: function () {
      return globalObject[parcelRequireName];
    },
  });

  globalObject[parcelRequireName] = newRequire;

  for (var i = 0; i < entry.length; i++) {
    newRequire(entry[i]);
  }

  if (mainEntry) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(mainEntry);

    // CommonJS
    if (typeof exports === 'object' && typeof module !== 'undefined') {
      module.exports = mainExports;

      // RequireJS
    } else if (typeof define === 'function' && define.amd) {
      define(function () {
        return mainExports;
      });

      // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }
})({"8vtpn":[function(require,module,exports) {
var global = arguments[3];
var HMR_HOST = null;
var HMR_PORT = null;
var HMR_SECURE = false;
var HMR_ENV_HASH = "d6ea1d42532a7575";
module.bundle.HMR_BUNDLE_ID = "b5dac773acc158c0";
"use strict";
/* global HMR_HOST, HMR_PORT, HMR_ENV_HASH, HMR_SECURE, chrome, browser, globalThis, __parcel__import__, __parcel__importScripts__, ServiceWorkerGlobalScope */ /*::
import type {
  HMRAsset,
  HMRMessage,
} from '@parcel/reporter-dev-server/src/HMRServer.js';
interface ParcelRequire {
  (string): mixed;
  cache: {|[string]: ParcelModule|};
  hotData: mixed;
  Module: any;
  parent: ?ParcelRequire;
  isParcelRequire: true;
  modules: {|[string]: [Function, {|[string]: string|}]|};
  HMR_BUNDLE_ID: string;
  root: ParcelRequire;
}
interface ParcelModule {
  hot: {|
    data: mixed,
    accept(cb: (Function) => void): void,
    dispose(cb: (mixed) => void): void,
    // accept(deps: Array<string> | string, cb: (Function) => void): void,
    // decline(): void,
    _acceptCallbacks: Array<(Function) => void>,
    _disposeCallbacks: Array<(mixed) => void>,
  |};
}
interface ExtensionContext {
  runtime: {|
    reload(): void,
    getURL(url: string): string;
    getManifest(): {manifest_version: number, ...};
  |};
}
declare var module: {bundle: ParcelRequire, ...};
declare var HMR_HOST: string;
declare var HMR_PORT: string;
declare var HMR_ENV_HASH: string;
declare var HMR_SECURE: boolean;
declare var chrome: ExtensionContext;
declare var browser: ExtensionContext;
declare var __parcel__import__: (string) => Promise<void>;
declare var __parcel__importScripts__: (string) => Promise<void>;
declare var globalThis: typeof self;
declare var ServiceWorkerGlobalScope: Object;
*/ var OVERLAY_ID = "__parcel__error__overlay__";
var OldModule = module.bundle.Module;
function Module(moduleName) {
    OldModule.call(this, moduleName);
    this.hot = {
        data: module.bundle.hotData,
        _acceptCallbacks: [],
        _disposeCallbacks: [],
        accept: function(fn) {
            this._acceptCallbacks.push(fn || function() {});
        },
        dispose: function(fn) {
            this._disposeCallbacks.push(fn);
        }
    };
    module.bundle.hotData = undefined;
}
module.bundle.Module = Module;
var checkedAssets, acceptedAssets, assetsToAccept /*: Array<[ParcelRequire, string]> */ ;
function getHostname() {
    return HMR_HOST || (location.protocol.indexOf("http") === 0 ? location.hostname : "localhost");
}
function getPort() {
    return HMR_PORT || location.port;
} // eslint-disable-next-line no-redeclare
var parent = module.bundle.parent;
if ((!parent || !parent.isParcelRequire) && typeof WebSocket !== "undefined") {
    var hostname = getHostname();
    var port = getPort();
    var protocol = HMR_SECURE || location.protocol == "https:" && !/localhost|127.0.0.1|0.0.0.0/.test(hostname) ? "wss" : "ws";
    var ws = new WebSocket(protocol + "://" + hostname + (port ? ":" + port : "") + "/"); // Web extension context
    var extCtx = typeof chrome === "undefined" ? typeof browser === "undefined" ? null : browser : chrome; // Safari doesn't support sourceURL in error stacks.
    // eval may also be disabled via CSP, so do a quick check.
    var supportsSourceURL = false;
    try {
        (0, eval)('throw new Error("test"); //# sourceURL=test.js');
    } catch (err) {
        supportsSourceURL = err.stack.includes("test.js");
    } // $FlowFixMe
    ws.onmessage = async function(event) {
        checkedAssets = {} /*: {|[string]: boolean|} */ ;
        acceptedAssets = {} /*: {|[string]: boolean|} */ ;
        assetsToAccept = [];
        var data = JSON.parse(event.data);
        if (data.type === "update") {
            // Remove error overlay if there is one
            if (typeof document !== "undefined") removeErrorOverlay();
            let assets = data.assets.filter((asset)=>asset.envHash === HMR_ENV_HASH); // Handle HMR Update
            let handled = assets.every((asset)=>{
                return asset.type === "css" || asset.type === "js" && hmrAcceptCheck(module.bundle.root, asset.id, asset.depsByBundle);
            });
            if (handled) {
                console.clear(); // Dispatch custom event so other runtimes (e.g React Refresh) are aware.
                if (typeof window !== "undefined" && typeof CustomEvent !== "undefined") window.dispatchEvent(new CustomEvent("parcelhmraccept"));
                await hmrApplyUpdates(assets);
                for(var i = 0; i < assetsToAccept.length; i++){
                    var id = assetsToAccept[i][1];
                    if (!acceptedAssets[id]) hmrAcceptRun(assetsToAccept[i][0], id);
                }
            } else fullReload();
        }
        if (data.type === "error") {
            // Log parcel errors to console
            for (let ansiDiagnostic of data.diagnostics.ansi){
                let stack = ansiDiagnostic.codeframe ? ansiDiagnostic.codeframe : ansiDiagnostic.stack;
                console.error("\uD83D\uDEA8 [parcel]: " + ansiDiagnostic.message + "\n" + stack + "\n\n" + ansiDiagnostic.hints.join("\n"));
            }
            if (typeof document !== "undefined") {
                // Render the fancy html overlay
                removeErrorOverlay();
                var overlay = createErrorOverlay(data.diagnostics.html); // $FlowFixMe
                document.body.appendChild(overlay);
            }
        }
    };
    ws.onerror = function(e) {
        console.error(e.message);
    };
    ws.onclose = function() {
        console.warn("[parcel] \uD83D\uDEA8 Connection to the HMR server was lost");
    };
}
function removeErrorOverlay() {
    var overlay = document.getElementById(OVERLAY_ID);
    if (overlay) {
        overlay.remove();
        console.log("[parcel] ✨ Error resolved");
    }
}
function createErrorOverlay(diagnostics) {
    var overlay = document.createElement("div");
    overlay.id = OVERLAY_ID;
    let errorHTML = '<div style="background: black; opacity: 0.85; font-size: 16px; color: white; position: fixed; height: 100%; width: 100%; top: 0px; left: 0px; padding: 30px; font-family: Menlo, Consolas, monospace; z-index: 9999;">';
    for (let diagnostic of diagnostics){
        let stack = diagnostic.frames.length ? diagnostic.frames.reduce((p, frame)=>{
            return `${p}
<a href="/__parcel_launch_editor?file=${encodeURIComponent(frame.location)}" style="text-decoration: underline; color: #888" onclick="fetch(this.href); return false">${frame.location}</a>
${frame.code}`;
        }, "") : diagnostic.stack;
        errorHTML += `
      <div>
        <div style="font-size: 18px; font-weight: bold; margin-top: 20px;">
          🚨 ${diagnostic.message}
        </div>
        <pre>${stack}</pre>
        <div>
          ${diagnostic.hints.map((hint)=>"<div>\uD83D\uDCA1 " + hint + "</div>").join("")}
        </div>
        ${diagnostic.documentation ? `<div>📝 <a style="color: violet" href="${diagnostic.documentation}" target="_blank">Learn more</a></div>` : ""}
      </div>
    `;
    }
    errorHTML += "</div>";
    overlay.innerHTML = errorHTML;
    return overlay;
}
function fullReload() {
    if ("reload" in location) location.reload();
    else if (extCtx && extCtx.runtime && extCtx.runtime.reload) extCtx.runtime.reload();
}
function getParents(bundle, id) /*: Array<[ParcelRequire, string]> */ {
    var modules = bundle.modules;
    if (!modules) return [];
    var parents = [];
    var k, d, dep;
    for(k in modules)for(d in modules[k][1]){
        dep = modules[k][1][d];
        if (dep === id || Array.isArray(dep) && dep[dep.length - 1] === id) parents.push([
            bundle,
            k
        ]);
    }
    if (bundle.parent) parents = parents.concat(getParents(bundle.parent, id));
    return parents;
}
function updateLink(link) {
    var newLink = link.cloneNode();
    newLink.onload = function() {
        if (link.parentNode !== null) // $FlowFixMe
        link.parentNode.removeChild(link);
    };
    newLink.setAttribute("href", link.getAttribute("href").split("?")[0] + "?" + Date.now()); // $FlowFixMe
    link.parentNode.insertBefore(newLink, link.nextSibling);
}
var cssTimeout = null;
function reloadCSS() {
    if (cssTimeout) return;
    cssTimeout = setTimeout(function() {
        var links = document.querySelectorAll('link[rel="stylesheet"]');
        for(var i = 0; i < links.length; i++){
            // $FlowFixMe[incompatible-type]
            var href = links[i].getAttribute("href");
            var hostname = getHostname();
            var servedFromHMRServer = hostname === "localhost" ? new RegExp("^(https?:\\/\\/(0.0.0.0|127.0.0.1)|localhost):" + getPort()).test(href) : href.indexOf(hostname + ":" + getPort());
            var absolute = /^https?:\/\//i.test(href) && href.indexOf(location.origin) !== 0 && !servedFromHMRServer;
            if (!absolute) updateLink(links[i]);
        }
        cssTimeout = null;
    }, 50);
}
function hmrDownload(asset) {
    if (asset.type === "js") {
        if (typeof document !== "undefined") {
            let script = document.createElement("script");
            script.src = asset.url + "?t=" + Date.now();
            if (asset.outputFormat === "esmodule") script.type = "module";
            return new Promise((resolve, reject)=>{
                var _document$head;
                script.onload = ()=>resolve(script);
                script.onerror = reject;
                (_document$head = document.head) === null || _document$head === void 0 || _document$head.appendChild(script);
            });
        } else if (typeof importScripts === "function") {
            // Worker scripts
            if (asset.outputFormat === "esmodule") return import(asset.url + "?t=" + Date.now());
            else return new Promise((resolve, reject)=>{
                try {
                    importScripts(asset.url + "?t=" + Date.now());
                    resolve();
                } catch (err) {
                    reject(err);
                }
            });
        }
    }
}
async function hmrApplyUpdates(assets) {
    global.parcelHotUpdate = Object.create(null);
    let scriptsToRemove;
    try {
        // If sourceURL comments aren't supported in eval, we need to load
        // the update from the dev server over HTTP so that stack traces
        // are correct in errors/logs. This is much slower than eval, so
        // we only do it if needed (currently just Safari).
        // https://bugs.webkit.org/show_bug.cgi?id=137297
        // This path is also taken if a CSP disallows eval.
        if (!supportsSourceURL) {
            let promises = assets.map((asset)=>{
                var _hmrDownload;
                return (_hmrDownload = hmrDownload(asset)) === null || _hmrDownload === void 0 ? void 0 : _hmrDownload.catch((err)=>{
                    // Web extension bugfix for Chromium
                    // https://bugs.chromium.org/p/chromium/issues/detail?id=1255412#c12
                    if (extCtx && extCtx.runtime && extCtx.runtime.getManifest().manifest_version == 3) {
                        if (typeof ServiceWorkerGlobalScope != "undefined" && global instanceof ServiceWorkerGlobalScope) {
                            extCtx.runtime.reload();
                            return;
                        }
                        asset.url = extCtx.runtime.getURL("/__parcel_hmr_proxy__?url=" + encodeURIComponent(asset.url + "?t=" + Date.now()));
                        return hmrDownload(asset);
                    }
                    throw err;
                });
            });
            scriptsToRemove = await Promise.all(promises);
        }
        assets.forEach(function(asset) {
            hmrApply(module.bundle.root, asset);
        });
    } finally{
        delete global.parcelHotUpdate;
        if (scriptsToRemove) scriptsToRemove.forEach((script)=>{
            if (script) {
                var _document$head2;
                (_document$head2 = document.head) === null || _document$head2 === void 0 || _document$head2.removeChild(script);
            }
        });
    }
}
function hmrApply(bundle, asset) {
    var modules = bundle.modules;
    if (!modules) return;
    if (asset.type === "css") reloadCSS();
    else if (asset.type === "js") {
        let deps = asset.depsByBundle[bundle.HMR_BUNDLE_ID];
        if (deps) {
            if (modules[asset.id]) {
                // Remove dependencies that are removed and will become orphaned.
                // This is necessary so that if the asset is added back again, the cache is gone, and we prevent a full page reload.
                let oldDeps = modules[asset.id][1];
                for(let dep in oldDeps)if (!deps[dep] || deps[dep] !== oldDeps[dep]) {
                    let id = oldDeps[dep];
                    let parents = getParents(module.bundle.root, id);
                    if (parents.length === 1) hmrDelete(module.bundle.root, id);
                }
            }
            if (supportsSourceURL) // Global eval. We would use `new Function` here but browser
            // support for source maps is better with eval.
            (0, eval)(asset.output);
             // $FlowFixMe
            let fn = global.parcelHotUpdate[asset.id];
            modules[asset.id] = [
                fn,
                deps
            ];
        } else if (bundle.parent) hmrApply(bundle.parent, asset);
    }
}
function hmrDelete(bundle, id) {
    let modules = bundle.modules;
    if (!modules) return;
    if (modules[id]) {
        // Collect dependencies that will become orphaned when this module is deleted.
        let deps = modules[id][1];
        let orphans = [];
        for(let dep in deps){
            let parents = getParents(module.bundle.root, deps[dep]);
            if (parents.length === 1) orphans.push(deps[dep]);
        } // Delete the module. This must be done before deleting dependencies in case of circular dependencies.
        delete modules[id];
        delete bundle.cache[id]; // Now delete the orphans.
        orphans.forEach((id)=>{
            hmrDelete(module.bundle.root, id);
        });
    } else if (bundle.parent) hmrDelete(bundle.parent, id);
}
function hmrAcceptCheck(bundle, id, depsByBundle) {
    if (hmrAcceptCheckOne(bundle, id, depsByBundle)) return true;
     // Traverse parents breadth first. All possible ancestries must accept the HMR update, or we'll reload.
    let parents = getParents(module.bundle.root, id);
    let accepted = false;
    while(parents.length > 0){
        let v = parents.shift();
        let a = hmrAcceptCheckOne(v[0], v[1], null);
        if (a) // If this parent accepts, stop traversing upward, but still consider siblings.
        accepted = true;
        else {
            // Otherwise, queue the parents in the next level upward.
            let p = getParents(module.bundle.root, v[1]);
            if (p.length === 0) {
                // If there are no parents, then we've reached an entry without accepting. Reload.
                accepted = false;
                break;
            }
            parents.push(...p);
        }
    }
    return accepted;
}
function hmrAcceptCheckOne(bundle, id, depsByBundle) {
    var modules = bundle.modules;
    if (!modules) return;
    if (depsByBundle && !depsByBundle[bundle.HMR_BUNDLE_ID]) {
        // If we reached the root bundle without finding where the asset should go,
        // there's nothing to do. Mark as "accepted" so we don't reload the page.
        if (!bundle.parent) return true;
        return hmrAcceptCheck(bundle.parent, id, depsByBundle);
    }
    if (checkedAssets[id]) return true;
    checkedAssets[id] = true;
    var cached = bundle.cache[id];
    assetsToAccept.push([
        bundle,
        id
    ]);
    if (!cached || cached.hot && cached.hot._acceptCallbacks.length) return true;
}
function hmrAcceptRun(bundle, id) {
    var cached = bundle.cache[id];
    bundle.hotData = {};
    if (cached && cached.hot) cached.hot.data = bundle.hotData;
    if (cached && cached.hot && cached.hot._disposeCallbacks.length) cached.hot._disposeCallbacks.forEach(function(cb) {
        cb(bundle.hotData);
    });
    delete bundle.cache[id];
    bundle(id);
    cached = bundle.cache[id];
    if (cached && cached.hot && cached.hot._acceptCallbacks.length) cached.hot._acceptCallbacks.forEach(function(cb) {
        var assetsToAlsoAccept = cb(function() {
            return getParents(module.bundle.root, id);
        });
        if (assetsToAlsoAccept && assetsToAccept.length) // $FlowFixMe[method-unbinding]
        assetsToAccept.push.apply(assetsToAccept, assetsToAlsoAccept);
    });
    acceptedAssets[id] = true;
}

},{}],"eoJgJ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
var _extends = require("@babel/runtime/helpers/extends");
var _extendsDefault = parcelHelpers.interopDefault(_extends);
var _i18N = require("./i18n");
var _errorTracking = require("./error-tracking");
var _preact = require("preact");
var _hooks = require("preact/hooks");
var _reactI18Next = require("react-i18next");
var _bus = require("./utils/bus");
var _fetchCache = require("./utils/fetchCache");
var _fetchCacheDefault = parcelHelpers.interopDefault(_fetchCache);
var _setIcon = require("../utils/setIcon");
var _setIconDefault = parcelHelpers.interopDefault(_setIcon);
var _arrivalTimeText = require("./components/ArrivalTimeText");
var _arrivalTimeTextDefault = parcelHelpers.interopDefault(_arrivalTimeText);
var _localeSelector = require("./components/LocaleSelector");
var _localeSelectorDefault = parcelHelpers.interopDefault(_localeSelector);
var _wheelchairSvg = require("./images/wheelchair.svg");
var _wheelchairSvgDefault = parcelHelpers.interopDefault(_wheelchairSvg);
var _wheelchairInaccessibleSvg = require("./images/wheelchair-inaccessible.svg");
var _wheelchairInaccessibleSvgDefault = parcelHelpers.interopDefault(_wheelchairInaccessibleSvg);
var _busSingleSvg = require("./images/bus-single.svg");
var _busSingleSvgDefault = parcelHelpers.interopDefault(_busSingleSvg);
var _busDoubleSvg = require("./images/bus-double.svg");
var _busDoubleSvgDefault = parcelHelpers.interopDefault(_busDoubleSvg);
var _busBendySvg = require("./images/bus-bendy.svg");
var _busBendySvgDefault = parcelHelpers.interopDefault(_busBendySvg);
const dataPath = "https://data.busrouter.sg/v1/";
const stopsJSONPath = dataPath + "stops.min.json";
const BUSES = {
    sd: {
        alt: "Single deck bus",
        src: (0, _busSingleSvgDefault.default),
        width: 20
    },
    dd: {
        alt: "Double deck bus",
        src: (0, _busDoubleSvgDefault.default),
        width: 20
    },
    bd: {
        alt: "Bendy bus",
        src: (0, _busBendySvgDefault.default),
        width: 26
    }
};
const WheelChair = ({ size =11  })=>(0, _preact.h)("img", {
        src: (0, _wheelchairSvgDefault.default),
        width: size,
        height: size,
        alt: "Wheelchair accessible"
    });
const WheelChairInaccessible = ({ size =11  })=>(0, _preact.h)("img", {
        src: (0, _wheelchairInaccessibleSvgDefault.default),
        width: size,
        height: size,
        alt: "Wheelchair inaccessible"
    });
const Bus = (props)=>{
    const { maxPx , index , duration_ms , type , load , feature , _ghost , _id  } = props;
    const busImage = BUSES[type.toLowerCase()];
    const prevPx = (0, _hooks.useRef)();
    const px = duration_ms / 1000 / 60 * (duration_ms > 0 ? 10 : 2.5);
    const busTooFar = px > maxPx - 30; // 30 = bus width
    const pxFar = 90 + index * 2; // index = zero-based
    (0, _hooks.useEffect)(()=>{
        prevPx.current = px;
    }, [
        px
    ]);
    let time = 1; // 1 second
    if (prevPx.current) {
        const distance = Math.abs(prevPx.current - px);
        time = distance / 10;
    }
    return (0, _preact.h)("span", {
        id: _id ? `bus-${_id}` : null,
        class: `bus ${_ghost ? "ghost" : ""}`,
        style: {
            marginLeft: busTooFar ? pxFar + "%" : px.toFixed(1) + "px",
            transitionDuration: `${time}s`
        }
    }, (0, _preact.h)("span", {
        class: "bus-float"
    }, (0, _preact.h)("img", busImage), (0, _preact.h)("br", null), (0, _preact.h)("span", {
        class: `time time-${load.toLowerCase()}`
    }, (0, _preact.h)((0, _arrivalTimeTextDefault.default), {
        ms: duration_ms
    })), feature.toLowerCase() !== "wab" && (0, _preact.h)(WheelChairInaccessible, null)));
};
let BUSID = 1;
const busID = ()=>BUSID++;
const isSameBus = (b1, b2)=>b1.feature === b2.feature && b1.type === b2.type && b1.visit_number === b2.visit_number && b1.origin_code === b2.origin_code && b1.destination_code === b2.destination_code;
const isSameBuses = (b1, b2)=>b1.map((b)=>b._id).join() === b2.map((b)=>b._id).join();
function BusLane({ index , no , buses  }) {
    const prevNo = (0, _hooks.useRef)();
    const prevBuses = (0, _hooks.useRef)();
    const nextBuses = buses.filter((nb)=>typeof nb?.duration_ms === "number");
    if (prevNo.current === no && !isSameBuses(prevBuses.current, nextBuses)) {
        nextBuses.forEach((nb)=>{
            delete nb._id;
        });
        const pBuses = prevBuses.current.filter((b)=>!b._ghost); // Remove previously ghosted buses
        pBuses.forEach((b, i)=>{
            // Next bus requirements/checks
            // - Within range of duration_ms of current bus
            // - Not assigned with ID (possibly from previous loop execution)
            // - Same bus type as current bus
            const latestNextBus = nextBuses.find((nb)=>{
                if (nb._id || !isSameBus(b, nb)) return false;
                const d = (nb.duration_ms - b.duration_ms) / 1000 / 60;
                return d > -5 && d < 3;
            });
            if (latestNextBus) latestNextBus._id = b._id; // Assign ID for marking
            else {
                // Insert "ghost" bus that will dissapear into thin air
                b._ghost = true;
                nextBuses.splice(i, 0, b);
            }
        });
    }
    nextBuses.forEach((nb)=>{
        if (!nb._id) nb._id = busID();
    });
    // DEBUGGING
    // const prevBusesClone = structuredClone(prevBuses.current);
    // const nextBusesClone = structuredClone(nextBuses);
    // if (no == 315) {
    //   console.log(
    //     no,
    //     prevBusesClone?.map((b) => b._id)?.join(),
    //     nextBusesClone?.map((b) => b._id)?.join(),
    //   );
    // }
    (0, _hooks.useEffect)(()=>{
        prevNo.current = no;
        prevBuses.current = structuredClone(nextBuses);
    }, [
        no,
        nextBuses
    ]);
    const busLaneRef = (0, _hooks.useRef)();
    const [busLaneWidth, setBusLaneWidth] = (0, _hooks.useState)(0);
    (0, _hooks.useLayoutEffect)(()=>{
        setBusLaneWidth(busLaneRef.current?.offsetWidth);
    }, []);
    return (0, _preact.h)("div", {
        class: "bus-lane",
        ref: busLaneRef
    }, nextBuses.map((b, i)=>(0, _preact.h)(Bus, (0, _extendsDefault.default)({
            key: b._id,
            index: i
        }, b, {
            maxPx: busLaneWidth
        }))), index && (0, _preact.h)("span", {
        class: "visit-number"
    }, index));
}
function ArrivalTimes() {
    const { t , i18n  } = (0, _reactI18Next.useTranslation)();
    const [busStop, setBusStop] = (0, _hooks.useState)(null);
    const [stopsData, setStopsData] = (0, _hooks.useState)(null);
    const [fetchServicesStatus, setFetchServicesStatus] = (0, _hooks.useState)(null); // 'loading', 'error', 'online'
    const [services, setServices] = (0, _hooks.useState)(null);
    const initialPinnedServices = JSON.parse(localStorage.getItem("busroutersg.arrival.pinnedServices")) || [];
    const [pinnedServices, setPinnedServices] = (0, _hooks.useState)(initialPinnedServices);
    (0, _hooks.useEffect)(async ()=>{
        const stops = await (0, _fetchCacheDefault.default)(stopsJSONPath, 1440);
        window.onhashchange = ()=>{
            const code = location.hash.slice(1);
            if (code) {
                const stop = stops[code];
                if (stop) {
                    const [lng, lat, name] = stop;
                    setBusStop({
                        code,
                        name,
                        lat,
                        lng
                    });
                    (0, _setIconDefault.default)(code);
                } else alert(t("arrivals.invalidBusStopCode"));
            } else setBusStop(null);
        };
        window.onhashchange();
        setStopsData(stops);
    }, []);
    (0, _hooks.useEffect)(()=>{
        if (busStop?.code) {
            const { code , name  } = busStop;
            document.title = t("arrivals.titleStop", {
                stopNumber: code,
                stopName: name
            });
            document.querySelector('[name="apple-mobile-web-app-title"]').setAttribute("content", document.title);
        } else {
            document.title = t("arrivals.title");
            document.querySelector('[name="apple-mobile-web-app-title"]').setAttribute("content", document.title);
        }
    }, [
        busStop,
        i18n.resolvedLanguage
    ]);
    let arrivalsTimeout, arrivalsRAF;
    function fetchServices(id) {
        if (!id) return;
        if (window._PAUSED) return;
        setFetchServicesStatus("loading");
        fetch(`https://arrivelah2.busrouter.sg/?id=${id}`).then((r)=>r.json()).then((results)=>{
            setFetchServicesStatus(results.services?.length ? "online" : null);
            setServices(results.services);
            arrivalsTimeout = setTimeout(()=>{
                arrivalsRAF = requestAnimationFrame(()=>fetchServices(id));
            }, 15000); // 15 seconds
        }).catch((e)=>{
            console.error(e);
            setFetchServicesStatus("error");
            arrivalsTimeout = setTimeout(()=>{
                arrivalsRAF = requestAnimationFrame(()=>fetchServices(id));
            }, 3000); // 3 seconds
        });
    }
    (0, _hooks.useEffect)(()=>{
        if (busStop) fetchServices(busStop.code);
        return ()=>{
            clearTimeout(arrivalsTimeout);
            cancelAnimationFrame(arrivalsRAF);
        };
    }, [
        busStop
    ]);
    function togglePin(no) {
        if (pinnedServices.includes(no)) {
            const index = pinnedServices.indexOf(no);
            pinnedServices.splice(index, 1);
        } else pinnedServices.push(no);
        setPinnedServices([
            ...pinnedServices
        ]);
        try {
            localStorage.setItem("busroutersg.arrival.pinnedServices", JSON.stringify(pinnedServices));
        } catch (e) {}
    }
    if (!busStop) {
        if (stopsData) return (0, _preact.h)("ul", {
            class: "stops-list"
        }, Object.keys(stopsData).map((stop)=>(0, _preact.h)("li", null, (0, _preact.h)("a", {
                href: `#${stop}`
            }, stopsData[stop][2]))));
        return;
    }
    const { code , name , lat , lng  } = busStop;
    if (services) services.sort((0, _bus.sortServicesPinned)(pinnedServices));
    const hasMultipleVisits = services?.some((service)=>{
        const { next , next2 , next3  } = service;
        return next?.visit_number > 1 || next2?.visit_number > 1 || next3?.visit_number > 1;
    });
    return (0, _preact.h)("div", null, (0, _preact.h)("div", {
        id: "bus-stop-map"
    }, (0, _preact.h)("img", {
        src: `https://busroutersg-staticmaps.cheeaun.workers.dev/${lng},${lat},17,0,60/400x200@2x`,
        alt: "Bus stop map",
        width: "400",
        height: "200",
        intrinsicsize: "400x200",
        loading: "lazy"
    })), (0, _preact.h)("h1", null, t("arrivals.preHeading"), (0, _preact.h)("b", {
        id: "bus-stop-name"
    }, (0, _preact.h)("span", {
        class: `stop-tag ${fetchServicesStatus}`
    }, code), " ", name)), (0, _preact.h)("table", null, services ? services.length ? (0, _preact.h)("tbody", {
        class: !services.length ? "loading" : ""
    }, services.map(({ no , next , next2 , next3  })=>{
        const pinned = pinnedServices.includes(no);
        const buses = [
            next,
            next2,
            next3
        ];
        const buses1 = buses.filter((b)=>b?.visit_number === 1);
        const buses2 = buses.filter((b)=>b?.visit_number === 2);
        return (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("tr", {
            class: pinned ? "pin" : ""
        }, (0, _preact.h)("th", {
            onClick: (e)=>{
                e.preventDefault();
                togglePin(no);
            }
        }, no), (0, _preact.h)("td", {
            class: `bus-lane-cell ${buses2.length ? "multiple" : ""}`
        }, buses2.length ? (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)(BusLane, {
            index: 1,
            no: no,
            buses: buses1
        }), (0, _preact.h)(BusLane, {
            index: 2,
            no: no,
            buses: buses2
        })) : (0, _preact.h)(BusLane, {
            no: no,
            buses: buses
        }))), (0, _preact.h)("tr", {
            class: pinned ? "pin" : ""
        }, (0, _preact.h)("th", {
            colspan: "2"
        }, (0, _preact.h)("small", {
            class: "destination"
        }, stopsData[next.destination_code][2]))));
    })) : (0, _preact.h)("tbody", null, (0, _preact.h)("tr", null, (0, _preact.h)("td", {
        class: "blank"
    }, "No arrival times available."))) : (0, _preact.h)("tbody", {
        class: "loading"
    }, (0, _preact.h)("tr", null, (0, _preact.h)("td", null, "Loading…")))), (0, _preact.h)("div", {
        class: "legend"
    }, (0, _preact.h)("div", {
        class: "loads"
    }, (0, _preact.h)("span", {
        class: "load load-sea"
    }, t("glossary.seatsAvailable")), (0, _preact.h)("span", {
        class: "load load-sda"
    }, t("glossary.standingAvailable")), (0, _preact.h)("span", {
        class: "load load-lsd"
    }, t("glossary.limitedStanding"))), hasMultipleVisits && (0, _preact.h)("p", {
        class: "visits"
    }, (0, _preact.h)("span", {
        class: "visit-numbers"
    }, (0, _preact.h)("span", {
        class: "visit-number"
    }, "1"), (0, _preact.h)("span", {
        class: "visit-number"
    }, "2")), t("arrivals.multipleVisitsLegend"))), (0, _preact.h)("footer", null, (0, _preact.h)((0, _reactI18Next.Trans), {
        i18nKey: "arrivals.wheelchairDisclaimer"
    }, (0, _preact.h)(WheelChair, {
        size: "16"
    }), " All public buses in revenue service are", (0, _preact.h)("a", {
        href: "https://en.wikipedia.org/wiki/Public_buses_of_Singapore#2020s:_In_with_electric_buses,_out_with_non-wheelchair-accessible_buses",
        target: "_blank"
    }, "wheelchair-accessible"), ". The ones that are not accesssible will be marked with this icon", (0, _preact.h)(WheelChairInaccessible, {
        size: "16"
    }), "."), (0, _preact.h)("p", null, (0, _preact.h)((0, _localeSelectorDefault.default), null))));
}
const $arrivals = document.getElementById("arrivals");
(0, _preact.render)((0, _preact.h)(ArrivalTimes, null), $arrivals);

},{"@babel/runtime/helpers/extends":"vw3vn","./i18n":"29PvA","./error-tracking":"fiYlI","preact":"26zcy","preact/hooks":"eZN76","react-i18next":"faThV","./utils/bus":"cu424","./utils/fetchCache":"6IPHM","../utils/setIcon":"cW2Km","./components/ArrivalTimeText":"bxfzt","./components/LocaleSelector":"e0gts","./images/wheelchair.svg":"8edJH","./images/wheelchair-inaccessible.svg":"bpEXb","./images/bus-single.svg":"c8qRE","./images/bus-double.svg":"guA4Y","./images/bus-bendy.svg":"jq9Si","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"vw3vn":[function(require,module,exports) {
function _extends() {
    module.exports = _extends = Object.assign ? Object.assign.bind() : function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source)if (Object.prototype.hasOwnProperty.call(source, key)) target[key] = source[key];
        }
        return target;
    }, module.exports.__esModule = true, module.exports["default"] = module.exports;
    return _extends.apply(this, arguments);
}
module.exports = _extends, module.exports.__esModule = true, module.exports["default"] = module.exports;

},{}],"cW2Km":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = (iconText)=>{
    let iconSize = 512;
    let iconBackgroundColor = "#F01B48";
    let iconPrimaryColor = "#FFFFFF";
    let iconTextFont = `bold ${Math.round(iconSize * 0.2)}px -apple-system, BlinkMacSystemFont, \"Segoe UI\", Roboto, Oxygen, Ubuntu, Cantarell, \"Open Sans\", \"Helvetica Neue\", sans-serif`;
    // canvas handles
    let c = document.createElement("canvas");
    c.width = iconSize;
    c.height = iconSize;
    let ctx = c.getContext("2d");
    // whitewash canvas first
    ctx.fillStyle = iconPrimaryColor;
    ctx.fillRect(0, 0, c.width, c.height);
    // draw radii. someday I hope canvas comes up with a fillRoundedRect()
    // 1:6.4 ratio (magic const of 0.15625) from https://stackoverflow.com/questions/2105289/iphone-app-icons-exact-radius
    // inset distance of 120 was eyeballed
    ctx.fillStyle = iconBackgroundColor;
    let iconInsetDistance = 120;
    let arcRadius = Math.round(c.width * 0.15625);
    ctx.beginPath();
    ctx.moveTo(iconInsetDistance - arcRadius, iconInsetDistance);
    ctx.quadraticCurveTo(iconInsetDistance - arcRadius, iconInsetDistance - arcRadius, iconInsetDistance, iconInsetDistance - arcRadius);
    ctx.lineTo(c.width - iconInsetDistance, iconInsetDistance - arcRadius);
    ctx.quadraticCurveTo(c.width - iconInsetDistance + arcRadius, iconInsetDistance - arcRadius, c.width - iconInsetDistance + arcRadius, iconInsetDistance);
    ctx.lineTo(c.width - iconInsetDistance + arcRadius, c.height - iconInsetDistance);
    ctx.quadraticCurveTo(c.width - iconInsetDistance + arcRadius, c.height - iconInsetDistance + arcRadius, c.width - iconInsetDistance, c.height - iconInsetDistance + arcRadius);
    ctx.lineTo(iconInsetDistance, c.height - iconInsetDistance + arcRadius);
    ctx.quadraticCurveTo(iconInsetDistance - arcRadius, c.height - iconInsetDistance + arcRadius, iconInsetDistance - arcRadius, c.height - iconInsetDistance);
    ctx.lineTo(iconInsetDistance - arcRadius, iconInsetDistance);
    ctx.fill();
    // draw the icon text
    // bus stop codes are consistently 5-characters wide
    ctx.font = iconTextFont;
    ctx.textAlign = "center";
    ctx.textBaseline = "middle";
    ctx.fillStyle = iconPrimaryColor;
    ctx.fillText(iconText, c.width / 2, c.height / 2);
    // replace existing apple-touch-icon
    document.querySelector('[rel="apple-touch-icon"]').setAttribute("href", c.toDataURL());
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bxfzt":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _preact = require("preact");
var _reactI18Next = require("react-i18next");
function ArrivalTimeText({ ms  }) {
    const { t  } = (0, _reactI18Next.useTranslation)();
    if (ms === null) return;
    const mins = Math.floor(ms / 1000 / 60);
    return mins <= 0 ? t("glossary.arriving") : t("glossary.arrivingMinutes", {
        count: mins
    });
}
exports.default = ArrivalTimeText;

},{"preact":"26zcy","react-i18next":"faThV","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8edJH":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("fC0tY") + "../wheelchair.e98980de.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"lgJ39":[function(require,module,exports) {
"use strict";
var bundleURL = {};
function getBundleURLCached(id) {
    var value = bundleURL[id];
    if (!value) {
        value = getBundleURL();
        bundleURL[id] = value;
    }
    return value;
}
function getBundleURL() {
    try {
        throw new Error();
    } catch (err) {
        var matches = ("" + err.stack).match(/(https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/[^)\n]+/g);
        if (matches) // The first two stack frames will be this function and getBundleURLCached.
        // Use the 3rd one, which will be a runtime in the original bundle.
        return getBaseURL(matches[2]);
    }
    return "/";
}
function getBaseURL(url) {
    return ("" + url).replace(/^((?:https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/.+)\/[^/]+$/, "$1") + "/";
} // TODO: Replace uses with `new URL(url).origin` when ie11 is no longer supported.
function getOrigin(url) {
    var matches = ("" + url).match(/(https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/[^/]+/);
    if (!matches) throw new Error("Origin not found");
    return matches[0];
}
exports.getBundleURL = getBundleURLCached;
exports.getBaseURL = getBaseURL;
exports.getOrigin = getOrigin;

},{}],"bpEXb":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("fC0tY") + "../wheelchair-inaccessible.b0c2a581.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"c8qRE":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("fC0tY") + "../bus-single.9c748151.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"guA4Y":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("fC0tY") + "../bus-double.529f1b3a.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"jq9Si":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("fC0tY") + "../bus-bendy.f2c7787b.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}]},["8vtpn","eoJgJ"], "eoJgJ", "parcelRequireda9d")

//# sourceMappingURL=index.acc158c0.js.map
