// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles

(function (modules, entry, mainEntry, parcelRequireName, globalName) {
  /* eslint-disable no-undef */
  var globalObject =
    typeof globalThis !== 'undefined'
      ? globalThis
      : typeof self !== 'undefined'
      ? self
      : typeof window !== 'undefined'
      ? window
      : typeof global !== 'undefined'
      ? global
      : {};
  /* eslint-enable no-undef */

  // Save the require from previous bundle to this closure if any
  var previousRequire =
    typeof globalObject[parcelRequireName] === 'function' &&
    globalObject[parcelRequireName];

  var cache = previousRequire.cache || {};
  // Do not use `require` to prevent Webpack from trying to bundle this call
  var nodeRequire =
    typeof module !== 'undefined' &&
    typeof module.require === 'function' &&
    module.require.bind(module);

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire =
          typeof globalObject[parcelRequireName] === 'function' &&
          globalObject[parcelRequireName];
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error("Cannot find module '" + name + "'");
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = (cache[name] = new newRequire.Module(name));

      modules[name][0].call(
        module.exports,
        localRequire,
        module,
        module.exports,
        this
      );
    }

    return cache[name].exports;

    function localRequire(x) {
      var res = localRequire.resolve(x);
      return res === false ? {} : newRequire(res);
    }

    function resolve(x) {
      var id = modules[name][1][x];
      return id != null ? id : x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [
      function (require, module) {
        module.exports = exports;
      },
      {},
    ];
  };

  Object.defineProperty(newRequire, 'root', {
    get: function () {
      return globalObject[parcelRequireName];
    },
  });

  globalObject[parcelRequireName] = newRequire;

  for (var i = 0; i < entry.length; i++) {
    newRequire(entry[i]);
  }

  if (mainEntry) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(mainEntry);

    // CommonJS
    if (typeof exports === 'object' && typeof module !== 'undefined') {
      module.exports = mainExports;

      // RequireJS
    } else if (typeof define === 'function' && define.amd) {
      define(function () {
        return mainExports;
      });

      // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }
})({"dfbnL":[function(require,module,exports) {
var global = arguments[3];
var HMR_HOST = null;
var HMR_PORT = null;
var HMR_SECURE = false;
var HMR_ENV_HASH = "d6ea1d42532a7575";
module.bundle.HMR_BUNDLE_ID = "6d937621f04a6e97";
"use strict";
/* global HMR_HOST, HMR_PORT, HMR_ENV_HASH, HMR_SECURE, chrome, browser, globalThis, __parcel__import__, __parcel__importScripts__, ServiceWorkerGlobalScope */ /*::
import type {
  HMRAsset,
  HMRMessage,
} from '@parcel/reporter-dev-server/src/HMRServer.js';
interface ParcelRequire {
  (string): mixed;
  cache: {|[string]: ParcelModule|};
  hotData: mixed;
  Module: any;
  parent: ?ParcelRequire;
  isParcelRequire: true;
  modules: {|[string]: [Function, {|[string]: string|}]|};
  HMR_BUNDLE_ID: string;
  root: ParcelRequire;
}
interface ParcelModule {
  hot: {|
    data: mixed,
    accept(cb: (Function) => void): void,
    dispose(cb: (mixed) => void): void,
    // accept(deps: Array<string> | string, cb: (Function) => void): void,
    // decline(): void,
    _acceptCallbacks: Array<(Function) => void>,
    _disposeCallbacks: Array<(mixed) => void>,
  |};
}
interface ExtensionContext {
  runtime: {|
    reload(): void,
    getURL(url: string): string;
    getManifest(): {manifest_version: number, ...};
  |};
}
declare var module: {bundle: ParcelRequire, ...};
declare var HMR_HOST: string;
declare var HMR_PORT: string;
declare var HMR_ENV_HASH: string;
declare var HMR_SECURE: boolean;
declare var chrome: ExtensionContext;
declare var browser: ExtensionContext;
declare var __parcel__import__: (string) => Promise<void>;
declare var __parcel__importScripts__: (string) => Promise<void>;
declare var globalThis: typeof self;
declare var ServiceWorkerGlobalScope: Object;
*/ var OVERLAY_ID = "__parcel__error__overlay__";
var OldModule = module.bundle.Module;
function Module(moduleName) {
    OldModule.call(this, moduleName);
    this.hot = {
        data: module.bundle.hotData,
        _acceptCallbacks: [],
        _disposeCallbacks: [],
        accept: function(fn) {
            this._acceptCallbacks.push(fn || function() {});
        },
        dispose: function(fn) {
            this._disposeCallbacks.push(fn);
        }
    };
    module.bundle.hotData = undefined;
}
module.bundle.Module = Module;
var checkedAssets, acceptedAssets, assetsToAccept /*: Array<[ParcelRequire, string]> */ ;
function getHostname() {
    return HMR_HOST || (location.protocol.indexOf("http") === 0 ? location.hostname : "localhost");
}
function getPort() {
    return HMR_PORT || location.port;
} // eslint-disable-next-line no-redeclare
var parent = module.bundle.parent;
if ((!parent || !parent.isParcelRequire) && typeof WebSocket !== "undefined") {
    var hostname = getHostname();
    var port = getPort();
    var protocol = HMR_SECURE || location.protocol == "https:" && !/localhost|127.0.0.1|0.0.0.0/.test(hostname) ? "wss" : "ws";
    var ws = new WebSocket(protocol + "://" + hostname + (port ? ":" + port : "") + "/"); // Web extension context
    var extCtx = typeof chrome === "undefined" ? typeof browser === "undefined" ? null : browser : chrome; // Safari doesn't support sourceURL in error stacks.
    // eval may also be disabled via CSP, so do a quick check.
    var supportsSourceURL = false;
    try {
        (0, eval)('throw new Error("test"); //# sourceURL=test.js');
    } catch (err) {
        supportsSourceURL = err.stack.includes("test.js");
    } // $FlowFixMe
    ws.onmessage = async function(event) {
        checkedAssets = {} /*: {|[string]: boolean|} */ ;
        acceptedAssets = {} /*: {|[string]: boolean|} */ ;
        assetsToAccept = [];
        var data = JSON.parse(event.data);
        if (data.type === "update") {
            // Remove error overlay if there is one
            if (typeof document !== "undefined") removeErrorOverlay();
            let assets = data.assets.filter((asset)=>asset.envHash === HMR_ENV_HASH); // Handle HMR Update
            let handled = assets.every((asset)=>{
                return asset.type === "css" || asset.type === "js" && hmrAcceptCheck(module.bundle.root, asset.id, asset.depsByBundle);
            });
            if (handled) {
                console.clear(); // Dispatch custom event so other runtimes (e.g React Refresh) are aware.
                if (typeof window !== "undefined" && typeof CustomEvent !== "undefined") window.dispatchEvent(new CustomEvent("parcelhmraccept"));
                await hmrApplyUpdates(assets);
                for(var i = 0; i < assetsToAccept.length; i++){
                    var id = assetsToAccept[i][1];
                    if (!acceptedAssets[id]) hmrAcceptRun(assetsToAccept[i][0], id);
                }
            } else fullReload();
        }
        if (data.type === "error") {
            // Log parcel errors to console
            for (let ansiDiagnostic of data.diagnostics.ansi){
                let stack = ansiDiagnostic.codeframe ? ansiDiagnostic.codeframe : ansiDiagnostic.stack;
                console.error("\uD83D\uDEA8 [parcel]: " + ansiDiagnostic.message + "\n" + stack + "\n\n" + ansiDiagnostic.hints.join("\n"));
            }
            if (typeof document !== "undefined") {
                // Render the fancy html overlay
                removeErrorOverlay();
                var overlay = createErrorOverlay(data.diagnostics.html); // $FlowFixMe
                document.body.appendChild(overlay);
            }
        }
    };
    ws.onerror = function(e) {
        console.error(e.message);
    };
    ws.onclose = function() {
        console.warn("[parcel] \uD83D\uDEA8 Connection to the HMR server was lost");
    };
}
function removeErrorOverlay() {
    var overlay = document.getElementById(OVERLAY_ID);
    if (overlay) {
        overlay.remove();
        console.log("[parcel] ✨ Error resolved");
    }
}
function createErrorOverlay(diagnostics) {
    var overlay = document.createElement("div");
    overlay.id = OVERLAY_ID;
    let errorHTML = '<div style="background: black; opacity: 0.85; font-size: 16px; color: white; position: fixed; height: 100%; width: 100%; top: 0px; left: 0px; padding: 30px; font-family: Menlo, Consolas, monospace; z-index: 9999;">';
    for (let diagnostic of diagnostics){
        let stack = diagnostic.frames.length ? diagnostic.frames.reduce((p, frame)=>{
            return `${p}
<a href="/__parcel_launch_editor?file=${encodeURIComponent(frame.location)}" style="text-decoration: underline; color: #888" onclick="fetch(this.href); return false">${frame.location}</a>
${frame.code}`;
        }, "") : diagnostic.stack;
        errorHTML += `
      <div>
        <div style="font-size: 18px; font-weight: bold; margin-top: 20px;">
          🚨 ${diagnostic.message}
        </div>
        <pre>${stack}</pre>
        <div>
          ${diagnostic.hints.map((hint)=>"<div>\uD83D\uDCA1 " + hint + "</div>").join("")}
        </div>
        ${diagnostic.documentation ? `<div>📝 <a style="color: violet" href="${diagnostic.documentation}" target="_blank">Learn more</a></div>` : ""}
      </div>
    `;
    }
    errorHTML += "</div>";
    overlay.innerHTML = errorHTML;
    return overlay;
}
function fullReload() {
    if ("reload" in location) location.reload();
    else if (extCtx && extCtx.runtime && extCtx.runtime.reload) extCtx.runtime.reload();
}
function getParents(bundle, id) /*: Array<[ParcelRequire, string]> */ {
    var modules = bundle.modules;
    if (!modules) return [];
    var parents = [];
    var k, d, dep;
    for(k in modules)for(d in modules[k][1]){
        dep = modules[k][1][d];
        if (dep === id || Array.isArray(dep) && dep[dep.length - 1] === id) parents.push([
            bundle,
            k
        ]);
    }
    if (bundle.parent) parents = parents.concat(getParents(bundle.parent, id));
    return parents;
}
function updateLink(link) {
    var newLink = link.cloneNode();
    newLink.onload = function() {
        if (link.parentNode !== null) // $FlowFixMe
        link.parentNode.removeChild(link);
    };
    newLink.setAttribute("href", link.getAttribute("href").split("?")[0] + "?" + Date.now()); // $FlowFixMe
    link.parentNode.insertBefore(newLink, link.nextSibling);
}
var cssTimeout = null;
function reloadCSS() {
    if (cssTimeout) return;
    cssTimeout = setTimeout(function() {
        var links = document.querySelectorAll('link[rel="stylesheet"]');
        for(var i = 0; i < links.length; i++){
            // $FlowFixMe[incompatible-type]
            var href = links[i].getAttribute("href");
            var hostname = getHostname();
            var servedFromHMRServer = hostname === "localhost" ? new RegExp("^(https?:\\/\\/(0.0.0.0|127.0.0.1)|localhost):" + getPort()).test(href) : href.indexOf(hostname + ":" + getPort());
            var absolute = /^https?:\/\//i.test(href) && href.indexOf(location.origin) !== 0 && !servedFromHMRServer;
            if (!absolute) updateLink(links[i]);
        }
        cssTimeout = null;
    }, 50);
}
function hmrDownload(asset) {
    if (asset.type === "js") {
        if (typeof document !== "undefined") {
            let script = document.createElement("script");
            script.src = asset.url + "?t=" + Date.now();
            if (asset.outputFormat === "esmodule") script.type = "module";
            return new Promise((resolve, reject)=>{
                var _document$head;
                script.onload = ()=>resolve(script);
                script.onerror = reject;
                (_document$head = document.head) === null || _document$head === void 0 || _document$head.appendChild(script);
            });
        } else if (typeof importScripts === "function") {
            // Worker scripts
            if (asset.outputFormat === "esmodule") return import(asset.url + "?t=" + Date.now());
            else return new Promise((resolve, reject)=>{
                try {
                    importScripts(asset.url + "?t=" + Date.now());
                    resolve();
                } catch (err) {
                    reject(err);
                }
            });
        }
    }
}
async function hmrApplyUpdates(assets) {
    global.parcelHotUpdate = Object.create(null);
    let scriptsToRemove;
    try {
        // If sourceURL comments aren't supported in eval, we need to load
        // the update from the dev server over HTTP so that stack traces
        // are correct in errors/logs. This is much slower than eval, so
        // we only do it if needed (currently just Safari).
        // https://bugs.webkit.org/show_bug.cgi?id=137297
        // This path is also taken if a CSP disallows eval.
        if (!supportsSourceURL) {
            let promises = assets.map((asset)=>{
                var _hmrDownload;
                return (_hmrDownload = hmrDownload(asset)) === null || _hmrDownload === void 0 ? void 0 : _hmrDownload.catch((err)=>{
                    // Web extension bugfix for Chromium
                    // https://bugs.chromium.org/p/chromium/issues/detail?id=1255412#c12
                    if (extCtx && extCtx.runtime && extCtx.runtime.getManifest().manifest_version == 3) {
                        if (typeof ServiceWorkerGlobalScope != "undefined" && global instanceof ServiceWorkerGlobalScope) {
                            extCtx.runtime.reload();
                            return;
                        }
                        asset.url = extCtx.runtime.getURL("/__parcel_hmr_proxy__?url=" + encodeURIComponent(asset.url + "?t=" + Date.now()));
                        return hmrDownload(asset);
                    }
                    throw err;
                });
            });
            scriptsToRemove = await Promise.all(promises);
        }
        assets.forEach(function(asset) {
            hmrApply(module.bundle.root, asset);
        });
    } finally{
        delete global.parcelHotUpdate;
        if (scriptsToRemove) scriptsToRemove.forEach((script)=>{
            if (script) {
                var _document$head2;
                (_document$head2 = document.head) === null || _document$head2 === void 0 || _document$head2.removeChild(script);
            }
        });
    }
}
function hmrApply(bundle, asset) {
    var modules = bundle.modules;
    if (!modules) return;
    if (asset.type === "css") reloadCSS();
    else if (asset.type === "js") {
        let deps = asset.depsByBundle[bundle.HMR_BUNDLE_ID];
        if (deps) {
            if (modules[asset.id]) {
                // Remove dependencies that are removed and will become orphaned.
                // This is necessary so that if the asset is added back again, the cache is gone, and we prevent a full page reload.
                let oldDeps = modules[asset.id][1];
                for(let dep in oldDeps)if (!deps[dep] || deps[dep] !== oldDeps[dep]) {
                    let id = oldDeps[dep];
                    let parents = getParents(module.bundle.root, id);
                    if (parents.length === 1) hmrDelete(module.bundle.root, id);
                }
            }
            if (supportsSourceURL) // Global eval. We would use `new Function` here but browser
            // support for source maps is better with eval.
            (0, eval)(asset.output);
             // $FlowFixMe
            let fn = global.parcelHotUpdate[asset.id];
            modules[asset.id] = [
                fn,
                deps
            ];
        } else if (bundle.parent) hmrApply(bundle.parent, asset);
    }
}
function hmrDelete(bundle, id) {
    let modules = bundle.modules;
    if (!modules) return;
    if (modules[id]) {
        // Collect dependencies that will become orphaned when this module is deleted.
        let deps = modules[id][1];
        let orphans = [];
        for(let dep in deps){
            let parents = getParents(module.bundle.root, deps[dep]);
            if (parents.length === 1) orphans.push(deps[dep]);
        } // Delete the module. This must be done before deleting dependencies in case of circular dependencies.
        delete modules[id];
        delete bundle.cache[id]; // Now delete the orphans.
        orphans.forEach((id)=>{
            hmrDelete(module.bundle.root, id);
        });
    } else if (bundle.parent) hmrDelete(bundle.parent, id);
}
function hmrAcceptCheck(bundle, id, depsByBundle) {
    if (hmrAcceptCheckOne(bundle, id, depsByBundle)) return true;
     // Traverse parents breadth first. All possible ancestries must accept the HMR update, or we'll reload.
    let parents = getParents(module.bundle.root, id);
    let accepted = false;
    while(parents.length > 0){
        let v = parents.shift();
        let a = hmrAcceptCheckOne(v[0], v[1], null);
        if (a) // If this parent accepts, stop traversing upward, but still consider siblings.
        accepted = true;
        else {
            // Otherwise, queue the parents in the next level upward.
            let p = getParents(module.bundle.root, v[1]);
            if (p.length === 0) {
                // If there are no parents, then we've reached an entry without accepting. Reload.
                accepted = false;
                break;
            }
            parents.push(...p);
        }
    }
    return accepted;
}
function hmrAcceptCheckOne(bundle, id, depsByBundle) {
    var modules = bundle.modules;
    if (!modules) return;
    if (depsByBundle && !depsByBundle[bundle.HMR_BUNDLE_ID]) {
        // If we reached the root bundle without finding where the asset should go,
        // there's nothing to do. Mark as "accepted" so we don't reload the page.
        if (!bundle.parent) return true;
        return hmrAcceptCheck(bundle.parent, id, depsByBundle);
    }
    if (checkedAssets[id]) return true;
    checkedAssets[id] = true;
    var cached = bundle.cache[id];
    assetsToAccept.push([
        bundle,
        id
    ]);
    if (!cached || cached.hot && cached.hot._acceptCallbacks.length) return true;
}
function hmrAcceptRun(bundle, id) {
    var cached = bundle.cache[id];
    bundle.hotData = {};
    if (cached && cached.hot) cached.hot.data = bundle.hotData;
    if (cached && cached.hot && cached.hot._disposeCallbacks.length) cached.hot._disposeCallbacks.forEach(function(cb) {
        cb(bundle.hotData);
    });
    delete bundle.cache[id];
    bundle(id);
    cached = bundle.cache[id];
    if (cached && cached.hot && cached.hot._acceptCallbacks.length) cached.hot._acceptCallbacks.forEach(function(cb) {
        var assetsToAlsoAccept = cb(function() {
            return getParents(module.bundle.root, id);
        });
        if (assetsToAlsoAccept && assetsToAccept.length) // $FlowFixMe[method-unbinding]
        assetsToAccept.push.apply(assetsToAccept, assetsToAlsoAccept);
    });
    acceptedAssets[id] = true;
}

},{}],"aeGU1":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
var _i18N = require("./i18n");
var _errorTracking = require("./error-tracking");
var _preact = require("preact");
var _hooks = require("preact/hooks");
var _mapboxGl = require("mapbox-gl");
var _mapboxGlDefault = parcelHelpers.interopDefault(_mapboxGl);
var _polyline = require("@mapbox/polyline");
var _fuseJs = require("fuse.js");
var _fuseJsDefault = parcelHelpers.interopDefault(_fuseJs);
var _justIntersect = require("just-intersect");
var _justIntersectDefault = parcelHelpers.interopDefault(_justIntersect);
var _cheapRuler = require("cheap-ruler");
var _cheapRulerDefault = parcelHelpers.interopDefault(_cheapRuler);
var _mapboxGlLanguage = require("@mapbox/mapbox-gl-language");
var _mapboxGlLanguageDefault = parcelHelpers.interopDefault(_mapboxGlLanguage);
var _reactI18Next = require("react-i18next");
var _config = require("./config");
var _specialID = require("./utils/specialID");
var _bus = require("./utils/bus");
var _fetchCache = require("./utils/fetchCache");
var _fetchCacheDefault = parcelHelpers.interopDefault(_fetchCache);
var _getRoute = require("./utils/getRoute");
var _getRouteDefault = parcelHelpers.interopDefault(_getRoute);
var _getDistance = require("./utils/getDistance");
var _getDistanceDefault = parcelHelpers.interopDefault(_getDistance);
var _getWalkingMinutes = require("./utils/getWalkingMinutes");
var _getWalkingMinutesDefault = parcelHelpers.interopDefault(_getWalkingMinutes);
var _usePrevious = require("./utils/usePrevious");
var _usePreviousDefault = parcelHelpers.interopDefault(_usePrevious);
var _ad = require("./ad");
var _adDefault = parcelHelpers.interopDefault(_ad);
var _about = require("./components/About");
var _aboutDefault = parcelHelpers.interopDefault(_about);
var _busServicesArrival = require("./components/BusServicesArrival");
var _busServicesArrivalDefault = parcelHelpers.interopDefault(_busServicesArrival);
var _geolocateControl = require("./components/GeolocateControl");
var _geolocateControlDefault = parcelHelpers.interopDefault(_geolocateControl);
var _betweenRoutes = require("./components/BetweenRoutes");
var _betweenRoutesDefault = parcelHelpers.interopDefault(_betweenRoutes);
var _scrollableContainer = require("./components/ScrollableContainer");
var _scrollableContainerDefault = parcelHelpers.interopDefault(_scrollableContainer);
var _stopsListJsx = require("./components/StopsList.jsx");
var _stopsListJsxDefault = parcelHelpers.interopDefault(_stopsListJsx);
var _stopPng = require("./images/stop.png");
var _stopPngDefault = parcelHelpers.interopDefault(_stopPng);
var _stopEndPng = require("./images/stop-end.png");
var _stopEndPngDefault = parcelHelpers.interopDefault(_stopEndPng);
var _openNewWindowSvg = require("./images/open-new-window.svg");
var _openNewWindowSvgDefault = parcelHelpers.interopDefault(_openNewWindowSvg);
var _openNewWindowBlueSvg = require("./images/open-new-window-blue.svg");
var _openNewWindowBlueSvgDefault = parcelHelpers.interopDefault(_openNewWindowBlueSvg);
var _passingRoutesBlueSvg = require("./images/passing-routes-blue.svg");
var _passingRoutesBlueSvgDefault = parcelHelpers.interopDefault(_passingRoutesBlueSvg);
var _iconSvg = require("../icons/icon.svg");
var _iconSvgDefault = parcelHelpers.interopDefault(_iconSvg);
var _busTinyPng = require("./images/bus-tiny.png");
var _busTinyPngDefault = parcelHelpers.interopDefault(_busTinyPng);
const dataPath = "https://data.busrouter.sg/v1/";
const routesJSONPath = dataPath + "routes.min.json";
const stopsJSONPath = dataPath + "stops.min.json";
const servicesJSONPath = dataPath + "services.min.json";
const $map = document.getElementById("map");
const STORE = {};
const BREAKPOINT = ()=>window.innerWidth > 640;
const supportsHover = window.matchMedia && matchMedia("(any-hover: hover)").matches;
const supportsTouch = window.matchMedia && matchMedia("(any-pointer: coarse)").matches || "ontouchstart" in window || navigator.MaxTouchPoints > 0 || navigator.msMaxTouchPoints > 0;
const supportsPromise = "Promise" in window;
const ruler = new (0, _cheapRulerDefault.default)(1.3);
const $logo = document.getElementById("logo");
const redirectToOldSite = ()=>{
    const redirect = confirm("Looks like your browser is a little old. Redirecting you to the older version of BusRouter SG.");
    if (redirect) location.href = "https://v1.busrouter.sg/";
};
if (!supportsPromise || !(0, _mapboxGlDefault.default).supported()) redirectToOldSite();
let rafST;
const rafScrollTop = ()=>{
    window.scrollTo(0, 0);
    rafST = requestAnimationFrame(rafScrollTop);
};
const $tooltip = document.getElementById("tooltip");
function showStopTooltip(data) {
    $tooltip.innerHTML = `<span class="stop-tag">${data.number}</span> ${data.name}`;
    $tooltip.classList.add("show");
    const { x , y: top  } = data;
    const left = Math.max(5 + $map.offsetLeft, Math.min(window.innerWidth - $tooltip.offsetWidth - 5, x + $map.offsetLeft - 5));
    $tooltip.style.transform = `translate(${left}px, ${top}px)`;
}
function hideStopTooltip() {
    $tooltip.classList.remove("show");
}
window.requestIdleCallback = window.requestIdleCallback || ((cb)=>setTimeout(cb, 1));
(0, _mapboxGlDefault.default).accessToken = (0, _config.MAPBOX_ACCESS_TOKEN);
const lowerLat = 1.2, upperLat = 1.48, lowerLong = 103.59, upperLong = 104.05;
const CACHE_TIME = 1440; // 1 day
let map;
let servicesDataArr = [];
let stopsDataArr = [];
let servicesData;
let stopsData = {};
let routesData;
let fuseServices;
let fuseStops;
const App = ()=>{
    const { t , i18n  } = (0, _reactI18Next.useTranslation)();
    const [route, setRoute] = (0, _hooks.useState)((0, _getRouteDefault.default)());
    const prevRoute = (0, _usePreviousDefault.default)(route);
    const [routeLoading, setRouteLoading] = (0, _hooks.useState)(true);
    const [services, setServices] = (0, _hooks.useState)([]);
    const [stops, setStops] = (0, _hooks.useState)([]);
    const [searching, setSearching] = (0, _hooks.useState)(false);
    const [expandSearch, setExpandSearch] = (0, _hooks.useState)(false);
    const [expandedSearchOnce, setExpandedSearchOnce] = (0, _hooks.useState)(false);
    const [shrinkSearch, setShrinkSearch] = (0, _hooks.useState)(false);
    const [stopPopoverData, setStopPopoverData] = (0, _hooks.useState)(null);
    const [showStopPopover, setShowStopPopover] = (0, _hooks.useState)(false);
    const [showServicePopover, setShowServicePopover] = (0, _hooks.useState)(false);
    const [showArrivalsPopover, setShowArrivalsPopover] = (0, _hooks.useState)(false);
    const [intersectStops, setIntersectStops] = (0, _hooks.useState)(0);
    const [showAd, setShowAd] = (0, _hooks.useState)(false);
    const [routeServices, setRouteServices] = (0, _hooks.useState)([]);
    const [showBetweenPopover, setShowBetweenPopover] = (0, _hooks.useState)(false);
    const [betweenStartStop, setBetweenStartStop] = (0, _hooks.useState)(null);
    const [betweenEndStop, setBetweenEndStop] = (0, _hooks.useState)(null);
    const prevStopNumber = (0, _hooks.useRef)(null);
    const servicesList = (0, _hooks.useRef)(null);
    const searchField = (0, _hooks.useRef)(null);
    const searchPopover = (0, _hooks.useRef)(null);
    const stopPopover = (0, _hooks.useRef)(null);
    const floatPill = (0, _hooks.useRef)(null);
    const betweenPopover = (0, _hooks.useRef)(null);
    const servicePopover = (0, _hooks.useRef)(null);
    let previewRAF = (0, _hooks.useRef)(null).current;
    // let labelLayerId;
    const largerScreen = window.matchMedia("(min-width: 1200px) and (min-height: 600px) and (orientation: landscape)").matches;
    const handleKeys = (e)=>{
        switch(e.key.toLowerCase()){
            case "enter":
                {
                    const link = servicesList.current?.querySelector('li a[href^="#"]');
                    if (link) {
                        searchField.current?.blur();
                        link.click();
                    }
                    break;
                }
        }
    };
    const handleSearchFocus = (e)=>{
        setExpandSearch(true);
        setExpandedSearchOnce(true);
        // $map.classList.add('fade-out');
        rafScrollTop();
        searchPopover.current?.addEventListener("transitionend", (e)=>{
            cancelAnimationFrame(rafST);
        });
    };
    const handleSearch = (e)=>{
        const { value  } = e && e.target || searchField;
        if (value) {
            const services = fuseServices.search(value);
            let stops = [];
            if (services.length < 20) stops = fuseStops.search(value);
            setServices(services.map((s)=>s.item));
            setStops(stops.map((s)=>s.item));
            setSearching(true);
            // Scroll to top, with hack for momentum scrolling
            // https://popmotion.io/blog/20170704-manually-set-scroll-while-ios-momentum-scroll-bounces/
            servicesList.current.style["-webkit-overflow-scrolling"] = "auto";
            servicesList.current.scrollTop = 0;
            servicesList.current.style["-webkit-overflow-scrolling"] = null;
        } else {
            setServices(servicesDataArr);
            setStops([]);
            setSearching(false);
        }
    };
    const handleSearchClose = ()=>{
        setExpandSearch(false);
        $map.classList.remove("fade-out");
        resetSearch();
    };
    const resetSearch = ()=>{
        searchField.current?.blur();
        searchField.current.value = "";
        setSearching(false);
        setServices(servicesDataArr);
        setStops([]);
    };
    const handleServicesScroll = ()=>{
        if (expandSearch || expandedSearchOnce) return;
        setExpandSearch(true);
        setExpandedSearchOnce(true);
    // $map.classList.add('fade-out');
    };
    const _showStopPopover = (number)=>{
        const { services , coordinates , name  } = stopsData[number];
        const popoverHeight = stopPopover.current?.offsetHeight;
        const offset = BREAKPOINT() ? [
            0,
            0
        ] : [
            0,
            -popoverHeight / 2
        ];
        const zoom = map.getZoom();
        if (zoom < 17) map.flyTo({
            zoom: 17,
            center: coordinates,
            offset,
            animate: zoom >= 12
        });
        else map.easeTo({
            center: coordinates,
            offset
        });
        if (prevStopNumber.current) {
            map.setFeatureState({
                source: "stops",
                id: (0, _specialID.encode)(prevStopNumber.current)
            }, {
                selected: false
            });
            map.setFeatureState({
                source: "stops-highlight",
                id: (0, _specialID.encode)(prevStopNumber.current)
            }, {
                selected: false
            });
        }
        map.setFeatureState({
            source: "stops",
            id: (0, _specialID.encode)(number)
        }, {
            selected: true
        });
        map.setFeatureState({
            source: "stops-highlight",
            id: (0, _specialID.encode)(number)
        }, {
            selected: true
        });
        setShrinkSearch(true);
        prevStopNumber.current = number;
        setShowStopPopover(true);
        setStopPopoverData({
            number,
            name,
            services
        });
        requestAnimationFrame(()=>{
            if (popoverHeight === stopPopover.current?.offsetHeight) return;
            const offset = BREAKPOINT() ? [
                0,
                0
            ] : [
                0,
                -stopPopover.current?.offsetHeight / 2
            ];
            const zoom = map.getZoom();
            if (zoom < 17) map.flyTo({
                zoom: 17,
                center: coordinates,
                offset,
                animate: zoom >= 12
            });
            else map.easeTo({
                center: coordinates,
                offset
            });
        });
    };
    const hideStopPopover = (e)=>{
        const { page , subpage  } = route;
        if (e && (page !== "stop" || subpage === "routes")) e.preventDefault();
        const number = stopPopoverData?.number || prevStopNumber.current;
        let stopToBeHighlighted;
        if (number) {
            map.setFeatureState({
                source: "stops",
                id: (0, _specialID.encode)(number)
            }, {
                selected: false
            });
            map.setFeatureState({
                source: "stops-highlight",
                id: (0, _specialID.encode)(number)
            }, {
                selected: false
            });
            if (stopPopover.current?.classList.contains("expand")) requestAnimationFrame(()=>{
                stopToBeHighlighted = servicePopover.current?.querySelector(`a[data-stop="${number}"]`);
                stopToBeHighlighted?.classList.add("flash");
                stopToBeHighlighted?.scrollIntoView({
                    behaviour: "smooth",
                    block: "center",
                    inline: "center"
                });
            });
        }
        setShowStopPopover(false);
        prevStopNumber.current = null;
        setTimeout(()=>{
            stopToBeHighlighted?.classList.remove("flash");
        }, 1000);
    };
    const navBackToStop = (e)=>{
        if (prevRoute?.page === "stop") {
            e.preventDefault();
            history.back();
        }
    };
    const zoomToStop = (num)=>{
        const number = num || stopPopoverData?.number;
        const { coordinates  } = stopsData[number];
        let offset = BREAKPOINT() ? [
            0,
            0
        ] : [
            0,
            -stopPopover.current.offsetHeight / 2
        ];
        if (showServicePopover) offset = BREAKPOINT() ? [
            -servicePopover.current.offsetWidth / 3,
            0
        ] : [
            0,
            -servicePopover.current.offsetHeight / 2
        ];
        const zoom = map.getZoom();
        if (zoom < 17) map.flyTo({
            zoom: 17,
            center: coordinates,
            offset
        });
        else map.easeTo({
            center: coordinates,
            offset
        });
    };
    const highlightRouteTag = (service)=>{
        const $servicesList = floatPill.current?.querySelector(".services-list");
        if (!$servicesList) return;
        if (service) {
            const otherServices = $servicesList.querySelectorAll(".service-tag");
            otherServices.forEach((el)=>{
                el.classList.remove("highlight");
                if (el.dataset.service.trim() === service.trim()) el.style.opacity = "";
                else el.style.opacity = 0.3;
            });
        } else $servicesList.querySelectorAll(".service-tag").forEach((el)=>el.style.opacity = "");
    };
    const clickRoute = (e, service)=>{
        const { target  } = e;
        e.stopPropagation();
        if (target.classList.contains("highlight")) return;
        e.preventDefault();
        target.classList.add("highlight");
        highlightRoute(null, service, true);
    };
    const highlightRoute = (e, service, zoomIn)=>{
        if (e) e.target.classList.remove("highlight");
        const hoveredRouteID = (0, _specialID.encode)(service);
        map.setFeatureState({
            source: "routes-path",
            id: hoveredRouteID
        }, {
            hover: true,
            fadein: false
        });
        STORE.routesPathServices?.forEach((service)=>{
            const id = (0, _specialID.encode)(service);
            if (hoveredRouteID === id) return;
            map.setFeatureState({
                source: "routes-path",
                id
            }, {
                hover: false,
                fadein: true
            });
        });
        if (zoomIn) // Fit map to route bounds
        requestAnimationFrame(()=>{
            const { routes  } = servicesData[service];
            const coordinates = routes[0].concat(routes[1] || []).map((stop)=>stopsData[stop].coordinates);
            const bounds = new (0, _mapboxGlDefault.default).LngLatBounds();
            coordinates.forEach((c)=>{
                bounds.extend(c);
            });
            map.fitBounds(bounds, {
                padding: largerScreen ? {
                    top: floatPill.current.offsetHeight / 2,
                    right: 80,
                    bottom: 80,
                    left: floatPill.current.offsetHeight / 2
                } : BREAKPOINT() ? {
                    top: 80,
                    right: Math.max(floatPill.current.offsetWidth / 2, 80),
                    bottom: 80 + floatPill.current.offsetHeight / 2,
                    left: Math.max(floatPill.current.offsetWidth / 2, 80)
                } : {
                    top: 80,
                    right: 80,
                    bottom: 80 + floatPill.current.offsetHeight,
                    // height of search bar + float pill
                    left: 80
                }
            });
        });
    };
    const unhighlightRoute = (e)=>{
        if (e && e.target?.classList.contains("service-tag")) e.target.classList.remove("highlight");
        STORE.routesPathServices?.forEach((service)=>{
            const id = (0, _specialID.encode)(service);
            map.setFeatureState({
                source: "routes-path",
                id
            }, {
                fadein: false,
                hover: false
            });
        });
    };
    const openBusArrival = (e, showPopup = false)=>{
        if (e) e.preventDefault();
        const width = 360;
        const height = 480;
        const url = e.target.href;
        const stopNumber = url.match(/[^#]+$/)[0];
        showPopup = showPopup || window.innerWidth > width * 2 && window.innerHeight > height || window.innerWidth > window.innerHeight; // landscape is weird
        if (showPopup) {
            const top = ((screen.availHeight || screen.height) - height) / 2;
            const left = (screen.width - width) / 2;
            window.open(url, `busArrivals-${stopNumber}`, `width=${width},height=${height},menubar=0,toolbar=0,top=${top},left=${left}`);
        } else {
            setShowArrivalsPopover({
                webviewURL: url,
                number: stopNumber
            });
            $map.classList.add("fade-out");
        }
    };
    const closeBusArrival = (e)=>{
        if (e) e.preventDefault();
        setShowArrivalsPopover(false);
        $map.classList.remove("fade-out");
    };
    const _showBetweenPopover = (data)=>{
        setShrinkSearch(true);
        setShowBetweenPopover(data);
        // Auto-select first result
        setTimeout(()=>{
            const firstResult = betweenPopover.current.querySelector(".between-item");
            firstResult.click();
        }, 300);
    };
    const cannotPreviewRoute = ()=>{
        const { page , subpage , value  } = route;
        return subpage === "routes" || page === "service" && value.split("~").length > 1;
    };
    const previewRoute = (service)=>{
        cancelAnimationFrame(previewRAF);
        if (cannotPreviewRoute()) return;
        previewRAF = requestAnimationFrame(()=>{
            const routes = routesData[service];
            const geometries = routes.map((route)=>(0, _polyline.toGeoJSON)(route));
            map.getSource("routes-path").setData({
                type: "FeatureCollection",
                features: geometries.map((geometry)=>({
                        type: "Feature",
                        id: (0, _specialID.encode)(service),
                        properties: {
                            service
                        },
                        geometry
                    }))
            });
        });
    };
    const unpreviewRoute = ()=>{
        cancelAnimationFrame(previewRAF);
        if (cannotPreviewRoute()) return;
        map.getSource("routes-path").setData({
            type: "FeatureCollection",
            features: []
        });
    };
    const renderBetweenRoute = ({ e , startStop , endStop , result  })=>{
        const { target  } = e;
        target.parentElement.parentElement.querySelectorAll(".between-item").forEach((el)=>{
            if (el === target) target.classList.add("selected");
            else el.classList.remove("selected");
        });
        const stops = [
            {
                ...startStop,
                end: true
            },
            {
                ...endStop,
                end: true
            }
        ];
        if (result.startStop && result.startStop.number != startStop.number) stops.push({
            ...result.startStop,
            end: true
        });
        if (result.endStop && result.endStop.number != endStop.number) stops.push({
            ...result.endStop,
            end: true
        });
        if (result.stopsBetween.length) result.stopsBetween.forEach((number)=>stops.push(stopsData[number]));
        // Render stops
        map.getSource("stops-highlight").setData({
            type: "FeatureCollection",
            features: stops.map((stop)=>({
                    type: "Feature",
                    id: (0, _specialID.encode)(stop.number),
                    properties: {
                        name: stop.name,
                        number: stop.number,
                        type: stop.end ? "end" : null,
                        left: stop.left
                    },
                    geometry: {
                        type: "Point",
                        coordinates: stop.coordinates
                    }
                }))
        });
        requestAnimationFrame(()=>{
            // Render routes
            const geometries = [];
            let [service, index] = result.startRoute.split("-");
            geometries.push((0, _polyline.toGeoJSON)(routesData[service][index]));
            if (result.endRoute) {
                let [service1, index1] = result.endRoute.split("-");
                geometries.push((0, _polyline.toGeoJSON)(routesData[service1][index1]));
            }
            if (result.startStop && result.startStop.number != startStop.number) geometries.push({
                type: "LineString",
                coordinates: [
                    result.startStop.coordinates,
                    startStop.coordinates
                ]
            });
            if (result.endStop && result.endStop.number != endStop.number) geometries.push({
                type: "LineString",
                coordinates: [
                    result.endStop.coordinates,
                    endStop.coordinates
                ]
            });
            map.getSource("routes-between").setData({
                type: "FeatureCollection",
                features: geometries.map((geometry, i)=>({
                        type: "Feature",
                        properties: {
                            type: i === 0 ? "start" : i === 1 ? "end" : "walk"
                        },
                        geometry
                    }))
            });
            // Fit map to stops bounds
            const bounds = new (0, _mapboxGlDefault.default).LngLatBounds();
            stops.forEach((stop)=>{
                bounds.extend(stop.coordinates);
            });
            map.fitBounds(bounds, {
                padding: BREAKPOINT() ? {
                    top: 80,
                    right: betweenPopover.current.offsetWidth + 80,
                    bottom: 80,
                    left: 80
                } : {
                    top: 80,
                    right: 80,
                    bottom: betweenPopover.current.offsetHeight + 80,
                    left: 80
                }
            });
        });
    };
    const defaultURL = document.querySelector('meta[property="og:url"]').content;
    const defaultImg = document.querySelector('meta[property="og:image"]').content;
    const defaultHead = {
        title: [
            "app.title"
        ],
        url: defaultURL,
        desc: [
            "app.description"
        ],
        image: defaultImg
    };
    const [head, setHead] = (0, _hooks.useState)(defaultHead);
    (0, _hooks.useEffect)(()=>{
        let { title , url , desc , image  } = head;
        document.title = document.querySelector('meta[property="og:title"]').content = Array.isArray(title) ? t(...title) : title;
        if (!/^https?/.test(url)) url = "https://busrouter.sg/#" + url;
        document.querySelector('meta[property="og:url"]').content = url;
        document.querySelector('meta[name="description"]').content = document.querySelector('meta[property="og:description"]').content = Array.isArray(desc) ? t(...desc) : desc;
        document.querySelector('meta[property="og:image"]').content = image;
    }, [
        head
    ]);
    (0, _hooks.useEffect)(()=>{
        i18n.on("languageChanged", ()=>{
            setHead({
                ...head
            });
        });
    }, []);
    const renderRoute = ()=>{
        const route = (0, _getRouteDefault.default)();
        // Reset everything
        $map.classList.remove("fade-out");
        setShowStopPopover(false);
        setShowServicePopover(false);
        setShowBetweenPopover(false);
        [
            "stops-highlight",
            "routes",
            "routes-path",
            "routes-between",
            "buses-service"
        ].forEach((source)=>{
            map.getSource(source)?.setData({
                type: "FeatureCollection",
                features: []
            });
        });
        if (prevStopNumber.current) hideStopPopover();
        map.setLayoutProperty("traffic", "visibility", route.page === "stop" && route.subpage !== "routes" ? "visible" : "none");
        switch(route.page){
            case "service":
                {
                    const servicesValue = route.value;
                    const services = servicesValue.split("~").filter((s)=>servicesData[s]);
                    if (!services.length) return; // No value or none of the service codes are valid
                    // Reset
                    setExpandSearch(false);
                    setShrinkSearch(true);
                    resetSearch();
                    // Hide all stops
                    map.setLayoutProperty("stops", "visibility", "none");
                    map.setLayoutProperty("stops-icon", "visibility", "none");
                    setRouteServices(services);
                    if (services.length === 1) {
                        const service = services[0];
                        const { name , routes  } = servicesData[service];
                        setHead({
                            title: [
                                "service.title",
                                {
                                    serviceNumber: service,
                                    serviceName: name
                                }
                            ],
                            url: `/services/${service}`
                        });
                        setShowServicePopover(true);
                        // Show stops of the selected service
                        const endStops = [
                            routes[0][0],
                            routes[0][routes[0].length - 1]
                        ];
                        if (routes[1]) endStops.push(routes[1][0], routes[1][routes[1].length - 1]);
                        let routeStops = [
                            ...routes[0],
                            ...routes[1] || []
                        ].filter((el, pos, arr)=>arr.indexOf(el) == pos); // Merge and unique
                        // Fit map to route bounds
                        const bounds = new (0, _mapboxGlDefault.default).LngLatBounds();
                        routeStops.forEach((stop)=>{
                            const { coordinates  } = stopsData[stop];
                            bounds.extend(coordinates);
                        });
                        requestAnimationFrame(()=>{
                            map.fitBounds(bounds, {
                                padding: BREAKPOINT() ? {
                                    top: 80,
                                    right: servicePopover.current.offsetWidth + 80,
                                    bottom: 80,
                                    left: 80
                                } : {
                                    top: 80,
                                    right: 80,
                                    bottom: servicePopover.current.offsetHeight + 20,
                                    left: 80
                                }
                            });
                        });
                        map.getSource("stops-highlight").setData({
                            type: "FeatureCollection",
                            features: routeStops.map((stop, i)=>{
                                const { name , left  } = stopsData[stop];
                                return {
                                    type: "Feature",
                                    id: (0, _specialID.encode)(stop),
                                    properties: {
                                        name,
                                        number: stop,
                                        type: endStops.includes(stop) ? "end" : null,
                                        left
                                    },
                                    geometry: {
                                        type: "Point",
                                        coordinates: stopsData[stop].coordinates
                                    }
                                };
                            })
                        });
                        // Show routes
                        requestAnimationFrame(()=>{
                            const routes = routesData[service];
                            const geometries = routes.map((route)=>(0, _polyline.toGeoJSON)(route));
                            map.getSource("routes").setData({
                                type: "FeatureCollection",
                                features: geometries.map((geometry)=>({
                                        type: "Feature",
                                        properties: {},
                                        geometry
                                    }))
                            });
                        });
                    } else {
                        const serviceNumbersNames = services.map((s)=>{
                            const { name  } = servicesData[s];
                            return `${s}: ${name}`;
                        }).join(", ");
                        setHead({
                            title: [
                                "service.titleMultiple",
                                {
                                    serviceNumbersNames
                                }
                            ],
                            url: `/services/${services.join("~")}`
                        });
                        let routeStops1 = [];
                        let endStops1 = [];
                        let serviceGeometries = [];
                        services.forEach((service)=>{
                            const { routes  } = servicesData[service];
                            endStops1.push(routes[0][0], routes[0][routes[0].length - 1]);
                            if (routes[1]) endStops1.push(routes[1][0], routes[1][routes[1].length - 1]);
                            const allRoutes = [
                                ...routes[0],
                                ...routes[1] || []
                            ].filter((el, pos, arr)=>{
                                return arr.indexOf(el) === pos;
                            });
                            routeStops1 = routeStops1.concat(allRoutes);
                            const routeGeometries = routesData[service];
                            serviceGeometries = serviceGeometries.concat(routeGeometries.map((r)=>({
                                    service,
                                    geometry: (0, _polyline.toGeoJSON)(r)
                                })));
                        });
                        // Merge and unique stops
                        const intersectStops = [];
                        routeStops1 = routeStops1.filter((el, pos, arr)=>{
                            const unique = arr.indexOf(el) === pos;
                            if (!unique && !intersectStops.includes(el)) intersectStops.push(el);
                            return unique;
                        });
                        intersectStops.sort();
                        setIntersectStops(intersectStops);
                        // Fit map to route bounds
                        const bounds1 = new (0, _mapboxGlDefault.default).LngLatBounds();
                        routeStops1.forEach((stop)=>{
                            const { coordinates  } = stopsData[stop];
                            bounds1.extend(coordinates);
                        });
                        requestAnimationFrame(()=>{
                            map.fitBounds(bounds1, {
                                padding: largerScreen ? {
                                    top: floatPill.current.offsetHeight / 2,
                                    right: 80,
                                    bottom: 80,
                                    left: floatPill.current.offsetHeight / 2
                                } : BREAKPOINT() ? {
                                    top: 80,
                                    right: Math.max(floatPill.current.offsetWidth / 2, 80),
                                    bottom: 80 + floatPill.current.offsetHeight / 2,
                                    left: Math.max(floatPill.current.offsetWidth / 2, 80)
                                } : {
                                    top: 80,
                                    right: 80,
                                    bottom: 80 + floatPill.current.offsetHeight,
                                    // height of search bar + float pill
                                    left: 80
                                }
                            });
                        });
                        map.getSource("stops-highlight").setData({
                            type: "FeatureCollection",
                            features: routeStops1.map((stop, i)=>{
                                const { name , left  } = stopsData[stop];
                                return {
                                    type: "Feature",
                                    id: (0, _specialID.encode)(stop),
                                    properties: {
                                        name,
                                        number: stop,
                                        type: endStops1.includes(stop) ? "end" : intersectStops.includes(stop) ? "intersect" : null,
                                        left
                                    },
                                    geometry: {
                                        type: "Point",
                                        coordinates: stopsData[stop].coordinates
                                    }
                                };
                            })
                        });
                        // Show routes
                        requestAnimationFrame(()=>{
                            map.getSource("routes-path").setData({
                                type: "FeatureCollection",
                                features: serviceGeometries.map((sg)=>({
                                        type: "Feature",
                                        id: (0, _specialID.encode)(sg.service),
                                        properties: {
                                            service: sg.service
                                        },
                                        geometry: sg.geometry
                                    }))
                            });
                            STORE.routesPathServices = serviceGeometries.map((sg)=>sg.service);
                        });
                    }
                    break;
                }
            case "stop":
                {
                    const stop = route.value;
                    if (!stopsData[stop]) return;
                    // Reset
                    setExpandSearch(false);
                    setShrinkSearch(true);
                    resetSearch();
                    const { routes: routes1 , name: name1 , coordinates  } = stopsData[stop];
                    if (route.subpage === "routes") {
                        setHead({
                            title: [
                                "stop.titleRoutes",
                                {
                                    stopNumber: stop,
                                    stopName: name1
                                }
                            ],
                            url: `/stops/${stop}/routes`
                        });
                        // Hide all stops
                        map.setLayoutProperty("stops", "visibility", "none");
                        map.setLayoutProperty("stops-icon", "visibility", "none");
                        // Show the all stops in all routes
                        const allStopsCoords = [];
                        allStopsCoords.push(coordinates);
                        const otherStops = new Set();
                        routes1.forEach((route)=>{
                            const [service, index] = route.split("-");
                            const stops = servicesData[service].routes[index];
                            stops.forEach((s)=>stop !== s && otherStops.add(s));
                        });
                        [
                            ...otherStops
                        ].map((s)=>{
                            allStopsCoords.push(stopsData[s].coordinates);
                        });
                        // Fit map to route bounds
                        const bounds2 = new (0, _mapboxGlDefault.default).LngLatBounds();
                        allStopsCoords.forEach((coordinates)=>{
                            bounds2.extend(coordinates);
                        });
                        requestAnimationFrame(()=>{
                            map.fitBounds(bounds2, {
                                padding: largerScreen ? {
                                    top: floatPill.current.offsetHeight / 2,
                                    right: 80,
                                    bottom: 80,
                                    left: floatPill.current.offsetHeight / 2
                                } : BREAKPOINT() ? {
                                    top: 80,
                                    right: Math.max(floatPill.current.offsetWidth / 2, 80),
                                    bottom: 80 + floatPill.current.offsetHeight / 2,
                                    left: Math.max(floatPill.current.offsetWidth / 2, 80)
                                } : {
                                    top: 80,
                                    right: 80,
                                    bottom: 80 + floatPill.current.offsetHeight,
                                    // height of search bar + float pill
                                    left: 80
                                }
                            });
                        });
                        map.getSource("stops-highlight").setData({
                            type: "FeatureCollection",
                            features: [
                                {
                                    type: "Feature",
                                    id: (0, _specialID.encode)(stop),
                                    properties: {
                                        name: name1,
                                        number: stop,
                                        type: "end",
                                        left: stopsData[stop].left
                                    },
                                    geometry: {
                                        type: "Point",
                                        coordinates
                                    }
                                }
                            ]
                        });
                        // Show all routes
                        requestAnimationFrame(()=>{
                            const serviceGeometries = routes1.map((route)=>{
                                const [service, index] = route.split("-");
                                const line = routesData[service][index];
                                const geometry = (0, _polyline.toGeoJSON)(line);
                                return {
                                    service,
                                    geometry
                                };
                            });
                            map.getSource("routes-path").setData({
                                type: "FeatureCollection",
                                features: serviceGeometries.map((sg, i)=>({
                                        type: "Feature",
                                        id: (0, _specialID.encode)(sg.service),
                                        properties: {
                                            service: sg.service
                                        },
                                        geometry: sg.geometry
                                    }))
                            });
                            STORE.routesPathServices = serviceGeometries.map((sg)=>sg.service);
                        });
                    } else {
                        setHead({
                            title: [
                                "stop.title",
                                {
                                    stopNumber: stop,
                                    stopName: name1
                                }
                            ],
                            url: `/stops/${stop}`
                        });
                        map.setLayoutProperty("stops", "visibility", "visible");
                        map.setLayoutProperty("stops-icon", "visibility", "visible");
                        _showStopPopover(stop);
                    }
                    break;
                }
            case "between":
                {
                    const coords = route.value;
                    const [startStopNumber, endStopNumber] = coords.split(/[,-]/).map(String);
                    if (!stopsData[startStopNumber] || !stopsData[endStopNumber]) {
                        alert("One of the stop numbers are not found.");
                        return;
                    }
                    setHead({
                        title: `Routes between ${startStopNumber} and ${endStopNumber} - ${t("app.name")}`,
                        url: `/between/${startStopNumber}-${endStopNumber}`
                    });
                    // Reset
                    setExpandSearch(false);
                    setShrinkSearch(true);
                    // Hide all stops
                    map.setLayoutProperty("stops", "visibility", "none");
                    map.setLayoutProperty("stops-icon", "visibility", "none");
                    function findRoutesBetween(startStop, endStop) {
                        const results = [];
                        const endServicesStops = endStop.routes.map((route)=>{
                            const [service, routeIndex] = route.split("-");
                            let serviceStops = servicesData[service].routes[routeIndex];
                            serviceStops = serviceStops.slice(0, serviceStops.indexOf(endStop.number) + 1);
                            return {
                                service,
                                stops: serviceStops,
                                route
                            };
                        });
                        startStop.routes.forEach((route)=>{
                            const [service, routeIndex] = route.split("-");
                            let serviceStops = servicesData[service].routes[routeIndex];
                            serviceStops = serviceStops.slice(serviceStops.indexOf(startStop.number));
                            // This service already can go straight to the end stop,
                            // there's no need to find any connections from end stop
                            if (serviceStops.includes(endStop.number)) results.push({
                                startService: service,
                                startRoute: route,
                                stopsBetween: []
                            });
                            else endServicesStops.forEach(({ service: s , stops , route: r  })=>{
                                // console.log(serviceStops, stops);
                                const intersectedStops = (0, _justIntersectDefault.default)(stops, serviceStops);
                                if (intersectedStops.length) {
                                    const startIndex = intersectedStops.indexOf(startStop.number);
                                    if (startIndex > -1) intersectedStops.splice(startIndex, 1);
                                    const endIndex = intersectedStops.indexOf(endStop.number);
                                    if (endIndex > -1) intersectedStops.splice(endIndex, 1);
                                    if (intersectedStops.length) results.push({
                                        startStop,
                                        startService: service,
                                        startRoute: route,
                                        stopsBetween: intersectedStops,
                                        endRoute: r,
                                        endService: s,
                                        endStop
                                    });
                                }
                            });
                        });
                        return results;
                    }
                    function findNearestStops(stop) {
                        let distance = Infinity;
                        let nearestStop = null;
                        for(let i = 0, l = stopsDataArr.length; i < l; i++){
                            const s = stopsDataArr[i];
                            if (s.number !== stop.number) {
                                const d = (0, _getDistanceDefault.default)(...stop.coordinates, ...s.coordinates);
                                if (d < distance) {
                                    distance = d;
                                    nearestStop = s;
                                }
                            }
                        }
                        return nearestStop;
                    }
                    const startStop = stopsData[startStopNumber];
                    const endStop = stopsData[endStopNumber];
                    const nearestEndStop = findNearestStops(endStop);
                    const nearestStartStop = findNearestStops(startStop);
                    console.log(startStop, endStop, nearestEndStop, nearestStartStop);
                    _showBetweenPopover({
                        startStop,
                        endStop,
                        nearestStartStop,
                        nearestEndStop,
                        startWalkMins: (0, _getWalkingMinutesDefault.default)(ruler.distance(startStop.coordinates, nearestStartStop.coordinates) * 1000),
                        endWalkMins: (0, _getWalkingMinutesDefault.default)(ruler.distance(endStop.coordinates, nearestEndStop.coordinates) * 1000),
                        results: [
                            findRoutesBetween(startStop, endStop),
                            findRoutesBetween(startStop, nearestEndStop),
                            findRoutesBetween(nearestStartStop, endStop),
                            findRoutesBetween(nearestStartStop, nearestEndStop)
                        ]
                    });
                    break;
                }
            default:
                setHead(defaultHead);
                // Show all stops
                map.setLayoutProperty("stops", "visibility", "visible");
                map.setLayoutProperty("stops-icon", "visibility", "visible");
        }
        const { pathname , search , hash  } = location;
        gtag("config", window._GA_TRACKING_ID, {
            page_path: pathname + search + hash
        });
        setRouteLoading(false);
    };
    const setStartStop = (number)=>{
        if (betweenEndStop && betweenEndStop != number) location.hash = `/between/${number}-${betweenEndStop}`;
        else {
            setBetweenStartStop(number);
            setBetweenEndStop(null);
        }
    };
    const setEndStop = (number)=>{
        if (betweenStartStop && betweenStartStop != number) location.hash = `/between/${betweenStartStop}-${number}`;
        else {
            setBetweenStartStop(null);
            setBetweenEndStop(number);
        }
    };
    const resetStartEndStops = ()=>{
        setBetweenStartStop(null);
        setBetweenEndStop(null);
    };
    const [mapLoaded, setMapLoaded] = (0, _hooks.useState)(false);
    const onLoad = async ()=>{
        window.onhashchange = ()=>{
            setRoute((0, _getRouteDefault.default)());
            renderRoute();
        };
        const fetchStopsP = (0, _fetchCacheDefault.default)(stopsJSONPath, CACHE_TIME);
        const fetchServicesP = (0, _fetchCacheDefault.default)(servicesJSONPath, CACHE_TIME);
        const fetchRoutesP = (0, _fetchCacheDefault.default)(routesJSONPath, CACHE_TIME);
        // Init data
        const stops = await fetchStopsP;
        Object.keys(stops).forEach((number)=>{
            const stop = stops[number];
            const [lng, lat, name] = stop;
            let left = false;
            if (/[19]$/.test(number)) {
                const oppositeNumber = number.replace(/[19]$/, (d)=>d === "1" ? 9 : 1);
                const oppositeStop = stops[oppositeNumber];
                if (oppositeStop) {
                    const bearing = ruler.bearing([
                        lng,
                        lat
                    ], [
                        oppositeStop[0],
                        oppositeStop[1]
                    ]);
                    left = bearing > 0;
                }
            }
            stopsData[number] = {
                name,
                number,
                interchange: /\sint$/i.test(name) && !/^(bef|aft|opp|bet)\s/i.test(name),
                coordinates: [
                    lng,
                    lat
                ],
                services: [],
                routes: [],
                left
            };
            stopsDataArr.push(stopsData[number]);
        });
        stopsDataArr.sort((a, b)=>a.interchange ? 1 : b.interchange ? -1 : 0);
        servicesData = await fetchServicesP;
        Object.keys(servicesData).forEach((number)=>{
            const { name , routes  } = servicesData[number];
            servicesDataArr.push({
                number,
                name
            });
            routes.forEach((route, i)=>{
                route.forEach((stop)=>{
                    if (stopsData[stop] && !stopsData[stop].services.includes(number)) {
                        stopsData[stop].services.push(number);
                        stopsData[stop].routes.push(number + "-" + i);
                    }
                });
            });
        });
        servicesDataArr.sort((a, b)=>(0, _bus.sortServices)(a.number, b.number));
        routesData = await fetchRoutesP;
        setServices(servicesDataArr);
        window._data = {
            servicesData,
            stopsData,
            stopsDataArr,
            routesData,
            servicesDataArr
        };
        map = window._map = new (0, _mapboxGlDefault.default).Map({
            container: "map",
            // style: 'mapbox://styles/cheeaun/clasg1d6s003s15qmq7wr6yp1/draft',
            style: "mapbox://styles/cheeaun/clasg1d6s003s15qmq7wr6yp1",
            renderWorldCopies: false,
            boxZoom: false,
            minZoom: 8,
            logoPosition: "bottom-left",
            attributionControl: false,
            pitchWithRotate: false,
            dragRotate: supportsTouch,
            touchPitch: false,
            bounds: [
                lowerLong,
                lowerLat,
                upperLong,
                upperLat
            ],
            fitBoundsOptions: {
                padding: BREAKPOINT() ? 120 : {
                    top: 40,
                    bottom: window.innerHeight / 2,
                    left: 40,
                    right: 40
                }
            }
        });
        if (!supportsTouch) map.touchZoomRotate.disableRotation();
        // Controls
        map.addControl(new (0, _mapboxGlDefault.default).AttributionControl({
            compact: true
        }), "bottom-left");
        map.addControl(new (0, _geolocateControlDefault.default)({
            offset: ()=>{
                if (!BREAKPOINT()) {
                    if (stopPopover.current?.classList.contains("expand")) return [
                        0,
                        -stopPopover.current.offsetHeight / 2
                    ];
                    else if (servicePopover.current?.classList.contains("expand")) return [
                        0,
                        -servicePopover.current.offsetHeight / 2
                    ];
                    else if (betweenPopover.current?.classList.contains("expand")) return [
                        0,
                        -betweenPopover.current.offsetHeight / 2
                    ];
                }
                return [
                    0,
                    0
                ];
            }
        }), "top-right");
        map.addControl(new (0, _mapboxGlDefault.default).NavigationControl({
            showCompass: true,
            showZoom: !supportsTouch
        }), "top-right");
        const compassButton = document.querySelector(".mapboxgl-ctrl-compass");
        map.on("rotateend", ()=>{
            const bearing = map.getBearing();
            compassButton.classList.toggle("show", bearing !== 0);
        });
        const mapLang = ()=>{
            // There's only en and zh, Don't have ms yet
            return ({
                zh: "zh-Hans"
            })[i18n.resolvedLanguage] || i18n.resolvedLanguage;
        };
        const language = new (0, _mapboxGlLanguageDefault.default)({
            supportedLanguages: [
                "en",
                "zh-Hans",
                "ms",
                "ta",
                "ja"
            ],
            defaultLanguage: mapLang()
        });
        map.addControl(language);
        i18n.on("languageChanged", ()=>{
            const localizedStyle = language.setLanguage(map.getStyle(), mapLang());
            map.setStyle(localizedStyle);
        });
        let initialMoveStart = false;
        const initialHideSearch = ()=>{
            if (initialMoveStart) return;
            initialMoveStart = true;
            $logo.classList.add("fadeout");
            setShrinkSearch(true);
        };
        map.once("dragstart", initialHideSearch);
        map.once("zoomstart", initialHideSearch);
        await new Promise((resolve, reject)=>{
            map.once("styledata", ()=>{
                const layers = map.getStyle().layers;
                console.log(layers);
                // labelLayerId = layers.find(
                //   (l) => l.type == 'symbol' && l.layout['text-field'],
                // ).id;
                resolve();
            });
        });
        // const localizedStyle = language.setLanguage(map.getStyle(), 'zh-Hans');
        // map.setStyle(localizedStyle);
        if (window.performance) {
            const timeSincePageLoad = Math.round(performance.now());
            gtag("event", "timing_complete", {
                name: "load",
                value: timeSincePageLoad,
                event_category: "Map"
            });
        }
        map.loadImage((0, _stopPngDefault.default), (e, img)=>{
            if (e) throw e;
            map.addImage("stop", img);
        });
        map.loadImage((0, _stopEndPngDefault.default), (e, img)=>{
            if (e) throw e;
            map.addImage("stop-end", img);
        });
        setMapLoaded(true);
    };
    (0, _hooks.useEffect)(()=>{
        onLoad();
    }, []);
    (0, _hooks.useEffect)(()=>{
        if (!mapLoaded) return;
        const mapCanvas = map.getCanvas();
        map.addSource("stops", {
            type: "geojson",
            tolerance: 10,
            buffer: 0,
            data: {
                type: "FeatureCollection",
                features: stopsDataArr.map((stop)=>({
                        type: "Feature",
                        id: (0, _specialID.encode)(stop.number),
                        properties: {
                            number: stop.number,
                            name: stop.name,
                            interchange: stop.interchange,
                            left: stop.left
                        },
                        geometry: {
                            type: "Point",
                            coordinates: stop.coordinates
                        }
                    }))
            }
        });
        const stopTextPartialFormat = [
            "get",
            "number"
        ];
        const stopTextFullFormat = [
            "format",
            [
                "get",
                "number"
            ],
            {
                "font-scale": 0.8
            },
            "\n",
            {},
            [
                "get",
                "name"
            ],
            {
                "text-color": "#000"
            }
        ];
        const stopText = {
            layout: {
                "text-optional": true,
                "text-field": [
                    "step",
                    [
                        "zoom"
                    ],
                    "",
                    15,
                    stopTextPartialFormat,
                    16,
                    stopTextFullFormat
                ],
                "text-size": [
                    "step",
                    [
                        "zoom"
                    ],
                    12,
                    16,
                    14
                ],
                "text-justify": [
                    "case",
                    [
                        "boolean",
                        [
                            "get",
                            "left"
                        ],
                        false
                    ],
                    "right",
                    "left"
                ],
                "text-anchor": [
                    "case",
                    [
                        "boolean",
                        [
                            "get",
                            "left"
                        ],
                        false
                    ],
                    "right",
                    "left"
                ],
                "text-offset": [
                    "case",
                    [
                        "boolean",
                        [
                            "get",
                            "left"
                        ],
                        false
                    ],
                    [
                        "literal",
                        [
                            -1,
                            0
                        ]
                    ],
                    [
                        "literal",
                        [
                            1,
                            0
                        ]
                    ]
                ],
                // 'text-justify': 'auto',
                // 'text-variable-anchor': ['left', 'right'],
                // 'text-radial-offset': 1,
                "text-padding": 0.5,
                "text-font": [
                    "DIN Offc Pro Medium",
                    "Arial Unicode MS Regular"
                ],
                "text-max-width": 16,
                "text-line-height": 1.1
            },
            paint: {
                "text-color": "#f01b48",
                "text-halo-width": 1,
                "text-halo-color": "#fff"
            }
        };
        map.addLayer({
            id: "stops",
            type: "circle",
            source: "stops",
            layout: {
                visibility: "none"
            },
            paint: {
                "circle-radius": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    10,
                    [
                        "case",
                        [
                            "boolean",
                            [
                                "feature-state",
                                "selected"
                            ],
                            false
                        ],
                        4,
                        0.75
                    ],
                    14,
                    4,
                    15,
                    [
                        "case",
                        [
                            "boolean",
                            [
                                "feature-state",
                                "selected"
                            ],
                            false
                        ],
                        12,
                        6
                    ]
                ],
                "circle-color": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "selected"
                        ],
                        false
                    ],
                    "#fff",
                    "#f01b48"
                ],
                "circle-stroke-color": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "selected"
                        ],
                        false
                    ],
                    "#f01b48",
                    "#fff"
                ],
                "circle-stroke-width": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "selected"
                        ],
                        false
                    ],
                    5,
                    1
                ],
                "circle-opacity": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    10,
                    1,
                    13.9,
                    1,
                    14,
                    0.5
                ],
                "circle-stroke-opacity": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    10,
                    [
                        "case",
                        [
                            "boolean",
                            [
                                "feature-state",
                                "selected"
                            ],
                            false
                        ],
                        1,
                        0
                    ],
                    13.5,
                    1,
                    14,
                    0.5
                ]
            }
        }, "settlement-subdivision-label");
        map.addLayer({
            id: "stops-icon",
            type: "symbol",
            source: "stops",
            filter: [
                "any",
                [
                    ">=",
                    [
                        "zoom"
                    ],
                    14
                ],
                [
                    "get",
                    "interchange"
                ]
            ],
            layout: {
                visibility: "none",
                // 'symbol-z-order': 'source',
                "icon-image": "stop",
                "icon-size": [
                    "step",
                    [
                        "zoom"
                    ],
                    0.4,
                    15,
                    0.5,
                    16,
                    0.6
                ],
                "icon-padding": 0.5,
                "icon-allow-overlap": true,
                // 'icon-ignore-placement': true,
                ...stopText.layout
            },
            paint: {
                "icon-opacity": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    8,
                    [
                        "case",
                        [
                            "get",
                            "interchange"
                        ],
                        1,
                        0
                    ],
                    14,
                    1
                ],
                ...stopText.paint
            }
        });
        requestIdleCallback(()=>{
            map.on("mouseenter", "stops", ()=>{
                mapCanvas.style.cursor = "pointer";
            });
            let lastFrame = null;
            if (supportsHover) {
                let lastFeature = null;
                map.on("mousemove", (e)=>{
                    const { point  } = e;
                    const features = map.queryRenderedFeatures(point, {
                        layers: [
                            "stops",
                            "stops-highlight"
                        ],
                        validate: false
                    });
                    if (features.length && map.getZoom() < 16 && !map.isMoving()) {
                        if (lastFeature && features[0].id === lastFeature.id) return;
                        lastFeature = features[0];
                        const stopID = (0, _specialID.decode)(features[0].id);
                        const data = stopsData[stopID];
                        if (lastFrame) cancelAnimationFrame(lastFrame);
                        lastFrame = requestAnimationFrame(()=>{
                            showStopTooltip({
                                ...data,
                                ...point
                            });
                        });
                    } else if (lastFeature) {
                        lastFeature = null;
                        hideStopTooltip();
                    }
                });
            }
            map.on("mouseleave", "stops", ()=>{
                mapCanvas.style.cursor = "";
                if (lastFrame) cancelAnimationFrame(lastFrame);
                requestAnimationFrame(hideStopTooltip);
            });
            map.on("mouseout", hideStopTooltip);
            map.on("movestart", hideStopTooltip);
        });
        map.addSource("stops-highlight", {
            type: "geojson",
            tolerance: 10,
            buffer: 0,
            data: {
                type: "FeatureCollection",
                features: []
            }
        });
        map.addLayer({
            id: "stops-highlight-circle",
            type: "circle",
            source: "stops-highlight",
            minzoom: 11,
            maxzoom: 14,
            filter: [
                "all",
                [
                    "!=",
                    [
                        "get",
                        "type"
                    ],
                    "end"
                ],
                [
                    "!=",
                    [
                        "get",
                        "type"
                    ],
                    "intersect"
                ]
            ],
            paint: {
                "circle-radius": [
                    "step",
                    [
                        "zoom"
                    ],
                    1.5,
                    12,
                    2
                ],
                "circle-color": "#fff",
                "circle-stroke-color": "#f01b48",
                "circle-stroke-width": [
                    "step",
                    [
                        "zoom"
                    ],
                    1.5,
                    12,
                    2
                ]
            }
        });
        map.addLayer({
            id: "stops-highlight",
            type: "symbol",
            source: "stops-highlight",
            filter: [
                "any",
                [
                    ">=",
                    [
                        "zoom"
                    ],
                    14
                ],
                [
                    "==",
                    [
                        "get",
                        "type"
                    ],
                    "end"
                ],
                [
                    "==",
                    [
                        "get",
                        "type"
                    ],
                    "intersect"
                ]
            ],
            layout: {
                "icon-image": [
                    "case",
                    [
                        "==",
                        [
                            "get",
                            "type"
                        ],
                        "end"
                    ],
                    "stop-end",
                    [
                        "==",
                        [
                            "get",
                            "type"
                        ],
                        "intersect"
                    ],
                    "stop-end",
                    "stop"
                ],
                "icon-size": [
                    "step",
                    [
                        "zoom"
                    ],
                    0.3,
                    10,
                    [
                        "case",
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "end"
                        ],
                        0.3,
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "intersect"
                        ],
                        0.25,
                        0.45
                    ],
                    15,
                    [
                        "case",
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "end"
                        ],
                        0.45,
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "intersect"
                        ],
                        0.4,
                        0.6
                    ]
                ],
                "icon-anchor": [
                    "case",
                    [
                        "==",
                        [
                            "get",
                            "type"
                        ],
                        "end"
                    ],
                    "bottom",
                    [
                        "==",
                        [
                            "get",
                            "type"
                        ],
                        "intersect"
                    ],
                    "bottom",
                    "center"
                ],
                "icon-padding": 0.5,
                "icon-allow-overlap": true,
                "icon-ignore-placement": true,
                ...stopText.layout,
                "text-field": [
                    "step",
                    [
                        "zoom"
                    ],
                    [
                        "case",
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "end"
                        ],
                        stopTextFullFormat,
                        ""
                    ],
                    14,
                    [
                        "case",
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "end"
                        ],
                        stopTextFullFormat,
                        stopTextPartialFormat
                    ],
                    16,
                    stopTextFullFormat
                ],
                "text-size": [
                    "step",
                    [
                        "zoom"
                    ],
                    [
                        "case",
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "end"
                        ],
                        14,
                        11
                    ],
                    16,
                    14
                ]
            },
            paint: {
                ...stopText.paint,
                "text-halo-width": [
                    "case",
                    [
                        "==",
                        [
                            "get",
                            "type"
                        ],
                        "end"
                    ],
                    2,
                    1
                ]
            }
        });
        map.addLayer({
            id: "stops-highlight-selected",
            type: "circle",
            source: "stops-highlight",
            filter: [
                "any",
                [
                    ">",
                    [
                        "zoom"
                    ],
                    10
                ],
                [
                    "==",
                    [
                        "get",
                        "type"
                    ],
                    "end"
                ]
            ],
            paint: {
                "circle-radius": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    10,
                    4,
                    15,
                    [
                        "case",
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "end"
                        ],
                        4,
                        [
                            "==",
                            [
                                "get",
                                "type"
                            ],
                            "intersect"
                        ],
                        4,
                        12
                    ]
                ],
                "circle-color": "#fff",
                "circle-stroke-color": "#f01b48",
                "circle-stroke-width": 5,
                "circle-opacity": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "selected"
                        ],
                        false
                    ],
                    0.5,
                    0
                ],
                "circle-stroke-opacity": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "selected"
                        ],
                        false
                    ],
                    0.5,
                    0
                ]
            }
        }, "stops-highlight");
        requestIdleCallback(()=>{
            map.on("mouseenter", "stops-highlight", ()=>{
                mapCanvas.style.cursor = "pointer";
            });
            map.on("mouseleave", "stops-highlight", ()=>{
                mapCanvas.style.cursor = "";
            });
        });
        // Bus service routes
        map.addSource("routes", {
            type: "geojson",
            tolerance: 1,
            buffer: 0,
            lineMetrics: true,
            data: {
                type: "FeatureCollection",
                features: []
            }
        });
        map.addLayer({
            id: "routes",
            type: "line",
            source: "routes",
            layout: {
                "line-cap": "round"
            },
            paint: {
                "line-color": "#f01b48",
                "line-gradient": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "line-progress"
                    ],
                    0,
                    "#f01b48",
                    0.5,
                    "#972FFE",
                    1,
                    "#f01b48"
                ],
                "line-opacity": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    0.9,
                    16,
                    0.4
                ],
                "line-width": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    2,
                    16,
                    5,
                    22,
                    10
                ],
                "line-offset": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    0,
                    16,
                    -3,
                    22,
                    [
                        "*",
                        [
                            "zoom"
                        ],
                        -3
                    ]
                ]
            }
        }, "stops");
        map.addLayer({
            id: "routes-bg",
            type: "line",
            source: "routes",
            layout: {
                "line-cap": "round"
            },
            paint: {
                "line-color": "#fff",
                "line-opacity": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    1,
                    22,
                    0
                ],
                "line-width": 6,
                "line-offset": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    0,
                    16,
                    -3,
                    22,
                    [
                        "*",
                        [
                            "zoom"
                        ],
                        -3
                    ]
                ]
            }
        }, "routes");
        map.addLayer({
            id: "route-arrows",
            type: "symbol",
            source: "routes",
            minzoom: 12,
            layout: {
                "symbol-placement": "line",
                "symbol-spacing": 100,
                "text-field": "→",
                "text-size": 16,
                "text-font": [
                    "DIN Offc Pro Medium",
                    "Arial Unicode MS Regular"
                ],
                "text-allow-overlap": true,
                "text-ignore-placement": true,
                "text-keep-upright": false,
                "text-anchor": "bottom",
                "text-padding": 0,
                "text-line-height": 1,
                "text-offset": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    [
                        "literal",
                        [
                            0,
                            0
                        ]
                    ],
                    22,
                    [
                        "literal",
                        [
                            0,
                            -2
                        ]
                    ]
                ]
            },
            paint: {
                "text-color": "#5301a4",
                "text-opacity": 0.9,
                "text-halo-color": "#fff",
                "text-halo-width": 2
            }
        }, "stops");
        // Bus service routes (passing, overlapping)
        map.addSource("routes-path", {
            type: "geojson",
            tolerance: 1,
            buffer: 0,
            lineMetrics: true,
            data: {
                type: "FeatureCollection",
                features: []
            }
        });
        map.addLayer({
            id: "routes-path",
            type: "line",
            source: "routes-path",
            layout: {
                "line-cap": "round"
            },
            paint: {
                "line-color": "#f01b48",
                "line-gradient": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "line-progress"
                    ],
                    0,
                    "#f01b48",
                    0.5,
                    "#972FFE",
                    1,
                    "#f01b48"
                ],
                "line-opacity": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "hover"
                        ],
                        false
                    ],
                    1,
                    [
                        "boolean",
                        [
                            "feature-state",
                            "fadein"
                        ],
                        false
                    ],
                    0.07,
                    0.5 // default
                ],
                "line-width": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    2,
                    16,
                    5,
                    22,
                    10
                ]
            }
        }, "stops");
        map.addLayer({
            id: "routes-path-bg",
            type: "line",
            source: "routes-path",
            layout: {
                "line-cap": "round"
            },
            maxzoom: 20,
            paint: {
                "line-color": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "fadein"
                        ],
                        false
                    ],
                    "transparent",
                    "#fff"
                ],
                "line-width": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    6,
                    16,
                    10,
                    22,
                    16
                ]
            }
        }, "routes-path");
        map.addLayer({
            id: "route-path-labels",
            type: "symbol",
            source: "routes-path",
            layout: {
                "symbol-placement": "line",
                "symbol-spacing": 300,
                "text-font": [
                    "DIN Offc Pro Medium",
                    "Arial Unicode MS Regular"
                ],
                "text-field": "{service}",
                "text-size": 14,
                "text-rotation-alignment": "viewport",
                "text-padding": 0,
                "text-line-height": 1
            },
            paint: {
                "text-color": "#3a6727",
                "text-halo-color": "#eeffd1",
                "text-halo-width": 2,
                "text-opacity": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "fadein"
                        ],
                        false
                    ],
                    0.1,
                    1
                ]
            }
        });
        map.addLayer({
            id: "route-path-arrows",
            type: "symbol",
            source: "routes-path",
            minzoom: 12,
            layout: {
                "symbol-placement": "line",
                "symbol-spacing": 200,
                "text-field": "→",
                "text-size": 16,
                "text-font": [
                    "DIN Offc Pro Medium",
                    "Arial Unicode MS Regular"
                ],
                // 'text-allow-overlap': true,
                // 'text-ignore-placement': true,
                "text-keep-upright": false,
                "text-anchor": "bottom",
                "text-padding": 0,
                "text-line-height": 1,
                "text-offset": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    [
                        "literal",
                        [
                            0,
                            0
                        ]
                    ],
                    22,
                    [
                        "literal",
                        [
                            0,
                            -2
                        ]
                    ]
                ]
            },
            paint: {
                "text-color": "#5301a4",
                "text-opacity": 0.9,
                "text-halo-color": "#fff",
                "text-halo-width": 2,
                "text-opacity": [
                    "case",
                    [
                        "boolean",
                        [
                            "feature-state",
                            "fadein"
                        ],
                        false
                    ],
                    0.1,
                    1
                ]
            }
        }, "stops");
        requestIdleCallback(()=>{
            let hoveredRouteID;
            map.on("mouseenter", "routes-path", ()=>{
                mapCanvas.style.cursor = "pointer";
            });
            map.on("click", "routes-path", (e)=>{
                if (e.features.length) {
                    const { id  } = e.features[0];
                    location.hash = `/services/${(0, _specialID.decode)(id)}`;
                }
            });
            map.on("mousemove", "routes-path", (e)=>{
                if (e.features.length) {
                    const currentHoveredRouteID = e.features[0].id;
                    if (hoveredRouteID && hoveredRouteID === currentHoveredRouteID) return;
                    if (hoveredRouteID) map.setFeatureState({
                        source: "routes-path",
                        id: hoveredRouteID
                    }, {
                        hover: false,
                        fadein: false
                    });
                    hoveredRouteID = currentHoveredRouteID;
                    map.setFeatureState({
                        source: "routes-path",
                        id: hoveredRouteID
                    }, {
                        hover: true,
                        fadein: false
                    });
                    STORE.routesPathServices?.forEach((service)=>{
                        const id = (0, _specialID.encode)(service);
                        if (hoveredRouteID === id) return;
                        map.setFeatureState({
                            source: "routes-path",
                            id
                        }, {
                            hover: false,
                            fadein: true
                        });
                    });
                    highlightRouteTag((0, _specialID.decode)(hoveredRouteID));
                }
            });
            map.on("mouseleave", "routes-path", ()=>{
                mapCanvas.style.cursor = "";
                if (hoveredRouteID) {
                    STORE.routesPathServices?.forEach((service)=>{
                        const id = (0, _specialID.encode)(service);
                        map.setFeatureState({
                            source: "routes-path",
                            id
                        }, {
                            fadein: false,
                            hover: false
                        });
                    });
                    hoveredRouteID = null;
                    highlightRouteTag();
                }
            });
        });
        // Traffic
        map.addSource("traffic", {
            type: "vector",
            url: "mapbox://mapbox.mapbox-traffic-v1"
        });
        map.addLayer({
            id: "traffic",
            type: "line",
            source: "traffic",
            "source-layer": "traffic",
            minzoom: 14,
            filter: [
                "all",
                [
                    "==",
                    "$type",
                    "LineString"
                ],
                [
                    "has",
                    "congestion"
                ]
            ],
            layout: {
                "line-join": "round",
                "line-cap": "round",
                visibility: "none"
            },
            paint: {
                "line-width": 3,
                "line-offset": [
                    "case",
                    [
                        "match",
                        [
                            "get",
                            "class"
                        ],
                        [
                            "link",
                            "motorway_link",
                            "service",
                            "street"
                        ],
                        true,
                        false
                    ],
                    6,
                    [
                        "match",
                        [
                            "get",
                            "class"
                        ],
                        [
                            "secondary",
                            "tertiary"
                        ],
                        true,
                        false
                    ],
                    6,
                    [
                        "==",
                        "class",
                        "primary"
                    ],
                    12,
                    [
                        "==",
                        "class",
                        "trunk"
                    ],
                    12,
                    [
                        "==",
                        "class",
                        "motorway"
                    ],
                    9,
                    6
                ],
                "line-color": [
                    "match",
                    [
                        "get",
                        "congestion"
                    ],
                    "low",
                    "rgba(36, 218, 26, .2)",
                    "moderate",
                    "rgba(253, 149, 0, .55)",
                    "heavy",
                    "rgba(252, 77, 77, .65)",
                    "severe",
                    "rgba(148, 41, 76, .75)",
                    "transparent"
                ],
                "line-opacity": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    14.1,
                    0,
                    16,
                    1
                ]
            }
        }, "road-label-navigation");
        // Service live buses
        map.addSource("buses-service", {
            type: "geojson",
            data: {
                type: "FeatureCollection",
                features: []
            }
        });
        map.loadImage((0, _busTinyPngDefault.default), (e, img)=>{
            if (e) throw e;
            map.addImage("bus-tiny", img);
        });
        map.addLayer({
            id: "buses-service",
            type: "symbol",
            source: "buses-service",
            minzoom: 9,
            layout: {
                "icon-image": "bus-tiny",
                "icon-allow-overlap": true,
                "icon-ignore-placement": true,
                "icon-size": [
                    "step",
                    [
                        "zoom"
                    ],
                    0.3,
                    14,
                    0.35,
                    15,
                    0.45,
                    16,
                    0.55
                ]
            }
        });
        // Between routes
        map.addSource("routes-between", {
            type: "geojson",
            tolerance: 1,
            buffer: 0,
            data: {
                type: "FeatureCollection",
                features: []
            }
        });
        map.addLayer({
            id: "routes-between",
            type: "line",
            source: "routes-between",
            filter: [
                "!=",
                [
                    "get",
                    "type"
                ],
                "walk"
            ],
            layout: {
                "line-cap": "round"
            },
            paint: {
                "line-color": [
                    "match",
                    [
                        "get",
                        "type"
                    ],
                    "start",
                    "#f01b48",
                    "end",
                    "#972FFE",
                    "#f01b48"
                ],
                "line-opacity": 0.7,
                "line-width": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    2,
                    16,
                    5,
                    22,
                    10
                ],
                "line-offset": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    0,
                    16,
                    -3,
                    22,
                    [
                        "*",
                        [
                            "zoom"
                        ],
                        -3
                    ]
                ]
            }
        }, "stops");
        map.addLayer({
            id: "routes-between-walk",
            type: "line",
            source: "routes-between",
            filter: [
                "==",
                [
                    "get",
                    "type"
                ],
                "walk"
            ],
            paint: {
                "line-color": "#007aff",
                "line-dasharray": [
                    2,
                    2
                ],
                "line-opacity": 0.7,
                "line-width": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    2,
                    16,
                    5,
                    22,
                    10
                ]
            }
        }, "stops-highlight");
        map.addLayer({
            id: "routes-between-bg",
            type: "line",
            source: "routes-between",
            layout: {
                "line-cap": "round"
            },
            maxzoom: 14,
            paint: {
                "line-color": "#fff",
                "line-width": 6
            }
        }, "routes-between");
        map.addLayer({
            id: "route-between-arrows",
            type: "symbol",
            source: "routes-between",
            minzoom: 12,
            layout: {
                "symbol-placement": "line",
                "symbol-spacing": 100,
                "text-field": "→",
                "text-size": 16,
                "text-allow-overlap": true,
                "text-ignore-placement": true,
                "text-keep-upright": false,
                "text-anchor": "bottom",
                "text-padding": 0,
                "text-line-height": 1,
                "text-offset": [
                    "interpolate",
                    [
                        "linear"
                    ],
                    [
                        "zoom"
                    ],
                    12,
                    [
                        "literal",
                        [
                            0,
                            0
                        ]
                    ],
                    22,
                    [
                        "literal",
                        [
                            0,
                            -2
                        ]
                    ]
                ]
            },
            paint: {
                "text-color": "#5301a4",
                "text-opacity": 0.8,
                "text-halo-color": "#fff",
                "text-halo-width": 2
            }
        });
        renderRoute();
        // Popover search field
        fuseServices = new (0, _fuseJsDefault.default)(servicesDataArr, {
            threshold: 0.3,
            keys: [
                "number",
                "name"
            ]
        });
        fuseStops = new (0, _fuseJsDefault.default)(stopsDataArr, {
            threshold: 0.3,
            keys: [
                "number",
                "name"
            ]
        });
        requestIdleCallback(()=>{
            // For cases when user already typed something before fuse.js inits
            if (searchField.current?.value) handleSearch();
            // Finally, show ad
            map.once("idle", ()=>{
                setTimeout(()=>{
                    setShowAd(true);
                }, 1000);
            });
        });
    }, [
        mapLoaded
    ]);
    (0, _hooks.useEffect)(()=>{
        if (!mapLoaded) return;
        const handleMapClick = (e)=>{
            if (e.originalEvent.altKey) console.log(e.lngLat);
            const { point  } = e;
            const features = map.queryRenderedFeatures(point, {
                layers: [
                    "stops",
                    "stops-icon",
                    "stops-highlight"
                ],
                validate: false
            });
            if (features.length) {
                const zoom = map.getZoom();
                const feature = features[0];
                const center = feature.geometry.coordinates;
                if (zoom < 12) {
                    // Slowly zoom in first
                    map.flyTo({
                        zoom: zoom + 2,
                        center
                    });
                    setShrinkSearch(true);
                } else if (feature.source == "stops") location.hash = `/stops/${feature.properties.number}`;
                else _showStopPopover(feature.properties.number);
            } else {
                const { page , subpage  } = route;
                if (page === "stop" && subpage !== "routes") location.hash = "/";
                else hideStopPopover();
            }
        };
        map.on("click", handleMapClick);
        return ()=>map.off("click", handleMapClick);
    }, [
        mapLoaded,
        route.page,
        route.subpage,
        _showStopPopover,
        hideStopPopover
    ]);
    const popoverIsUp = (0, _hooks.useMemo)(()=>(!!showStopPopover || !!showBetweenPopover || !!showArrivalsPopover || !!showServicePopover) && !largerScreen, [
        showStopPopover,
        showBetweenPopover,
        showArrivalsPopover,
        showServicePopover,
        largerScreen
    ]);
    // Global shortcuts
    (0, _hooks.useEffect)(()=>{
        const handler = (e)=>{
            const isFormField = e.target && e.target.tagName && /input|textarea|button|select/i.test(e.target.tagName);
            const keydown = e.key.toLowerCase();
            switch(keydown){
                case "/":
                    console.log("/", isFormField, searchField.current);
                    if (isFormField) return;
                    if (popoverIsUp) return;
                    e.preventDefault();
                    searchField.current.focus();
                    break;
                case "escape":
                    if (expandSearch) handleSearchClose();
                    else if (showStopPopover) hideStopPopover();
                    else if (showBetweenPopover) location.hash = "/";
                    else if (showServicePopover) location.hash = "/";
                    break;
                default:
                    if (e.shiftKey && e.altKey) document.body.classList.add("alt-mode");
            }
        };
        document.addEventListener("keydown", handler);
        return ()=>document.removeEventListener("keydown", handler);
    }, [
        expandSearch,
        showStopPopover,
        showBetweenPopover,
        showServicePopover,
        popoverIsUp
    ]);
    document.addEventListener("keyup", ()=>{
        document.body.classList.remove("alt-mode");
    });
    const showServicesFloatPill = route.page === "service" && servicesData && routeServices.length > 1;
    const showPassingRoutesFloatPill = route.page === "stop" && route.subpage === "routes" && stopsData && stopsData[route.value];
    return (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)((0, _aboutDefault.default), null), (0, _preact.h)("div", {
        id: "search-popover",
        ref: searchPopover,
        class: `popover ${expandSearch ? "expand" : ""} ${shrinkSearch ? "shrink" : ""} ${routeLoading ? "loading" : ""}`
    }, (0, _preact.h)("div", {
        id: "popover-float",
        hidden: !(showServicesFloatPill || showPassingRoutesFloatPill)
    }, (0, _preact.h)("div", {
        class: "float-pill",
        ref: floatPill
    }, (0, _preact.h)("a", {
        href: "#/",
        class: "popover-close"
    }, "\xd7"), showServicesFloatPill && (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("div", {
        class: "service-flex"
    }, (0, _preact.h)("h1", null, t("multiRoute.showingServices", {
        count: routeServices.length
    }))), (0, _preact.h)("div", {
        class: "services-list"
    }, (0, _preact.h)("div", null, routeServices.sort((0, _bus.sortServices)).map((service)=>(0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("a", {
            href: `#/services/${service}`,
            onClick: (e)=>clickRoute(e, service),
            onMouseEnter: (e)=>highlightRoute(e, service),
            onMouseLeave: unhighlightRoute,
            class: "service-tag",
            "data-service": service
        }, service, (0, _preact.h)("span", {
            class: "close",
            title: "Remove this service",
            onClick: (e)=>{
                e.preventDefault();
                e.stopPropagation();
                const newRouteServices = routeServices.filter((s)=>s !== service);
                location.hash = `/services/${newRouteServices.join("~")}`;
                unhighlightRoute();
            }
        }, "\xd7")))), (0, _preact.h)("button", {
        type: "button",
        class: "plus",
        onClick: ()=>{
            setExpandSearch(true);
            setExpandedSearchOnce(true);
        },
        title: t("multiRoute.addRoute")
    })), !!intersectStops.length && (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("h2", null, t("multiRoute.intersectingStops", {
        count: intersectStops.length
    })), (0, _preact.h)("ul", {
        class: "simple-stops-list"
    }, intersectStops.map((s)=>{
        const stop = stopsData[s];
        return (0, _preact.h)("li", {
            key: stop.number
        }, (0, _preact.h)("a", {
            href: `#/stops/${stop.number}`,
            onClick: (e)=>{
                e.preventDefault();
                zoomToStop(s);
            // onStopClickAgain={_showStopPopover}
            }
        }, (0, _preact.h)("b", {
            class: "stop-tag"
        }, stop.number), " ", (0, _preact.h)("span", {
            class: "stop-name"
        }, stop.name), " ", routeServices.length > 2 && (0, _preact.h)("span", {
            class: "services-meta-list"
        }, stopsData[stop.number].services.filter((s)=>routeServices.includes(s)).sort((0, _bus.sortServices)).join(" "))));
    }))))), showPassingRoutesFloatPill && (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("div", {
        class: "service-flex"
    }, (0, _preact.h)("span", {
        class: "stop-tag"
    }, route.value), (0, _preact.h)("div", null, (0, _preact.h)("h1", null, stopsData[route.value].name))), (0, _preact.h)("div", {
        class: "services-list",
        onClick: unhighlightRoute
    }, (0, _preact.h)("h2", null, t("passingRoutes.passingRoutes", {
        count: stopsData[route.value].services.length
    }), " ", "\xb7", " ", (0, _preact.h)("a", {
        href: `#/services/${stopsData[route.value].services.sort((0, _bus.sortServices)).join("~")}`
    }, t("glossary.multiRouteMode"), " ⊕")), stopsData[route.value].services.sort((0, _bus.sortServices)).map((service)=>(0, _preact.h)("a", {
            href: `#/services/${service}`,
            onClick: (e)=>clickRoute(e, service),
            onMouseEnter: (e)=>highlightRoute(e, service),
            onMouseLeave: unhighlightRoute,
            class: "service-tag",
            "data-service": service
        }, service)))))), (0, _preact.h)("div", {
        class: "popover-inner"
    }, (0, _preact.h)("div", {
        class: "popover-search"
    }, (0, _preact.h)("input", {
        type: "search",
        placeholder: t("search.placeholder"),
        autocomplete: "off",
        autocorrect: "off",
        autocapitalize: "off",
        spellcheck: "false",
        ref: searchField,
        onfocus: handleSearchFocus,
        oninput: handleSearch,
        onkeydown: handleKeys,
        disabled: !searching && !services.length
    }), (0, _preact.h)("button", {
        type: "button",
        onclick: handleSearchClose
    }, t("common.cancel"))), (0, _preact.h)("ul", {
        class: `popover-list ${services.length || searching ? "" : "loading"} ${searching ? "searching" : ""}`,
        ref: servicesList,
        onScroll: handleServicesScroll
    }, (0, _preact.h)("li", {
        class: "ads-li",
        hidden: !services.length || !showAd
    }, showAd && (0, _preact.h)((0, _adDefault.default), {
        key: "ad"
    })), services.length ? (expandedSearchOnce ? services : services.slice(0, 25)).map((s)=>{
        const isServicePage = route.page === "service";
        const checked = route.value && route.value.split("~").includes(s.number);
        return (0, _preact.h)("li", {
            key: s.number
        }, (0, _preact.h)("a", {
            href: `#/services/${s.number}`,
            class: checked ? "current" : "",
            onMouseEnter: ()=>previewRoute(s.number),
            onMouseLeave: unpreviewRoute
        }, (0, _preact.h)("b", {
            class: "service-tag"
        }, s.number), " ", s.name), (0, _preact.h)("label", {
            hidden: !isServicePage
        }, (0, _preact.h)("input", {
            type: "checkbox",
            checked: checked,
            onChange: (e)=>{
                const { checked  } = e.target;
                let newServices = [];
                if (checked) newServices = route.value.split("~").concat(s.number);
                else newServices = route.value.split("~").filter((service)=>service !== s.number);
                newServices.sort((0, _bus.sortServices));
                setTimeout(()=>{
                    if (newServices.length) location.hash = `/services/${newServices.join("~")}`;
                    else location.hash = "/";
                }, 250);
            }
        })));
    }) : !searching && [
        1,
        2,
        3,
        4,
        5,
        6,
        7,
        8
    ].map((s, i)=>(0, _preact.h)("li", {
            key: s
        }, (0, _preact.h)("a", {
            href: "#"
        }, (0, _preact.h)("b", {
            class: "service-tag"
        }, "\xa0\xa0\xa0"), (0, _preact.h)("span", {
            class: "placeholder"
        }, "█████", i % 3 == 0 ? "███" : "", " ███", i % 2 == 0 ? "████" : "")))), searching && !!stops.length && stops.map((s)=>(0, _preact.h)("li", {
            key: s.number
        }, (0, _preact.h)("a", {
            href: `#/stops/${s.number}`
        }, (0, _preact.h)("b", {
            class: "stop-tag"
        }, s.number), " ", s.name))), searching && !stops.length && !services.length && (0, _preact.h)("li", {
        class: "nada"
    }, "No results.")), (0, _preact.h)("div", {
        class: "sidebar-ads",
        hidden: !showAd
    }, showAd && (0, _preact.h)((0, _adDefault.default), {
        key: "ad2"
    })))), (0, _preact.h)("div", {
        id: "stop-popover",
        ref: stopPopover,
        class: `popover ${showStopPopover ? "expand" : ""}`
    }, stopPopoverData && (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("a", {
        href: "#/",
        onClick: hideStopPopover,
        class: "popover-close"
    }, "\xd7"), (0, _preact.h)("header", null, (0, _preact.h)("h1", {
        onClick: ()=>zoomToStop(stopPopoverData.number)
    }, (0, _preact.h)("b", {
        class: "stop-tag"
    }, stopPopoverData.number), " ", stopPopoverData.name)), (0, _preact.h)((0, _scrollableContainerDefault.default), {
        class: "popover-scroll"
    }, (0, _preact.h)("h2", null, t("glossary.nServices", {
        count: stopPopoverData.services.length
    }), " ", "∙", " ", (0, _preact.h)("a", {
        href: `/bus-first-last/#${stopPopoverData.number}`,
        target: "_blank"
    }, t("stop.firstLastBus"), " ", (0, _preact.h)("img", {
        src: (0, _openNewWindowSvgDefault.default),
        width: "12",
        height: "12",
        alt: "",
        class: "new-window"
    }))), (0, _preact.h)((0, _busServicesArrivalDefault.default), {
        active: showStopPopover,
        map: map,
        showBusesOnMap: route.page !== "service",
        id: stopPopoverData.number,
        services: stopPopoverData.services
    })), (0, _preact.h)("div", {
        class: "popover-footer"
    }, (0, _preact.h)("div", {
        class: "popover-buttons alt-hide"
    }, (0, _preact.h)("a", {
        href: `/bus-arrival/#${stopPopoverData.number}`,
        target: "_blank",
        onClick: openBusArrival,
        class: "popover-button primary"
    }, t("glossary.busArrivals"), " ", (0, _preact.h)("img", {
        src: (0, _openNewWindowBlueSvgDefault.default),
        width: "16",
        height: "16",
        alt: ""
    })), stopPopoverData.services.length > 1 && (0, _preact.h)("a", {
        href: `#/stops/${stopPopoverData.number}/routes`,
        class: "popover-button"
    }, t("glossary.passingRoutes"), " ", (0, _preact.h)("img", {
        src: (0, _passingRoutesBlueSvgDefault.default),
        width: "16",
        height: "16",
        alt: ""
    }))), (0, _preact.h)("div", {
        class: "popover-buttons alt-show-flex"
    }, (0, _preact.h)("button", {
        onClick: ()=>setStartStop(stopPopoverData.number),
        class: "popover-button"
    }, "Set as Start"), (0, _preact.h)("button", {
        onClick: ()=>setEndStop(stopPopoverData.number),
        class: "popover-button"
    }, "Set as End"))))), (0, _preact.h)("div", {
        ref: servicePopover,
        id: "service-popover",
        class: `popover ${showServicePopover ? "expand" : ""}`,
        key: ``
    }, (0, _preact.h)("a", {
        href: "#/",
        onClick: navBackToStop,
        class: "popover-close"
    }, "\xd7"), servicesData && routeServices.length && (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("header", null, (0, _preact.h)("h1", null, (0, _preact.h)("b", {
        class: "service-tag"
    }, routeServices[0]), servicesData[routeServices[0]].name)), (0, _preact.h)((0, _scrollableContainerDefault.default), {
        class: "popover-scroll",
        scrollToTopKey: `sttk-${routeServices[0]}`
    }, (0, _preact.h)("h2", null, t("glossary.nRoutes", {
        count: servicesData[routeServices[0]].routes.length
    }), " ", "∙", " ", servicesData[routeServices[0]].routes.map((route)=>t("glossary.nStops", {
            count: route.length
        })).join(" ∙ "), "\xa0\xa0", (0, _preact.h)("button", {
        type: "button",
        class: "plus",
        onClick: ()=>{
            setExpandSearch(true);
            setExpandedSearchOnce(true);
        },
        title: t("multiRoute.addRoute")
    })), (0, _preact.h)((0, _stopsListJsxDefault.default), {
        routes: servicesData[routeServices[0]].routes,
        stopsData: stopsData,
        onStopClick: zoomToStop,
        onStopClickAgain: _showStopPopover
    }), (0, _preact.h)("div", {
        class: "callout info"
    }, (0, _preact.h)("span", {
        class: "legend-opposite"
    }), " ", t("service.oppositeLegend"))))), (0, _preact.h)("div", {
        id: "between-popover",
        ref: betweenPopover,
        class: `popover ${showBetweenPopover ? "expand" : ""}`
    }, showBetweenPopover && [
        (0, _preact.h)("a", {
            href: "#/",
            onClick: resetStartEndStops,
            class: "popover-close"
        }, "\xd7"),
        (0, _preact.h)("header", null, (0, _preact.h)("h1", null, (0, _preact.h)("small", null, "Routes between"), (0, _preact.h)("br", null), (0, _preact.h)("b", {
            class: "stop-tag"
        }, showBetweenPopover.startStop.number), " and", " ", (0, _preact.h)("b", {
            class: "stop-tag"
        }, showBetweenPopover.endStop.number))),
        (0, _preact.h)("div", {
            class: "popover-scroll"
        }, (0, _preact.h)("div", {
            class: "callout warning"
        }, "This is a beta feature. Directions and routes may not be correct."), (0, _preact.h)("h2", null, "Direct routes"), (0, _preact.h)((0, _betweenRoutesDefault.default), {
            results: showBetweenPopover.results[0],
            onClickRoute: (e, result)=>renderBetweenRoute({
                    e,
                    startStop: showBetweenPopover.startStop,
                    endStop: showBetweenPopover.endStop,
                    result
                })
        }), (0, _preact.h)("h2", null, "Alternative routes"), (0, _preact.h)("h3", null, "Nearby arrival stop: ", showBetweenPopover.nearestEndStop.number, " (", showBetweenPopover.endWalkMins, "-min walk)"), (0, _preact.h)((0, _betweenRoutesDefault.default), {
            results: showBetweenPopover.results[1],
            nearbyEnd: true,
            onClickRoute: (e, result)=>renderBetweenRoute({
                    e,
                    startStop: showBetweenPopover.startStop,
                    endStop: showBetweenPopover.endStop,
                    result
                })
        }), (0, _preact.h)("h3", null, "Nearby departure stop:", " ", showBetweenPopover.nearestStartStop.number, " (", showBetweenPopover.startWalkMins, "-min walk)"), (0, _preact.h)((0, _betweenRoutesDefault.default), {
            results: showBetweenPopover.results[2],
            nearbyStart: true,
            onClickRoute: (e, result)=>renderBetweenRoute({
                    e,
                    startStop: showBetweenPopover.startStop,
                    endStop: showBetweenPopover.endStop,
                    result
                })
        }), (0, _preact.h)("h3", null, "Nearby departure & arrival stops:", " ", showBetweenPopover.nearestStartStop.number, " -", " ", showBetweenPopover.nearestEndStop.number), (0, _preact.h)((0, _betweenRoutesDefault.default), {
            results: showBetweenPopover.results[3],
            nearbyStart: true,
            nearbyEnd: true,
            onClickRoute: (e, result)=>renderBetweenRoute({
                    e,
                    startStop: showBetweenPopover.startStop,
                    endStop: showBetweenPopover.endStop,
                    result
                })
        }))
    ]), (0, _preact.h)("div", {
        id: "arrivals-popover",
        class: `popover ${showArrivalsPopover ? "expand" : ""}`
    }, showArrivalsPopover && [
        (0, _preact.h)("a", {
            href: "#/",
            onClick: closeBusArrival,
            class: "popover-close"
        }, "\xd7"),
        (0, _preact.h)("a", {
            href: `/bus-arrival/#${showArrivalsPopover.number}`,
            target: "_blank",
            onClick: (e)=>{
                openBusArrival(e, true);
                closeBusArrival(e);
            },
            class: "popover-popout popover-close"
        }, "Pop out", " ", (0, _preact.h)("img", {
            src: (0, _openNewWindowSvgDefault.default),
            width: "16",
            height: "16",
            alt: ""
        })),
        (0, _preact.h)("div", {
            class: "popover-scroll"
        }, (0, _preact.h)("iframe", {
            src: showArrivalsPopover.webviewURL
        }))
    ]));
};
(0, _preact.render)((0, _preact.h)(App, null), document.getElementById("app"));
if ("serviceWorker" in navigator) window.addEventListener("load", ()=>{
    navigator.serviceWorker.register(require("232f5b65eb051e9a"));
});
if (matchMedia("(display-mode: standalone)").matches || "standalone" in navigator) gtag("event", "pwa_load", {
    event_category: "PWA",
    event_label: "standalone",
    value: true,
    non_interaction: true
});
if (window.navigator.standalone) {
    document.body.classList.add("standalone");
    // Refresh map size when dismissing software keyboard
    // https://stackoverflow.com/a/19464029/20838
    document.addEventListener("focusout", ()=>{
        if (_map) _map.resize();
    });
    // Enable CSS active states
    document.addEventListener("touchstart", ()=>{}, false);
}
const isSafari = navigator.vendor && navigator.vendor.indexOf("Apple") !== -1;
if (isSafari && !window.navigator.standalone) setTimeout(function() {
    const ratio = window.devicePixelRatio;
    const canvas = document.createElement("canvas");
    const w = canvas.width = window.screen.width * ratio;
    const h = canvas.height = window.screen.height * ratio;
    const ctx = canvas.getContext("2d");
    ctx.fillStyle = "#F9F5ED";
    ctx.fillRect(0, 0, w, h);
    const icon = new Image();
    icon.onload = ()=>{
        const aspectRatio = icon.width / icon.height;
        icon.width = w / 2;
        icon.height = w / 2 / aspectRatio;
        ctx.drawImage(icon, (w - icon.width) / 2, (h - icon.height) / 2, icon.width, icon.height);
        document.head.insertAdjacentHTML("beforeend", `<link rel="apple-touch-startup-image" href="${canvas.toDataURL()}">`);
    };
    icon.src = (0, _iconSvgDefault.default);
}, 5000);

},{"./i18n":"29PvA","./error-tracking":"fiYlI","preact":"26zcy","preact/hooks":"eZN76","mapbox-gl":"562rs","@mapbox/polyline":"9Poxg","fuse.js":"4xnao","just-intersect":"kkPAm","cheap-ruler":"eQVRA","@mapbox/mapbox-gl-language":"9JxOa","react-i18next":"faThV","./config":"5MP3O","./utils/specialID":"8A3sw","./utils/bus":"cu424","./utils/fetchCache":"6IPHM","./utils/getRoute":"8fT5D","./utils/getDistance":"gX5A8","./utils/getWalkingMinutes":"32Vpq","./utils/usePrevious":"h4j6R","./ad":"3vhiK","./components/About":"44FUd","./components/BusServicesArrival":"2s8Um","./components/GeolocateControl":"htf46","./components/BetweenRoutes":"4xFa2","./components/ScrollableContainer":"b3g97","./components/StopsList.jsx":"g1DsO","./images/stop.png":"fxBVM","./images/stop-end.png":"9AfrY","./images/open-new-window.svg":"fLAIi","./images/open-new-window-blue.svg":"hxj0B","./images/passing-routes-blue.svg":"P8gmu","../icons/icon.svg":"1E4jG","./images/bus-tiny.png":"ghE5Y","232f5b65eb051e9a":"4Evke","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"562rs":[function(require,module,exports) {
/* Mapbox GL JS is Copyright © 2020 Mapbox and subject to the Mapbox Terms of Service ((https://www.mapbox.com/legal/tos/). */ (function(global, factory) {
    module.exports = factory();
})(this, function() {
    "use strict";
    /* eslint-disable */ var shared, worker, mapboxgl;
    // define gets called three times: one for each chunk. we rely on the order
    // they're imported to know which is which
    function define(_, chunk) {
        if (!shared) shared = chunk;
        else if (!worker) worker = chunk;
        else {
            var workerBundleString = "self.onerror = function() { console.error('An error occurred while parsing the WebWorker bundle. This is most likely due to improper transpilation by Babel; please see https://docs.mapbox.com/mapbox-gl-js/guides/install/#transpiling'); }; var sharedChunk = {}; (" + shared + ")(sharedChunk); (" + worker + ")(sharedChunk); self.onerror = null;";
            var sharedChunk = {};
            shared(sharedChunk);
            mapboxgl = chunk(sharedChunk);
            if (typeof window !== "undefined" && window && window.URL && window.URL.createObjectURL) mapboxgl.workerUrl = window.URL.createObjectURL(new Blob([
                workerBundleString
            ], {
                type: "text/javascript"
            }));
        }
    }
    define([
        "exports"
    ], function(t1) {
        "use strict";
        var e1 = "undefined" != typeof self ? self : {}, r = "2.11.0";
        let n;
        const i = {
            API_URL: "https://api.mapbox.com",
            get API_URL_REGEX () {
                if (null == n) {
                    const t2 = /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/|\?|$)/i;
                    try {
                        n = t2;
                    } catch (e2) {
                        n = t2;
                    }
                }
                return n;
            },
            get API_TILEJSON_REGEX () {
                return /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/v[0-9]*\/.*\.json.*$)/i;
            },
            get API_SPRITE_REGEX () {
                return /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/styles\/v[0-9]*\/)(.*\/sprite.*\..*$)/i;
            },
            get API_FONTS_REGEX () {
                return /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/fonts\/v[0-9]*\/)(.*\.pbf.*$)/i;
            },
            get API_STYLE_REGEX () {
                return /^((https?:)?\/\/)?([^\/]+\.)?mapbox\.c(n|om)(\/styles\/v[0-9]*\/)(.*$)/i;
            },
            get EVENTS_URL () {
                return this.API_URL ? 0 === this.API_URL.indexOf("https://api.mapbox.cn") ? "https://events.mapbox.cn/events/v2" : 0 === this.API_URL.indexOf("https://api.mapbox.com") ? "https://events.mapbox.com/events/v2" : null : null;
            },
            SESSION_PATH: "/map-sessions/v1",
            FEEDBACK_URL: "https://apps.mapbox.com/feedback",
            TILE_URL_VERSION: "v4",
            RASTER_URL_PREFIX: "raster/v1",
            REQUIRE_ACCESS_TOKEN: !0,
            ACCESS_TOKEN: null,
            MAX_PARALLEL_IMAGE_REQUESTS: 16
        }, s = {
            supported: !1,
            testSupport: function(t1) {
                !l && o && (u ? c(t1) : a = t1);
            }
        };
        let a, o, l = !1, u = !1;
        function c(t1) {
            const e1 = t1.createTexture();
            t1.bindTexture(t1.TEXTURE_2D, e1);
            try {
                if (t1.texImage2D(t1.TEXTURE_2D, 0, t1.RGBA, t1.RGBA, t1.UNSIGNED_BYTE, o), t1.isContextLost()) return;
                s.supported = !0;
            } catch (t2) {}
            t1.deleteTexture(e1), l = !0;
        }
        e1.document && (o = e1.document.createElement("img"), o.onload = function() {
            a && c(a), a = null, u = !0;
        }, o.onerror = function() {
            l = !0, a = null;
        }, o.src = "data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA=");
        const h = "01";
        var p = f;
        function f(t1, e1, r, n) {
            this.cx = 3 * t1, this.bx = 3 * (r - t1) - this.cx, this.ax = 1 - this.cx - this.bx, this.cy = 3 * e1, this.by = 3 * (n - e1) - this.cy, this.ay = 1 - this.cy - this.by, this.p1x = t1, this.p1y = e1, this.p2x = r, this.p2y = n;
        }
        f.prototype = {
            sampleCurveX: function(t1) {
                return ((this.ax * t1 + this.bx) * t1 + this.cx) * t1;
            },
            sampleCurveY: function(t1) {
                return ((this.ay * t1 + this.by) * t1 + this.cy) * t1;
            },
            sampleCurveDerivativeX: function(t1) {
                return (3 * this.ax * t1 + 2 * this.bx) * t1 + this.cx;
            },
            solveCurveX: function(t1, e1) {
                if (void 0 === e1 && (e1 = 1e-6), t1 < 0) return 0;
                if (t1 > 1) return 1;
                for(var r = t1, n = 0; n < 8; n++){
                    var i = this.sampleCurveX(r) - t1;
                    if (Math.abs(i) < e1) return r;
                    var s = this.sampleCurveDerivativeX(r);
                    if (Math.abs(s) < 1e-6) break;
                    r -= i / s;
                }
                var a = 0, o = 1;
                for(r = t1, n = 0; n < 20 && (i = this.sampleCurveX(r), !(Math.abs(i - t1) < e1)); n++)t1 > i ? a = r : o = r, r = .5 * (o - a) + a;
                return r;
            },
            solve: function(t1, e1) {
                return this.sampleCurveY(this.solveCurveX(t1, e1));
            }
        };
        var d = y;
        function y(t1, e1) {
            this.x = t1, this.y = e1;
        }
        y.prototype = {
            clone: function() {
                return new y(this.x, this.y);
            },
            add: function(t1) {
                return this.clone()._add(t1);
            },
            sub: function(t1) {
                return this.clone()._sub(t1);
            },
            multByPoint: function(t1) {
                return this.clone()._multByPoint(t1);
            },
            divByPoint: function(t1) {
                return this.clone()._divByPoint(t1);
            },
            mult: function(t1) {
                return this.clone()._mult(t1);
            },
            div: function(t1) {
                return this.clone()._div(t1);
            },
            rotate: function(t1) {
                return this.clone()._rotate(t1);
            },
            rotateAround: function(t1, e1) {
                return this.clone()._rotateAround(t1, e1);
            },
            matMult: function(t1) {
                return this.clone()._matMult(t1);
            },
            unit: function() {
                return this.clone()._unit();
            },
            perp: function() {
                return this.clone()._perp();
            },
            round: function() {
                return this.clone()._round();
            },
            mag: function() {
                return Math.sqrt(this.x * this.x + this.y * this.y);
            },
            equals: function(t1) {
                return this.x === t1.x && this.y === t1.y;
            },
            dist: function(t1) {
                return Math.sqrt(this.distSqr(t1));
            },
            distSqr: function(t1) {
                var e1 = t1.x - this.x, r = t1.y - this.y;
                return e1 * e1 + r * r;
            },
            angle: function() {
                return Math.atan2(this.y, this.x);
            },
            angleTo: function(t1) {
                return Math.atan2(this.y - t1.y, this.x - t1.x);
            },
            angleWith: function(t1) {
                return this.angleWithSep(t1.x, t1.y);
            },
            angleWithSep: function(t1, e1) {
                return Math.atan2(this.x * e1 - this.y * t1, this.x * t1 + this.y * e1);
            },
            _matMult: function(t1) {
                var e1 = t1[2] * this.x + t1[3] * this.y;
                return this.x = t1[0] * this.x + t1[1] * this.y, this.y = e1, this;
            },
            _add: function(t1) {
                return this.x += t1.x, this.y += t1.y, this;
            },
            _sub: function(t1) {
                return this.x -= t1.x, this.y -= t1.y, this;
            },
            _mult: function(t1) {
                return this.x *= t1, this.y *= t1, this;
            },
            _div: function(t1) {
                return this.x /= t1, this.y /= t1, this;
            },
            _multByPoint: function(t1) {
                return this.x *= t1.x, this.y *= t1.y, this;
            },
            _divByPoint: function(t1) {
                return this.x /= t1.x, this.y /= t1.y, this;
            },
            _unit: function() {
                return this._div(this.mag()), this;
            },
            _perp: function() {
                var t1 = this.y;
                return this.y = this.x, this.x = -t1, this;
            },
            _rotate: function(t1) {
                var e1 = Math.cos(t1), r = Math.sin(t1), n = r * this.x + e1 * this.y;
                return this.x = e1 * this.x - r * this.y, this.y = n, this;
            },
            _rotateAround: function(t1, e1) {
                var r = Math.cos(t1), n = Math.sin(t1), i = e1.y + n * (this.x - e1.x) + r * (this.y - e1.y);
                return this.x = e1.x + r * (this.x - e1.x) - n * (this.y - e1.y), this.y = i, this;
            },
            _round: function() {
                return this.x = Math.round(this.x), this.y = Math.round(this.y), this;
            }
        }, y.convert = function(t1) {
            return t1 instanceof y ? t1 : Array.isArray(t1) ? new y(t1[0], t1[1]) : t1;
        };
        const m = Math.PI / 180, g = 180 / Math.PI;
        function x(t1) {
            return t1 * m;
        }
        function v(t1) {
            return t1 * g;
        }
        const b = [
            [
                0,
                0
            ],
            [
                1,
                0
            ],
            [
                1,
                1
            ],
            [
                0,
                1
            ]
        ];
        function _(t1) {
            if (t1 <= 0) return 0;
            if (t1 >= 1) return 1;
            const e1 = t1 * t1, r = e1 * t1;
            return 4 * (t1 < .5 ? r : 3 * (t1 - e1) + r - .75);
        }
        function w(t1, e1, r, n) {
            const i = new p(t1, e1, r, n);
            return function(t1) {
                return i.solve(t1);
            };
        }
        const A = w(.25, .1, .25, 1);
        function S(t1, e1, r) {
            return Math.min(r, Math.max(e1, t1));
        }
        function k(t1, e1, r) {
            return (r = S((r - t1) / (e1 - t1), 0, 1)) * r * (3 - 2 * r);
        }
        function I(t1, e1, r) {
            const n = r - e1, i = ((t1 - e1) % n + n) % n + e1;
            return i === e1 ? r : i;
        }
        function M(t1, e1, r) {
            if (!t1.length) return r(null, []);
            let n = t1.length;
            const i = new Array(t1.length);
            let s = null;
            t1.forEach((t1, a)=>{
                e1(t1, (t1, e1)=>{
                    t1 && (s = t1), i[a] = e1, 0 == --n && r(s, i);
                });
            });
        }
        function z(t1) {
            const e1 = [];
            for(const r in t1)e1.push(t1[r]);
            return e1;
        }
        function T(t1, ...e1) {
            for (const r of e1)for(const e2 in r)t1[e2] = r[e2];
            return t1;
        }
        let B = 1;
        function E() {
            return B++;
        }
        function P() {
            return function t1(e1) {
                return e1 ? (e1 ^ Math.random() * (16 >> e1 / 4)).toString(16) : ([
                    1e7
                ] + -[
                    1e3
                ] + -4000 + -8000 + -100000000000).replace(/[018]/g, t1);
            }();
        }
        function C(t1) {
            return t1 <= 1 ? 1 : Math.pow(2, Math.ceil(Math.log(t1) / Math.LN2));
        }
        function D(t1) {
            return !!t1 && /^[0-9a-f]{8}-[0-9a-f]{4}-[4][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$/i.test(t1);
        }
        function V(t1, e1) {
            t1.forEach((t1)=>{
                e1[t1] && (e1[t1] = e1[t1].bind(e1));
            });
        }
        function F(t1, e1) {
            return -1 !== t1.indexOf(e1, t1.length - e1.length);
        }
        function L(t1, e1, r) {
            const n = {};
            for(const i in t1)n[i] = e1.call(r || this, t1[i], i, t1);
            return n;
        }
        function R(t1, e1, r) {
            const n = {};
            for(const i in t1)e1.call(r || this, t1[i], i, t1) && (n[i] = t1[i]);
            return n;
        }
        function U(t1) {
            return Array.isArray(t1) ? t1.map(U) : "object" == typeof t1 && t1 ? L(t1, U) : t1;
        }
        const j = {};
        function $(t1) {
            j[t1] || ("undefined" != typeof console && console.warn(t1), j[t1] = !0);
        }
        function O(t1, e1, r) {
            return (r.y - t1.y) * (e1.x - t1.x) > (e1.y - t1.y) * (r.x - t1.x);
        }
        function q(t1) {
            let e1 = 0;
            for(let r, n, i = 0, s = t1.length, a = s - 1; i < s; a = i++)r = t1[i], n = t1[a], e1 += (n.x - r.x) * (r.y + n.y);
            return e1;
        }
        function N() {
            return "undefined" != typeof WorkerGlobalScope && "undefined" != typeof self && self instanceof WorkerGlobalScope;
        }
        function G(t1) {
            const e1 = {};
            if (t1.replace(/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g, (t1, r, n, i)=>{
                const s = n || i;
                return e1[r] = !s || s.toLowerCase(), "";
            }), e1["max-age"]) {
                const t2 = parseInt(e1["max-age"], 10);
                isNaN(t2) ? delete e1["max-age"] : e1["max-age"] = t2;
            }
            return e1;
        }
        let Z = null;
        function X(t1) {
            if (null == Z) {
                const e1 = t1.navigator ? t1.navigator.userAgent : null;
                Z = !!t1.safari || !(!e1 || !(/\b(iPad|iPhone|iPod)\b/.test(e1) || e1.match("Safari") && !e1.match("Chrome")));
            }
            return Z;
        }
        function K(t1) {
            try {
                const r = e1[t1];
                return r.setItem("_mapbox_test_", 1), r.removeItem("_mapbox_test_"), !0;
            } catch (t2) {
                return !1;
            }
        }
        function H(t1, e1) {
            return [
                t1[4 * e1],
                t1[4 * e1 + 1],
                t1[4 * e1 + 2],
                t1[4 * e1 + 3]
            ];
        }
        const Y = "mapbox-tiles";
        let W, J, Q = 500, tt = 50;
        function et() {
            try {
                return e1.caches;
            } catch (t1) {}
        }
        function rt() {
            et() && !W && (W = e1.caches.open(Y));
        }
        function nt(t1) {
            const e1 = t1.indexOf("?");
            if (e1 < 0) return t1;
            const r = function(t1) {
                const e1 = t1.indexOf("?");
                return e1 > 0 ? t1.slice(e1 + 1).split("&") : [];
            }(t1), n = r.filter((t1)=>{
                const e1 = t1.split("=");
                return "language" === e1[0] || "worldview" === e1[0];
            });
            return n.length ? `${t1.slice(0, e1)}?${n.join("&")}` : t1.slice(0, e1);
        }
        let it = 1 / 0;
        const st = {
            Unknown: "Unknown",
            Style: "Style",
            Source: "Source",
            Tile: "Tile",
            Glyphs: "Glyphs",
            SpriteImage: "SpriteImage",
            SpriteJSON: "SpriteJSON",
            Image: "Image"
        };
        "function" == typeof Object.freeze && Object.freeze(st);
        class at extends Error {
            constructor(t1, e1, r){
                401 === e1 && gt(r) && (t1 += ": you may have provided an invalid Mapbox access token. See https://www.mapbox.com/api-documentation/#access-tokens-and-token-scopes"), super(t1), this.status = e1, this.url = r;
            }
            toString() {
                return `${this.name}: ${this.message} (${this.status}): ${this.url}`;
            }
        }
        const ot = N() ? ()=>self.worker && self.worker.referrer : ()=>("blob:" === e1.location.protocol ? e1.parent : e1).location.href;
        const lt = function(t1, r) {
            if (!(/^file:/.test(n = t1.url) || /^file:/.test(ot()) && !/^\w+:/.test(n))) {
                if (e1.fetch && e1.Request && e1.AbortController && e1.Request.prototype.hasOwnProperty("signal")) return function(t1, r) {
                    const n = new e1.AbortController, i = new e1.Request(t1.url, {
                        method: t1.method || "GET",
                        body: t1.body,
                        credentials: t1.credentials,
                        headers: t1.headers,
                        referrer: ot(),
                        signal: n.signal
                    });
                    let s = !1, a = !1;
                    const o = (l = i.url).indexOf("sku=") > 0 && gt(l);
                    var l;
                    "json" === t1.type && i.headers.set("Accept", "application/json");
                    const u = (n, s, l)=>{
                        if (a) return;
                        if (n && "SecurityError" !== n.message && $(n), s && l) return c(s);
                        const u = Date.now();
                        e1.fetch(i).then((e1)=>{
                            if (e1.ok) {
                                const t2 = o ? e1.clone() : null;
                                return c(e1, t2, u);
                            }
                            return r(new at(e1.statusText, e1.status, t1.url));
                        }).catch((t1)=>{
                            20 !== t1.code && r(new Error(t1.message));
                        });
                    }, c = (n, o, l)=>{
                        ("arrayBuffer" === t1.type ? n.arrayBuffer() : "json" === t1.type ? n.json() : n.text()).then((t1)=>{
                            a || (o && l && function(t1, r, n) {
                                if (rt(), !W) return;
                                const i = {
                                    status: r.status,
                                    statusText: r.statusText,
                                    headers: new e1.Headers
                                };
                                r.headers.forEach((t1, e1)=>i.headers.set(e1, t1));
                                const s = G(r.headers.get("Cache-Control") || "");
                                if (s["no-store"]) return;
                                s["max-age"] && i.headers.set("Expires", new Date(n + 1e3 * s["max-age"]).toUTCString());
                                const a = i.headers.get("Expires");
                                a && (new Date(a).getTime() - n < 42e4 || function(t1, e1) {
                                    if (void 0 === J) try {
                                        new Response(new ReadableStream), J = !0;
                                    } catch (t2) {
                                        J = !1;
                                    }
                                    J ? e1(t1.body) : t1.blob().then(e1);
                                }(r, (r)=>{
                                    const n = new e1.Response(r, i);
                                    rt(), W && W.then((e1)=>e1.put(nt(t1.url), n)).catch((t1)=>$(t1.message));
                                }));
                            }(i, o, l), s = !0, r(null, t1, n.headers.get("Cache-Control"), n.headers.get("Expires")));
                        }).catch((t1)=>{
                            a || r(new Error(t1.message));
                        });
                    };
                    return o ? function(t1, e1) {
                        if (rt(), !W) return e1(null);
                        const r = nt(t1.url);
                        W.then((t1)=>{
                            t1.match(r).then((n)=>{
                                const i = function(t1) {
                                    if (!t1) return !1;
                                    const e1 = new Date(t1.headers.get("Expires") || 0), r = G(t1.headers.get("Cache-Control") || "");
                                    return e1 > Date.now() && !r["no-cache"];
                                }(n);
                                t1.delete(r), i && t1.put(r, n.clone()), e1(null, n, i);
                            }).catch(e1);
                        }).catch(e1);
                    }(i, u) : u(null, null), {
                        cancel: ()=>{
                            a = !0, s || n.abort();
                        }
                    };
                }(t1, r);
                if (N() && self.worker && self.worker.actor) return self.worker.actor.send("getResource", t1, r, void 0, !0);
            }
            var n;
            return function(t1, r) {
                const n = new e1.XMLHttpRequest;
                n.open(t1.method || "GET", t1.url, !0), "arrayBuffer" === t1.type && (n.responseType = "arraybuffer");
                for(const e2 in t1.headers)n.setRequestHeader(e2, t1.headers[e2]);
                return "json" === t1.type && (n.responseType = "text", n.setRequestHeader("Accept", "application/json")), n.withCredentials = "include" === t1.credentials, n.onerror = ()=>{
                    r(new Error(n.statusText));
                }, n.onload = ()=>{
                    if ((n.status >= 200 && n.status < 300 || 0 === n.status) && null !== n.response) {
                        let e1 = n.response;
                        if ("json" === t1.type) try {
                            e1 = JSON.parse(n.response);
                        } catch (t2) {
                            return r(t2);
                        }
                        r(null, e1, n.getResponseHeader("Cache-Control"), n.getResponseHeader("Expires"));
                    } else r(new at(n.statusText, n.status, t1.url));
                }, n.send(t1.body), {
                    cancel: ()=>n.abort()
                };
            }(t1, r);
        }, ut = function(t1, e1) {
            return lt(T(t1, {
                type: "arrayBuffer"
            }), e1);
        };
        function ct(t1) {
            const r = e1.document.createElement("a");
            return r.href = t1, r.protocol === e1.document.location.protocol && r.host === e1.document.location.host;
        }
        const ht = "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAUAAarVyFEAAAAASUVORK5CYII=";
        let pt, ft;
        pt = [], ft = 0;
        const dt = function(t1, r) {
            if (s.supported && (t1.headers || (t1.headers = {}), t1.headers.accept = "image/webp,*/*"), ft >= i.MAX_PARALLEL_IMAGE_REQUESTS) {
                const e2 = {
                    requestParameters: t1,
                    callback: r,
                    cancelled: !1,
                    cancel () {
                        this.cancelled = !0;
                    }
                };
                return pt.push(e2), e2;
            }
            ft++;
            let n = !1;
            const a = ()=>{
                if (!n) for(n = !0, ft--; pt.length && ft < i.MAX_PARALLEL_IMAGE_REQUESTS;){
                    const t1 = pt.shift(), { requestParameters: e1 , callback: r , cancelled: n1  } = t1;
                    n1 || (t1.cancel = dt(e1, r).cancel);
                }
            }, o = ut(t1, (t1, n, i, s)=>{
                a(), t1 ? r(t1) : n && (e1.createImageBitmap ? function(t1, r) {
                    const n = new e1.Blob([
                        new Uint8Array(t1)
                    ], {
                        type: "image/png"
                    });
                    e1.createImageBitmap(n).then((t1)=>{
                        r(null, t1);
                    }).catch((t1)=>{
                        r(new Error(`Could not load image because of ${t1.message}. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported.`));
                    });
                }(n, (t1, e1)=>r(t1, e1, i, s)) : function(t1, r) {
                    const n = new e1.Image, i = e1.URL;
                    n.onload = ()=>{
                        r(null, n), i.revokeObjectURL(n.src), n.onload = null, e1.requestAnimationFrame(()=>{
                            n.src = ht;
                        });
                    }, n.onerror = ()=>r(new Error("Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."));
                    const s = new e1.Blob([
                        new Uint8Array(t1)
                    ], {
                        type: "image/png"
                    });
                    n.src = t1.byteLength ? i.createObjectURL(s) : ht;
                }(n, (t1, e1)=>r(t1, e1, i, s)));
            });
            return {
                cancel: ()=>{
                    o.cancel(), a();
                }
            };
        }, yt = "NO_ACCESS_TOKEN";
        function mt(t1) {
            return 0 === t1.indexOf("mapbox:");
        }
        function gt(t1) {
            return i.API_URL_REGEX.test(t1);
        }
        function xt(t1) {
            return i.API_STYLE_REGEX.test(t1) && !vt(t1);
        }
        function vt(t1) {
            return i.API_SPRITE_REGEX.test(t1);
        }
        const bt = /^(\w+):\/\/([^/?]*)(\/[^?]+)?\??(.+)?/;
        function _t(t1) {
            const e1 = t1.match(bt);
            if (!e1) throw new Error("Unable to parse URL object");
            return {
                protocol: e1[1],
                authority: e1[2],
                path: e1[3] || "/",
                params: e1[4] ? e1[4].split("&") : []
            };
        }
        function wt(t1) {
            const e1 = t1.params.length ? `?${t1.params.join("&")}` : "";
            return `${t1.protocol}://${t1.authority}${t1.path}${e1}`;
        }
        function At(t1) {
            if (!t1) return null;
            const r = t1.split(".");
            if (!r || 3 !== r.length) return null;
            try {
                return JSON.parse(decodeURIComponent(e1.atob(r[1]).split("").map((t1)=>"%" + ("00" + t1.charCodeAt(0).toString(16)).slice(-2)).join("")));
            } catch (t2) {
                return null;
            }
        }
        class St {
            constructor(t1){
                this.type = t1, this.anonId = null, this.eventData = {}, this.queue = [], this.pendingRequest = null;
            }
            getStorageKey(t1) {
                const r = At(i.ACCESS_TOKEN);
                let n = "";
                return n = r && r.u ? e1.btoa(encodeURIComponent(r.u).replace(/%([0-9A-F]{2})/g, (t1, e1)=>String.fromCharCode(Number("0x" + e1)))) : i.ACCESS_TOKEN || "", t1 ? `mapbox.eventData.${t1}:${n}` : `mapbox.eventData:${n}`;
            }
            fetchEventData() {
                const t1 = K("localStorage"), r = this.getStorageKey(), n = this.getStorageKey("uuid");
                if (t1) try {
                    const t2 = e1.localStorage.getItem(r);
                    t2 && (this.eventData = JSON.parse(t2));
                    const i = e1.localStorage.getItem(n);
                    i && (this.anonId = i);
                } catch (t3) {
                    $("Unable to read from LocalStorage");
                }
            }
            saveEventData() {
                const t1 = K("localStorage"), r = this.getStorageKey(), n = this.getStorageKey("uuid");
                if (t1) try {
                    e1.localStorage.setItem(n, this.anonId), Object.keys(this.eventData).length >= 1 && e1.localStorage.setItem(r, JSON.stringify(this.eventData));
                } catch (t2) {
                    $("Unable to write to LocalStorage");
                }
            }
            processRequests(t1) {}
            postEvent(t1, e1, r, n) {
                if (!i.EVENTS_URL) return;
                const s = _t(i.EVENTS_URL);
                s.params.push(`access_token=${n || i.ACCESS_TOKEN || ""}`);
                const a = {
                    event: this.type,
                    created: new Date(t1).toISOString()
                }, o = e1 ? T(a, e1) : a, l = {
                    url: wt(s),
                    headers: {
                        "Content-Type": "text/plain"
                    },
                    body: JSON.stringify([
                        o
                    ])
                };
                this.pendingRequest = function(t1, e1) {
                    return lt(T(t1, {
                        method: "POST"
                    }), e1);
                }(l, (t1)=>{
                    this.pendingRequest = null, r(t1), this.saveEventData(), this.processRequests(n);
                });
            }
            queueRequest(t1, e1) {
                this.queue.push(t1), this.processRequests(e1);
            }
        }
        const kt = new class extends St {
            constructor(t1){
                super("appUserTurnstile"), this._customAccessToken = t1;
            }
            postTurnstileEvent(t1, e1) {
                i.EVENTS_URL && i.ACCESS_TOKEN && Array.isArray(t1) && t1.some((t1)=>mt(t1) || gt(t1)) && this.queueRequest(Date.now(), e1);
            }
            processRequests(t1) {
                if (this.pendingRequest || 0 === this.queue.length) return;
                this.anonId && this.eventData.lastSuccess && this.eventData.tokenU || this.fetchEventData();
                const e1 = At(i.ACCESS_TOKEN), n = e1 ? e1.u : i.ACCESS_TOKEN;
                let s = n !== this.eventData.tokenU;
                D(this.anonId) || (this.anonId = P(), s = !0);
                const a = this.queue.shift();
                if (this.eventData.lastSuccess) {
                    const t2 = new Date(this.eventData.lastSuccess), e2 = new Date(a), r1 = (a - this.eventData.lastSuccess) / 864e5;
                    s = s || r1 >= 1 || r1 < -1 || t2.getDate() !== e2.getDate();
                } else s = !0;
                s ? this.postEvent(a, {
                    sdkIdentifier: "mapbox-gl-js",
                    sdkVersion: r,
                    skuId: h,
                    "enabled.telemetry": !1,
                    userId: this.anonId
                }, (t1)=>{
                    t1 || (this.eventData.lastSuccess = a, this.eventData.tokenU = n);
                }, t1) : this.processRequests();
            }
        }, It = kt.postTurnstileEvent.bind(kt), Mt = new class extends St {
            constructor(){
                super("map.load"), this.success = {}, this.skuToken = "";
            }
            postMapLoadEvent(t1, e1, r, n) {
                this.skuToken = e1, this.errorCb = n, i.EVENTS_URL && (r || i.ACCESS_TOKEN ? this.queueRequest({
                    id: t1,
                    timestamp: Date.now()
                }, r) : this.errorCb(new Error(yt)));
            }
            processRequests(t1) {
                if (this.pendingRequest || 0 === this.queue.length) return;
                const { id: e1 , timestamp: n  } = this.queue.shift();
                e1 && this.success[e1] || (this.anonId || this.fetchEventData(), D(this.anonId) || (this.anonId = P()), this.postEvent(n, {
                    sdkIdentifier: "mapbox-gl-js",
                    sdkVersion: r,
                    skuId: h,
                    skuToken: this.skuToken,
                    userId: this.anonId
                }, (t1)=>{
                    t1 ? this.errorCb(t1) : e1 && (this.success[e1] = !0);
                }, t1));
            }
        }, zt = Mt.postMapLoadEvent.bind(Mt), Tt = new class extends St {
            constructor(){
                super("gljs.performance");
            }
            postPerformanceEvent(t1, e1) {
                i.EVENTS_URL && (t1 || i.ACCESS_TOKEN) && this.queueRequest({
                    timestamp: Date.now(),
                    performanceData: e1
                }, t1);
            }
            processRequests(t1) {
                if (this.pendingRequest || 0 === this.queue.length) return;
                const { timestamp: n , performanceData: i  } = this.queue.shift(), s = function(t1) {
                    const n = e1.performance.getEntriesByType("resource"), i = e1.performance.getEntriesByType("mark"), s = function(t1) {
                        const e1 = {};
                        if (t1) {
                            for(const r in t1)if ("other" !== r) for (const n of t1[r]){
                                const t2 = `${r}RequestCount`, i = `${r}ResolveRangeMin`, s = `${r}ResolveRangeMax`;
                                e1[i] = Math.min(e1[i] || 1 / 0, n.startTime), e1[s] = Math.max(e1[s] || -1 / 0, n.responseEnd), void 0 === e1[t2] && (e1[t2] = 0), ++e1[t2];
                            }
                        }
                        return e1;
                    }(function(t1, e1) {
                        const r = {};
                        if (t1) for (const n of t1){
                            const t2 = e1(n);
                            void 0 === r[t2] && (r[t2] = []), r[t2].push(n);
                        }
                        return r;
                    }(n, Ft)), a = e1.devicePixelRatio, o = e1.navigator.connection || e1.navigator.mozConnection || e1.navigator.webkitConnection, l = {
                        counters: [],
                        metadata: [],
                        attributes: []
                    }, u = (t1, e1, r)=>{
                        null != r && t1.push({
                            name: e1,
                            value: r.toString()
                        });
                    };
                    for(const t2 in s)u(l.counters, t2, s[t2]);
                    if (t1.interactionRange[0] !== 1 / 0 && t1.interactionRange[1] !== -1 / 0 && (u(l.counters, "interactionRangeMin", t1.interactionRange[0]), u(l.counters, "interactionRangeMax", t1.interactionRange[1])), i) for (const t3 of Object.keys(Dt)){
                        const e2 = Dt[t3], r1 = i.find((t1)=>t1.name === e2);
                        r1 && u(l.counters, e2, r1.startTime);
                    }
                    return u(l.attributes, "style", function(t1) {
                        if (t1) for (const e1 of t1){
                            const t2 = e1.name.split("?")[0];
                            if (xt(t2)) {
                                const e2 = t2.split("/").slice(-2);
                                if (2 === e2.length) return `mapbox://styles/${e2[0]}/${e2[1]}`;
                            }
                        }
                    }(n)), u(l.attributes, "terrainEnabled", t1.terrainEnabled ? "true" : "false"), u(l.attributes, "fogEnabled", t1.fogEnabled ? "true" : "false"), u(l.attributes, "projection", t1.projection.name), u(l.attributes, "zoom", t1.zoom), u(l.metadata, "devicePixelRatio", a), u(l.metadata, "connectionEffectiveType", o ? o.effectiveType : void 0), u(l.metadata, "navigatorUserAgent", e1.navigator.userAgent), u(l.metadata, "screenWidth", e1.screen.width), u(l.metadata, "screenHeight", e1.screen.height), u(l.metadata, "windowWidth", e1.innerWidth), u(l.metadata, "windowHeight", e1.innerHeight), u(l.metadata, "mapWidth", t1.width / a), u(l.metadata, "mapHeight", t1.height / a), u(l.metadata, "webglRenderer", t1.renderer), u(l.metadata, "webglVendor", t1.vendor), u(l.metadata, "sdkVersion", r), u(l.metadata, "sdkIdentifier", "mapbox-gl-js"), l;
                }(i);
                for (const t2 of s.metadata);
                for (const t3 of s.counters);
                for (const t4 of s.attributes);
                this.postEvent(n, s, ()=>{}, t1);
            }
        }, Bt = Tt.postPerformanceEvent.bind(Tt), Et = new class extends St {
            constructor(){
                super("map.auth"), this.success = {}, this.skuToken = "";
            }
            getSession(t1, e1, r, n) {
                if (!i.API_URL || !i.SESSION_PATH) return;
                const s = _t(i.API_URL + i.SESSION_PATH);
                s.params.push(`sku=${e1 || ""}`), s.params.push(`access_token=${n || i.ACCESS_TOKEN || ""}`);
                const a = {
                    url: wt(s),
                    headers: {
                        "Content-Type": "text/plain"
                    }
                };
                this.pendingRequest = function(t1, e1) {
                    return lt(T(t1, {
                        method: "GET"
                    }), e1);
                }(a, (t1)=>{
                    this.pendingRequest = null, r(t1), this.saveEventData(), this.processRequests(n);
                });
            }
            getSessionAPI(t1, e1, r, n) {
                this.skuToken = e1, this.errorCb = n, i.SESSION_PATH && i.API_URL && (r || i.ACCESS_TOKEN ? this.queueRequest({
                    id: t1,
                    timestamp: Date.now()
                }, r) : this.errorCb(new Error(yt)));
            }
            processRequests(t1) {
                if (this.pendingRequest || 0 === this.queue.length) return;
                const { id: e1 , timestamp: r  } = this.queue.shift();
                e1 && this.success[e1] || this.getSession(r, this.skuToken, (t1)=>{
                    t1 ? this.errorCb(t1) : e1 && (this.success[e1] = !0);
                }, t1);
            }
        }, Pt = Et.getSessionAPI.bind(Et), Ct = new Set, Dt = {
            create: "create",
            load: "load",
            fullLoad: "fullLoad"
        }, Vt = {
            mark (t1) {
                e1.performance.mark(t1);
            },
            measure (t1, r, n) {
                e1.performance.measure(t1, r, n);
            }
        };
        function Ft(t1) {
            const e1 = t1.name.split("?")[0];
            return e1.includes("mapbox-gl.js") ? "javascript" : e1.includes("mapbox-gl.css") ? "css" : function(t1) {
                return i.API_FONTS_REGEX.test(t1);
            }(e1) ? "fontRange" : vt(e1) ? "sprite" : xt(e1) ? "style" : function(t1) {
                return i.API_TILEJSON_REGEX.test(t1);
            }(e1) ? "tilejson" : "other";
        }
        const Lt = e1.performance;
        function Rt(t1) {
            const e1 = t1 ? t1.url.toString() : void 0;
            return Lt.getEntriesByName(e1);
        }
        let Ut, jt, $t, Ot;
        const qt = {
            now: ()=>void 0 !== $t ? $t : e1.performance.now(),
            setNow (t1) {
                $t = t1;
            },
            restoreNow () {
                $t = void 0;
            },
            frame (t1) {
                const r = e1.requestAnimationFrame(t1);
                return {
                    cancel: ()=>e1.cancelAnimationFrame(r)
                };
            },
            getImageData (t1, r = 0) {
                const { width: n , height: i  } = t1;
                Ot || (Ot = e1.document.createElement("canvas"));
                const s = Ot.getContext("2d");
                if (!s) throw new Error("failed to create canvas 2d context");
                return (n > Ot.width || i > Ot.height) && (Ot.width = n, Ot.height = i), s.clearRect(-r, -r, n + 2 * r, i + 2 * r), s.drawImage(t1, 0, 0, n, i), s.getImageData(-r, -r, n + 2 * r, i + 2 * r);
            },
            resolveURL: (t1)=>(Ut || (Ut = e1.document.createElement("a")), Ut.href = t1, Ut.href),
            get devicePixelRatio () {
                return e1.devicePixelRatio;
            },
            get prefersReducedMotion () {
                return !!e1.matchMedia && (null == jt && (jt = e1.matchMedia("(prefers-reduced-motion: reduce)")), jt.matches);
            }
        };
        function Nt(t1, e1, r) {
            r[t1] && -1 !== r[t1].indexOf(e1) || (r[t1] = r[t1] || [], r[t1].push(e1));
        }
        function Gt(t1, e1, r) {
            if (r && r[t1]) {
                const n = r[t1].indexOf(e1);
                -1 !== n && r[t1].splice(n, 1);
            }
        }
        class Zt {
            constructor(t1, e1 = {}){
                T(this, e1), this.type = t1;
            }
        }
        class Xt extends Zt {
            constructor(t1, e1 = {}){
                super("error", T({
                    error: t1
                }, e1));
            }
        }
        class Kt {
            on(t1, e1) {
                return this._listeners = this._listeners || {}, Nt(t1, e1, this._listeners), this;
            }
            off(t1, e1) {
                return Gt(t1, e1, this._listeners), Gt(t1, e1, this._oneTimeListeners), this;
            }
            once(t1, e1) {
                return e1 ? (this._oneTimeListeners = this._oneTimeListeners || {}, Nt(t1, e1, this._oneTimeListeners), this) : new Promise((e1)=>this.once(t1, e1));
            }
            fire(t1, e1) {
                "string" == typeof t1 && (t1 = new Zt(t1, e1 || {}));
                const r = t1.type;
                if (this.listens(r)) {
                    t1.target = this;
                    const e2 = this._listeners && this._listeners[r] ? this._listeners[r].slice() : [];
                    for (const r1 of e2)r1.call(this, t1);
                    const n = this._oneTimeListeners && this._oneTimeListeners[r] ? this._oneTimeListeners[r].slice() : [];
                    for (const e3 of n)Gt(r, e3, this._oneTimeListeners), e3.call(this, t1);
                    const i = this._eventedParent;
                    i && (T(t1, "function" == typeof this._eventedParentData ? this._eventedParentData() : this._eventedParentData), i.fire(t1));
                } else t1 instanceof Xt && console.error(t1.error);
                return this;
            }
            listens(t1) {
                return !!(this._listeners && this._listeners[t1] && this._listeners[t1].length > 0 || this._oneTimeListeners && this._oneTimeListeners[t1] && this._oneTimeListeners[t1].length > 0 || this._eventedParent && this._eventedParent.listens(t1));
            }
            setEventedParent(t1, e1) {
                return this._eventedParent = t1, this._eventedParentData = e1, this;
            }
        }
        var Ht = JSON.parse('{"$version":8,"$root":{"version":{"required":true,"type":"enum","values":[8]},"name":{"type":"string"},"metadata":{"type":"*"},"center":{"type":"array","value":"number"},"zoom":{"type":"number"},"bearing":{"type":"number","default":0,"period":360,"units":"degrees"},"pitch":{"type":"number","default":0,"units":"degrees"},"light":{"type":"light"},"terrain":{"type":"terrain"},"fog":{"type":"fog"},"sources":{"required":true,"type":"sources"},"sprite":{"type":"string"},"glyphs":{"type":"string"},"transition":{"type":"transition"},"projection":{"type":"projection"},"layers":{"required":true,"type":"array","value":"layer"}},"sources":{"*":{"type":"source"}},"source":["source_vector","source_raster","source_raster_dem","source_geojson","source_video","source_image"],"source_vector":{"type":{"required":true,"type":"enum","values":{"vector":{}}},"url":{"type":"string"},"tiles":{"type":"array","value":"string"},"bounds":{"type":"array","value":"number","length":4,"default":[-180,-85.051129,180,85.051129]},"scheme":{"type":"enum","values":{"xyz":{},"tms":{}},"default":"xyz"},"minzoom":{"type":"number","default":0},"maxzoom":{"type":"number","default":22},"attribution":{"type":"string"},"promoteId":{"type":"promoteId"},"volatile":{"type":"boolean","default":false},"*":{"type":"*"}},"source_raster":{"type":{"required":true,"type":"enum","values":{"raster":{}}},"url":{"type":"string"},"tiles":{"type":"array","value":"string"},"bounds":{"type":"array","value":"number","length":4,"default":[-180,-85.051129,180,85.051129]},"minzoom":{"type":"number","default":0},"maxzoom":{"type":"number","default":22},"tileSize":{"type":"number","default":512,"units":"pixels"},"scheme":{"type":"enum","values":{"xyz":{},"tms":{}},"default":"xyz"},"attribution":{"type":"string"},"volatile":{"type":"boolean","default":false},"*":{"type":"*"}},"source_raster_dem":{"type":{"required":true,"type":"enum","values":{"raster-dem":{}}},"url":{"type":"string"},"tiles":{"type":"array","value":"string"},"bounds":{"type":"array","value":"number","length":4,"default":[-180,-85.051129,180,85.051129]},"minzoom":{"type":"number","default":0},"maxzoom":{"type":"number","default":22},"tileSize":{"type":"number","default":512,"units":"pixels"},"attribution":{"type":"string"},"encoding":{"type":"enum","values":{"terrarium":{},"mapbox":{}},"default":"mapbox"},"volatile":{"type":"boolean","default":false},"*":{"type":"*"}},"source_geojson":{"type":{"required":true,"type":"enum","values":{"geojson":{}}},"data":{"type":"*"},"maxzoom":{"type":"number","default":18},"attribution":{"type":"string"},"buffer":{"type":"number","default":128,"maximum":512,"minimum":0},"filter":{"type":"*"},"tolerance":{"type":"number","default":0.375},"cluster":{"type":"boolean","default":false},"clusterRadius":{"type":"number","default":50,"minimum":0},"clusterMaxZoom":{"type":"number"},"clusterMinPoints":{"type":"number"},"clusterProperties":{"type":"*"},"lineMetrics":{"type":"boolean","default":false},"generateId":{"type":"boolean","default":false},"promoteId":{"type":"promoteId"}},"source_video":{"type":{"required":true,"type":"enum","values":{"video":{}}},"urls":{"required":true,"type":"array","value":"string"},"coordinates":{"required":true,"type":"array","length":4,"value":{"type":"array","length":2,"value":"number"}}},"source_image":{"type":{"required":true,"type":"enum","values":{"image":{}}},"url":{"required":true,"type":"string"},"coordinates":{"required":true,"type":"array","length":4,"value":{"type":"array","length":2,"value":"number"}}},"layer":{"id":{"type":"string","required":true},"type":{"type":"enum","values":{"fill":{},"line":{},"symbol":{},"circle":{},"heatmap":{},"fill-extrusion":{},"raster":{},"hillshade":{},"background":{},"sky":{}},"required":true},"metadata":{"type":"*"},"source":{"type":"string"},"source-layer":{"type":"string"},"minzoom":{"type":"number","minimum":0,"maximum":24},"maxzoom":{"type":"number","minimum":0,"maximum":24},"filter":{"type":"filter"},"layout":{"type":"layout"},"paint":{"type":"paint"}},"layout":["layout_fill","layout_line","layout_circle","layout_heatmap","layout_fill-extrusion","layout_symbol","layout_raster","layout_hillshade","layout_background","layout_sky"],"layout_background":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"layout_sky":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"layout_fill":{"fill-sort-key":{"type":"number","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"layout_circle":{"circle-sort-key":{"type":"number","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"layout_heatmap":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"layout_fill-extrusion":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"},"fill-extrusion-edge-radius":{"type":"number","private":true,"default":0,"minimum":0,"maximum":1,"property-type":"constant"}},"layout_line":{"line-cap":{"type":"enum","values":{"butt":{},"round":{},"square":{}},"default":"butt","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"line-join":{"type":"enum","values":{"bevel":{},"round":{},"miter":{}},"default":"miter","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"line-miter-limit":{"type":"number","default":2,"requires":[{"line-join":"miter"}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"line-round-limit":{"type":"number","default":1.05,"requires":[{"line-join":"round"}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"line-sort-key":{"type":"number","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"layout_symbol":{"symbol-placement":{"type":"enum","values":{"point":{},"line":{},"line-center":{}},"default":"point","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"symbol-spacing":{"type":"number","default":250,"minimum":1,"units":"pixels","requires":[{"symbol-placement":"line"}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"symbol-avoid-edges":{"type":"boolean","default":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"symbol-sort-key":{"type":"number","expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"symbol-z-order":{"type":"enum","values":{"auto":{},"viewport-y":{},"source":{}},"default":"auto","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-allow-overlap":{"type":"boolean","default":false,"requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-ignore-placement":{"type":"boolean","default":false,"requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-optional":{"type":"boolean","default":false,"requires":["icon-image","text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-rotation-alignment":{"type":"enum","values":{"map":{},"viewport":{},"auto":{}},"default":"auto","requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-size":{"type":"number","default":1,"minimum":0,"units":"factor of the original icon size","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-text-fit":{"type":"enum","values":{"none":{},"width":{},"height":{},"both":{}},"default":"none","requires":["icon-image","text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-text-fit-padding":{"type":"array","value":"number","length":4,"default":[0,0,0,0],"units":"pixels","requires":["icon-image","text-field",{"icon-text-fit":["both","width","height"]}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"icon-image":{"type":"resolvedImage","tokens":true,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-rotate":{"type":"number","default":0,"period":360,"units":"degrees","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-padding":{"type":"number","default":2,"minimum":0,"units":"pixels","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"icon-keep-upright":{"type":"boolean","default":false,"requires":["icon-image",{"icon-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"icon-offset":{"type":"array","value":"number","length":2,"default":[0,0],"requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-anchor":{"type":"enum","values":{"center":{},"left":{},"right":{},"top":{},"bottom":{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},"default":"center","requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"icon-pitch-alignment":{"type":"enum","values":{"map":{},"viewport":{},"auto":{}},"default":"auto","requires":["icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-pitch-alignment":{"type":"enum","values":{"map":{},"viewport":{},"auto":{}},"default":"auto","requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-rotation-alignment":{"type":"enum","values":{"map":{},"viewport":{},"auto":{}},"default":"auto","requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-field":{"type":"formatted","default":"","tokens":true,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-font":{"type":"array","value":"string","default":["Open Sans Regular","Arial Unicode MS Regular"],"requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-size":{"type":"number","default":16,"minimum":0,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-max-width":{"type":"number","default":10,"minimum":0,"units":"ems","requires":["text-field",{"symbol-placement":["point"]}],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-line-height":{"type":"number","default":1.2,"units":"ems","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-letter-spacing":{"type":"number","default":0,"units":"ems","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-justify":{"type":"enum","values":{"auto":{},"left":{},"center":{},"right":{}},"default":"center","requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-radial-offset":{"type":"number","units":"ems","default":0,"requires":["text-field"],"property-type":"data-driven","expression":{"interpolated":true,"parameters":["zoom","feature"]}},"text-variable-anchor":{"type":"array","value":"enum","values":{"center":{},"left":{},"right":{},"top":{},"bottom":{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},"requires":["text-field",{"symbol-placement":["point"]}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-anchor":{"type":"enum","values":{"center":{},"left":{},"right":{},"top":{},"bottom":{},"top-left":{},"top-right":{},"bottom-left":{},"bottom-right":{}},"default":"center","requires":["text-field",{"!":"text-variable-anchor"}],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-max-angle":{"type":"number","default":45,"units":"degrees","requires":["text-field",{"symbol-placement":["line","line-center"]}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"text-writing-mode":{"type":"array","value":"enum","values":{"horizontal":{},"vertical":{}},"requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-rotate":{"type":"number","default":0,"period":360,"units":"degrees","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-padding":{"type":"number","default":2,"minimum":0,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"text-keep-upright":{"type":"boolean","default":true,"requires":["text-field",{"text-rotation-alignment":"map"},{"symbol-placement":["line","line-center"]}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-transform":{"type":"enum","values":{"none":{},"uppercase":{},"lowercase":{}},"default":"none","requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-offset":{"type":"array","value":"number","units":"ems","length":2,"default":[0,0],"requires":["text-field",{"!":"text-radial-offset"}],"expression":{"interpolated":true,"parameters":["zoom","feature"]},"property-type":"data-driven"},"text-allow-overlap":{"type":"boolean","default":false,"requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-ignore-placement":{"type":"boolean","default":false,"requires":["text-field"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-optional":{"type":"boolean","default":false,"requires":["text-field","icon-image"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"layout_raster":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"layout_hillshade":{"visibility":{"type":"enum","values":{"visible":{},"none":{}},"default":"visible","property-type":"constant"}},"filter":{"type":"array","value":"*"},"filter_symbol":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature","pitch","distance-from-center"]}},"filter_fill":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_line":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_circle":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_fill-extrusion":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_heatmap":{"type":"boolean","default":false,"transition":false,"property-type":"data-driven","expression":{"interpolated":false,"parameters":["zoom","feature"]}},"filter_operator":{"type":"enum","values":{"==":{},"!=":{},">":{},">=":{},"<":{},"<=":{},"in":{},"!in":{},"all":{},"any":{},"none":{},"has":{},"!has":{},"within":{}}},"geometry_type":{"type":"enum","values":{"Point":{},"LineString":{},"Polygon":{}}},"function":{"expression":{"type":"expression"},"stops":{"type":"array","value":"function_stop"},"base":{"type":"number","default":1,"minimum":0},"property":{"type":"string","default":"$zoom"},"type":{"type":"enum","values":{"identity":{},"exponential":{},"interval":{},"categorical":{}},"default":"exponential"},"colorSpace":{"type":"enum","values":{"rgb":{},"lab":{},"hcl":{}},"default":"rgb"},"default":{"type":"*","required":false}},"function_stop":{"type":"array","minimum":0,"maximum":24,"value":["number","color"],"length":2},"expression":{"type":"array","value":"*","minimum":1},"fog":{"range":{"type":"array","default":[0.5,10],"minimum":-20,"maximum":20,"length":2,"value":"number","property-type":"data-constant","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]}},"color":{"type":"color","property-type":"data-constant","default":"#ffffff","expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"high-color":{"type":"color","property-type":"data-constant","default":"#245cdf","expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"space-color":{"type":"color","property-type":"data-constant","default":["interpolate",["linear"],["zoom"],4,"#010b19",7,"#367ab9"],"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"horizon-blend":{"type":"number","property-type":"data-constant","default":["interpolate",["linear"],["zoom"],4,0.2,7,0.1],"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"star-intensity":{"type":"number","property-type":"data-constant","default":["interpolate",["linear"],["zoom"],5,0.35,6,0],"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true}},"light":{"anchor":{"type":"enum","default":"viewport","values":{"map":{},"viewport":{}},"property-type":"data-constant","transition":false,"expression":{"interpolated":false,"parameters":["zoom"]}},"position":{"type":"array","default":[1.15,210,30],"length":3,"value":"number","property-type":"data-constant","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]}},"color":{"type":"color","property-type":"data-constant","default":"#ffffff","expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"intensity":{"type":"number","property-type":"data-constant","default":0.5,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true}},"projection":{"name":{"type":"enum","values":{"albers":{},"equalEarth":{},"equirectangular":{},"lambertConformalConic":{},"mercator":{},"naturalEarth":{},"winkelTripel":{},"globe":{}},"default":"mercator","required":true},"center":{"type":"array","length":2,"value":"number","property-type":"data-constant","minimum":[-180,-90],"maximum":[180,90],"transition":false,"requires":[{"name":["albers","lambertConformalConic"]}]},"parallels":{"type":"array","length":2,"value":"number","property-type":"data-constant","minimum":[-90,-90],"maximum":[90,90],"transition":false,"requires":[{"name":["albers","lambertConformalConic"]}]}},"terrain":{"source":{"type":"string","required":true},"exaggeration":{"type":"number","property-type":"data-constant","default":1,"minimum":0,"maximum":1000,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true,"requires":["source"]}},"paint":["paint_fill","paint_line","paint_circle","paint_heatmap","paint_fill-extrusion","paint_symbol","paint_raster","paint_hillshade","paint_background","paint_sky"],"paint_fill":{"fill-antialias":{"type":"boolean","default":true,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"fill-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-color":{"type":"color","default":"#000000","transition":true,"requires":[{"!":"fill-pattern"}],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-outline-color":{"type":"color","transition":true,"requires":[{"!":"fill-pattern"},{"fill-antialias":true}],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"fill-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["fill-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"fill-pattern":{"type":"resolvedImage","transition":true,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"cross-faded-data-driven"}},"paint_fill-extrusion":{"fill-extrusion-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"fill-extrusion-color":{"type":"color","default":"#000000","transition":true,"requires":[{"!":"fill-extrusion-pattern"}],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"fill-extrusion-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["fill-extrusion-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"fill-extrusion-pattern":{"type":"resolvedImage","transition":true,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"cross-faded-data-driven"},"fill-extrusion-height":{"type":"number","default":0,"minimum":0,"units":"meters","transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-base":{"type":"number","default":0,"minimum":0,"units":"meters","transition":true,"requires":["fill-extrusion-height"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"fill-extrusion-vertical-gradient":{"type":"boolean","default":true,"transition":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"fill-extrusion-ambient-occlusion-intensity":{"property-type":"data-constant","type":"number","private":true,"default":0,"minimum":0,"maximum":1,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true},"fill-extrusion-ambient-occlusion-radius":{"property-type":"data-constant","type":"number","private":true,"default":3,"minimum":0,"expression":{"interpolated":true,"parameters":["zoom"]},"transition":true,"requires":["fill-extrusion-edge-radius"]}},"paint_line":{"line-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-color":{"type":"color","default":"#000000","transition":true,"requires":[{"!":"line-pattern"}],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"line-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["line-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"line-width":{"type":"number","default":1,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-gap-width":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-offset":{"type":"number","default":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-blur":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"line-dasharray":{"type":"array","value":"number","minimum":0,"transition":true,"units":"line widths","requires":[{"!":"line-pattern"}],"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"cross-faded-data-driven"},"line-pattern":{"type":"resolvedImage","transition":true,"expression":{"interpolated":false,"parameters":["zoom","feature"]},"property-type":"cross-faded-data-driven"},"line-gradient":{"type":"color","transition":false,"requires":[{"!":"line-pattern"},{"source":"geojson","has":{"lineMetrics":true}}],"expression":{"interpolated":true,"parameters":["line-progress"]},"property-type":"color-ramp"},"line-trim-offset":{"type":"array","value":"number","length":2,"default":[0,0],"minimum":[0,0],"maximum":[1,1],"transition":false,"requires":[{"source":"geojson","has":{"lineMetrics":true}}],"property-type":"constant"}},"paint_circle":{"circle-radius":{"type":"number","default":5,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-color":{"type":"color","default":"#000000","transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-blur":{"type":"number","default":0,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"circle-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["circle-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"circle-pitch-scale":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"circle-pitch-alignment":{"type":"enum","values":{"map":{},"viewport":{}},"default":"viewport","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"circle-stroke-width":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-stroke-color":{"type":"color","default":"#000000","transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"circle-stroke-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"}},"paint_heatmap":{"heatmap-radius":{"type":"number","default":30,"minimum":1,"transition":true,"units":"pixels","expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"heatmap-weight":{"type":"number","default":1,"minimum":0,"transition":false,"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"heatmap-intensity":{"type":"number","default":1,"minimum":0,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"heatmap-color":{"type":"color","default":["interpolate",["linear"],["heatmap-density"],0,"rgba(0, 0, 255, 0)",0.1,"royalblue",0.3,"cyan",0.5,"lime",0.7,"yellow",1,"red"],"transition":false,"expression":{"interpolated":true,"parameters":["heatmap-density"]},"property-type":"color-ramp"},"heatmap-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_symbol":{"icon-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-color":{"type":"color","default":"#000000","transition":true,"requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-color":{"type":"color","default":"rgba(0, 0, 0, 0)","transition":true,"requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-width":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-halo-blur":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"icon-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","requires":["icon-image"],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"icon-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["icon-image","icon-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"text-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-color":{"type":"color","default":"#000000","transition":true,"overridable":true,"requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-color":{"type":"color","default":"rgba(0, 0, 0, 0)","transition":true,"requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-width":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-halo-blur":{"type":"number","default":0,"minimum":0,"transition":true,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom","feature","feature-state"]},"property-type":"data-driven"},"text-translate":{"type":"array","value":"number","length":2,"default":[0,0],"transition":true,"units":"pixels","requires":["text-field"],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"text-translate-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"map","requires":["text-field","text-translate"],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_raster":{"raster-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-hue-rotate":{"type":"number","default":0,"period":360,"transition":true,"units":"degrees","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-brightness-min":{"type":"number","default":0,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-brightness-max":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-saturation":{"type":"number","default":0,"minimum":-1,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-contrast":{"type":"number","default":0,"minimum":-1,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"raster-resampling":{"type":"enum","values":{"linear":{},"nearest":{}},"default":"linear","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"raster-fade-duration":{"type":"number","default":300,"minimum":0,"transition":false,"units":"milliseconds","expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_hillshade":{"hillshade-illumination-direction":{"type":"number","default":335,"minimum":0,"maximum":359,"transition":false,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-illumination-anchor":{"type":"enum","values":{"map":{},"viewport":{}},"default":"viewport","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-exaggeration":{"type":"number","default":0.5,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-shadow-color":{"type":"color","default":"#000000","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-highlight-color":{"type":"color","default":"#FFFFFF","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"hillshade-accent-color":{"type":"color","default":"#000000","transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_background":{"background-color":{"type":"color","default":"#000000","transition":true,"requires":[{"!":"background-pattern"}],"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"},"background-pattern":{"type":"resolvedImage","transition":true,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"cross-faded"},"background-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"paint_sky":{"sky-type":{"type":"enum","values":{"gradient":{},"atmosphere":{}},"default":"atmosphere","expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"sky-atmosphere-sun":{"type":"array","value":"number","length":2,"units":"degrees","minimum":[0,0],"maximum":[360,180],"transition":false,"requires":[{"sky-type":"atmosphere"}],"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"sky-atmosphere-sun-intensity":{"type":"number","requires":[{"sky-type":"atmosphere"}],"default":10,"minimum":0,"maximum":100,"transition":false,"property-type":"data-constant"},"sky-gradient-center":{"type":"array","requires":[{"sky-type":"gradient"}],"value":"number","default":[0,0],"length":2,"units":"degrees","minimum":[0,0],"maximum":[360,180],"transition":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"sky-gradient-radius":{"type":"number","requires":[{"sky-type":"gradient"}],"default":90,"minimum":0,"maximum":180,"transition":false,"expression":{"interpolated":false,"parameters":["zoom"]},"property-type":"data-constant"},"sky-gradient":{"type":"color","default":["interpolate",["linear"],["sky-radial-progress"],0.8,"#87ceeb",1,"white"],"transition":false,"requires":[{"sky-type":"gradient"}],"expression":{"interpolated":true,"parameters":["sky-radial-progress"]},"property-type":"color-ramp"},"sky-atmosphere-halo-color":{"type":"color","default":"white","transition":false,"requires":[{"sky-type":"atmosphere"}],"property-type":"data-constant"},"sky-atmosphere-color":{"type":"color","default":"white","transition":false,"requires":[{"sky-type":"atmosphere"}],"property-type":"data-constant"},"sky-opacity":{"type":"number","default":1,"minimum":0,"maximum":1,"transition":true,"expression":{"interpolated":true,"parameters":["zoom"]},"property-type":"data-constant"}},"transition":{"duration":{"type":"number","default":300,"minimum":0,"units":"milliseconds"},"delay":{"type":"number","default":0,"minimum":0,"units":"milliseconds"}},"property-type":{"data-driven":{"type":"property-type"},"cross-faded":{"type":"property-type"},"cross-faded-data-driven":{"type":"property-type"},"color-ramp":{"type":"property-type"},"data-constant":{"type":"property-type"},"constant":{"type":"property-type"}},"promoteId":{"*":{"type":"string"}}}');
        function Yt(t1, ...e1) {
            for (const r of e1)for(const e2 in r)t1[e2] = r[e2];
            return t1;
        }
        function Wt(t1) {
            return t1 instanceof Number || t1 instanceof String || t1 instanceof Boolean ? t1.valueOf() : t1;
        }
        function Jt(t1) {
            if (Array.isArray(t1)) return t1.map(Jt);
            if (t1 instanceof Object && !(t1 instanceof Number || t1 instanceof String || t1 instanceof Boolean)) {
                const e1 = {};
                for(const r in t1)e1[r] = Jt(t1[r]);
                return e1;
            }
            return Wt(t1);
        }
        class Qt extends Error {
            constructor(t1, e1){
                super(e1), this.message = e1, this.key = t1;
            }
        }
        var te = Qt;
        class ee {
            constructor(t1, e1 = []){
                this.parent = t1, this.bindings = {};
                for (const [t2, r] of e1)this.bindings[t2] = r;
            }
            concat(t1) {
                return new ee(this, t1);
            }
            get(t1) {
                if (this.bindings[t1]) return this.bindings[t1];
                if (this.parent) return this.parent.get(t1);
                throw new Error(`${t1} not found in scope.`);
            }
            has(t1) {
                return !!this.bindings[t1] || !!this.parent && this.parent.has(t1);
            }
        }
        var re = ee;
        const ne = {
            kind: "null"
        }, ie = {
            kind: "number"
        }, se = {
            kind: "string"
        }, ae = {
            kind: "boolean"
        }, oe = {
            kind: "color"
        }, le = {
            kind: "object"
        }, ue = {
            kind: "value"
        }, ce = {
            kind: "collator"
        }, he = {
            kind: "formatted"
        }, pe = {
            kind: "resolvedImage"
        };
        function fe(t1, e1) {
            return {
                kind: "array",
                itemType: t1,
                N: e1
            };
        }
        function de(t1) {
            if ("array" === t1.kind) {
                const e1 = de(t1.itemType);
                return "number" == typeof t1.N ? `array<${e1}, ${t1.N}>` : "value" === t1.itemType.kind ? "array" : `array<${e1}>`;
            }
            return t1.kind;
        }
        const ye = [
            ne,
            ie,
            se,
            ae,
            oe,
            he,
            le,
            fe(ue),
            pe
        ];
        function me(t1, e1) {
            if ("error" === e1.kind) return null;
            if ("array" === t1.kind) {
                if ("array" === e1.kind && (0 === e1.N && "value" === e1.itemType.kind || !me(t1.itemType, e1.itemType)) && ("number" != typeof t1.N || t1.N === e1.N)) return null;
            } else {
                if (t1.kind === e1.kind) return null;
                if ("value" === t1.kind) {
                    for (const t2 of ye)if (!me(t2, e1)) return null;
                }
            }
            return `Expected ${de(t1)} but found ${de(e1)} instead.`;
        }
        function ge(t1, e1) {
            return e1.some((e1)=>e1.kind === t1.kind);
        }
        function xe(t1, e1) {
            return e1.some((e1)=>"null" === e1 ? null === t1 : "array" === e1 ? Array.isArray(t1) : "object" === e1 ? t1 && !Array.isArray(t1) && "object" == typeof t1 : e1 === typeof t1);
        }
        var ve, be = {
            transparent: [
                0,
                0,
                0,
                0
            ],
            aliceblue: [
                240,
                248,
                255,
                1
            ],
            antiquewhite: [
                250,
                235,
                215,
                1
            ],
            aqua: [
                0,
                255,
                255,
                1
            ],
            aquamarine: [
                127,
                255,
                212,
                1
            ],
            azure: [
                240,
                255,
                255,
                1
            ],
            beige: [
                245,
                245,
                220,
                1
            ],
            bisque: [
                255,
                228,
                196,
                1
            ],
            black: [
                0,
                0,
                0,
                1
            ],
            blanchedalmond: [
                255,
                235,
                205,
                1
            ],
            blue: [
                0,
                0,
                255,
                1
            ],
            blueviolet: [
                138,
                43,
                226,
                1
            ],
            brown: [
                165,
                42,
                42,
                1
            ],
            burlywood: [
                222,
                184,
                135,
                1
            ],
            cadetblue: [
                95,
                158,
                160,
                1
            ],
            chartreuse: [
                127,
                255,
                0,
                1
            ],
            chocolate: [
                210,
                105,
                30,
                1
            ],
            coral: [
                255,
                127,
                80,
                1
            ],
            cornflowerblue: [
                100,
                149,
                237,
                1
            ],
            cornsilk: [
                255,
                248,
                220,
                1
            ],
            crimson: [
                220,
                20,
                60,
                1
            ],
            cyan: [
                0,
                255,
                255,
                1
            ],
            darkblue: [
                0,
                0,
                139,
                1
            ],
            darkcyan: [
                0,
                139,
                139,
                1
            ],
            darkgoldenrod: [
                184,
                134,
                11,
                1
            ],
            darkgray: [
                169,
                169,
                169,
                1
            ],
            darkgreen: [
                0,
                100,
                0,
                1
            ],
            darkgrey: [
                169,
                169,
                169,
                1
            ],
            darkkhaki: [
                189,
                183,
                107,
                1
            ],
            darkmagenta: [
                139,
                0,
                139,
                1
            ],
            darkolivegreen: [
                85,
                107,
                47,
                1
            ],
            darkorange: [
                255,
                140,
                0,
                1
            ],
            darkorchid: [
                153,
                50,
                204,
                1
            ],
            darkred: [
                139,
                0,
                0,
                1
            ],
            darksalmon: [
                233,
                150,
                122,
                1
            ],
            darkseagreen: [
                143,
                188,
                143,
                1
            ],
            darkslateblue: [
                72,
                61,
                139,
                1
            ],
            darkslategray: [
                47,
                79,
                79,
                1
            ],
            darkslategrey: [
                47,
                79,
                79,
                1
            ],
            darkturquoise: [
                0,
                206,
                209,
                1
            ],
            darkviolet: [
                148,
                0,
                211,
                1
            ],
            deeppink: [
                255,
                20,
                147,
                1
            ],
            deepskyblue: [
                0,
                191,
                255,
                1
            ],
            dimgray: [
                105,
                105,
                105,
                1
            ],
            dimgrey: [
                105,
                105,
                105,
                1
            ],
            dodgerblue: [
                30,
                144,
                255,
                1
            ],
            firebrick: [
                178,
                34,
                34,
                1
            ],
            floralwhite: [
                255,
                250,
                240,
                1
            ],
            forestgreen: [
                34,
                139,
                34,
                1
            ],
            fuchsia: [
                255,
                0,
                255,
                1
            ],
            gainsboro: [
                220,
                220,
                220,
                1
            ],
            ghostwhite: [
                248,
                248,
                255,
                1
            ],
            gold: [
                255,
                215,
                0,
                1
            ],
            goldenrod: [
                218,
                165,
                32,
                1
            ],
            gray: [
                128,
                128,
                128,
                1
            ],
            green: [
                0,
                128,
                0,
                1
            ],
            greenyellow: [
                173,
                255,
                47,
                1
            ],
            grey: [
                128,
                128,
                128,
                1
            ],
            honeydew: [
                240,
                255,
                240,
                1
            ],
            hotpink: [
                255,
                105,
                180,
                1
            ],
            indianred: [
                205,
                92,
                92,
                1
            ],
            indigo: [
                75,
                0,
                130,
                1
            ],
            ivory: [
                255,
                255,
                240,
                1
            ],
            khaki: [
                240,
                230,
                140,
                1
            ],
            lavender: [
                230,
                230,
                250,
                1
            ],
            lavenderblush: [
                255,
                240,
                245,
                1
            ],
            lawngreen: [
                124,
                252,
                0,
                1
            ],
            lemonchiffon: [
                255,
                250,
                205,
                1
            ],
            lightblue: [
                173,
                216,
                230,
                1
            ],
            lightcoral: [
                240,
                128,
                128,
                1
            ],
            lightcyan: [
                224,
                255,
                255,
                1
            ],
            lightgoldenrodyellow: [
                250,
                250,
                210,
                1
            ],
            lightgray: [
                211,
                211,
                211,
                1
            ],
            lightgreen: [
                144,
                238,
                144,
                1
            ],
            lightgrey: [
                211,
                211,
                211,
                1
            ],
            lightpink: [
                255,
                182,
                193,
                1
            ],
            lightsalmon: [
                255,
                160,
                122,
                1
            ],
            lightseagreen: [
                32,
                178,
                170,
                1
            ],
            lightskyblue: [
                135,
                206,
                250,
                1
            ],
            lightslategray: [
                119,
                136,
                153,
                1
            ],
            lightslategrey: [
                119,
                136,
                153,
                1
            ],
            lightsteelblue: [
                176,
                196,
                222,
                1
            ],
            lightyellow: [
                255,
                255,
                224,
                1
            ],
            lime: [
                0,
                255,
                0,
                1
            ],
            limegreen: [
                50,
                205,
                50,
                1
            ],
            linen: [
                250,
                240,
                230,
                1
            ],
            magenta: [
                255,
                0,
                255,
                1
            ],
            maroon: [
                128,
                0,
                0,
                1
            ],
            mediumaquamarine: [
                102,
                205,
                170,
                1
            ],
            mediumblue: [
                0,
                0,
                205,
                1
            ],
            mediumorchid: [
                186,
                85,
                211,
                1
            ],
            mediumpurple: [
                147,
                112,
                219,
                1
            ],
            mediumseagreen: [
                60,
                179,
                113,
                1
            ],
            mediumslateblue: [
                123,
                104,
                238,
                1
            ],
            mediumspringgreen: [
                0,
                250,
                154,
                1
            ],
            mediumturquoise: [
                72,
                209,
                204,
                1
            ],
            mediumvioletred: [
                199,
                21,
                133,
                1
            ],
            midnightblue: [
                25,
                25,
                112,
                1
            ],
            mintcream: [
                245,
                255,
                250,
                1
            ],
            mistyrose: [
                255,
                228,
                225,
                1
            ],
            moccasin: [
                255,
                228,
                181,
                1
            ],
            navajowhite: [
                255,
                222,
                173,
                1
            ],
            navy: [
                0,
                0,
                128,
                1
            ],
            oldlace: [
                253,
                245,
                230,
                1
            ],
            olive: [
                128,
                128,
                0,
                1
            ],
            olivedrab: [
                107,
                142,
                35,
                1
            ],
            orange: [
                255,
                165,
                0,
                1
            ],
            orangered: [
                255,
                69,
                0,
                1
            ],
            orchid: [
                218,
                112,
                214,
                1
            ],
            palegoldenrod: [
                238,
                232,
                170,
                1
            ],
            palegreen: [
                152,
                251,
                152,
                1
            ],
            paleturquoise: [
                175,
                238,
                238,
                1
            ],
            palevioletred: [
                219,
                112,
                147,
                1
            ],
            papayawhip: [
                255,
                239,
                213,
                1
            ],
            peachpuff: [
                255,
                218,
                185,
                1
            ],
            peru: [
                205,
                133,
                63,
                1
            ],
            pink: [
                255,
                192,
                203,
                1
            ],
            plum: [
                221,
                160,
                221,
                1
            ],
            powderblue: [
                176,
                224,
                230,
                1
            ],
            purple: [
                128,
                0,
                128,
                1
            ],
            rebeccapurple: [
                102,
                51,
                153,
                1
            ],
            red: [
                255,
                0,
                0,
                1
            ],
            rosybrown: [
                188,
                143,
                143,
                1
            ],
            royalblue: [
                65,
                105,
                225,
                1
            ],
            saddlebrown: [
                139,
                69,
                19,
                1
            ],
            salmon: [
                250,
                128,
                114,
                1
            ],
            sandybrown: [
                244,
                164,
                96,
                1
            ],
            seagreen: [
                46,
                139,
                87,
                1
            ],
            seashell: [
                255,
                245,
                238,
                1
            ],
            sienna: [
                160,
                82,
                45,
                1
            ],
            silver: [
                192,
                192,
                192,
                1
            ],
            skyblue: [
                135,
                206,
                235,
                1
            ],
            slateblue: [
                106,
                90,
                205,
                1
            ],
            slategray: [
                112,
                128,
                144,
                1
            ],
            slategrey: [
                112,
                128,
                144,
                1
            ],
            snow: [
                255,
                250,
                250,
                1
            ],
            springgreen: [
                0,
                255,
                127,
                1
            ],
            steelblue: [
                70,
                130,
                180,
                1
            ],
            tan: [
                210,
                180,
                140,
                1
            ],
            teal: [
                0,
                128,
                128,
                1
            ],
            thistle: [
                216,
                191,
                216,
                1
            ],
            tomato: [
                255,
                99,
                71,
                1
            ],
            turquoise: [
                64,
                224,
                208,
                1
            ],
            violet: [
                238,
                130,
                238,
                1
            ],
            wheat: [
                245,
                222,
                179,
                1
            ],
            white: [
                255,
                255,
                255,
                1
            ],
            whitesmoke: [
                245,
                245,
                245,
                1
            ],
            yellow: [
                255,
                255,
                0,
                1
            ],
            yellowgreen: [
                154,
                205,
                50,
                1
            ]
        };
        function _e(t1) {
            return (t1 = Math.round(t1)) < 0 ? 0 : t1 > 255 ? 255 : t1;
        }
        function we(t1) {
            return _e("%" === t1[t1.length - 1] ? parseFloat(t1) / 100 * 255 : parseInt(t1));
        }
        function Ae(t1) {
            var e1;
            return (e1 = "%" === t1[t1.length - 1] ? parseFloat(t1) / 100 : parseFloat(t1)) < 0 ? 0 : e1 > 1 ? 1 : e1;
        }
        function Se(t1, e1, r) {
            return r < 0 ? r += 1 : r > 1 && (r -= 1), 6 * r < 1 ? t1 + (e1 - t1) * r * 6 : 2 * r < 1 ? e1 : 3 * r < 2 ? t1 + (e1 - t1) * (2 / 3 - r) * 6 : t1;
        }
        try {
            ve = ({}).parseCSSColor = function(t1) {
                var e1, r = t1.replace(/ /g, "").toLowerCase();
                if (r in be) return be[r].slice();
                if ("#" === r[0]) return 4 === r.length ? (e1 = parseInt(r.substr(1), 16)) >= 0 && e1 <= 4095 ? [
                    (3840 & e1) >> 4 | (3840 & e1) >> 8,
                    240 & e1 | (240 & e1) >> 4,
                    15 & e1 | (15 & e1) << 4,
                    1
                ] : null : 7 === r.length && (e1 = parseInt(r.substr(1), 16)) >= 0 && e1 <= 16777215 ? [
                    (16711680 & e1) >> 16,
                    (65280 & e1) >> 8,
                    255 & e1,
                    1
                ] : null;
                var n = r.indexOf("("), i = r.indexOf(")");
                if (-1 !== n && i + 1 === r.length) {
                    var s = r.substr(0, n), a = r.substr(n + 1, i - (n + 1)).split(","), o = 1;
                    switch(s){
                        case "rgba":
                            if (4 !== a.length) return null;
                            o = Ae(a.pop());
                        case "rgb":
                            return 3 !== a.length ? null : [
                                we(a[0]),
                                we(a[1]),
                                we(a[2]),
                                o
                            ];
                        case "hsla":
                            if (4 !== a.length) return null;
                            o = Ae(a.pop());
                        case "hsl":
                            if (3 !== a.length) return null;
                            var l = (parseFloat(a[0]) % 360 + 360) % 360 / 360, u = Ae(a[1]), c = Ae(a[2]), h = c <= .5 ? c * (u + 1) : c + u - c * u, p = 2 * c - h;
                            return [
                                _e(255 * Se(p, h, l + 1 / 3)),
                                _e(255 * Se(p, h, l)),
                                _e(255 * Se(p, h, l - 1 / 3)),
                                o
                            ];
                        default:
                            return null;
                    }
                }
                return null;
            };
        } catch (t3) {}
        class ke {
            constructor(t1, e1, r, n = 1){
                this.r = t1, this.g = e1, this.b = r, this.a = n;
            }
            static parse(t1) {
                if (!t1) return;
                if (t1 instanceof ke) return t1;
                if ("string" != typeof t1) return;
                const e1 = ve(t1);
                return e1 ? new ke(e1[0] / 255 * e1[3], e1[1] / 255 * e1[3], e1[2] / 255 * e1[3], e1[3]) : void 0;
            }
            toString() {
                const [t1, e1, r, n] = this.toArray();
                return `rgba(${Math.round(t1)},${Math.round(e1)},${Math.round(r)},${n})`;
            }
            toArray() {
                const { r: t1 , g: e1 , b: r , a: n  } = this;
                return 0 === n ? [
                    0,
                    0,
                    0,
                    0
                ] : [
                    255 * t1 / n,
                    255 * e1 / n,
                    255 * r / n,
                    n
                ];
            }
            toArray01() {
                const { r: t1 , g: e1 , b: r , a: n  } = this;
                return 0 === n ? [
                    0,
                    0,
                    0,
                    0
                ] : [
                    t1 / n,
                    e1 / n,
                    r / n,
                    n
                ];
            }
            toArray01PremultipliedAlpha() {
                const { r: t1 , g: e1 , b: r , a: n  } = this;
                return [
                    t1,
                    e1,
                    r,
                    n
                ];
            }
        }
        ke.black = new ke(0, 0, 0, 1), ke.white = new ke(1, 1, 1, 1), ke.transparent = new ke(0, 0, 0, 0), ke.red = new ke(1, 0, 0, 1), ke.blue = new ke(0, 0, 1, 1);
        var Ie = ke;
        class Me {
            constructor(t1, e1, r){
                this.sensitivity = t1 ? e1 ? "variant" : "case" : e1 ? "accent" : "base", this.locale = r, this.collator = new Intl.Collator(this.locale ? this.locale : [], {
                    sensitivity: this.sensitivity,
                    usage: "search"
                });
            }
            compare(t1, e1) {
                return this.collator.compare(t1, e1);
            }
            resolvedLocale() {
                return new Intl.Collator(this.locale ? this.locale : []).resolvedOptions().locale;
            }
        }
        class ze {
            constructor(t1, e1, r, n, i){
                this.text = t1.normalize ? t1.normalize() : t1, this.image = e1, this.scale = r, this.fontStack = n, this.textColor = i;
            }
        }
        class Te {
            constructor(t1){
                this.sections = t1;
            }
            static fromString(t1) {
                return new Te([
                    new ze(t1, null, null, null, null)
                ]);
            }
            isEmpty() {
                return 0 === this.sections.length || !this.sections.some((t1)=>0 !== t1.text.length || t1.image && 0 !== t1.image.name.length);
            }
            static factory(t1) {
                return t1 instanceof Te ? t1 : Te.fromString(t1);
            }
            toString() {
                return 0 === this.sections.length ? "" : this.sections.map((t1)=>t1.text).join("");
            }
            serialize() {
                const t1 = [
                    "format"
                ];
                for (const e1 of this.sections){
                    if (e1.image) {
                        t1.push([
                            "image",
                            e1.image.name
                        ]);
                        continue;
                    }
                    t1.push(e1.text);
                    const r = {};
                    e1.fontStack && (r["text-font"] = [
                        "literal",
                        e1.fontStack.split(",")
                    ]), e1.scale && (r["font-scale"] = e1.scale), e1.textColor && (r["text-color"] = [
                        "rgba"
                    ].concat(e1.textColor.toArray())), t1.push(r);
                }
                return t1;
            }
        }
        class Be {
            constructor(t1){
                this.name = t1.name, this.available = t1.available;
            }
            toString() {
                return this.name;
            }
            static fromString(t1) {
                return t1 ? new Be({
                    name: t1,
                    available: !1
                }) : null;
            }
            serialize() {
                return [
                    "image",
                    this.name
                ];
            }
        }
        function Ee(t1, e1, r, n) {
            return "number" == typeof t1 && t1 >= 0 && t1 <= 255 && "number" == typeof e1 && e1 >= 0 && e1 <= 255 && "number" == typeof r && r >= 0 && r <= 255 ? void 0 === n || "number" == typeof n && n >= 0 && n <= 1 ? null : `Invalid rgba value [${[
                t1,
                e1,
                r,
                n
            ].join(", ")}]: 'a' must be between 0 and 1.` : `Invalid rgba value [${("number" == typeof n ? [
                t1,
                e1,
                r,
                n
            ] : [
                t1,
                e1,
                r
            ]).join(", ")}]: 'r', 'g', and 'b' must be between 0 and 255.`;
        }
        function Pe(t1) {
            if (null === t1) return !0;
            if ("string" == typeof t1) return !0;
            if ("boolean" == typeof t1) return !0;
            if ("number" == typeof t1) return !0;
            if (t1 instanceof Ie) return !0;
            if (t1 instanceof Me) return !0;
            if (t1 instanceof Te) return !0;
            if (t1 instanceof Be) return !0;
            if (Array.isArray(t1)) {
                for (const e1 of t1)if (!Pe(e1)) return !1;
                return !0;
            }
            if ("object" == typeof t1) {
                for(const e2 in t1)if (!Pe(t1[e2])) return !1;
                return !0;
            }
            return !1;
        }
        function Ce(t1) {
            if (null === t1) return ne;
            if ("string" == typeof t1) return se;
            if ("boolean" == typeof t1) return ae;
            if ("number" == typeof t1) return ie;
            if (t1 instanceof Ie) return oe;
            if (t1 instanceof Me) return ce;
            if (t1 instanceof Te) return he;
            if (t1 instanceof Be) return pe;
            if (Array.isArray(t1)) {
                const e1 = t1.length;
                let r;
                for (const e2 of t1){
                    const t2 = Ce(e2);
                    if (r) {
                        if (r === t2) continue;
                        r = ue;
                        break;
                    }
                    r = t2;
                }
                return fe(r || ue, e1);
            }
            return le;
        }
        function De(t1) {
            const e1 = typeof t1;
            return null === t1 ? "" : "string" === e1 || "number" === e1 || "boolean" === e1 ? String(t1) : t1 instanceof Ie || t1 instanceof Te || t1 instanceof Be ? t1.toString() : JSON.stringify(t1);
        }
        class Ve {
            constructor(t1, e1){
                this.type = t1, this.value = e1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error(`'literal' expression requires exactly one argument, but found ${t1.length - 1} instead.`);
                if (!Pe(t1[1])) return e1.error("invalid value");
                const r = t1[1];
                let n = Ce(r);
                const i = e1.expectedType;
                return "array" !== n.kind || 0 !== n.N || !i || "array" !== i.kind || "number" == typeof i.N && 0 !== i.N || (n = i), new Ve(n, r);
            }
            evaluate() {
                return this.value;
            }
            eachChild() {}
            outputDefined() {
                return !0;
            }
            serialize() {
                return "array" === this.type.kind || "object" === this.type.kind ? [
                    "literal",
                    this.value
                ] : this.value instanceof Ie ? [
                    "rgba"
                ].concat(this.value.toArray()) : this.value instanceof Te ? this.value.serialize() : this.value;
            }
        }
        var Fe = Ve, Le = class {
            constructor(t1){
                this.name = "ExpressionEvaluationError", this.message = t1;
            }
            toJSON() {
                return this.message;
            }
        };
        const Re = {
            string: se,
            number: ie,
            boolean: ae,
            object: le
        };
        class Ue {
            constructor(t1, e1){
                this.type = t1, this.args = e1;
            }
            static parse(t1, e1) {
                if (t1.length < 2) return e1.error("Expected at least one argument.");
                let r, n = 1;
                const i = t1[0];
                if ("array" === i) {
                    let i1, s;
                    if (t1.length > 2) {
                        const r1 = t1[1];
                        if ("string" != typeof r1 || !(r1 in Re) || "object" === r1) return e1.error('The item type argument of "array" must be one of string, number, boolean', 1);
                        i1 = Re[r1], n++;
                    } else i1 = ue;
                    if (t1.length > 3) {
                        if (null !== t1[2] && ("number" != typeof t1[2] || t1[2] < 0 || t1[2] !== Math.floor(t1[2]))) return e1.error('The length argument to "array" must be a positive integer literal', 2);
                        s = t1[2], n++;
                    }
                    r = fe(i1, s);
                } else r = Re[i];
                const s1 = [];
                for(; n < t1.length; n++){
                    const r2 = e1.parse(t1[n], n, ue);
                    if (!r2) return null;
                    s1.push(r2);
                }
                return new Ue(r, s1);
            }
            evaluate(t1) {
                for(let e1 = 0; e1 < this.args.length; e1++){
                    const r = this.args[e1].evaluate(t1);
                    if (!me(this.type, Ce(r))) return r;
                    if (e1 === this.args.length - 1) throw new Le(`Expected value to be of type ${de(this.type)}, but found ${de(Ce(r))} instead.`);
                }
                return null;
            }
            eachChild(t1) {
                this.args.forEach(t1);
            }
            outputDefined() {
                return this.args.every((t1)=>t1.outputDefined());
            }
            serialize() {
                const t1 = this.type, e1 = [
                    t1.kind
                ];
                if ("array" === t1.kind) {
                    const r = t1.itemType;
                    if ("string" === r.kind || "number" === r.kind || "boolean" === r.kind) {
                        e1.push(r.kind);
                        const n = t1.N;
                        ("number" == typeof n || this.args.length > 1) && e1.push(n);
                    }
                }
                return e1.concat(this.args.map((t1)=>t1.serialize()));
            }
        }
        var je = Ue;
        class $e {
            constructor(t1){
                this.type = he, this.sections = t1;
            }
            static parse(t1, e1) {
                if (t1.length < 2) return e1.error("Expected at least one argument.");
                const r = t1[1];
                if (!Array.isArray(r) && "object" == typeof r) return e1.error("First argument must be an image or text section.");
                const n = [];
                let i = !1;
                for(let r1 = 1; r1 <= t1.length - 1; ++r1){
                    const s = t1[r1];
                    if (i && "object" == typeof s && !Array.isArray(s)) {
                        i = !1;
                        let t2 = null;
                        if (s["font-scale"] && (t2 = e1.parse(s["font-scale"], 1, ie), !t2)) return null;
                        let r2 = null;
                        if (s["text-font"] && (r2 = e1.parse(s["text-font"], 1, fe(se)), !r2)) return null;
                        let a = null;
                        if (s["text-color"] && (a = e1.parse(s["text-color"], 1, oe), !a)) return null;
                        const o = n[n.length - 1];
                        o.scale = t2, o.font = r2, o.textColor = a;
                    } else {
                        const s1 = e1.parse(t1[r1], 1, ue);
                        if (!s1) return null;
                        const a1 = s1.type.kind;
                        if ("string" !== a1 && "value" !== a1 && "null" !== a1 && "resolvedImage" !== a1) return e1.error("Formatted text type must be 'string', 'value', 'image' or 'null'.");
                        i = !0, n.push({
                            content: s1,
                            scale: null,
                            font: null,
                            textColor: null
                        });
                    }
                }
                return new $e(n);
            }
            evaluate(t1) {
                return new Te(this.sections.map((e1)=>{
                    const r = e1.content.evaluate(t1);
                    return Ce(r) === pe ? new ze("", r, null, null, null) : new ze(De(r), null, e1.scale ? e1.scale.evaluate(t1) : null, e1.font ? e1.font.evaluate(t1).join(",") : null, e1.textColor ? e1.textColor.evaluate(t1) : null);
                }));
            }
            eachChild(t1) {
                for (const e1 of this.sections)t1(e1.content), e1.scale && t1(e1.scale), e1.font && t1(e1.font), e1.textColor && t1(e1.textColor);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                const t1 = [
                    "format"
                ];
                for (const e1 of this.sections){
                    t1.push(e1.content.serialize());
                    const r = {};
                    e1.scale && (r["font-scale"] = e1.scale.serialize()), e1.font && (r["text-font"] = e1.font.serialize()), e1.textColor && (r["text-color"] = e1.textColor.serialize()), t1.push(r);
                }
                return t1;
            }
        }
        class Oe {
            constructor(t1){
                this.type = pe, this.input = t1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error("Expected two arguments.");
                const r = e1.parse(t1[1], 1, se);
                return r ? new Oe(r) : e1.error("No image name provided.");
            }
            evaluate(t1) {
                const e1 = this.input.evaluate(t1), r = Be.fromString(e1);
                return r && t1.availableImages && (r.available = t1.availableImages.indexOf(e1) > -1), r;
            }
            eachChild(t1) {
                t1(this.input);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                return [
                    "image",
                    this.input.serialize()
                ];
            }
        }
        const qe = {
            "to-boolean": ae,
            "to-color": oe,
            "to-number": ie,
            "to-string": se
        };
        class Ne {
            constructor(t1, e1){
                this.type = t1, this.args = e1;
            }
            static parse(t1, e1) {
                if (t1.length < 2) return e1.error("Expected at least one argument.");
                const r = t1[0];
                if (("to-boolean" === r || "to-string" === r) && 2 !== t1.length) return e1.error("Expected one argument.");
                const n = qe[r], i = [];
                for(let r1 = 1; r1 < t1.length; r1++){
                    const n1 = e1.parse(t1[r1], r1, ue);
                    if (!n1) return null;
                    i.push(n1);
                }
                return new Ne(n, i);
            }
            evaluate(t1) {
                if ("boolean" === this.type.kind) return Boolean(this.args[0].evaluate(t1));
                if ("color" === this.type.kind) {
                    let e1, r;
                    for (const n of this.args){
                        if (e1 = n.evaluate(t1), r = null, e1 instanceof Ie) return e1;
                        if ("string" == typeof e1) {
                            const r1 = t1.parseColor(e1);
                            if (r1) return r1;
                        } else if (Array.isArray(e1) && (r = e1.length < 3 || e1.length > 4 ? `Invalid rbga value ${JSON.stringify(e1)}: expected an array containing either three or four numeric values.` : Ee(e1[0], e1[1], e1[2], e1[3]), !r)) return new Ie(e1[0] / 255, e1[1] / 255, e1[2] / 255, e1[3]);
                    }
                    throw new Le(r || `Could not parse color from value '${"string" == typeof e1 ? e1 : String(JSON.stringify(e1))}'`);
                }
                if ("number" === this.type.kind) {
                    let e2 = null;
                    for (const r2 of this.args){
                        if (e2 = r2.evaluate(t1), null === e2) return 0;
                        const n1 = Number(e2);
                        if (!isNaN(n1)) return n1;
                    }
                    throw new Le(`Could not convert ${JSON.stringify(e2)} to number.`);
                }
                return "formatted" === this.type.kind ? Te.fromString(De(this.args[0].evaluate(t1))) : "resolvedImage" === this.type.kind ? Be.fromString(De(this.args[0].evaluate(t1))) : De(this.args[0].evaluate(t1));
            }
            eachChild(t1) {
                this.args.forEach(t1);
            }
            outputDefined() {
                return this.args.every((t1)=>t1.outputDefined());
            }
            serialize() {
                if ("formatted" === this.type.kind) return new $e([
                    {
                        content: this.args[0],
                        scale: null,
                        font: null,
                        textColor: null
                    }
                ]).serialize();
                if ("resolvedImage" === this.type.kind) return new Oe(this.args[0]).serialize();
                const t1 = [
                    `to-${this.type.kind}`
                ];
                return this.eachChild((e1)=>{
                    t1.push(e1.serialize());
                }), t1;
            }
        }
        var Ge = Ne;
        const Ze = [
            "Unknown",
            "Point",
            "LineString",
            "Polygon"
        ];
        var Xe = class {
            constructor(){
                this.globals = null, this.feature = null, this.featureState = null, this.formattedSection = null, this._parseColorCache = {}, this.availableImages = null, this.canonical = null, this.featureTileCoord = null, this.featureDistanceData = null;
            }
            id() {
                return this.feature && void 0 !== this.feature.id ? this.feature.id : null;
            }
            geometryType() {
                return this.feature ? "number" == typeof this.feature.type ? Ze[this.feature.type] : this.feature.type : null;
            }
            geometry() {
                return this.feature && "geometry" in this.feature ? this.feature.geometry : null;
            }
            canonicalID() {
                return this.canonical;
            }
            properties() {
                return this.feature && this.feature.properties || {};
            }
            distanceFromCenter() {
                if (this.featureTileCoord && this.featureDistanceData) {
                    const t1 = this.featureDistanceData.center, e1 = this.featureDistanceData.scale, { x: r , y: n  } = this.featureTileCoord;
                    return this.featureDistanceData.bearing[0] * (r * e1 - t1[0]) + this.featureDistanceData.bearing[1] * (n * e1 - t1[1]);
                }
                return 0;
            }
            parseColor(t1) {
                let e1 = this._parseColorCache[t1];
                return e1 || (e1 = this._parseColorCache[t1] = Ie.parse(t1)), e1;
            }
        };
        class Ke {
            constructor(t1, e1, r, n){
                this.name = t1, this.type = e1, this._evaluate = r, this.args = n;
            }
            evaluate(t1) {
                return this._evaluate(t1, this.args);
            }
            eachChild(t1) {
                this.args.forEach(t1);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                return [
                    this.name
                ].concat(this.args.map((t1)=>t1.serialize()));
            }
            static parse(t1, e1) {
                const r = t1[0], n = Ke.definitions[r];
                if (!n) return e1.error(`Unknown expression "${r}". If you wanted a literal array, use ["literal", [...]].`, 0);
                const i = Array.isArray(n) ? n[0] : n.type, s = Array.isArray(n) ? [
                    [
                        n[1],
                        n[2]
                    ]
                ] : n.overloads, a = s.filter(([e1])=>!Array.isArray(e1) || e1.length === t1.length - 1);
                let o = null;
                for (const [n1, s1] of a){
                    o = new _r(e1.registry, e1.path, null, e1.scope);
                    const a1 = [];
                    let l = !1;
                    for(let e2 = 1; e2 < t1.length; e2++){
                        const r1 = t1[e2], i1 = Array.isArray(n1) ? n1[e2 - 1] : n1.type, s2 = o.parse(r1, 1 + a1.length, i1);
                        if (!s2) {
                            l = !0;
                            break;
                        }
                        a1.push(s2);
                    }
                    if (!l) {
                        if (Array.isArray(n1) && n1.length !== a1.length) o.error(`Expected ${n1.length} arguments, but found ${a1.length} instead.`);
                        else {
                            for(let t2 = 0; t2 < a1.length; t2++){
                                const e3 = Array.isArray(n1) ? n1[t2] : n1.type, r2 = a1[t2];
                                o.concat(t2 + 1).checkSubtype(e3, r2.type);
                            }
                            if (0 === o.errors.length) return new Ke(r, i, s1, a1);
                        }
                    }
                }
                if (1 === a.length) e1.errors.push(...o.errors);
                else {
                    const r3 = (a.length ? a : s).map(([t1])=>{
                        var e1;
                        return e1 = t1, Array.isArray(e1) ? `(${e1.map(de).join(", ")})` : `(${de(e1.type)}...)`;
                    }).join(" | "), n2 = [];
                    for(let r4 = 1; r4 < t1.length; r4++){
                        const i2 = e1.parse(t1[r4], 1 + n2.length);
                        if (!i2) return null;
                        n2.push(de(i2.type));
                    }
                    e1.error(`Expected arguments of type ${r3}, but found (${n2.join(", ")}) instead.`);
                }
                return null;
            }
            static register(t1, e1) {
                Ke.definitions = e1;
                for(const r in e1)t1[r] = Ke;
            }
        }
        var He = Ke;
        class Ye {
            constructor(t1, e1, r){
                this.type = ce, this.locale = r, this.caseSensitive = t1, this.diacriticSensitive = e1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error("Expected one argument.");
                const r = t1[1];
                if ("object" != typeof r || Array.isArray(r)) return e1.error("Collator options argument must be an object.");
                const n = e1.parse(void 0 !== r["case-sensitive"] && r["case-sensitive"], 1, ae);
                if (!n) return null;
                const i = e1.parse(void 0 !== r["diacritic-sensitive"] && r["diacritic-sensitive"], 1, ae);
                if (!i) return null;
                let s = null;
                return r.locale && (s = e1.parse(r.locale, 1, se), !s) ? null : new Ye(n, i, s);
            }
            evaluate(t1) {
                return new Me(this.caseSensitive.evaluate(t1), this.diacriticSensitive.evaluate(t1), this.locale ? this.locale.evaluate(t1) : null);
            }
            eachChild(t1) {
                t1(this.caseSensitive), t1(this.diacriticSensitive), this.locale && t1(this.locale);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                const t1 = {};
                return t1["case-sensitive"] = this.caseSensitive.serialize(), t1["diacritic-sensitive"] = this.diacriticSensitive.serialize(), this.locale && (t1.locale = this.locale.serialize()), [
                    "collator",
                    t1
                ];
            }
        }
        const We = 8192;
        function Je(t1, e1) {
            t1[0] = Math.min(t1[0], e1[0]), t1[1] = Math.min(t1[1], e1[1]), t1[2] = Math.max(t1[2], e1[0]), t1[3] = Math.max(t1[3], e1[1]);
        }
        function Qe(t1, e1) {
            return !(t1[0] <= e1[0] || t1[2] >= e1[2] || t1[1] <= e1[1] || t1[3] >= e1[3]);
        }
        function tr(t1, e1) {
            const r = (180 + t1[0]) / 360, n = (180 - 180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + t1[1] * Math.PI / 360))) / 360, i = Math.pow(2, e1.z);
            return [
                Math.round(r * i * We),
                Math.round(n * i * We)
            ];
        }
        function er(t1, e1, r) {
            const n = t1[0] - e1[0], i = t1[1] - e1[1], s = t1[0] - r[0], a = t1[1] - r[1];
            return n * a - s * i == 0 && n * s <= 0 && i * a <= 0;
        }
        function rr(t1, e1) {
            let r = !1;
            for(let a = 0, o = e1.length; a < o; a++){
                const o1 = e1[a];
                for(let e2 = 0, a1 = o1.length; e2 < a1 - 1; e2++){
                    if (er(t1, o1[e2], o1[e2 + 1])) return !1;
                    (i = o1[e2])[1] > (n = t1)[1] != (s = o1[e2 + 1])[1] > n[1] && n[0] < (s[0] - i[0]) * (n[1] - i[1]) / (s[1] - i[1]) + i[0] && (r = !r);
                }
            }
            var n, i, s;
            return r;
        }
        function nr(t1, e1) {
            for(let r = 0; r < e1.length; r++)if (rr(t1, e1[r])) return !0;
            return !1;
        }
        function ir(t1, e1, r, n) {
            const i = n[0] - r[0], s = n[1] - r[1], a = (t1[0] - r[0]) * s - i * (t1[1] - r[1]), o = (e1[0] - r[0]) * s - i * (e1[1] - r[1]);
            return a > 0 && o < 0 || a < 0 && o > 0;
        }
        function sr(t1, e1, r) {
            for (const u of r)for(let r1 = 0; r1 < u.length - 1; ++r1)if (0 != (o = [
                (a = u[r1 + 1])[0] - (s = u[r1])[0],
                a[1] - s[1]
            ])[0] * (l = [
                (i = e1)[0] - (n = t1)[0],
                i[1] - n[1]
            ])[1] - o[1] * l[0] && ir(n, i, s, a) && ir(s, a, n, i)) return !0;
            var n, i, s, a, o, l;
            return !1;
        }
        function ar(t1, e1) {
            for(let r = 0; r < t1.length; ++r)if (!rr(t1[r], e1)) return !1;
            for(let r1 = 0; r1 < t1.length - 1; ++r1)if (sr(t1[r1], t1[r1 + 1], e1)) return !1;
            return !0;
        }
        function or(t1, e1) {
            for(let r = 0; r < e1.length; r++)if (ar(t1, e1[r])) return !0;
            return !1;
        }
        function lr(t1, e1, r) {
            const n = [];
            for(let i = 0; i < t1.length; i++){
                const s = [];
                for(let n1 = 0; n1 < t1[i].length; n1++){
                    const a = tr(t1[i][n1], r);
                    Je(e1, a), s.push(a);
                }
                n.push(s);
            }
            return n;
        }
        function ur(t1, e1, r) {
            const n = [];
            for(let i = 0; i < t1.length; i++){
                const s = lr(t1[i], e1, r);
                n.push(s);
            }
            return n;
        }
        function cr(t1, e1, r, n) {
            if (t1[0] < r[0] || t1[0] > r[2]) {
                const e2 = .5 * n;
                let i = t1[0] - r[0] > e2 ? -n : r[0] - t1[0] > e2 ? n : 0;
                0 === i && (i = t1[0] - r[2] > e2 ? -n : r[2] - t1[0] > e2 ? n : 0), t1[0] += i;
            }
            Je(e1, t1);
        }
        function hr(t1, e1, r, n) {
            const i = Math.pow(2, n.z) * We, s = [
                n.x * We,
                n.y * We
            ], a = [];
            if (!t1) return a;
            for (const n1 of t1)for (const t2 of n1){
                const n2 = [
                    t2.x + s[0],
                    t2.y + s[1]
                ];
                cr(n2, e1, r, i), a.push(n2);
            }
            return a;
        }
        function pr(t1, e1, r, n) {
            const i = Math.pow(2, n.z) * We, s = [
                n.x * We,
                n.y * We
            ], a = [];
            if (!t1) return a;
            for (const r1 of t1){
                const t2 = [];
                for (const n1 of r1){
                    const r2 = [
                        n1.x + s[0],
                        n1.y + s[1]
                    ];
                    Je(e1, r2), t2.push(r2);
                }
                a.push(t2);
            }
            if (e1[2] - e1[0] <= i / 2) {
                (o = e1)[0] = o[1] = 1 / 0, o[2] = o[3] = -1 / 0;
                for (const t3 of a)for (const n2 of t3)cr(n2, e1, r, i);
            }
            var o;
            return a;
        }
        class fr {
            constructor(t1, e1){
                this.type = ae, this.geojson = t1, this.geometries = e1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error(`'within' expression requires exactly one argument, but found ${t1.length - 1} instead.`);
                if (Pe(t1[1])) {
                    const e2 = t1[1];
                    if ("FeatureCollection" === e2.type) for(let t2 = 0; t2 < e2.features.length; ++t2){
                        const r = e2.features[t2].geometry.type;
                        if ("Polygon" === r || "MultiPolygon" === r) return new fr(e2, e2.features[t2].geometry);
                    }
                    else if ("Feature" === e2.type) {
                        const t3 = e2.geometry.type;
                        if ("Polygon" === t3 || "MultiPolygon" === t3) return new fr(e2, e2.geometry);
                    } else if ("Polygon" === e2.type || "MultiPolygon" === e2.type) return new fr(e2, e2);
                }
                return e1.error("'within' expression requires valid geojson object that contains polygon geometry type.");
            }
            evaluate(t1) {
                if (null != t1.geometry() && null != t1.canonicalID()) {
                    if ("Point" === t1.geometryType()) return function(t1, e1) {
                        const r = [
                            1 / 0,
                            1 / 0,
                            -1 / 0,
                            -1 / 0
                        ], n = [
                            1 / 0,
                            1 / 0,
                            -1 / 0,
                            -1 / 0
                        ], i = t1.canonicalID();
                        if (!i) return !1;
                        if ("Polygon" === e1.type) {
                            const s = lr(e1.coordinates, n, i), a = hr(t1.geometry(), r, n, i);
                            if (!Qe(r, n)) return !1;
                            for (const t2 of a)if (!rr(t2, s)) return !1;
                        }
                        if ("MultiPolygon" === e1.type) {
                            const s1 = ur(e1.coordinates, n, i), a1 = hr(t1.geometry(), r, n, i);
                            if (!Qe(r, n)) return !1;
                            for (const t3 of a1)if (!nr(t3, s1)) return !1;
                        }
                        return !0;
                    }(t1, this.geometries);
                    if ("LineString" === t1.geometryType()) return function(t1, e1) {
                        const r = [
                            1 / 0,
                            1 / 0,
                            -1 / 0,
                            -1 / 0
                        ], n = [
                            1 / 0,
                            1 / 0,
                            -1 / 0,
                            -1 / 0
                        ], i = t1.canonicalID();
                        if (!i) return !1;
                        if ("Polygon" === e1.type) {
                            const s = lr(e1.coordinates, n, i), a = pr(t1.geometry(), r, n, i);
                            if (!Qe(r, n)) return !1;
                            for (const t2 of a)if (!ar(t2, s)) return !1;
                        }
                        if ("MultiPolygon" === e1.type) {
                            const s1 = ur(e1.coordinates, n, i), a1 = pr(t1.geometry(), r, n, i);
                            if (!Qe(r, n)) return !1;
                            for (const t3 of a1)if (!or(t3, s1)) return !1;
                        }
                        return !0;
                    }(t1, this.geometries);
                }
                return !1;
            }
            eachChild() {}
            outputDefined() {
                return !0;
            }
            serialize() {
                return [
                    "within",
                    this.geojson
                ];
            }
        }
        var dr = fr;
        function yr(t1) {
            if (t1 instanceof He) {
                if ("get" === t1.name && 1 === t1.args.length) return !1;
                if ("feature-state" === t1.name) return !1;
                if ("has" === t1.name && 1 === t1.args.length) return !1;
                if ("properties" === t1.name || "geometry-type" === t1.name || "id" === t1.name) return !1;
                if (/^filter-/.test(t1.name)) return !1;
            }
            if (t1 instanceof dr) return !1;
            let e1 = !0;
            return t1.eachChild((t1)=>{
                e1 && !yr(t1) && (e1 = !1);
            }), e1;
        }
        function mr(t1) {
            if (t1 instanceof He && "feature-state" === t1.name) return !1;
            let e1 = !0;
            return t1.eachChild((t1)=>{
                e1 && !mr(t1) && (e1 = !1);
            }), e1;
        }
        function gr(t1, e1) {
            if (t1 instanceof He && e1.indexOf(t1.name) >= 0) return !1;
            let r = !0;
            return t1.eachChild((t1)=>{
                r && !gr(t1, e1) && (r = !1);
            }), r;
        }
        class xr {
            constructor(t1, e1){
                this.type = e1.type, this.name = t1, this.boundExpression = e1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length || "string" != typeof t1[1]) return e1.error("'var' expression requires exactly one string literal argument.");
                const r = t1[1];
                return e1.scope.has(r) ? new xr(r, e1.scope.get(r)) : e1.error(`Unknown variable "${r}". Make sure "${r}" has been bound in an enclosing "let" expression before using it.`, 1);
            }
            evaluate(t1) {
                return this.boundExpression.evaluate(t1);
            }
            eachChild() {}
            outputDefined() {
                return !1;
            }
            serialize() {
                return [
                    "var",
                    this.name
                ];
            }
        }
        var vr = xr;
        class br {
            constructor(t1, e1 = [], r, n = new re, i = []){
                this.registry = t1, this.path = e1, this.key = e1.map((t1)=>`[${t1}]`).join(""), this.scope = n, this.errors = i, this.expectedType = r;
            }
            parse(t1, e1, r, n, i = {}) {
                return e1 ? this.concat(e1, r, n)._parse(t1, i) : this._parse(t1, i);
            }
            _parse(t1, e1) {
                function r(t1, e1, r) {
                    return "assert" === r ? new je(e1, [
                        t1
                    ]) : "coerce" === r ? new Ge(e1, [
                        t1
                    ]) : t1;
                }
                if (null !== t1 && "string" != typeof t1 && "boolean" != typeof t1 && "number" != typeof t1 || (t1 = [
                    "literal",
                    t1
                ]), Array.isArray(t1)) {
                    if (0 === t1.length) return this.error('Expected an array with at least one element. If you wanted a literal array, use ["literal", []].');
                    const n = t1[0];
                    if ("string" != typeof n) return this.error(`Expression name must be a string, but found ${typeof n} instead. If you wanted a literal array, use ["literal", [...]].`, 0), null;
                    const i = this.registry[n];
                    if (i) {
                        let n1 = i.parse(t1, this);
                        if (!n1) return null;
                        if (this.expectedType) {
                            const t2 = this.expectedType, i1 = n1.type;
                            if ("string" !== t2.kind && "number" !== t2.kind && "boolean" !== t2.kind && "object" !== t2.kind && "array" !== t2.kind || "value" !== i1.kind) {
                                if ("color" !== t2.kind && "formatted" !== t2.kind && "resolvedImage" !== t2.kind || "value" !== i1.kind && "string" !== i1.kind) {
                                    if (this.checkSubtype(t2, i1)) return null;
                                } else n1 = r(n1, t2, e1.typeAnnotation || "coerce");
                            } else n1 = r(n1, t2, e1.typeAnnotation || "assert");
                        }
                        if (!(n1 instanceof Fe) && "resolvedImage" !== n1.type.kind && wr(n1)) {
                            const t3 = new Xe;
                            try {
                                n1 = new Fe(n1.type, n1.evaluate(t3));
                            } catch (t4) {
                                return this.error(t4.message), null;
                            }
                        }
                        return n1;
                    }
                    return this.error(`Unknown expression "${n}". If you wanted a literal array, use ["literal", [...]].`, 0);
                }
                return this.error(void 0 === t1 ? "'undefined' value invalid. Use null instead." : "object" == typeof t1 ? 'Bare objects invalid. Use ["literal", {...}] instead.' : `Expected an array, but found ${typeof t1} instead.`);
            }
            concat(t1, e1, r) {
                const n = "number" == typeof t1 ? this.path.concat(t1) : this.path, i = r ? this.scope.concat(r) : this.scope;
                return new br(this.registry, n, e1 || null, i, this.errors);
            }
            error(t1, ...e1) {
                const r = `${this.key}${e1.map((t1)=>`[${t1}]`).join("")}`;
                this.errors.push(new te(r, t1));
            }
            checkSubtype(t1, e1) {
                const r = me(t1, e1);
                return r && this.error(r), r;
            }
        }
        var _r = br;
        function wr(t1) {
            if (t1 instanceof vr) return wr(t1.boundExpression);
            if (t1 instanceof He && "error" === t1.name) return !1;
            if (t1 instanceof Ye) return !1;
            if (t1 instanceof dr) return !1;
            const e1 = t1 instanceof Ge || t1 instanceof je;
            let r = !0;
            return t1.eachChild((t1)=>{
                r = e1 ? r && wr(t1) : r && t1 instanceof Fe;
            }), !!r && yr(t1) && gr(t1, [
                "zoom",
                "heatmap-density",
                "line-progress",
                "sky-radial-progress",
                "accumulated",
                "is-supported-script",
                "pitch",
                "distance-from-center"
            ]);
        }
        function Ar(t1, e1) {
            const r = t1.length - 1;
            let n, i, s = 0, a = r, o = 0;
            for(; s <= a;)if (o = Math.floor((s + a) / 2), n = t1[o], i = t1[o + 1], n <= e1) {
                if (o === r || e1 < i) return o;
                s = o + 1;
            } else {
                if (!(n > e1)) throw new Le("Input is not a number.");
                a = o - 1;
            }
            return 0;
        }
        class Sr {
            constructor(t1, e1, r){
                this.type = t1, this.input = e1, this.labels = [], this.outputs = [];
                for (const [t2, e2] of r)this.labels.push(t2), this.outputs.push(e2);
            }
            static parse(t1, e1) {
                if (t1.length - 1 < 4) return e1.error(`Expected at least 4 arguments, but found only ${t1.length - 1}.`);
                if ((t1.length - 1) % 2 != 0) return e1.error("Expected an even number of arguments.");
                const r = e1.parse(t1[1], 1, ie);
                if (!r) return null;
                const n = [];
                let i = null;
                e1.expectedType && "value" !== e1.expectedType.kind && (i = e1.expectedType);
                for(let r1 = 1; r1 < t1.length; r1 += 2){
                    const s = 1 === r1 ? -1 / 0 : t1[r1], a = t1[r1 + 1], o = r1, l = r1 + 1;
                    if ("number" != typeof s) return e1.error('Input/output pairs for "step" expressions must be defined using literal numeric values (not computed expressions) for the input values.', o);
                    if (n.length && n[n.length - 1][0] >= s) return e1.error('Input/output pairs for "step" expressions must be arranged with input values in strictly ascending order.', o);
                    const u = e1.parse(a, l, i);
                    if (!u) return null;
                    i = i || u.type, n.push([
                        s,
                        u
                    ]);
                }
                return new Sr(i, r, n);
            }
            evaluate(t1) {
                const e1 = this.labels, r = this.outputs;
                if (1 === e1.length) return r[0].evaluate(t1);
                const n = this.input.evaluate(t1);
                if (n <= e1[0]) return r[0].evaluate(t1);
                const i = e1.length;
                return n >= e1[i - 1] ? r[i - 1].evaluate(t1) : r[Ar(e1, n)].evaluate(t1);
            }
            eachChild(t1) {
                t1(this.input);
                for (const e1 of this.outputs)t1(e1);
            }
            outputDefined() {
                return this.outputs.every((t1)=>t1.outputDefined());
            }
            serialize() {
                const t1 = [
                    "step",
                    this.input.serialize()
                ];
                for(let e1 = 0; e1 < this.labels.length; e1++)e1 > 0 && t1.push(this.labels[e1]), t1.push(this.outputs[e1].serialize());
                return t1;
            }
        }
        var kr = Sr;
        function Ir(t1, e1, r) {
            return t1 * (1 - r) + e1 * r;
        }
        var Mr = Object.freeze({
            __proto__: null,
            number: Ir,
            color: function(t1, e1, r) {
                return new Ie(Ir(t1.r, e1.r, r), Ir(t1.g, e1.g, r), Ir(t1.b, e1.b, r), Ir(t1.a, e1.a, r));
            },
            array: function(t1, e1, r) {
                return t1.map((t1, n)=>Ir(t1, e1[n], r));
            }
        });
        const zr = .95047, Tr = 1.08883, Br = 4 / 29, Er = 6 / 29, Pr = 3 * Er * Er, Cr = Math.PI / 180, Dr = 180 / Math.PI;
        function Vr(t1) {
            return t1 > .008856451679035631 ? Math.pow(t1, 1 / 3) : t1 / Pr + Br;
        }
        function Fr(t1) {
            return t1 > Er ? t1 * t1 * t1 : Pr * (t1 - Br);
        }
        function Lr(t1) {
            return 255 * (t1 <= .0031308 ? 12.92 * t1 : 1.055 * Math.pow(t1, 1 / 2.4) - .055);
        }
        function Rr(t1) {
            return (t1 /= 255) <= .04045 ? t1 / 12.92 : Math.pow((t1 + .055) / 1.055, 2.4);
        }
        function Ur(t1) {
            const e1 = Rr(t1.r), r = Rr(t1.g), n = Rr(t1.b), i = Vr((.4124564 * e1 + .3575761 * r + .1804375 * n) / zr), s = Vr((.2126729 * e1 + .7151522 * r + .072175 * n) / 1);
            return {
                l: 116 * s - 16,
                a: 500 * (i - s),
                b: 200 * (s - Vr((.0193339 * e1 + .119192 * r + .9503041 * n) / Tr)),
                alpha: t1.a
            };
        }
        function jr(t1) {
            let e1 = (t1.l + 16) / 116, r = isNaN(t1.a) ? e1 : e1 + t1.a / 500, n = isNaN(t1.b) ? e1 : e1 - t1.b / 200;
            return e1 = 1 * Fr(e1), r = zr * Fr(r), n = Tr * Fr(n), new Ie(Lr(3.2404542 * r - 1.5371385 * e1 - .4985314 * n), Lr(-0.969266 * r + 1.8760108 * e1 + .041556 * n), Lr(.0556434 * r - .2040259 * e1 + 1.0572252 * n), t1.alpha);
        }
        function $r(t1, e1, r) {
            const n = e1 - t1;
            return t1 + r * (n > 180 || n < -180 ? n - 360 * Math.round(n / 360) : n);
        }
        const Or = {
            forward: Ur,
            reverse: jr,
            interpolate: function(t1, e1, r) {
                return {
                    l: Ir(t1.l, e1.l, r),
                    a: Ir(t1.a, e1.a, r),
                    b: Ir(t1.b, e1.b, r),
                    alpha: Ir(t1.alpha, e1.alpha, r)
                };
            }
        }, qr = {
            forward: function(t1) {
                const { l: e1 , a: r , b: n  } = Ur(t1), i = Math.atan2(n, r) * Dr;
                return {
                    h: i < 0 ? i + 360 : i,
                    c: Math.sqrt(r * r + n * n),
                    l: e1,
                    alpha: t1.a
                };
            },
            reverse: function(t1) {
                const e1 = t1.h * Cr, r = t1.c;
                return jr({
                    l: t1.l,
                    a: Math.cos(e1) * r,
                    b: Math.sin(e1) * r,
                    alpha: t1.alpha
                });
            },
            interpolate: function(t1, e1, r) {
                return {
                    h: $r(t1.h, e1.h, r),
                    c: Ir(t1.c, e1.c, r),
                    l: Ir(t1.l, e1.l, r),
                    alpha: Ir(t1.alpha, e1.alpha, r)
                };
            }
        };
        var Nr = Object.freeze({
            __proto__: null,
            lab: Or,
            hcl: qr
        });
        class Gr {
            constructor(t1, e1, r, n, i){
                this.type = t1, this.operator = e1, this.interpolation = r, this.input = n, this.labels = [], this.outputs = [];
                for (const [t2, e2] of i)this.labels.push(t2), this.outputs.push(e2);
            }
            static interpolationFactor(t1, e1, r, n) {
                let i = 0;
                if ("exponential" === t1.name) i = Zr(e1, t1.base, r, n);
                else if ("linear" === t1.name) i = Zr(e1, 1, r, n);
                else if ("cubic-bezier" === t1.name) {
                    const s = t1.controlPoints;
                    i = new p(s[0], s[1], s[2], s[3]).solve(Zr(e1, 1, r, n));
                }
                return i;
            }
            static parse(t1, e1) {
                let [r, n, i, ...s] = t1;
                if (!Array.isArray(n) || 0 === n.length) return e1.error("Expected an interpolation type expression.", 1);
                if ("linear" === n[0]) n = {
                    name: "linear"
                };
                else if ("exponential" === n[0]) {
                    const t2 = n[1];
                    if ("number" != typeof t2) return e1.error("Exponential interpolation requires a numeric base.", 1, 1);
                    n = {
                        name: "exponential",
                        base: t2
                    };
                } else {
                    if ("cubic-bezier" !== n[0]) return e1.error(`Unknown interpolation type ${String(n[0])}`, 1, 0);
                    {
                        const t3 = n.slice(1);
                        if (4 !== t3.length || t3.some((t1)=>"number" != typeof t1 || t1 < 0 || t1 > 1)) return e1.error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1.", 1);
                        n = {
                            name: "cubic-bezier",
                            controlPoints: t3
                        };
                    }
                }
                if (t1.length - 1 < 4) return e1.error(`Expected at least 4 arguments, but found only ${t1.length - 1}.`);
                if ((t1.length - 1) % 2 != 0) return e1.error("Expected an even number of arguments.");
                if (i = e1.parse(i, 2, ie), !i) return null;
                const a = [];
                let o = null;
                "interpolate-hcl" === r || "interpolate-lab" === r ? o = oe : e1.expectedType && "value" !== e1.expectedType.kind && (o = e1.expectedType);
                for(let t4 = 0; t4 < s.length; t4 += 2){
                    const r1 = s[t4], n1 = s[t4 + 1], i1 = t4 + 3, l = t4 + 4;
                    if ("number" != typeof r1) return e1.error('Input/output pairs for "interpolate" expressions must be defined using literal numeric values (not computed expressions) for the input values.', i1);
                    if (a.length && a[a.length - 1][0] >= r1) return e1.error('Input/output pairs for "interpolate" expressions must be arranged with input values in strictly ascending order.', i1);
                    const u = e1.parse(n1, l, o);
                    if (!u) return null;
                    o = o || u.type, a.push([
                        r1,
                        u
                    ]);
                }
                return "number" === o.kind || "color" === o.kind || "array" === o.kind && "number" === o.itemType.kind && "number" == typeof o.N ? new Gr(o, r, n, i, a) : e1.error(`Type ${de(o)} is not interpolatable.`);
            }
            evaluate(t1) {
                const e1 = this.labels, r = this.outputs;
                if (1 === e1.length) return r[0].evaluate(t1);
                const n = this.input.evaluate(t1);
                if (n <= e1[0]) return r[0].evaluate(t1);
                const i = e1.length;
                if (n >= e1[i - 1]) return r[i - 1].evaluate(t1);
                const s = Ar(e1, n), a = Gr.interpolationFactor(this.interpolation, n, e1[s], e1[s + 1]), o = r[s].evaluate(t1), l = r[s + 1].evaluate(t1);
                return "interpolate" === this.operator ? Mr[this.type.kind.toLowerCase()](o, l, a) : "interpolate-hcl" === this.operator ? qr.reverse(qr.interpolate(qr.forward(o), qr.forward(l), a)) : Or.reverse(Or.interpolate(Or.forward(o), Or.forward(l), a));
            }
            eachChild(t1) {
                t1(this.input);
                for (const e1 of this.outputs)t1(e1);
            }
            outputDefined() {
                return this.outputs.every((t1)=>t1.outputDefined());
            }
            serialize() {
                let t1;
                t1 = "linear" === this.interpolation.name ? [
                    "linear"
                ] : "exponential" === this.interpolation.name ? 1 === this.interpolation.base ? [
                    "linear"
                ] : [
                    "exponential",
                    this.interpolation.base
                ] : [
                    "cubic-bezier"
                ].concat(this.interpolation.controlPoints);
                const e1 = [
                    this.operator,
                    t1,
                    this.input.serialize()
                ];
                for(let t2 = 0; t2 < this.labels.length; t2++)e1.push(this.labels[t2], this.outputs[t2].serialize());
                return e1;
            }
        }
        function Zr(t1, e1, r, n) {
            const i = n - r, s = t1 - r;
            return 0 === i ? 0 : 1 === e1 ? s / i : (Math.pow(e1, s) - 1) / (Math.pow(e1, i) - 1);
        }
        var Xr = Gr;
        class Kr {
            constructor(t1, e1){
                this.type = t1, this.args = e1;
            }
            static parse(t1, e1) {
                if (t1.length < 2) return e1.error("Expectected at least one argument.");
                let r = null;
                const n = e1.expectedType;
                n && "value" !== n.kind && (r = n);
                const i = [];
                for (const n1 of t1.slice(1)){
                    const t2 = e1.parse(n1, 1 + i.length, r, void 0, {
                        typeAnnotation: "omit"
                    });
                    if (!t2) return null;
                    r = r || t2.type, i.push(t2);
                }
                const s = n && i.some((t1)=>me(n, t1.type));
                return new Kr(s ? ue : r, i);
            }
            evaluate(t1) {
                let e1, r = null, n = 0;
                for (const i of this.args){
                    if (n++, r = i.evaluate(t1), r && r instanceof Be && !r.available && (e1 || (e1 = r), r = null, n === this.args.length)) return e1;
                    if (null !== r) break;
                }
                return r;
            }
            eachChild(t1) {
                this.args.forEach(t1);
            }
            outputDefined() {
                return this.args.every((t1)=>t1.outputDefined());
            }
            serialize() {
                const t1 = [
                    "coalesce"
                ];
                return this.eachChild((e1)=>{
                    t1.push(e1.serialize());
                }), t1;
            }
        }
        var Hr = Kr;
        class Yr {
            constructor(t1, e1){
                this.type = e1.type, this.bindings = [].concat(t1), this.result = e1;
            }
            evaluate(t1) {
                return this.result.evaluate(t1);
            }
            eachChild(t1) {
                for (const e1 of this.bindings)t1(e1[1]);
                t1(this.result);
            }
            static parse(t1, e1) {
                if (t1.length < 4) return e1.error(`Expected at least 3 arguments, but found ${t1.length - 1} instead.`);
                const r = [];
                for(let n = 1; n < t1.length - 1; n += 2){
                    const i = t1[n];
                    if ("string" != typeof i) return e1.error(`Expected string, but found ${typeof i} instead.`, n);
                    if (/[^a-zA-Z0-9_]/.test(i)) return e1.error("Variable names must contain only alphanumeric characters or '_'.", n);
                    const s = e1.parse(t1[n + 1], n + 1);
                    if (!s) return null;
                    r.push([
                        i,
                        s
                    ]);
                }
                const n1 = e1.parse(t1[t1.length - 1], t1.length - 1, e1.expectedType, r);
                return n1 ? new Yr(r, n1) : null;
            }
            outputDefined() {
                return this.result.outputDefined();
            }
            serialize() {
                const t1 = [
                    "let"
                ];
                for (const [e1, r] of this.bindings)t1.push(e1, r.serialize());
                return t1.push(this.result.serialize()), t1;
            }
        }
        var Wr = Yr;
        class Jr {
            constructor(t1, e1, r){
                this.type = t1, this.index = e1, this.input = r;
            }
            static parse(t1, e1) {
                if (3 !== t1.length) return e1.error(`Expected 2 arguments, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1, ie), n = e1.parse(t1[2], 2, fe(e1.expectedType || ue));
                return r && n ? new Jr(n.type.itemType, r, n) : null;
            }
            evaluate(t1) {
                const e1 = this.index.evaluate(t1), r = this.input.evaluate(t1);
                if (e1 < 0) throw new Le(`Array index out of bounds: ${e1} < 0.`);
                if (e1 >= r.length) throw new Le(`Array index out of bounds: ${e1} > ${r.length - 1}.`);
                if (e1 !== Math.floor(e1)) throw new Le(`Array index must be an integer, but found ${e1} instead.`);
                return r[e1];
            }
            eachChild(t1) {
                t1(this.index), t1(this.input);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                return [
                    "at",
                    this.index.serialize(),
                    this.input.serialize()
                ];
            }
        }
        var Qr = Jr;
        class tn {
            constructor(t1, e1){
                this.type = ae, this.needle = t1, this.haystack = e1;
            }
            static parse(t1, e1) {
                if (3 !== t1.length) return e1.error(`Expected 2 arguments, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1, ue), n = e1.parse(t1[2], 2, ue);
                return r && n ? ge(r.type, [
                    ae,
                    se,
                    ie,
                    ne,
                    ue
                ]) ? new tn(r, n) : e1.error(`Expected first argument to be of type boolean, string, number or null, but found ${de(r.type)} instead`) : null;
            }
            evaluate(t1) {
                const e1 = this.needle.evaluate(t1), r = this.haystack.evaluate(t1);
                if (null == r) return !1;
                if (!xe(e1, [
                    "boolean",
                    "string",
                    "number",
                    "null"
                ])) throw new Le(`Expected first argument to be of type boolean, string, number or null, but found ${de(Ce(e1))} instead.`);
                if (!xe(r, [
                    "string",
                    "array"
                ])) throw new Le(`Expected second argument to be of type array or string, but found ${de(Ce(r))} instead.`);
                return r.indexOf(e1) >= 0;
            }
            eachChild(t1) {
                t1(this.needle), t1(this.haystack);
            }
            outputDefined() {
                return !0;
            }
            serialize() {
                return [
                    "in",
                    this.needle.serialize(),
                    this.haystack.serialize()
                ];
            }
        }
        var en = tn;
        class rn {
            constructor(t1, e1, r){
                this.type = ie, this.needle = t1, this.haystack = e1, this.fromIndex = r;
            }
            static parse(t1, e1) {
                if (t1.length <= 2 || t1.length >= 5) return e1.error(`Expected 3 or 4 arguments, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1, ue), n = e1.parse(t1[2], 2, ue);
                if (!r || !n) return null;
                if (!ge(r.type, [
                    ae,
                    se,
                    ie,
                    ne,
                    ue
                ])) return e1.error(`Expected first argument to be of type boolean, string, number or null, but found ${de(r.type)} instead`);
                if (4 === t1.length) {
                    const i = e1.parse(t1[3], 3, ie);
                    return i ? new rn(r, n, i) : null;
                }
                return new rn(r, n);
            }
            evaluate(t1) {
                const e1 = this.needle.evaluate(t1), r = this.haystack.evaluate(t1);
                if (!xe(e1, [
                    "boolean",
                    "string",
                    "number",
                    "null"
                ])) throw new Le(`Expected first argument to be of type boolean, string, number or null, but found ${de(Ce(e1))} instead.`);
                if (!xe(r, [
                    "string",
                    "array"
                ])) throw new Le(`Expected second argument to be of type array or string, but found ${de(Ce(r))} instead.`);
                if (this.fromIndex) {
                    const n = this.fromIndex.evaluate(t1);
                    return r.indexOf(e1, n);
                }
                return r.indexOf(e1);
            }
            eachChild(t1) {
                t1(this.needle), t1(this.haystack), this.fromIndex && t1(this.fromIndex);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                if (null != this.fromIndex && void 0 !== this.fromIndex) {
                    const t1 = this.fromIndex.serialize();
                    return [
                        "index-of",
                        this.needle.serialize(),
                        this.haystack.serialize(),
                        t1
                    ];
                }
                return [
                    "index-of",
                    this.needle.serialize(),
                    this.haystack.serialize()
                ];
            }
        }
        var nn = rn;
        class sn {
            constructor(t1, e1, r, n, i, s){
                this.inputType = t1, this.type = e1, this.input = r, this.cases = n, this.outputs = i, this.otherwise = s;
            }
            static parse(t1, e1) {
                if (t1.length < 5) return e1.error(`Expected at least 4 arguments, but found only ${t1.length - 1}.`);
                if (t1.length % 2 != 1) return e1.error("Expected an even number of arguments.");
                let r, n;
                e1.expectedType && "value" !== e1.expectedType.kind && (n = e1.expectedType);
                const i = {}, s = [];
                for(let a = 2; a < t1.length - 1; a += 2){
                    let o = t1[a];
                    const l = t1[a + 1];
                    Array.isArray(o) || (o = [
                        o
                    ]);
                    const u = e1.concat(a);
                    if (0 === o.length) return u.error("Expected at least one branch label.");
                    for (const t2 of o){
                        if ("number" != typeof t2 && "string" != typeof t2) return u.error("Branch labels must be numbers or strings.");
                        if ("number" == typeof t2 && Math.abs(t2) > Number.MAX_SAFE_INTEGER) return u.error(`Branch labels must be integers no larger than ${Number.MAX_SAFE_INTEGER}.`);
                        if ("number" == typeof t2 && Math.floor(t2) !== t2) return u.error("Numeric branch labels must be integer values.");
                        if (r) {
                            if (u.checkSubtype(r, Ce(t2))) return null;
                        } else r = Ce(t2);
                        if (void 0 !== i[String(t2)]) return u.error("Branch labels must be unique.");
                        i[String(t2)] = s.length;
                    }
                    const c = e1.parse(l, a, n);
                    if (!c) return null;
                    n = n || c.type, s.push(c);
                }
                const a1 = e1.parse(t1[1], 1, ue);
                if (!a1) return null;
                const o1 = e1.parse(t1[t1.length - 1], t1.length - 1, n);
                return o1 ? "value" !== a1.type.kind && e1.concat(1).checkSubtype(r, a1.type) ? null : new sn(r, n, a1, i, s, o1) : null;
            }
            evaluate(t1) {
                const e1 = this.input.evaluate(t1);
                return (Ce(e1) === this.inputType && this.outputs[this.cases[e1]] || this.otherwise).evaluate(t1);
            }
            eachChild(t1) {
                t1(this.input), this.outputs.forEach(t1), t1(this.otherwise);
            }
            outputDefined() {
                return this.outputs.every((t1)=>t1.outputDefined()) && this.otherwise.outputDefined();
            }
            serialize() {
                const t1 = [
                    "match",
                    this.input.serialize()
                ], e1 = Object.keys(this.cases).sort(), r = [], n = {};
                for (const t2 of e1){
                    const e2 = n[this.cases[t2]];
                    void 0 === e2 ? (n[this.cases[t2]] = r.length, r.push([
                        this.cases[t2],
                        [
                            t2
                        ]
                    ])) : r[e2][1].push(t2);
                }
                const i = (t1)=>"number" === this.inputType.kind ? Number(t1) : t1;
                for (const [e3, n1] of r)t1.push(1 === n1.length ? i(n1[0]) : n1.map(i)), t1.push(this.outputs[e3].serialize());
                return t1.push(this.otherwise.serialize()), t1;
            }
        }
        var an = sn;
        class on {
            constructor(t1, e1, r){
                this.type = t1, this.branches = e1, this.otherwise = r;
            }
            static parse(t1, e1) {
                if (t1.length < 4) return e1.error(`Expected at least 3 arguments, but found only ${t1.length - 1}.`);
                if (t1.length % 2 != 0) return e1.error("Expected an odd number of arguments.");
                let r;
                e1.expectedType && "value" !== e1.expectedType.kind && (r = e1.expectedType);
                const n = [];
                for(let i = 1; i < t1.length - 1; i += 2){
                    const s = e1.parse(t1[i], i, ae);
                    if (!s) return null;
                    const a = e1.parse(t1[i + 1], i + 1, r);
                    if (!a) return null;
                    n.push([
                        s,
                        a
                    ]), r = r || a.type;
                }
                const i1 = e1.parse(t1[t1.length - 1], t1.length - 1, r);
                return i1 ? new on(r, n, i1) : null;
            }
            evaluate(t1) {
                for (const [e1, r] of this.branches)if (e1.evaluate(t1)) return r.evaluate(t1);
                return this.otherwise.evaluate(t1);
            }
            eachChild(t1) {
                for (const [e1, r] of this.branches)t1(e1), t1(r);
                t1(this.otherwise);
            }
            outputDefined() {
                return this.branches.every(([t1, e1])=>e1.outputDefined()) && this.otherwise.outputDefined();
            }
            serialize() {
                const t1 = [
                    "case"
                ];
                return this.eachChild((e1)=>{
                    t1.push(e1.serialize());
                }), t1;
            }
        }
        var ln = on;
        class un {
            constructor(t1, e1, r, n){
                this.type = t1, this.input = e1, this.beginIndex = r, this.endIndex = n;
            }
            static parse(t1, e1) {
                if (t1.length <= 2 || t1.length >= 5) return e1.error(`Expected 3 or 4 arguments, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1, ue), n = e1.parse(t1[2], 2, ie);
                if (!r || !n) return null;
                if (!ge(r.type, [
                    fe(ue),
                    se,
                    ue
                ])) return e1.error(`Expected first argument to be of type array or string, but found ${de(r.type)} instead`);
                if (4 === t1.length) {
                    const i = e1.parse(t1[3], 3, ie);
                    return i ? new un(r.type, r, n, i) : null;
                }
                return new un(r.type, r, n);
            }
            evaluate(t1) {
                const e1 = this.input.evaluate(t1), r = this.beginIndex.evaluate(t1);
                if (!xe(e1, [
                    "string",
                    "array"
                ])) throw new Le(`Expected first argument to be of type array or string, but found ${de(Ce(e1))} instead.`);
                if (this.endIndex) {
                    const n = this.endIndex.evaluate(t1);
                    return e1.slice(r, n);
                }
                return e1.slice(r);
            }
            eachChild(t1) {
                t1(this.input), t1(this.beginIndex), this.endIndex && t1(this.endIndex);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                if (null != this.endIndex && void 0 !== this.endIndex) {
                    const t1 = this.endIndex.serialize();
                    return [
                        "slice",
                        this.input.serialize(),
                        this.beginIndex.serialize(),
                        t1
                    ];
                }
                return [
                    "slice",
                    this.input.serialize(),
                    this.beginIndex.serialize()
                ];
            }
        }
        var cn = un;
        function hn(t1, e1) {
            return "==" === t1 || "!=" === t1 ? "boolean" === e1.kind || "string" === e1.kind || "number" === e1.kind || "null" === e1.kind || "value" === e1.kind : "string" === e1.kind || "number" === e1.kind || "value" === e1.kind;
        }
        function pn(t1, e1, r, n) {
            return 0 === n.compare(e1, r);
        }
        function fn(t1, e1, r) {
            const n = "==" !== t1 && "!=" !== t1;
            return class i {
                constructor(t1, e1, r){
                    this.type = ae, this.lhs = t1, this.rhs = e1, this.collator = r, this.hasUntypedArgument = "value" === t1.type.kind || "value" === e1.type.kind;
                }
                static parse(t1, e1) {
                    if (3 !== t1.length && 4 !== t1.length) return e1.error("Expected two or three arguments.");
                    const r = t1[0];
                    let s = e1.parse(t1[1], 1, ue);
                    if (!s) return null;
                    if (!hn(r, s.type)) return e1.concat(1).error(`"${r}" comparisons are not supported for type '${de(s.type)}'.`);
                    let a = e1.parse(t1[2], 2, ue);
                    if (!a) return null;
                    if (!hn(r, a.type)) return e1.concat(2).error(`"${r}" comparisons are not supported for type '${de(a.type)}'.`);
                    if (s.type.kind !== a.type.kind && "value" !== s.type.kind && "value" !== a.type.kind) return e1.error(`Cannot compare types '${de(s.type)}' and '${de(a.type)}'.`);
                    n && ("value" === s.type.kind && "value" !== a.type.kind ? s = new je(a.type, [
                        s
                    ]) : "value" !== s.type.kind && "value" === a.type.kind && (a = new je(s.type, [
                        a
                    ])));
                    let o = null;
                    if (4 === t1.length) {
                        if ("string" !== s.type.kind && "string" !== a.type.kind && "value" !== s.type.kind && "value" !== a.type.kind) return e1.error("Cannot use collator to compare non-string types.");
                        if (o = e1.parse(t1[3], 3, ce), !o) return null;
                    }
                    return new i(s, a, o);
                }
                evaluate(i) {
                    const s = this.lhs.evaluate(i), a = this.rhs.evaluate(i);
                    if (n && this.hasUntypedArgument) {
                        const e2 = Ce(s), r1 = Ce(a);
                        if (e2.kind !== r1.kind || "string" !== e2.kind && "number" !== e2.kind) throw new Le(`Expected arguments for "${t1}" to be (string, string) or (number, number), but found (${e2.kind}, ${r1.kind}) instead.`);
                    }
                    if (this.collator && !n && this.hasUntypedArgument) {
                        const t2 = Ce(s), r2 = Ce(a);
                        if ("string" !== t2.kind || "string" !== r2.kind) return e1(i, s, a);
                    }
                    return this.collator ? r(i, s, a, this.collator.evaluate(i)) : e1(i, s, a);
                }
                eachChild(t1) {
                    t1(this.lhs), t1(this.rhs), this.collator && t1(this.collator);
                }
                outputDefined() {
                    return !0;
                }
                serialize() {
                    const e1 = [
                        t1
                    ];
                    return this.eachChild((t1)=>{
                        e1.push(t1.serialize());
                    }), e1;
                }
            };
        }
        const dn = fn("==", function(t1, e1, r) {
            return e1 === r;
        }, pn), yn = fn("!=", function(t1, e1, r) {
            return e1 !== r;
        }, function(t1, e1, r, n) {
            return !pn(0, e1, r, n);
        }), mn = fn("<", function(t1, e1, r) {
            return e1 < r;
        }, function(t1, e1, r, n) {
            return n.compare(e1, r) < 0;
        }), gn = fn(">", function(t1, e1, r) {
            return e1 > r;
        }, function(t1, e1, r, n) {
            return n.compare(e1, r) > 0;
        }), xn = fn("<=", function(t1, e1, r) {
            return e1 <= r;
        }, function(t1, e1, r, n) {
            return n.compare(e1, r) <= 0;
        }), vn = fn(">=", function(t1, e1, r) {
            return e1 >= r;
        }, function(t1, e1, r, n) {
            return n.compare(e1, r) >= 0;
        });
        class bn {
            constructor(t1, e1, r, n, i, s){
                this.type = se, this.number = t1, this.locale = e1, this.currency = r, this.unit = n, this.minFractionDigits = i, this.maxFractionDigits = s;
            }
            static parse(t1, e1) {
                if (3 !== t1.length) return e1.error("Expected two arguments.");
                const r = e1.parse(t1[1], 1, ie);
                if (!r) return null;
                const n = t1[2];
                if ("object" != typeof n || Array.isArray(n)) return e1.error("NumberFormat options argument must be an object.");
                let i = null;
                if (n.locale && (i = e1.parse(n.locale, 1, se), !i)) return null;
                let s = null;
                if (n.currency && (s = e1.parse(n.currency, 1, se), !s)) return null;
                let a = null;
                if (n.unit && (a = e1.parse(n.unit, 1, se), !a)) return null;
                let o = null;
                if (n["min-fraction-digits"] && (o = e1.parse(n["min-fraction-digits"], 1, ie), !o)) return null;
                let l = null;
                return n["max-fraction-digits"] && (l = e1.parse(n["max-fraction-digits"], 1, ie), !l) ? null : new bn(r, i, s, a, o, l);
            }
            evaluate(t1) {
                return new Intl.NumberFormat(this.locale ? this.locale.evaluate(t1) : [], {
                    style: (this.currency ? "currency" : this.unit && "unit") || "decimal",
                    currency: this.currency ? this.currency.evaluate(t1) : void 0,
                    unit: this.unit ? this.unit.evaluate(t1) : void 0,
                    minimumFractionDigits: this.minFractionDigits ? this.minFractionDigits.evaluate(t1) : void 0,
                    maximumFractionDigits: this.maxFractionDigits ? this.maxFractionDigits.evaluate(t1) : void 0
                }).format(this.number.evaluate(t1));
            }
            eachChild(t1) {
                t1(this.number), this.locale && t1(this.locale), this.currency && t1(this.currency), this.unit && t1(this.unit), this.minFractionDigits && t1(this.minFractionDigits), this.maxFractionDigits && t1(this.maxFractionDigits);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                const t1 = {};
                return this.locale && (t1.locale = this.locale.serialize()), this.currency && (t1.currency = this.currency.serialize()), this.unit && (t1.unit = this.unit.serialize()), this.minFractionDigits && (t1["min-fraction-digits"] = this.minFractionDigits.serialize()), this.maxFractionDigits && (t1["max-fraction-digits"] = this.maxFractionDigits.serialize()), [
                    "number-format",
                    this.number.serialize(),
                    t1
                ];
            }
        }
        class _n {
            constructor(t1){
                this.type = ie, this.input = t1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error(`Expected 1 argument, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1);
                return r ? "array" !== r.type.kind && "string" !== r.type.kind && "value" !== r.type.kind ? e1.error(`Expected argument of type string or array, but found ${de(r.type)} instead.`) : new _n(r) : null;
            }
            evaluate(t1) {
                const e1 = this.input.evaluate(t1);
                if ("string" == typeof e1) return e1.length;
                if (Array.isArray(e1)) return e1.length;
                throw new Le(`Expected value to be of type string or array, but found ${de(Ce(e1))} instead.`);
            }
            eachChild(t1) {
                t1(this.input);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                const t1 = [
                    "length"
                ];
                return this.eachChild((e1)=>{
                    t1.push(e1.serialize());
                }), t1;
            }
        }
        const wn = {
            "==": dn,
            "!=": yn,
            ">": gn,
            "<": mn,
            ">=": vn,
            "<=": xn,
            array: je,
            at: Qr,
            boolean: je,
            case: ln,
            coalesce: Hr,
            collator: Ye,
            format: $e,
            image: Oe,
            in: en,
            "index-of": nn,
            interpolate: Xr,
            "interpolate-hcl": Xr,
            "interpolate-lab": Xr,
            length: _n,
            let: Wr,
            literal: Fe,
            match: an,
            number: je,
            "number-format": bn,
            object: je,
            slice: cn,
            step: kr,
            string: je,
            "to-boolean": Ge,
            "to-color": Ge,
            "to-number": Ge,
            "to-string": Ge,
            var: vr,
            within: dr
        };
        function An(t1, [e1, r, n, i]) {
            e1 = e1.evaluate(t1), r = r.evaluate(t1), n = n.evaluate(t1);
            const s = i ? i.evaluate(t1) : 1, a = Ee(e1, r, n, s);
            if (a) throw new Le(a);
            return new Ie(e1 / 255 * s, r / 255 * s, n / 255 * s, s);
        }
        function Sn(t1, e1) {
            return t1 in e1;
        }
        function kn(t1, e1) {
            const r = e1[t1];
            return void 0 === r ? null : r;
        }
        function In(t1) {
            return {
                type: t1
            };
        }
        He.register(wn, {
            error: [
                {
                    kind: "error"
                },
                [
                    se
                ],
                (t1, [e1])=>{
                    throw new Le(e1.evaluate(t1));
                }
            ],
            typeof: [
                se,
                [
                    ue
                ],
                (t1, [e1])=>de(Ce(e1.evaluate(t1)))
            ],
            "to-rgba": [
                fe(ie, 4),
                [
                    oe
                ],
                (t1, [e1])=>e1.evaluate(t1).toArray()
            ],
            rgb: [
                oe,
                [
                    ie,
                    ie,
                    ie
                ],
                An
            ],
            rgba: [
                oe,
                [
                    ie,
                    ie,
                    ie,
                    ie
                ],
                An
            ],
            has: {
                type: ae,
                overloads: [
                    [
                        [
                            se
                        ],
                        (t1, [e1])=>Sn(e1.evaluate(t1), t1.properties())
                    ],
                    [
                        [
                            se,
                            le
                        ],
                        (t1, [e1, r])=>Sn(e1.evaluate(t1), r.evaluate(t1))
                    ]
                ]
            },
            get: {
                type: ue,
                overloads: [
                    [
                        [
                            se
                        ],
                        (t1, [e1])=>kn(e1.evaluate(t1), t1.properties())
                    ],
                    [
                        [
                            se,
                            le
                        ],
                        (t1, [e1, r])=>kn(e1.evaluate(t1), r.evaluate(t1))
                    ]
                ]
            },
            "feature-state": [
                ue,
                [
                    se
                ],
                (t1, [e1])=>kn(e1.evaluate(t1), t1.featureState || {})
            ],
            properties: [
                le,
                [],
                (t1)=>t1.properties()
            ],
            "geometry-type": [
                se,
                [],
                (t1)=>t1.geometryType()
            ],
            id: [
                ue,
                [],
                (t1)=>t1.id()
            ],
            zoom: [
                ie,
                [],
                (t1)=>t1.globals.zoom
            ],
            pitch: [
                ie,
                [],
                (t1)=>t1.globals.pitch || 0
            ],
            "distance-from-center": [
                ie,
                [],
                (t1)=>t1.distanceFromCenter()
            ],
            "heatmap-density": [
                ie,
                [],
                (t1)=>t1.globals.heatmapDensity || 0
            ],
            "line-progress": [
                ie,
                [],
                (t1)=>t1.globals.lineProgress || 0
            ],
            "sky-radial-progress": [
                ie,
                [],
                (t1)=>t1.globals.skyRadialProgress || 0
            ],
            accumulated: [
                ue,
                [],
                (t1)=>void 0 === t1.globals.accumulated ? null : t1.globals.accumulated
            ],
            "+": [
                ie,
                In(ie),
                (t1, e1)=>{
                    let r = 0;
                    for (const n of e1)r += n.evaluate(t1);
                    return r;
                }
            ],
            "*": [
                ie,
                In(ie),
                (t1, e1)=>{
                    let r = 1;
                    for (const n of e1)r *= n.evaluate(t1);
                    return r;
                }
            ],
            "-": {
                type: ie,
                overloads: [
                    [
                        [
                            ie,
                            ie
                        ],
                        (t1, [e1, r])=>e1.evaluate(t1) - r.evaluate(t1)
                    ],
                    [
                        [
                            ie
                        ],
                        (t1, [e1])=>-e1.evaluate(t1)
                    ]
                ]
            },
            "/": [
                ie,
                [
                    ie,
                    ie
                ],
                (t1, [e1, r])=>e1.evaluate(t1) / r.evaluate(t1)
            ],
            "%": [
                ie,
                [
                    ie,
                    ie
                ],
                (t1, [e1, r])=>e1.evaluate(t1) % r.evaluate(t1)
            ],
            ln2: [
                ie,
                [],
                ()=>Math.LN2
            ],
            pi: [
                ie,
                [],
                ()=>Math.PI
            ],
            e: [
                ie,
                [],
                ()=>Math.E
            ],
            "^": [
                ie,
                [
                    ie,
                    ie
                ],
                (t1, [e1, r])=>Math.pow(e1.evaluate(t1), r.evaluate(t1))
            ],
            sqrt: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.sqrt(e1.evaluate(t1))
            ],
            log10: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.log(e1.evaluate(t1)) / Math.LN10
            ],
            ln: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.log(e1.evaluate(t1))
            ],
            log2: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.log(e1.evaluate(t1)) / Math.LN2
            ],
            sin: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.sin(e1.evaluate(t1))
            ],
            cos: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.cos(e1.evaluate(t1))
            ],
            tan: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.tan(e1.evaluate(t1))
            ],
            asin: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.asin(e1.evaluate(t1))
            ],
            acos: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.acos(e1.evaluate(t1))
            ],
            atan: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.atan(e1.evaluate(t1))
            ],
            min: [
                ie,
                In(ie),
                (t1, e1)=>Math.min(...e1.map((e1)=>e1.evaluate(t1)))
            ],
            max: [
                ie,
                In(ie),
                (t1, e1)=>Math.max(...e1.map((e1)=>e1.evaluate(t1)))
            ],
            abs: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.abs(e1.evaluate(t1))
            ],
            round: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>{
                    const r = e1.evaluate(t1);
                    return r < 0 ? -Math.round(-r) : Math.round(r);
                }
            ],
            floor: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.floor(e1.evaluate(t1))
            ],
            ceil: [
                ie,
                [
                    ie
                ],
                (t1, [e1])=>Math.ceil(e1.evaluate(t1))
            ],
            "filter-==": [
                ae,
                [
                    se,
                    ue
                ],
                (t1, [e1, r])=>t1.properties()[e1.value] === r.value
            ],
            "filter-id-==": [
                ae,
                [
                    ue
                ],
                (t1, [e1])=>t1.id() === e1.value
            ],
            "filter-type-==": [
                ae,
                [
                    se
                ],
                (t1, [e1])=>t1.geometryType() === e1.value
            ],
            "filter-<": [
                ae,
                [
                    se,
                    ue
                ],
                (t1, [e1, r])=>{
                    const n = t1.properties()[e1.value], i = r.value;
                    return typeof n == typeof i && n < i;
                }
            ],
            "filter-id-<": [
                ae,
                [
                    ue
                ],
                (t1, [e1])=>{
                    const r = t1.id(), n = e1.value;
                    return typeof r == typeof n && r < n;
                }
            ],
            "filter->": [
                ae,
                [
                    se,
                    ue
                ],
                (t1, [e1, r])=>{
                    const n = t1.properties()[e1.value], i = r.value;
                    return typeof n == typeof i && n > i;
                }
            ],
            "filter-id->": [
                ae,
                [
                    ue
                ],
                (t1, [e1])=>{
                    const r = t1.id(), n = e1.value;
                    return typeof r == typeof n && r > n;
                }
            ],
            "filter-<=": [
                ae,
                [
                    se,
                    ue
                ],
                (t1, [e1, r])=>{
                    const n = t1.properties()[e1.value], i = r.value;
                    return typeof n == typeof i && n <= i;
                }
            ],
            "filter-id-<=": [
                ae,
                [
                    ue
                ],
                (t1, [e1])=>{
                    const r = t1.id(), n = e1.value;
                    return typeof r == typeof n && r <= n;
                }
            ],
            "filter->=": [
                ae,
                [
                    se,
                    ue
                ],
                (t1, [e1, r])=>{
                    const n = t1.properties()[e1.value], i = r.value;
                    return typeof n == typeof i && n >= i;
                }
            ],
            "filter-id->=": [
                ae,
                [
                    ue
                ],
                (t1, [e1])=>{
                    const r = t1.id(), n = e1.value;
                    return typeof r == typeof n && r >= n;
                }
            ],
            "filter-has": [
                ae,
                [
                    ue
                ],
                (t1, [e1])=>e1.value in t1.properties()
            ],
            "filter-has-id": [
                ae,
                [],
                (t1)=>null !== t1.id() && void 0 !== t1.id()
            ],
            "filter-type-in": [
                ae,
                [
                    fe(se)
                ],
                (t1, [e1])=>e1.value.indexOf(t1.geometryType()) >= 0
            ],
            "filter-id-in": [
                ae,
                [
                    fe(ue)
                ],
                (t1, [e1])=>e1.value.indexOf(t1.id()) >= 0
            ],
            "filter-in-small": [
                ae,
                [
                    se,
                    fe(ue)
                ],
                (t1, [e1, r])=>r.value.indexOf(t1.properties()[e1.value]) >= 0
            ],
            "filter-in-large": [
                ae,
                [
                    se,
                    fe(ue)
                ],
                (t1, [e1, r])=>(function(t1, e1, r, n) {
                        for(; r <= n;){
                            const i = r + n >> 1;
                            if (e1[i] === t1) return !0;
                            e1[i] > t1 ? n = i - 1 : r = i + 1;
                        }
                        return !1;
                    })(t1.properties()[e1.value], r.value, 0, r.value.length - 1)
            ],
            all: {
                type: ae,
                overloads: [
                    [
                        [
                            ae,
                            ae
                        ],
                        (t1, [e1, r])=>e1.evaluate(t1) && r.evaluate(t1)
                    ],
                    [
                        In(ae),
                        (t1, e1)=>{
                            for (const r of e1)if (!r.evaluate(t1)) return !1;
                            return !0;
                        }
                    ]
                ]
            },
            any: {
                type: ae,
                overloads: [
                    [
                        [
                            ae,
                            ae
                        ],
                        (t1, [e1, r])=>e1.evaluate(t1) || r.evaluate(t1)
                    ],
                    [
                        In(ae),
                        (t1, e1)=>{
                            for (const r of e1)if (r.evaluate(t1)) return !0;
                            return !1;
                        }
                    ]
                ]
            },
            "!": [
                ae,
                [
                    ae
                ],
                (t1, [e1])=>!e1.evaluate(t1)
            ],
            "is-supported-script": [
                ae,
                [
                    se
                ],
                (t1, [e1])=>{
                    const r = t1.globals && t1.globals.isSupportedScript;
                    return !r || r(e1.evaluate(t1));
                }
            ],
            upcase: [
                se,
                [
                    se
                ],
                (t1, [e1])=>e1.evaluate(t1).toUpperCase()
            ],
            downcase: [
                se,
                [
                    se
                ],
                (t1, [e1])=>e1.evaluate(t1).toLowerCase()
            ],
            concat: [
                se,
                In(ue),
                (t1, e1)=>e1.map((e1)=>De(e1.evaluate(t1))).join("")
            ],
            "resolved-locale": [
                se,
                [
                    ce
                ],
                (t1, [e1])=>e1.evaluate(t1).resolvedLocale()
            ]
        });
        var Mn = wn;
        function zn(t1) {
            return {
                result: "success",
                value: t1
            };
        }
        function Tn(t1) {
            return {
                result: "error",
                value: t1
            };
        }
        function Bn(t1) {
            return "data-driven" === t1["property-type"] || "cross-faded-data-driven" === t1["property-type"];
        }
        function En(t1) {
            return !!t1.expression && t1.expression.parameters.indexOf("zoom") > -1;
        }
        function Pn(t1) {
            return !!t1.expression && t1.expression.interpolated;
        }
        function Cn(t1) {
            return t1 instanceof Number ? "number" : t1 instanceof String ? "string" : t1 instanceof Boolean ? "boolean" : Array.isArray(t1) ? "array" : null === t1 ? "null" : typeof t1;
        }
        function Dn(t1) {
            return "object" == typeof t1 && null !== t1 && !Array.isArray(t1);
        }
        function Vn(t1) {
            return t1;
        }
        function Fn(t1, e1) {
            const r = "color" === e1.type, n = t1.stops && "object" == typeof t1.stops[0][0], i = n || !(n || void 0 !== t1.property), s = t1.type || (Pn(e1) ? "exponential" : "interval");
            if (r && ((t1 = Yt({}, t1)).stops && (t1.stops = t1.stops.map((t1)=>[
                    t1[0],
                    Ie.parse(t1[1])
                ])), t1.default = Ie.parse(t1.default ? t1.default : e1.default)), t1.colorSpace && "rgb" !== t1.colorSpace && !Nr[t1.colorSpace]) throw new Error(`Unknown color space: ${t1.colorSpace}`);
            let a, o, l;
            if ("exponential" === s) a = jn;
            else if ("interval" === s) a = Un;
            else if ("categorical" === s) {
                a = Rn, o = Object.create(null);
                for (const e2 of t1.stops)o[e2[0]] = e2[1];
                l = typeof t1.stops[0][0];
            } else {
                if ("identity" !== s) throw new Error(`Unknown function type "${s}"`);
                a = $n;
            }
            if (n) {
                const r1 = {}, n1 = [];
                for(let e3 = 0; e3 < t1.stops.length; e3++){
                    const i1 = t1.stops[e3], s1 = i1[0].zoom;
                    void 0 === r1[s1] && (r1[s1] = {
                        zoom: s1,
                        type: t1.type,
                        property: t1.property,
                        default: t1.default,
                        stops: []
                    }, n1.push(s1)), r1[s1].stops.push([
                        i1[0].value,
                        i1[1]
                    ]);
                }
                const i2 = [];
                for (const t2 of n1)i2.push([
                    r1[t2].zoom,
                    Fn(r1[t2], e1)
                ]);
                const s2 = {
                    name: "linear"
                };
                return {
                    kind: "composite",
                    interpolationType: s2,
                    interpolationFactor: Xr.interpolationFactor.bind(void 0, s2),
                    zoomStops: i2.map((t1)=>t1[0]),
                    evaluate: ({ zoom: r  }, n)=>jn({
                            stops: i2,
                            base: t1.base
                        }, e1, r).evaluate(r, n)
                };
            }
            if (i) {
                const r2 = "exponential" === s ? {
                    name: "exponential",
                    base: void 0 !== t1.base ? t1.base : 1
                } : null;
                return {
                    kind: "camera",
                    interpolationType: r2,
                    interpolationFactor: Xr.interpolationFactor.bind(void 0, r2),
                    zoomStops: t1.stops.map((t1)=>t1[0]),
                    evaluate: ({ zoom: r  })=>a(t1, e1, r, o, l)
                };
            }
            return {
                kind: "source",
                evaluate (r, n) {
                    const i = n && n.properties ? n.properties[t1.property] : void 0;
                    return void 0 === i ? Ln(t1.default, e1.default) : a(t1, e1, i, o, l);
                }
            };
        }
        function Ln(t1, e1, r) {
            return void 0 !== t1 ? t1 : void 0 !== e1 ? e1 : void 0 !== r ? r : void 0;
        }
        function Rn(t1, e1, r, n, i) {
            return Ln(typeof r === i ? n[r] : void 0, t1.default, e1.default);
        }
        function Un(t1, e1, r) {
            if ("number" !== Cn(r)) return Ln(t1.default, e1.default);
            const n = t1.stops.length;
            if (1 === n) return t1.stops[0][1];
            if (r <= t1.stops[0][0]) return t1.stops[0][1];
            if (r >= t1.stops[n - 1][0]) return t1.stops[n - 1][1];
            const i = Ar(t1.stops.map((t1)=>t1[0]), r);
            return t1.stops[i][1];
        }
        function jn(t1, e1, r) {
            const n = void 0 !== t1.base ? t1.base : 1;
            if ("number" !== Cn(r)) return Ln(t1.default, e1.default);
            const i = t1.stops.length;
            if (1 === i) return t1.stops[0][1];
            if (r <= t1.stops[0][0]) return t1.stops[0][1];
            if (r >= t1.stops[i - 1][0]) return t1.stops[i - 1][1];
            const s = Ar(t1.stops.map((t1)=>t1[0]), r), a = function(t1, e1, r, n) {
                const i = n - r, s = t1 - r;
                return 0 === i ? 0 : 1 === e1 ? s / i : (Math.pow(e1, s) - 1) / (Math.pow(e1, i) - 1);
            }(r, n, t1.stops[s][0], t1.stops[s + 1][0]), o = t1.stops[s][1], l = t1.stops[s + 1][1];
            let u = Mr[e1.type] || Vn;
            if (t1.colorSpace && "rgb" !== t1.colorSpace) {
                const e2 = Nr[t1.colorSpace];
                u = (t1, r)=>e2.reverse(e2.interpolate(e2.forward(t1), e2.forward(r), a));
            }
            return "function" == typeof o.evaluate ? {
                evaluate (...t1) {
                    const e1 = o.evaluate.apply(void 0, t1), r = l.evaluate.apply(void 0, t1);
                    if (void 0 !== e1 && void 0 !== r) return u(e1, r, a);
                }
            } : u(o, l, a);
        }
        function $n(t1, e1, r) {
            return "color" === e1.type ? r = Ie.parse(r) : "formatted" === e1.type ? r = Te.fromString(r.toString()) : "resolvedImage" === e1.type ? r = Be.fromString(r.toString()) : Cn(r) === e1.type || "enum" === e1.type && e1.values[r] || (r = void 0), Ln(r, t1.default, e1.default);
        }
        class On {
            constructor(t1, e1){
                this.expression = t1, this._warningHistory = {}, this._evaluator = new Xe, this._defaultValue = e1 ? function(t1) {
                    return "color" === t1.type && (Dn(t1.default) || Array.isArray(t1.default)) ? new Ie(0, 0, 0, 0) : "color" === t1.type ? Ie.parse(t1.default) || null : void 0 === t1.default ? null : t1.default;
                }(e1) : null, this._enumValues = e1 && "enum" === e1.type ? e1.values : null;
            }
            evaluateWithoutErrorHandling(t1, e1, r, n, i, s, a, o) {
                return this._evaluator.globals = t1, this._evaluator.feature = e1, this._evaluator.featureState = r, this._evaluator.canonical = n || null, this._evaluator.availableImages = i || null, this._evaluator.formattedSection = s, this._evaluator.featureTileCoord = a || null, this._evaluator.featureDistanceData = o || null, this.expression.evaluate(this._evaluator);
            }
            evaluate(t1, e1, r, n, i, s, a, o) {
                this._evaluator.globals = t1, this._evaluator.feature = e1 || null, this._evaluator.featureState = r || null, this._evaluator.canonical = n || null, this._evaluator.availableImages = i || null, this._evaluator.formattedSection = s || null, this._evaluator.featureTileCoord = a || null, this._evaluator.featureDistanceData = o || null;
                try {
                    const t2 = this.expression.evaluate(this._evaluator);
                    if (null == t2 || "number" == typeof t2 && t2 != t2) return this._defaultValue;
                    if (this._enumValues && !(t2 in this._enumValues)) throw new Le(`Expected value to be one of ${Object.keys(this._enumValues).map((t1)=>JSON.stringify(t1)).join(", ")}, but found ${JSON.stringify(t2)} instead.`);
                    return t2;
                } catch (t3) {
                    return this._warningHistory[t3.message] || (this._warningHistory[t3.message] = !0, "undefined" != typeof console && console.warn(t3.message)), this._defaultValue;
                }
            }
        }
        function qn(t1) {
            return Array.isArray(t1) && t1.length > 0 && "string" == typeof t1[0] && t1[0] in Mn;
        }
        function Nn(t1, e1) {
            const r = new _r(Mn, [], e1 ? function(t1) {
                const e1 = {
                    color: oe,
                    string: se,
                    number: ie,
                    enum: se,
                    boolean: ae,
                    formatted: he,
                    resolvedImage: pe
                };
                return "array" === t1.type ? fe(e1[t1.value] || ue, t1.length) : e1[t1.type];
            }(e1) : void 0), n = r.parse(t1, void 0, void 0, void 0, e1 && "string" === e1.type ? {
                typeAnnotation: "coerce"
            } : void 0);
            return n ? zn(new On(n, e1)) : Tn(r.errors);
        }
        class Gn {
            constructor(t1, e1){
                this.kind = t1, this._styleExpression = e1, this.isStateDependent = "constant" !== t1 && !mr(e1.expression);
            }
            evaluateWithoutErrorHandling(t1, e1, r, n, i, s) {
                return this._styleExpression.evaluateWithoutErrorHandling(t1, e1, r, n, i, s);
            }
            evaluate(t1, e1, r, n, i, s) {
                return this._styleExpression.evaluate(t1, e1, r, n, i, s);
            }
        }
        class Zn {
            constructor(t1, e1, r, n){
                this.kind = t1, this.zoomStops = r, this._styleExpression = e1, this.isStateDependent = "camera" !== t1 && !mr(e1.expression), this.interpolationType = n;
            }
            evaluateWithoutErrorHandling(t1, e1, r, n, i, s) {
                return this._styleExpression.evaluateWithoutErrorHandling(t1, e1, r, n, i, s);
            }
            evaluate(t1, e1, r, n, i, s) {
                return this._styleExpression.evaluate(t1, e1, r, n, i, s);
            }
            interpolationFactor(t1, e1, r) {
                return this.interpolationType ? Xr.interpolationFactor(this.interpolationType, t1, e1, r) : 0;
            }
        }
        function Xn(t1, e1) {
            if ("error" === (t1 = Nn(t1, e1)).result) return t1;
            const r = t1.value.expression, n = yr(r);
            if (!n && !Bn(e1)) return Tn([
                new te("", "data expressions not supported")
            ]);
            const i = gr(r, [
                "zoom",
                "pitch",
                "distance-from-center"
            ]);
            if (!i && !En(e1)) return Tn([
                new te("", "zoom expressions not supported")
            ]);
            const s = Hn(r);
            return s || i ? s instanceof te ? Tn([
                s
            ]) : s instanceof Xr && !Pn(e1) ? Tn([
                new te("", '"interpolate" expressions cannot be used with this property')
            ]) : zn(s ? new Zn(n ? "camera" : "composite", t1.value, s.labels, s instanceof Xr ? s.interpolation : void 0) : new Gn(n ? "constant" : "source", t1.value)) : Tn([
                new te("", '"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.')
            ]);
        }
        class Kn {
            constructor(t1, e1){
                this._parameters = t1, this._specification = e1, Yt(this, Fn(this._parameters, this._specification));
            }
            static deserialize(t1) {
                return new Kn(t1._parameters, t1._specification);
            }
            static serialize(t1) {
                return {
                    _parameters: t1._parameters,
                    _specification: t1._specification
                };
            }
        }
        function Hn(t1) {
            let e1 = null;
            if (t1 instanceof Wr) e1 = Hn(t1.result);
            else if (t1 instanceof Hr) {
                for (const r of t1.args)if (e1 = Hn(r), e1) break;
            } else (t1 instanceof kr || t1 instanceof Xr) && t1.input instanceof He && "zoom" === t1.input.name && (e1 = t1);
            return e1 instanceof te || t1.eachChild((t1)=>{
                const r = Hn(t1);
                r instanceof te ? e1 = r : !e1 && r ? e1 = new te("", '"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.') : e1 && r && e1 !== r && (e1 = new te("", 'Only one zoom-based "step" or "interpolate" subexpression may be used in an expression.'));
            }), e1;
        }
        class Yn {
            constructor(t1, e1, r, n){
                this.message = (t1 ? `${t1}: ` : "") + r, n && (this.identifier = n), null != e1 && e1.__line__ && (this.line = e1.__line__);
            }
        }
        function Wn(t1) {
            const e1 = t1.key, r = t1.value, n = t1.valueSpec || {}, i = t1.objectElementValidators || {}, s = t1.style, a = t1.styleSpec;
            let o = [];
            const l = Cn(r);
            if ("object" !== l) return [
                new Yn(e1, r, `object expected, ${l} found`)
            ];
            for(const t2 in r){
                const l1 = t2.split(".")[0], u = n[l1] || n["*"];
                let c;
                i[l1] ? c = i[l1] : n[l1] ? c = Bi : i["*"] ? c = i["*"] : n["*"] && (c = Bi), c ? o = o.concat(c({
                    key: (e1 ? `${e1}.` : e1) + t2,
                    value: r[t2],
                    valueSpec: u,
                    style: s,
                    styleSpec: a,
                    object: r,
                    objectKey: t2
                }, r)) : o.push(new Yn(e1, r[t2], `unknown property "${t2}"`));
            }
            for(const t3 in n)i[t3] || n[t3].required && void 0 === n[t3].default && void 0 === r[t3] && o.push(new Yn(e1, r, `missing required property "${t3}"`));
            return o;
        }
        function Jn(t1) {
            const e1 = t1.value, r = t1.valueSpec, n = t1.style, i = t1.styleSpec, s = t1.key, a = t1.arrayElementValidator || Bi;
            if ("array" !== Cn(e1)) return [
                new Yn(s, e1, `array expected, ${Cn(e1)} found`)
            ];
            if (r.length && e1.length !== r.length) return [
                new Yn(s, e1, `array length ${r.length} expected, length ${e1.length} found`)
            ];
            if (r["min-length"] && e1.length < r["min-length"]) return [
                new Yn(s, e1, `array length at least ${r["min-length"]} expected, length ${e1.length} found`)
            ];
            let o = {
                type: r.value,
                values: r.values,
                minimum: r.minimum,
                maximum: r.maximum,
                function: void 0
            };
            i.$version < 7 && (o.function = r.function), "object" === Cn(r.value) && (o = r.value);
            let l = [];
            for(let t2 = 0; t2 < e1.length; t2++)l = l.concat(a({
                array: e1,
                arrayIndex: t2,
                value: e1[t2],
                valueSpec: o,
                style: n,
                styleSpec: i,
                key: `${s}[${t2}]`
            }));
            return l;
        }
        function Qn(t1) {
            const e1 = t1.key, r = t1.value, n = t1.valueSpec;
            let i = Cn(r);
            if ("number" === i && r != r && (i = "NaN"), "number" !== i) return [
                new Yn(e1, r, `number expected, ${i} found`)
            ];
            if ("minimum" in n) {
                let i1 = n.minimum;
                if ("array" === Cn(n.minimum) && (i1 = n.minimum[t1.arrayIndex]), r < i1) return [
                    new Yn(e1, r, `${r} is less than the minimum value ${i1}`)
                ];
            }
            if ("maximum" in n) {
                let i2 = n.maximum;
                if ("array" === Cn(n.maximum) && (i2 = n.maximum[t1.arrayIndex]), r > i2) return [
                    new Yn(e1, r, `${r} is greater than the maximum value ${i2}`)
                ];
            }
            return [];
        }
        function ti(t1) {
            const e1 = t1.valueSpec, r = Wt(t1.value.type);
            let n, i, s, a = {};
            const o = "categorical" !== r && void 0 === t1.value.property, l = !o, u = "array" === Cn(t1.value.stops) && "array" === Cn(t1.value.stops[0]) && "object" === Cn(t1.value.stops[0][0]), c = Wn({
                key: t1.key,
                value: t1.value,
                valueSpec: t1.styleSpec.function,
                style: t1.style,
                styleSpec: t1.styleSpec,
                objectElementValidators: {
                    stops: function(t1) {
                        if ("identity" === r) return [
                            new Yn(t1.key, t1.value, 'identity function may not have a "stops" property')
                        ];
                        let e1 = [];
                        const n = t1.value;
                        return e1 = e1.concat(Jn({
                            key: t1.key,
                            value: n,
                            valueSpec: t1.valueSpec,
                            style: t1.style,
                            styleSpec: t1.styleSpec,
                            arrayElementValidator: h
                        })), "array" === Cn(n) && 0 === n.length && e1.push(new Yn(t1.key, n, "array must have at least one stop")), e1;
                    },
                    default: function(t1) {
                        return Bi({
                            key: t1.key,
                            value: t1.value,
                            valueSpec: e1,
                            style: t1.style,
                            styleSpec: t1.styleSpec
                        });
                    }
                }
            });
            return "identity" === r && o && c.push(new Yn(t1.key, t1.value, 'missing required property "property"')), "identity" === r || t1.value.stops || c.push(new Yn(t1.key, t1.value, 'missing required property "stops"')), "exponential" === r && t1.valueSpec.expression && !Pn(t1.valueSpec) && c.push(new Yn(t1.key, t1.value, "exponential functions not supported")), t1.styleSpec.$version >= 8 && (l && !Bn(t1.valueSpec) ? c.push(new Yn(t1.key, t1.value, "property functions not supported")) : o && !En(t1.valueSpec) && c.push(new Yn(t1.key, t1.value, "zoom functions not supported"))), "categorical" !== r && !u || void 0 !== t1.value.property || c.push(new Yn(t1.key, t1.value, '"property" property is required')), c;
            function h(t1) {
                let r = [];
                const n = t1.value, o = t1.key;
                if ("array" !== Cn(n)) return [
                    new Yn(o, n, `array expected, ${Cn(n)} found`)
                ];
                if (2 !== n.length) return [
                    new Yn(o, n, `array length 2 expected, length ${n.length} found`)
                ];
                if (u) {
                    if ("object" !== Cn(n[0])) return [
                        new Yn(o, n, `object expected, ${Cn(n[0])} found`)
                    ];
                    if (void 0 === n[0].zoom) return [
                        new Yn(o, n, "object stop key must have zoom")
                    ];
                    if (void 0 === n[0].value) return [
                        new Yn(o, n, "object stop key must have value")
                    ];
                    const e2 = Wt(n[0].zoom);
                    if ("number" != typeof e2) return [
                        new Yn(o, n[0].zoom, "stop zoom values must be numbers")
                    ];
                    if (s && s > e2) return [
                        new Yn(o, n[0].zoom, "stop zoom values must appear in ascending order")
                    ];
                    e2 !== s && (s = e2, i = void 0, a = {}), r = r.concat(Wn({
                        key: `${o}[0]`,
                        value: n[0],
                        valueSpec: {
                            zoom: {}
                        },
                        style: t1.style,
                        styleSpec: t1.styleSpec,
                        objectElementValidators: {
                            zoom: Qn,
                            value: p
                        }
                    }));
                } else r = r.concat(p({
                    key: `${o}[0]`,
                    value: n[0],
                    valueSpec: {},
                    style: t1.style,
                    styleSpec: t1.styleSpec
                }, n));
                return qn(Jt(n[1])) ? r.concat([
                    new Yn(`${o}[1]`, n[1], "expressions are not allowed in function stops.")
                ]) : r.concat(Bi({
                    key: `${o}[1]`,
                    value: n[1],
                    valueSpec: e1,
                    style: t1.style,
                    styleSpec: t1.styleSpec
                }));
            }
            function p(t1, s) {
                const o = Cn(t1.value), l = Wt(t1.value), u = null !== t1.value ? t1.value : s;
                if (n) {
                    if (o !== n) return [
                        new Yn(t1.key, u, `${o} stop domain type must match previous stop domain type ${n}`)
                    ];
                } else n = o;
                if ("number" !== o && "string" !== o && "boolean" !== o && "number" != typeof l && "string" != typeof l && "boolean" != typeof l) return [
                    new Yn(t1.key, u, "stop domain value must be a number, string, or boolean")
                ];
                if ("number" !== o && "categorical" !== r) {
                    let n1 = `number expected, ${o} found`;
                    return Bn(e1) && void 0 === r && (n1 += '\nIf you intended to use a categorical function, specify `"type": "categorical"`.'), [
                        new Yn(t1.key, u, n1)
                    ];
                }
                return "categorical" !== r || "number" !== o || "number" == typeof l && isFinite(l) && Math.floor(l) === l ? "categorical" !== r && "number" === o && "number" == typeof l && "number" == typeof i && void 0 !== i && l < i ? [
                    new Yn(t1.key, u, "stop domain values must appear in ascending order")
                ] : (i = l, "categorical" === r && l in a ? [
                    new Yn(t1.key, u, "stop domain values must be unique")
                ] : (a[l] = !0, [])) : [
                    new Yn(t1.key, u, `integer expected, found ${String(l)}`)
                ];
            }
        }
        function ei(t1) {
            const e1 = ("property" === t1.expressionContext ? Xn : Nn)(Jt(t1.value), t1.valueSpec);
            if ("error" === e1.result) return e1.value.map((e1)=>new Yn(`${t1.key}${e1.key}`, t1.value, e1.message));
            const r = e1.value.expression || e1.value._styleExpression.expression;
            if ("property" === t1.expressionContext && "text-font" === t1.propertyKey && !r.outputDefined()) return [
                new Yn(t1.key, t1.value, `Invalid data expression for "${t1.propertyKey}". Output values must be contained as literals within the expression.`)
            ];
            if ("property" === t1.expressionContext && "layout" === t1.propertyType && !mr(r)) return [
                new Yn(t1.key, t1.value, '"feature-state" data expressions are not supported with layout properties.')
            ];
            if ("filter" === t1.expressionContext) return ri(r, t1);
            if (t1.expressionContext && 0 === t1.expressionContext.indexOf("cluster")) {
                if (!gr(r, [
                    "zoom",
                    "feature-state"
                ])) return [
                    new Yn(t1.key, t1.value, '"zoom" and "feature-state" expressions are not supported with cluster properties.')
                ];
                if ("cluster-initial" === t1.expressionContext && !yr(r)) return [
                    new Yn(t1.key, t1.value, "Feature data expressions are not supported with initial expression part of cluster properties.")
                ];
            }
            return [];
        }
        function ri(t1, e1) {
            const r = new Set([
                "zoom",
                "feature-state",
                "pitch",
                "distance-from-center"
            ]);
            if (e1.valueSpec && e1.valueSpec.expression) for (const t2 of e1.valueSpec.expression.parameters)r.delete(t2);
            if (0 === r.size) return [];
            const n = [];
            return t1 instanceof He && r.has(t1.name) ? [
                new Yn(e1.key, e1.value, `["${t1.name}"] expression is not supported in a filter for a ${e1.object.type} layer with id: ${e1.object.id}`)
            ] : (t1.eachChild((t1)=>{
                n.push(...ri(t1, e1));
            }), n);
        }
        function ni(t1) {
            const e1 = t1.key, r = t1.value, n = t1.valueSpec, i = [];
            return Array.isArray(n.values) ? -1 === n.values.indexOf(Wt(r)) && i.push(new Yn(e1, r, `expected one of [${n.values.join(", ")}], ${JSON.stringify(r)} found`)) : -1 === Object.keys(n.values).indexOf(Wt(r)) && i.push(new Yn(e1, r, `expected one of [${Object.keys(n.values).join(", ")}], ${JSON.stringify(r)} found`)), i;
        }
        function ii(t1) {
            if (!0 === t1 || !1 === t1) return !0;
            if (!Array.isArray(t1) || 0 === t1.length) return !1;
            switch(t1[0]){
                case "has":
                    return t1.length >= 2 && "$id" !== t1[1] && "$type" !== t1[1];
                case "in":
                    return t1.length >= 3 && ("string" != typeof t1[1] || Array.isArray(t1[2]));
                case "!in":
                case "!has":
                case "none":
                    return !1;
                case "==":
                case "!=":
                case ">":
                case ">=":
                case "<":
                case "<=":
                    return 3 !== t1.length || Array.isArray(t1[1]) || Array.isArray(t1[2]);
                case "any":
                case "all":
                    for (const e1 of t1.slice(1))if (!ii(e1) && "boolean" != typeof e1) return !1;
                    return !0;
                default:
                    return !0;
            }
        }
        function si(t1, e1 = "fill") {
            if (null == t1) return {
                filter: ()=>!0,
                needGeometry: !1,
                needFeature: !1
            };
            ii(t1) || (t1 = pi(t1));
            const r = t1;
            let n = !0;
            try {
                n = function(t1) {
                    if (!li(t1)) return t1;
                    let e1 = Jt(t1);
                    return oi(e1), e1 = ai(e1), e1;
                }(r);
            } catch (t2) {
                console.warn(`Failed to extract static filter. Filter will continue working, but at higher memory usage and slower framerate.\nThis is most likely a bug, please report this via https://github.com/mapbox/mapbox-gl-js/issues/new?assignees=&labels=&template=Bug_report.md\nand paste the contents of this message in the report.\nThank you!\nFilter Expression:\n${JSON.stringify(r, null, 2)}\n        `);
            }
            const i = Ht[`filter_${e1}`], s = Nn(n, i);
            let a = null;
            if ("error" === s.result) throw new Error(s.value.map((t1)=>`${t1.key}: ${t1.message}`).join(", "));
            a = (t1, e1, r)=>s.value.evaluate(t1, e1, {}, r);
            let o = null, l = null;
            if (n !== r) {
                const t3 = Nn(r, i);
                if ("error" === t3.result) throw new Error(t3.value.map((t1)=>`${t1.key}: ${t1.message}`).join(", "));
                o = (e1, r, n, i, s)=>t3.value.evaluate(e1, r, {}, n, void 0, void 0, i, s), l = !yr(t3.value.expression);
            }
            return {
                filter: a,
                dynamicFilter: o || void 0,
                needGeometry: hi(n),
                needFeature: !!l
            };
        }
        function ai(t1) {
            if (!Array.isArray(t1)) return t1;
            const e1 = function(t1) {
                if (ui.has(t1[0])) {
                    for(let e1 = 1; e1 < t1.length; e1++)if (li(t1[e1])) return !0;
                }
                return t1;
            }(t1);
            return !0 === e1 ? e1 : e1.map((t1)=>ai(t1));
        }
        function oi(t1) {
            let e1 = !1;
            const r = [];
            if ("case" === t1[0]) {
                for(let n = 1; n < t1.length - 1; n += 2)e1 = e1 || li(t1[n]), r.push(t1[n + 1]);
                r.push(t1[t1.length - 1]);
            } else if ("match" === t1[0]) {
                e1 = e1 || li(t1[1]);
                for(let e2 = 2; e2 < t1.length - 1; e2 += 2)r.push(t1[e2 + 1]);
                r.push(t1[t1.length - 1]);
            } else if ("step" === t1[0]) {
                e1 = e1 || li(t1[1]);
                for(let e3 = 1; e3 < t1.length - 1; e3 += 2)r.push(t1[e3 + 1]);
            }
            e1 && (t1.length = 0, t1.push("any", ...r));
            for(let e4 = 1; e4 < t1.length; e4++)oi(t1[e4]);
        }
        function li(t1) {
            if (!Array.isArray(t1)) return !1;
            if ("pitch" === (e1 = t1[0]) || "distance-from-center" === e1) return !0;
            var e1;
            for(let e2 = 1; e2 < t1.length; e2++)if (li(t1[e2])) return !0;
            return !1;
        }
        const ui = new Set([
            "in",
            "==",
            "!=",
            ">",
            ">=",
            "<",
            "<=",
            "to-boolean"
        ]);
        function ci(t1, e1) {
            return t1 < e1 ? -1 : t1 > e1 ? 1 : 0;
        }
        function hi(t1) {
            if (!Array.isArray(t1)) return !1;
            if ("within" === t1[0]) return !0;
            for(let e1 = 1; e1 < t1.length; e1++)if (hi(t1[e1])) return !0;
            return !1;
        }
        function pi(t1) {
            if (!t1) return !0;
            const e1 = t1[0];
            var r;
            return t1.length <= 1 ? "any" !== e1 : "==" === e1 ? fi(t1[1], t1[2], "==") : "!=" === e1 ? mi(fi(t1[1], t1[2], "==")) : "<" === e1 || ">" === e1 || "<=" === e1 || ">=" === e1 ? fi(t1[1], t1[2], e1) : "any" === e1 ? (r = t1.slice(1), [
                "any"
            ].concat(r.map(pi))) : "all" === e1 ? [
                "all"
            ].concat(t1.slice(1).map(pi)) : "none" === e1 ? [
                "all"
            ].concat(t1.slice(1).map(pi).map(mi)) : "in" === e1 ? di(t1[1], t1.slice(2)) : "!in" === e1 ? mi(di(t1[1], t1.slice(2))) : "has" === e1 ? yi(t1[1]) : "!has" === e1 ? mi(yi(t1[1])) : "within" !== e1 || t1;
        }
        function fi(t1, e1, r) {
            switch(t1){
                case "$type":
                    return [
                        `filter-type-${r}`,
                        e1
                    ];
                case "$id":
                    return [
                        `filter-id-${r}`,
                        e1
                    ];
                default:
                    return [
                        `filter-${r}`,
                        t1,
                        e1
                    ];
            }
        }
        function di(t1, e1) {
            if (0 === e1.length) return !1;
            switch(t1){
                case "$type":
                    return [
                        "filter-type-in",
                        [
                            "literal",
                            e1
                        ]
                    ];
                case "$id":
                    return [
                        "filter-id-in",
                        [
                            "literal",
                            e1
                        ]
                    ];
                default:
                    return e1.length > 200 && !e1.some((t1)=>typeof t1 != typeof e1[0]) ? [
                        "filter-in-large",
                        t1,
                        [
                            "literal",
                            e1.sort(ci)
                        ]
                    ] : [
                        "filter-in-small",
                        t1,
                        [
                            "literal",
                            e1
                        ]
                    ];
            }
        }
        function yi(t1) {
            switch(t1){
                case "$type":
                    return !0;
                case "$id":
                    return [
                        "filter-has-id"
                    ];
                default:
                    return [
                        "filter-has",
                        t1
                    ];
            }
        }
        function mi(t1) {
            return [
                "!",
                t1
            ];
        }
        function gi(t1) {
            return ii(Jt(t1.value)) ? ei(Yt({}, t1, {
                expressionContext: "filter",
                valueSpec: t1.styleSpec[`filter_${t1.layerType || "fill"}`]
            })) : xi(t1);
        }
        function xi(t1) {
            const e1 = t1.value, r = t1.key;
            if ("array" !== Cn(e1)) return [
                new Yn(r, e1, `array expected, ${Cn(e1)} found`)
            ];
            const n = t1.styleSpec;
            let i, s = [];
            if (e1.length < 1) return [
                new Yn(r, e1, "filter array must have at least 1 element")
            ];
            switch(s = s.concat(ni({
                key: `${r}[0]`,
                value: e1[0],
                valueSpec: n.filter_operator,
                style: t1.style,
                styleSpec: t1.styleSpec
            })), Wt(e1[0])){
                case "<":
                case "<=":
                case ">":
                case ">=":
                    e1.length >= 2 && "$type" === Wt(e1[1]) && s.push(new Yn(r, e1, `"$type" cannot be use with operator "${e1[0]}"`));
                case "==":
                case "!=":
                    3 !== e1.length && s.push(new Yn(r, e1, `filter array for operator "${e1[0]}" must have 3 elements`));
                case "in":
                case "!in":
                    e1.length >= 2 && (i = Cn(e1[1]), "string" !== i && s.push(new Yn(`${r}[1]`, e1[1], `string expected, ${i} found`)));
                    for(let a = 2; a < e1.length; a++)i = Cn(e1[a]), "$type" === Wt(e1[1]) ? s = s.concat(ni({
                        key: `${r}[${a}]`,
                        value: e1[a],
                        valueSpec: n.geometry_type,
                        style: t1.style,
                        styleSpec: t1.styleSpec
                    })) : "string" !== i && "number" !== i && "boolean" !== i && s.push(new Yn(`${r}[${a}]`, e1[a], `string, number, or boolean expected, ${i} found`));
                    break;
                case "any":
                case "all":
                case "none":
                    for(let n1 = 1; n1 < e1.length; n1++)s = s.concat(xi({
                        key: `${r}[${n1}]`,
                        value: e1[n1],
                        style: t1.style,
                        styleSpec: t1.styleSpec
                    }));
                    break;
                case "has":
                case "!has":
                    i = Cn(e1[1]), 2 !== e1.length ? s.push(new Yn(r, e1, `filter array for "${e1[0]}" operator must have 2 elements`)) : "string" !== i && s.push(new Yn(`${r}[1]`, e1[1], `string expected, ${i} found`));
                    break;
                case "within":
                    i = Cn(e1[1]), 2 !== e1.length ? s.push(new Yn(r, e1, `filter array for "${e1[0]}" operator must have 2 elements`)) : "object" !== i && s.push(new Yn(`${r}[1]`, e1[1], `object expected, ${i} found`));
            }
            return s;
        }
        function vi(t1, e1) {
            const r = t1.key, n = t1.style, i = t1.styleSpec, s = t1.value, a = t1.objectKey, o = i[`${e1}_${t1.layerType}`];
            if (!o) return [];
            const l = a.match(/^(.*)-transition$/);
            if ("paint" === e1 && l && o[l[1]] && o[l[1]].transition) return Bi({
                key: r,
                value: s,
                valueSpec: i.transition,
                style: n,
                styleSpec: i
            });
            const u = t1.valueSpec || o[a];
            if (!u) return [
                new Yn(r, s, `unknown property "${a}"`)
            ];
            let c;
            if ("string" === Cn(s) && Bn(u) && !u.tokens && (c = /^{([^}]+)}$/.exec(s))) return [
                new Yn(r, s, `"${a}" does not support interpolation syntax\nUse an identity property function instead: \`{ "type": "identity", "property": ${JSON.stringify(c[1])} }\`.`)
            ];
            const h = [];
            return "symbol" === t1.layerType && ("text-field" === a && n && !n.glyphs && h.push(new Yn(r, s, 'use of "text-field" requires a style "glyphs" property')), "text-font" === a && Dn(Jt(s)) && "identity" === Wt(s.type) && h.push(new Yn(r, s, '"text-font" does not support identity functions'))), h.concat(Bi({
                key: t1.key,
                value: s,
                valueSpec: u,
                style: n,
                styleSpec: i,
                expressionContext: "property",
                propertyType: e1,
                propertyKey: a
            }));
        }
        function bi(t1) {
            return vi(t1, "paint");
        }
        function _i(t1) {
            return vi(t1, "layout");
        }
        function wi(t1) {
            let e1 = [];
            const r = t1.value, n = t1.key, i = t1.style, s = t1.styleSpec;
            r.type || r.ref || e1.push(new Yn(n, r, 'either "type" or "ref" is required'));
            let a = Wt(r.type);
            const o = Wt(r.ref);
            if (r.id) {
                const s1 = Wt(r.id);
                for(let a1 = 0; a1 < t1.arrayIndex; a1++){
                    const t2 = i.layers[a1];
                    Wt(t2.id) === s1 && e1.push(new Yn(n, r.id, `duplicate layer id "${r.id}", previously used at line ${t2.id.__line__}`));
                }
            }
            if ("ref" in r) {
                let t3;
                [
                    "type",
                    "source",
                    "source-layer",
                    "filter",
                    "layout"
                ].forEach((t1)=>{
                    t1 in r && e1.push(new Yn(n, r[t1], `"${t1}" is prohibited for ref layers`));
                }), i.layers.forEach((e1)=>{
                    Wt(e1.id) === o && (t3 = e1);
                }), t3 ? t3.ref ? e1.push(new Yn(n, r.ref, "ref cannot reference another ref layer")) : a = Wt(t3.type) : "string" == typeof o && e1.push(new Yn(n, r.ref, `ref layer "${o}" not found`));
            } else if ("background" !== a && "sky" !== a) {
                if (r.source) {
                    const t4 = i.sources && i.sources[r.source], s2 = t4 && Wt(t4.type);
                    t4 ? "vector" === s2 && "raster" === a ? e1.push(new Yn(n, r.source, `layer "${r.id}" requires a raster source`)) : "raster" === s2 && "raster" !== a ? e1.push(new Yn(n, r.source, `layer "${r.id}" requires a vector source`)) : "vector" !== s2 || r["source-layer"] ? "raster-dem" === s2 && "hillshade" !== a ? e1.push(new Yn(n, r.source, "raster-dem source can only be used with layer type 'hillshade'.")) : "line" !== a || !r.paint || !r.paint["line-gradient"] && !r.paint["line-trim-offset"] || "geojson" === s2 && t4.lineMetrics || e1.push(new Yn(n, r, `layer "${r.id}" specifies a line-gradient, which requires a GeoJSON source with \`lineMetrics\` enabled.`)) : e1.push(new Yn(n, r, `layer "${r.id}" must specify a "source-layer"`)) : e1.push(new Yn(n, r.source, `source "${r.source}" not found`));
                } else e1.push(new Yn(n, r, 'missing required property "source"'));
            }
            return e1 = e1.concat(Wn({
                key: n,
                value: r,
                valueSpec: s.layer,
                style: t1.style,
                styleSpec: t1.styleSpec,
                objectElementValidators: {
                    "*": ()=>[],
                    type: ()=>Bi({
                            key: `${n}.type`,
                            value: r.type,
                            valueSpec: s.layer.type,
                            style: t1.style,
                            styleSpec: t1.styleSpec,
                            object: r,
                            objectKey: "type"
                        }),
                    filter: (t1)=>gi(Yt({
                            layerType: a
                        }, t1)),
                    layout: (t1)=>Wn({
                            layer: r,
                            key: t1.key,
                            value: t1.value,
                            valueSpec: {},
                            style: t1.style,
                            styleSpec: t1.styleSpec,
                            objectElementValidators: {
                                "*": (t1)=>_i(Yt({
                                        layerType: a
                                    }, t1))
                            }
                        }),
                    paint: (t1)=>Wn({
                            layer: r,
                            key: t1.key,
                            value: t1.value,
                            valueSpec: {},
                            style: t1.style,
                            styleSpec: t1.styleSpec,
                            objectElementValidators: {
                                "*": (t1)=>bi(Yt({
                                        layerType: a
                                    }, t1))
                            }
                        })
                }
            })), e1;
        }
        function Ai(t1) {
            const e1 = t1.value, r = t1.key, n = Cn(e1);
            return "string" !== n ? [
                new Yn(r, e1, `string expected, ${n} found`)
            ] : [];
        }
        const Si = {
            promoteId: function({ key: t1 , value: e1  }) {
                if ("string" === Cn(e1)) return Ai({
                    key: t1,
                    value: e1
                });
                {
                    const r = [];
                    for(const n in e1)r.push(...Ai({
                        key: `${t1}.${n}`,
                        value: e1[n]
                    }));
                    return r;
                }
            }
        };
        function ki(t1) {
            const e1 = t1.value, r = t1.key, n = t1.styleSpec, i = t1.style;
            if (!e1.type) return [
                new Yn(r, e1, '"type" is required')
            ];
            const s = Wt(e1.type);
            let a;
            switch(s){
                case "vector":
                case "raster":
                case "raster-dem":
                    return a = Wn({
                        key: r,
                        value: e1,
                        valueSpec: n[`source_${s.replace("-", "_")}`],
                        style: t1.style,
                        styleSpec: n,
                        objectElementValidators: Si
                    }), a;
                case "geojson":
                    if (a = Wn({
                        key: r,
                        value: e1,
                        valueSpec: n.source_geojson,
                        style: i,
                        styleSpec: n,
                        objectElementValidators: Si
                    }), e1.cluster) for(const t2 in e1.clusterProperties){
                        const [n1, i1] = e1.clusterProperties[t2], s1 = "string" == typeof n1 ? [
                            n1,
                            [
                                "accumulated"
                            ],
                            [
                                "get",
                                t2
                            ]
                        ] : n1;
                        a.push(...ei({
                            key: `${r}.${t2}.map`,
                            value: i1,
                            expressionContext: "cluster-map"
                        })), a.push(...ei({
                            key: `${r}.${t2}.reduce`,
                            value: s1,
                            expressionContext: "cluster-reduce"
                        }));
                    }
                    return a;
                case "video":
                    return Wn({
                        key: r,
                        value: e1,
                        valueSpec: n.source_video,
                        style: i,
                        styleSpec: n
                    });
                case "image":
                    return Wn({
                        key: r,
                        value: e1,
                        valueSpec: n.source_image,
                        style: i,
                        styleSpec: n
                    });
                case "canvas":
                    return [
                        new Yn(r, null, "Please use runtime APIs to add canvas sources, rather than including them in stylesheets.", "source.canvas")
                    ];
                default:
                    return ni({
                        key: `${r}.type`,
                        value: e1.type,
                        valueSpec: {
                            values: [
                                "vector",
                                "raster",
                                "raster-dem",
                                "geojson",
                                "video",
                                "image"
                            ]
                        },
                        style: i,
                        styleSpec: n
                    });
            }
        }
        function Ii(t1) {
            const e1 = t1.value, r = t1.styleSpec, n = r.light, i = t1.style;
            let s = [];
            const a = Cn(e1);
            if (void 0 === e1) return s;
            if ("object" !== a) return s = s.concat([
                new Yn("light", e1, `object expected, ${a} found`)
            ]), s;
            for(const t2 in e1){
                const a1 = t2.match(/^(.*)-transition$/);
                s = s.concat(a1 && n[a1[1]] && n[a1[1]].transition ? Bi({
                    key: t2,
                    value: e1[t2],
                    valueSpec: r.transition,
                    style: i,
                    styleSpec: r
                }) : n[t2] ? Bi({
                    key: t2,
                    value: e1[t2],
                    valueSpec: n[t2],
                    style: i,
                    styleSpec: r
                }) : [
                    new Yn(t2, e1[t2], `unknown property "${t2}"`)
                ]);
            }
            return s;
        }
        function Mi(t1) {
            const e1 = t1.value, r = t1.key, n = t1.style, i = t1.styleSpec, s = i.terrain;
            let a = [];
            const o = Cn(e1);
            if (void 0 === e1) return a;
            if ("object" !== o) return a = a.concat([
                new Yn("terrain", e1, `object expected, ${o} found`)
            ]), a;
            for(const t2 in e1){
                const r1 = t2.match(/^(.*)-transition$/);
                a = a.concat(r1 && s[r1[1]] && s[r1[1]].transition ? Bi({
                    key: t2,
                    value: e1[t2],
                    valueSpec: i.transition,
                    style: n,
                    styleSpec: i
                }) : s[t2] ? Bi({
                    key: t2,
                    value: e1[t2],
                    valueSpec: s[t2],
                    style: n,
                    styleSpec: i
                }) : [
                    new Yn(t2, e1[t2], `unknown property "${t2}"`)
                ]);
            }
            if (e1.source) {
                const t3 = n.sources && n.sources[e1.source], i1 = t3 && Wt(t3.type);
                t3 ? "raster-dem" !== i1 && a.push(new Yn(r, e1.source, `terrain cannot be used with a source of type ${String(i1)}, it only be used with a "raster-dem" source type`)) : a.push(new Yn(r, e1.source, `source "${e1.source}" not found`));
            } else a.push(new Yn(r, e1, 'terrain is missing required property "source"'));
            return a;
        }
        function zi(t1) {
            const e1 = t1.value, r = t1.style, n = t1.styleSpec, i = n.fog;
            let s = [];
            const a = Cn(e1);
            if (void 0 === e1) return s;
            if ("object" !== a) return s = s.concat([
                new Yn("fog", e1, `object expected, ${a} found`)
            ]), s;
            for(const t2 in e1){
                const a1 = t2.match(/^(.*)-transition$/);
                s = s.concat(a1 && i[a1[1]] && i[a1[1]].transition ? Bi({
                    key: t2,
                    value: e1[t2],
                    valueSpec: n.transition,
                    style: r,
                    styleSpec: n
                }) : i[t2] ? Bi({
                    key: t2,
                    value: e1[t2],
                    valueSpec: i[t2],
                    style: r,
                    styleSpec: n
                }) : [
                    new Yn(t2, e1[t2], `unknown property "${t2}"`)
                ]);
            }
            return s;
        }
        const Ti = {
            "*": ()=>[],
            array: Jn,
            boolean: function(t1) {
                const e1 = t1.value, r = t1.key, n = Cn(e1);
                return "boolean" !== n ? [
                    new Yn(r, e1, `boolean expected, ${n} found`)
                ] : [];
            },
            number: Qn,
            color: function(t1) {
                const e1 = t1.key, r = t1.value, n = Cn(r);
                return "string" !== n ? [
                    new Yn(e1, r, `color expected, ${n} found`)
                ] : null === ve(r) ? [
                    new Yn(e1, r, `color expected, "${r}" found`)
                ] : [];
            },
            enum: ni,
            filter: gi,
            function: ti,
            layer: wi,
            object: Wn,
            source: ki,
            light: Ii,
            terrain: Mi,
            fog: zi,
            string: Ai,
            formatted: function(t1) {
                return 0 === Ai(t1).length ? [] : ei(t1);
            },
            resolvedImage: function(t1) {
                return 0 === Ai(t1).length ? [] : ei(t1);
            },
            projection: function(t1) {
                const e1 = t1.value, r = t1.styleSpec, n = r.projection, i = t1.style;
                let s = [];
                const a = Cn(e1);
                if ("object" === a) for(const t2 in e1)s = s.concat(Bi({
                    key: t2,
                    value: e1[t2],
                    valueSpec: n[t2],
                    style: i,
                    styleSpec: r
                }));
                else "string" !== a && (s = s.concat([
                    new Yn("projection", e1, `object or string expected, ${a} found`)
                ]));
                return s;
            }
        };
        function Bi(t1) {
            const e1 = t1.value, r = t1.valueSpec, n = t1.styleSpec;
            return r.expression && Dn(Wt(e1)) ? ti(t1) : r.expression && qn(Jt(e1)) ? ei(t1) : r.type && Ti[r.type] ? Ti[r.type](t1) : Wn(Yt({}, t1, {
                valueSpec: r.type ? n[r.type] : r
            }));
        }
        function Ei(t1) {
            const e1 = t1.value, r = t1.key, n = Ai(t1);
            return n.length || (-1 === e1.indexOf("{fontstack}") && n.push(new Yn(r, e1, '"glyphs" url must include a "{fontstack}" token')), -1 === e1.indexOf("{range}") && n.push(new Yn(r, e1, '"glyphs" url must include a "{range}" token'))), n;
        }
        function Pi(t1, e1 = Ht) {
            return Vi(Bi({
                key: "",
                value: t1,
                valueSpec: e1.$root,
                styleSpec: e1,
                style: t1,
                objectElementValidators: {
                    glyphs: Ei,
                    "*": ()=>[]
                }
            }));
        }
        const Ci = (t1)=>Vi(bi(t1)), Di = (t1)=>Vi(_i(t1));
        function Vi(t1) {
            return t1.slice().sort((t1, e1)=>t1.line && e1.line ? t1.line - e1.line : 0);
        }
        function Fi(t1, e1) {
            let r = !1;
            if (e1 && e1.length) for (const n of e1)t1.fire(new Xt(new Error(n.message))), r = !0;
            return r;
        }
        var Li = Ri;
        function Ri(t1, e1, r) {
            var n = this.cells = [];
            if (t1 instanceof ArrayBuffer) {
                this.arrayBuffer = t1;
                var i = new Int32Array(this.arrayBuffer);
                t1 = i[0], this.d = (e1 = i[1]) + 2 * (r = i[2]);
                for(var s = 0; s < this.d * this.d; s++){
                    var a = i[3 + s], o = i[3 + s + 1];
                    n.push(a === o ? null : i.subarray(a, o));
                }
                var l = i[3 + n.length + 1];
                this.keys = i.subarray(i[3 + n.length], l), this.bboxes = i.subarray(l), this.insert = this._insertReadonly;
            } else {
                this.d = e1 + 2 * r;
                for(var u = 0; u < this.d * this.d; u++)n.push([]);
                this.keys = [], this.bboxes = [];
            }
            this.n = e1, this.extent = t1, this.padding = r, this.scale = e1 / t1, this.uid = 0;
            var c = r / e1 * t1;
            this.min = -c, this.max = t1 + c;
        }
        Ri.prototype.insert = function(t1, e1, r, n, i) {
            this._forEachCell(e1, r, n, i, this._insertCell, this.uid++), this.keys.push(t1), this.bboxes.push(e1), this.bboxes.push(r), this.bboxes.push(n), this.bboxes.push(i);
        }, Ri.prototype._insertReadonly = function() {
            throw "Cannot insert into a GridIndex created from an ArrayBuffer.";
        }, Ri.prototype._insertCell = function(t1, e1, r, n, i, s) {
            this.cells[i].push(s);
        }, Ri.prototype.query = function(t1, e1, r, n, i) {
            var s = this.min, a = this.max;
            if (t1 <= s && e1 <= s && a <= r && a <= n && !i) return Array.prototype.slice.call(this.keys);
            var o = [];
            return this._forEachCell(t1, e1, r, n, this._queryCell, o, {}, i), o;
        }, Ri.prototype._queryCell = function(t1, e1, r, n, i, s, a, o) {
            var l = this.cells[i];
            if (null !== l) for(var u = this.keys, c = this.bboxes, h = 0; h < l.length; h++){
                var p = l[h];
                if (void 0 === a[p]) {
                    var f = 4 * p;
                    (o ? o(c[f + 0], c[f + 1], c[f + 2], c[f + 3]) : t1 <= c[f + 2] && e1 <= c[f + 3] && r >= c[f + 0] && n >= c[f + 1]) ? (a[p] = !0, s.push(u[p])) : a[p] = !1;
                }
            }
        }, Ri.prototype._forEachCell = function(t1, e1, r, n, i, s, a, o) {
            for(var l = this._convertToCellCoord(t1), u = this._convertToCellCoord(e1), c = this._convertToCellCoord(r), h = this._convertToCellCoord(n), p = l; p <= c; p++)for(var f = u; f <= h; f++){
                var d = this.d * f + p;
                if ((!o || o(this._convertFromCellCoord(p), this._convertFromCellCoord(f), this._convertFromCellCoord(p + 1), this._convertFromCellCoord(f + 1))) && i.call(this, t1, e1, r, n, d, s, a, o)) return;
            }
        }, Ri.prototype._convertFromCellCoord = function(t1) {
            return (t1 - this.padding) / this.scale;
        }, Ri.prototype._convertToCellCoord = function(t1) {
            return Math.max(0, Math.min(this.d - 1, Math.floor(t1 * this.scale) + this.padding));
        }, Ri.prototype.toArrayBuffer = function() {
            if (this.arrayBuffer) return this.arrayBuffer;
            for(var t1 = this.cells, e1 = 3 + this.cells.length + 1 + 1, r = 0, n = 0; n < this.cells.length; n++)r += this.cells[n].length;
            var i = new Int32Array(e1 + r + this.keys.length + this.bboxes.length);
            i[0] = this.extent, i[1] = this.n, i[2] = this.padding;
            for(var s = e1, a = 0; a < t1.length; a++){
                var o = t1[a];
                i[3 + a] = s, i.set(o, s), s += o.length;
            }
            return i[3 + t1.length] = s, i.set(this.keys, s), i[3 + t1.length + 1] = s += this.keys.length, i.set(this.bboxes, s), s += this.bboxes.length, i.buffer;
        };
        const Ui = {};
        function ji(t1, e1, r = {}) {
            Object.defineProperty(t1, "_classRegistryKey", {
                value: e1,
                writeable: !1
            }), Ui[e1] = {
                klass: t1,
                omit: r.omit || []
            };
        }
        ji(Object, "Object"), Li.serialize = function(t1, e1) {
            const r = t1.toArrayBuffer();
            return e1 && e1.push(r), {
                buffer: r
            };
        }, Li.deserialize = function(t1) {
            return new Li(t1.buffer);
        }, Object.defineProperty(Li, "name", {
            value: "Grid"
        }), ji(Li, "Grid"), ji(Ie, "Color"), ji(Error, "Error"), ji(at, "AJAXError"), ji(Be, "ResolvedImage"), ji(Kn, "StylePropertyFunction"), ji(On, "StyleExpression", {
            omit: [
                "_evaluator"
            ]
        }), ji(Zn, "ZoomDependentExpression"), ji(Gn, "ZoomConstantExpression"), ji(He, "CompoundExpression", {
            omit: [
                "_evaluate"
            ]
        });
        for(const t4 in Mn)Ui[Mn[t4]._classRegistryKey] || ji(Mn[t4], `Expression${t4}`);
        function $i(t1) {
            return t1 && "undefined" != typeof ArrayBuffer && (t1 instanceof ArrayBuffer || t1.constructor && "ArrayBuffer" === t1.constructor.name);
        }
        function Oi(t1) {
            return e1.ImageBitmap && t1 instanceof e1.ImageBitmap;
        }
        function qi(t1, r) {
            if (null == t1 || "boolean" == typeof t1 || "number" == typeof t1 || "string" == typeof t1 || t1 instanceof Boolean || t1 instanceof Number || t1 instanceof String || t1 instanceof Date || t1 instanceof RegExp) return t1;
            if ($i(t1) || Oi(t1)) return r && r.push(t1), t1;
            if (ArrayBuffer.isView(t1)) {
                const e2 = t1;
                return r && r.push(e2.buffer), e2;
            }
            if (t1 instanceof e1.ImageData) return r && r.push(t1.data.buffer), t1;
            if (Array.isArray(t1)) {
                const e3 = [];
                for (const n of t1)e3.push(qi(n, r));
                return e3;
            }
            if ("object" == typeof t1) {
                const e4 = t1.constructor, n1 = e4._classRegistryKey;
                if (!n1) throw new Error(`can't serialize object of unregistered class ${n1}`);
                const i = e4.serialize ? e4.serialize(t1, r) : {};
                if (!e4.serialize) {
                    for(const e5 in t1)t1.hasOwnProperty(e5) && (Ui[n1].omit.indexOf(e5) >= 0 || (i[e5] = qi(t1[e5], r)));
                    t1 instanceof Error && (i.message = t1.message);
                }
                if (i.$name) throw new Error("$name property is reserved for worker serialization logic.");
                return "Object" !== n1 && (i.$name = n1), i;
            }
            throw new Error("can't serialize object of type " + typeof t1);
        }
        function Ni(t1) {
            if (null == t1 || "boolean" == typeof t1 || "number" == typeof t1 || "string" == typeof t1 || t1 instanceof Boolean || t1 instanceof Number || t1 instanceof String || t1 instanceof Date || t1 instanceof RegExp || $i(t1) || Oi(t1) || ArrayBuffer.isView(t1) || t1 instanceof e1.ImageData) return t1;
            if (Array.isArray(t1)) return t1.map(Ni);
            if ("object" == typeof t1) {
                const e2 = t1.$name || "Object", { klass: r  } = Ui[e2];
                if (!r) throw new Error(`can't deserialize unregistered class ${e2}`);
                if (r.deserialize) return r.deserialize(t1);
                const n = Object.create(r.prototype);
                for (const e3 of Object.keys(t1))"$name" !== e3 && (n[e3] = Ni(t1[e3]));
                return n;
            }
            throw new Error("can't deserialize object of type " + typeof t1);
        }
        class Gi {
            constructor(){
                this.first = !0;
            }
            update(t1, e1) {
                const r = Math.floor(t1);
                return this.first ? (this.first = !1, this.lastIntegerZoom = r, this.lastIntegerZoomTime = 0, this.lastZoom = t1, this.lastFloorZoom = r, !0) : (this.lastFloorZoom > r ? (this.lastIntegerZoom = r + 1, this.lastIntegerZoomTime = e1) : this.lastFloorZoom < r && (this.lastIntegerZoom = r, this.lastIntegerZoomTime = e1), t1 !== this.lastZoom && (this.lastZoom = t1, this.lastFloorZoom = r, !0));
            }
        }
        const Zi = (t1)=>t1 >= 1536 && t1 <= 1791, Xi = (t1)=>t1 >= 1872 && t1 <= 1919, Ki = (t1)=>t1 >= 2208 && t1 <= 2303, Hi = (t1)=>t1 >= 11904 && t1 <= 12031, Yi = (t1)=>t1 >= 12032 && t1 <= 12255, Wi = (t1)=>t1 >= 12272 && t1 <= 12287, Ji = (t1)=>t1 >= 12288 && t1 <= 12351, Qi = (t1)=>t1 >= 12352 && t1 <= 12447, ts = (t1)=>t1 >= 12448 && t1 <= 12543, es = (t1)=>t1 >= 12544 && t1 <= 12591, rs = (t1)=>t1 >= 12704 && t1 <= 12735, ns = (t1)=>t1 >= 12736 && t1 <= 12783, is = (t1)=>t1 >= 12784 && t1 <= 12799, ss = (t1)=>t1 >= 12800 && t1 <= 13055, as = (t1)=>t1 >= 13056 && t1 <= 13311, os = (t1)=>t1 >= 13312 && t1 <= 19903, ls = (t1)=>t1 >= 19968 && t1 <= 40959, us = (t1)=>t1 >= 40960 && t1 <= 42127, cs = (t1)=>t1 >= 42128 && t1 <= 42191, hs = (t1)=>t1 >= 44032 && t1 <= 55215, ps = (t1)=>t1 >= 63744 && t1 <= 64255, fs = (t1)=>t1 >= 64336 && t1 <= 65023, ds = (t1)=>t1 >= 65040 && t1 <= 65055, ys = (t1)=>t1 >= 65072 && t1 <= 65103, ms = (t1)=>t1 >= 65104 && t1 <= 65135, gs = (t1)=>t1 >= 65136 && t1 <= 65279, xs = (t1)=>t1 >= 65280 && t1 <= 65519;
        function vs(t1) {
            for (const e1 of t1)if (ws(e1.charCodeAt(0))) return !0;
            return !1;
        }
        function bs(t1) {
            for (const e1 of t1)if (!_s(e1.charCodeAt(0))) return !1;
            return !0;
        }
        function _s(t1) {
            return !(Zi(t1) || Xi(t1) || Ki(t1) || fs(t1) || gs(t1));
        }
        function ws(t1) {
            return !(746 !== t1 && 747 !== t1 && (t1 < 4352 || !(rs(t1) || es(t1) || ys(t1) && !(t1 >= 65097 && t1 <= 65103) || ps(t1) || as(t1) || Hi(t1) || ns(t1) || !(!Ji(t1) || t1 >= 12296 && t1 <= 12305 || t1 >= 12308 && t1 <= 12319 || 12336 === t1) || os(t1) || ls(t1) || ss(t1) || ((t1)=>t1 >= 12592 && t1 <= 12687)(t1) || ((t1)=>t1 >= 43360 && t1 <= 43391)(t1) || ((t1)=>t1 >= 55216 && t1 <= 55295)(t1) || ((t1)=>t1 >= 4352 && t1 <= 4607)(t1) || hs(t1) || Qi(t1) || Wi(t1) || ((t1)=>t1 >= 12688 && t1 <= 12703)(t1) || Yi(t1) || is(t1) || ts(t1) && 12540 !== t1 || !(!xs(t1) || 65288 === t1 || 65289 === t1 || 65293 === t1 || t1 >= 65306 && t1 <= 65310 || 65339 === t1 || 65341 === t1 || 65343 === t1 || t1 >= 65371 && t1 <= 65503 || 65507 === t1 || t1 >= 65512 && t1 <= 65519) || !(!ms(t1) || t1 >= 65112 && t1 <= 65118 || t1 >= 65123 && t1 <= 65126) || ((t1)=>t1 >= 5120 && t1 <= 5759)(t1) || ((t1)=>t1 >= 6320 && t1 <= 6399)(t1) || ds(t1) || ((t1)=>t1 >= 19904 && t1 <= 19967)(t1) || us(t1) || cs(t1))));
        }
        function As(t1) {
            return !(ws(t1) || function(t1) {
                return !!(((t1)=>t1 >= 128 && t1 <= 255)(t1) && (167 === t1 || 169 === t1 || 174 === t1 || 177 === t1 || 188 === t1 || 189 === t1 || 190 === t1 || 215 === t1 || 247 === t1) || ((t1)=>t1 >= 8192 && t1 <= 8303)(t1) && (8214 === t1 || 8224 === t1 || 8225 === t1 || 8240 === t1 || 8241 === t1 || 8251 === t1 || 8252 === t1 || 8258 === t1 || 8263 === t1 || 8264 === t1 || 8265 === t1 || 8273 === t1) || ((t1)=>t1 >= 8448 && t1 <= 8527)(t1) || ((t1)=>t1 >= 8528 && t1 <= 8591)(t1) || ((t1)=>t1 >= 8960 && t1 <= 9215)(t1) && (t1 >= 8960 && t1 <= 8967 || t1 >= 8972 && t1 <= 8991 || t1 >= 8996 && t1 <= 9e3 || 9003 === t1 || t1 >= 9085 && t1 <= 9114 || t1 >= 9150 && t1 <= 9165 || 9167 === t1 || t1 >= 9169 && t1 <= 9179 || t1 >= 9186 && t1 <= 9215) || ((t1)=>t1 >= 9216 && t1 <= 9279)(t1) && 9251 !== t1 || ((t1)=>t1 >= 9280 && t1 <= 9311)(t1) || ((t1)=>t1 >= 9312 && t1 <= 9471)(t1) || ((t1)=>t1 >= 9632 && t1 <= 9727)(t1) || ((t1)=>t1 >= 9728 && t1 <= 9983)(t1) && !(t1 >= 9754 && t1 <= 9759) || ((t1)=>t1 >= 11008 && t1 <= 11263)(t1) && (t1 >= 11026 && t1 <= 11055 || t1 >= 11088 && t1 <= 11097 || t1 >= 11192 && t1 <= 11243) || Ji(t1) || ts(t1) || ((t1)=>t1 >= 57344 && t1 <= 63743)(t1) || ys(t1) || ms(t1) || xs(t1) || 8734 === t1 || 8756 === t1 || 8757 === t1 || t1 >= 9984 && t1 <= 10087 || t1 >= 10102 && t1 <= 10131 || 65532 === t1 || 65533 === t1);
            }(t1));
        }
        function Ss(t1) {
            return t1 >= 1424 && t1 <= 2303 || fs(t1) || gs(t1);
        }
        function ks(t1, e1) {
            return !(!e1 && Ss(t1) || t1 >= 2304 && t1 <= 3583 || t1 >= 3840 && t1 <= 4255 || ((t1)=>t1 >= 6016 && t1 <= 6143)(t1));
        }
        function Is(t1) {
            for (const e1 of t1)if (Ss(e1.charCodeAt(0))) return !0;
            return !1;
        }
        const Ms = "deferred", zs = "loading", Ts = "loaded";
        let Bs = null, Es = "unavailable", Ps = null;
        const Cs = function(t1) {
            t1 && "string" == typeof t1 && t1.indexOf("NetworkError") > -1 && (Es = "error"), Bs && Bs(t1);
        };
        function Ds() {
            Vs.fire(new Zt("pluginStateChange", {
                pluginStatus: Es,
                pluginURL: Ps
            }));
        }
        const Vs = new Kt, Fs = function() {
            return Es;
        }, Ls = function() {
            if (Es !== Ms || !Ps) throw new Error("rtl-text-plugin cannot be downloaded unless a pluginURL is specified");
            Es = zs, Ds(), Ps && ut({
                url: Ps
            }, (t1)=>{
                t1 ? Cs(t1) : (Es = Ts, Ds());
            });
        }, Rs = {
            applyArabicShaping: null,
            processBidirectionalText: null,
            processStyledBidirectionalText: null,
            isLoaded: ()=>Es === Ts || null != Rs.applyArabicShaping,
            isLoading: ()=>Es === zs,
            setState (t1) {
                Es = t1.pluginStatus, Ps = t1.pluginURL;
            },
            isParsed: ()=>null != Rs.applyArabicShaping && null != Rs.processBidirectionalText && null != Rs.processStyledBidirectionalText,
            getPluginURL: ()=>Ps
        };
        class Us {
            constructor(t1, e1){
                this.zoom = t1, e1 ? (this.now = e1.now, this.fadeDuration = e1.fadeDuration, this.zoomHistory = e1.zoomHistory, this.transition = e1.transition, this.pitch = e1.pitch) : (this.now = 0, this.fadeDuration = 0, this.zoomHistory = new Gi, this.transition = {}, this.pitch = 0);
            }
            isSupportedScript(t1) {
                return function(t1, e1) {
                    for (const r of t1)if (!ks(r.charCodeAt(0), e1)) return !1;
                    return !0;
                }(t1, Rs.isLoaded());
            }
            crossFadingFactor() {
                return 0 === this.fadeDuration ? 1 : Math.min((this.now - this.zoomHistory.lastIntegerZoomTime) / this.fadeDuration, 1);
            }
            getCrossfadeParameters() {
                const t1 = this.zoom, e1 = t1 - Math.floor(t1), r = this.crossFadingFactor();
                return t1 > this.zoomHistory.lastIntegerZoom ? {
                    fromScale: 2,
                    toScale: 1,
                    t: e1 + (1 - e1) * r
                } : {
                    fromScale: .5,
                    toScale: 1,
                    t: 1 - (1 - r) * e1
                };
            }
        }
        class js {
            constructor(t1, e1){
                this.property = t1, this.value = e1, this.expression = function(t1, e1) {
                    if (Dn(t1)) return new Kn(t1, e1);
                    if (qn(t1)) {
                        const r = Xn(t1, e1);
                        if ("error" === r.result) throw new Error(r.value.map((t1)=>`${t1.key}: ${t1.message}`).join(", "));
                        return r.value;
                    }
                    {
                        let r1 = t1;
                        return "string" == typeof t1 && "color" === e1.type && (r1 = Ie.parse(t1)), {
                            kind: "constant",
                            evaluate: ()=>r1
                        };
                    }
                }(void 0 === e1 ? t1.specification.default : e1, t1.specification);
            }
            isDataDriven() {
                return "source" === this.expression.kind || "composite" === this.expression.kind;
            }
            possiblyEvaluate(t1, e1, r) {
                return this.property.possiblyEvaluate(this, t1, e1, r);
            }
        }
        class $s {
            constructor(t1){
                this.property = t1, this.value = new js(t1, void 0);
            }
            transitioned(t1, e1) {
                return new qs(this.property, this.value, e1, T({}, t1.transition, this.transition), t1.now);
            }
            untransitioned() {
                return new qs(this.property, this.value, null, {}, 0);
            }
        }
        class Os {
            constructor(t1){
                this._properties = t1, this._values = Object.create(t1.defaultTransitionablePropertyValues);
            }
            getValue(t1) {
                return U(this._values[t1].value.value);
            }
            setValue(t1, e1) {
                this._values.hasOwnProperty(t1) || (this._values[t1] = new $s(this._values[t1].property)), this._values[t1].value = new js(this._values[t1].property, null === e1 ? void 0 : U(e1));
            }
            getTransition(t1) {
                return U(this._values[t1].transition);
            }
            setTransition(t1, e1) {
                this._values.hasOwnProperty(t1) || (this._values[t1] = new $s(this._values[t1].property)), this._values[t1].transition = U(e1) || void 0;
            }
            serialize() {
                const t1 = {};
                for (const e1 of Object.keys(this._values)){
                    const r = this.getValue(e1);
                    void 0 !== r && (t1[e1] = r);
                    const n = this.getTransition(e1);
                    void 0 !== n && (t1[`${e1}-transition`] = n);
                }
                return t1;
            }
            transitioned(t1, e1) {
                const r = new Ns(this._properties);
                for (const n of Object.keys(this._values))r._values[n] = this._values[n].transitioned(t1, e1._values[n]);
                return r;
            }
            untransitioned() {
                const t1 = new Ns(this._properties);
                for (const e1 of Object.keys(this._values))t1._values[e1] = this._values[e1].untransitioned();
                return t1;
            }
        }
        class qs {
            constructor(t1, e1, r, n, i){
                const s = n.delay || 0, a = n.duration || 0;
                i = i || 0, this.property = t1, this.value = e1, this.begin = i + s, this.end = this.begin + a, t1.specification.transition && (n.delay || n.duration) && (this.prior = r);
            }
            possiblyEvaluate(t1, e1, r) {
                const n = t1.now || 0, i = this.value.possiblyEvaluate(t1, e1, r), s = this.prior;
                if (s) {
                    if (n > this.end) return this.prior = null, i;
                    if (this.value.isDataDriven()) return this.prior = null, i;
                    if (n < this.begin) return s.possiblyEvaluate(t1, e1, r);
                    {
                        const a = (n - this.begin) / (this.end - this.begin);
                        return this.property.interpolate(s.possiblyEvaluate(t1, e1, r), i, _(a));
                    }
                }
                return i;
            }
        }
        class Ns {
            constructor(t1){
                this._properties = t1, this._values = Object.create(t1.defaultTransitioningPropertyValues);
            }
            possiblyEvaluate(t1, e1, r) {
                const n = new Xs(this._properties);
                for (const i of Object.keys(this._values))n._values[i] = this._values[i].possiblyEvaluate(t1, e1, r);
                return n;
            }
            hasTransition() {
                for (const t1 of Object.keys(this._values))if (this._values[t1].prior) return !0;
                return !1;
            }
        }
        class Gs {
            constructor(t1){
                this._properties = t1, this._values = Object.create(t1.defaultPropertyValues);
            }
            getValue(t1) {
                return U(this._values[t1].value);
            }
            setValue(t1, e1) {
                this._values[t1] = new js(this._values[t1].property, null === e1 ? void 0 : U(e1));
            }
            serialize() {
                const t1 = {};
                for (const e1 of Object.keys(this._values)){
                    const r = this.getValue(e1);
                    void 0 !== r && (t1[e1] = r);
                }
                return t1;
            }
            possiblyEvaluate(t1, e1, r) {
                const n = new Xs(this._properties);
                for (const i of Object.keys(this._values))n._values[i] = this._values[i].possiblyEvaluate(t1, e1, r);
                return n;
            }
        }
        class Zs {
            constructor(t1, e1, r){
                this.property = t1, this.value = e1, this.parameters = r;
            }
            isConstant() {
                return "constant" === this.value.kind;
            }
            constantOr(t1) {
                return "constant" === this.value.kind ? this.value.value : t1;
            }
            evaluate(t1, e1, r, n) {
                return this.property.evaluate(this.value, this.parameters, t1, e1, r, n);
            }
        }
        class Xs {
            constructor(t1){
                this._properties = t1, this._values = Object.create(t1.defaultPossiblyEvaluatedValues);
            }
            get(t1) {
                return this._values[t1];
            }
        }
        class Ks {
            constructor(t1){
                this.specification = t1;
            }
            possiblyEvaluate(t1, e1) {
                return t1.expression.evaluate(e1);
            }
            interpolate(t1, e1, r) {
                const n = Mr[this.specification.type];
                return n ? n(t1, e1, r) : t1;
            }
        }
        class Hs {
            constructor(t1, e1){
                this.specification = t1, this.overrides = e1;
            }
            possiblyEvaluate(t1, e1, r, n) {
                return new Zs(this, "constant" === t1.expression.kind || "camera" === t1.expression.kind ? {
                    kind: "constant",
                    value: t1.expression.evaluate(e1, null, {}, r, n)
                } : t1.expression, e1);
            }
            interpolate(t1, e1, r) {
                if ("constant" !== t1.value.kind || "constant" !== e1.value.kind) return t1;
                if (void 0 === t1.value.value || void 0 === e1.value.value) return new Zs(this, {
                    kind: "constant",
                    value: void 0
                }, t1.parameters);
                const n = Mr[this.specification.type];
                return n ? new Zs(this, {
                    kind: "constant",
                    value: n(t1.value.value, e1.value.value, r)
                }, t1.parameters) : t1;
            }
            evaluate(t1, e1, r, n, i, s) {
                return "constant" === t1.kind ? t1.value : t1.evaluate(e1, r, n, i, s);
            }
        }
        class Ys extends Hs {
            possiblyEvaluate(t1, e1, r, n) {
                if (void 0 === t1.value) return new Zs(this, {
                    kind: "constant",
                    value: void 0
                }, e1);
                if ("constant" === t1.expression.kind) {
                    const i = t1.expression.evaluate(e1, null, {}, r, n), s = "resolvedImage" === t1.property.specification.type && "string" != typeof i ? i.name : i, a = this._calculate(s, s, s, e1);
                    return new Zs(this, {
                        kind: "constant",
                        value: a
                    }, e1);
                }
                if ("camera" === t1.expression.kind) {
                    const r1 = this._calculate(t1.expression.evaluate({
                        zoom: e1.zoom - 1
                    }), t1.expression.evaluate({
                        zoom: e1.zoom
                    }), t1.expression.evaluate({
                        zoom: e1.zoom + 1
                    }), e1);
                    return new Zs(this, {
                        kind: "constant",
                        value: r1
                    }, e1);
                }
                return new Zs(this, t1.expression, e1);
            }
            evaluate(t1, e1, r, n, i, s) {
                if ("source" === t1.kind) {
                    const a = t1.evaluate(e1, r, n, i, s);
                    return this._calculate(a, a, a, e1);
                }
                return "composite" === t1.kind ? this._calculate(t1.evaluate({
                    zoom: Math.floor(e1.zoom) - 1
                }, r, n), t1.evaluate({
                    zoom: Math.floor(e1.zoom)
                }, r, n), t1.evaluate({
                    zoom: Math.floor(e1.zoom) + 1
                }, r, n), e1) : t1.value;
            }
            _calculate(t1, e1, r, n) {
                return n.zoom > n.zoomHistory.lastIntegerZoom ? {
                    from: t1,
                    to: e1,
                    other: r
                } : {
                    from: r,
                    to: e1,
                    other: t1
                };
            }
            interpolate(t1) {
                return t1;
            }
        }
        class Ws {
            constructor(t1){
                this.specification = t1;
            }
            possiblyEvaluate(t1, e1, r, n) {
                if (void 0 !== t1.value) {
                    if ("constant" === t1.expression.kind) {
                        const i = t1.expression.evaluate(e1, null, {}, r, n);
                        return this._calculate(i, i, i, e1);
                    }
                    return this._calculate(t1.expression.evaluate(new Us(Math.floor(e1.zoom - 1), e1)), t1.expression.evaluate(new Us(Math.floor(e1.zoom), e1)), t1.expression.evaluate(new Us(Math.floor(e1.zoom + 1), e1)), e1);
                }
            }
            _calculate(t1, e1, r, n) {
                return n.zoom > n.zoomHistory.lastIntegerZoom ? {
                    from: t1,
                    to: e1
                } : {
                    from: r,
                    to: e1
                };
            }
            interpolate(t1) {
                return t1;
            }
        }
        class Js {
            constructor(t1){
                this.specification = t1;
            }
            possiblyEvaluate(t1, e1, r, n) {
                return !!t1.expression.evaluate(e1, null, {}, r, n);
            }
            interpolate() {
                return !1;
            }
        }
        class Qs {
            constructor(t1){
                this.properties = t1, this.defaultPropertyValues = {}, this.defaultTransitionablePropertyValues = {}, this.defaultTransitioningPropertyValues = {}, this.defaultPossiblyEvaluatedValues = {}, this.overridableProperties = [];
                const e1 = new Us(0, {});
                for(const r in t1){
                    const n = t1[r];
                    n.specification.overridable && this.overridableProperties.push(r);
                    const i = this.defaultPropertyValues[r] = new js(n, void 0), s = this.defaultTransitionablePropertyValues[r] = new $s(n);
                    this.defaultTransitioningPropertyValues[r] = s.untransitioned(), this.defaultPossiblyEvaluatedValues[r] = i.possiblyEvaluate(e1);
                }
            }
        }
        function ta(t1, e1) {
            return 256 * (t1 = S(Math.floor(t1), 0, 255)) + S(Math.floor(e1), 0, 255);
        }
        ji(Hs, "DataDrivenProperty"), ji(Ks, "DataConstantProperty"), ji(Ys, "CrossFadedDataDrivenProperty"), ji(Ws, "CrossFadedProperty"), ji(Js, "ColorRampProperty");
        const ea = {
            Int8: Int8Array,
            Uint8: Uint8Array,
            Int16: Int16Array,
            Uint16: Uint16Array,
            Int32: Int32Array,
            Uint32: Uint32Array,
            Float32: Float32Array
        };
        class ra {
            constructor(t1, e1){
                this._structArray = t1, this._pos1 = e1 * this.size, this._pos2 = this._pos1 / 2, this._pos4 = this._pos1 / 4, this._pos8 = this._pos1 / 8;
            }
        }
        class na {
            constructor(){
                this.isTransferred = !1, this.capacity = -1, this.resize(0);
            }
            static serialize(t1, e1) {
                return t1._trim(), e1 && (t1.isTransferred = !0, e1.push(t1.arrayBuffer)), {
                    length: t1.length,
                    arrayBuffer: t1.arrayBuffer
                };
            }
            static deserialize(t1) {
                const e1 = Object.create(this.prototype);
                return e1.arrayBuffer = t1.arrayBuffer, e1.length = t1.length, e1.capacity = t1.arrayBuffer.byteLength / e1.bytesPerElement, e1._refreshViews(), e1;
            }
            _trim() {
                this.length !== this.capacity && (this.capacity = this.length, this.arrayBuffer = this.arrayBuffer.slice(0, this.length * this.bytesPerElement), this._refreshViews());
            }
            clear() {
                this.length = 0;
            }
            resize(t1) {
                this.reserve(t1), this.length = t1;
            }
            reserve(t1) {
                if (t1 > this.capacity) {
                    this.capacity = Math.max(t1, Math.floor(5 * this.capacity), 128), this.arrayBuffer = new ArrayBuffer(this.capacity * this.bytesPerElement);
                    const e1 = this.uint8;
                    this._refreshViews(), e1 && this.uint8.set(e1);
                }
            }
            _refreshViews() {
                throw new Error("_refreshViews() must be implemented by each concrete StructArray layout");
            }
            destroy() {
                this.int8 = this.uint8 = this.int16 = this.uint16 = this.int32 = this.uint32 = this.float32 = null, this.arrayBuffer = null;
            }
        }
        function ia(t1, e1 = 1) {
            let r = 0, n = 0;
            return {
                members: t1.map((t1)=>{
                    const i = ea[t1.type].BYTES_PER_ELEMENT, s = r = sa(r, Math.max(e1, i)), a = t1.components || 1;
                    return n = Math.max(n, i), r += i * a, {
                        name: t1.name,
                        type: t1.type,
                        components: a,
                        offset: s
                    };
                }),
                size: sa(r, Math.max(n, e1)),
                alignment: e1
            };
        }
        function sa(t1, e1) {
            return Math.ceil(t1 / e1) * e1;
        }
        class aa extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1) {
                const r = this.length;
                return this.resize(r + 1), this.emplace(r, t1, e1);
            }
            emplace(t1, e1, r) {
                const n = 2 * t1;
                return this.int16[n + 0] = e1, this.int16[n + 1] = r, t1;
            }
        }
        aa.prototype.bytesPerElement = 4, ji(aa, "StructArrayLayout2i4");
        class oa extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r) {
                const n = this.length;
                return this.resize(n + 1), this.emplace(n, t1, e1, r);
            }
            emplace(t1, e1, r, n) {
                const i = 3 * t1;
                return this.int16[i + 0] = e1, this.int16[i + 1] = r, this.int16[i + 2] = n, t1;
            }
        }
        oa.prototype.bytesPerElement = 6, ji(oa, "StructArrayLayout3i6");
        class la extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n) {
                const i = this.length;
                return this.resize(i + 1), this.emplace(i, t1, e1, r, n);
            }
            emplace(t1, e1, r, n, i) {
                const s = 4 * t1;
                return this.int16[s + 0] = e1, this.int16[s + 1] = r, this.int16[s + 2] = n, this.int16[s + 3] = i, t1;
            }
        }
        la.prototype.bytesPerElement = 8, ji(la, "StructArrayLayout4i8");
        class ua extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s, a) {
                const o = this.length;
                return this.resize(o + 1), this.emplace(o, t1, e1, r, n, i, s, a);
            }
            emplace(t1, e1, r, n, i, s, a, o) {
                const l = 6 * t1, u = 12 * t1, c = 3 * t1;
                return this.int16[l + 0] = e1, this.int16[l + 1] = r, this.uint8[u + 4] = n, this.uint8[u + 5] = i, this.uint8[u + 6] = s, this.uint8[u + 7] = a, this.float32[c + 2] = o, t1;
            }
        }
        ua.prototype.bytesPerElement = 12, ji(ua, "StructArrayLayout2i4ub1f12");
        class ca extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n) {
                const i = this.length;
                return this.resize(i + 1), this.emplace(i, t1, e1, r, n);
            }
            emplace(t1, e1, r, n, i) {
                const s = 4 * t1;
                return this.float32[s + 0] = e1, this.float32[s + 1] = r, this.float32[s + 2] = n, this.float32[s + 3] = i, t1;
            }
        }
        ca.prototype.bytesPerElement = 16, ji(ca, "StructArrayLayout4f16");
        class ha extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s, a, o, l, u) {
                const c = this.length;
                return this.resize(c + 1), this.emplace(c, t1, e1, r, n, i, s, a, o, l, u);
            }
            emplace(t1, e1, r, n, i, s, a, o, l, u, c) {
                const h = 10 * t1;
                return this.uint16[h + 0] = e1, this.uint16[h + 1] = r, this.uint16[h + 2] = n, this.uint16[h + 3] = i, this.uint16[h + 4] = s, this.uint16[h + 5] = a, this.uint16[h + 6] = o, this.uint16[h + 7] = l, this.uint16[h + 8] = u, this.uint16[h + 9] = c, t1;
            }
        }
        ha.prototype.bytesPerElement = 20, ji(ha, "StructArrayLayout10ui20");
        class pa extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s, a, o) {
                const l = this.length;
                return this.resize(l + 1), this.emplace(l, t1, e1, r, n, i, s, a, o);
            }
            emplace(t1, e1, r, n, i, s, a, o, l) {
                const u = 8 * t1;
                return this.uint16[u + 0] = e1, this.uint16[u + 1] = r, this.uint16[u + 2] = n, this.uint16[u + 3] = i, this.uint16[u + 4] = s, this.uint16[u + 5] = a, this.uint16[u + 6] = o, this.uint16[u + 7] = l, t1;
            }
        }
        pa.prototype.bytesPerElement = 16, ji(pa, "StructArrayLayout8ui16");
        class fa extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s) {
                const a = this.length;
                return this.resize(a + 1), this.emplace(a, t1, e1, r, n, i, s);
            }
            emplace(t1, e1, r, n, i, s, a) {
                const o = 6 * t1;
                return this.int16[o + 0] = e1, this.int16[o + 1] = r, this.int16[o + 2] = n, this.int16[o + 3] = i, this.int16[o + 4] = s, this.int16[o + 5] = a, t1;
            }
        }
        fa.prototype.bytesPerElement = 12, ji(fa, "StructArrayLayout6i12");
        class da extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s, a, o, l, u, c, h) {
                const p = this.length;
                return this.resize(p + 1), this.emplace(p, t1, e1, r, n, i, s, a, o, l, u, c, h);
            }
            emplace(t1, e1, r, n, i, s, a, o, l, u, c, h, p) {
                const f = 12 * t1;
                return this.int16[f + 0] = e1, this.int16[f + 1] = r, this.int16[f + 2] = n, this.int16[f + 3] = i, this.uint16[f + 4] = s, this.uint16[f + 5] = a, this.uint16[f + 6] = o, this.uint16[f + 7] = l, this.int16[f + 8] = u, this.int16[f + 9] = c, this.int16[f + 10] = h, this.int16[f + 11] = p, t1;
            }
        }
        da.prototype.bytesPerElement = 24, ji(da, "StructArrayLayout4i4ui4i24");
        class ya extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s) {
                const a = this.length;
                return this.resize(a + 1), this.emplace(a, t1, e1, r, n, i, s);
            }
            emplace(t1, e1, r, n, i, s, a) {
                const o = 10 * t1, l = 5 * t1;
                return this.int16[o + 0] = e1, this.int16[o + 1] = r, this.int16[o + 2] = n, this.float32[l + 2] = i, this.float32[l + 3] = s, this.float32[l + 4] = a, t1;
            }
        }
        ya.prototype.bytesPerElement = 20, ji(ya, "StructArrayLayout3i3f20");
        class ma extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer);
            }
            emplaceBack(t1) {
                const e1 = this.length;
                return this.resize(e1 + 1), this.emplace(e1, t1);
            }
            emplace(t1, e1) {
                return this.uint32[1 * t1 + 0] = e1, t1;
            }
        }
        ma.prototype.bytesPerElement = 4, ji(ma, "StructArrayLayout1ul4");
        class ga extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s, a, o, l, u, c, h, p) {
                const f = this.length;
                return this.resize(f + 1), this.emplace(f, t1, e1, r, n, i, s, a, o, l, u, c, h, p);
            }
            emplace(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f) {
                const d = 20 * t1, y = 10 * t1;
                return this.int16[d + 0] = e1, this.int16[d + 1] = r, this.int16[d + 2] = n, this.int16[d + 3] = i, this.int16[d + 4] = s, this.float32[y + 3] = a, this.float32[y + 4] = o, this.float32[y + 5] = l, this.float32[y + 6] = u, this.int16[d + 14] = c, this.uint32[y + 8] = h, this.uint16[d + 18] = p, this.uint16[d + 19] = f, t1;
            }
        }
        ga.prototype.bytesPerElement = 40, ji(ga, "StructArrayLayout5i4f1i1ul2ui40");
        class xa extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s, a) {
                const o = this.length;
                return this.resize(o + 1), this.emplace(o, t1, e1, r, n, i, s, a);
            }
            emplace(t1, e1, r, n, i, s, a, o) {
                const l = 8 * t1;
                return this.int16[l + 0] = e1, this.int16[l + 1] = r, this.int16[l + 2] = n, this.int16[l + 4] = i, this.int16[l + 5] = s, this.int16[l + 6] = a, this.int16[l + 7] = o, t1;
            }
        }
        xa.prototype.bytesPerElement = 16, ji(xa, "StructArrayLayout3i2i2i16");
        class va extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i) {
                const s = this.length;
                return this.resize(s + 1), this.emplace(s, t1, e1, r, n, i);
            }
            emplace(t1, e1, r, n, i, s) {
                const a = 4 * t1, o = 8 * t1;
                return this.float32[a + 0] = e1, this.float32[a + 1] = r, this.float32[a + 2] = n, this.int16[o + 6] = i, this.int16[o + 7] = s, t1;
            }
        }
        va.prototype.bytesPerElement = 16, ji(va, "StructArrayLayout2f1f2i16");
        class ba extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n) {
                const i = this.length;
                return this.resize(i + 1), this.emplace(i, t1, e1, r, n);
            }
            emplace(t1, e1, r, n, i) {
                const s = 12 * t1, a = 3 * t1;
                return this.uint8[s + 0] = e1, this.uint8[s + 1] = r, this.float32[a + 1] = n, this.float32[a + 2] = i, t1;
            }
        }
        ba.prototype.bytesPerElement = 12, ji(ba, "StructArrayLayout2ub2f12");
        class _a extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r) {
                const n = this.length;
                return this.resize(n + 1), this.emplace(n, t1, e1, r);
            }
            emplace(t1, e1, r, n) {
                const i = 3 * t1;
                return this.float32[i + 0] = e1, this.float32[i + 1] = r, this.float32[i + 2] = n, t1;
            }
        }
        _a.prototype.bytesPerElement = 12, ji(_a, "StructArrayLayout3f12");
        class wa extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r) {
                const n = this.length;
                return this.resize(n + 1), this.emplace(n, t1, e1, r);
            }
            emplace(t1, e1, r, n) {
                const i = 3 * t1;
                return this.uint16[i + 0] = e1, this.uint16[i + 1] = r, this.uint16[i + 2] = n, t1;
            }
        }
        wa.prototype.bytesPerElement = 6, ji(wa, "StructArrayLayout3ui6");
        class Aa extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, d, y, m, g, x, v, b) {
                const _ = this.length;
                return this.resize(_ + 1), this.emplace(_, t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, d, y, m, g, x, v, b);
            }
            emplace(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, d, y, m, g, x, v, b, _) {
                const w = 30 * t1, A = 15 * t1, S = 60 * t1;
                return this.int16[w + 0] = e1, this.int16[w + 1] = r, this.int16[w + 2] = n, this.float32[A + 2] = i, this.float32[A + 3] = s, this.uint16[w + 8] = a, this.uint16[w + 9] = o, this.uint32[A + 5] = l, this.uint32[A + 6] = u, this.uint32[A + 7] = c, this.uint16[w + 16] = h, this.uint16[w + 17] = p, this.uint16[w + 18] = f, this.float32[A + 10] = d, this.float32[A + 11] = y, this.uint8[S + 48] = m, this.uint8[S + 49] = g, this.uint8[S + 50] = x, this.uint32[A + 13] = v, this.int16[w + 28] = b, this.uint8[S + 58] = _, t1;
            }
        }
        Aa.prototype.bytesPerElement = 60, ji(Aa, "StructArrayLayout3i2f2ui3ul3ui2f3ub1ul1i1ub60");
        class Sa extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, d, y, m, g, x, v, b, _, w, A, S, k, I, M, z, T) {
                const B = this.length;
                return this.resize(B + 1), this.emplace(B, t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, d, y, m, g, x, v, b, _, w, A, S, k, I, M, z, T);
            }
            emplace(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, d, y, m, g, x, v, b, _, w, A, S, k, I, M, z, T, B) {
                const E = 38 * t1, P = 19 * t1;
                return this.int16[E + 0] = e1, this.int16[E + 1] = r, this.int16[E + 2] = n, this.float32[P + 2] = i, this.float32[P + 3] = s, this.int16[E + 8] = a, this.int16[E + 9] = o, this.int16[E + 10] = l, this.int16[E + 11] = u, this.int16[E + 12] = c, this.int16[E + 13] = h, this.uint16[E + 14] = p, this.uint16[E + 15] = f, this.uint16[E + 16] = d, this.uint16[E + 17] = y, this.uint16[E + 18] = m, this.uint16[E + 19] = g, this.uint16[E + 20] = x, this.uint16[E + 21] = v, this.uint16[E + 22] = b, this.uint16[E + 23] = _, this.uint16[E + 24] = w, this.uint16[E + 25] = A, this.uint16[E + 26] = S, this.uint16[E + 27] = k, this.uint16[E + 28] = I, this.uint32[P + 15] = M, this.float32[P + 16] = z, this.float32[P + 17] = T, this.float32[P + 18] = B, t1;
            }
        }
        Sa.prototype.bytesPerElement = 76, ji(Sa, "StructArrayLayout3i2f6i15ui1ul3f76");
        class ka extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1) {
                const e1 = this.length;
                return this.resize(e1 + 1), this.emplace(e1, t1);
            }
            emplace(t1, e1) {
                return this.float32[1 * t1 + 0] = e1, t1;
            }
        }
        ka.prototype.bytesPerElement = 4, ji(ka, "StructArrayLayout1f4");
        class Ia extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i) {
                const s = this.length;
                return this.resize(s + 1), this.emplace(s, t1, e1, r, n, i);
            }
            emplace(t1, e1, r, n, i, s) {
                const a = 5 * t1;
                return this.float32[a + 0] = e1, this.float32[a + 1] = r, this.float32[a + 2] = n, this.float32[a + 3] = i, this.float32[a + 4] = s, t1;
            }
        }
        Ia.prototype.bytesPerElement = 20, ji(Ia, "StructArrayLayout5f20");
        class Ma extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n) {
                const i = this.length;
                return this.resize(i + 1), this.emplace(i, t1, e1, r, n);
            }
            emplace(t1, e1, r, n, i) {
                const s = 6 * t1;
                return this.uint32[3 * t1 + 0] = e1, this.uint16[s + 2] = r, this.uint16[s + 3] = n, this.uint16[s + 4] = i, t1;
            }
        }
        Ma.prototype.bytesPerElement = 12, ji(Ma, "StructArrayLayout1ul3ui12");
        class za extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1) {
                const r = this.length;
                return this.resize(r + 1), this.emplace(r, t1, e1);
            }
            emplace(t1, e1, r) {
                const n = 2 * t1;
                return this.uint16[n + 0] = e1, this.uint16[n + 1] = r, t1;
            }
        }
        za.prototype.bytesPerElement = 4, ji(za, "StructArrayLayout2ui4");
        class Ta extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1) {
                const e1 = this.length;
                return this.resize(e1 + 1), this.emplace(e1, t1);
            }
            emplace(t1, e1) {
                return this.uint16[1 * t1 + 0] = e1, t1;
            }
        }
        Ta.prototype.bytesPerElement = 2, ji(Ta, "StructArrayLayout1ui2");
        class Ba extends na {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1) {
                const r = this.length;
                return this.resize(r + 1), this.emplace(r, t1, e1);
            }
            emplace(t1, e1, r) {
                const n = 2 * t1;
                return this.float32[n + 0] = e1, this.float32[n + 1] = r, t1;
            }
        }
        Ba.prototype.bytesPerElement = 8, ji(Ba, "StructArrayLayout2f8");
        class Ea extends ra {
            get a_pos_30() {
                return this._structArray.int16[this._pos2 + 0];
            }
            get a_pos_31() {
                return this._structArray.int16[this._pos2 + 1];
            }
            get a_pos_32() {
                return this._structArray.int16[this._pos2 + 2];
            }
            get a_pos_normal_30() {
                return this._structArray.int16[this._pos2 + 3];
            }
            get a_pos_normal_31() {
                return this._structArray.int16[this._pos2 + 4];
            }
            get a_pos_normal_32() {
                return this._structArray.int16[this._pos2 + 5];
            }
        }
        Ea.prototype.size = 12;
        class Pa extends fa {
            get(t1) {
                return new Ea(this, t1);
            }
        }
        ji(Pa, "FillExtrusionExtArray");
        class Ca extends ra {
            get projectedAnchorX() {
                return this._structArray.int16[this._pos2 + 0];
            }
            get projectedAnchorY() {
                return this._structArray.int16[this._pos2 + 1];
            }
            get projectedAnchorZ() {
                return this._structArray.int16[this._pos2 + 2];
            }
            get tileAnchorX() {
                return this._structArray.int16[this._pos2 + 3];
            }
            get tileAnchorY() {
                return this._structArray.int16[this._pos2 + 4];
            }
            get x1() {
                return this._structArray.float32[this._pos4 + 3];
            }
            get y1() {
                return this._structArray.float32[this._pos4 + 4];
            }
            get x2() {
                return this._structArray.float32[this._pos4 + 5];
            }
            get y2() {
                return this._structArray.float32[this._pos4 + 6];
            }
            get padding() {
                return this._structArray.int16[this._pos2 + 14];
            }
            get featureIndex() {
                return this._structArray.uint32[this._pos4 + 8];
            }
            get sourceLayerIndex() {
                return this._structArray.uint16[this._pos2 + 18];
            }
            get bucketIndex() {
                return this._structArray.uint16[this._pos2 + 19];
            }
        }
        Ca.prototype.size = 40;
        class Da extends ga {
            get(t1) {
                return new Ca(this, t1);
            }
        }
        ji(Da, "CollisionBoxArray");
        class Va extends ra {
            get projectedAnchorX() {
                return this._structArray.int16[this._pos2 + 0];
            }
            get projectedAnchorY() {
                return this._structArray.int16[this._pos2 + 1];
            }
            get projectedAnchorZ() {
                return this._structArray.int16[this._pos2 + 2];
            }
            get tileAnchorX() {
                return this._structArray.float32[this._pos4 + 2];
            }
            get tileAnchorY() {
                return this._structArray.float32[this._pos4 + 3];
            }
            get glyphStartIndex() {
                return this._structArray.uint16[this._pos2 + 8];
            }
            get numGlyphs() {
                return this._structArray.uint16[this._pos2 + 9];
            }
            get vertexStartIndex() {
                return this._structArray.uint32[this._pos4 + 5];
            }
            get lineStartIndex() {
                return this._structArray.uint32[this._pos4 + 6];
            }
            get lineLength() {
                return this._structArray.uint32[this._pos4 + 7];
            }
            get segment() {
                return this._structArray.uint16[this._pos2 + 16];
            }
            get lowerSize() {
                return this._structArray.uint16[this._pos2 + 17];
            }
            get upperSize() {
                return this._structArray.uint16[this._pos2 + 18];
            }
            get lineOffsetX() {
                return this._structArray.float32[this._pos4 + 10];
            }
            get lineOffsetY() {
                return this._structArray.float32[this._pos4 + 11];
            }
            get writingMode() {
                return this._structArray.uint8[this._pos1 + 48];
            }
            get placedOrientation() {
                return this._structArray.uint8[this._pos1 + 49];
            }
            set placedOrientation(t1) {
                this._structArray.uint8[this._pos1 + 49] = t1;
            }
            get hidden() {
                return this._structArray.uint8[this._pos1 + 50];
            }
            set hidden(t1) {
                this._structArray.uint8[this._pos1 + 50] = t1;
            }
            get crossTileID() {
                return this._structArray.uint32[this._pos4 + 13];
            }
            set crossTileID(t1) {
                this._structArray.uint32[this._pos4 + 13] = t1;
            }
            get associatedIconIndex() {
                return this._structArray.int16[this._pos2 + 28];
            }
            get flipState() {
                return this._structArray.uint8[this._pos1 + 58];
            }
            set flipState(t1) {
                this._structArray.uint8[this._pos1 + 58] = t1;
            }
        }
        Va.prototype.size = 60;
        class Fa extends Aa {
            get(t1) {
                return new Va(this, t1);
            }
        }
        ji(Fa, "PlacedSymbolArray");
        class La extends ra {
            get projectedAnchorX() {
                return this._structArray.int16[this._pos2 + 0];
            }
            get projectedAnchorY() {
                return this._structArray.int16[this._pos2 + 1];
            }
            get projectedAnchorZ() {
                return this._structArray.int16[this._pos2 + 2];
            }
            get tileAnchorX() {
                return this._structArray.float32[this._pos4 + 2];
            }
            get tileAnchorY() {
                return this._structArray.float32[this._pos4 + 3];
            }
            get rightJustifiedTextSymbolIndex() {
                return this._structArray.int16[this._pos2 + 8];
            }
            get centerJustifiedTextSymbolIndex() {
                return this._structArray.int16[this._pos2 + 9];
            }
            get leftJustifiedTextSymbolIndex() {
                return this._structArray.int16[this._pos2 + 10];
            }
            get verticalPlacedTextSymbolIndex() {
                return this._structArray.int16[this._pos2 + 11];
            }
            get placedIconSymbolIndex() {
                return this._structArray.int16[this._pos2 + 12];
            }
            get verticalPlacedIconSymbolIndex() {
                return this._structArray.int16[this._pos2 + 13];
            }
            get key() {
                return this._structArray.uint16[this._pos2 + 14];
            }
            get textBoxStartIndex() {
                return this._structArray.uint16[this._pos2 + 15];
            }
            get textBoxEndIndex() {
                return this._structArray.uint16[this._pos2 + 16];
            }
            get verticalTextBoxStartIndex() {
                return this._structArray.uint16[this._pos2 + 17];
            }
            get verticalTextBoxEndIndex() {
                return this._structArray.uint16[this._pos2 + 18];
            }
            get iconBoxStartIndex() {
                return this._structArray.uint16[this._pos2 + 19];
            }
            get iconBoxEndIndex() {
                return this._structArray.uint16[this._pos2 + 20];
            }
            get verticalIconBoxStartIndex() {
                return this._structArray.uint16[this._pos2 + 21];
            }
            get verticalIconBoxEndIndex() {
                return this._structArray.uint16[this._pos2 + 22];
            }
            get featureIndex() {
                return this._structArray.uint16[this._pos2 + 23];
            }
            get numHorizontalGlyphVertices() {
                return this._structArray.uint16[this._pos2 + 24];
            }
            get numVerticalGlyphVertices() {
                return this._structArray.uint16[this._pos2 + 25];
            }
            get numIconVertices() {
                return this._structArray.uint16[this._pos2 + 26];
            }
            get numVerticalIconVertices() {
                return this._structArray.uint16[this._pos2 + 27];
            }
            get useRuntimeCollisionCircles() {
                return this._structArray.uint16[this._pos2 + 28];
            }
            get crossTileID() {
                return this._structArray.uint32[this._pos4 + 15];
            }
            set crossTileID(t1) {
                this._structArray.uint32[this._pos4 + 15] = t1;
            }
            get textOffset0() {
                return this._structArray.float32[this._pos4 + 16];
            }
            get textOffset1() {
                return this._structArray.float32[this._pos4 + 17];
            }
            get collisionCircleDiameter() {
                return this._structArray.float32[this._pos4 + 18];
            }
        }
        La.prototype.size = 76;
        class Ra extends Sa {
            get(t1) {
                return new La(this, t1);
            }
        }
        ji(Ra, "SymbolInstanceArray");
        class Ua extends ka {
            getoffsetX(t1) {
                return this.float32[1 * t1 + 0];
            }
        }
        ji(Ua, "GlyphOffsetArray");
        class ja extends oa {
            getx(t1) {
                return this.int16[3 * t1 + 0];
            }
            gety(t1) {
                return this.int16[3 * t1 + 1];
            }
            gettileUnitDistanceFromAnchor(t1) {
                return this.int16[3 * t1 + 2];
            }
        }
        ji(ja, "SymbolLineVertexArray");
        class $a extends ra {
            get featureIndex() {
                return this._structArray.uint32[this._pos4 + 0];
            }
            get sourceLayerIndex() {
                return this._structArray.uint16[this._pos2 + 2];
            }
            get bucketIndex() {
                return this._structArray.uint16[this._pos2 + 3];
            }
            get layoutVertexArrayOffset() {
                return this._structArray.uint16[this._pos2 + 4];
            }
        }
        $a.prototype.size = 12;
        class Oa extends Ma {
            get(t1) {
                return new $a(this, t1);
            }
        }
        ji(Oa, "FeatureIndexArray");
        class qa extends ra {
            get a_centroid_pos0() {
                return this._structArray.uint16[this._pos2 + 0];
            }
            get a_centroid_pos1() {
                return this._structArray.uint16[this._pos2 + 1];
            }
        }
        qa.prototype.size = 4;
        class Na extends za {
            get(t1) {
                return new qa(this, t1);
            }
        }
        ji(Na, "FillExtrusionCentroidArray");
        class Ga extends ra {
            get a_pos_30() {
                return this._structArray.int16[this._pos2 + 0];
            }
            get a_pos_31() {
                return this._structArray.int16[this._pos2 + 1];
            }
            get a_pos_32() {
                return this._structArray.int16[this._pos2 + 2];
            }
            get a_pos_normal_30() {
                return this._structArray.int16[this._pos2 + 3];
            }
            get a_pos_normal_31() {
                return this._structArray.int16[this._pos2 + 4];
            }
            get a_pos_normal_32() {
                return this._structArray.int16[this._pos2 + 5];
            }
        }
        Ga.prototype.size = 12;
        class Za extends fa {
            get(t1) {
                return new Ga(this, t1);
            }
        }
        ji(Za, "CircleGlobeExtArray");
        const Xa = ia([
            {
                name: "a_pattern_to",
                components: 4,
                type: "Uint16"
            },
            {
                name: "a_pattern_from",
                components: 4,
                type: "Uint16"
            },
            {
                name: "a_pixel_ratio_to",
                components: 1,
                type: "Uint16"
            },
            {
                name: "a_pixel_ratio_from",
                components: 1,
                type: "Uint16"
            }
        ]), Ka = ia([
            {
                name: "a_dash_to",
                components: 4,
                type: "Uint16"
            },
            {
                name: "a_dash_from",
                components: 4,
                type: "Uint16"
            }
        ]);
        var Ha = {
            exports: {}
        }, Ya = {
            exports: {}
        };
        Ya.exports = function(t1, e1) {
            var r, n, i, s, a, o, l, u;
            for(n = t1.length - (r = 3 & t1.length), i = e1, a = 3432918353, o = 461845907, u = 0; u < n;)l = 255 & t1.charCodeAt(u) | (255 & t1.charCodeAt(++u)) << 8 | (255 & t1.charCodeAt(++u)) << 16 | (255 & t1.charCodeAt(++u)) << 24, ++u, i = 27492 + (65535 & (s = 5 * (65535 & (i = (i ^= l = (65535 & (l = (l = (65535 & l) * a + (((l >>> 16) * a & 65535) << 16) & 4294967295) << 15 | l >>> 17)) * o + (((l >>> 16) * o & 65535) << 16) & 4294967295) << 13 | i >>> 19)) + ((5 * (i >>> 16) & 65535) << 16) & 4294967295)) + ((58964 + (s >>> 16) & 65535) << 16);
            switch(l = 0, r){
                case 3:
                    l ^= (255 & t1.charCodeAt(u + 2)) << 16;
                case 2:
                    l ^= (255 & t1.charCodeAt(u + 1)) << 8;
                case 1:
                    i ^= l = (65535 & (l = (l = (65535 & (l ^= 255 & t1.charCodeAt(u))) * a + (((l >>> 16) * a & 65535) << 16) & 4294967295) << 15 | l >>> 17)) * o + (((l >>> 16) * o & 65535) << 16) & 4294967295;
            }
            return i ^= t1.length, i = 2246822507 * (65535 & (i ^= i >>> 16)) + ((2246822507 * (i >>> 16) & 65535) << 16) & 4294967295, i = 3266489909 * (65535 & (i ^= i >>> 13)) + ((3266489909 * (i >>> 16) & 65535) << 16) & 4294967295, (i ^= i >>> 16) >>> 0;
        };
        var Wa = {
            exports: {}
        };
        Wa.exports = function(t1, e1) {
            for(var r, n = t1.length, i = e1 ^ n, s = 0; n >= 4;)r = 1540483477 * (65535 & (r = 255 & t1.charCodeAt(s) | (255 & t1.charCodeAt(++s)) << 8 | (255 & t1.charCodeAt(++s)) << 16 | (255 & t1.charCodeAt(++s)) << 24)) + ((1540483477 * (r >>> 16) & 65535) << 16), i = 1540483477 * (65535 & i) + ((1540483477 * (i >>> 16) & 65535) << 16) ^ (r = 1540483477 * (65535 & (r ^= r >>> 24)) + ((1540483477 * (r >>> 16) & 65535) << 16)), n -= 4, ++s;
            switch(n){
                case 3:
                    i ^= (255 & t1.charCodeAt(s + 2)) << 16;
                case 2:
                    i ^= (255 & t1.charCodeAt(s + 1)) << 8;
                case 1:
                    i = 1540483477 * (65535 & (i ^= 255 & t1.charCodeAt(s))) + ((1540483477 * (i >>> 16) & 65535) << 16);
            }
            return i = 1540483477 * (65535 & (i ^= i >>> 13)) + ((1540483477 * (i >>> 16) & 65535) << 16), (i ^= i >>> 15) >>> 0;
        };
        var Ja = Ya.exports, Qa = Wa.exports;
        Ha.exports = Ja, Ha.exports.murmur3 = Ja, Ha.exports.murmur2 = Qa;
        class to {
            constructor(){
                this.ids = [], this.positions = [], this.indexed = !1;
            }
            add(t1, e1, r, n) {
                this.ids.push(eo(t1)), this.positions.push(e1, r, n);
            }
            getPositions(t1) {
                const e1 = eo(t1);
                let r = 0, n = this.ids.length - 1;
                for(; r < n;){
                    const t2 = r + n >> 1;
                    this.ids[t2] >= e1 ? n = t2 : r = t2 + 1;
                }
                const i = [];
                for(; this.ids[r] === e1;)i.push({
                    index: this.positions[3 * r],
                    start: this.positions[3 * r + 1],
                    end: this.positions[3 * r + 2]
                }), r++;
                return i;
            }
            static serialize(t1, e1) {
                const r = new Float64Array(t1.ids), n = new Uint32Array(t1.positions);
                return ro(r, n, 0, r.length - 1), e1 && e1.push(r.buffer, n.buffer), {
                    ids: r,
                    positions: n
                };
            }
            static deserialize(t1) {
                const e1 = new to;
                return e1.ids = t1.ids, e1.positions = t1.positions, e1.indexed = !0, e1;
            }
        }
        function eo(t1) {
            const e1 = +t1;
            return !isNaN(e1) && Number.MIN_SAFE_INTEGER <= e1 && e1 <= Number.MAX_SAFE_INTEGER ? e1 : Ha.exports(String(t1));
        }
        function ro(t1, e1, r, n) {
            for(; r < n;){
                const i = t1[r + n >> 1];
                let s = r - 1, a = n + 1;
                for(;;){
                    do s++;
                    while (t1[s] < i);
                    do a--;
                    while (t1[a] > i);
                    if (s >= a) break;
                    no(t1, s, a), no(e1, 3 * s, 3 * a), no(e1, 3 * s + 1, 3 * a + 1), no(e1, 3 * s + 2, 3 * a + 2);
                }
                a - r < n - a ? (ro(t1, e1, r, a), r = a + 1) : (ro(t1, e1, a + 1, n), n = a);
            }
        }
        function no(t1, e1, r) {
            const n = t1[e1];
            t1[e1] = t1[r], t1[r] = n;
        }
        ji(to, "FeaturePositionMap");
        class io {
            constructor(t1){
                this.gl = t1.gl, this.initialized = !1;
            }
            fetchUniformLocation(t1, e1) {
                return this.location || this.initialized || (this.location = this.gl.getUniformLocation(t1, e1), this.initialized = !0), !!this.location;
            }
        }
        class so extends io {
            constructor(t1){
                super(t1), this.current = 0;
            }
            set(t1, e1, r) {
                this.fetchUniformLocation(t1, e1) && this.current !== r && (this.current = r, this.gl.uniform1f(this.location, r));
            }
        }
        class ao extends io {
            constructor(t1){
                super(t1), this.current = [
                    0,
                    0,
                    0,
                    0
                ];
            }
            set(t1, e1, r) {
                this.fetchUniformLocation(t1, e1) && (r[0] === this.current[0] && r[1] === this.current[1] && r[2] === this.current[2] && r[3] === this.current[3] || (this.current = r, this.gl.uniform4f(this.location, r[0], r[1], r[2], r[3])));
            }
        }
        class oo extends io {
            constructor(t1){
                super(t1), this.current = Ie.transparent;
            }
            set(t1, e1, r) {
                this.fetchUniformLocation(t1, e1) && (r.r === this.current.r && r.g === this.current.g && r.b === this.current.b && r.a === this.current.a || (this.current = r, this.gl.uniform4f(this.location, r.r, r.g, r.b, r.a)));
            }
        }
        const lo = new Float32Array(16), uo = new Float32Array(9), co = new Float32Array(4);
        function ho(t1) {
            return [
                ta(255 * t1.r, 255 * t1.g),
                ta(255 * t1.b, 255 * t1.a)
            ];
        }
        class po {
            constructor(t1, e1, r){
                this.value = t1, this.uniformNames = e1.map((t1)=>`u_${t1}`), this.type = r;
            }
            setUniform(t1, e1, r, n, i) {
                e1.set(t1, i, n.constantOr(this.value));
            }
            getBinding(t1, e1) {
                return "color" === this.type ? new oo(t1) : new so(t1);
            }
        }
        class fo {
            constructor(t1, e1){
                this.uniformNames = e1.map((t1)=>`u_${t1}`), this.patternFrom = null, this.patternTo = null, this.pixelRatioFrom = 1, this.pixelRatioTo = 1;
            }
            setConstantPatternPositions(t1, e1) {
                this.pixelRatioFrom = e1.pixelRatio || 1, this.pixelRatioTo = t1.pixelRatio || 1, this.patternFrom = e1.tl.concat(e1.br), this.patternTo = t1.tl.concat(t1.br);
            }
            setUniform(t1, e1, r, n, i) {
                const s = "u_pattern_to" === i || "u_dash_to" === i ? this.patternTo : "u_pattern_from" === i || "u_dash_from" === i ? this.patternFrom : "u_pixel_ratio_to" === i ? this.pixelRatioTo : "u_pixel_ratio_from" === i ? this.pixelRatioFrom : null;
                s && e1.set(t1, i, s);
            }
            getBinding(t1, e1) {
                return "u_pattern_from" === e1 || "u_pattern_to" === e1 || "u_dash_from" === e1 || "u_dash_to" === e1 ? new ao(t1) : new so(t1);
            }
        }
        class yo {
            constructor(t1, e1, r, n){
                this.expression = t1, this.type = r, this.maxValue = 0, this.paintVertexAttributes = e1.map((t1)=>({
                        name: `a_${t1}`,
                        type: "Float32",
                        components: "color" === r ? 2 : 1,
                        offset: 0
                    })), this.paintVertexArray = new n;
            }
            populatePaintArray(t1, e1, r, n, i, s) {
                const a = this.paintVertexArray.length, o = this.expression.evaluate(new Us(0), e1, {}, i, n, s);
                this.paintVertexArray.resize(t1), this._setPaintValue(a, t1, o);
            }
            updatePaintArray(t1, e1, r, n, i) {
                const s = this.expression.evaluate({
                    zoom: 0
                }, r, n, void 0, i);
                this._setPaintValue(t1, e1, s);
            }
            _setPaintValue(t1, e1, r) {
                if ("color" === this.type) {
                    const n = ho(r);
                    for(let r1 = t1; r1 < e1; r1++)this.paintVertexArray.emplace(r1, n[0], n[1]);
                } else {
                    for(let n1 = t1; n1 < e1; n1++)this.paintVertexArray.emplace(n1, r);
                    this.maxValue = Math.max(this.maxValue, Math.abs(r));
                }
            }
            upload(t1) {
                this.paintVertexArray && this.paintVertexArray.arrayBuffer && (this.paintVertexBuffer && this.paintVertexBuffer.buffer ? this.paintVertexBuffer.updateData(this.paintVertexArray) : this.paintVertexBuffer = t1.createVertexBuffer(this.paintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent));
            }
            destroy() {
                this.paintVertexBuffer && this.paintVertexBuffer.destroy();
            }
        }
        class mo {
            constructor(t1, e1, r, n, i, s){
                this.expression = t1, this.uniformNames = e1.map((t1)=>`u_${t1}_t`), this.type = r, this.useIntegerZoom = n, this.zoom = i, this.maxValue = 0, this.paintVertexAttributes = e1.map((t1)=>({
                        name: `a_${t1}`,
                        type: "Float32",
                        components: "color" === r ? 4 : 2,
                        offset: 0
                    })), this.paintVertexArray = new s;
            }
            populatePaintArray(t1, e1, r, n, i, s) {
                const a = this.expression.evaluate(new Us(this.zoom), e1, {}, i, n, s), o = this.expression.evaluate(new Us(this.zoom + 1), e1, {}, i, n, s), l = this.paintVertexArray.length;
                this.paintVertexArray.resize(t1), this._setPaintValue(l, t1, a, o);
            }
            updatePaintArray(t1, e1, r, n, i) {
                const s = this.expression.evaluate({
                    zoom: this.zoom
                }, r, n, void 0, i), a = this.expression.evaluate({
                    zoom: this.zoom + 1
                }, r, n, void 0, i);
                this._setPaintValue(t1, e1, s, a);
            }
            _setPaintValue(t1, e1, r, n) {
                if ("color" === this.type) {
                    const i = ho(r), s = ho(n);
                    for(let r1 = t1; r1 < e1; r1++)this.paintVertexArray.emplace(r1, i[0], i[1], s[0], s[1]);
                } else {
                    for(let i1 = t1; i1 < e1; i1++)this.paintVertexArray.emplace(i1, r, n);
                    this.maxValue = Math.max(this.maxValue, Math.abs(r), Math.abs(n));
                }
            }
            upload(t1) {
                this.paintVertexArray && this.paintVertexArray.arrayBuffer && (this.paintVertexBuffer && this.paintVertexBuffer.buffer ? this.paintVertexBuffer.updateData(this.paintVertexArray) : this.paintVertexBuffer = t1.createVertexBuffer(this.paintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent));
            }
            destroy() {
                this.paintVertexBuffer && this.paintVertexBuffer.destroy();
            }
            setUniform(t1, e1, r, n, i) {
                const s = this.useIntegerZoom ? Math.floor(r.zoom) : r.zoom, a = S(this.expression.interpolationFactor(s, this.zoom, this.zoom + 1), 0, 1);
                e1.set(t1, i, a);
            }
            getBinding(t1, e1) {
                return new so(t1);
            }
        }
        class go {
            constructor(t1, e1, r, n, i, s, a){
                this.expression = t1, this.type = r, this.useIntegerZoom = n, this.zoom = i, this.layerId = a, this.paintVertexAttributes = ("array" === r ? Ka : Xa).members;
                for(let t2 = 0; t2 < e1.length; ++t2);
                this.zoomInPaintVertexArray = new s, this.zoomOutPaintVertexArray = new s;
            }
            populatePaintArray(t1, e1, r) {
                const n = this.zoomInPaintVertexArray.length;
                this.zoomInPaintVertexArray.resize(t1), this.zoomOutPaintVertexArray.resize(t1), this._setPaintValues(n, t1, e1.patterns && e1.patterns[this.layerId], r);
            }
            updatePaintArray(t1, e1, r, n, i, s) {
                this._setPaintValues(t1, e1, r.patterns && r.patterns[this.layerId], s);
            }
            _setPaintValues(t1, e1, r, n) {
                if (!n || !r) return;
                const { min: i , mid: s , max: a  } = r, o = n[i], l = n[s], u = n[a];
                if (o && l && u) for(let r1 = t1; r1 < e1; r1++)this._setPaintValue(this.zoomInPaintVertexArray, r1, l, o), this._setPaintValue(this.zoomOutPaintVertexArray, r1, l, u);
            }
            _setPaintValue(t1, e1, r, n) {
                t1.emplace(e1, r.tl[0], r.tl[1], r.br[0], r.br[1], n.tl[0], n.tl[1], n.br[0], n.br[1], r.pixelRatio, n.pixelRatio);
            }
            upload(t1) {
                this.zoomInPaintVertexArray && this.zoomInPaintVertexArray.arrayBuffer && this.zoomOutPaintVertexArray && this.zoomOutPaintVertexArray.arrayBuffer && (this.zoomInPaintVertexBuffer = t1.createVertexBuffer(this.zoomInPaintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent), this.zoomOutPaintVertexBuffer = t1.createVertexBuffer(this.zoomOutPaintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent));
            }
            destroy() {
                this.zoomOutPaintVertexBuffer && this.zoomOutPaintVertexBuffer.destroy(), this.zoomInPaintVertexBuffer && this.zoomInPaintVertexBuffer.destroy();
            }
        }
        class xo {
            constructor(t1, e1, r = ()=>!0){
                this.binders = {}, this._buffers = [];
                const n = [];
                for(const i in t1.paint._values){
                    if (!r(i)) continue;
                    const s = t1.paint.get(i);
                    if (!(s instanceof Zs && Bn(s.property.specification))) continue;
                    const a = _o(i, t1.type), o = s.value, l = s.property.specification.type, u = s.property.useIntegerZoom, c = s.property.specification["property-type"], h = "cross-faded" === c || "cross-faded-data-driven" === c, p = "line-dasharray" === String(i) && "constant" !== t1.layout.get("line-cap").value.kind;
                    if ("constant" !== o.kind || p) {
                        if ("source" === o.kind || p || h) {
                            const r1 = So(i, l, "source");
                            this.binders[i] = h ? new go(o, a, l, u, e1, r1, t1.id) : new yo(o, a, l, r1), n.push(`/a_${i}`);
                        } else {
                            const t2 = So(i, l, "composite");
                            this.binders[i] = new mo(o, a, l, u, e1, t2), n.push(`/z_${i}`);
                        }
                    } else this.binders[i] = h ? new fo(o.value, a) : new po(o.value, a, l), n.push(`/u_${i}`);
                }
                this.cacheKey = n.sort().join("");
            }
            getMaxValue(t1) {
                const e1 = this.binders[t1];
                return e1 instanceof yo || e1 instanceof mo ? e1.maxValue : 0;
            }
            populatePaintArrays(t1, e1, r, n, i, s) {
                for(const a in this.binders){
                    const o = this.binders[a];
                    (o instanceof yo || o instanceof mo || o instanceof go) && o.populatePaintArray(t1, e1, r, n, i, s);
                }
            }
            setConstantPatternPositions(t1, e1) {
                for(const r in this.binders){
                    const n = this.binders[r];
                    n instanceof fo && n.setConstantPatternPositions(t1, e1);
                }
            }
            updatePaintArrays(t1, e1, r, n, i, s) {
                let a = !1;
                for(const o in t1){
                    const l = e1.getPositions(o);
                    for (const e2 of l){
                        const l1 = r.feature(e2.index);
                        for(const r1 in this.binders){
                            const u = this.binders[r1];
                            if ((u instanceof yo || u instanceof mo || u instanceof go) && !0 === u.expression.isStateDependent) {
                                const c = n.paint.get(r1);
                                u.expression = c.value, u.updatePaintArray(e2.start, e2.end, l1, t1[o], i, s), a = !0;
                            }
                        }
                    }
                }
                return a;
            }
            defines() {
                const t1 = [];
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    (r instanceof po || r instanceof fo) && t1.push(...r.uniformNames.map((t1)=>`#define HAS_UNIFORM_${t1}`));
                }
                return t1;
            }
            getBinderAttributes() {
                const t1 = [];
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    if (r instanceof yo || r instanceof mo || r instanceof go) for(let e2 = 0; e2 < r.paintVertexAttributes.length; e2++)t1.push(r.paintVertexAttributes[e2].name);
                }
                return t1;
            }
            getBinderUniforms() {
                const t1 = [];
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    if (r instanceof po || r instanceof fo || r instanceof mo) for (const e2 of r.uniformNames)t1.push(e2);
                }
                return t1;
            }
            getPaintVertexBuffers() {
                return this._buffers;
            }
            getUniforms(t1) {
                const e1 = [];
                for(const r in this.binders){
                    const n = this.binders[r];
                    if (n instanceof po || n instanceof fo || n instanceof mo) for (const i of n.uniformNames)e1.push({
                        name: i,
                        property: r,
                        binding: n.getBinding(t1, i)
                    });
                }
                return e1;
            }
            setUniforms(t1, e1, r, n, i) {
                for (const { name: e2 , property: s , binding: a  } of r)this.binders[s].setUniform(t1, a, i, n.get(s), e2);
            }
            updatePaintBuffers(t1) {
                this._buffers = [];
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    if (t1 && r instanceof go) {
                        const e2 = 2 === t1.fromScale ? r.zoomInPaintVertexBuffer : r.zoomOutPaintVertexBuffer;
                        e2 && this._buffers.push(e2);
                    } else (r instanceof yo || r instanceof mo) && r.paintVertexBuffer && this._buffers.push(r.paintVertexBuffer);
                }
            }
            upload(t1) {
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    (r instanceof yo || r instanceof mo || r instanceof go) && r.upload(t1);
                }
                this.updatePaintBuffers();
            }
            destroy() {
                for(const t1 in this.binders){
                    const e1 = this.binders[t1];
                    (e1 instanceof yo || e1 instanceof mo || e1 instanceof go) && e1.destroy();
                }
            }
        }
        class vo {
            constructor(t1, e1, r = ()=>!0){
                this.programConfigurations = {};
                for (const n of t1)this.programConfigurations[n.id] = new xo(n, e1, r);
                this.needsUpload = !1, this._featureMap = new to, this._bufferOffset = 0;
            }
            populatePaintArrays(t1, e1, r, n, i, s, a) {
                for(const r1 in this.programConfigurations)this.programConfigurations[r1].populatePaintArrays(t1, e1, n, i, s, a);
                void 0 !== e1.id && this._featureMap.add(e1.id, r, this._bufferOffset, t1), this._bufferOffset = t1, this.needsUpload = !0;
            }
            updatePaintArrays(t1, e1, r, n, i) {
                for (const s of r)this.needsUpload = this.programConfigurations[s.id].updatePaintArrays(t1, this._featureMap, e1, s, n, i) || this.needsUpload;
            }
            get(t1) {
                return this.programConfigurations[t1];
            }
            upload(t1) {
                if (this.needsUpload) {
                    for(const e1 in this.programConfigurations)this.programConfigurations[e1].upload(t1);
                    this.needsUpload = !1;
                }
            }
            destroy() {
                for(const t1 in this.programConfigurations)this.programConfigurations[t1].destroy();
            }
        }
        const bo = {
            "text-opacity": [
                "opacity"
            ],
            "icon-opacity": [
                "opacity"
            ],
            "text-color": [
                "fill_color"
            ],
            "icon-color": [
                "fill_color"
            ],
            "text-halo-color": [
                "halo_color"
            ],
            "icon-halo-color": [
                "halo_color"
            ],
            "text-halo-blur": [
                "halo_blur"
            ],
            "icon-halo-blur": [
                "halo_blur"
            ],
            "text-halo-width": [
                "halo_width"
            ],
            "icon-halo-width": [
                "halo_width"
            ],
            "line-gap-width": [
                "gapwidth"
            ],
            "line-pattern": [
                "pattern_to",
                "pattern_from",
                "pixel_ratio_to",
                "pixel_ratio_from"
            ],
            "fill-pattern": [
                "pattern_to",
                "pattern_from",
                "pixel_ratio_to",
                "pixel_ratio_from"
            ],
            "fill-extrusion-pattern": [
                "pattern_to",
                "pattern_from",
                "pixel_ratio_to",
                "pixel_ratio_from"
            ],
            "line-dasharray": [
                "dash_to",
                "dash_from"
            ]
        };
        function _o(t1, e1) {
            return bo[t1] || [
                t1.replace(`${e1}-`, "").replace(/-/g, "_")
            ];
        }
        const wo = {
            "line-pattern": {
                source: ha,
                composite: ha
            },
            "fill-pattern": {
                source: ha,
                composite: ha
            },
            "fill-extrusion-pattern": {
                source: ha,
                composite: ha
            },
            "line-dasharray": {
                source: pa,
                composite: pa
            }
        }, Ao = {
            color: {
                source: Ba,
                composite: ca
            },
            number: {
                source: ka,
                composite: Ba
            }
        };
        function So(t1, e1, r) {
            const n = wo[t1];
            return n && n[r] || Ao[e1][r];
        }
        ji(po, "ConstantBinder"), ji(fo, "CrossFadedConstantBinder"), ji(yo, "SourceExpressionBinder"), ji(go, "CrossFadedCompositeBinder"), ji(mo, "CompositeExpressionBinder"), ji(xo, "ProgramConfiguration", {
            omit: [
                "_buffers"
            ]
        }), ji(vo, "ProgramConfigurationSet");
        const ko = "-transition";
        class Io extends Kt {
            constructor(t1, e1){
                if (super(), this.id = t1.id, this.type = t1.type, this._featureFilter = {
                    filter: ()=>!0,
                    needGeometry: !1,
                    needFeature: !1
                }, this._filterCompiled = !1, "custom" !== t1.type && (this.metadata = t1.metadata, this.minzoom = t1.minzoom, this.maxzoom = t1.maxzoom, "background" !== t1.type && "sky" !== t1.type && (this.source = t1.source, this.sourceLayer = t1["source-layer"], this.filter = t1.filter), e1.layout && (this._unevaluatedLayout = new Gs(e1.layout)), e1.paint)) {
                    this._transitionablePaint = new Os(e1.paint);
                    for(const e2 in t1.paint)this.setPaintProperty(e2, t1.paint[e2], {
                        validate: !1
                    });
                    for(const e3 in t1.layout)this.setLayoutProperty(e3, t1.layout[e3], {
                        validate: !1
                    });
                    this._transitioningPaint = this._transitionablePaint.untransitioned(), this.paint = new Xs(e1.paint);
                }
            }
            getCrossfadeParameters() {
                return this._crossfadeParameters;
            }
            getLayoutProperty(t1) {
                return "visibility" === t1 ? this.visibility : this._unevaluatedLayout.getValue(t1);
            }
            setLayoutProperty(t1, e1, r = {}) {
                null != e1 && this._validate(Di, `layers.${this.id}.layout.${t1}`, t1, e1, r) || ("visibility" !== t1 ? this._unevaluatedLayout.setValue(t1, e1) : this.visibility = e1);
            }
            getPaintProperty(t1) {
                return F(t1, ko) ? this._transitionablePaint.getTransition(t1.slice(0, -ko.length)) : this._transitionablePaint.getValue(t1);
            }
            setPaintProperty(t1, e1, r = {}) {
                if (null != e1 && this._validate(Ci, `layers.${this.id}.paint.${t1}`, t1, e1, r)) return !1;
                if (F(t1, ko)) return this._transitionablePaint.setTransition(t1.slice(0, -ko.length), e1 || void 0), !1;
                {
                    const r1 = this._transitionablePaint._values[t1], n = "cross-faded-data-driven" === r1.property.specification["property-type"], i = r1.value.isDataDriven(), s = r1.value;
                    this._transitionablePaint.setValue(t1, e1), this._handleSpecialPaintPropertyUpdate(t1);
                    const a = this._transitionablePaint._values[t1].value;
                    return a.isDataDriven() || i || n || this._handleOverridablePaintPropertyUpdate(t1, s, a);
                }
            }
            _handleSpecialPaintPropertyUpdate(t1) {}
            getProgramIds() {
                return null;
            }
            getProgramConfiguration(t1) {
                return null;
            }
            _handleOverridablePaintPropertyUpdate(t1, e1, r) {
                return !1;
            }
            isHidden(t1) {
                return !!(this.minzoom && t1 < this.minzoom) || !!(this.maxzoom && t1 >= this.maxzoom) || "none" === this.visibility;
            }
            updateTransitions(t1) {
                this._transitioningPaint = this._transitionablePaint.transitioned(t1, this._transitioningPaint);
            }
            hasTransition() {
                return this._transitioningPaint.hasTransition();
            }
            recalculate(t1, e1) {
                t1.getCrossfadeParameters && (this._crossfadeParameters = t1.getCrossfadeParameters()), this._unevaluatedLayout && (this.layout = this._unevaluatedLayout.possiblyEvaluate(t1, void 0, e1)), this.paint = this._transitioningPaint.possiblyEvaluate(t1, void 0, e1);
            }
            serialize() {
                const t1 = {
                    id: this.id,
                    type: this.type,
                    source: this.source,
                    "source-layer": this.sourceLayer,
                    metadata: this.metadata,
                    minzoom: this.minzoom,
                    maxzoom: this.maxzoom,
                    filter: this.filter,
                    layout: this._unevaluatedLayout && this._unevaluatedLayout.serialize(),
                    paint: this._transitionablePaint && this._transitionablePaint.serialize()
                };
                return this.visibility && (t1.layout = t1.layout || {}, t1.layout.visibility = this.visibility), R(t1, (t1, e1)=>!(void 0 === t1 || "layout" === e1 && !Object.keys(t1).length || "paint" === e1 && !Object.keys(t1).length));
            }
            _validate(t1, e1, r, n, i = {}) {
                return (!i || !1 !== i.validate) && Fi(this, t1.call(Pi, {
                    key: e1,
                    layerType: this.type,
                    objectKey: r,
                    value: n,
                    styleSpec: Ht,
                    style: {
                        glyphs: !0,
                        sprite: !0
                    }
                }));
            }
            is3D() {
                return !1;
            }
            isSky() {
                return !1;
            }
            isTileClipped() {
                return !1;
            }
            hasOffscreenPass() {
                return !1;
            }
            resize() {}
            isStateDependent() {
                for(const t1 in this.paint._values){
                    const e1 = this.paint.get(t1);
                    if (e1 instanceof Zs && Bn(e1.property.specification) && ("source" === e1.value.kind || "composite" === e1.value.kind) && e1.value.isStateDependent) return !0;
                }
                return !1;
            }
            compileFilter() {
                this._filterCompiled || (this._featureFilter = si(this.filter), this._filterCompiled = !0);
            }
            invalidateCompiledFilter() {
                this._filterCompiled = !1;
            }
            dynamicFilter() {
                return this._featureFilter.dynamicFilter;
            }
            dynamicFilterNeedsFeature() {
                return this._featureFilter.needFeature;
            }
        }
        const Mo = ia([
            {
                name: "a_pos",
                components: 2,
                type: "Int16"
            }
        ], 4), zo = ia([
            {
                name: "a_pos_3",
                components: 3,
                type: "Int16"
            },
            {
                name: "a_pos_normal_3",
                components: 3,
                type: "Int16"
            }
        ]);
        class To {
            constructor(t1 = []){
                this.segments = t1;
            }
            prepareSegment(t1, e1, r, n) {
                let i = this.segments[this.segments.length - 1];
                return t1 > To.MAX_VERTEX_ARRAY_LENGTH && $(`Max vertices per segment is ${To.MAX_VERTEX_ARRAY_LENGTH}: bucket requested ${t1}`), (!i || i.vertexLength + t1 > To.MAX_VERTEX_ARRAY_LENGTH || i.sortKey !== n) && (i = {
                    vertexOffset: e1.length,
                    primitiveOffset: r.length,
                    vertexLength: 0,
                    primitiveLength: 0
                }, void 0 !== n && (i.sortKey = n), this.segments.push(i)), i;
            }
            get() {
                return this.segments;
            }
            destroy() {
                for (const t1 of this.segments)for(const e1 in t1.vaos)t1.vaos[e1].destroy();
            }
            static simpleSegment(t1, e1, r, n) {
                return new To([
                    {
                        vertexOffset: t1,
                        primitiveOffset: e1,
                        vertexLength: r,
                        primitiveLength: n,
                        vaos: {},
                        sortKey: 0
                    }
                ]);
            }
        }
        To.MAX_VERTEX_ARRAY_LENGTH = Math.pow(2, 16) - 1, ji(To, "SegmentVector");
        var Bo = 8192;
        class Eo {
            constructor(t1, e1){
                t1 && (e1 ? this.setSouthWest(t1).setNorthEast(e1) : 4 === t1.length ? this.setSouthWest([
                    t1[0],
                    t1[1]
                ]).setNorthEast([
                    t1[2],
                    t1[3]
                ]) : this.setSouthWest(t1[0]).setNorthEast(t1[1]));
            }
            setNorthEast(t1) {
                return this._ne = t1 instanceof Co ? new Co(t1.lng, t1.lat) : Co.convert(t1), this;
            }
            setSouthWest(t1) {
                return this._sw = t1 instanceof Co ? new Co(t1.lng, t1.lat) : Co.convert(t1), this;
            }
            extend(t1) {
                const e1 = this._sw, r = this._ne;
                let n, i;
                if (t1 instanceof Co) n = t1, i = t1;
                else {
                    if (!(t1 instanceof Eo)) return Array.isArray(t1) ? 4 === t1.length || t1.every(Array.isArray) ? this.extend(Eo.convert(t1)) : this.extend(Co.convert(t1)) : "object" == typeof t1 && null !== t1 && t1.hasOwnProperty("lat") && t1.hasOwnProperty("lon") ? this.extend(Co.convert(t1)) : this;
                    if (n = t1._sw, i = t1._ne, !n || !i) return this;
                }
                return e1 || r ? (e1.lng = Math.min(n.lng, e1.lng), e1.lat = Math.min(n.lat, e1.lat), r.lng = Math.max(i.lng, r.lng), r.lat = Math.max(i.lat, r.lat)) : (this._sw = new Co(n.lng, n.lat), this._ne = new Co(i.lng, i.lat)), this;
            }
            getCenter() {
                return new Co((this._sw.lng + this._ne.lng) / 2, (this._sw.lat + this._ne.lat) / 2);
            }
            getSouthWest() {
                return this._sw;
            }
            getNorthEast() {
                return this._ne;
            }
            getNorthWest() {
                return new Co(this.getWest(), this.getNorth());
            }
            getSouthEast() {
                return new Co(this.getEast(), this.getSouth());
            }
            getWest() {
                return this._sw.lng;
            }
            getSouth() {
                return this._sw.lat;
            }
            getEast() {
                return this._ne.lng;
            }
            getNorth() {
                return this._ne.lat;
            }
            toArray() {
                return [
                    this._sw.toArray(),
                    this._ne.toArray()
                ];
            }
            toString() {
                return `LngLatBounds(${this._sw.toString()}, ${this._ne.toString()})`;
            }
            isEmpty() {
                return !(this._sw && this._ne);
            }
            contains(t1) {
                const { lng: e1 , lat: r  } = Co.convert(t1);
                let n = this._sw.lng <= e1 && e1 <= this._ne.lng;
                return this._sw.lng > this._ne.lng && (n = this._sw.lng >= e1 && e1 >= this._ne.lng), this._sw.lat <= r && r <= this._ne.lat && n;
            }
            static convert(t1) {
                return !t1 || t1 instanceof Eo ? t1 : new Eo(t1);
            }
        }
        const Po = 6371008.8;
        class Co {
            constructor(t1, e1){
                if (isNaN(t1) || isNaN(e1)) throw new Error(`Invalid LngLat object: (${t1}, ${e1})`);
                if (this.lng = +t1, this.lat = +e1, this.lat > 90 || this.lat < -90) throw new Error("Invalid LngLat latitude value: must be between -90 and 90");
            }
            wrap() {
                return new Co(I(this.lng, -180, 180), this.lat);
            }
            toArray() {
                return [
                    this.lng,
                    this.lat
                ];
            }
            toString() {
                return `LngLat(${this.lng}, ${this.lat})`;
            }
            distanceTo(t1) {
                const e1 = Math.PI / 180, r = this.lat * e1, n = t1.lat * e1, i = Math.sin(r) * Math.sin(n) + Math.cos(r) * Math.cos(n) * Math.cos((t1.lng - this.lng) * e1);
                return Po * Math.acos(Math.min(i, 1));
            }
            toBounds(t1 = 0) {
                const e1 = 360 * t1 / 40075017, r = e1 / Math.cos(Math.PI / 180 * this.lat);
                return new Eo(new Co(this.lng - r, this.lat - e1), new Co(this.lng + r, this.lat + e1));
            }
            static convert(t1) {
                if (t1 instanceof Co) return t1;
                if (Array.isArray(t1) && (2 === t1.length || 3 === t1.length)) return new Co(Number(t1[0]), Number(t1[1]));
                if (!Array.isArray(t1) && "object" == typeof t1 && null !== t1) return new Co(Number("lng" in t1 ? t1.lng : t1.lon), Number(t1.lat));
                throw new Error("`LngLatLike` argument must be specified as a LngLat instance, an object {lng: <lng>, lat: <lat>}, an object {lon: <lng>, lat: <lat>}, or an array of [<lng>, <lat>]");
            }
        }
        const Do = 2 * Math.PI * Po;
        function Vo(t1) {
            return Do * Math.cos(t1 * Math.PI / 180);
        }
        function Fo(t1) {
            return (180 + t1) / 360;
        }
        function Lo(t1) {
            return (180 - 180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + t1 * Math.PI / 360))) / 360;
        }
        function Ro(t1, e1) {
            return t1 / Vo(e1);
        }
        function Uo(t1) {
            return 360 * t1 - 180;
        }
        function jo(t1) {
            return 360 / Math.PI * Math.atan(Math.exp((180 - 360 * t1) * Math.PI / 180)) - 90;
        }
        function $o(t1, e1) {
            return t1 * Vo(jo(e1));
        }
        const Oo = 85.051129;
        function qo(t1) {
            return 1 / Math.cos(t1 * Math.PI / 180);
        }
        class No {
            constructor(t1, e1, r = 0){
                this.x = +t1, this.y = +e1, this.z = +r;
            }
            static fromLngLat(t1, e1 = 0) {
                const r = Co.convert(t1);
                return new No(Fo(r.lng), Lo(r.lat), Ro(e1, r.lat));
            }
            toLngLat() {
                return new Co(Uo(this.x), jo(this.y));
            }
            toAltitude() {
                return $o(this.z, this.y);
            }
            meterInMercatorCoordinateUnits() {
                return 1 / Do * qo(jo(this.y));
            }
        }
        function Go(t1, e1, r, n, i, s, a, o, l) {
            const u = (e1 + n) / 2, c = (r + i) / 2, h = new d(u, c);
            o(h), function(t1, e1, r, n, i, s) {
                const a = r - i, o = n - s;
                return Math.abs((n - e1) * a - (r - t1) * o) / Math.hypot(a, o);
            }(h.x, h.y, s.x, s.y, a.x, a.y) >= l ? (Go(t1, e1, r, u, c, s, h, o, l), Go(t1, u, c, n, i, h, a, o, l)) : t1.push(a);
        }
        function Zo(t1, e1, r) {
            let n = t1[0], i = n.x, s = n.y;
            e1(n);
            const a = [
                n
            ];
            for(let o = 1; o < t1.length; o++){
                const l = t1[o], { x: u , y: c  } = l;
                e1(l), Go(a, i, s, u, c, n, l, e1, r), i = u, s = c, n = l;
            }
            return a;
        }
        function Xo(t1, e1, r, n) {
            if (n(e1, r)) {
                const i = e1.add(r)._mult(.5);
                Xo(t1, e1, i, n), Xo(t1, i, r, n);
            } else t1.push(r);
        }
        function Ko(t1, e1) {
            let r = t1[0];
            const n = [
                r
            ];
            for(let i = 1; i < t1.length; i++){
                const s = t1[i];
                Xo(n, r, s, e1), r = s;
            }
            return n;
        }
        const Ho = Math.pow(2, 14) - 1, Yo = -Ho - 1;
        function Wo(t1, e1) {
            const r = Math.round(t1.x * e1), n = Math.round(t1.y * e1);
            return t1.x = S(r, Yo, Ho), t1.y = S(n, Yo, Ho), (r < t1.x || r > t1.x + 1 || n < t1.y || n > t1.y + 1) && $("Geometry exceeds allowed extent, reduce your vector tile buffer size"), t1;
        }
        function Jo(t1, e1, r) {
            const n = t1.loadGeometry(), i = t1.extent, s = Bo / i;
            if (e1 && r && r.projection.isReprojectedInTileSpace) {
                const s1 = 1 << e1.z, { scale: a , x: o , y: l , projection: u  } = r, c = (t1)=>{
                    const r = Uo((e1.x + t1.x / i) / s1), n = jo((e1.y + t1.y / i) / s1), c = u.project(r, n);
                    t1.x = (c.x * a - o) * i, t1.y = (c.y * a - l) * i;
                };
                for(let e2 = 0; e2 < n.length; e2++)if (1 !== t1.type) n[e2] = Zo(n[e2], c, 1);
                else {
                    const t2 = [];
                    for (const r1 of n[e2])r1.x < 0 || r1.x >= i || r1.y < 0 || r1.y >= i || (c(r1), t2.push(r1));
                    n[e2] = t2;
                }
            }
            for (const t3 of n)for (const e3 of t3)Wo(e3, s);
            return n;
        }
        function Qo(t1, e1) {
            return {
                type: t1.type,
                id: t1.id,
                properties: t1.properties,
                geometry: e1 ? Jo(t1) : []
            };
        }
        function tl(t1, e1, r, n, i) {
            t1.emplaceBack(2 * e1 + (n + 1) / 2, 2 * r + (i + 1) / 2);
        }
        function el(t1, e1, r) {
            const n = 16384;
            t1.emplaceBack(e1.x, e1.y, e1.z, r[0] * n, r[1] * n, r[2] * n);
        }
        class rl {
            constructor(t1){
                this.zoom = t1.zoom, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.hasPattern = !1, this.projection = t1.projection, this.layoutVertexArray = new aa, this.indexArray = new wa, this.segments = new To, this.programConfigurations = new vo(t1.layers, t1.zoom), this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id);
            }
            populate(t1, e1, r, n) {
                const i = this.layers[0], s = [];
                let a = null;
                "circle" === i.type && (a = i.layout.get("circle-sort-key"));
                for (const { feature: e2 , id: i1 , index: o , sourceLayerIndex: l  } of t1){
                    const t2 = this.layers[0]._featureFilter.needGeometry, u = Qo(e2, t2);
                    if (!this.layers[0]._featureFilter.filter(new Us(this.zoom), u, r)) continue;
                    const c = a ? a.evaluate(u, {}, r) : void 0, h = {
                        id: i1,
                        properties: e2.properties,
                        type: e2.type,
                        sourceLayerIndex: l,
                        index: o,
                        geometry: t2 ? u.geometry : Jo(e2, r, n),
                        patterns: {},
                        sortKey: c
                    };
                    s.push(h);
                }
                a && s.sort((t1, e1)=>t1.sortKey - e1.sortKey);
                let o1 = null;
                "globe" === n.projection.name && (this.globeExtVertexArray = new Za, o1 = n.projection);
                for (const n1 of s){
                    const { geometry: i2 , index: s1 , sourceLayerIndex: a1  } = n1, l1 = t1[s1].feature;
                    this.addFeature(n1, i2, s1, e1.availableImages, r, o1), e1.featureIndex.insert(l1, i2, s1, a1, this.index);
                }
            }
            update(t1, e1, r, n) {
                this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t1, e1, this.stateDependentLayers, r, n);
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length;
            }
            uploadPending() {
                return !this.uploaded || this.programConfigurations.needsUpload;
            }
            upload(t1) {
                this.uploaded || (this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, Mo.members), this.indexBuffer = t1.createIndexBuffer(this.indexArray), this.globeExtVertexArray && (this.globeExtVertexBuffer = t1.createVertexBuffer(this.globeExtVertexArray, zo.members))), this.programConfigurations.upload(t1), this.uploaded = !0;
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy(), this.globeExtVertexBuffer && this.globeExtVertexBuffer.destroy());
            }
            addFeature(t1, e1, r, n, i, s) {
                for (const r1 of e1)for (const e2 of r1){
                    const r2 = e2.x, n1 = e2.y;
                    if (r2 < 0 || r2 >= Bo || n1 < 0 || n1 >= Bo) continue;
                    if (s) {
                        const t2 = s.projectTilePoint(r2, n1, i), e3 = s.upVector(i, r2, n1), a = this.globeExtVertexArray;
                        el(a, t2, e3), el(a, t2, e3), el(a, t2, e3), el(a, t2, e3);
                    }
                    const a1 = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray, t1.sortKey), o = a1.vertexLength;
                    tl(this.layoutVertexArray, r2, n1, -1, -1), tl(this.layoutVertexArray, r2, n1, 1, -1), tl(this.layoutVertexArray, r2, n1, 1, 1), tl(this.layoutVertexArray, r2, n1, -1, 1), this.indexArray.emplaceBack(o, o + 1, o + 2), this.indexArray.emplaceBack(o, o + 2, o + 3), a1.vertexLength += 4, a1.primitiveLength += 2;
                }
                this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t1, r, {}, n, i);
            }
        }
        function nl(t1, e1) {
            for(let r = 0; r < t1.length; r++)if (pl(e1, t1[r])) return !0;
            for(let r1 = 0; r1 < e1.length; r1++)if (pl(t1, e1[r1])) return !0;
            return !!ol(t1, e1);
        }
        function il(t1, e1, r) {
            return !!pl(t1, e1) || !!ul(e1, t1, r);
        }
        function sl(t1, e1) {
            if (1 === t1.length) return hl(e1, t1[0]);
            for(let r = 0; r < e1.length; r++){
                const n = e1[r];
                for(let e2 = 0; e2 < n.length; e2++)if (pl(t1, n[e2])) return !0;
            }
            for(let r1 = 0; r1 < t1.length; r1++)if (hl(e1, t1[r1])) return !0;
            for(let r2 = 0; r2 < e1.length; r2++)if (ol(t1, e1[r2])) return !0;
            return !1;
        }
        function al(t1, e1, r) {
            if (t1.length > 1) {
                if (ol(t1, e1)) return !0;
                for(let n = 0; n < e1.length; n++)if (ul(e1[n], t1, r)) return !0;
            }
            for(let n1 = 0; n1 < t1.length; n1++)if (ul(t1[n1], e1, r)) return !0;
            return !1;
        }
        function ol(t1, e1) {
            if (0 === t1.length || 0 === e1.length) return !1;
            for(let r = 0; r < t1.length - 1; r++){
                const n = t1[r], i = t1[r + 1];
                for(let t2 = 0; t2 < e1.length - 1; t2++)if (ll(n, i, e1[t2], e1[t2 + 1])) return !0;
            }
            return !1;
        }
        function ll(t1, e1, r, n) {
            return O(t1, r, n) !== O(e1, r, n) && O(t1, e1, r) !== O(t1, e1, n);
        }
        function ul(t1, e1, r) {
            const n = r * r;
            if (1 === e1.length) return t1.distSqr(e1[0]) < n;
            for(let r1 = 1; r1 < e1.length; r1++)if (cl(t1, e1[r1 - 1], e1[r1]) < n) return !0;
            return !1;
        }
        function cl(t1, e1, r) {
            const n = e1.distSqr(r);
            if (0 === n) return t1.distSqr(e1);
            const i = ((t1.x - e1.x) * (r.x - e1.x) + (t1.y - e1.y) * (r.y - e1.y)) / n;
            return t1.distSqr(i < 0 ? e1 : i > 1 ? r : r.sub(e1)._mult(i)._add(e1));
        }
        function hl(t1, e1) {
            let r, n, i, s = !1;
            for(let a = 0; a < t1.length; a++){
                r = t1[a];
                for(let t2 = 0, a1 = r.length - 1; t2 < r.length; a1 = t2++)n = r[t2], i = r[a1], n.y > e1.y != i.y > e1.y && e1.x < (i.x - n.x) * (e1.y - n.y) / (i.y - n.y) + n.x && (s = !s);
            }
            return s;
        }
        function pl(t1, e1) {
            let r = !1;
            for(let n = 0, i = t1.length - 1; n < t1.length; i = n++){
                const s = t1[n], a = t1[i];
                s.y > e1.y != a.y > e1.y && e1.x < (a.x - s.x) * (e1.y - s.y) / (a.y - s.y) + s.x && (r = !r);
            }
            return r;
        }
        function fl(t1, e1, r, n, i) {
            for (const s of t1)if (e1 <= s.x && r <= s.y && n >= s.x && i >= s.y) return !0;
            const s1 = [
                new d(e1, r),
                new d(e1, i),
                new d(n, i),
                new d(n, r)
            ];
            if (t1.length > 2) {
                for (const e2 of s1)if (pl(t1, e2)) return !0;
            }
            for(let e3 = 0; e3 < t1.length - 1; e3++)if (dl(t1[e3], t1[e3 + 1], s1)) return !0;
            return !1;
        }
        function dl(t1, e1, r) {
            const n = r[0], i = r[2];
            if (t1.x < n.x && e1.x < n.x || t1.x > i.x && e1.x > i.x || t1.y < n.y && e1.y < n.y || t1.y > i.y && e1.y > i.y) return !1;
            const s = O(t1, e1, r[0]);
            return s !== O(t1, e1, r[1]) || s !== O(t1, e1, r[2]) || s !== O(t1, e1, r[3]);
        }
        function yl(t1, e1, r) {
            const n = e1.paint.get(t1).value;
            return "constant" === n.kind ? n.value : r.programConfigurations.get(e1.id).getMaxValue(t1);
        }
        function ml(t1) {
            return Math.sqrt(t1[0] * t1[0] + t1[1] * t1[1]);
        }
        function gl(t1, e1, r, n, i) {
            if (!e1[0] && !e1[1]) return t1;
            const s = d.convert(e1)._mult(i);
            "viewport" === r && s._rotate(-n);
            const a = [];
            for(let e2 = 0; e2 < t1.length; e2++)a.push(t1[e2].sub(s));
            return a;
        }
        function xl(t1, e1, r, n) {
            const i = d.convert(t1)._mult(n);
            return "viewport" === e1 && i._rotate(-r), i;
        }
        ji(rl, "CircleBucket", {
            omit: [
                "layers"
            ]
        });
        const vl = new Qs({
            "circle-sort-key": new Hs(Ht.layout_circle["circle-sort-key"])
        });
        var bl = {
            paint: new Qs({
                "circle-radius": new Hs(Ht.paint_circle["circle-radius"]),
                "circle-color": new Hs(Ht.paint_circle["circle-color"]),
                "circle-blur": new Hs(Ht.paint_circle["circle-blur"]),
                "circle-opacity": new Hs(Ht.paint_circle["circle-opacity"]),
                "circle-translate": new Ks(Ht.paint_circle["circle-translate"]),
                "circle-translate-anchor": new Ks(Ht.paint_circle["circle-translate-anchor"]),
                "circle-pitch-scale": new Ks(Ht.paint_circle["circle-pitch-scale"]),
                "circle-pitch-alignment": new Ks(Ht.paint_circle["circle-pitch-alignment"]),
                "circle-stroke-width": new Hs(Ht.paint_circle["circle-stroke-width"]),
                "circle-stroke-color": new Hs(Ht.paint_circle["circle-stroke-color"]),
                "circle-stroke-opacity": new Hs(Ht.paint_circle["circle-stroke-opacity"])
            }),
            layout: vl
        }, _l = 1e-6, wl = "undefined" != typeof Float32Array ? Float32Array : Array;
        function Al() {
            var t1 = new wl(9);
            return wl != Float32Array && (t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[5] = 0, t1[6] = 0, t1[7] = 0), t1[0] = 1, t1[4] = 1, t1[8] = 1, t1;
        }
        function Sl(t1, e1, r) {
            var n = e1[0], i = e1[1], s = e1[2], a = e1[3], o = e1[4], l = e1[5], u = e1[6], c = e1[7], h = e1[8], p = r[0], f = r[1], d = r[2], y = r[3], m = r[4], g = r[5], x = r[6], v = r[7], b = r[8];
            return t1[0] = p * n + f * a + d * u, t1[1] = p * i + f * o + d * c, t1[2] = p * s + f * l + d * h, t1[3] = y * n + m * a + g * u, t1[4] = y * i + m * o + g * c, t1[5] = y * s + m * l + g * h, t1[6] = x * n + v * a + b * u, t1[7] = x * i + v * o + b * c, t1[8] = x * s + v * l + b * h, t1;
        }
        function kl(t1) {
            return t1[0] = 1, t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[5] = 1, t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[10] = 1, t1[11] = 0, t1[12] = 0, t1[13] = 0, t1[14] = 0, t1[15] = 1, t1;
        }
        function Il(t1, e1) {
            var r = e1[0], n = e1[1], i = e1[2], s = e1[3], a = e1[4], o = e1[5], l = e1[6], u = e1[7], c = e1[8], h = e1[9], p = e1[10], f = e1[11], d = e1[12], y = e1[13], m = e1[14], g = e1[15], x = r * o - n * a, v = r * l - i * a, b = r * u - s * a, _ = n * l - i * o, w = n * u - s * o, A = i * u - s * l, S = c * y - h * d, k = c * m - p * d, I = c * g - f * d, M = h * m - p * y, z = h * g - f * y, T = p * g - f * m, B = x * T - v * z + b * M + _ * I - w * k + A * S;
            return B ? (t1[0] = (o * T - l * z + u * M) * (B = 1 / B), t1[1] = (i * z - n * T - s * M) * B, t1[2] = (y * A - m * w + g * _) * B, t1[3] = (p * w - h * A - f * _) * B, t1[4] = (l * I - a * T - u * k) * B, t1[5] = (r * T - i * I + s * k) * B, t1[6] = (m * b - d * A - g * v) * B, t1[7] = (c * A - p * b + f * v) * B, t1[8] = (a * z - o * I + u * S) * B, t1[9] = (n * I - r * z - s * S) * B, t1[10] = (d * w - y * b + g * x) * B, t1[11] = (h * b - c * w - f * x) * B, t1[12] = (o * k - a * M - l * S) * B, t1[13] = (r * M - n * k + i * S) * B, t1[14] = (y * v - d * _ - m * x) * B, t1[15] = (c * _ - h * v + p * x) * B, t1) : null;
        }
        function Ml(t1, e1, r) {
            var n = e1[0], i = e1[1], s = e1[2], a = e1[3], o = e1[4], l = e1[5], u = e1[6], c = e1[7], h = e1[8], p = e1[9], f = e1[10], d = e1[11], y = e1[12], m = e1[13], g = e1[14], x = e1[15], v = r[0], b = r[1], _ = r[2], w = r[3];
            return t1[0] = v * n + b * o + _ * h + w * y, t1[1] = v * i + b * l + _ * p + w * m, t1[2] = v * s + b * u + _ * f + w * g, t1[3] = v * a + b * c + _ * d + w * x, t1[4] = (v = r[4]) * n + (b = r[5]) * o + (_ = r[6]) * h + (w = r[7]) * y, t1[5] = v * i + b * l + _ * p + w * m, t1[6] = v * s + b * u + _ * f + w * g, t1[7] = v * a + b * c + _ * d + w * x, t1[8] = (v = r[8]) * n + (b = r[9]) * o + (_ = r[10]) * h + (w = r[11]) * y, t1[9] = v * i + b * l + _ * p + w * m, t1[10] = v * s + b * u + _ * f + w * g, t1[11] = v * a + b * c + _ * d + w * x, t1[12] = (v = r[12]) * n + (b = r[13]) * o + (_ = r[14]) * h + (w = r[15]) * y, t1[13] = v * i + b * l + _ * p + w * m, t1[14] = v * s + b * u + _ * f + w * g, t1[15] = v * a + b * c + _ * d + w * x, t1;
        }
        function zl(t1, e1, r) {
            var n, i, s, a, o, l, u, c, h, p, f, d, y = r[0], m = r[1], g = r[2];
            return e1 === t1 ? (t1[12] = e1[0] * y + e1[4] * m + e1[8] * g + e1[12], t1[13] = e1[1] * y + e1[5] * m + e1[9] * g + e1[13], t1[14] = e1[2] * y + e1[6] * m + e1[10] * g + e1[14], t1[15] = e1[3] * y + e1[7] * m + e1[11] * g + e1[15]) : (i = e1[1], s = e1[2], a = e1[3], o = e1[4], l = e1[5], u = e1[6], c = e1[7], h = e1[8], p = e1[9], f = e1[10], d = e1[11], t1[0] = n = e1[0], t1[1] = i, t1[2] = s, t1[3] = a, t1[4] = o, t1[5] = l, t1[6] = u, t1[7] = c, t1[8] = h, t1[9] = p, t1[10] = f, t1[11] = d, t1[12] = n * y + o * m + h * g + e1[12], t1[13] = i * y + l * m + p * g + e1[13], t1[14] = s * y + u * m + f * g + e1[14], t1[15] = a * y + c * m + d * g + e1[15]), t1;
        }
        function Tl(t1, e1, r) {
            var n = r[0], i = r[1], s = r[2];
            return t1[0] = e1[0] * n, t1[1] = e1[1] * n, t1[2] = e1[2] * n, t1[3] = e1[3] * n, t1[4] = e1[4] * i, t1[5] = e1[5] * i, t1[6] = e1[6] * i, t1[7] = e1[7] * i, t1[8] = e1[8] * s, t1[9] = e1[9] * s, t1[10] = e1[10] * s, t1[11] = e1[11] * s, t1[12] = e1[12], t1[13] = e1[13], t1[14] = e1[14], t1[15] = e1[15], t1;
        }
        function Bl(t1, e1, r) {
            var n = Math.sin(r), i = Math.cos(r), s = e1[4], a = e1[5], o = e1[6], l = e1[7], u = e1[8], c = e1[9], h = e1[10], p = e1[11];
            return e1 !== t1 && (t1[0] = e1[0], t1[1] = e1[1], t1[2] = e1[2], t1[3] = e1[3], t1[12] = e1[12], t1[13] = e1[13], t1[14] = e1[14], t1[15] = e1[15]), t1[4] = s * i + u * n, t1[5] = a * i + c * n, t1[6] = o * i + h * n, t1[7] = l * i + p * n, t1[8] = u * i - s * n, t1[9] = c * i - a * n, t1[10] = h * i - o * n, t1[11] = p * i - l * n, t1;
        }
        function El(t1, e1, r) {
            var n = Math.sin(r), i = Math.cos(r), s = e1[0], a = e1[1], o = e1[2], l = e1[3], u = e1[8], c = e1[9], h = e1[10], p = e1[11];
            return e1 !== t1 && (t1[4] = e1[4], t1[5] = e1[5], t1[6] = e1[6], t1[7] = e1[7], t1[12] = e1[12], t1[13] = e1[13], t1[14] = e1[14], t1[15] = e1[15]), t1[0] = s * i - u * n, t1[1] = a * i - c * n, t1[2] = o * i - h * n, t1[3] = l * i - p * n, t1[8] = s * n + u * i, t1[9] = a * n + c * i, t1[10] = o * n + h * i, t1[11] = l * n + p * i, t1;
        }
        function Pl(t1, e1) {
            return t1[0] = e1[0], t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[5] = e1[1], t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[10] = e1[2], t1[11] = 0, t1[12] = 0, t1[13] = 0, t1[14] = 0, t1[15] = 1, t1;
        }
        function Cl(t1, e1, r) {
            var n, i, s, a = r[0], o = r[1], l = r[2], u = Math.hypot(a, o, l);
            return u < _l ? null : (a *= u = 1 / u, o *= u, l *= u, n = Math.sin(e1), i = Math.cos(e1), t1[0] = a * a * (s = 1 - i) + i, t1[1] = o * a * s + l * n, t1[2] = l * a * s - o * n, t1[3] = 0, t1[4] = a * o * s - l * n, t1[5] = o * o * s + i, t1[6] = l * o * s + a * n, t1[7] = 0, t1[8] = a * l * s + o * n, t1[9] = o * l * s - a * n, t1[10] = l * l * s + i, t1[11] = 0, t1[12] = 0, t1[13] = 0, t1[14] = 0, t1[15] = 1, t1);
        }
        Math.hypot || (Math.hypot = function() {
            for(var t1 = 0, e1 = arguments.length; e1--;)t1 += arguments[e1] * arguments[e1];
            return Math.sqrt(t1);
        });
        var Dl = Ml;
        function Vl() {
            var t1 = new wl(3);
            return wl != Float32Array && (t1[0] = 0, t1[1] = 0, t1[2] = 0), t1;
        }
        function Fl(t1) {
            var e1 = new wl(3);
            return e1[0] = t1[0], e1[1] = t1[1], e1[2] = t1[2], e1;
        }
        function Ll(t1) {
            return Math.hypot(t1[0], t1[1], t1[2]);
        }
        function Rl(t1, e1, r) {
            var n = new wl(3);
            return n[0] = t1, n[1] = e1, n[2] = r, n;
        }
        function Ul(t1, e1, r) {
            return t1[0] = e1[0] + r[0], t1[1] = e1[1] + r[1], t1[2] = e1[2] + r[2], t1;
        }
        function jl(t1, e1, r) {
            return t1[0] = e1[0] - r[0], t1[1] = e1[1] - r[1], t1[2] = e1[2] - r[2], t1;
        }
        function $l(t1, e1, r) {
            return t1[0] = e1[0] * r[0], t1[1] = e1[1] * r[1], t1[2] = e1[2] * r[2], t1;
        }
        function Ol(t1, e1, r) {
            return t1[0] = Math.min(e1[0], r[0]), t1[1] = Math.min(e1[1], r[1]), t1[2] = Math.min(e1[2], r[2]), t1;
        }
        function ql(t1, e1, r) {
            return t1[0] = Math.max(e1[0], r[0]), t1[1] = Math.max(e1[1], r[1]), t1[2] = Math.max(e1[2], r[2]), t1;
        }
        function Nl(t1, e1, r) {
            return t1[0] = e1[0] * r, t1[1] = e1[1] * r, t1[2] = e1[2] * r, t1;
        }
        function Gl(t1, e1, r, n) {
            return t1[0] = e1[0] + r[0] * n, t1[1] = e1[1] + r[1] * n, t1[2] = e1[2] + r[2] * n, t1;
        }
        function Zl(t1, e1) {
            var r = e1[0], n = e1[1], i = e1[2], s = r * r + n * n + i * i;
            return s > 0 && (s = 1 / Math.sqrt(s)), t1[0] = e1[0] * s, t1[1] = e1[1] * s, t1[2] = e1[2] * s, t1;
        }
        function Xl(t1, e1) {
            return t1[0] * e1[0] + t1[1] * e1[1] + t1[2] * e1[2];
        }
        function Kl(t1, e1, r) {
            var n = e1[0], i = e1[1], s = e1[2], a = r[0], o = r[1], l = r[2];
            return t1[0] = i * l - s * o, t1[1] = s * a - n * l, t1[2] = n * o - i * a, t1;
        }
        function Hl(t1, e1, r) {
            var n = e1[0], i = e1[1], s = e1[2], a = r[3] * n + r[7] * i + r[11] * s + r[15];
            return t1[0] = (r[0] * n + r[4] * i + r[8] * s + r[12]) / (a = a || 1), t1[1] = (r[1] * n + r[5] * i + r[9] * s + r[13]) / a, t1[2] = (r[2] * n + r[6] * i + r[10] * s + r[14]) / a, t1;
        }
        function Yl(t1, e1, r) {
            var n = r[0], i = r[1], s = r[2], a = e1[0], o = e1[1], l = e1[2], u = i * l - s * o, c = s * a - n * l, h = n * o - i * a, p = i * h - s * c, f = s * u - n * h, d = n * c - i * u, y = 2 * r[3];
            return c *= y, h *= y, f *= 2, d *= 2, t1[0] = a + (u *= y) + (p *= 2), t1[1] = o + c + f, t1[2] = l + h + d, t1;
        }
        var Wl, Jl = jl, Ql = $l, tu = Ll;
        function eu(t1, e1, r) {
            return t1[0] = e1[0] * r, t1[1] = e1[1] * r, t1[2] = e1[2] * r, t1[3] = e1[3] * r, t1;
        }
        function ru(t1, e1) {
            var r = e1[0], n = e1[1], i = e1[2], s = e1[3], a = r * r + n * n + i * i + s * s;
            return a > 0 && (a = 1 / Math.sqrt(a)), t1[0] = r * a, t1[1] = n * a, t1[2] = i * a, t1[3] = s * a, t1;
        }
        function nu(t1, e1, r) {
            var n = e1[0], i = e1[1], s = e1[2], a = e1[3];
            return t1[0] = r[0] * n + r[4] * i + r[8] * s + r[12] * a, t1[1] = r[1] * n + r[5] * i + r[9] * s + r[13] * a, t1[2] = r[2] * n + r[6] * i + r[10] * s + r[14] * a, t1[3] = r[3] * n + r[7] * i + r[11] * s + r[15] * a, t1;
        }
        function iu() {
            var t1 = new wl(4);
            return wl != Float32Array && (t1[0] = 0, t1[1] = 0, t1[2] = 0), t1[3] = 1, t1;
        }
        function su(t1) {
            return t1[0] = 0, t1[1] = 0, t1[2] = 0, t1[3] = 1, t1;
        }
        function au(t1, e1, r) {
            r *= .5;
            var n = e1[0], i = e1[1], s = e1[2], a = e1[3], o = Math.sin(r), l = Math.cos(r);
            return t1[0] = n * l + a * o, t1[1] = i * l + s * o, t1[2] = s * l - i * o, t1[3] = a * l - n * o, t1;
        }
        function ou(t1, e1, r) {
            r *= .5;
            var n = e1[0], i = e1[1], s = e1[2], a = e1[3], o = Math.sin(r), l = Math.cos(r);
            return t1[0] = n * l - s * o, t1[1] = i * l + a * o, t1[2] = s * l + n * o, t1[3] = a * l - i * o, t1;
        }
        Vl(), Wl = new wl(4), wl != Float32Array && (Wl[0] = 0, Wl[1] = 0, Wl[2] = 0, Wl[3] = 0);
        var lu = ru;
        Vl(), Rl(1, 0, 0), Rl(0, 1, 0), iu(), iu(), Al();
        class uu {
            constructor(t1, e1){
                this.pos = t1, this.dir = e1;
            }
            intersectsPlane(t1, e1, r) {
                const n = Xl(e1, this.dir);
                if (Math.abs(n) < 1e-6) return !1;
                const i = ((t1[0] - this.pos[0]) * e1[0] + (t1[1] - this.pos[1]) * e1[1] + (t1[2] - this.pos[2]) * e1[2]) / n;
                return r[0] = this.pos[0] + this.dir[0] * i, r[1] = this.pos[1] + this.dir[1] * i, r[2] = this.pos[2] + this.dir[2] * i, !0;
            }
            closestPointOnSphere(t1, e1, r) {
                if (function(t1, e1) {
                    var r = t1[0], n = t1[1], i = t1[2], s = e1[0], a = e1[1], o = e1[2];
                    return Math.abs(r - s) <= _l * Math.max(1, Math.abs(r), Math.abs(s)) && Math.abs(n - a) <= _l * Math.max(1, Math.abs(n), Math.abs(a)) && Math.abs(i - o) <= _l * Math.max(1, Math.abs(i), Math.abs(o));
                }(this.pos, t1) || 0 === e1) return r[0] = r[1] = r[2] = 0, !1;
                const [n, i, s] = this.dir, a = this.pos[0] - t1[0], o = this.pos[1] - t1[1], l = this.pos[2] - t1[2], u = n * n + i * i + s * s, c = 2 * (a * n + o * i + l * s), h = c * c - 4 * u * (a * a + o * o + l * l - e1 * e1);
                if (h < 0) {
                    const t2 = Math.max(-c / 2, 0), u1 = a + n * t2, h1 = o + i * t2, p = l + s * t2, f = Math.hypot(u1, h1, p);
                    return r[0] = u1 * e1 / f, r[1] = h1 * e1 / f, r[2] = p * e1 / f, !1;
                }
                {
                    const t3 = (-c - Math.sqrt(h)) / (2 * u);
                    if (t3 < 0) {
                        const t4 = Math.hypot(a, o, l);
                        return r[0] = a * e1 / t4, r[1] = o * e1 / t4, r[2] = l * e1 / t4, !1;
                    }
                    return r[0] = a + n * t3, r[1] = o + i * t3, r[2] = l + s * t3, !0;
                }
            }
        }
        class cu {
            constructor(t1, e1, r, n, i){
                this.TL = t1, this.TR = e1, this.BR = r, this.BL = n, this.horizon = i;
            }
            static fromInvProjectionMatrix(t1, e1, r) {
                const n = [
                    -1,
                    1,
                    1
                ], i = [
                    1,
                    1,
                    1
                ], s = [
                    1,
                    -1,
                    1
                ], a = [
                    -1,
                    -1,
                    1
                ], o = Hl(n, n, t1), l = Hl(i, i, t1), u = Hl(s, s, t1), c = Hl(a, a, t1);
                return new cu(o, l, u, c, e1 / r);
            }
        }
        class hu {
            constructor(t1, e1){
                this.points = t1, this.planes = e1;
            }
            static fromInvProjectionMatrix(t1, e1, r, n) {
                const i = Math.pow(2, r), s = [
                    [
                        -1,
                        1,
                        -1,
                        1
                    ],
                    [
                        1,
                        1,
                        -1,
                        1
                    ],
                    [
                        1,
                        -1,
                        -1,
                        1
                    ],
                    [
                        -1,
                        -1,
                        -1,
                        1
                    ],
                    [
                        -1,
                        1,
                        1,
                        1
                    ],
                    [
                        1,
                        1,
                        1,
                        1
                    ],
                    [
                        1,
                        -1,
                        1,
                        1
                    ],
                    [
                        -1,
                        -1,
                        1,
                        1
                    ]
                ].map((r)=>{
                    const s = nu([], r, t1), a = 1 / s[3] / e1 * i;
                    return function(t1, e1, r) {
                        return t1[0] = e1[0] * r[0], t1[1] = e1[1] * r[1], t1[2] = e1[2] * r[2], t1[3] = e1[3] * r[3], t1;
                    }(s, s, [
                        a,
                        a,
                        n ? 1 / s[3] : a,
                        a
                    ]);
                }), a = [
                    [
                        0,
                        1,
                        2
                    ],
                    [
                        6,
                        5,
                        4
                    ],
                    [
                        0,
                        3,
                        7
                    ],
                    [
                        2,
                        1,
                        5
                    ],
                    [
                        3,
                        2,
                        6
                    ],
                    [
                        0,
                        4,
                        5
                    ]
                ].map((t1)=>{
                    const e1 = Zl([], Kl([], Jl([], s[t1[0]], s[t1[1]]), Jl([], s[t1[2]], s[t1[1]]))), r = -Xl(e1, s[t1[1]]);
                    return e1.concat(r);
                });
                return new hu(s, a);
            }
        }
        class pu {
            static fromPoints(t1) {
                const e1 = [
                    1 / 0,
                    1 / 0,
                    1 / 0
                ], r = [
                    -1 / 0,
                    -1 / 0,
                    -1 / 0
                ];
                for (const n of t1)Ol(e1, e1, n), ql(r, r, n);
                return new pu(e1, r);
            }
            static applyTransform(t1, e1) {
                const r = t1.getCorners();
                for(let t2 = 0; t2 < r.length; ++t2)Hl(r[t2], r[t2], e1);
                return pu.fromPoints(r);
            }
            constructor(t1, e1){
                this.min = t1, this.max = e1, this.center = Nl([], Ul([], this.min, this.max), .5);
            }
            quadrant(t1) {
                const e1 = [
                    t1 % 2 == 0,
                    t1 < 2
                ], r = Fl(this.min), n = Fl(this.max);
                for(let t2 = 0; t2 < e1.length; t2++)r[t2] = e1[t2] ? this.min[t2] : this.center[t2], n[t2] = e1[t2] ? this.center[t2] : this.max[t2];
                return n[2] = this.max[2], new pu(r, n);
            }
            distanceX(t1) {
                return Math.max(Math.min(this.max[0], t1[0]), this.min[0]) - t1[0];
            }
            distanceY(t1) {
                return Math.max(Math.min(this.max[1], t1[1]), this.min[1]) - t1[1];
            }
            distanceZ(t1) {
                return Math.max(Math.min(this.max[2], t1[2]), this.min[2]) - t1[2];
            }
            getCorners() {
                const t1 = this.min, e1 = this.max;
                return [
                    [
                        t1[0],
                        t1[1],
                        t1[2]
                    ],
                    [
                        e1[0],
                        t1[1],
                        t1[2]
                    ],
                    [
                        e1[0],
                        e1[1],
                        t1[2]
                    ],
                    [
                        t1[0],
                        e1[1],
                        t1[2]
                    ],
                    [
                        t1[0],
                        t1[1],
                        e1[2]
                    ],
                    [
                        e1[0],
                        t1[1],
                        e1[2]
                    ],
                    [
                        e1[0],
                        e1[1],
                        e1[2]
                    ],
                    [
                        t1[0],
                        e1[1],
                        e1[2]
                    ]
                ];
            }
            intersects(t1) {
                const e1 = this.getCorners();
                let r = !0;
                for(let n = 0; n < t1.planes.length; n++){
                    const i = t1.planes[n];
                    let s = 0;
                    for(let t2 = 0; t2 < e1.length; t2++)s += Xl(i, e1[t2]) + i[3] >= 0;
                    if (0 === s) return 0;
                    s !== e1.length && (r = !1);
                }
                if (r) return 2;
                for(let e2 = 0; e2 < 3; e2++){
                    let r1 = Number.MAX_VALUE, n1 = -Number.MAX_VALUE;
                    for(let i1 = 0; i1 < t1.points.length; i1++){
                        const s1 = t1.points[i1][e2] - this.min[e2];
                        r1 = Math.min(r1, s1), n1 = Math.max(n1, s1);
                    }
                    if (n1 < 0 || r1 > this.max[e2] - this.min[e2]) return 0;
                }
                return 1;
            }
        }
        function fu(t1, e1, r, n, i, s, a, o, l) {
            if (s && t1.queryGeometry.isAboveHorizon) return !1;
            s && (l *= t1.pixelToTileUnitsFactor);
            const u = t1.tileID.canonical, c = r.projection.upVectorScale(u, r.center.lat, r.worldSize).metersToTile;
            for (const h of e1)for (const e2 of h){
                const h1 = e2.add(o), p = i && r.elevation ? r.elevation.exaggeration() * i.getElevationAt(h1.x, h1.y, !0) : 0, f = r.projection.projectTilePoint(h1.x, h1.y, u);
                if (p > 0) {
                    const t2 = r.projection.upVector(u, h1.x, h1.y);
                    f.x += t2[0] * c * p, f.y += t2[1] * c * p, f.z += t2[2] * c * p;
                }
                const d = s ? h1 : du(f.x, f.y, f.z, n), y = s ? t1.tilespaceRays.map((t1)=>gu(t1, p)) : t1.queryGeometry.screenGeometry, m = nu([], [
                    f.x,
                    f.y,
                    f.z,
                    1
                ], n);
                if (!a && s ? l *= m[3] / r.cameraToCenterDistance : a && !s && (l *= r.cameraToCenterDistance / m[3]), s) {
                    const t3 = jo((e2.y / Bo + u.y) / (1 << u.z));
                    l /= r.projection.pixelsPerMeter(t3, 1) / Ro(1, t3);
                }
                if (il(y, d, l)) return !0;
            }
            return !1;
        }
        function du(t1, e1, r, n) {
            const i = nu([], [
                t1,
                e1,
                r,
                1
            ], n);
            return new d(i[0] / i[3], i[1] / i[3]);
        }
        const yu = Rl(0, 0, 0), mu = Rl(0, 0, 1);
        function gu(t1, e1) {
            const r = Vl();
            return yu[2] = e1, t1.intersectsPlane(yu, mu, r), new d(r[0], r[1]);
        }
        class xu extends rl {
        }
        function vu(t1, { width: e1 , height: r  }, n, i) {
            if (i) {
                if (i instanceof Uint8ClampedArray) i = new Uint8Array(i.buffer);
                else if (i.length !== e1 * r * n) throw new RangeError("mismatched image size");
            } else i = new Uint8Array(e1 * r * n);
            return t1.width = e1, t1.height = r, t1.data = i, t1;
        }
        function bu(t1, e1, r) {
            const { width: n , height: i  } = e1;
            n === t1.width && i === t1.height || (_u(t1, e1, {
                x: 0,
                y: 0
            }, {
                x: 0,
                y: 0
            }, {
                width: Math.min(t1.width, n),
                height: Math.min(t1.height, i)
            }, r), t1.width = n, t1.height = i, t1.data = e1.data);
        }
        function _u(t1, e1, r, n, i, s) {
            if (0 === i.width || 0 === i.height) return e1;
            if (i.width > t1.width || i.height > t1.height || r.x > t1.width - i.width || r.y > t1.height - i.height) throw new RangeError("out of range source coordinates for image copy");
            if (i.width > e1.width || i.height > e1.height || n.x > e1.width - i.width || n.y > e1.height - i.height) throw new RangeError("out of range destination coordinates for image copy");
            const a = t1.data, o = e1.data;
            for(let l = 0; l < i.height; l++){
                const u = ((r.y + l) * t1.width + r.x) * s, c = ((n.y + l) * e1.width + n.x) * s;
                for(let t2 = 0; t2 < i.width * s; t2++)o[c + t2] = a[u + t2];
            }
            return e1;
        }
        ji(xu, "HeatmapBucket", {
            omit: [
                "layers"
            ]
        });
        class wu {
            constructor(t1, e1){
                vu(this, t1, 1, e1);
            }
            resize(t1) {
                bu(this, new wu(t1), 1);
            }
            clone() {
                return new wu({
                    width: this.width,
                    height: this.height
                }, new Uint8Array(this.data));
            }
            static copy(t1, e1, r, n, i) {
                _u(t1, e1, r, n, i, 1);
            }
        }
        class Au {
            constructor(t1, e1){
                vu(this, t1, 4, e1);
            }
            resize(t1) {
                bu(this, new Au(t1), 4);
            }
            replace(t1, e1) {
                e1 ? this.data.set(t1) : this.data = t1 instanceof Uint8ClampedArray ? new Uint8Array(t1.buffer) : t1;
            }
            clone() {
                return new Au({
                    width: this.width,
                    height: this.height
                }, new Uint8Array(this.data));
            }
            static copy(t1, e1, r, n, i) {
                _u(t1, e1, r, n, i, 4);
            }
        }
        ji(wu, "AlphaImage"), ji(Au, "RGBAImage");
        var Su = {
            paint: new Qs({
                "heatmap-radius": new Hs(Ht.paint_heatmap["heatmap-radius"]),
                "heatmap-weight": new Hs(Ht.paint_heatmap["heatmap-weight"]),
                "heatmap-intensity": new Ks(Ht.paint_heatmap["heatmap-intensity"]),
                "heatmap-color": new Js(Ht.paint_heatmap["heatmap-color"]),
                "heatmap-opacity": new Ks(Ht.paint_heatmap["heatmap-opacity"])
            })
        };
        function ku(t1) {
            const e1 = {}, r = t1.resolution || 256, n = t1.clips ? t1.clips.length : 1, i = t1.image || new Au({
                width: r,
                height: n
            }), s = (r, n, s)=>{
                e1[t1.evaluationKey] = s;
                const a = t1.expression.evaluate(e1);
                i.data[r + n + 0] = Math.floor(255 * a.r / a.a), i.data[r + n + 1] = Math.floor(255 * a.g / a.a), i.data[r + n + 2] = Math.floor(255 * a.b / a.a), i.data[r + n + 3] = Math.floor(255 * a.a);
            };
            if (t1.clips) for(let e2 = 0, i1 = 0; e2 < n; ++e2, i1 += 4 * r)for(let n1 = 0, a = 0; n1 < r; n1++, a += 4){
                const o = n1 / (r - 1), { start: l , end: u  } = t1.clips[e2];
                s(i1, a, l * (1 - o) + u * o);
            }
            else for(let t2 = 0, e3 = 0; t2 < r; t2++, e3 += 4)s(0, e3, t2 / (r - 1));
            return i;
        }
        var Iu = {
            paint: new Qs({
                "hillshade-illumination-direction": new Ks(Ht.paint_hillshade["hillshade-illumination-direction"]),
                "hillshade-illumination-anchor": new Ks(Ht.paint_hillshade["hillshade-illumination-anchor"]),
                "hillshade-exaggeration": new Ks(Ht.paint_hillshade["hillshade-exaggeration"]),
                "hillshade-shadow-color": new Ks(Ht.paint_hillshade["hillshade-shadow-color"]),
                "hillshade-highlight-color": new Ks(Ht.paint_hillshade["hillshade-highlight-color"]),
                "hillshade-accent-color": new Ks(Ht.paint_hillshade["hillshade-accent-color"])
            })
        };
        const Mu = ia([
            {
                name: "a_pos",
                components: 2,
                type: "Int16"
            }
        ], 4), { members: zu  } = Mu;
        var Tu = {
            exports: {}
        };
        function Bu(t1, e1, r) {
            r = r || 2;
            var n, i, s, a, o, l, u, c = e1 && e1.length, h = c ? e1[0] * r : t1.length, p = Eu(t1, 0, h, r, !0), f = [];
            if (!p || p.next === p.prev) return f;
            if (c && (p = function(t1, e1, r, n) {
                var i, s, a, o = [];
                for(i = 0, s = e1.length; i < s; i++)(a = Eu(t1, e1[i] * n, i < s - 1 ? e1[i + 1] * n : t1.length, n, !1)) === a.next && (a.steiner = !0), o.push(Ou(a));
                for(o.sort(Ru), i = 0; i < o.length; i++)r = Uu(o[i], r);
                return r;
            }(t1, e1, p, r)), t1.length > 80 * r) {
                n = s = t1[0], i = a = t1[1];
                for(var d = r; d < h; d += r)(o = t1[d]) < n && (n = o), (l = t1[d + 1]) < i && (i = l), o > s && (s = o), l > a && (a = l);
                u = 0 !== (u = Math.max(s - n, a - i)) ? 32767 / u : 0;
            }
            return Cu(p, f, r, n, i, u, 0), f;
        }
        function Eu(t1, e1, r, n, i) {
            var s, a;
            if (i === ec(t1, e1, r, n) > 0) for(s = e1; s < r; s += n)a = Ju(s, t1[s], t1[s + 1], a);
            else for(s = r - n; s >= e1; s -= n)a = Ju(s, t1[s], t1[s + 1], a);
            return a && Zu(a, a.next) && (Qu(a), a = a.next), a;
        }
        function Pu(t1, e1) {
            if (!t1) return t1;
            e1 || (e1 = t1);
            var r, n = t1;
            do if (r = !1, n.steiner || !Zu(n, n.next) && 0 !== Gu(n.prev, n, n.next)) n = n.next;
            else {
                if (Qu(n), (n = e1 = n.prev) === n.next) break;
                r = !0;
            }
            while (r || n !== e1);
            return e1;
        }
        function Cu(t1, e1, r, n, i, s, a) {
            if (t1) {
                !a && s && function(t1, e1, r, n) {
                    var i = t1;
                    do 0 === i.z && (i.z = $u(i.x, i.y, e1, r, n)), i.prevZ = i.prev, i.nextZ = i.next, i = i.next;
                    while (i !== t1);
                    i.prevZ.nextZ = null, i.prevZ = null, function(t1) {
                        var e1, r, n, i, s, a, o, l, u = 1;
                        do {
                            for(r = t1, t1 = null, s = null, a = 0; r;){
                                for(a++, n = r, o = 0, e1 = 0; e1 < u && (o++, n = n.nextZ); e1++);
                                for(l = u; o > 0 || l > 0 && n;)0 !== o && (0 === l || !n || r.z <= n.z) ? (i = r, r = r.nextZ, o--) : (i = n, n = n.nextZ, l--), s ? s.nextZ = i : t1 = i, i.prevZ = s, s = i;
                                r = n;
                            }
                            s.nextZ = null, u *= 2;
                        }while (a > 1);
                    }(i);
                }(t1, n, i, s);
                for(var o, l, u = t1; t1.prev !== t1.next;)if (o = t1.prev, l = t1.next, s ? Vu(t1, n, i, s) : Du(t1)) e1.push(o.i / r | 0), e1.push(t1.i / r | 0), e1.push(l.i / r | 0), Qu(t1), t1 = l.next, u = l.next;
                else if ((t1 = l) === u) {
                    a ? 1 === a ? Cu(t1 = Fu(Pu(t1), e1, r), e1, r, n, i, s, 2) : 2 === a && Lu(t1, e1, r, n, i, s) : Cu(Pu(t1), e1, r, n, i, s, 1);
                    break;
                }
            }
        }
        function Du(t1) {
            var e1 = t1.prev, r = t1, n = t1.next;
            if (Gu(e1, r, n) >= 0) return !1;
            for(var i = e1.x, s = r.x, a = n.x, o = e1.y, l = r.y, u = n.y, c = i < s ? i < a ? i : a : s < a ? s : a, h = o < l ? o < u ? o : u : l < u ? l : u, p = i > s ? i > a ? i : a : s > a ? s : a, f = o > l ? o > u ? o : u : l > u ? l : u, d = n.next; d !== e1;){
                if (d.x >= c && d.x <= p && d.y >= h && d.y <= f && qu(i, o, s, l, a, u, d.x, d.y) && Gu(d.prev, d, d.next) >= 0) return !1;
                d = d.next;
            }
            return !0;
        }
        function Vu(t1, e1, r, n) {
            var i = t1.prev, s = t1, a = t1.next;
            if (Gu(i, s, a) >= 0) return !1;
            for(var o = i.x, l = s.x, u = a.x, c = i.y, h = s.y, p = a.y, f = o < l ? o < u ? o : u : l < u ? l : u, d = c < h ? c < p ? c : p : h < p ? h : p, y = o > l ? o > u ? o : u : l > u ? l : u, m = c > h ? c > p ? c : p : h > p ? h : p, g = $u(f, d, e1, r, n), x = $u(y, m, e1, r, n), v = t1.prevZ, b = t1.nextZ; v && v.z >= g && b && b.z <= x;){
                if (v.x >= f && v.x <= y && v.y >= d && v.y <= m && v !== i && v !== a && qu(o, c, l, h, u, p, v.x, v.y) && Gu(v.prev, v, v.next) >= 0) return !1;
                if (v = v.prevZ, b.x >= f && b.x <= y && b.y >= d && b.y <= m && b !== i && b !== a && qu(o, c, l, h, u, p, b.x, b.y) && Gu(b.prev, b, b.next) >= 0) return !1;
                b = b.nextZ;
            }
            for(; v && v.z >= g;){
                if (v.x >= f && v.x <= y && v.y >= d && v.y <= m && v !== i && v !== a && qu(o, c, l, h, u, p, v.x, v.y) && Gu(v.prev, v, v.next) >= 0) return !1;
                v = v.prevZ;
            }
            for(; b && b.z <= x;){
                if (b.x >= f && b.x <= y && b.y >= d && b.y <= m && b !== i && b !== a && qu(o, c, l, h, u, p, b.x, b.y) && Gu(b.prev, b, b.next) >= 0) return !1;
                b = b.nextZ;
            }
            return !0;
        }
        function Fu(t1, e1, r) {
            var n = t1;
            do {
                var i = n.prev, s = n.next.next;
                !Zu(i, s) && Xu(i, n, n.next, s) && Yu(i, s) && Yu(s, i) && (e1.push(i.i / r | 0), e1.push(n.i / r | 0), e1.push(s.i / r | 0), Qu(n), Qu(n.next), n = t1 = s), n = n.next;
            }while (n !== t1);
            return Pu(n);
        }
        function Lu(t1, e1, r, n, i, s) {
            var a = t1;
            do {
                for(var o = a.next.next; o !== a.prev;){
                    if (a.i !== o.i && Nu(a, o)) {
                        var l = Wu(a, o);
                        return a = Pu(a, a.next), l = Pu(l, l.next), Cu(a, e1, r, n, i, s, 0), void Cu(l, e1, r, n, i, s, 0);
                    }
                    o = o.next;
                }
                a = a.next;
            }while (a !== t1);
        }
        function Ru(t1, e1) {
            return t1.x - e1.x;
        }
        function Uu(t1, e1) {
            var r = function(t1, e1) {
                var r, n = e1, i = t1.x, s = t1.y, a = -1 / 0;
                do {
                    if (s <= n.y && s >= n.next.y && n.next.y !== n.y) {
                        var o = n.x + (s - n.y) * (n.next.x - n.x) / (n.next.y - n.y);
                        if (o <= i && o > a && (a = o, r = n.x < n.next.x ? n : n.next, o === i)) return r;
                    }
                    n = n.next;
                }while (n !== e1);
                if (!r) return null;
                var l, u = r, c = r.x, h = r.y, p = 1 / 0;
                n = r;
                do i >= n.x && n.x >= c && i !== n.x && qu(s < h ? i : a, s, c, h, s < h ? a : i, s, n.x, n.y) && (l = Math.abs(s - n.y) / (i - n.x), Yu(n, t1) && (l < p || l === p && (n.x > r.x || n.x === r.x && ju(r, n))) && (r = n, p = l)), n = n.next;
                while (n !== u);
                return r;
            }(t1, e1);
            if (!r) return e1;
            var n = Wu(r, t1);
            return Pu(n, n.next), Pu(r, r.next);
        }
        function ju(t1, e1) {
            return Gu(t1.prev, t1, e1.prev) < 0 && Gu(e1.next, t1, t1.next) < 0;
        }
        function $u(t1, e1, r, n, i) {
            return (t1 = 1431655765 & ((t1 = 858993459 & ((t1 = 252645135 & ((t1 = 16711935 & ((t1 = (t1 - r) * i | 0) | t1 << 8)) | t1 << 4)) | t1 << 2)) | t1 << 1)) | (e1 = 1431655765 & ((e1 = 858993459 & ((e1 = 252645135 & ((e1 = 16711935 & ((e1 = (e1 - n) * i | 0) | e1 << 8)) | e1 << 4)) | e1 << 2)) | e1 << 1)) << 1;
        }
        function Ou(t1) {
            var e1 = t1, r = t1;
            do (e1.x < r.x || e1.x === r.x && e1.y < r.y) && (r = e1), e1 = e1.next;
            while (e1 !== t1);
            return r;
        }
        function qu(t1, e1, r, n, i, s, a, o) {
            return (i - a) * (e1 - o) >= (t1 - a) * (s - o) && (t1 - a) * (n - o) >= (r - a) * (e1 - o) && (r - a) * (s - o) >= (i - a) * (n - o);
        }
        function Nu(t1, e1) {
            return t1.next.i !== e1.i && t1.prev.i !== e1.i && !function(t1, e1) {
                var r = t1;
                do {
                    if (r.i !== t1.i && r.next.i !== t1.i && r.i !== e1.i && r.next.i !== e1.i && Xu(r, r.next, t1, e1)) return !0;
                    r = r.next;
                }while (r !== t1);
                return !1;
            }(t1, e1) && (Yu(t1, e1) && Yu(e1, t1) && function(t1, e1) {
                var r = t1, n = !1, i = (t1.x + e1.x) / 2, s = (t1.y + e1.y) / 2;
                do r.y > s != r.next.y > s && r.next.y !== r.y && i < (r.next.x - r.x) * (s - r.y) / (r.next.y - r.y) + r.x && (n = !n), r = r.next;
                while (r !== t1);
                return n;
            }(t1, e1) && (Gu(t1.prev, t1, e1.prev) || Gu(t1, e1.prev, e1)) || Zu(t1, e1) && Gu(t1.prev, t1, t1.next) > 0 && Gu(e1.prev, e1, e1.next) > 0);
        }
        function Gu(t1, e1, r) {
            return (e1.y - t1.y) * (r.x - e1.x) - (e1.x - t1.x) * (r.y - e1.y);
        }
        function Zu(t1, e1) {
            return t1.x === e1.x && t1.y === e1.y;
        }
        function Xu(t1, e1, r, n) {
            var i = Hu(Gu(t1, e1, r)), s = Hu(Gu(t1, e1, n)), a = Hu(Gu(r, n, t1)), o = Hu(Gu(r, n, e1));
            return i !== s && a !== o || !(0 !== i || !Ku(t1, r, e1)) || !(0 !== s || !Ku(t1, n, e1)) || !(0 !== a || !Ku(r, t1, n)) || !(0 !== o || !Ku(r, e1, n));
        }
        function Ku(t1, e1, r) {
            return e1.x <= Math.max(t1.x, r.x) && e1.x >= Math.min(t1.x, r.x) && e1.y <= Math.max(t1.y, r.y) && e1.y >= Math.min(t1.y, r.y);
        }
        function Hu(t1) {
            return t1 > 0 ? 1 : t1 < 0 ? -1 : 0;
        }
        function Yu(t1, e1) {
            return Gu(t1.prev, t1, t1.next) < 0 ? Gu(t1, e1, t1.next) >= 0 && Gu(t1, t1.prev, e1) >= 0 : Gu(t1, e1, t1.prev) < 0 || Gu(t1, t1.next, e1) < 0;
        }
        function Wu(t1, e1) {
            var r = new tc(t1.i, t1.x, t1.y), n = new tc(e1.i, e1.x, e1.y), i = t1.next, s = e1.prev;
            return t1.next = e1, e1.prev = t1, r.next = i, i.prev = r, n.next = r, r.prev = n, s.next = n, n.prev = s, n;
        }
        function Ju(t1, e1, r, n) {
            var i = new tc(t1, e1, r);
            return n ? (i.next = n.next, i.prev = n, n.next.prev = i, n.next = i) : (i.prev = i, i.next = i), i;
        }
        function Qu(t1) {
            t1.next.prev = t1.prev, t1.prev.next = t1.next, t1.prevZ && (t1.prevZ.nextZ = t1.nextZ), t1.nextZ && (t1.nextZ.prevZ = t1.prevZ);
        }
        function tc(t1, e1, r) {
            this.i = t1, this.x = e1, this.y = r, this.prev = null, this.next = null, this.z = 0, this.prevZ = null, this.nextZ = null, this.steiner = !1;
        }
        function ec(t1, e1, r, n) {
            for(var i = 0, s = e1, a = r - n; s < r; s += n)i += (t1[a] - t1[s]) * (t1[s + 1] + t1[a + 1]), a = s;
            return i;
        }
        function rc(t1, e1, r, n, i) {
            nc(t1, e1, r || 0, n || t1.length - 1, i || sc);
        }
        function nc(t1, e1, r, n, i) {
            for(; n > r;){
                if (n - r > 600) {
                    var s = n - r + 1, a = e1 - r + 1, o = Math.log(s), l = .5 * Math.exp(2 * o / 3), u = .5 * Math.sqrt(o * l * (s - l) / s) * (a - s / 2 < 0 ? -1 : 1);
                    nc(t1, e1, Math.max(r, Math.floor(e1 - a * l / s + u)), Math.min(n, Math.floor(e1 + (s - a) * l / s + u)), i);
                }
                var c = t1[e1], h = r, p = n;
                for(ic(t1, r, e1), i(t1[n], c) > 0 && ic(t1, r, n); h < p;){
                    for(ic(t1, h, p), h++, p--; i(t1[h], c) < 0;)h++;
                    for(; i(t1[p], c) > 0;)p--;
                }
                0 === i(t1[r], c) ? ic(t1, r, p) : ic(t1, ++p, n), p <= e1 && (r = p + 1), e1 <= p && (n = p - 1);
            }
        }
        function ic(t1, e1, r) {
            var n = t1[e1];
            t1[e1] = t1[r], t1[r] = n;
        }
        function sc(t1, e1) {
            return t1 < e1 ? -1 : t1 > e1 ? 1 : 0;
        }
        function ac(t1, e1) {
            const r = t1.length;
            if (r <= 1) return [
                t1
            ];
            const n = [];
            let i, s;
            for(let e2 = 0; e2 < r; e2++){
                const r1 = q(t1[e2]);
                0 !== r1 && (t1[e2].area = Math.abs(r1), void 0 === s && (s = r1 < 0), s === r1 < 0 ? (i && n.push(i), i = [
                    t1[e2]
                ]) : i.push(t1[e2]));
            }
            if (i && n.push(i), e1 > 1) for(let t2 = 0; t2 < n.length; t2++)n[t2].length <= e1 || (rc(n[t2], e1, 1, n[t2].length - 1, oc), n[t2] = n[t2].slice(0, e1));
            return n;
        }
        function oc(t1, e1) {
            return e1.area - t1.area;
        }
        function lc(t1, e1, r) {
            const n = r.patternDependencies;
            let i = !1;
            for (const r1 of e1){
                const e2 = r1.paint.get(`${t1}-pattern`);
                e2.isConstant() || (i = !0);
                const s = e2.constantOr(null);
                s && (i = !0, n[s.to] = !0, n[s.from] = !0);
            }
            return i;
        }
        function uc(t1, e1, r, n, i) {
            const s = i.patternDependencies;
            for (const a of e1){
                const e2 = a.paint.get(`${t1}-pattern`).value;
                if ("constant" !== e2.kind) {
                    let t2 = e2.evaluate({
                        zoom: n - 1
                    }, r, {}, i.availableImages), o = e2.evaluate({
                        zoom: n
                    }, r, {}, i.availableImages), l = e2.evaluate({
                        zoom: n + 1
                    }, r, {}, i.availableImages);
                    t2 = t2 && t2.name ? t2.name : t2, o = o && o.name ? o.name : o, l = l && l.name ? l.name : l, s[t2] = !0, s[o] = !0, s[l] = !0, r.patterns[a.id] = {
                        min: t2,
                        mid: o,
                        max: l
                    };
                }
            }
            return r;
        }
        Tu.exports = Bu, Tu.exports.default = Bu, Bu.deviation = function(t1, e1, r, n) {
            var i = e1 && e1.length, s = Math.abs(ec(t1, 0, i ? e1[0] * r : t1.length, r));
            if (i) for(var a = 0, o = e1.length; a < o; a++)s -= Math.abs(ec(t1, e1[a] * r, a < o - 1 ? e1[a + 1] * r : t1.length, r));
            var l = 0;
            for(a = 0; a < n.length; a += 3){
                var u = n[a] * r, c = n[a + 1] * r, h = n[a + 2] * r;
                l += Math.abs((t1[u] - t1[h]) * (t1[c + 1] - t1[u + 1]) - (t1[u] - t1[c]) * (t1[h + 1] - t1[u + 1]));
            }
            return 0 === s && 0 === l ? 0 : Math.abs((l - s) / s);
        }, Bu.flatten = function(t1) {
            for(var e1 = t1[0][0].length, r = {
                vertices: [],
                holes: [],
                dimensions: e1
            }, n = 0, i = 0; i < t1.length; i++){
                for(var s = 0; s < t1[i].length; s++)for(var a = 0; a < e1; a++)r.vertices.push(t1[i][s][a]);
                i > 0 && r.holes.push(n += t1[i - 1].length);
            }
            return r;
        };
        class cc {
            constructor(t1){
                this.zoom = t1.zoom, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.hasPattern = !1, this.patternFeatures = [], this.layoutVertexArray = new aa, this.indexArray = new wa, this.indexArray2 = new za, this.programConfigurations = new vo(t1.layers, t1.zoom), this.segments = new To, this.segments2 = new To, this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id), this.projection = t1.projection;
            }
            populate(t1, e1, r, n) {
                this.hasPattern = lc("fill", this.layers, e1);
                const i = this.layers[0].layout.get("fill-sort-key"), s = [];
                for (const { feature: a , id: o , index: l , sourceLayerIndex: u  } of t1){
                    const t2 = this.layers[0]._featureFilter.needGeometry, c = Qo(a, t2);
                    if (!this.layers[0]._featureFilter.filter(new Us(this.zoom), c, r)) continue;
                    const h = i ? i.evaluate(c, {}, r, e1.availableImages) : void 0, p = {
                        id: o,
                        properties: a.properties,
                        type: a.type,
                        sourceLayerIndex: u,
                        index: l,
                        geometry: t2 ? c.geometry : Jo(a, r, n),
                        patterns: {},
                        sortKey: h
                    };
                    s.push(p);
                }
                i && s.sort((t1, e1)=>t1.sortKey - e1.sortKey);
                for (const n1 of s){
                    const { geometry: i1 , index: s1 , sourceLayerIndex: a1  } = n1;
                    if (this.hasPattern) {
                        const t3 = uc("fill", this.layers, n1, this.zoom, e1);
                        this.patternFeatures.push(t3);
                    } else this.addFeature(n1, i1, s1, r, {}, e1.availableImages);
                    e1.featureIndex.insert(t1[s1].feature, i1, s1, a1, this.index);
                }
            }
            update(t1, e1, r, n) {
                this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t1, e1, this.stateDependentLayers, r, n);
            }
            addFeatures(t1, e1, r, n, i) {
                for (const t2 of this.patternFeatures)this.addFeature(t2, t2.geometry, t2.index, e1, r, n);
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length;
            }
            uploadPending() {
                return !this.uploaded || this.programConfigurations.needsUpload;
            }
            upload(t1) {
                this.uploaded || (this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, zu), this.indexBuffer = t1.createIndexBuffer(this.indexArray), this.indexBuffer2 = t1.createIndexBuffer(this.indexArray2)), this.programConfigurations.upload(t1), this.uploaded = !0;
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.indexBuffer2.destroy(), this.programConfigurations.destroy(), this.segments.destroy(), this.segments2.destroy());
            }
            addFeature(t1, e1, r, n, i, s = []) {
                for (const t2 of ac(e1, 500)){
                    let e2 = 0;
                    for (const r1 of t2)e2 += r1.length;
                    const r2 = this.segments.prepareSegment(e2, this.layoutVertexArray, this.indexArray), n1 = r2.vertexLength, i1 = [], s1 = [];
                    for (const e3 of t2){
                        if (0 === e3.length) continue;
                        e3 !== t2[0] && s1.push(i1.length / 2);
                        const r3 = this.segments2.prepareSegment(e3.length, this.layoutVertexArray, this.indexArray2), n2 = r3.vertexLength;
                        this.layoutVertexArray.emplaceBack(e3[0].x, e3[0].y), this.indexArray2.emplaceBack(n2 + e3.length - 1, n2), i1.push(e3[0].x), i1.push(e3[0].y);
                        for(let t3 = 1; t3 < e3.length; t3++)this.layoutVertexArray.emplaceBack(e3[t3].x, e3[t3].y), this.indexArray2.emplaceBack(n2 + t3 - 1, n2 + t3), i1.push(e3[t3].x), i1.push(e3[t3].y);
                        r3.vertexLength += e3.length, r3.primitiveLength += e3.length;
                    }
                    const a = Tu.exports(i1, s1);
                    for(let t4 = 0; t4 < a.length; t4 += 3)this.indexArray.emplaceBack(n1 + a[t4], n1 + a[t4 + 1], n1 + a[t4 + 2]);
                    r2.vertexLength += e2, r2.primitiveLength += a.length / 3;
                }
                this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t1, r, i, s, n);
            }
        }
        ji(cc, "FillBucket", {
            omit: [
                "layers",
                "patternFeatures"
            ]
        });
        const hc = new Qs({
            "fill-sort-key": new Hs(Ht.layout_fill["fill-sort-key"])
        });
        var pc = {
            paint: new Qs({
                "fill-antialias": new Ks(Ht.paint_fill["fill-antialias"]),
                "fill-opacity": new Hs(Ht.paint_fill["fill-opacity"]),
                "fill-color": new Hs(Ht.paint_fill["fill-color"]),
                "fill-outline-color": new Hs(Ht.paint_fill["fill-outline-color"]),
                "fill-translate": new Ks(Ht.paint_fill["fill-translate"]),
                "fill-translate-anchor": new Ks(Ht.paint_fill["fill-translate-anchor"]),
                "fill-pattern": new Ys(Ht.paint_fill["fill-pattern"])
            }),
            layout: hc
        };
        const fc = ia([
            {
                name: "a_pos_normal_ed",
                components: 4,
                type: "Int16"
            }
        ]), dc = ia([
            {
                name: "a_centroid_pos",
                components: 2,
                type: "Uint16"
            }
        ]), yc = ia([
            {
                name: "a_pos_3",
                components: 3,
                type: "Int16"
            },
            {
                name: "a_pos_normal_3",
                components: 3,
                type: "Int16"
            }
        ]), { members: mc  } = fc;
        var gc = {}, xc = d, vc = bc;
        function bc(t1, e1, r, n, i) {
            this.properties = {}, this.extent = r, this.type = 0, this._pbf = t1, this._geometry = -1, this._keys = n, this._values = i, t1.readFields(_c, this, e1);
        }
        function _c(t1, e1, r) {
            1 == t1 ? e1.id = r.readVarint() : 2 == t1 ? function(t1, e1) {
                for(var r = t1.readVarint() + t1.pos; t1.pos < r;){
                    var n = e1._keys[t1.readVarint()], i = e1._values[t1.readVarint()];
                    e1.properties[n] = i;
                }
            }(r, e1) : 3 == t1 ? e1.type = r.readVarint() : 4 == t1 && (e1._geometry = r.pos);
        }
        function wc(t1) {
            for(var e1, r, n = 0, i = 0, s = t1.length, a = s - 1; i < s; a = i++)n += ((r = t1[a]).x - (e1 = t1[i]).x) * (e1.y + r.y);
            return n;
        }
        bc.types = [
            "Unknown",
            "Point",
            "LineString",
            "Polygon"
        ], bc.prototype.loadGeometry = function() {
            var t1 = this._pbf;
            t1.pos = this._geometry;
            for(var e1, r = t1.readVarint() + t1.pos, n = 1, i = 0, s = 0, a = 0, o = []; t1.pos < r;){
                if (i <= 0) {
                    var l = t1.readVarint();
                    n = 7 & l, i = l >> 3;
                }
                if (i--, 1 === n || 2 === n) s += t1.readSVarint(), a += t1.readSVarint(), 1 === n && (e1 && o.push(e1), e1 = []), e1.push(new xc(s, a));
                else {
                    if (7 !== n) throw new Error("unknown command " + n);
                    e1 && e1.push(e1[0].clone());
                }
            }
            return e1 && o.push(e1), o;
        }, bc.prototype.bbox = function() {
            var t1 = this._pbf;
            t1.pos = this._geometry;
            for(var e1 = t1.readVarint() + t1.pos, r = 1, n = 0, i = 0, s = 0, a = 1 / 0, o = -1 / 0, l = 1 / 0, u = -1 / 0; t1.pos < e1;){
                if (n <= 0) {
                    var c = t1.readVarint();
                    r = 7 & c, n = c >> 3;
                }
                if (n--, 1 === r || 2 === r) (i += t1.readSVarint()) < a && (a = i), i > o && (o = i), (s += t1.readSVarint()) < l && (l = s), s > u && (u = s);
                else if (7 !== r) throw new Error("unknown command " + r);
            }
            return [
                a,
                l,
                o,
                u
            ];
        }, bc.prototype.toGeoJSON = function(t1, e1, r) {
            var n, i, s = this.extent * Math.pow(2, r), a = this.extent * t1, o = this.extent * e1, l = this.loadGeometry(), u = bc.types[this.type];
            function c(t1) {
                for(var e1 = 0; e1 < t1.length; e1++){
                    var r = t1[e1];
                    t1[e1] = [
                        360 * (r.x + a) / s - 180,
                        360 / Math.PI * Math.atan(Math.exp((180 - 360 * (r.y + o) / s) * Math.PI / 180)) - 90
                    ];
                }
            }
            switch(this.type){
                case 1:
                    var h = [];
                    for(n = 0; n < l.length; n++)h[n] = l[n][0];
                    c(l = h);
                    break;
                case 2:
                    for(n = 0; n < l.length; n++)c(l[n]);
                    break;
                case 3:
                    for(l = function(t1) {
                        var e1 = t1.length;
                        if (e1 <= 1) return [
                            t1
                        ];
                        for(var r, n, i = [], s = 0; s < e1; s++){
                            var a = wc(t1[s]);
                            0 !== a && (void 0 === n && (n = a < 0), n === a < 0 ? (r && i.push(r), r = [
                                t1[s]
                            ]) : r.push(t1[s]));
                        }
                        return r && i.push(r), i;
                    }(l), n = 0; n < l.length; n++)for(i = 0; i < l[n].length; i++)c(l[n][i]);
            }
            1 === l.length ? l = l[0] : u = "Multi" + u;
            var p = {
                type: "Feature",
                geometry: {
                    type: u,
                    coordinates: l
                },
                properties: this.properties
            };
            return "id" in this && (p.id = this.id), p;
        };
        var Ac = vc, Sc = kc;
        function kc(t1, e1) {
            this.version = 1, this.name = null, this.extent = 4096, this.length = 0, this._pbf = t1, this._keys = [], this._values = [], this._features = [], t1.readFields(Ic, this, e1), this.length = this._features.length;
        }
        function Ic(t1, e1, r) {
            15 === t1 ? e1.version = r.readVarint() : 1 === t1 ? e1.name = r.readString() : 5 === t1 ? e1.extent = r.readVarint() : 2 === t1 ? e1._features.push(r.pos) : 3 === t1 ? e1._keys.push(r.readString()) : 4 === t1 && e1._values.push(function(t1) {
                for(var e1 = null, r = t1.readVarint() + t1.pos; t1.pos < r;){
                    var n = t1.readVarint() >> 3;
                    e1 = 1 === n ? t1.readString() : 2 === n ? t1.readFloat() : 3 === n ? t1.readDouble() : 4 === n ? t1.readVarint64() : 5 === n ? t1.readVarint() : 6 === n ? t1.readSVarint() : 7 === n ? t1.readBoolean() : null;
                }
                return e1;
            }(r));
        }
        kc.prototype.feature = function(t1) {
            if (t1 < 0 || t1 >= this._features.length) throw new Error("feature index out of bounds");
            this._pbf.pos = this._features[t1];
            var e1 = this._pbf.readVarint() + this._pbf.pos;
            return new Ac(this._pbf, e1, this.extent, this._keys, this._values);
        };
        var Mc = Sc;
        function zc(t1, e1, r) {
            if (3 === t1) {
                var n = new Mc(r, r.readVarint() + r.pos);
                n.length && (e1[n.name] = n);
            }
        }
        var Tc = gc.VectorTile = function(t1, e1) {
            this.layers = t1.readFields(zc, {}, e1);
        }, Bc = gc.VectorTileFeature = vc;
        function Ec(t1, e1, r, n) {
            const i = [], s = 0 === n ? (t1, e1, r, n, i, s)=>{
                t1.push(new d(s, r + (s - e1) / (n - e1) * (i - r)));
            } : (t1, e1, r, n, i, s)=>{
                t1.push(new d(e1 + (s - r) / (i - r) * (n - e1), s));
            };
            for (const a of t1){
                const t2 = [];
                for (const i1 of a){
                    if (i1.length <= 2) continue;
                    const a1 = [];
                    for(let t3 = 0; t3 < i1.length - 1; t3++){
                        const o = i1[t3].x, l = i1[t3].y, u = i1[t3 + 1].x, c = i1[t3 + 1].y, h = 0 === n ? o : l, p = 0 === n ? u : c;
                        h < e1 ? p > e1 && s(a1, o, l, u, c, e1) : h > r ? p < r && s(a1, o, l, u, c, r) : a1.push(i1[t3]), p < e1 && h >= e1 && s(a1, o, l, u, c, e1), p > r && h <= r && s(a1, o, l, u, c, r);
                    }
                    let o1 = i1[i1.length - 1];
                    const l1 = 0 === n ? o1.x : o1.y;
                    l1 >= e1 && l1 <= r && a1.push(o1), a1.length && (o1 = a1[a1.length - 1], a1[0].x === o1.x && a1[0].y === o1.y || a1.push(a1[0]), t2.push(a1));
                }
                t2.length && i.push(t2);
            }
            return i;
        }
        gc.VectorTileLayer = Sc;
        const Pc = Bc.types, Cc = Math.pow(2, 13);
        function Dc(t1, e1, r, n, i, s, a, o) {
            t1.emplaceBack((e1 << 1) + a, (r << 1) + s, (Math.floor(n * Cc) << 1) + i, Math.round(o));
        }
        function Vc(t1, e1, r) {
            const n = 16384;
            t1.emplaceBack(e1.x, e1.y, e1.z, r[0] * n, r[1] * n, r[2] * n);
        }
        class Fc {
            constructor(){
                this.acc = new d(0, 0), this.polyCount = [];
            }
            startRing(t1) {
                this.currentPolyCount = {
                    edges: 0,
                    top: 0
                }, this.polyCount.push(this.currentPolyCount), this.min || (this.min = new d(t1.x, t1.y), this.max = new d(t1.x, t1.y));
            }
            append(t1, e1) {
                this.currentPolyCount.edges++, this.acc._add(t1);
                const r = this.min, n = this.max;
                t1.x < r.x ? r.x = t1.x : t1.x > n.x && (n.x = t1.x), t1.y < r.y ? r.y = t1.y : t1.y > n.y && (n.y = t1.y), ((0 === t1.x || t1.x === Bo) && t1.x === e1.x) != ((0 === t1.y || t1.y === Bo) && t1.y === e1.y) && this.processBorderOverlap(t1, e1), e1.x < 0 != t1.x < 0 && this.addBorderIntersection(0, Ir(e1.y, t1.y, (0 - e1.x) / (t1.x - e1.x))), e1.x > Bo != t1.x > Bo && this.addBorderIntersection(1, Ir(e1.y, t1.y, (Bo - e1.x) / (t1.x - e1.x))), e1.y < 0 != t1.y < 0 && this.addBorderIntersection(2, Ir(e1.x, t1.x, (0 - e1.y) / (t1.y - e1.y))), e1.y > Bo != t1.y > Bo && this.addBorderIntersection(3, Ir(e1.x, t1.x, (Bo - e1.y) / (t1.y - e1.y)));
            }
            addBorderIntersection(t1, e1) {
                this.borders || (this.borders = [
                    [
                        Number.MAX_VALUE,
                        -Number.MAX_VALUE
                    ],
                    [
                        Number.MAX_VALUE,
                        -Number.MAX_VALUE
                    ],
                    [
                        Number.MAX_VALUE,
                        -Number.MAX_VALUE
                    ],
                    [
                        Number.MAX_VALUE,
                        -Number.MAX_VALUE
                    ]
                ]);
                const r = this.borders[t1];
                e1 < r[0] && (r[0] = e1), e1 > r[1] && (r[1] = e1);
            }
            processBorderOverlap(t1, e1) {
                if (t1.x === e1.x) {
                    if (t1.y === e1.y) return;
                    const r = 0 === t1.x ? 0 : 1;
                    this.addBorderIntersection(r, e1.y), this.addBorderIntersection(r, t1.y);
                } else {
                    const r1 = 0 === t1.y ? 2 : 3;
                    this.addBorderIntersection(r1, e1.x), this.addBorderIntersection(r1, t1.x);
                }
            }
            centroid() {
                const t1 = this.polyCount.reduce((t1, e1)=>t1 + e1.edges, 0);
                return 0 !== t1 ? this.acc.div(t1)._round() : new d(0, 0);
            }
            span() {
                return new d(this.max.x - this.min.x, this.max.y - this.min.y);
            }
            intersectsCount() {
                return this.borders.reduce((t1, e1)=>t1 + +(e1[0] !== Number.MAX_VALUE), 0);
            }
        }
        class Lc {
            constructor(t1){
                this.zoom = t1.zoom, this.canonical = t1.canonical, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.hasPattern = !1, this.edgeRadius = 0, this.projection = t1.projection, this.layoutVertexArray = new la, this.centroidVertexArray = new Na, this.indexArray = new wa, this.programConfigurations = new vo(t1.layers, t1.zoom), this.segments = new To, this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id), this.enableTerrain = t1.enableTerrain;
            }
            populate(t1, e1, r, n) {
                this.features = [], this.hasPattern = lc("fill-extrusion", this.layers, e1), this.featuresOnBorder = [], this.borders = [
                    [],
                    [],
                    [],
                    []
                ], this.borderDoneWithNeighborZ = [
                    -1,
                    -1,
                    -1,
                    -1
                ], this.tileToMeter = function(t1) {
                    const e1 = Math.exp(Math.PI * (1 - t1.y / (1 << t1.z) * 2));
                    return 80150034 * e1 / (e1 * e1 + 1) / Bo / (1 << t1.z);
                }(r), this.edgeRadius = this.layers[0].layout.get("fill-extrusion-edge-radius") / this.tileToMeter;
                for (const { feature: i , id: s , index: a , sourceLayerIndex: o  } of t1){
                    const t2 = this.layers[0]._featureFilter.needGeometry, l = Qo(i, t2);
                    if (!this.layers[0]._featureFilter.filter(new Us(this.zoom), l, r)) continue;
                    const u = {
                        id: s,
                        sourceLayerIndex: o,
                        index: a,
                        geometry: t2 ? l.geometry : Jo(i, r, n),
                        properties: i.properties,
                        type: i.type,
                        patterns: {}
                    }, c = this.layoutVertexArray.length;
                    this.hasPattern ? this.features.push(uc("fill-extrusion", this.layers, u, this.zoom, e1)) : this.addFeature(u, u.geometry, a, r, {}, e1.availableImages, n), e1.featureIndex.insert(i, u.geometry, a, o, this.index, c);
                }
                this.sortBorders();
            }
            addFeatures(t1, e1, r, n, i) {
                for (const t2 of this.features){
                    const { geometry: s  } = t2;
                    this.addFeature(t2, s, t2.index, e1, r, n, i);
                }
                this.sortBorders();
            }
            update(t1, e1, r, n) {
                this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t1, e1, this.stateDependentLayers, r, n);
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length;
            }
            uploadPending() {
                return !this.uploaded || this.programConfigurations.needsUpload;
            }
            upload(t1) {
                this.uploaded || (this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, mc), this.indexBuffer = t1.createIndexBuffer(this.indexArray), this.layoutVertexExtArray && (this.layoutVertexExtBuffer = t1.createVertexBuffer(this.layoutVertexExtArray, yc.members, !0))), this.programConfigurations.upload(t1), this.uploaded = !0;
            }
            uploadCentroid(t1) {
                0 !== this.centroidVertexArray.length && (this.centroidVertexBuffer ? this.needsCentroidUpdate && this.centroidVertexBuffer.updateData(this.centroidVertexArray) : this.centroidVertexBuffer = t1.createVertexBuffer(this.centroidVertexArray, dc.members, !0), this.needsCentroidUpdate = !1);
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.centroidVertexBuffer && this.centroidVertexBuffer.destroy(), this.layoutVertexExtBuffer && this.layoutVertexExtBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy());
            }
            addFeature(t1, e1, r, n, i, s, a) {
                const o = [
                    new d(0, 0),
                    new d(Bo, Bo)
                ], l = a.projection, u = "globe" === l.name, c = this.enableTerrain && !u ? new Fc : null, h = "Polygon" === Pc[t1.type];
                u && !this.layoutVertexExtArray && (this.layoutVertexExtArray = new Pa);
                const p = ac(e1, 500);
                for(let t2 = p.length - 1; t2 >= 0; t2--){
                    const e2 = p[t2];
                    (0 === e2.length || (f = e2[0]).every((t1)=>t1.x <= 0) || f.every((t1)=>t1.x >= Bo) || f.every((t1)=>t1.y <= 0) || f.every((t1)=>t1.y >= Bo)) && p.splice(t2, 1);
                }
                var f;
                let y;
                if (u) y = Gc(p, o, n);
                else {
                    y = [];
                    for (const t3 of p)y.push({
                        polygon: t3,
                        bounds: o
                    });
                }
                const m = h ? this.edgeRadius : 0;
                for (const { polygon: t4 , bounds: e3  } of y){
                    let r1 = 0, i1 = 0;
                    for (const e4 of t4)h && !e4[0].equals(e4[e4.length - 1]) && e4.push(e4[0]), i1 += h ? e4.length - 1 : e4.length;
                    const s1 = this.segments.prepareSegment((h ? 5 : 4) * i1, this.layoutVertexArray, this.indexArray);
                    if (h) {
                        const e5 = [], i2 = [];
                        r1 = s1.vertexLength;
                        for (const r2 of t4){
                            let a1, o1;
                            r2.length && r2 !== t4[0] && i2.push(e5.length / 2), a1 = r2[1].sub(r2[0])._perp()._unit();
                            for(let t5 = 1; t5 < r2.length; t5++){
                                const i3 = r2[t5], c1 = r2[t5 === r2.length - 1 ? 1 : t5 + 1];
                                let { x: h1 , y: p1  } = i3;
                                if (m) {
                                    o1 = c1.sub(i3)._perp()._unit();
                                    const t6 = a1.add(o1)._unit(), e6 = m * Math.min(4, 1 / (a1.x * t6.x + a1.y * t6.y));
                                    h1 += e6 * t6.x, p1 += e6 * t6.y, a1 = o1;
                                }
                                Dc(this.layoutVertexArray, h1, p1, 0, 0, 1, 1, 0), s1.vertexLength++, e5.push(i3.x, i3.y), u && Vc(this.layoutVertexExtArray, l.projectTilePoint(h1, p1, n), l.upVector(n, h1, p1));
                            }
                        }
                        const a2 = Tu.exports(e5, i2);
                        for(let t7 = 0; t7 < a2.length; t7 += 3)this.indexArray.emplaceBack(r1 + a2[t7], r1 + a2[t7 + 2], r1 + a2[t7 + 1]), s1.primitiveLength++;
                    }
                    for (const i4 of t4){
                        c && i4.length && c.startRing(i4[0]);
                        let t8, a3, o2, p2 = i4.length > 4 && Oc(i4[i4.length - 2], i4[0], i4[1]), f1 = m ? Uc(i4[i4.length - 2], i4[0], i4[1], m) : 0;
                        a3 = i4[1].sub(i4[0])._perp()._unit();
                        let d1 = !0;
                        for(let y1 = 1, g = 0; y1 < i4.length; y1++){
                            let x = i4[y1 - 1], v = i4[y1];
                            const b = i4[y1 === i4.length - 1 ? 1 : y1 + 1];
                            if (c && h && c.currentPolyCount.top++, $c(v, x, e3)) {
                                m && (a3 = b.sub(v)._perp()._unit(), d1 = !d1);
                                continue;
                            }
                            c && c.append(v, x);
                            const _ = v.sub(x)._perp(), w = _.x / (Math.abs(_.x) + Math.abs(_.y)), A = _.y > 0 ? 1 : 0, S = x.dist(v);
                            if (g + S > 32768 && (g = 0), m) {
                                o2 = b.sub(v)._perp()._unit();
                                let t9 = jc(x, v, b, Rc(a3, o2), m);
                                isNaN(t9) && (t9 = 0);
                                const e7 = v.sub(x)._unit();
                                x = x.add(e7.mult(f1))._round(), v = v.add(e7.mult(-t9))._round(), f1 = t9, a3 = o2;
                            }
                            const k = s1.vertexLength, I = i4.length > 4 && Oc(x, v, b);
                            let M = qc(g, p2, d1);
                            if (Dc(this.layoutVertexArray, x.x, x.y, w, A, 0, 0, M), Dc(this.layoutVertexArray, x.x, x.y, w, A, 0, 1, M), g += S, M = qc(g, I, !d1), p2 = I, Dc(this.layoutVertexArray, v.x, v.y, w, A, 0, 0, M), Dc(this.layoutVertexArray, v.x, v.y, w, A, 0, 1, M), s1.vertexLength += 4, this.indexArray.emplaceBack(k + 0, k + 1, k + 2), this.indexArray.emplaceBack(k + 1, k + 3, k + 2), s1.primitiveLength += 2, m) {
                                const n1 = r1 + (1 === y1 ? i4.length - 2 : y1 - 2), a4 = 1 === y1 ? r1 : n1 + 1;
                                if (this.indexArray.emplaceBack(k + 1, n1, k + 3), this.indexArray.emplaceBack(n1, a4, k + 3), s1.primitiveLength += 2, void 0 === t8 && (t8 = k), !$c(b, i4[y1], e3)) {
                                    const e8 = y1 === i4.length - 1 ? t8 : s1.vertexLength;
                                    this.indexArray.emplaceBack(k + 2, k + 3, e8), this.indexArray.emplaceBack(k + 3, e8 + 1, e8), this.indexArray.emplaceBack(k + 3, a4, e8 + 1), s1.primitiveLength += 3;
                                }
                                d1 = !d1;
                            }
                            if (u) {
                                const t10 = this.layoutVertexExtArray, e9 = l.projectTilePoint(x.x, x.y, n), r3 = l.projectTilePoint(v.x, v.y, n), i5 = l.upVector(n, x.x, x.y), s2 = l.upVector(n, v.x, v.y);
                                Vc(t10, e9, i5), Vc(t10, e9, i5), Vc(t10, r3, s2), Vc(t10, r3, s2);
                            }
                        }
                        h && (r1 += i4.length - 1);
                    }
                }
                if (c && c.polyCount.length > 0) {
                    if (c.borders) {
                        c.vertexArrayOffset = this.centroidVertexArray.length;
                        const t11 = c.borders, e10 = this.featuresOnBorder.push(c) - 1;
                        for(let r4 = 0; r4 < 4; r4++)t11[r4][0] !== Number.MAX_VALUE && this.borders[r4].push(e10);
                    }
                    this.encodeCentroid(c.borders ? void 0 : c.centroid(), c);
                }
                this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t1, r, i, s, n);
            }
            sortBorders() {
                for(let t1 = 0; t1 < 4; t1++)this.borders[t1].sort((e1, r)=>this.featuresOnBorder[e1].borders[t1][0] - this.featuresOnBorder[r].borders[t1][0]);
            }
            encodeCentroid(t1, e1, r = !0) {
                let n, i;
                if (t1) {
                    if (0 !== t1.y) {
                        const r1 = e1.span()._mult(this.tileToMeter);
                        n = (Math.max(t1.x, 1) << 3) + Math.min(7, Math.round(r1.x / 10)), i = (Math.max(t1.y, 1) << 3) + Math.min(7, Math.round(r1.y / 10));
                    } else n = Math.ceil(7 * (t1.x + 450)), i = 0;
                } else n = 0, i = +r;
                let s = r ? this.centroidVertexArray.length : e1.vertexArrayOffset;
                for (const t2 of e1.polyCount){
                    r && this.centroidVertexArray.resize(this.centroidVertexArray.length + 4 * t2.edges + t2.top);
                    for(let e2 = 0; e2 < t2.top; e2++)this.centroidVertexArray.emplace(s++, n, i);
                    for(let e3 = 0; e3 < 2 * t2.edges; e3++)this.centroidVertexArray.emplace(s++, 0, i), this.centroidVertexArray.emplace(s++, n, i);
                }
            }
        }
        function Rc(t1, e1) {
            const r = t1.add(e1)._unit();
            return t1.x * r.x + t1.y * r.y;
        }
        function Uc(t1, e1, r, n) {
            const i = e1.sub(t1)._perp()._unit(), s = r.sub(e1)._perp()._unit();
            return jc(t1, e1, r, Rc(i, s), n);
        }
        function jc(t1, e1, r, n, i) {
            const s = Math.sqrt(1 - n * n);
            return Math.min(t1.dist(e1) / 3, e1.dist(r) / 3, i * s / n);
        }
        function $c(t1, e1, r) {
            return t1.x < r[0].x && e1.x < r[0].x || t1.x > r[1].x && e1.x > r[1].x || t1.y < r[0].y && e1.y < r[0].y || t1.y > r[1].y && e1.y > r[1].y;
        }
        function Oc(t1, e1, r) {
            if (t1.x < 0 || t1.x >= Bo || e1.x < 0 || e1.x >= Bo || r.x < 0 || r.x >= Bo) return !1;
            const n = r.sub(e1), i = n.perp(), s = t1.sub(e1);
            return (n.x * s.x + n.y * s.y) / Math.sqrt((n.x * n.x + n.y * n.y) * (s.x * s.x + s.y * s.y)) > -0.866 && i.x * s.x + i.y * s.y < 0;
        }
        function qc(t1, e1, r) {
            const n = e1 ? 2 | t1 : -3 & t1;
            return r ? 1 | n : -2 & n;
        }
        function Nc() {
            const t1 = Math.PI / 32, e1 = Math.tan(t1), r = Po;
            return r * Math.sqrt(1 + 2 * e1 * e1) - r;
        }
        function Gc(t1, e1, r) {
            const n = 1 << r.z, i = Uo(r.x / n), s = Uo((r.x + 1) / n), a = jo(r.y / n), o = jo((r.y + 1) / n);
            return function(t1, e1, r, n, i = 0, s) {
                const a = [];
                if (!t1.length || !r || !n) return a;
                const o = (t1, e1)=>{
                    for (const r of t1)a.push({
                        polygon: r,
                        bounds: e1
                    });
                }, l = Math.ceil(Math.log2(r)), u = Math.ceil(Math.log2(n)), c = l - u, h = [];
                for(let t2 = 0; t2 < Math.abs(c); t2++)h.push(c > 0 ? 0 : 1);
                for(let t3 = 0; t3 < Math.min(l, u); t3++)h.push(0), h.push(1);
                let p = t1;
                if (p = Ec(p, e1[0].y - i, e1[1].y + i, 1), p = Ec(p, e1[0].x - i, e1[1].x + i, 0), !p.length) return a;
                const f = [];
                for(h.length ? f.push({
                    polygons: p,
                    bounds: e1,
                    depth: 0
                }) : o(p, e1); f.length;){
                    const t4 = f.pop(), e2 = t4.depth, r1 = h[e2], n1 = t4.bounds[0], a1 = t4.bounds[1], l1 = 0 === r1 ? n1.x : n1.y, u1 = 0 === r1 ? a1.x : a1.y, c1 = s ? s(r1, l1, u1) : .5 * (l1 + u1), p1 = Ec(t4.polygons, l1 - i, c1 + i, r1), y = Ec(t4.polygons, c1 - i, u1 + i, r1);
                    if (p1.length) {
                        const t5 = [
                            n1,
                            new d(0 === r1 ? c1 : a1.x, 1 === r1 ? c1 : a1.y)
                        ];
                        h.length > e2 + 1 ? f.push({
                            polygons: p1,
                            bounds: t5,
                            depth: e2 + 1
                        }) : o(p1, t5);
                    }
                    if (y.length) {
                        const t6 = [
                            new d(0 === r1 ? c1 : n1.x, 1 === r1 ? c1 : n1.y),
                            a1
                        ];
                        h.length > e2 + 1 ? f.push({
                            polygons: y,
                            bounds: t6,
                            depth: e2 + 1
                        }) : o(y, t6);
                    }
                }
                return a;
            }(t1, e1, Math.ceil((s - i) / 11.25), Math.ceil((a - o) / 11.25), 1, (t1, e1, i)=>{
                if (0 === t1) return .5 * (e1 + i);
                {
                    const t2 = jo((r.y + e1 / Bo) / n);
                    return (Lo(.5 * (jo((r.y + i / Bo) / n) + t2)) * n - r.y) * Bo;
                }
            });
        }
        ji(Lc, "FillExtrusionBucket", {
            omit: [
                "layers",
                "features"
            ]
        }), ji(Fc, "PartMetadata");
        const Zc = new Qs({
            "fill-extrusion-edge-radius": new Ks(Ht["layout_fill-extrusion"]["fill-extrusion-edge-radius"])
        });
        var Xc = {
            paint: new Qs({
                "fill-extrusion-opacity": new Ks(Ht["paint_fill-extrusion"]["fill-extrusion-opacity"]),
                "fill-extrusion-color": new Hs(Ht["paint_fill-extrusion"]["fill-extrusion-color"]),
                "fill-extrusion-translate": new Ks(Ht["paint_fill-extrusion"]["fill-extrusion-translate"]),
                "fill-extrusion-translate-anchor": new Ks(Ht["paint_fill-extrusion"]["fill-extrusion-translate-anchor"]),
                "fill-extrusion-pattern": new Ys(Ht["paint_fill-extrusion"]["fill-extrusion-pattern"]),
                "fill-extrusion-height": new Hs(Ht["paint_fill-extrusion"]["fill-extrusion-height"]),
                "fill-extrusion-base": new Hs(Ht["paint_fill-extrusion"]["fill-extrusion-base"]),
                "fill-extrusion-vertical-gradient": new Ks(Ht["paint_fill-extrusion"]["fill-extrusion-vertical-gradient"]),
                "fill-extrusion-ambient-occlusion-intensity": new Ks(Ht["paint_fill-extrusion"]["fill-extrusion-ambient-occlusion-intensity"]),
                "fill-extrusion-ambient-occlusion-radius": new Ks(Ht["paint_fill-extrusion"]["fill-extrusion-ambient-occlusion-radius"])
            }),
            layout: Zc
        };
        function Kc(t1, e1, r) {
            var n = 2 * Math.PI * 6378137 / 256 / Math.pow(2, r);
            return [
                t1 * n - 2 * Math.PI * 6378137 / 2,
                e1 * n - 2 * Math.PI * 6378137 / 2
            ];
        }
        class Hc {
            constructor(t1, e1, r){
                this.z = t1, this.x = e1, this.y = r, this.key = Jc(0, t1, t1, e1, r);
            }
            equals(t1) {
                return this.z === t1.z && this.x === t1.x && this.y === t1.y;
            }
            url(t1, e1) {
                const r = function(t1, e1, r) {
                    var n = Kc(256 * t1, 256 * (e1 = Math.pow(2, r) - e1 - 1), r), i = Kc(256 * (t1 + 1), 256 * (e1 + 1), r);
                    return n[0] + "," + n[1] + "," + i[0] + "," + i[1];
                }(this.x, this.y, this.z), n = function(t1, e1, r) {
                    let n, i = "";
                    for(let s = t1; s > 0; s--)n = 1 << s - 1, i += (e1 & n ? 1 : 0) + (r & n ? 2 : 0);
                    return i;
                }(this.z, this.x, this.y);
                return t1[(this.x + this.y) % t1.length].replace("{prefix}", (this.x % 16).toString(16) + (this.y % 16).toString(16)).replace(/{z}/g, String(this.z)).replace(/{x}/g, String(this.x)).replace(/{y}/g, String("tms" === e1 ? Math.pow(2, this.z) - this.y - 1 : this.y)).replace("{quadkey}", n).replace("{bbox-epsg-3857}", r);
            }
            toString() {
                return `${this.z}/${this.x}/${this.y}`;
            }
        }
        class Yc {
            constructor(t1, e1){
                this.wrap = t1, this.canonical = e1, this.key = Jc(t1, e1.z, e1.z, e1.x, e1.y);
            }
        }
        class Wc {
            constructor(t1, e1, r, n, i){
                this.overscaledZ = t1, this.wrap = e1, this.canonical = new Hc(r, +n, +i), this.key = 0 === e1 && t1 === r ? this.canonical.key : Jc(e1, t1, r, n, i);
            }
            equals(t1) {
                return this.overscaledZ === t1.overscaledZ && this.wrap === t1.wrap && this.canonical.equals(t1.canonical);
            }
            scaledTo(t1) {
                const e1 = this.canonical.z - t1;
                return t1 > this.canonical.z ? new Wc(t1, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y) : new Wc(t1, this.wrap, t1, this.canonical.x >> e1, this.canonical.y >> e1);
            }
            calculateScaledKey(t1, e1 = !0) {
                if (this.overscaledZ === t1 && e1) return this.key;
                if (t1 > this.canonical.z) return Jc(this.wrap * +e1, t1, this.canonical.z, this.canonical.x, this.canonical.y);
                {
                    const r = this.canonical.z - t1;
                    return Jc(this.wrap * +e1, t1, t1, this.canonical.x >> r, this.canonical.y >> r);
                }
            }
            isChildOf(t1) {
                if (t1.wrap !== this.wrap) return !1;
                const e1 = this.canonical.z - t1.canonical.z;
                return 0 === t1.overscaledZ || t1.overscaledZ < this.overscaledZ && t1.canonical.x === this.canonical.x >> e1 && t1.canonical.y === this.canonical.y >> e1;
            }
            children(t1) {
                if (this.overscaledZ >= t1) return [
                    new Wc(this.overscaledZ + 1, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y)
                ];
                const e1 = this.canonical.z + 1, r = 2 * this.canonical.x, n = 2 * this.canonical.y;
                return [
                    new Wc(e1, this.wrap, e1, r, n),
                    new Wc(e1, this.wrap, e1, r + 1, n),
                    new Wc(e1, this.wrap, e1, r, n + 1),
                    new Wc(e1, this.wrap, e1, r + 1, n + 1)
                ];
            }
            isLessThan(t1) {
                return this.wrap < t1.wrap || !(this.wrap > t1.wrap) && (this.overscaledZ < t1.overscaledZ || !(this.overscaledZ > t1.overscaledZ) && (this.canonical.x < t1.canonical.x || !(this.canonical.x > t1.canonical.x) && this.canonical.y < t1.canonical.y));
            }
            wrapped() {
                return new Wc(this.overscaledZ, 0, this.canonical.z, this.canonical.x, this.canonical.y);
            }
            unwrapTo(t1) {
                return new Wc(this.overscaledZ, t1, this.canonical.z, this.canonical.x, this.canonical.y);
            }
            overscaleFactor() {
                return Math.pow(2, this.overscaledZ - this.canonical.z);
            }
            toUnwrapped() {
                return new Yc(this.wrap, this.canonical);
            }
            toString() {
                return `${this.overscaledZ}/${this.canonical.x}/${this.canonical.y}`;
            }
        }
        function Jc(t1, e1, r, n, i) {
            const s = 1 << Math.min(r, 22);
            let a = s * (i % s) + n % s;
            return t1 && r < 22 && (a += s * s * ((t1 < 0 ? -2 * t1 - 1 : 2 * t1) % (1 << 2 * (22 - r)))), 16 * (32 * a + r) + (e1 - r);
        }
        ji(Hc, "CanonicalTileID"), ji(Wc, "OverscaledTileID", {
            omit: [
                "projMatrix"
            ]
        });
        class Qc extends d {
            constructor(t1, e1, r){
                super(t1, e1), this.z = r;
            }
        }
        function th(t1, e1) {
            return t1.x * e1.x + t1.y * e1.y;
        }
        function eh(t1, e1) {
            if (1 === t1.length) {
                let r = 0;
                const n = e1[r++];
                let i;
                for(; !i || n.equals(i);)if (i = e1[r++], !i) return 1 / 0;
                for(; r < e1.length; r++){
                    const s = e1[r], a = t1[0], o = i.sub(n), l = s.sub(n), u = a.sub(n), c = th(o, o), h = th(o, l), p = th(l, l), f = th(u, o), d = th(u, l), y = c * p - h * h, m = (p * f - h * d) / y, g = (c * d - h * f) / y, x = n.z * (1 - m - g) + i.z * m + s.z * g;
                    if (isFinite(x)) return x;
                }
                return 1 / 0;
            }
            {
                let t2 = 1 / 0;
                for (const r1 of e1)t2 = Math.min(t2, r1.z);
                return t2;
            }
        }
        function rh(t1, e1, r, n, i, s, a, o) {
            const l = a * i.getElevationAt(t1, e1, !0, !0), u = 0 !== s[0], c = u ? 0 === s[1] ? a * (s[0] / 7 - 450) : a * function(t1, e1, r) {
                const n = Math.floor(e1[0] / 8), i = Math.floor(e1[1] / 8), s = 10 * (e1[0] - 8 * n), a = 10 * (e1[1] - 8 * i), o = t1.getElevationAt(n, i, !0, !0), l = t1.getMeterToDEM(r), u = Math.floor(.5 * (s * l - 1)), c = Math.floor(.5 * (a * l - 1)), h = t1.tileCoordToPixel(n, i), p = 2 * u + 1, f = 2 * c + 1, d = function(t1, e1, r, n, i) {
                    return [
                        t1.getElevationAtPixel(e1, r, !0),
                        t1.getElevationAtPixel(e1 + i, r, !0),
                        t1.getElevationAtPixel(e1, r + i, !0),
                        t1.getElevationAtPixel(e1 + n, r + i, !0)
                    ];
                }(t1, h.x - u, h.y - c, p, f), y = Math.abs(d[0] - d[1]), m = Math.abs(d[2] - d[3]), g = Math.abs(d[0] - d[2]) + Math.abs(d[1] - d[3]), x = Math.min(.25, .5 * l * (y + m) / p), v = Math.min(.25, .5 * l * g / f);
                return o + Math.max(x * s, v * a);
            }(i, s, o) : l;
            return {
                base: l + (0 === r) ? -1 : r,
                top: u ? Math.max(c + n, l + r + 2) : l + n
            };
        }
        const nh = ia([
            {
                name: "a_pos_normal",
                components: 2,
                type: "Int16"
            },
            {
                name: "a_data",
                components: 4,
                type: "Uint8"
            },
            {
                name: "a_linesofar",
                components: 1,
                type: "Float32"
            }
        ], 4), { members: ih  } = nh, sh = ia([
            {
                name: "a_packed",
                components: 4,
                type: "Float32"
            }
        ]), { members: ah  } = sh, oh = Bc.types, lh = Math.cos(Math.PI / 180 * 37.5);
        class uh {
            constructor(t1){
                this.zoom = t1.zoom, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.projection = t1.projection, this.hasPattern = !1, this.patternFeatures = [], this.lineClipsArray = [], this.gradients = {}, this.layers.forEach((t1)=>{
                    this.gradients[t1.id] = {};
                }), this.layoutVertexArray = new ua, this.layoutVertexArray2 = new ca, this.indexArray = new wa, this.programConfigurations = new vo(t1.layers, t1.zoom), this.segments = new To, this.maxLineLength = 0, this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id);
            }
            populate(t1, e1, r, n) {
                this.hasPattern = lc("line", this.layers, e1);
                const i = this.layers[0].layout.get("line-sort-key"), s = [];
                for (const { feature: e2 , id: a , index: o , sourceLayerIndex: l  } of t1){
                    const t2 = this.layers[0]._featureFilter.needGeometry, u = Qo(e2, t2);
                    if (!this.layers[0]._featureFilter.filter(new Us(this.zoom), u, r)) continue;
                    const c = i ? i.evaluate(u, {}, r) : void 0, h = {
                        id: a,
                        properties: e2.properties,
                        type: e2.type,
                        sourceLayerIndex: l,
                        index: o,
                        geometry: t2 ? u.geometry : Jo(e2, r, n),
                        patterns: {},
                        sortKey: c
                    };
                    s.push(h);
                }
                i && s.sort((t1, e1)=>t1.sortKey - e1.sortKey);
                const { lineAtlas: a1 , featureIndex: o1  } = e1, l1 = this.addConstantDashes(a1);
                for (const n1 of s){
                    const { geometry: i1 , index: s1 , sourceLayerIndex: u1  } = n1;
                    if (l1 && this.addFeatureDashes(n1, a1), this.hasPattern) {
                        const t3 = uc("line", this.layers, n1, this.zoom, e1);
                        this.patternFeatures.push(t3);
                    } else this.addFeature(n1, i1, s1, r, a1.positions, e1.availableImages);
                    o1.insert(t1[s1].feature, i1, s1, u1, this.index);
                }
            }
            addConstantDashes(t1) {
                let e1 = !1;
                for (const r of this.layers){
                    const n = r.paint.get("line-dasharray").value, i = r.layout.get("line-cap").value;
                    if ("constant" !== n.kind || "constant" !== i.kind) e1 = !0;
                    else {
                        const e2 = i.value, r1 = n.value;
                        if (!r1) continue;
                        t1.addDash(r1.from, e2), t1.addDash(r1.to, e2), r1.other && t1.addDash(r1.other, e2);
                    }
                }
                return e1;
            }
            addFeatureDashes(t1, e1) {
                const r = this.zoom;
                for (const n of this.layers){
                    const i = n.paint.get("line-dasharray").value, s = n.layout.get("line-cap").value;
                    if ("constant" === i.kind && "constant" === s.kind) continue;
                    let a, o, l, u, c, h;
                    if ("constant" === i.kind) {
                        const t2 = i.value;
                        if (!t2) continue;
                        a = t2.other || t2.to, o = t2.to, l = t2.from;
                    } else a = i.evaluate({
                        zoom: r - 1
                    }, t1), o = i.evaluate({
                        zoom: r
                    }, t1), l = i.evaluate({
                        zoom: r + 1
                    }, t1);
                    "constant" === s.kind ? u = c = h = s.value : (u = s.evaluate({
                        zoom: r - 1
                    }, t1), c = s.evaluate({
                        zoom: r
                    }, t1), h = s.evaluate({
                        zoom: r + 1
                    }, t1)), e1.addDash(a, u), e1.addDash(o, c), e1.addDash(l, h);
                    const p = e1.getKey(a, u), f = e1.getKey(o, c), d = e1.getKey(l, h);
                    t1.patterns[n.id] = {
                        min: p,
                        mid: f,
                        max: d
                    };
                }
            }
            update(t1, e1, r, n) {
                this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t1, e1, this.stateDependentLayers, r, n);
            }
            addFeatures(t1, e1, r, n, i) {
                for (const t2 of this.patternFeatures)this.addFeature(t2, t2.geometry, t2.index, e1, r, n);
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length;
            }
            uploadPending() {
                return !this.uploaded || this.programConfigurations.needsUpload;
            }
            upload(t1) {
                this.uploaded || (0 !== this.layoutVertexArray2.length && (this.layoutVertexBuffer2 = t1.createVertexBuffer(this.layoutVertexArray2, ah)), this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, ih), this.indexBuffer = t1.createIndexBuffer(this.indexArray)), this.programConfigurations.upload(t1), this.uploaded = !0;
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy());
            }
            lineFeatureClips(t1) {
                if (t1.properties && t1.properties.hasOwnProperty("mapbox_clip_start") && t1.properties.hasOwnProperty("mapbox_clip_end")) return {
                    start: +t1.properties.mapbox_clip_start,
                    end: +t1.properties.mapbox_clip_end
                };
            }
            addFeature(t1, e1, r, n, i, s) {
                const a = this.layers[0].layout, o = a.get("line-join").evaluate(t1, {}), l = a.get("line-cap").evaluate(t1, {}), u = a.get("line-miter-limit"), c = a.get("line-round-limit");
                this.lineClips = this.lineFeatureClips(t1);
                for (const r1 of e1)this.addLine(r1, t1, o, l, u, c);
                this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t1, r, i, s, n);
            }
            addLine(t1, e1, r, n, i, s) {
                if (this.distance = 0, this.scaledDistance = 0, this.totalDistance = 0, this.lineSoFar = 0, this.lineClips) {
                    this.lineClipsArray.push(this.lineClips);
                    for(let e2 = 0; e2 < t1.length - 1; e2++)this.totalDistance += t1[e2].dist(t1[e2 + 1]);
                    this.updateScaledDistance(), this.maxLineLength = Math.max(this.maxLineLength, this.totalDistance);
                }
                const a = "Polygon" === oh[e1.type];
                let o = t1.length;
                for(; o >= 2 && t1[o - 1].equals(t1[o - 2]);)o--;
                let l = 0;
                for(; l < o - 1 && t1[l].equals(t1[l + 1]);)l++;
                if (o < (a ? 3 : 2)) return;
                "bevel" === r && (i = 1.05);
                const u = this.overscaling <= 16 ? 122880 / (512 * this.overscaling) : 0, c = this.segments.prepareSegment(10 * o, this.layoutVertexArray, this.indexArray);
                let h, p, f, d, y;
                this.e1 = this.e2 = -1, a && (h = t1[o - 2], y = t1[l].sub(h)._unit()._perp());
                for(let e3 = l; e3 < o; e3++){
                    if (f = e3 === o - 1 ? a ? t1[l + 1] : void 0 : t1[e3 + 1], f && t1[e3].equals(f)) continue;
                    y && (d = y), h && (p = h), h = t1[e3], y = f ? f.sub(h)._unit()._perp() : d, d = d || y;
                    let m = d.add(y);
                    0 === m.x && 0 === m.y || m._unit();
                    const g = d.x * y.x + d.y * y.y, x = m.x * y.x + m.y * y.y, v = 0 !== x ? 1 / x : 1 / 0, b = 2 * Math.sqrt(2 - 2 * x), _ = x < lh && p && f, w = d.x * y.y - d.y * y.x > 0;
                    if (_ && e3 > l) {
                        const t2 = h.dist(p);
                        if (t2 > 2 * u) {
                            const e4 = h.sub(h.sub(p)._mult(u / t2)._round());
                            this.updateDistance(p, e4), this.addCurrentVertex(e4, d, 0, 0, c), p = e4;
                        }
                    }
                    const A = p && f;
                    let S = A ? r : a ? "butt" : n;
                    if (A && "round" === S && (v < s ? S = "miter" : v <= 2 && (S = "fakeround")), "miter" === S && v > i && (S = "bevel"), "bevel" === S && (v > 2 && (S = "flipbevel"), v < i && (S = "miter")), p && this.updateDistance(p, h), "miter" === S) m._mult(v), this.addCurrentVertex(h, m, 0, 0, c);
                    else if ("flipbevel" === S) {
                        if (v > 100) m = y.mult(-1);
                        else {
                            const t3 = v * d.add(y).mag() / d.sub(y).mag();
                            m._perp()._mult(t3 * (w ? -1 : 1));
                        }
                        this.addCurrentVertex(h, m, 0, 0, c), this.addCurrentVertex(h, m.mult(-1), 0, 0, c);
                    } else if ("bevel" === S || "fakeround" === S) {
                        const t4 = -Math.sqrt(v * v - 1), e5 = w ? t4 : 0, r1 = w ? 0 : t4;
                        if (p && this.addCurrentVertex(h, d, e5, r1, c), "fakeround" === S) {
                            const t5 = Math.round(180 * b / Math.PI / 20);
                            for(let e6 = 1; e6 < t5; e6++){
                                let r2 = e6 / t5;
                                if (.5 !== r2) {
                                    const t6 = r2 - .5;
                                    r2 += r2 * t6 * (r2 - 1) * ((1.0904 + g * (g * (3.55645 - 1.43519 * g) - 3.2452)) * t6 * t6 + (.848013 + g * (.215638 * g - 1.06021)));
                                }
                                const n1 = y.sub(d)._mult(r2)._add(d)._unit()._mult(w ? -1 : 1);
                                this.addHalfVertex(h, n1.x, n1.y, !1, w, 0, c);
                            }
                        }
                        f && this.addCurrentVertex(h, y, -e5, -r1, c);
                    } else if ("butt" === S) this.addCurrentVertex(h, m, 0, 0, c);
                    else if ("square" === S) {
                        const t7 = p ? 1 : -1;
                        p || this.addCurrentVertex(h, m, t7, t7, c), this.addCurrentVertex(h, m, 0, 0, c), p && this.addCurrentVertex(h, m, t7, t7, c);
                    } else "round" === S && (p && (this.addCurrentVertex(h, d, 0, 0, c), this.addCurrentVertex(h, d, 1, 1, c, !0)), f && (this.addCurrentVertex(h, y, -1, -1, c, !0), this.addCurrentVertex(h, y, 0, 0, c)));
                    if (_ && e3 < o - 1) {
                        const t8 = h.dist(f);
                        if (t8 > 2 * u) {
                            const e7 = h.add(f.sub(h)._mult(u / t8)._round());
                            this.updateDistance(h, e7), this.addCurrentVertex(e7, y, 0, 0, c), h = e7;
                        }
                    }
                }
            }
            addCurrentVertex(t1, e1, r, n, i, s = !1) {
                const a = e1.y * n - e1.x, o = -e1.y - e1.x * n;
                this.addHalfVertex(t1, e1.x + e1.y * r, e1.y - e1.x * r, s, !1, r, i), this.addHalfVertex(t1, a, o, s, !0, -n, i);
            }
            addHalfVertex({ x: t1 , y: e1  }, r, n, i, s, a, o) {
                this.layoutVertexArray.emplaceBack((t1 << 1) + (i ? 1 : 0), (e1 << 1) + (s ? 1 : 0), Math.round(63 * r) + 128, Math.round(63 * n) + 128, 1 + (0 === a ? 0 : a < 0 ? -1 : 1), 0, this.lineSoFar), this.lineClips && this.layoutVertexArray2.emplaceBack(this.scaledDistance, this.lineClipsArray.length, this.lineClips.start, this.lineClips.end);
                const l = o.vertexLength++;
                this.e1 >= 0 && this.e2 >= 0 && (this.indexArray.emplaceBack(this.e1, this.e2, l), o.primitiveLength++), s ? this.e2 = l : this.e1 = l;
            }
            updateScaledDistance() {
                if (this.lineClips) {
                    const t1 = this.totalDistance / (this.lineClips.end - this.lineClips.start);
                    this.scaledDistance = this.distance / this.totalDistance, this.lineSoFar = t1 * this.lineClips.start + this.distance;
                } else this.lineSoFar = this.distance;
            }
            updateDistance(t1, e1) {
                this.distance += t1.dist(e1), this.updateScaledDistance();
            }
        }
        ji(uh, "LineBucket", {
            omit: [
                "layers",
                "patternFeatures"
            ]
        });
        const ch = new Qs({
            "line-cap": new Hs(Ht.layout_line["line-cap"]),
            "line-join": new Hs(Ht.layout_line["line-join"]),
            "line-miter-limit": new Ks(Ht.layout_line["line-miter-limit"]),
            "line-round-limit": new Ks(Ht.layout_line["line-round-limit"]),
            "line-sort-key": new Hs(Ht.layout_line["line-sort-key"])
        });
        var hh = {
            paint: new Qs({
                "line-opacity": new Hs(Ht.paint_line["line-opacity"]),
                "line-color": new Hs(Ht.paint_line["line-color"]),
                "line-translate": new Ks(Ht.paint_line["line-translate"]),
                "line-translate-anchor": new Ks(Ht.paint_line["line-translate-anchor"]),
                "line-width": new Hs(Ht.paint_line["line-width"]),
                "line-gap-width": new Hs(Ht.paint_line["line-gap-width"]),
                "line-offset": new Hs(Ht.paint_line["line-offset"]),
                "line-blur": new Hs(Ht.paint_line["line-blur"]),
                "line-dasharray": new Ys(Ht.paint_line["line-dasharray"]),
                "line-pattern": new Ys(Ht.paint_line["line-pattern"]),
                "line-gradient": new Js(Ht.paint_line["line-gradient"]),
                "line-trim-offset": new Ks(Ht.paint_line["line-trim-offset"])
            }),
            layout: ch
        };
        const ph = new class extends Hs {
            possiblyEvaluate(t1, e1) {
                return e1 = new Us(Math.floor(e1.zoom), {
                    now: e1.now,
                    fadeDuration: e1.fadeDuration,
                    zoomHistory: e1.zoomHistory,
                    transition: e1.transition
                }), super.possiblyEvaluate(t1, e1);
            }
            evaluate(t1, e1, r, n) {
                return e1 = T({}, e1, {
                    zoom: Math.floor(e1.zoom)
                }), super.evaluate(t1, e1, r, n);
            }
        }(hh.paint.properties["line-width"].specification);
        function fh(t1, e1) {
            return e1 > 0 ? e1 + 2 * t1 : t1;
        }
        ph.useIntegerZoom = !0;
        const dh = ia([
            {
                name: "a_pos_offset",
                components: 4,
                type: "Int16"
            },
            {
                name: "a_tex_size",
                components: 4,
                type: "Uint16"
            },
            {
                name: "a_pixeloffset",
                components: 4,
                type: "Int16"
            }
        ], 4), yh = ia([
            {
                name: "a_globe_anchor",
                components: 3,
                type: "Int16"
            },
            {
                name: "a_globe_normal",
                components: 3,
                type: "Float32"
            }
        ], 4), mh = ia([
            {
                name: "a_projected_pos",
                components: 4,
                type: "Float32"
            }
        ], 4);
        ia([
            {
                name: "a_fade_opacity",
                components: 1,
                type: "Uint32"
            }
        ], 4);
        const gh = ia([
            {
                name: "a_placed",
                components: 2,
                type: "Uint8"
            },
            {
                name: "a_shift",
                components: 2,
                type: "Float32"
            }
        ]), xh = ia([
            {
                name: "a_size_scale",
                components: 1,
                type: "Float32"
            },
            {
                name: "a_padding",
                components: 2,
                type: "Float32"
            }
        ]);
        ia([
            {
                type: "Int16",
                name: "projectedAnchorX"
            },
            {
                type: "Int16",
                name: "projectedAnchorY"
            },
            {
                type: "Int16",
                name: "projectedAnchorZ"
            },
            {
                type: "Int16",
                name: "tileAnchorX"
            },
            {
                type: "Int16",
                name: "tileAnchorY"
            },
            {
                type: "Float32",
                name: "x1"
            },
            {
                type: "Float32",
                name: "y1"
            },
            {
                type: "Float32",
                name: "x2"
            },
            {
                type: "Float32",
                name: "y2"
            },
            {
                type: "Int16",
                name: "padding"
            },
            {
                type: "Uint32",
                name: "featureIndex"
            },
            {
                type: "Uint16",
                name: "sourceLayerIndex"
            },
            {
                type: "Uint16",
                name: "bucketIndex"
            }
        ]);
        const vh = ia([
            {
                name: "a_pos",
                components: 3,
                type: "Int16"
            },
            {
                name: "a_anchor_pos",
                components: 2,
                type: "Int16"
            },
            {
                name: "a_extrude",
                components: 2,
                type: "Int16"
            }
        ], 4), bh = ia([
            {
                name: "a_pos_2f",
                components: 2,
                type: "Float32"
            },
            {
                name: "a_radius",
                components: 1,
                type: "Float32"
            },
            {
                name: "a_flags",
                components: 2,
                type: "Int16"
            }
        ], 4);
        ia([
            {
                name: "triangle",
                components: 3,
                type: "Uint16"
            }
        ]), ia([
            {
                type: "Int16",
                name: "projectedAnchorX"
            },
            {
                type: "Int16",
                name: "projectedAnchorY"
            },
            {
                type: "Int16",
                name: "projectedAnchorZ"
            },
            {
                type: "Float32",
                name: "tileAnchorX"
            },
            {
                type: "Float32",
                name: "tileAnchorY"
            },
            {
                type: "Uint16",
                name: "glyphStartIndex"
            },
            {
                type: "Uint16",
                name: "numGlyphs"
            },
            {
                type: "Uint32",
                name: "vertexStartIndex"
            },
            {
                type: "Uint32",
                name: "lineStartIndex"
            },
            {
                type: "Uint32",
                name: "lineLength"
            },
            {
                type: "Uint16",
                name: "segment"
            },
            {
                type: "Uint16",
                name: "lowerSize"
            },
            {
                type: "Uint16",
                name: "upperSize"
            },
            {
                type: "Float32",
                name: "lineOffsetX"
            },
            {
                type: "Float32",
                name: "lineOffsetY"
            },
            {
                type: "Uint8",
                name: "writingMode"
            },
            {
                type: "Uint8",
                name: "placedOrientation"
            },
            {
                type: "Uint8",
                name: "hidden"
            },
            {
                type: "Uint32",
                name: "crossTileID"
            },
            {
                type: "Int16",
                name: "associatedIconIndex"
            },
            {
                type: "Uint8",
                name: "flipState"
            }
        ]), ia([
            {
                type: "Int16",
                name: "projectedAnchorX"
            },
            {
                type: "Int16",
                name: "projectedAnchorY"
            },
            {
                type: "Int16",
                name: "projectedAnchorZ"
            },
            {
                type: "Float32",
                name: "tileAnchorX"
            },
            {
                type: "Float32",
                name: "tileAnchorY"
            },
            {
                type: "Int16",
                name: "rightJustifiedTextSymbolIndex"
            },
            {
                type: "Int16",
                name: "centerJustifiedTextSymbolIndex"
            },
            {
                type: "Int16",
                name: "leftJustifiedTextSymbolIndex"
            },
            {
                type: "Int16",
                name: "verticalPlacedTextSymbolIndex"
            },
            {
                type: "Int16",
                name: "placedIconSymbolIndex"
            },
            {
                type: "Int16",
                name: "verticalPlacedIconSymbolIndex"
            },
            {
                type: "Uint16",
                name: "key"
            },
            {
                type: "Uint16",
                name: "textBoxStartIndex"
            },
            {
                type: "Uint16",
                name: "textBoxEndIndex"
            },
            {
                type: "Uint16",
                name: "verticalTextBoxStartIndex"
            },
            {
                type: "Uint16",
                name: "verticalTextBoxEndIndex"
            },
            {
                type: "Uint16",
                name: "iconBoxStartIndex"
            },
            {
                type: "Uint16",
                name: "iconBoxEndIndex"
            },
            {
                type: "Uint16",
                name: "verticalIconBoxStartIndex"
            },
            {
                type: "Uint16",
                name: "verticalIconBoxEndIndex"
            },
            {
                type: "Uint16",
                name: "featureIndex"
            },
            {
                type: "Uint16",
                name: "numHorizontalGlyphVertices"
            },
            {
                type: "Uint16",
                name: "numVerticalGlyphVertices"
            },
            {
                type: "Uint16",
                name: "numIconVertices"
            },
            {
                type: "Uint16",
                name: "numVerticalIconVertices"
            },
            {
                type: "Uint16",
                name: "useRuntimeCollisionCircles"
            },
            {
                type: "Uint32",
                name: "crossTileID"
            },
            {
                type: "Float32",
                components: 2,
                name: "textOffset"
            },
            {
                type: "Float32",
                name: "collisionCircleDiameter"
            }
        ]), ia([
            {
                type: "Float32",
                name: "offsetX"
            }
        ]), ia([
            {
                type: "Int16",
                name: "x"
            },
            {
                type: "Int16",
                name: "y"
            },
            {
                type: "Int16",
                name: "tileUnitDistanceFromAnchor"
            }
        ]);
        var _h = 24;
        const wh = 128;
        function Ah(t1, e1) {
            const { expression: r  } = e1;
            if ("constant" === r.kind) return {
                kind: "constant",
                layoutSize: r.evaluate(new Us(t1 + 1))
            };
            if ("source" === r.kind) return {
                kind: "source"
            };
            {
                const { zoomStops: e2 , interpolationType: n  } = r;
                let i = 0;
                for(; i < e2.length && e2[i] <= t1;)i++;
                i = Math.max(0, i - 1);
                let s = i;
                for(; s < e2.length && e2[s] < t1 + 1;)s++;
                s = Math.min(e2.length - 1, s);
                const a = e2[i], o = e2[s];
                return "composite" === r.kind ? {
                    kind: "composite",
                    minZoom: a,
                    maxZoom: o,
                    interpolationType: n
                } : {
                    kind: "camera",
                    minZoom: a,
                    maxZoom: o,
                    minSize: r.evaluate(new Us(a)),
                    maxSize: r.evaluate(new Us(o)),
                    interpolationType: n
                };
            }
        }
        function Sh(t1, { uSize: e1 , uSizeT: r  }, { lowerSize: n , upperSize: i  }) {
            return "source" === t1.kind ? n / wh : "composite" === t1.kind ? Ir(n / wh, i / wh, r) : e1;
        }
        function kh(t1, e1) {
            let r = 0, n = 0;
            if ("constant" === t1.kind) n = t1.layoutSize;
            else if ("source" !== t1.kind) {
                const { interpolationType: i , minZoom: s , maxZoom: a  } = t1, o = i ? S(Xr.interpolationFactor(i, e1, s, a), 0, 1) : 0;
                "camera" === t1.kind ? n = Ir(t1.minSize, t1.maxSize, o) : r = o;
            }
            return {
                uSizeT: r,
                uSize: n
            };
        }
        var Ih = Object.freeze({
            __proto__: null,
            getSizeData: Ah,
            evaluateSizeForFeature: Sh,
            evaluateSizeForZoom: kh,
            SIZE_PACK_FACTOR: wh
        });
        function Mh(t1, e1, r) {
            return t1.sections.forEach((t1)=>{
                t1.text = function(t1, e1, r) {
                    const n = e1.layout.get("text-transform").evaluate(r, {});
                    return "uppercase" === n ? t1 = t1.toLocaleUpperCase() : "lowercase" === n && (t1 = t1.toLocaleLowerCase()), Rs.applyArabicShaping && (t1 = Rs.applyArabicShaping(t1)), t1;
                }(t1.text, e1, r);
            }), t1;
        }
        const zh = {
            "!": "︕",
            "#": "＃",
            $: "＄",
            "%": "％",
            "&": "＆",
            "(": "︵",
            ")": "︶",
            "*": "＊",
            "+": "＋",
            ",": "︐",
            "-": "︲",
            ".": "・",
            "/": "／",
            ":": "︓",
            ";": "︔",
            "<": "︿",
            "=": "＝",
            ">": "﹀",
            "?": "︖",
            "@": "＠",
            "[": "﹇",
            "\\": "＼",
            "]": "﹈",
            "^": "＾",
            _: "︳",
            "`": "｀",
            "{": "︷",
            "|": "―",
            "}": "︸",
            "~": "～",
            "\xa2": "￠",
            "\xa3": "￡",
            "\xa5": "￥",
            "\xa6": "￤",
            "\xac": "￢",
            "\xaf": "￣",
            "–": "︲",
            "—": "︱",
            "‘": "﹃",
            "’": "﹄",
            "“": "﹁",
            "”": "﹂",
            "…": "︙",
            "‧": "・",
            "₩": "￦",
            "、": "︑",
            "。": "︒",
            "〈": "︿",
            "〉": "﹀",
            "《": "︽",
            "》": "︾",
            "「": "﹁",
            "」": "﹂",
            "『": "﹃",
            "』": "﹄",
            "【": "︻",
            "】": "︼",
            "〔": "︹",
            "〕": "︺",
            "〖": "︗",
            "〗": "︘",
            "！": "︕",
            "（": "︵",
            "）": "︶",
            "，": "︐",
            "－": "︲",
            "．": "・",
            "：": "︓",
            "；": "︔",
            "＜": "︿",
            "＞": "﹀",
            "？": "︖",
            "［": "﹇",
            "］": "﹈",
            "＿": "︳",
            "｛": "︷",
            "｜": "―",
            "｝": "︸",
            "｟": "︵",
            "｠": "︶",
            "｡": "︒",
            "｢": "﹁",
            "｣": "﹂"
        };
        function Th(t1) {
            return "︶" === t1 || "﹈" === t1 || "︸" === t1 || "﹄" === t1 || "﹂" === t1 || "︾" === t1 || "︼" === t1 || "︺" === t1 || "︘" === t1 || "﹀" === t1 || "︐" === t1 || "︓" === t1 || "︔" === t1 || "｀" === t1 || "￣" === t1 || "︑" === t1 || "︒" === t1;
        }
        function Bh(t1) {
            return "︵" === t1 || "﹇" === t1 || "︷" === t1 || "﹃" === t1 || "﹁" === t1 || "︽" === t1 || "︻" === t1 || "︹" === t1 || "︗" === t1 || "︿" === t1;
        }
        var Eh = Dh, Ph = function(t1, e1, r, n, i) {
            var s, a, o = 8 * i - n - 1, l = (1 << o) - 1, u = l >> 1, c = -7, h = r ? i - 1 : 0, p = r ? -1 : 1, f = t1[e1 + h];
            for(h += p, s = f & (1 << -c) - 1, f >>= -c, c += o; c > 0; s = 256 * s + t1[e1 + h], h += p, c -= 8);
            for(a = s & (1 << -c) - 1, s >>= -c, c += n; c > 0; a = 256 * a + t1[e1 + h], h += p, c -= 8);
            if (0 === s) s = 1 - u;
            else {
                if (s === l) return a ? NaN : 1 / 0 * (f ? -1 : 1);
                a += Math.pow(2, n), s -= u;
            }
            return (f ? -1 : 1) * a * Math.pow(2, s - n);
        }, Ch = function(t1, e1, r, n, i, s) {
            var a, o, l, u = 8 * s - i - 1, c = (1 << u) - 1, h = c >> 1, p = 23 === i ? Math.pow(2, -24) - Math.pow(2, -77) : 0, f = n ? 0 : s - 1, d = n ? 1 : -1, y = e1 < 0 || 0 === e1 && 1 / e1 < 0 ? 1 : 0;
            for(e1 = Math.abs(e1), isNaN(e1) || e1 === 1 / 0 ? (o = isNaN(e1) ? 1 : 0, a = c) : (a = Math.floor(Math.log(e1) / Math.LN2), e1 * (l = Math.pow(2, -a)) < 1 && (a--, l *= 2), (e1 += a + h >= 1 ? p / l : p * Math.pow(2, 1 - h)) * l >= 2 && (a++, l /= 2), a + h >= c ? (o = 0, a = c) : a + h >= 1 ? (o = (e1 * l - 1) * Math.pow(2, i), a += h) : (o = e1 * Math.pow(2, h - 1) * Math.pow(2, i), a = 0)); i >= 8; t1[r + f] = 255 & o, f += d, o /= 256, i -= 8);
            for(a = a << i | o, u += i; u > 0; t1[r + f] = 255 & a, f += d, a /= 256, u -= 8);
            t1[r + f - d] |= 128 * y;
        };
        /*! ieee754. BSD-3-Clause License. Feross Aboukhadijeh <https://feross.org/opensource> */ function Dh(t1) {
            this.buf = ArrayBuffer.isView && ArrayBuffer.isView(t1) ? t1 : new Uint8Array(t1 || 0), this.pos = 0, this.type = 0, this.length = this.buf.length;
        }
        Dh.Varint = 0, Dh.Fixed64 = 1, Dh.Bytes = 2, Dh.Fixed32 = 5;
        var Vh = 4294967296, Fh = 1 / Vh, Lh = "undefined" == typeof TextDecoder ? null : new TextDecoder("utf8");
        function Rh(t1) {
            return t1.type === Dh.Bytes ? t1.readVarint() + t1.pos : t1.pos + 1;
        }
        function Uh(t1, e1, r) {
            return r ? 4294967296 * e1 + (t1 >>> 0) : 4294967296 * (e1 >>> 0) + (t1 >>> 0);
        }
        function jh(t1, e1, r) {
            var n = e1 <= 16383 ? 1 : e1 <= 2097151 ? 2 : e1 <= 268435455 ? 3 : Math.floor(Math.log(e1) / (7 * Math.LN2));
            r.realloc(n);
            for(var i = r.pos - 1; i >= t1; i--)r.buf[i + n] = r.buf[i];
        }
        function $h(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeVarint(t1[r]);
        }
        function Oh(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeSVarint(t1[r]);
        }
        function qh(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeFloat(t1[r]);
        }
        function Nh(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeDouble(t1[r]);
        }
        function Gh(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeBoolean(t1[r]);
        }
        function Zh(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeFixed32(t1[r]);
        }
        function Xh(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeSFixed32(t1[r]);
        }
        function Kh(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeFixed64(t1[r]);
        }
        function Hh(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeSFixed64(t1[r]);
        }
        function Yh(t1, e1) {
            return (t1[e1] | t1[e1 + 1] << 8 | t1[e1 + 2] << 16) + 16777216 * t1[e1 + 3];
        }
        function Wh(t1, e1, r) {
            t1[r] = e1, t1[r + 1] = e1 >>> 8, t1[r + 2] = e1 >>> 16, t1[r + 3] = e1 >>> 24;
        }
        function Jh(t1, e1) {
            return (t1[e1] | t1[e1 + 1] << 8 | t1[e1 + 2] << 16) + (t1[e1 + 3] << 24);
        }
        function Qh(t1, e1, r) {
            e1.glyphs = [], 1 === t1 && r.readMessage(tp, e1);
        }
        function tp(t1, e1, r) {
            if (3 === t1) {
                const { id: t2 , bitmap: n , width: i , height: s , left: a , top: o , advance: l  } = r.readMessage(ep, {});
                e1.glyphs.push({
                    id: t2,
                    bitmap: new wu({
                        width: i + 6,
                        height: s + 6
                    }, n),
                    metrics: {
                        width: i,
                        height: s,
                        left: a,
                        top: o,
                        advance: l
                    }
                });
            } else 4 === t1 ? e1.ascender = r.readSVarint() : 5 === t1 && (e1.descender = r.readSVarint());
        }
        function ep(t1, e1, r) {
            1 === t1 ? e1.id = r.readVarint() : 2 === t1 ? e1.bitmap = r.readBytes() : 3 === t1 ? e1.width = r.readVarint() : 4 === t1 ? e1.height = r.readVarint() : 5 === t1 ? e1.left = r.readSVarint() : 6 === t1 ? e1.top = r.readSVarint() : 7 === t1 && (e1.advance = r.readVarint());
        }
        function rp(t1) {
            let e1 = 0, r = 0;
            for (const n of t1)e1 += n.w * n.h, r = Math.max(r, n.w);
            t1.sort((t1, e1)=>e1.h - t1.h);
            const n1 = [
                {
                    x: 0,
                    y: 0,
                    w: Math.max(Math.ceil(Math.sqrt(e1 / .95)), r),
                    h: 1 / 0
                }
            ];
            let i = 0, s = 0;
            for (const e2 of t1)for(let t2 = n1.length - 1; t2 >= 0; t2--){
                const r1 = n1[t2];
                if (!(e2.w > r1.w || e2.h > r1.h)) {
                    if (e2.x = r1.x, e2.y = r1.y, s = Math.max(s, e2.y + e2.h), i = Math.max(i, e2.x + e2.w), e2.w === r1.w && e2.h === r1.h) {
                        const e3 = n1.pop();
                        t2 < n1.length && (n1[t2] = e3);
                    } else e2.h === r1.h ? (r1.x += e2.w, r1.w -= e2.w) : e2.w === r1.w ? (r1.y += e2.h, r1.h -= e2.h) : (n1.push({
                        x: r1.x + e2.w,
                        y: r1.y,
                        w: r1.w - e2.w,
                        h: e2.h
                    }), r1.y += e2.h, r1.h -= e2.h);
                    break;
                }
            }
            return {
                w: i,
                h: s,
                fill: e1 / (i * s) || 0
            };
        }
        Dh.prototype = {
            destroy: function() {
                this.buf = null;
            },
            readFields: function(t1, e1, r) {
                for(r = r || this.length; this.pos < r;){
                    var n = this.readVarint(), i = n >> 3, s = this.pos;
                    this.type = 7 & n, t1(i, e1, this), this.pos === s && this.skip(n);
                }
                return e1;
            },
            readMessage: function(t1, e1) {
                return this.readFields(t1, e1, this.readVarint() + this.pos);
            },
            readFixed32: function() {
                var t1 = Yh(this.buf, this.pos);
                return this.pos += 4, t1;
            },
            readSFixed32: function() {
                var t1 = Jh(this.buf, this.pos);
                return this.pos += 4, t1;
            },
            readFixed64: function() {
                var t1 = Yh(this.buf, this.pos) + Yh(this.buf, this.pos + 4) * Vh;
                return this.pos += 8, t1;
            },
            readSFixed64: function() {
                var t1 = Yh(this.buf, this.pos) + Jh(this.buf, this.pos + 4) * Vh;
                return this.pos += 8, t1;
            },
            readFloat: function() {
                var t1 = Ph(this.buf, this.pos, !0, 23, 4);
                return this.pos += 4, t1;
            },
            readDouble: function() {
                var t1 = Ph(this.buf, this.pos, !0, 52, 8);
                return this.pos += 8, t1;
            },
            readVarint: function(t1) {
                var e1, r, n = this.buf;
                return e1 = 127 & (r = n[this.pos++]), r < 128 ? e1 : (e1 |= (127 & (r = n[this.pos++])) << 7, r < 128 ? e1 : (e1 |= (127 & (r = n[this.pos++])) << 14, r < 128 ? e1 : (e1 |= (127 & (r = n[this.pos++])) << 21, r < 128 ? e1 : function(t1, e1, r) {
                    var n, i, s = r.buf;
                    if (n = (112 & (i = s[r.pos++])) >> 4, i < 128) return Uh(t1, n, e1);
                    if (n |= (127 & (i = s[r.pos++])) << 3, i < 128) return Uh(t1, n, e1);
                    if (n |= (127 & (i = s[r.pos++])) << 10, i < 128) return Uh(t1, n, e1);
                    if (n |= (127 & (i = s[r.pos++])) << 17, i < 128) return Uh(t1, n, e1);
                    if (n |= (127 & (i = s[r.pos++])) << 24, i < 128) return Uh(t1, n, e1);
                    if (n |= (1 & (i = s[r.pos++])) << 31, i < 128) return Uh(t1, n, e1);
                    throw new Error("Expected varint not more than 10 bytes");
                }(e1 |= (15 & (r = n[this.pos])) << 28, t1, this))));
            },
            readVarint64: function() {
                return this.readVarint(!0);
            },
            readSVarint: function() {
                var t1 = this.readVarint();
                return t1 % 2 == 1 ? (t1 + 1) / -2 : t1 / 2;
            },
            readBoolean: function() {
                return Boolean(this.readVarint());
            },
            readString: function() {
                var t1 = this.readVarint() + this.pos, e1 = this.pos;
                return this.pos = t1, t1 - e1 >= 12 && Lh ? function(t1, e1, r) {
                    return Lh.decode(t1.subarray(e1, r));
                }(this.buf, e1, t1) : function(t1, e1, r) {
                    for(var n = "", i = e1; i < r;){
                        var s, a, o, l = t1[i], u = null, c = l > 239 ? 4 : l > 223 ? 3 : l > 191 ? 2 : 1;
                        if (i + c > r) break;
                        1 === c ? l < 128 && (u = l) : 2 === c ? 128 == (192 & (s = t1[i + 1])) && (u = (31 & l) << 6 | 63 & s) <= 127 && (u = null) : 3 === c ? (a = t1[i + 2], 128 == (192 & (s = t1[i + 1])) && 128 == (192 & a) && ((u = (15 & l) << 12 | (63 & s) << 6 | 63 & a) <= 2047 || u >= 55296 && u <= 57343) && (u = null)) : 4 === c && (a = t1[i + 2], o = t1[i + 3], 128 == (192 & (s = t1[i + 1])) && 128 == (192 & a) && 128 == (192 & o) && ((u = (15 & l) << 18 | (63 & s) << 12 | (63 & a) << 6 | 63 & o) <= 65535 || u >= 1114112) && (u = null)), null === u ? (u = 65533, c = 1) : u > 65535 && (u -= 65536, n += String.fromCharCode(u >>> 10 & 1023 | 55296), u = 56320 | 1023 & u), n += String.fromCharCode(u), i += c;
                    }
                    return n;
                }(this.buf, e1, t1);
            },
            readBytes: function() {
                var t1 = this.readVarint() + this.pos, e1 = this.buf.subarray(this.pos, t1);
                return this.pos = t1, e1;
            },
            readPackedVarint: function(t1, e1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readVarint(e1));
                var r = Rh(this);
                for(t1 = t1 || []; this.pos < r;)t1.push(this.readVarint(e1));
                return t1;
            },
            readPackedSVarint: function(t1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readSVarint());
                var e1 = Rh(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readSVarint());
                return t1;
            },
            readPackedBoolean: function(t1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readBoolean());
                var e1 = Rh(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readBoolean());
                return t1;
            },
            readPackedFloat: function(t1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readFloat());
                var e1 = Rh(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readFloat());
                return t1;
            },
            readPackedDouble: function(t1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readDouble());
                var e1 = Rh(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readDouble());
                return t1;
            },
            readPackedFixed32: function(t1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readFixed32());
                var e1 = Rh(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readFixed32());
                return t1;
            },
            readPackedSFixed32: function(t1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readSFixed32());
                var e1 = Rh(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readSFixed32());
                return t1;
            },
            readPackedFixed64: function(t1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readFixed64());
                var e1 = Rh(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readFixed64());
                return t1;
            },
            readPackedSFixed64: function(t1) {
                if (this.type !== Dh.Bytes) return t1.push(this.readSFixed64());
                var e1 = Rh(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readSFixed64());
                return t1;
            },
            skip: function(t1) {
                var e1 = 7 & t1;
                if (e1 === Dh.Varint) for(; this.buf[this.pos++] > 127;);
                else if (e1 === Dh.Bytes) this.pos = this.readVarint() + this.pos;
                else if (e1 === Dh.Fixed32) this.pos += 4;
                else {
                    if (e1 !== Dh.Fixed64) throw new Error("Unimplemented type: " + e1);
                    this.pos += 8;
                }
            },
            writeTag: function(t1, e1) {
                this.writeVarint(t1 << 3 | e1);
            },
            realloc: function(t1) {
                for(var e1 = this.length || 16; e1 < this.pos + t1;)e1 *= 2;
                if (e1 !== this.length) {
                    var r = new Uint8Array(e1);
                    r.set(this.buf), this.buf = r, this.length = e1;
                }
            },
            finish: function() {
                return this.length = this.pos, this.pos = 0, this.buf.subarray(0, this.length);
            },
            writeFixed32: function(t1) {
                this.realloc(4), Wh(this.buf, t1, this.pos), this.pos += 4;
            },
            writeSFixed32: function(t1) {
                this.realloc(4), Wh(this.buf, t1, this.pos), this.pos += 4;
            },
            writeFixed64: function(t1) {
                this.realloc(8), Wh(this.buf, -1 & t1, this.pos), Wh(this.buf, Math.floor(t1 * Fh), this.pos + 4), this.pos += 8;
            },
            writeSFixed64: function(t1) {
                this.realloc(8), Wh(this.buf, -1 & t1, this.pos), Wh(this.buf, Math.floor(t1 * Fh), this.pos + 4), this.pos += 8;
            },
            writeVarint: function(t1) {
                (t1 = +t1 || 0) > 268435455 || t1 < 0 ? function(t1, e1) {
                    var r, n;
                    if (t1 >= 0 ? (r = t1 % 4294967296 | 0, n = t1 / 4294967296 | 0) : (n = ~(-t1 / 4294967296), 4294967295 ^ (r = ~(-t1 % 4294967296)) ? r = r + 1 | 0 : (r = 0, n = n + 1 | 0)), t1 >= 0x10000000000000000 || t1 < -18446744073709552000) throw new Error("Given varint doesn't fit into 10 bytes");
                    e1.realloc(10), function(t1, e1, r) {
                        r.buf[r.pos++] = 127 & t1 | 128, t1 >>>= 7, r.buf[r.pos++] = 127 & t1 | 128, t1 >>>= 7, r.buf[r.pos++] = 127 & t1 | 128, t1 >>>= 7, r.buf[r.pos++] = 127 & t1 | 128, r.buf[r.pos] = 127 & (t1 >>>= 7);
                    }(r, 0, e1), function(t1, e1) {
                        var r = (7 & t1) << 4;
                        e1.buf[e1.pos++] |= r | ((t1 >>>= 3) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1 | ((t1 >>>= 7) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1 | ((t1 >>>= 7) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1 | ((t1 >>>= 7) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1 | ((t1 >>>= 7) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1)))));
                    }(n, e1);
                }(t1, this) : (this.realloc(4), this.buf[this.pos++] = 127 & t1 | (t1 > 127 ? 128 : 0), t1 <= 127 || (this.buf[this.pos++] = 127 & (t1 >>>= 7) | (t1 > 127 ? 128 : 0), t1 <= 127 || (this.buf[this.pos++] = 127 & (t1 >>>= 7) | (t1 > 127 ? 128 : 0), t1 <= 127 || (this.buf[this.pos++] = t1 >>> 7 & 127))));
            },
            writeSVarint: function(t1) {
                this.writeVarint(t1 < 0 ? 2 * -t1 - 1 : 2 * t1);
            },
            writeBoolean: function(t1) {
                this.writeVarint(Boolean(t1));
            },
            writeString: function(t1) {
                t1 = String(t1), this.realloc(4 * t1.length), this.pos++;
                var e1 = this.pos;
                this.pos = function(t1, e1, r) {
                    for(var n, i, s = 0; s < e1.length; s++){
                        if ((n = e1.charCodeAt(s)) > 55295 && n < 57344) {
                            if (!i) {
                                n > 56319 || s + 1 === e1.length ? (t1[r++] = 239, t1[r++] = 191, t1[r++] = 189) : i = n;
                                continue;
                            }
                            if (n < 56320) {
                                t1[r++] = 239, t1[r++] = 191, t1[r++] = 189, i = n;
                                continue;
                            }
                            n = i - 55296 << 10 | n - 56320 | 65536, i = null;
                        } else i && (t1[r++] = 239, t1[r++] = 191, t1[r++] = 189, i = null);
                        n < 128 ? t1[r++] = n : (n < 2048 ? t1[r++] = n >> 6 | 192 : (n < 65536 ? t1[r++] = n >> 12 | 224 : (t1[r++] = n >> 18 | 240, t1[r++] = n >> 12 & 63 | 128), t1[r++] = n >> 6 & 63 | 128), t1[r++] = 63 & n | 128);
                    }
                    return r;
                }(this.buf, t1, this.pos);
                var r = this.pos - e1;
                r >= 128 && jh(e1, r, this), this.pos = e1 - 1, this.writeVarint(r), this.pos += r;
            },
            writeFloat: function(t1) {
                this.realloc(4), Ch(this.buf, t1, this.pos, !0, 23, 4), this.pos += 4;
            },
            writeDouble: function(t1) {
                this.realloc(8), Ch(this.buf, t1, this.pos, !0, 52, 8), this.pos += 8;
            },
            writeBytes: function(t1) {
                var e1 = t1.length;
                this.writeVarint(e1), this.realloc(e1);
                for(var r = 0; r < e1; r++)this.buf[this.pos++] = t1[r];
            },
            writeRawMessage: function(t1, e1) {
                this.pos++;
                var r = this.pos;
                t1(e1, this);
                var n = this.pos - r;
                n >= 128 && jh(r, n, this), this.pos = r - 1, this.writeVarint(n), this.pos += n;
            },
            writeMessage: function(t1, e1, r) {
                this.writeTag(t1, Dh.Bytes), this.writeRawMessage(e1, r);
            },
            writePackedVarint: function(t1, e1) {
                e1.length && this.writeMessage(t1, $h, e1);
            },
            writePackedSVarint: function(t1, e1) {
                e1.length && this.writeMessage(t1, Oh, e1);
            },
            writePackedBoolean: function(t1, e1) {
                e1.length && this.writeMessage(t1, Gh, e1);
            },
            writePackedFloat: function(t1, e1) {
                e1.length && this.writeMessage(t1, qh, e1);
            },
            writePackedDouble: function(t1, e1) {
                e1.length && this.writeMessage(t1, Nh, e1);
            },
            writePackedFixed32: function(t1, e1) {
                e1.length && this.writeMessage(t1, Zh, e1);
            },
            writePackedSFixed32: function(t1, e1) {
                e1.length && this.writeMessage(t1, Xh, e1);
            },
            writePackedFixed64: function(t1, e1) {
                e1.length && this.writeMessage(t1, Kh, e1);
            },
            writePackedSFixed64: function(t1, e1) {
                e1.length && this.writeMessage(t1, Hh, e1);
            },
            writeBytesField: function(t1, e1) {
                this.writeTag(t1, Dh.Bytes), this.writeBytes(e1);
            },
            writeFixed32Field: function(t1, e1) {
                this.writeTag(t1, Dh.Fixed32), this.writeFixed32(e1);
            },
            writeSFixed32Field: function(t1, e1) {
                this.writeTag(t1, Dh.Fixed32), this.writeSFixed32(e1);
            },
            writeFixed64Field: function(t1, e1) {
                this.writeTag(t1, Dh.Fixed64), this.writeFixed64(e1);
            },
            writeSFixed64Field: function(t1, e1) {
                this.writeTag(t1, Dh.Fixed64), this.writeSFixed64(e1);
            },
            writeVarintField: function(t1, e1) {
                this.writeTag(t1, Dh.Varint), this.writeVarint(e1);
            },
            writeSVarintField: function(t1, e1) {
                this.writeTag(t1, Dh.Varint), this.writeSVarint(e1);
            },
            writeStringField: function(t1, e1) {
                this.writeTag(t1, Dh.Bytes), this.writeString(e1);
            },
            writeFloatField: function(t1, e1) {
                this.writeTag(t1, Dh.Fixed32), this.writeFloat(e1);
            },
            writeDoubleField: function(t1, e1) {
                this.writeTag(t1, Dh.Fixed64), this.writeDouble(e1);
            },
            writeBooleanField: function(t1, e1) {
                this.writeVarintField(t1, Boolean(e1));
            }
        };
        class np {
            constructor(t1, { pixelRatio: e1 , version: r , stretchX: n , stretchY: i , content: s  }){
                this.paddedRect = t1, this.pixelRatio = e1, this.stretchX = n, this.stretchY = i, this.content = s, this.version = r;
            }
            get tl() {
                return [
                    this.paddedRect.x + 1,
                    this.paddedRect.y + 1
                ];
            }
            get br() {
                return [
                    this.paddedRect.x + this.paddedRect.w - 1,
                    this.paddedRect.y + this.paddedRect.h - 1
                ];
            }
            get displaySize() {
                return [
                    (this.paddedRect.w - 2) / this.pixelRatio,
                    (this.paddedRect.h - 2) / this.pixelRatio
                ];
            }
        }
        class ip {
            constructor(t1, e1){
                const r = {}, n = {};
                this.haveRenderCallbacks = [];
                const i = [];
                this.addImages(t1, r, i), this.addImages(e1, n, i);
                const { w: s , h: a  } = rp(i), o = new Au({
                    width: s || 1,
                    height: a || 1
                });
                for(const e2 in t1){
                    const n1 = t1[e2], i1 = r[e2].paddedRect;
                    Au.copy(n1.data, o, {
                        x: 0,
                        y: 0
                    }, {
                        x: i1.x + 1,
                        y: i1.y + 1
                    }, n1.data);
                }
                for(const t2 in e1){
                    const r1 = e1[t2], i2 = n[t2].paddedRect, s1 = i2.x + 1, a1 = i2.y + 1, l = r1.data.width, u = r1.data.height;
                    Au.copy(r1.data, o, {
                        x: 0,
                        y: 0
                    }, {
                        x: s1,
                        y: a1
                    }, r1.data), Au.copy(r1.data, o, {
                        x: 0,
                        y: u - 1
                    }, {
                        x: s1,
                        y: a1 - 1
                    }, {
                        width: l,
                        height: 1
                    }), Au.copy(r1.data, o, {
                        x: 0,
                        y: 0
                    }, {
                        x: s1,
                        y: a1 + u
                    }, {
                        width: l,
                        height: 1
                    }), Au.copy(r1.data, o, {
                        x: l - 1,
                        y: 0
                    }, {
                        x: s1 - 1,
                        y: a1
                    }, {
                        width: 1,
                        height: u
                    }), Au.copy(r1.data, o, {
                        x: 0,
                        y: 0
                    }, {
                        x: s1 + l,
                        y: a1
                    }, {
                        width: 1,
                        height: u
                    });
                }
                this.image = o, this.iconPositions = r, this.patternPositions = n;
            }
            addImages(t1, e1, r) {
                for(const n in t1){
                    const i = t1[n], s = {
                        x: 0,
                        y: 0,
                        w: i.data.width + 2,
                        h: i.data.height + 2
                    };
                    r.push(s), e1[n] = new np(s, i), i.hasRenderCallback && this.haveRenderCallbacks.push(n);
                }
            }
            patchUpdatedImages(t1, e1) {
                this.haveRenderCallbacks = this.haveRenderCallbacks.filter((e1)=>t1.hasImage(e1)), t1.dispatchRenderCallbacks(this.haveRenderCallbacks);
                for(const r in t1.updatedImages)this.patchUpdatedImage(this.iconPositions[r], t1.getImage(r), e1), this.patchUpdatedImage(this.patternPositions[r], t1.getImage(r), e1);
            }
            patchUpdatedImage(t1, e1, r) {
                if (!t1 || !e1) return;
                if (t1.version === e1.version) return;
                t1.version = e1.version;
                const [n, i] = t1.tl;
                r.update(e1.data, void 0, {
                    x: n,
                    y: i
                });
            }
        }
        ji(np, "ImagePosition"), ji(ip, "ImageAtlas");
        const sp = {
            horizontal: 1,
            vertical: 2,
            horizontalOnly: 3
        };
        class ap {
            constructor(){
                this.scale = 1, this.fontStack = "", this.imageName = null;
            }
            static forText(t1, e1) {
                const r = new ap;
                return r.scale = t1 || 1, r.fontStack = e1, r;
            }
            static forImage(t1) {
                const e1 = new ap;
                return e1.imageName = t1, e1;
            }
        }
        class op {
            constructor(){
                this.text = "", this.sectionIndex = [], this.sections = [], this.imageSectionID = null;
            }
            static fromFeature(t1, e1) {
                const r = new op;
                for(let n = 0; n < t1.sections.length; n++){
                    const i = t1.sections[n];
                    i.image ? r.addImageSection(i) : r.addTextSection(i, e1);
                }
                return r;
            }
            length() {
                return this.text.length;
            }
            getSection(t1) {
                return this.sections[this.sectionIndex[t1]];
            }
            getSections() {
                return this.sections;
            }
            getSectionIndex(t1) {
                return this.sectionIndex[t1];
            }
            getCharCode(t1) {
                return this.text.charCodeAt(t1);
            }
            verticalizePunctuation(t1) {
                this.text = function(t1, e1) {
                    let r = "";
                    for(let n = 0; n < t1.length; n++){
                        const i = t1.charCodeAt(n + 1) || null, s = t1.charCodeAt(n - 1) || null;
                        r += !e1 && (i && As(i) && !zh[t1[n + 1]] || s && As(s) && !zh[t1[n - 1]]) || !zh[t1[n]] ? t1[n] : zh[t1[n]];
                    }
                    return r;
                }(this.text, t1);
            }
            trim() {
                let t1 = 0;
                for(let e1 = 0; e1 < this.text.length && up[this.text.charCodeAt(e1)]; e1++)t1++;
                let e2 = this.text.length;
                for(let r = this.text.length - 1; r >= 0 && r >= t1 && up[this.text.charCodeAt(r)]; r--)e2--;
                this.text = this.text.substring(t1, e2), this.sectionIndex = this.sectionIndex.slice(t1, e2);
            }
            substring(t1, e1) {
                const r = new op;
                return r.text = this.text.substring(t1, e1), r.sectionIndex = this.sectionIndex.slice(t1, e1), r.sections = this.sections, r;
            }
            toString() {
                return this.text;
            }
            getMaxScale() {
                return this.sectionIndex.reduce((t1, e1)=>Math.max(t1, this.sections[e1].scale), 0);
            }
            addTextSection(t1, e1) {
                this.text += t1.text, this.sections.push(ap.forText(t1.scale, t1.fontStack || e1));
                const r = this.sections.length - 1;
                for(let e2 = 0; e2 < t1.text.length; ++e2)this.sectionIndex.push(r);
            }
            addImageSection(t1) {
                const e1 = t1.image ? t1.image.name : "";
                if (0 === e1.length) return void $("Can't add FormattedSection with an empty image.");
                const r = this.getNextImageSectionCharCode();
                r ? (this.text += String.fromCharCode(r), this.sections.push(ap.forImage(e1)), this.sectionIndex.push(this.sections.length - 1)) : $("Reached maximum number of images 6401");
            }
            getNextImageSectionCharCode() {
                return this.imageSectionID ? this.imageSectionID >= 63743 ? null : ++this.imageSectionID : (this.imageSectionID = 57344, this.imageSectionID);
            }
        }
        function lp(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, d, y) {
            const m = op.fromFeature(t1, i);
            let g;
            h === sp.vertical && m.verticalizePunctuation(p);
            const { processBidirectionalText: x , processStyledBidirectionalText: v  } = Rs;
            if (x && 1 === m.sections.length) {
                g = [];
                const t2 = x(m.toString(), mp(m, u, s, e1, n, f, d));
                for (const e2 of t2){
                    const t3 = new op;
                    t3.text = e2, t3.sections = m.sections;
                    for(let r1 = 0; r1 < e2.length; r1++)t3.sectionIndex.push(0);
                    g.push(t3);
                }
            } else if (v) {
                g = [];
                const t4 = v(m.text, m.sectionIndex, mp(m, u, s, e1, n, f, d));
                for (const e3 of t4){
                    const t5 = new op;
                    t5.text = e3[0], t5.sectionIndex = e3[1], t5.sections = m.sections, g.push(t5);
                }
            } else g = function(t1, e1) {
                const r = [], n = t1.text;
                let i = 0;
                for (const n1 of e1)r.push(t1.substring(i, n1)), i = n1;
                return i < n.length && r.push(t1.substring(i, n.length)), r;
            }(m, mp(m, u, s, e1, n, f, d));
            const b = [], _ = {
                positionedLines: b,
                text: m.toString(),
                top: c[1],
                bottom: c[1],
                left: c[0],
                right: c[0],
                writingMode: h,
                iconsInText: !1,
                verticalizable: !1,
                hasBaseline: !1
            };
            return function(t1, e1, r, n, i, s, a, o, l, u, c, h) {
                let p = 0, f = 0, d = 0;
                const y = "right" === o ? 1 : "left" === o ? 0 : .5;
                let m = !1;
                for (const t2 of i){
                    const r1 = t2.getSections();
                    for (const t3 of r1){
                        if (t3.imageName) continue;
                        const r2 = e1[t3.fontStack];
                        if (r2 && (m = void 0 !== r2.ascender && void 0 !== r2.descender, !m)) break;
                    }
                    if (!m) break;
                }
                let g = 0;
                for (const a1 of i){
                    a1.trim();
                    const i1 = a1.getMaxScale(), o1 = (i1 - 1) * _h, v = {
                        positionedGlyphs: [],
                        lineOffset: 0
                    };
                    t1.positionedLines[g] = v;
                    const b = v.positionedGlyphs;
                    let _ = 0;
                    if (!a1.length()) {
                        f += s, ++g;
                        continue;
                    }
                    let w = 0, A = 0;
                    for(let s1 = 0; s1 < a1.length(); s1++){
                        const o2 = a1.getSection(s1), d1 = a1.getSectionIndex(s1), y1 = a1.getCharCode(s1);
                        let g1 = o2.scale, v1 = null, S = null, k = null, I = _h, M = 0;
                        const z = !(l === sp.horizontal || !c && !ws(y1) || c && (up[y1] || (x = y1, Zi(x) || Xi(x) || Ki(x) || fs(x) || gs(x))));
                        if (o2.imageName) {
                            const e2 = n[o2.imageName];
                            if (!e2) continue;
                            k = o2.imageName, t1.iconsInText = t1.iconsInText || !0, S = e2.paddedRect;
                            const r3 = e2.displaySize;
                            g1 = g1 * _h / h, v1 = {
                                width: r3[0],
                                height: r3[1],
                                left: 1,
                                top: -3,
                                advance: z ? r3[1] : r3[0],
                                localGlyph: !1
                            }, M = m ? -v1.height * g1 : i1 * _h - 17 - r3[1] * g1, I = v1.advance;
                            const s2 = (z ? r3[0] : r3[1]) * g1 - _h * i1;
                            s2 > 0 && s2 > _ && (_ = s2);
                        } else {
                            const t4 = r[o2.fontStack];
                            if (!t4) continue;
                            t4[y1] && (S = t4[y1]);
                            const n1 = e1[o2.fontStack];
                            if (!n1) continue;
                            const s3 = n1.glyphs[y1];
                            if (!s3) continue;
                            if (v1 = s3.metrics, I = 8203 !== y1 ? _h : 0, m) {
                                const t5 = void 0 !== n1.ascender ? Math.abs(n1.ascender) : 0, e3 = void 0 !== n1.descender ? Math.abs(n1.descender) : 0, r4 = (t5 + e3) * g1;
                                w < r4 && (w = r4, A = (t5 - e3) / 2 * g1), M = -t5 * g1;
                            } else M = (i1 - g1) * _h - 17;
                        }
                        z ? (t1.verticalizable = !0, b.push({
                            glyph: y1,
                            imageName: k,
                            x: p,
                            y: f + M,
                            vertical: z,
                            scale: g1,
                            localGlyph: v1.localGlyph,
                            fontStack: o2.fontStack,
                            sectionIndex: d1,
                            metrics: v1,
                            rect: S
                        }), p += I * g1 + u) : (b.push({
                            glyph: y1,
                            imageName: k,
                            x: p,
                            y: f + M,
                            vertical: z,
                            scale: g1,
                            localGlyph: v1.localGlyph,
                            fontStack: o2.fontStack,
                            sectionIndex: d1,
                            metrics: v1,
                            rect: S
                        }), p += v1.advance * g1 + u);
                    }
                    0 !== b.length && (d = Math.max(p - u, d), m ? xp(b, y, _, A, s * i1 / 2) : xp(b, y, _, 0, s / 2)), p = 0;
                    const S1 = s * i1 + _;
                    v.lineOffset = Math.max(_, o1), f += S1, ++g;
                }
                var x;
                const v2 = f, { horizontalAlign: b1 , verticalAlign: _1  } = gp(a);
                (function(t1, e1, r, n, i, s) {
                    const a = (e1 - r) * i, o = -s * n;
                    for (const e2 of t1)for (const t2 of e2.positionedGlyphs)t2.x += a, t2.y += o;
                })(t1.positionedLines, y, b1, _1, d, v2), t1.top += -_1 * v2, t1.bottom = t1.top + v2, t1.left += -b1 * d, t1.right = t1.left + d, t1.hasBaseline = m;
            }(_, e1, r, n, g, a, o, l, h, u, p, y), !function(t1) {
                for (const e1 of t1)if (0 !== e1.positionedGlyphs.length) return !1;
                return !0;
            }(b) && _;
        }
        const up = {
            9: !0,
            10: !0,
            11: !0,
            12: !0,
            13: !0,
            32: !0
        }, cp = {
            10: !0,
            32: !0,
            38: !0,
            40: !0,
            41: !0,
            43: !0,
            45: !0,
            47: !0,
            173: !0,
            183: !0,
            8203: !0,
            8208: !0,
            8211: !0,
            8231: !0
        };
        function hp(t1, e1, r, n, i, s) {
            if (e1.imageName) {
                const t2 = n[e1.imageName];
                return t2 ? t2.displaySize[0] * e1.scale * _h / s + i : 0;
            }
            {
                const n1 = r[e1.fontStack], s1 = n1 && n1.glyphs[t1];
                return s1 ? s1.metrics.advance * e1.scale + i : 0;
            }
        }
        function pp(t1, e1, r, n) {
            const i = Math.pow(t1 - e1, 2);
            return n ? t1 < e1 ? i / 2 : 2 * i : i + Math.abs(r) * r;
        }
        function fp(t1, e1, r) {
            let n = 0;
            return 10 === t1 && (n -= 1e4), r && (n += 150), 40 !== t1 && 65288 !== t1 || (n += 50), 41 !== e1 && 65289 !== e1 || (n += 50), n;
        }
        function dp(t1, e1, r, n, i, s) {
            let a = null, o = pp(e1, r, i, s);
            for (const t2 of n){
                const n1 = pp(e1 - t2.x, r, i, s) + t2.badness;
                n1 <= o && (a = t2, o = n1);
            }
            return {
                index: t1,
                x: e1,
                priorBreak: a,
                badness: o
            };
        }
        function yp(t1) {
            return t1 ? yp(t1.priorBreak).concat(t1.index) : [];
        }
        function mp(t1, e1, r, n, i, s, a) {
            if ("point" !== s) return [];
            if (!t1) return [];
            const o = [], l = function(t1, e1, r, n, i, s) {
                let a = 0;
                for(let r1 = 0; r1 < t1.length(); r1++){
                    const o = t1.getSection(r1);
                    a += hp(t1.getCharCode(r1), o, n, i, e1, s);
                }
                return a / Math.max(1, Math.ceil(a / r));
            }(t1, e1, r, n, i, a), u = t1.text.indexOf("​") >= 0;
            let c = 0;
            for(let r1 = 0; r1 < t1.length(); r1++){
                const s1 = t1.getSection(r1), p = t1.getCharCode(r1);
                if (up[p] || (c += hp(p, s1, n, i, e1, a)), r1 < t1.length() - 1) {
                    const e2 = !((h = p) < 11904 || !(rs(h) || es(h) || ys(h) || ps(h) || as(h) || Hi(h) || ns(h) || Ji(h) || os(h) || ls(h) || ss(h) || xs(h) || Qi(h) || Wi(h) || Yi(h) || is(h) || ts(h) || ds(h) || cs(h) || us(h)));
                    (cp[p] || e2 || s1.imageName) && o.push(dp(r1 + 1, c, l, o, fp(p, t1.getCharCode(r1 + 1), e2 && u), !1));
                }
            }
            var h;
            return yp(dp(t1.length(), c, l, o, 0, !0));
        }
        function gp(t1) {
            let e1 = .5, r = .5;
            switch(t1){
                case "right":
                case "top-right":
                case "bottom-right":
                    e1 = 1;
                    break;
                case "left":
                case "top-left":
                case "bottom-left":
                    e1 = 0;
            }
            switch(t1){
                case "bottom":
                case "bottom-right":
                case "bottom-left":
                    r = 1;
                    break;
                case "top":
                case "top-right":
                case "top-left":
                    r = 0;
            }
            return {
                horizontalAlign: e1,
                verticalAlign: r
            };
        }
        function xp(t1, e1, r, n, i) {
            if (!(e1 || r || n || i)) return;
            const s = t1.length - 1, a = t1[s], o = (a.x + a.metrics.advance * a.scale) * e1;
            for(let e2 = 0; e2 <= s; e2++)t1[e2].x -= o, t1[e2].y += r + n + i;
        }
        function vp(t1, e1, r) {
            const { horizontalAlign: n , verticalAlign: i  } = gp(r), s = e1[0] - t1.displaySize[0] * n, a = e1[1] - t1.displaySize[1] * i;
            return {
                image: t1,
                top: a,
                bottom: a + t1.displaySize[1],
                left: s,
                right: s + t1.displaySize[0]
            };
        }
        function bp(t1, e1, r, n, i, s) {
            const a = t1.image;
            let o;
            if (a.content) {
                const t2 = a.content, e2 = a.pixelRatio || 1;
                o = [
                    t2[0] / e2,
                    t2[1] / e2,
                    a.displaySize[0] - t2[2] / e2,
                    a.displaySize[1] - t2[3] / e2
                ];
            }
            const l = e1.left * s, u = e1.right * s;
            let c, h, p, f;
            "width" === r || "both" === r ? (f = i[0] + l - n[3], h = i[0] + u + n[1]) : (f = i[0] + (l + u - a.displaySize[0]) / 2, h = f + a.displaySize[0]);
            const d = e1.top * s, y = e1.bottom * s;
            return "height" === r || "both" === r ? (c = i[1] + d - n[0], p = i[1] + y + n[2]) : (c = i[1] + (d + y - a.displaySize[1]) / 2, p = c + a.displaySize[1]), {
                image: a,
                top: c,
                right: h,
                bottom: p,
                left: f,
                collisionPadding: o
            };
        }
        class _p extends d {
            constructor(t1, e1, r, n, i){
                super(t1, e1), this.angle = n, this.z = r, void 0 !== i && (this.segment = i);
            }
            clone() {
                return new _p(this.x, this.y, this.z, this.angle, this.segment);
            }
        }
        function wp(t1, e1, r, n, i) {
            if (void 0 === e1.segment) return !0;
            let s = e1, a = e1.segment + 1, o = 0;
            for(; o > -r / 2;){
                if (a--, a < 0) return !1;
                o -= t1[a].dist(s), s = t1[a];
            }
            o += t1[a].dist(t1[a + 1]), a++;
            const l = [];
            let u = 0;
            for(; o < r / 2;){
                const e2 = t1[a], r1 = t1[a + 1];
                if (!r1) return !1;
                let s1 = t1[a - 1].angleTo(e2) - e2.angleTo(r1);
                for(s1 = Math.abs((s1 + 3 * Math.PI) % (2 * Math.PI) - Math.PI), l.push({
                    distance: o,
                    angleDelta: s1
                }), u += s1; o - l[0].distance > n;)u -= l.shift().angleDelta;
                if (u > i) return !1;
                a++, o += e2.dist(r1);
            }
            return !0;
        }
        function Ap(t1) {
            let e1 = 0;
            for(let r = 0; r < t1.length - 1; r++)e1 += t1[r].dist(t1[r + 1]);
            return e1;
        }
        function Sp(t1, e1, r) {
            return t1 ? .6 * e1 * r : 0;
        }
        function kp(t1, e1) {
            return Math.max(t1 ? t1.right - t1.left : 0, e1 ? e1.right - e1.left : 0);
        }
        function Ip(t1, e1, r, n, i, s) {
            const a = Sp(r, i, s), o = kp(r, n) * s;
            let l = 0;
            const u = Ap(t1) / 2;
            for(let r1 = 0; r1 < t1.length - 1; r1++){
                const n1 = t1[r1], i1 = t1[r1 + 1], s1 = n1.dist(i1);
                if (l + s1 > u) {
                    const c = (u - l) / s1, h = Ir(n1.x, i1.x, c), p = Ir(n1.y, i1.y, c), f = new _p(h, p, 0, i1.angleTo(n1), r1);
                    return !a || wp(t1, f, o, a, e1) ? f : void 0;
                }
                l += s1;
            }
        }
        function Mp(t1, e1, r, n, i, s, a, o, l) {
            const u = Sp(n, s, a), c = kp(n, i), h = c * a, p = 0 === t1[0].x || t1[0].x === l || 0 === t1[0].y || t1[0].y === l;
            return e1 - h < e1 / 4 && (e1 = h + e1 / 4), zp(t1, p ? e1 / 2 * o % e1 : (c / 2 + 2 * s) * a * o % e1, e1, u, r, h, p, !1, l);
        }
        function zp(t1, e1, r, n, i, s, a, o, l) {
            const u = s / 2, c = Ap(t1);
            let h = 0, p = e1 - r, f = [];
            for(let e2 = 0; e2 < t1.length - 1; e2++){
                const a1 = t1[e2], o1 = t1[e2 + 1], d = a1.dist(o1), y = o1.angleTo(a1);
                for(; p + r < h + d;){
                    p += r;
                    const m = (p - h) / d, g = Ir(a1.x, o1.x, m), x = Ir(a1.y, o1.y, m);
                    if (g >= 0 && g < l && x >= 0 && x < l && p - u >= 0 && p + u <= c) {
                        const r1 = new _p(g, x, 0, y, e2);
                        r1._round(), n && !wp(t1, r1, s, n, i) || f.push(r1);
                    }
                }
                h += d;
            }
            return o || f.length || a || (f = zp(t1, h / 2, r, n, i, s, a, !0, l)), f;
        }
        function Tp(t1, e1, r, n, i) {
            const s = [];
            for(let a = 0; a < t1.length; a++){
                const o = t1[a];
                let l;
                for(let t2 = 0; t2 < o.length - 1; t2++){
                    let a1 = o[t2], u = o[t2 + 1];
                    a1.x < e1 && u.x < e1 || (a1.x < e1 ? a1 = new d(e1, a1.y + (e1 - a1.x) / (u.x - a1.x) * (u.y - a1.y))._round() : u.x < e1 && (u = new d(e1, a1.y + (e1 - a1.x) / (u.x - a1.x) * (u.y - a1.y))._round()), a1.y < r && u.y < r || (a1.y < r ? a1 = new d(a1.x + (r - a1.y) / (u.y - a1.y) * (u.x - a1.x), r)._round() : u.y < r && (u = new d(a1.x + (r - a1.y) / (u.y - a1.y) * (u.x - a1.x), r)._round()), a1.x >= n && u.x >= n || (a1.x >= n ? a1 = new d(n, a1.y + (n - a1.x) / (u.x - a1.x) * (u.y - a1.y))._round() : u.x >= n && (u = new d(n, a1.y + (n - a1.x) / (u.x - a1.x) * (u.y - a1.y))._round()), a1.y >= i && u.y >= i || (a1.y >= i ? a1 = new d(a1.x + (i - a1.y) / (u.y - a1.y) * (u.x - a1.x), i)._round() : u.y >= i && (u = new d(a1.x + (i - a1.y) / (u.y - a1.y) * (u.x - a1.x), i)._round()), l && a1.equals(l[l.length - 1]) || (l = [
                        a1
                    ], s.push(l)), l.push(u)))));
                }
            }
            return s;
        }
        ji(_p, "Anchor");
        const Bp = 1e20;
        function Ep(t1, e1, r, n, i, s, a, o, l) {
            for(let u = e1; u < e1 + n; u++)Pp(t1, r * s + u, s, i, a, o, l);
            for(let u1 = r; u1 < r + i; u1++)Pp(t1, u1 * s + e1, 1, n, a, o, l);
        }
        function Pp(t1, e1, r, n, i, s, a) {
            s[0] = 0, a[0] = -Bp, a[1] = Bp, i[0] = t1[e1];
            for(let o = 1, l = 0, u = 0; o < n; o++){
                i[o] = t1[e1 + o * r];
                const n1 = o * o;
                do {
                    const t2 = s[l];
                    u = (i[o] - i[t2] + n1 - t2 * t2) / (o - t2) / 2;
                }while (u <= a[l] && --l > -1);
                l++, s[l] = o, a[l] = u, a[l + 1] = Bp;
            }
            for(let o1 = 0, l1 = 0; o1 < n; o1++){
                for(; a[l1 + 1] < o1;)l1++;
                const n2 = s[l1], u1 = o1 - n2;
                t1[e1 + o1 * r] = i[n2] + u1 * u1;
            }
        }
        const Cp = {
            none: 0,
            ideographs: 1,
            all: 2
        };
        class Dp {
            constructor(t1, e1, r){
                this.requestManager = t1, this.localGlyphMode = e1, this.localFontFamily = r, this.entries = {}, this.localGlyphs = {
                    200: {},
                    400: {},
                    500: {},
                    900: {}
                };
            }
            setURL(t1) {
                this.url = t1;
            }
            getGlyphs(t1, e1) {
                const r = [];
                for(const e2 in t1)for (const n of t1[e2])r.push({
                    stack: e2,
                    id: n
                });
                M(r, ({ stack: t1 , id: e1  }, r)=>{
                    let n = this.entries[t1];
                    n || (n = this.entries[t1] = {
                        glyphs: {},
                        requests: {},
                        ranges: {},
                        ascender: void 0,
                        descender: void 0
                    });
                    let i = n.glyphs[e1];
                    if (void 0 !== i) return void r(null, {
                        stack: t1,
                        id: e1,
                        glyph: i
                    });
                    if (i = this._tinySDF(n, t1, e1), i) return n.glyphs[e1] = i, void r(null, {
                        stack: t1,
                        id: e1,
                        glyph: i
                    });
                    const s = Math.floor(e1 / 256);
                    if (256 * s > 65535) return void r(new Error("glyphs > 65535 not supported"));
                    if (n.ranges[s]) return void r(null, {
                        stack: t1,
                        id: e1,
                        glyph: i
                    });
                    let a = n.requests[s];
                    a || (a = n.requests[s] = [], Dp.loadGlyphRange(t1, s, this.url, this.requestManager, (t1, e1)=>{
                        if (e1) {
                            n.ascender = e1.ascender, n.descender = e1.descender;
                            for(const t2 in e1.glyphs)this._doesCharSupportLocalGlyph(+t2) || (n.glyphs[+t2] = e1.glyphs[+t2]);
                            n.ranges[s] = !0;
                        }
                        for (const r of a)r(t1, e1);
                        delete n.requests[s];
                    })), a.push((n, i)=>{
                        n ? r(n) : i && r(null, {
                            stack: t1,
                            id: e1,
                            glyph: i.glyphs[e1] || null
                        });
                    });
                }, (t1, r)=>{
                    if (t1) e1(t1);
                    else if (r) {
                        const t2 = {};
                        for (const { stack: e2 , id: n , glyph: i  } of r)void 0 === t2[e2] && (t2[e2] = {}), void 0 === t2[e2].glyphs && (t2[e2].glyphs = {}), t2[e2].glyphs[n] = i && {
                            id: i.id,
                            bitmap: i.bitmap.clone(),
                            metrics: i.metrics
                        }, t2[e2].ascender = this.entries[e2].ascender, t2[e2].descender = this.entries[e2].descender;
                        e1(null, t2);
                    }
                });
            }
            _doesCharSupportLocalGlyph(t1) {
                return this.localGlyphMode !== Cp.none && (this.localGlyphMode === Cp.all ? !!this.localFontFamily : !!this.localFontFamily && (ls(t1) || hs(t1) || Qi(t1) || ts(t1) || Ji(t1)));
            }
            _tinySDF(t1, e1, r) {
                const n = this.localFontFamily;
                if (!n || !this._doesCharSupportLocalGlyph(r)) return;
                let i = t1.tinySDF;
                if (!i) {
                    let r1 = "400";
                    /bold/i.test(e1) ? r1 = "900" : /medium/i.test(e1) ? r1 = "500" : /light/i.test(e1) && (r1 = "200"), i = t1.tinySDF = new Dp.TinySDF({
                        fontFamily: n,
                        fontWeight: r1,
                        fontSize: 48,
                        buffer: 6,
                        radius: 16
                    }), i.fontWeight = r1;
                }
                if (this.localGlyphs[i.fontWeight][r]) return this.localGlyphs[i.fontWeight][r];
                const s = String.fromCharCode(r), { data: a , width: o , height: l , glyphWidth: u , glyphHeight: c , glyphLeft: h , glyphTop: p , glyphAdvance: f  } = i.draw(s);
                return this.localGlyphs[i.fontWeight][r] = {
                    id: r,
                    bitmap: new wu({
                        width: o,
                        height: l
                    }, a),
                    metrics: {
                        width: u / 2,
                        height: c / 2,
                        left: h / 2,
                        top: p / 2 - 27,
                        advance: f / 2,
                        localGlyph: !0
                    }
                };
            }
        }
        function Vp(t1, e1, r, n) {
            const i = [], s = t1.image, a = s.pixelRatio, o = s.paddedRect.w - 2, l = s.paddedRect.h - 2, u = t1.right - t1.left, c = t1.bottom - t1.top, h = s.stretchX || [
                [
                    0,
                    o
                ]
            ], p = s.stretchY || [
                [
                    0,
                    l
                ]
            ], f = (t1, e1)=>t1 + e1[1] - e1[0], y = h.reduce(f, 0), m = p.reduce(f, 0), g = o - y, x = l - m;
            let v = 0, b = y, _ = 0, w = m, A = 0, S = g, k = 0, I = x;
            if (s.content && n) {
                const t2 = s.content;
                v = Fp(h, 0, t2[0]), _ = Fp(p, 0, t2[1]), b = Fp(h, t2[0], t2[2]), w = Fp(p, t2[1], t2[3]), A = t2[0] - v, k = t2[1] - _, S = t2[2] - t2[0] - b, I = t2[3] - t2[1] - w;
            }
            const M = (n, i, o, l)=>{
                const h = Rp(n.stretch - v, b, u, t1.left), p = Up(n.fixed - A, S, n.stretch, y), f = Rp(i.stretch - _, w, c, t1.top), g = Up(i.fixed - k, I, i.stretch, m), x = Rp(o.stretch - v, b, u, t1.left), M = Up(o.fixed - A, S, o.stretch, y), z = Rp(l.stretch - _, w, c, t1.top), T = Up(l.fixed - k, I, l.stretch, m), B = new d(h, f), E = new d(x, f), P = new d(x, z), C = new d(h, z), D = new d(p / a, g / a), V = new d(M / a, T / a), F = e1 * Math.PI / 180;
                if (F) {
                    const t2 = Math.sin(F), e2 = Math.cos(F), r1 = [
                        e2,
                        -t2,
                        t2,
                        e2
                    ];
                    B._matMult(r1), E._matMult(r1), C._matMult(r1), P._matMult(r1);
                }
                const L = n.stretch + n.fixed, R = i.stretch + i.fixed;
                return {
                    tl: B,
                    tr: E,
                    bl: C,
                    br: P,
                    tex: {
                        x: s.paddedRect.x + 1 + L,
                        y: s.paddedRect.y + 1 + R,
                        w: o.stretch + o.fixed - L,
                        h: l.stretch + l.fixed - R
                    },
                    writingMode: void 0,
                    glyphOffset: [
                        0,
                        0
                    ],
                    sectionIndex: 0,
                    pixelOffsetTL: D,
                    pixelOffsetBR: V,
                    minFontScaleX: S / a / u,
                    minFontScaleY: I / a / c,
                    isSDF: r
                };
            };
            if (n && (s.stretchX || s.stretchY)) {
                const t3 = Lp(h, g, y), e2 = Lp(p, x, m);
                for(let r1 = 0; r1 < t3.length - 1; r1++){
                    const n1 = t3[r1], s1 = t3[r1 + 1];
                    for(let t4 = 0; t4 < e2.length - 1; t4++)i.push(M(n1, e2[t4], s1, e2[t4 + 1]));
                }
            } else i.push(M({
                fixed: 0,
                stretch: -1
            }, {
                fixed: 0,
                stretch: -1
            }, {
                fixed: 0,
                stretch: o + 1
            }, {
                fixed: 0,
                stretch: l + 1
            }));
            return i;
        }
        function Fp(t1, e1, r) {
            let n = 0;
            for (const i of t1)n += Math.max(e1, Math.min(r, i[1])) - Math.max(e1, Math.min(r, i[0]));
            return n;
        }
        function Lp(t1, e1, r) {
            const n = [
                {
                    fixed: -1,
                    stretch: 0
                }
            ];
            for (const [e2, r1] of t1){
                const t2 = n[n.length - 1];
                n.push({
                    fixed: e2 - t2.stretch,
                    stretch: t2.stretch
                }), n.push({
                    fixed: e2 - t2.stretch,
                    stretch: t2.stretch + (r1 - e2)
                });
            }
            return n.push({
                fixed: e1 + 1,
                stretch: r
            }), n;
        }
        function Rp(t1, e1, r, n) {
            return t1 / e1 * r + n;
        }
        function Up(t1, e1, r, n) {
            return t1 - e1 * r / n;
        }
        function jp(t1, e1, r, n) {
            const i = e1 + t1.positionedLines[n].lineOffset;
            return 0 === n ? r + i / 2 : r + (i + (e1 + t1.positionedLines[n - 1].lineOffset)) / 2;
        }
        Dp.loadGlyphRange = function(t1, e1, r, n, i) {
            const s = 256 * e1, a = s + 255, o = n.transformRequest(n.normalizeGlyphsURL(r).replace("{fontstack}", t1).replace("{range}", `${s}-${a}`), st.Glyphs);
            ut(o, (t1, e1)=>{
                if (t1) i(t1);
                else if (e1) {
                    const t2 = {}, r = function(t1) {
                        return new Eh(t1).readFields(Qh, {});
                    }(e1);
                    for (const e2 of r.glyphs)t2[e2.id] = e2;
                    i(null, {
                        glyphs: t2,
                        ascender: r.ascender,
                        descender: r.descender
                    });
                }
            });
        }, Dp.TinySDF = class {
            constructor({ fontSize: t1 = 24 , buffer: e1 = 3 , radius: r = 8 , cutoff: n = .25 , fontFamily: i = "sans-serif" , fontWeight: s = "normal" , fontStyle: a = "normal"  } = {}){
                this.buffer = e1, this.cutoff = n, this.radius = r;
                const o = this.size = t1 + 4 * e1, l = this._createCanvas(o), u = this.ctx = l.getContext("2d", {
                    willReadFrequently: !0
                });
                u.font = `${a} ${s} ${t1}px ${i}`, u.textBaseline = "alphabetic", u.textAlign = "left", u.fillStyle = "black", this.gridOuter = new Float64Array(o * o), this.gridInner = new Float64Array(o * o), this.f = new Float64Array(o), this.z = new Float64Array(o + 1), this.v = new Uint16Array(o);
            }
            _createCanvas(t1) {
                const e1 = document.createElement("canvas");
                return e1.width = e1.height = t1, e1;
            }
            draw(t1) {
                const { width: e1 , actualBoundingBoxAscent: r , actualBoundingBoxDescent: n , actualBoundingBoxLeft: i , actualBoundingBoxRight: s  } = this.ctx.measureText(t1), a = Math.ceil(r), o = Math.min(this.size - this.buffer, Math.ceil(s - i)), l = Math.min(this.size - this.buffer, a + Math.ceil(n)), u = o + 2 * this.buffer, c = l + 2 * this.buffer, h = Math.max(u * c, 0), p = new Uint8ClampedArray(h), f = {
                    data: p,
                    width: u,
                    height: c,
                    glyphWidth: o,
                    glyphHeight: l,
                    glyphTop: a,
                    glyphLeft: 0,
                    glyphAdvance: e1
                };
                if (0 === o || 0 === l) return f;
                const { ctx: d , buffer: y , gridInner: m , gridOuter: g  } = this;
                d.clearRect(y, y, o, l), d.fillText(t1, y, y + a);
                const x = d.getImageData(y, y, o, l);
                g.fill(Bp, 0, h), m.fill(0, 0, h);
                for(let t2 = 0; t2 < l; t2++)for(let e2 = 0; e2 < o; e2++){
                    const r1 = x.data[4 * (t2 * o + e2) + 3] / 255;
                    if (0 === r1) continue;
                    const n1 = (t2 + y) * u + e2 + y;
                    if (1 === r1) g[n1] = 0, m[n1] = Bp;
                    else {
                        const t3 = .5 - r1;
                        g[n1] = t3 > 0 ? t3 * t3 : 0, m[n1] = t3 < 0 ? t3 * t3 : 0;
                    }
                }
                Ep(g, 0, 0, u, c, u, this.f, this.v, this.z), Ep(m, y, y, o, l, u, this.f, this.v, this.z);
                for(let t4 = 0; t4 < h; t4++){
                    const e3 = Math.sqrt(g[t4]) - Math.sqrt(m[t4]);
                    p[t4] = Math.round(255 - 255 * (e3 / this.radius + this.cutoff));
                }
                return f;
            }
        };
        class $p {
            constructor(t1 = [], e1 = Op){
                if (this.data = t1, this.length = this.data.length, this.compare = e1, this.length > 0) for(let t2 = (this.length >> 1) - 1; t2 >= 0; t2--)this._down(t2);
            }
            push(t1) {
                this.data.push(t1), this.length++, this._up(this.length - 1);
            }
            pop() {
                if (0 === this.length) return;
                const t1 = this.data[0], e1 = this.data.pop();
                return this.length--, this.length > 0 && (this.data[0] = e1, this._down(0)), t1;
            }
            peek() {
                return this.data[0];
            }
            _up(t1) {
                const { data: e1 , compare: r  } = this, n = e1[t1];
                for(; t1 > 0;){
                    const i = t1 - 1 >> 1, s = e1[i];
                    if (r(n, s) >= 0) break;
                    e1[t1] = s, t1 = i;
                }
                e1[t1] = n;
            }
            _down(t1) {
                const { data: e1 , compare: r  } = this, n = this.length >> 1, i = e1[t1];
                for(; t1 < n;){
                    let n1 = 1 + (t1 << 1), s = e1[n1];
                    const a = n1 + 1;
                    if (a < this.length && r(e1[a], s) < 0 && (n1 = a, s = e1[a]), r(s, i) >= 0) break;
                    e1[t1] = s, t1 = n1;
                }
                e1[t1] = i;
            }
        }
        function Op(t1, e1) {
            return t1 < e1 ? -1 : t1 > e1 ? 1 : 0;
        }
        function qp(t1, e1 = 1, r = !1) {
            let n = 1 / 0, i = 1 / 0, s = -1 / 0, a = -1 / 0;
            const o = t1[0];
            for(let t2 = 0; t2 < o.length; t2++){
                const e2 = o[t2];
                (!t2 || e2.x < n) && (n = e2.x), (!t2 || e2.y < i) && (i = e2.y), (!t2 || e2.x > s) && (s = e2.x), (!t2 || e2.y > a) && (a = e2.y);
            }
            const l = Math.min(s - n, a - i);
            let u = l / 2;
            const c = new $p([], Np);
            if (0 === l) return new d(n, i);
            for(let e3 = n; e3 < s; e3 += l)for(let r1 = i; r1 < a; r1 += l)c.push(new Gp(e3 + u, r1 + u, u, t1));
            let h = function(t1) {
                let e1 = 0, r = 0, n = 0;
                const i = t1[0];
                for(let t2 = 0, s = i.length, a = s - 1; t2 < s; a = t2++){
                    const s1 = i[t2], o = i[a], l = s1.x * o.y - o.x * s1.y;
                    r += (s1.x + o.x) * l, n += (s1.y + o.y) * l, e1 += 3 * l;
                }
                return new Gp(r / e1, n / e1, 0, t1);
            }(t1), p = c.length;
            for(; c.length;){
                const n1 = c.pop();
                (n1.d > h.d || !h.d) && (h = n1, r && console.log("found best %d after %d probes", Math.round(1e4 * n1.d) / 1e4, p)), n1.max - h.d <= e1 || (u = n1.h / 2, c.push(new Gp(n1.p.x - u, n1.p.y - u, u, t1)), c.push(new Gp(n1.p.x + u, n1.p.y - u, u, t1)), c.push(new Gp(n1.p.x - u, n1.p.y + u, u, t1)), c.push(new Gp(n1.p.x + u, n1.p.y + u, u, t1)), p += 4);
            }
            return r && (console.log(`num probes: ${p}`), console.log(`best distance: ${h.d}`)), h.p;
        }
        function Np(t1, e1) {
            return e1.max - t1.max;
        }
        function Gp(t1, e1, r, n) {
            this.p = new d(t1, e1), this.h = r, this.d = function(t1, e1) {
                let r = !1, n = 1 / 0;
                for(let i = 0; i < e1.length; i++){
                    const s = e1[i];
                    for(let e2 = 0, i1 = s.length, a = i1 - 1; e2 < i1; a = e2++){
                        const i2 = s[e2], o = s[a];
                        i2.y > t1.y != o.y > t1.y && t1.x < (o.x - i2.x) * (t1.y - i2.y) / (o.y - i2.y) + i2.x && (r = !r), n = Math.min(n, cl(t1, i2, o));
                    }
                }
                return (r ? 1 : -1) * Math.sqrt(n);
            }(this.p, n), this.max = this.d + this.h * Math.SQRT2;
        }
        const Zp = Number.POSITIVE_INFINITY, Xp = Math.sqrt(2);
        function Kp(t1, e1) {
            return e1[1] !== Zp ? function(t1, e1, r) {
                let n = 0, i = 0;
                switch(e1 = Math.abs(e1), r = Math.abs(r), t1){
                    case "top-right":
                    case "top-left":
                    case "top":
                        i = r - 7;
                        break;
                    case "bottom-right":
                    case "bottom-left":
                    case "bottom":
                        i = 7 - r;
                }
                switch(t1){
                    case "top-right":
                    case "bottom-right":
                    case "right":
                        n = -e1;
                        break;
                    case "top-left":
                    case "bottom-left":
                    case "left":
                        n = e1;
                }
                return [
                    n,
                    i
                ];
            }(t1, e1[0], e1[1]) : function(t1, e1) {
                let r = 0, n = 0;
                e1 < 0 && (e1 = 0);
                const i = e1 / Xp;
                switch(t1){
                    case "top-right":
                    case "top-left":
                        n = i - 7;
                        break;
                    case "bottom-right":
                    case "bottom-left":
                        n = 7 - i;
                        break;
                    case "bottom":
                        n = 7 - e1;
                        break;
                    case "top":
                        n = e1 - 7;
                }
                switch(t1){
                    case "top-right":
                    case "bottom-right":
                        r = -i;
                        break;
                    case "top-left":
                    case "bottom-left":
                        r = i;
                        break;
                    case "left":
                        r = e1;
                        break;
                    case "right":
                        r = -e1;
                }
                return [
                    r,
                    n
                ];
            }(t1, e1[0]);
        }
        function Hp(t1, e1, r, n, i, s, a, o, l, u) {
            t1.createArrays(), t1.tilePixelRatio = Bo / (512 * t1.overscaling), t1.compareText = {}, t1.iconsNeedLinear = !1;
            const c = t1.layers[0].layout, h = t1.layers[0]._unevaluatedLayout._values, p = {};
            if ("composite" === t1.textSizeData.kind) {
                const { minZoom: e2 , maxZoom: r1  } = t1.textSizeData;
                p.compositeTextSizes = [
                    h["text-size"].possiblyEvaluate(new Us(e2), o),
                    h["text-size"].possiblyEvaluate(new Us(r1), o)
                ];
            }
            if ("composite" === t1.iconSizeData.kind) {
                const { minZoom: e3 , maxZoom: r2  } = t1.iconSizeData;
                p.compositeIconSizes = [
                    h["icon-size"].possiblyEvaluate(new Us(e3), o),
                    h["icon-size"].possiblyEvaluate(new Us(r2), o)
                ];
            }
            p.layoutTextSize = h["text-size"].possiblyEvaluate(new Us(l + 1), o), p.layoutIconSize = h["icon-size"].possiblyEvaluate(new Us(l + 1), o), p.textMaxSize = h["text-size"].possiblyEvaluate(new Us(18), o);
            const f = "map" === c.get("text-rotation-alignment") && "point" !== c.get("symbol-placement"), d = c.get("text-size");
            for (const s1 of t1.features){
                const l1 = c.get("text-font").evaluate(s1, {}, o).join(","), h1 = d.evaluate(s1, {}, o), y = p.layoutTextSize.evaluate(s1, {}, o), m = (p.layoutIconSize.evaluate(s1, {}, o), {
                    horizontal: {},
                    vertical: void 0
                }), g = s1.text;
                let x, v = [
                    0,
                    0
                ];
                if (g) {
                    const n1 = g.toString(), a1 = c.get("text-letter-spacing").evaluate(s1, {}, o) * _h, u1 = c.get("text-line-height").evaluate(s1, {}, o) * _h, p1 = bs(n1) ? a1 : 0, d1 = c.get("text-anchor").evaluate(s1, {}, o), x1 = c.get("text-variable-anchor");
                    if (!x1) {
                        const t2 = c.get("text-radial-offset").evaluate(s1, {}, o);
                        v = t2 ? Kp(d1, [
                            t2 * _h,
                            Zp
                        ]) : c.get("text-offset").evaluate(s1, {}, o).map((t1)=>t1 * _h);
                    }
                    let b = f ? "center" : c.get("text-justify").evaluate(s1, {}, o);
                    const _ = c.get("symbol-placement"), w = "point" === _, A = "point" === _ ? c.get("text-max-width").evaluate(s1, {}, o) * _h : 0, S = (s)=>{
                        t1.allowVerticalPlacement && vs(n1) && (m.vertical = lp(g, e1, r, i, l1, A, u1, d1, s, p1, v, sp.vertical, !0, _, y, h1));
                    };
                    if (!f && x1) {
                        const t3 = "auto" === b ? x1.map((t1)=>Yp(t1)) : [
                            b
                        ];
                        let n2 = !1;
                        for(let s2 = 0; s2 < t3.length; s2++){
                            const a2 = t3[s2];
                            if (!m.horizontal[a2]) {
                                if (n2) m.horizontal[a2] = m.horizontal[0];
                                else {
                                    const t4 = lp(g, e1, r, i, l1, A, u1, "center", a2, p1, v, sp.horizontal, !1, _, y, h1);
                                    t4 && (m.horizontal[a2] = t4, n2 = 1 === t4.positionedLines.length);
                                }
                            }
                        }
                        S("left");
                    } else {
                        if ("auto" === b && (b = Yp(d1)), w || c.get("text-writing-mode").indexOf("horizontal") >= 0 || !vs(n1)) {
                            const t5 = lp(g, e1, r, i, l1, A, u1, d1, b, p1, v, sp.horizontal, !1, _, y, h1);
                            t5 && (m.horizontal[b] = t5);
                        }
                        S("point" === _ ? "left" : b);
                    }
                }
                let b1 = !1;
                if (s1.icon && s1.icon.name) {
                    const e4 = n[s1.icon.name];
                    e4 && (x = vp(i[s1.icon.name], c.get("icon-offset").evaluate(s1, {}, o), c.get("icon-anchor").evaluate(s1, {}, o)), b1 = e4.sdf, void 0 === t1.sdfIcons ? t1.sdfIcons = e4.sdf : t1.sdfIcons !== e4.sdf && $("Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer"), (e4.pixelRatio !== t1.pixelRatio || 0 !== c.get("icon-rotate").constantOr(1)) && (t1.iconsNeedLinear = !0));
                }
                const _1 = tf(m.horizontal) || m.vertical;
                t1.iconsInText || (t1.iconsInText = !!_1 && _1.iconsInText), (_1 || x) && Wp(t1, s1, m, x, n, p, y, 0, v, b1, a, o, u);
            }
            s && t1.generateCollisionDebugBuffers(l, t1.collisionBoxArray);
        }
        function Yp(t1) {
            switch(t1){
                case "right":
                case "top-right":
                case "bottom-right":
                    return "right";
                case "left":
                case "top-left":
                case "bottom-left":
                    return "left";
            }
            return "center";
        }
        function Wp(t1, e1, r, n, i, s, a, o, l, u, c, h, p) {
            let f = s.textMaxSize.evaluate(e1, {}, h);
            void 0 === f && (f = a);
            const d = t1.layers[0].layout, y = d.get("icon-offset").evaluate(e1, {}, h), m = tf(r.horizontal) || r.vertical, g = "globe" === p.name, v = a / 24, b = t1.tilePixelRatio * f / 24, _ = (T = t1.overscaling, t1.zoom > 18 && T > 2 && (T >>= 1), Math.max(Bo / (512 * T), 1) * d.get("symbol-spacing")), w = d.get("text-padding") * t1.tilePixelRatio, A = d.get("icon-padding") * t1.tilePixelRatio, S = x(d.get("text-max-angle")), k = "map" === d.get("text-rotation-alignment") && "point" !== d.get("symbol-placement"), I = "map" === d.get("icon-rotation-alignment") && "point" !== d.get("symbol-placement"), M = d.get("symbol-placement"), z = _ / 2;
            var T;
            const B = d.get("icon-text-fit");
            let E;
            n && "none" !== B && (t1.allowVerticalPlacement && r.vertical && (E = bp(n, r.vertical, B, d.get("icon-text-fit-padding"), y, v)), m && (n = bp(n, m, B, d.get("icon-text-fit-padding"), y, v)));
            const P = (a, o, f)=>{
                if (o.x < 0 || o.x >= Bo || o.y < 0 || o.y >= Bo) return;
                let d = null;
                if (g) {
                    const { x: t2 , y: e2 , z: r1  } = p.projectTilePoint(o.x, o.y, f);
                    d = {
                        anchor: new _p(t2, e2, r1, 0, void 0),
                        up: p.upVector(f, o.x, o.y)
                    };
                }
                !function(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, d, y, m, g, x, v, b, _, w, A, S) {
                    const k = t1.addToLineVertexArray(e1, n);
                    let I, M, z, T, B, E, P, C = 0, D = 0, V = 0, F = 0, L = -1, R = -1;
                    const U = {};
                    let j = Ha.exports("");
                    const O = r ? r.anchor : e1;
                    let q = 0, N = 0;
                    if (void 0 === l._unevaluatedLayout.getValue("text-radial-offset") ? [q, N] = l.layout.get("text-offset").evaluate(b, {}, S).map((t1)=>t1 * _h) : (q = l.layout.get("text-radial-offset").evaluate(b, {}, S) * _h, N = Zp), t1.allowVerticalPlacement && i.vertical) {
                        const t2 = i.vertical;
                        if (d) E = rf(t2), o && (P = rf(o));
                        else {
                            const r1 = l.layout.get("text-rotate").evaluate(b, {}, S) + 90;
                            z = ef(u, O, e1, c, h, p, t2, f, r1, y), o && (T = ef(u, O, e1, c, h, p, o, g, r1));
                        }
                    }
                    if (s) {
                        const n1 = l.layout.get("icon-rotate").evaluate(b, {}, S), i1 = "none" !== l.layout.get("icon-text-fit"), a1 = Vp(s, n1, w, i1), f1 = o ? Vp(o, n1, w, i1) : void 0;
                        M = ef(u, O, e1, c, h, p, s, g, n1), C = 4 * a1.length;
                        const d1 = t1.iconSizeData;
                        let y1 = null;
                        "source" === d1.kind ? (y1 = [
                            wh * l.layout.get("icon-size").evaluate(b, {}, S)
                        ], y1[0] > Jp && $(`${t1.layerIds[0]}: Value for "icon-size" is >= 255. Reduce your "icon-size".`)) : "composite" === d1.kind && (y1 = [
                            wh * _.compositeIconSizes[0].evaluate(b, {}, S),
                            wh * _.compositeIconSizes[1].evaluate(b, {}, S)
                        ], (y1[0] > Jp || y1[1] > Jp) && $(`${t1.layerIds[0]}: Value for "icon-size" is >= 255. Reduce your "icon-size".`)), t1.addSymbols(t1.icon, a1, y1, v, x, b, !1, r, e1, k.lineStartIndex, k.lineLength, -1, A, S), L = t1.icon.placedSymbolArray.length - 1, f1 && (D = 4 * f1.length, t1.addSymbols(t1.icon, f1, y1, v, x, b, sp.vertical, r, e1, k.lineStartIndex, k.lineLength, -1, A, S), R = t1.icon.placedSymbolArray.length - 1);
                    }
                    for(const n2 in i.horizontal){
                        const s1 = i.horizontal[n2];
                        I || (j = Ha.exports(s1.text), d ? B = rf(s1) : I = ef(u, O, e1, c, h, p, s1, f, l.layout.get("text-rotate").evaluate(b, {}, S), y));
                        const o1 = 1 === s1.positionedLines.length;
                        if (V += Qp(t1, r, e1, s1, a, l, d, b, y, k, i.vertical ? sp.horizontal : sp.horizontalOnly, o1 ? Object.keys(i.horizontal) : [
                            n2
                        ], U, L, _, A, S), o1) break;
                    }
                    i.vertical && (F += Qp(t1, r, e1, i.vertical, a, l, d, b, y, k, sp.vertical, [
                        "vertical"
                    ], U, R, _, A, S));
                    let G = -1;
                    const Z = (t1, e1)=>t1 ? Math.max(t1, e1) : e1;
                    G = Z(B, G), G = Z(E, G), G = Z(P, G);
                    const X = G > -1 ? 1 : 0;
                    t1.glyphOffsetArray.length >= md.MAX_GLYPHS && $("Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907"), void 0 !== b.sortKey && t1.addToSortKeyRanges(t1.symbolInstances.length, b.sortKey), t1.symbolInstances.emplaceBack(O.x, O.y, O.z, e1.x, e1.y, U.right >= 0 ? U.right : -1, U.center >= 0 ? U.center : -1, U.left >= 0 ? U.left : -1, U.vertical >= 0 ? U.vertical : -1, L, R, j, void 0 !== I ? I : t1.collisionBoxArray.length, void 0 !== I ? I + 1 : t1.collisionBoxArray.length, void 0 !== z ? z : t1.collisionBoxArray.length, void 0 !== z ? z + 1 : t1.collisionBoxArray.length, void 0 !== M ? M : t1.collisionBoxArray.length, void 0 !== M ? M + 1 : t1.collisionBoxArray.length, T || t1.collisionBoxArray.length, T ? T + 1 : t1.collisionBoxArray.length, c, V, F, C, D, X, 0, q, N, G);
                }(t1, o, d, a, r, n, i, E, t1.layers[0], t1.collisionBoxArray, e1.index, e1.sourceLayerIndex, t1.index, w, k, l, 0, A, I, y, e1, s, u, c, h);
            };
            if ("line" === M) for (const i1 of Tp(e1.geometry, 0, 0, Bo, Bo)){
                const e2 = Mp(i1, _, S, r.vertical || m, n, 24, b, t1.overscaling, Bo);
                for (const r1 of e2){
                    const e3 = m;
                    e3 && nf(t1, e3.text, z, r1) || P(i1, r1, h);
                }
            }
            else if ("line-center" === M) {
                for (const t2 of e1.geometry)if (t2.length > 1) {
                    const e4 = Ip(t2, S, r.vertical || m, n, 24, b);
                    e4 && P(t2, e4, h);
                }
            } else if ("Polygon" === e1.type) for (const t3 of ac(e1.geometry, 0)){
                const e5 = qp(t3, 16);
                P(t3[0], new _p(e5.x, e5.y, 0, 0, void 0), h);
            }
            else if ("LineString" === e1.type) for (const t4 of e1.geometry)P(t4, new _p(t4[0].x, t4[0].y, 0, 0, void 0), h);
            else if ("Point" === e1.type) for (const t5 of e1.geometry)for (const e6 of t5)P([
                e6
            ], new _p(e6.x, e6.y, 0, 0, void 0), h);
        }
        const Jp = 32640;
        function Qp(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f, y, m, g) {
            const x = function(t1, e1, r, n, i, s, a, o) {
                const l = [];
                if (0 === e1.positionedLines.length) return l;
                const u = n.layout.get("text-rotate").evaluate(s, {}) * Math.PI / 180, c = function(t1) {
                    const e1 = t1[0], r = t1[1], n = e1 * r;
                    return n > 0 ? [
                        e1,
                        -r
                    ] : n < 0 ? [
                        -e1,
                        r
                    ] : 0 === e1 ? [
                        r,
                        e1
                    ] : [
                        r,
                        -e1
                    ];
                }(r);
                let h = Math.abs(e1.top - e1.bottom);
                for (const t2 of e1.positionedLines)h -= t2.lineOffset;
                const p = e1.positionedLines.length, f = h / p;
                let y = e1.top - r[1];
                for(let t3 = 0; t3 < p; ++t3){
                    const n1 = e1.positionedLines[t3];
                    y = jp(e1, f, y, t3);
                    for (const t4 of n1.positionedGlyphs){
                        if (!t4.rect) continue;
                        const n2 = t4.rect || {};
                        let s1 = 4, h1 = !0, p1 = 1, f1 = 0;
                        if (t4.imageName) {
                            const e2 = a[t4.imageName];
                            if (!e2) continue;
                            if (e2.sdf) {
                                $("SDF images are not supported in formatted text and will be ignored.");
                                continue;
                            }
                            h1 = !1, p1 = e2.pixelRatio, s1 = 1 / p1;
                        }
                        const m = (i || o) && t4.vertical, g = t4.metrics.advance * t4.scale / 2, x = t4.metrics, v = t4.rect;
                        if (null === v) continue;
                        o && e1.verticalizable && (f1 = t4.imageName ? g - t4.metrics.width * t4.scale / 2 : 0);
                        const b = i ? [
                            t4.x + g,
                            t4.y
                        ] : [
                            0,
                            0
                        ];
                        let _ = [
                            0,
                            0
                        ], w = [
                            0,
                            0
                        ], A = !1;
                        i || (m ? (w = [
                            t4.x + g + c[0],
                            t4.y + c[1] - f1
                        ], A = !0) : _ = [
                            t4.x + g + r[0],
                            t4.y + r[1] - f1
                        ]);
                        const S = v.w * t4.scale / (p1 * (t4.localGlyph ? 2 : 1)), k = v.h * t4.scale / (p1 * (t4.localGlyph ? 2 : 1));
                        let I, M, z, T;
                        if (m) {
                            const e3 = t4.y - y, r1 = new d(-g, g - e3), n3 = -Math.PI / 2, i1 = new d(...w);
                            I = new d(-g + _[0], _[1]), I._rotateAround(n3, r1)._add(i1), I.x += -e3 + g, I.y -= (x.left - s1) * t4.scale;
                            const a1 = t4.imageName ? x.advance * t4.scale : _h * t4.scale, o1 = String.fromCharCode(t4.glyph);
                            Th(o1) ? I.x += (1 - s1) * t4.scale : Bh(o1) ? I.x += a1 - x.height * t4.scale + (-s1 - 1) * t4.scale : I.x += t4.imageName || x.width + 2 * s1 === v.w && x.height + 2 * s1 === v.h ? (a1 - k) / 2 : (a1 - (x.height + 2 * s1) * t4.scale) / 2, M = new d(I.x, I.y - S), z = new d(I.x + k, I.y), T = new d(I.x + k, I.y - S);
                        } else {
                            const e4 = (x.left - s1) * t4.scale - g + _[0], r2 = (-x.top - s1) * t4.scale + _[1], n4 = e4 + S, i2 = r2 + k;
                            I = new d(e4, r2), M = new d(n4, r2), z = new d(e4, i2), T = new d(n4, i2);
                        }
                        if (u) {
                            let t5;
                            t5 = i ? new d(0, 0) : A ? new d(c[0], c[1]) : new d(r[0], r[1]), I._rotateAround(u, t5), M._rotateAround(u, t5), z._rotateAround(u, t5), T._rotateAround(u, t5);
                        }
                        const B = new d(0, 0), E = new d(0, 0);
                        l.push({
                            tl: I,
                            tr: M,
                            bl: z,
                            br: T,
                            tex: n2,
                            writingMode: e1.writingMode,
                            glyphOffset: b,
                            sectionIndex: t4.sectionIndex,
                            isSDF: h1,
                            pixelOffsetTL: B,
                            pixelOffsetBR: E,
                            minFontScaleX: 0,
                            minFontScaleY: 0
                        });
                    }
                }
                return l;
            }(0, n, l, s, a, o, i, t1.allowVerticalPlacement), v = t1.textSizeData;
            let b = null;
            "source" === v.kind ? (b = [
                wh * s.layout.get("text-size").evaluate(o, {}, g)
            ], b[0] > Jp && $(`${t1.layerIds[0]}: Value for "text-size" is >= 255. Reduce your "text-size".`)) : "composite" === v.kind && (b = [
                wh * y.compositeTextSizes[0].evaluate(o, {}, g),
                wh * y.compositeTextSizes[1].evaluate(o, {}, g)
            ], (b[0] > Jp || b[1] > Jp) && $(`${t1.layerIds[0]}: Value for "text-size" is >= 255. Reduce your "text-size".`)), t1.addSymbols(t1.text, x, b, l, a, o, c, e1, r, u.lineStartIndex, u.lineLength, f, m, g);
            for (const e2 of h)p[e2] = t1.text.placedSymbolArray.length - 1;
            return 4 * x.length;
        }
        function tf(t1) {
            for(const e1 in t1)return t1[e1];
            return null;
        }
        function ef(t1, e1, r, n, i, s, a, o, l, u) {
            let c = a.top, h = a.bottom, p = a.left, f = a.right;
            const y = a.collisionPadding;
            if (y && (p -= y[0], c -= y[1], f += y[2], h += y[3]), l) {
                const t2 = new d(p, c), e2 = new d(f, c), r1 = new d(p, h), n1 = new d(f, h), i1 = x(l);
                let s1 = new d(0, 0);
                u && (s1 = new d(u[0], u[1])), t2._rotateAround(i1, s1), e2._rotateAround(i1, s1), r1._rotateAround(i1, s1), n1._rotateAround(i1, s1), p = Math.min(t2.x, e2.x, r1.x, n1.x), f = Math.max(t2.x, e2.x, r1.x, n1.x), c = Math.min(t2.y, e2.y, r1.y, n1.y), h = Math.max(t2.y, e2.y, r1.y, n1.y);
            }
            return t1.emplaceBack(e1.x, e1.y, e1.z, r.x, r.y, p, c, f, h, o, n, i, s), t1.length - 1;
        }
        function rf(t1) {
            t1.collisionPadding && (t1.top -= t1.collisionPadding[1], t1.bottom += t1.collisionPadding[3]);
            const e1 = t1.bottom - t1.top;
            return e1 > 0 ? Math.max(10, e1) : null;
        }
        function nf(t1, e1, r, n) {
            const i = t1.compareText;
            if (e1 in i) {
                const t2 = i[e1];
                for(let e2 = t2.length - 1; e2 >= 0; e2--)if (n.dist(t2[e2]) < r) return !0;
            } else i[e1] = [];
            return i[e1].push(n), !1;
        }
        const sf = ia([
            {
                type: "Float32",
                name: "a_globe_pos",
                components: 3
            },
            {
                type: "Float32",
                name: "a_uv",
                components: 2
            }
        ]), { members: af  } = sf, of = ia([
            {
                name: "a_pos_3",
                components: 3,
                type: "Int16"
            }
        ]);
        var lf = ia([
            {
                name: "a_pos",
                type: "Int16",
                components: 2
            }
        ]);
        const uf = Bo / Math.PI / 2, cf = 2 * Ro(1, 0) * uf * Math.PI, hf = 64, pf = [
            hf,
            32,
            16
        ], ff = -uf, df = uf, yf = [
            new pu([
                ff,
                ff,
                ff
            ], [
                df,
                df,
                df
            ]),
            new pu([
                ff,
                ff,
                ff
            ], [
                0,
                0,
                df
            ]),
            new pu([
                0,
                ff,
                ff
            ], [
                df,
                0,
                df
            ]),
            new pu([
                ff,
                0,
                ff
            ], [
                0,
                df,
                df
            ]),
            new pu([
                0,
                0,
                ff
            ], [
                df,
                df,
                df
            ])
        ];
        function mf(t1, e1, r, n = !0) {
            const i = Nl([], t1._camera.position, t1.worldSize), s = [
                e1,
                r,
                1,
                1
            ];
            nu(s, s, t1.pixelMatrixInverse), eu(s, s, 1 / s[3]);
            const a = Zl([], Jl([], s, i)), o = t1.globeMatrix, l = [
                o[12],
                o[13],
                o[14]
            ], u = Jl([], l, i), c = Ll(u), h = Zl([], u), p = t1.worldSize / (2 * Math.PI), f = Xl(h, a), d = Math.asin(p / c);
            if (d < Math.acos(f)) {
                if (!n) return null;
                const t2 = [], e2 = [];
                Nl(t2, a, c / f), Zl(e2, Jl(e2, t2, u)), Zl(a, Ul(a, u, Nl(a, e2, Math.tan(d) * c)));
            }
            const y = [];
            new uu(i, a).closestPointOnSphere(l, p, y);
            const m = Zl([], H(o, 0)), g = Zl([], H(o, 1)), x = Zl([], H(o, 2)), b = Xl(m, y), _ = Xl(g, y), w = Xl(x, y), A = v(Math.asin(-_ / p));
            let k = v(Math.atan2(b, w));
            k = t1.center.lng + function(t1, e1) {
                const r = (e1 - t1 + 180) % 360 - 180;
                return r < -180 ? r + 360 : r;
            }(t1.center.lng, k);
            const I = Fo(k), M = S(Lo(A), 0, 1);
            return new No(I, M);
        }
        class gf {
            constructor(t1, e1, r){
                this.a = Jl([], t1, r), this.b = Jl([], e1, r), this.center = r;
                const n = Zl([], this.a), i = Zl([], this.b);
                this.angle = Math.acos(Xl(n, i));
            }
        }
        function xf(t1, e1) {
            if (0 === t1.angle) return null;
            let r;
            return r = 0 === t1.a[e1] ? 1 / t1.angle * .5 * Math.PI : 1 / t1.angle * Math.atan(t1.b[e1] / t1.a[e1] / Math.sin(t1.angle) - 1 / Math.tan(t1.angle)), r < 0 || r > 1 ? null : function(t1, e1, r, n) {
                const i = Math.sin(r);
                return t1 * (Math.sin((1 - n) * r) / i) + e1 * (Math.sin(n * r) / i);
            }(t1.a[e1], t1.b[e1], t1.angle, S(r, 0, 1)) + t1.center[e1];
        }
        function vf(t1) {
            if (t1.z <= 1) return yf[t1.z + 2 * t1.y + t1.x];
            const e1 = kf(Sf(t1));
            return pu.fromPoints(e1);
        }
        function bf(t1, e1, r) {
            return Nl(t1, t1, 1 - r), Gl(t1, t1, e1, r);
        }
        function _f(t1, e1) {
            const r = Df(e1.zoom);
            if (0 === r) return vf(t1);
            const n = Sf(t1), i = kf(n), s = Fo(n.getWest()) * e1.worldSize, a = Fo(n.getEast()) * e1.worldSize, o = Lo(n.getNorth()) * e1.worldSize, l = Lo(n.getSouth()) * e1.worldSize, u = [
                s,
                o,
                0
            ], c = [
                a,
                o,
                0
            ], h = [
                s,
                l,
                0
            ], p = [
                a,
                l,
                0
            ], f = Il([], e1.globeMatrix);
            return Hl(u, u, f), Hl(c, c, f), Hl(h, h, f), Hl(p, p, f), i[0] = bf(i[0], h, r), i[1] = bf(i[1], p, r), i[2] = bf(i[2], c, r), i[3] = bf(i[3], u, r), pu.fromPoints(i);
        }
        function wf(t1, e1, r) {
            for (const n of t1)Hl(n, n, e1), Nl(n, n, r);
        }
        function Af(t1, e1, r) {
            const n = e1 / t1.worldSize, i = t1.globeMatrix;
            if (r.z <= 1) {
                const t2 = vf(r).getCorners();
                return wf(t2, i, n), pu.fromPoints(t2);
            }
            const s = Sf(r), a = kf(s);
            wf(a, i, n);
            const o = Number.MAX_VALUE, l = [
                -o,
                -o,
                -o
            ], u = [
                o,
                o,
                o
            ];
            if (s.contains(t1.center)) {
                for (const t3 of a)Ol(u, u, t3), ql(l, l, t3);
                l[2] = 0;
                const e2 = t1.point, r1 = [
                    e2.x * n,
                    e2.y * n,
                    0
                ];
                return Ol(u, u, r1), ql(l, l, r1), new pu(u, l);
            }
            const c = [
                i[12] * n,
                i[13] * n,
                i[14] * n
            ], h = s.getCenter(), p = S(t1.center.lat, -85.051129, Oo), f = S(h.lat, -85.051129, Oo), d = Fo(t1.center.lng), y = Lo(p);
            let m = d - Fo(h.lng);
            const g = y - Lo(f);
            m > .5 ? m -= 1 : m < -0.5 && (m += 1);
            let v = 0;
            Math.abs(m) > Math.abs(g) ? v = m >= 0 ? 1 : 3 : (v = g >= 0 ? 0 : 2, Gl(c, c, [
                i[4] * n,
                i[5] * n,
                i[6] * n
            ], -Math.sin(x(g >= 0 ? s.getSouth() : s.getNorth())) * uf));
            const b = a[v], _ = a[(v + 1) % 4], w = new gf(b, _, c), A = [
                xf(w, 0) || b[0],
                xf(w, 1) || b[1],
                xf(w, 2) || b[2]
            ], k = Df(t1.zoom);
            if (k > 0) {
                const n1 = function({ x: t1 , y: e1 , z: r  }, n, i, s, a) {
                    const o = 1 / (1 << r);
                    let l = t1 * o, u = l + o, c = e1 * o, h = c + o, p = 0;
                    const f = (l + u) / 2 - s;
                    return f > .5 ? p = -1 : f < -0.5 && (p = 1), l = ((l + p) * n - (s *= n)) * i + s, u = ((u + p) * n - s) * i + s, c = (c * n - (a *= n)) * i + a, h = (h * n - a) * i + a, [
                        [
                            l,
                            h,
                            0
                        ],
                        [
                            u,
                            h,
                            0
                        ],
                        [
                            u,
                            c,
                            0
                        ],
                        [
                            l,
                            c,
                            0
                        ]
                    ];
                }(r, e1, t1._pixelsPerMercatorPixel, d, y);
                for(let t4 = 0; t4 < a.length; t4++)bf(a[t4], n1[t4], k);
                const i1 = Ul([], n1[v], n1[(v + 1) % 4]);
                Nl(i1, i1, .5), bf(A, i1, k);
            }
            for (const t5 of a)Ol(u, u, t5), ql(l, l, t5);
            return u[2] = Math.min(b[2], _[2]), Ol(u, u, A), ql(l, l, A), new pu(u, l);
        }
        function Sf({ x: t1 , y: e1 , z: r  }) {
            const n = 1 / (1 << r), i = new Co(Uo(t1 * n), jo((e1 + 1) * n)), s = new Co(Uo((t1 + 1) * n), jo(e1 * n));
            return new Eo(i, s);
        }
        function kf(t1) {
            const e1 = x(t1.getNorth()), r = x(t1.getSouth()), n = Math.cos(e1), i = Math.cos(r), s = Math.sin(e1), a = Math.sin(r), o = t1.getWest(), l = t1.getEast();
            return [
                If(i, a, o),
                If(i, a, l),
                If(n, s, l),
                If(n, s, o)
            ];
        }
        function If(t1, e1, r, n = uf) {
            return r = x(r), [
                t1 * Math.sin(r) * n,
                -e1 * n,
                t1 * Math.cos(r) * n
            ];
        }
        function Mf(t1, e1, r) {
            return If(Math.cos(x(t1)), Math.sin(x(t1)), e1, r);
        }
        function zf(t1, e1, r, n) {
            const i = 1 << r.z, s = (t1 / Bo + r.x) / i;
            return Mf(jo((e1 / Bo + r.y) / i), Uo(s), n);
        }
        function Tf({ min: t1 , max: e1  }) {
            return 16383 / Math.max(e1[0] - t1[0], e1[1] - t1[1], e1[2] - t1[2]);
        }
        const Bf = new Float64Array(16);
        function Ef(t1) {
            const e1 = Tf(t1), r = Pl(Bf, [
                e1,
                e1,
                e1
            ]);
            var n, i;
            return zl(r, r, ((n = [])[0] = -(i = t1.min)[0], n[1] = -i[1], n[2] = -i[2], n));
        }
        function Pf(t1) {
            const e1 = (n = t1.min, (r = Bf)[0] = 1, r[1] = 0, r[2] = 0, r[3] = 0, r[4] = 0, r[5] = 1, r[6] = 0, r[7] = 0, r[8] = 0, r[9] = 0, r[10] = 1, r[11] = 0, r[12] = n[0], r[13] = n[1], r[14] = n[2], r[15] = 1, r);
            var r, n;
            const i = 1 / Tf(t1);
            return Tl(e1, e1, [
                i,
                i,
                i
            ]);
        }
        function Cf(t1, e1, r, n, i) {
            const s = function(t1) {
                const e1 = Bo / (2 * Math.PI);
                return t1 / (2 * Math.PI) / e1;
            }(r), a = [
                t1,
                e1,
                -r / (2 * Math.PI)
            ], o = kl(new Float64Array(16));
            return zl(o, o, a), Tl(o, o, [
                s,
                s,
                s
            ]), Bl(o, o, x(-i)), El(o, o, x(-n)), o;
        }
        function Df(t1) {
            return k(5, 6, t1);
        }
        function Vf(t1, e1) {
            const r = Mf(e1.lat, e1.lng), n = function(t1) {
                const e1 = Mf(t1._center.lat, t1._center.lng);
                let r = Kl([], Rl(0, 1, 0), e1);
                const n = Cl([], -t1.angle, e1);
                r = Hl(r, r, n), Cl(n, -t1._pitch, r);
                const i = Zl([], e1);
                return Nl(i, i, t1.cameraToCenterDistance / t1.pixelsPerMeter * cf), Hl(i, i, n), Ul([], e1, i);
            }(t1);
            var i, s, a, o, l, u, c, h, p, f;
            return a = (i = jl([], n, r))[0], o = i[1], l = i[2], u = (s = r)[0], c = s[1], h = s[2], f = (p = Math.sqrt(a * a + o * o + l * l) * Math.sqrt(u * u + c * c + h * h)) && Xl(i, s) / p, Math.acos(Math.min(Math.max(f, -1), 1));
        }
        const Ff = x(85), Lf = Math.cos(Ff), Rf = Math.sin(Ff);
        function Uf(t1, e1) {
            const r = t1.fovAboveCenter, n = t1.elevation ? t1.elevation.getMinElevationBelowMSL() * e1 : 0, i = (t1._camera.position[2] * t1.worldSize - n) / Math.cos(t1._pitch), s = Math.sin(r) * i / Math.sin(Math.max(Math.PI / 2 - t1._pitch - r, .01)), a = Math.sin(t1._pitch) * s + i;
            return Math.min(1.01 * a, i * (1 / t1._horizonShift));
        }
        function jf(t1, e1) {
            if (!e1.isReprojectedInTileSpace) return {
                scale: 1 << t1.z,
                x: t1.x,
                y: t1.y,
                x2: t1.x + 1,
                y2: t1.y + 1,
                projection: e1
            };
            const r = Math.pow(2, -t1.z), n = t1.x * r, i = (t1.x + 1) * r, s = t1.y * r, a = (t1.y + 1) * r, o = Uo(n), l = Uo(i), u = jo(s), c = jo(a), h = e1.project(o, u), p = e1.project(l, u), f = e1.project(l, c), d = e1.project(o, c);
            let y = Math.min(h.x, p.x, f.x, d.x), m = Math.min(h.y, p.y, f.y, d.y), g = Math.max(h.x, p.x, f.x, d.x), x = Math.max(h.y, p.y, f.y, d.y);
            const v = r / 16;
            function b(t1, r, n, i, s, a) {
                const o = (n + s) / 2, l = (i + a) / 2, u = e1.project(Uo(o), jo(l)), c = Math.max(0, y - u.x, m - u.y, u.x - g, u.y - x);
                y = Math.min(y, u.x), g = Math.max(g, u.x), m = Math.min(m, u.y), x = Math.max(x, u.y), c > v && (b(t1, u, n, i, o, l), b(u, r, o, l, s, a));
            }
            b(h, p, n, s, i, s), b(p, f, i, s, i, a), b(f, d, i, a, n, a), b(d, h, n, a, n, s), y -= v, m -= v, g += v, x += v;
            const _ = 1 / Math.max(g - y, x - m);
            return {
                scale: _,
                x: y * _,
                y: m * _,
                x2: g * _,
                y2: x * _,
                projection: e1
            };
        }
        const $f = kl(new Float32Array(16));
        class Of {
            constructor(t1){
                this.spec = t1, this.name = t1.name, this.wrap = !1, this.requiresDraping = !1, this.supportsWorldCopies = !1, this.supportsTerrain = !1, this.supportsFog = !1, this.supportsFreeCamera = !1, this.zAxisUnit = "meters", this.isReprojectedInTileSpace = !0, this.unsupportedLayers = [
                    "custom"
                ], this.center = [
                    0,
                    0
                ], this.range = [
                    3.5,
                    7
                ];
            }
            project(t1, e1) {
                return {
                    x: 0,
                    y: 0,
                    z: 0
                };
            }
            unproject(t1, e1) {
                return new Co(0, 0);
            }
            projectTilePoint(t1, e1, r) {
                return {
                    x: t1,
                    y: e1,
                    z: 0
                };
            }
            locationPoint(t1, e1, r = !0) {
                return t1._coordinatePoint(t1.locationCoordinate(e1), r);
            }
            pixelsPerMeter(t1, e1) {
                return Ro(1, t1) * e1;
            }
            pixelSpaceConversion(t1, e1, r) {
                return 1;
            }
            farthestPixelDistance(t1) {
                return Uf(t1, t1.pixelsPerMeter);
            }
            pointCoordinate(t1, e1, r, n) {
                const i = t1.horizonLineFromTop(!1), s = new d(e1, Math.max(i, r));
                return t1.rayIntersectionCoordinate(t1.pointRayIntersection(s, n));
            }
            pointCoordinate3D(t1, e1, r) {
                const n = new d(e1, r);
                if (t1.elevation) return t1.elevation.pointCoordinate(n);
                {
                    const e2 = this.pointCoordinate(t1, n.x, n.y, 0);
                    return [
                        e2.x,
                        e2.y,
                        e2.z
                    ];
                }
            }
            isPointAboveHorizon(t1, e1) {
                if (t1.elevation) return !this.pointCoordinate3D(t1, e1.x, e1.y);
                const r = t1.horizonLineFromTop();
                return e1.y < r;
            }
            createInversionMatrix(t1, e1) {
                return $f;
            }
            createTileMatrix(t1, e1, r) {
                let n, i, s;
                const a = r.canonical, o = kl(new Float64Array(16));
                if (this.isReprojectedInTileSpace) {
                    const l = jf(a, this);
                    n = 1, i = l.x + r.wrap * l.scale, s = l.y, Tl(o, o, [
                        n / l.scale,
                        n / l.scale,
                        t1.pixelsPerMeter / e1
                    ]);
                } else n = e1 / t1.zoomScale(a.z), i = (a.x + Math.pow(2, a.z) * r.wrap) * n, s = a.y * n;
                return zl(o, o, [
                    i,
                    s,
                    0
                ]), Tl(o, o, [
                    n / Bo,
                    n / Bo,
                    1
                ]), o;
            }
            upVector(t1, e1, r) {
                return [
                    0,
                    0,
                    1
                ];
            }
            upVectorScale(t1, e1, r) {
                return {
                    metersToTile: 1
                };
            }
        }
        class qf extends Of {
            constructor(t1){
                super(t1), this.range = [
                    4,
                    7
                ], this.center = t1.center || [
                    -96,
                    37.5
                ];
                const [e1, r] = this.parallels = t1.parallels || [
                    29.5,
                    45.5
                ], n = Math.sin(x(e1));
                this.n = (n + Math.sin(x(r))) / 2, this.c = 1 + n * (2 * this.n - n), this.r0 = Math.sqrt(this.c) / this.n;
            }
            project(t1, e1) {
                const { n: r , c: n , r0: i  } = this, s = x(t1 - this.center[0]), a = x(e1), o = Math.sqrt(n - 2 * r * Math.sin(a)) / r;
                return {
                    x: o * Math.sin(s * r),
                    y: o * Math.cos(s * r) - i,
                    z: 0
                };
            }
            unproject(t1, e1) {
                const { n: r , c: n , r0: i  } = this, s = i + e1;
                let a = Math.atan2(t1, Math.abs(s)) * Math.sign(s);
                s * r < 0 && (a -= Math.PI * Math.sign(t1) * Math.sign(s));
                const o = x(this.center[0]) * r;
                a = I(a, -Math.PI - o, Math.PI - o);
                const l = S(v(a / r) + this.center[0], -180, 180), u = Math.asin(S((n - (t1 * t1 + s * s) * r * r) / (2 * r), -1, 1)), c = S(v(u), -85.051129, Oo);
                return new Co(l, c);
            }
        }
        const Nf = 1.340264, Gf = -0.081106, Zf = 893e-6, Xf = .003796, Kf = Math.sqrt(3) / 2;
        class Hf extends Of {
            project(t1, e1) {
                e1 = e1 / 180 * Math.PI, t1 = t1 / 180 * Math.PI;
                const r = Math.asin(Kf * Math.sin(e1)), n = r * r, i = n * n * n;
                return {
                    x: .5 * (t1 * Math.cos(r) / (Kf * (Nf + 3 * Gf * n + i * (7 * Zf + 9 * Xf * n))) / Math.PI + .5),
                    y: 1 - .5 * (r * (Nf + Gf * n + i * (Zf + Xf * n)) / Math.PI + 1),
                    z: 0
                };
            }
            unproject(t1, e1) {
                t1 = (2 * t1 - .5) * Math.PI;
                let r = e1 = (2 * (1 - e1) - 1) * Math.PI, n = r * r, i = n * n * n;
                for(let t2, s, a, o = 0; o < 12 && (s = r * (Nf + Gf * n + i * (Zf + Xf * n)) - e1, a = Nf + 3 * Gf * n + i * (7 * Zf + 9 * Xf * n), t2 = s / a, r = S(r - t2, -Math.PI / 3, Math.PI / 3), n = r * r, i = n * n * n, !(Math.abs(t2) < 1e-12)); ++o);
                const s1 = Kf * t1 * (Nf + 3 * Gf * n + i * (7 * Zf + 9 * Xf * n)) / Math.cos(r), a1 = Math.asin(Math.sin(r) / Kf), o1 = S(180 * s1 / Math.PI, -180, 180), l = S(180 * a1 / Math.PI, -85.051129, Oo);
                return new Co(o1, l);
            }
        }
        class Yf extends Of {
            constructor(t1){
                super(t1), this.wrap = !0, this.supportsWorldCopies = !0;
            }
            project(t1, e1) {
                return {
                    x: .5 + t1 / 360,
                    y: .5 - e1 / 360,
                    z: 0
                };
            }
            unproject(t1, e1) {
                const r = 360 * (t1 - .5), n = S(360 * (.5 - e1), -85.051129, Oo);
                return new Co(r, n);
            }
        }
        const Wf = Math.PI / 2;
        function Jf(t1) {
            return Math.tan((Wf + t1) / 2);
        }
        class Qf extends Of {
            constructor(t1){
                super(t1), this.center = t1.center || [
                    0,
                    30
                ];
                const [e1, r] = this.parallels = t1.parallels || [
                    30,
                    30
                ];
                let n = x(e1), i = x(r);
                this.southernCenter = n + i < 0, this.southernCenter && (n = -n, i = -i);
                const s = Math.cos(n), a = Jf(n);
                this.n = n === i ? Math.sin(n) : Math.log(s / Math.cos(i)) / Math.log(Jf(i) / a), this.f = s * Math.pow(Jf(n), this.n) / this.n;
            }
            project(t1, e1) {
                e1 = x(e1), this.southernCenter && (e1 = -e1), t1 = x(t1 - this.center[0]);
                const r = 1e-6, { n: n , f: i  } = this;
                i > 0 ? e1 < -Wf + r && (e1 = -Wf + r) : e1 > Wf - r && (e1 = Wf - r);
                const s = i / Math.pow(Jf(e1), n);
                let a = s * Math.sin(n * t1), o = i - s * Math.cos(n * t1);
                return a = .5 * (a / Math.PI + .5), o = .5 * (o / Math.PI + .5), {
                    x: a,
                    y: this.southernCenter ? o : 1 - o,
                    z: 0
                };
            }
            unproject(t1, e1) {
                t1 = (2 * t1 - .5) * Math.PI, this.southernCenter && (e1 = 1 - e1), e1 = (2 * (1 - e1) - .5) * Math.PI;
                const { n: r , f: n  } = this, i = n - e1, s = Math.sign(i), a = Math.sign(r) * Math.sqrt(t1 * t1 + i * i);
                let o = Math.atan2(t1, Math.abs(i)) * s;
                i * r < 0 && (o -= Math.PI * Math.sign(t1) * s);
                const l = S(v(o / r) + this.center[0], -180, 180), u = S(v(2 * Math.atan(Math.pow(n / a, 1 / r)) - Wf), -85.051129, Oo);
                return new Co(l, this.southernCenter ? -u : u);
            }
        }
        class td extends Of {
            constructor(t1){
                super(t1), this.wrap = !0, this.supportsWorldCopies = !0, this.supportsTerrain = !0, this.supportsFog = !0, this.supportsFreeCamera = !0, this.isReprojectedInTileSpace = !1, this.unsupportedLayers = [], this.range = null;
            }
            project(t1, e1) {
                return {
                    x: Fo(t1),
                    y: Lo(e1),
                    z: 0
                };
            }
            unproject(t1, e1) {
                const r = Uo(t1), n = jo(e1);
                return new Co(r, n);
            }
        }
        const ed = x(Oo);
        class rd extends Of {
            project(t1, e1) {
                const r = (e1 = x(e1)) * e1, n = r * r;
                return {
                    x: .5 * ((t1 = x(t1)) * (.8707 - .131979 * r + n * (n * (.003971 * r - .001529 * n) - .013791)) / Math.PI + .5),
                    y: 1 - .5 * (e1 * (1.007226 + r * (.015085 + n * (.028874 * r - .044475 - .005916 * n))) / Math.PI + 1),
                    z: 0
                };
            }
            unproject(t1, e1) {
                t1 = (2 * t1 - .5) * Math.PI;
                let r = e1 = (2 * (1 - e1) - 1) * Math.PI, n = 25, i = 0, s = r * r;
                do {
                    s = r * r;
                    const t2 = s * s;
                    i = (r * (1.007226 + s * (.015085 + t2 * (.028874 * s - .044475 - .005916 * t2))) - e1) / (1.007226 + s * (.045255 + t2 * (.259866 * s - .311325 - .005916 * 11 * t2))), r = S(r - i, -ed, ed);
                }while (Math.abs(i) > 1e-6 && --n > 0);
                s = r * r;
                const a = S(v(t1 / (.8707 + s * (s * (s * s * s * (.003971 - .001529 * s) - .013791) - .131979))), -180, 180), o = v(r);
                return new Co(a, o);
            }
        }
        const nd = x(Oo);
        class id extends Of {
            project(t1, e1) {
                e1 = x(e1), t1 = x(t1);
                const r = Math.cos(e1), n = 2 / Math.PI, i = Math.acos(r * Math.cos(t1 / 2)), s = Math.sin(i) / i, a = .5 * (t1 * n + 2 * r * Math.sin(t1 / 2) / s) || 0, o = .5 * (e1 + Math.sin(e1) / s) || 0;
                return {
                    x: .5 * (a / Math.PI + .5),
                    y: 1 - .5 * (o / Math.PI + 1),
                    z: 0
                };
            }
            unproject(t1, e1) {
                let r = t1 = (2 * t1 - .5) * Math.PI, n = e1 = (2 * (1 - e1) - 1) * Math.PI, i = 25;
                const s = 1e-6;
                let a = 0, o = 0;
                do {
                    const i1 = Math.cos(n), s1 = Math.sin(n), l = 2 * s1 * i1, u = s1 * s1, c = i1 * i1, h = Math.cos(r / 2), p = Math.sin(r / 2), f = 2 * h * p, d = p * p, y = 1 - c * h * h, m = y ? 1 / y : 0, g = y ? Math.acos(i1 * h) * Math.sqrt(1 / y) : 0, x = .5 * (2 * g * i1 * p + 2 * r / Math.PI) - t1, v1 = .5 * (g * s1 + n) - e1, b = .5 * m * (c * d + g * i1 * h * u) + 1 / Math.PI, _ = m * (f * l / 4 - g * s1 * p), w = .125 * m * (l * p - g * s1 * c * f), A = .5 * m * (u * h + g * d * i1) + .5, k = _ * w - A * b;
                    a = (v1 * _ - x * A) / k, o = (x * w - v1 * b) / k, r = S(r - a, -Math.PI, Math.PI), n = S(n - o, -nd, nd);
                }while ((Math.abs(a) > s || Math.abs(o) > s) && --i > 0);
                return new Co(v(r), v(n));
            }
        }
        class sd extends Of {
            constructor(t1){
                super(t1), this.center = t1.center || [
                    0,
                    0
                ], this.parallels = t1.parallels || [
                    0,
                    0
                ], this.cosPhi = Math.max(.01, Math.cos(x(this.parallels[0]))), this.scale = 1 / (2 * Math.max(Math.PI * this.cosPhi, 1 / this.cosPhi)), this.wrap = !0, this.supportsWorldCopies = !0;
            }
            project(t1, e1) {
                const { scale: r , cosPhi: n  } = this;
                return {
                    x: x(t1) * n * r + .5,
                    y: -Math.sin(x(e1)) / n * r + .5,
                    z: 0
                };
            }
            unproject(t1, e1) {
                const { scale: r , cosPhi: n  } = this, i = -(e1 - .5) / r, s = S(v((t1 - .5) / r) / n, -180, 180), a = Math.asin(S(i * n, -1, 1)), o = S(v(a), -85.051129, Oo);
                return new Co(s, o);
            }
        }
        class ad extends td {
            constructor(t1){
                super(t1), this.requiresDraping = !0, this.supportsWorldCopies = !1, this.supportsFog = !0, this.zAxisUnit = "pixels", this.unsupportedLayers = [
                    "debug",
                    "custom"
                ], this.range = [
                    3,
                    5
                ];
            }
            projectTilePoint(t1, e1, r) {
                const n = zf(t1, e1, r);
                return Hl(n, n, Ef(vf(r))), {
                    x: n[0],
                    y: n[1],
                    z: n[2]
                };
            }
            locationPoint(t1, e1) {
                const r = Mf(e1.lat, e1.lng), n = Zl([], r), i = t1.elevation ? t1.elevation.getAtPointOrZero(t1.locationCoordinate(e1), t1._centerAltitude) : t1._centerAltitude;
                Gl(r, r, n, Ro(1, 0) * Bo * i);
                const s = kl(new Float64Array(16));
                return Ml(s, t1.pixelMatrix, t1.globeMatrix), Hl(r, r, s), new d(r[0], r[1]);
            }
            pixelsPerMeter(t1, e1) {
                return Ro(1, 0) * e1;
            }
            pixelSpaceConversion(t1, e1, r) {
                const n = Ro(1, t1) * e1, i = Ir(Ro(1, 45) * e1, n, r);
                return this.pixelsPerMeter(t1, e1) / i;
            }
            createTileMatrix(t1, e1, r) {
                const n = Pf(vf(r.canonical));
                return Ml(new Float64Array(16), t1.globeMatrix, n);
            }
            createInversionMatrix(t1, e1) {
                const { center: r  } = t1, n = Ef(vf(e1));
                return El(n, n, x(r.lng)), Bl(n, n, x(r.lat)), Tl(n, n, [
                    t1._pixelsPerMercatorPixel,
                    t1._pixelsPerMercatorPixel,
                    1
                ]), Float32Array.from(n);
            }
            pointCoordinate(t1, e1, r, n) {
                return mf(t1, e1, r, !0) || new No(0, 0);
            }
            pointCoordinate3D(t1, e1, r) {
                const n = this.pointCoordinate(t1, e1, r, 0);
                return [
                    n.x,
                    n.y,
                    n.z
                ];
            }
            isPointAboveHorizon(t1, e1) {
                return !mf(t1, e1.x, e1.y, !1);
            }
            farthestPixelDistance(t1) {
                const e1 = function(t1, e1) {
                    const r = t1.cameraToCenterDistance, n = t1._centerAltitude * e1, i = t1._camera, s = t1._camera.forward(), a = Ul([], Nl([], s, -r), [
                        0,
                        0,
                        n
                    ]), o = t1.worldSize / (2 * Math.PI), l = [
                        0,
                        0,
                        -o
                    ], u = t1.width / t1.height, c = Math.tan(t1.fovAboveCenter), h = Nl([], i.up(), c), p = Nl([], i.right(), c * u), f = Zl([], Ul([], Ul([], s, h), p)), d = [];
                    let y;
                    if (new uu(a, f).closestPointOnSphere(l, o, d)) {
                        const e2 = Ul([], d, l), r1 = Jl([], e2, a);
                        y = Math.cos(t1.fovAboveCenter) * Ll(r1);
                    } else {
                        const t2 = Jl([], a, l), e3 = Jl([], l, a);
                        Zl(e3, e3);
                        const r2 = Ll(t2) - o;
                        y = Math.sqrt(r2 * (r2 + 2 * o));
                        const n1 = Math.acos(y / (o + r2)) - Math.acos(Xl(s, e3));
                        y *= Math.cos(n1);
                    }
                    return 1.01 * y;
                }(t1, this.pixelsPerMeter(t1.center.lat, t1.worldSize)), r = Df(t1.zoom);
                if (r > 0) {
                    const n = Uf(t1, Ro(1, t1.center.lat) * t1.worldSize), i = t1.worldSize / (2 * Math.PI), s = Math.max(t1.width, t1.height) / t1.worldSize * Math.PI;
                    return Ir(e1, n + i * (1 - Math.cos(s)), Math.pow(r, 10));
                }
                return e1;
            }
            upVector(t1, e1, r) {
                return zf(e1, r, t1, 1);
            }
            upVectorScale(t1) {
                return {
                    metersToTile: cf * Tf(vf(t1))
                };
            }
        }
        function od(t1) {
            const e1 = t1.parallels, r = !!e1 && Math.abs(e1[0] + e1[1]) < .01;
            switch(t1.name){
                case "mercator":
                    return new td(t1);
                case "equirectangular":
                    return new Yf(t1);
                case "naturalEarth":
                    return new rd(t1);
                case "equalEarth":
                    return new Hf(t1);
                case "winkelTripel":
                    return new id(t1);
                case "albers":
                    return r ? new sd(t1) : new qf(t1);
                case "lambertConformalConic":
                    return r ? new sd(t1) : new Qf(t1);
                case "globe":
                    return new ad(t1);
            }
            throw new Error(`Invalid projection name: ${t1.name}`);
        }
        const ld = Bc.types, ud = [
            {
                name: "a_fade_opacity",
                components: 1,
                type: "Uint8",
                offset: 0
            }
        ];
        function cd(t1, e1, r, n, i, s, a, o, l, u, c, h, p) {
            const f = o ? Math.min(Jp, Math.round(o[0])) : 0, d = o ? Math.min(Jp, Math.round(o[1])) : 0;
            t1.emplaceBack(e1, r, Math.round(32 * n), Math.round(32 * i), s, a, (f << 1) + (l ? 1 : 0), d, 16 * u, 16 * c, 256 * h, 256 * p);
        }
        function hd(t1, e1, r, n, i, s, a) {
            t1.emplaceBack(e1, r, n, i, s, a);
        }
        function pd(t1, e1, r, n, i) {
            t1.emplaceBack(e1, r, n, i), t1.emplaceBack(e1, r, n, i), t1.emplaceBack(e1, r, n, i), t1.emplaceBack(e1, r, n, i);
        }
        function fd(t1) {
            for (const e1 of t1.sections)if (Is(e1.text)) return !0;
            return !1;
        }
        class dd {
            constructor(t1){
                this.layoutVertexArray = new da, this.indexArray = new wa, this.programConfigurations = t1, this.segments = new To, this.dynamicLayoutVertexArray = new ca, this.opacityVertexArray = new ma, this.placedSymbolArray = new Fa, this.globeExtVertexArray = new ya;
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length && 0 === this.indexArray.length && 0 === this.dynamicLayoutVertexArray.length && 0 === this.opacityVertexArray.length;
            }
            upload(t1, e1, r, n) {
                this.isEmpty() || (r && (this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, dh.members), this.indexBuffer = t1.createIndexBuffer(this.indexArray, e1), this.dynamicLayoutVertexBuffer = t1.createVertexBuffer(this.dynamicLayoutVertexArray, mh.members, !0), this.opacityVertexBuffer = t1.createVertexBuffer(this.opacityVertexArray, ud, !0), this.globeExtVertexArray.length > 0 && (this.globeExtVertexBuffer = t1.createVertexBuffer(this.globeExtVertexArray, yh.members, !0)), this.opacityVertexBuffer.itemSize = 1), (r || n) && this.programConfigurations.upload(t1));
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy(), this.dynamicLayoutVertexBuffer.destroy(), this.opacityVertexBuffer.destroy(), this.globeExtVertexBuffer && this.globeExtVertexBuffer.destroy());
            }
        }
        ji(dd, "SymbolBuffers");
        class yd {
            constructor(t1, e1, r){
                this.layoutVertexArray = new t1, this.layoutAttributes = e1, this.indexArray = new r, this.segments = new To, this.collisionVertexArray = new ba, this.collisionVertexArrayExt = new _a;
            }
            upload(t1) {
                this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, this.layoutAttributes), this.indexBuffer = t1.createIndexBuffer(this.indexArray), this.collisionVertexBuffer = t1.createVertexBuffer(this.collisionVertexArray, gh.members, !0), this.collisionVertexBufferExt = t1.createVertexBuffer(this.collisionVertexArrayExt, xh.members, !0);
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.segments.destroy(), this.collisionVertexBuffer.destroy(), this.collisionVertexBufferExt.destroy());
            }
        }
        ji(yd, "CollisionBuffers");
        class md {
            constructor(t1){
                this.collisionBoxArray = t1.collisionBoxArray, this.zoom = t1.zoom, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.pixelRatio = t1.pixelRatio, this.sourceLayerIndex = t1.sourceLayerIndex, this.hasPattern = !1, this.hasRTLText = !1, this.fullyClipped = !1, this.sortKeyRanges = [], this.collisionCircleArray = [], this.placementInvProjMatrix = kl([]), this.placementViewportMatrix = kl([]);
                const e1 = this.layers[0]._unevaluatedLayout._values;
                this.textSizeData = Ah(this.zoom, e1["text-size"]), this.iconSizeData = Ah(this.zoom, e1["icon-size"]);
                const r = this.layers[0].layout, n = r.get("symbol-sort-key"), i = r.get("symbol-z-order");
                this.canOverlap = r.get("text-allow-overlap") || r.get("icon-allow-overlap") || r.get("text-ignore-placement") || r.get("icon-ignore-placement"), this.sortFeaturesByKey = "viewport-y" !== i && void 0 !== n.constantOr(1), this.sortFeaturesByY = ("viewport-y" === i || "auto" === i && !this.sortFeaturesByKey) && this.canOverlap, this.writingModes = r.get("text-writing-mode").map((t1)=>sp[t1]), this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id), this.sourceID = t1.sourceID, this.projection = t1.projection;
            }
            createArrays() {
                this.text = new dd(new vo(this.layers, this.zoom, (t1)=>/^text/.test(t1))), this.icon = new dd(new vo(this.layers, this.zoom, (t1)=>/^icon/.test(t1))), this.glyphOffsetArray = new Ua, this.lineVertexArray = new ja, this.symbolInstances = new Ra;
            }
            calculateGlyphDependencies(t1, e1, r, n, i) {
                for(let r1 = 0; r1 < t1.length; r1++)if (e1[t1.charCodeAt(r1)] = !0, n && i) {
                    const n1 = zh[t1.charAt(r1)];
                    n1 && (e1[n1.charCodeAt(0)] = !0);
                }
            }
            populate(t1, e1, r, n) {
                const i = this.layers[0], s = i.layout, a = "globe" === this.projection.name, o = s.get("text-font"), l = s.get("text-field"), u = s.get("icon-image"), c = ("constant" !== l.value.kind || l.value.value instanceof Te && !l.value.value.isEmpty() || l.value.value.toString().length > 0) && ("constant" !== o.value.kind || o.value.value.length > 0), h = "constant" !== u.value.kind || !!u.value.value || Object.keys(u.parameters).length > 0, p = s.get("symbol-sort-key");
                if (this.features = [], !c && !h) return;
                const f = e1.iconDependencies, d = e1.glyphDependencies, y = e1.availableImages, m = new Us(this.zoom);
                for (const { feature: e2 , id: l1 , index: u1 , sourceLayerIndex: g  } of t1){
                    const t2 = i._featureFilter.needGeometry, x = Qo(e2, t2);
                    if (!i._featureFilter.filter(m, x, r)) continue;
                    if (t2 || (x.geometry = Jo(e2, r, n)), a && 1 !== e2.type && r.z <= 5) {
                        const t3 = x.geometry, e3 = .98078528056, n1 = (t1, n)=>Xl(zf(t1.x, t1.y, r, 1), zf(n.x, n.y, r, 1)) < e3;
                        for(let e4 = 0; e4 < t3.length; e4++)t3[e4] = Ko(t3[e4], n1);
                    }
                    let v, b;
                    if (c) {
                        const t4 = i.getValueAndResolveTokens("text-field", x, r, y), e5 = Te.factory(t4);
                        fd(e5) && (this.hasRTLText = !0), (!this.hasRTLText || "unavailable" === Fs() || this.hasRTLText && Rs.isParsed()) && (v = Mh(e5, i, x));
                    }
                    if (h) {
                        const t5 = i.getValueAndResolveTokens("icon-image", x, r, y);
                        b = t5 instanceof Be ? t5 : Be.fromString(t5);
                    }
                    if (!v && !b) continue;
                    const _ = this.sortFeaturesByKey ? p.evaluate(x, {}, r) : void 0;
                    if (this.features.push({
                        id: l1,
                        text: v,
                        icon: b,
                        index: u1,
                        sourceLayerIndex: g,
                        geometry: x.geometry,
                        properties: e2.properties,
                        type: ld[e2.type],
                        sortKey: _
                    }), b && (f[b.name] = !0), v) {
                        const t6 = o.evaluate(x, {}, r).join(","), e6 = "map" === s.get("text-rotation-alignment") && "point" !== s.get("symbol-placement");
                        this.allowVerticalPlacement = this.writingModes && this.writingModes.indexOf(sp.vertical) >= 0;
                        for (const r1 of v.sections)if (r1.image) f[r1.image.name] = !0;
                        else {
                            const n2 = vs(v.toString()), i1 = r1.fontStack || t6, s1 = d[i1] = d[i1] || {};
                            this.calculateGlyphDependencies(r1.text, s1, e6, this.allowVerticalPlacement, n2);
                        }
                    }
                }
                "line" === s.get("symbol-placement") && (this.features = function(t1) {
                    const e1 = {}, r = {}, n = [];
                    let i = 0;
                    function s(e1) {
                        n.push(t1[e1]), i++;
                    }
                    function a(t1, e1, i) {
                        const s = r[t1];
                        return delete r[t1], r[e1] = s, n[s].geometry[0].pop(), n[s].geometry[0] = n[s].geometry[0].concat(i[0]), s;
                    }
                    function o(t1, r, i) {
                        const s = e1[r];
                        return delete e1[r], e1[t1] = s, n[s].geometry[0].shift(), n[s].geometry[0] = i[0].concat(n[s].geometry[0]), s;
                    }
                    function l(t1, e1, r) {
                        const n = r ? e1[0][e1[0].length - 1] : e1[0][0];
                        return `${t1}:${n.x}:${n.y}`;
                    }
                    for(let u = 0; u < t1.length; u++){
                        const c = t1[u], h = c.geometry, p = c.text ? c.text.toString() : null;
                        if (!p) {
                            s(u);
                            continue;
                        }
                        const f = l(p, h), d = l(p, h, !0);
                        if (f in r && d in e1 && r[f] !== e1[d]) {
                            const t2 = o(f, d, h), i1 = a(f, d, n[t2].geometry);
                            delete e1[f], delete r[d], r[l(p, n[i1].geometry, !0)] = i1, n[t2].geometry = null;
                        } else f in r ? a(f, d, h) : d in e1 ? o(f, d, h) : (s(u), e1[f] = i - 1, r[d] = i - 1);
                    }
                    return n.filter((t1)=>t1.geometry);
                }(this.features)), this.sortFeaturesByKey && this.features.sort((t1, e1)=>t1.sortKey - e1.sortKey);
            }
            update(t1, e1, r, n) {
                this.stateDependentLayers.length && (this.text.programConfigurations.updatePaintArrays(t1, e1, this.layers, r, n), this.icon.programConfigurations.updatePaintArrays(t1, e1, this.layers, r, n));
            }
            isEmpty() {
                return 0 === this.symbolInstances.length && !this.hasRTLText;
            }
            uploadPending() {
                return !this.uploaded || this.text.programConfigurations.needsUpload || this.icon.programConfigurations.needsUpload;
            }
            upload(t1) {
                !this.uploaded && this.hasDebugData() && (this.textCollisionBox.upload(t1), this.iconCollisionBox.upload(t1)), this.text.upload(t1, this.sortFeaturesByY, !this.uploaded, this.text.programConfigurations.needsUpload), this.icon.upload(t1, this.sortFeaturesByY, !this.uploaded, this.icon.programConfigurations.needsUpload), this.uploaded = !0;
            }
            destroyDebugData() {
                this.textCollisionBox.destroy(), this.iconCollisionBox.destroy();
            }
            getProjection() {
                return this.projectionInstance || (this.projectionInstance = od(this.projection)), this.projectionInstance;
            }
            destroy() {
                this.text.destroy(), this.icon.destroy(), this.hasDebugData() && this.destroyDebugData();
            }
            addToLineVertexArray(t1, e1) {
                const r = this.lineVertexArray.length, n = t1.segment;
                if (void 0 !== n) {
                    let r1 = t1.dist(e1[n + 1]), i = t1.dist(e1[n]);
                    const s = {};
                    for(let t2 = n + 1; t2 < e1.length; t2++)s[t2] = {
                        x: e1[t2].x,
                        y: e1[t2].y,
                        tileUnitDistanceFromAnchor: r1
                    }, t2 < e1.length - 1 && (r1 += e1[t2 + 1].dist(e1[t2]));
                    for(let t3 = n || 0; t3 >= 0; t3--)s[t3] = {
                        x: e1[t3].x,
                        y: e1[t3].y,
                        tileUnitDistanceFromAnchor: i
                    }, t3 > 0 && (i += e1[t3 - 1].dist(e1[t3]));
                    for(let t4 = 0; t4 < e1.length; t4++){
                        const e2 = s[t4];
                        this.lineVertexArray.emplaceBack(e2.x, e2.y, e2.tileUnitDistanceFromAnchor);
                    }
                }
                return {
                    lineStartIndex: r,
                    lineLength: this.lineVertexArray.length - r
                };
            }
            addSymbols(t1, e1, r, n, i, s, a, o, l, u, c, h, p, f) {
                const d = t1.indexArray, y = t1.layoutVertexArray, m = t1.globeExtVertexArray, g = t1.segments.prepareSegment(4 * e1.length, y, d, this.canOverlap ? s.sortKey : void 0), x = this.glyphOffsetArray.length, v = g.vertexLength, b = this.allowVerticalPlacement && a === sp.vertical ? Math.PI / 2 : 0, _ = s.text && s.text.sections;
                for(let n1 = 0; n1 < e1.length; n1++){
                    const { tl: i1 , tr: a1 , bl: u1 , br: c1 , tex: h1 , pixelOffsetTL: x1 , pixelOffsetBR: v1 , minFontScaleX: w , minFontScaleY: A , glyphOffset: S , isSDF: k , sectionIndex: I  } = e1[n1], M = g.vertexLength, z = S[1];
                    if (cd(y, l.x, l.y, i1.x, z + i1.y, h1.x, h1.y, r, k, x1.x, x1.y, w, A), cd(y, l.x, l.y, a1.x, z + a1.y, h1.x + h1.w, h1.y, r, k, v1.x, x1.y, w, A), cd(y, l.x, l.y, u1.x, z + u1.y, h1.x, h1.y + h1.h, r, k, x1.x, v1.y, w, A), cd(y, l.x, l.y, c1.x, z + c1.y, h1.x + h1.w, h1.y + h1.h, r, k, v1.x, v1.y, w, A), o) {
                        const e2 = o.anchor, r1 = o.up;
                        hd(m, e2.x, e2.y, e2.z, r1[0], r1[1], r1[2]), hd(m, e2.x, e2.y, e2.z, r1[0], r1[1], r1[2]), hd(m, e2.x, e2.y, e2.z, r1[0], r1[1], r1[2]), hd(m, e2.x, e2.y, e2.z, r1[0], r1[1], r1[2]), pd(t1.dynamicLayoutVertexArray, e2.x, e2.y, e2.z, b);
                    } else pd(t1.dynamicLayoutVertexArray, l.x, l.y, l.z, b);
                    d.emplaceBack(M, M + 1, M + 2), d.emplaceBack(M + 1, M + 2, M + 3), g.vertexLength += 4, g.primitiveLength += 2, this.glyphOffsetArray.emplaceBack(S[0]), n1 !== e1.length - 1 && I === e1[n1 + 1].sectionIndex || t1.programConfigurations.populatePaintArrays(y.length, s, s.index, {}, p, f, _ && _[I]);
                }
                const w1 = o ? o.anchor : l;
                t1.placedSymbolArray.emplaceBack(w1.x, w1.y, w1.z, l.x, l.y, x, this.glyphOffsetArray.length - x, v, u, c, l.segment, r ? r[0] : 0, r ? r[1] : 0, n[0], n[1], a, 0, !1, 0, h, 0);
            }
            _commitLayoutVertex(t1, e1, r, n, i, s, a) {
                t1.emplaceBack(e1, r, n, i, s, Math.round(a.x), Math.round(a.y));
            }
            _addCollisionDebugVertices(t1, e1, r, n, i, s, a) {
                const o = r.segments.prepareSegment(4, r.layoutVertexArray, r.indexArray), l = o.vertexLength, u = a.tileAnchorX, c = a.tileAnchorY;
                for(let t2 = 0; t2 < 4; t2++)r.collisionVertexArray.emplaceBack(0, 0, 0, 0);
                r.collisionVertexArrayExt.emplaceBack(e1, -t1.padding, -t1.padding), r.collisionVertexArrayExt.emplaceBack(e1, t1.padding, -t1.padding), r.collisionVertexArrayExt.emplaceBack(e1, t1.padding, t1.padding), r.collisionVertexArrayExt.emplaceBack(e1, -t1.padding, t1.padding), this._commitLayoutVertex(r.layoutVertexArray, n, i, s, u, c, new d(t1.x1, t1.y1)), this._commitLayoutVertex(r.layoutVertexArray, n, i, s, u, c, new d(t1.x2, t1.y1)), this._commitLayoutVertex(r.layoutVertexArray, n, i, s, u, c, new d(t1.x2, t1.y2)), this._commitLayoutVertex(r.layoutVertexArray, n, i, s, u, c, new d(t1.x1, t1.y2)), o.vertexLength += 4;
                const h = r.indexArray;
                h.emplaceBack(l, l + 1), h.emplaceBack(l + 1, l + 2), h.emplaceBack(l + 2, l + 3), h.emplaceBack(l + 3, l), o.primitiveLength += 4;
            }
            _addTextDebugCollisionBoxes(t1, e1, r, n, i, s) {
                for(let a = n; a < i; a++){
                    const n1 = r.get(a), i1 = this.getSymbolInstanceTextSize(t1, s, e1, a);
                    this._addCollisionDebugVertices(n1, i1, this.textCollisionBox, n1.projectedAnchorX, n1.projectedAnchorY, n1.projectedAnchorZ, s);
                }
            }
            _addIconDebugCollisionBoxes(t1, e1, r, n, i, s) {
                for(let a = n; a < i; a++){
                    const n1 = r.get(a), i1 = this.getSymbolInstanceIconSize(t1, e1, s.placedIconSymbolIndex);
                    this._addCollisionDebugVertices(n1, i1, this.iconCollisionBox, n1.projectedAnchorX, n1.projectedAnchorY, n1.projectedAnchorZ, s);
                }
            }
            generateCollisionDebugBuffers(t1, e1) {
                this.hasDebugData() && this.destroyDebugData(), this.textCollisionBox = new yd(xa, vh.members, za), this.iconCollisionBox = new yd(xa, vh.members, za);
                const r = kh(this.iconSizeData, t1), n = kh(this.textSizeData, t1);
                for(let i = 0; i < this.symbolInstances.length; i++){
                    const s = this.symbolInstances.get(i);
                    this._addTextDebugCollisionBoxes(n, t1, e1, s.textBoxStartIndex, s.textBoxEndIndex, s), this._addTextDebugCollisionBoxes(n, t1, e1, s.verticalTextBoxStartIndex, s.verticalTextBoxEndIndex, s), this._addIconDebugCollisionBoxes(r, t1, e1, s.iconBoxStartIndex, s.iconBoxEndIndex, s), this._addIconDebugCollisionBoxes(r, t1, e1, s.verticalIconBoxStartIndex, s.verticalIconBoxEndIndex, s);
                }
            }
            getSymbolInstanceTextSize(t1, e1, r, n) {
                const i = this.text.placedSymbolArray.get(e1.rightJustifiedTextSymbolIndex >= 0 ? e1.rightJustifiedTextSymbolIndex : e1.centerJustifiedTextSymbolIndex >= 0 ? e1.centerJustifiedTextSymbolIndex : e1.leftJustifiedTextSymbolIndex >= 0 ? e1.leftJustifiedTextSymbolIndex : e1.verticalPlacedTextSymbolIndex >= 0 ? e1.verticalPlacedTextSymbolIndex : n), s = Sh(this.textSizeData, t1, i) / _h;
                return this.tilePixelRatio * s;
            }
            getSymbolInstanceIconSize(t1, e1, r) {
                const n = this.icon.placedSymbolArray.get(r), i = Sh(this.iconSizeData, t1, n);
                return this.tilePixelRatio * i;
            }
            _commitDebugCollisionVertexUpdate(t1, e1, r) {
                t1.emplaceBack(e1, -r, -r), t1.emplaceBack(e1, r, -r), t1.emplaceBack(e1, r, r), t1.emplaceBack(e1, -r, r);
            }
            _updateTextDebugCollisionBoxes(t1, e1, r, n, i, s) {
                for(let a = n; a < i; a++){
                    const n1 = r.get(a), i1 = this.getSymbolInstanceTextSize(t1, s, e1, a);
                    this._commitDebugCollisionVertexUpdate(this.textCollisionBox.collisionVertexArrayExt, i1, n1.padding);
                }
            }
            _updateIconDebugCollisionBoxes(t1, e1, r, n, i, s) {
                for(let a = n; a < i; a++){
                    const n1 = r.get(a), i1 = this.getSymbolInstanceIconSize(t1, e1, s);
                    this._commitDebugCollisionVertexUpdate(this.iconCollisionBox.collisionVertexArrayExt, i1, n1.padding);
                }
            }
            updateCollisionDebugBuffers(t1, e1) {
                if (!this.hasDebugData()) return;
                this.hasTextCollisionBoxData() && this.textCollisionBox.collisionVertexArrayExt.clear(), this.hasIconCollisionBoxData() && this.iconCollisionBox.collisionVertexArrayExt.clear();
                const r = kh(this.iconSizeData, t1), n = kh(this.textSizeData, t1);
                for(let i = 0; i < this.symbolInstances.length; i++){
                    const s = this.symbolInstances.get(i);
                    this._updateTextDebugCollisionBoxes(n, t1, e1, s.textBoxStartIndex, s.textBoxEndIndex, s), this._updateTextDebugCollisionBoxes(n, t1, e1, s.verticalTextBoxStartIndex, s.verticalTextBoxEndIndex, s), this._updateIconDebugCollisionBoxes(r, t1, e1, s.iconBoxStartIndex, s.iconBoxEndIndex, s.placedIconSymbolIndex), this._updateIconDebugCollisionBoxes(r, t1, e1, s.verticalIconBoxStartIndex, s.verticalIconBoxEndIndex, s.placedIconSymbolIndex);
                }
                this.hasTextCollisionBoxData() && this.textCollisionBox.collisionVertexBufferExt && this.textCollisionBox.collisionVertexBufferExt.updateData(this.textCollisionBox.collisionVertexArrayExt), this.hasIconCollisionBoxData() && this.iconCollisionBox.collisionVertexBufferExt && this.iconCollisionBox.collisionVertexBufferExt.updateData(this.iconCollisionBox.collisionVertexArrayExt);
            }
            _deserializeCollisionBoxesForSymbol(t1, e1, r, n, i, s, a, o, l) {
                const u = {};
                for(let n1 = e1; n1 < r; n1++){
                    const e2 = t1.get(n1);
                    u.textBox = {
                        x1: e2.x1,
                        y1: e2.y1,
                        x2: e2.x2,
                        y2: e2.y2,
                        padding: e2.padding,
                        projectedAnchorX: e2.projectedAnchorX,
                        projectedAnchorY: e2.projectedAnchorY,
                        projectedAnchorZ: e2.projectedAnchorZ,
                        tileAnchorX: e2.tileAnchorX,
                        tileAnchorY: e2.tileAnchorY
                    }, u.textFeatureIndex = e2.featureIndex;
                    break;
                }
                for(let e3 = n; e3 < i; e3++){
                    const r1 = t1.get(e3);
                    u.verticalTextBox = {
                        x1: r1.x1,
                        y1: r1.y1,
                        x2: r1.x2,
                        y2: r1.y2,
                        padding: r1.padding,
                        projectedAnchorX: r1.projectedAnchorX,
                        projectedAnchorY: r1.projectedAnchorY,
                        projectedAnchorZ: r1.projectedAnchorZ,
                        tileAnchorX: r1.tileAnchorX,
                        tileAnchorY: r1.tileAnchorY
                    }, u.verticalTextFeatureIndex = r1.featureIndex;
                    break;
                }
                for(let e4 = s; e4 < a; e4++){
                    const r2 = t1.get(e4);
                    u.iconBox = {
                        x1: r2.x1,
                        y1: r2.y1,
                        x2: r2.x2,
                        y2: r2.y2,
                        padding: r2.padding,
                        projectedAnchorX: r2.projectedAnchorX,
                        projectedAnchorY: r2.projectedAnchorY,
                        projectedAnchorZ: r2.projectedAnchorZ,
                        tileAnchorX: r2.tileAnchorX,
                        tileAnchorY: r2.tileAnchorY
                    }, u.iconFeatureIndex = r2.featureIndex;
                    break;
                }
                for(let e5 = o; e5 < l; e5++){
                    const r3 = t1.get(e5);
                    u.verticalIconBox = {
                        x1: r3.x1,
                        y1: r3.y1,
                        x2: r3.x2,
                        y2: r3.y2,
                        padding: r3.padding,
                        projectedAnchorX: r3.projectedAnchorX,
                        projectedAnchorY: r3.projectedAnchorY,
                        projectedAnchorZ: r3.projectedAnchorZ,
                        tileAnchorX: r3.tileAnchorX,
                        tileAnchorY: r3.tileAnchorY
                    }, u.verticalIconFeatureIndex = r3.featureIndex;
                    break;
                }
                return u;
            }
            deserializeCollisionBoxes(t1) {
                this.collisionArrays = [];
                for(let e1 = 0; e1 < this.symbolInstances.length; e1++){
                    const r = this.symbolInstances.get(e1);
                    this.collisionArrays.push(this._deserializeCollisionBoxesForSymbol(t1, r.textBoxStartIndex, r.textBoxEndIndex, r.verticalTextBoxStartIndex, r.verticalTextBoxEndIndex, r.iconBoxStartIndex, r.iconBoxEndIndex, r.verticalIconBoxStartIndex, r.verticalIconBoxEndIndex));
                }
            }
            hasTextData() {
                return this.text.segments.get().length > 0;
            }
            hasIconData() {
                return this.icon.segments.get().length > 0;
            }
            hasDebugData() {
                return this.textCollisionBox && this.iconCollisionBox;
            }
            hasTextCollisionBoxData() {
                return this.hasDebugData() && this.textCollisionBox.segments.get().length > 0;
            }
            hasIconCollisionBoxData() {
                return this.hasDebugData() && this.iconCollisionBox.segments.get().length > 0;
            }
            addIndicesForPlacedSymbol(t1, e1) {
                const r = t1.placedSymbolArray.get(e1), n = r.vertexStartIndex + 4 * r.numGlyphs;
                for(let e2 = r.vertexStartIndex; e2 < n; e2 += 4)t1.indexArray.emplaceBack(e2, e2 + 1, e2 + 2), t1.indexArray.emplaceBack(e2 + 1, e2 + 2, e2 + 3);
            }
            getSortedSymbolIndexes(t1) {
                if (this.sortedAngle === t1 && void 0 !== this.symbolInstanceIndexes) return this.symbolInstanceIndexes;
                const e1 = Math.sin(t1), r = Math.cos(t1), n = [], i = [], s = [];
                for(let t2 = 0; t2 < this.symbolInstances.length; ++t2){
                    s.push(t2);
                    const a = this.symbolInstances.get(t2);
                    n.push(0 | Math.round(e1 * a.tileAnchorX + r * a.tileAnchorY)), i.push(a.featureIndex);
                }
                return s.sort((t1, e1)=>n[t1] - n[e1] || i[e1] - i[t1]), s;
            }
            addToSortKeyRanges(t1, e1) {
                const r = this.sortKeyRanges[this.sortKeyRanges.length - 1];
                r && r.sortKey === e1 ? r.symbolInstanceEnd = t1 + 1 : this.sortKeyRanges.push({
                    sortKey: e1,
                    symbolInstanceStart: t1,
                    symbolInstanceEnd: t1 + 1
                });
            }
            sortFeatures(t1) {
                if (this.sortFeaturesByY && this.sortedAngle !== t1 && !(this.text.segments.get().length > 1 || this.icon.segments.get().length > 1)) {
                    this.symbolInstanceIndexes = this.getSortedSymbolIndexes(t1), this.sortedAngle = t1, this.text.indexArray.clear(), this.icon.indexArray.clear(), this.featureSortOrder = [];
                    for (const t2 of this.symbolInstanceIndexes){
                        const e1 = this.symbolInstances.get(t2);
                        this.featureSortOrder.push(e1.featureIndex), [
                            e1.rightJustifiedTextSymbolIndex,
                            e1.centerJustifiedTextSymbolIndex,
                            e1.leftJustifiedTextSymbolIndex
                        ].forEach((t1, e1, r)=>{
                            t1 >= 0 && r.indexOf(t1) === e1 && this.addIndicesForPlacedSymbol(this.text, t1);
                        }), e1.verticalPlacedTextSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.text, e1.verticalPlacedTextSymbolIndex), e1.placedIconSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.icon, e1.placedIconSymbolIndex), e1.verticalPlacedIconSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.icon, e1.verticalPlacedIconSymbolIndex);
                    }
                    this.text.indexBuffer && this.text.indexBuffer.updateData(this.text.indexArray), this.icon.indexBuffer && this.icon.indexBuffer.updateData(this.icon.indexArray);
                }
            }
        }
        ji(md, "SymbolBucket", {
            omit: [
                "layers",
                "collisionBoxArray",
                "features",
                "compareText"
            ]
        }), md.MAX_GLYPHS = 65535, md.addDynamicAttributes = pd;
        const gd = new Qs({
            "symbol-placement": new Ks(Ht.layout_symbol["symbol-placement"]),
            "symbol-spacing": new Ks(Ht.layout_symbol["symbol-spacing"]),
            "symbol-avoid-edges": new Ks(Ht.layout_symbol["symbol-avoid-edges"]),
            "symbol-sort-key": new Hs(Ht.layout_symbol["symbol-sort-key"]),
            "symbol-z-order": new Ks(Ht.layout_symbol["symbol-z-order"]),
            "icon-allow-overlap": new Ks(Ht.layout_symbol["icon-allow-overlap"]),
            "icon-ignore-placement": new Ks(Ht.layout_symbol["icon-ignore-placement"]),
            "icon-optional": new Ks(Ht.layout_symbol["icon-optional"]),
            "icon-rotation-alignment": new Ks(Ht.layout_symbol["icon-rotation-alignment"]),
            "icon-size": new Hs(Ht.layout_symbol["icon-size"]),
            "icon-text-fit": new Ks(Ht.layout_symbol["icon-text-fit"]),
            "icon-text-fit-padding": new Ks(Ht.layout_symbol["icon-text-fit-padding"]),
            "icon-image": new Hs(Ht.layout_symbol["icon-image"]),
            "icon-rotate": new Hs(Ht.layout_symbol["icon-rotate"]),
            "icon-padding": new Ks(Ht.layout_symbol["icon-padding"]),
            "icon-keep-upright": new Ks(Ht.layout_symbol["icon-keep-upright"]),
            "icon-offset": new Hs(Ht.layout_symbol["icon-offset"]),
            "icon-anchor": new Hs(Ht.layout_symbol["icon-anchor"]),
            "icon-pitch-alignment": new Ks(Ht.layout_symbol["icon-pitch-alignment"]),
            "text-pitch-alignment": new Ks(Ht.layout_symbol["text-pitch-alignment"]),
            "text-rotation-alignment": new Ks(Ht.layout_symbol["text-rotation-alignment"]),
            "text-field": new Hs(Ht.layout_symbol["text-field"]),
            "text-font": new Hs(Ht.layout_symbol["text-font"]),
            "text-size": new Hs(Ht.layout_symbol["text-size"]),
            "text-max-width": new Hs(Ht.layout_symbol["text-max-width"]),
            "text-line-height": new Hs(Ht.layout_symbol["text-line-height"]),
            "text-letter-spacing": new Hs(Ht.layout_symbol["text-letter-spacing"]),
            "text-justify": new Hs(Ht.layout_symbol["text-justify"]),
            "text-radial-offset": new Hs(Ht.layout_symbol["text-radial-offset"]),
            "text-variable-anchor": new Ks(Ht.layout_symbol["text-variable-anchor"]),
            "text-anchor": new Hs(Ht.layout_symbol["text-anchor"]),
            "text-max-angle": new Ks(Ht.layout_symbol["text-max-angle"]),
            "text-writing-mode": new Ks(Ht.layout_symbol["text-writing-mode"]),
            "text-rotate": new Hs(Ht.layout_symbol["text-rotate"]),
            "text-padding": new Ks(Ht.layout_symbol["text-padding"]),
            "text-keep-upright": new Ks(Ht.layout_symbol["text-keep-upright"]),
            "text-transform": new Hs(Ht.layout_symbol["text-transform"]),
            "text-offset": new Hs(Ht.layout_symbol["text-offset"]),
            "text-allow-overlap": new Ks(Ht.layout_symbol["text-allow-overlap"]),
            "text-ignore-placement": new Ks(Ht.layout_symbol["text-ignore-placement"]),
            "text-optional": new Ks(Ht.layout_symbol["text-optional"])
        });
        var xd = {
            paint: new Qs({
                "icon-opacity": new Hs(Ht.paint_symbol["icon-opacity"]),
                "icon-color": new Hs(Ht.paint_symbol["icon-color"]),
                "icon-halo-color": new Hs(Ht.paint_symbol["icon-halo-color"]),
                "icon-halo-width": new Hs(Ht.paint_symbol["icon-halo-width"]),
                "icon-halo-blur": new Hs(Ht.paint_symbol["icon-halo-blur"]),
                "icon-translate": new Ks(Ht.paint_symbol["icon-translate"]),
                "icon-translate-anchor": new Ks(Ht.paint_symbol["icon-translate-anchor"]),
                "text-opacity": new Hs(Ht.paint_symbol["text-opacity"]),
                "text-color": new Hs(Ht.paint_symbol["text-color"], {
                    runtimeType: oe,
                    getOverride: (t1)=>t1.textColor,
                    hasOverride: (t1)=>!!t1.textColor
                }),
                "text-halo-color": new Hs(Ht.paint_symbol["text-halo-color"]),
                "text-halo-width": new Hs(Ht.paint_symbol["text-halo-width"]),
                "text-halo-blur": new Hs(Ht.paint_symbol["text-halo-blur"]),
                "text-translate": new Ks(Ht.paint_symbol["text-translate"]),
                "text-translate-anchor": new Ks(Ht.paint_symbol["text-translate-anchor"])
            }),
            layout: gd
        };
        class vd {
            constructor(t1){
                this.type = t1.property.overrides ? t1.property.overrides.runtimeType : ne, this.defaultValue = t1;
            }
            evaluate(t1) {
                if (t1.formattedSection) {
                    const e1 = this.defaultValue.property.overrides;
                    if (e1 && e1.hasOverride(t1.formattedSection)) return e1.getOverride(t1.formattedSection);
                }
                return t1.feature && t1.featureState ? this.defaultValue.evaluate(t1.feature, t1.featureState) : this.defaultValue.property.specification.default;
            }
            eachChild(t1) {
                this.defaultValue.isConstant() || t1(this.defaultValue.value._styleExpression.expression);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                return null;
            }
        }
        ji(vd, "FormatSectionOverride", {
            omit: [
                "defaultValue"
            ]
        });
        class bd extends Io {
            constructor(t1){
                super(t1, xd);
            }
            recalculate(t1, e1) {
                super.recalculate(t1, e1), "auto" === this.layout.get("icon-rotation-alignment") && (this.layout._values["icon-rotation-alignment"] = "point" !== this.layout.get("symbol-placement") ? "map" : "viewport"), "auto" === this.layout.get("text-rotation-alignment") && (this.layout._values["text-rotation-alignment"] = "point" !== this.layout.get("symbol-placement") ? "map" : "viewport"), "auto" === this.layout.get("text-pitch-alignment") && (this.layout._values["text-pitch-alignment"] = this.layout.get("text-rotation-alignment")), "auto" === this.layout.get("icon-pitch-alignment") && (this.layout._values["icon-pitch-alignment"] = this.layout.get("icon-rotation-alignment"));
                const r = this.layout.get("text-writing-mode");
                if (r) {
                    const t2 = [];
                    for (const e2 of r)t2.indexOf(e2) < 0 && t2.push(e2);
                    this.layout._values["text-writing-mode"] = t2;
                } else this.layout._values["text-writing-mode"] = "point" === this.layout.get("symbol-placement") ? [
                    "horizontal"
                ] : [
                    "horizontal",
                    "vertical"
                ];
                this._setPaintOverrides();
            }
            getValueAndResolveTokens(t1, e1, r, n) {
                const i = this.layout.get(t1).evaluate(e1, {}, r, n), s = this._unevaluatedLayout._values[t1];
                return s.isDataDriven() || qn(s.value) || !i ? i : function(t1, e1) {
                    return e1.replace(/{([^{}]+)}/g, (e1, r)=>r in t1 ? String(t1[r]) : "");
                }(e1.properties, i);
            }
            createBucket(t1) {
                return new md(t1);
            }
            queryRadius() {
                return 0;
            }
            queryIntersectsFeature() {
                return !1;
            }
            _setPaintOverrides() {
                for (const t1 of xd.paint.overridableProperties){
                    if (!bd.hasPaintOverride(this.layout, t1)) continue;
                    const e1 = this.paint.get(t1), r = new vd(e1), n = new On(r, e1.property.specification);
                    let i = null;
                    i = "constant" === e1.value.kind || "source" === e1.value.kind ? new Gn("source", n) : new Zn("composite", n, e1.value.zoomStops, e1.value._interpolationType), this.paint._values[t1] = new Zs(e1.property, i, e1.parameters);
                }
            }
            _handleOverridablePaintPropertyUpdate(t1, e1, r) {
                return !(!this.layout || e1.isDataDriven() || r.isDataDriven()) && bd.hasPaintOverride(this.layout, t1);
            }
            static hasPaintOverride(t1, e1) {
                const r = t1.get("text-field"), n = xd.paint.properties[e1];
                let i = !1;
                const s = (t1)=>{
                    for (const e1 of t1)if (n.overrides && n.overrides.hasOverride(e1)) return void (i = !0);
                };
                if ("constant" === r.value.kind && r.value.value instanceof Te) s(r.value.value.sections);
                else if ("source" === r.value.kind) {
                    const t2 = (e1)=>{
                        i || (e1 instanceof Fe && Ce(e1.value) === he ? s(e1.value.sections) : e1 instanceof $e ? s(e1.sections) : e1.eachChild(t2));
                    }, e2 = r.value;
                    e2._styleExpression && t2(e2._styleExpression.expression);
                }
                return i;
            }
            getProgramConfiguration(t1) {
                return new xo(this, t1);
            }
        }
        var _d = {
            paint: new Qs({
                "background-color": new Ks(Ht.paint_background["background-color"]),
                "background-pattern": new Ws(Ht.paint_background["background-pattern"]),
                "background-opacity": new Ks(Ht.paint_background["background-opacity"])
            })
        }, wd = {
            paint: new Qs({
                "raster-opacity": new Ks(Ht.paint_raster["raster-opacity"]),
                "raster-hue-rotate": new Ks(Ht.paint_raster["raster-hue-rotate"]),
                "raster-brightness-min": new Ks(Ht.paint_raster["raster-brightness-min"]),
                "raster-brightness-max": new Ks(Ht.paint_raster["raster-brightness-max"]),
                "raster-saturation": new Ks(Ht.paint_raster["raster-saturation"]),
                "raster-contrast": new Ks(Ht.paint_raster["raster-contrast"]),
                "raster-resampling": new Ks(Ht.paint_raster["raster-resampling"]),
                "raster-fade-duration": new Ks(Ht.paint_raster["raster-fade-duration"])
            })
        };
        class Ad extends Io {
            constructor(t1){
                super(t1, {}), this.implementation = t1;
            }
            is3D() {
                return "3d" === this.implementation.renderingMode;
            }
            hasOffscreenPass() {
                return void 0 !== this.implementation.prerender;
            }
            recalculate() {}
            updateTransitions() {}
            hasTransition() {
                return !1;
            }
            serialize() {}
            onAdd(t1) {
                this.implementation.onAdd && this.implementation.onAdd(t1, t1.painter.context.gl);
            }
            onRemove(t1) {
                this.implementation.onRemove && this.implementation.onRemove(t1, t1.painter.context.gl);
            }
        }
        var Sd = {
            paint: new Qs({
                "sky-type": new Ks(Ht.paint_sky["sky-type"]),
                "sky-atmosphere-sun": new Ks(Ht.paint_sky["sky-atmosphere-sun"]),
                "sky-atmosphere-sun-intensity": new Ks(Ht.paint_sky["sky-atmosphere-sun-intensity"]),
                "sky-gradient-center": new Ks(Ht.paint_sky["sky-gradient-center"]),
                "sky-gradient-radius": new Ks(Ht.paint_sky["sky-gradient-radius"]),
                "sky-gradient": new Js(Ht.paint_sky["sky-gradient"]),
                "sky-atmosphere-halo-color": new Ks(Ht.paint_sky["sky-atmosphere-halo-color"]),
                "sky-atmosphere-color": new Ks(Ht.paint_sky["sky-atmosphere-color"]),
                "sky-opacity": new Ks(Ht.paint_sky["sky-opacity"])
            })
        };
        function kd(t1, e1, r) {
            const n = [
                0,
                0,
                1
            ], i = su([]);
            return ou(i, i, r ? -x(t1) + Math.PI : x(t1)), au(i, i, -x(e1)), Yl(n, n, i), Zl(n, n);
        }
        const Id = {
            circle: class extends Io {
                constructor(t1){
                    super(t1, bl);
                }
                createBucket(t1) {
                    return new rl(t1);
                }
                queryRadius(t1) {
                    const e1 = t1;
                    return yl("circle-radius", this, e1) + yl("circle-stroke-width", this, e1) + ml(this.paint.get("circle-translate"));
                }
                queryIntersectsFeature(t1, e1, r, n, i, s, a, o) {
                    const l = xl(this.paint.get("circle-translate"), this.paint.get("circle-translate-anchor"), s.angle, t1.pixelToTileUnitsFactor), u = this.paint.get("circle-radius").evaluate(e1, r) + this.paint.get("circle-stroke-width").evaluate(e1, r);
                    return fu(t1, n, s, a, o, "map" === this.paint.get("circle-pitch-alignment"), "map" === this.paint.get("circle-pitch-scale"), l, u);
                }
                getProgramIds() {
                    return [
                        "circle"
                    ];
                }
                getProgramConfiguration(t1) {
                    return new xo(this, t1);
                }
            },
            heatmap: class extends Io {
                createBucket(t1) {
                    return new xu(t1);
                }
                constructor(t1){
                    super(t1, Su), this._updateColorRamp();
                }
                _handleSpecialPaintPropertyUpdate(t1) {
                    "heatmap-color" === t1 && this._updateColorRamp();
                }
                _updateColorRamp() {
                    this.colorRamp = ku({
                        expression: this._transitionablePaint._values["heatmap-color"].value.expression,
                        evaluationKey: "heatmapDensity",
                        image: this.colorRamp
                    }), this.colorRampTexture = null;
                }
                resize() {
                    this.heatmapFbo && (this.heatmapFbo.destroy(), this.heatmapFbo = null);
                }
                queryRadius(t1) {
                    return yl("heatmap-radius", this, t1);
                }
                queryIntersectsFeature(t1, e1, r, n, i, s, a, o) {
                    const l = this.paint.get("heatmap-radius").evaluate(e1, r);
                    return fu(t1, n, s, a, o, !0, !0, new d(0, 0), l);
                }
                hasOffscreenPass() {
                    return 0 !== this.paint.get("heatmap-opacity") && "none" !== this.visibility;
                }
                getProgramIds() {
                    return [
                        "heatmap",
                        "heatmapTexture"
                    ];
                }
                getProgramConfiguration(t1) {
                    return new xo(this, t1);
                }
            },
            hillshade: class extends Io {
                constructor(t1){
                    super(t1, Iu);
                }
                hasOffscreenPass() {
                    return 0 !== this.paint.get("hillshade-exaggeration") && "none" !== this.visibility;
                }
                getProgramIds() {
                    return [
                        "hillshade",
                        "hillshadePrepare"
                    ];
                }
            },
            fill: class extends Io {
                constructor(t1){
                    super(t1, pc);
                }
                getProgramIds() {
                    const t1 = this.paint.get("fill-pattern"), e1 = t1 && t1.constantOr(1), r = [
                        e1 ? "fillPattern" : "fill"
                    ];
                    return this.paint.get("fill-antialias") && r.push(e1 && !this.getPaintProperty("fill-outline-color") ? "fillOutlinePattern" : "fillOutline"), r;
                }
                getProgramConfiguration(t1) {
                    return new xo(this, t1);
                }
                recalculate(t1, e1) {
                    super.recalculate(t1, e1);
                    const r = this.paint._values["fill-outline-color"];
                    "constant" === r.value.kind && void 0 === r.value.value && (this.paint._values["fill-outline-color"] = this.paint._values["fill-color"]);
                }
                createBucket(t1) {
                    return new cc(t1);
                }
                queryRadius() {
                    return ml(this.paint.get("fill-translate"));
                }
                queryIntersectsFeature(t1, e1, r, n, i, s) {
                    return !t1.queryGeometry.isAboveHorizon && sl(gl(t1.tilespaceGeometry, this.paint.get("fill-translate"), this.paint.get("fill-translate-anchor"), s.angle, t1.pixelToTileUnitsFactor), n);
                }
                isTileClipped() {
                    return !0;
                }
            },
            "fill-extrusion": class extends Io {
                constructor(t1){
                    super(t1, Xc);
                }
                createBucket(t1) {
                    return new Lc(t1);
                }
                queryRadius() {
                    return ml(this.paint.get("fill-extrusion-translate"));
                }
                is3D() {
                    return !0;
                }
                getProgramIds() {
                    return [
                        this.paint.get("fill-extrusion-pattern").constantOr(1) ? "fillExtrusionPattern" : "fillExtrusion"
                    ];
                }
                getProgramConfiguration(t1) {
                    return new xo(this, t1);
                }
                queryIntersectsFeature(t1, e1, r, n, i, s, a, o, l) {
                    const u = xl(this.paint.get("fill-extrusion-translate"), this.paint.get("fill-extrusion-translate-anchor"), s.angle, t1.pixelToTileUnitsFactor), c = this.paint.get("fill-extrusion-height").evaluate(e1, r), h = this.paint.get("fill-extrusion-base").evaluate(e1, r), p = [
                        0,
                        0
                    ], f = o && s.elevation, y = s.elevation ? s.elevation.exaggeration() : 1, m = t1.tile.getBucket(this);
                    if (f && m instanceof Lc) {
                        const t2 = m.centroidVertexArray, e2 = l + 1;
                        if (e2 < t2.length) {
                            const r1 = t2.get(e2);
                            p[0] = r1.a_centroid_pos0, p[1] = r1.a_centroid_pos1;
                        }
                    }
                    if (0 === p[0] && 1 === p[1]) return !1;
                    "globe" === s.projection.name && (n = Gc([
                        n
                    ], [
                        new d(0, 0),
                        new d(Bo, Bo)
                    ], t1.tileID.canonical).map((t1)=>t1.polygon).flat());
                    const g = f ? o : null, [x, v] = function(t1, e1, r, n, i, s, a, o, l, u, c) {
                        return "globe" === t1.projection.name ? function(t1, e1, r, n, i, s, a, o, l, u, c) {
                            const h = [], p = [], f = t1.projection.upVectorScale(c, t1.center.lat, t1.worldSize).metersToTile, d = [
                                0,
                                0,
                                0,
                                1
                            ], y = [
                                0,
                                0,
                                0,
                                1
                            ], m = (t1, e1, r, n)=>{
                                t1[0] = e1, t1[1] = r, t1[2] = n, t1[3] = 1;
                            }, g = Nc();
                            r > 0 && (r += g), n += g;
                            for (const g1 of e1){
                                const e2 = [], x = [];
                                for (const h1 of g1){
                                    const p1 = h1.x + i.x, g2 = h1.y + i.y, v = t1.projection.projectTilePoint(p1, g2, c), b = t1.projection.upVector(c, h1.x, h1.y);
                                    let _ = r, w = n;
                                    if (a) {
                                        const t2 = rh(p1, g2, r, n, a, o, l, u);
                                        _ += t2.base, w += t2.top;
                                    }
                                    0 !== r ? m(d, v.x + b[0] * f * _, v.y + b[1] * f * _, v.z + b[2] * f * _) : m(d, v.x, v.y, v.z), m(y, v.x + b[0] * f * w, v.y + b[1] * f * w, v.z + b[2] * f * w), Hl(d, d, s), Hl(y, y, s), e2.push(new Qc(d[0], d[1], d[2])), x.push(new Qc(y[0], y[1], y[2]));
                                }
                                h.push(e2), p.push(x);
                            }
                            return [
                                h,
                                p
                            ];
                        }(t1, e1, r, n, i, s, a, o, l, u, c) : a ? function(t1, e1, r, n, i, s, a, o, l) {
                            const u = [], c = [], h = [
                                0,
                                0,
                                0,
                                1
                            ];
                            for (const p of t1){
                                const t2 = [], f = [];
                                for (const u1 of p){
                                    const c1 = u1.x + n.x, p1 = u1.y + n.y, d = rh(c1, p1, e1, r, s, a, o, l);
                                    h[0] = c1, h[1] = p1, h[2] = d.base, h[3] = 1, nu(h, h, i), h[3] = Math.max(h[3], 1e-5);
                                    const y = new Qc(h[0] / h[3], h[1] / h[3], h[2] / h[3]);
                                    h[0] = c1, h[1] = p1, h[2] = d.top, h[3] = 1, nu(h, h, i), h[3] = Math.max(h[3], 1e-5);
                                    const m = new Qc(h[0] / h[3], h[1] / h[3], h[2] / h[3]);
                                    t2.push(y), f.push(m);
                                }
                                u.push(t2), c.push(f);
                            }
                            return [
                                u,
                                c
                            ];
                        }(e1, r, n, i, s, a, o, l, u) : function(t1, e1, r, n, i) {
                            const s = [], a = [], o = i[8] * e1, l = i[9] * e1, u = i[10] * e1, c = i[11] * e1, h = i[8] * r, p = i[9] * r, f = i[10] * r, d = i[11] * r;
                            for (const e2 of t1){
                                const t2 = [], r1 = [];
                                for (const s1 of e2){
                                    const e3 = s1.x + n.x, a1 = s1.y + n.y, y = i[0] * e3 + i[4] * a1 + i[12], m = i[1] * e3 + i[5] * a1 + i[13], g = i[2] * e3 + i[6] * a1 + i[14], x = i[3] * e3 + i[7] * a1 + i[15], v = y + o, b = m + l, _ = g + u, w = Math.max(x + c, 1e-5), A = y + h, S = m + p, k = g + f, I = Math.max(x + d, 1e-5);
                                    t2.push(new Qc(v / w, b / w, _ / w)), r1.push(new Qc(A / I, S / I, k / I));
                                }
                                s.push(t2), a.push(r1);
                            }
                            return [
                                s,
                                a
                            ];
                        }(e1, r, n, i, s);
                    }(s, n, h, c, u, a, g, p, y, s.center.lat, t1.tileID.canonical), b = t1.queryGeometry;
                    return function(t1, e1, r) {
                        let n = 1 / 0;
                        sl(r, e1) && (n = eh(r, e1[0]));
                        for(let i = 0; i < e1.length; i++){
                            const s = e1[i], a = t1[i];
                            for(let t2 = 0; t2 < s.length - 1; t2++){
                                const e2 = s[t2], i1 = [
                                    e2,
                                    s[t2 + 1],
                                    a[t2 + 1],
                                    a[t2],
                                    e2
                                ];
                                nl(r, i1) && (n = Math.min(n, eh(r, i1)));
                            }
                        }
                        return n !== 1 / 0 && n;
                    }(x, v, b.isPointQuery() ? b.screenBounds : b.screenGeometry);
                }
            },
            line: class extends Io {
                constructor(t1){
                    super(t1, hh), this.gradientVersion = 0;
                }
                _handleSpecialPaintPropertyUpdate(t1) {
                    if ("line-gradient" === t1) {
                        const t2 = this._transitionablePaint._values["line-gradient"].value.expression;
                        this.stepInterpolant = t2._styleExpression && t2._styleExpression.expression instanceof kr, this.gradientVersion = (this.gradientVersion + 1) % Number.MAX_SAFE_INTEGER;
                    }
                }
                gradientExpression() {
                    return this._transitionablePaint._values["line-gradient"].value.expression;
                }
                recalculate(t1, e1) {
                    super.recalculate(t1, e1), this.paint._values["line-floorwidth"] = ph.possiblyEvaluate(this._transitioningPaint._values["line-width"].value, t1);
                }
                createBucket(t1) {
                    return new uh(t1);
                }
                getProgramIds() {
                    return [
                        this.paint.get("line-pattern").constantOr(1) ? "linePattern" : "line"
                    ];
                }
                getProgramConfiguration(t1) {
                    return new xo(this, t1);
                }
                queryRadius(t1) {
                    const e1 = t1, r = fh(yl("line-width", this, e1), yl("line-gap-width", this, e1)), n = yl("line-offset", this, e1);
                    return r / 2 + Math.abs(n) + ml(this.paint.get("line-translate"));
                }
                queryIntersectsFeature(t1, e1, r, n, i, s) {
                    if (t1.queryGeometry.isAboveHorizon) return !1;
                    const a = gl(t1.tilespaceGeometry, this.paint.get("line-translate"), this.paint.get("line-translate-anchor"), s.angle, t1.pixelToTileUnitsFactor), o = t1.pixelToTileUnitsFactor / 2 * fh(this.paint.get("line-width").evaluate(e1, r), this.paint.get("line-gap-width").evaluate(e1, r)), l = this.paint.get("line-offset").evaluate(e1, r);
                    return l && (n = function(t1, e1) {
                        const r = [], n = new d(0, 0);
                        for(let i = 0; i < t1.length; i++){
                            const s = t1[i], a = [];
                            for(let t2 = 0; t2 < s.length; t2++){
                                const r1 = s[t2 - 1], i1 = s[t2], o = s[t2 + 1], l = 0 === t2 ? n : i1.sub(r1)._unit()._perp(), u = t2 === s.length - 1 ? n : o.sub(i1)._unit()._perp(), c = l._add(u)._unit();
                                c._mult(1 / (c.x * u.x + c.y * u.y)), a.push(c._mult(e1)._add(i1));
                            }
                            r.push(a);
                        }
                        return r;
                    }(n, l * t1.pixelToTileUnitsFactor)), function(t1, e1, r) {
                        for(let n = 0; n < e1.length; n++){
                            const i = e1[n];
                            if (t1.length >= 3) {
                                for(let e2 = 0; e2 < i.length; e2++)if (pl(t1, i[e2])) return !0;
                            }
                            if (al(t1, i, r)) return !0;
                        }
                        return !1;
                    }(a, n, o);
                }
                isTileClipped() {
                    return !0;
                }
            },
            symbol: bd,
            background: class extends Io {
                constructor(t1){
                    super(t1, _d);
                }
                getProgramIds() {
                    return [
                        this.paint.get("background-pattern") ? "backgroundPattern" : "background"
                    ];
                }
            },
            raster: class extends Io {
                constructor(t1){
                    super(t1, wd);
                }
                getProgramIds() {
                    return [
                        "raster"
                    ];
                }
            },
            sky: class extends Io {
                constructor(t1){
                    super(t1, Sd), this._updateColorRamp();
                }
                _handleSpecialPaintPropertyUpdate(t1) {
                    "sky-gradient" === t1 ? this._updateColorRamp() : "sky-atmosphere-sun" !== t1 && "sky-atmosphere-halo-color" !== t1 && "sky-atmosphere-color" !== t1 && "sky-atmosphere-sun-intensity" !== t1 || (this._skyboxInvalidated = !0);
                }
                _updateColorRamp() {
                    this.colorRamp = ku({
                        expression: this._transitionablePaint._values["sky-gradient"].value.expression,
                        evaluationKey: "skyRadialProgress"
                    }), this.colorRampTexture && (this.colorRampTexture.destroy(), this.colorRampTexture = null);
                }
                needsSkyboxCapture(t1) {
                    if (this._skyboxInvalidated || !this.skyboxTexture || !this.skyboxGeometry) return !0;
                    if (!this.paint.get("sky-atmosphere-sun")) {
                        const e1 = t1.style.light.properties.get("position");
                        return this._lightPosition.azimuthal !== e1.azimuthal || this._lightPosition.polar !== e1.polar;
                    }
                    return !1;
                }
                getCenter(t1, e1) {
                    if ("atmosphere" === this.paint.get("sky-type")) {
                        const r = this.paint.get("sky-atmosphere-sun"), n = !r, i = t1.style.light, s = i.properties.get("position");
                        return n && "viewport" === i.properties.get("anchor") && $("The sun direction is attached to a light with viewport anchor, lighting may behave unexpectedly."), n ? kd(s.azimuthal, 90 - s.polar, e1) : kd(r[0], 90 - r[1], e1);
                    }
                    const r1 = this.paint.get("sky-gradient-center");
                    return kd(r1[0], 90 - r1[1], e1);
                }
                is3D() {
                    return !1;
                }
                isSky() {
                    return !0;
                }
                markSkyboxValid(t1) {
                    this._skyboxInvalidated = !1, this._lightPosition = t1.style.light.properties.get("position");
                }
                hasOffscreenPass() {
                    return !0;
                }
                getProgramIds() {
                    const t1 = this.paint.get("sky-type");
                    return "atmosphere" === t1 ? [
                        "skyboxCapture",
                        "skybox"
                    ] : "gradient" === t1 ? [
                        "skyboxGradient"
                    ] : null;
                }
            }
        };
        class Md {
            constructor(t1, e1, r, n){
                this.context = t1, this.format = r, this.texture = t1.gl.createTexture(), this.update(e1, n);
            }
            update(t1, r, n) {
                const { width: i , height: s  } = t1, { context: a  } = this, { gl: o  } = a, { HTMLImageElement: l , HTMLCanvasElement: u , HTMLVideoElement: c , ImageData: h , ImageBitmap: p  } = e1;
                if (o.bindTexture(o.TEXTURE_2D, this.texture), a.pixelStoreUnpackFlipY.set(!1), a.pixelStoreUnpack.set(1), a.pixelStoreUnpackPremultiplyAlpha.set(this.format === o.RGBA && (!r || !1 !== r.premultiply)), n || this.size && this.size[0] === i && this.size[1] === s) {
                    const { x: e2 , y: r1  } = n || {
                        x: 0,
                        y: 0
                    };
                    t1 instanceof l || t1 instanceof u || t1 instanceof c || t1 instanceof h || p && t1 instanceof p ? o.texSubImage2D(o.TEXTURE_2D, 0, e2, r1, o.RGBA, o.UNSIGNED_BYTE, t1) : o.texSubImage2D(o.TEXTURE_2D, 0, e2, r1, i, s, o.RGBA, o.UNSIGNED_BYTE, t1.data);
                } else this.size = [
                    i,
                    s
                ], t1 instanceof l || t1 instanceof u || t1 instanceof c || t1 instanceof h || p && t1 instanceof p ? o.texImage2D(o.TEXTURE_2D, 0, this.format, this.format, o.UNSIGNED_BYTE, t1) : o.texImage2D(o.TEXTURE_2D, 0, this.format, i, s, 0, this.format, o.UNSIGNED_BYTE, t1.data);
                this.useMipmap = Boolean(r && r.useMipmap && this.isSizePowerOfTwo()), this.useMipmap && o.generateMipmap(o.TEXTURE_2D);
            }
            bind(t1, e1) {
                const { context: r  } = this, { gl: n  } = r;
                n.bindTexture(n.TEXTURE_2D, this.texture), t1 !== this.filter && (n.texParameteri(n.TEXTURE_2D, n.TEXTURE_MAG_FILTER, t1), n.texParameteri(n.TEXTURE_2D, n.TEXTURE_MIN_FILTER, this.useMipmap ? t1 === n.NEAREST ? n.NEAREST_MIPMAP_NEAREST : n.LINEAR_MIPMAP_NEAREST : t1), this.filter = t1), e1 !== this.wrap && (n.texParameteri(n.TEXTURE_2D, n.TEXTURE_WRAP_S, e1), n.texParameteri(n.TEXTURE_2D, n.TEXTURE_WRAP_T, e1), this.wrap = e1);
            }
            isSizePowerOfTwo() {
                return this.size[0] === this.size[1] && Math.log(this.size[0]) / Math.LN2 % 1 == 0;
            }
            destroy() {
                const { gl: t1  } = this.context;
                t1.deleteTexture(this.texture), this.texture = null;
            }
        }
        class zd {
            constructor(t1){
                this._callback = t1, this._triggered = !1, "undefined" != typeof MessageChannel && (this._channel = new MessageChannel, this._channel.port2.onmessage = ()=>{
                    this._triggered = !1, this._callback();
                });
            }
            trigger() {
                this._triggered || (this._triggered = !0, this._channel ? this._channel.port1.postMessage(!0) : setTimeout(()=>{
                    this._triggered = !1, this._callback();
                }, 0));
            }
            remove() {
                this._channel = void 0, this._callback = ()=>{};
            }
        }
        class Td {
            constructor(){
                this.tasks = {}, this.taskQueue = [], V([
                    "process"
                ], this), this.invoker = new zd(this.process), this.nextId = 0;
            }
            add(t1, e1) {
                const r = this.nextId++, n = function({ type: t1 , isSymbolTile: e1 , zoom: r  }) {
                    return r = r || 0, "message" === t1 ? 0 : "maybePrepare" !== t1 || e1 ? "parseTile" !== t1 || e1 ? "parseTile" === t1 && e1 ? 300 - r : "maybePrepare" === t1 && e1 ? 400 - r : 500 : 200 - r : 100 - r;
                }(e1);
                if (0 === n) {
                    N();
                    t1();
                    return {
                        cancel: ()=>{}
                    };
                }
                return this.tasks[r] = {
                    fn: t1,
                    metadata: e1,
                    priority: n,
                    id: r
                }, this.taskQueue.push(r), this.invoker.trigger(), {
                    cancel: ()=>{
                        delete this.tasks[r];
                    }
                };
            }
            process() {
                N();
                {
                    if (this.taskQueue = this.taskQueue.filter((t1)=>!!this.tasks[t1]), !this.taskQueue.length) return;
                    const t1 = this.pick();
                    if (null === t1) return;
                    const e1 = this.tasks[t1];
                    if (delete this.tasks[t1], this.taskQueue.length && this.invoker.trigger(), !e1) return;
                    e1.fn();
                }
            }
            pick() {
                let t1 = null, e1 = 1 / 0;
                for(let r = 0; r < this.taskQueue.length; r++){
                    const n = this.tasks[this.taskQueue[r]];
                    n.priority < e1 && (e1 = n.priority, t1 = r);
                }
                if (null === t1) return null;
                const r1 = this.taskQueue[t1];
                return this.taskQueue.splice(t1, 1), r1;
            }
            remove() {
                this.invoker.remove();
            }
        }
        class Bd {
            constructor(t1){
                this._stringToNumber = {}, this._numberToString = [];
                for(let e1 = 0; e1 < t1.length; e1++){
                    const r = t1[e1];
                    this._stringToNumber[r] = e1, this._numberToString[e1] = r;
                }
            }
            encode(t1) {
                return this._stringToNumber[t1];
            }
            decode(t1) {
                return this._numberToString[t1];
            }
        }
        const Ed = [
            "tile",
            "layer",
            "source",
            "sourceLayer",
            "state"
        ];
        class Pd {
            constructor(t1, e1, r, n, i){
                this.type = "Feature", this._vectorTileFeature = t1, this._z = e1, this._x = r, this._y = n, this.properties = t1.properties, this.id = i;
            }
            get geometry() {
                return void 0 === this._geometry && (this._geometry = this._vectorTileFeature.toGeoJSON(this._x, this._y, this._z).geometry), this._geometry;
            }
            set geometry(t1) {
                this._geometry = t1;
            }
            toJSON() {
                const t1 = {
                    type: "Feature",
                    geometry: this.geometry,
                    properties: this.properties
                };
                void 0 !== this.id && (t1.id = this.id);
                for (const e1 of Ed)void 0 !== this[e1] && (t1[e1] = this[e1]);
                return t1;
            }
        }
        const Cd = 32, Dd = 33, Vd = new Uint16Array(8184);
        for(let t5 = 0; t5 < 2046; t5++){
            let e3 = t5 + 2, r1 = 0, n1 = 0, i1 = 0, s1 = 0, a1 = 0, o1 = 0;
            for(1 & e3 ? i1 = s1 = a1 = Cd : r1 = n1 = o1 = Cd; (e3 >>= 1) > 1;){
                const t6 = r1 + i1 >> 1, l1 = n1 + s1 >> 1;
                1 & e3 ? (i1 = r1, s1 = n1, r1 = a1, n1 = o1) : (r1 = i1, n1 = s1, i1 = a1, s1 = o1), a1 = t6, o1 = l1;
            }
            const l2 = 4 * t5;
            Vd[l2 + 0] = r1, Vd[l2 + 1] = n1, Vd[l2 + 2] = i1, Vd[l2 + 3] = s1;
        }
        const Fd = new Uint16Array(2178), Ld = new Uint8Array(1089), Rd = new Uint16Array(1089);
        function Ud(t1) {
            return 0 === t1 ? -0.03125 : 32 === t1 ? .03125 : 0;
        }
        var jd = ia([
            {
                name: "a_pos",
                type: "Int16",
                components: 2
            },
            {
                name: "a_texture_pos",
                type: "Int16",
                components: 2
            }
        ]);
        const $d = {
            type: 2,
            extent: Bo,
            loadGeometry: ()=>[
                    [
                        new d(0, 0),
                        new d(8193, 0),
                        new d(8193, 8193),
                        new d(0, 8193),
                        new d(0, 0)
                    ]
                ]
        };
        class Od {
            constructor(t1, e1, r, n, i){
                this.tileID = t1, this.uid = E(), this.uses = 0, this.tileSize = e1, this.tileZoom = r, this.buckets = {}, this.expirationTime = null, this.queryPadding = 0, this.hasSymbolBuckets = !1, this.hasRTLText = !1, this.dependencies = {}, this.isRaster = i, this.expiredRequestCount = 0, this.state = "loading", n && n.transform && (this.projection = n.transform.projection);
            }
            registerFadeDuration(t1) {
                const e1 = t1 + this.timeAdded;
                e1 < qt.now() || this.fadeEndTime && e1 < this.fadeEndTime || (this.fadeEndTime = e1);
            }
            wasRequested() {
                return "errored" === this.state || "loaded" === this.state || "reloading" === this.state;
            }
            get tileTransform() {
                return this._tileTransform || (this._tileTransform = jf(this.tileID.canonical, this.projection)), this._tileTransform;
            }
            loadVectorData(t1, e1, r) {
                if (this.unloadVectorData(), this.state = "loaded", t1) {
                    t1.featureIndex && (this.latestFeatureIndex = t1.featureIndex, t1.rawTileData ? (this.latestRawTileData = t1.rawTileData, this.latestFeatureIndex.rawTileData = t1.rawTileData) : this.latestRawTileData && (this.latestFeatureIndex.rawTileData = this.latestRawTileData)), this.collisionBoxArray = t1.collisionBoxArray, this.buckets = function(t1, e1) {
                        const r = {};
                        if (!e1) return r;
                        for (const n of t1){
                            const t2 = n.layerIds.map((t1)=>e1.getLayer(t1)).filter(Boolean);
                            if (0 !== t2.length) {
                                n.layers = t2, n.stateDependentLayerIds && (n.stateDependentLayers = n.stateDependentLayerIds.map((e1)=>t2.filter((t1)=>t1.id === e1)[0]));
                                for (const e2 of t2)r[e2.id] = n;
                            }
                        }
                        return r;
                    }(t1.buckets, e1.style), this.hasSymbolBuckets = !1;
                    for(const t2 in this.buckets){
                        const e2 = this.buckets[t2];
                        if (e2 instanceof md) {
                            if (this.hasSymbolBuckets = !0, !r) break;
                            e2.justReloaded = !0;
                        }
                    }
                    if (this.hasRTLText = !1, this.hasSymbolBuckets) for(const t3 in this.buckets){
                        const e3 = this.buckets[t3];
                        if (e3 instanceof md && e3.hasRTLText) {
                            this.hasRTLText = !0, Rs.isLoading() || Rs.isLoaded() || "deferred" !== Fs() || Ls();
                            break;
                        }
                    }
                    this.queryPadding = 0;
                    for(const t4 in this.buckets){
                        const r1 = this.buckets[t4];
                        this.queryPadding = Math.max(this.queryPadding, e1.style.getLayer(t4).queryRadius(r1));
                    }
                    t1.imageAtlas && (this.imageAtlas = t1.imageAtlas), t1.glyphAtlasImage && (this.glyphAtlasImage = t1.glyphAtlasImage), t1.lineAtlas && (this.lineAtlas = t1.lineAtlas);
                } else this.collisionBoxArray = new Da;
            }
            unloadVectorData() {
                if (this.hasData()) {
                    for(const t1 in this.buckets)this.buckets[t1].destroy();
                    this.buckets = {}, this.imageAtlas && (this.imageAtlas = null), this.lineAtlas && (this.lineAtlas = null), this.imageAtlasTexture && this.imageAtlasTexture.destroy(), this.glyphAtlasTexture && this.glyphAtlasTexture.destroy(), this.lineAtlasTexture && this.lineAtlasTexture.destroy(), this._tileBoundsBuffer && (this._tileBoundsBuffer.destroy(), this._tileBoundsIndexBuffer.destroy(), this._tileBoundsSegments.destroy(), this._tileBoundsBuffer = null), this._tileDebugBuffer && (this._tileDebugBuffer.destroy(), this._tileDebugSegments.destroy(), this._tileDebugBuffer = null), this._tileDebugIndexBuffer && (this._tileDebugIndexBuffer.destroy(), this._tileDebugIndexBuffer = null), this._globeTileDebugBorderBuffer && (this._globeTileDebugBorderBuffer.destroy(), this._globeTileDebugBorderBuffer = null), this._tileDebugTextBuffer && (this._tileDebugTextBuffer.destroy(), this._tileDebugTextSegments.destroy(), this._tileDebugTextIndexBuffer.destroy(), this._tileDebugTextBuffer = null), this._globeTileDebugTextBuffer && (this._globeTileDebugTextBuffer.destroy(), this._globeTileDebugTextBuffer = null), this.latestFeatureIndex = null, this.state = "unloaded";
                }
            }
            getBucket(t1) {
                return this.buckets[t1.id];
            }
            upload(t1) {
                for(const e1 in this.buckets){
                    const r = this.buckets[e1];
                    r.uploadPending() && r.upload(t1);
                }
                const e2 = t1.gl;
                this.imageAtlas && !this.imageAtlas.uploaded && (this.imageAtlasTexture = new Md(t1, this.imageAtlas.image, e2.RGBA), this.imageAtlas.uploaded = !0), this.glyphAtlasImage && (this.glyphAtlasTexture = new Md(t1, this.glyphAtlasImage, e2.ALPHA), this.glyphAtlasImage = null), this.lineAtlas && !this.lineAtlas.uploaded && (this.lineAtlasTexture = new Md(t1, this.lineAtlas.image, e2.ALPHA), this.lineAtlas.uploaded = !0);
            }
            prepare(t1) {
                this.imageAtlas && this.imageAtlas.patchUpdatedImages(t1, this.imageAtlasTexture);
            }
            queryRenderedFeatures(t1, e1, r, n, i, s, a, o) {
                return this.latestFeatureIndex && this.latestFeatureIndex.rawTileData ? this.latestFeatureIndex.query({
                    tileResult: n,
                    pixelPosMatrix: a,
                    transform: s,
                    params: i,
                    tileTransform: this.tileTransform
                }, t1, e1, r) : {};
            }
            querySourceFeatures(t1, e1) {
                const r = this.latestFeatureIndex;
                if (!r || !r.rawTileData) return;
                const n = r.loadVTLayers(), i = e1 ? e1.sourceLayer : "", s = n._geojsonTileLayer || n[i];
                if (!s) return;
                const a = si(e1 && e1.filter), { z: o , x: l , y: u  } = this.tileID.canonical, c = {
                    z: o,
                    x: l,
                    y: u
                };
                for(let e2 = 0; e2 < s.length; e2++){
                    const n1 = s.feature(e2);
                    if (a.needGeometry) {
                        const t2 = Qo(n1, !0);
                        if (!a.filter(new Us(this.tileID.overscaledZ), t2, this.tileID.canonical)) continue;
                    } else if (!a.filter(new Us(this.tileID.overscaledZ), n1)) continue;
                    const h = r.getId(n1, i), p = new Pd(n1, o, l, u, h);
                    p.tile = c, t1.push(p);
                }
            }
            hasData() {
                return "loaded" === this.state || "reloading" === this.state || "expired" === this.state;
            }
            patternsLoaded() {
                return !!this.imageAtlas && !!Object.keys(this.imageAtlas.patternPositions).length;
            }
            setExpiryData(t1) {
                const e1 = this.expirationTime;
                if (t1.cacheControl) {
                    const e2 = G(t1.cacheControl);
                    e2["max-age"] && (this.expirationTime = Date.now() + 1e3 * e2["max-age"]);
                } else t1.expires && (this.expirationTime = new Date(t1.expires).getTime());
                if (this.expirationTime) {
                    const t2 = Date.now();
                    let r = !1;
                    if (this.expirationTime > t2) r = !1;
                    else if (e1) {
                        if (this.expirationTime < e1) r = !0;
                        else {
                            const n = this.expirationTime - e1;
                            n ? this.expirationTime = t2 + Math.max(n, 3e4) : r = !0;
                        }
                    } else r = !0;
                    r ? (this.expiredRequestCount++, this.state = "expired") : this.expiredRequestCount = 0;
                }
            }
            getExpiryTimeout() {
                if (this.expirationTime) return this.expiredRequestCount ? 1e3 * (1 << Math.min(this.expiredRequestCount - 1, 31)) : Math.min(this.expirationTime - (new Date).getTime(), Math.pow(2, 31) - 1);
            }
            setFeatureState(t1, e1) {
                if (!this.latestFeatureIndex || !this.latestFeatureIndex.rawTileData || 0 === Object.keys(t1).length || !e1) return;
                const r = this.latestFeatureIndex.loadVTLayers(), n = e1.style.listImages();
                for(const i in this.buckets){
                    if (!e1.style.hasLayer(i)) continue;
                    const s = this.buckets[i], a = s.layers[0].sourceLayer || "_geojsonTileLayer", o = r[a], l = t1[a];
                    if (!o || !l || 0 === Object.keys(l).length) continue;
                    if (s.update(l, o, n, this.imageAtlas && this.imageAtlas.patternPositions || {}), s instanceof uh || s instanceof cc) {
                        const t2 = e1.style._getSourceCache(s.layers[0].source);
                        e1._terrain && e1._terrain.enabled && t2 && s.programConfigurations.needsUpload && e1._terrain._clearRenderCacheForTile(t2.id, this.tileID);
                    }
                    const u = e1 && e1.style && e1.style.getLayer(i);
                    u && (this.queryPadding = Math.max(this.queryPadding, u.queryRadius(s)));
                }
            }
            holdingForFade() {
                return void 0 !== this.symbolFadeHoldUntil;
            }
            symbolFadeFinished() {
                return !this.symbolFadeHoldUntil || this.symbolFadeHoldUntil < qt.now();
            }
            clearFadeHold() {
                this.symbolFadeHoldUntil = void 0;
            }
            setHoldDuration(t1) {
                this.symbolFadeHoldUntil = qt.now() + t1;
            }
            setTexture(t1, e1) {
                const r = e1.context, n = r.gl;
                this.texture = this.texture || e1.getTileTexture(t1.width), this.texture ? this.texture.update(t1, {
                    useMipmap: !0
                }) : (this.texture = new Md(r, t1, n.RGBA, {
                    useMipmap: !0
                }), this.texture.bind(n.LINEAR, n.CLAMP_TO_EDGE), r.extTextureFilterAnisotropic && n.texParameterf(n.TEXTURE_2D, r.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT, r.extTextureFilterAnisotropicMax));
            }
            setDependencies(t1, e1) {
                const r = {};
                for (const t2 of e1)r[t2] = !0;
                this.dependencies[t1] = r;
            }
            hasDependency(t1, e1) {
                for (const r of t1){
                    const t2 = this.dependencies[r];
                    if (t2) {
                        for (const r1 of e1)if (t2[r1]) return !0;
                    }
                }
                return !1;
            }
            clearQueryDebugViz() {}
            _makeDebugTileBoundsBuffers(t1, e1) {
                if (!e1 || "mercator" === e1.name || this._tileDebugBuffer) return;
                const r = Jo($d, this.tileID.canonical, this.tileTransform)[0], n = new aa, i = new Ta;
                for(let t2 = 0; t2 < r.length; t2++){
                    const { x: e2 , y: s  } = r[t2];
                    n.emplaceBack(e2, s), i.emplaceBack(t2);
                }
                i.emplaceBack(0), this._tileDebugIndexBuffer = t1.createIndexBuffer(i), this._tileDebugBuffer = t1.createVertexBuffer(n, lf.members), this._tileDebugSegments = To.simpleSegment(0, 0, n.length, i.length);
            }
            _makeTileBoundsBuffers(t1, e1) {
                if (this._tileBoundsBuffer || !e1 || "mercator" === e1.name) return;
                const r = Jo($d, this.tileID.canonical, this.tileTransform)[0];
                let n, i;
                if (this.isRaster) {
                    const t2 = function(t1, e1) {
                        const r = jf(t1, e1), n = Math.pow(2, t1.z);
                        for(let i = 0; i < Dd; i++)for(let s = 0; s < Dd; s++){
                            const a = Uo((t1.x + (s + Ud(s)) / Cd) / n), o = jo((t1.y + (i + Ud(i)) / Cd) / n), l = e1.project(a, o), u = i * Dd + s;
                            Fd[2 * u + 0] = Math.round((l.x * r.scale - r.x) * Bo), Fd[2 * u + 1] = Math.round((l.y * r.scale - r.y) * Bo);
                        }
                        Ld.fill(0), Rd.fill(0);
                        for(let t2 = 2045; t2 >= 0; t2--){
                            const e2 = 4 * t2, r1 = Vd[e2 + 0], n1 = Vd[e2 + 1], i1 = Vd[e2 + 2], s1 = Vd[e2 + 3], a1 = r1 + i1 >> 1, o1 = n1 + s1 >> 1, l1 = a1 + o1 - n1, u1 = o1 + r1 - a1, c = n1 * Dd + r1, h = s1 * Dd + i1, p = o1 * Dd + a1, f = Math.hypot((Fd[2 * c + 0] + Fd[2 * h + 0]) / 2 - Fd[2 * p + 0], (Fd[2 * c + 1] + Fd[2 * h + 1]) / 2 - Fd[2 * p + 1]) >= 16;
                            if (Ld[p] = Ld[p] || (f ? 1 : 0), t2 < 1022) {
                                const t3 = (n1 + u1 >> 1) * Dd + (r1 + l1 >> 1), e3 = (s1 + u1 >> 1) * Dd + (i1 + l1 >> 1);
                                Ld[p] = Ld[p] || Ld[t3] || Ld[e3];
                            }
                        }
                        const i2 = new la, s2 = new wa;
                        let a2 = 0;
                        function o2(t1, e1) {
                            const r = e1 * Dd + t1;
                            return 0 === Rd[r] && (i2.emplaceBack(Fd[2 * r + 0], Fd[2 * r + 1], t1 * Bo / Cd, e1 * Bo / Cd), Rd[r] = ++a2), Rd[r] - 1;
                        }
                        function l2(t1, e1, r, n, i, a) {
                            const u = t1 + r >> 1, c = e1 + n >> 1;
                            if (Math.abs(t1 - i) + Math.abs(e1 - a) > 1 && Ld[c * Dd + u]) l2(i, a, t1, e1, u, c), l2(r, n, i, a, u, c);
                            else {
                                const l = o2(t1, e1), u1 = o2(r, n), c1 = o2(i, a);
                                s2.emplaceBack(l, u1, c1);
                            }
                        }
                        return l2(0, 0, Cd, Cd, Cd, 0), l2(Cd, Cd, 0, 0, 0, Cd), {
                            vertices: i2,
                            indices: s2
                        };
                    }(this.tileID.canonical, e1);
                    n = t2.vertices, i = t2.indices;
                } else {
                    n = new la, i = new wa;
                    for (const { x: t3 , y: e2  } of r)n.emplaceBack(t3, e2, 0, 0);
                    const t4 = Tu.exports(n.int16, void 0, 4);
                    for(let e3 = 0; e3 < t4.length; e3 += 3)i.emplaceBack(t4[e3], t4[e3 + 1], t4[e3 + 2]);
                }
                this._tileBoundsBuffer = t1.createVertexBuffer(n, jd.members), this._tileBoundsIndexBuffer = t1.createIndexBuffer(i), this._tileBoundsSegments = To.simpleSegment(0, 0, n.length, i.length);
            }
            _makeGlobeTileDebugBuffers(t1, e1) {
                const r = e1.projection;
                if (!r || "globe" !== r.name || e1.freezeTileCoverage) return;
                const n = this.tileID.canonical, i = Ef(_f(n, e1)), s = Df(e1.zoom);
                let a;
                s > 0 && (a = Il(new Float64Array(16), e1.globeMatrix)), this._makeGlobeTileDebugBorderBuffer(t1, n, e1, i, a, s), this._makeGlobeTileDebugTextBuffer(t1, n, e1, i, a, s);
            }
            _globePoint(t1, e1, r, n, i, s, a) {
                let o = zf(t1, e1, r);
                if (s) {
                    const i1 = 1 << r.z, l = Fo(n.center.lng), u = Lo(n.center.lat), c = (r.x + .5) / i1 - l;
                    let h = 0;
                    c > .5 ? h = -1 : c < -0.5 && (h = 1);
                    let p = (t1 / Bo + r.x) / i1 + h, f = (e1 / Bo + r.y) / i1;
                    p = (p - l) * n._pixelsPerMercatorPixel + l, f = (f - u) * n._pixelsPerMercatorPixel + u;
                    const d = [
                        p * n.worldSize,
                        f * n.worldSize,
                        0
                    ];
                    Hl(d, d, s), o = bf(o, d, a);
                }
                return Hl(o, o, i);
            }
            _makeGlobeTileDebugBorderBuffer(t1, e1, r, n, i, s) {
                const a = new aa, o = new Ta, l = new oa, u = (t1, u, c, h, p)=>{
                    const f = (c - t1) / (p - 1), d = (h - u) / (p - 1), y = a.length;
                    for(let c1 = 0; c1 < p; c1++){
                        const h1 = t1 + c1 * f, p1 = u + c1 * d;
                        a.emplaceBack(h1, p1);
                        const m = this._globePoint(h1, p1, e1, r, n, i, s);
                        l.emplaceBack(m[0], m[1], m[2]), o.emplaceBack(y + c1);
                    }
                }, c = Bo;
                u(0, 0, c, 0, 16), u(c, 0, c, c, 16), u(c, c, 0, c, 16), u(0, c, 0, 0, 16), this._tileDebugIndexBuffer = t1.createIndexBuffer(o), this._tileDebugBuffer = t1.createVertexBuffer(a, lf.members), this._globeTileDebugBorderBuffer = t1.createVertexBuffer(l, of.members), this._tileDebugSegments = To.simpleSegment(0, 0, a.length, o.length);
            }
            _makeGlobeTileDebugTextBuffer(t1, e1, r, n, i, s) {
                const a = new aa, o = new wa, l = new oa, u = 25;
                o.reserve(32), a.reserve(u), l.reserve(u);
                const c = (t1, e1)=>u * t1 + e1;
                for(let t2 = 0; t2 < u; t2++){
                    const o1 = 2048 * t2;
                    for(let t3 = 0; t3 < u; t3++){
                        const u1 = 2048 * t3;
                        a.emplaceBack(u1, o1);
                        const c1 = this._globePoint(u1, o1, e1, r, n, i, s);
                        l.emplaceBack(c1[0], c1[1], c1[2]);
                    }
                }
                for(let t4 = 0; t4 < 4; t4++)for(let e2 = 0; e2 < 4; e2++){
                    const r1 = c(t4, e2), n1 = c(t4, e2 + 1), i1 = c(t4 + 1, e2), s1 = c(t4 + 1, e2 + 1);
                    o.emplaceBack(r1, n1, i1), o.emplaceBack(i1, n1, s1);
                }
                this._tileDebugTextIndexBuffer = t1.createIndexBuffer(o), this._tileDebugTextBuffer = t1.createVertexBuffer(a, lf.members), this._globeTileDebugTextBuffer = t1.createVertexBuffer(l, of.members), this._tileDebugTextSegments = To.simpleSegment(0, 0, u, 32);
            }
        }
        class qd {
            constructor(){
                this.state = {}, this.stateChanges = {}, this.deletedStates = {};
            }
            updateState(t1, e1, r) {
                const n = String(e1);
                if (this.stateChanges[t1] = this.stateChanges[t1] || {}, this.stateChanges[t1][n] = this.stateChanges[t1][n] || {}, T(this.stateChanges[t1][n], r), null === this.deletedStates[t1]) {
                    this.deletedStates[t1] = {};
                    for(const e2 in this.state[t1])e2 !== n && (this.deletedStates[t1][e2] = null);
                } else if (this.deletedStates[t1] && null === this.deletedStates[t1][n]) {
                    this.deletedStates[t1][n] = {};
                    for(const e3 in this.state[t1][n])r[e3] || (this.deletedStates[t1][n][e3] = null);
                } else for(const e4 in r)this.deletedStates[t1] && this.deletedStates[t1][n] && null === this.deletedStates[t1][n][e4] && delete this.deletedStates[t1][n][e4];
            }
            removeFeatureState(t1, e1, r) {
                if (null === this.deletedStates[t1]) return;
                const n = String(e1);
                if (this.deletedStates[t1] = this.deletedStates[t1] || {}, r && void 0 !== e1) null !== this.deletedStates[t1][n] && (this.deletedStates[t1][n] = this.deletedStates[t1][n] || {}, this.deletedStates[t1][n][r] = null);
                else if (void 0 !== e1) {
                    if (this.stateChanges[t1] && this.stateChanges[t1][n]) for(r in this.deletedStates[t1][n] = {}, this.stateChanges[t1][n])this.deletedStates[t1][n][r] = null;
                    else this.deletedStates[t1][n] = null;
                } else this.deletedStates[t1] = null;
            }
            getState(t1, e1) {
                const r = String(e1), n = T({}, (this.state[t1] || {})[r], (this.stateChanges[t1] || {})[r]);
                if (null === this.deletedStates[t1]) return {};
                if (this.deletedStates[t1]) {
                    const r1 = this.deletedStates[t1][e1];
                    if (null === r1) return {};
                    for(const t2 in r1)delete n[t2];
                }
                return n;
            }
            initializeTileState(t1, e1) {
                t1.setFeatureState(this.state, e1);
            }
            coalesceChanges(t1, e1) {
                const r = {};
                for(const t2 in this.stateChanges){
                    this.state[t2] = this.state[t2] || {};
                    const e2 = {};
                    for(const r1 in this.stateChanges[t2])this.state[t2][r1] || (this.state[t2][r1] = {}), T(this.state[t2][r1], this.stateChanges[t2][r1]), e2[r1] = this.state[t2][r1];
                    r[t2] = e2;
                }
                for(const t3 in this.deletedStates){
                    this.state[t3] = this.state[t3] || {};
                    const e3 = {};
                    if (null === this.deletedStates[t3]) for(const r2 in this.state[t3])e3[r2] = {}, this.state[t3][r2] = {};
                    else for(const r3 in this.deletedStates[t3]){
                        if (null === this.deletedStates[t3][r3]) this.state[t3][r3] = {};
                        else for (const e4 of Object.keys(this.deletedStates[t3][r3]))delete this.state[t3][r3][e4];
                        e3[r3] = this.state[t3][r3];
                    }
                    r[t3] = r[t3] || {}, T(r[t3], e3);
                }
                if (this.stateChanges = {}, this.deletedStates = {}, 0 !== Object.keys(r).length) for(const n in t1)t1[n].setFeatureState(r, e1);
            }
        }
        class Nd {
            constructor(t1){
                this.size = t1, this.minimums = [], this.maximums = [], this.leaves = [];
            }
            getElevation(t1, e1) {
                const r = this.toIdx(t1, e1);
                return {
                    min: this.minimums[r],
                    max: this.maximums[r]
                };
            }
            isLeaf(t1, e1) {
                return this.leaves[this.toIdx(t1, e1)];
            }
            toIdx(t1, e1) {
                return e1 * this.size + t1;
            }
        }
        function Gd(t1, e1, r, n) {
            let i = 0, s = Number.MAX_VALUE;
            for(let a = 0; a < 3; a++)if (Math.abs(n[a]) < 1e-15) {
                if (r[a] < t1[a] || r[a] > e1[a]) return null;
            } else {
                const o = 1 / n[a];
                let l = (t1[a] - r[a]) * o, u = (e1[a] - r[a]) * o;
                if (l > u) {
                    const t2 = l;
                    l = u, u = t2;
                }
                if (l > i && (i = l), u < s && (s = u), i > s) return null;
            }
            return i;
        }
        function Zd(t1, e1, r, n, i, s, a, o, l, u, c) {
            const h = n - t1, p = i - e1, f = s - r, d = a - t1, y = o - e1, m = l - r, g = c[1] * m - c[2] * y, x = c[2] * d - c[0] * m, v = c[0] * y - c[1] * d, b = h * g + p * x + f * v;
            if (Math.abs(b) < 1e-15) return null;
            const _ = 1 / b, w = u[0] - t1, A = u[1] - e1, S = u[2] - r, k = (w * g + A * x + S * v) * _;
            if (k < 0 || k > 1) return null;
            const I = A * f - S * p, M = S * h - w * f, z = w * p - A * h, T = (c[0] * I + c[1] * M + c[2] * z) * _;
            return T < 0 || k + T > 1 ? null : (d * I + y * M + m * z) * _;
        }
        function Xd(t1, e1, r) {
            return (t1 - e1) / (r - e1);
        }
        function Kd(t1, e1, r, n, i, s, a, o, l) {
            const u = 1 << r, c = s - n, h = a - i, p = (t1 + 1) / u * c + n, f = (e1 + 0) / u * h + i, d = (e1 + 1) / u * h + i;
            o[0] = (t1 + 0) / u * c + n, o[1] = f, l[0] = p, l[1] = d;
        }
        class Hd {
            constructor(t1){
                if (this.maximums = [], this.minimums = [], this.leaves = [], this.childOffsets = [], this.nodeCount = 0, this.dem = t1, this._siblingOffset = [
                    [
                        0,
                        0
                    ],
                    [
                        1,
                        0
                    ],
                    [
                        0,
                        1
                    ],
                    [
                        1,
                        1
                    ]
                ], !this.dem) return;
                const e1 = function(t1) {
                    const e1 = Math.ceil(Math.log2(t1.dim / 8)), r = [];
                    let n = Math.ceil(Math.pow(2, e1));
                    const i = 1 / n, s = (t1, e1, r, n, i)=>{
                        const s = n ? 1 : 0, a = (t1 + 1) * r - s, o = e1 * r, l = (e1 + 1) * r - s;
                        i[0] = t1 * r, i[1] = o, i[2] = a, i[3] = l;
                    };
                    let a = new Nd(n);
                    const o = [];
                    for(let e2 = 0; e2 < n * n; e2++){
                        s(e2 % n, Math.floor(e2 / n), i, !1, o);
                        const r1 = Wd(o[0], o[1], t1), l = Wd(o[2], o[1], t1), u = Wd(o[2], o[3], t1), c = Wd(o[0], o[3], t1);
                        a.minimums.push(Math.min(r1, l, u, c)), a.maximums.push(Math.max(r1, l, u, c)), a.leaves.push(1);
                    }
                    for(r.push(a), n /= 2; n >= 1; n /= 2){
                        const t2 = r[r.length - 1];
                        a = new Nd(n);
                        for(let e3 = 0; e3 < n * n; e3++){
                            s(e3 % n, Math.floor(e3 / n), 2, !0, o);
                            const r2 = t2.getElevation(o[0], o[1]), i1 = t2.getElevation(o[2], o[1]), l1 = t2.getElevation(o[2], o[3]), u1 = t2.getElevation(o[0], o[3]), c1 = t2.isLeaf(o[0], o[1]), h = t2.isLeaf(o[2], o[1]), p = t2.isLeaf(o[2], o[3]), f = t2.isLeaf(o[0], o[3]), d = Math.min(r2.min, i1.min, l1.min, u1.min), y = Math.max(r2.max, i1.max, l1.max, u1.max), m = c1 && h && p && f;
                            a.maximums.push(y), a.minimums.push(d), a.leaves.push(y - d <= 5 && m ? 1 : 0);
                        }
                        r.push(a);
                    }
                    return r;
                }(this.dem), r = e1.length - 1, n = e1[r];
                this._addNode(n.minimums[0], n.maximums[0], n.leaves[0]), this._construct(e1, 0, 0, r, 0);
            }
            raycastRoot(t1, e1, r, n, i, s, a = 1) {
                return Gd([
                    t1,
                    e1,
                    -100
                ], [
                    r,
                    n,
                    this.maximums[0] * a
                ], i, s);
            }
            raycast(t1, e1, r, n, i, s, a = 1) {
                if (!this.nodeCount) return null;
                const o = this.raycastRoot(t1, e1, r, n, i, s, a);
                if (null == o) return null;
                const l = [], u = [], c = [], h = [], p = [
                    {
                        idx: 0,
                        t: o,
                        nodex: 0,
                        nodey: 0,
                        depth: 0
                    }
                ];
                for(; p.length > 0;){
                    const { idx: o1 , t: f , nodex: d , nodey: y , depth: m  } = p.pop();
                    if (this.leaves[o1]) {
                        Kd(d, y, m, t1, e1, r, n, c, h);
                        const o2 = 1 << m, l1 = (d + 0) / o2, u1 = (d + 1) / o2, p1 = (y + 0) / o2, g = (y + 1) / o2, x = Wd(l1, p1, this.dem) * a, v = Wd(u1, p1, this.dem) * a, b = Wd(u1, g, this.dem) * a, _ = Wd(l1, g, this.dem) * a, w = Zd(c[0], c[1], x, h[0], c[1], v, h[0], h[1], b, i, s), A = Zd(h[0], h[1], b, c[0], h[1], _, c[0], c[1], x, i, s), S = Math.min(null !== w ? w : Number.MAX_VALUE, null !== A ? A : Number.MAX_VALUE);
                        if (S !== Number.MAX_VALUE) return S;
                        {
                            const t2 = Gl([], i, s, f);
                            if (Yd(x, v, _, b, Xd(t2[0], c[0], h[0]), Xd(t2[1], c[1], h[1])) >= t2[2]) return f;
                        }
                        continue;
                    }
                    let g1 = 0;
                    for(let p2 = 0; p2 < this._siblingOffset.length; p2++){
                        Kd((d << 1) + this._siblingOffset[p2][0], (y << 1) + this._siblingOffset[p2][1], m + 1, t1, e1, r, n, c, h), c[2] = -100, h[2] = this.maximums[this.childOffsets[o1] + p2] * a;
                        const f1 = Gd(c, h, i, s);
                        if (null != f1) {
                            const t3 = f1;
                            l[p2] = t3;
                            let e2 = !1;
                            for(let r1 = 0; r1 < g1 && !e2; r1++)t3 >= l[u[r1]] && (u.splice(r1, 0, p2), e2 = !0);
                            e2 || (u[g1] = p2), g1++;
                        }
                    }
                    for(let t4 = 0; t4 < g1; t4++){
                        const e3 = u[t4];
                        p.push({
                            idx: this.childOffsets[o1] + e3,
                            t: l[e3],
                            nodex: (d << 1) + this._siblingOffset[e3][0],
                            nodey: (y << 1) + this._siblingOffset[e3][1],
                            depth: m + 1
                        });
                    }
                }
                return null;
            }
            _addNode(t1, e1, r) {
                return this.minimums.push(t1), this.maximums.push(e1), this.leaves.push(r), this.childOffsets.push(0), this.nodeCount++;
            }
            _construct(t1, e1, r, n, i) {
                if (1 === t1[n].isLeaf(e1, r)) return;
                this.childOffsets[i] || (this.childOffsets[i] = this.nodeCount);
                const s = n - 1, a = t1[s];
                let o = 0, l = 0;
                for(let t2 = 0; t2 < this._siblingOffset.length; t2++){
                    const n1 = 2 * e1 + this._siblingOffset[t2][0], i1 = 2 * r + this._siblingOffset[t2][1], s1 = a.getElevation(n1, i1), u = a.isLeaf(n1, i1), c = this._addNode(s1.min, s1.max, u);
                    u && (o |= 1 << t2), l || (l = c);
                }
                for(let n2 = 0; n2 < this._siblingOffset.length; n2++)o & 1 << n2 || this._construct(t1, 2 * e1 + this._siblingOffset[n2][0], 2 * r + this._siblingOffset[n2][1], s, l + n2);
            }
        }
        function Yd(t1, e1, r, n, i, s) {
            return Ir(Ir(t1, r, s), Ir(e1, n, s), i);
        }
        function Wd(t1, e1, r) {
            const n = r.dim, i = S(t1 * n - .5, 0, n - 1), s = S(e1 * n - .5, 0, n - 1), a = Math.floor(i), o = Math.floor(s), l = Math.min(a + 1, n - 1), u = Math.min(o + 1, n - 1);
            return Yd(r.get(a, o), r.get(l, o), r.get(a, u), r.get(l, u), i - a, s - o);
        }
        const Jd = {
            mapbox: [
                6553.6,
                25.6,
                .1,
                1e4
            ],
            terrarium: [
                256,
                1,
                1 / 256,
                32768
            ]
        };
        class Qd {
            get tree() {
                return this._tree || this._buildQuadTree(), this._tree;
            }
            constructor(t1, e1, r, n = !1, i = !1){
                if (this.uid = t1, e1.height !== e1.width) throw new RangeError("DEM tiles must be square");
                if (r && "mapbox" !== r && "terrarium" !== r) return $(`"${r}" is not a valid encoding type. Valid types include "mapbox" and "terrarium".`);
                this.stride = e1.height;
                const s = this.dim = e1.height - 2, a = new Uint32Array(e1.data.buffer);
                if (this.pixels = new Uint8Array(e1.data.buffer), this.encoding = r || "mapbox", this.borderReady = n, !n) {
                    for(let t2 = 0; t2 < s; t2++)a[this._idx(-1, t2)] = a[this._idx(0, t2)], a[this._idx(s, t2)] = a[this._idx(s - 1, t2)], a[this._idx(t2, -1)] = a[this._idx(t2, 0)], a[this._idx(t2, s)] = a[this._idx(t2, s - 1)];
                    a[this._idx(-1, -1)] = a[this._idx(0, 0)], a[this._idx(s, -1)] = a[this._idx(s - 1, 0)], a[this._idx(-1, s)] = a[this._idx(0, s - 1)], a[this._idx(s, s)] = a[this._idx(s - 1, s - 1)], i && this._buildQuadTree();
                }
            }
            _buildQuadTree() {
                this._tree = new Hd(this);
            }
            get(t1, e1, r = !1) {
                r && (t1 = S(t1, -1, this.dim), e1 = S(e1, -1, this.dim));
                const n = 4 * this._idx(t1, e1);
                return ("terrarium" === this.encoding ? this._unpackTerrarium : this._unpackMapbox)(this.pixels[n], this.pixels[n + 1], this.pixels[n + 2]);
            }
            static getUnpackVector(t1) {
                return Jd[t1];
            }
            get unpackVector() {
                return Jd[this.encoding];
            }
            _idx(t1, e1) {
                if (t1 < -1 || t1 >= this.dim + 1 || e1 < -1 || e1 >= this.dim + 1) throw new RangeError("out of range source coordinates for DEM data");
                return (e1 + 1) * this.stride + (t1 + 1);
            }
            _unpackMapbox(t1, e1, r) {
                return (256 * t1 * 256 + 256 * e1 + r) / 10 - 1e4;
            }
            _unpackTerrarium(t1, e1, r) {
                return 256 * t1 + e1 + r / 256 - 32768;
            }
            static pack(t1, e1) {
                const r = [
                    0,
                    0,
                    0,
                    0
                ], n = Qd.getUnpackVector(e1);
                let i = Math.floor((t1 + n[3]) / n[2]);
                return r[2] = i % 256, i = Math.floor(i / 256), r[1] = i % 256, i = Math.floor(i / 256), r[0] = i, r;
            }
            getPixels() {
                return new Au({
                    width: this.stride,
                    height: this.stride
                }, this.pixels);
            }
            backfillBorder(t1, e1, r) {
                if (this.dim !== t1.dim) throw new Error("dem dimension mismatch");
                let n = e1 * this.dim, i = e1 * this.dim + this.dim, s = r * this.dim, a = r * this.dim + this.dim;
                switch(e1){
                    case -1:
                        n = i - 1;
                        break;
                    case 1:
                        i = n + 1;
                }
                switch(r){
                    case -1:
                        s = a - 1;
                        break;
                    case 1:
                        a = s + 1;
                }
                const o = -e1 * this.dim, l = -r * this.dim;
                for(let e2 = s; e2 < a; e2++)for(let r1 = n; r1 < i; r1++){
                    const n1 = 4 * this._idx(r1, e2), i1 = 4 * this._idx(r1 + o, e2 + l);
                    this.pixels[n1 + 0] = t1.pixels[i1 + 0], this.pixels[n1 + 1] = t1.pixels[i1 + 1], this.pixels[n1 + 2] = t1.pixels[i1 + 2], this.pixels[n1 + 3] = t1.pixels[i1 + 3];
                }
            }
            onDeserialize() {
                this._tree && (this._tree.dem = this);
            }
        }
        ji(Qd, "DEMData"), ji(Hd, "DemMinMaxQuadTree", {
            omit: [
                "dem"
            ]
        });
        class ty {
            constructor(t1, e1){
                this.max = t1, this.onRemove = e1, this.reset();
            }
            reset() {
                for(const t1 in this.data)for (const e1 of this.data[t1])e1.timeout && clearTimeout(e1.timeout), this.onRemove(e1.value);
                return this.data = {}, this.order = [], this;
            }
            add(t1, e1, r) {
                const n = t1.wrapped().key;
                void 0 === this.data[n] && (this.data[n] = []);
                const i = {
                    value: e1,
                    timeout: void 0
                };
                if (void 0 !== r && (i.timeout = setTimeout(()=>{
                    this.remove(t1, i);
                }, r)), this.data[n].push(i), this.order.push(n), this.order.length > this.max) {
                    const t2 = this._getAndRemoveByKey(this.order[0]);
                    t2 && this.onRemove(t2);
                }
                return this;
            }
            has(t1) {
                return t1.wrapped().key in this.data;
            }
            getAndRemove(t1) {
                return this.has(t1) ? this._getAndRemoveByKey(t1.wrapped().key) : null;
            }
            _getAndRemoveByKey(t1) {
                const e1 = this.data[t1].shift();
                return e1.timeout && clearTimeout(e1.timeout), 0 === this.data[t1].length && delete this.data[t1], this.order.splice(this.order.indexOf(t1), 1), e1.value;
            }
            getByKey(t1) {
                const e1 = this.data[t1];
                return e1 ? e1[0].value : null;
            }
            get(t1) {
                return this.has(t1) ? this.data[t1.wrapped().key][0].value : null;
            }
            remove(t1, e1) {
                if (!this.has(t1)) return this;
                const r = t1.wrapped().key, n = void 0 === e1 ? 0 : this.data[r].indexOf(e1), i = this.data[r][n];
                return this.data[r].splice(n, 1), i.timeout && clearTimeout(i.timeout), 0 === this.data[r].length && delete this.data[r], this.onRemove(i.value), this.order.splice(this.order.indexOf(r), 1), this;
            }
            setMaxSize(t1) {
                for(this.max = t1; this.order.length > this.max;){
                    const t2 = this._getAndRemoveByKey(this.order[0]);
                    t2 && this.onRemove(t2);
                }
                return this;
            }
            filter(t1) {
                const e1 = [];
                for(const r in this.data)for (const n of this.data[r])t1(n.value) || e1.push(n);
                for (const t2 of e1)this.remove(t2.value.tileID, t2);
            }
        }
        class ey {
            constructor(t1, e1, r){
                this.func = t1, this.mask = e1, this.range = r;
            }
        }
        ey.ReadOnly = !1, ey.ReadWrite = !0, ey.disabled = new ey(519, ey.ReadOnly, [
            0,
            1
        ]);
        const ry = 7680;
        class ny {
            constructor(t1, e1, r, n, i, s){
                this.test = t1, this.ref = e1, this.mask = r, this.fail = n, this.depthFail = i, this.pass = s;
            }
        }
        ny.disabled = new ny({
            func: 519,
            mask: 0
        }, 0, 0, ry, ry, ry);
        class iy {
            constructor(t1, e1, r){
                this.blendFunction = t1, this.blendColor = e1, this.mask = r;
            }
        }
        iy.Replace = [
            1,
            0
        ], iy.disabled = new iy(iy.Replace, Ie.transparent, [
            !1,
            !1,
            !1,
            !1
        ]), iy.unblended = new iy(iy.Replace, Ie.transparent, [
            !0,
            !0,
            !0,
            !0
        ]), iy.alphaBlended = new iy([
            1,
            771
        ], Ie.transparent, [
            !0,
            !0,
            !0,
            !0
        ]);
        const sy = 1029, ay = 2305;
        class oy {
            constructor(t1, e1, r){
                this.enable = t1, this.mode = e1, this.frontFace = r;
            }
        }
        oy.disabled = new oy(!1, sy, ay), oy.backCCW = new oy(!0, sy, ay), oy.backCW = new oy(!0, sy, 2304), oy.frontCW = new oy(!0, 1028, 2304), oy.frontCCW = new oy(!0, 1028, ay);
        class ly extends Kt {
            constructor(t1, e1, r){
                super(), this.id = t1, this._onlySymbols = r, e1.on("data", (t1)=>{
                    "source" === t1.dataType && "metadata" === t1.sourceDataType && (this._sourceLoaded = !0), this._sourceLoaded && !this._paused && "source" === t1.dataType && "content" === t1.sourceDataType && (this.reload(), this.transform && this.update(this.transform));
                }), e1.on("error", ()=>{
                    this._sourceErrored = !0;
                }), this._source = e1, this._tiles = {}, this._cache = new ty(0, this._unloadTile.bind(this)), this._timers = {}, this._cacheTimers = {}, this._minTileCacheSize = e1.minTileCacheSize, this._maxTileCacheSize = e1.maxTileCacheSize, this._loadedParentTiles = {}, this._coveredTiles = {}, this._state = new qd, this._isRaster = "raster" === this._source.type || "raster-dem" === this._source.type || "custom" === this._source.type && "raster" === this._source._dataType;
            }
            onAdd(t1) {
                this.map = t1, this._minTileCacheSize = void 0 === this._minTileCacheSize && t1 ? t1._minTileCacheSize : this._minTileCacheSize, this._maxTileCacheSize = void 0 === this._maxTileCacheSize && t1 ? t1._maxTileCacheSize : this._maxTileCacheSize;
            }
            loaded() {
                if (this._sourceErrored) return !0;
                if (!this._sourceLoaded) return !1;
                if (!this._source.loaded()) return !1;
                for(const t1 in this._tiles){
                    const e1 = this._tiles[t1];
                    if ("loaded" !== e1.state && "errored" !== e1.state) return !1;
                }
                return !0;
            }
            getSource() {
                return this._source;
            }
            pause() {
                this._paused = !0;
            }
            resume() {
                if (!this._paused) return;
                const t1 = this._shouldReloadOnResume;
                this._paused = !1, this._shouldReloadOnResume = !1, t1 && this.reload(), this.transform && this.update(this.transform);
            }
            _loadTile(t1, e1) {
                return t1.isSymbolTile = this._onlySymbols, this._source.loadTile(t1, e1);
            }
            _unloadTile(t1) {
                if (this._source.unloadTile) return this._source.unloadTile(t1, ()=>{});
            }
            _abortTile(t1) {
                if (this._source.abortTile) return this._source.abortTile(t1, ()=>{});
            }
            serialize() {
                return this._source.serialize();
            }
            prepare(t1) {
                this._source.prepare && this._source.prepare(), this._state.coalesceChanges(this._tiles, this.map ? this.map.painter : null);
                for(const e1 in this._tiles){
                    const r = this._tiles[e1];
                    r.upload(t1), r.prepare(this.map.style.imageManager);
                }
            }
            getIds() {
                return z(this._tiles).map((t1)=>t1.tileID).sort(uy).map((t1)=>t1.key);
            }
            getRenderableIds(t1) {
                const e1 = [];
                for(const r in this._tiles)this._isIdRenderable(+r, t1) && e1.push(this._tiles[r]);
                return t1 ? e1.sort((t1, e1)=>{
                    const r = t1.tileID, n = e1.tileID, i = new d(r.canonical.x, r.canonical.y)._rotate(this.transform.angle), s = new d(n.canonical.x, n.canonical.y)._rotate(this.transform.angle);
                    return r.overscaledZ - n.overscaledZ || s.y - i.y || s.x - i.x;
                }).map((t1)=>t1.tileID.key) : e1.map((t1)=>t1.tileID).sort(uy).map((t1)=>t1.key);
            }
            hasRenderableParent(t1) {
                const e1 = this.findLoadedParent(t1, 0);
                return !!e1 && this._isIdRenderable(e1.tileID.key);
            }
            _isIdRenderable(t1, e1) {
                return this._tiles[t1] && this._tiles[t1].hasData() && !this._coveredTiles[t1] && (e1 || !this._tiles[t1].holdingForFade());
            }
            reload() {
                if (this._paused) this._shouldReloadOnResume = !0;
                else {
                    this._cache.reset();
                    for(const t1 in this._tiles)"errored" !== this._tiles[t1].state && this._reloadTile(+t1, "reloading");
                }
            }
            _reloadTile(t1, e1) {
                const r = this._tiles[t1];
                r && ("loading" !== r.state && (r.state = e1), this._loadTile(r, this._tileLoaded.bind(this, r, t1, e1)));
            }
            _tileLoaded(t1, e1, r, n) {
                if (n) {
                    if (t1.state = "errored", 404 !== n.status) this._source.fire(new Xt(n, {
                        tile: t1
                    }));
                    else if ("raster-dem" === this._source.type && this.usedForTerrain && this.map.painter.terrain) {
                        const t2 = this.map.painter.terrain;
                        this.update(this.transform, t2.getScaledDemTileSize(), !0), t2.resetTileLookupCache(this.id);
                    } else this.update(this.transform);
                } else t1.timeAdded = qt.now(), "expired" === r && (t1.refreshedUponExpiration = !0), this._setTileReloadTimer(e1, t1), "raster-dem" === this._source.type && t1.dem && this._backfillDEM(t1), this._state.initializeTileState(t1, this.map ? this.map.painter : null), this._source.fire(new Zt("data", {
                    dataType: "source",
                    tile: t1,
                    coord: t1.tileID,
                    sourceCacheId: this.id
                }));
            }
            _backfillDEM(t1) {
                const e1 = this.getRenderableIds();
                for(let n = 0; n < e1.length; n++){
                    const i = e1[n];
                    if (t1.neighboringTiles && t1.neighboringTiles[i]) {
                        const e2 = this.getTileByID(i);
                        r(t1, e2), r(e2, t1);
                    }
                }
                function r(t1, e1) {
                    if (!t1.dem || t1.dem.borderReady) return;
                    t1.needsHillshadePrepare = !0, t1.needsDEMTextureUpload = !0;
                    let r = e1.tileID.canonical.x - t1.tileID.canonical.x;
                    const n = e1.tileID.canonical.y - t1.tileID.canonical.y, i = Math.pow(2, t1.tileID.canonical.z), s = e1.tileID.key;
                    0 === r && 0 === n || Math.abs(n) > 1 || (Math.abs(r) > 1 && (1 === Math.abs(r + i) ? r += i : 1 === Math.abs(r - i) && (r -= i)), e1.dem && t1.dem && (t1.dem.backfillBorder(e1.dem, r, n), t1.neighboringTiles && t1.neighboringTiles[s] && (t1.neighboringTiles[s].backfilled = !0)));
                }
            }
            getTile(t1) {
                return this.getTileByID(t1.key);
            }
            getTileByID(t1) {
                return this._tiles[t1];
            }
            _retainLoadedChildren(t1, e1, r, n) {
                for(const i in this._tiles){
                    let s = this._tiles[i];
                    if (n[i] || !s.hasData() || s.tileID.overscaledZ <= e1 || s.tileID.overscaledZ > r) continue;
                    let a = s.tileID;
                    for(; s && s.tileID.overscaledZ > e1 + 1;){
                        const t2 = s.tileID.scaledTo(s.tileID.overscaledZ - 1);
                        s = this._tiles[t2.key], s && s.hasData() && (a = t2);
                    }
                    let o = a;
                    for(; o.overscaledZ > e1;)if (o = o.scaledTo(o.overscaledZ - 1), t1[o.key]) {
                        n[a.key] = a;
                        break;
                    }
                }
            }
            findLoadedParent(t1, e1) {
                if (t1.key in this._loadedParentTiles) {
                    const r = this._loadedParentTiles[t1.key];
                    return r && r.tileID.overscaledZ >= e1 ? r : null;
                }
                for(let r1 = t1.overscaledZ - 1; r1 >= e1; r1--){
                    const e2 = t1.scaledTo(r1), n = this._getLoadedTile(e2);
                    if (n) return n;
                }
            }
            _getLoadedTile(t1) {
                const e1 = this._tiles[t1.key];
                return e1 && e1.hasData() ? e1 : this._cache.getByKey(this._source.reparseOverscaled ? t1.wrapped().key : t1.canonical.key);
            }
            updateCacheSize(t1, e1) {
                e1 = e1 || this._source.tileSize;
                const r = Math.ceil(t1.width / e1) + 1, n = Math.ceil(t1.height / e1) + 1, i = Math.floor(r * n * 5), s = "number" == typeof this._minTileCacheSize ? Math.max(this._minTileCacheSize, i) : i, a = "number" == typeof this._maxTileCacheSize ? Math.min(this._maxTileCacheSize, s) : s;
                this._cache.setMaxSize(a);
            }
            handleWrapJump(t1) {
                const e1 = Math.round((t1 - (void 0 === this._prevLng ? t1 : this._prevLng)) / 360);
                if (this._prevLng = t1, e1) {
                    const t2 = {};
                    for(const r in this._tiles){
                        const n = this._tiles[r];
                        n.tileID = n.tileID.unwrapTo(n.tileID.wrap + e1), t2[n.tileID.key] = n;
                    }
                    this._tiles = t2;
                    for(const t3 in this._timers)clearTimeout(this._timers[t3]), delete this._timers[t3];
                    for(const t4 in this._tiles)this._setTileReloadTimer(+t4, this._tiles[t4]);
                }
            }
            update(t1, e1, r) {
                if (this.transform = t1, !this._sourceLoaded || this._paused || this.transform.freezeTileCoverage) return;
                if (this.usedForTerrain && !r) return;
                let n;
                this.updateCacheSize(t1, e1), "globe" !== this.transform.projection.name && this.handleWrapJump(this.transform.center.lng), this._coveredTiles = {}, this.used || this.usedForTerrain ? this._source.tileID ? n = t1.getVisibleUnwrappedCoordinates(this._source.tileID).map((t1)=>new Wc(t1.canonical.z, t1.wrap, t1.canonical.z, t1.canonical.x, t1.canonical.y)) : (n = t1.coveringTiles({
                    tileSize: e1 || this._source.tileSize,
                    minzoom: this._source.minzoom,
                    maxzoom: this._source.maxzoom,
                    roundZoom: this._source.roundZoom && !r,
                    reparseOverscaled: this._source.reparseOverscaled,
                    isTerrainDEM: this.usedForTerrain
                }), this._source.hasTile && (n = n.filter((t1)=>this._source.hasTile(t1)))) : n = [];
                const i = this._updateRetainedTiles(n);
                if (cy(this._source.type) && 0 !== n.length) {
                    const t2 = {}, e2 = {}, r1 = Object.keys(i);
                    for (const n1 of r1){
                        const r2 = i[n1], s = this._tiles[n1];
                        if (!s || s.fadeEndTime && s.fadeEndTime <= qt.now()) continue;
                        const a = this.findLoadedParent(r2, Math.max(r2.overscaledZ - ly.maxOverzooming, this._source.minzoom));
                        a && (this._addTile(a.tileID), t2[a.tileID.key] = a.tileID), e2[n1] = r2;
                    }
                    const s1 = n[n.length - 1].overscaledZ;
                    for(const t3 in this._tiles){
                        const r3 = this._tiles[t3];
                        if (i[t3] || !r3.hasData()) continue;
                        let n2 = r3.tileID;
                        for(; n2.overscaledZ > s1;){
                            n2 = n2.scaledTo(n2.overscaledZ - 1);
                            const s2 = this._tiles[n2.key];
                            if (s2 && s2.hasData() && e2[n2.key]) {
                                i[t3] = r3.tileID;
                                break;
                            }
                        }
                    }
                    for(const e3 in t2)i[e3] || (this._coveredTiles[e3] = !0, i[e3] = t2[e3]);
                }
                for(const t4 in i)this._tiles[t4].clearFadeHold();
                const s3 = function(t1, e1) {
                    const r = [];
                    for(const n in t1)n in e1 || r.push(n);
                    return r;
                }(this._tiles, i);
                for (const t5 of s3){
                    const e4 = this._tiles[t5];
                    e4.hasSymbolBuckets && !e4.holdingForFade() ? e4.setHoldDuration(this.map._fadeDuration) : e4.hasSymbolBuckets && !e4.symbolFadeFinished() || this._removeTile(+t5);
                }
                this._updateLoadedParentTileCache(), this._onlySymbols && this._source.afterUpdate && this._source.afterUpdate();
            }
            releaseSymbolFadeTiles() {
                for(const t1 in this._tiles)this._tiles[t1].holdingForFade() && this._removeTile(+t1);
            }
            _updateRetainedTiles(t1) {
                const e1 = {};
                if (0 === t1.length) return e1;
                const r = {}, n = t1.reduce((t1, e1)=>Math.min(t1, e1.overscaledZ), 1 / 0), i = t1[0].overscaledZ, s = Math.max(i - ly.maxOverzooming, this._source.minzoom), a = Math.max(i + ly.maxUnderzooming, this._source.minzoom), o = {};
                for (const r1 of t1){
                    const t2 = this._addTile(r1);
                    e1[r1.key] = r1, t2.hasData() || n < this._source.maxzoom && (o[r1.key] = r1);
                }
                this._retainLoadedChildren(o, n, a, e1);
                for (const n1 of t1){
                    let t3 = this._tiles[n1.key];
                    if (t3.hasData()) continue;
                    if (n1.canonical.z >= this._source.maxzoom) {
                        const t4 = n1.children(this._source.maxzoom)[0], r2 = this.getTile(t4);
                        if (r2 && r2.hasData()) {
                            e1[t4.key] = t4;
                            continue;
                        }
                    } else {
                        const t5 = n1.children(this._source.maxzoom);
                        if (e1[t5[0].key] && e1[t5[1].key] && e1[t5[2].key] && e1[t5[3].key]) continue;
                    }
                    let i1 = t3.wasRequested();
                    for(let a1 = n1.overscaledZ - 1; a1 >= s; --a1){
                        const s1 = n1.scaledTo(a1);
                        if (r[s1.key]) break;
                        if (r[s1.key] = !0, t3 = this.getTile(s1), !t3 && i1 && (t3 = this._addTile(s1)), t3 && (e1[s1.key] = s1, i1 = t3.wasRequested(), t3.hasData())) break;
                    }
                }
                return e1;
            }
            _updateLoadedParentTileCache() {
                this._loadedParentTiles = {};
                for(const t1 in this._tiles){
                    const e1 = [];
                    let r, n = this._tiles[t1].tileID;
                    for(; n.overscaledZ > 0;){
                        if (n.key in this._loadedParentTiles) {
                            r = this._loadedParentTiles[n.key];
                            break;
                        }
                        e1.push(n.key);
                        const t2 = n.scaledTo(n.overscaledZ - 1);
                        if (r = this._getLoadedTile(t2), r) break;
                        n = t2;
                    }
                    for (const t3 of e1)this._loadedParentTiles[t3] = r;
                }
            }
            _addTile(t1) {
                let e1 = this._tiles[t1.key];
                if (e1) return e1;
                e1 = this._cache.getAndRemove(t1), e1 && (this._setTileReloadTimer(t1.key, e1), e1.tileID = t1, this._state.initializeTileState(e1, this.map ? this.map.painter : null), this._cacheTimers[t1.key] && (clearTimeout(this._cacheTimers[t1.key]), delete this._cacheTimers[t1.key], this._setTileReloadTimer(t1.key, e1)));
                const r = Boolean(e1);
                if (!r) {
                    const r1 = this.map ? this.map.painter : null;
                    e1 = new Od(t1, this._source.tileSize * t1.overscaleFactor(), this.transform.tileZoom, r1, this._isRaster), this._loadTile(e1, this._tileLoaded.bind(this, e1, t1.key, e1.state));
                }
                return e1 ? (e1.uses++, this._tiles[t1.key] = e1, r || this._source.fire(new Zt("dataloading", {
                    tile: e1,
                    coord: e1.tileID,
                    dataType: "source"
                })), e1) : null;
            }
            _setTileReloadTimer(t1, e1) {
                t1 in this._timers && (clearTimeout(this._timers[t1]), delete this._timers[t1]);
                const r = e1.getExpiryTimeout();
                r && (this._timers[t1] = setTimeout(()=>{
                    this._reloadTile(t1, "expired"), delete this._timers[t1];
                }, r));
            }
            _removeTile(t1) {
                const e1 = this._tiles[t1];
                e1 && (e1.uses--, delete this._tiles[t1], this._timers[t1] && (clearTimeout(this._timers[t1]), delete this._timers[t1]), e1.uses > 0 || (e1.hasData() && "reloading" !== e1.state ? this._cache.add(e1.tileID, e1, e1.getExpiryTimeout()) : (e1.aborted = !0, this._abortTile(e1), this._unloadTile(e1))));
            }
            clearTiles() {
                this._shouldReloadOnResume = !1, this._paused = !1;
                for(const t1 in this._tiles)this._removeTile(+t1);
                this._source._clear && this._source._clear(), this._cache.reset(), this.map && this.usedForTerrain && this.map.painter.terrain && this.map.painter.terrain.resetTileLookupCache(this.id);
            }
            tilesIn(t1, e1, r) {
                const n = [], i = this.transform;
                if (!i) return n;
                const s = "globe" === i.projection.name, a = Fo(i.center.lng);
                for(const o in this._tiles){
                    const l = this._tiles[o];
                    if (r && l.clearQueryDebugViz(), l.holdingForFade()) continue;
                    let u;
                    if (s) {
                        const t2 = l.tileID.canonical;
                        if (0 === t2.z) {
                            const e2 = [
                                Math.abs(S(a, ...hy(t2, -1)) - a),
                                Math.abs(S(a, ...hy(t2, 1)) - a)
                            ];
                            u = [
                                0,
                                2 * e2.indexOf(Math.min(...e2)) - 1
                            ];
                        } else {
                            const e3 = [
                                Math.abs(S(a, ...hy(t2, -1)) - a),
                                Math.abs(S(a, ...hy(t2, 0)) - a),
                                Math.abs(S(a, ...hy(t2, 1)) - a)
                            ];
                            u = [
                                e3.indexOf(Math.min(...e3)) - 1
                            ];
                        }
                    } else u = [
                        0
                    ];
                    for (const r1 of u){
                        const s1 = t1.containsTile(l, i, e1, r1);
                        s1 && n.push(s1);
                    }
                }
                return n;
            }
            getVisibleCoordinates(t1) {
                const e1 = this.getRenderableIds(t1).map((t1)=>this._tiles[t1].tileID);
                for (const t2 of e1)t2.projMatrix = this.transform.calculateProjMatrix(t2.toUnwrapped());
                return e1;
            }
            hasTransition() {
                if (this._source.hasTransition()) return !0;
                if (cy(this._source.type)) for(const t1 in this._tiles){
                    const e1 = this._tiles[t1];
                    if (void 0 !== e1.fadeEndTime && e1.fadeEndTime >= qt.now()) return !0;
                }
                return !1;
            }
            setFeatureState(t1, e1, r) {
                this._state.updateState(t1 = t1 || "_geojsonTileLayer", e1, r);
            }
            removeFeatureState(t1, e1, r) {
                this._state.removeFeatureState(t1 = t1 || "_geojsonTileLayer", e1, r);
            }
            getFeatureState(t1, e1) {
                return this._state.getState(t1 = t1 || "_geojsonTileLayer", e1);
            }
            setDependencies(t1, e1, r) {
                const n = this._tiles[t1];
                n && n.setDependencies(e1, r);
            }
            reloadTilesForDependencies(t1, e1) {
                for(const r in this._tiles)this._tiles[r].hasDependency(t1, e1) && this._reloadTile(+r, "reloading");
                this._cache.filter((r)=>!r.hasDependency(t1, e1));
            }
            _preloadTiles(t1, e1) {
                const r = new Map, n = Array.isArray(t1) ? t1 : [
                    t1
                ], i = this.map.painter.terrain, s = this.usedForTerrain && i ? i.getScaledDemTileSize() : this._source.tileSize;
                for (const t2 of n){
                    const e2 = t2.coveringTiles({
                        tileSize: s,
                        minzoom: this._source.minzoom,
                        maxzoom: this._source.maxzoom,
                        roundZoom: this._source.roundZoom && !this.usedForTerrain,
                        reparseOverscaled: this._source.reparseOverscaled,
                        isTerrainDEM: this.usedForTerrain
                    });
                    for (const t3 of e2)r.set(t3.key, t3);
                    this.usedForTerrain && t2.updateElevation(!1);
                }
                M(Array.from(r.values()), (t1, e1)=>{
                    const r = new Od(t1, this._source.tileSize * t1.overscaleFactor(), this.transform.tileZoom, this.map.painter, this._isRaster);
                    this._loadTile(r, (t1)=>{
                        "raster-dem" === this._source.type && r.dem && this._backfillDEM(r), e1(t1, r);
                    });
                }, e1);
            }
        }
        function uy(t1, e1) {
            const r = Math.abs(2 * t1.wrap) - +(t1.wrap < 0), n = Math.abs(2 * e1.wrap) - +(e1.wrap < 0);
            return t1.overscaledZ - e1.overscaledZ || n - r || e1.canonical.y - t1.canonical.y || e1.canonical.x - t1.canonical.x;
        }
        function cy(t1) {
            return "raster" === t1 || "image" === t1 || "video" === t1 || "custom" === t1;
        }
        function hy(t1, e1) {
            const r = 1 << t1.z;
            return [
                t1.x / r + e1,
                (t1.x + 1) / r + e1
            ];
        }
        ly.maxOverzooming = 10, ly.maxUnderzooming = 3;
        class py {
            constructor(t1, e1, r){
                this._demTile = t1, this._dem = this._demTile.dem, this._scale = e1, this._offset = r;
            }
            static create(t1, e1, r) {
                const n = r || t1.findDEMTileFor(e1);
                if (!n || !n.dem) return;
                const i = n.dem, s = n.tileID, a = 1 << e1.canonical.z - s.canonical.z;
                return new py(n, n.tileSize / Bo / a, [
                    (e1.canonical.x / a - s.canonical.x) * i.dim,
                    (e1.canonical.y / a - s.canonical.y) * i.dim
                ]);
            }
            tileCoordToPixel(t1, e1) {
                const r = e1 * this._scale + this._offset[1], n = Math.floor(t1 * this._scale + this._offset[0]), i = Math.floor(r);
                return new d(n, i);
            }
            getElevationAt(t1, e1, r, n) {
                const i = t1 * this._scale + this._offset[0], s = e1 * this._scale + this._offset[1], a = Math.floor(i), o = Math.floor(s), l = this._dem;
                return n = !!n, r ? Ir(Ir(l.get(a, o, n), l.get(a, o + 1, n), s - o), Ir(l.get(a + 1, o, n), l.get(a + 1, o + 1, n), s - o), i - a) : l.get(a, o, n);
            }
            getElevationAtPixel(t1, e1, r) {
                return this._dem.get(t1, e1, !!r);
            }
            getMeterToDEM(t1) {
                return (1 << this._demTile.tileID.canonical.z) * Ro(1, t1) * this._dem.stride;
            }
        }
        class fy {
            constructor(t1, e1){
                this.tileID = t1, this.x = t1.canonical.x, this.y = t1.canonical.y, this.z = t1.canonical.z, this.grid = new Li(Bo, 16, 0), this.featureIndexArray = new Oa, this.promoteId = e1;
            }
            insert(t1, e1, r, n, i, s = 0) {
                const a = this.featureIndexArray.length;
                this.featureIndexArray.emplaceBack(r, n, i, s);
                const o = this.grid;
                for(let t2 = 0; t2 < e1.length; t2++){
                    const r1 = e1[t2], n1 = [
                        1 / 0,
                        1 / 0,
                        -1 / 0,
                        -1 / 0
                    ];
                    for(let t3 = 0; t3 < r1.length; t3++){
                        const e2 = r1[t3];
                        n1[0] = Math.min(n1[0], e2.x), n1[1] = Math.min(n1[1], e2.y), n1[2] = Math.max(n1[2], e2.x), n1[3] = Math.max(n1[3], e2.y);
                    }
                    n1[0] < Bo && n1[1] < Bo && n1[2] >= 0 && n1[3] >= 0 && o.insert(a, n1[0], n1[1], n1[2], n1[3]);
                }
            }
            loadVTLayers() {
                if (!this.vtLayers) {
                    this.vtLayers = new Tc(new Eh(this.rawTileData)).layers, this.sourceLayerCoder = new Bd(this.vtLayers ? Object.keys(this.vtLayers).sort() : [
                        "_geojsonTileLayer"
                    ]), this.vtFeatures = {};
                    for(const t1 in this.vtLayers)this.vtFeatures[t1] = [];
                }
                return this.vtLayers;
            }
            query(t1, e1, r, n) {
                this.loadVTLayers();
                const i = t1.params || {}, s = si(i.filter), a = t1.tileResult, o = t1.transform, l = a.bufferedTilespaceBounds, u = this.grid.query(l.min.x, l.min.y, l.max.x, l.max.y, (t1, e1, r, n)=>fl(a.bufferedTilespaceGeometry, t1, e1, r, n));
                u.sort(yy);
                let c = null;
                o.elevation && u.length > 0 && (c = py.create(o.elevation, this.tileID));
                const h = {};
                let p;
                for(let o1 = 0; o1 < u.length; o1++){
                    const l1 = u[o1];
                    if (l1 === p) continue;
                    p = l1;
                    const f = this.featureIndexArray.get(l1);
                    let d = null;
                    this.loadMatchingFeature(h, f, s, i.layers, i.availableImages, e1, r, n, (e1, r, n, i = 0)=>(d || (d = Jo(e1, this.tileID.canonical, t1.tileTransform)), r.queryIntersectsFeature(a, e1, n, d, this.z, t1.transform, t1.pixelPosMatrix, c, i)));
                }
                return h;
            }
            loadMatchingFeature(t1, e1, r, n, i, s, a, o, l) {
                const { featureIndex: u , bucketIndex: c , sourceLayerIndex: h , layoutVertexArrayOffset: p  } = e1, f = this.bucketLayerIDs[c];
                if (n && !function(t1, e1) {
                    for(let r = 0; r < t1.length; r++)if (e1.indexOf(t1[r]) >= 0) return !0;
                    return !1;
                }(n, f)) return;
                const d = this.sourceLayerCoder.decode(h), y = this.vtLayers[d].feature(u);
                if (r.needGeometry) {
                    const t2 = Qo(y, !0);
                    if (!r.filter(new Us(this.tileID.overscaledZ), t2, this.tileID.canonical)) return;
                } else if (!r.filter(new Us(this.tileID.overscaledZ), y)) return;
                const m = this.getId(y, d);
                for(let e2 = 0; e2 < f.length; e2++){
                    const r1 = f[e2];
                    if (n && n.indexOf(r1) < 0) continue;
                    const c1 = s[r1];
                    if (!c1) continue;
                    let h1 = {};
                    void 0 !== m && o && (h1 = o.getState(c1.sourceLayer || "_geojsonTileLayer", m));
                    const d1 = T({}, a[r1]);
                    d1.paint = dy(d1.paint, c1.paint, y, h1, i), d1.layout = dy(d1.layout, c1.layout, y, h1, i);
                    const g = !l || l(y, c1, h1, p);
                    if (!g) continue;
                    const x = new Pd(y, this.z, this.x, this.y, m);
                    x.layer = d1;
                    let v = t1[r1];
                    void 0 === v && (v = t1[r1] = []), v.push({
                        featureIndex: u,
                        feature: x,
                        intersectionZ: g
                    });
                }
            }
            lookupSymbolFeatures(t1, e1, r, n, i, s, a, o) {
                const l = {};
                this.loadVTLayers();
                const u = si(i);
                for (const i1 of t1)this.loadMatchingFeature(l, {
                    bucketIndex: r,
                    sourceLayerIndex: n,
                    featureIndex: i1,
                    layoutVertexArrayOffset: 0
                }, u, s, a, o, e1);
                return l;
            }
            loadFeature(t1) {
                const { featureIndex: e1 , sourceLayerIndex: r  } = t1;
                this.loadVTLayers();
                const n = this.sourceLayerCoder.decode(r), i = this.vtFeatures[n];
                if (i[e1]) return i[e1];
                const s = this.vtLayers[n].feature(e1);
                return i[e1] = s, s;
            }
            hasLayer(t1) {
                for (const e1 of this.bucketLayerIDs)for (const r of e1)if (t1 === r) return !0;
                return !1;
            }
            getId(t1, e1) {
                let r = t1.id;
                if (this.promoteId) {
                    const n = "string" == typeof this.promoteId ? this.promoteId : this.promoteId[e1];
                    null != n && (r = t1.properties[n]), "boolean" == typeof r && (r = Number(r));
                }
                return r;
            }
        }
        function dy(t1, e1, r, n, i) {
            return L(t1, (t1, s)=>{
                const a = e1 instanceof Xs ? e1.get(s) : null;
                return a && a.evaluate ? a.evaluate(r, n, i) : a;
            });
        }
        function yy(t1, e1) {
            return e1 - t1;
        }
        ji(fy, "FeatureIndex", {
            omit: [
                "rawTileData",
                "sourceLayerCoder"
            ]
        });
        class my {
            constructor(t1, e1){
                this.width = t1, this.height = e1, this.nextRow = 0, this.image = new wu({
                    width: t1,
                    height: e1
                }), this.positions = {}, this.uploaded = !1;
            }
            getDash(t1, e1) {
                const r = this.getKey(t1, e1);
                return this.positions[r];
            }
            trim() {
                const t1 = this.width, e1 = this.height = C(this.nextRow);
                this.image.resize({
                    width: t1,
                    height: e1
                });
            }
            getKey(t1, e1) {
                return t1.join(",") + e1;
            }
            getDashRanges(t1, e1, r) {
                const n = [];
                let i = t1.length % 2 == 1 ? -t1[t1.length - 1] * r : 0, s = t1[0] * r, a = !0;
                n.push({
                    left: i,
                    right: s,
                    isDash: a,
                    zeroLength: 0 === t1[0]
                });
                let o = t1[0];
                for(let e2 = 1; e2 < t1.length; e2++){
                    a = !a;
                    const l = t1[e2];
                    i = o * r, o += l, s = o * r, n.push({
                        left: i,
                        right: s,
                        isDash: a,
                        zeroLength: 0 === l
                    });
                }
                return n;
            }
            addRoundDash(t1, e1, r) {
                const n = e1 / 2;
                for(let e2 = -r; e2 <= r; e2++){
                    const i = this.width * (this.nextRow + r + e2);
                    let s = 0, a = t1[s];
                    for(let o = 0; o < this.width; o++){
                        o / a.right > 1 && (a = t1[++s]);
                        const l = Math.abs(o - a.left), u = Math.abs(o - a.right), c = Math.min(l, u);
                        let h;
                        const p = e2 / r * (n + 1);
                        if (a.isDash) {
                            const t2 = n - Math.abs(p);
                            h = Math.sqrt(c * c + t2 * t2);
                        } else h = n - Math.sqrt(c * c + p * p);
                        this.image.data[i + o] = Math.max(0, Math.min(255, h + 128));
                    }
                }
            }
            addRegularDash(t1, e1) {
                for(let e2 = t1.length - 1; e2 >= 0; --e2){
                    const r = t1[e2], n = t1[e2 + 1];
                    r.zeroLength ? t1.splice(e2, 1) : n && n.isDash === r.isDash && (n.left = r.left, t1.splice(e2, 1));
                }
                const r1 = t1[0], n1 = t1[t1.length - 1];
                r1.isDash === n1.isDash && (r1.left = n1.left - this.width, n1.right = r1.right + this.width);
                const i = this.width * this.nextRow;
                let s = 0, a = t1[s];
                for(let r2 = 0; r2 < this.width; r2++){
                    r2 / a.right > 1 && (a = t1[++s]);
                    const n2 = Math.abs(r2 - a.left), o = Math.abs(r2 - a.right), l = Math.min(n2, o);
                    this.image.data[i + r2] = Math.max(0, Math.min(255, (a.isDash ? l : -l) + e1 + 128));
                }
            }
            addDash(t1, e1) {
                const r = this.getKey(t1, e1);
                if (this.positions[r]) return this.positions[r];
                const n = "round" === e1, i = n ? 7 : 0, s = 2 * i + 1;
                if (this.nextRow + s > this.height) return $("LineAtlas out of space"), null;
                0 === t1.length && t1.push(1);
                let a = 0;
                for(let e2 = 0; e2 < t1.length; e2++)t1[e2] < 0 && ($("Negative value is found in line dasharray, replacing values with 0"), t1[e2] = 0), a += t1[e2];
                if (0 !== a) {
                    const r1 = this.width / a, s1 = this.getDashRanges(t1, this.width, r1);
                    n ? this.addRoundDash(s1, r1, i) : this.addRegularDash(s1, "square" === e1 ? .5 * r1 : 0);
                }
                const o = this.nextRow + i;
                this.nextRow += s;
                const l = {
                    tl: [
                        o,
                        i
                    ],
                    br: [
                        a,
                        0
                    ]
                };
                return this.positions[r] = l, l;
            }
        }
        ji(my, "LineAtlas");
        class gy {
            constructor(t1){
                const e1 = {}, r = [];
                for(const n in t1){
                    const i = t1[n], s = e1[n] = {};
                    for(const t2 in i.glyphs){
                        const e2 = i.glyphs[+t2];
                        if (!e2 || 0 === e2.bitmap.width || 0 === e2.bitmap.height) continue;
                        const n1 = e2.metrics.localGlyph ? 2 : 1, a = {
                            x: 0,
                            y: 0,
                            w: e2.bitmap.width + 2 * n1,
                            h: e2.bitmap.height + 2 * n1
                        };
                        r.push(a), s[t2] = a;
                    }
                }
                const { w: n2 , h: i1  } = rp(r), s1 = new wu({
                    width: n2 || 1,
                    height: i1 || 1
                });
                for(const r1 in t1){
                    const n3 = t1[r1];
                    for(const t3 in n3.glyphs){
                        const i2 = n3.glyphs[+t3];
                        if (!i2 || 0 === i2.bitmap.width || 0 === i2.bitmap.height) continue;
                        const a1 = e1[r1][t3], o = i2.metrics.localGlyph ? 2 : 1;
                        wu.copy(i2.bitmap, s1, {
                            x: 0,
                            y: 0
                        }, {
                            x: a1.x + o,
                            y: a1.y + o
                        }, i2.bitmap);
                    }
                }
                this.image = s1, this.positions = e1;
            }
        }
        ji(gy, "GlyphAtlas");
        class xy {
            constructor(t1){
                this.tileID = new Wc(t1.tileID.overscaledZ, t1.tileID.wrap, t1.tileID.canonical.z, t1.tileID.canonical.x, t1.tileID.canonical.y), this.tileZoom = t1.tileZoom, this.uid = t1.uid, this.zoom = t1.zoom, this.canonical = t1.tileID.canonical, this.pixelRatio = t1.pixelRatio, this.tileSize = t1.tileSize, this.source = t1.source, this.overscaling = this.tileID.overscaleFactor(), this.showCollisionBoxes = t1.showCollisionBoxes, this.collectResourceTiming = !!t1.collectResourceTiming, this.returnDependencies = !!t1.returnDependencies, this.promoteId = t1.promoteId, this.enableTerrain = !!t1.enableTerrain, this.isSymbolTile = t1.isSymbolTile, this.tileTransform = jf(t1.tileID.canonical, t1.projection), this.projection = t1.projection;
            }
            parse(t1, e1, r, n, i) {
                this.status = "parsing", this.data = t1, this.collisionBoxArray = new Da;
                const s = new Bd(Object.keys(t1.layers).sort()), a = new fy(this.tileID, this.promoteId);
                a.bucketLayerIDs = [];
                const o = {}, l = new my(256, 256), u = {
                    featureIndex: a,
                    iconDependencies: {},
                    patternDependencies: {},
                    glyphDependencies: {},
                    lineAtlas: l,
                    availableImages: r
                }, c = e1.familiesBySource[this.source];
                for(const e2 in c){
                    const n1 = t1.layers[e2];
                    if (!n1) continue;
                    let i1 = !1, l1 = !1;
                    for (const t2 of c[e2])"symbol" === t2[0].type ? i1 = !0 : l1 = !0;
                    if (!0 === this.isSymbolTile && !i1) continue;
                    if (!1 === this.isSymbolTile && !l1) continue;
                    1 === n1.version && $(`Vector tile source "${this.source}" layer "${e2}" does not use vector tile spec v2 and therefore may have some rendering errors.`);
                    const h = s.encode(e2), p = [];
                    for(let t3 = 0; t3 < n1.length; t3++){
                        const r1 = n1.feature(t3), i2 = a.getId(r1, e2);
                        p.push({
                            feature: r1,
                            id: i2,
                            index: t3,
                            sourceLayerIndex: h
                        });
                    }
                    for (const t4 of c[e2]){
                        const e3 = t4[0];
                        void 0 !== this.isSymbolTile && "symbol" === e3.type !== this.isSymbolTile || e3.minzoom && this.zoom < Math.floor(e3.minzoom) || e3.maxzoom && this.zoom >= e3.maxzoom || "none" !== e3.visibility && (vy(t4, this.zoom, r), (o[e3.id] = e3.createBucket({
                            index: a.bucketLayerIDs.length,
                            layers: t4,
                            zoom: this.zoom,
                            canonical: this.canonical,
                            pixelRatio: this.pixelRatio,
                            overscaling: this.overscaling,
                            collisionBoxArray: this.collisionBoxArray,
                            sourceLayerIndex: h,
                            sourceID: this.source,
                            enableTerrain: this.enableTerrain,
                            projection: this.projection.spec,
                            availableImages: r
                        })).populate(p, u, this.tileID.canonical, this.tileTransform), a.bucketLayerIDs.push(t4.map((t1)=>t1.id)));
                    }
                }
                let h1, p1, f, d;
                l.trim();
                const y = {
                    type: "maybePrepare",
                    isSymbolTile: this.isSymbolTile,
                    zoom: this.zoom
                }, m = L(u.glyphDependencies, (t1)=>Object.keys(t1).map(Number));
                Object.keys(m).length ? n.send("getGlyphs", {
                    uid: this.uid,
                    stacks: m
                }, (t1, e1)=>{
                    h1 || (h1 = t1, p1 = e1, v.call(this));
                }, void 0, !1, y) : p1 = {};
                const g = Object.keys(u.iconDependencies);
                g.length ? n.send("getImages", {
                    icons: g,
                    source: this.source,
                    tileID: this.tileID,
                    type: "icons"
                }, (t1, e1)=>{
                    h1 || (h1 = t1, f = e1, v.call(this));
                }, void 0, !1, y) : f = {};
                const x = Object.keys(u.patternDependencies);
                function v() {
                    if (h1) return i(h1);
                    if (p1 && f && d) {
                        const t1 = new gy(p1), e1 = new ip(f, d);
                        for(const n in o){
                            const i1 = o[n];
                            i1 instanceof md ? (vy(i1.layers, this.zoom, r), Hp(i1, p1, t1.positions, f, e1.iconPositions, this.showCollisionBoxes, r, this.tileID.canonical, this.tileZoom, this.projection)) : i1.hasPattern && (i1 instanceof uh || i1 instanceof cc || i1 instanceof Lc) && (vy(i1.layers, this.zoom, r), i1.addFeatures(u, this.tileID.canonical, e1.patternPositions, r, this.tileTransform));
                        }
                        this.status = "done", i(null, {
                            buckets: z(o).filter((t1)=>!t1.isEmpty()),
                            featureIndex: a,
                            collisionBoxArray: this.collisionBoxArray,
                            glyphAtlasImage: t1.image,
                            lineAtlas: l,
                            imageAtlas: e1,
                            glyphMap: this.returnDependencies ? p1 : null,
                            iconMap: this.returnDependencies ? f : null,
                            glyphPositions: this.returnDependencies ? t1.positions : null
                        });
                    }
                }
                x.length ? n.send("getImages", {
                    icons: x,
                    source: this.source,
                    tileID: this.tileID,
                    type: "patterns"
                }, (t1, e1)=>{
                    h1 || (h1 = t1, d = e1, v.call(this));
                }, void 0, !1, y) : d = {}, v.call(this);
            }
        }
        function vy(t1, e1, r) {
            const n = new Us(e1);
            for (const e2 of t1)e2.recalculate(n, r);
        }
        class by {
            constructor(t1){
                this.entries = {}, this.scheduler = t1;
            }
            request(t1, e1, r, n) {
                const i = this.entries[t1] = this.entries[t1] || {
                    callbacks: []
                };
                if (i.result) {
                    const [t2, r1] = i.result;
                    return this.scheduler ? this.scheduler.add(()=>{
                        n(t2, r1);
                    }, e1) : n(t2, r1), ()=>{};
                }
                return i.callbacks.push(n), i.cancel || (i.cancel = r((r, n)=>{
                    i.result = [
                        r,
                        n
                    ];
                    for (const t2 of i.callbacks)this.scheduler ? this.scheduler.add(()=>{
                        t2(r, n);
                    }, e1) : t2(r, n);
                    setTimeout(()=>delete this.entries[t1], 3e3);
                })), ()=>{
                    i.result || (i.callbacks = i.callbacks.filter((t1)=>t1 !== n), i.callbacks.length || (i.cancel(), delete this.entries[t1]));
                };
            }
        }
        function _y(t1, e1, r) {
            const n = JSON.stringify(t1.request);
            return t1.data && (this.deduped.entries[n] = {
                result: [
                    null,
                    t1.data
                ]
            }), this.deduped.request(n, {
                type: "parseTile",
                isSymbolTile: t1.isSymbolTile,
                zoom: t1.tileZoom
            }, (e1)=>{
                const n = ut(t1.request, (t1, n, i, s)=>{
                    t1 ? e1(t1) : n && e1(null, {
                        vectorTile: r ? void 0 : new Tc(new Eh(n)),
                        rawData: n,
                        cacheControl: i,
                        expires: s
                    });
                });
                return ()=>{
                    n.cancel(), e1();
                };
            }, e1);
        }
        t1.ARRAY_TYPE = wl, t1.AUTH_ERR_MSG = yt, t1.Aabb = pu, t1.Actor = class {
            constructor(t1, r, n){
                this.target = t1, this.parent = r, this.mapId = n, this.callbacks = {}, this.cancelCallbacks = {}, V([
                    "receive"
                ], this), this.target.addEventListener("message", this.receive, !1), this.globalScope = N() ? t1 : e1, this.scheduler = new Td;
            }
            send(t1, e1, r, n, i = !1, s) {
                const a = Math.round(1e18 * Math.random()).toString(36).substring(0, 10);
                r && (r.metadata = s, this.callbacks[a] = r);
                const o = X(this.globalScope) ? void 0 : [];
                return this.target.postMessage({
                    id: a,
                    type: t1,
                    hasCallback: !!r,
                    targetMapId: n,
                    mustQueue: i,
                    sourceMapId: this.mapId,
                    data: qi(e1, o)
                }, o), {
                    cancel: ()=>{
                        r && delete this.callbacks[a], this.target.postMessage({
                            id: a,
                            type: "<cancel>",
                            targetMapId: n,
                            sourceMapId: this.mapId
                        });
                    }
                };
            }
            receive(t1) {
                const e1 = t1.data, r = e1.id;
                if (r && (!e1.targetMapId || this.mapId === e1.targetMapId)) {
                    if ("<cancel>" === e1.type) {
                        const t2 = this.cancelCallbacks[r];
                        delete this.cancelCallbacks[r], t2 && t2.cancel();
                    } else if (e1.mustQueue || N()) {
                        const t3 = this.callbacks[r];
                        this.cancelCallbacks[r] = this.scheduler.add(()=>this.processTask(r, e1), t3 && t3.metadata || {
                            type: "message"
                        });
                    } else this.processTask(r, e1);
                }
            }
            processTask(t1, e1) {
                if ("<response>" === e1.type) {
                    const r = this.callbacks[t1];
                    delete this.callbacks[t1], r && (e1.error ? r(Ni(e1.error)) : r(null, Ni(e1.data)));
                } else {
                    const r1 = X(this.globalScope) ? void 0 : [], n = e1.hasCallback ? (e1, n)=>{
                        delete this.cancelCallbacks[t1], this.target.postMessage({
                            id: t1,
                            type: "<response>",
                            sourceMapId: this.mapId,
                            error: e1 ? qi(e1) : null,
                            data: qi(n, r1)
                        }, r1);
                    } : (t1)=>{}, i = Ni(e1.data);
                    if (this.parent[e1.type]) this.parent[e1.type](e1.sourceMapId, i, n);
                    else if (this.parent.getWorkerSource) {
                        const t2 = e1.type.split(".");
                        this.parent.getWorkerSource(e1.sourceMapId, t2[0], i.source)[t2[1]](i, n);
                    } else n(new Error(`Could not find function ${e1.type}`));
                }
            }
            remove() {
                this.scheduler.remove(), this.target.removeEventListener("message", this.receive, !1);
            }
        }, t1.CanonicalTileID = Hc, t1.Color = Ie, t1.ColorMode = iy, t1.CullFaceMode = oy, t1.DEMData = Qd, t1.DataConstantProperty = Ks, t1.DedupedRequest = by, t1.DepthMode = ey, t1.EXTENT = Bo, t1.Elevation = class {
            isDataAvailableAtPoint(t1) {
                const e1 = this._source();
                if (this.isUsingMockSource() || !e1 || t1.y < 0 || t1.y > 1) return !1;
                const r = e1.getSource().maxzoom, n = 1 << r, i = Math.floor(t1.x), s = Math.floor((t1.x - i) * n), a = Math.floor(t1.y * n), o = this.findDEMTileFor(new Wc(r, i, r, s, a));
                return !(!o || !o.dem);
            }
            getAtPointOrZero(t1, e1 = 0) {
                return this.getAtPoint(t1, e1) || 0;
            }
            getAtPoint(t1, e1, r = !0) {
                if (this.isUsingMockSource()) return null;
                null == e1 && (e1 = null);
                const n = this._source();
                if (!n) return e1;
                if (t1.y < 0 || t1.y > 1) return e1;
                const i = n.getSource().maxzoom, s = 1 << i, a = Math.floor(t1.x), o = t1.x - a, l = new Wc(i, a, i, Math.floor(o * s), Math.floor(t1.y * s)), u = this.findDEMTileFor(l);
                if (!u || !u.dem) return e1;
                const c = u.dem, h = 1 << u.tileID.canonical.z, p = (o * h - u.tileID.canonical.x) * c.dim, f = (t1.y * h - u.tileID.canonical.y) * c.dim, d = Math.floor(p), y = Math.floor(f);
                return (r ? this.exaggeration() : 1) * Ir(Ir(c.get(d, y), c.get(d, y + 1), f - y), Ir(c.get(d + 1, y), c.get(d + 1, y + 1), f - y), p - d);
            }
            getAtTileOffset(t1, e1, r) {
                const n = 1 << t1.canonical.z;
                return this.getAtPointOrZero(new No(t1.wrap + (t1.canonical.x + e1 / Bo) / n, (t1.canonical.y + r / Bo) / n));
            }
            getAtTileOffsetFunc(t1, e1, r, n) {
                return (i)=>{
                    const s = this.getAtTileOffset(t1, i.x, i.y), a = n.upVector(t1.canonical, i.x, i.y);
                    return Nl(a, a, s * n.upVectorScale(t1.canonical, e1, r).metersToTile), a;
                };
            }
            getForTilePoints(t1, e1, r, n) {
                if (this.isUsingMockSource()) return !1;
                const i = py.create(this, t1, n);
                return !!i && (e1.forEach((t1)=>{
                    t1[2] = this.exaggeration() * i.getElevationAt(t1[0], t1[1], r);
                }), !0);
            }
            getMinMaxForTile(t1) {
                if (this.isUsingMockSource()) return null;
                const e1 = this.findDEMTileFor(t1);
                if (!e1 || !e1.dem) return null;
                const r = e1.dem.tree, n = e1.tileID, i = 1 << t1.canonical.z - n.canonical.z;
                let s = t1.canonical.x / i - n.canonical.x, a = t1.canonical.y / i - n.canonical.y, o = 0;
                for(let e2 = 0; e2 < t1.canonical.z - n.canonical.z && !r.leaves[o]; e2++){
                    s *= 2, a *= 2;
                    const t2 = 2 * Math.floor(a) + Math.floor(s);
                    o = r.childOffsets[o] + t2, s %= 1, a %= 1;
                }
                return {
                    min: this.exaggeration() * r.minimums[o],
                    max: this.exaggeration() * r.maximums[o]
                };
            }
            getMinElevationBelowMSL() {
                throw new Error("Pure virtual method called.");
            }
            raycast(t1, e1, r) {
                throw new Error("Pure virtual method called.");
            }
            pointCoordinate(t1) {
                throw new Error("Pure virtual method called.");
            }
            _source() {
                throw new Error("Pure virtual method called.");
            }
            isUsingMockSource() {
                throw new Error("Pure virtual method called.");
            }
            exaggeration() {
                throw new Error("Pure virtual method called.");
            }
            findDEMTileFor(t1) {
                throw new Error("Pure virtual method called.");
            }
            get visibleDemTiles() {
                throw new Error("Getter must be implemented in subclass.");
            }
        }, t1.ErrorEvent = Xt, t1.EvaluationParameters = Us, t1.Event = Zt, t1.Evented = Kt, t1.FillExtrusionBucket = Lc, t1.Frustum = hu, t1.FrustumCorners = cu, t1.GLOBE_METERS_TO_ECEF = cf, t1.GLOBE_RADIUS = uf, t1.GLOBE_SCALE_MATCH_LATITUDE = 45, t1.GLOBE_ZOOM_THRESHOLD_MAX = 6, t1.GLOBE_ZOOM_THRESHOLD_MIN = 5, t1.GlobeSharedBuffers = class {
            constructor(t1){
                this._createGrid(t1), this._createPoles(t1);
            }
            destroy() {
                this._poleIndexBuffer.destroy(), this._gridBuffer.destroy(), this._gridIndexBuffer.destroy(), this._poleNorthVertexBuffer.destroy(), this._poleSouthVertexBuffer.destroy();
                for (const t1 of this._poleSegments)t1.destroy();
                for (const t2 of this._gridSegments)t2.destroy();
                if (this._wireframeIndexBuffer) {
                    this._wireframeIndexBuffer.destroy();
                    for (const t3 of this._wireframeSegments)t3.destroy();
                }
            }
            _createGrid(t1) {
                const e1 = new aa, r = new wa, n = 65;
                for(let t2 = 0; t2 < n; t2++)for(let r1 = 0; r1 < n; r1++)e1.emplaceBack(r1, t2);
                this._gridSegments = [];
                for(let t3 = 0, e2 = 0; t3 < pf.length; t3++){
                    const i = pf[t3];
                    for(let t4 = 0; t4 < i; t4++)for(let e3 = 0; e3 < 64; e3++){
                        const i1 = t4 * n + e3;
                        r.emplaceBack(i1 + 1, i1, i1 + n), r.emplaceBack(i1 + n, i1 + n + 1, i1 + 1);
                    }
                    const s = 64 * i * 2;
                    this._gridSegments.push(To.simpleSegment(0, e2, (i + 1) * n, s)), e2 += s;
                }
                this._gridBuffer = t1.createVertexBuffer(e1, lf.members), this._gridIndexBuffer = t1.createIndexBuffer(r, !0);
            }
            _createPoles(t1) {
                const e1 = new wa;
                for(let t2 = 0; t2 <= hf; t2++)e1.emplaceBack(0, t2 + 1, t2 + 2);
                this._poleIndexBuffer = t1.createIndexBuffer(e1, !0);
                const r = new Ia, n = new Ia;
                this._poleSegments = [];
                for(let t3 = 0, e2 = 0; t3 < 5; t3++){
                    const i = 360 / (1 << t3);
                    r.emplaceBack(0, -uf, 0, .5, 0), n.emplaceBack(0, -uf, 0, .5, 1);
                    for(let t4 = 0; t4 <= hf; t4++){
                        const e3 = t4 / hf, s = Ir(0, i, e3), [a, o, l] = If(Lf, Rf, s, uf);
                        r.emplaceBack(a, o, l, e3, 0), n.emplaceBack(a, o, l, e3, 1);
                    }
                    this._poleSegments.push(To.simpleSegment(e2, 0, 66, 64)), e2 += 66;
                }
                this._poleNorthVertexBuffer = t1.createVertexBuffer(r, af, !1), this._poleSouthVertexBuffer = t1.createVertexBuffer(n, af, !1);
            }
            getGridBuffers(t1) {
                return [
                    this._gridBuffer,
                    this._gridIndexBuffer,
                    this._gridSegments[t1]
                ];
            }
            getPoleBuffers(t1) {
                return [
                    this._poleNorthVertexBuffer,
                    this._poleSouthVertexBuffer,
                    this._poleIndexBuffer,
                    this._poleSegments[t1]
                ];
            }
            getWirefameBuffers(t1, e1) {
                if (!this._wireframeSegments) {
                    const e2 = new za, r = hf, n = r + 1;
                    this._wireframeSegments = [];
                    for(let t2 = 0, i = 0; t2 < pf.length; t2++){
                        const s = pf[t2];
                        for(let t3 = 0; t3 < s; t3++)for(let i1 = 0; i1 < r; i1++){
                            const r1 = t3 * n + i1;
                            e2.emplaceBack(r1, r1 + 1), e2.emplaceBack(r1, r1 + n), e2.emplaceBack(r1, r1 + n + 1);
                        }
                        const a = s * r * 3;
                        this._wireframeSegments.push(To.simpleSegment(0, i, (s + 1) * n, a)), i += a;
                    }
                    this._wireframeIndexBuffer = t1.createIndexBuffer(e2);
                }
                return [
                    this._gridBuffer,
                    this._wireframeIndexBuffer,
                    this._wireframeSegments[e1]
                ];
            }
        }, t1.GlyphManager = Dp, t1.ImagePosition = np, t1.LivePerformanceUtils = Vt, t1.LngLat = Co, t1.LngLatBounds = Eo, t1.LocalGlyphMode = Cp, t1.MAX_MERCATOR_LATITUDE = Oo, t1.MercatorCoordinate = No, t1.ONE_EM = _h, t1.OverscaledTileID = Wc, t1.PerformanceMarkers = Dt, t1.Properties = Qs, t1.RGBAImage = Au, t1.Ray = uu, t1.RequestManager = class {
            constructor(t1, e1, r){
                this._transformRequestFn = t1, this._customAccessToken = e1, this._silenceAuthErrors = !!r, this._createSkuToken();
            }
            _createSkuToken() {
                const t1 = function() {
                    let t1 = "";
                    for(let e1 = 0; e1 < 10; e1++)t1 += "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"[Math.floor(62 * Math.random())];
                    return {
                        token: [
                            "1",
                            h,
                            t1
                        ].join(""),
                        tokenExpiresAt: Date.now() + 432e5
                    };
                }();
                this._skuToken = t1.token, this._skuTokenExpiresAt = t1.tokenExpiresAt;
            }
            _isSkuTokenExpired() {
                return Date.now() > this._skuTokenExpiresAt;
            }
            transformRequest(t1, e1) {
                return this._transformRequestFn && this._transformRequestFn(t1, e1) || {
                    url: t1
                };
            }
            normalizeStyleURL(t1, e1) {
                if (!mt(t1)) return t1;
                const r = _t(t1);
                return r.path = `/styles/v1${r.path}`, this._makeAPIURL(r, this._customAccessToken || e1);
            }
            normalizeGlyphsURL(t1, e1) {
                if (!mt(t1)) return t1;
                const r = _t(t1);
                return r.path = `/fonts/v1${r.path}`, this._makeAPIURL(r, this._customAccessToken || e1);
            }
            normalizeSourceURL(t1, e1, r, n) {
                if (!mt(t1)) return t1;
                const i = _t(t1);
                return i.path = `/v4/${i.authority}.json`, i.params.push("secure"), r && i.params.push(`language=${r}`), n && i.params.push(`worldview=${n}`), this._makeAPIURL(i, this._customAccessToken || e1);
            }
            normalizeSpriteURL(t1, e1, r, n) {
                const i = _t(t1);
                return mt(t1) ? (i.path = `/styles/v1${i.path}/sprite${e1}${r}`, this._makeAPIURL(i, this._customAccessToken || n)) : (i.path += `${e1}${r}`, wt(i));
            }
            normalizeTileURL(t1, e1, r) {
                if (this._isSkuTokenExpired() && this._createSkuToken(), t1 && !mt(t1)) return t1;
                const n = _t(t1);
                n.path = n.path.replace(/(\.(png|jpg)\d*)(?=$)/, `${e1 || r && "raster" !== n.authority && 512 === r ? "@2x" : ""}${s.supported ? ".webp" : "$1"}`), "raster" === n.authority ? n.path = `/${i.RASTER_URL_PREFIX}${n.path}` : (n.path = n.path.replace(/^.+\/v4\//, "/"), n.path = `/${i.TILE_URL_VERSION}${n.path}`);
                const a = this._customAccessToken || function(t1) {
                    for (const e1 of t1){
                        const t2 = e1.match(/^access_token=(.*)$/);
                        if (t2) return t2[1];
                    }
                    return null;
                }(n.params) || i.ACCESS_TOKEN;
                return i.REQUIRE_ACCESS_TOKEN && a && this._skuToken && n.params.push(`sku=${this._skuToken}`), this._makeAPIURL(n, a);
            }
            canonicalizeTileURL(t1, e1) {
                const r = _t(t1);
                if (!r.path.match(/^(\/v4\/|\/raster\/v1\/)/) || !r.path.match(/\.[\w]+$/)) return t1;
                let n = "mapbox://";
                r.path.match(/^\/raster\/v1\//) ? n += `raster/${r.path.replace(`/${i.RASTER_URL_PREFIX}/`, "")}` : n += `tiles/${r.path.replace(`/${i.TILE_URL_VERSION}/`, "")}`;
                let s = r.params;
                return e1 && (s = s.filter((t1)=>!t1.match(/^access_token=/))), s.length && (n += `?${s.join("&")}`), n;
            }
            canonicalizeTileset(t1, e1) {
                const r = !!e1 && mt(e1), n = [];
                for (const e2 of t1.tiles || [])gt(e2) ? n.push(this.canonicalizeTileURL(e2, r)) : n.push(e2);
                return n;
            }
            _makeAPIURL(t1, e1) {
                const r = "See https://www.mapbox.com/api-documentation/#access-tokens-and-token-scopes", n = _t(i.API_URL);
                if (t1.protocol = n.protocol, t1.authority = n.authority, "http" === t1.protocol) {
                    const e2 = t1.params.indexOf("secure");
                    e2 >= 0 && t1.params.splice(e2, 1);
                }
                if ("/" !== n.path && (t1.path = `${n.path}${t1.path}`), !i.REQUIRE_ACCESS_TOKEN) return wt(t1);
                if (e1 = e1 || i.ACCESS_TOKEN, !this._silenceAuthErrors) {
                    if (!e1) throw new Error(`An API access token is required to use Mapbox GL. ${r}`);
                    if ("s" === e1[0]) throw new Error(`Use a public access token (pk.*) with Mapbox GL, not a secret access token (sk.*). ${r}`);
                }
                return t1.params = t1.params.filter((t1)=>-1 === t1.indexOf("access_token")), t1.params.push(`access_token=${e1 || ""}`), wt(t1);
            }
        }, t1.ResourceType = st, t1.SegmentVector = To, t1.SourceCache = ly, t1.StencilMode = ny, t1.StructArrayLayout1ui2 = Ta, t1.StructArrayLayout2f1f2i16 = va, t1.StructArrayLayout2i4 = aa, t1.StructArrayLayout2ui4 = za, t1.StructArrayLayout3f12 = _a, t1.StructArrayLayout3ui6 = wa, t1.StructArrayLayout4i8 = la, t1.StructArrayLayout5f20 = Ia, t1.Texture = Md, t1.Tile = Od, t1.Transitionable = Os, t1.Uniform1f = so, t1.Uniform1i = class extends io {
            constructor(t1){
                super(t1), this.current = 0;
            }
            set(t1, e1, r) {
                this.fetchUniformLocation(t1, e1) && this.current !== r && (this.current = r, this.gl.uniform1i(this.location, r));
            }
        }, t1.Uniform2f = class extends io {
            constructor(t1){
                super(t1), this.current = [
                    0,
                    0
                ];
            }
            set(t1, e1, r) {
                this.fetchUniformLocation(t1, e1) && (r[0] === this.current[0] && r[1] === this.current[1] || (this.current = r, this.gl.uniform2f(this.location, r[0], r[1])));
            }
        }, t1.Uniform3f = class extends io {
            constructor(t1){
                super(t1), this.current = [
                    0,
                    0,
                    0
                ];
            }
            set(t1, e1, r) {
                this.fetchUniformLocation(t1, e1) && (r[0] === this.current[0] && r[1] === this.current[1] && r[2] === this.current[2] || (this.current = r, this.gl.uniform3f(this.location, r[0], r[1], r[2])));
            }
        }, t1.Uniform4f = ao, t1.UniformColor = oo, t1.UniformMatrix2f = class extends io {
            constructor(t1){
                super(t1), this.current = co;
            }
            set(t1, e1, r) {
                if (this.fetchUniformLocation(t1, e1)) {
                    for(let t2 = 0; t2 < 4; t2++)if (r[t2] !== this.current[t2]) {
                        this.current = r, this.gl.uniformMatrix2fv(this.location, !1, r);
                        break;
                    }
                }
            }
        }, t1.UniformMatrix3f = class extends io {
            constructor(t1){
                super(t1), this.current = uo;
            }
            set(t1, e1, r) {
                if (this.fetchUniformLocation(t1, e1)) {
                    for(let t2 = 0; t2 < 9; t2++)if (r[t2] !== this.current[t2]) {
                        this.current = r, this.gl.uniformMatrix3fv(this.location, !1, r);
                        break;
                    }
                }
            }
        }, t1.UniformMatrix4f = class extends io {
            constructor(t1){
                super(t1), this.current = lo;
            }
            set(t1, e1, r) {
                if (this.fetchUniformLocation(t1, e1)) {
                    if (r[12] !== this.current[12] || r[0] !== this.current[0]) return this.current = r, void this.gl.uniformMatrix4fv(this.location, !1, r);
                    for(let t2 = 1; t2 < 16; t2++)if (r[t2] !== this.current[t2]) {
                        this.current = r, this.gl.uniformMatrix4fv(this.location, !1, r);
                        break;
                    }
                }
            }
        }, t1.UnwrappedTileID = Yc, t1.ValidationError = Yn, t1.VectorTileFeature = Bc, t1.VectorTileWorkerSource = class extends Kt {
            constructor(t1, e1, r, n, i){
                super(), this.actor = t1, this.layerIndex = e1, this.availableImages = r, this.loadVectorData = i || _y, this.loading = {}, this.loaded = {}, this.deduped = new by(t1.scheduler), this.isSpriteLoaded = n, this.scheduler = t1.scheduler;
            }
            loadTile(t1, e1) {
                const r = t1.uid, n = t1 && t1.request, i = n && n.collectResourceTiming, s = this.loading[r] = new xy(t1);
                s.abort = this.loadVectorData(t1, (a, o)=>{
                    const l = !this.loading[r];
                    if (delete this.loading[r], l || a || !o) return s.status = "done", l || (this.loaded[r] = s), e1(a);
                    const u = o.rawData, c = {};
                    o.expires && (c.expires = o.expires), o.cacheControl && (c.cacheControl = o.cacheControl), s.vectorTile = o.vectorTile || new Tc(new Eh(u));
                    const h = ()=>{
                        s.parse(s.vectorTile, this.layerIndex, this.availableImages, this.actor, (t1, r)=>{
                            if (t1 || !r) return e1(t1);
                            const s = {};
                            if (i) {
                                const t2 = Rt(n);
                                t2.length > 0 && (s.resourceTiming = JSON.parse(JSON.stringify(t2)));
                            }
                            e1(null, T({
                                rawTileData: u.slice(0)
                            }, r, c, s));
                        });
                    };
                    this.isSpriteLoaded ? h() : this.once("isSpriteLoaded", ()=>{
                        this.scheduler ? this.scheduler.add(h, {
                            type: "parseTile",
                            isSymbolTile: t1.isSymbolTile,
                            zoom: t1.tileZoom
                        }) : h();
                    }), this.loaded = this.loaded || {}, this.loaded[r] = s;
                });
            }
            reloadTile(t1, e1) {
                const r = this.loaded, n = t1.uid, i = this;
                if (r && r[n]) {
                    const s = r[n];
                    s.showCollisionBoxes = t1.showCollisionBoxes, s.enableTerrain = !!t1.enableTerrain, s.projection = t1.projection, s.tileTransform = jf(t1.tileID.canonical, t1.projection);
                    const a = (t1, r)=>{
                        const n = s.reloadCallback;
                        n && (delete s.reloadCallback, s.parse(s.vectorTile, i.layerIndex, this.availableImages, i.actor, n)), e1(t1, r);
                    };
                    "parsing" === s.status ? s.reloadCallback = a : "done" === s.status && (s.vectorTile ? s.parse(s.vectorTile, this.layerIndex, this.availableImages, this.actor, a) : a());
                }
            }
            abortTile(t1, e1) {
                const r = t1.uid, n = this.loading[r];
                n && (n.abort && n.abort(), delete this.loading[r]), e1();
            }
            removeTile(t1, e1) {
                const r = this.loaded, n = t1.uid;
                r && r[n] && delete r[n], e1();
            }
        }, t1.WritingMode = sp, t1.ZoomHistory = Gi, t1.add = Ul, t1.addDynamicAttributes = pd, t1.adjoint = function(t1, e1) {
            var r = e1[0], n = e1[1], i = e1[2], s = e1[3], a = e1[4], o = e1[5], l = e1[6], u = e1[7], c = e1[8];
            return t1[0] = a * c - o * u, t1[1] = i * u - n * c, t1[2] = n * o - i * a, t1[3] = o * l - s * c, t1[4] = r * c - i * l, t1[5] = i * s - r * o, t1[6] = s * u - a * l, t1[7] = n * l - r * u, t1[8] = r * a - n * s, t1;
        }, t1.asyncAll = M, t1.bezier = w, t1.bindAll = V, t1.boundsAttributes = jd, t1.bufferConvexPolygon = function(t1, e1) {
            const r = [];
            for(let n = 0; n < t1.length; n++){
                const i = I(n - 1, -1, t1.length - 1), s = I(n + 1, -1, t1.length - 1), a = t1[n], o = t1[s], l = t1[i].sub(a).unit(), u = o.sub(a).unit(), c = u.angleWithSep(l.x, l.y), h = l.add(u).unit().mult(-1 * e1 / Math.sin(c / 2));
                r.push(a.add(h));
            }
            return r;
        }, t1.cacheEntryPossiblyAdded = function(t1) {
            it++, it > tt && (t1.getActor().send("enforceCacheSizeLimit", Q), it = 0);
        }, t1.calculateGlobeLabelMatrix = function(t1, e1) {
            const { x: r , y: n  } = t1.point, i = Cf(r, n, t1.worldSize / t1._pixelsPerMercatorPixel, 0, 0);
            return Ml(i, i, Pf(vf(e1)));
        }, t1.calculateGlobeMatrix = function(t1) {
            const { x: e1 , y: r  } = t1.point, { lng: n , lat: i  } = t1._center;
            return Cf(e1, r, t1.worldSize, n, i);
        }, t1.calculateGlobeMercatorMatrix = function(t1) {
            const e1 = t1.pixelsPerMeter, r = e1 / Ro(1, t1.center.lat), n = kl(new Float64Array(16));
            return zl(n, n, [
                t1.point.x,
                t1.point.y,
                0
            ]), Tl(n, n, [
                r,
                r,
                e1
            ]), Float32Array.from(n);
        }, t1.circumferenceAtLatitude = Vo, t1.clamp = S, t1.clearTileCache = function(t1) {
            if (!et()) return;
            const r = e1.caches.delete(Y);
            t1 && r.catch(t1).then(()=>t1());
        }, t1.clipLine = Tp, t1.clone = function(t1) {
            var e1 = new wl(16);
            return e1[0] = t1[0], e1[1] = t1[1], e1[2] = t1[2], e1[3] = t1[3], e1[4] = t1[4], e1[5] = t1[5], e1[6] = t1[6], e1[7] = t1[7], e1[8] = t1[8], e1[9] = t1[9], e1[10] = t1[10], e1[11] = t1[11], e1[12] = t1[12], e1[13] = t1[13], e1[14] = t1[14], e1[15] = t1[15], e1;
        }, t1.clone$1 = U, t1.collisionCircleLayout = bh, t1.config = i, t1.conjugate = function(t1, e1) {
            return t1[0] = -e1[0], t1[1] = -e1[1], t1[2] = -e1[2], t1[3] = e1[3], t1;
        }, t1.create = function() {
            var t1 = new wl(16);
            return wl != Float32Array && (t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[11] = 0, t1[12] = 0, t1[13] = 0, t1[14] = 0), t1[0] = 1, t1[5] = 1, t1[10] = 1, t1[15] = 1, t1;
        }, t1.create$1 = Al, t1.createExpression = Nn, t1.createLayout = ia, t1.createStyleLayer = function(t1) {
            return "custom" === t1.type ? new Ad(t1) : new Id[t1.type](t1);
        }, t1.cross = Kl, t1.degToRad = x, t1.distance = function(t1, e1) {
            return Math.hypot(e1[0] - t1[0], e1[1] - t1[1], e1[2] - t1[2]);
        }, t1.div = function(t1, e1, r) {
            return t1[0] = e1[0] / r[0], t1[1] = e1[1] / r[1], t1[2] = e1[2] / r[2], t1;
        }, t1.dot = Xl, t1.earthRadius = Po, t1.ease = A, t1.easeCubicInOut = _, t1.ecefToLatLng = function([t1, e1, r]) {
            const n = Math.hypot(t1, e1, r), i = Math.atan2(t1, r), s = .5 * Math.PI - Math.acos(-e1 / n);
            return new Co(v(i), v(s));
        }, t1.emitValidationErrors = Fi, t1.endsWith = F, t1.enforceCacheSizeLimit = function(t1) {
            rt(), W && W.then((e1)=>{
                e1.keys().then((r)=>{
                    for(let n = 0; n < r.length - t1; n++)e1.delete(r[n]);
                });
            });
        }, t1.evaluateSizeForFeature = Sh, t1.evaluateSizeForZoom = kh, t1.evaluateVariableOffset = Kp, t1.evented = Vs, t1.exactEquals = function(t1, e1) {
            return t1[0] === e1[0] && t1[1] === e1[1] && t1[2] === e1[2] && t1[3] === e1[3];
        }, t1.exactEquals$1 = function(t1, e1) {
            return t1[0] === e1[0] && t1[1] === e1[1] && t1[2] === e1[2];
        }, t1.exported = qt, t1.exported$1 = s, t1.extend = T, t1.extend$1 = Yt, t1.fillExtrusionHeightLift = Nc, t1.filterObject = R, t1.fromMat4 = function(t1, e1) {
            return t1[0] = e1[0], t1[1] = e1[1], t1[2] = e1[2], t1[3] = e1[4], t1[4] = e1[5], t1[5] = e1[6], t1[6] = e1[8], t1[7] = e1[9], t1[8] = e1[10], t1;
        }, t1.fromQuat = function(t1, e1) {
            var r = e1[0], n = e1[1], i = e1[2], s = e1[3], a = r + r, o = n + n, l = i + i, u = r * a, c = n * a, h = n * o, p = i * a, f = i * o, d = i * l, y = s * a, m = s * o, g = s * l;
            return t1[0] = 1 - h - d, t1[1] = c + g, t1[2] = p - m, t1[3] = 0, t1[4] = c - g, t1[5] = 1 - u - d, t1[6] = f + y, t1[7] = 0, t1[8] = p + m, t1[9] = f - y, t1[10] = 1 - u - h, t1[11] = 0, t1[12] = 0, t1[13] = 0, t1[14] = 0, t1[15] = 1, t1;
        }, t1.fromRotation = function(t1, e1) {
            var r = Math.sin(e1), n = Math.cos(e1);
            return t1[0] = n, t1[1] = r, t1[2] = 0, t1[3] = -r, t1[4] = n, t1[5] = 0, t1[6] = 0, t1[7] = 0, t1[8] = 1, t1;
        }, t1.fromScaling = Pl, t1.furthestTileCorner = function(t1) {
            const e1 = Math.round((t1 + 45 + 360) % 360 / 90) % 4;
            return b[e1];
        }, t1.getAABBPointSquareDist = function(t1, e1, r) {
            let n = 0;
            for(let i = 0; i < 2; ++i){
                const s = r ? r[i] : 0;
                t1[i] > s && (n += (t1[i] - s) * (t1[i] - s)), e1[i] < s && (n += (s - e1[i]) * (s - e1[i]));
            }
            return n;
        }, t1.getAnchorAlignment = gp, t1.getAnchorJustification = Yp, t1.getBounds = function(t1) {
            let e1 = 1 / 0, r = 1 / 0, n = -1 / 0, i = -1 / 0;
            for (const s of t1)e1 = Math.min(e1, s.x), r = Math.min(r, s.y), n = Math.max(n, s.x), i = Math.max(i, s.y);
            return {
                min: new d(e1, r),
                max: new d(n, i)
            };
        }, t1.getColumn = H, t1.getGridMatrix = function(t1, e1, r, n) {
            const i = e1.getNorth(), s = e1.getSouth(), a = e1.getWest(), o = e1.getEast(), l = 1 << t1.z, u = o - a, c = i - s, h = u / hf, p = -c / pf[r], f = [
                0,
                h,
                0,
                p,
                0,
                0,
                i,
                a,
                0
            ];
            if (t1.z > 0) {
                const t2 = 180 / n;
                Sl(f, f, [
                    t2 / u + 1,
                    0,
                    0,
                    0,
                    t2 / c + 1,
                    0,
                    -0.5 * t2 / h,
                    .5 * t2 / p,
                    1
                ]);
            }
            return f[2] = l, f[5] = t1.x, f[8] = t1.y, f;
        }, t1.getImage = dt, t1.getJSON = function(t1, e1) {
            return lt(T(t1, {
                type: "json"
            }), e1);
        }, t1.getLatitudinalLod = function(t1) {
            const e1 = 80.051129;
            t1 = S(t1, -80.051129, e1) / e1 * 90;
            const r = Math.pow(Math.abs(Math.sin(x(t1))), 3);
            return Math.round(r * (pf.length - 1));
        }, t1.getMapSessionAPI = Pt, t1.getPerformanceMeasurement = Rt, t1.getProjection = od, t1.getRTLTextPluginStatus = Fs, t1.getReferrer = ot, t1.getTilePoint = function(t1, { x: e1 , y: r  }, n = 0) {
            return new d(((e1 - n) * t1.scale - t1.x) * Bo, (r * t1.scale - t1.y) * Bo);
        }, t1.getTileVec3 = function(t1, e1, r = 0) {
            return Rl(((e1.x - r) * t1.scale - t1.x) * Bo, (e1.y * t1.scale - t1.y) * Bo, $o(e1.z, e1.y));
        }, t1.getVideo = function(t1, r) {
            const n = e1.document.createElement("video");
            n.muted = !0, n.onloadstart = function() {
                r(null, n);
            };
            for(let r1 = 0; r1 < t1.length; r1++){
                const i = e1.document.createElement("source");
                ct(t1[r1]) || (n.crossOrigin = "Anonymous"), i.src = t1[r1], n.appendChild(i);
            }
            return {
                cancel: ()=>{}
            };
        }, t1.globeCenterToScreenPoint = function(t1) {
            const e1 = [
                0,
                0,
                0
            ], r = kl(new Float64Array(16));
            return Ml(r, t1.pixelMatrix, t1.globeMatrix), Hl(e1, e1, r), new d(e1[0], e1[1]);
        }, t1.globeDenormalizeECEF = Pf, t1.globeECEFOrigin = function(t1, e1) {
            const r = [
                0,
                0,
                0
            ];
            return Hl(r, r, Ef(vf(e1.canonical))), Hl(r, r, t1), r;
        }, t1.globeNormalizeECEF = Ef, t1.globePixelsToTileUnits = function(t1, e1) {
            return Bo / (512 * Math.pow(2, t1)) * Tf(vf(e1));
        }, t1.globePoleMatrixForTile = function(t1, e1, r) {
            const n = kl(new Float64Array(16)), i = (e1 / (1 << t1) - .5) * Math.PI * 2;
            return El(n, r.globeMatrix, i), Float32Array.from(n);
        }, t1.globeTileBounds = vf, t1.globeTiltAtLngLat = Vf, t1.globeToMercatorTransition = Df, t1.globeUseCustomAntiAliasing = function(t1, e1, r) {
            const n = Df(r.zoom), i = t1.style.map._antialias, s = !!e1.extStandardDerivatives, a = e1.extStandardDerivativesForceOff || t1.terrain && t1.terrain.exaggeration() > 0;
            return 0 === n && !i && !a && s;
        }, t1.identity = kl, t1.identity$1 = su, t1.invert = Il, t1.isFullscreen = function() {
            return !!e1.document.fullscreenElement || !!e1.document.webkitFullscreenElement;
        }, t1.isLngLatBehindGlobe = function(t1, e1) {
            return Vf(t1, e1) > Math.PI / 2 * 1.01;
        }, t1.isMapAuthenticated = function(t1) {
            return Ct.has(t1);
        }, t1.isMapboxURL = mt, t1.isSafariWithAntialiasingBug = function(t1) {
            const e1 = t1.navigator ? t1.navigator.userAgent : null;
            return !!X(t1) && e1 && (e1.match("Version/15.4") || e1.match("Version/15.5") || e1.match(/CPU (OS|iPhone OS) (15_4|15_5) like Mac OS X/));
        }, t1.latFromMercatorY = jo, t1.latLngToECEF = Mf, t1.len = tu, t1.length = Ll, t1.length$1 = function(t1) {
            return Math.hypot(t1[0], t1[1], t1[2], t1[3]);
        }, t1.lngFromMercatorX = Uo, t1.loadVectorTile = _y, t1.makeRequest = lt, t1.mapValue = function(t1, e1, r, n, i) {
            return S((t1 - e1) / (r - e1) * (i - n) + n, n, i);
        }, t1.mercatorScale = qo, t1.mercatorXfromLng = Fo, t1.mercatorYfromLat = Lo, t1.mercatorZfromAltitude = Ro, t1.mul = Dl, t1.mul$1 = Ql, t1.multiply = Ml, t1.multiply$1 = Sl, t1.multiply$2 = $l, t1.nextPowerOfTwo = C, t1.normalize = Zl, t1.normalize$1 = lu, t1.normalize$2 = ru, t1.number = Ir, t1.ortho = function(t1, e1, r, n, i, s, a) {
            var o = 1 / (e1 - r), l = 1 / (n - i), u = 1 / (s - a);
            return t1[0] = -2 * o, t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[5] = -2 * l, t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[10] = 2 * u, t1[11] = 0, t1[12] = (e1 + r) * o, t1[13] = (i + n) * l, t1[14] = (a + s) * u, t1[15] = 1, t1;
        }, t1.pbf = Eh, t1.perspective = function(t1, e1, r, n, i) {
            var s, a = 1 / Math.tan(e1 / 2);
            return t1[0] = a / r, t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[5] = a, t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[11] = -1, t1[12] = 0, t1[13] = 0, t1[15] = 0, null != i && i !== 1 / 0 ? (t1[10] = (i + n) * (s = 1 / (n - i)), t1[14] = 2 * i * n * s) : (t1[10] = -1, t1[14] = -2 * n), t1;
        }, t1.pick = function(t1, e1) {
            const r = {};
            for(let n = 0; n < e1.length; n++){
                const i = e1[n];
                i in t1 && (r[i] = t1[i]);
            }
            return r;
        }, t1.plugin = Rs, t1.pointGeometry = d, t1.polygonContainsPoint = pl, t1.polygonIntersectsBox = fl, t1.polygonIntersectsPolygon = nl, t1.polygonizeBounds = function(t1, e1, r = 0, n = !0) {
            const i = new d(r, r), s = t1.sub(i), a = e1.add(i), o = [
                s,
                new d(a.x, s.y),
                a,
                new d(s.x, a.y)
            ];
            return n && o.push(s.clone()), o;
        }, t1.posAttributes = lf, t1.postMapLoadEvent = zt, t1.postPerformanceEvent = Bt, t1.postTurnstileEvent = It, t1.potpack = rp, t1.prevPowerOfTwo = function(t1) {
            return t1 <= 1 ? 1 : Math.pow(2, Math.floor(Math.log(t1) / Math.LN2));
        }, t1.radToDeg = v, t1.refProperties = [
            "type",
            "source",
            "source-layer",
            "minzoom",
            "maxzoom",
            "filter",
            "layout"
        ], t1.registerForPluginStateChange = function(t1) {
            return t1({
                pluginStatus: Es,
                pluginURL: Ps
            }), Vs.on("pluginStateChange", t1), t1;
        }, t1.removeAuthState = function(t1) {
            Ct.delete(t1);
        }, t1.renderColorRamp = ku, t1.resample = Zo, t1.rotateX = Bl, t1.rotateX$1 = au, t1.rotateY = El, t1.rotateY$1 = ou, t1.rotateZ = function(t1, e1, r) {
            var n = Math.sin(r), i = Math.cos(r), s = e1[0], a = e1[1], o = e1[2], l = e1[3], u = e1[4], c = e1[5], h = e1[6], p = e1[7];
            return e1 !== t1 && (t1[8] = e1[8], t1[9] = e1[9], t1[10] = e1[10], t1[11] = e1[11], t1[12] = e1[12], t1[13] = e1[13], t1[14] = e1[14], t1[15] = e1[15]), t1[0] = s * i + u * n, t1[1] = a * i + c * n, t1[2] = o * i + h * n, t1[3] = l * i + p * n, t1[4] = u * i - s * n, t1[5] = c * i - a * n, t1[6] = h * i - o * n, t1[7] = p * i - l * n, t1;
        }, t1.rotateZ$1 = function(t1, e1, r) {
            r *= .5;
            var n = e1[0], i = e1[1], s = e1[2], a = e1[3], o = Math.sin(r), l = Math.cos(r);
            return t1[0] = n * l + i * o, t1[1] = i * l - n * o, t1[2] = s * l + a * o, t1[3] = a * l - s * o, t1;
        }, t1.scale = Tl, t1.scale$1 = eu, t1.scale$2 = Nl, t1.scaleAndAdd = Gl, t1.set = function(t1, e1, r, n) {
            return t1[0] = e1, t1[1] = r, t1[2] = n, t1;
        }, t1.setCacheLimits = function(t1, e1) {
            Q = t1, tt = e1;
        }, t1.setColumn = function(t1, e1, r) {
            t1[4 * e1 + 0] = r[0], t1[4 * e1 + 1] = r[1], t1[4 * e1 + 2] = r[2], t1[4 * e1 + 3] = r[3];
        }, t1.setRTLTextPlugin = function(t1, e1, r = !1) {
            if (Es === Ms || Es === zs || Es === Ts) throw new Error("setRTLTextPlugin cannot be called multiple times.");
            Ps = qt.resolveURL(t1), Es = Ms, Bs = e1, Ds(), r || Ls();
        }, t1.smoothstep = k, t1.spec = Ht, t1.squaredLength = function(t1) {
            var e1 = t1[0], r = t1[1], n = t1[2];
            return e1 * e1 + r * r + n * n;
        }, t1.storeAuthState = function(t1, e1) {
            e1 ? Ct.add(t1) : Ct.delete(t1);
        }, t1.sub = Jl, t1.subtract = jl, t1.symbolSize = Ih, t1.tileAABB = function(t1, e1, r, n, i, s, a, o, l) {
            if ("globe" === l.name) return Af(t1, e1, new Hc(r, n, i));
            const u = jf({
                z: r,
                x: n,
                y: i
            }, l);
            return new pu([
                (s + u.x / u.scale) * e1,
                e1 * (u.y / u.scale),
                a
            ], [
                (s + u.x2 / u.scale) * e1,
                e1 * (u.y2 / u.scale),
                o
            ]);
        }, t1.tileCornersToBounds = Sf, t1.tileTransform = jf, t1.transformMat3 = function(t1, e1, r) {
            var n = e1[0], i = e1[1], s = e1[2];
            return t1[0] = n * r[0] + i * r[3] + s * r[6], t1[1] = n * r[1] + i * r[4] + s * r[7], t1[2] = n * r[2] + i * r[5] + s * r[8], t1;
        }, t1.transformMat4 = Hl, t1.transformMat4$1 = nu, t1.transformQuat = Yl, t1.transitionTileAABBinECEF = _f, t1.translate = zl, t1.transpose = function(t1, e1) {
            if (t1 === e1) {
                var r = e1[1], n = e1[2], i = e1[5];
                t1[1] = e1[3], t1[2] = e1[6], t1[3] = r, t1[5] = e1[7], t1[6] = n, t1[7] = i;
            } else t1[0] = e1[0], t1[1] = e1[3], t1[2] = e1[6], t1[3] = e1[1], t1[4] = e1[4], t1[5] = e1[7], t1[6] = e1[2], t1[7] = e1[5], t1[8] = e1[8];
            return t1;
        }, t1.triggerPluginCompletionEvent = Cs, t1.uniqueId = E, t1.updateGlobeVertexNormal = function(t1, e1, r, n, i) {
            const s = 5 * e1 + 2;
            t1.float32[s + 0] = r, t1.float32[s + 1] = n, t1.float32[s + 2] = i;
        }, t1.validateCustomStyleLayer = function(t1) {
            const e1 = [], r = t1.id;
            return void 0 === r && e1.push({
                message: `layers.${r}: missing required property "id"`
            }), void 0 === t1.render && e1.push({
                message: `layers.${r}: missing required method "render"`
            }), t1.renderingMode && "2d" !== t1.renderingMode && "3d" !== t1.renderingMode && e1.push({
                message: `layers.${r}: property "renderingMode" must be either "2d" or "3d"`
            }), e1;
        }, t1.validateFilter = (t1)=>Vi(gi(t1)), t1.validateFog = (t1)=>Vi(zi(t1)), t1.validateLayer = (t1)=>Vi(wi(t1)), t1.validateLight = (t1)=>Vi(Ii(t1)), t1.validateSource = (t1)=>Vi(ki(t1)), t1.validateStyle = Pi, t1.validateTerrain = (t1)=>Vi(Mi(t1)), t1.values = z, t1.vectorTile = gc, t1.version = r, t1.warnOnce = $, t1.window = e1, t1.wrap = I;
    });
    define([
        "./shared"
    ], function(e1) {
        "use strict";
        function t1(e1) {
            if ("number" == typeof e1 || "boolean" == typeof e1 || "string" == typeof e1 || null == e1) return JSON.stringify(e1);
            if (Array.isArray(e1)) {
                let r = "[";
                for (const o of e1)r += `${t1(o)},`;
                return `${r}]`;
            }
            let r1 = "{";
            for (const o1 of Object.keys(e1).sort())r1 += `${o1}:${t1(e1[o1])},`;
            return `${r1}}`;
        }
        function r(r) {
            let o = "";
            for (const n of e1.refProperties)o += `/${t1(r[n])}`;
            return o;
        }
        class o {
            constructor(e1){
                this.keyCache = {}, e1 && this.replace(e1);
            }
            replace(e1) {
                this._layerConfigs = {}, this._layers = {}, this.update(e1, []);
            }
            update(t1, o) {
                for (const r1 of t1)this._layerConfigs[r1.id] = r1, (this._layers[r1.id] = e1.createStyleLayer(r1)).compileFilter(), this.keyCache[r1.id] && delete this.keyCache[r1.id];
                for (const e2 of o)delete this.keyCache[e2], delete this._layerConfigs[e2], delete this._layers[e2];
                this.familiesBySource = {};
                const n = function(e1, t1) {
                    const o = {};
                    for(let n = 0; n < e1.length; n++){
                        const i = t1 && t1[e1[n].id] || r(e1[n]);
                        t1 && (t1[e1[n].id] = i);
                        let s = o[i];
                        s || (s = o[i] = []), s.push(e1[n]);
                    }
                    const n1 = [];
                    for(const e2 in o)n1.push(o[e2]);
                    return n1;
                }(e1.values(this._layerConfigs), this.keyCache);
                for (const e3 of n){
                    const t2 = e3.map((e1)=>this._layers[e1.id]), r2 = t2[0];
                    if ("none" === r2.visibility) continue;
                    const o1 = r2.source || "";
                    let n1 = this.familiesBySource[o1];
                    n1 || (n1 = this.familiesBySource[o1] = {});
                    const i = r2.sourceLayer || "_geojsonTileLayer";
                    let s = n1[i];
                    s || (s = n1[i] = []), s.push(t2);
                }
            }
        }
        class n {
            loadTile(t1, r) {
                const { uid: o , encoding: n , rawImageData: i , padding: s , buildQuadTree: a  } = t1, l = e1.window.ImageBitmap && i instanceof e1.window.ImageBitmap ? this.getImageData(i, s) : i;
                r(null, new e1.DEMData(o, l, n, s < 1, a));
            }
            getImageData(e1, t1) {
                this.offscreenCanvas && this.offscreenCanvasContext || (this.offscreenCanvas = new OffscreenCanvas(e1.width, e1.height), this.offscreenCanvasContext = this.offscreenCanvas.getContext("2d")), this.offscreenCanvas.width = e1.width, this.offscreenCanvas.height = e1.height, this.offscreenCanvasContext.drawImage(e1, 0, 0, e1.width, e1.height);
                const r = this.offscreenCanvasContext.getImageData(-t1, -t1, e1.width + 2 * t1, e1.height + 2 * t1);
                return this.offscreenCanvasContext.clearRect(0, 0, this.offscreenCanvas.width, this.offscreenCanvas.height), r;
            }
        }
        var i = function e1(t1, r) {
            var o, n = t1 && t1.type;
            if ("FeatureCollection" === n) for(o = 0; o < t1.features.length; o++)e1(t1.features[o], r);
            else if ("GeometryCollection" === n) for(o = 0; o < t1.geometries.length; o++)e1(t1.geometries[o], r);
            else if ("Feature" === n) e1(t1.geometry, r);
            else if ("Polygon" === n) s(t1.coordinates, r);
            else if ("MultiPolygon" === n) for(o = 0; o < t1.coordinates.length; o++)s(t1.coordinates[o], r);
            return t1;
        };
        function s(e1, t1) {
            if (0 !== e1.length) {
                a(e1[0], t1);
                for(var r = 1; r < e1.length; r++)a(e1[r], !t1);
            }
        }
        function a(e1, t1) {
            for(var r = 0, o = 0, n = 0, i = e1.length, s = i - 1; n < i; s = n++){
                var a = (e1[n][0] - e1[s][0]) * (e1[s][1] + e1[n][1]), l = r + a;
                o += Math.abs(r) >= Math.abs(a) ? r - l + a : a - l + r, r = l;
            }
            r + o >= 0 != !!t1 && e1.reverse();
        }
        const l = e1.VectorTileFeature.prototype.toGeoJSON;
        class u {
            constructor(t1){
                this._feature = t1, this.extent = e1.EXTENT, this.type = t1.type, this.properties = t1.tags, "id" in t1 && !isNaN(t1.id) && (this.id = parseInt(t1.id, 10));
            }
            loadGeometry() {
                if (1 === this._feature.type) {
                    const t1 = [];
                    for (const r of this._feature.geometry)t1.push([
                        new e1.pointGeometry(r[0], r[1])
                    ]);
                    return t1;
                }
                {
                    const t2 = [];
                    for (const r1 of this._feature.geometry){
                        const o = [];
                        for (const t3 of r1)o.push(new e1.pointGeometry(t3[0], t3[1]));
                        t2.push(o);
                    }
                    return t2;
                }
            }
            toGeoJSON(e1, t1, r) {
                return l.call(this, e1, t1, r);
            }
        }
        class h {
            constructor(t1){
                this.layers = {
                    _geojsonTileLayer: this
                }, this.name = "_geojsonTileLayer", this.extent = e1.EXTENT, this.length = t1.length, this._features = t1;
            }
            feature(e1) {
                return new u(this._features[e1]);
            }
        }
        var c = {
            exports: {}
        }, f = e1.pointGeometry, p = e1.vectorTile.VectorTileFeature, g = d;
        function d(e1, t1) {
            this.options = t1 || {}, this.features = e1, this.length = e1.length;
        }
        function m(e1, t1) {
            this.id = "number" == typeof e1.id ? e1.id : void 0, this.type = e1.type, this.rawGeometry = 1 === e1.type ? [
                e1.geometry
            ] : e1.geometry, this.properties = e1.tags, this.extent = t1 || 4096;
        }
        d.prototype.feature = function(e1) {
            return new m(this.features[e1], this.options.extent);
        }, m.prototype.loadGeometry = function() {
            var e1 = this.rawGeometry;
            this.geometry = [];
            for(var t1 = 0; t1 < e1.length; t1++){
                for(var r = e1[t1], o = [], n = 0; n < r.length; n++)o.push(new f(r[n][0], r[n][1]));
                this.geometry.push(o);
            }
            return this.geometry;
        }, m.prototype.bbox = function() {
            this.geometry || this.loadGeometry();
            for(var e1 = this.geometry, t1 = 1 / 0, r = -1 / 0, o = 1 / 0, n = -1 / 0, i = 0; i < e1.length; i++)for(var s = e1[i], a = 0; a < s.length; a++){
                var l = s[a];
                t1 = Math.min(t1, l.x), r = Math.max(r, l.x), o = Math.min(o, l.y), n = Math.max(n, l.y);
            }
            return [
                t1,
                o,
                r,
                n
            ];
        }, m.prototype.toGeoJSON = p.prototype.toGeoJSON;
        var y = e1.pbf, v = g;
        function x(e1) {
            var t1 = new y;
            return function(e1, t1) {
                for(var r in e1.layers)t1.writeMessage(3, w, e1.layers[r]);
            }(e1, t1), t1.finish();
        }
        function w(e1, t1) {
            var r;
            t1.writeVarintField(15, e1.version || 1), t1.writeStringField(1, e1.name || ""), t1.writeVarintField(5, e1.extent || 4096);
            var o = {
                keys: [],
                values: [],
                keycache: {},
                valuecache: {}
            };
            for(r = 0; r < e1.length; r++)o.feature = e1.feature(r), t1.writeMessage(2, S, o);
            var n = o.keys;
            for(r = 0; r < n.length; r++)t1.writeStringField(3, n[r]);
            var i = o.values;
            for(r = 0; r < i.length; r++)t1.writeMessage(4, I, i[r]);
        }
        function S(e1, t1) {
            var r = e1.feature;
            void 0 !== r.id && t1.writeVarintField(1, r.id), t1.writeMessage(2, M, e1), t1.writeVarintField(3, r.type), t1.writeMessage(4, k, r);
        }
        function M(e1, t1) {
            var r = e1.feature, o = e1.keys, n = e1.values, i = e1.keycache, s = e1.valuecache;
            for(var a in r.properties){
                var l = r.properties[a], u = i[a];
                if (null !== l) {
                    void 0 === u && (o.push(a), i[a] = u = o.length - 1), t1.writeVarint(u);
                    var h = typeof l;
                    "string" !== h && "boolean" !== h && "number" !== h && (l = JSON.stringify(l));
                    var c = h + ":" + l, f = s[c];
                    void 0 === f && (n.push(l), s[c] = f = n.length - 1), t1.writeVarint(f);
                }
            }
        }
        function P(e1, t1) {
            return (t1 << 3) + (7 & e1);
        }
        function b(e1) {
            return e1 << 1 ^ e1 >> 31;
        }
        function k(e1, t1) {
            for(var r = e1.loadGeometry(), o = e1.type, n = 0, i = 0, s = r.length, a = 0; a < s; a++){
                var l = r[a], u = 1;
                1 === o && (u = l.length), t1.writeVarint(P(1, u));
                for(var h = 3 === o ? l.length - 1 : l.length, c = 0; c < h; c++){
                    1 === c && 1 !== o && t1.writeVarint(P(2, h - 1));
                    var f = l[c].x - n, p = l[c].y - i;
                    t1.writeVarint(b(f)), t1.writeVarint(b(p)), n += f, i += p;
                }
                3 === o && t1.writeVarint(P(7, 1));
            }
        }
        function I(e1, t1) {
            var r = typeof e1;
            "string" === r ? t1.writeStringField(1, e1) : "boolean" === r ? t1.writeBooleanField(7, e1) : "number" === r && (e1 % 1 != 0 ? t1.writeDoubleField(3, e1) : e1 < 0 ? t1.writeSVarintField(6, e1) : t1.writeVarintField(5, e1));
        }
        function T(e1, t1, r, o, n, i) {
            if (n - o <= r) return;
            const s = o + n >> 1;
            _(e1, t1, s, o, n, i % 2), T(e1, t1, r, o, s - 1, i + 1), T(e1, t1, r, s + 1, n, i + 1);
        }
        function _(e1, t1, r, o, n, i) {
            for(; n > o;){
                if (n - o > 600) {
                    const s = n - o + 1, a = r - o + 1, l = Math.log(s), u = .5 * Math.exp(2 * l / 3), h = .5 * Math.sqrt(l * u * (s - u) / s) * (a - s / 2 < 0 ? -1 : 1);
                    _(e1, t1, r, Math.max(o, Math.floor(r - a * u / s + h)), Math.min(n, Math.floor(r + (s - a) * u / s + h)), i);
                }
                const s1 = t1[2 * r + i];
                let a1 = o, l1 = n;
                for(L(e1, t1, o, r), t1[2 * n + i] > s1 && L(e1, t1, o, n); a1 < l1;){
                    for(L(e1, t1, a1, l1), a1++, l1--; t1[2 * a1 + i] < s1;)a1++;
                    for(; t1[2 * l1 + i] > s1;)l1--;
                }
                t1[2 * o + i] === s1 ? L(e1, t1, o, l1) : (l1++, L(e1, t1, l1, n)), l1 <= r && (o = l1 + 1), r <= l1 && (n = l1 - 1);
            }
        }
        function L(e1, t1, r, o) {
            C(e1, r, o), C(t1, 2 * r, 2 * o), C(t1, 2 * r + 1, 2 * o + 1);
        }
        function C(e1, t1, r) {
            const o = e1[t1];
            e1[t1] = e1[r], e1[r] = o;
        }
        function O(e1, t1, r, o) {
            const n = e1 - r, i = t1 - o;
            return n * n + i * i;
        }
        c.exports = x, c.exports.fromVectorTileJs = x, c.exports.fromGeojsonVt = function(e1, t1) {
            t1 = t1 || {};
            var r = {};
            for(var o in e1)r[o] = new v(e1[o].features, t1), r[o].name = o, r[o].version = t1.version, r[o].extent = t1.extent;
            return x({
                layers: r
            });
        }, c.exports.GeoJSONWrapper = v;
        const z = (e1)=>e1[0], E = (e1)=>e1[1];
        class F {
            constructor(e1, t1 = z, r = E, o = 64, n = Float64Array){
                this.nodeSize = o, this.points = e1;
                const i = e1.length < 65536 ? Uint16Array : Uint32Array, s = this.ids = new i(e1.length), a = this.coords = new n(2 * e1.length);
                for(let o1 = 0; o1 < e1.length; o1++)s[o1] = o1, a[2 * o1] = t1(e1[o1]), a[2 * o1 + 1] = r(e1[o1]);
                T(s, a, o, 0, s.length - 1, 0);
            }
            range(e1, t1, r, o) {
                return function(e1, t1, r, o, n, i, s) {
                    const a = [
                        0,
                        e1.length - 1,
                        0
                    ], l = [];
                    let u, h;
                    for(; a.length;){
                        const c = a.pop(), f = a.pop(), p = a.pop();
                        if (f - p <= s) {
                            for(let s1 = p; s1 <= f; s1++)u = t1[2 * s1], h = t1[2 * s1 + 1], u >= r && u <= n && h >= o && h <= i && l.push(e1[s1]);
                            continue;
                        }
                        const g = Math.floor((p + f) / 2);
                        u = t1[2 * g], h = t1[2 * g + 1], u >= r && u <= n && h >= o && h <= i && l.push(e1[g]);
                        const d = (c + 1) % 2;
                        (0 === c ? r <= u : o <= h) && (a.push(p), a.push(g - 1), a.push(d)), (0 === c ? n >= u : i >= h) && (a.push(g + 1), a.push(f), a.push(d));
                    }
                    return l;
                }(this.ids, this.coords, e1, t1, r, o, this.nodeSize);
            }
            within(e1, t1, r) {
                return function(e1, t1, r, o, n, i) {
                    const s = [
                        0,
                        e1.length - 1,
                        0
                    ], a = [], l = n * n;
                    for(; s.length;){
                        const u = s.pop(), h = s.pop(), c = s.pop();
                        if (h - c <= i) {
                            for(let n1 = c; n1 <= h; n1++)O(t1[2 * n1], t1[2 * n1 + 1], r, o) <= l && a.push(e1[n1]);
                            continue;
                        }
                        const f = Math.floor((c + h) / 2), p = t1[2 * f], g = t1[2 * f + 1];
                        O(p, g, r, o) <= l && a.push(e1[f]);
                        const d = (u + 1) % 2;
                        (0 === u ? r - n <= p : o - n <= g) && (s.push(c), s.push(f - 1), s.push(d)), (0 === u ? r + n >= p : o + n >= g) && (s.push(f + 1), s.push(h), s.push(d));
                    }
                    return a;
                }(this.ids, this.coords, e1, t1, r, this.nodeSize);
            }
        }
        const N = {
            minZoom: 0,
            maxZoom: 16,
            minPoints: 2,
            radius: 40,
            extent: 512,
            nodeSize: 64,
            log: !1,
            generateId: !1,
            reduce: null,
            map: (e1)=>e1
        }, j = Math.fround || (Z = new Float32Array(1), (e1)=>(Z[0] = +e1, Z[0]));
        var Z;
        class G {
            constructor(e1){
                this.options = $(Object.create(N), e1), this.trees = new Array(this.options.maxZoom + 1);
            }
            load(e1) {
                const { log: t1 , minZoom: r , maxZoom: o , nodeSize: n  } = this.options;
                t1 && console.time("total time");
                const i = `prepare ${e1.length} points`;
                t1 && console.time(i), this.points = e1;
                let s = [];
                for(let t2 = 0; t2 < e1.length; t2++)e1[t2].geometry && s.push(W(e1[t2], t2));
                this.trees[o + 1] = new F(s, B, R, n, Float32Array), t1 && console.timeEnd(i);
                for(let e2 = o; e2 >= r; e2--){
                    const r1 = +Date.now();
                    s = this._cluster(s, e2), this.trees[e2] = new F(s, B, R, n, Float32Array), t1 && console.log("z%d: %d clusters in %dms", e2, s.length, +Date.now() - r1);
                }
                return t1 && console.timeEnd("total time"), this;
            }
            getClusters(e1, t1) {
                let r = ((e1[0] + 180) % 360 + 360) % 360 - 180;
                const o = Math.max(-90, Math.min(90, e1[1]));
                let n = 180 === e1[2] ? 180 : ((e1[2] + 180) % 360 + 360) % 360 - 180;
                const i = Math.max(-90, Math.min(90, e1[3]));
                if (e1[2] - e1[0] >= 360) r = -180, n = 180;
                else if (r > n) {
                    const e2 = this.getClusters([
                        r,
                        o,
                        180,
                        i
                    ], t1), s = this.getClusters([
                        -180,
                        o,
                        n,
                        i
                    ], t1);
                    return e2.concat(s);
                }
                const s1 = this.trees[this._limitZoom(t1)], a = s1.range(V(r), A(i), V(n), A(o)), l = [];
                for (const e3 of a){
                    const t2 = s1.points[e3];
                    l.push(t2.numPoints ? Y(t2) : this.points[t2.index]);
                }
                return l;
            }
            getChildren(e1) {
                const t1 = this._getOriginId(e1), r = this._getOriginZoom(e1), o = "No cluster with the specified id.", n = this.trees[r];
                if (!n) throw new Error(o);
                const i = n.points[t1];
                if (!i) throw new Error(o);
                const s = this.options.radius / (this.options.extent * Math.pow(2, r - 1)), a = n.within(i.x, i.y, s), l = [];
                for (const t2 of a){
                    const r1 = n.points[t2];
                    r1.parentId === e1 && l.push(r1.numPoints ? Y(r1) : this.points[r1.index]);
                }
                if (0 === l.length) throw new Error(o);
                return l;
            }
            getLeaves(e1, t1, r) {
                const o = [];
                return this._appendLeaves(o, e1, t1 = t1 || 10, r = r || 0, 0), o;
            }
            getTile(e1, t1, r) {
                const o = this.trees[this._limitZoom(e1)], n = Math.pow(2, e1), { extent: i , radius: s  } = this.options, a = s / i, l = (r - a) / n, u = (r + 1 + a) / n, h = {
                    features: []
                };
                return this._addTileFeatures(o.range((t1 - a) / n, l, (t1 + 1 + a) / n, u), o.points, t1, r, n, h), 0 === t1 && this._addTileFeatures(o.range(1 - a / n, l, 1, u), o.points, n, r, n, h), t1 === n - 1 && this._addTileFeatures(o.range(0, l, a / n, u), o.points, -1, r, n, h), h.features.length ? h : null;
            }
            getClusterExpansionZoom(e1) {
                let t1 = this._getOriginZoom(e1) - 1;
                for(; t1 <= this.options.maxZoom;){
                    const r = this.getChildren(e1);
                    if (t1++, 1 !== r.length) break;
                    e1 = r[0].properties.cluster_id;
                }
                return t1;
            }
            _appendLeaves(e1, t1, r, o, n) {
                const i = this.getChildren(t1);
                for (const t2 of i){
                    const i1 = t2.properties;
                    if (i1 && i1.cluster ? n + i1.point_count <= o ? n += i1.point_count : n = this._appendLeaves(e1, i1.cluster_id, r, o, n) : n < o ? n++ : e1.push(t2), e1.length === r) break;
                }
                return n;
            }
            _addTileFeatures(e1, t1, r, o, n, i) {
                for (const s of e1){
                    const e2 = t1[s], a = e2.numPoints;
                    let l, u, h;
                    if (a) l = X(e2), u = e2.x, h = e2.y;
                    else {
                        const t2 = this.points[e2.index];
                        l = t2.properties, u = V(t2.geometry.coordinates[0]), h = A(t2.geometry.coordinates[1]);
                    }
                    const c = {
                        type: 1,
                        geometry: [
                            [
                                Math.round(this.options.extent * (u * n - r)),
                                Math.round(this.options.extent * (h * n - o))
                            ]
                        ],
                        tags: l
                    };
                    let f;
                    a ? f = e2.id : this.options.generateId ? f = e2.index : this.points[e2.index].id && (f = this.points[e2.index].id), void 0 !== f && (c.id = f), i.features.push(c);
                }
            }
            _limitZoom(e1) {
                return Math.max(this.options.minZoom, Math.min(Math.floor(+e1), this.options.maxZoom + 1));
            }
            _cluster(e1, t1) {
                const r = [], { radius: o , extent: n , reduce: i , minPoints: s  } = this.options, a = o / (n * Math.pow(2, t1));
                for(let o1 = 0; o1 < e1.length; o1++){
                    const n1 = e1[o1];
                    if (n1.zoom <= t1) continue;
                    n1.zoom = t1;
                    const l = this.trees[t1 + 1], u = l.within(n1.x, n1.y, a), h = n1.numPoints || 1;
                    let c = h;
                    for (const e2 of u){
                        const r1 = l.points[e2];
                        r1.zoom > t1 && (c += r1.numPoints || 1);
                    }
                    if (c > h && c >= s) {
                        let e3 = n1.x * h, s1 = n1.y * h, a1 = i && h > 1 ? this._map(n1, !0) : null;
                        const f = (o1 << 5) + (t1 + 1) + this.points.length;
                        for (const r2 of u){
                            const o2 = l.points[r2];
                            if (o2.zoom <= t1) continue;
                            o2.zoom = t1;
                            const u1 = o2.numPoints || 1;
                            e3 += o2.x * u1, s1 += o2.y * u1, o2.parentId = f, i && (a1 || (a1 = this._map(n1, !0)), i(a1, this._map(o2)));
                        }
                        n1.parentId = f, r.push(J(e3 / c, s1 / c, f, c, a1));
                    } else if (r.push(n1), c > 1) for (const e4 of u){
                        const o3 = l.points[e4];
                        o3.zoom <= t1 || (o3.zoom = t1, r.push(o3));
                    }
                }
                return r;
            }
            _getOriginId(e1) {
                return e1 - this.points.length >> 5;
            }
            _getOriginZoom(e1) {
                return (e1 - this.points.length) % 32;
            }
            _map(e1, t1) {
                if (e1.numPoints) return t1 ? $({}, e1.properties) : e1.properties;
                const r = this.points[e1.index].properties, o = this.options.map(r);
                return t1 && o === r ? $({}, o) : o;
            }
        }
        function J(e1, t1, r, o, n) {
            return {
                x: j(e1),
                y: j(t1),
                zoom: 1 / 0,
                id: r,
                parentId: -1,
                numPoints: o,
                properties: n
            };
        }
        function W(e1, t1) {
            const [r, o] = e1.geometry.coordinates;
            return {
                x: j(V(r)),
                y: j(A(o)),
                zoom: 1 / 0,
                index: t1,
                parentId: -1
            };
        }
        function Y(e1) {
            var t1;
            return {
                type: "Feature",
                id: e1.id,
                properties: X(e1),
                geometry: {
                    type: "Point",
                    coordinates: [
                        (t1 = e1.x, 360 * (t1 - .5)),
                        D(e1.y)
                    ]
                }
            };
        }
        function X(e1) {
            const t1 = e1.numPoints, r = t1 >= 1e4 ? `${Math.round(t1 / 1e3)}k` : t1 >= 1e3 ? Math.round(t1 / 100) / 10 + "k" : t1;
            return $($({}, e1.properties), {
                cluster: !0,
                cluster_id: e1.id,
                point_count: t1,
                point_count_abbreviated: r
            });
        }
        function V(e1) {
            return e1 / 360 + .5;
        }
        function A(e1) {
            const t1 = Math.sin(e1 * Math.PI / 180), r = .5 - .25 * Math.log((1 + t1) / (1 - t1)) / Math.PI;
            return r < 0 ? 0 : r > 1 ? 1 : r;
        }
        function D(e1) {
            const t1 = (180 - 360 * e1) * Math.PI / 180;
            return 360 * Math.atan(Math.exp(t1)) / Math.PI - 90;
        }
        function $(e1, t1) {
            for(const r in t1)e1[r] = t1[r];
            return e1;
        }
        function B(e1) {
            return e1.x;
        }
        function R(e1) {
            return e1.y;
        }
        function q(e1, t1, r, o) {
            for(var n, i = o, s = r - t1 >> 1, a = r - t1, l = e1[t1], u = e1[t1 + 1], h = e1[r], c = e1[r + 1], f = t1 + 3; f < r; f += 3){
                var p = U(e1[f], e1[f + 1], l, u, h, c);
                if (p > i) n = f, i = p;
                else if (p === i) {
                    var g = Math.abs(f - s);
                    g < a && (n = f, a = g);
                }
            }
            i > o && (n - t1 > 3 && q(e1, t1, n, o), e1[n + 2] = i, r - n > 3 && q(e1, n, r, o));
        }
        function U(e1, t1, r, o, n, i) {
            var s = n - r, a = i - o;
            if (0 !== s || 0 !== a) {
                var l = ((e1 - r) * s + (t1 - o) * a) / (s * s + a * a);
                l > 1 ? (r = n, o = i) : l > 0 && (r += s * l, o += a * l);
            }
            return (s = e1 - r) * s + (a = t1 - o) * a;
        }
        function Q(e1, t1, r, o) {
            var n = {
                id: void 0 === e1 ? null : e1,
                type: t1,
                geometry: r,
                tags: o,
                minX: 1 / 0,
                minY: 1 / 0,
                maxX: -1 / 0,
                maxY: -1 / 0
            };
            return function(e1) {
                var t1 = e1.geometry, r = e1.type;
                if ("Point" === r || "MultiPoint" === r || "LineString" === r) H(e1, t1);
                else if ("Polygon" === r || "MultiLineString" === r) for(var o = 0; o < t1.length; o++)H(e1, t1[o]);
                else if ("MultiPolygon" === r) for(o = 0; o < t1.length; o++)for(var n = 0; n < t1[o].length; n++)H(e1, t1[o][n]);
            }(n), n;
        }
        function H(e1, t1) {
            for(var r = 0; r < t1.length; r += 3)e1.minX = Math.min(e1.minX, t1[r]), e1.minY = Math.min(e1.minY, t1[r + 1]), e1.maxX = Math.max(e1.maxX, t1[r]), e1.maxY = Math.max(e1.maxY, t1[r + 1]);
        }
        function K(e1, t1, r, o) {
            if (t1.geometry) {
                var n = t1.geometry.coordinates, i = t1.geometry.type, s = Math.pow(r.tolerance / ((1 << r.maxZoom) * r.extent), 2), a = [], l = t1.id;
                if (r.promoteId ? l = t1.properties[r.promoteId] : r.generateId && (l = o || 0), "Point" === i) ee(n, a);
                else if ("MultiPoint" === i) for(var u = 0; u < n.length; u++)ee(n[u], a);
                else if ("LineString" === i) te(n, a, s, !1);
                else if ("MultiLineString" === i) {
                    if (r.lineMetrics) {
                        for(u = 0; u < n.length; u++)te(n[u], a = [], s, !1), e1.push(Q(l, "LineString", a, t1.properties));
                        return;
                    }
                    re(n, a, s, !1);
                } else if ("Polygon" === i) re(n, a, s, !0);
                else {
                    if ("MultiPolygon" !== i) {
                        if ("GeometryCollection" === i) {
                            for(u = 0; u < t1.geometry.geometries.length; u++)K(e1, {
                                id: l,
                                geometry: t1.geometry.geometries[u],
                                properties: t1.properties
                            }, r, o);
                            return;
                        }
                        throw new Error("Input data is not a valid GeoJSON object.");
                    }
                    for(u = 0; u < n.length; u++){
                        var h = [];
                        re(n[u], h, s, !0), a.push(h);
                    }
                }
                e1.push(Q(l, i, a, t1.properties));
            }
        }
        function ee(e1, t1) {
            t1.push(oe(e1[0])), t1.push(ne(e1[1])), t1.push(0);
        }
        function te(e1, t1, r, o) {
            for(var n, i, s = 0, a = 0; a < e1.length; a++){
                var l = oe(e1[a][0]), u = ne(e1[a][1]);
                t1.push(l), t1.push(u), t1.push(0), a > 0 && (s += o ? (n * u - l * i) / 2 : Math.sqrt(Math.pow(l - n, 2) + Math.pow(u - i, 2))), n = l, i = u;
            }
            var h = t1.length - 3;
            t1[2] = 1, q(t1, 0, h, r), t1[h + 2] = 1, t1.size = Math.abs(s), t1.start = 0, t1.end = t1.size;
        }
        function re(e1, t1, r, o) {
            for(var n = 0; n < e1.length; n++){
                var i = [];
                te(e1[n], i, r, o), t1.push(i);
            }
        }
        function oe(e1) {
            return e1 / 360 + .5;
        }
        function ne(e1) {
            var t1 = Math.sin(e1 * Math.PI / 180), r = .5 - .25 * Math.log((1 + t1) / (1 - t1)) / Math.PI;
            return r < 0 ? 0 : r > 1 ? 1 : r;
        }
        function ie(e1, t1, r, o, n, i, s, a) {
            if (o /= t1, i >= (r /= t1) && s < o) return e1;
            if (s < r || i >= o) return null;
            for(var l = [], u = 0; u < e1.length; u++){
                var h = e1[u], c = h.geometry, f = h.type, p = 0 === n ? h.minX : h.minY, g = 0 === n ? h.maxX : h.maxY;
                if (p >= r && g < o) l.push(h);
                else if (!(g < r || p >= o)) {
                    var d = [];
                    if ("Point" === f || "MultiPoint" === f) se(c, d, r, o, n);
                    else if ("LineString" === f) ae(c, d, r, o, n, !1, a.lineMetrics);
                    else if ("MultiLineString" === f) ue(c, d, r, o, n, !1);
                    else if ("Polygon" === f) ue(c, d, r, o, n, !0);
                    else if ("MultiPolygon" === f) for(var m = 0; m < c.length; m++){
                        var y = [];
                        ue(c[m], y, r, o, n, !0), y.length && d.push(y);
                    }
                    if (d.length) {
                        if (a.lineMetrics && "LineString" === f) {
                            for(m = 0; m < d.length; m++)l.push(Q(h.id, f, d[m], h.tags));
                            continue;
                        }
                        "LineString" !== f && "MultiLineString" !== f || (1 === d.length ? (f = "LineString", d = d[0]) : f = "MultiLineString"), "Point" !== f && "MultiPoint" !== f || (f = 3 === d.length ? "Point" : "MultiPoint"), l.push(Q(h.id, f, d, h.tags));
                    }
                }
            }
            return l.length ? l : null;
        }
        function se(e1, t1, r, o, n) {
            for(var i = 0; i < e1.length; i += 3){
                var s = e1[i + n];
                s >= r && s <= o && (t1.push(e1[i]), t1.push(e1[i + 1]), t1.push(e1[i + 2]));
            }
        }
        function ae(e1, t1, r, o, n, i, s) {
            for(var a, l, u = le(e1), h = 0 === n ? ce : fe, c = e1.start, f = 0; f < e1.length - 3; f += 3){
                var p = e1[f], g = e1[f + 1], d = e1[f + 2], m = e1[f + 3], y = e1[f + 4], v = 0 === n ? p : g, x = 0 === n ? m : y, w = !1;
                s && (a = Math.sqrt(Math.pow(p - m, 2) + Math.pow(g - y, 2))), v < r ? x > r && (l = h(u, p, g, m, y, r), s && (u.start = c + a * l)) : v > o ? x < o && (l = h(u, p, g, m, y, o), s && (u.start = c + a * l)) : he(u, p, g, d), x < r && v >= r && (l = h(u, p, g, m, y, r), w = !0), x > o && v <= o && (l = h(u, p, g, m, y, o), w = !0), !i && w && (s && (u.end = c + a * l), t1.push(u), u = le(e1)), s && (c += a);
            }
            var S = e1.length - 3;
            p = e1[S], g = e1[S + 1], d = e1[S + 2], (v = 0 === n ? p : g) >= r && v <= o && he(u, p, g, d), S = u.length - 3, i && S >= 3 && (u[S] !== u[0] || u[S + 1] !== u[1]) && he(u, u[0], u[1], u[2]), u.length && t1.push(u);
        }
        function le(e1) {
            var t1 = [];
            return t1.size = e1.size, t1.start = e1.start, t1.end = e1.end, t1;
        }
        function ue(e1, t1, r, o, n, i) {
            for(var s = 0; s < e1.length; s++)ae(e1[s], t1, r, o, n, i, !1);
        }
        function he(e1, t1, r, o) {
            e1.push(t1), e1.push(r), e1.push(o);
        }
        function ce(e1, t1, r, o, n, i) {
            var s = (i - t1) / (o - t1);
            return e1.push(i), e1.push(r + (n - r) * s), e1.push(1), s;
        }
        function fe(e1, t1, r, o, n, i) {
            var s = (i - r) / (n - r);
            return e1.push(t1 + (o - t1) * s), e1.push(i), e1.push(1), s;
        }
        function pe(e1, t1) {
            for(var r = [], o = 0; o < e1.length; o++){
                var n, i = e1[o], s = i.type;
                if ("Point" === s || "MultiPoint" === s || "LineString" === s) n = ge(i.geometry, t1);
                else if ("MultiLineString" === s || "Polygon" === s) {
                    n = [];
                    for(var a = 0; a < i.geometry.length; a++)n.push(ge(i.geometry[a], t1));
                } else if ("MultiPolygon" === s) for(n = [], a = 0; a < i.geometry.length; a++){
                    for(var l = [], u = 0; u < i.geometry[a].length; u++)l.push(ge(i.geometry[a][u], t1));
                    n.push(l);
                }
                r.push(Q(i.id, s, n, i.tags));
            }
            return r;
        }
        function ge(e1, t1) {
            var r = [];
            r.size = e1.size, void 0 !== e1.start && (r.start = e1.start, r.end = e1.end);
            for(var o = 0; o < e1.length; o += 3)r.push(e1[o] + t1, e1[o + 1], e1[o + 2]);
            return r;
        }
        function de(e1, t1) {
            if (e1.transformed) return e1;
            var r, o, n, i = 1 << e1.z, s = e1.x, a = e1.y;
            for(r = 0; r < e1.features.length; r++){
                var l = e1.features[r], u = l.geometry, h = l.type;
                if (l.geometry = [], 1 === h) for(o = 0; o < u.length; o += 2)l.geometry.push(me(u[o], u[o + 1], t1, i, s, a));
                else for(o = 0; o < u.length; o++){
                    var c = [];
                    for(n = 0; n < u[o].length; n += 2)c.push(me(u[o][n], u[o][n + 1], t1, i, s, a));
                    l.geometry.push(c);
                }
            }
            return e1.transformed = !0, e1;
        }
        function me(e1, t1, r, o, n, i) {
            return [
                Math.round(r * (e1 * o - n)),
                Math.round(r * (t1 * o - i))
            ];
        }
        function ye(e1, t1, r, o, n) {
            for(var i = t1 === n.maxZoom ? 0 : n.tolerance / ((1 << t1) * n.extent), s = {
                features: [],
                numPoints: 0,
                numSimplified: 0,
                numFeatures: 0,
                source: null,
                x: r,
                y: o,
                z: t1,
                transformed: !1,
                minX: 2,
                minY: 1,
                maxX: -1,
                maxY: 0
            }, a = 0; a < e1.length; a++){
                s.numFeatures++, ve(s, e1[a], i, n);
                var l = e1[a].minX, u = e1[a].minY, h = e1[a].maxX, c = e1[a].maxY;
                l < s.minX && (s.minX = l), u < s.minY && (s.minY = u), h > s.maxX && (s.maxX = h), c > s.maxY && (s.maxY = c);
            }
            return s;
        }
        function ve(e1, t1, r, o) {
            var n = t1.geometry, i = t1.type, s = [];
            if ("Point" === i || "MultiPoint" === i) for(var a = 0; a < n.length; a += 3)s.push(n[a]), s.push(n[a + 1]), e1.numPoints++, e1.numSimplified++;
            else if ("LineString" === i) xe(s, n, e1, r, !1, !1);
            else if ("MultiLineString" === i || "Polygon" === i) for(a = 0; a < n.length; a++)xe(s, n[a], e1, r, "Polygon" === i, 0 === a);
            else if ("MultiPolygon" === i) for(var l = 0; l < n.length; l++){
                var u = n[l];
                for(a = 0; a < u.length; a++)xe(s, u[a], e1, r, !0, 0 === a);
            }
            if (s.length) {
                var h = t1.tags || null;
                if ("LineString" === i && o.lineMetrics) {
                    for(var c in h = {}, t1.tags)h[c] = t1.tags[c];
                    h.mapbox_clip_start = n.start / n.size, h.mapbox_clip_end = n.end / n.size;
                }
                var f = {
                    geometry: s,
                    type: "Polygon" === i || "MultiPolygon" === i ? 3 : "LineString" === i || "MultiLineString" === i ? 2 : 1,
                    tags: h
                };
                null !== t1.id && (f.id = t1.id), e1.features.push(f);
            }
        }
        function xe(e1, t1, r, o, n, i) {
            var s = o * o;
            if (o > 0 && t1.size < (n ? s : o)) r.numPoints += t1.length / 3;
            else {
                for(var a = [], l = 0; l < t1.length; l += 3)(0 === o || t1[l + 2] > s) && (r.numSimplified++, a.push(t1[l]), a.push(t1[l + 1])), r.numPoints++;
                n && function(e1, t1) {
                    for(var r = 0, o = 0, n = e1.length, i = n - 2; o < n; i = o, o += 2)r += (e1[o] - e1[i]) * (e1[o + 1] + e1[i + 1]);
                    if (r > 0 === t1) for(o = 0, n = e1.length; o < n / 2; o += 2){
                        var s = e1[o], a = e1[o + 1];
                        e1[o] = e1[n - 2 - o], e1[o + 1] = e1[n - 1 - o], e1[n - 2 - o] = s, e1[n - 1 - o] = a;
                    }
                }(a, i), e1.push(a);
            }
        }
        function we(e1, t1) {
            var r = (t1 = this.options = function(e1, t1) {
                for(var r in t1)e1[r] = t1[r];
                return e1;
            }(Object.create(this.options), t1)).debug;
            if (r && console.time("preprocess data"), t1.maxZoom < 0 || t1.maxZoom > 24) throw new Error("maxZoom should be in the 0-24 range");
            if (t1.promoteId && t1.generateId) throw new Error("promoteId and generateId cannot be used together.");
            var o = function(e1, t1) {
                var r = [];
                if ("FeatureCollection" === e1.type) for(var o = 0; o < e1.features.length; o++)K(r, e1.features[o], t1, o);
                else K(r, "Feature" === e1.type ? e1 : {
                    geometry: e1
                }, t1);
                return r;
            }(e1, t1);
            this.tiles = {}, this.tileCoords = [], r && (console.timeEnd("preprocess data"), console.log("index: maxZoom: %d, maxPoints: %d", t1.indexMaxZoom, t1.indexMaxPoints), console.time("generate tiles"), this.stats = {}, this.total = 0), o = function(e1, t1) {
                var r = t1.buffer / t1.extent, o = e1, n = ie(e1, 1, -1 - r, r, 0, -1, 2, t1), i = ie(e1, 1, 1 - r, 2 + r, 0, -1, 2, t1);
                return (n || i) && (o = ie(e1, 1, -r, 1 + r, 0, -1, 2, t1) || [], n && (o = pe(n, 1).concat(o)), i && (o = o.concat(pe(i, -1)))), o;
            }(o, t1), o.length && this.splitTile(o, 0, 0, 0), r && (o.length && console.log("features: %d, points: %d", this.tiles[0].numFeatures, this.tiles[0].numPoints), console.timeEnd("generate tiles"), console.log("tiles generated:", this.total, JSON.stringify(this.stats)));
        }
        function Se(e1, t1, r) {
            return 32 * ((1 << e1) * r + t1) + e1;
        }
        function Me(e1, t1) {
            const r = e1.tileID.canonical;
            if (!this._geoJSONIndex) return t1(null, null);
            const o = this._geoJSONIndex.getTile(r.z, r.x, r.y);
            if (!o) return t1(null, null);
            const n = new h(o.features);
            let i = c.exports(n);
            0 === i.byteOffset && i.byteLength === i.buffer.byteLength || (i = new Uint8Array(i)), t1(null, {
                vectorTile: n,
                rawData: i.buffer
            });
        }
        we.prototype.options = {
            maxZoom: 14,
            indexMaxZoom: 5,
            indexMaxPoints: 1e5,
            tolerance: 3,
            extent: 4096,
            buffer: 64,
            lineMetrics: !1,
            promoteId: null,
            generateId: !1,
            debug: 0
        }, we.prototype.splitTile = function(e1, t1, r, o, n, i, s) {
            for(var a = [
                e1,
                t1,
                r,
                o
            ], l = this.options, u = l.debug; a.length;){
                o = a.pop(), r = a.pop(), t1 = a.pop(), e1 = a.pop();
                var h = 1 << t1, c = Se(t1, r, o), f = this.tiles[c];
                if (!f && (u > 1 && console.time("creation"), f = this.tiles[c] = ye(e1, t1, r, o, l), this.tileCoords.push({
                    z: t1,
                    x: r,
                    y: o
                }), u)) {
                    u > 1 && (console.log("tile z%d-%d-%d (features: %d, points: %d, simplified: %d)", t1, r, o, f.numFeatures, f.numPoints, f.numSimplified), console.timeEnd("creation"));
                    var p = "z" + t1;
                    this.stats[p] = (this.stats[p] || 0) + 1, this.total++;
                }
                if (f.source = e1, n) {
                    if (t1 === l.maxZoom || t1 === n) continue;
                    var g = 1 << n - t1;
                    if (r !== Math.floor(i / g) || o !== Math.floor(s / g)) continue;
                } else if (t1 === l.indexMaxZoom || f.numPoints <= l.indexMaxPoints) continue;
                if (f.source = null, 0 !== e1.length) {
                    u > 1 && console.time("clipping");
                    var d, m, y, v, x, w, S = .5 * l.buffer / l.extent, M = .5 - S, P = .5 + S, b = 1 + S;
                    d = m = y = v = null, x = ie(e1, h, r - S, r + P, 0, f.minX, f.maxX, l), w = ie(e1, h, r + M, r + b, 0, f.minX, f.maxX, l), e1 = null, x && (d = ie(x, h, o - S, o + P, 1, f.minY, f.maxY, l), m = ie(x, h, o + M, o + b, 1, f.minY, f.maxY, l), x = null), w && (y = ie(w, h, o - S, o + P, 1, f.minY, f.maxY, l), v = ie(w, h, o + M, o + b, 1, f.minY, f.maxY, l), w = null), u > 1 && console.timeEnd("clipping"), a.push(d || [], t1 + 1, 2 * r, 2 * o), a.push(m || [], t1 + 1, 2 * r, 2 * o + 1), a.push(y || [], t1 + 1, 2 * r + 1, 2 * o), a.push(v || [], t1 + 1, 2 * r + 1, 2 * o + 1);
                }
            }
        }, we.prototype.getTile = function(e1, t1, r) {
            var o = this.options, n = o.extent, i = o.debug;
            if (e1 < 0 || e1 > 24) return null;
            var s = 1 << e1, a = Se(e1, t1 = (t1 % s + s) % s, r);
            if (this.tiles[a]) return de(this.tiles[a], n);
            i > 1 && console.log("drilling down to z%d-%d-%d", e1, t1, r);
            for(var l, u = e1, h = t1, c = r; !l && u > 0;)u--, h = Math.floor(h / 2), c = Math.floor(c / 2), l = this.tiles[Se(u, h, c)];
            return l && l.source ? (i > 1 && console.log("found parent tile z%d-%d-%d", u, h, c), i > 1 && console.time("drilling down"), this.splitTile(l.source, u, h, c, e1, t1, r), i > 1 && console.timeEnd("drilling down"), this.tiles[a] ? de(this.tiles[a], n) : null) : null;
        };
        class Pe extends e1.VectorTileWorkerSource {
            constructor(e1, t1, r, o, n){
                super(e1, t1, r, o, Me), n && (this.loadGeoJSON = n);
            }
            loadData(t1, r) {
                const o = t1 && t1.request, n = o && o.collectResourceTiming;
                this.loadGeoJSON(t1, (s, a)=>{
                    if (s || !a) return r(s);
                    if ("object" != typeof a) return r(new Error(`Input data given to '${t1.source}' is not a valid GeoJSON object.`));
                    {
                        i(a, !0);
                        try {
                            if (t1.filter) {
                                const r1 = e1.createExpression(t1.filter, {
                                    type: "boolean",
                                    "property-type": "data-driven",
                                    overridable: !1,
                                    transition: !1
                                });
                                if ("error" === r1.result) throw new Error(r1.value.map((e1)=>`${e1.key}: ${e1.message}`).join(", "));
                                const o1 = a.features.filter((e1)=>r1.value.evaluate({
                                        zoom: 0
                                    }, e1));
                                a = {
                                    type: "FeatureCollection",
                                    features: o1
                                };
                            }
                            this._geoJSONIndex = t1.cluster ? new G(function({ superclusterOptions: t1 , clusterProperties: r  }) {
                                if (!r || !t1) return t1;
                                const o = {}, n = {}, i = {
                                    accumulated: null,
                                    zoom: 0
                                }, s = {
                                    properties: null
                                }, a = Object.keys(r);
                                for (const t2 of a){
                                    const [i1, s1] = r[t2], a1 = e1.createExpression(s1), l = e1.createExpression("string" == typeof i1 ? [
                                        i1,
                                        [
                                            "accumulated"
                                        ],
                                        [
                                            "get",
                                            t2
                                        ]
                                    ] : i1);
                                    o[t2] = a1.value, n[t2] = l.value;
                                }
                                return t1.map = (e1)=>{
                                    s.properties = e1;
                                    const t1 = {};
                                    for (const e2 of a)t1[e2] = o[e2].evaluate(i, s);
                                    return t1;
                                }, t1.reduce = (e1, t1)=>{
                                    s.properties = t1;
                                    for (const t2 of a)i.accumulated = e1[t2], e1[t2] = n[t2].evaluate(i, s);
                                }, t1;
                            }(t1)).load(a.features) : function(e1, t1) {
                                return new we(e1, t1);
                            }(a, t1.geojsonVtOptions);
                        } catch (s1) {
                            return r(s1);
                        }
                        this.loaded = {};
                        const l = {};
                        if (n) {
                            const r2 = e1.getPerformanceMeasurement(o);
                            r2 && (l.resourceTiming = {}, l.resourceTiming[t1.source] = JSON.parse(JSON.stringify(r2)));
                        }
                        r(null, l);
                    }
                });
            }
            reloadTile(e1, t1) {
                const r = this.loaded;
                return r && r[e1.uid] ? super.reloadTile(e1, t1) : this.loadTile(e1, t1);
            }
            loadGeoJSON(t1, r) {
                if (t1.request) e1.getJSON(t1.request, r);
                else {
                    if ("string" != typeof t1.data) return r(new Error(`Input data given to '${t1.source}' is not a valid GeoJSON object.`));
                    try {
                        return r(null, JSON.parse(t1.data));
                    } catch (e2) {
                        return r(new Error(`Input data given to '${t1.source}' is not a valid GeoJSON object.`));
                    }
                }
            }
            getClusterExpansionZoom(e1, t1) {
                try {
                    t1(null, this._geoJSONIndex.getClusterExpansionZoom(e1.clusterId));
                } catch (e2) {
                    t1(e2);
                }
            }
            getClusterChildren(e1, t1) {
                try {
                    t1(null, this._geoJSONIndex.getChildren(e1.clusterId));
                } catch (e2) {
                    t1(e2);
                }
            }
            getClusterLeaves(e1, t1) {
                try {
                    t1(null, this._geoJSONIndex.getLeaves(e1.clusterId, e1.limit, e1.offset));
                } catch (e2) {
                    t1(e2);
                }
            }
        }
        class be {
            constructor(t1){
                this.self = t1, this.actor = new e1.Actor(t1, this), this.layerIndexes = {}, this.availableImages = {}, this.isSpriteLoaded = {}, this.projections = {}, this.defaultProjection = e1.getProjection({
                    name: "mercator"
                }), this.workerSourceTypes = {
                    vector: e1.VectorTileWorkerSource,
                    geojson: Pe
                }, this.workerSources = {}, this.demWorkerSources = {}, this.self.registerWorkerSource = (e1, t1)=>{
                    if (this.workerSourceTypes[e1]) throw new Error(`Worker source with name "${e1}" already registered.`);
                    this.workerSourceTypes[e1] = t1;
                }, this.self.registerRTLTextPlugin = (t1)=>{
                    if (e1.plugin.isParsed()) throw new Error("RTL text plugin already registered.");
                    e1.plugin.applyArabicShaping = t1.applyArabicShaping, e1.plugin.processBidirectionalText = t1.processBidirectionalText, e1.plugin.processStyledBidirectionalText = t1.processStyledBidirectionalText;
                };
            }
            clearCaches(e1, t1, r) {
                delete this.layerIndexes[e1], delete this.availableImages[e1], delete this.workerSources[e1], delete this.demWorkerSources[e1], r();
            }
            checkIfReady(e1, t1, r) {
                r();
            }
            setReferrer(e1, t1) {
                this.referrer = t1;
            }
            spriteLoaded(t1, r) {
                this.isSpriteLoaded[t1] = r;
                for(const o in this.workerSources[t1]){
                    const n = this.workerSources[t1][o];
                    for(const t2 in n)n[t2] instanceof e1.VectorTileWorkerSource && (n[t2].isSpriteLoaded = r, n[t2].fire(new e1.Event("isSpriteLoaded")));
                }
            }
            setImages(e1, t1, r) {
                this.availableImages[e1] = t1;
                for(const r1 in this.workerSources[e1]){
                    const o = this.workerSources[e1][r1];
                    for(const e2 in o)o[e2].availableImages = t1;
                }
                r();
            }
            enableTerrain(e1, t1, r) {
                this.terrain = t1, r();
            }
            setProjection(t1, r) {
                this.projections[t1] = e1.getProjection(r);
            }
            setLayers(e1, t1, r) {
                this.getLayerIndex(e1).replace(t1), r();
            }
            updateLayers(e1, t1, r) {
                this.getLayerIndex(e1).update(t1.layers, t1.removedIds), r();
            }
            loadTile(t1, r, o) {
                const n = this.enableTerrain ? e1.extend({
                    enableTerrain: this.terrain
                }, r) : r;
                n.projection = this.projections[t1] || this.defaultProjection, this.getWorkerSource(t1, r.type, r.source).loadTile(n, o);
            }
            loadDEMTile(t1, r, o) {
                const n = this.enableTerrain ? e1.extend({
                    buildQuadTree: this.terrain
                }, r) : r;
                this.getDEMWorkerSource(t1, r.source).loadTile(n, o);
            }
            reloadTile(t1, r, o) {
                const n = this.enableTerrain ? e1.extend({
                    enableTerrain: this.terrain
                }, r) : r;
                n.projection = this.projections[t1] || this.defaultProjection, this.getWorkerSource(t1, r.type, r.source).reloadTile(n, o);
            }
            abortTile(e1, t1, r) {
                this.getWorkerSource(e1, t1.type, t1.source).abortTile(t1, r);
            }
            removeTile(e1, t1, r) {
                this.getWorkerSource(e1, t1.type, t1.source).removeTile(t1, r);
            }
            removeSource(e1, t1, r) {
                if (!this.workerSources[e1] || !this.workerSources[e1][t1.type] || !this.workerSources[e1][t1.type][t1.source]) return;
                const o = this.workerSources[e1][t1.type][t1.source];
                delete this.workerSources[e1][t1.type][t1.source], void 0 !== o.removeSource ? o.removeSource(t1, r) : r();
            }
            loadWorkerSource(e1, t1, r) {
                try {
                    this.self.importScripts(t1.url), r();
                } catch (e2) {
                    r(e2.toString());
                }
            }
            syncRTLPluginState(t1, r, o) {
                try {
                    e1.plugin.setState(r);
                    const t2 = e1.plugin.getPluginURL();
                    if (e1.plugin.isLoaded() && !e1.plugin.isParsed() && null != t2) {
                        this.self.importScripts(t2);
                        const r1 = e1.plugin.isParsed();
                        o(r1 ? void 0 : new Error(`RTL Text Plugin failed to import scripts from ${t2}`), r1);
                    }
                } catch (e2) {
                    o(e2.toString());
                }
            }
            getAvailableImages(e1) {
                let t1 = this.availableImages[e1];
                return t1 || (t1 = []), t1;
            }
            getLayerIndex(e1) {
                let t1 = this.layerIndexes[e1];
                return t1 || (t1 = this.layerIndexes[e1] = new o), t1;
            }
            getWorkerSource(e1, t1, r) {
                if (this.workerSources[e1] || (this.workerSources[e1] = {}), this.workerSources[e1][t1] || (this.workerSources[e1][t1] = {}), !this.workerSources[e1][t1][r]) {
                    const o = {
                        send: (t1, r, o, n, i, s)=>{
                            this.actor.send(t1, r, o, e1, i, s);
                        },
                        scheduler: this.actor.scheduler
                    };
                    this.workerSources[e1][t1][r] = new this.workerSourceTypes[t1](o, this.getLayerIndex(e1), this.getAvailableImages(e1), this.isSpriteLoaded[e1]);
                }
                return this.workerSources[e1][t1][r];
            }
            getDEMWorkerSource(e1, t1) {
                return this.demWorkerSources[e1] || (this.demWorkerSources[e1] = {}), this.demWorkerSources[e1][t1] || (this.demWorkerSources[e1][t1] = new n), this.demWorkerSources[e1][t1];
            }
            enforceCacheSizeLimit(t1, r) {
                e1.enforceCacheSizeLimit(r);
            }
            getWorkerPerformanceMetrics(e1, t1, r) {
                r(void 0, void 0);
            }
        }
        return "undefined" != typeof WorkerGlobalScope && "undefined" != typeof self && self instanceof WorkerGlobalScope && (self.worker = new be(self)), be;
    });
    define([
        "./shared"
    ], function(e1) {
        "use strict";
        function t1(e1, i) {
            if (Array.isArray(e1)) {
                if (!Array.isArray(i) || e1.length !== i.length) return !1;
                for(let o = 0; o < e1.length; o++)if (!t1(e1[o], i[o])) return !1;
                return !0;
            }
            if ("object" == typeof e1 && null !== e1 && null !== i) {
                if ("object" != typeof i) return !1;
                if (Object.keys(e1).length !== Object.keys(i).length) return !1;
                for(const o1 in e1)if (!t1(e1[o1], i[o1])) return !1;
                return !0;
            }
            return e1 === i;
        }
        var i = o;
        function o(e1) {
            return !function(e1) {
                var t1;
                return "undefined" == typeof window || "undefined" == typeof document ? "not a browser" : Array.prototype && Array.prototype.every && Array.prototype.filter && Array.prototype.forEach && Array.prototype.indexOf && Array.prototype.lastIndexOf && Array.prototype.map && Array.prototype.some && Array.prototype.reduce && Array.prototype.reduceRight && Array.isArray ? Function.prototype && Function.prototype.bind ? Object.keys && Object.create && Object.getPrototypeOf && Object.getOwnPropertyNames && Object.isSealed && Object.isFrozen && Object.isExtensible && Object.getOwnPropertyDescriptor && Object.defineProperty && Object.defineProperties && Object.seal && Object.freeze && Object.preventExtensions ? "JSON" in window && "parse" in JSON && "stringify" in JSON ? function() {
                    if (!("Worker" in window && "Blob" in window && "URL" in window)) return !1;
                    var e1, t1, i = new Blob([
                        ""
                    ], {
                        type: "text/javascript"
                    }), o = URL.createObjectURL(i);
                    try {
                        t1 = new Worker(o), e1 = !0;
                    } catch (t2) {
                        e1 = !1;
                    }
                    return t1 && t1.terminate(), URL.revokeObjectURL(o), e1;
                }() ? "Uint8ClampedArray" in window ? ArrayBuffer.isView ? function() {
                    var e1 = document.createElement("canvas");
                    e1.width = e1.height = 1;
                    var t1 = e1.getContext("2d");
                    if (!t1) return !1;
                    var i = t1.getImageData(0, 0, 1, 1);
                    return i && i.width === e1.width;
                }() ? (void 0 === r[t1 = e1 && e1.failIfMajorPerformanceCaveat] && (r[t1] = function(e1) {
                    var t1, i = function(e1) {
                        var t1 = document.createElement("canvas"), i = Object.create(o.webGLContextAttributes);
                        return i.failIfMajorPerformanceCaveat = e1, t1.getContext("webgl", i) || t1.getContext("experimental-webgl", i);
                    }(e1);
                    if (!i) return !1;
                    try {
                        t1 = i.createShader(i.VERTEX_SHADER);
                    } catch (e2) {
                        return !1;
                    }
                    return !(!t1 || i.isContextLost()) && (i.shaderSource(t1, "void main() {}"), i.compileShader(t1), !0 === i.getShaderParameter(t1, i.COMPILE_STATUS));
                }(t1)), r[t1] ? document.documentMode ? "insufficient ECMAScript 6 support" : void 0 : "insufficient WebGL support") : "insufficient Canvas/getImageData support" : "insufficient ArrayBuffer support" : "insufficient Uint8ClampedArray support" : "insufficient worker support" : "insufficient JSON support" : "insufficient Object support" : "insufficient Function support" : "insufficent Array support";
            }(e1);
        }
        var r = {};
        function n(t1, i, o) {
            const r = e1.window.document.createElement(t1);
            return void 0 !== i && (r.className = i), o && o.appendChild(r), r;
        }
        function a(t1, i, o) {
            const r = e1.window.document.createElementNS("http://www.w3.org/2000/svg", t1);
            for (const e2 of Object.keys(i))r.setAttributeNS(null, e2, i[e2]);
            return o && o.appendChild(r), r;
        }
        o.webGLContextAttributes = {
            antialias: !1,
            alpha: !0,
            stencil: !0,
            depth: !0
        };
        const s = e1.window.document && e1.window.document.documentElement.style, l = s && void 0 !== s.userSelect ? "userSelect" : "WebkitUserSelect";
        let c;
        function h() {
            s && l && (c = s[l], s[l] = "none");
        }
        function _() {
            s && l && (s[l] = c);
        }
        function u(t1) {
            t1.preventDefault(), t1.stopPropagation(), e1.window.removeEventListener("click", u, !0);
        }
        function d() {
            e1.window.addEventListener("click", u, !0), e1.window.setTimeout(()=>{
                e1.window.removeEventListener("click", u, !0);
            }, 0);
        }
        function p(e1, t1) {
            const i = e1.getBoundingClientRect();
            return g(e1, i, t1);
        }
        function m(e1, t1) {
            const i = e1.getBoundingClientRect(), o = [];
            for(let r = 0; r < t1.length; r++)o.push(g(e1, i, t1[r]));
            return o;
        }
        function f(t1) {
            return void 0 !== e1.window.InstallTrigger && 2 === t1.button && t1.ctrlKey && e1.window.navigator.platform.toUpperCase().indexOf("MAC") >= 0 ? 0 : t1.button;
        }
        function g(t1, i, o) {
            const r = t1.offsetWidth === i.width ? 1 : t1.offsetWidth / i.width;
            return new e1.pointGeometry((o.clientX - i.left) * r, (o.clientY - i.top) * r);
        }
        function v(e1, t1) {
            var i = t1[0], o = t1[1], r = t1[2], n = t1[3], a = i * n - r * o;
            return a ? (e1[0] = n * (a = 1 / a), e1[1] = -o * a, e1[2] = -r * a, e1[3] = i * a, e1) : null;
        }
        function x(e1) {
            const { userImage: t1  } = e1;
            return !!(t1 && t1.render && t1.render()) && (e1.data.replace(new Uint8Array(t1.data.buffer)), !0);
        }
        class y extends e1.Evented {
            constructor(){
                super(), this.images = {}, this.updatedImages = {}, this.callbackDispatchedThisFrame = {}, this.loaded = !1, this.requestors = [], this.patterns = {}, this.atlasImage = new e1.RGBAImage({
                    width: 1,
                    height: 1
                }), this.dirty = !0;
            }
            isLoaded() {
                return this.loaded;
            }
            setLoaded(e1) {
                if (this.loaded !== e1 && (this.loaded = e1, e1)) {
                    for (const { ids: e2 , callback: t1  } of this.requestors)this._notify(e2, t1);
                    this.requestors = [];
                }
            }
            hasImage(e1) {
                return !!this.getImage(e1);
            }
            getImage(e1) {
                return this.images[e1];
            }
            addImage(e1, t1) {
                this._validate(e1, t1) && (this.images[e1] = t1);
            }
            _validate(t1, i) {
                let o = !0;
                return this._validateStretch(i.stretchX, i.data && i.data.width) || (this.fire(new e1.ErrorEvent(new Error(`Image "${t1}" has invalid "stretchX" value`))), o = !1), this._validateStretch(i.stretchY, i.data && i.data.height) || (this.fire(new e1.ErrorEvent(new Error(`Image "${t1}" has invalid "stretchY" value`))), o = !1), this._validateContent(i.content, i) || (this.fire(new e1.ErrorEvent(new Error(`Image "${t1}" has invalid "content" value`))), o = !1), o;
            }
            _validateStretch(e1, t1) {
                if (!e1) return !0;
                let i = 0;
                for (const o of e1){
                    if (o[0] < i || o[1] < o[0] || t1 < o[1]) return !1;
                    i = o[1];
                }
                return !0;
            }
            _validateContent(e1, t1) {
                return !(e1 && (4 !== e1.length || e1[0] < 0 || t1.data.width < e1[0] || e1[1] < 0 || t1.data.height < e1[1] || e1[2] < 0 || t1.data.width < e1[2] || e1[3] < 0 || t1.data.height < e1[3] || e1[2] < e1[0] || e1[3] < e1[1]));
            }
            updateImage(e1, t1) {
                t1.version = this.images[e1].version + 1, this.images[e1] = t1, this.updatedImages[e1] = !0;
            }
            removeImage(e1) {
                const t1 = this.images[e1];
                delete this.images[e1], delete this.patterns[e1], t1.userImage && t1.userImage.onRemove && t1.userImage.onRemove();
            }
            listImages() {
                return Object.keys(this.images);
            }
            getImages(e1, t1) {
                let i = !0;
                if (!this.isLoaded()) for (const t2 of e1)this.images[t2] || (i = !1);
                this.isLoaded() || i ? this._notify(e1, t1) : this.requestors.push({
                    ids: e1,
                    callback: t1
                });
            }
            _notify(t1, i) {
                const o = {};
                for (const i1 of t1){
                    this.images[i1] || this.fire(new e1.Event("styleimagemissing", {
                        id: i1
                    }));
                    const t2 = this.images[i1];
                    t2 ? o[i1] = {
                        data: t2.data.clone(),
                        pixelRatio: t2.pixelRatio,
                        sdf: t2.sdf,
                        version: t2.version,
                        stretchX: t2.stretchX,
                        stretchY: t2.stretchY,
                        content: t2.content,
                        hasRenderCallback: Boolean(t2.userImage && t2.userImage.render)
                    } : e1.warnOnce(`Image "${i1}" could not be loaded. Please make sure you have added the image with map.addImage() or a "sprite" property in your style. You can provide missing images by listening for the "styleimagemissing" map event.`);
                }
                i(null, o);
            }
            getPixelSize() {
                const { width: e1 , height: t1  } = this.atlasImage;
                return {
                    width: e1,
                    height: t1
                };
            }
            getPattern(t1) {
                const i = this.patterns[t1], o = this.getImage(t1);
                if (!o) return null;
                if (i && i.position.version === o.version) return i.position;
                if (i) i.position.version = o.version;
                else {
                    const i1 = {
                        w: o.data.width + 2,
                        h: o.data.height + 2,
                        x: 0,
                        y: 0
                    }, r = new e1.ImagePosition(i1, o);
                    this.patterns[t1] = {
                        bin: i1,
                        position: r
                    };
                }
                return this._updatePatternAtlas(), this.patterns[t1].position;
            }
            bind(t1) {
                const i = t1.gl;
                this.atlasTexture ? this.dirty && (this.atlasTexture.update(this.atlasImage), this.dirty = !1) : this.atlasTexture = new e1.Texture(t1, this.atlasImage, i.RGBA), this.atlasTexture.bind(i.LINEAR, i.CLAMP_TO_EDGE);
            }
            _updatePatternAtlas() {
                const t1 = [];
                for(const e2 in this.patterns)t1.push(this.patterns[e2].bin);
                const { w: i , h: o  } = e1.potpack(t1), r = this.atlasImage;
                r.resize({
                    width: i || 1,
                    height: o || 1
                });
                for(const t2 in this.patterns){
                    const { bin: i1  } = this.patterns[t2], o1 = i1.x + 1, n = i1.y + 1, a = this.images[t2].data, s = a.width, l = a.height;
                    e1.RGBAImage.copy(a, r, {
                        x: 0,
                        y: 0
                    }, {
                        x: o1,
                        y: n
                    }, {
                        width: s,
                        height: l
                    }), e1.RGBAImage.copy(a, r, {
                        x: 0,
                        y: l - 1
                    }, {
                        x: o1,
                        y: n - 1
                    }, {
                        width: s,
                        height: 1
                    }), e1.RGBAImage.copy(a, r, {
                        x: 0,
                        y: 0
                    }, {
                        x: o1,
                        y: n + l
                    }, {
                        width: s,
                        height: 1
                    }), e1.RGBAImage.copy(a, r, {
                        x: s - 1,
                        y: 0
                    }, {
                        x: o1 - 1,
                        y: n
                    }, {
                        width: 1,
                        height: l
                    }), e1.RGBAImage.copy(a, r, {
                        x: 0,
                        y: 0
                    }, {
                        x: o1 + s,
                        y: n
                    }, {
                        width: 1,
                        height: l
                    });
                }
                this.dirty = !0;
            }
            beginFrame() {
                this.callbackDispatchedThisFrame = {};
            }
            dispatchRenderCallbacks(e1) {
                for (const t1 of e1){
                    if (this.callbackDispatchedThisFrame[t1]) continue;
                    this.callbackDispatchedThisFrame[t1] = !0;
                    const e2 = this.images[t1];
                    x(e2) && this.updateImage(t1, e2);
                }
            }
        }
        const b = new e1.Properties({
            anchor: new e1.DataConstantProperty(e1.spec.light.anchor),
            position: new class {
                constructor(){
                    this.specification = e1.spec.light.position;
                }
                possiblyEvaluate(t1, i) {
                    return function([t1, i, o]) {
                        const r = e1.degToRad(i + 90), n = e1.degToRad(o);
                        return {
                            x: t1 * Math.cos(r) * Math.sin(n),
                            y: t1 * Math.sin(r) * Math.sin(n),
                            z: t1 * Math.cos(n),
                            azimuthal: i,
                            polar: o
                        };
                    }(t1.expression.evaluate(i));
                }
                interpolate(t1, i, o) {
                    return {
                        x: e1.number(t1.x, i.x, o),
                        y: e1.number(t1.y, i.y, o),
                        z: e1.number(t1.z, i.z, o),
                        azimuthal: e1.number(t1.azimuthal, i.azimuthal, o),
                        polar: e1.number(t1.polar, i.polar, o)
                    };
                }
            },
            color: new e1.DataConstantProperty(e1.spec.light.color),
            intensity: new e1.DataConstantProperty(e1.spec.light.intensity)
        }), w = "-transition";
        class T extends e1.Evented {
            constructor(t1){
                super(), this._transitionable = new e1.Transitionable(b), this.setLight(t1), this._transitioning = this._transitionable.untransitioned();
            }
            getLight() {
                return this._transitionable.serialize();
            }
            setLight(t1, i = {}) {
                if (!this._validate(e1.validateLight, t1, i)) for(const i1 in t1){
                    const o = t1[i1];
                    e1.endsWith(i1, w) ? this._transitionable.setTransition(i1.slice(0, -w.length), o) : this._transitionable.setValue(i1, o);
                }
            }
            updateTransitions(e1) {
                this._transitioning = this._transitionable.transitioned(e1, this._transitioning);
            }
            hasTransition() {
                return this._transitioning.hasTransition();
            }
            recalculate(e1) {
                this.properties = this._transitioning.possiblyEvaluate(e1);
            }
            _validate(t1, i, o) {
                return (!o || !1 !== o.validate) && e1.emitValidationErrors(this, t1.call(e1.validateStyle, e1.extend({
                    value: i,
                    style: {
                        glyphs: !0,
                        sprite: !0
                    },
                    styleSpec: e1.spec
                })));
            }
        }
        const E = new e1.Properties({
            source: new e1.DataConstantProperty(e1.spec.terrain.source),
            exaggeration: new e1.DataConstantProperty(e1.spec.terrain.exaggeration)
        }), C = "-transition";
        class I extends e1.Evented {
            constructor(t1, i){
                super(), this._transitionable = new e1.Transitionable(E), this.set(t1), this._transitioning = this._transitionable.untransitioned(), this.drapeRenderMode = i;
            }
            get() {
                return this._transitionable.serialize();
            }
            set(t1) {
                for(const i in t1){
                    const o = t1[i];
                    e1.endsWith(i, C) ? this._transitionable.setTransition(i.slice(0, -C.length), o) : this._transitionable.setValue(i, o);
                }
            }
            updateTransitions(e1) {
                this._transitioning = this._transitionable.transitioned(e1, this._transitioning);
            }
            hasTransition() {
                return this._transitioning.hasTransition();
            }
            recalculate(e1) {
                this.properties = this._transitioning.possiblyEvaluate(e1);
            }
        }
        function M(t1, i, o, r) {
            const n = e1.smoothstep(45, 65, o), [a, s] = S(t1, r), l = e1.length(i);
            let c = 1 - Math.min(1, Math.exp((l - a) / (s - a) * -6));
            return c *= c * c, c = Math.min(1, 1.00747 * c), c * n * t1.alpha;
        }
        function S(e1, t1) {
            const i = .5 / Math.tan(.5 * t1);
            return [
                e1.range[0] + i,
                e1.range[1] + i
            ];
        }
        const z = new e1.Properties({
            range: new e1.DataConstantProperty(e1.spec.fog.range),
            color: new e1.DataConstantProperty(e1.spec.fog.color),
            "high-color": new e1.DataConstantProperty(e1.spec.fog["high-color"]),
            "space-color": new e1.DataConstantProperty(e1.spec.fog["space-color"]),
            "horizon-blend": new e1.DataConstantProperty(e1.spec.fog["horizon-blend"]),
            "star-intensity": new e1.DataConstantProperty(e1.spec.fog["star-intensity"])
        }), D = "-transition";
        class A extends e1.Evented {
            constructor(t1, i){
                super(), this._transitionable = new e1.Transitionable(z), this.set(t1), this._transitioning = this._transitionable.untransitioned(), this._transform = i;
            }
            get state() {
                const t1 = this._transform, i = "globe" === t1.projection.name, o = e1.globeToMercatorTransition(t1.zoom), r = this.properties.get("range"), n = [
                    .5,
                    3
                ];
                return {
                    range: i ? [
                        e1.number(n[0], r[0], o),
                        e1.number(n[1], r[1], o)
                    ] : r,
                    horizonBlend: this.properties.get("horizon-blend"),
                    alpha: this.properties.get("color").a
                };
            }
            get() {
                return this._transitionable.serialize();
            }
            set(t1, i = {}) {
                if (!this._validate(e1.validateFog, t1, i)) {
                    for (const i1 of Object.keys(e1.spec.fog))t1 && void 0 === t1[i1] && (t1[i1] = e1.spec.fog[i1].default);
                    for(const i2 in t1){
                        const o = t1[i2];
                        e1.endsWith(i2, D) ? this._transitionable.setTransition(i2.slice(0, -D.length), o) : this._transitionable.setValue(i2, o);
                    }
                }
            }
            getOpacity(t1) {
                if (!this._transform.projection.supportsFog) return 0;
                const i = this.properties && this.properties.get("color") || 1;
                return ("globe" === this._transform.projection.name ? 1 : e1.smoothstep(45, 65, t1)) * i.a;
            }
            getOpacityAtLatLng(t1, i) {
                return this._transform.projection.supportsFog ? function(t1, i, o) {
                    const r = e1.MercatorCoordinate.fromLngLat(i), n = o.elevation ? o.elevation.getAtPointOrZero(r) : 0, a = [
                        r.x,
                        r.y,
                        n
                    ];
                    return e1.transformMat4(a, a, o.mercatorFogMatrix), M(t1, a, o.pitch, o._fov);
                }(this.state, t1, i) : 0;
            }
            getFovAdjustedRange(e1) {
                return this._transform.projection.supportsFog ? S(this.state, e1) : [
                    0,
                    1
                ];
            }
            updateTransitions(e1) {
                this._transitioning = this._transitionable.transitioned(e1, this._transitioning);
            }
            hasTransition() {
                return this._transitioning.hasTransition();
            }
            recalculate(e1) {
                this.properties = this._transitioning.possiblyEvaluate(e1);
            }
            _validate(t1, i, o) {
                return (!o || !1 !== o.validate) && e1.emitValidationErrors(this, t1.call(e1.validateStyle, e1.extend({
                    value: i,
                    style: {
                        glyphs: !0,
                        sprite: !0
                    },
                    styleSpec: e1.spec
                })));
            }
        }
        class P {
            constructor(t1, i){
                this.workerPool = t1, this.actors = [], this.currentActor = 0, this.id = e1.uniqueId();
                const o = this.workerPool.acquire(this.id);
                for(let e2 = 0; e2 < o.length; e2++){
                    const t2 = new P.Actor(o[e2], i, this.id);
                    t2.name = `Worker ${e2}`, this.actors.push(t2);
                }
                this.ready = !1, this.broadcast("checkIfReady", null, ()=>{
                    this.ready = !0;
                });
            }
            broadcast(t1, i, o) {
                e1.asyncAll(this.actors, (e1, o)=>{
                    e1.send(t1, i, o);
                }, o = o || function() {});
            }
            getActor() {
                return this.currentActor = (this.currentActor + 1) % this.actors.length, this.actors[this.currentActor];
            }
            remove() {
                this.actors.forEach((e1)=>{
                    e1.remove();
                }), this.actors = [], this.workerPool.release(this.id);
            }
        }
        function L(t1, i, o) {
            return i * (e1.EXTENT / (t1.tileSize * Math.pow(2, o - t1.tileID.overscaledZ)));
        }
        P.Actor = e1.Actor;
        class R {
            constructor(e1, t1, i, o){
                this.screenBounds = e1, this.cameraPoint = t1, this._screenRaycastCache = {}, this._cameraRaycastCache = {}, this.isAboveHorizon = i, this.screenGeometry = this.bufferedScreenGeometry(0), this.screenGeometryMercator = this._bufferedScreenMercator(0, o);
            }
            static createFromScreenPoints(t1, i) {
                let o, r;
                if (t1 instanceof e1.pointGeometry || "number" == typeof t1[0]) {
                    const n = e1.pointGeometry.convert(t1);
                    o = [
                        n
                    ], r = i.isPointAboveHorizon(n);
                } else {
                    const n1 = e1.pointGeometry.convert(t1[0]), a = e1.pointGeometry.convert(t1[1]);
                    o = [
                        n1,
                        a
                    ], r = e1.polygonizeBounds(n1, a).every((e1)=>i.isPointAboveHorizon(e1));
                }
                return new R(o, i.getCameraPoint(), r, i);
            }
            isPointQuery() {
                return 1 === this.screenBounds.length;
            }
            bufferedScreenGeometry(t1) {
                return e1.polygonizeBounds(this.screenBounds[0], 1 === this.screenBounds.length ? this.screenBounds[0] : this.screenBounds[1], t1);
            }
            bufferedCameraGeometry(t1) {
                const i = this.screenBounds[0], o = 1 === this.screenBounds.length ? this.screenBounds[0].add(new e1.pointGeometry(1, 1)) : this.screenBounds[1], r = e1.polygonizeBounds(i, o, 0, !1);
                return this.cameraPoint.y > o.y && (this.cameraPoint.x > i.x && this.cameraPoint.x < o.x ? r.splice(3, 0, this.cameraPoint) : this.cameraPoint.x >= o.x ? r[2] = this.cameraPoint : this.cameraPoint.x <= i.x && (r[3] = this.cameraPoint)), e1.bufferConvexPolygon(r, t1);
            }
            bufferedCameraGeometryGlobe(t1) {
                const i = this.screenBounds[0], o = 1 === this.screenBounds.length ? this.screenBounds[0].add(new e1.pointGeometry(1, 1)) : this.screenBounds[1], r = e1.polygonizeBounds(i, o, t1), n = this.cameraPoint.clone();
                switch(3 * ((n.y > i.y) + (n.y > o.y)) + ((n.x > i.x) + (n.x > o.x))){
                    case 0:
                        r[0] = n, r[4] = n.clone();
                        break;
                    case 1:
                        r.splice(1, 0, n);
                        break;
                    case 2:
                        r[1] = n;
                        break;
                    case 3:
                        r.splice(4, 0, n);
                        break;
                    case 5:
                        r.splice(2, 0, n);
                        break;
                    case 6:
                        r[3] = n;
                        break;
                    case 7:
                        r.splice(3, 0, n);
                        break;
                    case 8:
                        r[2] = n;
                }
                return r;
            }
            containsTile(t1, i, o, r = 0) {
                const n = t1.queryPadding / i._pixelsPerMercatorPixel + 1, a = o ? this._bufferedCameraMercator(n, i) : this._bufferedScreenMercator(n, i);
                let s = t1.tileID.wrap + (a.unwrapped ? r : 0);
                const l = a.polygon.map((i)=>e1.getTilePoint(t1.tileTransform, i, s));
                if (!e1.polygonIntersectsBox(l, 0, 0, e1.EXTENT, e1.EXTENT)) return;
                s = t1.tileID.wrap + (this.screenGeometryMercator.unwrapped ? r : 0);
                const c = this.screenGeometryMercator.polygon.map((i)=>e1.getTileVec3(t1.tileTransform, i, s)), h = c.map((t1)=>new e1.pointGeometry(t1[0], t1[1])), _ = i.getFreeCameraOptions().position || new e1.MercatorCoordinate(0, 0, 0), u = e1.getTileVec3(t1.tileTransform, _, s), d = c.map((t1)=>{
                    const i = e1.sub(t1, t1, u);
                    return e1.normalize(i, i), new e1.Ray(u, i);
                }), p = L(t1, 1, i.zoom) * i._pixelsPerMercatorPixel;
                var m;
                return {
                    queryGeometry: this,
                    tilespaceGeometry: h,
                    tilespaceRays: d,
                    bufferedTilespaceGeometry: l,
                    bufferedTilespaceBounds: (m = e1.getBounds(l), m.min.x = e1.clamp(m.min.x, 0, e1.EXTENT), m.min.y = e1.clamp(m.min.y, 0, e1.EXTENT), m.max.x = e1.clamp(m.max.x, 0, e1.EXTENT), m.max.y = e1.clamp(m.max.y, 0, e1.EXTENT), m),
                    tile: t1,
                    tileID: t1.tileID,
                    pixelToTileUnitsFactor: p
                };
            }
            _bufferedScreenMercator(e1, t1) {
                const i = k(e1);
                if (this._screenRaycastCache[i]) return this._screenRaycastCache[i];
                {
                    let o;
                    return o = "globe" === t1.projection.name ? this._projectAndResample(this.bufferedScreenGeometry(e1), t1) : {
                        polygon: this.bufferedScreenGeometry(e1).map((e1)=>t1.pointCoordinate3D(e1)),
                        unwrapped: !0
                    }, this._screenRaycastCache[i] = o, o;
                }
            }
            _bufferedCameraMercator(e1, t1) {
                const i = k(e1);
                if (this._cameraRaycastCache[i]) return this._cameraRaycastCache[i];
                {
                    let o;
                    return o = "globe" === t1.projection.name ? this._projectAndResample(this.bufferedCameraGeometryGlobe(e1), t1) : {
                        polygon: this.bufferedCameraGeometry(e1).map((e1)=>t1.pointCoordinate3D(e1)),
                        unwrapped: !0
                    }, this._cameraRaycastCache[i] = o, o;
                }
            }
            _projectAndResample(t1, i) {
                const o = function(t1, i) {
                    const o = e1.multiply([], i.pixelMatrix, i.globeMatrix), r = [
                        0,
                        -e1.GLOBE_RADIUS,
                        0,
                        1
                    ], n = [
                        0,
                        e1.GLOBE_RADIUS,
                        0,
                        1
                    ], a = [
                        0,
                        0,
                        0,
                        1
                    ];
                    e1.transformMat4$1(r, r, o), e1.transformMat4$1(n, n, o), e1.transformMat4$1(a, a, o);
                    const s = new e1.pointGeometry(r[0] / r[3], r[1] / r[3]), l = new e1.pointGeometry(n[0] / n[3], n[1] / n[3]), c = e1.polygonContainsPoint(t1, s) && r[3] < a[3], h = e1.polygonContainsPoint(t1, l) && n[3] < a[3];
                    if (!c && !h) return null;
                    const _ = function(e1, t1, i) {
                        for(let o = 1; o < e1.length; o++){
                            const r = B(t1.pointCoordinate3D(e1[o - 1]).x), n = B(t1.pointCoordinate3D(e1[o]).x);
                            if (i < 0) {
                                if (r < n) return {
                                    idx: o,
                                    t: -r / (n - 1 - r)
                                };
                            } else if (n < r) return {
                                idx: o,
                                t: (1 - r) / (n + 1 - r)
                            };
                        }
                        return null;
                    }(t1, i, c ? -1 : 1);
                    if (!_) return null;
                    const { idx: u , t: d  } = _;
                    let p = u > 1 ? O(t1.slice(0, u), i) : [], m = u < t1.length ? O(t1.slice(u), i) : [];
                    p = p.map((t1)=>new e1.pointGeometry(B(t1.x), t1.y)), m = m.map((t1)=>new e1.pointGeometry(B(t1.x), t1.y));
                    const f = [
                        ...p
                    ];
                    0 === f.length && f.push(m[m.length - 1]);
                    const g = e1.number(f[f.length - 1].y, (0 === m.length ? p[0] : m[0]).y, d);
                    let v;
                    return v = c ? [
                        new e1.pointGeometry(0, g),
                        new e1.pointGeometry(0, 0),
                        new e1.pointGeometry(1, 0),
                        new e1.pointGeometry(1, g)
                    ] : [
                        new e1.pointGeometry(1, g),
                        new e1.pointGeometry(1, 1),
                        new e1.pointGeometry(0, 1),
                        new e1.pointGeometry(0, g)
                    ], f.push(...v), 0 === m.length ? f.push(p[0]) : f.push(...m), {
                        polygon: f.map((t1)=>new e1.MercatorCoordinate(t1.x, t1.y)),
                        unwrapped: !1
                    };
                }(t1, i);
                if (o) return o;
                const r = function(t1, i) {
                    let o = !1, r = -1 / 0, n = 0;
                    for(let e2 = 0; e2 < t1.length - 1; e2++)t1[e2].x > r && (r = t1[e2].x, n = e2);
                    for(let e3 = 0; e3 < t1.length - 1; e3++){
                        const i1 = (n + e3) % (t1.length - 1), r1 = t1[i1], a = t1[i1 + 1];
                        Math.abs(r1.x - a.x) > .5 && (r1.x < a.x ? (r1.x += 1, 0 === i1 && (t1[t1.length - 1].x += 1)) : (a.x += 1, i1 + 1 === t1.length - 1 && (t1[0].x += 1)), o = !0);
                    }
                    const a1 = e1.mercatorXfromLng(i.center.lng);
                    return o && a1 < Math.abs(a1 - 1) && t1.forEach((e1)=>{
                        e1.x -= 1;
                    }), {
                        polygon: t1,
                        unwrapped: o
                    };
                }(O(t1, i).map((t1)=>new e1.pointGeometry(B(t1.x), t1.y)), i);
                return {
                    polygon: r.polygon.map((t1)=>new e1.MercatorCoordinate(t1.x, t1.y)),
                    unwrapped: r.unwrapped
                };
            }
        }
        function O(t1, i) {
            return e1.resample(t1, (e1)=>{
                const t1 = i.pointCoordinate3D(e1);
                e1.x = t1.x, e1.y = t1.y;
            }, 1 / 256);
        }
        function B(e1) {
            return e1 < 0 ? 1 + e1 % 1 : e1 % 1;
        }
        function k(e1) {
            return 100 * e1 | 0;
        }
        function F(t1, i, o, r, n) {
            const a = function(o, r) {
                if (o) return n(o);
                if (r) {
                    t1.url && r.tiles && t1.tiles && delete t1.tiles;
                    const o1 = e1.pick(e1.extend(r, t1), [
                        "tiles",
                        "minzoom",
                        "maxzoom",
                        "attribution",
                        "mapbox_logo",
                        "bounds",
                        "scheme",
                        "tileSize",
                        "encoding"
                    ]);
                    r.vector_layers && (o1.vectorLayers = r.vector_layers, o1.vectorLayerIds = o1.vectorLayers.map((e1)=>e1.id)), o1.tiles = i.canonicalizeTileset(o1, t1.url), n(null, o1);
                }
            };
            return t1.url ? e1.getJSON(i.transformRequest(i.normalizeSourceURL(t1.url, null, o, r), e1.ResourceType.Source), a) : e1.exported.frame(()=>a(null, t1));
        }
        class U {
            constructor(t1, i, o){
                this.bounds = e1.LngLatBounds.convert(this.validateBounds(t1)), this.minzoom = i || 0, this.maxzoom = o || 24;
            }
            validateBounds(e1) {
                return Array.isArray(e1) && 4 === e1.length ? [
                    Math.max(-180, e1[0]),
                    Math.max(-90, e1[1]),
                    Math.min(180, e1[2]),
                    Math.min(90, e1[3])
                ] : [
                    -180,
                    -90,
                    180,
                    90
                ];
            }
            contains(t1) {
                const i = Math.pow(2, t1.z), o = Math.floor(e1.mercatorXfromLng(this.bounds.getWest()) * i), r = Math.floor(e1.mercatorYfromLat(this.bounds.getNorth()) * i), n = Math.ceil(e1.mercatorXfromLng(this.bounds.getEast()) * i), a = Math.ceil(e1.mercatorYfromLat(this.bounds.getSouth()) * i);
                return t1.x >= o && t1.x < n && t1.y >= r && t1.y < a;
            }
        }
        class N {
            constructor(e1, t1, i){
                this.context = e1;
                const o = e1.gl;
                this.buffer = o.createBuffer(), this.dynamicDraw = Boolean(i), this.context.unbindVAO(), e1.bindElementBuffer.set(this.buffer), o.bufferData(o.ELEMENT_ARRAY_BUFFER, t1.arrayBuffer, this.dynamicDraw ? o.DYNAMIC_DRAW : o.STATIC_DRAW), this.dynamicDraw || t1.destroy();
            }
            bind() {
                this.context.bindElementBuffer.set(this.buffer);
            }
            updateData(e1) {
                const t1 = this.context.gl;
                this.context.unbindVAO(), this.bind(), t1.bufferSubData(t1.ELEMENT_ARRAY_BUFFER, 0, e1.arrayBuffer);
            }
            destroy() {
                this.buffer && (this.context.gl.deleteBuffer(this.buffer), delete this.buffer);
            }
        }
        const G = {
            Int8: "BYTE",
            Uint8: "UNSIGNED_BYTE",
            Int16: "SHORT",
            Uint16: "UNSIGNED_SHORT",
            Int32: "INT",
            Uint32: "UNSIGNED_INT",
            Float32: "FLOAT"
        };
        class j {
            constructor(e1, t1, i, o){
                this.length = t1.length, this.attributes = i, this.itemSize = t1.bytesPerElement, this.dynamicDraw = o, this.context = e1;
                const r = e1.gl;
                this.buffer = r.createBuffer(), e1.bindVertexBuffer.set(this.buffer), r.bufferData(r.ARRAY_BUFFER, t1.arrayBuffer, this.dynamicDraw ? r.DYNAMIC_DRAW : r.STATIC_DRAW), this.dynamicDraw || t1.destroy();
            }
            bind() {
                this.context.bindVertexBuffer.set(this.buffer);
            }
            updateData(e1) {
                const t1 = this.context.gl;
                this.bind(), t1.bufferSubData(t1.ARRAY_BUFFER, 0, e1.arrayBuffer);
            }
            enableAttributes(e1, t1) {
                for(let i = 0; i < this.attributes.length; i++){
                    const o = t1.attributes[this.attributes[i].name];
                    void 0 !== o && e1.enableVertexAttribArray(o);
                }
            }
            setVertexAttribPointers(e1, t1, i) {
                for(let o = 0; o < this.attributes.length; o++){
                    const r = this.attributes[o], n = t1.attributes[r.name];
                    void 0 !== n && e1.vertexAttribPointer(n, r.components, e1[G[r.type]], !1, this.itemSize, r.offset + this.itemSize * (i || 0));
                }
            }
            destroy() {
                this.buffer && (this.context.gl.deleteBuffer(this.buffer), delete this.buffer);
            }
        }
        class Z {
            constructor(e1){
                this.gl = e1.gl, this.default = this.getDefault(), this.current = this.default, this.dirty = !1;
            }
            get() {
                return this.current;
            }
            set(e1) {}
            getDefault() {
                return this.default;
            }
            setDefault() {
                this.set(this.default);
            }
        }
        class V extends Z {
            getDefault() {
                return e1.Color.transparent;
            }
            set(e1) {
                const t1 = this.current;
                (e1.r !== t1.r || e1.g !== t1.g || e1.b !== t1.b || e1.a !== t1.a || this.dirty) && (this.gl.clearColor(e1.r, e1.g, e1.b, e1.a), this.current = e1, this.dirty = !1);
            }
        }
        class W extends Z {
            getDefault() {
                return 1;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.clearDepth(e1), this.current = e1, this.dirty = !1);
            }
        }
        class X extends Z {
            getDefault() {
                return 0;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.clearStencil(e1), this.current = e1, this.dirty = !1);
            }
        }
        class q extends Z {
            getDefault() {
                return [
                    !0,
                    !0,
                    !0,
                    !0
                ];
            }
            set(e1) {
                const t1 = this.current;
                (e1[0] !== t1[0] || e1[1] !== t1[1] || e1[2] !== t1[2] || e1[3] !== t1[3] || this.dirty) && (this.gl.colorMask(e1[0], e1[1], e1[2], e1[3]), this.current = e1, this.dirty = !1);
            }
        }
        class $ extends Z {
            getDefault() {
                return !0;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.depthMask(e1), this.current = e1, this.dirty = !1);
            }
        }
        class H extends Z {
            getDefault() {
                return 255;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.stencilMask(e1), this.current = e1, this.dirty = !1);
            }
        }
        class Y extends Z {
            getDefault() {
                return {
                    func: this.gl.ALWAYS,
                    ref: 0,
                    mask: 255
                };
            }
            set(e1) {
                const t1 = this.current;
                (e1.func !== t1.func || e1.ref !== t1.ref || e1.mask !== t1.mask || this.dirty) && (this.gl.stencilFunc(e1.func, e1.ref, e1.mask), this.current = e1, this.dirty = !1);
            }
        }
        class K extends Z {
            getDefault() {
                const e1 = this.gl;
                return [
                    e1.KEEP,
                    e1.KEEP,
                    e1.KEEP
                ];
            }
            set(e1) {
                const t1 = this.current;
                (e1[0] !== t1[0] || e1[1] !== t1[1] || e1[2] !== t1[2] || this.dirty) && (this.gl.stencilOp(e1[0], e1[1], e1[2]), this.current = e1, this.dirty = !1);
            }
        }
        class J extends Z {
            getDefault() {
                return !1;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                e1 ? t1.enable(t1.STENCIL_TEST) : t1.disable(t1.STENCIL_TEST), this.current = e1, this.dirty = !1;
            }
        }
        class Q extends Z {
            getDefault() {
                return [
                    0,
                    1
                ];
            }
            set(e1) {
                const t1 = this.current;
                (e1[0] !== t1[0] || e1[1] !== t1[1] || this.dirty) && (this.gl.depthRange(e1[0], e1[1]), this.current = e1, this.dirty = !1);
            }
        }
        class ee extends Z {
            getDefault() {
                return !1;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                e1 ? t1.enable(t1.DEPTH_TEST) : t1.disable(t1.DEPTH_TEST), this.current = e1, this.dirty = !1;
            }
        }
        class te extends Z {
            getDefault() {
                return this.gl.LESS;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.depthFunc(e1), this.current = e1, this.dirty = !1);
            }
        }
        class ie extends Z {
            getDefault() {
                return !1;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                e1 ? t1.enable(t1.BLEND) : t1.disable(t1.BLEND), this.current = e1, this.dirty = !1;
            }
        }
        class oe extends Z {
            getDefault() {
                const e1 = this.gl;
                return [
                    e1.ONE,
                    e1.ZERO
                ];
            }
            set(e1) {
                const t1 = this.current;
                (e1[0] !== t1[0] || e1[1] !== t1[1] || this.dirty) && (this.gl.blendFunc(e1[0], e1[1]), this.current = e1, this.dirty = !1);
            }
        }
        class re extends Z {
            getDefault() {
                return e1.Color.transparent;
            }
            set(e1) {
                const t1 = this.current;
                (e1.r !== t1.r || e1.g !== t1.g || e1.b !== t1.b || e1.a !== t1.a || this.dirty) && (this.gl.blendColor(e1.r, e1.g, e1.b, e1.a), this.current = e1, this.dirty = !1);
            }
        }
        class ne extends Z {
            getDefault() {
                return this.gl.FUNC_ADD;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.blendEquation(e1), this.current = e1, this.dirty = !1);
            }
        }
        class ae extends Z {
            getDefault() {
                return !1;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                e1 ? t1.enable(t1.CULL_FACE) : t1.disable(t1.CULL_FACE), this.current = e1, this.dirty = !1;
            }
        }
        class se extends Z {
            getDefault() {
                return this.gl.BACK;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.cullFace(e1), this.current = e1, this.dirty = !1);
            }
        }
        class le extends Z {
            getDefault() {
                return this.gl.CCW;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.frontFace(e1), this.current = e1, this.dirty = !1);
            }
        }
        class ce extends Z {
            getDefault() {
                return null;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.useProgram(e1), this.current = e1, this.dirty = !1);
            }
        }
        class he extends Z {
            getDefault() {
                return this.gl.TEXTURE0;
            }
            set(e1) {
                (e1 !== this.current || this.dirty) && (this.gl.activeTexture(e1), this.current = e1, this.dirty = !1);
            }
        }
        class _e extends Z {
            getDefault() {
                const e1 = this.gl;
                return [
                    0,
                    0,
                    e1.drawingBufferWidth,
                    e1.drawingBufferHeight
                ];
            }
            set(e1) {
                const t1 = this.current;
                (e1[0] !== t1[0] || e1[1] !== t1[1] || e1[2] !== t1[2] || e1[3] !== t1[3] || this.dirty) && (this.gl.viewport(e1[0], e1[1], e1[2], e1[3]), this.current = e1, this.dirty = !1);
            }
        }
        class ue extends Z {
            getDefault() {
                return null;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                t1.bindFramebuffer(t1.FRAMEBUFFER, e1), this.current = e1, this.dirty = !1;
            }
        }
        class de extends Z {
            getDefault() {
                return null;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                t1.bindRenderbuffer(t1.RENDERBUFFER, e1), this.current = e1, this.dirty = !1;
            }
        }
        class pe extends Z {
            getDefault() {
                return null;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                t1.bindTexture(t1.TEXTURE_2D, e1), this.current = e1, this.dirty = !1;
            }
        }
        class me extends Z {
            getDefault() {
                return null;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                t1.bindBuffer(t1.ARRAY_BUFFER, e1), this.current = e1, this.dirty = !1;
            }
        }
        class fe extends Z {
            getDefault() {
                return null;
            }
            set(e1) {
                const t1 = this.gl;
                t1.bindBuffer(t1.ELEMENT_ARRAY_BUFFER, e1), this.current = e1, this.dirty = !1;
            }
        }
        class ge extends Z {
            constructor(e1){
                super(e1), this.vao = e1.extVertexArrayObject;
            }
            getDefault() {
                return null;
            }
            set(e1) {
                this.vao && (e1 !== this.current || this.dirty) && (this.vao.bindVertexArrayOES(e1), this.current = e1, this.dirty = !1);
            }
        }
        class ve extends Z {
            getDefault() {
                return 4;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                t1.pixelStorei(t1.UNPACK_ALIGNMENT, e1), this.current = e1, this.dirty = !1;
            }
        }
        class xe extends Z {
            getDefault() {
                return !1;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                t1.pixelStorei(t1.UNPACK_PREMULTIPLY_ALPHA_WEBGL, e1), this.current = e1, this.dirty = !1;
            }
        }
        class ye extends Z {
            getDefault() {
                return !1;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                const t1 = this.gl;
                t1.pixelStorei(t1.UNPACK_FLIP_Y_WEBGL, e1), this.current = e1, this.dirty = !1;
            }
        }
        class be extends Z {
            constructor(e1, t1){
                super(e1), this.context = e1, this.parent = t1;
            }
            getDefault() {
                return null;
            }
        }
        class we extends be {
            setDirty() {
                this.dirty = !0;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                this.context.bindFramebuffer.set(this.parent);
                const t1 = this.gl;
                t1.framebufferTexture2D(t1.FRAMEBUFFER, t1.COLOR_ATTACHMENT0, t1.TEXTURE_2D, e1, 0), this.current = e1, this.dirty = !1;
            }
        }
        class Te extends be {
            attachment() {
                return this.gl.DEPTH_ATTACHMENT;
            }
            set(e1) {
                if (e1 === this.current && !this.dirty) return;
                this.context.bindFramebuffer.set(this.parent);
                const t1 = this.gl;
                t1.framebufferRenderbuffer(t1.FRAMEBUFFER, this.attachment(), t1.RENDERBUFFER, e1), this.current = e1, this.dirty = !1;
            }
        }
        class Ee extends Te {
            attachment() {
                return this.gl.DEPTH_STENCIL_ATTACHMENT;
            }
        }
        class Ce {
            constructor(e1, t1, i, o){
                this.context = e1, this.width = t1, this.height = i;
                const r = this.framebuffer = e1.gl.createFramebuffer();
                this.colorAttachment = new we(e1, r), o && (this.depthAttachment = new Te(e1, r));
            }
            destroy() {
                const e1 = this.context.gl, t1 = this.colorAttachment.get();
                if (t1 && e1.deleteTexture(t1), this.depthAttachment) {
                    const t2 = this.depthAttachment.get();
                    t2 && e1.deleteRenderbuffer(t2);
                }
                e1.deleteFramebuffer(this.framebuffer);
            }
        }
        class Ie {
            constructor(e1){
                this.gl = e1, this.extVertexArrayObject = this.gl.getExtension("OES_vertex_array_object"), this.clearColor = new V(this), this.clearDepth = new W(this), this.clearStencil = new X(this), this.colorMask = new q(this), this.depthMask = new $(this), this.stencilMask = new H(this), this.stencilFunc = new Y(this), this.stencilOp = new K(this), this.stencilTest = new J(this), this.depthRange = new Q(this), this.depthTest = new ee(this), this.depthFunc = new te(this), this.blend = new ie(this), this.blendFunc = new oe(this), this.blendColor = new re(this), this.blendEquation = new ne(this), this.cullFace = new ae(this), this.cullFaceSide = new se(this), this.frontFace = new le(this), this.program = new ce(this), this.activeTexture = new he(this), this.viewport = new _e(this), this.bindFramebuffer = new ue(this), this.bindRenderbuffer = new de(this), this.bindTexture = new pe(this), this.bindVertexBuffer = new me(this), this.bindElementBuffer = new fe(this), this.bindVertexArrayOES = this.extVertexArrayObject && new ge(this), this.pixelStoreUnpack = new ve(this), this.pixelStoreUnpackPremultiplyAlpha = new xe(this), this.pixelStoreUnpackFlipY = new ye(this), this.extTextureFilterAnisotropic = e1.getExtension("EXT_texture_filter_anisotropic") || e1.getExtension("MOZ_EXT_texture_filter_anisotropic") || e1.getExtension("WEBKIT_EXT_texture_filter_anisotropic"), this.extTextureFilterAnisotropic && (this.extTextureFilterAnisotropicMax = e1.getParameter(this.extTextureFilterAnisotropic.MAX_TEXTURE_MAX_ANISOTROPY_EXT)), this.extTextureFilterAnisotropicForceOff = !1, this.extStandardDerivativesForceOff = !1, this.extDebugRendererInfo = e1.getExtension("WEBGL_debug_renderer_info"), this.extDebugRendererInfo && (this.renderer = e1.getParameter(this.extDebugRendererInfo.UNMASKED_RENDERER_WEBGL), this.vendor = e1.getParameter(this.extDebugRendererInfo.UNMASKED_VENDOR_WEBGL)), this.extTextureHalfFloat = e1.getExtension("OES_texture_half_float"), this.extTextureHalfFloat && (e1.getExtension("OES_texture_half_float_linear"), this.extRenderToTextureHalfFloat = e1.getExtension("EXT_color_buffer_half_float")), this.extStandardDerivatives = e1.getExtension("OES_standard_derivatives"), this.extTimerQuery = e1.getExtension("EXT_disjoint_timer_query"), this.maxTextureSize = e1.getParameter(e1.MAX_TEXTURE_SIZE);
            }
            setDefault() {
                this.unbindVAO(), this.clearColor.setDefault(), this.clearDepth.setDefault(), this.clearStencil.setDefault(), this.colorMask.setDefault(), this.depthMask.setDefault(), this.stencilMask.setDefault(), this.stencilFunc.setDefault(), this.stencilOp.setDefault(), this.stencilTest.setDefault(), this.depthRange.setDefault(), this.depthTest.setDefault(), this.depthFunc.setDefault(), this.blend.setDefault(), this.blendFunc.setDefault(), this.blendColor.setDefault(), this.blendEquation.setDefault(), this.cullFace.setDefault(), this.cullFaceSide.setDefault(), this.frontFace.setDefault(), this.program.setDefault(), this.activeTexture.setDefault(), this.bindFramebuffer.setDefault(), this.pixelStoreUnpack.setDefault(), this.pixelStoreUnpackPremultiplyAlpha.setDefault(), this.pixelStoreUnpackFlipY.setDefault();
            }
            setDirty() {
                this.clearColor.dirty = !0, this.clearDepth.dirty = !0, this.clearStencil.dirty = !0, this.colorMask.dirty = !0, this.depthMask.dirty = !0, this.stencilMask.dirty = !0, this.stencilFunc.dirty = !0, this.stencilOp.dirty = !0, this.stencilTest.dirty = !0, this.depthRange.dirty = !0, this.depthTest.dirty = !0, this.depthFunc.dirty = !0, this.blend.dirty = !0, this.blendFunc.dirty = !0, this.blendColor.dirty = !0, this.blendEquation.dirty = !0, this.cullFace.dirty = !0, this.cullFaceSide.dirty = !0, this.frontFace.dirty = !0, this.program.dirty = !0, this.activeTexture.dirty = !0, this.viewport.dirty = !0, this.bindFramebuffer.dirty = !0, this.bindRenderbuffer.dirty = !0, this.bindTexture.dirty = !0, this.bindVertexBuffer.dirty = !0, this.bindElementBuffer.dirty = !0, this.extVertexArrayObject && (this.bindVertexArrayOES.dirty = !0), this.pixelStoreUnpack.dirty = !0, this.pixelStoreUnpackPremultiplyAlpha.dirty = !0, this.pixelStoreUnpackFlipY.dirty = !0;
            }
            createIndexBuffer(e1, t1) {
                return new N(this, e1, t1);
            }
            createVertexBuffer(e1, t1, i) {
                return new j(this, e1, t1, i);
            }
            createRenderbuffer(e1, t1, i) {
                const o = this.gl, r = o.createRenderbuffer();
                return this.bindRenderbuffer.set(r), o.renderbufferStorage(o.RENDERBUFFER, e1, t1, i), this.bindRenderbuffer.set(null), r;
            }
            createFramebuffer(e1, t1, i) {
                return new Ce(this, e1, t1, i);
            }
            clear({ color: e1 , depth: t1 , stencil: i  }) {
                const o = this.gl;
                let r = 0;
                e1 && (r |= o.COLOR_BUFFER_BIT, this.clearColor.set(e1), this.colorMask.set([
                    !0,
                    !0,
                    !0,
                    !0
                ])), void 0 !== t1 && (r |= o.DEPTH_BUFFER_BIT, this.depthRange.set([
                    0,
                    1
                ]), this.clearDepth.set(t1), this.depthMask.set(!0)), void 0 !== i && (r |= o.STENCIL_BUFFER_BIT, this.clearStencil.set(i), this.stencilMask.set(255)), o.clear(r);
            }
            setCullFace(e1) {
                !1 === e1.enable ? this.cullFace.set(!1) : (this.cullFace.set(!0), this.cullFaceSide.set(e1.mode), this.frontFace.set(e1.frontFace));
            }
            setDepthMode(e1) {
                e1.func !== this.gl.ALWAYS || e1.mask ? (this.depthTest.set(!0), this.depthFunc.set(e1.func), this.depthMask.set(e1.mask), this.depthRange.set(e1.range)) : this.depthTest.set(!1);
            }
            setStencilMode(e1) {
                e1.test.func !== this.gl.ALWAYS || e1.mask ? (this.stencilTest.set(!0), this.stencilMask.set(e1.mask), this.stencilOp.set([
                    e1.fail,
                    e1.depthFail,
                    e1.pass
                ]), this.stencilFunc.set({
                    func: e1.test.func,
                    ref: e1.ref,
                    mask: e1.test.mask
                })) : this.stencilTest.set(!1);
            }
            setColorMode(i) {
                t1(i.blendFunction, e1.ColorMode.Replace) ? this.blend.set(!1) : (this.blend.set(!0), this.blendFunc.set(i.blendFunction), this.blendColor.set(i.blendColor)), this.colorMask.set(i.mask);
            }
            unbindVAO() {
                this.extVertexArrayObject && this.bindVertexArrayOES.set(null);
            }
        }
        class Me extends e1.Evented {
            constructor(t1, i, o, r){
                super(), this.id = t1, this.dispatcher = o, this.setEventedParent(r), this.type = "raster", this.minzoom = 0, this.maxzoom = 22, this.roundZoom = !0, this.scheme = "xyz", this.tileSize = 512, this._loaded = !1, this._options = e1.extend({
                    type: "raster"
                }, i), e1.extend(this, e1.pick(i, [
                    "url",
                    "scheme",
                    "tileSize"
                ]));
            }
            load() {
                this._loaded = !1, this.fire(new e1.Event("dataloading", {
                    dataType: "source"
                })), this._tileJSONRequest = F(this._options, this.map._requestManager, null, null, (t1, i)=>{
                    this._tileJSONRequest = null, this._loaded = !0, t1 ? this.fire(new e1.ErrorEvent(t1)) : i && (e1.extend(this, i), i.bounds && (this.tileBounds = new U(i.bounds, this.minzoom, this.maxzoom)), e1.postTurnstileEvent(i.tiles), this.fire(new e1.Event("data", {
                        dataType: "source",
                        sourceDataType: "metadata"
                    })), this.fire(new e1.Event("data", {
                        dataType: "source",
                        sourceDataType: "content"
                    })));
                });
            }
            loaded() {
                return this._loaded;
            }
            onAdd(e1) {
                this.map = e1, this.load();
            }
            onRemove() {
                this._tileJSONRequest && (this._tileJSONRequest.cancel(), this._tileJSONRequest = null);
            }
            serialize() {
                return e1.extend({}, this._options);
            }
            hasTile(e1) {
                return !this.tileBounds || this.tileBounds.contains(e1.canonical);
            }
            loadTile(t1, i) {
                const o = e1.exported.devicePixelRatio >= 2, r = this.map._requestManager.normalizeTileURL(t1.tileID.canonical.url(this.tiles, this.scheme), o, this.tileSize);
                t1.request = e1.getImage(this.map._requestManager.transformRequest(r, e1.ResourceType.Tile), (o, r, n, a)=>(delete t1.request, t1.aborted ? (t1.state = "unloaded", i(null)) : o ? (t1.state = "errored", i(o)) : r ? (this.map._refreshExpiredTiles && t1.setExpiryData({
                        cacheControl: n,
                        expires: a
                    }), t1.setTexture(r, this.map.painter), t1.state = "loaded", e1.cacheEntryPossiblyAdded(this.dispatcher), void i(null)) : i(null)));
            }
            static loadTileData(e1, t1, i) {
                e1.setTexture(t1, i);
            }
            static unloadTileData(e1, t1) {
                e1.texture && t1.saveTileTexture(e1.texture);
            }
            abortTile(e1, t1) {
                e1.request && (e1.request.cancel(), delete e1.request), t1();
            }
            unloadTile(e1, t1) {
                e1.texture && this.map.painter.saveTileTexture(e1.texture), t1();
            }
            hasTransition() {
                return !1;
            }
        }
        let Se;
        function ze(t1, i, o, r, n, a, s, l) {
            const c = [
                t1,
                o,
                n,
                i,
                r,
                a,
                1,
                1,
                1
            ], h = [
                s,
                l,
                1
            ], _ = e1.adjoint([], c), [u, d, p] = e1.transformMat3(h, h, e1.transpose(_, _));
            return e1.multiply$1(c, [
                u,
                0,
                0,
                0,
                d,
                0,
                0,
                0,
                p
            ], c);
        }
        class De extends e1.Evented {
            constructor(e1, t1, i, o){
                super(), this.id = e1, this.dispatcher = i, this.coordinates = t1.coordinates, this.type = "image", this.minzoom = 0, this.maxzoom = 22, this.tileSize = 512, this.tiles = {}, this._loaded = !1, this.setEventedParent(o), this.options = t1, this._dirty = !1;
            }
            load(t1, i) {
                this._loaded = i || !1, this.fire(new e1.Event("dataloading", {
                    dataType: "source"
                })), this.url = this.options.url, this._imageRequest = e1.getImage(this.map._requestManager.transformRequest(this.url, e1.ResourceType.Image), (i, o)=>{
                    if (this._imageRequest = null, this._loaded = !0, i) this.fire(new e1.ErrorEvent(i));
                    else if (o) {
                        const { HTMLImageElement: i1  } = e1.window;
                        this.image = o instanceof i1 ? e1.exported.getImageData(o) : o, this._dirty = !0, this.width = this.image.width, this.height = this.image.height, t1 && (this.coordinates = t1), this._finishLoading();
                    }
                });
            }
            loaded() {
                return this._loaded;
            }
            updateImage(e1) {
                return this.image && e1.url ? (this._imageRequest && e1.url !== this.options.url && (this._imageRequest.cancel(), this._imageRequest = null), this.options.url = e1.url, this.load(e1.coordinates, this._loaded), this) : this;
            }
            _finishLoading() {
                this.map && (this.setCoordinates(this.coordinates), this.fire(new e1.Event("data", {
                    dataType: "source",
                    sourceDataType: "metadata"
                })));
            }
            onAdd(e1) {
                this.map = e1, this.load();
            }
            onRemove() {
                this._imageRequest && (this._imageRequest.cancel(), this._imageRequest = null), this.texture && this.texture.destroy();
            }
            setCoordinates(t1) {
                this.coordinates = t1, this._boundsArray = void 0;
                const i = t1.map(e1.MercatorCoordinate.fromLngLat);
                return this.tileID = function(t1) {
                    let i = 1 / 0, o = 1 / 0, r = -1 / 0, n = -1 / 0;
                    for (const e2 of t1)i = Math.min(i, e2.x), o = Math.min(o, e2.y), r = Math.max(r, e2.x), n = Math.max(n, e2.y);
                    const a = Math.max(r - i, n - o), s = Math.max(0, Math.floor(-Math.log(a) / Math.LN2)), l = Math.pow(2, s);
                    return new e1.CanonicalTileID(s, Math.floor((i + r) / 2 * l), Math.floor((o + n) / 2 * l));
                }(i), this.minzoom = this.maxzoom = this.tileID.z, this.fire(new e1.Event("data", {
                    dataType: "source",
                    sourceDataType: "content"
                })), this;
            }
            _clear() {
                this._boundsArray = void 0;
            }
            _prepareData(t1) {
                for(const e2 in this.tiles){
                    const t2 = this.tiles[e2];
                    "loaded" !== t2.state && (t2.state = "loaded", t2.texture = this.texture);
                }
                if (this._boundsArray) return;
                const i = e1.tileTransform(this.tileID, this.map.transform.projection), [o, r, n, a] = this.coordinates.map((t1)=>{
                    const o = i.projection.project(t1[0], t1[1]);
                    return e1.getTilePoint(i, o)._round();
                });
                this.perspectiveTransform = function(t1, i, o, r, n, a, s, l, c, h) {
                    const _ = ze(0, 0, t1, 0, 0, i, t1, i), u = ze(o, r, n, a, s, l, c, h);
                    return e1.multiply$1(u, e1.adjoint(_, _), u), [
                        u[6] / u[8] * t1 / e1.EXTENT,
                        u[7] / u[8] * i / e1.EXTENT
                    ];
                }(this.width, this.height, o.x, o.y, r.x, r.y, a.x, a.y, n.x, n.y);
                const s = this._boundsArray = new e1.StructArrayLayout4i8;
                s.emplaceBack(o.x, o.y, 0, 0), s.emplaceBack(r.x, r.y, e1.EXTENT, 0), s.emplaceBack(a.x, a.y, 0, e1.EXTENT), s.emplaceBack(n.x, n.y, e1.EXTENT, e1.EXTENT), this.boundsBuffer && this.boundsBuffer.destroy(), this.boundsBuffer = t1.createVertexBuffer(s, e1.boundsAttributes.members), this.boundsSegments = e1.SegmentVector.simpleSegment(0, 0, 4, 2);
            }
            prepare() {
                if (0 === Object.keys(this.tiles).length || !this.image) return;
                const t1 = this.map.painter.context, i = t1.gl;
                this._dirty && (this.texture ? this.texture.update(this.image) : (this.texture = new e1.Texture(t1, this.image, i.RGBA), this.texture.bind(i.LINEAR, i.CLAMP_TO_EDGE)), this._dirty = !1), this._prepareData(t1);
            }
            loadTile(e1, t1) {
                this.tileID && this.tileID.equals(e1.tileID.canonical) ? (this.tiles[String(e1.tileID.wrap)] = e1, e1.buckets = {}, t1(null)) : (e1.state = "errored", t1(null));
            }
            serialize() {
                return {
                    type: "image",
                    url: this.options.url,
                    coordinates: this.coordinates
                };
            }
            hasTransition() {
                return !1;
            }
        }
        const Ae = {
            vector: class extends e1.Evented {
                constructor(t1, i, o, r){
                    if (super(), this.id = t1, this.dispatcher = o, this.type = "vector", this.minzoom = 0, this.maxzoom = 22, this.scheme = "xyz", this.tileSize = 512, this.reparseOverscaled = !0, this.isTileClipped = !0, this._loaded = !1, e1.extend(this, e1.pick(i, [
                        "url",
                        "scheme",
                        "tileSize",
                        "promoteId"
                    ])), this._options = e1.extend({
                        type: "vector"
                    }, i), this._collectResourceTiming = i.collectResourceTiming, 512 !== this.tileSize) throw new Error("vector tile sources must have a tileSize of 512");
                    this.setEventedParent(r), this._tileWorkers = {}, this._deduped = new e1.DedupedRequest;
                }
                load(t1) {
                    this._loaded = !1, this.fire(new e1.Event("dataloading", {
                        dataType: "source"
                    }));
                    const i = Array.isArray(this.map._language) ? this.map._language.join() : this.map._language, o = this.map._worldview;
                    this._tileJSONRequest = F(this._options, this.map._requestManager, i, o, (r, n)=>{
                        this._tileJSONRequest = null, this._loaded = !0, r ? (i && console.warn(`Ensure that your requested language string is a valid BCP-47 code or list of codes. Found: ${i}`), o && 2 !== o.length && console.warn(`Requested worldview strings must be a valid ISO alpha-2 code. Found: ${o}`), this.fire(new e1.ErrorEvent(r))) : n && (e1.extend(this, n), n.bounds && (this.tileBounds = new U(n.bounds, this.minzoom, this.maxzoom)), e1.postTurnstileEvent(n.tiles, this.map._requestManager._customAccessToken), this.fire(new e1.Event("data", {
                            dataType: "source",
                            sourceDataType: "metadata"
                        })), this.fire(new e1.Event("data", {
                            dataType: "source",
                            sourceDataType: "content"
                        }))), t1 && t1(r);
                    });
                }
                loaded() {
                    return this._loaded;
                }
                hasTile(e1) {
                    return !this.tileBounds || this.tileBounds.contains(e1.canonical);
                }
                onAdd(e1) {
                    this.map = e1, this.load();
                }
                reload() {
                    this.cancelTileJSONRequest(), this.load(()=>{
                        const e1 = this.map.style._getSourceCaches(this.id);
                        for (const t1 of e1)t1.clearTiles();
                    });
                }
                setSourceProperty(e1) {
                    e1(), this.reload();
                }
                setTiles(e1) {
                    return this._options.tiles = e1, this.reload(), this;
                }
                setUrl(e1) {
                    return this.url = e1, this._options.url = e1, this.reload(), this;
                }
                onRemove() {
                    this.cancelTileJSONRequest();
                }
                serialize() {
                    return e1.extend({}, this._options);
                }
                loadTile(t1, i) {
                    const o = this.map._requestManager.normalizeTileURL(t1.tileID.canonical.url(this.tiles, this.scheme)), r = {
                        request: this.map._requestManager.transformRequest(o, e1.ResourceType.Tile),
                        data: void 0,
                        uid: t1.uid,
                        tileID: t1.tileID,
                        tileZoom: t1.tileZoom,
                        zoom: t1.tileID.overscaledZ,
                        tileSize: this.tileSize * t1.tileID.overscaleFactor(),
                        type: this.type,
                        source: this.id,
                        pixelRatio: e1.exported.devicePixelRatio,
                        showCollisionBoxes: this.map.showCollisionBoxes,
                        promoteId: this.promoteId,
                        isSymbolTile: t1.isSymbolTile
                    };
                    if (r.request.collectResourceTiming = this._collectResourceTiming, t1.actor && "expired" !== t1.state) "loading" === t1.state ? t1.reloadCallback = i : t1.request = t1.actor.send("reloadTile", r, n.bind(this));
                    else if (t1.actor = this._tileWorkers[o] = this._tileWorkers[o] || this.dispatcher.getActor(), this.dispatcher.ready) t1.request = t1.actor.send("loadTile", r, n.bind(this), void 0, !0);
                    else {
                        const i1 = e1.loadVectorTile.call({
                            deduped: this._deduped
                        }, r, (e1, i)=>{
                            e1 || !i ? n.call(this, e1) : (r.data = {
                                cacheControl: i.cacheControl,
                                expires: i.expires,
                                rawData: i.rawData.slice(0)
                            }, t1.actor && t1.actor.send("loadTile", r, n.bind(this), void 0, !0));
                        }, !0);
                        t1.request = {
                            cancel: i1
                        };
                    }
                    function n(o, r) {
                        return delete t1.request, t1.aborted ? i(null) : o && 404 !== o.status ? i(o) : (r && r.resourceTiming && (t1.resourceTiming = r.resourceTiming), this.map._refreshExpiredTiles && r && t1.setExpiryData(r), t1.loadVectorData(r, this.map.painter), e1.cacheEntryPossiblyAdded(this.dispatcher), i(null), void (t1.reloadCallback && (this.loadTile(t1, t1.reloadCallback), t1.reloadCallback = null)));
                    }
                }
                abortTile(e1) {
                    e1.request && (e1.request.cancel(), delete e1.request), e1.actor && e1.actor.send("abortTile", {
                        uid: e1.uid,
                        type: this.type,
                        source: this.id
                    });
                }
                unloadTile(e1) {
                    e1.unloadVectorData(), e1.actor && e1.actor.send("removeTile", {
                        uid: e1.uid,
                        type: this.type,
                        source: this.id
                    });
                }
                hasTransition() {
                    return !1;
                }
                afterUpdate() {
                    this._tileWorkers = {};
                }
                cancelTileJSONRequest() {
                    this._tileJSONRequest && (this._tileJSONRequest.cancel(), this._tileJSONRequest = null);
                }
            },
            raster: Me,
            "raster-dem": class extends Me {
                constructor(t1, i, o, r){
                    super(t1, i, o, r), this.type = "raster-dem", this.maxzoom = 22, this._options = e1.extend({
                        type: "raster-dem"
                    }, i), this.encoding = i.encoding || "mapbox";
                }
                loadTile(t1, i) {
                    const o = this.map._requestManager.normalizeTileURL(t1.tileID.canonical.url(this.tiles, this.scheme), !1, this.tileSize);
                    function r(e1, o) {
                        e1 && (t1.state = "errored", i(e1)), o && (t1.dem = o, t1.dem.onDeserialize(), t1.needsHillshadePrepare = !0, t1.needsDEMTextureUpload = !0, t1.state = "loaded", i(null));
                    }
                    t1.request = e1.getImage(this.map._requestManager.transformRequest(o, e1.ResourceType.Tile), (function(o, n, a, s) {
                        if (delete t1.request, t1.aborted) t1.state = "unloaded", i(null);
                        else if (o) t1.state = "errored", i(o);
                        else if (n) {
                            this.map._refreshExpiredTiles && t1.setExpiryData({
                                cacheControl: a,
                                expires: s
                            });
                            const i1 = e1.window.ImageBitmap && n instanceof e1.window.ImageBitmap && (null == Se && (Se = e1.window.OffscreenCanvas && new e1.window.OffscreenCanvas(1, 1).getContext("2d") && "function" == typeof e1.window.createImageBitmap), Se), o1 = 1 - (n.width - e1.prevPowerOfTwo(n.width)) / 2;
                            o1 < 1 || t1.neighboringTiles || (t1.neighboringTiles = this._getNeighboringTiles(t1.tileID));
                            const l = i1 ? n : e1.exported.getImageData(n, o1), c = {
                                uid: t1.uid,
                                coord: t1.tileID,
                                source: this.id,
                                rawImageData: l,
                                encoding: this.encoding,
                                padding: o1
                            };
                            t1.actor && "expired" !== t1.state || (t1.actor = this.dispatcher.getActor(), t1.actor.send("loadDEMTile", c, r.bind(this), void 0, !0));
                        }
                    }).bind(this));
                }
                _getNeighboringTiles(t1) {
                    const i = t1.canonical, o = Math.pow(2, i.z), r = (i.x - 1 + o) % o, n = 0 === i.x ? t1.wrap - 1 : t1.wrap, a = (i.x + 1 + o) % o, s = i.x + 1 === o ? t1.wrap + 1 : t1.wrap, l = {};
                    return l[new e1.OverscaledTileID(t1.overscaledZ, n, i.z, r, i.y).key] = {
                        backfilled: !1
                    }, l[new e1.OverscaledTileID(t1.overscaledZ, s, i.z, a, i.y).key] = {
                        backfilled: !1
                    }, i.y > 0 && (l[new e1.OverscaledTileID(t1.overscaledZ, n, i.z, r, i.y - 1).key] = {
                        backfilled: !1
                    }, l[new e1.OverscaledTileID(t1.overscaledZ, t1.wrap, i.z, i.x, i.y - 1).key] = {
                        backfilled: !1
                    }, l[new e1.OverscaledTileID(t1.overscaledZ, s, i.z, a, i.y - 1).key] = {
                        backfilled: !1
                    }), i.y + 1 < o && (l[new e1.OverscaledTileID(t1.overscaledZ, n, i.z, r, i.y + 1).key] = {
                        backfilled: !1
                    }, l[new e1.OverscaledTileID(t1.overscaledZ, t1.wrap, i.z, i.x, i.y + 1).key] = {
                        backfilled: !1
                    }, l[new e1.OverscaledTileID(t1.overscaledZ, s, i.z, a, i.y + 1).key] = {
                        backfilled: !1
                    }), l;
                }
                unloadTile(e1) {
                    e1.demTexture && this.map.painter.saveTileTexture(e1.demTexture), e1.fbo && (e1.fbo.destroy(), delete e1.fbo), e1.dem && delete e1.dem, delete e1.neighboringTiles, e1.state = "unloaded";
                }
            },
            geojson: class extends e1.Evented {
                constructor(t1, i, o, r){
                    super(), this.id = t1, this.type = "geojson", this.minzoom = 0, this.maxzoom = 18, this.tileSize = 512, this.isTileClipped = !0, this.reparseOverscaled = !0, this._loaded = !1, this.actor = o.getActor(), this.setEventedParent(r), this._data = i.data, this._options = e1.extend({}, i), this._collectResourceTiming = i.collectResourceTiming, void 0 !== i.maxzoom && (this.maxzoom = i.maxzoom), i.type && (this.type = i.type), i.attribution && (this.attribution = i.attribution), this.promoteId = i.promoteId;
                    const n = e1.EXTENT / this.tileSize;
                    this.workerOptions = e1.extend({
                        source: this.id,
                        cluster: i.cluster || !1,
                        geojsonVtOptions: {
                            buffer: (void 0 !== i.buffer ? i.buffer : 128) * n,
                            tolerance: (void 0 !== i.tolerance ? i.tolerance : .375) * n,
                            extent: e1.EXTENT,
                            maxZoom: this.maxzoom,
                            lineMetrics: i.lineMetrics || !1,
                            generateId: i.generateId || !1
                        },
                        superclusterOptions: {
                            maxZoom: void 0 !== i.clusterMaxZoom ? i.clusterMaxZoom : this.maxzoom - 1,
                            minPoints: Math.max(2, i.clusterMinPoints || 2),
                            extent: e1.EXTENT,
                            radius: (void 0 !== i.clusterRadius ? i.clusterRadius : 50) * n,
                            log: !1,
                            generateId: i.generateId || !1
                        },
                        clusterProperties: i.clusterProperties,
                        filter: i.filter
                    }, i.workerOptions);
                }
                onAdd(e1) {
                    this.map = e1, this.setData(this._data);
                }
                setData(e1) {
                    return this._data = e1, this._updateWorkerData(), this;
                }
                getClusterExpansionZoom(e1, t1) {
                    return this.actor.send("geojson.getClusterExpansionZoom", {
                        clusterId: e1,
                        source: this.id
                    }, t1), this;
                }
                getClusterChildren(e1, t1) {
                    return this.actor.send("geojson.getClusterChildren", {
                        clusterId: e1,
                        source: this.id
                    }, t1), this;
                }
                getClusterLeaves(e1, t1, i, o) {
                    return this.actor.send("geojson.getClusterLeaves", {
                        source: this.id,
                        clusterId: e1,
                        limit: t1,
                        offset: i
                    }, o), this;
                }
                _updateWorkerData() {
                    if (this._pendingLoad) return void (this._coalesce = !0);
                    this.fire(new e1.Event("dataloading", {
                        dataType: "source"
                    })), this._loaded = !1;
                    const t1 = e1.extend({}, this.workerOptions), i = this._data;
                    "string" == typeof i ? (t1.request = this.map._requestManager.transformRequest(e1.exported.resolveURL(i), e1.ResourceType.Source), t1.request.collectResourceTiming = this._collectResourceTiming) : t1.data = JSON.stringify(i), this._pendingLoad = this.actor.send(`${this.type}.loadData`, t1, (t1, i)=>{
                        if (this._loaded = !0, this._pendingLoad = null, t1) this.fire(new e1.ErrorEvent(t1));
                        else {
                            const t2 = {
                                dataType: "source",
                                sourceDataType: this._metadataFired ? "content" : "metadata"
                            };
                            this._collectResourceTiming && i && i.resourceTiming && i.resourceTiming[this.id] && (t2.resourceTiming = i.resourceTiming[this.id]), this.fire(new e1.Event("data", t2)), this._metadataFired = !0;
                        }
                        this._coalesce && (this._updateWorkerData(), this._coalesce = !1);
                    });
                }
                loaded() {
                    return this._loaded;
                }
                loadTile(t1, i) {
                    const o = t1.actor ? "reloadTile" : "loadTile";
                    t1.actor = this.actor, t1.request = this.actor.send(o, {
                        type: this.type,
                        uid: t1.uid,
                        tileID: t1.tileID,
                        tileZoom: t1.tileZoom,
                        zoom: t1.tileID.overscaledZ,
                        maxZoom: this.maxzoom,
                        tileSize: this.tileSize,
                        source: this.id,
                        pixelRatio: e1.exported.devicePixelRatio,
                        showCollisionBoxes: this.map.showCollisionBoxes,
                        promoteId: this.promoteId
                    }, (e1, r)=>(delete t1.request, t1.unloadVectorData(), t1.aborted ? i(null) : e1 ? i(e1) : (t1.loadVectorData(r, this.map.painter, "reloadTile" === o), i(null))), void 0, "loadTile" === o);
                }
                abortTile(e1) {
                    e1.request && (e1.request.cancel(), delete e1.request), e1.aborted = !0;
                }
                unloadTile(e1) {
                    e1.unloadVectorData(), this.actor.send("removeTile", {
                        uid: e1.uid,
                        type: this.type,
                        source: this.id
                    });
                }
                onRemove() {
                    this._pendingLoad && this._pendingLoad.cancel();
                }
                serialize() {
                    return e1.extend({}, this._options, {
                        type: this.type,
                        data: this._data
                    });
                }
                hasTransition() {
                    return !1;
                }
            },
            video: class extends De {
                constructor(e1, t1, i, o){
                    super(e1, t1, i, o), this.roundZoom = !0, this.type = "video", this.options = t1;
                }
                load() {
                    this._loaded = !1;
                    const t1 = this.options;
                    this.urls = [];
                    for (const i of t1.urls)this.urls.push(this.map._requestManager.transformRequest(i, e1.ResourceType.Source).url);
                    e1.getVideo(this.urls, (t1, i)=>{
                        this._loaded = !0, t1 ? this.fire(new e1.ErrorEvent(t1)) : i && (this.video = i, this.video.loop = !0, this.video.setAttribute("playsinline", ""), this.video.addEventListener("playing", ()=>{
                            this.map.triggerRepaint();
                        }), this.map && this.video.play(), this._finishLoading());
                    });
                }
                pause() {
                    this.video && this.video.pause();
                }
                play() {
                    this.video && this.video.play();
                }
                seek(t1) {
                    if (this.video) {
                        const i = this.video.seekable;
                        t1 < i.start(0) || t1 > i.end(0) ? this.fire(new e1.ErrorEvent(new e1.ValidationError(`sources.${this.id}`, null, `Playback for this video can be set only between the ${i.start(0)} and ${i.end(0)}-second mark.`))) : this.video.currentTime = t1;
                    }
                }
                getVideo() {
                    return this.video;
                }
                onAdd(e1) {
                    this.map || (this.map = e1, this.load(), this.video && (this.video.play(), this.setCoordinates(this.coordinates)));
                }
                prepare() {
                    if (0 === Object.keys(this.tiles).length || this.video.readyState < 2) return;
                    const t1 = this.map.painter.context, i = t1.gl;
                    this.texture ? this.video.paused || (this.texture.bind(i.LINEAR, i.CLAMP_TO_EDGE), i.texSubImage2D(i.TEXTURE_2D, 0, 0, 0, i.RGBA, i.UNSIGNED_BYTE, this.video)) : (this.texture = new e1.Texture(t1, this.video, i.RGBA), this.texture.bind(i.LINEAR, i.CLAMP_TO_EDGE), this.width = this.video.videoWidth, this.height = this.video.videoHeight), this._prepareData(t1);
                }
                serialize() {
                    return {
                        type: "video",
                        urls: this.urls,
                        coordinates: this.coordinates
                    };
                }
                hasTransition() {
                    return this.video && !this.video.paused;
                }
            },
            image: De,
            canvas: class extends De {
                constructor(t1, i, o, r){
                    super(t1, i, o, r), i.coordinates ? Array.isArray(i.coordinates) && 4 === i.coordinates.length && !i.coordinates.some((e1)=>!Array.isArray(e1) || 2 !== e1.length || e1.some((e1)=>"number" != typeof e1)) || this.fire(new e1.ErrorEvent(new e1.ValidationError(`sources.${t1}`, null, '"coordinates" property must be an array of 4 longitude/latitude array pairs'))) : this.fire(new e1.ErrorEvent(new e1.ValidationError(`sources.${t1}`, null, 'missing required property "coordinates"'))), i.animate && "boolean" != typeof i.animate && this.fire(new e1.ErrorEvent(new e1.ValidationError(`sources.${t1}`, null, 'optional "animate" property must be a boolean value'))), i.canvas ? "string" == typeof i.canvas || i.canvas instanceof e1.window.HTMLCanvasElement || this.fire(new e1.ErrorEvent(new e1.ValidationError(`sources.${t1}`, null, '"canvas" must be either a string representing the ID of the canvas element from which to read, or an HTMLCanvasElement instance'))) : this.fire(new e1.ErrorEvent(new e1.ValidationError(`sources.${t1}`, null, 'missing required property "canvas"'))), this.options = i, this.animate = void 0 === i.animate || i.animate;
                }
                load() {
                    this._loaded = !0, this.canvas || (this.canvas = this.options.canvas instanceof e1.window.HTMLCanvasElement ? this.options.canvas : e1.window.document.getElementById(this.options.canvas)), this.width = this.canvas.width, this.height = this.canvas.height, this._hasInvalidDimensions() ? this.fire(new e1.ErrorEvent(new Error("Canvas dimensions cannot be less than or equal to zero."))) : (this.play = function() {
                        this._playing = !0, this.map.triggerRepaint();
                    }, this.pause = function() {
                        this._playing && (this.prepare(), this._playing = !1);
                    }, this._finishLoading());
                }
                getCanvas() {
                    return this.canvas;
                }
                onAdd(e1) {
                    this.map = e1, this.load(), this.canvas && this.animate && this.play();
                }
                onRemove() {
                    this.pause();
                }
                prepare() {
                    let t1 = !1;
                    if (this.canvas.width !== this.width && (this.width = this.canvas.width, t1 = !0), this.canvas.height !== this.height && (this.height = this.canvas.height, t1 = !0), this._hasInvalidDimensions()) return;
                    if (0 === Object.keys(this.tiles).length) return;
                    const i = this.map.painter.context;
                    this.texture ? (t1 || this._playing) && this.texture.update(this.canvas, {
                        premultiply: !0
                    }) : this.texture = new e1.Texture(i, this.canvas, i.gl.RGBA, {
                        premultiply: !0
                    }), this._prepareData(i);
                }
                serialize() {
                    return {
                        type: "canvas",
                        coordinates: this.coordinates
                    };
                }
                hasTransition() {
                    return this._playing;
                }
                _hasInvalidDimensions() {
                    for (const e1 of [
                        this.canvas.width,
                        this.canvas.height
                    ])if (isNaN(e1) || e1 <= 0) return !0;
                    return !1;
                }
            },
            custom: class extends e1.Evented {
                constructor(t1, i, o, r){
                    super(), this.id = t1, this.type = "custom", this._dataType = "raster", this._dispatcher = o, this._implementation = i, this.setEventedParent(r), this.scheme = "xyz", this.minzoom = 0, this.maxzoom = 22, this.tileSize = 512, this._loaded = !1, this.roundZoom = !0, this._implementation || this.fire(new e1.ErrorEvent(new Error(`Missing implementation for ${this.id} custom source`))), this._implementation.loadTile || this.fire(new e1.ErrorEvent(new Error(`Missing loadTile implementation for ${this.id} custom source`))), this._implementation.bounds && (this.tileBounds = new U(this._implementation.bounds, this.minzoom, this.maxzoom)), i.update = this._update.bind(this), i.clearTiles = this._clearTiles.bind(this), i.coveringTiles = this._coveringTiles.bind(this), e1.extend(this, e1.pick(i, [
                        "dataType",
                        "scheme",
                        "minzoom",
                        "maxzoom",
                        "tileSize",
                        "attribution",
                        "minTileCacheSize",
                        "maxTileCacheSize"
                    ]));
                }
                serialize() {
                    return e1.pick(this, [
                        "type",
                        "scheme",
                        "minzoom",
                        "maxzoom",
                        "tileSize",
                        "attribution"
                    ]);
                }
                load() {
                    this._loaded = !0, this.fire(new e1.Event("data", {
                        dataType: "source",
                        sourceDataType: "metadata"
                    })), this.fire(new e1.Event("data", {
                        dataType: "source",
                        sourceDataType: "content"
                    }));
                }
                loaded() {
                    return this._loaded;
                }
                onAdd(t1) {
                    this._map = t1, this._loaded = !1, this.fire(new e1.Event("dataloading", {
                        dataType: "source"
                    })), this._implementation.onAdd && this._implementation.onAdd(t1), this.load();
                }
                onRemove(e1) {
                    this._implementation.onRemove && this._implementation.onRemove(e1);
                }
                hasTile(e1) {
                    if (this._implementation.hasTile) {
                        const { x: t1 , y: i , z: o  } = e1.canonical;
                        return this._implementation.hasTile({
                            x: t1,
                            y: i,
                            z: o
                        });
                    }
                    return !this.tileBounds || this.tileBounds.contains(e1.canonical);
                }
                loadTile(t1, i) {
                    const { x: o , y: r , z: n  } = t1.tileID.canonical, a = new e1.window.AbortController;
                    t1.request = Promise.resolve(this._implementation.loadTile({
                        x: o,
                        y: r,
                        z: n
                    }, {
                        signal: a.signal
                    })).then((function(o) {
                        return delete t1.request, t1.aborted ? (t1.state = "unloaded", i(null)) : void 0 === o ? (t1.state = "errored", i(null)) : null === o ? (this.loadTileData(t1, {
                            width: this.tileSize,
                            height: this.tileSize,
                            data: null
                        }), t1.state = "loaded", i(null)) : function(t1) {
                            return t1 instanceof e1.window.ImageData || t1 instanceof e1.window.HTMLCanvasElement || t1 instanceof e1.window.ImageBitmap || t1 instanceof e1.window.HTMLImageElement;
                        }(o) ? (this.loadTileData(t1, o), t1.state = "loaded", void i(null)) : (t1.state = "errored", i(new Error(`Can't infer data type for ${this.id}, only raster data supported at the moment`)));
                    }).bind(this)).catch((e1)=>{
                        20 !== e1.code && (t1.state = "errored", i(e1));
                    }), t1.request.cancel = ()=>a.abort();
                }
                loadTileData(e1, t1) {
                    Me.loadTileData(e1, t1, this._map.painter);
                }
                unloadTileData(e1) {
                    Me.unloadTileData(e1, this._map.painter);
                }
                unloadTile(e1, t1) {
                    if (this.unloadTileData(e1), this._implementation.unloadTile) {
                        const { x: t2 , y: i , z: o  } = e1.tileID.canonical;
                        this._implementation.unloadTile({
                            x: t2,
                            y: i,
                            z: o
                        });
                    }
                    t1();
                }
                abortTile(e1, t1) {
                    e1.request && e1.request.cancel && (e1.request.cancel(), delete e1.request), t1();
                }
                hasTransition() {
                    return !1;
                }
                _coveringTiles() {
                    return this._map.transform.coveringTiles({
                        tileSize: this.tileSize,
                        minzoom: this.minzoom,
                        maxzoom: this.maxzoom,
                        roundZoom: this.roundZoom
                    }).map((e1)=>({
                            x: e1.canonical.x,
                            y: e1.canonical.y,
                            z: e1.canonical.z
                        }));
                }
                _clearTiles() {
                    this._map.style._clearSource(this.id);
                }
                _update() {
                    this.fire(new e1.Event("data", {
                        dataType: "source",
                        sourceDataType: "content"
                    }));
                }
            }
        }, Pe = function(t1, i, o, r) {
            const n = new Ae[i.type](t1, i, o, r);
            if (n.id !== t1) throw new Error(`Expected Source id to be ${t1} instead of ${n.id}`);
            return e1.bindAll([
                "load",
                "abort",
                "unload",
                "serialize",
                "prepare"
            ], n), n;
        };
        function Le(t1, i) {
            const o = e1.identity([]);
            return e1.scale(o, o, [
                .5 * t1.width,
                .5 * -t1.height,
                1
            ]), e1.translate(o, o, [
                1,
                -1,
                0
            ]), e1.multiply(o, o, t1.calculateProjMatrix(i.toUnwrapped())), Float32Array.from(o);
        }
        function Re(e1, t1, i, o, r, n, a, s = !1) {
            const l = e1.tilesIn(o, a, s);
            l.sort(Be);
            const c = [];
            for (const o1 of l)c.push({
                wrappedTileID: o1.tile.tileID.wrapped().key,
                queryResults: o1.tile.queryRenderedFeatures(t1, i, e1._state, o1, r, n, Le(e1.transform, o1.tile.tileID), s)
            });
            const h = function(e1) {
                const t1 = {}, i = {};
                for (const o of e1){
                    const e2 = o.queryResults, r = o.wrappedTileID, n = i[r] = i[r] || {};
                    for(const i1 in e2){
                        const o1 = e2[i1], r1 = n[i1] = n[i1] || {}, a = t1[i1] = t1[i1] || [];
                        for (const e3 of o1)r1[e3.featureIndex] || (r1[e3.featureIndex] = !0, a.push(e3));
                    }
                }
                return t1;
            }(c);
            for(const t2 in h)h[t2].forEach((t1)=>{
                const i = t1.feature, o = i.layer;
                o && "background" !== o.type && "sky" !== o.type && (i.source = o.source, o["source-layer"] && (i.sourceLayer = o["source-layer"]), i.state = void 0 !== i.id ? e1.getFeatureState(o["source-layer"], i.id) : {});
            });
            return h;
        }
        function Oe(e1, t1) {
            const i = e1.getRenderableIds().map((t1)=>e1.getTileByID(t1)), o = [], r = {};
            for(let e2 = 0; e2 < i.length; e2++){
                const n = i[e2], a = n.tileID.canonical.key;
                r[a] || (r[a] = !0, n.querySourceFeatures(o, t1));
            }
            return o;
        }
        function Be(e1, t1) {
            const i = e1.tileID, o = t1.tileID;
            return i.overscaledZ - o.overscaledZ || i.canonical.y - o.canonical.y || i.wrap - o.wrap || i.canonical.x - o.canonical.x;
        }
        function ke() {
            return null != gn.workerClass ? new gn.workerClass : new e1.window.Worker(gn.workerUrl);
        }
        const Fe = "mapboxgl_preloaded_worker_pool";
        class Ue {
            constructor(){
                this.active = {};
            }
            acquire(e1) {
                if (!this.workers) for(this.workers = []; this.workers.length < Ue.workerCount;)this.workers.push(new ke);
                return this.active[e1] = !0, this.workers.slice();
            }
            release(e1) {
                delete this.active[e1], 0 === this.numActive() && (this.workers.forEach((e1)=>{
                    e1.terminate();
                }), this.workers = null);
            }
            isPreloaded() {
                return !!this.active[Fe];
            }
            numActive() {
                return Object.keys(this.active).length;
            }
        }
        let Ne;
        function Ge() {
            return Ne || (Ne = new Ue), Ne;
        }
        function je(t1, i) {
            const o = {};
            for(const e2 in t1)"ref" !== e2 && (o[e2] = t1[e2]);
            return e1.refProperties.forEach((e1)=>{
                e1 in i && (o[e1] = i[e1]);
            }), o;
        }
        function Ze(e1) {
            e1 = e1.slice();
            const t1 = Object.create(null);
            for(let i = 0; i < e1.length; i++)t1[e1[i].id] = e1[i];
            for(let i1 = 0; i1 < e1.length; i1++)"ref" in e1[i1] && (e1[i1] = je(e1[i1], t1[e1[i1].ref]));
            return e1;
        }
        Ue.workerCount = 2;
        const Ve = {
            setStyle: "setStyle",
            addLayer: "addLayer",
            removeLayer: "removeLayer",
            setPaintProperty: "setPaintProperty",
            setLayoutProperty: "setLayoutProperty",
            setFilter: "setFilter",
            addSource: "addSource",
            removeSource: "removeSource",
            setGeoJSONSourceData: "setGeoJSONSourceData",
            setLayerZoomRange: "setLayerZoomRange",
            setLayerProperty: "setLayerProperty",
            setCenter: "setCenter",
            setZoom: "setZoom",
            setBearing: "setBearing",
            setPitch: "setPitch",
            setSprite: "setSprite",
            setGlyphs: "setGlyphs",
            setTransition: "setTransition",
            setLight: "setLight",
            setTerrain: "setTerrain",
            setFog: "setFog",
            setProjection: "setProjection"
        };
        function We(e1, t1, i) {
            i.push({
                command: Ve.addSource,
                args: [
                    e1,
                    t1[e1]
                ]
            });
        }
        function Xe(e1, t1, i) {
            t1.push({
                command: Ve.removeSource,
                args: [
                    e1
                ]
            }), i[e1] = !0;
        }
        function qe(e1, t1, i, o) {
            Xe(e1, i, o), We(e1, t1, i);
        }
        function $e(e1, i, o) {
            let r;
            for(r in e1[o])if (e1[o].hasOwnProperty(r) && "data" !== r && !t1(e1[o][r], i[o][r])) return !1;
            for(r in i[o])if (i[o].hasOwnProperty(r) && "data" !== r && !t1(e1[o][r], i[o][r])) return !1;
            return !0;
        }
        function He(e1, i, o, r, n, a) {
            let s;
            for(s in i = i || {}, e1 = e1 || {})e1.hasOwnProperty(s) && (t1(e1[s], i[s]) || o.push({
                command: a,
                args: [
                    r,
                    s,
                    i[s],
                    n
                ]
            }));
            for(s in i)i.hasOwnProperty(s) && !e1.hasOwnProperty(s) && (t1(e1[s], i[s]) || o.push({
                command: a,
                args: [
                    r,
                    s,
                    i[s],
                    n
                ]
            }));
        }
        function Ye(e1) {
            return e1.id;
        }
        function Ke(e1, t1) {
            return e1[t1.id] = t1, e1;
        }
        class Je {
            constructor(e1, t1){
                this.reset(e1, t1);
            }
            reset(e1, t1) {
                this.points = e1 || [], this._distances = [
                    0
                ];
                for(let e2 = 1; e2 < this.points.length; e2++)this._distances[e2] = this._distances[e2 - 1] + this.points[e2].dist(this.points[e2 - 1]);
                this.length = this._distances[this._distances.length - 1], this.padding = Math.min(t1 || 0, .5 * this.length), this.paddedLength = this.length - 2 * this.padding;
            }
            lerp(t1) {
                if (1 === this.points.length) return this.points[0];
                t1 = e1.clamp(t1, 0, 1);
                let i = 1, o = this._distances[i];
                const r = t1 * this.paddedLength + this.padding;
                for(; o < r && i < this._distances.length;)o = this._distances[++i];
                const n = i - 1, a = this._distances[n], s = o - a, l = s > 0 ? (r - a) / s : 0;
                return this.points[n].mult(1 - l).add(this.points[i].mult(l));
            }
        }
        class Qe {
            constructor(e1, t1, i){
                const o = this.boxCells = [], r = this.circleCells = [];
                this.xCellCount = Math.ceil(e1 / i), this.yCellCount = Math.ceil(t1 / i);
                for(let e2 = 0; e2 < this.xCellCount * this.yCellCount; e2++)o.push([]), r.push([]);
                this.circleKeys = [], this.boxKeys = [], this.bboxes = [], this.circles = [], this.width = e1, this.height = t1, this.xScale = this.xCellCount / e1, this.yScale = this.yCellCount / t1, this.boxUid = 0, this.circleUid = 0;
            }
            keysLength() {
                return this.boxKeys.length + this.circleKeys.length;
            }
            insert(e1, t1, i, o, r) {
                this._forEachCell(t1, i, o, r, this._insertBoxCell, this.boxUid++), this.boxKeys.push(e1), this.bboxes.push(t1), this.bboxes.push(i), this.bboxes.push(o), this.bboxes.push(r);
            }
            insertCircle(e1, t1, i, o) {
                this._forEachCell(t1 - o, i - o, t1 + o, i + o, this._insertCircleCell, this.circleUid++), this.circleKeys.push(e1), this.circles.push(t1), this.circles.push(i), this.circles.push(o);
            }
            _insertBoxCell(e1, t1, i, o, r, n) {
                this.boxCells[r].push(n);
            }
            _insertCircleCell(e1, t1, i, o, r, n) {
                this.circleCells[r].push(n);
            }
            _query(e1, t1, i, o, r, n) {
                if (i < 0 || e1 > this.width || o < 0 || t1 > this.height) return !r && [];
                const a = [];
                if (e1 <= 0 && t1 <= 0 && this.width <= i && this.height <= o) {
                    if (r) return !0;
                    for(let e2 = 0; e2 < this.boxKeys.length; e2++)a.push({
                        key: this.boxKeys[e2],
                        x1: this.bboxes[4 * e2],
                        y1: this.bboxes[4 * e2 + 1],
                        x2: this.bboxes[4 * e2 + 2],
                        y2: this.bboxes[4 * e2 + 3]
                    });
                    for(let e3 = 0; e3 < this.circleKeys.length; e3++){
                        const t2 = this.circles[3 * e3], i1 = this.circles[3 * e3 + 1], o1 = this.circles[3 * e3 + 2];
                        a.push({
                            key: this.circleKeys[e3],
                            x1: t2 - o1,
                            y1: i1 - o1,
                            x2: t2 + o1,
                            y2: i1 + o1
                        });
                    }
                    return n ? a.filter(n) : a;
                }
                return this._forEachCell(e1, t1, i, o, this._queryCell, a, {
                    hitTest: r,
                    seenUids: {
                        box: {},
                        circle: {}
                    }
                }, n), r ? a.length > 0 : a;
            }
            _queryCircle(e1, t1, i, o, r) {
                const n = e1 - i, a = e1 + i, s = t1 - i, l = t1 + i;
                if (a < 0 || n > this.width || l < 0 || s > this.height) return !o && [];
                const c = [];
                return this._forEachCell(n, s, a, l, this._queryCellCircle, c, {
                    hitTest: o,
                    circle: {
                        x: e1,
                        y: t1,
                        radius: i
                    },
                    seenUids: {
                        box: {},
                        circle: {}
                    }
                }, r), o ? c.length > 0 : c;
            }
            query(e1, t1, i, o, r) {
                return this._query(e1, t1, i, o, !1, r);
            }
            hitTest(e1, t1, i, o, r) {
                return this._query(e1, t1, i, o, !0, r);
            }
            hitTestCircle(e1, t1, i, o) {
                return this._queryCircle(e1, t1, i, !0, o);
            }
            _queryCell(e1, t1, i, o, r, n, a, s) {
                const l = a.seenUids, c = this.boxCells[r];
                if (null !== c) {
                    const r1 = this.bboxes;
                    for (const h of c)if (!l.box[h]) {
                        l.box[h] = !0;
                        const c1 = 4 * h;
                        if (e1 <= r1[c1 + 2] && t1 <= r1[c1 + 3] && i >= r1[c1 + 0] && o >= r1[c1 + 1] && (!s || s(this.boxKeys[h]))) {
                            if (a.hitTest) return n.push(!0), !0;
                            n.push({
                                key: this.boxKeys[h],
                                x1: r1[c1],
                                y1: r1[c1 + 1],
                                x2: r1[c1 + 2],
                                y2: r1[c1 + 3]
                            });
                        }
                    }
                }
                const h1 = this.circleCells[r];
                if (null !== h1) {
                    const r2 = this.circles;
                    for (const c2 of h1)if (!l.circle[c2]) {
                        l.circle[c2] = !0;
                        const h2 = 3 * c2;
                        if (this._circleAndRectCollide(r2[h2], r2[h2 + 1], r2[h2 + 2], e1, t1, i, o) && (!s || s(this.circleKeys[c2]))) {
                            if (a.hitTest) return n.push(!0), !0;
                            {
                                const e2 = r2[h2], t2 = r2[h2 + 1], i1 = r2[h2 + 2];
                                n.push({
                                    key: this.circleKeys[c2],
                                    x1: e2 - i1,
                                    y1: t2 - i1,
                                    x2: e2 + i1,
                                    y2: t2 + i1
                                });
                            }
                        }
                    }
                }
            }
            _queryCellCircle(e1, t1, i, o, r, n, a, s) {
                const l = a.circle, c = a.seenUids, h = this.boxCells[r];
                if (null !== h) {
                    const e2 = this.bboxes;
                    for (const t2 of h)if (!c.box[t2]) {
                        c.box[t2] = !0;
                        const i1 = 4 * t2;
                        if (this._circleAndRectCollide(l.x, l.y, l.radius, e2[i1 + 0], e2[i1 + 1], e2[i1 + 2], e2[i1 + 3]) && (!s || s(this.boxKeys[t2]))) return n.push(!0), !0;
                    }
                }
                const _ = this.circleCells[r];
                if (null !== _) {
                    const e3 = this.circles;
                    for (const t3 of _)if (!c.circle[t3]) {
                        c.circle[t3] = !0;
                        const i2 = 3 * t3;
                        if (this._circlesCollide(e3[i2], e3[i2 + 1], e3[i2 + 2], l.x, l.y, l.radius) && (!s || s(this.circleKeys[t3]))) return n.push(!0), !0;
                    }
                }
            }
            _forEachCell(e1, t1, i, o, r, n, a, s) {
                const l = this._convertToXCellCoord(e1), c = this._convertToYCellCoord(t1), h = this._convertToXCellCoord(i), _ = this._convertToYCellCoord(o);
                for(let u = l; u <= h; u++)for(let l1 = c; l1 <= _; l1++)if (r.call(this, e1, t1, i, o, this.xCellCount * l1 + u, n, a, s)) return;
            }
            _convertToXCellCoord(e1) {
                return Math.max(0, Math.min(this.xCellCount - 1, Math.floor(e1 * this.xScale)));
            }
            _convertToYCellCoord(e1) {
                return Math.max(0, Math.min(this.yCellCount - 1, Math.floor(e1 * this.yScale)));
            }
            _circlesCollide(e1, t1, i, o, r, n) {
                const a = o - e1, s = r - t1, l = i + n;
                return l * l > a * a + s * s;
            }
            _circleAndRectCollide(e1, t1, i, o, r, n, a) {
                const s = (n - o) / 2, l = Math.abs(e1 - (o + s));
                if (l > s + i) return !1;
                const c = (a - r) / 2, h = Math.abs(t1 - (r + c));
                if (h > c + i) return !1;
                if (l <= s || h <= c) return !0;
                const _ = l - s, u = h - c;
                return _ * _ + u * u <= i * i;
            }
        }
        const et = Math.tan(85 * Math.PI / 180);
        function tt(t1, i, o, r, n, a, s) {
            const l = e1.create();
            if (o) {
                if ("globe" === a.name) {
                    const t2 = e1.calculateGlobeLabelMatrix(n, i);
                    e1.multiply(l, l, t2);
                } else {
                    const t3 = v([], s);
                    l[0] = t3[0], l[1] = t3[1], l[4] = t3[2], l[5] = t3[3], r || e1.rotateZ(l, l, n.angle);
                }
            } else e1.multiply(l, n.labelPlaneMatrix, t1);
            return l;
        }
        function it(e1, t1, i, o, r, n, a) {
            const s = tt(e1, t1, i, o, r, n, a);
            return "globe" === n.name && i || (s[2] = s[6] = s[10] = s[14] = 0), s;
        }
        function ot(t1, i, o, r, n, a, s) {
            if (o) {
                if ("globe" === a.name) {
                    const l = tt(t1, i, o, r, n, a, s);
                    return e1.invert(l, l), e1.multiply(l, t1, l), l;
                }
                {
                    const i1 = e1.clone(t1), o1 = e1.identity([]);
                    return o1[0] = s[0], o1[1] = s[1], o1[4] = s[2], o1[5] = s[3], e1.multiply(i1, i1, o1), r || e1.rotateZ(i1, i1, -n.angle), i1;
                }
            }
            return n.glCoordMatrix;
        }
        function rt(t1, i, o = 0) {
            const r = [
                t1.x,
                t1.y,
                o,
                1
            ];
            o ? e1.transformMat4$1(r, r, i) : gt(r, r, i);
            const n = r[3];
            return {
                point: [
                    r[0] / n,
                    r[1] / n,
                    r[2] / n
                ],
                signedDistanceFromCamera: n
            };
        }
        function nt(t1, i) {
            const o = [
                t1[0],
                t1[1],
                t1[2],
                1
            ];
            e1.transformMat4$1(o, o, i);
            const r = o[3];
            return {
                point: [
                    o[0] / r,
                    o[1] / r,
                    o[2] / r
                ],
                signedDistanceFromCamera: r
            };
        }
        function at(e1, t1) {
            return Math.min(.5 + e1 / t1 * .5, 1.5);
        }
        function st(e1, t1) {
            const i = e1[0] / e1[3], o = e1[1] / e1[3];
            return i >= -t1[0] && i <= t1[0] && o >= -t1[1] && o <= t1[1];
        }
        function lt(t1, i, o, r, n, a, s, l, c, h) {
            const _ = o.transform, u = r ? t1.textSizeData : t1.iconSizeData, d = e1.evaluateSizeForZoom(u, o.transform.zoom), p = "globe" === _.projection.name, m = [
                256 / o.width * 2 + 1,
                256 / o.height * 2 + 1
            ], f = r ? t1.text.dynamicLayoutVertexArray : t1.icon.dynamicLayoutVertexArray;
            f.clear();
            let g = null;
            p && (g = r ? t1.text.globeExtVertexArray : t1.icon.globeExtVertexArray);
            const v = t1.lineVertexArray, x = r ? t1.text.placedSymbolArray : t1.icon.placedSymbolArray, y = o.transform.width / o.transform.height;
            let b = !1;
            for(let r1 = 0; r1 < x.length; r1++){
                const p1 = x.get(r1);
                if (p1.writingMode !== e1.WritingMode.vertical || b || 0 !== r1 && x.get(r1 - 1).writingMode === e1.WritingMode.horizontal || (b = !0), (p1.hidden || p1.writingMode === e1.WritingMode.vertical) && !b) {
                    ft(p1.numGlyphs, f);
                    continue;
                }
                b = !1;
                const w = new e1.pointGeometry(p1.tileAnchorX, p1.tileAnchorY), T = c ? c(w) : [
                    0,
                    0,
                    0
                ], E = _.projection.projectTilePoint(w.x, w.y, h.canonical), C = [
                    E.x + T[0],
                    E.y + T[1],
                    E.z + T[2]
                ], I = [
                    ...C,
                    1
                ];
                if (e1.transformMat4$1(I, I, i), !st(I, m)) {
                    ft(p1.numGlyphs, f);
                    continue;
                }
                const M = at(o.transform.cameraToCenterDistance, I[3]), S = e1.evaluateSizeForFeature(u, d, p1), z = s ? S / M : S * M, D = rt(new e1.pointGeometry(C[0], C[1]), n, C[2]);
                if (D.signedDistanceFromCamera <= 0) {
                    ft(p1.numGlyphs, f);
                    continue;
                }
                let A = {};
                const P = s ? null : c, L = _t(p1, z, !1, l, i, n, a, t1.glyphOffsetArray, v, f, g, D.point, w, A, y, P, _.projection, h, s);
                b = L.useVertical, P && L.needsFlipping && (A = {}), (L.notEnoughRoom || b || L.needsFlipping && _t(p1, z, !0, l, i, n, a, t1.glyphOffsetArray, v, f, g, D.point, w, A, y, P, _.projection, h, s).notEnoughRoom) && ft(p1.numGlyphs, f);
            }
            r ? (t1.text.dynamicLayoutVertexBuffer.updateData(f), g && t1.text.globeExtVertexBuffer.updateData(g)) : (t1.icon.dynamicLayoutVertexBuffer.updateData(f), g && t1.icon.globeExtVertexBuffer.updateData(g));
        }
        function ct(e1, t1, i, o, r, n, a, s, l, c, h, _, u, d, p, m) {
            const f = s.glyphStartIndex + s.numGlyphs, g = s.lineStartIndex, v = s.lineStartIndex + s.lineLength, x = t1.getoffsetX(s.glyphStartIndex), y = t1.getoffsetX(f - 1), b = pt(e1 * x, i, o, r, n, a, s.segment, g, v, l, c, h, _, u, !0, d, p, m);
            if (!b) return null;
            const w = pt(e1 * y, i, o, r, n, a, s.segment, g, v, l, c, h, _, u, !0, d, p, m);
            return w ? {
                first: b,
                last: w
            } : null;
        }
        function ht(t1, i, o, r) {
            return t1.writingMode === e1.WritingMode.horizontal && Math.abs(o.y - i.y) > Math.abs(o.x - i.x) * r ? {
                useVertical: !0
            } : t1.writingMode === e1.WritingMode.vertical ? i.y < o.y ? {
                needsFlipping: !0
            } : null : 0 !== t1.flipState && function(e1, t1, i) {
                const o = (t1.x - e1.x) * i;
                return 0 === o || Math.abs((t1.y - e1.y) / o) > et;
            }(i, o, r) ? 1 === t1.flipState ? {
                needsFlipping: !0
            } : null : i.x > o.x ? {
                needsFlipping: !0
            } : null;
        }
        function _t(t1, i, o, r, n, a, s, l, c, h, _, u, d, p, m, f, g, v, x) {
            const y = i / 24, b = t1.lineOffsetX * y, w = t1.lineOffsetY * y;
            let T = [];
            if (t1.numGlyphs > 1) {
                const i1 = t1.glyphStartIndex + t1.numGlyphs, n1 = t1.lineStartIndex, h1 = t1.lineStartIndex + t1.lineLength, _1 = ct(y, l, b, w, o, u, d, t1, c, a, p, f, !1, g, v, x);
                if (!_1) return {
                    notEnoughRoom: !0
                };
                const E = nt(_1.first.point, s).point, C = nt(_1.last.point, s).point, I = new e1.pointGeometry(E[0], E[1]), M = new e1.pointGeometry(C[0], C[1]);
                if (r && !o) {
                    const e2 = ht(t1, I, M, m);
                    if (t1.flipState = e2 && e2.needsFlipping ? 1 : 2, e2) return e2;
                }
                T = [
                    _1.first
                ];
                for(let e3 = t1.glyphStartIndex + 1; e3 < i1 - 1; e3++){
                    const i2 = pt(y * l.getoffsetX(e3), b, w, o, u, d, t1.segment, n1, h1, c, a, p, f, !1, !1, g, v, x);
                    if (!i2) return {
                        notEnoughRoom: !0
                    };
                    T.push(i2);
                }
                T.push(_1.last);
            } else {
                if (r && !o) {
                    const i3 = rt(d, n).point, o1 = t1.lineStartIndex + t1.segment + 1, r1 = new e1.pointGeometry(c.getx(o1), c.gety(o1)), a1 = rt(r1, n), s1 = a1.signedDistanceFromCamera > 0 ? a1.point : dt(d, r1, i3, 1, n, void 0, g, v.canonical), l1 = ht(t1, new e1.pointGeometry(i3[0], i3[1]), new e1.pointGeometry(s1[0], s1[1]), m);
                    if (t1.flipState = l1 && l1.needsFlipping ? 1 : 2, l1) return l1;
                }
                const i4 = pt(y * l.getoffsetX(t1.glyphStartIndex), b, w, o, u, d, t1.segment, t1.lineStartIndex, t1.lineStartIndex + t1.lineLength, c, a, p, f, !1, !1, g, v, x);
                if (!i4) return {
                    notEnoughRoom: !0
                };
                T = [
                    i4
                ];
            }
            if (_) for (const t2 of T)e1.updateGlobeVertexNormal(_, h.length + 0, t2.up[0], t2.up[1], t2.up[2]), e1.updateGlobeVertexNormal(_, h.length + 1, t2.up[0], t2.up[1], t2.up[2]), e1.updateGlobeVertexNormal(_, h.length + 2, t2.up[0], t2.up[1], t2.up[2]), e1.updateGlobeVertexNormal(_, h.length + 3, t2.up[0], t2.up[1], t2.up[2]), e1.addDynamicAttributes(h, t2.point[0], t2.point[1], t2.point[2], t2.angle);
            else for (const t3 of T)e1.addDynamicAttributes(h, t3.point[0], t3.point[1], t3.point[2], t3.angle);
            return {};
        }
        function ut(t1, i, o, r, n) {
            const a = r.projectTilePoint(t1.x, t1.y, i);
            if (!n) return rt(a, o, a.z);
            const s = n(t1);
            return rt(new e1.pointGeometry(a.x + s[0], a.y + s[1]), o, a.z + s[2]);
        }
        function dt(t1, i, o, r, n, a, s, l) {
            const c = ut(t1.add(t1.sub(i)._unit()), l, n, s, a).point, h = e1.sub([], o, c);
            return e1.scaleAndAdd([], o, h, r / e1.length(h));
        }
        function pt(t1, i, o, r, n, a, s, l, c, h, _, u, d, p, m, f, g, v) {
            const x = r ? t1 - i : t1 + i;
            let y = x > 0 ? 1 : -1, b = 0;
            r && (y *= -1, b = Math.PI), y < 0 && (b += Math.PI);
            let w = y > 0 ? l + s : l + s + 1, T = n, E = n, C = 0, I = 0;
            const M = Math.abs(x), S = [], z = [];
            let D = a;
            const A = ()=>{
                const t1 = w - y;
                return 0 === C ? a : new e1.pointGeometry(h.getx(t1), h.gety(t1));
            }, P = ()=>{
                const e1 = A();
                return dt(e1, D || e1, E, M - C + 1, _, d, f, g.canonical);
            };
            for(; C + I <= M;){
                if (w += y, w < l || w >= c) return null;
                if (E = T, S.push(T), p && z.push(D || A()), T = u[w], void 0 === T) {
                    D = new e1.pointGeometry(h.getx(w), h.gety(w));
                    const t2 = ut(D, g.canonical, _, f, d);
                    T = t2.signedDistanceFromCamera > 0 ? u[w] = t2.point : P();
                } else D = null;
                C += I, I = e1.distance(E, T);
            }
            D = D || new e1.pointGeometry(h.getx(w), h.gety(w));
            const L = A();
            m && d && (u[w] = T = void 0 === u[w] ? T : P(), I = e1.distance(E, T));
            const R = (M - C) / I, O = D.sub(L).mult(R)._add(L), B = e1.sub([], T, E), k = e1.scaleAndAdd([], E, B, R);
            let F = [
                0,
                0,
                1
            ], U = B[0], N = B[1];
            if (v && (F = f.upVector(g.canonical, O.x, O.y), 0 !== F[0] || 0 !== F[1] || 1 !== F[2])) {
                const t3 = [
                    1,
                    0,
                    0
                ], i1 = [
                    0,
                    1,
                    0
                ];
                t3[0] = F[2], t3[1] = 0, t3[2] = -F[0], e1.cross(i1, F, t3), e1.normalize(t3, t3), e1.normalize(i1, i1), U = e1.dot(B, t3), N = e1.dot(B, i1);
            }
            if (o) {
                const t4 = e1.cross([], F, B);
                e1.normalize(t4, t4), e1.scaleAndAdd(k, k, t4, o * y);
            }
            const G = b + Math.atan2(N, U);
            return S.push(k), p && z.push(O), {
                point: k,
                angle: G,
                path: S,
                tilePath: z,
                up: F
            };
        }
        const mt = new Float32Array([
            -1 / 0,
            -1 / 0,
            0,
            -1 / 0,
            -1 / 0,
            0,
            -1 / 0,
            -1 / 0,
            0,
            -1 / 0,
            -1 / 0,
            0,
            -1 / 0,
            -1 / 0,
            0
        ]);
        function ft(e1, t1) {
            for(let i = 0; i < e1; i++){
                const e2 = t1.length;
                t1.resize(e2 + 4), t1.float32.set(mt, 4 * e2);
            }
        }
        function gt(e1, t1, i) {
            const o = t1[0], r = t1[1];
            return e1[0] = i[0] * o + i[4] * r + i[12], e1[1] = i[1] * o + i[5] * r + i[13], e1[3] = i[3] * o + i[7] * r + i[15], e1;
        }
        const vt = 100;
        class xt {
            constructor(e1, t1, i = new Qe(e1.width + 200, e1.height + 200, 25), o = new Qe(e1.width + 200, e1.height + 200, 25)){
                this.transform = e1, this.grid = i, this.ignoredGrid = o, this.pitchfactor = Math.cos(e1._pitch) * e1.cameraToCenterDistance, this.screenRightBoundary = e1.width + vt, this.screenBottomBoundary = e1.height + vt, this.gridRightBoundary = e1.width + 200, this.gridBottomBoundary = e1.height + 200, this.fogState = t1;
            }
            placeCollisionBox(e1, t1, i, o, r, n, a, s) {
                let l = i.projectedAnchorX, c = i.projectedAnchorY, h = i.projectedAnchorZ;
                const _ = i.elevation, u = i.tileID;
                if (_ && u) {
                    const t2 = e1.getProjection().upVector(u.canonical, i.tileAnchorX, i.tileAnchorY), o1 = e1.getProjection().upVectorScale(u.canonical, this.transform.center.lat, this.transform.worldSize).metersToTile;
                    l += t2[0] * _ * o1, c += t2[1] * _ * o1, h += t2[2] * _ * o1;
                }
                const d = this.projectAndGetPerspectiveRatio(a, [
                    l,
                    c,
                    h
                ], i.tileID, "globe" === e1.projection.name || !!_ || this.transform.pitch > 0, e1.getProjection()), p = n * d.perspectiveRatio, m = (i.x1 * t1 + o.x - i.padding) * p + d.point.x, f = (i.y1 * t1 + o.y - i.padding) * p + d.point.y, g = (i.x2 * t1 + o.x + i.padding) * p + d.point.x, v = (i.y2 * t1 + o.y + i.padding) * p + d.point.y, x = d.perspectiveRatio <= .55 || d.occluded;
                return !this.isInsideGrid(m, f, g, v) || !r && this.grid.hitTest(m, f, g, v, s) || x ? {
                    box: [],
                    offscreen: !1,
                    occluded: d.occluded
                } : {
                    box: [
                        m,
                        f,
                        g,
                        v
                    ],
                    offscreen: this.isOffscreen(m, f, g, v),
                    occluded: !1
                };
            }
            placeCollisionCircles(t1, i, o, r, n, a, s, l, c, h, _, u, d, p, m) {
                const f = [], g = this.transform.elevation, v = g ? g.getAtTileOffsetFunc(m, this.transform.center.lat, this.transform.worldSize, t1.getProjection()) : (e1)=>[
                        0,
                        0,
                        0
                    ], x = new e1.pointGeometry(o.tileAnchorX, o.tileAnchorY), y = t1.getProjection().projectTilePoint(o.tileAnchorX, o.tileAnchorY, m.canonical), b = v(x), w = [
                    y.x + b[0],
                    y.y + b[1],
                    y.z + b[2]
                ], T = "globe" === t1.projection.name, E = this.projectAndGetPerspectiveRatio(s, [
                    w[0],
                    w[1],
                    w[2]
                ], m, T || !!g || this.transform.pitch > 0, t1.getProjection()), { perspectiveRatio: C  } = E, I = (_ ? a / C : a * C) / e1.ONE_EM, M = rt(new e1.pointGeometry(w[0], w[1]), l, w[2]).point, S = E.signedDistanceFromCamera > 0 ? ct(I, n, o.lineOffsetX * I, o.lineOffsetY * I, !1, M, x, o, r, l, {}, g && !_ ? v : null, _ && !!g, t1.getProjection(), m, _) : null;
                let z = !1, D = !1, A = !0;
                if (S && !E.occluded) {
                    const t2 = .5 * d * C + p, o1 = new e1.pointGeometry(-100, -100), r1 = new e1.pointGeometry(this.screenRightBoundary, this.screenBottomBoundary), n1 = new Je, a1 = S.first, s1 = S.last;
                    let l1 = [];
                    for(let e2 = a1.path.length - 1; e2 >= 1; e2--)l1.push(a1.path[e2]);
                    for(let e3 = 1; e3 < s1.path.length; e3++)l1.push(s1.path[e3]);
                    const _1 = 2.5 * t2;
                    if (c) {
                        const e4 = l1.map(g && !T ? (e1, t1)=>{
                            const i = v(t1 < a1.path.length - 1 ? a1.tilePath[a1.path.length - 1 - t1] : s1.tilePath[t1 - a1.path.length + 2]);
                            return e1[2] = i[2], nt(e1, c);
                        } : (e1)=>nt(e1, c));
                        l1 = e4.some((e1)=>e1.signedDistanceFromCamera <= 0) ? [] : e4.map((e1)=>e1.point);
                    }
                    let m1 = [];
                    if (l1.length > 0) {
                        const t3 = l1.map((t1)=>new e1.pointGeometry(t1[0], t1[1]));
                        let i1 = 1 / 0, n2 = -1 / 0, a2 = 1 / 0, s2 = -1 / 0;
                        for(let e5 = 0; e5 < t3.length; e5++)i1 = Math.min(i1, t3[e5].x), a2 = Math.min(a2, t3[e5].y), n2 = Math.max(n2, t3[e5].x), s2 = Math.max(s2, t3[e5].y);
                        m1 = i1 >= o1.x && n2 <= r1.x && a2 >= o1.y && s2 <= r1.y ? [
                            t3
                        ] : n2 < o1.x || i1 > r1.x || s2 < o1.y || a2 > r1.y ? [] : e1.clipLine([
                            t3
                        ], o1.x, o1.y, r1.x, r1.y);
                    }
                    for (const e6 of m1){
                        n1.reset(e6, .25 * t2);
                        let o2 = 0;
                        o2 = n1.length <= .5 * t2 ? 1 : Math.ceil(n1.paddedLength / _1) + 1;
                        for(let e7 = 0; e7 < o2; e7++){
                            const r2 = e7 / Math.max(o2 - 1, 1), a3 = n1.lerp(r2), s3 = a3.x + vt, l2 = a3.y + vt;
                            f.push(s3, l2, t2, 0);
                            const c1 = s3 - t2, _2 = l2 - t2, d1 = s3 + t2, p1 = l2 + t2;
                            if (A = A && this.isOffscreen(c1, _2, d1, p1), D = D || this.isInsideGrid(c1, _2, d1, p1), !i && this.grid.hitTestCircle(s3, l2, t2, u) && (z = !0, !h)) return {
                                circles: [],
                                offscreen: !1,
                                collisionDetected: z,
                                occluded: !1
                            };
                        }
                    }
                }
                return {
                    circles: !h && z || !D ? [] : f,
                    offscreen: A,
                    collisionDetected: z,
                    occluded: E.occluded
                };
            }
            queryRenderedSymbols(t1) {
                if (0 === t1.length || 0 === this.grid.keysLength() && 0 === this.ignoredGrid.keysLength()) return {};
                const i = [];
                let o = 1 / 0, r = 1 / 0, n = -1 / 0, a = -1 / 0;
                for (const s of t1){
                    const t2 = new e1.pointGeometry(s.x + vt, s.y + vt);
                    o = Math.min(o, t2.x), r = Math.min(r, t2.y), n = Math.max(n, t2.x), a = Math.max(a, t2.y), i.push(t2);
                }
                const s1 = this.grid.query(o, r, n, a).concat(this.ignoredGrid.query(o, r, n, a)), l = {}, c = {};
                for (const t3 of s1){
                    const o1 = t3.key;
                    if (void 0 === l[o1.bucketInstanceId] && (l[o1.bucketInstanceId] = {}), l[o1.bucketInstanceId][o1.featureIndex]) continue;
                    const r1 = [
                        new e1.pointGeometry(t3.x1, t3.y1),
                        new e1.pointGeometry(t3.x2, t3.y1),
                        new e1.pointGeometry(t3.x2, t3.y2),
                        new e1.pointGeometry(t3.x1, t3.y2)
                    ];
                    e1.polygonIntersectsPolygon(i, r1) && (l[o1.bucketInstanceId][o1.featureIndex] = !0, void 0 === c[o1.bucketInstanceId] && (c[o1.bucketInstanceId] = []), c[o1.bucketInstanceId].push(o1.featureIndex));
                }
                return c;
            }
            insertCollisionBox(e1, t1, i, o, r) {
                (t1 ? this.ignoredGrid : this.grid).insert({
                    bucketInstanceId: i,
                    featureIndex: o,
                    collisionGroupID: r
                }, e1[0], e1[1], e1[2], e1[3]);
            }
            insertCollisionCircles(e1, t1, i, o, r) {
                const n = t1 ? this.ignoredGrid : this.grid, a = {
                    bucketInstanceId: i,
                    featureIndex: o,
                    collisionGroupID: r
                };
                for(let t2 = 0; t2 < e1.length; t2 += 4)n.insertCircle(a, e1[t2], e1[t2 + 1], e1[t2 + 2]);
            }
            projectAndGetPerspectiveRatio(t1, i, o, r, n) {
                const a = [
                    i[0],
                    i[1],
                    i[2],
                    1
                ];
                let s = !1;
                if (i[2] || this.transform.pitch > 0) {
                    e1.transformMat4$1(a, a, t1);
                    const r1 = "globe" === n.name;
                    this.fogState && o && !r1 && (s = function(t1, i, o, r, n, a) {
                        const s = a.calculateFogTileMatrix(n), l = [
                            i,
                            o,
                            r
                        ];
                        return e1.transformMat4(l, l, s), M(t1, l, a.pitch, a._fov);
                    }(this.fogState, i[0], i[1], i[2], o.toUnwrapped(), this.transform) > .9);
                } else gt(a, a, t1);
                return {
                    point: new e1.pointGeometry((a[0] / a[3] + 1) / 2 * this.transform.width + vt, (-a[1] / a[3] + 1) / 2 * this.transform.height + vt),
                    perspectiveRatio: Math.min(.5 + this.transform.getCameraToCenterDistance(n) / a[3] * .5, 1.5),
                    signedDistanceFromCamera: a[3],
                    occluded: r && a[2] > a[3] || s
                };
            }
            isOffscreen(e1, t1, i, o) {
                return i < vt || e1 >= this.screenRightBoundary || o < vt || t1 > this.screenBottomBoundary;
            }
            isInsideGrid(e1, t1, i, o) {
                return i >= 0 && e1 < this.gridRightBoundary && o >= 0 && t1 < this.gridBottomBoundary;
            }
            getViewportMatrix() {
                const t1 = e1.identity([]);
                return e1.translate(t1, t1, [
                    -100,
                    -100,
                    0
                ]), t1;
            }
        }
        function yt(t1, i, o) {
            const r = i.createTileMatrix(t1, t1.worldSize, o.toUnwrapped());
            return e1.multiply(new Float32Array(16), t1.projMatrix, r);
        }
        function bt(e1, t1, i) {
            if (t1.projection.name === i.projection.name) return e1.projMatrix;
            const o = i.clone();
            return o.setProjection(t1.projection), yt(o, t1.getProjection(), e1);
        }
        function wt(e1, t1, i) {
            return t1.name === i.projection.name ? e1.projMatrix : yt(i, t1, e1);
        }
        class Tt {
            constructor(e1, t1, i, o){
                this.opacity = e1 ? Math.max(0, Math.min(1, e1.opacity + (e1.placed ? t1 : -t1))) : o && i ? 1 : 0, this.placed = i;
            }
            isHidden() {
                return 0 === this.opacity && !this.placed;
            }
        }
        class Et {
            constructor(e1, t1, i, o, r, n = !1){
                this.text = new Tt(e1 ? e1.text : null, t1, i, r), this.icon = new Tt(e1 ? e1.icon : null, t1, o, r), this.clipped = n;
            }
            isHidden() {
                return this.text.isHidden() && this.icon.isHidden();
            }
        }
        class Ct {
            constructor(e1, t1, i, o = !1){
                this.text = e1, this.icon = t1, this.skipFade = i, this.clipped = o;
            }
        }
        class It {
            constructor(){
                this.invProjMatrix = e1.create(), this.viewportMatrix = e1.create(), this.circles = [];
            }
        }
        class Mt {
            constructor(e1, t1, i, o, r){
                this.bucketInstanceId = e1, this.featureIndex = t1, this.sourceLayerIndex = i, this.bucketIndex = o, this.tileID = r;
            }
        }
        class St {
            constructor(e1){
                this.crossSourceCollisions = e1, this.maxGroupID = 0, this.collisionGroups = {};
            }
            get(e1) {
                if (this.crossSourceCollisions) return {
                    ID: 0,
                    predicate: null
                };
                if (!this.collisionGroups[e1]) {
                    const t1 = ++this.maxGroupID;
                    this.collisionGroups[e1] = {
                        ID: t1,
                        predicate: (e1)=>e1.collisionGroupID === t1
                    };
                }
                return this.collisionGroups[e1];
            }
        }
        function zt(t1, i, o, r, n) {
            const { horizontalAlign: a , verticalAlign: s  } = e1.getAnchorAlignment(t1), l = -(a - .5) * i, c = -(s - .5) * o, h = e1.evaluateVariableOffset(t1, r);
            return new e1.pointGeometry(l + h[0] * n, c + h[1] * n);
        }
        function Dt(t1, i, o, r, n) {
            const a = new e1.pointGeometry(t1, i);
            return o && a._rotate(r ? n : -n), a;
        }
        class At {
            constructor(e1, t1, i, o, r){
                this.transform = e1.clone(), this.projection = e1.projection.name, this.collisionIndex = new xt(this.transform, r), this.placements = {}, this.opacities = {}, this.variableOffsets = {}, this.stale = !1, this.commitTime = 0, this.fadeDuration = t1, this.retainedQueryData = {}, this.collisionGroups = new St(i), this.collisionCircleArrays = {}, this.prevPlacement = o, o && (o.prevPlacement = void 0), this.placedOrientations = {};
            }
            getBucketParts(t1, i, o, r) {
                const n = o.getBucket(i), a = o.latestFeatureIndex;
                if (!n || !a || i.id !== n.layerIds[0]) return;
                const s = n.layers[0].layout, l = o.collisionBoxArray, c = Math.pow(2, this.transform.zoom - o.tileID.overscaledZ), h = o.tileSize / e1.EXTENT, _ = o.tileID.toUnwrapped();
                this.transform.setProjection(n.projection);
                const u = (d = o.tileID, p = n.getProjection(), m = this.transform, p.name === this.projection ? m.calculateProjMatrix(d.toUnwrapped()) : yt(m, p, d));
                var d, p, m;
                const f = "map" === s.get("text-pitch-alignment"), g = "map" === s.get("text-rotation-alignment");
                i.compileFilter();
                const v = i.dynamicFilter(), x = i.dynamicFilterNeedsFeature(), y = this.transform.calculatePixelsToTileUnitsMatrix(o), b = it(u, o.tileID.canonical, f, g, this.transform, n.getProjection(), y);
                let w = null;
                if (f) {
                    const t2 = ot(u, o.tileID.canonical, f, g, this.transform, n.getProjection(), y);
                    w = e1.multiply([], this.transform.labelPlaneMatrix, t2);
                }
                let T = null;
                v && o.latestFeatureIndex && (T = {
                    unwrappedTileID: _,
                    dynamicFilter: v,
                    dynamicFilterNeedsFeature: x,
                    featureIndex: o.latestFeatureIndex
                }), this.retainedQueryData[n.bucketInstanceId] = new Mt(n.bucketInstanceId, a, n.sourceLayerIndex, n.index, o.tileID);
                const E = {
                    bucket: n,
                    layout: s,
                    posMatrix: u,
                    textLabelPlaneMatrix: b,
                    labelToScreenMatrix: w,
                    clippingData: T,
                    scale: c,
                    textPixelRatio: h,
                    holdingForFade: o.holdingForFade(),
                    collisionBoxArray: l,
                    partiallyEvaluatedTextSize: e1.evaluateSizeForZoom(n.textSizeData, this.transform.zoom),
                    partiallyEvaluatedIconSize: e1.evaluateSizeForZoom(n.iconSizeData, this.transform.zoom),
                    collisionGroup: this.collisionGroups.get(n.sourceID)
                };
                if (r) for (const e2 of n.sortKeyRanges){
                    const { sortKey: i1 , symbolInstanceStart: o1 , symbolInstanceEnd: r1  } = e2;
                    t1.push({
                        sortKey: i1,
                        symbolInstanceStart: o1,
                        symbolInstanceEnd: r1,
                        parameters: E
                    });
                }
                else t1.push({
                    symbolInstanceStart: 0,
                    symbolInstanceEnd: n.symbolInstances.length,
                    parameters: E
                });
            }
            attemptAnchorPlacement(e1, t1, i, o, r, n, a, s, l, c, h, _, u, d, p, m, f, g) {
                const v = [
                    _.textOffset0,
                    _.textOffset1
                ], x = zt(e1, i, o, v, r), y = this.collisionIndex.placeCollisionBox(d, r, t1, Dt(x.x, x.y, n, a, this.transform.angle), h, s, l, c.predicate);
                if (m) {
                    const e2 = d.getSymbolInstanceIconSize(g, this.transform.zoom, _.placedIconSymbolIndex);
                    if (0 === this.collisionIndex.placeCollisionBox(d, e2, m, Dt(x.x, x.y, n, a, this.transform.angle), h, s, l, c.predicate).box.length) return;
                }
                if (y.box.length > 0) {
                    let t2;
                    return this.prevPlacement && this.prevPlacement.variableOffsets[_.crossTileID] && this.prevPlacement.placements[_.crossTileID] && this.prevPlacement.placements[_.crossTileID].text && (t2 = this.prevPlacement.variableOffsets[_.crossTileID].anchor), this.variableOffsets[_.crossTileID] = {
                        textOffset: v,
                        width: i,
                        height: o,
                        anchor: e1,
                        textScale: r,
                        prevAnchor: t2
                    }, this.markUsedJustification(d, e1, _, p), d.allowVerticalPlacement && (this.markUsedOrientation(d, p, _), this.placedOrientations[_.crossTileID] = p), {
                        shift: x,
                        placedGlyphBoxes: y
                    };
                }
            }
            placeLayerBucketPart(t1, i, o, r) {
                const { bucket: n , layout: a , posMatrix: s , textLabelPlaneMatrix: l , labelToScreenMatrix: c , clippingData: h , textPixelRatio: _ , holdingForFade: u , collisionBoxArray: d , partiallyEvaluatedTextSize: p , partiallyEvaluatedIconSize: m , collisionGroup: f  } = t1.parameters, g = a.get("text-optional"), v = a.get("icon-optional"), x = a.get("text-allow-overlap"), y = a.get("icon-allow-overlap"), b = "map" === a.get("text-rotation-alignment"), w = "map" === a.get("text-pitch-alignment"), T = "none" !== a.get("icon-text-fit"), E = "viewport-y" === a.get("symbol-z-order");
                this.transform.setProjection(n.projection);
                let C = x && (y || !n.hasIconData() || v), I = y && (x || !n.hasTextData() || g);
                !n.collisionArrays && d && n.deserializeCollisionBoxes(d), o && r && n.updateCollisionDebugBuffers(this.transform.zoom, d);
                const M = (t1, r, d)=>{
                    if (h) {
                        const o1 = {
                            zoom: this.transform.zoom,
                            pitch: this.transform.pitch
                        };
                        let r1 = null;
                        if (h.dynamicFilterNeedsFeature) {
                            const e2 = this.retainedQueryData[n.bucketInstanceId];
                            r1 = h.featureIndex.loadFeature({
                                featureIndex: t1.featureIndex,
                                bucketIndex: e2.bucketIndex,
                                sourceLayerIndex: e2.sourceLayerIndex,
                                layoutVertexArrayOffset: 0
                            });
                        }
                        if (!(0, h.dynamicFilter)(o1, r1, this.retainedQueryData[n.bucketInstanceId].tileID.canonical, new e1.pointGeometry(t1.tileAnchorX, t1.tileAnchorY), this.transform.calculateDistanceTileData(h.unwrappedTileID))) return this.placements[t1.crossTileID] = new Ct(!1, !1, !1, !0), void (i[t1.crossTileID] = !0);
                    }
                    if (i[t1.crossTileID]) return;
                    if (u) return void (this.placements[t1.crossTileID] = new Ct(!1, !1, !1));
                    let E = !1, M = !1, S = !0, z = !1, D = !1, A = null, P = {
                        box: null,
                        offscreen: null,
                        occluded: null
                    }, L = {
                        box: null,
                        offscreen: null,
                        occluded: null
                    }, R = null, O = null, B = null, k = 0, F = 0, U = 0;
                    d.textFeatureIndex ? k = d.textFeatureIndex : t1.useRuntimeCollisionCircles && (k = t1.featureIndex), d.verticalTextFeatureIndex && (F = d.verticalTextFeatureIndex);
                    const N = (e1)=>{
                        e1.tileID = this.retainedQueryData[n.bucketInstanceId].tileID, (this.transform.elevation || e1.elevation) && (e1.elevation = this.transform.elevation ? this.transform.elevation.getAtTileOffset(this.retainedQueryData[n.bucketInstanceId].tileID, e1.tileAnchorX, e1.tileAnchorY) : 0);
                    }, G = d.textBox;
                    if (G) {
                        N(G);
                        const i1 = (i)=>{
                            let o = e1.WritingMode.horizontal;
                            if (n.allowVerticalPlacement && !i && this.prevPlacement) {
                                const e2 = this.prevPlacement.placedOrientations[t1.crossTileID];
                                e2 && (this.placedOrientations[t1.crossTileID] = e2, o = e2, this.markUsedOrientation(n, o, t1));
                            }
                            return o;
                        }, o2 = (i, o)=>{
                            if (n.allowVerticalPlacement && t1.numVerticalGlyphVertices > 0 && d.verticalTextBox) {
                                for (const t2 of n.writingModes)if (t2 === e1.WritingMode.vertical ? (P = o(), L = P) : P = i(), P && P.box && P.box.length) break;
                            } else P = i();
                        };
                        if (a.get("text-variable-anchor")) {
                            let l1 = a.get("text-variable-anchor");
                            if (this.prevPlacement && this.prevPlacement.variableOffsets[t1.crossTileID]) {
                                const e3 = this.prevPlacement.variableOffsets[t1.crossTileID];
                                l1.indexOf(e3.anchor) > 0 && (l1 = l1.filter((t1)=>t1 !== e3.anchor), l1.unshift(e3.anchor));
                            }
                            const c1 = (e1, i, o)=>{
                                const a = n.getSymbolInstanceTextSize(p, t1, this.transform.zoom, r), c = (e1.x2 - e1.x1) * a + 2 * e1.padding, h = (e1.y2 - e1.y1) * a + 2 * e1.padding, u = T && !y ? i : null;
                                u && N(u);
                                let d = {
                                    box: [],
                                    offscreen: !1,
                                    occluded: !1
                                };
                                const g = x ? 2 * l1.length : l1.length;
                                for(let i1 = 0; i1 < g; ++i1){
                                    const g1 = this.attemptAnchorPlacement(l1[i1 % l1.length], e1, c, h, a, b, w, _, s, f, i1 >= l1.length, t1, r, n, o, u, p, m);
                                    if (g1 && (d = g1.placedGlyphBoxes, d && d.box && d.box.length)) {
                                        E = !0, A = g1.shift;
                                        break;
                                    }
                                }
                                return d;
                            };
                            o2(()=>c1(G, d.iconBox, e1.WritingMode.horizontal), ()=>{
                                const i = d.verticalTextBox;
                                return i && N(i), n.allowVerticalPlacement && !(P && P.box && P.box.length) && t1.numVerticalGlyphVertices > 0 && i ? c1(i, d.verticalIconBox, e1.WritingMode.vertical) : {
                                    box: null,
                                    offscreen: null,
                                    occluded: null
                                };
                            }), P && (E = P.box, S = P.offscreen, z = P.occluded);
                            const h1 = i1(P && P.box);
                            if (!E && this.prevPlacement) {
                                const e4 = this.prevPlacement.variableOffsets[t1.crossTileID];
                                e4 && (this.variableOffsets[t1.crossTileID] = e4, this.markUsedJustification(n, e4.anchor, t1, h1));
                            }
                        } else {
                            const a1 = (i, o)=>{
                                const a = n.getSymbolInstanceTextSize(p, t1, this.transform.zoom, r), l = this.collisionIndex.placeCollisionBox(n, a, i, new e1.pointGeometry(0, 0), x, _, s, f.predicate);
                                return l && l.box && l.box.length && (this.markUsedOrientation(n, o, t1), this.placedOrientations[t1.crossTileID] = o), l;
                            };
                            o2(()=>a1(G, e1.WritingMode.horizontal), ()=>{
                                const i = d.verticalTextBox;
                                return n.allowVerticalPlacement && t1.numVerticalGlyphVertices > 0 && i ? (N(i), a1(i, e1.WritingMode.vertical)) : {
                                    box: null,
                                    offscreen: null,
                                    occluded: null
                                };
                            }), i1(P && P.box && P.box.length);
                        }
                    }
                    if (R = P, E = R && R.box && R.box.length > 0, S = R && R.offscreen, z = R && R.occluded, t1.useRuntimeCollisionCircles) {
                        const i2 = n.text.placedSymbolArray.get(t1.centerJustifiedTextSymbolIndex >= 0 ? t1.centerJustifiedTextSymbolIndex : t1.verticalPlacedTextSymbolIndex), r2 = e1.evaluateSizeForFeature(n.textSizeData, p, i2), h2 = a.get("text-padding");
                        O = this.collisionIndex.placeCollisionCircles(n, x, i2, n.lineVertexArray, n.glyphOffsetArray, r2, s, l, c, o, w, f.predicate, t1.collisionCircleDiameter * r2 / e1.ONE_EM, h2, this.retainedQueryData[n.bucketInstanceId].tileID), E = x || O.circles.length > 0 && !O.collisionDetected, S = S && O.offscreen, z = O.occluded;
                    }
                    if (d.iconFeatureIndex && (U = d.iconFeatureIndex), d.iconBox) {
                        const i3 = (i)=>{
                            N(i);
                            const o = T && A ? Dt(A.x, A.y, b, w, this.transform.angle) : new e1.pointGeometry(0, 0), r = n.getSymbolInstanceIconSize(m, this.transform.zoom, t1.placedIconSymbolIndex);
                            return this.collisionIndex.placeCollisionBox(n, r, i, o, y, _, s, f.predicate);
                        };
                        L && L.box && L.box.length && d.verticalIconBox ? (B = i3(d.verticalIconBox), M = B.box.length > 0) : (B = i3(d.iconBox), M = B.box.length > 0), S = S && B.offscreen, D = B.occluded;
                    }
                    const j = g || 0 === t1.numHorizontalGlyphVertices && 0 === t1.numVerticalGlyphVertices, Z = v || 0 === t1.numIconVertices;
                    if (j || Z ? Z ? j || (M = M && E) : E = M && E : M = E = M && E, E && R && R.box && this.collisionIndex.insertCollisionBox(R.box, a.get("text-ignore-placement"), n.bucketInstanceId, L && L.box && F ? F : k, f.ID), M && B && this.collisionIndex.insertCollisionBox(B.box, a.get("icon-ignore-placement"), n.bucketInstanceId, U, f.ID), O && (E && this.collisionIndex.insertCollisionCircles(O.circles, a.get("text-ignore-placement"), n.bucketInstanceId, k, f.ID), o)) {
                        const e5 = n.bucketInstanceId;
                        let t2 = this.collisionCircleArrays[e5];
                        void 0 === t2 && (t2 = this.collisionCircleArrays[e5] = new It);
                        for(let e6 = 0; e6 < O.circles.length; e6 += 4)t2.circles.push(O.circles[e6 + 0]), t2.circles.push(O.circles[e6 + 1]), t2.circles.push(O.circles[e6 + 2]), t2.circles.push(O.collisionDetected ? 1 : 0);
                    }
                    const V = "globe" !== n.projection.name;
                    C = C && (V || !z), I = I && (V || !D), this.placements[t1.crossTileID] = new Ct(E || C, M || I, S || n.justReloaded), i[t1.crossTileID] = !0;
                };
                if (E) {
                    const e2 = n.getSortedSymbolIndexes(this.transform.angle);
                    for(let t2 = e2.length - 1; t2 >= 0; --t2){
                        const i1 = e2[t2];
                        M(n.symbolInstances.get(i1), i1, n.collisionArrays[i1]);
                    }
                } else for(let e3 = t1.symbolInstanceStart; e3 < t1.symbolInstanceEnd; e3++)M(n.symbolInstances.get(e3), e3, n.collisionArrays[e3]);
                if (o && n.bucketInstanceId in this.collisionCircleArrays) {
                    const t3 = this.collisionCircleArrays[n.bucketInstanceId];
                    e1.invert(t3.invProjMatrix, s), t3.viewportMatrix = this.collisionIndex.getViewportMatrix();
                }
                n.justReloaded = !1;
            }
            markUsedJustification(t1, i, o, r) {
                let n;
                n = r === e1.WritingMode.vertical ? o.verticalPlacedTextSymbolIndex : ({
                    left: o.leftJustifiedTextSymbolIndex,
                    center: o.centerJustifiedTextSymbolIndex,
                    right: o.rightJustifiedTextSymbolIndex
                })[e1.getAnchorJustification(i)];
                const a = [
                    o.leftJustifiedTextSymbolIndex,
                    o.centerJustifiedTextSymbolIndex,
                    o.rightJustifiedTextSymbolIndex,
                    o.verticalPlacedTextSymbolIndex
                ];
                for (const e2 of a)e2 >= 0 && (t1.text.placedSymbolArray.get(e2).crossTileID = n >= 0 && e2 !== n ? 0 : o.crossTileID);
            }
            markUsedOrientation(t1, i, o) {
                const r = i === e1.WritingMode.horizontal || i === e1.WritingMode.horizontalOnly ? i : 0, n = i === e1.WritingMode.vertical ? i : 0, a = [
                    o.leftJustifiedTextSymbolIndex,
                    o.centerJustifiedTextSymbolIndex,
                    o.rightJustifiedTextSymbolIndex
                ].filter((e1)=>-1 !== e1);
                for (const e2 of a)t1.text.placedSymbolArray.get(e2).placedOrientation = r;
                -1 !== o.verticalPlacedTextSymbolIndex && (t1.text.placedSymbolArray.get(o.verticalPlacedTextSymbolIndex).placedOrientation = n);
            }
            commit(e1) {
                this.commitTime = e1, this.zoomAtLastRecencyCheck = this.transform.zoom;
                const t1 = this.prevPlacement;
                let i = !1;
                this.prevZoomAdjustment = t1 ? t1.zoomAdjustment(this.transform.zoom) : 0;
                const o = t1 ? t1.symbolFadeChange(e1) : 1, r = t1 ? t1.opacities : {}, n = t1 ? t1.variableOffsets : {}, a = t1 ? t1.placedOrientations : {};
                for(const e2 in this.placements){
                    const t2 = this.placements[e2], n1 = r[e2];
                    n1 ? (this.opacities[e2] = new Et(n1, o, t2.text, t2.icon, null, t2.clipped), i = i || t2.text !== n1.text.placed || t2.icon !== n1.icon.placed) : (this.opacities[e2] = new Et(null, o, t2.text, t2.icon, t2.skipFade, t2.clipped), i = i || t2.text || t2.icon);
                }
                for(const e3 in r){
                    const t3 = r[e3];
                    if (!this.opacities[e3]) {
                        const r1 = new Et(t3, o, !1, !1);
                        r1.isHidden() || (this.opacities[e3] = r1, i = i || t3.text.placed || t3.icon.placed);
                    }
                }
                for(const e4 in n)this.variableOffsets[e4] || !this.opacities[e4] || this.opacities[e4].isHidden() || (this.variableOffsets[e4] = n[e4]);
                for(const e5 in a)this.placedOrientations[e5] || !this.opacities[e5] || this.opacities[e5].isHidden() || (this.placedOrientations[e5] = a[e5]);
                i ? this.lastPlacementChangeTime = e1 : "number" != typeof this.lastPlacementChangeTime && (this.lastPlacementChangeTime = t1 ? t1.lastPlacementChangeTime : e1);
            }
            updateLayerOpacities(e1, t1) {
                const i = {};
                for (const o of t1){
                    const t2 = o.getBucket(e1);
                    t2 && o.latestFeatureIndex && e1.id === t2.layerIds[0] && this.updateBucketOpacities(t2, i, o.collisionBoxArray);
                }
            }
            updateBucketOpacities(t1, i, o) {
                t1.hasTextData() && t1.text.opacityVertexArray.clear(), t1.hasIconData() && t1.icon.opacityVertexArray.clear(), t1.hasIconCollisionBoxData() && t1.iconCollisionBox.collisionVertexArray.clear(), t1.hasTextCollisionBoxData() && t1.textCollisionBox.collisionVertexArray.clear();
                const r = t1.layers[0].layout, n = !!t1.layers[0].dynamicFilter(), a = new Et(null, 0, !1, !1, !0), s = r.get("text-allow-overlap"), l = r.get("icon-allow-overlap"), c = r.get("text-variable-anchor"), h = "map" === r.get("text-rotation-alignment"), _ = "map" === r.get("text-pitch-alignment"), u = "none" !== r.get("icon-text-fit"), d = new Et(null, 0, s && (l || !t1.hasIconData() || r.get("icon-optional")), l && (s || !t1.hasTextData() || r.get("text-optional")), !0);
                !t1.collisionArrays && o && (t1.hasIconCollisionBoxData() || t1.hasTextCollisionBoxData()) && t1.deserializeCollisionBoxes(o);
                const p = (e1, t1, i)=>{
                    for(let o = 0; o < t1 / 4; o++)e1.opacityVertexArray.emplaceBack(i);
                };
                let m = 0;
                for(let o1 = 0; o1 < t1.symbolInstances.length; o1++){
                    const r1 = t1.symbolInstances.get(o1), { numHorizontalGlyphVertices: s1 , numVerticalGlyphVertices: l1 , crossTileID: f  } = r1;
                    let g = this.opacities[f];
                    i[f] ? g = a : g || (g = d, this.opacities[f] = g), i[f] = !0;
                    const v = s1 > 0 || l1 > 0, x = r1.numIconVertices > 0, y = this.placedOrientations[r1.crossTileID], b = y === e1.WritingMode.vertical, w = y === e1.WritingMode.horizontal || y === e1.WritingMode.horizontalOnly;
                    if (!v && !x || g.isHidden() || m++, v) {
                        const e2 = Nt(g.text);
                        p(t1.text, s1, b ? Gt : e2), p(t1.text, l1, w ? Gt : e2);
                        const i1 = g.text.isHidden();
                        [
                            r1.rightJustifiedTextSymbolIndex,
                            r1.centerJustifiedTextSymbolIndex,
                            r1.leftJustifiedTextSymbolIndex
                        ].forEach((e1)=>{
                            e1 >= 0 && (t1.text.placedSymbolArray.get(e1).hidden = i1 || b ? 1 : 0);
                        }), r1.verticalPlacedTextSymbolIndex >= 0 && (t1.text.placedSymbolArray.get(r1.verticalPlacedTextSymbolIndex).hidden = i1 || w ? 1 : 0);
                        const o2 = this.variableOffsets[r1.crossTileID];
                        o2 && this.markUsedJustification(t1, o2.anchor, r1, y);
                        const n1 = this.placedOrientations[r1.crossTileID];
                        n1 && (this.markUsedJustification(t1, "left", r1, n1), this.markUsedOrientation(t1, n1, r1));
                    }
                    if (x) {
                        const e3 = Nt(g.icon);
                        r1.placedIconSymbolIndex >= 0 && (p(t1.icon, r1.numIconVertices, b ? Gt : e3), t1.icon.placedSymbolArray.get(r1.placedIconSymbolIndex).hidden = g.icon.isHidden()), r1.verticalPlacedIconSymbolIndex >= 0 && (p(t1.icon, r1.numVerticalIconVertices, w ? Gt : e3), t1.icon.placedSymbolArray.get(r1.verticalPlacedIconSymbolIndex).hidden = g.icon.isHidden());
                    }
                    if (t1.hasIconCollisionBoxData() || t1.hasTextCollisionBoxData()) {
                        const i2 = t1.collisionArrays[o1];
                        if (i2) {
                            let o3 = new e1.pointGeometry(0, 0), r2 = !0;
                            if (i2.textBox || i2.verticalTextBox) {
                                if (c) {
                                    const e4 = this.variableOffsets[f];
                                    e4 ? (o3 = zt(e4.anchor, e4.width, e4.height, e4.textOffset, e4.textScale), h && o3._rotate(_ ? this.transform.angle : -this.transform.angle)) : r2 = !1;
                                }
                                n && (r2 = !g.clipped), i2.textBox && Pt(t1.textCollisionBox.collisionVertexArray, g.text.placed, !r2 || b, o3.x, o3.y), i2.verticalTextBox && Pt(t1.textCollisionBox.collisionVertexArray, g.text.placed, !r2 || w, o3.x, o3.y);
                            }
                            const a1 = r2 && Boolean(!w && i2.verticalIconBox);
                            i2.iconBox && Pt(t1.iconCollisionBox.collisionVertexArray, g.icon.placed, a1, u ? o3.x : 0, u ? o3.y : 0), i2.verticalIconBox && Pt(t1.iconCollisionBox.collisionVertexArray, g.icon.placed, !a1, u ? o3.x : 0, u ? o3.y : 0);
                        }
                    }
                }
                if (t1.fullyClipped = 0 === m, t1.sortFeatures(this.transform.angle), this.retainedQueryData[t1.bucketInstanceId] && (this.retainedQueryData[t1.bucketInstanceId].featureSortOrder = t1.featureSortOrder), t1.hasTextData() && t1.text.opacityVertexBuffer && t1.text.opacityVertexBuffer.updateData(t1.text.opacityVertexArray), t1.hasIconData() && t1.icon.opacityVertexBuffer && t1.icon.opacityVertexBuffer.updateData(t1.icon.opacityVertexArray), t1.hasIconCollisionBoxData() && t1.iconCollisionBox.collisionVertexBuffer && t1.iconCollisionBox.collisionVertexBuffer.updateData(t1.iconCollisionBox.collisionVertexArray), t1.hasTextCollisionBoxData() && t1.textCollisionBox.collisionVertexBuffer && t1.textCollisionBox.collisionVertexBuffer.updateData(t1.textCollisionBox.collisionVertexArray), t1.bucketInstanceId in this.collisionCircleArrays) {
                    const e5 = this.collisionCircleArrays[t1.bucketInstanceId];
                    t1.placementInvProjMatrix = e5.invProjMatrix, t1.placementViewportMatrix = e5.viewportMatrix, t1.collisionCircleArray = e5.circles, delete this.collisionCircleArrays[t1.bucketInstanceId];
                }
            }
            symbolFadeChange(e1) {
                return 0 === this.fadeDuration ? 1 : (e1 - this.commitTime) / this.fadeDuration + this.prevZoomAdjustment;
            }
            zoomAdjustment(e1) {
                return Math.max(0, (this.transform.zoom - e1) / 1.5);
            }
            hasTransitions(e1) {
                return this.stale || e1 - this.lastPlacementChangeTime < this.fadeDuration;
            }
            stillRecent(e1, t1) {
                const i = this.zoomAtLastRecencyCheck === t1 ? 1 - this.zoomAdjustment(t1) : 1;
                return this.zoomAtLastRecencyCheck = t1, this.commitTime + this.fadeDuration * i > e1;
            }
            setStale() {
                this.stale = !0;
            }
        }
        function Pt(e1, t1, i, o, r) {
            e1.emplaceBack(t1 ? 1 : 0, i ? 1 : 0, o || 0, r || 0), e1.emplaceBack(t1 ? 1 : 0, i ? 1 : 0, o || 0, r || 0), e1.emplaceBack(t1 ? 1 : 0, i ? 1 : 0, o || 0, r || 0), e1.emplaceBack(t1 ? 1 : 0, i ? 1 : 0, o || 0, r || 0);
        }
        const Lt = Math.pow(2, 25), Rt = Math.pow(2, 24), Ot = Math.pow(2, 17), Bt = Math.pow(2, 16), kt = Math.pow(2, 9), Ft = Math.pow(2, 8), Ut = Math.pow(2, 1);
        function Nt(e1) {
            if (0 === e1.opacity && !e1.placed) return 0;
            if (1 === e1.opacity && e1.placed) return 4294967295;
            const t1 = e1.placed ? 1 : 0, i = Math.floor(127 * e1.opacity);
            return i * Lt + t1 * Rt + i * Ot + t1 * Bt + i * kt + t1 * Ft + i * Ut + t1;
        }
        const Gt = 0;
        class jt {
            constructor(e1){
                this._sortAcrossTiles = "viewport-y" !== e1.layout.get("symbol-z-order") && void 0 !== e1.layout.get("symbol-sort-key").constantOr(1), this._currentTileIndex = 0, this._currentPartIndex = 0, this._seenCrossTileIDs = {}, this._bucketParts = [];
            }
            continuePlacement(e1, t1, i, o, r) {
                const n = this._bucketParts;
                for(; this._currentTileIndex < e1.length;)if (t1.getBucketParts(n, o, e1[this._currentTileIndex], this._sortAcrossTiles), this._currentTileIndex++, r()) return !0;
                for(this._sortAcrossTiles && (this._sortAcrossTiles = !1, n.sort((e1, t1)=>e1.sortKey - t1.sortKey)); this._currentPartIndex < n.length;){
                    const e2 = n[this._currentPartIndex];
                    if (t1.placeLayerBucketPart(e2, this._seenCrossTileIDs, i, 0 === e2.symbolInstanceStart), this._currentPartIndex++, r()) return !0;
                }
                return !1;
            }
        }
        class Zt {
            constructor(e1, t1, i, o, r, n, a, s){
                this.placement = new At(e1, r, n, a, s), this._currentPlacementIndex = t1.length - 1, this._forceFullPlacement = i, this._showCollisionBoxes = o, this._done = !1;
            }
            isDone() {
                return this._done;
            }
            continuePlacement(t1, i, o) {
                const r = e1.exported.now(), n = ()=>{
                    const t1 = e1.exported.now() - r;
                    return !this._forceFullPlacement && t1 > 2;
                };
                for(; this._currentPlacementIndex >= 0;){
                    const e2 = i[t1[this._currentPlacementIndex]], r1 = this.placement.collisionIndex.transform.zoom;
                    if ("symbol" === e2.type && (!e2.minzoom || e2.minzoom <= r1) && (!e2.maxzoom || e2.maxzoom > r1)) {
                        if (this._inProgressLayer || (this._inProgressLayer = new jt(e2)), this._inProgressLayer.continuePlacement(o[e2.source], this.placement, this._showCollisionBoxes, e2, n)) return;
                        delete this._inProgressLayer;
                    }
                    this._currentPlacementIndex--;
                }
                this._done = !0;
            }
            commit(e1) {
                return this.placement.commit(e1), this.placement;
            }
        }
        const Vt = 512 / e1.EXTENT / 2;
        class Wt {
            constructor(e1, t1, i){
                this.tileID = e1, this.indexedSymbolInstances = {}, this.bucketInstanceId = i;
                for(let i1 = 0; i1 < t1.length; i1++){
                    const o = t1.get(i1), r = o.key;
                    this.indexedSymbolInstances[r] || (this.indexedSymbolInstances[r] = []), this.indexedSymbolInstances[r].push({
                        crossTileID: o.crossTileID,
                        coord: this.getScaledCoordinates(o, e1)
                    });
                }
            }
            getScaledCoordinates(t1, i) {
                const o = Vt / Math.pow(2, i.canonical.z - this.tileID.canonical.z);
                return {
                    x: Math.floor((i.canonical.x * e1.EXTENT + t1.tileAnchorX) * o),
                    y: Math.floor((i.canonical.y * e1.EXTENT + t1.tileAnchorY) * o)
                };
            }
            findMatches(e1, t1, i) {
                const o = this.tileID.canonical.z < t1.canonical.z ? 1 : Math.pow(2, this.tileID.canonical.z - t1.canonical.z);
                for(let r = 0; r < e1.length; r++){
                    const n = e1.get(r);
                    if (n.crossTileID) continue;
                    const a = this.indexedSymbolInstances[n.key];
                    if (!a) continue;
                    const s = this.getScaledCoordinates(n, t1);
                    for (const e2 of a)if (Math.abs(e2.coord.x - s.x) <= o && Math.abs(e2.coord.y - s.y) <= o && !i[e2.crossTileID]) {
                        i[e2.crossTileID] = !0, n.crossTileID = e2.crossTileID;
                        break;
                    }
                }
            }
        }
        class Xt {
            constructor(){
                this.maxCrossTileID = 0;
            }
            generate() {
                return ++this.maxCrossTileID;
            }
        }
        class qt {
            constructor(){
                this.indexes = {}, this.usedCrossTileIDs = {}, this.lng = 0;
            }
            handleWrapJump(e1) {
                const t1 = Math.round((e1 - this.lng) / 360);
                if (0 !== t1) for(const e2 in this.indexes){
                    const i = this.indexes[e2], o = {};
                    for(const e3 in i){
                        const r = i[e3];
                        r.tileID = r.tileID.unwrapTo(r.tileID.wrap + t1), o[r.tileID.key] = r;
                    }
                    this.indexes[e2] = o;
                }
                this.lng = e1;
            }
            addBucket(e1, t1, i) {
                if (this.indexes[e1.overscaledZ] && this.indexes[e1.overscaledZ][e1.key]) {
                    if (this.indexes[e1.overscaledZ][e1.key].bucketInstanceId === t1.bucketInstanceId) return !1;
                    this.removeBucketCrossTileIDs(e1.overscaledZ, this.indexes[e1.overscaledZ][e1.key]);
                }
                for(let e2 = 0; e2 < t1.symbolInstances.length; e2++)t1.symbolInstances.get(e2).crossTileID = 0;
                this.usedCrossTileIDs[e1.overscaledZ] || (this.usedCrossTileIDs[e1.overscaledZ] = {});
                const o = this.usedCrossTileIDs[e1.overscaledZ];
                for(const i1 in this.indexes){
                    const r = this.indexes[i1];
                    if (Number(i1) > e1.overscaledZ) for(const i2 in r){
                        const n = r[i2];
                        n.tileID.isChildOf(e1) && n.findMatches(t1.symbolInstances, e1, o);
                    }
                    else {
                        const n1 = r[e1.scaledTo(Number(i1)).key];
                        n1 && n1.findMatches(t1.symbolInstances, e1, o);
                    }
                }
                for(let e3 = 0; e3 < t1.symbolInstances.length; e3++){
                    const r1 = t1.symbolInstances.get(e3);
                    r1.crossTileID || (r1.crossTileID = i.generate(), o[r1.crossTileID] = !0);
                }
                return void 0 === this.indexes[e1.overscaledZ] && (this.indexes[e1.overscaledZ] = {}), this.indexes[e1.overscaledZ][e1.key] = new Wt(e1, t1.symbolInstances, t1.bucketInstanceId), !0;
            }
            removeBucketCrossTileIDs(e1, t1) {
                for(const i in t1.indexedSymbolInstances)for (const o of t1.indexedSymbolInstances[i])delete this.usedCrossTileIDs[e1][o.crossTileID];
            }
            removeStaleBuckets(e1) {
                let t1 = !1;
                for(const i in this.indexes){
                    const o = this.indexes[i];
                    for(const r in o)e1[o[r].bucketInstanceId] || (this.removeBucketCrossTileIDs(i, o[r]), delete o[r], t1 = !0);
                }
                return t1;
            }
        }
        class $t {
            constructor(){
                this.layerIndexes = {}, this.crossTileIDs = new Xt, this.maxBucketInstanceId = 0, this.bucketsInCurrentPlacement = {};
            }
            addLayer(e1, t1, i, o) {
                let r = this.layerIndexes[e1.id];
                void 0 === r && (r = this.layerIndexes[e1.id] = new qt);
                let n = !1;
                const a = {};
                "globe" !== o.name && r.handleWrapJump(i);
                for (const i1 of t1){
                    const t2 = i1.getBucket(e1);
                    t2 && e1.id === t2.layerIds[0] && (t2.bucketInstanceId || (t2.bucketInstanceId = ++this.maxBucketInstanceId), r.addBucket(i1.tileID, t2, this.crossTileIDs) && (n = !0), a[t2.bucketInstanceId] = !0);
                }
                return r.removeStaleBuckets(a) && (n = !0), n;
            }
            pruneUnusedLayers(e1) {
                const t1 = {};
                e1.forEach((e1)=>{
                    t1[e1] = !0;
                });
                for(const e2 in this.layerIndexes)t1[e2] || delete this.layerIndexes[e2];
            }
        }
        const Ht = (t1, i)=>e1.emitValidationErrors(t1, i && i.filter((e1)=>"source.canvas" !== e1.identifier)), Yt = e1.pick(Ve, [
            "addLayer",
            "removeLayer",
            "setPaintProperty",
            "setLayoutProperty",
            "setFilter",
            "addSource",
            "removeSource",
            "setLayerZoomRange",
            "setLight",
            "setTransition",
            "setGeoJSONSourceData",
            "setTerrain",
            "setFog",
            "setProjection"
        ]), Kt = e1.pick(Ve, [
            "setCenter",
            "setZoom",
            "setBearing",
            "setPitch"
        ]), Jt = {
            version: 8,
            layers: [],
            sources: {}
        }, Qt = {
            fill: !0,
            line: !0,
            background: !0,
            hillshade: !0,
            raster: !0
        };
        class ei extends e1.Evented {
            constructor(t1, i = {}){
                super(), this.map = t1, this.dispatcher = new P(Ge(), this), this.imageManager = new y, this.imageManager.setEventedParent(this), this.glyphManager = new e1.GlyphManager(t1._requestManager, i.localFontFamily ? e1.LocalGlyphMode.all : i.localIdeographFontFamily ? e1.LocalGlyphMode.ideographs : e1.LocalGlyphMode.none, i.localFontFamily || i.localIdeographFontFamily), this.crossTileSymbolIndex = new $t, this._layers = {}, this._num3DLayers = 0, this._numSymbolLayers = 0, this._numCircleLayers = 0, this._serializedLayers = {}, this._sourceCaches = {}, this._otherSourceCaches = {}, this._symbolSourceCaches = {}, this.zoomHistory = new e1.ZoomHistory, this._loaded = !1, this._availableImages = [], this._order = [], this._drapedFirstOrder = [], this._markersNeedUpdate = !1, this._resetUpdates(), this.dispatcher.broadcast("setReferrer", e1.getReferrer());
                const o = this;
                this._rtlTextPluginCallback = ei.registerForPluginStateChange((t1)=>{
                    o.dispatcher.broadcast("syncRTLPluginState", {
                        pluginStatus: t1.pluginStatus,
                        pluginURL: t1.pluginURL
                    }, (t1, i)=>{
                        if (e1.triggerPluginCompletionEvent(t1), i && i.every((e1)=>e1)) for(const e2 in o._sourceCaches){
                            const t2 = o._sourceCaches[e2], i1 = t2.getSource().type;
                            "vector" !== i1 && "geojson" !== i1 || t2.reload();
                        }
                    });
                }), this.on("data", (e1)=>{
                    if ("source" !== e1.dataType || "metadata" !== e1.sourceDataType) return;
                    const t1 = this.getSource(e1.sourceId);
                    if (t1 && t1.vectorLayerIds) for(const e2 in this._layers){
                        const i = this._layers[e2];
                        i.source === t1.id && this._validateLayer(i);
                    }
                });
            }
            loadURL(t1, i = {}) {
                this.fire(new e1.Event("dataloading", {
                    dataType: "style"
                }));
                const o = "boolean" == typeof i.validate ? i.validate : !e1.isMapboxURL(t1);
                t1 = this.map._requestManager.normalizeStyleURL(t1, i.accessToken);
                const r = this.map._requestManager.transformRequest(t1, e1.ResourceType.Style);
                this._request = e1.getJSON(r, (t1, i)=>{
                    this._request = null, t1 ? this.fire(new e1.ErrorEvent(t1)) : i && this._load(i, o);
                });
            }
            loadJSON(t1, i = {}) {
                this.fire(new e1.Event("dataloading", {
                    dataType: "style"
                })), this._request = e1.exported.frame(()=>{
                    this._request = null, this._load(t1, !1 !== i.validate);
                });
            }
            loadEmpty() {
                this.fire(new e1.Event("dataloading", {
                    dataType: "style"
                })), this._load(Jt, !1);
            }
            _updateLayerCount(e1, t1) {
                const i = t1 ? 1 : -1;
                e1.is3D() && (this._num3DLayers += i), "circle" === e1.type && (this._numCircleLayers += i), "symbol" === e1.type && (this._numSymbolLayers += i);
            }
            _load(t1, i) {
                if (i && Ht(this, e1.validateStyle(t1))) return;
                this._loaded = !0, this.stylesheet = e1.clone$1(t1), this._updateMapProjection();
                for(const e2 in t1.sources)this.addSource(e2, t1.sources[e2], {
                    validate: !1
                });
                this._changed = !1, t1.sprite ? this._loadSprite(t1.sprite) : (this.imageManager.setLoaded(!0), this.dispatcher.broadcast("spriteLoaded", !0)), this.glyphManager.setURL(t1.glyphs);
                const o = Ze(this.stylesheet.layers);
                this._order = o.map((e1)=>e1.id), this._layers = {}, this._serializedLayers = {};
                for (let t2 of o)t2 = e1.createStyleLayer(t2), t2.setEventedParent(this, {
                    layer: {
                        id: t2.id
                    }
                }), this._layers[t2.id] = t2, this._serializedLayers[t2.id] = t2.serialize(), this._updateLayerCount(t2, !0);
                this.dispatcher.broadcast("setLayers", this._serializeLayers(this._order)), this.light = new T(this.stylesheet.light), this.stylesheet.terrain && !this.terrainSetForDrapingOnly() && this._createTerrain(this.stylesheet.terrain, 1), this.stylesheet.fog && this._createFog(this.stylesheet.fog), this._updateDrapeFirstLayers(), this.fire(new e1.Event("data", {
                    dataType: "style"
                })), this.fire(new e1.Event("style.load"));
            }
            terrainSetForDrapingOnly() {
                return !!this.terrain && 0 === this.terrain.drapeRenderMode;
            }
            setProjection(e1) {
                e1 ? this.stylesheet.projection = e1 : delete this.stylesheet.projection, this._updateMapProjection();
            }
            applyProjectionUpdate() {
                this._loaded && (this.dispatcher.broadcast("setProjection", this.map.transform.projectionOptions), this.map.transform.projection.requiresDraping ? this.getTerrain() || this.stylesheet.terrain || this.setTerrainForDraping() : this.terrainSetForDrapingOnly() && this.setTerrain(null));
            }
            _updateMapProjection() {
                this.map._useExplicitProjection ? this.applyProjectionUpdate() : this.map._prioritizeAndUpdateProjection(null, this.stylesheet.projection);
            }
            _loadSprite(t1) {
                this._spriteRequest = function(t1, i, o) {
                    let r, n, a;
                    const s = e1.exported.devicePixelRatio > 1 ? "@2x" : "";
                    let l = e1.getJSON(i.transformRequest(i.normalizeSpriteURL(t1, s, ".json"), e1.ResourceType.SpriteJSON), (e1, t1)=>{
                        l = null, a || (a = e1, r = t1, h());
                    }), c = e1.getImage(i.transformRequest(i.normalizeSpriteURL(t1, s, ".png"), e1.ResourceType.SpriteImage), (e1, t1)=>{
                        c = null, a || (a = e1, n = t1, h());
                    });
                    function h() {
                        if (a) o(a);
                        else if (r && n) {
                            const t1 = e1.exported.getImageData(n), i = {};
                            for(const o1 in r){
                                const { width: n1 , height: a1 , x: s , y: l , sdf: c , pixelRatio: h , stretchX: _ , stretchY: u , content: d  } = r[o1], p = new e1.RGBAImage({
                                    width: n1,
                                    height: a1
                                });
                                e1.RGBAImage.copy(t1, p, {
                                    x: s,
                                    y: l
                                }, {
                                    x: 0,
                                    y: 0
                                }, {
                                    width: n1,
                                    height: a1
                                }), i[o1] = {
                                    data: p,
                                    pixelRatio: h,
                                    sdf: c,
                                    stretchX: _,
                                    stretchY: u,
                                    content: d
                                };
                            }
                            o(null, i);
                        }
                    }
                    return {
                        cancel () {
                            l && (l.cancel(), l = null), c && (c.cancel(), c = null);
                        }
                    };
                }(t1, this.map._requestManager, (t1, i)=>{
                    if (this._spriteRequest = null, t1) this.fire(new e1.ErrorEvent(t1));
                    else if (i) for(const e2 in i)this.imageManager.addImage(e2, i[e2]);
                    this.imageManager.setLoaded(!0), this._availableImages = this.imageManager.listImages(), this.dispatcher.broadcast("setImages", this._availableImages), this.dispatcher.broadcast("spriteLoaded", !0), this.fire(new e1.Event("data", {
                        dataType: "style"
                    }));
                });
            }
            _validateLayer(t1) {
                const i = this.getSource(t1.source);
                if (!i) return;
                const o = t1.sourceLayer;
                o && ("geojson" === i.type || i.vectorLayerIds && -1 === i.vectorLayerIds.indexOf(o)) && this.fire(new e1.ErrorEvent(new Error(`Source layer "${o}" does not exist on source "${i.id}" as specified by style layer "${t1.id}"`)));
            }
            loaded() {
                if (!this._loaded) return !1;
                if (Object.keys(this._updatedSources).length) return !1;
                for(const e1 in this._sourceCaches)if (!this._sourceCaches[e1].loaded()) return !1;
                return !!this.imageManager.isLoaded();
            }
            _serializeLayers(e1) {
                const t1 = [];
                for (const i of e1){
                    const e2 = this._layers[i];
                    "custom" !== e2.type && t1.push(e2.serialize());
                }
                return t1;
            }
            hasTransitions() {
                if (this.light && this.light.hasTransition()) return !0;
                if (this.fog && this.fog.hasTransition()) return !0;
                for(const e1 in this._sourceCaches)if (this._sourceCaches[e1].hasTransition()) return !0;
                for(const e2 in this._layers)if (this._layers[e2].hasTransition()) return !0;
                return !1;
            }
            get order() {
                return this.map._optimizeForTerrain && this.terrain ? this._drapedFirstOrder : this._order;
            }
            isLayerDraped(e1) {
                return !!this.terrain && Qt[e1.type];
            }
            _checkLoaded() {
                if (!this._loaded) throw new Error("Style is not done loading");
            }
            update(t1) {
                if (!this._loaded) return;
                const i = this._changed;
                if (this._changed) {
                    const e2 = Object.keys(this._updatedLayers), i1 = Object.keys(this._removedLayers);
                    (e2.length || i1.length) && this._updateWorkerLayers(e2, i1);
                    for(const e3 in this._updatedSources){
                        const t2 = this._updatedSources[e3];
                        "reload" === t2 ? this._reloadSource(e3) : "clear" === t2 && this._clearSource(e3);
                    }
                    this._updateTilesForChangedImages();
                    for(const e4 in this._updatedPaintProps)this._layers[e4].updateTransitions(t1);
                    this.light.updateTransitions(t1), this.fog && this.fog.updateTransitions(t1), this._resetUpdates();
                }
                const o = {};
                for(const e5 in this._sourceCaches){
                    const t3 = this._sourceCaches[e5];
                    o[e5] = t3.used, t3.used = !1;
                }
                for (const e6 of this._order){
                    const i2 = this._layers[e6];
                    if (i2.recalculate(t1, this._availableImages), !i2.isHidden(t1.zoom)) {
                        const e7 = this._getLayerSourceCache(i2);
                        e7 && (e7.used = !0);
                    }
                    const o1 = this.map.painter;
                    if (o1) {
                        const e8 = i2.getProgramIds();
                        if (!e8) continue;
                        const r = i2.getProgramConfiguration(t1.zoom);
                        for (const t4 of e8)o1.useProgram(t4, r);
                    }
                }
                for(const t5 in o){
                    const i3 = this._sourceCaches[t5];
                    o[t5] !== i3.used && i3.getSource().fire(new e1.Event("data", {
                        sourceDataType: "visibility",
                        dataType: "source",
                        sourceId: i3.getSource().id
                    }));
                }
                this.light.recalculate(t1), this.terrain && this.terrain.recalculate(t1), this.fog && this.fog.recalculate(t1), this.z = t1.zoom, this._markersNeedUpdate && (this._updateMarkersOpacity(), this._markersNeedUpdate = !1), i && this.fire(new e1.Event("data", {
                    dataType: "style"
                }));
            }
            _updateTilesForChangedImages() {
                const e1 = Object.keys(this._changedImages);
                if (e1.length) {
                    for(const t1 in this._sourceCaches)this._sourceCaches[t1].reloadTilesForDependencies([
                        "icons",
                        "patterns"
                    ], e1);
                    this._changedImages = {};
                }
            }
            _updateWorkerLayers(e1, t1) {
                this.dispatcher.broadcast("updateLayers", {
                    layers: this._serializeLayers(e1),
                    removedIds: t1
                });
            }
            _resetUpdates() {
                this._changed = !1, this._updatedLayers = {}, this._removedLayers = {}, this._updatedSources = {}, this._updatedPaintProps = {}, this._changedImages = {};
            }
            setState(i) {
                if (this._checkLoaded(), Ht(this, e1.validateStyle(i))) return !1;
                (i = e1.clone$1(i)).layers = Ze(i.layers);
                const o = (function(e1, i) {
                    if (!e1) return [
                        {
                            command: Ve.setStyle,
                            args: [
                                i
                            ]
                        }
                    ];
                    let o = [];
                    try {
                        if (!t1(e1.version, i.version)) return [
                            {
                                command: Ve.setStyle,
                                args: [
                                    i
                                ]
                            }
                        ];
                        t1(e1.center, i.center) || o.push({
                            command: Ve.setCenter,
                            args: [
                                i.center
                            ]
                        }), t1(e1.zoom, i.zoom) || o.push({
                            command: Ve.setZoom,
                            args: [
                                i.zoom
                            ]
                        }), t1(e1.bearing, i.bearing) || o.push({
                            command: Ve.setBearing,
                            args: [
                                i.bearing
                            ]
                        }), t1(e1.pitch, i.pitch) || o.push({
                            command: Ve.setPitch,
                            args: [
                                i.pitch
                            ]
                        }), t1(e1.sprite, i.sprite) || o.push({
                            command: Ve.setSprite,
                            args: [
                                i.sprite
                            ]
                        }), t1(e1.glyphs, i.glyphs) || o.push({
                            command: Ve.setGlyphs,
                            args: [
                                i.glyphs
                            ]
                        }), t1(e1.transition, i.transition) || o.push({
                            command: Ve.setTransition,
                            args: [
                                i.transition
                            ]
                        }), t1(e1.light, i.light) || o.push({
                            command: Ve.setLight,
                            args: [
                                i.light
                            ]
                        }), t1(e1.fog, i.fog) || o.push({
                            command: Ve.setFog,
                            args: [
                                i.fog
                            ]
                        }), t1(e1.projection, i.projection) || o.push({
                            command: Ve.setProjection,
                            args: [
                                i.projection
                            ]
                        });
                        const r = {}, n = [];
                        !function(e1, i, o, r) {
                            let n;
                            for(n in i = i || {}, e1 = e1 || {})e1.hasOwnProperty(n) && (i.hasOwnProperty(n) || Xe(n, o, r));
                            for(n in i)i.hasOwnProperty(n) && (e1.hasOwnProperty(n) ? t1(e1[n], i[n]) || ("geojson" === e1[n].type && "geojson" === i[n].type && $e(e1, i, n) ? o.push({
                                command: Ve.setGeoJSONSourceData,
                                args: [
                                    n,
                                    i[n].data
                                ]
                            }) : qe(n, i, o, r)) : We(n, i, o));
                        }(e1.sources, i.sources, n, r);
                        const a = [];
                        e1.layers && e1.layers.forEach((e1)=>{
                            e1.source && r[e1.source] ? o.push({
                                command: Ve.removeLayer,
                                args: [
                                    e1.id
                                ]
                            }) : a.push(e1);
                        });
                        let s = e1.terrain;
                        s && r[s.source] && (o.push({
                            command: Ve.setTerrain,
                            args: [
                                void 0
                            ]
                        }), s = void 0), o = o.concat(n), t1(s, i.terrain) || o.push({
                            command: Ve.setTerrain,
                            args: [
                                i.terrain
                            ]
                        }), function(e1, i, o) {
                            i = i || [];
                            const r = (e1 = e1 || []).map(Ye), n = i.map(Ye), a = e1.reduce(Ke, {}), s = i.reduce(Ke, {}), l = r.slice(), c = Object.create(null);
                            let h, _, u, d, p, m, f;
                            for(h = 0, _ = 0; h < r.length; h++)u = r[h], s.hasOwnProperty(u) ? _++ : (o.push({
                                command: Ve.removeLayer,
                                args: [
                                    u
                                ]
                            }), l.splice(l.indexOf(u, _), 1));
                            for(h = 0, _ = 0; h < n.length; h++)u = n[n.length - 1 - h], l[l.length - 1 - h] !== u && (a.hasOwnProperty(u) ? (o.push({
                                command: Ve.removeLayer,
                                args: [
                                    u
                                ]
                            }), l.splice(l.lastIndexOf(u, l.length - _), 1)) : _++, m = l[l.length - h], o.push({
                                command: Ve.addLayer,
                                args: [
                                    s[u],
                                    m
                                ]
                            }), l.splice(l.length - h, 0, u), c[u] = !0);
                            for(h = 0; h < n.length; h++)if (u = n[h], d = a[u], p = s[u], !c[u] && !t1(d, p)) {
                                if (t1(d.source, p.source) && t1(d["source-layer"], p["source-layer"]) && t1(d.type, p.type)) {
                                    for(f in He(d.layout, p.layout, o, u, null, Ve.setLayoutProperty), He(d.paint, p.paint, o, u, null, Ve.setPaintProperty), t1(d.filter, p.filter) || o.push({
                                        command: Ve.setFilter,
                                        args: [
                                            u,
                                            p.filter
                                        ]
                                    }), t1(d.minzoom, p.minzoom) && t1(d.maxzoom, p.maxzoom) || o.push({
                                        command: Ve.setLayerZoomRange,
                                        args: [
                                            u,
                                            p.minzoom,
                                            p.maxzoom
                                        ]
                                    }), d)d.hasOwnProperty(f) && "layout" !== f && "paint" !== f && "filter" !== f && "metadata" !== f && "minzoom" !== f && "maxzoom" !== f && (0 === f.indexOf("paint.") ? He(d[f], p[f], o, u, f.slice(6), Ve.setPaintProperty) : t1(d[f], p[f]) || o.push({
                                        command: Ve.setLayerProperty,
                                        args: [
                                            u,
                                            f,
                                            p[f]
                                        ]
                                    }));
                                    for(f in p)p.hasOwnProperty(f) && !d.hasOwnProperty(f) && "layout" !== f && "paint" !== f && "filter" !== f && "metadata" !== f && "minzoom" !== f && "maxzoom" !== f && (0 === f.indexOf("paint.") ? He(d[f], p[f], o, u, f.slice(6), Ve.setPaintProperty) : t1(d[f], p[f]) || o.push({
                                        command: Ve.setLayerProperty,
                                        args: [
                                            u,
                                            f,
                                            p[f]
                                        ]
                                    }));
                                } else o.push({
                                    command: Ve.removeLayer,
                                    args: [
                                        u
                                    ]
                                }), m = l[l.lastIndexOf(u) + 1], o.push({
                                    command: Ve.addLayer,
                                    args: [
                                        p,
                                        m
                                    ]
                                });
                            }
                        }(a, i.layers, o);
                    } catch (e2) {
                        console.warn("Unable to compute style diff:", e2), o = [
                            {
                                command: Ve.setStyle,
                                args: [
                                    i
                                ]
                            }
                        ];
                    }
                    return o;
                })(this.serialize(), i).filter((e1)=>!(e1.command in Kt));
                if (0 === o.length) return !1;
                const r = o.filter((e1)=>!(e1.command in Yt));
                if (r.length > 0) throw new Error(`Unimplemented: ${r.map((e1)=>e1.command).join(", ")}.`);
                return o.forEach((e1)=>{
                    "setTransition" !== e1.command && "setProjection" !== e1.command && this[e1.command].apply(this, e1.args);
                }), this.stylesheet = i, this._updateMapProjection(), !0;
            }
            addImage(t1, i) {
                return this.getImage(t1) ? this.fire(new e1.ErrorEvent(new Error("An image with this name already exists."))) : (this.imageManager.addImage(t1, i), this._afterImageUpdated(t1), this);
            }
            updateImage(e1, t1) {
                this.imageManager.updateImage(e1, t1);
            }
            getImage(e1) {
                return this.imageManager.getImage(e1);
            }
            removeImage(t1) {
                return this.getImage(t1) ? (this.imageManager.removeImage(t1), this._afterImageUpdated(t1), this) : this.fire(new e1.ErrorEvent(new Error("No image with this name exists.")));
            }
            _afterImageUpdated(t1) {
                this._availableImages = this.imageManager.listImages(), this._changedImages[t1] = !0, this._changed = !0, this.dispatcher.broadcast("setImages", this._availableImages), this.fire(new e1.Event("data", {
                    dataType: "style"
                }));
            }
            listImages() {
                return this._checkLoaded(), this._availableImages.slice();
            }
            addSource(t1, i, o = {}) {
                if (this._checkLoaded(), void 0 !== this.getSource(t1)) throw new Error("There is already a source with this ID");
                if (!i.type) throw new Error(`The type property must be defined, but only the following properties were given: ${Object.keys(i).join(", ")}.`);
                if ([
                    "vector",
                    "raster",
                    "geojson",
                    "video",
                    "image"
                ].indexOf(i.type) >= 0 && this._validate(e1.validateSource, `sources.${t1}`, i, null, o)) return;
                this.map && this.map._collectResourceTiming && (i.collectResourceTiming = !0);
                const r = Pe(t1, i, this.dispatcher, this);
                r.setEventedParent(this, ()=>({
                        isSourceLoaded: this._isSourceCacheLoaded(t1),
                        source: r.serialize(),
                        sourceId: t1
                    }));
                const n = (i)=>{
                    const o = (i ? "symbol:" : "other:") + t1, n = this._sourceCaches[o] = new e1.SourceCache(o, r, i);
                    (i ? this._symbolSourceCaches : this._otherSourceCaches)[t1] = n, n.style = this, n.onAdd(this.map);
                };
                n(!1), "vector" !== i.type && "geojson" !== i.type || n(!0), r.onAdd && r.onAdd(this.map), this._changed = !0;
            }
            removeSource(t1) {
                this._checkLoaded();
                const i = this.getSource(t1);
                if (!i) throw new Error("There is no source with this ID");
                for(const i1 in this._layers)if (this._layers[i1].source === t1) return this.fire(new e1.ErrorEvent(new Error(`Source "${t1}" cannot be removed while layer "${i1}" is using it.`)));
                if (this.terrain && this.terrain.get().source === t1) return this.fire(new e1.ErrorEvent(new Error(`Source "${t1}" cannot be removed while terrain is using it.`)));
                const o = this._getSourceCaches(t1);
                for (const t2 of o)delete this._sourceCaches[t2.id], delete this._updatedSources[t2.id], t2.fire(new e1.Event("data", {
                    sourceDataType: "metadata",
                    dataType: "source",
                    sourceId: t2.getSource().id
                })), t2.setEventedParent(null), t2.clearTiles();
                return delete this._otherSourceCaches[t1], delete this._symbolSourceCaches[t1], i.setEventedParent(null), i.onRemove && i.onRemove(this.map), this._changed = !0, this;
            }
            setGeoJSONSourceData(e1, t1) {
                this._checkLoaded(), this.getSource(e1).setData(t1), this._changed = !0;
            }
            getSource(e1) {
                const t1 = this._getSourceCache(e1);
                return t1 && t1.getSource();
            }
            _getSources() {
                const e1 = [];
                for(const t1 in this._otherSourceCaches){
                    const i = this._getSourceCache(t1);
                    i && e1.push(i.getSource());
                }
                return e1;
            }
            addLayer(t1, i, o = {}) {
                this._checkLoaded();
                const r = t1.id;
                if (this.getLayer(r)) return void this.fire(new e1.ErrorEvent(new Error(`Layer with id "${r}" already exists on this map`)));
                let n;
                if ("custom" === t1.type) {
                    if (Ht(this, e1.validateCustomStyleLayer(t1))) return;
                    n = e1.createStyleLayer(t1);
                } else {
                    if ("object" == typeof t1.source && (this.addSource(r, t1.source), t1 = e1.clone$1(t1), t1 = e1.extend(t1, {
                        source: r
                    })), this._validate(e1.validateLayer, `layers.${r}`, t1, {
                        arrayIndex: -1
                    }, o)) return;
                    n = e1.createStyleLayer(t1), this._validateLayer(n), n.setEventedParent(this, {
                        layer: {
                            id: r
                        }
                    }), this._serializedLayers[n.id] = n.serialize(), this._updateLayerCount(n, !0);
                }
                const a = i ? this._order.indexOf(i) : this._order.length;
                if (i && -1 === a) return void this.fire(new e1.ErrorEvent(new Error(`Layer with id "${i}" does not exist on this map.`)));
                this._order.splice(a, 0, r), this._layerOrderChanged = !0, this._layers[r] = n;
                const s = this._getLayerSourceCache(n);
                if (this._removedLayers[r] && n.source && s && "custom" !== n.type) {
                    const e2 = this._removedLayers[r];
                    delete this._removedLayers[r], e2.type !== n.type ? this._updatedSources[n.source] = "clear" : (this._updatedSources[n.source] = "reload", s.pause());
                }
                this._updateLayer(n), n.onAdd && n.onAdd(this.map), this._updateDrapeFirstLayers();
            }
            moveLayer(t1, i) {
                if (this._checkLoaded(), this._changed = !0, !this._layers[t1]) return void this.fire(new e1.ErrorEvent(new Error(`The layer '${t1}' does not exist in the map's style and cannot be moved.`)));
                if (t1 === i) return;
                const o = this._order.indexOf(t1);
                this._order.splice(o, 1);
                const r = i ? this._order.indexOf(i) : this._order.length;
                i && -1 === r ? this.fire(new e1.ErrorEvent(new Error(`Layer with id "${i}" does not exist on this map.`))) : (this._order.splice(r, 0, t1), this._layerOrderChanged = !0, this._updateDrapeFirstLayers());
            }
            removeLayer(t1) {
                this._checkLoaded();
                const i = this._layers[t1];
                if (!i) return void this.fire(new e1.ErrorEvent(new Error(`The layer '${t1}' does not exist in the map's style and cannot be removed.`)));
                i.setEventedParent(null), this._updateLayerCount(i, !1);
                const o = this._order.indexOf(t1);
                this._order.splice(o, 1), this._layerOrderChanged = !0, this._changed = !0, this._removedLayers[t1] = i, delete this._layers[t1], delete this._serializedLayers[t1], delete this._updatedLayers[t1], delete this._updatedPaintProps[t1], i.onRemove && i.onRemove(this.map), this._updateDrapeFirstLayers();
            }
            getLayer(e1) {
                return this._layers[e1];
            }
            hasLayer(e1) {
                return e1 in this._layers;
            }
            hasLayerType(e1) {
                for(const t1 in this._layers)if (this._layers[t1].type === e1) return !0;
                return !1;
            }
            setLayerZoomRange(t1, i, o) {
                this._checkLoaded();
                const r = this.getLayer(t1);
                r ? r.minzoom === i && r.maxzoom === o || (null != i && (r.minzoom = i), null != o && (r.maxzoom = o), this._updateLayer(r)) : this.fire(new e1.ErrorEvent(new Error(`The layer '${t1}' does not exist in the map's style and cannot have zoom extent.`)));
            }
            setFilter(i, o, r = {}) {
                this._checkLoaded();
                const n = this.getLayer(i);
                if (n) {
                    if (!t1(n.filter, o)) return null == o ? (n.filter = void 0, void this._updateLayer(n)) : void (this._validate(e1.validateFilter, `layers.${n.id}.filter`, o, {
                        layerType: n.type
                    }, r) || (n.filter = e1.clone$1(o), this._updateLayer(n)));
                } else this.fire(new e1.ErrorEvent(new Error(`The layer '${i}' does not exist in the map's style and cannot be filtered.`)));
            }
            getFilter(t1) {
                const i = this.getLayer(t1);
                return i && e1.clone$1(i.filter);
            }
            setLayoutProperty(i, o, r, n = {}) {
                this._checkLoaded();
                const a = this.getLayer(i);
                a ? t1(a.getLayoutProperty(o), r) || (a.setLayoutProperty(o, r, n), this._updateLayer(a)) : this.fire(new e1.ErrorEvent(new Error(`The layer '${i}' does not exist in the map's style and cannot be styled.`)));
            }
            getLayoutProperty(t1, i) {
                const o = this.getLayer(t1);
                if (o) return o.getLayoutProperty(i);
                this.fire(new e1.ErrorEvent(new Error(`The layer '${t1}' does not exist in the map's style.`)));
            }
            setPaintProperty(i, o, r, n = {}) {
                this._checkLoaded();
                const a = this.getLayer(i);
                a ? t1(a.getPaintProperty(o), r) || (a.setPaintProperty(o, r, n) && this._updateLayer(a), this._changed = !0, this._updatedPaintProps[i] = !0) : this.fire(new e1.ErrorEvent(new Error(`The layer '${i}' does not exist in the map's style and cannot be styled.`)));
            }
            getPaintProperty(e1, t1) {
                const i = this.getLayer(e1);
                return i && i.getPaintProperty(t1);
            }
            setFeatureState(t1, i) {
                this._checkLoaded();
                const o = t1.source, r = t1.sourceLayer, n = this.getSource(o);
                if (!n) return void this.fire(new e1.ErrorEvent(new Error(`The source '${o}' does not exist in the map's style.`)));
                const a = n.type;
                if ("geojson" === a && r) return void this.fire(new e1.ErrorEvent(new Error("GeoJSON sources cannot have a sourceLayer parameter.")));
                if ("vector" === a && !r) return void this.fire(new e1.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
                void 0 === t1.id && this.fire(new e1.ErrorEvent(new Error("The feature id parameter must be provided.")));
                const s = this._getSourceCaches(o);
                for (const e2 of s)e2.setFeatureState(r, t1.id, i);
            }
            removeFeatureState(t1, i) {
                this._checkLoaded();
                const o = t1.source, r = this.getSource(o);
                if (!r) return void this.fire(new e1.ErrorEvent(new Error(`The source '${o}' does not exist in the map's style.`)));
                const n = r.type, a = "vector" === n ? t1.sourceLayer : void 0;
                if ("vector" === n && !a) return void this.fire(new e1.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
                if (i && "string" != typeof t1.id && "number" != typeof t1.id) return void this.fire(new e1.ErrorEvent(new Error("A feature id is required to remove its specific state property.")));
                const s = this._getSourceCaches(o);
                for (const e2 of s)e2.removeFeatureState(a, t1.id, i);
            }
            getFeatureState(t1) {
                this._checkLoaded();
                const i = t1.source, o = t1.sourceLayer, r = this.getSource(i);
                if (r) {
                    if ("vector" !== r.type || o) return void 0 === t1.id && this.fire(new e1.ErrorEvent(new Error("The feature id parameter must be provided."))), this._getSourceCaches(i)[0].getFeatureState(o, t1.id);
                    this.fire(new e1.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
                } else this.fire(new e1.ErrorEvent(new Error(`The source '${i}' does not exist in the map's style.`)));
            }
            getTransition() {
                return e1.extend({
                    duration: 300,
                    delay: 0
                }, this.stylesheet && this.stylesheet.transition);
            }
            serialize() {
                const t1 = {};
                for(const e2 in this._sourceCaches){
                    const i = this._sourceCaches[e2].getSource();
                    t1[i.id] || (t1[i.id] = i.serialize());
                }
                return e1.filterObject({
                    version: this.stylesheet.version,
                    name: this.stylesheet.name,
                    metadata: this.stylesheet.metadata,
                    light: this.stylesheet.light,
                    terrain: this.getTerrain() || void 0,
                    fog: this.stylesheet.fog,
                    center: this.stylesheet.center,
                    zoom: this.stylesheet.zoom,
                    bearing: this.stylesheet.bearing,
                    pitch: this.stylesheet.pitch,
                    sprite: this.stylesheet.sprite,
                    glyphs: this.stylesheet.glyphs,
                    transition: this.stylesheet.transition,
                    projection: this.stylesheet.projection,
                    sources: t1,
                    layers: this._serializeLayers(this._order)
                }, (e1)=>void 0 !== e1);
            }
            _updateLayer(e1) {
                this._updatedLayers[e1.id] = !0;
                const t1 = this._getLayerSourceCache(e1);
                e1.source && !this._updatedSources[e1.source] && t1 && "raster" !== t1.getSource().type && (this._updatedSources[e1.source] = "reload", t1.pause()), this._changed = !0, e1.invalidateCompiledFilter();
            }
            _flattenAndSortRenderedFeatures(e1) {
                const t1 = (e1)=>"fill-extrusion" === this._layers[e1].type, i = {}, o = [];
                for(let r = this._order.length - 1; r >= 0; r--){
                    const n = this._order[r];
                    if (t1(n)) {
                        i[n] = r;
                        for (const t2 of e1){
                            const e2 = t2[n];
                            if (e2) for (const t3 of e2)o.push(t3);
                        }
                    }
                }
                o.sort((e1, t1)=>t1.intersectionZ - e1.intersectionZ);
                const r1 = [];
                for(let n1 = this._order.length - 1; n1 >= 0; n1--){
                    const a = this._order[n1];
                    if (t1(a)) for(let e3 = o.length - 1; e3 >= 0; e3--){
                        const t4 = o[e3].feature;
                        if (i[t4.layer.id] < n1) break;
                        r1.push(t4), o.pop();
                    }
                    else for (const t5 of e1){
                        const e4 = t5[a];
                        if (e4) for (const t6 of e4)r1.push(t6.feature);
                    }
                }
                return r1;
            }
            queryRenderedFeatures(t1, i, o) {
                i && i.filter && this._validate(e1.validateFilter, "queryRenderedFeatures.filter", i.filter, null, i);
                const r = {};
                if (i && i.layers) {
                    if (!Array.isArray(i.layers)) return this.fire(new e1.ErrorEvent(new Error("parameters.layers must be an Array."))), [];
                    for (const t2 of i.layers){
                        const i1 = this._layers[t2];
                        if (!i1) return this.fire(new e1.ErrorEvent(new Error(`The layer '${t2}' does not exist in the map's style and cannot be queried for features.`))), [];
                        r[i1.source] = !0;
                    }
                }
                const n = [];
                i.availableImages = this._availableImages;
                const a = i && i.layers ? i.layers.some((e1)=>{
                    const t1 = this.getLayer(e1);
                    return t1 && t1.is3D();
                }) : this.has3DLayers(), s = R.createFromScreenPoints(t1, o);
                for(const e2 in this._sourceCaches){
                    const t3 = this._sourceCaches[e2].getSource().id;
                    i.layers && !r[t3] || n.push(Re(this._sourceCaches[e2], this._layers, this._serializedLayers, s, i, o, a, !!this.map._showQueryGeometry));
                }
                return this.placement && n.push(function(e1, t1, i, o, r, n, a) {
                    const s = {}, l = n.queryRenderedSymbols(o), c = [];
                    for (const e2 of Object.keys(l).map(Number))c.push(a[e2]);
                    c.sort(Be);
                    for (const i1 of c){
                        const o1 = i1.featureIndex.lookupSymbolFeatures(l[i1.bucketInstanceId], t1, i1.bucketIndex, i1.sourceLayerIndex, r.filter, r.layers, r.availableImages, e1);
                        for(const e3 in o1){
                            const t2 = s[e3] = s[e3] || [], r1 = o1[e3];
                            r1.sort((e1, t1)=>{
                                const o = i1.featureSortOrder;
                                if (o) {
                                    const i = o.indexOf(e1.featureIndex);
                                    return o.indexOf(t1.featureIndex) - i;
                                }
                                return t1.featureIndex - e1.featureIndex;
                            });
                            for (const e4 of r1)t2.push(e4);
                        }
                    }
                    for(const t3 in s)s[t3].forEach((o)=>{
                        const r = o.feature, n = i(e1[t3]).getFeatureState(r.layer["source-layer"], r.id);
                        r.source = r.layer.source, r.layer["source-layer"] && (r.sourceLayer = r.layer["source-layer"]), r.state = n;
                    });
                    return s;
                }(this._layers, this._serializedLayers, this._getLayerSourceCache.bind(this), s.screenGeometry, i, this.placement.collisionIndex, this.placement.retainedQueryData)), this._flattenAndSortRenderedFeatures(n);
            }
            querySourceFeatures(t1, i) {
                i && i.filter && this._validate(e1.validateFilter, "querySourceFeatures.filter", i.filter, null, i);
                const o = this._getSourceCaches(t1);
                let r = [];
                for (const e2 of o)r = r.concat(Oe(e2, i));
                return r;
            }
            addSourceType(e1, t1, i) {
                return ei.getSourceType(e1) ? i(new Error(`A source type called "${e1}" already exists.`)) : (ei.setSourceType(e1, t1), t1.workerSourceURL ? void this.dispatcher.broadcast("loadWorkerSource", {
                    name: e1,
                    url: t1.workerSourceURL
                }, i) : i(null, null));
            }
            getLight() {
                return this.light.getLight();
            }
            setLight(e1, i = {}) {
                this._checkLoaded();
                const o = this.light.getLight();
                let r = !1;
                for(const i1 in e1)if (!t1(e1[i1], o[i1])) {
                    r = !0;
                    break;
                }
                if (!r) return;
                const n = this._setTransitionParameters({
                    duration: 300,
                    delay: 0
                });
                this.light.setLight(e1, i), this.light.updateTransitions(n);
            }
            getTerrain() {
                return this.terrain && 1 === this.terrain.drapeRenderMode ? this.terrain.get() : null;
            }
            setTerrainForDraping() {
                this.setTerrain({
                    source: "",
                    exaggeration: 0
                }, 0);
            }
            setTerrain(i, o = 1) {
                if (this._checkLoaded(), !i) return delete this.terrain, delete this.stylesheet.terrain, this.dispatcher.broadcast("enableTerrain", !1), this._force3DLayerUpdate(), void (this._markersNeedUpdate = !0);
                if (1 === o) {
                    if ("object" == typeof i.source) {
                        const t2 = "terrain-dem-src";
                        this.addSource(t2, i.source), i = e1.clone$1(i), i = e1.extend(i, {
                            source: t2
                        });
                    }
                    if (this._validate(e1.validateTerrain, "terrain", i)) return;
                }
                if (!this.terrain || this.terrain && o !== this.terrain.drapeRenderMode) this._createTerrain(i, o);
                else {
                    const o1 = this.terrain, r = o1.get();
                    for (const t3 of Object.keys(e1.spec.terrain))!i.hasOwnProperty(t3) && e1.spec.terrain[t3].default && (i[t3] = e1.spec.terrain[t3].default);
                    for(const e2 in i)if (!t1(i[e2], r[e2])) {
                        o1.set(i), this.stylesheet.terrain = i;
                        const e3 = this._setTransitionParameters({
                            duration: 0
                        });
                        o1.updateTransitions(e3);
                        break;
                    }
                }
                this._updateDrapeFirstLayers(), this._markersNeedUpdate = !0;
            }
            _createFog(e1) {
                const t1 = this.fog = new A(e1, this.map.transform);
                this.stylesheet.fog = e1;
                const i = this._setTransitionParameters({
                    duration: 0
                });
                t1.updateTransitions(i);
            }
            _updateMarkersOpacity() {
                0 !== this.map._markers.length && this.map._requestDomTask(()=>{
                    for (const e1 of this.map._markers)e1._evaluateOpacity();
                });
            }
            getFog() {
                return this.fog ? this.fog.get() : null;
            }
            setFog(e1) {
                if (this._checkLoaded(), !e1) return delete this.fog, delete this.stylesheet.fog, void (this._markersNeedUpdate = !0);
                if (this.fog) {
                    const i = this.fog, o = i.get();
                    0 === Object.keys(e1).length && i.set(e1);
                    for(const r in e1)if (!t1(e1[r], o[r])) {
                        i.set(e1), this.stylesheet.fog = e1;
                        const t2 = this._setTransitionParameters({
                            duration: 0
                        });
                        i.updateTransitions(t2);
                        break;
                    }
                } else this._createFog(e1);
                this._markersNeedUpdate = !0;
            }
            _setTransitionParameters(t1) {
                return {
                    now: e1.exported.now(),
                    transition: e1.extend(t1, this.stylesheet.transition)
                };
            }
            _updateDrapeFirstLayers() {
                if (!this.map._optimizeForTerrain || !this.terrain) return;
                const e1 = this._order.filter((e1)=>this.isLayerDraped(this._layers[e1])), t1 = this._order.filter((e1)=>!this.isLayerDraped(this._layers[e1]));
                this._drapedFirstOrder = [], this._drapedFirstOrder.push(...e1), this._drapedFirstOrder.push(...t1);
            }
            _createTerrain(e1, t1) {
                const i = this.terrain = new I(e1, t1);
                this.stylesheet.terrain = e1, this.dispatcher.broadcast("enableTerrain", !this.terrainSetForDrapingOnly()), this._force3DLayerUpdate();
                const o = this._setTransitionParameters({
                    duration: 0
                });
                i.updateTransitions(o);
            }
            _force3DLayerUpdate() {
                for(const e1 in this._layers){
                    const t1 = this._layers[e1];
                    "fill-extrusion" === t1.type && this._updateLayer(t1);
                }
            }
            _forceSymbolLayerUpdate() {
                for(const e1 in this._layers){
                    const t1 = this._layers[e1];
                    "symbol" === t1.type && this._updateLayer(t1);
                }
            }
            _validate(t1, i, o, r, n = {}) {
                return (!n || !1 !== n.validate) && Ht(this, t1.call(e1.validateStyle, e1.extend({
                    key: i,
                    style: this.serialize(),
                    value: o,
                    styleSpec: e1.spec
                }, r)));
            }
            _remove() {
                this._request && (this._request.cancel(), this._request = null), this._spriteRequest && (this._spriteRequest.cancel(), this._spriteRequest = null), e1.evented.off("pluginStateChange", this._rtlTextPluginCallback);
                for(const e2 in this._layers)this._layers[e2].setEventedParent(null);
                for(const e3 in this._sourceCaches)this._sourceCaches[e3].clearTiles(), this._sourceCaches[e3].setEventedParent(null);
                this.imageManager.setEventedParent(null), this.setEventedParent(null), this.dispatcher.remove();
            }
            _clearSource(e1) {
                const t1 = this._getSourceCaches(e1);
                for (const e2 of t1)e2.clearTiles();
            }
            _reloadSource(e1) {
                const t1 = this._getSourceCaches(e1);
                for (const e2 of t1)e2.resume(), e2.reload();
            }
            _reloadSources() {
                for (const e1 of this._getSources())e1.reload && e1.reload();
            }
            _updateSources(e1) {
                for(const t1 in this._sourceCaches)this._sourceCaches[t1].update(e1);
            }
            _generateCollisionBoxes() {
                for(const e1 in this._sourceCaches){
                    const t1 = this._sourceCaches[e1];
                    t1.resume(), t1.reload();
                }
            }
            _updatePlacement(t1, i, o, r, n = !1) {
                let a = !1, s = !1;
                const l = {};
                for (const e2 of this._order){
                    const i1 = this._layers[e2];
                    if ("symbol" !== i1.type) continue;
                    if (!l[i1.source]) {
                        const e3 = this._getLayerSourceCache(i1);
                        if (!e3) continue;
                        l[i1.source] = e3.getRenderableIds(!0).map((t1)=>e3.getTileByID(t1)).sort((e1, t1)=>t1.tileID.overscaledZ - e1.tileID.overscaledZ || (e1.tileID.isLessThan(t1.tileID) ? -1 : 1));
                    }
                    const o1 = this.crossTileSymbolIndex.addLayer(i1, l[i1.source], t1.center.lng, t1.projection);
                    a = a || o1;
                }
                if (this.crossTileSymbolIndex.pruneUnusedLayers(this._order), n = n || this._layerOrderChanged || 0 === o, this._layerOrderChanged && this.fire(new e1.Event("neworder")), (n || !this.pauseablePlacement || this.pauseablePlacement.isDone() && !this.placement.stillRecent(e1.exported.now(), t1.zoom)) && (this.pauseablePlacement = new Zt(t1, this._order, n, i, o, r, this.placement, this.fog && t1.projection.supportsFog ? this.fog.state : null), this._layerOrderChanged = !1), this.pauseablePlacement.isDone() ? this.placement.setStale() : (this.pauseablePlacement.continuePlacement(this._order, this._layers, l), this.pauseablePlacement.isDone() && (this.placement = this.pauseablePlacement.commit(e1.exported.now()), s = !0), a && this.pauseablePlacement.placement.setStale()), s || a) for (const e4 of this._order){
                    const t2 = this._layers[e4];
                    "symbol" === t2.type && this.placement.updateLayerOpacities(t2, l[t2.source]);
                }
                return !this.pauseablePlacement.isDone() || this.placement.hasTransitions(e1.exported.now());
            }
            _releaseSymbolFadeTiles() {
                for(const e1 in this._sourceCaches)this._sourceCaches[e1].releaseSymbolFadeTiles();
            }
            getImages(e1, t1, i) {
                this.imageManager.getImages(t1.icons, i), this._updateTilesForChangedImages();
                const o = (e1)=>{
                    e1 && e1.setDependencies(t1.tileID.key, t1.type, t1.icons);
                };
                o(this._otherSourceCaches[t1.source]), o(this._symbolSourceCaches[t1.source]);
            }
            getGlyphs(e1, t1, i) {
                this.glyphManager.getGlyphs(t1.stacks, i);
            }
            getResource(t1, i, o) {
                return e1.makeRequest(i, o);
            }
            _getSourceCache(e1) {
                return this._otherSourceCaches[e1];
            }
            _getLayerSourceCache(e1) {
                return "symbol" === e1.type ? this._symbolSourceCaches[e1.source] : this._otherSourceCaches[e1.source];
            }
            _getSourceCaches(e1) {
                const t1 = [];
                return this._otherSourceCaches[e1] && t1.push(this._otherSourceCaches[e1]), this._symbolSourceCaches[e1] && t1.push(this._symbolSourceCaches[e1]), t1;
            }
            _isSourceCacheLoaded(t1) {
                const i = this._getSourceCaches(t1);
                return 0 === i.length ? (this.fire(new e1.ErrorEvent(new Error(`There is no source with ID '${t1}'`))), !1) : i.every((e1)=>e1.loaded());
            }
            has3DLayers() {
                return this._num3DLayers > 0;
            }
            hasSymbolLayers() {
                return this._numSymbolLayers > 0;
            }
            hasCircleLayers() {
                return this._numCircleLayers > 0;
            }
            _clearWorkerCaches() {
                this.dispatcher.broadcast("clearCaches");
            }
            destroy() {
                this._clearWorkerCaches(), this.terrainSetForDrapingOnly() && (delete this.terrain, delete this.stylesheet.terrain);
            }
        }
        ei.getSourceType = function(e1) {
            return Ae[e1];
        }, ei.setSourceType = function(e1, t1) {
            Ae[e1] = t1;
        }, ei.registerForPluginStateChange = e1.registerForPluginStateChange;
        var ti = "\n#define EPSILON 0.0000001\n#define PI 3.141592653589793\n#define EXTENT 8192.0\n#define HALF_PI PI/2.0\n#define QUARTER_PI PI/4.0\n#define RAD_TO_DEG 180.0/PI\n#define DEG_TO_RAD PI/180.0\n#define GLOBE_RADIUS EXTENT/PI/2.0", ii = "attribute highp vec3 a_pos_3f;uniform lowp mat4 u_matrix;varying highp vec3 v_uv;void main() {const mat3 half_neg_pi_around_x=mat3(1.0,0.0, 0.0,0.0,0.0,-1.0,0.0,1.0, 0.0);v_uv=half_neg_pi_around_x*a_pos_3f;vec4 pos=u_matrix*vec4(a_pos_3f,1.0);gl_Position=pos.xyww;}", oi = "\n#define ELEVATION_SCALE 7.0\n#define ELEVATION_OFFSET 450.0\n#ifdef PROJECTION_GLOBE_VIEW\nuniform vec3 u_tile_tl_up;uniform vec3 u_tile_tr_up;uniform vec3 u_tile_br_up;uniform vec3 u_tile_bl_up;uniform float u_tile_up_scale;vec3 elevationVector(vec2 pos) {vec2 uv=pos/EXTENT;vec3 up=normalize(mix(\nmix(u_tile_tl_up,u_tile_tr_up,uv.xxx),mix(u_tile_bl_up,u_tile_br_up,uv.xxx),uv.yyy));return up*u_tile_up_scale;}\n#else\nvec3 elevationVector(vec2 pos) { return vec3(0,0,1); }\n#endif\n#ifdef TERRAIN\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nuniform highp sampler2D u_dem;uniform highp sampler2D u_dem_prev;\n#else\nuniform sampler2D u_dem;uniform sampler2D u_dem_prev;\n#endif\nuniform vec4 u_dem_unpack;uniform vec2 u_dem_tl;uniform vec2 u_dem_tl_prev;uniform float u_dem_scale;uniform float u_dem_scale_prev;uniform float u_dem_size;uniform float u_dem_lerp;uniform float u_exaggeration;uniform float u_meter_to_dem;uniform mat4 u_label_plane_matrix_inv;uniform sampler2D u_depth;uniform vec2 u_depth_size_inv;vec4 tileUvToDemSample(vec2 uv,float dem_size,float dem_scale,vec2 dem_tl) {vec2 pos=dem_size*(uv*dem_scale+dem_tl)+1.0;vec2 f=fract(pos);return vec4((pos-f+0.5)/(dem_size+2.0),f);}float decodeElevation(vec4 v) {return dot(vec4(v.xyz*255.0,-1.0),u_dem_unpack);}float currentElevation(vec2 apos) {\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nvec2 pos=(u_dem_size*(apos/8192.0*u_dem_scale+u_dem_tl)+1.5)/(u_dem_size+2.0);return u_exaggeration*texture2D(u_dem,pos).a;\n#else\nfloat dd=1.0/(u_dem_size+2.0);vec4 r=tileUvToDemSample(apos/8192.0,u_dem_size,u_dem_scale,u_dem_tl);vec2 pos=r.xy;vec2 f=r.zw;float tl=decodeElevation(texture2D(u_dem,pos));\n#ifdef TERRAIN_DEM_NEAREST_FILTER\nreturn u_exaggeration*tl;\n#endif\nfloat tr=decodeElevation(texture2D(u_dem,pos+vec2(dd,0.0)));float bl=decodeElevation(texture2D(u_dem,pos+vec2(0.0,dd)));float br=decodeElevation(texture2D(u_dem,pos+vec2(dd,dd)));return u_exaggeration*mix(mix(tl,tr,f.x),mix(bl,br,f.x),f.y);\n#endif\n}float prevElevation(vec2 apos) {\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nvec2 pos=(u_dem_size*(apos/8192.0*u_dem_scale_prev+u_dem_tl_prev)+1.5)/(u_dem_size+2.0);return u_exaggeration*texture2D(u_dem_prev,pos).a;\n#else\nfloat dd=1.0/(u_dem_size+2.0);vec4 r=tileUvToDemSample(apos/8192.0,u_dem_size,u_dem_scale_prev,u_dem_tl_prev);vec2 pos=r.xy;vec2 f=r.zw;float tl=decodeElevation(texture2D(u_dem_prev,pos));float tr=decodeElevation(texture2D(u_dem_prev,pos+vec2(dd,0.0)));float bl=decodeElevation(texture2D(u_dem_prev,pos+vec2(0.0,dd)));float br=decodeElevation(texture2D(u_dem_prev,pos+vec2(dd,dd)));return u_exaggeration*mix(mix(tl,tr,f.x),mix(bl,br,f.x),f.y);\n#endif\n}\n#ifdef TERRAIN_VERTEX_MORPHING\nfloat elevation(vec2 apos) {float nextElevation=currentElevation(apos);float prevElevation=prevElevation(apos);return mix(prevElevation,nextElevation,u_dem_lerp);}\n#else\nfloat elevation(vec2 apos) {return currentElevation(apos);}\n#endif\nhighp float unpack_depth(highp vec4 rgba_depth)\n{const highp vec4 bit_shift=vec4(1.0/(255.0*255.0*255.0),1.0/(255.0*255.0),1.0/255.0,1.0);return dot(rgba_depth,bit_shift)*2.0-1.0;}bool isOccluded(vec4 frag) {vec3 coord=frag.xyz/frag.w;float depth=unpack_depth(texture2D(u_depth,(coord.xy+1.0)*0.5));return coord.z > depth+0.0005;}float occlusionFade(vec4 frag) {vec3 coord=frag.xyz/frag.w;vec3 df=vec3(5.0*u_depth_size_inv,0.0);vec2 uv=0.5*coord.xy+0.5;vec4 depth=vec4(\nunpack_depth(texture2D(u_depth,uv-df.xz)),unpack_depth(texture2D(u_depth,uv+df.xz)),unpack_depth(texture2D(u_depth,uv-df.zy)),unpack_depth(texture2D(u_depth,uv+df.zy))\n);return dot(vec4(0.25),vec4(1.0)-clamp(300.0*(vec4(coord.z-0.001)-depth),0.0,1.0));}vec4 fourSample(vec2 pos,vec2 off) {\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nfloat tl=texture2D(u_dem,pos).a;float tr=texture2D(u_dem,pos+vec2(off.x,0.0)).a;float bl=texture2D(u_dem,pos+vec2(0.0,off.y)).a;float br=texture2D(u_dem,pos+off).a;\n#else\nvec4 demtl=vec4(texture2D(u_dem,pos).xyz*255.0,-1.0);float tl=dot(demtl,u_dem_unpack);vec4 demtr=vec4(texture2D(u_dem,pos+vec2(off.x,0.0)).xyz*255.0,-1.0);float tr=dot(demtr,u_dem_unpack);vec4 dembl=vec4(texture2D(u_dem,pos+vec2(0.0,off.y)).xyz*255.0,-1.0);float bl=dot(dembl,u_dem_unpack);vec4 dembr=vec4(texture2D(u_dem,pos+off).xyz*255.0,-1.0);float br=dot(dembr,u_dem_unpack);\n#endif\nreturn vec4(tl,tr,bl,br);}float flatElevation(vec2 pack) {vec2 apos=floor(pack/8.0);vec2 span=10.0*(pack-apos*8.0);vec2 uvTex=(apos-vec2(1.0,1.0))/8190.0;float size=u_dem_size+2.0;float dd=1.0/size;vec2 pos=u_dem_size*(uvTex*u_dem_scale+u_dem_tl)+1.0;vec2 f=fract(pos);pos=(pos-f+0.5)*dd;vec4 h=fourSample(pos,vec2(dd));float z=mix(mix(h.x,h.y,f.x),mix(h.z,h.w,f.x),f.y);vec2 w=floor(0.5*(span*u_meter_to_dem-1.0));vec2 d=dd*w;vec4 bounds=vec4(d,vec2(1.0)-d);h=fourSample(pos-d,2.0*d+vec2(dd));vec4 diff=abs(h.xzxy-h.ywzw);vec2 slope=min(vec2(0.25),u_meter_to_dem*0.5*(diff.xz+diff.yw)/(2.0*w+vec2(1.0)));vec2 fix=slope*span;float base=z+max(fix.x,fix.y);return u_exaggeration*base;}float elevationFromUint16(float word) {return u_exaggeration*(word/ELEVATION_SCALE-ELEVATION_OFFSET);}\n#else\nfloat elevation(vec2 pos) { return 0.0; }bool isOccluded(vec4 frag) { return false; }float occlusionFade(vec4 frag) { return 1.0; }\n#endif", ri = "#ifdef FOG\nuniform mediump vec4 u_fog_color;uniform mediump vec2 u_fog_range;uniform mediump float u_fog_horizon_blend;uniform mediump mat4 u_fog_matrix;varying vec3 v_fog_pos;float fog_range(float depth) {return (depth-u_fog_range[0])/(u_fog_range[1]-u_fog_range[0]);}float fog_horizon_blending(vec3 camera_dir) {float t=max(0.0,camera_dir.z/u_fog_horizon_blend);return u_fog_color.a*exp(-3.0*t*t);}float fog_opacity(float t) {const float decay=6.0;float falloff=1.0-min(1.0,exp(-decay*t));falloff*=falloff*falloff;return u_fog_color.a*min(1.0,1.00747*falloff);}vec3 fog_position(vec3 pos) {return (u_fog_matrix*vec4(pos,1.0)).xyz;}vec3 fog_position(vec2 pos) {return fog_position(vec3(pos,0.0));}float fog(vec3 pos) {float depth=length(pos);float opacity=fog_opacity(fog_range(depth));return opacity*fog_horizon_blending(pos/depth);}\n#endif", ni = "#ifdef FOG\nuniform mediump vec4 u_fog_color;uniform mediump vec2 u_fog_range;uniform mediump float u_fog_horizon_blend;uniform mediump float u_fog_temporal_offset;varying vec3 v_fog_pos;uniform highp vec3 u_frustum_tl;uniform highp vec3 u_frustum_tr;uniform highp vec3 u_frustum_br;uniform highp vec3 u_frustum_bl;uniform highp vec3 u_globe_pos;uniform highp float u_globe_radius;uniform highp vec2 u_viewport;uniform float u_globe_transition;uniform int u_is_globe;float fog_range(float depth) {return (depth-u_fog_range[0])/(u_fog_range[1]-u_fog_range[0]);}float fog_horizon_blending(vec3 camera_dir) {float t=max(0.0,camera_dir.z/u_fog_horizon_blend);return u_fog_color.a*exp(-3.0*t*t);}float fog_opacity(float t) {const float decay=6.0;float falloff=1.0-min(1.0,exp(-decay*t));falloff*=falloff*falloff;return u_fog_color.a*min(1.0,1.00747*falloff);}float globe_glow_progress() {highp vec2 uv=gl_FragCoord.xy/u_viewport;highp vec3 ray_dir=mix(\nmix(u_frustum_tl,u_frustum_tr,uv.x),mix(u_frustum_bl,u_frustum_br,uv.x),1.0-uv.y);highp vec3 dir=normalize(ray_dir);highp vec3 closest_point=dot(u_globe_pos,dir)*dir;highp float sdf=length(closest_point-u_globe_pos)/u_globe_radius;return sdf+PI*0.5;}float fog_opacity(vec3 pos) {float depth=length(pos);return fog_opacity(fog_range(depth));}vec3 fog_apply(vec3 color,vec3 pos) {float depth=length(pos);float opacity;if (u_is_globe==1) {float glow_progress=globe_glow_progress();float t=mix(glow_progress,depth,u_globe_transition);opacity=fog_opacity(fog_range(t));} else {opacity=fog_opacity(fog_range(depth));opacity*=fog_horizon_blending(pos/depth);}return mix(color,u_fog_color.rgb,opacity);}vec4 fog_apply_from_vert(vec4 color,float fog_opac) {float alpha=EPSILON+color.a;color.rgb=mix(color.rgb/alpha,u_fog_color.rgb,fog_opac)*alpha;return color;}vec3 fog_apply_sky_gradient(vec3 camera_ray,vec3 sky_color) {float horizon_blend=fog_horizon_blending(normalize(camera_ray));return mix(sky_color,u_fog_color.rgb,horizon_blend);}vec4 fog_apply_premultiplied(vec4 color,vec3 pos) {float alpha=EPSILON+color.a;color.rgb=fog_apply(color.rgb/alpha,pos)*alpha;return color;}vec3 fog_dither(vec3 color) {vec2 dither_seed=gl_FragCoord.xy+u_fog_temporal_offset;return dither(color,dither_seed);}vec4 fog_dither(vec4 color) {return vec4(fog_dither(color.rgb),color.a);}\n#endif";
        let ai = {}, si = {};
        const li = [];
        di(ti, li), di(oi, li), di(ri, li), di(ni, li), ai = pi("", oi), si = pi(ni, ri);
        const ci = pi("\nhighp vec3 hash(highp vec2 p) {highp vec3 p3=fract(p.xyx*vec3(443.8975,397.2973,491.1871));p3+=dot(p3,p3.yxz+19.19);return fract((p3.xxy+p3.yzz)*p3.zyx);}vec3 dither(vec3 color,highp vec2 seed) {vec3 rnd=hash(seed)+hash(seed+0.59374)-0.5;return color+rnd/255.0;}highp float unpack_depth(highp vec4 rgba_depth)\n{const highp vec4 bit_shift=vec4(1.0/(255.0*255.0*255.0),1.0/(255.0*255.0),1.0/255.0,1.0);return dot(rgba_depth,bit_shift)*2.0-1.0;}highp vec4 pack_depth(highp float ndc_z) {highp float depth=ndc_z*0.5+0.5;const highp vec4 bit_shift=vec4(255.0*255.0*255.0,255.0*255.0,255.0,1.0);const highp vec4 bit_mask =vec4(0.0,1.0/255.0,1.0/255.0,1.0/255.0);highp vec4 res=fract(depth*bit_shift);res-=res.xxyz*bit_mask;return res;}", "\nfloat wrap(float n,float min,float max) {float d=max-min;float w=mod(mod(n-min,d)+d,d)+min;return (w==min) ? max : w;}\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 mercator_tile_position(mat4 matrix,vec2 tile_anchor,vec3 tile_id,vec2 mercator_center) {\n#ifndef PROJECTED_POS_ON_VIEWPORT\nfloat tiles=tile_id.z;vec2 mercator=(tile_anchor/EXTENT+tile_id.xy)/tiles;mercator-=mercator_center;mercator.x=wrap(mercator.x,-0.5,0.5);vec4 mercator_tile=vec4(mercator.xy*EXTENT,EXTENT/(2.0*PI),1.0);mercator_tile=matrix*mercator_tile;return mercator_tile.xyz;\n#else\nreturn vec3(0.0);\n#endif\n}vec3 mix_globe_mercator(vec3 globe,vec3 mercator,float t) {return mix(globe,mercator,t);}mat3 globe_mercator_surface_vectors(vec3 pos_normal,vec3 up_dir,float zoom_transition) {vec3 normal=zoom_transition==0.0 ? pos_normal : normalize(mix(pos_normal,up_dir,zoom_transition));vec3 xAxis=normalize(vec3(normal.z,0.0,-normal.x));vec3 yAxis=normalize(cross(normal,xAxis));return mat3(xAxis,yAxis,normal);}\n#endif\nvec2 unpack_float(const float packedValue) {int packedIntValue=int(packedValue);int v0=packedIntValue/256;return vec2(v0,packedIntValue-v0*256);}vec2 unpack_opacity(const float packedOpacity) {int intOpacity=int(packedOpacity)/2;return vec2(float(intOpacity)/127.0,mod(packedOpacity,2.0));}vec4 decode_color(const vec2 encodedColor) {return vec4(\nunpack_float(encodedColor[0])/255.0,unpack_float(encodedColor[1])/255.0\n);}float unpack_mix_vec2(const vec2 packedValue,const float t) {return mix(packedValue[0],packedValue[1],t);}vec4 unpack_mix_color(const vec4 packedColors,const float t) {vec4 minColor=decode_color(vec2(packedColors[0],packedColors[1]));vec4 maxColor=decode_color(vec2(packedColors[2],packedColors[3]));return mix(minColor,maxColor,t);}vec2 get_pattern_pos(const vec2 pixel_coord_upper,const vec2 pixel_coord_lower,const vec2 pattern_size,const float tile_units_to_pixels,const vec2 pos) {vec2 offset=mod(mod(mod(pixel_coord_upper,pattern_size)*256.0,pattern_size)*256.0+pixel_coord_lower,pattern_size);return (tile_units_to_pixels*pos+offset)/pattern_size;}const vec4 AWAY=vec4(-1000.0,-1000.0,-1000.0,1);//Normalized device coordinate that is not rendered."), hi = ti, _i = "\n#ifdef GL_ES\nprecision mediump float;\n#else\n\n#if !defined(lowp)\n#define lowp\n#endif\n\n#if !defined(mediump)\n#define mediump\n#endif\n\n#if !defined(highp)\n#define highp\n#endif\n\n#endif";
        var ui = {
            background: pi("uniform vec4 u_color;uniform float u_opacity;void main() {vec4 out_color=u_color;\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),
            backgroundPattern: pi("uniform vec2 u_pattern_tl_a;uniform vec2 u_pattern_br_a;uniform vec2 u_pattern_tl_b;uniform vec2 u_pattern_br_b;uniform vec2 u_texsize;uniform float u_mix;uniform float u_opacity;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(u_pattern_tl_a/u_texsize,u_pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(u_pattern_tl_b/u_texsize,u_pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);vec4 out_color=mix(color1,color2,u_mix);\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pattern_size_a;uniform vec2 u_pattern_size_b;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_scale_a;uniform float u_scale_b;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_a*u_pattern_size_a,u_tile_units_to_pixels,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_b*u_pattern_size_b,u_tile_units_to_pixels,a_pos);\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),
            circle: pi("varying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=v_data.xy;float extrude_length=length(extrude);lowp float antialiasblur=v_data.z;float antialiased_blur=-max(blur,antialiasblur);float opacity_t=smoothstep(0.0,antialiased_blur,extrude_length-1.0);float color_t=stroke_width < 0.01 ? 0.0 : smoothstep(\nantialiased_blur,0.0,extrude_length-radius/(radius+stroke_width)\n);vec4 out_color=mix(color*opacity,stroke_color*stroke_opacity,color_t);\n#ifdef FOG\nout_color=fog_apply_premultiplied(out_color,v_fog_pos);\n#endif\ngl_FragColor=out_color*(v_visibility*opacity_t);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "#define NUM_VISIBILITY_RINGS 2\n#define INV_SQRT2 0.70710678\n#define ELEVATION_BIAS 0.0001\n#define NUM_SAMPLES_PER_RING 16\nuniform mat4 u_matrix;uniform mat2 u_extrude_scale;uniform lowp float u_device_pixel_ratio;uniform highp float u_camera_to_center_distance;attribute vec2 a_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;attribute vec3 a_pos_normal_3;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_tile_id;uniform float u_zoom_transition;uniform vec3 u_up_dir;\n#endif\nvarying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvec2 calc_offset(vec2 extrusion,float radius,float stroke_width, float view_scale) {return extrusion*(radius+stroke_width)*u_extrude_scale*view_scale;}float cantilevered_elevation(vec2 pos,float radius,float stroke_width,float view_scale) {vec2 c1=pos+calc_offset(vec2(-1,-1),radius,stroke_width,view_scale);vec2 c2=pos+calc_offset(vec2(1,-1),radius,stroke_width,view_scale);vec2 c3=pos+calc_offset(vec2(1,1),radius,stroke_width,view_scale);vec2 c4=pos+calc_offset(vec2(-1,1),radius,stroke_width,view_scale);float h1=elevation(c1)+ELEVATION_BIAS;float h2=elevation(c2)+ELEVATION_BIAS;float h3=elevation(c3)+ELEVATION_BIAS;float h4=elevation(c4)+ELEVATION_BIAS;return max(h4,max(h3,max(h1,h2)));}float circle_elevation(vec2 pos) {\n#if defined(TERRAIN)\nreturn elevation(pos)+ELEVATION_BIAS;\n#else\nreturn 0.0;\n#endif\n}vec4 project_vertex(vec2 extrusion,vec4 world_center,vec4 projected_center,float radius,float stroke_width, float view_scale,mat3 surface_vectors) {vec2 sample_offset=calc_offset(extrusion,radius,stroke_width,view_scale);\n#ifdef PITCH_WITH_MAP\n#ifdef PROJECTION_GLOBE_VIEW\nreturn u_matrix*( world_center+vec4(sample_offset.x*surface_vectors[0]+sample_offset.y*surface_vectors[1],0) );\n#else\nreturn u_matrix*( world_center+vec4(sample_offset,0,0) );\n#endif\n#else\nreturn projected_center+vec4(sample_offset,0,0);\n#endif\n}float get_sample_step() {\n#ifdef PITCH_WITH_MAP\nreturn 2.0*PI/float(NUM_SAMPLES_PER_RING);\n#else\nreturn PI/float(NUM_SAMPLES_PER_RING);\n#endif\n}void main(void) {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=vec2(mod(a_pos,2.0)*2.0-1.0);vec2 circle_center=floor(a_pos*0.5);vec4 world_center;mat3 surface_vectors;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 pos_normal_3=a_pos_normal_3/16384.0;surface_vectors=globe_mercator_surface_vectors(pos_normal_3,u_up_dir,u_zoom_transition);vec3 surface_extrusion=extrude.x*surface_vectors[0]+extrude.y*surface_vectors[1];vec3 globe_elevation=elevationVector(circle_center)*circle_elevation(circle_center);vec3 globe_pos=a_pos_3+surface_extrusion+globe_elevation;vec3 mercator_elevation=u_up_dir*u_tile_up_scale*circle_elevation(circle_center);vec3 merc_pos=mercator_tile_position(u_inv_rot_matrix,circle_center,u_tile_id,u_merc_center)+surface_extrusion+mercator_elevation;vec3 pos=mix_globe_mercator(globe_pos,merc_pos,u_zoom_transition);world_center=vec4(pos,1);\n#else \nsurface_vectors=mat3(1.0);float height=circle_elevation(circle_center);world_center=vec4(circle_center,height,1);\n#endif\nvec4 projected_center=u_matrix*world_center;float view_scale=0.0;\n#ifdef PITCH_WITH_MAP\n#ifdef SCALE_WITH_MAP\nview_scale=1.0;\n#else\nview_scale=projected_center.w/u_camera_to_center_distance;\n#endif\n#else\n#ifdef SCALE_WITH_MAP\nview_scale=u_camera_to_center_distance;\n#else\nview_scale=projected_center.w;\n#endif\n#endif\ngl_Position=project_vertex(extrude,world_center,projected_center,radius,stroke_width,view_scale,surface_vectors);float visibility=0.0;\n#ifdef TERRAIN\nfloat step=get_sample_step();vec4 occlusion_world_center;vec4 occlusion_projected_center;\n#ifdef PITCH_WITH_MAP\nfloat cantilevered_height=cantilevered_elevation(circle_center,radius,stroke_width,view_scale);occlusion_world_center=vec4(circle_center,cantilevered_height,1);occlusion_projected_center=u_matrix*occlusion_world_center;\n#else\nocclusion_world_center=world_center;occlusion_projected_center=projected_center;\n#endif\nfor(int ring=0; ring < NUM_VISIBILITY_RINGS; ring++) {float scale=(float(ring)+1.0)/float(NUM_VISIBILITY_RINGS);for(int i=0; i < NUM_SAMPLES_PER_RING; i++) {vec2 extrusion=vec2(cos(step*float(i)),-sin(step*float(i)))*scale;vec4 frag_pos=project_vertex(extrusion,occlusion_world_center,occlusion_projected_center,radius,stroke_width,view_scale,surface_vectors);visibility+=float(!isOccluded(frag_pos));}}visibility/=float(NUM_VISIBILITY_RINGS)*float(NUM_SAMPLES_PER_RING);\n#else\nvisibility=1.0;\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nvisibility=1.0;\n#endif\nv_visibility=visibility;lowp float antialiasblur=1.0/u_device_pixel_ratio/(radius+stroke_width);v_data=vec3(extrude.x,extrude.y,antialiasblur);\n#ifdef FOG\nv_fog_pos=fog_position(world_center.xyz);\n#endif\n}"),
            clippingMask: pi("void main() {gl_FragColor=vec4(1.0);}", "attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"),
            heatmap: pi("uniform highp float u_intensity;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#define GAUSS_COEF 0.3989422804014327\nvoid main() {\n#pragma mapbox: initialize highp float weight\nfloat d=-0.5*3.0*3.0*dot(v_extrude,v_extrude);float val=weight*u_intensity*GAUSS_COEF*exp(d);gl_FragColor=vec4(val,1.0,1.0,1.0);\n#ifdef FOG\nif (u_is_globe==0) {gl_FragColor.r*=pow(1.0-fog_opacity(v_fog_pos),2.0);}\n#endif\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform float u_extrude_scale;uniform float u_opacity;uniform float u_intensity;attribute vec2 a_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;attribute vec3 a_pos_normal_3;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_tile_id;uniform float u_zoom_transition;uniform vec3 u_up_dir;\n#endif\nvarying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#pragma mapbox: define mediump float radius\nconst highp float ZERO=1.0/255.0/16.0;\n#define GAUSS_COEF 0.3989422804014327\nvoid main(void) {\n#pragma mapbox: initialize highp float weight\n#pragma mapbox: initialize mediump float radius\nvec2 unscaled_extrude=vec2(mod(a_pos,2.0)*2.0-1.0);float S=sqrt(-2.0*log(ZERO/weight/u_intensity/GAUSS_COEF))/3.0;v_extrude=S*unscaled_extrude;vec2 extrude=v_extrude*radius*u_extrude_scale;vec2 tilePos=floor(a_pos*0.5);vec3 pos;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 pos_normal_3=a_pos_normal_3/16384.0;mat3 surface_vectors=globe_mercator_surface_vectors(pos_normal_3,u_up_dir,u_zoom_transition);vec3 surface_extrusion=extrude.x*surface_vectors[0]+extrude.y*surface_vectors[1];vec3 globe_elevation=elevationVector(tilePos)*elevation(tilePos);vec3 globe_pos=a_pos_3+surface_extrusion+globe_elevation;vec3 mercator_elevation=u_up_dir*u_tile_up_scale*elevation(tilePos);vec3 merc_pos=mercator_tile_position(u_inv_rot_matrix,tilePos,u_tile_id,u_merc_center)+surface_extrusion+mercator_elevation;pos=mix_globe_mercator(globe_pos,merc_pos,u_zoom_transition);\n#else\npos=vec3(tilePos+extrude,elevation(tilePos));\n#endif\ngl_Position=u_matrix*vec4(pos,1);\n#ifdef FOG\nv_fog_pos=fog_position(pos);\n#endif\n}"),
            heatmapTexture: pi("uniform sampler2D u_image;uniform sampler2D u_color_ramp;uniform float u_opacity;varying vec2 v_pos;void main() {float t=texture2D(u_image,v_pos).r;vec4 color=texture2D(u_color_ramp,vec2(t,0.5));gl_FragColor=color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(0.0);\n#endif\n}", "attribute vec2 a_pos;varying vec2 v_pos;void main() {gl_Position=vec4(a_pos,0,1);v_pos=a_pos*0.5+0.5;}"),
            collisionBox: pi("varying float v_placed;varying float v_notUsed;void main() {vec4 red =vec4(1.0,0.0,0.0,1.0);vec4 blue=vec4(0.0,0.0,1.0,0.5);gl_FragColor =mix(red,blue,step(0.5,v_placed))*0.5;gl_FragColor*=mix(1.0,0.1,step(0.5,v_notUsed));}", "attribute vec3 a_pos;attribute vec2 a_anchor_pos;attribute vec2 a_extrude;attribute vec2 a_placed;attribute vec2 a_shift;attribute float a_size_scale;attribute vec2 a_padding;uniform mat4 u_matrix;uniform vec2 u_extrude_scale;uniform float u_camera_to_center_distance;varying float v_placed;varying float v_notUsed;void main() {vec4 projectedPoint=u_matrix*vec4(a_pos+elevationVector(a_anchor_pos)*elevation(a_anchor_pos),1);highp float camera_to_anchor_distance=projectedPoint.w;highp float collision_perspective_ratio=clamp(\n0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,1.5);gl_Position=projectedPoint;gl_Position.xy+=(a_extrude*a_size_scale+a_shift+a_padding)*u_extrude_scale*gl_Position.w*collision_perspective_ratio;v_placed=a_placed.x;v_notUsed=a_placed.y;}"),
            collisionCircle: pi("varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;void main() {float alpha=0.5*min(v_perspective_ratio,1.0);float stroke_radius=0.9*max(v_perspective_ratio,1.0);float distance_to_center=length(v_extrude);float distance_to_edge=abs(distance_to_center-v_radius);float opacity_t=smoothstep(-stroke_radius,0.0,-distance_to_edge);vec4 color=mix(vec4(0.0,0.0,1.0,0.5),vec4(1.0,0.0,0.0,1.0),v_collision);gl_FragColor=color*alpha*opacity_t;}", "attribute vec2 a_pos_2f;attribute float a_radius;attribute vec2 a_flags;uniform mat4 u_matrix;uniform mat4 u_inv_matrix;uniform vec2 u_viewport_size;uniform float u_camera_to_center_distance;varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;vec3 toTilePosition(vec2 screenPos) {vec4 rayStart=u_inv_matrix*vec4(screenPos,-1.0,1.0);vec4 rayEnd  =u_inv_matrix*vec4(screenPos, 1.0,1.0);rayStart.xyz/=rayStart.w;rayEnd.xyz  /=rayEnd.w;highp float t=(0.0-rayStart.z)/(rayEnd.z-rayStart.z);return mix(rayStart.xyz,rayEnd.xyz,t);}void main() {vec2 quadCenterPos=a_pos_2f;float radius=a_radius;float collision=a_flags.x;float vertexIdx=a_flags.y;vec2 quadVertexOffset=vec2(\nmix(-1.0,1.0,float(vertexIdx >=2.0)),mix(-1.0,1.0,float(vertexIdx >=1.0 && vertexIdx <=2.0)));vec2 quadVertexExtent=quadVertexOffset*radius;vec3 tilePos=toTilePosition(quadCenterPos);vec4 clipPos=u_matrix*vec4(tilePos,1.0);highp float camera_to_anchor_distance=clipPos.w;highp float collision_perspective_ratio=clamp(\n0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);float padding_factor=1.2;v_radius=radius;v_extrude=quadVertexExtent*padding_factor;v_perspective_ratio=collision_perspective_ratio;v_collision=collision;gl_Position=vec4(clipPos.xyz/clipPos.w,1.0)+vec4(quadVertexExtent*padding_factor/u_viewport_size*2.0,0.0,0.0);}"),
            debug: pi("uniform highp vec4 u_color;uniform sampler2D u_overlay;varying vec2 v_uv;void main() {vec4 overlay_color=texture2D(u_overlay,v_uv);gl_FragColor=mix(u_color,overlay_color,overlay_color.a);}", "attribute vec2 a_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;\n#endif\nvarying vec2 v_uv;uniform mat4 u_matrix;uniform float u_overlay_scale;void main() {float h=elevation(a_pos);v_uv=a_pos/8192.0;\n#ifdef PROJECTION_GLOBE_VIEW\ngl_Position=u_matrix*vec4(a_pos_3+elevationVector(a_pos)*h,1);\n#else\ngl_Position=u_matrix*vec4(a_pos*u_overlay_scale,h,1);\n#endif\n}"),
            fill: pi("#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\nvec4 out_color=color;\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),
            fillOutline: pi("varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);vec4 out_color=outline_color;\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;uniform vec2 u_world;varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),
            fillOutlinePattern: pi("uniform vec2 u_texsize;uniform sampler2D u_image;uniform float u_fade;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);float dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);vec4 out_color=mix(color1,color2,u_fade);\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_world;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;gl_Position=u_matrix*vec4(a_pos,0,1);vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,a_pos);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),
            fillPattern: pi("uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);vec4 out_color=mix(color1,color2,u_fade);\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileZoomRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileZoomRatio,a_pos);\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),
            fillExtrusion: pi("varying vec4 v_color;\n#ifdef RENDER_SHADOWS\nvarying highp vec4 v_pos_light_view_0;varying highp vec4 v_pos_light_view_1;varying float v_depth;\n#endif\n#ifdef FAUX_AO\nuniform lowp vec2 u_ao;varying vec3 v_ao;\n#endif\n#ifdef ZERO_ROOF_RADIUS\nvarying vec4 v_roof_color;\n#endif\n#if defined(ZERO_ROOF_RADIUS) || defined(RENDER_SHADOWS)\nvarying highp vec3 v_normal;\n#endif\nvoid main() {\n#if defined(ZERO_ROOF_RADIUS) || defined(RENDER_SHADOWS)\nvec3 normal=v_normal;\n#endif\nfloat z;vec4 color;\n#ifdef ZERO_ROOF_RADIUS\nz=float(normal.z > 0.00001);color=mix(v_color,v_roof_color,z);\n#else\ncolor=v_color;\n#endif\n#ifdef FAUX_AO\nfloat intensity=u_ao[0];float h=max(0.0,v_ao.z);float h_floors=h/u_ao[1];float y_shade=1.0-0.9*intensity*min(v_ao.y,1.0);float shade=(1.0-0.08*intensity)*(y_shade+(1.0-y_shade)*(1.0-pow(1.0-min(h_floors/16.0,1.0),16.0)))+0.08*intensity*min(h_floors/160.0,1.0);float concave=v_ao.x*v_ao.x;\n#ifdef ZERO_ROOF_RADIUS\nconcave*=(1.0-z);\n#endif\nfloat x_shade=mix(1.0,mix(0.6,0.75,min(h_floors/30.0,1.0)),intensity)+0.1*intensity*min(h,1.0);shade*=mix(1.0,x_shade*x_shade*x_shade,concave);color.rgb=color.rgb*shade;\n#endif\n#ifdef RENDER_SHADOWS\n#ifdef ZERO_ROOF_RADIUS\nnormal=mix(normal,vec3(0.0,0.0,1.0),z);\n#endif\ncolor.xyz=shadowed_color_normal(color.xyz,normalize(normal),v_pos_light_view_0,v_pos_light_view_1,v_depth);\n#endif\n#ifdef FOG\ncolor=fog_dither(fog_apply_premultiplied(color,v_fog_pos));\n#endif\ngl_FragColor=color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform float u_edge_radius;attribute vec4 a_pos_normal_ed;attribute vec2 a_centroid_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;attribute vec3 a_pos_normal_3;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_tile_id;uniform float u_zoom_transition;uniform vec3 u_up_dir;uniform float u_height_lift;\n#endif\nvarying vec4 v_color;\n#ifdef RENDER_SHADOWS\nuniform mat4 u_light_matrix_0;uniform mat4 u_light_matrix_1;varying highp vec4 v_pos_light_view_0;varying highp vec4 v_pos_light_view_1;varying float v_depth;\n#endif\n#ifdef ZERO_ROOF_RADIUS\nvarying vec4 v_roof_color;\n#endif\n#if defined(ZERO_ROOF_RADIUS) || defined(RENDER_SHADOWS)\nvarying highp vec3 v_normal;\n#endif\n#ifdef FAUX_AO\nuniform lowp vec2 u_ao;varying vec3 v_ao;\n#endif\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define highp vec4 color\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize highp vec4 color\nvec4 pos_nx=floor(a_pos_normal_ed*0.5);vec4 top_up_ny_start=a_pos_normal_ed-2.0*pos_nx;vec3 top_up_ny=top_up_ny_start.xyz;float x_normal=pos_nx.z/8192.0;vec3 normal=top_up_ny.y==1.0 ? vec3(0.0,0.0,1.0) : normalize(vec3(x_normal,(2.0*top_up_ny.z-1.0)*(1.0-abs(x_normal)),0.0));\n#if defined(ZERO_ROOF_RADIUS) || defined(RENDER_SHADOWS)\nv_normal=normal;\n#endif\nbase=max(0.0,base);height=max(0.0,top_up_ny.y==0.0 && top_up_ny.x==1.0 ? height-u_edge_radius : height);float t=top_up_ny.x;vec2 centroid_pos=vec2(0.0);\n#if defined(HAS_CENTROID) || defined(TERRAIN)\ncentroid_pos=a_centroid_pos;\n#endif\nfloat ele=0.0;float h=0.0;float c_ele;vec3 pos;\n#ifdef TERRAIN\nbool flat_roof=centroid_pos.x !=0.0 && t > 0.0;ele=elevation(pos_nx.xy);c_ele=flat_roof ? centroid_pos.y==0.0 ? elevationFromUint16(centroid_pos.x) : flatElevation(centroid_pos) : ele;h=flat_roof ? max(c_ele+height,ele+base+2.0) : ele+(t > 0.0 ? height : base==0.0 ?-5.0 : base);pos=vec3(pos_nx.xy,h);\n#else\nh=t > 0.0 ? height : base;pos=vec3(pos_nx.xy,h);\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nfloat lift=float((t+base) > 0.0)*u_height_lift;h+=lift;vec3 globe_normal=normalize(mix(a_pos_normal_3/16384.0,u_up_dir,u_zoom_transition));vec3 globe_pos=a_pos_3+globe_normal*(u_tile_up_scale*h);vec3 merc_pos=mercator_tile_position(u_inv_rot_matrix,pos.xy,u_tile_id,u_merc_center)+u_up_dir*u_tile_up_scale*pos.z;pos=mix_globe_mercator(globe_pos,merc_pos,u_zoom_transition);\n#endif\nfloat hidden=float(centroid_pos.x==0.0 && centroid_pos.y==1.0);gl_Position=mix(u_matrix*vec4(pos,1),AWAY,hidden);\n#ifdef RENDER_SHADOWS\nv_pos_light_view_0=u_light_matrix_0*vec4(pos,1);v_pos_light_view_1=u_light_matrix_1*vec4(pos,1);v_depth=gl_Position.w;\n#endif\nfloat colorvalue=color.r*0.2126+color.g*0.7152+color.b*0.0722;v_color=vec4(0.0,0.0,0.0,1.0);vec4 ambientlight=vec4(0.03,0.03,0.03,1.0);color+=ambientlight;float directional=clamp(dot(normal,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=(\n(1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}\n#ifdef FAUX_AO\nfloat concave=pos_nx.w-floor(pos_nx.w*0.5)*2.0;float start=top_up_ny_start.w;float y_ground=1.0-clamp(t+base,0.0,1.0);float top_height=height;\n#ifdef TERRAIN\ntop_height=mix(max(c_ele+height,ele+base+2.0),ele+height,float(centroid_pos.x==0.0))-ele;y_ground+=y_ground*5.0/max(3.0,top_height);\n#endif\nv_ao=vec3(mix(concave,-concave,start),y_ground,h-ele);directional*=(1.0+0.05*(1.0-top_up_ny.y)*u_ao[0]);\n#ifdef PROJECTION_GLOBE_VIEW\ntop_height+=u_height_lift;\n#endif\ngl_Position.z-=(0.0000006*(min(top_height,500.)+2.0*min(base,500.0)+60.0*concave+3.0*start))*gl_Position.w;\n#endif\nv_color.rgb+=clamp(color.rgb*directional*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_color*=u_opacity;\n#ifdef ZERO_ROOF_RADIUS\nv_roof_color=vec4(0.0,0.0,0.0,1.0);float roof_radiance=clamp(u_lightpos.z,0.0,1.0);roof_radiance=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),roof_radiance);v_roof_color.rgb+=clamp(color.rgb*roof_radiance*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_roof_color*=u_opacity;\n#endif\n#ifdef FOG\nv_fog_pos=fog_position(pos);\n#endif\n}"),
            fillExtrusionPattern: pi("uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;\n#ifdef FAUX_AO\nuniform lowp vec2 u_ao;varying vec3 v_ao;\n#endif\nvarying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);vec4 out_color=mix(color1,color2,u_fade);out_color=out_color*v_lighting;\n#ifdef FAUX_AO\nfloat intensity=u_ao[0];float h=max(0.0,v_ao.z);float h_floors=h/u_ao[1];float y_shade=1.0-0.9*intensity*min(v_ao.y,1.0);float shade=(1.0-0.08*intensity)*(y_shade+(1.0-y_shade)*(1.0-pow(1.0-min(h_floors/16.0,1.0),16.0)))+0.08*intensity*min(h_floors/160.0,1.0);float concave=v_ao.x*v_ao.x;float x_shade=mix(1.0,mix(0.6,0.75,min(h_floors/30.0,1.0)),intensity)+0.1*intensity*min(h,1.0);shade*=mix(1.0,x_shade*x_shade*x_shade,concave);out_color.rgb=out_color.rgb*shade;\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\ngl_FragColor=out_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_height_factor;uniform vec3 u_scale;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;attribute vec4 a_pos_normal_ed;attribute vec2 a_centroid_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_pos_3;attribute vec3 a_pos_normal_3;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_tile_id;uniform float u_zoom_transition;uniform vec3 u_up_dir;uniform float u_height_lift;\n#endif\nvarying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#ifdef FAUX_AO\nuniform lowp vec2 u_ao;varying vec3 v_ao;\n#endif\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec4 pos_nx=floor(a_pos_normal_ed*0.5);mediump vec4 top_up_ny_start=a_pos_normal_ed-2.0*pos_nx;mediump vec3 top_up_ny=top_up_ny_start.xyz;float x_normal=pos_nx.z/8192.0;vec3 normal=top_up_ny.y==1.0 ? vec3(0.0,0.0,1.0) : normalize(vec3(x_normal,(2.0*top_up_ny.z-1.0)*(1.0-abs(x_normal)),0.0));float edgedistance=a_pos_normal_ed.w;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;base=max(0.0,base);height=max(0.0,height);float t=top_up_ny.x;float z=t > 0.0 ? height : base;vec2 centroid_pos=vec2(0.0);\n#if defined(HAS_CENTROID) || defined(TERRAIN)\ncentroid_pos=a_centroid_pos;\n#endif\nfloat ele=0.0;float h=z;vec3 p;float c_ele;\n#ifdef TERRAIN\nbool flat_roof=centroid_pos.x !=0.0 && t > 0.0;ele=elevation(pos_nx.xy);c_ele=flat_roof ? centroid_pos.y==0.0 ? elevationFromUint16(centroid_pos.x) : flatElevation(centroid_pos) : ele;h=flat_roof ? max(c_ele+height,ele+base+2.0) : ele+(t > 0.0 ? height : base==0.0 ?-5.0 : base);p=vec3(pos_nx.xy,h);\n#else\np=vec3(pos_nx.xy,z);\n#endif\n#ifdef PROJECTION_GLOBE_VIEW\nfloat lift=float((t+base) > 0.0)*u_height_lift;h+=lift;vec3 globe_normal=normalize(mix(a_pos_normal_3/16384.0,u_up_dir,u_zoom_transition));vec3 globe_pos=a_pos_3+globe_normal*(u_tile_up_scale*(p.z+lift));vec3 merc_pos=mercator_tile_position(u_inv_rot_matrix,p.xy,u_tile_id,u_merc_center)+u_up_dir*u_tile_up_scale*p.z;p=mix_globe_mercator(globe_pos,merc_pos,u_zoom_transition);\n#endif\nfloat hidden=float(centroid_pos.x==0.0 && centroid_pos.y==1.0);gl_Position=mix(u_matrix*vec4(p,1),AWAY,hidden);vec2 pos=normal.z==1.0\n? pos_nx.xy\n: vec2(edgedistance,z*u_height_factor);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,pos);v_lighting=vec4(0.0,0.0,0.0,1.0);float directional=clamp(dot(normal,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((0.5+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=(\n(1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}\n#ifdef FAUX_AO\nfloat concave=pos_nx.w-floor(pos_nx.w*0.5)*2.0;float start=top_up_ny_start.w;float y_ground=1.0-clamp(t+base,0.0,1.0);float top_height=height;\n#ifdef TERRAIN\ntop_height=mix(max(c_ele+height,ele+base+2.0),ele+height,float(centroid_pos.x==0.0))-ele;y_ground+=y_ground*5.0/max(3.0,top_height);\n#endif\nv_ao=vec3(mix(concave,-concave,start),y_ground,h-ele);directional*=(1.0+0.05*(1.0-top_up_ny.y)*u_ao[0]);\n#ifdef PROJECTION_GLOBE_VIEW\ntop_height+=u_height_lift;\n#endif\ngl_Position.z-=(0.0000006*(min(top_height,500.)+2.0*min(base,500.0)+60.0*concave+3.0*start))*gl_Position.w;\n#endif\nv_lighting.rgb+=clamp(directional*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_lighting*=u_opacity;\n#ifdef FOG\nv_fog_pos=fog_position(p);\n#endif\n}"),
            hillshadePrepare: pi("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_dimension;uniform float u_zoom;uniform vec4 u_unpack;float getElevation(vec2 coord) {\n#ifdef TERRAIN_DEM_FLOAT_FORMAT\nreturn texture2D(u_image,coord).a/4.0;\n#else\nvec4 data=texture2D(u_image,coord)*255.0;data.a=-1.0;return dot(data,u_unpack)/4.0;\n#endif\n}void main() {vec2 epsilon=1.0/u_dimension;float a=getElevation(v_pos+vec2(-epsilon.x,-epsilon.y));float b=getElevation(v_pos+vec2(0,-epsilon.y));float c=getElevation(v_pos+vec2(epsilon.x,-epsilon.y));float d=getElevation(v_pos+vec2(-epsilon.x,0));float e=getElevation(v_pos);float f=getElevation(v_pos+vec2(epsilon.x,0));float g=getElevation(v_pos+vec2(-epsilon.x,epsilon.y));float h=getElevation(v_pos+vec2(0,epsilon.y));float i=getElevation(v_pos+vec2(epsilon.x,epsilon.y));float exaggerationFactor=u_zoom < 2.0 ? 0.4 : u_zoom < 4.5 ? 0.35 : 0.3;float exaggeration=u_zoom < 15.0 ? (u_zoom-15.0)*exaggerationFactor : 0.0;vec2 deriv=vec2(\n(c+f+f+i)-(a+d+d+g),(g+h+h+i)-(a+b+b+c)\n)/pow(2.0,exaggeration+(19.2562-u_zoom));gl_FragColor=clamp(vec4(\nderiv.x/2.0+0.5,deriv.y/2.0+0.5,1.0,1.0),0.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_dimension;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);highp vec2 epsilon=1.0/u_dimension;float scale=(u_dimension.x-2.0)/u_dimension.x;v_pos=(a_texture_pos/8192.0)*scale+epsilon;}"),
            hillshade: pi("uniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_latrange;uniform vec2 u_light;uniform vec4 u_shadow;uniform vec4 u_highlight;uniform vec4 u_accent;void main() {vec4 pixel=texture2D(u_image,v_pos);vec2 deriv=((pixel.rg*2.0)-1.0);float scaleFactor=cos(radians((u_latrange[0]-u_latrange[1])*(1.0-v_pos.y)+u_latrange[1]));float slope=atan(1.25*length(deriv)/scaleFactor);float aspect=deriv.x !=0.0 ? atan(deriv.y,-deriv.x) : PI/2.0*(deriv.y > 0.0 ? 1.0 :-1.0);float intensity=u_light.x;float azimuth=u_light.y+PI;float base=1.875-intensity*1.75;float maxValue=0.5*PI;float scaledSlope=intensity !=0.5 ? ((pow(base,slope)-1.0)/(pow(base,maxValue)-1.0))*maxValue : slope;float accent=cos(scaledSlope);vec4 accent_color=(1.0-accent)*u_accent*clamp(intensity*2.0,0.0,1.0);float shade=abs(mod((aspect+azimuth)/PI+0.5,2.0)-1.0);vec4 shade_color=mix(u_shadow,u_highlight,shade)*sin(scaledSlope)*clamp(intensity*2.0,0.0,1.0);gl_FragColor=accent_color*(1.0-shade_color.a)+shade_color;\n#ifdef FOG\ngl_FragColor=fog_dither(fog_apply_premultiplied(gl_FragColor,v_fog_pos));\n#endif\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=a_texture_pos/8192.0;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),
            line: pi("uniform lowp float u_device_pixel_ratio;uniform float u_alpha_discard_threshold;uniform highp vec2 u_trim_offset;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;varying highp vec4 v_uv;\n#ifdef RENDER_LINE_DASH\nuniform sampler2D u_dash_image;uniform float u_mix;uniform vec3 u_scale;varying vec2 v_tex_a;varying vec2 v_tex_b;\n#endif\n#ifdef RENDER_LINE_GRADIENT\nuniform sampler2D u_gradient_image;\n#endif\nuniform float u_border_width;uniform vec4 u_border_color;float luminance(vec3 c) {return (c.r+c.r+c.b+c.g+c.g+c.g)*0.1667;}\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 dash_from\n#pragma mapbox: define lowp vec4 dash_to\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize lowp vec4 dash_from\n#pragma mapbox: initialize lowp vec4 dash_to\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);\n#ifdef RENDER_LINE_DASH\nfloat sdfdist_a=texture2D(u_dash_image,v_tex_a).a;float sdfdist_b=texture2D(u_dash_image,v_tex_b).a;float sdfdist=mix(sdfdist_a,sdfdist_b,u_mix);float sdfwidth=min(dash_from.z*u_scale.y,dash_to.z*u_scale.z);float sdfgamma=1.0/(2.0*u_device_pixel_ratio)/sdfwidth;alpha*=smoothstep(0.5-sdfgamma/floorwidth,0.5+sdfgamma/floorwidth,sdfdist);\n#endif\n#ifdef RENDER_LINE_GRADIENT\nhighp vec4 out_color=texture2D(u_gradient_image,v_uv.xy);\n#else\nvec4 out_color=color;\n#endif\n#ifdef RENDER_LINE_TRIM_OFFSET\nhighp float start=v_uv[2];highp float end=v_uv[3];highp float trim_start=u_trim_offset[0];highp float trim_end=u_trim_offset[1];highp float line_progress=(start+(v_uv.x)*(end-start));if (trim_end > trim_start) {if (line_progress <=trim_end && line_progress >=trim_start) {out_color=vec4(0,0,0,0);}}\n#endif\n#ifdef FOG\nout_color=fog_dither(fog_apply_premultiplied(out_color,v_fog_pos));\n#endif\n#ifdef RENDER_LINE_ALPHA_DISCARD\nif (alpha < u_alpha_discard_threshold) {discard;}\n#endif\n#ifdef RENDER_LINE_BORDER\nfloat edgeBlur=(u_border_width+1.0/u_device_pixel_ratio);float alpha2=clamp(min(dist-(v_width2.t-edgeBlur),v_width2.s-dist)/edgeBlur,0.0,1.0);if (alpha2 < 1.) {float smoothAlpha=smoothstep(0.6,1.0,alpha2);\n#ifdef RENDER_LINE_BORDER_AUTO\nfloat Y=(out_color.a > 0.01) ? luminance(out_color.rgb/out_color.a) : 1.;float adjustment=(Y > 0.) ? 0.5/Y : 0.45;if (out_color.a > 0.25 && Y < 0.25) {vec3 borderColor=(Y > 0.) ? out_color.rgb : vec3(1,1,1)*out_color.a;out_color.rgb=out_color.rgb+borderColor*(adjustment*(1.0-smoothAlpha));} else {out_color.rgb*=(0.6 +0.4*smoothAlpha);}\n#else\nout_color.rgb=mix(u_border_color.rgb,out_color.rgb,smoothAlpha);\n#endif\n}\n#endif\ngl_FragColor=out_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define EXTRUDE_SCALE 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;\n#if defined(RENDER_LINE_GRADIENT) || defined(RENDER_LINE_TRIM_OFFSET)\nattribute highp vec4 a_packed;\n#endif\n#ifdef RENDER_LINE_DASH\nattribute float a_linesofar;\n#endif\nuniform mat4 u_matrix;uniform mat2 u_pixels_to_tile_units;uniform vec2 u_units_to_pixels;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp vec4 v_uv;\n#ifdef RENDER_LINE_DASH\nuniform vec2 u_texsize;uniform mediump vec3 u_scale;varying vec2 v_tex_a;varying vec2 v_tex_b;\n#endif\n#ifdef RENDER_LINE_GRADIENT\nuniform float u_image_height;\n#endif\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 dash_from\n#pragma mapbox: define lowp vec4 dash_to\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize lowp vec4 dash_from\n#pragma mapbox: initialize lowp vec4 dash_to\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*EXTRUDE_SCALE;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*EXTRUDE_SCALE*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist*u_pixels_to_tile_units,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2*u_pixels_to_tile_units,0.0,1.0)+projected_extrude;\n#ifndef RENDER_TO_TEXTURE\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#else\nv_gamma_scale=1.0;\n#endif\n#if defined(RENDER_LINE_GRADIENT) || defined(RENDER_LINE_TRIM_OFFSET)\nfloat a_uv_x=a_packed[0];float a_split_index=a_packed[1];highp float a_clip_start=a_packed[2];highp float a_clip_end=a_packed[3];\n#ifdef RENDER_LINE_GRADIENT\nhighp float texel_height=1.0/u_image_height;highp float half_texel_height=0.5*texel_height;v_uv=vec4(a_uv_x,a_split_index*texel_height-half_texel_height,a_clip_start,a_clip_end);\n#else\nv_uv=vec4(a_uv_x,0.0,a_clip_start,a_clip_end);\n#endif\n#endif\n#ifdef RENDER_LINE_DASH\nfloat tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;float scaleA=dash_from.z==0.0 ? 0.0 : tileZoomRatio/(dash_from.z*fromScale);float scaleB=dash_to.z==0.0 ? 0.0 : tileZoomRatio/(dash_to.z*toScale);float heightA=dash_from.y;float heightB=dash_to.y;v_tex_a=vec2(a_linesofar*scaleA/floorwidth,(-normal.y*heightA+dash_from.x+0.5)/u_texsize.y);v_tex_b=vec2(a_linesofar*scaleB/floorwidth,(-normal.y*heightB+dash_to.x+0.5)/u_texsize.y);\n#endif\nv_width2=vec2(outset,inset);\n#ifdef FOG\nv_fog_pos=fog_position(pos);\n#endif\n}"),
            linePattern: pi("uniform lowp float u_device_pixel_ratio;uniform vec2 u_texsize;uniform float u_fade;uniform mediump vec3 u_scale;uniform sampler2D u_image;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;vec2 pattern_size_a=vec2(display_size_a.x*fromScale/tileZoomRatio,display_size_a.y);vec2 pattern_size_b=vec2(display_size_b.x*toScale/tileZoomRatio,display_size_b.y);float aspect_a=display_size_a.y/v_width;float aspect_b=display_size_b.y/v_width;float dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float x_a=mod(v_linesofar/pattern_size_a.x*aspect_a,1.0);float x_b=mod(v_linesofar/pattern_size_b.x*aspect_b,1.0);float y=0.5*v_normal.y+0.5;vec2 texel_size=1.0/u_texsize;vec2 pos_a=mix(pattern_tl_a*texel_size-texel_size,pattern_br_a*texel_size+texel_size,vec2(x_a,y));vec2 pos_b=mix(pattern_tl_b*texel_size-texel_size,pattern_br_b*texel_size+texel_size,vec2(x_b,y));vec4 color=mix(texture2D(u_image,pos_a),texture2D(u_image,pos_b),u_fade);\n#ifdef FOG\ncolor=fog_dither(fog_apply_premultiplied(color,v_fog_pos));\n#endif\ngl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;attribute float a_linesofar;uniform mat4 u_matrix;uniform vec2 u_units_to_pixels;uniform mat2 u_pixels_to_tile_units;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist*u_pixels_to_tile_units,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2*u_pixels_to_tile_units,0.0,1.0)+projected_extrude;\n#ifndef RENDER_TO_TEXTURE\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#else\nv_gamma_scale=1.0;\n#endif\nv_linesofar=a_linesofar;v_width2=vec2(outset,inset);v_width=floorwidth;\n#ifdef FOG\nv_fog_pos=fog_position(pos);\n#endif\n}"),
            raster: pi("uniform float u_fade_t;uniform float u_opacity;uniform sampler2D u_image0;uniform sampler2D u_image1;varying vec2 v_pos0;varying vec2 v_pos1;uniform float u_brightness_low;uniform float u_brightness_high;uniform float u_saturation_factor;uniform float u_contrast_factor;uniform vec3 u_spin_weights;void main() {vec4 color0=texture2D(u_image0,v_pos0);vec4 color1=texture2D(u_image1,v_pos1);if (color0.a > 0.0) {color0.rgb=color0.rgb/color0.a;}if (color1.a > 0.0) {color1.rgb=color1.rgb/color1.a;}vec4 color=mix(color0,color1,u_fade_t);color.a*=u_opacity;vec3 rgb=color.rgb;rgb=vec3(\ndot(rgb,u_spin_weights.xyz),dot(rgb,u_spin_weights.zxy),dot(rgb,u_spin_weights.yzx));float average=(color.r+color.g+color.b)/3.0;rgb+=(average-rgb)*u_saturation_factor;rgb=(rgb-0.5)*u_contrast_factor+0.5;vec3 u_high_vec=vec3(u_brightness_low,u_brightness_low,u_brightness_low);vec3 u_low_vec=vec3(u_brightness_high,u_brightness_high,u_brightness_high);vec3 out_color=mix(u_high_vec,u_low_vec,rgb);\n#ifdef FOG\nout_color=fog_dither(fog_apply(out_color,v_fog_pos));\n#endif\ngl_FragColor=vec4(out_color*color.a,color.a);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_tl_parent;uniform float u_scale_parent;uniform vec2 u_perspective_transform;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos0;varying vec2 v_pos1;void main() {float w=1.0+dot(a_texture_pos,u_perspective_transform);gl_Position=u_matrix*vec4(a_pos*w,0,w);v_pos0=a_texture_pos/8192.0;v_pos1=(v_pos0*u_scale_parent)+u_tl_parent;\n#ifdef FOG\nv_fog_pos=fog_position(a_pos);\n#endif\n}"),
            symbolIcon: pi("uniform sampler2D u_texture;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nlowp float alpha=opacity*v_fade_opacity;gl_FragColor=texture2D(u_texture,v_tex)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec4 a_pos_offset;attribute vec4 a_tex_size;attribute vec4 a_pixeloffset;attribute vec4 a_projected_pos;attribute float a_fade_opacity;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_globe_anchor;attribute vec3 a_globe_normal;\n#endif\nuniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform highp float u_camera_to_center_distance;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform float u_fade_change;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform vec2 u_texsize;uniform vec3 u_up_vector;\n#ifdef PROJECTION_GLOBE_VIEW\nuniform vec3 u_tile_id;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_camera_forward;uniform float u_zoom_transition;uniform vec3 u_ecef_origin;uniform mat4 u_tile_matrix;\n#endif\nvarying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_tex_size.xy;vec2 a_size=a_tex_size.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;vec2 a_min_font_scale=a_pixeloffset.zw/256.0;highp float segment_angle=-a_projected_pos[3];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec2 tile_anchor=a_pos;vec3 h=elevationVector(tile_anchor)*elevation(tile_anchor);float globe_occlusion_fade;vec3 world_pos;vec3 mercator_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nmercator_pos=mercator_tile_position(u_inv_rot_matrix,tile_anchor,u_tile_id,u_merc_center);world_pos=mix_globe_mercator(a_globe_anchor+h,mercator_pos,u_zoom_transition);vec4 ecef_point=u_tile_matrix*vec4(world_pos,1.0);vec3 origin_to_point=ecef_point.xyz-u_ecef_origin;globe_occlusion_fade=dot(origin_to_point,u_camera_forward) >=0.0 ? 0.0 : 1.0;\n#else\nworld_pos=vec3(tile_anchor,0)+h;globe_occlusion_fade=1.0;\n#endif\nvec4 projected_point=u_matrix*vec4(world_pos,1);highp float camera_to_anchor_distance=projected_point.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(\n0.5+0.5*distance_ratio,0.0,1.5);size*=perspective_ratio;float font_scale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjected_point;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 displacement=vec3(a_globe_normal.z,0,-a_globe_normal.x);offsetProjected_point=u_matrix*vec4(a_globe_anchor+displacement,1);\n#else\noffsetProjected_point=u_matrix*vec4(tile_anchor+vec2(1,0),0,1);\n#endif\nvec2 a=projected_point.xy/projected_point.w;vec2 b=offsetProjected_point.xy/offsetProjected_point.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}vec4 projected_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 proj_pos=mix_globe_mercator(a_projected_pos.xyz+h,mercator_pos,u_zoom_transition);projected_pos=u_label_plane_matrix*vec4(proj_pos,1.0);\n#else\nprojected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,h.z,1.0);\n#endif\nhighp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);float z=0.0;vec2 offset=rotation_matrix*(a_offset/32.0*max(a_min_font_scale,font_scale)+a_pxoffset/16.0);\n#ifdef TERRAIN\n#ifdef PITCH_WITH_MAP_TERRAIN\nvec4 tile_pos=u_label_plane_matrix_inv*vec4(a_projected_pos.xy+offset,0.0,1.0);z=elevation(tile_pos.xy);\n#endif\n#endif\nfloat occlusion_fade=occlusionFade(projected_point)*globe_occlusion_fade;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 xAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,u_up_vector)) : vec3(1,0,0);vec3 yAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,xAxis)) : vec3(0,1,0);gl_Position=mix(u_coord_matrix*vec4(projected_pos.xyz/projected_pos.w+xAxis*offset.x+yAxis*offset.y,1.0),AWAY,float(projected_point.w <=0.0 || occlusion_fade==0.0));\n#else\ngl_Position=mix(u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+offset,z,1.0),AWAY,float(projected_point.w <=0.0 || occlusion_fade==0.0));\n#endif\nfloat projection_transition_fade=1.0;\n#if defined(PROJECTED_POS_ON_VIEWPORT) && defined(PROJECTION_GLOBE_VIEW)\nprojection_transition_fade=1.0-step(EPSILON,u_zoom_transition);\n#endif\nv_tex=a_tex/u_texsize;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;v_fade_opacity=max(0.0,min(occlusion_fade,fade_opacity[0]+fade_change))*projection_transition_fade;}"),
            symbolSDF: pi("#define SDF_PX 8.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;uniform bool u_is_text;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat EDGE_GAMMA=0.105/u_device_pixel_ratio;vec2 tex=v_data0.xy;float gamma_scale=v_data1.x;float size=v_data1.y;float fade_opacity=v_data1[2];float fontScale=u_is_text ? size/24.0 : size;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec4 a_pos_offset;attribute vec4 a_tex_size;attribute vec4 a_pixeloffset;attribute vec4 a_projected_pos;attribute float a_fade_opacity;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_globe_anchor;attribute vec3 a_globe_normal;\n#endif\nuniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec3 u_up_vector;\n#ifdef PROJECTION_GLOBE_VIEW\nuniform vec3 u_tile_id;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_camera_forward;uniform float u_zoom_transition;uniform vec3 u_ecef_origin;uniform mat4 u_tile_matrix;\n#endif\nvarying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_tex_size.xy;vec2 a_size=a_tex_size.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;highp float segment_angle=-a_projected_pos[3];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec2 tile_anchor=a_pos;vec3 h=elevationVector(tile_anchor)*elevation(tile_anchor);float globe_occlusion_fade;vec3 world_pos;vec3 mercator_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nmercator_pos=mercator_tile_position(u_inv_rot_matrix,tile_anchor,u_tile_id,u_merc_center);world_pos=mix_globe_mercator(a_globe_anchor+h,mercator_pos,u_zoom_transition);vec4 ecef_point=u_tile_matrix*vec4(world_pos,1.0);vec3 origin_to_point=ecef_point.xyz-u_ecef_origin;globe_occlusion_fade=dot(origin_to_point,u_camera_forward) >=0.0 ? 0.0 : 1.0;\n#else\nworld_pos=vec3(tile_anchor,0)+h;globe_occlusion_fade=1.0;\n#endif\nvec4 projected_point=u_matrix*vec4(world_pos,1);highp float camera_to_anchor_distance=projected_point.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(\n0.5+0.5*distance_ratio,0.0,1.5);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetprojected_point;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 displacement=vec3(a_globe_normal.z,0,-a_globe_normal.x);offsetprojected_point=u_matrix*vec4(a_globe_anchor+displacement,1);\n#else\noffsetprojected_point=u_matrix*vec4(tile_anchor+vec2(1,0),0,1);\n#endif\nvec2 a=projected_point.xy/projected_point.w;vec2 b=offsetprojected_point.xy/offsetprojected_point.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}vec4 projected_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 proj_pos=mix_globe_mercator(a_projected_pos.xyz+h,mercator_pos,u_zoom_transition);projected_pos=u_label_plane_matrix*vec4(proj_pos,1.0);\n#else\nprojected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,h.z,1.0);\n#endif\nhighp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);float z=0.0;vec2 offset=rotation_matrix*(a_offset/32.0*fontScale+a_pxoffset);\n#ifdef TERRAIN\n#ifdef PITCH_WITH_MAP_TERRAIN\nvec4 tile_pos=u_label_plane_matrix_inv*vec4(a_projected_pos.xy+offset,0.0,1.0);z=elevation(tile_pos.xy);\n#endif\n#endif\nfloat occlusion_fade=occlusionFade(projected_point)*globe_occlusion_fade;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 xAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,u_up_vector)) : vec3(1,0,0);vec3 yAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,xAxis)) : vec3(0,1,0);gl_Position=mix(u_coord_matrix*vec4(projected_pos.xyz/projected_pos.w+xAxis*offset.x+yAxis*offset.y,1.0),AWAY,float(projected_point.w <=0.0 || occlusion_fade==0.0));\n#else\ngl_Position=mix(u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+offset,z,1.0),AWAY,float(projected_point.w <=0.0 || occlusion_fade==0.0));\n#endif\nfloat gamma_scale=gl_Position.w;float projection_transition_fade=1.0;\n#if defined(PROJECTED_POS_ON_VIEWPORT) && defined(PROJECTION_GLOBE_VIEW)\nprojection_transition_fade=1.0-step(EPSILON,u_zoom_transition);\n#endif\nvec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(occlusion_fade,fade_opacity[0]+fade_change));v_data0=a_tex/u_texsize;v_data1=vec3(gamma_scale,size,interpolated_fade_opacity*projection_transition_fade);}"),
            symbolTextAndIcon: pi("#define SDF_PX 8.0\n#define SDF 1.0\n#define ICON 0.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform sampler2D u_texture_icon;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat fade_opacity=v_data1[2];if (v_data1.w==ICON) {vec2 tex_icon=v_data0.zw;lowp float alpha=opacity*fade_opacity;gl_FragColor=texture2D(u_texture_icon,tex_icon)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nreturn;}vec2 tex=v_data0.xy;float EDGE_GAMMA=0.105/u_device_pixel_ratio;float gamma_scale=v_data1.x;float size=v_data1.y;float fontScale=size/24.0;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec4 a_pos_offset;attribute vec4 a_tex_size;attribute vec4 a_projected_pos;attribute float a_fade_opacity;\n#ifdef PROJECTION_GLOBE_VIEW\nattribute vec3 a_globe_anchor;attribute vec3 a_globe_normal;\n#endif\nuniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec3 u_up_vector;uniform vec2 u_texsize_icon;\n#ifdef PROJECTION_GLOBE_VIEW\nuniform vec3 u_tile_id;uniform mat4 u_inv_rot_matrix;uniform vec2 u_merc_center;uniform vec3 u_camera_forward;uniform float u_zoom_transition;uniform vec3 u_ecef_origin;uniform mat4 u_tile_matrix;\n#endif\nvarying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_tex_size.xy;vec2 a_size=a_tex_size.zw;float a_size_min=floor(a_size[0]*0.5);float is_sdf=a_size[0]-2.0*a_size_min;highp float segment_angle=-a_projected_pos[3];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec2 tile_anchor=a_pos;vec3 h=elevationVector(tile_anchor)*elevation(tile_anchor);float globe_occlusion_fade;vec3 world_pos;vec3 mercator_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nmercator_pos=mercator_tile_position(u_inv_rot_matrix,tile_anchor,u_tile_id,u_merc_center);world_pos=mix_globe_mercator(a_globe_anchor+h,mercator_pos,u_zoom_transition);vec4 ecef_point=u_tile_matrix*vec4(world_pos,1.0);vec3 origin_to_point=ecef_point.xyz-u_ecef_origin;globe_occlusion_fade=dot(origin_to_point,u_camera_forward) >=0.0 ? 0.0 : 1.0;\n#else\nworld_pos=vec3(tile_anchor,0)+h;globe_occlusion_fade=1.0;\n#endif\nvec4 projected_point=u_matrix*vec4(world_pos,1);highp float camera_to_anchor_distance=projected_point.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(\n0.5+0.5*distance_ratio,0.0,1.5);size*=perspective_ratio;float font_scale=size/24.0;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offset_projected_point=u_matrix*vec4(a_pos+vec2(1,0),0,1);vec2 a=projected_point.xy/projected_point.w;vec2 b=offset_projected_point.xy/offset_projected_point.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}vec4 projected_pos;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 proj_pos=mix_globe_mercator(a_projected_pos.xyz+h,mercator_pos,u_zoom_transition);projected_pos=u_label_plane_matrix*vec4(proj_pos,1.0);\n#else\nprojected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,h.z,1.0);\n#endif\nhighp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);float z=0.0;vec2 offset=rotation_matrix*(a_offset/32.0*font_scale);\n#ifdef TERRAIN\n#ifdef PITCH_WITH_MAP_TERRAIN\nvec4 tile_pos=u_label_plane_matrix_inv*vec4(a_projected_pos.xy+offset,0.0,1.0);z=elevation(tile_pos.xy);\n#endif\n#endif\nfloat occlusion_fade=occlusionFade(projected_point)*globe_occlusion_fade;\n#ifdef PROJECTION_GLOBE_VIEW\nvec3 xAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,u_up_vector)) : vec3(1,0,0);vec3 yAxis=u_pitch_with_map ? normalize(cross(a_globe_normal,xAxis)) : vec3(0,1,0);gl_Position=mix(u_coord_matrix*vec4(projected_pos.xyz/projected_pos.w+xAxis*offset.x+yAxis*offset.y,1.0),AWAY,float(projected_point.w <=0.0 || occlusion_fade==0.0));\n#else\ngl_Position=mix(u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+offset,z,1.0),AWAY,float(projected_point.w <=0.0 || occlusion_fade==0.0));\n#endif\nfloat gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(occlusion_fade,fade_opacity[0]+fade_change));float projection_transition_fade=1.0;\n#if defined(PROJECTED_POS_ON_VIEWPORT) && defined(PROJECTION_GLOBE_VIEW)\nprojection_transition_fade=1.0-step(EPSILON,u_zoom_transition);\n#endif\nv_data0.xy=a_tex/u_texsize;v_data0.zw=a_tex/u_texsize_icon;v_data1=vec4(gamma_scale,size,interpolated_fade_opacity*projection_transition_fade,is_sdf);}"),
            terrainRaster: pi("uniform sampler2D u_image0;varying vec2 v_pos0;\n#ifdef FOG\nvarying float v_fog_opacity;\n#endif\n#ifdef RENDER_SHADOWS\nvarying vec4 v_pos_light_view_0;varying vec4 v_pos_light_view_1;varying float v_depth;\n#endif\nvoid main() {vec4 color=texture2D(u_image0,v_pos0);\n#ifdef RENDER_SHADOWS\ncolor.xyz=shadowed_color(color.xyz,v_pos_light_view_0,v_pos_light_view_1,v_depth);\n#endif\n#ifdef FOG\ncolor=fog_dither(fog_apply_from_vert(color,v_fog_opacity));\n#endif\ngl_FragColor=color;\n#ifdef TERRAIN_WIREFRAME\ngl_FragColor=vec4(1.0,0.0,0.0,0.8);\n#endif\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform float u_skirt_height;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos0;\n#ifdef FOG\nvarying float v_fog_opacity;\n#endif\n#ifdef RENDER_SHADOWS\nuniform mat4 u_light_matrix_0;uniform mat4 u_light_matrix_1;varying vec4 v_pos_light_view_0;varying vec4 v_pos_light_view_1;varying float v_depth;\n#endif\nconst float skirtOffset=24575.0;const float wireframeOffset=0.00015;void main() {v_pos0=a_texture_pos/8192.0;float skirt=float(a_pos.x >=skirtOffset);float elevation=elevation(a_texture_pos)-skirt*u_skirt_height;\n#ifdef TERRAIN_WIREFRAME\nelevation+=u_skirt_height*u_skirt_height*wireframeOffset;\n#endif\nvec2 decodedPos=a_pos-vec2(skirt*skirtOffset,0.0);gl_Position=u_matrix*vec4(decodedPos,elevation,1.0);\n#ifdef FOG\nv_fog_opacity=fog(fog_position(vec3(decodedPos,elevation)));\n#endif\n#ifdef RENDER_SHADOWS\nvec3 pos=vec3(decodedPos,elevation);v_pos_light_view_0=u_light_matrix_0*vec4(pos,1.);v_pos_light_view_1=u_light_matrix_1*vec4(pos,1.);v_depth=gl_Position.w;\n#endif\n}"),
            terrainDepth: pi("#ifdef GL_ES\nprecision highp float;\n#endif\nvarying float v_depth;void main() {gl_FragColor=pack_depth(v_depth);}", "uniform mat4 u_matrix;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying float v_depth;void main() {float elevation=elevation(a_texture_pos);gl_Position=u_matrix*vec4(a_pos,elevation,1.0);v_depth=gl_Position.z/gl_Position.w;}"),
            skybox: pi("\nvarying lowp vec3 v_uv;uniform lowp samplerCube u_cubemap;uniform lowp float u_opacity;uniform highp float u_temporal_offset;uniform highp vec3 u_sun_direction;float sun_disk(highp vec3 ray_direction,highp vec3 sun_direction) {highp float cos_angle=dot(normalize(ray_direction),sun_direction);const highp float cos_sun_angular_diameter=0.99996192306;const highp float smoothstep_delta=1e-5;return smoothstep(\ncos_sun_angular_diameter-smoothstep_delta,cos_sun_angular_diameter+smoothstep_delta,cos_angle);}float map(float value,float start,float end,float new_start,float new_end) {return ((value-start)*(new_end-new_start))/(end-start)+new_start;}void main() {vec3 uv=v_uv;const float y_bias=0.015;uv.y+=y_bias;uv.y=pow(abs(uv.y),1.0/5.0);uv.y=map(uv.y,0.0,1.0,-1.0,1.0);vec3 sky_color=textureCube(u_cubemap,uv).rgb;\n#ifdef FOG\nsky_color=fog_apply_sky_gradient(v_uv.xzy,sky_color);\n#endif\nsky_color.rgb=dither(sky_color.rgb,gl_FragCoord.xy+u_temporal_offset);sky_color+=0.1*sun_disk(v_uv,u_sun_direction);gl_FragColor=vec4(sky_color*u_opacity,u_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", ii),
            skyboxGradient: pi("varying highp vec3 v_uv;uniform lowp sampler2D u_color_ramp;uniform highp vec3 u_center_direction;uniform lowp float u_radius;uniform lowp float u_opacity;uniform highp float u_temporal_offset;void main() {float progress=acos(dot(normalize(v_uv),u_center_direction))/u_radius;vec4 color=texture2D(u_color_ramp,vec2(progress,0.5));\n#ifdef FOG\ncolor.rgb=fog_apply_sky_gradient(v_uv.xzy,color.rgb/color.a)*color.a;\n#endif\ncolor*=u_opacity;color.rgb=dither(color.rgb,gl_FragCoord.xy+u_temporal_offset);gl_FragColor=color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", ii),
            skyboxCapture: pi("\nvarying highp vec3 v_position;uniform highp float u_sun_intensity;uniform highp float u_luminance;uniform lowp vec3 u_sun_direction;uniform highp vec4 u_color_tint_r;uniform highp vec4 u_color_tint_m;\n#ifdef GL_ES\nprecision highp float;\n#endif\n#define BETA_R                  vec3(5.5e-6,13.0e-6,22.4e-6)\n#define BETA_M                  vec3(21e-6,21e-6,21e-6)\n#define MIE_G                   0.76\n#define DENSITY_HEIGHT_SCALE_R  8000.0\n#define DENSITY_HEIGHT_SCALE_M  1200.0\n#define PLANET_RADIUS           6360e3\n#define ATMOSPHERE_RADIUS       6420e3\n#define SAMPLE_STEPS            10\n#define DENSITY_STEPS           4\nfloat ray_sphere_exit(vec3 orig,vec3 dir,float radius) {float a=dot(dir,dir);float b=2.0*dot(dir,orig);float c=dot(orig,orig)-radius*radius;float d=sqrt(b*b-4.0*a*c);return (-b+d)/(2.0*a);}vec3 extinction(vec2 density) {return exp(-vec3(BETA_R*u_color_tint_r.a*density.x+BETA_M*u_color_tint_m.a*density.y));}vec2 local_density(vec3 point) {float height=max(length(point)-PLANET_RADIUS,0.0);float exp_r=exp(-height/DENSITY_HEIGHT_SCALE_R);float exp_m=exp(-height/DENSITY_HEIGHT_SCALE_M);return vec2(exp_r,exp_m);}float phase_ray(float cos_angle) {return (3.0/(16.0*PI))*(1.0+cos_angle*cos_angle);}float phase_mie(float cos_angle) {return (3.0/(8.0*PI))*((1.0-MIE_G*MIE_G)*(1.0+cos_angle*cos_angle))/((2.0+MIE_G*MIE_G)*pow(1.0+MIE_G*MIE_G-2.0*MIE_G*cos_angle,1.5));}vec2 density_to_atmosphere(vec3 point,vec3 light_dir) {float ray_len=ray_sphere_exit(point,light_dir,ATMOSPHERE_RADIUS);float step_len=ray_len/float(DENSITY_STEPS);vec2 density_point_to_atmosphere=vec2(0.0);for (int i=0; i < DENSITY_STEPS;++i) {vec3 point_on_ray=point+light_dir*((float(i)+0.5)*step_len);density_point_to_atmosphere+=local_density(point_on_ray)*step_len;;}return density_point_to_atmosphere;}vec3 atmosphere(vec3 ray_dir,vec3 sun_direction,float sun_intensity) {vec2 density_orig_to_point=vec2(0.0);vec3 scatter_r=vec3(0.0);vec3 scatter_m=vec3(0.0);vec3 origin=vec3(0.0,PLANET_RADIUS,0.0);float ray_len=ray_sphere_exit(origin,ray_dir,ATMOSPHERE_RADIUS);float step_len=ray_len/float(SAMPLE_STEPS);for (int i=0; i < SAMPLE_STEPS;++i) {vec3 point_on_ray=origin+ray_dir*((float(i)+0.5)*step_len);vec2 density=local_density(point_on_ray)*step_len;density_orig_to_point+=density;vec2 density_point_to_atmosphere=density_to_atmosphere(point_on_ray,sun_direction);vec2 density_orig_to_atmosphere=density_orig_to_point+density_point_to_atmosphere;vec3 extinction=extinction(density_orig_to_atmosphere);scatter_r+=density.x*extinction;scatter_m+=density.y*extinction;}float cos_angle=dot(ray_dir,sun_direction);float phase_r=phase_ray(cos_angle);float phase_m=phase_mie(cos_angle);vec3 beta_r=BETA_R*u_color_tint_r.rgb*u_color_tint_r.a;vec3 beta_m=BETA_M*u_color_tint_m.rgb*u_color_tint_m.a;return (scatter_r*phase_r*beta_r+scatter_m*phase_m*beta_m)*sun_intensity;}const float A=0.15;const float B=0.50;const float C=0.10;const float D=0.20;const float E=0.02;const float F=0.30;vec3 uncharted2_tonemap(vec3 x) {return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;}void main() {vec3 ray_direction=v_position;ray_direction.y=pow(ray_direction.y,5.0);const float y_bias=0.015;ray_direction.y+=y_bias;vec3 color=atmosphere(normalize(ray_direction),u_sun_direction,u_sun_intensity);float white_scale=1.0748724675633854;color=uncharted2_tonemap((log2(2.0/pow(u_luminance,4.0)))*color)*white_scale;gl_FragColor=vec4(color,1.0);}", "attribute highp vec3 a_pos_3f;uniform mat3 u_matrix_3f;varying highp vec3 v_position;float map(float value,float start,float end,float new_start,float new_end) {return ((value-start)*(new_end-new_start))/(end-start)+new_start;}void main() {vec4 pos=vec4(u_matrix_3f*a_pos_3f,1.0);v_position=pos.xyz;v_position.y*=-1.0;v_position.y=map(v_position.y,-1.0,1.0,0.0,1.0);gl_Position=vec4(a_pos_3f.xy,0.0,1.0);}"),
            globeRaster: pi("uniform sampler2D u_image0;varying vec2 v_pos0;\n#ifndef FOG\nuniform highp vec3 u_frustum_tl;uniform highp vec3 u_frustum_tr;uniform highp vec3 u_frustum_br;uniform highp vec3 u_frustum_bl;uniform highp vec3 u_globe_pos;uniform highp float u_globe_radius;uniform vec2 u_viewport;\n#endif\nvoid main() {vec4 color;\n#ifdef CUSTOM_ANTIALIASING\nvec2 uv=gl_FragCoord.xy/u_viewport;highp vec3 ray_dir=mix(\nmix(u_frustum_tl,u_frustum_tr,uv.x),mix(u_frustum_bl,u_frustum_br,uv.x),1.0-uv.y);vec3 dir=normalize(ray_dir);vec3 closest_point=dot(u_globe_pos,dir)*dir;float norm_dist_from_center=1.0-length(closest_point-u_globe_pos)/u_globe_radius;const float antialias_pixel=2.0;float antialias_factor=antialias_pixel*fwidth(norm_dist_from_center);float antialias=smoothstep(0.0,antialias_factor,norm_dist_from_center);vec4 raster=texture2D(u_image0,v_pos0);color=vec4(raster.rgb*antialias,raster.a*antialias);\n#else\ncolor=texture2D(u_image0,v_pos0);\n#endif\n#ifdef FOG\ncolor=fog_dither(fog_apply_premultiplied(color,v_fog_pos));\n#endif\ngl_FragColor=color;\n#ifdef TERRAIN_WIREFRAME\ngl_FragColor=vec4(1.0,0.0,0.0,0.8);\n#endif\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_proj_matrix;uniform mat4 u_normalize_matrix;uniform mat4 u_globe_matrix;uniform mat4 u_merc_matrix;uniform float u_zoom_transition;uniform vec2 u_merc_center;uniform mat3 u_grid_matrix;\n#ifdef GLOBE_POLES\nattribute vec3 a_globe_pos;attribute vec2 a_uv;\n#else\nattribute vec2 a_pos;\n#endif\nvarying vec2 v_pos0;const float wireframeOffset=1e3;float mercatorXfromLng(float lng) {return (180.0+lng)/360.0;}float mercatorYfromLat(float lat) {return (180.0-(RAD_TO_DEG*log(tan(QUARTER_PI+lat/2.0*DEG_TO_RAD))))/360.0;}vec3 latLngToECEF(vec2 latLng) {latLng=DEG_TO_RAD*latLng;float cosLat=cos(latLng[0]);float sinLat=sin(latLng[0]);float cosLng=cos(latLng[1]);float sinLng=sin(latLng[1]);float sx=cosLat*sinLng*GLOBE_RADIUS;float sy=-sinLat*GLOBE_RADIUS;float sz=cosLat*cosLng*GLOBE_RADIUS;return vec3(sx,sy,sz);}void main() {\n#ifdef GLOBE_POLES\nvec3 globe_pos=a_globe_pos;vec2 uv=a_uv;\n#else\nfloat tiles=u_grid_matrix[0][2];float idx=u_grid_matrix[1][2];float idy=u_grid_matrix[2][2];vec3 latLng=u_grid_matrix*vec3(a_pos,1.0);float mercatorY=mercatorYfromLat(latLng[0]);float uvY=mercatorY*tiles-idy;float mercatorX=mercatorXfromLng(latLng[1]);float uvX=mercatorX*tiles-idx;vec3 globe_pos=latLngToECEF(latLng.xy);vec2 merc_pos=vec2(mercatorX,mercatorY);vec2 uv=vec2(uvX,uvY);\n#endif\nv_pos0=uv;vec2 tile_pos=uv*EXTENT;\n#ifdef GLOBE_POLES\nvec3 up_vector=normalize(globe_pos)*u_tile_up_scale;\n#else\nvec3 up_vector=elevationVector(tile_pos);\n#endif\nfloat height=elevation(tile_pos);\n#ifdef TERRAIN_WIREFRAME\nheight+=wireframeOffset;\n#endif\nglobe_pos+=up_vector*height;\n#ifdef GLOBE_POLES\nvec4 interpolated_pos=u_globe_matrix*vec4(globe_pos,1.0);\n#else\nvec4 globe_world_pos=u_globe_matrix*vec4(globe_pos,1.0);vec4 merc_world_pos=vec4(0.0);if (u_zoom_transition > 0.0) {merc_world_pos=vec4(merc_pos,height,1.0);merc_world_pos.xy-=u_merc_center;merc_world_pos.x=wrap(merc_world_pos.x,-0.5,0.5);merc_world_pos=u_merc_matrix*merc_world_pos;}vec4 interpolated_pos=vec4(mix(globe_world_pos.xyz,merc_world_pos.xyz,u_zoom_transition),1.0);\n#endif\ngl_Position=u_proj_matrix*interpolated_pos;\n#ifdef FOG\nv_fog_pos=fog_position((u_normalize_matrix*vec4(globe_pos,1.0)).xyz);\n#endif\n}"),
            globeAtmosphere: pi("uniform float u_transition;uniform highp float u_fadeout_range;uniform highp float u_temporal_offset;uniform vec3 u_start_color;uniform vec4 u_color;uniform vec4 u_space_color;uniform vec4 u_high_color;uniform float u_star_intensity;uniform float u_star_size;uniform float u_star_density;uniform float u_horizon_angle;uniform mat4 u_rotation_matrix;varying highp vec3 v_ray_dir;varying highp vec3 v_horizon_dir;highp float random(highp vec3 p) {p=fract(p*vec3(23.2342,97.1231,91.2342));p+=dot(p.zxy,p.yxz+123.1234);return fract(p.x*p.y);}float stars(vec3 p,float scale,vec2 offset) {vec2 uv_scale=(u_viewport/u_star_size)*scale;vec3 position=vec3(p.xy*uv_scale+offset*u_viewport,p.z);vec3 q=fract(position)-0.5;vec3 id=floor(position);float random_visibility=step(random(id),u_star_density);float circle=smoothstep(0.5+u_star_intensity,0.5,length(q));return circle*random_visibility;}void main() {highp vec3 dir=normalize(v_ray_dir);float globe_pos_dot_dir;\n#ifdef PROJECTION_GLOBE_VIEW\nglobe_pos_dot_dir=dot(u_globe_pos,dir);highp vec3 closest_point_forward=abs(globe_pos_dot_dir)*dir;float norm_dist_from_center=length(closest_point_forward-u_globe_pos)/u_globe_radius;if (norm_dist_from_center < 0.98) {discard;return;}\n#endif\nhighp vec3 horizon_dir=normalize(v_horizon_dir);float horizon_angle_mercator=dir.y < horizon_dir.y ?\n0.0 : max(acos(dot(dir,horizon_dir)),0.0);float horizon_angle;\n#ifdef PROJECTION_GLOBE_VIEW\nhighp vec3 closest_point=globe_pos_dot_dir*dir;float closest_point_to_center=length(closest_point-u_globe_pos);float theta=asin(clamp(closest_point_to_center/length(u_globe_pos),-1.0,1.0));horizon_angle=globe_pos_dot_dir < 0.0 ?\nPI-theta-u_horizon_angle : theta-u_horizon_angle;float angle_t=pow(u_transition,10.0);horizon_angle=mix(horizon_angle,horizon_angle_mercator,angle_t);\n#else\nhorizon_angle=horizon_angle_mercator;\n#endif\nhorizon_angle/=PI;float t=exp(-horizon_angle/u_fadeout_range);float alpha_0=u_color.a;float alpha_1=u_high_color.a;float alpha_2=u_space_color.a;vec3 color_stop_0=u_color.rgb;vec3 color_stop_1=u_high_color.rgb;vec3 color_stop_2=u_space_color.rgb;vec3 c0=mix(color_stop_2,color_stop_1,alpha_1);vec3 c1=mix(c0,color_stop_0,alpha_0);vec3 c2=mix(c0,c1,t);vec3 c =mix(color_stop_2,c2,t);float a0=mix(alpha_2,1.0,alpha_1);float a1=mix(a0,1.0,alpha_0);float a2=mix(a0,a1,t);float a =mix(alpha_2,a2,t);vec2 uv=gl_FragCoord.xy/u_viewport-0.5;float aspect_ratio=u_viewport.x/u_viewport.y;vec4 uv_dir=vec4(normalize(vec3(uv.x*aspect_ratio,uv.y,1.0)),1.0);uv_dir=u_rotation_matrix*uv_dir;vec3 n=abs(uv_dir.xyz);vec2 uv_remap=(n.x > n.y && n.x > n.z) ? uv_dir.yz/uv_dir.x:\n(n.y > n.x && n.y > n.z) ? uv_dir.zx/uv_dir.y:\nuv_dir.xy/uv_dir.z;uv_remap.x/=aspect_ratio;vec3 D=vec3(uv_remap,1.0);highp float star_field=0.0;if (u_star_intensity > 0.0) {star_field+=stars(D,1.2,vec2(0.0,0.0));star_field+=stars(D,1.0,vec2(1.0,0.0));star_field+=stars(D,0.8,vec2(0.0,1.0));star_field+=stars(D,0.6,vec2(1.0,1.0));star_field*=(1.0-pow(t,0.25+(1.0-u_high_color.a)*0.75));c+=star_field*alpha_2;}c=dither(c,gl_FragCoord.xy+u_temporal_offset);gl_FragColor=vec4(c,a);}", "attribute vec3 a_pos;attribute vec2 a_uv;uniform vec3 u_frustum_tl;uniform vec3 u_frustum_tr;uniform vec3 u_frustum_br;uniform vec3 u_frustum_bl;uniform float u_horizon;varying highp vec3 v_ray_dir;varying highp vec3 v_horizon_dir;void main() {v_ray_dir=mix(\nmix(u_frustum_tl,u_frustum_tr,a_uv.x),mix(u_frustum_bl,u_frustum_br,a_uv.x),a_uv.y);v_horizon_dir=mix(\nmix(u_frustum_tl,u_frustum_bl,u_horizon),mix(u_frustum_tr,u_frustum_br,u_horizon),a_uv.x);gl_Position=vec4(a_pos,1.0);}")
        };
        function di(e1, t1) {
            const i = e1.replace(/\s*\/\/[^\n]*\n/g, "\n").split("\n");
            for (let e2 of i)if (e2 = e2.trim(), "#" === e2[0] && e2.includes("if") && !e2.includes("endif")) {
                e2 = e2.replace("#", "").replace(/ifdef|ifndef|elif|if/g, "").replace(/!|defined|\(|\)|\|\||&&/g, "").replace(/\s+/g, " ").trim();
                const i1 = e2.split(" ");
                for (const e3 of i1)t1.includes(e3) || t1.push(e3);
            }
        }
        function pi(e1, t1) {
            const i = /#pragma mapbox: ([\w]+) ([\w]+) ([\w]+) ([\w]+)/g, o = t1.match(/attribute (highp |mediump |lowp )?([\w]+) ([\w]+)/g), r = {}, n = [
                ...li
            ];
            return di(e1, n), di(t1, n), {
                fragmentSource: e1 = e1.replace(i, (e1, t1, i, o, n)=>(r[n] = !0, "define" === t1 ? `\n#ifndef HAS_UNIFORM_u_${n}\nvarying ${i} ${o} ${n};\n#else\nuniform ${i} ${o} u_${n};\n#endif\n` : `\n#ifdef HAS_UNIFORM_u_${n}\n    ${i} ${o} ${n} = u_${n};\n#endif\n`)),
                vertexSource: t1 = t1.replace(i, (e1, t1, i, o, n)=>{
                    const a = "float" === o ? "vec2" : "vec4", s = n.match(/color/) ? "color" : a;
                    return r[n] ? "define" === t1 ? `\n#ifndef HAS_UNIFORM_u_${n}\nuniform lowp float u_${n}_t;\nattribute ${i} ${a} a_${n};\nvarying ${i} ${o} ${n};\n#else\nuniform ${i} ${o} u_${n};\n#endif\n` : "vec4" === s ? `\n#ifndef HAS_UNIFORM_u_${n}\n    ${n} = a_${n};\n#else\n    ${i} ${o} ${n} = u_${n};\n#endif\n` : `\n#ifndef HAS_UNIFORM_u_${n}\n    ${n} = unpack_mix_${s}(a_${n}, u_${n}_t);\n#else\n    ${i} ${o} ${n} = u_${n};\n#endif\n` : "define" === t1 ? `\n#ifndef HAS_UNIFORM_u_${n}\nuniform lowp float u_${n}_t;\nattribute ${i} ${a} a_${n};\n#else\nuniform ${i} ${o} u_${n};\n#endif\n` : "vec4" === s ? `\n#ifndef HAS_UNIFORM_u_${n}\n    ${i} ${o} ${n} = a_${n};\n#else\n    ${i} ${o} ${n} = u_${n};\n#endif\n` : `\n#ifndef HAS_UNIFORM_u_${n}\n    ${i} ${o} ${n} = unpack_mix_${s}(a_${n}, u_${n}_t);\n#else\n    ${i} ${o} ${n} = u_${n};\n#endif\n`;
                }),
                staticAttributes: o,
                usedDefines: n
            };
        }
        class mi {
            constructor(){
                this.boundProgram = null, this.boundLayoutVertexBuffer = null, this.boundPaintVertexBuffers = [], this.boundIndexBuffer = null, this.boundVertexOffset = null, this.boundDynamicVertexBuffers = [], this.vao = null;
            }
            bind(e1, t1, i, o, r, n, a) {
                this.context = e1;
                let s = this.boundPaintVertexBuffers.length !== o.length;
                for(let e2 = 0; !s && e2 < o.length; e2++)this.boundPaintVertexBuffers[e2] !== o[e2] && (s = !0);
                let l = this.boundDynamicVertexBuffers.length !== a.length;
                for(let e3 = 0; !l && e3 < a.length; e3++)this.boundDynamicVertexBuffers[e3] !== a[e3] && (l = !0);
                if (!e1.extVertexArrayObject || !this.vao || this.boundProgram !== t1 || this.boundLayoutVertexBuffer !== i || s || l || this.boundIndexBuffer !== r || this.boundVertexOffset !== n) this.freshBind(t1, i, o, r, n, a);
                else {
                    e1.bindVertexArrayOES.set(this.vao);
                    for (const e4 of a)e4 && e4.bind();
                    r && r.dynamicDraw && r.bind();
                }
            }
            freshBind(e1, t1, i, o, r, n) {
                let a;
                const s = e1.numAttributes, l = this.context, c = l.gl;
                if (l.extVertexArrayObject) this.vao && this.destroy(), this.vao = l.extVertexArrayObject.createVertexArrayOES(), l.bindVertexArrayOES.set(this.vao), a = 0, this.boundProgram = e1, this.boundLayoutVertexBuffer = t1, this.boundPaintVertexBuffers = i, this.boundIndexBuffer = o, this.boundVertexOffset = r, this.boundDynamicVertexBuffers = n;
                else {
                    a = l.currentNumAttributes || 0;
                    for(let e2 = s; e2 < a; e2++)c.disableVertexAttribArray(e2);
                }
                t1.enableAttributes(c, e1), t1.bind(), t1.setVertexAttribPointers(c, e1, r);
                for (const t2 of i)t2.enableAttributes(c, e1), t2.bind(), t2.setVertexAttribPointers(c, e1, r);
                for (const t3 of n)t3 && (t3.enableAttributes(c, e1), t3.bind(), t3.setVertexAttribPointers(c, e1, r));
                o && o.bind(), l.currentNumAttributes = s;
            }
            destroy() {
                this.vao && (this.context.extVertexArrayObject.deleteVertexArrayOES(this.vao), this.vao = null);
            }
        }
        function fi(t1, i) {
            const o = Math.pow(2, i.canonical.z), r = i.canonical.y;
            return [
                new e1.MercatorCoordinate(0, r / o).toLngLat().lat,
                new e1.MercatorCoordinate(0, (r + 1) / o).toLngLat().lat
            ];
        }
        function gi(t1, i, o, r, n, a, s) {
            const l = t1.context, c = l.gl, h = o.fbo;
            if (!h) return;
            t1.prepareDrawTile();
            const _ = t1.useProgram("hillshade");
            l.activeTexture.set(c.TEXTURE0), c.bindTexture(c.TEXTURE_2D, h.colorAttachment.get());
            const u = ((e1, t1, i, o)=>{
                const r = i.paint.get("hillshade-shadow-color"), n = i.paint.get("hillshade-highlight-color"), a = i.paint.get("hillshade-accent-color");
                let s = i.paint.get("hillshade-illumination-direction") * (Math.PI / 180);
                "viewport" === i.paint.get("hillshade-illumination-anchor") && (s -= e1.transform.angle);
                const l = !e1.options.moving;
                return {
                    u_matrix: o || e1.transform.calculateProjMatrix(t1.tileID.toUnwrapped(), l),
                    u_image: 0,
                    u_latrange: fi(0, t1.tileID),
                    u_light: [
                        i.paint.get("hillshade-exaggeration"),
                        s
                    ],
                    u_shadow: r,
                    u_highlight: n,
                    u_accent: a
                };
            })(t1, o, r, t1.terrain ? i.projMatrix : null);
            t1.prepareDrawProgram(l, _, i.toUnwrapped());
            const { tileBoundsBuffer: d , tileBoundsIndexBuffer: p , tileBoundsSegments: m  } = t1.getTileBoundsBuffers(o);
            _.draw(l, c.TRIANGLES, n, a, s, e1.CullFaceMode.disabled, u, r.id, d, p, m);
        }
        function vi(t1, i, o) {
            if (!i.needsDEMTextureUpload) return;
            const r = t1.context, n = r.gl;
            r.pixelStoreUnpackPremultiplyAlpha.set(!1), i.demTexture = i.demTexture || t1.getTileTexture(o.stride);
            const a = o.getPixels();
            i.demTexture ? i.demTexture.update(a, {
                premultiply: !1
            }) : i.demTexture = new e1.Texture(r, a, n.RGBA, {
                premultiply: !1
            }), i.needsDEMTextureUpload = !1;
        }
        function xi(t1, i, o, r, n, a) {
            const s = t1.context, l = s.gl;
            if (!i.dem) return;
            const c = i.dem;
            if (s.activeTexture.set(l.TEXTURE1), vi(t1, i, c), !i.demTexture) return;
            i.demTexture.bind(l.NEAREST, l.CLAMP_TO_EDGE);
            const h = c.dim;
            s.activeTexture.set(l.TEXTURE0);
            let _ = i.fbo;
            if (!_) {
                const t2 = new e1.Texture(s, {
                    width: h,
                    height: h,
                    data: null
                }, l.RGBA);
                t2.bind(l.LINEAR, l.CLAMP_TO_EDGE), _ = i.fbo = s.createFramebuffer(h, h, !0), _.colorAttachment.set(t2.texture);
            }
            s.bindFramebuffer.set(_.framebuffer), s.viewport.set([
                0,
                0,
                h,
                h
            ]);
            const { tileBoundsBuffer: u , tileBoundsIndexBuffer: d , tileBoundsSegments: p  } = t1.getMercatorTileBoundsBuffers();
            t1.useProgram("hillshadePrepare").draw(s, l.TRIANGLES, r, n, a, e1.CullFaceMode.disabled, ((t1, i)=>{
                const o = i.stride, r = e1.create();
                return e1.ortho(r, 0, e1.EXTENT, -e1.EXTENT, 0, 0, 1), e1.translate(r, r, [
                    0,
                    -e1.EXTENT,
                    0
                ]), {
                    u_matrix: r,
                    u_image: 1,
                    u_dimension: [
                        o,
                        o
                    ],
                    u_zoom: t1.overscaledZ,
                    u_unpack: i.unpackVector
                };
            })(i.tileID, c), o.id, u, d, p), i.needsHillshadePrepare = !1;
        }
        const yi = (t1)=>({
                u_matrix: new e1.UniformMatrix4f(t1),
                u_image0: new e1.Uniform1i(t1),
                u_skirt_height: new e1.Uniform1f(t1)
            }), bi = (e1, t1)=>({
                u_matrix: e1,
                u_image0: 0,
                u_skirt_height: t1
            }), wi = (e1, t1, i, o, r, n, a, s, l, c, h, _, u, d)=>({
                u_proj_matrix: Float32Array.from(e1),
                u_globe_matrix: t1,
                u_normalize_matrix: Float32Array.from(o),
                u_merc_matrix: i,
                u_zoom_transition: r,
                u_merc_center: n,
                u_image0: 0,
                u_frustum_tl: a,
                u_frustum_tr: s,
                u_frustum_br: l,
                u_frustum_bl: c,
                u_globe_pos: h,
                u_globe_radius: _,
                u_viewport: u,
                u_grid_matrix: d ? Float32Array.from(d) : new Float32Array(9)
            });
        function Ti(e1, t1) {
            return null != e1 && null != t1 && !(!e1.hasData() || !t1.hasData()) && null != e1.demTexture && null != t1.demTexture && e1.tileID.key !== t1.tileID.key;
        }
        const Ei = new class {
            constructor(){
                this.operations = {};
            }
            newMorphing(e1, t1, i, o, r) {
                if (e1 in this.operations) {
                    const t2 = this.operations[e1];
                    t2.to.tileID.key !== i.tileID.key && (t2.queued = i);
                } else this.operations[e1] = {
                    startTime: o,
                    phase: 0,
                    duration: r,
                    from: t1,
                    to: i,
                    queued: null
                };
            }
            getMorphValuesForProxy(e1) {
                if (!(e1 in this.operations)) return null;
                const t1 = this.operations[e1];
                return {
                    from: t1.from,
                    to: t1.to,
                    phase: t1.phase
                };
            }
            update(e1) {
                for(const t1 in this.operations){
                    const i = this.operations[t1];
                    for(i.phase = (e1 - i.startTime) / i.duration; i.phase >= 1 || !this._validOp(i);)if (!this._nextOp(i, e1)) {
                        delete this.operations[t1];
                        break;
                    }
                }
            }
            _nextOp(e1, t1) {
                return !!e1.queued && (e1.from = e1.to, e1.to = e1.queued, e1.queued = null, e1.phase = 0, e1.startTime = t1, !0);
            }
            _validOp(e1) {
                return e1.from.hasData() && e1.to.hasData();
            }
        }, Ci = {
            0: null,
            1: "TERRAIN_VERTEX_MORPHING",
            2: "TERRAIN_WIREFRAME"
        };
        function Ii(e1, t1) {
            const i = 1 << e1.z;
            return !t1 && (0 === e1.x || e1.x === i - 1) || 0 === e1.y || e1.y === i - 1;
        }
        const Mi = (e1)=>({
                u_matrix: e1
            });
        function Si(t1, i, o, r, n) {
            if (n > 0) {
                const a = e1.exported.now(), s = (a - t1.timeAdded) / n, l = i ? (a - i.timeAdded) / n : -1, c = o.getSource(), h = r.coveringZoomLevel({
                    tileSize: c.tileSize,
                    roundZoom: c.roundZoom
                }), _ = !i || Math.abs(i.tileID.overscaledZ - h) > Math.abs(t1.tileID.overscaledZ - h), u = _ && t1.refreshedUponExpiration ? 1 : e1.clamp(_ ? s : 1 - l, 0, 1);
                return t1.refreshedUponExpiration && s >= 1 && (t1.refreshedUponExpiration = !1), i ? {
                    opacity: 1,
                    mix: 1 - u
                } : {
                    opacity: u,
                    mix: 0
                };
            }
            return {
                opacity: 1,
                mix: 0
            };
        }
        class zi extends e1.SourceCache {
            constructor(e1){
                const t1 = {
                    type: "raster-dem",
                    maxzoom: e1.transform.maxZoom
                }, i = new P(Ge(), null), o = Pe("mock-dem", t1, i, e1.style);
                super("mock-dem", o, !1), o.setEventedParent(this), this._sourceLoaded = !0;
            }
            _loadTile(e1, t1) {
                e1.state = "loaded", t1(null);
            }
        }
        class Di extends e1.SourceCache {
            constructor(e1){
                const t1 = Pe("proxy", {
                    type: "geojson",
                    maxzoom: e1.transform.maxZoom
                }, new P(Ge(), null), e1.style);
                super("proxy", t1, !1), t1.setEventedParent(this), this.map = this.getSource().map = e1, this.used = this._sourceLoaded = !0, this.renderCache = [], this.renderCachePool = [], this.proxyCachedFBO = {};
            }
            update(t1, i, o) {
                if (t1.freezeTileCoverage) return;
                this.transform = t1;
                const r = t1.coveringTiles({
                    tileSize: this._source.tileSize,
                    minzoom: this._source.minzoom,
                    maxzoom: this._source.maxzoom,
                    roundZoom: this._source.roundZoom,
                    reparseOverscaled: this._source.reparseOverscaled
                }).reduce((i, o)=>{
                    if (i[o.key] = "", !this._tiles[o.key]) {
                        const i1 = new e1.Tile(o, this._source.tileSize * o.overscaleFactor(), t1.tileZoom);
                        i1.state = "loaded", this._tiles[o.key] = i1;
                    }
                    return i;
                }, {});
                for(const e2 in this._tiles)e2 in r || (this.freeFBO(e2), this._tiles[e2].unloadVectorData(), delete this._tiles[e2]);
            }
            freeFBO(e1) {
                const t1 = this.proxyCachedFBO[e1];
                if (void 0 !== t1) {
                    const i = Object.values(t1);
                    this.renderCachePool.push(...i), delete this.proxyCachedFBO[e1];
                }
            }
            deallocRenderCache() {
                this.renderCache.forEach((e1)=>e1.fb.destroy()), this.renderCache = [], this.renderCachePool = [], this.proxyCachedFBO = {};
            }
        }
        class Ai extends e1.OverscaledTileID {
            constructor(e1, t1, i){
                super(e1.overscaledZ, e1.wrap, e1.canonical.z, e1.canonical.x, e1.canonical.y), this.proxyTileKey = t1, this.projMatrix = i;
            }
        }
        class Pi extends e1.Elevation {
            constructor(t1, i){
                super(), this.painter = t1, this.terrainTileForTile = {}, this.prevTerrainTileForTile = {};
                const [o, r, n] = function(t1) {
                    const i = new e1.StructArrayLayout4i8, o = new e1.StructArrayLayout3ui6, r = 131;
                    i.reserve(17161), o.reserve(33800);
                    const n = e1.EXTENT / 128, a = e1.EXTENT + n / 2, s = a + n;
                    for(let t2 = -n; t2 < s; t2 += n)for(let o1 = -n; o1 < s; o1 += n){
                        const r1 = o1 < 0 || o1 > a || t2 < 0 || t2 > a ? 24575 : 0, n1 = e1.clamp(Math.round(o1), 0, e1.EXTENT), s1 = e1.clamp(Math.round(t2), 0, e1.EXTENT);
                        i.emplaceBack(n1 + r1, s1, n1, s1);
                    }
                    const l = (e1, t1)=>{
                        const i = t1 * r + e1;
                        o.emplaceBack(i + 1, i, i + r), o.emplaceBack(i + r, i + r + 1, i + 1);
                    };
                    for(let e2 = 1; e2 < 129; e2++)for(let t3 = 1; t3 < 129; t3++)l(t3, e2);
                    return [
                        0,
                        129
                    ].forEach((e1)=>{
                        for(let t1 = 0; t1 < 130; t1++)l(t1, e1), l(e1, t1);
                    }), [
                        i,
                        o,
                        32768
                    ];
                }(), a = t1.context;
                this.gridBuffer = a.createVertexBuffer(o, e1.boundsAttributes.members), this.gridIndexBuffer = a.createIndexBuffer(r), this.gridSegments = e1.SegmentVector.simpleSegment(0, 0, o.length, r.length), this.gridNoSkirtSegments = e1.SegmentVector.simpleSegment(0, 0, o.length, n), this.proxyCoords = [], this.proxiedCoords = {}, this._visibleDemTiles = [], this._drapedRenderBatches = [], this._sourceTilesOverlap = {}, this.proxySourceCache = new Di(i.map), this.orthoMatrix = e1.create(), e1.ortho(this.orthoMatrix, "globe" === this.painter.transform.projection.name ? .015 : 0, e1.EXTENT, 0, e1.EXTENT, 0, 1);
                const s = a.gl;
                this._overlapStencilMode = new e1.StencilMode({
                    func: s.GEQUAL,
                    mask: 255
                }, 0, 255, s.KEEP, s.KEEP, s.REPLACE), this._previousZoom = t1.transform.zoom, this.pool = [], this._findCoveringTileCache = {}, this._tilesDirty = {}, this.style = i, this._useVertexMorphing = !0, this._exaggeration = 1, this._mockSourceCache = new zi(i.map);
            }
            set style(e1) {
                e1.on("data", this._onStyleDataEvent.bind(this)), e1.on("neworder", this._checkRenderCacheEfficiency.bind(this)), this._style = e1, this._checkRenderCacheEfficiency();
            }
            update(t1, i, o) {
                if (t1 && t1.terrain) {
                    this._style !== t1 && (this.style = t1), this.enabled = !0;
                    const r = t1.terrain.properties;
                    this.sourceCache = 0 === t1.terrain.drapeRenderMode ? this._mockSourceCache : t1._getSourceCache(r.get("source")), this._exaggeration = r.get("exaggeration");
                    const n = ()=>{
                        this.sourceCache.used && e1.warnOnce(`Raster DEM source '${this.sourceCache.id}' is used both for terrain and as layer source.\nThis leads to lower resolution of hillshade. For full hillshade resolution but higher memory consumption, define another raster DEM source.`);
                        const t1 = this.getScaledDemTileSize();
                        this.sourceCache.update(i, t1, !0), this.resetTileLookupCache(this.sourceCache.id);
                    };
                    this.sourceCache.usedForTerrain || (this.resetTileLookupCache(this.sourceCache.id), this.sourceCache.usedForTerrain = !0, n(), this._initializing = !0), n(), i.updateElevation(!o), this.resetTileLookupCache(this.proxySourceCache.id), this.proxySourceCache.update(i), this._emptyDEMTextureDirty = !0;
                } else this._disable();
            }
            resetTileLookupCache(e1) {
                this._findCoveringTileCache[e1] = {};
            }
            getScaledDemTileSize() {
                return this.sourceCache.getSource().tileSize / 128 * this.proxySourceCache.getSource().tileSize;
            }
            _checkRenderCacheEfficiency() {
                const t1 = this.renderCacheEfficiency(this._style);
                this._style.map._optimizeForTerrain || 100 !== t1.efficiency && e1.warnOnce(`Terrain render cache efficiency is not optimal (${t1.efficiency}%) and performance\n                may be affected negatively, consider placing all background, fill and line layers before layer\n                with id '${t1.firstUndrapedLayer}' or create a map using optimizeForTerrain: true option.`);
            }
            _onStyleDataEvent(e1) {
                e1.coord && "source" === e1.dataType ? this._clearRenderCacheForTile(e1.sourceCacheId, e1.coord) : "style" === e1.dataType && (this._invalidateRenderCache = !0);
            }
            _disable() {
                if (this.enabled && (this.enabled = !1, this._sharedDepthStencil = void 0, this.proxySourceCache.deallocRenderCache(), this._style)) for(const e1 in this._style._sourceCaches)this._style._sourceCaches[e1].usedForTerrain = !1;
            }
            destroy() {
                this._disable(), this._emptyDEMTexture && this._emptyDEMTexture.destroy(), this._emptyDepthBufferTexture && this._emptyDepthBufferTexture.destroy(), this.pool.forEach((e1)=>e1.fb.destroy()), this.pool = [], this._depthFBO && (this._depthFBO.destroy(), this._depthFBO = void 0, this._depthTexture = void 0);
            }
            _source() {
                return this.enabled ? this.sourceCache : null;
            }
            isUsingMockSource() {
                return this.sourceCache === this._mockSourceCache;
            }
            exaggeration() {
                return this._exaggeration;
            }
            get visibleDemTiles() {
                return this._visibleDemTiles;
            }
            get drapeBufferSize() {
                const e1 = 2 * this.proxySourceCache.getSource().tileSize;
                return [
                    e1,
                    e1
                ];
            }
            set useVertexMorphing(e1) {
                this._useVertexMorphing = e1;
            }
            updateTileBinding(t1) {
                if (!this.enabled) return;
                this.prevTerrainTileForTile = this.terrainTileForTile;
                const i = this.proxySourceCache, o = this.painter.transform;
                this._initializing && (this._initializing = 0 === o._centerAltitude && -1 === this.getAtPointOrZero(e1.MercatorCoordinate.fromLngLat(o.center), -1), this._emptyDEMTextureDirty = !this._initializing);
                const r = this.proxyCoords = i.getIds().map((e1)=>{
                    const t1 = i.getTileByID(e1).tileID;
                    return t1.projMatrix = o.calculateProjMatrix(t1.toUnwrapped()), t1;
                });
                !function(t1, i) {
                    const o = i.transform.pointCoordinate(i.transform.getCameraPoint()), r = new e1.pointGeometry(o.x, o.y);
                    t1.sort((t1, i)=>{
                        if (i.overscaledZ - t1.overscaledZ) return i.overscaledZ - t1.overscaledZ;
                        const o = new e1.pointGeometry(t1.canonical.x + (1 << t1.canonical.z) * t1.wrap, t1.canonical.y), n = new e1.pointGeometry(i.canonical.x + (1 << i.canonical.z) * i.wrap, i.canonical.y), a = r.mult(1 << t1.canonical.z);
                        return a.x -= .5, a.y -= .5, a.distSqr(o) - a.distSqr(n);
                    });
                }(r, this.painter), this._previousZoom = o.zoom;
                const n = this.proxyToSource || {};
                this.proxyToSource = {}, r.forEach((e1)=>{
                    this.proxyToSource[e1.key] = {};
                }), this.terrainTileForTile = {};
                const a = this._style._sourceCaches;
                for(const e2 in a){
                    const i1 = a[e2];
                    if (!i1.used) continue;
                    if (i1 !== this.sourceCache && this.resetTileLookupCache(i1.id), this._setupProxiedCoordsForOrtho(i1, t1[e2], n), i1.usedForTerrain) continue;
                    const o1 = t1[e2];
                    i1.getSource().reparseOverscaled && this._assignTerrainTiles(o1);
                }
                this.proxiedCoords[i.id] = r.map((e1)=>new Ai(e1, e1.key, this.orthoMatrix)), this._assignTerrainTiles(r), this._prepareDEMTextures(), this._setupDrapedRenderBatches(), this._initFBOPool(), this._setupRenderCache(n), this.renderingToTexture = !1, this._updateTimestamp = e1.exported.now();
                const s = {};
                this._visibleDemTiles = [];
                for (const e3 of this.proxyCoords){
                    const t2 = this.terrainTileForTile[e3.key];
                    if (!t2) continue;
                    const i2 = t2.tileID.key;
                    i2 in s || (this._visibleDemTiles.push(t2), s[i2] = i2);
                }
            }
            _assignTerrainTiles(e1) {
                this._initializing || e1.forEach((e1)=>{
                    if (this.terrainTileForTile[e1.key]) return;
                    const t1 = this._findTileCoveringTileID(e1, this.sourceCache);
                    t1 && (this.terrainTileForTile[e1.key] = t1);
                });
            }
            _prepareDEMTextures() {
                const e1 = this.painter.context, t1 = e1.gl;
                for(const i in this.terrainTileForTile){
                    const o = this.terrainTileForTile[i], r = o.dem;
                    !r || o.demTexture && !o.needsDEMTextureUpload || (e1.activeTexture.set(t1.TEXTURE1), vi(this.painter, o, r));
                }
            }
            _prepareDemTileUniforms(e1, t1, i, o) {
                if (!t1 || null == t1.demTexture) return !1;
                const r = e1.tileID.canonical, n = Math.pow(2, t1.tileID.canonical.z - r.z), a = o || "";
                return i[`u_dem_tl${a}`] = [
                    r.x * n % 1,
                    r.y * n % 1
                ], i[`u_dem_scale${a}`] = n, !0;
            }
            get emptyDEMTexture() {
                return !this._emptyDEMTextureDirty && this._emptyDEMTexture ? this._emptyDEMTexture : this._updateEmptyDEMTexture();
            }
            get emptyDepthBufferTexture() {
                const t1 = this.painter.context, i = t1.gl;
                if (!this._emptyDepthBufferTexture) {
                    const o = new e1.RGBAImage({
                        width: 1,
                        height: 1
                    }, Uint8Array.of(255, 255, 255, 255));
                    this._emptyDepthBufferTexture = new e1.Texture(t1, o, i.RGBA, {
                        premultiply: !1
                    });
                }
                return this._emptyDepthBufferTexture;
            }
            _getLoadedAreaMinimum() {
                let e1 = 0;
                const t1 = this._visibleDemTiles.reduce((t1, i)=>{
                    if (!i.dem) return t1;
                    const o = i.dem.tree.minimums[0];
                    return o > 0 && e1++, t1 + o;
                }, 0);
                return e1 ? t1 / e1 : 0;
            }
            _updateEmptyDEMTexture() {
                const t1 = this.painter.context, i = t1.gl;
                t1.activeTexture.set(i.TEXTURE2);
                const o = this._getLoadedAreaMinimum(), r = new e1.RGBAImage({
                    width: 1,
                    height: 1
                }, new Uint8Array(e1.DEMData.pack(o, this.sourceCache.getSource().encoding)));
                this._emptyDEMTextureDirty = !1;
                let n = this._emptyDEMTexture;
                return n ? n.update(r, {
                    premultiply: !1
                }) : n = this._emptyDEMTexture = new e1.Texture(t1, r, i.RGBA, {
                    premultiply: !1
                }), n;
            }
            setupElevationDraw(t1, i, o) {
                const r = this.painter.context, n = r.gl, a = (s = this.sourceCache.getSource().encoding, {
                    u_dem: 2,
                    u_dem_prev: 4,
                    u_dem_unpack: e1.DEMData.getUnpackVector(s),
                    u_dem_tl: [
                        0,
                        0
                    ],
                    u_dem_tl_prev: [
                        0,
                        0
                    ],
                    u_dem_scale: 0,
                    u_dem_scale_prev: 0,
                    u_dem_size: 0,
                    u_dem_lerp: 1,
                    u_depth: 3,
                    u_depth_size_inv: [
                        0,
                        0
                    ],
                    u_exaggeration: 0
                });
                var s;
                a.u_dem_size = this.sourceCache.getSource().tileSize, a.u_exaggeration = this.exaggeration();
                let l = null, c = null, h = 1;
                if (o && o.morphing && this._useVertexMorphing) {
                    const e2 = o.morphing.srcDemTile, i1 = o.morphing.dstDemTile;
                    h = o.morphing.phase, e2 && i1 && (this._prepareDemTileUniforms(t1, e2, a, "_prev") && (c = e2), this._prepareDemTileUniforms(t1, i1, a) && (l = i1));
                }
                if (c && l ? (r.activeTexture.set(n.TEXTURE2), l.demTexture.bind(n.NEAREST, n.CLAMP_TO_EDGE, n.NEAREST), r.activeTexture.set(n.TEXTURE4), c.demTexture.bind(n.NEAREST, n.CLAMP_TO_EDGE, n.NEAREST), a.u_dem_lerp = h) : (l = this.terrainTileForTile[t1.tileID.key], r.activeTexture.set(n.TEXTURE2), (this._prepareDemTileUniforms(t1, l, a) ? l.demTexture : this.emptyDEMTexture).bind(n.NEAREST, n.CLAMP_TO_EDGE)), r.activeTexture.set(n.TEXTURE3), o && o.useDepthForOcclusion ? (this._depthTexture && this._depthTexture.bind(n.NEAREST, n.CLAMP_TO_EDGE), this._depthFBO && (a.u_depth_size_inv = [
                    1 / this._depthFBO.width,
                    1 / this._depthFBO.height
                ])) : (this.emptyDepthBufferTexture.bind(n.NEAREST, n.CLAMP_TO_EDGE), a.u_depth_size_inv = [
                    1,
                    1
                ]), o && o.useMeterToDem && l) {
                    const t2 = (1 << l.tileID.canonical.z) * e1.mercatorZfromAltitude(1, this.painter.transform.center.lat) * this.sourceCache.getSource().tileSize;
                    a.u_meter_to_dem = t2;
                }
                if (o && o.labelPlaneMatrixInv && (a.u_label_plane_matrix_inv = o.labelPlaneMatrixInv), i.setTerrainUniformValues(r, a), "globe" === this.painter.transform.projection.name) {
                    const e3 = this.globeUniformValues(this.painter.transform, t1.tileID.canonical, o && o.useDenormalizedUpVectorScale);
                    i.setGlobeUniformValues(r, e3);
                }
            }
            globeUniformValues(t1, i, o) {
                const r = t1.projection;
                return {
                    u_tile_tl_up: r.upVector(i, 0, 0),
                    u_tile_tr_up: r.upVector(i, e1.EXTENT, 0),
                    u_tile_br_up: r.upVector(i, e1.EXTENT, e1.EXTENT),
                    u_tile_bl_up: r.upVector(i, 0, e1.EXTENT),
                    u_tile_up_scale: o ? e1.GLOBE_METERS_TO_ECEF : r.upVectorScale(i, t1.center.lat, t1.worldSize).metersToTile
                };
            }
            renderToBackBuffer(t1) {
                const i = this.painter, o = this.painter.context;
                0 !== t1.length && (o.bindFramebuffer.set(null), o.viewport.set([
                    0,
                    0,
                    i.width,
                    i.height
                ]), i.gpuTimingDeferredRenderStart(), this.renderingToTexture = !1, function(t1, i, o, r, n) {
                    if ("globe" === t1.transform.projection.name) !function(t1, i, o, r, n) {
                        const a = t1.context, s = a.gl;
                        let l, c;
                        const h = t1.options.showTerrainWireframe ? 2 : 0, _ = t1.transform, u = e1.globeUseCustomAntiAliasing(t1, a, _), d = (e1, i)=>{
                            if (c === e1) return;
                            const o = [
                                Ci[e1],
                                "PROJECTION_GLOBE_VIEW"
                            ];
                            u && o.push("CUSTOM_ANTIALIASING"), i && o.push(Ci[h]), l = t1.useProgram("globeRaster", null, o), c = e1;
                        }, p = t1.colorModeForRenderPass(), m = new e1.DepthMode(s.LEQUAL, e1.DepthMode.ReadWrite, t1.depthRangeFor3D);
                        Ei.update(n);
                        const f = e1.calculateGlobeMercatorMatrix(_), g = [
                            e1.mercatorXfromLng(_.center.lng),
                            e1.mercatorYfromLat(_.center.lat)
                        ], v = h ? [
                            !1,
                            !0
                        ] : [
                            !1
                        ], x = t1.globeSharedBuffers, y = [
                            _.width * e1.exported.devicePixelRatio,
                            _.height * e1.exported.devicePixelRatio
                        ], b = Float32Array.from(_.globeMatrix), w = {
                            useDenormalizedUpVectorScale: !0
                        };
                        if (v.forEach((h)=>{
                            c = -1;
                            const u = h ? s.LINES : s.TRIANGLES;
                            for (const c1 of r){
                                const r1 = o.getTile(c1), v = e1.StencilMode.disabled, T = i.prevTerrainTileForTile[c1.key], E = i.terrainTileForTile[c1.key];
                                Ti(T, E) && Ei.newMorphing(c1.key, T, E, n, 250), a.activeTexture.set(s.TEXTURE0), r1.texture.bind(s.LINEAR, s.CLAMP_TO_EDGE);
                                const C = Ei.getMorphValuesForProxy(c1.key), I = C ? 1 : 0;
                                C && e1.extend$1(w, {
                                    morphing: {
                                        srcDemTile: C.from,
                                        dstDemTile: C.to,
                                        phase: e1.easeCubicInOut(C.phase)
                                    }
                                });
                                const M = e1.tileCornersToBounds(c1.canonical), S = e1.getLatitudinalLod(M.getCenter().lat), z = e1.getGridMatrix(c1.canonical, M, S, _.worldSize / _._pixelsPerMercatorPixel), D = e1.globeNormalizeECEF(e1.globeTileBounds(c1.canonical)), A = wi(_.projMatrix, b, f, D, e1.globeToMercatorTransition(_.zoom), g, _.frustumCorners.TL, _.frustumCorners.TR, _.frustumCorners.BR, _.frustumCorners.BL, _.globeCenterInViewSpace, _.globeRadius, y, z);
                                if (d(I, h), i.setupElevationDraw(r1, l, w), t1.prepareDrawProgram(a, l, c1.toUnwrapped()), x) {
                                    const [i1, o1, r2] = h ? x.getWirefameBuffers(t1.context, S) : x.getGridBuffers(S);
                                    l.draw(a, u, m, v, p, e1.CullFaceMode.backCCW, A, "globe_raster", i1, o1, r2);
                                }
                            }
                        }), x) {
                            const n1 = [
                                "GLOBE_POLES",
                                "PROJECTION_GLOBE_VIEW"
                            ];
                            u && n1.push("CUSTOM_ANTIALIASING"), l = t1.useProgram("globeRaster", null, n1);
                            for (const n2 of r){
                                const { x: r1 , y: c1 , z: h1  } = n2.canonical, u1 = 0 === c1, d1 = c1 === (1 << h1) - 1, [f1, v1, b1, T] = x.getPoleBuffers(h1);
                                if (T && (u1 || d1)) {
                                    const c2 = o.getTile(n2);
                                    a.activeTexture.set(s.TEXTURE0), c2.texture.bind(s.LINEAR, s.CLAMP_TO_EDGE);
                                    let x1 = e1.globePoleMatrixForTile(h1, r1, _);
                                    const E = e1.globeNormalizeECEF(e1.globeTileBounds(n2.canonical)), C = (t1, i)=>t1.draw(a, s.TRIANGLES, m, e1.StencilMode.disabled, p, e1.CullFaceMode.disabled, wi(_.projMatrix, x1, x1, E, 0, g, _.frustumCorners.TL, _.frustumCorners.TR, _.frustumCorners.BR, _.frustumCorners.BL, _.globeCenterInViewSpace, _.globeRadius, y), "globe_pole_raster", i, b1, T);
                                    i.setupElevationDraw(c2, l, w), t1.prepareDrawProgram(a, l, n2.toUnwrapped()), u1 && C(l, f1), d1 && (x1 = e1.scale(e1.create(), x1, [
                                        1,
                                        -1,
                                        1
                                    ]), C(l, v1));
                                }
                            }
                        }
                    }(t1, i, o, r, n);
                    else {
                        const a = t1.context, s = a.gl;
                        let l, c;
                        const h = t1.options.showTerrainWireframe ? 2 : 0, _ = (e1, i)=>{
                            if (c === e1) return;
                            const o = [
                                Ci[e1]
                            ];
                            i && o.push(Ci[h]), l = t1.useProgram("terrainRaster", null, o), c = e1;
                        }, u = t1.colorModeForRenderPass(), d = new e1.DepthMode(s.LEQUAL, e1.DepthMode.ReadWrite, t1.depthRangeFor3D);
                        Ei.update(n);
                        const p = t1.transform, m = 6 * Math.pow(1.5, 22 - p.zoom) * i.exaggeration();
                        (h ? [
                            !1,
                            !0
                        ] : [
                            !1
                        ]).forEach((h)=>{
                            c = -1;
                            const f = h ? s.LINES : s.TRIANGLES, [g, v] = h ? i.getWirefameBuffer() : [
                                i.gridIndexBuffer,
                                i.gridSegments
                            ];
                            for (const c1 of r){
                                const r1 = o.getTile(c1), x = e1.StencilMode.disabled, y = i.prevTerrainTileForTile[c1.key], b = i.terrainTileForTile[c1.key];
                                Ti(y, b) && Ei.newMorphing(c1.key, y, b, n, 250), a.activeTexture.set(s.TEXTURE0), r1.texture.bind(s.LINEAR, s.CLAMP_TO_EDGE, s.LINEAR_MIPMAP_NEAREST);
                                const w = Ei.getMorphValuesForProxy(c1.key), T = w ? 1 : 0;
                                let E;
                                w && (E = {
                                    morphing: {
                                        srcDemTile: w.from,
                                        dstDemTile: w.to,
                                        phase: e1.easeCubicInOut(w.phase)
                                    }
                                });
                                const C = bi(c1.projMatrix, Ii(c1.canonical, p.renderWorldCopies) ? m / 10 : m);
                                _(T, h), i.setupElevationDraw(r1, l, E), t1.prepareDrawProgram(a, l, c1.toUnwrapped()), l.draw(a, f, d, x, u, e1.CullFaceMode.backCCW, C, "terrain_raster", i.gridBuffer, g, v);
                            }
                        });
                    }
                }(i, this, this.proxySourceCache, t1, this._updateTimestamp), this.renderingToTexture = !0, i.gpuTimingDeferredRenderEnd(), t1.splice(0, t1.length));
            }
            renderBatch(t1) {
                if (0 === this._drapedRenderBatches.length) return t1 + 1;
                this.renderingToTexture = !0;
                const i = this.painter, o = this.painter.context, r = this.proxySourceCache, n = this.proxiedCoords[r.id], a = this._drapedRenderBatches.shift(), s = [], l = i.style.order;
                let c = 0;
                for (const h of n){
                    const n1 = r.getTileByID(h.proxyTileKey), _ = r.proxyCachedFBO[h.key] ? r.proxyCachedFBO[h.key][t1] : void 0, u = void 0 !== _ ? r.renderCache[_] : this.pool[c++], d = void 0 !== _;
                    if (n1.texture = u.tex, d && !u.dirty) {
                        s.push(n1.tileID);
                        continue;
                    }
                    let p;
                    o.bindFramebuffer.set(u.fb.framebuffer), this.renderedToTile = !1, u.dirty && (o.clear({
                        color: e1.Color.transparent,
                        stencil: 0
                    }), u.dirty = !1);
                    for(let e2 = a.start; e2 <= a.end; ++e2){
                        const t2 = i.style._layers[l[e2]];
                        if (t2.isHidden(i.transform.zoom)) continue;
                        const r1 = i.style._getLayerSourceCache(t2), n2 = r1 ? this.proxyToSource[h.key][r1.id] : [
                            h
                        ];
                        if (!n2) continue;
                        const a1 = n2;
                        o.viewport.set([
                            0,
                            0,
                            u.fb.width,
                            u.fb.height
                        ]), p !== (r1 ? r1.id : null) && (this._setupStencil(u, n2, t2, r1), p = r1 ? r1.id : null), i.renderLayer(i, r1, t2, a1);
                    }
                    this.renderedToTile ? (u.dirty = !0, s.push(n1.tileID)) : d || --c, 5 === c && (c = 0, this.renderToBackBuffer(s));
                }
                return this.renderToBackBuffer(s), this.renderingToTexture = !1, o.bindFramebuffer.set(null), o.viewport.set([
                    0,
                    0,
                    i.width,
                    i.height
                ]), a.end + 1;
            }
            postRender() {}
            renderCacheEfficiency(e1) {
                const t1 = e1.order.length;
                if (0 === t1) return {
                    efficiency: 100
                };
                let i, o = 0, r = 0, n = !1;
                for(let a = 0; a < t1; ++a){
                    const t2 = e1._layers[e1.order[a]];
                    this._style.isLayerDraped(t2) ? (n && ++o, ++r) : n || (n = !0, i = t2.id);
                }
                return 0 === r ? {
                    efficiency: 100
                } : {
                    efficiency: 100 * (1 - o / r),
                    firstUndrapedLayer: i
                };
            }
            getMinElevationBelowMSL() {
                let e1 = 0;
                return this._visibleDemTiles.filter((e1)=>e1.dem).forEach((t1)=>{
                    e1 = Math.min(e1, t1.dem.tree.minimums[0]);
                }), 0 === e1 ? e1 : (e1 - 30) * this._exaggeration;
            }
            raycast(e1, t1, i) {
                if (!this._visibleDemTiles) return null;
                const o = this._visibleDemTiles.filter((e1)=>e1.dem).map((o)=>{
                    const r = o.tileID, n = 1 << r.overscaledZ, { x: a , y: s  } = r.canonical, l = a / n, c = (a + 1) / n, h = s / n, _ = (s + 1) / n;
                    return {
                        minx: l,
                        miny: h,
                        maxx: c,
                        maxy: _,
                        t: o.dem.tree.raycastRoot(l, h, c, _, e1, t1, i),
                        tile: o
                    };
                });
                o.sort((e1, t1)=>(null !== e1.t ? e1.t : Number.MAX_VALUE) - (null !== t1.t ? t1.t : Number.MAX_VALUE));
                for (const r of o){
                    if (null == r.t) return null;
                    const o1 = r.tile.dem.tree.raycast(r.minx, r.miny, r.maxx, r.maxy, e1, t1, i);
                    if (null != o1) return o1;
                }
                return null;
            }
            _createFBO() {
                const t1 = this.painter.context, i = t1.gl, o = this.drapeBufferSize;
                t1.activeTexture.set(i.TEXTURE0);
                const r = new e1.Texture(t1, {
                    width: o[0],
                    height: o[1],
                    data: null
                }, i.RGBA);
                r.bind(i.LINEAR, i.CLAMP_TO_EDGE);
                const n = t1.createFramebuffer(o[0], o[1], !1);
                return n.colorAttachment.set(r.texture), n.depthAttachment = new Ee(t1, n.framebuffer), void 0 === this._sharedDepthStencil ? (this._sharedDepthStencil = t1.createRenderbuffer(t1.gl.DEPTH_STENCIL, o[0], o[1]), this._stencilRef = 0, n.depthAttachment.set(this._sharedDepthStencil), t1.clear({
                    stencil: 0
                })) : n.depthAttachment.set(this._sharedDepthStencil), t1.extTextureFilterAnisotropic && !t1.extTextureFilterAnisotropicForceOff && i.texParameterf(i.TEXTURE_2D, t1.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT, t1.extTextureFilterAnisotropicMax), {
                    fb: n,
                    tex: r,
                    dirty: !1
                };
            }
            _initFBOPool() {
                for(; this.pool.length < Math.min(5, this.proxyCoords.length);)this.pool.push(this._createFBO());
            }
            _shouldDisableRenderCache() {
                if (this._style.light && this._style.light.hasTransition()) return !0;
                for(const e1 in this._style._sourceCaches)if (this._style._sourceCaches[e1].hasTransition()) return !0;
                return this._style.order.some((e1)=>{
                    const t1 = this._style._layers[e1], i = t1.isHidden(this.painter.transform.zoom), o = t1.getCrossfadeParameters(), r = !!o && 1 !== o.t, n = t1.hasTransition();
                    return "custom" !== t1.type && !i && (r || n);
                });
            }
            _clearRasterFadeFromRenderCache() {
                let e1 = !1;
                for(const t1 in this._style._sourceCaches)if (this._style._sourceCaches[t1]._source instanceof Me) {
                    e1 = !0;
                    break;
                }
                if (e1) for(let e2 = 0; e2 < this._style.order.length; ++e2){
                    const t2 = this._style._layers[this._style.order[e2]], i = t2.isHidden(this.painter.transform.zoom), o = this._style._getLayerSourceCache(t2);
                    if ("raster" !== t2.type || i || !o) continue;
                    const r = t2.paint.get("raster-fade-duration");
                    for (const e3 of this.proxyCoords){
                        const t3 = this.proxyToSource[e3.key][o.id];
                        if (t3) for (const e4 of t3){
                            const t4 = Si(o.getTile(e4), o.findLoadedParent(e4, 0), o, this.painter.transform, r);
                            (1 !== t4.opacity || 0 !== t4.mix) && this._clearRenderCacheForTile(o.id, e4);
                        }
                    }
                }
            }
            _setupDrapedRenderBatches() {
                const e1 = this._style.order, t1 = e1.length;
                if (0 === t1) return;
                const i = [];
                let o, r = 0, n = this._style._layers[e1[r]];
                for(; !this._style.isLayerDraped(n) && n.isHidden(this.painter.transform.zoom) && ++r < t1;)n = this._style._layers[e1[r]];
                for(; r < t1; ++r){
                    const t2 = this._style._layers[e1[r]];
                    t2.isHidden(this.painter.transform.zoom) || (this._style.isLayerDraped(t2) ? void 0 === o && (o = r) : void 0 !== o && (i.push({
                        start: o,
                        end: r - 1
                    }), o = void 0));
                }
                void 0 !== o && i.push({
                    start: o,
                    end: r - 1
                }), this._drapedRenderBatches = i;
            }
            _setupRenderCache(e1) {
                const t1 = this.proxySourceCache;
                if (this._shouldDisableRenderCache() || this._invalidateRenderCache) {
                    if (this._invalidateRenderCache = !1, t1.renderCache.length > t1.renderCachePool.length) {
                        const e2 = Object.values(t1.proxyCachedFBO);
                        t1.proxyCachedFBO = {};
                        for(let i = 0; i < e2.length; ++i){
                            const o = Object.values(e2[i]);
                            t1.renderCachePool.push(...o);
                        }
                    }
                    return;
                }
                this._clearRasterFadeFromRenderCache();
                const i1 = this.proxyCoords, o1 = this._tilesDirty;
                for(let r = i1.length - 1; r >= 0; r--){
                    const n = i1[r];
                    if (t1.getTileByID(n.key), void 0 !== t1.proxyCachedFBO[n.key]) {
                        const i2 = e1[n.key], r1 = this.proxyToSource[n.key];
                        let a = 0;
                        for(const e3 in r1){
                            const t2 = r1[e3], n1 = i2[e3];
                            if (!n1 || n1.length !== t2.length || t2.some((t1, i)=>t1 !== n1[i] || o1[e3] && o1[e3].hasOwnProperty(t1.key))) {
                                a = -1;
                                break;
                            }
                            ++a;
                        }
                        for(const e4 in t1.proxyCachedFBO[n.key])t1.renderCache[t1.proxyCachedFBO[n.key][e4]].dirty = a < 0 || a !== Object.values(i2).length;
                    }
                }
                const r2 = [
                    ...this._drapedRenderBatches
                ];
                r2.sort((e1, t1)=>t1.end - t1.start - (e1.end - e1.start));
                for (const e5 of r2)for (const o2 of i1){
                    if (t1.proxyCachedFBO[o2.key]) continue;
                    let i3 = t1.renderCachePool.pop();
                    void 0 === i3 && t1.renderCache.length < 50 && (i3 = t1.renderCache.length, t1.renderCache.push(this._createFBO())), void 0 !== i3 && (t1.proxyCachedFBO[o2.key] = {}, t1.proxyCachedFBO[o2.key][e5.start] = i3, t1.renderCache[i3].dirty = !0);
                }
                this._tilesDirty = {};
            }
            _setupStencil(e1, t1, i, o) {
                if (!o || !this._sourceTilesOverlap[o.id]) return void (this._overlapStencilType && (this._overlapStencilType = !1));
                const r = this.painter.context, n = r.gl;
                if (t1.length <= 1) return void (this._overlapStencilType = !1);
                let a;
                if (i.isTileClipped()) a = t1.length, this._overlapStencilMode.test = {
                    func: n.EQUAL,
                    mask: 255
                }, this._overlapStencilType = "Clip";
                else {
                    if (!(t1[0].overscaledZ > t1[t1.length - 1].overscaledZ)) return void (this._overlapStencilType = !1);
                    a = 1, this._overlapStencilMode.test = {
                        func: n.GREATER,
                        mask: 255
                    }, this._overlapStencilType = "Mask";
                }
                this._stencilRef + a > 255 && (r.clear({
                    stencil: 0
                }), this._stencilRef = 0), this._stencilRef += a, this._overlapStencilMode.ref = this._stencilRef, i.isTileClipped() && this._renderTileClippingMasks(t1, this._overlapStencilMode.ref);
            }
            clipOrMaskOverlapStencilType() {
                return "Clip" === this._overlapStencilType || "Mask" === this._overlapStencilType;
            }
            stencilModeForRTTOverlap(t1) {
                return this.renderingToTexture && this._overlapStencilType ? ("Clip" === this._overlapStencilType && (this._overlapStencilMode.ref = this.painter._tileClippingMaskIDs[t1.key]), this._overlapStencilMode) : e1.StencilMode.disabled;
            }
            _renderTileClippingMasks(t1, i) {
                const o = this.painter, r = this.painter.context, n = r.gl;
                o._tileClippingMaskIDs = {}, r.setColorMode(e1.ColorMode.disabled), r.setDepthMode(e1.DepthMode.disabled);
                const a = o.useProgram("clippingMask");
                for (const s of t1){
                    const t2 = o._tileClippingMaskIDs[s.key] = --i;
                    a.draw(r, n.TRIANGLES, e1.DepthMode.disabled, new e1.StencilMode({
                        func: n.ALWAYS,
                        mask: 0
                    }, t2, 255, n.KEEP, n.KEEP, n.REPLACE), e1.ColorMode.disabled, e1.CullFaceMode.disabled, Mi(s.projMatrix), "$clipping", o.tileExtentBuffer, o.quadTriangleIndexBuffer, o.tileExtentSegments);
                }
            }
            pointCoordinate(t1) {
                const i = this.painter.transform;
                if (t1.x < 0 || t1.x > i.width || t1.y < 0 || t1.y > i.height) return null;
                const o = [
                    t1.x,
                    t1.y,
                    1,
                    1
                ];
                e1.transformMat4$1(o, o, i.pixelMatrixInverse), e1.scale$1(o, o, 1 / o[3]), o[0] /= i.worldSize, o[1] /= i.worldSize;
                const r = i._camera.position, n = e1.mercatorZfromAltitude(1, i.center.lat), a = [
                    r[0],
                    r[1],
                    r[2] / n,
                    0
                ], s = e1.subtract([], o.slice(0, 3), a);
                e1.normalize(s, s);
                const l = this.raycast(a, s, this._exaggeration);
                return null !== l && l ? (e1.scaleAndAdd(a, a, s, l), a[3] = a[2], a[2] *= n, a) : null;
            }
            drawDepth() {
                const t1 = this.painter, i = t1.context, o = this.proxySourceCache, r = Math.ceil(t1.width), n = Math.ceil(t1.height);
                if (!this._depthFBO || this._depthFBO.width === r && this._depthFBO.height === n || (this._depthFBO.destroy(), this._depthFBO = void 0, this._depthTexture = void 0), !this._depthFBO) {
                    const t2 = i.gl, o1 = i.createFramebuffer(r, n, !0);
                    i.activeTexture.set(t2.TEXTURE0);
                    const a = new e1.Texture(i, {
                        width: r,
                        height: n,
                        data: null
                    }, t2.RGBA);
                    a.bind(t2.NEAREST, t2.CLAMP_TO_EDGE), o1.colorAttachment.set(a.texture);
                    const s = i.createRenderbuffer(i.gl.DEPTH_COMPONENT16, r, n);
                    o1.depthAttachment.set(s), this._depthFBO = o1, this._depthTexture = a;
                }
                i.bindFramebuffer.set(this._depthFBO.framebuffer), i.viewport.set([
                    0,
                    0,
                    r,
                    n
                ]), function(t1, i, o, r) {
                    if ("globe" === t1.transform.projection.name) return;
                    const n = t1.context, a = n.gl;
                    n.clear({
                        depth: 1
                    });
                    const s = t1.useProgram("terrainDepth"), l = new e1.DepthMode(a.LESS, e1.DepthMode.ReadWrite, t1.depthRangeFor3D);
                    for (const t2 of r){
                        const r1 = o.getTile(t2), c = bi(t2.projMatrix, 0);
                        i.setupElevationDraw(r1, s), s.draw(n, a.TRIANGLES, l, e1.StencilMode.disabled, e1.ColorMode.unblended, e1.CullFaceMode.backCCW, c, "terrain_depth", i.gridBuffer, i.gridIndexBuffer, i.gridNoSkirtSegments);
                    }
                }(t1, this, o, this.proxyCoords);
            }
            _setupProxiedCoordsForOrtho(e1, t1, i) {
                if (e1.getSource() instanceof De) return this._setupProxiedCoordsForImageSource(e1, t1, i);
                this._findCoveringTileCache[e1.id] = this._findCoveringTileCache[e1.id] || {};
                const o = this.proxiedCoords[e1.id] = [], r = this.proxyCoords;
                for(let t2 = 0; t2 < r.length; t2++){
                    const n = r[t2], a = this._findTileCoveringTileID(n, e1);
                    if (a) {
                        const t3 = this._createProxiedId(n, a, i[n.key] && i[n.key][e1.id]);
                        o.push(t3), this.proxyToSource[n.key][e1.id] = [
                            t3
                        ];
                    }
                }
                let n1 = !1;
                for(let r1 = 0; r1 < t1.length; r1++){
                    const a1 = e1.getTile(t1[r1]);
                    if (!a1 || !a1.hasData()) continue;
                    const s = this._findTileCoveringTileID(a1.tileID, this.proxySourceCache);
                    if (s && s.tileID.canonical.z !== a1.tileID.canonical.z) {
                        const t4 = this.proxyToSource[s.tileID.key][e1.id], r2 = this._createProxiedId(s.tileID, a1, i[s.tileID.key] && i[s.tileID.key][e1.id]);
                        t4 ? t4.splice(t4.length - 1, 0, r2) : this.proxyToSource[s.tileID.key][e1.id] = [
                            r2
                        ], o.push(r2), n1 = !0;
                    }
                }
                this._sourceTilesOverlap[e1.id] = n1;
            }
            _setupProxiedCoordsForImageSource(t1, i, o) {
                if (!t1.getSource().loaded()) return;
                const r = this.proxiedCoords[t1.id] = [], n = this.proxyCoords, a = t1.getSource(), s = new e1.pointGeometry(a.tileID.x, a.tileID.y)._div(1 << a.tileID.z), l = a.coordinates.map(e1.MercatorCoordinate.fromLngLat).reduce((e1, t1)=>(e1.min.x = Math.min(e1.min.x, t1.x - s.x), e1.min.y = Math.min(e1.min.y, t1.y - s.y), e1.max.x = Math.max(e1.max.x, t1.x - s.x), e1.max.y = Math.max(e1.max.y, t1.y - s.y), e1), {
                    min: new e1.pointGeometry(Number.MAX_VALUE, Number.MAX_VALUE),
                    max: new e1.pointGeometry(-Number.MAX_VALUE, -Number.MAX_VALUE)
                }), c = (t1, i)=>{
                    const o = t1.wrap + t1.canonical.x / (1 << t1.canonical.z), r = t1.canonical.y / (1 << t1.canonical.z), n = e1.EXTENT / (1 << t1.canonical.z), a = i.wrap + i.canonical.x / (1 << i.canonical.z), s = i.canonical.y / (1 << i.canonical.z);
                    return o + n < a + l.min.x || o > a + l.max.x || r + n < s + l.min.y || r > s + l.max.y;
                };
                for(let e2 = 0; e2 < n.length; e2++){
                    const a1 = n[e2];
                    for(let e3 = 0; e3 < i.length; e3++){
                        const n1 = t1.getTile(i[e3]);
                        if (!n1 || !n1.hasData()) continue;
                        if (c(a1, n1.tileID)) continue;
                        const s1 = this._createProxiedId(a1, n1, o[a1.key] && o[a1.key][t1.id]), l1 = this.proxyToSource[a1.key][t1.id];
                        l1 ? l1.push(s1) : this.proxyToSource[a1.key][t1.id] = [
                            s1
                        ], r.push(s1);
                    }
                }
            }
            _createProxiedId(t1, i, o) {
                let r = this.orthoMatrix;
                if (o) {
                    const e2 = o.find((e1)=>e1.key === i.tileID.key);
                    if (e2) return e2;
                }
                if (i.tileID.key !== t1.key) {
                    const o1 = t1.canonical.z - i.tileID.canonical.z;
                    let n, a, s;
                    r = e1.create();
                    const l = i.tileID.wrap - t1.wrap << t1.overscaledZ;
                    o1 > 0 ? (n = e1.EXTENT >> o1, a = n * ((i.tileID.canonical.x << o1) - t1.canonical.x + l), s = n * ((i.tileID.canonical.y << o1) - t1.canonical.y)) : (n = e1.EXTENT << -o1, a = e1.EXTENT * (i.tileID.canonical.x - (t1.canonical.x + l << -o1)), s = e1.EXTENT * (i.tileID.canonical.y - (t1.canonical.y << -o1))), e1.ortho(r, 0, n, 0, n, 0, 1), e1.translate(r, r, [
                        a,
                        s,
                        0
                    ]);
                }
                return new Ai(i.tileID, t1.key, r);
            }
            _findTileCoveringTileID(t1, i) {
                let o = i.getTile(t1);
                if (o && o.hasData()) return o;
                const r = this._findCoveringTileCache[i.id], n = r[t1.key];
                if (o = n ? i.getTileByID(n) : null, o && o.hasData() || null === n) return o;
                let a = o ? o.tileID : t1, s = a.overscaledZ;
                const l = i.getSource().minzoom, c = [];
                if (!n) {
                    const r1 = i.getSource().maxzoom;
                    if (t1.canonical.z >= r1) {
                        const o1 = t1.canonical.z - r1;
                        i.getSource().reparseOverscaled ? (s = Math.max(t1.canonical.z + 2, i.transform.tileZoom), a = new e1.OverscaledTileID(s, t1.wrap, r1, t1.canonical.x >> o1, t1.canonical.y >> o1)) : 0 !== o1 && (s = r1, a = new e1.OverscaledTileID(s, t1.wrap, r1, t1.canonical.x >> o1, t1.canonical.y >> o1));
                    }
                    a.key !== t1.key && (c.push(a.key), o = i.getTile(a));
                }
                const h = (e1)=>{
                    c.forEach((t1)=>{
                        r[t1] = e1;
                    }), c.length = 0;
                };
                for(s -= 1; s >= l && (!o || !o.hasData()); s--){
                    o && h(o.tileID.key);
                    const e2 = a.calculateScaledKey(s);
                    if (o = i.getTileByID(e2), o && o.hasData()) break;
                    const t2 = r[e2];
                    if (null === t2) break;
                    void 0 === t2 ? c.push(e2) : o = i.getTileByID(t2);
                }
                return h(o ? o.tileID.key : null), o && o.hasData() ? o : null;
            }
            findDEMTileFor(e1) {
                return this.enabled ? this._findTileCoveringTileID(e1, this.sourceCache) : null;
            }
            prepareDrawTile() {
                this.renderedToTile = !0;
            }
            _clearRenderCacheForTile(e1, t1) {
                let i = this._tilesDirty[e1];
                i || (i = this._tilesDirty[e1] = {}), i[t1.key] = !0;
            }
            getWirefameBuffer() {
                if (!this.wireframeSegments) {
                    const t1 = function(t1) {
                        let i = 0;
                        const o = new e1.StructArrayLayout2ui4, r = 131;
                        for(let e2 = 1; e2 < 129; e2++){
                            for(let t2 = 1; t2 < 129; t2++)i = e2 * r + t2, o.emplaceBack(i, i + 1), o.emplaceBack(i, i + r), o.emplaceBack(i + 1, i + r), 128 === e2 && o.emplaceBack(i + r, i + r + 1);
                            o.emplaceBack(i + 1, i + 1 + r);
                        }
                        return o;
                    }();
                    this.wireframeIndexBuffer = this.painter.context.createIndexBuffer(t1), this.wireframeSegments = e1.SegmentVector.simpleSegment(0, 0, this.gridBuffer.length, t1.length);
                }
                return [
                    this.wireframeIndexBuffer,
                    this.wireframeSegments
                ];
            }
        }
        class Li {
            static cacheKey(e1, t1, i, o) {
                let r = `${t1}${o ? o.cacheKey : ""}`;
                for (const t2 of i)e1.usedDefines.includes(t2) && (r += `/${t2}`);
                return r;
            }
            constructor(t1, i, o, r, n, a){
                const s = t1.gl;
                this.program = s.createProgram();
                const l = function(e1) {
                    const t1 = [];
                    for(let i = 0; i < e1.length; i++){
                        if (null === e1[i]) continue;
                        const o = e1[i].split(" ");
                        t1.push(o.pop());
                    }
                    return t1;
                }(o.staticAttributes), c = r ? r.getBinderAttributes() : [], h = l.concat(c);
                let _ = r ? r.defines() : [];
                _ = _.concat(a.map((e1)=>`#define ${e1}`));
                const u = _.concat(t1.extStandardDerivatives ? "#extension GL_OES_standard_derivatives : enable\n".concat(_i) : _i, _i, hi, ci.fragmentSource, si.fragmentSource, o.fragmentSource).join("\n"), d = _.concat("\n#ifdef GL_ES\nprecision highp float;\n#else\n\n#if !defined(lowp)\n#define lowp\n#endif\n\n#if !defined(mediump)\n#define mediump\n#endif\n\n#if !defined(highp)\n#define highp\n#endif\n\n#endif", hi, ci.vertexSource, si.vertexSource, ai.vertexSource, o.vertexSource).join("\n"), p = s.createShader(s.FRAGMENT_SHADER);
                if (s.isContextLost()) return void (this.failedToCreate = !0);
                s.shaderSource(p, u), s.compileShader(p), s.attachShader(this.program, p);
                const m = s.createShader(s.VERTEX_SHADER);
                if (s.isContextLost()) this.failedToCreate = !0;
                else {
                    s.shaderSource(m, d), s.compileShader(m), s.attachShader(this.program, m), this.attributes = {}, this.numAttributes = h.length;
                    for(let e2 = 0; e2 < this.numAttributes; e2++)h[e2] && (s.bindAttribLocation(this.program, e2, h[e2]), this.attributes[h[e2]] = e2);
                    s.linkProgram(this.program), s.deleteShader(m), s.deleteShader(p), this.fixedUniforms = n(t1), this.binderUniforms = r ? r.getUniforms(t1) : [], a.includes("TERRAIN") && (this.terrainUniforms = ((t1)=>({
                            u_dem: new e1.Uniform1i(t1),
                            u_dem_prev: new e1.Uniform1i(t1),
                            u_dem_unpack: new e1.Uniform4f(t1),
                            u_dem_tl: new e1.Uniform2f(t1),
                            u_dem_scale: new e1.Uniform1f(t1),
                            u_dem_tl_prev: new e1.Uniform2f(t1),
                            u_dem_scale_prev: new e1.Uniform1f(t1),
                            u_dem_size: new e1.Uniform1f(t1),
                            u_dem_lerp: new e1.Uniform1f(t1),
                            u_exaggeration: new e1.Uniform1f(t1),
                            u_depth: new e1.Uniform1i(t1),
                            u_depth_size_inv: new e1.Uniform2f(t1),
                            u_meter_to_dem: new e1.Uniform1f(t1),
                            u_label_plane_matrix_inv: new e1.UniformMatrix4f(t1)
                        }))(t1)), a.includes("GLOBE") && (this.globeUniforms = ((t1)=>({
                            u_tile_tl_up: new e1.Uniform3f(t1),
                            u_tile_tr_up: new e1.Uniform3f(t1),
                            u_tile_br_up: new e1.Uniform3f(t1),
                            u_tile_bl_up: new e1.Uniform3f(t1),
                            u_tile_up_scale: new e1.Uniform1f(t1)
                        }))(t1)), a.includes("FOG") && (this.fogUniforms = ((t1)=>({
                            u_fog_matrix: new e1.UniformMatrix4f(t1),
                            u_fog_range: new e1.Uniform2f(t1),
                            u_fog_color: new e1.Uniform4f(t1),
                            u_fog_horizon_blend: new e1.Uniform1f(t1),
                            u_fog_temporal_offset: new e1.Uniform1f(t1),
                            u_frustum_tl: new e1.Uniform3f(t1),
                            u_frustum_tr: new e1.Uniform3f(t1),
                            u_frustum_br: new e1.Uniform3f(t1),
                            u_frustum_bl: new e1.Uniform3f(t1),
                            u_globe_pos: new e1.Uniform3f(t1),
                            u_globe_radius: new e1.Uniform1f(t1),
                            u_globe_transition: new e1.Uniform1f(t1),
                            u_is_globe: new e1.Uniform1i(t1),
                            u_viewport: new e1.Uniform2f(t1)
                        }))(t1));
                }
            }
            setTerrainUniformValues(e1, t1) {
                if (!this.terrainUniforms) return;
                const i = this.terrainUniforms;
                if (!this.failedToCreate) {
                    e1.program.set(this.program);
                    for(const e2 in t1)i[e2] && i[e2].set(this.program, e2, t1[e2]);
                }
            }
            setGlobeUniformValues(e1, t1) {
                if (!this.globeUniforms) return;
                const i = this.globeUniforms;
                if (!this.failedToCreate) {
                    e1.program.set(this.program);
                    for(const e2 in t1)i[e2] && i[e2].set(this.program, e2, t1[e2]);
                }
            }
            setFogUniformValues(e1, t1) {
                if (!this.fogUniforms) return;
                const i = this.fogUniforms;
                if (!this.failedToCreate) {
                    e1.program.set(this.program);
                    for(const e2 in t1)i[e2].set(this.program, e2, t1[e2]);
                }
            }
            draw(e1, t1, i, o, r, n, a, s, l, c, h, _, u, d, p) {
                const m = e1.gl;
                if (this.failedToCreate) return;
                e1.program.set(this.program), e1.setDepthMode(i), e1.setStencilMode(o), e1.setColorMode(r), e1.setCullFace(n);
                for (const e2 of Object.keys(this.fixedUniforms))this.fixedUniforms[e2].set(this.program, e2, a[e2]);
                d && d.setUniforms(this.program, e1, this.binderUniforms, _, {
                    zoom: u
                });
                const f = {
                    [m.LINES]: 2,
                    [m.TRIANGLES]: 3,
                    [m.LINE_STRIP]: 1
                }[t1];
                for (const i1 of h.get()){
                    const o1 = i1.vaos || (i1.vaos = {});
                    (o1[s] || (o1[s] = new mi)).bind(e1, this, l, d ? d.getPaintVertexBuffers() : [], c, i1.vertexOffset, p || []), m.drawElements(t1, i1.primitiveLength * f, m.UNSIGNED_SHORT, i1.primitiveOffset * f * 2);
                }
            }
        }
        function Ri(e1, t1, i) {
            const o = 1 / L(i, 1, t1.transform.tileZoom), r = Math.pow(2, i.tileID.overscaledZ), n = i.tileSize * Math.pow(2, t1.transform.tileZoom) / r, a = n * (i.tileID.canonical.x + i.tileID.wrap * r), s = n * i.tileID.canonical.y;
            return {
                u_image: 0,
                u_texsize: i.imageAtlasTexture.size,
                u_scale: [
                    o,
                    e1.fromScale,
                    e1.toScale
                ],
                u_fade: e1.t,
                u_pixel_coord_upper: [
                    a >> 16,
                    s >> 16
                ],
                u_pixel_coord_lower: [
                    65535 & a,
                    65535 & s
                ]
            };
        }
        const Oi = e1.create(), Bi = (t1, i, o, r, n, a, s, l, c, h, _)=>{
            const u = i.style.light, d = u.properties.get("position"), p = [
                d.x,
                d.y,
                d.z
            ], m = e1.create$1();
            "viewport" === u.properties.get("anchor") && (e1.fromRotation(m, -i.transform.angle), e1.transformMat3(p, p, m));
            const f = u.properties.get("color"), g = i.transform, v = {
                u_matrix: t1,
                u_lightpos: p,
                u_lightintensity: u.properties.get("intensity"),
                u_lightcolor: [
                    f.r,
                    f.g,
                    f.b
                ],
                u_vertical_gradient: +o,
                u_opacity: r,
                u_tile_id: [
                    0,
                    0,
                    0
                ],
                u_zoom_transition: 0,
                u_inv_rot_matrix: Oi,
                u_merc_center: [
                    0,
                    0
                ],
                u_up_dir: [
                    0,
                    0,
                    0
                ],
                u_height_lift: 0,
                u_ao: n,
                u_edge_radius: a
            };
            return "globe" === g.projection.name && (v.u_tile_id = [
                s.canonical.x,
                s.canonical.y,
                1 << s.canonical.z
            ], v.u_zoom_transition = c, v.u_inv_rot_matrix = _, v.u_merc_center = h, v.u_up_dir = g.projection.upVector(new e1.CanonicalTileID(0, 0, 0), h[0] * e1.EXTENT, h[1] * e1.EXTENT), v.u_height_lift = l), v;
        }, ki = (t1, i, o, r, n, a, s, l, c, h, _, u, d)=>{
            const p = Bi(t1, i, o, r, n, a, s, h, _, u, d), m = {
                u_height_factor: -Math.pow(2, s.overscaledZ) / c.tileSize / 8
            };
            return e1.extend(p, Ri(l, i, c), m);
        }, Fi = (e1)=>({
                u_matrix: e1
            }), Ui = (t1, i, o, r)=>e1.extend(Fi(t1), Ri(o, i, r)), Ni = (e1, t1)=>({
                u_matrix: e1,
                u_world: t1
            }), Gi = (t1, i, o, r, n)=>e1.extend(Ui(t1, i, o, r), {
                u_world: n
            }), ji = e1.create(), Zi = (t1, i, o, r, n, a)=>{
            const s = t1.transform, l = "globe" === s.projection.name;
            let c;
            if ("map" === a.paint.get("circle-pitch-alignment")) {
                if (l) {
                    const t2 = e1.globePixelsToTileUnits(s.zoom, i.canonical) * s._pixelsPerMercatorPixel;
                    c = Float32Array.from([
                        t2,
                        0,
                        0,
                        t2
                    ]);
                } else c = s.calculatePixelsToTileUnitsMatrix(o);
            } else c = new Float32Array([
                s.pixelsToGLUnits[0],
                0,
                0,
                s.pixelsToGLUnits[1]
            ]);
            const h = {
                u_camera_to_center_distance: s.cameraToCenterDistance,
                u_matrix: t1.translatePosMatrix(i.projMatrix, o, a.paint.get("circle-translate"), a.paint.get("circle-translate-anchor")),
                u_device_pixel_ratio: e1.exported.devicePixelRatio,
                u_extrude_scale: c,
                u_inv_rot_matrix: ji,
                u_merc_center: [
                    0,
                    0
                ],
                u_tile_id: [
                    0,
                    0,
                    0
                ],
                u_zoom_transition: 0,
                u_up_dir: [
                    0,
                    0,
                    0
                ]
            };
            if (l) {
                h.u_inv_rot_matrix = r, h.u_merc_center = n, h.u_tile_id = [
                    i.canonical.x,
                    i.canonical.y,
                    1 << i.canonical.z
                ], h.u_zoom_transition = e1.globeToMercatorTransition(s.zoom);
                const t3 = n[0] * e1.EXTENT, o1 = n[1] * e1.EXTENT;
                h.u_up_dir = s.projection.upVector(new e1.CanonicalTileID(0, 0, 0), t3, o1);
            }
            return h;
        }, Vi = (e1)=>{
            const t1 = [];
            return "map" === e1.paint.get("circle-pitch-alignment") && t1.push("PITCH_WITH_MAP"), "map" === e1.paint.get("circle-pitch-scale") && t1.push("SCALE_WITH_MAP"), t1;
        }, Wi = (t1, i, o, r)=>{
            const n = e1.EXTENT / o.tileSize;
            return {
                u_matrix: t1,
                u_camera_to_center_distance: i.getCameraToCenterDistance(r),
                u_extrude_scale: [
                    i.pixelsToGLUnits[0] / n,
                    i.pixelsToGLUnits[1] / n
                ]
            };
        }, Xi = (e1, t1, i = 1)=>({
                u_matrix: e1,
                u_color: t1,
                u_overlay: 0,
                u_overlay_scale: i
            }), qi = e1.create(), $i = (t1, i, o, r, n, a, s)=>{
            const l = t1.transform, c = "globe" === l.projection.name, h = c ? e1.globePixelsToTileUnits(l.zoom, i.canonical) * l._pixelsPerMercatorPixel : L(o, 1, a), _ = {
                u_matrix: i.projMatrix,
                u_extrude_scale: h,
                u_intensity: s,
                u_inv_rot_matrix: qi,
                u_merc_center: [
                    0,
                    0
                ],
                u_tile_id: [
                    0,
                    0,
                    0
                ],
                u_zoom_transition: 0,
                u_up_dir: [
                    0,
                    0,
                    0
                ]
            };
            if (c) {
                _.u_inv_rot_matrix = r, _.u_merc_center = n, _.u_tile_id = [
                    i.canonical.x,
                    i.canonical.y,
                    1 << i.canonical.z
                ], _.u_zoom_transition = e1.globeToMercatorTransition(l.zoom);
                const t2 = n[0] * e1.EXTENT, o1 = n[1] * e1.EXTENT;
                _.u_up_dir = l.projection.upVector(new e1.CanonicalTileID(0, 0, 0), t2, o1);
            }
            return _;
        }, Hi = (e1, t1, i, o, r, n, a, s)=>{
            const l = e1.transform, c = l.calculatePixelsToTileUnitsMatrix(t1), h = {
                u_matrix: Ji(e1, t1, i, r),
                u_pixels_to_tile_units: c,
                u_device_pixel_ratio: a,
                u_units_to_pixels: [
                    1 / l.pixelsToGLUnits[0],
                    1 / l.pixelsToGLUnits[1]
                ],
                u_dash_image: 0,
                u_gradient_image: 1,
                u_image_height: n,
                u_texsize: [
                    0,
                    0
                ],
                u_scale: [
                    0,
                    0,
                    0
                ],
                u_mix: 0,
                u_alpha_discard_threshold: 0,
                u_trim_offset: s
            };
            if (Qi(i)) {
                const i1 = Ki(t1, e1.transform);
                h.u_texsize = t1.lineAtlasTexture.size, h.u_scale = [
                    i1,
                    o.fromScale,
                    o.toScale
                ], h.u_mix = o.t;
            }
            return h;
        }, Yi = (e1, t1, i, o, r, n)=>{
            const a = e1.transform, s = Ki(t1, a);
            return {
                u_matrix: Ji(e1, t1, i, r),
                u_texsize: t1.imageAtlasTexture.size,
                u_pixels_to_tile_units: a.calculatePixelsToTileUnitsMatrix(t1),
                u_device_pixel_ratio: n,
                u_image: 0,
                u_scale: [
                    s,
                    o.fromScale,
                    o.toScale
                ],
                u_fade: o.t,
                u_units_to_pixels: [
                    1 / a.pixelsToGLUnits[0],
                    1 / a.pixelsToGLUnits[1]
                ],
                u_alpha_discard_threshold: 0
            };
        };
        function Ki(e1, t1) {
            return 1 / L(e1, 1, t1.tileZoom);
        }
        function Ji(e1, t1, i, o) {
            return e1.translatePosMatrix(o || t1.tileID.projMatrix, t1, i.paint.get("line-translate"), i.paint.get("line-translate-anchor"));
        }
        function Qi(e1) {
            const t1 = e1.paint.get("line-dasharray").value;
            return t1.value || "constant" !== t1.kind;
        }
        const eo = (e1, t1, i, o, r, n)=>{
            var a, s;
            return {
                u_matrix: e1,
                u_tl_parent: t1,
                u_scale_parent: i,
                u_fade_t: o.mix,
                u_opacity: o.opacity * r.paint.get("raster-opacity"),
                u_image0: 0,
                u_image1: 1,
                u_brightness_low: r.paint.get("raster-brightness-min"),
                u_brightness_high: r.paint.get("raster-brightness-max"),
                u_saturation_factor: (s = r.paint.get("raster-saturation"), s > 0 ? 1 - 1 / (1.001 - s) : -s),
                u_contrast_factor: (a = r.paint.get("raster-contrast"), a > 0 ? 1 / (1 - a) : 1 + a),
                u_spin_weights: to(r.paint.get("raster-hue-rotate")),
                u_perspective_transform: n
            };
        };
        function to(e1) {
            e1 *= Math.PI / 180;
            const t1 = Math.sin(e1), i = Math.cos(e1);
            return [
                (2 * i + 1) / 3,
                (-Math.sqrt(3) * t1 - i + 1) / 3,
                (Math.sqrt(3) * t1 - i + 1) / 3
            ];
        }
        const io = e1.create(), oo = (t1, i, o, r, n, a, s, l, c, h, _, u, d, p, m, f)=>{
            const g = n.transform, v = {
                u_is_size_zoom_constant: +("constant" === t1 || "source" === t1),
                u_is_size_feature_constant: +("constant" === t1 || "camera" === t1),
                u_size_t: i ? i.uSizeT : 0,
                u_size: i ? i.uSize : 0,
                u_camera_to_center_distance: g.cameraToCenterDistance,
                u_rotate_symbol: +o,
                u_aspect_ratio: g.width / g.height,
                u_fade_change: n.options.fadeDuration ? n.symbolFadeChange : 1,
                u_matrix: a,
                u_label_plane_matrix: s,
                u_coord_matrix: l,
                u_is_text: +c,
                u_pitch_with_map: +r,
                u_texsize: h,
                u_texture: 0,
                u_tile_id: [
                    0,
                    0,
                    0
                ],
                u_zoom_transition: 0,
                u_inv_rot_matrix: io,
                u_merc_center: [
                    0,
                    0
                ],
                u_camera_forward: [
                    0,
                    0,
                    0
                ],
                u_ecef_origin: [
                    0,
                    0,
                    0
                ],
                u_tile_matrix: io,
                u_up_vector: [
                    0,
                    -1,
                    0
                ]
            };
            return "globe" === f.name && (v.u_tile_id = [
                _.canonical.x,
                _.canonical.y,
                1 << _.canonical.z
            ], v.u_zoom_transition = u, v.u_inv_rot_matrix = p, v.u_merc_center = d, v.u_camera_forward = g._camera.forward(), v.u_ecef_origin = e1.globeECEFOrigin(g.globeMatrix, _.toUnwrapped()), v.u_tile_matrix = Float32Array.from(g.globeMatrix), v.u_up_vector = m), v;
        }, ro = (t1, i, o, r, n, a, s, l, c, h, _, u, d, p, m, f, g)=>e1.extend(oo(t1, i, o, r, n, a, s, l, c, h, u, d, p, m, f, g), {
                u_gamma_scale: r ? n.transform.cameraToCenterDistance * Math.cos(n.terrain ? 0 : n.transform._pitch) : 1,
                u_device_pixel_ratio: e1.exported.devicePixelRatio,
                u_is_halo: +_
            }), no = (t1, i, o, r, n, a, s, l, c, h, _, u, d, p, m, f)=>e1.extend(ro(t1, i, o, r, n, a, s, l, !0, c, !0, _, u, d, p, m, f), {
                u_texsize_icon: h,
                u_texture_icon: 1
            }), ao = (e1, t1, i)=>({
                u_matrix: e1,
                u_opacity: t1,
                u_color: i
            }), so = (t1, i, o, r, n, a)=>e1.extend(function(e1, t1, i, o) {
                const r = i.imageManager.getPattern(e1.from.toString()), n = i.imageManager.getPattern(e1.to.toString()), { width: a , height: s  } = i.imageManager.getPixelSize(), l = Math.pow(2, o.tileID.overscaledZ), c = o.tileSize * Math.pow(2, i.transform.tileZoom) / l, h = c * (o.tileID.canonical.x + o.tileID.wrap * l), _ = c * o.tileID.canonical.y;
                return {
                    u_image: 0,
                    u_pattern_tl_a: r.tl,
                    u_pattern_br_a: r.br,
                    u_pattern_tl_b: n.tl,
                    u_pattern_br_b: n.br,
                    u_texsize: [
                        a,
                        s
                    ],
                    u_mix: t1.t,
                    u_pattern_size_a: r.displaySize,
                    u_pattern_size_b: n.displaySize,
                    u_scale_a: t1.fromScale,
                    u_scale_b: t1.toScale,
                    u_tile_units_to_pixels: 1 / L(o, 1, i.transform.tileZoom),
                    u_pixel_coord_upper: [
                        h >> 16,
                        _ >> 16
                    ],
                    u_pixel_coord_lower: [
                        65535 & h,
                        65535 & _
                    ]
                };
            }(r, a, o, n), {
                u_matrix: t1,
                u_opacity: i
            }), lo = {
            fillExtrusion: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_lightpos: new e1.Uniform3f(t1),
                    u_lightintensity: new e1.Uniform1f(t1),
                    u_lightcolor: new e1.Uniform3f(t1),
                    u_vertical_gradient: new e1.Uniform1f(t1),
                    u_opacity: new e1.Uniform1f(t1),
                    u_edge_radius: new e1.Uniform1f(t1),
                    u_ao: new e1.Uniform2f(t1),
                    u_tile_id: new e1.Uniform3f(t1),
                    u_zoom_transition: new e1.Uniform1f(t1),
                    u_inv_rot_matrix: new e1.UniformMatrix4f(t1),
                    u_merc_center: new e1.Uniform2f(t1),
                    u_up_dir: new e1.Uniform3f(t1),
                    u_height_lift: new e1.Uniform1f(t1)
                }),
            fillExtrusionPattern: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_lightpos: new e1.Uniform3f(t1),
                    u_lightintensity: new e1.Uniform1f(t1),
                    u_lightcolor: new e1.Uniform3f(t1),
                    u_vertical_gradient: new e1.Uniform1f(t1),
                    u_height_factor: new e1.Uniform1f(t1),
                    u_edge_radius: new e1.Uniform1f(t1),
                    u_ao: new e1.Uniform2f(t1),
                    u_tile_id: new e1.Uniform3f(t1),
                    u_zoom_transition: new e1.Uniform1f(t1),
                    u_inv_rot_matrix: new e1.UniformMatrix4f(t1),
                    u_merc_center: new e1.Uniform2f(t1),
                    u_up_dir: new e1.Uniform3f(t1),
                    u_height_lift: new e1.Uniform1f(t1),
                    u_image: new e1.Uniform1i(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_pixel_coord_upper: new e1.Uniform2f(t1),
                    u_pixel_coord_lower: new e1.Uniform2f(t1),
                    u_scale: new e1.Uniform3f(t1),
                    u_fade: new e1.Uniform1f(t1),
                    u_opacity: new e1.Uniform1f(t1)
                }),
            fill: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1)
                }),
            fillPattern: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_image: new e1.Uniform1i(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_pixel_coord_upper: new e1.Uniform2f(t1),
                    u_pixel_coord_lower: new e1.Uniform2f(t1),
                    u_scale: new e1.Uniform3f(t1),
                    u_fade: new e1.Uniform1f(t1)
                }),
            fillOutline: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_world: new e1.Uniform2f(t1)
                }),
            fillOutlinePattern: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_world: new e1.Uniform2f(t1),
                    u_image: new e1.Uniform1i(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_pixel_coord_upper: new e1.Uniform2f(t1),
                    u_pixel_coord_lower: new e1.Uniform2f(t1),
                    u_scale: new e1.Uniform3f(t1),
                    u_fade: new e1.Uniform1f(t1)
                }),
            circle: (t1)=>({
                    u_camera_to_center_distance: new e1.Uniform1f(t1),
                    u_extrude_scale: new e1.UniformMatrix2f(t1),
                    u_device_pixel_ratio: new e1.Uniform1f(t1),
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_inv_rot_matrix: new e1.UniformMatrix4f(t1),
                    u_merc_center: new e1.Uniform2f(t1),
                    u_tile_id: new e1.Uniform3f(t1),
                    u_zoom_transition: new e1.Uniform1f(t1),
                    u_up_dir: new e1.Uniform3f(t1)
                }),
            collisionBox: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_camera_to_center_distance: new e1.Uniform1f(t1),
                    u_extrude_scale: new e1.Uniform2f(t1)
                }),
            collisionCircle: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_inv_matrix: new e1.UniformMatrix4f(t1),
                    u_camera_to_center_distance: new e1.Uniform1f(t1),
                    u_viewport_size: new e1.Uniform2f(t1)
                }),
            debug: (t1)=>({
                    u_color: new e1.UniformColor(t1),
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_overlay: new e1.Uniform1i(t1),
                    u_overlay_scale: new e1.Uniform1f(t1)
                }),
            clippingMask: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1)
                }),
            heatmap: (t1)=>({
                    u_extrude_scale: new e1.Uniform1f(t1),
                    u_intensity: new e1.Uniform1f(t1),
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_inv_rot_matrix: new e1.UniformMatrix4f(t1),
                    u_merc_center: new e1.Uniform2f(t1),
                    u_tile_id: new e1.Uniform3f(t1),
                    u_zoom_transition: new e1.Uniform1f(t1),
                    u_up_dir: new e1.Uniform3f(t1)
                }),
            heatmapTexture: (t1)=>({
                    u_image: new e1.Uniform1i(t1),
                    u_color_ramp: new e1.Uniform1i(t1),
                    u_opacity: new e1.Uniform1f(t1)
                }),
            hillshade: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_image: new e1.Uniform1i(t1),
                    u_latrange: new e1.Uniform2f(t1),
                    u_light: new e1.Uniform2f(t1),
                    u_shadow: new e1.UniformColor(t1),
                    u_highlight: new e1.UniformColor(t1),
                    u_accent: new e1.UniformColor(t1)
                }),
            hillshadePrepare: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_image: new e1.Uniform1i(t1),
                    u_dimension: new e1.Uniform2f(t1),
                    u_zoom: new e1.Uniform1f(t1),
                    u_unpack: new e1.Uniform4f(t1)
                }),
            line: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_pixels_to_tile_units: new e1.UniformMatrix2f(t1),
                    u_device_pixel_ratio: new e1.Uniform1f(t1),
                    u_units_to_pixels: new e1.Uniform2f(t1),
                    u_dash_image: new e1.Uniform1i(t1),
                    u_gradient_image: new e1.Uniform1i(t1),
                    u_image_height: new e1.Uniform1f(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_scale: new e1.Uniform3f(t1),
                    u_mix: new e1.Uniform1f(t1),
                    u_alpha_discard_threshold: new e1.Uniform1f(t1),
                    u_trim_offset: new e1.Uniform2f(t1)
                }),
            linePattern: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_pixels_to_tile_units: new e1.UniformMatrix2f(t1),
                    u_device_pixel_ratio: new e1.Uniform1f(t1),
                    u_image: new e1.Uniform1i(t1),
                    u_units_to_pixels: new e1.Uniform2f(t1),
                    u_scale: new e1.Uniform3f(t1),
                    u_fade: new e1.Uniform1f(t1),
                    u_alpha_discard_threshold: new e1.Uniform1f(t1)
                }),
            raster: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_tl_parent: new e1.Uniform2f(t1),
                    u_scale_parent: new e1.Uniform1f(t1),
                    u_fade_t: new e1.Uniform1f(t1),
                    u_opacity: new e1.Uniform1f(t1),
                    u_image0: new e1.Uniform1i(t1),
                    u_image1: new e1.Uniform1i(t1),
                    u_brightness_low: new e1.Uniform1f(t1),
                    u_brightness_high: new e1.Uniform1f(t1),
                    u_saturation_factor: new e1.Uniform1f(t1),
                    u_contrast_factor: new e1.Uniform1f(t1),
                    u_spin_weights: new e1.Uniform3f(t1),
                    u_perspective_transform: new e1.Uniform2f(t1)
                }),
            symbolIcon: (t1)=>({
                    u_is_size_zoom_constant: new e1.Uniform1i(t1),
                    u_is_size_feature_constant: new e1.Uniform1i(t1),
                    u_size_t: new e1.Uniform1f(t1),
                    u_size: new e1.Uniform1f(t1),
                    u_camera_to_center_distance: new e1.Uniform1f(t1),
                    u_rotate_symbol: new e1.Uniform1i(t1),
                    u_aspect_ratio: new e1.Uniform1f(t1),
                    u_fade_change: new e1.Uniform1f(t1),
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_label_plane_matrix: new e1.UniformMatrix4f(t1),
                    u_coord_matrix: new e1.UniformMatrix4f(t1),
                    u_is_text: new e1.Uniform1i(t1),
                    u_pitch_with_map: new e1.Uniform1i(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_tile_id: new e1.Uniform3f(t1),
                    u_zoom_transition: new e1.Uniform1f(t1),
                    u_inv_rot_matrix: new e1.UniformMatrix4f(t1),
                    u_merc_center: new e1.Uniform2f(t1),
                    u_camera_forward: new e1.Uniform3f(t1),
                    u_tile_matrix: new e1.UniformMatrix4f(t1),
                    u_up_vector: new e1.Uniform3f(t1),
                    u_ecef_origin: new e1.Uniform3f(t1),
                    u_texture: new e1.Uniform1i(t1)
                }),
            symbolSDF: (t1)=>({
                    u_is_size_zoom_constant: new e1.Uniform1i(t1),
                    u_is_size_feature_constant: new e1.Uniform1i(t1),
                    u_size_t: new e1.Uniform1f(t1),
                    u_size: new e1.Uniform1f(t1),
                    u_camera_to_center_distance: new e1.Uniform1f(t1),
                    u_rotate_symbol: new e1.Uniform1i(t1),
                    u_aspect_ratio: new e1.Uniform1f(t1),
                    u_fade_change: new e1.Uniform1f(t1),
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_label_plane_matrix: new e1.UniformMatrix4f(t1),
                    u_coord_matrix: new e1.UniformMatrix4f(t1),
                    u_is_text: new e1.Uniform1i(t1),
                    u_pitch_with_map: new e1.Uniform1i(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_texture: new e1.Uniform1i(t1),
                    u_gamma_scale: new e1.Uniform1f(t1),
                    u_device_pixel_ratio: new e1.Uniform1f(t1),
                    u_tile_id: new e1.Uniform3f(t1),
                    u_zoom_transition: new e1.Uniform1f(t1),
                    u_inv_rot_matrix: new e1.UniformMatrix4f(t1),
                    u_merc_center: new e1.Uniform2f(t1),
                    u_camera_forward: new e1.Uniform3f(t1),
                    u_tile_matrix: new e1.UniformMatrix4f(t1),
                    u_up_vector: new e1.Uniform3f(t1),
                    u_ecef_origin: new e1.Uniform3f(t1),
                    u_is_halo: new e1.Uniform1i(t1)
                }),
            symbolTextAndIcon: (t1)=>({
                    u_is_size_zoom_constant: new e1.Uniform1i(t1),
                    u_is_size_feature_constant: new e1.Uniform1i(t1),
                    u_size_t: new e1.Uniform1f(t1),
                    u_size: new e1.Uniform1f(t1),
                    u_camera_to_center_distance: new e1.Uniform1f(t1),
                    u_rotate_symbol: new e1.Uniform1i(t1),
                    u_aspect_ratio: new e1.Uniform1f(t1),
                    u_fade_change: new e1.Uniform1f(t1),
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_label_plane_matrix: new e1.UniformMatrix4f(t1),
                    u_coord_matrix: new e1.UniformMatrix4f(t1),
                    u_is_text: new e1.Uniform1i(t1),
                    u_pitch_with_map: new e1.Uniform1i(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_texsize_icon: new e1.Uniform2f(t1),
                    u_texture: new e1.Uniform1i(t1),
                    u_texture_icon: new e1.Uniform1i(t1),
                    u_gamma_scale: new e1.Uniform1f(t1),
                    u_device_pixel_ratio: new e1.Uniform1f(t1),
                    u_is_halo: new e1.Uniform1i(t1)
                }),
            background: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_opacity: new e1.Uniform1f(t1),
                    u_color: new e1.UniformColor(t1)
                }),
            backgroundPattern: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_opacity: new e1.Uniform1f(t1),
                    u_image: new e1.Uniform1i(t1),
                    u_pattern_tl_a: new e1.Uniform2f(t1),
                    u_pattern_br_a: new e1.Uniform2f(t1),
                    u_pattern_tl_b: new e1.Uniform2f(t1),
                    u_pattern_br_b: new e1.Uniform2f(t1),
                    u_texsize: new e1.Uniform2f(t1),
                    u_mix: new e1.Uniform1f(t1),
                    u_pattern_size_a: new e1.Uniform2f(t1),
                    u_pattern_size_b: new e1.Uniform2f(t1),
                    u_scale_a: new e1.Uniform1f(t1),
                    u_scale_b: new e1.Uniform1f(t1),
                    u_pixel_coord_upper: new e1.Uniform2f(t1),
                    u_pixel_coord_lower: new e1.Uniform2f(t1),
                    u_tile_units_to_pixels: new e1.Uniform1f(t1)
                }),
            terrainRaster: yi,
            terrainDepth: yi,
            skybox: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_sun_direction: new e1.Uniform3f(t1),
                    u_cubemap: new e1.Uniform1i(t1),
                    u_opacity: new e1.Uniform1f(t1),
                    u_temporal_offset: new e1.Uniform1f(t1)
                }),
            skyboxGradient: (t1)=>({
                    u_matrix: new e1.UniformMatrix4f(t1),
                    u_color_ramp: new e1.Uniform1i(t1),
                    u_center_direction: new e1.Uniform3f(t1),
                    u_radius: new e1.Uniform1f(t1),
                    u_opacity: new e1.Uniform1f(t1),
                    u_temporal_offset: new e1.Uniform1f(t1)
                }),
            skyboxCapture: (t1)=>({
                    u_matrix_3f: new e1.UniformMatrix3f(t1),
                    u_sun_direction: new e1.Uniform3f(t1),
                    u_sun_intensity: new e1.Uniform1f(t1),
                    u_color_tint_r: new e1.Uniform4f(t1),
                    u_color_tint_m: new e1.Uniform4f(t1),
                    u_luminance: new e1.Uniform1f(t1)
                }),
            globeRaster: (t1)=>({
                    u_proj_matrix: new e1.UniformMatrix4f(t1),
                    u_globe_matrix: new e1.UniformMatrix4f(t1),
                    u_normalize_matrix: new e1.UniformMatrix4f(t1),
                    u_merc_matrix: new e1.UniformMatrix4f(t1),
                    u_zoom_transition: new e1.Uniform1f(t1),
                    u_merc_center: new e1.Uniform2f(t1),
                    u_image0: new e1.Uniform1i(t1),
                    u_grid_matrix: new e1.UniformMatrix3f(t1),
                    u_frustum_tl: new e1.Uniform3f(t1),
                    u_frustum_tr: new e1.Uniform3f(t1),
                    u_frustum_br: new e1.Uniform3f(t1),
                    u_frustum_bl: new e1.Uniform3f(t1),
                    u_globe_pos: new e1.Uniform3f(t1),
                    u_globe_radius: new e1.Uniform1f(t1),
                    u_viewport: new e1.Uniform2f(t1)
                }),
            globeAtmosphere: (t1)=>({
                    u_frustum_tl: new e1.Uniform3f(t1),
                    u_frustum_tr: new e1.Uniform3f(t1),
                    u_frustum_br: new e1.Uniform3f(t1),
                    u_frustum_bl: new e1.Uniform3f(t1),
                    u_horizon: new e1.Uniform1f(t1),
                    u_transition: new e1.Uniform1f(t1),
                    u_fadeout_range: new e1.Uniform1f(t1),
                    u_color: new e1.Uniform4f(t1),
                    u_high_color: new e1.Uniform4f(t1),
                    u_space_color: new e1.Uniform4f(t1),
                    u_star_intensity: new e1.Uniform1f(t1),
                    u_star_density: new e1.Uniform1f(t1),
                    u_star_size: new e1.Uniform1f(t1),
                    u_temporal_offset: new e1.Uniform1f(t1),
                    u_horizon_angle: new e1.Uniform1f(t1),
                    u_rotation_matrix: new e1.UniformMatrix4f(t1)
                })
        };
        let co;
        function ho(t1, i, o, r, n, a, s) {
            const l = t1.context, c = l.gl, h = t1.transform, _ = t1.useProgram("collisionBox"), u = [];
            let d = 0, p = 0;
            for(let m = 0; m < r.length; m++){
                const f = r[m], g = i.getTile(f), v = g.getBucket(o);
                if (!v) continue;
                const x = bt(f, v, h);
                let y = x;
                0 === n[0] && 0 === n[1] || (y = t1.translatePosMatrix(x, g, n, a));
                const b = s ? v.textCollisionBox : v.iconCollisionBox, w = v.collisionCircleArray;
                if (w.length > 0) {
                    const t2 = e1.create(), i1 = y;
                    e1.mul(t2, v.placementInvProjMatrix, h.glCoordMatrix), e1.mul(t2, t2, v.placementViewportMatrix), u.push({
                        circleArray: w,
                        circleOffset: p,
                        transform: i1,
                        invTransform: t2,
                        projection: v.getProjection()
                    }), d += w.length / 4, p = d;
                }
                b && (t1.terrain && t1.terrain.setupElevationDraw(g, _), _.draw(l, c.LINES, e1.DepthMode.disabled, e1.StencilMode.disabled, t1.colorModeForRenderPass(), e1.CullFaceMode.disabled, Wi(y, h, g, v.getProjection()), o.id, b.layoutVertexBuffer, b.indexBuffer, b.segments, null, h.zoom, null, [
                    b.collisionVertexBuffer,
                    b.collisionVertexBufferExt
                ]));
            }
            if (!s || !u.length) return;
            const m1 = t1.useProgram("collisionCircle"), f1 = new e1.StructArrayLayout2f1f2i16;
            f1.resize(4 * d), f1._trim();
            let g1 = 0;
            for (const e2 of u)for(let t3 = 0; t3 < e2.circleArray.length / 4; t3++){
                const i2 = 4 * t3, o1 = e2.circleArray[i2 + 0], r1 = e2.circleArray[i2 + 1], n1 = e2.circleArray[i2 + 2], a1 = e2.circleArray[i2 + 3];
                f1.emplace(g1++, o1, r1, n1, a1, 0), f1.emplace(g1++, o1, r1, n1, a1, 1), f1.emplace(g1++, o1, r1, n1, a1, 2), f1.emplace(g1++, o1, r1, n1, a1, 3);
            }
            (!co || co.length < 2 * d) && (co = function(t1) {
                const i = 2 * t1, o = new e1.StructArrayLayout3ui6;
                o.resize(i), o._trim();
                for(let e2 = 0; e2 < i; e2++){
                    const t2 = 6 * e2;
                    o.uint16[t2 + 0] = 4 * e2 + 0, o.uint16[t2 + 1] = 4 * e2 + 1, o.uint16[t2 + 2] = 4 * e2 + 2, o.uint16[t2 + 3] = 4 * e2 + 2, o.uint16[t2 + 4] = 4 * e2 + 3, o.uint16[t2 + 5] = 4 * e2 + 0;
                }
                return o;
            }(d));
            const v1 = l.createIndexBuffer(co, !0), x1 = l.createVertexBuffer(f1, e1.collisionCircleLayout.members, !0);
            for (const i3 of u){
                const r2 = {
                    u_matrix: i3.transform,
                    u_inv_matrix: i3.invTransform,
                    u_camera_to_center_distance: (y1 = h).getCameraToCenterDistance(i3.projection),
                    u_viewport_size: [
                        y1.width,
                        y1.height
                    ]
                };
                m1.draw(l, c.TRIANGLES, e1.DepthMode.disabled, e1.StencilMode.disabled, t1.colorModeForRenderPass(), e1.CullFaceMode.disabled, r2, o.id, x1, v1, e1.SegmentVector.simpleSegment(0, 2 * i3.circleOffset, i3.circleArray.length, i3.circleArray.length / 2), null, h.zoom);
            }
            var y1;
            x1.destroy(), v1.destroy();
        }
        const _o = e1.create();
        function uo(t1, i, o, r, n, a) {
            const { horizontalAlign: s , verticalAlign: l  } = e1.getAnchorAlignment(t1), c = -(s - .5) * i, h = -(l - .5) * o, _ = e1.evaluateVariableOffset(t1, r);
            return new e1.pointGeometry((c / n + _[0]) * a, (h / n + _[1]) * a);
        }
        function po(t1, i, o, r, n, a, s, l, c, h, _) {
            const u = t1.text.placedSymbolArray, d = t1.text.dynamicLayoutVertexArray, p = t1.icon.dynamicLayoutVertexArray, m = {}, f = wt(l, t1.getProjection(), a), g = a.elevation, v = t1.getProjection().upVectorScale(l.canonical, a.center.lat, a.worldSize);
            d.clear();
            for(let p1 = 0; p1 < u.length; p1++){
                const x = u.get(p1), y = t1.allowVerticalPlacement && !x.placedOrientation, b = x.hidden || !x.crossTileID || y ? null : r[x.crossTileID];
                if (b) {
                    const r1 = new e1.pointGeometry(x.tileAnchorX, x.tileAnchorY), u1 = t1.getProjection().upVector(l.canonical, r1.x, r1.y), p2 = g ? g.getAtTileOffset(l, r1.x, r1.y) : 0, y1 = nt([
                        x.projectedAnchorX + p2 * u1[0] * v.metersToTile,
                        x.projectedAnchorY + p2 * u1[1] * v.metersToTile,
                        x.projectedAnchorZ + p2 * u1[2] * v.metersToTile
                    ], o ? f : s), w = at(a.getCameraToCenterDistance(t1.getProjection()), y1.signedDistanceFromCamera);
                    let T = n.evaluateSizeForFeature(t1.textSizeData, h, x) * w / e1.ONE_EM;
                    o && (T *= t1.tilePixelRatio / c);
                    const { width: E , height: C , anchor: I , textOffset: M , textScale: S  } = b, z = uo(I, E, C, M, S, T);
                    let D;
                    if (o) {
                        const e2 = r1.add(z), { x: i1 , y: o1 , z: n1  } = t1.getProjection().projectTilePoint(e2.x, e2.y, l.canonical);
                        D = nt([
                            i1 + p2 * u1[0] * v.metersToTile,
                            o1 + p2 * u1[1] * v.metersToTile,
                            n1 + p2 * u1[2] * v.metersToTile
                        ], s).point;
                    } else {
                        const e3 = i ? z.rotate(-a.angle) : z;
                        D = [
                            y1.point[0] + e3.x,
                            y1.point[1] + e3.y,
                            0
                        ];
                    }
                    const A = t1.allowVerticalPlacement && x.placedOrientation === e1.WritingMode.vertical ? Math.PI / 2 : 0;
                    for(let t2 = 0; t2 < x.numGlyphs; t2++)e1.addDynamicAttributes(d, D[0], D[1], D[2], A);
                    _ && x.associatedIconIndex >= 0 && (m[x.associatedIconIndex] = {
                        shiftedAnchor: D,
                        angle: A
                    });
                } else ft(x.numGlyphs, d);
            }
            if (_) {
                p.clear();
                const i2 = t1.icon.placedSymbolArray;
                for(let t3 = 0; t3 < i2.length; t3++){
                    const o2 = i2.get(t3);
                    if (o2.hidden) ft(o2.numGlyphs, p);
                    else {
                        const i3 = m[t3];
                        if (i3) for(let t4 = 0; t4 < o2.numGlyphs; t4++)e1.addDynamicAttributes(p, i3.shiftedAnchor[0], i3.shiftedAnchor[1], i3.shiftedAnchor[2], i3.angle);
                        else ft(o2.numGlyphs, p);
                    }
                }
                t1.icon.dynamicLayoutVertexBuffer.updateData(p);
            }
            t1.text.dynamicLayoutVertexBuffer.updateData(d);
        }
        function mo(e1, t1, i) {
            return i.iconsInText && t1 ? "symbolTextAndIcon" : e1 ? "symbolSDF" : "symbolIcon";
        }
        function fo(t1, i, o, r, n, a, s, l, c, h, _, u) {
            const d = t1.context, p = d.gl, m = t1.transform, f = "map" === l, g = "map" === c, v = f && "point" !== o.layout.get("symbol-placement"), x = f && !g && !v, y = void 0 !== o.layout.get("symbol-sort-key").constantOr(1);
            let b = !1;
            const w = t1.depthModeForSublayer(0, e1.DepthMode.ReadOnly), T = [
                e1.mercatorXfromLng(m.center.lng),
                e1.mercatorYfromLat(m.center.lat)
            ], E = o.layout.get("text-variable-anchor"), C = "globe" === m.projection.name, I = [], M = [
                0,
                -1,
                0
            ];
            let S = M;
            !C && !m.mercatorFromTransition || f || (S = function(t1) {
                const i = t1._camera.getWorldToCamera(t1.worldSize, 1), o = e1.multiply([], i, t1.globeMatrix);
                e1.invert(o, o);
                const r = [
                    0,
                    0,
                    0
                ], n = [
                    0,
                    1,
                    0,
                    0
                ];
                return e1.transformMat4$1(n, n, o), r[0] = n[0], r[1] = n[1], r[2] = n[2], e1.normalize(r, r), r;
            }(m));
            for (const l1 of r){
                const r1 = i.getTile(l1), c1 = r1.getBucket(o);
                if (!c1) continue;
                if ("mercator" === c1.projection.name && C) continue;
                const _1 = n ? c1.text : c1.icon;
                if (!_1 || c1.fullyClipped || !_1.segments.get().length) continue;
                const u1 = _1.programConfigurations.get(o.id), d1 = n || c1.sdfIcons, w1 = n ? c1.textSizeData : c1.iconSizeData, z = g || 0 !== m.pitch, D = e1.evaluateSizeForZoom(w1, m.zoom);
                let A, P, L, R, O = [
                    0,
                    0
                ], B = null;
                if (n) {
                    if (P = r1.glyphAtlasTexture, L = p.LINEAR, A = r1.glyphAtlasTexture.size, c1.iconsInText) {
                        O = r1.imageAtlasTexture.size, B = r1.imageAtlasTexture;
                        const e2 = "composite" === w1.kind || "camera" === w1.kind;
                        R = z || t1.options.rotating || t1.options.zooming || e2 ? p.LINEAR : p.NEAREST;
                    }
                } else {
                    const e3 = 1 !== o.layout.get("icon-size").constantOr(0) || c1.iconsNeedLinear;
                    P = r1.imageAtlasTexture, L = d1 || t1.options.rotating || t1.options.zooming || e3 || z ? p.LINEAR : p.NEAREST, A = r1.imageAtlasTexture.size;
                }
                const k = "globe" === c1.projection.name, F = k ? S : M, U = k ? e1.globeToMercatorTransition(m.zoom) : 0, N = wt(l1, c1.getProjection(), m), G = m.calculatePixelsToTileUnitsMatrix(r1), j = tt(N, r1.tileID.canonical, g, f, m, c1.getProjection(), G), Z = t1.terrain && g && v ? e1.invert(e1.create(), j) : _o, V = ot(N, r1.tileID.canonical, g, f, m, c1.getProjection(), G), W = E && c1.hasTextData(), X = "none" !== o.layout.get("icon-text-fit") && W && c1.hasIconData();
                if (v) {
                    const e4 = m.elevation, i1 = e4 ? e4.getAtTileOffsetFunc(l1, m.center.lat, m.worldSize, c1.getProjection()) : (e1)=>[
                            0,
                            0,
                            0
                        ], o1 = it(N, r1.tileID.canonical, g, f, m, c1.getProjection(), G);
                    lt(c1, N, t1, n, o1, V, g, h, i1, l1);
                }
                const q = v || n && E || X, $ = t1.translatePosMatrix(N, r1, a, s), H = q ? _o : j, Y = t1.translatePosMatrix(V, r1, a, s, !0), K = c1.getProjection().createInversionMatrix(m, l1.canonical), J = [];
                t1.terrainRenderModeElevated() && g && J.push("PITCH_WITH_MAP_TERRAIN"), k && J.push("PROJECTION_GLOBE_VIEW"), q && J.push("PROJECTED_POS_ON_VIEWPORT");
                const Q = d1 && 0 !== o.paint.get(n ? "text-halo-width" : "icon-halo-width").constantOr(1);
                let ee;
                ee = d1 ? c1.iconsInText ? no(w1.kind, D, x, g, t1, $, H, Y, A, O, l1, U, T, K, F, c1.getProjection()) : ro(w1.kind, D, x, g, t1, $, H, Y, n, A, !0, l1, U, T, K, F, c1.getProjection()) : oo(w1.kind, D, x, g, t1, $, H, Y, n, A, l1, U, T, K, F, c1.getProjection());
                const te = {
                    program: t1.useProgram(mo(d1, n, c1), u1, J),
                    buffers: _1,
                    uniformValues: ee,
                    atlasTexture: P,
                    atlasTextureIcon: B,
                    atlasInterpolation: L,
                    atlasInterpolationIcon: R,
                    isSDF: d1,
                    hasHalo: Q,
                    tile: r1,
                    labelPlaneMatrixInv: Z
                };
                if (y && c1.canOverlap) {
                    b = !0;
                    const t2 = _1.segments.get();
                    for (const i2 of t2)I.push({
                        segments: new e1.SegmentVector([
                            i2
                        ]),
                        sortKey: i2.sortKey,
                        state: te
                    });
                } else I.push({
                    segments: _1.segments,
                    sortKey: 0,
                    state: te
                });
            }
            b && I.sort((e1, t1)=>e1.sortKey - t1.sortKey);
            for (const e5 of I){
                const i3 = e5.state;
                if (t1.terrain && t1.terrain.setupElevationDraw(i3.tile, i3.program, {
                    useDepthForOcclusion: !C,
                    labelPlaneMatrixInv: i3.labelPlaneMatrixInv
                }), d.activeTexture.set(p.TEXTURE0), i3.atlasTexture.bind(i3.atlasInterpolation, p.CLAMP_TO_EDGE), i3.atlasTextureIcon && (d.activeTexture.set(p.TEXTURE1), i3.atlasTextureIcon && i3.atlasTextureIcon.bind(i3.atlasInterpolationIcon, p.CLAMP_TO_EDGE)), i3.isSDF) {
                    const r2 = i3.uniformValues;
                    i3.hasHalo && (r2.u_is_halo = 1, go(i3.buffers, e5.segments, o, t1, i3.program, w, _, u, r2)), r2.u_is_halo = 0;
                }
                go(i3.buffers, e5.segments, o, t1, i3.program, w, _, u, i3.uniformValues);
            }
        }
        function go(t1, i, o, r, n, a, s, l, c) {
            const h = r.context, _ = [
                t1.dynamicLayoutVertexBuffer,
                t1.opacityVertexBuffer,
                t1.globeExtVertexBuffer
            ];
            n.draw(h, h.gl.TRIANGLES, a, s, l, e1.CullFaceMode.disabled, c, o.id, t1.layoutVertexBuffer, t1.indexBuffer, i, o.paint, r.transform.zoom, t1.programConfigurations.get(o.id), _);
        }
        function vo(t1, i, o, r, n, a, s) {
            const l = t1.context.gl, c = o.paint.get("fill-pattern"), h = c && c.constantOr(1), _ = o.getCrossfadeParameters();
            let u, d, p, m, f;
            s ? (d = h && !o.getPaintProperty("fill-outline-color") ? "fillOutlinePattern" : "fillOutline", u = l.LINES) : (d = h ? "fillPattern" : "fill", u = l.TRIANGLES);
            for (const g of r){
                const r1 = i.getTile(g);
                if (h && !r1.patternsLoaded()) continue;
                const v = r1.getBucket(o);
                if (!v) continue;
                t1.prepareDrawTile();
                const x = v.programConfigurations.get(o.id), y = t1.useProgram(d, x);
                h && (t1.context.activeTexture.set(l.TEXTURE0), r1.imageAtlasTexture.bind(l.LINEAR, l.CLAMP_TO_EDGE), x.updatePaintBuffers(_));
                const b = c.constantOr(null);
                if (b && r1.imageAtlas) {
                    const e2 = r1.imageAtlas, t2 = e2.patternPositions[b.to.toString()], i1 = e2.patternPositions[b.from.toString()];
                    t2 && i1 && x.setConstantPatternPositions(t2, i1);
                }
                const w = t1.translatePosMatrix(g.projMatrix, r1, o.paint.get("fill-translate"), o.paint.get("fill-translate-anchor"));
                if (s) {
                    m = v.indexBuffer2, f = v.segments2;
                    const e3 = t1.terrain && t1.terrain.renderingToTexture ? t1.terrain.drapeBufferSize : [
                        l.drawingBufferWidth,
                        l.drawingBufferHeight
                    ];
                    p = "fillOutlinePattern" === d && h ? Gi(w, t1, _, r1, e3) : Ni(w, e3);
                } else m = v.indexBuffer, f = v.segments, p = h ? Ui(w, t1, _, r1) : Fi(w);
                t1.prepareDrawProgram(t1.context, y, g.toUnwrapped()), y.draw(t1.context, u, n, t1.stencilModeForClipping(g), a, e1.CullFaceMode.disabled, p, o.id, v.layoutVertexBuffer, m, f, o.paint, t1.transform.zoom, x);
            }
        }
        function xo(t1, i, o, r, n, a, s) {
            const l = t1.context, c = l.gl, h = t1.transform, _ = o.paint.get("fill-extrusion-pattern"), u = _.constantOr(1), d = o.getCrossfadeParameters(), p = o.paint.get("fill-extrusion-opacity"), m = [
                o.paint.get("fill-extrusion-ambient-occlusion-intensity"),
                o.paint.get("fill-extrusion-ambient-occlusion-radius")
            ], f = o.layout.get("fill-extrusion-edge-radius"), g = "globe" === h.projection.name ? e1.fillExtrusionHeightLift() : 0, v = "globe" === h.projection.name, x = v ? e1.globeToMercatorTransition(h.zoom) : 0, y = [
                e1.mercatorXfromLng(h.center.lng),
                e1.mercatorYfromLat(h.center.lat)
            ], b = [];
            v && (b.push("PROJECTION_GLOBE_VIEW"), t1.style.terrainSetForDrapingOnly() && b.push("TERRAIN")), m[0] > 0 && b.push("FAUX_AO");
            for (const w of r){
                const r1 = i.getTile(w), T = r1.getBucket(o);
                if (!T || T.projection.name !== h.projection.name) continue;
                const E = T.programConfigurations.get(o.id), C = t1.useProgram(u ? "fillExtrusionPattern" : "fillExtrusion", E, b);
                if (t1.terrain) {
                    const e2 = t1.terrain;
                    if (t1.style.terrainSetForDrapingOnly()) e2.setupElevationDraw(r1, C, {
                        useMeterToDem: !0
                    });
                    else {
                        if (!T.enableTerrain) continue;
                        if (e2.setupElevationDraw(r1, C, {
                            useMeterToDem: !0
                        }), yo(l, i, w, T, o, e2), !T.centroidVertexBuffer) {
                            const e3 = C.attributes.a_centroid_pos;
                            void 0 !== e3 && c.vertexAttrib2f(e3, 0, 0);
                        }
                    }
                }
                u && (t1.context.activeTexture.set(c.TEXTURE0), r1.imageAtlasTexture.bind(c.LINEAR, c.CLAMP_TO_EDGE), E.updatePaintBuffers(d));
                const I = _.constantOr(null);
                if (I && r1.imageAtlas) {
                    const e4 = r1.imageAtlas, t2 = e4.patternPositions[I.to.toString()], i1 = e4.patternPositions[I.from.toString()];
                    t2 && i1 && E.setConstantPatternPositions(t2, i1);
                }
                const M = t1.translatePosMatrix(w.projMatrix, r1, o.paint.get("fill-extrusion-translate"), o.paint.get("fill-extrusion-translate-anchor")), S = h.projection.createInversionMatrix(h, w.canonical), z = o.paint.get("fill-extrusion-vertical-gradient"), D = u ? ki(M, t1, z, p, m, f, w, d, r1, g, x, y, S) : Bi(M, t1, z, p, m, f, w, g, x, y, S);
                t1.prepareDrawProgram(l, C, w.toUnwrapped());
                const A = [];
                t1.terrain && A.push(T.centroidVertexBuffer), v && A.push(T.layoutVertexExtBuffer), C.draw(l, l.gl.TRIANGLES, n, a, s, e1.CullFaceMode.backCCW, D, o.id, T.layoutVertexBuffer, T.indexBuffer, T.segments, o.paint, t1.transform.zoom, E, A);
            }
        }
        function yo(t1, i, o, r, n, a) {
            const s = [
                (t1)=>{
                    let i = t1.canonical.x - 1, o = t1.wrap;
                    return i < 0 && (i = (1 << t1.canonical.z) - 1, o--), new e1.OverscaledTileID(t1.overscaledZ, o, t1.canonical.z, i, t1.canonical.y);
                },
                (t1)=>{
                    let i = t1.canonical.x + 1, o = t1.wrap;
                    return i === 1 << t1.canonical.z && (i = 0, o++), new e1.OverscaledTileID(t1.overscaledZ, o, t1.canonical.z, i, t1.canonical.y);
                },
                (t1)=>new e1.OverscaledTileID(t1.overscaledZ, t1.wrap, t1.canonical.z, t1.canonical.x, (0 === t1.canonical.y ? 1 << t1.canonical.z : t1.canonical.y) - 1),
                (t1)=>new e1.OverscaledTileID(t1.overscaledZ, t1.wrap, t1.canonical.z, t1.canonical.x, t1.canonical.y === (1 << t1.canonical.z) - 1 ? 0 : t1.canonical.y + 1)
            ], l = (e1)=>{
                const t1 = i.getSource().minzoom, o = (e1)=>{
                    const t1 = i.getTileByID(e1);
                    if (t1 && t1.hasData()) return t1.getBucket(n);
                }, r = [
                    0,
                    -1,
                    1
                ];
                for (const i1 of r){
                    if (e1.overscaledZ + i1 < t1) continue;
                    const r1 = o(e1.calculateScaledKey(e1.overscaledZ + i1));
                    if (r1) return r1;
                }
            }, c = [
                0,
                0,
                0
            ], h = (t1, i)=>(c[0] = Math.min(t1.min.y, i.min.y), c[1] = Math.max(t1.max.y, i.max.y), c[2] = e1.EXTENT - i.min.x > t1.max.x ? i.min.x - e1.EXTENT : t1.max.x, c), _ = (t1, i)=>(c[0] = Math.min(t1.min.x, i.min.x), c[1] = Math.max(t1.max.x, i.max.x), c[2] = e1.EXTENT - i.min.y > t1.max.y ? i.min.y - e1.EXTENT : t1.max.y, c), u = [
                (e1, t1)=>h(e1, t1),
                (e1, t1)=>h(t1, e1),
                (e1, t1)=>_(e1, t1),
                (e1, t1)=>_(t1, e1)
            ], d = new e1.pointGeometry(0, 0);
            let p, m, f;
            const g = (t1, i, r, n, s)=>{
                const l = [
                    [
                        n ? r : t1,
                        n ? t1 : r,
                        0
                    ],
                    [
                        n ? r : i,
                        n ? i : r,
                        0
                    ]
                ], c = s < 0 ? e1.EXTENT + s : s, h = [
                    n ? c : (t1 + i) / 2,
                    n ? (t1 + i) / 2 : c,
                    0
                ];
                return 0 === r && s < 0 || 0 !== r && s > 0 ? a.getForTilePoints(f, [
                    h
                ], !0, m) : l.push(h), a.getForTilePoints(o, l, !0, p), Math.max(l[0][2], l[1][2], h[2]) / a.exaggeration();
            };
            for(let t2 = 0; t2 < 4; t2++){
                const i1 = (t2 < 2 ? 1 : 5) - t2, n1 = r.borders[t2];
                if (0 === n1.length) continue;
                const c1 = f = s[t2](o), h1 = l(c1);
                if (!(h1 && h1 instanceof e1.FillExtrusionBucket && h1.enableTerrain)) continue;
                if (r.borderDoneWithNeighborZ[t2] === h1.canonical.z && h1.borderDoneWithNeighborZ[i1] === r.canonical.z) continue;
                if (m = a.findDEMTileFor(c1), !m || !m.dem) continue;
                if (!p) {
                    const e2 = a.findDEMTileFor(o);
                    if (!e2 || !e2.dem) return;
                    p = e2;
                }
                const _1 = h1.borders[i1];
                let v = 0;
                const x = h1.borderDoneWithNeighborZ[i1] !== r.canonical.z;
                if (r.canonical.z === h1.canonical.z) {
                    for(let o1 = 0; o1 < n1.length; o1++){
                        const a1 = r.featuresOnBorder[n1[o1]], s1 = a1.borders[t2];
                        let l1;
                        for(; v < _1.length && (l1 = h1.featuresOnBorder[_1[v]], !(l1.borders[i1][1] > s1[0] + 3));)x && h1.encodeCentroid(void 0, l1, !1), v++;
                        if (l1 && v < _1.length) {
                            const o2 = v;
                            let n2 = 0;
                            for(; !(l1.borders[i1][0] > s1[1] - 3) && (n2++, ++v !== _1.length);)l1 = h1.featuresOnBorder[_1[v]];
                            if (l1 = h1.featuresOnBorder[_1[o2]], a1.intersectsCount() > 1 || l1.intersectsCount() > 1 || 1 !== n2) {
                                1 !== n2 && (v = o2), r.encodeCentroid(void 0, a1, !1), x && h1.encodeCentroid(void 0, l1, !1);
                                continue;
                            }
                            const c2 = u[t2](a1, l1), p1 = t2 % 2 ? e1.EXTENT - 1 : 0;
                            d.x = g(c2[0], Math.min(e1.EXTENT - 1, c2[1]), p1, t2 < 2, c2[2]), d.y = 0, r.encodeCentroid(d, a1, !1), x && h1.encodeCentroid(d, l1, !1);
                        } else r.encodeCentroid(void 0, a1, !1);
                    }
                    r.borderDoneWithNeighborZ[t2] = h1.canonical.z, r.needsCentroidUpdate = !0, x && (h1.borderDoneWithNeighborZ[i1] = r.canonical.z, h1.needsCentroidUpdate = !0);
                } else {
                    for (const e3 of n1)r.encodeCentroid(void 0, r.featuresOnBorder[e3], !1);
                    if (x) {
                        for (const e4 of _1)h1.encodeCentroid(void 0, h1.featuresOnBorder[e4], !1);
                        h1.borderDoneWithNeighborZ[i1] = r.canonical.z, h1.needsCentroidUpdate = !0;
                    }
                    r.borderDoneWithNeighborZ[t2] = h1.canonical.z, r.needsCentroidUpdate = !0;
                }
            }
            (r.needsCentroidUpdate || !r.centroidVertexBuffer && 0 !== r.centroidVertexArray.length) && r.uploadCentroid(t1);
        }
        const bo = new e1.Color(1, 0, 0, 1), wo = new e1.Color(0, 1, 0, 1), To = new e1.Color(0, 0, 1, 1), Eo = new e1.Color(1, 0, 1, 1), Co = new e1.Color(0, 1, 1, 1);
        function Io(t1, i, o) {
            const r = t1.context, n = t1.transform, a = r.gl, s = "globe" === n.projection.name, l = s ? [
                "PROJECTION_GLOBE_VIEW"
            ] : null;
            let c = o.projMatrix;
            if (s && e1.globeToMercatorTransition(n.zoom) > 0) {
                const t2 = e1.transitionTileAABBinECEF(o.canonical, n), i1 = e1.globeDenormalizeECEF(t2);
                c = e1.multiply(new Float32Array(16), n.globeMatrix, i1), e1.multiply(c, n.projMatrix, c);
            }
            const h = t1.useProgram("debug", null, l), _ = i.getTileByID(o.key);
            t1.terrain && t1.terrain.setupElevationDraw(_, h);
            const u = e1.DepthMode.disabled, d = e1.StencilMode.disabled, p = t1.colorModeForRenderPass(), m = "$debug";
            r.activeTexture.set(a.TEXTURE0), t1.emptyTexture.bind(a.LINEAR, a.CLAMP_TO_EDGE), s ? _._makeGlobeTileDebugBuffers(t1.context, n) : _._makeDebugTileBoundsBuffers(t1.context, n.projection);
            const f = _._tileDebugBuffer || t1.debugBuffer, g = _._tileDebugIndexBuffer || t1.debugIndexBuffer, v = _._tileDebugSegments || t1.debugSegments;
            h.draw(r, a.LINE_STRIP, u, d, p, e1.CullFaceMode.disabled, Xi(c, e1.Color.red), m, f, g, v, null, null, null, [
                _._globeTileDebugBorderBuffer
            ]);
            const x = _.latestRawTileData, y = Math.floor((x && x.byteLength || 0) / 1024), b = i.getTile(o).tileSize, w = 512 / Math.min(b, 512) * (o.overscaledZ / n.zoom) * .5;
            let T = o.canonical.toString();
            o.overscaledZ !== o.canonical.z && (T += ` => ${o.overscaledZ}`), T += ` ${y}kb`, function(e1, t1) {
                e1.initDebugOverlayCanvas();
                const i = e1.debugOverlayCanvas, o = e1.context.gl, r = e1.debugOverlayCanvas.getContext("2d");
                r.clearRect(0, 0, i.width, i.height), r.shadowColor = "white", r.shadowBlur = 2, r.lineWidth = 1.5, r.strokeStyle = "white", r.textBaseline = "top", r.font = "bold 36px Open Sans, sans-serif", r.fillText(t1, 5, 5), r.strokeText(t1, 5, 5), e1.debugOverlayTexture.update(i), e1.debugOverlayTexture.bind(o.LINEAR, o.CLAMP_TO_EDGE);
            }(t1, T);
            const E = _._tileDebugTextBuffer || t1.debugBuffer, C = _._tileDebugTextIndexBuffer || t1.quadTriangleIndexBuffer, I = _._tileDebugTextSegments || t1.debugSegments;
            h.draw(r, a.TRIANGLES, u, d, e1.ColorMode.alphaBlended, e1.CullFaceMode.disabled, Xi(c, e1.Color.transparent, w), m, E, C, I, null, null, null, [
                _._globeTileDebugTextBuffer
            ]);
        }
        function Mo(e1, t1, i, o) {
            zo(e1, 0, t1 + i / 2, e1.transform.width, i, o);
        }
        function So(e1, t1, i, o) {
            zo(e1, t1 - i / 2, 0, i, e1.transform.height, o);
        }
        function zo(t1, i, o, r, n, a) {
            const s = t1.context, l = s.gl;
            l.enable(l.SCISSOR_TEST), l.scissor(i * e1.exported.devicePixelRatio, o * e1.exported.devicePixelRatio, r * e1.exported.devicePixelRatio, n * e1.exported.devicePixelRatio), s.clear({
                color: a
            }), l.disable(l.SCISSOR_TEST);
        }
        const Do = e1.createLayout([
            {
                name: "a_pos_3f",
                components: 3,
                type: "Float32"
            }
        ]), { members: Ao  } = Do;
        function Po(e1, t1, i, o) {
            e1.emplaceBack(t1, i, o);
        }
        class Lo {
            constructor(t1){
                this.vertexArray = new e1.StructArrayLayout3f12, this.indices = new e1.StructArrayLayout3ui6, Po(this.vertexArray, -1, -1, 1), Po(this.vertexArray, 1, -1, 1), Po(this.vertexArray, -1, 1, 1), Po(this.vertexArray, 1, 1, 1), Po(this.vertexArray, -1, -1, -1), Po(this.vertexArray, 1, -1, -1), Po(this.vertexArray, -1, 1, -1), Po(this.vertexArray, 1, 1, -1), this.indices.emplaceBack(5, 1, 3), this.indices.emplaceBack(3, 7, 5), this.indices.emplaceBack(6, 2, 0), this.indices.emplaceBack(0, 4, 6), this.indices.emplaceBack(2, 6, 7), this.indices.emplaceBack(7, 3, 2), this.indices.emplaceBack(5, 4, 0), this.indices.emplaceBack(0, 1, 5), this.indices.emplaceBack(0, 2, 3), this.indices.emplaceBack(3, 1, 0), this.indices.emplaceBack(7, 6, 4), this.indices.emplaceBack(4, 5, 7), this.vertexBuffer = t1.createVertexBuffer(this.vertexArray, Ao), this.indexBuffer = t1.createIndexBuffer(this.indices), this.segment = e1.SegmentVector.simpleSegment(0, 0, 36, 12);
            }
        }
        function Ro(t1, i, o, r, n, a) {
            const s = t1.gl, l = i.paint.get("sky-atmosphere-color"), c = i.paint.get("sky-atmosphere-halo-color"), h = i.paint.get("sky-atmosphere-sun-intensity"), _ = ((e1, t1, i, o, r)=>({
                    u_matrix_3f: e1,
                    u_sun_direction: t1,
                    u_sun_intensity: i,
                    u_color_tint_r: [
                        o.r,
                        o.g,
                        o.b,
                        o.a
                    ],
                    u_color_tint_m: [
                        r.r,
                        r.g,
                        r.b,
                        r.a
                    ],
                    u_luminance: 5e-5
                }))(e1.fromMat4(e1.create$1(), r), n, h, l, c);
            s.framebufferTexture2D(s.FRAMEBUFFER, s.COLOR_ATTACHMENT0, s.TEXTURE_CUBE_MAP_POSITIVE_X + a, i.skyboxTexture, 0), o.draw(t1, s.TRIANGLES, e1.DepthMode.disabled, e1.StencilMode.disabled, e1.ColorMode.unblended, e1.CullFaceMode.frontCW, _, "skyboxCapture", i.skyboxGeometry.vertexBuffer, i.skyboxGeometry.indexBuffer, i.skyboxGeometry.segment);
        }
        const Oo = e1.createLayout([
            {
                type: "Float32",
                name: "a_pos",
                components: 3
            },
            {
                type: "Float32",
                name: "a_uv",
                components: 2
            }
        ]);
        class Bo {
            constructor(t1){
                const i = new e1.StructArrayLayout5f20;
                i.emplaceBack(-1, 1, 1, 0, 0), i.emplaceBack(1, 1, 1, 1, 0), i.emplaceBack(1, -1, 1, 1, 1), i.emplaceBack(-1, -1, 1, 0, 1);
                const o = new e1.StructArrayLayout3ui6;
                o.emplaceBack(0, 1, 2), o.emplaceBack(2, 3, 0), this.vertexBuffer = t1.createVertexBuffer(i, Oo.members), this.indexBuffer = t1.createIndexBuffer(o), this.segments = e1.SegmentVector.simpleSegment(0, 0, 4, 2);
            }
            destroy() {
                this.vertexBuffer.destroy(), this.indexBuffer.destroy(), this.segments.destroy();
            }
        }
        const ko = {
            symbol: function(t1, i, o, r, n) {
                if ("translucent" !== t1.renderPass) return;
                const a = e1.StencilMode.disabled, s = t1.colorModeForRenderPass();
                o.layout.get("text-variable-anchor") && function(t1, i, o, r, n, a, s) {
                    const l = i.transform, c = "map" === n, h = "map" === a;
                    for (const i1 of t1){
                        const t2 = r.getTile(i1), n1 = t2.getBucket(o);
                        if (!n1 || !n1.text || !n1.text.segments.get().length) continue;
                        const a1 = e1.evaluateSizeForZoom(n1.textSizeData, l.zoom), _ = wt(i1, n1.getProjection(), l), u = l.calculatePixelsToTileUnitsMatrix(t2), d = tt(_, t2.tileID.canonical, h, c, l, n1.getProjection(), u), p = "none" !== o.layout.get("icon-text-fit") && n1.hasIconData();
                        if (a1) {
                            const o1 = Math.pow(2, l.zoom - t2.tileID.overscaledZ);
                            po(n1, c, h, s, e1.symbolSize, l, d, i1, o1, a1, p);
                        }
                    }
                }(r, t1, o, i, o.layout.get("text-rotation-alignment"), o.layout.get("text-pitch-alignment"), n), 0 !== o.paint.get("icon-opacity").constantOr(1) && fo(t1, i, o, r, !1, o.paint.get("icon-translate"), o.paint.get("icon-translate-anchor"), o.layout.get("icon-rotation-alignment"), o.layout.get("icon-pitch-alignment"), o.layout.get("icon-keep-upright"), a, s), 0 !== o.paint.get("text-opacity").constantOr(1) && fo(t1, i, o, r, !0, o.paint.get("text-translate"), o.paint.get("text-translate-anchor"), o.layout.get("text-rotation-alignment"), o.layout.get("text-pitch-alignment"), o.layout.get("text-keep-upright"), a, s), i.map.showCollisionBoxes && (ho(t1, i, o, r, o.paint.get("text-translate"), o.paint.get("text-translate-anchor"), !0), ho(t1, i, o, r, o.paint.get("icon-translate"), o.paint.get("icon-translate-anchor"), !1));
            },
            circle: function(t1, i, o, r) {
                if ("translucent" !== t1.renderPass) return;
                const n = o.paint.get("circle-opacity"), a = o.paint.get("circle-stroke-width"), s = o.paint.get("circle-stroke-opacity"), l = void 0 !== o.layout.get("circle-sort-key").constantOr(1);
                if (0 === n.constantOr(1) && (0 === a.constantOr(1) || 0 === s.constantOr(1))) return;
                const c = t1.context, h = c.gl, _ = t1.transform, u = t1.depthModeForSublayer(0, e1.DepthMode.ReadOnly), d = e1.StencilMode.disabled, p = t1.colorModeForRenderPass(), m = "globe" === _.projection.name, f = [
                    e1.mercatorXfromLng(_.center.lng),
                    e1.mercatorYfromLat(_.center.lat)
                ], g = [];
                for(let n1 = 0; n1 < r.length; n1++){
                    const a1 = r[n1], s1 = i.getTile(a1), c1 = s1.getBucket(o);
                    if (!c1 || c1.projection.name !== _.projection.name) continue;
                    const h1 = c1.programConfigurations.get(o.id), u1 = Vi(o);
                    m && u1.push("PROJECTION_GLOBE_VIEW");
                    const d1 = t1.useProgram("circle", h1, u1), p1 = c1.layoutVertexBuffer, v = c1.globeExtVertexBuffer, x = c1.indexBuffer, y = _.projection.createInversionMatrix(_, a1.canonical), b = {
                        programConfiguration: h1,
                        program: d1,
                        layoutVertexBuffer: p1,
                        globeExtVertexBuffer: v,
                        indexBuffer: x,
                        uniformValues: Zi(t1, a1, s1, y, f, o),
                        tile: s1
                    };
                    if (l) {
                        const t2 = c1.segments.get();
                        for (const i1 of t2)g.push({
                            segments: new e1.SegmentVector([
                                i1
                            ]),
                            sortKey: i1.sortKey,
                            state: b
                        });
                    } else g.push({
                        segments: c1.segments,
                        sortKey: 0,
                        state: b
                    });
                }
                l && g.sort((e1, t1)=>e1.sortKey - t1.sortKey);
                const v1 = {
                    useDepthForOcclusion: !m
                };
                for (const i2 of g){
                    const { programConfiguration: r1 , program: n2 , layoutVertexBuffer: a2 , globeExtVertexBuffer: s2 , indexBuffer: l1 , uniformValues: m1 , tile: f1  } = i2.state, g1 = i2.segments;
                    t1.terrain && t1.terrain.setupElevationDraw(f1, n2, v1), t1.prepareDrawProgram(c, n2, f1.tileID.toUnwrapped()), n2.draw(c, h.TRIANGLES, u, d, p, e1.CullFaceMode.disabled, m1, o.id, a2, l1, g1, o.paint, _.zoom, r1, [
                        s2
                    ]);
                }
            },
            heatmap: function(t1, i, o, r) {
                if (0 !== o.paint.get("heatmap-opacity")) {
                    if ("offscreen" === t1.renderPass) {
                        const n = t1.context, a = n.gl, s = e1.StencilMode.disabled, l = new e1.ColorMode([
                            a.ONE,
                            a.ONE
                        ], e1.Color.transparent, [
                            !0,
                            !0,
                            !0,
                            !0
                        ]);
                        !function(e1, t1, i, o) {
                            const r = e1.gl, n = t1.width * o, a = t1.height * o;
                            e1.activeTexture.set(r.TEXTURE1), e1.viewport.set([
                                0,
                                0,
                                n,
                                a
                            ]);
                            let s = i.heatmapFbo;
                            if (!s || s && (s.width !== n || s.height !== a)) {
                                s && s.destroy();
                                const t2 = r.createTexture();
                                r.bindTexture(r.TEXTURE_2D, t2), r.texParameteri(r.TEXTURE_2D, r.TEXTURE_WRAP_S, r.CLAMP_TO_EDGE), r.texParameteri(r.TEXTURE_2D, r.TEXTURE_WRAP_T, r.CLAMP_TO_EDGE), r.texParameteri(r.TEXTURE_2D, r.TEXTURE_MIN_FILTER, r.LINEAR), r.texParameteri(r.TEXTURE_2D, r.TEXTURE_MAG_FILTER, r.LINEAR), s = i.heatmapFbo = e1.createFramebuffer(n, a, !1), function(e1, t1, i, o, r, n) {
                                    const a = e1.gl;
                                    a.texImage2D(a.TEXTURE_2D, 0, a.RGBA, r, n, 0, a.RGBA, e1.extRenderToTextureHalfFloat ? e1.extTextureHalfFloat.HALF_FLOAT_OES : a.UNSIGNED_BYTE, null), o.colorAttachment.set(i);
                                }(e1, 0, t2, s, n, a);
                            } else r.bindTexture(r.TEXTURE_2D, s.colorAttachment.get()), e1.bindFramebuffer.set(s.framebuffer);
                        }(n, t1, o, "globe" === t1.transform.projection.name ? .5 : .25), n.clear({
                            color: e1.Color.transparent
                        });
                        const c = t1.transform, h = "globe" === c.projection.name, _ = h ? [
                            "PROJECTION_GLOBE_VIEW"
                        ] : null, u = h ? e1.CullFaceMode.frontCCW : e1.CullFaceMode.disabled, d = [
                            e1.mercatorXfromLng(c.center.lng),
                            e1.mercatorYfromLat(c.center.lat)
                        ];
                        for(let p = 0; p < r.length; p++){
                            const m = r[p];
                            if (i.hasRenderableParent(m)) continue;
                            const f = i.getTile(m), g = f.getBucket(o);
                            if (!g || g.projection.name !== c.projection.name) continue;
                            const v = g.programConfigurations.get(o.id), x = t1.useProgram("heatmap", v, _), { zoom: y  } = t1.transform;
                            t1.terrain && t1.terrain.setupElevationDraw(f, x), t1.prepareDrawProgram(n, x, m.toUnwrapped());
                            const b = c.projection.createInversionMatrix(c, m.canonical);
                            x.draw(n, a.TRIANGLES, e1.DepthMode.disabled, s, l, u, $i(t1, m, f, b, d, y, o.paint.get("heatmap-intensity")), o.id, g.layoutVertexBuffer, g.indexBuffer, g.segments, o.paint, t1.transform.zoom, v, h ? [
                                g.globeExtVertexBuffer
                            ] : null);
                        }
                        n.viewport.set([
                            0,
                            0,
                            t1.width,
                            t1.height
                        ]);
                    } else "translucent" === t1.renderPass && (t1.context.setColorMode(t1.colorModeForRenderPass()), function(t1, i) {
                        const o = t1.context, r = o.gl, n = i.heatmapFbo;
                        if (!n) return;
                        o.activeTexture.set(r.TEXTURE0), r.bindTexture(r.TEXTURE_2D, n.colorAttachment.get()), o.activeTexture.set(r.TEXTURE1);
                        let a = i.colorRampTexture;
                        a || (a = i.colorRampTexture = new e1.Texture(o, i.colorRamp, r.RGBA)), a.bind(r.LINEAR, r.CLAMP_TO_EDGE), t1.useProgram("heatmapTexture").draw(o, r.TRIANGLES, e1.DepthMode.disabled, e1.StencilMode.disabled, t1.colorModeForRenderPass(), e1.CullFaceMode.disabled, ((e1, t1, i, o)=>({
                                u_image: 0,
                                u_color_ramp: 1,
                                u_opacity: t1.paint.get("heatmap-opacity")
                            }))(0, i), i.id, t1.viewportBuffer, t1.quadTriangleIndexBuffer, t1.viewportSegments, i.paint, t1.transform.zoom);
                    }(t1, o));
                }
            },
            line: function(t1, i, o, r) {
                if ("translucent" !== t1.renderPass) return;
                const n = o.paint.get("line-opacity"), a = o.paint.get("line-width");
                if (0 === n.constantOr(1) || 0 === a.constantOr(1)) return;
                const s = t1.depthModeForSublayer(0, e1.DepthMode.ReadOnly), l = t1.colorModeForRenderPass(), c = t1.terrain && t1.terrain.renderingToTexture ? 1 : e1.exported.devicePixelRatio, h = o.paint.get("line-dasharray"), _ = h.constantOr(1), u = o.layout.get("line-cap"), d = o.paint.get("line-pattern"), p = d.constantOr(1), m = o.paint.get("line-gradient"), f = o.getCrossfadeParameters(), g = p ? "linePattern" : "line", v = t1.context, x = v.gl, y = ((e1)=>{
                    const t1 = [];
                    Qi(e1) && t1.push("RENDER_LINE_DASH"), e1.paint.get("line-gradient") && t1.push("RENDER_LINE_GRADIENT");
                    const i = e1.paint.get("line-trim-offset");
                    0 === i[0] && 0 === i[1] || t1.push("RENDER_LINE_TRIM_OFFSET");
                    const o = e1.paint.get("line-pattern").constantOr(1), r = 1 !== e1.paint.get("line-opacity").constantOr(1);
                    return !o && r && t1.push("RENDER_LINE_ALPHA_DISCARD"), t1;
                })(o);
                let b = y.includes("RENDER_LINE_ALPHA_DISCARD");
                t1.terrain && t1.terrain.clipOrMaskOverlapStencilType() && (b = !1);
                for (const n1 of r){
                    const r1 = i.getTile(n1);
                    if (p && !r1.patternsLoaded()) continue;
                    const a1 = r1.getBucket(o);
                    if (!a1) continue;
                    t1.prepareDrawTile();
                    const w = a1.programConfigurations.get(o.id), T = t1.useProgram(g, w, y), E = d.constantOr(null);
                    if (E && r1.imageAtlas) {
                        const e2 = r1.imageAtlas, t2 = e2.patternPositions[E.to.toString()], i1 = e2.patternPositions[E.from.toString()];
                        t2 && i1 && w.setConstantPatternPositions(t2, i1);
                    }
                    const C = h.constantOr(null), I = u.constantOr(null);
                    if (!p && C && I && r1.lineAtlas) {
                        const e3 = r1.lineAtlas, t3 = e3.getDash(C.to, I), i2 = e3.getDash(C.from, I);
                        t3 && i2 && w.setConstantPatternPositions(t3, i2);
                    }
                    let [M, S] = o.paint.get("line-trim-offset");
                    if ("round" === I || "square" === I) {
                        const e4 = 1;
                        M !== S && (0 === M && (M -= e4), 1 === S && (S += e4));
                    }
                    const z = t1.terrain ? n1.projMatrix : null, D = p ? Yi(t1, r1, o, f, z, c) : Hi(t1, r1, o, f, z, a1.lineClipsArray.length, c, [
                        M,
                        S
                    ]);
                    if (m) {
                        const r2 = a1.gradients[o.id];
                        let s1 = r2.texture;
                        if (o.gradientVersion !== r2.version) {
                            let l1 = 256;
                            if (o.stepInterpolant) {
                                const o1 = i.getSource().maxzoom, r3 = n1.canonical.z === o1 ? Math.ceil(1 << t1.transform.maxZoom - n1.canonical.z) : 1;
                                l1 = e1.clamp(e1.nextPowerOfTwo(a1.maxLineLength / e1.EXTENT * 1024 * r3), 256, v.maxTextureSize);
                            }
                            r2.gradient = e1.renderColorRamp({
                                expression: o.gradientExpression(),
                                evaluationKey: "lineProgress",
                                resolution: l1,
                                image: r2.gradient || void 0,
                                clips: a1.lineClipsArray
                            }), r2.texture ? r2.texture.update(r2.gradient) : r2.texture = new e1.Texture(v, r2.gradient, x.RGBA), r2.version = o.gradientVersion, s1 = r2.texture;
                        }
                        v.activeTexture.set(x.TEXTURE1), s1.bind(o.stepInterpolant ? x.NEAREST : x.LINEAR, x.CLAMP_TO_EDGE);
                    }
                    _ && (v.activeTexture.set(x.TEXTURE0), r1.lineAtlasTexture.bind(x.LINEAR, x.REPEAT), w.updatePaintBuffers(f)), p && (v.activeTexture.set(x.TEXTURE0), r1.imageAtlasTexture.bind(x.LINEAR, x.CLAMP_TO_EDGE), w.updatePaintBuffers(f)), t1.prepareDrawProgram(v, T, n1.toUnwrapped());
                    const A = (i)=>{
                        T.draw(v, x.TRIANGLES, s, i, l, e1.CullFaceMode.disabled, D, o.id, a1.layoutVertexBuffer, a1.indexBuffer, a1.segments, o.paint, t1.transform.zoom, w, [
                            a1.layoutVertexBuffer2
                        ]);
                    };
                    if (b) {
                        const i3 = t1.stencilModeForClipping(n1).ref;
                        0 === i3 && t1.terrain && v.clear({
                            stencil: 0
                        });
                        const o2 = {
                            func: x.EQUAL,
                            mask: 255
                        };
                        D.u_alpha_discard_threshold = .8, A(new e1.StencilMode(o2, i3, 255, x.KEEP, x.KEEP, x.INVERT)), D.u_alpha_discard_threshold = 0, A(new e1.StencilMode(o2, i3, 255, x.KEEP, x.KEEP, x.KEEP));
                    } else A(t1.stencilModeForClipping(n1));
                }
                b && (t1.resetStencilClippingMasks(), t1.terrain && v.clear({
                    stencil: 0
                }));
            },
            fill: function(t1, i, o, r) {
                const n = o.paint.get("fill-color"), a = o.paint.get("fill-opacity");
                if (0 === a.constantOr(1)) return;
                const s = t1.colorModeForRenderPass(), l = o.paint.get("fill-pattern"), c = t1.opaquePassEnabledForLayer() && !l.constantOr(1) && 1 === n.constantOr(e1.Color.transparent).a && 1 === a.constantOr(0) ? "opaque" : "translucent";
                if (t1.renderPass === c) {
                    const n1 = t1.depthModeForSublayer(1, "opaque" === t1.renderPass ? e1.DepthMode.ReadWrite : e1.DepthMode.ReadOnly);
                    vo(t1, i, o, r, n1, s, !1);
                }
                if ("translucent" === t1.renderPass && o.paint.get("fill-antialias")) {
                    const n2 = t1.depthModeForSublayer(o.getPaintProperty("fill-outline-color") ? 2 : 0, e1.DepthMode.ReadOnly);
                    vo(t1, i, o, r, n2, s, !0);
                }
            },
            "fill-extrusion": function(t1, i, o, r) {
                const n = o.paint.get("fill-extrusion-opacity");
                if (0 !== n && "translucent" === t1.renderPass) {
                    const a = new e1.DepthMode(t1.context.gl.LEQUAL, e1.DepthMode.ReadWrite, t1.depthRangeFor3D);
                    if (1 !== n || o.paint.get("fill-extrusion-pattern").constantOr(1)) xo(t1, i, o, r, a, e1.StencilMode.disabled, e1.ColorMode.disabled), xo(t1, i, o, r, a, t1.stencilModeFor3D(), t1.colorModeForRenderPass()), t1.resetStencilClippingMasks();
                    else {
                        const n1 = t1.colorModeForRenderPass();
                        xo(t1, i, o, r, a, e1.StencilMode.disabled, n1);
                    }
                }
            },
            hillshade: function(t1, i, o, r) {
                if ("offscreen" !== t1.renderPass && "translucent" !== t1.renderPass) return;
                const n = t1.context, a = t1.depthModeForSublayer(0, e1.DepthMode.ReadOnly), s = t1.colorModeForRenderPass(), l = t1.terrain && t1.terrain.renderingToTexture, [c, h] = "translucent" !== t1.renderPass || l ? [
                    {},
                    r
                ] : t1.stencilConfigForOverlap(r);
                for (const r1 of h){
                    const n1 = i.getTile(r1);
                    if (n1.needsHillshadePrepare && "offscreen" === t1.renderPass) xi(t1, n1, o, a, e1.StencilMode.disabled, s);
                    else if ("translucent" === t1.renderPass) {
                        const e2 = l && t1.terrain ? t1.terrain.stencilModeForRTTOverlap(r1) : c[r1.overscaledZ];
                        gi(t1, r1, n1, o, a, e2, s);
                    }
                }
                n.viewport.set([
                    0,
                    0,
                    t1.width,
                    t1.height
                ]), t1.resetStencilClippingMasks();
            },
            raster: function(t1, i, o, r, n, a) {
                if ("translucent" !== t1.renderPass) return;
                if (0 === o.paint.get("raster-opacity")) return;
                if (!r.length) return;
                const s = t1.context, l = s.gl, c = i.getSource(), h = t1.useProgram("raster"), _ = t1.colorModeForRenderPass(), u = t1.terrain && t1.terrain.renderingToTexture, [d, p] = c instanceof De || u ? [
                    {},
                    r
                ] : t1.stencilConfigForOverlap(r), m = p[p.length - 1].overscaledZ, f = !t1.options.moving;
                for (const r1 of p){
                    const n1 = u ? e1.DepthMode.disabled : t1.depthModeForSublayer(r1.overscaledZ - m, 1 === o.paint.get("raster-opacity") ? e1.DepthMode.ReadWrite : e1.DepthMode.ReadOnly, l.LESS), p1 = r1.toUnwrapped(), g = i.getTile(r1);
                    if (u && (!g || !g.hasData())) continue;
                    const v = u ? r1.projMatrix : t1.transform.calculateProjMatrix(p1, f), x = t1.terrain && u ? t1.terrain.stencilModeForRTTOverlap(r1) : d[r1.overscaledZ], y = a ? 0 : o.paint.get("raster-fade-duration");
                    g.registerFadeDuration(y);
                    const b = i.findLoadedParent(r1, 0), w = Si(g, b, i, t1.transform, y);
                    let T, E;
                    t1.terrain && t1.terrain.prepareDrawTile();
                    const C = "nearest" === o.paint.get("raster-resampling") ? l.NEAREST : l.LINEAR;
                    s.activeTexture.set(l.TEXTURE0), g.texture.bind(C, l.CLAMP_TO_EDGE), s.activeTexture.set(l.TEXTURE1), b ? (b.texture.bind(C, l.CLAMP_TO_EDGE), T = Math.pow(2, b.tileID.overscaledZ - g.tileID.overscaledZ), E = [
                        g.tileID.canonical.x * T % 1,
                        g.tileID.canonical.y * T % 1
                    ]) : g.texture.bind(C, l.CLAMP_TO_EDGE);
                    const I = eo(v, E || [
                        0,
                        0
                    ], T || 1, w, o, c instanceof De ? c.perspectiveTransform : [
                        0,
                        0
                    ]);
                    if (t1.prepareDrawProgram(s, h, p1), c instanceof De) c.boundsBuffer && c.boundsSegments && h.draw(s, l.TRIANGLES, n1, e1.StencilMode.disabled, _, e1.CullFaceMode.disabled, I, o.id, c.boundsBuffer, t1.quadTriangleIndexBuffer, c.boundsSegments);
                    else {
                        const { tileBoundsBuffer: i1 , tileBoundsIndexBuffer: r2 , tileBoundsSegments: a1  } = t1.getTileBoundsBuffers(g);
                        h.draw(s, l.TRIANGLES, n1, x, _, e1.CullFaceMode.disabled, I, o.id, i1, r2, a1);
                    }
                }
                t1.resetStencilClippingMasks();
            },
            background: function(t1, i, o, r) {
                const n = o.paint.get("background-color"), a = o.paint.get("background-opacity");
                if (0 === a) return;
                const s = t1.context, l = s.gl, c = t1.transform, h = c.tileSize, _ = o.paint.get("background-pattern");
                if (t1.isPatternMissing(_)) return;
                const u = !_ && 1 === n.a && 1 === a && t1.opaquePassEnabledForLayer() ? "opaque" : "translucent";
                if (t1.renderPass !== u) return;
                const d = e1.StencilMode.disabled, p = t1.depthModeForSublayer(0, "opaque" === u ? e1.DepthMode.ReadWrite : e1.DepthMode.ReadOnly), m = t1.colorModeForRenderPass(), f = t1.useProgram(_ ? "backgroundPattern" : "background");
                let g, v = r;
                v || (g = t1.getBackgroundTiles(), v = Object.values(g).map((e1)=>e1.tileID)), _ && (s.activeTexture.set(l.TEXTURE0), t1.imageManager.bind(t1.context));
                const x = o.getCrossfadeParameters();
                for (const u1 of v){
                    const v1 = u1.toUnwrapped(), y = r ? u1.projMatrix : t1.transform.calculateProjMatrix(v1);
                    t1.prepareDrawTile();
                    const b = i ? i.getTile(u1) : g ? g[u1.key] : new e1.Tile(u1, h, c.zoom, t1), w = _ ? so(y, a, t1, _, {
                        tileID: u1,
                        tileSize: h
                    }, x) : ao(y, a, n);
                    t1.prepareDrawProgram(s, f, v1);
                    const { tileBoundsBuffer: T , tileBoundsIndexBuffer: E , tileBoundsSegments: C  } = t1.getTileBoundsBuffers(b);
                    f.draw(s, l.TRIANGLES, p, d, m, e1.CullFaceMode.disabled, w, o.id, T, E, C);
                }
            },
            sky: function(t1, i, o) {
                const r = t1.transform, n = "mercator" === r.projection.name || "globe" === r.projection.name ? 1 : e1.smoothstep(7, 8, r.zoom), a = o.paint.get("sky-opacity") * n;
                if (0 === a) return;
                const s = t1.context, l = o.paint.get("sky-type"), c = new e1.DepthMode(s.gl.LEQUAL, e1.DepthMode.ReadOnly, [
                    0,
                    1
                ]), h = t1.frameCounter / 1e3 % 1;
                "atmosphere" === l ? "offscreen" === t1.renderPass ? o.needsSkyboxCapture(t1) && (function(t1, i, o, r) {
                    const n = t1.context, a = n.gl;
                    let s = i.skyboxFbo;
                    if (!s) {
                        s = i.skyboxFbo = n.createFramebuffer(32, 32, !1), i.skyboxGeometry = new Lo(n), i.skyboxTexture = n.gl.createTexture(), a.bindTexture(a.TEXTURE_CUBE_MAP, i.skyboxTexture), a.texParameteri(a.TEXTURE_CUBE_MAP, a.TEXTURE_WRAP_S, a.CLAMP_TO_EDGE), a.texParameteri(a.TEXTURE_CUBE_MAP, a.TEXTURE_WRAP_T, a.CLAMP_TO_EDGE), a.texParameteri(a.TEXTURE_CUBE_MAP, a.TEXTURE_MIN_FILTER, a.LINEAR), a.texParameteri(a.TEXTURE_CUBE_MAP, a.TEXTURE_MAG_FILTER, a.LINEAR);
                        for(let e2 = 0; e2 < 6; ++e2)a.texImage2D(a.TEXTURE_CUBE_MAP_POSITIVE_X + e2, 0, a.RGBA, 32, 32, 0, a.RGBA, a.UNSIGNED_BYTE, null);
                    }
                    n.bindFramebuffer.set(s.framebuffer), n.viewport.set([
                        0,
                        0,
                        32,
                        32
                    ]);
                    const l = i.getCenter(t1, !0), c = t1.useProgram("skyboxCapture"), h = new Float64Array(16);
                    e1.identity(h), e1.rotateY(h, h, .5 * -Math.PI), Ro(n, i, c, h, l, 0), e1.identity(h), e1.rotateY(h, h, .5 * Math.PI), Ro(n, i, c, h, l, 1), e1.identity(h), e1.rotateX(h, h, .5 * -Math.PI), Ro(n, i, c, h, l, 2), e1.identity(h), e1.rotateX(h, h, .5 * Math.PI), Ro(n, i, c, h, l, 3), e1.identity(h), Ro(n, i, c, h, l, 4), e1.identity(h), e1.rotateY(h, h, Math.PI), Ro(n, i, c, h, l, 5), n.viewport.set([
                        0,
                        0,
                        t1.width,
                        t1.height
                    ]);
                }(t1, o), o.markSkyboxValid(t1)) : "sky" === t1.renderPass && function(t1, i, o, r, n) {
                    const a = t1.context, s = a.gl, l = t1.transform, c = t1.useProgram("skybox");
                    a.activeTexture.set(s.TEXTURE0), s.bindTexture(s.TEXTURE_CUBE_MAP, i.skyboxTexture);
                    const h = ((e1, t1, i, o, r)=>({
                            u_matrix: e1,
                            u_sun_direction: t1,
                            u_cubemap: 0,
                            u_opacity: o,
                            u_temporal_offset: r
                        }))(l.skyboxMatrix, i.getCenter(t1, !1), 0, r, n);
                    t1.prepareDrawProgram(a, c), c.draw(a, s.TRIANGLES, o, e1.StencilMode.disabled, t1.colorModeForRenderPass(), e1.CullFaceMode.backCW, h, "skybox", i.skyboxGeometry.vertexBuffer, i.skyboxGeometry.indexBuffer, i.skyboxGeometry.segment);
                }(t1, o, c, a, h) : "gradient" === l && "sky" === t1.renderPass && function(t1, i, o, r, n) {
                    const a = t1.context, s = a.gl, l = t1.transform, c = t1.useProgram("skyboxGradient");
                    i.skyboxGeometry || (i.skyboxGeometry = new Lo(a)), a.activeTexture.set(s.TEXTURE0);
                    let h = i.colorRampTexture;
                    h || (h = i.colorRampTexture = new e1.Texture(a, i.colorRamp, s.RGBA)), h.bind(s.LINEAR, s.CLAMP_TO_EDGE);
                    const _ = ((t1, i, o, r, n)=>({
                            u_matrix: t1,
                            u_color_ramp: 0,
                            u_center_direction: i,
                            u_radius: e1.degToRad(o),
                            u_opacity: r,
                            u_temporal_offset: n
                        }))(l.skyboxMatrix, i.getCenter(t1, !1), i.paint.get("sky-gradient-radius"), r, n);
                    t1.prepareDrawProgram(a, c), c.draw(a, s.TRIANGLES, o, e1.StencilMode.disabled, t1.colorModeForRenderPass(), e1.CullFaceMode.backCW, _, "skyboxGradient", i.skyboxGeometry.vertexBuffer, i.skyboxGeometry.indexBuffer, i.skyboxGeometry.segment);
                }(t1, o, c, a, h);
            },
            debug: function(e1, t1, i) {
                for(let o = 0; o < i.length; o++)Io(e1, t1, i[o]);
            },
            custom: function(t1, i, o) {
                const r = t1.context, n = o.implementation;
                if (t1.transform.projection.unsupportedLayers && t1.transform.projection.unsupportedLayers.includes("custom")) e1.warnOnce("Custom layers are not yet supported with non-mercator projections. Use mercator to enable custom layers.");
                else if ("offscreen" === t1.renderPass) {
                    const e2 = n.prerender;
                    e2 && (t1.setCustomLayerDefaults(), r.setColorMode(t1.colorModeForRenderPass()), e2.call(n, r.gl, t1.transform.customLayerMatrix()), r.setDirty(), t1.setBaseState());
                } else if ("translucent" === t1.renderPass) {
                    t1.setCustomLayerDefaults(), r.setColorMode(t1.colorModeForRenderPass()), r.setStencilMode(e1.StencilMode.disabled);
                    const i1 = "3d" === n.renderingMode ? new e1.DepthMode(t1.context.gl.LEQUAL, e1.DepthMode.ReadWrite, t1.depthRangeFor3D) : t1.depthModeForSublayer(0, e1.DepthMode.ReadOnly);
                    r.setDepthMode(i1), n.render(r.gl, t1.transform.customLayerMatrix()), r.setDirty(), t1.setBaseState(), r.bindFramebuffer.set(null);
                }
            }
        };
        class Fo {
            constructor(t1, i){
                this.context = new Ie(t1), this.transform = i, this._tileTextures = {}, this.frameCopies = [], this.loadTimeStamps = [], this.setup(), this.numSublayers = e1.SourceCache.maxUnderzooming + e1.SourceCache.maxOverzooming + 1, this.depthEpsilon = 1 / Math.pow(2, 16), this.crossTileSymbolIndex = new $t, this.deferredRenderGpuTimeQueries = [], this.gpuTimers = {}, this.frameCounter = 0, this._backgroundTiles = {};
            }
            updateTerrain(e1, t1) {
                const i = !!e1 && !!e1.terrain && this.transform.projection.supportsTerrain;
                if (!(i || this._terrain && this._terrain.enabled)) return;
                this._terrain || (this._terrain = new Pi(this, e1));
                const o = this._terrain;
                this.transform.elevation = i ? o : null, o.update(e1, this.transform, t1);
            }
            _updateFog(e1) {
                const t1 = e1.fog;
                if (!t1 || "globe" === this.transform.projection.name || t1.getOpacity(this.transform.pitch) < 1 || t1.properties.get("horizon-blend") < .03) return void (this.transform.fogCullDistSq = null);
                const [i, o] = t1.getFovAdjustedRange(this.transform._fov);
                if (i > o) return void (this.transform.fogCullDistSq = null);
                const r = i + .78 * (o - i);
                this.transform.fogCullDistSq = r * r;
            }
            get terrain() {
                return this.transform._terrainEnabled() && this._terrain && this._terrain.enabled ? this._terrain : null;
            }
            resize(t1, i) {
                if (this.width = t1 * e1.exported.devicePixelRatio, this.height = i * e1.exported.devicePixelRatio, this.context.viewport.set([
                    0,
                    0,
                    this.width,
                    this.height
                ]), this.style) for (const e2 of this.style.order)this.style._layers[e2].resize();
            }
            setup() {
                const t1 = this.context, i = new e1.StructArrayLayout2i4;
                i.emplaceBack(0, 0), i.emplaceBack(e1.EXTENT, 0), i.emplaceBack(0, e1.EXTENT), i.emplaceBack(e1.EXTENT, e1.EXTENT), this.tileExtentBuffer = t1.createVertexBuffer(i, e1.posAttributes.members), this.tileExtentSegments = e1.SegmentVector.simpleSegment(0, 0, 4, 2);
                const o = new e1.StructArrayLayout2i4;
                o.emplaceBack(0, 0), o.emplaceBack(e1.EXTENT, 0), o.emplaceBack(0, e1.EXTENT), o.emplaceBack(e1.EXTENT, e1.EXTENT), this.debugBuffer = t1.createVertexBuffer(o, e1.posAttributes.members), this.debugSegments = e1.SegmentVector.simpleSegment(0, 0, 4, 5);
                const r = new e1.StructArrayLayout2i4;
                r.emplaceBack(-1, -1), r.emplaceBack(1, -1), r.emplaceBack(-1, 1), r.emplaceBack(1, 1), this.viewportBuffer = t1.createVertexBuffer(r, e1.posAttributes.members), this.viewportSegments = e1.SegmentVector.simpleSegment(0, 0, 4, 2);
                const n = new e1.StructArrayLayout4i8;
                n.emplaceBack(0, 0, 0, 0), n.emplaceBack(e1.EXTENT, 0, e1.EXTENT, 0), n.emplaceBack(0, e1.EXTENT, 0, e1.EXTENT), n.emplaceBack(e1.EXTENT, e1.EXTENT, e1.EXTENT, e1.EXTENT), this.mercatorBoundsBuffer = t1.createVertexBuffer(n, e1.boundsAttributes.members), this.mercatorBoundsSegments = e1.SegmentVector.simpleSegment(0, 0, 4, 2);
                const a = new e1.StructArrayLayout3ui6;
                a.emplaceBack(0, 1, 2), a.emplaceBack(2, 1, 3), this.quadTriangleIndexBuffer = t1.createIndexBuffer(a);
                const s = new e1.StructArrayLayout1ui2;
                for (const e2 of [
                    0,
                    1,
                    3,
                    2,
                    0
                ])s.emplaceBack(e2);
                this.debugIndexBuffer = t1.createIndexBuffer(s), this.emptyTexture = new e1.Texture(t1, new e1.RGBAImage({
                    width: 1,
                    height: 1
                }, Uint8Array.of(0, 0, 0, 0)), t1.gl.RGBA), this.identityMat = e1.create();
                const l = this.context.gl;
                this.stencilClearMode = new e1.StencilMode({
                    func: l.ALWAYS,
                    mask: 0
                }, 0, 255, l.ZERO, l.ZERO, l.ZERO), this.loadTimeStamps.push(e1.window.performance.now()), this.atmosphereBuffer = new Bo(this.context);
            }
            getMercatorTileBoundsBuffers() {
                return {
                    tileBoundsBuffer: this.mercatorBoundsBuffer,
                    tileBoundsIndexBuffer: this.quadTriangleIndexBuffer,
                    tileBoundsSegments: this.mercatorBoundsSegments
                };
            }
            getTileBoundsBuffers(e1) {
                return e1._makeTileBoundsBuffers(this.context, this.transform.projection), e1._tileBoundsBuffer ? {
                    tileBoundsBuffer: e1._tileBoundsBuffer,
                    tileBoundsIndexBuffer: e1._tileBoundsIndexBuffer,
                    tileBoundsSegments: e1._tileBoundsSegments
                } : this.getMercatorTileBoundsBuffers();
            }
            clearStencil() {
                const t1 = this.context, i = t1.gl;
                this.nextStencilID = 1, this.currentStencilSource = void 0, this._tileClippingMaskIDs = {}, this.useProgram("clippingMask").draw(t1, i.TRIANGLES, e1.DepthMode.disabled, this.stencilClearMode, e1.ColorMode.disabled, e1.CullFaceMode.disabled, Mi(this.identityMat), "$clipping", this.viewportBuffer, this.quadTriangleIndexBuffer, this.viewportSegments);
            }
            resetStencilClippingMasks() {
                this.terrain || (this.currentStencilSource = void 0, this._tileClippingMaskIDs = {});
            }
            _renderTileClippingMasks(t1, i, o) {
                if (!i || this.currentStencilSource === i.id || !t1.isTileClipped() || !o || 0 === o.length) return;
                if (this._tileClippingMaskIDs && !this.terrain) {
                    let e2 = !1;
                    for (const t2 of o)if (void 0 === this._tileClippingMaskIDs[t2.key]) {
                        e2 = !0;
                        break;
                    }
                    if (!e2) return;
                }
                this.currentStencilSource = i.id;
                const r = this.context, n = r.gl;
                this.nextStencilID + o.length > 256 && this.clearStencil(), r.setColorMode(e1.ColorMode.disabled), r.setDepthMode(e1.DepthMode.disabled);
                const a = this.useProgram("clippingMask");
                this._tileClippingMaskIDs = {};
                for (const t3 of o){
                    const o1 = i.getTile(t3), s = this._tileClippingMaskIDs[t3.key] = this.nextStencilID++, { tileBoundsBuffer: l , tileBoundsIndexBuffer: c , tileBoundsSegments: h  } = this.getTileBoundsBuffers(o1);
                    a.draw(r, n.TRIANGLES, e1.DepthMode.disabled, new e1.StencilMode({
                        func: n.ALWAYS,
                        mask: 0
                    }, s, 255, n.KEEP, n.KEEP, n.REPLACE), e1.ColorMode.disabled, e1.CullFaceMode.disabled, Mi(t3.projMatrix), "$clipping", l, c, h);
                }
            }
            stencilModeFor3D() {
                this.currentStencilSource = void 0, this.nextStencilID + 1 > 256 && this.clearStencil();
                const t1 = this.nextStencilID++, i = this.context.gl;
                return new e1.StencilMode({
                    func: i.NOTEQUAL,
                    mask: 255
                }, t1, 255, i.KEEP, i.KEEP, i.REPLACE);
            }
            stencilModeForClipping(t1) {
                if (this.terrain) return this.terrain.stencilModeForRTTOverlap(t1);
                const i = this.context.gl;
                return new e1.StencilMode({
                    func: i.EQUAL,
                    mask: 255
                }, this._tileClippingMaskIDs[t1.key], 0, i.KEEP, i.KEEP, i.REPLACE);
            }
            stencilConfigForOverlap(t1) {
                const i = this.context.gl, o = t1.sort((e1, t1)=>t1.overscaledZ - e1.overscaledZ), r = o[o.length - 1].overscaledZ, n = o[0].overscaledZ - r + 1;
                if (n > 1) {
                    this.currentStencilSource = void 0, this.nextStencilID + n > 256 && this.clearStencil();
                    const t2 = {};
                    for(let o1 = 0; o1 < n; o1++)t2[o1 + r] = new e1.StencilMode({
                        func: i.GEQUAL,
                        mask: 255
                    }, o1 + this.nextStencilID, 255, i.KEEP, i.KEEP, i.REPLACE);
                    return this.nextStencilID += n, [
                        t2,
                        o
                    ];
                }
                return [
                    {
                        [r]: e1.StencilMode.disabled
                    },
                    o
                ];
            }
            colorModeForRenderPass() {
                const t1 = this.context.gl;
                if (this._showOverdrawInspector) {
                    const i = 1 / 8;
                    return new e1.ColorMode([
                        t1.CONSTANT_COLOR,
                        t1.ONE
                    ], new e1.Color(i, i, i, 0), [
                        !0,
                        !0,
                        !0,
                        !0
                    ]);
                }
                return "opaque" === this.renderPass ? e1.ColorMode.unblended : e1.ColorMode.alphaBlended;
            }
            depthModeForSublayer(t1, i, o) {
                if (!this.opaquePassEnabledForLayer()) return e1.DepthMode.disabled;
                const r = 1 - ((1 + this.currentLayer) * this.numSublayers + t1) * this.depthEpsilon;
                return new e1.DepthMode(o || this.context.gl.LEQUAL, i, [
                    r,
                    r
                ]);
            }
            opaquePassEnabledForLayer() {
                return this.currentLayer < this.opaquePassCutoff;
            }
            render(t1, i) {
                this.style = t1, this.options = i, this.imageManager = t1.imageManager, this.glyphManager = t1.glyphManager, this.symbolFadeChange = t1.placement.symbolFadeChange(e1.exported.now()), this.imageManager.beginFrame();
                const o = this.style.order, r = this.style._sourceCaches;
                for(const e2 in r){
                    const t2 = r[e2];
                    t2.used && t2.prepare(this.context);
                }
                const n = {}, a = {}, s = {};
                for(const e3 in r){
                    const t3 = r[e3];
                    n[e3] = t3.getVisibleCoordinates(), a[e3] = n[e3].slice().reverse(), s[e3] = t3.getVisibleCoordinates(!0).reverse();
                }
                this.opaquePassCutoff = 1 / 0;
                for(let e4 = 0; e4 < o.length; e4++)if (this.style._layers[o[e4]].is3D()) {
                    this.opaquePassCutoff = e4;
                    break;
                }
                if (this.terrain && (this.terrain.updateTileBinding(s), this.opaquePassCutoff = 0), "globe" !== this.transform.projection.name || this.globeSharedBuffers || (this.globeSharedBuffers = new e1.GlobeSharedBuffers(this.context)), e1.isMapAuthenticated(this.context.gl)) {
                    this.renderPass = "offscreen";
                    for (const e5 of o){
                        const i1 = this.style._layers[e5], o1 = t1._getLayerSourceCache(i1);
                        if (!i1.hasOffscreenPass() || i1.isHidden(this.transform.zoom)) continue;
                        const r1 = o1 ? a[o1.id] : void 0;
                        ("custom" === i1.type || i1.isSky() || r1 && r1.length) && this.renderLayer(this, o1, i1, r1);
                    }
                    if (this.depthRangeFor3D = [
                        0,
                        1 - (t1.order.length + 2) * this.numSublayers * this.depthEpsilon
                    ], this.terrain && (this.style.hasSymbolLayers() || this.style.hasCircleLayers()) && this.terrain.drawDepth(), this.context.bindFramebuffer.set(null), this.context.viewport.set([
                        0,
                        0,
                        this.width,
                        this.height
                    ]), this.context.clear({
                        color: i.showOverdrawInspector ? e1.Color.black : e1.Color.transparent,
                        depth: 1
                    }), this.clearStencil(), this._showOverdrawInspector = i.showOverdrawInspector, this.renderPass = "opaque", !this.terrain) for(this.currentLayer = o.length - 1; this.currentLayer >= 0; this.currentLayer--){
                        const e6 = this.style._layers[o[this.currentLayer]], i2 = t1._getLayerSourceCache(e6);
                        if (e6.isSky()) continue;
                        const r2 = i2 ? a[i2.id] : void 0;
                        this._renderTileClippingMasks(e6, i2, r2), this.renderLayer(this, i2, e6, r2);
                    }
                    if (this.style.fog && this.transform.projection.supportsFog && function(t1, i) {
                        const o = t1.context, r = o.gl, n = t1.transform, a = new e1.DepthMode(r.LEQUAL, e1.DepthMode.ReadOnly, [
                            0,
                            1
                        ]), s = t1.useProgram("globeAtmosphere", null, "globe" === n.projection.name ? [
                            "PROJECTION_GLOBE_VIEW",
                            "FOG"
                        ] : [
                            "FOG"
                        ]), l = e1.globeToMercatorTransition(n.zoom), c = i.properties.get("color").toArray01(), h = i.properties.get("high-color").toArray01(), _ = i.properties.get("space-color").toArray01PremultipliedAlpha(), u = e1.identity$1([]);
                        e1.rotateY$1(u, u, -e1.degToRad(n._center.lng)), e1.rotateX$1(u, u, e1.degToRad(n._center.lat)), e1.rotateZ$1(u, u, n.angle), e1.rotateX$1(u, u, -n._pitch);
                        const d = e1.fromQuat(new Float32Array(16), u), p = e1.mapValue(i.properties.get("star-intensity"), 0, 1, 0, .25), m = 5e-4, f = e1.mapValue(i.properties.get("horizon-blend"), 0, 1, m, .25), g = e1.globeUseCustomAntiAliasing(t1, o, n) && f === m ? n.worldSize / (2 * Math.PI * 1.025) - 1 : n.globeRadius, v = t1.frameCounter / 1e3 % 1, x = e1.length(n.globeCenterInViewSpace), y = Math.sqrt(Math.pow(x, 2) - Math.pow(g, 2)), b = Math.acos(y / x), w = ((t1, i, o, r, n, a, s, l, c, h, _, u, d, p)=>({
                                u_frustum_tl: t1,
                                u_frustum_tr: i,
                                u_frustum_br: o,
                                u_frustum_bl: r,
                                u_horizon: n,
                                u_transition: a,
                                u_fadeout_range: s,
                                u_color: l,
                                u_high_color: c,
                                u_space_color: h,
                                u_star_intensity: _,
                                u_star_size: 5 * e1.exported.devicePixelRatio,
                                u_star_density: 0,
                                u_temporal_offset: u,
                                u_horizon_angle: d,
                                u_rotation_matrix: p
                            }))(n.frustumCorners.TL, n.frustumCorners.TR, n.frustumCorners.BR, n.frustumCorners.BL, n.frustumCorners.horizon, l, f, c, h, _, p, v, b, d);
                        t1.prepareDrawProgram(o, s);
                        const T = t1.atmosphereBuffer;
                        T && s.draw(o, r.TRIANGLES, a, e1.StencilMode.disabled, e1.ColorMode.alphaBlended, e1.CullFaceMode.backCW, w, "skybox", T.vertexBuffer, T.indexBuffer, T.segments);
                    }(this, this.style.fog), this.renderPass = "sky", (e1.globeToMercatorTransition(this.transform.zoom) > 0 || "globe" !== this.transform.projection.name) && this.transform.isHorizonVisible()) for(this.currentLayer = 0; this.currentLayer < o.length; this.currentLayer++){
                        const e7 = this.style._layers[o[this.currentLayer]], i3 = t1._getLayerSourceCache(e7);
                        e7.isSky() && this.renderLayer(this, i3, e7, i3 ? a[i3.id] : void 0);
                    }
                    for(this.renderPass = "translucent", this.currentLayer = 0; this.currentLayer < o.length;){
                        const e8 = this.style._layers[o[this.currentLayer]], i4 = t1._getLayerSourceCache(e8);
                        if (e8.isSky()) {
                            ++this.currentLayer;
                            continue;
                        }
                        if (this.terrain && this.style.isLayerDraped(e8)) {
                            if (e8.isHidden(this.transform.zoom)) {
                                ++this.currentLayer;
                                continue;
                            }
                            this.currentLayer = this.terrain.renderBatch(this.currentLayer);
                            continue;
                        }
                        const r3 = i4 ? ("symbol" === e8.type ? s : a)[i4.id] : void 0;
                        this._renderTileClippingMasks(e8, i4, i4 ? n[i4.id] : void 0), this.renderLayer(this, i4, e8, r3), ++this.currentLayer;
                    }
                    if (this.terrain && this.terrain.postRender(), this.options.showTileBoundaries || this.options.showQueryGeometry || this.options.showTileAABBs) {
                        let i5 = null;
                        e1.values(this.style._layers).forEach((e1)=>{
                            const o = t1._getLayerSourceCache(e1);
                            o && !e1.isHidden(this.transform.zoom) && (!i5 || i5.getSource().maxzoom < o.getSource().maxzoom) && (i5 = o);
                        }), i5 && this.options.showTileBoundaries && ko.debug(this, i5, i5.getVisibleCoordinates());
                    }
                    this.options.showPadding && function(e1) {
                        const t1 = e1.transform.padding;
                        Mo(e1, e1.transform.height - (t1.top || 0), 3, bo), Mo(e1, t1.bottom || 0, 3, wo), So(e1, t1.left || 0, 3, To), So(e1, e1.transform.width - (t1.right || 0), 3, Eo);
                        const i = e1.transform.centerPoint;
                        !function(e1, t1, i, o) {
                            zo(e1, t1 - 1, i - 10, 2, 20, o), zo(e1, t1 - 10, i - 1, 20, 2, o);
                        }(e1, i.x, e1.transform.height - i.y, Co);
                    }(this), this.context.setDefault(), this.frameCounter = (this.frameCounter + 1) % Number.MAX_SAFE_INTEGER, this.tileLoaded && this.options.speedIndexTiming && (this.loadTimeStamps.push(e1.window.performance.now()), this.saveCanvasCopy());
                }
            }
            renderLayer(e1, t1, i, o) {
                i.isHidden(this.transform.zoom) || ("background" === i.type || "sky" === i.type || "custom" === i.type || o && o.length) && (this.id = i.id, this.gpuTimingStart(i), e1.transform.projection.unsupportedLayers && e1.transform.projection.unsupportedLayers.includes(i.type) || ko[i.type](e1, t1, i, o, this.style.placement.variableOffsets, this.options.isInitialLoad), this.gpuTimingEnd());
            }
            gpuTimingStart(e1) {
                if (!this.options.gpuTiming) return;
                const t1 = this.context.extTimerQuery;
                let i = this.gpuTimers[e1.id];
                i || (i = this.gpuTimers[e1.id] = {
                    calls: 0,
                    cpuTime: 0,
                    query: t1.createQueryEXT()
                }), i.calls++, t1.beginQueryEXT(t1.TIME_ELAPSED_EXT, i.query);
            }
            gpuTimingDeferredRenderStart() {
                if (this.options.gpuTimingDeferredRender) {
                    const e1 = this.context.extTimerQuery, t1 = e1.createQueryEXT();
                    this.deferredRenderGpuTimeQueries.push(t1), e1.beginQueryEXT(e1.TIME_ELAPSED_EXT, t1);
                }
            }
            gpuTimingDeferredRenderEnd() {
                if (!this.options.gpuTimingDeferredRender) return;
                const e1 = this.context.extTimerQuery;
                e1.endQueryEXT(e1.TIME_ELAPSED_EXT);
            }
            gpuTimingEnd() {
                if (!this.options.gpuTiming) return;
                const e1 = this.context.extTimerQuery;
                e1.endQueryEXT(e1.TIME_ELAPSED_EXT);
            }
            collectGpuTimers() {
                const e1 = this.gpuTimers;
                return this.gpuTimers = {}, e1;
            }
            collectDeferredRenderGpuQueries() {
                const e1 = this.deferredRenderGpuTimeQueries;
                return this.deferredRenderGpuTimeQueries = [], e1;
            }
            queryGpuTimers(e1) {
                const t1 = {};
                for(const i in e1){
                    const o = e1[i], r = this.context.extTimerQuery, n = r.getQueryObjectEXT(o.query, r.QUERY_RESULT_EXT) / 1e6;
                    r.deleteQueryEXT(o.query), t1[i] = n;
                }
                return t1;
            }
            queryGpuTimeDeferredRender(e1) {
                if (!this.options.gpuTimingDeferredRender) return 0;
                const t1 = this.context.extTimerQuery;
                let i = 0;
                for (const o of e1)i += t1.getQueryObjectEXT(o, t1.QUERY_RESULT_EXT) / 1e6, t1.deleteQueryEXT(o);
                return i;
            }
            translatePosMatrix(t1, i, o, r, n) {
                if (!o[0] && !o[1]) return t1;
                const a = n ? "map" === r ? this.transform.angle : 0 : "viewport" === r ? -this.transform.angle : 0;
                if (a) {
                    const e2 = Math.sin(a), t2 = Math.cos(a);
                    o = [
                        o[0] * t2 - o[1] * e2,
                        o[0] * e2 + o[1] * t2
                    ];
                }
                const s = [
                    n ? o[0] : L(i, o[0], this.transform.zoom),
                    n ? o[1] : L(i, o[1], this.transform.zoom),
                    0
                ], l = new Float32Array(16);
                return e1.translate(l, t1, s), l;
            }
            saveTileTexture(e1) {
                const t1 = this._tileTextures[e1.size[0]];
                t1 ? t1.push(e1) : this._tileTextures[e1.size[0]] = [
                    e1
                ];
            }
            getTileTexture(e1) {
                const t1 = this._tileTextures[e1];
                return t1 && t1.length > 0 ? t1.pop() : null;
            }
            isPatternMissing(e1) {
                if (!e1) return !1;
                if (!e1.from || !e1.to) return !0;
                const t1 = this.imageManager.getPattern(e1.from.toString()), i = this.imageManager.getPattern(e1.to.toString());
                return !t1 || !i;
            }
            terrainRenderModeElevated() {
                return this.style && !!this.style.getTerrain() && !!this.terrain && !this.terrain.renderingToTexture;
            }
            currentGlobalDefines() {
                const e1 = this.terrain && this.terrain.renderingToTexture, t1 = this.style && this.style.fog, i = [];
                return this.terrainRenderModeElevated() && i.push("TERRAIN"), "globe" === this.transform.projection.name && i.push("GLOBE"), t1 && !e1 && 0 !== t1.getOpacity(this.transform.pitch) && i.push("FOG"), e1 && i.push("RENDER_TO_TEXTURE"), this._showOverdrawInspector && i.push("OVERDRAW_INSPECTOR"), i;
            }
            useProgram(e1, t1, i) {
                this.cache = this.cache || {};
                const o = i || [], r = this.currentGlobalDefines().concat(o), n = Li.cacheKey(ui[e1], e1, r, t1);
                return this.cache[n] || (this.cache[n] = new Li(this.context, e1, ui[e1], t1, lo[e1], r)), this.cache[n];
            }
            setCustomLayerDefaults() {
                this.context.unbindVAO(), this.context.cullFace.setDefault(), this.context.frontFace.setDefault(), this.context.cullFaceSide.setDefault(), this.context.activeTexture.setDefault(), this.context.pixelStoreUnpack.setDefault(), this.context.pixelStoreUnpackPremultiplyAlpha.setDefault(), this.context.pixelStoreUnpackFlipY.setDefault();
            }
            setBaseState() {
                const e1 = this.context.gl;
                this.context.cullFace.set(!1), this.context.viewport.set([
                    0,
                    0,
                    this.width,
                    this.height
                ]), this.context.blendEquation.set(e1.FUNC_ADD);
            }
            initDebugOverlayCanvas() {
                null == this.debugOverlayCanvas && (this.debugOverlayCanvas = e1.window.document.createElement("canvas"), this.debugOverlayCanvas.width = 512, this.debugOverlayCanvas.height = 512, this.debugOverlayTexture = new e1.Texture(this.context, this.debugOverlayCanvas, this.context.gl.RGBA));
            }
            destroy() {
                this._terrain && this._terrain.destroy(), this.globeSharedBuffers && this.globeSharedBuffers.destroy(), this.emptyTexture.destroy(), this.debugOverlayTexture && this.debugOverlayTexture.destroy(), this.atmosphereBuffer && this.atmosphereBuffer.destroy();
            }
            prepareDrawTile() {
                this.terrain && this.terrain.prepareDrawTile();
            }
            prepareDrawProgram(t1, i, o) {
                if (this.terrain && this.terrain.renderingToTexture) return;
                const r = this.style.fog;
                if (r) {
                    const n = r.getOpacity(this.transform.pitch), a = ((t1, i, o, r, n, a, s, l, c, h, _)=>{
                        const u = t1.transform, d = i.properties.get("color").toArray01();
                        d[3] = r;
                        const p = t1.frameCounter / 1e3 % 1;
                        return {
                            u_fog_matrix: o ? u.calculateFogTileMatrix(o) : t1.identityMat,
                            u_fog_range: i.getFovAdjustedRange(u._fov),
                            u_fog_color: d,
                            u_fog_horizon_blend: i.properties.get("horizon-blend"),
                            u_fog_temporal_offset: p,
                            u_frustum_tl: n,
                            u_frustum_tr: a,
                            u_frustum_br: s,
                            u_frustum_bl: l,
                            u_globe_pos: c,
                            u_globe_radius: h,
                            u_viewport: _,
                            u_globe_transition: e1.globeToMercatorTransition(u.zoom),
                            u_is_globe: +("globe" === u.projection.name)
                        };
                    })(this, r, o, n, this.transform.frustumCorners.TL, this.transform.frustumCorners.TR, this.transform.frustumCorners.BR, this.transform.frustumCorners.BL, this.transform.globeCenterInViewSpace, this.transform.globeRadius, [
                        this.transform.width * e1.exported.devicePixelRatio,
                        this.transform.height * e1.exported.devicePixelRatio
                    ]);
                    i.setFogUniformValues(t1, a);
                }
            }
            setTileLoadedFlag(e1) {
                this.tileLoaded = e1;
            }
            saveCanvasCopy() {
                this.frameCopies.push(this.canvasCopy()), this.tileLoaded = !1;
            }
            canvasCopy() {
                const e1 = this.context.gl, t1 = e1.createTexture();
                return e1.bindTexture(e1.TEXTURE_2D, t1), e1.copyTexImage2D(e1.TEXTURE_2D, 0, e1.RGBA, 0, 0, e1.drawingBufferWidth, e1.drawingBufferHeight, 0), t1;
            }
            getCanvasCopiesAndTimestamps() {
                return {
                    canvasCopies: this.frameCopies,
                    timeStamps: this.loadTimeStamps
                };
            }
            averageElevationNeedsEasing() {
                if (!this.transform._elevation) return !1;
                const e1 = this.style && this.style.fog;
                return !!e1 && 0 !== e1.getOpacity(this.transform.pitch);
            }
            getBackgroundTiles() {
                const t1 = this._backgroundTiles, i = this._backgroundTiles = {}, o = this.transform.coveringTiles({
                    tileSize: 512
                });
                for (const r of o)i[r.key] = t1[r.key] || new e1.Tile(r, 512, this.transform.tileZoom, this);
                return i;
            }
            clearBackgroundTiles() {
                this._backgroundTiles = {};
            }
        }
        class Uo {
            constructor(e1 = 0, t1 = 0, i = 0, o = 0){
                if (isNaN(e1) || e1 < 0 || isNaN(t1) || t1 < 0 || isNaN(i) || i < 0 || isNaN(o) || o < 0) throw new Error("Invalid value for edge-insets, top, bottom, left and right must all be numbers");
                this.top = e1, this.bottom = t1, this.left = i, this.right = o;
            }
            interpolate(t1, i, o) {
                return null != i.top && null != t1.top && (this.top = e1.number(t1.top, i.top, o)), null != i.bottom && null != t1.bottom && (this.bottom = e1.number(t1.bottom, i.bottom, o)), null != i.left && null != t1.left && (this.left = e1.number(t1.left, i.left, o)), null != i.right && null != t1.right && (this.right = e1.number(t1.right, i.right, o)), this;
            }
            getCenter(t1, i) {
                const o = e1.clamp((this.left + t1 - this.right) / 2, 0, t1), r = e1.clamp((this.top + i - this.bottom) / 2, 0, i);
                return new e1.pointGeometry(o, r);
            }
            equals(e1) {
                return this.top === e1.top && this.bottom === e1.bottom && this.left === e1.left && this.right === e1.right;
            }
            clone() {
                return new Uo(this.top, this.bottom, this.left, this.right);
            }
            toJSON() {
                return {
                    top: this.top,
                    bottom: this.bottom,
                    left: this.left,
                    right: this.right
                };
            }
        }
        function No(t1, i) {
            const o = e1.getColumn(t1, 3);
            e1.fromQuat(t1, i), e1.setColumn(t1, 3, o);
        }
        function Go(t1, i) {
            const o = e1.identity$1([]);
            return e1.rotateZ$1(o, o, -i), e1.rotateX$1(o, o, -t1), o;
        }
        function jo(t1, i) {
            const o = [
                t1[0],
                t1[1],
                0
            ], r = [
                i[0],
                i[1],
                0
            ];
            if (e1.length(o) >= 1e-15) {
                const t2 = e1.normalize([], o);
                e1.scale$2(r, t2, e1.dot(r, t2)), i[0] = r[0], i[1] = r[1];
            }
            const n = e1.cross([], i, t1);
            if (e1.len(n) < 1e-15) return null;
            const a = Math.atan2(-n[1], n[0]);
            return Go(Math.atan2(Math.sqrt(t1[0] * t1[0] + t1[1] * t1[1]), -t1[2]), a);
        }
        class Zo {
            constructor(e1, t1){
                this.position = e1, this.orientation = t1;
            }
            get position() {
                return this._position;
            }
            set position(t1) {
                if (t1) {
                    const i = t1 instanceof e1.MercatorCoordinate ? t1 : new e1.MercatorCoordinate(t1[0], t1[1], t1[2]);
                    this._renderWorldCopies && (i.x = e1.wrap(i.x, 0, 1)), this._position = i;
                } else this._position = null;
            }
            lookAtPoint(t1, i) {
                if (this.orientation = null, !this.position) return;
                const o = this._elevation ? this._elevation.getAtPointOrZero(e1.MercatorCoordinate.fromLngLat(t1)) : 0, r = this.position, n = e1.MercatorCoordinate.fromLngLat(t1, o), a = [
                    n.x - r.x,
                    n.y - r.y,
                    n.z - r.z
                ];
                i || (i = [
                    0,
                    0,
                    1
                ]), i[2] = Math.abs(i[2]), this.orientation = jo(a, i);
            }
            setPitchBearing(t1, i) {
                this.orientation = Go(e1.degToRad(t1), e1.degToRad(-i));
            }
        }
        class Vo {
            constructor(t1, i){
                this._transform = e1.identity([]), this.orientation = i, this.position = t1;
            }
            get mercatorPosition() {
                const t1 = this.position;
                return new e1.MercatorCoordinate(t1[0], t1[1], t1[2]);
            }
            get position() {
                const t1 = e1.getColumn(this._transform, 3);
                return [
                    t1[0],
                    t1[1],
                    t1[2]
                ];
            }
            set position(t1) {
                var i;
                t1 && e1.setColumn(this._transform, 3, [
                    (i = t1)[0],
                    i[1],
                    i[2],
                    1
                ]);
            }
            get orientation() {
                return this._orientation;
            }
            set orientation(t1) {
                this._orientation = t1 || e1.identity$1([]), t1 && No(this._transform, this._orientation);
            }
            getPitchBearing() {
                const e1 = this.forward(), t1 = this.right();
                return {
                    bearing: Math.atan2(-t1[1], t1[0]),
                    pitch: Math.atan2(Math.sqrt(e1[0] * e1[0] + e1[1] * e1[1]), -e1[2])
                };
            }
            setPitchBearing(e1, t1) {
                this._orientation = Go(e1, t1), No(this._transform, this._orientation);
            }
            forward() {
                const t1 = e1.getColumn(this._transform, 2);
                return [
                    -t1[0],
                    -t1[1],
                    -t1[2]
                ];
            }
            up() {
                const t1 = e1.getColumn(this._transform, 1);
                return [
                    -t1[0],
                    -t1[1],
                    -t1[2]
                ];
            }
            right() {
                const t1 = e1.getColumn(this._transform, 0);
                return [
                    t1[0],
                    t1[1],
                    t1[2]
                ];
            }
            getCameraToWorld(t1, i) {
                const o = new Float64Array(16);
                return e1.invert(o, this.getWorldToCamera(t1, i)), o;
            }
            getWorldToCameraPosition(t1, i, o) {
                const r = this.position;
                e1.scale$2(r, r, -t1);
                const n = new Float64Array(16);
                return e1.fromScaling(n, [
                    o,
                    o,
                    o
                ]), e1.translate(n, n, r), n[10] *= i, n;
            }
            getWorldToCamera(t1, i) {
                const o = new Float64Array(16), r = new Float64Array(4), n = this.position;
                return e1.conjugate(r, this._orientation), e1.scale$2(n, n, -t1), e1.fromQuat(o, r), e1.translate(o, o, n), o[1] *= -1, o[5] *= -1, o[9] *= -1, o[13] *= -1, o[8] *= i, o[9] *= i, o[10] *= i, o[11] *= i, o;
            }
            getCameraToClipPerspective(t1, i, o, r) {
                const n = new Float64Array(16);
                return e1.perspective(n, t1, i, o, r), n;
            }
            getDistanceToElevation(t1) {
                const i = 0 === t1 ? 0 : e1.mercatorZfromAltitude(t1, this.position[1]), o = this.forward();
                return (i - this.position[2]) / o[2];
            }
            clone() {
                return new Vo([
                    ...this.position
                ], [
                    ...this.orientation
                ]);
            }
        }
        function Wo(t1, i) {
            const o = qo(t1.projection, t1.zoom, t1.width, t1.height), r = function(t1, i, o, r, n) {
                const a = new e1.LngLat(o.lng - 180 * $o, o.lat), s = new e1.LngLat(o.lng + 180 * $o, o.lat), l = t1.project(a.lng, a.lat), c = t1.project(s.lng, s.lat), h = -Math.atan2(c.y - l.y, c.x - l.x), _ = e1.MercatorCoordinate.fromLngLat(o);
                _.y = e1.clamp(_.y, -0.999975, .999975);
                const u = _.toLngLat(), d = t1.project(u.lng, u.lat), p = e1.MercatorCoordinate.fromLngLat(u);
                p.x += $o;
                const m = p.toLngLat(), f = t1.project(m.lng, m.lat), g = Yo(f.x - d.x, f.y - d.y, h), v = e1.MercatorCoordinate.fromLngLat(u);
                v.y += $o;
                const x = v.toLngLat(), y = t1.project(x.lng, x.lat), b = Yo(y.x - d.x, y.y - d.y, h), w = Math.abs(g.x) / Math.abs(b.y), T = e1.identity([]);
                e1.rotateZ(T, T, -h * (1 - (n ? 0 : r)));
                const E = e1.identity([]);
                return e1.scale(E, E, [
                    1,
                    1 - (1 - w) * r,
                    1
                ]), E[4] = -b.x / b.y * r, e1.rotateZ(E, E, h), e1.multiply(E, T, E), E;
            }(t1.projection, 0, t1.center, o, i), n = Xo(t1);
            return e1.scale(r, r, [
                n,
                n,
                1
            ]), r;
        }
        function Xo(t1) {
            const i = t1.projection, o = qo(t1.projection, t1.zoom, t1.width, t1.height), r = Ho(i, t1.center), n = Ho(i, e1.LngLat.convert(i.center));
            return Math.pow(2, r * o + (1 - o) * n);
        }
        function qo(t1, i, o, r, n = 1 / 0) {
            const a = t1.range;
            if (!a) return 0;
            const s = Math.min(n, Math.max(o, r)), l = Math.log(s / 1024) / Math.LN2;
            return e1.smoothstep(a[0] + l, a[1] + l, i);
        }
        const $o = 1 / 4e4;
        function Ho(t1, i) {
            const o = e1.clamp(i.lat, -e1.MAX_MERCATOR_LATITUDE, e1.MAX_MERCATOR_LATITUDE), r = new e1.LngLat(i.lng - 180 * $o, o), n = new e1.LngLat(i.lng + 180 * $o, o), a = t1.project(r.lng, o), s = t1.project(n.lng, o), l = e1.MercatorCoordinate.fromLngLat(r), c = e1.MercatorCoordinate.fromLngLat(n), h = s.x - a.x, _ = s.y - a.y, u = c.x - l.x, d = c.y - l.y, p = Math.sqrt((u * u + d * d) / (h * h + _ * _));
            return Math.log(p) / Math.LN2;
        }
        function Yo(e1, t1, i) {
            const o = Math.cos(i), r = Math.sin(i);
            return {
                x: e1 * o - t1 * r,
                y: e1 * r + t1 * o
            };
        }
        class Ko {
            constructor(t1, i, o, r, n, a, s){
                this.tileSize = 512, this._renderWorldCopies = void 0 === n || n, this._minZoom = t1 || 0, this._maxZoom = i || 22, this._minPitch = null == o ? 0 : o, this._maxPitch = null == r ? 60 : r, this.setProjection(a), this.setMaxBounds(s), this.width = 0, this.height = 0, this._center = new e1.LngLat(0, 0), this.zoom = 0, this.angle = 0, this._fov = .6435011087932844, this._pitch = 0, this._nearZ = 0, this._farZ = 0, this._unmodified = !0, this._edgeInsets = new Uo, this._projMatrixCache = {}, this._alignedProjMatrixCache = {}, this._fogTileMatrixCache = {}, this._distanceTileDataCache = {}, this._camera = new Vo, this._centerAltitude = 0, this._averageElevation = 0, this.cameraElevationReference = "ground", this._pixelsPerMercatorPixel = 1, this.globeRadius = 0, this.globeCenterInViewSpace = [
                    0,
                    0,
                    0
                ], this._horizonShift = .1;
            }
            clone() {
                const e1 = new Ko(this._minZoom, this._maxZoom, this._minPitch, this.maxPitch, this._renderWorldCopies, this.getProjection());
                return e1._elevation = this._elevation, e1._centerAltitude = this._centerAltitude, e1._centerAltitudeValidForExaggeration = this._centerAltitudeValidForExaggeration, e1.tileSize = this.tileSize, e1.mercatorFromTransition = this.mercatorFromTransition, e1.width = this.width, e1.height = this.height, e1.cameraElevationReference = this.cameraElevationReference, e1._center = this._center, e1._setZoom(this.zoom), e1._seaLevelZoom = this._seaLevelZoom, e1.angle = this.angle, e1._fov = this._fov, e1._pitch = this._pitch, e1._nearZ = this._nearZ, e1._farZ = this._farZ, e1._averageElevation = this._averageElevation, e1._unmodified = this._unmodified, e1._edgeInsets = this._edgeInsets.clone(), e1._camera = this._camera.clone(), e1._calcMatrices(), e1.freezeTileCoverage = this.freezeTileCoverage, e1.frustumCorners = this.frustumCorners, e1;
            }
            get elevation() {
                return this._elevation;
            }
            set elevation(e1) {
                this._elevation !== e1 && (this._elevation = e1, this._updateCameraOnTerrain(), this._calcMatrices());
            }
            updateElevation(e1) {
                const t1 = this._elevation && this._elevation.exaggeration() !== this._centerAltitudeValidForExaggeration;
                (null == this._seaLevelZoom || t1) && this._updateCameraOnTerrain(), (e1 || t1) && this._constrainCameraAltitude(), this._calcMatrices();
            }
            getProjection() {
                return e1.pick(this.projection, [
                    "name",
                    "center",
                    "parallels"
                ]);
            }
            setProjection(i) {
                this.projectionOptions = i || {
                    name: "mercator"
                };
                const o = this.projection ? this.getProjection() : void 0;
                this.projection = e1.getProjection(this.projectionOptions);
                const r = !t1(o, this.getProjection());
                return r && this._calcMatrices(), this.mercatorFromTransition = !1, r;
            }
            setMercatorFromTransition() {
                const t1 = this.projection.name;
                this.mercatorFromTransition = !0, this.projectionOptions = {
                    name: "mercator"
                }, this.projection = e1.getProjection({
                    name: "mercator"
                });
                const i = t1 !== this.projection.name;
                return i && this._calcMatrices(), i;
            }
            get minZoom() {
                return this._minZoom;
            }
            set minZoom(e1) {
                this._minZoom !== e1 && (this._minZoom = e1, this.zoom = Math.max(this.zoom, e1));
            }
            get maxZoom() {
                return this._maxZoom;
            }
            set maxZoom(e1) {
                this._maxZoom !== e1 && (this._maxZoom = e1, this.zoom = Math.min(this.zoom, e1));
            }
            get minPitch() {
                return this._minPitch;
            }
            set minPitch(e1) {
                this._minPitch !== e1 && (this._minPitch = e1, this.pitch = Math.max(this.pitch, e1));
            }
            get maxPitch() {
                return this._maxPitch;
            }
            set maxPitch(e1) {
                this._maxPitch !== e1 && (this._maxPitch = e1, this.pitch = Math.min(this.pitch, e1));
            }
            get renderWorldCopies() {
                return this._renderWorldCopies && !0 === this.projection.supportsWorldCopies;
            }
            set renderWorldCopies(e1) {
                void 0 === e1 ? e1 = !0 : null === e1 && (e1 = !1), this._renderWorldCopies = e1;
            }
            get worldSize() {
                return this.tileSize * this.scale;
            }
            get cameraWorldSize() {
                const e1 = Math.max(this._camera.getDistanceToElevation(this._averageElevation), Number.EPSILON);
                return this._worldSizeFromZoom(this._zoomFromMercatorZ(e1));
            }
            get pixelsPerMeter() {
                return this.projection.pixelsPerMeter(this.center.lat, this.worldSize);
            }
            get cameraPixelsPerMeter() {
                return e1.mercatorZfromAltitude(this.center.lat, this.cameraWorldSize);
            }
            get centerOffset() {
                return this.centerPoint._sub(this.size._div(2));
            }
            get size() {
                return new e1.pointGeometry(this.width, this.height);
            }
            get bearing() {
                return e1.wrap(this.rotation, -180, 180);
            }
            set bearing(e1) {
                this.rotation = e1;
            }
            get rotation() {
                return -this.angle / Math.PI * 180;
            }
            set rotation(t1) {
                const i = -t1 * Math.PI / 180;
                var o;
                this.angle !== i && (this._unmodified = !1, this.angle = i, this._calcMatrices(), this.rotationMatrix = (o = new e1.ARRAY_TYPE(4), e1.ARRAY_TYPE != Float32Array && (o[1] = 0, o[2] = 0), o[0] = 1, o[3] = 1, o), function(e1, t1, i) {
                    var o = t1[0], r = t1[1], n = t1[2], a = t1[3], s = Math.sin(i), l = Math.cos(i);
                    e1[0] = o * l + n * s, e1[1] = r * l + a * s, e1[2] = o * -s + n * l, e1[3] = r * -s + a * l;
                }(this.rotationMatrix, this.rotationMatrix, this.angle));
            }
            get pitch() {
                return this._pitch / Math.PI * 180;
            }
            set pitch(t1) {
                const i = e1.clamp(t1, this.minPitch, this.maxPitch) / 180 * Math.PI;
                this._pitch !== i && (this._unmodified = !1, this._pitch = i, this._calcMatrices());
            }
            get aspect() {
                return this.width / this.height;
            }
            get fovX() {
                return this._fov;
            }
            get fovY() {
                const e1 = 1 / Math.tan(.5 * this.fovX);
                return 2 * Math.atan(1 / this.aspect / e1);
            }
            set fov(t1) {
                t1 = Math.max(.01, Math.min(60, t1)), this._fov !== t1 && (this._unmodified = !1, this._fov = e1.degToRad(t1), this._calcMatrices());
            }
            get averageElevation() {
                return this._averageElevation;
            }
            set averageElevation(e1) {
                this._averageElevation = e1, this._calcFogMatrices(), this._distanceTileDataCache = {};
            }
            get zoom() {
                return this._zoom;
            }
            set zoom(e1) {
                const t1 = Math.min(Math.max(e1, this.minZoom), this.maxZoom);
                this._zoom !== t1 && (this._unmodified = !1, this._setZoom(t1), this._updateSeaLevelZoom(), this._constrain(), this._calcMatrices());
            }
            _setZoom(e1) {
                this._zoom = e1, this.scale = this.zoomScale(e1), this.tileZoom = Math.floor(e1), this.zoomFraction = e1 - this.tileZoom;
            }
            _updateCameraOnTerrain() {
                if (!this._elevation || !this._elevation.isDataAvailableAtPoint(this.locationCoordinate(this.center))) return this._centerAltitude = 0, this._seaLevelZoom = null, void (this._centerAltitudeValidForExaggeration = void 0);
                const e1 = this._elevation;
                this._centerAltitude = e1.getAtPointOrZero(this.locationCoordinate(this.center)), this._centerAltitudeValidForExaggeration = e1.exaggeration(), this._updateSeaLevelZoom();
            }
            _updateSeaLevelZoom() {
                void 0 !== this._centerAltitudeValidForExaggeration && (this._seaLevelZoom = this._zoomFromMercatorZ((this.pixelsPerMeter * this._centerAltitude + this.cameraToCenterDistance) / this.worldSize));
            }
            sampleAverageElevation() {
                if (!this._elevation) return 0;
                const t1 = this._elevation, i = [
                    [
                        .5,
                        .2
                    ],
                    [
                        .3,
                        .5
                    ],
                    [
                        .5,
                        .5
                    ],
                    [
                        .7,
                        .5
                    ],
                    [
                        .5,
                        .8
                    ]
                ], o = this.horizonLineFromTop();
                let r = 0, n = 0;
                for(let a = 0; a < i.length; a++){
                    const s = new e1.pointGeometry(i[a][0] * this.width, o + i[a][1] * (this.height - o)), l = t1.pointCoordinate(s);
                    if (!l) continue;
                    const c = 1 / Math.hypot(l[0] - this._camera.position[0], l[1] - this._camera.position[1]);
                    r += l[3] * c, n += c;
                }
                return 0 === n ? NaN : r / n;
            }
            get center() {
                return this._center;
            }
            set center(e1) {
                e1.lat === this._center.lat && e1.lng === this._center.lng || (this._unmodified = !1, this._center = e1, this._terrainEnabled() && ("ground" === this.cameraElevationReference ? this._updateCameraOnTerrain() : this._updateZoomFromElevation()), this._constrain(), this._calcMatrices());
            }
            _updateZoomFromElevation() {
                if (null == this._seaLevelZoom || !this._elevation) return;
                const e1 = this._seaLevelZoom, t1 = this._elevation.getAtPointOrZero(this.locationCoordinate(this.center)), i = this.pixelsPerMeter / this.worldSize * t1, o = this._mercatorZfromZoom(e1), r = this._mercatorZfromZoom(this._maxZoom), n = Math.max(o - i, r);
                this._setZoom(this._zoomFromMercatorZ(n));
            }
            get padding() {
                return this._edgeInsets.toJSON();
            }
            set padding(e1) {
                this._edgeInsets.equals(e1) || (this._unmodified = !1, this._edgeInsets.interpolate(this._edgeInsets, e1, 1), this._calcMatrices());
            }
            computeZoomRelativeTo(t1) {
                const i = this.rayIntersectionCoordinate(this.pointRayIntersection(this.centerPoint, t1.toAltitude()));
                let o;
                o = t1.z < this._camera.position[2] ? [
                    i.x,
                    i.y,
                    i.z
                ] : [
                    t1.x,
                    t1.y,
                    t1.z
                ];
                const r = e1.length(e1.sub([], this._camera.position, o));
                return e1.clamp(this._zoomFromMercatorZ(r), this._minZoom, this._maxZoom);
            }
            setFreeCameraOptions(t1) {
                if (!this.height) return;
                if (!t1.position && !t1.orientation) return;
                this._updateCameraState();
                let i = !1;
                if (t1.orientation && !e1.exactEquals(t1.orientation, this._camera.orientation) && (i = this._setCameraOrientation(t1.orientation)), t1.position) {
                    const o = [
                        t1.position.x,
                        t1.position.y,
                        t1.position.z
                    ];
                    e1.exactEquals$1(o, this._camera.position) || (this._setCameraPosition(o), i = !0);
                }
                i && (this._updateStateFromCamera(), this.recenterOnTerrain());
            }
            getFreeCameraOptions() {
                this._updateCameraState();
                const t1 = this._camera.position, i = new Zo;
                return i.position = new e1.MercatorCoordinate(t1[0], t1[1], t1[2]), i.orientation = this._camera.orientation, i._elevation = this.elevation, i._renderWorldCopies = this.renderWorldCopies, i;
            }
            _setCameraOrientation(t1) {
                if (!e1.length$1(t1)) return !1;
                e1.normalize$1(t1, t1);
                const i = e1.transformQuat([], [
                    0,
                    0,
                    -1
                ], t1), o = e1.transformQuat([], [
                    0,
                    -1,
                    0
                ], t1);
                if (o[2] < 0) return !1;
                const r = jo(i, o);
                return !!r && (this._camera.orientation = r, !0);
            }
            _setCameraPosition(t1) {
                const i = this.zoomScale(this.minZoom) * this.tileSize, o = this.zoomScale(this.maxZoom) * this.tileSize, r = this.cameraToCenterDistance;
                t1[2] = e1.clamp(t1[2], r / o, r / i), this._camera.position = t1;
            }
            get centerPoint() {
                return this._edgeInsets.getCenter(this.width, this.height);
            }
            get fovAboveCenter() {
                return this._fov * (.5 + this.centerOffset.y / this.height);
            }
            isPaddingEqual(e1) {
                return this._edgeInsets.equals(e1);
            }
            interpolatePadding(e1, t1, i) {
                this._unmodified = !1, this._edgeInsets.interpolate(e1, t1, i), this._constrain(), this._calcMatrices();
            }
            coveringZoomLevel(e1) {
                const t1 = (e1.roundZoom ? Math.round : Math.floor)(this.zoom + this.scaleZoom(this.tileSize / e1.tileSize));
                return Math.max(0, t1);
            }
            getVisibleUnwrappedCoordinates(t1) {
                const i = [
                    new e1.UnwrappedTileID(0, t1)
                ];
                if (this.renderWorldCopies) {
                    const o = this.pointCoordinate(new e1.pointGeometry(0, 0)), r = this.pointCoordinate(new e1.pointGeometry(this.width, 0)), n = this.pointCoordinate(new e1.pointGeometry(this.width, this.height)), a = this.pointCoordinate(new e1.pointGeometry(0, this.height)), s = Math.floor(Math.min(o.x, r.x, n.x, a.x)), l = Math.floor(Math.max(o.x, r.x, n.x, a.x)), c = 1;
                    for(let o1 = s - c; o1 <= l + c; o1++)0 !== o1 && i.push(new e1.UnwrappedTileID(o1, t1));
                }
                return i;
            }
            coveringTiles(t1) {
                let i = this.coveringZoomLevel(t1);
                const o = i, r = this.elevation && !t1.isTerrainDEM, n = "mercator" === this.projection.name;
                if (void 0 !== t1.minzoom && i < t1.minzoom) return [];
                void 0 !== t1.maxzoom && i > t1.maxzoom && (i = t1.maxzoom);
                const a = this.locationCoordinate(this.center), s = this.center.lat, l = 1 << i, c = [
                    l * a.x,
                    l * a.y,
                    0
                ], h = "globe" === this.projection.name, _ = !h, u = e1.Frustum.fromInvProjectionMatrix(this.invProjMatrix, this.worldSize, i, _), d = h ? this._camera.mercatorPosition : this.pointCoordinate(this.getCameraPoint()), p = l * e1.mercatorZfromAltitude(1, this.center.lat), m = this._camera.position[2] / e1.mercatorZfromAltitude(1, this.center.lat), f = [
                    l * d.x,
                    l * d.y,
                    m * (_ ? 1 : p)
                ], g = this.cameraToCenterDistance / t1.tileSize * (t1.roundZoom ? 1 : .502), v = this.pitch <= 60 && this._edgeInsets.top <= this._edgeInsets.bottom && !this._elevation && !this.projection.isReprojectedInTileSpace ? i : 0, x = t1.isTerrainDEM && this._elevation ? 1e4 * this._elevation.exaggeration() : this._centerAltitude, y = t1.isTerrainDEM ? -x : this._elevation ? this._elevation.getMinElevationBelowMSL() : 0, b = this.projection.isReprojectedInTileSpace ? Xo(this) : 1, w = (t1)=>{
                    const i = 1 / 4e4, o = new e1.MercatorCoordinate(t1.x + i, t1.y, t1.z), r = new e1.MercatorCoordinate(t1.x, t1.y + i, t1.z), n = t1.toLngLat(), a = o.toLngLat(), s = r.toLngLat(), l = this.locationCoordinate(n), c = this.locationCoordinate(a), h = this.locationCoordinate(s), _ = Math.hypot(c.x - l.x, c.y - l.y), u = Math.hypot(h.x - l.x, h.y - l.y);
                    return Math.sqrt(_ * u) * b / i;
                }, T = (t1)=>{
                    const i = x, o = y;
                    return {
                        aabb: e1.tileAABB(this, l, 0, 0, 0, t1, o, i, this.projection),
                        zoom: 0,
                        x: 0,
                        y: 0,
                        minZ: o,
                        maxZ: i,
                        wrap: t1,
                        fullyVisible: !1
                    };
                }, E = [];
                let C = [];
                const I = i, M = t1.reparseOverscaled ? o : i, S = (e1)=>e1 * e1, z = S((m - this._centerAltitude) * p), D = (e1)=>{
                    if (!this._elevation || !e1.tileID || !n) return;
                    const t1 = this._elevation.getMinMaxForTile(e1.tileID), i = e1.aabb;
                    t1 ? (i.min[2] = t1.min, i.max[2] = t1.max, i.center[2] = (i.min[2] + i.max[2]) / 2) : (e1.shouldSplit = A(e1), e1.shouldSplit || (i.min[2] = i.max[2] = i.center[2] = this._centerAltitude));
                }, A = (t1)=>{
                    if (t1.zoom < v) return !0;
                    if (t1.zoom === I) return !1;
                    if (null != t1.shouldSplit) return t1.shouldSplit;
                    const i = t1.aabb.distanceX(f), n = t1.aabb.distanceY(f);
                    let a = z, l = 1;
                    if (h) {
                        a = S(t1.aabb.distanceZ(f));
                        const i1 = Math.pow(2, t1.zoom), o1 = e1.latFromMercatorY((t1.y + 1) / i1), r1 = e1.latFromMercatorY(t1.y / i1), n1 = Math.min(Math.max(s, o1), r1), c = e1.circumferenceAtLatitude(n1) / e1.circumferenceAtLatitude(s);
                        if (l = n1 === s ? 1 / Math.max(1, this._mercatorScaleRatio - .3) : Math.min(1, c / this._mercatorScaleRatio), this.zoom <= e1.GLOBE_ZOOM_THRESHOLD_MIN && t1.zoom === I - 1 && c >= .9) return !0;
                    } else if (r && (a = S(t1.aabb.distanceZ(f) * p)), this.projection.isReprojectedInTileSpace && o <= 5) {
                        const i2 = Math.pow(2, t1.zoom), o2 = w(new e1.MercatorCoordinate((t1.x + .5) / i2, (t1.y + .5) / i2));
                        l = o2 > .85 ? 1 : o2;
                    }
                    const c1 = i * i + n * n + a, _ = S((1 << I - t1.zoom) * g * l * ((e1, t1)=>{
                        if (t1 * S(.707) < e1) return 1;
                        const i = Math.sqrt(t1 / e1);
                        return i / (1.4144271570014144 + (Math.pow(1.1, i - 1.4144271570014144 + 1) - 1) / (1.1 - 1) - 1);
                    })(Math.max(a, z), c1));
                    return c1 < _;
                };
                if (this.renderWorldCopies) for(let e2 = 1; e2 <= 3; e2++)E.push(T(-e2)), E.push(T(e2));
                for(E.push(T(0)); E.length > 0;){
                    const o1 = E.pop(), a1 = o1.x, s1 = o1.y;
                    let _1 = o1.fullyVisible;
                    if (!_1) {
                        const e3 = o1.aabb.intersects(u);
                        if (0 === e3) continue;
                        _1 = 2 === e3;
                    }
                    if (o1.zoom !== I && A(o1)) for(let t2 = 0; t2 < 4; t2++){
                        const i1 = (a1 << 1) + t2 % 2, c1 = (s1 << 1) + (t2 >> 1), u1 = {
                            aabb: n ? o1.aabb.quadrant(t2) : e1.tileAABB(this, l, o1.zoom + 1, i1, c1, o1.wrap, o1.minZ, o1.maxZ, this.projection),
                            zoom: o1.zoom + 1,
                            x: i1,
                            y: c1,
                            wrap: o1.wrap,
                            fullyVisible: _1,
                            tileID: void 0,
                            shouldSplit: void 0,
                            minZ: o1.minZ,
                            maxZ: o1.maxZ
                        };
                        r && !h && (u1.tileID = new e1.OverscaledTileID(o1.zoom + 1 === I ? M : o1.zoom + 1, o1.wrap, o1.zoom + 1, i1, c1), D(u1)), E.push(u1);
                    }
                    else {
                        const r1 = o1.zoom === I ? M : o1.zoom;
                        if (t1.minzoom && t1.minzoom > r1) continue;
                        const n1 = c[0] - (.5 + a1 + (o1.wrap << o1.zoom)) * (1 << i - o1.zoom), l1 = c[1] - .5 - s1, h1 = o1.tileID ? o1.tileID : new e1.OverscaledTileID(r1, o1.wrap, o1.zoom, a1, s1);
                        C.push({
                            tileID: h1,
                            distanceSq: n1 * n1 + l1 * l1
                        });
                    }
                }
                if (this.fogCullDistSq) {
                    const i2 = this.fogCullDistSq, o2 = this.horizonLineFromTop();
                    C = C.filter((r)=>{
                        const n = [
                            0,
                            0,
                            0,
                            1
                        ], a = [
                            e1.EXTENT,
                            e1.EXTENT,
                            0,
                            1
                        ], s = this.calculateFogTileMatrix(r.tileID.toUnwrapped());
                        e1.transformMat4$1(n, n, s), e1.transformMat4$1(a, a, s);
                        const l = e1.getAABBPointSquareDist(n, a);
                        if (0 === l) return !0;
                        let c = !1;
                        const h = this._elevation;
                        if (h && l > i2 && 0 !== o2) {
                            const i = this.calculateProjMatrix(r.tileID.toUnwrapped());
                            let n1;
                            t1.isTerrainDEM || (n1 = h.getMinMaxForTile(r.tileID)), n1 || (n1 = {
                                min: y,
                                max: x
                            });
                            const a1 = e1.furthestTileCorner(this.rotation), s1 = [
                                a1[0] * e1.EXTENT,
                                a1[1] * e1.EXTENT,
                                n1.max
                            ];
                            e1.transformMat4(s1, s1, i), c = (1 - s1[1]) * this.height * .5 < o2;
                        }
                        return l < i2 || c;
                    });
                }
                return C.sort((e1, t1)=>e1.distanceSq - t1.distanceSq).map((e1)=>e1.tileID);
            }
            resize(e1, t1) {
                this.width = e1, this.height = t1, this.pixelsToGLUnits = [
                    2 / e1,
                    -2 / t1
                ], this._constrain(), this._calcMatrices();
            }
            get unmodified() {
                return this._unmodified;
            }
            zoomScale(e1) {
                return Math.pow(2, e1);
            }
            scaleZoom(e1) {
                return Math.log(e1) / Math.LN2;
            }
            project(t1) {
                const i = e1.clamp(t1.lat, -e1.MAX_MERCATOR_LATITUDE, e1.MAX_MERCATOR_LATITUDE), o = this.projection.project(t1.lng, i);
                return new e1.pointGeometry(o.x * this.worldSize, o.y * this.worldSize);
            }
            unproject(e1) {
                return this.projection.unproject(e1.x / this.worldSize, e1.y / this.worldSize);
            }
            get point() {
                return this.project(this.center);
            }
            setLocationAtPoint(t1, i) {
                let o, r;
                const n = this.centerPoint;
                if ("globe" === this.projection.name) {
                    const e2 = this.worldSize;
                    o = (i.x - n.x) / e2, r = (i.y - n.y) / e2;
                } else {
                    const e3 = this.pointCoordinate(i), t2 = this.pointCoordinate(n);
                    o = e3.x - t2.x, r = e3.y - t2.y;
                }
                const a = this.locationCoordinate(t1);
                this.setLocation(new e1.MercatorCoordinate(a.x - o, a.y - r));
            }
            setLocation(e1) {
                this.center = this.coordinateLocation(e1), this.projection.wrap && (this.center = this.center.wrap());
            }
            locationPoint(e1) {
                return this.projection.locationPoint(this, e1);
            }
            locationPoint3D(e1) {
                return this.projection.locationPoint(this, e1, !0);
            }
            pointLocation(e1) {
                return this.coordinateLocation(this.pointCoordinate(e1));
            }
            pointLocation3D(e1) {
                return this.coordinateLocation(this.pointCoordinate3D(e1));
            }
            locationCoordinate(t1, i) {
                const o = i ? e1.mercatorZfromAltitude(i, t1.lat) : void 0, r = this.projection.project(t1.lng, t1.lat);
                return new e1.MercatorCoordinate(r.x, r.y, o);
            }
            coordinateLocation(e1) {
                return this.projection.unproject(e1.x, e1.y);
            }
            pointRayIntersection(t1, i) {
                const o = null != i ? i : this._centerAltitude, r = [
                    t1.x,
                    t1.y,
                    0,
                    1
                ], n = [
                    t1.x,
                    t1.y,
                    1,
                    1
                ];
                e1.transformMat4$1(r, r, this.pixelMatrixInverse), e1.transformMat4$1(n, n, this.pixelMatrixInverse);
                const a = n[3];
                e1.scale$1(r, r, 1 / r[3]), e1.scale$1(n, n, 1 / a);
                const s = r[2], l = n[2];
                return {
                    p0: r,
                    p1: n,
                    t: s === l ? 0 : (o - s) / (l - s)
                };
            }
            screenPointToMercatorRay(t1) {
                const i = [
                    t1.x,
                    t1.y,
                    0,
                    1
                ], o = [
                    t1.x,
                    t1.y,
                    1,
                    1
                ];
                return e1.transformMat4$1(i, i, this.pixelMatrixInverse), e1.transformMat4$1(o, o, this.pixelMatrixInverse), e1.scale$1(i, i, 1 / i[3]), e1.scale$1(o, o, 1 / o[3]), i[2] = e1.mercatorZfromAltitude(i[2], this._center.lat) * this.worldSize, o[2] = e1.mercatorZfromAltitude(o[2], this._center.lat) * this.worldSize, e1.scale$1(i, i, 1 / this.worldSize), e1.scale$1(o, o, 1 / this.worldSize), new e1.Ray([
                    i[0],
                    i[1],
                    i[2]
                ], e1.normalize([], e1.sub([], o, i)));
            }
            rayIntersectionCoordinate(t1) {
                const { p0: i , p1: o , t: r  } = t1, n = e1.mercatorZfromAltitude(i[2], this._center.lat), a = e1.mercatorZfromAltitude(o[2], this._center.lat);
                return new e1.MercatorCoordinate(e1.number(i[0], o[0], r) / this.worldSize, e1.number(i[1], o[1], r) / this.worldSize, e1.number(n, a, r));
            }
            pointCoordinate(e1, t1 = this._centerAltitude) {
                return this.projection.pointCoordinate(this, e1.x, e1.y, t1);
            }
            pointCoordinate3D(t1) {
                if (!this.elevation) return this.pointCoordinate(t1);
                let i = this.projection.pointCoordinate3D(this, t1.x, t1.y);
                if (i) return new e1.MercatorCoordinate(i[0], i[1], i[2]);
                let o = 0, r = this.horizonLineFromTop();
                if (t1.y > r) return this.pointCoordinate(t1);
                const n = .02 * r, a = t1.clone();
                for(let t2 = 0; t2 < 10 && r - o > n; t2++){
                    a.y = e1.number(o, r, .66);
                    const t3 = this.projection.pointCoordinate3D(this, a.x, a.y);
                    t3 ? (r = a.y, i = t3) : o = a.y;
                }
                return i ? new e1.MercatorCoordinate(i[0], i[1], i[2]) : this.pointCoordinate(t1);
            }
            isPointAboveHorizon(e1) {
                return this.projection.isPointAboveHorizon(this, e1);
            }
            _coordinatePoint(t1, i) {
                const o = i && this.elevation ? this.elevation.getAtPointOrZero(t1, this._centerAltitude) : this._centerAltitude, r = [
                    t1.x * this.worldSize,
                    t1.y * this.worldSize,
                    o + t1.toAltitude(),
                    1
                ];
                return e1.transformMat4$1(r, r, this.pixelMatrix), r[3] > 0 ? new e1.pointGeometry(r[0] / r[3], r[1] / r[3]) : new e1.pointGeometry(Number.MAX_VALUE, Number.MAX_VALUE);
            }
            _getGlobeBounds() {
                const { top: t1 , left: i  } = this._edgeInsets, o = this.height - this._edgeInsets.bottom, r = this.width - this._edgeInsets.right, n = this.pointCoordinate3D(new e1.pointGeometry(i, t1)), a = this.pointCoordinate3D(new e1.pointGeometry(r, t1)), s = this.pointCoordinate3D(new e1.pointGeometry(r, o)), l = this.pointCoordinate3D(new e1.pointGeometry(i, o));
                let c = Math.min(n.x, l.x), h = Math.max(a.x, s.x), _ = Math.min(n.y, a.y), u = Math.max(l.y, s.y);
                const d = Math.pow(2, -this.zoom) / 16, p = (t1, i, o, r)=>{
                    const n = (t1 + o) / 2, a = (i + r) / 2, s = new e1.pointGeometry(n, a), l = this.pointCoordinate3D(s), m = Math.max(0, c - l.x, _ - l.y, l.x - h, l.y - u);
                    c = Math.min(c, l.x), h = Math.max(h, l.x), _ = Math.min(_, l.y), u = Math.max(u, l.y), m > d && (p(t1, i, n, a), p(n, a, o, r));
                };
                p(i, t1, r, t1), p(r, t1, r, o), p(r, o, i, o), p(i, o, i, t1);
                const m = new e1.LngLat(e1.lngFromMercatorX(h), e1.latFromMercatorY(_)), f = new e1.LngLat(e1.lngFromMercatorX(c), e1.latFromMercatorY(u));
                return new e1.LngLatBounds(f, m);
            }
            _getBounds(t1, i) {
                if ("globe" === this.projection.name) return this._getGlobeBounds();
                const o = new e1.pointGeometry(this._edgeInsets.left, this._edgeInsets.top), r = new e1.pointGeometry(this.width - this._edgeInsets.right, this._edgeInsets.top), n = new e1.pointGeometry(this.width - this._edgeInsets.right, this.height - this._edgeInsets.bottom), a = new e1.pointGeometry(this._edgeInsets.left, this.height - this._edgeInsets.bottom);
                let s = this.pointCoordinate(o, t1), l = this.pointCoordinate(r, t1);
                const c = this.pointCoordinate(n, i), h = this.pointCoordinate(a, i), _ = (e1, t1)=>(t1.y - e1.y) / (t1.x - e1.x);
                return s.y > 1 && l.y >= 0 ? s = new e1.MercatorCoordinate((1 - h.y) / _(h, s) + h.x, 1) : s.y < 0 && l.y <= 1 && (s = new e1.MercatorCoordinate(-h.y / _(h, s) + h.x, 0)), l.y > 1 && s.y >= 0 ? l = new e1.MercatorCoordinate((1 - c.y) / _(c, l) + c.x, 1) : l.y < 0 && s.y <= 1 && (l = new e1.MercatorCoordinate(-c.y / _(c, l) + c.x, 0)), (new e1.LngLatBounds).extend(this.coordinateLocation(s)).extend(this.coordinateLocation(l)).extend(this.coordinateLocation(h)).extend(this.coordinateLocation(c));
            }
            _getBounds3D() {
                const e1 = this.elevation;
                if (!e1.visibleDemTiles.length || e1.isUsingMockSource()) return this._getBounds(0, 0);
                const t1 = e1.visibleDemTiles.reduce((e1, t1)=>{
                    if (t1.dem) {
                        const i = t1.dem.tree;
                        e1.min = Math.min(e1.min, i.minimums[0]), e1.max = Math.max(e1.max, i.maximums[0]);
                    }
                    return e1;
                }, {
                    min: Number.MAX_VALUE,
                    max: 0
                });
                return this._getBounds(t1.min * e1.exaggeration(), t1.max * e1.exaggeration());
            }
            getBounds() {
                return this._terrainEnabled() ? this._getBounds3D() : this._getBounds(0, 0);
            }
            horizonLineFromTop(e1 = !0) {
                const t1 = this.height / 2 / Math.tan(this._fov / 2) / Math.tan(Math.max(this._pitch, .1)) + this.centerOffset.y, i = this.height / 2 - t1 * (1 - this._horizonShift);
                return e1 ? Math.max(0, i) : i;
            }
            getMaxBounds() {
                return this.maxBounds;
            }
            setMaxBounds(t1) {
                this.maxBounds = t1, this.minLat = -e1.MAX_MERCATOR_LATITUDE, this.maxLat = e1.MAX_MERCATOR_LATITUDE, this.minLng = -180, this.maxLng = 180, t1 && (this.minLat = t1.getSouth(), this.maxLat = t1.getNorth(), this.minLng = t1.getWest(), this.maxLng = t1.getEast(), this.maxLng < this.minLng && (this.maxLng += 360)), this.worldMinX = e1.mercatorXfromLng(this.minLng) * this.tileSize, this.worldMaxX = e1.mercatorXfromLng(this.maxLng) * this.tileSize, this.worldMinY = e1.mercatorYfromLat(this.maxLat) * this.tileSize, this.worldMaxY = e1.mercatorYfromLat(this.minLat) * this.tileSize, this._constrain();
            }
            calculatePosMatrix(e1, t1) {
                return this.projection.createTileMatrix(this, t1, e1);
            }
            calculateDistanceTileData(t1) {
                const i = t1.key, o = this._distanceTileDataCache;
                if (o[i]) return o[i];
                const r = t1.canonical, n = 1 / this.height, a = this.cameraWorldSize / this.zoomScale(r.z), s = (r.x + Math.pow(2, r.z) * t1.wrap) * a, l = r.y * a, c = this.point, h = this.angle, _ = Math.sin(-h), u = -Math.cos(-h);
                return o[i] = {
                    bearing: [
                        _,
                        u
                    ],
                    center: [
                        (c.x - s) * n,
                        (c.y - l) * n
                    ],
                    scale: a / e1.EXTENT * n
                }, o[i];
            }
            calculateFogTileMatrix(t1) {
                const i = t1.key, o = this._fogTileMatrixCache;
                if (o[i]) return o[i];
                const r = this.projection.createTileMatrix(this, this.cameraWorldSize, t1);
                return e1.multiply(r, this.worldToFogMatrix, r), o[i] = new Float32Array(r), o[i];
            }
            calculateProjMatrix(t1, i = !1) {
                const o = t1.key, r = i ? this._alignedProjMatrixCache : this._projMatrixCache;
                if (r[o]) return r[o];
                const n = this.calculatePosMatrix(t1, this.worldSize);
                return e1.multiply(n, this.projection.isReprojectedInTileSpace ? this.mercatorMatrix : i ? this.alignedProjMatrix : this.projMatrix, n), r[o] = new Float32Array(n), r[o];
            }
            calculatePixelsToTileUnitsMatrix(t1) {
                const i = t1.tileID.key, o = this._pixelsToTileUnitsCache;
                if (o[i]) return o[i];
                const r = function(t1, i) {
                    const { scale: o  } = t1.tileTransform, r = o * e1.EXTENT / (t1.tileSize * Math.pow(2, i.zoom - t1.tileID.overscaledZ + t1.tileID.canonical.z));
                    var n, a, s, l, c, h, _, u;
                    return n = new Float32Array(4), l = (a = i.inverseAdjustmentMatrix)[1], c = a[2], h = a[3], u = (s = [
                        r,
                        r
                    ])[1], n[0] = a[0] * (_ = s[0]), n[1] = l * _, n[2] = c * u, n[3] = h * u, n;
                }(t1, this);
                return o[i] = r, o[i];
            }
            customLayerMatrix() {
                return this.mercatorMatrix.slice();
            }
            recenterOnTerrain() {
                if (!this._elevation || "globe" === this.projection.name) return;
                const t1 = this._elevation;
                this._updateCameraState();
                const i = e1.mercatorZfromAltitude(1, this._center.lat) * this.worldSize, o = this._computeCameraPosition(i), r = this._camera.forward(), n = e1.mercatorZfromAltitude(1, this._center.lat);
                o[2] /= n, r[2] /= n, e1.normalize(r, r);
                const a = t1.raycast(o, r, t1.exaggeration());
                if (a) {
                    const t2 = e1.scaleAndAdd([], o, r, a), i1 = new e1.MercatorCoordinate(t2[0], t2[1], e1.mercatorZfromAltitude(t2[2], e1.latFromMercatorY(t2[1]))), s = (i1.z + e1.length([
                        i1.x - o[0],
                        i1.y - o[1],
                        i1.z - o[2] * n
                    ])) * this._pixelsPerMercatorPixel;
                    this._seaLevelZoom = this._zoomFromMercatorZ(s), this._centerAltitude = i1.toAltitude(), this._center = this.coordinateLocation(i1), this._updateZoomFromElevation(), this._constrain(), this._calcMatrices();
                }
            }
            _constrainCameraAltitude() {
                if (!this._elevation) return;
                const t1 = this._elevation;
                this._updateCameraState();
                const i = e1.mercatorZfromAltitude(1, this._center.lat) * this.worldSize, o = this._computeCameraPosition(i), r = t1.getAtPointOrZero(new e1.MercatorCoordinate(...o)), n = this._minimumHeightOverTerrain() * Math.cos(e1.degToRad(this._maxPitch)), a = this._camera.position[2] - this.pixelsPerMeter / this.worldSize * r;
                if (a < n) {
                    const t2 = this.locationCoordinate(this._center, this._centerAltitude), i1 = [
                        t2.x - o[0],
                        t2.y - o[1],
                        t2.z - o[2]
                    ], r1 = e1.length(i1);
                    i1[2] -= (n - a) / this._pixelsPerMercatorPixel;
                    const s = e1.length(i1);
                    if (0 === s) return;
                    e1.scale$2(i1, i1, r1 / s * this._pixelsPerMercatorPixel), this._camera.position = [
                        t2.x - i1[0],
                        t2.y - i1[1],
                        t2.z * this._pixelsPerMercatorPixel - i1[2]
                    ], this._camera.orientation = jo(i1, this._camera.up()), this._updateStateFromCamera();
                }
            }
            _constrain() {
                if (!this.center || !this.width || !this.height || this._constraining) return;
                this._constraining = !0;
                const t1 = "globe" === this.projection.name || this.mercatorFromTransition;
                if (this.projection.isReprojectedInTileSpace || t1) {
                    const i = this.center;
                    return i.lat = e1.clamp(i.lat, this.minLat, this.maxLat), (this.maxBounds || !this.renderWorldCopies && !t1) && (i.lng = e1.clamp(i.lng, this.minLng, this.maxLng)), this.center = i, void (this._constraining = !1);
                }
                const i1 = this._unmodified, { x: o , y: r  } = this.point;
                let n = 0, a = o, s = r;
                const l = this.width / 2, c = this.height / 2, h = this.worldMinY * this.scale, _ = this.worldMaxY * this.scale;
                if (r - c < h && (s = h + c), r + c > _ && (s = _ - c), _ - h < this.height && (n = Math.max(n, this.height / (_ - h)), s = (_ + h) / 2), this.maxBounds || !this._renderWorldCopies || !this.projection.wrap) {
                    const e2 = this.worldMinX * this.scale, t2 = this.worldMaxX * this.scale, i2 = this.worldSize / 2 - (e2 + t2) / 2;
                    a = (o + i2 + this.worldSize) % this.worldSize - i2, a - l < e2 && (a = e2 + l), a + l > t2 && (a = t2 - l), t2 - e2 < this.width && (n = Math.max(n, this.width / (t2 - e2)), a = (t2 + e2) / 2);
                }
                a === o && s === r || (this.center = this.unproject(new e1.pointGeometry(a, s))), n && (this.zoom += this.scaleZoom(n)), this._constrainCameraAltitude(), this._unmodified = i1, this._constraining = !1;
            }
            _minZoomForBounds() {
                let e1 = Math.max(0, this.scaleZoom(this.height / (this.worldMaxY - this.worldMinY)));
                return this.maxBounds && (e1 = Math.max(e1, this.scaleZoom(this.width / (this.worldMaxX - this.worldMinX)))), e1;
            }
            _maxCameraBoundsDistance() {
                return this._mercatorZfromZoom(this._minZoomForBounds());
            }
            _calcMatrices() {
                if (!this.height) return;
                const t1 = this.centerOffset, i = this.pixelsPerMeter;
                "globe" === this.projection.name && (this._mercatorScaleRatio = e1.mercatorZfromAltitude(1, this.center.lat) / e1.mercatorZfromAltitude(1, e1.GLOBE_SCALE_MATCH_LATITUDE));
                const o = qo(this.projection, this.zoom, this.width, this.height, 1024);
                this._pixelsPerMercatorPixel = this.projection.pixelSpaceConversion(this.center.lat, this.worldSize, o), this.cameraToCenterDistance = .5 / Math.tan(.5 * this._fov) * this.height * this._pixelsPerMercatorPixel, this._updateCameraState(), this._farZ = this.projection.farthestPixelDistance(this), this._nearZ = this.height / 50;
                const r = this._camera.getWorldToCamera(this.worldSize, "meters" === this.projection.zAxisUnit ? i : 1), n = this._camera.getCameraToClipPerspective(this._fov, this.width / this.height, this._nearZ, this._farZ);
                n[8] = 2 * -t1.x / this.width, n[9] = 2 * t1.y / this.height;
                let a = e1.mul([], n, r);
                if (this.projection.isReprojectedInTileSpace) {
                    const t2 = this.locationCoordinate(this.center), i1 = e1.identity([]);
                    e1.translate(i1, i1, [
                        t2.x * this.worldSize,
                        t2.y * this.worldSize,
                        0
                    ]), e1.multiply(i1, i1, Wo(this)), e1.translate(i1, i1, [
                        -t2.x * this.worldSize,
                        -t2.y * this.worldSize,
                        0
                    ]), e1.multiply(a, a, i1), this.inverseAdjustmentMatrix = function(e1) {
                        const t1 = Wo(e1, !0);
                        return v([], [
                            t1[0],
                            t1[1],
                            t1[4],
                            t1[5]
                        ]);
                    }(this);
                } else this.inverseAdjustmentMatrix = [
                    1,
                    0,
                    0,
                    1
                ];
                this.mercatorMatrix = e1.scale([], a, [
                    this.worldSize,
                    this.worldSize,
                    this.worldSize / i,
                    1
                ]), this.projMatrix = a, this.invProjMatrix = e1.invert(new Float64Array(16), this.projMatrix);
                const s = e1.invert([], n);
                this.frustumCorners = e1.FrustumCorners.fromInvProjectionMatrix(s, this.horizonLineFromTop(), this.height);
                const l = new Float32Array(16);
                e1.identity(l), e1.scale(l, l, [
                    1,
                    -1,
                    1
                ]), e1.rotateX(l, l, this._pitch), e1.rotateZ(l, l, this.angle);
                const c = e1.perspective(new Float32Array(16), this._fov, this.width / this.height, this._nearZ, this._farZ), h = (Math.PI / 2 - this._pitch) * (this.height / this._fov) * this._horizonShift;
                c[8] = 2 * -t1.x / this.width, c[9] = 2 * (t1.y + h) / this.height, this.skyboxMatrix = e1.multiply(l, c, l);
                const _ = this.point, u = _.x, d = _.y, p = this.width % 2 / 2, m = this.height % 2 / 2, f = Math.cos(this.angle), g = Math.sin(this.angle), x = u - Math.round(u) + f * p + g * m, y = d - Math.round(d) + f * m + g * p, b = new Float64Array(a);
                if (e1.translate(b, b, [
                    x > .5 ? x - 1 : x,
                    y > .5 ? y - 1 : y,
                    0
                ]), this.alignedProjMatrix = b, a = e1.create(), e1.scale(a, a, [
                    this.width / 2,
                    -this.height / 2,
                    1
                ]), e1.translate(a, a, [
                    1,
                    -1,
                    0
                ]), this.labelPlaneMatrix = a, a = e1.create(), e1.scale(a, a, [
                    1,
                    -1,
                    1
                ]), e1.translate(a, a, [
                    -1,
                    -1,
                    0
                ]), e1.scale(a, a, [
                    2 / this.width,
                    2 / this.height,
                    1
                ]), this.glCoordMatrix = a, this.pixelMatrix = e1.multiply(new Float64Array(16), this.labelPlaneMatrix, this.projMatrix), this._calcFogMatrices(), this._distanceTileDataCache = {}, a = e1.invert(new Float64Array(16), this.pixelMatrix), !a) throw new Error("failed to invert matrix");
                if (this.pixelMatrixInverse = a, "globe" === this.projection.name || this.mercatorFromTransition) {
                    this.globeMatrix = e1.calculateGlobeMatrix(this);
                    const t3 = [
                        this.globeMatrix[12],
                        this.globeMatrix[13],
                        this.globeMatrix[14]
                    ];
                    this.globeCenterInViewSpace = e1.transformMat4(t3, t3, r), this.globeRadius = this.worldSize / 2 / Math.PI - 1;
                } else this.globeMatrix = a;
                this._projMatrixCache = {}, this._alignedProjMatrixCache = {}, this._pixelsToTileUnitsCache = {};
            }
            _calcFogMatrices() {
                this._fogTileMatrixCache = {};
                const t1 = this.cameraWorldSize, i = this.cameraPixelsPerMeter, o = this._camera.position, r = 1 / this.height / this._pixelsPerMercatorPixel, n = [
                    t1,
                    t1,
                    i
                ];
                e1.scale$2(n, n, r), e1.scale$2(o, o, -1), e1.multiply$2(o, o, n);
                const a = e1.create();
                e1.translate(a, a, o), e1.scale(a, a, n), this.mercatorFogMatrix = a, this.worldToFogMatrix = this._camera.getWorldToCameraPosition(t1, i, r);
            }
            _computeCameraPosition(e1) {
                const t1 = (e1 = e1 || this.pixelsPerMeter) / this.pixelsPerMeter, i = this._camera.forward(), o = this.point, r = this._mercatorZfromZoom(this._seaLevelZoom ? this._seaLevelZoom : this._zoom) * t1 - e1 / this.worldSize * this._centerAltitude;
                return [
                    o.x / this.worldSize - i[0] * r,
                    o.y / this.worldSize - i[1] * r,
                    e1 / this.worldSize * this._centerAltitude - i[2] * r
                ];
            }
            _updateCameraState() {
                this.height && (this._camera.setPitchBearing(this._pitch, this.angle), this._camera.position = this._computeCameraPosition());
            }
            _translateCameraConstrained(t1) {
                const i = this._maxCameraBoundsDistance() * Math.cos(this._pitch), o = this._camera.position[2], r = t1[2];
                let n = 1;
                this.projection.wrap && (this.center = this.center.wrap()), r > 0 && (n = Math.min((i - o) / r, 1)), this._camera.position = e1.scaleAndAdd([], this._camera.position, t1, n), this._updateStateFromCamera();
            }
            _updateStateFromCamera() {
                const t1 = this._camera.position, i = this._camera.forward(), { pitch: o , bearing: r  } = this._camera.getPitchBearing(), n = e1.mercatorZfromAltitude(this._centerAltitude, this.center.lat) * this._pixelsPerMercatorPixel, a = this._mercatorZfromZoom(this._maxZoom) * Math.cos(e1.degToRad(this._maxPitch)), s = Math.max((t1[2] - n) / Math.cos(o), a), l = this._zoomFromMercatorZ(s);
                e1.scaleAndAdd(t1, t1, i, s), this._pitch = e1.clamp(o, e1.degToRad(this.minPitch), e1.degToRad(this.maxPitch)), this.angle = e1.wrap(r, -Math.PI, Math.PI), this._setZoom(e1.clamp(l, this._minZoom, this._maxZoom)), this._updateSeaLevelZoom(), this._center = this.coordinateLocation(new e1.MercatorCoordinate(t1[0], t1[1], t1[2])), this._unmodified = !1, this._constrain(), this._calcMatrices();
            }
            _worldSizeFromZoom(e1) {
                return Math.pow(2, e1) * this.tileSize;
            }
            _mercatorZfromZoom(e1) {
                return this.cameraToCenterDistance / this._worldSizeFromZoom(e1);
            }
            _minimumHeightOverTerrain() {
                const e1 = Math.min((null != this._seaLevelZoom ? this._seaLevelZoom : this._zoom) + 2, this._maxZoom);
                return this._mercatorZfromZoom(e1);
            }
            _zoomFromMercatorZ(e1) {
                return this.scaleZoom(this.cameraToCenterDistance / (e1 * this.tileSize));
            }
            zoomFromMercatorZAdjusted(e1) {
                const t1 = (t1)=>{
                    const i = this.getCameraToCenterDistance(this.projection, t1);
                    return this.scaleZoom(i / (e1 * this.tileSize));
                };
                let i, o = t1(this.zoom), r = Math.abs(o - t1(o));
                for(; i !== r;)o = t1(o), i = r, r = Math.abs(o - t1(o));
                return o;
            }
            _terrainEnabled() {
                return !(!this._elevation || !this.projection.supportsTerrain && (e1.warnOnce("Terrain is not yet supported with alternate projections. Use mercator or globe to enable terrain."), 1));
            }
            anyCornerOffEdge(t1, i) {
                const o = Math.min(t1.x, i.x), r = Math.max(t1.x, i.x), n = Math.min(t1.y, i.y), a = Math.max(t1.y, i.y);
                if (n < this.horizonLineFromTop(!1)) return !0;
                if ("mercator" !== this.projection.name) return !1;
                const s = [
                    new e1.pointGeometry(o, n),
                    new e1.pointGeometry(r, a),
                    new e1.pointGeometry(o, a),
                    new e1.pointGeometry(r, n)
                ], l = this.renderWorldCopies ? -3 : 0, c = this.renderWorldCopies ? 4 : 1;
                for (const e2 of s){
                    const t2 = this.pointRayIntersection(e2);
                    if (t2.t < 0) return !0;
                    const i1 = this.rayIntersectionCoordinate(t2);
                    if (i1.x < l || i1.y < 0 || i1.x > c || i1.y > 1) return !0;
                }
                return !1;
            }
            isHorizonVisible() {
                return this.pitch + e1.radToDeg(this.fovAboveCenter) > 88 || this.anyCornerOffEdge(new e1.pointGeometry(0, 0), new e1.pointGeometry(this.width, this.height));
            }
            zoomDeltaToMovement(t1, i) {
                const o = e1.length(e1.sub([], this._camera.position, t1)), r = this._zoomFromMercatorZ(o) + i;
                return o - this._mercatorZfromZoom(r);
            }
            getCameraPoint() {
                if ("globe" === this.projection.name) {
                    const t1 = function(t1, i) {
                        const o = [
                            t1[0],
                            t1[1],
                            t1[2],
                            1
                        ];
                        e1.transformMat4$1(o, o, i);
                        const r = Math.max(o[3], 1e-6);
                        return [
                            o[0] / r,
                            o[1] / r,
                            o[2] / r,
                            r
                        ];
                    }([
                        this.globeMatrix[12],
                        this.globeMatrix[13],
                        this.globeMatrix[14]
                    ], this.pixelMatrix);
                    return new e1.pointGeometry(t1[0], t1[1]);
                }
                {
                    const t2 = Math.tan(this._pitch) * (this.cameraToCenterDistance || 1);
                    return this.centerPoint.add(new e1.pointGeometry(0, t2));
                }
            }
            getCameraToCenterDistance(e1, t1 = this.zoom) {
                const i = qo(e1, t1, this.width, this.height, 1024), o = e1.pixelSpaceConversion(this.center.lat, this.worldSize, i);
                return .5 / Math.tan(.5 * this._fov) * this.height * o;
            }
            getWorldToCameraMatrix() {
                const t1 = this._camera.getWorldToCamera(this.worldSize, "meters" === this.projection.zAxisUnit ? this.pixelsPerMeter : 1);
                return "globe" === this.projection.name && e1.multiply(t1, t1, this.globeMatrix), t1;
            }
        }
        function Jo(e1, t1) {
            let i = !1, o = null;
            const r = ()=>{
                o = null, i && (e1(), o = setTimeout(r, t1), i = !1);
            };
            return ()=>(i = !0, o || r(), o);
        }
        class Qo {
            constructor(t1){
                this._hashName = t1 && encodeURIComponent(t1), e1.bindAll([
                    "_getCurrentHash",
                    "_onHashChange",
                    "_updateHash"
                ], this), this._updateHash = Jo(this._updateHashUnthrottled.bind(this), 300);
            }
            addTo(t1) {
                return this._map = t1, e1.window.addEventListener("hashchange", this._onHashChange, !1), t1.on("moveend", this._updateHash), this;
            }
            remove() {
                return this._map ? (this._map.off("moveend", this._updateHash), e1.window.removeEventListener("hashchange", this._onHashChange, !1), clearTimeout(this._updateHash()), this._map = void 0, this) : this;
            }
            getHashString() {
                const t1 = this._map;
                if (!t1) return "";
                const i = er(t1);
                if (this._hashName) {
                    const t2 = this._hashName;
                    let o = !1;
                    const r = e1.window.location.hash.slice(1).split("&").map((e1)=>{
                        const r = e1.split("=")[0];
                        return r === t2 ? (o = !0, `${r}=${i}`) : e1;
                    }).filter((e1)=>e1);
                    return o || r.push(`${t2}=${i}`), `#${r.join("&")}`;
                }
                return `#${i}`;
            }
            _getCurrentHash() {
                const t1 = e1.window.location.hash.replace("#", "");
                if (this._hashName) {
                    let e2;
                    return t1.split("&").map((e1)=>e1.split("=")).forEach((t1)=>{
                        t1[0] === this._hashName && (e2 = t1);
                    }), (e2 && e2[1] || "").split("/");
                }
                return t1.split("/");
            }
            _onHashChange() {
                const e1 = this._map;
                if (!e1) return !1;
                const t1 = this._getCurrentHash();
                if (t1.length >= 3 && !t1.some((e1)=>isNaN(e1))) {
                    const i = e1.dragRotate.isEnabled() && e1.touchZoomRotate.isEnabled() ? +(t1[3] || 0) : e1.getBearing();
                    return e1.jumpTo({
                        center: [
                            +t1[2],
                            +t1[1]
                        ],
                        zoom: +t1[0],
                        bearing: i,
                        pitch: +(t1[4] || 0)
                    }), !0;
                }
                return !1;
            }
            _updateHashUnthrottled() {
                const t1 = e1.window.location.href.replace(/(#.+)?$/, this.getHashString());
                e1.window.history.replaceState(e1.window.history.state, null, t1);
            }
        }
        function er(e1, t1) {
            const i = e1.getCenter(), o = Math.round(100 * e1.getZoom()) / 100, r = Math.ceil((o * Math.LN2 + Math.log(512 / 360 / .5)) / Math.LN10), n = Math.pow(10, r), a = Math.round(i.lng * n) / n, s = Math.round(i.lat * n) / n, l = e1.getBearing(), c = e1.getPitch();
            let h = t1 ? `/${a}/${s}/${o}` : `${o}/${s}/${a}`;
            return (l || c) && (h += "/" + Math.round(10 * l) / 10), c && (h += `/${Math.round(c)}`), h;
        }
        const tr = {
            linearity: .3,
            easing: e1.bezier(0, 0, .3, 1)
        }, ir = e1.extend({
            deceleration: 2500,
            maxSpeed: 1400
        }, tr), or = e1.extend({
            deceleration: 20,
            maxSpeed: 1400
        }, tr), rr = e1.extend({
            deceleration: 1e3,
            maxSpeed: 360
        }, tr), nr = e1.extend({
            deceleration: 1e3,
            maxSpeed: 90
        }, tr);
        class ar {
            constructor(e1){
                this._map = e1, this.clear();
            }
            clear() {
                this._inertiaBuffer = [];
            }
            record(t1) {
                this._drainInertiaBuffer(), this._inertiaBuffer.push({
                    time: e1.exported.now(),
                    settings: t1
                });
            }
            _drainInertiaBuffer() {
                const t1 = this._inertiaBuffer, i = e1.exported.now();
                for(; t1.length > 0 && i - t1[0].time > 160;)t1.shift();
            }
            _onMoveEnd(t1) {
                if (this._drainInertiaBuffer(), this._inertiaBuffer.length < 2) return;
                const i = {
                    zoom: 0,
                    bearing: 0,
                    pitch: 0,
                    pan: new e1.pointGeometry(0, 0),
                    pinchAround: void 0,
                    around: void 0
                };
                for (const { settings: e2  } of this._inertiaBuffer)i.zoom += e2.zoomDelta || 0, i.bearing += e2.bearingDelta || 0, i.pitch += e2.pitchDelta || 0, e2.panDelta && i.pan._add(e2.panDelta), e2.around && (i.around = e2.around), e2.pinchAround && (i.pinchAround = e2.pinchAround);
                const o = this._inertiaBuffer[this._inertiaBuffer.length - 1].time - this._inertiaBuffer[0].time, r = {};
                if (i.pan.mag()) {
                    const n = lr(i.pan.mag(), o, e1.extend({}, ir, t1 || {}));
                    r.offset = i.pan.mult(n.amount / i.pan.mag()), r.center = this._map.transform.center, sr(r, n);
                }
                if (i.zoom) {
                    const e3 = lr(i.zoom, o, or);
                    r.zoom = this._map.transform.zoom + e3.amount, sr(r, e3);
                }
                if (i.bearing) {
                    const t2 = lr(i.bearing, o, rr);
                    r.bearing = this._map.transform.bearing + e1.clamp(t2.amount, -179, 179), sr(r, t2);
                }
                if (i.pitch) {
                    const e4 = lr(i.pitch, o, nr);
                    r.pitch = this._map.transform.pitch + e4.amount, sr(r, e4);
                }
                if (r.zoom || r.bearing) {
                    const e5 = void 0 === i.pinchAround ? i.around : i.pinchAround;
                    r.around = e5 ? this._map.unproject(e5) : this._map.getCenter();
                }
                return this.clear(), r.noMoveStart = !0, r;
            }
        }
        function sr(e1, t1) {
            (!e1.duration || e1.duration < t1.duration) && (e1.duration = t1.duration, e1.easing = t1.easing);
        }
        function lr(t1, i, o) {
            const { maxSpeed: r , linearity: n , deceleration: a  } = o, s = e1.clamp(t1 * n / (i / 1e3), -r, r), l = Math.abs(s) / (a * n);
            return {
                easing: o.easing,
                duration: 1e3 * l,
                amount: s * (l / 2)
            };
        }
        class cr extends e1.Event {
            preventDefault() {
                this._defaultPrevented = !0;
            }
            get defaultPrevented() {
                return this._defaultPrevented;
            }
            constructor(t1, i, o, r = {}){
                const n = p(i.getCanvasContainer(), o), a = i.unproject(n);
                super(t1, e1.extend({
                    point: n,
                    lngLat: a,
                    originalEvent: o
                }, r)), this._defaultPrevented = !1, this.target = i;
            }
        }
        class hr extends e1.Event {
            preventDefault() {
                this._defaultPrevented = !0;
            }
            get defaultPrevented() {
                return this._defaultPrevented;
            }
            constructor(t1, i, o){
                const r = "touchend" === t1 ? o.changedTouches : o.touches, n = m(i.getCanvasContainer(), r), a = n.map((e1)=>i.unproject(e1)), s = n.reduce((e1, t1, i, o)=>e1.add(t1.div(o.length)), new e1.pointGeometry(0, 0));
                super(t1, {
                    points: n,
                    point: s,
                    lngLats: a,
                    lngLat: i.unproject(s),
                    originalEvent: o
                }), this._defaultPrevented = !1;
            }
        }
        class _r extends e1.Event {
            preventDefault() {
                this._defaultPrevented = !0;
            }
            get defaultPrevented() {
                return this._defaultPrevented;
            }
            constructor(e1, t1, i){
                super(e1, {
                    originalEvent: i
                }), this._defaultPrevented = !1;
            }
        }
        class ur {
            constructor(e1, t1){
                this._map = e1, this._clickTolerance = t1.clickTolerance;
            }
            reset() {
                this._mousedownPos = void 0;
            }
            wheel(e1) {
                return this._firePreventable(new _r(e1.type, this._map, e1));
            }
            mousedown(e1, t1) {
                return this._mousedownPos = t1, this._firePreventable(new cr(e1.type, this._map, e1));
            }
            mouseup(e1) {
                this._map.fire(new cr(e1.type, this._map, e1));
            }
            preclick(t1) {
                const i = e1.extend({}, t1);
                i.type = "preclick", this._map.fire(new cr(i.type, this._map, i));
            }
            click(e1, t1) {
                this._mousedownPos && this._mousedownPos.dist(t1) >= this._clickTolerance || (this.preclick(e1), this._map.fire(new cr(e1.type, this._map, e1)));
            }
            dblclick(e1) {
                return this._firePreventable(new cr(e1.type, this._map, e1));
            }
            mouseover(e1) {
                this._map.fire(new cr(e1.type, this._map, e1));
            }
            mouseout(e1) {
                this._map.fire(new cr(e1.type, this._map, e1));
            }
            touchstart(e1) {
                return this._firePreventable(new hr(e1.type, this._map, e1));
            }
            touchmove(e1) {
                this._map.fire(new hr(e1.type, this._map, e1));
            }
            touchend(e1) {
                this._map.fire(new hr(e1.type, this._map, e1));
            }
            touchcancel(e1) {
                this._map.fire(new hr(e1.type, this._map, e1));
            }
            _firePreventable(e1) {
                if (this._map.fire(e1), e1.defaultPrevented) return {};
            }
            isEnabled() {
                return !0;
            }
            isActive() {
                return !1;
            }
            enable() {}
            disable() {}
        }
        class dr {
            constructor(e1){
                this._map = e1;
            }
            reset() {
                this._delayContextMenu = !1, this._contextMenuEvent = void 0;
            }
            mousemove(e1) {
                this._map.fire(new cr(e1.type, this._map, e1));
            }
            mousedown() {
                this._delayContextMenu = !0;
            }
            mouseup() {
                this._delayContextMenu = !1, this._contextMenuEvent && (this._map.fire(new cr("contextmenu", this._map, this._contextMenuEvent)), delete this._contextMenuEvent);
            }
            contextmenu(e1) {
                this._delayContextMenu ? this._contextMenuEvent = e1 : this._map.fire(new cr(e1.type, this._map, e1)), this._map.listens("contextmenu") && e1.preventDefault();
            }
            isEnabled() {
                return !0;
            }
            isActive() {
                return !1;
            }
            enable() {}
            disable() {}
        }
        class pr {
            constructor(e1, t1){
                this._map = e1, this._el = e1.getCanvasContainer(), this._container = e1.getContainer(), this._clickTolerance = t1.clickTolerance || 1;
            }
            isEnabled() {
                return !!this._enabled;
            }
            isActive() {
                return !!this._active;
            }
            enable() {
                this.isEnabled() || (this._enabled = !0);
            }
            disable() {
                this.isEnabled() && (this._enabled = !1);
            }
            mousedown(e1, t1) {
                this.isEnabled() && e1.shiftKey && 0 === e1.button && (h(), this._startPos = this._lastPos = t1, this._active = !0);
            }
            mousemoveWindow(e1, t1) {
                if (!this._active) return;
                const i = t1, o = this._startPos, r = this._lastPos;
                if (!o || !r || r.equals(i) || !this._box && i.dist(o) < this._clickTolerance) return;
                this._lastPos = i, this._box || (this._box = n("div", "mapboxgl-boxzoom", this._container), this._container.classList.add("mapboxgl-crosshair"), this._fireEvent("boxzoomstart", e1));
                const a = Math.min(o.x, i.x), s = Math.max(o.x, i.x), l = Math.min(o.y, i.y), c = Math.max(o.y, i.y);
                this._map._requestDomTask(()=>{
                    this._box && (this._box.style.transform = `translate(${a}px,${l}px)`, this._box.style.width = s - a + "px", this._box.style.height = c - l + "px");
                });
            }
            mouseupWindow(t1, i) {
                if (!this._active) return;
                const o = this._startPos, r = i;
                if (o && 0 === t1.button) {
                    if (this.reset(), d(), o.x !== r.x || o.y !== r.y) return this._map.fire(new e1.Event("boxzoomend", {
                        originalEvent: t1
                    })), {
                        cameraAnimation: (e1)=>e1.fitScreenCoordinates(o, r, this._map.getBearing(), {
                                linear: !1
                            })
                    };
                    this._fireEvent("boxzoomcancel", t1);
                }
            }
            keydown(e1) {
                this._active && 27 === e1.keyCode && (this.reset(), this._fireEvent("boxzoomcancel", e1));
            }
            blur() {
                this.reset();
            }
            reset() {
                this._active = !1, this._container.classList.remove("mapboxgl-crosshair"), this._box && (this._box.remove(), this._box = null), _(), delete this._startPos, delete this._lastPos;
            }
            _fireEvent(t1, i) {
                return this._map.fire(new e1.Event(t1, {
                    originalEvent: i
                }));
            }
        }
        function mr(e1, t1) {
            const i = {};
            for(let o = 0; o < e1.length; o++)i[e1[o].identifier] = t1[o];
            return i;
        }
        class fr {
            constructor(e1){
                this.reset(), this.numTouches = e1.numTouches;
            }
            reset() {
                this.centroid = void 0, this.startTime = 0, this.touches = {}, this.aborted = !1;
            }
            touchstart(t1, i, o) {
                (this.centroid || o.length > this.numTouches) && (this.aborted = !0), this.aborted || (0 === this.startTime && (this.startTime = t1.timeStamp), o.length === this.numTouches && (this.centroid = function(t1) {
                    const i = new e1.pointGeometry(0, 0);
                    for (const e2 of t1)i._add(e2);
                    return i.div(t1.length);
                }(i), this.touches = mr(o, i)));
            }
            touchmove(e1, t1, i) {
                if (this.aborted || !this.centroid) return;
                const o = mr(i, t1);
                for(const e2 in this.touches){
                    const t2 = this.touches[e2], i1 = o[e2];
                    (!i1 || i1.dist(t2) > 30) && (this.aborted = !0);
                }
            }
            touchend(e1, t1, i) {
                if ((!this.centroid || e1.timeStamp - this.startTime > 500) && (this.aborted = !0), 0 === i.length) {
                    const e2 = !this.aborted && this.centroid;
                    if (this.reset(), e2) return e2;
                }
            }
        }
        class gr {
            constructor(e1){
                this.singleTap = new fr(e1), this.numTaps = e1.numTaps, this.reset();
            }
            reset() {
                this.lastTime = 1 / 0, this.lastTap = void 0, this.count = 0, this.singleTap.reset();
            }
            touchstart(e1, t1, i) {
                this.singleTap.touchstart(e1, t1, i);
            }
            touchmove(e1, t1, i) {
                this.singleTap.touchmove(e1, t1, i);
            }
            touchend(e1, t1, i) {
                const o = this.singleTap.touchend(e1, t1, i);
                if (o) {
                    const t2 = e1.timeStamp - this.lastTime < 500, i1 = !this.lastTap || this.lastTap.dist(o) < 30;
                    if (t2 && i1 || this.reset(), this.count++, this.lastTime = e1.timeStamp, this.lastTap = o, this.count === this.numTaps) return this.reset(), o;
                }
            }
        }
        class vr {
            constructor(){
                this._zoomIn = new gr({
                    numTouches: 1,
                    numTaps: 2
                }), this._zoomOut = new gr({
                    numTouches: 2,
                    numTaps: 1
                }), this.reset();
            }
            reset() {
                this._active = !1, this._zoomIn.reset(), this._zoomOut.reset();
            }
            touchstart(e1, t1, i) {
                this._zoomIn.touchstart(e1, t1, i), this._zoomOut.touchstart(e1, t1, i);
            }
            touchmove(e1, t1, i) {
                this._zoomIn.touchmove(e1, t1, i), this._zoomOut.touchmove(e1, t1, i);
            }
            touchend(e1, t1, i) {
                const o = this._zoomIn.touchend(e1, t1, i), r = this._zoomOut.touchend(e1, t1, i);
                return o ? (this._active = !0, e1.preventDefault(), setTimeout(()=>this.reset(), 0), {
                    cameraAnimation: (t1)=>t1.easeTo({
                            duration: 300,
                            zoom: t1.getZoom() + 1,
                            around: t1.unproject(o)
                        }, {
                            originalEvent: e1
                        })
                }) : r ? (this._active = !0, e1.preventDefault(), setTimeout(()=>this.reset(), 0), {
                    cameraAnimation: (t1)=>t1.easeTo({
                            duration: 300,
                            zoom: t1.getZoom() - 1,
                            around: t1.unproject(r)
                        }, {
                            originalEvent: e1
                        })
                }) : void 0;
            }
            touchcancel() {
                this.reset();
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        const xr = {
            0: 1,
            2: 2
        };
        class yr {
            constructor(e1){
                this.reset(), this._clickTolerance = e1.clickTolerance || 1;
            }
            blur() {
                this.reset();
            }
            reset() {
                this._active = !1, this._moved = !1, this._lastPoint = void 0, this._eventButton = void 0;
            }
            _correctButton(e1, t1) {
                return !1;
            }
            _move(e1, t1) {
                return {};
            }
            mousedown(e1, t1) {
                if (this._lastPoint) return;
                const i = f(e1);
                this._correctButton(e1, i) && (this._lastPoint = t1, this._eventButton = i);
            }
            mousemoveWindow(e1, t1) {
                const i = this._lastPoint;
                if (i) {
                    if (e1.preventDefault(), null != this._eventButton && function(e1, t1) {
                        const i = xr[t1];
                        return void 0 === e1.buttons || (e1.buttons & i) !== i;
                    }(e1, this._eventButton)) this.reset();
                    else if (this._moved || !(t1.dist(i) < this._clickTolerance)) return this._moved = !0, this._lastPoint = t1, this._move(i, t1);
                }
            }
            mouseupWindow(e1) {
                this._lastPoint && f(e1) === this._eventButton && (this._moved && d(), this.reset());
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        class br extends yr {
            mousedown(e1, t1) {
                super.mousedown(e1, t1), this._lastPoint && (this._active = !0);
            }
            _correctButton(e1, t1) {
                return 0 === t1 && !e1.ctrlKey;
            }
            _move(e1, t1) {
                return {
                    around: t1,
                    panDelta: t1.sub(e1)
                };
            }
        }
        class wr extends yr {
            _correctButton(e1, t1) {
                return 0 === t1 && e1.ctrlKey || 2 === t1;
            }
            _move(e1, t1) {
                const i = .8 * (t1.x - e1.x);
                if (i) return this._active = !0, {
                    bearingDelta: i
                };
            }
            contextmenu(e1) {
                e1.preventDefault();
            }
        }
        class Tr extends yr {
            _correctButton(e1, t1) {
                return 0 === t1 && e1.ctrlKey || 2 === t1;
            }
            _move(e1, t1) {
                const i = -0.5 * (t1.y - e1.y);
                if (i) return this._active = !0, {
                    pitchDelta: i
                };
            }
            contextmenu(e1) {
                e1.preventDefault();
            }
        }
        class Er {
            constructor(t1, i){
                this._map = t1, this._el = t1.getCanvasContainer(), this._minTouches = 1, this._clickTolerance = i.clickTolerance || 1, this.reset(), e1.bindAll([
                    "_addTouchPanBlocker",
                    "_showTouchPanBlockerAlert"
                ], this);
            }
            reset() {
                this._active = !1, this._touches = {}, this._sum = new e1.pointGeometry(0, 0);
            }
            touchstart(e1, t1, i) {
                return this._calculateTransform(e1, t1, i);
            }
            touchmove(t1, i, o) {
                if (this._active && !(o.length < this._minTouches)) {
                    if (this._map._cooperativeGestures && !this._map.isMoving()) {
                        if (1 === o.length && !e1.isFullscreen()) return void this._showTouchPanBlockerAlert();
                        "hidden" !== this._alertContainer.style.visibility && (this._alertContainer.style.visibility = "hidden", clearTimeout(this._alertTimer));
                    }
                    return t1.cancelable && t1.preventDefault(), this._calculateTransform(t1, i, o);
                }
            }
            touchend(e1, t1, i) {
                this._calculateTransform(e1, t1, i), this._active && i.length < this._minTouches && this.reset();
            }
            touchcancel() {
                this.reset();
            }
            _calculateTransform(t1, i, o) {
                o.length > 0 && (this._active = !0);
                const r = mr(o, i), n = new e1.pointGeometry(0, 0), a = new e1.pointGeometry(0, 0);
                let s = 0;
                for(const e2 in r){
                    const t2 = r[e2], i1 = this._touches[e2];
                    i1 && (n._add(t2), a._add(t2.sub(i1)), s++, r[e2] = t2);
                }
                if (this._touches = r, s < this._minTouches || !a.mag()) return;
                const l = a.div(s);
                return this._sum._add(l), this._sum.mag() < this._clickTolerance ? void 0 : {
                    around: n.div(s),
                    panDelta: l
                };
            }
            enable() {
                this._enabled = !0, this._map._cooperativeGestures && (this._addTouchPanBlocker(), this._el.classList.add("mapboxgl-touch-pan-blocker-override", "mapboxgl-scrollable-page"));
            }
            disable() {
                this._enabled = !1, this._map._cooperativeGestures && (clearTimeout(this._alertTimer), this._alertContainer.remove(), this._el.classList.remove("mapboxgl-touch-pan-blocker-override", "mapboxgl-scrollable-page")), this.reset();
            }
            isEnabled() {
                return !!this._enabled;
            }
            isActive() {
                return !!this._active;
            }
            _addTouchPanBlocker() {
                this._map && !this._alertContainer && (this._alertContainer = n("div", "mapboxgl-touch-pan-blocker", this._map._container), this._alertContainer.textContent = this._map._getUIString("TouchPanBlocker.Message"), this._alertContainer.style.fontSize = `${Math.max(10, Math.min(24, Math.floor(.05 * this._el.clientWidth)))}px`);
            }
            _showTouchPanBlockerAlert() {
                this._alertContainer.style.visibility = "visible", this._alertContainer.classList.add("mapboxgl-touch-pan-blocker-show"), this._alertContainer.setAttribute("role", "alert"), clearTimeout(this._alertTimer), this._alertTimer = setTimeout(()=>{
                    this._alertContainer.classList.remove("mapboxgl-touch-pan-blocker-show"), this._alertContainer.setAttribute("role", "null");
                }, 500);
            }
        }
        class Cr {
            constructor(){
                this.reset();
            }
            reset() {
                this._active = !1, this._firstTwoTouches = void 0;
            }
            _start(e1) {}
            _move(e1, t1, i) {
                return {};
            }
            touchstart(e1, t1, i) {
                this._firstTwoTouches || i.length < 2 || (this._firstTwoTouches = [
                    i[0].identifier,
                    i[1].identifier
                ], this._start([
                    t1[0],
                    t1[1]
                ]));
            }
            touchmove(e1, t1, i) {
                const o = this._firstTwoTouches;
                if (!o) return;
                e1.preventDefault();
                const [r, n] = o, a = Ir(i, t1, r), s = Ir(i, t1, n);
                if (!a || !s) return;
                const l = this._aroundCenter ? null : a.add(s).div(2);
                return this._move([
                    a,
                    s
                ], l, e1);
            }
            touchend(e1, t1, i) {
                if (!this._firstTwoTouches) return;
                const [o, r] = this._firstTwoTouches, n = Ir(i, t1, o), a = Ir(i, t1, r);
                n && a || (this._active && d(), this.reset());
            }
            touchcancel() {
                this.reset();
            }
            enable(e1) {
                this._enabled = !0, this._aroundCenter = !!e1 && "center" === e1.around;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        function Ir(e1, t1, i) {
            for(let o = 0; o < e1.length; o++)if (e1[o].identifier === i) return t1[o];
        }
        function Mr(e1, t1) {
            return Math.log(e1 / t1) / Math.LN2;
        }
        class Sr extends Cr {
            reset() {
                super.reset(), this._distance = 0, this._startDistance = 0;
            }
            _start(e1) {
                this._startDistance = this._distance = e1[0].dist(e1[1]);
            }
            _move(e1, t1) {
                const i = this._distance;
                if (this._distance = e1[0].dist(e1[1]), this._active || !(Math.abs(Mr(this._distance, this._startDistance)) < .1)) return this._active = !0, {
                    zoomDelta: Mr(this._distance, i),
                    pinchAround: t1
                };
            }
        }
        function zr(e1, t1) {
            return 180 * e1.angleWith(t1) / Math.PI;
        }
        class Dr extends Cr {
            reset() {
                super.reset(), this._minDiameter = 0, this._startVector = void 0, this._vector = void 0;
            }
            _start(e1) {
                this._startVector = this._vector = e1[0].sub(e1[1]), this._minDiameter = e1[0].dist(e1[1]);
            }
            _move(e1, t1) {
                const i = this._vector;
                if (this._vector = e1[0].sub(e1[1]), i && (this._active || !this._isBelowThreshold(this._vector))) return this._active = !0, {
                    bearingDelta: zr(this._vector, i),
                    pinchAround: t1
                };
            }
            _isBelowThreshold(e1) {
                this._minDiameter = Math.min(this._minDiameter, e1.mag());
                const t1 = 25 / (Math.PI * this._minDiameter) * 360, i = this._startVector;
                if (!i) return !1;
                const o = zr(e1, i);
                return Math.abs(o) < t1;
            }
        }
        function Ar(e1) {
            return Math.abs(e1.y) > Math.abs(e1.x);
        }
        class Pr extends Cr {
            constructor(e1){
                super(), this._map = e1;
            }
            reset() {
                super.reset(), this._valid = void 0, this._firstMove = void 0, this._lastPoints = void 0;
            }
            _start(e1) {
                this._lastPoints = e1, Ar(e1[0].sub(e1[1])) && (this._valid = !1);
            }
            _move(t1, i, o) {
                const r = this._lastPoints;
                if (!r) return;
                const n = t1[0].sub(r[0]), a = t1[1].sub(r[1]);
                return this._map._cooperativeGestures && !e1.isFullscreen() && o.touches.length < 3 || (this._valid = this.gestureBeginsVertically(n, a, o.timeStamp), !this._valid) ? void 0 : (this._lastPoints = t1, this._active = !0, {
                    pitchDelta: (n.y + a.y) / 2 * -0.5
                });
            }
            gestureBeginsVertically(e1, t1, i) {
                if (void 0 !== this._valid) return this._valid;
                const o = e1.mag() >= 2, r = t1.mag() >= 2;
                if (!o && !r) return;
                if (!o || !r) return null == this._firstMove && (this._firstMove = i), i - this._firstMove < 100 && void 0;
                const n = e1.y > 0 == t1.y > 0;
                return Ar(e1) && Ar(t1) && n;
            }
        }
        const Lr = {
            panStep: 100,
            bearingStep: 15,
            pitchStep: 10
        };
        class Rr {
            constructor(){
                const e1 = Lr;
                this._panStep = e1.panStep, this._bearingStep = e1.bearingStep, this._pitchStep = e1.pitchStep, this._rotationDisabled = !1;
            }
            blur() {
                this.reset();
            }
            reset() {
                this._active = !1;
            }
            keydown(e1) {
                if (e1.altKey || e1.ctrlKey || e1.metaKey) return;
                let t1 = 0, i = 0, o = 0, r = 0, n = 0;
                switch(e1.keyCode){
                    case 61:
                    case 107:
                    case 171:
                    case 187:
                        t1 = 1;
                        break;
                    case 189:
                    case 109:
                    case 173:
                        t1 = -1;
                        break;
                    case 37:
                        e1.shiftKey ? i = -1 : (e1.preventDefault(), r = -1);
                        break;
                    case 39:
                        e1.shiftKey ? i = 1 : (e1.preventDefault(), r = 1);
                        break;
                    case 38:
                        e1.shiftKey ? o = 1 : (e1.preventDefault(), n = -1);
                        break;
                    case 40:
                        e1.shiftKey ? o = -1 : (e1.preventDefault(), n = 1);
                        break;
                    default:
                        return;
                }
                return this._rotationDisabled && (i = 0, o = 0), {
                    cameraAnimation: (a)=>{
                        const s = a.getZoom();
                        a.easeTo({
                            duration: 300,
                            easeId: "keyboardHandler",
                            easing: Or,
                            zoom: t1 ? Math.round(s) + t1 * (e1.shiftKey ? 2 : 1) : s,
                            bearing: a.getBearing() + i * this._bearingStep,
                            pitch: a.getPitch() + o * this._pitchStep,
                            offset: [
                                -r * this._panStep,
                                -n * this._panStep
                            ],
                            center: a.getCenter()
                        }, {
                            originalEvent: e1
                        });
                    }
                };
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
            disableRotation() {
                this._rotationDisabled = !0;
            }
            enableRotation() {
                this._rotationDisabled = !1;
            }
        }
        function Or(e1) {
            return e1 * (2 - e1);
        }
        const Br = 4.000244140625;
        class kr {
            constructor(t1, i){
                this._map = t1, this._el = t1.getCanvasContainer(), this._handler = i, this._delta = 0, this._defaultZoomRate = .01, this._wheelZoomRate = .0022222222222222222, e1.bindAll([
                    "_onTimeout",
                    "_addScrollZoomBlocker",
                    "_showBlockerAlert"
                ], this);
            }
            setZoomRate(e1) {
                this._defaultZoomRate = e1;
            }
            setWheelZoomRate(e1) {
                this._wheelZoomRate = e1;
            }
            isEnabled() {
                return !!this._enabled;
            }
            isActive() {
                return this._active || void 0 !== this._finishTimeout;
            }
            isZooming() {
                return !!this._zooming;
            }
            enable(e1) {
                this.isEnabled() || (this._enabled = !0, this._aroundCenter = !!e1 && "center" === e1.around, this._map._cooperativeGestures && this._addScrollZoomBlocker());
            }
            disable() {
                this.isEnabled() && (this._enabled = !1, this._map._cooperativeGestures && (clearTimeout(this._alertTimer), this._alertContainer.remove()));
            }
            wheel(t1) {
                if (!this.isEnabled()) return;
                if (this._map._cooperativeGestures) {
                    if (!(t1.ctrlKey || t1.metaKey || this.isZooming() || e1.isFullscreen())) return void this._showBlockerAlert();
                    "hidden" !== this._alertContainer.style.visibility && (this._alertContainer.style.visibility = "hidden", clearTimeout(this._alertTimer));
                }
                let i = t1.deltaMode === e1.window.WheelEvent.DOM_DELTA_LINE ? 40 * t1.deltaY : t1.deltaY;
                const o = e1.exported.now(), r = o - (this._lastWheelEventTime || 0);
                this._lastWheelEventTime = o, 0 !== i && i % Br == 0 ? this._type = "wheel" : 0 !== i && Math.abs(i) < 4 ? this._type = "trackpad" : r > 400 ? (this._type = null, this._lastValue = i, this._timeout = setTimeout(this._onTimeout, 40, t1)) : this._type || (this._type = Math.abs(r * i) < 200 ? "trackpad" : "wheel", this._timeout && (clearTimeout(this._timeout), this._timeout = null, i += this._lastValue)), t1.shiftKey && i && (i /= 4), this._type && (this._lastWheelEvent = t1, this._delta -= i, this._active || this._start(t1)), t1.preventDefault();
            }
            _onTimeout(e1) {
                this._type = "wheel", this._delta -= this._lastValue, this._active || this._start(e1);
            }
            _start(e1) {
                if (!this._delta) return;
                this._frameId && (this._frameId = null), this._active = !0, this.isZooming() || (this._zooming = !0), this._finishTimeout && (clearTimeout(this._finishTimeout), delete this._finishTimeout);
                const t1 = p(this._el, e1);
                this._aroundPoint = this._aroundCenter ? this._map.transform.centerPoint : t1, this._aroundCoord = this._map.transform.pointCoordinate3D(this._aroundPoint), this._targetZoom = void 0, this._frameId || (this._frameId = !0, this._handler._triggerRenderFrame());
            }
            renderFrame() {
                if (!this._frameId) return;
                if (this._frameId = null, !this.isActive()) return;
                const t1 = this._map.transform;
                "wheel" === this._type && t1.projection.wrap && (t1._center.lng >= 180 || t1._center.lng <= -180) && (this._prevEase = null, this._easing = null, this._lastWheelEvent = null, this._lastWheelEventTime = 0);
                const i = ()=>t1._terrainEnabled() && this._aroundCoord ? t1.computeZoomRelativeTo(this._aroundCoord) : t1.zoom;
                if (0 !== this._delta) {
                    const e2 = "wheel" === this._type && Math.abs(this._delta) > Br ? this._wheelZoomRate : this._defaultZoomRate;
                    let o = 2 / (1 + Math.exp(-Math.abs(this._delta * e2)));
                    this._delta < 0 && 0 !== o && (o = 1 / o);
                    const r = i(), n = Math.pow(2, r), a = "number" == typeof this._targetZoom ? t1.zoomScale(this._targetZoom) : n;
                    this._targetZoom = Math.min(t1.maxZoom, Math.max(t1.minZoom, t1.scaleZoom(a * o))), "wheel" === this._type && (this._startZoom = r, this._easing = this._smoothOutEasing(200)), this._delta = 0;
                }
                const o1 = "number" == typeof this._targetZoom ? this._targetZoom : i(), r1 = this._startZoom, n1 = this._easing;
                let a1, s = !1;
                if ("wheel" === this._type && r1 && n1) {
                    const t2 = Math.min((e1.exported.now() - this._lastWheelEventTime) / 200, 1), i1 = n1(t2);
                    a1 = e1.number(r1, o1, i1), t2 < 1 ? this._frameId || (this._frameId = !0) : s = !0;
                } else a1 = o1, s = !0;
                return this._active = !0, s && (this._active = !1, this._finishTimeout = setTimeout(()=>{
                    this._zooming = !1, this._handler._triggerRenderFrame(), delete this._targetZoom, delete this._finishTimeout;
                }, 200)), {
                    noInertia: !0,
                    needsRenderFrame: !s,
                    zoomDelta: a1 - i(),
                    around: this._aroundPoint,
                    aroundCoord: this._aroundCoord,
                    originalEvent: this._lastWheelEvent
                };
            }
            _smoothOutEasing(t1) {
                let i = e1.ease;
                if (this._prevEase) {
                    const t2 = this._prevEase, o = (e1.exported.now() - t2.start) / t2.duration, r = t2.easing(o + .01) - t2.easing(o), n = .27 / Math.sqrt(r * r + 1e-4) * .01, a = Math.sqrt(.0729 - n * n);
                    i = e1.bezier(n, a, .25, 1);
                }
                return this._prevEase = {
                    start: e1.exported.now(),
                    duration: t1,
                    easing: i
                }, i;
            }
            blur() {
                this.reset();
            }
            reset() {
                this._active = !1;
            }
            _addScrollZoomBlocker() {
                this._map && !this._alertContainer && (this._alertContainer = n("div", "mapboxgl-scroll-zoom-blocker", this._map._container), this._alertContainer.textContent = /(Mac|iPad)/i.test(e1.window.navigator.userAgent) ? this._map._getUIString("ScrollZoomBlocker.CmdMessage") : this._map._getUIString("ScrollZoomBlocker.CtrlMessage"), this._alertContainer.style.fontSize = `${Math.max(10, Math.min(24, Math.floor(.05 * this._el.clientWidth)))}px`);
            }
            _showBlockerAlert() {
                this._alertContainer.style.visibility = "visible", this._alertContainer.classList.add("mapboxgl-scroll-zoom-blocker-show"), this._alertContainer.setAttribute("role", "alert"), clearTimeout(this._alertTimer), this._alertTimer = setTimeout(()=>{
                    this._alertContainer.classList.remove("mapboxgl-scroll-zoom-blocker-show"), this._alertContainer.setAttribute("role", "null");
                }, 200);
            }
        }
        class Fr {
            constructor(e1, t1){
                this._clickZoom = e1, this._tapZoom = t1;
            }
            enable() {
                this._clickZoom.enable(), this._tapZoom.enable();
            }
            disable() {
                this._clickZoom.disable(), this._tapZoom.disable();
            }
            isEnabled() {
                return this._clickZoom.isEnabled() && this._tapZoom.isEnabled();
            }
            isActive() {
                return this._clickZoom.isActive() || this._tapZoom.isActive();
            }
        }
        class Ur {
            constructor(){
                this.reset();
            }
            reset() {
                this._active = !1;
            }
            blur() {
                this.reset();
            }
            dblclick(e1, t1) {
                return e1.preventDefault(), {
                    cameraAnimation: (i)=>{
                        i.easeTo({
                            duration: 300,
                            zoom: i.getZoom() + (e1.shiftKey ? -1 : 1),
                            around: i.unproject(t1)
                        }, {
                            originalEvent: e1
                        });
                    }
                };
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        class Nr {
            constructor(){
                this._tap = new gr({
                    numTouches: 1,
                    numTaps: 1
                }), this.reset();
            }
            reset() {
                this._active = !1, this._swipePoint = void 0, this._swipeTouch = 0, this._tapTime = 0, this._tap.reset();
            }
            touchstart(e1, t1, i) {
                this._swipePoint || (this._tapTime && e1.timeStamp - this._tapTime > 500 && this.reset(), this._tapTime ? i.length > 0 && (this._swipePoint = t1[0], this._swipeTouch = i[0].identifier) : this._tap.touchstart(e1, t1, i));
            }
            touchmove(e1, t1, i) {
                if (this._tapTime) {
                    if (this._swipePoint) {
                        if (i[0].identifier !== this._swipeTouch) return;
                        const o = t1[0], r = o.y - this._swipePoint.y;
                        return this._swipePoint = o, e1.preventDefault(), this._active = !0, {
                            zoomDelta: r / 128
                        };
                    }
                } else this._tap.touchmove(e1, t1, i);
            }
            touchend(e1, t1, i) {
                this._tapTime ? this._swipePoint && 0 === i.length && this.reset() : this._tap.touchend(e1, t1, i) && (this._tapTime = e1.timeStamp);
            }
            touchcancel() {
                this.reset();
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        class Gr {
            constructor(e1, t1, i){
                this._el = e1, this._mousePan = t1, this._touchPan = i;
            }
            enable(e1) {
                this._inertiaOptions = e1 || {}, this._mousePan.enable(), this._touchPan.enable(), this._el.classList.add("mapboxgl-touch-drag-pan");
            }
            disable() {
                this._mousePan.disable(), this._touchPan.disable(), this._el.classList.remove("mapboxgl-touch-drag-pan");
            }
            isEnabled() {
                return this._mousePan.isEnabled() && this._touchPan.isEnabled();
            }
            isActive() {
                return this._mousePan.isActive() || this._touchPan.isActive();
            }
        }
        class jr {
            constructor(e1, t1, i){
                this._pitchWithRotate = e1.pitchWithRotate, this._mouseRotate = t1, this._mousePitch = i;
            }
            enable() {
                this._mouseRotate.enable(), this._pitchWithRotate && this._mousePitch.enable();
            }
            disable() {
                this._mouseRotate.disable(), this._mousePitch.disable();
            }
            isEnabled() {
                return this._mouseRotate.isEnabled() && (!this._pitchWithRotate || this._mousePitch.isEnabled());
            }
            isActive() {
                return this._mouseRotate.isActive() || this._mousePitch.isActive();
            }
        }
        class Zr {
            constructor(e1, t1, i, o){
                this._el = e1, this._touchZoom = t1, this._touchRotate = i, this._tapDragZoom = o, this._rotationDisabled = !1, this._enabled = !0;
            }
            enable(e1) {
                this._touchZoom.enable(e1), this._rotationDisabled || this._touchRotate.enable(e1), this._tapDragZoom.enable(), this._el.classList.add("mapboxgl-touch-zoom-rotate");
            }
            disable() {
                this._touchZoom.disable(), this._touchRotate.disable(), this._tapDragZoom.disable(), this._el.classList.remove("mapboxgl-touch-zoom-rotate");
            }
            isEnabled() {
                return this._touchZoom.isEnabled() && (this._rotationDisabled || this._touchRotate.isEnabled()) && this._tapDragZoom.isEnabled();
            }
            isActive() {
                return this._touchZoom.isActive() || this._touchRotate.isActive() || this._tapDragZoom.isActive();
            }
            disableRotation() {
                this._rotationDisabled = !0, this._touchRotate.disable();
            }
            enableRotation() {
                this._rotationDisabled = !1, this._touchZoom.isEnabled() && this._touchRotate.enable();
            }
        }
        const Vr = (e1)=>e1.zoom || e1.drag || e1.pitch || e1.rotate;
        class Wr extends e1.Event {
        }
        class Xr {
            constructor(){
                this.constants = [
                    1,
                    1,
                    .01
                ], this.radius = 0;
            }
            setup(t1, i) {
                const o = e1.sub([], i, t1);
                this.radius = e1.length(o[2] < 0 ? e1.div([], o, this.constants) : [
                    o[0],
                    o[1],
                    0
                ]);
            }
            projectRay(t1) {
                e1.div(t1, t1, this.constants), e1.normalize(t1, t1), e1.mul$1(t1, t1, this.constants);
                const i = e1.scale$2([], t1, this.radius);
                if (i[2] > 0) {
                    const t2 = e1.scale$2([], [
                        0,
                        0,
                        1
                    ], e1.dot(i, [
                        0,
                        0,
                        1
                    ])), o = e1.scale$2([], e1.normalize([], [
                        i[0],
                        i[1],
                        0
                    ]), this.radius), r = e1.add([], i, e1.scale$2([], e1.sub([], e1.add([], o, t2), i), 2));
                    i[0] = r[0], i[1] = r[1];
                }
                return i;
            }
        }
        function qr(e1) {
            return e1.panDelta && e1.panDelta.mag() || e1.zoomDelta || e1.bearingDelta || e1.pitchDelta;
        }
        class $r {
            constructor(t1, i){
                this._map = t1, this._el = this._map.getCanvasContainer(), this._handlers = [], this._handlersById = {}, this._changes = [], this._inertia = new ar(t1), this._bearingSnap = i.bearingSnap, this._previousActiveHandlers = {}, this._trackingEllipsoid = new Xr, this._dragOrigin = null, this._eventsInProgress = {}, this._addDefaultHandlers(i), e1.bindAll([
                    "handleEvent",
                    "handleWindowEvent"
                ], this);
                const o = this._el;
                this._listeners = [
                    [
                        o,
                        "touchstart",
                        {
                            passive: !0
                        }
                    ],
                    [
                        o,
                        "touchmove",
                        {
                            passive: !1
                        }
                    ],
                    [
                        o,
                        "touchend",
                        void 0
                    ],
                    [
                        o,
                        "touchcancel",
                        void 0
                    ],
                    [
                        o,
                        "mousedown",
                        void 0
                    ],
                    [
                        o,
                        "mousemove",
                        void 0
                    ],
                    [
                        o,
                        "mouseup",
                        void 0
                    ],
                    [
                        e1.window.document,
                        "mousemove",
                        {
                            capture: !0
                        }
                    ],
                    [
                        e1.window.document,
                        "mouseup",
                        void 0
                    ],
                    [
                        o,
                        "mouseover",
                        void 0
                    ],
                    [
                        o,
                        "mouseout",
                        void 0
                    ],
                    [
                        o,
                        "dblclick",
                        void 0
                    ],
                    [
                        o,
                        "click",
                        void 0
                    ],
                    [
                        o,
                        "keydown",
                        {
                            capture: !1
                        }
                    ],
                    [
                        o,
                        "keyup",
                        void 0
                    ],
                    [
                        o,
                        "wheel",
                        {
                            passive: !1
                        }
                    ],
                    [
                        o,
                        "contextmenu",
                        void 0
                    ],
                    [
                        e1.window,
                        "blur",
                        void 0
                    ]
                ];
                for (const [t2, i1, o1] of this._listeners)t2.addEventListener(i1, t2 === e1.window.document ? this.handleWindowEvent : this.handleEvent, o1);
            }
            destroy() {
                for (const [t1, i, o] of this._listeners)t1.removeEventListener(i, t1 === e1.window.document ? this.handleWindowEvent : this.handleEvent, o);
            }
            _addDefaultHandlers(e1) {
                const t1 = this._map, i = t1.getCanvasContainer();
                this._add("mapEvent", new ur(t1, e1));
                const o = t1.boxZoom = new pr(t1, e1);
                this._add("boxZoom", o);
                const r = new vr, n = new Ur;
                t1.doubleClickZoom = new Fr(n, r), this._add("tapZoom", r), this._add("clickZoom", n);
                const a = new Nr;
                this._add("tapDragZoom", a);
                const s = t1.touchPitch = new Pr(t1);
                this._add("touchPitch", s);
                const l = new wr(e1), c = new Tr(e1);
                t1.dragRotate = new jr(e1, l, c), this._add("mouseRotate", l, [
                    "mousePitch"
                ]), this._add("mousePitch", c, [
                    "mouseRotate"
                ]);
                const h = new br(e1), _ = new Er(t1, e1);
                t1.dragPan = new Gr(i, h, _), this._add("mousePan", h), this._add("touchPan", _, [
                    "touchZoom",
                    "touchRotate"
                ]);
                const u = new Dr, d = new Sr;
                t1.touchZoomRotate = new Zr(i, d, u, a), this._add("touchRotate", u, [
                    "touchPan",
                    "touchZoom"
                ]), this._add("touchZoom", d, [
                    "touchPan",
                    "touchRotate"
                ]), this._add("blockableMapEvent", new dr(t1));
                const p = t1.scrollZoom = new kr(t1, this);
                this._add("scrollZoom", p, [
                    "mousePan"
                ]);
                const m = t1.keyboard = new Rr;
                this._add("keyboard", m);
                for (const i1 of [
                    "boxZoom",
                    "doubleClickZoom",
                    "tapDragZoom",
                    "touchPitch",
                    "dragRotate",
                    "dragPan",
                    "touchZoomRotate",
                    "scrollZoom",
                    "keyboard"
                ])e1.interactive && e1[i1] && t1[i1].enable(e1[i1]);
            }
            _add(e1, t1, i) {
                this._handlers.push({
                    handlerName: e1,
                    handler: t1,
                    allowed: i
                }), this._handlersById[e1] = t1;
            }
            stop(e1) {
                if (!this._updatingCamera) {
                    for (const { handler: e2  } of this._handlers)e2.reset();
                    this._inertia.clear(), this._fireEvents({}, {}, e1), this._changes = [];
                }
            }
            isActive() {
                for (const { handler: e1  } of this._handlers)if (e1.isActive()) return !0;
                return !1;
            }
            isZooming() {
                return !!this._eventsInProgress.zoom || this._map.scrollZoom.isZooming();
            }
            isRotating() {
                return !!this._eventsInProgress.rotate;
            }
            isMoving() {
                return !!Vr(this._eventsInProgress) || this.isZooming();
            }
            _blockedByActive(e1, t1, i) {
                for(const o in e1)if (o !== i && (!t1 || t1.indexOf(o) < 0)) return !0;
                return !1;
            }
            handleWindowEvent(e1) {
                this.handleEvent(e1, `${e1.type}Window`);
            }
            _getMapTouches(e1) {
                const t1 = [];
                for (const i of e1)this._el.contains(i.target) && t1.push(i);
                return t1;
            }
            handleEvent(e1, t1) {
                this._updatingCamera = !0;
                const i = "renderFrame" === e1.type, o = i ? void 0 : e1, r = {
                    needsRenderFrame: !1
                }, n = {}, a = {}, s = e1.touches ? this._getMapTouches(e1.touches) : void 0, l = s ? m(this._el, s) : i ? void 0 : p(this._el, e1);
                for (const { handlerName: i1 , handler: c , allowed: h  } of this._handlers){
                    if (!c.isEnabled()) continue;
                    let _;
                    this._blockedByActive(a, h, i1) ? c.reset() : c[t1 || e1.type] && (_ = c[t1 || e1.type](e1, l, s), this.mergeHandlerResult(r, n, _, i1, o), _ && _.needsRenderFrame && this._triggerRenderFrame()), (_ || c.isActive()) && (a[i1] = c);
                }
                const c1 = {};
                for(const e2 in this._previousActiveHandlers)a[e2] || (c1[e2] = o);
                this._previousActiveHandlers = a, (Object.keys(c1).length || qr(r)) && (this._changes.push([
                    r,
                    n,
                    c1
                ]), this._triggerRenderFrame()), (Object.keys(a).length || qr(r)) && this._map._stop(!0), this._updatingCamera = !1;
                const { cameraAnimation: h1  } = r;
                h1 && (this._inertia.clear(), this._fireEvents({}, {}, !0), this._changes = [], h1(this._map));
            }
            mergeHandlerResult(t1, i, o, r, n) {
                if (!o) return;
                e1.extend(t1, o);
                const a = {
                    handlerName: r,
                    originalEvent: o.originalEvent || n
                };
                void 0 !== o.zoomDelta && (i.zoom = a), void 0 !== o.panDelta && (i.drag = a), void 0 !== o.pitchDelta && (i.pitch = a), void 0 !== o.bearingDelta && (i.rotate = a);
            }
            _applyChanges() {
                const t1 = {}, i = {}, o = {};
                for (const [r, n, a] of this._changes)r.panDelta && (t1.panDelta = (t1.panDelta || new e1.pointGeometry(0, 0))._add(r.panDelta)), r.zoomDelta && (t1.zoomDelta = (t1.zoomDelta || 0) + r.zoomDelta), r.bearingDelta && (t1.bearingDelta = (t1.bearingDelta || 0) + r.bearingDelta), r.pitchDelta && (t1.pitchDelta = (t1.pitchDelta || 0) + r.pitchDelta), void 0 !== r.around && (t1.around = r.around), void 0 !== r.aroundCoord && (t1.aroundCoord = r.aroundCoord), void 0 !== r.pinchAround && (t1.pinchAround = r.pinchAround), r.noInertia && (t1.noInertia = r.noInertia), e1.extend(i, n), e1.extend(o, a);
                this._updateMapTransform(t1, i, o), this._changes = [];
            }
            _updateMapTransform(t1, i, o) {
                const r = this._map, n = r.transform, a = (e1)=>[
                        e1.x,
                        e1.y,
                        e1.z
                    ];
                if (((e1)=>{
                    const t1 = this._eventsInProgress.drag;
                    return t1 && !this._handlersById[t1.handlerName].isActive();
                })() && !qr(t1)) {
                    const e2 = n.zoom;
                    n.cameraElevationReference = "sea", n.recenterOnTerrain(), n.cameraElevationReference = "ground", e2 !== n.zoom && this._map._update(!0);
                }
                if (!qr(t1)) return void this._fireEvents(i, o, !0);
                let { panDelta: s , zoomDelta: l , bearingDelta: c , pitchDelta: h , around: _ , aroundCoord: u , pinchAround: d  } = t1;
                void 0 !== d && (_ = d), ((e1)=>i.drag && !this._eventsInProgress.drag)() && _ && (this._dragOrigin = a(n.pointCoordinate3D(_)), this._trackingEllipsoid.setup(n._camera.position, this._dragOrigin)), n.cameraElevationReference = "sea", r._stop(!0), _ = _ || r.transform.centerPoint, c && (n.bearing += c), h && (n.pitch += h), n._updateCameraState();
                const p = [
                    0,
                    0,
                    0
                ];
                if (s) {
                    if ("mercator" === n.projection.name) {
                        const e3 = this._trackingEllipsoid.projectRay(n.screenPointToMercatorRay(_).dir), t2 = this._trackingEllipsoid.projectRay(n.screenPointToMercatorRay(_.sub(s)).dir);
                        p[0] = t2[0] - e3[0], p[1] = t2[1] - e3[1];
                    } else {
                        const t3 = n.pointCoordinate(_);
                        if ("globe" === n.projection.name) {
                            s = s.rotate(-n.angle);
                            const i1 = n._pixelsPerMercatorPixel / n.worldSize;
                            p[0] = -s.x * e1.mercatorScale(e1.latFromMercatorY(t3.y)) * i1, p[1] = -s.y * e1.mercatorScale(n.center.lat) * i1;
                        } else {
                            const e4 = n.pointCoordinate(_.sub(s));
                            t3 && e4 && (p[0] = e4.x - t3.x, p[1] = e4.y - t3.y);
                        }
                    }
                }
                const m = n.zoom, f = [
                    0,
                    0,
                    0
                ];
                if (l) {
                    const t4 = a(u || n.pointCoordinate3D(_)), i2 = {
                        dir: e1.normalize([], e1.sub([], t4, n._camera.position))
                    };
                    if (i2.dir[2] < 0) {
                        const o1 = n.zoomDeltaToMovement(t4, l);
                        e1.scale$2(f, i2.dir, o1);
                    }
                }
                const g = e1.add(p, p, f);
                n._translateCameraConstrained(g), l && Math.abs(n.zoom - m) > 1e-4 && n.recenterOnTerrain(), n.cameraElevationReference = "ground", this._map._update(), t1.noInertia || this._inertia.record(t1), this._fireEvents(i, o, !0);
            }
            _fireEvents(t1, i, o) {
                const r = Vr(this._eventsInProgress), n = Vr(t1), a = {};
                for(const e2 in t1){
                    const { originalEvent: i1  } = t1[e2];
                    this._eventsInProgress[e2] || (a[`${e2}start`] = i1), this._eventsInProgress[e2] = t1[e2];
                }
                !r && n && this._fireEvent("movestart", n.originalEvent);
                for(const e3 in a)this._fireEvent(e3, a[e3]);
                n && this._fireEvent("move", n.originalEvent);
                for(const e4 in t1){
                    const { originalEvent: i2  } = t1[e4];
                    this._fireEvent(e4, i2);
                }
                const s = {};
                let l;
                for(const e5 in this._eventsInProgress){
                    const { handlerName: t2 , originalEvent: o1  } = this._eventsInProgress[e5];
                    this._handlersById[t2].isActive() || (delete this._eventsInProgress[e5], l = i[t2] || o1, s[`${e5}end`] = l);
                }
                for(const e6 in s)this._fireEvent(e6, s[e6]);
                const c = Vr(this._eventsInProgress);
                if (o && (r || n) && !c) {
                    this._updatingCamera = !0;
                    const t3 = this._inertia._onMoveEnd(this._map.dragPan._inertiaOptions), i3 = (e1)=>0 !== e1 && -this._bearingSnap < e1 && e1 < this._bearingSnap;
                    t3 ? (i3(t3.bearing || this._map.getBearing()) && (t3.bearing = 0), this._map.easeTo(t3, {
                        originalEvent: l
                    })) : (this._map.fire(new e1.Event("moveend", {
                        originalEvent: l
                    })), i3(this._map.getBearing()) && this._map.resetNorth()), this._updatingCamera = !1;
                }
            }
            _fireEvent(t1, i) {
                this._map.fire(new e1.Event(t1, i ? {
                    originalEvent: i
                } : {}));
            }
            _requestFrame() {
                return this._map.triggerRepaint(), this._map._renderTaskQueue.add((e1)=>{
                    this._frameId = void 0, this.handleEvent(new Wr("renderFrame", {
                        timeStamp: e1
                    })), this._applyChanges();
                });
            }
            _triggerRenderFrame() {
                void 0 === this._frameId && (this._frameId = this._requestFrame());
            }
        }
        const Hr = "map.setFreeCameraOptions(...) and map.getFreeCameraOptions() are not yet supported for non-mercator projections.";
        class Yr extends e1.Evented {
            constructor(t1, i){
                super(), this._moving = !1, this._zooming = !1, this.transform = t1, this._bearingSnap = i.bearingSnap, e1.bindAll([
                    "_renderFrameCallback"
                ], this);
            }
            getCenter() {
                return new e1.LngLat(this.transform.center.lng, this.transform.center.lat);
            }
            setCenter(e1, t1) {
                return this.jumpTo({
                    center: e1
                }, t1);
            }
            panBy(t1, i, o) {
                return t1 = e1.pointGeometry.convert(t1).mult(-1), this.panTo(this.transform.center, e1.extend({
                    offset: t1
                }, i), o);
            }
            panTo(t1, i, o) {
                return this.easeTo(e1.extend({
                    center: t1
                }, i), o);
            }
            getZoom() {
                return this.transform.zoom;
            }
            setZoom(e1, t1) {
                return this.jumpTo({
                    zoom: e1
                }, t1), this;
            }
            zoomTo(t1, i, o) {
                return this.easeTo(e1.extend({
                    zoom: t1
                }, i), o);
            }
            zoomIn(e1, t1) {
                return this.zoomTo(this.getZoom() + 1, e1, t1), this;
            }
            zoomOut(e1, t1) {
                return this.zoomTo(this.getZoom() - 1, e1, t1), this;
            }
            getBearing() {
                return this.transform.bearing;
            }
            setBearing(e1, t1) {
                return this.jumpTo({
                    bearing: e1
                }, t1), this;
            }
            getPadding() {
                return this.transform.padding;
            }
            setPadding(e1, t1) {
                return this.jumpTo({
                    padding: e1
                }, t1), this;
            }
            rotateTo(t1, i, o) {
                return this.easeTo(e1.extend({
                    bearing: t1
                }, i), o);
            }
            resetNorth(t1, i) {
                return this.rotateTo(0, e1.extend({
                    duration: 1e3
                }, t1), i), this;
            }
            resetNorthPitch(t1, i) {
                return this.easeTo(e1.extend({
                    bearing: 0,
                    pitch: 0,
                    duration: 1e3
                }, t1), i), this;
            }
            snapToNorth(e1, t1) {
                return Math.abs(this.getBearing()) < this._bearingSnap ? this.resetNorth(e1, t1) : this;
            }
            getPitch() {
                return this.transform.pitch;
            }
            setPitch(e1, t1) {
                return this.jumpTo({
                    pitch: e1
                }, t1), this;
            }
            cameraForBounds(t1, i) {
                t1 = e1.LngLatBounds.convert(t1);
                const o = i && i.bearing || 0, r = t1.getNorthWest(), n = t1.getSouthEast();
                return this._cameraForBounds(this.transform, r, n, o, i);
            }
            _extendCameraOptions(t1) {
                const i = {
                    top: 0,
                    bottom: 0,
                    right: 0,
                    left: 0
                };
                if ("number" == typeof (t1 = e1.extend({
                    padding: i,
                    offset: [
                        0,
                        0
                    ],
                    maxZoom: this.transform.maxZoom
                }, t1)).padding) {
                    const e2 = t1.padding;
                    t1.padding = {
                        top: e2,
                        bottom: e2,
                        right: e2,
                        left: e2
                    };
                }
                return t1.padding = e1.extend(i, t1.padding), t1;
            }
            _minimumAABBFrustumDistance(e1, t1) {
                const i = t1.max[0] - t1.min[0], o = t1.max[1] - t1.min[1];
                return i / o > e1.aspect ? i / (2 * Math.tan(.5 * e1.fovX) * e1.aspect) : o / (2 * Math.tan(.5 * e1.fovY) * e1.aspect);
            }
            _cameraForBoundsOnGlobe(t1, i, o, r, n) {
                const a = t1.clone(), s = this._extendCameraOptions(n);
                a.bearing = r;
                const l = e1.LngLat.convert(i), c = e1.LngLat.convert(o), h = .5 * (l.lat + c.lat), _ = .5 * (l.lng + c.lng), u = e1.latLngToECEF(h, _), d = e1.normalize([], u), p = e1.normalize([], e1.cross([], d, [
                    0,
                    1,
                    0
                ])), m = e1.cross([], p, d), f = [
                    p[0],
                    p[1],
                    p[2],
                    0,
                    m[0],
                    m[1],
                    m[2],
                    0,
                    d[0],
                    d[1],
                    d[2],
                    0,
                    0,
                    0,
                    0,
                    1
                ], g = [
                    u,
                    e1.latLngToECEF(l.lat, l.lng),
                    e1.latLngToECEF(c.lat, l.lng),
                    e1.latLngToECEF(c.lat, c.lng),
                    e1.latLngToECEF(l.lat, c.lng),
                    e1.latLngToECEF(h, l.lng),
                    e1.latLngToECEF(h, c.lng),
                    e1.latLngToECEF(l.lat, _),
                    e1.latLngToECEF(c.lat, _)
                ];
                let v = e1.Aabb.fromPoints(g.map((t1)=>[
                        e1.dot(p, t1),
                        e1.dot(m, t1),
                        e1.dot(d, t1)
                    ]));
                const x = e1.transformMat4([], v.center, f);
                0 === e1.squaredLength(x) && e1.set(x, 0, 0, 1), e1.normalize(x, x), e1.scale$2(x, x, e1.GLOBE_RADIUS), a.center = e1.ecefToLatLng(x);
                const y = a.getWorldToCameraMatrix(), b = e1.invert(new Float64Array(16), y);
                v = e1.Aabb.applyTransform(v, e1.multiply([], y, f)), e1.transformMat4(x, x, y);
                const w = .5 * (v.max[2] - v.min[2]), T = this._minimumAABBFrustumDistance(a, v), E = e1.scale$2([], [
                    0,
                    0,
                    1
                ], w), C = e1.add(E, x, E), I = T + (0 === a.pitch ? 0 : e1.distance(x, C)), M = a.globeCenterInViewSpace, S = e1.sub([], x, [
                    M[0],
                    M[1],
                    M[2]
                ]);
                e1.normalize(S, S), e1.scale$2(S, S, I);
                const z = e1.add([], x, S);
                e1.transformMat4(z, z, b);
                const D = e1.earthRadius / e1.GLOBE_RADIUS, A = e1.length(z), P = e1.mercatorZfromAltitude(A * D - e1.earthRadius, 0), L = Math.min(a.zoomFromMercatorZAdjusted(P), s.maxZoom);
                return L > .5 * (e1.GLOBE_ZOOM_THRESHOLD_MIN + e1.GLOBE_ZOOM_THRESHOLD_MAX) ? (a.setProjection({
                    name: "mercator"
                }), a.zoom = L, this._cameraForBounds(a, i, o, r, n)) : {
                    center: a.center,
                    zoom: L,
                    bearing: r
                };
            }
            queryTerrainElevation(t1, i) {
                const o = this.transform.elevation;
                return o ? (i = e1.extend({}, {
                    exaggerated: !0
                }, i), o.getAtPoint(e1.MercatorCoordinate.fromLngLat(t1), null, i.exaggerated)) : null;
            }
            _cameraForBounds(t1, i, o, r, n) {
                if ("globe" === t1.projection.name) return this._cameraForBoundsOnGlobe(t1, i, o, r, n);
                const a = t1.clone(), s = this._extendCameraOptions(n), l = a.padding;
                a.bearing = r;
                const c = e1.LngLat.convert(i), h = e1.LngLat.convert(o), _ = new e1.LngLat(c.lng, h.lat), u = new e1.LngLat(h.lng, c.lat), d = a.project(c), p = a.project(h), m = this.queryTerrainElevation(c), f = this.queryTerrainElevation(h), g = this.queryTerrainElevation(_), v = this.queryTerrainElevation(u), x = [
                    [
                        d.x,
                        d.y,
                        Math.min(m || 0, f || 0, g || 0, v || 0)
                    ],
                    [
                        p.x,
                        p.y,
                        Math.max(m || 0, f || 0, g || 0, v || 0)
                    ]
                ];
                let y = e1.Aabb.fromPoints(x);
                const b = a.getWorldToCameraMatrix(), w = e1.invert(new Float64Array(16), b);
                y = e1.Aabb.applyTransform(y, b);
                const T = e1.sub([], y.max, y.min), E = l.left || 0, C = l.right || 0, I = l.bottom || 0, M = l.top || 0, { left: S , right: z , top: D , bottom: A  } = s.padding, P = .5 * (E + C), L = .5 * (M + I), R = Math.min(a.scaleZoom(a.scale * Math.min((a.width - (E + C + S + z)) / T[0], (a.height - (I + M + A + D)) / T[1])), s.maxZoom), O = a.scale / a.zoomScale(R);
                y = new e1.Aabb([
                    y.min[0] - (S + P) * O,
                    y.min[1] - (A + L) * O,
                    y.min[2]
                ], [
                    y.max[0] + (z + P) * O,
                    y.max[1] + (D + L) * O,
                    y.max[2]
                ]);
                const B = .5 * T[2], k = this._minimumAABBFrustumDistance(a, y), F = [
                    0,
                    0,
                    1,
                    0
                ];
                e1.transformMat4$1(F, F, b), e1.normalize$2(F, F);
                const U = e1.scale$2([], F, k + B), N = e1.add([], y.center, U), G = ("number" == typeof s.offset.x && "number" == typeof s.offset.y ? new e1.pointGeometry(s.offset.x, s.offset.y) : e1.pointGeometry.convert(s.offset)).rotate(-e1.degToRad(r));
                y.center[0] -= G.x * O, y.center[1] += G.y * O, e1.transformMat4(y.center, y.center, w), e1.transformMat4(N, N, w);
                const j = [
                    y.center[0],
                    y.center[1],
                    N[2] * a.pixelsPerMeter
                ];
                e1.scale$2(j, j, 1 / a.worldSize);
                const Z = e1.lngFromMercatorX(j[0]), V = e1.latFromMercatorY(j[1]), W = Math.min(a._zoomFromMercatorZ(j[2]), s.maxZoom), X = new e1.LngLat(Z, V);
                return a.mercatorFromTransition && W < .5 * (e1.GLOBE_ZOOM_THRESHOLD_MIN + e1.GLOBE_ZOOM_THRESHOLD_MAX) ? (a.setProjection({
                    name: "globe"
                }), a.zoom = W, this._cameraForBounds(a, i, o, r, n)) : {
                    center: X,
                    zoom: W,
                    bearing: r
                };
            }
            fitBounds(e1, t1, i) {
                const o = this.cameraForBounds(e1, t1);
                return this._fitInternal(o, t1, i);
            }
            fitScreenCoordinates(t1, i, o, r, n) {
                const a = e1.pointGeometry.convert(t1), s = e1.pointGeometry.convert(i), l = new e1.pointGeometry(Math.min(a.x, s.x), Math.min(a.y, s.y)), c = new e1.pointGeometry(Math.max(a.x, s.x), Math.max(a.y, s.y));
                if ("mercator" === this.transform.projection.name && this.transform.anyCornerOffEdge(a, s)) return this;
                const h = this.transform.pointLocation3D(l), _ = this.transform.pointLocation3D(c), u = this.transform.pointLocation3D(new e1.pointGeometry(l.x, c.y)), d = this.transform.pointLocation3D(new e1.pointGeometry(c.x, l.y)), p = [
                    Math.min(h.lng, _.lng, u.lng, d.lng),
                    Math.min(h.lat, _.lat, u.lat, d.lat)
                ], m = [
                    Math.max(h.lng, _.lng, u.lng, d.lng),
                    Math.max(h.lat, _.lat, u.lat, d.lat)
                ], f = this._cameraForBounds(this.transform, p, m, o, r);
                return this._fitInternal(f, r, n);
            }
            _fitInternal(t1, i, o) {
                return t1 ? (delete (i = e1.extend(t1, i)).padding, i.linear ? this.easeTo(i, o) : this.flyTo(i, o)) : this;
            }
            jumpTo(t1, i) {
                this.stop();
                const o = t1.preloadOnly ? this.transform.clone() : this.transform;
                let r = !1, n = !1, a = !1;
                return "zoom" in t1 && o.zoom !== +t1.zoom && (r = !0, o.zoom = +t1.zoom), void 0 !== t1.center && (o.center = e1.LngLat.convert(t1.center)), "bearing" in t1 && o.bearing !== +t1.bearing && (n = !0, o.bearing = +t1.bearing), "pitch" in t1 && o.pitch !== +t1.pitch && (a = !0, o.pitch = +t1.pitch), null == t1.padding || o.isPaddingEqual(t1.padding) || (o.padding = t1.padding), t1.preloadOnly ? (this._preloadTiles(o), this) : (this.fire(new e1.Event("movestart", i)).fire(new e1.Event("move", i)), r && this.fire(new e1.Event("zoomstart", i)).fire(new e1.Event("zoom", i)).fire(new e1.Event("zoomend", i)), n && this.fire(new e1.Event("rotatestart", i)).fire(new e1.Event("rotate", i)).fire(new e1.Event("rotateend", i)), a && this.fire(new e1.Event("pitchstart", i)).fire(new e1.Event("pitch", i)).fire(new e1.Event("pitchend", i)), this.fire(new e1.Event("moveend", i)));
            }
            getFreeCameraOptions() {
                return this.transform.projection.supportsFreeCamera || e1.warnOnce(Hr), this.transform.getFreeCameraOptions();
            }
            setFreeCameraOptions(t1, i) {
                const o = this.transform;
                if (!o.projection.supportsFreeCamera) return e1.warnOnce(Hr), this;
                this.stop();
                const r = o.zoom, n = o.pitch, a = o.bearing;
                o.setFreeCameraOptions(t1);
                const s = r !== o.zoom, l = n !== o.pitch, c = a !== o.bearing;
                return this.fire(new e1.Event("movestart", i)).fire(new e1.Event("move", i)), s && this.fire(new e1.Event("zoomstart", i)).fire(new e1.Event("zoom", i)).fire(new e1.Event("zoomend", i)), c && this.fire(new e1.Event("rotatestart", i)).fire(new e1.Event("rotate", i)).fire(new e1.Event("rotateend", i)), l && this.fire(new e1.Event("pitchstart", i)).fire(new e1.Event("pitch", i)).fire(new e1.Event("pitchend", i)), this.fire(new e1.Event("moveend", i)), this;
            }
            easeTo(t1, i) {
                this._stop(!1, t1.easeId), (!1 === (t1 = e1.extend({
                    offset: [
                        0,
                        0
                    ],
                    duration: 500,
                    easing: e1.ease
                }, t1)).animate || !t1.essential && e1.exported.prefersReducedMotion) && (t1.duration = 0);
                const o = this.transform, r = this.getZoom(), n = this.getBearing(), a = this.getPitch(), s = this.getPadding(), l = "zoom" in t1 ? +t1.zoom : r, c = "bearing" in t1 ? this._normalizeBearing(t1.bearing, n) : n, h = "pitch" in t1 ? +t1.pitch : a, _ = "padding" in t1 ? t1.padding : o.padding, u = e1.pointGeometry.convert(t1.offset);
                let d, p, m;
                if ("globe" === o.projection.name) {
                    const i1 = e1.MercatorCoordinate.fromLngLat(o.center), r1 = u.rotate(-o.angle);
                    i1.x += r1.x / o.worldSize, i1.y += r1.y / o.worldSize;
                    const n1 = i1.toLngLat(), a1 = e1.LngLat.convert(t1.center || n1);
                    this._normalizeCenter(a1), d = o.centerPoint.add(r1), p = new e1.pointGeometry(i1.x, i1.y).mult(o.worldSize), m = new e1.pointGeometry(e1.mercatorXfromLng(a1.lng), e1.mercatorYfromLat(a1.lat)).mult(o.worldSize).sub(p);
                } else {
                    d = o.centerPoint.add(u);
                    const i2 = o.pointLocation(d), r2 = e1.LngLat.convert(t1.center || i2);
                    this._normalizeCenter(r2), p = o.project(i2), m = o.project(r2).sub(p);
                }
                const f = o.zoomScale(l - r);
                let g, v;
                t1.around && (g = e1.LngLat.convert(t1.around), v = o.locationPoint(g));
                const x = this._zooming || l !== r, y = this._rotating || n !== c, b = this._pitching || h !== a, w = !o.isPaddingEqual(_), T = (o)=>(T)=>{
                        if (x && (o.zoom = e1.number(r, l, T)), y && (o.bearing = e1.number(n, c, T)), b && (o.pitch = e1.number(a, h, T)), w && (o.interpolatePadding(s, _, T), d = o.centerPoint.add(u)), g) o.setLocationAtPoint(g, v);
                        else {
                            const e2 = o.zoomScale(o.zoom - r), t2 = l > r ? Math.min(2, f) : Math.max(.5, f), i1 = Math.pow(t2, 1 - T), n1 = o.unproject(p.add(m.mult(T * i1)).mult(e2));
                            o.setLocationAtPoint(o.renderWorldCopies ? n1.wrap() : n1, d);
                        }
                        return t1.preloadOnly || this._fireMoveEvents(i), o;
                    };
                if (t1.preloadOnly) {
                    const e2 = this._emulate(T, t1.duration, o);
                    return this._preloadTiles(e2), this;
                }
                const E = {
                    moving: this._moving,
                    zooming: this._zooming,
                    rotating: this._rotating,
                    pitching: this._pitching
                };
                return this._zooming = x, this._rotating = y, this._pitching = b, this._padding = w, this._easeId = t1.easeId, this._prepareEase(i, t1.noMoveStart, E), this._ease(T(o), (e1)=>{
                    o.recenterOnTerrain(), this._afterEase(i, e1);
                }, t1), this;
            }
            _prepareEase(t1, i, o = {}) {
                this._moving = !0, this.transform.cameraElevationReference = "sea", i || o.moving || this.fire(new e1.Event("movestart", t1)), this._zooming && !o.zooming && this.fire(new e1.Event("zoomstart", t1)), this._rotating && !o.rotating && this.fire(new e1.Event("rotatestart", t1)), this._pitching && !o.pitching && this.fire(new e1.Event("pitchstart", t1));
            }
            _fireMoveEvents(t1) {
                this.fire(new e1.Event("move", t1)), this._zooming && this.fire(new e1.Event("zoom", t1)), this._rotating && this.fire(new e1.Event("rotate", t1)), this._pitching && this.fire(new e1.Event("pitch", t1));
            }
            _afterEase(t1, i) {
                if (this._easeId && i && this._easeId === i) return;
                this._easeId = void 0, this.transform.cameraElevationReference = "ground";
                const o = this._zooming, r = this._rotating, n = this._pitching;
                this._moving = !1, this._zooming = !1, this._rotating = !1, this._pitching = !1, this._padding = !1, o && this.fire(new e1.Event("zoomend", t1)), r && this.fire(new e1.Event("rotateend", t1)), n && this.fire(new e1.Event("pitchend", t1)), this.fire(new e1.Event("moveend", t1));
            }
            flyTo(t1, i) {
                if (!t1.essential && e1.exported.prefersReducedMotion) {
                    const o = e1.pick(t1, [
                        "center",
                        "zoom",
                        "bearing",
                        "pitch",
                        "around"
                    ]);
                    return this.jumpTo(o, i);
                }
                this.stop(), t1 = e1.extend({
                    offset: [
                        0,
                        0
                    ],
                    speed: 1.2,
                    curve: 1.42,
                    easing: e1.ease
                }, t1);
                const o1 = this.transform, r = this.getZoom(), n = this.getBearing(), a = this.getPitch(), s = this.getPadding(), l = "zoom" in t1 ? e1.clamp(+t1.zoom, o1.minZoom, o1.maxZoom) : r, c = "bearing" in t1 ? this._normalizeBearing(t1.bearing, n) : n, h = "pitch" in t1 ? +t1.pitch : a, _ = "padding" in t1 ? t1.padding : o1.padding, u = o1.zoomScale(l - r), d = e1.pointGeometry.convert(t1.offset);
                let p = o1.centerPoint.add(d);
                const m = o1.pointLocation(p), f = e1.LngLat.convert(t1.center || m);
                this._normalizeCenter(f);
                const g = o1.project(m), v = o1.project(f).sub(g);
                let x = t1.curve;
                const y = Math.max(o1.width, o1.height), b = y / u, w = v.mag();
                if ("minZoom" in t1) {
                    const i1 = e1.clamp(Math.min(t1.minZoom, r, l), o1.minZoom, o1.maxZoom), n1 = y / o1.zoomScale(i1 - r);
                    x = Math.sqrt(n1 / w * 2);
                }
                const T = x * x;
                function E(e1) {
                    const t1 = (b * b - y * y + (e1 ? -1 : 1) * T * T * w * w) / (2 * (e1 ? b : y) * T * w);
                    return Math.log(Math.sqrt(t1 * t1 + 1) - t1);
                }
                function C(e1) {
                    return (Math.exp(e1) - Math.exp(-e1)) / 2;
                }
                function I(e1) {
                    return (Math.exp(e1) + Math.exp(-e1)) / 2;
                }
                const M = E(0);
                let S = function(e1) {
                    return I(M) / I(M + x * e1);
                }, z = function(e1) {
                    var t1;
                    return y * ((I(M) * (C(t1 = M + x * e1) / I(t1)) - C(M)) / T) / w;
                }, D = (E(1) - M) / x;
                if (Math.abs(w) < 1e-6 || !isFinite(D)) {
                    if (Math.abs(y - b) < 1e-6) return this.easeTo(t1, i);
                    const e2 = b < y ? -1 : 1;
                    D = Math.abs(Math.log(b / y)) / x, z = function() {
                        return 0;
                    }, S = function(t1) {
                        return Math.exp(e2 * x * t1);
                    };
                }
                t1.duration = "duration" in t1 ? +t1.duration : 1e3 * D / ("screenSpeed" in t1 ? +t1.screenSpeed / x : +t1.speed), t1.maxDuration && t1.duration > t1.maxDuration && (t1.duration = 0);
                const A = n !== c, P = h !== a, L = !o1.isPaddingEqual(_), R = (o)=>(u)=>{
                        const m = u * D, x = 1 / S(m);
                        o.zoom = 1 === u ? l : r + o.scaleZoom(x), A && (o.bearing = e1.number(n, c, u)), P && (o.pitch = e1.number(a, h, u)), L && (o.interpolatePadding(s, _, u), p = o.centerPoint.add(d));
                        const y = 1 === u ? f : o.unproject(g.add(v.mult(z(m))).mult(x));
                        return o.setLocationAtPoint(o.renderWorldCopies ? y.wrap() : y, p), o._updateCameraOnTerrain(), t1.preloadOnly || this._fireMoveEvents(i), o;
                    };
                if (t1.preloadOnly) {
                    const e3 = this._emulate(R, t1.duration, o1);
                    return this._preloadTiles(e3), this;
                }
                return this._zooming = !0, this._rotating = A, this._pitching = P, this._padding = L, this._prepareEase(i, !1), this._ease(R(o1), ()=>this._afterEase(i), t1), this;
            }
            isEasing() {
                return !!this._easeFrameId;
            }
            stop() {
                return this._stop();
            }
            _stop(e1, t1) {
                if (this._easeFrameId && (this._cancelRenderFrame(this._easeFrameId), this._easeFrameId = void 0, this._onEaseFrame = void 0), this._onEaseEnd) {
                    const e2 = this._onEaseEnd;
                    this._onEaseEnd = void 0, e2.call(this, t1);
                }
                if (!e1) {
                    const e3 = this.handlers;
                    e3 && e3.stop(!1);
                }
                return this;
            }
            _ease(t1, i, o) {
                !1 === o.animate || 0 === o.duration ? (t1(1), i()) : (this._easeStart = e1.exported.now(), this._easeOptions = o, this._onEaseFrame = t1, this._onEaseEnd = i, this._easeFrameId = this._requestRenderFrame(this._renderFrameCallback));
            }
            _renderFrameCallback() {
                const t1 = Math.min((e1.exported.now() - this._easeStart) / this._easeOptions.duration, 1), i = this._onEaseFrame;
                i && i(this._easeOptions.easing(t1)), t1 < 1 ? this._easeFrameId = this._requestRenderFrame(this._renderFrameCallback) : this.stop();
            }
            _normalizeBearing(t1, i) {
                t1 = e1.wrap(t1, -180, 180);
                const o = Math.abs(t1 - i);
                return Math.abs(t1 - 360 - i) < o && (t1 -= 360), Math.abs(t1 + 360 - i) < o && (t1 += 360), t1;
            }
            _normalizeCenter(e1) {
                const t1 = this.transform;
                if (!t1.renderWorldCopies || t1.maxBounds) return;
                const i = e1.lng - t1.center.lng;
                e1.lng += i > 180 ? -360 : i < -180 ? 360 : 0;
            }
            _emulate(e1, t1, i) {
                const o = Math.ceil(15 * t1 / 1e3), r = [], n = e1(i.clone());
                for(let e2 = 0; e2 <= o; e2++){
                    const t2 = n(e2 / o);
                    r.push(t2.clone());
                }
                return r;
            }
        }
        class Kr {
            constructor(t1 = {}){
                this.options = t1, e1.bindAll([
                    "_toggleAttribution",
                    "_updateEditLink",
                    "_updateData",
                    "_updateCompact"
                ], this);
            }
            getDefaultPosition() {
                return "bottom-right";
            }
            onAdd(e1) {
                const t1 = this.options && this.options.compact;
                return this._map = e1, this._container = n("div", "mapboxgl-ctrl mapboxgl-ctrl-attrib"), this._compactButton = n("button", "mapboxgl-ctrl-attrib-button", this._container), n("span", "mapboxgl-ctrl-icon", this._compactButton).setAttribute("aria-hidden", "true"), this._compactButton.type = "button", this._compactButton.addEventListener("click", this._toggleAttribution), this._setElementTitle(this._compactButton, "ToggleAttribution"), this._innerContainer = n("div", "mapboxgl-ctrl-attrib-inner", this._container), this._innerContainer.setAttribute("role", "list"), t1 && this._container.classList.add("mapboxgl-compact"), this._updateAttributions(), this._updateEditLink(), this._map.on("styledata", this._updateData), this._map.on("sourcedata", this._updateData), this._map.on("moveend", this._updateEditLink), void 0 === t1 && (this._map.on("resize", this._updateCompact), this._updateCompact()), this._container;
            }
            onRemove() {
                this._container.remove(), this._map.off("styledata", this._updateData), this._map.off("sourcedata", this._updateData), this._map.off("moveend", this._updateEditLink), this._map.off("resize", this._updateCompact), this._map = void 0, this._attribHTML = void 0;
            }
            _setElementTitle(e1, t1) {
                const i = this._map._getUIString(`AttributionControl.${t1}`);
                e1.setAttribute("aria-label", i), e1.removeAttribute("title"), e1.firstElementChild && e1.firstElementChild.setAttribute("title", i);
            }
            _toggleAttribution() {
                this._container.classList.contains("mapboxgl-compact-show") ? (this._container.classList.remove("mapboxgl-compact-show"), this._compactButton.setAttribute("aria-expanded", "false")) : (this._container.classList.add("mapboxgl-compact-show"), this._compactButton.setAttribute("aria-expanded", "true"));
            }
            _updateEditLink() {
                let t1 = this._editLink;
                t1 || (t1 = this._editLink = this._container.querySelector(".mapbox-improve-map"));
                const i = [
                    {
                        key: "owner",
                        value: this.styleOwner
                    },
                    {
                        key: "id",
                        value: this.styleId
                    },
                    {
                        key: "access_token",
                        value: this._map._requestManager._customAccessToken || e1.config.ACCESS_TOKEN
                    }
                ];
                if (t1) {
                    const o = i.reduce((e1, t1, o)=>(t1.value && (e1 += `${t1.key}=${t1.value}${o < i.length - 1 ? "&" : ""}`), e1), "?");
                    t1.href = `${e1.config.FEEDBACK_URL}/${o}#${er(this._map, !0)}`, t1.rel = "noopener nofollow", this._setElementTitle(t1, "MapFeedback");
                }
            }
            _updateData(e1) {
                !e1 || "metadata" !== e1.sourceDataType && "visibility" !== e1.sourceDataType && "style" !== e1.dataType || (this._updateAttributions(), this._updateEditLink());
            }
            _updateAttributions() {
                if (!this._map.style) return;
                let e1 = [];
                if (this._map.style.stylesheet) {
                    const e2 = this._map.style.stylesheet;
                    this.styleOwner = e2.owner, this.styleId = e2.id;
                }
                const t1 = this._map.style._sourceCaches;
                for(const i in t1){
                    const o = t1[i];
                    if (o.used) {
                        const t2 = o.getSource();
                        t2.attribution && e1.indexOf(t2.attribution) < 0 && e1.push(t2.attribution);
                    }
                }
                e1.sort((e1, t1)=>e1.length - t1.length), e1 = e1.filter((t1, i)=>{
                    for(let o = i + 1; o < e1.length; o++)if (e1[o].indexOf(t1) >= 0) return !1;
                    return !0;
                }), this.options.customAttribution && (Array.isArray(this.options.customAttribution) ? e1 = [
                    ...this.options.customAttribution,
                    ...e1
                ] : e1.unshift(this.options.customAttribution));
                const i1 = e1.join(" | ");
                i1 !== this._attribHTML && (this._attribHTML = i1, e1.length ? (this._innerContainer.innerHTML = i1, this._container.classList.remove("mapboxgl-attrib-empty")) : this._container.classList.add("mapboxgl-attrib-empty"), this._editLink = null);
            }
            _updateCompact() {
                this._map.getCanvasContainer().offsetWidth <= 640 ? this._container.classList.add("mapboxgl-compact") : this._container.classList.remove("mapboxgl-compact", "mapboxgl-compact-show");
            }
        }
        class Jr {
            constructor(){
                e1.bindAll([
                    "_updateLogo",
                    "_updateCompact"
                ], this);
            }
            onAdd(e1) {
                this._map = e1, this._container = n("div", "mapboxgl-ctrl");
                const t1 = n("a", "mapboxgl-ctrl-logo");
                return t1.target = "_blank", t1.rel = "noopener nofollow", t1.href = "https://www.mapbox.com/", t1.setAttribute("aria-label", this._map._getUIString("LogoControl.Title")), t1.setAttribute("rel", "noopener nofollow"), this._container.appendChild(t1), this._container.style.display = "none", this._map.on("sourcedata", this._updateLogo), this._updateLogo(), this._map.on("resize", this._updateCompact), this._updateCompact(), this._container;
            }
            onRemove() {
                this._container.remove(), this._map.off("sourcedata", this._updateLogo), this._map.off("resize", this._updateCompact);
            }
            getDefaultPosition() {
                return "bottom-left";
            }
            _updateLogo(e1) {
                e1 && "metadata" !== e1.sourceDataType || (this._container.style.display = this._logoRequired() ? "block" : "none");
            }
            _logoRequired() {
                if (!this._map.style) return !0;
                const e1 = this._map.style._sourceCaches;
                if (0 === Object.entries(e1).length) return !0;
                for(const t1 in e1){
                    const i = e1[t1].getSource();
                    if (i.hasOwnProperty("mapbox_logo") && !i.mapbox_logo) return !1;
                }
                return !0;
            }
            _updateCompact() {
                const e1 = this._container.children;
                if (e1.length) {
                    const t1 = e1[0];
                    this._map.getCanvasContainer().offsetWidth < 250 ? t1.classList.add("mapboxgl-compact") : t1.classList.remove("mapboxgl-compact");
                }
            }
        }
        class Qr {
            constructor(){
                this._queue = [], this._id = 0, this._cleared = !1, this._currentlyRunning = !1;
            }
            add(e1) {
                const t1 = ++this._id;
                return this._queue.push({
                    callback: e1,
                    id: t1,
                    cancelled: !1
                }), t1;
            }
            remove(e1) {
                const t1 = this._currentlyRunning, i = t1 ? this._queue.concat(t1) : this._queue;
                for (const t2 of i)if (t2.id === e1) return void (t2.cancelled = !0);
            }
            run(e1 = 0) {
                const t1 = this._currentlyRunning = this._queue;
                this._queue = [];
                for (const i of t1)if (!i.cancelled && (i.callback(e1), this._cleared)) break;
                this._cleared = !1, this._currentlyRunning = !1;
            }
            clear() {
                this._currentlyRunning && (this._cleared = !0), this._queue = [];
            }
        }
        function en(t1, i, o) {
            if (t1 = new e1.LngLat(t1.lng, t1.lat), i) {
                const r = new e1.LngLat(t1.lng - 360, t1.lat), n = new e1.LngLat(t1.lng + 360, t1.lat), a = 360 * Math.ceil(Math.abs(t1.lng - o.center.lng) / 360), s = o.locationPoint(t1).distSqr(i), l = i.x < 0 || i.y < 0 || i.x > o.width || i.y > o.height;
                o.locationPoint(r).distSqr(i) < s && (l || Math.abs(r.lng - o.center.lng) < a) ? t1 = r : o.locationPoint(n).distSqr(i) < s && (l || Math.abs(n.lng - o.center.lng) < a) && (t1 = n);
            }
            for(; Math.abs(t1.lng - o.center.lng) > 180;){
                const e2 = o.locationPoint(t1);
                if (e2.x >= 0 && e2.y >= 0 && e2.x <= o.width && e2.y <= o.height) break;
                t1.lng > o.center.lng ? t1.lng -= 360 : t1.lng += 360;
            }
            return t1;
        }
        const tn = {
            center: "translate(-50%,-50%)",
            top: "translate(-50%,0)",
            "top-left": "translate(0,0)",
            "top-right": "translate(-100%,0)",
            bottom: "translate(-50%,-100%)",
            "bottom-left": "translate(0,-100%)",
            "bottom-right": "translate(-100%,-100%)",
            left: "translate(0,-50%)",
            right: "translate(-100%,-50%)"
        };
        class on extends e1.Evented {
            constructor(t1, i){
                if (super(), (t1 instanceof e1.window.HTMLElement || i) && (t1 = e1.extend({
                    element: t1
                }, i)), e1.bindAll([
                    "_update",
                    "_onMove",
                    "_onUp",
                    "_addDragHandler",
                    "_onMapClick",
                    "_onKeyPress",
                    "_clearFadeTimer"
                ], this), this._anchor = t1 && t1.anchor || "center", this._color = t1 && t1.color || "#3FB1CE", this._scale = t1 && t1.scale || 1, this._draggable = t1 && t1.draggable || !1, this._clickTolerance = t1 && t1.clickTolerance || 0, this._isDragging = !1, this._state = "inactive", this._rotation = t1 && t1.rotation || 0, this._rotationAlignment = t1 && t1.rotationAlignment || "auto", this._pitchAlignment = t1 && t1.pitchAlignment && t1.pitchAlignment || "auto", this._updateMoving = ()=>this._update(!0), this._occludedOpacity = t1 && t1.occludedOpacity || .2, t1 && t1.element) this._element = t1.element, this._offset = e1.pointGeometry.convert(t1 && t1.offset || [
                    0,
                    0
                ]);
                else {
                    this._defaultMarker = !0, this._element = n("div");
                    const i1 = 41, o = 27, r = a("svg", {
                        display: "block",
                        height: i1 * this._scale + "px",
                        width: o * this._scale + "px",
                        viewBox: `0 0 ${o} ${i1}`
                    }, this._element), s = a("radialGradient", {
                        id: "shadowGradient"
                    }, a("defs", {}, r));
                    a("stop", {
                        offset: "10%",
                        "stop-opacity": .4
                    }, s), a("stop", {
                        offset: "100%",
                        "stop-opacity": .05
                    }, s), a("ellipse", {
                        cx: 13.5,
                        cy: 34.8,
                        rx: 10.5,
                        ry: 5.25,
                        fill: "url(#shadowGradient)"
                    }, r), a("path", {
                        fill: this._color,
                        d: "M27,13.5C27,19.07 20.25,27 14.75,34.5C14.02,35.5 12.98,35.5 12.25,34.5C6.75,27 0,19.22 0,13.5C0,6.04 6.04,0 13.5,0C20.96,0 27,6.04 27,13.5Z"
                    }, r), a("path", {
                        opacity: .25,
                        d: "M13.5,0C6.04,0 0,6.04 0,13.5C0,19.22 6.75,27 12.25,34.5C13,35.52 14.02,35.5 14.75,34.5C20.25,27 27,19.07 27,13.5C27,6.04 20.96,0 13.5,0ZM13.5,1C20.42,1 26,6.58 26,13.5C26,15.9 24.5,19.18 22.22,22.74C19.95,26.3 16.71,30.14 13.94,33.91C13.74,34.18 13.61,34.32 13.5,34.44C13.39,34.32 13.26,34.18 13.06,33.91C10.28,30.13 7.41,26.31 5.02,22.77C2.62,19.23 1,15.95 1,13.5C1,6.58 6.58,1 13.5,1Z"
                    }, r), a("circle", {
                        fill: "white",
                        cx: 13.5,
                        cy: 13.5,
                        r: 5.5
                    }, r), this._offset = e1.pointGeometry.convert(t1 && t1.offset || [
                        0,
                        -14
                    ]);
                }
                this._element.hasAttribute("aria-label") || this._element.setAttribute("aria-label", "Map marker"), this._element.classList.add("mapboxgl-marker"), this._element.addEventListener("dragstart", (e1)=>{
                    e1.preventDefault();
                }), this._element.addEventListener("mousedown", (e1)=>{
                    e1.preventDefault();
                });
                const o1 = this._element.classList;
                for(const e2 in tn)o1.remove(`mapboxgl-marker-anchor-${e2}`);
                o1.add(`mapboxgl-marker-anchor-${this._anchor}`), this._popup = null;
            }
            addTo(e1) {
                return e1 === this._map || (this.remove(), this._map = e1, e1.getCanvasContainer().appendChild(this._element), e1.on("move", this._updateMoving), e1.on("moveend", this._update), e1.on("remove", this._clearFadeTimer), e1._addMarker(this), this.setDraggable(this._draggable), this._update(), e1.on("click", this._onMapClick)), this;
            }
            remove() {
                const e1 = this._map;
                return e1 && (e1.off("click", this._onMapClick), e1.off("move", this._updateMoving), e1.off("moveend", this._update), e1.off("mousedown", this._addDragHandler), e1.off("touchstart", this._addDragHandler), e1.off("mouseup", this._onUp), e1.off("touchend", this._onUp), e1.off("mousemove", this._onMove), e1.off("touchmove", this._onMove), e1.off("remove", this._clearFadeTimer), e1._removeMarker(this), this._map = void 0), this._clearFadeTimer(), this._element.remove(), this._popup && this._popup.remove(), this;
            }
            getLngLat() {
                return this._lngLat;
            }
            setLngLat(t1) {
                return this._lngLat = e1.LngLat.convert(t1), this._pos = null, this._popup && this._popup.setLngLat(this._lngLat), this._update(!0), this;
            }
            getElement() {
                return this._element;
            }
            setPopup(e1) {
                if (this._popup && (this._popup.remove(), this._popup = null, this._element.removeAttribute("role"), this._element.removeEventListener("keypress", this._onKeyPress), this._originalTabIndex || this._element.removeAttribute("tabindex")), e1) {
                    if (!("offset" in e1.options)) {
                        const t1 = 38.1, i = 13.5, o = Math.sqrt(Math.pow(i, 2) / 2);
                        e1.options.offset = this._defaultMarker ? {
                            top: [
                                0,
                                0
                            ],
                            "top-left": [
                                0,
                                0
                            ],
                            "top-right": [
                                0,
                                0
                            ],
                            bottom: [
                                0,
                                -t1
                            ],
                            "bottom-left": [
                                o,
                                -1 * (t1 - i + o)
                            ],
                            "bottom-right": [
                                -o,
                                -1 * (t1 - i + o)
                            ],
                            left: [
                                i,
                                -1 * (t1 - i)
                            ],
                            right: [
                                -i,
                                -1 * (t1 - i)
                            ]
                        } : this._offset;
                    }
                    this._popup = e1, e1._marker = this, this._lngLat && this._popup.setLngLat(this._lngLat), this._element.setAttribute("role", "button"), this._originalTabIndex = this._element.getAttribute("tabindex"), this._originalTabIndex || this._element.setAttribute("tabindex", "0"), this._element.addEventListener("keypress", this._onKeyPress), this._element.setAttribute("aria-expanded", "false");
                }
                return this;
            }
            _onKeyPress(e1) {
                const t1 = e1.code, i = e1.charCode || e1.keyCode;
                "Space" !== t1 && "Enter" !== t1 && 32 !== i && 13 !== i || this.togglePopup();
            }
            _onMapClick(e1) {
                const t1 = e1.originalEvent.target, i = this._element;
                this._popup && (t1 === i || i.contains(t1)) && this.togglePopup();
            }
            getPopup() {
                return this._popup;
            }
            togglePopup() {
                const e1 = this._popup;
                return e1 ? (e1.isOpen() ? (e1.remove(), this._element.setAttribute("aria-expanded", "false")) : this._map && (e1.addTo(this._map), this._element.setAttribute("aria-expanded", "true")), this) : this;
            }
            _behindTerrain() {
                const e1 = this._map, t1 = this._pos;
                if (!e1 || !t1) return !1;
                const i = e1.unproject(t1), o = e1.getFreeCameraOptions();
                if (!o.position) return !1;
                const r = o.position.toLngLat();
                return r.distanceTo(i) < .9 * r.distanceTo(this._lngLat);
            }
            _evaluateOpacity() {
                const t1 = this._map;
                if (!t1) return;
                const i = this._pos;
                if (!i || i.x < 0 || i.x > t1.transform.width || i.y < 0 || i.y > t1.transform.height) return void this._clearFadeTimer();
                const o = t1.unproject(i);
                let r;
                t1._showingGlobe() && e1.isLngLatBehindGlobe(t1.transform, this._lngLat) ? r = 0 : (r = 1 - t1._queryFogOpacity(o), t1.transform._terrainEnabled() && t1.getTerrain() && this._behindTerrain() && (r *= this._occludedOpacity)), this._element.style.opacity = `${r}`, this._element.style.pointerEvents = r > 0 ? "auto" : "none", this._popup && this._popup._setOpacity(r), this._fadeTimer = null;
            }
            _clearFadeTimer() {
                this._fadeTimer && (clearTimeout(this._fadeTimer), this._fadeTimer = null);
            }
            _updateDOM() {
                const e1 = this._pos;
                if (!e1 || !this._map) return;
                const t1 = this._offset.mult(this._scale);
                this._element.style.transform = `\n            translate(${e1.x}px,${e1.y}px)\n            ${tn[this._anchor]}\n            ${this._calculateXYTransform()} ${this._calculateZTransform()}\n            translate(${t1.x}px,${t1.y}px)\n        `;
            }
            _calculateXYTransform() {
                const t1 = this._pos, i = this._map, o = this.getPitchAlignment();
                if (!i || !t1 || "map" !== o) return "";
                if (!i._showingGlobe()) {
                    const e2 = i.getPitch();
                    return e2 ? `rotateX(${e2}deg)` : "";
                }
                const r = e1.radToDeg(e1.globeTiltAtLngLat(i.transform, this._lngLat)), n = t1.sub(e1.globeCenterToScreenPoint(i.transform)), a = Math.abs(n.x) + Math.abs(n.y);
                if (0 === a) return "";
                const s = r / a;
                return `rotateX(${-n.y * s}deg) rotateY(${n.x * s}deg)`;
            }
            _calculateZTransform() {
                const t1 = this._pos, i = this._map;
                if (!i || !t1) return "";
                let o = 0;
                const r = this.getRotationAlignment();
                if ("map" === r) {
                    if (i._showingGlobe()) {
                        const t2 = i.project(new e1.LngLat(this._lngLat.lng, this._lngLat.lat + .001)), r1 = i.project(new e1.LngLat(this._lngLat.lng, this._lngLat.lat - .001)).sub(t2);
                        o = e1.radToDeg(Math.atan2(r1.y, r1.x)) - 90;
                    } else o = -i.getBearing();
                } else if ("horizon" === r) {
                    const r2 = e1.smoothstep(4, 6, i.getZoom()), n = e1.globeCenterToScreenPoint(i.transform);
                    n.y += r2 * i.transform.height;
                    const a = t1.sub(n), s = e1.radToDeg(Math.atan2(a.y, a.x));
                    o = (s > 90 ? s - 270 : s + 90) * (1 - r2);
                }
                return o += this._rotation, o ? `rotateZ(${o}deg)` : "";
            }
            _update(t1) {
                e1.window.cancelAnimationFrame(this._updateFrameId);
                const i = this._map;
                i && (i.transform.renderWorldCopies && (this._lngLat = en(this._lngLat, this._pos, i.transform)), this._pos = i.project(this._lngLat), !0 === t1 ? this._updateFrameId = e1.window.requestAnimationFrame(()=>{
                    this._element && this._pos && this._anchor && (this._pos = this._pos.round(), this._updateDOM());
                }) : this._pos = this._pos.round(), i._requestDomTask(()=>{
                    this._map && (this._element && this._pos && this._anchor && this._updateDOM(), (i._showingGlobe() || i.getTerrain() || i.getFog()) && !this._fadeTimer && (this._fadeTimer = setTimeout(this._evaluateOpacity.bind(this), 60)));
                }));
            }
            getOffset() {
                return this._offset;
            }
            setOffset(t1) {
                return this._offset = e1.pointGeometry.convert(t1), this._update(), this;
            }
            _onMove(t1) {
                const i = this._map;
                if (!i) return;
                const o = this._pointerdownPos, r = this._positionDelta;
                if (o && r) {
                    if (!this._isDragging) {
                        const e2 = this._clickTolerance || i._clickTolerance;
                        if (t1.point.dist(o) < e2) return;
                        this._isDragging = !0;
                    }
                    this._pos = t1.point.sub(r), this._lngLat = i.unproject(this._pos), this.setLngLat(this._lngLat), this._element.style.pointerEvents = "none", "pending" === this._state && (this._state = "active", this.fire(new e1.Event("dragstart"))), this.fire(new e1.Event("drag"));
                }
            }
            _onUp() {
                this._element.style.pointerEvents = "auto", this._positionDelta = null, this._pointerdownPos = null, this._isDragging = !1;
                const t1 = this._map;
                t1 && (t1.off("mousemove", this._onMove), t1.off("touchmove", this._onMove)), "active" === this._state && this.fire(new e1.Event("dragend")), this._state = "inactive";
            }
            _addDragHandler(e1) {
                const t1 = this._map, i = this._pos;
                t1 && i && this._element.contains(e1.originalEvent.target) && (e1.preventDefault(), this._positionDelta = e1.point.sub(i), this._pointerdownPos = e1.point, this._state = "pending", t1.on("mousemove", this._onMove), t1.on("touchmove", this._onMove), t1.once("mouseup", this._onUp), t1.once("touchend", this._onUp));
            }
            setDraggable(e1) {
                this._draggable = !!e1;
                const t1 = this._map;
                return t1 && (e1 ? (t1.on("mousedown", this._addDragHandler), t1.on("touchstart", this._addDragHandler)) : (t1.off("mousedown", this._addDragHandler), t1.off("touchstart", this._addDragHandler))), this;
            }
            isDraggable() {
                return this._draggable;
            }
            setRotation(e1) {
                return this._rotation = e1 || 0, this._update(), this;
            }
            getRotation() {
                return this._rotation;
            }
            setRotationAlignment(e1) {
                return this._rotationAlignment = e1 || "auto", this._update(), this;
            }
            getRotationAlignment() {
                return "auto" === this._rotationAlignment || "horizon" === this._rotationAlignment && this._map && !this._map._showingGlobe() ? "viewport" : this._rotationAlignment;
            }
            setPitchAlignment(e1) {
                return this._pitchAlignment = e1 || "auto", this._update(), this;
            }
            getPitchAlignment() {
                return "auto" === this._pitchAlignment ? this.getRotationAlignment() : this._pitchAlignment;
            }
            setOccludedOpacity(e1) {
                return this._occludedOpacity = e1 || .2, this._update(), this;
            }
            getOccludedOpacity() {
                return this._occludedOpacity;
            }
        }
        const rn = {
            closeButton: !0,
            closeOnClick: !0,
            focusAfterOpen: !0,
            className: "",
            maxWidth: "240px"
        }, nn = [
            "a[href]",
            "[tabindex]:not([tabindex='-1'])",
            "[contenteditable]:not([contenteditable='false'])",
            "button:not([disabled])",
            "input:not([disabled])",
            "select:not([disabled])",
            "textarea:not([disabled])"
        ].join(", ");
        function an(t1 = new e1.pointGeometry(0, 0), i = "bottom") {
            if ("number" == typeof t1) {
                const o = Math.round(Math.sqrt(.5 * Math.pow(t1, 2)));
                switch(i){
                    case "top":
                        return new e1.pointGeometry(0, t1);
                    case "top-left":
                        return new e1.pointGeometry(o, o);
                    case "top-right":
                        return new e1.pointGeometry(-o, o);
                    case "bottom":
                        return new e1.pointGeometry(0, -t1);
                    case "bottom-left":
                        return new e1.pointGeometry(o, -o);
                    case "bottom-right":
                        return new e1.pointGeometry(-o, -o);
                    case "left":
                        return new e1.pointGeometry(t1, 0);
                    case "right":
                        return new e1.pointGeometry(-t1, 0);
                }
                return new e1.pointGeometry(0, 0);
            }
            return t1 instanceof e1.pointGeometry || Array.isArray(t1) ? e1.pointGeometry.convert(t1) : e1.pointGeometry.convert(t1[i] || [
                0,
                0
            ]);
        }
        class sn {
            constructor(e1){
                this.jumpTo(e1);
            }
            getValue(t1) {
                if (t1 <= this._startTime) return this._start;
                if (t1 >= this._endTime) return this._end;
                const i = e1.easeCubicInOut((t1 - this._startTime) / (this._endTime - this._startTime));
                return this._start * (1 - i) + this._end * i;
            }
            isEasing(e1) {
                return e1 >= this._startTime && e1 <= this._endTime;
            }
            jumpTo(e1) {
                this._startTime = -1 / 0, this._endTime = -1 / 0, this._start = e1, this._end = e1;
            }
            easeTo(e1, t1, i) {
                this._start = this.getValue(t1), this._end = e1, this._startTime = t1, this._endTime = t1 + i;
            }
        }
        const ln = {
            "AttributionControl.ToggleAttribution": "Toggle attribution",
            "AttributionControl.MapFeedback": "Map feedback",
            "FullscreenControl.Enter": "Enter fullscreen",
            "FullscreenControl.Exit": "Exit fullscreen",
            "GeolocateControl.FindMyLocation": "Find my location",
            "GeolocateControl.LocationNotAvailable": "Location not available",
            "LogoControl.Title": "Mapbox logo",
            "Map.Title": "Map",
            "NavigationControl.ResetBearing": "Reset bearing to north",
            "NavigationControl.ZoomIn": "Zoom in",
            "NavigationControl.ZoomOut": "Zoom out",
            "ScrollZoomBlocker.CtrlMessage": "Use ctrl + scroll to zoom the map",
            "ScrollZoomBlocker.CmdMessage": "Use ⌘ + scroll to zoom the map",
            "TouchPanBlocker.Message": "Use two fingers to move the map"
        }, cn = {
            center: [
                0,
                0
            ],
            zoom: 0,
            bearing: 0,
            pitch: 0,
            minZoom: -2,
            maxZoom: 22,
            minPitch: 0,
            maxPitch: 85,
            interactive: !0,
            scrollZoom: !0,
            boxZoom: !0,
            dragRotate: !0,
            dragPan: !0,
            keyboard: !0,
            doubleClickZoom: !0,
            touchZoomRotate: !0,
            touchPitch: !0,
            cooperativeGestures: !1,
            performanceMetricsCollection: !0,
            bearingSnap: 7,
            clickTolerance: 3,
            pitchWithRotate: !0,
            hash: !1,
            attributionControl: !0,
            failIfMajorPerformanceCaveat: !1,
            preserveDrawingBuffer: !1,
            trackResize: !0,
            optimizeForTerrain: !0,
            renderWorldCopies: !0,
            refreshExpiredTiles: !0,
            minTileCacheSize: null,
            maxTileCacheSize: null,
            localIdeographFontFamily: "sans-serif",
            localFontFamily: null,
            transformRequest: null,
            accessToken: null,
            fadeDuration: 300,
            crossSourceCollisions: !0
        };
        function hn(e1) {
            e1.parentNode && e1.parentNode.removeChild(e1);
        }
        const _n = {
            showCompass: !0,
            showZoom: !0,
            visualizePitch: !1
        };
        class un {
            constructor(t1, i, o = !1){
                this._clickTolerance = 10, this.element = i, this.mouseRotate = new wr({
                    clickTolerance: t1.dragRotate._mouseRotate._clickTolerance
                }), this.map = t1, o && (this.mousePitch = new Tr({
                    clickTolerance: t1.dragRotate._mousePitch._clickTolerance
                })), e1.bindAll([
                    "mousedown",
                    "mousemove",
                    "mouseup",
                    "touchstart",
                    "touchmove",
                    "touchend",
                    "reset"
                ], this), i.addEventListener("mousedown", this.mousedown), i.addEventListener("touchstart", this.touchstart, {
                    passive: !1
                }), i.addEventListener("touchmove", this.touchmove), i.addEventListener("touchend", this.touchend), i.addEventListener("touchcancel", this.reset);
            }
            down(e1, t1) {
                this.mouseRotate.mousedown(e1, t1), this.mousePitch && this.mousePitch.mousedown(e1, t1), h();
            }
            move(e1, t1) {
                const i = this.map, o = this.mouseRotate.mousemoveWindow(e1, t1), r = o && o.bearingDelta;
                if (r && i.setBearing(i.getBearing() + r), this.mousePitch) {
                    const o1 = this.mousePitch.mousemoveWindow(e1, t1), r1 = o1 && o1.pitchDelta;
                    r1 && i.setPitch(i.getPitch() + r1);
                }
            }
            off() {
                const e1 = this.element;
                e1.removeEventListener("mousedown", this.mousedown), e1.removeEventListener("touchstart", this.touchstart, {
                    passive: !1
                }), e1.removeEventListener("touchmove", this.touchmove), e1.removeEventListener("touchend", this.touchend), e1.removeEventListener("touchcancel", this.reset), this.offTemp();
            }
            offTemp() {
                _(), e1.window.removeEventListener("mousemove", this.mousemove), e1.window.removeEventListener("mouseup", this.mouseup);
            }
            mousedown(t1) {
                this.down(e1.extend({}, t1, {
                    ctrlKey: !0,
                    preventDefault: ()=>t1.preventDefault()
                }), p(this.element, t1)), e1.window.addEventListener("mousemove", this.mousemove), e1.window.addEventListener("mouseup", this.mouseup);
            }
            mousemove(e1) {
                this.move(e1, p(this.element, e1));
            }
            mouseup(e1) {
                this.mouseRotate.mouseupWindow(e1), this.mousePitch && this.mousePitch.mouseupWindow(e1), this.offTemp();
            }
            touchstart(e1) {
                1 !== e1.targetTouches.length ? this.reset() : (this._startPos = this._lastPos = m(this.element, e1.targetTouches)[0], this.down({
                    type: "mousedown",
                    button: 0,
                    ctrlKey: !0,
                    preventDefault: ()=>e1.preventDefault()
                }, this._startPos));
            }
            touchmove(e1) {
                1 !== e1.targetTouches.length ? this.reset() : (this._lastPos = m(this.element, e1.targetTouches)[0], this.move({
                    preventDefault: ()=>e1.preventDefault()
                }, this._lastPos));
            }
            touchend(e1) {
                0 === e1.targetTouches.length && this._startPos && this._lastPos && this._startPos.dist(this._lastPos) < this._clickTolerance && this.element.click(), this.reset();
            }
            reset() {
                this.mouseRotate.reset(), this.mousePitch && this.mousePitch.reset(), delete this._startPos, delete this._lastPos, this.offTemp();
            }
        }
        const dn = {
            positionOptions: {
                enableHighAccuracy: !1,
                maximumAge: 0,
                timeout: 6e3
            },
            fitBoundsOptions: {
                maxZoom: 15
            },
            trackUserLocation: !1,
            showAccuracyCircle: !0,
            showUserLocation: !0,
            showUserHeading: !1
        }, pn = {
            maxWidth: 100,
            unit: "metric"
        };
        function mn(e1, t1, i) {
            const o = fn(t1), r = o / t1, n = {
                kilometer: "km",
                meter: "m",
                mile: "mi",
                foot: "ft",
                "nautical-mile": "nm"
            }[i];
            this._map._requestDomTask(()=>{
                this._container.style.width = e1 * r + "px", this._container.innerHTML = `${o}&nbsp;${n}`;
            });
        }
        function fn(e1) {
            const t1 = Math.pow(10, `${Math.floor(e1)}`.length - 1);
            let i = e1 / t1;
            return i = i >= 10 ? 10 : i >= 5 ? 5 : i >= 3 ? 3 : i >= 2 ? 2 : i >= 1 ? 1 : function(e1) {
                const t1 = Math.pow(10, Math.ceil(-Math.log(e1) / Math.LN10));
                return Math.round(e1 * t1) / t1;
            }(i), t1 * i;
        }
        const gn = {
            version: e1.version,
            supported: i,
            setRTLTextPlugin: e1.setRTLTextPlugin,
            getRTLTextPluginStatus: e1.getRTLTextPluginStatus,
            Map: class extends Yr {
                constructor(t1){
                    if (e1.LivePerformanceUtils.mark(e1.PerformanceMarkers.create), null != (t1 = e1.extend({}, cn, t1)).minZoom && null != t1.maxZoom && t1.minZoom > t1.maxZoom) throw new Error("maxZoom must be greater than or equal to minZoom");
                    if (null != t1.minPitch && null != t1.maxPitch && t1.minPitch > t1.maxPitch) throw new Error("maxPitch must be greater than or equal to minPitch");
                    if (null != t1.minPitch && t1.minPitch < 0) throw new Error("minPitch must be greater than or equal to 0");
                    if (null != t1.maxPitch && t1.maxPitch > 85) throw new Error("maxPitch must be less than or equal to 85");
                    if (t1.antialias && e1.isSafariWithAntialiasingBug(e1.window) && (t1.antialias = !1, e1.warnOnce("Antialiasing is disabled for this WebGL context to avoid browser bug: https://github.com/mapbox/mapbox-gl-js/issues/11609")), super(new Ko(t1.minZoom, t1.maxZoom, t1.minPitch, t1.maxPitch, t1.renderWorldCopies), t1), this._interactive = t1.interactive, this._minTileCacheSize = t1.minTileCacheSize, this._maxTileCacheSize = t1.maxTileCacheSize, this._failIfMajorPerformanceCaveat = t1.failIfMajorPerformanceCaveat, this._preserveDrawingBuffer = t1.preserveDrawingBuffer, this._antialias = t1.antialias, this._trackResize = t1.trackResize, this._bearingSnap = t1.bearingSnap, this._refreshExpiredTiles = t1.refreshExpiredTiles, this._fadeDuration = t1.fadeDuration, this._isInitialLoad = !0, this._crossSourceCollisions = t1.crossSourceCollisions, this._crossFadingFactor = 1, this._collectResourceTiming = t1.collectResourceTiming, this._optimizeForTerrain = t1.optimizeForTerrain, this._language = this._parseLanguage(t1.language), this._worldview = t1.worldview, this._renderTaskQueue = new Qr, this._domRenderTaskQueue = new Qr, this._controls = [], this._markers = [], this._popups = [], this._mapId = e1.uniqueId(), this._locale = e1.extend({}, ln, t1.locale), this._clickTolerance = t1.clickTolerance, this._cooperativeGestures = t1.cooperativeGestures, this._performanceMetricsCollection = t1.performanceMetricsCollection, this._containerWidth = 0, this._containerHeight = 0, this._averageElevationLastSampledAt = -1 / 0, this._averageElevationExaggeration = 0, this._averageElevation = new sn(0), this._interactionRange = [
                        1 / 0,
                        -1 / 0
                    ], this._useExplicitProjection = !1, this._requestManager = new e1.RequestManager(t1.transformRequest, t1.accessToken, t1.testMode), this._silenceAuthErrors = !!t1.testMode, "string" == typeof t1.container) {
                        if (this._container = e1.window.document.getElementById(t1.container), !this._container) throw new Error(`Container '${t1.container}' not found.`);
                    } else {
                        if (!(t1.container instanceof e1.window.HTMLElement)) throw new Error("Invalid type: 'container' must be a String or HTMLElement.");
                        this._container = t1.container;
                    }
                    if (this._container.childNodes.length > 0 && e1.warnOnce("The map container element should be empty, otherwise the map's interactivity will be negatively impacted. If you want to display a message when WebGL is not supported, use the Mapbox GL Supported plugin instead."), t1.maxBounds && this.setMaxBounds(t1.maxBounds), e1.bindAll([
                        "_onWindowOnline",
                        "_onWindowResize",
                        "_onMapScroll",
                        "_contextLost",
                        "_contextRestored"
                    ], this), this._setupContainer(), this._setupPainter(), void 0 === this.painter) throw new Error("Failed to initialize WebGL.");
                    this.on("move", ()=>this._update(!1)), this.on("moveend", ()=>this._update(!1)), this.on("zoom", ()=>this._update(!0)), void 0 !== e1.window && (e1.window.addEventListener("online", this._onWindowOnline, !1), e1.window.addEventListener("resize", this._onWindowResize, !1), e1.window.addEventListener("orientationchange", this._onWindowResize, !1), e1.window.addEventListener("webkitfullscreenchange", this._onWindowResize, !1)), this.handlers = new $r(this, t1), this._localFontFamily = t1.localFontFamily, this._localIdeographFontFamily = t1.localIdeographFontFamily, t1.style && this.setStyle(t1.style, {
                        localFontFamily: this._localFontFamily,
                        localIdeographFontFamily: this._localIdeographFontFamily
                    }), t1.projection && this.setProjection(t1.projection), this._hash = t1.hash && new Qo("string" == typeof t1.hash && t1.hash || void 0).addTo(this), this._hash && this._hash._onHashChange() || (this.jumpTo({
                        center: t1.center,
                        zoom: t1.zoom,
                        bearing: t1.bearing,
                        pitch: t1.pitch
                    }), t1.bounds && (this.resize(), this.fitBounds(t1.bounds, e1.extend({}, t1.fitBoundsOptions, {
                        duration: 0
                    })))), this.resize(), t1.attributionControl && this.addControl(new Kr({
                        customAttribution: t1.customAttribution
                    })), this._logoControl = new Jr, this.addControl(this._logoControl, t1.logoPosition), this.on("style.load", ()=>{
                        this.transform.unmodified && this.jumpTo(this.style.stylesheet);
                    }), this.on("data", (t1)=>{
                        this._update("style" === t1.dataType), this.fire(new e1.Event(`${t1.dataType}data`, t1));
                    }), this.on("dataloading", (t1)=>{
                        this.fire(new e1.Event(`${t1.dataType}dataloading`, t1));
                    });
                }
                _getMapId() {
                    return this._mapId;
                }
                addControl(t1, i) {
                    if (void 0 === i && (i = t1.getDefaultPosition ? t1.getDefaultPosition() : "top-right"), !t1 || !t1.onAdd) return this.fire(new e1.ErrorEvent(new Error("Invalid argument to map.addControl(). Argument must be a control with onAdd and onRemove methods.")));
                    const o = t1.onAdd(this);
                    this._controls.push(t1);
                    const r = this._controlPositions[i];
                    return -1 !== i.indexOf("bottom") ? r.insertBefore(o, r.firstChild) : r.appendChild(o), this;
                }
                removeControl(t1) {
                    if (!t1 || !t1.onRemove) return this.fire(new e1.ErrorEvent(new Error("Invalid argument to map.removeControl(). Argument must be a control with onAdd and onRemove methods.")));
                    const i = this._controls.indexOf(t1);
                    return i > -1 && this._controls.splice(i, 1), t1.onRemove(this), this;
                }
                hasControl(e1) {
                    return this._controls.indexOf(e1) > -1;
                }
                getContainer() {
                    return this._container;
                }
                getCanvasContainer() {
                    return this._canvasContainer;
                }
                getCanvas() {
                    return this._canvas;
                }
                resize(t1) {
                    if (this._updateContainerDimensions(), this._containerWidth === this.transform.width && this._containerHeight === this.transform.height) return this;
                    this._resizeCanvas(this._containerWidth, this._containerHeight), this.transform.resize(this._containerWidth, this._containerHeight), this.painter.resize(Math.ceil(this._containerWidth), Math.ceil(this._containerHeight));
                    const i = !this._moving;
                    return i && this.fire(new e1.Event("movestart", t1)).fire(new e1.Event("move", t1)), this.fire(new e1.Event("resize", t1)), i && this.fire(new e1.Event("moveend", t1)), this;
                }
                getBounds() {
                    return "globe" === this.transform.projection.name && e1.warnOnce('Globe projection does not support getBounds API, this API may behave unexpectedly when viewing the poles."'), this.transform.getBounds();
                }
                getMaxBounds() {
                    return this.transform.getMaxBounds() || null;
                }
                setMaxBounds(t1) {
                    return this.transform.setMaxBounds(e1.LngLatBounds.convert(t1)), this._update();
                }
                setMinZoom(t1) {
                    if ((t1 = null == t1 ? -2 : t1) >= -2 && t1 <= this.transform.maxZoom) return this.transform.minZoom = t1, this._update(), this.getZoom() < t1 ? this.setZoom(t1) : this.fire(new e1.Event("zoomstart")).fire(new e1.Event("zoom")).fire(new e1.Event("zoomend")), this;
                    throw new Error("minZoom must be between -2 and the current maxZoom, inclusive");
                }
                getMinZoom() {
                    return this.transform.minZoom;
                }
                setMaxZoom(t1) {
                    if ((t1 = null == t1 ? 22 : t1) >= this.transform.minZoom) return this.transform.maxZoom = t1, this._update(), this.getZoom() > t1 ? this.setZoom(t1) : this.fire(new e1.Event("zoomstart")).fire(new e1.Event("zoom")).fire(new e1.Event("zoomend")), this;
                    throw new Error("maxZoom must be greater than the current minZoom");
                }
                getMaxZoom() {
                    return this.transform.maxZoom;
                }
                setMinPitch(t1) {
                    if ((t1 = null == t1 ? 0 : t1) < 0) throw new Error("minPitch must be greater than or equal to 0");
                    if (t1 >= 0 && t1 <= this.transform.maxPitch) return this.transform.minPitch = t1, this._update(), this.getPitch() < t1 ? this.setPitch(t1) : this.fire(new e1.Event("pitchstart")).fire(new e1.Event("pitch")).fire(new e1.Event("pitchend")), this;
                    throw new Error("minPitch must be between 0 and the current maxPitch, inclusive");
                }
                getMinPitch() {
                    return this.transform.minPitch;
                }
                setMaxPitch(t1) {
                    if ((t1 = null == t1 ? 85 : t1) > 85) throw new Error("maxPitch must be less than or equal to 85");
                    if (t1 >= this.transform.minPitch) return this.transform.maxPitch = t1, this._update(), this.getPitch() > t1 ? this.setPitch(t1) : this.fire(new e1.Event("pitchstart")).fire(new e1.Event("pitch")).fire(new e1.Event("pitchend")), this;
                    throw new Error("maxPitch must be greater than or equal to minPitch");
                }
                getMaxPitch() {
                    return this.transform.maxPitch;
                }
                getRenderWorldCopies() {
                    return this.transform.renderWorldCopies;
                }
                setRenderWorldCopies(e1) {
                    return this.transform.renderWorldCopies = e1, this.transform.renderWorldCopies || this._forceMarkerAndPopupUpdate(!0), this._update();
                }
                getLanguage() {
                    return this._language;
                }
                _parseLanguage(t1) {
                    return "auto" === t1 ? e1.window.navigator.language : Array.isArray(t1) ? 0 === t1.length ? void 0 : t1.map((t1)=>"auto" === t1 ? e1.window.navigator.language : t1) : t1;
                }
                setLanguage(e1) {
                    const t1 = this._parseLanguage(e1);
                    if (!this.style || t1 === this._language) return this;
                    this._language = t1, this.style._reloadSources();
                    for (const e2 of this._controls)e2._setLanguage && e2._setLanguage(this._language);
                    return this;
                }
                getWorldview() {
                    return this._worldview;
                }
                setWorldview(e1) {
                    return this.style && e1 !== this._worldview ? (this._worldview = e1, this.style._reloadSources(), this) : this;
                }
                getProjection() {
                    return this.transform.mercatorFromTransition ? {
                        name: "globe",
                        center: [
                            0,
                            0
                        ]
                    } : this.transform.getProjection();
                }
                _showingGlobe() {
                    return "globe" === this.transform.projection.name;
                }
                setProjection(e1) {
                    return this._lazyInitEmptyStyle(), e1 ? "string" == typeof e1 && (e1 = {
                        name: e1
                    }) : e1 = null, this._useExplicitProjection = !!e1, this._prioritizeAndUpdateProjection(e1, this.style.stylesheet ? this.style.stylesheet.projection : null);
                }
                _updateProjectionTransition() {
                    if ("globe" !== this.getProjection().name) return;
                    const t1 = this.transform, i = t1.projection.name;
                    let o;
                    "globe" === i && t1.zoom >= e1.GLOBE_ZOOM_THRESHOLD_MAX ? (t1.setMercatorFromTransition(), o = !0) : "mercator" === i && t1.zoom < e1.GLOBE_ZOOM_THRESHOLD_MAX && (t1.setProjection({
                        name: "globe"
                    }), o = !0), o && (this.style.applyProjectionUpdate(), this.style._forceSymbolLayerUpdate());
                }
                _prioritizeAndUpdateProjection(e1, t1) {
                    return this._updateProjection(e1 || t1 || {
                        name: "mercator"
                    });
                }
                _updateProjection(t1) {
                    let i;
                    if (i = "globe" === t1.name && this.transform.zoom >= e1.GLOBE_ZOOM_THRESHOLD_MAX ? this.transform.setMercatorFromTransition() : this.transform.setProjection(t1), this.style.applyProjectionUpdate(), i) {
                        this.painter.clearBackgroundTiles();
                        for(const e2 in this.style._sourceCaches)this.style._sourceCaches[e2].clearTiles();
                        this._update(!0), this._forceMarkerAndPopupUpdate(!0);
                    }
                    return this;
                }
                project(t1) {
                    return this.transform.locationPoint3D(e1.LngLat.convert(t1));
                }
                unproject(t1) {
                    return this.transform.pointLocation3D(e1.pointGeometry.convert(t1));
                }
                isMoving() {
                    return this._moving || this.handlers && this.handlers.isMoving() || !1;
                }
                isZooming() {
                    return this._zooming || this.handlers && this.handlers.isZooming() || !1;
                }
                isRotating() {
                    return this._rotating || this.handlers && this.handlers.isRotating() || !1;
                }
                _createDelegatedListener(e1, t1, i) {
                    if ("mouseenter" === e1 || "mouseover" === e1) {
                        let o = !1;
                        const r = (r)=>{
                            const n = t1.filter((e1)=>this.getLayer(e1)), a = n.length ? this.queryRenderedFeatures(r.point, {
                                layers: n
                            }) : [];
                            a.length ? o || (o = !0, i.call(this, new cr(e1, this, r.originalEvent, {
                                features: a
                            }))) : o = !1;
                        }, n = ()=>{
                            o = !1;
                        };
                        return {
                            layers: new Set(t1),
                            listener: i,
                            delegates: {
                                mousemove: r,
                                mouseout: n
                            }
                        };
                    }
                    if ("mouseleave" === e1 || "mouseout" === e1) {
                        let o1 = !1;
                        const r1 = (r)=>{
                            const n = t1.filter((e1)=>this.getLayer(e1));
                            (n.length ? this.queryRenderedFeatures(r.point, {
                                layers: n
                            }) : []).length ? o1 = !0 : o1 && (o1 = !1, i.call(this, new cr(e1, this, r.originalEvent)));
                        }, n1 = (t1)=>{
                            o1 && (o1 = !1, i.call(this, new cr(e1, this, t1.originalEvent)));
                        };
                        return {
                            layers: new Set(t1),
                            listener: i,
                            delegates: {
                                mousemove: r1,
                                mouseout: n1
                            }
                        };
                    }
                    {
                        const o2 = (e1)=>{
                            const o = t1.filter((e1)=>this.getLayer(e1)), r = o.length ? this.queryRenderedFeatures(e1.point, {
                                layers: o
                            }) : [];
                            r.length && (e1.features = r, i.call(this, e1), delete e1.features);
                        };
                        return {
                            layers: new Set(t1),
                            listener: i,
                            delegates: {
                                [e1]: o2
                            }
                        };
                    }
                }
                on(e1, t1, i) {
                    if (void 0 === i) return super.on(e1, t1);
                    Array.isArray(t1) || (t1 = [
                        t1
                    ]);
                    const o = this._createDelegatedListener(e1, t1, i);
                    this._delegatedListeners = this._delegatedListeners || {}, this._delegatedListeners[e1] = this._delegatedListeners[e1] || [], this._delegatedListeners[e1].push(o);
                    for(const e2 in o.delegates)this.on(e2, o.delegates[e2]);
                    return this;
                }
                once(e1, t1, i) {
                    if (void 0 === i) return super.once(e1, t1);
                    Array.isArray(t1) || (t1 = [
                        t1
                    ]);
                    const o = this._createDelegatedListener(e1, t1, i);
                    for(const e2 in o.delegates)this.once(e2, o.delegates[e2]);
                    return this;
                }
                off(e1, t1, i) {
                    if (void 0 === i) return super.off(e1, t1);
                    t1 = new Set(Array.isArray(t1) ? t1 : [
                        t1
                    ]);
                    const o = (e1, t1)=>{
                        if (e1.size !== t1.size) return !1;
                        for (const i of e1)if (!t1.has(i)) return !1;
                        return !0;
                    }, r = this._delegatedListeners ? this._delegatedListeners[e1] : void 0;
                    return r && ((e1)=>{
                        for(let r = 0; r < e1.length; r++){
                            const n = e1[r];
                            if (n.listener === i && o(n.layers, t1)) {
                                for(const e2 in n.delegates)this.off(e2, n.delegates[e2]);
                                return e1.splice(r, 1), this;
                            }
                        }
                    })(r), this;
                }
                queryRenderedFeatures(t1, i) {
                    return this.style ? (void 0 !== i || void 0 === t1 || t1 instanceof e1.pointGeometry || Array.isArray(t1) || (i = t1, t1 = void 0), this.style.queryRenderedFeatures(t1 = t1 || [
                        [
                            0,
                            0
                        ],
                        [
                            this.transform.width,
                            this.transform.height
                        ]
                    ], i = i || {}, this.transform)) : [];
                }
                querySourceFeatures(e1, t1) {
                    return this.style.querySourceFeatures(e1, t1);
                }
                setStyle(t1, i) {
                    return !1 !== (i = e1.extend({}, {
                        localIdeographFontFamily: this._localIdeographFontFamily,
                        localFontFamily: this._localFontFamily
                    }, i)).diff && i.localIdeographFontFamily === this._localIdeographFontFamily && i.localFontFamily === this._localFontFamily && this.style && t1 ? (this._diffStyle(t1, i), this) : (this._localIdeographFontFamily = i.localIdeographFontFamily, this._localFontFamily = i.localFontFamily, this._updateStyle(t1, i));
                }
                _getUIString(e1) {
                    const t1 = this._locale[e1];
                    if (null == t1) throw new Error(`Missing UI string '${e1}'`);
                    return t1;
                }
                _updateStyle(e1, t1) {
                    return this.style && (this.style.setEventedParent(null), this.style._remove(), this.style = void 0), e1 && (this.style = new ei(this, t1 || {}), this.style.setEventedParent(this, {
                        style: this.style
                    }), "string" == typeof e1 ? this.style.loadURL(e1) : this.style.loadJSON(e1)), this._updateTerrain(), this;
                }
                _lazyInitEmptyStyle() {
                    this.style || (this.style = new ei(this, {}), this.style.setEventedParent(this, {
                        style: this.style
                    }), this.style.loadEmpty());
                }
                _diffStyle(t1, i) {
                    if ("string" == typeof t1) {
                        const o = this._requestManager.normalizeStyleURL(t1), r = this._requestManager.transformRequest(o, e1.ResourceType.Style);
                        e1.getJSON(r, (t1, o)=>{
                            t1 ? this.fire(new e1.ErrorEvent(t1)) : o && this._updateDiff(o, i);
                        });
                    } else "object" == typeof t1 && this._updateDiff(t1, i);
                }
                _updateDiff(t1, i) {
                    try {
                        this.style.setState(t1) && this._update(!0);
                    } catch (o) {
                        e1.warnOnce(`Unable to perform style diff: ${o.message || o.error || o}.  Rebuilding the style from scratch.`), this._updateStyle(t1, i);
                    }
                }
                getStyle() {
                    if (this.style) return this.style.serialize();
                }
                isStyleLoaded() {
                    return this.style ? this.style.loaded() : (e1.warnOnce("There is no style added to the map."), !1);
                }
                addSource(e1, t1) {
                    return this._lazyInitEmptyStyle(), this.style.addSource(e1, t1), this._update(!0);
                }
                isSourceLoaded(e1) {
                    return !!this.style && this.style._isSourceCacheLoaded(e1);
                }
                areTilesLoaded() {
                    const e1 = this.style && this.style._sourceCaches;
                    for(const t1 in e1){
                        const i = e1[t1]._tiles;
                        for(const e2 in i){
                            const t2 = i[e2];
                            if ("loaded" !== t2.state && "errored" !== t2.state) return !1;
                        }
                    }
                    return !0;
                }
                addSourceType(e1, t1, i) {
                    this._lazyInitEmptyStyle(), this.style.addSourceType(e1, t1, i);
                }
                removeSource(e1) {
                    return this.style.removeSource(e1), this._updateTerrain(), this._update(!0);
                }
                getSource(e1) {
                    return this.style.getSource(e1);
                }
                addImage(t1, i, { pixelRatio: o = 1 , sdf: r = !1 , stretchX: n , stretchY: a , content: s  } = {}) {
                    if (this._lazyInitEmptyStyle(), i instanceof e1.window.HTMLImageElement || e1.window.ImageBitmap && i instanceof e1.window.ImageBitmap) {
                        const { width: l , height: c , data: h  } = e1.exported.getImageData(i);
                        this.style.addImage(t1, {
                            data: new e1.RGBAImage({
                                width: l,
                                height: c
                            }, h),
                            pixelRatio: o,
                            stretchX: n,
                            stretchY: a,
                            content: s,
                            sdf: r,
                            version: 0
                        });
                    } else if (void 0 === i.width || void 0 === i.height) this.fire(new e1.ErrorEvent(new Error("Invalid arguments to map.addImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));
                    else {
                        const { width: l1 , height: c1  } = i, h1 = i;
                        this.style.addImage(t1, {
                            data: new e1.RGBAImage({
                                width: l1,
                                height: c1
                            }, new Uint8Array(h1.data)),
                            pixelRatio: o,
                            stretchX: n,
                            stretchY: a,
                            content: s,
                            sdf: r,
                            version: 0,
                            userImage: h1
                        }), h1.onAdd && h1.onAdd(this, t1);
                    }
                }
                updateImage(t1, i) {
                    const o = this.style.getImage(t1);
                    if (!o) return void this.fire(new e1.ErrorEvent(new Error("The map has no image with that id. If you are adding a new image use `map.addImage(...)` instead.")));
                    const r = i instanceof e1.window.HTMLImageElement || e1.window.ImageBitmap && i instanceof e1.window.ImageBitmap ? e1.exported.getImageData(i) : i, { width: n , height: a  } = r;
                    void 0 !== n && void 0 !== a ? n === o.data.width && a === o.data.height ? (o.data.replace(r.data, !(i instanceof e1.window.HTMLImageElement || e1.window.ImageBitmap && i instanceof e1.window.ImageBitmap)), this.style.updateImage(t1, o)) : this.fire(new e1.ErrorEvent(new Error(`The width and height of the updated image (${n}, ${a})\n                must be that same as the previous version of the image\n                (${o.data.width}, ${o.data.height})`))) : this.fire(new e1.ErrorEvent(new Error("Invalid arguments to map.updateImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));
                }
                hasImage(t1) {
                    return t1 ? !!this.style.getImage(t1) : (this.fire(new e1.ErrorEvent(new Error("Missing required image id"))), !1);
                }
                removeImage(e1) {
                    this.style.removeImage(e1);
                }
                loadImage(t1, i) {
                    e1.getImage(this._requestManager.transformRequest(t1, e1.ResourceType.Image), (t1, o)=>{
                        i(t1, o instanceof e1.window.HTMLImageElement ? e1.exported.getImageData(o) : o);
                    });
                }
                listImages() {
                    return this.style.listImages();
                }
                addLayer(e1, t1) {
                    return this._lazyInitEmptyStyle(), this.style.addLayer(e1, t1), this._update(!0);
                }
                moveLayer(e1, t1) {
                    return this.style.moveLayer(e1, t1), this._update(!0);
                }
                removeLayer(e1) {
                    return this.style.removeLayer(e1), this._update(!0);
                }
                getLayer(e1) {
                    return this.style.getLayer(e1);
                }
                setLayerZoomRange(e1, t1, i) {
                    return this.style.setLayerZoomRange(e1, t1, i), this._update(!0);
                }
                setFilter(e1, t1, i = {}) {
                    return this.style.setFilter(e1, t1, i), this._update(!0);
                }
                getFilter(e1) {
                    return this.style.getFilter(e1);
                }
                setPaintProperty(e1, t1, i, o = {}) {
                    return this.style.setPaintProperty(e1, t1, i, o), this._update(!0);
                }
                getPaintProperty(e1, t1) {
                    return this.style.getPaintProperty(e1, t1);
                }
                setLayoutProperty(e1, t1, i, o = {}) {
                    return this.style.setLayoutProperty(e1, t1, i, o), this._update(!0);
                }
                getLayoutProperty(e1, t1) {
                    return this.style.getLayoutProperty(e1, t1);
                }
                setLight(e1, t1 = {}) {
                    return this._lazyInitEmptyStyle(), this.style.setLight(e1, t1), this._update(!0);
                }
                getLight() {
                    return this.style.getLight();
                }
                setTerrain(e1) {
                    return this._lazyInitEmptyStyle(), !e1 && this.transform.projection.requiresDraping ? this.style.setTerrainForDraping() : this.style.setTerrain(e1), this._averageElevationLastSampledAt = -1 / 0, this._update(!0);
                }
                getTerrain() {
                    return this.style ? this.style.getTerrain() : null;
                }
                setFog(e1) {
                    return this._lazyInitEmptyStyle(), this.style.setFog(e1), this._update(!0);
                }
                getFog() {
                    return this.style ? this.style.getFog() : null;
                }
                _queryFogOpacity(t1) {
                    return this.style && this.style.fog ? this.style.fog.getOpacityAtLatLng(e1.LngLat.convert(t1), this.transform) : 0;
                }
                setFeatureState(e1, t1) {
                    return this.style.setFeatureState(e1, t1), this._update();
                }
                removeFeatureState(e1, t1) {
                    return this.style.removeFeatureState(e1, t1), this._update();
                }
                getFeatureState(e1) {
                    return this.style.getFeatureState(e1);
                }
                _updateContainerDimensions() {
                    if (!this._container) return;
                    const t1 = this._container.getBoundingClientRect().width || 400, i = this._container.getBoundingClientRect().height || 300;
                    let o, r, n, a = this._container;
                    for(; a && (!r || !n);){
                        const t2 = e1.window.getComputedStyle(a).transform;
                        t2 && "none" !== t2 && (o = t2.match(/matrix.*\((.+)\)/)[1].split(", "), o[0] && "0" !== o[0] && "1" !== o[0] && (r = o[0]), o[3] && "0" !== o[3] && "1" !== o[3] && (n = o[3])), a = a.parentElement;
                    }
                    this._containerWidth = r ? Math.abs(t1 / r) : t1, this._containerHeight = n ? Math.abs(i / n) : i;
                }
                _detectMissingCSS() {
                    "rgb(250, 128, 114)" !== e1.window.getComputedStyle(this._missingCSSCanary).getPropertyValue("background-color") && e1.warnOnce("This page appears to be missing CSS declarations for Mapbox GL JS, which may cause the map to display incorrectly. Please ensure your page includes mapbox-gl.css, as described in https://www.mapbox.com/mapbox-gl-js/api/.");
                }
                _setupContainer() {
                    const e1 = this._container;
                    e1.classList.add("mapboxgl-map"), (this._missingCSSCanary = n("div", "mapboxgl-canary", e1)).style.visibility = "hidden", this._detectMissingCSS();
                    const t1 = this._canvasContainer = n("div", "mapboxgl-canvas-container", e1);
                    this._interactive && t1.classList.add("mapboxgl-interactive"), this._canvas = n("canvas", "mapboxgl-canvas", t1), this._canvas.addEventListener("webglcontextlost", this._contextLost, !1), this._canvas.addEventListener("webglcontextrestored", this._contextRestored, !1), this._canvas.setAttribute("tabindex", "0"), this._canvas.setAttribute("aria-label", this._getUIString("Map.Title")), this._canvas.setAttribute("role", "region"), this._updateContainerDimensions(), this._resizeCanvas(this._containerWidth, this._containerHeight);
                    const i = this._controlContainer = n("div", "mapboxgl-control-container", e1), o = this._controlPositions = {};
                    [
                        "top-left",
                        "top-right",
                        "bottom-left",
                        "bottom-right"
                    ].forEach((e1)=>{
                        o[e1] = n("div", `mapboxgl-ctrl-${e1}`, i);
                    }), this._container.addEventListener("scroll", this._onMapScroll, !1);
                }
                _resizeCanvas(t1, i) {
                    const o = e1.exported.devicePixelRatio || 1;
                    this._canvas.width = o * Math.ceil(t1), this._canvas.height = o * Math.ceil(i), this._canvas.style.width = `${t1}px`, this._canvas.style.height = `${i}px`;
                }
                _addMarker(e1) {
                    this._markers.push(e1);
                }
                _removeMarker(e1) {
                    const t1 = this._markers.indexOf(e1);
                    -1 !== t1 && this._markers.splice(t1, 1);
                }
                _addPopup(e1) {
                    this._popups.push(e1);
                }
                _removePopup(e1) {
                    const t1 = this._popups.indexOf(e1);
                    -1 !== t1 && this._popups.splice(t1, 1);
                }
                _setupPainter() {
                    const t1 = e1.extend({}, i.webGLContextAttributes, {
                        failIfMajorPerformanceCaveat: this._failIfMajorPerformanceCaveat,
                        preserveDrawingBuffer: this._preserveDrawingBuffer,
                        antialias: this._antialias || !1
                    }), o = this._canvas.getContext("webgl", t1) || this._canvas.getContext("experimental-webgl", t1);
                    o ? (e1.storeAuthState(o, !0), this.painter = new Fo(o, this.transform), this.on("data", (e1)=>{
                        "source" === e1.dataType && this.painter.setTileLoadedFlag(!0);
                    }), e1.exported$1.testSupport(o)) : this.fire(new e1.ErrorEvent(new Error("Failed to initialize WebGL")));
                }
                _contextLost(t1) {
                    t1.preventDefault(), this._frame && (this._frame.cancel(), this._frame = null), this.fire(new e1.Event("webglcontextlost", {
                        originalEvent: t1
                    }));
                }
                _contextRestored(t1) {
                    this._setupPainter(), this.resize(), this._update(), this.fire(new e1.Event("webglcontextrestored", {
                        originalEvent: t1
                    }));
                }
                _onMapScroll(e1) {
                    if (e1.target === this._container) return this._container.scrollTop = 0, this._container.scrollLeft = 0, !1;
                }
                loaded() {
                    return !this._styleDirty && !this._sourcesDirty && !!this.style && this.style.loaded();
                }
                _update(e1) {
                    return this.style ? (this._styleDirty = this._styleDirty || e1, this._sourcesDirty = !0, this.triggerRepaint(), this) : this;
                }
                _requestRenderFrame(e1) {
                    return this._update(), this._renderTaskQueue.add(e1);
                }
                _cancelRenderFrame(e1) {
                    this._renderTaskQueue.remove(e1);
                }
                _requestDomTask(e1) {
                    !this.loaded() || this.loaded() && !this.isMoving() ? e1() : this._domRenderTaskQueue.add(e1);
                }
                _render(t1) {
                    let i;
                    const o = this.painter.context.extTimerQuery, r = e1.exported.now();
                    if (this.listens("gpu-timing-frame") && (i = o.createQueryEXT(), o.beginQueryEXT(o.TIME_ELAPSED_EXT, i)), this.painter.context.setDirty(), this.painter.setBaseState(), (this.isMoving() || this.isRotating() || this.isZooming()) && (this._interactionRange[0] = Math.min(this._interactionRange[0], e1.window.performance.now()), this._interactionRange[1] = Math.max(this._interactionRange[1], e1.window.performance.now())), this._renderTaskQueue.run(t1), this._domRenderTaskQueue.run(t1), this._removed) return;
                    this._updateProjectionTransition();
                    let n = !1;
                    const a = this._isInitialLoad ? 0 : this._fadeDuration;
                    if (this.style && this._styleDirty) {
                        this._styleDirty = !1;
                        const t2 = this.transform.zoom, i1 = this.transform.pitch, o1 = e1.exported.now();
                        this.style.zoomHistory.update(t2, o1);
                        const r1 = new e1.EvaluationParameters(t2, {
                            now: o1,
                            fadeDuration: a,
                            pitch: i1,
                            zoomHistory: this.style.zoomHistory,
                            transition: this.style.getTransition()
                        }), s = r1.crossFadingFactor();
                        1 === s && s === this._crossFadingFactor || (n = !0, this._crossFadingFactor = s), this.style.update(r1);
                    }
                    this.style && this.style.fog && this.style.fog.hasTransition() && (this.style._markersNeedUpdate = !0, this._sourcesDirty = !0);
                    let s1 = !1;
                    if (this.style && this._sourcesDirty ? (this._sourcesDirty = !1, this.painter._updateFog(this.style), this._updateTerrain(), s1 = this._updateAverageElevation(r), this.style._updateSources(this.transform), this._forceMarkerAndPopupUpdate()) : s1 = this._updateAverageElevation(r), this._placementDirty = this.style && this.style._updatePlacement(this.painter.transform, this.showCollisionBoxes, a, this._crossSourceCollisions), this.style && this.painter.render(this.style, {
                        showTileBoundaries: this.showTileBoundaries,
                        showTerrainWireframe: this.showTerrainWireframe,
                        showOverdrawInspector: this._showOverdrawInspector,
                        showQueryGeometry: !!this._showQueryGeometry,
                        showTileAABBs: this.showTileAABBs,
                        rotating: this.isRotating(),
                        zooming: this.isZooming(),
                        moving: this.isMoving(),
                        fadeDuration: a,
                        isInitialLoad: this._isInitialLoad,
                        showPadding: this.showPadding,
                        gpuTiming: !!this.listens("gpu-timing-layer"),
                        gpuTimingDeferredRender: !!this.listens("gpu-timing-deferred-render"),
                        speedIndexTiming: this.speedIndexTiming
                    }), this.fire(new e1.Event("render")), this.loaded() && !this._loaded && (this._loaded = !0, this.fire(new e1.Event("load"))), this.style && (this.style.hasTransitions() || n) && (this._styleDirty = !0), this.style && !this._placementDirty && this.style._releaseSymbolFadeTiles(), i) {
                        const t3 = e1.exported.now() - r;
                        o.endQueryEXT(o.TIME_ELAPSED_EXT, i), setTimeout(()=>{
                            const n = o.getQueryObjectEXT(i, o.QUERY_RESULT_EXT) / 1e6;
                            o.deleteQueryEXT(i), this.fire(new e1.Event("gpu-timing-frame", {
                                cpuTime: t3,
                                gpuTime: n
                            })), e1.window.performance.mark("frame-gpu", {
                                startTime: r,
                                detail: {
                                    gpuTime: n
                                }
                            });
                        }, 50);
                    }
                    if (this.listens("gpu-timing-layer")) {
                        const t4 = this.painter.collectGpuTimers();
                        setTimeout(()=>{
                            const i = this.painter.queryGpuTimers(t4);
                            this.fire(new e1.Event("gpu-timing-layer", {
                                layerTimes: i
                            }));
                        }, 50);
                    }
                    if (this.listens("gpu-timing-deferred-render")) {
                        const t5 = this.painter.collectDeferredRenderGpuQueries();
                        setTimeout(()=>{
                            const i = this.painter.queryGpuTimeDeferredRender(t5);
                            this.fire(new e1.Event("gpu-timing-deferred-render", {
                                gpuTime: i
                            }));
                        }, 50);
                    }
                    const l = this._sourcesDirty || this._styleDirty || this._placementDirty || s1;
                    if (l || this._repaint) this.triggerRepaint();
                    else {
                        const t6 = !this.isMoving() && this.loaded();
                        if (t6 && (s1 = this._updateAverageElevation(r, !0)), s1) this.triggerRepaint();
                        else if (this._triggerFrame(!1), t6 && (this.fire(new e1.Event("idle")), this._isInitialLoad = !1, this.speedIndexTiming)) {
                            const t7 = this._calculateSpeedIndex();
                            this.fire(new e1.Event("speedindexcompleted", {
                                speedIndex: t7
                            })), this.speedIndexTiming = !1;
                        }
                    }
                    !this._loaded || this._fullyLoaded || l || (this._fullyLoaded = !0, e1.LivePerformanceUtils.mark(e1.PerformanceMarkers.fullLoad), this._performanceMetricsCollection && e1.postPerformanceEvent(this._requestManager._customAccessToken, {
                        width: this.painter.width,
                        height: this.painter.height,
                        interactionRange: this._interactionRange,
                        terrainEnabled: !!this.painter.style.getTerrain(),
                        fogEnabled: !!this.painter.style.getFog(),
                        projection: this.painter.transform.projection,
                        zoom: this.transform.zoom,
                        renderer: this.painter.context.renderer,
                        vendor: this.painter.context.vendor
                    }), this._authenticate());
                }
                _forceMarkerAndPopupUpdate(e1) {
                    for (const t1 of this._markers)e1 && !this.getRenderWorldCopies() && (t1._lngLat = t1._lngLat.wrap()), t1._update();
                    for (const t2 of this._popups)!e1 || this.getRenderWorldCopies() || t2._trackPointer || (t2._lngLat = t2._lngLat.wrap()), t2._update();
                }
                _updateAverageElevation(e1, t1 = !1) {
                    const i = (e1)=>(this.transform.averageElevation = e1, this._update(!1), !0);
                    if (!this.painter.averageElevationNeedsEasing()) return 0 !== this.transform.averageElevation && i(0);
                    if ((t1 || e1 - this._averageElevationLastSampledAt > 500) && !this._averageElevation.isEasing(e1)) {
                        const t2 = this.transform.averageElevation;
                        let o = this.transform.sampleAverageElevation(), r = !1;
                        this.transform.elevation && (r = this.transform.elevation.exaggeration() !== this._averageElevationExaggeration, this._averageElevationExaggeration = this.transform.elevation.exaggeration()), isNaN(o) ? o = 0 : this._averageElevationLastSampledAt = e1;
                        const n = Math.abs(t2 - o);
                        if (n > 1) {
                            if (this._isInitialLoad || r) return this._averageElevation.jumpTo(o), i(o);
                            this._averageElevation.easeTo(o, e1, 300);
                        } else if (n > 1e-4) return this._averageElevation.jumpTo(o), i(o);
                    }
                    return !!this._averageElevation.isEasing(e1) && i(this._averageElevation.getValue(e1));
                }
                _authenticate() {
                    e1.getMapSessionAPI(this._getMapId(), this._requestManager._skuToken, this._requestManager._customAccessToken, (t1)=>{
                        if (t1 && (t1.message === e1.AUTH_ERR_MSG || 401 === t1.status)) {
                            const t2 = this.painter.context.gl;
                            e1.storeAuthState(t2, !1), this._logoControl instanceof Jr && this._logoControl._updateLogo(), t2 && t2.clear(t2.DEPTH_BUFFER_BIT | t2.COLOR_BUFFER_BIT | t2.STENCIL_BUFFER_BIT), this._silenceAuthErrors || this.fire(new e1.ErrorEvent(new Error("A valid Mapbox access token is required to use Mapbox GL JS. To create an account or a new access token, visit https://account.mapbox.com/")));
                        }
                    }), e1.postMapLoadEvent(this._getMapId(), this._requestManager._skuToken, this._requestManager._customAccessToken, ()=>{});
                }
                _updateTerrain() {
                    this.painter.updateTerrain(this.style, this.isMoving() || this.isRotating() || this.isZooming());
                }
                _calculateSpeedIndex() {
                    const e1 = this.painter.canvasCopy(), t1 = this.painter.getCanvasCopiesAndTimestamps();
                    t1.timeStamps.push(performance.now());
                    const i = this.painter.context.gl, o = i.createFramebuffer();
                    function r(e1) {
                        i.framebufferTexture2D(i.FRAMEBUFFER, i.COLOR_ATTACHMENT0, i.TEXTURE_2D, e1, 0);
                        const t1 = new Uint8Array(i.drawingBufferWidth * i.drawingBufferHeight * 4);
                        return i.readPixels(0, 0, i.drawingBufferWidth, i.drawingBufferHeight, i.RGBA, i.UNSIGNED_BYTE, t1), t1;
                    }
                    return i.bindFramebuffer(i.FRAMEBUFFER, o), this._canvasPixelComparison(r(e1), t1.canvasCopies.map(r), t1.timeStamps);
                }
                _canvasPixelComparison(e1, t1, i) {
                    let o = i[1] - i[0];
                    const r = e1.length / 4;
                    for(let n = 0; n < t1.length; n++){
                        const a = t1[n];
                        let s = 0;
                        for(let t2 = 0; t2 < a.length; t2 += 4)a[t2] === e1[t2] && a[t2 + 1] === e1[t2 + 1] && a[t2 + 2] === e1[t2 + 2] && a[t2 + 3] === e1[t2 + 3] && (s += 1);
                        o += (i[n + 2] - i[n + 1]) * (1 - s / r);
                    }
                    return o;
                }
                remove() {
                    this._hash && this._hash.remove();
                    for (const e2 of this._controls)e2.onRemove(this);
                    this._controls = [], this._frame && (this._frame.cancel(), this._frame = null), this._renderTaskQueue.clear(), this._domRenderTaskQueue.clear(), this.style && this.style.destroy(), this.painter.destroy(), this.handlers && this.handlers.destroy(), this.handlers = void 0, this.setStyle(null), void 0 !== e1.window && (e1.window.removeEventListener("resize", this._onWindowResize, !1), e1.window.removeEventListener("orientationchange", this._onWindowResize, !1), e1.window.removeEventListener("webkitfullscreenchange", this._onWindowResize, !1), e1.window.removeEventListener("online", this._onWindowOnline, !1));
                    const t1 = this.painter.context.gl.getExtension("WEBGL_lose_context");
                    t1 && t1.loseContext(), this._canvas.removeEventListener("webglcontextlost", this._contextLost, !1), this._canvas.removeEventListener("webglcontextrestored", this._contextRestored, !1), hn(this._canvasContainer), hn(this._controlContainer), hn(this._missingCSSCanary), this._canvas = void 0, this._canvasContainer = void 0, this._controlContainer = void 0, this._missingCSSCanary = void 0, this._container.classList.remove("mapboxgl-map"), this._container.removeEventListener("scroll", this._onMapScroll, !1), e1.removeAuthState(this.painter.context.gl), this._removed = !0, this.fire(new e1.Event("remove"));
                }
                triggerRepaint() {
                    this._triggerFrame(!0);
                }
                _triggerFrame(t1) {
                    this._renderNextFrame = this._renderNextFrame || t1, this.style && !this._frame && (this._frame = e1.exported.frame((e1)=>{
                        const t1 = !!this._renderNextFrame;
                        this._frame = null, this._renderNextFrame = null, t1 && this._render(e1);
                    }));
                }
                _preloadTiles(t1) {
                    const i = this.style ? Object.values(this.style._sourceCaches) : [];
                    return e1.asyncAll(i, (e1, i)=>e1._preloadTiles(t1, i), ()=>{
                        this.triggerRepaint();
                    }), this;
                }
                _onWindowOnline() {
                    this._update();
                }
                _onWindowResize(e1) {
                    this._trackResize && this.resize({
                        originalEvent: e1
                    })._update();
                }
                get showTileBoundaries() {
                    return !!this._showTileBoundaries;
                }
                set showTileBoundaries(e1) {
                    this._showTileBoundaries !== e1 && (this._showTileBoundaries = e1, this._update());
                }
                get showTerrainWireframe() {
                    return !!this._showTerrainWireframe;
                }
                set showTerrainWireframe(e1) {
                    this._showTerrainWireframe !== e1 && (this._showTerrainWireframe = e1, this._update());
                }
                get speedIndexTiming() {
                    return !!this._speedIndexTiming;
                }
                set speedIndexTiming(e1) {
                    this._speedIndexTiming !== e1 && (this._speedIndexTiming = e1, this._update());
                }
                get showPadding() {
                    return !!this._showPadding;
                }
                set showPadding(e1) {
                    this._showPadding !== e1 && (this._showPadding = e1, this._update());
                }
                get showCollisionBoxes() {
                    return !!this._showCollisionBoxes;
                }
                set showCollisionBoxes(e1) {
                    this._showCollisionBoxes !== e1 && (this._showCollisionBoxes = e1, e1 ? this.style._generateCollisionBoxes() : this._update());
                }
                get showOverdrawInspector() {
                    return !!this._showOverdrawInspector;
                }
                set showOverdrawInspector(e1) {
                    this._showOverdrawInspector !== e1 && (this._showOverdrawInspector = e1, this._update());
                }
                get repaint() {
                    return !!this._repaint;
                }
                set repaint(e1) {
                    this._repaint !== e1 && (this._repaint = e1, this.triggerRepaint());
                }
                get vertices() {
                    return !!this._vertices;
                }
                set vertices(e1) {
                    this._vertices = e1, this._update();
                }
                get showTileAABBs() {
                    return !!this._showTileAABBs;
                }
                set showTileAABBs(e1) {
                    this._showTileAABBs !== e1 && (this._showTileAABBs = e1, e1 && this._update());
                }
                _setCacheLimits(t1, i) {
                    e1.setCacheLimits(t1, i);
                }
                get version() {
                    return e1.version;
                }
            },
            NavigationControl: class {
                constructor(t1){
                    this.options = e1.extend({}, _n, t1), this._container = n("div", "mapboxgl-ctrl mapboxgl-ctrl-group"), this._container.addEventListener("contextmenu", (e1)=>e1.preventDefault()), this.options.showZoom && (e1.bindAll([
                        "_setButtonTitle",
                        "_updateZoomButtons"
                    ], this), this._zoomInButton = this._createButton("mapboxgl-ctrl-zoom-in", (e1)=>{
                        this._map && this._map.zoomIn({}, {
                            originalEvent: e1
                        });
                    }), n("span", "mapboxgl-ctrl-icon", this._zoomInButton).setAttribute("aria-hidden", "true"), this._zoomOutButton = this._createButton("mapboxgl-ctrl-zoom-out", (e1)=>{
                        this._map && this._map.zoomOut({}, {
                            originalEvent: e1
                        });
                    }), n("span", "mapboxgl-ctrl-icon", this._zoomOutButton).setAttribute("aria-hidden", "true")), this.options.showCompass && (e1.bindAll([
                        "_rotateCompassArrow"
                    ], this), this._compass = this._createButton("mapboxgl-ctrl-compass", (e1)=>{
                        const t1 = this._map;
                        t1 && (this.options.visualizePitch ? t1.resetNorthPitch({}, {
                            originalEvent: e1
                        }) : t1.resetNorth({}, {
                            originalEvent: e1
                        }));
                    }), this._compassIcon = n("span", "mapboxgl-ctrl-icon", this._compass), this._compassIcon.setAttribute("aria-hidden", "true"));
                }
                _updateZoomButtons() {
                    const e1 = this._map;
                    if (!e1) return;
                    const t1 = e1.getZoom(), i = t1 === e1.getMaxZoom(), o = t1 === e1.getMinZoom();
                    this._zoomInButton.disabled = i, this._zoomOutButton.disabled = o, this._zoomInButton.setAttribute("aria-disabled", i.toString()), this._zoomOutButton.setAttribute("aria-disabled", o.toString());
                }
                _rotateCompassArrow() {
                    const e1 = this._map;
                    if (!e1) return;
                    const t1 = this.options.visualizePitch ? `scale(${1 / Math.pow(Math.cos(e1.transform.pitch * (Math.PI / 180)), .5)}) rotateX(${e1.transform.pitch}deg) rotateZ(${e1.transform.angle * (180 / Math.PI)}deg)` : `rotate(${e1.transform.angle * (180 / Math.PI)}deg)`;
                    e1._requestDomTask(()=>{
                        this._compassIcon && (this._compassIcon.style.transform = t1);
                    });
                }
                onAdd(e1) {
                    return this._map = e1, this.options.showZoom && (this._setButtonTitle(this._zoomInButton, "ZoomIn"), this._setButtonTitle(this._zoomOutButton, "ZoomOut"), e1.on("zoom", this._updateZoomButtons), this._updateZoomButtons()), this.options.showCompass && (this._setButtonTitle(this._compass, "ResetBearing"), this.options.visualizePitch && e1.on("pitch", this._rotateCompassArrow), e1.on("rotate", this._rotateCompassArrow), this._rotateCompassArrow(), this._handler = new un(e1, this._compass, this.options.visualizePitch)), this._container;
                }
                onRemove() {
                    const e1 = this._map;
                    e1 && (this._container.remove(), this.options.showZoom && e1.off("zoom", this._updateZoomButtons), this.options.showCompass && (this.options.visualizePitch && e1.off("pitch", this._rotateCompassArrow), e1.off("rotate", this._rotateCompassArrow), this._handler && this._handler.off(), this._handler = void 0), this._map = void 0);
                }
                _createButton(e1, t1) {
                    const i = n("button", e1, this._container);
                    return i.type = "button", i.addEventListener("click", t1), i;
                }
                _setButtonTitle(e1, t1) {
                    if (!this._map) return;
                    const i = this._map._getUIString(`NavigationControl.${t1}`);
                    e1.setAttribute("aria-label", i), e1.firstElementChild && e1.firstElementChild.setAttribute("title", i);
                }
            },
            GeolocateControl: class extends e1.Evented {
                constructor(t1){
                    super(), this.options = e1.extend({
                        geolocation: e1.window.navigator.geolocation
                    }, dn, t1), e1.bindAll([
                        "_onSuccess",
                        "_onError",
                        "_onZoom",
                        "_finish",
                        "_setupUI",
                        "_updateCamera",
                        "_updateMarker",
                        "_updateMarkerRotation",
                        "_onDeviceOrientation"
                    ], this), this._updateMarkerRotationThrottled = Jo(this._updateMarkerRotation, 20), this._numberOfWatches = 0;
                }
                onAdd(e1) {
                    return this._map = e1, this._container = n("div", "mapboxgl-ctrl mapboxgl-ctrl-group"), this._checkGeolocationSupport(this._setupUI), this._container;
                }
                onRemove() {
                    void 0 !== this._geolocationWatchID && (this.options.geolocation.clearWatch(this._geolocationWatchID), this._geolocationWatchID = void 0), this.options.showUserLocation && this._userLocationDotMarker && this._userLocationDotMarker.remove(), this.options.showAccuracyCircle && this._accuracyCircleMarker && this._accuracyCircleMarker.remove(), this._container.remove(), this._map.off("zoom", this._onZoom), this._map = void 0, this._numberOfWatches = 0, this._noTimeout = !1;
                }
                _checkGeolocationSupport(t1) {
                    const i = (e1 = !!this.options.geolocation)=>{
                        this._supportsGeolocation = e1, t1(e1);
                    };
                    void 0 !== this._supportsGeolocation ? t1(this._supportsGeolocation) : void 0 !== e1.window.navigator.permissions ? e1.window.navigator.permissions.query({
                        name: "geolocation"
                    }).then((e1)=>i("denied" !== e1.state)).catch(()=>i()) : i();
                }
                _isOutOfMapMaxBounds(e1) {
                    const t1 = this._map.getMaxBounds(), i = e1.coords;
                    return !!t1 && (i.longitude < t1.getWest() || i.longitude > t1.getEast() || i.latitude < t1.getSouth() || i.latitude > t1.getNorth());
                }
                _setErrorState() {
                    switch(this._watchState){
                        case "WAITING_ACTIVE":
                            this._watchState = "ACTIVE_ERROR", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error");
                            break;
                        case "ACTIVE_LOCK":
                            this._watchState = "ACTIVE_ERROR", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting");
                            break;
                        case "BACKGROUND":
                            this._watchState = "BACKGROUND_ERROR", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting");
                    }
                }
                _onSuccess(t1) {
                    if (this._map) {
                        if (this._isOutOfMapMaxBounds(t1)) return this._setErrorState(), this.fire(new e1.Event("outofmaxbounds", t1)), this._updateMarker(), void this._finish();
                        if (this.options.trackUserLocation) switch(this._lastKnownPosition = t1, this._watchState){
                            case "WAITING_ACTIVE":
                            case "ACTIVE_LOCK":
                            case "ACTIVE_ERROR":
                                this._watchState = "ACTIVE_LOCK", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");
                                break;
                            case "BACKGROUND":
                            case "BACKGROUND_ERROR":
                                this._watchState = "BACKGROUND", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background");
                        }
                        this.options.showUserLocation && "OFF" !== this._watchState && this._updateMarker(t1), this.options.trackUserLocation && "ACTIVE_LOCK" !== this._watchState || this._updateCamera(t1), this.options.showUserLocation && this._dotElement.classList.remove("mapboxgl-user-location-dot-stale"), this.fire(new e1.Event("geolocate", t1)), this._finish();
                    }
                }
                _updateCamera(t1) {
                    const i = new e1.LngLat(t1.coords.longitude, t1.coords.latitude), o = t1.coords.accuracy, r = this._map.getBearing(), n = e1.extend({
                        bearing: r
                    }, this.options.fitBoundsOptions);
                    this._map.fitBounds(i.toBounds(o), n, {
                        geolocateSource: !0
                    });
                }
                _updateMarker(t1) {
                    if (t1) {
                        const i = new e1.LngLat(t1.coords.longitude, t1.coords.latitude);
                        this._accuracyCircleMarker.setLngLat(i).addTo(this._map), this._userLocationDotMarker.setLngLat(i).addTo(this._map), this._accuracy = t1.coords.accuracy, this.options.showUserLocation && this.options.showAccuracyCircle && this._updateCircleRadius();
                    } else this._userLocationDotMarker.remove(), this._accuracyCircleMarker.remove();
                }
                _updateCircleRadius() {
                    const t1 = this._map.transform, i = e1.mercatorZfromAltitude(1, t1._center.lat) * t1.worldSize, o = Math.ceil(2 * this._accuracy * i);
                    this._circleElement.style.width = `${o}px`, this._circleElement.style.height = `${o}px`;
                }
                _onZoom() {
                    this.options.showUserLocation && this.options.showAccuracyCircle && this._updateCircleRadius();
                }
                _updateMarkerRotation() {
                    this._userLocationDotMarker && "number" == typeof this._heading ? (this._userLocationDotMarker.setRotation(this._heading), this._dotElement.classList.add("mapboxgl-user-location-show-heading")) : (this._dotElement.classList.remove("mapboxgl-user-location-show-heading"), this._userLocationDotMarker.setRotation(0));
                }
                _onError(t1) {
                    if (this._map) {
                        if (this.options.trackUserLocation) {
                            if (1 === t1.code) {
                                this._watchState = "OFF", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.disabled = !0;
                                const e2 = this._map._getUIString("GeolocateControl.LocationNotAvailable");
                                this._geolocateButton.setAttribute("aria-label", e2), this._geolocateButton.firstElementChild && this._geolocateButton.firstElementChild.setAttribute("title", e2), void 0 !== this._geolocationWatchID && this._clearWatch();
                            } else {
                                if (3 === t1.code && this._noTimeout) return;
                                this._setErrorState();
                            }
                        }
                        "OFF" !== this._watchState && this.options.showUserLocation && this._dotElement.classList.add("mapboxgl-user-location-dot-stale"), this.fire(new e1.Event("error", t1)), this._finish();
                    }
                }
                _finish() {
                    this._timeoutId && clearTimeout(this._timeoutId), this._timeoutId = void 0;
                }
                _setupUI(t1) {
                    if (this._container.addEventListener("contextmenu", (e1)=>e1.preventDefault()), this._geolocateButton = n("button", "mapboxgl-ctrl-geolocate", this._container), n("span", "mapboxgl-ctrl-icon", this._geolocateButton).setAttribute("aria-hidden", "true"), this._geolocateButton.type = "button", !1 === t1) {
                        e1.warnOnce("Geolocation support is not available so the GeolocateControl will be disabled.");
                        const t2 = this._map._getUIString("GeolocateControl.LocationNotAvailable");
                        this._geolocateButton.disabled = !0, this._geolocateButton.setAttribute("aria-label", t2), this._geolocateButton.firstElementChild && this._geolocateButton.firstElementChild.setAttribute("title", t2);
                    } else {
                        const e2 = this._map._getUIString("GeolocateControl.FindMyLocation");
                        this._geolocateButton.setAttribute("aria-label", e2), this._geolocateButton.firstElementChild && this._geolocateButton.firstElementChild.setAttribute("title", e2);
                    }
                    this.options.trackUserLocation && (this._geolocateButton.setAttribute("aria-pressed", "false"), this._watchState = "OFF"), this.options.showUserLocation && (this._dotElement = n("div", "mapboxgl-user-location"), this._dotElement.appendChild(n("div", "mapboxgl-user-location-dot")), this._dotElement.appendChild(n("div", "mapboxgl-user-location-heading")), this._userLocationDotMarker = new on({
                        element: this._dotElement,
                        rotationAlignment: "map",
                        pitchAlignment: "map"
                    }), this._circleElement = n("div", "mapboxgl-user-location-accuracy-circle"), this._accuracyCircleMarker = new on({
                        element: this._circleElement,
                        pitchAlignment: "map"
                    }), this.options.trackUserLocation && (this._watchState = "OFF"), this._map.on("zoom", this._onZoom)), this._geolocateButton.addEventListener("click", this.trigger.bind(this)), this._setup = !0, this.options.trackUserLocation && this._map.on("movestart", (t1)=>{
                        t1.geolocateSource || "ACTIVE_LOCK" !== this._watchState || t1.originalEvent && "resize" === t1.originalEvent.type || (this._watchState = "BACKGROUND", this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this.fire(new e1.Event("trackuserlocationend")));
                    });
                }
                _onDeviceOrientation(e1) {
                    this._userLocationDotMarker && (e1.webkitCompassHeading ? this._heading = e1.webkitCompassHeading : !0 === e1.absolute && (this._heading = -1 * e1.alpha), this._updateMarkerRotationThrottled());
                }
                trigger() {
                    if (!this._setup) return e1.warnOnce("Geolocate control triggered before added to a map"), !1;
                    if (this.options.trackUserLocation) {
                        switch(this._watchState){
                            case "OFF":
                                this._watchState = "WAITING_ACTIVE", this.fire(new e1.Event("trackuserlocationstart"));
                                break;
                            case "WAITING_ACTIVE":
                            case "ACTIVE_LOCK":
                            case "ACTIVE_ERROR":
                            case "BACKGROUND_ERROR":
                                this._numberOfWatches--, this._noTimeout = !1, this._watchState = "OFF", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background-error"), this.fire(new e1.Event("trackuserlocationend"));
                                break;
                            case "BACKGROUND":
                                this._watchState = "ACTIVE_LOCK", this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-background"), this._lastKnownPosition && this._updateCamera(this._lastKnownPosition), this.fire(new e1.Event("trackuserlocationstart"));
                        }
                        switch(this._watchState){
                            case "WAITING_ACTIVE":
                                this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");
                                break;
                            case "ACTIVE_LOCK":
                                this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active");
                                break;
                            case "ACTIVE_ERROR":
                                this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-active-error");
                                break;
                            case "BACKGROUND":
                                this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background");
                                break;
                            case "BACKGROUND_ERROR":
                                this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-background-error");
                        }
                        if ("OFF" === this._watchState && void 0 !== this._geolocationWatchID) this._clearWatch();
                        else if (void 0 === this._geolocationWatchID) {
                            let e2;
                            this._geolocateButton.classList.add("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.setAttribute("aria-pressed", "true"), this._numberOfWatches++, this._numberOfWatches > 1 ? (e2 = {
                                maximumAge: 6e5,
                                timeout: 0
                            }, this._noTimeout = !0) : (e2 = this.options.positionOptions, this._noTimeout = !1), this._geolocationWatchID = this.options.geolocation.watchPosition(this._onSuccess, this._onError, e2), this.options.showUserHeading && this._addDeviceOrientationListener();
                        }
                    } else this.options.geolocation.getCurrentPosition(this._onSuccess, this._onError, this.options.positionOptions), this._timeoutId = setTimeout(this._finish, 1e4);
                    return !0;
                }
                _addDeviceOrientationListener() {
                    const t1 = ()=>{
                        e1.window.addEventListener("ondeviceorientationabsolute" in e1.window ? "deviceorientationabsolute" : "deviceorientation", this._onDeviceOrientation);
                    };
                    void 0 !== e1.window.DeviceMotionEvent && "function" == typeof e1.window.DeviceMotionEvent.requestPermission ? DeviceOrientationEvent.requestPermission().then((e1)=>{
                        "granted" === e1 && t1();
                    }).catch(console.error) : t1();
                }
                _clearWatch() {
                    this.options.geolocation.clearWatch(this._geolocationWatchID), e1.window.removeEventListener("deviceorientation", this._onDeviceOrientation), e1.window.removeEventListener("deviceorientationabsolute", this._onDeviceOrientation), this._geolocationWatchID = void 0, this._geolocateButton.classList.remove("mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.setAttribute("aria-pressed", "false"), this.options.showUserLocation && this._updateMarker(null);
                }
            },
            AttributionControl: Kr,
            ScaleControl: class {
                constructor(t1){
                    this.options = e1.extend({}, pn, t1), function() {
                        try {
                            return new Intl.NumberFormat("en", {
                                style: "unit",
                                unitDisplay: "narrow",
                                unit: "meter"
                            }), !0;
                        } catch (e1) {
                            return !1;
                        }
                    }() || (this._setScale = mn.bind(this)), e1.bindAll([
                        "_update",
                        "_setScale",
                        "setUnit"
                    ], this);
                }
                getDefaultPosition() {
                    return "bottom-left";
                }
                _update() {
                    const e1 = this.options.maxWidth || 100, t1 = this._map, i = t1._containerHeight / 2, o = t1._containerWidth / 2 - e1 / 2, r = t1.unproject([
                        o,
                        i
                    ]), n = t1.unproject([
                        o + e1,
                        i
                    ]), a = r.distanceTo(n);
                    if ("imperial" === this.options.unit) {
                        const t2 = 3.2808 * a;
                        t2 > 5280 ? this._setScale(e1, t2 / 5280, "mile") : this._setScale(e1, t2, "foot");
                    } else "nautical" === this.options.unit ? this._setScale(e1, a / 1852, "nautical-mile") : a >= 1e3 ? this._setScale(e1, a / 1e3, "kilometer") : this._setScale(e1, a, "meter");
                }
                _setScale(e1, t1, i) {
                    const o = fn(t1), r = o / t1;
                    this._map._requestDomTask(()=>{
                        this._container.style.width = e1 * r + "px", this._container.innerHTML = "nautical-mile" !== i ? new Intl.NumberFormat(this._language, {
                            style: "unit",
                            unitDisplay: "narrow",
                            unit: i
                        }).format(o) : `${o}&nbsp;nm`;
                    });
                }
                onAdd(e1) {
                    return this._map = e1, this._language = e1.getLanguage(), this._container = n("div", "mapboxgl-ctrl mapboxgl-ctrl-scale", e1.getContainer()), this._container.dir = "auto", this._map.on("move", this._update), this._update(), this._container;
                }
                onRemove() {
                    this._container.remove(), this._map.off("move", this._update), this._map = void 0;
                }
                _setLanguage(e1) {
                    this._language = e1, this._update();
                }
                setUnit(e1) {
                    this.options.unit = e1, this._update();
                }
            },
            FullscreenControl: class {
                constructor(t1){
                    this._fullscreen = !1, t1 && t1.container && (t1.container instanceof e1.window.HTMLElement ? this._container = t1.container : e1.warnOnce("Full screen control 'container' must be a DOM element.")), e1.bindAll([
                        "_onClickFullscreen",
                        "_changeIcon"
                    ], this), "onfullscreenchange" in e1.window.document ? this._fullscreenchange = "fullscreenchange" : "onwebkitfullscreenchange" in e1.window.document && (this._fullscreenchange = "webkitfullscreenchange");
                }
                onAdd(t1) {
                    return this._map = t1, this._container || (this._container = this._map.getContainer()), this._controlContainer = n("div", "mapboxgl-ctrl mapboxgl-ctrl-group"), this._checkFullscreenSupport() ? this._setupUI() : (this._controlContainer.style.display = "none", e1.warnOnce("This device does not support fullscreen mode.")), this._controlContainer;
                }
                onRemove() {
                    this._controlContainer.remove(), this._map = null, e1.window.document.removeEventListener(this._fullscreenchange, this._changeIcon);
                }
                _checkFullscreenSupport() {
                    return !(!e1.window.document.fullscreenEnabled && !e1.window.document.webkitFullscreenEnabled);
                }
                _setupUI() {
                    const t1 = this._fullscreenButton = n("button", "mapboxgl-ctrl-fullscreen", this._controlContainer);
                    n("span", "mapboxgl-ctrl-icon", t1).setAttribute("aria-hidden", "true"), t1.type = "button", this._updateTitle(), this._fullscreenButton.addEventListener("click", this._onClickFullscreen), e1.window.document.addEventListener(this._fullscreenchange, this._changeIcon);
                }
                _updateTitle() {
                    const e1 = this._getTitle();
                    this._fullscreenButton.setAttribute("aria-label", e1), this._fullscreenButton.firstElementChild && this._fullscreenButton.firstElementChild.setAttribute("title", e1);
                }
                _getTitle() {
                    return this._map._getUIString(this._isFullscreen() ? "FullscreenControl.Exit" : "FullscreenControl.Enter");
                }
                _isFullscreen() {
                    return this._fullscreen;
                }
                _changeIcon() {
                    (e1.window.document.fullscreenElement || e1.window.document.webkitFullscreenElement) === this._container !== this._fullscreen && (this._fullscreen = !this._fullscreen, this._fullscreenButton.classList.toggle("mapboxgl-ctrl-shrink"), this._fullscreenButton.classList.toggle("mapboxgl-ctrl-fullscreen"), this._updateTitle());
                }
                _onClickFullscreen() {
                    this._isFullscreen() ? e1.window.document.exitFullscreen ? e1.window.document.exitFullscreen() : e1.window.document.webkitCancelFullScreen && e1.window.document.webkitCancelFullScreen() : this._container.requestFullscreen ? this._container.requestFullscreen() : this._container.webkitRequestFullscreen && this._container.webkitRequestFullscreen();
                }
            },
            Popup: class extends e1.Evented {
                constructor(t1){
                    super(), this.options = e1.extend(Object.create(rn), t1), e1.bindAll([
                        "_update",
                        "_onClose",
                        "remove",
                        "_onMouseEvent"
                    ], this), this._classList = new Set(t1 && t1.className ? t1.className.trim().split(/\s+/) : []);
                }
                addTo(t1) {
                    return this._map && this.remove(), this._map = t1, this.options.closeOnClick && t1.on("preclick", this._onClose), this.options.closeOnMove && t1.on("move", this._onClose), t1.on("remove", this.remove), this._update(), t1._addPopup(this), this._focusFirstElement(), this._trackPointer ? (t1.on("mousemove", this._onMouseEvent), t1.on("mouseup", this._onMouseEvent), t1._canvasContainer.classList.add("mapboxgl-track-pointer")) : t1.on("move", this._update), this.fire(new e1.Event("open")), this;
                }
                isOpen() {
                    return !!this._map;
                }
                remove() {
                    this._content && this._content.remove(), this._container && (this._container.remove(), this._container = void 0);
                    const t1 = this._map;
                    return t1 && (t1.off("move", this._update), t1.off("move", this._onClose), t1.off("preclick", this._onClose), t1.off("click", this._onClose), t1.off("remove", this.remove), t1.off("mousemove", this._onMouseEvent), t1.off("mouseup", this._onMouseEvent), t1.off("drag", this._onMouseEvent), t1._canvasContainer && t1._canvasContainer.classList.remove("mapboxgl-track-pointer"), t1._removePopup(this), this._map = void 0), this.fire(new e1.Event("close")), this;
                }
                getLngLat() {
                    return this._lngLat;
                }
                setLngLat(t1) {
                    this._lngLat = e1.LngLat.convert(t1), this._pos = null, this._trackPointer = !1, this._update();
                    const i = this._map;
                    return i && (i.on("move", this._update), i.off("mousemove", this._onMouseEvent), i._canvasContainer.classList.remove("mapboxgl-track-pointer")), this;
                }
                trackPointer() {
                    this._trackPointer = !0, this._pos = null, this._update();
                    const e1 = this._map;
                    return e1 && (e1.off("move", this._update), e1.on("mousemove", this._onMouseEvent), e1.on("drag", this._onMouseEvent), e1._canvasContainer.classList.add("mapboxgl-track-pointer")), this;
                }
                getElement() {
                    return this._container;
                }
                setText(t1) {
                    return this.setDOMContent(e1.window.document.createTextNode(t1));
                }
                setHTML(t1) {
                    const i = e1.window.document.createDocumentFragment(), o = e1.window.document.createElement("body");
                    let r;
                    for(o.innerHTML = t1; r = o.firstChild, r;)i.appendChild(r);
                    return this.setDOMContent(i);
                }
                getMaxWidth() {
                    return this._container && this._container.style.maxWidth;
                }
                setMaxWidth(e1) {
                    return this.options.maxWidth = e1, this._update(), this;
                }
                setDOMContent(e1) {
                    let t1 = this._content;
                    if (t1) for(; t1.hasChildNodes();)t1.firstChild && t1.removeChild(t1.firstChild);
                    else t1 = this._content = n("div", "mapboxgl-popup-content", this._container || void 0);
                    if (t1.appendChild(e1), this.options.closeButton) {
                        const e2 = this._closeButton = n("button", "mapboxgl-popup-close-button", t1);
                        e2.type = "button", e2.setAttribute("aria-label", "Close popup"), e2.setAttribute("aria-hidden", "true"), e2.innerHTML = "&#215;", e2.addEventListener("click", this._onClose);
                    }
                    return this._update(), this._focusFirstElement(), this;
                }
                addClassName(e1) {
                    return this._classList.add(e1), this._updateClassList(), this;
                }
                removeClassName(e1) {
                    return this._classList.delete(e1), this._updateClassList(), this;
                }
                setOffset(e1) {
                    return this.options.offset = e1, this._update(), this;
                }
                toggleClassName(e1) {
                    let t1;
                    return this._classList.delete(e1) ? t1 = !1 : (this._classList.add(e1), t1 = !0), this._updateClassList(), t1;
                }
                _onMouseEvent(e1) {
                    this._update(e1.point);
                }
                _getAnchor(e1) {
                    if (this.options.anchor) return this.options.anchor;
                    const t1 = this._map, i = this._container, o = this._pos;
                    if (!t1 || !i || !o) return "bottom";
                    const r = i.offsetWidth, n = i.offsetHeight, a = o.x < r / 2, s = o.x > t1.transform.width - r / 2;
                    if (o.y + e1 < n) return a ? "top-left" : s ? "top-right" : "top";
                    if (o.y > t1.transform.height - n) {
                        if (a) return "bottom-left";
                        if (s) return "bottom-right";
                    }
                    return a ? "left" : s ? "right" : "bottom";
                }
                _updateClassList() {
                    const e1 = this._container;
                    if (!e1) return;
                    const t1 = [
                        ...this._classList
                    ];
                    t1.push("mapboxgl-popup"), this._anchor && t1.push(`mapboxgl-popup-anchor-${this._anchor}`), this._trackPointer && t1.push("mapboxgl-popup-track-pointer"), e1.className = t1.join(" ");
                }
                _update(t1) {
                    const i = this._map, o = this._content;
                    if (!i || !this._lngLat && !this._trackPointer || !o) return;
                    let r = this._container;
                    if (r || (r = this._container = n("div", "mapboxgl-popup", i.getContainer()), this._tip = n("div", "mapboxgl-popup-tip", r), r.appendChild(o)), this.options.maxWidth && r.style.maxWidth !== this.options.maxWidth && (r.style.maxWidth = this.options.maxWidth), i.transform.renderWorldCopies && !this._trackPointer && (this._lngLat = en(this._lngLat, this._pos, i.transform)), !this._trackPointer || t1) {
                        const e2 = this._pos = this._trackPointer && t1 ? t1 : i.project(this._lngLat), o1 = an(this.options.offset), r1 = this._anchor = this._getAnchor(o1.y), n1 = an(this.options.offset, r1), a = e2.add(n1).round();
                        i._requestDomTask(()=>{
                            this._container && r1 && (this._container.style.transform = `${tn[r1]} translate(${a.x}px,${a.y}px)`);
                        });
                    }
                    if (!this._marker && i._showingGlobe()) {
                        const t2 = e1.isLngLatBehindGlobe(i.transform, this._lngLat) ? 0 : 1;
                        this._setOpacity(t2);
                    }
                    this._updateClassList();
                }
                _focusFirstElement() {
                    if (!this.options.focusAfterOpen || !this._container) return;
                    const e1 = this._container.querySelector(nn);
                    e1 && e1.focus();
                }
                _onClose() {
                    this.remove();
                }
                _setOpacity(e1) {
                    this._container && (this._container.style.opacity = `${e1}`), this._content && (this._content.style.pointerEvents = e1 ? "auto" : "none");
                }
            },
            Marker: on,
            Style: ei,
            LngLat: e1.LngLat,
            LngLatBounds: e1.LngLatBounds,
            Point: e1.pointGeometry,
            MercatorCoordinate: e1.MercatorCoordinate,
            FreeCameraOptions: Zo,
            Evented: e1.Evented,
            config: e1.config,
            prewarm: function() {
                Ge().acquire(Fe);
            },
            clearPrewarmedResources: function() {
                const e1 = Ne;
                e1 && (e1.isPreloaded() && 1 === e1.numActive() ? (e1.release(Fe), Ne = null) : console.warn("Could not clear WebWorkers since there are active Map instances that still reference it. The pre-warmed WebWorker pool can only be cleared when all map instances have been removed with map.remove()"));
            },
            get accessToken () {
                return e1.config.ACCESS_TOKEN;
            },
            set accessToken (t){
                e1.config.ACCESS_TOKEN = t;
            },
            get baseApiUrl () {
                return e1.config.API_URL;
            },
            set baseApiUrl (t){
                e1.config.API_URL = t;
            },
            get workerCount () {
                return Ue.workerCount;
            },
            set workerCount (e){
                Ue.workerCount = e;
            },
            get maxParallelImageRequests () {
                return e1.config.MAX_PARALLEL_IMAGE_REQUESTS;
            },
            set maxParallelImageRequests (t){
                e1.config.MAX_PARALLEL_IMAGE_REQUESTS = t;
            },
            clearStorage (t1) {
                e1.clearTileCache(t1);
            },
            workerUrl: "",
            workerClass: null,
            setNow: e1.exported.setNow,
            restoreNow: e1.exported.restoreNow
        };
        return gn;
    });
    //
    var mapboxgl$1 = mapboxgl;
    return mapboxgl$1;
});

},{}],"9Poxg":[function(require,module,exports) {
"use strict";
/**
 * Based off of [the offical Google document](https://developers.google.com/maps/documentation/utilities/polylinealgorithm)
 *
 * Some parts from [this implementation](http://facstaff.unca.edu/mcmcclur/GoogleMaps/EncodePolyline/PolylineEncoder.js)
 * by [Mark McClure](http://facstaff.unca.edu/mcmcclur/)
 *
 * @module polyline
 */ var polyline = {};
function py2_round(value) {
    // Google's polyline algorithm uses the same rounding strategy as Python 2, which is different from JS for negative values
    return Math.floor(Math.abs(value) + 0.5) * (value >= 0 ? 1 : -1);
}
function encode(current, previous, factor) {
    current = py2_round(current * factor);
    previous = py2_round(previous * factor);
    var coordinate = current - previous;
    coordinate <<= 1;
    if (current - previous < 0) coordinate = ~coordinate;
    var output = "";
    while(coordinate >= 0x20){
        output += String.fromCharCode((0x20 | coordinate & 0x1f) + 63);
        coordinate >>= 5;
    }
    output += String.fromCharCode(coordinate + 63);
    return output;
}
/**
 * Decodes to a [latitude, longitude] coordinates array.
 *
 * This is adapted from the implementation in Project-OSRM.
 *
 * @param {String} str
 * @param {Number} precision
 * @returns {Array}
 *
 * @see https://github.com/Project-OSRM/osrm-frontend/blob/master/WebContent/routing/OSRM.RoutingGeometry.js
 */ polyline.decode = function(str, precision) {
    var index = 0, lat = 0, lng = 0, coordinates = [], shift = 0, result = 0, byte = null, latitude_change, longitude_change, factor = Math.pow(10, Number.isInteger(precision) ? precision : 5);
    // Coordinates have variable length when encoded, so just keep
    // track of whether we've hit the end of the string. In each
    // loop iteration, a single coordinate is decoded.
    while(index < str.length){
        // Reset shift, result, and byte
        byte = null;
        shift = 0;
        result = 0;
        do {
            byte = str.charCodeAt(index++) - 63;
            result |= (byte & 0x1f) << shift;
            shift += 5;
        }while (byte >= 0x20);
        latitude_change = result & 1 ? ~(result >> 1) : result >> 1;
        shift = result = 0;
        do {
            byte = str.charCodeAt(index++) - 63;
            result |= (byte & 0x1f) << shift;
            shift += 5;
        }while (byte >= 0x20);
        longitude_change = result & 1 ? ~(result >> 1) : result >> 1;
        lat += latitude_change;
        lng += longitude_change;
        coordinates.push([
            lat / factor,
            lng / factor
        ]);
    }
    return coordinates;
};
/**
 * Encodes the given [latitude, longitude] coordinates array.
 *
 * @param {Array.<Array.<Number>>} coordinates
 * @param {Number} precision
 * @returns {String}
 */ polyline.encode = function(coordinates, precision) {
    if (!coordinates.length) return "";
    var factor = Math.pow(10, Number.isInteger(precision) ? precision : 5), output = encode(coordinates[0][0], 0, factor) + encode(coordinates[0][1], 0, factor);
    for(var i = 1; i < coordinates.length; i++){
        var a = coordinates[i], b = coordinates[i - 1];
        output += encode(a[0], b[0], factor);
        output += encode(a[1], b[1], factor);
    }
    return output;
};
function flipped(coords) {
    var flipped = [];
    for(var i = 0; i < coords.length; i++){
        var coord = coords[i].slice();
        flipped.push([
            coord[1],
            coord[0]
        ]);
    }
    return flipped;
}
/**
 * Encodes a GeoJSON LineString feature/geometry.
 *
 * @param {Object} geojson
 * @param {Number} precision
 * @returns {String}
 */ polyline.fromGeoJSON = function(geojson, precision) {
    if (geojson && geojson.type === "Feature") geojson = geojson.geometry;
    if (!geojson || geojson.type !== "LineString") throw new Error("Input must be a GeoJSON LineString");
    return polyline.encode(flipped(geojson.coordinates), precision);
};
/**
 * Decodes to a GeoJSON LineString geometry.
 *
 * @param {String} str
 * @param {Number} precision
 * @returns {Object}
 */ polyline.toGeoJSON = function(str, precision) {
    var coords = polyline.decode(str, precision);
    return {
        type: "LineString",
        coordinates: flipped(coords)
    };
};
if (module.exports) module.exports = polyline;

},{}],"4xnao":[function(require,module,exports) {
/**
 * Fuse.js v6.6.2 - Lightweight fuzzy-search (http://fusejs.io)
 *
 * Copyright (c) 2022 Kiro Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 */ var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "default", ()=>Fuse);
function isArray(value) {
    return !Array.isArray ? getTag(value) === "[object Array]" : Array.isArray(value);
}
// Adapted from: https://github.com/lodash/lodash/blob/master/.internal/baseToString.js
const INFINITY = 1 / 0;
function baseToString(value) {
    // Exit early for strings to avoid a performance hit in some environments.
    if (typeof value == "string") return value;
    let result = value + "";
    return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
function toString(value) {
    return value == null ? "" : baseToString(value);
}
function isString(value) {
    return typeof value === "string";
}
function isNumber(value) {
    return typeof value === "number";
}
// Adapted from: https://github.com/lodash/lodash/blob/master/isBoolean.js
function isBoolean(value) {
    return value === true || value === false || isObjectLike(value) && getTag(value) == "[object Boolean]";
}
function isObject(value) {
    return typeof value === "object";
}
// Checks if `value` is object-like.
function isObjectLike(value) {
    return isObject(value) && value !== null;
}
function isDefined(value) {
    return value !== undefined && value !== null;
}
function isBlank(value) {
    return !value.trim().length;
}
// Gets the `toStringTag` of `value`.
// Adapted from: https://github.com/lodash/lodash/blob/master/.internal/getTag.js
function getTag(value) {
    return value == null ? value === undefined ? "[object Undefined]" : "[object Null]" : Object.prototype.toString.call(value);
}
const EXTENDED_SEARCH_UNAVAILABLE = "Extended search is not available";
const INCORRECT_INDEX_TYPE = "Incorrect 'index' type";
const LOGICAL_SEARCH_INVALID_QUERY_FOR_KEY = (key)=>`Invalid value for key ${key}`;
const PATTERN_LENGTH_TOO_LARGE = (max)=>`Pattern length exceeds max of ${max}.`;
const MISSING_KEY_PROPERTY = (name)=>`Missing ${name} property in key`;
const INVALID_KEY_WEIGHT_VALUE = (key)=>`Property 'weight' in key '${key}' must be a positive integer`;
const hasOwn = Object.prototype.hasOwnProperty;
class KeyStore {
    constructor(keys){
        this._keys = [];
        this._keyMap = {};
        let totalWeight = 0;
        keys.forEach((key)=>{
            let obj = createKey(key);
            totalWeight += obj.weight;
            this._keys.push(obj);
            this._keyMap[obj.id] = obj;
            totalWeight += obj.weight;
        });
        // Normalize weights so that their sum is equal to 1
        this._keys.forEach((key)=>{
            key.weight /= totalWeight;
        });
    }
    get(keyId) {
        return this._keyMap[keyId];
    }
    keys() {
        return this._keys;
    }
    toJSON() {
        return JSON.stringify(this._keys);
    }
}
function createKey(key) {
    let path = null;
    let id = null;
    let src = null;
    let weight = 1;
    let getFn = null;
    if (isString(key) || isArray(key)) {
        src = key;
        path = createKeyPath(key);
        id = createKeyId(key);
    } else {
        if (!hasOwn.call(key, "name")) throw new Error(MISSING_KEY_PROPERTY("name"));
        const name = key.name;
        src = name;
        if (hasOwn.call(key, "weight")) {
            weight = key.weight;
            if (weight <= 0) throw new Error(INVALID_KEY_WEIGHT_VALUE(name));
        }
        path = createKeyPath(name);
        id = createKeyId(name);
        getFn = key.getFn;
    }
    return {
        path,
        id,
        weight,
        src,
        getFn
    };
}
function createKeyPath(key) {
    return isArray(key) ? key : key.split(".");
}
function createKeyId(key) {
    return isArray(key) ? key.join(".") : key;
}
function get(obj, path) {
    let list = [];
    let arr = false;
    const deepGet = (obj, path, index)=>{
        if (!isDefined(obj)) return;
        if (!path[index]) // If there's no path left, we've arrived at the object we care about.
        list.push(obj);
        else {
            let key = path[index];
            const value = obj[key];
            if (!isDefined(value)) return;
            // If we're at the last value in the path, and if it's a string/number/bool,
            // add it to the list
            if (index === path.length - 1 && (isString(value) || isNumber(value) || isBoolean(value))) list.push(toString(value));
            else if (isArray(value)) {
                arr = true;
                // Search each item in the array.
                for(let i = 0, len = value.length; i < len; i += 1)deepGet(value[i], path, index + 1);
            } else if (path.length) // An object. Recurse further.
            deepGet(value, path, index + 1);
        }
    };
    // Backwards compatibility (since path used to be a string)
    deepGet(obj, isString(path) ? path.split(".") : path, 0);
    return arr ? list : list[0];
}
const MatchOptions = {
    // Whether the matches should be included in the result set. When `true`, each record in the result
    // set will include the indices of the matched characters.
    // These can consequently be used for highlighting purposes.
    includeMatches: false,
    // When `true`, the matching function will continue to the end of a search pattern even if
    // a perfect match has already been located in the string.
    findAllMatches: false,
    // Minimum number of characters that must be matched before a result is considered a match
    minMatchCharLength: 1
};
const BasicOptions = {
    // When `true`, the algorithm continues searching to the end of the input even if a perfect
    // match is found before the end of the same input.
    isCaseSensitive: false,
    // When true, the matching function will continue to the end of a search pattern even if
    includeScore: false,
    // List of properties that will be searched. This also supports nested properties.
    keys: [],
    // Whether to sort the result list, by score
    shouldSort: true,
    // Default sort function: sort by ascending score, ascending index
    sortFn: (a, b)=>a.score === b.score ? a.idx < b.idx ? -1 : 1 : a.score < b.score ? -1 : 1
};
const FuzzyOptions = {
    // Approximately where in the text is the pattern expected to be found?
    location: 0,
    // At what point does the match algorithm give up. A threshold of '0.0' requires a perfect match
    // (of both letters and location), a threshold of '1.0' would match anything.
    threshold: 0.6,
    // Determines how close the match must be to the fuzzy location (specified above).
    // An exact letter match which is 'distance' characters away from the fuzzy location
    // would score as a complete mismatch. A distance of '0' requires the match be at
    // the exact location specified, a threshold of '1000' would require a perfect match
    // to be within 800 characters of the fuzzy location to be found using a 0.8 threshold.
    distance: 100
};
const AdvancedOptions = {
    // When `true`, it enables the use of unix-like search commands
    useExtendedSearch: false,
    // The get function to use when fetching an object's properties.
    // The default will search nested paths *ie foo.bar.baz*
    getFn: get,
    // When `true`, search will ignore `location` and `distance`, so it won't matter
    // where in the string the pattern appears.
    // More info: https://fusejs.io/concepts/scoring-theory.html#fuzziness-score
    ignoreLocation: false,
    // When `true`, the calculation for the relevance score (used for sorting) will
    // ignore the field-length norm.
    // More info: https://fusejs.io/concepts/scoring-theory.html#field-length-norm
    ignoreFieldNorm: false,
    // The weight to determine how much field length norm effects scoring.
    fieldNormWeight: 1
};
var Config = {
    ...BasicOptions,
    ...MatchOptions,
    ...FuzzyOptions,
    ...AdvancedOptions
};
const SPACE = /[^ ]+/g;
// Field-length norm: the shorter the field, the higher the weight.
// Set to 3 decimals to reduce index size.
function norm(weight = 1, mantissa = 3) {
    const cache = new Map();
    const m = Math.pow(10, mantissa);
    return {
        get (value) {
            const numTokens = value.match(SPACE).length;
            if (cache.has(numTokens)) return cache.get(numTokens);
            // Default function is 1/sqrt(x), weight makes that variable
            const norm = 1 / Math.pow(numTokens, 0.5 * weight);
            // In place of `toFixed(mantissa)`, for faster computation
            const n = parseFloat(Math.round(norm * m) / m);
            cache.set(numTokens, n);
            return n;
        },
        clear () {
            cache.clear();
        }
    };
}
class FuseIndex {
    constructor({ getFn =Config.getFn , fieldNormWeight =Config.fieldNormWeight  } = {}){
        this.norm = norm(fieldNormWeight, 3);
        this.getFn = getFn;
        this.isCreated = false;
        this.setIndexRecords();
    }
    setSources(docs = []) {
        this.docs = docs;
    }
    setIndexRecords(records = []) {
        this.records = records;
    }
    setKeys(keys = []) {
        this.keys = keys;
        this._keysMap = {};
        keys.forEach((key, idx)=>{
            this._keysMap[key.id] = idx;
        });
    }
    create() {
        if (this.isCreated || !this.docs.length) return;
        this.isCreated = true;
        // List is Array<String>
        if (isString(this.docs[0])) this.docs.forEach((doc, docIndex)=>{
            this._addString(doc, docIndex);
        });
        else // List is Array<Object>
        this.docs.forEach((doc, docIndex)=>{
            this._addObject(doc, docIndex);
        });
        this.norm.clear();
    }
    // Adds a doc to the end of the index
    add(doc) {
        const idx = this.size();
        if (isString(doc)) this._addString(doc, idx);
        else this._addObject(doc, idx);
    }
    // Removes the doc at the specified index of the index
    removeAt(idx) {
        this.records.splice(idx, 1);
        // Change ref index of every subsquent doc
        for(let i = idx, len = this.size(); i < len; i += 1)this.records[i].i -= 1;
    }
    getValueForItemAtKeyId(item, keyId) {
        return item[this._keysMap[keyId]];
    }
    size() {
        return this.records.length;
    }
    _addString(doc, docIndex) {
        if (!isDefined(doc) || isBlank(doc)) return;
        let record = {
            v: doc,
            i: docIndex,
            n: this.norm.get(doc)
        };
        this.records.push(record);
    }
    _addObject(doc, docIndex) {
        let record = {
            i: docIndex,
            $: {}
        };
        // Iterate over every key (i.e, path), and fetch the value at that key
        this.keys.forEach((key, keyIndex)=>{
            let value = key.getFn ? key.getFn(doc) : this.getFn(doc, key.path);
            if (!isDefined(value)) return;
            if (isArray(value)) {
                let subRecords = [];
                const stack = [
                    {
                        nestedArrIndex: -1,
                        value
                    }
                ];
                while(stack.length){
                    const { nestedArrIndex , value: value1  } = stack.pop();
                    if (!isDefined(value1)) continue;
                    if (isString(value1) && !isBlank(value1)) {
                        let subRecord = {
                            v: value1,
                            i: nestedArrIndex,
                            n: this.norm.get(value1)
                        };
                        subRecords.push(subRecord);
                    } else if (isArray(value1)) value1.forEach((item, k)=>{
                        stack.push({
                            nestedArrIndex: k,
                            value: item
                        });
                    });
                }
                record.$[keyIndex] = subRecords;
            } else if (isString(value) && !isBlank(value)) {
                let subRecord1 = {
                    v: value,
                    n: this.norm.get(value)
                };
                record.$[keyIndex] = subRecord1;
            }
        });
        this.records.push(record);
    }
    toJSON() {
        return {
            keys: this.keys,
            records: this.records
        };
    }
}
function createIndex(keys, docs, { getFn =Config.getFn , fieldNormWeight =Config.fieldNormWeight  } = {}) {
    const myIndex = new FuseIndex({
        getFn,
        fieldNormWeight
    });
    myIndex.setKeys(keys.map(createKey));
    myIndex.setSources(docs);
    myIndex.create();
    return myIndex;
}
function parseIndex(data, { getFn =Config.getFn , fieldNormWeight =Config.fieldNormWeight  } = {}) {
    const { keys , records  } = data;
    const myIndex = new FuseIndex({
        getFn,
        fieldNormWeight
    });
    myIndex.setKeys(keys);
    myIndex.setIndexRecords(records);
    return myIndex;
}
function computeScore$1(pattern, { errors =0 , currentLocation =0 , expectedLocation =0 , distance =Config.distance , ignoreLocation =Config.ignoreLocation  } = {}) {
    const accuracy = errors / pattern.length;
    if (ignoreLocation) return accuracy;
    const proximity = Math.abs(expectedLocation - currentLocation);
    if (!distance) // Dodge divide by zero error.
    return proximity ? 1.0 : accuracy;
    return accuracy + proximity / distance;
}
function convertMaskToIndices(matchmask = [], minMatchCharLength = Config.minMatchCharLength) {
    let indices = [];
    let start = -1;
    let end = -1;
    let i = 0;
    for(let len = matchmask.length; i < len; i += 1){
        let match = matchmask[i];
        if (match && start === -1) start = i;
        else if (!match && start !== -1) {
            end = i - 1;
            if (end - start + 1 >= minMatchCharLength) indices.push([
                start,
                end
            ]);
            start = -1;
        }
    }
    // (i-1 - start) + 1 => i - start
    if (matchmask[i - 1] && i - start >= minMatchCharLength) indices.push([
        start,
        i - 1
    ]);
    return indices;
}
// Machine word size
const MAX_BITS = 32;
function search(text, pattern, patternAlphabet, { location =Config.location , distance =Config.distance , threshold =Config.threshold , findAllMatches =Config.findAllMatches , minMatchCharLength =Config.minMatchCharLength , includeMatches =Config.includeMatches , ignoreLocation =Config.ignoreLocation  } = {}) {
    if (pattern.length > MAX_BITS) throw new Error(PATTERN_LENGTH_TOO_LARGE(MAX_BITS));
    const patternLen = pattern.length;
    // Set starting location at beginning text and initialize the alphabet.
    const textLen = text.length;
    // Handle the case when location > text.length
    const expectedLocation = Math.max(0, Math.min(location, textLen));
    // Highest score beyond which we give up.
    let currentThreshold = threshold;
    // Is there a nearby exact match? (speedup)
    let bestLocation = expectedLocation;
    // Performance: only computer matches when the minMatchCharLength > 1
    // OR if `includeMatches` is true.
    const computeMatches = minMatchCharLength > 1 || includeMatches;
    // A mask of the matches, used for building the indices
    const matchMask = computeMatches ? Array(textLen) : [];
    let index;
    // Get all exact matches, here for speed up
    while((index = text.indexOf(pattern, bestLocation)) > -1){
        let score = computeScore$1(pattern, {
            currentLocation: index,
            expectedLocation,
            distance,
            ignoreLocation
        });
        currentThreshold = Math.min(score, currentThreshold);
        bestLocation = index + patternLen;
        if (computeMatches) {
            let i = 0;
            while(i < patternLen){
                matchMask[index + i] = 1;
                i += 1;
            }
        }
    }
    // Reset the best location
    bestLocation = -1;
    let lastBitArr = [];
    let finalScore = 1;
    let binMax = patternLen + textLen;
    const mask = 1 << patternLen - 1;
    for(let i1 = 0; i1 < patternLen; i1 += 1){
        // Scan for the best match; each iteration allows for one more error.
        // Run a binary search to determine how far from the match location we can stray
        // at this error level.
        let binMin = 0;
        let binMid = binMax;
        while(binMin < binMid){
            const score1 = computeScore$1(pattern, {
                errors: i1,
                currentLocation: expectedLocation + binMid,
                expectedLocation,
                distance,
                ignoreLocation
            });
            if (score1 <= currentThreshold) binMin = binMid;
            else binMax = binMid;
            binMid = Math.floor((binMax - binMin) / 2 + binMin);
        }
        // Use the result from this iteration as the maximum for the next.
        binMax = binMid;
        let start = Math.max(1, expectedLocation - binMid + 1);
        let finish = findAllMatches ? textLen : Math.min(expectedLocation + binMid, textLen) + patternLen;
        // Initialize the bit array
        let bitArr = Array(finish + 2);
        bitArr[finish + 1] = (1 << i1) - 1;
        for(let j = finish; j >= start; j -= 1){
            let currentLocation = j - 1;
            let charMatch = patternAlphabet[text.charAt(currentLocation)];
            if (computeMatches) // Speed up: quick bool to int conversion (i.e, `charMatch ? 1 : 0`)
            matchMask[currentLocation] = +!!charMatch;
            // First pass: exact match
            bitArr[j] = (bitArr[j + 1] << 1 | 1) & charMatch;
            // Subsequent passes: fuzzy match
            if (i1) bitArr[j] |= (lastBitArr[j + 1] | lastBitArr[j]) << 1 | 1 | lastBitArr[j + 1];
            if (bitArr[j] & mask) {
                finalScore = computeScore$1(pattern, {
                    errors: i1,
                    currentLocation,
                    expectedLocation,
                    distance,
                    ignoreLocation
                });
                // This match will almost certainly be better than any existing match.
                // But check anyway.
                if (finalScore <= currentThreshold) {
                    // Indeed it is
                    currentThreshold = finalScore;
                    bestLocation = currentLocation;
                    // Already passed `loc`, downhill from here on in.
                    if (bestLocation <= expectedLocation) break;
                    // When passing `bestLocation`, don't exceed our current distance from `expectedLocation`.
                    start = Math.max(1, 2 * expectedLocation - bestLocation);
                }
            }
        }
        // No hope for a (better) match at greater error levels.
        const score2 = computeScore$1(pattern, {
            errors: i1 + 1,
            currentLocation: expectedLocation,
            expectedLocation,
            distance,
            ignoreLocation
        });
        if (score2 > currentThreshold) break;
        lastBitArr = bitArr;
    }
    const result = {
        isMatch: bestLocation >= 0,
        // Count exact matches (those with a score of 0) to be "almost" exact
        score: Math.max(0.001, finalScore)
    };
    if (computeMatches) {
        const indices = convertMaskToIndices(matchMask, minMatchCharLength);
        if (!indices.length) result.isMatch = false;
        else if (includeMatches) result.indices = indices;
    }
    return result;
}
function createPatternAlphabet(pattern) {
    let mask = {};
    for(let i = 0, len = pattern.length; i < len; i += 1){
        const char = pattern.charAt(i);
        mask[char] = (mask[char] || 0) | 1 << len - i - 1;
    }
    return mask;
}
class BitapSearch {
    constructor(pattern, { location =Config.location , threshold =Config.threshold , distance =Config.distance , includeMatches =Config.includeMatches , findAllMatches =Config.findAllMatches , minMatchCharLength =Config.minMatchCharLength , isCaseSensitive =Config.isCaseSensitive , ignoreLocation =Config.ignoreLocation  } = {}){
        this.options = {
            location,
            threshold,
            distance,
            includeMatches,
            findAllMatches,
            minMatchCharLength,
            isCaseSensitive,
            ignoreLocation
        };
        this.pattern = isCaseSensitive ? pattern : pattern.toLowerCase();
        this.chunks = [];
        if (!this.pattern.length) return;
        const addChunk = (pattern, startIndex)=>{
            this.chunks.push({
                pattern,
                alphabet: createPatternAlphabet(pattern),
                startIndex
            });
        };
        const len = this.pattern.length;
        if (len > MAX_BITS) {
            let i = 0;
            const remainder = len % MAX_BITS;
            const end = len - remainder;
            while(i < end){
                addChunk(this.pattern.substr(i, MAX_BITS), i);
                i += MAX_BITS;
            }
            if (remainder) {
                const startIndex = len - MAX_BITS;
                addChunk(this.pattern.substr(startIndex), startIndex);
            }
        } else addChunk(this.pattern, 0);
    }
    searchIn(text) {
        const { isCaseSensitive , includeMatches  } = this.options;
        if (!isCaseSensitive) text = text.toLowerCase();
        // Exact match
        if (this.pattern === text) {
            let result = {
                isMatch: true,
                score: 0
            };
            if (includeMatches) result.indices = [
                [
                    0,
                    text.length - 1
                ]
            ];
            return result;
        }
        // Otherwise, use Bitap algorithm
        const { location , distance , threshold , findAllMatches , minMatchCharLength , ignoreLocation  } = this.options;
        let allIndices = [];
        let totalScore = 0;
        let hasMatches = false;
        this.chunks.forEach(({ pattern , alphabet , startIndex  })=>{
            const { isMatch , score , indices  } = search(text, pattern, alphabet, {
                location: location + startIndex,
                distance,
                threshold,
                findAllMatches,
                minMatchCharLength,
                includeMatches,
                ignoreLocation
            });
            if (isMatch) hasMatches = true;
            totalScore += score;
            if (isMatch && indices) allIndices = [
                ...allIndices,
                ...indices
            ];
        });
        let result1 = {
            isMatch: hasMatches,
            score: hasMatches ? totalScore / this.chunks.length : 1
        };
        if (hasMatches && includeMatches) result1.indices = allIndices;
        return result1;
    }
}
class BaseMatch {
    constructor(pattern){
        this.pattern = pattern;
    }
    static isMultiMatch(pattern) {
        return getMatch(pattern, this.multiRegex);
    }
    static isSingleMatch(pattern) {
        return getMatch(pattern, this.singleRegex);
    }
    search() {}
}
function getMatch(pattern, exp) {
    const matches = pattern.match(exp);
    return matches ? matches[1] : null;
}
// Token: 'file
class ExactMatch extends BaseMatch {
    constructor(pattern){
        super(pattern);
    }
    static get type() {
        return "exact";
    }
    static get multiRegex() {
        return /^="(.*)"$/;
    }
    static get singleRegex() {
        return /^=(.*)$/;
    }
    search(text) {
        const isMatch = text === this.pattern;
        return {
            isMatch,
            score: isMatch ? 0 : 1,
            indices: [
                0,
                this.pattern.length - 1
            ]
        };
    }
}
// Token: !fire
class InverseExactMatch extends BaseMatch {
    constructor(pattern){
        super(pattern);
    }
    static get type() {
        return "inverse-exact";
    }
    static get multiRegex() {
        return /^!"(.*)"$/;
    }
    static get singleRegex() {
        return /^!(.*)$/;
    }
    search(text) {
        const index = text.indexOf(this.pattern);
        const isMatch = index === -1;
        return {
            isMatch,
            score: isMatch ? 0 : 1,
            indices: [
                0,
                text.length - 1
            ]
        };
    }
}
// Token: ^file
class PrefixExactMatch extends BaseMatch {
    constructor(pattern){
        super(pattern);
    }
    static get type() {
        return "prefix-exact";
    }
    static get multiRegex() {
        return /^\^"(.*)"$/;
    }
    static get singleRegex() {
        return /^\^(.*)$/;
    }
    search(text) {
        const isMatch = text.startsWith(this.pattern);
        return {
            isMatch,
            score: isMatch ? 0 : 1,
            indices: [
                0,
                this.pattern.length - 1
            ]
        };
    }
}
// Token: !^fire
class InversePrefixExactMatch extends BaseMatch {
    constructor(pattern){
        super(pattern);
    }
    static get type() {
        return "inverse-prefix-exact";
    }
    static get multiRegex() {
        return /^!\^"(.*)"$/;
    }
    static get singleRegex() {
        return /^!\^(.*)$/;
    }
    search(text) {
        const isMatch = !text.startsWith(this.pattern);
        return {
            isMatch,
            score: isMatch ? 0 : 1,
            indices: [
                0,
                text.length - 1
            ]
        };
    }
}
// Token: .file$
class SuffixExactMatch extends BaseMatch {
    constructor(pattern){
        super(pattern);
    }
    static get type() {
        return "suffix-exact";
    }
    static get multiRegex() {
        return /^"(.*)"\$$/;
    }
    static get singleRegex() {
        return /^(.*)\$$/;
    }
    search(text) {
        const isMatch = text.endsWith(this.pattern);
        return {
            isMatch,
            score: isMatch ? 0 : 1,
            indices: [
                text.length - this.pattern.length,
                text.length - 1
            ]
        };
    }
}
// Token: !.file$
class InverseSuffixExactMatch extends BaseMatch {
    constructor(pattern){
        super(pattern);
    }
    static get type() {
        return "inverse-suffix-exact";
    }
    static get multiRegex() {
        return /^!"(.*)"\$$/;
    }
    static get singleRegex() {
        return /^!(.*)\$$/;
    }
    search(text) {
        const isMatch = !text.endsWith(this.pattern);
        return {
            isMatch,
            score: isMatch ? 0 : 1,
            indices: [
                0,
                text.length - 1
            ]
        };
    }
}
class FuzzyMatch extends BaseMatch {
    constructor(pattern, { location =Config.location , threshold =Config.threshold , distance =Config.distance , includeMatches =Config.includeMatches , findAllMatches =Config.findAllMatches , minMatchCharLength =Config.minMatchCharLength , isCaseSensitive =Config.isCaseSensitive , ignoreLocation =Config.ignoreLocation  } = {}){
        super(pattern);
        this._bitapSearch = new BitapSearch(pattern, {
            location,
            threshold,
            distance,
            includeMatches,
            findAllMatches,
            minMatchCharLength,
            isCaseSensitive,
            ignoreLocation
        });
    }
    static get type() {
        return "fuzzy";
    }
    static get multiRegex() {
        return /^"(.*)"$/;
    }
    static get singleRegex() {
        return /^(.*)$/;
    }
    search(text) {
        return this._bitapSearch.searchIn(text);
    }
}
// Token: 'file
class IncludeMatch extends BaseMatch {
    constructor(pattern){
        super(pattern);
    }
    static get type() {
        return "include";
    }
    static get multiRegex() {
        return /^'"(.*)"$/;
    }
    static get singleRegex() {
        return /^'(.*)$/;
    }
    search(text) {
        let location = 0;
        let index;
        const indices = [];
        const patternLen = this.pattern.length;
        // Get all exact matches
        while((index = text.indexOf(this.pattern, location)) > -1){
            location = index + patternLen;
            indices.push([
                index,
                location - 1
            ]);
        }
        const isMatch = !!indices.length;
        return {
            isMatch,
            score: isMatch ? 0 : 1,
            indices
        };
    }
}
// ❗Order is important. DO NOT CHANGE.
const searchers = [
    ExactMatch,
    IncludeMatch,
    PrefixExactMatch,
    InversePrefixExactMatch,
    InverseSuffixExactMatch,
    SuffixExactMatch,
    InverseExactMatch,
    FuzzyMatch
];
const searchersLen = searchers.length;
// Regex to split by spaces, but keep anything in quotes together
const SPACE_RE = / +(?=(?:[^\"]*\"[^\"]*\")*[^\"]*$)/;
const OR_TOKEN = "|";
// Return a 2D array representation of the query, for simpler parsing.
// Example:
// "^core go$ | rb$ | py$ xy$" => [["^core", "go$"], ["rb$"], ["py$", "xy$"]]
function parseQuery(pattern, options = {}) {
    return pattern.split(OR_TOKEN).map((item)=>{
        let query = item.trim().split(SPACE_RE).filter((item)=>item && !!item.trim());
        let results = [];
        for(let i = 0, len = query.length; i < len; i += 1){
            const queryItem = query[i];
            // 1. Handle multiple query match (i.e, once that are quoted, like `"hello world"`)
            let found = false;
            let idx = -1;
            while(!found && ++idx < searchersLen){
                const searcher = searchers[idx];
                let token = searcher.isMultiMatch(queryItem);
                if (token) {
                    results.push(new searcher(token, options));
                    found = true;
                }
            }
            if (found) continue;
            // 2. Handle single query matches (i.e, once that are *not* quoted)
            idx = -1;
            while(++idx < searchersLen){
                const searcher1 = searchers[idx];
                let token1 = searcher1.isSingleMatch(queryItem);
                if (token1) {
                    results.push(new searcher1(token1, options));
                    break;
                }
            }
        }
        return results;
    });
}
// These extended matchers can return an array of matches, as opposed
// to a singl match
const MultiMatchSet = new Set([
    FuzzyMatch.type,
    IncludeMatch.type
]);
/**
 * Command-like searching
 * ======================
 *
 * Given multiple search terms delimited by spaces.e.g. `^jscript .python$ ruby !java`,
 * search in a given text.
 *
 * Search syntax:
 *
 * | Token       | Match type                 | Description                            |
 * | ----------- | -------------------------- | -------------------------------------- |
 * | `jscript`   | fuzzy-match                | Items that fuzzy match `jscript`       |
 * | `=scheme`   | exact-match                | Items that are `scheme`                |
 * | `'python`   | include-match              | Items that include `python`            |
 * | `!ruby`     | inverse-exact-match        | Items that do not include `ruby`       |
 * | `^java`     | prefix-exact-match         | Items that start with `java`           |
 * | `!^earlang` | inverse-prefix-exact-match | Items that do not start with `earlang` |
 * | `.js$`      | suffix-exact-match         | Items that end with `.js`              |
 * | `!.go$`     | inverse-suffix-exact-match | Items that do not end with `.go`       |
 *
 * A single pipe character acts as an OR operator. For example, the following
 * query matches entries that start with `core` and end with either`go`, `rb`,
 * or`py`.
 *
 * ```
 * ^core go$ | rb$ | py$
 * ```
 */ class ExtendedSearch {
    constructor(pattern, { isCaseSensitive =Config.isCaseSensitive , includeMatches =Config.includeMatches , minMatchCharLength =Config.minMatchCharLength , ignoreLocation =Config.ignoreLocation , findAllMatches =Config.findAllMatches , location =Config.location , threshold =Config.threshold , distance =Config.distance  } = {}){
        this.query = null;
        this.options = {
            isCaseSensitive,
            includeMatches,
            minMatchCharLength,
            findAllMatches,
            ignoreLocation,
            location,
            threshold,
            distance
        };
        this.pattern = isCaseSensitive ? pattern : pattern.toLowerCase();
        this.query = parseQuery(this.pattern, this.options);
    }
    static condition(_, options) {
        return options.useExtendedSearch;
    }
    searchIn(text) {
        const query = this.query;
        if (!query) return {
            isMatch: false,
            score: 1
        };
        const { includeMatches , isCaseSensitive  } = this.options;
        text = isCaseSensitive ? text : text.toLowerCase();
        let numMatches = 0;
        let allIndices = [];
        let totalScore = 0;
        // ORs
        for(let i = 0, qLen = query.length; i < qLen; i += 1){
            const searchers = query[i];
            // Reset indices
            allIndices.length = 0;
            numMatches = 0;
            // ANDs
            for(let j = 0, pLen = searchers.length; j < pLen; j += 1){
                const searcher = searchers[j];
                const { isMatch , indices , score  } = searcher.search(text);
                if (isMatch) {
                    numMatches += 1;
                    totalScore += score;
                    if (includeMatches) {
                        const type = searcher.constructor.type;
                        if (MultiMatchSet.has(type)) allIndices = [
                            ...allIndices,
                            ...indices
                        ];
                        else allIndices.push(indices);
                    }
                } else {
                    totalScore = 0;
                    numMatches = 0;
                    allIndices.length = 0;
                    break;
                }
            }
            // OR condition, so if TRUE, return
            if (numMatches) {
                let result = {
                    isMatch: true,
                    score: totalScore / numMatches
                };
                if (includeMatches) result.indices = allIndices;
                return result;
            }
        }
        // Nothing was matched
        return {
            isMatch: false,
            score: 1
        };
    }
}
const registeredSearchers = [];
function register(...args) {
    registeredSearchers.push(...args);
}
function createSearcher(pattern, options) {
    for(let i = 0, len = registeredSearchers.length; i < len; i += 1){
        let searcherClass = registeredSearchers[i];
        if (searcherClass.condition(pattern, options)) return new searcherClass(pattern, options);
    }
    return new BitapSearch(pattern, options);
}
const LogicalOperator = {
    AND: "$and",
    OR: "$or"
};
const KeyType = {
    PATH: "$path",
    PATTERN: "$val"
};
const isExpression = (query)=>!!(query[LogicalOperator.AND] || query[LogicalOperator.OR]);
const isPath = (query)=>!!query[KeyType.PATH];
const isLeaf = (query)=>!isArray(query) && isObject(query) && !isExpression(query);
const convertToExplicit = (query)=>({
        [LogicalOperator.AND]: Object.keys(query).map((key)=>({
                [key]: query[key]
            }))
    });
// When `auto` is `true`, the parse function will infer and initialize and add
// the appropriate `Searcher` instance
function parse(query, options, { auto =true  } = {}) {
    const next = (query)=>{
        let keys = Object.keys(query);
        const isQueryPath = isPath(query);
        if (!isQueryPath && keys.length > 1 && !isExpression(query)) return next(convertToExplicit(query));
        if (isLeaf(query)) {
            const key = isQueryPath ? query[KeyType.PATH] : keys[0];
            const pattern = isQueryPath ? query[KeyType.PATTERN] : query[key];
            if (!isString(pattern)) throw new Error(LOGICAL_SEARCH_INVALID_QUERY_FOR_KEY(key));
            const obj = {
                keyId: createKeyId(key),
                pattern
            };
            if (auto) obj.searcher = createSearcher(pattern, options);
            return obj;
        }
        let node = {
            children: [],
            operator: keys[0]
        };
        keys.forEach((key)=>{
            const value = query[key];
            if (isArray(value)) value.forEach((item)=>{
                node.children.push(next(item));
            });
        });
        return node;
    };
    if (!isExpression(query)) query = convertToExplicit(query);
    return next(query);
}
// Practical scoring function
function computeScore(results, { ignoreFieldNorm =Config.ignoreFieldNorm  }) {
    results.forEach((result)=>{
        let totalScore = 1;
        result.matches.forEach(({ key , norm , score  })=>{
            const weight = key ? key.weight : null;
            totalScore *= Math.pow(score === 0 && weight ? Number.EPSILON : score, (weight || 1) * (ignoreFieldNorm ? 1 : norm));
        });
        result.score = totalScore;
    });
}
function transformMatches(result, data) {
    const matches = result.matches;
    data.matches = [];
    if (!isDefined(matches)) return;
    matches.forEach((match)=>{
        if (!isDefined(match.indices) || !match.indices.length) return;
        const { indices , value  } = match;
        let obj = {
            indices,
            value
        };
        if (match.key) obj.key = match.key.src;
        if (match.idx > -1) obj.refIndex = match.idx;
        data.matches.push(obj);
    });
}
function transformScore(result, data) {
    data.score = result.score;
}
function format(results, docs, { includeMatches =Config.includeMatches , includeScore =Config.includeScore  } = {}) {
    const transformers = [];
    if (includeMatches) transformers.push(transformMatches);
    if (includeScore) transformers.push(transformScore);
    return results.map((result)=>{
        const { idx  } = result;
        const data = {
            item: docs[idx],
            refIndex: idx
        };
        if (transformers.length) transformers.forEach((transformer)=>{
            transformer(result, data);
        });
        return data;
    });
}
class Fuse {
    constructor(docs, options = {}, index){
        this.options = {
            ...Config,
            ...options
        };
        this.options.useExtendedSearch;
        this._keyStore = new KeyStore(this.options.keys);
        this.setCollection(docs, index);
    }
    setCollection(docs, index) {
        this._docs = docs;
        if (index && !(index instanceof FuseIndex)) throw new Error(INCORRECT_INDEX_TYPE);
        this._myIndex = index || createIndex(this.options.keys, this._docs, {
            getFn: this.options.getFn,
            fieldNormWeight: this.options.fieldNormWeight
        });
    }
    add(doc) {
        if (!isDefined(doc)) return;
        this._docs.push(doc);
        this._myIndex.add(doc);
    }
    remove(predicate = ()=>false) {
        const results = [];
        for(let i = 0, len = this._docs.length; i < len; i += 1){
            const doc = this._docs[i];
            if (predicate(doc, i)) {
                this.removeAt(i);
                i -= 1;
                len -= 1;
                results.push(doc);
            }
        }
        return results;
    }
    removeAt(idx) {
        this._docs.splice(idx, 1);
        this._myIndex.removeAt(idx);
    }
    getIndex() {
        return this._myIndex;
    }
    search(query, { limit =-1  } = {}) {
        const { includeMatches , includeScore , shouldSort , sortFn , ignoreFieldNorm  } = this.options;
        let results = isString(query) ? isString(this._docs[0]) ? this._searchStringList(query) : this._searchObjectList(query) : this._searchLogical(query);
        computeScore(results, {
            ignoreFieldNorm
        });
        if (shouldSort) results.sort(sortFn);
        if (isNumber(limit) && limit > -1) results = results.slice(0, limit);
        return format(results, this._docs, {
            includeMatches,
            includeScore
        });
    }
    _searchStringList(query) {
        const searcher = createSearcher(query, this.options);
        const { records  } = this._myIndex;
        const results = [];
        // Iterate over every string in the index
        records.forEach(({ v: text , i: idx , n: norm  })=>{
            if (!isDefined(text)) return;
            const { isMatch , score , indices  } = searcher.searchIn(text);
            if (isMatch) results.push({
                item: text,
                idx,
                matches: [
                    {
                        score,
                        value: text,
                        norm,
                        indices
                    }
                ]
            });
        });
        return results;
    }
    _searchLogical(query) {
        const expression = parse(query, this.options);
        const evaluate = (node, item, idx)=>{
            if (!node.children) {
                const { keyId , searcher  } = node;
                const matches = this._findMatches({
                    key: this._keyStore.get(keyId),
                    value: this._myIndex.getValueForItemAtKeyId(item, keyId),
                    searcher
                });
                if (matches && matches.length) return [
                    {
                        idx,
                        item,
                        matches
                    }
                ];
                return [];
            }
            const res = [];
            for(let i = 0, len = node.children.length; i < len; i += 1){
                const child = node.children[i];
                const result = evaluate(child, item, idx);
                if (result.length) res.push(...result);
                else if (node.operator === LogicalOperator.AND) return [];
            }
            return res;
        };
        const records = this._myIndex.records;
        const resultMap = {};
        const results = [];
        records.forEach(({ $: item , i: idx  })=>{
            if (isDefined(item)) {
                let expResults = evaluate(expression, item, idx);
                if (expResults.length) {
                    // Dedupe when adding
                    if (!resultMap[idx]) {
                        resultMap[idx] = {
                            idx,
                            item,
                            matches: []
                        };
                        results.push(resultMap[idx]);
                    }
                    expResults.forEach(({ matches  })=>{
                        resultMap[idx].matches.push(...matches);
                    });
                }
            }
        });
        return results;
    }
    _searchObjectList(query) {
        const searcher = createSearcher(query, this.options);
        const { keys , records  } = this._myIndex;
        const results = [];
        // List is Array<Object>
        records.forEach(({ $: item , i: idx  })=>{
            if (!isDefined(item)) return;
            let matches = [];
            // Iterate over every key (i.e, path), and fetch the value at that key
            keys.forEach((key, keyIndex)=>{
                matches.push(...this._findMatches({
                    key,
                    value: item[keyIndex],
                    searcher
                }));
            });
            if (matches.length) results.push({
                idx,
                item,
                matches
            });
        });
        return results;
    }
    _findMatches({ key , value , searcher  }) {
        if (!isDefined(value)) return [];
        let matches = [];
        if (isArray(value)) value.forEach(({ v: text , i: idx , n: norm  })=>{
            if (!isDefined(text)) return;
            const { isMatch , score , indices  } = searcher.searchIn(text);
            if (isMatch) matches.push({
                score,
                key,
                value: text,
                idx,
                norm,
                indices
            });
        });
        else {
            const { v: text , n: norm  } = value;
            const { isMatch , score , indices  } = searcher.searchIn(text);
            if (isMatch) matches.push({
                score,
                key,
                value: text,
                norm,
                indices
            });
        }
        return matches;
    }
}
Fuse.version = "6.6.2";
Fuse.createIndex = createIndex;
Fuse.parseIndex = parseIndex;
Fuse.config = Config;
Fuse.parseQuery = parse;
register(ExtendedSearch);

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kkPAm":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "default", ()=>arrayIntersect);
var arrayIntersect = intersect;
/*
  intersect([1, 2, 5, 6], [2, 3, 5, 6]); // [2, 5, 6]
  intersect([1, 2, 2, 4, 5], [3, 2, 2, 5, 7]); // [2, 5]
*/ function intersect(arr1, arr2) {
    if (!Array.isArray(arr1) || !Array.isArray(arr2)) throw new Error("expected both arguments to be arrays");
    var result = [];
    var set = convertArrayToSet(arr2);
    var memo = {};
    for(var i = 0; i < arr1.length; i++){
        var item = arr1[i];
        if (set.hasOwnProperty(item) && !memo.hasOwnProperty(item)) {
            result.push(item);
            memo[item] = true;
        }
    }
    return result;
}
function convertArrayToSet(arr) {
    var output = {};
    for(var i = 0; i < arr.length; i++){
        var item = arr[i];
        if (!output.hasOwnProperty(item)) output[item] = true;
    }
    return output;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eQVRA":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
"use strict"; /* @flow */ 
const factors = {
    kilometers: 1,
    miles: 1000 / 1609.344,
    nauticalmiles: 1000 / 1852,
    meters: 1000,
    metres: 1000,
    yards: 1000 / 0.9144,
    feet: 1000 / 0.3048,
    inches: 1000 / 0.0254
};
// Values that define WGS84 ellipsoid model of the Earth
const RE = 6378.137; // equatorial radius
const FE = 1 / 298.257223563; // flattening
const E2 = FE * (2 - FE);
const RAD = Math.PI / 180;
class CheapRuler {
    /**
     * Creates a ruler object from tile coordinates (y and z).
     *
     * @param {number} y
     * @param {number} z
     * @param {string} [units='kilometers']
     * @returns {CheapRuler}
     * @example
     * const ruler = cheapRuler.fromTile(1567, 12);
     * //=ruler
     */ static fromTile(y, z, units) {
        const n = Math.PI * (1 - 2 * (y + 0.5) / Math.pow(2, z));
        const lat = Math.atan(0.5 * (Math.exp(n) - Math.exp(-n))) / RAD;
        return new CheapRuler(lat, units);
    }
    /**
     * Multipliers for converting between units.
     *
     * @example
     * // convert 50 meters to yards
     * 50 * CheapRuler.units.yards / CheapRuler.units.meters;
     */ static get units() {
        return factors;
    }
    /**
     * Creates a ruler instance for very fast approximations to common geodesic measurements around a certain latitude.
     *
     * @param {number} lat latitude
     * @param {string} [units='kilometers']
     * @returns {CheapRuler}
     * @example
     * const ruler = cheapRuler(35.05, 'miles');
     * //=ruler
     */ constructor(lat, units){
        if (lat === undefined) throw new Error("No latitude given.");
        if (units && !factors[units]) throw new Error(`Unknown unit ${units}. Use one of: ${Object.keys(factors).join(", ")}`);
        // Curvature formulas from https://en.wikipedia.org/wiki/Earth_radius#Meridional
        const m = RAD * RE * (units ? factors[units] : 1);
        const coslat = Math.cos(lat * RAD);
        const w2 = 1 / (1 - E2 * (1 - coslat * coslat));
        const w = Math.sqrt(w2);
        // multipliers for converting longitude and latitude degrees into distance
        this.kx = m * w * coslat; // based on normal radius of curvature
        this.ky = m * w * w2 * (1 - E2); // based on meridonal radius of curvature
    }
    /**
     * Given two points of the form [longitude, latitude], returns the distance.
     *
     * @param {Array<number>} a point [longitude, latitude]
     * @param {Array<number>} b point [longitude, latitude]
     * @returns {number} distance
     * @example
     * const distance = ruler.distance([30.5, 50.5], [30.51, 50.49]);
     * //=distance
     */ distance(a, b) {
        const dx = wrap(a[0] - b[0]) * this.kx;
        const dy = (a[1] - b[1]) * this.ky;
        return Math.sqrt(dx * dx + dy * dy);
    }
    /**
     * Returns the bearing between two points in angles.
     *
     * @param {Array<number>} a point [longitude, latitude]
     * @param {Array<number>} b point [longitude, latitude]
     * @returns {number} bearing
     * @example
     * const bearing = ruler.bearing([30.5, 50.5], [30.51, 50.49]);
     * //=bearing
     */ bearing(a, b) {
        const dx = wrap(b[0] - a[0]) * this.kx;
        const dy = (b[1] - a[1]) * this.ky;
        return Math.atan2(dx, dy) / RAD;
    }
    /**
     * Returns a new point given distance and bearing from the starting point.
     *
     * @param {Array<number>} p point [longitude, latitude]
     * @param {number} dist distance
     * @param {number} bearing
     * @returns {Array<number>} point [longitude, latitude]
     * @example
     * const point = ruler.destination([30.5, 50.5], 0.1, 90);
     * //=point
     */ destination(p, dist, bearing) {
        const a = bearing * RAD;
        return this.offset(p, Math.sin(a) * dist, Math.cos(a) * dist);
    }
    /**
     * Returns a new point given easting and northing offsets (in ruler units) from the starting point.
     *
     * @param {Array<number>} p point [longitude, latitude]
     * @param {number} dx easting
     * @param {number} dy northing
     * @returns {Array<number>} point [longitude, latitude]
     * @example
     * const point = ruler.offset([30.5, 50.5], 10, 10);
     * //=point
     */ offset(p, dx, dy) {
        return [
            p[0] + dx / this.kx,
            p[1] + dy / this.ky
        ];
    }
    /**
     * Given a line (an array of points), returns the total line distance.
     *
     * @param {Array<Array<number>>} points [longitude, latitude]
     * @returns {number} total line distance
     * @example
     * const length = ruler.lineDistance([
     *     [-67.031, 50.458], [-67.031, 50.534],
     *     [-66.929, 50.534], [-66.929, 50.458]
     * ]);
     * //=length
     */ lineDistance(points) {
        let total = 0;
        for(let i = 0; i < points.length - 1; i++)total += this.distance(points[i], points[i + 1]);
        return total;
    }
    /**
     * Given a polygon (an array of rings, where each ring is an array of points), returns the area.
     *
     * @param {Array<Array<Array<number>>>} polygon
     * @returns {number} area value in the specified units (square kilometers by default)
     * @example
     * const area = ruler.area([[
     *     [-67.031, 50.458], [-67.031, 50.534], [-66.929, 50.534],
     *     [-66.929, 50.458], [-67.031, 50.458]
     * ]]);
     * //=area
     */ area(polygon) {
        let sum = 0;
        for(let i = 0; i < polygon.length; i++){
            const ring = polygon[i];
            for(let j = 0, len = ring.length, k = len - 1; j < len; k = j++)sum += wrap(ring[j][0] - ring[k][0]) * (ring[j][1] + ring[k][1]) * (i ? -1 : 1);
        }
        return Math.abs(sum) / 2 * this.kx * this.ky;
    }
    /**
     * Returns the point at a specified distance along the line.
     *
     * @param {Array<Array<number>>} line
     * @param {number} dist distance
     * @returns {Array<number>} point [longitude, latitude]
     * @example
     * const point = ruler.along(line, 2.5);
     * //=point
     */ along(line, dist) {
        let sum = 0;
        if (dist <= 0) return line[0];
        for(let i = 0; i < line.length - 1; i++){
            const p0 = line[i];
            const p1 = line[i + 1];
            const d = this.distance(p0, p1);
            sum += d;
            if (sum > dist) return interpolate(p0, p1, (dist - (sum - d)) / d);
        }
        return line[line.length - 1];
    }
    /**
     * Returns the distance from a point `p` to a line segment `a` to `b`.
     *
     * @pointToSegmentDistance
     * @param {Array<number>} p point [longitude, latitude]
     * @param {Array<number>} p1 segment point 1 [longitude, latitude]
     * @param {Array<number>} p2 segment point 2 [longitude, latitude]
     * @returns {number} distance
     * @example
     * const distance = ruler.pointToSegmentDistance([-67.04, 50.5], [-67.05, 50.57], [-67.03, 50.54]);
     * //=distance
     */ pointToSegmentDistance(p, a, b) {
        let [x, y] = a;
        let dx = wrap(b[0] - x) * this.kx;
        let dy = (b[1] - y) * this.ky;
        let t = 0;
        if (dx !== 0 || dy !== 0) {
            t = (wrap(p[0] - x) * this.kx * dx + (p[1] - y) * this.ky * dy) / (dx * dx + dy * dy);
            if (t > 1) {
                x = b[0];
                y = b[1];
            } else if (t > 0) {
                x += dx / this.kx * t;
                y += dy / this.ky * t;
            }
        }
        dx = wrap(p[0] - x) * this.kx;
        dy = (p[1] - y) * this.ky;
        return Math.sqrt(dx * dx + dy * dy);
    }
    /**
     * Returns an object of the form {point, index, t}, where point is closest point on the line
     * from the given point, index is the start index of the segment with the closest point,
     * and t is a parameter from 0 to 1 that indicates where the closest point is on that segment.
     *
     * @param {Array<Array<number>>} line
     * @param {Array<number>} p point [longitude, latitude]
     * @returns {Object} {point, index, t}
     * @example
     * const point = ruler.pointOnLine(line, [-67.04, 50.5]).point;
     * //=point
     */ pointOnLine(line, p) {
        let minDist = Infinity;
        let minX, minY, minI, minT;
        for(let i = 0; i < line.length - 1; i++){
            let x = line[i][0];
            let y = line[i][1];
            let dx = wrap(line[i + 1][0] - x) * this.kx;
            let dy = (line[i + 1][1] - y) * this.ky;
            let t = 0;
            if (dx !== 0 || dy !== 0) {
                t = (wrap(p[0] - x) * this.kx * dx + (p[1] - y) * this.ky * dy) / (dx * dx + dy * dy);
                if (t > 1) {
                    x = line[i + 1][0];
                    y = line[i + 1][1];
                } else if (t > 0) {
                    x += dx / this.kx * t;
                    y += dy / this.ky * t;
                }
            }
            dx = wrap(p[0] - x) * this.kx;
            dy = (p[1] - y) * this.ky;
            const sqDist = dx * dx + dy * dy;
            if (sqDist < minDist) {
                minDist = sqDist;
                minX = x;
                minY = y;
                minI = i;
                minT = t;
            }
        }
        return {
            point: [
                minX,
                minY
            ],
            index: minI,
            t: Math.max(0, Math.min(1, minT))
        };
    }
    /**
     * Returns a part of the given line between the start and the stop points (or their closest points on the line).
     *
     * @param {Array<number>} start point [longitude, latitude]
     * @param {Array<number>} stop point [longitude, latitude]
     * @param {Array<Array<number>>} line
     * @returns {Array<Array<number>>} line part of a line
     * @example
     * const line2 = ruler.lineSlice([-67.04, 50.5], [-67.05, 50.56], line1);
     * //=line2
     */ lineSlice(start, stop, line) {
        let p1 = this.pointOnLine(line, start);
        let p2 = this.pointOnLine(line, stop);
        if (p1.index > p2.index || p1.index === p2.index && p1.t > p2.t) {
            const tmp = p1;
            p1 = p2;
            p2 = tmp;
        }
        const slice = [
            p1.point
        ];
        const l = p1.index + 1;
        const r = p2.index;
        if (!equals(line[l], slice[0]) && l <= r) slice.push(line[l]);
        for(let i = l + 1; i <= r; i++)slice.push(line[i]);
        if (!equals(line[r], p2.point)) slice.push(p2.point);
        return slice;
    }
    /**
     * Returns a part of the given line between the start and the stop points indicated by distance along the line.
     *
     * @param {number} start distance
     * @param {number} stop distance
     * @param {Array<Array<number>>} line
     * @returns {Array<Array<number>>} line part of a line
     * @example
     * const line2 = ruler.lineSliceAlong(10, 20, line1);
     * //=line2
     */ lineSliceAlong(start, stop, line) {
        let sum = 0;
        const slice = [];
        for(let i = 0; i < line.length - 1; i++){
            const p0 = line[i];
            const p1 = line[i + 1];
            const d = this.distance(p0, p1);
            sum += d;
            if (sum > start && slice.length === 0) slice.push(interpolate(p0, p1, (start - (sum - d)) / d));
            if (sum >= stop) {
                slice.push(interpolate(p0, p1, (stop - (sum - d)) / d));
                return slice;
            }
            if (sum > start) slice.push(p1);
        }
        return slice;
    }
    /**
     * Given a point, returns a bounding box object ([w, s, e, n]) created from the given point buffered by a given distance.
     *
     * @param {Array<number>} p point [longitude, latitude]
     * @param {number} buffer
     * @returns {Array<number>} box object ([w, s, e, n])
     * @example
     * const bbox = ruler.bufferPoint([30.5, 50.5], 0.01);
     * //=bbox
     */ bufferPoint(p, buffer) {
        const v = buffer / this.ky;
        const h = buffer / this.kx;
        return [
            p[0] - h,
            p[1] - v,
            p[0] + h,
            p[1] + v
        ];
    }
    /**
     * Given a bounding box, returns the box buffered by a given distance.
     *
     * @param {Array<number>} box object ([w, s, e, n])
     * @param {number} buffer
     * @returns {Array<number>} box object ([w, s, e, n])
     * @example
     * const bbox = ruler.bufferBBox([30.5, 50.5, 31, 51], 0.2);
     * //=bbox
     */ bufferBBox(bbox, buffer) {
        const v = buffer / this.ky;
        const h = buffer / this.kx;
        return [
            bbox[0] - h,
            bbox[1] - v,
            bbox[2] + h,
            bbox[3] + v
        ];
    }
    /**
     * Returns true if the given point is inside in the given bounding box, otherwise false.
     *
     * @param {Array<number>} p point [longitude, latitude]
     * @param {Array<number>} box object ([w, s, e, n])
     * @returns {boolean}
     * @example
     * const inside = ruler.insideBBox([30.5, 50.5], [30, 50, 31, 51]);
     * //=inside
     */ insideBBox(p, bbox) {
        return wrap(p[0] - bbox[0]) >= 0 && wrap(p[0] - bbox[2]) <= 0 && p[1] >= bbox[1] && p[1] <= bbox[3];
    }
}
exports.default = CheapRuler;
function equals(a, b) {
    return a[0] === b[0] && a[1] === b[1];
}
function interpolate(a, b, t) {
    const dx = wrap(b[0] - a[0]);
    const dy = b[1] - a[1];
    return [
        a[0] + dx * t,
        a[1] + dy * t
    ];
}
// normalize a degree value into [-180..180] range
function wrap(deg) {
    while(deg < -180)deg += 360;
    while(deg > 180)deg -= 360;
    return deg;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9JxOa":[function(require,module,exports) {
/**
 * Create a new [Mapbox GL JS plugin](https://www.mapbox.com/blog/build-mapbox-gl-js-plugins/) that
 * modifies the layers of the map style to use the `text-field` that matches the browser language.
 * As of Mapbox GL Language v1.0.0, this plugin no longer supports token values (e.g. `{name}`). v1.0+ expects the `text-field`
 * property of a style to use an [expression](https://docs.mapbox.com/mapbox-gl-js/style-spec/expressions/) of the form `['get', 'name_en']` or `['get', 'name']`; these expressions can be nested. Note that `get` expressions used as inputs to other expressions may not be handled by this plugin. For example:
 * ```
 * ["match",
 *   ["get", "name"],
 *   "California",
 *   "Golden State",
 *   ["coalesce",
 *     ["get", "name_en"],
 *     ["get", "name"]
 *   ]
 * ]
 * ```
 * Only styles based on [Mapbox v8 styles](https://docs.mapbox.com/help/troubleshooting/streets-v8-migration-guide/) are supported.
 *
 * @constructor
 * @param {object} options - Options to configure the plugin.
 * @param {string[]} [options.supportedLanguages] - List of supported languages
 * @param {Function} [options.languageTransform] - Custom style transformation to apply
 * @param {RegExp} [options.languageField=/^name_/] - RegExp to match if a text-field is a language field
 * @param {Function} [options.getLanguageField] - Given a language choose the field in the vector tiles
 * @param {string} [options.languageSource] - Name of the source that contains the different languages.
 * @param {string} [options.defaultLanguage] - Name of the default language to initialize style after loading.
 * @param {string[]} [options.excludedLayerIds] - Name of the layers that should be excluded from translation.
 */ function MapboxLanguage(options) {
    options = Object.assign({}, options);
    if (!(this instanceof MapboxLanguage)) throw new Error("MapboxLanguage needs to be called with the new keyword");
    this.setLanguage = this.setLanguage.bind(this);
    this._initialStyleUpdate = this._initialStyleUpdate.bind(this);
    this._defaultLanguage = options.defaultLanguage;
    this._isLanguageField = options.languageField || /^name_/;
    this._getLanguageField = options.getLanguageField || function nameField(language) {
        return language === "mul" ? "name" : `name_${language}`;
    };
    this._languageSource = options.languageSource || null;
    this._languageTransform = options.languageTransform;
    this._excludedLayerIds = options.excludedLayerIds || [];
    this.supportedLanguages = options.supportedLanguages || [
        "ar",
        "de",
        "en",
        "es",
        "fr",
        "it",
        "ja",
        "ko",
        "mul",
        "pt",
        "ru",
        "vi",
        "zh-Hans",
        "zh-Hant"
    ];
}
const isTokenField = /^\{name/;
function isFlatExpressionField(isLangField, property) {
    const isGetExpression = Array.isArray(property) && property[0] === "get";
    if (isGetExpression && isTokenField.test(property[1])) console.warn("This plugin no longer supports the use of token syntax (e.g. {name}). Please use a get expression. See https://docs.mapbox.com/mapbox-gl-js/style-spec/expressions/ for more details.");
    return isGetExpression && isLangField.test(property[1]);
}
function adaptNestedExpressionField(isLangField, property, languageFieldName) {
    if (Array.isArray(property)) {
        for(let i = 1; i < property.length; i++)if (Array.isArray(property[i])) {
            if (isFlatExpressionField(isLangField, property[i])) property[i][1] = languageFieldName;
            adaptNestedExpressionField(isLangField, property[i], languageFieldName);
        }
    }
}
function adaptPropertyLanguage(isLangField, property, languageFieldName) {
    if (isFlatExpressionField(isLangField, property)) property[1] = languageFieldName;
    adaptNestedExpressionField(isLangField, property, languageFieldName);
    // handle special case of bare ['get', 'name'] expression by wrapping it in a coalesce statement
    if (property[0] === "get" && property[1] === "name") {
        const defaultProp = property.slice();
        const adaptedProp = [
            "get",
            languageFieldName
        ];
        property = [
            "coalesce",
            adaptedProp,
            defaultProp
        ];
    }
    return property;
}
function changeLayerTextProperty(isLangField, layer, languageFieldName, excludedLayerIds) {
    if (layer.layout && layer.layout["text-field"] && excludedLayerIds.indexOf(layer.id) === -1) return Object.assign({}, layer, {
        layout: Object.assign({}, layer.layout, {
            "text-field": adaptPropertyLanguage(isLangField, layer.layout["text-field"], languageFieldName)
        })
    });
    return layer;
}
function findStreetsSource(style) {
    const sources = Object.keys(style.sources).filter((sourceName)=>{
        const url = style.sources[sourceName].url;
        // the source URL can reference the source version or the style version
        // this check and the error forces users to migrate to styles using source version 8
        return url && url.indexOf("mapbox.mapbox-streets-v8") > -1 || /mapbox-streets-v[1-9][1-9]/.test(url);
    });
    if (!sources.length) throw new Error('If using MapboxLanguage with a Mapbox style, the style must be based on vector tile version 8, e.g. "streets-v11"');
    return sources[0];
}
/**
 * Explicitly change the language for a style.
 * @param {object} style - Mapbox GL style to modify
 * @param {string} language - The language iso code
 * @returns {object} the modified style
 */ MapboxLanguage.prototype.setLanguage = function(style, language) {
    if (this.supportedLanguages.indexOf(language) < 0) throw new Error(`Language ${language} is not supported`);
    const streetsSource = this._languageSource || findStreetsSource(style);
    if (!streetsSource) return style;
    const field = this._getLanguageField(language);
    const isLangField = this._isLanguageField;
    const excludedLayerIds = this._excludedLayerIds;
    const changedLayers = style.layers.map((layer)=>{
        if (layer.source === streetsSource) return changeLayerTextProperty(isLangField, layer, field, excludedLayerIds);
        return layer;
    });
    const languageStyle = Object.assign({}, style, {
        layers: changedLayers
    });
    return this._languageTransform ? this._languageTransform(languageStyle, language) : languageStyle;
};
MapboxLanguage.prototype._initialStyleUpdate = function() {
    const style = this._map.getStyle();
    const language = this._defaultLanguage || browserLanguage(this.supportedLanguages);
    this._map.setStyle(this.setLanguage(style, language));
};
function browserLanguage(supportedLanguages) {
    const language = navigator.languages ? navigator.languages[0] : navigator.language || navigator.userLanguage;
    const parts = language && language.split("-");
    let languageCode = language;
    if (parts.length > 1) languageCode = parts[0];
    if (supportedLanguages.indexOf(languageCode) > -1) return languageCode;
    return null;
}
MapboxLanguage.prototype.onAdd = function(map) {
    this._map = map;
    this._map.on("style.load", this._initialStyleUpdate);
    this._container = document.createElement("div");
    return this._container;
};
MapboxLanguage.prototype.onRemove = function() {
    this._map.off("style.load", this._initialStyleUpdate);
    this._map = undefined;
};
if (typeof module.exports !== "undefined") module.exports = MapboxLanguage;
else window.MapboxLanguage = MapboxLanguage;

},{}],"5MP3O":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "MAPBOX_ACCESS_TOKEN", ()=>MAPBOX_ACCESS_TOKEN);
parcelHelpers.export(exports, "ARCGIS_API_KEY", ()=>ARCGIS_API_KEY);
const MAPBOX_ACCESS_TOKEN = "pk.eyJ1IjoiY2hlZWF1biIsImEiOiJjam9weHRuMW4xdXczM3FteTR1OGt3OWxhIn0.I9fgZVxvN_wSJb8soniwpQ";
const ARCGIS_API_KEY = "AAPKabd75694252a4a1885ed1e9daf2c021bnzUEoNoYQafflN6M1AZWT0hk_dHkyPleyOdjBVDSwDoCnX01cNV39nTBWanJHXh-";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8A3sw":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "encode", ()=>encode);
parcelHelpers.export(exports, "decode", ()=>decode);
const encode = (id)=>parseInt(id.replace(/\w/gi, (c)=>"" + c.charCodeAt()), 10);
const decode = (number)=>String.fromCharCode(...("" + number).match(/\w\w/gi));

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8fT5D":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = ()=>{
    const path = location.hash.replace(/^#/, "") || "/";
    if (path === "/") return {
        page: "home"
    };
    let [_, page, value, subpage] = path.match(/(service|stop|between)s?\/([^\/]+)\/?([^\/]+)?/) || [];
    return {
        page,
        value,
        path,
        subpage
    };
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gX5A8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function getDistance(x1, y1, x2, y2) {
    let xs = x2 - x1;
    let ys = y2 - y1;
    xs *= xs;
    ys *= ys;
    return Math.sqrt(xs + ys);
}
exports.default = getDistance;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"32Vpq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function getWalkingMinutes(distance) {
    // meters
    const walkingSpeed = 1.4; // meter/second
    return Math.ceil(distance / walkingSpeed / 60);
}
exports.default = getWalkingMinutes;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"h4j6R":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _hooks = require("preact/hooks");
function usePrevious(value) {
    const ref = (0, _hooks.useRef)();
    (0, _hooks.useEffect)(()=>{
        ref.current = value;
    }, [
        value
    ]);
    return ref.current;
}
exports.default = usePrevious;

},{"preact/hooks":"eZN76","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3vhiK":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _preact = require("preact");
var _hooks = require("preact/hooks");
exports.default = ()=>{
    try {
        if (localStorage["busroutersg.noads"] === "1") return "";
    } catch (e) {}
    const adRef = (0, _hooks.useRef)();
    (0, _hooks.useEffect)(()=>{
        if (adRef.current?.offsetWidth > 0) {
            // Only push if the ad slot is visible
            adRef.current.id = "bsa-zone_1623358681242-2_123456";
            window.optimize = window.optimize || {
                queue: []
            };
            window.optimize.queue.push(()=>{
                window.optimize.pushAll();
            });
        }
    }, []);
    const showFake = location.hostname === "localhost";
    return (0, _preact.h)("div", {
        ref: adRef,
        class: "ads",
        style: showFake ? {
            backgroundColor: "rgba(0,0,0,.03)",
            textAlign: "center",
            minHeight: 160,
            display: "flex",
            justifyContent: "center",
            alignItems: "center",
            fontWeight: "bold",
            color: "gray"
        } : {
            backgroundColor: "rgba(0,0,0,.03)",
            textAlign: "center"
        }
    }, showFake && "AD");
};

},{"preact":"26zcy","preact/hooks":"eZN76","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"44FUd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _preact = require("preact");
var _hooks = require("preact/hooks");
var _reactI18Next = require("react-i18next");
var _localeSelector = require("./LocaleSelector");
var _localeSelectorDefault = parcelHelpers.interopDefault(_localeSelector);
function About() {
    const { t , i18n  } = (0, _reactI18Next.useTranslation)();
    const [hidden, setHidden] = (0, _hooks.useState)(true);
    (0, _hooks.useEffect)(()=>{
        try {
            const intro = localStorage.getItem("busroutersg.about");
            if (intro !== "true") setHidden(false);
        } catch (e) {}
        const $logo = document.getElementById("logo");
        if ($logo) $logo.onclick = (e)=>{
            e.preventDefault();
            setHidden(!hidden);
        };
    }, []);
    return (0, _preact.h)("div", {
        id: "about",
        hidden: hidden,
        onClick: ()=>setHidden(true)
    }, (0, _preact.h)("section", {
        onClick: (e)=>e.stopPropagation()
    }, (0, _preact.h)("h2", null, t("app.name"), (0, _preact.h)("br", null), (0, _preact.h)("small", null, t("app.shortDescription"))), (0, _preact.h)("p", null, t("app.description")), (0, _preact.h)((0, _localeSelectorDefault.default), null), (0, _preact.h)("hr", null), (0, _preact.h)("p", null, (0, _preact.h)((0, _reactI18Next.Trans), {
        i18nKey: "about.disclaimerCopyright"
    }, (0, _preact.h)("a", {
        href: "https://github.com/cheeaun/busrouter-sg",
        target: "_blank",
        rel: "noopener"
    }, "Built"), "&", (0, _preact.h)("a", {
        href: "/visualization/",
        target: "_blank",
        rel: "noopener"
    }, "visualized"), "by", (0, _preact.h)("a", {
        href: "http://twitter.com/cheeaun",
        target: "_blank",
        rel: "noopener"
    }, "@cheeaun"), ". Data", (0, _preact.h)("a", {
        href: "http://www.mytransport.sg/",
        target: "_blank",
        rel: "noopener",
        title: "Land Transport Authority"
    }, "\xa9 LTA"), ".")), (0, _preact.h)("p", null, (0, _preact.h)((0, _reactI18Next.Trans), {
        i18nKey: "about.sisterSites"
    }, "Sister sites:", (0, _preact.h)("a", {
        href: "https://railrouter.sg/",
        target: "_blank",
        rel: "noopener"
    }, "\uD83D\uDE86 RailRouter SG"), " ", (0, _preact.h)("a", {
        href: "https://taxirouter.sg/",
        target: "_blank",
        rel: "noopener"
    }, "\uD83D\uDE96 TaxiRouter SG"))), (0, _preact.h)("p", null, (0, _preact.h)("a", {
        class: "donation-box",
        href: "https://www.buymeacoffee.com/cheeaun",
        target: "_blank",
        rel: "noopener"
    }, t("about.liking"), (0, _preact.h)("br", null), t("about.treatCoffee"))), (0, _preact.h)("div", {
        class: "popover-buttons"
    }, (0, _preact.h)("button", {
        class: "popover-button",
        onClick: ()=>{
            setHidden(true);
            try {
                localStorage.setItem("busroutersg.about", "true");
            } catch (e) {}
        }
    }, t("about.explore")))));
}
exports.default = About;

},{"preact":"26zcy","preact/hooks":"eZN76","react-i18next":"faThV","./LocaleSelector":"e0gts","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2s8Um":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _preact = require("preact");
var _hooks = require("preact/hooks");
var _cheapRuler = require("cheap-ruler");
var _cheapRulerDefault = parcelHelpers.interopDefault(_cheapRuler);
var _reactI18Next = require("react-i18next");
var _specialID = require("../utils/specialID");
var _getRoute = require("../utils/getRoute");
var _getRouteDefault = parcelHelpers.interopDefault(_getRoute);
var _rafInterval = require("../utils/rafInterval");
var _bus = require("../utils/bus");
var _arrivalTimeText = require("./ArrivalTimeText");
var _arrivalTimeTextDefault = parcelHelpers.interopDefault(_arrivalTimeText);
var _busTinyPng = require("../images/bus-tiny.png");
var _busTinyPngDefault = parcelHelpers.interopDefault(_busTinyPng);
const ruler = new (0, _cheapRulerDefault.default)(1.3);
const setupBusesStopLayerOnce = (map)=>{
    if (!map) return;
    if (!map.getSource("buses-stop")) {
        map.addSource("buses-stop", {
            type: "geojson",
            tolerance: 10,
            data: {
                type: "FeatureCollection",
                features: []
            }
        });
        if (!map.hasImage("bus-tiny")) map.loadImage((0, _busTinyPngDefault.default), (e, img)=>{
            if (!map.hasImage("bus-tiny")) map.addImage("bus-tiny", img);
        });
        map.addLayer({
            id: "buses-stop",
            type: "symbol",
            source: "buses-stop",
            minzoom: 11,
            layout: {
                "icon-image": "bus-tiny",
                "icon-allow-overlap": true,
                "icon-ignore-placement": true,
                "icon-size": [
                    "step",
                    [
                        "zoom"
                    ],
                    0.25,
                    15,
                    0.3,
                    16,
                    0.4
                ],
                "text-field": [
                    "step",
                    [
                        "zoom"
                    ],
                    "",
                    15,
                    [
                        "get",
                        "number"
                    ]
                ],
                "text-optional": true,
                "text-size": 10,
                "text-font": [
                    "DIN Offc Pro Medium",
                    "Arial Unicode MS Regular"
                ],
                "text-variable-anchor": [
                    "left",
                    "right",
                    "bottom",
                    "top"
                ],
                "text-justify": "auto",
                "text-padding": [
                    "step",
                    [
                        "zoom"
                    ],
                    4,
                    15,
                    6,
                    16,
                    8
                ]
            },
            paint: {
                "text-color": "#00454d",
                "text-halo-color": "#fff",
                "text-halo-width": 2
            }
        });
    }
};
const removeMapBuses = (map)=>{
    if (!map) return;
    map.getSource("buses-stop")?.setData({
        type: "FeatureCollection",
        features: []
    });
};
const timeout = (n)=>new Promise((f)=>setTimeout(f, n));
function BusServicesArrival({ services , id , map , active , showBusesOnMap  }) {
    if (!id) return;
    const { t  } = (0, _reactI18Next.useTranslation)();
    const [isLoading, setIsLoading] = (0, _hooks.useState)(false);
    const [servicesArrivals, setServicesArrivals] = (0, _hooks.useState)({});
    const [servicesIssues, setServicesIssues] = (0, _hooks.useState)([]);
    const [liveBusCount, setLiveBusCount] = (0, _hooks.useState)(0);
    const [oneServiceHasMultipleDirections, setOneServiceHasMultipleDirections] = (0, _hooks.useState)(false);
    const route = (0, _getRouteDefault.default)();
    let controller;
    const renderStopsTimeout = (0, _hooks.useRef)();
    const fetchServices = (0, _hooks.useCallback)(()=>{
        setIsLoading(true);
        controller = new AbortController();
        fetch(`https://arrivelah2.busrouter.sg/?id=${id}`, {
            signal: controller.signal
        }).then((res)=>res.json()).then((results)=>{
            const servicesArrivals = {};
            const { services  } = results;
            services.forEach((service)=>{
                if (!servicesArrivals[service.no] || servicesArrivals[service.no] > service.next.duration_ms // if there is a service with multiple directions, we only want the one with the shortest duration
                ) servicesArrivals[service.no] = service.next.duration_ms;
            });
            setServicesArrivals(servicesArrivals);
            setIsLoading(false);
            // check for issues (duplicate services, multiple visits)
            const servicesWithIssues = [];
            services.forEach((service, i)=>{
                const hasDuplicateServices = services.findIndex((s)=>s.no === service.no) !== i;
                if (hasDuplicateServices) servicesWithIssues.push(service.no);
                const { next , next2 , next3  } = service;
                const hasMultipleVisits = next?.visit_number > 1 || next2?.visit_number > 1 || next3?.visit_number > 1;
                if (hasMultipleVisits) servicesWithIssues.push(service.no);
            });
            setServicesIssues(servicesWithIssues);
            const hasIssues = servicesWithIssues.length > 0;
            setOneServiceHasMultipleDirections(hasIssues);
            if (showBusesOnMap) {
                setupBusesStopLayerOnce(map);
                renderStopsTimeout.current = setTimeout(()=>{
                    const servicesWithCoords = services.filter((s)=>s.no && s.next.lat > 0);
                    setLiveBusCount(servicesWithCoords.length);
                    const pointMargin = 100;
                    const servicesWithFixedCoordsPromises = servicesWithCoords.map(async (s)=>{
                        await timeout(0); // Forces this to be async
                        const coords = [
                            s.next.lng,
                            s.next.lat
                        ];
                        const point = map.project(coords);
                        let shortestDistance = Infinity;
                        let nearestCoords;
                        if (point.x && point.y) {
                            const features = map.queryRenderedFeatures([
                                [
                                    point.x - pointMargin,
                                    point.y - pointMargin
                                ],
                                [
                                    point.x + pointMargin,
                                    point.y + pointMargin
                                ]
                            ], {
                                validate: false
                            }).filter((f)=>{
                                return f.sourceLayer === "road" && f.layer.type === "line" && f.properties.class != "path" && !/(pedestrian|sidewalk|steps)/.test(f.layer.id);
                            });
                            features.forEach((f)=>{
                                const nearestPoint = ruler.pointOnLine(f.geometry.coordinates, coords);
                                if (nearestPoint.t) {
                                    const distance = ruler.distance(coords, nearestPoint.point);
                                    if (distance < shortestDistance) {
                                        shortestDistance = distance;
                                        nearestCoords = nearestPoint.point;
                                    }
                                }
                            });
                            if (nearestCoords && shortestDistance * 1000 < 10) {
                                // Only within 10m
                                console.log(`Fixed bus position: ${s.no} - ${(shortestDistance * 1000).toFixed(3)}m`);
                                s.next = {
                                    lng: nearestCoords[0],
                                    lat: nearestCoords[1]
                                };
                            }
                        }
                        return s;
                    });
                    requestAnimationFrame(async ()=>{
                        const servicesWithFixedCoords = await Promise.all(servicesWithFixedCoordsPromises);
                        map.getSource("buses-stop").setData({
                            type: "FeatureCollection",
                            features: servicesWithFixedCoords.map((s)=>({
                                    type: "Feature",
                                    id: (0, _specialID.encode)(s.no),
                                    properties: {
                                        number: s.no
                                    },
                                    geometry: {
                                        type: "Point",
                                        coordinates: [
                                            s.next.lng,
                                            s.next.lat
                                        ]
                                    }
                                }))
                        });
                    });
                }, map.loaded() ? 0 : 1000);
            }
        }).catch(()=>{
        // Silent fail
        });
    }, [
        id
    ]);
    (0, _hooks.useEffect)(()=>{
        let intervalID;
        if (active) intervalID = (0, _rafInterval.setRafInterval)(fetchServices, 15000); // 15 seconds
        return ()=>{
            (0, _rafInterval.clearRafInterval)(intervalID);
            controller?.abort();
            clearTimeout(renderStopsTimeout.current);
            removeMapBuses(map);
        };
    }, [
        id,
        active,
        showBusesOnMap
    ]);
    const servicesValue = route.value?.split("~") || [];
    return (0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("p", {
        class: `services-list ${isLoading ? "loading" : ""}`
    }, services.sort((0, _bus.sortServices)).map((service)=>(0, _preact.h)((0, _preact.Fragment), null, (0, _preact.h)("a", {
            href: `#/services/${service}`,
            class: `service-tag ${route.page === "service" && servicesValue.includes(service) ? "current" : ""}`
        }, service, servicesIssues.includes(service) && " ⚠️", servicesArrivals[service] && (0, _preact.h)("span", null, (0, _preact.h)((0, _arrivalTimeTextDefault.default), {
            ms: servicesArrivals[service]
        }))), " "))), oneServiceHasMultipleDirections && (0, _preact.h)("div", {
        class: "callout warning iconic"
    }, t("stop.multipleDirectionsWarning")), showBusesOnMap && liveBusCount > 0 && (0, _preact.h)("p", {
        style: {
            marginTop: 5,
            fontSize: ".8em"
        }
    }, (0, _preact.h)("span", {
        class: "live"
    }, t("common.live")), " ", (0, _preact.h)("img", {
        src: (0, _busTinyPngDefault.default),
        width: "16",
        alt: ""
    }), " ", t("stop.liveBusTrack", {
        count: liveBusCount
    })));
}
exports.default = BusServicesArrival;

},{"preact":"26zcy","preact/hooks":"eZN76","cheap-ruler":"eQVRA","react-i18next":"faThV","../utils/specialID":"8A3sw","../utils/getRoute":"8fT5D","../utils/rafInterval":"7ME9T","../utils/bus":"cu424","./ArrivalTimeText":"bxfzt","../images/bus-tiny.png":"ghE5Y","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7ME9T":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "setRafInterval", ()=>setRafInterval);
parcelHelpers.export(exports, "clearRafInterval", ()=>clearRafInterval);
const setRafInterval = (fn, delay)=>{
    const id = {};
    function tick() {
        fn();
        id.timeout = setTimeout(()=>{
            id.raf = requestAnimationFrame(tick);
        }, delay);
    }
    tick();
    return id;
};
const clearRafInterval = (id)=>{
    if (!id) return;
    const { timeout , raf  } = id;
    clearTimeout(timeout);
    cancelAnimationFrame(raf);
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bxfzt":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _preact = require("preact");
var _reactI18Next = require("react-i18next");
function ArrivalTimeText({ ms  }) {
    const { t  } = (0, _reactI18Next.useTranslation)();
    if (ms === null) return;
    const mins = Math.floor(ms / 1000 / 60);
    return mins <= 0 ? t("glossary.arriving") : t("glossary.arrivingMinutes", {
        count: mins
    });
}
exports.default = ArrivalTimeText;

},{"preact":"26zcy","react-i18next":"faThV","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ghE5Y":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("9pgM9") + "bus-tiny.3f63e152.png" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"lgJ39":[function(require,module,exports) {
"use strict";
var bundleURL = {};
function getBundleURLCached(id) {
    var value = bundleURL[id];
    if (!value) {
        value = getBundleURL();
        bundleURL[id] = value;
    }
    return value;
}
function getBundleURL() {
    try {
        throw new Error();
    } catch (err) {
        var matches = ("" + err.stack).match(/(https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/[^)\n]+/g);
        if (matches) // The first two stack frames will be this function and getBundleURLCached.
        // Use the 3rd one, which will be a runtime in the original bundle.
        return getBaseURL(matches[2]);
    }
    return "/";
}
function getBaseURL(url) {
    return ("" + url).replace(/^((?:https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/.+)\/[^/]+$/, "$1") + "/";
} // TODO: Replace uses with `new URL(url).origin` when ie11 is no longer supported.
function getOrigin(url) {
    var matches = ("" + url).match(/(https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/[^/]+/);
    if (!matches) throw new Error("Origin not found");
    return matches[0];
}
exports.getBundleURL = getBundleURLCached;
exports.getBaseURL = getBaseURL;
exports.getOrigin = getOrigin;

},{}],"htf46":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _mapboxGl = require("mapbox-gl");
var _mapboxGlDefault = parcelHelpers.interopDefault(_mapboxGl);
var _checkGeolocationSupport = require("../utils/checkGeolocationSupport");
var _checkGeolocationSupportDefault = parcelHelpers.interopDefault(_checkGeolocationSupport);
var _compassHeading = require("../utils/compassHeading");
var _compassHeadingDefault = parcelHelpers.interopDefault(_compassHeading);
class GeolocateControl {
    _watching = false;
    _locking = false;
    _setup = false;
    _currentLocation = null;
    _buttonClicked = false;
    _orientationGranted = false;
    constructor(options){
        this.options = Object.assign({
            offset: [
                0,
                0
            ],
            onClick: ()=>{}
        }, options);
    }
    onAdd(map) {
        this._map = map;
        const container = document.createElement("div");
        container.className = "mapboxgl-ctrl mapboxgl-ctrl-group";
        this._container = container;
        (0, _checkGeolocationSupportDefault.default)(this._setupUI);
        return this._container;
    }
    _setupUI = (supported)=>{
        if (!supported) console.warn("Geolocation support is not available.");
        const button = document.createElement("button");
        button.className = "mapboxgl-ctrl-icon mapboxgl-ctrl-custom-geolocate";
        button.type = "button";
        button.innerHTML = `<svg viewBox="0 0 16 15" width="18" height="18">
    <path d="M.75 5.94c-.3.14-.51.33-.63.57a1.12 1.12 0 00.3 1.38c.2.17.47.26.8.27l5.54.02c.06 0 .09 0 .1.02.02.02.02.05.02.1l.02 5.5c.01.35.1.62.28.82.17.2.39.33.64.37.26.04.51-.01.77-.14.25-.14.45-.37.6-.7l5.7-12.34c.16-.32.22-.61.18-.87a1.05 1.05 0 00-.32-.65c-.17-.16-.4-.26-.67-.28-.28-.03-.58.03-.9.18L.75 5.94z"/>
    <path fill="#fff" class="inner" d="M2.37 6.74h-.02c0-.01 0-.02.02-.03l10.9-4.95h.03l-.01.03-4.97 10.88c0 .02-.01.02-.02.02v-.02l.04-5.31a.64.64 0 00-.66-.66l-5.31.04z"/>
  </svg>`;
        button.addEventListener("click", this._clickButton, false);
        this._button = button;
        this._container.appendChild(this._button);
        const dot = document.createElement("div");
        dot.innerHTML = `<div class="user-location-dot"></div>
      <div class="user-location-compass" hidden></div>`;
        // <div class="user-location-accuracy"></div>`;
        dot.className = "user-location";
        this._dot = new (0, _mapboxGlDefault.default).Marker({
            element: dot,
            rotationAlignment: "map"
        });
        const dotElement = this._dot.getElement();
        this._compass = dotElement.querySelector(".user-location-compass");
        // this._accuracy = dotElement.querySelector('.user-location-accuracy');
        this._map.on("movestart", (e)=>{
            if (!e.geolocateSource && this._locking) {
                this._locking = false;
                this._updateButtonState(null);
            }
        });
        this._setup = true;
        if (supported === "granted") this._clickButton(null, false);
    };
    _updateButtonState = (state)=>{
        const { classList  } = this._button;
        classList.remove("loading");
        classList.remove("active");
        if (state) classList.add(state);
    };
    _flyToCurrentLocation = ()=>{
        const map = this._map;
        const { _currentLocation: center  } = this;
        const { offset: _offset  } = this.options;
        const offset = typeof _offset === "function" ? _offset() : _offset;
        const { x , y  } = map.project(center);
        const { offsetWidth , offsetHeight , offsetLeft , offsetTop  } = map.getContainer();
        const margin = Math.max(offsetWidth, offsetHeight);
        const withinBounds = x > offsetLeft - margin && x < offsetWidth + margin && y > offsetTop - margin && y < offsetHeight + margin;
        // console.log(center, x, y, offsetLeft, offsetTop, offsetWidth, offsetHeight);
        const eventData = {
            geolocateSource: true
        };
        if (withinBounds) {
            if (map.getZoom() < 14) map.easeTo({
                center,
                zoom: 18,
                duration: 300,
                offset,
                animate: false
            }, eventData);
            else map.flyTo({
                center,
                zoom: 18,
                speed: 1.5,
                duration: 2000,
                offset
            }, eventData);
        } else map.easeTo({
            center,
            zoom: 18,
            duration: 300,
            offset,
            animate: false
        }, eventData);
    };
    _setHeading = (e)=>{
        console.log("_setHeading", e);
        if (!this._watching) return;
        if (!e || e.alpha === null) return;
        this._compass.hidden = false;
        const heading = e.compassHeading || e.webkitCompassHeading || (0, _compassHeadingDefault.default)(e.alpha, e.beta, e.gamma);
        // -60deg rotateX is for *tilting* the compass "box" to look like a trapezoid
        // this._compass.style.transform = `rotate(${Math.round(
        //   heading,
        // )}deg) scale(4)`;
        this._dot.setRotation(heading);
    };
    _clickButton = (e, locking = true)=>{
        if (e) e.preventDefault();
        if (!this._setup) return;
        const { onClick  } = this.options;
        if (this._watching) {
            this._updateButtonState("active");
            this._flyToCurrentLocation();
            this._locking = true;
            onClick(this._currentLocation);
        } else {
            this._updateButtonState("loading");
            this._buttonClicked = true;
            this._locking = locking;
            let deviceorientation;
            this._watching = navigator.geolocation.watchPosition((position)=>{
                console.log({
                    position
                });
                const { latitude , longitude  } = position.coords;
                if (`${[
                    latitude,
                    longitude
                ]}` === `${this._currentLocation}`) return; // No idea why
                // console.log({ latitude, longitude });
                this._currentLocation = [
                    longitude,
                    latitude
                ];
                this._dot.setLngLat(this._currentLocation);
                if (!this._dot._addedToMap) {
                    this._dot.addTo(this._map);
                    this._dot._addedToMap = true;
                }
                if (this._locking) {
                    this._updateButtonState("active");
                    this._flyToCurrentLocation();
                } else this._updateButtonState(null);
                if (this._buttonClicked) {
                    // Differentiate between initiated from button click or watchPosition subsequent runs
                    this._buttonClicked = false;
                    onClick(this._currentLocation);
                }
                this._watching = true;
            }, (e)=>{
                this._locking = false;
                this._watching = false;
                this._buttonClicked = false;
                this._updateButtonState(null);
                navigator.geolocation.clearWatch(this._watching);
                if (deviceorientation) window.removeEventListener(deviceorientation, this._setHeading);
                console.warn(e);
                if (e.code === 1) // PERMISSION_DENIED
                alert("Looks like location tracking is blocked on your browser. Please enable it in the settings to use this feature.");
                else // Retry again
                this._clickButton();
            }, {
                enableHighAccuracy: true,
                timeout: 60000,
                // 1min
                maximumAge: 1000 // 1s
            });
            if (window.DeviceOrientationEvent) {
                // https://developers.google.com/web/updates/2016/03/device-orientation-changes
                // https://stackoverflow.com/a/47870694/20838
                if (location.hostname === "localhost") // Stupid bug with Chrome
                // `ondeviceorientationabsolute` is true but always return empty values
                deviceorientation = "deviceorientation";
                else deviceorientation = "ondeviceorientationabsolute" in window ? "deviceorientationabsolute" : "deviceorientation";
                window.addEventListener(deviceorientation, this._setHeading, false);
                if (!this._orientationGranted) {
                    if (typeof DeviceOrientationEvent.requestPermission === "function") DeviceOrientationEvent.requestPermission().then(function(permissionState) {
                        if (permissionState === "granted") {
                            this._orientationGranted = true;
                            console.log("granted");
                        }
                    }).catch((e)=>{});
                }
            }
        }
    };
}
exports.default = GeolocateControl;

},{"mapbox-gl":"562rs","../utils/checkGeolocationSupport":"fAYXi","../utils/compassHeading":"jengN","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fAYXi":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
let supportsGeolocation;
function checkGeolocationSupport(callback) {
    if (supportsGeolocation !== undefined) callback(supportsGeolocation);
    else if (window.navigator.permissions !== undefined) // navigator.permissions has incomplete browser support
    // http://caniuse.com/#feat=permissions-api
    // Test for the case where a browser disables Geolocation because of an
    // insecure origin
    window.navigator.permissions.query({
        name: "geolocation"
    }).then((p)=>{
        console.log("Geolocation permission", p.state);
        supportsGeolocation = p.state === "denied" ? false : p.state;
        callback(supportsGeolocation);
    });
    else {
        supportsGeolocation = !!window.navigator.geolocation;
        callback(supportsGeolocation);
    }
}
exports.default = checkGeolocationSupport;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jengN":[function(require,module,exports) {
// https://stackoverflow.com/a/21829819/20838
// http://w3c.github.io/deviceorientation/spec-source-orientation.html#worked-example
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
const degtorad = Math.PI / 180; // Degree-to-Radian conversion
function compassHeading(alpha, beta, gamma) {
    const _x = beta ? beta * degtorad : 0; // beta value
    const _y = gamma ? gamma * degtorad : 0; // gamma value
    const _z = alpha ? alpha * degtorad : 0; // alpha value
    const cX = Math.cos(_x);
    const cY = Math.cos(_y);
    const cZ = Math.cos(_z);
    const sX = Math.sin(_x);
    const sY = Math.sin(_y);
    const sZ = Math.sin(_z);
    // Calculate Vx and Vy components
    const Vx = -cZ * sY - sZ * sX * cY;
    const Vy = -sZ * sY + cZ * sX * cY;
    // Calculate compass heading
    let compassHeading = Math.atan(Vx / Vy);
    // Convert compass heading to use whole unit circle
    if (Vy < 0) compassHeading += Math.PI;
    else if (Vx < 0) compassHeading += 2 * Math.PI;
    return compassHeading * (180 / Math.PI); // Compass Heading (in degrees)
}
exports.default = compassHeading;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4xFa2":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _preact = require("preact");
function BetweenRoutes(props) {
    const { results , nearbyStart , nearbyEnd , onClickRoute  } = props;
    if (!results.length) return (0, _preact.h)("div", {
        class: "between-block between-nada"
    }, "\uD83D\uDE14 No routes available.");
    return (0, _preact.h)("div", {
        class: "between-block"
    }, results.map((result)=>{
        const { stopsBetween  } = result;
        return (0, _preact.h)("div", {
            class: `between-item ${nearbyStart ? "nearby-start" : ""}  ${nearbyEnd ? "nearby-end" : ""}`,
            onClick: (e)=>onClickRoute(e, result)
        }, (0, _preact.h)("div", {
            class: "between-inner"
        }, (0, _preact.h)("div", {
            class: `between-services ${result.endService ? "" : "full"}`
        }, (0, _preact.h)("span", {
            class: "start"
        }, result.startService), !!result.endService && (0, _preact.h)("span", {
            class: "end"
        }, result.endService)), (0, _preact.h)("div", {
            class: `between-stops ${stopsBetween.length ? "" : "nada"}`
        }, result.startStop && (0, _preact.h)("span", {
            class: "start"
        }, result.startStop.number), (0, _preact.h)("span", {
            class: `betweens betweens-${Math.min(6, stopsBetween.length)}`
        }, !!stopsBetween.length && (stopsBetween.length === 1 ? stopsBetween[0] : `${stopsBetween.length} stops`)), result.endStop && (0, _preact.h)("span", {
            class: "end"
        }, result.endStop.number))));
    }));
}
exports.default = BetweenRoutes;

},{"preact":"26zcy","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"b3g97":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _extends = require("@babel/runtime/helpers/extends");
var _extendsDefault = parcelHelpers.interopDefault(_extends);
var _preact = require("preact");
var _hooks = require("preact/hooks");
var _useResizeObserver = require("../utils/useResizeObserver");
var _useResizeObserverDefault = parcelHelpers.interopDefault(_useResizeObserver);
function ScrollableContainer(props) {
    const { children , scrollToTopKey , ...otherProps } = props;
    const ref = (0, _hooks.useRef)(null);
    const { width , height  } = (0, _useResizeObserverDefault.default)({
        ref
    });
    const [scrollShadow, setScrollShadow] = (0, _hooks.useState)("bottom");
    (0, _hooks.useEffect)(()=>{
        // console.log('TRIGGER');
        const { current: el  } = ref;
        const { scrollHeight , offsetHeight  } = el;
        const handleScroll = ()=>{
            // console.log('SCROLL');
            if (el.scrollTop <= 0) setScrollShadow("bottom");
            else if (el.scrollTop + el.offsetHeight >= el.scrollHeight) setScrollShadow("top");
            else setScrollShadow("both");
        };
        const scrollable = scrollHeight > offsetHeight + 5; // Magic threshold
        if (scrollable) {
            handleScroll();
            el.addEventListener("scroll", handleScroll);
        } else setScrollShadow("");
        return ()=>el.removeEventListener("scroll", handleScroll);
    }, [
        width,
        height
    ]);
    // Scroll to top when `scrollToTopKey` changes
    (0, _hooks.useEffect)(()=>{
        ref.current.scrollTop = 0;
    }, [
        scrollToTopKey
    ]);
    return (0, _preact.h)("div", (0, _extendsDefault.default)({}, otherProps, {
        ref: ref,
        "data-scroll-shadow": scrollShadow
    }), children);
}
exports.default = ScrollableContainer;

},{"@babel/runtime/helpers/extends":"vw3vn","preact":"26zcy","preact/hooks":"eZN76","../utils/useResizeObserver":"coMeS","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"vw3vn":[function(require,module,exports) {
function _extends() {
    module.exports = _extends = Object.assign ? Object.assign.bind() : function(target) {
        for(var i = 1; i < arguments.length; i++){
            var source = arguments[i];
            for(var key in source)if (Object.prototype.hasOwnProperty.call(source, key)) target[key] = source[key];
        }
        return target;
    }, module.exports.__esModule = true, module.exports["default"] = module.exports;
    return _extends.apply(this, arguments);
}
module.exports = _extends, module.exports.__esModule = true, module.exports["default"] = module.exports;

},{}],"coMeS":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _resizeObserver = require("@juggle/resize-observer");
var _useResizeObserver = require("use-resize-observer");
var _useResizeObserverDefault = parcelHelpers.interopDefault(_useResizeObserver);
if (!window.ResizeObserver) window.ResizeObserver = (0, _resizeObserver.ResizeObserver);
exports.default = (0, _useResizeObserverDefault.default);

},{"@juggle/resize-observer":"2PQAi","use-resize-observer":"ifr9J","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2PQAi":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ResizeObserver", ()=>(0, _resizeObserver.ResizeObserver));
parcelHelpers.export(exports, "ResizeObserverEntry", ()=>(0, _resizeObserverEntry.ResizeObserverEntry));
parcelHelpers.export(exports, "ResizeObserverSize", ()=>(0, _resizeObserverSize.ResizeObserverSize));
var _resizeObserver = require("../ResizeObserver");
var _resizeObserverEntry = require("../ResizeObserverEntry");
var _resizeObserverSize = require("../ResizeObserverSize");

},{"../ResizeObserver":"fp9NI","../ResizeObserverEntry":"hbv3I","../ResizeObserverSize":"5Km0Y","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fp9NI":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ResizeObserver", ()=>ResizeObserver);
var _resizeObserverController = require("./ResizeObserverController");
var _element = require("./utils/element");
var ResizeObserver = function() {
    function ResizeObserver(callback) {
        if (arguments.length === 0) throw new TypeError("Failed to construct 'ResizeObserver': 1 argument required, but only 0 present.");
        if (typeof callback !== "function") throw new TypeError("Failed to construct 'ResizeObserver': The callback provided as parameter 1 is not a function.");
        (0, _resizeObserverController.ResizeObserverController).connect(this, callback);
    }
    ResizeObserver.prototype.observe = function(target, options) {
        if (arguments.length === 0) throw new TypeError("Failed to execute 'observe' on 'ResizeObserver': 1 argument required, but only 0 present.");
        if (!(0, _element.isElement)(target)) throw new TypeError("Failed to execute 'observe' on 'ResizeObserver': parameter 1 is not of type 'Element");
        (0, _resizeObserverController.ResizeObserverController).observe(this, target, options);
    };
    ResizeObserver.prototype.unobserve = function(target) {
        if (arguments.length === 0) throw new TypeError("Failed to execute 'unobserve' on 'ResizeObserver': 1 argument required, but only 0 present.");
        if (!(0, _element.isElement)(target)) throw new TypeError("Failed to execute 'unobserve' on 'ResizeObserver': parameter 1 is not of type 'Element");
        (0, _resizeObserverController.ResizeObserverController).unobserve(this, target);
    };
    ResizeObserver.prototype.disconnect = function() {
        (0, _resizeObserverController.ResizeObserverController).disconnect(this);
    };
    ResizeObserver.toString = function() {
        return "function ResizeObserver () { [polyfill code] }";
    };
    return ResizeObserver;
}();

},{"./ResizeObserverController":"aR7Kr","./utils/element":"fYEXf","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aR7Kr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ResizeObserverController", ()=>ResizeObserverController);
var _scheduler = require("./utils/scheduler");
var _resizeObservation = require("./ResizeObservation");
var _resizeObserverDetail = require("./ResizeObserverDetail");
var _resizeObservers = require("./utils/resizeObservers");
var observerMap = new WeakMap();
var getObservationIndex = function(observationTargets, target) {
    for(var i = 0; i < observationTargets.length; i += 1){
        if (observationTargets[i].target === target) return i;
    }
    return -1;
};
var ResizeObserverController = function() {
    function ResizeObserverController() {}
    ResizeObserverController.connect = function(resizeObserver, callback) {
        var detail = new (0, _resizeObserverDetail.ResizeObserverDetail)(resizeObserver, callback);
        observerMap.set(resizeObserver, detail);
    };
    ResizeObserverController.observe = function(resizeObserver, target, options) {
        var detail = observerMap.get(resizeObserver);
        var firstObservation = detail.observationTargets.length === 0;
        if (getObservationIndex(detail.observationTargets, target) < 0) {
            firstObservation && (0, _resizeObservers.resizeObservers).push(detail);
            detail.observationTargets.push(new (0, _resizeObservation.ResizeObservation)(target, options && options.box));
            (0, _scheduler.updateCount)(1);
            (0, _scheduler.scheduler).schedule();
        }
    };
    ResizeObserverController.unobserve = function(resizeObserver, target) {
        var detail = observerMap.get(resizeObserver);
        var index = getObservationIndex(detail.observationTargets, target);
        var lastObservation = detail.observationTargets.length === 1;
        if (index >= 0) {
            lastObservation && (0, _resizeObservers.resizeObservers).splice((0, _resizeObservers.resizeObservers).indexOf(detail), 1);
            detail.observationTargets.splice(index, 1);
            (0, _scheduler.updateCount)(-1);
        }
    };
    ResizeObserverController.disconnect = function(resizeObserver) {
        var _this = this;
        var detail = observerMap.get(resizeObserver);
        detail.observationTargets.slice().forEach(function(ot) {
            return _this.unobserve(resizeObserver, ot.target);
        });
        detail.activeTargets.splice(0, detail.activeTargets.length);
    };
    return ResizeObserverController;
}();

},{"./utils/scheduler":"crV2X","./ResizeObservation":"j5Hu6","./ResizeObserverDetail":"46Usx","./utils/resizeObservers":"bMmHK","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"crV2X":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "scheduler", ()=>scheduler);
parcelHelpers.export(exports, "updateCount", ()=>updateCount);
var _process = require("./process");
var _global = require("./global");
var _queueResizeObserver = require("./queueResizeObserver");
var watching = 0;
var isWatching = function() {
    return !!watching;
};
var CATCH_PERIOD = 250;
var observerConfig = {
    attributes: true,
    characterData: true,
    childList: true,
    subtree: true
};
var events = [
    "resize",
    "load",
    "transitionend",
    "animationend",
    "animationstart",
    "animationiteration",
    "keyup",
    "keydown",
    "mouseup",
    "mousedown",
    "mouseover",
    "mouseout",
    "blur",
    "focus"
];
var time = function(timeout) {
    if (timeout === void 0) timeout = 0;
    return Date.now() + timeout;
};
var scheduled = false;
var Scheduler = function() {
    function Scheduler() {
        var _this = this;
        this.stopped = true;
        this.listener = function() {
            return _this.schedule();
        };
    }
    Scheduler.prototype.run = function(timeout) {
        var _this = this;
        if (timeout === void 0) timeout = CATCH_PERIOD;
        if (scheduled) return;
        scheduled = true;
        var until = time(timeout);
        (0, _queueResizeObserver.queueResizeObserver)(function() {
            var elementsHaveResized = false;
            try {
                elementsHaveResized = (0, _process.process)();
            } finally{
                scheduled = false;
                timeout = until - time();
                if (!isWatching()) return;
                if (elementsHaveResized) _this.run(1000);
                else if (timeout > 0) _this.run(timeout);
                else _this.start();
            }
        });
    };
    Scheduler.prototype.schedule = function() {
        this.stop();
        this.run();
    };
    Scheduler.prototype.observe = function() {
        var _this = this;
        var cb = function() {
            return _this.observer && _this.observer.observe(document.body, observerConfig);
        };
        document.body ? cb() : (0, _global.global).addEventListener("DOMContentLoaded", cb);
    };
    Scheduler.prototype.start = function() {
        var _this = this;
        if (this.stopped) {
            this.stopped = false;
            this.observer = new MutationObserver(this.listener);
            this.observe();
            events.forEach(function(name) {
                return (0, _global.global).addEventListener(name, _this.listener, true);
            });
        }
    };
    Scheduler.prototype.stop = function() {
        var _this = this;
        if (!this.stopped) {
            this.observer && this.observer.disconnect();
            events.forEach(function(name) {
                return (0, _global.global).removeEventListener(name, _this.listener, true);
            });
            this.stopped = true;
        }
    };
    return Scheduler;
}();
var scheduler = new Scheduler();
var updateCount = function(n) {
    !watching && n > 0 && scheduler.start();
    watching += n;
    !watching && scheduler.stop();
};

},{"./process":"affUf","./global":"culvB","./queueResizeObserver":"bQ2y4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"affUf":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "process", ()=>process);
var _hasActiveObservations = require("../algorithms/hasActiveObservations");
var _hasSkippedObservations = require("../algorithms/hasSkippedObservations");
var _deliverResizeLoopError = require("../algorithms/deliverResizeLoopError");
var _broadcastActiveObservations = require("../algorithms/broadcastActiveObservations");
var _gatherActiveObservationsAtDepth = require("../algorithms/gatherActiveObservationsAtDepth");
var process = function() {
    var depth = 0;
    (0, _gatherActiveObservationsAtDepth.gatherActiveObservationsAtDepth)(depth);
    while((0, _hasActiveObservations.hasActiveObservations)()){
        depth = (0, _broadcastActiveObservations.broadcastActiveObservations)();
        (0, _gatherActiveObservationsAtDepth.gatherActiveObservationsAtDepth)(depth);
    }
    if ((0, _hasSkippedObservations.hasSkippedObservations)()) (0, _deliverResizeLoopError.deliverResizeLoopError)();
    return depth > 0;
};

},{"../algorithms/hasActiveObservations":"5pYPo","../algorithms/hasSkippedObservations":"lXPzu","../algorithms/deliverResizeLoopError":"g2RSW","../algorithms/broadcastActiveObservations":"fEflG","../algorithms/gatherActiveObservationsAtDepth":"aF1Qb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5pYPo":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "hasActiveObservations", ()=>hasActiveObservations);
var _resizeObservers = require("../utils/resizeObservers");
var hasActiveObservations = function() {
    return (0, _resizeObservers.resizeObservers).some(function(ro) {
        return ro.activeTargets.length > 0;
    });
};

},{"../utils/resizeObservers":"bMmHK","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bMmHK":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "resizeObservers", ()=>resizeObservers);
var resizeObservers = [];

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lXPzu":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "hasSkippedObservations", ()=>hasSkippedObservations);
var _resizeObservers = require("../utils/resizeObservers");
var hasSkippedObservations = function() {
    return (0, _resizeObservers.resizeObservers).some(function(ro) {
        return ro.skippedTargets.length > 0;
    });
};

},{"../utils/resizeObservers":"bMmHK","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"g2RSW":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "deliverResizeLoopError", ()=>deliverResizeLoopError);
var msg = "ResizeObserver loop completed with undelivered notifications.";
var deliverResizeLoopError = function() {
    var event;
    if (typeof ErrorEvent === "function") event = new ErrorEvent("error", {
        message: msg
    });
    else {
        event = document.createEvent("Event");
        event.initEvent("error", false, false);
        event.message = msg;
    }
    window.dispatchEvent(event);
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fEflG":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "broadcastActiveObservations", ()=>broadcastActiveObservations);
var _resizeObservers = require("../utils/resizeObservers");
var _resizeObserverEntry = require("../ResizeObserverEntry");
var _calculateDepthForNode = require("./calculateDepthForNode");
var _calculateBoxSize = require("./calculateBoxSize");
var broadcastActiveObservations = function() {
    var shallowestDepth = Infinity;
    var callbacks = [];
    (0, _resizeObservers.resizeObservers).forEach(function processObserver(ro) {
        if (ro.activeTargets.length === 0) return;
        var entries = [];
        ro.activeTargets.forEach(function processTarget(ot) {
            var entry = new (0, _resizeObserverEntry.ResizeObserverEntry)(ot.target);
            var targetDepth = (0, _calculateDepthForNode.calculateDepthForNode)(ot.target);
            entries.push(entry);
            ot.lastReportedSize = (0, _calculateBoxSize.calculateBoxSize)(ot.target, ot.observedBox);
            if (targetDepth < shallowestDepth) shallowestDepth = targetDepth;
        });
        callbacks.push(function resizeObserverCallback() {
            ro.callback.call(ro.observer, entries, ro.observer);
        });
        ro.activeTargets.splice(0, ro.activeTargets.length);
    });
    for(var _i = 0, callbacks_1 = callbacks; _i < callbacks_1.length; _i++){
        var callback = callbacks_1[_i];
        callback();
    }
    return shallowestDepth;
};

},{"../utils/resizeObservers":"bMmHK","../ResizeObserverEntry":"hbv3I","./calculateDepthForNode":"kpcjo","./calculateBoxSize":"5700d","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"hbv3I":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ResizeObserverEntry", ()=>ResizeObserverEntry);
var _calculateBoxSize = require("./algorithms/calculateBoxSize");
var _freeze = require("./utils/freeze");
var ResizeObserverEntry = function() {
    function ResizeObserverEntry(target) {
        var boxes = (0, _calculateBoxSize.calculateBoxSizes)(target);
        this.target = target;
        this.contentRect = boxes.contentRect;
        this.borderBoxSize = (0, _freeze.freeze)([
            boxes.borderBoxSize
        ]);
        this.contentBoxSize = (0, _freeze.freeze)([
            boxes.contentBoxSize
        ]);
        this.devicePixelContentBoxSize = (0, _freeze.freeze)([
            boxes.devicePixelContentBoxSize
        ]);
    }
    return ResizeObserverEntry;
}();

},{"./algorithms/calculateBoxSize":"5700d","./utils/freeze":"hHRAz","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5700d":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "calculateBoxSize", ()=>calculateBoxSize);
parcelHelpers.export(exports, "calculateBoxSizes", ()=>calculateBoxSizes);
var _resizeObserverBoxOptions = require("../ResizeObserverBoxOptions");
var _resizeObserverSize = require("../ResizeObserverSize");
var _domrectReadOnly = require("../DOMRectReadOnly");
var _element = require("../utils/element");
var _freeze = require("../utils/freeze");
var _global = require("../utils/global");
var cache = new WeakMap();
var scrollRegexp = /auto|scroll/;
var verticalRegexp = /^tb|vertical/;
var IE = /msie|trident/i.test((0, _global.global).navigator && (0, _global.global).navigator.userAgent);
var parseDimension = function(pixel) {
    return parseFloat(pixel || "0");
};
var size = function(inlineSize, blockSize, switchSizes) {
    if (inlineSize === void 0) inlineSize = 0;
    if (blockSize === void 0) blockSize = 0;
    if (switchSizes === void 0) switchSizes = false;
    return new (0, _resizeObserverSize.ResizeObserverSize)((switchSizes ? blockSize : inlineSize) || 0, (switchSizes ? inlineSize : blockSize) || 0);
};
var zeroBoxes = (0, _freeze.freeze)({
    devicePixelContentBoxSize: size(),
    borderBoxSize: size(),
    contentBoxSize: size(),
    contentRect: new (0, _domrectReadOnly.DOMRectReadOnly)(0, 0, 0, 0)
});
var calculateBoxSizes = function(target, forceRecalculation) {
    if (forceRecalculation === void 0) forceRecalculation = false;
    if (cache.has(target) && !forceRecalculation) return cache.get(target);
    if ((0, _element.isHidden)(target)) {
        cache.set(target, zeroBoxes);
        return zeroBoxes;
    }
    var cs = getComputedStyle(target);
    var svg = (0, _element.isSVG)(target) && target.ownerSVGElement && target.getBBox();
    var removePadding = !IE && cs.boxSizing === "border-box";
    var switchSizes = verticalRegexp.test(cs.writingMode || "");
    var canScrollVertically = !svg && scrollRegexp.test(cs.overflowY || "");
    var canScrollHorizontally = !svg && scrollRegexp.test(cs.overflowX || "");
    var paddingTop = svg ? 0 : parseDimension(cs.paddingTop);
    var paddingRight = svg ? 0 : parseDimension(cs.paddingRight);
    var paddingBottom = svg ? 0 : parseDimension(cs.paddingBottom);
    var paddingLeft = svg ? 0 : parseDimension(cs.paddingLeft);
    var borderTop = svg ? 0 : parseDimension(cs.borderTopWidth);
    var borderRight = svg ? 0 : parseDimension(cs.borderRightWidth);
    var borderBottom = svg ? 0 : parseDimension(cs.borderBottomWidth);
    var borderLeft = svg ? 0 : parseDimension(cs.borderLeftWidth);
    var horizontalPadding = paddingLeft + paddingRight;
    var verticalPadding = paddingTop + paddingBottom;
    var horizontalBorderArea = borderLeft + borderRight;
    var verticalBorderArea = borderTop + borderBottom;
    var horizontalScrollbarThickness = !canScrollHorizontally ? 0 : target.offsetHeight - verticalBorderArea - target.clientHeight;
    var verticalScrollbarThickness = !canScrollVertically ? 0 : target.offsetWidth - horizontalBorderArea - target.clientWidth;
    var widthReduction = removePadding ? horizontalPadding + horizontalBorderArea : 0;
    var heightReduction = removePadding ? verticalPadding + verticalBorderArea : 0;
    var contentWidth = svg ? svg.width : parseDimension(cs.width) - widthReduction - verticalScrollbarThickness;
    var contentHeight = svg ? svg.height : parseDimension(cs.height) - heightReduction - horizontalScrollbarThickness;
    var borderBoxWidth = contentWidth + horizontalPadding + verticalScrollbarThickness + horizontalBorderArea;
    var borderBoxHeight = contentHeight + verticalPadding + horizontalScrollbarThickness + verticalBorderArea;
    var boxes = (0, _freeze.freeze)({
        devicePixelContentBoxSize: size(Math.round(contentWidth * devicePixelRatio), Math.round(contentHeight * devicePixelRatio), switchSizes),
        borderBoxSize: size(borderBoxWidth, borderBoxHeight, switchSizes),
        contentBoxSize: size(contentWidth, contentHeight, switchSizes),
        contentRect: new (0, _domrectReadOnly.DOMRectReadOnly)(paddingLeft, paddingTop, contentWidth, contentHeight)
    });
    cache.set(target, boxes);
    return boxes;
};
var calculateBoxSize = function(target, observedBox, forceRecalculation) {
    var _a = calculateBoxSizes(target, forceRecalculation), borderBoxSize = _a.borderBoxSize, contentBoxSize = _a.contentBoxSize, devicePixelContentBoxSize = _a.devicePixelContentBoxSize;
    switch(observedBox){
        case (0, _resizeObserverBoxOptions.ResizeObserverBoxOptions).DEVICE_PIXEL_CONTENT_BOX:
            return devicePixelContentBoxSize;
        case (0, _resizeObserverBoxOptions.ResizeObserverBoxOptions).BORDER_BOX:
            return borderBoxSize;
        default:
            return contentBoxSize;
    }
};

},{"../ResizeObserverBoxOptions":"dNYRq","../ResizeObserverSize":"5Km0Y","../DOMRectReadOnly":"6N7Pa","../utils/element":"fYEXf","../utils/freeze":"hHRAz","../utils/global":"culvB","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dNYRq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ResizeObserverBoxOptions", ()=>ResizeObserverBoxOptions);
var ResizeObserverBoxOptions;
(function(ResizeObserverBoxOptions) {
    ResizeObserverBoxOptions["BORDER_BOX"] = "border-box";
    ResizeObserverBoxOptions["CONTENT_BOX"] = "content-box";
    ResizeObserverBoxOptions["DEVICE_PIXEL_CONTENT_BOX"] = "device-pixel-content-box";
})(ResizeObserverBoxOptions || (ResizeObserverBoxOptions = {}));

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5Km0Y":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ResizeObserverSize", ()=>ResizeObserverSize);
var _freeze = require("./utils/freeze");
var ResizeObserverSize = function() {
    function ResizeObserverSize(inlineSize, blockSize) {
        this.inlineSize = inlineSize;
        this.blockSize = blockSize;
        (0, _freeze.freeze)(this);
    }
    return ResizeObserverSize;
}();

},{"./utils/freeze":"hHRAz","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"hHRAz":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "freeze", ()=>freeze);
var freeze = function(obj) {
    return Object.freeze(obj);
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6N7Pa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "DOMRectReadOnly", ()=>DOMRectReadOnly);
var _freeze = require("./utils/freeze");
var DOMRectReadOnly = function() {
    function DOMRectReadOnly(x, y, width, height) {
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.top = this.y;
        this.left = this.x;
        this.bottom = this.top + this.height;
        this.right = this.left + this.width;
        return (0, _freeze.freeze)(this);
    }
    DOMRectReadOnly.prototype.toJSON = function() {
        var _a = this, x = _a.x, y = _a.y, top = _a.top, right = _a.right, bottom = _a.bottom, left = _a.left, width = _a.width, height = _a.height;
        return {
            x: x,
            y: y,
            top: top,
            right: right,
            bottom: bottom,
            left: left,
            width: width,
            height: height
        };
    };
    DOMRectReadOnly.fromRect = function(rectangle) {
        return new DOMRectReadOnly(rectangle.x, rectangle.y, rectangle.width, rectangle.height);
    };
    return DOMRectReadOnly;
}();

},{"./utils/freeze":"hHRAz","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fYEXf":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isSVG", ()=>isSVG);
parcelHelpers.export(exports, "isHidden", ()=>isHidden);
parcelHelpers.export(exports, "isElement", ()=>isElement);
parcelHelpers.export(exports, "isReplacedElement", ()=>isReplacedElement);
var isSVG = function(target) {
    return target instanceof SVGElement && "getBBox" in target;
};
var isHidden = function(target) {
    if (isSVG(target)) {
        var _a = target.getBBox(), width = _a.width, height = _a.height;
        return !width && !height;
    }
    var _b = target, offsetWidth = _b.offsetWidth, offsetHeight = _b.offsetHeight;
    return !(offsetWidth || offsetHeight || target.getClientRects().length);
};
var isElement = function(obj) {
    var _a, _b;
    if (obj instanceof Element) return true;
    var scope = (_b = (_a = obj) === null || _a === void 0 ? void 0 : _a.ownerDocument) === null || _b === void 0 ? void 0 : _b.defaultView;
    return !!(scope && obj instanceof scope.Element);
};
var isReplacedElement = function(target) {
    switch(target.tagName){
        case "INPUT":
            if (target.type !== "image") break;
        case "VIDEO":
        case "AUDIO":
        case "EMBED":
        case "OBJECT":
        case "CANVAS":
        case "IFRAME":
        case "IMG":
            return true;
    }
    return false;
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"culvB":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "global", ()=>global);
var global = typeof window !== "undefined" ? window : {};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kpcjo":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "calculateDepthForNode", ()=>calculateDepthForNode);
var _element = require("../utils/element");
var calculateDepthForNode = function(node) {
    if ((0, _element.isHidden)(node)) return Infinity;
    var depth = 0;
    var parent = node.parentNode;
    while(parent){
        depth += 1;
        parent = parent.parentNode;
    }
    return depth;
};

},{"../utils/element":"fYEXf","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aF1Qb":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "gatherActiveObservationsAtDepth", ()=>gatherActiveObservationsAtDepth);
var _resizeObservers = require("../utils/resizeObservers");
var _calculateDepthForNode = require("./calculateDepthForNode");
var gatherActiveObservationsAtDepth = function(depth) {
    (0, _resizeObservers.resizeObservers).forEach(function processObserver(ro) {
        ro.activeTargets.splice(0, ro.activeTargets.length);
        ro.skippedTargets.splice(0, ro.skippedTargets.length);
        ro.observationTargets.forEach(function processTarget(ot) {
            if (ot.isActive()) {
                if ((0, _calculateDepthForNode.calculateDepthForNode)(ot.target) > depth) ro.activeTargets.push(ot);
                else ro.skippedTargets.push(ot);
            }
        });
    });
};

},{"../utils/resizeObservers":"bMmHK","./calculateDepthForNode":"kpcjo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bQ2y4":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "queueResizeObserver", ()=>queueResizeObserver);
var _queueMicroTask = require("./queueMicroTask");
var queueResizeObserver = function(cb) {
    (0, _queueMicroTask.queueMicroTask)(function ResizeObserver() {
        requestAnimationFrame(cb);
    });
};

},{"./queueMicroTask":"5Yzv8","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5Yzv8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "queueMicroTask", ()=>queueMicroTask);
var trigger;
var callbacks = [];
var notify = function() {
    return callbacks.splice(0).forEach(function(cb) {
        return cb();
    });
};
var queueMicroTask = function(callback) {
    if (!trigger) {
        var toggle_1 = 0;
        var el_1 = document.createTextNode("");
        var config = {
            characterData: true
        };
        new MutationObserver(function() {
            return notify();
        }).observe(el_1, config);
        trigger = function() {
            el_1.textContent = "" + (toggle_1 ? toggle_1-- : toggle_1++);
        };
    }
    callbacks.push(callback);
    trigger();
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"j5Hu6":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ResizeObservation", ()=>ResizeObservation);
var _resizeObserverBoxOptions = require("./ResizeObserverBoxOptions");
var _calculateBoxSize = require("./algorithms/calculateBoxSize");
var _element = require("./utils/element");
var skipNotifyOnElement = function(target) {
    return !(0, _element.isSVG)(target) && !(0, _element.isReplacedElement)(target) && getComputedStyle(target).display === "inline";
};
var ResizeObservation = function() {
    function ResizeObservation(target, observedBox) {
        this.target = target;
        this.observedBox = observedBox || (0, _resizeObserverBoxOptions.ResizeObserverBoxOptions).CONTENT_BOX;
        this.lastReportedSize = {
            inlineSize: 0,
            blockSize: 0
        };
    }
    ResizeObservation.prototype.isActive = function() {
        var size = (0, _calculateBoxSize.calculateBoxSize)(this.target, this.observedBox, true);
        if (skipNotifyOnElement(this.target)) this.lastReportedSize = size;
        if (this.lastReportedSize.inlineSize !== size.inlineSize || this.lastReportedSize.blockSize !== size.blockSize) return true;
        return false;
    };
    return ResizeObservation;
}();

},{"./ResizeObserverBoxOptions":"dNYRq","./algorithms/calculateBoxSize":"5700d","./utils/element":"fYEXf","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"46Usx":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ResizeObserverDetail", ()=>ResizeObserverDetail);
var ResizeObserverDetail = function() {
    function ResizeObserverDetail(resizeObserver, callback) {
        this.activeTargets = [];
        this.skippedTargets = [];
        this.observationTargets = [];
        this.observer = resizeObserver;
        this.callback = callback;
    }
    return ResizeObserverDetail;
}();

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ifr9J":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "default", ()=>useResizeObserver);
var _react = require("react");
// This could've been more streamlined with internal state instead of abusing
// refs to such extent, but then composing hooks and components could not opt out of unnecessary renders.
function useResolvedElement(subscriber, refOrElement) {
    var lastReportRef = (0, _react.useRef)(null);
    var refOrElementRef = (0, _react.useRef)(null);
    refOrElementRef.current = refOrElement;
    var cbElementRef = (0, _react.useRef)(null); // Calling re-evaluation after each render without using a dep array,
    // as the ref object's current value could've changed since the last render.
    (0, _react.useEffect)(function() {
        evaluateSubscription();
    });
    var evaluateSubscription = (0, _react.useCallback)(function() {
        var cbElement = cbElementRef.current;
        var refOrElement = refOrElementRef.current; // Ugly ternary. But smaller than an if-else block.
        var element = cbElement ? cbElement : refOrElement ? refOrElement instanceof Element ? refOrElement : refOrElement.current : null;
        if (lastReportRef.current && lastReportRef.current.element === element && lastReportRef.current.subscriber === subscriber) return;
        if (lastReportRef.current && lastReportRef.current.cleanup) lastReportRef.current.cleanup();
        lastReportRef.current = {
            element: element,
            subscriber: subscriber,
            // Only calling the subscriber, if there's an actual element to report.
            // Setting cleanup to undefined unless a subscriber returns one, as an existing cleanup function would've been just called.
            cleanup: element ? subscriber(element) : undefined
        };
    }, [
        subscriber
    ]); // making sure we call the cleanup function on unmount
    (0, _react.useEffect)(function() {
        return function() {
            if (lastReportRef.current && lastReportRef.current.cleanup) {
                lastReportRef.current.cleanup();
                lastReportRef.current = null;
            }
        };
    }, []);
    return (0, _react.useCallback)(function(element) {
        cbElementRef.current = element;
        evaluateSubscription();
    }, [
        evaluateSubscription
    ]);
}
// We're only using the first element of the size sequences, until future versions of the spec solidify on how
// exactly it'll be used for fragments in multi-column scenarios:
// From the spec:
// > The box size properties are exposed as FrozenArray in order to support elements that have multiple fragments,
// > which occur in multi-column scenarios. However the current definitions of content rect and border box do not
// > mention how those boxes are affected by multi-column layout. In this spec, there will only be a single
// > ResizeObserverSize returned in the FrozenArray, which will correspond to the dimensions of the first column.
// > A future version of this spec will extend the returned FrozenArray to contain the per-fragment size information.
// (https://drafts.csswg.org/resize-observer/#resize-observer-entry-interface)
//
// Also, testing these new box options revealed that in both Chrome and FF everything is returned in the callback,
// regardless of the "box" option.
// The spec states the following on this:
// > This does not have any impact on which box dimensions are returned to the defined callback when the event
// > is fired, it solely defines which box the author wishes to observe layout changes on.
// (https://drafts.csswg.org/resize-observer/#resize-observer-interface)
// I'm not exactly clear on what this means, especially when you consider a later section stating the following:
// > This section is non-normative. An author may desire to observe more than one CSS box.
// > In this case, author will need to use multiple ResizeObservers.
// (https://drafts.csswg.org/resize-observer/#resize-observer-interface)
// Which is clearly not how current browser implementations behave, and seems to contradict the previous quote.
// For this reason I decided to only return the requested size,
// even though it seems we have access to results for all box types.
// This also means that we get to keep the current api, being able to return a simple { width, height } pair,
// regardless of box option.
function extractSize(entry, boxProp, sizeType) {
    if (!entry[boxProp]) {
        if (boxProp === "contentBoxSize") // The dimensions in `contentBoxSize` and `contentRect` are equivalent according to the spec.
        // See the 6th step in the description for the RO algorithm:
        // https://drafts.csswg.org/resize-observer/#create-and-populate-resizeobserverentry-h
        // > Set this.contentRect to logical this.contentBoxSize given target and observedBox of "content-box".
        // In real browser implementations of course these objects differ, but the width/height values should be equivalent.
        return entry.contentRect[sizeType === "inlineSize" ? "width" : "height"];
        return undefined;
    } // A couple bytes smaller than calling Array.isArray() and just as effective here.
    return entry[boxProp][0] ? entry[boxProp][0][sizeType] : // behaviour of returning objects instead of arrays for `borderBoxSize` and `contentBoxSize`.
    // @ts-ignore
    entry[boxProp][sizeType];
}
function useResizeObserver(opts) {
    if (opts === void 0) opts = {};
    // Saving the callback as a ref. With this, I don't need to put onResize in the
    // effect dep array, and just passing in an anonymous function without memoising
    // will not reinstantiate the hook's ResizeObserver.
    var onResize = opts.onResize;
    var onResizeRef = (0, _react.useRef)(undefined);
    onResizeRef.current = onResize;
    var round = opts.round || Math.round; // Using a single instance throughout the hook's lifetime
    var resizeObserverRef = (0, _react.useRef)();
    var _useState = (0, _react.useState)({
        width: undefined,
        height: undefined
    }), size = _useState[0], setSize = _useState[1]; // In certain edge cases the RO might want to report a size change just after
    // the component unmounted.
    var didUnmount = (0, _react.useRef)(false);
    (0, _react.useEffect)(function() {
        didUnmount.current = false;
        return function() {
            didUnmount.current = true;
        };
    }, []); // Using a ref to track the previous width / height to avoid unnecessary renders.
    var previous = (0, _react.useRef)({
        width: undefined,
        height: undefined
    }); // This block is kinda like a useEffect, only it's called whenever a new
    // element could be resolved based on the ref option. It also has a cleanup
    // function.
    var refCallback = useResolvedElement((0, _react.useCallback)(function(element) {
        // We only use a single Resize Observer instance, and we're instantiating it on demand, only once there's something to observe.
        // This instance is also recreated when the `box` option changes, so that a new observation is fired if there was a previously observed element with a different box option.
        if (!resizeObserverRef.current || resizeObserverRef.current.box !== opts.box || resizeObserverRef.current.round !== round) resizeObserverRef.current = {
            box: opts.box,
            round: round,
            instance: new ResizeObserver(function(entries) {
                var entry = entries[0];
                var boxProp = opts.box === "border-box" ? "borderBoxSize" : opts.box === "device-pixel-content-box" ? "devicePixelContentBoxSize" : "contentBoxSize";
                var reportedWidth = extractSize(entry, boxProp, "inlineSize");
                var reportedHeight = extractSize(entry, boxProp, "blockSize");
                var newWidth = reportedWidth ? round(reportedWidth) : undefined;
                var newHeight = reportedHeight ? round(reportedHeight) : undefined;
                if (previous.current.width !== newWidth || previous.current.height !== newHeight) {
                    var newSize = {
                        width: newWidth,
                        height: newHeight
                    };
                    previous.current.width = newWidth;
                    previous.current.height = newHeight;
                    if (onResizeRef.current) onResizeRef.current(newSize);
                    else if (!didUnmount.current) setSize(newSize);
                }
            })
        };
        resizeObserverRef.current.instance.observe(element, {
            box: opts.box
        });
        return function() {
            if (resizeObserverRef.current) resizeObserverRef.current.instance.unobserve(element);
        };
    }, [
        opts.box,
        round
    ]), opts.ref);
    return (0, _react.useMemo)(function() {
        return {
            ref: refCallback,
            width: size.width,
            height: size.height
        };
    }, [
        refCallback,
        size.width,
        size.height
    ]);
}

},{"react":"aF0cT","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"g1DsO":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _preact = require("preact");
var _hooks = require("preact/hooks");
function rowSpaner(stopGrid, column, stop) {
    if (!stop) return 1;
    let span = 1;
    let rowIndex = stopGrid.findIndex((pair)=>pair[column] === stop);
    while(stopGrid[++rowIndex] && !stopGrid[rowIndex][column]){
        // Indicate the column has been rowspan-ed
        stopGrid[rowIndex][column] = "___";
        span++;
    }
    return span;
}
function isOpposite(stop) {
    return /[19]$/.test(stop);
}
function getOpposite(stop) {
    if (isOpposite(stop)) return stop.replace(/[19]$/, (d)=>d === "1" ? 9 : 1);
    return null;
}
function areOpposite(stop1, stop2) {
    if (!stop1 || !stop2) return false;
    return stop1 !== stop2 && stop1 === getOpposite(stop2);
}
function StopsList(props) {
    const { routes , stopsData , onStopClick , onStopClickAgain  } = props;
    if (!routes || !routes.length || routes[0].length <= 1 || routes[1] && routes[1].length <= 1 || !stopsData) {
        console.warn("Invalid arguments");
        return null;
    }
    const [route1, route2] = routes;
    if (route1 && route2) {
        if (route1[0] === route2[0]) console.warn("Both routes start from same point", route1[0]);
        if (route1[route1.length - 1] === route2[route2.length - 1]) console.warn("Both routes end at same point", route1[route1.length - 1]);
        if (route1[route1.length - 1] === route2[0] && route2[route2.length - 1] !== route1[0]) console.warn("First route connects to the 2nd route. Why?", route1[route1.length - 1], route2[0], route2[route2.length - 1], route1[0]);
    }
    const route1Len = route1.length;
    const route1FirstStop = route1[0];
    const route1LastStop = route1[route1Len - 1];
    const lastStop = (0, _hooks.useRef)();
    const StopLink = ({ stop  })=>stop ? (0, _preact.h)("a", {
            href: `#/stops/${stop}`,
            "data-stop": stop,
            onClick: (e)=>{
                e.preventDefault();
                if (lastStop.current === stop && onStopClickAgain) onStopClickAgain(stop);
                else if (onStopClick) onStopClick(stop);
                lastStop.current = stop;
            }
        }, (0, _preact.h)("b", {
            class: "mini-stop-tag"
        }, stop), (0, _preact.h)("br", null), stopsData[stop].name) : null;
    // Only 1 route & not a loop
    if (!route2 && route1FirstStop !== route1LastStop) {
        // Contains duplicates
        if (route1.some((val, i)=>route1.indexOf(val) !== i)) // Do nothing for now, this is very edge case
        console.info("Duplicate stops found on 1-way route.");
        console.warn();
        return (0, _preact.h)("ol", {
            class: "stops-list"
        }, route1.map((s)=>(0, _preact.h)("li", null, (0, _preact.h)(StopLink, {
                stop: s
            }))));
    } else {
        // Complex table layout for complex routes yo
        const stopGrid = [];
        // Create mutable copies
        let route1Copy, route2Copy;
        let loopRoute = false; // A->A
        if (route2) {
            route1Copy = route1.slice();
            route2Copy = route2.slice().reverse(); // Reverse for easier index reference
        } else {
            // Mostly likely a loop route A⟲B
            // So, split route1 into two routes
            loopRoute = true;
            let half;
            let hasMidStop = false;
            const hasDupStops = [];
            for(let i = 1, j = route1Len - 2; route1Len > 3 && !half; i++, j--){
                const stop = route1[i];
                // console.log(i, j, route1, 1, stop);
                if (isOpposite(stop)) {
                    // WEIRD CASE: the route has duplicate stops!
                    // Don't check first item because last item is its duplicate in loop route
                    if (i !== route1.lastIndexOf(stop)) // TODO: Handle this usecase?
                    // Do nothing for now
                    hasDupStops.push(stop);
                    else {
                        // Normal case, let's find the middle index
                        const opStop = getOpposite(route1[i]);
                        const index = route1.lastIndexOf(opStop);
                        if (index > 0) j = index;
                    }
                }
                if (i === j - 1) half = j;
                else if (i === j) {
                    half = j;
                    hasMidStop = true;
                }
            }
            if (hasDupStops.length) console.info("This loop route has duplicate stops.", hasDupStops);
            route1Copy = route1.slice(0, half);
            route2Copy = route1.slice(-(route1Len - half - (hasMidStop ? 1 : 0))).reverse();
            // console.log('x', half, route1, route1Copy, route2Copy);
            /*
      const half = Math.floor(route1Len / 2);
      route1Copy = route1.slice(0, half);
      route2Copy = route1.slice(-half).reverse();
      */ if (hasMidStop) {
                // Odd
                const midStop = route1[half];
                console.log({
                    midStop
                });
                if (areOpposite(midStop, route1[half - 1])) {
                    // ~~~ = Dummy stop to connect at the end
                    route2Copy.push(midStop, "~~~");
                    route1Copy.push("~~~");
                } else if (areOpposite(midStop, route1[half + 1])) {
                    route1Copy.push(midStop, "~~~");
                    route2Copy.push("~~~");
                } else {
                    // Throw in both because it'll be merged and rendered as a single stop later
                    route1Copy.push(midStop);
                    route2Copy.push(midStop);
                }
            } else {
                // Even
                route1Copy.push("~~~");
                route2Copy.push("~~~");
            }
        }
        console.log({
            route1Copy: route1Copy.slice(),
            route2Copy: route2Copy.slice()
        });
        // const oppositeStops = [];
        // route1Copy.forEach((s, i) => {
        //   const opS = getOpposite(s);
        //   if (opS) {
        //     if (
        //       route2Copy.includes(opS) &&
        //       !route1Copy.includes(opS) &&
        //       !route2Copy.includes(s)
        //     ) {
        //       oppositeStops.push(s, opS);
        //     }
        //   }
        // });
        let i1 = 0;
        const maxLoopCount = route1Copy.length + route2Copy.length;
        let col1IsEmpty = true, col2IsEmpty = true;
        let col1FirstStop = false, col2FirstStop = false, col1LastStop = false, col2LastStop = false;
        do {
            const stop1HasOpposite = route2Copy.includes(getOpposite(route1Copy[0]));
            const stop2HasOpposite = route1Copy.includes(getOpposite(route2Copy[0]));
            const stop1IsLast = route1Copy.length === 1 || !route1Copy.length;
            const stop2IsLast = route2Copy.length === 1 || !route2Copy.length;
            if (loopRoute && i1 === 0) stopGrid[i1] = [
                route1Copy.shift(),
                route2Copy.shift()
            ];
            else if (stop1HasOpposite && !stop2HasOpposite || stop1IsLast && !stop1HasOpposite && !stop2IsLast && !stop2HasOpposite) stopGrid[i1] = [
                null,
                route2Copy.shift()
            ];
            else if (!stop1HasOpposite && stop2HasOpposite || stop2IsLast && !stop2HasOpposite && !stop1IsLast && !stop1HasOpposite) stopGrid[i1] = [
                route1Copy.shift(),
                null
            ];
            else stopGrid[i1] = [
                route1Copy.shift(),
                route2Copy.shift()
            ];
            // Check empty columns
            if (stopGrid[i1]?.[0] && col1IsEmpty) col1IsEmpty = false;
            else if (!stopGrid[i1]?.[0] && !route1Copy.length) col1IsEmpty = true;
            if (stopGrid[i1]?.[1] && col2IsEmpty) col2IsEmpty = false;
            else if (!stopGrid[i1]?.[1] && !route2Copy.length) col2IsEmpty = true;
            // Extra metadata
            const metadata = {
                isSame: stopGrid[i1][0] === stopGrid[i1][1],
                // Same stop (very lazy check, no snapping)
                isOpposite: areOpposite(stopGrid[i1][0], stopGrid[i1][1]),
                col1IsEmpty,
                col2IsEmpty
            };
            // Check first/last stops
            if (stopGrid[i1]?.[0] && !col1FirstStop) metadata.col1FirstStop = col1FirstStop = true;
            if (stopGrid[i1]?.[1] && !col2FirstStop) metadata.col2FirstStop = col2FirstStop = true;
            if (!route1Copy.length && !col1LastStop) metadata.col1LastStop = col1LastStop = true;
            if (!route2Copy.length && !col2LastStop) metadata.col2LastStop = col2LastStop = true;
            // Final metadata push
            stopGrid[i1]?.push(metadata);
            // Infinite loop guard
            if (i1 > maxLoopCount + 2) {
                console.error("Something is wrong. Might be infinite loop", i1, route1Copy, route2Copy, stopGrid);
                return null;
            }
            i1++;
        }while (route1Copy[0] || route2Copy[0]);
        // Postfix for loop routes (A->A)
        if (loopRoute) {
            const lastRow = stopGrid[stopGrid.length - 1];
            const last2ndRow = stopGrid[stopGrid.length - 2];
            if (lastRow[0] === lastRow[1] && last2ndRow?.includes(null)) {
                const [s1, s2, meta] = last2ndRow;
                if (lastRow[0] === "~~~") {
                    const theStop = /\d/.test(s1) ? s1 : s2;
                    stopGrid[stopGrid.length - 2] = [
                        theStop,
                        theStop,
                        {
                            ...meta,
                            col1LastStop: true,
                            col2LastStop: true
                        }
                    ];
                    stopGrid.pop();
                } else if (lastRow[0]) {
                    if (!s1) last2ndRow[0] = lastRow[0];
                    if (!s2) last2ndRow[1] = lastRow[0];
                    if (!s1 || !s2) stopGrid[stopGrid.length - 1] = [
                        "~~~",
                        "~~~",
                        {
                            col1LastStop: true,
                            col2LastStop: true
                        }
                    ];
                }
            }
        }
        console.log({
            route1,
            route2,
            stopGrid
        });
        const stopGridStops = stopGrid.flat().filter((v)=>/\d/.test(v)).filter((value, index, array)=>array.indexOf(value) == index);
        const routeStops = [
            ...route1,
            ...route2 || []
        ].filter((value, index, array)=>array.indexOf(value) == index);
        if (stopGridStops.length !== routeStops.length) console.error("Some stops are missing!", stopGridStops, routeStops);
        return (0, _preact.h)("table", {
            class: "stops-table"
        }, (0, _preact.h)("colgroup", null, (0, _preact.h)("col", {
            class: "stop"
        }), (0, _preact.h)("col", {
            class: "middle"
        }), (0, _preact.h)("col", {
            class: "stop"
        })), stopGrid.map(([s1, s2, { isSame , isOpposite , col1IsEmpty , col2IsEmpty , col1FirstStop , col2FirstStop , col1LastStop , col2LastStop  }], index)=>{
            const isEdgeRows = (index === 0 || index === stopGrid.length - 1) && s1 === s2;
            return (0, _preact.h)((0, _preact.Fragment), null, index === 0 && (0, _preact.h)("tr", null, (0, _preact.h)("td", {
                colspan: "3"
            })), (0, _preact.h)("tr", {
                class: isEdgeRows ? "edge" : ""
            }, isEdgeRows ? (0, _preact.h)("td", {
                class: `stop-${s1 === "~~~" ? "u" : index === 0 ? "start" : "end"} ${loopRoute ? "loop" : ""}`,
                colspan: "3"
            }, s1 !== "~~~" && (0, _preact.h)(StopLink, {
                stop: s1
            })) : (0, _preact.h)((0, _preact.Fragment), null, s1 ? s1 !== "___" && (0, _preact.h)("td", {
                class: `${col1IsEmpty ? "" : "stop"} ${col1FirstStop ? "first" : ""} ${col1LastStop ? "last" : ""}`,
                rowspan: isOpposite || index === stopGrid.length - 1 || index === 0 ? 1 : rowSpaner(stopGrid, 0, s1)
            }, (0, _preact.h)(StopLink, {
                stop: s1
            })) : (0, _preact.h)("td", {
                class: col1IsEmpty ? "" : "empty"
            }), (0, _preact.h)("td", {
                class: isOpposite ? "opposite" : isSame ? "same" : ""
            }), s2 ? s2 !== "___" && (0, _preact.h)("td", {
                class: `${col2IsEmpty ? "" : "stop"} ${col2FirstStop ? "first" : ""} ${col2LastStop ? "last" : ""}`,
                rowspan: isOpposite || index === stopGrid.length - 1 || index === 0 ? 1 : rowSpaner(stopGrid, 1, s2)
            }, (0, _preact.h)(StopLink, {
                stop: s2
            })) : (0, _preact.h)("td", {
                class: col2IsEmpty ? "" : "empty"
            }))));
        }));
    }
    return null;
}
exports.default = StopsList;

},{"preact":"26zcy","preact/hooks":"eZN76","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fxBVM":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("9pgM9") + "stop.8f869b64.png" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"9AfrY":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("9pgM9") + "stop-end.9c43e5c0.png" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"fLAIi":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("9pgM9") + "open-new-window.91e0c18c.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"hxj0B":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("9pgM9") + "open-new-window-blue.37a14235.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"P8gmu":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("9pgM9") + "passing-routes-blue.2146ac26.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"1E4jG":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("9pgM9") + "icon.697525d4.svg" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"4Evke":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("9pgM9") + "service-worker.js" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}]},["dfbnL","aeGU1"], "aeGU1", "parcelRequireda9d")

//# sourceMappingURL=index.f04a6e97.js.map
