// modules are defined as an array
// [ module function, map of requires ]
//
// map of requires is short require name -> numeric require
//
// anything defined in a previous bundle is accessed via the
// orig method which is the require for previous bundles

(function (modules, entry, mainEntry, parcelRequireName, globalName) {
  /* eslint-disable no-undef */
  var globalObject =
    typeof globalThis !== 'undefined'
      ? globalThis
      : typeof self !== 'undefined'
      ? self
      : typeof window !== 'undefined'
      ? window
      : typeof global !== 'undefined'
      ? global
      : {};
  /* eslint-enable no-undef */

  // Save the require from previous bundle to this closure if any
  var previousRequire =
    typeof globalObject[parcelRequireName] === 'function' &&
    globalObject[parcelRequireName];

  var cache = previousRequire.cache || {};
  // Do not use `require` to prevent Webpack from trying to bundle this call
  var nodeRequire =
    typeof module !== 'undefined' &&
    typeof module.require === 'function' &&
    module.require.bind(module);

  function newRequire(name, jumped) {
    if (!cache[name]) {
      if (!modules[name]) {
        // if we cannot find the module within our internal map or
        // cache jump to the current global require ie. the last bundle
        // that was added to the page.
        var currentRequire =
          typeof globalObject[parcelRequireName] === 'function' &&
          globalObject[parcelRequireName];
        if (!jumped && currentRequire) {
          return currentRequire(name, true);
        }

        // If there are other bundles on this page the require from the
        // previous one is saved to 'previousRequire'. Repeat this as
        // many times as there are bundles until the module is found or
        // we exhaust the require chain.
        if (previousRequire) {
          return previousRequire(name, true);
        }

        // Try the node require function if it exists.
        if (nodeRequire && typeof name === 'string') {
          return nodeRequire(name);
        }

        var err = new Error("Cannot find module '" + name + "'");
        err.code = 'MODULE_NOT_FOUND';
        throw err;
      }

      localRequire.resolve = resolve;
      localRequire.cache = {};

      var module = (cache[name] = new newRequire.Module(name));

      modules[name][0].call(
        module.exports,
        localRequire,
        module,
        module.exports,
        this
      );
    }

    return cache[name].exports;

    function localRequire(x) {
      var res = localRequire.resolve(x);
      return res === false ? {} : newRequire(res);
    }

    function resolve(x) {
      var id = modules[name][1][x];
      return id != null ? id : x;
    }
  }

  function Module(moduleName) {
    this.id = moduleName;
    this.bundle = newRequire;
    this.exports = {};
  }

  newRequire.isParcelRequire = true;
  newRequire.Module = Module;
  newRequire.modules = modules;
  newRequire.cache = cache;
  newRequire.parent = previousRequire;
  newRequire.register = function (id, exports) {
    modules[id] = [
      function (require, module) {
        module.exports = exports;
      },
      {},
    ];
  };

  Object.defineProperty(newRequire, 'root', {
    get: function () {
      return globalObject[parcelRequireName];
    },
  });

  globalObject[parcelRequireName] = newRequire;

  for (var i = 0; i < entry.length; i++) {
    newRequire(entry[i]);
  }

  if (mainEntry) {
    // Expose entry point to Node, AMD or browser globals
    // Based on https://github.com/ForbesLindesay/umd/blob/master/template.js
    var mainExports = newRequire(mainEntry);

    // CommonJS
    if (typeof exports === 'object' && typeof module !== 'undefined') {
      module.exports = mainExports;

      // RequireJS
    } else if (typeof define === 'function' && define.amd) {
      define(function () {
        return mainExports;
      });

      // <script>
    } else if (globalName) {
      this[globalName] = mainExports;
    }
  }
})({"gHhew":[function(require,module,exports) {
var global = arguments[3];
var HMR_HOST = null;
var HMR_PORT = null;
var HMR_SECURE = false;
var HMR_ENV_HASH = "d6ea1d42532a7575";
module.bundle.HMR_BUNDLE_ID = "ae58109abc01c452";
"use strict";
/* global HMR_HOST, HMR_PORT, HMR_ENV_HASH, HMR_SECURE, chrome, browser, globalThis, __parcel__import__, __parcel__importScripts__, ServiceWorkerGlobalScope */ /*::
import type {
  HMRAsset,
  HMRMessage,
} from '@parcel/reporter-dev-server/src/HMRServer.js';
interface ParcelRequire {
  (string): mixed;
  cache: {|[string]: ParcelModule|};
  hotData: mixed;
  Module: any;
  parent: ?ParcelRequire;
  isParcelRequire: true;
  modules: {|[string]: [Function, {|[string]: string|}]|};
  HMR_BUNDLE_ID: string;
  root: ParcelRequire;
}
interface ParcelModule {
  hot: {|
    data: mixed,
    accept(cb: (Function) => void): void,
    dispose(cb: (mixed) => void): void,
    // accept(deps: Array<string> | string, cb: (Function) => void): void,
    // decline(): void,
    _acceptCallbacks: Array<(Function) => void>,
    _disposeCallbacks: Array<(mixed) => void>,
  |};
}
interface ExtensionContext {
  runtime: {|
    reload(): void,
    getURL(url: string): string;
    getManifest(): {manifest_version: number, ...};
  |};
}
declare var module: {bundle: ParcelRequire, ...};
declare var HMR_HOST: string;
declare var HMR_PORT: string;
declare var HMR_ENV_HASH: string;
declare var HMR_SECURE: boolean;
declare var chrome: ExtensionContext;
declare var browser: ExtensionContext;
declare var __parcel__import__: (string) => Promise<void>;
declare var __parcel__importScripts__: (string) => Promise<void>;
declare var globalThis: typeof self;
declare var ServiceWorkerGlobalScope: Object;
*/ var OVERLAY_ID = "__parcel__error__overlay__";
var OldModule = module.bundle.Module;
function Module(moduleName) {
    OldModule.call(this, moduleName);
    this.hot = {
        data: module.bundle.hotData,
        _acceptCallbacks: [],
        _disposeCallbacks: [],
        accept: function(fn) {
            this._acceptCallbacks.push(fn || function() {});
        },
        dispose: function(fn) {
            this._disposeCallbacks.push(fn);
        }
    };
    module.bundle.hotData = undefined;
}
module.bundle.Module = Module;
var checkedAssets, acceptedAssets, assetsToAccept /*: Array<[ParcelRequire, string]> */ ;
function getHostname() {
    return HMR_HOST || (location.protocol.indexOf("http") === 0 ? location.hostname : "localhost");
}
function getPort() {
    return HMR_PORT || location.port;
} // eslint-disable-next-line no-redeclare
var parent = module.bundle.parent;
if ((!parent || !parent.isParcelRequire) && typeof WebSocket !== "undefined") {
    var hostname = getHostname();
    var port = getPort();
    var protocol = HMR_SECURE || location.protocol == "https:" && !/localhost|127.0.0.1|0.0.0.0/.test(hostname) ? "wss" : "ws";
    var ws = new WebSocket(protocol + "://" + hostname + (port ? ":" + port : "") + "/"); // Web extension context
    var extCtx = typeof chrome === "undefined" ? typeof browser === "undefined" ? null : browser : chrome; // Safari doesn't support sourceURL in error stacks.
    // eval may also be disabled via CSP, so do a quick check.
    var supportsSourceURL = false;
    try {
        (0, eval)('throw new Error("test"); //# sourceURL=test.js');
    } catch (err) {
        supportsSourceURL = err.stack.includes("test.js");
    } // $FlowFixMe
    ws.onmessage = async function(event) {
        checkedAssets = {} /*: {|[string]: boolean|} */ ;
        acceptedAssets = {} /*: {|[string]: boolean|} */ ;
        assetsToAccept = [];
        var data = JSON.parse(event.data);
        if (data.type === "update") {
            // Remove error overlay if there is one
            if (typeof document !== "undefined") removeErrorOverlay();
            let assets = data.assets.filter((asset)=>asset.envHash === HMR_ENV_HASH); // Handle HMR Update
            let handled = assets.every((asset)=>{
                return asset.type === "css" || asset.type === "js" && hmrAcceptCheck(module.bundle.root, asset.id, asset.depsByBundle);
            });
            if (handled) {
                console.clear(); // Dispatch custom event so other runtimes (e.g React Refresh) are aware.
                if (typeof window !== "undefined" && typeof CustomEvent !== "undefined") window.dispatchEvent(new CustomEvent("parcelhmraccept"));
                await hmrApplyUpdates(assets);
                for(var i = 0; i < assetsToAccept.length; i++){
                    var id = assetsToAccept[i][1];
                    if (!acceptedAssets[id]) hmrAcceptRun(assetsToAccept[i][0], id);
                }
            } else fullReload();
        }
        if (data.type === "error") {
            // Log parcel errors to console
            for (let ansiDiagnostic of data.diagnostics.ansi){
                let stack = ansiDiagnostic.codeframe ? ansiDiagnostic.codeframe : ansiDiagnostic.stack;
                console.error("\uD83D\uDEA8 [parcel]: " + ansiDiagnostic.message + "\n" + stack + "\n\n" + ansiDiagnostic.hints.join("\n"));
            }
            if (typeof document !== "undefined") {
                // Render the fancy html overlay
                removeErrorOverlay();
                var overlay = createErrorOverlay(data.diagnostics.html); // $FlowFixMe
                document.body.appendChild(overlay);
            }
        }
    };
    ws.onerror = function(e) {
        console.error(e.message);
    };
    ws.onclose = function() {
        console.warn("[parcel] \uD83D\uDEA8 Connection to the HMR server was lost");
    };
}
function removeErrorOverlay() {
    var overlay = document.getElementById(OVERLAY_ID);
    if (overlay) {
        overlay.remove();
        console.log("[parcel] ✨ Error resolved");
    }
}
function createErrorOverlay(diagnostics) {
    var overlay = document.createElement("div");
    overlay.id = OVERLAY_ID;
    let errorHTML = '<div style="background: black; opacity: 0.85; font-size: 16px; color: white; position: fixed; height: 100%; width: 100%; top: 0px; left: 0px; padding: 30px; font-family: Menlo, Consolas, monospace; z-index: 9999;">';
    for (let diagnostic of diagnostics){
        let stack = diagnostic.frames.length ? diagnostic.frames.reduce((p, frame)=>{
            return `${p}
<a href="/__parcel_launch_editor?file=${encodeURIComponent(frame.location)}" style="text-decoration: underline; color: #888" onclick="fetch(this.href); return false">${frame.location}</a>
${frame.code}`;
        }, "") : diagnostic.stack;
        errorHTML += `
      <div>
        <div style="font-size: 18px; font-weight: bold; margin-top: 20px;">
          🚨 ${diagnostic.message}
        </div>
        <pre>${stack}</pre>
        <div>
          ${diagnostic.hints.map((hint)=>"<div>\uD83D\uDCA1 " + hint + "</div>").join("")}
        </div>
        ${diagnostic.documentation ? `<div>📝 <a style="color: violet" href="${diagnostic.documentation}" target="_blank">Learn more</a></div>` : ""}
      </div>
    `;
    }
    errorHTML += "</div>";
    overlay.innerHTML = errorHTML;
    return overlay;
}
function fullReload() {
    if ("reload" in location) location.reload();
    else if (extCtx && extCtx.runtime && extCtx.runtime.reload) extCtx.runtime.reload();
}
function getParents(bundle, id) /*: Array<[ParcelRequire, string]> */ {
    var modules = bundle.modules;
    if (!modules) return [];
    var parents = [];
    var k, d, dep;
    for(k in modules)for(d in modules[k][1]){
        dep = modules[k][1][d];
        if (dep === id || Array.isArray(dep) && dep[dep.length - 1] === id) parents.push([
            bundle,
            k
        ]);
    }
    if (bundle.parent) parents = parents.concat(getParents(bundle.parent, id));
    return parents;
}
function updateLink(link) {
    var newLink = link.cloneNode();
    newLink.onload = function() {
        if (link.parentNode !== null) // $FlowFixMe
        link.parentNode.removeChild(link);
    };
    newLink.setAttribute("href", link.getAttribute("href").split("?")[0] + "?" + Date.now()); // $FlowFixMe
    link.parentNode.insertBefore(newLink, link.nextSibling);
}
var cssTimeout = null;
function reloadCSS() {
    if (cssTimeout) return;
    cssTimeout = setTimeout(function() {
        var links = document.querySelectorAll('link[rel="stylesheet"]');
        for(var i = 0; i < links.length; i++){
            // $FlowFixMe[incompatible-type]
            var href = links[i].getAttribute("href");
            var hostname = getHostname();
            var servedFromHMRServer = hostname === "localhost" ? new RegExp("^(https?:\\/\\/(0.0.0.0|127.0.0.1)|localhost):" + getPort()).test(href) : href.indexOf(hostname + ":" + getPort());
            var absolute = /^https?:\/\//i.test(href) && href.indexOf(location.origin) !== 0 && !servedFromHMRServer;
            if (!absolute) updateLink(links[i]);
        }
        cssTimeout = null;
    }, 50);
}
function hmrDownload(asset) {
    if (asset.type === "js") {
        if (typeof document !== "undefined") {
            let script = document.createElement("script");
            script.src = asset.url + "?t=" + Date.now();
            if (asset.outputFormat === "esmodule") script.type = "module";
            return new Promise((resolve, reject)=>{
                var _document$head;
                script.onload = ()=>resolve(script);
                script.onerror = reject;
                (_document$head = document.head) === null || _document$head === void 0 || _document$head.appendChild(script);
            });
        } else if (typeof importScripts === "function") {
            // Worker scripts
            if (asset.outputFormat === "esmodule") return import(asset.url + "?t=" + Date.now());
            else return new Promise((resolve, reject)=>{
                try {
                    importScripts(asset.url + "?t=" + Date.now());
                    resolve();
                } catch (err) {
                    reject(err);
                }
            });
        }
    }
}
async function hmrApplyUpdates(assets) {
    global.parcelHotUpdate = Object.create(null);
    let scriptsToRemove;
    try {
        // If sourceURL comments aren't supported in eval, we need to load
        // the update from the dev server over HTTP so that stack traces
        // are correct in errors/logs. This is much slower than eval, so
        // we only do it if needed (currently just Safari).
        // https://bugs.webkit.org/show_bug.cgi?id=137297
        // This path is also taken if a CSP disallows eval.
        if (!supportsSourceURL) {
            let promises = assets.map((asset)=>{
                var _hmrDownload;
                return (_hmrDownload = hmrDownload(asset)) === null || _hmrDownload === void 0 ? void 0 : _hmrDownload.catch((err)=>{
                    // Web extension bugfix for Chromium
                    // https://bugs.chromium.org/p/chromium/issues/detail?id=1255412#c12
                    if (extCtx && extCtx.runtime && extCtx.runtime.getManifest().manifest_version == 3) {
                        if (typeof ServiceWorkerGlobalScope != "undefined" && global instanceof ServiceWorkerGlobalScope) {
                            extCtx.runtime.reload();
                            return;
                        }
                        asset.url = extCtx.runtime.getURL("/__parcel_hmr_proxy__?url=" + encodeURIComponent(asset.url + "?t=" + Date.now()));
                        return hmrDownload(asset);
                    }
                    throw err;
                });
            });
            scriptsToRemove = await Promise.all(promises);
        }
        assets.forEach(function(asset) {
            hmrApply(module.bundle.root, asset);
        });
    } finally{
        delete global.parcelHotUpdate;
        if (scriptsToRemove) scriptsToRemove.forEach((script)=>{
            if (script) {
                var _document$head2;
                (_document$head2 = document.head) === null || _document$head2 === void 0 || _document$head2.removeChild(script);
            }
        });
    }
}
function hmrApply(bundle, asset) {
    var modules = bundle.modules;
    if (!modules) return;
    if (asset.type === "css") reloadCSS();
    else if (asset.type === "js") {
        let deps = asset.depsByBundle[bundle.HMR_BUNDLE_ID];
        if (deps) {
            if (modules[asset.id]) {
                // Remove dependencies that are removed and will become orphaned.
                // This is necessary so that if the asset is added back again, the cache is gone, and we prevent a full page reload.
                let oldDeps = modules[asset.id][1];
                for(let dep in oldDeps)if (!deps[dep] || deps[dep] !== oldDeps[dep]) {
                    let id = oldDeps[dep];
                    let parents = getParents(module.bundle.root, id);
                    if (parents.length === 1) hmrDelete(module.bundle.root, id);
                }
            }
            if (supportsSourceURL) // Global eval. We would use `new Function` here but browser
            // support for source maps is better with eval.
            (0, eval)(asset.output);
             // $FlowFixMe
            let fn = global.parcelHotUpdate[asset.id];
            modules[asset.id] = [
                fn,
                deps
            ];
        } else if (bundle.parent) hmrApply(bundle.parent, asset);
    }
}
function hmrDelete(bundle, id) {
    let modules = bundle.modules;
    if (!modules) return;
    if (modules[id]) {
        // Collect dependencies that will become orphaned when this module is deleted.
        let deps = modules[id][1];
        let orphans = [];
        for(let dep in deps){
            let parents = getParents(module.bundle.root, deps[dep]);
            if (parents.length === 1) orphans.push(deps[dep]);
        } // Delete the module. This must be done before deleting dependencies in case of circular dependencies.
        delete modules[id];
        delete bundle.cache[id]; // Now delete the orphans.
        orphans.forEach((id)=>{
            hmrDelete(module.bundle.root, id);
        });
    } else if (bundle.parent) hmrDelete(bundle.parent, id);
}
function hmrAcceptCheck(bundle, id, depsByBundle) {
    if (hmrAcceptCheckOne(bundle, id, depsByBundle)) return true;
     // Traverse parents breadth first. All possible ancestries must accept the HMR update, or we'll reload.
    let parents = getParents(module.bundle.root, id);
    let accepted = false;
    while(parents.length > 0){
        let v = parents.shift();
        let a = hmrAcceptCheckOne(v[0], v[1], null);
        if (a) // If this parent accepts, stop traversing upward, but still consider siblings.
        accepted = true;
        else {
            // Otherwise, queue the parents in the next level upward.
            let p = getParents(module.bundle.root, v[1]);
            if (p.length === 0) {
                // If there are no parents, then we've reached an entry without accepting. Reload.
                accepted = false;
                break;
            }
            parents.push(...p);
        }
    }
    return accepted;
}
function hmrAcceptCheckOne(bundle, id, depsByBundle) {
    var modules = bundle.modules;
    if (!modules) return;
    if (depsByBundle && !depsByBundle[bundle.HMR_BUNDLE_ID]) {
        // If we reached the root bundle without finding where the asset should go,
        // there's nothing to do. Mark as "accepted" so we don't reload the page.
        if (!bundle.parent) return true;
        return hmrAcceptCheck(bundle.parent, id, depsByBundle);
    }
    if (checkedAssets[id]) return true;
    checkedAssets[id] = true;
    var cached = bundle.cache[id];
    assetsToAccept.push([
        bundle,
        id
    ]);
    if (!cached || cached.hot && cached.hot._acceptCallbacks.length) return true;
}
function hmrAcceptRun(bundle, id) {
    var cached = bundle.cache[id];
    bundle.hotData = {};
    if (cached && cached.hot) cached.hot.data = bundle.hotData;
    if (cached && cached.hot && cached.hot._disposeCallbacks.length) cached.hot._disposeCallbacks.forEach(function(cb) {
        cb(bundle.hotData);
    });
    delete bundle.cache[id];
    bundle(id);
    cached = bundle.cache[id];
    if (cached && cached.hot && cached.hot._acceptCallbacks.length) cached.hot._acceptCallbacks.forEach(function(cb) {
        var assetsToAlsoAccept = cb(function() {
            return getParents(module.bundle.root, id);
        });
        if (assetsToAlsoAccept && assetsToAccept.length) // $FlowFixMe[method-unbinding]
        assetsToAccept.push.apply(assetsToAccept, assetsToAlsoAccept);
    });
    acceptedAssets[id] = true;
}

},{}],"bHhB8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
var _maplibreGl = require("maplibre-gl");
var _maplibreGlDefault = parcelHelpers.interopDefault(_maplibreGl);
var _mapboxLayer = require("@deck.gl/mapbox/dist/esm/mapbox-layer");
var _mapboxLayerDefault = parcelHelpers.interopDefault(_mapboxLayer);
var _solidPolygonLayer = require("@deck.gl/layers/dist/esm/solid-polygon-layer/solid-polygon-layer");
var _solidPolygonLayerDefault = parcelHelpers.interopDefault(_solidPolygonLayer);
var _pathLayer = require("@deck.gl/layers/dist/esm/path-layer/path-layer");
var _pathLayerDefault = parcelHelpers.interopDefault(_pathLayer);
var _bus = require("../assets/utils/bus");
var _fetchCache = require("../assets/utils/fetchCache");
var _fetchCacheDefault = parcelHelpers.interopDefault(_fetchCache);
var _config = require("../assets/config");
var _routesJson = require("./data/routes.json");
var _routesJsonDefault = parcelHelpers.interopDefault(_routesJson);
var _stops3DJson = require("./data/stops.3d.json");
var _stops3DJsonDefault = parcelHelpers.interopDefault(_stops3DJson);
const CACHE_TIME = 10080; // 1 week
const stopsFetch = (0, _fetchCacheDefault.default)((0, _stops3DJsonDefault.default), CACHE_TIME);
const routesFetch = (0, _fetchCacheDefault.default)((0, _routesJsonDefault.default), CACHE_TIME);
const lowerLat = 1.1, upperLat = 1.58, lowerLong = 103.49, upperLong = 104.15;
const map = new (0, _maplibreGlDefault.default).Map({
    container: "map",
    // style: `mapbox://styles/uberdata/cjoqbbf6l9k302sl96tyvka09`,
    style: `https://basemaps-api.arcgis.com/arcgis/rest/services/styles/4cad6f82d6b54c67bdcc3a6fb105888f?type=style&token=${(0, _config.ARCGIS_API_KEY)}`,
    boxZoom: false,
    minZoom: 8,
    renderWorldCopies: false,
    bounds: [
        lowerLong,
        lowerLat,
        upperLong,
        upperLat
    ],
    attributionControl: false
});
map.addControl(new (0, _maplibreGlDefault.default).NavigationControl(), "bottom-right");
map.addControl(new (0, _maplibreGlDefault.default).AttributionControl({
    compact: true
}), "bottom-left");
// https://davidwalsh.name/javascript-debounce-function
function debounce(func, wait, immediate) {
    var timeout;
    return function() {
        var context = this, args = arguments;
        var later = function() {
            timeout = null;
            if (!immediate) func.apply(context, args);
        };
        var callNow = immediate && !timeout;
        clearTimeout(timeout);
        timeout = setTimeout(later, wait);
        if (callNow) func.apply(context, args);
    };
}
// https://gist.github.com/rosszurowski/67f04465c424a9bc0dae
function lerpColor(a, b, amount) {
    var ah = parseInt(a.replace(/#/g, ""), 16), ar = ah >> 16, ag = ah >> 8 & 0xff, ab = ah & 0xff, bh = parseInt(b.replace(/#/g, ""), 16), br = bh >> 16, bg = bh >> 8 & 0xff, bb = bh & 0xff, rr = ar + amount * (br - ar), rg = ag + amount * (bg - ag), rb = ab + amount * (bb - ab);
    return [
        rr,
        rg,
        rb
    ];
}
const mapCanvas = map.getCanvas();
map.on("load", async ()=>{
    const stopsData = (await stopsFetch).sort((a, b)=>a.number - b.number);
    const routesData = (await routesFetch).sort((a, b)=>(0, _bus.sortServices)(a.number, b.number));
    const serviceStops = {};
    stopsData.forEach((stop)=>{
        stop.services.forEach((service)=>{
            if (!serviceStops[service]) serviceStops[service] = new Set();
            serviceStops[service].add(stop.number);
        });
    });
    const stopLayerHover = debounce((info, e)=>{
        const object = info.object;
        let number = object ? object.number : null;
        const services = object ? object.services : null;
        if (number) showStop(number, services);
        else {
            const [_, type, number1] = location.hash.match(/#([^\/]+)\/([^\/]+)/i) || [
                ,
                , 
            ];
            if (type === "stops") showStop(number1);
            else if (type === "services") showService(number1);
            else showStop(null);
        }
        focusListStop(number);
    }, 100);
    const stopsLayer = new (0, _mapboxLayerDefault.default)({
        id: "stops",
        type: (0, _solidPolygonLayerDefault.default),
        data: stopsData,
        getPolygon: (d)=>d.contour,
        extruded: true,
        getElevation: (d)=>d.faded ? 30 : d.level * 100,
        getFillColor: (d)=>d.highlighted ? [
                229,
                238,
                193
            ] : d.faded ? [
                55,
                83,
                95,
                255
            ] : [
                55,
                83,
                95,
                128
            ],
        pickable: true,
        autoHighlight: true,
        highlightColor: [
            229,
            238,
            193
        ],
        onHover: stopLayerHover,
        onClick: (info, e)=>{
            if (!info.object) return;
            const { number  } = info.object;
            location.hash = `#stops/${number}`;
        },
        parameters: {
            depthTest: false,
            blend: true
        }
    });
    map.addLayer(stopsLayer);
    const $tooltip = document.getElementById("tooltip");
    const highestLevel = routesData.reduce((level, d)=>d.level > level ? d.level : level, 1);
    const routesLayer = new (0, _mapboxLayerDefault.default)({
        id: "routes",
        type: (0, _pathLayerDefault.default),
        data: routesData,
        getPath: (d)=>d.path,
        opacity: 1,
        widthMinPixels: 1,
        getWidth: 10,
        getColor: (d)=>d.faded ? [
                0,
                0,
                0,
                0
            ] : lerpColor("#73BC84", "#E5EEC1", d.level / highestLevel),
        pickable: true,
        autoHighlight: true,
        highlightColor: [
            255,
            255,
            255
        ],
        onHover: (info, e)=>{
            if (info.object) {
                const { number  } = info.object;
                const { x , y  } = e.offsetCenter;
                $tooltip.innerHTML = `Service ${number}`;
                const { offsetWidth: w  } = $tooltip;
                const tx = Math.min(x, mapCanvas.offsetWidth - w - 5);
                const ty = y + 16; // Under the cursor
                $tooltip.style.transform = `translate3d(${tx}px, ${ty}px, 0)`;
                $tooltip.hidden = false;
            } else $tooltip.hidden = true;
        },
        parameters: {
            depthTest: false,
            blend: true
        }
    });
    map.addLayer(routesLayer);
    map.once("data", ()=>{
        requestAnimationFrame(()=>{
            map.once("idle", ()=>{
                document.body.classList.add("ready");
            });
            const center = map.unproject([
                mapCanvas.offsetWidth / 2,
                mapCanvas.offsetHeight / 3
            ]);
            map.easeTo({
                pitch: 45,
                bearing: -10,
                center,
                duration: 2000,
                zoom: map.getZoom() + 0.1
            });
        });
    });
    const showStop = (number, services)=>{
        stopsLayer.setProps({
            data: stopsData.map((d)=>{
                d.faded = number && d.number !== number;
                d.highlighted = number && d.number === number;
                return d;
            })
        });
        if (number) {
            if (!services) services = stopsData.find((d)=>d.number === number).services;
            routesLayer.setProps({
                data: routesData.map((d)=>{
                    const highlighted = services.includes(d.number);
                    d.highlighted = highlighted;
                    d.faded = !highlighted;
                    return d;
                })
            });
        } else routesLayer.setProps({
            data: routesData.map((d)=>{
                d.highlighted = d.faded = false;
                return d;
            })
        });
    };
    const showService = (number)=>{
        if (number) {
            const stops = serviceStops[number];
            stopsLayer.setProps({
                data: stopsData.map((d)=>{
                    d.faded = !stops.has(d.number);
                    d.highlighted = false;
                    return d;
                })
            });
        } else stopsLayer.setProps({
            data: stopsData.map((d)=>{
                d.faded = false;
                d.highlighted = false;
                return d;
            })
        });
        routesLayer.setProps({
            data: routesData.map((d)=>{
                d.faded = number && d.number !== number;
                d.highlighted = false;
                return d;
            })
        });
    };
    const $panel = document.getElementById("panel");
    const routesList = routesData.map((r)=>r.number).filter((el, pos, arr)=>arr.indexOf(el) === pos);
    $panel.innerHTML = `
    <button type="button" id="toggle">▼</button>
    <div id="services">
      <h2 title="${routesList.length} services">Services</h2>
      <ul>
        ${routesList.map((number)=>`<li><a href="#services/${number}" class="number">${number}</a></li>`).join("")}
      </ul>
    </div>
    <div id="stops">
      <h2>${stopsData.length} Stops</h2>
      <ul>
        ${stopsData.map((s)=>`<li><a href="#stops/${s.number}"><span class="number">${s.number}</span>&nbsp;&nbsp;${s.name}</a></li>`).join("")}
      </ul>
    </div>
  `;
    $panel.querySelector("#toggle").addEventListener("click", ()=>{
        document.body.classList.toggle("map-expand");
        setTimeout(()=>{
            map.resize();
        }, 350);
    });
    const $stops = $panel.querySelector("#stops");
    const focusListStop = (number)=>{
        const el = $stops.querySelector(`a[href*="/${number}"]`);
        if (el) el.focus();
    };
    let mouseoutRAF;
    $panel.addEventListener("mouseover", (e)=>{
        if (e.target.tagName.toLowerCase() === "a") {
            cancelAnimationFrame(mouseoutRAF);
            const [_, type, number] = e.target.href.match(/#([^\/]+)\/([^\/]+)/i);
            if (type === "stops") showStop(number);
            else if (type === "services") showService(number);
        }
    });
    $panel.addEventListener("mouseout", (e)=>{
        if (e.target.tagName.toLowerCase() === "a") mouseoutRAF = requestAnimationFrame(()=>{
            const [_, type, number] = location.hash.match(/#([^\/]+)\/([^\/]+)/i) || [
                ,
                , 
            ];
            if (type) {
                if (type === "stops") showStop(number);
                else if (type === "services") showService(number);
            } else {
                const [_1, type1, number1] = e.target.href.match(/#([^\/]+)\/([^\/]+)/i);
                if (type1 === "stops") showStop(null);
                else if (type1 === "services") showService(null);
            }
        });
    });
    const $status = document.getElementById("status");
    const closeHTML = '<a href="#" class="close">\xd7</a>';
    window.onhashchange = ()=>{
        const [_, type, number] = location.hash.match(/#([^\/]+)\/([^\/]+)/i) || [
            ,
            , 
        ];
        if (type === "stops") {
            showStop(number);
            const { name  } = stopsData.find((s)=>s.number === number);
            $status.hidden = false;
            $status.innerHTML = `<span>Bus stop ${number}: ${name}</span> ${closeHTML}`;
        } else if (type === "services") {
            showService(number);
            $status.hidden = false;
            $status.innerHTML = `<span>Bus service ${number}</span> ${closeHTML}`;
        } else {
            showStop(null);
            $status.hidden = true;
        }
    };
    window.onhashchange();
});

},{"maplibre-gl":"5AnAU","@deck.gl/mapbox/dist/esm/mapbox-layer":"aXxeu","@deck.gl/layers/dist/esm/solid-polygon-layer/solid-polygon-layer":"2mJad","@deck.gl/layers/dist/esm/path-layer/path-layer":"kUQVe","../assets/utils/bus":"cu424","../assets/utils/fetchCache":"6IPHM","../assets/config":"5MP3O","./data/routes.json":"9h2Tj","./data/stops.3d.json":"6ctOZ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5AnAU":[function(require,module,exports) {
/* MapLibre GL JS is licensed under the 3-Clause BSD License. Full text of license: https://github.com/maplibre/maplibre-gl-js/blob/v2.4.0/LICENSE.txt */ (function(global, factory) {
    module.exports = factory();
})(this, function() {
    "use strict";
    /* eslint-disable */ var shared, worker, maplibregl;
    // define gets called three times: one for each chunk. we rely on the order
    // they're imported to know which is which
    function define(_, chunk) {
        if (!shared) shared = chunk;
        else if (!worker) worker = chunk;
        else {
            var workerBundleString = "var sharedChunk = {}; (" + shared + ")(sharedChunk); (" + worker + ")(sharedChunk);";
            var sharedChunk = {};
            shared(sharedChunk);
            maplibregl = chunk(sharedChunk);
            if (typeof window !== "undefined") maplibregl.workerUrl = window.URL.createObjectURL(new Blob([
                workerBundleString
            ], {
                type: "text/javascript"
            }));
        }
    }
    define([
        "exports"
    ], function(t1) {
        "use strict";
        var e1 = r;
        function r(t1, e1, r, n) {
            this.cx = 3 * t1, this.bx = 3 * (r - t1) - this.cx, this.ax = 1 - this.cx - this.bx, this.cy = 3 * e1, this.by = 3 * (n - e1) - this.cy, this.ay = 1 - this.cy - this.by, this.p1x = t1, this.p1y = e1, this.p2x = r, this.p2y = n;
        }
        function n(t1, r, n, i) {
            const a = new e1(t1, r, n, i);
            return function(t1) {
                return a.solve(t1);
            };
        }
        r.prototype = {
            sampleCurveX: function(t1) {
                return ((this.ax * t1 + this.bx) * t1 + this.cx) * t1;
            },
            sampleCurveY: function(t1) {
                return ((this.ay * t1 + this.by) * t1 + this.cy) * t1;
            },
            sampleCurveDerivativeX: function(t1) {
                return (3 * this.ax * t1 + 2 * this.bx) * t1 + this.cx;
            },
            solveCurveX: function(t1, e1) {
                if (void 0 === e1 && (e1 = 1e-6), t1 < 0) return 0;
                if (t1 > 1) return 1;
                for(var r = t1, n = 0; n < 8; n++){
                    var i = this.sampleCurveX(r) - t1;
                    if (Math.abs(i) < e1) return r;
                    var a = this.sampleCurveDerivativeX(r);
                    if (Math.abs(a) < 1e-6) break;
                    r -= i / a;
                }
                var s = 0, o = 1;
                for(r = t1, n = 0; n < 20 && (i = this.sampleCurveX(r), !(Math.abs(i - t1) < e1)); n++)t1 > i ? s = r : o = r, r = .5 * (o - s) + s;
                return r;
            },
            solve: function(t1, e1) {
                return this.sampleCurveY(this.solveCurveX(t1, e1));
            }
        };
        const i = n(.25, .1, .25, 1);
        function a(t1, e1, r) {
            return Math.min(r, Math.max(e1, t1));
        }
        function s(t1, e1, r) {
            const n = r - e1, i = ((t1 - e1) % n + n) % n + e1;
            return i === e1 ? r : i;
        }
        function o(t1, ...e1) {
            for (const r of e1)for(const e2 in r)t1[e2] = r[e2];
            return t1;
        }
        let l = 1;
        function u(t1, e1) {
            t1.forEach((t1)=>{
                e1[t1] && (e1[t1] = e1[t1].bind(e1));
            });
        }
        function c(t1, e1, r) {
            const n = {};
            for(const i in t1)n[i] = e1.call(r || this, t1[i], i, t1);
            return n;
        }
        function h(t1, e1, r) {
            const n = {};
            for(const i in t1)e1.call(r || this, t1[i], i, t1) && (n[i] = t1[i]);
            return n;
        }
        function p(t1) {
            return Array.isArray(t1) ? t1.map(p) : "object" == typeof t1 && t1 ? c(t1, p) : t1;
        }
        const f = {};
        function d(t1) {
            f[t1] || ("undefined" != typeof console && console.warn(t1), f[t1] = !0);
        }
        function y(t1, e1, r) {
            return (r.y - t1.y) * (e1.x - t1.x) > (e1.y - t1.y) * (r.x - t1.x);
        }
        function m(t1) {
            let e1 = 0;
            for(let r, n, i = 0, a = t1.length, s = a - 1; i < a; s = i++)r = t1[i], n = t1[s], e1 += (n.x - r.x) * (r.y + n.y);
            return e1;
        }
        function g() {
            return "undefined" != typeof WorkerGlobalScope && "undefined" != typeof self && self instanceof WorkerGlobalScope;
        }
        function x(t1) {
            const e1 = {};
            if (t1.replace(/(?:^|(?:\s*\,\s*))([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)(?:\=(?:([^\x00-\x20\(\)<>@\,;\:\\"\/\[\]\?\=\{\}\x7F]+)|(?:\"((?:[^"\\]|\\.)*)\")))?/g, (t1, r, n, i)=>{
                const a = n || i;
                return e1[r] = !a || a.toLowerCase(), "";
            }), e1["max-age"]) {
                const t2 = parseInt(e1["max-age"], 10);
                isNaN(t2) ? delete e1["max-age"] : e1["max-age"] = t2;
            }
            return e1;
        }
        let v, b, w = null;
        function _(t1) {
            if (null == w) {
                const e1 = t1.navigator ? t1.navigator.userAgent : null;
                w = !!t1.safari || !(!e1 || !(/\b(iPad|iPhone|iPod)\b/.test(e1) || e1.match("Safari") && !e1.match("Chrome")));
            }
            return w;
        }
        function A(t1) {
            return "undefined" != typeof ImageBitmap && t1 instanceof ImageBitmap;
        }
        const k = {
            now: "undefined" != typeof performance && performance && performance.now ? performance.now.bind(performance) : Date.now.bind(Date),
            frame (t1) {
                const e1 = requestAnimationFrame(t1);
                return {
                    cancel: ()=>cancelAnimationFrame(e1)
                };
            },
            getImageData (t1, e1 = 0) {
                const r = window.document.createElement("canvas"), n = r.getContext("2d");
                if (!n) throw new Error("failed to create canvas 2d context");
                return r.width = t1.width, r.height = t1.height, n.drawImage(t1, 0, 0, t1.width, t1.height), n.getImageData(-e1, -e1, t1.width + 2 * e1, t1.height + 2 * e1);
            },
            resolveURL: (t1)=>(v || (v = document.createElement("a")), v.href = t1, v.href),
            hardwareConcurrency: "undefined" != typeof navigator && navigator.hardwareConcurrency || 4,
            get prefersReducedMotion () {
                return !!matchMedia && (null == b && (b = matchMedia("(prefers-reduced-motion: reduce)")), b.matches);
            }
        };
        var S = I;
        function I(t1, e1) {
            this.x = t1, this.y = e1;
        }
        I.prototype = {
            clone: function() {
                return new I(this.x, this.y);
            },
            add: function(t1) {
                return this.clone()._add(t1);
            },
            sub: function(t1) {
                return this.clone()._sub(t1);
            },
            multByPoint: function(t1) {
                return this.clone()._multByPoint(t1);
            },
            divByPoint: function(t1) {
                return this.clone()._divByPoint(t1);
            },
            mult: function(t1) {
                return this.clone()._mult(t1);
            },
            div: function(t1) {
                return this.clone()._div(t1);
            },
            rotate: function(t1) {
                return this.clone()._rotate(t1);
            },
            rotateAround: function(t1, e1) {
                return this.clone()._rotateAround(t1, e1);
            },
            matMult: function(t1) {
                return this.clone()._matMult(t1);
            },
            unit: function() {
                return this.clone()._unit();
            },
            perp: function() {
                return this.clone()._perp();
            },
            round: function() {
                return this.clone()._round();
            },
            mag: function() {
                return Math.sqrt(this.x * this.x + this.y * this.y);
            },
            equals: function(t1) {
                return this.x === t1.x && this.y === t1.y;
            },
            dist: function(t1) {
                return Math.sqrt(this.distSqr(t1));
            },
            distSqr: function(t1) {
                var e1 = t1.x - this.x, r = t1.y - this.y;
                return e1 * e1 + r * r;
            },
            angle: function() {
                return Math.atan2(this.y, this.x);
            },
            angleTo: function(t1) {
                return Math.atan2(this.y - t1.y, this.x - t1.x);
            },
            angleWith: function(t1) {
                return this.angleWithSep(t1.x, t1.y);
            },
            angleWithSep: function(t1, e1) {
                return Math.atan2(this.x * e1 - this.y * t1, this.x * t1 + this.y * e1);
            },
            _matMult: function(t1) {
                var e1 = t1[2] * this.x + t1[3] * this.y;
                return this.x = t1[0] * this.x + t1[1] * this.y, this.y = e1, this;
            },
            _add: function(t1) {
                return this.x += t1.x, this.y += t1.y, this;
            },
            _sub: function(t1) {
                return this.x -= t1.x, this.y -= t1.y, this;
            },
            _mult: function(t1) {
                return this.x *= t1, this.y *= t1, this;
            },
            _div: function(t1) {
                return this.x /= t1, this.y /= t1, this;
            },
            _multByPoint: function(t1) {
                return this.x *= t1.x, this.y *= t1.y, this;
            },
            _divByPoint: function(t1) {
                return this.x /= t1.x, this.y /= t1.y, this;
            },
            _unit: function() {
                return this._div(this.mag()), this;
            },
            _perp: function() {
                var t1 = this.y;
                return this.y = this.x, this.x = -t1, this;
            },
            _rotate: function(t1) {
                var e1 = Math.cos(t1), r = Math.sin(t1), n = r * this.x + e1 * this.y;
                return this.x = e1 * this.x - r * this.y, this.y = n, this;
            },
            _rotateAround: function(t1, e1) {
                var r = Math.cos(t1), n = Math.sin(t1), i = e1.y + n * (this.x - e1.x) + r * (this.y - e1.y);
                return this.x = e1.x + r * (this.x - e1.x) - n * (this.y - e1.y), this.y = i, this;
            },
            _round: function() {
                return this.x = Math.round(this.x), this.y = Math.round(this.y), this;
            }
        }, I.convert = function(t1) {
            return t1 instanceof I ? t1 : Array.isArray(t1) ? new I(t1[0], t1[1]) : t1;
        };
        const M = {
            MAX_PARALLEL_IMAGE_REQUESTS: 16,
            REGISTERED_PROTOCOLS: {}
        }, z = "mapbox-tiles";
        let B, C, P = 500, V = 50;
        function E() {
            "undefined" == typeof caches || B || (B = caches.open(z));
        }
        let F = 1 / 0;
        const T = {
            supported: !1,
            testSupport: function(t1) {
                !$ && D && (R ? O(t1) : L = t1);
            }
        };
        let L, D, $ = !1, R = !1;
        function O(t1) {
            const e1 = t1.createTexture();
            t1.bindTexture(t1.TEXTURE_2D, e1);
            try {
                if (t1.texImage2D(t1.TEXTURE_2D, 0, t1.RGBA, t1.RGBA, t1.UNSIGNED_BYTE, D), t1.isContextLost()) return;
                T.supported = !0;
            } catch (t2) {}
            t1.deleteTexture(e1), $ = !0;
        }
        "undefined" != typeof document && (D = document.createElement("img"), D.onload = function() {
            L && O(L), L = null, R = !0;
        }, D.onerror = function() {
            $ = !0, L = null;
        }, D.src = "data:image/webp;base64,UklGRh4AAABXRUJQVlA4TBEAAAAvAQAAAAfQ//73v/+BiOh/AAA=");
        const U = {
            Unknown: "Unknown",
            Style: "Style",
            Source: "Source",
            Tile: "Tile",
            Glyphs: "Glyphs",
            SpriteImage: "SpriteImage",
            SpriteJSON: "SpriteJSON",
            Image: "Image"
        };
        "function" == typeof Object.freeze && Object.freeze(U);
        class q extends Error {
            constructor(t1, e1, r, n){
                super(`AJAXError: ${e1} (${t1}): ${r}`), this.status = t1, this.statusText = e1, this.url = r, this.body = n;
            }
        }
        const j = g() ? ()=>self.worker && self.worker.referrer : ()=>("blob:" === window.location.protocol ? window.parent : window).location.href;
        function N(t1, e1) {
            const r = new AbortController, n = new Request(t1.url, {
                method: t1.method || "GET",
                body: t1.body,
                credentials: t1.credentials,
                headers: t1.headers,
                referrer: j(),
                signal: r.signal
            });
            let i = !1, a = !1;
            "json" === t1.type && n.headers.set("Accept", "application/json");
            return ((r, s, o)=>{
                if (a) return;
                const l = Date.now();
                fetch(n).then((r)=>r.ok ? ((r, s, o)=>{
                        ("arrayBuffer" === t1.type ? r.arrayBuffer() : "json" === t1.type ? r.json() : r.text()).then((t1)=>{
                            a || (s && o && function(t1, e1, r) {
                                if (E(), !B) return;
                                const n = {
                                    status: e1.status,
                                    statusText: e1.statusText,
                                    headers: new Headers
                                };
                                e1.headers.forEach((t1, e1)=>n.headers.set(e1, t1));
                                const i = x(e1.headers.get("Cache-Control") || "");
                                i["no-store"] || (i["max-age"] && n.headers.set("Expires", new Date(r + 1e3 * i["max-age"]).toUTCString()), new Date(n.headers.get("Expires")).getTime() - r < 42e4 || function(t1, e1) {
                                    if (void 0 === C) try {
                                        new Response(new ReadableStream), C = !0;
                                    } catch (t2) {
                                        C = !1;
                                    }
                                    C ? e1(t1.body) : t1.blob().then(e1);
                                }(e1, (e1)=>{
                                    const r = new Response(e1, n);
                                    E(), B && B.then((e1)=>e1.put(function(t1) {
                                            const e1 = t1.indexOf("?");
                                            return e1 < 0 ? t1 : t1.slice(0, e1);
                                        }(t1.url), r)).catch((t1)=>d(t1.message));
                                }));
                            }(n, s, o), i = !0, e1(null, t1, r.headers.get("Cache-Control"), r.headers.get("Expires")));
                        }).catch((t1)=>{
                            a || e1(new Error(t1.message));
                        });
                    })(r, null, l) : r.blob().then((n)=>e1(new q(r.status, r.statusText, t1.url, n)))).catch((t1)=>{
                    20 !== t1.code && e1(new Error(t1.message));
                });
            })(), {
                cancel: ()=>{
                    a = !0, i || r.abort();
                }
            };
        }
        const Z = function(t1, e1) {
            if (/:\/\//.test(t1.url) && !/^https?:|^file:/.test(t1.url)) {
                if (g() && self.worker && self.worker.actor) return self.worker.actor.send("getResource", t1, e1);
                if (!g()) {
                    const r = t1.url.substring(0, t1.url.indexOf("://"));
                    return (M.REGISTERED_PROTOCOLS[r] || N)(t1, e1);
                }
            }
            if (!(/^file:/.test(r1 = t1.url) || /^file:/.test(j()) && !/^\w+:/.test(r1))) {
                if (fetch && Request && AbortController && Object.prototype.hasOwnProperty.call(Request.prototype, "signal")) return N(t1, e1);
                if (g() && self.worker && self.worker.actor) return self.worker.actor.send("getResource", t1, e1, void 0, !0);
            }
            var r1;
            return function(t1, e1) {
                const r = new XMLHttpRequest;
                r.open(t1.method || "GET", t1.url, !0), "arrayBuffer" === t1.type && (r.responseType = "arraybuffer");
                for(const e2 in t1.headers)r.setRequestHeader(e2, t1.headers[e2]);
                return "json" === t1.type && (r.responseType = "text", r.setRequestHeader("Accept", "application/json")), r.withCredentials = "include" === t1.credentials, r.onerror = ()=>{
                    e1(new Error(r.statusText));
                }, r.onload = ()=>{
                    if ((r.status >= 200 && r.status < 300 || 0 === r.status) && null !== r.response) {
                        let n = r.response;
                        if ("json" === t1.type) try {
                            n = JSON.parse(r.response);
                        } catch (t2) {
                            return e1(t2);
                        }
                        e1(null, n, r.getResponseHeader("Cache-Control"), r.getResponseHeader("Expires"));
                    } else {
                        const n1 = new Blob([
                            r.response
                        ], {
                            type: r.getResponseHeader("Content-Type")
                        });
                        e1(new q(r.status, r.statusText, t1.url, n1));
                    }
                }, r.send(t1.body), {
                    cancel: ()=>r.abort()
                };
            }(t1, e1);
        }, K = function(t1, e1) {
            return Z(o(t1, {
                type: "arrayBuffer"
            }), e1);
        };
        function G(t1) {
            const e1 = window.document.createElement("a");
            return e1.href = t1, e1.protocol === window.document.location.protocol && e1.host === window.document.location.host;
        }
        const J = "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAAC0lEQVQYV2NgAAIAAAUAAarVyFEAAAAASUVORK5CYII=";
        let X, Y;
        X = [], Y = 0;
        const H = function(t1, e1) {
            if (T.supported && (t1.headers || (t1.headers = {}), t1.headers.accept = "image/webp,*/*"), Y >= M.MAX_PARALLEL_IMAGE_REQUESTS) {
                const r = {
                    requestParameters: t1,
                    callback: e1,
                    cancelled: !1,
                    cancel () {
                        this.cancelled = !0;
                    }
                };
                return X.push(r), r;
            }
            Y++;
            let r1 = !1;
            const n = ()=>{
                if (!r1) for(r1 = !0, Y--; X.length && Y < M.MAX_PARALLEL_IMAGE_REQUESTS;){
                    const t1 = X.shift(), { requestParameters: e1 , callback: r , cancelled: n  } = t1;
                    n || (t1.cancel = H(e1, r).cancel);
                }
            }, i = K(t1, (t1, r, i, a)=>{
                n(), t1 ? e1(t1) : r && function(t1, e1) {
                    "function" == typeof createImageBitmap ? function(t1, e1) {
                        const r = new Blob([
                            new Uint8Array(t1)
                        ], {
                            type: "image/png"
                        });
                        createImageBitmap(r).then((t1)=>{
                            e1(null, t1);
                        }).catch((t1)=>{
                            e1(new Error(`Could not load image because of ${t1.message}. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported.`));
                        });
                    }(t1, e1) : function(t1, e1) {
                        const r = new Image;
                        r.onload = ()=>{
                            e1(null, r), URL.revokeObjectURL(r.src), r.onload = null, window.requestAnimationFrame(()=>{
                                r.src = J;
                            });
                        }, r.onerror = ()=>e1(new Error("Could not load image. Please make sure to use a supported image type such as PNG or JPEG. Note that SVGs are not supported."));
                        const n = new Blob([
                            new Uint8Array(t1)
                        ], {
                            type: "image/png"
                        });
                        r.src = t1.byteLength ? URL.createObjectURL(n) : J;
                    }(t1, e1);
                }(r, (t1, r)=>{
                    null != t1 ? e1(t1) : null != r && e1(null, r, {
                        cacheControl: i,
                        expires: a
                    });
                });
            });
            return {
                cancel: ()=>{
                    i.cancel(), n();
                }
            };
        };
        function W(t1, e1, r) {
            r[t1] && -1 !== r[t1].indexOf(e1) || (r[t1] = r[t1] || [], r[t1].push(e1));
        }
        function Q(t1, e1, r) {
            if (r && r[t1]) {
                const n = r[t1].indexOf(e1);
                -1 !== n && r[t1].splice(n, 1);
            }
        }
        class tt {
            constructor(t1, e1 = {}){
                o(this, e1), this.type = t1;
            }
        }
        class et extends tt {
            constructor(t1, e1 = {}){
                super("error", o({
                    error: t1
                }, e1));
            }
        }
        class rt {
            on(t1, e1) {
                return this._listeners = this._listeners || {}, W(t1, e1, this._listeners), this;
            }
            off(t1, e1) {
                return Q(t1, e1, this._listeners), Q(t1, e1, this._oneTimeListeners), this;
            }
            once(t1, e1) {
                return this._oneTimeListeners = this._oneTimeListeners || {}, W(t1, e1, this._oneTimeListeners), this;
            }
            fire(t1, e1) {
                "string" == typeof t1 && (t1 = new tt(t1, e1 || {}));
                const r = t1.type;
                if (this.listens(r)) {
                    t1.target = this;
                    const e2 = this._listeners && this._listeners[r] ? this._listeners[r].slice() : [];
                    for (const r1 of e2)r1.call(this, t1);
                    const n = this._oneTimeListeners && this._oneTimeListeners[r] ? this._oneTimeListeners[r].slice() : [];
                    for (const e3 of n)Q(r, e3, this._oneTimeListeners), e3.call(this, t1);
                    const i = this._eventedParent;
                    i && (o(t1, "function" == typeof this._eventedParentData ? this._eventedParentData() : this._eventedParentData), i.fire(t1));
                } else t1 instanceof et && console.error(t1.error);
                return this;
            }
            listens(t1) {
                return this._listeners && this._listeners[t1] && this._listeners[t1].length > 0 || this._oneTimeListeners && this._oneTimeListeners[t1] && this._oneTimeListeners[t1].length > 0 || this._eventedParent && this._eventedParent.listens(t1);
            }
            setEventedParent(t1, e1) {
                return this._eventedParent = t1, this._eventedParentData = e1, this;
            }
        }
        var nt = {
            $version: 8,
            $root: {
                version: {
                    required: !0,
                    type: "enum",
                    values: [
                        8
                    ]
                },
                name: {
                    type: "string"
                },
                metadata: {
                    type: "*"
                },
                center: {
                    type: "array",
                    value: "number"
                },
                zoom: {
                    type: "number"
                },
                bearing: {
                    type: "number",
                    default: 0,
                    period: 360,
                    units: "degrees"
                },
                pitch: {
                    type: "number",
                    default: 0,
                    units: "degrees"
                },
                light: {
                    type: "light"
                },
                terrain: {
                    type: "terrain"
                },
                sources: {
                    required: !0,
                    type: "sources"
                },
                sprite: {
                    type: "string"
                },
                glyphs: {
                    type: "string"
                },
                transition: {
                    type: "transition"
                },
                layers: {
                    required: !0,
                    type: "array",
                    value: "layer"
                }
            },
            sources: {
                "*": {
                    type: "source"
                }
            },
            source: [
                "source_vector",
                "source_raster",
                "source_raster_dem",
                "source_geojson",
                "source_video",
                "source_image"
            ],
            source_vector: {
                type: {
                    required: !0,
                    type: "enum",
                    values: {
                        vector: {}
                    }
                },
                url: {
                    type: "string"
                },
                tiles: {
                    type: "array",
                    value: "string"
                },
                bounds: {
                    type: "array",
                    value: "number",
                    length: 4,
                    default: [
                        -180,
                        -85.051129,
                        180,
                        85.051129
                    ]
                },
                scheme: {
                    type: "enum",
                    values: {
                        xyz: {},
                        tms: {}
                    },
                    default: "xyz"
                },
                minzoom: {
                    type: "number",
                    default: 0
                },
                maxzoom: {
                    type: "number",
                    default: 22
                },
                attribution: {
                    type: "string"
                },
                promoteId: {
                    type: "promoteId"
                },
                volatile: {
                    type: "boolean",
                    default: !1
                },
                "*": {
                    type: "*"
                }
            },
            source_raster: {
                type: {
                    required: !0,
                    type: "enum",
                    values: {
                        raster: {}
                    }
                },
                url: {
                    type: "string"
                },
                tiles: {
                    type: "array",
                    value: "string"
                },
                bounds: {
                    type: "array",
                    value: "number",
                    length: 4,
                    default: [
                        -180,
                        -85.051129,
                        180,
                        85.051129
                    ]
                },
                minzoom: {
                    type: "number",
                    default: 0
                },
                maxzoom: {
                    type: "number",
                    default: 22
                },
                tileSize: {
                    type: "number",
                    default: 512,
                    units: "pixels"
                },
                scheme: {
                    type: "enum",
                    values: {
                        xyz: {},
                        tms: {}
                    },
                    default: "xyz"
                },
                attribution: {
                    type: "string"
                },
                volatile: {
                    type: "boolean",
                    default: !1
                },
                "*": {
                    type: "*"
                }
            },
            source_raster_dem: {
                type: {
                    required: !0,
                    type: "enum",
                    values: {
                        "raster-dem": {}
                    }
                },
                url: {
                    type: "string"
                },
                tiles: {
                    type: "array",
                    value: "string"
                },
                bounds: {
                    type: "array",
                    value: "number",
                    length: 4,
                    default: [
                        -180,
                        -85.051129,
                        180,
                        85.051129
                    ]
                },
                minzoom: {
                    type: "number",
                    default: 0
                },
                maxzoom: {
                    type: "number",
                    default: 22
                },
                tileSize: {
                    type: "number",
                    default: 512,
                    units: "pixels"
                },
                attribution: {
                    type: "string"
                },
                encoding: {
                    type: "enum",
                    values: {
                        terrarium: {},
                        mapbox: {}
                    },
                    default: "mapbox"
                },
                volatile: {
                    type: "boolean",
                    default: !1
                },
                "*": {
                    type: "*"
                }
            },
            source_geojson: {
                type: {
                    required: !0,
                    type: "enum",
                    values: {
                        geojson: {}
                    }
                },
                data: {
                    type: "*"
                },
                maxzoom: {
                    type: "number",
                    default: 18
                },
                attribution: {
                    type: "string"
                },
                buffer: {
                    type: "number",
                    default: 128,
                    maximum: 512,
                    minimum: 0
                },
                filter: {
                    type: "*"
                },
                tolerance: {
                    type: "number",
                    default: .375
                },
                cluster: {
                    type: "boolean",
                    default: !1
                },
                clusterRadius: {
                    type: "number",
                    default: 50,
                    minimum: 0
                },
                clusterMaxZoom: {
                    type: "number"
                },
                clusterMinPoints: {
                    type: "number"
                },
                clusterProperties: {
                    type: "*"
                },
                lineMetrics: {
                    type: "boolean",
                    default: !1
                },
                generateId: {
                    type: "boolean",
                    default: !1
                },
                promoteId: {
                    type: "promoteId"
                }
            },
            source_video: {
                type: {
                    required: !0,
                    type: "enum",
                    values: {
                        video: {}
                    }
                },
                urls: {
                    required: !0,
                    type: "array",
                    value: "string"
                },
                coordinates: {
                    required: !0,
                    type: "array",
                    length: 4,
                    value: {
                        type: "array",
                        length: 2,
                        value: "number"
                    }
                }
            },
            source_image: {
                type: {
                    required: !0,
                    type: "enum",
                    values: {
                        image: {}
                    }
                },
                url: {
                    required: !0,
                    type: "string"
                },
                coordinates: {
                    required: !0,
                    type: "array",
                    length: 4,
                    value: {
                        type: "array",
                        length: 2,
                        value: "number"
                    }
                }
            },
            layer: {
                id: {
                    type: "string",
                    required: !0
                },
                type: {
                    type: "enum",
                    values: {
                        fill: {},
                        line: {},
                        symbol: {},
                        circle: {},
                        heatmap: {},
                        "fill-extrusion": {},
                        raster: {},
                        hillshade: {},
                        background: {}
                    },
                    required: !0
                },
                metadata: {
                    type: "*"
                },
                source: {
                    type: "string"
                },
                "source-layer": {
                    type: "string"
                },
                minzoom: {
                    type: "number",
                    minimum: 0,
                    maximum: 24
                },
                maxzoom: {
                    type: "number",
                    minimum: 0,
                    maximum: 24
                },
                filter: {
                    type: "filter"
                },
                layout: {
                    type: "layout"
                },
                paint: {
                    type: "paint"
                }
            },
            layout: [
                "layout_fill",
                "layout_line",
                "layout_circle",
                "layout_heatmap",
                "layout_fill-extrusion",
                "layout_symbol",
                "layout_raster",
                "layout_hillshade",
                "layout_background"
            ],
            layout_background: {
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            layout_fill: {
                "fill-sort-key": {
                    type: "number",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            layout_circle: {
                "circle-sort-key": {
                    type: "number",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            layout_heatmap: {
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            "layout_fill-extrusion": {
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            layout_line: {
                "line-cap": {
                    type: "enum",
                    values: {
                        butt: {},
                        round: {},
                        square: {}
                    },
                    default: "butt",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "line-join": {
                    type: "enum",
                    values: {
                        bevel: {},
                        round: {},
                        miter: {}
                    },
                    default: "miter",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "line-miter-limit": {
                    type: "number",
                    default: 2,
                    requires: [
                        {
                            "line-join": "miter"
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "line-round-limit": {
                    type: "number",
                    default: 1.05,
                    requires: [
                        {
                            "line-join": "round"
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "line-sort-key": {
                    type: "number",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            layout_symbol: {
                "symbol-placement": {
                    type: "enum",
                    values: {
                        point: {},
                        line: {},
                        "line-center": {}
                    },
                    default: "point",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "symbol-spacing": {
                    type: "number",
                    default: 250,
                    minimum: 1,
                    units: "pixels",
                    requires: [
                        {
                            "symbol-placement": "line"
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "symbol-avoid-edges": {
                    type: "boolean",
                    default: !1,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "symbol-sort-key": {
                    type: "number",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "symbol-z-order": {
                    type: "enum",
                    values: {
                        auto: {},
                        "viewport-y": {},
                        source: {}
                    },
                    default: "auto",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-allow-overlap": {
                    type: "boolean",
                    default: !1,
                    requires: [
                        "icon-image",
                        {
                            "!": "icon-overlap"
                        }
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-overlap": {
                    type: "enum",
                    values: {
                        never: {},
                        always: {},
                        cooperative: {}
                    },
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-ignore-placement": {
                    type: "boolean",
                    default: !1,
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-optional": {
                    type: "boolean",
                    default: !1,
                    requires: [
                        "icon-image",
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-rotation-alignment": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {},
                        auto: {}
                    },
                    default: "auto",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-size": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    units: "factor of the original icon size",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-text-fit": {
                    type: "enum",
                    values: {
                        none: {},
                        width: {},
                        height: {},
                        both: {}
                    },
                    default: "none",
                    requires: [
                        "icon-image",
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-text-fit-padding": {
                    type: "array",
                    value: "number",
                    length: 4,
                    default: [
                        0,
                        0,
                        0,
                        0
                    ],
                    units: "pixels",
                    requires: [
                        "icon-image",
                        "text-field",
                        {
                            "icon-text-fit": [
                                "both",
                                "width",
                                "height"
                            ]
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-image": {
                    type: "resolvedImage",
                    tokens: !0,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-rotate": {
                    type: "number",
                    default: 0,
                    period: 360,
                    units: "degrees",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-padding": {
                    type: "padding",
                    default: [
                        2
                    ],
                    units: "pixels",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-keep-upright": {
                    type: "boolean",
                    default: !1,
                    requires: [
                        "icon-image",
                        {
                            "icon-rotation-alignment": "map"
                        },
                        {
                            "symbol-placement": [
                                "line",
                                "line-center"
                            ]
                        }
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-offset": {
                    type: "array",
                    value: "number",
                    length: 2,
                    default: [
                        0,
                        0
                    ],
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-anchor": {
                    type: "enum",
                    values: {
                        center: {},
                        left: {},
                        right: {},
                        top: {},
                        bottom: {},
                        "top-left": {},
                        "top-right": {},
                        "bottom-left": {},
                        "bottom-right": {}
                    },
                    default: "center",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-pitch-alignment": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {},
                        auto: {}
                    },
                    default: "auto",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-pitch-alignment": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {},
                        auto: {}
                    },
                    default: "auto",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-rotation-alignment": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {},
                        "viewport-glyph": {},
                        auto: {}
                    },
                    default: "auto",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-field": {
                    type: "formatted",
                    default: "",
                    tokens: !0,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-font": {
                    type: "array",
                    value: "string",
                    default: [
                        "Open Sans Regular",
                        "Arial Unicode MS Regular"
                    ],
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-size": {
                    type: "number",
                    default: 16,
                    minimum: 0,
                    units: "pixels",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-max-width": {
                    type: "number",
                    default: 10,
                    minimum: 0,
                    units: "ems",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-line-height": {
                    type: "number",
                    default: 1.2,
                    units: "ems",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-letter-spacing": {
                    type: "number",
                    default: 0,
                    units: "ems",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-justify": {
                    type: "enum",
                    values: {
                        auto: {},
                        left: {},
                        center: {},
                        right: {}
                    },
                    default: "center",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-radial-offset": {
                    type: "number",
                    units: "ems",
                    default: 0,
                    requires: [
                        "text-field"
                    ],
                    "property-type": "data-driven",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    }
                },
                "text-variable-anchor": {
                    type: "array",
                    value: "enum",
                    values: {
                        center: {},
                        left: {},
                        right: {},
                        top: {},
                        bottom: {},
                        "top-left": {},
                        "top-right": {},
                        "bottom-left": {},
                        "bottom-right": {}
                    },
                    requires: [
                        "text-field",
                        {
                            "symbol-placement": [
                                "point"
                            ]
                        }
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-anchor": {
                    type: "enum",
                    values: {
                        center: {},
                        left: {},
                        right: {},
                        top: {},
                        bottom: {},
                        "top-left": {},
                        "top-right": {},
                        "bottom-left": {},
                        "bottom-right": {}
                    },
                    default: "center",
                    requires: [
                        "text-field",
                        {
                            "!": "text-variable-anchor"
                        }
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-max-angle": {
                    type: "number",
                    default: 45,
                    units: "degrees",
                    requires: [
                        "text-field",
                        {
                            "symbol-placement": [
                                "line",
                                "line-center"
                            ]
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-writing-mode": {
                    type: "array",
                    value: "enum",
                    values: {
                        horizontal: {},
                        vertical: {}
                    },
                    requires: [
                        "text-field",
                        {
                            "symbol-placement": [
                                "point"
                            ]
                        }
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-rotate": {
                    type: "number",
                    default: 0,
                    period: 360,
                    units: "degrees",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-padding": {
                    type: "number",
                    default: 2,
                    minimum: 0,
                    units: "pixels",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-keep-upright": {
                    type: "boolean",
                    default: !0,
                    requires: [
                        "text-field",
                        {
                            "text-rotation-alignment": "map"
                        },
                        {
                            "symbol-placement": [
                                "line",
                                "line-center"
                            ]
                        }
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-transform": {
                    type: "enum",
                    values: {
                        none: {},
                        uppercase: {},
                        lowercase: {}
                    },
                    default: "none",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-offset": {
                    type: "array",
                    value: "number",
                    units: "ems",
                    length: 2,
                    default: [
                        0,
                        0
                    ],
                    requires: [
                        "text-field",
                        {
                            "!": "text-radial-offset"
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-allow-overlap": {
                    type: "boolean",
                    default: !1,
                    requires: [
                        "text-field",
                        {
                            "!": "text-overlap"
                        }
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-overlap": {
                    type: "enum",
                    values: {
                        never: {},
                        always: {},
                        cooperative: {}
                    },
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-ignore-placement": {
                    type: "boolean",
                    default: !1,
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-optional": {
                    type: "boolean",
                    default: !1,
                    requires: [
                        "text-field",
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            layout_raster: {
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            layout_hillshade: {
                visibility: {
                    type: "enum",
                    values: {
                        visible: {},
                        none: {}
                    },
                    default: "visible",
                    "property-type": "constant"
                }
            },
            filter: {
                type: "array",
                value: "*"
            },
            filter_operator: {
                type: "enum",
                values: {
                    "==": {},
                    "!=": {},
                    ">": {},
                    ">=": {},
                    "<": {},
                    "<=": {},
                    in: {},
                    "!in": {},
                    all: {},
                    any: {},
                    none: {},
                    has: {},
                    "!has": {},
                    within: {}
                }
            },
            geometry_type: {
                type: "enum",
                values: {
                    Point: {},
                    LineString: {},
                    Polygon: {}
                }
            },
            function: {
                expression: {
                    type: "expression"
                },
                stops: {
                    type: "array",
                    value: "function_stop"
                },
                base: {
                    type: "number",
                    default: 1,
                    minimum: 0
                },
                property: {
                    type: "string",
                    default: "$zoom"
                },
                type: {
                    type: "enum",
                    values: {
                        identity: {},
                        exponential: {},
                        interval: {},
                        categorical: {}
                    },
                    default: "exponential"
                },
                colorSpace: {
                    type: "enum",
                    values: {
                        rgb: {},
                        lab: {},
                        hcl: {}
                    },
                    default: "rgb"
                },
                default: {
                    type: "*",
                    required: !1
                }
            },
            function_stop: {
                type: "array",
                minimum: 0,
                maximum: 24,
                value: [
                    "number",
                    "color"
                ],
                length: 2
            },
            expression: {
                type: "array",
                value: "*",
                minimum: 1
            },
            light: {
                anchor: {
                    type: "enum",
                    default: "viewport",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    "property-type": "data-constant",
                    transition: !1,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    }
                },
                position: {
                    type: "array",
                    default: [
                        1.15,
                        210,
                        30
                    ],
                    length: 3,
                    value: "number",
                    "property-type": "data-constant",
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    }
                },
                color: {
                    type: "color",
                    "property-type": "data-constant",
                    default: "#ffffff",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    transition: !0
                },
                intensity: {
                    type: "number",
                    "property-type": "data-constant",
                    default: .5,
                    minimum: 0,
                    maximum: 1,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    transition: !0
                }
            },
            terrain: {
                source: {
                    type: "string",
                    required: !0
                },
                exaggeration: {
                    type: "number",
                    minimum: 0,
                    default: 1
                },
                elevationOffset: {
                    type: "number",
                    default: 450
                }
            },
            paint: [
                "paint_fill",
                "paint_line",
                "paint_circle",
                "paint_heatmap",
                "paint_fill-extrusion",
                "paint_symbol",
                "paint_raster",
                "paint_hillshade",
                "paint_background"
            ],
            paint_fill: {
                "fill-antialias": {
                    type: "boolean",
                    default: !0,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "fill-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "fill-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    requires: [
                        {
                            "!": "fill-pattern"
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "fill-outline-color": {
                    type: "color",
                    transition: !0,
                    requires: [
                        {
                            "!": "fill-pattern"
                        },
                        {
                            "fill-antialias": !0
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "fill-translate": {
                    type: "array",
                    value: "number",
                    length: 2,
                    default: [
                        0,
                        0
                    ],
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "fill-translate-anchor": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "map",
                    requires: [
                        "fill-translate"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "fill-pattern": {
                    type: "resolvedImage",
                    transition: !0,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "cross-faded-data-driven"
                }
            },
            "paint_fill-extrusion": {
                "fill-extrusion-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "fill-extrusion-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    requires: [
                        {
                            "!": "fill-extrusion-pattern"
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "fill-extrusion-translate": {
                    type: "array",
                    value: "number",
                    length: 2,
                    default: [
                        0,
                        0
                    ],
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "fill-extrusion-translate-anchor": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "map",
                    requires: [
                        "fill-extrusion-translate"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "fill-extrusion-pattern": {
                    type: "resolvedImage",
                    transition: !0,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "cross-faded-data-driven"
                },
                "fill-extrusion-height": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    units: "meters",
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "fill-extrusion-base": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    units: "meters",
                    transition: !0,
                    requires: [
                        "fill-extrusion-height"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "fill-extrusion-vertical-gradient": {
                    type: "boolean",
                    default: !0,
                    transition: !1,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                }
            },
            paint_line: {
                "line-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "line-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    requires: [
                        {
                            "!": "line-pattern"
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "line-translate": {
                    type: "array",
                    value: "number",
                    length: 2,
                    default: [
                        0,
                        0
                    ],
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "line-translate-anchor": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "map",
                    requires: [
                        "line-translate"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "line-width": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "line-gap-width": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "line-offset": {
                    type: "number",
                    default: 0,
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "line-blur": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "line-dasharray": {
                    type: "array",
                    value: "number",
                    minimum: 0,
                    transition: !0,
                    units: "line widths",
                    requires: [
                        {
                            "!": "line-pattern"
                        }
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "cross-faded"
                },
                "line-pattern": {
                    type: "resolvedImage",
                    transition: !0,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom",
                            "feature"
                        ]
                    },
                    "property-type": "cross-faded-data-driven"
                },
                "line-gradient": {
                    type: "color",
                    transition: !1,
                    requires: [
                        {
                            "!": "line-dasharray"
                        },
                        {
                            "!": "line-pattern"
                        },
                        {
                            source: "geojson",
                            has: {
                                lineMetrics: !0
                            }
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "line-progress"
                        ]
                    },
                    "property-type": "color-ramp"
                }
            },
            paint_circle: {
                "circle-radius": {
                    type: "number",
                    default: 5,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "circle-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "circle-blur": {
                    type: "number",
                    default: 0,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "circle-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "circle-translate": {
                    type: "array",
                    value: "number",
                    length: 2,
                    default: [
                        0,
                        0
                    ],
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "circle-translate-anchor": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "map",
                    requires: [
                        "circle-translate"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "circle-pitch-scale": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "map",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "circle-pitch-alignment": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "viewport",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "circle-stroke-width": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "circle-stroke-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "circle-stroke-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                }
            },
            paint_heatmap: {
                "heatmap-radius": {
                    type: "number",
                    default: 30,
                    minimum: 1,
                    transition: !0,
                    units: "pixels",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "heatmap-weight": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    transition: !1,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "heatmap-intensity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "heatmap-color": {
                    type: "color",
                    default: [
                        "interpolate",
                        [
                            "linear"
                        ],
                        [
                            "heatmap-density"
                        ],
                        0,
                        "rgba(0, 0, 255, 0)",
                        .1,
                        "royalblue",
                        .3,
                        "cyan",
                        .5,
                        "lime",
                        .7,
                        "yellow",
                        1,
                        "red"
                    ],
                    transition: !1,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "heatmap-density"
                        ]
                    },
                    "property-type": "color-ramp"
                },
                "heatmap-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                }
            },
            paint_symbol: {
                "icon-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-halo-color": {
                    type: "color",
                    default: "rgba(0, 0, 0, 0)",
                    transition: !0,
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-halo-width": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-halo-blur": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "icon-translate": {
                    type: "array",
                    value: "number",
                    length: 2,
                    default: [
                        0,
                        0
                    ],
                    transition: !0,
                    units: "pixels",
                    requires: [
                        "icon-image"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "icon-translate-anchor": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "map",
                    requires: [
                        "icon-image",
                        "icon-translate"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    overridable: !0,
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-halo-color": {
                    type: "color",
                    default: "rgba(0, 0, 0, 0)",
                    transition: !0,
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-halo-width": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-halo-blur": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    transition: !0,
                    units: "pixels",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom",
                            "feature",
                            "feature-state"
                        ]
                    },
                    "property-type": "data-driven"
                },
                "text-translate": {
                    type: "array",
                    value: "number",
                    length: 2,
                    default: [
                        0,
                        0
                    ],
                    transition: !0,
                    units: "pixels",
                    requires: [
                        "text-field"
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "text-translate-anchor": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "map",
                    requires: [
                        "text-field",
                        "text-translate"
                    ],
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                }
            },
            paint_raster: {
                "raster-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "raster-hue-rotate": {
                    type: "number",
                    default: 0,
                    period: 360,
                    transition: !0,
                    units: "degrees",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "raster-brightness-min": {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "raster-brightness-max": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "raster-saturation": {
                    type: "number",
                    default: 0,
                    minimum: -1,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "raster-contrast": {
                    type: "number",
                    default: 0,
                    minimum: -1,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "raster-resampling": {
                    type: "enum",
                    values: {
                        linear: {},
                        nearest: {}
                    },
                    default: "linear",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "raster-fade-duration": {
                    type: "number",
                    default: 300,
                    minimum: 0,
                    transition: !1,
                    units: "milliseconds",
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                }
            },
            paint_hillshade: {
                "hillshade-illumination-direction": {
                    type: "number",
                    default: 335,
                    minimum: 0,
                    maximum: 359,
                    transition: !1,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "hillshade-illumination-anchor": {
                    type: "enum",
                    values: {
                        map: {},
                        viewport: {}
                    },
                    default: "viewport",
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "hillshade-exaggeration": {
                    type: "number",
                    default: .5,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "hillshade-shadow-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "hillshade-highlight-color": {
                    type: "color",
                    default: "#FFFFFF",
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "hillshade-accent-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                }
            },
            paint_background: {
                "background-color": {
                    type: "color",
                    default: "#000000",
                    transition: !0,
                    requires: [
                        {
                            "!": "background-pattern"
                        }
                    ],
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                },
                "background-pattern": {
                    type: "resolvedImage",
                    transition: !0,
                    expression: {
                        interpolated: !1,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "cross-faded"
                },
                "background-opacity": {
                    type: "number",
                    default: 1,
                    minimum: 0,
                    maximum: 1,
                    transition: !0,
                    expression: {
                        interpolated: !0,
                        parameters: [
                            "zoom"
                        ]
                    },
                    "property-type": "data-constant"
                }
            },
            transition: {
                duration: {
                    type: "number",
                    default: 300,
                    minimum: 0,
                    units: "milliseconds"
                },
                delay: {
                    type: "number",
                    default: 0,
                    minimum: 0,
                    units: "milliseconds"
                }
            },
            "property-type": {
                "data-driven": {
                    type: "property-type"
                },
                "cross-faded": {
                    type: "property-type"
                },
                "cross-faded-data-driven": {
                    type: "property-type"
                },
                "color-ramp": {
                    type: "property-type"
                },
                "data-constant": {
                    type: "property-type"
                },
                constant: {
                    type: "property-type"
                }
            },
            promoteId: {
                "*": {
                    type: "string"
                }
            }
        };
        class it {
            constructor(t1, e1, r, n){
                this.message = (t1 ? `${t1}: ` : "") + r, n && (this.identifier = n), null != e1 && e1.__line__ && (this.line = e1.__line__);
            }
        }
        function at(t1) {
            const e1 = t1.value;
            return e1 ? [
                new it(t1.key, e1, "constants have been deprecated as of v8")
            ] : [];
        }
        function st(t1, ...e1) {
            for (const r of e1)for(const e2 in r)t1[e2] = r[e2];
            return t1;
        }
        function ot(t1) {
            return t1 instanceof Number || t1 instanceof String || t1 instanceof Boolean ? t1.valueOf() : t1;
        }
        function lt(t1) {
            if (Array.isArray(t1)) return t1.map(lt);
            if (t1 instanceof Object && !(t1 instanceof Number || t1 instanceof String || t1 instanceof Boolean)) {
                const e1 = {};
                for(const r in t1)e1[r] = lt(t1[r]);
                return e1;
            }
            return ot(t1);
        }
        class ut extends Error {
            constructor(t1, e1){
                super(e1), this.message = e1, this.key = t1;
            }
        }
        class ct {
            constructor(t1, e1 = []){
                this.parent = t1, this.bindings = {};
                for (const [t2, r] of e1)this.bindings[t2] = r;
            }
            concat(t1) {
                return new ct(this, t1);
            }
            get(t1) {
                if (this.bindings[t1]) return this.bindings[t1];
                if (this.parent) return this.parent.get(t1);
                throw new Error(`${t1} not found in scope.`);
            }
            has(t1) {
                return !!this.bindings[t1] || !!this.parent && this.parent.has(t1);
            }
        }
        const ht = {
            kind: "null"
        }, pt = {
            kind: "number"
        }, ft = {
            kind: "string"
        }, dt = {
            kind: "boolean"
        }, yt = {
            kind: "color"
        }, mt = {
            kind: "object"
        }, gt = {
            kind: "value"
        }, xt = {
            kind: "collator"
        }, vt = {
            kind: "formatted"
        }, bt = {
            kind: "padding"
        }, wt = {
            kind: "resolvedImage"
        };
        function _t(t1, e1) {
            return {
                kind: "array",
                itemType: t1,
                N: e1
            };
        }
        function At(t1) {
            if ("array" === t1.kind) {
                const e1 = At(t1.itemType);
                return "number" == typeof t1.N ? `array<${e1}, ${t1.N}>` : "value" === t1.itemType.kind ? "array" : `array<${e1}>`;
            }
            return t1.kind;
        }
        const kt = [
            ht,
            pt,
            ft,
            dt,
            yt,
            vt,
            mt,
            _t(gt),
            bt,
            wt
        ];
        function St(t1, e1) {
            if ("error" === e1.kind) return null;
            if ("array" === t1.kind) {
                if ("array" === e1.kind && (0 === e1.N && "value" === e1.itemType.kind || !St(t1.itemType, e1.itemType)) && ("number" != typeof t1.N || t1.N === e1.N)) return null;
            } else {
                if (t1.kind === e1.kind) return null;
                if ("value" === t1.kind) {
                    for (const t2 of kt)if (!St(t2, e1)) return null;
                }
            }
            return `Expected ${At(t1)} but found ${At(e1)} instead.`;
        }
        function It(t1, e1) {
            return e1.some((e1)=>e1.kind === t1.kind);
        }
        function Mt(t1, e1) {
            return e1.some((e1)=>"null" === e1 ? null === t1 : "array" === e1 ? Array.isArray(t1) : "object" === e1 ? t1 && !Array.isArray(t1) && "object" == typeof t1 : e1 === typeof t1);
        }
        var zt, Bt = {
            transparent: [
                0,
                0,
                0,
                0
            ],
            aliceblue: [
                240,
                248,
                255,
                1
            ],
            antiquewhite: [
                250,
                235,
                215,
                1
            ],
            aqua: [
                0,
                255,
                255,
                1
            ],
            aquamarine: [
                127,
                255,
                212,
                1
            ],
            azure: [
                240,
                255,
                255,
                1
            ],
            beige: [
                245,
                245,
                220,
                1
            ],
            bisque: [
                255,
                228,
                196,
                1
            ],
            black: [
                0,
                0,
                0,
                1
            ],
            blanchedalmond: [
                255,
                235,
                205,
                1
            ],
            blue: [
                0,
                0,
                255,
                1
            ],
            blueviolet: [
                138,
                43,
                226,
                1
            ],
            brown: [
                165,
                42,
                42,
                1
            ],
            burlywood: [
                222,
                184,
                135,
                1
            ],
            cadetblue: [
                95,
                158,
                160,
                1
            ],
            chartreuse: [
                127,
                255,
                0,
                1
            ],
            chocolate: [
                210,
                105,
                30,
                1
            ],
            coral: [
                255,
                127,
                80,
                1
            ],
            cornflowerblue: [
                100,
                149,
                237,
                1
            ],
            cornsilk: [
                255,
                248,
                220,
                1
            ],
            crimson: [
                220,
                20,
                60,
                1
            ],
            cyan: [
                0,
                255,
                255,
                1
            ],
            darkblue: [
                0,
                0,
                139,
                1
            ],
            darkcyan: [
                0,
                139,
                139,
                1
            ],
            darkgoldenrod: [
                184,
                134,
                11,
                1
            ],
            darkgray: [
                169,
                169,
                169,
                1
            ],
            darkgreen: [
                0,
                100,
                0,
                1
            ],
            darkgrey: [
                169,
                169,
                169,
                1
            ],
            darkkhaki: [
                189,
                183,
                107,
                1
            ],
            darkmagenta: [
                139,
                0,
                139,
                1
            ],
            darkolivegreen: [
                85,
                107,
                47,
                1
            ],
            darkorange: [
                255,
                140,
                0,
                1
            ],
            darkorchid: [
                153,
                50,
                204,
                1
            ],
            darkred: [
                139,
                0,
                0,
                1
            ],
            darksalmon: [
                233,
                150,
                122,
                1
            ],
            darkseagreen: [
                143,
                188,
                143,
                1
            ],
            darkslateblue: [
                72,
                61,
                139,
                1
            ],
            darkslategray: [
                47,
                79,
                79,
                1
            ],
            darkslategrey: [
                47,
                79,
                79,
                1
            ],
            darkturquoise: [
                0,
                206,
                209,
                1
            ],
            darkviolet: [
                148,
                0,
                211,
                1
            ],
            deeppink: [
                255,
                20,
                147,
                1
            ],
            deepskyblue: [
                0,
                191,
                255,
                1
            ],
            dimgray: [
                105,
                105,
                105,
                1
            ],
            dimgrey: [
                105,
                105,
                105,
                1
            ],
            dodgerblue: [
                30,
                144,
                255,
                1
            ],
            firebrick: [
                178,
                34,
                34,
                1
            ],
            floralwhite: [
                255,
                250,
                240,
                1
            ],
            forestgreen: [
                34,
                139,
                34,
                1
            ],
            fuchsia: [
                255,
                0,
                255,
                1
            ],
            gainsboro: [
                220,
                220,
                220,
                1
            ],
            ghostwhite: [
                248,
                248,
                255,
                1
            ],
            gold: [
                255,
                215,
                0,
                1
            ],
            goldenrod: [
                218,
                165,
                32,
                1
            ],
            gray: [
                128,
                128,
                128,
                1
            ],
            green: [
                0,
                128,
                0,
                1
            ],
            greenyellow: [
                173,
                255,
                47,
                1
            ],
            grey: [
                128,
                128,
                128,
                1
            ],
            honeydew: [
                240,
                255,
                240,
                1
            ],
            hotpink: [
                255,
                105,
                180,
                1
            ],
            indianred: [
                205,
                92,
                92,
                1
            ],
            indigo: [
                75,
                0,
                130,
                1
            ],
            ivory: [
                255,
                255,
                240,
                1
            ],
            khaki: [
                240,
                230,
                140,
                1
            ],
            lavender: [
                230,
                230,
                250,
                1
            ],
            lavenderblush: [
                255,
                240,
                245,
                1
            ],
            lawngreen: [
                124,
                252,
                0,
                1
            ],
            lemonchiffon: [
                255,
                250,
                205,
                1
            ],
            lightblue: [
                173,
                216,
                230,
                1
            ],
            lightcoral: [
                240,
                128,
                128,
                1
            ],
            lightcyan: [
                224,
                255,
                255,
                1
            ],
            lightgoldenrodyellow: [
                250,
                250,
                210,
                1
            ],
            lightgray: [
                211,
                211,
                211,
                1
            ],
            lightgreen: [
                144,
                238,
                144,
                1
            ],
            lightgrey: [
                211,
                211,
                211,
                1
            ],
            lightpink: [
                255,
                182,
                193,
                1
            ],
            lightsalmon: [
                255,
                160,
                122,
                1
            ],
            lightseagreen: [
                32,
                178,
                170,
                1
            ],
            lightskyblue: [
                135,
                206,
                250,
                1
            ],
            lightslategray: [
                119,
                136,
                153,
                1
            ],
            lightslategrey: [
                119,
                136,
                153,
                1
            ],
            lightsteelblue: [
                176,
                196,
                222,
                1
            ],
            lightyellow: [
                255,
                255,
                224,
                1
            ],
            lime: [
                0,
                255,
                0,
                1
            ],
            limegreen: [
                50,
                205,
                50,
                1
            ],
            linen: [
                250,
                240,
                230,
                1
            ],
            magenta: [
                255,
                0,
                255,
                1
            ],
            maroon: [
                128,
                0,
                0,
                1
            ],
            mediumaquamarine: [
                102,
                205,
                170,
                1
            ],
            mediumblue: [
                0,
                0,
                205,
                1
            ],
            mediumorchid: [
                186,
                85,
                211,
                1
            ],
            mediumpurple: [
                147,
                112,
                219,
                1
            ],
            mediumseagreen: [
                60,
                179,
                113,
                1
            ],
            mediumslateblue: [
                123,
                104,
                238,
                1
            ],
            mediumspringgreen: [
                0,
                250,
                154,
                1
            ],
            mediumturquoise: [
                72,
                209,
                204,
                1
            ],
            mediumvioletred: [
                199,
                21,
                133,
                1
            ],
            midnightblue: [
                25,
                25,
                112,
                1
            ],
            mintcream: [
                245,
                255,
                250,
                1
            ],
            mistyrose: [
                255,
                228,
                225,
                1
            ],
            moccasin: [
                255,
                228,
                181,
                1
            ],
            navajowhite: [
                255,
                222,
                173,
                1
            ],
            navy: [
                0,
                0,
                128,
                1
            ],
            oldlace: [
                253,
                245,
                230,
                1
            ],
            olive: [
                128,
                128,
                0,
                1
            ],
            olivedrab: [
                107,
                142,
                35,
                1
            ],
            orange: [
                255,
                165,
                0,
                1
            ],
            orangered: [
                255,
                69,
                0,
                1
            ],
            orchid: [
                218,
                112,
                214,
                1
            ],
            palegoldenrod: [
                238,
                232,
                170,
                1
            ],
            palegreen: [
                152,
                251,
                152,
                1
            ],
            paleturquoise: [
                175,
                238,
                238,
                1
            ],
            palevioletred: [
                219,
                112,
                147,
                1
            ],
            papayawhip: [
                255,
                239,
                213,
                1
            ],
            peachpuff: [
                255,
                218,
                185,
                1
            ],
            peru: [
                205,
                133,
                63,
                1
            ],
            pink: [
                255,
                192,
                203,
                1
            ],
            plum: [
                221,
                160,
                221,
                1
            ],
            powderblue: [
                176,
                224,
                230,
                1
            ],
            purple: [
                128,
                0,
                128,
                1
            ],
            rebeccapurple: [
                102,
                51,
                153,
                1
            ],
            red: [
                255,
                0,
                0,
                1
            ],
            rosybrown: [
                188,
                143,
                143,
                1
            ],
            royalblue: [
                65,
                105,
                225,
                1
            ],
            saddlebrown: [
                139,
                69,
                19,
                1
            ],
            salmon: [
                250,
                128,
                114,
                1
            ],
            sandybrown: [
                244,
                164,
                96,
                1
            ],
            seagreen: [
                46,
                139,
                87,
                1
            ],
            seashell: [
                255,
                245,
                238,
                1
            ],
            sienna: [
                160,
                82,
                45,
                1
            ],
            silver: [
                192,
                192,
                192,
                1
            ],
            skyblue: [
                135,
                206,
                235,
                1
            ],
            slateblue: [
                106,
                90,
                205,
                1
            ],
            slategray: [
                112,
                128,
                144,
                1
            ],
            slategrey: [
                112,
                128,
                144,
                1
            ],
            snow: [
                255,
                250,
                250,
                1
            ],
            springgreen: [
                0,
                255,
                127,
                1
            ],
            steelblue: [
                70,
                130,
                180,
                1
            ],
            tan: [
                210,
                180,
                140,
                1
            ],
            teal: [
                0,
                128,
                128,
                1
            ],
            thistle: [
                216,
                191,
                216,
                1
            ],
            tomato: [
                255,
                99,
                71,
                1
            ],
            turquoise: [
                64,
                224,
                208,
                1
            ],
            violet: [
                238,
                130,
                238,
                1
            ],
            wheat: [
                245,
                222,
                179,
                1
            ],
            white: [
                255,
                255,
                255,
                1
            ],
            whitesmoke: [
                245,
                245,
                245,
                1
            ],
            yellow: [
                255,
                255,
                0,
                1
            ],
            yellowgreen: [
                154,
                205,
                50,
                1
            ]
        };
        function Ct(t1) {
            return (t1 = Math.round(t1)) < 0 ? 0 : t1 > 255 ? 255 : t1;
        }
        function Pt(t1) {
            return Ct("%" === t1[t1.length - 1] ? parseFloat(t1) / 100 * 255 : parseInt(t1));
        }
        function Vt(t1) {
            var e1;
            return (e1 = "%" === t1[t1.length - 1] ? parseFloat(t1) / 100 : parseFloat(t1)) < 0 ? 0 : e1 > 1 ? 1 : e1;
        }
        function Et(t1, e1, r) {
            return r < 0 ? r += 1 : r > 1 && (r -= 1), 6 * r < 1 ? t1 + (e1 - t1) * r * 6 : 2 * r < 1 ? e1 : 3 * r < 2 ? t1 + (e1 - t1) * (2 / 3 - r) * 6 : t1;
        }
        try {
            zt = ({}).parseCSSColor = function(t1) {
                var e1, r = t1.replace(/ /g, "").toLowerCase();
                if (r in Bt) return Bt[r].slice();
                if ("#" === r[0]) return 4 === r.length ? (e1 = parseInt(r.substr(1), 16)) >= 0 && e1 <= 4095 ? [
                    (3840 & e1) >> 4 | (3840 & e1) >> 8,
                    240 & e1 | (240 & e1) >> 4,
                    15 & e1 | (15 & e1) << 4,
                    1
                ] : null : 7 === r.length && (e1 = parseInt(r.substr(1), 16)) >= 0 && e1 <= 16777215 ? [
                    (16711680 & e1) >> 16,
                    (65280 & e1) >> 8,
                    255 & e1,
                    1
                ] : null;
                var n = r.indexOf("("), i = r.indexOf(")");
                if (-1 !== n && i + 1 === r.length) {
                    var a = r.substr(0, n), s = r.substr(n + 1, i - (n + 1)).split(","), o = 1;
                    switch(a){
                        case "rgba":
                            if (4 !== s.length) return null;
                            o = Vt(s.pop());
                        case "rgb":
                            return 3 !== s.length ? null : [
                                Pt(s[0]),
                                Pt(s[1]),
                                Pt(s[2]),
                                o
                            ];
                        case "hsla":
                            if (4 !== s.length) return null;
                            o = Vt(s.pop());
                        case "hsl":
                            if (3 !== s.length) return null;
                            var l = (parseFloat(s[0]) % 360 + 360) % 360 / 360, u = Vt(s[1]), c = Vt(s[2]), h = c <= .5 ? c * (u + 1) : c + u - c * u, p = 2 * c - h;
                            return [
                                Ct(255 * Et(p, h, l + 1 / 3)),
                                Ct(255 * Et(p, h, l)),
                                Ct(255 * Et(p, h, l - 1 / 3)),
                                o
                            ];
                        default:
                            return null;
                    }
                }
                return null;
            };
        } catch (t2) {}
        class Ft {
            constructor(t1, e1, r, n = 1){
                this.r = t1, this.g = e1, this.b = r, this.a = n;
            }
            static parse(t1) {
                if (!t1) return;
                if (t1 instanceof Ft) return t1;
                if ("string" != typeof t1) return;
                const e1 = zt(t1);
                return e1 ? new Ft(e1[0] / 255 * e1[3], e1[1] / 255 * e1[3], e1[2] / 255 * e1[3], e1[3]) : void 0;
            }
            toString() {
                const [t1, e1, r, n] = this.toArray();
                return `rgba(${Math.round(t1)},${Math.round(e1)},${Math.round(r)},${n})`;
            }
            toArray() {
                const { r: t1 , g: e1 , b: r , a: n  } = this;
                return 0 === n ? [
                    0,
                    0,
                    0,
                    0
                ] : [
                    255 * t1 / n,
                    255 * e1 / n,
                    255 * r / n,
                    n
                ];
            }
        }
        Ft.black = new Ft(0, 0, 0, 1), Ft.white = new Ft(1, 1, 1, 1), Ft.transparent = new Ft(0, 0, 0, 0), Ft.red = new Ft(1, 0, 0, 1);
        class Tt {
            constructor(t1, e1, r){
                this.sensitivity = t1 ? e1 ? "variant" : "case" : e1 ? "accent" : "base", this.locale = r, this.collator = new Intl.Collator(this.locale ? this.locale : [], {
                    sensitivity: this.sensitivity,
                    usage: "search"
                });
            }
            compare(t1, e1) {
                return this.collator.compare(t1, e1);
            }
            resolvedLocale() {
                return new Intl.Collator(this.locale ? this.locale : []).resolvedOptions().locale;
            }
        }
        class Lt {
            constructor(t1, e1, r, n, i){
                this.text = t1, this.image = e1, this.scale = r, this.fontStack = n, this.textColor = i;
            }
        }
        class Dt {
            constructor(t1){
                this.sections = t1;
            }
            static fromString(t1) {
                return new Dt([
                    new Lt(t1, null, null, null, null)
                ]);
            }
            isEmpty() {
                return 0 === this.sections.length || !this.sections.some((t1)=>0 !== t1.text.length || t1.image && 0 !== t1.image.name.length);
            }
            static factory(t1) {
                return t1 instanceof Dt ? t1 : Dt.fromString(t1);
            }
            toString() {
                return 0 === this.sections.length ? "" : this.sections.map((t1)=>t1.text).join("");
            }
        }
        class $t {
            constructor(t1){
                this.values = t1.slice();
            }
            static parse(t1) {
                if (t1 instanceof $t) return t1;
                if ("number" == typeof t1) return new $t([
                    t1,
                    t1,
                    t1,
                    t1
                ]);
                if (Array.isArray(t1) && !(t1.length < 1 || t1.length > 4)) {
                    for (const e1 of t1)if ("number" != typeof e1) return;
                    switch(t1.length){
                        case 1:
                            t1 = [
                                t1[0],
                                t1[0],
                                t1[0],
                                t1[0]
                            ];
                            break;
                        case 2:
                            t1 = [
                                t1[0],
                                t1[1],
                                t1[0],
                                t1[1]
                            ];
                            break;
                        case 3:
                            t1 = [
                                t1[0],
                                t1[1],
                                t1[2],
                                t1[1]
                            ];
                    }
                    return new $t(t1);
                }
            }
            toString() {
                return JSON.stringify(this.values);
            }
        }
        class Rt {
            constructor(t1){
                this.name = t1.name, this.available = t1.available;
            }
            toString() {
                return this.name;
            }
            static fromString(t1) {
                return t1 ? new Rt({
                    name: t1,
                    available: !1
                }) : null;
            }
        }
        function Ot(t1, e1, r, n) {
            return "number" == typeof t1 && t1 >= 0 && t1 <= 255 && "number" == typeof e1 && e1 >= 0 && e1 <= 255 && "number" == typeof r && r >= 0 && r <= 255 ? void 0 === n || "number" == typeof n && n >= 0 && n <= 1 ? null : `Invalid rgba value [${[
                t1,
                e1,
                r,
                n
            ].join(", ")}]: 'a' must be between 0 and 1.` : `Invalid rgba value [${("number" == typeof n ? [
                t1,
                e1,
                r,
                n
            ] : [
                t1,
                e1,
                r
            ]).join(", ")}]: 'r', 'g', and 'b' must be between 0 and 255.`;
        }
        function Ut(t1) {
            if (null === t1) return !0;
            if ("string" == typeof t1) return !0;
            if ("boolean" == typeof t1) return !0;
            if ("number" == typeof t1) return !0;
            if (t1 instanceof Ft) return !0;
            if (t1 instanceof Tt) return !0;
            if (t1 instanceof Dt) return !0;
            if (t1 instanceof $t) return !0;
            if (t1 instanceof Rt) return !0;
            if (Array.isArray(t1)) {
                for (const e1 of t1)if (!Ut(e1)) return !1;
                return !0;
            }
            if ("object" == typeof t1) {
                for(const e2 in t1)if (!Ut(t1[e2])) return !1;
                return !0;
            }
            return !1;
        }
        function qt(t1) {
            if (null === t1) return ht;
            if ("string" == typeof t1) return ft;
            if ("boolean" == typeof t1) return dt;
            if ("number" == typeof t1) return pt;
            if (t1 instanceof Ft) return yt;
            if (t1 instanceof Tt) return xt;
            if (t1 instanceof Dt) return vt;
            if (t1 instanceof $t) return bt;
            if (t1 instanceof Rt) return wt;
            if (Array.isArray(t1)) {
                const e1 = t1.length;
                let r;
                for (const e2 of t1){
                    const t2 = qt(e2);
                    if (r) {
                        if (r === t2) continue;
                        r = gt;
                        break;
                    }
                    r = t2;
                }
                return _t(r || gt, e1);
            }
            return mt;
        }
        function jt(t1) {
            const e1 = typeof t1;
            return null === t1 ? "" : "string" === e1 || "number" === e1 || "boolean" === e1 ? String(t1) : t1 instanceof Ft || t1 instanceof Dt || t1 instanceof $t || t1 instanceof Rt ? t1.toString() : JSON.stringify(t1);
        }
        class Nt {
            constructor(t1, e1){
                this.type = t1, this.value = e1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error(`'literal' expression requires exactly one argument, but found ${t1.length - 1} instead.`);
                if (!Ut(t1[1])) return e1.error("invalid value");
                const r = t1[1];
                let n = qt(r);
                const i = e1.expectedType;
                return "array" !== n.kind || 0 !== n.N || !i || "array" !== i.kind || "number" == typeof i.N && 0 !== i.N || (n = i), new Nt(n, r);
            }
            evaluate() {
                return this.value;
            }
            eachChild() {}
            outputDefined() {
                return !0;
            }
        }
        class Zt {
            constructor(t1){
                this.name = "ExpressionEvaluationError", this.message = t1;
            }
            toJSON() {
                return this.message;
            }
        }
        const Kt = {
            string: ft,
            number: pt,
            boolean: dt,
            object: mt
        };
        class Gt {
            constructor(t1, e1){
                this.type = t1, this.args = e1;
            }
            static parse(t1, e1) {
                if (t1.length < 2) return e1.error("Expected at least one argument.");
                let r, n = 1;
                const i = t1[0];
                if ("array" === i) {
                    let i1, a;
                    if (t1.length > 2) {
                        const r1 = t1[1];
                        if ("string" != typeof r1 || !(r1 in Kt) || "object" === r1) return e1.error('The item type argument of "array" must be one of string, number, boolean', 1);
                        i1 = Kt[r1], n++;
                    } else i1 = gt;
                    if (t1.length > 3) {
                        if (null !== t1[2] && ("number" != typeof t1[2] || t1[2] < 0 || t1[2] !== Math.floor(t1[2]))) return e1.error('The length argument to "array" must be a positive integer literal', 2);
                        a = t1[2], n++;
                    }
                    r = _t(i1, a);
                } else {
                    if (!Kt[i]) throw new Error(`Types doesn't contain name = ${i}`);
                    r = Kt[i];
                }
                const a1 = [];
                for(; n < t1.length; n++){
                    const r2 = e1.parse(t1[n], n, gt);
                    if (!r2) return null;
                    a1.push(r2);
                }
                return new Gt(r, a1);
            }
            evaluate(t1) {
                for(let e1 = 0; e1 < this.args.length; e1++){
                    const r = this.args[e1].evaluate(t1);
                    if (!St(this.type, qt(r))) return r;
                    if (e1 === this.args.length - 1) throw new Zt(`Expected value to be of type ${At(this.type)}, but found ${At(qt(r))} instead.`);
                }
                throw new Error;
            }
            eachChild(t1) {
                this.args.forEach(t1);
            }
            outputDefined() {
                return this.args.every((t1)=>t1.outputDefined());
            }
        }
        const Jt = {
            "to-boolean": dt,
            "to-color": yt,
            "to-number": pt,
            "to-string": ft
        };
        class Xt {
            constructor(t1, e1){
                this.type = t1, this.args = e1;
            }
            static parse(t1, e1) {
                if (t1.length < 2) return e1.error("Expected at least one argument.");
                const r = t1[0];
                if (!Jt[r]) throw new Error(`Can't parse ${r} as it is not part of the known types`);
                if (("to-boolean" === r || "to-string" === r) && 2 !== t1.length) return e1.error("Expected one argument.");
                const n = Jt[r], i = [];
                for(let r1 = 1; r1 < t1.length; r1++){
                    const n1 = e1.parse(t1[r1], r1, gt);
                    if (!n1) return null;
                    i.push(n1);
                }
                return new Xt(n, i);
            }
            evaluate(t1) {
                if ("boolean" === this.type.kind) return Boolean(this.args[0].evaluate(t1));
                if ("color" === this.type.kind) {
                    let e1, r;
                    for (const n of this.args){
                        if (e1 = n.evaluate(t1), r = null, e1 instanceof Ft) return e1;
                        if ("string" == typeof e1) {
                            const r1 = t1.parseColor(e1);
                            if (r1) return r1;
                        } else if (Array.isArray(e1) && (r = e1.length < 3 || e1.length > 4 ? `Invalid rbga value ${JSON.stringify(e1)}: expected an array containing either three or four numeric values.` : Ot(e1[0], e1[1], e1[2], e1[3]), !r)) return new Ft(e1[0] / 255, e1[1] / 255, e1[2] / 255, e1[3]);
                    }
                    throw new Zt(r || `Could not parse color from value '${"string" == typeof e1 ? e1 : JSON.stringify(e1)}'`);
                }
                if ("padding" === this.type.kind) {
                    let e2;
                    for (const r2 of this.args){
                        e2 = r2.evaluate(t1);
                        const n1 = $t.parse(e2);
                        if (n1) return n1;
                    }
                    throw new Zt(`Could not parse padding from value '${"string" == typeof e2 ? e2 : JSON.stringify(e2)}'`);
                }
                if ("number" === this.type.kind) {
                    let e3 = null;
                    for (const r3 of this.args){
                        if (e3 = r3.evaluate(t1), null === e3) return 0;
                        const n2 = Number(e3);
                        if (!isNaN(n2)) return n2;
                    }
                    throw new Zt(`Could not convert ${JSON.stringify(e3)} to number.`);
                }
                return "formatted" === this.type.kind ? Dt.fromString(jt(this.args[0].evaluate(t1))) : "resolvedImage" === this.type.kind ? Rt.fromString(jt(this.args[0].evaluate(t1))) : jt(this.args[0].evaluate(t1));
            }
            eachChild(t1) {
                this.args.forEach(t1);
            }
            outputDefined() {
                return this.args.every((t1)=>t1.outputDefined());
            }
        }
        const Yt = [
            "Unknown",
            "Point",
            "LineString",
            "Polygon"
        ];
        class Ht {
            constructor(){
                this.globals = null, this.feature = null, this.featureState = null, this.formattedSection = null, this._parseColorCache = {}, this.availableImages = null, this.canonical = null;
            }
            id() {
                return this.feature && "id" in this.feature ? this.feature.id : null;
            }
            geometryType() {
                return this.feature ? "number" == typeof this.feature.type ? Yt[this.feature.type] : this.feature.type : null;
            }
            geometry() {
                return this.feature && "geometry" in this.feature ? this.feature.geometry : null;
            }
            canonicalID() {
                return this.canonical;
            }
            properties() {
                return this.feature && this.feature.properties || {};
            }
            parseColor(t1) {
                let e1 = this._parseColorCache[t1];
                return e1 || (e1 = this._parseColorCache[t1] = Ft.parse(t1)), e1;
            }
        }
        class Wt {
            constructor(t1, e1, r, n){
                this.name = t1, this.type = e1, this._evaluate = r, this.args = n;
            }
            evaluate(t1) {
                return this._evaluate(t1, this.args);
            }
            eachChild(t1) {
                this.args.forEach(t1);
            }
            outputDefined() {
                return !1;
            }
            static parse(t1, e1) {
                const r = t1[0], n = Wt.definitions[r];
                if (!n) return e1.error(`Unknown expression "${r}". If you wanted a literal array, use ["literal", [...]].`, 0);
                const i = Array.isArray(n) ? n[0] : n.type, a = Array.isArray(n) ? [
                    [
                        n[1],
                        n[2]
                    ]
                ] : n.overloads, s = a.filter(([e1])=>!Array.isArray(e1) || e1.length === t1.length - 1);
                let o = null;
                for (const [n1, a1] of s){
                    o = new we(e1.registry, e1.path, null, e1.scope);
                    const s1 = [];
                    let l = !1;
                    for(let e2 = 1; e2 < t1.length; e2++){
                        const r1 = t1[e2], i1 = Array.isArray(n1) ? n1[e2 - 1] : n1.type, a2 = o.parse(r1, 1 + s1.length, i1);
                        if (!a2) {
                            l = !0;
                            break;
                        }
                        s1.push(a2);
                    }
                    if (!l) {
                        if (Array.isArray(n1) && n1.length !== s1.length) o.error(`Expected ${n1.length} arguments, but found ${s1.length} instead.`);
                        else {
                            for(let t2 = 0; t2 < s1.length; t2++){
                                const e3 = Array.isArray(n1) ? n1[t2] : n1.type, r2 = s1[t2];
                                o.concat(t2 + 1).checkSubtype(e3, r2.type);
                            }
                            if (0 === o.errors.length) return new Wt(r, i, a1, s1);
                        }
                    }
                }
                if (1 === s.length) e1.errors.push(...o.errors);
                else {
                    const r3 = (s.length ? s : a).map(([t1])=>{
                        var e1;
                        return e1 = t1, Array.isArray(e1) ? `(${e1.map(At).join(", ")})` : `(${At(e1.type)}...)`;
                    }).join(" | "), n2 = [];
                    for(let r4 = 1; r4 < t1.length; r4++){
                        const i2 = e1.parse(t1[r4], 1 + n2.length);
                        if (!i2) return null;
                        n2.push(At(i2.type));
                    }
                    e1.error(`Expected arguments of type ${r3}, but found (${n2.join(", ")}) instead.`);
                }
                return null;
            }
            static register(t1, e1) {
                Wt.definitions = e1;
                for(const r in e1)t1[r] = Wt;
            }
        }
        class Qt {
            constructor(t1, e1, r){
                this.type = xt, this.locale = r, this.caseSensitive = t1, this.diacriticSensitive = e1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error("Expected one argument.");
                const r = t1[1];
                if ("object" != typeof r || Array.isArray(r)) return e1.error("Collator options argument must be an object.");
                const n = e1.parse(void 0 !== r["case-sensitive"] && r["case-sensitive"], 1, dt);
                if (!n) return null;
                const i = e1.parse(void 0 !== r["diacritic-sensitive"] && r["diacritic-sensitive"], 1, dt);
                if (!i) return null;
                let a = null;
                return r.locale && (a = e1.parse(r.locale, 1, ft), !a) ? null : new Qt(n, i, a);
            }
            evaluate(t1) {
                return new Tt(this.caseSensitive.evaluate(t1), this.diacriticSensitive.evaluate(t1), this.locale ? this.locale.evaluate(t1) : null);
            }
            eachChild(t1) {
                t1(this.caseSensitive), t1(this.diacriticSensitive), this.locale && t1(this.locale);
            }
            outputDefined() {
                return !1;
            }
        }
        const te = 8192;
        function ee(t1, e1) {
            t1[0] = Math.min(t1[0], e1[0]), t1[1] = Math.min(t1[1], e1[1]), t1[2] = Math.max(t1[2], e1[0]), t1[3] = Math.max(t1[3], e1[1]);
        }
        function re(t1, e1) {
            return !(t1[0] <= e1[0] || t1[2] >= e1[2] || t1[1] <= e1[1] || t1[3] >= e1[3]);
        }
        function ne(t1, e1) {
            const r = (180 + t1[0]) / 360, n = (180 - 180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + t1[1] * Math.PI / 360))) / 360, i = Math.pow(2, e1.z);
            return [
                Math.round(r * i * te),
                Math.round(n * i * te)
            ];
        }
        function ie(t1, e1, r) {
            const n = t1[0] - e1[0], i = t1[1] - e1[1], a = t1[0] - r[0], s = t1[1] - r[1];
            return n * s - a * i == 0 && n * a <= 0 && i * s <= 0;
        }
        function ae(t1, e1) {
            let r = !1;
            for(let s = 0, o = e1.length; s < o; s++){
                const o1 = e1[s];
                for(let e2 = 0, s1 = o1.length; e2 < s1 - 1; e2++){
                    if (ie(t1, o1[e2], o1[e2 + 1])) return !1;
                    (i = o1[e2])[1] > (n = t1)[1] != (a = o1[e2 + 1])[1] > n[1] && n[0] < (a[0] - i[0]) * (n[1] - i[1]) / (a[1] - i[1]) + i[0] && (r = !r);
                }
            }
            var n, i, a;
            return r;
        }
        function se(t1, e1) {
            for(let r = 0; r < e1.length; r++)if (ae(t1, e1[r])) return !0;
            return !1;
        }
        function oe(t1, e1, r, n) {
            const i = n[0] - r[0], a = n[1] - r[1], s = (t1[0] - r[0]) * a - i * (t1[1] - r[1]), o = (e1[0] - r[0]) * a - i * (e1[1] - r[1]);
            return s > 0 && o < 0 || s < 0 && o > 0;
        }
        function le(t1, e1, r) {
            for (const u of r)for(let r1 = 0; r1 < u.length - 1; ++r1)if (0 != (o = [
                (s = u[r1 + 1])[0] - (a = u[r1])[0],
                s[1] - a[1]
            ])[0] * (l = [
                (i = e1)[0] - (n = t1)[0],
                i[1] - n[1]
            ])[1] - o[1] * l[0] && oe(n, i, a, s) && oe(a, s, n, i)) return !0;
            var n, i, a, s, o, l;
            return !1;
        }
        function ue(t1, e1) {
            for(let r = 0; r < t1.length; ++r)if (!ae(t1[r], e1)) return !1;
            for(let r1 = 0; r1 < t1.length - 1; ++r1)if (le(t1[r1], t1[r1 + 1], e1)) return !1;
            return !0;
        }
        function ce(t1, e1) {
            for(let r = 0; r < e1.length; r++)if (ue(t1, e1[r])) return !0;
            return !1;
        }
        function he(t1, e1, r) {
            const n = [];
            for(let i = 0; i < t1.length; i++){
                const a = [];
                for(let n1 = 0; n1 < t1[i].length; n1++){
                    const s = ne(t1[i][n1], r);
                    ee(e1, s), a.push(s);
                }
                n.push(a);
            }
            return n;
        }
        function pe(t1, e1, r) {
            const n = [];
            for(let i = 0; i < t1.length; i++){
                const a = he(t1[i], e1, r);
                n.push(a);
            }
            return n;
        }
        function fe(t1, e1, r, n) {
            if (t1[0] < r[0] || t1[0] > r[2]) {
                const e2 = .5 * n;
                let i = t1[0] - r[0] > e2 ? -n : r[0] - t1[0] > e2 ? n : 0;
                0 === i && (i = t1[0] - r[2] > e2 ? -n : r[2] - t1[0] > e2 ? n : 0), t1[0] += i;
            }
            ee(e1, t1);
        }
        function de(t1, e1, r, n) {
            const i = Math.pow(2, n.z) * te, a = [
                n.x * te,
                n.y * te
            ], s = [];
            for (const n1 of t1)for (const t2 of n1){
                const n2 = [
                    t2.x + a[0],
                    t2.y + a[1]
                ];
                fe(n2, e1, r, i), s.push(n2);
            }
            return s;
        }
        function ye(t1, e1, r, n) {
            const i = Math.pow(2, n.z) * te, a = [
                n.x * te,
                n.y * te
            ], s = [];
            for (const r1 of t1){
                const t2 = [];
                for (const n1 of r1){
                    const r2 = [
                        n1.x + a[0],
                        n1.y + a[1]
                    ];
                    ee(e1, r2), t2.push(r2);
                }
                s.push(t2);
            }
            if (e1[2] - e1[0] <= i / 2) {
                (o = e1)[0] = o[1] = 1 / 0, o[2] = o[3] = -1 / 0;
                for (const t3 of s)for (const n2 of t3)fe(n2, e1, r, i);
            }
            var o;
            return s;
        }
        class me {
            constructor(t1, e1){
                this.type = dt, this.geojson = t1, this.geometries = e1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error(`'within' expression requires exactly one argument, but found ${t1.length - 1} instead.`);
                if (Ut(t1[1])) {
                    const e2 = t1[1];
                    if ("FeatureCollection" === e2.type) for(let t2 = 0; t2 < e2.features.length; ++t2){
                        const r = e2.features[t2].geometry.type;
                        if ("Polygon" === r || "MultiPolygon" === r) return new me(e2, e2.features[t2].geometry);
                    }
                    else if ("Feature" === e2.type) {
                        const t3 = e2.geometry.type;
                        if ("Polygon" === t3 || "MultiPolygon" === t3) return new me(e2, e2.geometry);
                    } else if ("Polygon" === e2.type || "MultiPolygon" === e2.type) return new me(e2, e2);
                }
                return e1.error("'within' expression requires valid geojson object that contains polygon geometry type.");
            }
            evaluate(t1) {
                if (null != t1.geometry() && null != t1.canonicalID()) {
                    if ("Point" === t1.geometryType()) return function(t1, e1) {
                        const r = [
                            1 / 0,
                            1 / 0,
                            -1 / 0,
                            -1 / 0
                        ], n = [
                            1 / 0,
                            1 / 0,
                            -1 / 0,
                            -1 / 0
                        ], i = t1.canonicalID();
                        if ("Polygon" === e1.type) {
                            const a = he(e1.coordinates, n, i), s = de(t1.geometry(), r, n, i);
                            if (!re(r, n)) return !1;
                            for (const t2 of s)if (!ae(t2, a)) return !1;
                        }
                        if ("MultiPolygon" === e1.type) {
                            const a1 = pe(e1.coordinates, n, i), s1 = de(t1.geometry(), r, n, i);
                            if (!re(r, n)) return !1;
                            for (const t3 of s1)if (!se(t3, a1)) return !1;
                        }
                        return !0;
                    }(t1, this.geometries);
                    if ("LineString" === t1.geometryType()) return function(t1, e1) {
                        const r = [
                            1 / 0,
                            1 / 0,
                            -1 / 0,
                            -1 / 0
                        ], n = [
                            1 / 0,
                            1 / 0,
                            -1 / 0,
                            -1 / 0
                        ], i = t1.canonicalID();
                        if ("Polygon" === e1.type) {
                            const a = he(e1.coordinates, n, i), s = ye(t1.geometry(), r, n, i);
                            if (!re(r, n)) return !1;
                            for (const t2 of s)if (!ue(t2, a)) return !1;
                        }
                        if ("MultiPolygon" === e1.type) {
                            const a1 = pe(e1.coordinates, n, i), s1 = ye(t1.geometry(), r, n, i);
                            if (!re(r, n)) return !1;
                            for (const t3 of s1)if (!ce(t3, a1)) return !1;
                        }
                        return !0;
                    }(t1, this.geometries);
                }
                return !1;
            }
            eachChild() {}
            outputDefined() {
                return !0;
            }
        }
        function ge(t1) {
            if (t1 instanceof Wt) {
                if ("get" === t1.name && 1 === t1.args.length) return !1;
                if ("feature-state" === t1.name) return !1;
                if ("has" === t1.name && 1 === t1.args.length) return !1;
                if ("properties" === t1.name || "geometry-type" === t1.name || "id" === t1.name) return !1;
                if (/^filter-/.test(t1.name)) return !1;
            }
            if (t1 instanceof me) return !1;
            let e1 = !0;
            return t1.eachChild((t1)=>{
                e1 && !ge(t1) && (e1 = !1);
            }), e1;
        }
        function xe(t1) {
            if (t1 instanceof Wt && "feature-state" === t1.name) return !1;
            let e1 = !0;
            return t1.eachChild((t1)=>{
                e1 && !xe(t1) && (e1 = !1);
            }), e1;
        }
        function ve(t1, e1) {
            if (t1 instanceof Wt && e1.indexOf(t1.name) >= 0) return !1;
            let r = !0;
            return t1.eachChild((t1)=>{
                r && !ve(t1, e1) && (r = !1);
            }), r;
        }
        class be {
            constructor(t1, e1){
                this.type = e1.type, this.name = t1, this.boundExpression = e1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length || "string" != typeof t1[1]) return e1.error("'var' expression requires exactly one string literal argument.");
                const r = t1[1];
                return e1.scope.has(r) ? new be(r, e1.scope.get(r)) : e1.error(`Unknown variable "${r}". Make sure "${r}" has been bound in an enclosing "let" expression before using it.`, 1);
            }
            evaluate(t1) {
                return this.boundExpression.evaluate(t1);
            }
            eachChild() {}
            outputDefined() {
                return !1;
            }
        }
        class we {
            constructor(t1, e1 = [], r, n = new ct, i = []){
                this.registry = t1, this.path = e1, this.key = e1.map((t1)=>`[${t1}]`).join(""), this.scope = n, this.errors = i, this.expectedType = r;
            }
            parse(t1, e1, r, n, i = {}) {
                return e1 ? this.concat(e1, r, n)._parse(t1, i) : this._parse(t1, i);
            }
            _parse(t1, e1) {
                function r(t1, e1, r) {
                    return "assert" === r ? new Gt(e1, [
                        t1
                    ]) : "coerce" === r ? new Xt(e1, [
                        t1
                    ]) : t1;
                }
                if (null !== t1 && "string" != typeof t1 && "boolean" != typeof t1 && "number" != typeof t1 || (t1 = [
                    "literal",
                    t1
                ]), Array.isArray(t1)) {
                    if (0 === t1.length) return this.error('Expected an array with at least one element. If you wanted a literal array, use ["literal", []].');
                    const n = t1[0];
                    if ("string" != typeof n) return this.error(`Expression name must be a string, but found ${typeof n} instead. If you wanted a literal array, use ["literal", [...]].`, 0), null;
                    const i = this.registry[n];
                    if (i) {
                        let n1 = i.parse(t1, this);
                        if (!n1) return null;
                        if (this.expectedType) {
                            const t2 = this.expectedType, i1 = n1.type;
                            if ("string" !== t2.kind && "number" !== t2.kind && "boolean" !== t2.kind && "object" !== t2.kind && "array" !== t2.kind || "value" !== i1.kind) {
                                if ("color" !== t2.kind && "formatted" !== t2.kind && "resolvedImage" !== t2.kind || "value" !== i1.kind && "string" !== i1.kind) {
                                    if ("padding" !== t2.kind || "value" !== i1.kind && "number" !== i1.kind && "array" !== i1.kind) {
                                        if (this.checkSubtype(t2, i1)) return null;
                                    } else n1 = r(n1, t2, e1.typeAnnotation || "coerce");
                                } else n1 = r(n1, t2, e1.typeAnnotation || "coerce");
                            } else n1 = r(n1, t2, e1.typeAnnotation || "assert");
                        }
                        if (!(n1 instanceof Nt) && "resolvedImage" !== n1.type.kind && _e(n1)) {
                            const t3 = new Ht;
                            try {
                                n1 = new Nt(n1.type, n1.evaluate(t3));
                            } catch (t4) {
                                return this.error(t4.message), null;
                            }
                        }
                        return n1;
                    }
                    return this.error(`Unknown expression "${n}". If you wanted a literal array, use ["literal", [...]].`, 0);
                }
                return this.error(void 0 === t1 ? "'undefined' value invalid. Use null instead." : "object" == typeof t1 ? 'Bare objects invalid. Use ["literal", {...}] instead.' : `Expected an array, but found ${typeof t1} instead.`);
            }
            concat(t1, e1, r) {
                const n = "number" == typeof t1 ? this.path.concat(t1) : this.path, i = r ? this.scope.concat(r) : this.scope;
                return new we(this.registry, n, e1 || null, i, this.errors);
            }
            error(t1, ...e1) {
                const r = `${this.key}${e1.map((t1)=>`[${t1}]`).join("")}`;
                this.errors.push(new ut(r, t1));
            }
            checkSubtype(t1, e1) {
                const r = St(t1, e1);
                return r && this.error(r), r;
            }
        }
        function _e(t1) {
            if (t1 instanceof be) return _e(t1.boundExpression);
            if (t1 instanceof Wt && "error" === t1.name) return !1;
            if (t1 instanceof Qt) return !1;
            if (t1 instanceof me) return !1;
            const e1 = t1 instanceof Xt || t1 instanceof Gt;
            let r = !0;
            return t1.eachChild((t1)=>{
                r = e1 ? r && _e(t1) : r && t1 instanceof Nt;
            }), !!r && ge(t1) && ve(t1, [
                "zoom",
                "heatmap-density",
                "line-progress",
                "accumulated",
                "is-supported-script"
            ]);
        }
        function Ae(t1, e1) {
            const r = t1.length - 1;
            let n, i, a = 0, s = r, o = 0;
            for(; a <= s;)if (o = Math.floor((a + s) / 2), n = t1[o], i = t1[o + 1], n <= e1) {
                if (o === r || e1 < i) return o;
                a = o + 1;
            } else {
                if (!(n > e1)) throw new Zt("Input is not a number.");
                s = o - 1;
            }
            return 0;
        }
        class ke {
            constructor(t1, e1, r){
                this.type = t1, this.input = e1, this.labels = [], this.outputs = [];
                for (const [t2, e2] of r)this.labels.push(t2), this.outputs.push(e2);
            }
            static parse(t1, e1) {
                if (t1.length - 1 < 4) return e1.error(`Expected at least 4 arguments, but found only ${t1.length - 1}.`);
                if ((t1.length - 1) % 2 != 0) return e1.error("Expected an even number of arguments.");
                const r = e1.parse(t1[1], 1, pt);
                if (!r) return null;
                const n = [];
                let i = null;
                e1.expectedType && "value" !== e1.expectedType.kind && (i = e1.expectedType);
                for(let r1 = 1; r1 < t1.length; r1 += 2){
                    const a = 1 === r1 ? -1 / 0 : t1[r1], s = t1[r1 + 1], o = r1, l = r1 + 1;
                    if ("number" != typeof a) return e1.error('Input/output pairs for "step" expressions must be defined using literal numeric values (not computed expressions) for the input values.', o);
                    if (n.length && n[n.length - 1][0] >= a) return e1.error('Input/output pairs for "step" expressions must be arranged with input values in strictly ascending order.', o);
                    const u = e1.parse(s, l, i);
                    if (!u) return null;
                    i = i || u.type, n.push([
                        a,
                        u
                    ]);
                }
                return new ke(i, r, n);
            }
            evaluate(t1) {
                const e1 = this.labels, r = this.outputs;
                if (1 === e1.length) return r[0].evaluate(t1);
                const n = this.input.evaluate(t1);
                if (n <= e1[0]) return r[0].evaluate(t1);
                const i = e1.length;
                return n >= e1[i - 1] ? r[i - 1].evaluate(t1) : r[Ae(e1, n)].evaluate(t1);
            }
            eachChild(t1) {
                t1(this.input);
                for (const e1 of this.outputs)t1(e1);
            }
            outputDefined() {
                return this.outputs.every((t1)=>t1.outputDefined());
            }
        }
        function Se(t1, e1, r) {
            return t1 * (1 - r) + e1 * r;
        }
        var Ie = Object.freeze({
            __proto__: null,
            number: Se,
            color: function(t1, e1, r) {
                return new Ft(Se(t1.r, e1.r, r), Se(t1.g, e1.g, r), Se(t1.b, e1.b, r), Se(t1.a, e1.a, r));
            },
            array: function(t1, e1, r) {
                return t1.map((t1, n)=>Se(t1, e1[n], r));
            },
            padding: function(t1, e1, r) {
                const n = t1.values, i = e1.values;
                return new $t([
                    Se(n[0], i[0], r),
                    Se(n[1], i[1], r),
                    Se(n[2], i[2], r),
                    Se(n[3], i[3], r)
                ]);
            }
        });
        const Me = .95047, ze = 1.08883, Be = 4 / 29, Ce = 6 / 29, Pe = 3 * Ce * Ce, Ve = Math.PI / 180, Ee = 180 / Math.PI;
        function Fe(t1) {
            return t1 > .008856451679035631 ? Math.pow(t1, 1 / 3) : t1 / Pe + Be;
        }
        function Te(t1) {
            return t1 > Ce ? t1 * t1 * t1 : Pe * (t1 - Be);
        }
        function Le(t1) {
            return 255 * (t1 <= .0031308 ? 12.92 * t1 : 1.055 * Math.pow(t1, 1 / 2.4) - .055);
        }
        function De(t1) {
            return (t1 /= 255) <= .04045 ? t1 / 12.92 : Math.pow((t1 + .055) / 1.055, 2.4);
        }
        function $e(t1) {
            const e1 = De(t1.r), r = De(t1.g), n = De(t1.b), i = Fe((.4124564 * e1 + .3575761 * r + .1804375 * n) / Me), a = Fe((.2126729 * e1 + .7151522 * r + .072175 * n) / 1);
            return {
                l: 116 * a - 16,
                a: 500 * (i - a),
                b: 200 * (a - Fe((.0193339 * e1 + .119192 * r + .9503041 * n) / ze)),
                alpha: t1.a
            };
        }
        function Re(t1) {
            let e1 = (t1.l + 16) / 116, r = isNaN(t1.a) ? e1 : e1 + t1.a / 500, n = isNaN(t1.b) ? e1 : e1 - t1.b / 200;
            return e1 = 1 * Te(e1), r = Me * Te(r), n = ze * Te(n), new Ft(Le(3.2404542 * r - 1.5371385 * e1 - .4985314 * n), Le(-0.969266 * r + 1.8760108 * e1 + .041556 * n), Le(.0556434 * r - .2040259 * e1 + 1.0572252 * n), t1.alpha);
        }
        function Oe(t1, e1, r) {
            const n = e1 - t1;
            return t1 + r * (n > 180 || n < -180 ? n - 360 * Math.round(n / 360) : n);
        }
        const Ue = {
            forward: $e,
            reverse: Re,
            interpolate: function(t1, e1, r) {
                return {
                    l: Se(t1.l, e1.l, r),
                    a: Se(t1.a, e1.a, r),
                    b: Se(t1.b, e1.b, r),
                    alpha: Se(t1.alpha, e1.alpha, r)
                };
            }
        }, qe = {
            forward: function(t1) {
                const { l: e1 , a: r , b: n  } = $e(t1), i = Math.atan2(n, r) * Ee;
                return {
                    h: i < 0 ? i + 360 : i,
                    c: Math.sqrt(r * r + n * n),
                    l: e1,
                    alpha: t1.a
                };
            },
            reverse: function(t1) {
                const e1 = t1.h * Ve, r = t1.c;
                return Re({
                    l: t1.l,
                    a: Math.cos(e1) * r,
                    b: Math.sin(e1) * r,
                    alpha: t1.alpha
                });
            },
            interpolate: function(t1, e1, r) {
                return {
                    h: Oe(t1.h, e1.h, r),
                    c: Se(t1.c, e1.c, r),
                    l: Se(t1.l, e1.l, r),
                    alpha: Se(t1.alpha, e1.alpha, r)
                };
            }
        };
        var je = Object.freeze({
            __proto__: null,
            lab: Ue,
            hcl: qe
        });
        class Ne {
            constructor(t1, e1, r, n, i){
                this.type = t1, this.operator = e1, this.interpolation = r, this.input = n, this.labels = [], this.outputs = [];
                for (const [t2, e2] of i)this.labels.push(t2), this.outputs.push(e2);
            }
            static interpolationFactor(t1, r, n, i) {
                let a = 0;
                if ("exponential" === t1.name) a = Ze(r, t1.base, n, i);
                else if ("linear" === t1.name) a = Ze(r, 1, n, i);
                else if ("cubic-bezier" === t1.name) {
                    const s = t1.controlPoints;
                    a = new e1(s[0], s[1], s[2], s[3]).solve(Ze(r, 1, n, i));
                }
                return a;
            }
            static parse(t1, e1) {
                let [r, n, i, ...a] = t1;
                if (!Array.isArray(n) || 0 === n.length) return e1.error("Expected an interpolation type expression.", 1);
                if ("linear" === n[0]) n = {
                    name: "linear"
                };
                else if ("exponential" === n[0]) {
                    const t2 = n[1];
                    if ("number" != typeof t2) return e1.error("Exponential interpolation requires a numeric base.", 1, 1);
                    n = {
                        name: "exponential",
                        base: t2
                    };
                } else {
                    if ("cubic-bezier" !== n[0]) return e1.error(`Unknown interpolation type ${String(n[0])}`, 1, 0);
                    {
                        const t3 = n.slice(1);
                        if (4 !== t3.length || t3.some((t1)=>"number" != typeof t1 || t1 < 0 || t1 > 1)) return e1.error("Cubic bezier interpolation requires four numeric arguments with values between 0 and 1.", 1);
                        n = {
                            name: "cubic-bezier",
                            controlPoints: t3
                        };
                    }
                }
                if (t1.length - 1 < 4) return e1.error(`Expected at least 4 arguments, but found only ${t1.length - 1}.`);
                if ((t1.length - 1) % 2 != 0) return e1.error("Expected an even number of arguments.");
                if (i = e1.parse(i, 2, pt), !i) return null;
                const s = [];
                let o = null;
                "interpolate-hcl" === r || "interpolate-lab" === r ? o = yt : e1.expectedType && "value" !== e1.expectedType.kind && (o = e1.expectedType);
                for(let t4 = 0; t4 < a.length; t4 += 2){
                    const r1 = a[t4], n1 = a[t4 + 1], i1 = t4 + 3, l = t4 + 4;
                    if ("number" != typeof r1) return e1.error('Input/output pairs for "interpolate" expressions must be defined using literal numeric values (not computed expressions) for the input values.', i1);
                    if (s.length && s[s.length - 1][0] >= r1) return e1.error('Input/output pairs for "interpolate" expressions must be arranged with input values in strictly ascending order.', i1);
                    const u = e1.parse(n1, l, o);
                    if (!u) return null;
                    o = o || u.type, s.push([
                        r1,
                        u
                    ]);
                }
                return "number" === o.kind || "color" === o.kind || "padding" === o.kind || "array" === o.kind && "number" === o.itemType.kind && "number" == typeof o.N ? new Ne(o, r, n, i, s) : e1.error(`Type ${At(o)} is not interpolatable.`);
            }
            evaluate(t1) {
                const e1 = this.labels, r = this.outputs;
                if (1 === e1.length) return r[0].evaluate(t1);
                const n = this.input.evaluate(t1);
                if (n <= e1[0]) return r[0].evaluate(t1);
                const i = e1.length;
                if (n >= e1[i - 1]) return r[i - 1].evaluate(t1);
                const a = Ae(e1, n), s = Ne.interpolationFactor(this.interpolation, n, e1[a], e1[a + 1]), o = r[a].evaluate(t1), l = r[a + 1].evaluate(t1);
                return "interpolate" === this.operator ? Ie[this.type.kind.toLowerCase()](o, l, s) : "interpolate-hcl" === this.operator ? qe.reverse(qe.interpolate(qe.forward(o), qe.forward(l), s)) : Ue.reverse(Ue.interpolate(Ue.forward(o), Ue.forward(l), s));
            }
            eachChild(t1) {
                t1(this.input);
                for (const e1 of this.outputs)t1(e1);
            }
            outputDefined() {
                return this.outputs.every((t1)=>t1.outputDefined());
            }
        }
        function Ze(t1, e1, r, n) {
            const i = n - r, a = t1 - r;
            return 0 === i ? 0 : 1 === e1 ? a / i : (Math.pow(e1, a) - 1) / (Math.pow(e1, i) - 1);
        }
        class Ke {
            constructor(t1, e1){
                this.type = t1, this.args = e1;
            }
            static parse(t1, e1) {
                if (t1.length < 2) return e1.error("Expectected at least one argument.");
                let r = null;
                const n = e1.expectedType;
                n && "value" !== n.kind && (r = n);
                const i = [];
                for (const n1 of t1.slice(1)){
                    const t2 = e1.parse(n1, 1 + i.length, r, void 0, {
                        typeAnnotation: "omit"
                    });
                    if (!t2) return null;
                    r = r || t2.type, i.push(t2);
                }
                if (!r) throw new Error("No output type");
                const a = n && i.some((t1)=>St(n, t1.type));
                return new Ke(a ? gt : r, i);
            }
            evaluate(t1) {
                let e1, r = null, n = 0;
                for (const i of this.args)if (n++, r = i.evaluate(t1), r && r instanceof Rt && !r.available && (e1 || (e1 = r.name), r = null, n === this.args.length && (r = e1)), null !== r) break;
                return r;
            }
            eachChild(t1) {
                this.args.forEach(t1);
            }
            outputDefined() {
                return this.args.every((t1)=>t1.outputDefined());
            }
        }
        class Ge {
            constructor(t1, e1){
                this.type = e1.type, this.bindings = [].concat(t1), this.result = e1;
            }
            evaluate(t1) {
                return this.result.evaluate(t1);
            }
            eachChild(t1) {
                for (const e1 of this.bindings)t1(e1[1]);
                t1(this.result);
            }
            static parse(t1, e1) {
                if (t1.length < 4) return e1.error(`Expected at least 3 arguments, but found ${t1.length - 1} instead.`);
                const r = [];
                for(let n = 1; n < t1.length - 1; n += 2){
                    const i = t1[n];
                    if ("string" != typeof i) return e1.error(`Expected string, but found ${typeof i} instead.`, n);
                    if (/[^a-zA-Z0-9_]/.test(i)) return e1.error("Variable names must contain only alphanumeric characters or '_'.", n);
                    const a = e1.parse(t1[n + 1], n + 1);
                    if (!a) return null;
                    r.push([
                        i,
                        a
                    ]);
                }
                const n1 = e1.parse(t1[t1.length - 1], t1.length - 1, e1.expectedType, r);
                return n1 ? new Ge(r, n1) : null;
            }
            outputDefined() {
                return this.result.outputDefined();
            }
        }
        class Je {
            constructor(t1, e1, r){
                this.type = t1, this.index = e1, this.input = r;
            }
            static parse(t1, e1) {
                if (3 !== t1.length) return e1.error(`Expected 2 arguments, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1, pt), n = e1.parse(t1[2], 2, _t(e1.expectedType || gt));
                return r && n ? new Je(n.type.itemType, r, n) : null;
            }
            evaluate(t1) {
                const e1 = this.index.evaluate(t1), r = this.input.evaluate(t1);
                if (e1 < 0) throw new Zt(`Array index out of bounds: ${e1} < 0.`);
                if (e1 >= r.length) throw new Zt(`Array index out of bounds: ${e1} > ${r.length - 1}.`);
                if (e1 !== Math.floor(e1)) throw new Zt(`Array index must be an integer, but found ${e1} instead.`);
                return r[e1];
            }
            eachChild(t1) {
                t1(this.index), t1(this.input);
            }
            outputDefined() {
                return !1;
            }
        }
        class Xe {
            constructor(t1, e1){
                this.type = dt, this.needle = t1, this.haystack = e1;
            }
            static parse(t1, e1) {
                if (3 !== t1.length) return e1.error(`Expected 2 arguments, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1, gt), n = e1.parse(t1[2], 2, gt);
                return r && n ? It(r.type, [
                    dt,
                    ft,
                    pt,
                    ht,
                    gt
                ]) ? new Xe(r, n) : e1.error(`Expected first argument to be of type boolean, string, number or null, but found ${At(r.type)} instead`) : null;
            }
            evaluate(t1) {
                const e1 = this.needle.evaluate(t1), r = this.haystack.evaluate(t1);
                if (!r) return !1;
                if (!Mt(e1, [
                    "boolean",
                    "string",
                    "number",
                    "null"
                ])) throw new Zt(`Expected first argument to be of type boolean, string, number or null, but found ${At(qt(e1))} instead.`);
                if (!Mt(r, [
                    "string",
                    "array"
                ])) throw new Zt(`Expected second argument to be of type array or string, but found ${At(qt(r))} instead.`);
                return r.indexOf(e1) >= 0;
            }
            eachChild(t1) {
                t1(this.needle), t1(this.haystack);
            }
            outputDefined() {
                return !0;
            }
        }
        class Ye {
            constructor(t1, e1, r){
                this.type = pt, this.needle = t1, this.haystack = e1, this.fromIndex = r;
            }
            static parse(t1, e1) {
                if (t1.length <= 2 || t1.length >= 5) return e1.error(`Expected 3 or 4 arguments, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1, gt), n = e1.parse(t1[2], 2, gt);
                if (!r || !n) return null;
                if (!It(r.type, [
                    dt,
                    ft,
                    pt,
                    ht,
                    gt
                ])) return e1.error(`Expected first argument to be of type boolean, string, number or null, but found ${At(r.type)} instead`);
                if (4 === t1.length) {
                    const i = e1.parse(t1[3], 3, pt);
                    return i ? new Ye(r, n, i) : null;
                }
                return new Ye(r, n);
            }
            evaluate(t1) {
                const e1 = this.needle.evaluate(t1), r = this.haystack.evaluate(t1);
                if (!Mt(e1, [
                    "boolean",
                    "string",
                    "number",
                    "null"
                ])) throw new Zt(`Expected first argument to be of type boolean, string, number or null, but found ${At(qt(e1))} instead.`);
                if (!Mt(r, [
                    "string",
                    "array"
                ])) throw new Zt(`Expected second argument to be of type array or string, but found ${At(qt(r))} instead.`);
                if (this.fromIndex) {
                    const n = this.fromIndex.evaluate(t1);
                    return r.indexOf(e1, n);
                }
                return r.indexOf(e1);
            }
            eachChild(t1) {
                t1(this.needle), t1(this.haystack), this.fromIndex && t1(this.fromIndex);
            }
            outputDefined() {
                return !1;
            }
        }
        class He {
            constructor(t1, e1, r, n, i, a){
                this.inputType = t1, this.type = e1, this.input = r, this.cases = n, this.outputs = i, this.otherwise = a;
            }
            static parse(t1, e1) {
                if (t1.length < 5) return e1.error(`Expected at least 4 arguments, but found only ${t1.length - 1}.`);
                if (t1.length % 2 != 1) return e1.error("Expected an even number of arguments.");
                let r, n;
                e1.expectedType && "value" !== e1.expectedType.kind && (n = e1.expectedType);
                const i = {}, a = [];
                for(let s = 2; s < t1.length - 1; s += 2){
                    let o = t1[s];
                    const l = t1[s + 1];
                    Array.isArray(o) || (o = [
                        o
                    ]);
                    const u = e1.concat(s);
                    if (0 === o.length) return u.error("Expected at least one branch label.");
                    for (const t2 of o){
                        if ("number" != typeof t2 && "string" != typeof t2) return u.error("Branch labels must be numbers or strings.");
                        if ("number" == typeof t2 && Math.abs(t2) > Number.MAX_SAFE_INTEGER) return u.error(`Branch labels must be integers no larger than ${Number.MAX_SAFE_INTEGER}.`);
                        if ("number" == typeof t2 && Math.floor(t2) !== t2) return u.error("Numeric branch labels must be integer values.");
                        if (r) {
                            if (u.checkSubtype(r, qt(t2))) return null;
                        } else r = qt(t2);
                        if (void 0 !== i[String(t2)]) return u.error("Branch labels must be unique.");
                        i[String(t2)] = a.length;
                    }
                    const c = e1.parse(l, s, n);
                    if (!c) return null;
                    n = n || c.type, a.push(c);
                }
                const s1 = e1.parse(t1[1], 1, gt);
                if (!s1) return null;
                const o1 = e1.parse(t1[t1.length - 1], t1.length - 1, n);
                return o1 ? "value" !== s1.type.kind && e1.concat(1).checkSubtype(r, s1.type) ? null : new He(r, n, s1, i, a, o1) : null;
            }
            evaluate(t1) {
                const e1 = this.input.evaluate(t1);
                return (qt(e1) === this.inputType && this.outputs[this.cases[e1]] || this.otherwise).evaluate(t1);
            }
            eachChild(t1) {
                t1(this.input), this.outputs.forEach(t1), t1(this.otherwise);
            }
            outputDefined() {
                return this.outputs.every((t1)=>t1.outputDefined()) && this.otherwise.outputDefined();
            }
        }
        class We {
            constructor(t1, e1, r){
                this.type = t1, this.branches = e1, this.otherwise = r;
            }
            static parse(t1, e1) {
                if (t1.length < 4) return e1.error(`Expected at least 3 arguments, but found only ${t1.length - 1}.`);
                if (t1.length % 2 != 0) return e1.error("Expected an odd number of arguments.");
                let r;
                e1.expectedType && "value" !== e1.expectedType.kind && (r = e1.expectedType);
                const n = [];
                for(let i = 1; i < t1.length - 1; i += 2){
                    const a = e1.parse(t1[i], i, dt);
                    if (!a) return null;
                    const s = e1.parse(t1[i + 1], i + 1, r);
                    if (!s) return null;
                    n.push([
                        a,
                        s
                    ]), r = r || s.type;
                }
                const i1 = e1.parse(t1[t1.length - 1], t1.length - 1, r);
                if (!i1) return null;
                if (!r) throw new Error("Can't infer output type");
                return new We(r, n, i1);
            }
            evaluate(t1) {
                for (const [e1, r] of this.branches)if (e1.evaluate(t1)) return r.evaluate(t1);
                return this.otherwise.evaluate(t1);
            }
            eachChild(t1) {
                for (const [e1, r] of this.branches)t1(e1), t1(r);
                t1(this.otherwise);
            }
            outputDefined() {
                return this.branches.every(([t1, e1])=>e1.outputDefined()) && this.otherwise.outputDefined();
            }
        }
        class Qe {
            constructor(t1, e1, r, n){
                this.type = t1, this.input = e1, this.beginIndex = r, this.endIndex = n;
            }
            static parse(t1, e1) {
                if (t1.length <= 2 || t1.length >= 5) return e1.error(`Expected 3 or 4 arguments, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1, gt), n = e1.parse(t1[2], 2, pt);
                if (!r || !n) return null;
                if (!It(r.type, [
                    _t(gt),
                    ft,
                    gt
                ])) return e1.error(`Expected first argument to be of type array or string, but found ${At(r.type)} instead`);
                if (4 === t1.length) {
                    const i = e1.parse(t1[3], 3, pt);
                    return i ? new Qe(r.type, r, n, i) : null;
                }
                return new Qe(r.type, r, n);
            }
            evaluate(t1) {
                const e1 = this.input.evaluate(t1), r = this.beginIndex.evaluate(t1);
                if (!Mt(e1, [
                    "string",
                    "array"
                ])) throw new Zt(`Expected first argument to be of type array or string, but found ${At(qt(e1))} instead.`);
                if (this.endIndex) {
                    const n = this.endIndex.evaluate(t1);
                    return e1.slice(r, n);
                }
                return e1.slice(r);
            }
            eachChild(t1) {
                t1(this.input), t1(this.beginIndex), this.endIndex && t1(this.endIndex);
            }
            outputDefined() {
                return !1;
            }
        }
        function tr(t1, e1) {
            return "==" === t1 || "!=" === t1 ? "boolean" === e1.kind || "string" === e1.kind || "number" === e1.kind || "null" === e1.kind || "value" === e1.kind : "string" === e1.kind || "number" === e1.kind || "value" === e1.kind;
        }
        function er(t1, e1, r, n) {
            return 0 === n.compare(e1, r);
        }
        function rr(t1, e1, r) {
            const n = "==" !== t1 && "!=" !== t1;
            return class i {
                constructor(t1, e1, r){
                    this.type = dt, this.lhs = t1, this.rhs = e1, this.collator = r, this.hasUntypedArgument = "value" === t1.type.kind || "value" === e1.type.kind;
                }
                static parse(t1, e1) {
                    if (3 !== t1.length && 4 !== t1.length) return e1.error("Expected two or three arguments.");
                    const r = t1[0];
                    let a = e1.parse(t1[1], 1, gt);
                    if (!a) return null;
                    if (!tr(r, a.type)) return e1.concat(1).error(`"${r}" comparisons are not supported for type '${At(a.type)}'.`);
                    let s = e1.parse(t1[2], 2, gt);
                    if (!s) return null;
                    if (!tr(r, s.type)) return e1.concat(2).error(`"${r}" comparisons are not supported for type '${At(s.type)}'.`);
                    if (a.type.kind !== s.type.kind && "value" !== a.type.kind && "value" !== s.type.kind) return e1.error(`Cannot compare types '${At(a.type)}' and '${At(s.type)}'.`);
                    n && ("value" === a.type.kind && "value" !== s.type.kind ? a = new Gt(s.type, [
                        a
                    ]) : "value" !== a.type.kind && "value" === s.type.kind && (s = new Gt(a.type, [
                        s
                    ])));
                    let o = null;
                    if (4 === t1.length) {
                        if ("string" !== a.type.kind && "string" !== s.type.kind && "value" !== a.type.kind && "value" !== s.type.kind) return e1.error("Cannot use collator to compare non-string types.");
                        if (o = e1.parse(t1[3], 3, xt), !o) return null;
                    }
                    return new i(a, s, o);
                }
                evaluate(i) {
                    const a = this.lhs.evaluate(i), s = this.rhs.evaluate(i);
                    if (n && this.hasUntypedArgument) {
                        const e2 = qt(a), r1 = qt(s);
                        if (e2.kind !== r1.kind || "string" !== e2.kind && "number" !== e2.kind) throw new Zt(`Expected arguments for "${t1}" to be (string, string) or (number, number), but found (${e2.kind}, ${r1.kind}) instead.`);
                    }
                    if (this.collator && !n && this.hasUntypedArgument) {
                        const t2 = qt(a), r2 = qt(s);
                        if ("string" !== t2.kind || "string" !== r2.kind) return e1(i, a, s);
                    }
                    return this.collator ? r(i, a, s, this.collator.evaluate(i)) : e1(i, a, s);
                }
                eachChild(t1) {
                    t1(this.lhs), t1(this.rhs), this.collator && t1(this.collator);
                }
                outputDefined() {
                    return !0;
                }
            };
        }
        const nr = rr("==", function(t1, e1, r) {
            return e1 === r;
        }, er), ir = rr("!=", function(t1, e1, r) {
            return e1 !== r;
        }, function(t1, e1, r, n) {
            return !er(0, e1, r, n);
        }), ar = rr("<", function(t1, e1, r) {
            return e1 < r;
        }, function(t1, e1, r, n) {
            return n.compare(e1, r) < 0;
        }), sr = rr(">", function(t1, e1, r) {
            return e1 > r;
        }, function(t1, e1, r, n) {
            return n.compare(e1, r) > 0;
        }), or = rr("<=", function(t1, e1, r) {
            return e1 <= r;
        }, function(t1, e1, r, n) {
            return n.compare(e1, r) <= 0;
        }), lr = rr(">=", function(t1, e1, r) {
            return e1 >= r;
        }, function(t1, e1, r, n) {
            return n.compare(e1, r) >= 0;
        });
        class ur {
            constructor(t1, e1, r, n, i){
                this.type = ft, this.number = t1, this.locale = e1, this.currency = r, this.minFractionDigits = n, this.maxFractionDigits = i;
            }
            static parse(t1, e1) {
                if (3 !== t1.length) return e1.error("Expected two arguments.");
                const r = e1.parse(t1[1], 1, pt);
                if (!r) return null;
                const n = t1[2];
                if ("object" != typeof n || Array.isArray(n)) return e1.error("NumberFormat options argument must be an object.");
                let i = null;
                if (n.locale && (i = e1.parse(n.locale, 1, ft), !i)) return null;
                let a = null;
                if (n.currency && (a = e1.parse(n.currency, 1, ft), !a)) return null;
                let s = null;
                if (n["min-fraction-digits"] && (s = e1.parse(n["min-fraction-digits"], 1, pt), !s)) return null;
                let o = null;
                return n["max-fraction-digits"] && (o = e1.parse(n["max-fraction-digits"], 1, pt), !o) ? null : new ur(r, i, a, s, o);
            }
            evaluate(t1) {
                return new Intl.NumberFormat(this.locale ? this.locale.evaluate(t1) : [], {
                    style: this.currency ? "currency" : "decimal",
                    currency: this.currency ? this.currency.evaluate(t1) : void 0,
                    minimumFractionDigits: this.minFractionDigits ? this.minFractionDigits.evaluate(t1) : void 0,
                    maximumFractionDigits: this.maxFractionDigits ? this.maxFractionDigits.evaluate(t1) : void 0
                }).format(this.number.evaluate(t1));
            }
            eachChild(t1) {
                t1(this.number), this.locale && t1(this.locale), this.currency && t1(this.currency), this.minFractionDigits && t1(this.minFractionDigits), this.maxFractionDigits && t1(this.maxFractionDigits);
            }
            outputDefined() {
                return !1;
            }
        }
        class cr {
            constructor(t1){
                this.type = vt, this.sections = t1;
            }
            static parse(t1, e1) {
                if (t1.length < 2) return e1.error("Expected at least one argument.");
                const r = t1[1];
                if (!Array.isArray(r) && "object" == typeof r) return e1.error("First argument must be an image or text section.");
                const n = [];
                let i = !1;
                for(let r1 = 1; r1 <= t1.length - 1; ++r1){
                    const a = t1[r1];
                    if (i && "object" == typeof a && !Array.isArray(a)) {
                        i = !1;
                        let t2 = null;
                        if (a["font-scale"] && (t2 = e1.parse(a["font-scale"], 1, pt), !t2)) return null;
                        let r2 = null;
                        if (a["text-font"] && (r2 = e1.parse(a["text-font"], 1, _t(ft)), !r2)) return null;
                        let s = null;
                        if (a["text-color"] && (s = e1.parse(a["text-color"], 1, yt), !s)) return null;
                        const o = n[n.length - 1];
                        o.scale = t2, o.font = r2, o.textColor = s;
                    } else {
                        const a1 = e1.parse(t1[r1], 1, gt);
                        if (!a1) return null;
                        const s1 = a1.type.kind;
                        if ("string" !== s1 && "value" !== s1 && "null" !== s1 && "resolvedImage" !== s1) return e1.error("Formatted text type must be 'string', 'value', 'image' or 'null'.");
                        i = !0, n.push({
                            content: a1,
                            scale: null,
                            font: null,
                            textColor: null
                        });
                    }
                }
                return new cr(n);
            }
            evaluate(t1) {
                return new Dt(this.sections.map((e1)=>{
                    const r = e1.content.evaluate(t1);
                    return qt(r) === wt ? new Lt("", r, null, null, null) : new Lt(jt(r), null, e1.scale ? e1.scale.evaluate(t1) : null, e1.font ? e1.font.evaluate(t1).join(",") : null, e1.textColor ? e1.textColor.evaluate(t1) : null);
                }));
            }
            eachChild(t1) {
                for (const e1 of this.sections)t1(e1.content), e1.scale && t1(e1.scale), e1.font && t1(e1.font), e1.textColor && t1(e1.textColor);
            }
            outputDefined() {
                return !1;
            }
        }
        class hr {
            constructor(t1){
                this.type = wt, this.input = t1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error("Expected two arguments.");
                const r = e1.parse(t1[1], 1, ft);
                return r ? new hr(r) : e1.error("No image name provided.");
            }
            evaluate(t1) {
                const e1 = this.input.evaluate(t1), r = Rt.fromString(e1);
                return r && t1.availableImages && (r.available = t1.availableImages.indexOf(e1) > -1), r;
            }
            eachChild(t1) {
                t1(this.input);
            }
            outputDefined() {
                return !1;
            }
        }
        class pr {
            constructor(t1){
                this.type = pt, this.input = t1;
            }
            static parse(t1, e1) {
                if (2 !== t1.length) return e1.error(`Expected 1 argument, but found ${t1.length - 1} instead.`);
                const r = e1.parse(t1[1], 1);
                return r ? "array" !== r.type.kind && "string" !== r.type.kind && "value" !== r.type.kind ? e1.error(`Expected argument of type string or array, but found ${At(r.type)} instead.`) : new pr(r) : null;
            }
            evaluate(t1) {
                const e1 = this.input.evaluate(t1);
                if ("string" == typeof e1) return e1.length;
                if (Array.isArray(e1)) return e1.length;
                throw new Zt(`Expected value to be of type string or array, but found ${At(qt(e1))} instead.`);
            }
            eachChild(t1) {
                t1(this.input);
            }
            outputDefined() {
                return !1;
            }
        }
        const fr = {
            "==": nr,
            "!=": ir,
            ">": sr,
            "<": ar,
            ">=": lr,
            "<=": or,
            array: Gt,
            at: Je,
            boolean: Gt,
            case: We,
            coalesce: Ke,
            collator: Qt,
            format: cr,
            image: hr,
            in: Xe,
            "index-of": Ye,
            interpolate: Ne,
            "interpolate-hcl": Ne,
            "interpolate-lab": Ne,
            length: pr,
            let: Ge,
            literal: Nt,
            match: He,
            number: Gt,
            "number-format": ur,
            object: Gt,
            slice: Qe,
            step: ke,
            string: Gt,
            "to-boolean": Xt,
            "to-color": Xt,
            "to-number": Xt,
            "to-string": Xt,
            var: be,
            within: me
        };
        function dr(t1, [e1, r, n, i]) {
            e1 = e1.evaluate(t1), r = r.evaluate(t1), n = n.evaluate(t1);
            const a = i ? i.evaluate(t1) : 1, s = Ot(e1, r, n, a);
            if (s) throw new Zt(s);
            return new Ft(e1 / 255 * a, r / 255 * a, n / 255 * a, a);
        }
        function yr(t1, e1) {
            return t1 in e1;
        }
        function mr(t1, e1) {
            const r = e1[t1];
            return void 0 === r ? null : r;
        }
        function gr(t1) {
            return {
                type: t1
            };
        }
        function xr(t1) {
            return {
                result: "success",
                value: t1
            };
        }
        function vr(t1) {
            return {
                result: "error",
                value: t1
            };
        }
        function br(t1) {
            return "data-driven" === t1["property-type"] || "cross-faded-data-driven" === t1["property-type"];
        }
        function wr(t1) {
            return !!t1.expression && t1.expression.parameters.indexOf("zoom") > -1;
        }
        function _r(t1) {
            return !!t1.expression && t1.expression.interpolated;
        }
        function Ar(t1) {
            return t1 instanceof Number ? "number" : t1 instanceof String ? "string" : t1 instanceof Boolean ? "boolean" : Array.isArray(t1) ? "array" : null === t1 ? "null" : typeof t1;
        }
        function kr(t1) {
            return "object" == typeof t1 && null !== t1 && !Array.isArray(t1);
        }
        function Sr(t1) {
            return t1;
        }
        function Ir(t1, e1) {
            const r = "color" === e1.type, n = t1.stops && "object" == typeof t1.stops[0][0], i = n || !(n || void 0 !== t1.property), a = t1.type || (_r(e1) ? "exponential" : "interval");
            if (r || "padding" === e1.type) {
                const n1 = r ? Ft.parse : $t.parse;
                (t1 = st({}, t1)).stops && (t1.stops = t1.stops.map((t1)=>[
                        t1[0],
                        n1(t1[1])
                    ])), t1.default = n1(t1.default ? t1.default : e1.default);
            }
            if (t1.colorSpace && "rgb" !== t1.colorSpace && !je[t1.colorSpace]) throw new Error(`Unknown color space: ${t1.colorSpace}`);
            let s, o, l;
            if ("exponential" === a) s = Cr;
            else if ("interval" === a) s = Br;
            else if ("categorical" === a) {
                s = zr, o = Object.create(null);
                for (const e2 of t1.stops)o[e2[0]] = e2[1];
                l = typeof t1.stops[0][0];
            } else {
                if ("identity" !== a) throw new Error(`Unknown function type "${a}"`);
                s = Pr;
            }
            if (n) {
                const r1 = {}, n2 = [];
                for(let e3 = 0; e3 < t1.stops.length; e3++){
                    const i1 = t1.stops[e3], a1 = i1[0].zoom;
                    void 0 === r1[a1] && (r1[a1] = {
                        zoom: a1,
                        type: t1.type,
                        property: t1.property,
                        default: t1.default,
                        stops: []
                    }, n2.push(a1)), r1[a1].stops.push([
                        i1[0].value,
                        i1[1]
                    ]);
                }
                const i2 = [];
                for (const t2 of n2)i2.push([
                    r1[t2].zoom,
                    Ir(r1[t2], e1)
                ]);
                const a2 = {
                    name: "linear"
                };
                return {
                    kind: "composite",
                    interpolationType: a2,
                    interpolationFactor: Ne.interpolationFactor.bind(void 0, a2),
                    zoomStops: i2.map((t1)=>t1[0]),
                    evaluate: ({ zoom: r  }, n)=>Cr({
                            stops: i2,
                            base: t1.base
                        }, e1, r).evaluate(r, n)
                };
            }
            if (i) {
                const r2 = "exponential" === a ? {
                    name: "exponential",
                    base: void 0 !== t1.base ? t1.base : 1
                } : null;
                return {
                    kind: "camera",
                    interpolationType: r2,
                    interpolationFactor: Ne.interpolationFactor.bind(void 0, r2),
                    zoomStops: t1.stops.map((t1)=>t1[0]),
                    evaluate: ({ zoom: r  })=>s(t1, e1, r, o, l)
                };
            }
            return {
                kind: "source",
                evaluate (r, n) {
                    const i = n && n.properties ? n.properties[t1.property] : void 0;
                    return void 0 === i ? Mr(t1.default, e1.default) : s(t1, e1, i, o, l);
                }
            };
        }
        function Mr(t1, e1, r) {
            return void 0 !== t1 ? t1 : void 0 !== e1 ? e1 : void 0 !== r ? r : void 0;
        }
        function zr(t1, e1, r, n, i) {
            return Mr(typeof r === i ? n[r] : void 0, t1.default, e1.default);
        }
        function Br(t1, e1, r) {
            if ("number" !== Ar(r)) return Mr(t1.default, e1.default);
            const n = t1.stops.length;
            if (1 === n) return t1.stops[0][1];
            if (r <= t1.stops[0][0]) return t1.stops[0][1];
            if (r >= t1.stops[n - 1][0]) return t1.stops[n - 1][1];
            const i = Ae(t1.stops.map((t1)=>t1[0]), r);
            return t1.stops[i][1];
        }
        function Cr(t1, e1, r) {
            const n = void 0 !== t1.base ? t1.base : 1;
            if ("number" !== Ar(r)) return Mr(t1.default, e1.default);
            const i = t1.stops.length;
            if (1 === i) return t1.stops[0][1];
            if (r <= t1.stops[0][0]) return t1.stops[0][1];
            if (r >= t1.stops[i - 1][0]) return t1.stops[i - 1][1];
            const a = Ae(t1.stops.map((t1)=>t1[0]), r), s = function(t1, e1, r, n) {
                const i = n - r, a = t1 - r;
                return 0 === i ? 0 : 1 === e1 ? a / i : (Math.pow(e1, a) - 1) / (Math.pow(e1, i) - 1);
            }(r, n, t1.stops[a][0], t1.stops[a + 1][0]), o = t1.stops[a][1], l = t1.stops[a + 1][1];
            let u = Ie[e1.type] || Sr;
            if (t1.colorSpace && "rgb" !== t1.colorSpace) {
                const e2 = je[t1.colorSpace];
                u = (t1, r)=>e2.reverse(e2.interpolate(e2.forward(t1), e2.forward(r), s));
            }
            return "function" == typeof o.evaluate ? {
                evaluate (...t1) {
                    const e1 = o.evaluate.apply(void 0, t1), r = l.evaluate.apply(void 0, t1);
                    if (void 0 !== e1 && void 0 !== r) return u(e1, r, s);
                }
            } : u(o, l, s);
        }
        function Pr(t1, e1, r) {
            switch(e1.type){
                case "color":
                    r = Ft.parse(r);
                    break;
                case "formatted":
                    r = Dt.fromString(r.toString());
                    break;
                case "resolvedImage":
                    r = Rt.fromString(r.toString());
                    break;
                case "padding":
                    r = $t.parse(r);
                    break;
                default:
                    Ar(r) === e1.type || "enum" === e1.type && e1.values[r] || (r = void 0);
            }
            return Mr(r, t1.default, e1.default);
        }
        Wt.register(fr, {
            error: [
                {
                    kind: "error"
                },
                [
                    ft
                ],
                (t1, [e1])=>{
                    throw new Zt(e1.evaluate(t1));
                }
            ],
            typeof: [
                ft,
                [
                    gt
                ],
                (t1, [e1])=>At(qt(e1.evaluate(t1)))
            ],
            "to-rgba": [
                _t(pt, 4),
                [
                    yt
                ],
                (t1, [e1])=>e1.evaluate(t1).toArray()
            ],
            rgb: [
                yt,
                [
                    pt,
                    pt,
                    pt
                ],
                dr
            ],
            rgba: [
                yt,
                [
                    pt,
                    pt,
                    pt,
                    pt
                ],
                dr
            ],
            has: {
                type: dt,
                overloads: [
                    [
                        [
                            ft
                        ],
                        (t1, [e1])=>yr(e1.evaluate(t1), t1.properties())
                    ],
                    [
                        [
                            ft,
                            mt
                        ],
                        (t1, [e1, r])=>yr(e1.evaluate(t1), r.evaluate(t1))
                    ]
                ]
            },
            get: {
                type: gt,
                overloads: [
                    [
                        [
                            ft
                        ],
                        (t1, [e1])=>mr(e1.evaluate(t1), t1.properties())
                    ],
                    [
                        [
                            ft,
                            mt
                        ],
                        (t1, [e1, r])=>mr(e1.evaluate(t1), r.evaluate(t1))
                    ]
                ]
            },
            "feature-state": [
                gt,
                [
                    ft
                ],
                (t1, [e1])=>mr(e1.evaluate(t1), t1.featureState || {})
            ],
            properties: [
                mt,
                [],
                (t1)=>t1.properties()
            ],
            "geometry-type": [
                ft,
                [],
                (t1)=>t1.geometryType()
            ],
            id: [
                gt,
                [],
                (t1)=>t1.id()
            ],
            zoom: [
                pt,
                [],
                (t1)=>t1.globals.zoom
            ],
            "heatmap-density": [
                pt,
                [],
                (t1)=>t1.globals.heatmapDensity || 0
            ],
            "line-progress": [
                pt,
                [],
                (t1)=>t1.globals.lineProgress || 0
            ],
            accumulated: [
                gt,
                [],
                (t1)=>void 0 === t1.globals.accumulated ? null : t1.globals.accumulated
            ],
            "+": [
                pt,
                gr(pt),
                (t1, e1)=>{
                    let r = 0;
                    for (const n of e1)r += n.evaluate(t1);
                    return r;
                }
            ],
            "*": [
                pt,
                gr(pt),
                (t1, e1)=>{
                    let r = 1;
                    for (const n of e1)r *= n.evaluate(t1);
                    return r;
                }
            ],
            "-": {
                type: pt,
                overloads: [
                    [
                        [
                            pt,
                            pt
                        ],
                        (t1, [e1, r])=>e1.evaluate(t1) - r.evaluate(t1)
                    ],
                    [
                        [
                            pt
                        ],
                        (t1, [e1])=>-e1.evaluate(t1)
                    ]
                ]
            },
            "/": [
                pt,
                [
                    pt,
                    pt
                ],
                (t1, [e1, r])=>e1.evaluate(t1) / r.evaluate(t1)
            ],
            "%": [
                pt,
                [
                    pt,
                    pt
                ],
                (t1, [e1, r])=>e1.evaluate(t1) % r.evaluate(t1)
            ],
            ln2: [
                pt,
                [],
                ()=>Math.LN2
            ],
            pi: [
                pt,
                [],
                ()=>Math.PI
            ],
            e: [
                pt,
                [],
                ()=>Math.E
            ],
            "^": [
                pt,
                [
                    pt,
                    pt
                ],
                (t1, [e1, r])=>Math.pow(e1.evaluate(t1), r.evaluate(t1))
            ],
            sqrt: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.sqrt(e1.evaluate(t1))
            ],
            log10: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.log(e1.evaluate(t1)) / Math.LN10
            ],
            ln: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.log(e1.evaluate(t1))
            ],
            log2: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.log(e1.evaluate(t1)) / Math.LN2
            ],
            sin: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.sin(e1.evaluate(t1))
            ],
            cos: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.cos(e1.evaluate(t1))
            ],
            tan: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.tan(e1.evaluate(t1))
            ],
            asin: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.asin(e1.evaluate(t1))
            ],
            acos: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.acos(e1.evaluate(t1))
            ],
            atan: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.atan(e1.evaluate(t1))
            ],
            min: [
                pt,
                gr(pt),
                (t1, e1)=>Math.min(...e1.map((e1)=>e1.evaluate(t1)))
            ],
            max: [
                pt,
                gr(pt),
                (t1, e1)=>Math.max(...e1.map((e1)=>e1.evaluate(t1)))
            ],
            abs: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.abs(e1.evaluate(t1))
            ],
            round: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>{
                    const r = e1.evaluate(t1);
                    return r < 0 ? -Math.round(-r) : Math.round(r);
                }
            ],
            floor: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.floor(e1.evaluate(t1))
            ],
            ceil: [
                pt,
                [
                    pt
                ],
                (t1, [e1])=>Math.ceil(e1.evaluate(t1))
            ],
            "filter-==": [
                dt,
                [
                    ft,
                    gt
                ],
                (t1, [e1, r])=>t1.properties()[e1.value] === r.value
            ],
            "filter-id-==": [
                dt,
                [
                    gt
                ],
                (t1, [e1])=>t1.id() === e1.value
            ],
            "filter-type-==": [
                dt,
                [
                    ft
                ],
                (t1, [e1])=>t1.geometryType() === e1.value
            ],
            "filter-<": [
                dt,
                [
                    ft,
                    gt
                ],
                (t1, [e1, r])=>{
                    const n = t1.properties()[e1.value], i = r.value;
                    return typeof n == typeof i && n < i;
                }
            ],
            "filter-id-<": [
                dt,
                [
                    gt
                ],
                (t1, [e1])=>{
                    const r = t1.id(), n = e1.value;
                    return typeof r == typeof n && r < n;
                }
            ],
            "filter->": [
                dt,
                [
                    ft,
                    gt
                ],
                (t1, [e1, r])=>{
                    const n = t1.properties()[e1.value], i = r.value;
                    return typeof n == typeof i && n > i;
                }
            ],
            "filter-id->": [
                dt,
                [
                    gt
                ],
                (t1, [e1])=>{
                    const r = t1.id(), n = e1.value;
                    return typeof r == typeof n && r > n;
                }
            ],
            "filter-<=": [
                dt,
                [
                    ft,
                    gt
                ],
                (t1, [e1, r])=>{
                    const n = t1.properties()[e1.value], i = r.value;
                    return typeof n == typeof i && n <= i;
                }
            ],
            "filter-id-<=": [
                dt,
                [
                    gt
                ],
                (t1, [e1])=>{
                    const r = t1.id(), n = e1.value;
                    return typeof r == typeof n && r <= n;
                }
            ],
            "filter->=": [
                dt,
                [
                    ft,
                    gt
                ],
                (t1, [e1, r])=>{
                    const n = t1.properties()[e1.value], i = r.value;
                    return typeof n == typeof i && n >= i;
                }
            ],
            "filter-id->=": [
                dt,
                [
                    gt
                ],
                (t1, [e1])=>{
                    const r = t1.id(), n = e1.value;
                    return typeof r == typeof n && r >= n;
                }
            ],
            "filter-has": [
                dt,
                [
                    gt
                ],
                (t1, [e1])=>e1.value in t1.properties()
            ],
            "filter-has-id": [
                dt,
                [],
                (t1)=>null !== t1.id() && void 0 !== t1.id()
            ],
            "filter-type-in": [
                dt,
                [
                    _t(ft)
                ],
                (t1, [e1])=>e1.value.indexOf(t1.geometryType()) >= 0
            ],
            "filter-id-in": [
                dt,
                [
                    _t(gt)
                ],
                (t1, [e1])=>e1.value.indexOf(t1.id()) >= 0
            ],
            "filter-in-small": [
                dt,
                [
                    ft,
                    _t(gt)
                ],
                (t1, [e1, r])=>r.value.indexOf(t1.properties()[e1.value]) >= 0
            ],
            "filter-in-large": [
                dt,
                [
                    ft,
                    _t(gt)
                ],
                (t1, [e1, r])=>(function(t1, e1, r, n) {
                        for(; r <= n;){
                            const i = r + n >> 1;
                            if (e1[i] === t1) return !0;
                            e1[i] > t1 ? n = i - 1 : r = i + 1;
                        }
                        return !1;
                    })(t1.properties()[e1.value], r.value, 0, r.value.length - 1)
            ],
            all: {
                type: dt,
                overloads: [
                    [
                        [
                            dt,
                            dt
                        ],
                        (t1, [e1, r])=>e1.evaluate(t1) && r.evaluate(t1)
                    ],
                    [
                        gr(dt),
                        (t1, e1)=>{
                            for (const r of e1)if (!r.evaluate(t1)) return !1;
                            return !0;
                        }
                    ]
                ]
            },
            any: {
                type: dt,
                overloads: [
                    [
                        [
                            dt,
                            dt
                        ],
                        (t1, [e1, r])=>e1.evaluate(t1) || r.evaluate(t1)
                    ],
                    [
                        gr(dt),
                        (t1, e1)=>{
                            for (const r of e1)if (r.evaluate(t1)) return !0;
                            return !1;
                        }
                    ]
                ]
            },
            "!": [
                dt,
                [
                    dt
                ],
                (t1, [e1])=>!e1.evaluate(t1)
            ],
            "is-supported-script": [
                dt,
                [
                    ft
                ],
                (t1, [e1])=>{
                    const r = t1.globals && t1.globals.isSupportedScript;
                    return !r || r(e1.evaluate(t1));
                }
            ],
            upcase: [
                ft,
                [
                    ft
                ],
                (t1, [e1])=>e1.evaluate(t1).toUpperCase()
            ],
            downcase: [
                ft,
                [
                    ft
                ],
                (t1, [e1])=>e1.evaluate(t1).toLowerCase()
            ],
            concat: [
                ft,
                gr(gt),
                (t1, e1)=>e1.map((e1)=>jt(e1.evaluate(t1))).join("")
            ],
            "resolved-locale": [
                ft,
                [
                    xt
                ],
                (t1, [e1])=>e1.evaluate(t1).resolvedLocale()
            ]
        });
        class Vr {
            constructor(t1, e1){
                this.expression = t1, this._warningHistory = {}, this._evaluator = new Ht, this._defaultValue = e1 ? function(t1) {
                    return "color" === t1.type && kr(t1.default) ? new Ft(0, 0, 0, 0) : "color" === t1.type ? Ft.parse(t1.default) || null : "padding" === t1.type ? $t.parse(t1.default) || null : void 0 === t1.default ? null : t1.default;
                }(e1) : null, this._enumValues = e1 && "enum" === e1.type ? e1.values : null;
            }
            evaluateWithoutErrorHandling(t1, e1, r, n, i, a) {
                return this._evaluator.globals = t1, this._evaluator.feature = e1, this._evaluator.featureState = r, this._evaluator.canonical = n, this._evaluator.availableImages = i || null, this._evaluator.formattedSection = a, this.expression.evaluate(this._evaluator);
            }
            evaluate(t1, e1, r, n, i, a) {
                this._evaluator.globals = t1, this._evaluator.feature = e1 || null, this._evaluator.featureState = r || null, this._evaluator.canonical = n, this._evaluator.availableImages = i || null, this._evaluator.formattedSection = a || null;
                try {
                    const t2 = this.expression.evaluate(this._evaluator);
                    if (null == t2 || "number" == typeof t2 && t2 != t2) return this._defaultValue;
                    if (this._enumValues && !(t2 in this._enumValues)) throw new Zt(`Expected value to be one of ${Object.keys(this._enumValues).map((t1)=>JSON.stringify(t1)).join(", ")}, but found ${JSON.stringify(t2)} instead.`);
                    return t2;
                } catch (t3) {
                    return this._warningHistory[t3.message] || (this._warningHistory[t3.message] = !0, "undefined" != typeof console && console.warn(t3.message)), this._defaultValue;
                }
            }
        }
        function Er(t1) {
            return Array.isArray(t1) && t1.length > 0 && "string" == typeof t1[0] && t1[0] in fr;
        }
        function Fr(t1, e1) {
            const r = new we(fr, [], e1 ? function(t1) {
                const e1 = {
                    color: yt,
                    string: ft,
                    number: pt,
                    enum: ft,
                    boolean: dt,
                    formatted: vt,
                    padding: bt,
                    resolvedImage: wt
                };
                return "array" === t1.type ? _t(e1[t1.value] || gt, t1.length) : e1[t1.type];
            }(e1) : void 0), n = r.parse(t1, void 0, void 0, void 0, e1 && "string" === e1.type ? {
                typeAnnotation: "coerce"
            } : void 0);
            return n ? xr(new Vr(n, e1)) : vr(r.errors);
        }
        class Tr {
            constructor(t1, e1){
                this.kind = t1, this._styleExpression = e1, this.isStateDependent = "constant" !== t1 && !xe(e1.expression);
            }
            evaluateWithoutErrorHandling(t1, e1, r, n, i, a) {
                return this._styleExpression.evaluateWithoutErrorHandling(t1, e1, r, n, i, a);
            }
            evaluate(t1, e1, r, n, i, a) {
                return this._styleExpression.evaluate(t1, e1, r, n, i, a);
            }
        }
        class Lr {
            constructor(t1, e1, r, n){
                this.kind = t1, this.zoomStops = r, this._styleExpression = e1, this.isStateDependent = "camera" !== t1 && !xe(e1.expression), this.interpolationType = n;
            }
            evaluateWithoutErrorHandling(t1, e1, r, n, i, a) {
                return this._styleExpression.evaluateWithoutErrorHandling(t1, e1, r, n, i, a);
            }
            evaluate(t1, e1, r, n, i, a) {
                return this._styleExpression.evaluate(t1, e1, r, n, i, a);
            }
            interpolationFactor(t1, e1, r) {
                return this.interpolationType ? Ne.interpolationFactor(this.interpolationType, t1, e1, r) : 0;
            }
        }
        function Dr(t1, e1) {
            const r = Fr(t1, e1);
            if ("error" === r.result) return r;
            const n = r.value.expression, i = ge(n);
            if (!i && !br(e1)) return vr([
                new ut("", "data expressions not supported")
            ]);
            const a = ve(n, [
                "zoom"
            ]);
            if (!a && !wr(e1)) return vr([
                new ut("", "zoom expressions not supported")
            ]);
            const s = Rr(n);
            return s || a ? s instanceof ut ? vr([
                s
            ]) : s instanceof Ne && !_r(e1) ? vr([
                new ut("", '"interpolate" expressions cannot be used with this property')
            ]) : xr(s ? new Lr(i ? "camera" : "composite", r.value, s.labels, s instanceof Ne ? s.interpolation : void 0) : new Tr(i ? "constant" : "source", r.value)) : vr([
                new ut("", '"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.')
            ]);
        }
        class $r {
            constructor(t1, e1){
                this._parameters = t1, this._specification = e1, st(this, Ir(this._parameters, this._specification));
            }
            static deserialize(t1) {
                return new $r(t1._parameters, t1._specification);
            }
            static serialize(t1) {
                return {
                    _parameters: t1._parameters,
                    _specification: t1._specification
                };
            }
        }
        function Rr(t1) {
            let e1 = null;
            if (t1 instanceof Ge) e1 = Rr(t1.result);
            else if (t1 instanceof Ke) {
                for (const r of t1.args)if (e1 = Rr(r), e1) break;
            } else (t1 instanceof ke || t1 instanceof Ne) && t1.input instanceof Wt && "zoom" === t1.input.name && (e1 = t1);
            return e1 instanceof ut || t1.eachChild((t1)=>{
                const r = Rr(t1);
                r instanceof ut ? e1 = r : !e1 && r ? e1 = new ut("", '"zoom" expression may only be used as input to a top-level "step" or "interpolate" expression.') : e1 && r && e1 !== r && (e1 = new ut("", 'Only one zoom-based "step" or "interpolate" subexpression may be used in an expression.'));
            }), e1;
        }
        function Or(t1) {
            const e1 = t1.key, r = t1.value, n = t1.valueSpec || {}, i = t1.objectElementValidators || {}, a = t1.style, s = t1.styleSpec;
            let o = [];
            const l = Ar(r);
            if ("object" !== l) return [
                new it(e1, r, `object expected, ${l} found`)
            ];
            for(const t2 in r){
                const l1 = t2.split(".")[0], u = n[l1] || n["*"];
                let c;
                if (i[l1]) c = i[l1];
                else if (n[l1]) c = yn;
                else if (i["*"]) c = i["*"];
                else {
                    if (!n["*"]) {
                        o.push(new it(e1, r[t2], `unknown property "${t2}"`));
                        continue;
                    }
                    c = yn;
                }
                o = o.concat(c({
                    key: (e1 ? `${e1}.` : e1) + t2,
                    value: r[t2],
                    valueSpec: u,
                    style: a,
                    styleSpec: s,
                    object: r,
                    objectKey: t2
                }, r));
            }
            for(const t3 in n)i[t3] || n[t3].required && void 0 === n[t3].default && void 0 === r[t3] && o.push(new it(e1, r, `missing required property "${t3}"`));
            return o;
        }
        function Ur(t1) {
            const e1 = t1.value, r = t1.valueSpec, n = t1.style, i = t1.styleSpec, a = t1.key, s = t1.arrayElementValidator || yn;
            if ("array" !== Ar(e1)) return [
                new it(a, e1, `array expected, ${Ar(e1)} found`)
            ];
            if (r.length && e1.length !== r.length) return [
                new it(a, e1, `array length ${r.length} expected, length ${e1.length} found`)
            ];
            if (r["min-length"] && e1.length < r["min-length"]) return [
                new it(a, e1, `array length at least ${r["min-length"]} expected, length ${e1.length} found`)
            ];
            let o = {
                type: r.value,
                values: r.values
            };
            i.$version < 7 && (o.function = r.function), "object" === Ar(r.value) && (o = r.value);
            let l = [];
            for(let t2 = 0; t2 < e1.length; t2++)l = l.concat(s({
                array: e1,
                arrayIndex: t2,
                value: e1[t2],
                valueSpec: o,
                style: n,
                styleSpec: i,
                key: `${a}[${t2}]`
            }));
            return l;
        }
        function qr(t1) {
            const e1 = t1.key, r = t1.value, n = t1.valueSpec;
            let i = Ar(r);
            return "number" === i && r != r && (i = "NaN"), "number" !== i ? [
                new it(e1, r, `number expected, ${i} found`)
            ] : "minimum" in n && r < n.minimum ? [
                new it(e1, r, `${r} is less than the minimum value ${n.minimum}`)
            ] : "maximum" in n && r > n.maximum ? [
                new it(e1, r, `${r} is greater than the maximum value ${n.maximum}`)
            ] : [];
        }
        function jr(t1) {
            const e1 = t1.valueSpec, r = ot(t1.value.type);
            let n, i, a, s = {};
            const o = "categorical" !== r && void 0 === t1.value.property, l = !o, u = "array" === Ar(t1.value.stops) && "array" === Ar(t1.value.stops[0]) && "object" === Ar(t1.value.stops[0][0]), c = Or({
                key: t1.key,
                value: t1.value,
                valueSpec: t1.styleSpec.function,
                style: t1.style,
                styleSpec: t1.styleSpec,
                objectElementValidators: {
                    stops: function(t1) {
                        if ("identity" === r) return [
                            new it(t1.key, t1.value, 'identity function may not have a "stops" property')
                        ];
                        let e1 = [];
                        const n = t1.value;
                        return e1 = e1.concat(Ur({
                            key: t1.key,
                            value: n,
                            valueSpec: t1.valueSpec,
                            style: t1.style,
                            styleSpec: t1.styleSpec,
                            arrayElementValidator: h
                        })), "array" === Ar(n) && 0 === n.length && e1.push(new it(t1.key, n, "array must have at least one stop")), e1;
                    },
                    default: function(t1) {
                        return yn({
                            key: t1.key,
                            value: t1.value,
                            valueSpec: e1,
                            style: t1.style,
                            styleSpec: t1.styleSpec
                        });
                    }
                }
            });
            return "identity" === r && o && c.push(new it(t1.key, t1.value, 'missing required property "property"')), "identity" === r || t1.value.stops || c.push(new it(t1.key, t1.value, 'missing required property "stops"')), "exponential" === r && t1.valueSpec.expression && !_r(t1.valueSpec) && c.push(new it(t1.key, t1.value, "exponential functions not supported")), t1.styleSpec.$version >= 8 && (l && !br(t1.valueSpec) ? c.push(new it(t1.key, t1.value, "property functions not supported")) : o && !wr(t1.valueSpec) && c.push(new it(t1.key, t1.value, "zoom functions not supported"))), "categorical" !== r && !u || void 0 !== t1.value.property || c.push(new it(t1.key, t1.value, '"property" property is required')), c;
            function h(t1) {
                let r = [];
                const n = t1.value, o = t1.key;
                if ("array" !== Ar(n)) return [
                    new it(o, n, `array expected, ${Ar(n)} found`)
                ];
                if (2 !== n.length) return [
                    new it(o, n, `array length 2 expected, length ${n.length} found`)
                ];
                if (u) {
                    if ("object" !== Ar(n[0])) return [
                        new it(o, n, `object expected, ${Ar(n[0])} found`)
                    ];
                    if (void 0 === n[0].zoom) return [
                        new it(o, n, "object stop key must have zoom")
                    ];
                    if (void 0 === n[0].value) return [
                        new it(o, n, "object stop key must have value")
                    ];
                    if (a && a > ot(n[0].zoom)) return [
                        new it(o, n[0].zoom, "stop zoom values must appear in ascending order")
                    ];
                    ot(n[0].zoom) !== a && (a = ot(n[0].zoom), i = void 0, s = {}), r = r.concat(Or({
                        key: `${o}[0]`,
                        value: n[0],
                        valueSpec: {
                            zoom: {}
                        },
                        style: t1.style,
                        styleSpec: t1.styleSpec,
                        objectElementValidators: {
                            zoom: qr,
                            value: p
                        }
                    }));
                } else r = r.concat(p({
                    key: `${o}[0]`,
                    value: n[0],
                    valueSpec: {},
                    style: t1.style,
                    styleSpec: t1.styleSpec
                }, n));
                return Er(lt(n[1])) ? r.concat([
                    new it(`${o}[1]`, n[1], "expressions are not allowed in function stops.")
                ]) : r.concat(yn({
                    key: `${o}[1]`,
                    value: n[1],
                    valueSpec: e1,
                    style: t1.style,
                    styleSpec: t1.styleSpec
                }));
            }
            function p(t1, a) {
                const o = Ar(t1.value), l = ot(t1.value), u = null !== t1.value ? t1.value : a;
                if (n) {
                    if (o !== n) return [
                        new it(t1.key, u, `${o} stop domain type must match previous stop domain type ${n}`)
                    ];
                } else n = o;
                if ("number" !== o && "string" !== o && "boolean" !== o) return [
                    new it(t1.key, u, "stop domain value must be a number, string, or boolean")
                ];
                if ("number" !== o && "categorical" !== r) {
                    let n1 = `number expected, ${o} found`;
                    return br(e1) && void 0 === r && (n1 += '\nIf you intended to use a categorical function, specify `"type": "categorical"`.'), [
                        new it(t1.key, u, n1)
                    ];
                }
                return "categorical" !== r || "number" !== o || isFinite(l) && Math.floor(l) === l ? "categorical" !== r && "number" === o && void 0 !== i && l < i ? [
                    new it(t1.key, u, "stop domain values must appear in ascending order")
                ] : (i = l, "categorical" === r && l in s ? [
                    new it(t1.key, u, "stop domain values must be unique")
                ] : (s[l] = !0, [])) : [
                    new it(t1.key, u, `integer expected, found ${l}`)
                ];
            }
        }
        function Nr(t1) {
            const e1 = ("property" === t1.expressionContext ? Dr : Fr)(lt(t1.value), t1.valueSpec);
            if ("error" === e1.result) return e1.value.map((e1)=>new it(`${t1.key}${e1.key}`, t1.value, e1.message));
            const r = e1.value.expression || e1.value._styleExpression.expression;
            if ("property" === t1.expressionContext && "text-font" === t1.propertyKey && !r.outputDefined()) return [
                new it(t1.key, t1.value, `Invalid data expression for "${t1.propertyKey}". Output values must be contained as literals within the expression.`)
            ];
            if ("property" === t1.expressionContext && "layout" === t1.propertyType && !xe(r)) return [
                new it(t1.key, t1.value, '"feature-state" data expressions are not supported with layout properties.')
            ];
            if ("filter" === t1.expressionContext && !xe(r)) return [
                new it(t1.key, t1.value, '"feature-state" data expressions are not supported with filters.')
            ];
            if (t1.expressionContext && 0 === t1.expressionContext.indexOf("cluster")) {
                if (!ve(r, [
                    "zoom",
                    "feature-state"
                ])) return [
                    new it(t1.key, t1.value, '"zoom" and "feature-state" expressions are not supported with cluster properties.')
                ];
                if ("cluster-initial" === t1.expressionContext && !ge(r)) return [
                    new it(t1.key, t1.value, "Feature data expressions are not supported with initial expression part of cluster properties.")
                ];
            }
            return [];
        }
        function Zr(t1) {
            const e1 = t1.key, r = t1.value, n = t1.valueSpec, i = [];
            return Array.isArray(n.values) ? -1 === n.values.indexOf(ot(r)) && i.push(new it(e1, r, `expected one of [${n.values.join(", ")}], ${JSON.stringify(r)} found`)) : -1 === Object.keys(n.values).indexOf(ot(r)) && i.push(new it(e1, r, `expected one of [${Object.keys(n.values).join(", ")}], ${JSON.stringify(r)} found`)), i;
        }
        function Kr(t1) {
            if (!0 === t1 || !1 === t1) return !0;
            if (!Array.isArray(t1) || 0 === t1.length) return !1;
            switch(t1[0]){
                case "has":
                    return t1.length >= 2 && "$id" !== t1[1] && "$type" !== t1[1];
                case "in":
                    return t1.length >= 3 && ("string" != typeof t1[1] || Array.isArray(t1[2]));
                case "!in":
                case "!has":
                case "none":
                    return !1;
                case "==":
                case "!=":
                case ">":
                case ">=":
                case "<":
                case "<=":
                    return 3 !== t1.length || Array.isArray(t1[1]) || Array.isArray(t1[2]);
                case "any":
                case "all":
                    for (const e1 of t1.slice(1))if (!Kr(e1) && "boolean" != typeof e1) return !1;
                    return !0;
                default:
                    return !0;
            }
        }
        const Gr = {
            type: "boolean",
            default: !1,
            transition: !1,
            "property-type": "data-driven",
            expression: {
                interpolated: !1,
                parameters: [
                    "zoom",
                    "feature"
                ]
            }
        };
        function Jr(t1) {
            if (null == t1) return {
                filter: ()=>!0,
                needGeometry: !1
            };
            Kr(t1) || (t1 = Hr(t1));
            const e1 = Fr(t1, Gr);
            if ("error" === e1.result) throw new Error(e1.value.map((t1)=>`${t1.key}: ${t1.message}`).join(", "));
            return {
                filter: (t1, r, n)=>e1.value.evaluate(t1, r, {}, n),
                needGeometry: Yr(t1)
            };
        }
        function Xr(t1, e1) {
            return t1 < e1 ? -1 : t1 > e1 ? 1 : 0;
        }
        function Yr(t1) {
            if (!Array.isArray(t1)) return !1;
            if ("within" === t1[0]) return !0;
            for(let e1 = 1; e1 < t1.length; e1++)if (Yr(t1[e1])) return !0;
            return !1;
        }
        function Hr(t1) {
            if (!t1) return !0;
            const e1 = t1[0];
            var r;
            return t1.length <= 1 ? "any" !== e1 : "==" === e1 ? Wr(t1[1], t1[2], "==") : "!=" === e1 ? en(Wr(t1[1], t1[2], "==")) : "<" === e1 || ">" === e1 || "<=" === e1 || ">=" === e1 ? Wr(t1[1], t1[2], e1) : "any" === e1 ? (r = t1.slice(1), [
                "any"
            ].concat(r.map(Hr))) : "all" === e1 ? [
                "all"
            ].concat(t1.slice(1).map(Hr)) : "none" === e1 ? [
                "all"
            ].concat(t1.slice(1).map(Hr).map(en)) : "in" === e1 ? Qr(t1[1], t1.slice(2)) : "!in" === e1 ? en(Qr(t1[1], t1.slice(2))) : "has" === e1 ? tn(t1[1]) : "!has" === e1 ? en(tn(t1[1])) : "within" !== e1 || t1;
        }
        function Wr(t1, e1, r) {
            switch(t1){
                case "$type":
                    return [
                        `filter-type-${r}`,
                        e1
                    ];
                case "$id":
                    return [
                        `filter-id-${r}`,
                        e1
                    ];
                default:
                    return [
                        `filter-${r}`,
                        t1,
                        e1
                    ];
            }
        }
        function Qr(t1, e1) {
            if (0 === e1.length) return !1;
            switch(t1){
                case "$type":
                    return [
                        "filter-type-in",
                        [
                            "literal",
                            e1
                        ]
                    ];
                case "$id":
                    return [
                        "filter-id-in",
                        [
                            "literal",
                            e1
                        ]
                    ];
                default:
                    return e1.length > 200 && !e1.some((t1)=>typeof t1 != typeof e1[0]) ? [
                        "filter-in-large",
                        t1,
                        [
                            "literal",
                            e1.sort(Xr)
                        ]
                    ] : [
                        "filter-in-small",
                        t1,
                        [
                            "literal",
                            e1
                        ]
                    ];
            }
        }
        function tn(t1) {
            switch(t1){
                case "$type":
                    return !0;
                case "$id":
                    return [
                        "filter-has-id"
                    ];
                default:
                    return [
                        "filter-has",
                        t1
                    ];
            }
        }
        function en(t1) {
            return [
                "!",
                t1
            ];
        }
        function rn(t1) {
            return Kr(lt(t1.value)) ? Nr(st({}, t1, {
                expressionContext: "filter",
                valueSpec: {
                    value: "boolean"
                }
            })) : nn(t1);
        }
        function nn(t1) {
            const e1 = t1.value, r = t1.key;
            if ("array" !== Ar(e1)) return [
                new it(r, e1, `array expected, ${Ar(e1)} found`)
            ];
            const n = t1.styleSpec;
            let i, a = [];
            if (e1.length < 1) return [
                new it(r, e1, "filter array must have at least 1 element")
            ];
            switch(a = a.concat(Zr({
                key: `${r}[0]`,
                value: e1[0],
                valueSpec: n.filter_operator,
                style: t1.style,
                styleSpec: t1.styleSpec
            })), ot(e1[0])){
                case "<":
                case "<=":
                case ">":
                case ">=":
                    e1.length >= 2 && "$type" === ot(e1[1]) && a.push(new it(r, e1, `"$type" cannot be use with operator "${e1[0]}"`));
                case "==":
                case "!=":
                    3 !== e1.length && a.push(new it(r, e1, `filter array for operator "${e1[0]}" must have 3 elements`));
                case "in":
                case "!in":
                    e1.length >= 2 && (i = Ar(e1[1]), "string" !== i && a.push(new it(`${r}[1]`, e1[1], `string expected, ${i} found`)));
                    for(let s = 2; s < e1.length; s++)i = Ar(e1[s]), "$type" === ot(e1[1]) ? a = a.concat(Zr({
                        key: `${r}[${s}]`,
                        value: e1[s],
                        valueSpec: n.geometry_type,
                        style: t1.style,
                        styleSpec: t1.styleSpec
                    })) : "string" !== i && "number" !== i && "boolean" !== i && a.push(new it(`${r}[${s}]`, e1[s], `string, number, or boolean expected, ${i} found`));
                    break;
                case "any":
                case "all":
                case "none":
                    for(let n1 = 1; n1 < e1.length; n1++)a = a.concat(nn({
                        key: `${r}[${n1}]`,
                        value: e1[n1],
                        style: t1.style,
                        styleSpec: t1.styleSpec
                    }));
                    break;
                case "has":
                case "!has":
                    i = Ar(e1[1]), 2 !== e1.length ? a.push(new it(r, e1, `filter array for "${e1[0]}" operator must have 2 elements`)) : "string" !== i && a.push(new it(`${r}[1]`, e1[1], `string expected, ${i} found`));
                    break;
                case "within":
                    i = Ar(e1[1]), 2 !== e1.length ? a.push(new it(r, e1, `filter array for "${e1[0]}" operator must have 2 elements`)) : "object" !== i && a.push(new it(`${r}[1]`, e1[1], `object expected, ${i} found`));
            }
            return a;
        }
        function an(t1, e1) {
            const r = t1.key, n = t1.style, i = t1.styleSpec, a = t1.value, s = t1.objectKey, o = i[`${e1}_${t1.layerType}`];
            if (!o) return [];
            const l = s.match(/^(.*)-transition$/);
            if ("paint" === e1 && l && o[l[1]] && o[l[1]].transition) return yn({
                key: r,
                value: a,
                valueSpec: i.transition,
                style: n,
                styleSpec: i
            });
            const u = t1.valueSpec || o[s];
            if (!u) return [
                new it(r, a, `unknown property "${s}"`)
            ];
            let c;
            if ("string" === Ar(a) && br(u) && !u.tokens && (c = /^{([^}]+)}$/.exec(a))) return [
                new it(r, a, `"${s}" does not support interpolation syntax\nUse an identity property function instead: \`{ "type": "identity", "property": ${JSON.stringify(c[1])} }\`.`)
            ];
            const h = [];
            return "symbol" === t1.layerType && ("text-field" === s && n && !n.glyphs && h.push(new it(r, a, 'use of "text-field" requires a style "glyphs" property')), "text-font" === s && kr(lt(a)) && "identity" === ot(a.type) && h.push(new it(r, a, '"text-font" does not support identity functions'))), h.concat(yn({
                key: t1.key,
                value: a,
                valueSpec: u,
                style: n,
                styleSpec: i,
                expressionContext: "property",
                propertyType: e1,
                propertyKey: s
            }));
        }
        function sn(t1) {
            return an(t1, "paint");
        }
        function on(t1) {
            return an(t1, "layout");
        }
        function ln(t1) {
            let e1 = [];
            const r = t1.value, n = t1.key, i = t1.style, a = t1.styleSpec;
            r.type || r.ref || e1.push(new it(n, r, 'either "type" or "ref" is required'));
            let s = ot(r.type);
            const o = ot(r.ref);
            if (r.id) {
                const a1 = ot(r.id);
                for(let s1 = 0; s1 < t1.arrayIndex; s1++){
                    const t2 = i.layers[s1];
                    ot(t2.id) === a1 && e1.push(new it(n, r.id, `duplicate layer id "${r.id}", previously used at line ${t2.id.__line__}`));
                }
            }
            if ("ref" in r) {
                let t3;
                [
                    "type",
                    "source",
                    "source-layer",
                    "filter",
                    "layout"
                ].forEach((t1)=>{
                    t1 in r && e1.push(new it(n, r[t1], `"${t1}" is prohibited for ref layers`));
                }), i.layers.forEach((e1)=>{
                    ot(e1.id) === o && (t3 = e1);
                }), t3 ? t3.ref ? e1.push(new it(n, r.ref, "ref cannot reference another ref layer")) : s = ot(t3.type) : e1.push(new it(n, r.ref, `ref layer "${o}" not found`));
            } else if ("background" !== s) {
                if (r.source) {
                    const t4 = i.sources && i.sources[r.source], a2 = t4 && ot(t4.type);
                    t4 ? "vector" === a2 && "raster" === s ? e1.push(new it(n, r.source, `layer "${r.id}" requires a raster source`)) : "raster" === a2 && "raster" !== s ? e1.push(new it(n, r.source, `layer "${r.id}" requires a vector source`)) : "vector" !== a2 || r["source-layer"] ? "raster-dem" === a2 && "hillshade" !== s ? e1.push(new it(n, r.source, "raster-dem source can only be used with layer type 'hillshade'.")) : "line" !== s || !r.paint || !r.paint["line-gradient"] || "geojson" === a2 && t4.lineMetrics || e1.push(new it(n, r, `layer "${r.id}" specifies a line-gradient, which requires a GeoJSON source with \`lineMetrics\` enabled.`)) : e1.push(new it(n, r, `layer "${r.id}" must specify a "source-layer"`)) : e1.push(new it(n, r.source, `source "${r.source}" not found`));
                } else e1.push(new it(n, r, 'missing required property "source"'));
            }
            return e1 = e1.concat(Or({
                key: n,
                value: r,
                valueSpec: a.layer,
                style: t1.style,
                styleSpec: t1.styleSpec,
                objectElementValidators: {
                    "*": ()=>[],
                    type: ()=>yn({
                            key: `${n}.type`,
                            value: r.type,
                            valueSpec: a.layer.type,
                            style: t1.style,
                            styleSpec: t1.styleSpec,
                            object: r,
                            objectKey: "type"
                        }),
                    filter: rn,
                    layout: (t1)=>Or({
                            layer: r,
                            key: t1.key,
                            value: t1.value,
                            style: t1.style,
                            styleSpec: t1.styleSpec,
                            objectElementValidators: {
                                "*": (t1)=>on(st({
                                        layerType: s
                                    }, t1))
                            }
                        }),
                    paint: (t1)=>Or({
                            layer: r,
                            key: t1.key,
                            value: t1.value,
                            style: t1.style,
                            styleSpec: t1.styleSpec,
                            objectElementValidators: {
                                "*": (t1)=>sn(st({
                                        layerType: s
                                    }, t1))
                            }
                        })
                }
            })), e1;
        }
        function un(t1) {
            const e1 = t1.value, r = t1.key, n = Ar(e1);
            return "string" !== n ? [
                new it(r, e1, `string expected, ${n} found`)
            ] : [];
        }
        const cn = {
            promoteId: function({ key: t1 , value: e1  }) {
                if ("string" === Ar(e1)) return un({
                    key: t1,
                    value: e1
                });
                {
                    const r = [];
                    for(const n in e1)r.push(...un({
                        key: `${t1}.${n}`,
                        value: e1[n]
                    }));
                    return r;
                }
            }
        };
        function hn(t1) {
            const e1 = t1.value, r = t1.key, n = t1.styleSpec, i = t1.style;
            if (!e1.type) return [
                new it(r, e1, '"type" is required')
            ];
            const a = ot(e1.type);
            let s;
            switch(a){
                case "vector":
                case "raster":
                case "raster-dem":
                    return s = Or({
                        key: r,
                        value: e1,
                        valueSpec: n[`source_${a.replace("-", "_")}`],
                        style: t1.style,
                        styleSpec: n,
                        objectElementValidators: cn
                    }), s;
                case "geojson":
                    if (s = Or({
                        key: r,
                        value: e1,
                        valueSpec: n.source_geojson,
                        style: i,
                        styleSpec: n,
                        objectElementValidators: cn
                    }), e1.cluster) for(const t2 in e1.clusterProperties){
                        const [n1, i1] = e1.clusterProperties[t2], a1 = "string" == typeof n1 ? [
                            n1,
                            [
                                "accumulated"
                            ],
                            [
                                "get",
                                t2
                            ]
                        ] : n1;
                        s.push(...Nr({
                            key: `${r}.${t2}.map`,
                            value: i1,
                            expressionContext: "cluster-map"
                        })), s.push(...Nr({
                            key: `${r}.${t2}.reduce`,
                            value: a1,
                            expressionContext: "cluster-reduce"
                        }));
                    }
                    return s;
                case "video":
                    return Or({
                        key: r,
                        value: e1,
                        valueSpec: n.source_video,
                        style: i,
                        styleSpec: n
                    });
                case "image":
                    return Or({
                        key: r,
                        value: e1,
                        valueSpec: n.source_image,
                        style: i,
                        styleSpec: n
                    });
                case "canvas":
                    return [
                        new it(r, null, "Please use runtime APIs to add canvas sources, rather than including them in stylesheets.", "source.canvas")
                    ];
                default:
                    return Zr({
                        key: `${r}.type`,
                        value: e1.type,
                        valueSpec: {
                            values: [
                                "vector",
                                "raster",
                                "raster-dem",
                                "geojson",
                                "video",
                                "image"
                            ]
                        },
                        style: i,
                        styleSpec: n
                    });
            }
        }
        function pn(t1) {
            const e1 = t1.value, r = t1.styleSpec, n = r.light, i = t1.style;
            let a = [];
            const s = Ar(e1);
            if (void 0 === e1) return a;
            if ("object" !== s) return a = a.concat([
                new it("light", e1, `object expected, ${s} found`)
            ]), a;
            for(const t2 in e1){
                const s1 = t2.match(/^(.*)-transition$/);
                a = a.concat(s1 && n[s1[1]] && n[s1[1]].transition ? yn({
                    key: t2,
                    value: e1[t2],
                    valueSpec: r.transition,
                    style: i,
                    styleSpec: r
                }) : n[t2] ? yn({
                    key: t2,
                    value: e1[t2],
                    valueSpec: n[t2],
                    style: i,
                    styleSpec: r
                }) : [
                    new it(t2, e1[t2], `unknown property "${t2}"`)
                ]);
            }
            return a;
        }
        function fn(t1) {
            const e1 = t1.value, r = t1.styleSpec, n = r.terrain, i = t1.style;
            let a = [];
            const s = Ar(e1);
            if (void 0 === e1) return a;
            if ("object" !== s) return a = a.concat([
                new it("terrain", e1, `object expected, ${s} found`)
            ]), a;
            for(const t2 in e1)a = a.concat(n[t2] ? yn({
                key: t2,
                value: e1[t2],
                valueSpec: n[t2],
                style: i,
                styleSpec: r
            }) : [
                new it(t2, e1[t2], `unknown property "${t2}"`)
            ]);
            return a;
        }
        const dn = {
            "*": ()=>[],
            array: Ur,
            boolean: function(t1) {
                const e1 = t1.value, r = t1.key, n = Ar(e1);
                return "boolean" !== n ? [
                    new it(r, e1, `boolean expected, ${n} found`)
                ] : [];
            },
            number: qr,
            color: function(t1) {
                const e1 = t1.key, r = t1.value, n = Ar(r);
                return "string" !== n ? [
                    new it(e1, r, `color expected, ${n} found`)
                ] : null === zt(r) ? [
                    new it(e1, r, `color expected, "${r}" found`)
                ] : [];
            },
            constants: at,
            enum: Zr,
            filter: rn,
            function: jr,
            layer: ln,
            object: Or,
            source: hn,
            light: pn,
            terrain: fn,
            string: un,
            formatted: function(t1) {
                return 0 === un(t1).length ? [] : Nr(t1);
            },
            resolvedImage: function(t1) {
                return 0 === un(t1).length ? [] : Nr(t1);
            },
            padding: function(t1) {
                const e1 = t1.key, r = t1.value;
                if ("array" === Ar(r)) {
                    if (r.length < 1 || r.length > 4) return [
                        new it(e1, r, `padding requires 1 to 4 values; ${r.length} values found`)
                    ];
                    const t2 = {
                        type: "number"
                    };
                    let n = [];
                    for(let i = 0; i < r.length; i++)n = n.concat(yn({
                        key: `${e1}[${i}]`,
                        value: r[i],
                        valueSpec: t2
                    }));
                    return n;
                }
                return qr({
                    key: e1,
                    value: r,
                    valueSpec: {}
                });
            }
        };
        function yn(t1) {
            const e1 = t1.value, r = t1.valueSpec, n = t1.styleSpec;
            return r.expression && kr(ot(e1)) ? jr(t1) : r.expression && Er(lt(e1)) ? Nr(t1) : r.type && dn[r.type] ? dn[r.type](t1) : Or(st({}, t1, {
                valueSpec: r.type ? n[r.type] : r
            }));
        }
        function mn(t1) {
            const e1 = t1.value, r = t1.key, n = un(t1);
            return n.length || (-1 === e1.indexOf("{fontstack}") && n.push(new it(r, e1, '"glyphs" url must include a "{fontstack}" token')), -1 === e1.indexOf("{range}") && n.push(new it(r, e1, '"glyphs" url must include a "{range}" token'))), n;
        }
        function gn(t1, e1 = nt) {
            let r = [];
            return r = r.concat(yn({
                key: "",
                value: t1,
                valueSpec: e1.$root,
                styleSpec: e1,
                style: t1,
                objectElementValidators: {
                    glyphs: mn,
                    "*": ()=>[]
                }
            })), t1.constants && (r = r.concat(at({
                key: "constants",
                value: t1.constants,
                style: t1,
                styleSpec: e1
            }))), xn(r);
        }
        function xn(t1) {
            return [].concat(t1).sort((t1, e1)=>t1.line - e1.line);
        }
        function vn(t1) {
            return function(...e1) {
                return xn(t1.apply(this, e1));
            };
        }
        gn.source = vn(hn), gn.light = vn(pn), gn.terrain = vn(fn), gn.layer = vn(ln), gn.filter = vn(rn), gn.paintProperty = vn(sn), gn.layoutProperty = vn(on);
        const bn = gn, wn = bn.light, _n = bn.paintProperty, An = bn.layoutProperty;
        function kn(t1, e1) {
            let r = !1;
            if (e1 && e1.length) for (const n of e1)t1.fire(new et(new Error(n.message))), r = !0;
            return r;
        }
        class Sn {
            constructor(t1, e1, r){
                const n = this.cells = [];
                if (t1 instanceof ArrayBuffer) {
                    this.arrayBuffer = t1;
                    const i = new Int32Array(this.arrayBuffer);
                    t1 = i[0], this.d = (e1 = i[1]) + 2 * (r = i[2]);
                    for(let t2 = 0; t2 < this.d * this.d; t2++){
                        const e2 = i[3 + t2], r1 = i[3 + t2 + 1];
                        n.push(e2 === r1 ? null : i.subarray(e2, r1));
                    }
                    const a = i[3 + n.length + 1];
                    this.keys = i.subarray(i[3 + n.length], a), this.bboxes = i.subarray(a), this.insert = this._insertReadonly;
                } else {
                    this.d = e1 + 2 * r;
                    for(let t3 = 0; t3 < this.d * this.d; t3++)n.push([]);
                    this.keys = [], this.bboxes = [];
                }
                this.n = e1, this.extent = t1, this.padding = r, this.scale = e1 / t1, this.uid = 0;
                const i1 = r / e1 * t1;
                this.min = -i1, this.max = t1 + i1;
            }
            insert(t1, e1, r, n, i) {
                this._forEachCell(e1, r, n, i, this._insertCell, this.uid++, void 0, void 0), this.keys.push(t1), this.bboxes.push(e1), this.bboxes.push(r), this.bboxes.push(n), this.bboxes.push(i);
            }
            _insertReadonly() {
                throw new Error("Cannot insert into a GridIndex created from an ArrayBuffer.");
            }
            _insertCell(t1, e1, r, n, i, a) {
                this.cells[i].push(a);
            }
            query(t1, e1, r, n, i) {
                const a = this.min, s = this.max;
                if (t1 <= a && e1 <= a && s <= r && s <= n && !i) return Array.prototype.slice.call(this.keys);
                {
                    const a1 = [];
                    return this._forEachCell(t1, e1, r, n, this._queryCell, a1, {}, i), a1;
                }
            }
            _queryCell(t1, e1, r, n, i, a, s, o) {
                const l = this.cells[i];
                if (null !== l) {
                    const i1 = this.keys, u = this.bboxes;
                    for(let c = 0; c < l.length; c++){
                        const h = l[c];
                        if (void 0 === s[h]) {
                            const l1 = 4 * h;
                            (o ? o(u[l1 + 0], u[l1 + 1], u[l1 + 2], u[l1 + 3]) : t1 <= u[l1 + 2] && e1 <= u[l1 + 3] && r >= u[l1 + 0] && n >= u[l1 + 1]) ? (s[h] = !0, a.push(i1[h])) : s[h] = !1;
                        }
                    }
                }
            }
            _forEachCell(t1, e1, r, n, i, a, s, o) {
                const l = this._convertToCellCoord(t1), u = this._convertToCellCoord(e1), c = this._convertToCellCoord(r), h = this._convertToCellCoord(n);
                for(let p = l; p <= c; p++)for(let l1 = u; l1 <= h; l1++){
                    const u1 = this.d * l1 + p;
                    if ((!o || o(this._convertFromCellCoord(p), this._convertFromCellCoord(l1), this._convertFromCellCoord(p + 1), this._convertFromCellCoord(l1 + 1))) && i.call(this, t1, e1, r, n, u1, a, s, o)) return;
                }
            }
            _convertFromCellCoord(t1) {
                return (t1 - this.padding) / this.scale;
            }
            _convertToCellCoord(t1) {
                return Math.max(0, Math.min(this.d - 1, Math.floor(t1 * this.scale) + this.padding));
            }
            toArrayBuffer() {
                if (this.arrayBuffer) return this.arrayBuffer;
                const t1 = this.cells, e1 = 3 + this.cells.length + 1 + 1;
                let r = 0;
                for(let t2 = 0; t2 < this.cells.length; t2++)r += this.cells[t2].length;
                const n = new Int32Array(e1 + r + this.keys.length + this.bboxes.length);
                n[0] = this.extent, n[1] = this.n, n[2] = this.padding;
                let i = e1;
                for(let e2 = 0; e2 < t1.length; e2++){
                    const r1 = t1[e2];
                    n[3 + e2] = i, n.set(r1, i), i += r1.length;
                }
                return n[3 + t1.length] = i, n.set(this.keys, i), i += this.keys.length, n[3 + t1.length + 1] = i, n.set(this.bboxes, i), i += this.bboxes.length, n.buffer;
            }
            static serialize(t1, e1) {
                const r = t1.toArrayBuffer();
                return e1 && e1.push(r), {
                    buffer: r
                };
            }
            static deserialize(t1) {
                return new Sn(t1.buffer);
            }
        }
        const In = {};
        function Mn(t1, e1, r = {}) {
            if (In[t1]) throw new Error(`${t1} is already registered.`);
            Object.defineProperty(e1, "_classRegistryKey", {
                value: t1,
                writeable: !1
            }), In[t1] = {
                klass: e1,
                omit: r.omit || [],
                shallow: r.shallow || []
            };
        }
        Mn("Object", Object), Mn("TransferableGridIndex", Sn), Mn("Color", Ft), Mn("Error", Error), Mn("AJAXError", q), Mn("ResolvedImage", Rt), Mn("StylePropertyFunction", $r), Mn("StyleExpression", Vr, {
            omit: [
                "_evaluator"
            ]
        }), Mn("ZoomDependentExpression", Lr), Mn("ZoomConstantExpression", Tr), Mn("CompoundExpression", Wt, {
            omit: [
                "_evaluate"
            ]
        });
        for(const t3 in fr)fr[t3]._classRegistryKey || Mn(`Expression_${t3}`, fr[t3]);
        function zn(t1) {
            return t1 && "undefined" != typeof ArrayBuffer && (t1 instanceof ArrayBuffer || t1.constructor && "ArrayBuffer" === t1.constructor.name);
        }
        function Bn(t1, e1) {
            if (null == t1 || "boolean" == typeof t1 || "number" == typeof t1 || "string" == typeof t1 || t1 instanceof Boolean || t1 instanceof Number || t1 instanceof String || t1 instanceof Date || t1 instanceof RegExp || t1 instanceof Blob) return t1;
            if (zn(t1)) return e1 && e1.push(t1), t1;
            if (A(t1)) return e1 && e1.push(t1), t1;
            if (ArrayBuffer.isView(t1)) {
                const r = t1;
                return e1 && e1.push(r.buffer), r;
            }
            if (t1 instanceof ImageData) return e1 && e1.push(t1.data.buffer), t1;
            if (Array.isArray(t1)) {
                const r1 = [];
                for (const n of t1)r1.push(Bn(n, e1));
                return r1;
            }
            if ("object" == typeof t1) {
                const r2 = t1.constructor, n1 = r2._classRegistryKey;
                if (!n1) throw new Error("can't serialize object of unregistered class");
                if (!In[n1]) throw new Error(`${n1} is not registered.`);
                const i = r2.serialize ? r2.serialize(t1, e1) : {};
                if (r2.serialize) {
                    if (e1 && i === e1[e1.length - 1]) throw new Error("statically serialized object won't survive transfer of $name property");
                } else {
                    for(const r3 in t1){
                        if (!t1.hasOwnProperty(r3)) continue;
                        if (In[n1].omit.indexOf(r3) >= 0) continue;
                        const a = t1[r3];
                        i[r3] = In[n1].shallow.indexOf(r3) >= 0 ? a : Bn(a, e1);
                    }
                    t1 instanceof Error && (i.message = t1.message);
                }
                if (i.$name) throw new Error("$name property is reserved for worker serialization logic.");
                return "Object" !== n1 && (i.$name = n1), i;
            }
            throw new Error("can't serialize object of type " + typeof t1);
        }
        function Cn(t1) {
            if (null == t1 || "boolean" == typeof t1 || "number" == typeof t1 || "string" == typeof t1 || t1 instanceof Boolean || t1 instanceof Number || t1 instanceof String || t1 instanceof Date || t1 instanceof RegExp || t1 instanceof Blob || zn(t1) || A(t1) || ArrayBuffer.isView(t1) || t1 instanceof ImageData) return t1;
            if (Array.isArray(t1)) return t1.map(Cn);
            if ("object" == typeof t1) {
                const e1 = t1.$name || "Object";
                if (!In[e1]) throw new Error(`can't deserialize unregistered class ${e1}`);
                const { klass: r  } = In[e1];
                if (!r) throw new Error(`can't deserialize unregistered class ${e1}`);
                if (r.deserialize) return r.deserialize(t1);
                const n = Object.create(r.prototype);
                for (const r1 of Object.keys(t1)){
                    if ("$name" === r1) continue;
                    const i = t1[r1];
                    n[r1] = In[e1].shallow.indexOf(r1) >= 0 ? i : Cn(i);
                }
                return n;
            }
            throw new Error("can't deserialize object of type " + typeof t1);
        }
        class Pn {
            constructor(){
                this.first = !0;
            }
            update(t1, e1) {
                const r = Math.floor(t1);
                return this.first ? (this.first = !1, this.lastIntegerZoom = r, this.lastIntegerZoomTime = 0, this.lastZoom = t1, this.lastFloorZoom = r, !0) : (this.lastFloorZoom > r ? (this.lastIntegerZoom = r + 1, this.lastIntegerZoomTime = e1) : this.lastFloorZoom < r && (this.lastIntegerZoom = r, this.lastIntegerZoomTime = e1), t1 !== this.lastZoom && (this.lastZoom = t1, this.lastFloorZoom = r, !0));
            }
        }
        const Vn = {
            "Latin-1 Supplement": (t1)=>t1 >= 128 && t1 <= 255,
            Arabic: (t1)=>t1 >= 1536 && t1 <= 1791,
            "Arabic Supplement": (t1)=>t1 >= 1872 && t1 <= 1919,
            "Arabic Extended-A": (t1)=>t1 >= 2208 && t1 <= 2303,
            "Hangul Jamo": (t1)=>t1 >= 4352 && t1 <= 4607,
            "Unified Canadian Aboriginal Syllabics": (t1)=>t1 >= 5120 && t1 <= 5759,
            Khmer: (t1)=>t1 >= 6016 && t1 <= 6143,
            "Unified Canadian Aboriginal Syllabics Extended": (t1)=>t1 >= 6320 && t1 <= 6399,
            "General Punctuation": (t1)=>t1 >= 8192 && t1 <= 8303,
            "Letterlike Symbols": (t1)=>t1 >= 8448 && t1 <= 8527,
            "Number Forms": (t1)=>t1 >= 8528 && t1 <= 8591,
            "Miscellaneous Technical": (t1)=>t1 >= 8960 && t1 <= 9215,
            "Control Pictures": (t1)=>t1 >= 9216 && t1 <= 9279,
            "Optical Character Recognition": (t1)=>t1 >= 9280 && t1 <= 9311,
            "Enclosed Alphanumerics": (t1)=>t1 >= 9312 && t1 <= 9471,
            "Geometric Shapes": (t1)=>t1 >= 9632 && t1 <= 9727,
            "Miscellaneous Symbols": (t1)=>t1 >= 9728 && t1 <= 9983,
            "Miscellaneous Symbols and Arrows": (t1)=>t1 >= 11008 && t1 <= 11263,
            "CJK Radicals Supplement": (t1)=>t1 >= 11904 && t1 <= 12031,
            "Kangxi Radicals": (t1)=>t1 >= 12032 && t1 <= 12255,
            "Ideographic Description Characters": (t1)=>t1 >= 12272 && t1 <= 12287,
            "CJK Symbols and Punctuation": (t1)=>t1 >= 12288 && t1 <= 12351,
            Hiragana: (t1)=>t1 >= 12352 && t1 <= 12447,
            Katakana: (t1)=>t1 >= 12448 && t1 <= 12543,
            Bopomofo: (t1)=>t1 >= 12544 && t1 <= 12591,
            "Hangul Compatibility Jamo": (t1)=>t1 >= 12592 && t1 <= 12687,
            Kanbun: (t1)=>t1 >= 12688 && t1 <= 12703,
            "Bopomofo Extended": (t1)=>t1 >= 12704 && t1 <= 12735,
            "CJK Strokes": (t1)=>t1 >= 12736 && t1 <= 12783,
            "Katakana Phonetic Extensions": (t1)=>t1 >= 12784 && t1 <= 12799,
            "Enclosed CJK Letters and Months": (t1)=>t1 >= 12800 && t1 <= 13055,
            "CJK Compatibility": (t1)=>t1 >= 13056 && t1 <= 13311,
            "CJK Unified Ideographs Extension A": (t1)=>t1 >= 13312 && t1 <= 19903,
            "Yijing Hexagram Symbols": (t1)=>t1 >= 19904 && t1 <= 19967,
            "CJK Unified Ideographs": (t1)=>t1 >= 19968 && t1 <= 40959,
            "Yi Syllables": (t1)=>t1 >= 40960 && t1 <= 42127,
            "Yi Radicals": (t1)=>t1 >= 42128 && t1 <= 42191,
            "Hangul Jamo Extended-A": (t1)=>t1 >= 43360 && t1 <= 43391,
            "Hangul Syllables": (t1)=>t1 >= 44032 && t1 <= 55215,
            "Hangul Jamo Extended-B": (t1)=>t1 >= 55216 && t1 <= 55295,
            "Private Use Area": (t1)=>t1 >= 57344 && t1 <= 63743,
            "CJK Compatibility Ideographs": (t1)=>t1 >= 63744 && t1 <= 64255,
            "Arabic Presentation Forms-A": (t1)=>t1 >= 64336 && t1 <= 65023,
            "Vertical Forms": (t1)=>t1 >= 65040 && t1 <= 65055,
            "CJK Compatibility Forms": (t1)=>t1 >= 65072 && t1 <= 65103,
            "Small Form Variants": (t1)=>t1 >= 65104 && t1 <= 65135,
            "Arabic Presentation Forms-B": (t1)=>t1 >= 65136 && t1 <= 65279,
            "Halfwidth and Fullwidth Forms": (t1)=>t1 >= 65280 && t1 <= 65519
        };
        function En(t1) {
            for (const e1 of t1)if (Ln(e1.charCodeAt(0))) return !0;
            return !1;
        }
        function Fn(t1) {
            for (const e1 of t1)if (!Tn(e1.charCodeAt(0))) return !1;
            return !0;
        }
        function Tn(t1) {
            return !(Vn.Arabic(t1) || Vn["Arabic Supplement"](t1) || Vn["Arabic Extended-A"](t1) || Vn["Arabic Presentation Forms-A"](t1) || Vn["Arabic Presentation Forms-B"](t1));
        }
        function Ln(t1) {
            return !(746 !== t1 && 747 !== t1 && (t1 < 4352 || !(Vn["Bopomofo Extended"](t1) || Vn.Bopomofo(t1) || Vn["CJK Compatibility Forms"](t1) && !(t1 >= 65097 && t1 <= 65103) || Vn["CJK Compatibility Ideographs"](t1) || Vn["CJK Compatibility"](t1) || Vn["CJK Radicals Supplement"](t1) || Vn["CJK Strokes"](t1) || !(!Vn["CJK Symbols and Punctuation"](t1) || t1 >= 12296 && t1 <= 12305 || t1 >= 12308 && t1 <= 12319 || 12336 === t1) || Vn["CJK Unified Ideographs Extension A"](t1) || Vn["CJK Unified Ideographs"](t1) || Vn["Enclosed CJK Letters and Months"](t1) || Vn["Hangul Compatibility Jamo"](t1) || Vn["Hangul Jamo Extended-A"](t1) || Vn["Hangul Jamo Extended-B"](t1) || Vn["Hangul Jamo"](t1) || Vn["Hangul Syllables"](t1) || Vn.Hiragana(t1) || Vn["Ideographic Description Characters"](t1) || Vn.Kanbun(t1) || Vn["Kangxi Radicals"](t1) || Vn["Katakana Phonetic Extensions"](t1) || Vn.Katakana(t1) && 12540 !== t1 || !(!Vn["Halfwidth and Fullwidth Forms"](t1) || 65288 === t1 || 65289 === t1 || 65293 === t1 || t1 >= 65306 && t1 <= 65310 || 65339 === t1 || 65341 === t1 || 65343 === t1 || t1 >= 65371 && t1 <= 65503 || 65507 === t1 || t1 >= 65512 && t1 <= 65519) || !(!Vn["Small Form Variants"](t1) || t1 >= 65112 && t1 <= 65118 || t1 >= 65123 && t1 <= 65126) || Vn["Unified Canadian Aboriginal Syllabics"](t1) || Vn["Unified Canadian Aboriginal Syllabics Extended"](t1) || Vn["Vertical Forms"](t1) || Vn["Yijing Hexagram Symbols"](t1) || Vn["Yi Syllables"](t1) || Vn["Yi Radicals"](t1))));
        }
        function Dn(t1) {
            return !(Ln(t1) || function(t1) {
                return !!(Vn["Latin-1 Supplement"](t1) && (167 === t1 || 169 === t1 || 174 === t1 || 177 === t1 || 188 === t1 || 189 === t1 || 190 === t1 || 215 === t1 || 247 === t1) || Vn["General Punctuation"](t1) && (8214 === t1 || 8224 === t1 || 8225 === t1 || 8240 === t1 || 8241 === t1 || 8251 === t1 || 8252 === t1 || 8258 === t1 || 8263 === t1 || 8264 === t1 || 8265 === t1 || 8273 === t1) || Vn["Letterlike Symbols"](t1) || Vn["Number Forms"](t1) || Vn["Miscellaneous Technical"](t1) && (t1 >= 8960 && t1 <= 8967 || t1 >= 8972 && t1 <= 8991 || t1 >= 8996 && t1 <= 9e3 || 9003 === t1 || t1 >= 9085 && t1 <= 9114 || t1 >= 9150 && t1 <= 9165 || 9167 === t1 || t1 >= 9169 && t1 <= 9179 || t1 >= 9186 && t1 <= 9215) || Vn["Control Pictures"](t1) && 9251 !== t1 || Vn["Optical Character Recognition"](t1) || Vn["Enclosed Alphanumerics"](t1) || Vn["Geometric Shapes"](t1) || Vn["Miscellaneous Symbols"](t1) && !(t1 >= 9754 && t1 <= 9759) || Vn["Miscellaneous Symbols and Arrows"](t1) && (t1 >= 11026 && t1 <= 11055 || t1 >= 11088 && t1 <= 11097 || t1 >= 11192 && t1 <= 11243) || Vn["CJK Symbols and Punctuation"](t1) || Vn.Katakana(t1) || Vn["Private Use Area"](t1) || Vn["CJK Compatibility Forms"](t1) || Vn["Small Form Variants"](t1) || Vn["Halfwidth and Fullwidth Forms"](t1) || 8734 === t1 || 8756 === t1 || 8757 === t1 || t1 >= 9984 && t1 <= 10087 || t1 >= 10102 && t1 <= 10131 || 65532 === t1 || 65533 === t1);
            }(t1));
        }
        function $n(t1) {
            return t1 >= 1424 && t1 <= 2303 || Vn["Arabic Presentation Forms-A"](t1) || Vn["Arabic Presentation Forms-B"](t1);
        }
        function Rn(t1, e1) {
            return !(!e1 && $n(t1) || t1 >= 2304 && t1 <= 3583 || t1 >= 3840 && t1 <= 4255 || Vn.Khmer(t1));
        }
        function On(t1) {
            for (const e1 of t1)if ($n(e1.charCodeAt(0))) return !0;
            return !1;
        }
        const Un = "deferred", qn = "loading", jn = "loaded";
        let Nn = null, Zn = "unavailable", Kn = null;
        const Gn = function(t1) {
            t1 && "string" == typeof t1 && t1.indexOf("NetworkError") > -1 && (Zn = "error"), Nn && Nn(t1);
        };
        function Jn() {
            Xn.fire(new tt("pluginStateChange", {
                pluginStatus: Zn,
                pluginURL: Kn
            }));
        }
        const Xn = new rt, Yn = function() {
            return Zn;
        }, Hn = function() {
            if (Zn !== Un || !Kn) throw new Error("rtl-text-plugin cannot be downloaded unless a pluginURL is specified");
            Zn = qn, Jn(), Kn && K({
                url: Kn
            }, (t1)=>{
                t1 ? Gn(t1) : (Zn = jn, Jn());
            });
        }, Wn = {
            applyArabicShaping: null,
            processBidirectionalText: null,
            processStyledBidirectionalText: null,
            isLoaded: ()=>Zn === jn || null != Wn.applyArabicShaping,
            isLoading: ()=>Zn === qn,
            setState (t1) {
                if (!g()) throw new Error("Cannot set the state of the rtl-text-plugin when not in the web-worker context");
                Zn = t1.pluginStatus, Kn = t1.pluginURL;
            },
            isParsed () {
                if (!g()) throw new Error("rtl-text-plugin is only parsed on the worker-threads");
                return null != Wn.applyArabicShaping && null != Wn.processBidirectionalText && null != Wn.processStyledBidirectionalText;
            },
            getPluginURL () {
                if (!g()) throw new Error("rtl-text-plugin url can only be queried from the worker threads");
                return Kn;
            }
        };
        class Qn {
            constructor(t1, e1){
                this.zoom = t1, e1 ? (this.now = e1.now, this.fadeDuration = e1.fadeDuration, this.zoomHistory = e1.zoomHistory, this.transition = e1.transition) : (this.now = 0, this.fadeDuration = 0, this.zoomHistory = new Pn, this.transition = {});
            }
            isSupportedScript(t1) {
                return function(t1, e1) {
                    for (const r of t1)if (!Rn(r.charCodeAt(0), e1)) return !1;
                    return !0;
                }(t1, Wn.isLoaded());
            }
            crossFadingFactor() {
                return 0 === this.fadeDuration ? 1 : Math.min((this.now - this.zoomHistory.lastIntegerZoomTime) / this.fadeDuration, 1);
            }
            getCrossfadeParameters() {
                const t1 = this.zoom, e1 = t1 - Math.floor(t1), r = this.crossFadingFactor();
                return t1 > this.zoomHistory.lastIntegerZoom ? {
                    fromScale: 2,
                    toScale: 1,
                    t: e1 + (1 - e1) * r
                } : {
                    fromScale: .5,
                    toScale: 1,
                    t: 1 - (1 - r) * e1
                };
            }
        }
        class ti {
            constructor(t1, e1){
                this.property = t1, this.value = e1, this.expression = function(t1, e1) {
                    if (kr(t1)) return new $r(t1, e1);
                    if (Er(t1)) {
                        const r = Dr(t1, e1);
                        if ("error" === r.result) throw new Error(r.value.map((t1)=>`${t1.key}: ${t1.message}`).join(", "));
                        return r.value;
                    }
                    {
                        let r1 = t1;
                        return "color" === e1.type && "string" == typeof t1 ? r1 = Ft.parse(t1) : "padding" !== e1.type || "number" != typeof t1 && !Array.isArray(t1) || (r1 = $t.parse(t1)), {
                            kind: "constant",
                            evaluate: ()=>r1
                        };
                    }
                }(void 0 === e1 ? t1.specification.default : e1, t1.specification);
            }
            isDataDriven() {
                return "source" === this.expression.kind || "composite" === this.expression.kind;
            }
            possiblyEvaluate(t1, e1, r) {
                return this.property.possiblyEvaluate(this, t1, e1, r);
            }
        }
        class ei {
            constructor(t1){
                this.property = t1, this.value = new ti(t1, void 0);
            }
            transitioned(t1, e1) {
                return new ni(this.property, this.value, e1, o({}, t1.transition, this.transition), t1.now);
            }
            untransitioned() {
                return new ni(this.property, this.value, null, {}, 0);
            }
        }
        class ri {
            constructor(t1){
                this._properties = t1, this._values = Object.create(t1.defaultTransitionablePropertyValues);
            }
            getValue(t1) {
                return p(this._values[t1].value.value);
            }
            setValue(t1, e1) {
                Object.prototype.hasOwnProperty.call(this._values, t1) || (this._values[t1] = new ei(this._values[t1].property)), this._values[t1].value = new ti(this._values[t1].property, null === e1 ? void 0 : p(e1));
            }
            getTransition(t1) {
                return p(this._values[t1].transition);
            }
            setTransition(t1, e1) {
                Object.prototype.hasOwnProperty.call(this._values, t1) || (this._values[t1] = new ei(this._values[t1].property)), this._values[t1].transition = p(e1) || void 0;
            }
            serialize() {
                const t1 = {};
                for (const e1 of Object.keys(this._values)){
                    const r = this.getValue(e1);
                    void 0 !== r && (t1[e1] = r);
                    const n = this.getTransition(e1);
                    void 0 !== n && (t1[`${e1}-transition`] = n);
                }
                return t1;
            }
            transitioned(t1, e1) {
                const r = new ii(this._properties);
                for (const n of Object.keys(this._values))r._values[n] = this._values[n].transitioned(t1, e1._values[n]);
                return r;
            }
            untransitioned() {
                const t1 = new ii(this._properties);
                for (const e1 of Object.keys(this._values))t1._values[e1] = this._values[e1].untransitioned();
                return t1;
            }
        }
        class ni {
            constructor(t1, e1, r, n, i){
                this.property = t1, this.value = e1, this.begin = i + n.delay || 0, this.end = this.begin + n.duration || 0, t1.specification.transition && (n.delay || n.duration) && (this.prior = r);
            }
            possiblyEvaluate(t1, e1, r) {
                const n = t1.now || 0, i = this.value.possiblyEvaluate(t1, e1, r), a = this.prior;
                if (a) {
                    if (n > this.end) return this.prior = null, i;
                    if (this.value.isDataDriven()) return this.prior = null, i;
                    if (n < this.begin) return a.possiblyEvaluate(t1, e1, r);
                    {
                        const s = (n - this.begin) / (this.end - this.begin);
                        return this.property.interpolate(a.possiblyEvaluate(t1, e1, r), i, function(t1) {
                            if (t1 <= 0) return 0;
                            if (t1 >= 1) return 1;
                            const e1 = t1 * t1, r = e1 * t1;
                            return 4 * (t1 < .5 ? r : 3 * (t1 - e1) + r - .75);
                        }(s));
                    }
                }
                return i;
            }
        }
        class ii {
            constructor(t1){
                this._properties = t1, this._values = Object.create(t1.defaultTransitioningPropertyValues);
            }
            possiblyEvaluate(t1, e1, r) {
                const n = new oi(this._properties);
                for (const i of Object.keys(this._values))n._values[i] = this._values[i].possiblyEvaluate(t1, e1, r);
                return n;
            }
            hasTransition() {
                for (const t1 of Object.keys(this._values))if (this._values[t1].prior) return !0;
                return !1;
            }
        }
        class ai {
            constructor(t1){
                this._properties = t1, this._values = Object.create(t1.defaultPropertyValues);
            }
            getValue(t1) {
                return p(this._values[t1].value);
            }
            setValue(t1, e1) {
                this._values[t1] = new ti(this._values[t1].property, null === e1 ? void 0 : p(e1));
            }
            serialize() {
                const t1 = {};
                for (const e1 of Object.keys(this._values)){
                    const r = this.getValue(e1);
                    void 0 !== r && (t1[e1] = r);
                }
                return t1;
            }
            possiblyEvaluate(t1, e1, r) {
                const n = new oi(this._properties);
                for (const i of Object.keys(this._values))n._values[i] = this._values[i].possiblyEvaluate(t1, e1, r);
                return n;
            }
        }
        class si {
            constructor(t1, e1, r){
                this.property = t1, this.value = e1, this.parameters = r;
            }
            isConstant() {
                return "constant" === this.value.kind;
            }
            constantOr(t1) {
                return "constant" === this.value.kind ? this.value.value : t1;
            }
            evaluate(t1, e1, r, n) {
                return this.property.evaluate(this.value, this.parameters, t1, e1, r, n);
            }
        }
        class oi {
            constructor(t1){
                this._properties = t1, this._values = Object.create(t1.defaultPossiblyEvaluatedValues);
            }
            get(t1) {
                return this._values[t1];
            }
        }
        class li {
            constructor(t1){
                this.specification = t1;
            }
            possiblyEvaluate(t1, e1) {
                if (t1.isDataDriven()) throw new Error("Value should not be data driven");
                return t1.expression.evaluate(e1);
            }
            interpolate(t1, e1, r) {
                const n = Ie[this.specification.type];
                return n ? n(t1, e1, r) : t1;
            }
        }
        class ui {
            constructor(t1, e1){
                this.specification = t1, this.overrides = e1;
            }
            possiblyEvaluate(t1, e1, r, n) {
                return new si(this, "constant" === t1.expression.kind || "camera" === t1.expression.kind ? {
                    kind: "constant",
                    value: t1.expression.evaluate(e1, null, {}, r, n)
                } : t1.expression, e1);
            }
            interpolate(t1, e1, r) {
                if ("constant" !== t1.value.kind || "constant" !== e1.value.kind) return t1;
                if (void 0 === t1.value.value || void 0 === e1.value.value) return new si(this, {
                    kind: "constant",
                    value: void 0
                }, t1.parameters);
                const n = Ie[this.specification.type];
                return n ? new si(this, {
                    kind: "constant",
                    value: n(t1.value.value, e1.value.value, r)
                }, t1.parameters) : t1;
            }
            evaluate(t1, e1, r, n, i, a) {
                return "constant" === t1.kind ? t1.value : t1.evaluate(e1, r, n, i, a);
            }
        }
        class ci extends ui {
            possiblyEvaluate(t1, e1, r, n) {
                if (void 0 === t1.value) return new si(this, {
                    kind: "constant",
                    value: void 0
                }, e1);
                if ("constant" === t1.expression.kind) {
                    const i = t1.expression.evaluate(e1, null, {}, r, n), a = "resolvedImage" === t1.property.specification.type && "string" != typeof i ? i.name : i, s = this._calculate(a, a, a, e1);
                    return new si(this, {
                        kind: "constant",
                        value: s
                    }, e1);
                }
                if ("camera" === t1.expression.kind) {
                    const r1 = this._calculate(t1.expression.evaluate({
                        zoom: e1.zoom - 1
                    }), t1.expression.evaluate({
                        zoom: e1.zoom
                    }), t1.expression.evaluate({
                        zoom: e1.zoom + 1
                    }), e1);
                    return new si(this, {
                        kind: "constant",
                        value: r1
                    }, e1);
                }
                return new si(this, t1.expression, e1);
            }
            evaluate(t1, e1, r, n, i, a) {
                if ("source" === t1.kind) {
                    const s = t1.evaluate(e1, r, n, i, a);
                    return this._calculate(s, s, s, e1);
                }
                return "composite" === t1.kind ? this._calculate(t1.evaluate({
                    zoom: Math.floor(e1.zoom) - 1
                }, r, n), t1.evaluate({
                    zoom: Math.floor(e1.zoom)
                }, r, n), t1.evaluate({
                    zoom: Math.floor(e1.zoom) + 1
                }, r, n), e1) : t1.value;
            }
            _calculate(t1, e1, r, n) {
                return n.zoom > n.zoomHistory.lastIntegerZoom ? {
                    from: t1,
                    to: e1
                } : {
                    from: r,
                    to: e1
                };
            }
            interpolate(t1) {
                return t1;
            }
        }
        class hi {
            constructor(t1){
                this.specification = t1;
            }
            possiblyEvaluate(t1, e1, r, n) {
                if (void 0 !== t1.value) {
                    if ("constant" === t1.expression.kind) {
                        const i = t1.expression.evaluate(e1, null, {}, r, n);
                        return this._calculate(i, i, i, e1);
                    }
                    return this._calculate(t1.expression.evaluate(new Qn(Math.floor(e1.zoom - 1), e1)), t1.expression.evaluate(new Qn(Math.floor(e1.zoom), e1)), t1.expression.evaluate(new Qn(Math.floor(e1.zoom + 1), e1)), e1);
                }
            }
            _calculate(t1, e1, r, n) {
                return n.zoom > n.zoomHistory.lastIntegerZoom ? {
                    from: t1,
                    to: e1
                } : {
                    from: r,
                    to: e1
                };
            }
            interpolate(t1) {
                return t1;
            }
        }
        class pi {
            constructor(t1){
                this.specification = t1;
            }
            possiblyEvaluate(t1, e1, r, n) {
                return !!t1.expression.evaluate(e1, null, {}, r, n);
            }
            interpolate() {
                return !1;
            }
        }
        class fi {
            constructor(t1){
                this.properties = t1, this.defaultPropertyValues = {}, this.defaultTransitionablePropertyValues = {}, this.defaultTransitioningPropertyValues = {}, this.defaultPossiblyEvaluatedValues = {}, this.overridableProperties = [];
                for(const e1 in t1){
                    const r = t1[e1];
                    r.specification.overridable && this.overridableProperties.push(e1);
                    const n = this.defaultPropertyValues[e1] = new ti(r, void 0), i = this.defaultTransitionablePropertyValues[e1] = new ei(r);
                    this.defaultTransitioningPropertyValues[e1] = i.untransitioned(), this.defaultPossiblyEvaluatedValues[e1] = n.possiblyEvaluate({});
                }
            }
        }
        Mn("DataDrivenProperty", ui), Mn("DataConstantProperty", li), Mn("CrossFadedDataDrivenProperty", ci), Mn("CrossFadedProperty", hi), Mn("ColorRampProperty", pi);
        const di = "-transition";
        class yi extends rt {
            constructor(t1, e1){
                if (super(), this.id = t1.id, this.type = t1.type, this._featureFilter = {
                    filter: ()=>!0,
                    needGeometry: !1
                }, "custom" !== t1.type && (this.metadata = t1.metadata, this.minzoom = t1.minzoom, this.maxzoom = t1.maxzoom, "background" !== t1.type && (this.source = t1.source, this.sourceLayer = t1["source-layer"], this.filter = t1.filter), e1.layout && (this._unevaluatedLayout = new ai(e1.layout)), e1.paint)) {
                    this._transitionablePaint = new ri(e1.paint);
                    for(const e2 in t1.paint)this.setPaintProperty(e2, t1.paint[e2], {
                        validate: !1
                    });
                    for(const e3 in t1.layout)this.setLayoutProperty(e3, t1.layout[e3], {
                        validate: !1
                    });
                    this._transitioningPaint = this._transitionablePaint.untransitioned(), this.paint = new oi(e1.paint);
                }
            }
            getCrossfadeParameters() {
                return this._crossfadeParameters;
            }
            getLayoutProperty(t1) {
                return "visibility" === t1 ? this.visibility : this._unevaluatedLayout.getValue(t1);
            }
            setLayoutProperty(t1, e1, r = {}) {
                null != e1 && this._validate(An, `layers.${this.id}.layout.${t1}`, t1, e1, r) || ("visibility" !== t1 ? this._unevaluatedLayout.setValue(t1, e1) : this.visibility = e1);
            }
            getPaintProperty(t1) {
                return t1.endsWith(di) ? this._transitionablePaint.getTransition(t1.slice(0, -di.length)) : this._transitionablePaint.getValue(t1);
            }
            setPaintProperty(t1, e1, r = {}) {
                if (null != e1 && this._validate(_n, `layers.${this.id}.paint.${t1}`, t1, e1, r)) return !1;
                if (t1.endsWith(di)) return this._transitionablePaint.setTransition(t1.slice(0, -di.length), e1 || void 0), !1;
                {
                    const r1 = this._transitionablePaint._values[t1], n = "cross-faded-data-driven" === r1.property.specification["property-type"], i = r1.value.isDataDriven(), a = r1.value;
                    this._transitionablePaint.setValue(t1, e1), this._handleSpecialPaintPropertyUpdate(t1);
                    const s = this._transitionablePaint._values[t1].value;
                    return s.isDataDriven() || i || n || this._handleOverridablePaintPropertyUpdate(t1, a, s);
                }
            }
            _handleSpecialPaintPropertyUpdate(t1) {}
            _handleOverridablePaintPropertyUpdate(t1, e1, r) {
                return !1;
            }
            isHidden(t1) {
                return !!(this.minzoom && t1 < this.minzoom) || !!(this.maxzoom && t1 >= this.maxzoom) || "none" === this.visibility;
            }
            updateTransitions(t1) {
                this._transitioningPaint = this._transitionablePaint.transitioned(t1, this._transitioningPaint);
            }
            hasTransition() {
                return this._transitioningPaint.hasTransition();
            }
            recalculate(t1, e1) {
                t1.getCrossfadeParameters && (this._crossfadeParameters = t1.getCrossfadeParameters()), this._unevaluatedLayout && (this.layout = this._unevaluatedLayout.possiblyEvaluate(t1, void 0, e1)), this.paint = this._transitioningPaint.possiblyEvaluate(t1, void 0, e1);
            }
            serialize() {
                const t1 = {
                    id: this.id,
                    type: this.type,
                    source: this.source,
                    "source-layer": this.sourceLayer,
                    metadata: this.metadata,
                    minzoom: this.minzoom,
                    maxzoom: this.maxzoom,
                    filter: this.filter,
                    layout: this._unevaluatedLayout && this._unevaluatedLayout.serialize(),
                    paint: this._transitionablePaint && this._transitionablePaint.serialize()
                };
                return this.visibility && (t1.layout = t1.layout || {}, t1.layout.visibility = this.visibility), h(t1, (t1, e1)=>!(void 0 === t1 || "layout" === e1 && !Object.keys(t1).length || "paint" === e1 && !Object.keys(t1).length));
            }
            _validate(t1, e1, r, n, i = {}) {
                return (!i || !1 !== i.validate) && kn(this, t1.call(bn, {
                    key: e1,
                    layerType: this.type,
                    objectKey: r,
                    value: n,
                    styleSpec: nt,
                    style: {
                        glyphs: !0,
                        sprite: !0
                    }
                }));
            }
            is3D() {
                return !1;
            }
            isTileClipped() {
                return !1;
            }
            hasOffscreenPass() {
                return !1;
            }
            resize() {}
            isStateDependent() {
                for(const t1 in this.paint._values){
                    const e1 = this.paint.get(t1);
                    if (e1 instanceof si && br(e1.property.specification) && ("source" === e1.value.kind || "composite" === e1.value.kind) && e1.value.isStateDependent) return !0;
                }
                return !1;
            }
        }
        const mi = {
            Int8: Int8Array,
            Uint8: Uint8Array,
            Int16: Int16Array,
            Uint16: Uint16Array,
            Int32: Int32Array,
            Uint32: Uint32Array,
            Float32: Float32Array
        };
        class gi {
            constructor(t1, e1){
                this._structArray = t1, this._pos1 = e1 * this.size, this._pos2 = this._pos1 / 2, this._pos4 = this._pos1 / 4, this._pos8 = this._pos1 / 8;
            }
        }
        class xi {
            constructor(){
                this.isTransferred = !1, this.capacity = -1, this.resize(0);
            }
            static serialize(t1, e1) {
                return t1._trim(), e1 && (t1.isTransferred = !0, e1.push(t1.arrayBuffer)), {
                    length: t1.length,
                    arrayBuffer: t1.arrayBuffer
                };
            }
            static deserialize(t1) {
                const e1 = Object.create(this.prototype);
                return e1.arrayBuffer = t1.arrayBuffer, e1.length = t1.length, e1.capacity = t1.arrayBuffer.byteLength / e1.bytesPerElement, e1._refreshViews(), e1;
            }
            _trim() {
                this.length !== this.capacity && (this.capacity = this.length, this.arrayBuffer = this.arrayBuffer.slice(0, this.length * this.bytesPerElement), this._refreshViews());
            }
            clear() {
                this.length = 0;
            }
            resize(t1) {
                this.reserve(t1), this.length = t1;
            }
            reserve(t1) {
                if (t1 > this.capacity) {
                    this.capacity = Math.max(t1, Math.floor(5 * this.capacity), 128), this.arrayBuffer = new ArrayBuffer(this.capacity * this.bytesPerElement);
                    const e1 = this.uint8;
                    this._refreshViews(), e1 && this.uint8.set(e1);
                }
            }
            _refreshViews() {
                throw new Error("_refreshViews() must be implemented by each concrete StructArray layout");
            }
        }
        function vi(t1, e1 = 1) {
            let r = 0, n = 0;
            return {
                members: t1.map((t1)=>{
                    const i = mi[t1.type].BYTES_PER_ELEMENT, a = r = bi(r, Math.max(e1, i)), s = t1.components || 1;
                    return n = Math.max(n, i), r += i * s, {
                        name: t1.name,
                        type: t1.type,
                        components: s,
                        offset: a
                    };
                }),
                size: bi(r, Math.max(n, e1)),
                alignment: e1
            };
        }
        function bi(t1, e1) {
            return Math.ceil(t1 / e1) * e1;
        }
        class wi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1) {
                const r = this.length;
                return this.resize(r + 1), this.emplace(r, t1, e1);
            }
            emplace(t1, e1, r) {
                const n = 2 * t1;
                return this.int16[n + 0] = e1, this.int16[n + 1] = r, t1;
            }
        }
        wi.prototype.bytesPerElement = 4, Mn("StructArrayLayout2i4", wi);
        class _i extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n) {
                const i = this.length;
                return this.resize(i + 1), this.emplace(i, t1, e1, r, n);
            }
            emplace(t1, e1, r, n, i) {
                const a = 4 * t1;
                return this.int16[a + 0] = e1, this.int16[a + 1] = r, this.int16[a + 2] = n, this.int16[a + 3] = i, t1;
            }
        }
        _i.prototype.bytesPerElement = 8, Mn("StructArrayLayout4i8", _i);
        class Ai extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, a) {
                const s = this.length;
                return this.resize(s + 1), this.emplace(s, t1, e1, r, n, i, a);
            }
            emplace(t1, e1, r, n, i, a, s) {
                const o = 6 * t1;
                return this.int16[o + 0] = e1, this.int16[o + 1] = r, this.int16[o + 2] = n, this.int16[o + 3] = i, this.int16[o + 4] = a, this.int16[o + 5] = s, t1;
            }
        }
        Ai.prototype.bytesPerElement = 12, Mn("StructArrayLayout2i4i12", Ai);
        class ki extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, a) {
                const s = this.length;
                return this.resize(s + 1), this.emplace(s, t1, e1, r, n, i, a);
            }
            emplace(t1, e1, r, n, i, a, s) {
                const o = 4 * t1, l = 8 * t1;
                return this.int16[o + 0] = e1, this.int16[o + 1] = r, this.uint8[l + 4] = n, this.uint8[l + 5] = i, this.uint8[l + 6] = a, this.uint8[l + 7] = s, t1;
            }
        }
        ki.prototype.bytesPerElement = 8, Mn("StructArrayLayout2i4ub8", ki);
        class Si extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1) {
                const r = this.length;
                return this.resize(r + 1), this.emplace(r, t1, e1);
            }
            emplace(t1, e1, r) {
                const n = 2 * t1;
                return this.float32[n + 0] = e1, this.float32[n + 1] = r, t1;
            }
        }
        Si.prototype.bytesPerElement = 8, Mn("StructArrayLayout2f8", Si);
        class Ii extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, a, s, o, l, u) {
                const c = this.length;
                return this.resize(c + 1), this.emplace(c, t1, e1, r, n, i, a, s, o, l, u);
            }
            emplace(t1, e1, r, n, i, a, s, o, l, u, c) {
                const h = 10 * t1;
                return this.uint16[h + 0] = e1, this.uint16[h + 1] = r, this.uint16[h + 2] = n, this.uint16[h + 3] = i, this.uint16[h + 4] = a, this.uint16[h + 5] = s, this.uint16[h + 6] = o, this.uint16[h + 7] = l, this.uint16[h + 8] = u, this.uint16[h + 9] = c, t1;
            }
        }
        Ii.prototype.bytesPerElement = 20, Mn("StructArrayLayout10ui20", Ii);
        class Mi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, a, s, o, l, u, c, h) {
                const p = this.length;
                return this.resize(p + 1), this.emplace(p, t1, e1, r, n, i, a, s, o, l, u, c, h);
            }
            emplace(t1, e1, r, n, i, a, s, o, l, u, c, h, p) {
                const f = 12 * t1;
                return this.int16[f + 0] = e1, this.int16[f + 1] = r, this.int16[f + 2] = n, this.int16[f + 3] = i, this.uint16[f + 4] = a, this.uint16[f + 5] = s, this.uint16[f + 6] = o, this.uint16[f + 7] = l, this.int16[f + 8] = u, this.int16[f + 9] = c, this.int16[f + 10] = h, this.int16[f + 11] = p, t1;
            }
        }
        Mi.prototype.bytesPerElement = 24, Mn("StructArrayLayout4i4ui4i24", Mi);
        class zi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r) {
                const n = this.length;
                return this.resize(n + 1), this.emplace(n, t1, e1, r);
            }
            emplace(t1, e1, r, n) {
                const i = 3 * t1;
                return this.float32[i + 0] = e1, this.float32[i + 1] = r, this.float32[i + 2] = n, t1;
            }
        }
        zi.prototype.bytesPerElement = 12, Mn("StructArrayLayout3f12", zi);
        class Bi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer);
            }
            emplaceBack(t1) {
                const e1 = this.length;
                return this.resize(e1 + 1), this.emplace(e1, t1);
            }
            emplace(t1, e1) {
                return this.uint32[1 * t1 + 0] = e1, t1;
            }
        }
        Bi.prototype.bytesPerElement = 4, Mn("StructArrayLayout1ul4", Bi);
        class Ci extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, a, s, o, l) {
                const u = this.length;
                return this.resize(u + 1), this.emplace(u, t1, e1, r, n, i, a, s, o, l);
            }
            emplace(t1, e1, r, n, i, a, s, o, l, u) {
                const c = 10 * t1, h = 5 * t1;
                return this.int16[c + 0] = e1, this.int16[c + 1] = r, this.int16[c + 2] = n, this.int16[c + 3] = i, this.int16[c + 4] = a, this.int16[c + 5] = s, this.uint32[h + 3] = o, this.uint16[c + 8] = l, this.uint16[c + 9] = u, t1;
            }
        }
        Ci.prototype.bytesPerElement = 20, Mn("StructArrayLayout6i1ul2ui20", Ci);
        class Pi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, a) {
                const s = this.length;
                return this.resize(s + 1), this.emplace(s, t1, e1, r, n, i, a);
            }
            emplace(t1, e1, r, n, i, a, s) {
                const o = 6 * t1;
                return this.int16[o + 0] = e1, this.int16[o + 1] = r, this.int16[o + 2] = n, this.int16[o + 3] = i, this.int16[o + 4] = a, this.int16[o + 5] = s, t1;
            }
        }
        Pi.prototype.bytesPerElement = 12, Mn("StructArrayLayout2i2i2i12", Pi);
        class Vi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i) {
                const a = this.length;
                return this.resize(a + 1), this.emplace(a, t1, e1, r, n, i);
            }
            emplace(t1, e1, r, n, i, a) {
                const s = 4 * t1, o = 8 * t1;
                return this.float32[s + 0] = e1, this.float32[s + 1] = r, this.float32[s + 2] = n, this.int16[o + 6] = i, this.int16[o + 7] = a, t1;
            }
        }
        Vi.prototype.bytesPerElement = 16, Mn("StructArrayLayout2f1f2i16", Vi);
        class Ei extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n) {
                const i = this.length;
                return this.resize(i + 1), this.emplace(i, t1, e1, r, n);
            }
            emplace(t1, e1, r, n, i) {
                const a = 12 * t1, s = 3 * t1;
                return this.uint8[a + 0] = e1, this.uint8[a + 1] = r, this.float32[s + 1] = n, this.float32[s + 2] = i, t1;
            }
        }
        Ei.prototype.bytesPerElement = 12, Mn("StructArrayLayout2ub2f12", Ei);
        class Fi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r) {
                const n = this.length;
                return this.resize(n + 1), this.emplace(n, t1, e1, r);
            }
            emplace(t1, e1, r, n) {
                const i = 3 * t1;
                return this.uint16[i + 0] = e1, this.uint16[i + 1] = r, this.uint16[i + 2] = n, t1;
            }
        }
        Fi.prototype.bytesPerElement = 6, Mn("StructArrayLayout3ui6", Fi);
        class Ti extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, a, s, o, l, u, c, h, p, f, d, y, m) {
                const g = this.length;
                return this.resize(g + 1), this.emplace(g, t1, e1, r, n, i, a, s, o, l, u, c, h, p, f, d, y, m);
            }
            emplace(t1, e1, r, n, i, a, s, o, l, u, c, h, p, f, d, y, m, g) {
                const x = 24 * t1, v = 12 * t1, b = 48 * t1;
                return this.int16[x + 0] = e1, this.int16[x + 1] = r, this.uint16[x + 2] = n, this.uint16[x + 3] = i, this.uint32[v + 2] = a, this.uint32[v + 3] = s, this.uint32[v + 4] = o, this.uint16[x + 10] = l, this.uint16[x + 11] = u, this.uint16[x + 12] = c, this.float32[v + 7] = h, this.float32[v + 8] = p, this.uint8[b + 36] = f, this.uint8[b + 37] = d, this.uint8[b + 38] = y, this.uint32[v + 10] = m, this.int16[x + 22] = g, t1;
            }
        }
        Ti.prototype.bytesPerElement = 48, Mn("StructArrayLayout2i2ui3ul3ui2f3ub1ul1i48", Ti);
        class Li extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n, i, a, s, o, l, u, c, h, p, f, d, y, m, g, x, v, b, w, _, A, k, S, I, M) {
                const z = this.length;
                return this.resize(z + 1), this.emplace(z, t1, e1, r, n, i, a, s, o, l, u, c, h, p, f, d, y, m, g, x, v, b, w, _, A, k, S, I, M);
            }
            emplace(t1, e1, r, n, i, a, s, o, l, u, c, h, p, f, d, y, m, g, x, v, b, w, _, A, k, S, I, M, z) {
                const B = 34 * t1, C = 17 * t1;
                return this.int16[B + 0] = e1, this.int16[B + 1] = r, this.int16[B + 2] = n, this.int16[B + 3] = i, this.int16[B + 4] = a, this.int16[B + 5] = s, this.int16[B + 6] = o, this.int16[B + 7] = l, this.uint16[B + 8] = u, this.uint16[B + 9] = c, this.uint16[B + 10] = h, this.uint16[B + 11] = p, this.uint16[B + 12] = f, this.uint16[B + 13] = d, this.uint16[B + 14] = y, this.uint16[B + 15] = m, this.uint16[B + 16] = g, this.uint16[B + 17] = x, this.uint16[B + 18] = v, this.uint16[B + 19] = b, this.uint16[B + 20] = w, this.uint16[B + 21] = _, this.uint16[B + 22] = A, this.uint32[C + 12] = k, this.float32[C + 13] = S, this.float32[C + 14] = I, this.float32[C + 15] = M, this.float32[C + 16] = z, t1;
            }
        }
        Li.prototype.bytesPerElement = 68, Mn("StructArrayLayout8i15ui1ul4f68", Li);
        class Di extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1) {
                const e1 = this.length;
                return this.resize(e1 + 1), this.emplace(e1, t1);
            }
            emplace(t1, e1) {
                return this.float32[1 * t1 + 0] = e1, t1;
            }
        }
        Di.prototype.bytesPerElement = 4, Mn("StructArrayLayout1f4", Di);
        class $i extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.int16 = new Int16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r) {
                const n = this.length;
                return this.resize(n + 1), this.emplace(n, t1, e1, r);
            }
            emplace(t1, e1, r, n) {
                const i = 3 * t1;
                return this.int16[i + 0] = e1, this.int16[i + 1] = r, this.int16[i + 2] = n, t1;
            }
        }
        $i.prototype.bytesPerElement = 6, Mn("StructArrayLayout3i6", $i);
        class Ri extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint32 = new Uint32Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r) {
                const n = this.length;
                return this.resize(n + 1), this.emplace(n, t1, e1, r);
            }
            emplace(t1, e1, r, n) {
                const i = 4 * t1;
                return this.uint32[2 * t1 + 0] = e1, this.uint16[i + 2] = r, this.uint16[i + 3] = n, t1;
            }
        }
        Ri.prototype.bytesPerElement = 8, Mn("StructArrayLayout1ul2ui8", Ri);
        class Oi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1) {
                const r = this.length;
                return this.resize(r + 1), this.emplace(r, t1, e1);
            }
            emplace(t1, e1, r) {
                const n = 2 * t1;
                return this.uint16[n + 0] = e1, this.uint16[n + 1] = r, t1;
            }
        }
        Oi.prototype.bytesPerElement = 4, Mn("StructArrayLayout2ui4", Oi);
        class Ui extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.uint16 = new Uint16Array(this.arrayBuffer);
            }
            emplaceBack(t1) {
                const e1 = this.length;
                return this.resize(e1 + 1), this.emplace(e1, t1);
            }
            emplace(t1, e1) {
                return this.uint16[1 * t1 + 0] = e1, t1;
            }
        }
        Ui.prototype.bytesPerElement = 2, Mn("StructArrayLayout1ui2", Ui);
        class qi extends xi {
            _refreshViews() {
                this.uint8 = new Uint8Array(this.arrayBuffer), this.float32 = new Float32Array(this.arrayBuffer);
            }
            emplaceBack(t1, e1, r, n) {
                const i = this.length;
                return this.resize(i + 1), this.emplace(i, t1, e1, r, n);
            }
            emplace(t1, e1, r, n, i) {
                const a = 4 * t1;
                return this.float32[a + 0] = e1, this.float32[a + 1] = r, this.float32[a + 2] = n, this.float32[a + 3] = i, t1;
            }
        }
        qi.prototype.bytesPerElement = 16, Mn("StructArrayLayout4f16", qi);
        class ji extends gi {
            get anchorPointX() {
                return this._structArray.int16[this._pos2 + 0];
            }
            get anchorPointY() {
                return this._structArray.int16[this._pos2 + 1];
            }
            get x1() {
                return this._structArray.int16[this._pos2 + 2];
            }
            get y1() {
                return this._structArray.int16[this._pos2 + 3];
            }
            get x2() {
                return this._structArray.int16[this._pos2 + 4];
            }
            get y2() {
                return this._structArray.int16[this._pos2 + 5];
            }
            get featureIndex() {
                return this._structArray.uint32[this._pos4 + 3];
            }
            get sourceLayerIndex() {
                return this._structArray.uint16[this._pos2 + 8];
            }
            get bucketIndex() {
                return this._structArray.uint16[this._pos2 + 9];
            }
            get anchorPoint() {
                return new S(this.anchorPointX, this.anchorPointY);
            }
        }
        ji.prototype.size = 20;
        class Ni extends Ci {
            get(t1) {
                return new ji(this, t1);
            }
        }
        Mn("CollisionBoxArray", Ni);
        class Zi extends gi {
            get anchorX() {
                return this._structArray.int16[this._pos2 + 0];
            }
            get anchorY() {
                return this._structArray.int16[this._pos2 + 1];
            }
            get glyphStartIndex() {
                return this._structArray.uint16[this._pos2 + 2];
            }
            get numGlyphs() {
                return this._structArray.uint16[this._pos2 + 3];
            }
            get vertexStartIndex() {
                return this._structArray.uint32[this._pos4 + 2];
            }
            get lineStartIndex() {
                return this._structArray.uint32[this._pos4 + 3];
            }
            get lineLength() {
                return this._structArray.uint32[this._pos4 + 4];
            }
            get segment() {
                return this._structArray.uint16[this._pos2 + 10];
            }
            get lowerSize() {
                return this._structArray.uint16[this._pos2 + 11];
            }
            get upperSize() {
                return this._structArray.uint16[this._pos2 + 12];
            }
            get lineOffsetX() {
                return this._structArray.float32[this._pos4 + 7];
            }
            get lineOffsetY() {
                return this._structArray.float32[this._pos4 + 8];
            }
            get writingMode() {
                return this._structArray.uint8[this._pos1 + 36];
            }
            get placedOrientation() {
                return this._structArray.uint8[this._pos1 + 37];
            }
            set placedOrientation(t1) {
                this._structArray.uint8[this._pos1 + 37] = t1;
            }
            get hidden() {
                return this._structArray.uint8[this._pos1 + 38];
            }
            set hidden(t1) {
                this._structArray.uint8[this._pos1 + 38] = t1;
            }
            get crossTileID() {
                return this._structArray.uint32[this._pos4 + 10];
            }
            set crossTileID(t1) {
                this._structArray.uint32[this._pos4 + 10] = t1;
            }
            get associatedIconIndex() {
                return this._structArray.int16[this._pos2 + 22];
            }
        }
        Zi.prototype.size = 48;
        class Ki extends Ti {
            get(t1) {
                return new Zi(this, t1);
            }
        }
        Mn("PlacedSymbolArray", Ki);
        class Gi extends gi {
            get anchorX() {
                return this._structArray.int16[this._pos2 + 0];
            }
            get anchorY() {
                return this._structArray.int16[this._pos2 + 1];
            }
            get rightJustifiedTextSymbolIndex() {
                return this._structArray.int16[this._pos2 + 2];
            }
            get centerJustifiedTextSymbolIndex() {
                return this._structArray.int16[this._pos2 + 3];
            }
            get leftJustifiedTextSymbolIndex() {
                return this._structArray.int16[this._pos2 + 4];
            }
            get verticalPlacedTextSymbolIndex() {
                return this._structArray.int16[this._pos2 + 5];
            }
            get placedIconSymbolIndex() {
                return this._structArray.int16[this._pos2 + 6];
            }
            get verticalPlacedIconSymbolIndex() {
                return this._structArray.int16[this._pos2 + 7];
            }
            get key() {
                return this._structArray.uint16[this._pos2 + 8];
            }
            get textBoxStartIndex() {
                return this._structArray.uint16[this._pos2 + 9];
            }
            get textBoxEndIndex() {
                return this._structArray.uint16[this._pos2 + 10];
            }
            get verticalTextBoxStartIndex() {
                return this._structArray.uint16[this._pos2 + 11];
            }
            get verticalTextBoxEndIndex() {
                return this._structArray.uint16[this._pos2 + 12];
            }
            get iconBoxStartIndex() {
                return this._structArray.uint16[this._pos2 + 13];
            }
            get iconBoxEndIndex() {
                return this._structArray.uint16[this._pos2 + 14];
            }
            get verticalIconBoxStartIndex() {
                return this._structArray.uint16[this._pos2 + 15];
            }
            get verticalIconBoxEndIndex() {
                return this._structArray.uint16[this._pos2 + 16];
            }
            get featureIndex() {
                return this._structArray.uint16[this._pos2 + 17];
            }
            get numHorizontalGlyphVertices() {
                return this._structArray.uint16[this._pos2 + 18];
            }
            get numVerticalGlyphVertices() {
                return this._structArray.uint16[this._pos2 + 19];
            }
            get numIconVertices() {
                return this._structArray.uint16[this._pos2 + 20];
            }
            get numVerticalIconVertices() {
                return this._structArray.uint16[this._pos2 + 21];
            }
            get useRuntimeCollisionCircles() {
                return this._structArray.uint16[this._pos2 + 22];
            }
            get crossTileID() {
                return this._structArray.uint32[this._pos4 + 12];
            }
            set crossTileID(t1) {
                this._structArray.uint32[this._pos4 + 12] = t1;
            }
            get textBoxScale() {
                return this._structArray.float32[this._pos4 + 13];
            }
            get textOffset0() {
                return this._structArray.float32[this._pos4 + 14];
            }
            get textOffset1() {
                return this._structArray.float32[this._pos4 + 15];
            }
            get collisionCircleDiameter() {
                return this._structArray.float32[this._pos4 + 16];
            }
        }
        Gi.prototype.size = 68;
        class Ji extends Li {
            get(t1) {
                return new Gi(this, t1);
            }
        }
        Mn("SymbolInstanceArray", Ji);
        class Xi extends Di {
            getoffsetX(t1) {
                return this.float32[1 * t1 + 0];
            }
        }
        Mn("GlyphOffsetArray", Xi);
        class Yi extends $i {
            getx(t1) {
                return this.int16[3 * t1 + 0];
            }
            gety(t1) {
                return this.int16[3 * t1 + 1];
            }
            gettileUnitDistanceFromAnchor(t1) {
                return this.int16[3 * t1 + 2];
            }
        }
        Mn("SymbolLineVertexArray", Yi);
        class Hi extends gi {
            get featureIndex() {
                return this._structArray.uint32[this._pos4 + 0];
            }
            get sourceLayerIndex() {
                return this._structArray.uint16[this._pos2 + 2];
            }
            get bucketIndex() {
                return this._structArray.uint16[this._pos2 + 3];
            }
        }
        Hi.prototype.size = 8;
        class Wi extends Ri {
            get(t1) {
                return new Hi(this, t1);
            }
        }
        Mn("FeatureIndexArray", Wi);
        class Qi extends wi {
        }
        class ta extends wi {
        }
        class ea extends wi {
        }
        class ra extends Ai {
        }
        class na extends ki {
        }
        class ia extends Si {
        }
        class aa extends Ii {
        }
        class sa extends Mi {
        }
        class oa extends zi {
        }
        class la extends Bi {
        }
        class ua extends Pi {
        }
        class ca extends Ei {
        }
        class ha extends Fi {
        }
        class pa extends Oi {
        }
        const fa = vi([
            {
                name: "a_pos",
                components: 2,
                type: "Int16"
            }
        ], 4), { members: da  } = fa;
        class ya {
            constructor(t1 = []){
                this.segments = t1;
            }
            prepareSegment(t1, e1, r, n) {
                let i = this.segments[this.segments.length - 1];
                return t1 > ya.MAX_VERTEX_ARRAY_LENGTH && d(`Max vertices per segment is ${ya.MAX_VERTEX_ARRAY_LENGTH}: bucket requested ${t1}`), (!i || i.vertexLength + t1 > ya.MAX_VERTEX_ARRAY_LENGTH || i.sortKey !== n) && (i = {
                    vertexOffset: e1.length,
                    primitiveOffset: r.length,
                    vertexLength: 0,
                    primitiveLength: 0
                }, void 0 !== n && (i.sortKey = n), this.segments.push(i)), i;
            }
            get() {
                return this.segments;
            }
            destroy() {
                for (const t1 of this.segments)for(const e1 in t1.vaos)t1.vaos[e1].destroy();
            }
            static simpleSegment(t1, e1, r, n) {
                return new ya([
                    {
                        vertexOffset: t1,
                        primitiveOffset: e1,
                        vertexLength: r,
                        primitiveLength: n,
                        vaos: {},
                        sortKey: 0
                    }
                ]);
            }
        }
        function ma(t1, e1) {
            return 256 * (t1 = a(Math.floor(t1), 0, 255)) + a(Math.floor(e1), 0, 255);
        }
        ya.MAX_VERTEX_ARRAY_LENGTH = Math.pow(2, 16) - 1, Mn("SegmentVector", ya);
        const ga = vi([
            {
                name: "a_pattern_from",
                components: 4,
                type: "Uint16"
            },
            {
                name: "a_pattern_to",
                components: 4,
                type: "Uint16"
            },
            {
                name: "a_pixel_ratio_from",
                components: 1,
                type: "Uint16"
            },
            {
                name: "a_pixel_ratio_to",
                components: 1,
                type: "Uint16"
            }
        ]);
        var xa = {
            exports: {}
        }, va = {
            exports: {}
        };
        va.exports = function(t1, e1) {
            var r, n, i, a, s, o, l, u;
            for(n = t1.length - (r = 3 & t1.length), i = e1, s = 3432918353, o = 461845907, u = 0; u < n;)l = 255 & t1.charCodeAt(u) | (255 & t1.charCodeAt(++u)) << 8 | (255 & t1.charCodeAt(++u)) << 16 | (255 & t1.charCodeAt(++u)) << 24, ++u, i = 27492 + (65535 & (a = 5 * (65535 & (i = (i ^= l = (65535 & (l = (l = (65535 & l) * s + (((l >>> 16) * s & 65535) << 16) & 4294967295) << 15 | l >>> 17)) * o + (((l >>> 16) * o & 65535) << 16) & 4294967295) << 13 | i >>> 19)) + ((5 * (i >>> 16) & 65535) << 16) & 4294967295)) + ((58964 + (a >>> 16) & 65535) << 16);
            switch(l = 0, r){
                case 3:
                    l ^= (255 & t1.charCodeAt(u + 2)) << 16;
                case 2:
                    l ^= (255 & t1.charCodeAt(u + 1)) << 8;
                case 1:
                    i ^= l = (65535 & (l = (l = (65535 & (l ^= 255 & t1.charCodeAt(u))) * s + (((l >>> 16) * s & 65535) << 16) & 4294967295) << 15 | l >>> 17)) * o + (((l >>> 16) * o & 65535) << 16) & 4294967295;
            }
            return i ^= t1.length, i = 2246822507 * (65535 & (i ^= i >>> 16)) + ((2246822507 * (i >>> 16) & 65535) << 16) & 4294967295, i = 3266489909 * (65535 & (i ^= i >>> 13)) + ((3266489909 * (i >>> 16) & 65535) << 16) & 4294967295, (i ^= i >>> 16) >>> 0;
        };
        var ba = {
            exports: {}
        };
        ba.exports = function(t1, e1) {
            for(var r, n = t1.length, i = e1 ^ n, a = 0; n >= 4;)r = 1540483477 * (65535 & (r = 255 & t1.charCodeAt(a) | (255 & t1.charCodeAt(++a)) << 8 | (255 & t1.charCodeAt(++a)) << 16 | (255 & t1.charCodeAt(++a)) << 24)) + ((1540483477 * (r >>> 16) & 65535) << 16), i = 1540483477 * (65535 & i) + ((1540483477 * (i >>> 16) & 65535) << 16) ^ (r = 1540483477 * (65535 & (r ^= r >>> 24)) + ((1540483477 * (r >>> 16) & 65535) << 16)), n -= 4, ++a;
            switch(n){
                case 3:
                    i ^= (255 & t1.charCodeAt(a + 2)) << 16;
                case 2:
                    i ^= (255 & t1.charCodeAt(a + 1)) << 8;
                case 1:
                    i = 1540483477 * (65535 & (i ^= 255 & t1.charCodeAt(a))) + ((1540483477 * (i >>> 16) & 65535) << 16);
            }
            return i = 1540483477 * (65535 & (i ^= i >>> 13)) + ((1540483477 * (i >>> 16) & 65535) << 16), (i ^= i >>> 15) >>> 0;
        };
        var wa = va.exports, _a = ba.exports;
        xa.exports = wa, xa.exports.murmur3 = wa, xa.exports.murmur2 = _a;
        class Aa {
            constructor(){
                this.ids = [], this.positions = [], this.indexed = !1;
            }
            add(t1, e1, r, n) {
                this.ids.push(ka(t1)), this.positions.push(e1, r, n);
            }
            getPositions(t1) {
                if (!this.indexed) throw new Error("Trying to get index, but feature positions are not indexed");
                const e1 = ka(t1);
                let r = 0, n = this.ids.length - 1;
                for(; r < n;){
                    const t2 = r + n >> 1;
                    this.ids[t2] >= e1 ? n = t2 : r = t2 + 1;
                }
                const i = [];
                for(; this.ids[r] === e1;)i.push({
                    index: this.positions[3 * r],
                    start: this.positions[3 * r + 1],
                    end: this.positions[3 * r + 2]
                }), r++;
                return i;
            }
            static serialize(t1, e1) {
                const r = new Float64Array(t1.ids), n = new Uint32Array(t1.positions);
                return Sa(r, n, 0, r.length - 1), e1 && e1.push(r.buffer, n.buffer), {
                    ids: r,
                    positions: n
                };
            }
            static deserialize(t1) {
                const e1 = new Aa;
                return e1.ids = t1.ids, e1.positions = t1.positions, e1.indexed = !0, e1;
            }
        }
        function ka(t1) {
            const e1 = +t1;
            return !isNaN(e1) && e1 <= Number.MAX_SAFE_INTEGER ? e1 : xa.exports(String(t1));
        }
        function Sa(t1, e1, r, n) {
            for(; r < n;){
                const i = t1[r + n >> 1];
                let a = r - 1, s = n + 1;
                for(;;){
                    do a++;
                    while (t1[a] < i);
                    do s--;
                    while (t1[s] > i);
                    if (a >= s) break;
                    Ia(t1, a, s), Ia(e1, 3 * a, 3 * s), Ia(e1, 3 * a + 1, 3 * s + 1), Ia(e1, 3 * a + 2, 3 * s + 2);
                }
                s - r < n - s ? (Sa(t1, e1, r, s), r = s + 1) : (Sa(t1, e1, s + 1, n), n = s);
            }
        }
        function Ia(t1, e1, r) {
            const n = t1[e1];
            t1[e1] = t1[r], t1[r] = n;
        }
        Mn("FeaturePositionMap", Aa);
        class Ma {
            constructor(t1, e1){
                this.gl = t1.gl, this.location = e1;
            }
        }
        class za extends Ma {
            constructor(t1, e1){
                super(t1, e1), this.current = 0;
            }
            set(t1) {
                this.current !== t1 && (this.current = t1, this.gl.uniform1f(this.location, t1));
            }
        }
        class Ba extends Ma {
            constructor(t1, e1){
                super(t1, e1), this.current = [
                    0,
                    0,
                    0,
                    0
                ];
            }
            set(t1) {
                t1[0] === this.current[0] && t1[1] === this.current[1] && t1[2] === this.current[2] && t1[3] === this.current[3] || (this.current = t1, this.gl.uniform4f(this.location, t1[0], t1[1], t1[2], t1[3]));
            }
        }
        class Ca extends Ma {
            constructor(t1, e1){
                super(t1, e1), this.current = Ft.transparent;
            }
            set(t1) {
                t1.r === this.current.r && t1.g === this.current.g && t1.b === this.current.b && t1.a === this.current.a || (this.current = t1, this.gl.uniform4f(this.location, t1.r, t1.g, t1.b, t1.a));
            }
        }
        const Pa = new Float32Array(16);
        function Va(t1) {
            return [
                ma(255 * t1.r, 255 * t1.g),
                ma(255 * t1.b, 255 * t1.a)
            ];
        }
        class Ea {
            constructor(t1, e1, r){
                this.value = t1, this.uniformNames = e1.map((t1)=>`u_${t1}`), this.type = r;
            }
            setUniform(t1, e1, r) {
                t1.set(r.constantOr(this.value));
            }
            getBinding(t1, e1, r) {
                return "color" === this.type ? new Ca(t1, e1) : new za(t1, e1);
            }
        }
        class Fa {
            constructor(t1, e1){
                this.uniformNames = e1.map((t1)=>`u_${t1}`), this.patternFrom = null, this.patternTo = null, this.pixelRatioFrom = 1, this.pixelRatioTo = 1;
            }
            setConstantPatternPositions(t1, e1) {
                this.pixelRatioFrom = e1.pixelRatio, this.pixelRatioTo = t1.pixelRatio, this.patternFrom = e1.tlbr, this.patternTo = t1.tlbr;
            }
            setUniform(t1, e1, r, n) {
                const i = "u_pattern_to" === n ? this.patternTo : "u_pattern_from" === n ? this.patternFrom : "u_pixel_ratio_to" === n ? this.pixelRatioTo : "u_pixel_ratio_from" === n ? this.pixelRatioFrom : null;
                i && t1.set(i);
            }
            getBinding(t1, e1, r) {
                return "u_pattern" === r.substr(0, 9) ? new Ba(t1, e1) : new za(t1, e1);
            }
        }
        class Ta {
            constructor(t1, e1, r, n){
                this.expression = t1, this.type = r, this.maxValue = 0, this.paintVertexAttributes = e1.map((t1)=>({
                        name: `a_${t1}`,
                        type: "Float32",
                        components: "color" === r ? 2 : 1,
                        offset: 0
                    })), this.paintVertexArray = new n;
            }
            populatePaintArray(t1, e1, r, n, i) {
                const a = this.paintVertexArray.length, s = this.expression.evaluate(new Qn(0), e1, {}, n, [], i);
                this.paintVertexArray.resize(t1), this._setPaintValue(a, t1, s);
            }
            updatePaintArray(t1, e1, r, n) {
                const i = this.expression.evaluate({
                    zoom: 0
                }, r, n);
                this._setPaintValue(t1, e1, i);
            }
            _setPaintValue(t1, e1, r) {
                if ("color" === this.type) {
                    const n = Va(r);
                    for(let r1 = t1; r1 < e1; r1++)this.paintVertexArray.emplace(r1, n[0], n[1]);
                } else {
                    for(let n1 = t1; n1 < e1; n1++)this.paintVertexArray.emplace(n1, r);
                    this.maxValue = Math.max(this.maxValue, Math.abs(r));
                }
            }
            upload(t1) {
                this.paintVertexArray && this.paintVertexArray.arrayBuffer && (this.paintVertexBuffer && this.paintVertexBuffer.buffer ? this.paintVertexBuffer.updateData(this.paintVertexArray) : this.paintVertexBuffer = t1.createVertexBuffer(this.paintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent));
            }
            destroy() {
                this.paintVertexBuffer && this.paintVertexBuffer.destroy();
            }
        }
        class La {
            constructor(t1, e1, r, n, i, a){
                this.expression = t1, this.uniformNames = e1.map((t1)=>`u_${t1}_t`), this.type = r, this.useIntegerZoom = n, this.zoom = i, this.maxValue = 0, this.paintVertexAttributes = e1.map((t1)=>({
                        name: `a_${t1}`,
                        type: "Float32",
                        components: "color" === r ? 4 : 2,
                        offset: 0
                    })), this.paintVertexArray = new a;
            }
            populatePaintArray(t1, e1, r, n, i) {
                const a = this.expression.evaluate(new Qn(this.zoom), e1, {}, n, [], i), s = this.expression.evaluate(new Qn(this.zoom + 1), e1, {}, n, [], i), o = this.paintVertexArray.length;
                this.paintVertexArray.resize(t1), this._setPaintValue(o, t1, a, s);
            }
            updatePaintArray(t1, e1, r, n) {
                const i = this.expression.evaluate({
                    zoom: this.zoom
                }, r, n), a = this.expression.evaluate({
                    zoom: this.zoom + 1
                }, r, n);
                this._setPaintValue(t1, e1, i, a);
            }
            _setPaintValue(t1, e1, r, n) {
                if ("color" === this.type) {
                    const i = Va(r), a = Va(n);
                    for(let r1 = t1; r1 < e1; r1++)this.paintVertexArray.emplace(r1, i[0], i[1], a[0], a[1]);
                } else {
                    for(let i1 = t1; i1 < e1; i1++)this.paintVertexArray.emplace(i1, r, n);
                    this.maxValue = Math.max(this.maxValue, Math.abs(r), Math.abs(n));
                }
            }
            upload(t1) {
                this.paintVertexArray && this.paintVertexArray.arrayBuffer && (this.paintVertexBuffer && this.paintVertexBuffer.buffer ? this.paintVertexBuffer.updateData(this.paintVertexArray) : this.paintVertexBuffer = t1.createVertexBuffer(this.paintVertexArray, this.paintVertexAttributes, this.expression.isStateDependent));
            }
            destroy() {
                this.paintVertexBuffer && this.paintVertexBuffer.destroy();
            }
            setUniform(t1, e1) {
                const r = this.useIntegerZoom ? Math.floor(e1.zoom) : e1.zoom, n = a(this.expression.interpolationFactor(r, this.zoom, this.zoom + 1), 0, 1);
                t1.set(n);
            }
            getBinding(t1, e1, r) {
                return new za(t1, e1);
            }
        }
        class Da {
            constructor(t1, e1, r, n, i, a){
                this.expression = t1, this.type = e1, this.useIntegerZoom = r, this.zoom = n, this.layerId = a, this.zoomInPaintVertexArray = new i, this.zoomOutPaintVertexArray = new i;
            }
            populatePaintArray(t1, e1, r) {
                const n = this.zoomInPaintVertexArray.length;
                this.zoomInPaintVertexArray.resize(t1), this.zoomOutPaintVertexArray.resize(t1), this._setPaintValues(n, t1, e1.patterns && e1.patterns[this.layerId], r);
            }
            updatePaintArray(t1, e1, r, n, i) {
                this._setPaintValues(t1, e1, r.patterns && r.patterns[this.layerId], i);
            }
            _setPaintValues(t1, e1, r, n) {
                if (!n || !r) return;
                const { min: i , mid: a , max: s  } = r, o = n[i], l = n[a], u = n[s];
                if (o && l && u) for(let r1 = t1; r1 < e1; r1++)this.zoomInPaintVertexArray.emplace(r1, l.tl[0], l.tl[1], l.br[0], l.br[1], o.tl[0], o.tl[1], o.br[0], o.br[1], l.pixelRatio, o.pixelRatio), this.zoomOutPaintVertexArray.emplace(r1, l.tl[0], l.tl[1], l.br[0], l.br[1], u.tl[0], u.tl[1], u.br[0], u.br[1], l.pixelRatio, u.pixelRatio);
            }
            upload(t1) {
                this.zoomInPaintVertexArray && this.zoomInPaintVertexArray.arrayBuffer && this.zoomOutPaintVertexArray && this.zoomOutPaintVertexArray.arrayBuffer && (this.zoomInPaintVertexBuffer = t1.createVertexBuffer(this.zoomInPaintVertexArray, ga.members, this.expression.isStateDependent), this.zoomOutPaintVertexBuffer = t1.createVertexBuffer(this.zoomOutPaintVertexArray, ga.members, this.expression.isStateDependent));
            }
            destroy() {
                this.zoomOutPaintVertexBuffer && this.zoomOutPaintVertexBuffer.destroy(), this.zoomInPaintVertexBuffer && this.zoomInPaintVertexBuffer.destroy();
            }
        }
        class $a {
            constructor(t1, e1, r){
                this.binders = {}, this._buffers = [];
                const n = [];
                for(const i in t1.paint._values){
                    if (!r(i)) continue;
                    const a = t1.paint.get(i);
                    if (!(a instanceof si && br(a.property.specification))) continue;
                    const s = Oa(i, t1.type), o = a.value, l = a.property.specification.type, u = a.property.useIntegerZoom, c = a.property.specification["property-type"], h = "cross-faded" === c || "cross-faded-data-driven" === c;
                    if ("constant" === o.kind) this.binders[i] = h ? new Fa(o.value, s) : new Ea(o.value, s, l), n.push(`/u_${i}`);
                    else if ("source" === o.kind || h) {
                        const r1 = Ua(i, l, "source");
                        this.binders[i] = h ? new Da(o, l, u, e1, r1, t1.id) : new Ta(o, s, l, r1), n.push(`/a_${i}`);
                    } else {
                        const t2 = Ua(i, l, "composite");
                        this.binders[i] = new La(o, s, l, u, e1, t2), n.push(`/z_${i}`);
                    }
                }
                this.cacheKey = n.sort().join("");
            }
            getMaxValue(t1) {
                const e1 = this.binders[t1];
                return e1 instanceof Ta || e1 instanceof La ? e1.maxValue : 0;
            }
            populatePaintArrays(t1, e1, r, n, i) {
                for(const a in this.binders){
                    const s = this.binders[a];
                    (s instanceof Ta || s instanceof La || s instanceof Da) && s.populatePaintArray(t1, e1, r, n, i);
                }
            }
            setConstantPatternPositions(t1, e1) {
                for(const r in this.binders){
                    const n = this.binders[r];
                    n instanceof Fa && n.setConstantPatternPositions(t1, e1);
                }
            }
            updatePaintArrays(t1, e1, r, n, i) {
                let a = !1;
                for(const s in t1){
                    const o = e1.getPositions(s);
                    for (const e2 of o){
                        const o1 = r.feature(e2.index);
                        for(const r1 in this.binders){
                            const l = this.binders[r1];
                            if ((l instanceof Ta || l instanceof La || l instanceof Da) && !0 === l.expression.isStateDependent) {
                                const u = n.paint.get(r1);
                                l.expression = u.value, l.updatePaintArray(e2.start, e2.end, o1, t1[s], i), a = !0;
                            }
                        }
                    }
                }
                return a;
            }
            defines() {
                const t1 = [];
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    (r instanceof Ea || r instanceof Fa) && t1.push(...r.uniformNames.map((t1)=>`#define HAS_UNIFORM_${t1}`));
                }
                return t1;
            }
            getBinderAttributes() {
                const t1 = [];
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    if (r instanceof Ta || r instanceof La) for(let e2 = 0; e2 < r.paintVertexAttributes.length; e2++)t1.push(r.paintVertexAttributes[e2].name);
                    else if (r instanceof Da) for(let e3 = 0; e3 < ga.members.length; e3++)t1.push(ga.members[e3].name);
                }
                return t1;
            }
            getBinderUniforms() {
                const t1 = [];
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    if (r instanceof Ea || r instanceof Fa || r instanceof La) for (const e2 of r.uniformNames)t1.push(e2);
                }
                return t1;
            }
            getPaintVertexBuffers() {
                return this._buffers;
            }
            getUniforms(t1, e1) {
                const r = [];
                for(const n in this.binders){
                    const i = this.binders[n];
                    if (i instanceof Ea || i instanceof Fa || i instanceof La) {
                        for (const a of i.uniformNames)if (e1[a]) {
                            const s = i.getBinding(t1, e1[a], a);
                            r.push({
                                name: a,
                                property: n,
                                binding: s
                            });
                        }
                    }
                }
                return r;
            }
            setUniforms(t1, e1, r, n) {
                for (const { name: t2 , property: i , binding: a  } of e1)this.binders[i].setUniform(a, n, r.get(i), t2);
            }
            updatePaintBuffers(t1) {
                this._buffers = [];
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    if (t1 && r instanceof Da) {
                        const e2 = 2 === t1.fromScale ? r.zoomInPaintVertexBuffer : r.zoomOutPaintVertexBuffer;
                        e2 && this._buffers.push(e2);
                    } else (r instanceof Ta || r instanceof La) && r.paintVertexBuffer && this._buffers.push(r.paintVertexBuffer);
                }
            }
            upload(t1) {
                for(const e1 in this.binders){
                    const r = this.binders[e1];
                    (r instanceof Ta || r instanceof La || r instanceof Da) && r.upload(t1);
                }
                this.updatePaintBuffers();
            }
            destroy() {
                for(const t1 in this.binders){
                    const e1 = this.binders[t1];
                    (e1 instanceof Ta || e1 instanceof La || e1 instanceof Da) && e1.destroy();
                }
            }
        }
        class Ra {
            constructor(t1, e1, r = ()=>!0){
                this.programConfigurations = {};
                for (const n of t1)this.programConfigurations[n.id] = new $a(n, e1, r);
                this.needsUpload = !1, this._featureMap = new Aa, this._bufferOffset = 0;
            }
            populatePaintArrays(t1, e1, r, n, i, a) {
                for(const r1 in this.programConfigurations)this.programConfigurations[r1].populatePaintArrays(t1, e1, n, i, a);
                void 0 !== e1.id && this._featureMap.add(e1.id, r, this._bufferOffset, t1), this._bufferOffset = t1, this.needsUpload = !0;
            }
            updatePaintArrays(t1, e1, r, n) {
                for (const i of r)this.needsUpload = this.programConfigurations[i.id].updatePaintArrays(t1, this._featureMap, e1, i, n) || this.needsUpload;
            }
            get(t1) {
                return this.programConfigurations[t1];
            }
            upload(t1) {
                if (this.needsUpload) {
                    for(const e1 in this.programConfigurations)this.programConfigurations[e1].upload(t1);
                    this.needsUpload = !1;
                }
            }
            destroy() {
                for(const t1 in this.programConfigurations)this.programConfigurations[t1].destroy();
            }
        }
        function Oa(t1, e1) {
            return ({
                "text-opacity": [
                    "opacity"
                ],
                "icon-opacity": [
                    "opacity"
                ],
                "text-color": [
                    "fill_color"
                ],
                "icon-color": [
                    "fill_color"
                ],
                "text-halo-color": [
                    "halo_color"
                ],
                "icon-halo-color": [
                    "halo_color"
                ],
                "text-halo-blur": [
                    "halo_blur"
                ],
                "icon-halo-blur": [
                    "halo_blur"
                ],
                "text-halo-width": [
                    "halo_width"
                ],
                "icon-halo-width": [
                    "halo_width"
                ],
                "line-gap-width": [
                    "gapwidth"
                ],
                "line-pattern": [
                    "pattern_to",
                    "pattern_from",
                    "pixel_ratio_to",
                    "pixel_ratio_from"
                ],
                "fill-pattern": [
                    "pattern_to",
                    "pattern_from",
                    "pixel_ratio_to",
                    "pixel_ratio_from"
                ],
                "fill-extrusion-pattern": [
                    "pattern_to",
                    "pattern_from",
                    "pixel_ratio_to",
                    "pixel_ratio_from"
                ]
            })[t1] || [
                t1.replace(`${e1}-`, "").replace(/-/g, "_")
            ];
        }
        function Ua(t1, e1, r) {
            const n = {
                color: {
                    source: Si,
                    composite: qi
                },
                number: {
                    source: Di,
                    composite: Si
                }
            }, i = function(t1) {
                return ({
                    "line-pattern": {
                        source: aa,
                        composite: aa
                    },
                    "fill-pattern": {
                        source: aa,
                        composite: aa
                    },
                    "fill-extrusion-pattern": {
                        source: aa,
                        composite: aa
                    }
                })[t1];
            }(t1);
            return i && i[r] || n[e1][r];
        }
        Mn("ConstantBinder", Ea), Mn("CrossFadedConstantBinder", Fa), Mn("SourceExpressionBinder", Ta), Mn("CrossFadedCompositeBinder", Da), Mn("CompositeExpressionBinder", La), Mn("ProgramConfiguration", $a, {
            omit: [
                "_buffers"
            ]
        }), Mn("ProgramConfigurationSet", Ra);
        var qa = 8192;
        const ja = Math.pow(2, 14) - 1, Na = -ja - 1;
        function Za(t1) {
            const e1 = qa / t1.extent, r = t1.loadGeometry();
            for(let t2 = 0; t2 < r.length; t2++){
                const n = r[t2];
                for(let t3 = 0; t3 < n.length; t3++){
                    const r1 = n[t3], i = Math.round(r1.x * e1), s = Math.round(r1.y * e1);
                    r1.x = a(i, Na, ja), r1.y = a(s, Na, ja), (i < r1.x || i > r1.x + 1 || s < r1.y || s > r1.y + 1) && d("Geometry exceeds allowed extent, reduce your vector tile buffer size");
                }
            }
            return r;
        }
        function Ka(t1, e1) {
            return {
                type: t1.type,
                id: t1.id,
                properties: t1.properties,
                geometry: e1 ? Za(t1) : []
            };
        }
        function Ga(t1, e1, r, n, i) {
            t1.emplaceBack(2 * e1 + (n + 1) / 2, 2 * r + (i + 1) / 2);
        }
        class Ja {
            constructor(t1){
                this.zoom = t1.zoom, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.hasPattern = !1, this.layoutVertexArray = new ta, this.indexArray = new ha, this.segments = new ya, this.programConfigurations = new Ra(t1.layers, t1.zoom), this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id);
            }
            populate(t1, e1, r) {
                const n = this.layers[0], i = [];
                let a = null, s = !1;
                "circle" === n.type && (a = n.layout.get("circle-sort-key"), s = !a.isConstant());
                for (const { feature: e2 , id: n1 , index: o , sourceLayerIndex: l  } of t1){
                    const t2 = this.layers[0]._featureFilter.needGeometry, u = Ka(e2, t2);
                    if (!this.layers[0]._featureFilter.filter(new Qn(this.zoom), u, r)) continue;
                    const c = s ? a.evaluate(u, {}, r) : void 0, h = {
                        id: n1,
                        properties: e2.properties,
                        type: e2.type,
                        sourceLayerIndex: l,
                        index: o,
                        geometry: t2 ? u.geometry : Za(e2),
                        patterns: {},
                        sortKey: c
                    };
                    i.push(h);
                }
                s && i.sort((t1, e1)=>t1.sortKey - e1.sortKey);
                for (const n2 of i){
                    const { geometry: i1 , index: a1 , sourceLayerIndex: s1  } = n2, o1 = t1[a1].feature;
                    this.addFeature(n2, i1, a1, r), e1.featureIndex.insert(o1, i1, a1, s1, this.index);
                }
            }
            update(t1, e1, r) {
                this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t1, e1, this.stateDependentLayers, r);
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length;
            }
            uploadPending() {
                return !this.uploaded || this.programConfigurations.needsUpload;
            }
            upload(t1) {
                this.uploaded || (this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, da), this.indexBuffer = t1.createIndexBuffer(this.indexArray)), this.programConfigurations.upload(t1), this.uploaded = !0;
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy());
            }
            addFeature(t1, e1, r, n) {
                for (const r1 of e1)for (const e2 of r1){
                    const r2 = e2.x, n1 = e2.y;
                    if (r2 < 0 || r2 >= qa || n1 < 0 || n1 >= qa) continue;
                    const i = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray, t1.sortKey), a = i.vertexLength;
                    Ga(this.layoutVertexArray, r2, n1, -1, -1), Ga(this.layoutVertexArray, r2, n1, 1, -1), Ga(this.layoutVertexArray, r2, n1, 1, 1), Ga(this.layoutVertexArray, r2, n1, -1, 1), this.indexArray.emplaceBack(a, a + 1, a + 2), this.indexArray.emplaceBack(a, a + 3, a + 2), i.vertexLength += 4, i.primitiveLength += 2;
                }
                this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t1, r, {}, n);
            }
        }
        function Xa(t1, e1) {
            for(let r = 0; r < t1.length; r++)if (is(e1, t1[r])) return !0;
            for(let r1 = 0; r1 < e1.length; r1++)if (is(t1, e1[r1])) return !0;
            return !!Qa(t1, e1);
        }
        function Ya(t1, e1, r) {
            return !!is(t1, e1) || !!es(e1, t1, r);
        }
        function Ha(t1, e1) {
            if (1 === t1.length) return ns(e1, t1[0]);
            for(let r = 0; r < e1.length; r++){
                const n = e1[r];
                for(let e2 = 0; e2 < n.length; e2++)if (is(t1, n[e2])) return !0;
            }
            for(let r1 = 0; r1 < t1.length; r1++)if (ns(e1, t1[r1])) return !0;
            for(let r2 = 0; r2 < e1.length; r2++)if (Qa(t1, e1[r2])) return !0;
            return !1;
        }
        function Wa(t1, e1, r) {
            if (t1.length > 1) {
                if (Qa(t1, e1)) return !0;
                for(let n = 0; n < e1.length; n++)if (es(e1[n], t1, r)) return !0;
            }
            for(let n1 = 0; n1 < t1.length; n1++)if (es(t1[n1], e1, r)) return !0;
            return !1;
        }
        function Qa(t1, e1) {
            if (0 === t1.length || 0 === e1.length) return !1;
            for(let r = 0; r < t1.length - 1; r++){
                const n = t1[r], i = t1[r + 1];
                for(let t2 = 0; t2 < e1.length - 1; t2++)if (ts(n, i, e1[t2], e1[t2 + 1])) return !0;
            }
            return !1;
        }
        function ts(t1, e1, r, n) {
            return y(t1, r, n) !== y(e1, r, n) && y(t1, e1, r) !== y(t1, e1, n);
        }
        function es(t1, e1, r) {
            const n = r * r;
            if (1 === e1.length) return t1.distSqr(e1[0]) < n;
            for(let r1 = 1; r1 < e1.length; r1++)if (rs(t1, e1[r1 - 1], e1[r1]) < n) return !0;
            return !1;
        }
        function rs(t1, e1, r) {
            const n = e1.distSqr(r);
            if (0 === n) return t1.distSqr(e1);
            const i = ((t1.x - e1.x) * (r.x - e1.x) + (t1.y - e1.y) * (r.y - e1.y)) / n;
            return t1.distSqr(i < 0 ? e1 : i > 1 ? r : r.sub(e1)._mult(i)._add(e1));
        }
        function ns(t1, e1) {
            let r, n, i, a = !1;
            for(let s = 0; s < t1.length; s++){
                r = t1[s];
                for(let t2 = 0, s1 = r.length - 1; t2 < r.length; s1 = t2++)n = r[t2], i = r[s1], n.y > e1.y != i.y > e1.y && e1.x < (i.x - n.x) * (e1.y - n.y) / (i.y - n.y) + n.x && (a = !a);
            }
            return a;
        }
        function is(t1, e1) {
            let r = !1;
            for(let n = 0, i = t1.length - 1; n < t1.length; i = n++){
                const a = t1[n], s = t1[i];
                a.y > e1.y != s.y > e1.y && e1.x < (s.x - a.x) * (e1.y - a.y) / (s.y - a.y) + a.x && (r = !r);
            }
            return r;
        }
        function as(t1, e1, r) {
            const n = r[0], i = r[2];
            if (t1.x < n.x && e1.x < n.x || t1.x > i.x && e1.x > i.x || t1.y < n.y && e1.y < n.y || t1.y > i.y && e1.y > i.y) return !1;
            const a = y(t1, e1, r[0]);
            return a !== y(t1, e1, r[1]) || a !== y(t1, e1, r[2]) || a !== y(t1, e1, r[3]);
        }
        function ss(t1, e1, r) {
            const n = e1.paint.get(t1).value;
            return "constant" === n.kind ? n.value : r.programConfigurations.get(e1.id).getMaxValue(t1);
        }
        function os(t1) {
            return Math.sqrt(t1[0] * t1[0] + t1[1] * t1[1]);
        }
        function ls(t1, e1, r, n, i) {
            if (!e1[0] && !e1[1]) return t1;
            const a = S.convert(e1)._mult(i);
            "viewport" === r && a._rotate(-n);
            const s = [];
            for(let e2 = 0; e2 < t1.length; e2++)s.push(t1[e2].sub(a));
            return s;
        }
        Mn("CircleBucket", Ja, {
            omit: [
                "layers"
            ]
        });
        const us = new fi({
            "circle-sort-key": new ui(nt.layout_circle["circle-sort-key"])
        });
        var cs = {
            paint: new fi({
                "circle-radius": new ui(nt.paint_circle["circle-radius"]),
                "circle-color": new ui(nt.paint_circle["circle-color"]),
                "circle-blur": new ui(nt.paint_circle["circle-blur"]),
                "circle-opacity": new ui(nt.paint_circle["circle-opacity"]),
                "circle-translate": new li(nt.paint_circle["circle-translate"]),
                "circle-translate-anchor": new li(nt.paint_circle["circle-translate-anchor"]),
                "circle-pitch-scale": new li(nt.paint_circle["circle-pitch-scale"]),
                "circle-pitch-alignment": new li(nt.paint_circle["circle-pitch-alignment"]),
                "circle-stroke-width": new ui(nt.paint_circle["circle-stroke-width"]),
                "circle-stroke-color": new ui(nt.paint_circle["circle-stroke-color"]),
                "circle-stroke-opacity": new ui(nt.paint_circle["circle-stroke-opacity"])
            }),
            layout: us
        }, hs = 1e-6, ps = "undefined" != typeof Float32Array ? Float32Array : Array;
        function fs() {
            var t1 = new ps(9);
            return ps != Float32Array && (t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[5] = 0, t1[6] = 0, t1[7] = 0), t1[0] = 1, t1[4] = 1, t1[8] = 1, t1;
        }
        function ds(t1) {
            return t1[0] = 1, t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[5] = 1, t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[10] = 1, t1[11] = 0, t1[12] = 0, t1[13] = 0, t1[14] = 0, t1[15] = 1, t1;
        }
        function ys(t1, e1, r) {
            var n = e1[0], i = e1[1], a = e1[2], s = e1[3], o = e1[4], l = e1[5], u = e1[6], c = e1[7], h = e1[8], p = e1[9], f = e1[10], d = e1[11], y = e1[12], m = e1[13], g = e1[14], x = e1[15], v = r[0], b = r[1], w = r[2], _ = r[3];
            return t1[0] = v * n + b * o + w * h + _ * y, t1[1] = v * i + b * l + w * p + _ * m, t1[2] = v * a + b * u + w * f + _ * g, t1[3] = v * s + b * c + w * d + _ * x, t1[4] = (v = r[4]) * n + (b = r[5]) * o + (w = r[6]) * h + (_ = r[7]) * y, t1[5] = v * i + b * l + w * p + _ * m, t1[6] = v * a + b * u + w * f + _ * g, t1[7] = v * s + b * c + w * d + _ * x, t1[8] = (v = r[8]) * n + (b = r[9]) * o + (w = r[10]) * h + (_ = r[11]) * y, t1[9] = v * i + b * l + w * p + _ * m, t1[10] = v * a + b * u + w * f + _ * g, t1[11] = v * s + b * c + w * d + _ * x, t1[12] = (v = r[12]) * n + (b = r[13]) * o + (w = r[14]) * h + (_ = r[15]) * y, t1[13] = v * i + b * l + w * p + _ * m, t1[14] = v * a + b * u + w * f + _ * g, t1[15] = v * s + b * c + w * d + _ * x, t1;
        }
        Math.hypot || (Math.hypot = function() {
            for(var t1 = 0, e1 = arguments.length; e1--;)t1 += arguments[e1] * arguments[e1];
            return Math.sqrt(t1);
        });
        var ms, gs = ys;
        function xs() {
            var t1 = new ps(3);
            return ps != Float32Array && (t1[0] = 0, t1[1] = 0, t1[2] = 0), t1;
        }
        function vs(t1, e1, r) {
            var n = new ps(3);
            return n[0] = t1, n[1] = e1, n[2] = r, n;
        }
        function bs(t1, e1, r) {
            var n = e1[0], i = e1[1], a = e1[2], s = e1[3];
            return t1[0] = r[0] * n + r[4] * i + r[8] * a + r[12] * s, t1[1] = r[1] * n + r[5] * i + r[9] * a + r[13] * s, t1[2] = r[2] * n + r[6] * i + r[10] * a + r[14] * s, t1[3] = r[3] * n + r[7] * i + r[11] * a + r[15] * s, t1;
        }
        function ws() {
            var t1 = new ps(4);
            return ps != Float32Array && (t1[0] = 0, t1[1] = 0, t1[2] = 0), t1[3] = 1, t1;
        }
        function _s(t1, e1) {
            const r = bs([], [
                t1.x,
                t1.y,
                0,
                1
            ], e1);
            return new S(r[0] / r[3], r[1] / r[3]);
        }
        xs(), ms = new ps(4), ps != Float32Array && (ms[0] = 0, ms[1] = 0, ms[2] = 0, ms[3] = 0), xs(), vs(1, 0, 0), vs(0, 1, 0), ws(), ws(), fs(), function() {
            var t1;
            t1 = new ps(2), ps != Float32Array && (t1[0] = 0, t1[1] = 0);
        }();
        class As extends Ja {
        }
        Mn("HeatmapBucket", As, {
            omit: [
                "layers"
            ]
        });
        var ks = {
            paint: new fi({
                "heatmap-radius": new ui(nt.paint_heatmap["heatmap-radius"]),
                "heatmap-weight": new ui(nt.paint_heatmap["heatmap-weight"]),
                "heatmap-intensity": new li(nt.paint_heatmap["heatmap-intensity"]),
                "heatmap-color": new pi(nt.paint_heatmap["heatmap-color"]),
                "heatmap-opacity": new li(nt.paint_heatmap["heatmap-opacity"])
            })
        };
        function Ss(t1, { width: e1 , height: r  }, n, i) {
            if (i) {
                if (i instanceof Uint8ClampedArray) i = new Uint8Array(i.buffer);
                else if (i.length !== e1 * r * n) throw new RangeError(`mismatched image size. expected: ${i.length} but got: ${e1 * r * n}`);
            } else i = new Uint8Array(e1 * r * n);
            return t1.width = e1, t1.height = r, t1.data = i, t1;
        }
        function Is(t1, { width: e1 , height: r  }, n) {
            if (e1 === t1.width && r === t1.height) return;
            const i = Ss({}, {
                width: e1,
                height: r
            }, n);
            Ms(t1, i, {
                x: 0,
                y: 0
            }, {
                x: 0,
                y: 0
            }, {
                width: Math.min(t1.width, e1),
                height: Math.min(t1.height, r)
            }, n), t1.width = e1, t1.height = r, t1.data = i.data;
        }
        function Ms(t1, e1, r, n, i, a) {
            if (0 === i.width || 0 === i.height) return e1;
            if (i.width > t1.width || i.height > t1.height || r.x > t1.width - i.width || r.y > t1.height - i.height) throw new RangeError("out of range source coordinates for image copy");
            if (i.width > e1.width || i.height > e1.height || n.x > e1.width - i.width || n.y > e1.height - i.height) throw new RangeError("out of range destination coordinates for image copy");
            const s = t1.data, o = e1.data;
            if (s === o) throw new Error("srcData equals dstData, so image is already copied");
            for(let l = 0; l < i.height; l++){
                const u = ((r.y + l) * t1.width + r.x) * a, c = ((n.y + l) * e1.width + n.x) * a;
                for(let t2 = 0; t2 < i.width * a; t2++)o[c + t2] = s[u + t2];
            }
            return e1;
        }
        class zs {
            constructor(t1, e1){
                Ss(this, t1, 1, e1);
            }
            resize(t1) {
                Is(this, t1, 1);
            }
            clone() {
                return new zs({
                    width: this.width,
                    height: this.height
                }, new Uint8Array(this.data));
            }
            static copy(t1, e1, r, n, i) {
                Ms(t1, e1, r, n, i, 1);
            }
        }
        class Bs {
            constructor(t1, e1){
                Ss(this, t1, 4, e1);
            }
            resize(t1) {
                Is(this, t1, 4);
            }
            replace(t1, e1) {
                e1 ? this.data.set(t1) : this.data = t1 instanceof Uint8ClampedArray ? new Uint8Array(t1.buffer) : t1;
            }
            clone() {
                return new Bs({
                    width: this.width,
                    height: this.height
                }, new Uint8Array(this.data));
            }
            static copy(t1, e1, r, n, i) {
                Ms(t1, e1, r, n, i, 4);
            }
        }
        function Cs(t1) {
            const e1 = {}, r = t1.resolution || 256, n = t1.clips ? t1.clips.length : 1, i = t1.image || new Bs({
                width: r,
                height: n
            });
            if (Math.log(r) / Math.LN2 % 1 != 0) throw new Error(`width is not a power of 2 - ${r}`);
            const a = (r, n, a)=>{
                e1[t1.evaluationKey] = a;
                const s = t1.expression.evaluate(e1);
                i.data[r + n + 0] = Math.floor(255 * s.r / s.a), i.data[r + n + 1] = Math.floor(255 * s.g / s.a), i.data[r + n + 2] = Math.floor(255 * s.b / s.a), i.data[r + n + 3] = Math.floor(255 * s.a);
            };
            if (t1.clips) for(let e2 = 0, i1 = 0; e2 < n; ++e2, i1 += 4 * r)for(let n1 = 0, s = 0; n1 < r; n1++, s += 4){
                const o = n1 / (r - 1), { start: l , end: u  } = t1.clips[e2];
                a(i1, s, l * (1 - o) + u * o);
            }
            else for(let t2 = 0, e3 = 0; t2 < r; t2++, e3 += 4)a(0, e3, t2 / (r - 1));
            return i;
        }
        Mn("AlphaImage", zs), Mn("RGBAImage", Bs);
        var Ps = {
            paint: new fi({
                "hillshade-illumination-direction": new li(nt.paint_hillshade["hillshade-illumination-direction"]),
                "hillshade-illumination-anchor": new li(nt.paint_hillshade["hillshade-illumination-anchor"]),
                "hillshade-exaggeration": new li(nt.paint_hillshade["hillshade-exaggeration"]),
                "hillshade-shadow-color": new li(nt.paint_hillshade["hillshade-shadow-color"]),
                "hillshade-highlight-color": new li(nt.paint_hillshade["hillshade-highlight-color"]),
                "hillshade-accent-color": new li(nt.paint_hillshade["hillshade-accent-color"])
            })
        };
        const Vs = vi([
            {
                name: "a_pos",
                components: 2,
                type: "Int16"
            }
        ], 4), { members: Es  } = Vs;
        var Fs = {
            exports: {}
        };
        function Ts(t1, e1, r) {
            r = r || 2;
            var n, i, a, s, o, l, u, c = e1 && e1.length, h = c ? e1[0] * r : t1.length, p = Ls(t1, 0, h, r, !0), f = [];
            if (!p || p.next === p.prev) return f;
            if (c && (p = function(t1, e1, r, n) {
                var i, a, s, o = [];
                for(i = 0, a = e1.length; i < a; i++)(s = Ls(t1, e1[i] * n, i < a - 1 ? e1[i + 1] * n : t1.length, n, !1)) === s.next && (s.steiner = !0), o.push(Gs(s));
                for(o.sort(js), i = 0; i < o.length; i++)r = Ns(o[i], r);
                return r;
            }(t1, e1, p, r)), t1.length > 80 * r) {
                n = a = t1[0], i = s = t1[1];
                for(var d = r; d < h; d += r)(o = t1[d]) < n && (n = o), (l = t1[d + 1]) < i && (i = l), o > a && (a = o), l > s && (s = l);
                u = 0 !== (u = Math.max(a - n, s - i)) ? 32767 / u : 0;
            }
            return $s(p, f, r, n, i, u, 0), f;
        }
        function Ls(t1, e1, r, n, i) {
            var a, s;
            if (i === so(t1, e1, r, n) > 0) for(a = e1; a < r; a += n)s = no(a, t1[a], t1[a + 1], s);
            else for(a = r - n; a >= e1; a -= n)s = no(a, t1[a], t1[a + 1], s);
            return s && Hs(s, s.next) && (io(s), s = s.next), s;
        }
        function Ds(t1, e1) {
            if (!t1) return t1;
            e1 || (e1 = t1);
            var r, n = t1;
            do if (r = !1, n.steiner || !Hs(n, n.next) && 0 !== Ys(n.prev, n, n.next)) n = n.next;
            else {
                if (io(n), (n = e1 = n.prev) === n.next) break;
                r = !0;
            }
            while (r || n !== e1);
            return e1;
        }
        function $s(t1, e1, r, n, i, a, s) {
            if (t1) {
                !s && a && function(t1, e1, r, n) {
                    var i = t1;
                    do 0 === i.z && (i.z = Ks(i.x, i.y, e1, r, n)), i.prevZ = i.prev, i.nextZ = i.next, i = i.next;
                    while (i !== t1);
                    i.prevZ.nextZ = null, i.prevZ = null, function(t1) {
                        var e1, r, n, i, a, s, o, l, u = 1;
                        do {
                            for(r = t1, t1 = null, a = null, s = 0; r;){
                                for(s++, n = r, o = 0, e1 = 0; e1 < u && (o++, n = n.nextZ); e1++);
                                for(l = u; o > 0 || l > 0 && n;)0 !== o && (0 === l || !n || r.z <= n.z) ? (i = r, r = r.nextZ, o--) : (i = n, n = n.nextZ, l--), a ? a.nextZ = i : t1 = i, i.prevZ = a, a = i;
                                r = n;
                            }
                            a.nextZ = null, u *= 2;
                        }while (s > 1);
                    }(i);
                }(t1, n, i, a);
                for(var o, l, u = t1; t1.prev !== t1.next;)if (o = t1.prev, l = t1.next, a ? Os(t1, n, i, a) : Rs(t1)) e1.push(o.i / r | 0), e1.push(t1.i / r | 0), e1.push(l.i / r | 0), io(t1), t1 = l.next, u = l.next;
                else if ((t1 = l) === u) {
                    s ? 1 === s ? $s(t1 = Us(Ds(t1), e1, r), e1, r, n, i, a, 2) : 2 === s && qs(t1, e1, r, n, i, a) : $s(Ds(t1), e1, r, n, i, a, 1);
                    break;
                }
            }
        }
        function Rs(t1) {
            var e1 = t1.prev, r = t1, n = t1.next;
            if (Ys(e1, r, n) >= 0) return !1;
            for(var i = e1.x, a = r.x, s = n.x, o = e1.y, l = r.y, u = n.y, c = i < a ? i < s ? i : s : a < s ? a : s, h = o < l ? o < u ? o : u : l < u ? l : u, p = i > a ? i > s ? i : s : a > s ? a : s, f = o > l ? o > u ? o : u : l > u ? l : u, d = n.next; d !== e1;){
                if (d.x >= c && d.x <= p && d.y >= h && d.y <= f && Js(i, o, a, l, s, u, d.x, d.y) && Ys(d.prev, d, d.next) >= 0) return !1;
                d = d.next;
            }
            return !0;
        }
        function Os(t1, e1, r, n) {
            var i = t1.prev, a = t1, s = t1.next;
            if (Ys(i, a, s) >= 0) return !1;
            for(var o = i.x, l = a.x, u = s.x, c = i.y, h = a.y, p = s.y, f = o < l ? o < u ? o : u : l < u ? l : u, d = c < h ? c < p ? c : p : h < p ? h : p, y = o > l ? o > u ? o : u : l > u ? l : u, m = c > h ? c > p ? c : p : h > p ? h : p, g = Ks(f, d, e1, r, n), x = Ks(y, m, e1, r, n), v = t1.prevZ, b = t1.nextZ; v && v.z >= g && b && b.z <= x;){
                if (v.x >= f && v.x <= y && v.y >= d && v.y <= m && v !== i && v !== s && Js(o, c, l, h, u, p, v.x, v.y) && Ys(v.prev, v, v.next) >= 0) return !1;
                if (v = v.prevZ, b.x >= f && b.x <= y && b.y >= d && b.y <= m && b !== i && b !== s && Js(o, c, l, h, u, p, b.x, b.y) && Ys(b.prev, b, b.next) >= 0) return !1;
                b = b.nextZ;
            }
            for(; v && v.z >= g;){
                if (v.x >= f && v.x <= y && v.y >= d && v.y <= m && v !== i && v !== s && Js(o, c, l, h, u, p, v.x, v.y) && Ys(v.prev, v, v.next) >= 0) return !1;
                v = v.prevZ;
            }
            for(; b && b.z <= x;){
                if (b.x >= f && b.x <= y && b.y >= d && b.y <= m && b !== i && b !== s && Js(o, c, l, h, u, p, b.x, b.y) && Ys(b.prev, b, b.next) >= 0) return !1;
                b = b.nextZ;
            }
            return !0;
        }
        function Us(t1, e1, r) {
            var n = t1;
            do {
                var i = n.prev, a = n.next.next;
                !Hs(i, a) && Ws(i, n, n.next, a) && eo(i, a) && eo(a, i) && (e1.push(i.i / r | 0), e1.push(n.i / r | 0), e1.push(a.i / r | 0), io(n), io(n.next), n = t1 = a), n = n.next;
            }while (n !== t1);
            return Ds(n);
        }
        function qs(t1, e1, r, n, i, a) {
            var s = t1;
            do {
                for(var o = s.next.next; o !== s.prev;){
                    if (s.i !== o.i && Xs(s, o)) {
                        var l = ro(s, o);
                        return s = Ds(s, s.next), l = Ds(l, l.next), $s(s, e1, r, n, i, a, 0), void $s(l, e1, r, n, i, a, 0);
                    }
                    o = o.next;
                }
                s = s.next;
            }while (s !== t1);
        }
        function js(t1, e1) {
            return t1.x - e1.x;
        }
        function Ns(t1, e1) {
            var r = function(t1, e1) {
                var r, n = e1, i = t1.x, a = t1.y, s = -1 / 0;
                do {
                    if (a <= n.y && a >= n.next.y && n.next.y !== n.y) {
                        var o = n.x + (a - n.y) * (n.next.x - n.x) / (n.next.y - n.y);
                        if (o <= i && o > s && (s = o, r = n.x < n.next.x ? n : n.next, o === i)) return r;
                    }
                    n = n.next;
                }while (n !== e1);
                if (!r) return null;
                var l, u = r, c = r.x, h = r.y, p = 1 / 0;
                n = r;
                do i >= n.x && n.x >= c && i !== n.x && Js(a < h ? i : s, a, c, h, a < h ? s : i, a, n.x, n.y) && (l = Math.abs(a - n.y) / (i - n.x), eo(n, t1) && (l < p || l === p && (n.x > r.x || n.x === r.x && Zs(r, n))) && (r = n, p = l)), n = n.next;
                while (n !== u);
                return r;
            }(t1, e1);
            if (!r) return e1;
            var n = ro(r, t1);
            return Ds(n, n.next), Ds(r, r.next);
        }
        function Zs(t1, e1) {
            return Ys(t1.prev, t1, e1.prev) < 0 && Ys(e1.next, t1, t1.next) < 0;
        }
        function Ks(t1, e1, r, n, i) {
            return (t1 = 1431655765 & ((t1 = 858993459 & ((t1 = 252645135 & ((t1 = 16711935 & ((t1 = (t1 - r) * i | 0) | t1 << 8)) | t1 << 4)) | t1 << 2)) | t1 << 1)) | (e1 = 1431655765 & ((e1 = 858993459 & ((e1 = 252645135 & ((e1 = 16711935 & ((e1 = (e1 - n) * i | 0) | e1 << 8)) | e1 << 4)) | e1 << 2)) | e1 << 1)) << 1;
        }
        function Gs(t1) {
            var e1 = t1, r = t1;
            do (e1.x < r.x || e1.x === r.x && e1.y < r.y) && (r = e1), e1 = e1.next;
            while (e1 !== t1);
            return r;
        }
        function Js(t1, e1, r, n, i, a, s, o) {
            return (i - s) * (e1 - o) >= (t1 - s) * (a - o) && (t1 - s) * (n - o) >= (r - s) * (e1 - o) && (r - s) * (a - o) >= (i - s) * (n - o);
        }
        function Xs(t1, e1) {
            return t1.next.i !== e1.i && t1.prev.i !== e1.i && !function(t1, e1) {
                var r = t1;
                do {
                    if (r.i !== t1.i && r.next.i !== t1.i && r.i !== e1.i && r.next.i !== e1.i && Ws(r, r.next, t1, e1)) return !0;
                    r = r.next;
                }while (r !== t1);
                return !1;
            }(t1, e1) && (eo(t1, e1) && eo(e1, t1) && function(t1, e1) {
                var r = t1, n = !1, i = (t1.x + e1.x) / 2, a = (t1.y + e1.y) / 2;
                do r.y > a != r.next.y > a && r.next.y !== r.y && i < (r.next.x - r.x) * (a - r.y) / (r.next.y - r.y) + r.x && (n = !n), r = r.next;
                while (r !== t1);
                return n;
            }(t1, e1) && (Ys(t1.prev, t1, e1.prev) || Ys(t1, e1.prev, e1)) || Hs(t1, e1) && Ys(t1.prev, t1, t1.next) > 0 && Ys(e1.prev, e1, e1.next) > 0);
        }
        function Ys(t1, e1, r) {
            return (e1.y - t1.y) * (r.x - e1.x) - (e1.x - t1.x) * (r.y - e1.y);
        }
        function Hs(t1, e1) {
            return t1.x === e1.x && t1.y === e1.y;
        }
        function Ws(t1, e1, r, n) {
            var i = to(Ys(t1, e1, r)), a = to(Ys(t1, e1, n)), s = to(Ys(r, n, t1)), o = to(Ys(r, n, e1));
            return i !== a && s !== o || !(0 !== i || !Qs(t1, r, e1)) || !(0 !== a || !Qs(t1, n, e1)) || !(0 !== s || !Qs(r, t1, n)) || !(0 !== o || !Qs(r, e1, n));
        }
        function Qs(t1, e1, r) {
            return e1.x <= Math.max(t1.x, r.x) && e1.x >= Math.min(t1.x, r.x) && e1.y <= Math.max(t1.y, r.y) && e1.y >= Math.min(t1.y, r.y);
        }
        function to(t1) {
            return t1 > 0 ? 1 : t1 < 0 ? -1 : 0;
        }
        function eo(t1, e1) {
            return Ys(t1.prev, t1, t1.next) < 0 ? Ys(t1, e1, t1.next) >= 0 && Ys(t1, t1.prev, e1) >= 0 : Ys(t1, e1, t1.prev) < 0 || Ys(t1, t1.next, e1) < 0;
        }
        function ro(t1, e1) {
            var r = new ao(t1.i, t1.x, t1.y), n = new ao(e1.i, e1.x, e1.y), i = t1.next, a = e1.prev;
            return t1.next = e1, e1.prev = t1, r.next = i, i.prev = r, n.next = r, r.prev = n, a.next = n, n.prev = a, n;
        }
        function no(t1, e1, r, n) {
            var i = new ao(t1, e1, r);
            return n ? (i.next = n.next, i.prev = n, n.next.prev = i, n.next = i) : (i.prev = i, i.next = i), i;
        }
        function io(t1) {
            t1.next.prev = t1.prev, t1.prev.next = t1.next, t1.prevZ && (t1.prevZ.nextZ = t1.nextZ), t1.nextZ && (t1.nextZ.prevZ = t1.prevZ);
        }
        function ao(t1, e1, r) {
            this.i = t1, this.x = e1, this.y = r, this.prev = null, this.next = null, this.z = 0, this.prevZ = null, this.nextZ = null, this.steiner = !1;
        }
        function so(t1, e1, r, n) {
            for(var i = 0, a = e1, s = r - n; a < r; a += n)i += (t1[s] - t1[a]) * (t1[a + 1] + t1[s + 1]), s = a;
            return i;
        }
        function oo(t1, e1, r, n, i) {
            lo(t1, e1, r || 0, n || t1.length - 1, i || co);
        }
        function lo(t1, e1, r, n, i) {
            for(; n > r;){
                if (n - r > 600) {
                    var a = n - r + 1, s = e1 - r + 1, o = Math.log(a), l = .5 * Math.exp(2 * o / 3), u = .5 * Math.sqrt(o * l * (a - l) / a) * (s - a / 2 < 0 ? -1 : 1);
                    lo(t1, e1, Math.max(r, Math.floor(e1 - s * l / a + u)), Math.min(n, Math.floor(e1 + (a - s) * l / a + u)), i);
                }
                var c = t1[e1], h = r, p = n;
                for(uo(t1, r, e1), i(t1[n], c) > 0 && uo(t1, r, n); h < p;){
                    for(uo(t1, h, p), h++, p--; i(t1[h], c) < 0;)h++;
                    for(; i(t1[p], c) > 0;)p--;
                }
                0 === i(t1[r], c) ? uo(t1, r, p) : uo(t1, ++p, n), p <= e1 && (r = p + 1), e1 <= p && (n = p - 1);
            }
        }
        function uo(t1, e1, r) {
            var n = t1[e1];
            t1[e1] = t1[r], t1[r] = n;
        }
        function co(t1, e1) {
            return t1 < e1 ? -1 : t1 > e1 ? 1 : 0;
        }
        function ho(t1, e1) {
            const r = t1.length;
            if (r <= 1) return [
                t1
            ];
            const n = [];
            let i, a;
            for(let e2 = 0; e2 < r; e2++){
                const r1 = m(t1[e2]);
                0 !== r1 && (t1[e2].area = Math.abs(r1), void 0 === a && (a = r1 < 0), a === r1 < 0 ? (i && n.push(i), i = [
                    t1[e2]
                ]) : i.push(t1[e2]));
            }
            if (i && n.push(i), e1 > 1) for(let t2 = 0; t2 < n.length; t2++)n[t2].length <= e1 || (oo(n[t2], e1, 1, n[t2].length - 1, po), n[t2] = n[t2].slice(0, e1));
            return n;
        }
        function po(t1, e1) {
            return e1.area - t1.area;
        }
        function fo(t1, e1, r) {
            const n = r.patternDependencies;
            let i = !1;
            for (const r1 of e1){
                const e2 = r1.paint.get(`${t1}-pattern`);
                e2.isConstant() || (i = !0);
                const a = e2.constantOr(null);
                a && (i = !0, n[a.to] = !0, n[a.from] = !0);
            }
            return i;
        }
        function yo(t1, e1, r, n, i) {
            const a = i.patternDependencies;
            for (const s of e1){
                const e2 = s.paint.get(`${t1}-pattern`).value;
                if ("constant" !== e2.kind) {
                    let t2 = e2.evaluate({
                        zoom: n - 1
                    }, r, {}, i.availableImages), o = e2.evaluate({
                        zoom: n
                    }, r, {}, i.availableImages), l = e2.evaluate({
                        zoom: n + 1
                    }, r, {}, i.availableImages);
                    t2 = t2 && t2.name ? t2.name : t2, o = o && o.name ? o.name : o, l = l && l.name ? l.name : l, a[t2] = !0, a[o] = !0, a[l] = !0, r.patterns[s.id] = {
                        min: t2,
                        mid: o,
                        max: l
                    };
                }
            }
            return r;
        }
        Fs.exports = Ts, Fs.exports.default = Ts, Ts.deviation = function(t1, e1, r, n) {
            var i = e1 && e1.length, a = Math.abs(so(t1, 0, i ? e1[0] * r : t1.length, r));
            if (i) for(var s = 0, o = e1.length; s < o; s++)a -= Math.abs(so(t1, e1[s] * r, s < o - 1 ? e1[s + 1] * r : t1.length, r));
            var l = 0;
            for(s = 0; s < n.length; s += 3){
                var u = n[s] * r, c = n[s + 1] * r, h = n[s + 2] * r;
                l += Math.abs((t1[u] - t1[h]) * (t1[c + 1] - t1[u + 1]) - (t1[u] - t1[c]) * (t1[h + 1] - t1[u + 1]));
            }
            return 0 === a && 0 === l ? 0 : Math.abs((l - a) / a);
        }, Ts.flatten = function(t1) {
            for(var e1 = t1[0][0].length, r = {
                vertices: [],
                holes: [],
                dimensions: e1
            }, n = 0, i = 0; i < t1.length; i++){
                for(var a = 0; a < t1[i].length; a++)for(var s = 0; s < e1; s++)r.vertices.push(t1[i][a][s]);
                i > 0 && r.holes.push(n += t1[i - 1].length);
            }
            return r;
        };
        class mo {
            constructor(t1){
                this.zoom = t1.zoom, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.hasPattern = !1, this.patternFeatures = [], this.layoutVertexArray = new ea, this.indexArray = new ha, this.indexArray2 = new pa, this.programConfigurations = new Ra(t1.layers, t1.zoom), this.segments = new ya, this.segments2 = new ya, this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id);
            }
            populate(t1, e1, r) {
                this.hasPattern = fo("fill", this.layers, e1);
                const n = this.layers[0].layout.get("fill-sort-key"), i = !n.isConstant(), a = [];
                for (const { feature: s , id: o , index: l , sourceLayerIndex: u  } of t1){
                    const t2 = this.layers[0]._featureFilter.needGeometry, c = Ka(s, t2);
                    if (!this.layers[0]._featureFilter.filter(new Qn(this.zoom), c, r)) continue;
                    const h = i ? n.evaluate(c, {}, r, e1.availableImages) : void 0, p = {
                        id: o,
                        properties: s.properties,
                        type: s.type,
                        sourceLayerIndex: u,
                        index: l,
                        geometry: t2 ? c.geometry : Za(s),
                        patterns: {},
                        sortKey: h
                    };
                    a.push(p);
                }
                i && a.sort((t1, e1)=>t1.sortKey - e1.sortKey);
                for (const n1 of a){
                    const { geometry: i1 , index: a1 , sourceLayerIndex: s1  } = n1;
                    if (this.hasPattern) {
                        const t3 = yo("fill", this.layers, n1, this.zoom, e1);
                        this.patternFeatures.push(t3);
                    } else this.addFeature(n1, i1, a1, r, {});
                    e1.featureIndex.insert(t1[a1].feature, i1, a1, s1, this.index);
                }
            }
            update(t1, e1, r) {
                this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t1, e1, this.stateDependentLayers, r);
            }
            addFeatures(t1, e1, r) {
                for (const t2 of this.patternFeatures)this.addFeature(t2, t2.geometry, t2.index, e1, r);
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length;
            }
            uploadPending() {
                return !this.uploaded || this.programConfigurations.needsUpload;
            }
            upload(t1) {
                this.uploaded || (this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, Es), this.indexBuffer = t1.createIndexBuffer(this.indexArray), this.indexBuffer2 = t1.createIndexBuffer(this.indexArray2)), this.programConfigurations.upload(t1), this.uploaded = !0;
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.indexBuffer2.destroy(), this.programConfigurations.destroy(), this.segments.destroy(), this.segments2.destroy());
            }
            addFeature(t1, e1, r, n, i) {
                for (const t2 of ho(e1, 500)){
                    let e2 = 0;
                    for (const r1 of t2)e2 += r1.length;
                    const r2 = this.segments.prepareSegment(e2, this.layoutVertexArray, this.indexArray), n1 = r2.vertexLength, i1 = [], a = [];
                    for (const e3 of t2){
                        if (0 === e3.length) continue;
                        e3 !== t2[0] && a.push(i1.length / 2);
                        const r3 = this.segments2.prepareSegment(e3.length, this.layoutVertexArray, this.indexArray2), n2 = r3.vertexLength;
                        this.layoutVertexArray.emplaceBack(e3[0].x, e3[0].y), this.indexArray2.emplaceBack(n2 + e3.length - 1, n2), i1.push(e3[0].x), i1.push(e3[0].y);
                        for(let t3 = 1; t3 < e3.length; t3++)this.layoutVertexArray.emplaceBack(e3[t3].x, e3[t3].y), this.indexArray2.emplaceBack(n2 + t3 - 1, n2 + t3), i1.push(e3[t3].x), i1.push(e3[t3].y);
                        r3.vertexLength += e3.length, r3.primitiveLength += e3.length;
                    }
                    const s = Fs.exports(i1, a);
                    for(let t4 = 0; t4 < s.length; t4 += 3)this.indexArray.emplaceBack(n1 + s[t4], n1 + s[t4 + 1], n1 + s[t4 + 2]);
                    r2.vertexLength += e2, r2.primitiveLength += s.length / 3;
                }
                this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t1, r, i, n);
            }
        }
        Mn("FillBucket", mo, {
            omit: [
                "layers",
                "patternFeatures"
            ]
        });
        const go = new fi({
            "fill-sort-key": new ui(nt.layout_fill["fill-sort-key"])
        });
        var xo = {
            paint: new fi({
                "fill-antialias": new li(nt.paint_fill["fill-antialias"]),
                "fill-opacity": new ui(nt.paint_fill["fill-opacity"]),
                "fill-color": new ui(nt.paint_fill["fill-color"]),
                "fill-outline-color": new ui(nt.paint_fill["fill-outline-color"]),
                "fill-translate": new li(nt.paint_fill["fill-translate"]),
                "fill-translate-anchor": new li(nt.paint_fill["fill-translate-anchor"]),
                "fill-pattern": new ci(nt.paint_fill["fill-pattern"])
            }),
            layout: go
        };
        const vo = vi([
            {
                name: "a_pos",
                components: 2,
                type: "Int16"
            },
            {
                name: "a_normal_ed",
                components: 4,
                type: "Int16"
            }
        ], 4), bo = vi([
            {
                name: "a_centroid",
                components: 2,
                type: "Int16"
            }
        ], 4), { members: wo  } = vo;
        var _o = {}, Ao = S, ko = So;
        function So(t1, e1, r, n, i) {
            this.properties = {}, this.extent = r, this.type = 0, this._pbf = t1, this._geometry = -1, this._keys = n, this._values = i, t1.readFields(Io, this, e1);
        }
        function Io(t1, e1, r) {
            1 == t1 ? e1.id = r.readVarint() : 2 == t1 ? function(t1, e1) {
                for(var r = t1.readVarint() + t1.pos; t1.pos < r;){
                    var n = e1._keys[t1.readVarint()], i = e1._values[t1.readVarint()];
                    e1.properties[n] = i;
                }
            }(r, e1) : 3 == t1 ? e1.type = r.readVarint() : 4 == t1 && (e1._geometry = r.pos);
        }
        function Mo(t1) {
            for(var e1, r, n = 0, i = 0, a = t1.length, s = a - 1; i < a; s = i++)n += ((r = t1[s]).x - (e1 = t1[i]).x) * (e1.y + r.y);
            return n;
        }
        So.types = [
            "Unknown",
            "Point",
            "LineString",
            "Polygon"
        ], So.prototype.loadGeometry = function() {
            var t1 = this._pbf;
            t1.pos = this._geometry;
            for(var e1, r = t1.readVarint() + t1.pos, n = 1, i = 0, a = 0, s = 0, o = []; t1.pos < r;){
                if (i <= 0) {
                    var l = t1.readVarint();
                    n = 7 & l, i = l >> 3;
                }
                if (i--, 1 === n || 2 === n) a += t1.readSVarint(), s += t1.readSVarint(), 1 === n && (e1 && o.push(e1), e1 = []), e1.push(new Ao(a, s));
                else {
                    if (7 !== n) throw new Error("unknown command " + n);
                    e1 && e1.push(e1[0].clone());
                }
            }
            return e1 && o.push(e1), o;
        }, So.prototype.bbox = function() {
            var t1 = this._pbf;
            t1.pos = this._geometry;
            for(var e1 = t1.readVarint() + t1.pos, r = 1, n = 0, i = 0, a = 0, s = 1 / 0, o = -1 / 0, l = 1 / 0, u = -1 / 0; t1.pos < e1;){
                if (n <= 0) {
                    var c = t1.readVarint();
                    r = 7 & c, n = c >> 3;
                }
                if (n--, 1 === r || 2 === r) (i += t1.readSVarint()) < s && (s = i), i > o && (o = i), (a += t1.readSVarint()) < l && (l = a), a > u && (u = a);
                else if (7 !== r) throw new Error("unknown command " + r);
            }
            return [
                s,
                l,
                o,
                u
            ];
        }, So.prototype.toGeoJSON = function(t1, e1, r) {
            var n, i, a = this.extent * Math.pow(2, r), s = this.extent * t1, o = this.extent * e1, l = this.loadGeometry(), u = So.types[this.type];
            function c(t1) {
                for(var e1 = 0; e1 < t1.length; e1++){
                    var r = t1[e1];
                    t1[e1] = [
                        360 * (r.x + s) / a - 180,
                        360 / Math.PI * Math.atan(Math.exp((180 - 360 * (r.y + o) / a) * Math.PI / 180)) - 90
                    ];
                }
            }
            switch(this.type){
                case 1:
                    var h = [];
                    for(n = 0; n < l.length; n++)h[n] = l[n][0];
                    c(l = h);
                    break;
                case 2:
                    for(n = 0; n < l.length; n++)c(l[n]);
                    break;
                case 3:
                    for(l = function(t1) {
                        var e1 = t1.length;
                        if (e1 <= 1) return [
                            t1
                        ];
                        for(var r, n, i = [], a = 0; a < e1; a++){
                            var s = Mo(t1[a]);
                            0 !== s && (void 0 === n && (n = s < 0), n === s < 0 ? (r && i.push(r), r = [
                                t1[a]
                            ]) : r.push(t1[a]));
                        }
                        return r && i.push(r), i;
                    }(l), n = 0; n < l.length; n++)for(i = 0; i < l[n].length; i++)c(l[n][i]);
            }
            1 === l.length ? l = l[0] : u = "Multi" + u;
            var p = {
                type: "Feature",
                geometry: {
                    type: u,
                    coordinates: l
                },
                properties: this.properties
            };
            return "id" in this && (p.id = this.id), p;
        };
        var zo = ko, Bo = Co;
        function Co(t1, e1) {
            this.version = 1, this.name = null, this.extent = 4096, this.length = 0, this._pbf = t1, this._keys = [], this._values = [], this._features = [], t1.readFields(Po, this, e1), this.length = this._features.length;
        }
        function Po(t1, e1, r) {
            15 === t1 ? e1.version = r.readVarint() : 1 === t1 ? e1.name = r.readString() : 5 === t1 ? e1.extent = r.readVarint() : 2 === t1 ? e1._features.push(r.pos) : 3 === t1 ? e1._keys.push(r.readString()) : 4 === t1 && e1._values.push(function(t1) {
                for(var e1 = null, r = t1.readVarint() + t1.pos; t1.pos < r;){
                    var n = t1.readVarint() >> 3;
                    e1 = 1 === n ? t1.readString() : 2 === n ? t1.readFloat() : 3 === n ? t1.readDouble() : 4 === n ? t1.readVarint64() : 5 === n ? t1.readVarint() : 6 === n ? t1.readSVarint() : 7 === n ? t1.readBoolean() : null;
                }
                return e1;
            }(r));
        }
        Co.prototype.feature = function(t1) {
            if (t1 < 0 || t1 >= this._features.length) throw new Error("feature index out of bounds");
            this._pbf.pos = this._features[t1];
            var e1 = this._pbf.readVarint() + this._pbf.pos;
            return new zo(this._pbf, e1, this.extent, this._keys, this._values);
        };
        var Vo = Bo;
        function Eo(t1, e1, r) {
            if (3 === t1) {
                var n = new Vo(r, r.readVarint() + r.pos);
                n.length && (e1[n.name] = n);
            }
        }
        _o.VectorTile = function(t1, e1) {
            this.layers = t1.readFields(Eo, {}, e1);
        }, _o.VectorTileFeature = ko, _o.VectorTileLayer = Bo;
        const Fo = _o.VectorTileFeature.types, To = Math.pow(2, 13);
        function Lo(t1, e1, r, n, i, a, s, o) {
            t1.emplaceBack(e1, r, 2 * Math.floor(n * To) + s, i * To * 2, a * To * 2, Math.round(o));
        }
        class Do {
            constructor(t1){
                this.zoom = t1.zoom, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.hasPattern = !1, this.layoutVertexArray = new ra, this.centroidVertexArray = new Qi, this.indexArray = new ha, this.programConfigurations = new Ra(t1.layers, t1.zoom), this.segments = new ya, this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id);
            }
            populate(t1, e1, r) {
                this.features = [], this.hasPattern = fo("fill-extrusion", this.layers, e1);
                for (const { feature: n , id: i , index: a , sourceLayerIndex: s  } of t1){
                    const t2 = this.layers[0]._featureFilter.needGeometry, o = Ka(n, t2);
                    if (!this.layers[0]._featureFilter.filter(new Qn(this.zoom), o, r)) continue;
                    const l = {
                        id: i,
                        sourceLayerIndex: s,
                        index: a,
                        geometry: t2 ? o.geometry : Za(n),
                        properties: n.properties,
                        type: n.type,
                        patterns: {}
                    };
                    this.hasPattern ? this.features.push(yo("fill-extrusion", this.layers, l, this.zoom, e1)) : this.addFeature(l, l.geometry, a, r, {}), e1.featureIndex.insert(n, l.geometry, a, s, this.index, !0);
                }
            }
            addFeatures(t1, e1, r) {
                for (const t2 of this.features){
                    const { geometry: n  } = t2;
                    this.addFeature(t2, n, t2.index, e1, r);
                }
            }
            update(t1, e1, r) {
                this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t1, e1, this.stateDependentLayers, r);
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length && 0 === this.centroidVertexArray.length;
            }
            uploadPending() {
                return !this.uploaded || this.programConfigurations.needsUpload;
            }
            upload(t1) {
                this.uploaded || (this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, wo), this.centroidVertexBuffer = t1.createVertexBuffer(this.centroidVertexArray, bo.members, !0), this.indexBuffer = t1.createIndexBuffer(this.indexArray)), this.programConfigurations.upload(t1), this.uploaded = !0;
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy(), this.centroidVertexBuffer.destroy());
            }
            addFeature(t1, e1, r, n, i) {
                const a = {
                    x: 0,
                    y: 0,
                    vertexCount: 0
                };
                for (const r1 of ho(e1, 500)){
                    let e2 = 0;
                    for (const t2 of r1)e2 += t2.length;
                    let n1 = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray);
                    for (const t3 of r1){
                        if (0 === t3.length) continue;
                        if (Ro(t3)) continue;
                        let e3 = 0;
                        for(let r2 = 0; r2 < t3.length; r2++){
                            const i1 = t3[r2];
                            if (r2 >= 1) {
                                const s = t3[r2 - 1];
                                if (!$o(i1, s)) {
                                    n1.vertexLength + 4 > ya.MAX_VERTEX_ARRAY_LENGTH && (n1 = this.segments.prepareSegment(4, this.layoutVertexArray, this.indexArray));
                                    const t4 = i1.sub(s)._perp()._unit(), r3 = s.dist(i1);
                                    e3 + r3 > 32768 && (e3 = 0), Lo(this.layoutVertexArray, i1.x, i1.y, t4.x, t4.y, 0, 0, e3), Lo(this.layoutVertexArray, i1.x, i1.y, t4.x, t4.y, 0, 1, e3), a.x += 2 * i1.x, a.y += 2 * i1.y, a.vertexCount += 2, e3 += r3, Lo(this.layoutVertexArray, s.x, s.y, t4.x, t4.y, 0, 0, e3), Lo(this.layoutVertexArray, s.x, s.y, t4.x, t4.y, 0, 1, e3), a.x += 2 * s.x, a.y += 2 * s.y, a.vertexCount += 2;
                                    const o = n1.vertexLength;
                                    this.indexArray.emplaceBack(o, o + 2, o + 1), this.indexArray.emplaceBack(o + 1, o + 2, o + 3), n1.vertexLength += 4, n1.primitiveLength += 2;
                                }
                            }
                        }
                    }
                    if (n1.vertexLength + e2 > ya.MAX_VERTEX_ARRAY_LENGTH && (n1 = this.segments.prepareSegment(e2, this.layoutVertexArray, this.indexArray)), "Polygon" !== Fo[t1.type]) continue;
                    const i2 = [], s1 = [], o1 = n1.vertexLength;
                    for (const t5 of r1)if (0 !== t5.length) {
                        t5 !== r1[0] && s1.push(i2.length / 2);
                        for(let e4 = 0; e4 < t5.length; e4++){
                            const r4 = t5[e4];
                            Lo(this.layoutVertexArray, r4.x, r4.y, 0, 0, 1, 1, 0), a.x += r4.x, a.y += r4.y, a.vertexCount += 1, i2.push(r4.x), i2.push(r4.y);
                        }
                    }
                    const l = Fs.exports(i2, s1);
                    for(let t6 = 0; t6 < l.length; t6 += 3)this.indexArray.emplaceBack(o1 + l[t6], o1 + l[t6 + 2], o1 + l[t6 + 1]);
                    n1.primitiveLength += l.length / 3, n1.vertexLength += e2;
                }
                for(let t7 = 0; t7 < a.vertexCount; t7++)this.centroidVertexArray.emplaceBack(Math.floor(a.x / a.vertexCount), Math.floor(a.y / a.vertexCount));
                this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t1, r, i, n);
            }
        }
        function $o(t1, e1) {
            return t1.x === e1.x && (t1.x < 0 || t1.x > qa) || t1.y === e1.y && (t1.y < 0 || t1.y > qa);
        }
        function Ro(t1) {
            return t1.every((t1)=>t1.x < 0) || t1.every((t1)=>t1.x > qa) || t1.every((t1)=>t1.y < 0) || t1.every((t1)=>t1.y > qa);
        }
        Mn("FillExtrusionBucket", Do, {
            omit: [
                "layers",
                "features"
            ]
        });
        var Oo = {
            paint: new fi({
                "fill-extrusion-opacity": new li(nt["paint_fill-extrusion"]["fill-extrusion-opacity"]),
                "fill-extrusion-color": new ui(nt["paint_fill-extrusion"]["fill-extrusion-color"]),
                "fill-extrusion-translate": new li(nt["paint_fill-extrusion"]["fill-extrusion-translate"]),
                "fill-extrusion-translate-anchor": new li(nt["paint_fill-extrusion"]["fill-extrusion-translate-anchor"]),
                "fill-extrusion-pattern": new ci(nt["paint_fill-extrusion"]["fill-extrusion-pattern"]),
                "fill-extrusion-height": new ui(nt["paint_fill-extrusion"]["fill-extrusion-height"]),
                "fill-extrusion-base": new ui(nt["paint_fill-extrusion"]["fill-extrusion-base"]),
                "fill-extrusion-vertical-gradient": new li(nt["paint_fill-extrusion"]["fill-extrusion-vertical-gradient"])
            })
        };
        function Uo(t1, e1) {
            return t1.x * e1.x + t1.y * e1.y;
        }
        function qo(t1, e1) {
            if (1 === t1.length) {
                let r = 0;
                const n = e1[r++];
                let i;
                for(; !i || n.equals(i);)if (i = e1[r++], !i) return 1 / 0;
                for(; r < e1.length; r++){
                    const a = e1[r], s = t1[0], o = i.sub(n), l = a.sub(n), u = s.sub(n), c = Uo(o, o), h = Uo(o, l), p = Uo(l, l), f = Uo(u, o), d = Uo(u, l), y = c * p - h * h, m = (p * f - h * d) / y, g = (c * d - h * f) / y, x = n.z * (1 - m - g) + i.z * m + a.z * g;
                    if (isFinite(x)) return x;
                }
                return 1 / 0;
            }
            {
                let t2 = 1 / 0;
                for (const r1 of e1)t2 = Math.min(t2, r1.z);
                return t2;
            }
        }
        const jo = vi([
            {
                name: "a_pos_normal",
                components: 2,
                type: "Int16"
            },
            {
                name: "a_data",
                components: 4,
                type: "Uint8"
            }
        ], 4), { members: No  } = jo, Zo = vi([
            {
                name: "a_uv_x",
                components: 1,
                type: "Float32"
            },
            {
                name: "a_split_index",
                components: 1,
                type: "Float32"
            }
        ]), { members: Ko  } = Zo, Go = _o.VectorTileFeature.types, Jo = Math.cos(Math.PI / 180 * 37.5), Xo = Math.pow(2, 14) / .5;
        class Yo {
            constructor(t1){
                this.zoom = t1.zoom, this.overscaling = t1.overscaling, this.layers = t1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = t1.index, this.hasPattern = !1, this.patternFeatures = [], this.lineClipsArray = [], this.gradients = {}, this.layers.forEach((t1)=>{
                    this.gradients[t1.id] = {};
                }), this.layoutVertexArray = new na, this.layoutVertexArray2 = new ia, this.indexArray = new ha, this.programConfigurations = new Ra(t1.layers, t1.zoom), this.segments = new ya, this.maxLineLength = 0, this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id);
            }
            populate(t1, e1, r) {
                this.hasPattern = fo("line", this.layers, e1);
                const n = this.layers[0].layout.get("line-sort-key"), i = !n.isConstant(), a = [];
                for (const { feature: e2 , id: s , index: o , sourceLayerIndex: l  } of t1){
                    const t2 = this.layers[0]._featureFilter.needGeometry, u = Ka(e2, t2);
                    if (!this.layers[0]._featureFilter.filter(new Qn(this.zoom), u, r)) continue;
                    const c = i ? n.evaluate(u, {}, r) : void 0, h = {
                        id: s,
                        properties: e2.properties,
                        type: e2.type,
                        sourceLayerIndex: l,
                        index: o,
                        geometry: t2 ? u.geometry : Za(e2),
                        patterns: {},
                        sortKey: c
                    };
                    a.push(h);
                }
                i && a.sort((t1, e1)=>t1.sortKey - e1.sortKey);
                for (const n1 of a){
                    const { geometry: i1 , index: a1 , sourceLayerIndex: s1  } = n1;
                    if (this.hasPattern) {
                        const t3 = yo("line", this.layers, n1, this.zoom, e1);
                        this.patternFeatures.push(t3);
                    } else this.addFeature(n1, i1, a1, r, {});
                    e1.featureIndex.insert(t1[a1].feature, i1, a1, s1, this.index);
                }
            }
            update(t1, e1, r) {
                this.stateDependentLayers.length && this.programConfigurations.updatePaintArrays(t1, e1, this.stateDependentLayers, r);
            }
            addFeatures(t1, e1, r) {
                for (const t2 of this.patternFeatures)this.addFeature(t2, t2.geometry, t2.index, e1, r);
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length;
            }
            uploadPending() {
                return !this.uploaded || this.programConfigurations.needsUpload;
            }
            upload(t1) {
                this.uploaded || (0 !== this.layoutVertexArray2.length && (this.layoutVertexBuffer2 = t1.createVertexBuffer(this.layoutVertexArray2, Ko)), this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, No), this.indexBuffer = t1.createIndexBuffer(this.indexArray)), this.programConfigurations.upload(t1), this.uploaded = !0;
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy());
            }
            lineFeatureClips(t1) {
                if (t1.properties && Object.prototype.hasOwnProperty.call(t1.properties, "mapbox_clip_start") && Object.prototype.hasOwnProperty.call(t1.properties, "mapbox_clip_end")) return {
                    start: +t1.properties.mapbox_clip_start,
                    end: +t1.properties.mapbox_clip_end
                };
            }
            addFeature(t1, e1, r, n, i) {
                const a = this.layers[0].layout, s = a.get("line-join").evaluate(t1, {}), o = a.get("line-cap"), l = a.get("line-miter-limit"), u = a.get("line-round-limit");
                this.lineClips = this.lineFeatureClips(t1);
                for (const r1 of e1)this.addLine(r1, t1, s, o, l, u);
                this.programConfigurations.populatePaintArrays(this.layoutVertexArray.length, t1, r, i, n);
            }
            addLine(t1, e1, r, n, i, a) {
                if (this.distance = 0, this.scaledDistance = 0, this.totalDistance = 0, this.lineClips) {
                    this.lineClipsArray.push(this.lineClips);
                    for(let e2 = 0; e2 < t1.length - 1; e2++)this.totalDistance += t1[e2].dist(t1[e2 + 1]);
                    this.updateScaledDistance(), this.maxLineLength = Math.max(this.maxLineLength, this.totalDistance);
                }
                const s = "Polygon" === Go[e1.type];
                let o = t1.length;
                for(; o >= 2 && t1[o - 1].equals(t1[o - 2]);)o--;
                let l = 0;
                for(; l < o - 1 && t1[l].equals(t1[l + 1]);)l++;
                if (o < (s ? 3 : 2)) return;
                "bevel" === r && (i = 1.05);
                const u = this.overscaling <= 16 ? 122880 / (512 * this.overscaling) : 0, c = this.segments.prepareSegment(10 * o, this.layoutVertexArray, this.indexArray);
                let h, p, f, d, y;
                this.e1 = this.e2 = -1, s && (h = t1[o - 2], y = t1[l].sub(h)._unit()._perp());
                for(let e3 = l; e3 < o; e3++){
                    if (f = e3 === o - 1 ? s ? t1[l + 1] : void 0 : t1[e3 + 1], f && t1[e3].equals(f)) continue;
                    y && (d = y), h && (p = h), h = t1[e3], y = f ? f.sub(h)._unit()._perp() : d, d = d || y;
                    let m = d.add(y);
                    0 === m.x && 0 === m.y || m._unit();
                    const g = d.x * y.x + d.y * y.y, x = m.x * y.x + m.y * y.y, v = 0 !== x ? 1 / x : 1 / 0, b = 2 * Math.sqrt(2 - 2 * x), w = x < Jo && p && f, _ = d.x * y.y - d.y * y.x > 0;
                    if (w && e3 > l) {
                        const t2 = h.dist(p);
                        if (t2 > 2 * u) {
                            const e4 = h.sub(h.sub(p)._mult(u / t2)._round());
                            this.updateDistance(p, e4), this.addCurrentVertex(e4, d, 0, 0, c), p = e4;
                        }
                    }
                    const A = p && f;
                    let k = A ? r : s ? "butt" : n;
                    if (A && "round" === k && (v < a ? k = "miter" : v <= 2 && (k = "fakeround")), "miter" === k && v > i && (k = "bevel"), "bevel" === k && (v > 2 && (k = "flipbevel"), v < i && (k = "miter")), p && this.updateDistance(p, h), "miter" === k) m._mult(v), this.addCurrentVertex(h, m, 0, 0, c);
                    else if ("flipbevel" === k) {
                        if (v > 100) m = y.mult(-1);
                        else {
                            const t3 = v * d.add(y).mag() / d.sub(y).mag();
                            m._perp()._mult(t3 * (_ ? -1 : 1));
                        }
                        this.addCurrentVertex(h, m, 0, 0, c), this.addCurrentVertex(h, m.mult(-1), 0, 0, c);
                    } else if ("bevel" === k || "fakeround" === k) {
                        const t4 = -Math.sqrt(v * v - 1), e5 = _ ? t4 : 0, r1 = _ ? 0 : t4;
                        if (p && this.addCurrentVertex(h, d, e5, r1, c), "fakeround" === k) {
                            const t5 = Math.round(180 * b / Math.PI / 20);
                            for(let e6 = 1; e6 < t5; e6++){
                                let r2 = e6 / t5;
                                if (.5 !== r2) {
                                    const t6 = r2 - .5;
                                    r2 += r2 * t6 * (r2 - 1) * ((1.0904 + g * (g * (3.55645 - 1.43519 * g) - 3.2452)) * t6 * t6 + (.848013 + g * (.215638 * g - 1.06021)));
                                }
                                const n1 = y.sub(d)._mult(r2)._add(d)._unit()._mult(_ ? -1 : 1);
                                this.addHalfVertex(h, n1.x, n1.y, !1, _, 0, c);
                            }
                        }
                        f && this.addCurrentVertex(h, y, -e5, -r1, c);
                    } else if ("butt" === k) this.addCurrentVertex(h, m, 0, 0, c);
                    else if ("square" === k) {
                        const t7 = p ? 1 : -1;
                        this.addCurrentVertex(h, m, t7, t7, c);
                    } else "round" === k && (p && (this.addCurrentVertex(h, d, 0, 0, c), this.addCurrentVertex(h, d, 1, 1, c, !0)), f && (this.addCurrentVertex(h, y, -1, -1, c, !0), this.addCurrentVertex(h, y, 0, 0, c)));
                    if (w && e3 < o - 1) {
                        const t8 = h.dist(f);
                        if (t8 > 2 * u) {
                            const e7 = h.add(f.sub(h)._mult(u / t8)._round());
                            this.updateDistance(h, e7), this.addCurrentVertex(e7, y, 0, 0, c), h = e7;
                        }
                    }
                }
            }
            addCurrentVertex(t1, e1, r, n, i, a = !1) {
                const s = e1.y * n - e1.x, o = -e1.y - e1.x * n;
                this.addHalfVertex(t1, e1.x + e1.y * r, e1.y - e1.x * r, a, !1, r, i), this.addHalfVertex(t1, s, o, a, !0, -n, i), this.distance > Xo / 2 && 0 === this.totalDistance && (this.distance = 0, this.addCurrentVertex(t1, e1, r, n, i, a));
            }
            addHalfVertex({ x: t1 , y: e1  }, r, n, i, a, s, o) {
                const l = .5 * (this.lineClips ? this.scaledDistance * (Xo - 1) : this.scaledDistance);
                this.layoutVertexArray.emplaceBack((t1 << 1) + (i ? 1 : 0), (e1 << 1) + (a ? 1 : 0), Math.round(63 * r) + 128, Math.round(63 * n) + 128, 1 + (0 === s ? 0 : s < 0 ? -1 : 1) | (63 & l) << 2, l >> 6), this.lineClips && this.layoutVertexArray2.emplaceBack((this.scaledDistance - this.lineClips.start) / (this.lineClips.end - this.lineClips.start), this.lineClipsArray.length);
                const u = o.vertexLength++;
                this.e1 >= 0 && this.e2 >= 0 && (this.indexArray.emplaceBack(this.e1, this.e2, u), o.primitiveLength++), a ? this.e2 = u : this.e1 = u;
            }
            updateScaledDistance() {
                this.scaledDistance = this.lineClips ? this.lineClips.start + (this.lineClips.end - this.lineClips.start) * this.distance / this.totalDistance : this.distance;
            }
            updateDistance(t1, e1) {
                this.distance += t1.dist(e1), this.updateScaledDistance();
            }
        }
        Mn("LineBucket", Yo, {
            omit: [
                "layers",
                "patternFeatures"
            ]
        });
        const Ho = new fi({
            "line-cap": new li(nt.layout_line["line-cap"]),
            "line-join": new ui(nt.layout_line["line-join"]),
            "line-miter-limit": new li(nt.layout_line["line-miter-limit"]),
            "line-round-limit": new li(nt.layout_line["line-round-limit"]),
            "line-sort-key": new ui(nt.layout_line["line-sort-key"])
        });
        var Wo = {
            paint: new fi({
                "line-opacity": new ui(nt.paint_line["line-opacity"]),
                "line-color": new ui(nt.paint_line["line-color"]),
                "line-translate": new li(nt.paint_line["line-translate"]),
                "line-translate-anchor": new li(nt.paint_line["line-translate-anchor"]),
                "line-width": new ui(nt.paint_line["line-width"]),
                "line-gap-width": new ui(nt.paint_line["line-gap-width"]),
                "line-offset": new ui(nt.paint_line["line-offset"]),
                "line-blur": new ui(nt.paint_line["line-blur"]),
                "line-dasharray": new hi(nt.paint_line["line-dasharray"]),
                "line-pattern": new ci(nt.paint_line["line-pattern"]),
                "line-gradient": new pi(nt.paint_line["line-gradient"])
            }),
            layout: Ho
        };
        const Qo = new class extends ui {
            possiblyEvaluate(t1, e1) {
                return e1 = new Qn(Math.floor(e1.zoom), {
                    now: e1.now,
                    fadeDuration: e1.fadeDuration,
                    zoomHistory: e1.zoomHistory,
                    transition: e1.transition
                }), super.possiblyEvaluate(t1, e1);
            }
            evaluate(t1, e1, r, n) {
                return e1 = o({}, e1, {
                    zoom: Math.floor(e1.zoom)
                }), super.evaluate(t1, e1, r, n);
            }
        }(Wo.paint.properties["line-width"].specification);
        function tl(t1, e1) {
            return e1 > 0 ? e1 + 2 * t1 : t1;
        }
        Qo.useIntegerZoom = !0;
        const el = vi([
            {
                name: "a_pos_offset",
                components: 4,
                type: "Int16"
            },
            {
                name: "a_data",
                components: 4,
                type: "Uint16"
            },
            {
                name: "a_pixeloffset",
                components: 4,
                type: "Int16"
            }
        ], 4), rl = vi([
            {
                name: "a_projected_pos",
                components: 3,
                type: "Float32"
            }
        ], 4);
        vi([
            {
                name: "a_fade_opacity",
                components: 1,
                type: "Uint32"
            }
        ], 4);
        const nl = vi([
            {
                name: "a_placed",
                components: 2,
                type: "Uint8"
            },
            {
                name: "a_shift",
                components: 2,
                type: "Float32"
            }
        ]);
        vi([
            {
                type: "Int16",
                name: "anchorPointX"
            },
            {
                type: "Int16",
                name: "anchorPointY"
            },
            {
                type: "Int16",
                name: "x1"
            },
            {
                type: "Int16",
                name: "y1"
            },
            {
                type: "Int16",
                name: "x2"
            },
            {
                type: "Int16",
                name: "y2"
            },
            {
                type: "Uint32",
                name: "featureIndex"
            },
            {
                type: "Uint16",
                name: "sourceLayerIndex"
            },
            {
                type: "Uint16",
                name: "bucketIndex"
            }
        ]);
        const il = vi([
            {
                name: "a_pos",
                components: 2,
                type: "Int16"
            },
            {
                name: "a_anchor_pos",
                components: 2,
                type: "Int16"
            },
            {
                name: "a_extrude",
                components: 2,
                type: "Int16"
            }
        ], 4), al = vi([
            {
                name: "a_pos",
                components: 2,
                type: "Float32"
            },
            {
                name: "a_radius",
                components: 1,
                type: "Float32"
            },
            {
                name: "a_flags",
                components: 2,
                type: "Int16"
            }
        ], 4);
        function sl(t1, e1, r) {
            return t1.sections.forEach((t1)=>{
                t1.text = function(t1, e1, r) {
                    const n = e1.layout.get("text-transform").evaluate(r, {});
                    return "uppercase" === n ? t1 = t1.toLocaleUpperCase() : "lowercase" === n && (t1 = t1.toLocaleLowerCase()), Wn.applyArabicShaping && (t1 = Wn.applyArabicShaping(t1)), t1;
                }(t1.text, e1, r);
            }), t1;
        }
        vi([
            {
                name: "triangle",
                components: 3,
                type: "Uint16"
            }
        ]), vi([
            {
                type: "Int16",
                name: "anchorX"
            },
            {
                type: "Int16",
                name: "anchorY"
            },
            {
                type: "Uint16",
                name: "glyphStartIndex"
            },
            {
                type: "Uint16",
                name: "numGlyphs"
            },
            {
                type: "Uint32",
                name: "vertexStartIndex"
            },
            {
                type: "Uint32",
                name: "lineStartIndex"
            },
            {
                type: "Uint32",
                name: "lineLength"
            },
            {
                type: "Uint16",
                name: "segment"
            },
            {
                type: "Uint16",
                name: "lowerSize"
            },
            {
                type: "Uint16",
                name: "upperSize"
            },
            {
                type: "Float32",
                name: "lineOffsetX"
            },
            {
                type: "Float32",
                name: "lineOffsetY"
            },
            {
                type: "Uint8",
                name: "writingMode"
            },
            {
                type: "Uint8",
                name: "placedOrientation"
            },
            {
                type: "Uint8",
                name: "hidden"
            },
            {
                type: "Uint32",
                name: "crossTileID"
            },
            {
                type: "Int16",
                name: "associatedIconIndex"
            }
        ]), vi([
            {
                type: "Int16",
                name: "anchorX"
            },
            {
                type: "Int16",
                name: "anchorY"
            },
            {
                type: "Int16",
                name: "rightJustifiedTextSymbolIndex"
            },
            {
                type: "Int16",
                name: "centerJustifiedTextSymbolIndex"
            },
            {
                type: "Int16",
                name: "leftJustifiedTextSymbolIndex"
            },
            {
                type: "Int16",
                name: "verticalPlacedTextSymbolIndex"
            },
            {
                type: "Int16",
                name: "placedIconSymbolIndex"
            },
            {
                type: "Int16",
                name: "verticalPlacedIconSymbolIndex"
            },
            {
                type: "Uint16",
                name: "key"
            },
            {
                type: "Uint16",
                name: "textBoxStartIndex"
            },
            {
                type: "Uint16",
                name: "textBoxEndIndex"
            },
            {
                type: "Uint16",
                name: "verticalTextBoxStartIndex"
            },
            {
                type: "Uint16",
                name: "verticalTextBoxEndIndex"
            },
            {
                type: "Uint16",
                name: "iconBoxStartIndex"
            },
            {
                type: "Uint16",
                name: "iconBoxEndIndex"
            },
            {
                type: "Uint16",
                name: "verticalIconBoxStartIndex"
            },
            {
                type: "Uint16",
                name: "verticalIconBoxEndIndex"
            },
            {
                type: "Uint16",
                name: "featureIndex"
            },
            {
                type: "Uint16",
                name: "numHorizontalGlyphVertices"
            },
            {
                type: "Uint16",
                name: "numVerticalGlyphVertices"
            },
            {
                type: "Uint16",
                name: "numIconVertices"
            },
            {
                type: "Uint16",
                name: "numVerticalIconVertices"
            },
            {
                type: "Uint16",
                name: "useRuntimeCollisionCircles"
            },
            {
                type: "Uint32",
                name: "crossTileID"
            },
            {
                type: "Float32",
                name: "textBoxScale"
            },
            {
                type: "Float32",
                components: 2,
                name: "textOffset"
            },
            {
                type: "Float32",
                name: "collisionCircleDiameter"
            }
        ]), vi([
            {
                type: "Float32",
                name: "offsetX"
            }
        ]), vi([
            {
                type: "Int16",
                name: "x"
            },
            {
                type: "Int16",
                name: "y"
            },
            {
                type: "Int16",
                name: "tileUnitDistanceFromAnchor"
            }
        ]);
        const ol = {
            "!": "︕",
            "#": "＃",
            $: "＄",
            "%": "％",
            "&": "＆",
            "(": "︵",
            ")": "︶",
            "*": "＊",
            "+": "＋",
            ",": "︐",
            "-": "︲",
            ".": "・",
            "/": "／",
            ":": "︓",
            ";": "︔",
            "<": "︿",
            "=": "＝",
            ">": "﹀",
            "?": "︖",
            "@": "＠",
            "[": "﹇",
            "\\": "＼",
            "]": "﹈",
            "^": "＾",
            _: "︳",
            "`": "｀",
            "{": "︷",
            "|": "―",
            "}": "︸",
            "~": "～",
            "\xa2": "￠",
            "\xa3": "￡",
            "\xa5": "￥",
            "\xa6": "￤",
            "\xac": "￢",
            "\xaf": "￣",
            "–": "︲",
            "—": "︱",
            "‘": "﹃",
            "’": "﹄",
            "“": "﹁",
            "”": "﹂",
            "…": "︙",
            "‧": "・",
            "₩": "￦",
            "、": "︑",
            "。": "︒",
            "〈": "︿",
            "〉": "﹀",
            "《": "︽",
            "》": "︾",
            "「": "﹁",
            "」": "﹂",
            "『": "﹃",
            "』": "﹄",
            "【": "︻",
            "】": "︼",
            "〔": "︹",
            "〕": "︺",
            "〖": "︗",
            "〗": "︘",
            "！": "︕",
            "（": "︵",
            "）": "︶",
            "，": "︐",
            "－": "︲",
            "．": "・",
            "：": "︓",
            "；": "︔",
            "＜": "︿",
            "＞": "﹀",
            "？": "︖",
            "［": "﹇",
            "］": "﹈",
            "＿": "︳",
            "｛": "︷",
            "｜": "―",
            "｝": "︸",
            "｟": "︵",
            "｠": "︶",
            "｡": "︒",
            "｢": "﹁",
            "｣": "﹂"
        };
        var ll = 24, ul = pl, cl = function(t1, e1, r, n, i) {
            var a, s, o = 8 * i - n - 1, l = (1 << o) - 1, u = l >> 1, c = -7, h = r ? i - 1 : 0, p = r ? -1 : 1, f = t1[e1 + h];
            for(h += p, a = f & (1 << -c) - 1, f >>= -c, c += o; c > 0; a = 256 * a + t1[e1 + h], h += p, c -= 8);
            for(s = a & (1 << -c) - 1, a >>= -c, c += n; c > 0; s = 256 * s + t1[e1 + h], h += p, c -= 8);
            if (0 === a) a = 1 - u;
            else {
                if (a === l) return s ? NaN : 1 / 0 * (f ? -1 : 1);
                s += Math.pow(2, n), a -= u;
            }
            return (f ? -1 : 1) * s * Math.pow(2, a - n);
        }, hl = function(t1, e1, r, n, i, a) {
            var s, o, l, u = 8 * a - i - 1, c = (1 << u) - 1, h = c >> 1, p = 23 === i ? Math.pow(2, -24) - Math.pow(2, -77) : 0, f = n ? 0 : a - 1, d = n ? 1 : -1, y = e1 < 0 || 0 === e1 && 1 / e1 < 0 ? 1 : 0;
            for(e1 = Math.abs(e1), isNaN(e1) || e1 === 1 / 0 ? (o = isNaN(e1) ? 1 : 0, s = c) : (s = Math.floor(Math.log(e1) / Math.LN2), e1 * (l = Math.pow(2, -s)) < 1 && (s--, l *= 2), (e1 += s + h >= 1 ? p / l : p * Math.pow(2, 1 - h)) * l >= 2 && (s++, l /= 2), s + h >= c ? (o = 0, s = c) : s + h >= 1 ? (o = (e1 * l - 1) * Math.pow(2, i), s += h) : (o = e1 * Math.pow(2, h - 1) * Math.pow(2, i), s = 0)); i >= 8; t1[r + f] = 255 & o, f += d, o /= 256, i -= 8);
            for(s = s << i | o, u += i; u > 0; t1[r + f] = 255 & s, f += d, s /= 256, u -= 8);
            t1[r + f - d] |= 128 * y;
        };
        function pl(t1) {
            this.buf = ArrayBuffer.isView && ArrayBuffer.isView(t1) ? t1 : new Uint8Array(t1 || 0), this.pos = 0, this.type = 0, this.length = this.buf.length;
        }
        pl.Varint = 0, pl.Fixed64 = 1, pl.Bytes = 2, pl.Fixed32 = 5;
        var fl, dl = 4294967296, yl = 1 / dl, ml = "undefined" == typeof TextDecoder ? null : new TextDecoder("utf8");
        function gl(t1) {
            return t1.type === pl.Bytes ? t1.readVarint() + t1.pos : t1.pos + 1;
        }
        function xl(t1, e1, r) {
            return r ? 4294967296 * e1 + (t1 >>> 0) : 4294967296 * (e1 >>> 0) + (t1 >>> 0);
        }
        function vl(t1, e1, r) {
            var n = e1 <= 16383 ? 1 : e1 <= 2097151 ? 2 : e1 <= 268435455 ? 3 : Math.floor(Math.log(e1) / (7 * Math.LN2));
            r.realloc(n);
            for(var i = r.pos - 1; i >= t1; i--)r.buf[i + n] = r.buf[i];
        }
        function bl(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeVarint(t1[r]);
        }
        function wl(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeSVarint(t1[r]);
        }
        function _l(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeFloat(t1[r]);
        }
        function Al(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeDouble(t1[r]);
        }
        function kl(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeBoolean(t1[r]);
        }
        function Sl(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeFixed32(t1[r]);
        }
        function Il(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeSFixed32(t1[r]);
        }
        function Ml(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeFixed64(t1[r]);
        }
        function zl(t1, e1) {
            for(var r = 0; r < t1.length; r++)e1.writeSFixed64(t1[r]);
        }
        function Bl(t1, e1) {
            return (t1[e1] | t1[e1 + 1] << 8 | t1[e1 + 2] << 16) + 16777216 * t1[e1 + 3];
        }
        function Cl(t1, e1, r) {
            t1[r] = e1, t1[r + 1] = e1 >>> 8, t1[r + 2] = e1 >>> 16, t1[r + 3] = e1 >>> 24;
        }
        function Pl(t1, e1) {
            return (t1[e1] | t1[e1 + 1] << 8 | t1[e1 + 2] << 16) + (t1[e1 + 3] << 24);
        }
        function Vl(t1, e1, r) {
            1 === t1 && r.readMessage(El, e1);
        }
        function El(t1, e1, r) {
            if (3 === t1) {
                const { id: t2 , bitmap: n , width: i , height: a , left: s , top: o , advance: l  } = r.readMessage(Fl, {});
                e1.push({
                    id: t2,
                    bitmap: new zs({
                        width: i + 6,
                        height: a + 6
                    }, n),
                    metrics: {
                        width: i,
                        height: a,
                        left: s,
                        top: o,
                        advance: l
                    }
                });
            }
        }
        function Fl(t1, e1, r) {
            1 === t1 ? e1.id = r.readVarint() : 2 === t1 ? e1.bitmap = r.readBytes() : 3 === t1 ? e1.width = r.readVarint() : 4 === t1 ? e1.height = r.readVarint() : 5 === t1 ? e1.left = r.readSVarint() : 6 === t1 ? e1.top = r.readSVarint() : 7 === t1 && (e1.advance = r.readVarint());
        }
        function Tl(t1) {
            let e1 = 0, r = 0;
            for (const n of t1)e1 += n.w * n.h, r = Math.max(r, n.w);
            t1.sort((t1, e1)=>e1.h - t1.h);
            const n1 = [
                {
                    x: 0,
                    y: 0,
                    w: Math.max(Math.ceil(Math.sqrt(e1 / .95)), r),
                    h: 1 / 0
                }
            ];
            let i = 0, a = 0;
            for (const e2 of t1)for(let t2 = n1.length - 1; t2 >= 0; t2--){
                const r1 = n1[t2];
                if (!(e2.w > r1.w || e2.h > r1.h)) {
                    if (e2.x = r1.x, e2.y = r1.y, a = Math.max(a, e2.y + e2.h), i = Math.max(i, e2.x + e2.w), e2.w === r1.w && e2.h === r1.h) {
                        const e3 = n1.pop();
                        t2 < n1.length && (n1[t2] = e3);
                    } else e2.h === r1.h ? (r1.x += e2.w, r1.w -= e2.w) : e2.w === r1.w ? (r1.y += e2.h, r1.h -= e2.h) : (n1.push({
                        x: r1.x + e2.w,
                        y: r1.y,
                        w: r1.w - e2.w,
                        h: e2.h
                    }), r1.y += e2.h, r1.h -= e2.h);
                    break;
                }
            }
            return {
                w: i,
                h: a,
                fill: e1 / (i * a) || 0
            };
        }
        pl.prototype = {
            destroy: function() {
                this.buf = null;
            },
            readFields: function(t1, e1, r) {
                for(r = r || this.length; this.pos < r;){
                    var n = this.readVarint(), i = n >> 3, a = this.pos;
                    this.type = 7 & n, t1(i, e1, this), this.pos === a && this.skip(n);
                }
                return e1;
            },
            readMessage: function(t1, e1) {
                return this.readFields(t1, e1, this.readVarint() + this.pos);
            },
            readFixed32: function() {
                var t1 = Bl(this.buf, this.pos);
                return this.pos += 4, t1;
            },
            readSFixed32: function() {
                var t1 = Pl(this.buf, this.pos);
                return this.pos += 4, t1;
            },
            readFixed64: function() {
                var t1 = Bl(this.buf, this.pos) + Bl(this.buf, this.pos + 4) * dl;
                return this.pos += 8, t1;
            },
            readSFixed64: function() {
                var t1 = Bl(this.buf, this.pos) + Pl(this.buf, this.pos + 4) * dl;
                return this.pos += 8, t1;
            },
            readFloat: function() {
                var t1 = cl(this.buf, this.pos, !0, 23, 4);
                return this.pos += 4, t1;
            },
            readDouble: function() {
                var t1 = cl(this.buf, this.pos, !0, 52, 8);
                return this.pos += 8, t1;
            },
            readVarint: function(t1) {
                var e1, r, n = this.buf;
                return e1 = 127 & (r = n[this.pos++]), r < 128 ? e1 : (e1 |= (127 & (r = n[this.pos++])) << 7, r < 128 ? e1 : (e1 |= (127 & (r = n[this.pos++])) << 14, r < 128 ? e1 : (e1 |= (127 & (r = n[this.pos++])) << 21, r < 128 ? e1 : function(t1, e1, r) {
                    var n, i, a = r.buf;
                    if (n = (112 & (i = a[r.pos++])) >> 4, i < 128) return xl(t1, n, e1);
                    if (n |= (127 & (i = a[r.pos++])) << 3, i < 128) return xl(t1, n, e1);
                    if (n |= (127 & (i = a[r.pos++])) << 10, i < 128) return xl(t1, n, e1);
                    if (n |= (127 & (i = a[r.pos++])) << 17, i < 128) return xl(t1, n, e1);
                    if (n |= (127 & (i = a[r.pos++])) << 24, i < 128) return xl(t1, n, e1);
                    if (n |= (1 & (i = a[r.pos++])) << 31, i < 128) return xl(t1, n, e1);
                    throw new Error("Expected varint not more than 10 bytes");
                }(e1 |= (15 & (r = n[this.pos])) << 28, t1, this))));
            },
            readVarint64: function() {
                return this.readVarint(!0);
            },
            readSVarint: function() {
                var t1 = this.readVarint();
                return t1 % 2 == 1 ? (t1 + 1) / -2 : t1 / 2;
            },
            readBoolean: function() {
                return Boolean(this.readVarint());
            },
            readString: function() {
                var t1 = this.readVarint() + this.pos, e1 = this.pos;
                return this.pos = t1, t1 - e1 >= 12 && ml ? function(t1, e1, r) {
                    return ml.decode(t1.subarray(e1, r));
                }(this.buf, e1, t1) : function(t1, e1, r) {
                    for(var n = "", i = e1; i < r;){
                        var a, s, o, l = t1[i], u = null, c = l > 239 ? 4 : l > 223 ? 3 : l > 191 ? 2 : 1;
                        if (i + c > r) break;
                        1 === c ? l < 128 && (u = l) : 2 === c ? 128 == (192 & (a = t1[i + 1])) && (u = (31 & l) << 6 | 63 & a) <= 127 && (u = null) : 3 === c ? (s = t1[i + 2], 128 == (192 & (a = t1[i + 1])) && 128 == (192 & s) && ((u = (15 & l) << 12 | (63 & a) << 6 | 63 & s) <= 2047 || u >= 55296 && u <= 57343) && (u = null)) : 4 === c && (s = t1[i + 2], o = t1[i + 3], 128 == (192 & (a = t1[i + 1])) && 128 == (192 & s) && 128 == (192 & o) && ((u = (15 & l) << 18 | (63 & a) << 12 | (63 & s) << 6 | 63 & o) <= 65535 || u >= 1114112) && (u = null)), null === u ? (u = 65533, c = 1) : u > 65535 && (u -= 65536, n += String.fromCharCode(u >>> 10 & 1023 | 55296), u = 56320 | 1023 & u), n += String.fromCharCode(u), i += c;
                    }
                    return n;
                }(this.buf, e1, t1);
            },
            readBytes: function() {
                var t1 = this.readVarint() + this.pos, e1 = this.buf.subarray(this.pos, t1);
                return this.pos = t1, e1;
            },
            readPackedVarint: function(t1, e1) {
                if (this.type !== pl.Bytes) return t1.push(this.readVarint(e1));
                var r = gl(this);
                for(t1 = t1 || []; this.pos < r;)t1.push(this.readVarint(e1));
                return t1;
            },
            readPackedSVarint: function(t1) {
                if (this.type !== pl.Bytes) return t1.push(this.readSVarint());
                var e1 = gl(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readSVarint());
                return t1;
            },
            readPackedBoolean: function(t1) {
                if (this.type !== pl.Bytes) return t1.push(this.readBoolean());
                var e1 = gl(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readBoolean());
                return t1;
            },
            readPackedFloat: function(t1) {
                if (this.type !== pl.Bytes) return t1.push(this.readFloat());
                var e1 = gl(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readFloat());
                return t1;
            },
            readPackedDouble: function(t1) {
                if (this.type !== pl.Bytes) return t1.push(this.readDouble());
                var e1 = gl(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readDouble());
                return t1;
            },
            readPackedFixed32: function(t1) {
                if (this.type !== pl.Bytes) return t1.push(this.readFixed32());
                var e1 = gl(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readFixed32());
                return t1;
            },
            readPackedSFixed32: function(t1) {
                if (this.type !== pl.Bytes) return t1.push(this.readSFixed32());
                var e1 = gl(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readSFixed32());
                return t1;
            },
            readPackedFixed64: function(t1) {
                if (this.type !== pl.Bytes) return t1.push(this.readFixed64());
                var e1 = gl(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readFixed64());
                return t1;
            },
            readPackedSFixed64: function(t1) {
                if (this.type !== pl.Bytes) return t1.push(this.readSFixed64());
                var e1 = gl(this);
                for(t1 = t1 || []; this.pos < e1;)t1.push(this.readSFixed64());
                return t1;
            },
            skip: function(t1) {
                var e1 = 7 & t1;
                if (e1 === pl.Varint) for(; this.buf[this.pos++] > 127;);
                else if (e1 === pl.Bytes) this.pos = this.readVarint() + this.pos;
                else if (e1 === pl.Fixed32) this.pos += 4;
                else {
                    if (e1 !== pl.Fixed64) throw new Error("Unimplemented type: " + e1);
                    this.pos += 8;
                }
            },
            writeTag: function(t1, e1) {
                this.writeVarint(t1 << 3 | e1);
            },
            realloc: function(t1) {
                for(var e1 = this.length || 16; e1 < this.pos + t1;)e1 *= 2;
                if (e1 !== this.length) {
                    var r = new Uint8Array(e1);
                    r.set(this.buf), this.buf = r, this.length = e1;
                }
            },
            finish: function() {
                return this.length = this.pos, this.pos = 0, this.buf.subarray(0, this.length);
            },
            writeFixed32: function(t1) {
                this.realloc(4), Cl(this.buf, t1, this.pos), this.pos += 4;
            },
            writeSFixed32: function(t1) {
                this.realloc(4), Cl(this.buf, t1, this.pos), this.pos += 4;
            },
            writeFixed64: function(t1) {
                this.realloc(8), Cl(this.buf, -1 & t1, this.pos), Cl(this.buf, Math.floor(t1 * yl), this.pos + 4), this.pos += 8;
            },
            writeSFixed64: function(t1) {
                this.realloc(8), Cl(this.buf, -1 & t1, this.pos), Cl(this.buf, Math.floor(t1 * yl), this.pos + 4), this.pos += 8;
            },
            writeVarint: function(t1) {
                (t1 = +t1 || 0) > 268435455 || t1 < 0 ? function(t1, e1) {
                    var r, n;
                    if (t1 >= 0 ? (r = t1 % 4294967296 | 0, n = t1 / 4294967296 | 0) : (n = ~(-t1 / 4294967296), 4294967295 ^ (r = ~(-t1 % 4294967296)) ? r = r + 1 | 0 : (r = 0, n = n + 1 | 0)), t1 >= 0x10000000000000000 || t1 < -18446744073709552000) throw new Error("Given varint doesn't fit into 10 bytes");
                    e1.realloc(10), function(t1, e1, r) {
                        r.buf[r.pos++] = 127 & t1 | 128, t1 >>>= 7, r.buf[r.pos++] = 127 & t1 | 128, t1 >>>= 7, r.buf[r.pos++] = 127 & t1 | 128, t1 >>>= 7, r.buf[r.pos++] = 127 & t1 | 128, r.buf[r.pos] = 127 & (t1 >>>= 7);
                    }(r, 0, e1), function(t1, e1) {
                        var r = (7 & t1) << 4;
                        e1.buf[e1.pos++] |= r | ((t1 >>>= 3) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1 | ((t1 >>>= 7) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1 | ((t1 >>>= 7) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1 | ((t1 >>>= 7) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1 | ((t1 >>>= 7) ? 128 : 0), t1 && (e1.buf[e1.pos++] = 127 & t1)))));
                    }(n, e1);
                }(t1, this) : (this.realloc(4), this.buf[this.pos++] = 127 & t1 | (t1 > 127 ? 128 : 0), t1 <= 127 || (this.buf[this.pos++] = 127 & (t1 >>>= 7) | (t1 > 127 ? 128 : 0), t1 <= 127 || (this.buf[this.pos++] = 127 & (t1 >>>= 7) | (t1 > 127 ? 128 : 0), t1 <= 127 || (this.buf[this.pos++] = t1 >>> 7 & 127))));
            },
            writeSVarint: function(t1) {
                this.writeVarint(t1 < 0 ? 2 * -t1 - 1 : 2 * t1);
            },
            writeBoolean: function(t1) {
                this.writeVarint(Boolean(t1));
            },
            writeString: function(t1) {
                t1 = String(t1), this.realloc(4 * t1.length), this.pos++;
                var e1 = this.pos;
                this.pos = function(t1, e1, r) {
                    for(var n, i, a = 0; a < e1.length; a++){
                        if ((n = e1.charCodeAt(a)) > 55295 && n < 57344) {
                            if (!i) {
                                n > 56319 || a + 1 === e1.length ? (t1[r++] = 239, t1[r++] = 191, t1[r++] = 189) : i = n;
                                continue;
                            }
                            if (n < 56320) {
                                t1[r++] = 239, t1[r++] = 191, t1[r++] = 189, i = n;
                                continue;
                            }
                            n = i - 55296 << 10 | n - 56320 | 65536, i = null;
                        } else i && (t1[r++] = 239, t1[r++] = 191, t1[r++] = 189, i = null);
                        n < 128 ? t1[r++] = n : (n < 2048 ? t1[r++] = n >> 6 | 192 : (n < 65536 ? t1[r++] = n >> 12 | 224 : (t1[r++] = n >> 18 | 240, t1[r++] = n >> 12 & 63 | 128), t1[r++] = n >> 6 & 63 | 128), t1[r++] = 63 & n | 128);
                    }
                    return r;
                }(this.buf, t1, this.pos);
                var r = this.pos - e1;
                r >= 128 && vl(e1, r, this), this.pos = e1 - 1, this.writeVarint(r), this.pos += r;
            },
            writeFloat: function(t1) {
                this.realloc(4), hl(this.buf, t1, this.pos, !0, 23, 4), this.pos += 4;
            },
            writeDouble: function(t1) {
                this.realloc(8), hl(this.buf, t1, this.pos, !0, 52, 8), this.pos += 8;
            },
            writeBytes: function(t1) {
                var e1 = t1.length;
                this.writeVarint(e1), this.realloc(e1);
                for(var r = 0; r < e1; r++)this.buf[this.pos++] = t1[r];
            },
            writeRawMessage: function(t1, e1) {
                this.pos++;
                var r = this.pos;
                t1(e1, this);
                var n = this.pos - r;
                n >= 128 && vl(r, n, this), this.pos = r - 1, this.writeVarint(n), this.pos += n;
            },
            writeMessage: function(t1, e1, r) {
                this.writeTag(t1, pl.Bytes), this.writeRawMessage(e1, r);
            },
            writePackedVarint: function(t1, e1) {
                e1.length && this.writeMessage(t1, bl, e1);
            },
            writePackedSVarint: function(t1, e1) {
                e1.length && this.writeMessage(t1, wl, e1);
            },
            writePackedBoolean: function(t1, e1) {
                e1.length && this.writeMessage(t1, kl, e1);
            },
            writePackedFloat: function(t1, e1) {
                e1.length && this.writeMessage(t1, _l, e1);
            },
            writePackedDouble: function(t1, e1) {
                e1.length && this.writeMessage(t1, Al, e1);
            },
            writePackedFixed32: function(t1, e1) {
                e1.length && this.writeMessage(t1, Sl, e1);
            },
            writePackedSFixed32: function(t1, e1) {
                e1.length && this.writeMessage(t1, Il, e1);
            },
            writePackedFixed64: function(t1, e1) {
                e1.length && this.writeMessage(t1, Ml, e1);
            },
            writePackedSFixed64: function(t1, e1) {
                e1.length && this.writeMessage(t1, zl, e1);
            },
            writeBytesField: function(t1, e1) {
                this.writeTag(t1, pl.Bytes), this.writeBytes(e1);
            },
            writeFixed32Field: function(t1, e1) {
                this.writeTag(t1, pl.Fixed32), this.writeFixed32(e1);
            },
            writeSFixed32Field: function(t1, e1) {
                this.writeTag(t1, pl.Fixed32), this.writeSFixed32(e1);
            },
            writeFixed64Field: function(t1, e1) {
                this.writeTag(t1, pl.Fixed64), this.writeFixed64(e1);
            },
            writeSFixed64Field: function(t1, e1) {
                this.writeTag(t1, pl.Fixed64), this.writeSFixed64(e1);
            },
            writeVarintField: function(t1, e1) {
                this.writeTag(t1, pl.Varint), this.writeVarint(e1);
            },
            writeSVarintField: function(t1, e1) {
                this.writeTag(t1, pl.Varint), this.writeSVarint(e1);
            },
            writeStringField: function(t1, e1) {
                this.writeTag(t1, pl.Bytes), this.writeString(e1);
            },
            writeFloatField: function(t1, e1) {
                this.writeTag(t1, pl.Fixed32), this.writeFloat(e1);
            },
            writeDoubleField: function(t1, e1) {
                this.writeTag(t1, pl.Fixed64), this.writeDouble(e1);
            },
            writeBooleanField: function(t1, e1) {
                this.writeVarintField(t1, Boolean(e1));
            }
        };
        class Ll {
            constructor(t1, { pixelRatio: e1 , version: r , stretchX: n , stretchY: i , content: a  }){
                this.paddedRect = t1, this.pixelRatio = e1, this.stretchX = n, this.stretchY = i, this.content = a, this.version = r;
            }
            get tl() {
                return [
                    this.paddedRect.x + 1,
                    this.paddedRect.y + 1
                ];
            }
            get br() {
                return [
                    this.paddedRect.x + this.paddedRect.w - 1,
                    this.paddedRect.y + this.paddedRect.h - 1
                ];
            }
            get tlbr() {
                return this.tl.concat(this.br);
            }
            get displaySize() {
                return [
                    (this.paddedRect.w - 2) / this.pixelRatio,
                    (this.paddedRect.h - 2) / this.pixelRatio
                ];
            }
        }
        class Dl {
            constructor(t1, e1){
                const r = {}, n = {};
                this.haveRenderCallbacks = [];
                const i = [];
                this.addImages(t1, r, i), this.addImages(e1, n, i);
                const { w: a , h: s  } = Tl(i), o = new Bs({
                    width: a || 1,
                    height: s || 1
                });
                for(const e2 in t1){
                    const n1 = t1[e2], i1 = r[e2].paddedRect;
                    Bs.copy(n1.data, o, {
                        x: 0,
                        y: 0
                    }, {
                        x: i1.x + 1,
                        y: i1.y + 1
                    }, n1.data);
                }
                for(const t2 in e1){
                    const r1 = e1[t2], i2 = n[t2].paddedRect, a1 = i2.x + 1, s1 = i2.y + 1, l = r1.data.width, u = r1.data.height;
                    Bs.copy(r1.data, o, {
                        x: 0,
                        y: 0
                    }, {
                        x: a1,
                        y: s1
                    }, r1.data), Bs.copy(r1.data, o, {
                        x: 0,
                        y: u - 1
                    }, {
                        x: a1,
                        y: s1 - 1
                    }, {
                        width: l,
                        height: 1
                    }), Bs.copy(r1.data, o, {
                        x: 0,
                        y: 0
                    }, {
                        x: a1,
                        y: s1 + u
                    }, {
                        width: l,
                        height: 1
                    }), Bs.copy(r1.data, o, {
                        x: l - 1,
                        y: 0
                    }, {
                        x: a1 - 1,
                        y: s1
                    }, {
                        width: 1,
                        height: u
                    }), Bs.copy(r1.data, o, {
                        x: 0,
                        y: 0
                    }, {
                        x: a1 + l,
                        y: s1
                    }, {
                        width: 1,
                        height: u
                    });
                }
                this.image = o, this.iconPositions = r, this.patternPositions = n;
            }
            addImages(t1, e1, r) {
                for(const n in t1){
                    const i = t1[n], a = {
                        x: 0,
                        y: 0,
                        w: i.data.width + 2,
                        h: i.data.height + 2
                    };
                    r.push(a), e1[n] = new Ll(a, i), i.hasRenderCallback && this.haveRenderCallbacks.push(n);
                }
            }
            patchUpdatedImages(t1, e1) {
                t1.dispatchRenderCallbacks(this.haveRenderCallbacks);
                for(const r in t1.updatedImages)this.patchUpdatedImage(this.iconPositions[r], t1.getImage(r), e1), this.patchUpdatedImage(this.patternPositions[r], t1.getImage(r), e1);
            }
            patchUpdatedImage(t1, e1, r) {
                if (!t1 || !e1) return;
                if (t1.version === e1.version) return;
                t1.version = e1.version;
                const [n, i] = t1.tl;
                r.update(e1.data, void 0, {
                    x: n,
                    y: i
                });
            }
        }
        Mn("ImagePosition", Ll), Mn("ImageAtlas", Dl), t1.WritingMode = void 0, (fl = t1.WritingMode || (t1.WritingMode = {}))[fl.none = 0] = "none", fl[fl.horizontal = 1] = "horizontal", fl[fl.vertical = 2] = "vertical", fl[fl.horizontalOnly = 3] = "horizontalOnly";
        const $l = -17;
        class Rl {
            constructor(){
                this.scale = 1, this.fontStack = "", this.imageName = null;
            }
            static forText(t1, e1) {
                const r = new Rl;
                return r.scale = t1 || 1, r.fontStack = e1, r;
            }
            static forImage(t1) {
                const e1 = new Rl;
                return e1.imageName = t1, e1;
            }
        }
        class Ol {
            constructor(){
                this.text = "", this.sectionIndex = [], this.sections = [], this.imageSectionID = null;
            }
            static fromFeature(t1, e1) {
                const r = new Ol;
                for(let n = 0; n < t1.sections.length; n++){
                    const i = t1.sections[n];
                    i.image ? r.addImageSection(i) : r.addTextSection(i, e1);
                }
                return r;
            }
            length() {
                return this.text.length;
            }
            getSection(t1) {
                return this.sections[this.sectionIndex[t1]];
            }
            getSectionIndex(t1) {
                return this.sectionIndex[t1];
            }
            getCharCode(t1) {
                return this.text.charCodeAt(t1);
            }
            verticalizePunctuation() {
                this.text = function(t1) {
                    let e1 = "";
                    for(let r = 0; r < t1.length; r++){
                        const n = t1.charCodeAt(r + 1) || null, i = t1.charCodeAt(r - 1) || null;
                        e1 += n && Dn(n) && !ol[t1[r + 1]] || i && Dn(i) && !ol[t1[r - 1]] || !ol[t1[r]] ? t1[r] : ol[t1[r]];
                    }
                    return e1;
                }(this.text);
            }
            trim() {
                let t1 = 0;
                for(let e1 = 0; e1 < this.text.length && ql[this.text.charCodeAt(e1)]; e1++)t1++;
                let e2 = this.text.length;
                for(let r = this.text.length - 1; r >= 0 && r >= t1 && ql[this.text.charCodeAt(r)]; r--)e2--;
                this.text = this.text.substring(t1, e2), this.sectionIndex = this.sectionIndex.slice(t1, e2);
            }
            substring(t1, e1) {
                const r = new Ol;
                return r.text = this.text.substring(t1, e1), r.sectionIndex = this.sectionIndex.slice(t1, e1), r.sections = this.sections, r;
            }
            toString() {
                return this.text;
            }
            getMaxScale() {
                return this.sectionIndex.reduce((t1, e1)=>Math.max(t1, this.sections[e1].scale), 0);
            }
            addTextSection(t1, e1) {
                this.text += t1.text, this.sections.push(Rl.forText(t1.scale, t1.fontStack || e1));
                const r = this.sections.length - 1;
                for(let e2 = 0; e2 < t1.text.length; ++e2)this.sectionIndex.push(r);
            }
            addImageSection(t1) {
                const e1 = t1.image ? t1.image.name : "";
                if (0 === e1.length) return void d("Can't add FormattedSection with an empty image.");
                const r = this.getNextImageSectionCharCode();
                r ? (this.text += String.fromCharCode(r), this.sections.push(Rl.forImage(e1)), this.sectionIndex.push(this.sections.length - 1)) : d("Reached maximum number of images 6401");
            }
            getNextImageSectionCharCode() {
                return this.imageSectionID ? this.imageSectionID >= 63743 ? null : ++this.imageSectionID : (this.imageSectionID = 57344, this.imageSectionID);
            }
        }
        function Ul(e1, r, n, i, a, s, o, l, u, c, h, p, f, d, y, m) {
            const g = Ol.fromFeature(e1, a);
            let x;
            p === t1.WritingMode.vertical && g.verticalizePunctuation();
            const { processBidirectionalText: v , processStyledBidirectionalText: b  } = Wn;
            if (v && 1 === g.sections.length) {
                x = [];
                const t2 = v(g.toString(), Xl(g, c, s, r, i, d, y));
                for (const e2 of t2){
                    const t3 = new Ol;
                    t3.text = e2, t3.sections = g.sections;
                    for(let r1 = 0; r1 < e2.length; r1++)t3.sectionIndex.push(0);
                    x.push(t3);
                }
            } else if (b) {
                x = [];
                const t4 = b(g.text, g.sectionIndex, Xl(g, c, s, r, i, d, y));
                for (const e3 of t4){
                    const t5 = new Ol;
                    t5.text = e3[0], t5.sectionIndex = e3[1], t5.sections = g.sections, x.push(t5);
                }
            } else x = function(t1, e1) {
                const r = [], n = t1.text;
                let i = 0;
                for (const n1 of e1)r.push(t1.substring(i, n1)), i = n1;
                return i < n.length && r.push(t1.substring(i, n.length)), r;
            }(g, Xl(g, c, s, r, i, d, y));
            const w = [], _ = {
                positionedLines: w,
                text: g.toString(),
                top: h[1],
                bottom: h[1],
                left: h[0],
                right: h[0],
                writingMode: p,
                iconsInText: !1,
                verticalizable: !1
            };
            return function(e1, r, n, i, a, s, o, l, u, c, h, p) {
                let f = 0, d = $l, y = 0, m = 0;
                const g = "right" === l ? 1 : "left" === l ? 0 : .5;
                let x = 0;
                for (const o1 of a){
                    o1.trim();
                    const a1 = o1.getMaxScale(), l1 = (a1 - 1) * ll, b = {
                        positionedGlyphs: [],
                        lineOffset: 0
                    };
                    e1.positionedLines[x] = b;
                    const w = b.positionedGlyphs;
                    let _ = 0;
                    if (!o1.length()) {
                        d += s, ++x;
                        continue;
                    }
                    for(let s1 = 0; s1 < o1.length(); s1++){
                        const y1 = o1.getSection(s1), m1 = o1.getSectionIndex(s1), g1 = o1.getCharCode(s1);
                        let x1 = 0, b1 = null, A = null, k = null, S = ll;
                        const I = !(u === t1.WritingMode.horizontal || !h && !Ln(g1) || h && (ql[g1] || (v = g1, Vn.Arabic(v) || Vn["Arabic Supplement"](v) || Vn["Arabic Extended-A"](v) || Vn["Arabic Presentation Forms-A"](v) || Vn["Arabic Presentation Forms-B"](v))));
                        if (y1.imageName) {
                            const t2 = i[y1.imageName];
                            if (!t2) continue;
                            k = y1.imageName, e1.iconsInText = e1.iconsInText || !0, A = t2.paddedRect;
                            const r1 = t2.displaySize;
                            y1.scale = y1.scale * ll / p, b1 = {
                                width: r1[0],
                                height: r1[1],
                                left: 1,
                                top: -3,
                                advance: I ? r1[1] : r1[0]
                            }, x1 = l1 + (ll - r1[1] * y1.scale), S = b1.advance;
                            const n1 = I ? r1[0] * y1.scale - ll * a1 : r1[1] * y1.scale - ll * a1;
                            n1 > 0 && n1 > _ && (_ = n1);
                        } else {
                            const t3 = n[y1.fontStack], e2 = t3 && t3[g1];
                            if (e2 && e2.rect) A = e2.rect, b1 = e2.metrics;
                            else {
                                const t4 = r[y1.fontStack], e3 = t4 && t4[g1];
                                if (!e3) continue;
                                b1 = e3.metrics;
                            }
                            x1 = (a1 - y1.scale) * ll;
                        }
                        I ? (e1.verticalizable = !0, w.push({
                            glyph: g1,
                            imageName: k,
                            x: f,
                            y: d + x1,
                            vertical: I,
                            scale: y1.scale,
                            fontStack: y1.fontStack,
                            sectionIndex: m1,
                            metrics: b1,
                            rect: A
                        }), f += S * y1.scale + c) : (w.push({
                            glyph: g1,
                            imageName: k,
                            x: f,
                            y: d + x1,
                            vertical: I,
                            scale: y1.scale,
                            fontStack: y1.fontStack,
                            sectionIndex: m1,
                            metrics: b1,
                            rect: A
                        }), f += b1.advance * y1.scale + c);
                    }
                    0 !== w.length && (y = Math.max(f - c, y), Hl(w, 0, w.length - 1, g, _)), f = 0;
                    const A1 = s * a1 + _;
                    b.lineOffset = Math.max(_, l1), d += A1, m = Math.max(A1, m), ++x;
                }
                var v;
                const b2 = d - $l, { horizontalAlign: w1 , verticalAlign: _1  } = Yl(o);
                (function(t1, e1, r, n, i, a, s, o, l) {
                    const u = (e1 - r) * i;
                    let c = 0;
                    c = a !== s ? -o * n - $l : (-n * l + .5) * s;
                    for (const e2 of t1)for (const t2 of e2.positionedGlyphs)t2.x += u, t2.y += c;
                })(e1.positionedLines, g, w1, _1, y, m, s, b2, a.length), e1.top += -_1 * b2, e1.bottom = e1.top + b2, e1.left += -w1 * y, e1.right = e1.left + y;
            }(_, r, n, i, x, o, l, u, p, c, f, m), !function(t1) {
                for (const e1 of t1)if (0 !== e1.positionedGlyphs.length) return !1;
                return !0;
            }(w) && _;
        }
        const ql = {
            9: !0,
            10: !0,
            11: !0,
            12: !0,
            13: !0,
            32: !0
        }, jl = {
            10: !0,
            32: !0,
            38: !0,
            40: !0,
            41: !0,
            43: !0,
            45: !0,
            47: !0,
            173: !0,
            183: !0,
            8203: !0,
            8208: !0,
            8211: !0,
            8231: !0
        };
        function Nl(t1, e1, r, n, i, a) {
            if (e1.imageName) {
                const t2 = n[e1.imageName];
                return t2 ? t2.displaySize[0] * e1.scale * ll / a + i : 0;
            }
            {
                const n1 = r[e1.fontStack], a1 = n1 && n1[t1];
                return a1 ? a1.metrics.advance * e1.scale + i : 0;
            }
        }
        function Zl(t1, e1, r, n) {
            const i = Math.pow(t1 - e1, 2);
            return n ? t1 < e1 ? i / 2 : 2 * i : i + Math.abs(r) * r;
        }
        function Kl(t1, e1, r) {
            let n = 0;
            return 10 === t1 && (n -= 1e4), r && (n += 150), 40 !== t1 && 65288 !== t1 || (n += 50), 41 !== e1 && 65289 !== e1 || (n += 50), n;
        }
        function Gl(t1, e1, r, n, i, a) {
            let s = null, o = Zl(e1, r, i, a);
            for (const t2 of n){
                const n1 = Zl(e1 - t2.x, r, i, a) + t2.badness;
                n1 <= o && (s = t2, o = n1);
            }
            return {
                index: t1,
                x: e1,
                priorBreak: s,
                badness: o
            };
        }
        function Jl(t1) {
            return t1 ? Jl(t1.priorBreak).concat(t1.index) : [];
        }
        function Xl(t1, e1, r, n, i, a, s) {
            if ("point" !== a) return [];
            if (!t1) return [];
            const o = [], l = function(t1, e1, r, n, i, a) {
                let s = 0;
                for(let r1 = 0; r1 < t1.length(); r1++){
                    const o = t1.getSection(r1);
                    s += Nl(t1.getCharCode(r1), o, n, i, e1, a);
                }
                return s / Math.max(1, Math.ceil(s / r));
            }(t1, e1, r, n, i, s), u = t1.text.indexOf("​") >= 0;
            let c = 0;
            for(let r1 = 0; r1 < t1.length(); r1++){
                const a1 = t1.getSection(r1), p = t1.getCharCode(r1);
                if (ql[p] || (c += Nl(p, a1, n, i, e1, s)), r1 < t1.length() - 1) {
                    const e2 = !((h = p) < 11904 || !(Vn["Bopomofo Extended"](h) || Vn.Bopomofo(h) || Vn["CJK Compatibility Forms"](h) || Vn["CJK Compatibility Ideographs"](h) || Vn["CJK Compatibility"](h) || Vn["CJK Radicals Supplement"](h) || Vn["CJK Strokes"](h) || Vn["CJK Symbols and Punctuation"](h) || Vn["CJK Unified Ideographs Extension A"](h) || Vn["CJK Unified Ideographs"](h) || Vn["Enclosed CJK Letters and Months"](h) || Vn["Halfwidth and Fullwidth Forms"](h) || Vn.Hiragana(h) || Vn["Ideographic Description Characters"](h) || Vn["Kangxi Radicals"](h) || Vn["Katakana Phonetic Extensions"](h) || Vn.Katakana(h) || Vn["Vertical Forms"](h) || Vn["Yi Radicals"](h) || Vn["Yi Syllables"](h)));
                    (jl[p] || e2 || a1.imageName) && o.push(Gl(r1 + 1, c, l, o, Kl(p, t1.getCharCode(r1 + 1), e2 && u), !1));
                }
            }
            var h;
            return Jl(Gl(t1.length(), c, l, o, 0, !0));
        }
        function Yl(t1) {
            let e1 = .5, r = .5;
            switch(t1){
                case "right":
                case "top-right":
                case "bottom-right":
                    e1 = 1;
                    break;
                case "left":
                case "top-left":
                case "bottom-left":
                    e1 = 0;
            }
            switch(t1){
                case "bottom":
                case "bottom-right":
                case "bottom-left":
                    r = 1;
                    break;
                case "top":
                case "top-right":
                case "top-left":
                    r = 0;
            }
            return {
                horizontalAlign: e1,
                verticalAlign: r
            };
        }
        function Hl(t1, e1, r, n, i) {
            if (!n && !i) return;
            const a = t1[r], s = (t1[r].x + a.metrics.advance * a.scale) * n;
            for(let n1 = e1; n1 <= r; n1++)t1[n1].x -= s, t1[n1].y += i;
        }
        function Wl(t1, e1, r) {
            const { horizontalAlign: n , verticalAlign: i  } = Yl(r), a = e1[0] - t1.displaySize[0] * n, s = e1[1] - t1.displaySize[1] * i;
            return {
                image: t1,
                top: s,
                bottom: s + t1.displaySize[1],
                left: a,
                right: a + t1.displaySize[0]
            };
        }
        function Ql(t1, e1, r, n, i, a) {
            const s = t1.image;
            let o;
            if (s.content) {
                const t2 = s.content, e2 = s.pixelRatio || 1;
                o = [
                    t2[0] / e2,
                    t2[1] / e2,
                    s.displaySize[0] - t2[2] / e2,
                    s.displaySize[1] - t2[3] / e2
                ];
            }
            const l = e1.left * a, u = e1.right * a;
            let c, h, p, f;
            "width" === r || "both" === r ? (f = i[0] + l - n[3], h = i[0] + u + n[1]) : (f = i[0] + (l + u - s.displaySize[0]) / 2, h = f + s.displaySize[0]);
            const d = e1.top * a, y = e1.bottom * a;
            return "height" === r || "both" === r ? (c = i[1] + d - n[0], p = i[1] + y + n[2]) : (c = i[1] + (d + y - s.displaySize[1]) / 2, p = c + s.displaySize[1]), {
                image: s,
                top: c,
                right: h,
                bottom: p,
                left: f,
                collisionPadding: o
            };
        }
        const tu = 128;
        function eu(t1, e1) {
            const { expression: r  } = e1;
            if ("constant" === r.kind) return {
                kind: "constant",
                layoutSize: r.evaluate(new Qn(t1 + 1))
            };
            if ("source" === r.kind) return {
                kind: "source"
            };
            {
                const { zoomStops: e2 , interpolationType: n  } = r;
                let i = 0;
                for(; i < e2.length && e2[i] <= t1;)i++;
                i = Math.max(0, i - 1);
                let a = i;
                for(; a < e2.length && e2[a] < t1 + 1;)a++;
                a = Math.min(e2.length - 1, a);
                const s = e2[i], o = e2[a];
                return "composite" === r.kind ? {
                    kind: "composite",
                    minZoom: s,
                    maxZoom: o,
                    interpolationType: n
                } : {
                    kind: "camera",
                    minZoom: s,
                    maxZoom: o,
                    minSize: r.evaluate(new Qn(s)),
                    maxSize: r.evaluate(new Qn(o)),
                    interpolationType: n
                };
            }
        }
        class ru extends S {
            constructor(t1, e1, r, n){
                super(t1, e1), this.angle = r, void 0 !== n && (this.segment = n);
            }
            clone() {
                return new ru(this.x, this.y, this.angle, this.segment);
            }
        }
        function nu(t1, e1, r, n, i) {
            if (void 0 === e1.segment) return !0;
            let a = e1, s = e1.segment + 1, o = 0;
            for(; o > -r / 2;){
                if (s--, s < 0) return !1;
                o -= t1[s].dist(a), a = t1[s];
            }
            o += t1[s].dist(t1[s + 1]), s++;
            const l = [];
            let u = 0;
            for(; o < r / 2;){
                const e2 = t1[s], r1 = t1[s + 1];
                if (!r1) return !1;
                let a1 = t1[s - 1].angleTo(e2) - e2.angleTo(r1);
                for(a1 = Math.abs((a1 + 3 * Math.PI) % (2 * Math.PI) - Math.PI), l.push({
                    distance: o,
                    angleDelta: a1
                }), u += a1; o - l[0].distance > n;)u -= l.shift().angleDelta;
                if (u > i) return !1;
                s++, o += e2.dist(r1);
            }
            return !0;
        }
        function iu(t1) {
            let e1 = 0;
            for(let r = 0; r < t1.length - 1; r++)e1 += t1[r].dist(t1[r + 1]);
            return e1;
        }
        function au(t1, e1, r) {
            return t1 ? .6 * e1 * r : 0;
        }
        function su(t1, e1) {
            return Math.max(t1 ? t1.right - t1.left : 0, e1 ? e1.right - e1.left : 0);
        }
        function ou(t1, e1, r, n, i, a) {
            const s = au(r, i, a), o = su(r, n) * a;
            let l = 0;
            const u = iu(t1) / 2;
            for(let r1 = 0; r1 < t1.length - 1; r1++){
                const n1 = t1[r1], i1 = t1[r1 + 1], a1 = n1.dist(i1);
                if (l + a1 > u) {
                    const c = (u - l) / a1, h = Se(n1.x, i1.x, c), p = Se(n1.y, i1.y, c), f = new ru(h, p, i1.angleTo(n1), r1);
                    return f._round(), !s || nu(t1, f, o, s, e1) ? f : void 0;
                }
                l += a1;
            }
        }
        function lu(t1, e1, r, n, i, a, s, o, l) {
            const u = au(n, a, s), c = su(n, i), h = c * s, p = 0 === t1[0].x || t1[0].x === l || 0 === t1[0].y || t1[0].y === l;
            return e1 - h < e1 / 4 && (e1 = h + e1 / 4), uu(t1, p ? e1 / 2 * o % e1 : (c / 2 + 2 * a) * s * o % e1, e1, u, r, h, p, !1, l);
        }
        function uu(t1, e1, r, n, i, a, s, o, l) {
            const u = a / 2, c = iu(t1);
            let h = 0, p = e1 - r, f = [];
            for(let e2 = 0; e2 < t1.length - 1; e2++){
                const s1 = t1[e2], o1 = t1[e2 + 1], d = s1.dist(o1), y = o1.angleTo(s1);
                for(; p + r < h + d;){
                    p += r;
                    const m = (p - h) / d, g = Se(s1.x, o1.x, m), x = Se(s1.y, o1.y, m);
                    if (g >= 0 && g < l && x >= 0 && x < l && p - u >= 0 && p + u <= c) {
                        const r1 = new ru(g, x, y, e2);
                        r1._round(), n && !nu(t1, r1, a, n, i) || f.push(r1);
                    }
                }
                h += d;
            }
            return o || f.length || s || (f = uu(t1, h / 2, r, n, i, a, s, !0, l)), f;
        }
        function cu(t1, e1, r, n, i) {
            const a = [];
            for(let s = 0; s < t1.length; s++){
                const o = t1[s];
                let l;
                for(let t2 = 0; t2 < o.length - 1; t2++){
                    let s1 = o[t2], u = o[t2 + 1];
                    s1.x < e1 && u.x < e1 || (s1.x < e1 ? s1 = new S(e1, s1.y + (e1 - s1.x) / (u.x - s1.x) * (u.y - s1.y))._round() : u.x < e1 && (u = new S(e1, s1.y + (e1 - s1.x) / (u.x - s1.x) * (u.y - s1.y))._round()), s1.y < r && u.y < r || (s1.y < r ? s1 = new S(s1.x + (r - s1.y) / (u.y - s1.y) * (u.x - s1.x), r)._round() : u.y < r && (u = new S(s1.x + (r - s1.y) / (u.y - s1.y) * (u.x - s1.x), r)._round()), s1.x >= n && u.x >= n || (s1.x >= n ? s1 = new S(n, s1.y + (n - s1.x) / (u.x - s1.x) * (u.y - s1.y))._round() : u.x >= n && (u = new S(n, s1.y + (n - s1.x) / (u.x - s1.x) * (u.y - s1.y))._round()), s1.y >= i && u.y >= i || (s1.y >= i ? s1 = new S(s1.x + (i - s1.y) / (u.y - s1.y) * (u.x - s1.x), i)._round() : u.y >= i && (u = new S(s1.x + (i - s1.y) / (u.y - s1.y) * (u.x - s1.x), i)._round()), l && s1.equals(l[l.length - 1]) || (l = [
                        s1
                    ], a.push(l)), l.push(u)))));
                }
            }
            return a;
        }
        function hu(t1, e1, r, n) {
            const i = [], a = t1.image, s = a.pixelRatio, o = a.paddedRect.w - 2, l = a.paddedRect.h - 2, u = t1.right - t1.left, c = t1.bottom - t1.top, h = a.stretchX || [
                [
                    0,
                    o
                ]
            ], p = a.stretchY || [
                [
                    0,
                    l
                ]
            ], f = (t1, e1)=>t1 + e1[1] - e1[0], d = h.reduce(f, 0), y = p.reduce(f, 0), m = o - d, g = l - y;
            let x = 0, v = d, b = 0, w = y, _ = 0, A = m, k = 0, I = g;
            if (a.content && n) {
                const t2 = a.content;
                x = pu(h, 0, t2[0]), b = pu(p, 0, t2[1]), v = pu(h, t2[0], t2[2]), w = pu(p, t2[1], t2[3]), _ = t2[0] - x, k = t2[1] - b, A = t2[2] - t2[0] - v, I = t2[3] - t2[1] - w;
            }
            const M = (n, i, o, l)=>{
                const h = du(n.stretch - x, v, u, t1.left), p = yu(n.fixed - _, A, n.stretch, d), f = du(i.stretch - b, w, c, t1.top), m = yu(i.fixed - k, I, i.stretch, y), g = du(o.stretch - x, v, u, t1.left), M = yu(o.fixed - _, A, o.stretch, d), z = du(l.stretch - b, w, c, t1.top), B = yu(l.fixed - k, I, l.stretch, y), C = new S(h, f), P = new S(g, f), V = new S(g, z), E = new S(h, z), F = new S(p / s, m / s), T = new S(M / s, B / s), L = e1 * Math.PI / 180;
                if (L) {
                    const t2 = Math.sin(L), e2 = Math.cos(L), r1 = [
                        e2,
                        -t2,
                        t2,
                        e2
                    ];
                    C._matMult(r1), P._matMult(r1), E._matMult(r1), V._matMult(r1);
                }
                const D = n.stretch + n.fixed, $ = i.stretch + i.fixed;
                return {
                    tl: C,
                    tr: P,
                    bl: E,
                    br: V,
                    tex: {
                        x: a.paddedRect.x + 1 + D,
                        y: a.paddedRect.y + 1 + $,
                        w: o.stretch + o.fixed - D,
                        h: l.stretch + l.fixed - $
                    },
                    writingMode: void 0,
                    glyphOffset: [
                        0,
                        0
                    ],
                    sectionIndex: 0,
                    pixelOffsetTL: F,
                    pixelOffsetBR: T,
                    minFontScaleX: A / s / u,
                    minFontScaleY: I / s / c,
                    isSDF: r
                };
            };
            if (n && (a.stretchX || a.stretchY)) {
                const t3 = fu(h, m, d), e2 = fu(p, g, y);
                for(let r1 = 0; r1 < t3.length - 1; r1++){
                    const n1 = t3[r1], a1 = t3[r1 + 1];
                    for(let t4 = 0; t4 < e2.length - 1; t4++)i.push(M(n1, e2[t4], a1, e2[t4 + 1]));
                }
            } else i.push(M({
                fixed: 0,
                stretch: -1
            }, {
                fixed: 0,
                stretch: -1
            }, {
                fixed: 0,
                stretch: o + 1
            }, {
                fixed: 0,
                stretch: l + 1
            }));
            return i;
        }
        function pu(t1, e1, r) {
            let n = 0;
            for (const i of t1)n += Math.max(e1, Math.min(r, i[1])) - Math.max(e1, Math.min(r, i[0]));
            return n;
        }
        function fu(t1, e1, r) {
            const n = [
                {
                    fixed: -1,
                    stretch: 0
                }
            ];
            for (const [e2, r1] of t1){
                const t2 = n[n.length - 1];
                n.push({
                    fixed: e2 - t2.stretch,
                    stretch: t2.stretch
                }), n.push({
                    fixed: e2 - t2.stretch,
                    stretch: t2.stretch + (r1 - e2)
                });
            }
            return n.push({
                fixed: e1 + 1,
                stretch: r
            }), n;
        }
        function du(t1, e1, r, n) {
            return t1 / e1 * r + n;
        }
        function yu(t1, e1, r, n) {
            return t1 - e1 * r / n;
        }
        Mn("Anchor", ru);
        class mu {
            constructor(t1, e1, r, n, i, a, s, o, l, u){
                if (this.boxStartIndex = t1.length, l) {
                    let t2 = a.top, e2 = a.bottom;
                    const r1 = a.collisionPadding;
                    r1 && (t2 -= r1[1], e2 += r1[3]);
                    let n1 = e2 - t2;
                    n1 > 0 && (n1 = Math.max(10, n1), this.circleDiameter = n1);
                } else {
                    let l1 = a.top * s - o[0], c = a.bottom * s + o[2], h = a.left * s - o[3], p = a.right * s + o[1];
                    const f = a.collisionPadding;
                    if (f && (h -= f[0] * s, l1 -= f[1] * s, p += f[2] * s, c += f[3] * s), u) {
                        const t3 = new S(h, l1), e3 = new S(p, l1), r2 = new S(h, c), n2 = new S(p, c), i1 = u * Math.PI / 180;
                        t3._rotate(i1), e3._rotate(i1), r2._rotate(i1), n2._rotate(i1), h = Math.min(t3.x, e3.x, r2.x, n2.x), p = Math.max(t3.x, e3.x, r2.x, n2.x), l1 = Math.min(t3.y, e3.y, r2.y, n2.y), c = Math.max(t3.y, e3.y, r2.y, n2.y);
                    }
                    t1.emplaceBack(e1.x, e1.y, h, l1, p, c, r, n, i);
                }
                this.boxEndIndex = t1.length;
            }
        }
        class gu {
            constructor(t1 = [], e1 = xu){
                if (this.data = t1, this.length = this.data.length, this.compare = e1, this.length > 0) for(let t2 = (this.length >> 1) - 1; t2 >= 0; t2--)this._down(t2);
            }
            push(t1) {
                this.data.push(t1), this.length++, this._up(this.length - 1);
            }
            pop() {
                if (0 === this.length) return;
                const t1 = this.data[0], e1 = this.data.pop();
                return this.length--, this.length > 0 && (this.data[0] = e1, this._down(0)), t1;
            }
            peek() {
                return this.data[0];
            }
            _up(t1) {
                const { data: e1 , compare: r  } = this, n = e1[t1];
                for(; t1 > 0;){
                    const i = t1 - 1 >> 1, a = e1[i];
                    if (r(n, a) >= 0) break;
                    e1[t1] = a, t1 = i;
                }
                e1[t1] = n;
            }
            _down(t1) {
                const { data: e1 , compare: r  } = this, n = this.length >> 1, i = e1[t1];
                for(; t1 < n;){
                    let n1 = 1 + (t1 << 1), a = e1[n1];
                    const s = n1 + 1;
                    if (s < this.length && r(e1[s], a) < 0 && (n1 = s, a = e1[s]), r(a, i) >= 0) break;
                    e1[t1] = a, t1 = n1;
                }
                e1[t1] = i;
            }
        }
        function xu(t1, e1) {
            return t1 < e1 ? -1 : t1 > e1 ? 1 : 0;
        }
        function vu(t1, e1 = 1, r = !1) {
            let n = 1 / 0, i = 1 / 0, a = -1 / 0, s = -1 / 0;
            const o = t1[0];
            for(let t2 = 0; t2 < o.length; t2++){
                const e2 = o[t2];
                (!t2 || e2.x < n) && (n = e2.x), (!t2 || e2.y < i) && (i = e2.y), (!t2 || e2.x > a) && (a = e2.x), (!t2 || e2.y > s) && (s = e2.y);
            }
            const l = Math.min(a - n, s - i);
            let u = l / 2;
            const c = new gu([], bu);
            if (0 === l) return new S(n, i);
            for(let e3 = n; e3 < a; e3 += l)for(let r1 = i; r1 < s; r1 += l)c.push(new wu(e3 + u, r1 + u, u, t1));
            let h = function(t1) {
                let e1 = 0, r = 0, n = 0;
                const i = t1[0];
                for(let t2 = 0, a = i.length, s = a - 1; t2 < a; s = t2++){
                    const a1 = i[t2], o = i[s], l = a1.x * o.y - o.x * a1.y;
                    r += (a1.x + o.x) * l, n += (a1.y + o.y) * l, e1 += 3 * l;
                }
                return new wu(r / e1, n / e1, 0, t1);
            }(t1), p = c.length;
            for(; c.length;){
                const n1 = c.pop();
                (n1.d > h.d || !h.d) && (h = n1, r && console.log("found best %d after %d probes", Math.round(1e4 * n1.d) / 1e4, p)), n1.max - h.d <= e1 || (u = n1.h / 2, c.push(new wu(n1.p.x - u, n1.p.y - u, u, t1)), c.push(new wu(n1.p.x + u, n1.p.y - u, u, t1)), c.push(new wu(n1.p.x - u, n1.p.y + u, u, t1)), c.push(new wu(n1.p.x + u, n1.p.y + u, u, t1)), p += 4);
            }
            return r && (console.log(`num probes: ${p}`), console.log(`best distance: ${h.d}`)), h.p;
        }
        function bu(t1, e1) {
            return e1.max - t1.max;
        }
        function wu(t1, e1, r, n) {
            this.p = new S(t1, e1), this.h = r, this.d = function(t1, e1) {
                let r = !1, n = 1 / 0;
                for(let i = 0; i < e1.length; i++){
                    const a = e1[i];
                    for(let e2 = 0, i1 = a.length, s = i1 - 1; e2 < i1; s = e2++){
                        const i2 = a[e2], o = a[s];
                        i2.y > t1.y != o.y > t1.y && t1.x < (o.x - i2.x) * (t1.y - i2.y) / (o.y - i2.y) + i2.x && (r = !r), n = Math.min(n, rs(t1, i2, o));
                    }
                }
                return (r ? 1 : -1) * Math.sqrt(n);
            }(this.p, n), this.max = this.d + this.h * Math.SQRT2;
        }
        const _u = Number.POSITIVE_INFINITY;
        function Au(t1, e1) {
            return e1[1] !== _u ? function(t1, e1, r) {
                let n = 0, i = 0;
                switch(e1 = Math.abs(e1), r = Math.abs(r), t1){
                    case "top-right":
                    case "top-left":
                    case "top":
                        i = r - 7;
                        break;
                    case "bottom-right":
                    case "bottom-left":
                    case "bottom":
                        i = 7 - r;
                }
                switch(t1){
                    case "top-right":
                    case "bottom-right":
                    case "right":
                        n = -e1;
                        break;
                    case "top-left":
                    case "bottom-left":
                    case "left":
                        n = e1;
                }
                return [
                    n,
                    i
                ];
            }(t1, e1[0], e1[1]) : function(t1, e1) {
                let r = 0, n = 0;
                e1 < 0 && (e1 = 0);
                const i = e1 / Math.sqrt(2);
                switch(t1){
                    case "top-right":
                    case "top-left":
                        n = i - 7;
                        break;
                    case "bottom-right":
                    case "bottom-left":
                        n = 7 - i;
                        break;
                    case "bottom":
                        n = 7 - e1;
                        break;
                    case "top":
                        n = e1 - 7;
                }
                switch(t1){
                    case "top-right":
                    case "bottom-right":
                        r = -i;
                        break;
                    case "top-left":
                    case "bottom-left":
                        r = i;
                        break;
                    case "left":
                        r = e1;
                        break;
                    case "right":
                        r = -e1;
                }
                return [
                    r,
                    n
                ];
            }(t1, e1[0]);
        }
        function ku(t1) {
            switch(t1){
                case "right":
                case "top-right":
                case "bottom-right":
                    return "right";
                case "left":
                case "top-left":
                case "bottom-left":
                    return "left";
            }
            return "center";
        }
        function Su(e1, r, n, i, a, s, o, l, u, c, h) {
            let p = s.textMaxSize.evaluate(r, {});
            void 0 === p && (p = o);
            const f = e1.layers[0].layout, y = f.get("icon-offset").evaluate(r, {}, h), m = zu(n.horizontal), g = o / 24, x = e1.tilePixelRatio * g, v = e1.tilePixelRatio * p / 24, b = e1.tilePixelRatio * l, w = e1.tilePixelRatio * f.get("symbol-spacing"), _ = f.get("text-padding") * e1.tilePixelRatio, A = function(t1, e1, r, n = 1) {
                const i = t1.get("icon-padding").evaluate(e1, {}, r), a = i && i.values;
                return [
                    a[0] * n,
                    a[1] * n,
                    a[2] * n,
                    a[3] * n
                ];
            }(f, r, h, e1.tilePixelRatio), k = f.get("text-max-angle") / 180 * Math.PI, S = "viewport" !== f.get("text-rotation-alignment") && "point" !== f.get("symbol-placement"), I = "map" === f.get("icon-rotation-alignment") && "point" !== f.get("symbol-placement"), M = f.get("symbol-placement"), z = w / 2, B = f.get("icon-text-fit");
            let C;
            i && "none" !== B && (e1.allowVerticalPlacement && n.vertical && (C = Ql(i, n.vertical, B, f.get("icon-text-fit-padding"), y, g)), m && (i = Ql(i, m, B, f.get("icon-text-fit-padding"), y, g)));
            const P = (l, p)=>{
                p.x < 0 || p.x >= qa || p.y < 0 || p.y >= qa || function(e1, r, n, i, a, s, o, l, u, c, h, p, f, y, m, g, x, v, b, w, _, A, k, S, I) {
                    const M = e1.addToLineVertexArray(r, n);
                    let z, B, C, P, V = 0, E = 0, F = 0, T = 0, L = -1, D = -1;
                    const $ = {};
                    let R = xa.exports(""), O = 0, U = 0;
                    if (void 0 === l._unevaluatedLayout.getValue("text-radial-offset") ? [O, U] = l.layout.get("text-offset").evaluate(_, {}, S).map((t1)=>t1 * ll) : (O = l.layout.get("text-radial-offset").evaluate(_, {}, S) * ll, U = _u), e1.allowVerticalPlacement && i.vertical) {
                        const t2 = l.layout.get("text-rotate").evaluate(_, {}, S) + 90;
                        C = new mu(u, r, c, h, p, i.vertical, f, y, m, t2), o && (P = new mu(u, r, c, h, p, o, x, v, m, t2));
                    }
                    if (a) {
                        const n1 = l.layout.get("icon-rotate").evaluate(_, {}), i1 = "none" !== l.layout.get("icon-text-fit"), s1 = hu(a, n1, k, i1), f1 = o ? hu(o, n1, k, i1) : void 0;
                        B = new mu(u, r, c, h, p, a, x, v, !1, n1), V = 4 * s1.length;
                        const y1 = e1.iconSizeData;
                        let m1 = null;
                        "source" === y1.kind ? (m1 = [
                            tu * l.layout.get("icon-size").evaluate(_, {})
                        ], m1[0] > Iu && d(`${e1.layerIds[0]}: Value for "icon-size" is >= 255. Reduce your "icon-size".`)) : "composite" === y1.kind && (m1 = [
                            tu * A.compositeIconSizes[0].evaluate(_, {}, S),
                            tu * A.compositeIconSizes[1].evaluate(_, {}, S)
                        ], (m1[0] > Iu || m1[1] > Iu) && d(`${e1.layerIds[0]}: Value for "icon-size" is >= 255. Reduce your "icon-size".`)), e1.addSymbols(e1.icon, s1, m1, w, b, _, t1.WritingMode.none, r, M.lineStartIndex, M.lineLength, -1, S), L = e1.icon.placedSymbolArray.length - 1, f1 && (E = 4 * f1.length, e1.addSymbols(e1.icon, f1, m1, w, b, _, t1.WritingMode.vertical, r, M.lineStartIndex, M.lineLength, -1, S), D = e1.icon.placedSymbolArray.length - 1);
                    }
                    const q = Object.keys(i.horizontal);
                    for (const n2 of q){
                        const a1 = i.horizontal[n2];
                        if (!z) {
                            R = xa.exports(a1.text);
                            const t3 = l.layout.get("text-rotate").evaluate(_, {}, S);
                            z = new mu(u, r, c, h, p, a1, f, y, m, t3);
                        }
                        const o1 = 1 === a1.positionedLines.length;
                        if (F += Mu(e1, r, a1, s, l, m, _, g, M, i.vertical ? t1.WritingMode.horizontal : t1.WritingMode.horizontalOnly, o1 ? q : [
                            n2
                        ], $, L, A, S), o1) break;
                    }
                    i.vertical && (T += Mu(e1, r, i.vertical, s, l, m, _, g, M, t1.WritingMode.vertical, [
                        "vertical"
                    ], $, D, A, S));
                    const j = z ? z.boxStartIndex : e1.collisionBoxArray.length, N = z ? z.boxEndIndex : e1.collisionBoxArray.length, Z = C ? C.boxStartIndex : e1.collisionBoxArray.length, K = C ? C.boxEndIndex : e1.collisionBoxArray.length, G = B ? B.boxStartIndex : e1.collisionBoxArray.length, J = B ? B.boxEndIndex : e1.collisionBoxArray.length, X = P ? P.boxStartIndex : e1.collisionBoxArray.length, Y = P ? P.boxEndIndex : e1.collisionBoxArray.length;
                    let H = -1;
                    const W = (t1, e1)=>t1 && t1.circleDiameter ? Math.max(t1.circleDiameter, e1) : e1;
                    H = W(z, H), H = W(C, H), H = W(B, H), H = W(P, H);
                    const Q = H > -1 ? 1 : 0;
                    Q && (H *= I / ll), e1.glyphOffsetArray.length >= Du.MAX_GLYPHS && d("Too many glyphs being rendered in a tile. See https://github.com/mapbox/mapbox-gl-js/issues/2907"), void 0 !== _.sortKey && e1.addToSortKeyRanges(e1.symbolInstances.length, _.sortKey), e1.symbolInstances.emplaceBack(r.x, r.y, $.right >= 0 ? $.right : -1, $.center >= 0 ? $.center : -1, $.left >= 0 ? $.left : -1, $.vertical || -1, L, D, R, j, N, Z, K, G, J, X, Y, c, F, T, V, E, Q, 0, f, O, U, H);
                }(e1, p, l, n, i, a, C, e1.layers[0], e1.collisionBoxArray, r.index, r.sourceLayerIndex, e1.index, x, [
                    _,
                    _,
                    _,
                    _
                ], S, u, b, A, I, y, r, s, c, h, o);
            };
            if ("line" === M) for (const t2 of cu(r.geometry, 0, 0, qa, qa)){
                const r1 = lu(t2, w, k, n.vertical || m, i, 24, v, e1.overscaling, qa);
                for (const n1 of r1){
                    const r2 = m;
                    r2 && Bu(e1, r2.text, z, n1) || P(t2, n1);
                }
            }
            else if ("line-center" === M) {
                for (const t3 of r.geometry)if (t3.length > 1) {
                    const e2 = ou(t3, k, n.vertical || m, i, 24, v);
                    e2 && P(t3, e2);
                }
            } else if ("Polygon" === r.type) for (const t4 of ho(r.geometry, 0)){
                const e3 = vu(t4, 16);
                P(t4[0], new ru(e3.x, e3.y, 0));
            }
            else if ("LineString" === r.type) for (const t5 of r.geometry)P(t5, new ru(t5[0].x, t5[0].y, 0));
            else if ("Point" === r.type) for (const t6 of r.geometry)for (const e4 of t6)P([
                e4
            ], new ru(e4.x, e4.y, 0));
        }
        const Iu = 32640;
        function Mu(t1, e1, r, n, i, a, s, o, l, u, c, h, p, f, y) {
            const m = function(t1, e1, r, n, i, a, s, o) {
                const l = n.layout.get("text-rotate").evaluate(a, {}) * Math.PI / 180, u = [];
                for (const t2 of e1.positionedLines)for (const n1 of t2.positionedGlyphs){
                    if (!n1.rect) continue;
                    const a1 = n1.rect || {};
                    let c = 4, h = !0, p = 1, f = 0;
                    const d = (i || o) && n1.vertical, y = n1.metrics.advance * n1.scale / 2;
                    if (o && e1.verticalizable) {
                        const e2 = (n1.scale - 1) * ll, r1 = (ll - n1.metrics.width * n1.scale) / 2;
                        f = t2.lineOffset / 2 - (n1.imageName ? -r1 : e2);
                    }
                    if (n1.imageName) {
                        const t3 = s[n1.imageName];
                        h = t3.sdf, p = t3.pixelRatio, c = 1 / p;
                    }
                    const m = i ? [
                        n1.x + y,
                        n1.y
                    ] : [
                        0,
                        0
                    ];
                    let g = i ? [
                        0,
                        0
                    ] : [
                        n1.x + y + r[0],
                        n1.y + r[1] - f
                    ], x = [
                        0,
                        0
                    ];
                    d && (x = g, g = [
                        0,
                        0
                    ]);
                    const v = (n1.metrics.left - c) * n1.scale - y + g[0], b = (-n1.metrics.top - c) * n1.scale + g[1], w = v + a1.w * n1.scale / p, _ = b + a1.h * n1.scale / p, A = new S(v, b), k = new S(w, b), I = new S(v, _), M = new S(w, _);
                    if (d) {
                        const t4 = new S(-y, y - $l), e3 = -Math.PI / 2, r2 = 12 - y, i1 = new S(22 - r2, -(n1.imageName ? r2 : 0)), a2 = new S(...x);
                        A._rotateAround(e3, t4)._add(i1)._add(a2), k._rotateAround(e3, t4)._add(i1)._add(a2), I._rotateAround(e3, t4)._add(i1)._add(a2), M._rotateAround(e3, t4)._add(i1)._add(a2);
                    }
                    if (l) {
                        const t5 = Math.sin(l), e4 = Math.cos(l), r3 = [
                            e4,
                            -t5,
                            t5,
                            e4
                        ];
                        A._matMult(r3), k._matMult(r3), I._matMult(r3), M._matMult(r3);
                    }
                    const z = new S(0, 0), B = new S(0, 0);
                    u.push({
                        tl: A,
                        tr: k,
                        bl: I,
                        br: M,
                        tex: a1,
                        writingMode: e1.writingMode,
                        glyphOffset: m,
                        sectionIndex: n1.sectionIndex,
                        isSDF: h,
                        pixelOffsetTL: z,
                        pixelOffsetBR: B,
                        minFontScaleX: 0,
                        minFontScaleY: 0
                    });
                }
                return u;
            }(0, r, o, i, a, s, n, t1.allowVerticalPlacement), g = t1.textSizeData;
            let x = null;
            "source" === g.kind ? (x = [
                tu * i.layout.get("text-size").evaluate(s, {})
            ], x[0] > Iu && d(`${t1.layerIds[0]}: Value for "text-size" is >= 255. Reduce your "text-size".`)) : "composite" === g.kind && (x = [
                tu * f.compositeTextSizes[0].evaluate(s, {}, y),
                tu * f.compositeTextSizes[1].evaluate(s, {}, y)
            ], (x[0] > Iu || x[1] > Iu) && d(`${t1.layerIds[0]}: Value for "text-size" is >= 255. Reduce your "text-size".`)), t1.addSymbols(t1.text, m, x, o, a, s, u, e1, l.lineStartIndex, l.lineLength, p, y);
            for (const e2 of c)h[e2] = t1.text.placedSymbolArray.length - 1;
            return 4 * m.length;
        }
        function zu(t1) {
            for(const e1 in t1)return t1[e1];
            return null;
        }
        function Bu(t1, e1, r, n) {
            const i = t1.compareText;
            if (e1 in i) {
                const t2 = i[e1];
                for(let e2 = t2.length - 1; e2 >= 0; e2--)if (n.dist(t2[e2]) < r) return !0;
            } else i[e1] = [];
            return i[e1].push(n), !1;
        }
        const Cu = _o.VectorTileFeature.types, Pu = [
            {
                name: "a_fade_opacity",
                components: 1,
                type: "Uint8",
                offset: 0
            }
        ];
        function Vu(t1, e1, r, n, i, a, s, o, l, u, c, h, p) {
            const f = o ? Math.min(Iu, Math.round(o[0])) : 0, d = o ? Math.min(Iu, Math.round(o[1])) : 0;
            t1.emplaceBack(e1, r, Math.round(32 * n), Math.round(32 * i), a, s, (f << 1) + (l ? 1 : 0), d, 16 * u, 16 * c, 256 * h, 256 * p);
        }
        function Eu(t1, e1, r) {
            t1.emplaceBack(e1.x, e1.y, r), t1.emplaceBack(e1.x, e1.y, r), t1.emplaceBack(e1.x, e1.y, r), t1.emplaceBack(e1.x, e1.y, r);
        }
        function Fu(t1) {
            for (const e1 of t1.sections)if (On(e1.text)) return !0;
            return !1;
        }
        class Tu {
            constructor(t1){
                this.layoutVertexArray = new sa, this.indexArray = new ha, this.programConfigurations = t1, this.segments = new ya, this.dynamicLayoutVertexArray = new oa, this.opacityVertexArray = new la, this.placedSymbolArray = new Ki;
            }
            isEmpty() {
                return 0 === this.layoutVertexArray.length && 0 === this.indexArray.length && 0 === this.dynamicLayoutVertexArray.length && 0 === this.opacityVertexArray.length;
            }
            upload(t1, e1, r, n) {
                this.isEmpty() || (r && (this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, el.members), this.indexBuffer = t1.createIndexBuffer(this.indexArray, e1), this.dynamicLayoutVertexBuffer = t1.createVertexBuffer(this.dynamicLayoutVertexArray, rl.members, !0), this.opacityVertexBuffer = t1.createVertexBuffer(this.opacityVertexArray, Pu, !0), this.opacityVertexBuffer.itemSize = 1), (r || n) && this.programConfigurations.upload(t1));
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.programConfigurations.destroy(), this.segments.destroy(), this.dynamicLayoutVertexBuffer.destroy(), this.opacityVertexBuffer.destroy());
            }
        }
        Mn("SymbolBuffers", Tu);
        class Lu {
            constructor(t1, e1, r){
                this.layoutVertexArray = new t1, this.layoutAttributes = e1, this.indexArray = new r, this.segments = new ya, this.collisionVertexArray = new ca;
            }
            upload(t1) {
                this.layoutVertexBuffer = t1.createVertexBuffer(this.layoutVertexArray, this.layoutAttributes), this.indexBuffer = t1.createIndexBuffer(this.indexArray), this.collisionVertexBuffer = t1.createVertexBuffer(this.collisionVertexArray, nl.members, !0);
            }
            destroy() {
                this.layoutVertexBuffer && (this.layoutVertexBuffer.destroy(), this.indexBuffer.destroy(), this.segments.destroy(), this.collisionVertexBuffer.destroy());
            }
        }
        Mn("CollisionBuffers", Lu);
        class Du {
            constructor(e1){
                this.collisionBoxArray = e1.collisionBoxArray, this.zoom = e1.zoom, this.overscaling = e1.overscaling, this.layers = e1.layers, this.layerIds = this.layers.map((t1)=>t1.id), this.index = e1.index, this.pixelRatio = e1.pixelRatio, this.sourceLayerIndex = e1.sourceLayerIndex, this.hasPattern = !1, this.hasRTLText = !1, this.sortKeyRanges = [], this.collisionCircleArray = [], this.placementInvProjMatrix = ds([]), this.placementViewportMatrix = ds([]);
                const r = this.layers[0]._unevaluatedLayout._values;
                this.textSizeData = eu(this.zoom, r["text-size"]), this.iconSizeData = eu(this.zoom, r["icon-size"]);
                const n = this.layers[0].layout, i = n.get("symbol-sort-key"), a = n.get("symbol-z-order");
                this.canOverlap = "never" !== qu(n, "text-overlap", "text-allow-overlap") || "never" !== qu(n, "icon-overlap", "icon-allow-overlap") || n.get("text-ignore-placement") || n.get("icon-ignore-placement"), this.sortFeaturesByKey = "viewport-y" !== a && !i.isConstant(), this.sortFeaturesByY = ("viewport-y" === a || "auto" === a && !this.sortFeaturesByKey) && this.canOverlap, "point" === n.get("symbol-placement") && (this.writingModes = n.get("text-writing-mode").map((e1)=>t1.WritingMode[e1])), this.stateDependentLayerIds = this.layers.filter((t1)=>t1.isStateDependent()).map((t1)=>t1.id), this.sourceID = e1.sourceID;
            }
            createArrays() {
                this.text = new Tu(new Ra(this.layers, this.zoom, (t1)=>/^text/.test(t1))), this.icon = new Tu(new Ra(this.layers, this.zoom, (t1)=>/^icon/.test(t1))), this.glyphOffsetArray = new Xi, this.lineVertexArray = new Yi, this.symbolInstances = new Ji;
            }
            calculateGlyphDependencies(t1, e1, r, n, i) {
                for(let a = 0; a < t1.length; a++)if (e1[t1.charCodeAt(a)] = !0, (r || n) && i) {
                    const r1 = ol[t1.charAt(a)];
                    r1 && (e1[r1.charCodeAt(0)] = !0);
                }
            }
            populate(e1, r, n) {
                const i = this.layers[0], a = i.layout, s = a.get("text-font"), o = a.get("text-field"), l = a.get("icon-image"), u = ("constant" !== o.value.kind || o.value.value instanceof Dt && !o.value.value.isEmpty() || o.value.value.toString().length > 0) && ("constant" !== s.value.kind || s.value.value.length > 0), c = "constant" !== l.value.kind || !!l.value.value || Object.keys(l.parameters).length > 0, h = a.get("symbol-sort-key");
                if (this.features = [], !u && !c) return;
                const p = r.iconDependencies, f = r.glyphDependencies, d = r.availableImages, y = new Qn(this.zoom);
                for (const { feature: r1 , id: o1 , index: l1 , sourceLayerIndex: m  } of e1){
                    const e2 = i._featureFilter.needGeometry, g = Ka(r1, e2);
                    if (!i._featureFilter.filter(y, g, n)) continue;
                    let x, v;
                    if (e2 || (g.geometry = Za(r1)), u) {
                        const t2 = i.getValueAndResolveTokens("text-field", g, n, d), e3 = Dt.factory(t2);
                        Fu(e3) && (this.hasRTLText = !0), (!this.hasRTLText || "unavailable" === Yn() || this.hasRTLText && Wn.isParsed()) && (x = sl(e3, i, g));
                    }
                    if (c) {
                        const t3 = i.getValueAndResolveTokens("icon-image", g, n, d);
                        v = t3 instanceof Rt ? t3 : Rt.fromString(t3);
                    }
                    if (!x && !v) continue;
                    const b = this.sortFeaturesByKey ? h.evaluate(g, {}, n) : void 0;
                    if (this.features.push({
                        id: o1,
                        text: x,
                        icon: v,
                        index: l1,
                        sourceLayerIndex: m,
                        geometry: g.geometry,
                        properties: r1.properties,
                        type: Cu[r1.type],
                        sortKey: b
                    }), v && (p[v.name] = !0), x) {
                        const e4 = s.evaluate(g, {}, n).join(","), r2 = "viewport" !== a.get("text-rotation-alignment") && "point" !== a.get("symbol-placement");
                        this.allowVerticalPlacement = this.writingModes && this.writingModes.indexOf(t1.WritingMode.vertical) >= 0;
                        for (const t4 of x.sections)if (t4.image) p[t4.image.name] = !0;
                        else {
                            const n1 = En(x.toString()), i1 = t4.fontStack || e4, a1 = f[i1] = f[i1] || {};
                            this.calculateGlyphDependencies(t4.text, a1, r2, this.allowVerticalPlacement, n1);
                        }
                    }
                }
                "line" === a.get("symbol-placement") && (this.features = function(t1) {
                    const e1 = {}, r = {}, n = [];
                    let i = 0;
                    function a(e1) {
                        n.push(t1[e1]), i++;
                    }
                    function s(t1, e1, i) {
                        const a = r[t1];
                        return delete r[t1], r[e1] = a, n[a].geometry[0].pop(), n[a].geometry[0] = n[a].geometry[0].concat(i[0]), a;
                    }
                    function o(t1, r, i) {
                        const a = e1[r];
                        return delete e1[r], e1[t1] = a, n[a].geometry[0].shift(), n[a].geometry[0] = i[0].concat(n[a].geometry[0]), a;
                    }
                    function l(t1, e1, r) {
                        const n = r ? e1[0][e1[0].length - 1] : e1[0][0];
                        return `${t1}:${n.x}:${n.y}`;
                    }
                    for(let u = 0; u < t1.length; u++){
                        const c = t1[u], h = c.geometry, p = c.text ? c.text.toString() : null;
                        if (!p) {
                            a(u);
                            continue;
                        }
                        const f = l(p, h), d = l(p, h, !0);
                        if (f in r && d in e1 && r[f] !== e1[d]) {
                            const t2 = o(f, d, h), i1 = s(f, d, n[t2].geometry);
                            delete e1[f], delete r[d], r[l(p, n[i1].geometry, !0)] = i1, n[t2].geometry = null;
                        } else f in r ? s(f, d, h) : d in e1 ? o(f, d, h) : (a(u), e1[f] = i - 1, r[d] = i - 1);
                    }
                    return n.filter((t1)=>t1.geometry);
                }(this.features)), this.sortFeaturesByKey && this.features.sort((t1, e1)=>t1.sortKey - e1.sortKey);
            }
            update(t1, e1, r) {
                this.stateDependentLayers.length && (this.text.programConfigurations.updatePaintArrays(t1, e1, this.layers, r), this.icon.programConfigurations.updatePaintArrays(t1, e1, this.layers, r));
            }
            isEmpty() {
                return 0 === this.symbolInstances.length && !this.hasRTLText;
            }
            uploadPending() {
                return !this.uploaded || this.text.programConfigurations.needsUpload || this.icon.programConfigurations.needsUpload;
            }
            upload(t1) {
                !this.uploaded && this.hasDebugData() && (this.textCollisionBox.upload(t1), this.iconCollisionBox.upload(t1)), this.text.upload(t1, this.sortFeaturesByY, !this.uploaded, this.text.programConfigurations.needsUpload), this.icon.upload(t1, this.sortFeaturesByY, !this.uploaded, this.icon.programConfigurations.needsUpload), this.uploaded = !0;
            }
            destroyDebugData() {
                this.textCollisionBox.destroy(), this.iconCollisionBox.destroy();
            }
            destroy() {
                this.text.destroy(), this.icon.destroy(), this.hasDebugData() && this.destroyDebugData();
            }
            addToLineVertexArray(t1, e1) {
                const r = this.lineVertexArray.length;
                if (void 0 !== t1.segment) {
                    let r1 = t1.dist(e1[t1.segment + 1]), n = t1.dist(e1[t1.segment]);
                    const i = {};
                    for(let n1 = t1.segment + 1; n1 < e1.length; n1++)i[n1] = {
                        x: e1[n1].x,
                        y: e1[n1].y,
                        tileUnitDistanceFromAnchor: r1
                    }, n1 < e1.length - 1 && (r1 += e1[n1 + 1].dist(e1[n1]));
                    for(let r2 = t1.segment || 0; r2 >= 0; r2--)i[r2] = {
                        x: e1[r2].x,
                        y: e1[r2].y,
                        tileUnitDistanceFromAnchor: n
                    }, r2 > 0 && (n += e1[r2 - 1].dist(e1[r2]));
                    for(let t2 = 0; t2 < e1.length; t2++){
                        const e2 = i[t2];
                        this.lineVertexArray.emplaceBack(e2.x, e2.y, e2.tileUnitDistanceFromAnchor);
                    }
                }
                return {
                    lineStartIndex: r,
                    lineLength: this.lineVertexArray.length - r
                };
            }
            addSymbols(e1, r, n, i, a, s, o, l, u, c, h, p) {
                const f = e1.indexArray, d = e1.layoutVertexArray, y = e1.segments.prepareSegment(4 * r.length, d, f, this.canOverlap ? s.sortKey : void 0), m = this.glyphOffsetArray.length, g = y.vertexLength, x = this.allowVerticalPlacement && o === t1.WritingMode.vertical ? Math.PI / 2 : 0, v = s.text && s.text.sections;
                for(let t2 = 0; t2 < r.length; t2++){
                    const { tl: i1 , tr: a1 , bl: o1 , br: u1 , tex: c1 , pixelOffsetTL: h1 , pixelOffsetBR: m1 , minFontScaleX: g1 , minFontScaleY: b , glyphOffset: w , isSDF: _ , sectionIndex: A  } = r[t2], k = y.vertexLength, S = w[1];
                    Vu(d, l.x, l.y, i1.x, S + i1.y, c1.x, c1.y, n, _, h1.x, h1.y, g1, b), Vu(d, l.x, l.y, a1.x, S + a1.y, c1.x + c1.w, c1.y, n, _, m1.x, h1.y, g1, b), Vu(d, l.x, l.y, o1.x, S + o1.y, c1.x, c1.y + c1.h, n, _, h1.x, m1.y, g1, b), Vu(d, l.x, l.y, u1.x, S + u1.y, c1.x + c1.w, c1.y + c1.h, n, _, m1.x, m1.y, g1, b), Eu(e1.dynamicLayoutVertexArray, l, x), f.emplaceBack(k, k + 1, k + 2), f.emplaceBack(k + 1, k + 2, k + 3), y.vertexLength += 4, y.primitiveLength += 2, this.glyphOffsetArray.emplaceBack(w[0]), t2 !== r.length - 1 && A === r[t2 + 1].sectionIndex || e1.programConfigurations.populatePaintArrays(d.length, s, s.index, {}, p, v && v[A]);
                }
                e1.placedSymbolArray.emplaceBack(l.x, l.y, m, this.glyphOffsetArray.length - m, g, u, c, l.segment, n ? n[0] : 0, n ? n[1] : 0, i[0], i[1], o, 0, !1, 0, h);
            }
            _addCollisionDebugVertex(t1, e1, r, n, i, a) {
                return e1.emplaceBack(0, 0), t1.emplaceBack(r.x, r.y, n, i, Math.round(a.x), Math.round(a.y));
            }
            addCollisionDebugVertices(t1, e1, r, n, i, a, s) {
                const o = i.segments.prepareSegment(4, i.layoutVertexArray, i.indexArray), l = o.vertexLength, u = i.layoutVertexArray, c = i.collisionVertexArray, h = s.anchorX, p = s.anchorY;
                this._addCollisionDebugVertex(u, c, a, h, p, new S(t1, e1)), this._addCollisionDebugVertex(u, c, a, h, p, new S(r, e1)), this._addCollisionDebugVertex(u, c, a, h, p, new S(r, n)), this._addCollisionDebugVertex(u, c, a, h, p, new S(t1, n)), o.vertexLength += 4;
                const f = i.indexArray;
                f.emplaceBack(l, l + 1), f.emplaceBack(l + 1, l + 2), f.emplaceBack(l + 2, l + 3), f.emplaceBack(l + 3, l), o.primitiveLength += 4;
            }
            addDebugCollisionBoxes(t1, e1, r, n) {
                for(let i = t1; i < e1; i++){
                    const t2 = this.collisionBoxArray.get(i);
                    this.addCollisionDebugVertices(t2.x1, t2.y1, t2.x2, t2.y2, n ? this.textCollisionBox : this.iconCollisionBox, t2.anchorPoint, r);
                }
            }
            generateCollisionDebugBuffers() {
                this.hasDebugData() && this.destroyDebugData(), this.textCollisionBox = new Lu(ua, il.members, pa), this.iconCollisionBox = new Lu(ua, il.members, pa);
                for(let t1 = 0; t1 < this.symbolInstances.length; t1++){
                    const e1 = this.symbolInstances.get(t1);
                    this.addDebugCollisionBoxes(e1.textBoxStartIndex, e1.textBoxEndIndex, e1, !0), this.addDebugCollisionBoxes(e1.verticalTextBoxStartIndex, e1.verticalTextBoxEndIndex, e1, !0), this.addDebugCollisionBoxes(e1.iconBoxStartIndex, e1.iconBoxEndIndex, e1, !1), this.addDebugCollisionBoxes(e1.verticalIconBoxStartIndex, e1.verticalIconBoxEndIndex, e1, !1);
                }
            }
            _deserializeCollisionBoxesForSymbol(t1, e1, r, n, i, a, s, o, l) {
                const u = {};
                for(let n1 = e1; n1 < r; n1++){
                    const e2 = t1.get(n1);
                    u.textBox = {
                        x1: e2.x1,
                        y1: e2.y1,
                        x2: e2.x2,
                        y2: e2.y2,
                        anchorPointX: e2.anchorPointX,
                        anchorPointY: e2.anchorPointY
                    }, u.textFeatureIndex = e2.featureIndex;
                    break;
                }
                for(let e3 = n; e3 < i; e3++){
                    const r1 = t1.get(e3);
                    u.verticalTextBox = {
                        x1: r1.x1,
                        y1: r1.y1,
                        x2: r1.x2,
                        y2: r1.y2,
                        anchorPointX: r1.anchorPointX,
                        anchorPointY: r1.anchorPointY
                    }, u.verticalTextFeatureIndex = r1.featureIndex;
                    break;
                }
                for(let e4 = a; e4 < s; e4++){
                    const r2 = t1.get(e4);
                    u.iconBox = {
                        x1: r2.x1,
                        y1: r2.y1,
                        x2: r2.x2,
                        y2: r2.y2,
                        anchorPointX: r2.anchorPointX,
                        anchorPointY: r2.anchorPointY
                    }, u.iconFeatureIndex = r2.featureIndex;
                    break;
                }
                for(let e5 = o; e5 < l; e5++){
                    const r3 = t1.get(e5);
                    u.verticalIconBox = {
                        x1: r3.x1,
                        y1: r3.y1,
                        x2: r3.x2,
                        y2: r3.y2,
                        anchorPointX: r3.anchorPointX,
                        anchorPointY: r3.anchorPointY
                    }, u.verticalIconFeatureIndex = r3.featureIndex;
                    break;
                }
                return u;
            }
            deserializeCollisionBoxes(t1) {
                this.collisionArrays = [];
                for(let e1 = 0; e1 < this.symbolInstances.length; e1++){
                    const r = this.symbolInstances.get(e1);
                    this.collisionArrays.push(this._deserializeCollisionBoxesForSymbol(t1, r.textBoxStartIndex, r.textBoxEndIndex, r.verticalTextBoxStartIndex, r.verticalTextBoxEndIndex, r.iconBoxStartIndex, r.iconBoxEndIndex, r.verticalIconBoxStartIndex, r.verticalIconBoxEndIndex));
                }
            }
            hasTextData() {
                return this.text.segments.get().length > 0;
            }
            hasIconData() {
                return this.icon.segments.get().length > 0;
            }
            hasDebugData() {
                return this.textCollisionBox && this.iconCollisionBox;
            }
            hasTextCollisionBoxData() {
                return this.hasDebugData() && this.textCollisionBox.segments.get().length > 0;
            }
            hasIconCollisionBoxData() {
                return this.hasDebugData() && this.iconCollisionBox.segments.get().length > 0;
            }
            addIndicesForPlacedSymbol(t1, e1) {
                const r = t1.placedSymbolArray.get(e1), n = r.vertexStartIndex + 4 * r.numGlyphs;
                for(let e2 = r.vertexStartIndex; e2 < n; e2 += 4)t1.indexArray.emplaceBack(e2, e2 + 1, e2 + 2), t1.indexArray.emplaceBack(e2 + 1, e2 + 2, e2 + 3);
            }
            getSortedSymbolIndexes(t1) {
                if (this.sortedAngle === t1 && void 0 !== this.symbolInstanceIndexes) return this.symbolInstanceIndexes;
                const e1 = Math.sin(t1), r = Math.cos(t1), n = [], i = [], a = [];
                for(let t2 = 0; t2 < this.symbolInstances.length; ++t2){
                    a.push(t2);
                    const s = this.symbolInstances.get(t2);
                    n.push(0 | Math.round(e1 * s.anchorX + r * s.anchorY)), i.push(s.featureIndex);
                }
                return a.sort((t1, e1)=>n[t1] - n[e1] || i[e1] - i[t1]), a;
            }
            addToSortKeyRanges(t1, e1) {
                const r = this.sortKeyRanges[this.sortKeyRanges.length - 1];
                r && r.sortKey === e1 ? r.symbolInstanceEnd = t1 + 1 : this.sortKeyRanges.push({
                    sortKey: e1,
                    symbolInstanceStart: t1,
                    symbolInstanceEnd: t1 + 1
                });
            }
            sortFeatures(t1) {
                if (this.sortFeaturesByY && this.sortedAngle !== t1 && !(this.text.segments.get().length > 1 || this.icon.segments.get().length > 1)) {
                    this.symbolInstanceIndexes = this.getSortedSymbolIndexes(t1), this.sortedAngle = t1, this.text.indexArray.clear(), this.icon.indexArray.clear(), this.featureSortOrder = [];
                    for (const t2 of this.symbolInstanceIndexes){
                        const e1 = this.symbolInstances.get(t2);
                        this.featureSortOrder.push(e1.featureIndex), [
                            e1.rightJustifiedTextSymbolIndex,
                            e1.centerJustifiedTextSymbolIndex,
                            e1.leftJustifiedTextSymbolIndex
                        ].forEach((t1, e1, r)=>{
                            t1 >= 0 && r.indexOf(t1) === e1 && this.addIndicesForPlacedSymbol(this.text, t1);
                        }), e1.verticalPlacedTextSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.text, e1.verticalPlacedTextSymbolIndex), e1.placedIconSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.icon, e1.placedIconSymbolIndex), e1.verticalPlacedIconSymbolIndex >= 0 && this.addIndicesForPlacedSymbol(this.icon, e1.verticalPlacedIconSymbolIndex);
                    }
                    this.text.indexBuffer && this.text.indexBuffer.updateData(this.text.indexArray), this.icon.indexBuffer && this.icon.indexBuffer.updateData(this.icon.indexArray);
                }
            }
        }
        Mn("SymbolBucket", Du, {
            omit: [
                "layers",
                "collisionBoxArray",
                "features",
                "compareText"
            ]
        }), Du.MAX_GLYPHS = 65535, Du.addDynamicAttributes = Eu;
        const $u = new fi({
            "symbol-placement": new li(nt.layout_symbol["symbol-placement"]),
            "symbol-spacing": new li(nt.layout_symbol["symbol-spacing"]),
            "symbol-avoid-edges": new li(nt.layout_symbol["symbol-avoid-edges"]),
            "symbol-sort-key": new ui(nt.layout_symbol["symbol-sort-key"]),
            "symbol-z-order": new li(nt.layout_symbol["symbol-z-order"]),
            "icon-allow-overlap": new li(nt.layout_symbol["icon-allow-overlap"]),
            "icon-overlap": new li(nt.layout_symbol["icon-overlap"]),
            "icon-ignore-placement": new li(nt.layout_symbol["icon-ignore-placement"]),
            "icon-optional": new li(nt.layout_symbol["icon-optional"]),
            "icon-rotation-alignment": new li(nt.layout_symbol["icon-rotation-alignment"]),
            "icon-size": new ui(nt.layout_symbol["icon-size"]),
            "icon-text-fit": new li(nt.layout_symbol["icon-text-fit"]),
            "icon-text-fit-padding": new li(nt.layout_symbol["icon-text-fit-padding"]),
            "icon-image": new ui(nt.layout_symbol["icon-image"]),
            "icon-rotate": new ui(nt.layout_symbol["icon-rotate"]),
            "icon-padding": new ui(nt.layout_symbol["icon-padding"]),
            "icon-keep-upright": new li(nt.layout_symbol["icon-keep-upright"]),
            "icon-offset": new ui(nt.layout_symbol["icon-offset"]),
            "icon-anchor": new ui(nt.layout_symbol["icon-anchor"]),
            "icon-pitch-alignment": new li(nt.layout_symbol["icon-pitch-alignment"]),
            "text-pitch-alignment": new li(nt.layout_symbol["text-pitch-alignment"]),
            "text-rotation-alignment": new li(nt.layout_symbol["text-rotation-alignment"]),
            "text-field": new ui(nt.layout_symbol["text-field"]),
            "text-font": new ui(nt.layout_symbol["text-font"]),
            "text-size": new ui(nt.layout_symbol["text-size"]),
            "text-max-width": new ui(nt.layout_symbol["text-max-width"]),
            "text-line-height": new li(nt.layout_symbol["text-line-height"]),
            "text-letter-spacing": new ui(nt.layout_symbol["text-letter-spacing"]),
            "text-justify": new ui(nt.layout_symbol["text-justify"]),
            "text-radial-offset": new ui(nt.layout_symbol["text-radial-offset"]),
            "text-variable-anchor": new li(nt.layout_symbol["text-variable-anchor"]),
            "text-anchor": new ui(nt.layout_symbol["text-anchor"]),
            "text-max-angle": new li(nt.layout_symbol["text-max-angle"]),
            "text-writing-mode": new li(nt.layout_symbol["text-writing-mode"]),
            "text-rotate": new ui(nt.layout_symbol["text-rotate"]),
            "text-padding": new li(nt.layout_symbol["text-padding"]),
            "text-keep-upright": new li(nt.layout_symbol["text-keep-upright"]),
            "text-transform": new ui(nt.layout_symbol["text-transform"]),
            "text-offset": new ui(nt.layout_symbol["text-offset"]),
            "text-allow-overlap": new li(nt.layout_symbol["text-allow-overlap"]),
            "text-overlap": new li(nt.layout_symbol["text-overlap"]),
            "text-ignore-placement": new li(nt.layout_symbol["text-ignore-placement"]),
            "text-optional": new li(nt.layout_symbol["text-optional"])
        });
        var Ru = {
            paint: new fi({
                "icon-opacity": new ui(nt.paint_symbol["icon-opacity"]),
                "icon-color": new ui(nt.paint_symbol["icon-color"]),
                "icon-halo-color": new ui(nt.paint_symbol["icon-halo-color"]),
                "icon-halo-width": new ui(nt.paint_symbol["icon-halo-width"]),
                "icon-halo-blur": new ui(nt.paint_symbol["icon-halo-blur"]),
                "icon-translate": new li(nt.paint_symbol["icon-translate"]),
                "icon-translate-anchor": new li(nt.paint_symbol["icon-translate-anchor"]),
                "text-opacity": new ui(nt.paint_symbol["text-opacity"]),
                "text-color": new ui(nt.paint_symbol["text-color"], {
                    runtimeType: yt,
                    getOverride: (t1)=>t1.textColor,
                    hasOverride: (t1)=>!!t1.textColor
                }),
                "text-halo-color": new ui(nt.paint_symbol["text-halo-color"]),
                "text-halo-width": new ui(nt.paint_symbol["text-halo-width"]),
                "text-halo-blur": new ui(nt.paint_symbol["text-halo-blur"]),
                "text-translate": new li(nt.paint_symbol["text-translate"]),
                "text-translate-anchor": new li(nt.paint_symbol["text-translate-anchor"])
            }),
            layout: $u
        };
        class Ou {
            constructor(t1){
                if (void 0 === t1.property.overrides) throw new Error("overrides must be provided to instantiate FormatSectionOverride class");
                this.type = t1.property.overrides ? t1.property.overrides.runtimeType : ht, this.defaultValue = t1;
            }
            evaluate(t1) {
                if (t1.formattedSection) {
                    const e1 = this.defaultValue.property.overrides;
                    if (e1 && e1.hasOverride(t1.formattedSection)) return e1.getOverride(t1.formattedSection);
                }
                return t1.feature && t1.featureState ? this.defaultValue.evaluate(t1.feature, t1.featureState) : this.defaultValue.property.specification.default;
            }
            eachChild(t1) {
                this.defaultValue.isConstant() || t1(this.defaultValue.value._styleExpression.expression);
            }
            outputDefined() {
                return !1;
            }
            serialize() {
                return null;
            }
        }
        Mn("FormatSectionOverride", Ou, {
            omit: [
                "defaultValue"
            ]
        });
        class Uu extends yi {
            constructor(t1){
                super(t1, Ru);
            }
            recalculate(t1, e1) {
                if (super.recalculate(t1, e1), "auto" === this.layout.get("icon-rotation-alignment") && (this.layout._values["icon-rotation-alignment"] = "point" !== this.layout.get("symbol-placement") ? "map" : "viewport"), "auto" === this.layout.get("text-rotation-alignment") && (this.layout._values["text-rotation-alignment"] = "point" !== this.layout.get("symbol-placement") ? "map" : "viewport"), "auto" === this.layout.get("text-pitch-alignment") && (this.layout._values["text-pitch-alignment"] = "map" === this.layout.get("text-rotation-alignment") ? "map" : "viewport"), "auto" === this.layout.get("icon-pitch-alignment") && (this.layout._values["icon-pitch-alignment"] = this.layout.get("icon-rotation-alignment")), "point" === this.layout.get("symbol-placement")) {
                    const t2 = this.layout.get("text-writing-mode");
                    if (t2) {
                        const e2 = [];
                        for (const r of t2)e2.indexOf(r) < 0 && e2.push(r);
                        this.layout._values["text-writing-mode"] = e2;
                    } else this.layout._values["text-writing-mode"] = [
                        "horizontal"
                    ];
                }
                this._setPaintOverrides();
            }
            getValueAndResolveTokens(t1, e1, r, n) {
                const i = this.layout.get(t1).evaluate(e1, {}, r, n), a = this._unevaluatedLayout._values[t1];
                return a.isDataDriven() || Er(a.value) || !i ? i : function(t1, e1) {
                    return e1.replace(/{([^{}]+)}/g, (e1, r)=>r in t1 ? String(t1[r]) : "");
                }(e1.properties, i);
            }
            createBucket(t1) {
                return new Du(t1);
            }
            queryRadius() {
                return 0;
            }
            queryIntersectsFeature() {
                throw new Error("Should take a different path in FeatureIndex");
            }
            _setPaintOverrides() {
                for (const t1 of Ru.paint.overridableProperties){
                    if (!Uu.hasPaintOverride(this.layout, t1)) continue;
                    const e1 = this.paint.get(t1), r = new Ou(e1), n = new Vr(r, e1.property.specification);
                    let i = null;
                    i = "constant" === e1.value.kind || "source" === e1.value.kind ? new Tr("source", n) : new Lr("composite", n, e1.value.zoomStops), this.paint._values[t1] = new si(e1.property, i, e1.parameters);
                }
            }
            _handleOverridablePaintPropertyUpdate(t1, e1, r) {
                return !(!this.layout || e1.isDataDriven() || r.isDataDriven()) && Uu.hasPaintOverride(this.layout, t1);
            }
            static hasPaintOverride(t1, e1) {
                const r = t1.get("text-field"), n = Ru.paint.properties[e1];
                let i = !1;
                const a = (t1)=>{
                    for (const e1 of t1)if (n.overrides && n.overrides.hasOverride(e1)) return void (i = !0);
                };
                if ("constant" === r.value.kind && r.value.value instanceof Dt) a(r.value.value.sections);
                else if ("source" === r.value.kind) {
                    const t2 = (e1)=>{
                        i || (e1 instanceof Nt && qt(e1.value) === vt ? a(e1.value.sections) : e1 instanceof cr ? a(e1.sections) : e1.eachChild(t2));
                    }, e2 = r.value;
                    e2._styleExpression && t2(e2._styleExpression.expression);
                }
                return i;
            }
        }
        function qu(t1, e1, r) {
            let n = "never";
            const i = t1.get(e1);
            return i ? n = i : t1.get(r) && (n = "always"), n;
        }
        var ju = {
            paint: new fi({
                "background-color": new li(nt.paint_background["background-color"]),
                "background-pattern": new hi(nt.paint_background["background-pattern"]),
                "background-opacity": new li(nt.paint_background["background-opacity"])
            })
        }, Nu = {
            paint: new fi({
                "raster-opacity": new li(nt.paint_raster["raster-opacity"]),
                "raster-hue-rotate": new li(nt.paint_raster["raster-hue-rotate"]),
                "raster-brightness-min": new li(nt.paint_raster["raster-brightness-min"]),
                "raster-brightness-max": new li(nt.paint_raster["raster-brightness-max"]),
                "raster-saturation": new li(nt.paint_raster["raster-saturation"]),
                "raster-contrast": new li(nt.paint_raster["raster-contrast"]),
                "raster-resampling": new li(nt.paint_raster["raster-resampling"]),
                "raster-fade-duration": new li(nt.paint_raster["raster-fade-duration"])
            })
        };
        class Zu extends yi {
            constructor(t1){
                super(t1, {}), this.onAdd = (t1)=>{
                    this.implementation.onAdd && this.implementation.onAdd(t1, t1.painter.context.gl);
                }, this.onRemove = (t1)=>{
                    this.implementation.onRemove && this.implementation.onRemove(t1, t1.painter.context.gl);
                }, this.implementation = t1;
            }
            is3D() {
                return "3d" === this.implementation.renderingMode;
            }
            hasOffscreenPass() {
                return void 0 !== this.implementation.prerender;
            }
            recalculate() {}
            updateTransitions() {}
            hasTransition() {
                return !1;
            }
            serialize() {
                throw new Error("Custom layers cannot be serialized");
            }
        }
        const Ku = {
            circle: class extends yi {
                constructor(t1){
                    super(t1, cs);
                }
                createBucket(t1) {
                    return new Ja(t1);
                }
                queryRadius(t1) {
                    const e1 = t1;
                    return ss("circle-radius", this, e1) + ss("circle-stroke-width", this, e1) + os(this.paint.get("circle-translate"));
                }
                queryIntersectsFeature(t1, e1, r, n, i, a, s, o) {
                    const l = ls(t1, this.paint.get("circle-translate"), this.paint.get("circle-translate-anchor"), a.angle, s), u = this.paint.get("circle-radius").evaluate(e1, r) + this.paint.get("circle-stroke-width").evaluate(e1, r), c = "map" === this.paint.get("circle-pitch-alignment"), h = c ? l : function(t1, e1) {
                        return t1.map((t1)=>_s(t1, e1));
                    }(l, o), p = c ? u * s : u;
                    for (const t2 of n)for (const e2 of t2){
                        const t3 = c ? e2 : _s(e2, o);
                        let r1 = p;
                        const n1 = bs([], [
                            e2.x,
                            e2.y,
                            0,
                            1
                        ], o);
                        if ("viewport" === this.paint.get("circle-pitch-scale") && "map" === this.paint.get("circle-pitch-alignment") ? r1 *= n1[3] / a.cameraToCenterDistance : "map" === this.paint.get("circle-pitch-scale") && "viewport" === this.paint.get("circle-pitch-alignment") && (r1 *= a.cameraToCenterDistance / n1[3]), Ya(h, t3, r1)) return !0;
                    }
                    return !1;
                }
            },
            heatmap: class extends yi {
                constructor(t1){
                    super(t1, ks), this._updateColorRamp();
                }
                createBucket(t1) {
                    return new As(t1);
                }
                _handleSpecialPaintPropertyUpdate(t1) {
                    "heatmap-color" === t1 && this._updateColorRamp();
                }
                _updateColorRamp() {
                    this.colorRamp = Cs({
                        expression: this._transitionablePaint._values["heatmap-color"].value.expression,
                        evaluationKey: "heatmapDensity",
                        image: this.colorRamp
                    }), this.colorRampTexture = null;
                }
                resize() {
                    this.heatmapFbo && (this.heatmapFbo.destroy(), this.heatmapFbo = null);
                }
                queryRadius() {
                    return 0;
                }
                queryIntersectsFeature() {
                    return !1;
                }
                hasOffscreenPass() {
                    return 0 !== this.paint.get("heatmap-opacity") && "none" !== this.visibility;
                }
            },
            hillshade: class extends yi {
                constructor(t1){
                    super(t1, Ps);
                }
                hasOffscreenPass() {
                    return 0 !== this.paint.get("hillshade-exaggeration") && "none" !== this.visibility;
                }
            },
            fill: class extends yi {
                constructor(t1){
                    super(t1, xo);
                }
                recalculate(t1, e1) {
                    super.recalculate(t1, e1);
                    const r = this.paint._values["fill-outline-color"];
                    "constant" === r.value.kind && void 0 === r.value.value && (this.paint._values["fill-outline-color"] = this.paint._values["fill-color"]);
                }
                createBucket(t1) {
                    return new mo(t1);
                }
                queryRadius() {
                    return os(this.paint.get("fill-translate"));
                }
                queryIntersectsFeature(t1, e1, r, n, i, a, s) {
                    return Ha(ls(t1, this.paint.get("fill-translate"), this.paint.get("fill-translate-anchor"), a.angle, s), n);
                }
                isTileClipped() {
                    return !0;
                }
            },
            "fill-extrusion": class extends yi {
                constructor(t1){
                    super(t1, Oo);
                }
                createBucket(t1) {
                    return new Do(t1);
                }
                queryRadius() {
                    return os(this.paint.get("fill-extrusion-translate"));
                }
                is3D() {
                    return !0;
                }
                queryIntersectsFeature(t1, e1, r, n, i, a, s, o) {
                    const l = ls(t1, this.paint.get("fill-extrusion-translate"), this.paint.get("fill-extrusion-translate-anchor"), a.angle, s), u = this.paint.get("fill-extrusion-height").evaluate(e1, r), c = this.paint.get("fill-extrusion-base").evaluate(e1, r), h = function(t1, e1, r, n) {
                        const i = [];
                        for (const r1 of t1){
                            const t2 = [
                                r1.x,
                                r1.y,
                                0,
                                1
                            ];
                            bs(t2, t2, e1), i.push(new S(t2[0] / t2[3], t2[1] / t2[3]));
                        }
                        return i;
                    }(l, o), p = function(t1, e1, r, n) {
                        const i = [], a = [], s = n[8] * e1, o = n[9] * e1, l = n[10] * e1, u = n[11] * e1, c = n[8] * r, h = n[9] * r, p = n[10] * r, f = n[11] * r;
                        for (const e2 of t1){
                            const t2 = [], r1 = [];
                            for (const i1 of e2){
                                const e3 = i1.x, a1 = i1.y, d = n[0] * e3 + n[4] * a1 + n[12], y = n[1] * e3 + n[5] * a1 + n[13], m = n[2] * e3 + n[6] * a1 + n[14], g = n[3] * e3 + n[7] * a1 + n[15], x = m + l, v = g + u, b = d + c, w = y + h, _ = m + p, A = g + f, k = new S((d + s) / v, (y + o) / v);
                                k.z = x / v, t2.push(k);
                                const I = new S(b / A, w / A);
                                I.z = _ / A, r1.push(I);
                            }
                            i.push(t2), a.push(r1);
                        }
                        return [
                            i,
                            a
                        ];
                    }(n, c, u, o);
                    return function(t1, e1, r) {
                        let n = 1 / 0;
                        Ha(r, e1) && (n = qo(r, e1[0]));
                        for(let i = 0; i < e1.length; i++){
                            const a = e1[i], s = t1[i];
                            for(let t2 = 0; t2 < a.length - 1; t2++){
                                const e2 = a[t2], i1 = [
                                    e2,
                                    a[t2 + 1],
                                    s[t2 + 1],
                                    s[t2],
                                    e2
                                ];
                                Xa(r, i1) && (n = Math.min(n, qo(r, i1)));
                            }
                        }
                        return n !== 1 / 0 && n;
                    }(p[0], p[1], h);
                }
            },
            line: class extends yi {
                constructor(t1){
                    super(t1, Wo), this.gradientVersion = 0;
                }
                _handleSpecialPaintPropertyUpdate(t1) {
                    "line-gradient" === t1 && (this.stepInterpolant = this._transitionablePaint._values["line-gradient"].value.expression._styleExpression.expression instanceof ke, this.gradientVersion = (this.gradientVersion + 1) % Number.MAX_SAFE_INTEGER);
                }
                gradientExpression() {
                    return this._transitionablePaint._values["line-gradient"].value.expression;
                }
                recalculate(t1, e1) {
                    super.recalculate(t1, e1), this.paint._values["line-floorwidth"] = Qo.possiblyEvaluate(this._transitioningPaint._values["line-width"].value, t1);
                }
                createBucket(t1) {
                    return new Yo(t1);
                }
                queryRadius(t1) {
                    const e1 = t1, r = tl(ss("line-width", this, e1), ss("line-gap-width", this, e1)), n = ss("line-offset", this, e1);
                    return r / 2 + Math.abs(n) + os(this.paint.get("line-translate"));
                }
                queryIntersectsFeature(t1, e1, r, n, i, a, s) {
                    const o = ls(t1, this.paint.get("line-translate"), this.paint.get("line-translate-anchor"), a.angle, s), l = s / 2 * tl(this.paint.get("line-width").evaluate(e1, r), this.paint.get("line-gap-width").evaluate(e1, r)), u = this.paint.get("line-offset").evaluate(e1, r);
                    return u && (n = function(t1, e1) {
                        const r = [];
                        for(let n = 0; n < t1.length; n++){
                            const i = t1[n], a = [];
                            for(let t2 = 0; t2 < i.length; t2++){
                                const r1 = i[t2 - 1], n1 = i[t2], s = i[t2 + 1], o = 0 === t2 ? new S(0, 0) : n1.sub(r1)._unit()._perp(), l = t2 === i.length - 1 ? new S(0, 0) : s.sub(n1)._unit()._perp(), u = o._add(l)._unit(), c = u.x * l.x + u.y * l.y;
                                0 !== c && u._mult(1 / c), a.push(u._mult(e1)._add(n1));
                            }
                            r.push(a);
                        }
                        return r;
                    }(n, u * s)), function(t1, e1, r) {
                        for(let n = 0; n < e1.length; n++){
                            const i = e1[n];
                            if (t1.length >= 3) {
                                for(let e2 = 0; e2 < i.length; e2++)if (is(t1, i[e2])) return !0;
                            }
                            if (Wa(t1, i, r)) return !0;
                        }
                        return !1;
                    }(o, n, l);
                }
                isTileClipped() {
                    return !0;
                }
            },
            symbol: Uu,
            background: class extends yi {
                constructor(t1){
                    super(t1, ju);
                }
            },
            raster: class extends yi {
                constructor(t1){
                    super(t1, Nu);
                }
            }
        };
        class Gu {
            constructor(t1){
                this._callback = t1, this._triggered = !1, "undefined" != typeof MessageChannel && (this._channel = new MessageChannel, this._channel.port2.onmessage = ()=>{
                    this._triggered = !1, this._callback();
                });
            }
            trigger() {
                this._triggered || (this._triggered = !0, this._channel ? this._channel.port1.postMessage(!0) : setTimeout(()=>{
                    this._triggered = !1, this._callback();
                }, 0));
            }
            remove() {
                delete this._channel, this._callback = ()=>{};
            }
        }
        const Ju = 6371008.8;
        class Xu {
            constructor(t1, e1){
                if (isNaN(t1) || isNaN(e1)) throw new Error(`Invalid LngLat object: (${t1}, ${e1})`);
                if (this.lng = +t1, this.lat = +e1, this.lat > 90 || this.lat < -90) throw new Error("Invalid LngLat latitude value: must be between -90 and 90");
            }
            wrap() {
                return new Xu(s(this.lng, -180, 180), this.lat);
            }
            toArray() {
                return [
                    this.lng,
                    this.lat
                ];
            }
            toString() {
                return `LngLat(${this.lng}, ${this.lat})`;
            }
            distanceTo(t1) {
                const e1 = Math.PI / 180, r = this.lat * e1, n = t1.lat * e1, i = Math.sin(r) * Math.sin(n) + Math.cos(r) * Math.cos(n) * Math.cos((t1.lng - this.lng) * e1);
                return Ju * Math.acos(Math.min(i, 1));
            }
            toBounds(t1 = 0) {
                const e1 = 360 * t1 / 40075017, r = e1 / Math.cos(Math.PI / 180 * this.lat);
                return new Yu(new Xu(this.lng - r, this.lat - e1), new Xu(this.lng + r, this.lat + e1));
            }
            static convert(t1) {
                if (t1 instanceof Xu) return t1;
                if (Array.isArray(t1) && (2 === t1.length || 3 === t1.length)) return new Xu(Number(t1[0]), Number(t1[1]));
                if (!Array.isArray(t1) && "object" == typeof t1 && null !== t1) return new Xu(Number("lng" in t1 ? t1.lng : t1.lon), Number(t1.lat));
                throw new Error("`LngLatLike` argument must be specified as a LngLat instance, an object {lng: <lng>, lat: <lat>}, an object {lon: <lng>, lat: <lat>}, or an array of [<lng>, <lat>]");
            }
        }
        class Yu {
            constructor(t1, e1){
                t1 && (e1 ? this.setSouthWest(t1).setNorthEast(e1) : 4 === t1.length ? this.setSouthWest([
                    t1[0],
                    t1[1]
                ]).setNorthEast([
                    t1[2],
                    t1[3]
                ]) : this.setSouthWest(t1[0]).setNorthEast(t1[1]));
            }
            setNorthEast(t1) {
                return this._ne = t1 instanceof Xu ? new Xu(t1.lng, t1.lat) : Xu.convert(t1), this;
            }
            setSouthWest(t1) {
                return this._sw = t1 instanceof Xu ? new Xu(t1.lng, t1.lat) : Xu.convert(t1), this;
            }
            extend(t1) {
                const e1 = this._sw, r = this._ne;
                let n, i;
                if (t1 instanceof Xu) n = t1, i = t1;
                else {
                    if (!(t1 instanceof Yu)) return Array.isArray(t1) ? 4 === t1.length || t1.every(Array.isArray) ? this.extend(Yu.convert(t1)) : this.extend(Xu.convert(t1)) : this;
                    if (n = t1._sw, i = t1._ne, !n || !i) return this;
                }
                return e1 || r ? (e1.lng = Math.min(n.lng, e1.lng), e1.lat = Math.min(n.lat, e1.lat), r.lng = Math.max(i.lng, r.lng), r.lat = Math.max(i.lat, r.lat)) : (this._sw = new Xu(n.lng, n.lat), this._ne = new Xu(i.lng, i.lat)), this;
            }
            getCenter() {
                return new Xu((this._sw.lng + this._ne.lng) / 2, (this._sw.lat + this._ne.lat) / 2);
            }
            getSouthWest() {
                return this._sw;
            }
            getNorthEast() {
                return this._ne;
            }
            getNorthWest() {
                return new Xu(this.getWest(), this.getNorth());
            }
            getSouthEast() {
                return new Xu(this.getEast(), this.getSouth());
            }
            getWest() {
                return this._sw.lng;
            }
            getSouth() {
                return this._sw.lat;
            }
            getEast() {
                return this._ne.lng;
            }
            getNorth() {
                return this._ne.lat;
            }
            toArray() {
                return [
                    this._sw.toArray(),
                    this._ne.toArray()
                ];
            }
            toString() {
                return `LngLatBounds(${this._sw.toString()}, ${this._ne.toString()})`;
            }
            isEmpty() {
                return !(this._sw && this._ne);
            }
            contains(t1) {
                const { lng: e1 , lat: r  } = Xu.convert(t1);
                let n = this._sw.lng <= e1 && e1 <= this._ne.lng;
                return this._sw.lng > this._ne.lng && (n = this._sw.lng >= e1 && e1 >= this._ne.lng), this._sw.lat <= r && r <= this._ne.lat && n;
            }
            static convert(t1) {
                return t1 instanceof Yu ? t1 : t1 ? new Yu(t1) : t1;
            }
        }
        const Hu = 2 * Math.PI * Ju;
        function Wu(t1) {
            return Hu * Math.cos(t1 * Math.PI / 180);
        }
        function Qu(t1) {
            return (180 + t1) / 360;
        }
        function tc(t1) {
            return (180 - 180 / Math.PI * Math.log(Math.tan(Math.PI / 4 + t1 * Math.PI / 360))) / 360;
        }
        function ec(t1, e1) {
            return t1 / Wu(e1);
        }
        function rc(t1) {
            return 360 / Math.PI * Math.atan(Math.exp((180 - 360 * t1) * Math.PI / 180)) - 90;
        }
        class nc {
            constructor(t1, e1, r = 0){
                this.x = +t1, this.y = +e1, this.z = +r;
            }
            static fromLngLat(t1, e1 = 0) {
                const r = Xu.convert(t1);
                return new nc(Qu(r.lng), tc(r.lat), ec(e1, r.lat));
            }
            toLngLat() {
                return new Xu(360 * this.x - 180, rc(this.y));
            }
            toAltitude() {
                return this.z * Wu(rc(this.y));
            }
            meterInMercatorCoordinateUnits() {
                var t1;
                return 1 / Hu * (t1 = rc(this.y), 1 / Math.cos(t1 * Math.PI / 180));
            }
        }
        function ic(t1, e1, r) {
            var n = 2 * Math.PI * 6378137 / 256 / Math.pow(2, r);
            return [
                t1 * n - 2 * Math.PI * 6378137 / 2,
                e1 * n - 2 * Math.PI * 6378137 / 2
            ];
        }
        class ac {
            constructor(t1, e1, r){
                if (t1 < 0 || t1 > 25 || r < 0 || r >= Math.pow(2, t1) || e1 < 0 || e1 >= Math.pow(2, t1)) throw new Error(`x=${e1}, y=${r}, z=${t1} outside of bounds. 0<=x<${Math.pow(2, t1)}, 0<=y<${Math.pow(2, t1)} 0<=z<=25 `);
                this.z = t1, this.x = e1, this.y = r, this.key = lc(0, t1, t1, e1, r);
            }
            equals(t1) {
                return this.z === t1.z && this.x === t1.x && this.y === t1.y;
            }
            url(t1, e1, r) {
                const n = (a = this.y, s = this.z, o = ic(256 * (i = this.x), 256 * (a = Math.pow(2, s) - a - 1), s), l = ic(256 * (i + 1), 256 * (a + 1), s), o[0] + "," + o[1] + "," + l[0] + "," + l[1]);
                var i, a, s, o, l;
                const u = function(t1, e1, r) {
                    let n, i = "";
                    for(let a = t1; a > 0; a--)n = 1 << a - 1, i += (e1 & n ? 1 : 0) + (r & n ? 2 : 0);
                    return i;
                }(this.z, this.x, this.y);
                return t1[(this.x + this.y) % t1.length].replace(/{prefix}/g, (this.x % 16).toString(16) + (this.y % 16).toString(16)).replace(/{z}/g, String(this.z)).replace(/{x}/g, String(this.x)).replace(/{y}/g, String("tms" === r ? Math.pow(2, this.z) - this.y - 1 : this.y)).replace(/{ratio}/g, e1 > 1 ? "@2x" : "").replace(/{quadkey}/g, u).replace(/{bbox-epsg-3857}/g, n);
            }
            isChildOf(t1) {
                const e1 = this.z - t1.z;
                return e1 > 0 && t1.x === this.x >> e1 && t1.y === this.y >> e1;
            }
            getTilePoint(t1) {
                const e1 = Math.pow(2, this.z);
                return new S((t1.x * e1 - this.x) * qa, (t1.y * e1 - this.y) * qa);
            }
            toString() {
                return `${this.z}/${this.x}/${this.y}`;
            }
        }
        class sc {
            constructor(t1, e1){
                this.wrap = t1, this.canonical = e1, this.key = lc(t1, e1.z, e1.z, e1.x, e1.y);
            }
        }
        class oc {
            constructor(t1, e1, r, n, i){
                if (t1 < r) throw new Error(`overscaledZ should be >= z; overscaledZ = ${t1}; z = ${r}`);
                this.overscaledZ = t1, this.wrap = e1, this.canonical = new ac(r, +n, +i), this.key = lc(e1, t1, r, n, i);
            }
            clone() {
                return new oc(this.overscaledZ, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y);
            }
            equals(t1) {
                return this.overscaledZ === t1.overscaledZ && this.wrap === t1.wrap && this.canonical.equals(t1.canonical);
            }
            scaledTo(t1) {
                if (t1 > this.overscaledZ) throw new Error(`targetZ > this.overscaledZ; targetZ = ${t1}; overscaledZ = ${this.overscaledZ}`);
                const e1 = this.canonical.z - t1;
                return t1 > this.canonical.z ? new oc(t1, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y) : new oc(t1, this.wrap, t1, this.canonical.x >> e1, this.canonical.y >> e1);
            }
            calculateScaledKey(t1, e1) {
                if (t1 > this.overscaledZ) throw new Error(`targetZ > this.overscaledZ; targetZ = ${t1}; overscaledZ = ${this.overscaledZ}`);
                const r = this.canonical.z - t1;
                return t1 > this.canonical.z ? lc(this.wrap * +e1, t1, this.canonical.z, this.canonical.x, this.canonical.y) : lc(this.wrap * +e1, t1, t1, this.canonical.x >> r, this.canonical.y >> r);
            }
            isChildOf(t1) {
                if (t1.wrap !== this.wrap) return !1;
                const e1 = this.canonical.z - t1.canonical.z;
                return 0 === t1.overscaledZ || t1.overscaledZ < this.overscaledZ && t1.canonical.x === this.canonical.x >> e1 && t1.canonical.y === this.canonical.y >> e1;
            }
            children(t1) {
                if (this.overscaledZ >= t1) return [
                    new oc(this.overscaledZ + 1, this.wrap, this.canonical.z, this.canonical.x, this.canonical.y)
                ];
                const e1 = this.canonical.z + 1, r = 2 * this.canonical.x, n = 2 * this.canonical.y;
                return [
                    new oc(e1, this.wrap, e1, r, n),
                    new oc(e1, this.wrap, e1, r + 1, n),
                    new oc(e1, this.wrap, e1, r, n + 1),
                    new oc(e1, this.wrap, e1, r + 1, n + 1)
                ];
            }
            isLessThan(t1) {
                return this.wrap < t1.wrap || !(this.wrap > t1.wrap) && (this.overscaledZ < t1.overscaledZ || !(this.overscaledZ > t1.overscaledZ) && (this.canonical.x < t1.canonical.x || !(this.canonical.x > t1.canonical.x) && this.canonical.y < t1.canonical.y));
            }
            wrapped() {
                return new oc(this.overscaledZ, 0, this.canonical.z, this.canonical.x, this.canonical.y);
            }
            unwrapTo(t1) {
                return new oc(this.overscaledZ, t1, this.canonical.z, this.canonical.x, this.canonical.y);
            }
            overscaleFactor() {
                return Math.pow(2, this.overscaledZ - this.canonical.z);
            }
            toUnwrapped() {
                return new sc(this.wrap, this.canonical);
            }
            toString() {
                return `${this.overscaledZ}/${this.canonical.x}/${this.canonical.y}`;
            }
            getTilePoint(t1) {
                return this.canonical.getTilePoint(new nc(t1.x - this.wrap, t1.y));
            }
        }
        function lc(t1, e1, r, n, i) {
            (t1 *= 2) < 0 && (t1 = -1 * t1 - 1);
            const a = 1 << r;
            return (a * a * t1 + a * i + n).toString(36) + r.toString(36) + e1.toString(36);
        }
        Mn("CanonicalTileID", ac), Mn("OverscaledTileID", oc, {
            omit: [
                "posMatrix"
            ]
        });
        class uc {
            constructor(t1, e1, r){
                if (this.uid = t1, e1.height !== e1.width) throw new RangeError("DEM tiles must be square");
                if (r && "mapbox" !== r && "terrarium" !== r) return void d(`"${r}" is not a valid encoding type. Valid types include "mapbox" and "terrarium".`);
                this.stride = e1.height;
                const n = this.dim = e1.height - 2;
                this.data = new Uint32Array(e1.data.buffer), this.encoding = r || "mapbox";
                for(let t2 = 0; t2 < n; t2++)this.data[this._idx(-1, t2)] = this.data[this._idx(0, t2)], this.data[this._idx(n, t2)] = this.data[this._idx(n - 1, t2)], this.data[this._idx(t2, -1)] = this.data[this._idx(t2, 0)], this.data[this._idx(t2, n)] = this.data[this._idx(t2, n - 1)];
                this.data[this._idx(-1, -1)] = this.data[this._idx(0, 0)], this.data[this._idx(n, -1)] = this.data[this._idx(n - 1, 0)], this.data[this._idx(-1, n)] = this.data[this._idx(0, n - 1)], this.data[this._idx(n, n)] = this.data[this._idx(n - 1, n - 1)], this.min = Number.MAX_SAFE_INTEGER, this.max = Number.MIN_SAFE_INTEGER;
                for(let t3 = 0; t3 < n; t3++)for(let e2 = 0; e2 < n; e2++){
                    const r1 = this.get(t3, e2);
                    r1 > this.max && (this.max = r1), r1 < this.min && (this.min = r1);
                }
            }
            get(t1, e1) {
                const r = new Uint8Array(this.data.buffer), n = 4 * this._idx(t1, e1);
                return ("terrarium" === this.encoding ? this._unpackTerrarium : this._unpackMapbox)(r[n], r[n + 1], r[n + 2]);
            }
            getUnpackVector() {
                return "terrarium" === this.encoding ? [
                    256,
                    1,
                    1 / 256,
                    32768
                ] : [
                    6553.6,
                    25.6,
                    .1,
                    1e4
                ];
            }
            _idx(t1, e1) {
                if (t1 < -1 || t1 >= this.dim + 1 || e1 < -1 || e1 >= this.dim + 1) throw new RangeError("out of range source coordinates for DEM data");
                return (e1 + 1) * this.stride + (t1 + 1);
            }
            _unpackMapbox(t1, e1, r) {
                return (256 * t1 * 256 + 256 * e1 + r) / 10 - 1e4;
            }
            _unpackTerrarium(t1, e1, r) {
                return 256 * t1 + e1 + r / 256 - 32768;
            }
            getPixels() {
                return new Bs({
                    width: this.stride,
                    height: this.stride
                }, new Uint8Array(this.data.buffer));
            }
            backfillBorder(t1, e1, r) {
                if (this.dim !== t1.dim) throw new Error("dem dimension mismatch");
                let n = e1 * this.dim, i = e1 * this.dim + this.dim, a = r * this.dim, s = r * this.dim + this.dim;
                switch(e1){
                    case -1:
                        n = i - 1;
                        break;
                    case 1:
                        i = n + 1;
                }
                switch(r){
                    case -1:
                        a = s - 1;
                        break;
                    case 1:
                        s = a + 1;
                }
                const o = -e1 * this.dim, l = -r * this.dim;
                for(let e2 = a; e2 < s; e2++)for(let r1 = n; r1 < i; r1++)this.data[this._idx(r1, e2)] = t1.data[this._idx(r1 + o, e2 + l)];
            }
        }
        Mn("DEMData", uc);
        class cc {
            constructor(t1){
                this._stringToNumber = {}, this._numberToString = [];
                for(let e1 = 0; e1 < t1.length; e1++){
                    const r = t1[e1];
                    this._stringToNumber[r] = e1, this._numberToString[e1] = r;
                }
            }
            encode(t1) {
                return this._stringToNumber[t1];
            }
            decode(t1) {
                if (t1 >= this._numberToString.length) throw new Error(`Out of bounds. Index requested n=${t1} can't be >= this._numberToString.length ${this._numberToString.length}`);
                return this._numberToString[t1];
            }
        }
        class hc {
            constructor(t1, e1, r, n, i){
                this.type = "Feature", this._vectorTileFeature = t1, t1._z = e1, t1._x = r, t1._y = n, this.properties = t1.properties, this.id = i;
            }
            get geometry() {
                return void 0 === this._geometry && (this._geometry = this._vectorTileFeature.toGeoJSON(this._vectorTileFeature._x, this._vectorTileFeature._y, this._vectorTileFeature._z).geometry), this._geometry;
            }
            set geometry(t1) {
                this._geometry = t1;
            }
            toJSON() {
                const t1 = {
                    geometry: this.geometry
                };
                for(const e1 in this)"_geometry" !== e1 && "_vectorTileFeature" !== e1 && (t1[e1] = this[e1]);
                return t1;
            }
        }
        class pc {
            constructor(t1, e1){
                this.tileID = t1, this.x = t1.canonical.x, this.y = t1.canonical.y, this.z = t1.canonical.z, this.grid = new Sn(qa, 16, 0), this.grid3D = new Sn(qa, 16, 0), this.featureIndexArray = new Wi, this.promoteId = e1;
            }
            insert(t1, e1, r, n, i, a) {
                const s = this.featureIndexArray.length;
                this.featureIndexArray.emplaceBack(r, n, i);
                const o = a ? this.grid3D : this.grid;
                for(let t2 = 0; t2 < e1.length; t2++){
                    const r1 = e1[t2], n1 = [
                        1 / 0,
                        1 / 0,
                        -1 / 0,
                        -1 / 0
                    ];
                    for(let t3 = 0; t3 < r1.length; t3++){
                        const e2 = r1[t3];
                        n1[0] = Math.min(n1[0], e2.x), n1[1] = Math.min(n1[1], e2.y), n1[2] = Math.max(n1[2], e2.x), n1[3] = Math.max(n1[3], e2.y);
                    }
                    n1[0] < qa && n1[1] < qa && n1[2] >= 0 && n1[3] >= 0 && o.insert(s, n1[0], n1[1], n1[2], n1[3]);
                }
            }
            loadVTLayers() {
                return this.vtLayers || (this.vtLayers = new _o.VectorTile(new ul(this.rawTileData)).layers, this.sourceLayerCoder = new cc(this.vtLayers ? Object.keys(this.vtLayers).sort() : [
                    "_geojsonTileLayer"
                ])), this.vtLayers;
            }
            query(t1, e1, r, n) {
                this.loadVTLayers();
                const i = t1.params || {}, a = qa / t1.tileSize / t1.scale, s = Jr(i.filter), o = t1.queryGeometry, l = t1.queryPadding * a, u = dc(o), c = this.grid.query(u.minX - l, u.minY - l, u.maxX + l, u.maxY + l), h = dc(t1.cameraQueryGeometry), p = this.grid3D.query(h.minX - l, h.minY - l, h.maxX + l, h.maxY + l, (e1, r, n, i)=>(function(t1, e1, r, n, i) {
                        for (const a of t1)if (e1 <= a.x && r <= a.y && n >= a.x && i >= a.y) return !0;
                        const a1 = [
                            new S(e1, r),
                            new S(e1, i),
                            new S(n, i),
                            new S(n, r)
                        ];
                        if (t1.length > 2) {
                            for (const e2 of a1)if (is(t1, e2)) return !0;
                        }
                        for(let e3 = 0; e3 < t1.length - 1; e3++)if (as(t1[e3], t1[e3 + 1], a1)) return !0;
                        return !1;
                    })(t1.cameraQueryGeometry, e1 - l, r - l, n + l, i + l));
                for (const t2 of p)c.push(t2);
                c.sort(yc);
                const f = {};
                let d;
                for(let l1 = 0; l1 < c.length; l1++){
                    const u1 = c[l1];
                    if (u1 === d) continue;
                    d = u1;
                    const h1 = this.featureIndexArray.get(u1);
                    let p1 = null;
                    this.loadMatchingFeature(f, h1.bucketIndex, h1.sourceLayerIndex, h1.featureIndex, s, i.layers, i.availableImages, e1, r, n, (e1, r, n)=>(p1 || (p1 = Za(e1)), r.queryIntersectsFeature(o, e1, n, p1, this.z, t1.transform, a, t1.pixelPosMatrix)));
                }
                return f;
            }
            loadMatchingFeature(t1, e1, r, n, i, a, s, l, u, c, h) {
                const p = this.bucketLayerIDs[e1];
                if (a && !function(t1, e1) {
                    for(let r = 0; r < t1.length; r++)if (e1.indexOf(t1[r]) >= 0) return !0;
                    return !1;
                }(a, p)) return;
                const f = this.sourceLayerCoder.decode(r), d = this.vtLayers[f].feature(n);
                if (i.needGeometry) {
                    const t2 = Ka(d, !0);
                    if (!i.filter(new Qn(this.tileID.overscaledZ), t2, this.tileID.canonical)) return;
                } else if (!i.filter(new Qn(this.tileID.overscaledZ), d)) return;
                const y = this.getId(d, f);
                for(let e2 = 0; e2 < p.length; e2++){
                    const r1 = p[e2];
                    if (a && a.indexOf(r1) < 0) continue;
                    const i1 = l[r1];
                    if (!i1) continue;
                    let f1 = {};
                    y && c && (f1 = c.getState(i1.sourceLayer || "_geojsonTileLayer", y));
                    const m = o({}, u[r1]);
                    m.paint = fc(m.paint, i1.paint, d, f1, s), m.layout = fc(m.layout, i1.layout, d, f1, s);
                    const g = !h || h(d, i1, f1);
                    if (!g) continue;
                    const x = new hc(d, this.z, this.x, this.y, y);
                    x.layer = m;
                    let v = t1[r1];
                    void 0 === v && (v = t1[r1] = []), v.push({
                        featureIndex: n,
                        feature: x,
                        intersectionZ: g
                    });
                }
            }
            lookupSymbolFeatures(t1, e1, r, n, i, a, s, o) {
                const l = {};
                this.loadVTLayers();
                const u = Jr(i);
                for (const i1 of t1)this.loadMatchingFeature(l, r, n, i1, u, a, s, o, e1);
                return l;
            }
            hasLayer(t1) {
                for (const e1 of this.bucketLayerIDs)for (const r of e1)if (t1 === r) return !0;
                return !1;
            }
            getId(t1, e1) {
                let r = t1.id;
                return this.promoteId && (r = t1.properties["string" == typeof this.promoteId ? this.promoteId : this.promoteId[e1]], "boolean" == typeof r && (r = Number(r))), r;
            }
        }
        function fc(t1, e1, r, n, i) {
            return c(t1, (t1, a)=>{
                const s = e1 instanceof oi ? e1.get(a) : null;
                return s && s.evaluate ? s.evaluate(r, n, i) : s;
            });
        }
        function dc(t1) {
            let e1 = 1 / 0, r = 1 / 0, n = -1 / 0, i = -1 / 0;
            for (const a of t1)e1 = Math.min(e1, a.x), r = Math.min(r, a.y), n = Math.max(n, a.x), i = Math.max(i, a.y);
            return {
                minX: e1,
                minY: r,
                maxX: n,
                maxY: i
            };
        }
        function yc(t1, e1) {
            return e1 - t1;
        }
        var mc;
        Mn("FeatureIndex", pc, {
            omit: [
                "rawTileData",
                "sourceLayerCoder"
            ]
        }), t1.PerformanceMarkers = void 0, (mc = t1.PerformanceMarkers || (t1.PerformanceMarkers = {})).create = "create", mc.load = "load", mc.fullLoad = "fullLoad";
        let gc = null, xc = [];
        const vc = 1e3 / 30, bc = {
            mark (t1) {
                performance.mark(t1);
            },
            frame (t1) {
                const e1 = t1;
                null != gc && xc.push(e1 - gc), gc = e1;
            },
            clearMetrics () {
                gc = null, xc = [], performance.clearMeasures("loadTime"), performance.clearMeasures("fullLoadTime");
                for(const e1 in t1.PerformanceMarkers)performance.clearMarks(t1.PerformanceMarkers[e1]);
            },
            getPerformanceMetrics () {
                performance.measure("loadTime", t1.PerformanceMarkers.create, t1.PerformanceMarkers.load), performance.measure("fullLoadTime", t1.PerformanceMarkers.create, t1.PerformanceMarkers.fullLoad);
                const e1 = performance.getEntriesByName("loadTime")[0].duration, r = performance.getEntriesByName("fullLoadTime")[0].duration, n = xc.length, i = 1 / (xc.reduce((t1, e1)=>t1 + e1, 0) / n / 1e3), a = xc.filter((t1)=>t1 > vc).reduce((t1, e1)=>t1 + (e1 - vc) / vc, 0);
                return {
                    loadTime: e1,
                    fullLoadTime: r,
                    fps: i,
                    percentDroppedFrames: a / (n + a) * 100
                };
            }
        };
        t1.AJAXError = q, t1.ARRAY_TYPE = ps, t1.Actor = class {
            constructor(t1, e1, r){
                this.target = t1, this.parent = e1, this.mapId = r, this.callbacks = {}, this.tasks = {}, this.taskQueue = [], this.cancelCallbacks = {}, u([
                    "receive",
                    "process"
                ], this), this.invoker = new Gu(this.process), this.target.addEventListener("message", this.receive, !1), this.globalScope = g() ? t1 : window;
            }
            send(t1, e1, r, n, i = !1) {
                const a = Math.round(1e18 * Math.random()).toString(36).substring(0, 10);
                r && (this.callbacks[a] = r);
                const s = _(this.globalScope) ? void 0 : [];
                return this.target.postMessage({
                    id: a,
                    type: t1,
                    hasCallback: !!r,
                    targetMapId: n,
                    mustQueue: i,
                    sourceMapId: this.mapId,
                    data: Bn(e1, s)
                }, s), {
                    cancel: ()=>{
                        r && delete this.callbacks[a], this.target.postMessage({
                            id: a,
                            type: "<cancel>",
                            targetMapId: n,
                            sourceMapId: this.mapId
                        });
                    }
                };
            }
            receive(t1) {
                const e1 = t1.data, r = e1.id;
                if (r && (!e1.targetMapId || this.mapId === e1.targetMapId)) {
                    if ("<cancel>" === e1.type) {
                        delete this.tasks[r];
                        const t2 = this.cancelCallbacks[r];
                        delete this.cancelCallbacks[r], t2 && t2();
                    } else g() || e1.mustQueue ? (this.tasks[r] = e1, this.taskQueue.push(r), this.invoker.trigger()) : this.processTask(r, e1);
                }
            }
            process() {
                if (!this.taskQueue.length) return;
                const t1 = this.taskQueue.shift(), e1 = this.tasks[t1];
                delete this.tasks[t1], this.taskQueue.length && this.invoker.trigger(), e1 && this.processTask(t1, e1);
            }
            processTask(t1, e1) {
                if ("<response>" === e1.type) {
                    const r = this.callbacks[t1];
                    delete this.callbacks[t1], r && (e1.error ? r(Cn(e1.error)) : r(null, Cn(e1.data)));
                } else {
                    let r1 = !1;
                    const n = _(this.globalScope) ? void 0 : [], i = e1.hasCallback ? (e1, i)=>{
                        r1 = !0, delete this.cancelCallbacks[t1], this.target.postMessage({
                            id: t1,
                            type: "<response>",
                            sourceMapId: this.mapId,
                            error: e1 ? Bn(e1) : null,
                            data: Bn(i, n)
                        }, n);
                    } : (t1)=>{
                        r1 = !0;
                    };
                    let a = null;
                    const s = Cn(e1.data);
                    if (this.parent[e1.type]) a = this.parent[e1.type](e1.sourceMapId, s, i);
                    else if (this.parent.getWorkerSource) {
                        const t2 = e1.type.split(".");
                        a = this.parent.getWorkerSource(e1.sourceMapId, t2[0], s.source)[t2[1]](s, i);
                    } else i(new Error(`Could not find function ${e1.type}`));
                    !r1 && a && a.cancel && (this.cancelCallbacks[t1] = a.cancel);
                }
            }
            remove() {
                this.invoker.remove(), this.target.removeEventListener("message", this.receive, !1);
            }
        }, t1.AlphaImage = zs, t1.CanonicalTileID = ac, t1.CollisionBoxArray = Ni, t1.CollisionCircleLayoutArray = class extends Vi {
        }, t1.Color = Ft, t1.DEMData = uc, t1.DataConstantProperty = li, t1.DictionaryCoder = cc, t1.EXTENT = qa, t1.ErrorEvent = et, t1.EvaluationParameters = Qn, t1.Event = tt, t1.Evented = rt, t1.FeatureIndex = pc, t1.FillBucket = mo, t1.FillExtrusionBucket = Do, t1.GeoJSONFeature = hc, t1.ImageAtlas = Dl, t1.ImagePosition = Ll, t1.LineBucket = Yo, t1.LineStripIndexArray = class extends Ui {
        }, t1.LngLat = Xu, t1.LngLatBounds = Yu, t1.MercatorCoordinate = nc, t1.ONE_EM = ll, t1.OverscaledTileID = oc, t1.PerformanceUtils = bc, t1.PosArray = Qi, t1.Properties = fi, t1.QuadTriangleArray = class extends Fi {
        }, t1.RGBAImage = Bs, t1.RasterBoundsArray = class extends _i {
        }, t1.RequestPerformance = class {
            constructor(t1){
                this._marks = {
                    start: [
                        t1.url,
                        "start"
                    ].join("#"),
                    end: [
                        t1.url,
                        "end"
                    ].join("#"),
                    measure: t1.url.toString()
                }, performance.mark(this._marks.start);
            }
            finish() {
                performance.mark(this._marks.end);
                let t1 = performance.getEntriesByName(this._marks.measure);
                return 0 === t1.length && (performance.measure(this._marks.measure, this._marks.start, this._marks.end), t1 = performance.getEntriesByName(this._marks.measure), performance.clearMarks(this._marks.start), performance.clearMarks(this._marks.end), performance.clearMeasures(this._marks.measure)), t1;
            }
        }, t1.ResourceType = U, t1.SegmentVector = ya, t1.SymbolBucket = Du, t1.Transitionable = ri, t1.TriangleIndexArray = ha, t1.Uniform1f = za, t1.Uniform1i = class extends Ma {
            constructor(t1, e1){
                super(t1, e1), this.current = 0;
            }
            set(t1) {
                this.current !== t1 && (this.current = t1, this.gl.uniform1i(this.location, t1));
            }
        }, t1.Uniform2f = class extends Ma {
            constructor(t1, e1){
                super(t1, e1), this.current = [
                    0,
                    0
                ];
            }
            set(t1) {
                t1[0] === this.current[0] && t1[1] === this.current[1] || (this.current = t1, this.gl.uniform2f(this.location, t1[0], t1[1]));
            }
        }, t1.Uniform3f = class extends Ma {
            constructor(t1, e1){
                super(t1, e1), this.current = [
                    0,
                    0,
                    0
                ];
            }
            set(t1) {
                t1[0] === this.current[0] && t1[1] === this.current[1] && t1[2] === this.current[2] || (this.current = t1, this.gl.uniform3f(this.location, t1[0], t1[1], t1[2]));
            }
        }, t1.Uniform4f = Ba, t1.UniformColor = Ca, t1.UniformMatrix4f = class extends Ma {
            constructor(t1, e1){
                super(t1, e1), this.current = Pa;
            }
            set(t1) {
                if (t1[12] !== this.current[12] || t1[0] !== this.current[0]) return this.current = t1, void this.gl.uniformMatrix4fv(this.location, !1, t1);
                for(let e1 = 1; e1 < 16; e1++)if (t1[e1] !== this.current[e1]) {
                    this.current = t1, this.gl.uniformMatrix4fv(this.location, !1, t1);
                    break;
                }
            }
        }, t1.UnwrappedTileID = sc, t1.ValidationError = it, t1.ZoomHistory = Pn, t1.add = function(t1, e1, r) {
            return t1[0] = e1[0] + r[0], t1[1] = e1[1] + r[1], t1[2] = e1[2] + r[2], t1;
        }, t1.addDynamicAttributes = Eu, t1.asyncAll = function(t1, e1, r) {
            if (!t1.length) return r(null, []);
            let n = t1.length;
            const i = new Array(t1.length);
            let a = null;
            t1.forEach((t1, s)=>{
                e1(t1, (t1, e1)=>{
                    t1 && (a = t1), i[s] = e1, 0 == --n && r(a, i);
                });
            });
        }, t1.bezier = n, t1.bindAll = u, t1.cacheEntryPossiblyAdded = function(t1) {
            F++, F > V && (t1.getActor().send("enforceCacheSizeLimit", P), F = 0);
        }, t1.clamp = a, t1.clearTileCache = function(t1) {
            const e1 = caches.delete(z);
            t1 && e1.catch(t1).then(()=>t1());
        }, t1.clipLine = cu, t1.clone = function(t1) {
            var e1 = new ps(16);
            return e1[0] = t1[0], e1[1] = t1[1], e1[2] = t1[2], e1[3] = t1[3], e1[4] = t1[4], e1[5] = t1[5], e1[6] = t1[6], e1[7] = t1[7], e1[8] = t1[8], e1[9] = t1[9], e1[10] = t1[10], e1[11] = t1[11], e1[12] = t1[12], e1[13] = t1[13], e1[14] = t1[14], e1[15] = t1[15], e1;
        }, t1.clone$1 = p, t1.clone$2 = function(t1) {
            var e1 = new ps(3);
            return e1[0] = t1[0], e1[1] = t1[1], e1[2] = t1[2], e1;
        }, t1.collisionCircleLayout = al, t1.config = M, t1.copy = function(t1, e1) {
            return t1[0] = e1[0], t1[1] = e1[1], t1[2] = e1[2], t1[3] = e1[3], t1[4] = e1[4], t1[5] = e1[5], t1[6] = e1[6], t1[7] = e1[7], t1[8] = e1[8], t1[9] = e1[9], t1[10] = e1[10], t1[11] = e1[11], t1[12] = e1[12], t1[13] = e1[13], t1[14] = e1[14], t1[15] = e1[15], t1;
        }, t1.create = function() {
            var t1 = new ps(16);
            return ps != Float32Array && (t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[11] = 0, t1[12] = 0, t1[13] = 0, t1[14] = 0), t1[0] = 1, t1[5] = 1, t1[10] = 1, t1[15] = 1, t1;
        }, t1.create$1 = fs, t1.createExpression = Fr, t1.createFilter = Jr, t1.createLayout = vi, t1.createStyleLayer = function(t1) {
            return "custom" === t1.type ? new Zu(t1) : new Ku[t1.type](t1);
        }, t1.cross = function(t1, e1, r) {
            var n = e1[0], i = e1[1], a = e1[2], s = r[0], o = r[1], l = r[2];
            return t1[0] = i * l - a * o, t1[1] = a * s - n * l, t1[2] = n * o - i * s, t1;
        }, t1.dot = function(t1, e1) {
            return t1[0] * e1[0] + t1[1] * e1[1] + t1[2] * e1[2];
        }, t1.dot$1 = function(t1, e1) {
            return t1[0] * e1[0] + t1[1] * e1[1] + t1[2] * e1[2] + t1[3] * e1[3];
        }, t1.ease = i, t1.emitValidationErrors = kn, t1.enforceCacheSizeLimit = function(t1) {
            E(), B && B.then((e1)=>{
                e1.keys().then((r)=>{
                    for(let n = 0; n < r.length - t1; n++)e1.delete(r[n]);
                });
            });
        }, t1.equals = function(t1, e1) {
            var r = t1[0], n = t1[1], i = t1[2], a = t1[3], s = t1[4], o = t1[5], l = t1[6], u = t1[7], c = t1[8], h = t1[9], p = t1[10], f = t1[11], d = t1[12], y = t1[13], m = t1[14], g = t1[15], x = e1[0], v = e1[1], b = e1[2], w = e1[3], _ = e1[4], A = e1[5], k = e1[6], S = e1[7], I = e1[8], M = e1[9], z = e1[10], B = e1[11], C = e1[12], P = e1[13], V = e1[14], E = e1[15];
            return Math.abs(r - x) <= hs * Math.max(1, Math.abs(r), Math.abs(x)) && Math.abs(n - v) <= hs * Math.max(1, Math.abs(n), Math.abs(v)) && Math.abs(i - b) <= hs * Math.max(1, Math.abs(i), Math.abs(b)) && Math.abs(a - w) <= hs * Math.max(1, Math.abs(a), Math.abs(w)) && Math.abs(s - _) <= hs * Math.max(1, Math.abs(s), Math.abs(_)) && Math.abs(o - A) <= hs * Math.max(1, Math.abs(o), Math.abs(A)) && Math.abs(l - k) <= hs * Math.max(1, Math.abs(l), Math.abs(k)) && Math.abs(u - S) <= hs * Math.max(1, Math.abs(u), Math.abs(S)) && Math.abs(c - I) <= hs * Math.max(1, Math.abs(c), Math.abs(I)) && Math.abs(h - M) <= hs * Math.max(1, Math.abs(h), Math.abs(M)) && Math.abs(p - z) <= hs * Math.max(1, Math.abs(p), Math.abs(z)) && Math.abs(f - B) <= hs * Math.max(1, Math.abs(f), Math.abs(B)) && Math.abs(d - C) <= hs * Math.max(1, Math.abs(d), Math.abs(C)) && Math.abs(y - P) <= hs * Math.max(1, Math.abs(y), Math.abs(P)) && Math.abs(m - V) <= hs * Math.max(1, Math.abs(m), Math.abs(V)) && Math.abs(g - E) <= hs * Math.max(1, Math.abs(g), Math.abs(E));
        }, t1.evaluateSizeForFeature = function(t1, { uSize: e1 , uSizeT: r  }, { lowerSize: n , upperSize: i  }) {
            return "source" === t1.kind ? n / tu : "composite" === t1.kind ? Se(n / tu, i / tu, r) : e1;
        }, t1.evaluateSizeForZoom = function(t1, e1) {
            let r = 0, n = 0;
            if ("constant" === t1.kind) n = t1.layoutSize;
            else if ("source" !== t1.kind) {
                const { interpolationType: i , minZoom: s , maxZoom: o  } = t1, l = i ? a(Ne.interpolationFactor(i, e1, s, o), 0, 1) : 0;
                "camera" === t1.kind ? n = Se(t1.minSize, t1.maxSize, l) : r = l;
            }
            return {
                uSizeT: r,
                uSize: n
            };
        }, t1.evaluateVariableOffset = Au, t1.evented = Xn, t1.exported = k, t1.exported$1 = T, t1.extend = o, t1.filterObject = h, t1.fromRotation = function(t1, e1) {
            var r = Math.sin(e1), n = Math.cos(e1);
            return t1[0] = n, t1[1] = r, t1[2] = 0, t1[3] = -r, t1[4] = n, t1[5] = 0, t1[6] = 0, t1[7] = 0, t1[8] = 1, t1;
        }, t1.fromScaling = function(t1, e1) {
            return t1[0] = e1[0], t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[5] = e1[1], t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[10] = e1[2], t1[11] = 0, t1[12] = 0, t1[13] = 0, t1[14] = 0, t1[15] = 1, t1;
        }, t1.getAnchorAlignment = Yl, t1.getAnchorJustification = ku, t1.getArrayBuffer = K, t1.getImage = H, t1.getJSON = function(t1, e1) {
            return Z(o(t1, {
                type: "json"
            }), e1);
        }, t1.getOverlapMode = qu, t1.getRTLTextPluginStatus = Yn, t1.getReferrer = j, t1.getVideo = function(t1, e1) {
            const r = window.document.createElement("video");
            r.muted = !0, r.onloadstart = function() {
                e1(null, r);
            };
            for(let e2 = 0; e2 < t1.length; e2++){
                const n = window.document.createElement("source");
                G(t1[e2]) || (r.crossOrigin = "Anonymous"), n.src = t1[e2], r.appendChild(n);
            }
            return {
                cancel: ()=>{}
            };
        }, t1.identity = ds, t1.invert = function(t1, e1) {
            var r = e1[0], n = e1[1], i = e1[2], a = e1[3], s = e1[4], o = e1[5], l = e1[6], u = e1[7], c = e1[8], h = e1[9], p = e1[10], f = e1[11], d = e1[12], y = e1[13], m = e1[14], g = e1[15], x = r * o - n * s, v = r * l - i * s, b = r * u - a * s, w = n * l - i * o, _ = n * u - a * o, A = i * u - a * l, k = c * y - h * d, S = c * m - p * d, I = c * g - f * d, M = h * m - p * y, z = h * g - f * y, B = p * g - f * m, C = x * B - v * z + b * M + w * I - _ * S + A * k;
            return C ? (t1[0] = (o * B - l * z + u * M) * (C = 1 / C), t1[1] = (i * z - n * B - a * M) * C, t1[2] = (y * A - m * _ + g * w) * C, t1[3] = (p * _ - h * A - f * w) * C, t1[4] = (l * I - s * B - u * S) * C, t1[5] = (r * B - i * I + a * S) * C, t1[6] = (m * b - d * A - g * v) * C, t1[7] = (c * A - p * b + f * v) * C, t1[8] = (s * z - o * I + u * k) * C, t1[9] = (n * I - r * z - a * k) * C, t1[10] = (d * _ - y * b + g * x) * C, t1[11] = (h * b - c * _ - f * x) * C, t1[12] = (o * S - s * M - l * k) * C, t1[13] = (r * M - n * S + i * k) * C, t1[14] = (y * v - d * w - m * x) * C, t1[15] = (c * w - h * v + p * x) * C, t1) : null;
        }, t1.isImageBitmap = A, t1.isSafari = _, t1.isWorker = g, t1.keysDifference = function(t1, e1) {
            const r = [];
            for(const n in t1)n in e1 || r.push(n);
            return r;
        }, t1.lazyLoadRTLTextPlugin = function() {
            Wn.isLoading() || Wn.isLoaded() || "deferred" !== Yn() || Hn();
        }, t1.makeRequest = Z, t1.mapObject = c, t1.mercatorXfromLng = Qu, t1.mercatorYfromLat = tc, t1.mercatorZfromAltitude = ec, t1.mul = gs, t1.mul$1 = function(t1, e1, r) {
            return t1[0] = e1[0] * r[0], t1[1] = e1[1] * r[1], t1[2] = e1[2] * r[2], t1[3] = e1[3] * r[3], t1;
        }, t1.multiply = ys, t1.nextPowerOfTwo = function(t1) {
            return t1 <= 1 ? 1 : Math.pow(2, Math.ceil(Math.log(t1) / Math.LN2));
        }, t1.normalize = function(t1, e1) {
            var r = e1[0], n = e1[1], i = e1[2], a = r * r + n * n + i * i;
            return a > 0 && (a = 1 / Math.sqrt(a)), t1[0] = e1[0] * a, t1[1] = e1[1] * a, t1[2] = e1[2] * a, t1;
        }, t1.number = Se, t1.ortho = function(t1, e1, r, n, i, a, s) {
            var o = 1 / (e1 - r), l = 1 / (n - i), u = 1 / (a - s);
            return t1[0] = -2 * o, t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[5] = -2 * l, t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[10] = 2 * u, t1[11] = 0, t1[12] = (e1 + r) * o, t1[13] = (i + n) * l, t1[14] = (s + a) * u, t1[15] = 1, t1;
        }, t1.parseCacheControl = x, t1.parseGlyphPbf = function(t1) {
            return new ul(t1).readFields(Vl, []);
        }, t1.pbf = ul, t1.performSymbolLayout = function(e1) {
            e1.bucket.createArrays(), e1.bucket.tilePixelRatio = qa / (512 * e1.bucket.overscaling), e1.bucket.compareText = {}, e1.bucket.iconsNeedLinear = !1;
            const r = e1.bucket.layers[0].layout, n = e1.bucket.layers[0]._unevaluatedLayout._values, i = {
                layoutIconSize: n["icon-size"].possiblyEvaluate(new Qn(e1.bucket.zoom + 1), e1.canonical),
                layoutTextSize: n["text-size"].possiblyEvaluate(new Qn(e1.bucket.zoom + 1), e1.canonical),
                textMaxSize: n["text-size"].possiblyEvaluate(new Qn(18))
            };
            if ("composite" === e1.bucket.textSizeData.kind) {
                const { minZoom: t2 , maxZoom: r1  } = e1.bucket.textSizeData;
                i.compositeTextSizes = [
                    n["text-size"].possiblyEvaluate(new Qn(t2), e1.canonical),
                    n["text-size"].possiblyEvaluate(new Qn(r1), e1.canonical)
                ];
            }
            if ("composite" === e1.bucket.iconSizeData.kind) {
                const { minZoom: t3 , maxZoom: r2  } = e1.bucket.iconSizeData;
                i.compositeIconSizes = [
                    n["icon-size"].possiblyEvaluate(new Qn(t3), e1.canonical),
                    n["icon-size"].possiblyEvaluate(new Qn(r2), e1.canonical)
                ];
            }
            const a = r.get("text-line-height") * ll, s = "viewport" !== r.get("text-rotation-alignment") && "point" !== r.get("symbol-placement"), o = r.get("text-keep-upright"), l = r.get("text-size");
            for (const n1 of e1.bucket.features){
                const u = r.get("text-font").evaluate(n1, {}, e1.canonical).join(","), c = l.evaluate(n1, {}, e1.canonical), h = i.layoutTextSize.evaluate(n1, {}, e1.canonical), p = i.layoutIconSize.evaluate(n1, {}, e1.canonical), f = {
                    horizontal: {},
                    vertical: void 0
                }, y = n1.text;
                let m, g = [
                    0,
                    0
                ];
                if (y) {
                    const i1 = y.toString(), l1 = r.get("text-letter-spacing").evaluate(n1, {}, e1.canonical) * ll, p1 = Fn(i1) ? l1 : 0, d1 = r.get("text-anchor").evaluate(n1, {}, e1.canonical), m1 = r.get("text-variable-anchor");
                    if (!m1) {
                        const t4 = r.get("text-radial-offset").evaluate(n1, {}, e1.canonical);
                        g = t4 ? Au(d1, [
                            t4 * ll,
                            _u
                        ]) : r.get("text-offset").evaluate(n1, {}, e1.canonical).map((t1)=>t1 * ll);
                    }
                    let x = s ? "center" : r.get("text-justify").evaluate(n1, {}, e1.canonical);
                    const v = r.get("symbol-placement"), b = "point" === v ? r.get("text-max-width").evaluate(n1, {}, e1.canonical) * ll : 0, w = ()=>{
                        e1.bucket.allowVerticalPlacement && En(i1) && (f.vertical = Ul(y, e1.glyphMap, e1.glyphPositions, e1.imagePositions, u, b, a, d1, "left", p1, g, t1.WritingMode.vertical, !0, v, h, c));
                    };
                    if (!s && m1) {
                        const r3 = "auto" === x ? m1.map((t1)=>ku(t1)) : [
                            x
                        ];
                        let n2 = !1;
                        for(let i2 = 0; i2 < r3.length; i2++){
                            const s1 = r3[i2];
                            if (!f.horizontal[s1]) {
                                if (n2) f.horizontal[s1] = f.horizontal[0];
                                else {
                                    const r4 = Ul(y, e1.glyphMap, e1.glyphPositions, e1.imagePositions, u, b, a, "center", s1, p1, g, t1.WritingMode.horizontal, !1, v, h, c);
                                    r4 && (f.horizontal[s1] = r4, n2 = 1 === r4.positionedLines.length);
                                }
                            }
                        }
                        w();
                    } else {
                        "auto" === x && (x = ku(d1));
                        const r5 = Ul(y, e1.glyphMap, e1.glyphPositions, e1.imagePositions, u, b, a, d1, x, p1, g, t1.WritingMode.horizontal, !1, v, h, c);
                        r5 && (f.horizontal[x] = r5), w(), En(i1) && s && o && (f.vertical = Ul(y, e1.glyphMap, e1.glyphPositions, e1.imagePositions, u, b, a, d1, x, p1, g, t1.WritingMode.vertical, !1, v, h, c));
                    }
                }
                let x1 = !1;
                if (n1.icon && n1.icon.name) {
                    const t5 = e1.imageMap[n1.icon.name];
                    t5 && (m = Wl(e1.imagePositions[n1.icon.name], r.get("icon-offset").evaluate(n1, {}, e1.canonical), r.get("icon-anchor").evaluate(n1, {}, e1.canonical)), x1 = !!t5.sdf, void 0 === e1.bucket.sdfIcons ? e1.bucket.sdfIcons = x1 : e1.bucket.sdfIcons !== x1 && d("Style sheet warning: Cannot mix SDF and non-SDF icons in one buffer"), (t5.pixelRatio !== e1.bucket.pixelRatio || 0 !== r.get("icon-rotate").constantOr(1)) && (e1.bucket.iconsNeedLinear = !0));
                }
                const v1 = zu(f.horizontal) || f.vertical;
                e1.bucket.iconsInText = !!v1 && v1.iconsInText, (v1 || m) && Su(e1.bucket, n1, f, m, e1.imageMap, i, h, p, g, x1, e1.canonical);
            }
            e1.showCollisionBoxes && e1.bucket.generateCollisionDebugBuffers();
        }, t1.perspective = function(t1, e1, r, n, i) {
            var a, s = 1 / Math.tan(e1 / 2);
            return t1[0] = s / r, t1[1] = 0, t1[2] = 0, t1[3] = 0, t1[4] = 0, t1[5] = s, t1[6] = 0, t1[7] = 0, t1[8] = 0, t1[9] = 0, t1[11] = -1, t1[12] = 0, t1[13] = 0, t1[15] = 0, null != i && i !== 1 / 0 ? (t1[10] = (i + n) * (a = 1 / (n - i)), t1[14] = 2 * i * n * a) : (t1[10] = -1, t1[14] = -2 * n), t1;
        }, t1.pick = function(t1, e1) {
            const r = {};
            for(let n = 0; n < e1.length; n++){
                const i = e1[n];
                i in t1 && (r[i] = t1[i]);
            }
            return r;
        }, t1.plugin = Wn, t1.pointGeometry = S, t1.polygonIntersectsPolygon = Xa, t1.potpack = Tl, t1.refProperties = [
            "type",
            "source",
            "source-layer",
            "minzoom",
            "maxzoom",
            "filter",
            "layout"
        ], t1.register = Mn, t1.registerForPluginStateChange = function(t1) {
            return t1({
                pluginStatus: Zn,
                pluginURL: Kn
            }), Xn.on("pluginStateChange", t1), t1;
        }, t1.renderColorRamp = Cs, t1.rotateX = function(t1, e1, r) {
            var n = Math.sin(r), i = Math.cos(r), a = e1[4], s = e1[5], o = e1[6], l = e1[7], u = e1[8], c = e1[9], h = e1[10], p = e1[11];
            return e1 !== t1 && (t1[0] = e1[0], t1[1] = e1[1], t1[2] = e1[2], t1[3] = e1[3], t1[12] = e1[12], t1[13] = e1[13], t1[14] = e1[14], t1[15] = e1[15]), t1[4] = a * i + u * n, t1[5] = s * i + c * n, t1[6] = o * i + h * n, t1[7] = l * i + p * n, t1[8] = u * i - a * n, t1[9] = c * i - s * n, t1[10] = h * i - o * n, t1[11] = p * i - l * n, t1;
        }, t1.rotateZ = function(t1, e1, r) {
            var n = Math.sin(r), i = Math.cos(r), a = e1[0], s = e1[1], o = e1[2], l = e1[3], u = e1[4], c = e1[5], h = e1[6], p = e1[7];
            return e1 !== t1 && (t1[8] = e1[8], t1[9] = e1[9], t1[10] = e1[10], t1[11] = e1[11], t1[12] = e1[12], t1[13] = e1[13], t1[14] = e1[14], t1[15] = e1[15]), t1[0] = a * i + u * n, t1[1] = s * i + c * n, t1[2] = o * i + h * n, t1[3] = l * i + p * n, t1[4] = u * i - a * n, t1[5] = c * i - s * n, t1[6] = h * i - o * n, t1[7] = p * i - l * n, t1;
        }, t1.scale = function(t1, e1, r) {
            var n = r[0], i = r[1], a = r[2];
            return t1[0] = e1[0] * n, t1[1] = e1[1] * n, t1[2] = e1[2] * n, t1[3] = e1[3] * n, t1[4] = e1[4] * i, t1[5] = e1[5] * i, t1[6] = e1[6] * i, t1[7] = e1[7] * i, t1[8] = e1[8] * a, t1[9] = e1[9] * a, t1[10] = e1[10] * a, t1[11] = e1[11] * a, t1[12] = e1[12], t1[13] = e1[13], t1[14] = e1[14], t1[15] = e1[15], t1;
        }, t1.scale$1 = function(t1, e1, r) {
            return t1[0] = e1[0] * r, t1[1] = e1[1] * r, t1[2] = e1[2] * r, t1;
        }, t1.setCacheLimits = function(t1, e1) {
            P = t1, V = e1;
        }, t1.setRTLTextPlugin = function(t1, e1, r = !1) {
            if (Zn === Un || Zn === qn || Zn === jn) throw new Error("setRTLTextPlugin cannot be called multiple times.");
            Kn = k.resolveURL(t1), Zn = Un, Nn = e1, Jn(), r || Hn();
        }, t1.spec = nt, t1.sphericalToCartesian = function([t1, e1, r]) {
            return e1 += 90, e1 *= Math.PI / 180, r *= Math.PI / 180, {
                x: t1 * Math.cos(e1) * Math.sin(r),
                y: t1 * Math.sin(e1) * Math.sin(r),
                z: t1 * Math.cos(r)
            };
        }, t1.sqrLen = function(t1) {
            var e1 = t1[0], r = t1[1];
            return e1 * e1 + r * r;
        }, t1.sub = function(t1, e1, r) {
            return t1[0] = e1[0] - r[0], t1[1] = e1[1] - r[1], t1[2] = e1[2] - r[2], t1;
        }, t1.toEvaluationFeature = Ka, t1.transformMat3 = function(t1, e1, r) {
            var n = e1[0], i = e1[1], a = e1[2];
            return t1[0] = n * r[0] + i * r[3] + a * r[6], t1[1] = n * r[1] + i * r[4] + a * r[7], t1[2] = n * r[2] + i * r[5] + a * r[8], t1;
        }, t1.transformMat4 = bs, t1.transformMat4$1 = function(t1, e1, r) {
            var n = e1[0], i = e1[1];
            return t1[0] = r[0] * n + r[4] * i + r[12], t1[1] = r[1] * n + r[5] * i + r[13], t1;
        }, t1.translate = function(t1, e1, r) {
            var n, i, a, s, o, l, u, c, h, p, f, d, y = r[0], m = r[1], g = r[2];
            return e1 === t1 ? (t1[12] = e1[0] * y + e1[4] * m + e1[8] * g + e1[12], t1[13] = e1[1] * y + e1[5] * m + e1[9] * g + e1[13], t1[14] = e1[2] * y + e1[6] * m + e1[10] * g + e1[14], t1[15] = e1[3] * y + e1[7] * m + e1[11] * g + e1[15]) : (i = e1[1], a = e1[2], s = e1[3], o = e1[4], l = e1[5], u = e1[6], c = e1[7], h = e1[8], p = e1[9], f = e1[10], d = e1[11], t1[0] = n = e1[0], t1[1] = i, t1[2] = a, t1[3] = s, t1[4] = o, t1[5] = l, t1[6] = u, t1[7] = c, t1[8] = h, t1[9] = p, t1[10] = f, t1[11] = d, t1[12] = n * y + o * m + h * g + e1[12], t1[13] = i * y + l * m + p * g + e1[13], t1[14] = a * y + u * m + f * g + e1[14], t1[15] = s * y + c * m + d * g + e1[15]), t1;
        }, t1.triggerPluginCompletionEvent = Gn, t1.unicodeBlockLookup = Vn, t1.uniqueId = function() {
            return l++;
        }, t1.validateCustomStyleLayer = function(t1) {
            const e1 = [], r = t1.id;
            return void 0 === r && e1.push({
                message: `layers.${r}: missing required property "id"`
            }), void 0 === t1.render && e1.push({
                message: `layers.${r}: missing required method "render"`
            }), t1.renderingMode && "2d" !== t1.renderingMode && "3d" !== t1.renderingMode && e1.push({
                message: `layers.${r}: property "renderingMode" must be either "2d" or "3d"`
            }), e1;
        }, t1.validateLight = wn, t1.validateStyle = bn, t1.vectorTile = _o, t1.warnOnce = d, t1.wrap = s;
    });
    define([
        "./shared"
    ], function(e1) {
        "use strict";
        function t1(e1) {
            const o = typeof e1;
            if ("number" === o || "boolean" === o || "string" === o || null == e1) return JSON.stringify(e1);
            if (Array.isArray(e1)) {
                let o1 = "[";
                for (const i of e1)o1 += `${t1(i)},`;
                return `${o1}]`;
            }
            const i1 = Object.keys(e1).sort();
            let r = "{";
            for(let o2 = 0; o2 < i1.length; o2++)r += `${JSON.stringify(i1[o2])}:${t1(e1[i1[o2]])},`;
            return `${r}}`;
        }
        function o(o) {
            let i = "";
            for (const r of e1.refProperties)i += `/${t1(o[r])}`;
            return i;
        }
        class i {
            constructor(e1){
                this.keyCache = {}, e1 && this.replace(e1);
            }
            replace(e1) {
                this._layerConfigs = {}, this._layers = {}, this.update(e1, []);
            }
            update(t1, i) {
                for (const o1 of t1){
                    this._layerConfigs[o1.id] = o1;
                    const t2 = this._layers[o1.id] = e1.createStyleLayer(o1);
                    t2._featureFilter = e1.createFilter(t2.filter), this.keyCache[o1.id] && delete this.keyCache[o1.id];
                }
                for (const e2 of i)delete this.keyCache[e2], delete this._layerConfigs[e2], delete this._layers[e2];
                this.familiesBySource = {};
                const r = function(e1, t1) {
                    const i = {};
                    for(let r = 0; r < e1.length; r++){
                        const n = t1 && t1[e1[r].id] || o(e1[r]);
                        t1 && (t1[e1[r].id] = n);
                        let s = i[n];
                        s || (s = i[n] = []), s.push(e1[r]);
                    }
                    const r1 = [];
                    for(const e2 in i)r1.push(i[e2]);
                    return r1;
                }(Object.values(this._layerConfigs), this.keyCache);
                for (const e3 of r){
                    const t3 = e3.map((e1)=>this._layers[e1.id]), o2 = t3[0];
                    if ("none" === o2.visibility) continue;
                    const i1 = o2.source || "";
                    let r1 = this.familiesBySource[i1];
                    r1 || (r1 = this.familiesBySource[i1] = {});
                    const n = o2.sourceLayer || "_geojsonTileLayer";
                    let s = r1[n];
                    s || (s = r1[n] = []), s.push(t3);
                }
            }
        }
        class r {
            constructor(t1){
                const o = {}, i = [];
                for(const e2 in t1){
                    const r = t1[e2], n = o[e2] = {};
                    for(const e3 in r){
                        const t2 = r[+e3];
                        if (!t2 || 0 === t2.bitmap.width || 0 === t2.bitmap.height) continue;
                        const o1 = {
                            x: 0,
                            y: 0,
                            w: t2.bitmap.width + 2,
                            h: t2.bitmap.height + 2
                        };
                        i.push(o1), n[e3] = {
                            rect: o1,
                            metrics: t2.metrics
                        };
                    }
                }
                const { w: r1 , h: n1  } = e1.potpack(i), s = new e1.AlphaImage({
                    width: r1 || 1,
                    height: n1 || 1
                });
                for(const i1 in t1){
                    const r2 = t1[i1];
                    for(const t3 in r2){
                        const n2 = r2[+t3];
                        if (!n2 || 0 === n2.bitmap.width || 0 === n2.bitmap.height) continue;
                        const a = o[i1][t3].rect;
                        e1.AlphaImage.copy(n2.bitmap, s, {
                            x: 0,
                            y: 0
                        }, {
                            x: a.x + 1,
                            y: a.y + 1
                        }, n2.bitmap);
                    }
                }
                this.image = s, this.positions = o;
            }
        }
        e1.register("GlyphAtlas", r);
        class n {
            constructor(t1){
                this.tileID = new e1.OverscaledTileID(t1.tileID.overscaledZ, t1.tileID.wrap, t1.tileID.canonical.z, t1.tileID.canonical.x, t1.tileID.canonical.y), this.uid = t1.uid, this.zoom = t1.zoom, this.pixelRatio = t1.pixelRatio, this.tileSize = t1.tileSize, this.source = t1.source, this.overscaling = this.tileID.overscaleFactor(), this.showCollisionBoxes = t1.showCollisionBoxes, this.collectResourceTiming = !!t1.collectResourceTiming, this.returnDependencies = !!t1.returnDependencies, this.promoteId = t1.promoteId;
            }
            parse(t1, o, i, n, a) {
                this.status = "parsing", this.data = t1, this.collisionBoxArray = new e1.CollisionBoxArray;
                const l = new e1.DictionaryCoder(Object.keys(t1.layers).sort()), c = new e1.FeatureIndex(this.tileID, this.promoteId);
                c.bucketLayerIDs = [];
                const u = {}, h = {
                    featureIndex: c,
                    iconDependencies: {},
                    patternDependencies: {},
                    glyphDependencies: {},
                    availableImages: i
                }, p = o.familiesBySource[this.source];
                for(const o1 in p){
                    const r1 = t1.layers[o1];
                    if (!r1) continue;
                    1 === r1.version && e1.warnOnce(`Vector tile source "${this.source}" layer "${o1}" does not use vector tile spec v2 and therefore may have some rendering errors.`);
                    const n1 = l.encode(o1), a1 = [];
                    for(let e2 = 0; e2 < r1.length; e2++){
                        const t2 = r1.feature(e2), i1 = c.getId(t2, o1);
                        a1.push({
                            feature: t2,
                            id: i1,
                            index: e2,
                            sourceLayerIndex: n1
                        });
                    }
                    for (const t3 of p[o1]){
                        const o2 = t3[0];
                        o2.source !== this.source && e1.warnOnce(`layer.source = ${o2.source} does not equal this.source = ${this.source}`), o2.minzoom && this.zoom < Math.floor(o2.minzoom) || o2.maxzoom && this.zoom >= o2.maxzoom || "none" !== o2.visibility && (s(t3, this.zoom, i), (u[o2.id] = o2.createBucket({
                            index: c.bucketLayerIDs.length,
                            layers: t3,
                            zoom: this.zoom,
                            pixelRatio: this.pixelRatio,
                            overscaling: this.overscaling,
                            collisionBoxArray: this.collisionBoxArray,
                            sourceLayerIndex: n1,
                            sourceID: this.source
                        })).populate(a1, h, this.tileID.canonical), c.bucketLayerIDs.push(t3.map((e1)=>e1.id)));
                    }
                }
                let f, d, g, m;
                const y = e1.mapObject(h.glyphDependencies, (e1)=>Object.keys(e1).map(Number));
                Object.keys(y).length ? n.send("getGlyphs", {
                    uid: this.uid,
                    stacks: y
                }, (e1, t1)=>{
                    f || (f = e1, d = t1, w.call(this));
                }) : d = {};
                const v = Object.keys(h.iconDependencies);
                v.length ? n.send("getImages", {
                    icons: v,
                    source: this.source,
                    tileID: this.tileID,
                    type: "icons"
                }, (e1, t1)=>{
                    f || (f = e1, g = t1, w.call(this));
                }) : g = {};
                const x = Object.keys(h.patternDependencies);
                function w() {
                    if (f) return a(f);
                    if (d && g && m) {
                        const t1 = new r(d), o = new e1.ImageAtlas(g, m);
                        for(const r1 in u){
                            const n = u[r1];
                            n instanceof e1.SymbolBucket ? (s(n.layers, this.zoom, i), e1.performSymbolLayout({
                                bucket: n,
                                glyphMap: d,
                                glyphPositions: t1.positions,
                                imageMap: g,
                                imagePositions: o.iconPositions,
                                showCollisionBoxes: this.showCollisionBoxes,
                                canonical: this.tileID.canonical
                            })) : n.hasPattern && (n instanceof e1.LineBucket || n instanceof e1.FillBucket || n instanceof e1.FillExtrusionBucket) && (s(n.layers, this.zoom, i), n.addFeatures(h, this.tileID.canonical, o.patternPositions));
                        }
                        this.status = "done", a(null, {
                            buckets: Object.values(u).filter((e1)=>!e1.isEmpty()),
                            featureIndex: c,
                            collisionBoxArray: this.collisionBoxArray,
                            glyphAtlasImage: t1.image,
                            imageAtlas: o,
                            glyphMap: this.returnDependencies ? d : null,
                            iconMap: this.returnDependencies ? g : null,
                            glyphPositions: this.returnDependencies ? t1.positions : null
                        });
                    }
                }
                x.length ? n.send("getImages", {
                    icons: x,
                    source: this.source,
                    tileID: this.tileID,
                    type: "patterns"
                }, (e1, t1)=>{
                    f || (f = e1, m = t1, w.call(this));
                }) : m = {}, w.call(this);
            }
        }
        function s(t1, o, i) {
            const r = new e1.EvaluationParameters(o);
            for (const e2 of t1)e2.recalculate(r, i);
        }
        function a(t1, o) {
            const i = e1.getArrayBuffer(t1.request, (t1, i, r, n)=>{
                t1 ? o(t1) : i && o(null, {
                    vectorTile: new e1.vectorTile.VectorTile(new e1.pbf(i)),
                    rawData: i,
                    cacheControl: r,
                    expires: n
                });
            });
            return ()=>{
                i.cancel(), o();
            };
        }
        class l {
            constructor(e1, t1, o, i){
                this.actor = e1, this.layerIndex = t1, this.availableImages = o, this.loadVectorData = i || a, this.loading = {}, this.loaded = {};
            }
            loadTile(t1, o) {
                const i = t1.uid;
                this.loading || (this.loading = {});
                const r = !!(t1 && t1.request && t1.request.collectResourceTiming) && new e1.RequestPerformance(t1.request), s = this.loading[i] = new n(t1);
                s.abort = this.loadVectorData(t1, (t1, n)=>{
                    if (delete this.loading[i], t1 || !n) return s.status = "done", this.loaded[i] = s, o(t1);
                    const a = n.rawData, l = {};
                    n.expires && (l.expires = n.expires), n.cacheControl && (l.cacheControl = n.cacheControl);
                    const c = {};
                    if (r) {
                        const e2 = r.finish();
                        e2 && (c.resourceTiming = JSON.parse(JSON.stringify(e2)));
                    }
                    s.vectorTile = n.vectorTile, s.parse(n.vectorTile, this.layerIndex, this.availableImages, this.actor, (t1, i)=>{
                        if (t1 || !i) return o(t1);
                        o(null, e1.extend({
                            rawTileData: a.slice(0)
                        }, i, l, c));
                    }), this.loaded = this.loaded || {}, this.loaded[i] = s;
                });
            }
            reloadTile(e1, t1) {
                const o = this.loaded, i = e1.uid, r = this;
                if (o && o[i]) {
                    const n = o[i];
                    n.showCollisionBoxes = e1.showCollisionBoxes;
                    const s = (e1, o)=>{
                        const i = n.reloadCallback;
                        i && (delete n.reloadCallback, n.parse(n.vectorTile, r.layerIndex, this.availableImages, r.actor, i)), t1(e1, o);
                    };
                    "parsing" === n.status ? n.reloadCallback = s : "done" === n.status && (n.vectorTile ? n.parse(n.vectorTile, this.layerIndex, this.availableImages, this.actor, s) : s());
                }
            }
            abortTile(e1, t1) {
                const o = this.loading, i = e1.uid;
                o && o[i] && o[i].abort && (o[i].abort(), delete o[i]), t1();
            }
            removeTile(e1, t1) {
                const o = this.loaded, i = e1.uid;
                o && o[i] && delete o[i], t1();
            }
        }
        class c {
            constructor(){
                this.loaded = {};
            }
            loadTile(t1, o) {
                const { uid: i , encoding: r , rawImageData: n  } = t1, s = e1.isImageBitmap(n) ? this.getImageData(n) : n, a = new e1.DEMData(i, s, r);
                this.loaded = this.loaded || {}, this.loaded[i] = a, o(null, a);
            }
            getImageData(t1) {
                this.offscreenCanvas && this.offscreenCanvasContext || (this.offscreenCanvas = new OffscreenCanvas(t1.width, t1.height), this.offscreenCanvasContext = this.offscreenCanvas.getContext("2d")), this.offscreenCanvas.width = t1.width, this.offscreenCanvas.height = t1.height, this.offscreenCanvasContext.drawImage(t1, 0, 0, t1.width, t1.height);
                const o = this.offscreenCanvasContext.getImageData(-1, -1, t1.width + 2, t1.height + 2);
                return this.offscreenCanvasContext.clearRect(0, 0, this.offscreenCanvas.width, this.offscreenCanvas.height), new e1.RGBAImage({
                    width: o.width,
                    height: o.height
                }, o.data);
            }
            removeTile(e1) {
                const t1 = this.loaded, o = e1.uid;
                t1 && t1[o] && delete t1[o];
            }
        }
        var u = function e1(t1, o) {
            var i, r = t1 && t1.type;
            if ("FeatureCollection" === r) for(i = 0; i < t1.features.length; i++)e1(t1.features[i], o);
            else if ("GeometryCollection" === r) for(i = 0; i < t1.geometries.length; i++)e1(t1.geometries[i], o);
            else if ("Feature" === r) e1(t1.geometry, o);
            else if ("Polygon" === r) h(t1.coordinates, o);
            else if ("MultiPolygon" === r) for(i = 0; i < t1.coordinates.length; i++)h(t1.coordinates[i], o);
            return t1;
        };
        function h(e1, t1) {
            if (0 !== e1.length) {
                p(e1[0], t1);
                for(var o = 1; o < e1.length; o++)p(e1[o], !t1);
            }
        }
        function p(e1, t1) {
            for(var o = 0, i = 0, r = 0, n = e1.length, s = n - 1; r < n; s = r++){
                var a = (e1[r][0] - e1[s][0]) * (e1[s][1] + e1[r][1]), l = o + a;
                i += Math.abs(o) >= Math.abs(a) ? o - l + a : a - l + o, o = l;
            }
            o + i >= 0 != !!t1 && e1.reverse();
        }
        const f = e1.vectorTile.VectorTileFeature.prototype.toGeoJSON;
        class d {
            constructor(t1){
                this._feature = t1, this.extent = e1.EXTENT, this.type = t1.type, this.properties = t1.tags, "id" in t1 && !isNaN(t1.id) && (this.id = parseInt(t1.id, 10));
            }
            loadGeometry() {
                if (1 === this._feature.type) {
                    const t1 = [];
                    for (const o of this._feature.geometry)t1.push([
                        new e1.pointGeometry(o[0], o[1])
                    ]);
                    return t1;
                }
                {
                    const t2 = [];
                    for (const o1 of this._feature.geometry){
                        const i = [];
                        for (const t3 of o1)i.push(new e1.pointGeometry(t3[0], t3[1]));
                        t2.push(i);
                    }
                    return t2;
                }
            }
            toGeoJSON(e1, t1, o) {
                return f.call(this, e1, t1, o);
            }
        }
        class g {
            constructor(t1){
                this.layers = {
                    _geojsonTileLayer: this
                }, this.name = "_geojsonTileLayer", this.extent = e1.EXTENT, this.length = t1.length, this._features = t1;
            }
            feature(e1) {
                return new d(this._features[e1]);
            }
        }
        var m = {
            exports: {}
        }, y = e1.pointGeometry, v = e1.vectorTile.VectorTileFeature, x = w;
        function w(e1, t1) {
            this.options = t1 || {}, this.features = e1, this.length = e1.length;
        }
        function S(e1, t1) {
            this.id = "number" == typeof e1.id ? e1.id : void 0, this.type = e1.type, this.rawGeometry = 1 === e1.type ? [
                e1.geometry
            ] : e1.geometry, this.properties = e1.tags, this.extent = t1 || 4096;
        }
        w.prototype.feature = function(e1) {
            return new S(this.features[e1], this.options.extent);
        }, S.prototype.loadGeometry = function() {
            var e1 = this.rawGeometry;
            this.geometry = [];
            for(var t1 = 0; t1 < e1.length; t1++){
                for(var o = e1[t1], i = [], r = 0; r < o.length; r++)i.push(new y(o[r][0], o[r][1]));
                this.geometry.push(i);
            }
            return this.geometry;
        }, S.prototype.bbox = function() {
            this.geometry || this.loadGeometry();
            for(var e1 = this.geometry, t1 = 1 / 0, o = -1 / 0, i = 1 / 0, r = -1 / 0, n = 0; n < e1.length; n++)for(var s = e1[n], a = 0; a < s.length; a++){
                var l = s[a];
                t1 = Math.min(t1, l.x), o = Math.max(o, l.x), i = Math.min(i, l.y), r = Math.max(r, l.y);
            }
            return [
                t1,
                i,
                o,
                r
            ];
        }, S.prototype.toGeoJSON = v.prototype.toGeoJSON;
        var M = e1.pbf, I = x;
        function b(e1) {
            var t1 = new M;
            return function(e1, t1) {
                for(var o in e1.layers)t1.writeMessage(3, k, e1.layers[o]);
            }(e1, t1), t1.finish();
        }
        function k(e1, t1) {
            var o;
            t1.writeVarintField(15, e1.version || 1), t1.writeStringField(1, e1.name || ""), t1.writeVarintField(5, e1.extent || 4096);
            var i = {
                keys: [],
                values: [],
                keycache: {},
                valuecache: {}
            };
            for(o = 0; o < e1.length; o++)i.feature = e1.feature(o), t1.writeMessage(2, P, i);
            var r = i.keys;
            for(o = 0; o < r.length; o++)t1.writeStringField(3, r[o]);
            var n = i.values;
            for(o = 0; o < n.length; o++)t1.writeMessage(4, L, n[o]);
        }
        function P(e1, t1) {
            var o = e1.feature;
            void 0 !== o.id && t1.writeVarintField(1, o.id), t1.writeMessage(2, T, e1), t1.writeVarintField(3, o.type), t1.writeMessage(4, D, o);
        }
        function T(e1, t1) {
            var o = e1.feature, i = e1.keys, r = e1.values, n = e1.keycache, s = e1.valuecache;
            for(var a in o.properties){
                var l = o.properties[a], c = n[a];
                if (null !== l) {
                    void 0 === c && (i.push(a), n[a] = c = i.length - 1), t1.writeVarint(c);
                    var u = typeof l;
                    "string" !== u && "boolean" !== u && "number" !== u && (l = JSON.stringify(l));
                    var h = u + ":" + l, p = s[h];
                    void 0 === p && (r.push(l), s[h] = p = r.length - 1), t1.writeVarint(p);
                }
            }
        }
        function C(e1, t1) {
            return (t1 << 3) + (7 & e1);
        }
        function _(e1) {
            return e1 << 1 ^ e1 >> 31;
        }
        function D(e1, t1) {
            for(var o = e1.loadGeometry(), i = e1.type, r = 0, n = 0, s = o.length, a = 0; a < s; a++){
                var l = o[a], c = 1;
                1 === i && (c = l.length), t1.writeVarint(C(1, c));
                for(var u = 3 === i ? l.length - 1 : l.length, h = 0; h < u; h++){
                    1 === h && 1 !== i && t1.writeVarint(C(2, u - 1));
                    var p = l[h].x - r, f = l[h].y - n;
                    t1.writeVarint(_(p)), t1.writeVarint(_(f)), r += p, n += f;
                }
                3 === i && t1.writeVarint(C(7, 1));
            }
        }
        function L(e1, t1) {
            var o = typeof e1;
            "string" === o ? t1.writeStringField(1, e1) : "boolean" === o ? t1.writeBooleanField(7, e1) : "number" === o && (e1 % 1 != 0 ? t1.writeDoubleField(3, e1) : e1 < 0 ? t1.writeSVarintField(6, e1) : t1.writeVarintField(5, e1));
        }
        function z(e1, t1, o, i, r, n) {
            if (r - i <= o) return;
            const s = i + r >> 1;
            O(e1, t1, s, i, r, n % 2), z(e1, t1, o, i, s - 1, n + 1), z(e1, t1, o, s + 1, r, n + 1);
        }
        function O(e1, t1, o, i, r, n) {
            for(; r > i;){
                if (r - i > 600) {
                    const s = r - i + 1, a = o - i + 1, l = Math.log(s), c = .5 * Math.exp(2 * l / 3), u = .5 * Math.sqrt(l * c * (s - c) / s) * (a - s / 2 < 0 ? -1 : 1);
                    O(e1, t1, o, Math.max(i, Math.floor(o - a * c / s + u)), Math.min(r, Math.floor(o + (s - a) * c / s + u)), n);
                }
                const s1 = t1[2 * o + n];
                let a1 = i, l1 = r;
                for(E(e1, t1, i, o), t1[2 * r + n] > s1 && E(e1, t1, i, r); a1 < l1;){
                    for(E(e1, t1, a1, l1), a1++, l1--; t1[2 * a1 + n] < s1;)a1++;
                    for(; t1[2 * l1 + n] > s1;)l1--;
                }
                t1[2 * i + n] === s1 ? E(e1, t1, i, l1) : (l1++, E(e1, t1, l1, r)), l1 <= o && (i = l1 + 1), o <= l1 && (r = l1 - 1);
            }
        }
        function E(e1, t1, o, i) {
            F(e1, o, i), F(t1, 2 * o, 2 * i), F(t1, 2 * o + 1, 2 * i + 1);
        }
        function F(e1, t1, o) {
            const i = e1[t1];
            e1[t1] = e1[o], e1[o] = i;
        }
        function N(e1, t1, o, i) {
            const r = e1 - o, n = t1 - i;
            return r * r + n * n;
        }
        m.exports = b, m.exports.fromVectorTileJs = b, m.exports.fromGeojsonVt = function(e1, t1) {
            t1 = t1 || {};
            var o = {};
            for(var i in e1)o[i] = new I(e1[i].features, t1), o[i].name = i, o[i].version = t1.version, o[i].extent = t1.extent;
            return b({
                layers: o
            });
        }, m.exports.GeoJSONWrapper = I;
        const A = (e1)=>e1[0], B = (e1)=>e1[1];
        class J {
            constructor(e1, t1 = A, o = B, i = 64, r = Float64Array){
                this.nodeSize = i, this.points = e1;
                const n = e1.length < 65536 ? Uint16Array : Uint32Array, s = this.ids = new n(e1.length), a = this.coords = new r(2 * e1.length);
                for(let i1 = 0; i1 < e1.length; i1++)s[i1] = i1, a[2 * i1] = t1(e1[i1]), a[2 * i1 + 1] = o(e1[i1]);
                z(s, a, i, 0, s.length - 1, 0);
            }
            range(e1, t1, o, i) {
                return function(e1, t1, o, i, r, n, s) {
                    const a = [
                        0,
                        e1.length - 1,
                        0
                    ], l = [];
                    let c, u;
                    for(; a.length;){
                        const h = a.pop(), p = a.pop(), f = a.pop();
                        if (p - f <= s) {
                            for(let s1 = f; s1 <= p; s1++)c = t1[2 * s1], u = t1[2 * s1 + 1], c >= o && c <= r && u >= i && u <= n && l.push(e1[s1]);
                            continue;
                        }
                        const d = Math.floor((f + p) / 2);
                        c = t1[2 * d], u = t1[2 * d + 1], c >= o && c <= r && u >= i && u <= n && l.push(e1[d]);
                        const g = (h + 1) % 2;
                        (0 === h ? o <= c : i <= u) && (a.push(f), a.push(d - 1), a.push(g)), (0 === h ? r >= c : n >= u) && (a.push(d + 1), a.push(p), a.push(g));
                    }
                    return l;
                }(this.ids, this.coords, e1, t1, o, i, this.nodeSize);
            }
            within(e1, t1, o) {
                return function(e1, t1, o, i, r, n) {
                    const s = [
                        0,
                        e1.length - 1,
                        0
                    ], a = [], l = r * r;
                    for(; s.length;){
                        const c = s.pop(), u = s.pop(), h = s.pop();
                        if (u - h <= n) {
                            for(let r1 = h; r1 <= u; r1++)N(t1[2 * r1], t1[2 * r1 + 1], o, i) <= l && a.push(e1[r1]);
                            continue;
                        }
                        const p = Math.floor((h + u) / 2), f = t1[2 * p], d = t1[2 * p + 1];
                        N(f, d, o, i) <= l && a.push(e1[p]);
                        const g = (c + 1) % 2;
                        (0 === c ? o - r <= f : i - r <= d) && (s.push(h), s.push(p - 1), s.push(g)), (0 === c ? o + r >= f : i + r >= d) && (s.push(p + 1), s.push(u), s.push(g));
                    }
                    return a;
                }(this.ids, this.coords, e1, t1, o, this.nodeSize);
            }
        }
        const Z = {
            minZoom: 0,
            maxZoom: 16,
            minPoints: 2,
            radius: 40,
            extent: 512,
            nodeSize: 64,
            log: !1,
            generateId: !1,
            reduce: null,
            map: (e1)=>e1
        }, G = Math.fround || (j = new Float32Array(1), (e1)=>(j[0] = +e1, j[0]));
        var j;
        class Y {
            constructor(e1){
                this.options = H(Object.create(Z), e1), this.trees = new Array(this.options.maxZoom + 1);
            }
            load(e1) {
                const { log: t1 , minZoom: o , maxZoom: i , nodeSize: r  } = this.options;
                t1 && console.time("total time");
                const n = `prepare ${e1.length} points`;
                t1 && console.time(n), this.points = e1;
                let s = [];
                for(let t2 = 0; t2 < e1.length; t2++)e1[t2].geometry && s.push(X(e1[t2], t2));
                this.trees[i + 1] = new J(s, K, Q, r, Float32Array), t1 && console.timeEnd(n);
                for(let e2 = i; e2 >= o; e2--){
                    const o1 = +Date.now();
                    s = this._cluster(s, e2), this.trees[e2] = new J(s, K, Q, r, Float32Array), t1 && console.log("z%d: %d clusters in %dms", e2, s.length, +Date.now() - o1);
                }
                return t1 && console.timeEnd("total time"), this;
            }
            getClusters(e1, t1) {
                let o = ((e1[0] + 180) % 360 + 360) % 360 - 180;
                const i = Math.max(-90, Math.min(90, e1[1]));
                let r = 180 === e1[2] ? 180 : ((e1[2] + 180) % 360 + 360) % 360 - 180;
                const n = Math.max(-90, Math.min(90, e1[3]));
                if (e1[2] - e1[0] >= 360) o = -180, r = 180;
                else if (o > r) {
                    const e2 = this.getClusters([
                        o,
                        i,
                        180,
                        n
                    ], t1), s = this.getClusters([
                        -180,
                        i,
                        r,
                        n
                    ], t1);
                    return e2.concat(s);
                }
                const s1 = this.trees[this._limitZoom(t1)], a = s1.range($(o), q(n), $(r), q(i)), l = [];
                for (const e3 of a){
                    const t2 = s1.points[e3];
                    l.push(t2.numPoints ? R(t2) : this.points[t2.index]);
                }
                return l;
            }
            getChildren(e1) {
                const t1 = this._getOriginId(e1), o = this._getOriginZoom(e1), i = "No cluster with the specified id.", r = this.trees[o];
                if (!r) throw new Error(i);
                const n = r.points[t1];
                if (!n) throw new Error(i);
                const s = this.options.radius / (this.options.extent * Math.pow(2, o - 1)), a = r.within(n.x, n.y, s), l = [];
                for (const t2 of a){
                    const o1 = r.points[t2];
                    o1.parentId === e1 && l.push(o1.numPoints ? R(o1) : this.points[o1.index]);
                }
                if (0 === l.length) throw new Error(i);
                return l;
            }
            getLeaves(e1, t1, o) {
                const i = [];
                return this._appendLeaves(i, e1, t1 = t1 || 10, o = o || 0, 0), i;
            }
            getTile(e1, t1, o) {
                const i = this.trees[this._limitZoom(e1)], r = Math.pow(2, e1), { extent: n , radius: s  } = this.options, a = s / n, l = (o - a) / r, c = (o + 1 + a) / r, u = {
                    features: []
                };
                return this._addTileFeatures(i.range((t1 - a) / r, l, (t1 + 1 + a) / r, c), i.points, t1, o, r, u), 0 === t1 && this._addTileFeatures(i.range(1 - a / r, l, 1, c), i.points, r, o, r, u), t1 === r - 1 && this._addTileFeatures(i.range(0, l, a / r, c), i.points, -1, o, r, u), u.features.length ? u : null;
            }
            getClusterExpansionZoom(e1) {
                let t1 = this._getOriginZoom(e1) - 1;
                for(; t1 <= this.options.maxZoom;){
                    const o = this.getChildren(e1);
                    if (t1++, 1 !== o.length) break;
                    e1 = o[0].properties.cluster_id;
                }
                return t1;
            }
            _appendLeaves(e1, t1, o, i, r) {
                const n = this.getChildren(t1);
                for (const t2 of n){
                    const n1 = t2.properties;
                    if (n1 && n1.cluster ? r + n1.point_count <= i ? r += n1.point_count : r = this._appendLeaves(e1, n1.cluster_id, o, i, r) : r < i ? r++ : e1.push(t2), e1.length === o) break;
                }
                return r;
            }
            _addTileFeatures(e1, t1, o, i, r, n) {
                for (const s of e1){
                    const e2 = t1[s], a = e2.numPoints;
                    let l, c, u;
                    if (a) l = W(e2), c = e2.x, u = e2.y;
                    else {
                        const t2 = this.points[e2.index];
                        l = t2.properties, c = $(t2.geometry.coordinates[0]), u = q(t2.geometry.coordinates[1]);
                    }
                    const h = {
                        type: 1,
                        geometry: [
                            [
                                Math.round(this.options.extent * (c * r - o)),
                                Math.round(this.options.extent * (u * r - i))
                            ]
                        ],
                        tags: l
                    };
                    let p;
                    a ? p = e2.id : this.options.generateId ? p = e2.index : this.points[e2.index].id && (p = this.points[e2.index].id), void 0 !== p && (h.id = p), n.features.push(h);
                }
            }
            _limitZoom(e1) {
                return Math.max(this.options.minZoom, Math.min(Math.floor(+e1), this.options.maxZoom + 1));
            }
            _cluster(e1, t1) {
                const o = [], { radius: i , extent: r , reduce: n , minPoints: s  } = this.options, a = i / (r * Math.pow(2, t1));
                for(let i1 = 0; i1 < e1.length; i1++){
                    const r1 = e1[i1];
                    if (r1.zoom <= t1) continue;
                    r1.zoom = t1;
                    const l = this.trees[t1 + 1], c = l.within(r1.x, r1.y, a), u = r1.numPoints || 1;
                    let h = u;
                    for (const e2 of c){
                        const o1 = l.points[e2];
                        o1.zoom > t1 && (h += o1.numPoints || 1);
                    }
                    if (h > u && h >= s) {
                        let e3 = r1.x * u, s1 = r1.y * u, a1 = n && u > 1 ? this._map(r1, !0) : null;
                        const p = (i1 << 5) + (t1 + 1) + this.points.length;
                        for (const o2 of c){
                            const i2 = l.points[o2];
                            if (i2.zoom <= t1) continue;
                            i2.zoom = t1;
                            const c1 = i2.numPoints || 1;
                            e3 += i2.x * c1, s1 += i2.y * c1, i2.parentId = p, n && (a1 || (a1 = this._map(r1, !0)), n(a1, this._map(i2)));
                        }
                        r1.parentId = p, o.push(V(e3 / h, s1 / h, p, h, a1));
                    } else if (o.push(r1), h > 1) for (const e4 of c){
                        const i3 = l.points[e4];
                        i3.zoom <= t1 || (i3.zoom = t1, o.push(i3));
                    }
                }
                return o;
            }
            _getOriginId(e1) {
                return e1 - this.points.length >> 5;
            }
            _getOriginZoom(e1) {
                return (e1 - this.points.length) % 32;
            }
            _map(e1, t1) {
                if (e1.numPoints) return t1 ? H({}, e1.properties) : e1.properties;
                const o = this.points[e1.index].properties, i = this.options.map(o);
                return t1 && i === o ? H({}, i) : i;
            }
        }
        function V(e1, t1, o, i, r) {
            return {
                x: G(e1),
                y: G(t1),
                zoom: 1 / 0,
                id: o,
                parentId: -1,
                numPoints: i,
                properties: r
            };
        }
        function X(e1, t1) {
            const [o, i] = e1.geometry.coordinates;
            return {
                x: G($(o)),
                y: G(q(i)),
                zoom: 1 / 0,
                index: t1,
                parentId: -1
            };
        }
        function R(e1) {
            var t1;
            return {
                type: "Feature",
                id: e1.id,
                properties: W(e1),
                geometry: {
                    type: "Point",
                    coordinates: [
                        (t1 = e1.x, 360 * (t1 - .5)),
                        U(e1.y)
                    ]
                }
            };
        }
        function W(e1) {
            const t1 = e1.numPoints, o = t1 >= 1e4 ? `${Math.round(t1 / 1e3)}k` : t1 >= 1e3 ? Math.round(t1 / 100) / 10 + "k" : t1;
            return H(H({}, e1.properties), {
                cluster: !0,
                cluster_id: e1.id,
                point_count: t1,
                point_count_abbreviated: o
            });
        }
        function $(e1) {
            return e1 / 360 + .5;
        }
        function q(e1) {
            const t1 = Math.sin(e1 * Math.PI / 180), o = .5 - .25 * Math.log((1 + t1) / (1 - t1)) / Math.PI;
            return o < 0 ? 0 : o > 1 ? 1 : o;
        }
        function U(e1) {
            const t1 = (180 - 360 * e1) * Math.PI / 180;
            return 360 * Math.atan(Math.exp(t1)) / Math.PI - 90;
        }
        function H(e1, t1) {
            for(const o in t1)e1[o] = t1[o];
            return e1;
        }
        function K(e1) {
            return e1.x;
        }
        function Q(e1) {
            return e1.y;
        }
        function ee(e1, t1, o, i) {
            for(var r, n = i, s = o - t1 >> 1, a = o - t1, l = e1[t1], c = e1[t1 + 1], u = e1[o], h = e1[o + 1], p = t1 + 3; p < o; p += 3){
                var f = te(e1[p], e1[p + 1], l, c, u, h);
                if (f > n) r = p, n = f;
                else if (f === n) {
                    var d = Math.abs(p - s);
                    d < a && (r = p, a = d);
                }
            }
            n > i && (r - t1 > 3 && ee(e1, t1, r, i), e1[r + 2] = n, o - r > 3 && ee(e1, r, o, i));
        }
        function te(e1, t1, o, i, r, n) {
            var s = r - o, a = n - i;
            if (0 !== s || 0 !== a) {
                var l = ((e1 - o) * s + (t1 - i) * a) / (s * s + a * a);
                l > 1 ? (o = r, i = n) : l > 0 && (o += s * l, i += a * l);
            }
            return (s = e1 - o) * s + (a = t1 - i) * a;
        }
        function oe(e1, t1, o, i) {
            var r = {
                id: void 0 === e1 ? null : e1,
                type: t1,
                geometry: o,
                tags: i,
                minX: 1 / 0,
                minY: 1 / 0,
                maxX: -1 / 0,
                maxY: -1 / 0
            };
            return function(e1) {
                var t1 = e1.geometry, o = e1.type;
                if ("Point" === o || "MultiPoint" === o || "LineString" === o) ie(e1, t1);
                else if ("Polygon" === o || "MultiLineString" === o) for(var i = 0; i < t1.length; i++)ie(e1, t1[i]);
                else if ("MultiPolygon" === o) for(i = 0; i < t1.length; i++)for(var r = 0; r < t1[i].length; r++)ie(e1, t1[i][r]);
            }(r), r;
        }
        function ie(e1, t1) {
            for(var o = 0; o < t1.length; o += 3)e1.minX = Math.min(e1.minX, t1[o]), e1.minY = Math.min(e1.minY, t1[o + 1]), e1.maxX = Math.max(e1.maxX, t1[o]), e1.maxY = Math.max(e1.maxY, t1[o + 1]);
        }
        function re(e1, t1, o, i) {
            if (t1.geometry) {
                var r = t1.geometry.coordinates, n = t1.geometry.type, s = Math.pow(o.tolerance / ((1 << o.maxZoom) * o.extent), 2), a = [], l = t1.id;
                if (o.promoteId ? l = t1.properties[o.promoteId] : o.generateId && (l = i || 0), "Point" === n) ne(r, a);
                else if ("MultiPoint" === n) for(var c = 0; c < r.length; c++)ne(r[c], a);
                else if ("LineString" === n) se(r, a, s, !1);
                else if ("MultiLineString" === n) {
                    if (o.lineMetrics) {
                        for(c = 0; c < r.length; c++)se(r[c], a = [], s, !1), e1.push(oe(l, "LineString", a, t1.properties));
                        return;
                    }
                    ae(r, a, s, !1);
                } else if ("Polygon" === n) ae(r, a, s, !0);
                else {
                    if ("MultiPolygon" !== n) {
                        if ("GeometryCollection" === n) {
                            for(c = 0; c < t1.geometry.geometries.length; c++)re(e1, {
                                id: l,
                                geometry: t1.geometry.geometries[c],
                                properties: t1.properties
                            }, o, i);
                            return;
                        }
                        throw new Error("Input data is not a valid GeoJSON object.");
                    }
                    for(c = 0; c < r.length; c++){
                        var u = [];
                        ae(r[c], u, s, !0), a.push(u);
                    }
                }
                e1.push(oe(l, n, a, t1.properties));
            }
        }
        function ne(e1, t1) {
            t1.push(le(e1[0])), t1.push(ce(e1[1])), t1.push(0);
        }
        function se(e1, t1, o, i) {
            for(var r, n, s = 0, a = 0; a < e1.length; a++){
                var l = le(e1[a][0]), c = ce(e1[a][1]);
                t1.push(l), t1.push(c), t1.push(0), a > 0 && (s += i ? (r * c - l * n) / 2 : Math.sqrt(Math.pow(l - r, 2) + Math.pow(c - n, 2))), r = l, n = c;
            }
            var u = t1.length - 3;
            t1[2] = 1, ee(t1, 0, u, o), t1[u + 2] = 1, t1.size = Math.abs(s), t1.start = 0, t1.end = t1.size;
        }
        function ae(e1, t1, o, i) {
            for(var r = 0; r < e1.length; r++){
                var n = [];
                se(e1[r], n, o, i), t1.push(n);
            }
        }
        function le(e1) {
            return e1 / 360 + .5;
        }
        function ce(e1) {
            var t1 = Math.sin(e1 * Math.PI / 180), o = .5 - .25 * Math.log((1 + t1) / (1 - t1)) / Math.PI;
            return o < 0 ? 0 : o > 1 ? 1 : o;
        }
        function ue(e1, t1, o, i, r, n, s, a) {
            if (i /= t1, n >= (o /= t1) && s < i) return e1;
            if (s < o || n >= i) return null;
            for(var l = [], c = 0; c < e1.length; c++){
                var u = e1[c], h = u.geometry, p = u.type, f = 0 === r ? u.minX : u.minY, d = 0 === r ? u.maxX : u.maxY;
                if (f >= o && d < i) l.push(u);
                else if (!(d < o || f >= i)) {
                    var g = [];
                    if ("Point" === p || "MultiPoint" === p) he(h, g, o, i, r);
                    else if ("LineString" === p) pe(h, g, o, i, r, !1, a.lineMetrics);
                    else if ("MultiLineString" === p) de(h, g, o, i, r, !1);
                    else if ("Polygon" === p) de(h, g, o, i, r, !0);
                    else if ("MultiPolygon" === p) for(var m = 0; m < h.length; m++){
                        var y = [];
                        de(h[m], y, o, i, r, !0), y.length && g.push(y);
                    }
                    if (g.length) {
                        if (a.lineMetrics && "LineString" === p) {
                            for(m = 0; m < g.length; m++)l.push(oe(u.id, p, g[m], u.tags));
                            continue;
                        }
                        "LineString" !== p && "MultiLineString" !== p || (1 === g.length ? (p = "LineString", g = g[0]) : p = "MultiLineString"), "Point" !== p && "MultiPoint" !== p || (p = 3 === g.length ? "Point" : "MultiPoint"), l.push(oe(u.id, p, g, u.tags));
                    }
                }
            }
            return l.length ? l : null;
        }
        function he(e1, t1, o, i, r) {
            for(var n = 0; n < e1.length; n += 3){
                var s = e1[n + r];
                s >= o && s <= i && (t1.push(e1[n]), t1.push(e1[n + 1]), t1.push(e1[n + 2]));
            }
        }
        function pe(e1, t1, o, i, r, n, s) {
            for(var a, l, c = fe(e1), u = 0 === r ? me : ye, h = e1.start, p = 0; p < e1.length - 3; p += 3){
                var f = e1[p], d = e1[p + 1], g = e1[p + 2], m = e1[p + 3], y = e1[p + 4], v = 0 === r ? f : d, x = 0 === r ? m : y, w = !1;
                s && (a = Math.sqrt(Math.pow(f - m, 2) + Math.pow(d - y, 2))), v < o ? x > o && (l = u(c, f, d, m, y, o), s && (c.start = h + a * l)) : v > i ? x < i && (l = u(c, f, d, m, y, i), s && (c.start = h + a * l)) : ge(c, f, d, g), x < o && v >= o && (l = u(c, f, d, m, y, o), w = !0), x > i && v <= i && (l = u(c, f, d, m, y, i), w = !0), !n && w && (s && (c.end = h + a * l), t1.push(c), c = fe(e1)), s && (h += a);
            }
            var S = e1.length - 3;
            f = e1[S], d = e1[S + 1], g = e1[S + 2], (v = 0 === r ? f : d) >= o && v <= i && ge(c, f, d, g), S = c.length - 3, n && S >= 3 && (c[S] !== c[0] || c[S + 1] !== c[1]) && ge(c, c[0], c[1], c[2]), c.length && t1.push(c);
        }
        function fe(e1) {
            var t1 = [];
            return t1.size = e1.size, t1.start = e1.start, t1.end = e1.end, t1;
        }
        function de(e1, t1, o, i, r, n) {
            for(var s = 0; s < e1.length; s++)pe(e1[s], t1, o, i, r, n, !1);
        }
        function ge(e1, t1, o, i) {
            e1.push(t1), e1.push(o), e1.push(i);
        }
        function me(e1, t1, o, i, r, n) {
            var s = (n - t1) / (i - t1);
            return e1.push(n), e1.push(o + (r - o) * s), e1.push(1), s;
        }
        function ye(e1, t1, o, i, r, n) {
            var s = (n - o) / (r - o);
            return e1.push(t1 + (i - t1) * s), e1.push(n), e1.push(1), s;
        }
        function ve(e1, t1) {
            for(var o = [], i = 0; i < e1.length; i++){
                var r, n = e1[i], s = n.type;
                if ("Point" === s || "MultiPoint" === s || "LineString" === s) r = xe(n.geometry, t1);
                else if ("MultiLineString" === s || "Polygon" === s) {
                    r = [];
                    for(var a = 0; a < n.geometry.length; a++)r.push(xe(n.geometry[a], t1));
                } else if ("MultiPolygon" === s) for(r = [], a = 0; a < n.geometry.length; a++){
                    for(var l = [], c = 0; c < n.geometry[a].length; c++)l.push(xe(n.geometry[a][c], t1));
                    r.push(l);
                }
                o.push(oe(n.id, s, r, n.tags));
            }
            return o;
        }
        function xe(e1, t1) {
            var o = [];
            o.size = e1.size, void 0 !== e1.start && (o.start = e1.start, o.end = e1.end);
            for(var i = 0; i < e1.length; i += 3)o.push(e1[i] + t1, e1[i + 1], e1[i + 2]);
            return o;
        }
        function we(e1, t1) {
            if (e1.transformed) return e1;
            var o, i, r, n = 1 << e1.z, s = e1.x, a = e1.y;
            for(o = 0; o < e1.features.length; o++){
                var l = e1.features[o], c = l.geometry, u = l.type;
                if (l.geometry = [], 1 === u) for(i = 0; i < c.length; i += 2)l.geometry.push(Se(c[i], c[i + 1], t1, n, s, a));
                else for(i = 0; i < c.length; i++){
                    var h = [];
                    for(r = 0; r < c[i].length; r += 2)h.push(Se(c[i][r], c[i][r + 1], t1, n, s, a));
                    l.geometry.push(h);
                }
            }
            return e1.transformed = !0, e1;
        }
        function Se(e1, t1, o, i, r, n) {
            return [
                Math.round(o * (e1 * i - r)),
                Math.round(o * (t1 * i - n))
            ];
        }
        function Me(e1, t1, o, i, r) {
            for(var n = t1 === r.maxZoom ? 0 : r.tolerance / ((1 << t1) * r.extent), s = {
                features: [],
                numPoints: 0,
                numSimplified: 0,
                numFeatures: 0,
                source: null,
                x: o,
                y: i,
                z: t1,
                transformed: !1,
                minX: 2,
                minY: 1,
                maxX: -1,
                maxY: 0
            }, a = 0; a < e1.length; a++){
                s.numFeatures++, Ie(s, e1[a], n, r);
                var l = e1[a].minX, c = e1[a].minY, u = e1[a].maxX, h = e1[a].maxY;
                l < s.minX && (s.minX = l), c < s.minY && (s.minY = c), u > s.maxX && (s.maxX = u), h > s.maxY && (s.maxY = h);
            }
            return s;
        }
        function Ie(e1, t1, o, i) {
            var r = t1.geometry, n = t1.type, s = [];
            if ("Point" === n || "MultiPoint" === n) for(var a = 0; a < r.length; a += 3)s.push(r[a]), s.push(r[a + 1]), e1.numPoints++, e1.numSimplified++;
            else if ("LineString" === n) be(s, r, e1, o, !1, !1);
            else if ("MultiLineString" === n || "Polygon" === n) for(a = 0; a < r.length; a++)be(s, r[a], e1, o, "Polygon" === n, 0 === a);
            else if ("MultiPolygon" === n) for(var l = 0; l < r.length; l++){
                var c = r[l];
                for(a = 0; a < c.length; a++)be(s, c[a], e1, o, !0, 0 === a);
            }
            if (s.length) {
                var u = t1.tags || null;
                if ("LineString" === n && i.lineMetrics) {
                    for(var h in u = {}, t1.tags)u[h] = t1.tags[h];
                    u.mapbox_clip_start = r.start / r.size, u.mapbox_clip_end = r.end / r.size;
                }
                var p = {
                    geometry: s,
                    type: "Polygon" === n || "MultiPolygon" === n ? 3 : "LineString" === n || "MultiLineString" === n ? 2 : 1,
                    tags: u
                };
                null !== t1.id && (p.id = t1.id), e1.features.push(p);
            }
        }
        function be(e1, t1, o, i, r, n) {
            var s = i * i;
            if (i > 0 && t1.size < (r ? s : i)) o.numPoints += t1.length / 3;
            else {
                for(var a = [], l = 0; l < t1.length; l += 3)(0 === i || t1[l + 2] > s) && (o.numSimplified++, a.push(t1[l]), a.push(t1[l + 1])), o.numPoints++;
                r && function(e1, t1) {
                    for(var o = 0, i = 0, r = e1.length, n = r - 2; i < r; n = i, i += 2)o += (e1[i] - e1[n]) * (e1[i + 1] + e1[n + 1]);
                    if (o > 0 === t1) for(i = 0, r = e1.length; i < r / 2; i += 2){
                        var s = e1[i], a = e1[i + 1];
                        e1[i] = e1[r - 2 - i], e1[i + 1] = e1[r - 1 - i], e1[r - 2 - i] = s, e1[r - 1 - i] = a;
                    }
                }(a, n), e1.push(a);
            }
        }
        function ke(e1, t1) {
            var o = (t1 = this.options = function(e1, t1) {
                for(var o in t1)e1[o] = t1[o];
                return e1;
            }(Object.create(this.options), t1)).debug;
            if (o && console.time("preprocess data"), t1.maxZoom < 0 || t1.maxZoom > 24) throw new Error("maxZoom should be in the 0-24 range");
            if (t1.promoteId && t1.generateId) throw new Error("promoteId and generateId cannot be used together.");
            var i = function(e1, t1) {
                var o = [];
                if ("FeatureCollection" === e1.type) for(var i = 0; i < e1.features.length; i++)re(o, e1.features[i], t1, i);
                else re(o, "Feature" === e1.type ? e1 : {
                    geometry: e1
                }, t1);
                return o;
            }(e1, t1);
            this.tiles = {}, this.tileCoords = [], o && (console.timeEnd("preprocess data"), console.log("index: maxZoom: %d, maxPoints: %d", t1.indexMaxZoom, t1.indexMaxPoints), console.time("generate tiles"), this.stats = {}, this.total = 0), i = function(e1, t1) {
                var o = t1.buffer / t1.extent, i = e1, r = ue(e1, 1, -1 - o, o, 0, -1, 2, t1), n = ue(e1, 1, 1 - o, 2 + o, 0, -1, 2, t1);
                return (r || n) && (i = ue(e1, 1, -o, 1 + o, 0, -1, 2, t1) || [], r && (i = ve(r, 1).concat(i)), n && (i = i.concat(ve(n, -1)))), i;
            }(i, t1), i.length && this.splitTile(i, 0, 0, 0), o && (i.length && console.log("features: %d, points: %d", this.tiles[0].numFeatures, this.tiles[0].numPoints), console.timeEnd("generate tiles"), console.log("tiles generated:", this.total, JSON.stringify(this.stats)));
        }
        function Pe(e1, t1, o) {
            return 32 * ((1 << e1) * o + t1) + e1;
        }
        function Te(e1, t1) {
            const o = e1.tileID.canonical;
            if (!this._geoJSONIndex) return t1(null, null);
            const i = this._geoJSONIndex.getTile(o.z, o.x, o.y);
            if (!i) return t1(null, null);
            const r = new g(i.features);
            let n = m.exports(r);
            0 === n.byteOffset && n.byteLength === n.buffer.byteLength || (n = new Uint8Array(n)), t1(null, {
                vectorTile: r,
                rawData: n.buffer
            });
        }
        ke.prototype.options = {
            maxZoom: 14,
            indexMaxZoom: 5,
            indexMaxPoints: 1e5,
            tolerance: 3,
            extent: 4096,
            buffer: 64,
            lineMetrics: !1,
            promoteId: null,
            generateId: !1,
            debug: 0
        }, ke.prototype.splitTile = function(e1, t1, o, i, r, n, s) {
            for(var a = [
                e1,
                t1,
                o,
                i
            ], l = this.options, c = l.debug; a.length;){
                i = a.pop(), o = a.pop(), t1 = a.pop(), e1 = a.pop();
                var u = 1 << t1, h = Pe(t1, o, i), p = this.tiles[h];
                if (!p && (c > 1 && console.time("creation"), p = this.tiles[h] = Me(e1, t1, o, i, l), this.tileCoords.push({
                    z: t1,
                    x: o,
                    y: i
                }), c)) {
                    c > 1 && (console.log("tile z%d-%d-%d (features: %d, points: %d, simplified: %d)", t1, o, i, p.numFeatures, p.numPoints, p.numSimplified), console.timeEnd("creation"));
                    var f = "z" + t1;
                    this.stats[f] = (this.stats[f] || 0) + 1, this.total++;
                }
                if (p.source = e1, r) {
                    if (t1 === l.maxZoom || t1 === r) continue;
                    var d = 1 << r - t1;
                    if (o !== Math.floor(n / d) || i !== Math.floor(s / d)) continue;
                } else if (t1 === l.indexMaxZoom || p.numPoints <= l.indexMaxPoints) continue;
                if (p.source = null, 0 !== e1.length) {
                    c > 1 && console.time("clipping");
                    var g, m, y, v, x, w, S = .5 * l.buffer / l.extent, M = .5 - S, I = .5 + S, b = 1 + S;
                    g = m = y = v = null, x = ue(e1, u, o - S, o + I, 0, p.minX, p.maxX, l), w = ue(e1, u, o + M, o + b, 0, p.minX, p.maxX, l), e1 = null, x && (g = ue(x, u, i - S, i + I, 1, p.minY, p.maxY, l), m = ue(x, u, i + M, i + b, 1, p.minY, p.maxY, l), x = null), w && (y = ue(w, u, i - S, i + I, 1, p.minY, p.maxY, l), v = ue(w, u, i + M, i + b, 1, p.minY, p.maxY, l), w = null), c > 1 && console.timeEnd("clipping"), a.push(g || [], t1 + 1, 2 * o, 2 * i), a.push(m || [], t1 + 1, 2 * o, 2 * i + 1), a.push(y || [], t1 + 1, 2 * o + 1, 2 * i), a.push(v || [], t1 + 1, 2 * o + 1, 2 * i + 1);
                }
            }
        }, ke.prototype.getTile = function(e1, t1, o) {
            var i = this.options, r = i.extent, n = i.debug;
            if (e1 < 0 || e1 > 24) return null;
            var s = 1 << e1, a = Pe(e1, t1 = (t1 % s + s) % s, o);
            if (this.tiles[a]) return we(this.tiles[a], r);
            n > 1 && console.log("drilling down to z%d-%d-%d", e1, t1, o);
            for(var l, c = e1, u = t1, h = o; !l && c > 0;)c--, u = Math.floor(u / 2), h = Math.floor(h / 2), l = this.tiles[Pe(c, u, h)];
            return l && l.source ? (n > 1 && console.log("found parent tile z%d-%d-%d", c, u, h), n > 1 && console.time("drilling down"), this.splitTile(l.source, c, u, h, e1, t1, o), n > 1 && console.timeEnd("drilling down"), this.tiles[a] ? we(this.tiles[a], r) : null) : null;
        };
        class Ce extends l {
            constructor(e1, t1, o, i){
                super(e1, t1, o, Te), i && (this.loadGeoJSON = i);
            }
            loadData(t1, o) {
                var i;
                null === (i = this._pendingRequest) || void 0 === i || i.cancel(), this._pendingCallback && this._pendingCallback(null, {
                    abandoned: !0
                });
                const r = !!(t1 && t1.request && t1.request.collectResourceTiming) && new e1.RequestPerformance(t1.request);
                this._pendingCallback = o, this._pendingRequest = this.loadGeoJSON(t1, (i, n)=>{
                    if (delete this._pendingCallback, delete this._pendingRequest, i || !n) return o(i);
                    if ("object" != typeof n) return o(new Error(`Input data given to '${t1.source}' is not a valid GeoJSON object.`));
                    {
                        u(n, !0);
                        try {
                            if (t1.filter) {
                                const o1 = e1.createExpression(t1.filter, {
                                    type: "boolean",
                                    "property-type": "data-driven",
                                    overridable: !1,
                                    transition: !1
                                });
                                if ("error" === o1.result) throw new Error(o1.value.map((e1)=>`${e1.key}: ${e1.message}`).join(", "));
                                const i1 = n.features.filter((e1)=>o1.value.evaluate({
                                        zoom: 0
                                    }, e1));
                                n = {
                                    type: "FeatureCollection",
                                    features: i1
                                };
                            }
                            this._geoJSONIndex = t1.cluster ? new Y(function({ superclusterOptions: t1 , clusterProperties: o  }) {
                                if (!o || !t1) return t1;
                                const i = {}, r = {}, n = {
                                    accumulated: null,
                                    zoom: 0
                                }, s = {
                                    properties: null
                                }, a = Object.keys(o);
                                for (const t2 of a){
                                    const [n1, s1] = o[t2], a1 = e1.createExpression(s1), l = e1.createExpression("string" == typeof n1 ? [
                                        n1,
                                        [
                                            "accumulated"
                                        ],
                                        [
                                            "get",
                                            t2
                                        ]
                                    ] : n1);
                                    i[t2] = a1.value, r[t2] = l.value;
                                }
                                return t1.map = (e1)=>{
                                    s.properties = e1;
                                    const t1 = {};
                                    for (const e2 of a)t1[e2] = i[e2].evaluate(n, s);
                                    return t1;
                                }, t1.reduce = (e1, t1)=>{
                                    s.properties = t1;
                                    for (const t2 of a)n.accumulated = e1[t2], e1[t2] = r[t2].evaluate(n, s);
                                }, t1;
                            }(t1)).load(n.features) : function(e1, t1) {
                                return new ke(e1, t1);
                            }(n, t1.geojsonVtOptions);
                        } catch (i2) {
                            return o(i2);
                        }
                        this.loaded = {};
                        const s = {};
                        if (r) {
                            const e2 = r.finish();
                            e2 && (s.resourceTiming = {}, s.resourceTiming[t1.source] = JSON.parse(JSON.stringify(e2)));
                        }
                        o(null, s);
                    }
                });
            }
            reloadTile(e1, t1) {
                const o = this.loaded;
                return o && o[e1.uid] ? super.reloadTile(e1, t1) : this.loadTile(e1, t1);
            }
            loadGeoJSON(t1, o) {
                if (t1.request) return e1.getJSON(t1.request, o);
                if ("string" == typeof t1.data) try {
                    o(null, JSON.parse(t1.data));
                } catch (e2) {
                    o(new Error(`Input data given to '${t1.source}' is not a valid GeoJSON object.`));
                }
                else o(new Error(`Input data given to '${t1.source}' is not a valid GeoJSON object.`));
                return {
                    cancel: ()=>{}
                };
            }
            removeSource(e1, t1) {
                this._pendingCallback && this._pendingCallback(null, {
                    abandoned: !0
                }), t1();
            }
            getClusterExpansionZoom(e1, t1) {
                try {
                    t1(null, this._geoJSONIndex.getClusterExpansionZoom(e1.clusterId));
                } catch (e2) {
                    t1(e2);
                }
            }
            getClusterChildren(e1, t1) {
                try {
                    t1(null, this._geoJSONIndex.getChildren(e1.clusterId));
                } catch (e2) {
                    t1(e2);
                }
            }
            getClusterLeaves(e1, t1) {
                try {
                    t1(null, this._geoJSONIndex.getLeaves(e1.clusterId, e1.limit, e1.offset));
                } catch (e2) {
                    t1(e2);
                }
            }
        }
        class _e {
            constructor(t1){
                this.self = t1, this.actor = new e1.Actor(t1, this), this.layerIndexes = {}, this.availableImages = {}, this.workerSourceTypes = {
                    vector: l,
                    geojson: Ce
                }, this.workerSources = {}, this.demWorkerSources = {}, this.self.registerWorkerSource = (e1, t1)=>{
                    if (this.workerSourceTypes[e1]) throw new Error(`Worker source with name "${e1}" already registered.`);
                    this.workerSourceTypes[e1] = t1;
                }, this.self.registerRTLTextPlugin = (t1)=>{
                    if (e1.plugin.isParsed()) throw new Error("RTL text plugin already registered.");
                    e1.plugin.applyArabicShaping = t1.applyArabicShaping, e1.plugin.processBidirectionalText = t1.processBidirectionalText, e1.plugin.processStyledBidirectionalText = t1.processStyledBidirectionalText;
                };
            }
            setReferrer(e1, t1) {
                this.referrer = t1;
            }
            setImages(e1, t1, o) {
                this.availableImages[e1] = t1;
                for(const o1 in this.workerSources[e1]){
                    const i = this.workerSources[e1][o1];
                    for(const e2 in i)i[e2].availableImages = t1;
                }
                o();
            }
            setLayers(e1, t1, o) {
                this.getLayerIndex(e1).replace(t1), o();
            }
            updateLayers(e1, t1, o) {
                this.getLayerIndex(e1).update(t1.layers, t1.removedIds), o();
            }
            loadTile(e1, t1, o) {
                this.getWorkerSource(e1, t1.type, t1.source).loadTile(t1, o);
            }
            loadDEMTile(e1, t1, o) {
                this.getDEMWorkerSource(e1, t1.source).loadTile(t1, o);
            }
            reloadTile(e1, t1, o) {
                this.getWorkerSource(e1, t1.type, t1.source).reloadTile(t1, o);
            }
            abortTile(e1, t1, o) {
                this.getWorkerSource(e1, t1.type, t1.source).abortTile(t1, o);
            }
            removeTile(e1, t1, o) {
                this.getWorkerSource(e1, t1.type, t1.source).removeTile(t1, o);
            }
            removeDEMTile(e1, t1) {
                this.getDEMWorkerSource(e1, t1.source).removeTile(t1);
            }
            removeSource(e1, t1, o) {
                if (!this.workerSources[e1] || !this.workerSources[e1][t1.type] || !this.workerSources[e1][t1.type][t1.source]) return;
                const i = this.workerSources[e1][t1.type][t1.source];
                delete this.workerSources[e1][t1.type][t1.source], void 0 !== i.removeSource ? i.removeSource(t1, o) : o();
            }
            loadWorkerSource(e1, t1, o) {
                try {
                    this.self.importScripts(t1.url), o();
                } catch (e2) {
                    o(e2.toString());
                }
            }
            syncRTLPluginState(t1, o, i) {
                try {
                    e1.plugin.setState(o);
                    const t2 = e1.plugin.getPluginURL();
                    if (e1.plugin.isLoaded() && !e1.plugin.isParsed() && null != t2) {
                        this.self.importScripts(t2);
                        const o1 = e1.plugin.isParsed();
                        i(o1 ? void 0 : new Error(`RTL Text Plugin failed to import scripts from ${t2}`), o1);
                    }
                } catch (e2) {
                    i(e2.toString());
                }
            }
            getAvailableImages(e1) {
                let t1 = this.availableImages[e1];
                return t1 || (t1 = []), t1;
            }
            getLayerIndex(e1) {
                let t1 = this.layerIndexes[e1];
                return t1 || (t1 = this.layerIndexes[e1] = new i), t1;
            }
            getWorkerSource(e1, t1, o) {
                if (this.workerSources[e1] || (this.workerSources[e1] = {}), this.workerSources[e1][t1] || (this.workerSources[e1][t1] = {}), !this.workerSources[e1][t1][o]) {
                    const i = {
                        send: (t1, o, i)=>{
                            this.actor.send(t1, o, i, e1);
                        }
                    };
                    this.workerSources[e1][t1][o] = new this.workerSourceTypes[t1](i, this.getLayerIndex(e1), this.getAvailableImages(e1));
                }
                return this.workerSources[e1][t1][o];
            }
            getDEMWorkerSource(e1, t1) {
                return this.demWorkerSources[e1] || (this.demWorkerSources[e1] = {}), this.demWorkerSources[e1][t1] || (this.demWorkerSources[e1][t1] = new c), this.demWorkerSources[e1][t1];
            }
            enforceCacheSizeLimit(t1, o) {
                e1.enforceCacheSizeLimit(o);
            }
        }
        return e1.isWorker() && (self.worker = new _e(self)), _e;
    });
    define([
        "./shared"
    ], function(t1) {
        "use strict";
        var e1 = i;
        function i(t1) {
            return !function(t1) {
                var e1;
                return "undefined" == typeof window || "undefined" == typeof document ? "not a browser" : Array.prototype && Array.prototype.every && Array.prototype.filter && Array.prototype.forEach && Array.prototype.indexOf && Array.prototype.lastIndexOf && Array.prototype.map && Array.prototype.some && Array.prototype.reduce && Array.prototype.reduceRight && Array.isArray ? Function.prototype && Function.prototype.bind ? Object.keys && Object.create && Object.getPrototypeOf && Object.getOwnPropertyNames && Object.isSealed && Object.isFrozen && Object.isExtensible && Object.getOwnPropertyDescriptor && Object.defineProperty && Object.defineProperties && Object.seal && Object.freeze && Object.preventExtensions ? "JSON" in window && "parse" in JSON && "stringify" in JSON ? function() {
                    if (!("Worker" in window && "Blob" in window && "URL" in window)) return !1;
                    var t1, e1, i = new Blob([
                        ""
                    ], {
                        type: "text/javascript"
                    }), o = URL.createObjectURL(i);
                    try {
                        e1 = new Worker(o), t1 = !0;
                    } catch (e2) {
                        t1 = !1;
                    }
                    return e1 && e1.terminate(), URL.revokeObjectURL(o), t1;
                }() ? "Uint8ClampedArray" in window ? ArrayBuffer.isView ? function() {
                    var t1 = document.createElement("canvas");
                    t1.width = t1.height = 1;
                    var e1 = t1.getContext("2d");
                    if (!e1) return !1;
                    var i = e1.getImageData(0, 0, 1, 1);
                    return i && i.width === t1.width;
                }() ? (void 0 === o[e1 = t1 && t1.failIfMajorPerformanceCaveat] && (o[e1] = function(t1) {
                    var e1, o = function(t1) {
                        var e1 = document.createElement("canvas"), o = Object.create(i.webGLContextAttributes);
                        return o.failIfMajorPerformanceCaveat = t1, e1.getContext("webgl", o) || e1.getContext("experimental-webgl", o);
                    }(t1);
                    if (!o) return !1;
                    try {
                        e1 = o.createShader(o.VERTEX_SHADER);
                    } catch (t2) {
                        return !1;
                    }
                    return !(!e1 || o.isContextLost()) && (o.shaderSource(e1, "void main() {}"), o.compileShader(e1), !0 === o.getShaderParameter(e1, o.COMPILE_STATUS));
                }(e1)), o[e1] ? document.documentMode ? "insufficient ECMAScript 6 support" : void 0 : "insufficient WebGL support") : "insufficient Canvas/getImageData support" : "insufficient ArrayBuffer support" : "insufficient Uint8ClampedArray support" : "insufficient worker support" : "insufficient JSON support" : "insufficient Object support" : "insufficient Function support" : "insufficent Array support";
            }(t1);
        }
        var o = {};
        function a(t1, e1) {
            if (Array.isArray(t1)) {
                if (!Array.isArray(e1) || t1.length !== e1.length) return !1;
                for(let i = 0; i < t1.length; i++)if (!a(t1[i], e1[i])) return !1;
                return !0;
            }
            if ("object" == typeof t1 && null !== t1 && null !== e1) {
                if ("object" != typeof e1) return !1;
                if (Object.keys(t1).length !== Object.keys(e1).length) return !1;
                for(const i1 in t1)if (!a(t1[i1], e1[i1])) return !1;
                return !0;
            }
            return t1 === e1;
        }
        i.webGLContextAttributes = {
            antialias: !1,
            alpha: !0,
            stencil: !0,
            depth: !0
        };
        class r {
            static testProp(t1) {
                if (!r.docStyle) return t1[0];
                for(let e1 = 0; e1 < t1.length; e1++)if (t1[e1] in r.docStyle) return t1[e1];
                return t1[0];
            }
            static create(t1, e1, i) {
                const o = window.document.createElement(t1);
                return void 0 !== e1 && (o.className = e1), i && i.appendChild(o), o;
            }
            static createNS(t1, e1) {
                return window.document.createElementNS(t1, e1);
            }
            static disableDrag() {
                r.docStyle && r.selectProp && (r.userSelect = r.docStyle[r.selectProp], r.docStyle[r.selectProp] = "none");
            }
            static enableDrag() {
                r.docStyle && r.selectProp && (r.docStyle[r.selectProp] = r.userSelect);
            }
            static setTransform(t1, e1) {
                t1.style[r.transformProp] = e1;
            }
            static addEventListener(t1, e1, i, o = {}) {
                t1.addEventListener(e1, i, "passive" in o ? o : o.capture);
            }
            static removeEventListener(t1, e1, i, o = {}) {
                t1.removeEventListener(e1, i, "passive" in o ? o : o.capture);
            }
            static suppressClickInternal(t1) {
                t1.preventDefault(), t1.stopPropagation(), window.removeEventListener("click", r.suppressClickInternal, !0);
            }
            static suppressClick() {
                window.addEventListener("click", r.suppressClickInternal, !0), window.setTimeout(()=>{
                    window.removeEventListener("click", r.suppressClickInternal, !0);
                }, 0);
            }
            static mousePos(e1, i) {
                const o = e1.getBoundingClientRect();
                return new t1.pointGeometry(i.clientX - o.left - e1.clientLeft, i.clientY - o.top - e1.clientTop);
            }
            static touchPos(e1, i) {
                const o = e1.getBoundingClientRect(), a = [];
                for(let r = 0; r < i.length; r++)a.push(new t1.pointGeometry(i[r].clientX - o.left - e1.clientLeft, i[r].clientY - o.top - e1.clientTop));
                return a;
            }
            static mouseButton(t1) {
                return t1.button;
            }
            static remove(t1) {
                t1.parentNode && t1.parentNode.removeChild(t1);
            }
        }
        r.docStyle = "undefined" != typeof window && window.document && window.document.documentElement.style, r.selectProp = r.testProp([
            "userSelect",
            "MozUserSelect",
            "WebkitUserSelect",
            "msUserSelect"
        ]), r.transformProp = r.testProp([
            "transform",
            "WebkitTransform"
        ]);
        class s {
            constructor(t1){
                this._transformRequestFn = t1;
            }
            transformRequest(t1, e1) {
                return this._transformRequestFn && this._transformRequestFn(t1, e1) || {
                    url: t1
                };
            }
            normalizeSpriteURL(t1, e1, i) {
                const o = function(t1) {
                    const e1 = t1.match(n);
                    if (!e1) throw new Error(`Unable to parse URL "${t1}"`);
                    return {
                        protocol: e1[1],
                        authority: e1[2],
                        path: e1[3] || "/",
                        params: e1[4] ? e1[4].split("&") : []
                    };
                }(t1);
                return o.path += `${e1}${i}`, function(t1) {
                    const e1 = t1.params.length ? `?${t1.params.join("&")}` : "";
                    return `${t1.protocol}://${t1.authority}${t1.path}${e1}`;
                }(o);
            }
            setTransformRequest(t1) {
                this._transformRequestFn = t1;
            }
        }
        const n = /^(\w+):\/\/([^/?]*)(\/[^?]+)?\??(.+)?/;
        class l {
            constructor(t1, e1, i, o){
                this.context = t1, this.format = i, this.texture = t1.gl.createTexture(), this.update(e1, o);
            }
            update(e1, i, o) {
                const { width: a , height: r  } = e1, s = !(this.size && this.size[0] === a && this.size[1] === r || o), { context: n  } = this, { gl: l  } = n;
                if (this.useMipmap = Boolean(i && i.useMipmap), l.bindTexture(l.TEXTURE_2D, this.texture), n.pixelStoreUnpackFlipY.set(!1), n.pixelStoreUnpack.set(1), n.pixelStoreUnpackPremultiplyAlpha.set(this.format === l.RGBA && (!i || !1 !== i.premultiply)), s) this.size = [
                    a,
                    r
                ], e1 instanceof HTMLImageElement || e1 instanceof HTMLCanvasElement || e1 instanceof HTMLVideoElement || e1 instanceof ImageData || t1.isImageBitmap(e1) ? l.texImage2D(l.TEXTURE_2D, 0, this.format, this.format, l.UNSIGNED_BYTE, e1) : l.texImage2D(l.TEXTURE_2D, 0, this.format, a, r, 0, this.format, l.UNSIGNED_BYTE, e1.data);
                else {
                    const { x: i1 , y: s1  } = o || {
                        x: 0,
                        y: 0
                    };
                    e1 instanceof HTMLImageElement || e1 instanceof HTMLCanvasElement || e1 instanceof HTMLVideoElement || e1 instanceof ImageData || t1.isImageBitmap(e1) ? l.texSubImage2D(l.TEXTURE_2D, 0, i1, s1, l.RGBA, l.UNSIGNED_BYTE, e1) : l.texSubImage2D(l.TEXTURE_2D, 0, i1, s1, a, r, l.RGBA, l.UNSIGNED_BYTE, e1.data);
                }
                this.useMipmap && this.isSizePowerOfTwo() && l.generateMipmap(l.TEXTURE_2D);
            }
            bind(t1, e1, i) {
                const { context: o  } = this, { gl: a  } = o;
                a.bindTexture(a.TEXTURE_2D, this.texture), i !== a.LINEAR_MIPMAP_NEAREST || this.isSizePowerOfTwo() || (i = a.LINEAR), t1 !== this.filter && (a.texParameteri(a.TEXTURE_2D, a.TEXTURE_MAG_FILTER, t1), a.texParameteri(a.TEXTURE_2D, a.TEXTURE_MIN_FILTER, i || t1), this.filter = t1), e1 !== this.wrap && (a.texParameteri(a.TEXTURE_2D, a.TEXTURE_WRAP_S, e1), a.texParameteri(a.TEXTURE_2D, a.TEXTURE_WRAP_T, e1), this.wrap = e1);
            }
            isSizePowerOfTwo() {
                return this.size[0] === this.size[1] && Math.log(this.size[0]) / Math.LN2 % 1 == 0;
            }
            destroy() {
                const { gl: t1  } = this.context;
                t1.deleteTexture(this.texture), this.texture = null;
            }
        }
        function c(t1) {
            const { userImage: e1  } = t1;
            return !!(e1 && e1.render && e1.render()) && (t1.data.replace(new Uint8Array(e1.data.buffer)), !0);
        }
        class h extends t1.Evented {
            constructor(){
                super(), this.images = {}, this.updatedImages = {}, this.callbackDispatchedThisFrame = {}, this.loaded = !1, this.requestors = [], this.patterns = {}, this.atlasImage = new t1.RGBAImage({
                    width: 1,
                    height: 1
                }), this.dirty = !0;
            }
            isLoaded() {
                return this.loaded;
            }
            setLoaded(t1) {
                if (this.loaded !== t1 && (this.loaded = t1, t1)) {
                    for (const { ids: t2 , callback: e1  } of this.requestors)this._notify(t2, e1);
                    this.requestors = [];
                }
            }
            getImage(t1) {
                return this.images[t1];
            }
            addImage(t1, e1) {
                if (this.images[t1]) throw new Error(`Image id ${t1} already exist, use updateImage instead`);
                this._validate(t1, e1) && (this.images[t1] = e1);
            }
            _validate(e1, i) {
                let o = !0;
                return this._validateStretch(i.stretchX, i.data && i.data.width) || (this.fire(new t1.ErrorEvent(new Error(`Image "${e1}" has invalid "stretchX" value`))), o = !1), this._validateStretch(i.stretchY, i.data && i.data.height) || (this.fire(new t1.ErrorEvent(new Error(`Image "${e1}" has invalid "stretchY" value`))), o = !1), this._validateContent(i.content, i) || (this.fire(new t1.ErrorEvent(new Error(`Image "${e1}" has invalid "content" value`))), o = !1), o;
            }
            _validateStretch(t1, e1) {
                if (!t1) return !0;
                let i = 0;
                for (const o of t1){
                    if (o[0] < i || o[1] < o[0] || e1 < o[1]) return !1;
                    i = o[1];
                }
                return !0;
            }
            _validateContent(t1, e1) {
                return !(t1 && (4 !== t1.length || t1[0] < 0 || e1.data.width < t1[0] || t1[1] < 0 || e1.data.height < t1[1] || t1[2] < 0 || e1.data.width < t1[2] || t1[3] < 0 || e1.data.height < t1[3] || t1[2] < t1[0] || t1[3] < t1[1]));
            }
            updateImage(t1, e1) {
                const i = this.images[t1];
                if (i.data.width !== e1.data.width || i.data.height !== e1.data.height) throw new Error(`size mismatch between old image (${i.data.width}x${i.data.height}) and new image (${e1.data.width}x${e1.data.height}).`);
                e1.version = i.version + 1, this.images[t1] = e1, this.updatedImages[t1] = !0;
            }
            removeImage(t1) {
                const e1 = this.images[t1];
                delete this.images[t1], delete this.patterns[t1], e1.userImage && e1.userImage.onRemove && e1.userImage.onRemove();
            }
            listImages() {
                return Object.keys(this.images);
            }
            getImages(t1, e1) {
                let i = !0;
                if (!this.isLoaded()) for (const e2 of t1)this.images[e2] || (i = !1);
                this.isLoaded() || i ? this._notify(t1, e1) : this.requestors.push({
                    ids: t1,
                    callback: e1
                });
            }
            _notify(e1, i) {
                const o = {};
                for (const i1 of e1){
                    this.images[i1] || this.fire(new t1.Event("styleimagemissing", {
                        id: i1
                    }));
                    const e2 = this.images[i1];
                    e2 ? o[i1] = {
                        data: e2.data.clone(),
                        pixelRatio: e2.pixelRatio,
                        sdf: e2.sdf,
                        version: e2.version,
                        stretchX: e2.stretchX,
                        stretchY: e2.stretchY,
                        content: e2.content,
                        hasRenderCallback: Boolean(e2.userImage && e2.userImage.render)
                    } : t1.warnOnce(`Image "${i1}" could not be loaded. Please make sure you have added the image with map.addImage() or a "sprite" property in your style. You can provide missing images by listening for the "styleimagemissing" map event.`);
                }
                i(null, o);
            }
            getPixelSize() {
                const { width: t1 , height: e1  } = this.atlasImage;
                return {
                    width: t1,
                    height: e1
                };
            }
            getPattern(e1) {
                const i = this.patterns[e1], o = this.getImage(e1);
                if (!o) return null;
                if (i && i.position.version === o.version) return i.position;
                if (i) i.position.version = o.version;
                else {
                    const i1 = {
                        w: o.data.width + 2,
                        h: o.data.height + 2,
                        x: 0,
                        y: 0
                    }, a = new t1.ImagePosition(i1, o);
                    this.patterns[e1] = {
                        bin: i1,
                        position: a
                    };
                }
                return this._updatePatternAtlas(), this.patterns[e1].position;
            }
            bind(t1) {
                const e1 = t1.gl;
                this.atlasTexture ? this.dirty && (this.atlasTexture.update(this.atlasImage), this.dirty = !1) : this.atlasTexture = new l(t1, this.atlasImage, e1.RGBA), this.atlasTexture.bind(e1.LINEAR, e1.CLAMP_TO_EDGE);
            }
            _updatePatternAtlas() {
                const e1 = [];
                for(const t2 in this.patterns)e1.push(this.patterns[t2].bin);
                const { w: i , h: o  } = t1.potpack(e1), a = this.atlasImage;
                a.resize({
                    width: i || 1,
                    height: o || 1
                });
                for(const e2 in this.patterns){
                    const { bin: i1  } = this.patterns[e2], o1 = i1.x + 1, r = i1.y + 1, s = this.images[e2].data, n = s.width, l = s.height;
                    t1.RGBAImage.copy(s, a, {
                        x: 0,
                        y: 0
                    }, {
                        x: o1,
                        y: r
                    }, {
                        width: n,
                        height: l
                    }), t1.RGBAImage.copy(s, a, {
                        x: 0,
                        y: l - 1
                    }, {
                        x: o1,
                        y: r - 1
                    }, {
                        width: n,
                        height: 1
                    }), t1.RGBAImage.copy(s, a, {
                        x: 0,
                        y: 0
                    }, {
                        x: o1,
                        y: r + l
                    }, {
                        width: n,
                        height: 1
                    }), t1.RGBAImage.copy(s, a, {
                        x: n - 1,
                        y: 0
                    }, {
                        x: o1 - 1,
                        y: r
                    }, {
                        width: 1,
                        height: l
                    }), t1.RGBAImage.copy(s, a, {
                        x: 0,
                        y: 0
                    }, {
                        x: o1 + n,
                        y: r
                    }, {
                        width: 1,
                        height: l
                    });
                }
                this.dirty = !0;
            }
            beginFrame() {
                this.callbackDispatchedThisFrame = {};
            }
            dispatchRenderCallbacks(e1) {
                for (const i of e1){
                    if (this.callbackDispatchedThisFrame[i]) continue;
                    this.callbackDispatchedThisFrame[i] = !0;
                    const e2 = this.images[i];
                    e2 || t1.warnOnce(`Image with ID: "${i}" was not found`), c(e2) && this.updateImage(i, e2);
                }
            }
        }
        const u = 1e20;
        function d(t1, e1, i, o, a, r, s, n, l) {
            for(let c = e1; c < e1 + o; c++)m(t1, i * r + c, r, a, s, n, l);
            for(let c1 = i; c1 < i + a; c1++)m(t1, c1 * r + e1, 1, o, s, n, l);
        }
        function m(t1, e1, i, o, a, r, s) {
            r[0] = 0, s[0] = -u, s[1] = u, a[0] = t1[e1];
            for(let n = 1, l = 0, c = 0; n < o; n++){
                a[n] = t1[e1 + n * i];
                const o1 = n * n;
                do {
                    const t2 = r[l];
                    c = (a[n] - a[t2] + o1 - t2 * t2) / (n - t2) / 2;
                }while (c <= s[l] && --l > -1);
                l++, r[l] = n, s[l] = c, s[l + 1] = u;
            }
            for(let n1 = 0, l1 = 0; n1 < o; n1++){
                for(; s[l1 + 1] < n1;)l1++;
                const o2 = r[l1], c1 = n1 - o2;
                t1[e1 + n1 * i] = a[o2] + c1 * c1;
            }
        }
        class _ {
            constructor(t1, e1){
                this.requestManager = t1, this.localIdeographFontFamily = e1, this.entries = {};
            }
            setURL(t1) {
                this.url = t1;
            }
            getGlyphs(e1, i) {
                const o = [];
                for(const t2 in e1)for (const i1 of e1[t2])o.push({
                    stack: t2,
                    id: i1
                });
                t1.asyncAll(o, ({ stack: t1 , id: e1  }, i)=>{
                    let o = this.entries[t1];
                    o || (o = this.entries[t1] = {
                        glyphs: {},
                        requests: {},
                        ranges: {}
                    });
                    let a = o.glyphs[e1];
                    if (void 0 !== a) return void i(null, {
                        stack: t1,
                        id: e1,
                        glyph: a
                    });
                    if (a = this._tinySDF(o, t1, e1), a) return o.glyphs[e1] = a, void i(null, {
                        stack: t1,
                        id: e1,
                        glyph: a
                    });
                    const r = Math.floor(e1 / 256);
                    if (256 * r > 65535) return void i(new Error("glyphs > 65535 not supported"));
                    if (o.ranges[r]) return void i(null, {
                        stack: t1,
                        id: e1,
                        glyph: a
                    });
                    let s = o.requests[r];
                    s || (s = o.requests[r] = [], _.loadGlyphRange(t1, r, this.url, this.requestManager, (t1, e1)=>{
                        if (e1) {
                            for(const t2 in e1)this._doesCharSupportLocalGlyph(+t2) || (o.glyphs[+t2] = e1[+t2]);
                            o.ranges[r] = !0;
                        }
                        for (const i of s)i(t1, e1);
                        delete o.requests[r];
                    })), s.push((o, a)=>{
                        o ? i(o) : a && i(null, {
                            stack: t1,
                            id: e1,
                            glyph: a[e1] || null
                        });
                    });
                }, (t1, e1)=>{
                    if (t1) i(t1);
                    else if (e1) {
                        const t2 = {};
                        for (const { stack: i1 , id: o , glyph: a  } of e1)(t2[i1] || (t2[i1] = {}))[o] = a && {
                            id: a.id,
                            bitmap: a.bitmap.clone(),
                            metrics: a.metrics
                        };
                        i(null, t2);
                    }
                });
            }
            _doesCharSupportLocalGlyph(e1) {
                return !!this.localIdeographFontFamily && (t1.unicodeBlockLookup["CJK Unified Ideographs"](e1) || t1.unicodeBlockLookup["Hangul Syllables"](e1) || t1.unicodeBlockLookup.Hiragana(e1) || t1.unicodeBlockLookup.Katakana(e1));
            }
            _tinySDF(e1, i, o) {
                const a = this.localIdeographFontFamily;
                if (!a) return;
                if (!this._doesCharSupportLocalGlyph(o)) return;
                let r = e1.tinySDF;
                if (!r) {
                    let t2 = "400";
                    /bold/i.test(i) ? t2 = "900" : /medium/i.test(i) ? t2 = "500" : /light/i.test(i) && (t2 = "200"), r = e1.tinySDF = new _.TinySDF({
                        fontSize: 24,
                        buffer: 3,
                        radius: 8,
                        cutoff: .25,
                        fontFamily: a,
                        fontWeight: t2
                    });
                }
                const s = r.draw(String.fromCharCode(o));
                return {
                    id: o,
                    bitmap: new t1.AlphaImage({
                        width: s.width || 30,
                        height: s.height || 30
                    }, s.data),
                    metrics: {
                        width: s.glyphWidth || 24,
                        height: s.glyphHeight || 24,
                        left: s.glyphLeft || 0,
                        top: s.glyphTop - 27 || -8,
                        advance: s.glyphAdvance || 24
                    }
                };
            }
        }
        _.loadGlyphRange = function(e1, i, o, a, r) {
            const s = 256 * i, n = s + 255, l = a.transformRequest(o.replace("{fontstack}", e1).replace("{range}", `${s}-${n}`), t1.ResourceType.Glyphs);
            t1.getArrayBuffer(l, (e1, i)=>{
                if (e1) r(e1);
                else if (i) {
                    const e2 = {};
                    for (const o of t1.parseGlyphPbf(i))e2[o.id] = o;
                    r(null, e2);
                }
            });
        }, _.TinySDF = class {
            constructor({ fontSize: t1 = 24 , buffer: e1 = 3 , radius: i = 8 , cutoff: o = .25 , fontFamily: a = "sans-serif" , fontWeight: r = "normal" , fontStyle: s = "normal"  } = {}){
                this.buffer = e1, this.cutoff = o, this.radius = i;
                const n = this.size = t1 + 4 * e1, l = this._createCanvas(n), c = this.ctx = l.getContext("2d", {
                    willReadFrequently: !0
                });
                c.font = `${s} ${r} ${t1}px ${a}`, c.textBaseline = "alphabetic", c.textAlign = "left", c.fillStyle = "black", this.gridOuter = new Float64Array(n * n), this.gridInner = new Float64Array(n * n), this.f = new Float64Array(n), this.z = new Float64Array(n + 1), this.v = new Uint16Array(n);
            }
            _createCanvas(t1) {
                const e1 = document.createElement("canvas");
                return e1.width = e1.height = t1, e1;
            }
            draw(t1) {
                const { width: e1 , actualBoundingBoxAscent: i , actualBoundingBoxDescent: o , actualBoundingBoxLeft: a , actualBoundingBoxRight: r  } = this.ctx.measureText(t1), s = Math.ceil(i), n = Math.min(this.size - this.buffer, Math.ceil(r - a)), l = Math.min(this.size - this.buffer, s + Math.ceil(o)), c = n + 2 * this.buffer, h = l + 2 * this.buffer, m = Math.max(c * h, 0), _ = new Uint8ClampedArray(m), p = {
                    data: _,
                    width: c,
                    height: h,
                    glyphWidth: n,
                    glyphHeight: l,
                    glyphTop: s,
                    glyphLeft: 0,
                    glyphAdvance: e1
                };
                if (0 === n || 0 === l) return p;
                const { ctx: f , buffer: g , gridInner: x , gridOuter: v  } = this;
                f.clearRect(g, g, n, l), f.fillText(t1, g, g + s);
                const y = f.getImageData(g, g, n, l);
                v.fill(u, 0, m), x.fill(0, 0, m);
                for(let t2 = 0; t2 < l; t2++)for(let e2 = 0; e2 < n; e2++){
                    const i1 = y.data[4 * (t2 * n + e2) + 3] / 255;
                    if (0 === i1) continue;
                    const o1 = (t2 + g) * c + e2 + g;
                    if (1 === i1) v[o1] = 0, x[o1] = u;
                    else {
                        const t3 = .5 - i1;
                        v[o1] = t3 > 0 ? t3 * t3 : 0, x[o1] = t3 < 0 ? t3 * t3 : 0;
                    }
                }
                d(v, 0, 0, c, h, c, this.f, this.v, this.z), d(x, g, g, n, l, c, this.f, this.v, this.z);
                for(let t4 = 0; t4 < m; t4++){
                    const e3 = Math.sqrt(v[t4]) - Math.sqrt(x[t4]);
                    _[t4] = Math.round(255 - 255 * (e3 / this.radius + this.cutoff));
                }
                return p;
            }
        };
        const p = new t1.Properties({
            anchor: new t1.DataConstantProperty(t1.spec.light.anchor),
            position: new class {
                constructor(){
                    this.specification = t1.spec.light.position;
                }
                possiblyEvaluate(e1, i) {
                    return t1.sphericalToCartesian(e1.expression.evaluate(i));
                }
                interpolate(e1, i, o) {
                    return {
                        x: t1.number(e1.x, i.x, o),
                        y: t1.number(e1.y, i.y, o),
                        z: t1.number(e1.z, i.z, o)
                    };
                }
            },
            color: new t1.DataConstantProperty(t1.spec.light.color),
            intensity: new t1.DataConstantProperty(t1.spec.light.intensity)
        }), f = "-transition";
        class g extends t1.Evented {
            constructor(e1){
                super(), this._transitionable = new t1.Transitionable(p), this.setLight(e1), this._transitioning = this._transitionable.untransitioned();
            }
            getLight() {
                return this._transitionable.serialize();
            }
            setLight(e1, i = {}) {
                if (!this._validate(t1.validateLight, e1, i)) for(const t2 in e1){
                    const i1 = e1[t2];
                    t2.endsWith(f) ? this._transitionable.setTransition(t2.slice(0, -f.length), i1) : this._transitionable.setValue(t2, i1);
                }
            }
            updateTransitions(t1) {
                this._transitioning = this._transitionable.transitioned(t1, this._transitioning);
            }
            hasTransition() {
                return this._transitioning.hasTransition();
            }
            recalculate(t1) {
                this.properties = this._transitioning.possiblyEvaluate(t1);
            }
            _validate(e1, i, o) {
                return (!o || !1 !== o.validate) && t1.emitValidationErrors(this, e1.call(t1.validateStyle, t1.extend({
                    value: i,
                    style: {
                        glyphs: !0,
                        sprite: !0
                    },
                    styleSpec: t1.spec
                })));
            }
        }
        class x {
            constructor(t1, e1){
                this.width = t1, this.height = e1, this.nextRow = 0, this.data = new Uint8Array(this.width * this.height), this.dashEntry = {};
            }
            getDash(t1, e1) {
                const i = t1.join(",") + String(e1);
                return this.dashEntry[i] || (this.dashEntry[i] = this.addDash(t1, e1)), this.dashEntry[i];
            }
            getDashRanges(t1, e1, i) {
                const o = [];
                let a = t1.length % 2 == 1 ? -t1[t1.length - 1] * i : 0, r = t1[0] * i, s = !0;
                o.push({
                    left: a,
                    right: r,
                    isDash: s,
                    zeroLength: 0 === t1[0]
                });
                let n = t1[0];
                for(let e2 = 1; e2 < t1.length; e2++){
                    s = !s;
                    const l = t1[e2];
                    a = n * i, n += l, r = n * i, o.push({
                        left: a,
                        right: r,
                        isDash: s,
                        zeroLength: 0 === l
                    });
                }
                return o;
            }
            addRoundDash(t1, e1, i) {
                const o = e1 / 2;
                for(let e2 = -i; e2 <= i; e2++){
                    const a = this.width * (this.nextRow + i + e2);
                    let r = 0, s = t1[r];
                    for(let n = 0; n < this.width; n++){
                        n / s.right > 1 && (s = t1[++r]);
                        const l = Math.abs(n - s.left), c = Math.abs(n - s.right), h = Math.min(l, c);
                        let u;
                        const d = e2 / i * (o + 1);
                        if (s.isDash) {
                            const t2 = o - Math.abs(d);
                            u = Math.sqrt(h * h + t2 * t2);
                        } else u = o - Math.sqrt(h * h + d * d);
                        this.data[a + n] = Math.max(0, Math.min(255, u + 128));
                    }
                }
            }
            addRegularDash(t1) {
                for(let e1 = t1.length - 1; e1 >= 0; --e1){
                    const i = t1[e1], o = t1[e1 + 1];
                    i.zeroLength ? t1.splice(e1, 1) : o && o.isDash === i.isDash && (o.left = i.left, t1.splice(e1, 1));
                }
                const e2 = t1[0], i1 = t1[t1.length - 1];
                e2.isDash === i1.isDash && (e2.left = i1.left - this.width, i1.right = e2.right + this.width);
                const o1 = this.width * this.nextRow;
                let a = 0, r = t1[a];
                for(let e3 = 0; e3 < this.width; e3++){
                    e3 / r.right > 1 && (r = t1[++a]);
                    const i2 = Math.abs(e3 - r.left), s = Math.abs(e3 - r.right), n = Math.min(i2, s);
                    this.data[o1 + e3] = Math.max(0, Math.min(255, (r.isDash ? n : -n) + 128));
                }
            }
            addDash(e1, i) {
                const o = i ? 7 : 0, a = 2 * o + 1;
                if (this.nextRow + a > this.height) return t1.warnOnce("LineAtlas out of space"), null;
                let r = 0;
                for(let t2 = 0; t2 < e1.length; t2++)r += e1[t2];
                if (0 !== r) {
                    const t3 = this.width / r, a1 = this.getDashRanges(e1, this.width, t3);
                    i ? this.addRoundDash(a1, t3, o) : this.addRegularDash(a1);
                }
                const s = {
                    y: (this.nextRow + o + .5) / this.height,
                    height: 2 * o / this.height,
                    width: r
                };
                return this.nextRow += a, this.dirty = !0, s;
            }
            bind(t1) {
                const e1 = t1.gl;
                this.texture ? (e1.bindTexture(e1.TEXTURE_2D, this.texture), this.dirty && (this.dirty = !1, e1.texSubImage2D(e1.TEXTURE_2D, 0, 0, 0, this.width, this.height, e1.ALPHA, e1.UNSIGNED_BYTE, this.data))) : (this.texture = e1.createTexture(), e1.bindTexture(e1.TEXTURE_2D, this.texture), e1.texParameteri(e1.TEXTURE_2D, e1.TEXTURE_WRAP_S, e1.REPEAT), e1.texParameteri(e1.TEXTURE_2D, e1.TEXTURE_WRAP_T, e1.REPEAT), e1.texParameteri(e1.TEXTURE_2D, e1.TEXTURE_MIN_FILTER, e1.LINEAR), e1.texParameteri(e1.TEXTURE_2D, e1.TEXTURE_MAG_FILTER, e1.LINEAR), e1.texImage2D(e1.TEXTURE_2D, 0, e1.ALPHA, this.width, this.height, 0, e1.ALPHA, e1.UNSIGNED_BYTE, this.data));
            }
        }
        class v {
            constructor(e1, i){
                this.workerPool = e1, this.actors = [], this.currentActor = 0, this.id = t1.uniqueId();
                const o = this.workerPool.acquire(this.id);
                for(let t2 = 0; t2 < o.length; t2++){
                    const e2 = new v.Actor(o[t2], i, this.id);
                    e2.name = `Worker ${t2}`, this.actors.push(e2);
                }
                if (!this.actors.length) throw new Error("No actors found");
            }
            broadcast(e1, i, o) {
                t1.asyncAll(this.actors, (t1, o)=>{
                    t1.send(e1, i, o);
                }, o = o || function() {});
            }
            getActor() {
                return this.currentActor = (this.currentActor + 1) % this.actors.length, this.actors[this.currentActor];
            }
            remove() {
                this.actors.forEach((t1)=>{
                    t1.remove();
                }), this.actors = [], this.workerPool.release(this.id);
            }
        }
        function y(e1, i, o) {
            const a = function(i, a) {
                if (i) return o(i);
                if (a) {
                    const i1 = t1.pick(t1.extend(a, e1), [
                        "tiles",
                        "minzoom",
                        "maxzoom",
                        "attribution",
                        "bounds",
                        "scheme",
                        "tileSize",
                        "encoding"
                    ]);
                    a.vector_layers && (i1.vectorLayers = a.vector_layers, i1.vectorLayerIds = i1.vectorLayers.map((t1)=>t1.id)), o(null, i1);
                }
            };
            return e1.url ? t1.getJSON(i.transformRequest(e1.url, t1.ResourceType.Source), a) : t1.exported.frame(()=>a(null, e1));
        }
        v.Actor = t1.Actor;
        class b {
            constructor(e1, i, o){
                this.bounds = t1.LngLatBounds.convert(this.validateBounds(e1)), this.minzoom = i || 0, this.maxzoom = o || 24;
            }
            validateBounds(t1) {
                return Array.isArray(t1) && 4 === t1.length ? [
                    Math.max(-180, t1[0]),
                    Math.max(-90, t1[1]),
                    Math.min(180, t1[2]),
                    Math.min(90, t1[3])
                ] : [
                    -180,
                    -90,
                    180,
                    90
                ];
            }
            contains(e1) {
                const i = Math.pow(2, e1.z), o = Math.floor(t1.mercatorXfromLng(this.bounds.getWest()) * i), a = Math.floor(t1.mercatorYfromLat(this.bounds.getNorth()) * i), r = Math.ceil(t1.mercatorXfromLng(this.bounds.getEast()) * i), s = Math.ceil(t1.mercatorYfromLat(this.bounds.getSouth()) * i);
                return e1.x >= o && e1.x < r && e1.y >= a && e1.y < s;
            }
        }
        class w extends t1.Evented {
            constructor(e1, i, o, a){
                if (super(), this.id = e1, this.dispatcher = o, this.type = "vector", this.minzoom = 0, this.maxzoom = 22, this.scheme = "xyz", this.tileSize = 512, this.reparseOverscaled = !0, this.isTileClipped = !0, this._loaded = !1, t1.extend(this, t1.pick(i, [
                    "url",
                    "scheme",
                    "tileSize",
                    "promoteId"
                ])), this._options = t1.extend({
                    type: "vector"
                }, i), this._collectResourceTiming = i.collectResourceTiming, 512 !== this.tileSize) throw new Error("vector tile sources must have a tileSize of 512");
                this.setEventedParent(a);
            }
            load() {
                this._loaded = !1, this.fire(new t1.Event("dataloading", {
                    dataType: "source"
                })), this._tileJSONRequest = y(this._options, this.map._requestManager, (e1, i)=>{
                    this._tileJSONRequest = null, this._loaded = !0, this.map.style.sourceCaches[this.id].clearTiles(), e1 ? this.fire(new t1.ErrorEvent(e1)) : i && (t1.extend(this, i), i.bounds && (this.tileBounds = new b(i.bounds, this.minzoom, this.maxzoom)), this.fire(new t1.Event("data", {
                        dataType: "source",
                        sourceDataType: "metadata"
                    })), this.fire(new t1.Event("data", {
                        dataType: "source",
                        sourceDataType: "content"
                    })));
                });
            }
            loaded() {
                return this._loaded;
            }
            hasTile(t1) {
                return !this.tileBounds || this.tileBounds.contains(t1.canonical);
            }
            onAdd(t1) {
                this.map = t1, this.load();
            }
            setSourceProperty(t1) {
                this._tileJSONRequest && this._tileJSONRequest.cancel(), t1(), this.load();
            }
            setTiles(t1) {
                return this.setSourceProperty(()=>{
                    this._options.tiles = t1;
                }), this;
            }
            setUrl(t1) {
                return this.setSourceProperty(()=>{
                    this.url = t1, this._options.url = t1;
                }), this;
            }
            onRemove() {
                this._tileJSONRequest && (this._tileJSONRequest.cancel(), this._tileJSONRequest = null);
            }
            serialize() {
                return t1.extend({}, this._options);
            }
            loadTile(e1, i) {
                const o = e1.tileID.canonical.url(this.tiles, this.map.getPixelRatio(), this.scheme), a = {
                    request: this.map._requestManager.transformRequest(o, t1.ResourceType.Tile),
                    uid: e1.uid,
                    tileID: e1.tileID,
                    zoom: e1.tileID.overscaledZ,
                    tileSize: this.tileSize * e1.tileID.overscaleFactor(),
                    type: this.type,
                    source: this.id,
                    pixelRatio: this.map.getPixelRatio(),
                    showCollisionBoxes: this.map.showCollisionBoxes,
                    promoteId: this.promoteId
                };
                function r(o, a) {
                    return delete e1.request, e1.aborted ? i(null) : o && 404 !== o.status ? i(o) : (a && a.resourceTiming && (e1.resourceTiming = a.resourceTiming), this.map._refreshExpiredTiles && a && e1.setExpiryData(a), e1.loadVectorData(a, this.map.painter), t1.cacheEntryPossiblyAdded(this.dispatcher), i(null), void (e1.reloadCallback && (this.loadTile(e1, e1.reloadCallback), e1.reloadCallback = null)));
                }
                a.request.collectResourceTiming = this._collectResourceTiming, e1.actor && "expired" !== e1.state ? "loading" === e1.state ? e1.reloadCallback = i : e1.request = e1.actor.send("reloadTile", a, r.bind(this)) : (e1.actor = this.dispatcher.getActor(), e1.request = e1.actor.send("loadTile", a, r.bind(this)));
            }
            abortTile(t1) {
                t1.request && (t1.request.cancel(), delete t1.request), t1.actor && t1.actor.send("abortTile", {
                    uid: t1.uid,
                    type: this.type,
                    source: this.id
                }, void 0);
            }
            unloadTile(t1) {
                t1.unloadVectorData(), t1.actor && t1.actor.send("removeTile", {
                    uid: t1.uid,
                    type: this.type,
                    source: this.id
                }, void 0);
            }
            hasTransition() {
                return !1;
            }
        }
        class T extends t1.Evented {
            constructor(e1, i, o, a){
                super(), this.id = e1, this.dispatcher = o, this.setEventedParent(a), this.type = "raster", this.minzoom = 0, this.maxzoom = 22, this.roundZoom = !0, this.scheme = "xyz", this.tileSize = 512, this._loaded = !1, this._options = t1.extend({
                    type: "raster"
                }, i), t1.extend(this, t1.pick(i, [
                    "url",
                    "scheme",
                    "tileSize"
                ]));
            }
            load() {
                this._loaded = !1, this.fire(new t1.Event("dataloading", {
                    dataType: "source"
                })), this._tileJSONRequest = y(this._options, this.map._requestManager, (e1, i)=>{
                    this._tileJSONRequest = null, this._loaded = !0, e1 ? this.fire(new t1.ErrorEvent(e1)) : i && (t1.extend(this, i), i.bounds && (this.tileBounds = new b(i.bounds, this.minzoom, this.maxzoom)), this.fire(new t1.Event("data", {
                        dataType: "source",
                        sourceDataType: "metadata"
                    })), this.fire(new t1.Event("data", {
                        dataType: "source",
                        sourceDataType: "content"
                    })));
                });
            }
            loaded() {
                return this._loaded;
            }
            onAdd(t1) {
                this.map = t1, this.load();
            }
            onRemove() {
                this._tileJSONRequest && (this._tileJSONRequest.cancel(), this._tileJSONRequest = null);
            }
            serialize() {
                return t1.extend({}, this._options);
            }
            hasTile(t1) {
                return !this.tileBounds || this.tileBounds.contains(t1.canonical);
            }
            loadTile(e1, i) {
                const o = e1.tileID.canonical.url(this.tiles, this.map.getPixelRatio(), this.scheme);
                e1.request = t1.getImage(this.map._requestManager.transformRequest(o, t1.ResourceType.Tile), (o, a, r)=>{
                    if (delete e1.request, e1.aborted) e1.state = "unloaded", i(null);
                    else if (o) e1.state = "errored", i(o);
                    else if (a) {
                        this.map._refreshExpiredTiles && e1.setExpiryData(r);
                        const o1 = this.map.painter.context, s = o1.gl;
                        e1.texture = this.map.painter.getTileTexture(a.width), e1.texture ? e1.texture.update(a, {
                            useMipmap: !0
                        }) : (e1.texture = new l(o1, a, s.RGBA, {
                            useMipmap: !0
                        }), e1.texture.bind(s.LINEAR, s.CLAMP_TO_EDGE, s.LINEAR_MIPMAP_NEAREST), o1.extTextureFilterAnisotropic && s.texParameterf(s.TEXTURE_2D, o1.extTextureFilterAnisotropic.TEXTURE_MAX_ANISOTROPY_EXT, o1.extTextureFilterAnisotropicMax)), e1.state = "loaded", t1.cacheEntryPossiblyAdded(this.dispatcher), i(null);
                    }
                });
            }
            abortTile(t1, e1) {
                t1.request && (t1.request.cancel(), delete t1.request), e1();
            }
            unloadTile(t1, e1) {
                t1.texture && this.map.painter.saveTileTexture(t1.texture), e1();
            }
            hasTransition() {
                return !1;
            }
        }
        let E;
        class I extends T {
            constructor(e1, i, o, a){
                super(e1, i, o, a), this.type = "raster-dem", this.maxzoom = 22, this._options = t1.extend({
                    type: "raster-dem"
                }, i), this.encoding = i.encoding || "mapbox";
            }
            serialize() {
                return {
                    type: "raster-dem",
                    url: this.url,
                    tileSize: this.tileSize,
                    tiles: this.tiles,
                    bounds: this.bounds,
                    encoding: this.encoding
                };
            }
            loadTile(e1, i) {
                const o = e1.tileID.canonical.url(this.tiles, this.map.getPixelRatio(), this.scheme);
                function a(t1, o) {
                    t1 && (e1.state = "errored", i(t1)), o && (e1.dem = o, e1.needsHillshadePrepare = !0, e1.needsTerrainPrepare = !0, e1.state = "loaded", i(null));
                }
                e1.request = t1.getImage(this.map._requestManager.transformRequest(o, t1.ResourceType.Tile), (function(o, r) {
                    if (delete e1.request, e1.aborted) e1.state = "unloaded", i(null);
                    else if (o) e1.state = "errored", i(o);
                    else if (r) {
                        this.map._refreshExpiredTiles && e1.setExpiryData(r), delete r.cacheControl, delete r.expires;
                        const i1 = t1.isImageBitmap(r) && (null == E && (E = "undefined" != typeof OffscreenCanvas && new OffscreenCanvas(1, 1).getContext("2d") && "function" == typeof createImageBitmap), E) ? r : t1.exported.getImageData(r, 1), o1 = {
                            uid: e1.uid,
                            coord: e1.tileID,
                            source: this.id,
                            rawImageData: i1,
                            encoding: this.encoding
                        };
                        e1.actor && "expired" !== e1.state || (e1.actor = this.dispatcher.getActor(), e1.actor.send("loadDEMTile", o1, a.bind(this)));
                    }
                }).bind(this)), e1.neighboringTiles = this._getNeighboringTiles(e1.tileID);
            }
            _getNeighboringTiles(e1) {
                const i = e1.canonical, o = Math.pow(2, i.z), a = (i.x - 1 + o) % o, r = 0 === i.x ? e1.wrap - 1 : e1.wrap, s = (i.x + 1 + o) % o, n = i.x + 1 === o ? e1.wrap + 1 : e1.wrap, l = {};
                return l[new t1.OverscaledTileID(e1.overscaledZ, r, i.z, a, i.y).key] = {
                    backfilled: !1
                }, l[new t1.OverscaledTileID(e1.overscaledZ, n, i.z, s, i.y).key] = {
                    backfilled: !1
                }, i.y > 0 && (l[new t1.OverscaledTileID(e1.overscaledZ, r, i.z, a, i.y - 1).key] = {
                    backfilled: !1
                }, l[new t1.OverscaledTileID(e1.overscaledZ, e1.wrap, i.z, i.x, i.y - 1).key] = {
                    backfilled: !1
                }, l[new t1.OverscaledTileID(e1.overscaledZ, n, i.z, s, i.y - 1).key] = {
                    backfilled: !1
                }), i.y + 1 < o && (l[new t1.OverscaledTileID(e1.overscaledZ, r, i.z, a, i.y + 1).key] = {
                    backfilled: !1
                }, l[new t1.OverscaledTileID(e1.overscaledZ, e1.wrap, i.z, i.x, i.y + 1).key] = {
                    backfilled: !1
                }, l[new t1.OverscaledTileID(e1.overscaledZ, n, i.z, s, i.y + 1).key] = {
                    backfilled: !1
                }), l;
            }
            unloadTile(t1) {
                t1.demTexture && this.map.painter.saveTileTexture(t1.demTexture), t1.fbo && (t1.fbo.destroy(), delete t1.fbo), t1.dem && delete t1.dem, delete t1.neighboringTiles, t1.state = "unloaded", t1.actor && t1.actor.send("removeDEMTile", {
                    uid: t1.uid,
                    source: this.id
                });
            }
        }
        class C extends t1.Evented {
            constructor(e1, i, o, a){
                super(), this.id = e1, this.type = "geojson", this.minzoom = 0, this.maxzoom = 18, this.tileSize = 512, this.isTileClipped = !0, this.reparseOverscaled = !0, this._removed = !1, this._pendingLoads = 0, this.actor = o.getActor(), this.setEventedParent(a), this._data = i.data, this._options = t1.extend({}, i), this._collectResourceTiming = i.collectResourceTiming, void 0 !== i.maxzoom && (this.maxzoom = i.maxzoom), i.type && (this.type = i.type), i.attribution && (this.attribution = i.attribution), this.promoteId = i.promoteId;
                const r = t1.EXTENT / this.tileSize;
                this.workerOptions = t1.extend({
                    source: this.id,
                    cluster: i.cluster || !1,
                    geojsonVtOptions: {
                        buffer: (void 0 !== i.buffer ? i.buffer : 128) * r,
                        tolerance: (void 0 !== i.tolerance ? i.tolerance : .375) * r,
                        extent: t1.EXTENT,
                        maxZoom: this.maxzoom,
                        lineMetrics: i.lineMetrics || !1,
                        generateId: i.generateId || !1
                    },
                    superclusterOptions: {
                        maxZoom: void 0 !== i.clusterMaxZoom ? i.clusterMaxZoom : this.maxzoom - 1,
                        minPoints: Math.max(2, i.clusterMinPoints || 2),
                        extent: t1.EXTENT,
                        radius: (i.clusterRadius || 50) * r,
                        log: !1,
                        generateId: i.generateId || !1
                    },
                    clusterProperties: i.clusterProperties,
                    filter: i.filter
                }, i.workerOptions);
            }
            load() {
                this._updateWorkerData("metadata");
            }
            onAdd(t1) {
                this.map = t1, this.load();
            }
            setData(t1) {
                return this._data = t1, this._updateWorkerData("content"), this;
            }
            getClusterExpansionZoom(t1, e1) {
                return this.actor.send("geojson.getClusterExpansionZoom", {
                    clusterId: t1,
                    source: this.id
                }, e1), this;
            }
            getClusterChildren(t1, e1) {
                return this.actor.send("geojson.getClusterChildren", {
                    clusterId: t1,
                    source: this.id
                }, e1), this;
            }
            getClusterLeaves(t1, e1, i, o) {
                return this.actor.send("geojson.getClusterLeaves", {
                    source: this.id,
                    clusterId: t1,
                    limit: e1,
                    offset: i
                }, o), this;
            }
            _updateWorkerData(e1) {
                const i = t1.extend({}, this.workerOptions), o = this._data;
                "string" == typeof o ? (i.request = this.map._requestManager.transformRequest(t1.exported.resolveURL(o), t1.ResourceType.Source), i.request.collectResourceTiming = this._collectResourceTiming) : i.data = JSON.stringify(o), this._pendingLoads++, this.fire(new t1.Event("dataloading", {
                    dataType: "source"
                })), this.actor.send(`${this.type}.loadData`, i, (i, o)=>{
                    if (this._pendingLoads--, this._removed || o && o.abandoned) return void this.fire(new t1.Event("dataabort", {
                        dataType: "source",
                        sourceDataType: e1
                    }));
                    let a = null;
                    if (o && o.resourceTiming && o.resourceTiming[this.id] && (a = o.resourceTiming[this.id].slice(0)), i) return void this.fire(new t1.ErrorEvent(i));
                    const r = {
                        dataType: "source",
                        sourceDataType: e1
                    };
                    this._collectResourceTiming && a && a.length > 0 && t1.extend(r, {
                        resourceTiming: a
                    }), this.fire(new t1.Event("data", r));
                });
            }
            loaded() {
                return 0 === this._pendingLoads;
            }
            loadTile(t1, e1) {
                const i = t1.actor ? "reloadTile" : "loadTile";
                t1.actor = this.actor;
                const o = {
                    type: this.type,
                    uid: t1.uid,
                    tileID: t1.tileID,
                    zoom: t1.tileID.overscaledZ,
                    maxZoom: this.maxzoom,
                    tileSize: this.tileSize,
                    source: this.id,
                    pixelRatio: this.map.getPixelRatio(),
                    showCollisionBoxes: this.map.showCollisionBoxes,
                    promoteId: this.promoteId
                };
                t1.request = this.actor.send(i, o, (o, a)=>(delete t1.request, t1.unloadVectorData(), t1.aborted ? e1(null) : o ? e1(o) : (t1.loadVectorData(a, this.map.painter, "reloadTile" === i), e1(null))));
            }
            abortTile(t1) {
                t1.request && (t1.request.cancel(), delete t1.request), t1.aborted = !0;
            }
            unloadTile(t1) {
                t1.unloadVectorData(), this.actor.send("removeTile", {
                    uid: t1.uid,
                    type: this.type,
                    source: this.id
                });
            }
            onRemove() {
                this._removed = !0, this.actor.send("removeSource", {
                    type: this.type,
                    source: this.id
                });
            }
            serialize() {
                return t1.extend({}, this._options, {
                    type: this.type,
                    data: this._data
                });
            }
            hasTransition() {
                return !1;
            }
        }
        var S = t1.createLayout([
            {
                name: "a_pos",
                type: "Int16",
                components: 2
            },
            {
                name: "a_texture_pos",
                type: "Int16",
                components: 2
            }
        ]);
        class D extends t1.Evented {
            constructor(t1, e1, i, o){
                super(), this.id = t1, this.dispatcher = i, this.coordinates = e1.coordinates, this.type = "image", this.minzoom = 0, this.maxzoom = 22, this.tileSize = 512, this.tiles = {}, this._loaded = !1, this.setEventedParent(o), this.options = e1;
            }
            load(e1, i) {
                this._loaded = !1, this.fire(new t1.Event("dataloading", {
                    dataType: "source"
                })), this.url = this.options.url, t1.getImage(this.map._requestManager.transformRequest(this.url, t1.ResourceType.Image), (o, a)=>{
                    this._loaded = !0, o ? this.fire(new t1.ErrorEvent(o)) : a && (this.image = a, e1 && (this.coordinates = e1), i && i(), this._finishLoading());
                });
            }
            loaded() {
                return this._loaded;
            }
            updateImage(t1) {
                return this.image && t1.url ? (this.options.url = t1.url, this.load(t1.coordinates, ()=>{
                    this.texture = null;
                }), this) : this;
            }
            _finishLoading() {
                this.map && (this.setCoordinates(this.coordinates), this.fire(new t1.Event("data", {
                    dataType: "source",
                    sourceDataType: "metadata"
                })));
            }
            onAdd(t1) {
                this.map = t1, this.load();
            }
            setCoordinates(e1) {
                this.coordinates = e1;
                const i = e1.map(t1.MercatorCoordinate.fromLngLat);
                this.tileID = function(e1) {
                    let i = 1 / 0, o = 1 / 0, a = -1 / 0, r = -1 / 0;
                    for (const t2 of e1)i = Math.min(i, t2.x), o = Math.min(o, t2.y), a = Math.max(a, t2.x), r = Math.max(r, t2.y);
                    const s = Math.max(a - i, r - o), n = Math.max(0, Math.floor(-Math.log(s) / Math.LN2)), l = Math.pow(2, n);
                    return new t1.CanonicalTileID(n, Math.floor((i + a) / 2 * l), Math.floor((o + r) / 2 * l));
                }(i), this.minzoom = this.maxzoom = this.tileID.z;
                const o = i.map((t1)=>this.tileID.getTilePoint(t1)._round());
                return this._boundsArray = new t1.RasterBoundsArray, this._boundsArray.emplaceBack(o[0].x, o[0].y, 0, 0), this._boundsArray.emplaceBack(o[1].x, o[1].y, t1.EXTENT, 0), this._boundsArray.emplaceBack(o[3].x, o[3].y, 0, t1.EXTENT), this._boundsArray.emplaceBack(o[2].x, o[2].y, t1.EXTENT, t1.EXTENT), this.boundsBuffer && (this.boundsBuffer.destroy(), delete this.boundsBuffer), this.fire(new t1.Event("data", {
                    dataType: "source",
                    sourceDataType: "content"
                })), this;
            }
            prepare() {
                if (0 === Object.keys(this.tiles).length || !this.image) return;
                const e1 = this.map.painter.context, i = e1.gl;
                this.boundsBuffer || (this.boundsBuffer = e1.createVertexBuffer(this._boundsArray, S.members)), this.boundsSegments || (this.boundsSegments = t1.SegmentVector.simpleSegment(0, 0, 4, 2)), this.texture || (this.texture = new l(e1, this.image, i.RGBA), this.texture.bind(i.LINEAR, i.CLAMP_TO_EDGE));
                for(const t2 in this.tiles){
                    const e2 = this.tiles[t2];
                    "loaded" !== e2.state && (e2.state = "loaded", e2.texture = this.texture);
                }
            }
            loadTile(t1, e1) {
                this.tileID && this.tileID.equals(t1.tileID.canonical) ? (this.tiles[String(t1.tileID.wrap)] = t1, t1.buckets = {}, e1(null)) : (t1.state = "errored", e1(null));
            }
            serialize() {
                return {
                    type: "image",
                    url: this.options.url,
                    coordinates: this.coordinates
                };
            }
            hasTransition() {
                return !1;
            }
        }
        class z extends D {
            constructor(t1, e1, i, o){
                super(t1, e1, i, o), this.roundZoom = !0, this.type = "video", this.options = e1;
            }
            load() {
                this._loaded = !1;
                const e1 = this.options;
                this.urls = [];
                for (const i of e1.urls)this.urls.push(this.map._requestManager.transformRequest(i, t1.ResourceType.Source).url);
                t1.getVideo(this.urls, (e1, i)=>{
                    this._loaded = !0, e1 ? this.fire(new t1.ErrorEvent(e1)) : i && (this.video = i, this.video.loop = !0, this.video.addEventListener("playing", ()=>{
                        this.map.triggerRepaint();
                    }), this.map && this.video.play(), this._finishLoading());
                });
            }
            pause() {
                this.video && this.video.pause();
            }
            play() {
                this.video && this.video.play();
            }
            seek(e1) {
                if (this.video) {
                    const i = this.video.seekable;
                    e1 < i.start(0) || e1 > i.end(0) ? this.fire(new t1.ErrorEvent(new t1.ValidationError(`sources.${this.id}`, null, `Playback for this video can be set only between the ${i.start(0)} and ${i.end(0)}-second mark.`))) : this.video.currentTime = e1;
                }
            }
            getVideo() {
                return this.video;
            }
            onAdd(t1) {
                this.map || (this.map = t1, this.load(), this.video && (this.video.play(), this.setCoordinates(this.coordinates)));
            }
            prepare() {
                if (0 === Object.keys(this.tiles).length || this.video.readyState < 2) return;
                const e1 = this.map.painter.context, i = e1.gl;
                this.boundsBuffer || (this.boundsBuffer = e1.createVertexBuffer(this._boundsArray, S.members)), this.boundsSegments || (this.boundsSegments = t1.SegmentVector.simpleSegment(0, 0, 4, 2)), this.texture ? this.video.paused || (this.texture.bind(i.LINEAR, i.CLAMP_TO_EDGE), i.texSubImage2D(i.TEXTURE_2D, 0, 0, 0, i.RGBA, i.UNSIGNED_BYTE, this.video)) : (this.texture = new l(e1, this.video, i.RGBA), this.texture.bind(i.LINEAR, i.CLAMP_TO_EDGE));
                for(const t2 in this.tiles){
                    const e2 = this.tiles[t2];
                    "loaded" !== e2.state && (e2.state = "loaded", e2.texture = this.texture);
                }
            }
            serialize() {
                return {
                    type: "video",
                    urls: this.urls,
                    coordinates: this.coordinates
                };
            }
            hasTransition() {
                return this.video && !this.video.paused;
            }
        }
        class P extends D {
            constructor(e1, i, o, a){
                super(e1, i, o, a), i.coordinates ? Array.isArray(i.coordinates) && 4 === i.coordinates.length && !i.coordinates.some((t1)=>!Array.isArray(t1) || 2 !== t1.length || t1.some((t1)=>"number" != typeof t1)) || this.fire(new t1.ErrorEvent(new t1.ValidationError(`sources.${e1}`, null, '"coordinates" property must be an array of 4 longitude/latitude array pairs'))) : this.fire(new t1.ErrorEvent(new t1.ValidationError(`sources.${e1}`, null, 'missing required property "coordinates"'))), i.animate && "boolean" != typeof i.animate && this.fire(new t1.ErrorEvent(new t1.ValidationError(`sources.${e1}`, null, 'optional "animate" property must be a boolean value'))), i.canvas ? "string" == typeof i.canvas || i.canvas instanceof HTMLCanvasElement || this.fire(new t1.ErrorEvent(new t1.ValidationError(`sources.${e1}`, null, '"canvas" must be either a string representing the ID of the canvas element from which to read, or an HTMLCanvasElement instance'))) : this.fire(new t1.ErrorEvent(new t1.ValidationError(`sources.${e1}`, null, 'missing required property "canvas"'))), this.options = i, this.animate = void 0 === i.animate || i.animate;
            }
            load() {
                this._loaded = !0, this.canvas || (this.canvas = this.options.canvas instanceof HTMLCanvasElement ? this.options.canvas : document.getElementById(this.options.canvas)), this.width = this.canvas.width, this.height = this.canvas.height, this._hasInvalidDimensions() ? this.fire(new t1.ErrorEvent(new Error("Canvas dimensions cannot be less than or equal to zero."))) : (this.play = function() {
                    this._playing = !0, this.map.triggerRepaint();
                }, this.pause = function() {
                    this._playing && (this.prepare(), this._playing = !1);
                }, this._finishLoading());
            }
            getCanvas() {
                return this.canvas;
            }
            onAdd(t1) {
                this.map = t1, this.load(), this.canvas && this.animate && this.play();
            }
            onRemove() {
                this.pause();
            }
            prepare() {
                let e1 = !1;
                if (this.canvas.width !== this.width && (this.width = this.canvas.width, e1 = !0), this.canvas.height !== this.height && (this.height = this.canvas.height, e1 = !0), this._hasInvalidDimensions()) return;
                if (0 === Object.keys(this.tiles).length) return;
                const i = this.map.painter.context, o = i.gl;
                this.boundsBuffer || (this.boundsBuffer = i.createVertexBuffer(this._boundsArray, S.members)), this.boundsSegments || (this.boundsSegments = t1.SegmentVector.simpleSegment(0, 0, 4, 2)), this.texture ? (e1 || this._playing) && this.texture.update(this.canvas, {
                    premultiply: !0
                }) : this.texture = new l(i, this.canvas, o.RGBA, {
                    premultiply: !0
                });
                for(const t2 in this.tiles){
                    const e2 = this.tiles[t2];
                    "loaded" !== e2.state && (e2.state = "loaded", e2.texture = this.texture);
                }
            }
            serialize() {
                return {
                    type: "canvas",
                    coordinates: this.coordinates
                };
            }
            hasTransition() {
                return this._playing;
            }
            _hasInvalidDimensions() {
                for (const t1 of [
                    this.canvas.width,
                    this.canvas.height
                ])if (isNaN(t1) || t1 <= 0) return !0;
                return !1;
            }
        }
        const M = {
            vector: w,
            raster: T,
            "raster-dem": I,
            geojson: C,
            video: z,
            image: D,
            canvas: P
        };
        function A(e1, i) {
            const o = t1.create();
            return t1.translate(o, o, [
                1,
                1,
                0
            ]), t1.scale(o, o, [
                .5 * e1.width,
                .5 * e1.height,
                1
            ]), t1.multiply(o, o, e1.calculatePosMatrix(i.toUnwrapped()));
        }
        function L(t1, e1, i, o, a, r) {
            const s = function(t1, e1, i) {
                if (t1) for (const o of t1){
                    const t2 = e1[o];
                    if (t2 && t2.source === i && "fill-extrusion" === t2.type) return !0;
                }
                else for(const t3 in e1){
                    const o1 = e1[t3];
                    if (o1.source === i && "fill-extrusion" === o1.type) return !0;
                }
                return !1;
            }(a && a.layers, e1, t1.id), n = r.maxPitchScaleFactor(), l = t1.tilesIn(o, n, s);
            l.sort(R);
            const c = [];
            for (const o1 of l)c.push({
                wrappedTileID: o1.tileID.wrapped().key,
                queryResults: o1.tile.queryRenderedFeatures(e1, i, t1._state, o1.queryGeometry, o1.cameraQueryGeometry, o1.scale, a, r, n, A(t1.transform, o1.tileID))
            });
            const h = function(t1) {
                const e1 = {}, i = {};
                for (const o of t1){
                    const t2 = o.queryResults, a = o.wrappedTileID, r = i[a] = i[a] || {};
                    for(const i1 in t2){
                        const o1 = t2[i1], a1 = r[i1] = r[i1] || {}, s = e1[i1] = e1[i1] || [];
                        for (const t3 of o1)a1[t3.featureIndex] || (a1[t3.featureIndex] = !0, s.push(t3));
                    }
                }
                return e1;
            }(c);
            for(const e2 in h)h[e2].forEach((e1)=>{
                const i = e1.feature, o = t1.getFeatureState(i.layer["source-layer"], i.id);
                i.source = i.layer.source, i.layer["source-layer"] && (i.sourceLayer = i.layer["source-layer"]), i.state = o;
            });
            return h;
        }
        function R(t1, e1) {
            const i = t1.tileID, o = e1.tileID;
            return i.overscaledZ - o.overscaledZ || i.canonical.y - o.canonical.y || i.wrap - o.wrap || i.canonical.x - o.canonical.x;
        }
        class k {
            constructor(e1, i){
                this.tileID = e1, this.uid = t1.uniqueId(), this.uses = 0, this.tileSize = i, this.buckets = {}, this.expirationTime = null, this.queryPadding = 0, this.hasSymbolBuckets = !1, this.hasRTLText = !1, this.dependencies = {}, this.textures = [], this.textureCoords = {}, this.expiredRequestCount = 0, this.state = "loading";
            }
            registerFadeDuration(e1) {
                const i = e1 + this.timeAdded;
                i < t1.exported.now() || this.fadeEndTime && i < this.fadeEndTime || (this.fadeEndTime = i);
            }
            wasRequested() {
                return "errored" === this.state || "loaded" === this.state || "reloading" === this.state;
            }
            clearTextures(t1) {
                this.demTexture && t1.saveTileTexture(this.demTexture), this.textures.forEach((e1)=>t1.saveTileTexture(e1)), this.demTexture = null, this.textures = [], this.textureCoords = {};
            }
            loadVectorData(e1, i, o) {
                if (this.hasData() && this.unloadVectorData(), this.state = "loaded", e1) {
                    e1.featureIndex && (this.latestFeatureIndex = e1.featureIndex, e1.rawTileData ? (this.latestRawTileData = e1.rawTileData, this.latestFeatureIndex.rawTileData = e1.rawTileData) : this.latestRawTileData && (this.latestFeatureIndex.rawTileData = this.latestRawTileData)), this.collisionBoxArray = e1.collisionBoxArray, this.buckets = function(t1, e1) {
                        const i = {};
                        if (!e1) return i;
                        for (const o of t1){
                            const t2 = o.layerIds.map((t1)=>e1.getLayer(t1)).filter(Boolean);
                            if (0 !== t2.length) {
                                o.layers = t2, o.stateDependentLayerIds && (o.stateDependentLayers = o.stateDependentLayerIds.map((e1)=>t2.filter((t1)=>t1.id === e1)[0]));
                                for (const e2 of t2)i[e2.id] = o;
                            }
                        }
                        return i;
                    }(e1.buckets, i.style), this.hasSymbolBuckets = !1;
                    for(const e2 in this.buckets){
                        const i1 = this.buckets[e2];
                        if (i1 instanceof t1.SymbolBucket) {
                            if (this.hasSymbolBuckets = !0, !o) break;
                            i1.justReloaded = !0;
                        }
                    }
                    if (this.hasRTLText = !1, this.hasSymbolBuckets) for(const e3 in this.buckets){
                        const i2 = this.buckets[e3];
                        if (i2 instanceof t1.SymbolBucket && i2.hasRTLText) {
                            this.hasRTLText = !0, t1.lazyLoadRTLTextPlugin();
                            break;
                        }
                    }
                    this.queryPadding = 0;
                    for(const t2 in this.buckets){
                        const e4 = this.buckets[t2];
                        this.queryPadding = Math.max(this.queryPadding, i.style.getLayer(t2).queryRadius(e4));
                    }
                    e1.imageAtlas && (this.imageAtlas = e1.imageAtlas), e1.glyphAtlasImage && (this.glyphAtlasImage = e1.glyphAtlasImage);
                } else this.collisionBoxArray = new t1.CollisionBoxArray;
            }
            unloadVectorData() {
                for(const t1 in this.buckets)this.buckets[t1].destroy();
                this.buckets = {}, this.imageAtlasTexture && this.imageAtlasTexture.destroy(), this.imageAtlas && (this.imageAtlas = null), this.glyphAtlasTexture && this.glyphAtlasTexture.destroy(), this.latestFeatureIndex = null, this.state = "unloaded";
            }
            getBucket(t1) {
                return this.buckets[t1.id];
            }
            upload(t1) {
                for(const e1 in this.buckets){
                    const i = this.buckets[e1];
                    i.uploadPending() && i.upload(t1);
                }
                const e2 = t1.gl;
                this.imageAtlas && !this.imageAtlas.uploaded && (this.imageAtlasTexture = new l(t1, this.imageAtlas.image, e2.RGBA), this.imageAtlas.uploaded = !0), this.glyphAtlasImage && (this.glyphAtlasTexture = new l(t1, this.glyphAtlasImage, e2.ALPHA), this.glyphAtlasImage = null);
            }
            prepare(t1) {
                this.imageAtlas && this.imageAtlas.patchUpdatedImages(t1, this.imageAtlasTexture);
            }
            queryRenderedFeatures(t1, e1, i, o, a, r, s, n, l, c) {
                return this.latestFeatureIndex && this.latestFeatureIndex.rawTileData ? this.latestFeatureIndex.query({
                    queryGeometry: o,
                    cameraQueryGeometry: a,
                    scale: r,
                    tileSize: this.tileSize,
                    pixelPosMatrix: c,
                    transform: n,
                    params: s,
                    queryPadding: this.queryPadding * l
                }, t1, e1, i) : {};
            }
            querySourceFeatures(e1, i) {
                const o = this.latestFeatureIndex;
                if (!o || !o.rawTileData) return;
                const a = o.loadVTLayers(), r = i ? i.sourceLayer : "", s = a._geojsonTileLayer || a[r];
                if (!s) return;
                const n = t1.createFilter(i && i.filter), { z: l , x: c , y: h  } = this.tileID.canonical, u = {
                    z: l,
                    x: c,
                    y: h
                };
                for(let i1 = 0; i1 < s.length; i1++){
                    const a1 = s.feature(i1);
                    if (n.needGeometry) {
                        const e2 = t1.toEvaluationFeature(a1, !0);
                        if (!n.filter(new t1.EvaluationParameters(this.tileID.overscaledZ), e2, this.tileID.canonical)) continue;
                    } else if (!n.filter(new t1.EvaluationParameters(this.tileID.overscaledZ), a1)) continue;
                    const d = o.getId(a1, r), m = new t1.GeoJSONFeature(a1, l, c, h, d);
                    m.tile = u, e1.push(m);
                }
            }
            hasData() {
                return "loaded" === this.state || "reloading" === this.state || "expired" === this.state;
            }
            patternsLoaded() {
                return this.imageAtlas && !!Object.keys(this.imageAtlas.patternPositions).length;
            }
            setExpiryData(e1) {
                const i = this.expirationTime;
                if (e1.cacheControl) {
                    const i1 = t1.parseCacheControl(e1.cacheControl);
                    i1["max-age"] && (this.expirationTime = Date.now() + 1e3 * i1["max-age"]);
                } else e1.expires && (this.expirationTime = new Date(e1.expires).getTime());
                if (this.expirationTime) {
                    const t2 = Date.now();
                    let e2 = !1;
                    if (this.expirationTime > t2) e2 = !1;
                    else if (i) {
                        if (this.expirationTime < i) e2 = !0;
                        else {
                            const o = this.expirationTime - i;
                            o ? this.expirationTime = t2 + Math.max(o, 3e4) : e2 = !0;
                        }
                    } else e2 = !0;
                    e2 ? (this.expiredRequestCount++, this.state = "expired") : this.expiredRequestCount = 0;
                }
            }
            getExpiryTimeout() {
                if (this.expirationTime) return this.expiredRequestCount ? 1e3 * (1 << Math.min(this.expiredRequestCount - 1, 31)) : Math.min(this.expirationTime - (new Date).getTime(), Math.pow(2, 31) - 1);
            }
            setFeatureState(t1, e1) {
                if (!this.latestFeatureIndex || !this.latestFeatureIndex.rawTileData || 0 === Object.keys(t1).length) return;
                const i = this.latestFeatureIndex.loadVTLayers();
                for(const o in this.buckets){
                    if (!e1.style.hasLayer(o)) continue;
                    const a = this.buckets[o], r = a.layers[0].sourceLayer || "_geojsonTileLayer", s = i[r], n = t1[r];
                    if (!s || !n || 0 === Object.keys(n).length) continue;
                    a.update(n, s, this.imageAtlas && this.imageAtlas.patternPositions || {});
                    const l = e1 && e1.style && e1.style.getLayer(o);
                    l && (this.queryPadding = Math.max(this.queryPadding, l.queryRadius(a)));
                }
            }
            holdingForFade() {
                return void 0 !== this.symbolFadeHoldUntil;
            }
            symbolFadeFinished() {
                return !this.symbolFadeHoldUntil || this.symbolFadeHoldUntil < t1.exported.now();
            }
            clearFadeHold() {
                this.symbolFadeHoldUntil = void 0;
            }
            setHoldDuration(e1) {
                this.symbolFadeHoldUntil = t1.exported.now() + e1;
            }
            setDependencies(t1, e1) {
                const i = {};
                for (const t2 of e1)i[t2] = !0;
                this.dependencies[t1] = i;
            }
            hasDependency(t1, e1) {
                for (const i of t1){
                    const t2 = this.dependencies[i];
                    if (t2) {
                        for (const i1 of e1)if (t2[i1]) return !0;
                    }
                }
                return !1;
            }
        }
        class B {
            constructor(t1, e1){
                this.max = t1, this.onRemove = e1, this.reset();
            }
            reset() {
                for(const t1 in this.data)for (const e1 of this.data[t1])e1.timeout && clearTimeout(e1.timeout), this.onRemove(e1.value);
                return this.data = {}, this.order = [], this;
            }
            add(t1, e1, i) {
                const o = t1.wrapped().key;
                void 0 === this.data[o] && (this.data[o] = []);
                const a = {
                    value: e1,
                    timeout: void 0
                };
                if (void 0 !== i && (a.timeout = setTimeout(()=>{
                    this.remove(t1, a);
                }, i)), this.data[o].push(a), this.order.push(o), this.order.length > this.max) {
                    const t2 = this._getAndRemoveByKey(this.order[0]);
                    t2 && this.onRemove(t2);
                }
                return this;
            }
            has(t1) {
                return t1.wrapped().key in this.data;
            }
            getAndRemove(t1) {
                return this.has(t1) ? this._getAndRemoveByKey(t1.wrapped().key) : null;
            }
            _getAndRemoveByKey(t1) {
                const e1 = this.data[t1].shift();
                return e1.timeout && clearTimeout(e1.timeout), 0 === this.data[t1].length && delete this.data[t1], this.order.splice(this.order.indexOf(t1), 1), e1.value;
            }
            getByKey(t1) {
                const e1 = this.data[t1];
                return e1 ? e1[0].value : null;
            }
            get(t1) {
                return this.has(t1) ? this.data[t1.wrapped().key][0].value : null;
            }
            remove(t1, e1) {
                if (!this.has(t1)) return this;
                const i = t1.wrapped().key, o = void 0 === e1 ? 0 : this.data[i].indexOf(e1), a = this.data[i][o];
                return this.data[i].splice(o, 1), a.timeout && clearTimeout(a.timeout), 0 === this.data[i].length && delete this.data[i], this.onRemove(a.value), this.order.splice(this.order.indexOf(i), 1), this;
            }
            setMaxSize(t1) {
                for(this.max = t1; this.order.length > this.max;){
                    const t2 = this._getAndRemoveByKey(this.order[0]);
                    t2 && this.onRemove(t2);
                }
                return this;
            }
            filter(t1) {
                const e1 = [];
                for(const i in this.data)for (const o of this.data[i])t1(o.value) || e1.push(o);
                for (const t2 of e1)this.remove(t2.value.tileID, t2);
            }
        }
        class F {
            constructor(){
                this.state = {}, this.stateChanges = {}, this.deletedStates = {};
            }
            updateState(e1, i, o) {
                const a = String(i);
                if (this.stateChanges[e1] = this.stateChanges[e1] || {}, this.stateChanges[e1][a] = this.stateChanges[e1][a] || {}, t1.extend(this.stateChanges[e1][a], o), null === this.deletedStates[e1]) {
                    this.deletedStates[e1] = {};
                    for(const t2 in this.state[e1])t2 !== a && (this.deletedStates[e1][t2] = null);
                } else if (this.deletedStates[e1] && null === this.deletedStates[e1][a]) {
                    this.deletedStates[e1][a] = {};
                    for(const t3 in this.state[e1][a])o[t3] || (this.deletedStates[e1][a][t3] = null);
                } else for(const t4 in o)this.deletedStates[e1] && this.deletedStates[e1][a] && null === this.deletedStates[e1][a][t4] && delete this.deletedStates[e1][a][t4];
            }
            removeFeatureState(t1, e1, i) {
                if (null === this.deletedStates[t1]) return;
                const o = String(e1);
                if (this.deletedStates[t1] = this.deletedStates[t1] || {}, i && void 0 !== e1) null !== this.deletedStates[t1][o] && (this.deletedStates[t1][o] = this.deletedStates[t1][o] || {}, this.deletedStates[t1][o][i] = null);
                else if (void 0 !== e1) {
                    if (this.stateChanges[t1] && this.stateChanges[t1][o]) for(i in this.deletedStates[t1][o] = {}, this.stateChanges[t1][o])this.deletedStates[t1][o][i] = null;
                    else this.deletedStates[t1][o] = null;
                } else this.deletedStates[t1] = null;
            }
            getState(e1, i) {
                const o = String(i), a = t1.extend({}, (this.state[e1] || {})[o], (this.stateChanges[e1] || {})[o]);
                if (null === this.deletedStates[e1]) return {};
                if (this.deletedStates[e1]) {
                    const t2 = this.deletedStates[e1][i];
                    if (null === t2) return {};
                    for(const e2 in t2)delete a[e2];
                }
                return a;
            }
            initializeTileState(t1, e1) {
                t1.setFeatureState(this.state, e1);
            }
            coalesceChanges(e1, i) {
                const o = {};
                for(const e2 in this.stateChanges){
                    this.state[e2] = this.state[e2] || {};
                    const i1 = {};
                    for(const o1 in this.stateChanges[e2])this.state[e2][o1] || (this.state[e2][o1] = {}), t1.extend(this.state[e2][o1], this.stateChanges[e2][o1]), i1[o1] = this.state[e2][o1];
                    o[e2] = i1;
                }
                for(const e3 in this.deletedStates){
                    this.state[e3] = this.state[e3] || {};
                    const i2 = {};
                    if (null === this.deletedStates[e3]) for(const t2 in this.state[e3])i2[t2] = {}, this.state[e3][t2] = {};
                    else for(const t3 in this.deletedStates[e3]){
                        if (null === this.deletedStates[e3][t3]) this.state[e3][t3] = {};
                        else for (const i3 of Object.keys(this.deletedStates[e3][t3]))delete this.state[e3][t3][i3];
                        i2[t3] = this.state[e3][t3];
                    }
                    o[e3] = o[e3] || {}, t1.extend(o[e3], i2);
                }
                if (this.stateChanges = {}, this.deletedStates = {}, 0 !== Object.keys(o).length) for(const t4 in e1)e1[t4].setFeatureState(o, i);
            }
        }
        class O extends t1.Evented {
            constructor(e1, i, o){
                super(), this.id = e1, this.dispatcher = o, this.on("data", (t1)=>{
                    "source" === t1.dataType && "metadata" === t1.sourceDataType && (this._sourceLoaded = !0), this._sourceLoaded && !this._paused && "source" === t1.dataType && "content" === t1.sourceDataType && (this.reload(), this.transform && this.update(this.transform, this.terrain));
                }), this.on("dataloading", ()=>{
                    this._sourceErrored = !1;
                }), this.on("error", ()=>{
                    this._sourceErrored = this._source.loaded();
                }), this._source = function(e1, i, o, a) {
                    const r = new M[i.type](e1, i, o, a);
                    if (r.id !== e1) throw new Error(`Expected Source id to be ${e1} instead of ${r.id}`);
                    return t1.bindAll([
                        "load",
                        "abort",
                        "unload",
                        "serialize",
                        "prepare"
                    ], r), r;
                }(e1, i, o, this), this._tiles = {}, this._cache = new B(0, this._unloadTile.bind(this)), this._timers = {}, this._cacheTimers = {}, this._maxTileCacheSize = null, this._loadedParentTiles = {}, this._coveredTiles = {}, this._state = new F;
            }
            onAdd(t1) {
                this.map = t1, this._maxTileCacheSize = t1 ? t1._maxTileCacheSize : null, this._source && this._source.onAdd && this._source.onAdd(t1);
            }
            onRemove(t1) {
                this.clearTiles(), this._source && this._source.onRemove && this._source.onRemove(t1);
            }
            loaded() {
                if (this._sourceErrored) return !0;
                if (!this._sourceLoaded) return !1;
                if (!this._source.loaded()) return !1;
                for(const t1 in this._tiles){
                    const e1 = this._tiles[t1];
                    if ("loaded" !== e1.state && "errored" !== e1.state) return !1;
                }
                return !0;
            }
            getSource() {
                return this._source;
            }
            pause() {
                this._paused = !0;
            }
            resume() {
                if (!this._paused) return;
                const t1 = this._shouldReloadOnResume;
                this._paused = !1, this._shouldReloadOnResume = !1, t1 && this.reload(), this.transform && this.update(this.transform, this.terrain);
            }
            _loadTile(t1, e1) {
                return this._source.loadTile(t1, e1);
            }
            _unloadTile(t1) {
                if (this._source.unloadTile) return this._source.unloadTile(t1, ()=>{});
            }
            _abortTile(e1) {
                this._source.abortTile && this._source.abortTile(e1, ()=>{}), this._source.fire(new t1.Event("dataabort", {
                    tile: e1,
                    coord: e1.tileID,
                    dataType: "source"
                }));
            }
            serialize() {
                return this._source.serialize();
            }
            prepare(t1) {
                this._source.prepare && this._source.prepare(), this._state.coalesceChanges(this._tiles, this.map ? this.map.painter : null);
                for(const e1 in this._tiles){
                    const i = this._tiles[e1];
                    i.upload(t1), i.prepare(this.map.style.imageManager);
                }
            }
            getIds() {
                return Object.values(this._tiles).map((t1)=>t1.tileID).sort(U).map((t1)=>t1.key);
            }
            getRenderableIds(e1) {
                const i = [];
                for(const t2 in this._tiles)this._isIdRenderable(t2, e1) && i.push(this._tiles[t2]);
                return e1 ? i.sort((e1, i)=>{
                    const o = e1.tileID, a = i.tileID, r = new t1.pointGeometry(o.canonical.x, o.canonical.y)._rotate(this.transform.angle), s = new t1.pointGeometry(a.canonical.x, a.canonical.y)._rotate(this.transform.angle);
                    return o.overscaledZ - a.overscaledZ || s.y - r.y || s.x - r.x;
                }).map((t1)=>t1.tileID.key) : i.map((t1)=>t1.tileID).sort(U).map((t1)=>t1.key);
            }
            hasRenderableParent(t1) {
                const e1 = this.findLoadedParent(t1, 0);
                return !!e1 && this._isIdRenderable(e1.tileID.key);
            }
            _isIdRenderable(t1, e1) {
                return this._tiles[t1] && this._tiles[t1].hasData() && !this._coveredTiles[t1] && (e1 || !this._tiles[t1].holdingForFade());
            }
            reload() {
                if (this._paused) this._shouldReloadOnResume = !0;
                else {
                    this._cache.reset();
                    for(const t1 in this._tiles)"errored" !== this._tiles[t1].state && this._reloadTile(t1, "reloading");
                }
            }
            _reloadTile(t1, e1) {
                const i = this._tiles[t1];
                i && ("loading" !== i.state && (i.state = e1), this._loadTile(i, this._tileLoaded.bind(this, i, t1, e1)));
            }
            _tileLoaded(e1, i, o, a) {
                if (a) return e1.state = "errored", void (404 !== a.status ? this._source.fire(new t1.ErrorEvent(a, {
                    tile: e1
                })) : this.update(this.transform, this.terrain));
                e1.timeAdded = t1.exported.now(), "expired" === o && (e1.refreshedUponExpiration = !0), this._setTileReloadTimer(i, e1), "raster-dem" === this.getSource().type && e1.dem && this._backfillDEM(e1), this._state.initializeTileState(e1, this.map ? this.map.painter : null), e1.aborted || this._source.fire(new t1.Event("data", {
                    dataType: "source",
                    tile: e1,
                    coord: e1.tileID
                }));
            }
            _backfillDEM(t1) {
                const e1 = this.getRenderableIds();
                for(let o = 0; o < e1.length; o++){
                    const a = e1[o];
                    if (t1.neighboringTiles && t1.neighboringTiles[a]) {
                        const e2 = this.getTileByID(a);
                        i(t1, e2), i(e2, t1);
                    }
                }
                function i(t1, e1) {
                    t1.needsHillshadePrepare = !0, t1.needsTerrainPrepare = !0;
                    let i = e1.tileID.canonical.x - t1.tileID.canonical.x;
                    const o = e1.tileID.canonical.y - t1.tileID.canonical.y, a = Math.pow(2, t1.tileID.canonical.z), r = e1.tileID.key;
                    0 === i && 0 === o || Math.abs(o) > 1 || (Math.abs(i) > 1 && (1 === Math.abs(i + a) ? i += a : 1 === Math.abs(i - a) && (i -= a)), e1.dem && t1.dem && (t1.dem.backfillBorder(e1.dem, i, o), t1.neighboringTiles && t1.neighboringTiles[r] && (t1.neighboringTiles[r].backfilled = !0)));
                }
            }
            getTile(t1) {
                return this.getTileByID(t1.key);
            }
            getTileByID(t1) {
                return this._tiles[t1];
            }
            _retainLoadedChildren(t1, e1, i, o) {
                for(const a in this._tiles){
                    let r = this._tiles[a];
                    if (o[a] || !r.hasData() || r.tileID.overscaledZ <= e1 || r.tileID.overscaledZ > i) continue;
                    let s = r.tileID;
                    for(; r && r.tileID.overscaledZ > e1 + 1;){
                        const t2 = r.tileID.scaledTo(r.tileID.overscaledZ - 1);
                        r = this._tiles[t2.key], r && r.hasData() && (s = t2);
                    }
                    let n = s;
                    for(; n.overscaledZ > e1;)if (n = n.scaledTo(n.overscaledZ - 1), t1[n.key]) {
                        o[s.key] = s;
                        break;
                    }
                }
            }
            findLoadedParent(t1, e1) {
                if (t1.key in this._loadedParentTiles) {
                    const i = this._loadedParentTiles[t1.key];
                    return i && i.tileID.overscaledZ >= e1 ? i : null;
                }
                for(let i1 = t1.overscaledZ - 1; i1 >= e1; i1--){
                    const e2 = t1.scaledTo(i1), o = this._getLoadedTile(e2);
                    if (o) return o;
                }
            }
            _getLoadedTile(t1) {
                const e1 = this._tiles[t1.key];
                return e1 && e1.hasData() ? e1 : this._cache.getByKey(t1.wrapped().key);
            }
            updateCacheSize(t1) {
                const e1 = Math.ceil(t1.width / this._source.tileSize) + 1, i = Math.ceil(t1.height / this._source.tileSize) + 1, o = Math.floor(e1 * i * 5), a = "number" == typeof this._maxTileCacheSize ? Math.min(this._maxTileCacheSize, o) : o;
                this._cache.setMaxSize(a);
            }
            handleWrapJump(t1) {
                const e1 = Math.round((t1 - (void 0 === this._prevLng ? t1 : this._prevLng)) / 360);
                if (this._prevLng = t1, e1) {
                    const t2 = {};
                    for(const i in this._tiles){
                        const o = this._tiles[i];
                        o.tileID = o.tileID.unwrapTo(o.tileID.wrap + e1), t2[o.tileID.key] = o;
                    }
                    this._tiles = t2;
                    for(const t3 in this._timers)clearTimeout(this._timers[t3]), delete this._timers[t3];
                    for(const t4 in this._tiles)this._setTileReloadTimer(t4, this._tiles[t4]);
                }
            }
            update(e1, i) {
                if (this.transform = e1, this.terrain = i, !this._sourceLoaded || this._paused) return;
                let o;
                this.updateCacheSize(e1), this.handleWrapJump(this.transform.center.lng), this._coveredTiles = {}, this.used || this.usedForTerrain ? this._source.tileID ? o = e1.getVisibleUnwrappedCoordinates(this._source.tileID).map((e1)=>new t1.OverscaledTileID(e1.canonical.z, e1.wrap, e1.canonical.z, e1.canonical.x, e1.canonical.y)) : (o = e1.coveringTiles({
                    tileSize: this.usedForTerrain ? this.tileSize : this._source.tileSize,
                    minzoom: this._source.minzoom,
                    maxzoom: this._source.maxzoom,
                    roundZoom: !this.usedForTerrain && this._source.roundZoom,
                    reparseOverscaled: this._source.reparseOverscaled,
                    terrain: i
                }), this._source.hasTile && (o = o.filter((t1)=>this._source.hasTile(t1)))) : o = [];
                const a = e1.coveringZoomLevel(this._source), r = Math.max(a - O.maxOverzooming, this._source.minzoom), s = Math.max(a + O.maxUnderzooming, this._source.minzoom);
                if (this.usedForTerrain) {
                    const t2 = {};
                    for (const e2 of o)if (e2.canonical.z > this._source.minzoom) {
                        const i1 = e2.scaledTo(e2.canonical.z - 1);
                        t2[i1.key] = i1;
                        const o1 = e2.scaledTo(Math.max(this._source.minzoom, Math.min(e2.canonical.z, 5)));
                        t2[o1.key] = o1;
                    }
                    o = o.concat(Object.values(t2));
                }
                const n = this._updateRetainedTiles(o, a);
                if (N(this._source.type)) {
                    const e3 = {}, l = {}, c = Object.keys(n);
                    for (const i2 of c){
                        const o2 = n[i2], a1 = this._tiles[i2];
                        if (!a1 || a1.fadeEndTime && a1.fadeEndTime <= t1.exported.now()) continue;
                        const s1 = this.findLoadedParent(o2, r);
                        s1 && (this._addTile(s1.tileID), e3[s1.tileID.key] = s1.tileID), l[i2] = o2;
                    }
                    this._retainLoadedChildren(l, a, s, n);
                    for(const t3 in e3)n[t3] || (this._coveredTiles[t3] = !0, n[t3] = e3[t3]);
                    if (i) {
                        const t4 = {}, e4 = {};
                        for (const i3 of o)this._tiles[i3.key].hasData() ? t4[i3.key] = i3 : e4[i3.key] = i3;
                        for(const i4 in e4){
                            const o3 = e4[i4].children(this._source.maxzoom);
                            this._tiles[o3[0].key] && this._tiles[o3[1].key] && this._tiles[o3[2].key] && this._tiles[o3[3].key] && (t4[o3[0].key] = n[o3[0].key] = o3[0], t4[o3[1].key] = n[o3[1].key] = o3[1], t4[o3[2].key] = n[o3[2].key] = o3[2], t4[o3[3].key] = n[o3[3].key] = o3[3], delete e4[i4]);
                        }
                        for(const i5 in e4){
                            const o4 = this.findLoadedParent(e4[i5], this._source.minzoom);
                            if (o4) {
                                t4[o4.tileID.key] = n[o4.tileID.key] = o4.tileID;
                                for(const e5 in t4)t4[e5].isChildOf(o4.tileID) && delete t4[e5];
                            }
                        }
                        for(const e6 in this._tiles)t4[e6] || (this._coveredTiles[e6] = !0);
                    }
                }
                for(const t5 in n)this._tiles[t5].clearFadeHold();
                const l1 = t1.keysDifference(this._tiles, n);
                for (const t6 of l1){
                    const e7 = this._tiles[t6];
                    e7.hasSymbolBuckets && !e7.holdingForFade() ? e7.setHoldDuration(this.map._fadeDuration) : e7.hasSymbolBuckets && !e7.symbolFadeFinished() || this._removeTile(t6);
                }
                this._updateLoadedParentTileCache();
            }
            releaseSymbolFadeTiles() {
                for(const t1 in this._tiles)this._tiles[t1].holdingForFade() && this._removeTile(t1);
            }
            _updateRetainedTiles(t1, e1) {
                const i = {}, o = {}, a = Math.max(e1 - O.maxOverzooming, this._source.minzoom), r = Math.max(e1 + O.maxUnderzooming, this._source.minzoom), s = {};
                for (const o1 of t1){
                    const t2 = this._addTile(o1);
                    i[o1.key] = o1, t2.hasData() || e1 < this._source.maxzoom && (s[o1.key] = o1);
                }
                this._retainLoadedChildren(s, e1, r, i);
                for (const r1 of t1){
                    let t3 = this._tiles[r1.key];
                    if (t3.hasData()) continue;
                    if (e1 + 1 > this._source.maxzoom) {
                        const t4 = r1.children(this._source.maxzoom)[0], e2 = this.getTile(t4);
                        if (e2 && e2.hasData()) {
                            i[t4.key] = t4;
                            continue;
                        }
                    } else {
                        const t5 = r1.children(this._source.maxzoom);
                        if (i[t5[0].key] && i[t5[1].key] && i[t5[2].key] && i[t5[3].key]) continue;
                    }
                    let s1 = t3.wasRequested();
                    for(let e3 = r1.overscaledZ - 1; e3 >= a; --e3){
                        const a1 = r1.scaledTo(e3);
                        if (o[a1.key]) break;
                        if (o[a1.key] = !0, t3 = this.getTile(a1), !t3 && s1 && (t3 = this._addTile(a1)), t3 && (i[a1.key] = a1, s1 = t3.wasRequested(), t3.hasData())) break;
                    }
                }
                return i;
            }
            _updateLoadedParentTileCache() {
                this._loadedParentTiles = {};
                for(const t1 in this._tiles){
                    const e1 = [];
                    let i, o = this._tiles[t1].tileID;
                    for(; o.overscaledZ > 0;){
                        if (o.key in this._loadedParentTiles) {
                            i = this._loadedParentTiles[o.key];
                            break;
                        }
                        e1.push(o.key);
                        const t2 = o.scaledTo(o.overscaledZ - 1);
                        if (i = this._getLoadedTile(t2), i) break;
                        o = t2;
                    }
                    for (const t3 of e1)this._loadedParentTiles[t3] = i;
                }
            }
            _addTile(e1) {
                let i = this._tiles[e1.key];
                if (i) return i;
                i = this._cache.getAndRemove(e1), i && (this._setTileReloadTimer(e1.key, i), i.tileID = e1, this._state.initializeTileState(i, this.map ? this.map.painter : null), this._cacheTimers[e1.key] && (clearTimeout(this._cacheTimers[e1.key]), delete this._cacheTimers[e1.key], this._setTileReloadTimer(e1.key, i)));
                const o = i;
                return i || (i = new k(e1, this._source.tileSize * e1.overscaleFactor()), this._loadTile(i, this._tileLoaded.bind(this, i, e1.key, i.state))), i.uses++, this._tiles[e1.key] = i, o || this._source.fire(new t1.Event("dataloading", {
                    tile: i,
                    coord: i.tileID,
                    dataType: "source"
                })), i;
            }
            _setTileReloadTimer(t1, e1) {
                t1 in this._timers && (clearTimeout(this._timers[t1]), delete this._timers[t1]);
                const i = e1.getExpiryTimeout();
                i && (this._timers[t1] = setTimeout(()=>{
                    this._reloadTile(t1, "expired"), delete this._timers[t1];
                }, i));
            }
            _removeTile(t1) {
                const e1 = this._tiles[t1];
                e1 && (e1.uses--, delete this._tiles[t1], this._timers[t1] && (clearTimeout(this._timers[t1]), delete this._timers[t1]), e1.uses > 0 || (e1.hasData() && "reloading" !== e1.state ? this._cache.add(e1.tileID, e1, e1.getExpiryTimeout()) : (e1.aborted = !0, this._abortTile(e1), this._unloadTile(e1))));
            }
            clearTiles() {
                this._shouldReloadOnResume = !1, this._paused = !1;
                for(const t1 in this._tiles)this._removeTile(t1);
                this._cache.reset();
            }
            tilesIn(e1, i, o) {
                const a = [], r = this.transform;
                if (!r) return a;
                const s = o ? r.getCameraQueryGeometry(e1) : e1, n = e1.map((t1)=>r.pointCoordinate(t1, this.terrain)), l = s.map((t1)=>r.pointCoordinate(t1, this.terrain)), c = this.getIds();
                let h = 1 / 0, u = 1 / 0, d = -1 / 0, m = -1 / 0;
                for (const t2 of l)h = Math.min(h, t2.x), u = Math.min(u, t2.y), d = Math.max(d, t2.x), m = Math.max(m, t2.y);
                for(let e2 = 0; e2 < c.length; e2++){
                    const o1 = this._tiles[c[e2]];
                    if (o1.holdingForFade()) continue;
                    const s1 = o1.tileID, _ = Math.pow(2, r.zoom - o1.tileID.overscaledZ), p = i * o1.queryPadding * t1.EXTENT / o1.tileSize / _, f = [
                        s1.getTilePoint(new t1.MercatorCoordinate(h, u)),
                        s1.getTilePoint(new t1.MercatorCoordinate(d, m))
                    ];
                    if (f[0].x - p < t1.EXTENT && f[0].y - p < t1.EXTENT && f[1].x + p >= 0 && f[1].y + p >= 0) {
                        const t3 = n.map((t1)=>s1.getTilePoint(t1)), e3 = l.map((t1)=>s1.getTilePoint(t1));
                        a.push({
                            tile: o1,
                            tileID: s1,
                            queryGeometry: t3,
                            cameraQueryGeometry: e3,
                            scale: _
                        });
                    }
                }
                return a;
            }
            getVisibleCoordinates(t1) {
                const e1 = this.getRenderableIds(t1).map((t1)=>this._tiles[t1].tileID);
                for (const t2 of e1)t2.posMatrix = this.transform.calculatePosMatrix(t2.toUnwrapped());
                return e1;
            }
            hasTransition() {
                if (this._source.hasTransition()) return !0;
                if (N(this._source.type)) for(const e1 in this._tiles){
                    const i = this._tiles[e1];
                    if (void 0 !== i.fadeEndTime && i.fadeEndTime >= t1.exported.now()) return !0;
                }
                return !1;
            }
            setFeatureState(t1, e1, i) {
                this._state.updateState(t1 = t1 || "_geojsonTileLayer", e1, i);
            }
            removeFeatureState(t1, e1, i) {
                this._state.removeFeatureState(t1 = t1 || "_geojsonTileLayer", e1, i);
            }
            getFeatureState(t1, e1) {
                return this._state.getState(t1 = t1 || "_geojsonTileLayer", e1);
            }
            setDependencies(t1, e1, i) {
                const o = this._tiles[t1];
                o && o.setDependencies(e1, i);
            }
            reloadTilesForDependencies(t1, e1) {
                for(const i in this._tiles)this._tiles[i].hasDependency(t1, e1) && this._reloadTile(i, "reloading");
                this._cache.filter((i)=>!i.hasDependency(t1, e1));
            }
        }
        function U(t1, e1) {
            const i = Math.abs(2 * t1.wrap) - +(t1.wrap < 0), o = Math.abs(2 * e1.wrap) - +(e1.wrap < 0);
            return t1.overscaledZ - e1.overscaledZ || o - i || e1.canonical.y - t1.canonical.y || e1.canonical.x - t1.canonical.x;
        }
        function N(t1) {
            return "raster" === t1 || "image" === t1 || "video" === t1;
        }
        O.maxOverzooming = 10, O.maxUnderzooming = 3;
        const G = "mapboxgl_preloaded_worker_pool";
        class Z {
            constructor(){
                this.active = {};
            }
            acquire(t1) {
                if (!this.workers) for(this.workers = []; this.workers.length < Z.workerCount;)this.workers.push(new Worker(ba.workerUrl));
                return this.active[t1] = !0, this.workers.slice();
            }
            release(t1) {
                delete this.active[t1], 0 === this.numActive() && (this.workers.forEach((t1)=>{
                    t1.terminate();
                }), this.workers = null);
            }
            isPreloaded() {
                return !!this.active[G];
            }
            numActive() {
                return Object.keys(this.active).length;
            }
        }
        const V = Math.floor(t1.exported.hardwareConcurrency / 2);
        let q;
        function j() {
            return q || (q = new Z), q;
        }
        function $(e1, i) {
            const o = {};
            for(const t2 in e1)"ref" !== t2 && (o[t2] = e1[t2]);
            return t1.refProperties.forEach((t1)=>{
                t1 in i && (o[t1] = i[t1]);
            }), o;
        }
        function X(t1) {
            t1 = t1.slice();
            const e1 = Object.create(null);
            for(let i = 0; i < t1.length; i++)e1[t1[i].id] = t1[i];
            for(let i1 = 0; i1 < t1.length; i1++)"ref" in t1[i1] && (t1[i1] = $(t1[i1], e1[t1[i1].ref]));
            return t1;
        }
        Z.workerCount = Math.max(Math.min(V, 6), 1);
        const W = {
            setStyle: "setStyle",
            addLayer: "addLayer",
            removeLayer: "removeLayer",
            setPaintProperty: "setPaintProperty",
            setLayoutProperty: "setLayoutProperty",
            setFilter: "setFilter",
            addSource: "addSource",
            removeSource: "removeSource",
            setGeoJSONSourceData: "setGeoJSONSourceData",
            setLayerZoomRange: "setLayerZoomRange",
            setLayerProperty: "setLayerProperty",
            setCenter: "setCenter",
            setZoom: "setZoom",
            setBearing: "setBearing",
            setPitch: "setPitch",
            setSprite: "setSprite",
            setGlyphs: "setGlyphs",
            setTransition: "setTransition",
            setLight: "setLight"
        };
        function H(t1, e1, i) {
            i.push({
                command: W.addSource,
                args: [
                    t1,
                    e1[t1]
                ]
            });
        }
        function K(t1, e1, i) {
            e1.push({
                command: W.removeSource,
                args: [
                    t1
                ]
            }), i[t1] = !0;
        }
        function Y(t1, e1, i, o) {
            K(t1, i, o), H(t1, e1, i);
        }
        function J(t1, e1, i) {
            let o;
            for(o in t1[i])if (Object.prototype.hasOwnProperty.call(t1[i], o) && "data" !== o && !a(t1[i][o], e1[i][o])) return !1;
            for(o in e1[i])if (Object.prototype.hasOwnProperty.call(e1[i], o) && "data" !== o && !a(t1[i][o], e1[i][o])) return !1;
            return !0;
        }
        function Q(t1, e1, i, o, r, s) {
            let n;
            for(n in e1 = e1 || {}, t1 = t1 || {})Object.prototype.hasOwnProperty.call(t1, n) && (a(t1[n], e1[n]) || i.push({
                command: s,
                args: [
                    o,
                    n,
                    e1[n],
                    r
                ]
            }));
            for(n in e1)Object.prototype.hasOwnProperty.call(e1, n) && !Object.prototype.hasOwnProperty.call(t1, n) && (a(t1[n], e1[n]) || i.push({
                command: s,
                args: [
                    o,
                    n,
                    e1[n],
                    r
                ]
            }));
        }
        function tt(t1) {
            return t1.id;
        }
        function et(t1, e1) {
            return t1[e1.id] = e1, t1;
        }
        class it {
            constructor(t1, e1){
                this.reset(t1, e1);
            }
            reset(t1, e1) {
                this.points = t1 || [], this._distances = [
                    0
                ];
                for(let t2 = 1; t2 < this.points.length; t2++)this._distances[t2] = this._distances[t2 - 1] + this.points[t2].dist(this.points[t2 - 1]);
                this.length = this._distances[this._distances.length - 1], this.padding = Math.min(e1 || 0, .5 * this.length), this.paddedLength = this.length - 2 * this.padding;
            }
            lerp(e1) {
                if (1 === this.points.length) return this.points[0];
                e1 = t1.clamp(e1, 0, 1);
                let i = 1, o = this._distances[i];
                const a = e1 * this.paddedLength + this.padding;
                for(; o < a && i < this._distances.length;)o = this._distances[++i];
                const r = i - 1, s = this._distances[r], n = o - s, l = n > 0 ? (a - s) / n : 0;
                return this.points[r].mult(1 - l).add(this.points[i].mult(l));
            }
        }
        function ot(t1, e1) {
            let i = !0;
            return "always" === t1 || "never" !== t1 && "never" !== e1 || (i = !1), i;
        }
        class at {
            constructor(t1, e1, i){
                const o = this.boxCells = [], a = this.circleCells = [];
                this.xCellCount = Math.ceil(t1 / i), this.yCellCount = Math.ceil(e1 / i);
                for(let t2 = 0; t2 < this.xCellCount * this.yCellCount; t2++)o.push([]), a.push([]);
                this.circleKeys = [], this.boxKeys = [], this.bboxes = [], this.circles = [], this.width = t1, this.height = e1, this.xScale = this.xCellCount / t1, this.yScale = this.yCellCount / e1, this.boxUid = 0, this.circleUid = 0;
            }
            keysLength() {
                return this.boxKeys.length + this.circleKeys.length;
            }
            insert(t1, e1, i, o, a) {
                this._forEachCell(e1, i, o, a, this._insertBoxCell, this.boxUid++), this.boxKeys.push(t1), this.bboxes.push(e1), this.bboxes.push(i), this.bboxes.push(o), this.bboxes.push(a);
            }
            insertCircle(t1, e1, i, o) {
                this._forEachCell(e1 - o, i - o, e1 + o, i + o, this._insertCircleCell, this.circleUid++), this.circleKeys.push(t1), this.circles.push(e1), this.circles.push(i), this.circles.push(o);
            }
            _insertBoxCell(t1, e1, i, o, a, r) {
                this.boxCells[a].push(r);
            }
            _insertCircleCell(t1, e1, i, o, a, r) {
                this.circleCells[a].push(r);
            }
            _query(t1, e1, i, o, a, r, s) {
                if (i < 0 || t1 > this.width || o < 0 || e1 > this.height) return [];
                const n = [];
                if (t1 <= 0 && e1 <= 0 && this.width <= i && this.height <= o) {
                    if (a) return [
                        {
                            key: null,
                            x1: t1,
                            y1: e1,
                            x2: i,
                            y2: o
                        }
                    ];
                    for(let t2 = 0; t2 < this.boxKeys.length; t2++)n.push({
                        key: this.boxKeys[t2],
                        x1: this.bboxes[4 * t2],
                        y1: this.bboxes[4 * t2 + 1],
                        x2: this.bboxes[4 * t2 + 2],
                        y2: this.bboxes[4 * t2 + 3]
                    });
                    for(let t3 = 0; t3 < this.circleKeys.length; t3++){
                        const e2 = this.circles[3 * t3], i1 = this.circles[3 * t3 + 1], o1 = this.circles[3 * t3 + 2];
                        n.push({
                            key: this.circleKeys[t3],
                            x1: e2 - o1,
                            y1: i1 - o1,
                            x2: e2 + o1,
                            y2: i1 + o1
                        });
                    }
                } else this._forEachCell(t1, e1, i, o, this._queryCell, n, {
                    hitTest: a,
                    overlapMode: r,
                    seenUids: {
                        box: {},
                        circle: {}
                    }
                }, s);
                return n;
            }
            query(t1, e1, i, o) {
                return this._query(t1, e1, i, o, !1, null);
            }
            hitTest(t1, e1, i, o, a, r) {
                return this._query(t1, e1, i, o, !0, a, r).length > 0;
            }
            hitTestCircle(t1, e1, i, o, a) {
                const r = t1 - i, s = t1 + i, n = e1 - i, l = e1 + i;
                if (s < 0 || r > this.width || l < 0 || n > this.height) return !1;
                const c = [];
                return this._forEachCell(r, n, s, l, this._queryCellCircle, c, {
                    hitTest: !0,
                    overlapMode: o,
                    circle: {
                        x: t1,
                        y: e1,
                        radius: i
                    },
                    seenUids: {
                        box: {},
                        circle: {}
                    }
                }, a), c.length > 0;
            }
            _queryCell(t1, e1, i, o, a, r, s, n) {
                const { seenUids: l , hitTest: c , overlapMode: h  } = s, u = this.boxCells[a];
                if (null !== u) {
                    const a1 = this.bboxes;
                    for (const s1 of u)if (!l.box[s1]) {
                        l.box[s1] = !0;
                        const u1 = 4 * s1, d = this.boxKeys[s1];
                        if (t1 <= a1[u1 + 2] && e1 <= a1[u1 + 3] && i >= a1[u1 + 0] && o >= a1[u1 + 1] && (!n || n(d)) && (!c || !ot(h, d.overlapMode)) && (r.push({
                            key: d,
                            x1: a1[u1],
                            y1: a1[u1 + 1],
                            x2: a1[u1 + 2],
                            y2: a1[u1 + 3]
                        }), c)) return !0;
                    }
                }
                const d1 = this.circleCells[a];
                if (null !== d1) {
                    const a2 = this.circles;
                    for (const s2 of d1)if (!l.circle[s2]) {
                        l.circle[s2] = !0;
                        const u2 = 3 * s2, d2 = this.circleKeys[s2];
                        if (this._circleAndRectCollide(a2[u2], a2[u2 + 1], a2[u2 + 2], t1, e1, i, o) && (!n || n(d2)) && (!c || !ot(h, d2.overlapMode))) {
                            const t2 = a2[u2], e2 = a2[u2 + 1], i1 = a2[u2 + 2];
                            if (r.push({
                                key: d2,
                                x1: t2 - i1,
                                y1: e2 - i1,
                                x2: t2 + i1,
                                y2: e2 + i1
                            }), c) return !0;
                        }
                    }
                }
                return !1;
            }
            _queryCellCircle(t1, e1, i, o, a, r, s, n) {
                const { circle: l , seenUids: c , overlapMode: h  } = s, u = this.boxCells[a];
                if (null !== u) {
                    const t2 = this.bboxes;
                    for (const e2 of u)if (!c.box[e2]) {
                        c.box[e2] = !0;
                        const i1 = 4 * e2, o1 = this.boxKeys[e2];
                        if (this._circleAndRectCollide(l.x, l.y, l.radius, t2[i1 + 0], t2[i1 + 1], t2[i1 + 2], t2[i1 + 3]) && (!n || n(o1)) && !ot(h, o1.overlapMode)) return r.push(!0), !0;
                    }
                }
                const d = this.circleCells[a];
                if (null !== d) {
                    const t3 = this.circles;
                    for (const e3 of d)if (!c.circle[e3]) {
                        c.circle[e3] = !0;
                        const i2 = 3 * e3, o2 = this.circleKeys[e3];
                        if (this._circlesCollide(t3[i2], t3[i2 + 1], t3[i2 + 2], l.x, l.y, l.radius) && (!n || n(o2)) && !ot(h, o2.overlapMode)) return r.push(!0), !0;
                    }
                }
            }
            _forEachCell(t1, e1, i, o, a, r, s, n) {
                const l = this._convertToXCellCoord(t1), c = this._convertToYCellCoord(e1), h = this._convertToXCellCoord(i), u = this._convertToYCellCoord(o);
                for(let d = l; d <= h; d++)for(let l1 = c; l1 <= u; l1++)if (a.call(this, t1, e1, i, o, this.xCellCount * l1 + d, r, s, n)) return;
            }
            _convertToXCellCoord(t1) {
                return Math.max(0, Math.min(this.xCellCount - 1, Math.floor(t1 * this.xScale)));
            }
            _convertToYCellCoord(t1) {
                return Math.max(0, Math.min(this.yCellCount - 1, Math.floor(t1 * this.yScale)));
            }
            _circlesCollide(t1, e1, i, o, a, r) {
                const s = o - t1, n = a - e1, l = i + r;
                return l * l > s * s + n * n;
            }
            _circleAndRectCollide(t1, e1, i, o, a, r, s) {
                const n = (r - o) / 2, l = Math.abs(t1 - (o + n));
                if (l > n + i) return !1;
                const c = (s - a) / 2, h = Math.abs(e1 - (a + c));
                if (h > c + i) return !1;
                if (l <= n || h <= c) return !0;
                const u = l - n, d = h - c;
                return u * u + d * d <= i * i;
            }
        }
        function rt(e1, i, o, a, r) {
            const s = t1.create();
            return i ? (t1.scale(s, s, [
                1 / r,
                1 / r,
                1
            ]), o || t1.rotateZ(s, s, a.angle)) : t1.multiply(s, a.labelPlaneMatrix, e1), s;
        }
        function st(e1, i, o, a, r) {
            if (i) {
                const i1 = t1.clone(e1);
                return t1.scale(i1, i1, [
                    r,
                    r,
                    1
                ]), o || t1.rotateZ(i1, i1, -a.angle), i1;
            }
            return a.glCoordMatrix;
        }
        function nt(e1, i, o) {
            let a;
            o ? (a = [
                e1.x,
                e1.y,
                o(e1.x, e1.y),
                1
            ], t1.transformMat4(a, a, i)) : (a = [
                e1.x,
                e1.y,
                0,
                1
            ], xt(a, a, i));
            const r = a[3];
            return {
                point: new t1.pointGeometry(a[0] / r, a[1] / r),
                signedDistanceFromCamera: r
            };
        }
        function lt(t1, e1) {
            return .5 + t1 / e1 * .5;
        }
        function ct(t1, e1) {
            const i = t1[0] / t1[3], o = t1[1] / t1[3];
            return i >= -e1[0] && i <= e1[0] && o >= -e1[1] && o <= e1[1];
        }
        function ht(e1, i, o, a, r, s, n, l, c, h) {
            const u = a ? e1.textSizeData : e1.iconSizeData, d = t1.evaluateSizeForZoom(u, o.transform.zoom), m = [
                256 / o.width * 2 + 1,
                256 / o.height * 2 + 1
            ], _ = a ? e1.text.dynamicLayoutVertexArray : e1.icon.dynamicLayoutVertexArray;
            _.clear();
            const p = e1.lineVertexArray, f = a ? e1.text.placedSymbolArray : e1.icon.placedSymbolArray, g = o.transform.width / o.transform.height;
            let x = !1;
            for(let a1 = 0; a1 < f.length; a1++){
                const v = f.get(a1);
                if (v.hidden || v.writingMode === t1.WritingMode.vertical && !x) {
                    gt(v.numGlyphs, _);
                    continue;
                }
                let y;
                if (x = !1, h ? (y = [
                    v.anchorX,
                    v.anchorY,
                    h(v.anchorX, v.anchorY),
                    1
                ], t1.transformMat4(y, y, i)) : (y = [
                    v.anchorX,
                    v.anchorY,
                    0,
                    1
                ], xt(y, y, i)), !ct(y, m)) {
                    gt(v.numGlyphs, _);
                    continue;
                }
                const b = lt(o.transform.cameraToCenterDistance, y[3]), w = t1.evaluateSizeForFeature(u, d, v), T = n ? w / b : w * b, E = new t1.pointGeometry(v.anchorX, v.anchorY), I = nt(E, r, h).point, C = {}, S = mt(v, T, !1, l, i, r, s, e1.glyphOffsetArray, p, _, I, E, C, g, c, h);
                x = S.useVertical, (S.notEnoughRoom || x || S.needsFlipping && mt(v, T, !0, l, i, r, s, e1.glyphOffsetArray, p, _, I, E, C, g, c, h).notEnoughRoom) && gt(v.numGlyphs, _);
            }
            a ? e1.text.dynamicLayoutVertexBuffer.updateData(_) : e1.icon.dynamicLayoutVertexBuffer.updateData(_);
        }
        function ut(t1, e1, i, o, a, r, s, n, l, c, h, u, d) {
            const m = n.glyphStartIndex + n.numGlyphs, _ = n.lineStartIndex, p = n.lineStartIndex + n.lineLength, f = e1.getoffsetX(n.glyphStartIndex), g = e1.getoffsetX(m - 1), x = pt(t1 * f, i, o, a, r, s, n.segment, _, p, l, c, h, u, d);
            if (!x) return null;
            const v = pt(t1 * g, i, o, a, r, s, n.segment, _, p, l, c, h, u, d);
            return v ? {
                first: x,
                last: v
            } : null;
        }
        function dt(e1, i, o, a) {
            return e1 === t1.WritingMode.horizontal && Math.abs(o.y - i.y) > Math.abs(o.x - i.x) * a ? {
                useVertical: !0
            } : (e1 === t1.WritingMode.vertical ? i.y < o.y : i.x > o.x) ? {
                needsFlipping: !0
            } : null;
        }
        function mt(e1, i, o, a, r, s, n, l, c, h, u, d, m, _, p, f) {
            const g = i / 24, x = e1.lineOffsetX * g, v = e1.lineOffsetY * g;
            let y;
            if (e1.numGlyphs > 1) {
                const t2 = e1.glyphStartIndex + e1.numGlyphs, i1 = e1.lineStartIndex, r1 = e1.lineStartIndex + e1.lineLength, h1 = ut(g, l, x, v, o, u, d, e1, c, s, m, p, f);
                if (!h1) return {
                    notEnoughRoom: !0
                };
                const b = nt(h1.first.point, n, f).point, w = nt(h1.last.point, n, f).point;
                if (a && !o) {
                    const t3 = dt(e1.writingMode, b, w, _);
                    if (t3) return t3;
                }
                y = [
                    h1.first
                ];
                for(let a1 = e1.glyphStartIndex + 1; a1 < t2 - 1; a1++)y.push(pt(g * l.getoffsetX(a1), x, v, o, u, d, e1.segment, i1, r1, c, s, m, p, f));
                y.push(h1.last);
            } else {
                if (a && !o) {
                    const i2 = nt(d, r, f).point, o1 = e1.lineStartIndex + e1.segment + 1, a2 = new t1.pointGeometry(c.getx(o1), c.gety(o1)), s1 = nt(a2, r, f), n1 = s1.signedDistanceFromCamera > 0 ? s1.point : _t(d, a2, i2, 1, r, f), l1 = dt(e1.writingMode, i2, n1, _);
                    if (l1) return l1;
                }
                const i3 = pt(g * l.getoffsetX(e1.glyphStartIndex), x, v, o, u, d, e1.segment, e1.lineStartIndex, e1.lineStartIndex + e1.lineLength, c, s, m, p, f);
                if (!i3) return {
                    notEnoughRoom: !0
                };
                y = [
                    i3
                ];
            }
            for (const e2 of y)t1.addDynamicAttributes(h, e2.point, e2.angle);
            return {};
        }
        function _t(t1, e1, i, o, a, r) {
            const s = nt(t1.add(t1.sub(e1)._unit()), a, r).point, n = i.sub(s);
            return i.add(n._mult(o / n.mag()));
        }
        function pt(e1, i, o, a, r, s, n, l, c, h, u, d, m, _) {
            const p = a ? e1 - i : e1 + i;
            let f = p > 0 ? 1 : -1, g = 0;
            a && (f *= -1, g = Math.PI), f < 0 && (g += Math.PI);
            let x = f > 0 ? l + n : l + n + 1, v = r, y = r, b = 0, w = 0;
            const T = Math.abs(p), E = [];
            for(; b + w <= T;){
                if (x += f, x < l || x >= c) return null;
                if (y = v, E.push(v), v = d[x], void 0 === v) {
                    const e2 = new t1.pointGeometry(h.getx(x), h.gety(x)), i1 = nt(e2, u, _);
                    if (i1.signedDistanceFromCamera > 0) v = d[x] = i1.point;
                    else {
                        const i2 = x - f;
                        v = _t(0 === b ? s : new t1.pointGeometry(h.getx(i2), h.gety(i2)), e2, y, T - b + 1, u, _);
                    }
                }
                b += w, w = y.dist(v);
            }
            const I = (T - b) / w, C = v.sub(y), S = C.mult(I)._add(y);
            S._add(C._unit()._perp()._mult(o * f));
            const D = g + Math.atan2(v.y - y.y, v.x - y.x);
            return E.push(S), {
                point: S,
                angle: m ? D : 0,
                path: E
            };
        }
        const ft = new Float32Array([
            -1 / 0,
            -1 / 0,
            0,
            -1 / 0,
            -1 / 0,
            0,
            -1 / 0,
            -1 / 0,
            0,
            -1 / 0,
            -1 / 0,
            0
        ]);
        function gt(t1, e1) {
            for(let i = 0; i < t1; i++){
                const t2 = e1.length;
                e1.resize(t2 + 4), e1.float32.set(ft, 3 * t2);
            }
        }
        function xt(t1, e1, i) {
            const o = e1[0], a = e1[1];
            return t1[0] = i[0] * o + i[4] * a + i[12], t1[1] = i[1] * o + i[5] * a + i[13], t1[3] = i[3] * o + i[7] * a + i[15], t1;
        }
        const vt = 100;
        class yt {
            constructor(t1, e1 = new at(t1.width + 200, t1.height + 200, 25), i = new at(t1.width + 200, t1.height + 200, 25)){
                this.transform = t1, this.grid = e1, this.ignoredGrid = i, this.pitchfactor = Math.cos(t1._pitch) * t1.cameraToCenterDistance, this.screenRightBoundary = t1.width + vt, this.screenBottomBoundary = t1.height + vt, this.gridRightBoundary = t1.width + 200, this.gridBottomBoundary = t1.height + 200, this.perspectiveRatioCutoff = .6;
            }
            placeCollisionBox(t1, e1, i, o, a, r) {
                const s = this.projectAndGetPerspectiveRatio(o, t1.anchorPointX, t1.anchorPointY, r), n = i * s.perspectiveRatio, l = t1.x1 * n + s.point.x, c = t1.y1 * n + s.point.y, h = t1.x2 * n + s.point.x, u = t1.y2 * n + s.point.y;
                return !this.isInsideGrid(l, c, h, u) || "always" !== e1 && this.grid.hitTest(l, c, h, u, e1, a) || s.perspectiveRatio < this.perspectiveRatioCutoff ? {
                    box: [],
                    offscreen: !1
                } : {
                    box: [
                        l,
                        c,
                        h,
                        u
                    ],
                    offscreen: this.isOffscreen(l, c, h, u)
                };
            }
            placeCollisionCircles(e1, i, o, a, r, s, n, l, c, h, u, d, m, _) {
                const p = [], f = new t1.pointGeometry(i.anchorX, i.anchorY), g = nt(f, s, _), x = lt(this.transform.cameraToCenterDistance, g.signedDistanceFromCamera), v = (h ? r / x : r * x) / t1.ONE_EM, y = nt(f, n, _).point, b = ut(v, a, i.lineOffsetX * v, i.lineOffsetY * v, !1, y, f, i, o, n, {}, !1, _);
                let w = !1, T = !1, E = !0;
                if (b) {
                    const i1 = .5 * d * x + m, o1 = new t1.pointGeometry(-100, -100), a1 = new t1.pointGeometry(this.screenRightBoundary, this.screenBottomBoundary), r1 = new it, s1 = b.first, n1 = b.last;
                    let h1 = [];
                    for(let t2 = s1.path.length - 1; t2 >= 1; t2--)h1.push(s1.path[t2]);
                    for(let t3 = 1; t3 < n1.path.length; t3++)h1.push(n1.path[t3]);
                    const f1 = 2.5 * i1;
                    if (l) {
                        const t4 = h1.map((t1)=>nt(t1, l, _));
                        h1 = t4.some((t1)=>t1.signedDistanceFromCamera <= 0) ? [] : t4.map((t1)=>t1.point);
                    }
                    let g1 = [];
                    if (h1.length > 0) {
                        const e2 = h1[0].clone(), i2 = h1[0].clone();
                        for(let t5 = 1; t5 < h1.length; t5++)e2.x = Math.min(e2.x, h1[t5].x), e2.y = Math.min(e2.y, h1[t5].y), i2.x = Math.max(i2.x, h1[t5].x), i2.y = Math.max(i2.y, h1[t5].y);
                        g1 = e2.x >= o1.x && i2.x <= a1.x && e2.y >= o1.y && i2.y <= a1.y ? [
                            h1
                        ] : i2.x < o1.x || e2.x > a1.x || i2.y < o1.y || e2.y > a1.y ? [] : t1.clipLine([
                            h1
                        ], o1.x, o1.y, a1.x, a1.y);
                    }
                    for (const t6 of g1){
                        r1.reset(t6, .25 * i1);
                        let o2 = 0;
                        o2 = r1.length <= .5 * i1 ? 1 : Math.ceil(r1.paddedLength / f1) + 1;
                        for(let t7 = 0; t7 < o2; t7++){
                            const a2 = t7 / Math.max(o2 - 1, 1), s2 = r1.lerp(a2), n2 = s2.x + vt, l1 = s2.y + vt;
                            p.push(n2, l1, i1, 0);
                            const h2 = n2 - i1, d1 = l1 - i1, m1 = n2 + i1, _1 = l1 + i1;
                            if (E = E && this.isOffscreen(h2, d1, m1, _1), T = T || this.isInsideGrid(h2, d1, m1, _1), "always" !== e1 && this.grid.hitTestCircle(n2, l1, i1, e1, u) && (w = !0, !c)) return {
                                circles: [],
                                offscreen: !1,
                                collisionDetected: w
                            };
                        }
                    }
                }
                return {
                    circles: !c && w || !T || x < this.perspectiveRatioCutoff ? [] : p,
                    offscreen: E,
                    collisionDetected: w
                };
            }
            queryRenderedSymbols(e1) {
                if (0 === e1.length || 0 === this.grid.keysLength() && 0 === this.ignoredGrid.keysLength()) return {};
                const i = [];
                let o = 1 / 0, a = 1 / 0, r = -1 / 0, s = -1 / 0;
                for (const n of e1){
                    const e2 = new t1.pointGeometry(n.x + vt, n.y + vt);
                    o = Math.min(o, e2.x), a = Math.min(a, e2.y), r = Math.max(r, e2.x), s = Math.max(s, e2.y), i.push(e2);
                }
                const n1 = this.grid.query(o, a, r, s).concat(this.ignoredGrid.query(o, a, r, s)), l = {}, c = {};
                for (const e3 of n1){
                    const o1 = e3.key;
                    if (void 0 === l[o1.bucketInstanceId] && (l[o1.bucketInstanceId] = {}), l[o1.bucketInstanceId][o1.featureIndex]) continue;
                    const a1 = [
                        new t1.pointGeometry(e3.x1, e3.y1),
                        new t1.pointGeometry(e3.x2, e3.y1),
                        new t1.pointGeometry(e3.x2, e3.y2),
                        new t1.pointGeometry(e3.x1, e3.y2)
                    ];
                    t1.polygonIntersectsPolygon(i, a1) && (l[o1.bucketInstanceId][o1.featureIndex] = !0, void 0 === c[o1.bucketInstanceId] && (c[o1.bucketInstanceId] = []), c[o1.bucketInstanceId].push(o1.featureIndex));
                }
                return c;
            }
            insertCollisionBox(t1, e1, i, o, a, r) {
                (i ? this.ignoredGrid : this.grid).insert({
                    bucketInstanceId: o,
                    featureIndex: a,
                    collisionGroupID: r,
                    overlapMode: e1
                }, t1[0], t1[1], t1[2], t1[3]);
            }
            insertCollisionCircles(t1, e1, i, o, a, r) {
                const s = i ? this.ignoredGrid : this.grid, n = {
                    bucketInstanceId: o,
                    featureIndex: a,
                    collisionGroupID: r,
                    overlapMode: e1
                };
                for(let e2 = 0; e2 < t1.length; e2 += 4)s.insertCircle(n, t1[e2], t1[e2 + 1], t1[e2 + 2]);
            }
            projectAndGetPerspectiveRatio(e1, i, o, a) {
                let r;
                return a ? (r = [
                    i,
                    o,
                    a(i, o),
                    1
                ], t1.transformMat4(r, r, e1)) : (r = [
                    i,
                    o,
                    0,
                    1
                ], xt(r, r, e1)), {
                    point: new t1.pointGeometry((r[0] / r[3] + 1) / 2 * this.transform.width + vt, (-r[1] / r[3] + 1) / 2 * this.transform.height + vt),
                    perspectiveRatio: .5 + this.transform.cameraToCenterDistance / r[3] * .5
                };
            }
            isOffscreen(t1, e1, i, o) {
                return i < vt || t1 >= this.screenRightBoundary || o < vt || e1 > this.screenBottomBoundary;
            }
            isInsideGrid(t1, e1, i, o) {
                return i >= 0 && t1 < this.gridRightBoundary && o >= 0 && e1 < this.gridBottomBoundary;
            }
            getViewportMatrix() {
                const e1 = t1.identity([]);
                return t1.translate(e1, e1, [
                    -100,
                    -100,
                    0
                ]), e1;
            }
        }
        function bt(e1, i, o) {
            return i * (t1.EXTENT / (e1.tileSize * Math.pow(2, o - e1.tileID.overscaledZ)));
        }
        class wt {
            constructor(t1, e1, i, o){
                this.opacity = t1 ? Math.max(0, Math.min(1, t1.opacity + (t1.placed ? e1 : -e1))) : o && i ? 1 : 0, this.placed = i;
            }
            isHidden() {
                return 0 === this.opacity && !this.placed;
            }
        }
        class Tt {
            constructor(t1, e1, i, o, a){
                this.text = new wt(t1 ? t1.text : null, e1, i, a), this.icon = new wt(t1 ? t1.icon : null, e1, o, a);
            }
            isHidden() {
                return this.text.isHidden() && this.icon.isHidden();
            }
        }
        class Et {
            constructor(t1, e1, i){
                this.text = t1, this.icon = e1, this.skipFade = i;
            }
        }
        class It {
            constructor(){
                this.invProjMatrix = t1.create(), this.viewportMatrix = t1.create(), this.circles = [];
            }
        }
        class Ct {
            constructor(t1, e1, i, o, a){
                this.bucketInstanceId = t1, this.featureIndex = e1, this.sourceLayerIndex = i, this.bucketIndex = o, this.tileID = a;
            }
        }
        class St {
            constructor(t1){
                this.crossSourceCollisions = t1, this.maxGroupID = 0, this.collisionGroups = {};
            }
            get(t1) {
                if (this.crossSourceCollisions) return {
                    ID: 0,
                    predicate: null
                };
                if (!this.collisionGroups[t1]) {
                    const e1 = ++this.maxGroupID;
                    this.collisionGroups[t1] = {
                        ID: e1,
                        predicate: (t1)=>t1.collisionGroupID === e1
                    };
                }
                return this.collisionGroups[t1];
            }
        }
        function Dt(e1, i, o, a, r) {
            const { horizontalAlign: s , verticalAlign: n  } = t1.getAnchorAlignment(e1), l = -(s - .5) * i, c = -(n - .5) * o, h = t1.evaluateVariableOffset(e1, a);
            return new t1.pointGeometry(l + h[0] * r, c + h[1] * r);
        }
        function zt(e1, i, o, a, r, s) {
            const { x1: n , x2: l , y1: c , y2: h , anchorPointX: u , anchorPointY: d  } = e1, m = new t1.pointGeometry(i, o);
            return a && m._rotate(r ? s : -s), {
                x1: n + m.x,
                y1: c + m.y,
                x2: l + m.x,
                y2: h + m.y,
                anchorPointX: u,
                anchorPointY: d
            };
        }
        class Pt {
            constructor(t1, e1, i, o, a){
                this.transform = t1.clone(), this.terrain = e1, this.collisionIndex = new yt(this.transform), this.placements = {}, this.opacities = {}, this.variableOffsets = {}, this.stale = !1, this.commitTime = 0, this.fadeDuration = i, this.retainedQueryData = {}, this.collisionGroups = new St(o), this.collisionCircleArrays = {}, this.prevPlacement = a, a && (a.prevPlacement = void 0), this.placedOrientations = {};
            }
            getBucketParts(e1, i, o, a) {
                const r = o.getBucket(i), s = o.latestFeatureIndex;
                if (!r || !s || i.id !== r.layerIds[0]) return;
                const n = o.collisionBoxArray, l = r.layers[0].layout, c = Math.pow(2, this.transform.zoom - o.tileID.overscaledZ), h = o.tileSize / t1.EXTENT, u = this.transform.calculatePosMatrix(o.tileID.toUnwrapped()), d = "map" === l.get("text-pitch-alignment"), m = "map" === l.get("text-rotation-alignment"), _ = bt(o, 1, this.transform.zoom), p = rt(u, d, m, this.transform, _);
                let f = null;
                if (d) {
                    const e2 = st(u, d, m, this.transform, _);
                    f = t1.multiply([], this.transform.labelPlaneMatrix, e2);
                }
                this.retainedQueryData[r.bucketInstanceId] = new Ct(r.bucketInstanceId, s, r.sourceLayerIndex, r.index, o.tileID);
                const g = {
                    bucket: r,
                    layout: l,
                    posMatrix: u,
                    textLabelPlaneMatrix: p,
                    labelToScreenMatrix: f,
                    scale: c,
                    textPixelRatio: h,
                    holdingForFade: o.holdingForFade(),
                    collisionBoxArray: n,
                    partiallyEvaluatedTextSize: t1.evaluateSizeForZoom(r.textSizeData, this.transform.zoom),
                    collisionGroup: this.collisionGroups.get(r.sourceID)
                };
                if (a) for (const t2 of r.sortKeyRanges){
                    const { sortKey: i1 , symbolInstanceStart: o1 , symbolInstanceEnd: a1  } = t2;
                    e1.push({
                        sortKey: i1,
                        symbolInstanceStart: o1,
                        symbolInstanceEnd: a1,
                        parameters: g
                    });
                }
                else e1.push({
                    symbolInstanceStart: 0,
                    symbolInstanceEnd: r.symbolInstances.length,
                    parameters: g
                });
            }
            attemptAnchorPlacement(t1, e1, i, o, a, r, s, n, l, c, h, u, d, m, _, p) {
                const f = [
                    u.textOffset0,
                    u.textOffset1
                ], g = Dt(t1, i, o, f, a), x = this.collisionIndex.placeCollisionBox(zt(e1, g.x, g.y, r, s, this.transform.angle), h, n, l, c.predicate, p);
                if ((!_ || 0 !== this.collisionIndex.placeCollisionBox(zt(_, g.x, g.y, r, s, this.transform.angle), h, n, l, c.predicate, p).box.length) && x.box.length > 0) {
                    let e2;
                    if (this.prevPlacement && this.prevPlacement.variableOffsets[u.crossTileID] && this.prevPlacement.placements[u.crossTileID] && this.prevPlacement.placements[u.crossTileID].text && (e2 = this.prevPlacement.variableOffsets[u.crossTileID].anchor), 0 === u.crossTileID) throw new Error("symbolInstance.crossTileID can't be 0");
                    return this.variableOffsets[u.crossTileID] = {
                        textOffset: f,
                        width: i,
                        height: o,
                        anchor: t1,
                        textBoxScale: a,
                        prevAnchor: e2
                    }, this.markUsedJustification(d, t1, u, m), d.allowVerticalPlacement && (this.markUsedOrientation(d, m, u), this.placedOrientations[u.crossTileID] = m), {
                        shift: g,
                        placedGlyphBoxes: x
                    };
                }
            }
            placeLayerBucketPart(e1, i, o) {
                const { bucket: a , layout: r , posMatrix: s , textLabelPlaneMatrix: n , labelToScreenMatrix: l , textPixelRatio: c , holdingForFade: h , collisionBoxArray: u , partiallyEvaluatedTextSize: d , collisionGroup: m  } = e1.parameters, _ = r.get("text-optional"), p = r.get("icon-optional"), f = t1.getOverlapMode(r, "text-overlap", "text-allow-overlap"), g = "always" === f, x = t1.getOverlapMode(r, "icon-overlap", "icon-allow-overlap"), v = "always" === x, y = "map" === r.get("text-rotation-alignment"), b = "map" === r.get("text-pitch-alignment"), w = "none" !== r.get("icon-text-fit"), T = "viewport-y" === r.get("symbol-z-order"), E = g && (v || !a.hasIconData() || p), I = v && (g || !a.hasTextData() || _);
                !a.collisionArrays && u && a.deserializeCollisionBoxes(u);
                const C = (e1, u)=>{
                    if (i[e1.crossTileID]) return;
                    if (h) return void (this.placements[e1.crossTileID] = new Et(!1, !1, !1));
                    let v = !1, T = !1, C = !0, S = null, D = {
                        box: null,
                        offscreen: null
                    }, z = {
                        box: null,
                        offscreen: null
                    }, P = null, M = null, A = null, L = 0, R = 0, k = 0;
                    u.textFeatureIndex ? L = u.textFeatureIndex : e1.useRuntimeCollisionCircles && (L = e1.featureIndex), u.verticalTextFeatureIndex && (R = u.verticalTextFeatureIndex);
                    const B = this.retainedQueryData[a.bucketInstanceId].tileID, F = this.terrain ? (t1, e1)=>this.terrain.getElevation(B, t1, e1) : null;
                    for (const t2 of [
                        "textBox",
                        "verticalTextBox",
                        "iconBox",
                        "verticalIconBox"
                    ]){
                        const e2 = u[t2];
                        e2 && (e2.elevation = F ? F(e2.anchorPointX, e2.anchorPointY) : 0);
                    }
                    const O = u.textBox;
                    if (O) {
                        const i1 = (i)=>{
                            let o = t1.WritingMode.horizontal;
                            if (a.allowVerticalPlacement && !i && this.prevPlacement) {
                                const t2 = this.prevPlacement.placedOrientations[e1.crossTileID];
                                t2 && (this.placedOrientations[e1.crossTileID] = t2, o = t2, this.markUsedOrientation(a, o, e1));
                            }
                            return o;
                        }, o1 = (i, o)=>{
                            if (a.allowVerticalPlacement && e1.numVerticalGlyphVertices > 0 && u.verticalTextBox) {
                                for (const e2 of a.writingModes)if (e2 === t1.WritingMode.vertical ? (D = o(), z = D) : D = i(), D && D.box && D.box.length) break;
                            } else D = i();
                        };
                        if (r.get("text-variable-anchor")) {
                            let n1 = r.get("text-variable-anchor");
                            if (this.prevPlacement && this.prevPlacement.variableOffsets[e1.crossTileID]) {
                                const t3 = this.prevPlacement.variableOffsets[e1.crossTileID];
                                n1.indexOf(t3.anchor) > 0 && (n1 = n1.filter((e1)=>e1 !== t3.anchor), n1.unshift(t3.anchor));
                            }
                            const l1 = (t1, i, o)=>{
                                const r = t1.x2 - t1.x1, l = t1.y2 - t1.y1, h = e1.textBoxScale, u = w && "never" === x ? i : null;
                                let d = {
                                    box: [],
                                    offscreen: !1
                                };
                                const _ = "never" !== f ? 2 * n1.length : n1.length;
                                for(let i1 = 0; i1 < _; ++i1){
                                    const _1 = this.attemptAnchorPlacement(n1[i1 % n1.length], t1, r, l, h, y, b, c, s, m, i1 >= n1.length ? f : "never", e1, a, o, u, F);
                                    if (_1 && (d = _1.placedGlyphBoxes, d && d.box && d.box.length)) {
                                        v = !0, S = _1.shift;
                                        break;
                                    }
                                }
                                return d;
                            };
                            o1(()=>l1(O, u.iconBox, t1.WritingMode.horizontal), ()=>{
                                const i = u.verticalTextBox;
                                return a.allowVerticalPlacement && !(D && D.box && D.box.length) && e1.numVerticalGlyphVertices > 0 && i ? l1(i, u.verticalIconBox, t1.WritingMode.vertical) : {
                                    box: null,
                                    offscreen: null
                                };
                            }), D && (v = D.box, C = D.offscreen);
                            const h1 = i1(D && D.box);
                            if (!v && this.prevPlacement) {
                                const t4 = this.prevPlacement.variableOffsets[e1.crossTileID];
                                t4 && (this.variableOffsets[e1.crossTileID] = t4, this.markUsedJustification(a, t4.anchor, e1, h1));
                            }
                        } else {
                            const r1 = (t1, i)=>{
                                const o = this.collisionIndex.placeCollisionBox(t1, f, c, s, m.predicate, F);
                                return o && o.box && o.box.length && (this.markUsedOrientation(a, i, e1), this.placedOrientations[e1.crossTileID] = i), o;
                            };
                            o1(()=>r1(O, t1.WritingMode.horizontal), ()=>{
                                const i = u.verticalTextBox;
                                return a.allowVerticalPlacement && e1.numVerticalGlyphVertices > 0 && i ? r1(i, t1.WritingMode.vertical) : {
                                    box: null,
                                    offscreen: null
                                };
                            }), i1(D && D.box && D.box.length);
                        }
                    }
                    if (P = D, v = P && P.box && P.box.length > 0, C = P && P.offscreen, e1.useRuntimeCollisionCircles) {
                        const i2 = a.text.placedSymbolArray.get(e1.centerJustifiedTextSymbolIndex), c1 = t1.evaluateSizeForFeature(a.textSizeData, d, i2), h2 = r.get("text-padding");
                        M = this.collisionIndex.placeCollisionCircles(f, i2, a.lineVertexArray, a.glyphOffsetArray, c1, s, n, l, o, b, m.predicate, e1.collisionCircleDiameter, h2, F), M.circles.length && M.collisionDetected && !o && t1.warnOnce("Collisions detected, but collision boxes are not shown"), v = g || M.circles.length > 0 && !M.collisionDetected, C = C && M.offscreen;
                    }
                    if (u.iconFeatureIndex && (k = u.iconFeatureIndex), u.iconBox) {
                        const t5 = (t1)=>{
                            const e1 = w && S ? zt(t1, S.x, S.y, y, b, this.transform.angle) : t1;
                            return this.collisionIndex.placeCollisionBox(e1, x, c, s, m.predicate, F);
                        };
                        z && z.box && z.box.length && u.verticalIconBox ? (A = t5(u.verticalIconBox), T = A.box.length > 0) : (A = t5(u.iconBox), T = A.box.length > 0), C = C && A.offscreen;
                    }
                    const U = _ || 0 === e1.numHorizontalGlyphVertices && 0 === e1.numVerticalGlyphVertices, N = p || 0 === e1.numIconVertices;
                    if (U || N ? N ? U || (T = T && v) : v = T && v : T = v = T && v, v && P && P.box && this.collisionIndex.insertCollisionBox(P.box, f, r.get("text-ignore-placement"), a.bucketInstanceId, z && z.box && R ? R : L, m.ID), T && A && this.collisionIndex.insertCollisionBox(A.box, x, r.get("icon-ignore-placement"), a.bucketInstanceId, k, m.ID), M && (v && this.collisionIndex.insertCollisionCircles(M.circles, f, r.get("text-ignore-placement"), a.bucketInstanceId, L, m.ID), o)) {
                        const t6 = a.bucketInstanceId;
                        let e3 = this.collisionCircleArrays[t6];
                        void 0 === e3 && (e3 = this.collisionCircleArrays[t6] = new It);
                        for(let t7 = 0; t7 < M.circles.length; t7 += 4)e3.circles.push(M.circles[t7 + 0]), e3.circles.push(M.circles[t7 + 1]), e3.circles.push(M.circles[t7 + 2]), e3.circles.push(M.collisionDetected ? 1 : 0);
                    }
                    if (0 === e1.crossTileID) throw new Error("symbolInstance.crossTileID can't be 0");
                    if (0 === a.bucketInstanceId) throw new Error("bucket.bucketInstanceId can't be 0");
                    this.placements[e1.crossTileID] = new Et(v || E, T || I, C || a.justReloaded), i[e1.crossTileID] = !0;
                };
                if (T) {
                    if (0 !== e1.symbolInstanceStart) throw new Error("bucket.bucketInstanceId should be 0");
                    const t2 = a.getSortedSymbolIndexes(this.transform.angle);
                    for(let e2 = t2.length - 1; e2 >= 0; --e2){
                        const i1 = t2[e2];
                        C(a.symbolInstances.get(i1), a.collisionArrays[i1]);
                    }
                } else for(let t3 = e1.symbolInstanceStart; t3 < e1.symbolInstanceEnd; t3++)C(a.symbolInstances.get(t3), a.collisionArrays[t3]);
                if (o && a.bucketInstanceId in this.collisionCircleArrays) {
                    const e3 = this.collisionCircleArrays[a.bucketInstanceId];
                    t1.invert(e3.invProjMatrix, s), e3.viewportMatrix = this.collisionIndex.getViewportMatrix();
                }
                a.justReloaded = !1;
            }
            markUsedJustification(e1, i, o, a) {
                let r;
                r = a === t1.WritingMode.vertical ? o.verticalPlacedTextSymbolIndex : ({
                    left: o.leftJustifiedTextSymbolIndex,
                    center: o.centerJustifiedTextSymbolIndex,
                    right: o.rightJustifiedTextSymbolIndex
                })[t1.getAnchorJustification(i)];
                const s = [
                    o.leftJustifiedTextSymbolIndex,
                    o.centerJustifiedTextSymbolIndex,
                    o.rightJustifiedTextSymbolIndex,
                    o.verticalPlacedTextSymbolIndex
                ];
                for (const t2 of s)t2 >= 0 && (e1.text.placedSymbolArray.get(t2).crossTileID = r >= 0 && t2 !== r ? 0 : o.crossTileID);
            }
            markUsedOrientation(e1, i, o) {
                const a = i === t1.WritingMode.horizontal || i === t1.WritingMode.horizontalOnly ? i : 0, r = i === t1.WritingMode.vertical ? i : 0, s = [
                    o.leftJustifiedTextSymbolIndex,
                    o.centerJustifiedTextSymbolIndex,
                    o.rightJustifiedTextSymbolIndex
                ];
                for (const t2 of s)e1.text.placedSymbolArray.get(t2).placedOrientation = a;
                o.verticalPlacedTextSymbolIndex && (e1.text.placedSymbolArray.get(o.verticalPlacedTextSymbolIndex).placedOrientation = r);
            }
            commit(t1) {
                this.commitTime = t1, this.zoomAtLastRecencyCheck = this.transform.zoom;
                const e1 = this.prevPlacement;
                let i = !1;
                this.prevZoomAdjustment = e1 ? e1.zoomAdjustment(this.transform.zoom) : 0;
                const o = e1 ? e1.symbolFadeChange(t1) : 1, a = e1 ? e1.opacities : {}, r = e1 ? e1.variableOffsets : {}, s = e1 ? e1.placedOrientations : {};
                for(const t2 in this.placements){
                    const e2 = this.placements[t2], r1 = a[t2];
                    r1 ? (this.opacities[t2] = new Tt(r1, o, e2.text, e2.icon), i = i || e2.text !== r1.text.placed || e2.icon !== r1.icon.placed) : (this.opacities[t2] = new Tt(null, o, e2.text, e2.icon, e2.skipFade), i = i || e2.text || e2.icon);
                }
                for(const t3 in a){
                    const e3 = a[t3];
                    if (!this.opacities[t3]) {
                        const a1 = new Tt(e3, o, !1, !1);
                        a1.isHidden() || (this.opacities[t3] = a1, i = i || e3.text.placed || e3.icon.placed);
                    }
                }
                for(const t4 in r)this.variableOffsets[t4] || !this.opacities[t4] || this.opacities[t4].isHidden() || (this.variableOffsets[t4] = r[t4]);
                for(const t5 in s)this.placedOrientations[t5] || !this.opacities[t5] || this.opacities[t5].isHidden() || (this.placedOrientations[t5] = s[t5]);
                if (e1 && void 0 === e1.lastPlacementChangeTime) throw new Error("Last placement time for previous placement is not defined");
                i ? this.lastPlacementChangeTime = t1 : "number" != typeof this.lastPlacementChangeTime && (this.lastPlacementChangeTime = e1 ? e1.lastPlacementChangeTime : t1);
            }
            updateLayerOpacities(t1, e1) {
                const i = {};
                for (const o of e1){
                    const e2 = o.getBucket(t1);
                    e2 && o.latestFeatureIndex && t1.id === e2.layerIds[0] && this.updateBucketOpacities(e2, i, o.collisionBoxArray);
                }
            }
            updateBucketOpacities(e1, i, o) {
                e1.hasTextData() && e1.text.opacityVertexArray.clear(), e1.hasIconData() && e1.icon.opacityVertexArray.clear(), e1.hasIconCollisionBoxData() && e1.iconCollisionBox.collisionVertexArray.clear(), e1.hasTextCollisionBoxData() && e1.textCollisionBox.collisionVertexArray.clear();
                const a = e1.layers[0].layout, r = new Tt(null, 0, !1, !1, !0), s = a.get("text-allow-overlap"), n = a.get("icon-allow-overlap"), l = a.get("text-variable-anchor"), c = "map" === a.get("text-rotation-alignment"), h = "map" === a.get("text-pitch-alignment"), u = "none" !== a.get("icon-text-fit"), d = new Tt(null, 0, s && (n || !e1.hasIconData() || a.get("icon-optional")), n && (s || !e1.hasTextData() || a.get("text-optional")), !0);
                !e1.collisionArrays && o && (e1.hasIconCollisionBoxData() || e1.hasTextCollisionBoxData()) && e1.deserializeCollisionBoxes(o);
                const m = (t1, e1, i)=>{
                    for(let o = 0; o < e1 / 4; o++)t1.opacityVertexArray.emplaceBack(i);
                };
                for(let o1 = 0; o1 < e1.symbolInstances.length; o1++){
                    const a1 = e1.symbolInstances.get(o1), { numHorizontalGlyphVertices: s1 , numVerticalGlyphVertices: n1 , crossTileID: _  } = a1;
                    let p = this.opacities[_];
                    i[_] ? p = r : p || (p = d, this.opacities[_] = p), i[_] = !0;
                    const f = a1.numIconVertices > 0, g = this.placedOrientations[a1.crossTileID], x = g === t1.WritingMode.vertical, v = g === t1.WritingMode.horizontal || g === t1.WritingMode.horizontalOnly;
                    if (s1 > 0 || n1 > 0) {
                        const t2 = Ut(p.text);
                        m(e1.text, s1, x ? Nt : t2), m(e1.text, n1, v ? Nt : t2);
                        const i1 = p.text.isHidden();
                        [
                            a1.rightJustifiedTextSymbolIndex,
                            a1.centerJustifiedTextSymbolIndex,
                            a1.leftJustifiedTextSymbolIndex
                        ].forEach((t1)=>{
                            t1 >= 0 && (e1.text.placedSymbolArray.get(t1).hidden = i1 || x ? 1 : 0);
                        }), a1.verticalPlacedTextSymbolIndex >= 0 && (e1.text.placedSymbolArray.get(a1.verticalPlacedTextSymbolIndex).hidden = i1 || v ? 1 : 0);
                        const o2 = this.variableOffsets[a1.crossTileID];
                        o2 && this.markUsedJustification(e1, o2.anchor, a1, g);
                        const r1 = this.placedOrientations[a1.crossTileID];
                        r1 && (this.markUsedJustification(e1, "left", a1, r1), this.markUsedOrientation(e1, r1, a1));
                    }
                    if (f) {
                        const t3 = Ut(p.icon), i2 = !(u && a1.verticalPlacedIconSymbolIndex && x);
                        a1.placedIconSymbolIndex >= 0 && (m(e1.icon, a1.numIconVertices, i2 ? t3 : Nt), e1.icon.placedSymbolArray.get(a1.placedIconSymbolIndex).hidden = p.icon.isHidden()), a1.verticalPlacedIconSymbolIndex >= 0 && (m(e1.icon, a1.numVerticalIconVertices, i2 ? Nt : t3), e1.icon.placedSymbolArray.get(a1.verticalPlacedIconSymbolIndex).hidden = p.icon.isHidden());
                    }
                    if (e1.hasIconCollisionBoxData() || e1.hasTextCollisionBoxData()) {
                        const i3 = e1.collisionArrays[o1];
                        if (i3) {
                            let o3 = new t1.pointGeometry(0, 0);
                            if (i3.textBox || i3.verticalTextBox) {
                                let t4 = !0;
                                if (l) {
                                    const e2 = this.variableOffsets[_];
                                    e2 ? (o3 = Dt(e2.anchor, e2.width, e2.height, e2.textOffset, e2.textBoxScale), c && o3._rotate(h ? this.transform.angle : -this.transform.angle)) : t4 = !1;
                                }
                                i3.textBox && Mt(e1.textCollisionBox.collisionVertexArray, p.text.placed, !t4 || x, o3.x, o3.y), i3.verticalTextBox && Mt(e1.textCollisionBox.collisionVertexArray, p.text.placed, !t4 || v, o3.x, o3.y);
                            }
                            const a2 = Boolean(!v && i3.verticalIconBox);
                            i3.iconBox && Mt(e1.iconCollisionBox.collisionVertexArray, p.icon.placed, a2, u ? o3.x : 0, u ? o3.y : 0), i3.verticalIconBox && Mt(e1.iconCollisionBox.collisionVertexArray, p.icon.placed, !a2, u ? o3.x : 0, u ? o3.y : 0);
                        }
                    }
                }
                if (e1.sortFeatures(this.transform.angle), this.retainedQueryData[e1.bucketInstanceId] && (this.retainedQueryData[e1.bucketInstanceId].featureSortOrder = e1.featureSortOrder), e1.hasTextData() && e1.text.opacityVertexBuffer && e1.text.opacityVertexBuffer.updateData(e1.text.opacityVertexArray), e1.hasIconData() && e1.icon.opacityVertexBuffer && e1.icon.opacityVertexBuffer.updateData(e1.icon.opacityVertexArray), e1.hasIconCollisionBoxData() && e1.iconCollisionBox.collisionVertexBuffer && e1.iconCollisionBox.collisionVertexBuffer.updateData(e1.iconCollisionBox.collisionVertexArray), e1.hasTextCollisionBoxData() && e1.textCollisionBox.collisionVertexBuffer && e1.textCollisionBox.collisionVertexBuffer.updateData(e1.textCollisionBox.collisionVertexArray), e1.text.opacityVertexArray.length !== e1.text.layoutVertexArray.length / 4) throw new Error(`bucket.text.opacityVertexArray.length (= ${e1.text.opacityVertexArray.length}) !== bucket.text.layoutVertexArray.length (= ${e1.text.layoutVertexArray.length}) / 4`);
                if (e1.icon.opacityVertexArray.length !== e1.icon.layoutVertexArray.length / 4) throw new Error(`bucket.icon.opacityVertexArray.length (= ${e1.icon.opacityVertexArray.length}) !== bucket.icon.layoutVertexArray.length (= ${e1.icon.layoutVertexArray.length}) / 4`);
                if (e1.bucketInstanceId in this.collisionCircleArrays) {
                    const t5 = this.collisionCircleArrays[e1.bucketInstanceId];
                    e1.placementInvProjMatrix = t5.invProjMatrix, e1.placementViewportMatrix = t5.viewportMatrix, e1.collisionCircleArray = t5.circles, delete this.collisionCircleArrays[e1.bucketInstanceId];
                }
            }
            symbolFadeChange(t1) {
                return 0 === this.fadeDuration ? 1 : (t1 - this.commitTime) / this.fadeDuration + this.prevZoomAdjustment;
            }
            zoomAdjustment(t1) {
                return Math.max(0, (this.transform.zoom - t1) / 1.5);
            }
            hasTransitions(t1) {
                return this.stale || t1 - this.lastPlacementChangeTime < this.fadeDuration;
            }
            stillRecent(t1, e1) {
                const i = this.zoomAtLastRecencyCheck === e1 ? 1 - this.zoomAdjustment(e1) : 1;
                return this.zoomAtLastRecencyCheck = e1, this.commitTime + this.fadeDuration * i > t1;
            }
            setStale() {
                this.stale = !0;
            }
        }
        function Mt(t1, e1, i, o, a) {
            t1.emplaceBack(e1 ? 1 : 0, i ? 1 : 0, o || 0, a || 0), t1.emplaceBack(e1 ? 1 : 0, i ? 1 : 0, o || 0, a || 0), t1.emplaceBack(e1 ? 1 : 0, i ? 1 : 0, o || 0, a || 0), t1.emplaceBack(e1 ? 1 : 0, i ? 1 : 0, o || 0, a || 0);
        }
        const At = Math.pow(2, 25), Lt = Math.pow(2, 24), Rt = Math.pow(2, 17), kt = Math.pow(2, 16), Bt = Math.pow(2, 9), Ft = Math.pow(2, 8), Ot = Math.pow(2, 1);
        function Ut(t1) {
            if (0 === t1.opacity && !t1.placed) return 0;
            if (1 === t1.opacity && t1.placed) return 4294967295;
            const e1 = t1.placed ? 1 : 0, i = Math.floor(127 * t1.opacity);
            return i * At + e1 * Lt + i * Rt + e1 * kt + i * Bt + e1 * Ft + i * Ot + e1;
        }
        const Nt = 0;
        class Gt {
            constructor(t1){
                this._sortAcrossTiles = "viewport-y" !== t1.layout.get("symbol-z-order") && !t1.layout.get("symbol-sort-key").isConstant(), this._currentTileIndex = 0, this._currentPartIndex = 0, this._seenCrossTileIDs = {}, this._bucketParts = [];
            }
            continuePlacement(t1, e1, i, o, a) {
                const r = this._bucketParts;
                for(; this._currentTileIndex < t1.length;)if (e1.getBucketParts(r, o, t1[this._currentTileIndex], this._sortAcrossTiles), this._currentTileIndex++, a()) return !0;
                for(this._sortAcrossTiles && (this._sortAcrossTiles = !1, r.sort((t1, e1)=>t1.sortKey - e1.sortKey)); this._currentPartIndex < r.length;)if (e1.placeLayerBucketPart(r[this._currentPartIndex], this._seenCrossTileIDs, i), this._currentPartIndex++, a()) return !0;
                return !1;
            }
        }
        class Zt {
            constructor(t1, e1, i, o, a, r, s, n){
                this.placement = new Pt(t1, e1, r, s, n), this._currentPlacementIndex = i.length - 1, this._forceFullPlacement = o, this._showCollisionBoxes = a, this._done = !1;
            }
            isDone() {
                return this._done;
            }
            continuePlacement(e1, i, o) {
                const a = t1.exported.now(), r = ()=>{
                    const e1 = t1.exported.now() - a;
                    return !this._forceFullPlacement && e1 > 2;
                };
                for(; this._currentPlacementIndex >= 0;){
                    const t2 = i[e1[this._currentPlacementIndex]], a1 = this.placement.collisionIndex.transform.zoom;
                    if ("symbol" === t2.type && (!t2.minzoom || t2.minzoom <= a1) && (!t2.maxzoom || t2.maxzoom > a1)) {
                        if (this._inProgressLayer || (this._inProgressLayer = new Gt(t2)), this._inProgressLayer.continuePlacement(o[t2.source], this.placement, this._showCollisionBoxes, t2, r)) return;
                        delete this._inProgressLayer;
                    }
                    this._currentPlacementIndex--;
                }
                this._done = !0;
            }
            commit(t1) {
                return this.placement.commit(t1), this.placement;
            }
        }
        const Vt = 512 / t1.EXTENT / 2;
        class qt {
            constructor(t1, e1, i){
                this.tileID = t1, this.indexedSymbolInstances = {}, this.bucketInstanceId = i;
                for(let i1 = 0; i1 < e1.length; i1++){
                    const o = e1.get(i1), a = o.key;
                    this.indexedSymbolInstances[a] || (this.indexedSymbolInstances[a] = []), this.indexedSymbolInstances[a].push({
                        crossTileID: o.crossTileID,
                        coord: this.getScaledCoordinates(o, t1)
                    });
                }
            }
            getScaledCoordinates(e1, i) {
                const o = Vt / Math.pow(2, i.canonical.z - this.tileID.canonical.z);
                return {
                    x: Math.floor((i.canonical.x * t1.EXTENT + e1.anchorX) * o),
                    y: Math.floor((i.canonical.y * t1.EXTENT + e1.anchorY) * o)
                };
            }
            findMatches(t1, e1, i) {
                const o = this.tileID.canonical.z < e1.canonical.z ? 1 : Math.pow(2, this.tileID.canonical.z - e1.canonical.z);
                for(let a = 0; a < t1.length; a++){
                    const r = t1.get(a);
                    if (r.crossTileID) continue;
                    const s = this.indexedSymbolInstances[r.key];
                    if (!s) continue;
                    const n = this.getScaledCoordinates(r, e1);
                    for (const t2 of s)if (Math.abs(t2.coord.x - n.x) <= o && Math.abs(t2.coord.y - n.y) <= o && !i[t2.crossTileID]) {
                        i[t2.crossTileID] = !0, r.crossTileID = t2.crossTileID;
                        break;
                    }
                }
            }
        }
        class jt {
            constructor(){
                this.maxCrossTileID = 0;
            }
            generate() {
                return ++this.maxCrossTileID;
            }
        }
        class $t {
            constructor(){
                this.indexes = {}, this.usedCrossTileIDs = {}, this.lng = 0;
            }
            handleWrapJump(t1) {
                const e1 = Math.round((t1 - this.lng) / 360);
                if (0 !== e1) for(const t2 in this.indexes){
                    const i = this.indexes[t2], o = {};
                    for(const t3 in i){
                        const a = i[t3];
                        a.tileID = a.tileID.unwrapTo(a.tileID.wrap + e1), o[a.tileID.key] = a;
                    }
                    this.indexes[t2] = o;
                }
                this.lng = t1;
            }
            addBucket(t1, e1, i) {
                if (this.indexes[t1.overscaledZ] && this.indexes[t1.overscaledZ][t1.key]) {
                    if (this.indexes[t1.overscaledZ][t1.key].bucketInstanceId === e1.bucketInstanceId) return !1;
                    this.removeBucketCrossTileIDs(t1.overscaledZ, this.indexes[t1.overscaledZ][t1.key]);
                }
                for(let t2 = 0; t2 < e1.symbolInstances.length; t2++)e1.symbolInstances.get(t2).crossTileID = 0;
                this.usedCrossTileIDs[t1.overscaledZ] || (this.usedCrossTileIDs[t1.overscaledZ] = {});
                const o = this.usedCrossTileIDs[t1.overscaledZ];
                for(const i1 in this.indexes){
                    const a = this.indexes[i1];
                    if (Number(i1) > t1.overscaledZ) for(const i2 in a){
                        const r = a[i2];
                        r.tileID.isChildOf(t1) && r.findMatches(e1.symbolInstances, t1, o);
                    }
                    else {
                        const r1 = a[t1.scaledTo(Number(i1)).key];
                        r1 && r1.findMatches(e1.symbolInstances, t1, o);
                    }
                }
                for(let t3 = 0; t3 < e1.symbolInstances.length; t3++){
                    const a1 = e1.symbolInstances.get(t3);
                    a1.crossTileID || (a1.crossTileID = i.generate(), o[a1.crossTileID] = !0);
                }
                return void 0 === this.indexes[t1.overscaledZ] && (this.indexes[t1.overscaledZ] = {}), this.indexes[t1.overscaledZ][t1.key] = new qt(t1, e1.symbolInstances, e1.bucketInstanceId), !0;
            }
            removeBucketCrossTileIDs(t1, e1) {
                for(const i in e1.indexedSymbolInstances)for (const o of e1.indexedSymbolInstances[i])delete this.usedCrossTileIDs[t1][o.crossTileID];
            }
            removeStaleBuckets(t1) {
                let e1 = !1;
                for(const i in this.indexes){
                    const o = this.indexes[i];
                    for(const a in o)t1[o[a].bucketInstanceId] || (this.removeBucketCrossTileIDs(i, o[a]), delete o[a], e1 = !0);
                }
                return e1;
            }
        }
        class Xt {
            constructor(){
                this.layerIndexes = {}, this.crossTileIDs = new jt, this.maxBucketInstanceId = 0, this.bucketsInCurrentPlacement = {};
            }
            addLayer(t1, e1, i) {
                let o = this.layerIndexes[t1.id];
                void 0 === o && (o = this.layerIndexes[t1.id] = new $t);
                let a = !1;
                const r = {};
                o.handleWrapJump(i);
                for (const i1 of e1){
                    const e2 = i1.getBucket(t1);
                    e2 && t1.id === e2.layerIds[0] && (e2.bucketInstanceId || (e2.bucketInstanceId = ++this.maxBucketInstanceId), o.addBucket(i1.tileID, e2, this.crossTileIDs) && (a = !0), r[e2.bucketInstanceId] = !0);
                }
                return o.removeStaleBuckets(r) && (a = !0), a;
            }
            pruneUnusedLayers(t1) {
                const e1 = {};
                t1.forEach((t1)=>{
                    e1[t1] = !0;
                });
                for(const t2 in this.layerIndexes)e1[t2] || delete this.layerIndexes[t2];
            }
        }
        var Wt = t1.createLayout([
            {
                name: "a_pos",
                type: "Int16",
                components: 2
            }
        ]);
        class Ht extends t1.Evented {
            constructor(t1){
                super(), this.sourceCache = t1, this._tiles = {}, this._renderableTilesKeys = [], this._sourceTileCache = {}, this.renderHistory = [], this.minzoom = 0, this.maxzoom = 22, this.tileSize = 512, this.deltaZoom = 1, this.renderHistorySize = t1._cache.max, t1.usedForTerrain = !0, t1.tileSize = this.tileSize * 2 ** this.deltaZoom;
            }
            destruct() {
                this.sourceCache.usedForTerrain = !1, this.sourceCache.tileSize = null;
                for(const t1 in this._tiles){
                    const e1 = this._tiles[t1];
                    e1.textures.forEach((t1)=>t1.destroy()), e1.textures = [];
                }
            }
            update(e1, i) {
                this.sourceCache.update(e1, i), this._renderableTilesKeys = [];
                for (const o of e1.coveringTiles({
                    tileSize: this.tileSize,
                    minzoom: this.minzoom,
                    maxzoom: this.maxzoom,
                    reparseOverscaled: !1,
                    terrain: i
                }))this._renderableTilesKeys.push(o.key), this._tiles[o.key] || (o.posMatrix = new Float64Array(16), t1.ortho(o.posMatrix, 0, t1.EXTENT, 0, t1.EXTENT, 0, 1), this._tiles[o.key] = new k(o, this.tileSize));
            }
            removeOutdated(t1) {
                const e1 = {};
                this.renderHistory = this.renderHistory.filter((t1, e1)=>this.renderHistory.indexOf(t1) === e1).slice(0, this.renderHistorySize);
                for (const t2 of this._renderableTilesKeys)e1[t2] = !0;
                for (const t3 of this.renderHistory)e1[t3] = !0;
                for(const i in this._tiles)e1[i] || (this._tiles[i].clearTextures(t1), delete this._tiles[i]);
            }
            getRenderableTiles() {
                return this._renderableTilesKeys.map((t1)=>this.getTileByID(t1));
            }
            getTileByID(t1) {
                return this._tiles[t1];
            }
            getTerrainCoords(e1) {
                const i = {};
                for (const o of this._renderableTilesKeys){
                    const a = this._tiles[o].tileID;
                    if (a.canonical.equals(e1.canonical)) {
                        const a1 = e1.clone();
                        a1.posMatrix = new Float64Array(16), t1.ortho(a1.posMatrix, 0, t1.EXTENT, 0, t1.EXTENT, 0, 1), i[o] = a1;
                    } else if (a.canonical.isChildOf(e1.canonical)) {
                        const r = e1.clone();
                        r.posMatrix = new Float64Array(16);
                        const s = a.canonical.z - e1.canonical.z, n = a.canonical.x - (a.canonical.x >> s << s), l = a.canonical.y - (a.canonical.y >> s << s), c = t1.EXTENT >> s;
                        t1.ortho(r.posMatrix, 0, c, 0, c, 0, 1), t1.translate(r.posMatrix, r.posMatrix, [
                            -n * c,
                            -l * c,
                            0
                        ]), i[o] = r;
                    } else if (e1.canonical.isChildOf(a.canonical)) {
                        const r1 = e1.clone();
                        r1.posMatrix = new Float64Array(16);
                        const s1 = e1.canonical.z - a.canonical.z, n1 = e1.canonical.x - (e1.canonical.x >> s1 << s1), l1 = e1.canonical.y - (e1.canonical.y >> s1 << s1), c1 = t1.EXTENT >> s1;
                        t1.ortho(r1.posMatrix, 0, t1.EXTENT, 0, t1.EXTENT, 0, 1), t1.translate(r1.posMatrix, r1.posMatrix, [
                            n1 * c1,
                            l1 * c1,
                            0
                        ]), t1.scale(r1.posMatrix, r1.posMatrix, [
                            1 / 2 ** s1,
                            1 / 2 ** s1,
                            0
                        ]), i[o] = r1;
                    }
                }
                return i;
            }
            getSourceTile(t1, e1) {
                const i = this.sourceCache._source;
                let o = t1.overscaledZ - this.deltaZoom;
                if (o > i.maxzoom && (o = i.maxzoom), o < i.minzoom) return null;
                this._sourceTileCache[t1.key] || (this._sourceTileCache[t1.key] = t1.scaledTo(o).key);
                let a = this.sourceCache.getTileByID(this._sourceTileCache[t1.key]);
                if ((!a || !a.dem) && e1) for(; o >= i.minzoom && (!a || !a.dem);)a = this.sourceCache.getTileByID(t1.scaledTo(o--).key);
                return a;
            }
            tilesAfterTime(t1 = Date.now()) {
                return Object.values(this._tiles).filter((e1)=>e1.timeLoaded >= t1);
            }
        }
        class Kt {
            constructor(t1, e1, i){
                this.style = t1, this.sourceCache = new Ht(e1), this.options = i, this.exaggeration = "number" == typeof i.exaggeration ? i.exaggeration : 1, this.elevationOffset = "number" == typeof i.elevationOffset ? i.elevationOffset : 450, this.qualityFactor = 2, this.meshSize = 128, this._demMatrixCache = {}, this.coordsIndex = [], this._coordsTextureSize = 1024, this.clearRerenderCache();
            }
            getDEMElevation(e1, i, o, a = t1.EXTENT) {
                if (!(i >= 0 && i < a && o >= 0 && o < a)) return this.elevationOffset;
                let r = 0;
                const s = this.getTerrainData(e1);
                if (s.tile && s.tile.dem) {
                    const e2 = t1.transformMat4$1([], [
                        i / a * t1.EXTENT,
                        o / a * t1.EXTENT
                    ], s.u_terrain_matrix), n = [
                        e2[0] * s.tile.dem.dim,
                        e2[1] * s.tile.dem.dim
                    ], l = [
                        Math.floor(n[0]),
                        Math.floor(n[1])
                    ], c = s.tile.dem.get(l[0], l[1]), h = s.tile.dem.get(l[0], l[1] + 1), u = s.tile.dem.get(l[0] + 1, l[1]), d = s.tile.dem.get(l[0] + 1, l[1] + 1);
                    r = t1.number(t1.number(c, h, n[0] - l[0]), t1.number(u, d, n[0] - l[0]), n[1] - l[1]);
                }
                return r;
            }
            rememberForRerender(t1, e1) {
                for(const i in this.sourceCache._tiles){
                    const o = this.sourceCache._tiles[i];
                    (o.tileID.equals(e1) || o.tileID.isChildOf(e1)) && (t1 === this.sourceCache.sourceCache.id && (o.timeLoaded = Date.now()), this._rerender[t1] = this._rerender[t1] || {}, this._rerender[t1][o.tileID.key] = !0);
                }
            }
            needsRerender(t1, e1) {
                return this._rerender[t1] && this._rerender[t1][e1.key];
            }
            clearRerenderCache() {
                this._rerender = {};
            }
            getElevation(e1, i, o, a = t1.EXTENT) {
                return (this.getDEMElevation(e1, i, o, a) + this.elevationOffset) * this.exaggeration;
            }
            getTerrainData(e1) {
                if (!this._emptyDemTexture) {
                    const e2 = this.style.map.painter.context, i = new t1.RGBAImage({
                        width: 1,
                        height: 1
                    }, new Uint8Array(4));
                    this._emptyDepthTexture = new l(e2, i, e2.gl.RGBA, {
                        premultiply: !1
                    }), this._emptyDemUnpack = [
                        0,
                        0,
                        0,
                        0
                    ], this._emptyDemTexture = new l(e2, new t1.RGBAImage({
                        width: 1,
                        height: 1
                    }), e2.gl.RGBA, {
                        premultiply: !1
                    }), this._emptyDemTexture.bind(e2.gl.NEAREST, e2.gl.CLAMP_TO_EDGE), this._emptyDemMatrix = t1.identity([]);
                }
                const i1 = this.sourceCache.getSourceTile(e1, !0);
                if (i1 && i1.dem && (!i1.demTexture || i1.needsTerrainPrepare)) {
                    const t2 = this.style.map.painter.context;
                    i1.demTexture = this.style.map.painter.getTileTexture(i1.dem.stride), i1.demTexture ? i1.demTexture.update(i1.dem.getPixels(), {
                        premultiply: !1
                    }) : i1.demTexture = new l(t2, i1.dem.getPixels(), t2.gl.RGBA, {
                        premultiply: !1
                    }), i1.demTexture.bind(t2.gl.NEAREST, t2.gl.CLAMP_TO_EDGE), i1.needsTerrainPrepare = !1;
                }
                const o = i1 && i1 + i1.tileID.key + e1.key;
                if (o && !this._demMatrixCache[o]) {
                    const o1 = this.sourceCache.sourceCache._source.maxzoom;
                    let a = e1.canonical.z - i1.tileID.canonical.z;
                    e1.overscaledZ > e1.canonical.z && (e1.canonical.z >= o1 ? a = e1.canonical.z - o1 : t1.warnOnce("cannot calculate elevation if elevation maxzoom > source.maxzoom"));
                    const r = e1.canonical.x - (e1.canonical.x >> a << a), s = e1.canonical.y - (e1.canonical.y >> a << a), n = t1.fromScaling(new Float64Array(16), [
                        1 / (t1.EXTENT << a),
                        1 / (t1.EXTENT << a),
                        0
                    ]);
                    t1.translate(n, n, [
                        r * t1.EXTENT,
                        s * t1.EXTENT,
                        0
                    ]), this._demMatrixCache[e1.key] = {
                        matrix: n,
                        coord: e1
                    };
                }
                return {
                    u_depth: 2,
                    u_terrain: 3,
                    u_terrain_dim: i1 && i1.dem && i1.dem.dim || 1,
                    u_terrain_matrix: o ? this._demMatrixCache[e1.key].matrix : this._emptyDemMatrix,
                    u_terrain_unpack: i1 && i1.dem && i1.dem.getUnpackVector() || this._emptyDemUnpack,
                    u_terrain_offset: this.elevationOffset,
                    u_terrain_exaggeration: this.exaggeration,
                    texture: (i1 && i1.demTexture || this._emptyDemTexture).texture,
                    depthTexture: (this._fboDepthTexture || this._emptyDepthTexture).texture,
                    tile: i1
                };
            }
            getRTTFramebuffer() {
                const t1 = this.style.map.painter;
                if (!this._rttFramebuffer) {
                    const e1 = this.sourceCache.tileSize * this.qualityFactor;
                    this._rttFramebuffer = t1.context.createFramebuffer(e1, e1, !0), this._rttFramebuffer.depthAttachment.set(t1.context.createRenderbuffer(t1.context.gl.DEPTH_COMPONENT16, e1, e1));
                }
                return this._rttFramebuffer;
            }
            getFramebuffer(t1) {
                const e1 = this.style.map.painter, i = e1.width / devicePixelRatio, o = e1.height / devicePixelRatio;
                return !this._fbo || this._fbo.width === i && this._fbo.height === o || (this._fbo.destroy(), this._fboCoordsTexture.destroy(), this._fboDepthTexture.destroy(), delete this._fbo, delete this._fboDepthTexture, delete this._fboCoordsTexture), this._fboCoordsTexture || (this._fboCoordsTexture = new l(e1.context, {
                    width: i,
                    height: o,
                    data: null
                }, e1.context.gl.RGBA, {
                    premultiply: !1
                }), this._fboCoordsTexture.bind(e1.context.gl.NEAREST, e1.context.gl.CLAMP_TO_EDGE)), this._fboDepthTexture || (this._fboDepthTexture = new l(e1.context, {
                    width: i,
                    height: o,
                    data: null
                }, e1.context.gl.RGBA, {
                    premultiply: !1
                }), this._fboDepthTexture.bind(e1.context.gl.NEAREST, e1.context.gl.CLAMP_TO_EDGE)), this._fbo || (this._fbo = e1.context.createFramebuffer(i, o, !0), this._fbo.depthAttachment.set(e1.context.createRenderbuffer(e1.context.gl.DEPTH_COMPONENT16, i, o))), this._fbo.colorAttachment.set("coords" === t1 ? this._fboCoordsTexture.texture : this._fboDepthTexture.texture), this._fbo;
            }
            getCoordsTexture() {
                const e1 = this.style.map.painter.context;
                if (this._coordsTexture) return this._coordsTexture;
                const i = new Uint8Array(this._coordsTextureSize * this._coordsTextureSize * 4);
                for(let t2 = 0, e2 = 0; t2 < this._coordsTextureSize; t2++)for(let o = 0; o < this._coordsTextureSize; o++, e2 += 4)i[e2 + 0] = 255 & o, i[e2 + 1] = 255 & t2, i[e2 + 2] = o >> 8 << 4 | t2 >> 8, i[e2 + 3] = 0;
                const o1 = new t1.RGBAImage({
                    width: this._coordsTextureSize,
                    height: this._coordsTextureSize
                }, new Uint8Array(i.buffer)), a = new l(e1, o1, e1.gl.RGBA, {
                    premultiply: !1
                });
                return a.bind(e1.gl.NEAREST, e1.gl.CLAMP_TO_EDGE), this._coordsTexture = a, a;
            }
            pointCoordinate(e1) {
                const i = new Uint8Array(4), o = this.style.map.painter, a = o.context, r = a.gl;
                a.bindFramebuffer.set(this.getFramebuffer("coords").framebuffer), r.readPixels(e1.x, o.height / devicePixelRatio - e1.y - 1, 1, 1, r.RGBA, r.UNSIGNED_BYTE, i), a.bindFramebuffer.set(null);
                const s = i[0] + (i[2] >> 4 << 8), n = i[1] + ((15 & i[2]) << 8), l = this.coordsIndex[255 - i[3]], c = l && this.sourceCache.getTileByID(l);
                if (!c) return null;
                const h = this._coordsTextureSize, u = (1 << c.tileID.canonical.z) * h;
                return new t1.MercatorCoordinate((c.tileID.canonical.x * h + s) / u, (c.tileID.canonical.y * h + n) / u, this.getElevation(c.tileID, s, n, h));
            }
            getTerrainMesh() {
                if (this._mesh) return this._mesh;
                const e1 = this.style.map.painter.context, i = new t1.PosArray, o = new t1.TriangleIndexArray, a = this.meshSize, r = t1.EXTENT / a, s = a * a;
                for(let t2 = 0; t2 <= a; t2++)for(let e2 = 0; e2 <= a; e2++)i.emplaceBack(e2 * r, t2 * r);
                for(let t3 = 0; t3 < s; t3 += a + 1)for(let e3 = 0; e3 < a; e3++)o.emplaceBack(e3 + t3, a + e3 + t3 + 1, a + e3 + t3 + 2), o.emplaceBack(e3 + t3, a + e3 + t3 + 2, e3 + t3 + 1);
                return this._mesh = {
                    indexBuffer: e1.createIndexBuffer(o),
                    vertexBuffer: e1.createVertexBuffer(i, Wt.members),
                    segments: t1.SegmentVector.simpleSegment(0, 0, i.length, o.length)
                }, this._mesh;
            }
            getMinMaxElevation(t1) {
                const e1 = this.getTerrainData(t1).tile, i = {
                    minElevation: null,
                    maxElevation: null
                };
                return e1 && e1.dem && (i.minElevation = (e1.dem.min + this.elevationOffset) * this.exaggeration, i.maxElevation = (e1.dem.max + this.elevationOffset) * this.exaggeration), i;
            }
        }
        const Yt = (e1, i)=>t1.emitValidationErrors(e1, i && i.filter((t1)=>"source.canvas" !== t1.identifier)), Jt = t1.pick(W, [
            "addLayer",
            "removeLayer",
            "setPaintProperty",
            "setLayoutProperty",
            "setFilter",
            "addSource",
            "removeSource",
            "setLayerZoomRange",
            "setLight",
            "setTransition",
            "setGeoJSONSourceData"
        ]), Qt = t1.pick(W, [
            "setCenter",
            "setZoom",
            "setBearing",
            "setPitch"
        ]), te = function() {
            const e1 = {}, i = t1.spec.$version;
            for(const o in t1.spec.$root){
                const a = t1.spec.$root[o];
                if (a.required) {
                    let t2 = null;
                    t2 = "version" === o ? i : "array" === a.type ? [] : {}, null != t2 && (e1[o] = t2);
                }
            }
            return e1;
        }();
        class ee extends t1.Evented {
            constructor(e1, i = {}){
                super(), this.map = e1, this.dispatcher = new v(j(), this), this.imageManager = new h, this.imageManager.setEventedParent(this), this.glyphManager = new _(e1._requestManager, i.localIdeographFontFamily), this.lineAtlas = new x(256, 512), this.crossTileSymbolIndex = new Xt, this._layers = {}, this._serializedLayers = {}, this._order = [], this.sourceCaches = {}, this.zoomHistory = new t1.ZoomHistory, this._loaded = !1, this._availableImages = [], this._resetUpdates(), this.dispatcher.broadcast("setReferrer", t1.getReferrer());
                const o = this;
                this._rtlTextPluginCallback = ee.registerForPluginStateChange((e1)=>{
                    o.dispatcher.broadcast("syncRTLPluginState", {
                        pluginStatus: e1.pluginStatus,
                        pluginURL: e1.pluginURL
                    }, (e1, i)=>{
                        if (t1.triggerPluginCompletionEvent(e1), i && i.every((t1)=>t1)) for(const t2 in o.sourceCaches)o.sourceCaches[t2].reload();
                    });
                }), this.on("data", (t1)=>{
                    if ("source" !== t1.dataType || "metadata" !== t1.sourceDataType) return;
                    const e1 = this.sourceCaches[t1.sourceId];
                    if (!e1) return;
                    const i = e1.getSource();
                    if (i && i.vectorLayerIds) for(const t2 in this._layers){
                        const e2 = this._layers[t2];
                        e2.source === i.id && this._validateLayer(e2);
                    }
                });
            }
            loadURL(e1, i = {}) {
                this.fire(new t1.Event("dataloading", {
                    dataType: "style"
                }));
                const o = "boolean" != typeof i.validate || i.validate, a = this.map._requestManager.transformRequest(e1, t1.ResourceType.Style);
                this._request = t1.getJSON(a, (e1, i)=>{
                    this._request = null, e1 ? this.fire(new t1.ErrorEvent(e1)) : i && this._load(i, o);
                });
            }
            loadJSON(e1, i = {}) {
                this.fire(new t1.Event("dataloading", {
                    dataType: "style"
                })), this._request = t1.exported.frame(()=>{
                    this._request = null, this._load(e1, !1 !== i.validate);
                });
            }
            loadEmpty() {
                this.fire(new t1.Event("dataloading", {
                    dataType: "style"
                })), this._load(te, !1);
            }
            _load(e1, i) {
                if (i && Yt(this, t1.validateStyle(e1))) return;
                this._loaded = !0, this.stylesheet = e1;
                for(const t2 in e1.sources)this.addSource(t2, e1.sources[t2], {
                    validate: !1
                });
                e1.sprite ? this._loadSprite(e1.sprite) : this.imageManager.setLoaded(!0), this.glyphManager.setURL(e1.glyphs);
                const o = X(this.stylesheet.layers);
                this._order = o.map((t1)=>t1.id), this._layers = {}, this._serializedLayers = {};
                for (let e2 of o)e2 = t1.createStyleLayer(e2), e2.setEventedParent(this, {
                    layer: {
                        id: e2.id
                    }
                }), this._layers[e2.id] = e2, this._serializedLayers[e2.id] = e2.serialize();
                this.dispatcher.broadcast("setLayers", this._serializeLayers(this._order)), this.light = new g(this.stylesheet.light), this.setTerrain(this.stylesheet.terrain), this.fire(new t1.Event("data", {
                    dataType: "style"
                })), this.fire(new t1.Event("style.load"));
            }
            _loadSprite(e1) {
                this._spriteRequest = function(e1, i, o, a) {
                    let r, s, n;
                    const l = o > 1 ? "@2x" : "";
                    let c = t1.getJSON(i.transformRequest(i.normalizeSpriteURL(e1, l, ".json"), t1.ResourceType.SpriteJSON), (t1, e1)=>{
                        c = null, n || (n = t1, r = e1, u());
                    }), h = t1.getImage(i.transformRequest(i.normalizeSpriteURL(e1, l, ".png"), t1.ResourceType.SpriteImage), (t1, e1)=>{
                        h = null, n || (n = t1, s = e1, u());
                    });
                    function u() {
                        if (n) a(n);
                        else if (r && s) {
                            const e1 = t1.exported.getImageData(s), i = {};
                            for(const o in r){
                                const { width: a1 , height: s1 , x: n1 , y: l , sdf: c , pixelRatio: h , stretchX: u , stretchY: d , content: m  } = r[o], _ = new t1.RGBAImage({
                                    width: a1,
                                    height: s1
                                });
                                t1.RGBAImage.copy(e1, _, {
                                    x: n1,
                                    y: l
                                }, {
                                    x: 0,
                                    y: 0
                                }, {
                                    width: a1,
                                    height: s1
                                }), i[o] = {
                                    data: _,
                                    pixelRatio: h,
                                    sdf: c,
                                    stretchX: u,
                                    stretchY: d,
                                    content: m
                                };
                            }
                            a(null, i);
                        }
                    }
                    return {
                        cancel () {
                            c && (c.cancel(), c = null), h && (h.cancel(), h = null);
                        }
                    };
                }(e1, this.map._requestManager, this.map.getPixelRatio(), (e1, i)=>{
                    if (this._spriteRequest = null, e1) this.fire(new t1.ErrorEvent(e1));
                    else if (i) for(const t2 in i)this.imageManager.addImage(t2, i[t2]);
                    this.imageManager.setLoaded(!0), this._availableImages = this.imageManager.listImages(), this.dispatcher.broadcast("setImages", this._availableImages), this.fire(new t1.Event("data", {
                        dataType: "style"
                    }));
                });
            }
            _validateLayer(e1) {
                const i = this.sourceCaches[e1.source];
                if (!i) return;
                const o = e1.sourceLayer;
                if (!o) return;
                const a = i.getSource();
                ("geojson" === a.type || a.vectorLayerIds && -1 === a.vectorLayerIds.indexOf(o)) && this.fire(new t1.ErrorEvent(new Error(`Source layer "${o}" does not exist on source "${a.id}" as specified by style layer "${e1.id}".`)));
            }
            loaded() {
                if (!this._loaded) return !1;
                if (Object.keys(this._updatedSources).length) return !1;
                for(const t1 in this.sourceCaches)if (!this.sourceCaches[t1].loaded()) return !1;
                return !!this.imageManager.isLoaded();
            }
            _serializeLayers(t1) {
                const e1 = [];
                for (const i of t1){
                    const t2 = this._layers[i];
                    "custom" !== t2.type && e1.push(t2.serialize());
                }
                return e1;
            }
            hasTransitions() {
                if (this.light && this.light.hasTransition()) return !0;
                for(const t1 in this.sourceCaches)if (this.sourceCaches[t1].hasTransition()) return !0;
                for(const t2 in this._layers)if (this._layers[t2].hasTransition()) return !0;
                return !1;
            }
            _checkLoaded() {
                if (!this._loaded) throw new Error("Style is not done loading.");
            }
            update(e1) {
                if (!this._loaded) return;
                const i = this._changed;
                if (this._changed) {
                    const t2 = Object.keys(this._updatedLayers), i1 = Object.keys(this._removedLayers);
                    (t2.length || i1.length) && this._updateWorkerLayers(t2, i1);
                    for(const t3 in this._updatedSources){
                        const e2 = this._updatedSources[t3];
                        if ("reload" === e2) this._reloadSource(t3);
                        else {
                            if ("clear" !== e2) throw new Error(`Invalid action ${e2}`);
                            this._clearSource(t3);
                        }
                    }
                    this._updateTilesForChangedImages();
                    for(const t4 in this._updatedPaintProps)this._layers[t4].updateTransitions(e1);
                    this.light.updateTransitions(e1), this._resetUpdates();
                }
                const o = {};
                for(const t5 in this.sourceCaches){
                    const e3 = this.sourceCaches[t5];
                    o[t5] = e3.used, e3.used = !1;
                }
                for (const t6 of this._order){
                    const i2 = this._layers[t6];
                    i2.recalculate(e1, this._availableImages), !i2.isHidden(e1.zoom) && i2.source && (this.sourceCaches[i2.source].used = !0);
                }
                for(const e4 in o){
                    const i3 = this.sourceCaches[e4];
                    o[e4] !== i3.used && i3.fire(new t1.Event("data", {
                        sourceDataType: "visibility",
                        dataType: "source",
                        sourceId: e4
                    }));
                }
                this.light.recalculate(e1), this.z = e1.zoom, i && this.fire(new t1.Event("data", {
                    dataType: "style"
                }));
            }
            _updateTilesForChangedImages() {
                const t1 = Object.keys(this._changedImages);
                if (t1.length) {
                    for(const e1 in this.sourceCaches)this.sourceCaches[e1].reloadTilesForDependencies([
                        "icons",
                        "patterns"
                    ], t1);
                    this._changedImages = {};
                }
            }
            _updateWorkerLayers(t1, e1) {
                this.dispatcher.broadcast("updateLayers", {
                    layers: this._serializeLayers(t1),
                    removedIds: e1
                });
            }
            _resetUpdates() {
                this._changed = !1, this._updatedLayers = {}, this._removedLayers = {}, this._updatedSources = {}, this._updatedPaintProps = {}, this._changedImages = {};
            }
            setTerrain(e1) {
                if (this._checkLoaded(), this._terrainDataCallback && this.off("data", this._terrainDataCallback), this._terrainfreezeElevationCallback && this.map.off("freezeElevation", this._terrainfreezeElevationCallback), e1) {
                    const t2 = this.sourceCaches[e1.source];
                    if (!t2) throw new Error(`cannot load terrain, because there exists no source with ID: ${e1.source}`);
                    this.terrain = new Kt(this, t2, e1), this.map.transform.updateElevation(this.terrain), this._terrainfreezeElevationCallback = (t1)=>{
                        t1.freeze ? this.map.transform.freezeElevation = !0 : (this.map.transform.freezeElevation = !1, this.map.transform.recalculateZoom(this.terrain));
                    }, this._terrainDataCallback = (t1)=>{
                        t1.tile && (t1.sourceId === e1.source ? (this.map.transform.updateElevation(this.terrain), this.terrain.rememberForRerender(t1.sourceId, t1.tile.tileID)) : "geojson" === t1.source.type && this.terrain.rememberForRerender(t1.sourceId, t1.tile.tileID));
                    }, this.on("data", this._terrainDataCallback), this.map.on("freezeElevation", this._terrainfreezeElevationCallback);
                } else this.terrain && this.terrain.sourceCache.destruct(), this.terrain = null, this.map.transform.updateElevation(this.terrain);
                this.map.fire(new t1.Event("terrain", {
                    terrain: e1
                }));
            }
            setState(e1) {
                if (this._checkLoaded(), Yt(this, t1.validateStyle(e1))) return !1;
                (e1 = t1.clone$1(e1)).layers = X(e1.layers);
                const i = (function(t1, e1) {
                    if (!t1) return [
                        {
                            command: W.setStyle,
                            args: [
                                e1
                            ]
                        }
                    ];
                    let i = [];
                    try {
                        if (!a(t1.version, e1.version)) return [
                            {
                                command: W.setStyle,
                                args: [
                                    e1
                                ]
                            }
                        ];
                        a(t1.center, e1.center) || i.push({
                            command: W.setCenter,
                            args: [
                                e1.center
                            ]
                        }), a(t1.zoom, e1.zoom) || i.push({
                            command: W.setZoom,
                            args: [
                                e1.zoom
                            ]
                        }), a(t1.bearing, e1.bearing) || i.push({
                            command: W.setBearing,
                            args: [
                                e1.bearing
                            ]
                        }), a(t1.pitch, e1.pitch) || i.push({
                            command: W.setPitch,
                            args: [
                                e1.pitch
                            ]
                        }), a(t1.sprite, e1.sprite) || i.push({
                            command: W.setSprite,
                            args: [
                                e1.sprite
                            ]
                        }), a(t1.glyphs, e1.glyphs) || i.push({
                            command: W.setGlyphs,
                            args: [
                                e1.glyphs
                            ]
                        }), a(t1.transition, e1.transition) || i.push({
                            command: W.setTransition,
                            args: [
                                e1.transition
                            ]
                        }), a(t1.light, e1.light) || i.push({
                            command: W.setLight,
                            args: [
                                e1.light
                            ]
                        });
                        const o = {}, r = [];
                        !function(t1, e1, i, o) {
                            let r;
                            for(r in e1 = e1 || {}, t1 = t1 || {})Object.prototype.hasOwnProperty.call(t1, r) && (Object.prototype.hasOwnProperty.call(e1, r) || K(r, i, o));
                            for(r in e1)Object.prototype.hasOwnProperty.call(e1, r) && (Object.prototype.hasOwnProperty.call(t1, r) ? a(t1[r], e1[r]) || ("geojson" === t1[r].type && "geojson" === e1[r].type && J(t1, e1, r) ? i.push({
                                command: W.setGeoJSONSourceData,
                                args: [
                                    r,
                                    e1[r].data
                                ]
                            }) : Y(r, e1, i, o)) : H(r, e1, i));
                        }(t1.sources, e1.sources, r, o);
                        const s = [];
                        t1.layers && t1.layers.forEach((t1)=>{
                            o[t1.source] ? i.push({
                                command: W.removeLayer,
                                args: [
                                    t1.id
                                ]
                            }) : s.push(t1);
                        }), i = i.concat(r), function(t1, e1, i) {
                            e1 = e1 || [];
                            const o = (t1 = t1 || []).map(tt), r = e1.map(tt), s = t1.reduce(et, {}), n = e1.reduce(et, {}), l = o.slice(), c = Object.create(null);
                            let h, u, d, m, _, p, f;
                            for(h = 0, u = 0; h < o.length; h++)d = o[h], Object.prototype.hasOwnProperty.call(n, d) ? u++ : (i.push({
                                command: W.removeLayer,
                                args: [
                                    d
                                ]
                            }), l.splice(l.indexOf(d, u), 1));
                            for(h = 0, u = 0; h < r.length; h++)d = r[r.length - 1 - h], l[l.length - 1 - h] !== d && (Object.prototype.hasOwnProperty.call(s, d) ? (i.push({
                                command: W.removeLayer,
                                args: [
                                    d
                                ]
                            }), l.splice(l.lastIndexOf(d, l.length - u), 1)) : u++, p = l[l.length - h], i.push({
                                command: W.addLayer,
                                args: [
                                    n[d],
                                    p
                                ]
                            }), l.splice(l.length - h, 0, d), c[d] = !0);
                            for(h = 0; h < r.length; h++)if (d = r[h], m = s[d], _ = n[d], !c[d] && !a(m, _)) {
                                if (a(m.source, _.source) && a(m["source-layer"], _["source-layer"]) && a(m.type, _.type)) {
                                    for(f in Q(m.layout, _.layout, i, d, null, W.setLayoutProperty), Q(m.paint, _.paint, i, d, null, W.setPaintProperty), a(m.filter, _.filter) || i.push({
                                        command: W.setFilter,
                                        args: [
                                            d,
                                            _.filter
                                        ]
                                    }), a(m.minzoom, _.minzoom) && a(m.maxzoom, _.maxzoom) || i.push({
                                        command: W.setLayerZoomRange,
                                        args: [
                                            d,
                                            _.minzoom,
                                            _.maxzoom
                                        ]
                                    }), m)Object.prototype.hasOwnProperty.call(m, f) && "layout" !== f && "paint" !== f && "filter" !== f && "metadata" !== f && "minzoom" !== f && "maxzoom" !== f && (0 === f.indexOf("paint.") ? Q(m[f], _[f], i, d, f.slice(6), W.setPaintProperty) : a(m[f], _[f]) || i.push({
                                        command: W.setLayerProperty,
                                        args: [
                                            d,
                                            f,
                                            _[f]
                                        ]
                                    }));
                                    for(f in _)Object.prototype.hasOwnProperty.call(_, f) && !Object.prototype.hasOwnProperty.call(m, f) && "layout" !== f && "paint" !== f && "filter" !== f && "metadata" !== f && "minzoom" !== f && "maxzoom" !== f && (0 === f.indexOf("paint.") ? Q(m[f], _[f], i, d, f.slice(6), W.setPaintProperty) : a(m[f], _[f]) || i.push({
                                        command: W.setLayerProperty,
                                        args: [
                                            d,
                                            f,
                                            _[f]
                                        ]
                                    }));
                                } else i.push({
                                    command: W.removeLayer,
                                    args: [
                                        d
                                    ]
                                }), p = l[l.lastIndexOf(d) + 1], i.push({
                                    command: W.addLayer,
                                    args: [
                                        _,
                                        p
                                    ]
                                });
                            }
                        }(s, e1.layers, i);
                    } catch (t2) {
                        console.warn("Unable to compute style diff:", t2), i = [
                            {
                                command: W.setStyle,
                                args: [
                                    e1
                                ]
                            }
                        ];
                    }
                    return i;
                })(this.serialize(), e1).filter((t1)=>!(t1.command in Qt));
                if (0 === i.length) return !1;
                const o = i.filter((t1)=>!(t1.command in Jt));
                if (o.length > 0) throw new Error(`Unimplemented: ${o.map((t1)=>t1.command).join(", ")}.`);
                return i.forEach((t1)=>{
                    "setTransition" !== t1.command && this[t1.command].apply(this, t1.args);
                }), this.stylesheet = e1, !0;
            }
            addImage(e1, i) {
                if (this.getImage(e1)) return this.fire(new t1.ErrorEvent(new Error(`An image named "${e1}" already exists.`)));
                this.imageManager.addImage(e1, i), this._afterImageUpdated(e1);
            }
            updateImage(t1, e1) {
                this.imageManager.updateImage(t1, e1);
            }
            getImage(t1) {
                return this.imageManager.getImage(t1);
            }
            removeImage(e1) {
                if (!this.getImage(e1)) return this.fire(new t1.ErrorEvent(new Error(`An image named "${e1}" does not exist.`)));
                this.imageManager.removeImage(e1), this._afterImageUpdated(e1);
            }
            _afterImageUpdated(e1) {
                this._availableImages = this.imageManager.listImages(), this._changedImages[e1] = !0, this._changed = !0, this.dispatcher.broadcast("setImages", this._availableImages), this.fire(new t1.Event("data", {
                    dataType: "style"
                }));
            }
            listImages() {
                return this._checkLoaded(), this.imageManager.listImages();
            }
            addSource(e1, i, o = {}) {
                if (this._checkLoaded(), void 0 !== this.sourceCaches[e1]) throw new Error(`Source "${e1}" already exists.`);
                if (!i.type) throw new Error(`The type property must be defined, but only the following properties were given: ${Object.keys(i).join(", ")}.`);
                if ([
                    "vector",
                    "raster",
                    "geojson",
                    "video",
                    "image"
                ].indexOf(i.type) >= 0 && this._validate(t1.validateStyle.source, `sources.${e1}`, i, null, o)) return;
                this.map && this.map._collectResourceTiming && (i.collectResourceTiming = !0);
                const a = this.sourceCaches[e1] = new O(e1, i, this.dispatcher);
                a.style = this, a.setEventedParent(this, ()=>({
                        isSourceLoaded: this.loaded(),
                        source: a.serialize(),
                        sourceId: e1
                    })), a.onAdd(this.map), this._changed = !0;
            }
            removeSource(e1) {
                if (this._checkLoaded(), void 0 === this.sourceCaches[e1]) throw new Error("There is no source with this ID");
                for(const i in this._layers)if (this._layers[i].source === e1) return this.fire(new t1.ErrorEvent(new Error(`Source "${e1}" cannot be removed while layer "${i}" is using it.`)));
                const i1 = this.sourceCaches[e1];
                delete this.sourceCaches[e1], delete this._updatedSources[e1], i1.fire(new t1.Event("data", {
                    sourceDataType: "metadata",
                    dataType: "source",
                    sourceId: e1
                })), i1.setEventedParent(null), i1.onRemove(this.map), this._changed = !0;
            }
            setGeoJSONSourceData(t1, e1) {
                if (this._checkLoaded(), void 0 === this.sourceCaches[t1]) throw new Error(`There is no source with this ID=${t1}`);
                const i = this.sourceCaches[t1].getSource();
                if ("geojson" !== i.type) throw new Error(`geojsonSource.type is ${i.type}, which is !== 'geojson`);
                i.setData(e1), this._changed = !0;
            }
            getSource(t1) {
                return this.sourceCaches[t1] && this.sourceCaches[t1].getSource();
            }
            addLayer(e1, i, o = {}) {
                this._checkLoaded();
                const a = e1.id;
                if (this.getLayer(a)) return void this.fire(new t1.ErrorEvent(new Error(`Layer "${a}" already exists on this map.`)));
                let r;
                if ("custom" === e1.type) {
                    if (Yt(this, t1.validateCustomStyleLayer(e1))) return;
                    r = t1.createStyleLayer(e1);
                } else {
                    if ("object" == typeof e1.source && (this.addSource(a, e1.source), e1 = t1.clone$1(e1), e1 = t1.extend(e1, {
                        source: a
                    })), this._validate(t1.validateStyle.layer, `layers.${a}`, e1, {
                        arrayIndex: -1
                    }, o)) return;
                    r = t1.createStyleLayer(e1), this._validateLayer(r), r.setEventedParent(this, {
                        layer: {
                            id: a
                        }
                    }), this._serializedLayers[r.id] = r.serialize();
                }
                const s = i ? this._order.indexOf(i) : this._order.length;
                if (i && -1 === s) this.fire(new t1.ErrorEvent(new Error(`Cannot add layer "${a}" before non-existing layer "${i}".`)));
                else {
                    if (this._order.splice(s, 0, a), this._layerOrderChanged = !0, this._layers[a] = r, this._removedLayers[a] && r.source && "custom" !== r.type) {
                        const t2 = this._removedLayers[a];
                        delete this._removedLayers[a], t2.type !== r.type ? this._updatedSources[r.source] = "clear" : (this._updatedSources[r.source] = "reload", this.sourceCaches[r.source].pause());
                    }
                    this._updateLayer(r), r.onAdd && r.onAdd(this.map);
                }
            }
            moveLayer(e1, i) {
                if (this._checkLoaded(), this._changed = !0, !this._layers[e1]) return void this.fire(new t1.ErrorEvent(new Error(`The layer '${e1}' does not exist in the map's style and cannot be moved.`)));
                if (e1 === i) return;
                const o = this._order.indexOf(e1);
                this._order.splice(o, 1);
                const a = i ? this._order.indexOf(i) : this._order.length;
                i && -1 === a ? this.fire(new t1.ErrorEvent(new Error(`Cannot move layer "${e1}" before non-existing layer "${i}".`))) : (this._order.splice(a, 0, e1), this._layerOrderChanged = !0);
            }
            removeLayer(e1) {
                this._checkLoaded();
                const i = this._layers[e1];
                if (!i) return void this.fire(new t1.ErrorEvent(new Error(`Cannot remove non-existing layer "${e1}".`)));
                i.setEventedParent(null);
                const o = this._order.indexOf(e1);
                this._order.splice(o, 1), this._layerOrderChanged = !0, this._changed = !0, this._removedLayers[e1] = i, delete this._layers[e1], delete this._serializedLayers[e1], delete this._updatedLayers[e1], delete this._updatedPaintProps[e1], i.onRemove && i.onRemove(this.map);
            }
            getLayer(t1) {
                return this._layers[t1];
            }
            hasLayer(t1) {
                return t1 in this._layers;
            }
            setLayerZoomRange(e1, i, o) {
                this._checkLoaded();
                const a = this.getLayer(e1);
                a ? a.minzoom === i && a.maxzoom === o || (null != i && (a.minzoom = i), null != o && (a.maxzoom = o), this._updateLayer(a)) : this.fire(new t1.ErrorEvent(new Error(`Cannot set the zoom range of non-existing layer "${e1}".`)));
            }
            setFilter(e1, i, o = {}) {
                this._checkLoaded();
                const r = this.getLayer(e1);
                if (r) {
                    if (!a(r.filter, i)) return null == i ? (r.filter = void 0, void this._updateLayer(r)) : void (this._validate(t1.validateStyle.filter, `layers.${r.id}.filter`, i, null, o) || (r.filter = t1.clone$1(i), this._updateLayer(r)));
                } else this.fire(new t1.ErrorEvent(new Error(`Cannot filter non-existing layer "${e1}".`)));
            }
            getFilter(e1) {
                return t1.clone$1(this.getLayer(e1).filter);
            }
            setLayoutProperty(e1, i, o, r = {}) {
                this._checkLoaded();
                const s = this.getLayer(e1);
                s ? a(s.getLayoutProperty(i), o) || (s.setLayoutProperty(i, o, r), this._updateLayer(s)) : this.fire(new t1.ErrorEvent(new Error(`Cannot style non-existing layer "${e1}".`)));
            }
            getLayoutProperty(e1, i) {
                const o = this.getLayer(e1);
                if (o) return o.getLayoutProperty(i);
                this.fire(new t1.ErrorEvent(new Error(`Cannot get style of non-existing layer "${e1}".`)));
            }
            setPaintProperty(e1, i, o, r = {}) {
                this._checkLoaded();
                const s = this.getLayer(e1);
                s ? a(s.getPaintProperty(i), o) || (s.setPaintProperty(i, o, r) && this._updateLayer(s), this._changed = !0, this._updatedPaintProps[e1] = !0) : this.fire(new t1.ErrorEvent(new Error(`Cannot style non-existing layer "${e1}".`)));
            }
            getPaintProperty(t1, e1) {
                return this.getLayer(t1).getPaintProperty(e1);
            }
            setFeatureState(e1, i) {
                this._checkLoaded();
                const o = e1.source, a = e1.sourceLayer, r = this.sourceCaches[o];
                if (void 0 === r) return void this.fire(new t1.ErrorEvent(new Error(`The source '${o}' does not exist in the map's style.`)));
                const s = r.getSource().type;
                "geojson" === s && a ? this.fire(new t1.ErrorEvent(new Error("GeoJSON sources cannot have a sourceLayer parameter."))) : "vector" !== s || a ? (void 0 === e1.id && this.fire(new t1.ErrorEvent(new Error("The feature id parameter must be provided."))), r.setFeatureState(a, e1.id, i)) : this.fire(new t1.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
            }
            removeFeatureState(e1, i) {
                this._checkLoaded();
                const o = e1.source, a = this.sourceCaches[o];
                if (void 0 === a) return void this.fire(new t1.ErrorEvent(new Error(`The source '${o}' does not exist in the map's style.`)));
                const r = a.getSource().type, s = "vector" === r ? e1.sourceLayer : void 0;
                "vector" !== r || s ? i && "string" != typeof e1.id && "number" != typeof e1.id ? this.fire(new t1.ErrorEvent(new Error("A feature id is required to remove its specific state property."))) : a.removeFeatureState(s, e1.id, i) : this.fire(new t1.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
            }
            getFeatureState(e1) {
                this._checkLoaded();
                const i = e1.source, o = e1.sourceLayer, a = this.sourceCaches[i];
                if (void 0 !== a) return "vector" !== a.getSource().type || o ? (void 0 === e1.id && this.fire(new t1.ErrorEvent(new Error("The feature id parameter must be provided."))), a.getFeatureState(o, e1.id)) : void this.fire(new t1.ErrorEvent(new Error("The sourceLayer parameter must be provided for vector source types.")));
                this.fire(new t1.ErrorEvent(new Error(`The source '${i}' does not exist in the map's style.`)));
            }
            getTransition() {
                return t1.extend({
                    duration: 300,
                    delay: 0
                }, this.stylesheet && this.stylesheet.transition);
            }
            serialize() {
                return t1.filterObject({
                    version: this.stylesheet.version,
                    name: this.stylesheet.name,
                    metadata: this.stylesheet.metadata,
                    light: this.stylesheet.light,
                    center: this.stylesheet.center,
                    zoom: this.stylesheet.zoom,
                    bearing: this.stylesheet.bearing,
                    pitch: this.stylesheet.pitch,
                    sprite: this.stylesheet.sprite,
                    glyphs: this.stylesheet.glyphs,
                    transition: this.stylesheet.transition,
                    sources: t1.mapObject(this.sourceCaches, (t1)=>t1.serialize()),
                    layers: this._serializeLayers(this._order)
                }, (t1)=>void 0 !== t1);
            }
            _updateLayer(t1) {
                this._updatedLayers[t1.id] = !0, t1.source && !this._updatedSources[t1.source] && "raster" !== this.sourceCaches[t1.source].getSource().type && (this._updatedSources[t1.source] = "reload", this.sourceCaches[t1.source].pause()), this._changed = !0;
            }
            _flattenAndSortRenderedFeatures(t1) {
                const e1 = (t1)=>"fill-extrusion" === this._layers[t1].type, i = {}, o = [];
                for(let a = this._order.length - 1; a >= 0; a--){
                    const r = this._order[a];
                    if (e1(r)) {
                        i[r] = a;
                        for (const e2 of t1){
                            const t2 = e2[r];
                            if (t2) for (const e3 of t2)o.push(e3);
                        }
                    }
                }
                o.sort((t1, e1)=>e1.intersectionZ - t1.intersectionZ);
                const a1 = [];
                for(let r1 = this._order.length - 1; r1 >= 0; r1--){
                    const s = this._order[r1];
                    if (e1(s)) for(let t3 = o.length - 1; t3 >= 0; t3--){
                        const e4 = o[t3].feature;
                        if (i[e4.layer.id] < r1) break;
                        a1.push(e4), o.pop();
                    }
                    else for (const e5 of t1){
                        const t4 = e5[s];
                        if (t4) for (const e6 of t4)a1.push(e6.feature);
                    }
                }
                return a1;
            }
            queryRenderedFeatures(e1, i, o) {
                i && i.filter && this._validate(t1.validateStyle.filter, "queryRenderedFeatures.filter", i.filter, null, i);
                const a = {};
                if (i && i.layers) {
                    if (!Array.isArray(i.layers)) return this.fire(new t1.ErrorEvent(new Error("parameters.layers must be an Array."))), [];
                    for (const e2 of i.layers){
                        const i1 = this._layers[e2];
                        if (!i1) return this.fire(new t1.ErrorEvent(new Error(`The layer '${e2}' does not exist in the map's style and cannot be queried for features.`))), [];
                        a[i1.source] = !0;
                    }
                }
                const r = [];
                i.availableImages = this._availableImages;
                for(const t2 in this.sourceCaches)i.layers && !a[t2] || r.push(L(this.sourceCaches[t2], this._layers, this._serializedLayers, e1, i, o));
                return this.placement && r.push(function(t1, e1, i, o, a, r, s) {
                    const n = {}, l = r.queryRenderedSymbols(o), c = [];
                    for (const t2 of Object.keys(l).map(Number))c.push(s[t2]);
                    c.sort(R);
                    for (const i1 of c){
                        const o1 = i1.featureIndex.lookupSymbolFeatures(l[i1.bucketInstanceId], e1, i1.bucketIndex, i1.sourceLayerIndex, a.filter, a.layers, a.availableImages, t1);
                        for(const t3 in o1){
                            const e2 = n[t3] = n[t3] || [], a1 = o1[t3];
                            a1.sort((t1, e1)=>{
                                const o = i1.featureSortOrder;
                                if (o) {
                                    const i = o.indexOf(t1.featureIndex);
                                    return o.indexOf(e1.featureIndex) - i;
                                }
                                return e1.featureIndex - t1.featureIndex;
                            });
                            for (const t4 of a1)e2.push(t4);
                        }
                    }
                    for(const e3 in n)n[e3].forEach((o)=>{
                        const a = o.feature, r = i[t1[e3].source].getFeatureState(a.layer["source-layer"], a.id);
                        a.source = a.layer.source, a.layer["source-layer"] && (a.sourceLayer = a.layer["source-layer"]), a.state = r;
                    });
                    return n;
                }(this._layers, this._serializedLayers, this.sourceCaches, e1, i, this.placement.collisionIndex, this.placement.retainedQueryData)), this._flattenAndSortRenderedFeatures(r);
            }
            querySourceFeatures(e1, i) {
                i && i.filter && this._validate(t1.validateStyle.filter, "querySourceFeatures.filter", i.filter, null, i);
                const o = this.sourceCaches[e1];
                return o ? function(t1, e1) {
                    const i = t1.getRenderableIds().map((e1)=>t1.getTileByID(e1)), o = [], a = {};
                    for(let t2 = 0; t2 < i.length; t2++){
                        const r = i[t2], s = r.tileID.canonical.key;
                        a[s] || (a[s] = !0, r.querySourceFeatures(o, e1));
                    }
                    return o;
                }(o, i) : [];
            }
            addSourceType(t1, e1, i) {
                return ee.getSourceType(t1) ? i(new Error(`A source type called "${t1}" already exists.`)) : (ee.setSourceType(t1, e1), e1.workerSourceURL ? void this.dispatcher.broadcast("loadWorkerSource", {
                    name: t1,
                    url: e1.workerSourceURL
                }, i) : i(null, null));
            }
            getLight() {
                return this.light.getLight();
            }
            setLight(e1, i = {}) {
                this._checkLoaded();
                const o = this.light.getLight();
                let r = !1;
                for(const t2 in e1)if (!a(e1[t2], o[t2])) {
                    r = !0;
                    break;
                }
                if (!r) return;
                const s = {
                    now: t1.exported.now(),
                    transition: t1.extend({
                        duration: 300,
                        delay: 0
                    }, this.stylesheet.transition)
                };
                this.light.setLight(e1, i), this.light.updateTransitions(s);
            }
            _validate(e1, i, o, a, r = {}) {
                return (!r || !1 !== r.validate) && Yt(this, e1.call(t1.validateStyle, t1.extend({
                    key: i,
                    style: this.serialize(),
                    value: o,
                    styleSpec: t1.spec
                }, a)));
            }
            _remove() {
                this._request && (this._request.cancel(), this._request = null), this._spriteRequest && (this._spriteRequest.cancel(), this._spriteRequest = null), t1.evented.off("pluginStateChange", this._rtlTextPluginCallback);
                for(const t2 in this._layers)this._layers[t2].setEventedParent(null);
                for(const t3 in this.sourceCaches){
                    const e1 = this.sourceCaches[t3];
                    e1.setEventedParent(null), e1.onRemove(this.map);
                }
                this.imageManager.setEventedParent(null), this.setEventedParent(null), this.dispatcher.remove();
            }
            _clearSource(t1) {
                this.sourceCaches[t1].clearTiles();
            }
            _reloadSource(t1) {
                this.sourceCaches[t1].resume(), this.sourceCaches[t1].reload();
            }
            _updateSources(t1) {
                for(const e1 in this.sourceCaches)this.sourceCaches[e1].update(t1, this.terrain);
            }
            _generateCollisionBoxes() {
                for(const t1 in this.sourceCaches)this._reloadSource(t1);
            }
            _updatePlacement(e1, i, o, a, r = !1) {
                let s = !1, n = !1;
                const l = {};
                for (const t2 of this._order){
                    const i1 = this._layers[t2];
                    if ("symbol" !== i1.type) continue;
                    if (!l[i1.source]) {
                        const t3 = this.sourceCaches[i1.source];
                        l[i1.source] = t3.getRenderableIds(!0).map((e1)=>t3.getTileByID(e1)).sort((t1, e1)=>e1.tileID.overscaledZ - t1.tileID.overscaledZ || (t1.tileID.isLessThan(e1.tileID) ? -1 : 1));
                    }
                    const o1 = this.crossTileSymbolIndex.addLayer(i1, l[i1.source], e1.center.lng);
                    s = s || o1;
                }
                if (this.crossTileSymbolIndex.pruneUnusedLayers(this._order), ((r = r || this._layerOrderChanged || 0 === o) || !this.pauseablePlacement || this.pauseablePlacement.isDone() && !this.placement.stillRecent(t1.exported.now(), e1.zoom)) && (this.pauseablePlacement = new Zt(e1, this.terrain, this._order, r, i, o, a, this.placement), this._layerOrderChanged = !1), this.pauseablePlacement.isDone() ? this.placement.setStale() : (this.pauseablePlacement.continuePlacement(this._order, this._layers, l), this.pauseablePlacement.isDone() && (this.placement = this.pauseablePlacement.commit(t1.exported.now()), n = !0), s && this.pauseablePlacement.placement.setStale()), n || s) for (const t4 of this._order){
                    const e2 = this._layers[t4];
                    "symbol" === e2.type && this.placement.updateLayerOpacities(e2, l[e2.source]);
                }
                return !this.pauseablePlacement.isDone() || this.placement.hasTransitions(t1.exported.now());
            }
            _releaseSymbolFadeTiles() {
                for(const t1 in this.sourceCaches)this.sourceCaches[t1].releaseSymbolFadeTiles();
            }
            getImages(t1, e1, i) {
                this.imageManager.getImages(e1.icons, i), this._updateTilesForChangedImages();
                const o = this.sourceCaches[e1.source];
                o && o.setDependencies(e1.tileID.key, e1.type, e1.icons);
            }
            getGlyphs(t1, e1, i) {
                this.glyphManager.getGlyphs(e1.stacks, i);
            }
            getResource(e1, i, o) {
                return t1.makeRequest(i, o);
            }
        }
        ee.getSourceType = function(t1) {
            return M[t1];
        }, ee.setSourceType = function(t1, e1) {
            M[t1] = e1;
        }, ee.registerForPluginStateChange = t1.registerForPluginStateChange;
        var ie = "attribute vec2 a_pos;uniform mat4 u_matrix;varying vec2 v_texture_pos;varying float v_depth;void main() {v_texture_pos=a_pos/8192.0;gl_Position=u_matrix*vec4(a_pos,get_elevation(a_pos),1.0);v_depth=gl_Position.z/gl_Position.w;}";
        const oe = {
            prelude: ae("#ifdef GL_ES\nprecision mediump float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif", "#ifdef GL_ES\nprecision highp float;\n#else\n#if !defined(lowp)\n#define lowp\n#endif\n#if !defined(mediump)\n#define mediump\n#endif\n#if !defined(highp)\n#define highp\n#endif\n#endif\nvec2 unpack_float(const float packedValue) {int packedIntValue=int(packedValue);int v0=packedIntValue/256;return vec2(v0,packedIntValue-v0*256);}vec2 unpack_opacity(const float packedOpacity) {int intOpacity=int(packedOpacity)/2;return vec2(float(intOpacity)/127.0,mod(packedOpacity,2.0));}vec4 decode_color(const vec2 encodedColor) {return vec4(unpack_float(encodedColor[0])/255.0,unpack_float(encodedColor[1])/255.0\n);}float unpack_mix_vec2(const vec2 packedValue,const float t) {return mix(packedValue[0],packedValue[1],t);}vec4 unpack_mix_color(const vec4 packedColors,const float t) {vec4 minColor=decode_color(vec2(packedColors[0],packedColors[1]));vec4 maxColor=decode_color(vec2(packedColors[2],packedColors[3]));return mix(minColor,maxColor,t);}vec2 get_pattern_pos(const vec2 pixel_coord_upper,const vec2 pixel_coord_lower,const vec2 pattern_size,const float tile_units_to_pixels,const vec2 pos) {vec2 offset=mod(mod(mod(pixel_coord_upper,pattern_size)*256.0,pattern_size)*256.0+pixel_coord_lower,pattern_size);return (tile_units_to_pixels*pos+offset)/pattern_size;}\n#ifdef TERRAIN3D\nuniform sampler2D u_terrain;uniform float u_terrain_dim;uniform mat4 u_terrain_matrix;uniform vec4 u_terrain_unpack;uniform float u_terrain_offset;uniform float u_terrain_exaggeration;uniform highp sampler2D u_depth;\n#endif\nconst highp vec4 bitSh=vec4(256.*256.*256.,256.*256.,256.,1.);const highp vec4 bitShifts=vec4(1.)/bitSh;highp float unpack(highp vec4 color) {return dot(color,bitShifts);}highp float depthOpacity(vec3 frag) {\n#ifdef TERRAIN3D\nhighp float d=unpack(texture2D(u_depth,frag.xy*0.5+0.5))+0.0001-frag.z;return 1.0-max(0.0,min(1.0,-d*500.0));\n#else\nreturn 1.0;\n#endif\n}float calculate_visibility(vec4 pos) {\n#ifdef TERRAIN3D\nvec3 frag=pos.xyz/pos.w;highp float d=depthOpacity(frag);if (d > 0.95) return 1.0;return (d+depthOpacity(frag+vec3(0.0,0.01,0.0)))/2.0;\n#else\nreturn 1.0;\n#endif\n}float ele(vec2 pos) {\n#ifdef TERRAIN3D\nvec4 rgb=(texture2D(u_terrain,pos)*255.0)*u_terrain_unpack;return rgb.r+rgb.g+rgb.b-u_terrain_unpack.a;\n#else\nreturn 0.0;\n#endif\n}float get_elevation(vec2 pos) {\n#ifdef TERRAIN3D\nvec2 coord=(u_terrain_matrix*vec4(pos,0.0,1.0)).xy*u_terrain_dim+1.0;vec2 f=fract(coord);vec2 c=(floor(coord)+0.5)/(u_terrain_dim+2.0);float d=1.0/(u_terrain_dim+2.0);float tl=ele(c);float tr=ele(c+vec2(d,0.0));float bl=ele(c+vec2(0.0,d));float br=ele(c+vec2(d,d));float elevation=mix(mix(tl,tr,f.x),mix(bl,br,f.x),f.y);return (elevation+u_terrain_offset)*u_terrain_exaggeration;\n#else\nreturn 0.0;\n#endif\n}"),
            background: ae("uniform vec4 u_color;uniform float u_opacity;void main() {gl_FragColor=u_color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"),
            backgroundPattern: ae("uniform vec2 u_pattern_tl_a;uniform vec2 u_pattern_br_a;uniform vec2 u_pattern_tl_b;uniform vec2 u_pattern_br_b;uniform vec2 u_texsize;uniform float u_mix;uniform float u_opacity;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(u_pattern_tl_a/u_texsize,u_pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(u_pattern_tl_b/u_texsize,u_pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_mix)*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pattern_size_a;uniform vec2 u_pattern_size_b;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_scale_a;uniform float u_scale_b;uniform float u_tile_units_to_pixels;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_a*u_pattern_size_a,u_tile_units_to_pixels,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,u_scale_b*u_pattern_size_b,u_tile_units_to_pixels,a_pos);}"),
            circle: ae("varying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=v_data.xy;float extrude_length=length(extrude);lowp float antialiasblur=v_data.z;float antialiased_blur=-max(blur,antialiasblur);float opacity_t=smoothstep(0.0,antialiased_blur,extrude_length-1.0);float color_t=stroke_width < 0.01 ? 0.0 : smoothstep(antialiased_blur,0.0,extrude_length-radius/(radius+stroke_width));gl_FragColor=v_visibility*opacity_t*mix(color*opacity,stroke_color*stroke_opacity,color_t);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform bool u_scale_with_map;uniform bool u_pitch_with_map;uniform vec2 u_extrude_scale;uniform lowp float u_device_pixel_ratio;uniform highp float u_camera_to_center_distance;attribute vec2 a_pos;varying vec3 v_data;varying float v_visibility;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define mediump float radius\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define highp vec4 stroke_color\n#pragma mapbox: define mediump float stroke_width\n#pragma mapbox: define lowp float stroke_opacity\nvoid main(void) {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize mediump float radius\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize highp vec4 stroke_color\n#pragma mapbox: initialize mediump float stroke_width\n#pragma mapbox: initialize lowp float stroke_opacity\nvec2 extrude=vec2(mod(a_pos,2.0)*2.0-1.0);vec2 circle_center=floor(a_pos*0.5);float ele=get_elevation(circle_center);v_visibility=calculate_visibility(u_matrix*vec4(circle_center,ele,1.0));if (u_pitch_with_map) {vec2 corner_position=circle_center;if (u_scale_with_map) {corner_position+=extrude*(radius+stroke_width)*u_extrude_scale;} else {vec4 projected_center=u_matrix*vec4(circle_center,0,1);corner_position+=extrude*(radius+stroke_width)*u_extrude_scale*(projected_center.w/u_camera_to_center_distance);}gl_Position=u_matrix*vec4(corner_position,ele,1);} else {gl_Position=u_matrix*vec4(circle_center,ele,1);if (u_scale_with_map) {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*u_camera_to_center_distance;} else {gl_Position.xy+=extrude*(radius+stroke_width)*u_extrude_scale*gl_Position.w;}}lowp float antialiasblur=1.0/u_device_pixel_ratio/(radius+stroke_width);v_data=vec3(extrude.x,extrude.y,antialiasblur);}"),
            clippingMask: ae("void main() {gl_FragColor=vec4(1.0);}", "attribute vec2 a_pos;uniform mat4 u_matrix;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);}"),
            heatmap: ae("uniform highp float u_intensity;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#define GAUSS_COEF 0.3989422804014327\nvoid main() {\n#pragma mapbox: initialize highp float weight\nfloat d=-0.5*3.0*3.0*dot(v_extrude,v_extrude);float val=weight*u_intensity*GAUSS_COEF*exp(d);gl_FragColor=vec4(val,1.0,1.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform float u_extrude_scale;uniform float u_opacity;uniform float u_intensity;attribute vec2 a_pos;varying vec2 v_extrude;\n#pragma mapbox: define highp float weight\n#pragma mapbox: define mediump float radius\nconst highp float ZERO=1.0/255.0/16.0;\n#define GAUSS_COEF 0.3989422804014327\nvoid main(void) {\n#pragma mapbox: initialize highp float weight\n#pragma mapbox: initialize mediump float radius\nvec2 unscaled_extrude=vec2(mod(a_pos,2.0)*2.0-1.0);float S=sqrt(-2.0*log(ZERO/weight/u_intensity/GAUSS_COEF))/3.0;v_extrude=S*unscaled_extrude;vec2 extrude=v_extrude*radius*u_extrude_scale;vec4 pos=vec4(floor(a_pos*0.5)+extrude,0,1);gl_Position=u_matrix*pos;}"),
            heatmapTexture: ae("uniform sampler2D u_image;uniform sampler2D u_color_ramp;uniform float u_opacity;varying vec2 v_pos;void main() {float t=texture2D(u_image,v_pos).r;vec4 color=texture2D(u_color_ramp,vec2(t,0.5));gl_FragColor=color*u_opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(0.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_world;attribute vec2 a_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos*u_world,0,1);v_pos.x=a_pos.x;v_pos.y=1.0-a_pos.y;}"),
            collisionBox: ae("varying float v_placed;varying float v_notUsed;void main() {float alpha=0.5;gl_FragColor=vec4(1.0,0.0,0.0,1.0)*alpha;if (v_placed > 0.5) {gl_FragColor=vec4(0.0,0.0,1.0,0.5)*alpha;}if (v_notUsed > 0.5) {gl_FragColor*=.1;}}", "attribute vec2 a_pos;attribute vec2 a_anchor_pos;attribute vec2 a_extrude;attribute vec2 a_placed;attribute vec2 a_shift;uniform mat4 u_matrix;uniform vec2 u_extrude_scale;uniform float u_camera_to_center_distance;varying float v_placed;varying float v_notUsed;void main() {vec4 projectedPoint=u_matrix*vec4(a_anchor_pos,0,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);gl_Position=u_matrix*vec4(a_pos,get_elevation(a_pos),1.0);gl_Position.xy+=(a_extrude+a_shift)*u_extrude_scale*gl_Position.w*collision_perspective_ratio;v_placed=a_placed.x;v_notUsed=a_placed.y;}"),
            collisionCircle: ae("varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;void main() {float alpha=0.5*min(v_perspective_ratio,1.0);float stroke_radius=0.9*max(v_perspective_ratio,1.0);float distance_to_center=length(v_extrude);float distance_to_edge=abs(distance_to_center-v_radius);float opacity_t=smoothstep(-stroke_radius,0.0,-distance_to_edge);vec4 color=mix(vec4(0.0,0.0,1.0,0.5),vec4(1.0,0.0,0.0,1.0),v_collision);gl_FragColor=color*alpha*opacity_t;}", "attribute vec2 a_pos;attribute float a_radius;attribute vec2 a_flags;uniform mat4 u_matrix;uniform mat4 u_inv_matrix;uniform vec2 u_viewport_size;uniform float u_camera_to_center_distance;varying float v_radius;varying vec2 v_extrude;varying float v_perspective_ratio;varying float v_collision;vec3 toTilePosition(vec2 screenPos) {vec4 rayStart=u_inv_matrix*vec4(screenPos,-1.0,1.0);vec4 rayEnd  =u_inv_matrix*vec4(screenPos, 1.0,1.0);rayStart.xyz/=rayStart.w;rayEnd.xyz  /=rayEnd.w;highp float t=(0.0-rayStart.z)/(rayEnd.z-rayStart.z);return mix(rayStart.xyz,rayEnd.xyz,t);}void main() {vec2 quadCenterPos=a_pos;float radius=a_radius;float collision=a_flags.x;float vertexIdx=a_flags.y;vec2 quadVertexOffset=vec2(mix(-1.0,1.0,float(vertexIdx >=2.0)),mix(-1.0,1.0,float(vertexIdx >=1.0 && vertexIdx <=2.0)));vec2 quadVertexExtent=quadVertexOffset*radius;vec3 tilePos=toTilePosition(quadCenterPos);vec4 clipPos=u_matrix*vec4(tilePos,1.0);highp float camera_to_anchor_distance=clipPos.w;highp float collision_perspective_ratio=clamp(0.5+0.5*(u_camera_to_center_distance/camera_to_anchor_distance),0.0,4.0);float padding_factor=1.2;v_radius=radius;v_extrude=quadVertexExtent*padding_factor;v_perspective_ratio=collision_perspective_ratio;v_collision=collision;gl_Position=vec4(clipPos.xyz/clipPos.w,1.0)+vec4(quadVertexExtent*padding_factor/u_viewport_size*2.0,0.0,0.0);}"),
            debug: ae("uniform highp vec4 u_color;uniform sampler2D u_overlay;varying vec2 v_uv;void main() {vec4 overlay_color=texture2D(u_overlay,v_uv);gl_FragColor=mix(u_color,overlay_color,overlay_color.a);}", "attribute vec2 a_pos;varying vec2 v_uv;uniform mat4 u_matrix;uniform float u_overlay_scale;void main() {v_uv=a_pos/8192.0;gl_Position=u_matrix*vec4(a_pos*u_overlay_scale,get_elevation(a_pos),1);}"),
            fill: ae("#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_FragColor=color*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);}"),
            fillOutline: ae("varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=outline_color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "attribute vec2 a_pos;uniform mat4 u_matrix;uniform vec2 u_world;varying vec2 v_pos;\n#pragma mapbox: define highp vec4 outline_color\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 outline_color\n#pragma mapbox: initialize lowp float opacity\ngl_Position=u_matrix*vec4(a_pos,0,1);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}"),
            fillOutlinePattern: ae("uniform vec2 u_texsize;uniform sampler2D u_image;uniform float u_fade;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);float dist=length(v_pos-gl_FragCoord.xy);float alpha=1.0-smoothstep(0.0,1.0,dist);gl_FragColor=mix(color1,color2,u_fade)*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_world;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec2 v_pos;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;gl_Position=u_matrix*vec4(a_pos,0,1);vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,a_pos);v_pos=(gl_Position.xy/gl_Position.w+1.0)/2.0*u_world;}"),
            fillPattern: ae("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);gl_FragColor=mix(color1,color2,u_fade)*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform vec3 u_scale;attribute vec2 a_pos;varying vec2 v_pos_a;varying vec2 v_pos_b;\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;gl_Position=u_matrix*vec4(a_pos,0,1);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileZoomRatio,a_pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileZoomRatio,a_pos);}"),
            fillExtrusion: ae("varying vec4 v_color;void main() {gl_FragColor=v_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;uniform float u_vertical_gradient;uniform lowp float u_opacity;attribute vec2 a_pos;attribute vec4 a_normal_ed;\n#ifdef TERRAIN3D\nattribute vec2 a_centroid;\n#endif\nvarying vec4 v_color;\n#pragma mapbox: define highp float base\n#pragma mapbox: define highp float height\n#pragma mapbox: define highp vec4 color\nvoid main() {\n#pragma mapbox: initialize highp float base\n#pragma mapbox: initialize highp float height\n#pragma mapbox: initialize highp vec4 color\nvec3 normal=a_normal_ed.xyz;\n#ifdef TERRAIN3D\nfloat baseDelta=10.0;float ele=get_elevation(a_centroid);\n#else\nfloat baseDelta=0.0;float ele=0.0;\n#endif\nbase=max(0.0,ele+base-baseDelta);height=max(0.0,ele+height);float t=mod(normal.x,2.0);gl_Position=u_matrix*vec4(a_pos,t > 0.0 ? height : base,1);float colorvalue=color.r*0.2126+color.g*0.7152+color.b*0.0722;v_color=vec4(0.0,0.0,0.0,1.0);vec4 ambientlight=vec4(0.03,0.03,0.03,1.0);color+=ambientlight;float directional=clamp(dot(normal/16384.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((1.0-colorvalue+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_color.r+=clamp(color.r*directional*u_lightcolor.r,mix(0.0,0.3,1.0-u_lightcolor.r),1.0);v_color.g+=clamp(color.g*directional*u_lightcolor.g,mix(0.0,0.3,1.0-u_lightcolor.g),1.0);v_color.b+=clamp(color.b*directional*u_lightcolor.b,mix(0.0,0.3,1.0-u_lightcolor.b),1.0);v_color*=u_opacity;}"),
            fillExtrusionPattern: ae("uniform vec2 u_texsize;uniform float u_fade;uniform sampler2D u_image;varying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;vec2 imagecoord=mod(v_pos_a,1.0);vec2 pos=mix(pattern_tl_a/u_texsize,pattern_br_a/u_texsize,imagecoord);vec4 color1=texture2D(u_image,pos);vec2 imagecoord_b=mod(v_pos_b,1.0);vec2 pos2=mix(pattern_tl_b/u_texsize,pattern_br_b/u_texsize,imagecoord_b);vec4 color2=texture2D(u_image,pos2);vec4 mixedColor=mix(color1,color2,u_fade);gl_FragColor=mixedColor*v_lighting;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_pixel_coord_upper;uniform vec2 u_pixel_coord_lower;uniform float u_height_factor;uniform vec3 u_scale;uniform float u_vertical_gradient;uniform lowp float u_opacity;uniform vec3 u_lightcolor;uniform lowp vec3 u_lightpos;uniform lowp float u_lightintensity;attribute vec2 a_pos;attribute vec4 a_normal_ed;\n#ifdef TERRAIN3D\nattribute vec2 a_centroid;\n#endif\nvarying vec2 v_pos_a;varying vec2 v_pos_b;varying vec4 v_lighting;\n#pragma mapbox: define lowp float base\n#pragma mapbox: define lowp float height\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float base\n#pragma mapbox: initialize lowp float height\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec3 normal=a_normal_ed.xyz;float edgedistance=a_normal_ed.w;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;\n#ifdef TERRAIN3D\nfloat baseDelta=10.0;float ele=get_elevation(a_centroid);\n#else\nfloat baseDelta=0.0;float ele=0.0;\n#endif\nbase=max(0.0,ele+base-baseDelta);height=max(0.0,ele+height);float t=mod(normal.x,2.0);float z=t > 0.0 ? height : base;gl_Position=u_matrix*vec4(a_pos,z,1);vec2 pos=normal.x==1.0 && normal.y==0.0 && normal.z==16384.0\n? a_pos\n: vec2(edgedistance,z*u_height_factor);v_pos_a=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,fromScale*display_size_a,tileRatio,pos);v_pos_b=get_pattern_pos(u_pixel_coord_upper,u_pixel_coord_lower,toScale*display_size_b,tileRatio,pos);v_lighting=vec4(0.0,0.0,0.0,1.0);float directional=clamp(dot(normal/16383.0,u_lightpos),0.0,1.0);directional=mix((1.0-u_lightintensity),max((0.5+u_lightintensity),1.0),directional);if (normal.y !=0.0) {directional*=((1.0-u_vertical_gradient)+(u_vertical_gradient*clamp((t+base)*pow(height/150.0,0.5),mix(0.7,0.98,1.0-u_lightintensity),1.0)));}v_lighting.rgb+=clamp(directional*u_lightcolor,mix(vec3(0.0),vec3(0.3),1.0-u_lightcolor),vec3(1.0));v_lighting*=u_opacity;}"),
            hillshadePrepare: ae("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_dimension;uniform float u_zoom;uniform vec4 u_unpack;float getElevation(vec2 coord,float bias) {vec4 data=texture2D(u_image,coord)*255.0;data.a=-1.0;return dot(data,u_unpack)/4.0;}void main() {vec2 epsilon=1.0/u_dimension;float a=getElevation(v_pos+vec2(-epsilon.x,-epsilon.y),0.0);float b=getElevation(v_pos+vec2(0,-epsilon.y),0.0);float c=getElevation(v_pos+vec2(epsilon.x,-epsilon.y),0.0);float d=getElevation(v_pos+vec2(-epsilon.x,0),0.0);float e=getElevation(v_pos,0.0);float f=getElevation(v_pos+vec2(epsilon.x,0),0.0);float g=getElevation(v_pos+vec2(-epsilon.x,epsilon.y),0.0);float h=getElevation(v_pos+vec2(0,epsilon.y),0.0);float i=getElevation(v_pos+vec2(epsilon.x,epsilon.y),0.0);float exaggerationFactor=u_zoom < 2.0 ? 0.4 : u_zoom < 4.5 ? 0.35 : 0.3;float exaggeration=u_zoom < 15.0 ? (u_zoom-15.0)*exaggerationFactor : 0.0;vec2 deriv=vec2((c+f+f+i)-(a+d+d+g),(g+h+h+i)-(a+b+b+c))/pow(2.0,exaggeration+(19.2562-u_zoom));gl_FragColor=clamp(vec4(deriv.x/2.0+0.5,deriv.y/2.0+0.5,1.0,1.0),0.0,1.0);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_dimension;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);highp vec2 epsilon=1.0/u_dimension;float scale=(u_dimension.x-2.0)/u_dimension.x;v_pos=(a_texture_pos/8192.0)*scale+epsilon;}"),
            hillshade: ae("uniform sampler2D u_image;varying vec2 v_pos;uniform vec2 u_latrange;uniform vec2 u_light;uniform vec4 u_shadow;uniform vec4 u_highlight;uniform vec4 u_accent;\n#define PI 3.141592653589793\nvoid main() {vec4 pixel=texture2D(u_image,v_pos);vec2 deriv=((pixel.rg*2.0)-1.0);float scaleFactor=cos(radians((u_latrange[0]-u_latrange[1])*(1.0-v_pos.y)+u_latrange[1]));float slope=atan(1.25*length(deriv)/scaleFactor);float aspect=deriv.x !=0.0 ? atan(deriv.y,-deriv.x) : PI/2.0*(deriv.y > 0.0 ? 1.0 :-1.0);float intensity=u_light.x;float azimuth=u_light.y+PI;float base=1.875-intensity*1.75;float maxValue=0.5*PI;float scaledSlope=intensity !=0.5 ? ((pow(base,slope)-1.0)/(pow(base,maxValue)-1.0))*maxValue : slope;float accent=cos(scaledSlope);vec4 accent_color=(1.0-accent)*u_accent*clamp(intensity*2.0,0.0,1.0);float shade=abs(mod((aspect+azimuth)/PI+0.5,2.0)-1.0);vec4 shade_color=mix(u_shadow,u_highlight,shade)*sin(scaledSlope)*clamp(intensity*2.0,0.0,1.0);gl_FragColor=accent_color*(1.0-shade_color.a)+shade_color;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos=a_texture_pos/8192.0;}"),
            line: ae("uniform lowp float u_device_pixel_ratio;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform vec2 u_units_to_pixels;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp float v_linesofar;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;v_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*2.0;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_width2=vec2(outset,inset);}"),
            lineGradient: ae("uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;varying vec2 v_width2;varying vec2 v_normal;varying float v_gamma_scale;varying highp vec2 v_uv;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);vec4 color=texture2D(u_image,v_uv);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define scale 0.015873016\nattribute vec2 a_pos_normal;attribute vec4 a_data;attribute float a_uv_x;attribute float a_split_index;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_units_to_pixels;uniform float u_image_height;varying vec2 v_normal;varying vec2 v_width2;varying float v_gamma_scale;varying highp vec2 v_uv;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;highp float texel_height=1.0/u_image_height;highp float half_texel_height=0.5*texel_height;v_uv=vec2(a_uv_x,a_split_index*texel_height-half_texel_height);vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_width2=vec2(outset,inset);}"),
            linePattern: ae("#ifdef GL_ES\nprecision highp float;\n#endif\nuniform lowp float u_device_pixel_ratio;uniform vec2 u_texsize;uniform float u_fade;uniform mediump vec3 u_scale;uniform sampler2D u_image;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\nvec2 pattern_tl_a=pattern_from.xy;vec2 pattern_br_a=pattern_from.zw;vec2 pattern_tl_b=pattern_to.xy;vec2 pattern_br_b=pattern_to.zw;float tileZoomRatio=u_scale.x;float fromScale=u_scale.y;float toScale=u_scale.z;vec2 display_size_a=(pattern_br_a-pattern_tl_a)/pixel_ratio_from;vec2 display_size_b=(pattern_br_b-pattern_tl_b)/pixel_ratio_to;vec2 pattern_size_a=vec2(display_size_a.x*fromScale/tileZoomRatio,display_size_a.y);vec2 pattern_size_b=vec2(display_size_b.x*toScale/tileZoomRatio,display_size_b.y);float aspect_a=display_size_a.y/v_width;float aspect_b=display_size_b.y/v_width;float dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float x_a=mod(v_linesofar/pattern_size_a.x*aspect_a,1.0);float x_b=mod(v_linesofar/pattern_size_b.x*aspect_b,1.0);float y=0.5*v_normal.y+0.5;vec2 texel_size=1.0/u_texsize;vec2 pos_a=mix(pattern_tl_a*texel_size-texel_size,pattern_br_a*texel_size+texel_size,vec2(x_a,y));vec2 pos_b=mix(pattern_tl_b*texel_size-texel_size,pattern_br_b*texel_size+texel_size,vec2(x_b,y));vec4 color=mix(texture2D(u_image,pos_a),texture2D(u_image,pos_b),u_fade);gl_FragColor=color*alpha*opacity;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform vec2 u_units_to_pixels;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;varying vec2 v_normal;varying vec2 v_width2;varying float v_linesofar;varying float v_gamma_scale;varying float v_width;\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\n#pragma mapbox: define lowp vec4 pattern_from\n#pragma mapbox: define lowp vec4 pattern_to\n#pragma mapbox: define lowp float pixel_ratio_from\n#pragma mapbox: define lowp float pixel_ratio_to\nvoid main() {\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\n#pragma mapbox: initialize mediump vec4 pattern_from\n#pragma mapbox: initialize mediump vec4 pattern_to\n#pragma mapbox: initialize lowp float pixel_ratio_from\n#pragma mapbox: initialize lowp float pixel_ratio_to\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_linesofar=a_linesofar;v_width2=vec2(outset,inset);v_width=floorwidth;}"),
            lineSDF: ae("uniform lowp float u_device_pixel_ratio;uniform sampler2D u_image;uniform float u_sdfgamma;uniform float u_mix;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat dist=length(v_normal)*v_width2.s;float blur2=(blur+1.0/u_device_pixel_ratio)*v_gamma_scale;float alpha=clamp(min(dist-(v_width2.t-blur2),v_width2.s-dist)/blur2,0.0,1.0);float sdfdist_a=texture2D(u_image,v_tex_a).a;float sdfdist_b=texture2D(u_image,v_tex_b).a;float sdfdist=mix(sdfdist_a,sdfdist_b,u_mix);alpha*=smoothstep(0.5-u_sdfgamma/floorwidth,0.5+u_sdfgamma/floorwidth,sdfdist);gl_FragColor=color*(alpha*opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "\n#define scale 0.015873016\n#define LINE_DISTANCE_SCALE 2.0\nattribute vec2 a_pos_normal;attribute vec4 a_data;uniform mat4 u_matrix;uniform mediump float u_ratio;uniform lowp float u_device_pixel_ratio;uniform vec2 u_patternscale_a;uniform float u_tex_y_a;uniform vec2 u_patternscale_b;uniform float u_tex_y_b;uniform vec2 u_units_to_pixels;varying vec2 v_normal;varying vec2 v_width2;varying vec2 v_tex_a;varying vec2 v_tex_b;varying float v_gamma_scale;\n#pragma mapbox: define highp vec4 color\n#pragma mapbox: define lowp float blur\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define mediump float gapwidth\n#pragma mapbox: define lowp float offset\n#pragma mapbox: define mediump float width\n#pragma mapbox: define lowp float floorwidth\nvoid main() {\n#pragma mapbox: initialize highp vec4 color\n#pragma mapbox: initialize lowp float blur\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize mediump float gapwidth\n#pragma mapbox: initialize lowp float offset\n#pragma mapbox: initialize mediump float width\n#pragma mapbox: initialize lowp float floorwidth\nfloat ANTIALIASING=1.0/u_device_pixel_ratio/2.0;vec2 a_extrude=a_data.xy-128.0;float a_direction=mod(a_data.z,4.0)-1.0;float a_linesofar=(floor(a_data.z/4.0)+a_data.w*64.0)*LINE_DISTANCE_SCALE;vec2 pos=floor(a_pos_normal*0.5);mediump vec2 normal=a_pos_normal-2.0*pos;normal.y=normal.y*2.0-1.0;v_normal=normal;gapwidth=gapwidth/2.0;float halfwidth=width/2.0;offset=-1.0*offset;float inset=gapwidth+(gapwidth > 0.0 ? ANTIALIASING : 0.0);float outset=gapwidth+halfwidth*(gapwidth > 0.0 ? 2.0 : 1.0)+(halfwidth==0.0 ? 0.0 : ANTIALIASING);mediump vec2 dist=outset*a_extrude*scale;mediump float u=0.5*a_direction;mediump float t=1.0-abs(u);mediump vec2 offset2=offset*a_extrude*scale*normal.y*mat2(t,-u,u,t);vec4 projected_extrude=u_matrix*vec4(dist/u_ratio,0.0,0.0);gl_Position=u_matrix*vec4(pos+offset2/u_ratio,0.0,1.0)+projected_extrude;\n#ifdef TERRAIN3D\nv_gamma_scale=1.0;\n#else\nfloat extrude_length_without_perspective=length(dist);float extrude_length_with_perspective=length(projected_extrude.xy/gl_Position.w*u_units_to_pixels);v_gamma_scale=extrude_length_without_perspective/extrude_length_with_perspective;\n#endif\nv_tex_a=vec2(a_linesofar*u_patternscale_a.x/floorwidth,normal.y*u_patternscale_a.y+u_tex_y_a);v_tex_b=vec2(a_linesofar*u_patternscale_b.x/floorwidth,normal.y*u_patternscale_b.y+u_tex_y_b);v_width2=vec2(outset,inset);}"),
            raster: ae("uniform float u_fade_t;uniform float u_opacity;uniform sampler2D u_image0;uniform sampler2D u_image1;varying vec2 v_pos0;varying vec2 v_pos1;uniform float u_brightness_low;uniform float u_brightness_high;uniform float u_saturation_factor;uniform float u_contrast_factor;uniform vec3 u_spin_weights;void main() {vec4 color0=texture2D(u_image0,v_pos0);vec4 color1=texture2D(u_image1,v_pos1);if (color0.a > 0.0) {color0.rgb=color0.rgb/color0.a;}if (color1.a > 0.0) {color1.rgb=color1.rgb/color1.a;}vec4 color=mix(color0,color1,u_fade_t);color.a*=u_opacity;vec3 rgb=color.rgb;rgb=vec3(dot(rgb,u_spin_weights.xyz),dot(rgb,u_spin_weights.zxy),dot(rgb,u_spin_weights.yzx));float average=(color.r+color.g+color.b)/3.0;rgb+=(average-rgb)*u_saturation_factor;rgb=(rgb-0.5)*u_contrast_factor+0.5;vec3 u_high_vec=vec3(u_brightness_low,u_brightness_low,u_brightness_low);vec3 u_low_vec=vec3(u_brightness_high,u_brightness_high,u_brightness_high);gl_FragColor=vec4(mix(u_high_vec,u_low_vec,rgb)*color.a,color.a);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "uniform mat4 u_matrix;uniform vec2 u_tl_parent;uniform float u_scale_parent;uniform float u_buffer_scale;attribute vec2 a_pos;attribute vec2 a_texture_pos;varying vec2 v_pos0;varying vec2 v_pos1;void main() {gl_Position=u_matrix*vec4(a_pos,0,1);v_pos0=(((a_texture_pos/8192.0)-0.5)/u_buffer_scale )+0.5;v_pos1=(v_pos0*u_scale_parent)+u_tl_parent;}"),
            symbolIcon: ae("uniform sampler2D u_texture;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nlowp float alpha=opacity*v_fade_opacity;gl_FragColor=texture2D(u_texture,v_tex)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform highp float u_camera_to_center_distance;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform float u_fade_change;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform vec2 u_texsize;varying vec2 v_tex;varying float v_fade_opacity;\n#pragma mapbox: define lowp float opacity\nvoid main() {\n#pragma mapbox: initialize lowp float opacity\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;vec2 a_minFontScale=a_pixeloffset.zw/256.0;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*max(a_minFontScale,fontScale)+a_pxoffset/16.0),z,1.0);v_tex=a_tex/u_texsize;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float visibility=calculate_visibility(projectedPoint);v_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));}"),
            symbolSDF: ae("#define SDF_PX 8.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;uniform bool u_is_text;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat EDGE_GAMMA=0.105/u_device_pixel_ratio;vec2 tex=v_data0.xy;float gamma_scale=v_data1.x;float size=v_data1.y;float fade_opacity=v_data1[2];float fontScale=u_is_text ? size/24.0 : size;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec4 a_pixeloffset;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;varying vec2 v_data0;varying vec3 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);vec2 a_pxoffset=a_pixeloffset.xy;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=u_is_text ? size/24.0 : size;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale+a_pxoffset),z,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float visibility=calculate_visibility(projectedPoint);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));v_data0=a_tex/u_texsize;v_data1=vec3(gamma_scale,size,interpolated_fade_opacity);}"),
            symbolTextAndIcon: ae("#define SDF_PX 8.0\n#define SDF 1.0\n#define ICON 0.0\nuniform bool u_is_halo;uniform sampler2D u_texture;uniform sampler2D u_texture_icon;uniform highp float u_gamma_scale;uniform lowp float u_device_pixel_ratio;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nfloat fade_opacity=v_data1[2];if (v_data1.w==ICON) {vec2 tex_icon=v_data0.zw;lowp float alpha=opacity*fade_opacity;gl_FragColor=texture2D(u_texture_icon,tex_icon)*alpha;\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\nreturn;}vec2 tex=v_data0.xy;float EDGE_GAMMA=0.105/u_device_pixel_ratio;float gamma_scale=v_data1.x;float size=v_data1.y;float fontScale=size/24.0;lowp vec4 color=fill_color;highp float gamma=EDGE_GAMMA/(fontScale*u_gamma_scale);lowp float buff=(256.0-64.0)/256.0;if (u_is_halo) {color=halo_color;gamma=(halo_blur*1.19/SDF_PX+EDGE_GAMMA)/(fontScale*u_gamma_scale);buff=(6.0-halo_width/fontScale)/SDF_PX;}lowp float dist=texture2D(u_texture,tex).a;highp float gamma_scaled=gamma*gamma_scale;highp float alpha=smoothstep(buff-gamma_scaled,buff+gamma_scaled,dist);gl_FragColor=color*(alpha*opacity*fade_opacity);\n#ifdef OVERDRAW_INSPECTOR\ngl_FragColor=vec4(1.0);\n#endif\n}", "const float PI=3.141592653589793;attribute vec4 a_pos_offset;attribute vec4 a_data;attribute vec3 a_projected_pos;attribute float a_fade_opacity;uniform bool u_is_size_zoom_constant;uniform bool u_is_size_feature_constant;uniform highp float u_size_t;uniform highp float u_size;uniform mat4 u_matrix;uniform mat4 u_label_plane_matrix;uniform mat4 u_coord_matrix;uniform bool u_is_text;uniform bool u_pitch_with_map;uniform highp float u_pitch;uniform bool u_rotate_symbol;uniform highp float u_aspect_ratio;uniform highp float u_camera_to_center_distance;uniform float u_fade_change;uniform vec2 u_texsize;uniform vec2 u_texsize_icon;varying vec4 v_data0;varying vec4 v_data1;\n#pragma mapbox: define highp vec4 fill_color\n#pragma mapbox: define highp vec4 halo_color\n#pragma mapbox: define lowp float opacity\n#pragma mapbox: define lowp float halo_width\n#pragma mapbox: define lowp float halo_blur\nvoid main() {\n#pragma mapbox: initialize highp vec4 fill_color\n#pragma mapbox: initialize highp vec4 halo_color\n#pragma mapbox: initialize lowp float opacity\n#pragma mapbox: initialize lowp float halo_width\n#pragma mapbox: initialize lowp float halo_blur\nvec2 a_pos=a_pos_offset.xy;vec2 a_offset=a_pos_offset.zw;vec2 a_tex=a_data.xy;vec2 a_size=a_data.zw;float a_size_min=floor(a_size[0]*0.5);float is_sdf=a_size[0]-2.0*a_size_min;float ele=get_elevation(a_pos);highp float segment_angle=-a_projected_pos[2];float size;if (!u_is_size_zoom_constant && !u_is_size_feature_constant) {size=mix(a_size_min,a_size[1],u_size_t)/128.0;} else if (u_is_size_zoom_constant && !u_is_size_feature_constant) {size=a_size_min/128.0;} else {size=u_size;}vec4 projectedPoint=u_matrix*vec4(a_pos,ele,1);highp float camera_to_anchor_distance=projectedPoint.w;highp float distance_ratio=u_pitch_with_map ?\ncamera_to_anchor_distance/u_camera_to_center_distance :\nu_camera_to_center_distance/camera_to_anchor_distance;highp float perspective_ratio=clamp(0.5+0.5*distance_ratio,0.0,4.0);size*=perspective_ratio;float fontScale=size/24.0;highp float symbol_rotation=0.0;if (u_rotate_symbol) {vec4 offsetProjectedPoint=u_matrix*vec4(a_pos+vec2(1,0),ele,1);vec2 a=projectedPoint.xy/projectedPoint.w;vec2 b=offsetProjectedPoint.xy/offsetProjectedPoint.w;symbol_rotation=atan((b.y-a.y)/u_aspect_ratio,b.x-a.x);}highp float angle_sin=sin(segment_angle+symbol_rotation);highp float angle_cos=cos(segment_angle+symbol_rotation);mat2 rotation_matrix=mat2(angle_cos,-1.0*angle_sin,angle_sin,angle_cos);vec4 projected_pos=u_label_plane_matrix*vec4(a_projected_pos.xy,ele,1.0);float z=float(u_pitch_with_map)*projected_pos.z/projected_pos.w;gl_Position=u_coord_matrix*vec4(projected_pos.xy/projected_pos.w+rotation_matrix*(a_offset/32.0*fontScale),z,1.0);float gamma_scale=gl_Position.w;vec2 fade_opacity=unpack_opacity(a_fade_opacity);float visibility=calculate_visibility(projectedPoint);float fade_change=fade_opacity[1] > 0.5 ? u_fade_change :-u_fade_change;float interpolated_fade_opacity=max(0.0,min(visibility,fade_opacity[0]+fade_change));v_data0.xy=a_tex/u_texsize;v_data0.zw=a_tex/u_texsize_icon;v_data1=vec4(gamma_scale,size,interpolated_fade_opacity,is_sdf);}"),
            terrain: ae("uniform sampler2D u_texture;varying vec2 v_texture_pos;void main() {gl_FragColor=texture2D(u_texture,v_texture_pos);}", ie),
            terrainDepth: ae("varying float v_depth;const highp vec4 bitSh=vec4(256.*256.*256.,256.*256.,256.,1.);const highp vec4 bitMsk=vec4(0.,vec3(1./256.0));highp vec4 pack(highp float value) {highp vec4 comp=fract(value*bitSh);comp-=comp.xxyz*bitMsk;return comp;}void main() {gl_FragColor=pack(v_depth);}", ie),
            terrainCoords: ae("precision mediump float;uniform sampler2D u_texture;uniform float u_terrain_coords_id;varying vec2 v_texture_pos;void main() {vec4 rgba=texture2D(u_texture,v_texture_pos);gl_FragColor=vec4(rgba.r,rgba.g,rgba.b,u_terrain_coords_id);}", ie)
        };
        function ae(t1, e1) {
            const i = /#pragma mapbox: ([\w]+) ([\w]+) ([\w]+) ([\w]+)/g, o = e1.match(/attribute ([\w]+) ([\w]+)/g), a = t1.match(/uniform ([\w]+) ([\w]+)([\s]*)([\w]*)/g), r = e1.match(/uniform ([\w]+) ([\w]+)([\s]*)([\w]*)/g), s = r ? r.concat(a) : a, n = {};
            return {
                fragmentSource: t1 = t1.replace(i, (t1, e1, i, o, a)=>(n[a] = !0, "define" === e1 ? `\n#ifndef HAS_UNIFORM_u_${a}\nvarying ${i} ${o} ${a};\n#else\nuniform ${i} ${o} u_${a};\n#endif\n` : `\n#ifdef HAS_UNIFORM_u_${a}\n    ${i} ${o} ${a} = u_${a};\n#endif\n`)),
                vertexSource: e1 = e1.replace(i, (t1, e1, i, o, a)=>{
                    const r = "float" === o ? "vec2" : "vec4", s = a.match(/color/) ? "color" : r;
                    return n[a] ? "define" === e1 ? `\n#ifndef HAS_UNIFORM_u_${a}\nuniform lowp float u_${a}_t;\nattribute ${i} ${r} a_${a};\nvarying ${i} ${o} ${a};\n#else\nuniform ${i} ${o} u_${a};\n#endif\n` : "vec4" === s ? `\n#ifndef HAS_UNIFORM_u_${a}\n    ${a} = a_${a};\n#else\n    ${i} ${o} ${a} = u_${a};\n#endif\n` : `\n#ifndef HAS_UNIFORM_u_${a}\n    ${a} = unpack_mix_${s}(a_${a}, u_${a}_t);\n#else\n    ${i} ${o} ${a} = u_${a};\n#endif\n` : "define" === e1 ? `\n#ifndef HAS_UNIFORM_u_${a}\nuniform lowp float u_${a}_t;\nattribute ${i} ${r} a_${a};\n#else\nuniform ${i} ${o} u_${a};\n#endif\n` : "vec4" === s ? `\n#ifndef HAS_UNIFORM_u_${a}\n    ${i} ${o} ${a} = a_${a};\n#else\n    ${i} ${o} ${a} = u_${a};\n#endif\n` : `\n#ifndef HAS_UNIFORM_u_${a}\n    ${i} ${o} ${a} = unpack_mix_${s}(a_${a}, u_${a}_t);\n#else\n    ${i} ${o} ${a} = u_${a};\n#endif\n`;
                }),
                staticAttributes: o,
                staticUniforms: s
            };
        }
        class re {
            constructor(){
                this.boundProgram = null, this.boundLayoutVertexBuffer = null, this.boundPaintVertexBuffers = [], this.boundIndexBuffer = null, this.boundVertexOffset = null, this.boundDynamicVertexBuffer = null, this.vao = null;
            }
            bind(t1, e1, i, o, a, r, s, n, l) {
                this.context = t1;
                let c = this.boundPaintVertexBuffers.length !== o.length;
                for(let t2 = 0; !c && t2 < o.length; t2++)this.boundPaintVertexBuffers[t2] !== o[t2] && (c = !0);
                t1.extVertexArrayObject && this.vao && this.boundProgram === e1 && this.boundLayoutVertexBuffer === i && !c && this.boundIndexBuffer === a && this.boundVertexOffset === r && this.boundDynamicVertexBuffer === s && this.boundDynamicVertexBuffer2 === n && this.boundDynamicVertexBuffer3 === l ? (t1.bindVertexArrayOES.set(this.vao), s && s.bind(), a && a.dynamicDraw && a.bind(), n && n.bind(), l && l.bind()) : this.freshBind(e1, i, o, a, r, s, n, l);
            }
            freshBind(t1, e1, i, o, a, r, s, n) {
                let l;
                const c = t1.numAttributes, h = this.context, u = h.gl;
                if (h.extVertexArrayObject) this.vao && this.destroy(), this.vao = h.extVertexArrayObject.createVertexArrayOES(), h.bindVertexArrayOES.set(this.vao), l = 0, this.boundProgram = t1, this.boundLayoutVertexBuffer = e1, this.boundPaintVertexBuffers = i, this.boundIndexBuffer = o, this.boundVertexOffset = a, this.boundDynamicVertexBuffer = r, this.boundDynamicVertexBuffer2 = s, this.boundDynamicVertexBuffer3 = n;
                else {
                    l = h.currentNumAttributes || 0;
                    for(let t2 = c; t2 < l; t2++)u.disableVertexAttribArray(t2);
                }
                e1.enableAttributes(u, t1);
                for (const e2 of i)e2.enableAttributes(u, t1);
                r && r.enableAttributes(u, t1), s && s.enableAttributes(u, t1), n && n.enableAttributes(u, t1), e1.bind(), e1.setVertexAttribPointers(u, t1, a);
                for (const e3 of i)e3.bind(), e3.setVertexAttribPointers(u, t1, a);
                r && (r.bind(), r.setVertexAttribPointers(u, t1, a)), o && o.bind(), s && (s.bind(), s.setVertexAttribPointers(u, t1, a)), n && (n.bind(), n.setVertexAttribPointers(u, t1, a)), h.currentNumAttributes = c;
            }
            destroy() {
                this.vao && (this.context.extVertexArrayObject.deleteVertexArrayOES(this.vao), this.vao = null);
            }
        }
        function se(t1) {
            const e1 = [];
            for(let i = 0; i < t1.length; i++){
                if (null === t1[i]) continue;
                const o = t1[i].split(" ");
                e1.push(o.pop());
            }
            return e1;
        }
        class ne {
            constructor(e1, i, o, a, r, s, n){
                const l = e1.gl;
                this.program = l.createProgram();
                const c = se(o.staticAttributes), h = a ? a.getBinderAttributes() : [], u = c.concat(h), d = oe.prelude.staticUniforms ? se(oe.prelude.staticUniforms) : [], m = o.staticUniforms ? se(o.staticUniforms) : [], _ = a ? a.getBinderUniforms() : [], p = d.concat(m).concat(_), f = [];
                for (const t2 of p)f.indexOf(t2) < 0 && f.push(t2);
                const g = a ? a.defines() : [];
                s && g.push("#define OVERDRAW_INSPECTOR;"), n && g.push("#define TERRAIN3D;");
                const x = g.concat(oe.prelude.fragmentSource, o.fragmentSource).join("\n"), v = g.concat(oe.prelude.vertexSource, o.vertexSource).join("\n"), y = l.createShader(l.FRAGMENT_SHADER);
                if (l.isContextLost()) return void (this.failedToCreate = !0);
                l.shaderSource(y, x), l.compileShader(y), l.attachShader(this.program, y);
                const b = l.createShader(l.VERTEX_SHADER);
                if (l.isContextLost()) return void (this.failedToCreate = !0);
                l.shaderSource(b, v), l.compileShader(b), l.attachShader(this.program, b), this.attributes = {};
                const w = {};
                this.numAttributes = u.length;
                for(let t3 = 0; t3 < this.numAttributes; t3++)u[t3] && (l.bindAttribLocation(this.program, t3, u[t3]), this.attributes[u[t3]] = t3);
                l.linkProgram(this.program), l.deleteShader(b), l.deleteShader(y);
                for(let t4 = 0; t4 < f.length; t4++){
                    const e2 = f[t4];
                    if (e2 && !w[e2]) {
                        const t5 = l.getUniformLocation(this.program, e2);
                        t5 && (w[e2] = t5);
                    }
                }
                this.fixedUniforms = r(e1, w), this.terrainUniforms = ((e1, i)=>({
                        u_depth: new t1.Uniform1i(e1, i.u_depth),
                        u_terrain: new t1.Uniform1i(e1, i.u_terrain),
                        u_terrain_dim: new t1.Uniform1f(e1, i.u_terrain_dim),
                        u_terrain_matrix: new t1.UniformMatrix4f(e1, i.u_terrain_matrix),
                        u_terrain_unpack: new t1.Uniform4f(e1, i.u_terrain_unpack),
                        u_terrain_offset: new t1.Uniform1f(e1, i.u_terrain_offset),
                        u_terrain_exaggeration: new t1.Uniform1f(e1, i.u_terrain_exaggeration)
                    }))(e1, w), this.binderUniforms = a ? a.getUniforms(e1, w) : [];
            }
            draw(t1, e1, i, o, a, r, s, n, l, c, h, u, d, m, _, p, f, g) {
                const x = t1.gl;
                if (this.failedToCreate) return;
                if (t1.program.set(this.program), t1.setDepthMode(i), t1.setStencilMode(o), t1.setColorMode(a), t1.setCullFace(r), n) {
                    t1.activeTexture.set(x.TEXTURE2), x.bindTexture(x.TEXTURE_2D, n.depthTexture), t1.activeTexture.set(x.TEXTURE3), x.bindTexture(x.TEXTURE_2D, n.texture);
                    for(const t2 in this.terrainUniforms)this.terrainUniforms[t2].set(n[t2]);
                }
                for(const t3 in this.fixedUniforms)this.fixedUniforms[t3].set(s[t3]);
                _ && _.setUniforms(t1, this.binderUniforms, d, {
                    zoom: m
                });
                let v = 0;
                switch(e1){
                    case x.LINES:
                        v = 2;
                        break;
                    case x.TRIANGLES:
                        v = 3;
                        break;
                    case x.LINE_STRIP:
                        v = 1;
                }
                for (const i1 of u.get()){
                    const o1 = i1.vaos || (i1.vaos = {});
                    (o1[l] || (o1[l] = new re)).bind(t1, this, c, _ ? _.getPaintVertexBuffers() : [], h, i1.vertexOffset, p, f, g), x.drawElements(e1, i1.primitiveLength * v, x.UNSIGNED_SHORT, i1.primitiveOffset * v * 2);
                }
            }
        }
        function le(t1, e1, i) {
            const o = 1 / bt(i, 1, e1.transform.tileZoom), a = Math.pow(2, i.tileID.overscaledZ), r = i.tileSize * Math.pow(2, e1.transform.tileZoom) / a, s = r * (i.tileID.canonical.x + i.tileID.wrap * a), n = r * i.tileID.canonical.y;
            return {
                u_image: 0,
                u_texsize: i.imageAtlasTexture.size,
                u_scale: [
                    o,
                    t1.fromScale,
                    t1.toScale
                ],
                u_fade: t1.t,
                u_pixel_coord_upper: [
                    s >> 16,
                    n >> 16
                ],
                u_pixel_coord_lower: [
                    65535 & s,
                    65535 & n
                ]
            };
        }
        const ce = (e1, i, o, a)=>{
            const r = i.style.light, s = r.properties.get("position"), n = [
                s.x,
                s.y,
                s.z
            ], l = t1.create$1();
            "viewport" === r.properties.get("anchor") && t1.fromRotation(l, -i.transform.angle), t1.transformMat3(n, n, l);
            const c = r.properties.get("color");
            return {
                u_matrix: e1,
                u_lightpos: n,
                u_lightintensity: r.properties.get("intensity"),
                u_lightcolor: [
                    c.r,
                    c.g,
                    c.b
                ],
                u_vertical_gradient: +o,
                u_opacity: a
            };
        }, he = (e1, i, o, a, r, s, n)=>t1.extend(ce(e1, i, o, a), le(s, i, n), {
                u_height_factor: -Math.pow(2, r.overscaledZ) / n.tileSize / 8
            }), ue = (t1)=>({
                u_matrix: t1
            }), de = (e1, i, o, a)=>t1.extend(ue(e1), le(o, i, a)), me = (t1, e1)=>({
                u_matrix: t1,
                u_world: e1
            }), _e = (e1, i, o, a, r)=>t1.extend(de(e1, i, o, a), {
                u_world: r
            }), pe = (t1, e1, i, o)=>{
            const a = t1.transform;
            let r, s;
            if ("map" === o.paint.get("circle-pitch-alignment")) {
                const t2 = bt(i, 1, a.zoom);
                r = !0, s = [
                    t2,
                    t2
                ];
            } else r = !1, s = a.pixelsToGLUnits;
            return {
                u_camera_to_center_distance: a.cameraToCenterDistance,
                u_scale_with_map: +("map" === o.paint.get("circle-pitch-scale")),
                u_matrix: t1.translatePosMatrix(e1.posMatrix, i, o.paint.get("circle-translate"), o.paint.get("circle-translate-anchor")),
                u_pitch_with_map: +r,
                u_device_pixel_ratio: t1.pixelRatio,
                u_extrude_scale: s
            };
        }, fe = (t1, e1, i)=>{
            const o = bt(i, 1, e1.zoom), a = Math.pow(2, e1.zoom - i.tileID.overscaledZ), r = i.tileID.overscaleFactor();
            return {
                u_matrix: t1,
                u_camera_to_center_distance: e1.cameraToCenterDistance,
                u_pixels_to_tile_units: o,
                u_extrude_scale: [
                    e1.pixelsToGLUnits[0] / (o * a),
                    e1.pixelsToGLUnits[1] / (o * a)
                ],
                u_overscale_factor: r
            };
        }, ge = (t1, e1, i = 1)=>({
                u_matrix: t1,
                u_color: e1,
                u_overlay: 0,
                u_overlay_scale: i
            }), xe = (t1)=>({
                u_matrix: t1
            }), ve = (t1, e1, i, o)=>({
                u_matrix: t1,
                u_extrude_scale: bt(e1, 1, i),
                u_intensity: o
            });
        function ye(e1, i) {
            const o = Math.pow(2, i.canonical.z), a = i.canonical.y;
            return [
                new t1.MercatorCoordinate(0, a / o).toLngLat().lat,
                new t1.MercatorCoordinate(0, (a + 1) / o).toLngLat().lat
            ];
        }
        const be = (t1, e1, i, o)=>{
            const a = t1.transform;
            return {
                u_matrix: Ce(t1, e1, i, o),
                u_ratio: 1 / bt(e1, 1, a.zoom),
                u_device_pixel_ratio: t1.pixelRatio,
                u_units_to_pixels: [
                    1 / a.pixelsToGLUnits[0],
                    1 / a.pixelsToGLUnits[1]
                ]
            };
        }, we = (e1, i, o, a, r)=>t1.extend(be(e1, i, o, r), {
                u_image: 0,
                u_image_height: a
            }), Te = (t1, e1, i, o, a)=>{
            const r = t1.transform, s = Ie(e1, r);
            return {
                u_matrix: Ce(t1, e1, i, a),
                u_texsize: e1.imageAtlasTexture.size,
                u_ratio: 1 / bt(e1, 1, r.zoom),
                u_device_pixel_ratio: t1.pixelRatio,
                u_image: 0,
                u_scale: [
                    s,
                    o.fromScale,
                    o.toScale
                ],
                u_fade: o.t,
                u_units_to_pixels: [
                    1 / r.pixelsToGLUnits[0],
                    1 / r.pixelsToGLUnits[1]
                ]
            };
        }, Ee = (e1, i, o, a, r, s)=>{
            const n = e1.lineAtlas, l = Ie(i, e1.transform), c = "round" === o.layout.get("line-cap"), h = n.getDash(a.from, c), u = n.getDash(a.to, c), d = h.width * r.fromScale, m = u.width * r.toScale;
            return t1.extend(be(e1, i, o, s), {
                u_patternscale_a: [
                    l / d,
                    -h.height / 2
                ],
                u_patternscale_b: [
                    l / m,
                    -u.height / 2
                ],
                u_sdfgamma: n.width / (256 * Math.min(d, m) * e1.pixelRatio) / 2,
                u_image: 0,
                u_tex_y_a: h.y,
                u_tex_y_b: u.y,
                u_mix: r.t
            });
        };
        function Ie(t1, e1) {
            return 1 / bt(t1, 1, e1.tileZoom);
        }
        function Ce(t1, e1, i, o) {
            return t1.translatePosMatrix(o ? o.posMatrix : e1.tileID.posMatrix, e1, i.paint.get("line-translate"), i.paint.get("line-translate-anchor"));
        }
        const Se = (t1, e1, i, o, a)=>{
            var r, s;
            return {
                u_matrix: t1,
                u_tl_parent: e1,
                u_scale_parent: i,
                u_buffer_scale: 1,
                u_fade_t: o.mix,
                u_opacity: o.opacity * a.paint.get("raster-opacity"),
                u_image0: 0,
                u_image1: 1,
                u_brightness_low: a.paint.get("raster-brightness-min"),
                u_brightness_high: a.paint.get("raster-brightness-max"),
                u_saturation_factor: (s = a.paint.get("raster-saturation"), s > 0 ? 1 - 1 / (1.001 - s) : -s),
                u_contrast_factor: (r = a.paint.get("raster-contrast"), r > 0 ? 1 / (1 - r) : 1 + r),
                u_spin_weights: De(a.paint.get("raster-hue-rotate"))
            };
        };
        function De(t1) {
            t1 *= Math.PI / 180;
            const e1 = Math.sin(t1), i = Math.cos(t1);
            return [
                (2 * i + 1) / 3,
                (-Math.sqrt(3) * e1 - i + 1) / 3,
                (Math.sqrt(3) * e1 - i + 1) / 3
            ];
        }
        const ze = (t1, e1, i, o, a, r, s, n, l, c)=>{
            const h = a.transform;
            return {
                u_is_size_zoom_constant: +("constant" === t1 || "source" === t1),
                u_is_size_feature_constant: +("constant" === t1 || "camera" === t1),
                u_size_t: e1 ? e1.uSizeT : 0,
                u_size: e1 ? e1.uSize : 0,
                u_camera_to_center_distance: h.cameraToCenterDistance,
                u_pitch: h.pitch / 360 * 2 * Math.PI,
                u_rotate_symbol: +i,
                u_aspect_ratio: h.width / h.height,
                u_fade_change: a.options.fadeDuration ? a.symbolFadeChange : 1,
                u_matrix: r,
                u_label_plane_matrix: s,
                u_coord_matrix: n,
                u_is_text: +l,
                u_pitch_with_map: +o,
                u_texsize: c,
                u_texture: 0
            };
        }, Pe = (e1, i, o, a, r, s, n, l, c, h, u)=>{
            const d = r.transform;
            return t1.extend(ze(e1, i, o, a, r, s, n, l, c, h), {
                u_gamma_scale: a ? Math.cos(d._pitch) * d.cameraToCenterDistance : 1,
                u_device_pixel_ratio: r.pixelRatio,
                u_is_halo: +u
            });
        }, Me = (e1, i, o, a, r, s, n, l, c, h)=>t1.extend(Pe(e1, i, o, a, r, s, n, l, !0, c, !0), {
                u_texsize_icon: h,
                u_texture_icon: 1
            }), Ae = (t1, e1, i)=>({
                u_matrix: t1,
                u_opacity: e1,
                u_color: i
            }), Le = (e1, i, o, a, r, s)=>t1.extend(function(t1, e1, i, o) {
                const a = i.imageManager.getPattern(t1.from.toString()), r = i.imageManager.getPattern(t1.to.toString()), { width: s , height: n  } = i.imageManager.getPixelSize(), l = Math.pow(2, o.tileID.overscaledZ), c = o.tileSize * Math.pow(2, i.transform.tileZoom) / l, h = c * (o.tileID.canonical.x + o.tileID.wrap * l), u = c * o.tileID.canonical.y;
                return {
                    u_image: 0,
                    u_pattern_tl_a: a.tl,
                    u_pattern_br_a: a.br,
                    u_pattern_tl_b: r.tl,
                    u_pattern_br_b: r.br,
                    u_texsize: [
                        s,
                        n
                    ],
                    u_mix: e1.t,
                    u_pattern_size_a: a.displaySize,
                    u_pattern_size_b: r.displaySize,
                    u_scale_a: e1.fromScale,
                    u_scale_b: e1.toScale,
                    u_tile_units_to_pixels: 1 / bt(o, 1, i.transform.tileZoom),
                    u_pixel_coord_upper: [
                        h >> 16,
                        u >> 16
                    ],
                    u_pixel_coord_lower: [
                        65535 & h,
                        65535 & u
                    ]
                };
            }(a, s, o, r), {
                u_matrix: e1,
                u_opacity: i
            }), Re = {
            fillExtrusion: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_lightpos: new t1.Uniform3f(e1, i.u_lightpos),
                    u_lightintensity: new t1.Uniform1f(e1, i.u_lightintensity),
                    u_lightcolor: new t1.Uniform3f(e1, i.u_lightcolor),
                    u_vertical_gradient: new t1.Uniform1f(e1, i.u_vertical_gradient),
                    u_opacity: new t1.Uniform1f(e1, i.u_opacity)
                }),
            fillExtrusionPattern: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_lightpos: new t1.Uniform3f(e1, i.u_lightpos),
                    u_lightintensity: new t1.Uniform1f(e1, i.u_lightintensity),
                    u_lightcolor: new t1.Uniform3f(e1, i.u_lightcolor),
                    u_vertical_gradient: new t1.Uniform1f(e1, i.u_vertical_gradient),
                    u_height_factor: new t1.Uniform1f(e1, i.u_height_factor),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_texsize: new t1.Uniform2f(e1, i.u_texsize),
                    u_pixel_coord_upper: new t1.Uniform2f(e1, i.u_pixel_coord_upper),
                    u_pixel_coord_lower: new t1.Uniform2f(e1, i.u_pixel_coord_lower),
                    u_scale: new t1.Uniform3f(e1, i.u_scale),
                    u_fade: new t1.Uniform1f(e1, i.u_fade),
                    u_opacity: new t1.Uniform1f(e1, i.u_opacity)
                }),
            fill: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix)
                }),
            fillPattern: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_texsize: new t1.Uniform2f(e1, i.u_texsize),
                    u_pixel_coord_upper: new t1.Uniform2f(e1, i.u_pixel_coord_upper),
                    u_pixel_coord_lower: new t1.Uniform2f(e1, i.u_pixel_coord_lower),
                    u_scale: new t1.Uniform3f(e1, i.u_scale),
                    u_fade: new t1.Uniform1f(e1, i.u_fade)
                }),
            fillOutline: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_world: new t1.Uniform2f(e1, i.u_world)
                }),
            fillOutlinePattern: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_world: new t1.Uniform2f(e1, i.u_world),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_texsize: new t1.Uniform2f(e1, i.u_texsize),
                    u_pixel_coord_upper: new t1.Uniform2f(e1, i.u_pixel_coord_upper),
                    u_pixel_coord_lower: new t1.Uniform2f(e1, i.u_pixel_coord_lower),
                    u_scale: new t1.Uniform3f(e1, i.u_scale),
                    u_fade: new t1.Uniform1f(e1, i.u_fade)
                }),
            circle: (e1, i)=>({
                    u_camera_to_center_distance: new t1.Uniform1f(e1, i.u_camera_to_center_distance),
                    u_scale_with_map: new t1.Uniform1i(e1, i.u_scale_with_map),
                    u_pitch_with_map: new t1.Uniform1i(e1, i.u_pitch_with_map),
                    u_extrude_scale: new t1.Uniform2f(e1, i.u_extrude_scale),
                    u_device_pixel_ratio: new t1.Uniform1f(e1, i.u_device_pixel_ratio),
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix)
                }),
            collisionBox: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_camera_to_center_distance: new t1.Uniform1f(e1, i.u_camera_to_center_distance),
                    u_pixels_to_tile_units: new t1.Uniform1f(e1, i.u_pixels_to_tile_units),
                    u_extrude_scale: new t1.Uniform2f(e1, i.u_extrude_scale),
                    u_overscale_factor: new t1.Uniform1f(e1, i.u_overscale_factor)
                }),
            collisionCircle: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_inv_matrix: new t1.UniformMatrix4f(e1, i.u_inv_matrix),
                    u_camera_to_center_distance: new t1.Uniform1f(e1, i.u_camera_to_center_distance),
                    u_viewport_size: new t1.Uniform2f(e1, i.u_viewport_size)
                }),
            debug: (e1, i)=>({
                    u_color: new t1.UniformColor(e1, i.u_color),
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_overlay: new t1.Uniform1i(e1, i.u_overlay),
                    u_overlay_scale: new t1.Uniform1f(e1, i.u_overlay_scale)
                }),
            clippingMask: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix)
                }),
            heatmap: (e1, i)=>({
                    u_extrude_scale: new t1.Uniform1f(e1, i.u_extrude_scale),
                    u_intensity: new t1.Uniform1f(e1, i.u_intensity),
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix)
                }),
            heatmapTexture: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_world: new t1.Uniform2f(e1, i.u_world),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_color_ramp: new t1.Uniform1i(e1, i.u_color_ramp),
                    u_opacity: new t1.Uniform1f(e1, i.u_opacity)
                }),
            hillshade: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_latrange: new t1.Uniform2f(e1, i.u_latrange),
                    u_light: new t1.Uniform2f(e1, i.u_light),
                    u_shadow: new t1.UniformColor(e1, i.u_shadow),
                    u_highlight: new t1.UniformColor(e1, i.u_highlight),
                    u_accent: new t1.UniformColor(e1, i.u_accent)
                }),
            hillshadePrepare: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_dimension: new t1.Uniform2f(e1, i.u_dimension),
                    u_zoom: new t1.Uniform1f(e1, i.u_zoom),
                    u_unpack: new t1.Uniform4f(e1, i.u_unpack)
                }),
            line: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_ratio: new t1.Uniform1f(e1, i.u_ratio),
                    u_device_pixel_ratio: new t1.Uniform1f(e1, i.u_device_pixel_ratio),
                    u_units_to_pixels: new t1.Uniform2f(e1, i.u_units_to_pixels)
                }),
            lineGradient: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_ratio: new t1.Uniform1f(e1, i.u_ratio),
                    u_device_pixel_ratio: new t1.Uniform1f(e1, i.u_device_pixel_ratio),
                    u_units_to_pixels: new t1.Uniform2f(e1, i.u_units_to_pixels),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_image_height: new t1.Uniform1f(e1, i.u_image_height)
                }),
            linePattern: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_texsize: new t1.Uniform2f(e1, i.u_texsize),
                    u_ratio: new t1.Uniform1f(e1, i.u_ratio),
                    u_device_pixel_ratio: new t1.Uniform1f(e1, i.u_device_pixel_ratio),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_units_to_pixels: new t1.Uniform2f(e1, i.u_units_to_pixels),
                    u_scale: new t1.Uniform3f(e1, i.u_scale),
                    u_fade: new t1.Uniform1f(e1, i.u_fade)
                }),
            lineSDF: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_ratio: new t1.Uniform1f(e1, i.u_ratio),
                    u_device_pixel_ratio: new t1.Uniform1f(e1, i.u_device_pixel_ratio),
                    u_units_to_pixels: new t1.Uniform2f(e1, i.u_units_to_pixels),
                    u_patternscale_a: new t1.Uniform2f(e1, i.u_patternscale_a),
                    u_patternscale_b: new t1.Uniform2f(e1, i.u_patternscale_b),
                    u_sdfgamma: new t1.Uniform1f(e1, i.u_sdfgamma),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_tex_y_a: new t1.Uniform1f(e1, i.u_tex_y_a),
                    u_tex_y_b: new t1.Uniform1f(e1, i.u_tex_y_b),
                    u_mix: new t1.Uniform1f(e1, i.u_mix)
                }),
            raster: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_tl_parent: new t1.Uniform2f(e1, i.u_tl_parent),
                    u_scale_parent: new t1.Uniform1f(e1, i.u_scale_parent),
                    u_buffer_scale: new t1.Uniform1f(e1, i.u_buffer_scale),
                    u_fade_t: new t1.Uniform1f(e1, i.u_fade_t),
                    u_opacity: new t1.Uniform1f(e1, i.u_opacity),
                    u_image0: new t1.Uniform1i(e1, i.u_image0),
                    u_image1: new t1.Uniform1i(e1, i.u_image1),
                    u_brightness_low: new t1.Uniform1f(e1, i.u_brightness_low),
                    u_brightness_high: new t1.Uniform1f(e1, i.u_brightness_high),
                    u_saturation_factor: new t1.Uniform1f(e1, i.u_saturation_factor),
                    u_contrast_factor: new t1.Uniform1f(e1, i.u_contrast_factor),
                    u_spin_weights: new t1.Uniform3f(e1, i.u_spin_weights)
                }),
            symbolIcon: (e1, i)=>({
                    u_is_size_zoom_constant: new t1.Uniform1i(e1, i.u_is_size_zoom_constant),
                    u_is_size_feature_constant: new t1.Uniform1i(e1, i.u_is_size_feature_constant),
                    u_size_t: new t1.Uniform1f(e1, i.u_size_t),
                    u_size: new t1.Uniform1f(e1, i.u_size),
                    u_camera_to_center_distance: new t1.Uniform1f(e1, i.u_camera_to_center_distance),
                    u_pitch: new t1.Uniform1f(e1, i.u_pitch),
                    u_rotate_symbol: new t1.Uniform1i(e1, i.u_rotate_symbol),
                    u_aspect_ratio: new t1.Uniform1f(e1, i.u_aspect_ratio),
                    u_fade_change: new t1.Uniform1f(e1, i.u_fade_change),
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_label_plane_matrix: new t1.UniformMatrix4f(e1, i.u_label_plane_matrix),
                    u_coord_matrix: new t1.UniformMatrix4f(e1, i.u_coord_matrix),
                    u_is_text: new t1.Uniform1i(e1, i.u_is_text),
                    u_pitch_with_map: new t1.Uniform1i(e1, i.u_pitch_with_map),
                    u_texsize: new t1.Uniform2f(e1, i.u_texsize),
                    u_texture: new t1.Uniform1i(e1, i.u_texture)
                }),
            symbolSDF: (e1, i)=>({
                    u_is_size_zoom_constant: new t1.Uniform1i(e1, i.u_is_size_zoom_constant),
                    u_is_size_feature_constant: new t1.Uniform1i(e1, i.u_is_size_feature_constant),
                    u_size_t: new t1.Uniform1f(e1, i.u_size_t),
                    u_size: new t1.Uniform1f(e1, i.u_size),
                    u_camera_to_center_distance: new t1.Uniform1f(e1, i.u_camera_to_center_distance),
                    u_pitch: new t1.Uniform1f(e1, i.u_pitch),
                    u_rotate_symbol: new t1.Uniform1i(e1, i.u_rotate_symbol),
                    u_aspect_ratio: new t1.Uniform1f(e1, i.u_aspect_ratio),
                    u_fade_change: new t1.Uniform1f(e1, i.u_fade_change),
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_label_plane_matrix: new t1.UniformMatrix4f(e1, i.u_label_plane_matrix),
                    u_coord_matrix: new t1.UniformMatrix4f(e1, i.u_coord_matrix),
                    u_is_text: new t1.Uniform1i(e1, i.u_is_text),
                    u_pitch_with_map: new t1.Uniform1i(e1, i.u_pitch_with_map),
                    u_texsize: new t1.Uniform2f(e1, i.u_texsize),
                    u_texture: new t1.Uniform1i(e1, i.u_texture),
                    u_gamma_scale: new t1.Uniform1f(e1, i.u_gamma_scale),
                    u_device_pixel_ratio: new t1.Uniform1f(e1, i.u_device_pixel_ratio),
                    u_is_halo: new t1.Uniform1i(e1, i.u_is_halo)
                }),
            symbolTextAndIcon: (e1, i)=>({
                    u_is_size_zoom_constant: new t1.Uniform1i(e1, i.u_is_size_zoom_constant),
                    u_is_size_feature_constant: new t1.Uniform1i(e1, i.u_is_size_feature_constant),
                    u_size_t: new t1.Uniform1f(e1, i.u_size_t),
                    u_size: new t1.Uniform1f(e1, i.u_size),
                    u_camera_to_center_distance: new t1.Uniform1f(e1, i.u_camera_to_center_distance),
                    u_pitch: new t1.Uniform1f(e1, i.u_pitch),
                    u_rotate_symbol: new t1.Uniform1i(e1, i.u_rotate_symbol),
                    u_aspect_ratio: new t1.Uniform1f(e1, i.u_aspect_ratio),
                    u_fade_change: new t1.Uniform1f(e1, i.u_fade_change),
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_label_plane_matrix: new t1.UniformMatrix4f(e1, i.u_label_plane_matrix),
                    u_coord_matrix: new t1.UniformMatrix4f(e1, i.u_coord_matrix),
                    u_is_text: new t1.Uniform1i(e1, i.u_is_text),
                    u_pitch_with_map: new t1.Uniform1i(e1, i.u_pitch_with_map),
                    u_texsize: new t1.Uniform2f(e1, i.u_texsize),
                    u_texsize_icon: new t1.Uniform2f(e1, i.u_texsize_icon),
                    u_texture: new t1.Uniform1i(e1, i.u_texture),
                    u_texture_icon: new t1.Uniform1i(e1, i.u_texture_icon),
                    u_gamma_scale: new t1.Uniform1f(e1, i.u_gamma_scale),
                    u_device_pixel_ratio: new t1.Uniform1f(e1, i.u_device_pixel_ratio),
                    u_is_halo: new t1.Uniform1i(e1, i.u_is_halo)
                }),
            background: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_opacity: new t1.Uniform1f(e1, i.u_opacity),
                    u_color: new t1.UniformColor(e1, i.u_color)
                }),
            backgroundPattern: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_opacity: new t1.Uniform1f(e1, i.u_opacity),
                    u_image: new t1.Uniform1i(e1, i.u_image),
                    u_pattern_tl_a: new t1.Uniform2f(e1, i.u_pattern_tl_a),
                    u_pattern_br_a: new t1.Uniform2f(e1, i.u_pattern_br_a),
                    u_pattern_tl_b: new t1.Uniform2f(e1, i.u_pattern_tl_b),
                    u_pattern_br_b: new t1.Uniform2f(e1, i.u_pattern_br_b),
                    u_texsize: new t1.Uniform2f(e1, i.u_texsize),
                    u_mix: new t1.Uniform1f(e1, i.u_mix),
                    u_pattern_size_a: new t1.Uniform2f(e1, i.u_pattern_size_a),
                    u_pattern_size_b: new t1.Uniform2f(e1, i.u_pattern_size_b),
                    u_scale_a: new t1.Uniform1f(e1, i.u_scale_a),
                    u_scale_b: new t1.Uniform1f(e1, i.u_scale_b),
                    u_pixel_coord_upper: new t1.Uniform2f(e1, i.u_pixel_coord_upper),
                    u_pixel_coord_lower: new t1.Uniform2f(e1, i.u_pixel_coord_lower),
                    u_tile_units_to_pixels: new t1.Uniform1f(e1, i.u_tile_units_to_pixels)
                }),
            terrain: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_texture: new t1.Uniform1i(e1, i.u_texture)
                }),
            terrainDepth: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix)
                }),
            terrainCoords: (e1, i)=>({
                    u_matrix: new t1.UniformMatrix4f(e1, i.u_matrix),
                    u_texture: new t1.Uniform1i(e1, i.u_texture),
                    u_terrain_coords_id: new t1.Uniform1f(e1, i.u_terrain_coords_id)
                })
        };
        class ke {
            constructor(t1, e1, i){
                this.context = t1;
                const o = t1.gl;
                this.buffer = o.createBuffer(), this.dynamicDraw = Boolean(i), this.context.unbindVAO(), t1.bindElementBuffer.set(this.buffer), o.bufferData(o.ELEMENT_ARRAY_BUFFER, e1.arrayBuffer, this.dynamicDraw ? o.DYNAMIC_DRAW : o.STATIC_DRAW), this.dynamicDraw || delete e1.arrayBuffer;
            }
            bind() {
                this.context.bindElementBuffer.set(this.buffer);
            }
            updateData(t1) {
                const e1 = this.context.gl;
                if (!this.dynamicDraw) throw new Error("Attempted to update data while not in dynamic mode.");
                this.context.unbindVAO(), this.bind(), e1.bufferSubData(e1.ELEMENT_ARRAY_BUFFER, 0, t1.arrayBuffer);
            }
            destroy() {
                this.buffer && (this.context.gl.deleteBuffer(this.buffer), delete this.buffer);
            }
        }
        const Be = {
            Int8: "BYTE",
            Uint8: "UNSIGNED_BYTE",
            Int16: "SHORT",
            Uint16: "UNSIGNED_SHORT",
            Int32: "INT",
            Uint32: "UNSIGNED_INT",
            Float32: "FLOAT"
        };
        class Fe {
            constructor(t1, e1, i, o){
                this.length = e1.length, this.attributes = i, this.itemSize = e1.bytesPerElement, this.dynamicDraw = o, this.context = t1;
                const a = t1.gl;
                this.buffer = a.createBuffer(), t1.bindVertexBuffer.set(this.buffer), a.bufferData(a.ARRAY_BUFFER, e1.arrayBuffer, this.dynamicDraw ? a.DYNAMIC_DRAW : a.STATIC_DRAW), this.dynamicDraw || delete e1.arrayBuffer;
            }
            bind() {
                this.context.bindVertexBuffer.set(this.buffer);
            }
            updateData(t1) {
                if (t1.length !== this.length) throw new Error(`Length of new data is ${t1.length}, which doesn't match current length of ${this.length}`);
                const e1 = this.context.gl;
                this.bind(), e1.bufferSubData(e1.ARRAY_BUFFER, 0, t1.arrayBuffer);
            }
            enableAttributes(t1, e1) {
                for(let i = 0; i < this.attributes.length; i++){
                    const o = e1.attributes[this.attributes[i].name];
                    void 0 !== o && t1.enableVertexAttribArray(o);
                }
            }
            setVertexAttribPointers(t1, e1, i) {
                for(let o = 0; o < this.attributes.length; o++){
                    const a = this.attributes[o], r = e1.attributes[a.name];
                    void 0 !== r && t1.vertexAttribPointer(r, a.components, t1[Be[a.type]], !1, this.itemSize, a.offset + this.itemSize * (i || 0));
                }
            }
            destroy() {
                this.buffer && (this.context.gl.deleteBuffer(this.buffer), delete this.buffer);
            }
        }
        class Oe {
            constructor(t1){
                this.gl = t1.gl, this.default = this.getDefault(), this.current = this.default, this.dirty = !1;
            }
            get() {
                return this.current;
            }
            set(t1) {}
            getDefault() {
                return this.default;
            }
            setDefault() {
                this.set(this.default);
            }
        }
        class Ue extends Oe {
            getDefault() {
                return t1.Color.transparent;
            }
            set(t1) {
                const e1 = this.current;
                (t1.r !== e1.r || t1.g !== e1.g || t1.b !== e1.b || t1.a !== e1.a || this.dirty) && (this.gl.clearColor(t1.r, t1.g, t1.b, t1.a), this.current = t1, this.dirty = !1);
            }
        }
        class Ne extends Oe {
            getDefault() {
                return 1;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.clearDepth(t1), this.current = t1, this.dirty = !1);
            }
        }
        class Ge extends Oe {
            getDefault() {
                return 0;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.clearStencil(t1), this.current = t1, this.dirty = !1);
            }
        }
        class Ze extends Oe {
            getDefault() {
                return [
                    !0,
                    !0,
                    !0,
                    !0
                ];
            }
            set(t1) {
                const e1 = this.current;
                (t1[0] !== e1[0] || t1[1] !== e1[1] || t1[2] !== e1[2] || t1[3] !== e1[3] || this.dirty) && (this.gl.colorMask(t1[0], t1[1], t1[2], t1[3]), this.current = t1, this.dirty = !1);
            }
        }
        class Ve extends Oe {
            getDefault() {
                return !0;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.depthMask(t1), this.current = t1, this.dirty = !1);
            }
        }
        class qe extends Oe {
            getDefault() {
                return 255;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.stencilMask(t1), this.current = t1, this.dirty = !1);
            }
        }
        class je extends Oe {
            getDefault() {
                return {
                    func: this.gl.ALWAYS,
                    ref: 0,
                    mask: 255
                };
            }
            set(t1) {
                const e1 = this.current;
                (t1.func !== e1.func || t1.ref !== e1.ref || t1.mask !== e1.mask || this.dirty) && (this.gl.stencilFunc(t1.func, t1.ref, t1.mask), this.current = t1, this.dirty = !1);
            }
        }
        class $e extends Oe {
            getDefault() {
                const t1 = this.gl;
                return [
                    t1.KEEP,
                    t1.KEEP,
                    t1.KEEP
                ];
            }
            set(t1) {
                const e1 = this.current;
                (t1[0] !== e1[0] || t1[1] !== e1[1] || t1[2] !== e1[2] || this.dirty) && (this.gl.stencilOp(t1[0], t1[1], t1[2]), this.current = t1, this.dirty = !1);
            }
        }
        class Xe extends Oe {
            getDefault() {
                return !1;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                t1 ? e1.enable(e1.STENCIL_TEST) : e1.disable(e1.STENCIL_TEST), this.current = t1, this.dirty = !1;
            }
        }
        class We extends Oe {
            getDefault() {
                return [
                    0,
                    1
                ];
            }
            set(t1) {
                const e1 = this.current;
                (t1[0] !== e1[0] || t1[1] !== e1[1] || this.dirty) && (this.gl.depthRange(t1[0], t1[1]), this.current = t1, this.dirty = !1);
            }
        }
        class He extends Oe {
            getDefault() {
                return !1;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                t1 ? e1.enable(e1.DEPTH_TEST) : e1.disable(e1.DEPTH_TEST), this.current = t1, this.dirty = !1;
            }
        }
        class Ke extends Oe {
            getDefault() {
                return this.gl.LESS;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.depthFunc(t1), this.current = t1, this.dirty = !1);
            }
        }
        class Ye extends Oe {
            getDefault() {
                return !1;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                t1 ? e1.enable(e1.BLEND) : e1.disable(e1.BLEND), this.current = t1, this.dirty = !1;
            }
        }
        class Je extends Oe {
            getDefault() {
                const t1 = this.gl;
                return [
                    t1.ONE,
                    t1.ZERO
                ];
            }
            set(t1) {
                const e1 = this.current;
                (t1[0] !== e1[0] || t1[1] !== e1[1] || this.dirty) && (this.gl.blendFunc(t1[0], t1[1]), this.current = t1, this.dirty = !1);
            }
        }
        class Qe extends Oe {
            getDefault() {
                return t1.Color.transparent;
            }
            set(t1) {
                const e1 = this.current;
                (t1.r !== e1.r || t1.g !== e1.g || t1.b !== e1.b || t1.a !== e1.a || this.dirty) && (this.gl.blendColor(t1.r, t1.g, t1.b, t1.a), this.current = t1, this.dirty = !1);
            }
        }
        class ti extends Oe {
            getDefault() {
                return this.gl.FUNC_ADD;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.blendEquation(t1), this.current = t1, this.dirty = !1);
            }
        }
        class ei extends Oe {
            getDefault() {
                return !1;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                t1 ? e1.enable(e1.CULL_FACE) : e1.disable(e1.CULL_FACE), this.current = t1, this.dirty = !1;
            }
        }
        class ii extends Oe {
            getDefault() {
                return this.gl.BACK;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.cullFace(t1), this.current = t1, this.dirty = !1);
            }
        }
        class oi extends Oe {
            getDefault() {
                return this.gl.CCW;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.frontFace(t1), this.current = t1, this.dirty = !1);
            }
        }
        class ai extends Oe {
            getDefault() {
                return null;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.useProgram(t1), this.current = t1, this.dirty = !1);
            }
        }
        class ri extends Oe {
            getDefault() {
                return this.gl.TEXTURE0;
            }
            set(t1) {
                (t1 !== this.current || this.dirty) && (this.gl.activeTexture(t1), this.current = t1, this.dirty = !1);
            }
        }
        class si extends Oe {
            getDefault() {
                const t1 = this.gl;
                return [
                    0,
                    0,
                    t1.drawingBufferWidth,
                    t1.drawingBufferHeight
                ];
            }
            set(t1) {
                const e1 = this.current;
                (t1[0] !== e1[0] || t1[1] !== e1[1] || t1[2] !== e1[2] || t1[3] !== e1[3] || this.dirty) && (this.gl.viewport(t1[0], t1[1], t1[2], t1[3]), this.current = t1, this.dirty = !1);
            }
        }
        class ni extends Oe {
            getDefault() {
                return null;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                e1.bindFramebuffer(e1.FRAMEBUFFER, t1), this.current = t1, this.dirty = !1;
            }
        }
        class li extends Oe {
            getDefault() {
                return null;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                e1.bindRenderbuffer(e1.RENDERBUFFER, t1), this.current = t1, this.dirty = !1;
            }
        }
        class ci extends Oe {
            getDefault() {
                return null;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                e1.bindTexture(e1.TEXTURE_2D, t1), this.current = t1, this.dirty = !1;
            }
        }
        class hi extends Oe {
            getDefault() {
                return null;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                e1.bindBuffer(e1.ARRAY_BUFFER, t1), this.current = t1, this.dirty = !1;
            }
        }
        class ui extends Oe {
            getDefault() {
                return null;
            }
            set(t1) {
                const e1 = this.gl;
                e1.bindBuffer(e1.ELEMENT_ARRAY_BUFFER, t1), this.current = t1, this.dirty = !1;
            }
        }
        class di extends Oe {
            constructor(t1){
                super(t1), this.vao = t1.extVertexArrayObject;
            }
            getDefault() {
                return null;
            }
            set(t1) {
                this.vao && (t1 !== this.current || this.dirty) && (this.vao.bindVertexArrayOES(t1), this.current = t1, this.dirty = !1);
            }
        }
        class mi extends Oe {
            getDefault() {
                return 4;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                e1.pixelStorei(e1.UNPACK_ALIGNMENT, t1), this.current = t1, this.dirty = !1;
            }
        }
        class _i extends Oe {
            getDefault() {
                return !1;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                e1.pixelStorei(e1.UNPACK_PREMULTIPLY_ALPHA_WEBGL, t1), this.current = t1, this.dirty = !1;
            }
        }
        class pi extends Oe {
            getDefault() {
                return !1;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                const e1 = this.gl;
                e1.pixelStorei(e1.UNPACK_FLIP_Y_WEBGL, t1), this.current = t1, this.dirty = !1;
            }
        }
        class fi extends Oe {
            constructor(t1, e1){
                super(t1), this.context = t1, this.parent = e1;
            }
            getDefault() {
                return null;
            }
        }
        class gi extends fi {
            setDirty() {
                this.dirty = !0;
            }
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                this.context.bindFramebuffer.set(this.parent);
                const e1 = this.gl;
                e1.framebufferTexture2D(e1.FRAMEBUFFER, e1.COLOR_ATTACHMENT0, e1.TEXTURE_2D, t1, 0), this.current = t1, this.dirty = !1;
            }
        }
        class xi extends fi {
            set(t1) {
                if (t1 === this.current && !this.dirty) return;
                this.context.bindFramebuffer.set(this.parent);
                const e1 = this.gl;
                e1.framebufferRenderbuffer(e1.FRAMEBUFFER, e1.DEPTH_ATTACHMENT, e1.RENDERBUFFER, t1), this.current = t1, this.dirty = !1;
            }
        }
        class vi {
            constructor(t1, e1, i, o){
                this.context = t1, this.width = e1, this.height = i;
                const a = t1.gl, r = this.framebuffer = a.createFramebuffer();
                if (this.colorAttachment = new gi(t1, r), o && (this.depthAttachment = new xi(t1, r)), a.checkFramebufferStatus(a.FRAMEBUFFER) !== a.FRAMEBUFFER_COMPLETE) throw new Error("Framebuffer is not complete");
            }
            destroy() {
                const t1 = this.context.gl, e1 = this.colorAttachment.get();
                if (e1 && t1.deleteTexture(e1), this.depthAttachment) {
                    const e2 = this.depthAttachment.get();
                    e2 && t1.deleteRenderbuffer(e2);
                }
                t1.deleteFramebuffer(this.framebuffer);
            }
        }
        class yi {
            constructor(t1, e1, i){
                this.blendFunction = t1, this.blendColor = e1, this.mask = i;
            }
        }
        yi.Replace = [
            1,
            0
        ], yi.disabled = new yi(yi.Replace, t1.Color.transparent, [
            !1,
            !1,
            !1,
            !1
        ]), yi.unblended = new yi(yi.Replace, t1.Color.transparent, [
            !0,
            !0,
            !0,
            !0
        ]), yi.alphaBlended = new yi([
            1,
            771
        ], t1.Color.transparent, [
            !0,
            !0,
            !0,
            !0
        ]);
        class bi {
            constructor(t1){
                this.gl = t1, this.extVertexArrayObject = this.gl.getExtension("OES_vertex_array_object"), this.clearColor = new Ue(this), this.clearDepth = new Ne(this), this.clearStencil = new Ge(this), this.colorMask = new Ze(this), this.depthMask = new Ve(this), this.stencilMask = new qe(this), this.stencilFunc = new je(this), this.stencilOp = new $e(this), this.stencilTest = new Xe(this), this.depthRange = new We(this), this.depthTest = new He(this), this.depthFunc = new Ke(this), this.blend = new Ye(this), this.blendFunc = new Je(this), this.blendColor = new Qe(this), this.blendEquation = new ti(this), this.cullFace = new ei(this), this.cullFaceSide = new ii(this), this.frontFace = new oi(this), this.program = new ai(this), this.activeTexture = new ri(this), this.viewport = new si(this), this.bindFramebuffer = new ni(this), this.bindRenderbuffer = new li(this), this.bindTexture = new ci(this), this.bindVertexBuffer = new hi(this), this.bindElementBuffer = new ui(this), this.bindVertexArrayOES = this.extVertexArrayObject && new di(this), this.pixelStoreUnpack = new mi(this), this.pixelStoreUnpackPremultiplyAlpha = new _i(this), this.pixelStoreUnpackFlipY = new pi(this), this.extTextureFilterAnisotropic = t1.getExtension("EXT_texture_filter_anisotropic") || t1.getExtension("MOZ_EXT_texture_filter_anisotropic") || t1.getExtension("WEBKIT_EXT_texture_filter_anisotropic"), this.extTextureFilterAnisotropic && (this.extTextureFilterAnisotropicMax = t1.getParameter(this.extTextureFilterAnisotropic.MAX_TEXTURE_MAX_ANISOTROPY_EXT)), this.extTextureHalfFloat = t1.getExtension("OES_texture_half_float"), this.extTextureHalfFloat && (t1.getExtension("OES_texture_half_float_linear"), this.extRenderToTextureHalfFloat = t1.getExtension("EXT_color_buffer_half_float")), this.extTimerQuery = t1.getExtension("EXT_disjoint_timer_query"), this.maxTextureSize = t1.getParameter(t1.MAX_TEXTURE_SIZE);
            }
            setDefault() {
                this.unbindVAO(), this.clearColor.setDefault(), this.clearDepth.setDefault(), this.clearStencil.setDefault(), this.colorMask.setDefault(), this.depthMask.setDefault(), this.stencilMask.setDefault(), this.stencilFunc.setDefault(), this.stencilOp.setDefault(), this.stencilTest.setDefault(), this.depthRange.setDefault(), this.depthTest.setDefault(), this.depthFunc.setDefault(), this.blend.setDefault(), this.blendFunc.setDefault(), this.blendColor.setDefault(), this.blendEquation.setDefault(), this.cullFace.setDefault(), this.cullFaceSide.setDefault(), this.frontFace.setDefault(), this.program.setDefault(), this.activeTexture.setDefault(), this.bindFramebuffer.setDefault(), this.pixelStoreUnpack.setDefault(), this.pixelStoreUnpackPremultiplyAlpha.setDefault(), this.pixelStoreUnpackFlipY.setDefault();
            }
            setDirty() {
                this.clearColor.dirty = !0, this.clearDepth.dirty = !0, this.clearStencil.dirty = !0, this.colorMask.dirty = !0, this.depthMask.dirty = !0, this.stencilMask.dirty = !0, this.stencilFunc.dirty = !0, this.stencilOp.dirty = !0, this.stencilTest.dirty = !0, this.depthRange.dirty = !0, this.depthTest.dirty = !0, this.depthFunc.dirty = !0, this.blend.dirty = !0, this.blendFunc.dirty = !0, this.blendColor.dirty = !0, this.blendEquation.dirty = !0, this.cullFace.dirty = !0, this.cullFaceSide.dirty = !0, this.frontFace.dirty = !0, this.program.dirty = !0, this.activeTexture.dirty = !0, this.viewport.dirty = !0, this.bindFramebuffer.dirty = !0, this.bindRenderbuffer.dirty = !0, this.bindTexture.dirty = !0, this.bindVertexBuffer.dirty = !0, this.bindElementBuffer.dirty = !0, this.extVertexArrayObject && (this.bindVertexArrayOES.dirty = !0), this.pixelStoreUnpack.dirty = !0, this.pixelStoreUnpackPremultiplyAlpha.dirty = !0, this.pixelStoreUnpackFlipY.dirty = !0;
            }
            createIndexBuffer(t1, e1) {
                return new ke(this, t1, e1);
            }
            createVertexBuffer(t1, e1, i) {
                return new Fe(this, t1, e1, i);
            }
            createRenderbuffer(t1, e1, i) {
                const o = this.gl, a = o.createRenderbuffer();
                return this.bindRenderbuffer.set(a), o.renderbufferStorage(o.RENDERBUFFER, t1, e1, i), this.bindRenderbuffer.set(null), a;
            }
            createFramebuffer(t1, e1, i) {
                return new vi(this, t1, e1, i);
            }
            clear({ color: t1 , depth: e1  }) {
                const i = this.gl;
                let o = 0;
                t1 && (o |= i.COLOR_BUFFER_BIT, this.clearColor.set(t1), this.colorMask.set([
                    !0,
                    !0,
                    !0,
                    !0
                ])), void 0 !== e1 && (o |= i.DEPTH_BUFFER_BIT, this.depthRange.set([
                    0,
                    1
                ]), this.clearDepth.set(e1), this.depthMask.set(!0)), i.clear(o);
            }
            setCullFace(t1) {
                !1 === t1.enable ? this.cullFace.set(!1) : (this.cullFace.set(!0), this.cullFaceSide.set(t1.mode), this.frontFace.set(t1.frontFace));
            }
            setDepthMode(t1) {
                t1.func !== this.gl.ALWAYS || t1.mask ? (this.depthTest.set(!0), this.depthFunc.set(t1.func), this.depthMask.set(t1.mask), this.depthRange.set(t1.range)) : this.depthTest.set(!1);
            }
            setStencilMode(t1) {
                t1.test.func !== this.gl.ALWAYS || t1.mask ? (this.stencilTest.set(!0), this.stencilMask.set(t1.mask), this.stencilOp.set([
                    t1.fail,
                    t1.depthFail,
                    t1.pass
                ]), this.stencilFunc.set({
                    func: t1.test.func,
                    ref: t1.ref,
                    mask: t1.test.mask
                })) : this.stencilTest.set(!1);
            }
            setColorMode(t1) {
                a(t1.blendFunction, yi.Replace) ? this.blend.set(!1) : (this.blend.set(!0), this.blendFunc.set(t1.blendFunction), this.blendColor.set(t1.blendColor)), this.colorMask.set(t1.mask);
            }
            unbindVAO() {
                this.extVertexArrayObject && this.bindVertexArrayOES.set(null);
            }
        }
        class wi {
            constructor(t1, e1, i){
                this.func = t1, this.mask = e1, this.range = i;
            }
        }
        wi.ReadOnly = !1, wi.ReadWrite = !0, wi.disabled = new wi(519, wi.ReadOnly, [
            0,
            1
        ]);
        const Ti = 7680;
        class Ei {
            constructor(t1, e1, i, o, a, r){
                this.test = t1, this.ref = e1, this.mask = i, this.fail = o, this.depthFail = a, this.pass = r;
            }
        }
        Ei.disabled = new Ei({
            func: 519,
            mask: 0
        }, 0, 0, Ti, Ti, Ti);
        class Ii {
            constructor(t1, e1, i){
                this.enable = t1, this.mode = e1, this.frontFace = i;
            }
        }
        let Ci;
        function Si(e1, i, o, a, r, s, n) {
            const l = e1.context, c = l.gl, h = e1.useProgram("collisionBox"), u = [];
            let d = 0, m = 0;
            for(let _ = 0; _ < a.length; _++){
                const p = a[_], f = i.getTile(p), g = f.getBucket(o);
                if (!g) continue;
                let x = p.posMatrix;
                0 === r[0] && 0 === r[1] || (x = e1.translatePosMatrix(p.posMatrix, f, r, s));
                const v = n ? g.textCollisionBox : g.iconCollisionBox, y = g.collisionCircleArray;
                if (y.length > 0) {
                    const i1 = t1.create(), o1 = x;
                    t1.mul(i1, g.placementInvProjMatrix, e1.transform.glCoordMatrix), t1.mul(i1, i1, g.placementViewportMatrix), u.push({
                        circleArray: y,
                        circleOffset: m,
                        transform: o1,
                        invTransform: i1,
                        coord: p
                    }), d += y.length / 4, m = d;
                }
                v && h.draw(l, c.LINES, wi.disabled, Ei.disabled, e1.colorModeForRenderPass(), Ii.disabled, fe(x, e1.transform, f), e1.style.terrain && e1.style.terrain.getTerrainData(p), o.id, v.layoutVertexBuffer, v.indexBuffer, v.segments, null, e1.transform.zoom, null, null, v.collisionVertexBuffer);
            }
            if (!n || !u.length) return;
            const _1 = e1.useProgram("collisionCircle"), p1 = new t1.CollisionCircleLayoutArray;
            p1.resize(4 * d), p1._trim();
            let f1 = 0;
            for (const t2 of u)for(let e2 = 0; e2 < t2.circleArray.length / 4; e2++){
                const i2 = 4 * e2, o2 = t2.circleArray[i2 + 0], a1 = t2.circleArray[i2 + 1], r1 = t2.circleArray[i2 + 2], s1 = t2.circleArray[i2 + 3];
                p1.emplace(f1++, o2, a1, r1, s1, 0), p1.emplace(f1++, o2, a1, r1, s1, 1), p1.emplace(f1++, o2, a1, r1, s1, 2), p1.emplace(f1++, o2, a1, r1, s1, 3);
            }
            (!Ci || Ci.length < 2 * d) && (Ci = function(e1) {
                const i = 2 * e1, o = new t1.QuadTriangleArray;
                o.resize(i), o._trim();
                for(let t2 = 0; t2 < i; t2++){
                    const e2 = 6 * t2;
                    o.uint16[e2 + 0] = 4 * t2 + 0, o.uint16[e2 + 1] = 4 * t2 + 1, o.uint16[e2 + 2] = 4 * t2 + 2, o.uint16[e2 + 3] = 4 * t2 + 2, o.uint16[e2 + 4] = 4 * t2 + 3, o.uint16[e2 + 5] = 4 * t2 + 0;
                }
                return o;
            }(d));
            const g1 = l.createIndexBuffer(Ci, !0), x1 = l.createVertexBuffer(p1, t1.collisionCircleLayout.members, !0);
            for (const i3 of u){
                const a2 = {
                    u_matrix: i3.transform,
                    u_inv_matrix: i3.invTransform,
                    u_camera_to_center_distance: (v1 = e1.transform).cameraToCenterDistance,
                    u_viewport_size: [
                        v1.width,
                        v1.height
                    ]
                };
                _1.draw(l, c.TRIANGLES, wi.disabled, Ei.disabled, e1.colorModeForRenderPass(), Ii.disabled, a2, e1.style.terrain && e1.style.terrain.getTerrainData(i3.coord), o.id, x1, g1, t1.SegmentVector.simpleSegment(0, 2 * i3.circleOffset, i3.circleArray.length, i3.circleArray.length / 2), null, e1.transform.zoom, null, null, null);
            }
            var v1;
            x1.destroy(), g1.destroy();
        }
        Ii.disabled = new Ii(!1, 1029, 2305), Ii.backCCW = new Ii(!0, 1029, 2305);
        const Di = t1.identity(new Float32Array(16));
        function zi(e1, i, o, a, r, s) {
            const { horizontalAlign: n , verticalAlign: l  } = t1.getAnchorAlignment(e1), c = -(n - .5) * i, h = -(l - .5) * o, u = t1.evaluateVariableOffset(e1, a);
            return new t1.pointGeometry((c / r + u[0]) * s, (h / r + u[1]) * s);
        }
        function Pi(e1, i, o, a, r, s, n, l, c, h, u) {
            const d = e1.text.placedSymbolArray, m = e1.text.dynamicLayoutVertexArray, _ = e1.icon.dynamicLayoutVertexArray, p = {};
            m.clear();
            for(let _1 = 0; _1 < d.length; _1++){
                const f = d.get(_1), g = e1.allowVerticalPlacement && !f.placedOrientation, x = f.hidden || !f.crossTileID || g ? null : a[f.crossTileID];
                if (x) {
                    const a1 = new t1.pointGeometry(f.anchorX, f.anchorY), d1 = nt(a1, o ? n : s, u), _2 = lt(r.cameraToCenterDistance, d1.signedDistanceFromCamera);
                    let g1 = t1.evaluateSizeForFeature(e1.textSizeData, c, f) * _2 / t1.ONE_EM;
                    o && (g1 *= e1.tilePixelRatio / l);
                    const { width: v , height: y , anchor: b , textOffset: w , textBoxScale: T  } = x, E = zi(b, v, y, w, T, g1), I = o ? nt(a1.add(E), s, u).point : d1.point.add(i ? E.rotate(-r.angle) : E), C = e1.allowVerticalPlacement && f.placedOrientation === t1.WritingMode.vertical ? Math.PI / 2 : 0;
                    for(let e2 = 0; e2 < f.numGlyphs; e2++)t1.addDynamicAttributes(m, I, C);
                    h && f.associatedIconIndex >= 0 && (p[f.associatedIconIndex] = {
                        shiftedAnchor: I,
                        angle: C
                    });
                } else gt(f.numGlyphs, m);
            }
            if (h) {
                _.clear();
                const i1 = e1.icon.placedSymbolArray;
                for(let e3 = 0; e3 < i1.length; e3++){
                    const o1 = i1.get(e3);
                    if (o1.hidden) gt(o1.numGlyphs, _);
                    else {
                        const i2 = p[e3];
                        if (i2) for(let e4 = 0; e4 < o1.numGlyphs; e4++)t1.addDynamicAttributes(_, i2.shiftedAnchor, i2.angle);
                        else gt(o1.numGlyphs, _);
                    }
                }
                e1.icon.dynamicLayoutVertexBuffer.updateData(_);
            }
            e1.text.dynamicLayoutVertexBuffer.updateData(m);
        }
        function Mi(t1, e1, i) {
            return i.iconsInText && e1 ? "symbolTextAndIcon" : t1 ? "symbolSDF" : "symbolIcon";
        }
        function Ai(e1, i, o, a, r, s, n, l, c, h, u, d) {
            const m = e1.context, _ = m.gl, p = e1.transform, f = "map" === l, g = "map" === c, x = "viewport" !== l && "point" !== o.layout.get("symbol-placement"), v = f && !g && !x, y = !o.layout.get("symbol-sort-key").isConstant();
            let b = !1;
            const w = e1.depthModeForSublayer(0, wi.ReadOnly), T = o.layout.get("text-variable-anchor"), E = [];
            for (const l1 of a){
                const a1 = i.getTile(l1), c1 = a1.getBucket(o);
                if (!c1) continue;
                const u1 = r ? c1.text : c1.icon;
                if (!u1 || !u1.segments.get().length) continue;
                const d1 = u1.programConfigurations.get(o.id), m1 = r || c1.sdfIcons, w1 = r ? c1.textSizeData : c1.iconSizeData, I = g || 0 !== p.pitch, C = e1.useProgram(Mi(m1, r, c1), d1), S = t1.evaluateSizeForZoom(w1, p.zoom), D = e1.style.terrain && e1.style.terrain.getTerrainData(l1);
                let z, P, M, A, L = [
                    0,
                    0
                ], R = null;
                if (r) {
                    if (P = a1.glyphAtlasTexture, M = _.LINEAR, z = a1.glyphAtlasTexture.size, c1.iconsInText) {
                        L = a1.imageAtlasTexture.size, R = a1.imageAtlasTexture;
                        const t2 = "composite" === w1.kind || "camera" === w1.kind;
                        A = I || e1.options.rotating || e1.options.zooming || t2 ? _.LINEAR : _.NEAREST;
                    }
                } else {
                    const t3 = 1 !== o.layout.get("icon-size").constantOr(0) || c1.iconsNeedLinear;
                    P = a1.imageAtlasTexture, M = m1 || e1.options.rotating || e1.options.zooming || t3 || I ? _.LINEAR : _.NEAREST, z = a1.imageAtlasTexture.size;
                }
                const k = bt(a1, 1, e1.transform.zoom), B = rt(l1.posMatrix, g, f, e1.transform, k), F = st(l1.posMatrix, g, f, e1.transform, k), O = T && c1.hasTextData(), U = "none" !== o.layout.get("icon-text-fit") && O && c1.hasIconData();
                if (x) {
                    const t4 = e1.style.terrain ? (t1, i)=>e1.style.terrain.getElevation(l1, t1, i) : null, i1 = "map" === o.layout.get("text-rotation-alignment");
                    ht(c1, l1.posMatrix, e1, r, B, F, g, h, i1, t4);
                }
                const N = e1.translatePosMatrix(l1.posMatrix, a1, s, n), G = x || r && T || U ? Di : B, Z = e1.translatePosMatrix(F, a1, s, n, !0), V = m1 && 0 !== o.paint.get(r ? "text-halo-width" : "icon-halo-width").constantOr(1);
                let q;
                q = m1 ? c1.iconsInText ? Me(w1.kind, S, v, g, e1, N, G, Z, z, L) : Pe(w1.kind, S, v, g, e1, N, G, Z, r, z, !0) : ze(w1.kind, S, v, g, e1, N, G, Z, r, z);
                const j = {
                    program: C,
                    buffers: u1,
                    uniformValues: q,
                    atlasTexture: P,
                    atlasTextureIcon: R,
                    atlasInterpolation: M,
                    atlasInterpolationIcon: A,
                    isSDF: m1,
                    hasHalo: V
                };
                if (y && c1.canOverlap) {
                    b = !0;
                    const e2 = u1.segments.get();
                    for (const i2 of e2)E.push({
                        segments: new t1.SegmentVector([
                            i2
                        ]),
                        sortKey: i2.sortKey,
                        state: j,
                        terrainData: D
                    });
                } else E.push({
                    segments: u1.segments,
                    sortKey: 0,
                    state: j,
                    terrainData: D
                });
            }
            b && E.sort((t1, e1)=>t1.sortKey - e1.sortKey);
            for (const t5 of E){
                const i3 = t5.state;
                if (m.activeTexture.set(_.TEXTURE0), i3.atlasTexture.bind(i3.atlasInterpolation, _.CLAMP_TO_EDGE), i3.atlasTextureIcon && (m.activeTexture.set(_.TEXTURE1), i3.atlasTextureIcon && i3.atlasTextureIcon.bind(i3.atlasInterpolationIcon, _.CLAMP_TO_EDGE)), i3.isSDF) {
                    const a2 = i3.uniformValues;
                    i3.hasHalo && (a2.u_is_halo = 1, Li(i3.buffers, t5.segments, o, e1, i3.program, w, u, d, a2, t5.terrainData)), a2.u_is_halo = 0;
                }
                Li(i3.buffers, t5.segments, o, e1, i3.program, w, u, d, i3.uniformValues, t5.terrainData);
            }
        }
        function Li(t1, e1, i, o, a, r, s, n, l, c) {
            const h = o.context;
            a.draw(h, h.gl.TRIANGLES, r, s, n, Ii.disabled, l, c, i.id, t1.layoutVertexBuffer, t1.indexBuffer, e1, i.paint, o.transform.zoom, t1.programConfigurations.get(i.id), t1.dynamicLayoutVertexBuffer, t1.opacityVertexBuffer);
        }
        function Ri(t1, e1, i, o, a, r, s) {
            const n = t1.context.gl, l = i.paint.get("fill-pattern"), c = l && l.constantOr(1), h = i.getCrossfadeParameters();
            let u, d, m, _, p;
            s ? (d = c && !i.getPaintProperty("fill-outline-color") ? "fillOutlinePattern" : "fillOutline", u = n.LINES) : (d = c ? "fillPattern" : "fill", u = n.TRIANGLES);
            for (const f of o){
                const o1 = e1.getTile(f);
                if (c && !o1.patternsLoaded()) continue;
                const g = o1.getBucket(i);
                if (!g) continue;
                const x = g.programConfigurations.get(i.id), v = t1.useProgram(d, x), y = t1.style.terrain && t1.style.terrain.getTerrainData(f);
                c && (t1.context.activeTexture.set(n.TEXTURE0), o1.imageAtlasTexture.bind(n.LINEAR, n.CLAMP_TO_EDGE), x.updatePaintBuffers(h));
                const b = l.constantOr(null);
                if (b && o1.imageAtlas) {
                    const t2 = o1.imageAtlas, e2 = t2.patternPositions[b.to.toString()], i1 = t2.patternPositions[b.from.toString()];
                    e2 && i1 && x.setConstantPatternPositions(e2, i1);
                }
                const w = y ? f : null, T = t1.translatePosMatrix(w ? w.posMatrix : f.posMatrix, o1, i.paint.get("fill-translate"), i.paint.get("fill-translate-anchor"));
                if (s) {
                    _ = g.indexBuffer2, p = g.segments2;
                    const e3 = [
                        n.drawingBufferWidth,
                        n.drawingBufferHeight
                    ];
                    m = "fillOutlinePattern" === d && c ? _e(T, t1, h, o1, e3) : me(T, e3);
                } else _ = g.indexBuffer, p = g.segments, m = c ? de(T, t1, h, o1) : ue(T);
                v.draw(t1.context, u, a, t1.stencilModeForClipping(f), r, Ii.disabled, m, y, i.id, g.layoutVertexBuffer, _, p, i.paint, t1.transform.zoom, x);
            }
        }
        function ki(t1, e1, i, o, a, r, s) {
            const n = t1.context, l = n.gl, c = i.paint.get("fill-extrusion-pattern"), h = c.constantOr(1), u = i.getCrossfadeParameters(), d = i.paint.get("fill-extrusion-opacity");
            for (const m of o){
                const o1 = e1.getTile(m), _ = o1.getBucket(i);
                if (!_) continue;
                const p = t1.style.terrain && t1.style.terrain.getTerrainData(m), f = _.programConfigurations.get(i.id), g = t1.useProgram(h ? "fillExtrusionPattern" : "fillExtrusion", f);
                h && (t1.context.activeTexture.set(l.TEXTURE0), o1.imageAtlasTexture.bind(l.LINEAR, l.CLAMP_TO_EDGE), f.updatePaintBuffers(u));
                const x = c.constantOr(null);
                if (x && o1.imageAtlas) {
                    const t2 = o1.imageAtlas, e2 = t2.patternPositions[x.to.toString()], i1 = t2.patternPositions[x.from.toString()];
                    e2 && i1 && f.setConstantPatternPositions(e2, i1);
                }
                const v = t1.translatePosMatrix(m.posMatrix, o1, i.paint.get("fill-extrusion-translate"), i.paint.get("fill-extrusion-translate-anchor")), y = i.paint.get("fill-extrusion-vertical-gradient"), b = h ? he(v, t1, y, d, m, u, o1) : ce(v, t1, y, d);
                g.draw(n, n.gl.TRIANGLES, a, r, s, Ii.backCCW, b, p, i.id, _.layoutVertexBuffer, _.indexBuffer, _.segments, i.paint, t1.transform.zoom, f, t1.style.terrain && _.centroidVertexBuffer);
            }
        }
        function Bi(t1, e1, i, o, a, r, s) {
            const n = t1.context, l = n.gl, c = i.fbo;
            if (!c) return;
            const h = t1.useProgram("hillshade"), u = t1.style.terrain && t1.style.terrain.getTerrainData(e1);
            n.activeTexture.set(l.TEXTURE0), l.bindTexture(l.TEXTURE_2D, c.colorAttachment.get()), h.draw(n, l.TRIANGLES, a, r, s, Ii.disabled, ((t1, e1, i, o)=>{
                const a = i.paint.get("hillshade-shadow-color"), r = i.paint.get("hillshade-highlight-color"), s = i.paint.get("hillshade-accent-color");
                let n = i.paint.get("hillshade-illumination-direction") * (Math.PI / 180);
                "viewport" === i.paint.get("hillshade-illumination-anchor") && (n -= t1.transform.angle);
                const l = !t1.options.moving;
                return {
                    u_matrix: o ? o.posMatrix : t1.transform.calculatePosMatrix(e1.tileID.toUnwrapped(), l),
                    u_image: 0,
                    u_latrange: ye(0, e1.tileID),
                    u_light: [
                        i.paint.get("hillshade-exaggeration"),
                        n
                    ],
                    u_shadow: a,
                    u_highlight: r,
                    u_accent: s
                };
            })(t1, i, o, u ? e1 : null), u, o.id, t1.rasterBoundsBuffer, t1.quadTriangleIndexBuffer, t1.rasterBoundsSegments);
        }
        function Fi(e1, i, o, a, r, s) {
            const n = e1.context, c = n.gl, h = i.dem;
            if (h && h.data) {
                const u = h.dim, d = h.stride, m = h.getPixels();
                if (n.activeTexture.set(c.TEXTURE1), n.pixelStoreUnpackPremultiplyAlpha.set(!1), i.demTexture = i.demTexture || e1.getTileTexture(d), i.demTexture) {
                    const t2 = i.demTexture;
                    t2.update(m, {
                        premultiply: !1
                    }), t2.bind(c.NEAREST, c.CLAMP_TO_EDGE);
                } else i.demTexture = new l(n, m, c.RGBA, {
                    premultiply: !1
                }), i.demTexture.bind(c.NEAREST, c.CLAMP_TO_EDGE);
                n.activeTexture.set(c.TEXTURE0);
                let _ = i.fbo;
                if (!_) {
                    const t3 = new l(n, {
                        width: u,
                        height: u,
                        data: null
                    }, c.RGBA);
                    t3.bind(c.LINEAR, c.CLAMP_TO_EDGE), _ = i.fbo = n.createFramebuffer(u, u, !0), _.colorAttachment.set(t3.texture);
                }
                n.bindFramebuffer.set(_.framebuffer), n.viewport.set([
                    0,
                    0,
                    u,
                    u
                ]), e1.useProgram("hillshadePrepare").draw(n, c.TRIANGLES, a, r, s, Ii.disabled, ((e1, i)=>{
                    const o = i.stride, a = t1.create();
                    return t1.ortho(a, 0, t1.EXTENT, -t1.EXTENT, 0, 0, 1), t1.translate(a, a, [
                        0,
                        -t1.EXTENT,
                        0
                    ]), {
                        u_matrix: a,
                        u_image: 1,
                        u_dimension: [
                            o,
                            o
                        ],
                        u_zoom: e1.overscaledZ,
                        u_unpack: i.getUnpackVector()
                    };
                })(i.tileID, h), null, o.id, e1.rasterBoundsBuffer, e1.quadTriangleIndexBuffer, e1.rasterBoundsSegments), i.needsHillshadePrepare = !1;
            }
        }
        function Oi(e1, i, o, a, r, s) {
            const n = a.paint.get("raster-fade-duration");
            if (!s && n > 0) {
                const a1 = t1.exported.now(), s1 = (a1 - e1.timeAdded) / n, l = i ? (a1 - i.timeAdded) / n : -1, c = o.getSource(), h = r.coveringZoomLevel({
                    tileSize: c.tileSize,
                    roundZoom: c.roundZoom
                }), u = !i || Math.abs(i.tileID.overscaledZ - h) > Math.abs(e1.tileID.overscaledZ - h), d = u && e1.refreshedUponExpiration ? 1 : t1.clamp(u ? s1 : 1 - l, 0, 1);
                return e1.refreshedUponExpiration && s1 >= 1 && (e1.refreshedUponExpiration = !1), i ? {
                    opacity: 1,
                    mix: 1 - d
                } : {
                    opacity: d,
                    mix: 0
                };
            }
            return {
                opacity: 1,
                mix: 0
            };
        }
        const Ui = new t1.Color(1, 0, 0, 1), Ni = new t1.Color(0, 1, 0, 1), Gi = new t1.Color(0, 0, 1, 1), Zi = new t1.Color(1, 0, 1, 1), Vi = new t1.Color(0, 1, 1, 1);
        function qi(t1, e1, i, o) {
            $i(t1, 0, e1 + i / 2, t1.transform.width, i, o);
        }
        function ji(t1, e1, i, o) {
            $i(t1, e1 - i / 2, 0, i, t1.transform.height, o);
        }
        function $i(t1, e1, i, o, a, r) {
            const s = t1.context, n = s.gl;
            n.enable(n.SCISSOR_TEST), n.scissor(e1 * t1.pixelRatio, i * t1.pixelRatio, o * t1.pixelRatio, a * t1.pixelRatio), s.clear({
                color: r
            }), n.disable(n.SCISSOR_TEST);
        }
        function Xi(e1, i, o) {
            const a = e1.context, r = a.gl, s = o.posMatrix, n = e1.useProgram("debug"), l = wi.disabled, c = Ei.disabled, h = e1.colorModeForRenderPass(), u = "$debug", d = e1.style.terrain && e1.style.terrain.getTerrainData(o);
            a.activeTexture.set(r.TEXTURE0), e1.emptyTexture.bind(r.LINEAR, r.CLAMP_TO_EDGE);
            const m = i.getTileByID(o.key).latestRawTileData, _ = Math.floor((m && m.byteLength || 0) / 1024), p = i.getTile(o).tileSize, f = 512 / Math.min(p, 512) * (o.overscaledZ / e1.transform.zoom) * .5;
            let g = o.canonical.toString();
            o.overscaledZ !== o.canonical.z && (g += ` => ${o.overscaledZ}`), function(t1, e1) {
                t1.initDebugOverlayCanvas();
                const i = t1.debugOverlayCanvas, o = t1.context.gl, a = t1.debugOverlayCanvas.getContext("2d");
                a.clearRect(0, 0, i.width, i.height), a.shadowColor = "white", a.shadowBlur = 2, a.lineWidth = 1.5, a.strokeStyle = "white", a.textBaseline = "top", a.font = "bold 36px Open Sans, sans-serif", a.fillText(e1, 5, 5), a.strokeText(e1, 5, 5), t1.debugOverlayTexture.update(i), t1.debugOverlayTexture.bind(o.LINEAR, o.CLAMP_TO_EDGE);
            }(e1, `${g} ${_}kB`), n.draw(a, r.TRIANGLES, l, c, yi.alphaBlended, Ii.disabled, ge(s, t1.Color.transparent, f), null, u, e1.debugBuffer, e1.quadTriangleIndexBuffer, e1.debugSegments), n.draw(a, r.LINE_STRIP, l, c, h, Ii.disabled, ge(s, t1.Color.red), d, u, e1.debugBuffer, e1.tileBorderIndexBuffer, e1.debugSegments);
        }
        function Wi(t1, e1, i) {
            const o = t1.context, a = o.gl, r = t1.colorModeForRenderPass(), s = new wi(a.LEQUAL, wi.ReadWrite, t1.depthRangeFor3D), n = t1.useProgram("terrain"), l = e1.getTerrainMesh(), c = e1.getTerrainData(i.tileID);
            o.bindFramebuffer.set(null), o.viewport.set([
                0,
                0,
                t1.width,
                t1.height
            ]), o.activeTexture.set(a.TEXTURE0), a.bindTexture(a.TEXTURE_2D, e1.getRTTFramebuffer().colorAttachment.get());
            const h = t1.transform.calculatePosMatrix(i.tileID.toUnwrapped());
            n.draw(o, a.TRIANGLES, s, Ei.disabled, r, Ii.backCCW, {
                u_matrix: h,
                u_texture: 0
            }, c, "terrain", l.vertexBuffer, l.indexBuffer, l.segments);
        }
        function Hi(t1, e1, i, o) {
            const a = t1.context, r = i.tileSize * e1.qualityFactor;
            i.textures[o] || (i.textures[o] = t1.getTileTexture(r) || new l(a, {
                width: r,
                height: r,
                data: null
            }, a.gl.RGBA), i.textures[o].bind(a.gl.LINEAR, a.gl.CLAMP_TO_EDGE), 0 === o && e1.sourceCache.renderHistory.unshift(i.tileID.key));
            const s = e1.getRTTFramebuffer();
            s.colorAttachment.set(i.textures[o].texture), a.bindFramebuffer.set(s.framebuffer), a.viewport.set([
                0,
                0,
                r,
                r
            ]);
        }
        class Ki {
            constructor(t1){
                this._coordsDescendingInv = {}, this._coordsDescendingInvStr = {}, this.painter = t1, this._renderToTexture = {
                    background: !0,
                    fill: !0,
                    line: !0,
                    raster: !0
                }, this._coordsDescendingInv = {}, this._coordsDescendingInvStr = {}, this._stacks = [], this._prevType = null, this._rerender = {}, this._renderableTiles = t1.style.terrain.sourceCache.getRenderableTiles(), this._init();
            }
            _init() {
                const t1 = this.painter.style, e1 = t1.terrain;
                for(const i in t1.sourceCaches){
                    this._coordsDescendingInv[i] = {};
                    const o = t1.sourceCaches[i].getVisibleCoordinates();
                    for (const t2 of o){
                        const o1 = e1.sourceCache.getTerrainCoords(t2);
                        for(const t3 in o1)this._coordsDescendingInv[i][t3] || (this._coordsDescendingInv[i][t3] = []), this._coordsDescendingInv[i][t3].push(o1[t3]);
                    }
                }
                for (const e2 of t1._order){
                    const i1 = t1._layers[e2], o2 = i1.source;
                    if (this._renderToTexture[i1.type] && !this._coordsDescendingInvStr[o2]) {
                        this._coordsDescendingInvStr[o2] = {};
                        for(const t4 in this._coordsDescendingInv[o2])this._coordsDescendingInvStr[o2][t4] = this._coordsDescendingInv[o2][t4].map((t1)=>t1.key).sort().join();
                    }
                }
                return this._renderableTiles.forEach((t1)=>{
                    for(const i in this._coordsDescendingInvStr){
                        const o = this._coordsDescendingInvStr[i][t1.tileID.key];
                        o && o !== t1.textureCoords[i] && t1.clearTextures(this.painter), e1.needsRerender(i, t1.tileID) && t1.clearTextures(this.painter);
                    }
                    this._rerender[t1.tileID.key] = !t1.textures.length;
                }), e1.clearRerenderCache(), e1.sourceCache.removeOutdated(this.painter), this;
            }
            renderLayer(e1) {
                const i = e1.type, o = this.painter, a = o.style._order, r = o.currentLayer, s = r + 1 === a.length;
                if (this._renderToTexture[i] && (this._prevType && this._renderToTexture[this._prevType] || this._stacks.push([]), this._prevType = i, this._stacks[this._stacks.length - 1].push(a[r]), !s)) return !0;
                if (this._renderToTexture[this._prevType] || "hillshade" === i || this._renderToTexture[i] && s) {
                    this._prevType = i;
                    const s1 = this._stacks.length - 1, n = this._stacks[s1] || [];
                    for (const e2 of this._renderableTiles){
                        if (Hi(o, o.style.terrain, e2, s1), this._rerender[e2.tileID.key]) {
                            o.context.clear({
                                color: t1.Color.transparent
                            });
                            for(let t2 = 0; t2 < n.length; t2++){
                                const i1 = o.style._layers[n[t2]], a1 = i1.source ? this._coordsDescendingInv[i1.source][e2.tileID.key] : [
                                    e2.tileID
                                ];
                                o._renderTileClippingMasks(i1, a1), o.renderLayer(o, o.style.sourceCaches[i1.source], i1, a1), i1.source && (e2.textureCoords[i1.source] = this._coordsDescendingInvStr[i1.source][e2.tileID.key]);
                            }
                        }
                        Wi(o, o.style.terrain, e2);
                    }
                    if ("hillshade" === i) {
                        this._stacks.push([
                            a[r]
                        ]);
                        for (const i2 of this._renderableTiles){
                            const a2 = this._coordsDescendingInv[e1.source][i2.tileID.key];
                            Hi(o, o.style.terrain, i2, this._stacks.length - 1), o.context.clear({
                                color: t1.Color.transparent
                            }), o._renderTileClippingMasks(e1, a2), o.renderLayer(o, o.style.sourceCaches[e1.source], e1, a2), Wi(o, o.style.terrain, i2);
                        }
                        return !0;
                    }
                    return this._renderToTexture[i];
                }
                return !1;
            }
        }
        const Yi = {
            symbol: function(e1, i, o, a, r) {
                if ("translucent" !== e1.renderPass) return;
                const s = Ei.disabled, n = e1.colorModeForRenderPass();
                o.layout.get("text-variable-anchor") && function(e1, i, o, a, r, s, n) {
                    const l = i.transform, c = "map" === r, h = "map" === s;
                    for (const r1 of e1){
                        const e2 = a.getTile(r1), s1 = e2.getBucket(o);
                        if (!s1 || !s1.text || !s1.text.segments.get().length) continue;
                        const u = t1.evaluateSizeForZoom(s1.textSizeData, l.zoom), d = bt(e2, 1, i.transform.zoom), m = rt(r1.posMatrix, h, c, i.transform, d), _ = "none" !== o.layout.get("icon-text-fit") && s1.hasIconData();
                        if (u) {
                            const t2 = Math.pow(2, l.zoom - e2.tileID.overscaledZ);
                            Pi(s1, c, h, n, l, m, r1.posMatrix, t2, u, _, i.style.terrain ? (t1, e1)=>i.style.terrain.getElevation(r1, t1, e1) : null);
                        }
                    }
                }(a, e1, o, i, o.layout.get("text-rotation-alignment"), o.layout.get("text-pitch-alignment"), r), 0 !== o.paint.get("icon-opacity").constantOr(1) && Ai(e1, i, o, a, !1, o.paint.get("icon-translate"), o.paint.get("icon-translate-anchor"), o.layout.get("icon-rotation-alignment"), o.layout.get("icon-pitch-alignment"), o.layout.get("icon-keep-upright"), s, n), 0 !== o.paint.get("text-opacity").constantOr(1) && Ai(e1, i, o, a, !0, o.paint.get("text-translate"), o.paint.get("text-translate-anchor"), o.layout.get("text-rotation-alignment"), o.layout.get("text-pitch-alignment"), o.layout.get("text-keep-upright"), s, n), i.map.showCollisionBoxes && (Si(e1, i, o, a, o.paint.get("text-translate"), o.paint.get("text-translate-anchor"), !0), Si(e1, i, o, a, o.paint.get("icon-translate"), o.paint.get("icon-translate-anchor"), !1));
            },
            circle: function(e1, i, o, a) {
                if ("translucent" !== e1.renderPass) return;
                const r = o.paint.get("circle-opacity"), s = o.paint.get("circle-stroke-width"), n = o.paint.get("circle-stroke-opacity"), l = !o.layout.get("circle-sort-key").isConstant();
                if (0 === r.constantOr(1) && (0 === s.constantOr(1) || 0 === n.constantOr(1))) return;
                const c = e1.context, h = c.gl, u = e1.depthModeForSublayer(0, wi.ReadOnly), d = Ei.disabled, m = e1.colorModeForRenderPass(), _ = [];
                for(let r1 = 0; r1 < a.length; r1++){
                    const s1 = a[r1], n1 = i.getTile(s1), c1 = n1.getBucket(o);
                    if (!c1) continue;
                    const h1 = c1.programConfigurations.get(o.id), u1 = e1.useProgram("circle", h1), d1 = c1.layoutVertexBuffer, m1 = c1.indexBuffer, p = e1.style.terrain && e1.style.terrain.getTerrainData(s1), f = {
                        programConfiguration: h1,
                        program: u1,
                        layoutVertexBuffer: d1,
                        indexBuffer: m1,
                        uniformValues: pe(e1, s1, n1, o),
                        terrainData: p
                    };
                    if (l) {
                        const e2 = c1.segments.get();
                        for (const i1 of e2)_.push({
                            segments: new t1.SegmentVector([
                                i1
                            ]),
                            sortKey: i1.sortKey,
                            state: f
                        });
                    } else _.push({
                        segments: c1.segments,
                        sortKey: 0,
                        state: f
                    });
                }
                l && _.sort((t1, e1)=>t1.sortKey - e1.sortKey);
                for (const t2 of _){
                    const { programConfiguration: i2 , program: a1 , layoutVertexBuffer: r2 , indexBuffer: s2 , uniformValues: n2 , terrainData: l1  } = t2.state;
                    a1.draw(c, h.TRIANGLES, u, d, m, Ii.disabled, n2, l1, o.id, r2, s2, t2.segments, o.paint, e1.transform.zoom, i2);
                }
            },
            heatmap: function(e1, i, o, a) {
                if (0 !== o.paint.get("heatmap-opacity")) {
                    if ("offscreen" === e1.renderPass) {
                        const r = e1.context, s = r.gl, n = Ei.disabled, l1 = new yi([
                            s.ONE,
                            s.ONE
                        ], t1.Color.transparent, [
                            !0,
                            !0,
                            !0,
                            !0
                        ]);
                        !function(t1, e1, i) {
                            const o = t1.gl;
                            t1.activeTexture.set(o.TEXTURE1), t1.viewport.set([
                                0,
                                0,
                                e1.width / 4,
                                e1.height / 4
                            ]);
                            let a = i.heatmapFbo;
                            if (a) o.bindTexture(o.TEXTURE_2D, a.colorAttachment.get()), t1.bindFramebuffer.set(a.framebuffer);
                            else {
                                const r = o.createTexture();
                                o.bindTexture(o.TEXTURE_2D, r), o.texParameteri(o.TEXTURE_2D, o.TEXTURE_WRAP_S, o.CLAMP_TO_EDGE), o.texParameteri(o.TEXTURE_2D, o.TEXTURE_WRAP_T, o.CLAMP_TO_EDGE), o.texParameteri(o.TEXTURE_2D, o.TEXTURE_MIN_FILTER, o.LINEAR), o.texParameteri(o.TEXTURE_2D, o.TEXTURE_MAG_FILTER, o.LINEAR), a = i.heatmapFbo = t1.createFramebuffer(e1.width / 4, e1.height / 4, !1), function(t1, e1, i, o) {
                                    const a = t1.gl;
                                    a.texImage2D(a.TEXTURE_2D, 0, a.RGBA, e1.width / 4, e1.height / 4, 0, a.RGBA, t1.extRenderToTextureHalfFloat ? t1.extTextureHalfFloat.HALF_FLOAT_OES : a.UNSIGNED_BYTE, null), o.colorAttachment.set(i);
                                }(t1, e1, r, a);
                            }
                        }(r, e1, o), r.clear({
                            color: t1.Color.transparent
                        });
                        for(let t2 = 0; t2 < a.length; t2++){
                            const c = a[t2];
                            if (i.hasRenderableParent(c)) continue;
                            const h = i.getTile(c), u = h.getBucket(o);
                            if (!u) continue;
                            const d = u.programConfigurations.get(o.id), m = e1.useProgram("heatmap", d), { zoom: _  } = e1.transform;
                            m.draw(r, s.TRIANGLES, wi.disabled, n, l1, Ii.disabled, ve(c.posMatrix, h, _, o.paint.get("heatmap-intensity")), null, o.id, u.layoutVertexBuffer, u.indexBuffer, u.segments, o.paint, e1.transform.zoom, d);
                        }
                        r.viewport.set([
                            0,
                            0,
                            e1.width,
                            e1.height
                        ]);
                    } else "translucent" === e1.renderPass && (e1.context.setColorMode(e1.colorModeForRenderPass()), function(e1, i) {
                        const o = e1.context, a = o.gl, r = i.heatmapFbo;
                        if (!r) return;
                        o.activeTexture.set(a.TEXTURE0), a.bindTexture(a.TEXTURE_2D, r.colorAttachment.get()), o.activeTexture.set(a.TEXTURE1);
                        let s = i.colorRampTexture;
                        s || (s = i.colorRampTexture = new l(o, i.colorRamp, a.RGBA)), s.bind(a.LINEAR, a.CLAMP_TO_EDGE), e1.useProgram("heatmapTexture").draw(o, a.TRIANGLES, wi.disabled, Ei.disabled, e1.colorModeForRenderPass(), Ii.disabled, ((e1, i, o, a)=>{
                            const r = t1.create();
                            t1.ortho(r, 0, e1.width, e1.height, 0, 0, 1);
                            const s = e1.context.gl;
                            return {
                                u_matrix: r,
                                u_world: [
                                    s.drawingBufferWidth,
                                    s.drawingBufferHeight
                                ],
                                u_image: 0,
                                u_color_ramp: 1,
                                u_opacity: i.paint.get("heatmap-opacity")
                            };
                        })(e1, i), null, i.id, e1.viewportBuffer, e1.quadTriangleIndexBuffer, e1.viewportSegments, i.paint, e1.transform.zoom);
                    }(e1, o));
                }
            },
            line: function(e1, i, o, a) {
                if ("translucent" !== e1.renderPass) return;
                const r = o.paint.get("line-opacity"), s = o.paint.get("line-width");
                if (0 === r.constantOr(1) || 0 === s.constantOr(1)) return;
                const n = e1.depthModeForSublayer(0, wi.ReadOnly), c = e1.colorModeForRenderPass(), h = o.paint.get("line-dasharray"), u = o.paint.get("line-pattern"), d = u.constantOr(1), m = o.paint.get("line-gradient"), _ = o.getCrossfadeParameters(), p = d ? "linePattern" : h ? "lineSDF" : m ? "lineGradient" : "line", f = e1.context, g = f.gl;
                let x = !0;
                for (const r1 of a){
                    const a1 = i.getTile(r1);
                    if (d && !a1.patternsLoaded()) continue;
                    const s1 = a1.getBucket(o);
                    if (!s1) continue;
                    const v = s1.programConfigurations.get(o.id), y = e1.context.program.get(), b = e1.useProgram(p, v), w = x || b.program !== y, T = e1.style.terrain && e1.style.terrain.getTerrainData(r1), E = u.constantOr(null);
                    if (E && a1.imageAtlas) {
                        const t2 = a1.imageAtlas, e2 = t2.patternPositions[E.to.toString()], i1 = t2.patternPositions[E.from.toString()];
                        e2 && i1 && v.setConstantPatternPositions(e2, i1);
                    }
                    const I = T ? r1 : null, C = d ? Te(e1, a1, o, _, I) : h ? Ee(e1, a1, o, h, _, I) : m ? we(e1, a1, o, s1.lineClipsArray.length, I) : be(e1, a1, o, I);
                    if (d) f.activeTexture.set(g.TEXTURE0), a1.imageAtlasTexture.bind(g.LINEAR, g.CLAMP_TO_EDGE), v.updatePaintBuffers(_);
                    else if (h && (w || e1.lineAtlas.dirty)) f.activeTexture.set(g.TEXTURE0), e1.lineAtlas.bind(f);
                    else if (m) {
                        const a2 = s1.gradients[o.id];
                        let n1 = a2.texture;
                        if (o.gradientVersion !== a2.version) {
                            let c1 = 256;
                            if (o.stepInterpolant) {
                                const o1 = i.getSource().maxzoom, a3 = r1.canonical.z === o1 ? Math.ceil(1 << e1.transform.maxZoom - r1.canonical.z) : 1;
                                c1 = t1.clamp(t1.nextPowerOfTwo(s1.maxLineLength / t1.EXTENT * 1024 * a3), 256, f.maxTextureSize);
                            }
                            a2.gradient = t1.renderColorRamp({
                                expression: o.gradientExpression(),
                                evaluationKey: "lineProgress",
                                resolution: c1,
                                image: a2.gradient || void 0,
                                clips: s1.lineClipsArray
                            }), a2.texture ? a2.texture.update(a2.gradient) : a2.texture = new l(f, a2.gradient, g.RGBA), a2.version = o.gradientVersion, n1 = a2.texture;
                        }
                        f.activeTexture.set(g.TEXTURE0), n1.bind(o.stepInterpolant ? g.NEAREST : g.LINEAR, g.CLAMP_TO_EDGE);
                    }
                    b.draw(f, g.TRIANGLES, n, e1.stencilModeForClipping(r1), c, Ii.disabled, C, T, o.id, s1.layoutVertexBuffer, s1.indexBuffer, s1.segments, o.paint, e1.transform.zoom, v, s1.layoutVertexBuffer2), x = !1;
                }
            },
            fill: function(e1, i, o, a) {
                const r = o.paint.get("fill-color"), s = o.paint.get("fill-opacity");
                if (0 === s.constantOr(1)) return;
                const n = e1.colorModeForRenderPass(), l = o.paint.get("fill-pattern"), c = e1.opaquePassEnabledForLayer() && !l.constantOr(1) && 1 === r.constantOr(t1.Color.transparent).a && 1 === s.constantOr(0) ? "opaque" : "translucent";
                if (e1.renderPass === c) {
                    const t2 = e1.depthModeForSublayer(1, "opaque" === e1.renderPass ? wi.ReadWrite : wi.ReadOnly);
                    Ri(e1, i, o, a, t2, n, !1);
                }
                if ("translucent" === e1.renderPass && o.paint.get("fill-antialias")) {
                    const t3 = e1.depthModeForSublayer(o.getPaintProperty("fill-outline-color") ? 2 : 0, wi.ReadOnly);
                    Ri(e1, i, o, a, t3, n, !0);
                }
            },
            "fill-extrusion": function(t1, e1, i, o) {
                const a = i.paint.get("fill-extrusion-opacity");
                if (0 !== a && "translucent" === t1.renderPass) {
                    const r = new wi(t1.context.gl.LEQUAL, wi.ReadWrite, t1.depthRangeFor3D);
                    if (1 !== a || i.paint.get("fill-extrusion-pattern").constantOr(1)) ki(t1, e1, i, o, r, Ei.disabled, yi.disabled), ki(t1, e1, i, o, r, t1.stencilModeFor3D(), t1.colorModeForRenderPass());
                    else {
                        const a1 = t1.colorModeForRenderPass();
                        ki(t1, e1, i, o, r, Ei.disabled, a1);
                    }
                }
            },
            hillshade: function(t1, e1, i, o) {
                if ("offscreen" !== t1.renderPass && "translucent" !== t1.renderPass) return;
                const a = t1.context, r = t1.depthModeForSublayer(0, wi.ReadOnly), s = t1.colorModeForRenderPass(), [n, l] = "translucent" === t1.renderPass ? t1.stencilConfigForOverlap(o) : [
                    {},
                    o
                ];
                for (const o1 of l){
                    const a1 = e1.getTile(o1);
                    void 0 !== a1.needsHillshadePrepare && a1.needsHillshadePrepare && "offscreen" === t1.renderPass ? Fi(t1, a1, i, r, Ei.disabled, s) : "translucent" === t1.renderPass && Bi(t1, o1, a1, i, r, n[o1.overscaledZ], s);
                }
                a.viewport.set([
                    0,
                    0,
                    t1.width,
                    t1.height
                ]);
            },
            raster: function(t1, e1, i, o) {
                if ("translucent" !== t1.renderPass) return;
                if (0 === i.paint.get("raster-opacity")) return;
                if (!o.length) return;
                const a = t1.context, r = a.gl, s = e1.getSource(), n = t1.useProgram("raster"), l = t1.colorModeForRenderPass(), [c, h] = s instanceof D ? [
                    {},
                    o
                ] : t1.stencilConfigForOverlap(o), u = h[h.length - 1].overscaledZ, d = !t1.options.moving;
                for (const o1 of h){
                    const h1 = t1.depthModeForSublayer(o1.overscaledZ - u, 1 === i.paint.get("raster-opacity") ? wi.ReadWrite : wi.ReadOnly, r.LESS), m = e1.getTile(o1);
                    m.registerFadeDuration(i.paint.get("raster-fade-duration"));
                    const _ = e1.findLoadedParent(o1, 0), p = Oi(m, _, e1, i, t1.transform, t1.style.terrain);
                    let f, g;
                    const x = "nearest" === i.paint.get("raster-resampling") ? r.NEAREST : r.LINEAR;
                    a.activeTexture.set(r.TEXTURE0), m.texture.bind(x, r.CLAMP_TO_EDGE, r.LINEAR_MIPMAP_NEAREST), a.activeTexture.set(r.TEXTURE1), _ ? (_.texture.bind(x, r.CLAMP_TO_EDGE, r.LINEAR_MIPMAP_NEAREST), f = Math.pow(2, _.tileID.overscaledZ - m.tileID.overscaledZ), g = [
                        m.tileID.canonical.x * f % 1,
                        m.tileID.canonical.y * f % 1
                    ]) : m.texture.bind(x, r.CLAMP_TO_EDGE, r.LINEAR_MIPMAP_NEAREST);
                    const v = t1.style.terrain && t1.style.terrain.getTerrainData(o1), y = v ? o1 : null, b = y ? y.posMatrix : t1.transform.calculatePosMatrix(o1.toUnwrapped(), d), w = Se(b, g || [
                        0,
                        0
                    ], f || 1, p, i);
                    s instanceof D ? n.draw(a, r.TRIANGLES, h1, Ei.disabled, l, Ii.disabled, w, v, i.id, s.boundsBuffer, t1.quadTriangleIndexBuffer, s.boundsSegments) : n.draw(a, r.TRIANGLES, h1, c[o1.overscaledZ], l, Ii.disabled, w, v, i.id, t1.rasterBoundsBuffer, t1.quadTriangleIndexBuffer, t1.rasterBoundsSegments);
                }
            },
            background: function(t1, e1, i, o) {
                const a = i.paint.get("background-color"), r = i.paint.get("background-opacity");
                if (0 === r) return;
                const s = t1.context, n = s.gl, l = t1.transform, c = l.tileSize, h = i.paint.get("background-pattern");
                if (t1.isPatternMissing(h)) return;
                const u = !h && 1 === a.a && 1 === r && t1.opaquePassEnabledForLayer() ? "opaque" : "translucent";
                if (t1.renderPass !== u) return;
                const d = Ei.disabled, m = t1.depthModeForSublayer(0, "opaque" === u ? wi.ReadWrite : wi.ReadOnly), _ = t1.colorModeForRenderPass(), p = t1.useProgram(h ? "backgroundPattern" : "background"), f = o || l.coveringTiles({
                    tileSize: c,
                    terrain: t1.style.terrain
                });
                h && (s.activeTexture.set(n.TEXTURE0), t1.imageManager.bind(t1.context));
                const g = i.getCrossfadeParameters();
                for (const e2 of f){
                    const l1 = o ? e2.posMatrix : t1.transform.calculatePosMatrix(e2.toUnwrapped()), u1 = h ? Le(l1, r, t1, h, {
                        tileID: e2,
                        tileSize: c
                    }, g) : Ae(l1, r, a), f1 = t1.style.terrain && t1.style.terrain.getTerrainData(e2);
                    p.draw(s, n.TRIANGLES, m, d, _, Ii.disabled, u1, f1, i.id, t1.tileExtentBuffer, t1.quadTriangleIndexBuffer, t1.tileExtentSegments);
                }
            },
            debug: function(t1, e1, i) {
                for(let o = 0; o < i.length; o++)Xi(t1, e1, i[o]);
            },
            custom: function(t1, e1, i) {
                const o = t1.context, a = i.implementation;
                if ("offscreen" === t1.renderPass) {
                    const e2 = a.prerender;
                    e2 && (t1.setCustomLayerDefaults(), o.setColorMode(t1.colorModeForRenderPass()), e2.call(a, o.gl, t1.transform.customLayerMatrix()), o.setDirty(), t1.setBaseState());
                } else if ("translucent" === t1.renderPass) {
                    t1.setCustomLayerDefaults(), o.setColorMode(t1.colorModeForRenderPass()), o.setStencilMode(Ei.disabled);
                    const e3 = "3d" === a.renderingMode ? new wi(t1.context.gl.LEQUAL, wi.ReadWrite, t1.depthRangeFor3D) : t1.depthModeForSublayer(0, wi.ReadOnly);
                    o.setDepthMode(e3), a.render(o.gl, t1.transform.customLayerMatrix()), o.setDirty(), t1.setBaseState(), o.bindFramebuffer.set(null);
                }
            }
        };
        class Ji {
            constructor(e1, i){
                this.context = new bi(e1), this.transform = i, this._tileTextures = {}, this.terrainFacilitator = {
                    dirty: !0,
                    matrix: t1.create(),
                    renderTime: 0
                }, this.setup(), this.numSublayers = O.maxUnderzooming + O.maxOverzooming + 1, this.depthEpsilon = 1 / Math.pow(2, 16), this.crossTileSymbolIndex = new Xt, this.gpuTimers = {};
            }
            resize(t1, e1, i) {
                if (this.width = t1 * i, this.height = e1 * i, this.pixelRatio = i, this.context.viewport.set([
                    0,
                    0,
                    this.width,
                    this.height
                ]), this.style) for (const t2 of this.style._order)this.style._layers[t2].resize();
            }
            setup() {
                const e1 = this.context, i = new t1.PosArray;
                i.emplaceBack(0, 0), i.emplaceBack(t1.EXTENT, 0), i.emplaceBack(0, t1.EXTENT), i.emplaceBack(t1.EXTENT, t1.EXTENT), this.tileExtentBuffer = e1.createVertexBuffer(i, Wt.members), this.tileExtentSegments = t1.SegmentVector.simpleSegment(0, 0, 4, 2);
                const o = new t1.PosArray;
                o.emplaceBack(0, 0), o.emplaceBack(t1.EXTENT, 0), o.emplaceBack(0, t1.EXTENT), o.emplaceBack(t1.EXTENT, t1.EXTENT), this.debugBuffer = e1.createVertexBuffer(o, Wt.members), this.debugSegments = t1.SegmentVector.simpleSegment(0, 0, 4, 5);
                const a = new t1.RasterBoundsArray;
                a.emplaceBack(0, 0, 0, 0), a.emplaceBack(t1.EXTENT, 0, t1.EXTENT, 0), a.emplaceBack(0, t1.EXTENT, 0, t1.EXTENT), a.emplaceBack(t1.EXTENT, t1.EXTENT, t1.EXTENT, t1.EXTENT), this.rasterBoundsBuffer = e1.createVertexBuffer(a, S.members), this.rasterBoundsSegments = t1.SegmentVector.simpleSegment(0, 0, 4, 2);
                const r = new t1.PosArray;
                r.emplaceBack(0, 0), r.emplaceBack(1, 0), r.emplaceBack(0, 1), r.emplaceBack(1, 1), this.viewportBuffer = e1.createVertexBuffer(r, Wt.members), this.viewportSegments = t1.SegmentVector.simpleSegment(0, 0, 4, 2);
                const s = new t1.LineStripIndexArray;
                s.emplaceBack(0), s.emplaceBack(1), s.emplaceBack(3), s.emplaceBack(2), s.emplaceBack(0), this.tileBorderIndexBuffer = e1.createIndexBuffer(s);
                const n = new t1.TriangleIndexArray;
                n.emplaceBack(0, 1, 2), n.emplaceBack(2, 1, 3), this.quadTriangleIndexBuffer = e1.createIndexBuffer(n), this.emptyTexture = new l(e1, {
                    width: 1,
                    height: 1,
                    data: new Uint8Array([
                        0,
                        0,
                        0,
                        0
                    ])
                }, e1.gl.RGBA);
                const c = this.context.gl;
                this.stencilClearMode = new Ei({
                    func: c.ALWAYS,
                    mask: 0
                }, 0, 255, c.ZERO, c.ZERO, c.ZERO);
            }
            clearStencil() {
                const e1 = this.context, i = e1.gl;
                this.nextStencilID = 1, this.currentStencilSource = void 0;
                const o = t1.create();
                t1.ortho(o, 0, this.width, this.height, 0, 0, 1), t1.scale(o, o, [
                    i.drawingBufferWidth,
                    i.drawingBufferHeight,
                    0
                ]), this.useProgram("clippingMask").draw(e1, i.TRIANGLES, wi.disabled, this.stencilClearMode, yi.disabled, Ii.disabled, xe(o), null, "$clipping", this.viewportBuffer, this.quadTriangleIndexBuffer, this.viewportSegments);
            }
            _renderTileClippingMasks(t1, e1) {
                if (this.currentStencilSource === t1.source || !t1.isTileClipped() || !e1 || !e1.length) return;
                this.currentStencilSource = t1.source;
                const i = this.context, o = i.gl;
                this.nextStencilID + e1.length > 256 && this.clearStencil(), i.setColorMode(yi.disabled), i.setDepthMode(wi.disabled);
                const a = this.useProgram("clippingMask");
                this._tileClippingMaskIDs = {};
                for (const t2 of e1){
                    const e2 = this._tileClippingMaskIDs[t2.key] = this.nextStencilID++, r = this.style.terrain && this.style.terrain.getTerrainData(t2);
                    a.draw(i, o.TRIANGLES, wi.disabled, new Ei({
                        func: o.ALWAYS,
                        mask: 0
                    }, e2, 255, o.KEEP, o.KEEP, o.REPLACE), yi.disabled, Ii.disabled, xe(t2.posMatrix), r, "$clipping", this.tileExtentBuffer, this.quadTriangleIndexBuffer, this.tileExtentSegments);
                }
            }
            stencilModeFor3D() {
                this.currentStencilSource = void 0, this.nextStencilID + 1 > 256 && this.clearStencil();
                const t1 = this.nextStencilID++, e1 = this.context.gl;
                return new Ei({
                    func: e1.NOTEQUAL,
                    mask: 255
                }, t1, 255, e1.KEEP, e1.KEEP, e1.REPLACE);
            }
            stencilModeForClipping(t1) {
                const e1 = this.context.gl;
                return new Ei({
                    func: e1.EQUAL,
                    mask: 255
                }, this._tileClippingMaskIDs[t1.key], 0, e1.KEEP, e1.KEEP, e1.REPLACE);
            }
            stencilConfigForOverlap(t1) {
                const e1 = this.context.gl, i = t1.sort((t1, e1)=>e1.overscaledZ - t1.overscaledZ), o = i[i.length - 1].overscaledZ, a = i[0].overscaledZ - o + 1;
                if (a > 1) {
                    this.currentStencilSource = void 0, this.nextStencilID + a > 256 && this.clearStencil();
                    const t2 = {};
                    for(let i1 = 0; i1 < a; i1++)t2[i1 + o] = new Ei({
                        func: e1.GEQUAL,
                        mask: 255
                    }, i1 + this.nextStencilID, 255, e1.KEEP, e1.KEEP, e1.REPLACE);
                    return this.nextStencilID += a, [
                        t2,
                        i
                    ];
                }
                return [
                    {
                        [o]: Ei.disabled
                    },
                    i
                ];
            }
            colorModeForRenderPass() {
                const e1 = this.context.gl;
                if (this._showOverdrawInspector) {
                    const i = 1 / 8;
                    return new yi([
                        e1.CONSTANT_COLOR,
                        e1.ONE
                    ], new t1.Color(i, i, i, 0), [
                        !0,
                        !0,
                        !0,
                        !0
                    ]);
                }
                return "opaque" === this.renderPass ? yi.unblended : yi.alphaBlended;
            }
            depthModeForSublayer(t1, e1, i) {
                if (!this.opaquePassEnabledForLayer()) return wi.disabled;
                const o = 1 - ((1 + this.currentLayer) * this.numSublayers + t1) * this.depthEpsilon;
                return new wi(i || this.context.gl.LEQUAL, e1, [
                    o,
                    o
                ]);
            }
            opaquePassEnabledForLayer() {
                return this.currentLayer < this.opaquePassCutoff;
            }
            render(e1, i) {
                this.style = e1, this.options = i, this.lineAtlas = e1.lineAtlas, this.imageManager = e1.imageManager, this.glyphManager = e1.glyphManager, this.symbolFadeChange = e1.placement.symbolFadeChange(t1.exported.now()), this.imageManager.beginFrame();
                const o = this.style._order, a = this.style.sourceCaches, r = this.style.terrain && new Ki(this);
                for(const t2 in a){
                    const e2 = a[t2];
                    e2.used && e2.prepare(this.context);
                }
                const s = {}, n = {}, l = {};
                for(const t3 in a){
                    const e3 = a[t3];
                    s[t3] = e3.getVisibleCoordinates(), n[t3] = s[t3].slice().reverse(), l[t3] = e3.getVisibleCoordinates(!0).reverse();
                }
                this.opaquePassCutoff = 1 / 0;
                for(let t4 = 0; t4 < o.length; t4++)if (this.style._layers[o[t4]].is3D()) {
                    this.opaquePassCutoff = t4;
                    break;
                }
                if (r) {
                    this.opaquePassCutoff = 0;
                    const e4 = this.style.terrain.sourceCache.tilesAfterTime(this.terrainFacilitator.renderTime);
                    (this.terrainFacilitator.dirty || !t1.equals(this.terrainFacilitator.matrix, this.transform.projMatrix) || e4.length) && (t1.copy(this.terrainFacilitator.matrix, this.transform.projMatrix), this.terrainFacilitator.renderTime = Date.now(), this.terrainFacilitator.dirty = !1, function(e1, i) {
                        const o = e1.context, a = o.gl, r = yi.unblended, s = new wi(a.LEQUAL, wi.ReadWrite, [
                            0,
                            1
                        ]), n = i.getTerrainMesh(), l = i.sourceCache.getRenderableTiles(), c = e1.useProgram("terrainDepth");
                        o.bindFramebuffer.set(i.getFramebuffer("depth").framebuffer), o.viewport.set([
                            0,
                            0,
                            e1.width / devicePixelRatio,
                            e1.height / devicePixelRatio
                        ]), o.clear({
                            color: t1.Color.transparent,
                            depth: 1
                        });
                        for (const t2 of l){
                            const l1 = i.getTerrainData(t2.tileID), h = e1.transform.calculatePosMatrix(t2.tileID.toUnwrapped());
                            c.draw(o, a.TRIANGLES, s, Ei.disabled, r, Ii.backCCW, {
                                u_matrix: h
                            }, l1, "terrain", n.vertexBuffer, n.indexBuffer, n.segments);
                        }
                        o.bindFramebuffer.set(null), o.viewport.set([
                            0,
                            0,
                            e1.width,
                            e1.height
                        ]);
                    }(this, this.style.terrain), function(e1, i) {
                        const o = e1.context, a = o.gl, r = yi.unblended, s = new wi(a.LEQUAL, wi.ReadWrite, [
                            0,
                            1
                        ]), n = i.getTerrainMesh(), l = i.getCoordsTexture(), c = i.sourceCache.getRenderableTiles(), h = e1.useProgram("terrainCoords");
                        o.bindFramebuffer.set(i.getFramebuffer("coords").framebuffer), o.viewport.set([
                            0,
                            0,
                            e1.width / devicePixelRatio,
                            e1.height / devicePixelRatio
                        ]), o.clear({
                            color: t1.Color.transparent,
                            depth: 1
                        }), i.coordsIndex = [];
                        for (const t2 of c){
                            const c1 = i.getTerrainData(t2.tileID);
                            o.activeTexture.set(a.TEXTURE0), a.bindTexture(a.TEXTURE_2D, l.texture);
                            const u = e1.transform.calculatePosMatrix(t2.tileID.toUnwrapped());
                            h.draw(o, a.TRIANGLES, s, Ei.disabled, r, Ii.backCCW, {
                                u_matrix: u,
                                u_terrain_coords_id: (255 - i.coordsIndex.length) / 255,
                                u_texture: 0
                            }, c1, "terrain", n.vertexBuffer, n.indexBuffer, n.segments), i.coordsIndex.push(t2.tileID.key);
                        }
                        o.bindFramebuffer.set(null), o.viewport.set([
                            0,
                            0,
                            e1.width,
                            e1.height
                        ]);
                    }(this, this.style.terrain));
                }
                this.renderPass = "offscreen";
                for (const t5 of o){
                    const e5 = this.style._layers[t5];
                    if (!e5.hasOffscreenPass() || e5.isHidden(this.transform.zoom)) continue;
                    const i1 = n[e5.source];
                    ("custom" === e5.type || i1.length) && this.renderLayer(this, a[e5.source], e5, i1);
                }
                if (this.context.bindFramebuffer.set(null), this.context.clear({
                    color: i.showOverdrawInspector ? t1.Color.black : t1.Color.transparent,
                    depth: 1
                }), this.clearStencil(), this._showOverdrawInspector = i.showOverdrawInspector, this.depthRangeFor3D = [
                    0,
                    1 - (e1._order.length + 2) * this.numSublayers * this.depthEpsilon
                ], !r) for(this.renderPass = "opaque", this.currentLayer = o.length - 1; this.currentLayer >= 0; this.currentLayer--){
                    const t6 = this.style._layers[o[this.currentLayer]], e6 = a[t6.source], i2 = s[t6.source];
                    this._renderTileClippingMasks(t6, i2), this.renderLayer(this, e6, t6, i2);
                }
                for(this.renderPass = "translucent", this.currentLayer = 0; this.currentLayer < o.length; this.currentLayer++){
                    const t7 = this.style._layers[o[this.currentLayer]], e7 = a[t7.source];
                    if (r && r.renderLayer(t7)) continue;
                    const i3 = ("symbol" === t7.type ? l : n)[t7.source];
                    this._renderTileClippingMasks(t7, s[t7.source]), this.renderLayer(this, e7, t7, i3);
                }
                if (this.options.showTileBoundaries) {
                    let t8, e8;
                    Object.values(this.style._layers).forEach((i)=>{
                        i.source && !i.isHidden(this.transform.zoom) && (i.source !== (e8 && e8.id) && (e8 = this.style.sourceCaches[i.source]), (!t8 || t8.getSource().maxzoom < e8.getSource().maxzoom) && (t8 = e8));
                    }), t8 && Yi.debug(this, t8, t8.getVisibleCoordinates());
                }
                this.options.showPadding && function(t1) {
                    const e1 = t1.transform.padding;
                    qi(t1, t1.transform.height - (e1.top || 0), 3, Ui), qi(t1, e1.bottom || 0, 3, Ni), ji(t1, e1.left || 0, 3, Gi), ji(t1, t1.transform.width - (e1.right || 0), 3, Zi);
                    const i = t1.transform.centerPoint;
                    !function(t1, e1, i, o) {
                        $i(t1, e1 - 1, i - 10, 2, 20, o), $i(t1, e1 - 10, i - 1, 20, 2, o);
                    }(t1, i.x, t1.transform.height - i.y, Vi);
                }(this), this.context.setDefault();
            }
            renderLayer(t1, e1, i, o) {
                i.isHidden(this.transform.zoom) || ("background" === i.type || "custom" === i.type || (o || []).length) && (this.id = i.id, this.gpuTimingStart(i), Yi[i.type](t1, e1, i, o, this.style.placement.variableOffsets), this.gpuTimingEnd());
            }
            gpuTimingStart(t1) {
                if (!this.options.gpuTiming) return;
                const e1 = this.context.extTimerQuery;
                let i = this.gpuTimers[t1.id];
                i || (i = this.gpuTimers[t1.id] = {
                    calls: 0,
                    cpuTime: 0,
                    query: e1.createQueryEXT()
                }), i.calls++, e1.beginQueryEXT(e1.TIME_ELAPSED_EXT, i.query);
            }
            gpuTimingEnd() {
                if (!this.options.gpuTiming) return;
                const t1 = this.context.extTimerQuery;
                t1.endQueryEXT(t1.TIME_ELAPSED_EXT);
            }
            collectGpuTimers() {
                const t1 = this.gpuTimers;
                return this.gpuTimers = {}, t1;
            }
            queryGpuTimers(t1) {
                const e1 = {};
                for(const i in t1){
                    const o = t1[i], a = this.context.extTimerQuery, r = a.getQueryObjectEXT(o.query, a.QUERY_RESULT_EXT) / 1e6;
                    a.deleteQueryEXT(o.query), e1[i] = r;
                }
                return e1;
            }
            translatePosMatrix(e1, i, o, a, r) {
                if (!o[0] && !o[1]) return e1;
                const s = r ? "map" === a ? this.transform.angle : 0 : "viewport" === a ? -this.transform.angle : 0;
                if (s) {
                    const t2 = Math.sin(s), e2 = Math.cos(s);
                    o = [
                        o[0] * e2 - o[1] * t2,
                        o[0] * t2 + o[1] * e2
                    ];
                }
                const n = [
                    r ? o[0] : bt(i, o[0], this.transform.zoom),
                    r ? o[1] : bt(i, o[1], this.transform.zoom),
                    0
                ], l = new Float32Array(16);
                return t1.translate(l, e1, n), l;
            }
            saveTileTexture(t1) {
                const e1 = this._tileTextures[t1.size[0]];
                e1 ? e1.push(t1) : this._tileTextures[t1.size[0]] = [
                    t1
                ];
            }
            getTileTexture(t1) {
                const e1 = this._tileTextures[t1];
                return e1 && e1.length > 0 ? e1.pop() : null;
            }
            isPatternMissing(t1) {
                if (!t1) return !1;
                if (!t1.from || !t1.to) return !0;
                const e1 = this.imageManager.getPattern(t1.from.toString()), i = this.imageManager.getPattern(t1.to.toString());
                return !e1 || !i;
            }
            useProgram(t1, e1) {
                this.cache = this.cache || {};
                const i = t1 + (e1 ? e1.cacheKey : "") + (this._showOverdrawInspector ? "/overdraw" : "") + (this.style.terrain ? "/terrain" : "");
                return this.cache[i] || (this.cache[i] = new ne(this.context, t1, oe[t1], e1, Re[t1], this._showOverdrawInspector, this.style.terrain)), this.cache[i];
            }
            setCustomLayerDefaults() {
                this.context.unbindVAO(), this.context.cullFace.setDefault(), this.context.activeTexture.setDefault(), this.context.pixelStoreUnpack.setDefault(), this.context.pixelStoreUnpackPremultiplyAlpha.setDefault(), this.context.pixelStoreUnpackFlipY.setDefault();
            }
            setBaseState() {
                const t1 = this.context.gl;
                this.context.cullFace.set(!1), this.context.viewport.set([
                    0,
                    0,
                    this.width,
                    this.height
                ]), this.context.blendEquation.set(t1.FUNC_ADD);
            }
            initDebugOverlayCanvas() {
                null == this.debugOverlayCanvas && (this.debugOverlayCanvas = document.createElement("canvas"), this.debugOverlayCanvas.width = 512, this.debugOverlayCanvas.height = 512, this.debugOverlayTexture = new l(this.context, this.debugOverlayCanvas, this.context.gl.RGBA));
            }
            destroy() {
                this.emptyTexture.destroy(), this.debugOverlayTexture && this.debugOverlayTexture.destroy();
            }
        }
        class Qi {
            constructor(t1, e1){
                this.points = t1, this.planes = e1;
            }
            static fromInvProjectionMatrix(e1, i, o) {
                const a = Math.pow(2, o), r = [
                    [
                        -1,
                        1,
                        -1,
                        1
                    ],
                    [
                        1,
                        1,
                        -1,
                        1
                    ],
                    [
                        1,
                        -1,
                        -1,
                        1
                    ],
                    [
                        -1,
                        -1,
                        -1,
                        1
                    ],
                    [
                        -1,
                        1,
                        1,
                        1
                    ],
                    [
                        1,
                        1,
                        1,
                        1
                    ],
                    [
                        1,
                        -1,
                        1,
                        1
                    ],
                    [
                        -1,
                        -1,
                        1,
                        1
                    ]
                ].map((o)=>{
                    const r = 1 / (o = t1.transformMat4([], o, e1))[3] / i * a;
                    return t1.mul$1(o, o, [
                        r,
                        r,
                        1 / o[3],
                        r
                    ]);
                }), s = [
                    [
                        0,
                        1,
                        2
                    ],
                    [
                        6,
                        5,
                        4
                    ],
                    [
                        0,
                        3,
                        7
                    ],
                    [
                        2,
                        1,
                        5
                    ],
                    [
                        3,
                        2,
                        6
                    ],
                    [
                        0,
                        4,
                        5
                    ]
                ].map((e1)=>{
                    const i = t1.sub([], r[e1[0]], r[e1[1]]), o = t1.sub([], r[e1[2]], r[e1[1]]), a = t1.normalize([], t1.cross([], i, o)), s = -t1.dot(a, r[e1[1]]);
                    return a.concat(s);
                });
                return new Qi(r, s);
            }
        }
        class to {
            constructor(e1, i){
                this.min = e1, this.max = i, this.center = t1.scale$1([], t1.add([], this.min, this.max), .5);
            }
            quadrant(e1) {
                const i = [
                    e1 % 2 == 0,
                    e1 < 2
                ], o = t1.clone$2(this.min), a = t1.clone$2(this.max);
                for(let t2 = 0; t2 < i.length; t2++)o[t2] = i[t2] ? this.min[t2] : this.center[t2], a[t2] = i[t2] ? this.center[t2] : this.max[t2];
                return a[2] = this.max[2], new to(o, a);
            }
            distanceX(t1) {
                return Math.max(Math.min(this.max[0], t1[0]), this.min[0]) - t1[0];
            }
            distanceY(t1) {
                return Math.max(Math.min(this.max[1], t1[1]), this.min[1]) - t1[1];
            }
            intersects(e1) {
                const i = [
                    [
                        this.min[0],
                        this.min[1],
                        this.min[2],
                        1
                    ],
                    [
                        this.max[0],
                        this.min[1],
                        this.min[2],
                        1
                    ],
                    [
                        this.max[0],
                        this.max[1],
                        this.min[2],
                        1
                    ],
                    [
                        this.min[0],
                        this.max[1],
                        this.min[2],
                        1
                    ],
                    [
                        this.min[0],
                        this.min[1],
                        this.max[2],
                        1
                    ],
                    [
                        this.max[0],
                        this.min[1],
                        this.max[2],
                        1
                    ],
                    [
                        this.max[0],
                        this.max[1],
                        this.max[2],
                        1
                    ],
                    [
                        this.min[0],
                        this.max[1],
                        this.max[2],
                        1
                    ]
                ];
                let o = !0;
                for(let a = 0; a < e1.planes.length; a++){
                    const r = e1.planes[a];
                    let s = 0;
                    for(let e2 = 0; e2 < i.length; e2++)t1.dot$1(r, i[e2]) >= 0 && s++;
                    if (0 === s) return 0;
                    s !== i.length && (o = !1);
                }
                if (o) return 2;
                for(let t2 = 0; t2 < 3; t2++){
                    let i1 = Number.MAX_VALUE, o1 = -Number.MAX_VALUE;
                    for(let a1 = 0; a1 < e1.points.length; a1++){
                        const r1 = e1.points[a1][t2] - this.min[t2];
                        i1 = Math.min(i1, r1), o1 = Math.max(o1, r1);
                    }
                    if (o1 < 0 || i1 > this.max[t2] - this.min[t2]) return 0;
                }
                return 1;
            }
        }
        class eo {
            constructor(t1 = 0, e1 = 0, i = 0, o = 0){
                if (isNaN(t1) || t1 < 0 || isNaN(e1) || e1 < 0 || isNaN(i) || i < 0 || isNaN(o) || o < 0) throw new Error("Invalid value for edge-insets, top, bottom, left and right must all be numbers");
                this.top = t1, this.bottom = e1, this.left = i, this.right = o;
            }
            interpolate(e1, i, o) {
                return null != i.top && null != e1.top && (this.top = t1.number(e1.top, i.top, o)), null != i.bottom && null != e1.bottom && (this.bottom = t1.number(e1.bottom, i.bottom, o)), null != i.left && null != e1.left && (this.left = t1.number(e1.left, i.left, o)), null != i.right && null != e1.right && (this.right = t1.number(e1.right, i.right, o)), this;
            }
            getCenter(e1, i) {
                const o = t1.clamp((this.left + e1 - this.right) / 2, 0, e1), a = t1.clamp((this.top + i - this.bottom) / 2, 0, i);
                return new t1.pointGeometry(o, a);
            }
            equals(t1) {
                return this.top === t1.top && this.bottom === t1.bottom && this.left === t1.left && this.right === t1.right;
            }
            clone() {
                return new eo(this.top, this.bottom, this.left, this.right);
            }
            toJSON() {
                return {
                    top: this.top,
                    bottom: this.bottom,
                    left: this.left,
                    right: this.right
                };
            }
        }
        class io {
            constructor(e1, i, o, a, r){
                this.tileSize = 512, this.maxValidLatitude = 85.051129, this.freezeElevation = !1, this._renderWorldCopies = void 0 === r || !!r, this._minZoom = e1 || 0, this._maxZoom = i || 22, this._minPitch = null == o ? 0 : o, this._maxPitch = null == a ? 60 : a, this.setMaxBounds(), this.width = 0, this.height = 0, this._center = new t1.LngLat(0, 0), this._elevation = 0, this.zoom = 0, this.angle = 0, this._fov = .6435011087932844, this._pitch = 0, this._unmodified = !0, this._edgeInsets = new eo, this._posMatrixCache = {}, this._alignedPosMatrixCache = {};
            }
            clone() {
                const t1 = new io(this._minZoom, this._maxZoom, this._minPitch, this.maxPitch, this._renderWorldCopies);
                return t1.tileSize = this.tileSize, t1.latRange = this.latRange, t1.width = this.width, t1.height = this.height, t1._center = this._center, t1._elevation = this._elevation, t1.zoom = this.zoom, t1.angle = this.angle, t1._fov = this._fov, t1._pitch = this._pitch, t1._unmodified = this._unmodified, t1._edgeInsets = this._edgeInsets.clone(), t1._calcMatrices(), t1;
            }
            get minZoom() {
                return this._minZoom;
            }
            set minZoom(t1) {
                this._minZoom !== t1 && (this._minZoom = t1, this.zoom = Math.max(this.zoom, t1));
            }
            get maxZoom() {
                return this._maxZoom;
            }
            set maxZoom(t1) {
                this._maxZoom !== t1 && (this._maxZoom = t1, this.zoom = Math.min(this.zoom, t1));
            }
            get minPitch() {
                return this._minPitch;
            }
            set minPitch(t1) {
                this._minPitch !== t1 && (this._minPitch = t1, this.pitch = Math.max(this.pitch, t1));
            }
            get maxPitch() {
                return this._maxPitch;
            }
            set maxPitch(t1) {
                this._maxPitch !== t1 && (this._maxPitch = t1, this.pitch = Math.min(this.pitch, t1));
            }
            get renderWorldCopies() {
                return this._renderWorldCopies;
            }
            set renderWorldCopies(t1) {
                void 0 === t1 ? t1 = !0 : null === t1 && (t1 = !1), this._renderWorldCopies = t1;
            }
            get worldSize() {
                return this.tileSize * this.scale;
            }
            get centerOffset() {
                return this.centerPoint._sub(this.size._div(2));
            }
            get size() {
                return new t1.pointGeometry(this.width, this.height);
            }
            get bearing() {
                return -this.angle / Math.PI * 180;
            }
            set bearing(e1) {
                const i = -t1.wrap(e1, -180, 180) * Math.PI / 180;
                var o;
                this.angle !== i && (this._unmodified = !1, this.angle = i, this._calcMatrices(), this.rotationMatrix = (o = new t1.ARRAY_TYPE(4), t1.ARRAY_TYPE != Float32Array && (o[1] = 0, o[2] = 0), o[0] = 1, o[3] = 1, o), function(t1, e1, i) {
                    var o = e1[0], a = e1[1], r = e1[2], s = e1[3], n = Math.sin(i), l = Math.cos(i);
                    t1[0] = o * l + r * n, t1[1] = a * l + s * n, t1[2] = o * -n + r * l, t1[3] = a * -n + s * l;
                }(this.rotationMatrix, this.rotationMatrix, this.angle));
            }
            get pitch() {
                return this._pitch / Math.PI * 180;
            }
            set pitch(e1) {
                const i = t1.clamp(e1, this.minPitch, this.maxPitch) / 180 * Math.PI;
                this._pitch !== i && (this._unmodified = !1, this._pitch = i, this._calcMatrices());
            }
            get fov() {
                return this._fov / Math.PI * 180;
            }
            set fov(t1) {
                t1 = Math.max(.01, Math.min(60, t1)), this._fov !== t1 && (this._unmodified = !1, this._fov = t1 / 180 * Math.PI, this._calcMatrices());
            }
            get zoom() {
                return this._zoom;
            }
            set zoom(t1) {
                const e1 = Math.min(Math.max(t1, this.minZoom), this.maxZoom);
                this._zoom !== e1 && (this._unmodified = !1, this._zoom = e1, this.scale = this.zoomScale(e1), this.tileZoom = Math.floor(e1), this.zoomFraction = e1 - this.tileZoom, this._constrain(), this._calcMatrices());
            }
            get center() {
                return this._center;
            }
            set center(t1) {
                t1.lat === this._center.lat && t1.lng === this._center.lng || (this._unmodified = !1, this._center = t1, this._constrain(), this._calcMatrices());
            }
            get elevation() {
                return this._elevation;
            }
            set elevation(t1) {
                t1 !== this._elevation && (this._elevation = t1, this._constrain(), this._calcMatrices());
            }
            get padding() {
                return this._edgeInsets.toJSON();
            }
            set padding(t1) {
                this._edgeInsets.equals(t1) || (this._unmodified = !1, this._edgeInsets.interpolate(this._edgeInsets, t1, 1), this._calcMatrices());
            }
            get centerPoint() {
                return this._edgeInsets.getCenter(this.width, this.height);
            }
            isPaddingEqual(t1) {
                return this._edgeInsets.equals(t1);
            }
            interpolatePadding(t1, e1, i) {
                this._unmodified = !1, this._edgeInsets.interpolate(t1, e1, i), this._constrain(), this._calcMatrices();
            }
            coveringZoomLevel(t1) {
                const e1 = (t1.roundZoom ? Math.round : Math.floor)(this.zoom + this.scaleZoom(this.tileSize / t1.tileSize));
                return Math.max(0, e1);
            }
            getVisibleUnwrappedCoordinates(e1) {
                const i = [
                    new t1.UnwrappedTileID(0, e1)
                ];
                if (this._renderWorldCopies) {
                    const o = this.pointCoordinate(new t1.pointGeometry(0, 0)), a = this.pointCoordinate(new t1.pointGeometry(this.width, 0)), r = this.pointCoordinate(new t1.pointGeometry(this.width, this.height)), s = this.pointCoordinate(new t1.pointGeometry(0, this.height)), n = Math.floor(Math.min(o.x, a.x, r.x, s.x)), l = Math.floor(Math.max(o.x, a.x, r.x, s.x)), c = 1;
                    for(let o1 = n - c; o1 <= l + c; o1++)0 !== o1 && i.push(new t1.UnwrappedTileID(o1, e1));
                }
                return i;
            }
            coveringTiles(e1) {
                var i, o;
                let a = this.coveringZoomLevel(e1);
                const r = a;
                if (void 0 !== e1.minzoom && a < e1.minzoom) return [];
                void 0 !== e1.maxzoom && a > e1.maxzoom && (a = e1.maxzoom);
                const s = this.pointCoordinate(this.getCameraPoint()), n = t1.MercatorCoordinate.fromLngLat(this.center), l = Math.pow(2, a), c = [
                    l * s.x,
                    l * s.y,
                    0
                ], h = [
                    l * n.x,
                    l * n.y,
                    0
                ], u = Qi.fromInvProjectionMatrix(this.invProjMatrix, this.worldSize, a);
                let d = e1.minzoom || 0;
                !e1.terrain && this.pitch <= 60 && this._edgeInsets.top < .1 && (d = a);
                const m = e1.terrain ? 2 / Math.min(this.tileSize, e1.tileSize) * this.tileSize : 3, _ = (t1)=>({
                        aabb: new to([
                            t1 * l,
                            0,
                            0
                        ], [
                            (t1 + 1) * l,
                            l,
                            0
                        ]),
                        zoom: 0,
                        x: 0,
                        y: 0,
                        wrap: t1,
                        fullyVisible: !1
                    }), p = [], f = [], g = a, x = e1.reparseOverscaled ? r : a;
                if (this._renderWorldCopies) for(let t2 = 1; t2 <= 3; t2++)p.push(_(-t2)), p.push(_(t2));
                for(p.push(_(0)); p.length > 0;){
                    const a1 = p.pop(), r1 = a1.x, s1 = a1.y;
                    let n1 = a1.fullyVisible;
                    if (!n1) {
                        const t3 = a1.aabb.intersects(u);
                        if (0 === t3) continue;
                        n1 = 2 === t3;
                    }
                    const l1 = e1.terrain ? c : h, _1 = a1.aabb.distanceX(l1), v = a1.aabb.distanceY(l1), y = Math.max(Math.abs(_1), Math.abs(v)), b = m + (1 << g - a1.zoom) - 2;
                    if (a1.zoom === g || y > b && a1.zoom >= d) {
                        const e2 = g - a1.zoom, i1 = c[0] - .5 - (r1 << e2), o1 = c[1] - .5 - (s1 << e2);
                        f.push({
                            tileID: new t1.OverscaledTileID(a1.zoom === g ? x : a1.zoom, a1.wrap, a1.zoom, r1, s1),
                            distanceSq: t1.sqrLen([
                                h[0] - .5 - r1,
                                h[1] - .5 - s1
                            ]),
                            tileDistanceToCamera: Math.sqrt(i1 * i1 + o1 * o1)
                        });
                    } else for(let l2 = 0; l2 < 4; l2++){
                        const c1 = (r1 << 1) + l2 % 2, h1 = (s1 << 1) + (l2 >> 1), u1 = a1.zoom + 1;
                        let d1 = a1.aabb.quadrant(l2);
                        if (e1.terrain) {
                            const r2 = new t1.OverscaledTileID(u1, a1.wrap, u1, c1, h1), s2 = e1.terrain.getMinMaxElevation(r2), n2 = null !== (i = s2.minElevation) && void 0 !== i ? i : this.elevation, l3 = null !== (o = s2.maxElevation) && void 0 !== o ? o : this.elevation;
                            d1 = new to([
                                d1.min[0],
                                d1.min[1],
                                n2
                            ], [
                                d1.max[0],
                                d1.max[1],
                                l3
                            ]);
                        }
                        p.push({
                            aabb: d1,
                            zoom: u1,
                            x: c1,
                            y: h1,
                            wrap: a1.wrap,
                            fullyVisible: n1
                        });
                    }
                }
                return f.sort((t1, e1)=>t1.distanceSq - e1.distanceSq).map((t1)=>t1.tileID);
            }
            resize(t1, e1) {
                this.width = t1, this.height = e1, this.pixelsToGLUnits = [
                    2 / t1,
                    -2 / e1
                ], this._constrain(), this._calcMatrices();
            }
            get unmodified() {
                return this._unmodified;
            }
            zoomScale(t1) {
                return Math.pow(2, t1);
            }
            scaleZoom(t1) {
                return Math.log(t1) / Math.LN2;
            }
            project(e1) {
                const i = t1.clamp(e1.lat, -this.maxValidLatitude, this.maxValidLatitude);
                return new t1.pointGeometry(t1.mercatorXfromLng(e1.lng) * this.worldSize, t1.mercatorYfromLat(i) * this.worldSize);
            }
            unproject(e1) {
                return new t1.MercatorCoordinate(e1.x / this.worldSize, e1.y / this.worldSize).toLngLat();
            }
            get point() {
                return this.project(this.center);
            }
            updateElevation(t1) {
                this.freezeElevation || (this.elevation = t1 ? this.getElevation(this._center, t1) : 0);
            }
            getElevation(e1, i) {
                const o = t1.MercatorCoordinate.fromLngLat(e1), a = (1 << this.tileZoom) * t1.EXTENT, r = o.x * a, s = o.y * a, n = Math.floor(r / t1.EXTENT), l = Math.floor(s / t1.EXTENT), c = new t1.OverscaledTileID(this.tileZoom, 0, this.tileZoom, n, l);
                return i.getElevation(c, r % t1.EXTENT, s % t1.EXTENT, t1.EXTENT);
            }
            getCameraPosition() {
                return {
                    lngLat: this.pointLocation(this.getCameraPoint()),
                    altitude: Math.cos(this._pitch) * this.cameraToCenterDistance / this._pixelPerMeter + this.elevation
                };
            }
            recalculateZoom(e1) {
                const i = this.pointLocation(this.centerPoint, e1), o = this.getElevation(i, e1);
                if (!(this.elevation - o)) return;
                const a = this.getCameraPosition(), r = t1.MercatorCoordinate.fromLngLat(a.lngLat, a.altitude), s = t1.MercatorCoordinate.fromLngLat(i, o), n = r.x - s.x, l = r.y - s.y, c = r.z - s.z, h = Math.sqrt(n * n + l * l + c * c), u = this.scaleZoom(this.cameraToCenterDistance / h / this.tileSize);
                this._elevation = o, this._center = i, this.zoom = u;
            }
            setLocationAtPoint(e1, i) {
                const o = this.pointCoordinate(i), a = this.pointCoordinate(this.centerPoint), r = this.locationCoordinate(e1), s = new t1.MercatorCoordinate(r.x - (o.x - a.x), r.y - (o.y - a.y));
                this.center = this.coordinateLocation(s), this._renderWorldCopies && (this.center = this.center.wrap());
            }
            locationPoint(t1, e1) {
                return e1 ? this.coordinatePoint(this.locationCoordinate(t1), this.getElevation(t1, e1), this.pixelMatrix3D) : this.coordinatePoint(this.locationCoordinate(t1));
            }
            pointLocation(t1, e1) {
                return this.coordinateLocation(this.pointCoordinate(t1, e1));
            }
            locationCoordinate(e1) {
                return t1.MercatorCoordinate.fromLngLat(e1);
            }
            coordinateLocation(t1) {
                return t1 && t1.toLngLat();
            }
            pointCoordinate(e1, i) {
                if (i) {
                    const t2 = i.pointCoordinate(e1);
                    if (null != t2) return t2;
                }
                const o = [
                    e1.x,
                    e1.y,
                    0,
                    1
                ], a = [
                    e1.x,
                    e1.y,
                    1,
                    1
                ];
                t1.transformMat4(o, o, this.pixelMatrixInverse), t1.transformMat4(a, a, this.pixelMatrixInverse);
                const r = o[3], s = a[3], n = o[1] / r, l = a[1] / s, c = o[2] / r, h = a[2] / s, u = c === h ? 0 : (0 - c) / (h - c);
                return new t1.MercatorCoordinate(t1.number(o[0] / r, a[0] / s, u) / this.worldSize, t1.number(n, l, u) / this.worldSize);
            }
            coordinatePoint(e1, i = 0, o = this.pixelMatrix) {
                const a = [
                    e1.x * this.worldSize,
                    e1.y * this.worldSize,
                    i,
                    1
                ];
                return t1.transformMat4(a, a, o), new t1.pointGeometry(a[0] / a[3], a[1] / a[3]);
            }
            getBounds() {
                const e1 = Math.max(0, this.height / 2 - this.getHorizon());
                return (new t1.LngLatBounds).extend(this.pointLocation(new t1.pointGeometry(0, e1))).extend(this.pointLocation(new t1.pointGeometry(this.width, e1))).extend(this.pointLocation(new t1.pointGeometry(this.width, this.height))).extend(this.pointLocation(new t1.pointGeometry(0, this.height)));
            }
            getMaxBounds() {
                return this.latRange && 2 === this.latRange.length && this.lngRange && 2 === this.lngRange.length ? new t1.LngLatBounds([
                    this.lngRange[0],
                    this.latRange[0]
                ], [
                    this.lngRange[1],
                    this.latRange[1]
                ]) : null;
            }
            getHorizon() {
                return Math.tan(Math.PI / 2 - this._pitch) * this.cameraToCenterDistance * .85;
            }
            setMaxBounds(t1) {
                t1 ? (this.lngRange = [
                    t1.getWest(),
                    t1.getEast()
                ], this.latRange = [
                    t1.getSouth(),
                    t1.getNorth()
                ], this._constrain()) : (this.lngRange = null, this.latRange = [
                    -this.maxValidLatitude,
                    this.maxValidLatitude
                ]);
            }
            calculatePosMatrix(e1, i = !1) {
                const o = e1.key, a = i ? this._alignedPosMatrixCache : this._posMatrixCache;
                if (a[o]) return a[o];
                const r = e1.canonical, s = this.worldSize / this.zoomScale(r.z), n = r.x + Math.pow(2, r.z) * e1.wrap, l = t1.identity(new Float64Array(16));
                return t1.translate(l, l, [
                    n * s,
                    r.y * s,
                    0
                ]), t1.scale(l, l, [
                    s / t1.EXTENT,
                    s / t1.EXTENT,
                    1
                ]), t1.multiply(l, i ? this.alignedProjMatrix : this.projMatrix, l), a[o] = new Float32Array(l), a[o];
            }
            customLayerMatrix() {
                return this.mercatorMatrix.slice();
            }
            _constrain() {
                if (!this.center || !this.width || !this.height || this._constraining) return;
                this._constraining = !0;
                let e1, i, o, a, r = -90, s = 90, n = -180, l = 180;
                const c = this.size, h = this._unmodified;
                if (this.latRange) {
                    const i1 = this.latRange;
                    r = t1.mercatorYfromLat(i1[1]) * this.worldSize, s = t1.mercatorYfromLat(i1[0]) * this.worldSize, e1 = s - r < c.y ? c.y / (s - r) : 0;
                }
                if (this.lngRange) {
                    const e2 = this.lngRange;
                    n = t1.wrap(t1.mercatorXfromLng(e2[0]) * this.worldSize, 0, this.worldSize), l = t1.wrap(t1.mercatorXfromLng(e2[1]) * this.worldSize, 0, this.worldSize), l < n && (l += this.worldSize), i = l - n < c.x ? c.x / (l - n) : 0;
                }
                const u = this.point, d = Math.max(i || 0, e1 || 0);
                if (d) return this.center = this.unproject(new t1.pointGeometry(i ? (l + n) / 2 : u.x, e1 ? (s + r) / 2 : u.y)), this.zoom += this.scaleZoom(d), this._unmodified = h, void (this._constraining = !1);
                if (this.latRange) {
                    const t2 = u.y, e3 = c.y / 2;
                    t2 - e3 < r && (a = r + e3), t2 + e3 > s && (a = s - e3);
                }
                if (this.lngRange) {
                    const e4 = (n + l) / 2, i2 = t1.wrap(u.x, e4 - this.worldSize / 2, e4 + this.worldSize / 2), a1 = c.x / 2;
                    i2 - a1 < n && (o = n + a1), i2 + a1 > l && (o = l - a1);
                }
                void 0 === o && void 0 === a || (this.center = this.unproject(new t1.pointGeometry(void 0 !== o ? o : u.x, void 0 !== a ? a : u.y)).wrap()), this._unmodified = h, this._constraining = !1;
            }
            _calcMatrices() {
                if (!this.height) return;
                const e1 = this.centerOffset, i = this.point.x, o = this.point.y;
                this.cameraToCenterDistance = .5 / Math.tan(this._fov / 2) * this.height, this._pixelPerMeter = t1.mercatorZfromAltitude(1, this.center.lat) * this.worldSize;
                let a = t1.identity(new Float64Array(16));
                t1.scale(a, a, [
                    this.width / 2,
                    -this.height / 2,
                    1
                ]), t1.translate(a, a, [
                    1,
                    -1,
                    0
                ]), this.labelPlaneMatrix = a, a = t1.identity(new Float64Array(16)), t1.scale(a, a, [
                    1,
                    -1,
                    1
                ]), t1.translate(a, a, [
                    -1,
                    -1,
                    0
                ]), t1.scale(a, a, [
                    2 / this.width,
                    2 / this.height,
                    1
                ]), this.glCoordMatrix = a, this.cameraToSeaLevelDistance = this.cameraToCenterDistance + this._elevation * this._pixelPerMeter / Math.cos(this._pitch);
                const r = Math.PI / 2 + this._pitch, s = this._fov * (.5 + e1.y / this.height), n = Math.sin(s) * this.cameraToSeaLevelDistance / Math.sin(t1.clamp(Math.PI - r - s, .01, Math.PI - .01)), l = this.getHorizon(), c = 2 * Math.atan(l / this.cameraToCenterDistance) * (.5 + e1.y / (2 * l)), h = Math.sin(c) * this.cameraToSeaLevelDistance / Math.sin(t1.clamp(Math.PI - r - c, .01, Math.PI - .01)), u = Math.cos(Math.PI / 2 - this._pitch) * n + this.cameraToSeaLevelDistance, d = Math.cos(Math.PI / 2 - this._pitch) * h + this.cameraToSeaLevelDistance, m = 1.01 * Math.min(u, d), _ = this.height / 50;
                a = new Float64Array(16), t1.perspective(a, this._fov, this.width / this.height, _, m), a[8] = 2 * -e1.x / this.width, a[9] = 2 * e1.y / this.height, t1.scale(a, a, [
                    1,
                    -1,
                    1
                ]), t1.translate(a, a, [
                    0,
                    0,
                    -this.cameraToCenterDistance
                ]), t1.rotateX(a, a, this._pitch), t1.rotateZ(a, a, this.angle), t1.translate(a, a, [
                    -i,
                    -o,
                    0
                ]), this.mercatorMatrix = t1.scale([], a, [
                    this.worldSize,
                    this.worldSize,
                    this.worldSize
                ]), t1.scale(a, a, [
                    1,
                    1,
                    this._pixelPerMeter
                ]), this.pixelMatrix = t1.multiply(new Float64Array(16), this.labelPlaneMatrix, a), t1.translate(a, a, [
                    0,
                    0,
                    -this.elevation
                ]), this.projMatrix = a, this.invProjMatrix = t1.invert([], a), this.pixelMatrix3D = t1.multiply(new Float64Array(16), this.labelPlaneMatrix, a);
                const p = this.width % 2 / 2, f = this.height % 2 / 2, g = Math.cos(this.angle), x = Math.sin(this.angle), v = i - Math.round(i) + g * p + x * f, y = o - Math.round(o) + g * f + x * p, b = new Float64Array(a);
                if (t1.translate(b, b, [
                    v > .5 ? v - 1 : v,
                    y > .5 ? y - 1 : y,
                    0
                ]), this.alignedProjMatrix = b, a = t1.invert(new Float64Array(16), this.pixelMatrix), !a) throw new Error("failed to invert matrix");
                this.pixelMatrixInverse = a, this._posMatrixCache = {}, this._alignedPosMatrixCache = {};
            }
            maxPitchScaleFactor() {
                if (!this.pixelMatrixInverse) return 1;
                const e1 = this.pointCoordinate(new t1.pointGeometry(0, 0)), i = [
                    e1.x * this.worldSize,
                    e1.y * this.worldSize,
                    0,
                    1
                ];
                return t1.transformMat4(i, i, this.pixelMatrix)[3] / this.cameraToCenterDistance;
            }
            getCameraPoint() {
                const e1 = Math.tan(this._pitch) * (this.cameraToCenterDistance || 1);
                return this.centerPoint.add(new t1.pointGeometry(0, e1));
            }
            getCameraQueryGeometry(e1) {
                const i = this.getCameraPoint();
                if (1 === e1.length) return [
                    e1[0],
                    i
                ];
                {
                    let o = i.x, a = i.y, r = i.x, s = i.y;
                    for (const t2 of e1)o = Math.min(o, t2.x), a = Math.min(a, t2.y), r = Math.max(r, t2.x), s = Math.max(s, t2.y);
                    return [
                        new t1.pointGeometry(o, a),
                        new t1.pointGeometry(r, a),
                        new t1.pointGeometry(r, s),
                        new t1.pointGeometry(o, s),
                        new t1.pointGeometry(o, a)
                    ];
                }
            }
        }
        class oo {
            constructor(e1){
                this._hashName = e1 && encodeURIComponent(e1), t1.bindAll([
                    "_getCurrentHash",
                    "_onHashChange",
                    "_updateHash"
                ], this), this._updateHash = function(t1, e1) {
                    let i = !1, o = null;
                    const a = ()=>{
                        o = null, i && (t1(), o = setTimeout(a, 300), i = !1);
                    };
                    return ()=>(i = !0, o || a(), o);
                }(this._updateHashUnthrottled.bind(this));
            }
            addTo(t1) {
                return this._map = t1, addEventListener("hashchange", this._onHashChange, !1), this._map.on("moveend", this._updateHash), this;
            }
            remove() {
                return removeEventListener("hashchange", this._onHashChange, !1), this._map.off("moveend", this._updateHash), clearTimeout(this._updateHash()), delete this._map, this;
            }
            getHashString(t1) {
                const e1 = this._map.getCenter(), i = Math.round(100 * this._map.getZoom()) / 100, o = Math.ceil((i * Math.LN2 + Math.log(512 / 360 / .5)) / Math.LN10), a = Math.pow(10, o), r = Math.round(e1.lng * a) / a, s = Math.round(e1.lat * a) / a, n = this._map.getBearing(), l = this._map.getPitch();
                let c = "";
                if (c += t1 ? `/${r}/${s}/${i}` : `${i}/${s}/${r}`, (n || l) && (c += "/" + Math.round(10 * n) / 10), l && (c += `/${Math.round(l)}`), this._hashName) {
                    const t2 = this._hashName;
                    let e2 = !1;
                    const i1 = window.location.hash.slice(1).split("&").map((i)=>{
                        const o = i.split("=")[0];
                        return o === t2 ? (e2 = !0, `${o}=${c}`) : i;
                    }).filter((t1)=>t1);
                    return e2 || i1.push(`${t2}=${c}`), `#${i1.join("&")}`;
                }
                return `#${c}`;
            }
            _getCurrentHash() {
                const t1 = window.location.hash.replace("#", "");
                if (this._hashName) {
                    let e1;
                    return t1.split("&").map((t1)=>t1.split("=")).forEach((t1)=>{
                        t1[0] === this._hashName && (e1 = t1);
                    }), (e1 && e1[1] || "").split("/");
                }
                return t1.split("/");
            }
            _onHashChange() {
                const t1 = this._getCurrentHash();
                if (t1.length >= 3 && !t1.some((t1)=>isNaN(t1))) {
                    const e1 = this._map.dragRotate.isEnabled() && this._map.touchZoomRotate.isEnabled() ? +(t1[3] || 0) : this._map.getBearing();
                    return this._map.jumpTo({
                        center: [
                            +t1[2],
                            +t1[1]
                        ],
                        zoom: +t1[0],
                        bearing: e1,
                        pitch: +(t1[4] || 0)
                    }), !0;
                }
                return !1;
            }
            _updateHashUnthrottled() {
                const t1 = window.location.href.replace(/(#.+)?$/, this.getHashString());
                try {
                    window.history.replaceState(window.history.state, null, t1);
                } catch (t2) {}
            }
        }
        const ao = {
            linearity: .3,
            easing: t1.bezier(0, 0, .3, 1)
        }, ro = t1.extend({
            deceleration: 2500,
            maxSpeed: 1400
        }, ao), so = t1.extend({
            deceleration: 20,
            maxSpeed: 1400
        }, ao), no = t1.extend({
            deceleration: 1e3,
            maxSpeed: 360
        }, ao), lo = t1.extend({
            deceleration: 1e3,
            maxSpeed: 90
        }, ao);
        class co {
            constructor(t1){
                this._map = t1, this.clear();
            }
            clear() {
                this._inertiaBuffer = [];
            }
            record(e1) {
                this._drainInertiaBuffer(), this._inertiaBuffer.push({
                    time: t1.exported.now(),
                    settings: e1
                });
            }
            _drainInertiaBuffer() {
                const e1 = this._inertiaBuffer, i = t1.exported.now();
                for(; e1.length > 0 && i - e1[0].time > 160;)e1.shift();
            }
            _onMoveEnd(e1) {
                if (this._drainInertiaBuffer(), this._inertiaBuffer.length < 2) return;
                const i = {
                    zoom: 0,
                    bearing: 0,
                    pitch: 0,
                    pan: new t1.pointGeometry(0, 0),
                    pinchAround: void 0,
                    around: void 0
                };
                for (const { settings: t2  } of this._inertiaBuffer)i.zoom += t2.zoomDelta || 0, i.bearing += t2.bearingDelta || 0, i.pitch += t2.pitchDelta || 0, t2.panDelta && i.pan._add(t2.panDelta), t2.around && (i.around = t2.around), t2.pinchAround && (i.pinchAround = t2.pinchAround);
                const o = this._inertiaBuffer[this._inertiaBuffer.length - 1].time - this._inertiaBuffer[0].time, a = {};
                if (i.pan.mag()) {
                    const r = uo(i.pan.mag(), o, t1.extend({}, ro, e1 || {}));
                    a.offset = i.pan.mult(r.amount / i.pan.mag()), a.center = this._map.transform.center, ho(a, r);
                }
                if (i.zoom) {
                    const t3 = uo(i.zoom, o, so);
                    a.zoom = this._map.transform.zoom + t3.amount, ho(a, t3);
                }
                if (i.bearing) {
                    const e2 = uo(i.bearing, o, no);
                    a.bearing = this._map.transform.bearing + t1.clamp(e2.amount, -179, 179), ho(a, e2);
                }
                if (i.pitch) {
                    const t4 = uo(i.pitch, o, lo);
                    a.pitch = this._map.transform.pitch + t4.amount, ho(a, t4);
                }
                if (a.zoom || a.bearing) {
                    const t5 = void 0 === i.pinchAround ? i.around : i.pinchAround;
                    a.around = t5 ? this._map.unproject(t5) : this._map.getCenter();
                }
                return this.clear(), t1.extend(a, {
                    noMoveStart: !0
                });
            }
        }
        function ho(t1, e1) {
            (!t1.duration || t1.duration < e1.duration) && (t1.duration = e1.duration, t1.easing = e1.easing);
        }
        function uo(e1, i, o) {
            const { maxSpeed: a , linearity: r , deceleration: s  } = o, n = t1.clamp(e1 * r / (i / 1e3), -a, a), l = Math.abs(n) / (s * r);
            return {
                easing: o.easing,
                duration: 1e3 * l,
                amount: n * (l / 2)
            };
        }
        class mo extends t1.Event {
            constructor(e1, i, o, a = {}){
                const s = r.mousePos(i.getCanvasContainer(), o), n = i.unproject(s);
                super(e1, t1.extend({
                    point: s,
                    lngLat: n,
                    originalEvent: o
                }, a)), this._defaultPrevented = !1, this.target = i;
            }
            preventDefault() {
                this._defaultPrevented = !0;
            }
            get defaultPrevented() {
                return this._defaultPrevented;
            }
        }
        class _o extends t1.Event {
            constructor(e1, i, o){
                const a = "touchend" === e1 ? o.changedTouches : o.touches, s = r.touchPos(i.getCanvasContainer(), a), n = s.map((t1)=>i.unproject(t1)), l = s.reduce((t1, e1, i, o)=>t1.add(e1.div(o.length)), new t1.pointGeometry(0, 0));
                super(e1, {
                    points: s,
                    point: l,
                    lngLats: n,
                    lngLat: i.unproject(l),
                    originalEvent: o
                }), this._defaultPrevented = !1;
            }
            preventDefault() {
                this._defaultPrevented = !0;
            }
            get defaultPrevented() {
                return this._defaultPrevented;
            }
        }
        class po extends t1.Event {
            constructor(t1, e1, i){
                super(t1, {
                    originalEvent: i
                }), this._defaultPrevented = !1;
            }
            preventDefault() {
                this._defaultPrevented = !0;
            }
            get defaultPrevented() {
                return this._defaultPrevented;
            }
        }
        class fo {
            constructor(t1, e1){
                this._map = t1, this._clickTolerance = e1.clickTolerance;
            }
            reset() {
                delete this._mousedownPos;
            }
            wheel(t1) {
                return this._firePreventable(new po(t1.type, this._map, t1));
            }
            mousedown(t1, e1) {
                return this._mousedownPos = e1, this._firePreventable(new mo(t1.type, this._map, t1));
            }
            mouseup(t1) {
                this._map.fire(new mo(t1.type, this._map, t1));
            }
            click(t1, e1) {
                this._mousedownPos && this._mousedownPos.dist(e1) >= this._clickTolerance || this._map.fire(new mo(t1.type, this._map, t1));
            }
            dblclick(t1) {
                return this._firePreventable(new mo(t1.type, this._map, t1));
            }
            mouseover(t1) {
                this._map.fire(new mo(t1.type, this._map, t1));
            }
            mouseout(t1) {
                this._map.fire(new mo(t1.type, this._map, t1));
            }
            touchstart(t1) {
                return this._firePreventable(new _o(t1.type, this._map, t1));
            }
            touchmove(t1) {
                this._map.fire(new _o(t1.type, this._map, t1));
            }
            touchend(t1) {
                this._map.fire(new _o(t1.type, this._map, t1));
            }
            touchcancel(t1) {
                this._map.fire(new _o(t1.type, this._map, t1));
            }
            _firePreventable(t1) {
                if (this._map.fire(t1), t1.defaultPrevented) return {};
            }
            isEnabled() {
                return !0;
            }
            isActive() {
                return !1;
            }
            enable() {}
            disable() {}
        }
        class go {
            constructor(t1){
                this._map = t1;
            }
            reset() {
                this._delayContextMenu = !1, this._ignoreContextMenu = !0, delete this._contextMenuEvent;
            }
            mousemove(t1) {
                this._map.fire(new mo(t1.type, this._map, t1));
            }
            mousedown() {
                this._delayContextMenu = !0, this._ignoreContextMenu = !1;
            }
            mouseup() {
                this._delayContextMenu = !1, this._contextMenuEvent && (this._map.fire(new mo("contextmenu", this._map, this._contextMenuEvent)), delete this._contextMenuEvent);
            }
            contextmenu(t1) {
                this._delayContextMenu ? this._contextMenuEvent = t1 : this._ignoreContextMenu || this._map.fire(new mo(t1.type, this._map, t1)), this._map.listens("contextmenu") && t1.preventDefault();
            }
            isEnabled() {
                return !0;
            }
            isActive() {
                return !1;
            }
            enable() {}
            disable() {}
        }
        class xo {
            constructor(t1, e1){
                this._map = t1, this._el = t1.getCanvasContainer(), this._container = t1.getContainer(), this._clickTolerance = e1.clickTolerance || 1;
            }
            isEnabled() {
                return !!this._enabled;
            }
            isActive() {
                return !!this._active;
            }
            enable() {
                this.isEnabled() || (this._enabled = !0);
            }
            disable() {
                this.isEnabled() && (this._enabled = !1);
            }
            mousedown(t1, e1) {
                this.isEnabled() && t1.shiftKey && 0 === t1.button && (r.disableDrag(), this._startPos = this._lastPos = e1, this._active = !0);
            }
            mousemoveWindow(t1, e1) {
                if (!this._active) return;
                const i = e1;
                if (this._lastPos.equals(i) || !this._box && i.dist(this._startPos) < this._clickTolerance) return;
                const o = this._startPos;
                this._lastPos = i, this._box || (this._box = r.create("div", "maplibregl-boxzoom mapboxgl-boxzoom", this._container), this._container.classList.add("maplibregl-crosshair", "mapboxgl-crosshair"), this._fireEvent("boxzoomstart", t1));
                const a = Math.min(o.x, i.x), s = Math.max(o.x, i.x), n = Math.min(o.y, i.y), l = Math.max(o.y, i.y);
                r.setTransform(this._box, `translate(${a}px,${n}px)`), this._box.style.width = s - a + "px", this._box.style.height = l - n + "px";
            }
            mouseupWindow(e1, i) {
                if (!this._active) return;
                if (0 !== e1.button) return;
                const o = this._startPos, a = i;
                if (this.reset(), r.suppressClick(), o.x !== a.x || o.y !== a.y) return this._map.fire(new t1.Event("boxzoomend", {
                    originalEvent: e1
                })), {
                    cameraAnimation: (t1)=>t1.fitScreenCoordinates(o, a, this._map.getBearing(), {
                            linear: !0
                        })
                };
                this._fireEvent("boxzoomcancel", e1);
            }
            keydown(t1) {
                this._active && 27 === t1.keyCode && (this.reset(), this._fireEvent("boxzoomcancel", t1));
            }
            reset() {
                this._active = !1, this._container.classList.remove("maplibregl-crosshair", "mapboxgl-crosshair"), this._box && (r.remove(this._box), this._box = null), r.enableDrag(), delete this._startPos, delete this._lastPos;
            }
            _fireEvent(e1, i) {
                return this._map.fire(new t1.Event(e1, {
                    originalEvent: i
                }));
            }
        }
        function vo(t1, e1) {
            if (t1.length !== e1.length) throw new Error(`The number of touches and points are not equal - touches ${t1.length}, points ${e1.length}`);
            const i = {};
            for(let o = 0; o < t1.length; o++)i[t1[o].identifier] = e1[o];
            return i;
        }
        class yo {
            constructor(t1){
                this.reset(), this.numTouches = t1.numTouches;
            }
            reset() {
                delete this.centroid, delete this.startTime, delete this.touches, this.aborted = !1;
            }
            touchstart(e1, i, o) {
                (this.centroid || o.length > this.numTouches) && (this.aborted = !0), this.aborted || (void 0 === this.startTime && (this.startTime = e1.timeStamp), o.length === this.numTouches && (this.centroid = function(e1) {
                    const i = new t1.pointGeometry(0, 0);
                    for (const t2 of e1)i._add(t2);
                    return i.div(e1.length);
                }(i), this.touches = vo(o, i)));
            }
            touchmove(t1, e1, i) {
                if (this.aborted || !this.centroid) return;
                const o = vo(i, e1);
                for(const t2 in this.touches){
                    const e2 = this.touches[t2], i1 = o[t2];
                    (!i1 || i1.dist(e2) > 30) && (this.aborted = !0);
                }
            }
            touchend(t1, e1, i) {
                if ((!this.centroid || t1.timeStamp - this.startTime > 500) && (this.aborted = !0), 0 === i.length) {
                    const t2 = !this.aborted && this.centroid;
                    if (this.reset(), t2) return t2;
                }
            }
        }
        class bo {
            constructor(t1){
                this.singleTap = new yo(t1), this.numTaps = t1.numTaps, this.reset();
            }
            reset() {
                this.lastTime = 1 / 0, delete this.lastTap, this.count = 0, this.singleTap.reset();
            }
            touchstart(t1, e1, i) {
                this.singleTap.touchstart(t1, e1, i);
            }
            touchmove(t1, e1, i) {
                this.singleTap.touchmove(t1, e1, i);
            }
            touchend(t1, e1, i) {
                const o = this.singleTap.touchend(t1, e1, i);
                if (o) {
                    const e2 = t1.timeStamp - this.lastTime < 500, i1 = !this.lastTap || this.lastTap.dist(o) < 30;
                    if (e2 && i1 || this.reset(), this.count++, this.lastTime = t1.timeStamp, this.lastTap = o, this.count === this.numTaps) return this.reset(), o;
                }
            }
        }
        class wo {
            constructor(){
                this._zoomIn = new bo({
                    numTouches: 1,
                    numTaps: 2
                }), this._zoomOut = new bo({
                    numTouches: 2,
                    numTaps: 1
                }), this.reset();
            }
            reset() {
                this._active = !1, this._zoomIn.reset(), this._zoomOut.reset();
            }
            touchstart(t1, e1, i) {
                this._zoomIn.touchstart(t1, e1, i), this._zoomOut.touchstart(t1, e1, i);
            }
            touchmove(t1, e1, i) {
                this._zoomIn.touchmove(t1, e1, i), this._zoomOut.touchmove(t1, e1, i);
            }
            touchend(t1, e1, i) {
                const o = this._zoomIn.touchend(t1, e1, i), a = this._zoomOut.touchend(t1, e1, i);
                return o ? (this._active = !0, t1.preventDefault(), setTimeout(()=>this.reset(), 0), {
                    cameraAnimation: (e1)=>e1.easeTo({
                            duration: 300,
                            zoom: e1.getZoom() + 1,
                            around: e1.unproject(o)
                        }, {
                            originalEvent: t1
                        })
                }) : a ? (this._active = !0, t1.preventDefault(), setTimeout(()=>this.reset(), 0), {
                    cameraAnimation: (e1)=>e1.easeTo({
                            duration: 300,
                            zoom: e1.getZoom() - 1,
                            around: e1.unproject(a)
                        }, {
                            originalEvent: t1
                        })
                }) : void 0;
            }
            touchcancel() {
                this.reset();
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        const To = {
            0: 1,
            2: 2
        };
        class Eo {
            constructor(t1){
                this.reset(), this._clickTolerance = t1.clickTolerance || 1;
            }
            reset() {
                this._active = !1, this._moved = !1, delete this._lastPoint, delete this._eventButton;
            }
            _correctButton(t1, e1) {
                return !1;
            }
            _move(t1, e1) {
                return {};
            }
            mousedown(t1, e1) {
                if (this._lastPoint) return;
                const i = r.mouseButton(t1);
                this._correctButton(t1, i) && (this._lastPoint = e1, this._eventButton = i);
            }
            mousemoveWindow(t1, e1) {
                const i = this._lastPoint;
                if (i) {
                    if (t1.preventDefault(), function(t1, e1) {
                        const i = To[e1];
                        return void 0 === t1.buttons || (t1.buttons & i) !== i;
                    }(t1, this._eventButton)) this.reset();
                    else if (this._moved || !(e1.dist(i) < this._clickTolerance)) return this._moved = !0, this._lastPoint = e1, this._move(i, e1);
                }
            }
            mouseupWindow(t1) {
                this._lastPoint && r.mouseButton(t1) === this._eventButton && (this._moved && r.suppressClick(), this.reset());
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        class Io extends Eo {
            mousedown(t1, e1) {
                super.mousedown(t1, e1), this._lastPoint && (this._active = !0);
            }
            _correctButton(t1, e1) {
                return 0 === e1 && !t1.ctrlKey;
            }
            _move(t1, e1) {
                return {
                    around: e1,
                    panDelta: e1.sub(t1)
                };
            }
        }
        class Co extends Eo {
            _correctButton(t1, e1) {
                return 0 === e1 && t1.ctrlKey || 2 === e1;
            }
            _move(t1, e1) {
                const i = .8 * (e1.x - t1.x);
                if (i) return this._active = !0, {
                    bearingDelta: i
                };
            }
            contextmenu(t1) {
                t1.preventDefault();
            }
        }
        class So extends Eo {
            _correctButton(t1, e1) {
                return 0 === e1 && t1.ctrlKey || 2 === e1;
            }
            _move(t1, e1) {
                const i = -0.5 * (e1.y - t1.y);
                if (i) return this._active = !0, {
                    pitchDelta: i
                };
            }
            contextmenu(t1) {
                t1.preventDefault();
            }
        }
        class Do {
            constructor(t1, e1){
                this._minTouches = t1.cooperativeGestures ? 2 : 1, this._clickTolerance = t1.clickTolerance || 1, this._map = e1, this.reset();
            }
            reset() {
                this._active = !1, this._touches = {}, this._sum = new t1.pointGeometry(0, 0), setTimeout(()=>{
                    this._cancelCooperativeMessage = !1;
                }, 200);
            }
            touchstart(t1, e1, i) {
                return this._calculateTransform(t1, e1, i);
            }
            touchmove(t1, e1, i) {
                if (this._map._cooperativeGestures && (2 === this._minTouches && i.length < 2 && !this._cancelCooperativeMessage ? this._map._onCooperativeGesture(t1, !1, i.length) : this._cancelCooperativeMessage || (this._cancelCooperativeMessage = !0)), this._active && !(i.length < this._minTouches)) return t1.preventDefault(), this._calculateTransform(t1, e1, i);
            }
            touchend(t1, e1, i) {
                this._calculateTransform(t1, e1, i), this._active && i.length < this._minTouches && this.reset();
            }
            touchcancel() {
                this.reset();
            }
            _calculateTransform(e1, i, o) {
                o.length > 0 && (this._active = !0);
                const a = vo(o, i), r = new t1.pointGeometry(0, 0), s = new t1.pointGeometry(0, 0);
                let n = 0;
                for(const t2 in a){
                    const e2 = a[t2], i1 = this._touches[t2];
                    i1 && (r._add(e2), s._add(e2.sub(i1)), n++, a[t2] = e2);
                }
                if (this._touches = a, n < this._minTouches || !s.mag()) return;
                const l = s.div(n);
                return this._sum._add(l), this._sum.mag() < this._clickTolerance ? void 0 : {
                    around: r.div(n),
                    panDelta: l
                };
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        class zo {
            constructor(){
                this.reset();
            }
            reset() {
                this._active = !1, delete this._firstTwoTouches;
            }
            _start(t1) {}
            _move(t1, e1, i) {
                return {};
            }
            touchstart(t1, e1, i) {
                this._firstTwoTouches || i.length < 2 || (this._firstTwoTouches = [
                    i[0].identifier,
                    i[1].identifier
                ], this._start([
                    e1[0],
                    e1[1]
                ]));
            }
            touchmove(t1, e1, i) {
                if (!this._firstTwoTouches) return;
                t1.preventDefault();
                const [o, a] = this._firstTwoTouches, r = Po(i, e1, o), s = Po(i, e1, a);
                if (!r || !s) return;
                const n = this._aroundCenter ? null : r.add(s).div(2);
                return this._move([
                    r,
                    s
                ], n, t1);
            }
            touchend(t1, e1, i) {
                if (!this._firstTwoTouches) return;
                const [o, a] = this._firstTwoTouches, s = Po(i, e1, o), n = Po(i, e1, a);
                s && n || (this._active && r.suppressClick(), this.reset());
            }
            touchcancel() {
                this.reset();
            }
            enable(t1) {
                this._enabled = !0, this._aroundCenter = !!t1 && "center" === t1.around;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        function Po(t1, e1, i) {
            for(let o = 0; o < t1.length; o++)if (t1[o].identifier === i) return e1[o];
        }
        function Mo(t1, e1) {
            return Math.log(t1 / e1) / Math.LN2;
        }
        class Ao extends zo {
            reset() {
                super.reset(), delete this._distance, delete this._startDistance;
            }
            _start(t1) {
                this._startDistance = this._distance = t1[0].dist(t1[1]);
            }
            _move(t1, e1) {
                const i = this._distance;
                if (this._distance = t1[0].dist(t1[1]), this._active || !(Math.abs(Mo(this._distance, this._startDistance)) < .1)) return this._active = !0, {
                    zoomDelta: Mo(this._distance, i),
                    pinchAround: e1
                };
            }
        }
        function Lo(t1, e1) {
            return 180 * t1.angleWith(e1) / Math.PI;
        }
        class Ro extends zo {
            reset() {
                super.reset(), delete this._minDiameter, delete this._startVector, delete this._vector;
            }
            _start(t1) {
                this._startVector = this._vector = t1[0].sub(t1[1]), this._minDiameter = t1[0].dist(t1[1]);
            }
            _move(t1, e1) {
                const i = this._vector;
                if (this._vector = t1[0].sub(t1[1]), this._active || !this._isBelowThreshold(this._vector)) return this._active = !0, {
                    bearingDelta: Lo(this._vector, i),
                    pinchAround: e1
                };
            }
            _isBelowThreshold(t1) {
                this._minDiameter = Math.min(this._minDiameter, t1.mag());
                const e1 = 25 / (Math.PI * this._minDiameter) * 360, i = Lo(t1, this._startVector);
                return Math.abs(i) < e1;
            }
        }
        function ko(t1) {
            return Math.abs(t1.y) > Math.abs(t1.x);
        }
        class Bo extends zo {
            constructor(t1){
                super(), this._map = t1;
            }
            reset() {
                super.reset(), this._valid = void 0, delete this._firstMove, delete this._lastPoints;
            }
            touchstart(t1, e1, i) {
                super.touchstart(t1, e1, i), this._currentTouchCount = i.length;
            }
            _start(t1) {
                this._lastPoints = t1, ko(t1[0].sub(t1[1])) && (this._valid = !1);
            }
            _move(t1, e1, i) {
                if (this._map._cooperativeGestures && this._currentTouchCount < 3) return;
                const o = t1[0].sub(this._lastPoints[0]), a = t1[1].sub(this._lastPoints[1]);
                return this._valid = this.gestureBeginsVertically(o, a, i.timeStamp), this._valid ? (this._lastPoints = t1, this._active = !0, {
                    pitchDelta: (o.y + a.y) / 2 * -0.5
                }) : void 0;
            }
            gestureBeginsVertically(t1, e1, i) {
                if (void 0 !== this._valid) return this._valid;
                const o = t1.mag() >= 2, a = e1.mag() >= 2;
                if (!o && !a) return;
                if (!o || !a) return void 0 === this._firstMove && (this._firstMove = i), i - this._firstMove < 100 && void 0;
                const r = t1.y > 0 == e1.y > 0;
                return ko(t1) && ko(e1) && r;
            }
        }
        const Fo = {
            panStep: 100,
            bearingStep: 15,
            pitchStep: 10
        };
        class Oo {
            constructor(){
                const t1 = Fo;
                this._panStep = t1.panStep, this._bearingStep = t1.bearingStep, this._pitchStep = t1.pitchStep, this._rotationDisabled = !1;
            }
            reset() {
                this._active = !1;
            }
            keydown(t1) {
                if (t1.altKey || t1.ctrlKey || t1.metaKey) return;
                let e1 = 0, i = 0, o = 0, a = 0, r = 0;
                switch(t1.keyCode){
                    case 61:
                    case 107:
                    case 171:
                    case 187:
                        e1 = 1;
                        break;
                    case 189:
                    case 109:
                    case 173:
                        e1 = -1;
                        break;
                    case 37:
                        t1.shiftKey ? i = -1 : (t1.preventDefault(), a = -1);
                        break;
                    case 39:
                        t1.shiftKey ? i = 1 : (t1.preventDefault(), a = 1);
                        break;
                    case 38:
                        t1.shiftKey ? o = 1 : (t1.preventDefault(), r = -1);
                        break;
                    case 40:
                        t1.shiftKey ? o = -1 : (t1.preventDefault(), r = 1);
                        break;
                    default:
                        return;
                }
                return this._rotationDisabled && (i = 0, o = 0), {
                    cameraAnimation: (s)=>{
                        const n = s.getZoom();
                        s.easeTo({
                            duration: 300,
                            easeId: "keyboardHandler",
                            easing: Uo,
                            zoom: e1 ? Math.round(n) + e1 * (t1.shiftKey ? 2 : 1) : n,
                            bearing: s.getBearing() + i * this._bearingStep,
                            pitch: s.getPitch() + o * this._pitchStep,
                            offset: [
                                -a * this._panStep,
                                -r * this._panStep
                            ],
                            center: s.getCenter()
                        }, {
                            originalEvent: t1
                        });
                    }
                };
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
            disableRotation() {
                this._rotationDisabled = !0;
            }
            enableRotation() {
                this._rotationDisabled = !1;
            }
        }
        function Uo(t1) {
            return t1 * (2 - t1);
        }
        const No = 4.000244140625;
        class Go {
            constructor(e1, i){
                this._map = e1, this._el = e1.getCanvasContainer(), this._handler = i, this._delta = 0, this._defaultZoomRate = .01, this._wheelZoomRate = .0022222222222222222, t1.bindAll([
                    "_onTimeout"
                ], this);
            }
            setZoomRate(t1) {
                this._defaultZoomRate = t1;
            }
            setWheelZoomRate(t1) {
                this._wheelZoomRate = t1;
            }
            isEnabled() {
                return !!this._enabled;
            }
            isActive() {
                return !!this._active || void 0 !== this._finishTimeout;
            }
            isZooming() {
                return !!this._zooming;
            }
            enable(t1) {
                this.isEnabled() || (this._enabled = !0, this._aroundCenter = t1 && "center" === t1.around);
            }
            disable() {
                this.isEnabled() && (this._enabled = !1);
            }
            wheel(e1) {
                if (!this.isEnabled()) return;
                if (this._map._cooperativeGestures) {
                    if (!this._map._metaPress) return;
                    e1.preventDefault();
                }
                let i = e1.deltaMode === WheelEvent.DOM_DELTA_LINE ? 40 * e1.deltaY : e1.deltaY;
                const o = t1.exported.now(), a = o - (this._lastWheelEventTime || 0);
                this._lastWheelEventTime = o, 0 !== i && i % No == 0 ? this._type = "wheel" : 0 !== i && Math.abs(i) < 4 ? this._type = "trackpad" : a > 400 ? (this._type = null, this._lastValue = i, this._timeout = setTimeout(this._onTimeout, 40, e1)) : this._type || (this._type = Math.abs(a * i) < 200 ? "trackpad" : "wheel", this._timeout && (clearTimeout(this._timeout), this._timeout = null, i += this._lastValue)), e1.shiftKey && i && (i /= 4), this._type && (this._lastWheelEvent = e1, this._delta -= i, this._active || this._start(e1)), e1.preventDefault();
            }
            _onTimeout(t1) {
                this._type = "wheel", this._delta -= this._lastValue, this._active || this._start(t1);
            }
            _start(e1) {
                if (!this._delta) return;
                this._frameId && (this._frameId = null), this._active = !0, this.isZooming() || (this._zooming = !0), this._finishTimeout && (clearTimeout(this._finishTimeout), delete this._finishTimeout);
                const i = r.mousePos(this._el, e1);
                this._around = t1.LngLat.convert(this._aroundCenter ? this._map.getCenter() : this._map.unproject(i)), this._aroundPoint = this._map.transform.locationPoint(this._around), this._frameId || (this._frameId = !0, this._handler._triggerRenderFrame());
            }
            renderFrame() {
                if (!this._frameId) return;
                if (this._frameId = null, !this.isActive()) return;
                const e1 = this._map.transform;
                if (0 !== this._delta) {
                    const t2 = "wheel" === this._type && Math.abs(this._delta) > No ? this._wheelZoomRate : this._defaultZoomRate;
                    let i = 2 / (1 + Math.exp(-Math.abs(this._delta * t2)));
                    this._delta < 0 && 0 !== i && (i = 1 / i);
                    const o = "number" == typeof this._targetZoom ? e1.zoomScale(this._targetZoom) : e1.scale;
                    this._targetZoom = Math.min(e1.maxZoom, Math.max(e1.minZoom, e1.scaleZoom(o * i))), "wheel" === this._type && (this._startZoom = e1.zoom, this._easing = this._smoothOutEasing(200)), this._delta = 0;
                }
                const i1 = "number" == typeof this._targetZoom ? this._targetZoom : e1.zoom, o1 = this._startZoom, a = this._easing;
                let r, s = !1;
                if ("wheel" === this._type && o1 && a) {
                    const e2 = Math.min((t1.exported.now() - this._lastWheelEventTime) / 200, 1), n = a(e2);
                    r = t1.number(o1, i1, n), e2 < 1 ? this._frameId || (this._frameId = !0) : s = !0;
                } else r = i1, s = !0;
                return this._active = !0, s && (this._active = !1, this._finishTimeout = setTimeout(()=>{
                    this._zooming = !1, this._handler._triggerRenderFrame(), delete this._targetZoom, delete this._finishTimeout;
                }, 200)), {
                    noInertia: !0,
                    needsRenderFrame: !s,
                    zoomDelta: r - e1.zoom,
                    around: this._aroundPoint,
                    originalEvent: this._lastWheelEvent
                };
            }
            _smoothOutEasing(e1) {
                let i = t1.ease;
                if (this._prevEase) {
                    const e2 = this._prevEase, o = (t1.exported.now() - e2.start) / e2.duration, a = e2.easing(o + .01) - e2.easing(o), r = .27 / Math.sqrt(a * a + 1e-4) * .01, s = Math.sqrt(.0729 - r * r);
                    i = t1.bezier(r, s, .25, 1);
                }
                return this._prevEase = {
                    start: t1.exported.now(),
                    duration: e1,
                    easing: i
                }, i;
            }
            reset() {
                this._active = !1;
            }
        }
        class Zo {
            constructor(t1, e1){
                this._clickZoom = t1, this._tapZoom = e1;
            }
            enable() {
                this._clickZoom.enable(), this._tapZoom.enable();
            }
            disable() {
                this._clickZoom.disable(), this._tapZoom.disable();
            }
            isEnabled() {
                return this._clickZoom.isEnabled() && this._tapZoom.isEnabled();
            }
            isActive() {
                return this._clickZoom.isActive() || this._tapZoom.isActive();
            }
        }
        class Vo {
            constructor(){
                this.reset();
            }
            reset() {
                this._active = !1;
            }
            dblclick(t1, e1) {
                return t1.preventDefault(), {
                    cameraAnimation: (i)=>{
                        i.easeTo({
                            duration: 300,
                            zoom: i.getZoom() + (t1.shiftKey ? -1 : 1),
                            around: i.unproject(e1)
                        }, {
                            originalEvent: t1
                        });
                    }
                };
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        class qo {
            constructor(){
                this._tap = new bo({
                    numTouches: 1,
                    numTaps: 1
                }), this.reset();
            }
            reset() {
                this._active = !1, delete this._swipePoint, delete this._swipeTouch, delete this._tapTime, this._tap.reset();
            }
            touchstart(t1, e1, i) {
                this._swipePoint || (this._tapTime && t1.timeStamp - this._tapTime > 500 && this.reset(), this._tapTime ? i.length > 0 && (this._swipePoint = e1[0], this._swipeTouch = i[0].identifier) : this._tap.touchstart(t1, e1, i));
            }
            touchmove(t1, e1, i) {
                if (this._tapTime) {
                    if (this._swipePoint) {
                        if (i[0].identifier !== this._swipeTouch) return;
                        const o = e1[0], a = o.y - this._swipePoint.y;
                        return this._swipePoint = o, t1.preventDefault(), this._active = !0, {
                            zoomDelta: a / 128
                        };
                    }
                } else this._tap.touchmove(t1, e1, i);
            }
            touchend(t1, e1, i) {
                this._tapTime ? this._swipePoint && 0 === i.length && this.reset() : this._tap.touchend(t1, e1, i) && (this._tapTime = t1.timeStamp);
            }
            touchcancel() {
                this.reset();
            }
            enable() {
                this._enabled = !0;
            }
            disable() {
                this._enabled = !1, this.reset();
            }
            isEnabled() {
                return this._enabled;
            }
            isActive() {
                return this._active;
            }
        }
        class jo {
            constructor(t1, e1, i){
                this._el = t1, this._mousePan = e1, this._touchPan = i;
            }
            enable(t1) {
                this._inertiaOptions = t1 || {}, this._mousePan.enable(), this._touchPan.enable(), this._el.classList.add("maplibregl-touch-drag-pan", "mapboxgl-touch-drag-pan");
            }
            disable() {
                this._mousePan.disable(), this._touchPan.disable(), this._el.classList.remove("maplibregl-touch-drag-pan", "mapboxgl-touch-drag-pan");
            }
            isEnabled() {
                return this._mousePan.isEnabled() && this._touchPan.isEnabled();
            }
            isActive() {
                return this._mousePan.isActive() || this._touchPan.isActive();
            }
        }
        class $o {
            constructor(t1, e1, i){
                this._pitchWithRotate = t1.pitchWithRotate, this._mouseRotate = e1, this._mousePitch = i;
            }
            enable() {
                this._mouseRotate.enable(), this._pitchWithRotate && this._mousePitch.enable();
            }
            disable() {
                this._mouseRotate.disable(), this._mousePitch.disable();
            }
            isEnabled() {
                return this._mouseRotate.isEnabled() && (!this._pitchWithRotate || this._mousePitch.isEnabled());
            }
            isActive() {
                return this._mouseRotate.isActive() || this._mousePitch.isActive();
            }
        }
        class Xo {
            constructor(t1, e1, i, o){
                this._el = t1, this._touchZoom = e1, this._touchRotate = i, this._tapDragZoom = o, this._rotationDisabled = !1, this._enabled = !0;
            }
            enable(t1) {
                this._touchZoom.enable(t1), this._rotationDisabled || this._touchRotate.enable(t1), this._tapDragZoom.enable(), this._el.classList.add("maplibregl-touch-zoom-rotate", "mapboxgl-touch-zoom-rotate");
            }
            disable() {
                this._touchZoom.disable(), this._touchRotate.disable(), this._tapDragZoom.disable(), this._el.classList.remove("maplibregl-touch-zoom-rotate", "mapboxgl-touch-zoom-rotate");
            }
            isEnabled() {
                return this._touchZoom.isEnabled() && (this._rotationDisabled || this._touchRotate.isEnabled()) && this._tapDragZoom.isEnabled();
            }
            isActive() {
                return this._touchZoom.isActive() || this._touchRotate.isActive() || this._tapDragZoom.isActive();
            }
            disableRotation() {
                this._rotationDisabled = !0, this._touchRotate.disable();
            }
            enableRotation() {
                this._rotationDisabled = !1, this._touchZoom.isEnabled() && this._touchRotate.enable();
            }
        }
        const Wo = (t1)=>t1.zoom || t1.drag || t1.pitch || t1.rotate;
        class Ho extends t1.Event {
        }
        function Ko(t1) {
            return t1.panDelta && t1.panDelta.mag() || t1.zoomDelta || t1.bearingDelta || t1.pitchDelta;
        }
        class Yo {
            constructor(e1, i){
                this._map = e1, this._el = this._map.getCanvasContainer(), this._handlers = [], this._handlersById = {}, this._changes = [], this._inertia = new co(e1), this._bearingSnap = i.bearingSnap, this._previousActiveHandlers = {}, this._eventsInProgress = {}, this._addDefaultHandlers(i), t1.bindAll([
                    "handleEvent",
                    "handleWindowEvent"
                ], this);
                const o = this._el;
                this._listeners = [
                    [
                        o,
                        "touchstart",
                        {
                            passive: !0
                        }
                    ],
                    [
                        o,
                        "touchmove",
                        {
                            passive: !1
                        }
                    ],
                    [
                        o,
                        "touchend",
                        void 0
                    ],
                    [
                        o,
                        "touchcancel",
                        void 0
                    ],
                    [
                        o,
                        "mousedown",
                        void 0
                    ],
                    [
                        o,
                        "mousemove",
                        void 0
                    ],
                    [
                        o,
                        "mouseup",
                        void 0
                    ],
                    [
                        document,
                        "mousemove",
                        {
                            capture: !0
                        }
                    ],
                    [
                        document,
                        "mouseup",
                        void 0
                    ],
                    [
                        o,
                        "mouseover",
                        void 0
                    ],
                    [
                        o,
                        "mouseout",
                        void 0
                    ],
                    [
                        o,
                        "dblclick",
                        void 0
                    ],
                    [
                        o,
                        "click",
                        void 0
                    ],
                    [
                        o,
                        "keydown",
                        {
                            capture: !1
                        }
                    ],
                    [
                        o,
                        "keyup",
                        void 0
                    ],
                    [
                        o,
                        "wheel",
                        {
                            passive: !1
                        }
                    ],
                    [
                        o,
                        "contextmenu",
                        void 0
                    ],
                    [
                        window,
                        "blur",
                        void 0
                    ]
                ];
                for (const [t2, e2, i1] of this._listeners)r.addEventListener(t2, e2, t2 === document ? this.handleWindowEvent : this.handleEvent, i1);
            }
            destroy() {
                for (const [t1, e1, i] of this._listeners)r.removeEventListener(t1, e1, t1 === document ? this.handleWindowEvent : this.handleEvent, i);
            }
            _addDefaultHandlers(t1) {
                const e1 = this._map, i = e1.getCanvasContainer();
                this._add("mapEvent", new fo(e1, t1));
                const o = e1.boxZoom = new xo(e1, t1);
                this._add("boxZoom", o);
                const a = new wo, r = new Vo;
                e1.doubleClickZoom = new Zo(r, a), this._add("tapZoom", a), this._add("clickZoom", r);
                const s = new qo;
                this._add("tapDragZoom", s);
                const n = e1.touchPitch = new Bo(e1);
                this._add("touchPitch", n);
                const l = new Co(t1), c = new So(t1);
                e1.dragRotate = new $o(t1, l, c), this._add("mouseRotate", l, [
                    "mousePitch"
                ]), this._add("mousePitch", c, [
                    "mouseRotate"
                ]);
                const h = new Io(t1), u = new Do(t1, e1);
                e1.dragPan = new jo(i, h, u), this._add("mousePan", h), this._add("touchPan", u, [
                    "touchZoom",
                    "touchRotate"
                ]);
                const d = new Ro, m = new Ao;
                e1.touchZoomRotate = new Xo(i, m, d, s), this._add("touchRotate", d, [
                    "touchPan",
                    "touchZoom"
                ]), this._add("touchZoom", m, [
                    "touchPan",
                    "touchRotate"
                ]);
                const _ = e1.scrollZoom = new Go(e1, this);
                this._add("scrollZoom", _, [
                    "mousePan"
                ]);
                const p = e1.keyboard = new Oo;
                this._add("keyboard", p), this._add("blockableMapEvent", new go(e1));
                for (const i1 of [
                    "boxZoom",
                    "doubleClickZoom",
                    "tapDragZoom",
                    "touchPitch",
                    "dragRotate",
                    "dragPan",
                    "touchZoomRotate",
                    "scrollZoom",
                    "keyboard"
                ])t1.interactive && t1[i1] && e1[i1].enable(t1[i1]);
            }
            _add(t1, e1, i) {
                this._handlers.push({
                    handlerName: t1,
                    handler: e1,
                    allowed: i
                }), this._handlersById[t1] = e1;
            }
            stop(t1) {
                if (!this._updatingCamera) {
                    for (const { handler: t2  } of this._handlers)t2.reset();
                    this._inertia.clear(), this._fireEvents({}, {}, t1), this._changes = [];
                }
            }
            isActive() {
                for (const { handler: t1  } of this._handlers)if (t1.isActive()) return !0;
                return !1;
            }
            isZooming() {
                return !!this._eventsInProgress.zoom || this._map.scrollZoom.isZooming();
            }
            isRotating() {
                return !!this._eventsInProgress.rotate;
            }
            isMoving() {
                return Boolean(Wo(this._eventsInProgress)) || this.isZooming();
            }
            _blockedByActive(t1, e1, i) {
                for(const o in t1)if (o !== i && (!e1 || e1.indexOf(o) < 0)) return !0;
                return !1;
            }
            handleWindowEvent(t1) {
                this.handleEvent(t1, `${t1.type}Window`);
            }
            _getMapTouches(t1) {
                const e1 = [];
                for (const i of t1)this._el.contains(i.target) && e1.push(i);
                return e1;
            }
            handleEvent(t1, e1) {
                if ("blur" === t1.type) return void this.stop(!0);
                this._updatingCamera = !0;
                const i = "renderFrame" === t1.type ? void 0 : t1, o = {
                    needsRenderFrame: !1
                }, a = {}, s = {}, n = t1.touches, l = n ? this._getMapTouches(n) : void 0, c = l ? r.touchPos(this._el, l) : r.mousePos(this._el, t1);
                for (const { handlerName: r1 , handler: n1 , allowed: h  } of this._handlers){
                    if (!n1.isEnabled()) continue;
                    let u;
                    this._blockedByActive(s, h, r1) ? n1.reset() : n1[e1 || t1.type] && (u = n1[e1 || t1.type](t1, c, l), this.mergeHandlerResult(o, a, u, r1, i), u && u.needsRenderFrame && this._triggerRenderFrame()), (u || n1.isActive()) && (s[r1] = n1);
                }
                const h1 = {};
                for(const t2 in this._previousActiveHandlers)s[t2] || (h1[t2] = i);
                this._previousActiveHandlers = s, (Object.keys(h1).length || Ko(o)) && (this._changes.push([
                    o,
                    a,
                    h1
                ]), this._triggerRenderFrame()), (Object.keys(s).length || Ko(o)) && this._map._stop(!0), this._updatingCamera = !1;
                const { cameraAnimation: u1  } = o;
                u1 && (this._inertia.clear(), this._fireEvents({}, {}, !0), this._changes = [], u1(this._map));
            }
            mergeHandlerResult(e1, i, o, a, r) {
                if (!o) return;
                t1.extend(e1, o);
                const s = {
                    handlerName: a,
                    originalEvent: o.originalEvent || r
                };
                void 0 !== o.zoomDelta && (i.zoom = s), void 0 !== o.panDelta && (i.drag = s), void 0 !== o.pitchDelta && (i.pitch = s), void 0 !== o.bearingDelta && (i.rotate = s);
            }
            _applyChanges() {
                const e1 = {}, i = {}, o = {};
                for (const [a, r, s] of this._changes)a.panDelta && (e1.panDelta = (e1.panDelta || new t1.pointGeometry(0, 0))._add(a.panDelta)), a.zoomDelta && (e1.zoomDelta = (e1.zoomDelta || 0) + a.zoomDelta), a.bearingDelta && (e1.bearingDelta = (e1.bearingDelta || 0) + a.bearingDelta), a.pitchDelta && (e1.pitchDelta = (e1.pitchDelta || 0) + a.pitchDelta), void 0 !== a.around && (e1.around = a.around), void 0 !== a.pinchAround && (e1.pinchAround = a.pinchAround), a.noInertia && (e1.noInertia = a.noInertia), t1.extend(i, r), t1.extend(o, s);
                this._updateMapTransform(e1, i, o), this._changes = [];
            }
            _updateMapTransform(e1, i, o) {
                const a = this._map, r = a.transform, s = a.style && a.style.terrain;
                if (!(Ko(e1) || s && this._drag)) return this._fireEvents(i, o, !0);
                let { panDelta: n , zoomDelta: l , bearingDelta: c , pitchDelta: h , around: u , pinchAround: d  } = e1;
                void 0 !== d && (u = d), a._stop(!0), u = u || a.transform.centerPoint;
                const m = r.pointLocation(n ? u.sub(n) : u);
                c && (r.bearing += c), h && (r.pitch += h), l && (r.zoom += l), s ? i.drag && !this._drag ? (this._drag = {
                    center: r.centerPoint,
                    lngLat: r.pointLocation(u),
                    point: u,
                    handlerName: i.drag.handlerName
                }, a.fire(new t1.Event("freezeElevation", {
                    freeze: !0
                }))) : this._drag && o[this._drag.handlerName] ? (a.fire(new t1.Event("freezeElevation", {
                    freeze: !1
                })), this._drag = null) : i.drag && this._drag && (r.center = r.pointLocation(r.centerPoint.sub(n))) : r.setLocationAtPoint(m, u), this._map._update(), e1.noInertia || this._inertia.record(e1), this._fireEvents(i, o, !0);
            }
            _fireEvents(e1, i, o) {
                const a = Wo(this._eventsInProgress), r = Wo(e1), s = {};
                for(const t2 in e1){
                    const { originalEvent: i1  } = e1[t2];
                    this._eventsInProgress[t2] || (s[`${t2}start`] = i1), this._eventsInProgress[t2] = e1[t2];
                }
                !a && r && this._fireEvent("movestart", r.originalEvent);
                for(const t3 in s)this._fireEvent(t3, s[t3]);
                r && this._fireEvent("move", r.originalEvent);
                for(const t4 in e1){
                    const { originalEvent: i2  } = e1[t4];
                    this._fireEvent(t4, i2);
                }
                const n = {};
                let l;
                for(const t5 in this._eventsInProgress){
                    const { handlerName: e2 , originalEvent: o1  } = this._eventsInProgress[t5];
                    this._handlersById[e2].isActive() || (delete this._eventsInProgress[t5], l = i[e2] || o1, n[`${t5}end`] = l);
                }
                for(const t6 in n)this._fireEvent(t6, n[t6]);
                const c = Wo(this._eventsInProgress);
                if (o && (a || r) && !c) {
                    this._updatingCamera = !0;
                    const e3 = this._inertia._onMoveEnd(this._map.dragPan._inertiaOptions), i3 = (t1)=>0 !== t1 && -this._bearingSnap < t1 && t1 < this._bearingSnap;
                    e3 ? (i3(e3.bearing || this._map.getBearing()) && (e3.bearing = 0), this._map.easeTo(e3, {
                        originalEvent: l
                    })) : (this._map.fire(new t1.Event("moveend", {
                        originalEvent: l
                    })), i3(this._map.getBearing()) && this._map.resetNorth()), this._updatingCamera = !1;
                }
            }
            _fireEvent(e1, i) {
                this._map.fire(new t1.Event(e1, i ? {
                    originalEvent: i
                } : {}));
            }
            _requestFrame() {
                return this._map.triggerRepaint(), this._map._renderTaskQueue.add((t1)=>{
                    delete this._frameId, this.handleEvent(new Ho("renderFrame", {
                        timeStamp: t1
                    })), this._applyChanges();
                });
            }
            _triggerRenderFrame() {
                void 0 === this._frameId && (this._frameId = this._requestFrame());
            }
        }
        const Jo = {
            extend: (e1, ...i)=>t1.extend(e1, ...i),
            run (t1) {
                t1();
            },
            logToElement (t1, e1 = !1, i = "log") {
                const o = window.document.getElementById(i);
                o && (e1 && (o.innerHTML = ""), o.innerHTML += `<br>${t1}`);
            }
        };
        class Qo extends t1.Evented {
            constructor(e1, i){
                super(), this._moving = !1, this._zooming = !1, this.transform = e1, this._bearingSnap = i.bearingSnap, t1.bindAll([
                    "_renderFrameCallback"
                ], this);
            }
            getCenter() {
                return new t1.LngLat(this.transform.center.lng, this.transform.center.lat);
            }
            setCenter(t1, e1) {
                return this.jumpTo({
                    center: t1
                }, e1);
            }
            panBy(e1, i, o) {
                return e1 = t1.pointGeometry.convert(e1).mult(-1), this.panTo(this.transform.center, t1.extend({
                    offset: e1
                }, i), o);
            }
            panTo(e1, i, o) {
                return this.easeTo(t1.extend({
                    center: e1
                }, i), o);
            }
            getZoom() {
                return this.transform.zoom;
            }
            setZoom(t1, e1) {
                return this.jumpTo({
                    zoom: t1
                }, e1), this;
            }
            zoomTo(e1, i, o) {
                return this.easeTo(t1.extend({
                    zoom: e1
                }, i), o);
            }
            zoomIn(t1, e1) {
                return this.zoomTo(this.getZoom() + 1, t1, e1), this;
            }
            zoomOut(t1, e1) {
                return this.zoomTo(this.getZoom() - 1, t1, e1), this;
            }
            getBearing() {
                return this.transform.bearing;
            }
            setBearing(t1, e1) {
                return this.jumpTo({
                    bearing: t1
                }, e1), this;
            }
            getPadding() {
                return this.transform.padding;
            }
            setPadding(t1, e1) {
                return this.jumpTo({
                    padding: t1
                }, e1), this;
            }
            rotateTo(e1, i, o) {
                return this.easeTo(t1.extend({
                    bearing: e1
                }, i), o);
            }
            resetNorth(e1, i) {
                return this.rotateTo(0, t1.extend({
                    duration: 1e3
                }, e1), i), this;
            }
            resetNorthPitch(e1, i) {
                return this.easeTo(t1.extend({
                    bearing: 0,
                    pitch: 0,
                    duration: 1e3
                }, e1), i), this;
            }
            snapToNorth(t1, e1) {
                return Math.abs(this.getBearing()) < this._bearingSnap ? this.resetNorth(t1, e1) : this;
            }
            getPitch() {
                return this.transform.pitch;
            }
            setPitch(t1, e1) {
                return this.jumpTo({
                    pitch: t1
                }, e1), this;
            }
            cameraForBounds(e1, i) {
                e1 = t1.LngLatBounds.convert(e1);
                const o = i && i.bearing || 0;
                return this._cameraForBoxAndBearing(e1.getNorthWest(), e1.getSouthEast(), o, i);
            }
            _cameraForBoxAndBearing(e1, i, o, a) {
                const r = {
                    top: 0,
                    bottom: 0,
                    right: 0,
                    left: 0
                };
                if ("number" == typeof (a = t1.extend({
                    padding: r,
                    offset: [
                        0,
                        0
                    ],
                    maxZoom: this.transform.maxZoom
                }, a)).padding) {
                    const t2 = a.padding;
                    a.padding = {
                        top: t2,
                        bottom: t2,
                        right: t2,
                        left: t2
                    };
                }
                a.padding = t1.extend(r, a.padding);
                const s = this.transform, n = s.padding, l = s.project(t1.LngLat.convert(e1)), c = s.project(t1.LngLat.convert(i)), h = l.rotate(-o * Math.PI / 180), u = c.rotate(-o * Math.PI / 180), d = new t1.pointGeometry(Math.max(h.x, u.x), Math.max(h.y, u.y)), m = new t1.pointGeometry(Math.min(h.x, u.x), Math.min(h.y, u.y)), _ = d.sub(m), p = (s.width - (n.left + n.right + a.padding.left + a.padding.right)) / _.x, f = (s.height - (n.top + n.bottom + a.padding.top + a.padding.bottom)) / _.y;
                if (f < 0 || p < 0) return void t1.warnOnce("Map cannot fit within canvas with the given bounds, padding, and/or offset.");
                const g = Math.min(s.scaleZoom(s.scale * Math.min(p, f)), a.maxZoom), x = t1.pointGeometry.convert(a.offset), v = new t1.pointGeometry((a.padding.left - a.padding.right) / 2, (a.padding.top - a.padding.bottom) / 2).rotate(o * Math.PI / 180), y = x.add(v).mult(s.scale / s.zoomScale(g));
                return {
                    center: s.unproject(l.add(c).div(2).sub(y)),
                    zoom: g,
                    bearing: o
                };
            }
            fitBounds(t1, e1, i) {
                return this._fitInternal(this.cameraForBounds(t1, e1), e1, i);
            }
            fitScreenCoordinates(e1, i, o, a, r) {
                return this._fitInternal(this._cameraForBoxAndBearing(this.transform.pointLocation(t1.pointGeometry.convert(e1)), this.transform.pointLocation(t1.pointGeometry.convert(i)), o, a), a, r);
            }
            _fitInternal(e1, i, o) {
                return e1 ? (delete (i = t1.extend(e1, i)).padding, i.linear ? this.easeTo(i, o) : this.flyTo(i, o)) : this;
            }
            jumpTo(e1, i) {
                this.stop();
                const o = this.transform;
                let a = !1, r = !1, s = !1;
                return "zoom" in e1 && o.zoom !== +e1.zoom && (a = !0, o.zoom = +e1.zoom), void 0 !== e1.center && (o.center = t1.LngLat.convert(e1.center)), "bearing" in e1 && o.bearing !== +e1.bearing && (r = !0, o.bearing = +e1.bearing), "pitch" in e1 && o.pitch !== +e1.pitch && (s = !0, o.pitch = +e1.pitch), null == e1.padding || o.isPaddingEqual(e1.padding) || (o.padding = e1.padding), this.fire(new t1.Event("movestart", i)).fire(new t1.Event("move", i)), a && this.fire(new t1.Event("zoomstart", i)).fire(new t1.Event("zoom", i)).fire(new t1.Event("zoomend", i)), r && this.fire(new t1.Event("rotatestart", i)).fire(new t1.Event("rotate", i)).fire(new t1.Event("rotateend", i)), s && this.fire(new t1.Event("pitchstart", i)).fire(new t1.Event("pitch", i)).fire(new t1.Event("pitchend", i)), this.fire(new t1.Event("moveend", i));
            }
            calculateCameraOptionsFromTo(e1, i, o, a = 0) {
                const r = t1.MercatorCoordinate.fromLngLat(e1, i), s = t1.MercatorCoordinate.fromLngLat(o, a), n = s.x - r.x, l = s.y - r.y, c = s.z - r.z, h = Math.hypot(n, l, c);
                if (0 === h) throw new Error("Can't calculate camera options with same From and To");
                const u = Math.hypot(n, l), d = this.transform.scaleZoom(this.transform.cameraToCenterDistance / h / this.transform.tileSize), m = 180 * Math.atan2(n, -l) / Math.PI;
                let _ = 180 * Math.acos(u / h) / Math.PI;
                return _ = c < 0 ? 90 - _ : 90 + _, {
                    center: s.toLngLat(),
                    zoom: d,
                    pitch: _,
                    bearing: m
                };
            }
            easeTo(e1, i) {
                this._stop(!1, e1.easeId), (!1 === (e1 = t1.extend({
                    offset: [
                        0,
                        0
                    ],
                    duration: 500,
                    easing: t1.ease
                }, e1)).animate || !e1.essential && t1.exported.prefersReducedMotion) && (e1.duration = 0);
                const o = this.transform, a = this.getZoom(), r = this.getBearing(), s = this.getPitch(), n = this.getPadding(), l = "zoom" in e1 ? +e1.zoom : a, c = "bearing" in e1 ? this._normalizeBearing(e1.bearing, r) : r, h = "pitch" in e1 ? +e1.pitch : s, u = "padding" in e1 ? e1.padding : o.padding, d = t1.pointGeometry.convert(e1.offset);
                let m = o.centerPoint.add(d);
                const _ = o.pointLocation(m), p = t1.LngLat.convert(e1.center || _);
                this._normalizeCenter(p);
                const f = o.project(_), g = o.project(p).sub(f), x = o.zoomScale(l - a);
                let v, y;
                e1.around && (v = t1.LngLat.convert(e1.around), y = o.locationPoint(v));
                const b = {
                    moving: this._moving,
                    zooming: this._zooming,
                    rotating: this._rotating,
                    pitching: this._pitching
                };
                return this._zooming = this._zooming || l !== a, this._rotating = this._rotating || r !== c, this._pitching = this._pitching || h !== s, this._padding = !o.isPaddingEqual(u), this._easeId = e1.easeId, this._prepareEase(i, e1.noMoveStart, b), this._ease((e1)=>{
                    if (this._zooming && (o.zoom = t1.number(a, l, e1)), this._rotating && (o.bearing = t1.number(r, c, e1)), this._pitching && (o.pitch = t1.number(s, h, e1)), this._padding && (o.interpolatePadding(n, u, e1), m = o.centerPoint.add(d)), v) o.setLocationAtPoint(v, y);
                    else {
                        const t2 = o.zoomScale(o.zoom - a), i1 = l > a ? Math.min(2, x) : Math.max(.5, x), r1 = Math.pow(i1, 1 - e1), s1 = o.unproject(f.add(g.mult(e1 * r1)).mult(t2));
                        o.setLocationAtPoint(o.renderWorldCopies ? s1.wrap() : s1, m);
                    }
                    this._fireMoveEvents(i);
                }, (t1)=>{
                    this._afterEase(i, t1);
                }, e1), this;
            }
            _prepareEase(e1, i, o = {}) {
                this._moving = !0, this.fire(new t1.Event("freezeElevation", {
                    freeze: !0
                })), i || o.moving || this.fire(new t1.Event("movestart", e1)), this._zooming && !o.zooming && this.fire(new t1.Event("zoomstart", e1)), this._rotating && !o.rotating && this.fire(new t1.Event("rotatestart", e1)), this._pitching && !o.pitching && this.fire(new t1.Event("pitchstart", e1));
            }
            _fireMoveEvents(e1) {
                this.fire(new t1.Event("move", e1)), this._zooming && this.fire(new t1.Event("zoom", e1)), this._rotating && this.fire(new t1.Event("rotate", e1)), this._pitching && this.fire(new t1.Event("pitch", e1));
            }
            _afterEase(e1, i) {
                if (this._easeId && i && this._easeId === i) return;
                delete this._easeId, this.fire(new t1.Event("freezeElevation", {
                    freeze: !1
                }));
                const o = this._zooming, a = this._rotating, r = this._pitching;
                this._moving = !1, this._zooming = !1, this._rotating = !1, this._pitching = !1, this._padding = !1, o && this.fire(new t1.Event("zoomend", e1)), a && this.fire(new t1.Event("rotateend", e1)), r && this.fire(new t1.Event("pitchend", e1)), this.fire(new t1.Event("moveend", e1));
            }
            flyTo(e1, i) {
                if (!e1.essential && t1.exported.prefersReducedMotion) {
                    const o = t1.pick(e1, [
                        "center",
                        "zoom",
                        "bearing",
                        "pitch",
                        "around"
                    ]);
                    return this.jumpTo(o, i);
                }
                this.stop(), e1 = t1.extend({
                    offset: [
                        0,
                        0
                    ],
                    speed: 1.2,
                    curve: 1.42,
                    easing: t1.ease
                }, e1);
                const o1 = this.transform, a = this.getZoom(), r = this.getBearing(), s = this.getPitch(), n = this.getPadding(), l = "zoom" in e1 ? t1.clamp(+e1.zoom, o1.minZoom, o1.maxZoom) : a, c = "bearing" in e1 ? this._normalizeBearing(e1.bearing, r) : r, h = "pitch" in e1 ? +e1.pitch : s, u = "padding" in e1 ? e1.padding : o1.padding, d = o1.zoomScale(l - a), m = t1.pointGeometry.convert(e1.offset);
                let _ = o1.centerPoint.add(m);
                const p = o1.pointLocation(_), f = t1.LngLat.convert(e1.center || p);
                this._normalizeCenter(f);
                const g = o1.project(p), x = o1.project(f).sub(g);
                let v = e1.curve;
                const y = Math.max(o1.width, o1.height), b = y / d, w = x.mag();
                if ("minZoom" in e1) {
                    const i1 = t1.clamp(Math.min(e1.minZoom, a, l), o1.minZoom, o1.maxZoom), r1 = y / o1.zoomScale(i1 - a);
                    v = Math.sqrt(r1 / w * 2);
                }
                const T = v * v;
                function E(t1) {
                    const e1 = (b * b - y * y + (t1 ? -1 : 1) * T * T * w * w) / (2 * (t1 ? b : y) * T * w);
                    return Math.log(Math.sqrt(e1 * e1 + 1) - e1);
                }
                function I(t1) {
                    return (Math.exp(t1) - Math.exp(-t1)) / 2;
                }
                function C(t1) {
                    return (Math.exp(t1) + Math.exp(-t1)) / 2;
                }
                const S = E(0);
                let D = function(t1) {
                    return C(S) / C(S + v * t1);
                }, z = function(t1) {
                    var e1;
                    return y * ((C(S) * (I(e1 = S + v * t1) / C(e1)) - I(S)) / T) / w;
                }, P = (E(1) - S) / v;
                if (Math.abs(w) < 1e-6 || !isFinite(P)) {
                    if (Math.abs(y - b) < 1e-6) return this.easeTo(e1, i);
                    const t2 = b < y ? -1 : 1;
                    P = Math.abs(Math.log(b / y)) / v, z = function() {
                        return 0;
                    }, D = function(e1) {
                        return Math.exp(t2 * v * e1);
                    };
                }
                return e1.duration = "duration" in e1 ? +e1.duration : 1e3 * P / ("screenSpeed" in e1 ? +e1.screenSpeed / v : +e1.speed), e1.maxDuration && e1.duration > e1.maxDuration && (e1.duration = 0), this._zooming = !0, this._rotating = r !== c, this._pitching = h !== s, this._padding = !o1.isPaddingEqual(u), this._prepareEase(i, !1), this._ease((e1)=>{
                    const d = e1 * P, p = 1 / D(d);
                    o1.zoom = 1 === e1 ? l : a + o1.scaleZoom(p), this._rotating && (o1.bearing = t1.number(r, c, e1)), this._pitching && (o1.pitch = t1.number(s, h, e1)), this._padding && (o1.interpolatePadding(n, u, e1), _ = o1.centerPoint.add(m));
                    const v = 1 === e1 ? f : o1.unproject(g.add(x.mult(z(d))).mult(p));
                    o1.setLocationAtPoint(o1.renderWorldCopies ? v.wrap() : v, _), this._fireMoveEvents(i);
                }, ()=>this._afterEase(i), e1), this;
            }
            isEasing() {
                return !!this._easeFrameId;
            }
            stop() {
                return this._stop();
            }
            _stop(t1, e1) {
                if (this._easeFrameId && (this._cancelRenderFrame(this._easeFrameId), delete this._easeFrameId, delete this._onEaseFrame), this._onEaseEnd) {
                    const t2 = this._onEaseEnd;
                    delete this._onEaseEnd, t2.call(this, e1);
                }
                if (!t1) {
                    const t3 = this.handlers;
                    t3 && t3.stop(!1);
                }
                return this;
            }
            _ease(e1, i, o) {
                !1 === o.animate || 0 === o.duration ? (e1(1), i()) : (this._easeStart = t1.exported.now(), this._easeOptions = o, this._onEaseFrame = e1, this._onEaseEnd = i, this._easeFrameId = this._requestRenderFrame(this._renderFrameCallback));
            }
            _renderFrameCallback() {
                const e1 = Math.min((t1.exported.now() - this._easeStart) / this._easeOptions.duration, 1);
                this._onEaseFrame(this._easeOptions.easing(e1)), e1 < 1 ? this._easeFrameId = this._requestRenderFrame(this._renderFrameCallback) : this.stop();
            }
            _normalizeBearing(e1, i) {
                e1 = t1.wrap(e1, -180, 180);
                const o = Math.abs(e1 - i);
                return Math.abs(e1 - 360 - i) < o && (e1 -= 360), Math.abs(e1 + 360 - i) < o && (e1 += 360), e1;
            }
            _normalizeCenter(t1) {
                const e1 = this.transform;
                if (!e1.renderWorldCopies || e1.lngRange) return;
                const i = t1.lng - e1.center.lng;
                t1.lng += i > 180 ? -360 : i < -180 ? 360 : 0;
            }
        }
        class ta {
            constructor(e1 = {}){
                this.options = e1, t1.bindAll([
                    "_toggleAttribution",
                    "_updateData",
                    "_updateCompact",
                    "_updateCompactMinimize"
                ], this);
            }
            getDefaultPosition() {
                return "bottom-right";
            }
            onAdd(t1) {
                return this._map = t1, this._compact = this.options && this.options.compact, this._container = r.create("details", "maplibregl-ctrl maplibregl-ctrl-attrib mapboxgl-ctrl mapboxgl-ctrl-attrib"), this._compactButton = r.create("summary", "maplibregl-ctrl-attrib-button mapboxgl-ctrl-attrib-button", this._container), this._compactButton.addEventListener("click", this._toggleAttribution), this._setElementTitle(this._compactButton, "ToggleAttribution"), this._innerContainer = r.create("div", "maplibregl-ctrl-attrib-inner mapboxgl-ctrl-attrib-inner", this._container), this._updateAttributions(), this._updateCompact(), this._map.on("styledata", this._updateData), this._map.on("sourcedata", this._updateData), this._map.on("terrain", this._updateData), this._map.on("resize", this._updateCompact), this._map.on("drag", this._updateCompactMinimize), this._container;
            }
            onRemove() {
                r.remove(this._container), this._map.off("styledata", this._updateData), this._map.off("sourcedata", this._updateData), this._map.off("terrain", this._updateData), this._map.off("resize", this._updateCompact), this._map.off("drag", this._updateCompactMinimize), this._map = void 0, this._compact = void 0, this._attribHTML = void 0;
            }
            _setElementTitle(t1, e1) {
                const i = this._map._getUIString(`AttributionControl.${e1}`);
                t1.title = i, t1.setAttribute("aria-label", i);
            }
            _toggleAttribution() {
                this._container.classList.contains("maplibregl-compact") && (this._container.classList.contains("maplibregl-compact-show") ? (this._container.setAttribute("open", ""), this._container.classList.remove("maplibregl-compact-show", "mapboxgl-compact-show")) : (this._container.classList.add("maplibregl-compact-show", "mapboxgl-compact-show"), this._container.removeAttribute("open")));
            }
            _updateData(t1) {
                !t1 || "metadata" !== t1.sourceDataType && "visibility" !== t1.sourceDataType && "style" !== t1.dataType && "terrain" !== t1.type || this._updateAttributions();
            }
            _updateAttributions() {
                if (!this._map.style) return;
                let t1 = [];
                if (this.options.customAttribution && (Array.isArray(this.options.customAttribution) ? t1 = t1.concat(this.options.customAttribution.map((t1)=>"string" != typeof t1 ? "" : t1)) : "string" == typeof this.options.customAttribution && t1.push(this.options.customAttribution)), this._map.style.stylesheet) {
                    const t2 = this._map.style.stylesheet;
                    this.styleOwner = t2.owner, this.styleId = t2.id;
                }
                const e1 = this._map.style.sourceCaches;
                for(const i in e1){
                    const o = e1[i];
                    if (o.used || o.usedForTerrain) {
                        const e2 = o.getSource();
                        e2.attribution && t1.indexOf(e2.attribution) < 0 && t1.push(e2.attribution);
                    }
                }
                t1 = t1.filter((t1)=>String(t1).trim()), t1.sort((t1, e1)=>t1.length - e1.length), t1 = t1.filter((e1, i)=>{
                    for(let o = i + 1; o < t1.length; o++)if (t1[o].indexOf(e1) >= 0) return !1;
                    return !0;
                });
                const i1 = t1.join(" | ");
                i1 !== this._attribHTML && (this._attribHTML = i1, t1.length ? (this._innerContainer.innerHTML = i1, this._container.classList.remove("maplibregl-attrib-empty", "mapboxgl-attrib-empty")) : this._container.classList.add("maplibregl-attrib-empty", "mapboxgl-attrib-empty"), this._updateCompact(), this._editLink = null);
            }
            _updateCompact() {
                this._map.getCanvasContainer().offsetWidth <= 640 || this._compact ? !1 === this._compact ? this._container.setAttribute("open", "") : this._container.classList.contains("maplibregl-compact") || this._container.classList.contains("maplibregl-attrib-empty") || (this._container.setAttribute("open", ""), this._container.classList.add("maplibregl-compact", "mapboxgl-compact", "maplibregl-compact-show", "mapboxgl-compact-show")) : (this._container.setAttribute("open", ""), this._container.classList.contains("maplibregl-compact") && this._container.classList.remove("maplibregl-compact", "maplibregl-compact-show", "mapboxgl-compact", "mapboxgl-compact-show"));
            }
            _updateCompactMinimize() {
                this._container.classList.contains("maplibregl-compact") && this._container.classList.contains("maplibregl-compact-show") && this._container.classList.remove("maplibregl-compact-show", "mapboxgl-compact-show");
            }
        }
        class ea {
            constructor(e1 = {}){
                this.options = e1, t1.bindAll([
                    "_updateCompact"
                ], this);
            }
            getDefaultPosition() {
                return "bottom-left";
            }
            onAdd(t1) {
                this._map = t1, this._compact = this.options && this.options.compact, this._container = r.create("div", "maplibregl-ctrl mapboxgl-ctrl");
                const e1 = r.create("a", "maplibregl-ctrl-logo mapboxgl-ctrl-logo");
                return e1.target = "_blank", e1.rel = "noopener nofollow", e1.href = "https://maplibre.org/", e1.setAttribute("aria-label", this._map._getUIString("LogoControl.Title")), e1.setAttribute("rel", "noopener nofollow"), this._container.appendChild(e1), this._container.style.display = "block", this._map.on("resize", this._updateCompact), this._updateCompact(), this._container;
            }
            onRemove() {
                r.remove(this._container), this._map.off("resize", this._updateCompact), this._map = void 0, this._compact = void 0;
            }
            _updateCompact() {
                const t1 = this._container.children;
                if (t1.length) {
                    const e1 = t1[0];
                    this._map.getCanvasContainer().offsetWidth <= 640 || this._compact ? !1 !== this._compact && e1.classList.add("maplibregl-compact", "mapboxgl-compact") : e1.classList.remove("maplibregl-compact", "mapboxgl-compact");
                }
            }
        }
        class ia {
            constructor(){
                this._queue = [], this._id = 0, this._cleared = !1, this._currentlyRunning = !1;
            }
            add(t1) {
                const e1 = ++this._id;
                return this._queue.push({
                    callback: t1,
                    id: e1,
                    cancelled: !1
                }), e1;
            }
            remove(t1) {
                const e1 = this._currentlyRunning, i = e1 ? this._queue.concat(e1) : this._queue;
                for (const e2 of i)if (e2.id === t1) return void (e2.cancelled = !0);
            }
            run(t1 = 0) {
                if (this._currentlyRunning) throw new Error("Attempting to run(), but is already running.");
                const e1 = this._currentlyRunning = this._queue;
                this._queue = [];
                for (const i of e1)if (!i.cancelled && (i.callback(t1), this._cleared)) break;
                this._cleared = !1, this._currentlyRunning = !1;
            }
            clear() {
                this._currentlyRunning && (this._cleared = !0), this._queue = [];
            }
        }
        const oa = {
            "AttributionControl.ToggleAttribution": "Toggle attribution",
            "AttributionControl.MapFeedback": "Map feedback",
            "FullscreenControl.Enter": "Enter fullscreen",
            "FullscreenControl.Exit": "Exit fullscreen",
            "GeolocateControl.FindMyLocation": "Find my location",
            "GeolocateControl.LocationNotAvailable": "Location not available",
            "LogoControl.Title": "Mapbox logo",
            "NavigationControl.ResetBearing": "Reset bearing to north",
            "NavigationControl.ZoomIn": "Zoom in",
            "NavigationControl.ZoomOut": "Zoom out",
            "ScaleControl.Feet": "ft",
            "ScaleControl.Meters": "m",
            "ScaleControl.Kilometers": "km",
            "ScaleControl.Miles": "mi",
            "ScaleControl.NauticalMiles": "nm",
            "TerrainControl.enableTerrain": "Enable terrain",
            "TerrainControl.disableTerrain": "Disable terrain"
        }, aa = {
            center: [
                0,
                0
            ],
            zoom: 0,
            bearing: 0,
            pitch: 0,
            minZoom: -2,
            maxZoom: 22,
            minPitch: 0,
            maxPitch: 60,
            interactive: !0,
            scrollZoom: !0,
            boxZoom: !0,
            dragRotate: !0,
            dragPan: !0,
            keyboard: !0,
            doubleClickZoom: !0,
            touchZoomRotate: !0,
            touchPitch: !0,
            cooperativeGestures: void 0,
            bearingSnap: 7,
            clickTolerance: 3,
            pitchWithRotate: !0,
            hash: !1,
            attributionControl: !0,
            maplibreLogo: !1,
            failIfMajorPerformanceCaveat: !1,
            preserveDrawingBuffer: !1,
            trackResize: !0,
            renderWorldCopies: !0,
            refreshExpiredTiles: !0,
            maxTileCacheSize: null,
            localIdeographFontFamily: "sans-serif",
            transformRequest: null,
            fadeDuration: 300,
            crossSourceCollisions: !0
        }, ra = {
            showCompass: !0,
            showZoom: !0,
            visualizePitch: !1
        };
        class sa {
            constructor(e1, i, o = !1){
                this._clickTolerance = 10, this.element = i, this.mouseRotate = new Co({
                    clickTolerance: e1.dragRotate._mouseRotate._clickTolerance
                }), this.map = e1, o && (this.mousePitch = new So({
                    clickTolerance: e1.dragRotate._mousePitch._clickTolerance
                })), t1.bindAll([
                    "mousedown",
                    "mousemove",
                    "mouseup",
                    "touchstart",
                    "touchmove",
                    "touchend",
                    "reset"
                ], this), r.addEventListener(i, "mousedown", this.mousedown), r.addEventListener(i, "touchstart", this.touchstart, {
                    passive: !1
                }), r.addEventListener(i, "touchmove", this.touchmove), r.addEventListener(i, "touchend", this.touchend), r.addEventListener(i, "touchcancel", this.reset);
            }
            down(t1, e1) {
                this.mouseRotate.mousedown(t1, e1), this.mousePitch && this.mousePitch.mousedown(t1, e1), r.disableDrag();
            }
            move(t1, e1) {
                const i = this.map, o = this.mouseRotate.mousemoveWindow(t1, e1);
                if (o && o.bearingDelta && i.setBearing(i.getBearing() + o.bearingDelta), this.mousePitch) {
                    const o1 = this.mousePitch.mousemoveWindow(t1, e1);
                    o1 && o1.pitchDelta && i.setPitch(i.getPitch() + o1.pitchDelta);
                }
            }
            off() {
                const t1 = this.element;
                r.removeEventListener(t1, "mousedown", this.mousedown), r.removeEventListener(t1, "touchstart", this.touchstart, {
                    passive: !1
                }), r.removeEventListener(t1, "touchmove", this.touchmove), r.removeEventListener(t1, "touchend", this.touchend), r.removeEventListener(t1, "touchcancel", this.reset), this.offTemp();
            }
            offTemp() {
                r.enableDrag(), r.removeEventListener(window, "mousemove", this.mousemove), r.removeEventListener(window, "mouseup", this.mouseup);
            }
            mousedown(e1) {
                this.down(t1.extend({}, e1, {
                    ctrlKey: !0,
                    preventDefault: ()=>e1.preventDefault()
                }), r.mousePos(this.element, e1)), r.addEventListener(window, "mousemove", this.mousemove), r.addEventListener(window, "mouseup", this.mouseup);
            }
            mousemove(t1) {
                this.move(t1, r.mousePos(this.element, t1));
            }
            mouseup(t1) {
                this.mouseRotate.mouseupWindow(t1), this.mousePitch && this.mousePitch.mouseupWindow(t1), this.offTemp();
            }
            touchstart(t1) {
                1 !== t1.targetTouches.length ? this.reset() : (this._startPos = this._lastPos = r.touchPos(this.element, t1.targetTouches)[0], this.down({
                    type: "mousedown",
                    button: 0,
                    ctrlKey: !0,
                    preventDefault: ()=>t1.preventDefault()
                }, this._startPos));
            }
            touchmove(t1) {
                1 !== t1.targetTouches.length ? this.reset() : (this._lastPos = r.touchPos(this.element, t1.targetTouches)[0], this.move({
                    preventDefault: ()=>t1.preventDefault()
                }, this._lastPos));
            }
            touchend(t1) {
                0 === t1.targetTouches.length && this._startPos && this._lastPos && this._startPos.dist(this._lastPos) < this._clickTolerance && this.element.click(), this.reset();
            }
            reset() {
                this.mouseRotate.reset(), this.mousePitch && this.mousePitch.reset(), delete this._startPos, delete this._lastPos, this.offTemp();
            }
        }
        function na(e1, i, o) {
            if (e1 = new t1.LngLat(e1.lng, e1.lat), i) {
                const a = new t1.LngLat(e1.lng - 360, e1.lat), r = new t1.LngLat(e1.lng + 360, e1.lat), s = o.locationPoint(e1).distSqr(i);
                o.locationPoint(a).distSqr(i) < s ? e1 = a : o.locationPoint(r).distSqr(i) < s && (e1 = r);
            }
            for(; Math.abs(e1.lng - o.center.lng) > 180;){
                const t2 = o.locationPoint(e1);
                if (t2.x >= 0 && t2.y >= 0 && t2.x <= o.width && t2.y <= o.height) break;
                e1.lng > o.center.lng ? e1.lng -= 360 : e1.lng += 360;
            }
            return e1;
        }
        const la = {
            center: "translate(-50%,-50%)",
            top: "translate(-50%,0)",
            "top-left": "translate(0,0)",
            "top-right": "translate(-100%,0)",
            bottom: "translate(-50%,-100%)",
            "bottom-left": "translate(0,-100%)",
            "bottom-right": "translate(-100%,-100%)",
            left: "translate(0,-50%)",
            right: "translate(-100%,-50%)"
        };
        function ca(t1, e1, i) {
            const o = t1.classList;
            for(const t2 in la)o.remove(`maplibregl-${i}-anchor-${t2}`, `mapboxgl-${i}-anchor-${t2}`);
            o.add(`maplibregl-${i}-anchor-${e1}`, `mapboxgl-${i}-anchor-${e1}`);
        }
        class ha extends t1.Evented {
            constructor(e1, i){
                if (super(), (e1 instanceof HTMLElement || i) && (e1 = t1.extend({
                    element: e1
                }, i)), t1.bindAll([
                    "_update",
                    "_onMove",
                    "_onUp",
                    "_addDragHandler",
                    "_onMapClick",
                    "_onKeyPress"
                ], this), this._anchor = e1 && e1.anchor || "center", this._color = e1 && e1.color || "#3FB1CE", this._scale = e1 && e1.scale || 1, this._draggable = e1 && e1.draggable || !1, this._clickTolerance = e1 && e1.clickTolerance || 0, this._isDragging = !1, this._state = "inactive", this._rotation = e1 && e1.rotation || 0, this._rotationAlignment = e1 && e1.rotationAlignment || "auto", this._pitchAlignment = e1 && e1.pitchAlignment && "auto" !== e1.pitchAlignment ? e1.pitchAlignment : this._rotationAlignment, e1 && e1.element) this._element = e1.element, this._offset = t1.pointGeometry.convert(e1 && e1.offset || [
                    0,
                    0
                ]);
                else {
                    this._defaultMarker = !0, this._element = r.create("div"), this._element.setAttribute("aria-label", "Map marker");
                    const i1 = r.createNS("http://www.w3.org/2000/svg", "svg"), o = 41, a = 27;
                    i1.setAttributeNS(null, "display", "block"), i1.setAttributeNS(null, "height", `${o}px`), i1.setAttributeNS(null, "width", `${a}px`), i1.setAttributeNS(null, "viewBox", `0 0 ${a} ${o}`);
                    const s = r.createNS("http://www.w3.org/2000/svg", "g");
                    s.setAttributeNS(null, "stroke", "none"), s.setAttributeNS(null, "stroke-width", "1"), s.setAttributeNS(null, "fill", "none"), s.setAttributeNS(null, "fill-rule", "evenodd");
                    const n = r.createNS("http://www.w3.org/2000/svg", "g");
                    n.setAttributeNS(null, "fill-rule", "nonzero");
                    const l = r.createNS("http://www.w3.org/2000/svg", "g");
                    l.setAttributeNS(null, "transform", "translate(3.0, 29.0)"), l.setAttributeNS(null, "fill", "#000000");
                    const c = [
                        {
                            rx: "10.5",
                            ry: "5.25002273"
                        },
                        {
                            rx: "10.5",
                            ry: "5.25002273"
                        },
                        {
                            rx: "9.5",
                            ry: "4.77275007"
                        },
                        {
                            rx: "8.5",
                            ry: "4.29549936"
                        },
                        {
                            rx: "7.5",
                            ry: "3.81822308"
                        },
                        {
                            rx: "6.5",
                            ry: "3.34094679"
                        },
                        {
                            rx: "5.5",
                            ry: "2.86367051"
                        },
                        {
                            rx: "4.5",
                            ry: "2.38636864"
                        }
                    ];
                    for (const t2 of c){
                        const e2 = r.createNS("http://www.w3.org/2000/svg", "ellipse");
                        e2.setAttributeNS(null, "opacity", "0.04"), e2.setAttributeNS(null, "cx", "10.5"), e2.setAttributeNS(null, "cy", "5.80029008"), e2.setAttributeNS(null, "rx", t2.rx), e2.setAttributeNS(null, "ry", t2.ry), l.appendChild(e2);
                    }
                    const h = r.createNS("http://www.w3.org/2000/svg", "g");
                    h.setAttributeNS(null, "fill", this._color);
                    const u = r.createNS("http://www.w3.org/2000/svg", "path");
                    u.setAttributeNS(null, "d", "M27,13.5 C27,19.074644 20.250001,27.000002 14.75,34.500002 C14.016665,35.500004 12.983335,35.500004 12.25,34.500002 C6.7499993,27.000002 0,19.222562 0,13.5 C0,6.0441559 6.0441559,0 13.5,0 C20.955844,0 27,6.0441559 27,13.5 Z"), h.appendChild(u);
                    const d = r.createNS("http://www.w3.org/2000/svg", "g");
                    d.setAttributeNS(null, "opacity", "0.25"), d.setAttributeNS(null, "fill", "#000000");
                    const m = r.createNS("http://www.w3.org/2000/svg", "path");
                    m.setAttributeNS(null, "d", "M13.5,0 C6.0441559,0 0,6.0441559 0,13.5 C0,19.222562 6.7499993,27 12.25,34.5 C13,35.522727 14.016664,35.500004 14.75,34.5 C20.250001,27 27,19.074644 27,13.5 C27,6.0441559 20.955844,0 13.5,0 Z M13.5,1 C20.415404,1 26,6.584596 26,13.5 C26,15.898657 24.495584,19.181431 22.220703,22.738281 C19.945823,26.295132 16.705119,30.142167 13.943359,33.908203 C13.743445,34.180814 13.612715,34.322738 13.5,34.441406 C13.387285,34.322738 13.256555,34.180814 13.056641,33.908203 C10.284481,30.127985 7.4148684,26.314159 5.015625,22.773438 C2.6163816,19.232715 1,15.953538 1,13.5 C1,6.584596 6.584596,1 13.5,1 Z"), d.appendChild(m);
                    const _ = r.createNS("http://www.w3.org/2000/svg", "g");
                    _.setAttributeNS(null, "transform", "translate(6.0, 7.0)"), _.setAttributeNS(null, "fill", "#FFFFFF");
                    const p = r.createNS("http://www.w3.org/2000/svg", "g");
                    p.setAttributeNS(null, "transform", "translate(8.0, 8.0)");
                    const f = r.createNS("http://www.w3.org/2000/svg", "circle");
                    f.setAttributeNS(null, "fill", "#000000"), f.setAttributeNS(null, "opacity", "0.25"), f.setAttributeNS(null, "cx", "5.5"), f.setAttributeNS(null, "cy", "5.5"), f.setAttributeNS(null, "r", "5.4999962");
                    const g = r.createNS("http://www.w3.org/2000/svg", "circle");
                    g.setAttributeNS(null, "fill", "#FFFFFF"), g.setAttributeNS(null, "cx", "5.5"), g.setAttributeNS(null, "cy", "5.5"), g.setAttributeNS(null, "r", "5.4999962"), p.appendChild(f), p.appendChild(g), n.appendChild(l), n.appendChild(h), n.appendChild(d), n.appendChild(_), n.appendChild(p), i1.appendChild(n), i1.setAttributeNS(null, "height", o * this._scale + "px"), i1.setAttributeNS(null, "width", a * this._scale + "px"), this._element.appendChild(i1), this._offset = t1.pointGeometry.convert(e1 && e1.offset || [
                        0,
                        -14
                    ]);
                }
                this._element.classList.add("maplibregl-marker", "mapboxgl-marker"), this._element.addEventListener("dragstart", (t1)=>{
                    t1.preventDefault();
                }), this._element.addEventListener("mousedown", (t1)=>{
                    t1.preventDefault();
                }), ca(this._element, this._anchor, "marker"), this._popup = null;
            }
            addTo(t1) {
                return this.remove(), this._map = t1, t1.getCanvasContainer().appendChild(this._element), t1.on("move", this._update), t1.on("moveend", this._update), this.setDraggable(this._draggable), this._update(), this._map.on("click", this._onMapClick), this;
            }
            remove() {
                return this._opacityTimeout && (clearTimeout(this._opacityTimeout), delete this._opacityTimeout), this._map && (this._map.off("click", this._onMapClick), this._map.off("move", this._update), this._map.off("moveend", this._update), this._map.off("mousedown", this._addDragHandler), this._map.off("touchstart", this._addDragHandler), this._map.off("mouseup", this._onUp), this._map.off("touchend", this._onUp), this._map.off("mousemove", this._onMove), this._map.off("touchmove", this._onMove), delete this._map), r.remove(this._element), this._popup && this._popup.remove(), this;
            }
            getLngLat() {
                return this._lngLat;
            }
            setLngLat(e1) {
                return this._lngLat = t1.LngLat.convert(e1), this._pos = null, this._popup && this._popup.setLngLat(this._lngLat), this._update(), this;
            }
            getElement() {
                return this._element;
            }
            setPopup(t1) {
                if (this._popup && (this._popup.remove(), this._popup = null, this._element.removeEventListener("keypress", this._onKeyPress), this._originalTabIndex || this._element.removeAttribute("tabindex")), t1) {
                    if (!("offset" in t1.options)) {
                        const e1 = 38.1, i = 13.5, o = Math.sqrt(Math.pow(i, 2) / 2);
                        t1.options.offset = this._defaultMarker ? {
                            top: [
                                0,
                                0
                            ],
                            "top-left": [
                                0,
                                0
                            ],
                            "top-right": [
                                0,
                                0
                            ],
                            bottom: [
                                0,
                                -e1
                            ],
                            "bottom-left": [
                                o,
                                -1 * (e1 - i + o)
                            ],
                            "bottom-right": [
                                -o,
                                -1 * (e1 - i + o)
                            ],
                            left: [
                                i,
                                -1 * (e1 - i)
                            ],
                            right: [
                                -i,
                                -1 * (e1 - i)
                            ]
                        } : this._offset;
                    }
                    this._popup = t1, this._lngLat && this._popup.setLngLat(this._lngLat), this._originalTabIndex = this._element.getAttribute("tabindex"), this._originalTabIndex || this._element.setAttribute("tabindex", "0"), this._element.addEventListener("keypress", this._onKeyPress);
                }
                return this;
            }
            _onKeyPress(t1) {
                const e1 = t1.code, i = t1.charCode || t1.keyCode;
                "Space" !== e1 && "Enter" !== e1 && 32 !== i && 13 !== i || this.togglePopup();
            }
            _onMapClick(t1) {
                const e1 = t1.originalEvent.target, i = this._element;
                this._popup && (e1 === i || i.contains(e1)) && this.togglePopup();
            }
            getPopup() {
                return this._popup;
            }
            togglePopup() {
                const t1 = this._popup;
                return t1 ? (t1.isOpen() ? t1.remove() : t1.addTo(this._map), this) : this;
            }
            _update(t1) {
                if (!this._map) return;
                this._map.transform.renderWorldCopies && (this._lngLat = na(this._lngLat, this._pos, this._map.transform)), this._pos = this._map.project(this._lngLat)._add(this._offset);
                let e1 = "";
                "viewport" === this._rotationAlignment || "auto" === this._rotationAlignment ? e1 = `rotateZ(${this._rotation}deg)` : "map" === this._rotationAlignment && (e1 = `rotateZ(${this._rotation - this._map.getBearing()}deg)`);
                let i = "";
                "viewport" === this._pitchAlignment || "auto" === this._pitchAlignment ? i = "rotateX(0deg)" : "map" === this._pitchAlignment && (i = `rotateX(${this._map.getPitch()}deg)`), t1 && "moveend" !== t1.type || (this._pos = this._pos.round()), r.setTransform(this._element, `${la[this._anchor]} translate(${this._pos.x}px, ${this._pos.y}px) ${i} ${e1}`), this._map.style && this._map.style.terrain && !this._opacityTimeout && (this._opacityTimeout = setTimeout(()=>{
                    const t1 = this._map.unproject(this._pos), e1 = 40075016.686 * Math.abs(Math.cos(this._lngLat.lat * Math.PI / 180)) / Math.pow(2, this._map.transform.tileZoom + 8);
                    this._element.style.opacity = t1.distanceTo(this._lngLat) > 20 * e1 ? "0.2" : "1.0", this._opacityTimeout = null;
                }, 100));
            }
            getOffset() {
                return this._offset;
            }
            setOffset(e1) {
                return this._offset = t1.pointGeometry.convert(e1), this._update(), this;
            }
            _onMove(e1) {
                if (!this._isDragging) {
                    const t2 = this._clickTolerance || this._map._clickTolerance;
                    this._isDragging = e1.point.dist(this._pointerdownPos) >= t2;
                }
                this._isDragging && (this._pos = e1.point.sub(this._positionDelta), this._lngLat = this._map.unproject(this._pos), this.setLngLat(this._lngLat), this._element.style.pointerEvents = "none", "pending" === this._state && (this._state = "active", this.fire(new t1.Event("dragstart"))), this.fire(new t1.Event("drag")));
            }
            _onUp() {
                this._element.style.pointerEvents = "auto", this._positionDelta = null, this._pointerdownPos = null, this._isDragging = !1, this._map.off("mousemove", this._onMove), this._map.off("touchmove", this._onMove), "active" === this._state && this.fire(new t1.Event("dragend")), this._state = "inactive";
            }
            _addDragHandler(t1) {
                this._element.contains(t1.originalEvent.target) && (t1.preventDefault(), this._positionDelta = t1.point.sub(this._pos).add(this._offset), this._pointerdownPos = t1.point, this._state = "pending", this._map.on("mousemove", this._onMove), this._map.on("touchmove", this._onMove), this._map.once("mouseup", this._onUp), this._map.once("touchend", this._onUp));
            }
            setDraggable(t1) {
                return this._draggable = !!t1, this._map && (t1 ? (this._map.on("mousedown", this._addDragHandler), this._map.on("touchstart", this._addDragHandler)) : (this._map.off("mousedown", this._addDragHandler), this._map.off("touchstart", this._addDragHandler))), this;
            }
            isDraggable() {
                return this._draggable;
            }
            setRotation(t1) {
                return this._rotation = t1 || 0, this._update(), this;
            }
            getRotation() {
                return this._rotation;
            }
            setRotationAlignment(t1) {
                return this._rotationAlignment = t1 || "auto", this._update(), this;
            }
            getRotationAlignment() {
                return this._rotationAlignment;
            }
            setPitchAlignment(t1) {
                return this._pitchAlignment = t1 && "auto" !== t1 ? t1 : this._rotationAlignment, this._update(), this;
            }
            getPitchAlignment() {
                return this._pitchAlignment;
            }
        }
        const ua = {
            positionOptions: {
                enableHighAccuracy: !1,
                maximumAge: 0,
                timeout: 6e3
            },
            fitBoundsOptions: {
                maxZoom: 15
            },
            trackUserLocation: !1,
            showAccuracyCircle: !0,
            showUserLocation: !0
        };
        let da, ma = 0, _a = !1;
        const pa = {
            maxWidth: 100,
            unit: "metric"
        };
        function fa(t1, e1, i) {
            const o = i && i.maxWidth || 100, a = t1._container.clientHeight / 2, r = t1.unproject([
                0,
                a
            ]), s = t1.unproject([
                o,
                a
            ]), n = r.distanceTo(s);
            if (i && "imperial" === i.unit) {
                const i1 = 3.2808 * n;
                i1 > 5280 ? ga(e1, o, i1 / 5280, t1._getUIString("ScaleControl.Miles")) : ga(e1, o, i1, t1._getUIString("ScaleControl.Feet"));
            } else i && "nautical" === i.unit ? ga(e1, o, n / 1852, t1._getUIString("ScaleControl.NauticalMiles")) : n >= 1e3 ? ga(e1, o, n / 1e3, t1._getUIString("ScaleControl.Kilometers")) : ga(e1, o, n, t1._getUIString("ScaleControl.Meters"));
        }
        function ga(t1, e1, i, o) {
            const a = function(t1) {
                const e1 = Math.pow(10, `${Math.floor(t1)}`.length - 1);
                let i = t1 / e1;
                return i = i >= 10 ? 10 : i >= 5 ? 5 : i >= 3 ? 3 : i >= 2 ? 2 : i >= 1 ? 1 : function(t1) {
                    const e1 = Math.pow(10, Math.ceil(-Math.log(t1) / Math.LN10));
                    return Math.round(t1 * e1) / e1;
                }(i), e1 * i;
            }(i);
            t1.style.width = e1 * (a / i) + "px", t1.innerHTML = `${a}&nbsp;${o}`;
        }
        const xa = {
            closeButton: !0,
            closeOnClick: !0,
            focusAfterOpen: !0,
            className: "",
            maxWidth: "240px"
        }, va = [
            "a[href]",
            "[tabindex]:not([tabindex='-1'])",
            "[contenteditable]:not([contenteditable='false'])",
            "button:not([disabled])",
            "input:not([disabled])",
            "select:not([disabled])",
            "textarea:not([disabled])"
        ].join(", ");
        function ya(e1) {
            if (e1) {
                if ("number" == typeof e1) {
                    const i = Math.round(Math.sqrt(.5 * Math.pow(e1, 2)));
                    return {
                        center: new t1.pointGeometry(0, 0),
                        top: new t1.pointGeometry(0, e1),
                        "top-left": new t1.pointGeometry(i, i),
                        "top-right": new t1.pointGeometry(-i, i),
                        bottom: new t1.pointGeometry(0, -e1),
                        "bottom-left": new t1.pointGeometry(i, -i),
                        "bottom-right": new t1.pointGeometry(-i, -i),
                        left: new t1.pointGeometry(e1, 0),
                        right: new t1.pointGeometry(-e1, 0)
                    };
                }
                if (e1 instanceof t1.pointGeometry || Array.isArray(e1)) {
                    const i1 = t1.pointGeometry.convert(e1);
                    return {
                        center: i1,
                        top: i1,
                        "top-left": i1,
                        "top-right": i1,
                        bottom: i1,
                        "bottom-left": i1,
                        "bottom-right": i1,
                        left: i1,
                        right: i1
                    };
                }
                return {
                    center: t1.pointGeometry.convert(e1.center || [
                        0,
                        0
                    ]),
                    top: t1.pointGeometry.convert(e1.top || [
                        0,
                        0
                    ]),
                    "top-left": t1.pointGeometry.convert(e1["top-left"] || [
                        0,
                        0
                    ]),
                    "top-right": t1.pointGeometry.convert(e1["top-right"] || [
                        0,
                        0
                    ]),
                    bottom: t1.pointGeometry.convert(e1.bottom || [
                        0,
                        0
                    ]),
                    "bottom-left": t1.pointGeometry.convert(e1["bottom-left"] || [
                        0,
                        0
                    ]),
                    "bottom-right": t1.pointGeometry.convert(e1["bottom-right"] || [
                        0,
                        0
                    ]),
                    left: t1.pointGeometry.convert(e1.left || [
                        0,
                        0
                    ]),
                    right: t1.pointGeometry.convert(e1.right || [
                        0,
                        0
                    ])
                };
            }
            return ya(new t1.pointGeometry(0, 0));
        }
        const ba = {
            supported: e1,
            setRTLTextPlugin: t1.setRTLTextPlugin,
            getRTLTextPluginStatus: t1.getRTLTextPluginStatus,
            Map: class extends Qo {
                constructor(e1){
                    var i;
                    if (t1.PerformanceUtils.mark(t1.PerformanceMarkers.create), null != (e1 = t1.extend({}, aa, e1)).minZoom && null != e1.maxZoom && e1.minZoom > e1.maxZoom) throw new Error("maxZoom must be greater than or equal to minZoom");
                    if (null != e1.minPitch && null != e1.maxPitch && e1.minPitch > e1.maxPitch) throw new Error("maxPitch must be greater than or equal to minPitch");
                    if (null != e1.minPitch && e1.minPitch < 0) throw new Error("minPitch must be greater than or equal to 0");
                    if (null != e1.maxPitch && e1.maxPitch > 85) throw new Error("maxPitch must be less than or equal to 85");
                    if (super(new io(e1.minZoom, e1.maxZoom, e1.minPitch, e1.maxPitch, e1.renderWorldCopies), {
                        bearingSnap: e1.bearingSnap
                    }), this._interactive = e1.interactive, this._cooperativeGestures = e1.cooperativeGestures, this._maxTileCacheSize = e1.maxTileCacheSize, this._failIfMajorPerformanceCaveat = e1.failIfMajorPerformanceCaveat, this._preserveDrawingBuffer = e1.preserveDrawingBuffer, this._antialias = e1.antialias, this._trackResize = e1.trackResize, this._bearingSnap = e1.bearingSnap, this._refreshExpiredTiles = e1.refreshExpiredTiles, this._fadeDuration = e1.fadeDuration, this._crossSourceCollisions = e1.crossSourceCollisions, this._crossFadingFactor = 1, this._collectResourceTiming = e1.collectResourceTiming, this._renderTaskQueue = new ia, this._controls = [], this._mapId = t1.uniqueId(), this._locale = t1.extend({}, oa, e1.locale), this._clickTolerance = e1.clickTolerance, this._pixelRatio = null !== (i = e1.pixelRatio) && void 0 !== i ? i : devicePixelRatio, this._requestManager = new s(e1.transformRequest), "string" == typeof e1.container) {
                        if (this._container = document.getElementById(e1.container), !this._container) throw new Error(`Container '${e1.container}' not found.`);
                    } else {
                        if (!(e1.container instanceof HTMLElement)) throw new Error("Invalid type: 'container' must be a String or HTMLElement.");
                        this._container = e1.container;
                    }
                    if (e1.maxBounds && this.setMaxBounds(e1.maxBounds), t1.bindAll([
                        "_onWindowOnline",
                        "_onWindowResize",
                        "_onMapScroll",
                        "_contextLost",
                        "_contextRestored"
                    ], this), this._setupContainer(), this._setupPainter(), void 0 === this.painter) throw new Error("Failed to initialize WebGL.");
                    this.on("move", ()=>this._update(!1)), this.on("moveend", ()=>this._update(!1)), this.on("zoom", ()=>this._update(!0)), this.on("terrain", ()=>{
                        this.painter.terrainFacilitator.dirty = !0, this._update(!0);
                    }), "undefined" != typeof window && (addEventListener("online", this._onWindowOnline, !1), addEventListener("resize", this._onWindowResize, !1), addEventListener("orientationchange", this._onWindowResize, !1)), this.handlers = new Yo(this, e1), this._cooperativeGestures && this._setupCooperativeGestures(), this._hash = e1.hash && new oo("string" == typeof e1.hash && e1.hash || void 0).addTo(this), this._hash && this._hash._onHashChange() || (this.jumpTo({
                        center: e1.center,
                        zoom: e1.zoom,
                        bearing: e1.bearing,
                        pitch: e1.pitch
                    }), e1.bounds && (this.resize(), this.fitBounds(e1.bounds, t1.extend({}, e1.fitBoundsOptions, {
                        duration: 0
                    })))), this.resize(), this._localIdeographFontFamily = e1.localIdeographFontFamily, e1.style && this.setStyle(e1.style, {
                        localIdeographFontFamily: e1.localIdeographFontFamily
                    }), e1.attributionControl && this.addControl(new ta({
                        customAttribution: e1.customAttribution
                    })), e1.maplibreLogo && this.addControl(new ea, e1.logoPosition), this.on("style.load", ()=>{
                        this.transform.unmodified && this.jumpTo(this.style.stylesheet);
                    }), this.on("data", (e1)=>{
                        this._update("style" === e1.dataType), this.fire(new t1.Event(`${e1.dataType}data`, e1));
                    }), this.on("dataloading", (e1)=>{
                        this.fire(new t1.Event(`${e1.dataType}dataloading`, e1));
                    }), this.on("dataabort", (e1)=>{
                        this.fire(new t1.Event("sourcedataabort", e1));
                    });
                }
                _getMapId() {
                    return this._mapId;
                }
                addControl(e1, i) {
                    if (void 0 === i && (i = e1.getDefaultPosition ? e1.getDefaultPosition() : "top-right"), !e1 || !e1.onAdd) return this.fire(new t1.ErrorEvent(new Error("Invalid argument to map.addControl(). Argument must be a control with onAdd and onRemove methods.")));
                    const o = e1.onAdd(this);
                    this._controls.push(e1);
                    const a = this._controlPositions[i];
                    return -1 !== i.indexOf("bottom") ? a.insertBefore(o, a.firstChild) : a.appendChild(o), this;
                }
                removeControl(e1) {
                    if (!e1 || !e1.onRemove) return this.fire(new t1.ErrorEvent(new Error("Invalid argument to map.removeControl(). Argument must be a control with onAdd and onRemove methods.")));
                    const i = this._controls.indexOf(e1);
                    return i > -1 && this._controls.splice(i, 1), e1.onRemove(this), this;
                }
                hasControl(t1) {
                    return this._controls.indexOf(t1) > -1;
                }
                calculateCameraOptionsFromTo(t1, e1, i, o) {
                    return null == o && this.style.terrain && (o = this.transform.getElevation(i, this.style.terrain)), super.calculateCameraOptionsFromTo(t1, e1, i, o);
                }
                resize(e1) {
                    const i = this._containerDimensions(), o = i[0], a = i[1];
                    this._resizeCanvas(o, a, this.getPixelRatio()), this.transform.resize(o, a), this.painter.resize(o, a, this.getPixelRatio());
                    const r = !this._moving;
                    return r && (this.stop(), this.fire(new t1.Event("movestart", e1)).fire(new t1.Event("move", e1))), this.fire(new t1.Event("resize", e1)), r && this.fire(new t1.Event("moveend", e1)), this;
                }
                getPixelRatio() {
                    return this._pixelRatio;
                }
                setPixelRatio(t1) {
                    const [e1, i] = this._containerDimensions();
                    this._pixelRatio = t1, this._resizeCanvas(e1, i, t1), this.painter.resize(e1, i, t1);
                }
                getBounds() {
                    return this.transform.getBounds();
                }
                getMaxBounds() {
                    return this.transform.getMaxBounds();
                }
                setMaxBounds(e1) {
                    return this.transform.setMaxBounds(t1.LngLatBounds.convert(e1)), this._update();
                }
                setMinZoom(t1) {
                    if ((t1 = null == t1 ? -2 : t1) >= -2 && t1 <= this.transform.maxZoom) return this.transform.minZoom = t1, this._update(), this.getZoom() < t1 && this.setZoom(t1), this;
                    throw new Error("minZoom must be between -2 and the current maxZoom, inclusive");
                }
                getMinZoom() {
                    return this.transform.minZoom;
                }
                setMaxZoom(t1) {
                    if ((t1 = null == t1 ? 22 : t1) >= this.transform.minZoom) return this.transform.maxZoom = t1, this._update(), this.getZoom() > t1 && this.setZoom(t1), this;
                    throw new Error("maxZoom must be greater than the current minZoom");
                }
                getMaxZoom() {
                    return this.transform.maxZoom;
                }
                setMinPitch(t1) {
                    if ((t1 = null == t1 ? 0 : t1) < 0) throw new Error("minPitch must be greater than or equal to 0");
                    if (t1 >= 0 && t1 <= this.transform.maxPitch) return this.transform.minPitch = t1, this._update(), this.getPitch() < t1 && this.setPitch(t1), this;
                    throw new Error("minPitch must be between 0 and the current maxPitch, inclusive");
                }
                getMinPitch() {
                    return this.transform.minPitch;
                }
                setMaxPitch(t1) {
                    if ((t1 = null == t1 ? 60 : t1) > 85) throw new Error("maxPitch must be less than or equal to 85");
                    if (t1 >= this.transform.minPitch) return this.transform.maxPitch = t1, this._update(), this.getPitch() > t1 && this.setPitch(t1), this;
                    throw new Error("maxPitch must be greater than the current minPitch");
                }
                getMaxPitch() {
                    return this.transform.maxPitch;
                }
                getRenderWorldCopies() {
                    return this.transform.renderWorldCopies;
                }
                setRenderWorldCopies(t1) {
                    return this.transform.renderWorldCopies = t1, this._update();
                }
                project(e1) {
                    return this.transform.locationPoint(t1.LngLat.convert(e1), this.style && this.style.terrain);
                }
                unproject(e1) {
                    return this.transform.pointLocation(t1.pointGeometry.convert(e1), this.style && this.style.terrain);
                }
                isMoving() {
                    return this._moving || this.handlers.isMoving();
                }
                isZooming() {
                    return this._zooming || this.handlers.isZooming();
                }
                isRotating() {
                    return this._rotating || this.handlers.isRotating();
                }
                _createDelegatedListener(t1, e1, i) {
                    if ("mouseenter" === t1 || "mouseover" === t1) {
                        let o = !1;
                        const a = (a)=>{
                            const r = this.getLayer(e1) ? this.queryRenderedFeatures(a.point, {
                                layers: [
                                    e1
                                ]
                            }) : [];
                            r.length ? o || (o = !0, i.call(this, new mo(t1, this, a.originalEvent, {
                                features: r
                            }))) : o = !1;
                        };
                        return {
                            layer: e1,
                            listener: i,
                            delegates: {
                                mousemove: a,
                                mouseout: ()=>{
                                    o = !1;
                                }
                            }
                        };
                    }
                    if ("mouseleave" === t1 || "mouseout" === t1) {
                        let o1 = !1;
                        const a1 = (a)=>{
                            (this.getLayer(e1) ? this.queryRenderedFeatures(a.point, {
                                layers: [
                                    e1
                                ]
                            }) : []).length ? o1 = !0 : o1 && (o1 = !1, i.call(this, new mo(t1, this, a.originalEvent)));
                        }, r = (e1)=>{
                            o1 && (o1 = !1, i.call(this, new mo(t1, this, e1.originalEvent)));
                        };
                        return {
                            layer: e1,
                            listener: i,
                            delegates: {
                                mousemove: a1,
                                mouseout: r
                            }
                        };
                    }
                    {
                        const o2 = (t1)=>{
                            const o = this.getLayer(e1) ? this.queryRenderedFeatures(t1.point, {
                                layers: [
                                    e1
                                ]
                            }) : [];
                            o.length && (t1.features = o, i.call(this, t1), delete t1.features);
                        };
                        return {
                            layer: e1,
                            listener: i,
                            delegates: {
                                [t1]: o2
                            }
                        };
                    }
                }
                on(t1, e1, i) {
                    if (void 0 === i) return super.on(t1, e1);
                    const o = this._createDelegatedListener(t1, e1, i);
                    this._delegatedListeners = this._delegatedListeners || {}, this._delegatedListeners[t1] = this._delegatedListeners[t1] || [], this._delegatedListeners[t1].push(o);
                    for(const t2 in o.delegates)this.on(t2, o.delegates[t2]);
                    return this;
                }
                once(t1, e1, i) {
                    if (void 0 === i) return super.once(t1, e1);
                    const o = this._createDelegatedListener(t1, e1, i);
                    for(const t2 in o.delegates)this.once(t2, o.delegates[t2]);
                    return this;
                }
                off(t1, e1, i) {
                    return void 0 === i ? super.off(t1, e1) : (this._delegatedListeners && this._delegatedListeners[t1] && ((o)=>{
                        const a = this._delegatedListeners[t1];
                        for(let t2 = 0; t2 < a.length; t2++){
                            const o1 = a[t2];
                            if (o1.layer === e1 && o1.listener === i) {
                                for(const t3 in o1.delegates)this.off(t3, o1.delegates[t3]);
                                return a.splice(t2, 1), this;
                            }
                        }
                    })(), this);
                }
                queryRenderedFeatures(e1, i) {
                    if (!this.style) return [];
                    let o;
                    if (void 0 !== i || void 0 === e1 || e1 instanceof t1.pointGeometry || Array.isArray(e1) || (i = e1, e1 = void 0), i = i || {}, (e1 = e1 || [
                        [
                            0,
                            0
                        ],
                        [
                            this.transform.width,
                            this.transform.height
                        ]
                    ]) instanceof t1.pointGeometry || "number" == typeof e1[0]) o = [
                        t1.pointGeometry.convert(e1)
                    ];
                    else {
                        const i1 = t1.pointGeometry.convert(e1[0]), a = t1.pointGeometry.convert(e1[1]);
                        o = [
                            i1,
                            new t1.pointGeometry(a.x, i1.y),
                            a,
                            new t1.pointGeometry(i1.x, a.y),
                            i1
                        ];
                    }
                    return this.style.queryRenderedFeatures(o, i, this.transform);
                }
                querySourceFeatures(t1, e1) {
                    return this.style.querySourceFeatures(t1, e1);
                }
                setStyle(e1, i) {
                    return !1 !== (i = t1.extend({}, {
                        localIdeographFontFamily: this._localIdeographFontFamily
                    }, i)).diff && i.localIdeographFontFamily === this._localIdeographFontFamily && this.style && e1 ? (this._diffStyle(e1, i), this) : (this._localIdeographFontFamily = i.localIdeographFontFamily, this._updateStyle(e1, i));
                }
                setTransformRequest(t1) {
                    return this._requestManager.setTransformRequest(t1), this;
                }
                _getUIString(t1) {
                    const e1 = this._locale[t1];
                    if (null == e1) throw new Error(`Missing UI string '${t1}'`);
                    return e1;
                }
                _updateStyle(t1, e1) {
                    return this.style && (this.style.setEventedParent(null), this.style._remove()), t1 ? (this.style = new ee(this, e1 || {}), this.style.setEventedParent(this, {
                        style: this.style
                    }), "string" == typeof t1 ? this.style.loadURL(t1) : this.style.loadJSON(t1), this) : (delete this.style, this);
                }
                _lazyInitEmptyStyle() {
                    this.style || (this.style = new ee(this, {}), this.style.setEventedParent(this, {
                        style: this.style
                    }), this.style.loadEmpty());
                }
                _diffStyle(e1, i) {
                    if ("string" == typeof e1) {
                        const o = this._requestManager.transformRequest(e1, t1.ResourceType.Style);
                        t1.getJSON(o, (e1, o)=>{
                            e1 ? this.fire(new t1.ErrorEvent(e1)) : o && this._updateDiff(o, i);
                        });
                    } else "object" == typeof e1 && this._updateDiff(e1, i);
                }
                _updateDiff(e1, i) {
                    try {
                        this.style.setState(e1) && this._update(!0);
                    } catch (o) {
                        t1.warnOnce(`Unable to perform style diff: ${o.message || o.error || o}.  Rebuilding the style from scratch.`), this._updateStyle(e1, i);
                    }
                }
                getStyle() {
                    if (this.style) return this.style.serialize();
                }
                isStyleLoaded() {
                    return this.style ? this.style.loaded() : t1.warnOnce("There is no style added to the map.");
                }
                addSource(t1, e1) {
                    return this._lazyInitEmptyStyle(), this.style.addSource(t1, e1), this._update(!0);
                }
                isSourceLoaded(e1) {
                    const i = this.style && this.style.sourceCaches[e1];
                    if (void 0 !== i) return i.loaded();
                    this.fire(new t1.ErrorEvent(new Error(`There is no source with ID '${e1}'`)));
                }
                setTerrain(t1) {
                    return this.style.setTerrain(t1), this;
                }
                getTerrain() {
                    return this.style.terrain && this.style.terrain.options;
                }
                areTilesLoaded() {
                    const t1 = this.style && this.style.sourceCaches;
                    for(const e1 in t1){
                        const i = t1[e1]._tiles;
                        for(const t2 in i){
                            const e2 = i[t2];
                            if ("loaded" !== e2.state && "errored" !== e2.state) return !1;
                        }
                    }
                    return !0;
                }
                addSourceType(t1, e1, i) {
                    return this._lazyInitEmptyStyle(), this.style.addSourceType(t1, e1, i);
                }
                removeSource(t1) {
                    return this.style.removeSource(t1), this._update(!0);
                }
                getSource(t1) {
                    return this.style.getSource(t1);
                }
                addImage(e1, i, { pixelRatio: o = 1 , sdf: a = !1 , stretchX: r , stretchY: s , content: n  } = {}) {
                    if (this._lazyInitEmptyStyle(), i instanceof HTMLImageElement || t1.isImageBitmap(i)) {
                        const { width: l , height: c , data: h  } = t1.exported.getImageData(i);
                        this.style.addImage(e1, {
                            data: new t1.RGBAImage({
                                width: l,
                                height: c
                            }, h),
                            pixelRatio: o,
                            stretchX: r,
                            stretchY: s,
                            content: n,
                            sdf: a,
                            version: 0
                        });
                    } else {
                        if (void 0 === i.width || void 0 === i.height) return this.fire(new t1.ErrorEvent(new Error("Invalid arguments to map.addImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));
                        {
                            const { width: l1 , height: c1 , data: h1  } = i, u = i;
                            this.style.addImage(e1, {
                                data: new t1.RGBAImage({
                                    width: l1,
                                    height: c1
                                }, new Uint8Array(h1)),
                                pixelRatio: o,
                                stretchX: r,
                                stretchY: s,
                                content: n,
                                sdf: a,
                                version: 0,
                                userImage: u
                            }), u.onAdd && u.onAdd(this, e1);
                        }
                    }
                }
                updateImage(e1, i) {
                    const o = this.style.getImage(e1);
                    if (!o) return this.fire(new t1.ErrorEvent(new Error("The map has no image with that id. If you are adding a new image use `map.addImage(...)` instead.")));
                    const a = i instanceof HTMLImageElement || t1.isImageBitmap(i) ? t1.exported.getImageData(i) : i, { width: r , height: s , data: n  } = a;
                    if (void 0 === r || void 0 === s) return this.fire(new t1.ErrorEvent(new Error("Invalid arguments to map.updateImage(). The second argument must be an `HTMLImageElement`, `ImageData`, `ImageBitmap`, or object with `width`, `height`, and `data` properties with the same format as `ImageData`")));
                    if (r !== o.data.width || s !== o.data.height) return this.fire(new t1.ErrorEvent(new Error("The width and height of the updated image must be that same as the previous version of the image")));
                    const l = !(i instanceof HTMLImageElement || t1.isImageBitmap(i));
                    o.data.replace(n, l), this.style.updateImage(e1, o);
                }
                hasImage(e1) {
                    return e1 ? !!this.style.getImage(e1) : (this.fire(new t1.ErrorEvent(new Error("Missing required image id"))), !1);
                }
                removeImage(t1) {
                    this.style.removeImage(t1);
                }
                loadImage(e1, i) {
                    t1.getImage(this._requestManager.transformRequest(e1, t1.ResourceType.Image), i);
                }
                listImages() {
                    return this.style.listImages();
                }
                addLayer(t1, e1) {
                    return this._lazyInitEmptyStyle(), this.style.addLayer(t1, e1), this._update(!0);
                }
                moveLayer(t1, e1) {
                    return this.style.moveLayer(t1, e1), this._update(!0);
                }
                removeLayer(t1) {
                    return this.style.removeLayer(t1), this._update(!0);
                }
                getLayer(t1) {
                    return this.style.getLayer(t1);
                }
                setLayerZoomRange(t1, e1, i) {
                    return this.style.setLayerZoomRange(t1, e1, i), this._update(!0);
                }
                setFilter(t1, e1, i = {}) {
                    return this.style.setFilter(t1, e1, i), this._update(!0);
                }
                getFilter(t1) {
                    return this.style.getFilter(t1);
                }
                setPaintProperty(t1, e1, i, o = {}) {
                    return this.style.setPaintProperty(t1, e1, i, o), this._update(!0);
                }
                getPaintProperty(t1, e1) {
                    return this.style.getPaintProperty(t1, e1);
                }
                setLayoutProperty(t1, e1, i, o = {}) {
                    return this.style.setLayoutProperty(t1, e1, i, o), this._update(!0);
                }
                getLayoutProperty(t1, e1) {
                    return this.style.getLayoutProperty(t1, e1);
                }
                setLight(t1, e1 = {}) {
                    return this._lazyInitEmptyStyle(), this.style.setLight(t1, e1), this._update(!0);
                }
                getLight() {
                    return this.style.getLight();
                }
                setFeatureState(t1, e1) {
                    return this.style.setFeatureState(t1, e1), this._update();
                }
                removeFeatureState(t1, e1) {
                    return this.style.removeFeatureState(t1, e1), this._update();
                }
                getFeatureState(t1) {
                    return this.style.getFeatureState(t1);
                }
                getContainer() {
                    return this._container;
                }
                getCanvasContainer() {
                    return this._canvasContainer;
                }
                getCanvas() {
                    return this._canvas;
                }
                _containerDimensions() {
                    let t1 = 0, e1 = 0;
                    return this._container && (t1 = this._container.clientWidth || 400, e1 = this._container.clientHeight || 300), [
                        t1,
                        e1
                    ];
                }
                _setupContainer() {
                    const t1 = this._container;
                    t1.classList.add("maplibregl-map", "mapboxgl-map");
                    const e1 = this._canvasContainer = r.create("div", "maplibregl-canvas-container mapboxgl-canvas-container", t1);
                    this._interactive && e1.classList.add("maplibregl-interactive", "mapboxgl-interactive"), this._canvas = r.create("canvas", "maplibregl-canvas mapboxgl-canvas", e1), this._canvas.addEventListener("webglcontextlost", this._contextLost, !1), this._canvas.addEventListener("webglcontextrestored", this._contextRestored, !1), this._canvas.setAttribute("tabindex", "0"), this._canvas.setAttribute("aria-label", "Map"), this._canvas.setAttribute("role", "region");
                    const i = this._containerDimensions();
                    this._resizeCanvas(i[0], i[1], this.getPixelRatio());
                    const o = this._controlContainer = r.create("div", "maplibregl-control-container mapboxgl-control-container", t1), a = this._controlPositions = {};
                    [
                        "top-left",
                        "top-right",
                        "bottom-left",
                        "bottom-right"
                    ].forEach((t1)=>{
                        a[t1] = r.create("div", `maplibregl-ctrl-${t1} mapboxgl-ctrl-${t1}`, o);
                    }), this._container.addEventListener("scroll", this._onMapScroll, !1);
                }
                _setupCooperativeGestures() {
                    const t1 = this._container;
                    this._metaPress = !1, this._cooperativeGesturesScreen = r.create("div", "maplibregl-cooperative-gesture-screen", t1);
                    let e1 = "Control", i = "boolean" != typeof this._cooperativeGestures && this._cooperativeGestures.windowsHelpText ? this._cooperativeGestures.windowsHelpText : "Use Ctrl + scroll to zoom the map";
                    0 === navigator.platform.indexOf("Mac") && (i = "boolean" != typeof this._cooperativeGestures && this._cooperativeGestures.macHelpText ? this._cooperativeGestures.macHelpText : "Use ⌘ + scroll to zoom the map", e1 = "Meta"), this._cooperativeGesturesScreen.innerHTML = `\n            <div class="maplibregl-desktop-message">${i}</div>\n            <div class="maplibregl-mobile-message">${"boolean" != typeof this._cooperativeGestures && this._cooperativeGestures.mobileHelpText ? this._cooperativeGestures.mobileHelpText : "Use two fingers to move the map"}</div>\n        `, document.addEventListener("keydown", (t1)=>{
                        t1.key === e1 && (this._metaPress = !0);
                    }), document.addEventListener("keyup", (t1)=>{
                        t1.key === e1 && (this._metaPress = !1);
                    }), this._canvasContainer.addEventListener("wheel", (t1)=>{
                        this._onCooperativeGesture(t1, this._metaPress, 1);
                    }, !1), this._canvasContainer.classList.remove("mapboxgl-touch-drag-pan", "maplibregl-touch-drag-pan");
                }
                _resizeCanvas(t1, e1, i) {
                    this._canvas.width = i * t1, this._canvas.height = i * e1, this._canvas.style.width = `${t1}px`, this._canvas.style.height = `${e1}px`;
                }
                _setupPainter() {
                    const i = t1.extend({}, e1.webGLContextAttributes, {
                        failIfMajorPerformanceCaveat: this._failIfMajorPerformanceCaveat,
                        preserveDrawingBuffer: this._preserveDrawingBuffer,
                        antialias: this._antialias || !1
                    }), o = this._canvas.getContext("webgl", i) || this._canvas.getContext("experimental-webgl", i);
                    o ? (this.painter = new Ji(o, this.transform), t1.exported$1.testSupport(o)) : this.fire(new t1.ErrorEvent(new Error("Failed to initialize WebGL")));
                }
                _contextLost(e1) {
                    e1.preventDefault(), this._frame && (this._frame.cancel(), this._frame = null), this.fire(new t1.Event("webglcontextlost", {
                        originalEvent: e1
                    }));
                }
                _contextRestored(e1) {
                    this._setupPainter(), this.resize(), this._update(), this.fire(new t1.Event("webglcontextrestored", {
                        originalEvent: e1
                    }));
                }
                _onMapScroll(t1) {
                    if (t1.target === this._container) return this._container.scrollTop = 0, this._container.scrollLeft = 0, !1;
                }
                _onCooperativeGesture(t1, e1, i) {
                    return !e1 && i < 2 && (this._cooperativeGesturesScreen.classList.add("maplibregl-show"), setTimeout(()=>{
                        this._cooperativeGesturesScreen.classList.remove("maplibregl-show");
                    }, 100)), !1;
                }
                loaded() {
                    return !this._styleDirty && !this._sourcesDirty && !!this.style && this.style.loaded();
                }
                _update(t1) {
                    return this.style ? (this._styleDirty = this._styleDirty || t1, this._sourcesDirty = !0, this.triggerRepaint(), this) : this;
                }
                _requestRenderFrame(t1) {
                    return this._update(), this._renderTaskQueue.add(t1);
                }
                _cancelRenderFrame(t1) {
                    this._renderTaskQueue.remove(t1);
                }
                _render(e1) {
                    let i, o = 0;
                    const a = this.painter.context.extTimerQuery;
                    if (this.listens("gpu-timing-frame") && (i = a.createQueryEXT(), a.beginQueryEXT(a.TIME_ELAPSED_EXT, i), o = t1.exported.now()), this.painter.context.setDirty(), this.painter.setBaseState(), this._renderTaskQueue.run(e1), this._removed) return;
                    let r = !1;
                    if (this.style && this._styleDirty) {
                        this._styleDirty = !1;
                        const e2 = this.transform.zoom, i1 = t1.exported.now();
                        this.style.zoomHistory.update(e2, i1);
                        const o1 = new t1.EvaluationParameters(e2, {
                            now: i1,
                            fadeDuration: this._fadeDuration,
                            zoomHistory: this.style.zoomHistory,
                            transition: this.style.getTransition()
                        }), a1 = o1.crossFadingFactor();
                        1 === a1 && a1 === this._crossFadingFactor || (r = !0, this._crossFadingFactor = a1), this.style.update(o1);
                    }
                    if (this.style && this._sourcesDirty && (this._sourcesDirty = !1, this.style._updateSources(this.transform)), this.style.terrain && this.style.terrain.sourceCache.update(this.transform, this.style.terrain), this.transform.updateElevation(this.style.terrain), this._placementDirty = this.style && this.style._updatePlacement(this.painter.transform, this.showCollisionBoxes, this._fadeDuration, this._crossSourceCollisions), this.painter.render(this.style, {
                        showTileBoundaries: this.showTileBoundaries,
                        showOverdrawInspector: this._showOverdrawInspector,
                        rotating: this.isRotating(),
                        zooming: this.isZooming(),
                        moving: this.isMoving(),
                        fadeDuration: this._fadeDuration,
                        showPadding: this.showPadding,
                        gpuTiming: !!this.listens("gpu-timing-layer")
                    }), this.fire(new t1.Event("render")), this.loaded() && !this._loaded && (this._loaded = !0, t1.PerformanceUtils.mark(t1.PerformanceMarkers.load), this.fire(new t1.Event("load"))), this.style && (this.style.hasTransitions() || r) && (this._styleDirty = !0), this.style && !this._placementDirty && this.style._releaseSymbolFadeTiles(), this.listens("gpu-timing-frame")) {
                        const e3 = t1.exported.now() - o;
                        a.endQueryEXT(a.TIME_ELAPSED_EXT, i), setTimeout(()=>{
                            const o = a.getQueryObjectEXT(i, a.QUERY_RESULT_EXT) / 1e6;
                            a.deleteQueryEXT(i), this.fire(new t1.Event("gpu-timing-frame", {
                                cpuTime: e3,
                                gpuTime: o
                            }));
                        }, 50);
                    }
                    if (this.listens("gpu-timing-layer")) {
                        const e4 = this.painter.collectGpuTimers();
                        setTimeout(()=>{
                            const i = this.painter.queryGpuTimers(e4);
                            this.fire(new t1.Event("gpu-timing-layer", {
                                layerTimes: i
                            }));
                        }, 50);
                    }
                    const s = this._sourcesDirty || this._styleDirty || this._placementDirty;
                    return s || this._repaint ? this.triggerRepaint() : !this.isMoving() && this.loaded() && this.fire(new t1.Event("idle")), !this._loaded || this._fullyLoaded || s || (this._fullyLoaded = !0, t1.PerformanceUtils.mark(t1.PerformanceMarkers.fullLoad)), this;
                }
                redraw() {
                    return this.style && (this._frame && (this._frame.cancel(), this._frame = null), this._render(0)), this;
                }
                remove() {
                    this._hash && this._hash.remove();
                    for (const t2 of this._controls)t2.onRemove(this);
                    this._controls = [], this._frame && (this._frame.cancel(), this._frame = null), this._renderTaskQueue.clear(), this.painter.destroy(), this.handlers.destroy(), delete this.handlers, this.setStyle(null), "undefined" != typeof window && (removeEventListener("resize", this._onWindowResize, !1), removeEventListener("orientationchange", this._onWindowResize, !1), removeEventListener("online", this._onWindowOnline, !1));
                    const e1 = this.painter.context.gl.getExtension("WEBGL_lose_context");
                    e1 && e1.loseContext(), this._canvas.removeEventListener("webglcontextrestored", this._contextRestored, !1), this._canvas.removeEventListener("webglcontextlost", this._contextLost, !1), r.remove(this._canvasContainer), r.remove(this._controlContainer), this._cooperativeGestures && r.remove(this._cooperativeGesturesScreen), this._container.classList.remove("maplibregl-map", "mapboxgl-map"), t1.PerformanceUtils.clearMetrics(), this._removed = !0, this.fire(new t1.Event("remove"));
                }
                triggerRepaint() {
                    this.style && !this._frame && (this._frame = t1.exported.frame((e1)=>{
                        t1.PerformanceUtils.frame(e1), this._frame = null, this._render(e1);
                    }));
                }
                _onWindowOnline() {
                    this._update();
                }
                _onWindowResize(t1) {
                    this._trackResize && this.resize({
                        originalEvent: t1
                    })._update();
                }
                get showTileBoundaries() {
                    return !!this._showTileBoundaries;
                }
                set showTileBoundaries(t1) {
                    this._showTileBoundaries !== t1 && (this._showTileBoundaries = t1, this._update());
                }
                get showPadding() {
                    return !!this._showPadding;
                }
                set showPadding(t1) {
                    this._showPadding !== t1 && (this._showPadding = t1, this._update());
                }
                get showCollisionBoxes() {
                    return !!this._showCollisionBoxes;
                }
                set showCollisionBoxes(t1) {
                    this._showCollisionBoxes !== t1 && (this._showCollisionBoxes = t1, t1 ? this.style._generateCollisionBoxes() : this._update());
                }
                get showOverdrawInspector() {
                    return !!this._showOverdrawInspector;
                }
                set showOverdrawInspector(t1) {
                    this._showOverdrawInspector !== t1 && (this._showOverdrawInspector = t1, this._update());
                }
                get repaint() {
                    return !!this._repaint;
                }
                set repaint(t1) {
                    this._repaint !== t1 && (this._repaint = t1, this.triggerRepaint());
                }
                get vertices() {
                    return !!this._vertices;
                }
                set vertices(t1) {
                    this._vertices = t1, this._update();
                }
                _setCacheLimits(e1, i) {
                    t1.setCacheLimits(e1, i);
                }
                get version() {
                    return "2.4.0";
                }
            },
            NavigationControl: class {
                constructor(e1){
                    this.options = t1.extend({}, ra, e1), this._container = r.create("div", "maplibregl-ctrl maplibregl-ctrl-group mapboxgl-ctrl mapboxgl-ctrl-group"), this._container.addEventListener("contextmenu", (t1)=>t1.preventDefault()), this.options.showZoom && (t1.bindAll([
                        "_setButtonTitle",
                        "_updateZoomButtons"
                    ], this), this._zoomInButton = this._createButton("maplibregl-ctrl-zoom-in mapboxgl-ctrl-zoom-in", (t1)=>this._map.zoomIn({}, {
                            originalEvent: t1
                        })), r.create("span", "maplibregl-ctrl-icon mapboxgl-ctrl-icon", this._zoomInButton).setAttribute("aria-hidden", "true"), this._zoomOutButton = this._createButton("maplibregl-ctrl-zoom-out mapboxgl-ctrl-zoom-out", (t1)=>this._map.zoomOut({}, {
                            originalEvent: t1
                        })), r.create("span", "maplibregl-ctrl-icon mapboxgl-ctrl-icon", this._zoomOutButton).setAttribute("aria-hidden", "true")), this.options.showCompass && (t1.bindAll([
                        "_rotateCompassArrow"
                    ], this), this._compass = this._createButton("maplibregl-ctrl-compass mapboxgl-ctrl-compass", (t1)=>{
                        this.options.visualizePitch ? this._map.resetNorthPitch({}, {
                            originalEvent: t1
                        }) : this._map.resetNorth({}, {
                            originalEvent: t1
                        });
                    }), this._compassIcon = r.create("span", "maplibregl-ctrl-icon mapboxgl-ctrl-icon", this._compass), this._compassIcon.setAttribute("aria-hidden", "true"));
                }
                _updateZoomButtons() {
                    const t1 = this._map.getZoom(), e1 = t1 === this._map.getMaxZoom(), i = t1 === this._map.getMinZoom();
                    this._zoomInButton.disabled = e1, this._zoomOutButton.disabled = i, this._zoomInButton.setAttribute("aria-disabled", e1.toString()), this._zoomOutButton.setAttribute("aria-disabled", i.toString());
                }
                _rotateCompassArrow() {
                    const t1 = this.options.visualizePitch ? `scale(${1 / Math.pow(Math.cos(this._map.transform.pitch * (Math.PI / 180)), .5)}) rotateX(${this._map.transform.pitch}deg) rotateZ(${this._map.transform.angle * (180 / Math.PI)}deg)` : `rotate(${this._map.transform.angle * (180 / Math.PI)}deg)`;
                    this._compassIcon.style.transform = t1;
                }
                onAdd(t1) {
                    return this._map = t1, this.options.showZoom && (this._setButtonTitle(this._zoomInButton, "ZoomIn"), this._setButtonTitle(this._zoomOutButton, "ZoomOut"), this._map.on("zoom", this._updateZoomButtons), this._updateZoomButtons()), this.options.showCompass && (this._setButtonTitle(this._compass, "ResetBearing"), this.options.visualizePitch && this._map.on("pitch", this._rotateCompassArrow), this._map.on("rotate", this._rotateCompassArrow), this._rotateCompassArrow(), this._handler = new sa(this._map, this._compass, this.options.visualizePitch)), this._container;
                }
                onRemove() {
                    r.remove(this._container), this.options.showZoom && this._map.off("zoom", this._updateZoomButtons), this.options.showCompass && (this.options.visualizePitch && this._map.off("pitch", this._rotateCompassArrow), this._map.off("rotate", this._rotateCompassArrow), this._handler.off(), delete this._handler), delete this._map;
                }
                _createButton(t1, e1) {
                    const i = r.create("button", t1, this._container);
                    return i.type = "button", i.addEventListener("click", e1), i;
                }
                _setButtonTitle(t1, e1) {
                    const i = this._map._getUIString(`NavigationControl.${e1}`);
                    t1.title = i, t1.setAttribute("aria-label", i);
                }
            },
            GeolocateControl: class extends t1.Evented {
                constructor(e1){
                    super(), this.options = t1.extend({}, ua, e1), t1.bindAll([
                        "_onSuccess",
                        "_onError",
                        "_onZoom",
                        "_finish",
                        "_setupUI",
                        "_updateCamera",
                        "_updateMarker"
                    ], this);
                }
                onAdd(t1) {
                    var e1;
                    return this._map = t1, this._container = r.create("div", "maplibregl-ctrl maplibregl-ctrl-group mapboxgl-ctrl mapboxgl-ctrl-group"), e1 = this._setupUI, void 0 !== da ? e1(da) : void 0 !== window.navigator.permissions ? window.navigator.permissions.query({
                        name: "geolocation"
                    }).then((t1)=>{
                        da = "denied" !== t1.state, e1(da);
                    }) : (da = !!window.navigator.geolocation, e1(da)), this._container;
                }
                onRemove() {
                    void 0 !== this._geolocationWatchID && (window.navigator.geolocation.clearWatch(this._geolocationWatchID), this._geolocationWatchID = void 0), this.options.showUserLocation && this._userLocationDotMarker && this._userLocationDotMarker.remove(), this.options.showAccuracyCircle && this._accuracyCircleMarker && this._accuracyCircleMarker.remove(), r.remove(this._container), this._map.off("zoom", this._onZoom), this._map = void 0, ma = 0, _a = !1;
                }
                _isOutOfMapMaxBounds(t1) {
                    const e1 = this._map.getMaxBounds(), i = t1.coords;
                    return e1 && (i.longitude < e1.getWest() || i.longitude > e1.getEast() || i.latitude < e1.getSouth() || i.latitude > e1.getNorth());
                }
                _setErrorState() {
                    switch(this._watchState){
                        case "WAITING_ACTIVE":
                            this._watchState = "ACTIVE_ERROR", this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active", "mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active-error", "mapboxgl-ctrl-geolocate-active-error");
                            break;
                        case "ACTIVE_LOCK":
                            this._watchState = "ACTIVE_ERROR", this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active", "mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active-error", "mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting");
                            break;
                        case "BACKGROUND":
                            this._watchState = "BACKGROUND_ERROR", this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background", "mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-background-error", "mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting");
                            break;
                        case "ACTIVE_ERROR":
                            break;
                        default:
                            throw new Error(`Unexpected watchState ${this._watchState}`);
                    }
                }
                _onSuccess(e1) {
                    if (this._map) {
                        if (this._isOutOfMapMaxBounds(e1)) return this._setErrorState(), this.fire(new t1.Event("outofmaxbounds", e1)), this._updateMarker(), void this._finish();
                        if (this.options.trackUserLocation) switch(this._lastKnownPosition = e1, this._watchState){
                            case "WAITING_ACTIVE":
                            case "ACTIVE_LOCK":
                            case "ACTIVE_ERROR":
                                this._watchState = "ACTIVE_LOCK", this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active-error", "mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active", "mapboxgl-ctrl-geolocate-active");
                                break;
                            case "BACKGROUND":
                            case "BACKGROUND_ERROR":
                                this._watchState = "BACKGROUND", this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background-error", "mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-background", "mapboxgl-ctrl-geolocate-background");
                                break;
                            default:
                                throw new Error(`Unexpected watchState ${this._watchState}`);
                        }
                        this.options.showUserLocation && "OFF" !== this._watchState && this._updateMarker(e1), this.options.trackUserLocation && "ACTIVE_LOCK" !== this._watchState || this._updateCamera(e1), this.options.showUserLocation && this._dotElement.classList.remove("maplibregl-user-location-dot-stale", "mapboxgl-user-location-dot-stale"), this.fire(new t1.Event("geolocate", e1)), this._finish();
                    }
                }
                _updateCamera(e1) {
                    const i = new t1.LngLat(e1.coords.longitude, e1.coords.latitude), o = e1.coords.accuracy, a = this._map.getBearing(), r = t1.extend({
                        bearing: a
                    }, this.options.fitBoundsOptions);
                    this._map.fitBounds(i.toBounds(o), r, {
                        geolocateSource: !0
                    });
                }
                _updateMarker(e1) {
                    if (e1) {
                        const i = new t1.LngLat(e1.coords.longitude, e1.coords.latitude);
                        this._accuracyCircleMarker.setLngLat(i).addTo(this._map), this._userLocationDotMarker.setLngLat(i).addTo(this._map), this._accuracy = e1.coords.accuracy, this.options.showUserLocation && this.options.showAccuracyCircle && this._updateCircleRadius();
                    } else this._userLocationDotMarker.remove(), this._accuracyCircleMarker.remove();
                }
                _updateCircleRadius() {
                    const t1 = this._map._container.clientHeight / 2, e1 = this._map.unproject([
                        0,
                        t1
                    ]), i = this._map.unproject([
                        1,
                        t1
                    ]), o = e1.distanceTo(i), a = Math.ceil(2 * this._accuracy / o);
                    this._circleElement.style.width = `${a}px`, this._circleElement.style.height = `${a}px`;
                }
                _onZoom() {
                    this.options.showUserLocation && this.options.showAccuracyCircle && this._updateCircleRadius();
                }
                _onError(e1) {
                    if (this._map) {
                        if (this.options.trackUserLocation) {
                            if (1 === e1.code) {
                                this._watchState = "OFF", this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active", "mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active-error", "mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background", "mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background-error", "mapboxgl-ctrl-geolocate-background-error"), this._geolocateButton.disabled = !0;
                                const t2 = this._map._getUIString("GeolocateControl.LocationNotAvailable");
                                this._geolocateButton.title = t2, this._geolocateButton.setAttribute("aria-label", t2), void 0 !== this._geolocationWatchID && this._clearWatch();
                            } else {
                                if (3 === e1.code && _a) return;
                                this._setErrorState();
                            }
                        }
                        "OFF" !== this._watchState && this.options.showUserLocation && this._dotElement.classList.add("maplibregl-user-location-dot-stale", "mapboxgl-user-location-dot-stale"), this.fire(new t1.Event("error", e1)), this._finish();
                    }
                }
                _finish() {
                    this._timeoutId && clearTimeout(this._timeoutId), this._timeoutId = void 0;
                }
                _setupUI(e1) {
                    if (this._container.addEventListener("contextmenu", (t1)=>t1.preventDefault()), this._geolocateButton = r.create("button", "maplibregl-ctrl-geolocate mapboxgl-ctrl-geolocate", this._container), r.create("span", "maplibregl-ctrl-icon mapboxgl-ctrl-icon", this._geolocateButton).setAttribute("aria-hidden", "true"), this._geolocateButton.type = "button", !1 === e1) {
                        t1.warnOnce("Geolocation support is not available so the GeolocateControl will be disabled.");
                        const e2 = this._map._getUIString("GeolocateControl.LocationNotAvailable");
                        this._geolocateButton.disabled = !0, this._geolocateButton.title = e2, this._geolocateButton.setAttribute("aria-label", e2);
                    } else {
                        const t2 = this._map._getUIString("GeolocateControl.FindMyLocation");
                        this._geolocateButton.title = t2, this._geolocateButton.setAttribute("aria-label", t2);
                    }
                    this.options.trackUserLocation && (this._geolocateButton.setAttribute("aria-pressed", "false"), this._watchState = "OFF"), this.options.showUserLocation && (this._dotElement = r.create("div", "maplibregl-user-location-dot mapboxgl-user-location-dot"), this._userLocationDotMarker = new ha(this._dotElement), this._circleElement = r.create("div", "maplibregl-user-location-accuracy-circle mapboxgl-user-location-accuracy-circle"), this._accuracyCircleMarker = new ha({
                        element: this._circleElement,
                        pitchAlignment: "map"
                    }), this.options.trackUserLocation && (this._watchState = "OFF"), this._map.on("zoom", this._onZoom)), this._geolocateButton.addEventListener("click", this.trigger.bind(this)), this._setup = !0, this.options.trackUserLocation && this._map.on("movestart", (e1)=>{
                        e1.geolocateSource || "ACTIVE_LOCK" !== this._watchState || e1.originalEvent && "resize" === e1.originalEvent.type || (this._watchState = "BACKGROUND", this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-background", "mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active", "mapboxgl-ctrl-geolocate-active"), this.fire(new t1.Event("trackuserlocationend")));
                    });
                }
                trigger() {
                    if (!this._setup) return t1.warnOnce("Geolocate control triggered before added to a map"), !1;
                    if (this.options.trackUserLocation) {
                        switch(this._watchState){
                            case "OFF":
                                this._watchState = "WAITING_ACTIVE", this.fire(new t1.Event("trackuserlocationstart"));
                                break;
                            case "WAITING_ACTIVE":
                            case "ACTIVE_LOCK":
                            case "ACTIVE_ERROR":
                            case "BACKGROUND_ERROR":
                                ma--, _a = !1, this._watchState = "OFF", this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active", "mapboxgl-ctrl-geolocate-active"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-active-error", "mapboxgl-ctrl-geolocate-active-error"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background", "mapboxgl-ctrl-geolocate-background"), this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background-error", "mapboxgl-ctrl-geolocate-background-error"), this.fire(new t1.Event("trackuserlocationend"));
                                break;
                            case "BACKGROUND":
                                this._watchState = "ACTIVE_LOCK", this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-background", "mapboxgl-ctrl-geolocate-background"), this._lastKnownPosition && this._updateCamera(this._lastKnownPosition), this.fire(new t1.Event("trackuserlocationstart"));
                                break;
                            default:
                                throw new Error(`Unexpected watchState ${this._watchState}`);
                        }
                        switch(this._watchState){
                            case "WAITING_ACTIVE":
                                this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active", "mapboxgl-ctrl-geolocate-active");
                                break;
                            case "ACTIVE_LOCK":
                                this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-active", "mapboxgl-ctrl-geolocate-active");
                                break;
                            case "OFF":
                                break;
                            default:
                                throw new Error(`Unexpected watchState ${this._watchState}`);
                        }
                        if ("OFF" === this._watchState && void 0 !== this._geolocationWatchID) this._clearWatch();
                        else if (void 0 === this._geolocationWatchID) {
                            let t2;
                            this._geolocateButton.classList.add("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.setAttribute("aria-pressed", "true"), ma++, ma > 1 ? (t2 = {
                                maximumAge: 6e5,
                                timeout: 0
                            }, _a = !0) : (t2 = this.options.positionOptions, _a = !1), this._geolocationWatchID = window.navigator.geolocation.watchPosition(this._onSuccess, this._onError, t2);
                        }
                    } else window.navigator.geolocation.getCurrentPosition(this._onSuccess, this._onError, this.options.positionOptions), this._timeoutId = setTimeout(this._finish, 1e4);
                    return !0;
                }
                _clearWatch() {
                    window.navigator.geolocation.clearWatch(this._geolocationWatchID), this._geolocationWatchID = void 0, this._geolocateButton.classList.remove("maplibregl-ctrl-geolocate-waiting", "mapboxgl-ctrl-geolocate-waiting"), this._geolocateButton.setAttribute("aria-pressed", "false"), this.options.showUserLocation && this._updateMarker(null);
                }
            },
            AttributionControl: ta,
            LogoControl: ea,
            ScaleControl: class {
                constructor(e1){
                    this.options = t1.extend({}, pa, e1), t1.bindAll([
                        "_onMove",
                        "setUnit"
                    ], this);
                }
                getDefaultPosition() {
                    return "bottom-left";
                }
                _onMove() {
                    fa(this._map, this._container, this.options);
                }
                onAdd(t1) {
                    return this._map = t1, this._container = r.create("div", "maplibregl-ctrl maplibregl-ctrl-scale mapboxgl-ctrl mapboxgl-ctrl-scale", t1.getContainer()), this._map.on("move", this._onMove), this._onMove(), this._container;
                }
                onRemove() {
                    r.remove(this._container), this._map.off("move", this._onMove), this._map = void 0;
                }
                setUnit(t1) {
                    this.options.unit = t1, fa(this._map, this._container, this.options);
                }
            },
            FullscreenControl: class {
                constructor(e1){
                    this._fullscreen = !1, e1 && e1.container && (e1.container instanceof HTMLElement ? this._container = e1.container : t1.warnOnce("Full screen control 'container' must be a DOM element.")), t1.bindAll([
                        "_onClickFullscreen",
                        "_changeIcon"
                    ], this), "onfullscreenchange" in document ? this._fullscreenchange = "fullscreenchange" : "onmozfullscreenchange" in document ? this._fullscreenchange = "mozfullscreenchange" : "onwebkitfullscreenchange" in document ? this._fullscreenchange = "webkitfullscreenchange" : "onmsfullscreenchange" in document && (this._fullscreenchange = "MSFullscreenChange");
                }
                onAdd(e1) {
                    return this._map = e1, this._container || (this._container = this._map.getContainer()), this._controlContainer = r.create("div", "maplibregl-ctrl maplibregl-ctrl-group mapboxgl-ctrl mapboxgl-ctrl-group"), this._checkFullscreenSupport() ? this._setupUI() : (this._controlContainer.style.display = "none", t1.warnOnce("This device does not support fullscreen mode.")), this._controlContainer;
                }
                onRemove() {
                    r.remove(this._controlContainer), this._map = null, window.document.removeEventListener(this._fullscreenchange, this._changeIcon);
                }
                _checkFullscreenSupport() {
                    return !!(document.fullscreenEnabled || document.mozFullScreenEnabled || document.msFullscreenEnabled || document.webkitFullscreenEnabled);
                }
                _setupUI() {
                    const t1 = this._fullscreenButton = r.create("button", "maplibregl-ctrl-fullscreen mapboxgl-ctrl-fullscreen", this._controlContainer);
                    r.create("span", "maplibregl-ctrl-icon mapboxgl-ctrl-icon", t1).setAttribute("aria-hidden", "true"), t1.type = "button", this._updateTitle(), this._fullscreenButton.addEventListener("click", this._onClickFullscreen), window.document.addEventListener(this._fullscreenchange, this._changeIcon);
                }
                _updateTitle() {
                    const t1 = this._getTitle();
                    this._fullscreenButton.setAttribute("aria-label", t1), this._fullscreenButton.title = t1;
                }
                _getTitle() {
                    return this._map._getUIString(this._isFullscreen() ? "FullscreenControl.Exit" : "FullscreenControl.Enter");
                }
                _isFullscreen() {
                    return this._fullscreen;
                }
                _changeIcon() {
                    (window.document.fullscreenElement || window.document.mozFullScreenElement || window.document.webkitFullscreenElement || window.document.msFullscreenElement) === this._container !== this._fullscreen && (this._fullscreen = !this._fullscreen, this._fullscreenButton.classList.toggle("maplibregl-ctrl-shrink"), this._fullscreenButton.classList.toggle("mapboxgl-ctrl-shrink"), this._fullscreenButton.classList.toggle("maplibregl-ctrl-fullscreen"), this._fullscreenButton.classList.toggle("mapboxgl-ctrl-fullscreen"), this._updateTitle());
                }
                _onClickFullscreen() {
                    this._isFullscreen() ? window.document.exitFullscreen ? window.document.exitFullscreen() : window.document.mozCancelFullScreen ? window.document.mozCancelFullScreen() : window.document.msExitFullscreen ? window.document.msExitFullscreen() : window.document.webkitCancelFullScreen && window.document.webkitCancelFullScreen() : this._container.requestFullscreen ? this._container.requestFullscreen() : this._container.mozRequestFullScreen ? this._container.mozRequestFullScreen() : this._container.msRequestFullscreen ? this._container.msRequestFullscreen() : this._container.webkitRequestFullscreen && this._container.webkitRequestFullscreen();
                }
            },
            TerrainControl: class {
                constructor(e1){
                    this.options = e1, t1.bindAll([
                        "_toggleTerrain",
                        "_updateTerrainIcon"
                    ], this);
                }
                onAdd(t1) {
                    return this._map = t1, this._container = r.create("div", "maplibregl-ctrl maplibregl-ctrl-group mapboxgl-ctrl mapboxgl-ctrl-group"), this._terrainButton = r.create("button", "maplibregl-ctrl-terrain mapboxgl-ctrl-terrain", this._container), r.create("span", "maplibregl-ctrl-icon mapboxgl-ctrl-icon", this._terrainButton).setAttribute("aria-hidden", "true"), this._terrainButton.type = "button", this._terrainButton.addEventListener("click", this._toggleTerrain), this._updateTerrainIcon(), this._map.on("terrain", this._updateTerrainIcon), this._container;
                }
                onRemove() {
                    r.remove(this._container), this._map.off("terrain", this._updateTerrainIcon), this._map = void 0;
                }
                _toggleTerrain() {
                    this._map.getTerrain() ? this._map.setTerrain(null) : this._map.setTerrain(this.options), this._updateTerrainIcon();
                }
                _updateTerrainIcon() {
                    this._terrainButton.classList.remove("maplibregl-ctrl-terrain", "mapboxgl-ctrl-terrain"), this._terrainButton.classList.remove("maplibregl-ctrl-terrain-enabled", "mapboxgl-ctrl-terrain-enabled"), this._map.style.terrain ? (this._terrainButton.classList.add("maplibregl-ctrl-terrain-enabled", "mapboxgl-ctrl-terrain-enabled"), this._terrainButton.title = this._map._getUIString("TerrainControl.disableTerrain")) : (this._terrainButton.classList.add("maplibregl-ctrl-terrain", "mapboxgl-ctrl-terrain"), this._terrainButton.title = this._map._getUIString("TerrainControl.enableTerrain"));
                }
            },
            Popup: class extends t1.Evented {
                constructor(e1){
                    super(), this.options = t1.extend(Object.create(xa), e1), t1.bindAll([
                        "_update",
                        "_onClose",
                        "remove",
                        "_onMouseMove",
                        "_onMouseUp",
                        "_onDrag"
                    ], this);
                }
                addTo(e1) {
                    return this._map && this.remove(), this._map = e1, this.options.closeOnClick && this._map.on("click", this._onClose), this.options.closeOnMove && this._map.on("move", this._onClose), this._map.on("remove", this.remove), this._update(), this._focusFirstElement(), this._trackPointer ? (this._map.on("mousemove", this._onMouseMove), this._map.on("mouseup", this._onMouseUp), this._container && this._container.classList.add("maplibregl-popup-track-pointer", "mapboxgl-popup-track-pointer"), this._map._canvasContainer.classList.add("maplibregl-track-pointer", "mapboxgl-track-pointer")) : this._map.on("move", this._update), this.fire(new t1.Event("open")), this;
                }
                isOpen() {
                    return !!this._map;
                }
                remove() {
                    return this._content && r.remove(this._content), this._container && (r.remove(this._container), delete this._container), this._map && (this._map.off("move", this._update), this._map.off("move", this._onClose), this._map.off("click", this._onClose), this._map.off("remove", this.remove), this._map.off("mousemove", this._onMouseMove), this._map.off("mouseup", this._onMouseUp), this._map.off("drag", this._onDrag), delete this._map), this.fire(new t1.Event("close")), this;
                }
                getLngLat() {
                    return this._lngLat;
                }
                setLngLat(e1) {
                    return this._lngLat = t1.LngLat.convert(e1), this._pos = null, this._trackPointer = !1, this._update(), this._map && (this._map.on("move", this._update), this._map.off("mousemove", this._onMouseMove), this._container && this._container.classList.remove("maplibregl-popup-track-pointer", "mapboxgl-popup-track-pointer"), this._map._canvasContainer.classList.remove("maplibregl-track-pointer", "mapboxgl-track-pointer")), this;
                }
                trackPointer() {
                    return this._trackPointer = !0, this._pos = null, this._update(), this._map && (this._map.off("move", this._update), this._map.on("mousemove", this._onMouseMove), this._map.on("drag", this._onDrag), this._container && this._container.classList.add("maplibregl-popup-track-pointer", "mapboxgl-popup-track-pointer"), this._map._canvasContainer.classList.add("maplibregl-track-pointer", "mapboxgl-track-pointer")), this;
                }
                getElement() {
                    return this._container;
                }
                setText(t1) {
                    return this.setDOMContent(document.createTextNode(t1));
                }
                setHTML(t1) {
                    const e1 = document.createDocumentFragment(), i = document.createElement("body");
                    let o;
                    for(i.innerHTML = t1; o = i.firstChild, o;)e1.appendChild(o);
                    return this.setDOMContent(e1);
                }
                getMaxWidth() {
                    return this._container && this._container.style.maxWidth;
                }
                setMaxWidth(t1) {
                    return this.options.maxWidth = t1, this._update(), this;
                }
                setDOMContent(t1) {
                    if (this._content) for(; this._content.hasChildNodes();)this._content.firstChild && this._content.removeChild(this._content.firstChild);
                    else this._content = r.create("div", "maplibregl-popup-content mapboxgl-popup-content", this._container);
                    return this._content.appendChild(t1), this._createCloseButton(), this._update(), this._focusFirstElement(), this;
                }
                addClassName(t1) {
                    this._container && this._container.classList.add(t1);
                }
                removeClassName(t1) {
                    this._container && this._container.classList.remove(t1);
                }
                setOffset(t1) {
                    return this.options.offset = t1, this._update(), this;
                }
                toggleClassName(t1) {
                    if (this._container) return this._container.classList.toggle(t1);
                }
                _createCloseButton() {
                    this.options.closeButton && (this._closeButton = r.create("button", "maplibregl-popup-close-button mapboxgl-popup-close-button", this._content), this._closeButton.type = "button", this._closeButton.setAttribute("aria-label", "Close popup"), this._closeButton.innerHTML = "&#215;", this._closeButton.addEventListener("click", this._onClose));
                }
                _onMouseUp(t1) {
                    this._update(t1.point);
                }
                _onMouseMove(t1) {
                    this._update(t1.point);
                }
                _onDrag(t1) {
                    this._update(t1.point);
                }
                _update(t1) {
                    if (!this._map || !this._lngLat && !this._trackPointer || !this._content) return;
                    if (this._container || (this._container = r.create("div", "maplibregl-popup mapboxgl-popup", this._map.getContainer()), this._tip = r.create("div", "maplibregl-popup-tip mapboxgl-popup-tip", this._container), this._container.appendChild(this._content), this.options.className && this.options.className.split(" ").forEach((t1)=>this._container.classList.add(t1)), this._trackPointer && this._container.classList.add("maplibregl-popup-track-pointer", "mapboxgl-popup-track-pointer")), this.options.maxWidth && this._container.style.maxWidth !== this.options.maxWidth && (this._container.style.maxWidth = this.options.maxWidth), this._map.transform.renderWorldCopies && !this._trackPointer && (this._lngLat = na(this._lngLat, this._pos, this._map.transform)), this._trackPointer && !t1) return;
                    const e1 = this._pos = this._trackPointer && t1 ? t1 : this._map.project(this._lngLat);
                    let i = this.options.anchor;
                    const o = ya(this.options.offset);
                    if (!i) {
                        const t2 = this._container.offsetWidth, a = this._container.offsetHeight;
                        let r1;
                        r1 = e1.y + o.bottom.y < a ? [
                            "top"
                        ] : e1.y > this._map.transform.height - a ? [
                            "bottom"
                        ] : [], e1.x < t2 / 2 ? r1.push("left") : e1.x > this._map.transform.width - t2 / 2 && r1.push("right"), i = 0 === r1.length ? "bottom" : r1.join("-");
                    }
                    const a1 = e1.add(o[i]).round();
                    r.setTransform(this._container, `${la[i]} translate(${a1.x}px,${a1.y}px)`), ca(this._container, i, "popup");
                }
                _focusFirstElement() {
                    if (!this.options.focusAfterOpen || !this._container) return;
                    const t1 = this._container.querySelector(va);
                    t1 && t1.focus();
                }
                _onClose() {
                    this.remove();
                }
            },
            Marker: ha,
            Style: ee,
            LngLat: t1.LngLat,
            LngLatBounds: t1.LngLatBounds,
            Point: t1.pointGeometry,
            MercatorCoordinate: t1.MercatorCoordinate,
            Evented: t1.Evented,
            AJAXError: t1.AJAXError,
            config: t1.config,
            CanvasSource: P,
            GeoJSONSource: C,
            ImageSource: D,
            RasterDEMTileSource: I,
            RasterTileSource: T,
            VectorTileSource: w,
            VideoSource: z,
            prewarm: function() {
                j().acquire(G);
            },
            clearPrewarmedResources: function() {
                const t1 = q;
                t1 && (t1.isPreloaded() && 1 === t1.numActive() ? (t1.release(G), q = null) : console.warn("Could not clear WebWorkers since there are active Map instances that still reference it. The pre-warmed WebWorker pool can only be cleared when all map instances have been removed with map.remove()"));
            },
            get version () {
                return "2.4.0";
            },
            get workerCount () {
                return Z.workerCount;
            },
            set workerCount (t){
                Z.workerCount = t;
            },
            get maxParallelImageRequests () {
                return t1.config.MAX_PARALLEL_IMAGE_REQUESTS;
            },
            set maxParallelImageRequests (e){
                t1.config.MAX_PARALLEL_IMAGE_REQUESTS = e;
            },
            clearStorage (e1) {
                t1.clearTileCache(e1);
            },
            workerUrl: "",
            addProtocol (e1, i) {
                t1.config.REGISTERED_PROTOCOLS[e1] = i;
            },
            removeProtocol (e1) {
                delete t1.config.REGISTERED_PROTOCOLS[e1];
            }
        };
        return Jo.extend(ba, {
            isSafari: t1.isSafari,
            getPerformanceMetrics: t1.PerformanceUtils.getPerformanceMetrics
        }), ba;
    });
    //
    var maplibregl$1 = maplibregl;
    return maplibregl$1;
});

},{}],"aXxeu":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _deckUtils = require("./deck-utils");
class MapboxLayer {
    constructor(props){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "type", void 0);
        (0, _definePropertyDefault.default)(this, "renderingMode", void 0);
        (0, _definePropertyDefault.default)(this, "map", void 0);
        (0, _definePropertyDefault.default)(this, "deck", void 0);
        (0, _definePropertyDefault.default)(this, "props", void 0);
        if (!props.id) throw new Error("Layer must have an unique id");
        this.id = props.id;
        this.type = "custom";
        this.renderingMode = props.renderingMode || "3d";
        this.map = null;
        this.deck = null;
        this.props = props;
    }
    onAdd(map, gl) {
        this.map = map;
        this.deck = (0, _deckUtils.getDeckInstance)({
            map,
            gl,
            deck: this.props.deck
        });
        (0, _deckUtils.addLayer)(this.deck, this);
    }
    onRemove() {
        if (this.deck) (0, _deckUtils.removeLayer)(this.deck, this);
    }
    setProps(props) {
        Object.assign(this.props, props, {
            id: this.id
        });
        if (this.deck) (0, _deckUtils.updateLayer)(this.deck, this);
    }
    render() {
        (0, _deckUtils.drawLayer)(this.deck, this.map, this);
    }
}
exports.default = MapboxLayer;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./deck-utils":"iDkPo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iDkPo":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getDeckInstance", ()=>getDeckInstance);
parcelHelpers.export(exports, "addLayer", ()=>addLayer);
parcelHelpers.export(exports, "removeLayer", ()=>removeLayer);
parcelHelpers.export(exports, "updateLayer", ()=>updateLayer);
parcelHelpers.export(exports, "drawLayer", ()=>drawLayer);
parcelHelpers.export(exports, "getViewState", ()=>getViewState);
var _core = require("@deck.gl/core");
function getDeckInstance({ map , gl , deck  }) {
    if (map.__deck) return map.__deck;
    const customRender = deck === null || deck === void 0 ? void 0 : deck.props._customRender;
    const deckProps = {
        useDevicePixels: true,
        _customRender: ()=>{
            map.triggerRepaint();
            customRender === null || customRender === void 0 || customRender("");
        },
        parameters: {
            depthMask: true,
            depthTest: true,
            blend: true,
            blendFunc: [
                770,
                771,
                1,
                771
            ],
            polygonOffsetFill: true,
            depthFunc: 515,
            blendEquation: 32774
        },
        views: deck && deck.props.views || [
            new (0, _core.MapView)({
                id: "mapbox"
            })
        ]
    };
    let deckInstance;
    if (!deck || deck.props.gl === gl) {
        Object.assign(deckProps, {
            gl,
            width: null,
            height: null,
            touchAction: "unset",
            viewState: getViewState(map)
        });
        map.on("move", ()=>onMapMove(deckInstance, map));
    }
    if (deck) {
        deckInstance = deck;
        deck.setProps(deckProps);
        deck.userData.isExternal = true;
    } else {
        deckInstance = new (0, _core.Deck)(deckProps);
        map.on("remove", ()=>{
            deckInstance.finalize();
            map.__deck = null;
        });
    }
    deckInstance.userData.mapboxLayers = new Set();
    deckInstance.userData.mapboxVersion = getMapboxVersion(map);
    map.__deck = deckInstance;
    map.on("render", ()=>{
        if (deckInstance.isInitialized) afterRender(deckInstance, map);
    });
    return deckInstance;
}
function addLayer(deck, layer) {
    deck.userData.mapboxLayers.add(layer);
    updateLayers(deck);
}
function removeLayer(deck, layer) {
    deck.userData.mapboxLayers.delete(layer);
    updateLayers(deck);
}
function updateLayer(deck, layer) {
    updateLayers(deck);
}
function drawLayer(deck, map, layer) {
    let { currentViewport  } = deck.userData;
    let clearStack = false;
    if (!currentViewport) {
        currentViewport = getViewport(deck, map, true);
        deck.userData.currentViewport = currentViewport;
        clearStack = true;
    }
    if (!deck.isInitialized) return;
    deck._drawLayers("mapbox-repaint", {
        viewports: [
            currentViewport
        ],
        layerFilter: ({ layer: deckLayer  })=>layer.id === deckLayer.id,
        clearStack,
        clearCanvas: false
    });
}
function getViewState(map) {
    const { lng , lat  } = map.getCenter();
    return {
        longitude: (lng + 540) % 360 - 180,
        latitude: lat,
        zoom: map.getZoom(),
        bearing: map.getBearing(),
        pitch: map.getPitch(),
        padding: map.getPadding(),
        repeat: map.getRenderWorldCopies()
    };
}
function getMapboxVersion(map) {
    let major = 0;
    let minor = 0;
    const version = map.version;
    if (version) [major, minor] = version.split(".").slice(0, 2).map(Number);
    return {
        major,
        minor
    };
}
function getViewport(deck, map, useMapboxProjection = true) {
    const { mapboxVersion  } = deck.userData;
    return new (0, _core.WebMercatorViewport)(Object.assign({
        id: "mapbox",
        x: 0,
        y: 0,
        width: deck.width,
        height: deck.height
    }, getViewState(map), useMapboxProjection ? {
        nearZMultiplier: mapboxVersion.major === 1 && mapboxVersion.minor >= 3 || mapboxVersion.major >= 2 ? 0.02 : 1 / (deck.height || 1)
    } : {
        nearZMultiplier: 0.1
    }));
}
function afterRender(deck, map) {
    const { mapboxLayers , isExternal  } = deck.userData;
    if (isExternal) {
        const mapboxLayerIds = Array.from(mapboxLayers, (layer)=>layer.id);
        const deckLayers = (0, _core._flatten)(deck.props.layers, Boolean);
        const hasNonMapboxLayers = deckLayers.some((layer)=>layer && !mapboxLayerIds.includes(layer.id));
        let viewports = deck.getViewports();
        const mapboxViewportIdx = viewports.findIndex((vp)=>vp.id === "mapbox");
        const hasNonMapboxViews = viewports.length > 1 || mapboxViewportIdx < 0;
        if (hasNonMapboxLayers || hasNonMapboxViews) {
            if (mapboxViewportIdx >= 0) {
                viewports = viewports.slice();
                viewports[mapboxViewportIdx] = getViewport(deck, map, false);
            }
            deck._drawLayers("mapbox-repaint", {
                viewports,
                layerFilter: (params)=>(!deck.props.layerFilter || deck.props.layerFilter(params)) && (params.viewport.id !== "mapbox" || !mapboxLayerIds.includes(params.layer.id)),
                clearCanvas: false
            });
        }
    }
    deck.userData.currentViewport = null;
}
function onMapMove(deck, map) {
    deck.setProps({
        viewState: getViewState(map)
    });
    deck.needsRedraw({
        clearRedrawFlags: true
    });
}
function updateLayers(deck) {
    if (deck.userData.isExternal) return;
    const layers = [];
    deck.userData.mapboxLayers.forEach((deckLayer)=>{
        const LayerType = deckLayer.props.type;
        const layer = new LayerType(deckLayer.props);
        layers.push(layer);
    });
    deck.setProps({
        layers
    });
}

},{"@deck.gl/core":"iErGJ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iErGJ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "COORDINATE_SYSTEM", ()=>(0, _constants.COORDINATE_SYSTEM));
parcelHelpers.export(exports, "OPERATION", ()=>(0, _constants.OPERATION));
parcelHelpers.export(exports, "UNIT", ()=>(0, _constants.UNIT));
parcelHelpers.export(exports, "LightingEffect", ()=>(0, _lightingEffectDefault.default));
parcelHelpers.export(exports, "AmbientLight", ()=>(0, _ambientLight.AmbientLight));
parcelHelpers.export(exports, "DirectionalLight", ()=>(0, _directionalLight.DirectionalLight));
parcelHelpers.export(exports, "PointLight", ()=>(0, _pointLight.PointLight));
parcelHelpers.export(exports, "_CameraLight", ()=>(0, _cameraLightDefault.default));
parcelHelpers.export(exports, "_SunLight", ()=>(0, _sunLightDefault.default));
parcelHelpers.export(exports, "PostProcessEffect", ()=>(0, _postProcessEffectDefault.default));
parcelHelpers.export(exports, "_LayersPass", ()=>(0, _layersPassDefault.default));
parcelHelpers.export(exports, "Deck", ()=>(0, _deckDefault.default));
parcelHelpers.export(exports, "LayerManager", ()=>(0, _layerManagerDefault.default));
parcelHelpers.export(exports, "AttributeManager", ()=>(0, _attributeManagerDefault.default));
parcelHelpers.export(exports, "Layer", ()=>(0, _layerDefault.default));
parcelHelpers.export(exports, "CompositeLayer", ()=>(0, _compositeLayerDefault.default));
parcelHelpers.export(exports, "DeckRenderer", ()=>(0, _deckRendererDefault.default));
parcelHelpers.export(exports, "Viewport", ()=>(0, _viewportDefault.default));
parcelHelpers.export(exports, "WebMercatorViewport", ()=>(0, _webMercatorViewportDefault.default));
parcelHelpers.export(exports, "_GlobeViewport", ()=>(0, _globeViewportDefault.default));
parcelHelpers.export(exports, "OrbitViewport", ()=>(0, _orbitViewportDefault.default));
parcelHelpers.export(exports, "OrthographicViewport", ()=>(0, _orthographicViewportDefault.default));
parcelHelpers.export(exports, "FirstPersonViewport", ()=>(0, _firstPersonViewportDefault.default));
parcelHelpers.export(exports, "picking", ()=>(0, _shaderlib.picking));
parcelHelpers.export(exports, "project", ()=>(0, _shaderlib.project));
parcelHelpers.export(exports, "project32", ()=>(0, _shaderlib.project32));
parcelHelpers.export(exports, "gouraudLighting", ()=>(0, _shaderlib.gouraudLighting));
parcelHelpers.export(exports, "phongLighting", ()=>(0, _shaderlib.phongLighting));
parcelHelpers.export(exports, "shadow", ()=>(0, _shaderlib.shadow));
parcelHelpers.export(exports, "View", ()=>(0, _viewDefault.default));
parcelHelpers.export(exports, "MapView", ()=>(0, _mapViewDefault.default));
parcelHelpers.export(exports, "FirstPersonView", ()=>(0, _firstPersonViewDefault.default));
parcelHelpers.export(exports, "OrbitView", ()=>(0, _orbitViewDefault.default));
parcelHelpers.export(exports, "OrthographicView", ()=>(0, _orthographicViewDefault.default));
parcelHelpers.export(exports, "_GlobeView", ()=>(0, _globeViewDefault.default));
parcelHelpers.export(exports, "Controller", ()=>(0, _controllerDefault.default));
parcelHelpers.export(exports, "MapController", ()=>(0, _mapControllerDefault.default));
parcelHelpers.export(exports, "_GlobeController", ()=>(0, _globeControllerDefault.default));
parcelHelpers.export(exports, "FirstPersonController", ()=>(0, _firstPersonControllerDefault.default));
parcelHelpers.export(exports, "OrbitController", ()=>(0, _orbitControllerDefault.default));
parcelHelpers.export(exports, "OrthographicController", ()=>(0, _orthographicControllerDefault.default));
parcelHelpers.export(exports, "LayerExtension", ()=>(0, _layerExtensionDefault.default));
parcelHelpers.export(exports, "TRANSITION_EVENTS", ()=>(0, _transitionManager.TRANSITION_EVENTS));
parcelHelpers.export(exports, "TransitionInterpolator", ()=>(0, _transitionInterpolatorDefault.default));
parcelHelpers.export(exports, "LinearInterpolator", ()=>(0, _linearInterpolatorDefault.default));
parcelHelpers.export(exports, "FlyToInterpolator", ()=>(0, _flyToInterpolatorDefault.default));
parcelHelpers.export(exports, "log", ()=>(0, _logDefault.default));
parcelHelpers.export(exports, "assert", ()=>(0, _assertDefault.default));
parcelHelpers.export(exports, "createIterable", ()=>(0, _iterableUtils.createIterable));
parcelHelpers.export(exports, "fp64LowPart", ()=>(0, _mathUtils.fp64LowPart));
parcelHelpers.export(exports, "Tesselator", ()=>(0, _tesselatorDefault.default));
parcelHelpers.export(exports, "_fillArray", ()=>(0, _flatten.fillArray));
parcelHelpers.export(exports, "_flatten", ()=>(0, _flatten.flatten));
parcelHelpers.export(exports, "_count", ()=>(0, _count.count));
parcelHelpers.export(exports, "_memoize", ()=>(0, _memoizeDefault.default));
parcelHelpers.export(exports, "_mergeShaders", ()=>(0, _shader.mergeShaders));
parcelHelpers.export(exports, "_compareProps", ()=>(0, _props.compareProps));
var _init = require("./lib/init");
var _shaderlib = require("./shaderlib");
var _constants = require("./lib/constants");
var _lightingEffect = require("./effects/lighting/lighting-effect");
var _lightingEffectDefault = parcelHelpers.interopDefault(_lightingEffect);
var _ambientLight = require("./effects/lighting/ambient-light");
var _directionalLight = require("./effects/lighting/directional-light");
var _pointLight = require("./effects/lighting/point-light");
var _cameraLight = require("./effects/lighting/camera-light");
var _cameraLightDefault = parcelHelpers.interopDefault(_cameraLight);
var _sunLight = require("./effects/lighting/sun-light");
var _sunLightDefault = parcelHelpers.interopDefault(_sunLight);
var _postProcessEffect = require("./effects/post-process-effect");
var _postProcessEffectDefault = parcelHelpers.interopDefault(_postProcessEffect);
var _layersPass = require("./passes/layers-pass");
var _layersPassDefault = parcelHelpers.interopDefault(_layersPass);
var _deck = require("./lib/deck");
var _deckDefault = parcelHelpers.interopDefault(_deck);
var _layerManager = require("./lib/layer-manager");
var _layerManagerDefault = parcelHelpers.interopDefault(_layerManager);
var _attributeManager = require("./lib/attribute/attribute-manager");
var _attributeManagerDefault = parcelHelpers.interopDefault(_attributeManager);
var _layer = require("./lib/layer");
var _layerDefault = parcelHelpers.interopDefault(_layer);
var _compositeLayer = require("./lib/composite-layer");
var _compositeLayerDefault = parcelHelpers.interopDefault(_compositeLayer);
var _deckRenderer = require("./lib/deck-renderer");
var _deckRendererDefault = parcelHelpers.interopDefault(_deckRenderer);
var _viewport = require("./viewports/viewport");
var _viewportDefault = parcelHelpers.interopDefault(_viewport);
var _webMercatorViewport = require("./viewports/web-mercator-viewport");
var _webMercatorViewportDefault = parcelHelpers.interopDefault(_webMercatorViewport);
var _globeViewport = require("./viewports/globe-viewport");
var _globeViewportDefault = parcelHelpers.interopDefault(_globeViewport);
var _orbitViewport = require("./viewports/orbit-viewport");
var _orbitViewportDefault = parcelHelpers.interopDefault(_orbitViewport);
var _orthographicViewport = require("./viewports/orthographic-viewport");
var _orthographicViewportDefault = parcelHelpers.interopDefault(_orthographicViewport);
var _firstPersonViewport = require("./viewports/first-person-viewport");
var _firstPersonViewportDefault = parcelHelpers.interopDefault(_firstPersonViewport);
var _view = require("./views/view");
var _viewDefault = parcelHelpers.interopDefault(_view);
var _mapView = require("./views/map-view");
var _mapViewDefault = parcelHelpers.interopDefault(_mapView);
var _firstPersonView = require("./views/first-person-view");
var _firstPersonViewDefault = parcelHelpers.interopDefault(_firstPersonView);
var _orbitView = require("./views/orbit-view");
var _orbitViewDefault = parcelHelpers.interopDefault(_orbitView);
var _orthographicView = require("./views/orthographic-view");
var _orthographicViewDefault = parcelHelpers.interopDefault(_orthographicView);
var _globeView = require("./views/globe-view");
var _globeViewDefault = parcelHelpers.interopDefault(_globeView);
var _controller = require("./controllers/controller");
var _controllerDefault = parcelHelpers.interopDefault(_controller);
var _mapController = require("./controllers/map-controller");
var _mapControllerDefault = parcelHelpers.interopDefault(_mapController);
var _globeController = require("./controllers/globe-controller");
var _globeControllerDefault = parcelHelpers.interopDefault(_globeController);
var _firstPersonController = require("./controllers/first-person-controller");
var _firstPersonControllerDefault = parcelHelpers.interopDefault(_firstPersonController);
var _orbitController = require("./controllers/orbit-controller");
var _orbitControllerDefault = parcelHelpers.interopDefault(_orbitController);
var _orthographicController = require("./controllers/orthographic-controller");
var _orthographicControllerDefault = parcelHelpers.interopDefault(_orthographicController);
var _layerExtension = require("./lib/layer-extension");
var _layerExtensionDefault = parcelHelpers.interopDefault(_layerExtension);
var _transitionManager = require("./controllers/transition-manager");
var _transitionInterpolator = require("./transitions/transition-interpolator");
var _transitionInterpolatorDefault = parcelHelpers.interopDefault(_transitionInterpolator);
var _linearInterpolator = require("./transitions/linear-interpolator");
var _linearInterpolatorDefault = parcelHelpers.interopDefault(_linearInterpolator);
var _flyToInterpolator = require("./transitions/fly-to-interpolator");
var _flyToInterpolatorDefault = parcelHelpers.interopDefault(_flyToInterpolator);
var _log = require("./utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _assert = require("./utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _iterableUtils = require("./utils/iterable-utils");
var _mathUtils = require("./utils/math-utils");
var _tesselator = require("./utils/tesselator");
var _tesselatorDefault = parcelHelpers.interopDefault(_tesselator);
var _flatten = require("./utils/flatten");
var _count = require("./utils/count");
var _memoize = require("./utils/memoize");
var _memoizeDefault = parcelHelpers.interopDefault(_memoize);
var _shader = require("./utils/shader");
var _props = require("./lifecycle/props");

},{"./lib/init":"2jj5x","./shaderlib":"dQXUb","./lib/constants":"ksWme","./effects/lighting/lighting-effect":"3N8o6","./effects/lighting/ambient-light":"a1sv0","./effects/lighting/directional-light":"jlZGq","./effects/lighting/point-light":false,"./effects/lighting/camera-light":false,"./effects/lighting/sun-light":false,"./effects/post-process-effect":false,"./passes/layers-pass":"bsyAy","./lib/deck":"hGHXX","./lib/layer-manager":"7wYcl","./lib/attribute/attribute-manager":"5oF21","./lib/layer":"kUVcd","./lib/composite-layer":false,"./lib/deck-renderer":"hXp5w","./viewports/viewport":"kxGGY","./viewports/web-mercator-viewport":"cVyIy","./viewports/globe-viewport":false,"./viewports/orbit-viewport":false,"./viewports/orthographic-viewport":"dwTyd","./viewports/first-person-viewport":false,"./views/view":"iThAT","./views/map-view":"aiwwz","./views/first-person-view":false,"./views/orbit-view":false,"./views/orthographic-view":"kAGcQ","./views/globe-view":false,"./controllers/controller":"4Hxmk","./controllers/map-controller":"8KSWr","./controllers/globe-controller":false,"./controllers/first-person-controller":false,"./controllers/orbit-controller":"2WwKU","./controllers/orthographic-controller":"6YTVr","./lib/layer-extension":false,"./controllers/transition-manager":"e2pjH","./transitions/transition-interpolator":"3ldCS","./transitions/linear-interpolator":"fCusj","./transitions/fly-to-interpolator":false,"./utils/log":"iINk7","./utils/assert":"aysGh","./utils/iterable-utils":"6frHT","./utils/math-utils":"1KANI","./utils/tesselator":"lmfmq","./utils/flatten":"bFfhb","./utils/count":"66RBf","./utils/memoize":"gjCnZ","./utils/shader":"4B3So","./lifecycle/props":"8bMWn","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2jj5x":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _core = require("@loaders.gl/core");
var _images = require("@loaders.gl/images");
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _debug = require("../debug");
var _jsonLoader = require("../utils/json-loader");
var _jsonLoaderDefault = parcelHelpers.interopDefault(_jsonLoader);
const version = "8.8.20";
const existingVersion = globalThis.deck && globalThis.deck.VERSION;
if (existingVersion && existingVersion !== version) throw new Error("deck.gl - multiple versions detected: ".concat(existingVersion, " vs ").concat(version));
if (!existingVersion) {
    (0, _logDefault.default).log(1, "deck.gl ".concat(version))();
    globalThis.deck = {
        ...globalThis.deck,
        VERSION: version,
        version,
        log: (0, _logDefault.default),
        _registerLoggers: (0, _debug.register)
    };
    (0, _core.registerLoaders)([
        (0, _jsonLoaderDefault.default),
        [
            (0, _images.ImageLoader),
            {
                imagebitmap: {
                    premultiplyAlpha: "none"
                }
            }
        ]
    ]);
}
exports.default = globalThis.deck;

},{"@loaders.gl/core":"aRzJb","@loaders.gl/images":"4b9Lz","../utils/log":"iINk7","../debug":"e6y6V","../utils/json-loader":"dYnRW","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aRzJb":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "fetchFile", ()=>(0, _fetchFile.fetchFile));
parcelHelpers.export(exports, "readArrayBuffer", ()=>(0, _readArrayBuffer.readArrayBuffer));
parcelHelpers.export(exports, "readFileSync", ()=>(0, _readFile.readFileSync));
parcelHelpers.export(exports, "writeFile", ()=>(0, _writeFile.writeFile));
parcelHelpers.export(exports, "writeFileSync", ()=>(0, _writeFile.writeFileSync));
parcelHelpers.export(exports, "setLoaderOptions", ()=>(0, _loaderOptions.setLoaderOptions));
parcelHelpers.export(exports, "getLoaderOptions", ()=>(0, _loaderOptions.getLoaderOptions));
parcelHelpers.export(exports, "registerLoaders", ()=>(0, _registerLoaders.registerLoaders));
parcelHelpers.export(exports, "selectLoader", ()=>(0, _selectLoader.selectLoader));
parcelHelpers.export(exports, "selectLoaderSync", ()=>(0, _selectLoader.selectLoaderSync));
parcelHelpers.export(exports, "parse", ()=>(0, _parse.parse));
parcelHelpers.export(exports, "parseSync", ()=>(0, _parseSync.parseSync));
parcelHelpers.export(exports, "parseInBatches", ()=>(0, _parseInBatches.parseInBatches));
parcelHelpers.export(exports, "load", ()=>(0, _load.load));
parcelHelpers.export(exports, "loadInBatches", ()=>(0, _loadInBatches.loadInBatches));
parcelHelpers.export(exports, "encode", ()=>(0, _encode.encode));
parcelHelpers.export(exports, "encodeSync", ()=>(0, _encode.encodeSync));
parcelHelpers.export(exports, "encodeInBatches", ()=>(0, _encode.encodeInBatches));
parcelHelpers.export(exports, "encodeText", ()=>(0, _encode.encodeText));
parcelHelpers.export(exports, "encodeURLtoURL", ()=>(0, _encode.encodeURLtoURL));
parcelHelpers.export(exports, "save", ()=>(0, _save.save));
parcelHelpers.export(exports, "saveSync", ()=>(0, _save.saveSync));
parcelHelpers.export(exports, "setPathPrefix", ()=>(0, _loaderUtils.setPathPrefix));
parcelHelpers.export(exports, "getPathPrefix", ()=>(0, _loaderUtils.getPathPrefix));
parcelHelpers.export(exports, "resolvePath", ()=>(0, _loaderUtils.resolvePath));
parcelHelpers.export(exports, "RequestScheduler", ()=>(0, _loaderUtils.RequestScheduler));
parcelHelpers.export(exports, "makeIterator", ()=>(0, _makeIterator.makeIterator));
parcelHelpers.export(exports, "makeStream", ()=>(0, _makeNodeStream.makeStream));
parcelHelpers.export(exports, "NullWorkerLoader", ()=>(0, _nullLoader.NullWorkerLoader));
parcelHelpers.export(exports, "NullLoader", ()=>(0, _nullLoader.NullLoader));
parcelHelpers.export(exports, "JSONLoader", ()=>(0, _loaderUtils.JSONLoader));
parcelHelpers.export(exports, "_fetchProgress", ()=>(0, _fetchProgressDefault.default));
parcelHelpers.export(exports, "_BrowserFileSystem", ()=>(0, _browserFilesystemDefault.default));
parcelHelpers.export(exports, "_unregisterLoaders", ()=>(0, _registerLoaders._unregisterLoaders));
parcelHelpers.export(exports, "isBrowser", ()=>(0, _loaderUtils.isBrowser));
parcelHelpers.export(exports, "isWorker", ()=>(0, _loaderUtils.isWorker));
parcelHelpers.export(exports, "self", ()=>(0, _loaderUtils.self));
parcelHelpers.export(exports, "window", ()=>(0, _loaderUtils.window));
parcelHelpers.export(exports, "global", ()=>(0, _loaderUtils.global));
parcelHelpers.export(exports, "document", ()=>(0, _loaderUtils.document));
parcelHelpers.export(exports, "assert", ()=>(0, _loaderUtils.assert));
parcelHelpers.export(exports, "forEach", ()=>(0, _loaderUtils.forEach));
parcelHelpers.export(exports, "concatenateArrayBuffersAsync", ()=>(0, _loaderUtils.concatenateArrayBuffersAsync));
parcelHelpers.export(exports, "makeTextDecoderIterator", ()=>(0, _loaderUtils.makeTextDecoderIterator));
parcelHelpers.export(exports, "makeTextEncoderIterator", ()=>(0, _loaderUtils.makeTextEncoderIterator));
parcelHelpers.export(exports, "makeLineIterator", ()=>(0, _loaderUtils.makeLineIterator));
parcelHelpers.export(exports, "makeNumberedLineIterator", ()=>(0, _loaderUtils.makeNumberedLineIterator));
parcelHelpers.export(exports, "isPureObject", ()=>(0, _isType.isPureObject));
parcelHelpers.export(exports, "isPromise", ()=>(0, _isType.isPromise));
parcelHelpers.export(exports, "isIterable", ()=>(0, _isType.isIterable));
parcelHelpers.export(exports, "isAsyncIterable", ()=>(0, _isType.isAsyncIterable));
parcelHelpers.export(exports, "isIterator", ()=>(0, _isType.isIterator));
parcelHelpers.export(exports, "isResponse", ()=>(0, _isType.isResponse));
parcelHelpers.export(exports, "isReadableStream", ()=>(0, _isType.isReadableStream));
parcelHelpers.export(exports, "isWritableStream", ()=>(0, _isType.isWritableStream));
var _fetchFile = require("./lib/fetch/fetch-file");
var _readArrayBuffer = require("./lib/fetch/read-array-buffer");
var _readFile = require("./lib/fetch/read-file");
var _writeFile = require("./lib/fetch/write-file");
var _loaderOptions = require("./lib/api/loader-options");
var _registerLoaders = require("./lib/api/register-loaders");
var _selectLoader = require("./lib/api/select-loader");
var _parse = require("./lib/api/parse");
var _parseSync = require("./lib/api/parse-sync");
var _parseInBatches = require("./lib/api/parse-in-batches");
var _load = require("./lib/api/load");
var _loadInBatches = require("./lib/api/load-in-batches");
var _encode = require("./lib/api/encode");
var _save = require("./lib/api/save");
var _loaderUtils = require("@loaders.gl/loader-utils");
var _makeIterator = require("./iterators/make-iterator/make-iterator");
var _makeNodeStream = require("./iterators/make-stream/make-node-stream");
var _nullLoader = require("./null-loader");
var _fetchProgress = require("./lib/progress/fetch-progress");
var _fetchProgressDefault = parcelHelpers.interopDefault(_fetchProgress);
var _browserFilesystem = require("./lib/filesystems/browser-filesystem");
var _browserFilesystemDefault = parcelHelpers.interopDefault(_browserFilesystem);
var _isType = require("./javascript-utils/is-type");

},{"./lib/fetch/fetch-file":"1jy9e","./lib/fetch/read-array-buffer":false,"./lib/fetch/read-file":false,"./lib/fetch/write-file":false,"./lib/api/loader-options":false,"./lib/api/register-loaders":"il5Nd","./lib/api/select-loader":"lStT8","./lib/api/parse":"k1WZf","./lib/api/parse-sync":false,"./lib/api/parse-in-batches":false,"./lib/api/load":"akPph","./lib/api/load-in-batches":false,"./lib/api/encode":false,"./lib/api/save":false,"@loaders.gl/loader-utils":"dIGVb","./iterators/make-iterator/make-iterator":"ix2Cu","./iterators/make-stream/make-node-stream":false,"./null-loader":false,"./lib/progress/fetch-progress":false,"./lib/filesystems/browser-filesystem":false,"./javascript-utils/is-type":"8cOpM","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1jy9e":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "fetchFile", ()=>fetchFile);
var _loaderUtils = require("@loaders.gl/loader-utils");
var _responseUtils = require("../utils/response-utils");
async function fetchFile(url, options) {
    if (typeof url === "string") {
        url = (0, _loaderUtils.resolvePath)(url);
        let fetchOptions = options;
        if (options !== null && options !== void 0 && options.fetch && typeof (options === null || options === void 0 ? void 0 : options.fetch) !== "function") fetchOptions = options.fetch;
        return await fetch(url, fetchOptions);
    }
    return await (0, _responseUtils.makeResponse)(url);
}

},{"@loaders.gl/loader-utils":"dIGVb","../utils/response-utils":"aPIYv","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dIGVb":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assert", ()=>(0, _assert.assert));
parcelHelpers.export(exports, "isBrowser", ()=>(0, _globals.isBrowser));
parcelHelpers.export(exports, "isWorker", ()=>(0, _globals.isWorker));
parcelHelpers.export(exports, "nodeVersion", ()=>(0, _globals.nodeVersion));
parcelHelpers.export(exports, "self", ()=>(0, _globals.self));
parcelHelpers.export(exports, "window", ()=>(0, _globals.window));
parcelHelpers.export(exports, "global", ()=>(0, _globals.global));
parcelHelpers.export(exports, "document", ()=>(0, _globals.document));
parcelHelpers.export(exports, "createLoaderWorker", ()=>(0, _createLoaderWorker.createLoaderWorker));
parcelHelpers.export(exports, "parseWithWorker", ()=>(0, _parseWithWorker.parseWithWorker));
parcelHelpers.export(exports, "canParseWithWorker", ()=>(0, _parseWithWorker.canParseWithWorker));
parcelHelpers.export(exports, "canEncodeWithWorker", ()=>(0, _encodeWithWorker.canEncodeWithWorker));
parcelHelpers.export(exports, "parseJSON", ()=>(0, _parseJson.parseJSON));
parcelHelpers.export(exports, "toArrayBuffer", ()=>(0, _arrayBufferUtils.toArrayBuffer));
parcelHelpers.export(exports, "sliceArrayBuffer", ()=>(0, _arrayBufferUtils.sliceArrayBuffer));
parcelHelpers.export(exports, "concatenateArrayBuffers", ()=>(0, _arrayBufferUtils.concatenateArrayBuffers));
parcelHelpers.export(exports, "concatenateTypedArrays", ()=>(0, _arrayBufferUtils.concatenateTypedArrays));
parcelHelpers.export(exports, "compareArrayBuffers", ()=>(0, _arrayBufferUtils.compareArrayBuffers));
parcelHelpers.export(exports, "padToNBytes", ()=>(0, _memoryCopyUtils.padToNBytes));
parcelHelpers.export(exports, "copyToArray", ()=>(0, _memoryCopyUtils.copyToArray));
parcelHelpers.export(exports, "copyArrayBuffer", ()=>(0, _memoryCopyUtils.copyArrayBuffer));
parcelHelpers.export(exports, "copyPaddedArrayBufferToDataView", ()=>(0, _binaryCopyUtils.copyPaddedArrayBufferToDataView));
parcelHelpers.export(exports, "copyPaddedStringToDataView", ()=>(0, _binaryCopyUtils.copyPaddedStringToDataView));
parcelHelpers.export(exports, "padStringToByteAlignment", ()=>(0, _encodeUtils.padStringToByteAlignment));
parcelHelpers.export(exports, "copyStringToDataView", ()=>(0, _encodeUtils.copyStringToDataView));
parcelHelpers.export(exports, "copyBinaryToDataView", ()=>(0, _encodeUtils.copyBinaryToDataView));
parcelHelpers.export(exports, "getFirstCharacters", ()=>(0, _getFirstCharacters.getFirstCharacters));
parcelHelpers.export(exports, "getMagicString", ()=>(0, _getFirstCharacters.getMagicString));
parcelHelpers.export(exports, "makeTextEncoderIterator", ()=>(0, _textIterators.makeTextEncoderIterator));
parcelHelpers.export(exports, "makeTextDecoderIterator", ()=>(0, _textIterators.makeTextDecoderIterator));
parcelHelpers.export(exports, "makeLineIterator", ()=>(0, _textIterators.makeLineIterator));
parcelHelpers.export(exports, "makeNumberedLineIterator", ()=>(0, _textIterators.makeNumberedLineIterator));
parcelHelpers.export(exports, "forEach", ()=>(0, _asyncIteration.forEach));
parcelHelpers.export(exports, "concatenateArrayBuffersAsync", ()=>(0, _asyncIteration.concatenateArrayBuffersAsync));
parcelHelpers.export(exports, "RequestScheduler", ()=>(0, _requestSchedulerDefault.default));
parcelHelpers.export(exports, "setPathPrefix", ()=>(0, _fileAliases.setPathPrefix));
parcelHelpers.export(exports, "getPathPrefix", ()=>(0, _fileAliases.getPathPrefix));
parcelHelpers.export(exports, "resolvePath", ()=>(0, _fileAliases.resolvePath));
parcelHelpers.export(exports, "_addAliases", ()=>(0, _fileAliases.addAliases));
parcelHelpers.export(exports, "JSONLoader", ()=>(0, _jsonLoader.JSONLoader));
parcelHelpers.export(exports, "isBuffer", ()=>(0, _bufferUtils.isBuffer));
parcelHelpers.export(exports, "toBuffer", ()=>(0, _bufferUtils.toBuffer));
parcelHelpers.export(exports, "bufferToArrayBuffer", ()=>(0, _bufferUtils.bufferToArrayBuffer));
parcelHelpers.export(exports, "promisify", ()=>(0, _util.promisify));
parcelHelpers.export(exports, "_NodeFileSystem", ()=>(0, _nodeFilesystemDefault.default));
parcelHelpers.export(exports, "path", ()=>_path);
parcelHelpers.export(exports, "util", ()=>_util);
parcelHelpers.export(exports, "fs", ()=>_fs);
var _assert = require("./lib/env-utils/assert");
var _globals = require("./lib/env-utils/globals");
var _createLoaderWorker = require("./lib/worker-loader-utils/create-loader-worker");
var _parseWithWorker = require("./lib/worker-loader-utils/parse-with-worker");
var _encodeWithWorker = require("./lib/worker-loader-utils/encode-with-worker");
var _parseJson = require("./lib/parser-utils/parse-json");
var _arrayBufferUtils = require("./lib/binary-utils/array-buffer-utils");
var _memoryCopyUtils = require("./lib/binary-utils/memory-copy-utils");
var _binaryCopyUtils = require("./lib/binary-utils/binary-copy-utils");
var _encodeUtils = require("./lib/binary-utils/encode-utils");
var _getFirstCharacters = require("./lib/binary-utils/get-first-characters");
var _textIterators = require("./lib/iterators/text-iterators");
var _asyncIteration = require("./lib/iterators/async-iteration");
var _requestScheduler = require("./lib/request-utils/request-scheduler");
var _requestSchedulerDefault = parcelHelpers.interopDefault(_requestScheduler);
var _fileAliases = require("./lib/path-utils/file-aliases");
var _jsonLoader = require("./json-loader");
var _path = require("./lib/path-utils/path");
var _bufferUtils = require("./lib/binary-utils/buffer-utils");
var _util = require("./lib/node/util");
var _fs = require("./lib/node/fs");
var _nodeFilesystem = require("./lib/filesystems/node-filesystem");
var _nodeFilesystemDefault = parcelHelpers.interopDefault(_nodeFilesystem);

},{"./lib/env-utils/assert":"e25iX","./lib/env-utils/globals":"dGYHJ","./lib/worker-loader-utils/create-loader-worker":false,"./lib/worker-loader-utils/parse-with-worker":"4NnDT","./lib/worker-loader-utils/encode-with-worker":false,"./lib/parser-utils/parse-json":false,"./lib/binary-utils/array-buffer-utils":"fbAGO","./lib/binary-utils/memory-copy-utils":false,"./lib/binary-utils/binary-copy-utils":false,"./lib/binary-utils/encode-utils":false,"./lib/binary-utils/get-first-characters":false,"./lib/iterators/text-iterators":"k54fu","./lib/iterators/async-iteration":"6YlSL","./lib/request-utils/request-scheduler":"fw3IW","./lib/path-utils/file-aliases":"hda0z","./json-loader":"3nK4p","./lib/path-utils/path":"fIhvt","./lib/binary-utils/buffer-utils":"ckFub","./lib/node/util":"jhUEF","./lib/node/fs":"jhUEF","./lib/filesystems/node-filesystem":false,"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"e25iX":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assert", ()=>assert);
function assert(condition, message) {
    if (!condition) throw new Error(message || "loader assertion failed.");
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dGYHJ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "self", ()=>self_);
parcelHelpers.export(exports, "window", ()=>window_);
parcelHelpers.export(exports, "global", ()=>global_);
parcelHelpers.export(exports, "document", ()=>document_);
parcelHelpers.export(exports, "isBrowser", ()=>isBrowser);
parcelHelpers.export(exports, "isWorker", ()=>isWorker);
parcelHelpers.export(exports, "nodeVersion", ()=>nodeVersion);
var global = arguments[3];
var process = require("process");
const globals = {
    self: typeof self !== "undefined" && self,
    window: typeof window !== "undefined" && window,
    global: typeof global !== "undefined" && global,
    document: typeof document !== "undefined" && document
};
const self_ = globals.self || globals.window || globals.global || {};
const window_ = globals.window || globals.self || globals.global || {};
const global_ = globals.global || globals.self || globals.window || {};
const document_ = globals.document || {};
const isBrowser = Boolean(typeof process !== "object" || String(process) !== "[object process]" || true);
const isWorker = typeof importScripts === "function";
const matches = typeof process !== "undefined" && process.version && /v([0-9]*)/.exec(process.version);
const nodeVersion = matches && parseFloat(matches[1]) || 0;

},{"process":"d5jf4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4NnDT":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "canParseWithWorker", ()=>canParseWithWorker);
parcelHelpers.export(exports, "parseWithWorker", ()=>parseWithWorker);
var _workerUtils = require("@loaders.gl/worker-utils");
function canParseWithWorker(loader, options) {
    if (!(0, _workerUtils.WorkerFarm).isSupported()) return false;
    if (!(0, _workerUtils.isBrowser) && !(options !== null && options !== void 0 && options._nodeWorkers)) return false;
    return loader.worker && (options === null || options === void 0 ? void 0 : options.worker);
}
async function parseWithWorker(loader, data, options, context, parseOnMainThread) {
    const name = loader.id;
    const url = (0, _workerUtils.getWorkerURL)(loader, options);
    const workerFarm = (0, _workerUtils.WorkerFarm).getWorkerFarm(options);
    const workerPool = workerFarm.getWorkerPool({
        name,
        url
    });
    options = JSON.parse(JSON.stringify(options));
    context = JSON.parse(JSON.stringify(context || {}));
    const job = await workerPool.startJob("process-on-worker", onMessage.bind(null, parseOnMainThread));
    job.postMessage("process", {
        input: data,
        options,
        context
    });
    const result = await job.result;
    return await result.result;
}
async function onMessage(parseOnMainThread, job, type, payload) {
    switch(type){
        case "done":
            job.done(payload);
            break;
        case "error":
            job.error(new Error(payload.error));
            break;
        case "process":
            const { id , input , options  } = payload;
            try {
                const result = await parseOnMainThread(input, options);
                job.postMessage("done", {
                    id,
                    result
                });
            } catch (error) {
                const message = error instanceof Error ? error.message : "unknown error";
                job.postMessage("error", {
                    id,
                    error: message
                });
            }
            break;
        default:
            console.warn("parse-with-worker unknown message ".concat(type));
    }
}

},{"@loaders.gl/worker-utils":"gdHyK","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gdHyK":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assert", ()=>(0, _assert.assert));
parcelHelpers.export(exports, "isBrowser", ()=>(0, _globals.isBrowser));
parcelHelpers.export(exports, "isWorker", ()=>(0, _globals.isWorker));
parcelHelpers.export(exports, "WorkerJob", ()=>(0, _workerJobDefault.default));
parcelHelpers.export(exports, "WorkerThread", ()=>(0, _workerThreadDefault.default));
parcelHelpers.export(exports, "WorkerFarm", ()=>(0, _workerFarmDefault.default));
parcelHelpers.export(exports, "WorkerPool", ()=>(0, _workerPoolDefault.default));
parcelHelpers.export(exports, "WorkerBody", ()=>(0, _workerBodyDefault.default));
parcelHelpers.export(exports, "processOnWorker", ()=>(0, _processOnWorker.processOnWorker));
parcelHelpers.export(exports, "canProcessOnWorker", ()=>(0, _processOnWorker.canProcessOnWorker));
parcelHelpers.export(exports, "createWorker", ()=>(0, _createWorker.createWorker));
parcelHelpers.export(exports, "getWorkerURL", ()=>(0, _getWorkerUrl.getWorkerURL));
parcelHelpers.export(exports, "validateWorkerVersion", ()=>(0, _validateWorkerVersion.validateWorkerVersion));
parcelHelpers.export(exports, "getTransferList", ()=>(0, _getTransferList.getTransferList));
parcelHelpers.export(exports, "getTransferListForWriter", ()=>(0, _getTransferList.getTransferListForWriter));
parcelHelpers.export(exports, "getLibraryUrl", ()=>(0, _libraryUtils.getLibraryUrl));
parcelHelpers.export(exports, "loadLibrary", ()=>(0, _libraryUtils.loadLibrary));
parcelHelpers.export(exports, "AsyncQueue", ()=>(0, _asyncQueueDefault.default));
parcelHelpers.export(exports, "ChildProcessProxy", ()=>(0, _childProcessProxyDefault.default));
parcelHelpers.export(exports, "NullWorker", ()=>NullWorker);
var _version = require("./lib/env-utils/version");
var _assert = require("./lib/env-utils/assert");
var _globals = require("./lib/env-utils/globals");
var _workerJob = require("./lib/worker-farm/worker-job");
var _workerJobDefault = parcelHelpers.interopDefault(_workerJob);
var _workerThread = require("./lib/worker-farm/worker-thread");
var _workerThreadDefault = parcelHelpers.interopDefault(_workerThread);
var _workerFarm = require("./lib/worker-farm/worker-farm");
var _workerFarmDefault = parcelHelpers.interopDefault(_workerFarm);
var _workerPool = require("./lib/worker-farm/worker-pool");
var _workerPoolDefault = parcelHelpers.interopDefault(_workerPool);
var _workerBody = require("./lib/worker-farm/worker-body");
var _workerBodyDefault = parcelHelpers.interopDefault(_workerBody);
var _processOnWorker = require("./lib/worker-api/process-on-worker");
var _createWorker = require("./lib/worker-api/create-worker");
var _getWorkerUrl = require("./lib/worker-api/get-worker-url");
var _validateWorkerVersion = require("./lib/worker-api/validate-worker-version");
var _getTransferList = require("./lib/worker-utils/get-transfer-list");
var _libraryUtils = require("./lib/library-utils/library-utils");
var _asyncQueue = require("./lib/async-queue/async-queue");
var _asyncQueueDefault = parcelHelpers.interopDefault(_asyncQueue);
var _childProcessProxy = require("./lib/process-utils/child-process-proxy");
var _childProcessProxyDefault = parcelHelpers.interopDefault(_childProcessProxy);
const NullWorker = {
    id: "null",
    name: "null",
    module: "worker-utils",
    version: (0, _version.VERSION),
    options: {
        null: {}
    }
};

},{"./lib/env-utils/version":"wh9L9","./lib/env-utils/assert":"3cQmp","./lib/env-utils/globals":"1kr2U","./lib/worker-farm/worker-job":"jiwOK","./lib/worker-farm/worker-thread":"kQxzC","./lib/worker-farm/worker-farm":"lIQeO","./lib/worker-farm/worker-pool":"4fLAD","./lib/worker-farm/worker-body":false,"./lib/worker-api/process-on-worker":false,"./lib/worker-api/create-worker":false,"./lib/worker-api/get-worker-url":"1Y2F0","./lib/worker-api/validate-worker-version":"c84Lp","./lib/worker-utils/get-transfer-list":"brtAu","./lib/library-utils/library-utils":false,"./lib/async-queue/async-queue":false,"./lib/process-utils/child-process-proxy":"jhUEF","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"wh9L9":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "VERSION", ()=>VERSION);
const DEFAULT_VERSION = "latest";
const VERSION = "3.2.12";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3cQmp":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assert", ()=>assert);
function assert(condition, message) {
    if (!condition) throw new Error(message || "loaders.gl assertion failed.");
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1kr2U":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "self", ()=>self_);
parcelHelpers.export(exports, "window", ()=>window_);
parcelHelpers.export(exports, "global", ()=>global_);
parcelHelpers.export(exports, "document", ()=>document_);
parcelHelpers.export(exports, "isBrowser", ()=>isBrowser);
parcelHelpers.export(exports, "isWorker", ()=>isWorker);
parcelHelpers.export(exports, "isMobile", ()=>isMobile);
parcelHelpers.export(exports, "nodeVersion", ()=>nodeVersion);
var process = require("process");
var global = arguments[3];
const globals = {
    self: typeof self !== "undefined" && self,
    window: typeof window !== "undefined" && window,
    global: typeof global !== "undefined" && global,
    document: typeof document !== "undefined" && document
};
const self_ = globals.self || globals.window || globals.global || {};
const window_ = globals.window || globals.self || globals.global || {};
const global_ = globals.global || globals.self || globals.window || {};
const document_ = globals.document || {};
const isBrowser = typeof process !== "object" || String(process) !== "[object process]" || true;
const isWorker = typeof importScripts === "function";
const isMobile = typeof window !== "undefined" && typeof window.orientation !== "undefined";
const matches = typeof process !== "undefined" && process.version && /v([0-9]*)/.exec(process.version);
const nodeVersion = matches && parseFloat(matches[1]) || 0;

},{"process":"d5jf4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jiwOK":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _assert = require("../env-utils/assert");
class WorkerJob {
    constructor(jobName, workerThread){
        (0, _definePropertyDefault.default)(this, "name", void 0);
        (0, _definePropertyDefault.default)(this, "workerThread", void 0);
        (0, _definePropertyDefault.default)(this, "isRunning", true);
        (0, _definePropertyDefault.default)(this, "result", void 0);
        (0, _definePropertyDefault.default)(this, "_resolve", ()=>{});
        (0, _definePropertyDefault.default)(this, "_reject", ()=>{});
        this.name = jobName;
        this.workerThread = workerThread;
        this.result = new Promise((resolve, reject)=>{
            this._resolve = resolve;
            this._reject = reject;
        });
    }
    postMessage(type, payload) {
        this.workerThread.postMessage({
            source: "loaders.gl",
            type,
            payload
        });
    }
    done(value) {
        (0, _assert.assert)(this.isRunning);
        this.isRunning = false;
        this._resolve(value);
    }
    error(error) {
        (0, _assert.assert)(this.isRunning);
        this.isRunning = false;
        this._reject(error);
    }
}
exports.default = WorkerJob;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../env-utils/assert":"3cQmp","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kQxzC":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _workerThreads = require("../node/worker_threads");
var _globals = require("../env-utils/globals");
var _assert = require("../env-utils/assert");
var _getLoadableWorkerUrl = require("../worker-utils/get-loadable-worker-url");
var _getTransferList = require("../worker-utils/get-transfer-list");
const NOOP = ()=>{};
class WorkerThread {
    static isSupported() {
        return typeof Worker !== "undefined" && (0, _globals.isBrowser) || typeof (0, _workerThreads.Worker) !== "undefined" && !(0, _globals.isBrowser);
    }
    constructor(props){
        (0, _definePropertyDefault.default)(this, "name", void 0);
        (0, _definePropertyDefault.default)(this, "source", void 0);
        (0, _definePropertyDefault.default)(this, "url", void 0);
        (0, _definePropertyDefault.default)(this, "terminated", false);
        (0, _definePropertyDefault.default)(this, "worker", void 0);
        (0, _definePropertyDefault.default)(this, "onMessage", void 0);
        (0, _definePropertyDefault.default)(this, "onError", void 0);
        (0, _definePropertyDefault.default)(this, "_loadableURL", "");
        const { name , source , url  } = props;
        (0, _assert.assert)(source || url);
        this.name = name;
        this.source = source;
        this.url = url;
        this.onMessage = NOOP;
        this.onError = (error)=>console.log(error);
        this.worker = (0, _globals.isBrowser) ? this._createBrowserWorker() : this._createNodeWorker();
    }
    destroy() {
        this.onMessage = NOOP;
        this.onError = NOOP;
        this.worker.terminate();
        this.terminated = true;
    }
    get isRunning() {
        return Boolean(this.onMessage);
    }
    postMessage(data, transferList) {
        transferList = transferList || (0, _getTransferList.getTransferList)(data);
        this.worker.postMessage(data, transferList);
    }
    _getErrorFromErrorEvent(event) {
        let message = "Failed to load ";
        message += "worker ".concat(this.name, " from ").concat(this.url, ". ");
        if (event.message) message += "".concat(event.message, " in ");
        if (event.lineno) message += ":".concat(event.lineno, ":").concat(event.colno);
        return new Error(message);
    }
    _createBrowserWorker() {
        this._loadableURL = (0, _getLoadableWorkerUrl.getLoadableWorkerURL)({
            source: this.source,
            url: this.url
        });
        const worker = new Worker(this._loadableURL, {
            name: this.name
        });
        worker.onmessage = (event)=>{
            if (!event.data) this.onError(new Error("No data received"));
            else this.onMessage(event.data);
        };
        worker.onerror = (error)=>{
            this.onError(this._getErrorFromErrorEvent(error));
            this.terminated = true;
        };
        worker.onmessageerror = (event)=>console.error(event);
        return worker;
    }
    _createNodeWorker() {
        let worker;
        if (this.url) {
            const absolute = this.url.includes(":/") || this.url.startsWith("/");
            const url = absolute ? this.url : "./".concat(this.url);
            worker = new (0, _workerThreads.Worker)(url, {
                eval: false
            });
        } else if (this.source) worker = new (0, _workerThreads.Worker)(this.source, {
            eval: true
        });
        else throw new Error("no worker");
        worker.on("message", (data)=>{
            this.onMessage(data);
        });
        worker.on("error", (error)=>{
            this.onError(error);
        });
        worker.on("exit", (code)=>{});
        return worker;
    }
}
exports.default = WorkerThread;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../node/worker_threads":"gCoku","../env-utils/globals":"1kr2U","../env-utils/assert":"3cQmp","../worker-utils/get-loadable-worker-url":"sz97C","../worker-utils/get-transfer-list":"brtAu","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gCoku":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Worker", ()=>Worker);
parcelHelpers.export(exports, "parentPort", ()=>parentPort);
class Worker {
}
const parentPort = null;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"sz97C":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getLoadableWorkerURL", ()=>getLoadableWorkerURL);
var _assert = require("../env-utils/assert");
const workerURLCache = new Map();
function getLoadableWorkerURL(props) {
    (0, _assert.assert)(props.source && !props.url || !props.source && props.url);
    let workerURL = workerURLCache.get(props.source || props.url);
    if (!workerURL) {
        if (props.url) {
            workerURL = getLoadableWorkerURLFromURL(props.url);
            workerURLCache.set(props.url, workerURL);
        }
        if (props.source) {
            workerURL = getLoadableWorkerURLFromSource(props.source);
            workerURLCache.set(props.source, workerURL);
        }
    }
    (0, _assert.assert)(workerURL);
    return workerURL;
}
function getLoadableWorkerURLFromURL(url) {
    if (!url.startsWith("http")) return url;
    const workerSource = buildScriptSource(url);
    return getLoadableWorkerURLFromSource(workerSource);
}
function getLoadableWorkerURLFromSource(workerSource) {
    const blob = new Blob([
        workerSource
    ], {
        type: "application/javascript"
    });
    return URL.createObjectURL(blob);
}
function buildScriptSource(workerUrl) {
    return "try {\n  importScripts('".concat(workerUrl, "');\n} catch (error) {\n  console.error(error);\n  throw error;\n}");
}

},{"../env-utils/assert":"3cQmp","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"brtAu":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getTransferList", ()=>getTransferList);
parcelHelpers.export(exports, "getTransferListForWriter", ()=>getTransferListForWriter);
function getTransferList(object, recursive = true, transfers) {
    const transfersSet = transfers || new Set();
    if (!object) ;
    else if (isTransferable(object)) transfersSet.add(object);
    else if (isTransferable(object.buffer)) transfersSet.add(object.buffer);
    else if (ArrayBuffer.isView(object)) ;
    else if (recursive && typeof object === "object") for(const key in object)getTransferList(object[key], recursive, transfersSet);
    return transfers === undefined ? Array.from(transfersSet) : [];
}
function isTransferable(object) {
    if (!object) return false;
    if (object instanceof ArrayBuffer) return true;
    if (typeof MessagePort !== "undefined" && object instanceof MessagePort) return true;
    if (typeof ImageBitmap !== "undefined" && object instanceof ImageBitmap) return true;
    if (typeof OffscreenCanvas !== "undefined" && object instanceof OffscreenCanvas) return true;
    return false;
}
function getTransferListForWriter(object) {
    if (object === null) return {};
    const clone = Object.assign({}, object);
    Object.keys(clone).forEach((key)=>{
        if (typeof object[key] === "object" && !ArrayBuffer.isView(object[key])) clone[key] = getTransferListForWriter(object[key]);
        else if (typeof clone[key] === "function" || clone[key] instanceof RegExp) clone[key] = {};
        else clone[key] = object[key];
    });
    return clone;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lIQeO":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _workerPool = require("./worker-pool");
var _workerPoolDefault = parcelHelpers.interopDefault(_workerPool);
var _workerThread = require("./worker-thread");
var _workerThreadDefault = parcelHelpers.interopDefault(_workerThread);
const DEFAULT_PROPS = {
    maxConcurrency: 3,
    maxMobileConcurrency: 1,
    reuseWorkers: true,
    onDebug: ()=>{}
};
class WorkerFarm {
    static isSupported() {
        return (0, _workerThreadDefault.default).isSupported();
    }
    static getWorkerFarm(props = {}) {
        WorkerFarm._workerFarm = WorkerFarm._workerFarm || new WorkerFarm({});
        WorkerFarm._workerFarm.setProps(props);
        return WorkerFarm._workerFarm;
    }
    constructor(props){
        (0, _definePropertyDefault.default)(this, "props", void 0);
        (0, _definePropertyDefault.default)(this, "workerPools", new Map());
        this.props = {
            ...DEFAULT_PROPS
        };
        this.setProps(props);
        this.workerPools = new Map();
    }
    destroy() {
        for (const workerPool of this.workerPools.values())workerPool.destroy();
        this.workerPools = new Map();
    }
    setProps(props) {
        this.props = {
            ...this.props,
            ...props
        };
        for (const workerPool of this.workerPools.values())workerPool.setProps(this._getWorkerPoolProps());
    }
    getWorkerPool(options) {
        const { name , source , url  } = options;
        let workerPool = this.workerPools.get(name);
        if (!workerPool) {
            workerPool = new (0, _workerPoolDefault.default)({
                name,
                source,
                url
            });
            workerPool.setProps(this._getWorkerPoolProps());
            this.workerPools.set(name, workerPool);
        }
        return workerPool;
    }
    _getWorkerPoolProps() {
        return {
            maxConcurrency: this.props.maxConcurrency,
            maxMobileConcurrency: this.props.maxMobileConcurrency,
            reuseWorkers: this.props.reuseWorkers,
            onDebug: this.props.onDebug
        };
    }
}
exports.default = WorkerFarm;
(0, _definePropertyDefault.default)(WorkerFarm, "_workerFarm", void 0);

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./worker-pool":"4fLAD","./worker-thread":"kQxzC","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4fLAD":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _globals = require("../env-utils/globals");
var _workerThread = require("./worker-thread");
var _workerThreadDefault = parcelHelpers.interopDefault(_workerThread);
var _workerJob = require("./worker-job");
var _workerJobDefault = parcelHelpers.interopDefault(_workerJob);
class WorkerPool {
    static isSupported() {
        return (0, _workerThreadDefault.default).isSupported();
    }
    constructor(props){
        (0, _definePropertyDefault.default)(this, "name", "unnamed");
        (0, _definePropertyDefault.default)(this, "source", void 0);
        (0, _definePropertyDefault.default)(this, "url", void 0);
        (0, _definePropertyDefault.default)(this, "maxConcurrency", 1);
        (0, _definePropertyDefault.default)(this, "maxMobileConcurrency", 1);
        (0, _definePropertyDefault.default)(this, "onDebug", ()=>{});
        (0, _definePropertyDefault.default)(this, "reuseWorkers", true);
        (0, _definePropertyDefault.default)(this, "props", {});
        (0, _definePropertyDefault.default)(this, "jobQueue", []);
        (0, _definePropertyDefault.default)(this, "idleQueue", []);
        (0, _definePropertyDefault.default)(this, "count", 0);
        (0, _definePropertyDefault.default)(this, "isDestroyed", false);
        this.source = props.source;
        this.url = props.url;
        this.setProps(props);
    }
    destroy() {
        this.idleQueue.forEach((worker)=>worker.destroy());
        this.isDestroyed = true;
    }
    setProps(props) {
        this.props = {
            ...this.props,
            ...props
        };
        if (props.name !== undefined) this.name = props.name;
        if (props.maxConcurrency !== undefined) this.maxConcurrency = props.maxConcurrency;
        if (props.maxMobileConcurrency !== undefined) this.maxMobileConcurrency = props.maxMobileConcurrency;
        if (props.reuseWorkers !== undefined) this.reuseWorkers = props.reuseWorkers;
        if (props.onDebug !== undefined) this.onDebug = props.onDebug;
    }
    async startJob(name, onMessage = (job, type, data)=>job.done(data), onError = (job, error)=>job.error(error)) {
        const startPromise = new Promise((onStart)=>{
            this.jobQueue.push({
                name,
                onMessage,
                onError,
                onStart
            });
            return this;
        });
        this._startQueuedJob();
        return await startPromise;
    }
    async _startQueuedJob() {
        if (!this.jobQueue.length) return;
        const workerThread = this._getAvailableWorker();
        if (!workerThread) return;
        const queuedJob = this.jobQueue.shift();
        if (queuedJob) {
            this.onDebug({
                message: "Starting job",
                name: queuedJob.name,
                workerThread,
                backlog: this.jobQueue.length
            });
            const job = new (0, _workerJobDefault.default)(queuedJob.name, workerThread);
            workerThread.onMessage = (data)=>queuedJob.onMessage(job, data.type, data.payload);
            workerThread.onError = (error)=>queuedJob.onError(job, error);
            queuedJob.onStart(job);
            try {
                await job.result;
            } finally{
                this.returnWorkerToQueue(workerThread);
            }
        }
    }
    returnWorkerToQueue(worker) {
        const shouldDestroyWorker = this.isDestroyed || !this.reuseWorkers || this.count > this._getMaxConcurrency();
        if (shouldDestroyWorker) {
            worker.destroy();
            this.count--;
        } else this.idleQueue.push(worker);
        if (!this.isDestroyed) this._startQueuedJob();
    }
    _getAvailableWorker() {
        if (this.idleQueue.length > 0) return this.idleQueue.shift() || null;
        if (this.count < this._getMaxConcurrency()) {
            this.count++;
            const name = "".concat(this.name.toLowerCase(), " (#").concat(this.count, " of ").concat(this.maxConcurrency, ")");
            return new (0, _workerThreadDefault.default)({
                name,
                source: this.source,
                url: this.url
            });
        }
        return null;
    }
    _getMaxConcurrency() {
        return (0, _globals.isMobile) ? this.maxMobileConcurrency : this.maxConcurrency;
    }
}
exports.default = WorkerPool;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../env-utils/globals":"1kr2U","./worker-thread":"kQxzC","./worker-job":"jiwOK","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1Y2F0":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getWorkerName", ()=>getWorkerName);
parcelHelpers.export(exports, "getWorkerURL", ()=>getWorkerURL);
var _assert = require("../env-utils/assert");
var _version = require("../env-utils/version");
const NPM_TAG = "latest";
const VERSION = "3.2.12";
function getWorkerName(worker) {
    const warning = worker.version !== VERSION ? " (worker-utils@".concat(VERSION, ")") : "";
    return "".concat(worker.name, "@").concat(worker.version).concat(warning);
}
function getWorkerURL(worker, options = {}) {
    const workerOptions = options[worker.id] || {};
    const workerFile = "".concat(worker.id, "-worker.js");
    let url = workerOptions.workerUrl;
    if (!url && worker.id === "compression") url = options.workerUrl;
    if (options._workerType === "test") url = "modules/".concat(worker.module, "/dist/").concat(workerFile);
    if (!url) {
        let version = worker.version;
        if (version === "latest") version = NPM_TAG;
        const versionTag = version ? "@".concat(version) : "";
        url = "https://unpkg.com/@loaders.gl/".concat(worker.module).concat(versionTag, "/dist/").concat(workerFile);
    }
    (0, _assert.assert)(url);
    return url;
}

},{"../env-utils/assert":"3cQmp","../env-utils/version":"wh9L9","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"c84Lp":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "validateWorkerVersion", ()=>validateWorkerVersion);
var _assert = require("../env-utils/assert");
var _version = require("../env-utils/version");
function validateWorkerVersion(worker, coreVersion = (0, _version.VERSION)) {
    (0, _assert.assert)(worker, "no worker provided");
    const workerVersion = worker.version;
    if (!coreVersion || !workerVersion) return false;
    return true;
}
function parseVersion(version) {
    const parts = version.split(".").map(Number);
    return {
        major: parts[0],
        minor: parts[1]
    };
}

},{"../env-utils/assert":"3cQmp","../env-utils/version":"wh9L9","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jhUEF":[function(require,module,exports) {
"use strict";

},{}],"fbAGO":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "toArrayBuffer", ()=>toArrayBuffer);
parcelHelpers.export(exports, "compareArrayBuffers", ()=>compareArrayBuffers);
parcelHelpers.export(exports, "concatenateArrayBuffers", ()=>concatenateArrayBuffers);
parcelHelpers.export(exports, "concatenateTypedArrays", ()=>concatenateTypedArrays);
parcelHelpers.export(exports, "sliceArrayBuffer", ()=>sliceArrayBuffer);
var _bufferUtils = require("./buffer-utils");
function toArrayBuffer(data) {
    if ((0, _bufferUtils.isBuffer)(data)) return (0, _bufferUtils.bufferToArrayBuffer)(data);
    if (data instanceof ArrayBuffer) return data;
    if (ArrayBuffer.isView(data)) {
        if (data.byteOffset === 0 && data.byteLength === data.buffer.byteLength) return data.buffer;
        return data.buffer.slice(data.byteOffset, data.byteOffset + data.byteLength);
    }
    if (typeof data === "string") {
        const text = data;
        const uint8Array = new TextEncoder().encode(text);
        return uint8Array.buffer;
    }
    if (data && typeof data === "object" && data._toArrayBuffer) return data._toArrayBuffer();
    throw new Error("toArrayBuffer");
}
function compareArrayBuffers(arrayBuffer1, arrayBuffer2, byteLength) {
    byteLength = byteLength || arrayBuffer1.byteLength;
    if (arrayBuffer1.byteLength < byteLength || arrayBuffer2.byteLength < byteLength) return false;
    const array1 = new Uint8Array(arrayBuffer1);
    const array2 = new Uint8Array(arrayBuffer2);
    for(let i = 0; i < array1.length; ++i){
        if (array1[i] !== array2[i]) return false;
    }
    return true;
}
function concatenateArrayBuffers(...sources) {
    const sourceArrays = sources.map((source2)=>source2 instanceof ArrayBuffer ? new Uint8Array(source2) : source2);
    const byteLength = sourceArrays.reduce((length, typedArray)=>length + typedArray.byteLength, 0);
    const result = new Uint8Array(byteLength);
    let offset = 0;
    for (const sourceArray of sourceArrays){
        result.set(sourceArray, offset);
        offset += sourceArray.byteLength;
    }
    return result.buffer;
}
function concatenateTypedArrays(...typedArrays) {
    const arrays = typedArrays;
    const TypedArrayConstructor = arrays && arrays.length > 1 && arrays[0].constructor || null;
    if (!TypedArrayConstructor) throw new Error('"concatenateTypedArrays" - incorrect quantity of arguments or arguments have incompatible data types');
    const sumLength = arrays.reduce((acc, value)=>acc + value.length, 0);
    const result = new TypedArrayConstructor(sumLength);
    let offset = 0;
    for (const array of arrays){
        result.set(array, offset);
        offset += array.length;
    }
    return result;
}
function sliceArrayBuffer(arrayBuffer, byteOffset, byteLength) {
    const subArray = byteLength !== undefined ? new Uint8Array(arrayBuffer).subarray(byteOffset, byteOffset + byteLength) : new Uint8Array(arrayBuffer).subarray(byteOffset);
    const arrayCopy = new Uint8Array(subArray);
    return arrayCopy.buffer;
}

},{"./buffer-utils":"ckFub","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ckFub":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isBuffer", ()=>isBuffer);
parcelHelpers.export(exports, "toBuffer", ()=>toBuffer);
parcelHelpers.export(exports, "bufferToArrayBuffer", ()=>bufferToArrayBuffer);
var _buffer = require("../node/buffer");
function isBuffer(value) {
    return value && typeof value === "object" && value.isBuffer;
}
function toBuffer(data) {
    return _buffer.toBuffer ? _buffer.toBuffer(data) : data;
}
function bufferToArrayBuffer(buffer) {
    if (isBuffer(buffer)) {
        const typedArray = new Uint8Array(buffer.buffer, buffer.byteOffset, buffer.length);
        return typedArray.slice().buffer;
    }
    return buffer;
}

},{"../node/buffer":"jhUEF","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"k54fu":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "makeTextDecoderIterator", ()=>makeTextDecoderIterator);
parcelHelpers.export(exports, "makeTextEncoderIterator", ()=>makeTextEncoderIterator);
parcelHelpers.export(exports, "makeLineIterator", ()=>makeLineIterator);
parcelHelpers.export(exports, "makeNumberedLineIterator", ()=>makeNumberedLineIterator);
async function* makeTextDecoderIterator(arrayBufferIterator, options = {}) {
    const textDecoder = new TextDecoder(undefined, options);
    for await (const arrayBuffer of arrayBufferIterator)yield typeof arrayBuffer === "string" ? arrayBuffer : textDecoder.decode(arrayBuffer, {
        stream: true
    });
}
async function* makeTextEncoderIterator(textIterator) {
    const textEncoder = new TextEncoder();
    for await (const text of textIterator)yield typeof text === "string" ? textEncoder.encode(text) : text;
}
async function* makeLineIterator(textIterator) {
    let previous = "";
    for await (const textChunk of textIterator){
        previous += textChunk;
        let eolIndex;
        while((eolIndex = previous.indexOf("\n")) >= 0){
            const line = previous.slice(0, eolIndex + 1);
            previous = previous.slice(eolIndex + 1);
            yield line;
        }
    }
    if (previous.length > 0) yield previous;
}
async function* makeNumberedLineIterator(lineIterator) {
    let counter = 1;
    for await (const line of lineIterator){
        yield {
            counter,
            line
        };
        counter++;
    }
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6YlSL":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "forEach", ()=>forEach);
parcelHelpers.export(exports, "concatenateArrayBuffersAsync", ()=>concatenateArrayBuffersAsync);
parcelHelpers.export(exports, "concatenateStringsAsync", ()=>concatenateStringsAsync);
var _arrayBufferUtils = require("../binary-utils/array-buffer-utils");
async function forEach(iterator, visitor) {
    while(true){
        const { done , value  } = await iterator.next();
        if (done) {
            iterator.return();
            return;
        }
        const cancel = visitor(value);
        if (cancel) return;
    }
}
async function concatenateArrayBuffersAsync(asyncIterator) {
    const arrayBuffers = [];
    for await (const chunk of asyncIterator)arrayBuffers.push(chunk);
    return (0, _arrayBufferUtils.concatenateArrayBuffers)(...arrayBuffers);
}
async function concatenateStringsAsync(asyncIterator) {
    const strings = [];
    for await (const chunk of asyncIterator)strings.push(chunk);
    return strings.join("");
}

},{"../binary-utils/array-buffer-utils":"fbAGO","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fw3IW":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _stats = require("@probe.gl/stats");
const STAT_QUEUED_REQUESTS = "Queued Requests";
const STAT_ACTIVE_REQUESTS = "Active Requests";
const STAT_CANCELLED_REQUESTS = "Cancelled Requests";
const STAT_QUEUED_REQUESTS_EVER = "Queued Requests Ever";
const STAT_ACTIVE_REQUESTS_EVER = "Active Requests Ever";
const DEFAULT_PROPS = {
    id: "request-scheduler",
    throttleRequests: true,
    maxRequests: 6
};
class RequestScheduler {
    constructor(props = {}){
        (0, _definePropertyDefault.default)(this, "props", void 0);
        (0, _definePropertyDefault.default)(this, "stats", void 0);
        (0, _definePropertyDefault.default)(this, "activeRequestCount", 0);
        (0, _definePropertyDefault.default)(this, "requestQueue", []);
        (0, _definePropertyDefault.default)(this, "requestMap", new Map());
        (0, _definePropertyDefault.default)(this, "deferredUpdate", null);
        this.props = {
            ...DEFAULT_PROPS,
            ...props
        };
        this.stats = new (0, _stats.Stats)({
            id: this.props.id
        });
        this.stats.get(STAT_QUEUED_REQUESTS);
        this.stats.get(STAT_ACTIVE_REQUESTS);
        this.stats.get(STAT_CANCELLED_REQUESTS);
        this.stats.get(STAT_QUEUED_REQUESTS_EVER);
        this.stats.get(STAT_ACTIVE_REQUESTS_EVER);
    }
    scheduleRequest(handle, getPriority = ()=>0) {
        if (!this.props.throttleRequests) return Promise.resolve({
            done: ()=>{}
        });
        if (this.requestMap.has(handle)) return this.requestMap.get(handle);
        const request = {
            handle,
            priority: 0,
            getPriority
        };
        const promise = new Promise((resolve)=>{
            request.resolve = resolve;
            return request;
        });
        this.requestQueue.push(request);
        this.requestMap.set(handle, promise);
        this._issueNewRequests();
        return promise;
    }
    _issueRequest(request) {
        const { handle , resolve  } = request;
        let isDone = false;
        const done = ()=>{
            if (!isDone) {
                isDone = true;
                this.requestMap.delete(handle);
                this.activeRequestCount--;
                this._issueNewRequests();
            }
        };
        this.activeRequestCount++;
        return resolve ? resolve({
            done
        }) : Promise.resolve({
            done
        });
    }
    _issueNewRequests() {
        if (!this.deferredUpdate) this.deferredUpdate = setTimeout(()=>this._issueNewRequestsAsync(), 0);
    }
    _issueNewRequestsAsync() {
        this.deferredUpdate = null;
        const freeSlots = Math.max(this.props.maxRequests - this.activeRequestCount, 0);
        if (freeSlots === 0) return;
        this._updateAllRequests();
        for(let i = 0; i < freeSlots; ++i){
            const request = this.requestQueue.shift();
            if (request) this._issueRequest(request);
        }
    }
    _updateAllRequests() {
        const requestQueue = this.requestQueue;
        for(let i = 0; i < requestQueue.length; ++i){
            const request = requestQueue[i];
            if (!this._updateRequest(request)) {
                requestQueue.splice(i, 1);
                this.requestMap.delete(request.handle);
                i--;
            }
        }
        requestQueue.sort((a, b)=>a.priority - b.priority);
    }
    _updateRequest(request) {
        request.priority = request.getPriority(request.handle);
        if (request.priority < 0) {
            request.resolve(null);
            return false;
        }
        return true;
    }
}
exports.default = RequestScheduler;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@probe.gl/stats":"krQZu","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"krQZu":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Stats", ()=>(0, _statsDefault.default));
parcelHelpers.export(exports, "Stat", ()=>(0, _statDefault.default));
parcelHelpers.export(exports, "_getHiResTimestamp", ()=>(0, _hiResTimestampDefault.default));
var _stats = require("./lib/stats");
var _statsDefault = parcelHelpers.interopDefault(_stats);
var _stat = require("./lib/stat");
var _statDefault = parcelHelpers.interopDefault(_stat);
var _hiResTimestamp = require("./utils/hi-res-timestamp");
var _hiResTimestampDefault = parcelHelpers.interopDefault(_hiResTimestamp);

},{"./lib/stats":"qjKR9","./lib/stat":"ebeOH","./utils/hi-res-timestamp":"bGuET","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"qjKR9":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _stat = require("./stat");
var _statDefault = parcelHelpers.interopDefault(_stat);
class Stats {
    constructor(options){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "stats", {});
        this.id = options.id;
        this.stats = {};
        this._initializeStats(options.stats);
        Object.seal(this);
    }
    get(name) {
        let type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "count";
        return this._getOrCreate({
            name,
            type
        });
    }
    get size() {
        return Object.keys(this.stats).length;
    }
    reset() {
        for(const key in this.stats)this.stats[key].reset();
        return this;
    }
    forEach(fn) {
        for(const key in this.stats)fn(this.stats[key]);
    }
    getTable() {
        const table = {};
        this.forEach((stat)=>{
            table[stat.name] = {
                time: stat.time || 0,
                count: stat.count || 0,
                average: stat.getAverageTime() || 0,
                hz: stat.getHz() || 0
            };
        });
        return table;
    }
    _initializeStats() {
        let stats = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        stats.forEach((stat)=>this._getOrCreate(stat));
    }
    _getOrCreate(stat) {
        if (!stat || !stat.name) return null;
        const { name , type  } = stat;
        if (!this.stats[name]) {
            if (stat instanceof (0, _statDefault.default)) this.stats[name] = stat;
            else this.stats[name] = new (0, _statDefault.default)(name, type);
        }
        return this.stats[name];
    }
}
exports.default = Stats;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./stat":"ebeOH","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ebeOH":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _hiResTimestamp = require("../utils/hi-res-timestamp");
var _hiResTimestampDefault = parcelHelpers.interopDefault(_hiResTimestamp);
class Stat {
    constructor(name, type){
        (0, _definePropertyDefault.default)(this, "name", void 0);
        (0, _definePropertyDefault.default)(this, "type", void 0);
        (0, _definePropertyDefault.default)(this, "sampleSize", 1);
        (0, _definePropertyDefault.default)(this, "time", void 0);
        (0, _definePropertyDefault.default)(this, "count", void 0);
        (0, _definePropertyDefault.default)(this, "samples", void 0);
        (0, _definePropertyDefault.default)(this, "lastTiming", void 0);
        (0, _definePropertyDefault.default)(this, "lastSampleTime", void 0);
        (0, _definePropertyDefault.default)(this, "lastSampleCount", void 0);
        (0, _definePropertyDefault.default)(this, "_count", 0);
        (0, _definePropertyDefault.default)(this, "_time", 0);
        (0, _definePropertyDefault.default)(this, "_samples", 0);
        (0, _definePropertyDefault.default)(this, "_startTime", 0);
        (0, _definePropertyDefault.default)(this, "_timerPending", false);
        this.name = name;
        this.type = type;
        this.reset();
    }
    setSampleSize(samples) {
        this.sampleSize = samples;
        return this;
    }
    incrementCount() {
        this.addCount(1);
        return this;
    }
    decrementCount() {
        this.subtractCount(1);
        return this;
    }
    addCount(value) {
        this._count += value;
        this._samples++;
        this._checkSampling();
        return this;
    }
    subtractCount(value) {
        this._count -= value;
        this._samples++;
        this._checkSampling();
        return this;
    }
    addTime(time) {
        this._time += time;
        this.lastTiming = time;
        this._samples++;
        this._checkSampling();
        return this;
    }
    timeStart() {
        this._startTime = (0, _hiResTimestampDefault.default)();
        this._timerPending = true;
        return this;
    }
    timeEnd() {
        if (!this._timerPending) return this;
        this.addTime((0, _hiResTimestampDefault.default)() - this._startTime);
        this._timerPending = false;
        this._checkSampling();
        return this;
    }
    getSampleAverageCount() {
        return this.sampleSize > 0 ? this.lastSampleCount / this.sampleSize : 0;
    }
    getSampleAverageTime() {
        return this.sampleSize > 0 ? this.lastSampleTime / this.sampleSize : 0;
    }
    getSampleHz() {
        return this.lastSampleTime > 0 ? this.sampleSize / (this.lastSampleTime / 1000) : 0;
    }
    getAverageCount() {
        return this.samples > 0 ? this.count / this.samples : 0;
    }
    getAverageTime() {
        return this.samples > 0 ? this.time / this.samples : 0;
    }
    getHz() {
        return this.time > 0 ? this.samples / (this.time / 1000) : 0;
    }
    reset() {
        this.time = 0;
        this.count = 0;
        this.samples = 0;
        this.lastTiming = 0;
        this.lastSampleTime = 0;
        this.lastSampleCount = 0;
        this._count = 0;
        this._time = 0;
        this._samples = 0;
        this._startTime = 0;
        this._timerPending = false;
        return this;
    }
    _checkSampling() {
        if (this._samples === this.sampleSize) {
            this.lastSampleTime = this._time;
            this.lastSampleCount = this._count;
            this.count += this._count;
            this.time += this._time;
            this.samples += this._samples;
            this._time = 0;
            this._count = 0;
            this._samples = 0;
        }
    }
}
exports.default = Stat;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../utils/hi-res-timestamp":"bGuET","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bGuET":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var process = require("process");
function getHiResTimestamp() {
    let timestamp;
    if (typeof window !== "undefined" && window.performance) timestamp = window.performance.now();
    else if (typeof process !== "undefined" && process.hrtime) {
        const timeParts = process.hrtime();
        timestamp = timeParts[0] * 1000 + timeParts[1] / 1e6;
    } else timestamp = Date.now();
    return timestamp;
}
exports.default = getHiResTimestamp;

},{"process":"d5jf4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"hda0z":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "setPathPrefix", ()=>setPathPrefix);
parcelHelpers.export(exports, "getPathPrefix", ()=>getPathPrefix);
parcelHelpers.export(exports, "addAliases", ()=>addAliases);
parcelHelpers.export(exports, "resolvePath", ()=>resolvePath);
let pathPrefix = "";
const fileAliases = {};
function setPathPrefix(prefix) {
    pathPrefix = prefix;
}
function getPathPrefix() {
    return pathPrefix;
}
function addAliases(aliases) {
    Object.assign(fileAliases, aliases);
}
function resolvePath(filename) {
    for(const alias in fileAliases)if (filename.startsWith(alias)) {
        const replacement = fileAliases[alias];
        filename = filename.replace(alias, replacement);
    }
    if (!filename.startsWith("http://") && !filename.startsWith("https://")) filename = "".concat(pathPrefix).concat(filename);
    return filename;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3nK4p":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "JSONLoader", ()=>JSONLoader);
parcelHelpers.export(exports, "_typecheckJSONLoader", ()=>_typecheckJSONLoader);
const VERSION = "3.2.12";
const JSONLoader = {
    name: "JSON",
    id: "json",
    module: "json",
    version: VERSION,
    extensions: [
        "json",
        "geojson"
    ],
    mimeTypes: [
        "application/json"
    ],
    category: "json",
    text: true,
    parseTextSync,
    parse: async (arrayBuffer)=>parseTextSync(new TextDecoder().decode(arrayBuffer)),
    options: {}
};
function parseTextSync(text) {
    return JSON.parse(text);
}
const _typecheckJSONLoader = JSONLoader;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fIhvt":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "filename", ()=>filename);
parcelHelpers.export(exports, "dirname", ()=>dirname);
parcelHelpers.export(exports, "join", ()=>join);
function filename(url) {
    const slashIndex = url && url.lastIndexOf("/");
    return slashIndex >= 0 ? url.substr(slashIndex + 1) : "";
}
function dirname(url) {
    const slashIndex = url && url.lastIndexOf("/");
    return slashIndex >= 0 ? url.substr(0, slashIndex) : "";
}
function join(...parts) {
    const separator = "/";
    parts = parts.map((part, index)=>{
        if (index) part = part.replace(new RegExp("^".concat(separator)), "");
        if (index !== parts.length - 1) part = part.replace(new RegExp("".concat(separator, "$")), "");
        return part;
    });
    return parts.join(separator);
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aPIYv":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "makeResponse", ()=>makeResponse);
parcelHelpers.export(exports, "checkResponse", ()=>checkResponse);
parcelHelpers.export(exports, "checkResponseSync", ()=>checkResponseSync);
var _isType = require("../../javascript-utils/is-type");
var _resourceUtils = require("./resource-utils");
async function makeResponse(resource) {
    if ((0, _isType.isResponse)(resource)) return resource;
    const headers = {};
    const contentLength = (0, _resourceUtils.getResourceContentLength)(resource);
    if (contentLength >= 0) headers["content-length"] = String(contentLength);
    const { url , type  } = (0, _resourceUtils.getResourceUrlAndType)(resource);
    if (type) headers["content-type"] = type;
    const initialDataUrl = await getInitialDataUrl(resource);
    if (initialDataUrl) headers["x-first-bytes"] = initialDataUrl;
    if (typeof resource === "string") resource = new TextEncoder().encode(resource);
    const response = new Response(resource, {
        headers
    });
    Object.defineProperty(response, "url", {
        value: url
    });
    return response;
}
async function checkResponse(response) {
    if (!response.ok) {
        const message = await getResponseError(response);
        throw new Error(message);
    }
}
function checkResponseSync(response) {
    if (!response.ok) {
        let message = "".concat(response.status, " ").concat(response.statusText);
        message = message.length > 60 ? "".concat(message.slice(0, 60), "...") : message;
        throw new Error(message);
    }
}
async function getResponseError(response) {
    let message = "Failed to fetch resource ".concat(response.url, " (").concat(response.status, "): ");
    try {
        const contentType = response.headers.get("Content-Type");
        let text = response.statusText;
        if (contentType.includes("application/json")) text += " ".concat(await response.text());
        message += text;
        message = message.length > 60 ? "".concat(message.slice(0, 60), "...") : message;
    } catch (error) {}
    return message;
}
async function getInitialDataUrl(resource) {
    const INITIAL_DATA_LENGTH = 5;
    if (typeof resource === "string") return "data:,".concat(resource.slice(0, INITIAL_DATA_LENGTH));
    if (resource instanceof Blob) {
        const blobSlice = resource.slice(0, 5);
        return await new Promise((resolve)=>{
            const reader = new FileReader();
            reader.onload = (event)=>{
                var _event$target;
                return resolve(event === null || event === void 0 ? void 0 : (_event$target = event.target) === null || _event$target === void 0 ? void 0 : _event$target.result);
            };
            reader.readAsDataURL(blobSlice);
        });
    }
    if (resource instanceof ArrayBuffer) {
        const slice = resource.slice(0, INITIAL_DATA_LENGTH);
        const base64 = arrayBufferToBase64(slice);
        return "data:base64,".concat(base64);
    }
    return null;
}
function arrayBufferToBase64(buffer) {
    let binary = "";
    const bytes = new Uint8Array(buffer);
    for(let i = 0; i < bytes.byteLength; i++)binary += String.fromCharCode(bytes[i]);
    return btoa(binary);
}

},{"../../javascript-utils/is-type":"8cOpM","./resource-utils":"dxxLV","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8cOpM":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isObject", ()=>isObject);
parcelHelpers.export(exports, "isPureObject", ()=>isPureObject);
parcelHelpers.export(exports, "isPromise", ()=>isPromise);
parcelHelpers.export(exports, "isIterable", ()=>isIterable);
parcelHelpers.export(exports, "isAsyncIterable", ()=>isAsyncIterable);
parcelHelpers.export(exports, "isIterator", ()=>isIterator);
parcelHelpers.export(exports, "isResponse", ()=>isResponse);
parcelHelpers.export(exports, "isFile", ()=>isFile);
parcelHelpers.export(exports, "isBlob", ()=>isBlob);
parcelHelpers.export(exports, "isBuffer", ()=>isBuffer);
parcelHelpers.export(exports, "isWritableDOMStream", ()=>isWritableDOMStream);
parcelHelpers.export(exports, "isReadableDOMStream", ()=>isReadableDOMStream);
parcelHelpers.export(exports, "isWritableNodeStream", ()=>isWritableNodeStream);
parcelHelpers.export(exports, "isReadableNodeStream", ()=>isReadableNodeStream);
parcelHelpers.export(exports, "isReadableStream", ()=>isReadableStream);
parcelHelpers.export(exports, "isWritableStream", ()=>isWritableStream);
const isBoolean = (x)=>typeof x === "boolean";
const isFunction = (x)=>typeof x === "function";
const isObject = (x)=>x !== null && typeof x === "object";
const isPureObject = (x)=>isObject(x) && x.constructor === ({}).constructor;
const isPromise = (x)=>isObject(x) && isFunction(x.then);
const isIterable = (x)=>x && typeof x[Symbol.iterator] === "function";
const isAsyncIterable = (x)=>x && typeof x[Symbol.asyncIterator] === "function";
const isIterator = (x)=>x && isFunction(x.next);
const isResponse = (x)=>typeof Response !== "undefined" && x instanceof Response || x && x.arrayBuffer && x.text && x.json;
const isFile = (x)=>typeof File !== "undefined" && x instanceof File;
const isBlob = (x)=>typeof Blob !== "undefined" && x instanceof Blob;
const isBuffer = (x)=>x && typeof x === "object" && x.isBuffer;
const isWritableDOMStream = (x)=>isObject(x) && isFunction(x.abort) && isFunction(x.getWriter);
const isReadableDOMStream = (x)=>typeof ReadableStream !== "undefined" && x instanceof ReadableStream || isObject(x) && isFunction(x.tee) && isFunction(x.cancel) && isFunction(x.getReader);
const isWritableNodeStream = (x)=>isObject(x) && isFunction(x.end) && isFunction(x.write) && isBoolean(x.writable);
const isReadableNodeStream = (x)=>isObject(x) && isFunction(x.read) && isFunction(x.pipe) && isBoolean(x.readable);
const isReadableStream = (x)=>isReadableDOMStream(x) || isReadableNodeStream(x);
const isWritableStream = (x)=>isWritableDOMStream(x) || isWritableNodeStream(x);

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dxxLV":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getResourceUrlAndType", ()=>getResourceUrlAndType);
parcelHelpers.export(exports, "getResourceContentLength", ()=>getResourceContentLength);
var _isType = require("../../javascript-utils/is-type");
var _mimeTypeUtils = require("./mime-type-utils");
const QUERY_STRING_PATTERN = /\?.*/;
function getResourceUrlAndType(resource) {
    if ((0, _isType.isResponse)(resource)) {
        const url = stripQueryString(resource.url || "");
        const contentTypeHeader = resource.headers.get("content-type") || "";
        return {
            url,
            type: (0, _mimeTypeUtils.parseMIMEType)(contentTypeHeader) || (0, _mimeTypeUtils.parseMIMETypeFromURL)(url)
        };
    }
    if ((0, _isType.isBlob)(resource)) return {
        url: stripQueryString(resource.name || ""),
        type: resource.type || ""
    };
    if (typeof resource === "string") return {
        url: stripQueryString(resource),
        type: (0, _mimeTypeUtils.parseMIMETypeFromURL)(resource)
    };
    return {
        url: "",
        type: ""
    };
}
function getResourceContentLength(resource) {
    if ((0, _isType.isResponse)(resource)) return resource.headers["content-length"] || -1;
    if ((0, _isType.isBlob)(resource)) return resource.size;
    if (typeof resource === "string") return resource.length;
    if (resource instanceof ArrayBuffer) return resource.byteLength;
    if (ArrayBuffer.isView(resource)) return resource.byteLength;
    return -1;
}
function stripQueryString(url) {
    return url.replace(QUERY_STRING_PATTERN, "");
}

},{"../../javascript-utils/is-type":"8cOpM","./mime-type-utils":"e4gxc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"e4gxc":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "parseMIMEType", ()=>parseMIMEType);
parcelHelpers.export(exports, "parseMIMETypeFromURL", ()=>parseMIMETypeFromURL);
const DATA_URL_PATTERN = /^data:([-\w.]+\/[-\w.+]+)(;|,)/;
const MIME_TYPE_PATTERN = /^([-\w.]+\/[-\w.+]+)/;
function parseMIMEType(mimeString) {
    const matches = MIME_TYPE_PATTERN.exec(mimeString);
    if (matches) return matches[1];
    return mimeString;
}
function parseMIMETypeFromURL(url) {
    const matches = DATA_URL_PATTERN.exec(url);
    if (matches) return matches[1];
    return "";
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"il5Nd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "registerLoaders", ()=>registerLoaders);
parcelHelpers.export(exports, "getRegisteredLoaders", ()=>getRegisteredLoaders);
parcelHelpers.export(exports, "_unregisterLoaders", ()=>_unregisterLoaders);
var _normalizeLoader = require("../loader-utils/normalize-loader");
var _optionUtils = require("../loader-utils/option-utils");
const getGlobalLoaderRegistry = ()=>{
    const state = (0, _optionUtils.getGlobalLoaderState)();
    state.loaderRegistry = state.loaderRegistry || [];
    return state.loaderRegistry;
};
function registerLoaders(loaders) {
    const loaderRegistry = getGlobalLoaderRegistry();
    loaders = Array.isArray(loaders) ? loaders : [
        loaders
    ];
    for (const loader of loaders){
        const normalizedLoader = (0, _normalizeLoader.normalizeLoader)(loader);
        if (!loaderRegistry.find((registeredLoader)=>normalizedLoader === registeredLoader)) loaderRegistry.unshift(normalizedLoader);
    }
}
function getRegisteredLoaders() {
    return getGlobalLoaderRegistry();
}
function _unregisterLoaders() {
    const state = (0, _optionUtils.getGlobalLoaderState)();
    state.loaderRegistry = [];
}

},{"../loader-utils/normalize-loader":"dnJ09","../loader-utils/option-utils":"5QYgB","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dnJ09":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isLoaderObject", ()=>isLoaderObject);
parcelHelpers.export(exports, "normalizeLoader", ()=>normalizeLoader);
var _loaderUtils = require("@loaders.gl/loader-utils");
function isLoaderObject(loader) {
    var _loader;
    if (!loader) return false;
    if (Array.isArray(loader)) loader = loader[0];
    const hasExtensions = Array.isArray((_loader = loader) === null || _loader === void 0 ? void 0 : _loader.extensions);
    return hasExtensions;
}
function normalizeLoader(loader) {
    var _loader2, _loader3;
    (0, _loaderUtils.assert)(loader, "null loader");
    (0, _loaderUtils.assert)(isLoaderObject(loader), "invalid loader");
    let options;
    if (Array.isArray(loader)) {
        options = loader[1];
        loader = loader[0];
        loader = {
            ...loader,
            options: {
                ...loader.options,
                ...options
            }
        };
    }
    if ((_loader2 = loader) !== null && _loader2 !== void 0 && _loader2.parseTextSync || (_loader3 = loader) !== null && _loader3 !== void 0 && _loader3.parseText) loader.text = true;
    if (!loader.text) loader.binary = true;
    return loader;
}

},{"@loaders.gl/loader-utils":"dIGVb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5QYgB":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getGlobalLoaderState", ()=>getGlobalLoaderState);
parcelHelpers.export(exports, "getGlobalLoaderOptions", ()=>getGlobalLoaderOptions);
parcelHelpers.export(exports, "setGlobalOptions", ()=>setGlobalOptions);
parcelHelpers.export(exports, "normalizeOptions", ()=>normalizeOptions);
parcelHelpers.export(exports, "getFetchFunction", ()=>getFetchFunction);
var _isType = require("../../javascript-utils/is-type");
var _fetchFile = require("../fetch/fetch-file");
var _loggers = require("./loggers");
var _optionDefaults = require("./option-defaults");
function getGlobalLoaderState() {
    globalThis.loaders = globalThis.loaders || {};
    const { loaders  } = globalThis;
    loaders._state = loaders._state || {};
    return loaders._state;
}
const getGlobalLoaderOptions = ()=>{
    const state = getGlobalLoaderState();
    state.globalOptions = state.globalOptions || {
        ...(0, _optionDefaults.DEFAULT_LOADER_OPTIONS)
    };
    return state.globalOptions;
};
function setGlobalOptions(options) {
    const state = getGlobalLoaderState();
    const globalOptions = getGlobalLoaderOptions();
    state.globalOptions = normalizeOptionsInternal(globalOptions, options);
}
function normalizeOptions(options, loader, loaders, url) {
    loaders = loaders || [];
    loaders = Array.isArray(loaders) ? loaders : [
        loaders
    ];
    validateOptions(options, loaders);
    return normalizeOptionsInternal(loader, options, url);
}
function getFetchFunction(options, context) {
    const globalOptions = getGlobalLoaderOptions();
    const fetchOptions = options || globalOptions;
    if (typeof fetchOptions.fetch === "function") return fetchOptions.fetch;
    if ((0, _isType.isObject)(fetchOptions.fetch)) return (url)=>(0, _fetchFile.fetchFile)(url, fetchOptions);
    if (context !== null && context !== void 0 && context.fetch) return context === null || context === void 0 ? void 0 : context.fetch;
    return 0, _fetchFile.fetchFile;
}
function validateOptions(options, loaders) {
    validateOptionsObject(options, null, (0, _optionDefaults.DEFAULT_LOADER_OPTIONS), (0, _optionDefaults.REMOVED_LOADER_OPTIONS), loaders);
    for (const loader of loaders){
        const idOptions = options && options[loader.id] || {};
        const loaderOptions = loader.options && loader.options[loader.id] || {};
        const deprecatedOptions = loader.deprecatedOptions && loader.deprecatedOptions[loader.id] || {};
        validateOptionsObject(idOptions, loader.id, loaderOptions, deprecatedOptions, loaders);
    }
}
function validateOptionsObject(options, id, defaultOptions, deprecatedOptions, loaders) {
    const loaderName = id || "Top level";
    const prefix = id ? "".concat(id, ".") : "";
    for(const key in options){
        const isSubOptions = !id && (0, _isType.isObject)(options[key]);
        const isBaseUriOption = key === "baseUri" && !id;
        const isWorkerUrlOption = key === "workerUrl" && id;
        if (!(key in defaultOptions) && !isBaseUriOption && !isWorkerUrlOption) {
            if (key in deprecatedOptions) (0, _loggers.probeLog).warn("".concat(loaderName, " loader option '").concat(prefix).concat(key, "' no longer supported, use '").concat(deprecatedOptions[key], "'"))();
            else if (!isSubOptions) {
                const suggestion = findSimilarOption(key, loaders);
                (0, _loggers.probeLog).warn("".concat(loaderName, " loader option '").concat(prefix).concat(key, "' not recognized. ").concat(suggestion))();
            }
        }
    }
}
function findSimilarOption(optionKey, loaders) {
    const lowerCaseOptionKey = optionKey.toLowerCase();
    let bestSuggestion = "";
    for (const loader of loaders)for(const key in loader.options){
        if (optionKey === key) return "Did you mean '".concat(loader.id, ".").concat(key, "'?");
        const lowerCaseKey = key.toLowerCase();
        const isPartialMatch = lowerCaseOptionKey.startsWith(lowerCaseKey) || lowerCaseKey.startsWith(lowerCaseOptionKey);
        if (isPartialMatch) bestSuggestion = bestSuggestion || "Did you mean '".concat(loader.id, ".").concat(key, "'?");
    }
    return bestSuggestion;
}
function normalizeOptionsInternal(loader, options, url) {
    const loaderDefaultOptions = loader.options || {};
    const mergedOptions = {
        ...loaderDefaultOptions
    };
    addUrlOptions(mergedOptions, url);
    if (mergedOptions.log === null) mergedOptions.log = new (0, _loggers.NullLog)();
    mergeNestedFields(mergedOptions, getGlobalLoaderOptions());
    mergeNestedFields(mergedOptions, options);
    return mergedOptions;
}
function mergeNestedFields(mergedOptions, options) {
    for(const key in options)if (key in options) {
        const value = options[key];
        if ((0, _isType.isPureObject)(value) && (0, _isType.isPureObject)(mergedOptions[key])) mergedOptions[key] = {
            ...mergedOptions[key],
            ...options[key]
        };
        else mergedOptions[key] = options[key];
    }
}
function addUrlOptions(options, url) {
    if (url && !("baseUri" in options)) options.baseUri = url;
}

},{"../../javascript-utils/is-type":"8cOpM","../fetch/fetch-file":"1jy9e","./loggers":"5o0IC","./option-defaults":"j5PYk","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5o0IC":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "probeLog", ()=>probeLog);
parcelHelpers.export(exports, "NullLog", ()=>NullLog);
parcelHelpers.export(exports, "ConsoleLog", ()=>ConsoleLog);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _probeGl = require("probe.gl");
const probeLog = new (0, _probeGl.Log)({
    id: "loaders.gl"
});
class NullLog {
    log() {
        return ()=>{};
    }
    info() {
        return ()=>{};
    }
    warn() {
        return ()=>{};
    }
    error() {
        return ()=>{};
    }
}
class ConsoleLog {
    constructor(){
        (0, _definePropertyDefault.default)(this, "console", void 0);
        this.console = console;
    }
    log(...args) {
        return this.console.log.bind(this.console, ...args);
    }
    info(...args) {
        return this.console.info.bind(this.console, ...args);
    }
    warn(...args) {
        return this.console.warn.bind(this.console, ...args);
    }
    error(...args) {
        return this.console.error.bind(this.console, ...args);
    }
}

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","probe.gl":"eB55V","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eB55V":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "VERSION", ()=>(0, _env.VERSION));
parcelHelpers.export(exports, "self", ()=>(0, _env.self));
parcelHelpers.export(exports, "window", ()=>(0, _env.window));
parcelHelpers.export(exports, "global", ()=>(0, _env.global));
parcelHelpers.export(exports, "document", ()=>(0, _env.document));
parcelHelpers.export(exports, "process", ()=>(0, _env.process));
parcelHelpers.export(exports, "console", ()=>(0, _env.console));
parcelHelpers.export(exports, "isBrowser", ()=>(0, _env.isBrowser));
parcelHelpers.export(exports, "isBrowserMainThread", ()=>(0, _env.isBrowserMainThread));
parcelHelpers.export(exports, "getBrowser", ()=>(0, _env.getBrowser));
parcelHelpers.export(exports, "isMobile", ()=>(0, _env.isMobile));
parcelHelpers.export(exports, "isElectron", ()=>(0, _env.isElectron));
parcelHelpers.export(exports, "assert", ()=>(0, _env.assert));
parcelHelpers.export(exports, "Log", ()=>(0, _log.Log));
parcelHelpers.export(exports, "COLOR", ()=>(0, _log.COLOR));
parcelHelpers.export(exports, "default", ()=>(0, _logDefault.default));
parcelHelpers.export(exports, "addColor", ()=>(0, _log.addColor));
parcelHelpers.export(exports, "leftPad", ()=>(0, _log.leftPad));
parcelHelpers.export(exports, "rightPad", ()=>(0, _log.rightPad));
parcelHelpers.export(exports, "autobind", ()=>(0, _log.autobind));
parcelHelpers.export(exports, "LocalStorage", ()=>(0, _logDefault.default));
parcelHelpers.export(exports, "getHiResTimestamp", ()=>(0, _logDefault.default));
parcelHelpers.export(exports, "Stats", ()=>(0, _stats.Stats));
parcelHelpers.export(exports, "Stat", ()=>(0, _stats.Stat));
var _env = require("@probe.gl/env");
var _log = require("@probe.gl/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _stats = require("@probe.gl/stats");

},{"@probe.gl/env":"6dzgb","@probe.gl/log":"1XvNl","@probe.gl/stats":"krQZu","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6dzgb":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "VERSION", ()=>(0, _globals.VERSION));
parcelHelpers.export(exports, "self", ()=>(0, _globals1.self));
parcelHelpers.export(exports, "window", ()=>(0, _globals1.window));
parcelHelpers.export(exports, "global", ()=>(0, _globals1.global));
parcelHelpers.export(exports, "document", ()=>(0, _globals1.document));
parcelHelpers.export(exports, "process", ()=>(0, _globals1.process));
parcelHelpers.export(exports, "console", ()=>(0, _globals1.console));
parcelHelpers.export(exports, "isBrowser", ()=>(0, _isBrowserDefault.default));
parcelHelpers.export(exports, "isBrowserMainThread", ()=>(0, _isBrowser.isBrowserMainThread));
parcelHelpers.export(exports, "getBrowser", ()=>(0, _getBrowserDefault.default));
parcelHelpers.export(exports, "isMobile", ()=>(0, _getBrowser.isMobile));
parcelHelpers.export(exports, "isElectron", ()=>(0, _isElectronDefault.default));
parcelHelpers.export(exports, "assert", ()=>(0, _assertDefault.default));
var _globals = require("./utils/globals");
var _globals1 = require("./lib/globals");
var _isBrowser = require("./lib/is-browser");
var _isBrowserDefault = parcelHelpers.interopDefault(_isBrowser);
var _getBrowser = require("./lib/get-browser");
var _getBrowserDefault = parcelHelpers.interopDefault(_getBrowser);
var _isElectron = require("./lib/is-electron");
var _isElectronDefault = parcelHelpers.interopDefault(_isElectron);
var _assert = require("./utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);

},{"./utils/globals":"TUYsx","./lib/globals":"8ZiBX","./lib/is-browser":"9Harb","./lib/get-browser":"4FVvr","./lib/is-electron":"kJH6z","./utils/assert":"adNBz","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"TUYsx":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "self", ()=>(0, _globals.self));
parcelHelpers.export(exports, "window", ()=>(0, _globals.window));
parcelHelpers.export(exports, "global", ()=>(0, _globals.global));
parcelHelpers.export(exports, "document", ()=>(0, _globals.document));
parcelHelpers.export(exports, "process", ()=>(0, _globals.process));
parcelHelpers.export(exports, "console", ()=>(0, _globals.console));
parcelHelpers.export(exports, "VERSION", ()=>VERSION);
parcelHelpers.export(exports, "isBrowser", ()=>isBrowser);
var _isBrowser = require("../lib/is-browser");
var _isBrowserDefault = parcelHelpers.interopDefault(_isBrowser);
var _globals = require("../lib/globals");
const VERSION = typeof __VERSION__ !== "undefined" ? __VERSION__ : "untranspiled source";
const isBrowser = (0, _isBrowserDefault.default)();

},{"../lib/is-browser":"9Harb","../lib/globals":"8ZiBX","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9Harb":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isBrowserMainThread", ()=>isBrowserMainThread);
var _isElectron = require("./is-electron");
var _isElectronDefault = parcelHelpers.interopDefault(_isElectron);
var process = require("process");
function isBrowser() {
    const isNode = typeof process === "object" && String(process) === "[object process]" && false;
    return !isNode || (0, _isElectronDefault.default)();
}
exports.default = isBrowser;
function isBrowserMainThread() {
    return isBrowser() && typeof document !== "undefined";
}

},{"process":"d5jf4","./is-electron":"kJH6z","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kJH6z":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var process = require("process");
function isElectron(mockUserAgent) {
    if (typeof window !== "undefined" && typeof window.process === "object" && window.process.type === "renderer") return true;
    if (typeof process !== "undefined" && typeof process.versions === "object" && Boolean(process.versions.electron)) return true;
    const realUserAgent = typeof navigator === "object" && typeof navigator.userAgent === "string" && navigator.userAgent;
    const userAgent = mockUserAgent || realUserAgent;
    if (userAgent && userAgent.indexOf("Electron") >= 0) return true;
    return false;
}
exports.default = isElectron;

},{"process":"d5jf4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8ZiBX":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "self", ()=>self_);
parcelHelpers.export(exports, "window", ()=>window_);
parcelHelpers.export(exports, "global", ()=>global_);
parcelHelpers.export(exports, "document", ()=>document_);
parcelHelpers.export(exports, "process", ()=>process_);
parcelHelpers.export(exports, "console", ()=>console_);
var process = require("process");
var global = arguments[3];
const globals = {
    self: typeof self !== "undefined" && self,
    window: typeof window !== "undefined" && window,
    global: typeof global !== "undefined" && global,
    document: typeof document !== "undefined" && document,
    process: typeof process === "object" && process
};
const global_ = globalThis;
const self_ = globals.self || globals.window || globals.global;
const window_ = globals.window || globals.self || globals.global;
const document_ = globals.document || {};
const process_ = globals.process || {};
const console_ = console;

},{"process":"d5jf4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4FVvr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isMobile", ()=>isMobile);
var _isBrowser = require("./is-browser");
var _isBrowserDefault = parcelHelpers.interopDefault(_isBrowser);
var _isElectron = require("./is-electron");
var _isElectronDefault = parcelHelpers.interopDefault(_isElectron);
const window = globalThis;
function isMobile() {
    return typeof window.orientation !== "undefined";
}
function getBrowser(mockUserAgent) {
    if (!mockUserAgent && !(0, _isBrowserDefault.default)()) return "Node";
    if ((0, _isElectronDefault.default)(mockUserAgent)) return "Electron";
    const navigator_ = typeof navigator !== "undefined" ? navigator : {};
    const userAgent = mockUserAgent || navigator_.userAgent || "";
    if (userAgent.indexOf("Edge") > -1) return "Edge";
    const isMSIE = userAgent.indexOf("MSIE ") !== -1;
    const isTrident = userAgent.indexOf("Trident/") !== -1;
    if (isMSIE || isTrident) return "IE";
    if (window.chrome) return "Chrome";
    if (window.safari) return "Safari";
    if (window.mozInnerScreenX) return "Firefox";
    return "Unknown";
}
exports.default = getBrowser;

},{"./is-browser":"9Harb","./is-electron":"kJH6z","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"adNBz":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function assert(condition, message) {
    if (!condition) throw new Error(message || "Assertion failed");
}
exports.default = assert;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1XvNl":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Log", ()=>(0, _logDefault.default));
parcelHelpers.export(exports, "COLOR", ()=>(0, _color.COLOR));
parcelHelpers.export(exports, "addColor", ()=>(0, _color.addColor));
parcelHelpers.export(exports, "leftPad", ()=>(0, _formatters.leftPad));
parcelHelpers.export(exports, "rightPad", ()=>(0, _formatters.rightPad));
parcelHelpers.export(exports, "autobind", ()=>(0, _autobind.autobind));
parcelHelpers.export(exports, "LocalStorage", ()=>(0, _localStorageDefault.default));
parcelHelpers.export(exports, "getHiResTimestamp", ()=>(0, _hiResTimestamp.getHiResTimestamp));
var _log = require("./log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _color = require("./utils/color");
var _formatters = require("./utils/formatters");
var _autobind = require("./utils/autobind");
var _localStorage = require("./utils/local-storage");
var _localStorageDefault = parcelHelpers.interopDefault(_localStorage);
var _hiResTimestamp = require("./utils/hi-res-timestamp");
var _init = require("./init");
exports.default = new (0, _logDefault.default)({
    id: "@probe.gl/log"
});

},{"./log":"67904","./utils/color":"3e1Yk","./utils/formatters":"BG8Ro","./utils/autobind":"4eSBe","./utils/local-storage":"5Yf47","./utils/hi-res-timestamp":"8pEr3","./init":"8Ahzc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"67904":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "normalizeArguments", ()=>normalizeArguments);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _env = require("@probe.gl/env");
var _localStorage = require("./utils/local-storage");
var _localStorageDefault = parcelHelpers.interopDefault(_localStorage);
var _formatters = require("./utils/formatters");
var _color = require("./utils/color");
var _autobind = require("./utils/autobind");
var _assert = require("./utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _hiResTimestamp = require("./utils/hi-res-timestamp");
const originalConsole = {
    debug: (0, _env.isBrowser) ? console.debug || console.log : console.log,
    log: console.log,
    info: console.info,
    warn: console.warn,
    error: console.error
};
const DEFAULT_SETTINGS = {
    enabled: true,
    level: 0
};
function noop() {}
const cache = {};
const ONCE = {
    once: true
};
class Log {
    constructor(){
        let { id  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
            id: ""
        };
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "VERSION", (0, _env.VERSION));
        (0, _definePropertyDefault.default)(this, "_startTs", (0, _hiResTimestamp.getHiResTimestamp)());
        (0, _definePropertyDefault.default)(this, "_deltaTs", (0, _hiResTimestamp.getHiResTimestamp)());
        (0, _definePropertyDefault.default)(this, "_storage", void 0);
        (0, _definePropertyDefault.default)(this, "userData", {});
        (0, _definePropertyDefault.default)(this, "LOG_THROTTLE_TIMEOUT", 0);
        this.id = id;
        this._storage = new (0, _localStorageDefault.default)("__probe-".concat(this.id, "__"), DEFAULT_SETTINGS);
        this.userData = {};
        this.timeStamp("".concat(this.id, " started"));
        (0, _autobind.autobind)(this);
        Object.seal(this);
    }
    set level(newLevel) {
        this.setLevel(newLevel);
    }
    get level() {
        return this.getLevel();
    }
    isEnabled() {
        return this._storage.config.enabled;
    }
    getLevel() {
        return this._storage.config.level;
    }
    getTotal() {
        return Number(((0, _hiResTimestamp.getHiResTimestamp)() - this._startTs).toPrecision(10));
    }
    getDelta() {
        return Number(((0, _hiResTimestamp.getHiResTimestamp)() - this._deltaTs).toPrecision(10));
    }
    set priority(newPriority) {
        this.level = newPriority;
    }
    get priority() {
        return this.level;
    }
    getPriority() {
        return this.level;
    }
    enable() {
        let enabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
        this._storage.updateConfiguration({
            enabled
        });
        return this;
    }
    setLevel(level) {
        this._storage.updateConfiguration({
            level
        });
        return this;
    }
    get(setting) {
        return this._storage.config[setting];
    }
    set(setting, value) {
        this._storage.updateConfiguration({
            [setting]: value
        });
    }
    settings() {
        if (console.table) console.table(this._storage.config);
        else console.log(this._storage.config);
    }
    assert(condition, message) {
        (0, _assertDefault.default)(condition, message);
    }
    warn(message) {
        return this._getLogFunction(0, message, originalConsole.warn, arguments, ONCE);
    }
    error(message) {
        return this._getLogFunction(0, message, originalConsole.error, arguments);
    }
    deprecated(oldUsage, newUsage) {
        return this.warn("`".concat(oldUsage, "` is deprecated and will be removed in a later version. Use `").concat(newUsage, "` instead"));
    }
    removed(oldUsage, newUsage) {
        return this.error("`".concat(oldUsage, "` has been removed. Use `").concat(newUsage, "` instead"));
    }
    probe(logLevel, message) {
        return this._getLogFunction(logLevel, message, originalConsole.log, arguments, {
            time: true,
            once: true
        });
    }
    log(logLevel, message) {
        return this._getLogFunction(logLevel, message, originalConsole.debug, arguments);
    }
    info(logLevel, message) {
        return this._getLogFunction(logLevel, message, console.info, arguments);
    }
    once(logLevel, message) {
        for(var _len = arguments.length, args = new Array(_len > 2 ? _len - 2 : 0), _key = 2; _key < _len; _key++)args[_key - 2] = arguments[_key];
        return this._getLogFunction(logLevel, message, originalConsole.debug || originalConsole.info, arguments, ONCE);
    }
    table(logLevel, table, columns) {
        if (table) return this._getLogFunction(logLevel, table, console.table || noop, columns && [
            columns
        ], {
            tag: getTableHeader(table)
        });
        return noop;
    }
    image(_ref) {
        let { logLevel , priority , image , message ="" , scale =1  } = _ref;
        if (!this._shouldLog(logLevel || priority)) return noop;
        return (0, _env.isBrowser) ? logImageInBrowser({
            image,
            message,
            scale
        }) : logImageInNode({
            image,
            message,
            scale
        });
    }
    time(logLevel, message) {
        return this._getLogFunction(logLevel, message, console.time ? console.time : console.info);
    }
    timeEnd(logLevel, message) {
        return this._getLogFunction(logLevel, message, console.timeEnd ? console.timeEnd : console.info);
    }
    timeStamp(logLevel, message) {
        return this._getLogFunction(logLevel, message, console.timeStamp || noop);
    }
    group(logLevel, message) {
        let opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {
            collapsed: false
        };
        const options = normalizeArguments({
            logLevel,
            message,
            opts
        });
        const { collapsed  } = opts;
        options.method = (collapsed ? console.groupCollapsed : console.group) || console.info;
        return this._getLogFunction(options);
    }
    groupCollapsed(logLevel, message) {
        let opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        return this.group(logLevel, message, Object.assign({}, opts, {
            collapsed: true
        }));
    }
    groupEnd(logLevel) {
        return this._getLogFunction(logLevel, "", console.groupEnd || noop);
    }
    withGroup(logLevel, message, func) {
        this.group(logLevel, message)();
        try {
            func();
        } finally{
            this.groupEnd(logLevel)();
        }
    }
    trace() {
        if (console.trace) console.trace();
    }
    _shouldLog(logLevel) {
        return this.isEnabled() && this.getLevel() >= normalizeLogLevel(logLevel);
    }
    _getLogFunction(logLevel, message, method, args, opts) {
        if (this._shouldLog(logLevel)) {
            opts = normalizeArguments({
                logLevel,
                message,
                args,
                opts
            });
            method = method || opts.method;
            (0, _assertDefault.default)(method);
            opts.total = this.getTotal();
            opts.delta = this.getDelta();
            this._deltaTs = (0, _hiResTimestamp.getHiResTimestamp)();
            const tag = opts.tag || opts.message;
            if (opts.once) {
                if (!cache[tag]) cache[tag] = (0, _hiResTimestamp.getHiResTimestamp)();
                else return noop;
            }
            message = decorateMessage(this.id, opts.message, opts);
            return method.bind(console, message, ...opts.args);
        }
        return noop;
    }
}
exports.default = Log;
(0, _definePropertyDefault.default)(Log, "VERSION", (0, _env.VERSION));
function normalizeLogLevel(logLevel) {
    if (!logLevel) return 0;
    let resolvedLevel;
    switch(typeof logLevel){
        case "number":
            resolvedLevel = logLevel;
            break;
        case "object":
            resolvedLevel = logLevel.logLevel || logLevel.priority || 0;
            break;
        default:
            return 0;
    }
    (0, _assertDefault.default)(Number.isFinite(resolvedLevel) && resolvedLevel >= 0);
    return resolvedLevel;
}
function normalizeArguments(opts) {
    const { logLevel , message  } = opts;
    opts.logLevel = normalizeLogLevel(logLevel);
    const args = opts.args ? Array.from(opts.args) : [];
    while(args.length && args.shift() !== message);
    switch(typeof logLevel){
        case "string":
        case "function":
            if (message !== undefined) args.unshift(message);
            opts.message = logLevel;
            break;
        case "object":
            Object.assign(opts, logLevel);
            break;
        default:
    }
    if (typeof opts.message === "function") opts.message = opts.message();
    const messageType = typeof opts.message;
    (0, _assertDefault.default)(messageType === "string" || messageType === "object");
    return Object.assign(opts, {
        args
    }, opts.opts);
}
function decorateMessage(id, message, opts) {
    if (typeof message === "string") {
        const time = opts.time ? (0, _formatters.leftPad)((0, _formatters.formatTime)(opts.total)) : "";
        message = opts.time ? "".concat(id, ": ").concat(time, "  ").concat(message) : "".concat(id, ": ").concat(message);
        message = (0, _color.addColor)(message, opts.color, opts.background);
    }
    return message;
}
function logImageInNode(_ref2) {
    let { image , message ="" , scale =1  } = _ref2;
    let asciify = null;
    try {
        asciify = module.require("asciify-image");
    } catch (error) {}
    if (asciify) return ()=>asciify(image, {
            fit: "box",
            width: "".concat(Math.round(80 * scale), "%")
        }).then((data)=>console.log(data));
    return noop;
}
function logImageInBrowser(_ref3) {
    let { image , message ="" , scale =1  } = _ref3;
    if (typeof image === "string") {
        const img = new Image();
        img.onload = ()=>{
            const args = (0, _formatters.formatImage)(img, message, scale);
            console.log(...args);
        };
        img.src = image;
        return noop;
    }
    const element = image.nodeName || "";
    if (element.toLowerCase() === "img") {
        console.log(...(0, _formatters.formatImage)(image, message, scale));
        return noop;
    }
    if (element.toLowerCase() === "canvas") {
        const img1 = new Image();
        img1.onload = ()=>console.log(...(0, _formatters.formatImage)(img1, message, scale));
        img1.src = image.toDataURL();
        return noop;
    }
    return noop;
}
function getTableHeader(table) {
    for(const key in table){
        for(const title in table[key])return title || "untitled";
    }
    return "empty";
}

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@probe.gl/env":"6dzgb","./utils/local-storage":"5Yf47","./utils/formatters":"BG8Ro","./utils/color":"3e1Yk","./utils/autobind":"4eSBe","./utils/assert":"133lR","./utils/hi-res-timestamp":"8pEr3","asciify-image":"jhUEF","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5Yf47":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
function getStorage(type) {
    try {
        const storage = window[type];
        const x = "__storage_test__";
        storage.setItem(x, x);
        storage.removeItem(x);
        return storage;
    } catch (e) {
        return null;
    }
}
class LocalStorage {
    constructor(id){
        let defaultSettings = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        let type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "sessionStorage";
        (0, _definePropertyDefault.default)(this, "storage", void 0);
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "config", {});
        this.storage = getStorage(type);
        this.id = id;
        this.config = {};
        Object.assign(this.config, defaultSettings);
        this._loadConfiguration();
    }
    getConfiguration() {
        return this.config;
    }
    setConfiguration(configuration) {
        this.config = {};
        return this.updateConfiguration(configuration);
    }
    updateConfiguration(configuration) {
        Object.assign(this.config, configuration);
        if (this.storage) {
            const serialized = JSON.stringify(this.config);
            this.storage.setItem(this.id, serialized);
        }
        return this;
    }
    _loadConfiguration() {
        let configuration = {};
        if (this.storage) {
            const serializedConfiguration = this.storage.getItem(this.id);
            configuration = serializedConfiguration ? JSON.parse(serializedConfiguration) : {};
        }
        Object.assign(this.config, configuration);
        return this;
    }
}
exports.default = LocalStorage;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"BG8Ro":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "formatTime", ()=>formatTime);
parcelHelpers.export(exports, "leftPad", ()=>leftPad);
parcelHelpers.export(exports, "rightPad", ()=>rightPad);
parcelHelpers.export(exports, "formatValue", ()=>formatValue);
parcelHelpers.export(exports, "formatImage", ()=>formatImage);
function formatTime(ms) {
    let formatted;
    if (ms < 10) formatted = "".concat(ms.toFixed(2), "ms");
    else if (ms < 100) formatted = "".concat(ms.toFixed(1), "ms");
    else if (ms < 1000) formatted = "".concat(ms.toFixed(0), "ms");
    else formatted = "".concat((ms / 1000).toFixed(2), "s");
    return formatted;
}
function leftPad(string) {
    let length = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 8;
    const padLength = Math.max(length - string.length, 0);
    return "".concat(" ".repeat(padLength)).concat(string);
}
function rightPad(string) {
    let length = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 8;
    const padLength = Math.max(length - string.length, 0);
    return "".concat(string).concat(" ".repeat(padLength));
}
function formatValue(v) {
    let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    const EPSILON = 1e-16;
    const { isInteger =false  } = opts;
    if (Array.isArray(v) || ArrayBuffer.isView(v)) return formatArrayValue(v, opts);
    if (!Number.isFinite(v)) return String(v);
    if (Math.abs(v) < EPSILON) return isInteger ? "0" : "0.";
    if (isInteger) return v.toFixed(0);
    if (Math.abs(v) > 100 && Math.abs(v) < 10000) return v.toFixed(0);
    const string = v.toPrecision(2);
    const decimal = string.indexOf(".0");
    return decimal === string.length - 2 ? string.slice(0, -1) : string;
}
function formatArrayValue(v, opts) {
    const { maxElts =16 , size =1  } = opts;
    let string = "[";
    for(let i = 0; i < v.length && i < maxElts; ++i){
        if (i > 0) string += ",".concat(i % size === 0 ? " " : "");
        string += formatValue(v[i], opts);
    }
    const terminator = v.length > maxElts ? "..." : "]";
    return "".concat(string).concat(terminator);
}
function formatImage(image, message, scale) {
    let maxWidth = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 600;
    const imageUrl = image.src.replace(/\(/g, "%28").replace(/\)/g, "%29");
    if (image.width > maxWidth) scale = Math.min(scale, maxWidth / image.width);
    const width = image.width * scale;
    const height = image.height * scale;
    const style = [
        "font-size:1px;",
        "padding:".concat(Math.floor(height / 2), "px ").concat(Math.floor(width / 2), "px;"),
        "line-height:".concat(height, "px;"),
        "background:url(".concat(imageUrl, ");"),
        "background-size:".concat(width, "px ").concat(height, "px;"),
        "color:transparent;"
    ].join("");
    return [
        "".concat(message, " %c+"),
        style
    ];
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3e1Yk":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "COLOR", ()=>COLOR);
parcelHelpers.export(exports, "addColor", ()=>addColor);
var _env = require("@probe.gl/env");
let COLOR;
(function(COLOR) {
    COLOR[COLOR["BLACK"] = 30] = "BLACK";
    COLOR[COLOR["RED"] = 31] = "RED";
    COLOR[COLOR["GREEN"] = 32] = "GREEN";
    COLOR[COLOR["YELLOW"] = 33] = "YELLOW";
    COLOR[COLOR["BLUE"] = 34] = "BLUE";
    COLOR[COLOR["MAGENTA"] = 35] = "MAGENTA";
    COLOR[COLOR["CYAN"] = 36] = "CYAN";
    COLOR[COLOR["WHITE"] = 37] = "WHITE";
    COLOR[COLOR["BRIGHT_BLACK"] = 90] = "BRIGHT_BLACK";
    COLOR[COLOR["BRIGHT_RED"] = 91] = "BRIGHT_RED";
    COLOR[COLOR["BRIGHT_GREEN"] = 92] = "BRIGHT_GREEN";
    COLOR[COLOR["BRIGHT_YELLOW"] = 93] = "BRIGHT_YELLOW";
    COLOR[COLOR["BRIGHT_BLUE"] = 94] = "BRIGHT_BLUE";
    COLOR[COLOR["BRIGHT_MAGENTA"] = 95] = "BRIGHT_MAGENTA";
    COLOR[COLOR["BRIGHT_CYAN"] = 96] = "BRIGHT_CYAN";
    COLOR[COLOR["BRIGHT_WHITE"] = 97] = "BRIGHT_WHITE";
})(COLOR || (COLOR = {}));
function getColor(color) {
    return typeof color === "string" ? COLOR[color.toUpperCase()] || COLOR.WHITE : color;
}
function addColor(string, color, background) {
    if (!(0, _env.isBrowser) && typeof string === "string") {
        if (color) {
            color = getColor(color);
            string = "\x1b[".concat(color, "m").concat(string, "\x1b[39m");
        }
        if (background) {
            color = getColor(background);
            string = "\x1b[".concat(background + 10, "m").concat(string, "\x1b[49m");
        }
    }
    return string;
}

},{"@probe.gl/env":"6dzgb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4eSBe":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "autobind", ()=>autobind);
function autobind(obj) {
    let predefined = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [
        "constructor"
    ];
    const proto = Object.getPrototypeOf(obj);
    const propNames = Object.getOwnPropertyNames(proto);
    for (const key of propNames){
        if (typeof obj[key] === "function") {
            if (!predefined.find((name)=>key === name)) obj[key] = obj[key].bind(obj);
        }
    }
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"133lR":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function assert(condition, message) {
    if (!condition) throw new Error(message || "Assertion failed");
}
exports.default = assert;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8pEr3":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getHiResTimestamp", ()=>getHiResTimestamp);
var _env = require("@probe.gl/env");
function getHiResTimestamp() {
    let timestamp;
    if ((0, _env.isBrowser) && "performance" in (0, _env.window)) {
        var _window$performance, _window$performance$n;
        timestamp = (0, _env.window) === null || (0, _env.window) === void 0 ? void 0 : (_window$performance = (0, _env.window).performance) === null || _window$performance === void 0 ? void 0 : (_window$performance$n = _window$performance.now) === null || _window$performance$n === void 0 ? void 0 : _window$performance$n.call(_window$performance);
    } else if ("hrtime" in (0, _env.process)) {
        var _process$hrtime;
        const timeParts = (0, _env.process) === null || (0, _env.process) === void 0 ? void 0 : (_process$hrtime = (0, _env.process).hrtime) === null || _process$hrtime === void 0 ? void 0 : _process$hrtime.call((0, _env.process));
        timestamp = timeParts[0] * 1000 + timeParts[1] / 1e6;
    } else timestamp = Date.now();
    return timestamp;
}

},{"@probe.gl/env":"6dzgb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8Ahzc":[function(require,module,exports) {
globalThis.probe = {};

},{}],"j5PYk":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "DEFAULT_LOADER_OPTIONS", ()=>DEFAULT_LOADER_OPTIONS);
parcelHelpers.export(exports, "REMOVED_LOADER_OPTIONS", ()=>REMOVED_LOADER_OPTIONS);
var _loaderUtils = require("@loaders.gl/loader-utils");
var _loggers = require("./loggers");
const DEFAULT_LOADER_OPTIONS = {
    fetch: null,
    mimeType: undefined,
    nothrow: false,
    log: new (0, _loggers.ConsoleLog)(),
    CDN: "https://unpkg.com/@loaders.gl",
    worker: true,
    maxConcurrency: 3,
    maxMobileConcurrency: 1,
    reuseWorkers: (0, _loaderUtils.isBrowser),
    _nodeWorkers: false,
    _workerType: "",
    limit: 0,
    _limitMB: 0,
    batchSize: "auto",
    batchDebounceMs: 0,
    metadata: false,
    transforms: []
};
const REMOVED_LOADER_OPTIONS = {
    throws: "nothrow",
    dataType: "(no longer used)",
    uri: "baseUri",
    method: "fetch.method",
    headers: "fetch.headers",
    body: "fetch.body",
    mode: "fetch.mode",
    credentials: "fetch.credentials",
    cache: "fetch.cache",
    redirect: "fetch.redirect",
    referrer: "fetch.referrer",
    referrerPolicy: "fetch.referrerPolicy",
    integrity: "fetch.integrity",
    keepalive: "fetch.keepalive",
    signal: "fetch.signal"
};

},{"@loaders.gl/loader-utils":"dIGVb","./loggers":"5o0IC","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lStT8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "selectLoader", ()=>selectLoader);
parcelHelpers.export(exports, "selectLoaderSync", ()=>selectLoaderSync);
var _loaderUtils = require("@loaders.gl/loader-utils");
var _normalizeLoader = require("../loader-utils/normalize-loader");
var _log = require("../utils/log");
var _resourceUtils = require("../utils/resource-utils");
var _registerLoaders = require("./register-loaders");
var _isType = require("../../javascript-utils/is-type");
const EXT_PATTERN = /\.([^.]+)$/;
async function selectLoader(data, loaders = [], options, context) {
    if (!validHTTPResponse(data)) return null;
    let loader = selectLoaderSync(data, loaders, {
        ...options,
        nothrow: true
    }, context);
    if (loader) return loader;
    if ((0, _isType.isBlob)(data)) {
        data = await data.slice(0, 10).arrayBuffer();
        loader = selectLoaderSync(data, loaders, options, context);
    }
    if (!loader && !(options !== null && options !== void 0 && options.nothrow)) throw new Error(getNoValidLoaderMessage(data));
    return loader;
}
function selectLoaderSync(data, loaders = [], options, context) {
    if (!validHTTPResponse(data)) return null;
    if (loaders && !Array.isArray(loaders)) return (0, _normalizeLoader.normalizeLoader)(loaders);
    let candidateLoaders = [];
    if (loaders) candidateLoaders = candidateLoaders.concat(loaders);
    if (!(options !== null && options !== void 0 && options.ignoreRegisteredLoaders)) candidateLoaders.push(...(0, _registerLoaders.getRegisteredLoaders)());
    normalizeLoaders(candidateLoaders);
    const loader = selectLoaderInternal(data, candidateLoaders, options, context);
    if (!loader && !(options !== null && options !== void 0 && options.nothrow)) throw new Error(getNoValidLoaderMessage(data));
    return loader;
}
function selectLoaderInternal(data, loaders, options, context) {
    const { url , type  } = (0, _resourceUtils.getResourceUrlAndType)(data);
    const testUrl = url || (context === null || context === void 0 ? void 0 : context.url);
    let loader = null;
    let reason = "";
    if (options !== null && options !== void 0 && options.mimeType) {
        loader = findLoaderByMIMEType(loaders, options === null || options === void 0 ? void 0 : options.mimeType);
        reason = "match forced by supplied MIME type ".concat(options === null || options === void 0 ? void 0 : options.mimeType);
    }
    loader = loader || findLoaderByUrl(loaders, testUrl);
    reason = reason || (loader ? "matched url ".concat(testUrl) : "");
    loader = loader || findLoaderByMIMEType(loaders, type);
    reason = reason || (loader ? "matched MIME type ".concat(type) : "");
    loader = loader || findLoaderByInitialBytes(loaders, data);
    reason = reason || (loader ? "matched initial data ".concat(getFirstCharacters(data)) : "");
    loader = loader || findLoaderByMIMEType(loaders, options === null || options === void 0 ? void 0 : options.fallbackMimeType);
    reason = reason || (loader ? "matched fallback MIME type ".concat(type) : "");
    if (reason) {
        var _loader;
        (0, _log.log).log(1, "selectLoader selected ".concat((_loader = loader) === null || _loader === void 0 ? void 0 : _loader.name, ": ").concat(reason, "."));
    }
    return loader;
}
function validHTTPResponse(data) {
    if (data instanceof Response) {
        if (data.status === 204) return false;
    }
    return true;
}
function getNoValidLoaderMessage(data) {
    const { url , type  } = (0, _resourceUtils.getResourceUrlAndType)(data);
    let message = "No valid loader found (";
    message += url ? "".concat((0, _loaderUtils.path).filename(url), ", ") : "no url provided, ";
    message += "MIME type: ".concat(type ? '"'.concat(type, '"') : "not provided", ", ");
    const firstCharacters = data ? getFirstCharacters(data) : "";
    message += firstCharacters ? ' first bytes: "'.concat(firstCharacters, '"') : "first bytes: not available";
    message += ")";
    return message;
}
function normalizeLoaders(loaders) {
    for (const loader of loaders)(0, _normalizeLoader.normalizeLoader)(loader);
}
function findLoaderByUrl(loaders, url) {
    const match = url && EXT_PATTERN.exec(url);
    const extension = match && match[1];
    return extension ? findLoaderByExtension(loaders, extension) : null;
}
function findLoaderByExtension(loaders, extension) {
    extension = extension.toLowerCase();
    for (const loader of loaders)for (const loaderExtension of loader.extensions){
        if (loaderExtension.toLowerCase() === extension) return loader;
    }
    return null;
}
function findLoaderByMIMEType(loaders, mimeType) {
    for (const loader of loaders){
        if (loader.mimeTypes && loader.mimeTypes.includes(mimeType)) return loader;
        if (mimeType === "application/x.".concat(loader.id)) return loader;
    }
    return null;
}
function findLoaderByInitialBytes(loaders, data) {
    if (!data) return null;
    for (const loader of loaders){
        if (typeof data === "string") {
            if (testDataAgainstText(data, loader)) return loader;
        } else if (ArrayBuffer.isView(data)) {
            if (testDataAgainstBinary(data.buffer, data.byteOffset, loader)) return loader;
        } else if (data instanceof ArrayBuffer) {
            const byteOffset = 0;
            if (testDataAgainstBinary(data, byteOffset, loader)) return loader;
        }
    }
    return null;
}
function testDataAgainstText(data, loader) {
    if (loader.testText) return loader.testText(data);
    const tests = Array.isArray(loader.tests) ? loader.tests : [
        loader.tests
    ];
    return tests.some((test)=>data.startsWith(test));
}
function testDataAgainstBinary(data, byteOffset, loader) {
    const tests = Array.isArray(loader.tests) ? loader.tests : [
        loader.tests
    ];
    return tests.some((test)=>testBinary(data, byteOffset, loader, test));
}
function testBinary(data, byteOffset, loader, test) {
    if (test instanceof ArrayBuffer) return (0, _loaderUtils.compareArrayBuffers)(test, data, test.byteLength);
    switch(typeof test){
        case "function":
            return test(data, loader);
        case "string":
            const magic = getMagicString(data, byteOffset, test.length);
            return test === magic;
        default:
            return false;
    }
}
function getFirstCharacters(data, length = 5) {
    if (typeof data === "string") return data.slice(0, length);
    else if (ArrayBuffer.isView(data)) return getMagicString(data.buffer, data.byteOffset, length);
    else if (data instanceof ArrayBuffer) {
        const byteOffset = 0;
        return getMagicString(data, byteOffset, length);
    }
    return "";
}
function getMagicString(arrayBuffer, byteOffset, length) {
    if (arrayBuffer.byteLength < byteOffset + length) return "";
    const dataView = new DataView(arrayBuffer);
    let magic = "";
    for(let i = 0; i < length; i++)magic += String.fromCharCode(dataView.getUint8(byteOffset + i));
    return magic;
}

},{"@loaders.gl/loader-utils":"dIGVb","../loader-utils/normalize-loader":"dnJ09","../utils/log":"b4nDa","../utils/resource-utils":"dxxLV","./register-loaders":"il5Nd","../../javascript-utils/is-type":"8cOpM","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"b4nDa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "log", ()=>log);
var _log = require("@probe.gl/log");
const log = new (0, _log.Log)({
    id: "loaders.gl"
});

},{"@probe.gl/log":"1XvNl","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"k1WZf":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "parse", ()=>parse);
var _workerUtils = require("@loaders.gl/worker-utils");
var _loaderUtils = require("@loaders.gl/loader-utils");
var _normalizeLoader = require("../loader-utils/normalize-loader");
var _isType = require("../../javascript-utils/is-type");
var _optionUtils = require("../loader-utils/option-utils");
var _getData = require("../loader-utils/get-data");
var _loaderContext = require("../loader-utils/loader-context");
var _resourceUtils = require("../utils/resource-utils");
var _selectLoader = require("./select-loader");
async function parse(data, loaders, options, context) {
    (0, _workerUtils.assert)(!context || typeof context === "object");
    if (loaders && !Array.isArray(loaders) && !(0, _normalizeLoader.isLoaderObject)(loaders)) {
        context = undefined;
        options = loaders;
        loaders = undefined;
    }
    data = await data;
    options = options || {};
    const { url  } = (0, _resourceUtils.getResourceUrlAndType)(data);
    const typedLoaders = loaders;
    const candidateLoaders = (0, _loaderContext.getLoadersFromContext)(typedLoaders, context);
    const loader = await (0, _selectLoader.selectLoader)(data, candidateLoaders, options);
    if (!loader) return null;
    options = (0, _optionUtils.normalizeOptions)(options, loader, candidateLoaders, url);
    context = (0, _loaderContext.getLoaderContext)({
        url,
        parse,
        loaders: candidateLoaders
    }, options, context);
    return await parseWithLoader(loader, data, options, context);
}
async function parseWithLoader(loader, data, options, context) {
    (0, _workerUtils.validateWorkerVersion)(loader);
    if ((0, _isType.isResponse)(data)) {
        const response = data;
        const { ok , redirected , status , statusText , type , url  } = response;
        const headers = Object.fromEntries(response.headers.entries());
        context.response = {
            headers,
            ok,
            redirected,
            status,
            statusText,
            type,
            url
        };
    }
    data = await (0, _getData.getArrayBufferOrStringFromData)(data, loader, options);
    if (loader.parseTextSync && typeof data === "string") {
        options.dataType = "text";
        return loader.parseTextSync(data, options, context, loader);
    }
    if ((0, _loaderUtils.canParseWithWorker)(loader, options)) return await (0, _loaderUtils.parseWithWorker)(loader, data, options, context, parse);
    if (loader.parseText && typeof data === "string") return await loader.parseText(data, options, context, loader);
    if (loader.parse) return await loader.parse(data, options, context, loader);
    (0, _workerUtils.assert)(!loader.parseSync);
    throw new Error("".concat(loader.id, " loader - no parser found and worker is disabled"));
}

},{"@loaders.gl/worker-utils":"gdHyK","@loaders.gl/loader-utils":"dIGVb","../loader-utils/normalize-loader":"dnJ09","../../javascript-utils/is-type":"8cOpM","../loader-utils/option-utils":"5QYgB","../loader-utils/get-data":"8VtKf","../loader-utils/loader-context":"lplHW","../utils/resource-utils":"dxxLV","./select-loader":"lStT8","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8VtKf":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getArrayBufferOrStringFromDataSync", ()=>getArrayBufferOrStringFromDataSync);
parcelHelpers.export(exports, "getArrayBufferOrStringFromData", ()=>getArrayBufferOrStringFromData);
parcelHelpers.export(exports, "getAsyncIterableFromData", ()=>getAsyncIterableFromData);
parcelHelpers.export(exports, "getReadableStream", ()=>getReadableStream);
var _loaderUtils = require("@loaders.gl/loader-utils");
var _isType = require("../../javascript-utils/is-type");
var _makeIterator = require("../../iterators/make-iterator/make-iterator");
var _responseUtils = require("../utils/response-utils");
const ERR_DATA = "Cannot convert supplied data type";
function getArrayBufferOrStringFromDataSync(data, loader, options) {
    if (loader.text && typeof data === "string") return data;
    if ((0, _isType.isBuffer)(data)) data = data.buffer;
    if (data instanceof ArrayBuffer) {
        const arrayBuffer = data;
        if (loader.text && !loader.binary) {
            const textDecoder = new TextDecoder("utf8");
            return textDecoder.decode(arrayBuffer);
        }
        return arrayBuffer;
    }
    if (ArrayBuffer.isView(data)) {
        if (loader.text && !loader.binary) {
            const textDecoder1 = new TextDecoder("utf8");
            return textDecoder1.decode(data);
        }
        let arrayBuffer1 = data.buffer;
        const byteLength = data.byteLength || data.length;
        if (data.byteOffset !== 0 || byteLength !== arrayBuffer1.byteLength) arrayBuffer1 = arrayBuffer1.slice(data.byteOffset, data.byteOffset + byteLength);
        return arrayBuffer1;
    }
    throw new Error(ERR_DATA);
}
async function getArrayBufferOrStringFromData(data, loader, options) {
    const isArrayBuffer = data instanceof ArrayBuffer || ArrayBuffer.isView(data);
    if (typeof data === "string" || isArrayBuffer) return getArrayBufferOrStringFromDataSync(data, loader, options);
    if ((0, _isType.isBlob)(data)) data = await (0, _responseUtils.makeResponse)(data);
    if ((0, _isType.isResponse)(data)) {
        const response = data;
        await (0, _responseUtils.checkResponse)(response);
        return loader.binary ? await response.arrayBuffer() : await response.text();
    }
    if ((0, _isType.isReadableStream)(data)) data = (0, _makeIterator.makeIterator)(data, options);
    if ((0, _isType.isIterable)(data) || (0, _isType.isAsyncIterable)(data)) return (0, _loaderUtils.concatenateArrayBuffersAsync)(data);
    throw new Error(ERR_DATA);
}
async function getAsyncIterableFromData(data, options) {
    if ((0, _isType.isIterator)(data)) return data;
    if ((0, _isType.isResponse)(data)) {
        const response = data;
        await (0, _responseUtils.checkResponse)(response);
        const body = await response.body;
        return (0, _makeIterator.makeIterator)(body, options);
    }
    if ((0, _isType.isBlob)(data) || (0, _isType.isReadableStream)(data)) return (0, _makeIterator.makeIterator)(data, options);
    if ((0, _isType.isAsyncIterable)(data)) return data[Symbol.asyncIterator]();
    return getIterableFromData(data);
}
async function getReadableStream(data) {
    if ((0, _isType.isReadableStream)(data)) return data;
    if ((0, _isType.isResponse)(data)) return data.body;
    const response = await (0, _responseUtils.makeResponse)(data);
    return response.body;
}
function getIterableFromData(data) {
    if (ArrayBuffer.isView(data)) return function* oneChunk() {
        yield data.buffer;
    }();
    if (data instanceof ArrayBuffer) return function* oneChunk() {
        yield data;
    }();
    if ((0, _isType.isIterator)(data)) return data;
    if ((0, _isType.isIterable)(data)) return data[Symbol.iterator]();
    throw new Error(ERR_DATA);
}

},{"@loaders.gl/loader-utils":"dIGVb","../../javascript-utils/is-type":"8cOpM","../../iterators/make-iterator/make-iterator":"ix2Cu","../utils/response-utils":"aPIYv","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ix2Cu":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "makeIterator", ()=>makeIterator);
var _makeStringIterator = require("./make-string-iterator");
var _makeArrayBufferIterator = require("./make-array-buffer-iterator");
var _makeBlobIterator = require("./make-blob-iterator");
var _makeStreamIterator = require("./make-stream-iterator");
var _isType = require("../../javascript-utils/is-type");
function makeIterator(data, options) {
    if (typeof data === "string") return (0, _makeStringIterator.makeStringIterator)(data, options);
    if (data instanceof ArrayBuffer) return (0, _makeArrayBufferIterator.makeArrayBufferIterator)(data, options);
    if ((0, _isType.isBlob)(data)) return (0, _makeBlobIterator.makeBlobIterator)(data, options);
    if ((0, _isType.isReadableStream)(data)) return (0, _makeStreamIterator.makeStreamIterator)(data, options);
    if ((0, _isType.isResponse)(data)) {
        const response = data;
        return (0, _makeStreamIterator.makeStreamIterator)(response.body, options);
    }
    throw new Error("makeIterator");
}

},{"./make-string-iterator":"1gHt8","./make-array-buffer-iterator":"7SjDI","./make-blob-iterator":"iuM2a","./make-stream-iterator":"5Llef","../../javascript-utils/is-type":"8cOpM","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1gHt8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "makeStringIterator", ()=>makeStringIterator);
const DEFAULT_CHUNK_SIZE = 262144;
function* makeStringIterator(string, options) {
    const chunkSize = (options === null || options === void 0 ? void 0 : options.chunkSize) || DEFAULT_CHUNK_SIZE;
    let offset = 0;
    const textEncoder = new TextEncoder();
    while(offset < string.length){
        const chunkLength = Math.min(string.length - offset, chunkSize);
        const chunk = string.slice(offset, offset + chunkLength);
        offset += chunkLength;
        yield textEncoder.encode(chunk);
    }
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7SjDI":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "makeArrayBufferIterator", ()=>makeArrayBufferIterator);
const DEFAULT_CHUNK_SIZE = 262144;
function* makeArrayBufferIterator(arrayBuffer, options = {}) {
    const { chunkSize =DEFAULT_CHUNK_SIZE  } = options;
    let byteOffset = 0;
    while(byteOffset < arrayBuffer.byteLength){
        const chunkByteLength = Math.min(arrayBuffer.byteLength - byteOffset, chunkSize);
        const chunk = new ArrayBuffer(chunkByteLength);
        const sourceArray = new Uint8Array(arrayBuffer, byteOffset, chunkByteLength);
        const chunkArray = new Uint8Array(chunk);
        chunkArray.set(sourceArray);
        byteOffset += chunkByteLength;
        yield chunk;
    }
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iuM2a":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "makeBlobIterator", ()=>makeBlobIterator);
const DEFAULT_CHUNK_SIZE = 1048576;
async function* makeBlobIterator(blob, options) {
    const chunkSize = (options === null || options === void 0 ? void 0 : options.chunkSize) || DEFAULT_CHUNK_SIZE;
    let offset = 0;
    while(offset < blob.size){
        const end = offset + chunkSize;
        const chunk = await blob.slice(offset, end).arrayBuffer();
        offset = end;
        yield chunk;
    }
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5Llef":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "makeStreamIterator", ()=>makeStreamIterator);
var _loaderUtils = require("@loaders.gl/loader-utils");
function makeStreamIterator(stream, options) {
    return (0, _loaderUtils.isBrowser) ? makeBrowserStreamIterator(stream, options) : makeNodeStreamIterator(stream, options);
}
async function* makeBrowserStreamIterator(stream, options) {
    const reader = stream.getReader();
    let nextBatchPromise;
    try {
        while(true){
            const currentBatchPromise = nextBatchPromise || reader.read();
            if (options !== null && options !== void 0 && options._streamReadAhead) nextBatchPromise = reader.read();
            const { done , value  } = await currentBatchPromise;
            if (done) return;
            yield (0, _loaderUtils.toArrayBuffer)(value);
        }
    } catch (error) {
        reader.releaseLock();
    }
}
async function* makeNodeStreamIterator(stream, options) {
    for await (const chunk of stream)yield (0, _loaderUtils.toArrayBuffer)(chunk);
}

},{"@loaders.gl/loader-utils":"dIGVb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lplHW":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getLoaderContext", ()=>getLoaderContext);
parcelHelpers.export(exports, "getLoadersFromContext", ()=>getLoadersFromContext);
var _optionUtils = require("./option-utils");
function getLoaderContext(context, options, previousContext = null) {
    if (previousContext) return previousContext;
    const resolvedContext = {
        fetch: (0, _optionUtils.getFetchFunction)(options, context),
        ...context
    };
    if (!Array.isArray(resolvedContext.loaders)) resolvedContext.loaders = null;
    return resolvedContext;
}
function getLoadersFromContext(loaders, context) {
    if (!context && loaders && !Array.isArray(loaders)) return loaders;
    let candidateLoaders;
    if (loaders) candidateLoaders = Array.isArray(loaders) ? loaders : [
        loaders
    ];
    if (context && context.loaders) {
        const contextLoaders = Array.isArray(context.loaders) ? context.loaders : [
            context.loaders
        ];
        candidateLoaders = candidateLoaders ? [
            ...candidateLoaders,
            ...contextLoaders
        ] : contextLoaders;
    }
    return candidateLoaders && candidateLoaders.length ? candidateLoaders : null;
}

},{"./option-utils":"5QYgB","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"akPph":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "load", ()=>load);
var _isType = require("../../javascript-utils/is-type");
var _normalizeLoader = require("../loader-utils/normalize-loader");
var _optionUtils = require("../loader-utils/option-utils");
var _parse = require("./parse");
async function load(url, loaders, options, context) {
    if (!Array.isArray(loaders) && !(0, _normalizeLoader.isLoaderObject)(loaders)) {
        context = undefined;
        options = loaders;
        loaders = undefined;
    }
    const fetch = (0, _optionUtils.getFetchFunction)(options);
    let data = url;
    if (typeof url === "string") data = await fetch(url);
    if ((0, _isType.isBlob)(url)) data = await fetch(url);
    return await (0, _parse.parse)(data, loaders, options);
}

},{"../../javascript-utils/is-type":"8cOpM","../loader-utils/normalize-loader":"dnJ09","../loader-utils/option-utils":"5QYgB","./parse":"k1WZf","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4b9Lz":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ImageLoader", ()=>(0, _imageLoader.ImageLoader));
parcelHelpers.export(exports, "ImageWriter", ()=>(0, _imageWriter.ImageWriter));
parcelHelpers.export(exports, "getBinaryImageMetadata", ()=>(0, _binaryImageApi.getBinaryImageMetadata));
parcelHelpers.export(exports, "isImageTypeSupported", ()=>(0, _imageType.isImageTypeSupported));
parcelHelpers.export(exports, "getDefaultImageType", ()=>(0, _imageType.getDefaultImageType));
parcelHelpers.export(exports, "isImage", ()=>(0, _parsedImageApi.isImage));
parcelHelpers.export(exports, "getImageType", ()=>(0, _parsedImageApi.getImageType));
parcelHelpers.export(exports, "getImageSize", ()=>(0, _parsedImageApi.getImageSize));
parcelHelpers.export(exports, "getImageData", ()=>(0, _parsedImageApi.getImageData));
parcelHelpers.export(exports, "_isImageFormatSupported", ()=>(0, _imageFormat._isImageFormatSupported));
parcelHelpers.export(exports, "loadImage", ()=>(0, _loadImage.loadImage));
var _imageLoader = require("./image-loader");
var _imageWriter = require("./image-writer");
var _binaryImageApi = require("./lib/category-api/binary-image-api");
var _imageType = require("./lib/category-api/image-type");
var _parsedImageApi = require("./lib/category-api/parsed-image-api");
var _imageFormat = require("./lib/category-api/image-format");
var _loadImage = require("./lib/texture-api/load-image");

},{"./image-loader":"1N4bg","./image-writer":false,"./lib/category-api/binary-image-api":"aSbA8","./lib/category-api/image-type":"87A6o","./lib/category-api/parsed-image-api":"fFVe2","./lib/category-api/image-format":false,"./lib/texture-api/load-image":false,"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1N4bg":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ImageLoader", ()=>ImageLoader);
parcelHelpers.export(exports, "_typecheckImageLoader", ()=>_typecheckImageLoader);
var _version = require("./lib/utils/version");
var _parseImage = require("./lib/parsers/parse-image");
var _parseImageDefault = parcelHelpers.interopDefault(_parseImage);
var _binaryImageApi = require("./lib/category-api/binary-image-api");
const EXTENSIONS = [
    "png",
    "jpg",
    "jpeg",
    "gif",
    "webp",
    "bmp",
    "ico",
    "svg"
];
const MIME_TYPES = [
    "image/png",
    "image/jpeg",
    "image/gif",
    "image/webp",
    "image/bmp",
    "image/vnd.microsoft.icon",
    "image/svg+xml"
];
const DEFAULT_IMAGE_LOADER_OPTIONS = {
    image: {
        type: "auto",
        decode: true
    }
};
const ImageLoader = {
    id: "image",
    module: "images",
    name: "Images",
    version: (0, _version.VERSION),
    mimeTypes: MIME_TYPES,
    extensions: EXTENSIONS,
    parse: (0, _parseImageDefault.default),
    tests: [
        (arrayBuffer)=>Boolean((0, _binaryImageApi.getBinaryImageMetadata)(new DataView(arrayBuffer)))
    ],
    options: DEFAULT_IMAGE_LOADER_OPTIONS
};
const _typecheckImageLoader = ImageLoader;

},{"./lib/utils/version":"1y0th","./lib/parsers/parse-image":"4m6XY","./lib/category-api/binary-image-api":"aSbA8","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1y0th":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "VERSION", ()=>VERSION);
const VERSION = "3.2.12";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4m6XY":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _loaderUtils = require("@loaders.gl/loader-utils");
var _imageType = require("../category-api/image-type");
var _parsedImageApi = require("../category-api/parsed-image-api");
var _parseToImage = require("./parse-to-image");
var _parseToImageDefault = parcelHelpers.interopDefault(_parseToImage);
var _parseToImageBitmap = require("./parse-to-image-bitmap");
var _parseToImageBitmapDefault = parcelHelpers.interopDefault(_parseToImageBitmap);
var _parseToNodeImage = require("./parse-to-node-image");
var _parseToNodeImageDefault = parcelHelpers.interopDefault(_parseToNodeImage);
async function parseImage(arrayBuffer, options, context) {
    options = options || {};
    const imageOptions = options.image || {};
    const imageType = imageOptions.type || "auto";
    const { url  } = context || {};
    const loadType = getLoadableImageType(imageType);
    let image;
    switch(loadType){
        case "imagebitmap":
            image = await (0, _parseToImageBitmapDefault.default)(arrayBuffer, options, url);
            break;
        case "image":
            image = await (0, _parseToImageDefault.default)(arrayBuffer, options, url);
            break;
        case "data":
            image = await (0, _parseToNodeImageDefault.default)(arrayBuffer, options);
            break;
        default:
            (0, _loaderUtils.assert)(false);
    }
    if (imageType === "data") image = (0, _parsedImageApi.getImageData)(image);
    return image;
}
exports.default = parseImage;
function getLoadableImageType(type) {
    switch(type){
        case "auto":
        case "data":
            return (0, _imageType.getDefaultImageType)();
        default:
            (0, _imageType.isImageTypeSupported)(type);
            return type;
    }
}

},{"@loaders.gl/loader-utils":"dIGVb","../category-api/image-type":"87A6o","../category-api/parsed-image-api":"fFVe2","./parse-to-image":"jQD4S","./parse-to-image-bitmap":"kNB0t","./parse-to-node-image":"04Hj6","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"87A6o":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isImageTypeSupported", ()=>isImageTypeSupported);
parcelHelpers.export(exports, "getDefaultImageType", ()=>getDefaultImageType);
var _loaderUtils = require("@loaders.gl/loader-utils");
const { _parseImageNode  } = globalThis;
const IMAGE_SUPPORTED = typeof Image !== "undefined";
const IMAGE_BITMAP_SUPPORTED = typeof ImageBitmap !== "undefined";
const NODE_IMAGE_SUPPORTED = Boolean(_parseImageNode);
const DATA_SUPPORTED = (0, _loaderUtils.isBrowser) ? true : NODE_IMAGE_SUPPORTED;
function isImageTypeSupported(type) {
    switch(type){
        case "auto":
            return IMAGE_BITMAP_SUPPORTED || IMAGE_SUPPORTED || DATA_SUPPORTED;
        case "imagebitmap":
            return IMAGE_BITMAP_SUPPORTED;
        case "image":
            return IMAGE_SUPPORTED;
        case "data":
            return DATA_SUPPORTED;
        default:
            throw new Error("@loaders.gl/images: image ".concat(type, " not supported in this environment"));
    }
}
function getDefaultImageType() {
    if (IMAGE_BITMAP_SUPPORTED) return "imagebitmap";
    if (IMAGE_SUPPORTED) return "image";
    if (DATA_SUPPORTED) return "data";
    throw new Error("Install '@loaders.gl/polyfills' to parse images under Node.js");
}

},{"@loaders.gl/loader-utils":"dIGVb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fFVe2":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isImage", ()=>isImage);
parcelHelpers.export(exports, "deleteImage", ()=>deleteImage);
parcelHelpers.export(exports, "getImageType", ()=>getImageType);
parcelHelpers.export(exports, "getImageSize", ()=>getImageSize);
parcelHelpers.export(exports, "getImageData", ()=>getImageData);
function isImage(image) {
    return Boolean(getImageTypeOrNull(image));
}
function deleteImage(image) {
    switch(getImageType(image)){
        case "imagebitmap":
            image.close();
            break;
        default:
    }
}
function getImageType(image) {
    const format = getImageTypeOrNull(image);
    if (!format) throw new Error("Not an image");
    return format;
}
function getImageSize(image) {
    return getImageData(image);
}
function getImageData(image) {
    switch(getImageType(image)){
        case "data":
            return image;
        case "image":
        case "imagebitmap":
            const canvas = document.createElement("canvas");
            const context = canvas.getContext("2d");
            if (!context) throw new Error("getImageData");
            canvas.width = image.width;
            canvas.height = image.height;
            context.drawImage(image, 0, 0);
            return context.getImageData(0, 0, image.width, image.height);
        default:
            throw new Error("getImageData");
    }
}
function getImageTypeOrNull(image) {
    if (typeof ImageBitmap !== "undefined" && image instanceof ImageBitmap) return "imagebitmap";
    if (typeof Image !== "undefined" && image instanceof Image) return "image";
    if (image && typeof image === "object" && image.data && image.width && image.height) return "data";
    return null;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jQD4S":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "loadToImage", ()=>loadToImage);
var _svgUtils = require("./svg-utils");
async function parseToImage(arrayBuffer, options, url) {
    const blobOrDataUrl = (0, _svgUtils.getBlobOrSVGDataUrl)(arrayBuffer, url);
    const URL = self.URL || self.webkitURL;
    const objectUrl = typeof blobOrDataUrl !== "string" && URL.createObjectURL(blobOrDataUrl);
    try {
        return await loadToImage(objectUrl || blobOrDataUrl, options);
    } finally{
        if (objectUrl) URL.revokeObjectURL(objectUrl);
    }
}
exports.default = parseToImage;
async function loadToImage(url, options) {
    const image = new Image();
    image.src = url;
    if (options.image && options.image.decode && image.decode) {
        await image.decode();
        return image;
    }
    return await new Promise((resolve, reject)=>{
        try {
            image.onload = ()=>resolve(image);
            image.onerror = (err)=>reject(new Error("Could not load image ".concat(url, ": ").concat(err)));
        } catch (error) {
            reject(error);
        }
    });
}

},{"./svg-utils":"5kpAy","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5kpAy":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isSVG", ()=>isSVG);
parcelHelpers.export(exports, "getBlobOrSVGDataUrl", ()=>getBlobOrSVGDataUrl);
parcelHelpers.export(exports, "getBlob", ()=>getBlob);
const SVG_DATA_URL_PATTERN = /^data:image\/svg\+xml/;
const SVG_URL_PATTERN = /\.svg((\?|#).*)?$/;
function isSVG(url) {
    return url && (SVG_DATA_URL_PATTERN.test(url) || SVG_URL_PATTERN.test(url));
}
function getBlobOrSVGDataUrl(arrayBuffer, url) {
    if (isSVG(url)) {
        const textDecoder = new TextDecoder();
        let xmlText = textDecoder.decode(arrayBuffer);
        try {
            if (typeof unescape === "function" && typeof encodeURIComponent === "function") xmlText = unescape(encodeURIComponent(xmlText));
        } catch (error) {
            throw new Error(error.message);
        }
        const src = "data:image/svg+xml;base64,".concat(btoa(xmlText));
        return src;
    }
    return getBlob(arrayBuffer, url);
}
function getBlob(arrayBuffer, url) {
    if (isSVG(url)) throw new Error("SVG cannot be parsed directly to imagebitmap");
    return new Blob([
        new Uint8Array(arrayBuffer)
    ]);
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kNB0t":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _svgUtils = require("./svg-utils");
var _parseToImage = require("./parse-to-image");
var _parseToImageDefault = parcelHelpers.interopDefault(_parseToImage);
const EMPTY_OBJECT = {};
let imagebitmapOptionsSupported = true;
async function parseToImageBitmap(arrayBuffer, options, url) {
    let blob;
    if ((0, _svgUtils.isSVG)(url)) {
        const image = await (0, _parseToImageDefault.default)(arrayBuffer, options, url);
        blob = image;
    } else blob = (0, _svgUtils.getBlob)(arrayBuffer, url);
    const imagebitmapOptions = options && options.imagebitmap;
    return await safeCreateImageBitmap(blob, imagebitmapOptions);
}
exports.default = parseToImageBitmap;
async function safeCreateImageBitmap(blob, imagebitmapOptions = null) {
    if (isEmptyObject(imagebitmapOptions) || !imagebitmapOptionsSupported) imagebitmapOptions = null;
    if (imagebitmapOptions) try {
        return await createImageBitmap(blob, imagebitmapOptions);
    } catch (error) {
        console.warn(error);
        imagebitmapOptionsSupported = false;
    }
    return await createImageBitmap(blob);
}
function isEmptyObject(object) {
    for(const key in object || EMPTY_OBJECT)return false;
    return true;
}

},{"./svg-utils":"5kpAy","./parse-to-image":"jQD4S","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"04Hj6":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _loaderUtils = require("@loaders.gl/loader-utils");
var _binaryImageApi = require("../category-api/binary-image-api");
async function parseToNodeImage(arrayBuffer, options) {
    const { mimeType  } = (0, _binaryImageApi.getBinaryImageMetadata)(arrayBuffer) || {};
    const _parseImageNode = globalThis._parseImageNode;
    (0, _loaderUtils.assert)(_parseImageNode);
    return await _parseImageNode(arrayBuffer, mimeType);
}
exports.default = parseToNodeImage;

},{"@loaders.gl/loader-utils":"dIGVb","../category-api/binary-image-api":"aSbA8","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aSbA8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getBinaryImageMetadata", ()=>getBinaryImageMetadata);
parcelHelpers.export(exports, "getBmpMetadata", ()=>getBmpMetadata);
const BIG_ENDIAN = false;
const LITTLE_ENDIAN = true;
function getBinaryImageMetadata(binaryData) {
    const dataView = toDataView(binaryData);
    return getPngMetadata(dataView) || getJpegMetadata(dataView) || getGifMetadata(dataView) || getBmpMetadata(dataView);
}
function getPngMetadata(binaryData) {
    const dataView = toDataView(binaryData);
    const isPng = dataView.byteLength >= 24 && dataView.getUint32(0, BIG_ENDIAN) === 0x89504e47;
    if (!isPng) return null;
    return {
        mimeType: "image/png",
        width: dataView.getUint32(16, BIG_ENDIAN),
        height: dataView.getUint32(20, BIG_ENDIAN)
    };
}
function getGifMetadata(binaryData) {
    const dataView = toDataView(binaryData);
    const isGif = dataView.byteLength >= 10 && dataView.getUint32(0, BIG_ENDIAN) === 0x47494638;
    if (!isGif) return null;
    return {
        mimeType: "image/gif",
        width: dataView.getUint16(6, LITTLE_ENDIAN),
        height: dataView.getUint16(8, LITTLE_ENDIAN)
    };
}
function getBmpMetadata(binaryData) {
    const dataView = toDataView(binaryData);
    const isBmp = dataView.byteLength >= 14 && dataView.getUint16(0, BIG_ENDIAN) === 0x424d && dataView.getUint32(2, LITTLE_ENDIAN) === dataView.byteLength;
    if (!isBmp) return null;
    return {
        mimeType: "image/bmp",
        width: dataView.getUint32(18, LITTLE_ENDIAN),
        height: dataView.getUint32(22, LITTLE_ENDIAN)
    };
}
function getJpegMetadata(binaryData) {
    const dataView = toDataView(binaryData);
    const isJpeg = dataView.byteLength >= 3 && dataView.getUint16(0, BIG_ENDIAN) === 0xffd8 && dataView.getUint8(2) === 0xff;
    if (!isJpeg) return null;
    const { tableMarkers , sofMarkers  } = getJpegMarkers();
    let i = 2;
    while(i + 9 < dataView.byteLength){
        const marker = dataView.getUint16(i, BIG_ENDIAN);
        if (sofMarkers.has(marker)) return {
            mimeType: "image/jpeg",
            height: dataView.getUint16(i + 5, BIG_ENDIAN),
            width: dataView.getUint16(i + 7, BIG_ENDIAN)
        };
        if (!tableMarkers.has(marker)) return null;
        i += 2;
        i += dataView.getUint16(i, BIG_ENDIAN);
    }
    return null;
}
function getJpegMarkers() {
    const tableMarkers = new Set([
        0xffdb,
        0xffc4,
        0xffcc,
        0xffdd,
        0xfffe
    ]);
    for(let i = 0xffe0; i < 0xfff0; ++i)tableMarkers.add(i);
    const sofMarkers = new Set([
        0xffc0,
        0xffc1,
        0xffc2,
        0xffc3,
        0xffc5,
        0xffc6,
        0xffc7,
        0xffc9,
        0xffca,
        0xffcb,
        0xffcd,
        0xffce,
        0xffcf,
        0xffde
    ]);
    return {
        tableMarkers,
        sofMarkers
    };
}
function toDataView(data) {
    if (data instanceof DataView) return data;
    if (ArrayBuffer.isView(data)) return new DataView(data.buffer);
    if (data instanceof ArrayBuffer) return new DataView(data);
    throw new Error("toDataView");
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iINk7":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _log = require("@probe.gl/log");
exports.default = new (0, _log.Log)({
    id: "deck"
});

},{"@probe.gl/log":"1XvNl","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"e6y6V":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "register", ()=>register);
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _loggers = require("./loggers");
let loggers = {};
loggers = (0, _loggers.getLoggers)((0, _logDefault.default));
function register(handlers) {
    loggers = handlers;
}
function debug(eventType, arg1, arg2, arg3) {
    if ((0, _logDefault.default).level > 0 && loggers[eventType]) loggers[eventType].call(null, arg1, arg2, arg3);
}
exports.default = debug;

},{"../utils/log":"iINk7","./loggers":"lctwA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lctwA":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getLoggers", ()=>getLoggers);
const logState = {
    attributeUpdateStart: -1,
    attributeManagerUpdateStart: -1,
    attributeUpdateMessages: []
};
const LOG_LEVEL_MAJOR_UPDATE = 1;
const LOG_LEVEL_MINOR_UPDATE = 2;
const LOG_LEVEL_UPDATE_DETAIL = 3;
const LOG_LEVEL_INFO = 4;
const LOG_LEVEL_DRAW = 2;
const getLoggers = (log)=>({
        "layer.changeFlag": (layer, key, flags)=>{
            log.log(LOG_LEVEL_UPDATE_DETAIL, "".concat(layer.id, " ").concat(key, ": "), flags[key])();
        },
        "layer.initialize": (layer)=>{
            log.log(LOG_LEVEL_MAJOR_UPDATE, "Initializing ".concat(layer))();
        },
        "layer.update": (layer, needsUpdate)=>{
            if (needsUpdate) {
                const flags = layer.getChangeFlags();
                log.log(LOG_LEVEL_MINOR_UPDATE, "Updating ".concat(layer, " because: ").concat(Object.keys(flags).filter((key)=>flags[key]).join(", ")))();
            } else log.log(LOG_LEVEL_INFO, "".concat(layer, " does not need update"))();
        },
        "layer.matched": (layer, changed)=>{
            if (changed) log.log(LOG_LEVEL_INFO, "Matched ".concat(layer, ", state transfered"))();
        },
        "layer.finalize": (layer)=>{
            log.log(LOG_LEVEL_MAJOR_UPDATE, "Finalizing ".concat(layer))();
        },
        "compositeLayer.renderLayers": (layer, updated, subLayers)=>{
            if (updated) log.log(LOG_LEVEL_MINOR_UPDATE, "Composite layer rendered new subLayers ".concat(layer), subLayers)();
            else log.log(LOG_LEVEL_INFO, "Composite layer reused subLayers ".concat(layer), subLayers)();
        },
        "layerManager.setLayers": (layerManager, updated, layers)=>{
            if (updated) log.log(LOG_LEVEL_MINOR_UPDATE, "Updating ".concat(layers.length, " deck layers"))();
        },
        "layerManager.activateViewport": (layerManager, viewport)=>{
            log.log(LOG_LEVEL_UPDATE_DETAIL, "Viewport changed", viewport)();
        },
        "attributeManager.invalidate": (attributeManager, trigger, attributeNames)=>{
            log.log(LOG_LEVEL_MAJOR_UPDATE, attributeNames ? "invalidated attributes ".concat(attributeNames, " (").concat(trigger, ") for ").concat(attributeManager.id) : "invalidated all attributes for ".concat(attributeManager.id))();
        },
        "attributeManager.updateStart": (attributeManager)=>{
            logState.attributeUpdateMessages.length = 0;
            logState.attributeManagerUpdateStart = Date.now();
        },
        "attributeManager.updateEnd": (attributeManager, numInstances)=>{
            const timeMs = Math.round(Date.now() - logState.attributeManagerUpdateStart);
            log.groupCollapsed(LOG_LEVEL_MINOR_UPDATE, "Updated attributes for ".concat(numInstances, " instances in ").concat(attributeManager.id, " in ").concat(timeMs, "ms"))();
            for (const updateMessage of logState.attributeUpdateMessages)log.log(LOG_LEVEL_UPDATE_DETAIL, updateMessage)();
            log.groupEnd(LOG_LEVEL_MINOR_UPDATE)();
        },
        "attribute.updateStart": (attribute)=>{
            logState.attributeUpdateStart = Date.now();
        },
        "attribute.allocate": (attribute, numInstances)=>{
            const message = "".concat(attribute.id, " allocated ").concat(numInstances);
            logState.attributeUpdateMessages.push(message);
        },
        "attribute.updateEnd": (attribute, numInstances)=>{
            const timeMs = Math.round(Date.now() - logState.attributeUpdateStart);
            const message = "".concat(attribute.id, " updated ").concat(numInstances, " in ").concat(timeMs, "ms");
            logState.attributeUpdateMessages.push(message);
        },
        "deckRenderer.renderLayers": (deckRenderer, renderStats, opts)=>{
            const { pass , redrawReason , stats  } = opts;
            for (const status of renderStats){
                const { totalCount , visibleCount , compositeCount , pickableCount  } = status;
                const primitiveCount = totalCount - compositeCount;
                const hiddenCount = primitiveCount - visibleCount;
                log.log(LOG_LEVEL_DRAW, "RENDER #".concat(deckRenderer.renderCount, "   ").concat(visibleCount, " (of ").concat(totalCount, " layers) to ").concat(pass, " because ").concat(redrawReason, "   (").concat(hiddenCount, " hidden, ").concat(compositeCount, " composite ").concat(pickableCount, " pickable)"))();
                if (stats) stats.get("Redraw Layers").add(visibleCount);
            }
        }
    });

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dYnRW":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function isJSON(text) {
    const firstChar = text[0];
    const lastChar = text[text.length - 1];
    return firstChar === "{" && lastChar === "}" || firstChar === "[" && lastChar === "]";
}
exports.default = {
    id: "JSON",
    name: "JSON",
    module: "",
    version: "",
    options: {},
    extensions: [
        "json",
        "geojson"
    ],
    mimeTypes: [
        "application/json",
        "application/geo+json"
    ],
    testText: isJSON,
    parseTextSync: JSON.parse
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dQXUb":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "createProgramManager", ()=>createProgramManager);
parcelHelpers.export(exports, "picking", ()=>(0, _pickingDefault.default));
parcelHelpers.export(exports, "project", ()=>(0, _projectDefault.default));
parcelHelpers.export(exports, "project32", ()=>(0, _project32Default.default));
parcelHelpers.export(exports, "gouraudLighting", ()=>(0, _core.gouraudLighting));
parcelHelpers.export(exports, "phongLighting", ()=>(0, _core.phongLighting));
parcelHelpers.export(exports, "shadow", ()=>(0, _shadowDefault.default));
var _core = require("@luma.gl/core");
var _project = require("./project/project");
var _projectDefault = parcelHelpers.interopDefault(_project);
var _project32 = require("./project32/project32");
var _project32Default = parcelHelpers.interopDefault(_project32);
var _shadow = require("./shadow/shadow");
var _shadowDefault = parcelHelpers.interopDefault(_shadow);
var _picking = require("./picking/picking");
var _pickingDefault = parcelHelpers.interopDefault(_picking);
const DEFAULT_MODULES = [
    (0, _projectDefault.default)
];
const SHADER_HOOKS = [
    "vs:DECKGL_FILTER_SIZE(inout vec3 size, VertexGeometry geometry)",
    "vs:DECKGL_FILTER_GL_POSITION(inout vec4 position, VertexGeometry geometry)",
    "vs:DECKGL_FILTER_COLOR(inout vec4 color, VertexGeometry geometry)",
    "fs:DECKGL_FILTER_COLOR(inout vec4 color, FragmentGeometry geometry)"
];
function createProgramManager(gl) {
    const programManager = (0, _core.ProgramManager).getDefaultProgramManager(gl);
    for (const shaderModule of DEFAULT_MODULES)programManager.addDefaultModule(shaderModule);
    for (const shaderHook of SHADER_HOOKS)programManager.addShaderHook(shaderHook);
    return programManager;
}

},{"@luma.gl/core":"9yA57","./project/project":"7sBNM","./project32/project32":"1FHtp","./shadow/shadow":"3jgej","./picking/picking":"1yRfV","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9yA57":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "createGLContext", ()=>(0, _gltools.createGLContext));
parcelHelpers.export(exports, "instrumentGLContext", ()=>(0, _gltools.instrumentGLContext));
parcelHelpers.export(exports, "isWebGL", ()=>(0, _gltools.isWebGL));
parcelHelpers.export(exports, "isWebGL2", ()=>(0, _gltools.isWebGL2));
parcelHelpers.export(exports, "getParameters", ()=>(0, _gltools.getParameters));
parcelHelpers.export(exports, "setParameters", ()=>(0, _gltools.setParameters));
parcelHelpers.export(exports, "withParameters", ()=>(0, _gltools.withParameters));
parcelHelpers.export(exports, "resetParameters", ()=>(0, _gltools.resetParameters));
parcelHelpers.export(exports, "cssToDeviceRatio", ()=>(0, _gltools.cssToDeviceRatio));
parcelHelpers.export(exports, "cssToDevicePixels", ()=>(0, _gltools.cssToDevicePixels));
parcelHelpers.export(exports, "lumaStats", ()=>(0, _webgl.lumaStats));
parcelHelpers.export(exports, "FEATURES", ()=>(0, _webgl.FEATURES));
parcelHelpers.export(exports, "hasFeature", ()=>(0, _webgl.hasFeature));
parcelHelpers.export(exports, "hasFeatures", ()=>(0, _webgl.hasFeatures));
parcelHelpers.export(exports, "Buffer", ()=>(0, _webgl.Buffer));
parcelHelpers.export(exports, "Program", ()=>(0, _webgl.Program));
parcelHelpers.export(exports, "Framebuffer", ()=>(0, _webgl.Framebuffer));
parcelHelpers.export(exports, "Renderbuffer", ()=>(0, _webgl.Renderbuffer));
parcelHelpers.export(exports, "Texture2D", ()=>(0, _webgl.Texture2D));
parcelHelpers.export(exports, "TextureCube", ()=>(0, _webgl.TextureCube));
parcelHelpers.export(exports, "VertexShader", ()=>(0, _webgl.VertexShader));
parcelHelpers.export(exports, "FragmentShader", ()=>(0, _webgl.FragmentShader));
parcelHelpers.export(exports, "clear", ()=>(0, _webgl.clear));
parcelHelpers.export(exports, "readPixelsToArray", ()=>(0, _webgl.readPixelsToArray));
parcelHelpers.export(exports, "readPixelsToBuffer", ()=>(0, _webgl.readPixelsToBuffer));
parcelHelpers.export(exports, "cloneTextureFrom", ()=>(0, _webgl.cloneTextureFrom));
parcelHelpers.export(exports, "copyToTexture", ()=>(0, _webgl.copyToTexture));
parcelHelpers.export(exports, "Texture3D", ()=>(0, _webgl.Texture3D));
parcelHelpers.export(exports, "TransformFeedback", ()=>(0, _webgl.TransformFeedback));
parcelHelpers.export(exports, "AnimationLoop", ()=>(0, _engine.AnimationLoop));
parcelHelpers.export(exports, "Model", ()=>(0, _engine.Model));
parcelHelpers.export(exports, "Transform", ()=>(0, _engine.Transform));
parcelHelpers.export(exports, "ProgramManager", ()=>(0, _engine.ProgramManager));
parcelHelpers.export(exports, "Timeline", ()=>(0, _engine.Timeline));
parcelHelpers.export(exports, "Geometry", ()=>(0, _engine.Geometry));
parcelHelpers.export(exports, "ClipSpace", ()=>(0, _engine.ClipSpace));
parcelHelpers.export(exports, "ConeGeometry", ()=>(0, _engine.ConeGeometry));
parcelHelpers.export(exports, "CubeGeometry", ()=>(0, _engine.CubeGeometry));
parcelHelpers.export(exports, "CylinderGeometry", ()=>(0, _engine.CylinderGeometry));
parcelHelpers.export(exports, "IcoSphereGeometry", ()=>(0, _engine.IcoSphereGeometry));
parcelHelpers.export(exports, "PlaneGeometry", ()=>(0, _engine.PlaneGeometry));
parcelHelpers.export(exports, "SphereGeometry", ()=>(0, _engine.SphereGeometry));
parcelHelpers.export(exports, "TruncatedConeGeometry", ()=>(0, _engine.TruncatedConeGeometry));
parcelHelpers.export(exports, "normalizeShaderModule", ()=>(0, _shadertools.normalizeShaderModule));
parcelHelpers.export(exports, "fp32", ()=>(0, _shadertools.fp32));
parcelHelpers.export(exports, "fp64", ()=>(0, _shadertools.fp64));
parcelHelpers.export(exports, "project", ()=>(0, _shadertools.project));
parcelHelpers.export(exports, "dirlight", ()=>(0, _shadertools.dirlight));
parcelHelpers.export(exports, "picking", ()=>(0, _shadertools.picking));
parcelHelpers.export(exports, "gouraudLighting", ()=>(0, _shadertools.gouraudLighting));
parcelHelpers.export(exports, "phongLighting", ()=>(0, _shadertools.phongLighting));
parcelHelpers.export(exports, "pbr", ()=>(0, _shadertools.pbr));
parcelHelpers.export(exports, "log", ()=>(0, _webgl.log));
parcelHelpers.export(exports, "assert", ()=>(0, _webgl.assert));
parcelHelpers.export(exports, "uid", ()=>(0, _webgl.uid));
var _gltools = require("@luma.gl/gltools");
var _webgl = require("@luma.gl/webgl");
var _engine = require("@luma.gl/engine");
var _shadertools = require("@luma.gl/shadertools");

},{"@luma.gl/gltools":"aIkwg","@luma.gl/webgl":"4LrGo","@luma.gl/engine":"6iaDa","@luma.gl/shadertools":"gjHNu","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aIkwg":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "log", ()=>(0, _log.log));
parcelHelpers.export(exports, "isWebGL", ()=>(0, _webglChecks.isWebGL));
parcelHelpers.export(exports, "isWebGL2", ()=>(0, _webglChecks.isWebGL2));
parcelHelpers.export(exports, "getWebGL2Context", ()=>(0, _webglChecks.getWebGL2Context));
parcelHelpers.export(exports, "assertWebGLContext", ()=>(0, _webglChecks.assertWebGLContext));
parcelHelpers.export(exports, "assertWebGL2Context", ()=>(0, _webglChecks.assertWebGL2Context));
parcelHelpers.export(exports, "polyfillContext", ()=>(0, _polyfillContext.polyfillContext));
parcelHelpers.export(exports, "getParameters", ()=>(0, _unifiedParameterApi.getParameters));
parcelHelpers.export(exports, "setParameters", ()=>(0, _unifiedParameterApi.setParameters));
parcelHelpers.export(exports, "resetParameters", ()=>(0, _unifiedParameterApi.resetParameters));
parcelHelpers.export(exports, "withParameters", ()=>(0, _unifiedParameterApi.withParameters));
parcelHelpers.export(exports, "trackContextState", ()=>(0, _trackContextState.trackContextState));
parcelHelpers.export(exports, "pushContextState", ()=>(0, _trackContextState.pushContextState));
parcelHelpers.export(exports, "popContextState", ()=>(0, _trackContextState.popContextState));
parcelHelpers.export(exports, "createGLContext", ()=>(0, _context.createGLContext));
parcelHelpers.export(exports, "resizeGLContext", ()=>(0, _context.resizeGLContext));
parcelHelpers.export(exports, "instrumentGLContext", ()=>(0, _context.instrumentGLContext));
parcelHelpers.export(exports, "getContextDebugInfo", ()=>(0, _context.getContextDebugInfo));
parcelHelpers.export(exports, "cssToDeviceRatio", ()=>(0, _devicePixels.cssToDeviceRatio));
parcelHelpers.export(exports, "cssToDevicePixels", ()=>(0, _devicePixels.cssToDevicePixels));
var _log = require("./utils/log");
var _webglChecks = require("./utils/webgl-checks");
var _polyfillContext = require("./polyfill/polyfill-context");
var _unifiedParameterApi = require("./state-tracker/unified-parameter-api");
var _trackContextState = require("./state-tracker/track-context-state");
var _context = require("./context/context");
var _devicePixels = require("./utils/device-pixels");

},{"./utils/log":"3Y8CF","./utils/webgl-checks":"437R8","./polyfill/polyfill-context":"2PEbB","./state-tracker/unified-parameter-api":"fMyNC","./state-tracker/track-context-state":"s03a6","./context/context":"lGnkj","./utils/device-pixels":"3vEDz","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3Y8CF":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "log", ()=>log);
var _log = require("@probe.gl/log");
const log = new (0, _log.Log)({
    id: "luma.gl"
});

},{"@probe.gl/log":"1XvNl","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"437R8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ERR_WEBGL", ()=>ERR_WEBGL);
parcelHelpers.export(exports, "ERR_WEBGL2", ()=>ERR_WEBGL2);
parcelHelpers.export(exports, "isWebGL", ()=>isWebGL);
parcelHelpers.export(exports, "isWebGL2", ()=>isWebGL2);
parcelHelpers.export(exports, "getWebGL2Context", ()=>getWebGL2Context);
parcelHelpers.export(exports, "assertWebGLContext", ()=>assertWebGLContext);
parcelHelpers.export(exports, "assertWebGL2Context", ()=>assertWebGL2Context);
var _assert = require("./assert");
const ERR_CONTEXT = "Invalid WebGLRenderingContext";
const ERR_WEBGL = ERR_CONTEXT;
const ERR_WEBGL2 = "Requires WebGL2";
function isWebGL(gl) {
    if (typeof WebGLRenderingContext !== "undefined" && gl instanceof WebGLRenderingContext) return true;
    if (typeof WebGL2RenderingContext !== "undefined" && gl instanceof WebGL2RenderingContext) return true;
    return Boolean(gl && Number.isFinite(gl._version));
}
function isWebGL2(gl) {
    if (typeof WebGL2RenderingContext !== "undefined" && gl instanceof WebGL2RenderingContext) return true;
    return Boolean(gl && gl._version === 2);
}
function getWebGL2Context(gl) {
    return isWebGL2(gl) ? gl : null;
}
function assertWebGLContext(gl) {
    (0, _assert.assert)(isWebGL(gl), ERR_CONTEXT);
    return gl;
}
function assertWebGL2Context(gl) {
    (0, _assert.assert)(isWebGL2(gl), ERR_WEBGL2);
    return gl;
}

},{"./assert":"6h0Q9","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6h0Q9":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assert", ()=>assert);
function assert(condition, message) {
    if (!condition) throw new Error(message || "luma.gl: assertion failed.");
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2PEbB":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "polyfillContext", ()=>polyfillContext);
var _polyfillVertexArrayObject = require("./polyfill-vertex-array-object");
var _assert = require("../utils/assert");
var _polyfillTable = require("./polyfill-table");
function polyfillContext(gl) {
    gl.luma = gl.luma || {};
    const { luma  } = gl;
    if (!luma.polyfilled) {
        (0, _polyfillVertexArrayObject.polyfillVertexArrayObject)(gl);
        initializeExtensions(gl);
        installPolyfills(gl, (0, _polyfillTable.WEBGL2_CONTEXT_POLYFILLS));
        installOverrides(gl, {
            target: luma,
            target2: gl
        });
        luma.polyfilled = true;
    }
    return gl;
}
globalThis.polyfillContext = polyfillContext;
function initializeExtensions(gl) {
    gl.luma.extensions = {};
    const EXTENSIONS = gl.getSupportedExtensions() || [];
    for (const extension of EXTENSIONS)gl.luma[extension] = gl.getExtension(extension);
}
function installOverrides(gl, _ref) {
    let { target , target2  } = _ref;
    Object.keys((0, _polyfillTable.WEBGL2_CONTEXT_OVERRIDES)).forEach((key)=>{
        if (typeof (0, _polyfillTable.WEBGL2_CONTEXT_OVERRIDES)[key] === "function") {
            const originalFunc = gl[key] ? gl[key].bind(gl) : ()=>{};
            const polyfill = (0, _polyfillTable.WEBGL2_CONTEXT_OVERRIDES)[key].bind(null, gl, originalFunc);
            target[key] = polyfill;
            target2[key] = polyfill;
        }
    });
}
function installPolyfills(gl, polyfills) {
    for (const extension of Object.getOwnPropertyNames(polyfills))if (extension !== "overrides") polyfillExtension(gl, {
        extension,
        target: gl.luma,
        target2: gl
    });
}
function polyfillExtension(gl, _ref2) {
    let { extension , target , target2  } = _ref2;
    const defaults = (0, _polyfillTable.WEBGL2_CONTEXT_POLYFILLS)[extension];
    (0, _assert.assert)(defaults);
    const { meta ={}  } = defaults;
    const { suffix =""  } = meta;
    const ext = gl.getExtension(extension);
    for (const key of Object.keys(defaults)){
        const extKey = "".concat(key).concat(suffix);
        let polyfill = null;
        if (key === "meta") ;
        else if (typeof gl[key] === "function") ;
        else if (ext && typeof ext[extKey] === "function") polyfill = function() {
            return ext[extKey](...arguments);
        };
        else if (typeof defaults[key] === "function") polyfill = defaults[key].bind(target);
        if (polyfill) {
            target[key] = polyfill;
            target2[key] = polyfill;
        }
    }
}

},{"./polyfill-vertex-array-object":"gnYDT","../utils/assert":"6h0Q9","./polyfill-table":"3YDfR","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gnYDT":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "polyfillVertexArrayObject", ()=>polyfillVertexArrayObject);
const glErrorShadow = {};
function error(msg) {
    if (globalThis.console && globalThis.console.error) globalThis.console.error(msg);
}
function log(msg) {
    if (globalThis.console && globalThis.console.log) globalThis.console.log(msg);
}
function synthesizeGLError(err, opt_msg) {
    glErrorShadow[err] = true;
    if (opt_msg !== undefined) error(opt_msg);
}
function wrapGLError(gl) {
    const f = gl.getError;
    gl.getError = function getError() {
        let err;
        do {
            err = f.apply(gl);
            if (err !== 0) glErrorShadow[err] = true;
        }while (err !== 0);
        for(err in glErrorShadow)if (glErrorShadow[err]) {
            delete glErrorShadow[err];
            return parseInt(err, 10);
        }
        return 0;
    };
}
const WebGLVertexArrayObjectOES = function WebGLVertexArrayObjectOES(ext) {
    const gl = ext.gl;
    this.ext = ext;
    this.isAlive = true;
    this.hasBeenBound = false;
    this.elementArrayBuffer = null;
    this.attribs = new Array(ext.maxVertexAttribs);
    for(let n = 0; n < this.attribs.length; n++){
        const attrib = new WebGLVertexArrayObjectOES.VertexAttrib(gl);
        this.attribs[n] = attrib;
    }
    this.maxAttrib = 0;
};
WebGLVertexArrayObjectOES.VertexAttrib = function VertexAttrib(gl) {
    this.enabled = false;
    this.buffer = null;
    this.size = 4;
    this.type = 5126;
    this.normalized = false;
    this.stride = 16;
    this.offset = 0;
    this.cached = "";
    this.recache();
};
WebGLVertexArrayObjectOES.VertexAttrib.prototype.recache = function recache() {
    this.cached = [
        this.size,
        this.type,
        this.normalized,
        this.stride,
        this.offset
    ].join(":");
};
const OESVertexArrayObject = function OESVertexArrayObject(gl) {
    const self = this;
    this.gl = gl;
    wrapGLError(gl);
    const original = this.original = {
        getParameter: gl.getParameter,
        enableVertexAttribArray: gl.enableVertexAttribArray,
        disableVertexAttribArray: gl.disableVertexAttribArray,
        bindBuffer: gl.bindBuffer,
        getVertexAttrib: gl.getVertexAttrib,
        vertexAttribPointer: gl.vertexAttribPointer
    };
    gl.getParameter = function getParameter(pname) {
        if (pname === self.VERTEX_ARRAY_BINDING_OES) {
            if (self.currentVertexArrayObject === self.defaultVertexArrayObject) return null;
            return self.currentVertexArrayObject;
        }
        return original.getParameter.apply(this, arguments);
    };
    gl.enableVertexAttribArray = function enableVertexAttribArray(index) {
        const vao = self.currentVertexArrayObject;
        vao.maxAttrib = Math.max(vao.maxAttrib, index);
        const attrib = vao.attribs[index];
        attrib.enabled = true;
        return original.enableVertexAttribArray.apply(this, arguments);
    };
    gl.disableVertexAttribArray = function disableVertexAttribArray(index) {
        const vao = self.currentVertexArrayObject;
        vao.maxAttrib = Math.max(vao.maxAttrib, index);
        const attrib = vao.attribs[index];
        attrib.enabled = false;
        return original.disableVertexAttribArray.apply(this, arguments);
    };
    gl.bindBuffer = function bindBuffer(target, buffer) {
        switch(target){
            case 34962:
                self.currentArrayBuffer = buffer;
                break;
            case 34963:
                self.currentVertexArrayObject.elementArrayBuffer = buffer;
                break;
            default:
        }
        return original.bindBuffer.apply(this, arguments);
    };
    gl.getVertexAttrib = function getVertexAttrib(index, pname) {
        const vao = self.currentVertexArrayObject;
        const attrib = vao.attribs[index];
        switch(pname){
            case 34975:
                return attrib.buffer;
            case 34338:
                return attrib.enabled;
            case 34339:
                return attrib.size;
            case 34340:
                return attrib.stride;
            case 34341:
                return attrib.type;
            case 34922:
                return attrib.normalized;
            default:
                return original.getVertexAttrib.apply(this, arguments);
        }
    };
    gl.vertexAttribPointer = function vertexAttribPointer(indx, size, type, normalized, stride, offset) {
        const vao = self.currentVertexArrayObject;
        vao.maxAttrib = Math.max(vao.maxAttrib, indx);
        const attrib = vao.attribs[indx];
        attrib.buffer = self.currentArrayBuffer;
        attrib.size = size;
        attrib.type = type;
        attrib.normalized = normalized;
        attrib.stride = stride;
        attrib.offset = offset;
        attrib.recache();
        return original.vertexAttribPointer.apply(this, arguments);
    };
    if (gl.instrumentExtension) gl.instrumentExtension(this, "OES_vertex_array_object");
    if (gl.canvas) gl.canvas.addEventListener("webglcontextrestored", ()=>{
        log("OESVertexArrayObject emulation library context restored");
        self.reset_();
    }, true);
    this.reset_();
};
OESVertexArrayObject.prototype.VERTEX_ARRAY_BINDING_OES = 0x85b5;
OESVertexArrayObject.prototype.reset_ = function reset_() {
    const contextWasLost = this.vertexArrayObjects !== undefined;
    if (contextWasLost) for(let ii = 0; ii < this.vertexArrayObjects.length; ++ii)this.vertexArrayObjects.isAlive = false;
    const gl = this.gl;
    this.maxVertexAttribs = gl.getParameter(34921);
    this.defaultVertexArrayObject = new WebGLVertexArrayObjectOES(this);
    this.currentVertexArrayObject = null;
    this.currentArrayBuffer = null;
    this.vertexArrayObjects = [
        this.defaultVertexArrayObject
    ];
    this.bindVertexArrayOES(null);
};
OESVertexArrayObject.prototype.createVertexArrayOES = function createVertexArrayOES() {
    const arrayObject = new WebGLVertexArrayObjectOES(this);
    this.vertexArrayObjects.push(arrayObject);
    return arrayObject;
};
OESVertexArrayObject.prototype.deleteVertexArrayOES = function deleteVertexArrayOES(arrayObject) {
    arrayObject.isAlive = false;
    this.vertexArrayObjects.splice(this.vertexArrayObjects.indexOf(arrayObject), 1);
    if (this.currentVertexArrayObject === arrayObject) this.bindVertexArrayOES(null);
};
OESVertexArrayObject.prototype.isVertexArrayOES = function isVertexArrayOES(arrayObject) {
    if (arrayObject && arrayObject instanceof WebGLVertexArrayObjectOES) {
        if (arrayObject.hasBeenBound && arrayObject.ext === this) return true;
    }
    return false;
};
OESVertexArrayObject.prototype.bindVertexArrayOES = function bindVertexArrayOES(arrayObject) {
    const gl = this.gl;
    if (arrayObject && !arrayObject.isAlive) {
        synthesizeGLError(1282, "bindVertexArrayOES: attempt to bind deleted arrayObject");
        return;
    }
    const original = this.original;
    const oldVAO = this.currentVertexArrayObject;
    this.currentVertexArrayObject = arrayObject || this.defaultVertexArrayObject;
    this.currentVertexArrayObject.hasBeenBound = true;
    const newVAO = this.currentVertexArrayObject;
    if (oldVAO === newVAO) return;
    if (!oldVAO || newVAO.elementArrayBuffer !== oldVAO.elementArrayBuffer) original.bindBuffer.call(gl, 34963, newVAO.elementArrayBuffer);
    let currentBinding = this.currentArrayBuffer;
    const maxAttrib = Math.max(oldVAO ? oldVAO.maxAttrib : 0, newVAO.maxAttrib);
    for(let n = 0; n <= maxAttrib; n++){
        const attrib = newVAO.attribs[n];
        const oldAttrib = oldVAO ? oldVAO.attribs[n] : null;
        if (!oldVAO || attrib.enabled !== oldAttrib.enabled) {
            if (attrib.enabled) original.enableVertexAttribArray.call(gl, n);
            else original.disableVertexAttribArray.call(gl, n);
        }
        if (attrib.enabled) {
            let bufferChanged = false;
            if (!oldVAO || attrib.buffer !== oldAttrib.buffer) {
                if (currentBinding !== attrib.buffer) {
                    original.bindBuffer.call(gl, 34962, attrib.buffer);
                    currentBinding = attrib.buffer;
                }
                bufferChanged = true;
            }
            if (bufferChanged || attrib.cached !== oldAttrib.cached) original.vertexAttribPointer.call(gl, n, attrib.size, attrib.type, attrib.normalized, attrib.stride, attrib.offset);
        }
    }
    if (this.currentArrayBuffer !== currentBinding) original.bindBuffer.call(gl, 34962, this.currentArrayBuffer);
};
function polyfillVertexArrayObject(gl) {
    if (typeof gl.createVertexArray === "function") return;
    const original_getSupportedExtensions = gl.getSupportedExtensions;
    gl.getSupportedExtensions = function getSupportedExtensions() {
        const list = original_getSupportedExtensions.call(this) || [];
        if (list.indexOf("OES_vertex_array_object") < 0) list.push("OES_vertex_array_object");
        return list;
    };
    const original_getExtension = gl.getExtension;
    gl.getExtension = function getExtension(name) {
        const ext = original_getExtension.call(this, name);
        if (ext) return ext;
        if (name !== "OES_vertex_array_object") return null;
        if (!gl.__OESVertexArrayObject) this.__OESVertexArrayObject = new OESVertexArrayObject(this);
        return this.__OESVertexArrayObject;
    };
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3YDfR":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "WEBGL2_CONTEXT_POLYFILLS", ()=>WEBGL2_CONTEXT_POLYFILLS);
parcelHelpers.export(exports, "WEBGL2_CONTEXT_OVERRIDES", ()=>WEBGL2_CONTEXT_OVERRIDES);
var _assert = require("../utils/assert");
var _webglChecks = require("../utils/webgl-checks");
var _getParameterPolyfill = require("./get-parameter-polyfill");
const OES_vertex_array_object = "OES_vertex_array_object";
const ANGLE_instanced_arrays = "ANGLE_instanced_arrays";
const WEBGL_draw_buffers = "WEBGL_draw_buffers";
const EXT_disjoint_timer_query = "EXT_disjoint_timer_query";
const EXT_texture_filter_anisotropic = "EXT_texture_filter_anisotropic";
const ERR_VAO_NOT_SUPPORTED = "VertexArray requires WebGL2 or OES_vertex_array_object extension";
function getExtensionData(gl, extension) {
    return {
        webgl2: (0, _webglChecks.isWebGL2)(gl),
        ext: gl.getExtension(extension)
    };
}
const WEBGL2_CONTEXT_POLYFILLS = {
    [OES_vertex_array_object]: {
        meta: {
            suffix: "OES"
        },
        createVertexArray: ()=>{
            (0, _assert.assert)(false, ERR_VAO_NOT_SUPPORTED);
        },
        deleteVertexArray: ()=>{},
        bindVertexArray: ()=>{},
        isVertexArray: ()=>false
    },
    [ANGLE_instanced_arrays]: {
        meta: {
            suffix: "ANGLE"
        },
        vertexAttribDivisor (location, divisor) {
            (0, _assert.assert)(divisor === 0, "WebGL instanced rendering not supported");
        },
        drawElementsInstanced: ()=>{},
        drawArraysInstanced: ()=>{}
    },
    [WEBGL_draw_buffers]: {
        meta: {
            suffix: "WEBGL"
        },
        drawBuffers: ()=>{
            (0, _assert.assert)(false);
        }
    },
    [EXT_disjoint_timer_query]: {
        meta: {
            suffix: "EXT"
        },
        createQuery: ()=>{
            (0, _assert.assert)(false);
        },
        deleteQuery: ()=>{
            (0, _assert.assert)(false);
        },
        beginQuery: ()=>{
            (0, _assert.assert)(false);
        },
        endQuery: ()=>{},
        getQuery (handle, pname) {
            return this.getQueryObject(handle, pname);
        },
        getQueryParameter (handle, pname) {
            return this.getQueryObject(handle, pname);
        },
        getQueryObject: ()=>{}
    }
};
const WEBGL2_CONTEXT_OVERRIDES = {
    readBuffer: (gl, originalFunc, attachment)=>{
        if ((0, _webglChecks.isWebGL2)(gl)) originalFunc(attachment);
    },
    getVertexAttrib: (gl, originalFunc, location, pname)=>{
        const { webgl2 , ext  } = getExtensionData(gl, ANGLE_instanced_arrays);
        let result;
        switch(pname){
            case 35069:
                result = !webgl2 ? false : undefined;
                break;
            case 35070:
                result = !webgl2 && !ext ? 0 : undefined;
                break;
            default:
        }
        return result !== undefined ? result : originalFunc(location, pname);
    },
    getProgramParameter: (gl, originalFunc, program, pname)=>{
        if (!(0, _webglChecks.isWebGL2)(gl)) switch(pname){
            case 35967:
                return 35981;
            case 35971:
                return 0;
            case 35382:
                return 0;
            default:
        }
        return originalFunc(program, pname);
    },
    getInternalformatParameter: (gl, originalFunc, target, format, pname)=>{
        if (!(0, _webglChecks.isWebGL2)(gl)) switch(pname){
            case 32937:
                return new Int32Array([
                    0
                ]);
            default:
        }
        return gl.getInternalformatParameter(target, format, pname);
    },
    getTexParameter (gl, originalFunc, target, pname) {
        switch(pname){
            case 34046:
                const { extensions  } = gl.luma;
                const ext = extensions[EXT_texture_filter_anisotropic];
                pname = ext && ext.TEXTURE_MAX_ANISOTROPY_EXT || 34046;
                break;
            default:
        }
        return originalFunc(target, pname);
    },
    getParameter: (0, _getParameterPolyfill.getParameterPolyfill),
    hint (gl, originalFunc, pname, value) {
        return originalFunc(pname, value);
    }
};

},{"../utils/assert":"6h0Q9","../utils/webgl-checks":"437R8","./get-parameter-polyfill":"1C6rW","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1C6rW":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getParameterPolyfill", ()=>getParameterPolyfill);
var _webglChecks = require("../utils/webgl-checks");
const OES_element_index = "OES_element_index";
const WEBGL_draw_buffers = "WEBGL_draw_buffers";
const EXT_disjoint_timer_query = "EXT_disjoint_timer_query";
const EXT_disjoint_timer_query_webgl2 = "EXT_disjoint_timer_query_webgl2";
const EXT_texture_filter_anisotropic = "EXT_texture_filter_anisotropic";
const WEBGL_debug_renderer_info = "WEBGL_debug_renderer_info";
const GL_FRAGMENT_SHADER_DERIVATIVE_HINT = 0x8b8b;
const GL_DONT_CARE = 0x1100;
const GL_GPU_DISJOINT_EXT = 0x8fbb;
const GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = 0x84ff;
const GL_UNMASKED_VENDOR_WEBGL = 0x9245;
const GL_UNMASKED_RENDERER_WEBGL = 0x9246;
const getWebGL2ValueOrZero = (gl)=>!(0, _webglChecks.isWebGL2)(gl) ? 0 : undefined;
const WEBGL_PARAMETERS = {
    [3074]: (gl)=>!(0, _webglChecks.isWebGL2)(gl) ? 36064 : undefined,
    [GL_FRAGMENT_SHADER_DERIVATIVE_HINT]: (gl)=>!(0, _webglChecks.isWebGL2)(gl) ? GL_DONT_CARE : undefined,
    [35977]: getWebGL2ValueOrZero,
    [32937]: getWebGL2ValueOrZero,
    [GL_GPU_DISJOINT_EXT]: (gl, getParameter)=>{
        const ext = (0, _webglChecks.isWebGL2)(gl) ? gl.getExtension(EXT_disjoint_timer_query_webgl2) : gl.getExtension(EXT_disjoint_timer_query);
        return ext && ext.GPU_DISJOINT_EXT ? getParameter(ext.GPU_DISJOINT_EXT) : 0;
    },
    [GL_UNMASKED_VENDOR_WEBGL]: (gl, getParameter)=>{
        const ext = gl.getExtension(WEBGL_debug_renderer_info);
        return getParameter(ext && ext.UNMASKED_VENDOR_WEBGL || 7936);
    },
    [GL_UNMASKED_RENDERER_WEBGL]: (gl, getParameter)=>{
        const ext = gl.getExtension(WEBGL_debug_renderer_info);
        return getParameter(ext && ext.UNMASKED_RENDERER_WEBGL || 7937);
    },
    [GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT]: (gl, getParameter)=>{
        const ext = gl.luma.extensions[EXT_texture_filter_anisotropic];
        return ext ? getParameter(ext.MAX_TEXTURE_MAX_ANISOTROPY_EXT) : 1.0;
    },
    [32883]: getWebGL2ValueOrZero,
    [35071]: getWebGL2ValueOrZero,
    [37447]: getWebGL2ValueOrZero,
    [36063]: (gl, getParameter)=>{
        if (!(0, _webglChecks.isWebGL2)(gl)) {
            const ext = gl.getExtension(WEBGL_draw_buffers);
            return ext ? getParameter(ext.MAX_COLOR_ATTACHMENTS_WEBGL) : 0;
        }
        return undefined;
    },
    [35379]: getWebGL2ValueOrZero,
    [35374]: getWebGL2ValueOrZero,
    [35377]: getWebGL2ValueOrZero,
    [34852]: (gl)=>{
        if (!(0, _webglChecks.isWebGL2)(gl)) {
            const ext = gl.getExtension(WEBGL_draw_buffers);
            return ext ? ext.MAX_DRAW_BUFFERS_WEBGL : 0;
        }
        return undefined;
    },
    [36203]: (gl)=>gl.getExtension(OES_element_index) ? 2147483647 : 65535,
    [33001]: (gl)=>gl.getExtension(OES_element_index) ? 16777216 : 65535,
    [33000]: (gl)=>16777216,
    [37157]: getWebGL2ValueOrZero,
    [35373]: getWebGL2ValueOrZero,
    [35657]: getWebGL2ValueOrZero,
    [36183]: getWebGL2ValueOrZero,
    [37137]: getWebGL2ValueOrZero,
    [34045]: getWebGL2ValueOrZero,
    [35978]: getWebGL2ValueOrZero,
    [35979]: getWebGL2ValueOrZero,
    [35968]: getWebGL2ValueOrZero,
    [35376]: getWebGL2ValueOrZero,
    [35375]: getWebGL2ValueOrZero,
    [35659]: getWebGL2ValueOrZero,
    [37154]: getWebGL2ValueOrZero,
    [35371]: getWebGL2ValueOrZero,
    [35658]: getWebGL2ValueOrZero,
    [35076]: getWebGL2ValueOrZero,
    [35077]: getWebGL2ValueOrZero,
    [35380]: getWebGL2ValueOrZero
};
function getParameterPolyfill(gl, originalGetParameter, pname) {
    const limit = WEBGL_PARAMETERS[pname];
    const value = typeof limit === "function" ? limit(gl, originalGetParameter, pname) : limit;
    const result = value !== undefined ? value : originalGetParameter(pname);
    return result;
}

},{"../utils/webgl-checks":"437R8","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fMyNC":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "setParameters", ()=>setParameters);
parcelHelpers.export(exports, "getParameters", ()=>getParameters);
parcelHelpers.export(exports, "resetParameters", ()=>resetParameters);
parcelHelpers.export(exports, "withParameters", ()=>withParameters);
var _webglParameterTables = require("./webgl-parameter-tables");
var _trackContextState = require("./track-context-state");
var _assert = require("../utils/assert");
var _webglChecks = require("../utils/webgl-checks");
var _utils = require("../utils/utils");
function setParameters(gl, values) {
    (0, _assert.assert)((0, _webglChecks.isWebGL)(gl), "setParameters requires a WebGL context");
    if ((0, _utils.isObjectEmpty)(values)) return;
    const compositeSetters = {};
    for(const key in values){
        const glConstant = Number(key);
        const setter = (0, _webglParameterTables.GL_PARAMETER_SETTERS)[key];
        if (setter) {
            if (typeof setter === "string") compositeSetters[setter] = true;
            else setter(gl, values[key], glConstant);
        }
    }
    const cache = gl.state && gl.state.cache;
    if (cache) for(const key1 in compositeSetters){
        const compositeSetter = (0, _webglParameterTables.GL_COMPOSITE_PARAMETER_SETTERS)[key1];
        compositeSetter(gl, values, cache);
    }
}
function getParameters(gl, parameters) {
    parameters = parameters || (0, _webglParameterTables.GL_PARAMETER_DEFAULTS);
    if (typeof parameters === "number") {
        const key = parameters;
        const getter = (0, _webglParameterTables.GL_PARAMETER_GETTERS)[key];
        return getter ? getter(gl, key) : gl.getParameter(key);
    }
    const parameterKeys = Array.isArray(parameters) ? parameters : Object.keys(parameters);
    const state = {};
    for (const key1 of parameterKeys){
        const getter1 = (0, _webglParameterTables.GL_PARAMETER_GETTERS)[key1];
        state[key1] = getter1 ? getter1(gl, Number(key1)) : gl.getParameter(Number(key1));
    }
    return state;
}
function resetParameters(gl) {
    setParameters(gl, (0, _webglParameterTables.GL_PARAMETER_DEFAULTS));
}
function withParameters(gl, parameters, func) {
    if ((0, _utils.isObjectEmpty)(parameters)) return func(gl);
    const { nocatch =true  } = parameters;
    (0, _trackContextState.pushContextState)(gl);
    setParameters(gl, parameters);
    let value;
    if (nocatch) {
        value = func(gl);
        (0, _trackContextState.popContextState)(gl);
    } else try {
        value = func(gl);
    } finally{
        (0, _trackContextState.popContextState)(gl);
    }
    return value;
}

},{"./webgl-parameter-tables":"kYfge","./track-context-state":"s03a6","../utils/assert":"6h0Q9","../utils/webgl-checks":"437R8","../utils/utils":"2s2sA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kYfge":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "GL_PARAMETER_DEFAULTS", ()=>GL_PARAMETER_DEFAULTS);
parcelHelpers.export(exports, "GL_PARAMETER_SETTERS", ()=>GL_PARAMETER_SETTERS);
parcelHelpers.export(exports, "GL_COMPOSITE_PARAMETER_SETTERS", ()=>GL_COMPOSITE_PARAMETER_SETTERS);
parcelHelpers.export(exports, "GL_HOOKED_SETTERS", ()=>GL_HOOKED_SETTERS);
parcelHelpers.export(exports, "GL_PARAMETER_GETTERS", ()=>GL_PARAMETER_GETTERS);
var _webglChecks = require("../utils/webgl-checks");
const GL_PARAMETER_DEFAULTS = {
    [3042]: false,
    [32773]: new Float32Array([
        0,
        0,
        0,
        0
    ]),
    [32777]: 32774,
    [34877]: 32774,
    [32969]: 1,
    [32968]: 0,
    [32971]: 1,
    [32970]: 0,
    [3106]: new Float32Array([
        0,
        0,
        0,
        0
    ]),
    [3107]: [
        true,
        true,
        true,
        true
    ],
    [2884]: false,
    [2885]: 1029,
    [2929]: false,
    [2931]: 1,
    [2932]: 513,
    [2928]: new Float32Array([
        0,
        1
    ]),
    [2930]: true,
    [3024]: true,
    [36006]: null,
    [2886]: 2305,
    [33170]: 4352,
    [2849]: 1,
    [32823]: false,
    [32824]: 0,
    [10752]: 0,
    [32938]: 1.0,
    [32939]: false,
    [3089]: false,
    [3088]: new Int32Array([
        0,
        0,
        1024,
        1024
    ]),
    [2960]: false,
    [2961]: 0,
    [2968]: 0xffffffff,
    [36005]: 0xffffffff,
    [2962]: 519,
    [2967]: 0,
    [2963]: 0xffffffff,
    [34816]: 519,
    [36003]: 0,
    [36004]: 0xffffffff,
    [2964]: 7680,
    [2965]: 7680,
    [2966]: 7680,
    [34817]: 7680,
    [34818]: 7680,
    [34819]: 7680,
    [2978]: [
        0,
        0,
        1024,
        1024
    ],
    [3333]: 4,
    [3317]: 4,
    [37440]: false,
    [37441]: false,
    [37443]: 37444,
    [35723]: 4352,
    [36010]: null,
    [35977]: false,
    [3330]: 0,
    [3332]: 0,
    [3331]: 0,
    [3314]: 0,
    [32878]: 0,
    [3316]: 0,
    [3315]: 0,
    [32877]: 0
};
const enable = (gl, value, key)=>value ? gl.enable(key) : gl.disable(key);
const hint = (gl, value, key)=>gl.hint(key, value);
const pixelStorei = (gl, value, key)=>gl.pixelStorei(key, value);
const drawFramebuffer = (gl, value)=>{
    const target = (0, _webglChecks.isWebGL2)(gl) ? 36009 : 36160;
    return gl.bindFramebuffer(target, value);
};
const readFramebuffer = (gl, value)=>{
    return gl.bindFramebuffer(36008, value);
};
function isArray(array) {
    return Array.isArray(array) || ArrayBuffer.isView(array);
}
const GL_PARAMETER_SETTERS = {
    [3042]: enable,
    [32773]: (gl, value)=>gl.blendColor(...value),
    [32777]: "blendEquation",
    [34877]: "blendEquation",
    [32969]: "blendFunc",
    [32968]: "blendFunc",
    [32971]: "blendFunc",
    [32970]: "blendFunc",
    [3106]: (gl, value)=>gl.clearColor(...value),
    [3107]: (gl, value)=>gl.colorMask(...value),
    [2884]: enable,
    [2885]: (gl, value)=>gl.cullFace(value),
    [2929]: enable,
    [2931]: (gl, value)=>gl.clearDepth(value),
    [2932]: (gl, value)=>gl.depthFunc(value),
    [2928]: (gl, value)=>gl.depthRange(...value),
    [2930]: (gl, value)=>gl.depthMask(value),
    [3024]: enable,
    [35723]: hint,
    [36006]: drawFramebuffer,
    [2886]: (gl, value)=>gl.frontFace(value),
    [33170]: hint,
    [2849]: (gl, value)=>gl.lineWidth(value),
    [32823]: enable,
    [32824]: "polygonOffset",
    [10752]: "polygonOffset",
    [35977]: enable,
    [32938]: "sampleCoverage",
    [32939]: "sampleCoverage",
    [3089]: enable,
    [3088]: (gl, value)=>gl.scissor(...value),
    [2960]: enable,
    [2961]: (gl, value)=>gl.clearStencil(value),
    [2968]: (gl, value)=>gl.stencilMaskSeparate(1028, value),
    [36005]: (gl, value)=>gl.stencilMaskSeparate(1029, value),
    [2962]: "stencilFuncFront",
    [2967]: "stencilFuncFront",
    [2963]: "stencilFuncFront",
    [34816]: "stencilFuncBack",
    [36003]: "stencilFuncBack",
    [36004]: "stencilFuncBack",
    [2964]: "stencilOpFront",
    [2965]: "stencilOpFront",
    [2966]: "stencilOpFront",
    [34817]: "stencilOpBack",
    [34818]: "stencilOpBack",
    [34819]: "stencilOpBack",
    [2978]: (gl, value)=>gl.viewport(...value),
    [3333]: pixelStorei,
    [3317]: pixelStorei,
    [37440]: pixelStorei,
    [37441]: pixelStorei,
    [37443]: pixelStorei,
    [3330]: pixelStorei,
    [3332]: pixelStorei,
    [3331]: pixelStorei,
    [36010]: readFramebuffer,
    [3314]: pixelStorei,
    [32878]: pixelStorei,
    [3316]: pixelStorei,
    [3315]: pixelStorei,
    [32877]: pixelStorei,
    framebuffer: (gl, framebuffer)=>{
        const handle = framebuffer && "handle" in framebuffer ? framebuffer.handle : framebuffer;
        return gl.bindFramebuffer(36160, handle);
    },
    blend: (gl, value)=>value ? gl.enable(3042) : gl.disable(3042),
    blendColor: (gl, value)=>gl.blendColor(...value),
    blendEquation: (gl, args)=>{
        args = isArray(args) ? args : [
            args,
            args
        ];
        gl.blendEquationSeparate(...args);
    },
    blendFunc: (gl, args)=>{
        args = isArray(args) && args.length === 2 ? [
            ...args,
            ...args
        ] : args;
        gl.blendFuncSeparate(...args);
    },
    clearColor: (gl, value)=>gl.clearColor(...value),
    clearDepth: (gl, value)=>gl.clearDepth(value),
    clearStencil: (gl, value)=>gl.clearStencil(value),
    colorMask: (gl, value)=>gl.colorMask(...value),
    cull: (gl, value)=>value ? gl.enable(2884) : gl.disable(2884),
    cullFace: (gl, value)=>gl.cullFace(value),
    depthTest: (gl, value)=>value ? gl.enable(2929) : gl.disable(2929),
    depthFunc: (gl, value)=>gl.depthFunc(value),
    depthMask: (gl, value)=>gl.depthMask(value),
    depthRange: (gl, value)=>gl.depthRange(...value),
    dither: (gl, value)=>value ? gl.enable(3024) : gl.disable(3024),
    derivativeHint: (gl, value)=>{
        gl.hint(35723, value);
    },
    frontFace: (gl, value)=>gl.frontFace(value),
    mipmapHint: (gl, value)=>gl.hint(33170, value),
    lineWidth: (gl, value)=>gl.lineWidth(value),
    polygonOffsetFill: (gl, value)=>value ? gl.enable(32823) : gl.disable(32823),
    polygonOffset: (gl, value)=>gl.polygonOffset(...value),
    sampleCoverage: (gl, value)=>gl.sampleCoverage(...value),
    scissorTest: (gl, value)=>value ? gl.enable(3089) : gl.disable(3089),
    scissor: (gl, value)=>gl.scissor(...value),
    stencilTest: (gl, value)=>value ? gl.enable(2960) : gl.disable(2960),
    stencilMask: (gl, value)=>{
        value = isArray(value) ? value : [
            value,
            value
        ];
        const [mask, backMask] = value;
        gl.stencilMaskSeparate(1028, mask);
        gl.stencilMaskSeparate(1029, backMask);
    },
    stencilFunc: (gl, args)=>{
        args = isArray(args) && args.length === 3 ? [
            ...args,
            ...args
        ] : args;
        const [func, ref, mask, backFunc, backRef, backMask] = args;
        gl.stencilFuncSeparate(1028, func, ref, mask);
        gl.stencilFuncSeparate(1029, backFunc, backRef, backMask);
    },
    stencilOp: (gl, args)=>{
        args = isArray(args) && args.length === 3 ? [
            ...args,
            ...args
        ] : args;
        const [sfail, dpfail, dppass, backSfail, backDpfail, backDppass] = args;
        gl.stencilOpSeparate(1028, sfail, dpfail, dppass);
        gl.stencilOpSeparate(1029, backSfail, backDpfail, backDppass);
    },
    viewport: (gl, value)=>gl.viewport(...value)
};
function getValue(glEnum, values, cache) {
    return values[glEnum] !== undefined ? values[glEnum] : cache[glEnum];
}
const GL_COMPOSITE_PARAMETER_SETTERS = {
    blendEquation: (gl, values, cache)=>gl.blendEquationSeparate(getValue(32777, values, cache), getValue(34877, values, cache)),
    blendFunc: (gl, values, cache)=>gl.blendFuncSeparate(getValue(32969, values, cache), getValue(32968, values, cache), getValue(32971, values, cache), getValue(32970, values, cache)),
    polygonOffset: (gl, values, cache)=>gl.polygonOffset(getValue(32824, values, cache), getValue(10752, values, cache)),
    sampleCoverage: (gl, values, cache)=>gl.sampleCoverage(getValue(32938, values, cache), getValue(32939, values, cache)),
    stencilFuncFront: (gl, values, cache)=>gl.stencilFuncSeparate(1028, getValue(2962, values, cache), getValue(2967, values, cache), getValue(2963, values, cache)),
    stencilFuncBack: (gl, values, cache)=>gl.stencilFuncSeparate(1029, getValue(34816, values, cache), getValue(36003, values, cache), getValue(36004, values, cache)),
    stencilOpFront: (gl, values, cache)=>gl.stencilOpSeparate(1028, getValue(2964, values, cache), getValue(2965, values, cache), getValue(2966, values, cache)),
    stencilOpBack: (gl, values, cache)=>gl.stencilOpSeparate(1029, getValue(34817, values, cache), getValue(34818, values, cache), getValue(34819, values, cache))
};
const GL_HOOKED_SETTERS = {
    enable: (update, capability)=>update({
            [capability]: true
        }),
    disable: (update, capability)=>update({
            [capability]: false
        }),
    pixelStorei: (update, pname, value)=>update({
            [pname]: value
        }),
    hint: (update, pname, hint)=>update({
            [pname]: hint
        }),
    bindFramebuffer: (update, target, framebuffer)=>{
        switch(target){
            case 36160:
                return update({
                    [36006]: framebuffer,
                    [36010]: framebuffer
                });
            case 36009:
                return update({
                    [36006]: framebuffer
                });
            case 36008:
                return update({
                    [36010]: framebuffer
                });
            default:
                return null;
        }
    },
    blendColor: (update, r, g, b, a)=>update({
            [32773]: new Float32Array([
                r,
                g,
                b,
                a
            ])
        }),
    blendEquation: (update, mode)=>update({
            [32777]: mode,
            [34877]: mode
        }),
    blendEquationSeparate: (update, modeRGB, modeAlpha)=>update({
            [32777]: modeRGB,
            [34877]: modeAlpha
        }),
    blendFunc: (update, src, dst)=>update({
            [32969]: src,
            [32968]: dst,
            [32971]: src,
            [32970]: dst
        }),
    blendFuncSeparate: (update, srcRGB, dstRGB, srcAlpha, dstAlpha)=>update({
            [32969]: srcRGB,
            [32968]: dstRGB,
            [32971]: srcAlpha,
            [32970]: dstAlpha
        }),
    clearColor: (update, r, g, b, a)=>update({
            [3106]: new Float32Array([
                r,
                g,
                b,
                a
            ])
        }),
    clearDepth: (update, depth)=>update({
            [2931]: depth
        }),
    clearStencil: (update, s)=>update({
            [2961]: s
        }),
    colorMask: (update, r, g, b, a)=>update({
            [3107]: [
                r,
                g,
                b,
                a
            ]
        }),
    cullFace: (update, mode)=>update({
            [2885]: mode
        }),
    depthFunc: (update, func)=>update({
            [2932]: func
        }),
    depthRange: (update, zNear, zFar)=>update({
            [2928]: new Float32Array([
                zNear,
                zFar
            ])
        }),
    depthMask: (update, mask)=>update({
            [2930]: mask
        }),
    frontFace: (update, face)=>update({
            [2886]: face
        }),
    lineWidth: (update, width)=>update({
            [2849]: width
        }),
    polygonOffset: (update, factor, units)=>update({
            [32824]: factor,
            [10752]: units
        }),
    sampleCoverage: (update, value, invert)=>update({
            [32938]: value,
            [32939]: invert
        }),
    scissor: (update, x, y, width, height)=>update({
            [3088]: new Int32Array([
                x,
                y,
                width,
                height
            ])
        }),
    stencilMask: (update, mask)=>update({
            [2968]: mask,
            [36005]: mask
        }),
    stencilMaskSeparate: (update, face, mask)=>update({
            [face === 1028 ? 2968 : 36005]: mask
        }),
    stencilFunc: (update, func, ref, mask)=>update({
            [2962]: func,
            [2967]: ref,
            [2963]: mask,
            [34816]: func,
            [36003]: ref,
            [36004]: mask
        }),
    stencilFuncSeparate: (update, face, func, ref, mask)=>update({
            [face === 1028 ? 2962 : 34816]: func,
            [face === 1028 ? 2967 : 36003]: ref,
            [face === 1028 ? 2963 : 36004]: mask
        }),
    stencilOp: (update, fail, zfail, zpass)=>update({
            [2964]: fail,
            [2965]: zfail,
            [2966]: zpass,
            [34817]: fail,
            [34818]: zfail,
            [34819]: zpass
        }),
    stencilOpSeparate: (update, face, fail, zfail, zpass)=>update({
            [face === 1028 ? 2964 : 34817]: fail,
            [face === 1028 ? 2965 : 34818]: zfail,
            [face === 1028 ? 2966 : 34819]: zpass
        }),
    viewport: (update, x, y, width, height)=>update({
            [2978]: [
                x,
                y,
                width,
                height
            ]
        })
};
const isEnabled = (gl, key)=>gl.isEnabled(key);
const GL_PARAMETER_GETTERS = {
    [3042]: isEnabled,
    [2884]: isEnabled,
    [2929]: isEnabled,
    [3024]: isEnabled,
    [32823]: isEnabled,
    [32926]: isEnabled,
    [32928]: isEnabled,
    [3089]: isEnabled,
    [2960]: isEnabled,
    [35977]: isEnabled
};

},{"../utils/webgl-checks":"437R8","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"s03a6":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "trackContextState", ()=>trackContextState);
parcelHelpers.export(exports, "pushContextState", ()=>pushContextState);
parcelHelpers.export(exports, "popContextState", ()=>popContextState);
var _webglParameterTables = require("./webgl-parameter-tables");
var _unifiedParameterApi = require("./unified-parameter-api");
var _assert = require("../utils/assert");
var _utils = require("../utils/utils");
function installGetterOverride(gl, functionName) {
    const originalGetterFunc = gl[functionName].bind(gl);
    gl[functionName] = function get() {
        const pname = arguments.length <= 0 ? undefined : arguments[0];
        if (!(pname in gl.state.cache)) return originalGetterFunc(...arguments);
        return gl.state.enable ? gl.state.cache[pname] : originalGetterFunc(...arguments);
    };
    Object.defineProperty(gl[functionName], "name", {
        value: "".concat(functionName, "-from-cache"),
        configurable: false
    });
}
function installSetterSpy(gl, functionName, setter) {
    const originalSetterFunc = gl[functionName].bind(gl);
    gl[functionName] = function set() {
        for(var _len = arguments.length, params = new Array(_len), _key = 0; _key < _len; _key++)params[_key] = arguments[_key];
        const { valueChanged , oldValue  } = setter(gl.state._updateCache, ...params);
        if (valueChanged) originalSetterFunc(...params);
        return oldValue;
    };
    Object.defineProperty(gl[functionName], "name", {
        value: "".concat(functionName, "-to-cache"),
        configurable: false
    });
}
function installProgramSpy(gl) {
    const originalUseProgram = gl.useProgram.bind(gl);
    gl.useProgram = function useProgramLuma(handle) {
        if (gl.state.program !== handle) {
            originalUseProgram(handle);
            gl.state.program = handle;
        }
    };
}
class GLState {
    constructor(gl){
        let { copyState =false , log =()=>{}  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        this.gl = gl;
        this.program = null;
        this.stateStack = [];
        this.enable = true;
        this.cache = copyState ? (0, _unifiedParameterApi.getParameters)(gl) : Object.assign({}, (0, _webglParameterTables.GL_PARAMETER_DEFAULTS));
        this.log = log;
        this._updateCache = this._updateCache.bind(this);
        Object.seal(this);
    }
    push() {
        let values = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this.stateStack.push({});
    }
    pop() {
        (0, _assert.assert)(this.stateStack.length > 0);
        const oldValues = this.stateStack[this.stateStack.length - 1];
        (0, _unifiedParameterApi.setParameters)(this.gl, oldValues);
        this.stateStack.pop();
    }
    _updateCache(values) {
        let valueChanged = false;
        let oldValue;
        const oldValues = this.stateStack.length > 0 && this.stateStack[this.stateStack.length - 1];
        for(const key in values){
            (0, _assert.assert)(key !== undefined);
            const value = values[key];
            const cached = this.cache[key];
            if (!(0, _utils.deepArrayEqual)(value, cached)) {
                valueChanged = true;
                oldValue = cached;
                if (oldValues && !(key in oldValues)) oldValues[key] = cached;
                this.cache[key] = value;
            }
        }
        return {
            valueChanged,
            oldValue
        };
    }
}
function trackContextState(gl) {
    let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    const { enable =true , copyState  } = options;
    (0, _assert.assert)(copyState !== undefined);
    if (!gl.state) {
        const { polyfillContext  } = globalThis;
        if (polyfillContext) polyfillContext(gl);
        gl.state = new GLState(gl, {
            copyState
        });
        installProgramSpy(gl);
        for(const key in 0, _webglParameterTables.GL_HOOKED_SETTERS){
            const setter = (0, _webglParameterTables.GL_HOOKED_SETTERS)[key];
            installSetterSpy(gl, key, setter);
        }
        installGetterOverride(gl, "getParameter");
        installGetterOverride(gl, "isEnabled");
    }
    gl.state.enable = enable;
    return gl;
}
function pushContextState(gl) {
    if (!gl.state) trackContextState(gl, {
        copyState: false
    });
    gl.state.push();
}
function popContextState(gl) {
    (0, _assert.assert)(gl.state);
    gl.state.pop();
}

},{"./webgl-parameter-tables":"kYfge","./unified-parameter-api":"fMyNC","../utils/assert":"6h0Q9","../utils/utils":"2s2sA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2s2sA":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "isObjectEmpty", ()=>isObjectEmpty);
parcelHelpers.export(exports, "deepArrayEqual", ()=>deepArrayEqual);
function isObjectEmpty(object) {
    for(const key in object)return false;
    return true;
}
function deepArrayEqual(x, y) {
    if (x === y) return true;
    const isArrayX = Array.isArray(x) || ArrayBuffer.isView(x);
    const isArrayY = Array.isArray(y) || ArrayBuffer.isView(y);
    if (isArrayX && isArrayY && x.length === y.length) {
        for(let i = 0; i < x.length; ++i){
            if (x[i] !== y[i]) return false;
        }
        return true;
    }
    return false;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lGnkj":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "createGLContext", ()=>createGLContext);
parcelHelpers.export(exports, "instrumentGLContext", ()=>instrumentGLContext);
parcelHelpers.export(exports, "getContextDebugInfo", ()=>getContextDebugInfo);
parcelHelpers.export(exports, "resizeGLContext", ()=>resizeGLContext);
var _env = require("@probe.gl/env");
var _trackContextState = require("../state-tracker/track-context-state");
var _log = require("../utils/log");
var _assert = require("../utils/assert");
var _devicePixels = require("../utils/device-pixels");
var _webglChecks = require("../utils/webgl-checks");
const isBrowser = (0, _env.isBrowser)();
const isPage = isBrowser && typeof document !== "undefined";
const CONTEXT_DEFAULTS = {
    webgl2: true,
    webgl1: true,
    throwOnError: true,
    manageState: true,
    canvas: null,
    debug: false,
    width: 800,
    height: 600
};
function createGLContext() {
    let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    (0, _assert.assert)(isBrowser, "createGLContext only available in the browser.\nCreate your own headless context or use 'createHeadlessContext' from @luma.gl/test-utils");
    options = Object.assign({}, CONTEXT_DEFAULTS, options);
    const { width , height  } = options;
    function onError(message) {
        if (options.throwOnError) throw new Error(message);
        console.error(message);
        return null;
    }
    options.onError = onError;
    let gl;
    const { canvas  } = options;
    const targetCanvas = getCanvas({
        canvas,
        width,
        height,
        onError
    });
    gl = createBrowserContext(targetCanvas, options);
    if (!gl) return null;
    gl = instrumentGLContext(gl, options);
    logInfo(gl);
    return gl;
}
function instrumentGLContext(gl) {
    let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (!gl || gl._instrumented) return gl;
    gl._version = gl._version || getVersion(gl);
    gl.luma = gl.luma || {};
    gl.luma.canvasSizeInfo = gl.luma.canvasSizeInfo || {};
    options = Object.assign({}, CONTEXT_DEFAULTS, options);
    const { manageState , debug  } = options;
    if (manageState) (0, _trackContextState.trackContextState)(gl, {
        copyState: false,
        log: function() {
            for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++)args[_key] = arguments[_key];
            return (0, _log.log).log(1, ...args)();
        }
    });
    if (isBrowser && debug) {
        if (!globalThis.makeDebugContext) (0, _log.log).warn('WebGL debug mode not activated. import "@luma.gl/debug" to enable.')();
        else {
            gl = globalThis.makeDebugContext(gl, options);
            (0, _log.log).level = Math.max((0, _log.log).level, 1);
        }
    }
    gl._instrumented = true;
    return gl;
}
function getContextDebugInfo(gl) {
    const vendorMasked = gl.getParameter(7936);
    const rendererMasked = gl.getParameter(7937);
    const ext = gl.getExtension("WEBGL_debug_renderer_info");
    const vendorUnmasked = ext && gl.getParameter(ext.UNMASKED_VENDOR_WEBGL || 7936);
    const rendererUnmasked = ext && gl.getParameter(ext.UNMASKED_RENDERER_WEBGL || 7937);
    return {
        vendor: vendorUnmasked || vendorMasked,
        renderer: rendererUnmasked || rendererMasked,
        vendorMasked,
        rendererMasked,
        version: gl.getParameter(7938),
        shadingLanguageVersion: gl.getParameter(35724)
    };
}
function resizeGLContext(gl) {
    let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    if (gl.canvas) {
        const devicePixelRatio = (0, _devicePixels.getDevicePixelRatio)(options.useDevicePixels);
        setDevicePixelRatio(gl, devicePixelRatio, options);
        return;
    }
    const ext = gl.getExtension("STACKGL_resize_drawingbuffer");
    if (ext && "width" in options && "height" in options) ext.resize(options.width, options.height);
}
function createBrowserContext(canvas, options) {
    const { onError  } = options;
    let errorMessage = null;
    const onCreateError = (error)=>errorMessage = error.statusMessage || errorMessage;
    canvas.addEventListener("webglcontextcreationerror", onCreateError, false);
    const { webgl1 =true , webgl2 =true  } = options;
    let gl = null;
    if (webgl2) {
        gl = gl || canvas.getContext("webgl2", options);
        gl = gl || canvas.getContext("experimental-webgl2", options);
    }
    if (webgl1) {
        gl = gl || canvas.getContext("webgl", options);
        gl = gl || canvas.getContext("experimental-webgl", options);
    }
    canvas.removeEventListener("webglcontextcreationerror", onCreateError, false);
    if (!gl) return onError("Failed to create ".concat(webgl2 && !webgl1 ? "WebGL2" : "WebGL", " context: ").concat(errorMessage || "Unknown error"));
    if (options.onContextLost) canvas.addEventListener("webglcontextlost", options.onContextLost, false);
    if (options.onContextRestored) canvas.addEventListener("webglcontextrestored", options.onContextRestored, false);
    return gl;
}
function getCanvas(_ref) {
    let { canvas , width =800 , height =600 , onError  } = _ref;
    let targetCanvas;
    if (typeof canvas === "string") {
        const isPageLoaded = isPage && document.readyState === "complete";
        if (!isPageLoaded) onError("createGLContext called on canvas '".concat(canvas, "' before page was loaded"));
        targetCanvas = document.getElementById(canvas);
    } else if (canvas) targetCanvas = canvas;
    else {
        targetCanvas = document.createElement("canvas");
        targetCanvas.id = "lumagl-canvas";
        targetCanvas.style.width = Number.isFinite(width) ? "".concat(width, "px") : "100%";
        targetCanvas.style.height = Number.isFinite(height) ? "".concat(height, "px") : "100%";
        document.body.insertBefore(targetCanvas, document.body.firstChild);
    }
    return targetCanvas;
}
function logInfo(gl) {
    const webGL = (0, _webglChecks.isWebGL2)(gl) ? "WebGL2" : "WebGL1";
    const info = getContextDebugInfo(gl);
    const driver = info ? "(".concat(info.vendor, ",").concat(info.renderer, ")") : "";
    const debug = gl.debug ? " debug" : "";
    (0, _log.log).info(1, "".concat(webGL).concat(debug, " context ").concat(driver))();
}
function getVersion(gl) {
    if (typeof WebGL2RenderingContext !== "undefined" && gl instanceof WebGL2RenderingContext) return 2;
    return 1;
}
function setDevicePixelRatio(gl, devicePixelRatio, options) {
    let clientWidth = "width" in options ? options.width : gl.canvas.clientWidth;
    let clientHeight = "height" in options ? options.height : gl.canvas.clientHeight;
    if (!clientWidth || !clientHeight) {
        (0, _log.log).log(1, "Canvas clientWidth/clientHeight is 0")();
        devicePixelRatio = 1;
        clientWidth = gl.canvas.width || 1;
        clientHeight = gl.canvas.height || 1;
    }
    gl.luma = gl.luma || {};
    gl.luma.canvasSizeInfo = gl.luma.canvasSizeInfo || {};
    const cachedSize = gl.luma.canvasSizeInfo;
    if (cachedSize.clientWidth !== clientWidth || cachedSize.clientHeight !== clientHeight || cachedSize.devicePixelRatio !== devicePixelRatio) {
        let clampedPixelRatio = devicePixelRatio;
        const canvasWidth = Math.floor(clientWidth * clampedPixelRatio);
        const canvasHeight = Math.floor(clientHeight * clampedPixelRatio);
        gl.canvas.width = canvasWidth;
        gl.canvas.height = canvasHeight;
        if (gl.drawingBufferWidth !== canvasWidth || gl.drawingBufferHeight !== canvasHeight) {
            (0, _log.log).warn("Device pixel ratio clamped")();
            clampedPixelRatio = Math.min(gl.drawingBufferWidth / clientWidth, gl.drawingBufferHeight / clientHeight);
            gl.canvas.width = Math.floor(clientWidth * clampedPixelRatio);
            gl.canvas.height = Math.floor(clientHeight * clampedPixelRatio);
        }
        Object.assign(gl.luma.canvasSizeInfo, {
            clientWidth,
            clientHeight,
            devicePixelRatio
        });
    }
}

},{"@probe.gl/env":"6dzgb","../state-tracker/track-context-state":"s03a6","../utils/log":"3Y8CF","../utils/assert":"6h0Q9","../utils/device-pixels":"3vEDz","../utils/webgl-checks":"437R8","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3vEDz":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "cssToDeviceRatio", ()=>cssToDeviceRatio);
parcelHelpers.export(exports, "cssToDevicePixels", ()=>cssToDevicePixels);
parcelHelpers.export(exports, "getDevicePixelRatio", ()=>getDevicePixelRatio);
function cssToDeviceRatio(gl) {
    const { luma  } = gl;
    if (gl.canvas && luma) {
        const { clientWidth  } = luma.canvasSizeInfo;
        return clientWidth ? gl.drawingBufferWidth / clientWidth : 1;
    }
    return 1;
}
function cssToDevicePixels(gl, cssPixel) {
    let yInvert = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
    const ratio = cssToDeviceRatio(gl);
    const width = gl.drawingBufferWidth;
    const height = gl.drawingBufferHeight;
    return scalePixels(cssPixel, ratio, width, height, yInvert);
}
function getDevicePixelRatio(useDevicePixels) {
    const windowRatio = typeof window === "undefined" ? 1 : window.devicePixelRatio || 1;
    if (Number.isFinite(useDevicePixels)) return useDevicePixels <= 0 ? 1 : useDevicePixels;
    return useDevicePixels ? windowRatio : 1;
}
function scalePixels(pixel, ratio, width, height, yInvert) {
    const x = scaleX(pixel[0], ratio, width);
    let y = scaleY(pixel[1], ratio, height, yInvert);
    let t = scaleX(pixel[0] + 1, ratio, width);
    const xHigh = t === width - 1 ? t : t - 1;
    t = scaleY(pixel[1] + 1, ratio, height, yInvert);
    let yHigh;
    if (yInvert) {
        t = t === 0 ? t : t + 1;
        yHigh = y;
        y = t;
    } else yHigh = t === height - 1 ? t : t - 1;
    return {
        x,
        y,
        width: Math.max(xHigh - x + 1, 1),
        height: Math.max(yHigh - y + 1, 1)
    };
}
function scaleX(x, ratio, width) {
    const r = Math.min(Math.round(x * ratio), width - 1);
    return r;
}
function scaleY(y, ratio, height, yInvert) {
    return yInvert ? Math.max(0, height - 1 - Math.round(y * ratio)) : Math.min(Math.round(y * ratio), height - 1);
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4LrGo":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "lumaStats", ()=>(0, _init.lumaStats));
parcelHelpers.export(exports, "requestAnimationFrame", ()=>(0, _requestAnimationFrame.requestAnimationFrame));
parcelHelpers.export(exports, "cancelAnimationFrame", ()=>(0, _requestAnimationFrame.cancelAnimationFrame));
parcelHelpers.export(exports, "cloneTextureFrom", ()=>(0, _textureUtils.cloneTextureFrom));
parcelHelpers.export(exports, "getKeyValue", ()=>(0, _constantsToKeys.getKeyValue));
parcelHelpers.export(exports, "getKey", ()=>(0, _constantsToKeys.getKey));
parcelHelpers.export(exports, "getContextInfo", ()=>(0, _limits.getContextInfo));
parcelHelpers.export(exports, "getGLContextInfo", ()=>(0, _limits.getGLContextInfo));
parcelHelpers.export(exports, "getContextLimits", ()=>(0, _limits.getContextLimits));
parcelHelpers.export(exports, "FEATURES", ()=>(0, _webglFeaturesTable.FEATURES));
parcelHelpers.export(exports, "hasFeature", ()=>(0, _features.hasFeature));
parcelHelpers.export(exports, "hasFeatures", ()=>(0, _features.hasFeatures));
parcelHelpers.export(exports, "getFeatures", ()=>(0, _features.getFeatures));
parcelHelpers.export(exports, "canCompileGLGSExtension", ()=>(0, _checkGlslExtensionDefault.default));
parcelHelpers.export(exports, "Accessor", ()=>(0, _accessorDefault.default));
parcelHelpers.export(exports, "Buffer", ()=>(0, _bufferDefault.default));
parcelHelpers.export(exports, "Shader", ()=>(0, _shader.Shader));
parcelHelpers.export(exports, "VertexShader", ()=>(0, _shader.VertexShader));
parcelHelpers.export(exports, "FragmentShader", ()=>(0, _shader.FragmentShader));
parcelHelpers.export(exports, "Program", ()=>(0, _programDefault.default));
parcelHelpers.export(exports, "Framebuffer", ()=>(0, _framebufferDefault.default));
parcelHelpers.export(exports, "Renderbuffer", ()=>(0, _renderbufferDefault.default));
parcelHelpers.export(exports, "Texture2D", ()=>(0, _texture2DDefault.default));
parcelHelpers.export(exports, "TextureCube", ()=>(0, _textureCubeDefault.default));
parcelHelpers.export(exports, "clear", ()=>(0, _clear.clear));
parcelHelpers.export(exports, "clearBuffer", ()=>(0, _clear.clearBuffer));
parcelHelpers.export(exports, "readPixelsToArray", ()=>(0, _copyAndBlit.readPixelsToArray));
parcelHelpers.export(exports, "readPixelsToBuffer", ()=>(0, _copyAndBlit.readPixelsToBuffer));
parcelHelpers.export(exports, "copyToDataUrl", ()=>(0, _copyAndBlit.copyToDataUrl));
parcelHelpers.export(exports, "copyToImage", ()=>(0, _copyAndBlit.copyToImage));
parcelHelpers.export(exports, "copyToTexture", ()=>(0, _copyAndBlit.copyToTexture));
parcelHelpers.export(exports, "blit", ()=>(0, _copyAndBlit.blit));
parcelHelpers.export(exports, "Query", ()=>(0, _queryDefault.default));
parcelHelpers.export(exports, "Texture3D", ()=>(0, _texture3DDefault.default));
parcelHelpers.export(exports, "TransformFeedback", ()=>(0, _transformFeedbackDefault.default));
parcelHelpers.export(exports, "VertexArrayObject", ()=>(0, _vertexArrayObjectDefault.default));
parcelHelpers.export(exports, "VertexArray", ()=>(0, _vertexArrayDefault.default));
parcelHelpers.export(exports, "UniformBufferLayout", ()=>(0, _uniformBufferLayoutDefault.default));
parcelHelpers.export(exports, "setPathPrefix", ()=>(0, _loadFile.setPathPrefix));
parcelHelpers.export(exports, "loadFile", ()=>(0, _loadFile.loadFile));
parcelHelpers.export(exports, "loadImage", ()=>(0, _loadFile.loadImage));
parcelHelpers.export(exports, "getShaderName", ()=>(0, _getShaderNameDefault.default));
parcelHelpers.export(exports, "getShaderVersion", ()=>(0, _getShaderVersionDefault.default));
parcelHelpers.export(exports, "log", ()=>(0, _gltools.log));
parcelHelpers.export(exports, "assert", ()=>(0, _assert.assert));
parcelHelpers.export(exports, "uid", ()=>(0, _utils.uid));
parcelHelpers.export(exports, "isObjectEmpty", ()=>(0, _utils.isObjectEmpty));
parcelHelpers.export(exports, "parseUniformName", ()=>(0, _uniforms.parseUniformName));
parcelHelpers.export(exports, "getUniformSetter", ()=>(0, _uniforms.getUniformSetter));
parcelHelpers.export(exports, "getDebugTableForUniforms", ()=>(0, _debugUniforms.getDebugTableForUniforms));
parcelHelpers.export(exports, "getDebugTableForVertexArray", ()=>(0, _debugVertexArray.getDebugTableForVertexArray));
parcelHelpers.export(exports, "getDebugTableForProgramConfiguration", ()=>(0, _debugProgramConfiguration.getDebugTableForProgramConfiguration));
var _init = require("./init");
var _requestAnimationFrame = require("./webgl-utils/request-animation-frame");
var _textureUtils = require("./webgl-utils/texture-utils");
var _constantsToKeys = require("./webgl-utils/constants-to-keys");
var _limits = require("./features/limits");
var _webglFeaturesTable = require("./features/webgl-features-table");
var _features = require("./features/features");
var _checkGlslExtension = require("./features/check-glsl-extension");
var _checkGlslExtensionDefault = parcelHelpers.interopDefault(_checkGlslExtension);
var _accessor = require("./classes/accessor");
var _accessorDefault = parcelHelpers.interopDefault(_accessor);
var _buffer = require("./classes/buffer");
var _bufferDefault = parcelHelpers.interopDefault(_buffer);
var _shader = require("./classes/shader");
var _program = require("./classes/program");
var _programDefault = parcelHelpers.interopDefault(_program);
var _framebuffer = require("./classes/framebuffer");
var _framebufferDefault = parcelHelpers.interopDefault(_framebuffer);
var _renderbuffer = require("./classes/renderbuffer");
var _renderbufferDefault = parcelHelpers.interopDefault(_renderbuffer);
var _texture2D = require("./classes/texture-2d");
var _texture2DDefault = parcelHelpers.interopDefault(_texture2D);
var _textureCube = require("./classes/texture-cube");
var _textureCubeDefault = parcelHelpers.interopDefault(_textureCube);
var _clear = require("./classes/clear");
var _copyAndBlit = require("./classes/copy-and-blit");
var _query = require("./classes/query");
var _queryDefault = parcelHelpers.interopDefault(_query);
var _texture3D = require("./classes/texture-3d");
var _texture3DDefault = parcelHelpers.interopDefault(_texture3D);
var _transformFeedback = require("./classes/transform-feedback");
var _transformFeedbackDefault = parcelHelpers.interopDefault(_transformFeedback);
var _vertexArrayObject = require("./classes/vertex-array-object");
var _vertexArrayObjectDefault = parcelHelpers.interopDefault(_vertexArrayObject);
var _vertexArray = require("./classes/vertex-array");
var _vertexArrayDefault = parcelHelpers.interopDefault(_vertexArray);
var _uniformBufferLayout = require("./classes/uniform-buffer-layout");
var _uniformBufferLayoutDefault = parcelHelpers.interopDefault(_uniformBufferLayout);
var _loadFile = require("./utils/load-file");
var _getShaderName = require("./glsl-utils/get-shader-name");
var _getShaderNameDefault = parcelHelpers.interopDefault(_getShaderName);
var _getShaderVersion = require("./glsl-utils/get-shader-version");
var _getShaderVersionDefault = parcelHelpers.interopDefault(_getShaderVersion);
var _gltools = require("@luma.gl/gltools");
var _assert = require("./utils/assert");
var _utils = require("./utils/utils");
var _uniforms = require("./classes/uniforms");
var _debugUniforms = require("./debug/debug-uniforms");
var _debugVertexArray = require("./debug/debug-vertex-array");
var _debugProgramConfiguration = require("./debug/debug-program-configuration");

},{"./init":"7XbRT","./webgl-utils/request-animation-frame":"PeSeb","./webgl-utils/texture-utils":"9VLOZ","./webgl-utils/constants-to-keys":"9tmTY","./features/limits":false,"./features/webgl-features-table":"6TJ7X","./features/features":"k5Bgw","./features/check-glsl-extension":false,"./classes/accessor":"9zq2J","./classes/buffer":"4AGCy","./classes/shader":"e1xCc","./classes/program":"6vdQd","./classes/framebuffer":"8XBFw","./classes/renderbuffer":"kY99Z","./classes/texture-2d":"fCSl3","./classes/texture-cube":"e9dKT","./classes/clear":"ejQqu","./classes/copy-and-blit":"iOt7e","./classes/query":"aG7Qa","./classes/texture-3d":"lL9iV","./classes/transform-feedback":"3JXgK","./classes/vertex-array-object":"eO1Wv","./classes/vertex-array":"cSPWF","./classes/uniform-buffer-layout":false,"./utils/load-file":"6JotM","./glsl-utils/get-shader-name":"gXko9","./glsl-utils/get-shader-version":"lG7lN","@luma.gl/gltools":"aIkwg","./utils/assert":"hxAMc","./utils/utils":"adQQr","./classes/uniforms":"3d3Rq","./debug/debug-uniforms":"kT0ac","./debug/debug-vertex-array":"l39Jz","./debug/debug-program-configuration":"ltF5l","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7XbRT":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "StatsManager", ()=>StatsManager);
parcelHelpers.export(exports, "lumaStats", ()=>lumaStats);
var _gltools = require("@luma.gl/gltools");
var _stats = require("@probe.gl/stats");
var _env = require("@probe.gl/env");
const VERSION = "8.5.16";
const STARTUP_MESSAGE = "set luma.log.level=1 (or higher) to trace rendering";
class StatsManager {
    constructor(){
        this.stats = new Map();
    }
    get(name) {
        if (!this.stats.has(name)) this.stats.set(name, new (0, _stats.Stats)({
            id: name
        }));
        return this.stats.get(name);
    }
}
const lumaStats = new StatsManager();
if (globalThis.luma && globalThis.luma.VERSION !== VERSION) throw new Error("luma.gl - multiple VERSIONs detected: ".concat(globalThis.luma.VERSION, " vs ").concat(VERSION));
if (!globalThis.luma) {
    if ((0, _env.isBrowser)()) (0, _gltools.log).log(1, "luma.gl ".concat(VERSION, " - ").concat(STARTUP_MESSAGE))();
    globalThis.luma = globalThis.luma || {
        VERSION,
        version: VERSION,
        log: (0, _gltools.log),
        stats: lumaStats,
        globals: {
            modules: {},
            nodeIO: {}
        }
    };
}
exports.default = globalThis.luma;

},{"@luma.gl/gltools":"aIkwg","@probe.gl/stats":"krQZu","@probe.gl/env":"6dzgb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"PeSeb":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "requestAnimationFrame", ()=>requestAnimationFrame);
parcelHelpers.export(exports, "cancelAnimationFrame", ()=>cancelAnimationFrame);
function requestAnimationFrame(callback) {
    return typeof window !== "undefined" && window.requestAnimationFrame ? window.requestAnimationFrame(callback) : setTimeout(callback, 1000 / 60);
}
function cancelAnimationFrame(timerId) {
    return typeof window !== "undefined" && window.cancelAnimationFrame ? window.cancelAnimationFrame(timerId) : clearTimeout(timerId);
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9VLOZ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "cloneTextureFrom", ()=>cloneTextureFrom);
parcelHelpers.export(exports, "toFramebuffer", ()=>toFramebuffer);
var _texture2D = require("../classes/texture-2d");
var _texture2DDefault = parcelHelpers.interopDefault(_texture2D);
var _textureCube = require("../classes/texture-cube");
var _textureCubeDefault = parcelHelpers.interopDefault(_textureCube);
var _texture3D = require("../classes/texture-3d");
var _texture3DDefault = parcelHelpers.interopDefault(_texture3D);
var _framebuffer = require("../classes/framebuffer");
var _framebufferDefault = parcelHelpers.interopDefault(_framebuffer);
var _assert = require("../utils/assert");
function cloneTextureFrom(refTexture, overrides) {
    (0, _assert.assert)(refTexture instanceof (0, _texture2DDefault.default) || refTexture instanceof (0, _textureCubeDefault.default) || refTexture instanceof (0, _texture3DDefault.default));
    const TextureType = refTexture.constructor;
    const { gl , width , height , format , type , dataFormat , border , mipmaps  } = refTexture;
    const textureOptions = Object.assign({
        width,
        height,
        format,
        type,
        dataFormat,
        border,
        mipmaps
    }, overrides);
    return new TextureType(gl, textureOptions);
}
function toFramebuffer(texture, opts) {
    const { gl , width , height , id  } = texture;
    const framebuffer = new (0, _framebufferDefault.default)(gl, Object.assign({}, opts, {
        id: "framebuffer-for-".concat(id),
        width,
        height,
        attachments: {
            [36064]: texture
        }
    }));
    return framebuffer;
}

},{"../classes/texture-2d":"fCSl3","../classes/texture-cube":"e9dKT","../classes/texture-3d":"lL9iV","../classes/framebuffer":"8XBFw","../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fCSl3":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _texture = require("./texture");
var _textureDefault = parcelHelpers.interopDefault(_texture);
var _loadFile = require("../utils/load-file");
class Texture2D extends (0, _textureDefault.default) {
    get [Symbol.toStringTag]() {
        return "Texture2D";
    }
    static isSupported(gl, opts) {
        return (0, _textureDefault.default).isSupported(gl, opts);
    }
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        (0, _gltools.assertWebGLContext)(gl);
        if (props instanceof Promise || typeof props === "string") props = {
            data: props
        };
        if (typeof props.data === "string") props = Object.assign({}, props, {
            data: (0, _loadFile.loadImage)(props.data)
        });
        super(gl, Object.assign({}, props, {
            target: 3553
        }));
        this.initialize(props);
        Object.seal(this);
    }
}
exports.default = Texture2D;

},{"@luma.gl/gltools":"aIkwg","./texture":"14YT4","../utils/load-file":"6JotM","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"14YT4":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
var _buffer = require("./buffer");
var _bufferDefault = parcelHelpers.interopDefault(_buffer);
var _textureFormats = require("./texture-formats");
var _assert = require("../utils/assert");
var _utils = require("../utils/utils");
const NPOT_MIN_FILTERS = [
    9729,
    9728
];
const WebGLBuffer = globalThis.WebGLBuffer || function WebGLBuffer() {};
class Texture extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "Texture";
    }
    static isSupported(gl) {
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        const { format , linearFiltering  } = opts;
        let supported = true;
        if (format) {
            supported = supported && (0, _textureFormats.isFormatSupported)(gl, format);
            supported = supported && (!linearFiltering || (0, _textureFormats.isLinearFilteringSupported)(gl, format));
        }
        return supported;
    }
    constructor(gl, props){
        const { id =(0, _utils.uid)("texture") , handle , target  } = props;
        super(gl, {
            id,
            handle
        });
        this.target = target;
        this.textureUnit = undefined;
        this.loaded = false;
        this.width = undefined;
        this.height = undefined;
        this.depth = undefined;
        this.format = undefined;
        this.type = undefined;
        this.dataFormat = undefined;
        this.border = undefined;
        this.textureUnit = undefined;
        this.mipmaps = undefined;
    }
    toString() {
        return "Texture(".concat(this.id, ",").concat(this.width, "x").concat(this.height, ")");
    }
    initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        let data = props.data;
        if (data instanceof Promise) {
            data.then((resolvedImageData)=>this.initialize(Object.assign({}, props, {
                    pixels: resolvedImageData,
                    data: resolvedImageData
                })));
            return this;
        }
        const isVideo = typeof HTMLVideoElement !== "undefined" && data instanceof HTMLVideoElement;
        if (isVideo && data.readyState < HTMLVideoElement.HAVE_METADATA) {
            this._video = null;
            data.addEventListener("loadeddata", ()=>this.initialize(props));
            return this;
        }
        const { pixels =null , format =6408 , border =0 , recreate =false , parameters ={} , pixelStore ={} , textureUnit  } = props;
        if (!data) data = pixels;
        let { width , height , dataFormat , type , compressed =false , mipmaps =true  } = props;
        const { depth =0  } = props;
        ({ width , height , compressed , dataFormat , type  } = this._deduceParameters({
            format,
            type,
            dataFormat,
            compressed,
            data,
            width,
            height
        }));
        this.width = width;
        this.height = height;
        this.depth = depth;
        this.format = format;
        this.type = type;
        this.dataFormat = dataFormat;
        this.border = border;
        this.textureUnit = textureUnit;
        if (Number.isFinite(this.textureUnit)) {
            this.gl.activeTexture(33984 + this.textureUnit);
            this.gl.bindTexture(this.target, this.handle);
        }
        if (mipmaps && this._isNPOT()) {
            (0, _gltools.log).warn("texture: ".concat(this, " is Non-Power-Of-Two, disabling mipmaping"))();
            mipmaps = false;
            this._updateForNPOT(parameters);
        }
        this.mipmaps = mipmaps;
        this.setImageData({
            data,
            width,
            height,
            depth,
            format,
            type,
            dataFormat,
            border,
            mipmaps,
            parameters: pixelStore,
            compressed
        });
        if (mipmaps) this.generateMipmap();
        this.setParameters(parameters);
        if (recreate) this.data = data;
        if (isVideo) this._video = {
            video: data,
            parameters,
            lastTime: data.readyState >= HTMLVideoElement.HAVE_CURRENT_DATA ? data.currentTime : -1
        };
        return this;
    }
    update() {
        if (this._video) {
            const { video , parameters , lastTime  } = this._video;
            if (lastTime === video.currentTime || video.readyState < HTMLVideoElement.HAVE_CURRENT_DATA) return;
            this.setSubImageData({
                data: video,
                parameters
            });
            if (this.mipmaps) this.generateMipmap();
            this._video.lastTime = video.currentTime;
        }
    }
    resize(_ref) {
        let { height , width , mipmaps =false  } = _ref;
        if (width !== this.width || height !== this.height) return this.initialize({
            width,
            height,
            format: this.format,
            type: this.type,
            dataFormat: this.dataFormat,
            border: this.border,
            mipmaps
        });
        return this;
    }
    generateMipmap() {
        let params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if (this._isNPOT()) {
            (0, _gltools.log).warn("texture: ".concat(this, " is Non-Power-Of-Two, disabling mipmaping"))();
            return this;
        }
        this.mipmaps = true;
        this.gl.bindTexture(this.target, this.handle);
        (0, _gltools.withParameters)(this.gl, params, ()=>{
            this.gl.generateMipmap(this.target);
        });
        this.gl.bindTexture(this.target, null);
        return this;
    }
    setImageData(options) {
        this._trackDeallocatedMemory("Texture");
        const { target =this.target , pixels =null , level =0 , format =this.format , border =this.border , offset =0 , parameters ={}  } = options;
        let { data =null , type =this.type , width =this.width , height =this.height , dataFormat =this.dataFormat , compressed =false  } = options;
        if (!data) data = pixels;
        ({ type , dataFormat , compressed , width , height  } = this._deduceParameters({
            format,
            type,
            dataFormat,
            compressed,
            data,
            width,
            height
        }));
        const { gl  } = this;
        gl.bindTexture(this.target, this.handle);
        let dataType = null;
        ({ data , dataType  } = this._getDataType({
            data,
            compressed
        }));
        let gl2;
        let compressedTextureSize = 0;
        (0, _gltools.withParameters)(this.gl, parameters, ()=>{
            switch(dataType){
                case "null":
                    gl.texImage2D(target, level, format, width, height, border, dataFormat, type, data);
                    break;
                case "typed-array":
                    gl.texImage2D(target, level, format, width, height, border, dataFormat, type, data, offset);
                    break;
                case "buffer":
                    gl2 = (0, _gltools.assertWebGL2Context)(gl);
                    gl2.bindBuffer(35052, data.handle || data);
                    gl2.texImage2D(target, level, format, width, height, border, dataFormat, type, offset);
                    gl2.bindBuffer(35052, null);
                    break;
                case "browser-object":
                    if ((0, _gltools.isWebGL2)(gl)) gl.texImage2D(target, level, format, width, height, border, dataFormat, type, data);
                    else gl.texImage2D(target, level, format, dataFormat, type, data);
                    break;
                case "compressed":
                    for (const [levelIndex, levelData] of data.entries()){
                        gl.compressedTexImage2D(target, levelIndex, levelData.format, levelData.width, levelData.height, border, levelData.data);
                        compressedTextureSize += levelData.levelSize;
                    }
                    break;
                default:
                    (0, _assert.assert)(false, "Unknown image data type");
            }
        });
        if (dataType === "compressed") this._trackAllocatedMemory(compressedTextureSize, "Texture");
        else if (data && data.byteLength) this._trackAllocatedMemory(data.byteLength, "Texture");
        else {
            const channels = (0, _textureFormats.DATA_FORMAT_CHANNELS)[this.dataFormat] || 4;
            const channelSize = (0, _textureFormats.TYPE_SIZES)[this.type] || 1;
            this._trackAllocatedMemory(this.width * this.height * channels * channelSize, "Texture");
        }
        this.loaded = true;
        return this;
    }
    setSubImageData(_ref2) {
        let { target =this.target , pixels =null , data =null , x =0 , y =0 , width =this.width , height =this.height , level =0 , format =this.format , type =this.type , dataFormat =this.dataFormat , compressed =false , offset =0 , border =this.border , parameters ={}  } = _ref2;
        ({ type , dataFormat , compressed , width , height  } = this._deduceParameters({
            format,
            type,
            dataFormat,
            compressed,
            data,
            width,
            height
        }));
        (0, _assert.assert)(this.depth === 0, "texSubImage not supported for 3D textures");
        if (!data) data = pixels;
        if (data && data.data) {
            const ndarray = data;
            data = ndarray.data;
            width = ndarray.shape[0];
            height = ndarray.shape[1];
        }
        if (data instanceof (0, _bufferDefault.default)) data = data.handle;
        this.gl.bindTexture(this.target, this.handle);
        (0, _gltools.withParameters)(this.gl, parameters, ()=>{
            if (compressed) this.gl.compressedTexSubImage2D(target, level, x, y, width, height, format, data);
            else if (data === null) this.gl.texSubImage2D(target, level, x, y, width, height, dataFormat, type, null);
            else if (ArrayBuffer.isView(data)) this.gl.texSubImage2D(target, level, x, y, width, height, dataFormat, type, data, offset);
            else if (data instanceof WebGLBuffer) {
                const gl2 = (0, _gltools.assertWebGL2Context)(this.gl);
                gl2.bindBuffer(35052, data);
                gl2.texSubImage2D(target, level, x, y, width, height, dataFormat, type, offset);
                gl2.bindBuffer(35052, null);
            } else if ((0, _gltools.isWebGL2)(this.gl)) {
                const gl21 = (0, _gltools.assertWebGL2Context)(this.gl);
                gl21.texSubImage2D(target, level, x, y, width, height, dataFormat, type, data);
            } else this.gl.texSubImage2D(target, level, x, y, dataFormat, type, data);
        });
        this.gl.bindTexture(this.target, null);
    }
    copyFramebuffer() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _gltools.log).error("Texture.copyFramebuffer({...}) is no logner supported, use copyToTexture(source, target, opts})")();
        return null;
    }
    getActiveUnit() {
        return this.gl.getParameter(34016) - 33984;
    }
    bind() {
        let textureUnit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.textureUnit;
        const { gl  } = this;
        if (textureUnit !== undefined) {
            this.textureUnit = textureUnit;
            gl.activeTexture(33984 + textureUnit);
        }
        gl.bindTexture(this.target, this.handle);
        return textureUnit;
    }
    unbind() {
        let textureUnit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.textureUnit;
        const { gl  } = this;
        if (textureUnit !== undefined) {
            this.textureUnit = textureUnit;
            gl.activeTexture(33984 + textureUnit);
        }
        gl.bindTexture(this.target, null);
        return textureUnit;
    }
    _getDataType(_ref3) {
        let { data , compressed =false  } = _ref3;
        if (compressed) return {
            data,
            dataType: "compressed"
        };
        if (data === null) return {
            data,
            dataType: "null"
        };
        if (ArrayBuffer.isView(data)) return {
            data,
            dataType: "typed-array"
        };
        if (data instanceof (0, _bufferDefault.default)) return {
            data: data.handle,
            dataType: "buffer"
        };
        if (data instanceof WebGLBuffer) return {
            data,
            dataType: "buffer"
        };
        return {
            data,
            dataType: "browser-object"
        };
    }
    _deduceParameters(opts) {
        const { format , data  } = opts;
        let { width , height , dataFormat , type , compressed  } = opts;
        const textureFormat = (0, _textureFormats.TEXTURE_FORMATS)[format];
        dataFormat = dataFormat || textureFormat && textureFormat.dataFormat;
        type = type || textureFormat && textureFormat.types[0];
        compressed = compressed || textureFormat && textureFormat.compressed;
        ({ width , height  } = this._deduceImageSize(data, width, height));
        return {
            dataFormat,
            type,
            compressed,
            width,
            height,
            format,
            data
        };
    }
    _deduceImageSize(data, width, height) {
        let size;
        if (typeof ImageData !== "undefined" && data instanceof ImageData) size = {
            width: data.width,
            height: data.height
        };
        else if (typeof HTMLImageElement !== "undefined" && data instanceof HTMLImageElement) size = {
            width: data.naturalWidth,
            height: data.naturalHeight
        };
        else if (typeof HTMLCanvasElement !== "undefined" && data instanceof HTMLCanvasElement) size = {
            width: data.width,
            height: data.height
        };
        else if (typeof ImageBitmap !== "undefined" && data instanceof ImageBitmap) size = {
            width: data.width,
            height: data.height
        };
        else if (typeof HTMLVideoElement !== "undefined" && data instanceof HTMLVideoElement) size = {
            width: data.videoWidth,
            height: data.videoHeight
        };
        else if (!data) size = {
            width: width >= 0 ? width : 1,
            height: height >= 0 ? height : 1
        };
        else size = {
            width,
            height
        };
        (0, _assert.assert)(size, "Could not deduced texture size");
        (0, _assert.assert)(width === undefined || size.width === width, "Deduced texture width does not match supplied width");
        (0, _assert.assert)(height === undefined || size.height === height, "Deduced texture height does not match supplied height");
        return size;
    }
    _createHandle() {
        return this.gl.createTexture();
    }
    _deleteHandle() {
        this.gl.deleteTexture(this.handle);
        this._trackDeallocatedMemory("Texture");
    }
    _getParameter(pname) {
        switch(pname){
            case 4096:
                return this.width;
            case 4097:
                return this.height;
            default:
                this.gl.bindTexture(this.target, this.handle);
                const value = this.gl.getTexParameter(this.target, pname);
                this.gl.bindTexture(this.target, null);
                return value;
        }
    }
    _setParameter(pname, param) {
        this.gl.bindTexture(this.target, this.handle);
        param = this._getNPOTParam(pname, param);
        switch(pname){
            case 33082:
            case 33083:
                this.gl.texParameterf(this.handle, pname, param);
                break;
            case 4096:
            case 4097:
                (0, _assert.assert)(false);
                break;
            default:
                this.gl.texParameteri(this.target, pname, param);
                break;
        }
        this.gl.bindTexture(this.target, null);
        return this;
    }
    _isNPOT() {
        if ((0, _gltools.isWebGL2)(this.gl)) return false;
        if (!this.width || !this.height) return false;
        return !(0, _utils.isPowerOfTwo)(this.width) || !(0, _utils.isPowerOfTwo)(this.height);
    }
    _updateForNPOT(parameters) {
        if (parameters[this.gl.TEXTURE_MIN_FILTER] === undefined) parameters[this.gl.TEXTURE_MIN_FILTER] = this.gl.LINEAR;
        if (parameters[this.gl.TEXTURE_WRAP_S] === undefined) parameters[this.gl.TEXTURE_WRAP_S] = this.gl.CLAMP_TO_EDGE;
        if (parameters[this.gl.TEXTURE_WRAP_T] === undefined) parameters[this.gl.TEXTURE_WRAP_T] = this.gl.CLAMP_TO_EDGE;
    }
    _getNPOTParam(pname, param) {
        if (this._isNPOT()) switch(pname){
            case 10241:
                if (NPOT_MIN_FILTERS.indexOf(param) === -1) param = 9729;
                break;
            case 10242:
            case 10243:
                if (param !== 33071) param = 33071;
                break;
            default:
                break;
        }
        return param;
    }
}
exports.default = Texture;

},{"@luma.gl/gltools":"aIkwg","./resource":"10MWq","./buffer":"4AGCy","./texture-formats":"ieSKa","../utils/assert":"hxAMc","../utils/utils":"adQQr","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"10MWq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _init = require("../init");
var _constantsToKeys = require("../webgl-utils/constants-to-keys");
var _assert = require("../utils/assert");
var _utils = require("../utils/utils");
var _stubMethods = require("../utils/stub-methods");
const ERR_RESOURCE_METHOD_UNDEFINED = "Resource subclass must define virtual methods";
class Resource {
    get [Symbol.toStringTag]() {
        return "Resource";
    }
    constructor(gl){
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        (0, _gltools.assertWebGLContext)(gl);
        const { id , userData ={}  } = opts;
        this.gl = gl;
        this.gl2 = gl;
        this.id = id || (0, _utils.uid)(this[Symbol.toStringTag]);
        this.userData = userData;
        this._bound = false;
        this._handle = opts.handle;
        if (this._handle === undefined) this._handle = this._createHandle();
        this.byteLength = 0;
        this._initStats();
        this._addStats();
    }
    toString() {
        return "".concat(this[Symbol.toStringTag] || this.constructor.name, "(").concat(this.id, ")");
    }
    get handle() {
        return this._handle;
    }
    delete() {
        let { deleteChildren =false  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const children = this._handle && this._deleteHandle(this._handle);
        if (this._handle) this._removeStats();
        this._handle = null;
        if (children && deleteChildren) children.filter(Boolean).forEach((child)=>child.delete());
        return this;
    }
    bind() {
        let funcOrHandle = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.handle;
        if (typeof funcOrHandle !== "function") {
            this._bindHandle(funcOrHandle);
            return this;
        }
        let value;
        if (!this._bound) {
            this._bindHandle(this.handle);
            this._bound = true;
            value = funcOrHandle();
            this._bound = false;
            this._bindHandle(null);
        } else value = funcOrHandle();
        return value;
    }
    unbind() {
        this.bind(null);
    }
    getParameter(pname) {
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        pname = (0, _constantsToKeys.getKeyValue)(this.gl, pname);
        (0, _assert.assert)(pname);
        const parameters = this.constructor.PARAMETERS || {};
        const parameter = parameters[pname];
        if (parameter) {
            const isWebgl2 = (0, _gltools.isWebGL2)(this.gl);
            const parameterAvailable = (!("webgl2" in parameter) || isWebgl2) && (!("extension" in parameter) || this.gl.getExtension(parameter.extension));
            if (!parameterAvailable) {
                const webgl1Default = parameter.webgl1;
                const webgl2Default = "webgl2" in parameter ? parameter.webgl2 : parameter.webgl1;
                const defaultValue = isWebgl2 ? webgl2Default : webgl1Default;
                return defaultValue;
            }
        }
        return this._getParameter(pname, opts);
    }
    getParameters() {
        let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { parameters , keys  } = options;
        const PARAMETERS = this.constructor.PARAMETERS || {};
        const isWebgl2 = (0, _gltools.isWebGL2)(this.gl);
        const values = {};
        const parameterKeys = parameters || Object.keys(PARAMETERS);
        for (const pname of parameterKeys){
            const parameter = PARAMETERS[pname];
            const parameterAvailable = parameter && (!("webgl2" in parameter) || isWebgl2) && (!("extension" in parameter) || this.gl.getExtension(parameter.extension));
            if (parameterAvailable) {
                const key = keys ? (0, _constantsToKeys.getKey)(this.gl, pname) : pname;
                values[key] = this.getParameter(pname, options);
                if (keys && parameter.type === "GLenum") values[key] = (0, _constantsToKeys.getKey)(this.gl, values[key]);
            }
        }
        return values;
    }
    setParameter(pname, value) {
        pname = (0, _constantsToKeys.getKeyValue)(this.gl, pname);
        (0, _assert.assert)(pname);
        const parameters = this.constructor.PARAMETERS || {};
        const parameter = parameters[pname];
        if (parameter) {
            const isWebgl2 = (0, _gltools.isWebGL2)(this.gl);
            const parameterAvailable = (!("webgl2" in parameter) || isWebgl2) && (!("extension" in parameter) || this.gl.getExtension(parameter.extension));
            if (!parameterAvailable) throw new Error("Parameter not available on this platform");
            if (parameter.type === "GLenum") value = (0, _constantsToKeys.getKeyValue)(value);
        }
        this._setParameter(pname, value);
        return this;
    }
    setParameters(parameters) {
        for(const pname in parameters)this.setParameter(pname, parameters[pname]);
        return this;
    }
    stubRemovedMethods(className, version, methodNames) {
        return (0, _stubMethods.stubRemovedMethods)(this, className, version, methodNames);
    }
    initialize(opts) {}
    _createHandle() {
        throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _deleteHandle() {
        throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _bindHandle(handle) {
        throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _getOptsFromHandle() {
        throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _getParameter(pname, opts) {
        throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _setParameter(pname, value) {
        throw new Error(ERR_RESOURCE_METHOD_UNDEFINED);
    }
    _context() {
        this.gl.luma = this.gl.luma || {};
        return this.gl.luma;
    }
    _initStats() {
        this.gl.stats = this.gl.stats || new (0, _init.StatsManager)();
    }
    _addStats() {
        const name = this[Symbol.toStringTag];
        const stats = (0, _init.lumaStats).get("Resource Counts");
        stats.get("Resources Created").incrementCount();
        stats.get("".concat(name, "s Created")).incrementCount();
        stats.get("".concat(name, "s Active")).incrementCount();
    }
    _removeStats() {
        const name = this[Symbol.toStringTag];
        const stats = (0, _init.lumaStats).get("Resource Counts");
        stats.get("".concat(name, "s Active")).decrementCount();
    }
    _trackAllocatedMemory(bytes) {
        let name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this[Symbol.toStringTag];
        this._doTrackAllocatedMemory(bytes, name);
        this._doTrackAllocatedMemory(bytes, name, this.gl.stats.get("Memory Usage"));
    }
    _doTrackAllocatedMemory(bytes) {
        let name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this[Symbol.toStringTag];
        let stats = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : (0, _init.lumaStats).get("Memory Usage");
        stats.get("GPU Memory").addCount(bytes);
        stats.get("".concat(name, " Memory")).addCount(bytes);
        this.byteLength = bytes;
    }
    _trackDeallocatedMemory() {
        let name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this[Symbol.toStringTag];
        this._doTrackDeallocatedMemory(name);
        this._doTrackDeallocatedMemory(name, this.gl.stats.get("Memory Usage"));
    }
    _doTrackDeallocatedMemory() {
        let name = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this[Symbol.toStringTag];
        let stats = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : (0, _init.lumaStats).get("Memory Usage");
        stats.get("GPU Memory").subtractCount(this.byteLength);
        stats.get("".concat(name, " Memory")).subtractCount(this.byteLength);
        this.byteLength = 0;
    }
}
exports.default = Resource;

},{"@luma.gl/gltools":"aIkwg","../init":"7XbRT","../webgl-utils/constants-to-keys":"9tmTY","../utils/assert":"hxAMc","../utils/utils":"adQQr","../utils/stub-methods":"cgiTF","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9tmTY":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getKeyValue", ()=>getKeyValue);
parcelHelpers.export(exports, "getKey", ()=>getKey);
parcelHelpers.export(exports, "getKeyType", ()=>getKeyType);
var _assert = require("../utils/assert");
function getKeyValue(gl, name) {
    if (typeof name !== "string") return name;
    const number = Number(name);
    if (!isNaN(number)) return number;
    name = name.replace(/^.*\./, "");
    const value = gl[name];
    (0, _assert.assert)(value !== undefined, "Accessing undefined constant GL.".concat(name));
    return value;
}
function getKey(gl, value) {
    value = Number(value);
    for(const key in gl){
        if (gl[key] === value) return "GL.".concat(key);
    }
    return String(value);
}
function getKeyType(gl, value) {
    (0, _assert.assert)(value !== undefined, "undefined key");
    value = Number(value);
    for(const key in gl){
        if (gl[key] === value) return "GL.".concat(key);
    }
    return String(value);
}

},{"../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"hxAMc":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assert", ()=>assert);
function assert(condition, message) {
    if (!condition) throw new Error(message || "luma.gl: assertion failed.");
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"adQQr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "uid", ()=>uid);
parcelHelpers.export(exports, "isPowerOfTwo", ()=>isPowerOfTwo);
parcelHelpers.export(exports, "isObjectEmpty", ()=>isObjectEmpty);
var _assert = require("./assert");
const uidCounters = {};
function uid() {
    let id = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "id";
    uidCounters[id] = uidCounters[id] || 1;
    const count = uidCounters[id]++;
    return "".concat(id, "-").concat(count);
}
function isPowerOfTwo(n) {
    (0, _assert.assert)(typeof n === "number", "Input must be a number");
    return n && (n & n - 1) === 0;
}
function isObjectEmpty(obj) {
    let isEmpty = true;
    for(const key in obj){
        isEmpty = false;
        break;
    }
    return isEmpty;
}

},{"./assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cgiTF":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "stubRemovedMethods", ()=>stubRemovedMethods);
var _gltools = require("@luma.gl/gltools");
function stubRemovedMethods(instance, className, version, methodNames) {
    const upgradeMessage = "See luma.gl ".concat(version, " Upgrade Guide at https://luma.gl/docs/upgrade-guide");
    const prototype = Object.getPrototypeOf(instance);
    methodNames.forEach((methodName)=>{
        if (prototype.methodName) return;
        prototype[methodName] = ()=>{
            (0, _gltools.log).removed("Calling removed method ".concat(className, ".").concat(methodName, ": "), upgradeMessage)();
            throw new Error(methodName);
        };
    });
}

},{"@luma.gl/gltools":"aIkwg","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4AGCy":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
var _accessor = require("./accessor");
var _accessorDefault = parcelHelpers.interopDefault(_accessor);
var _typedArrayUtils = require("../webgl-utils/typed-array-utils");
var _gltools = require("@luma.gl/gltools");
var _assert = require("../utils/assert");
var _checkProps = require("../utils/check-props");
const DEBUG_DATA_LENGTH = 10;
const DEPRECATED_PROPS = {
    offset: "accessor.offset",
    stride: "accessor.stride",
    type: "accessor.type",
    size: "accessor.size",
    divisor: "accessor.divisor",
    normalized: "accessor.normalized",
    integer: "accessor.integer",
    instanced: "accessor.divisor",
    isInstanced: "accessor.divisor"
};
const PROP_CHECKS_INITIALIZE = {
    removedProps: {},
    replacedProps: {
        bytes: "byteLength"
    },
    deprecatedProps: DEPRECATED_PROPS
};
const PROP_CHECKS_SET_PROPS = {
    removedProps: DEPRECATED_PROPS
};
class Buffer extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "Buffer";
    }
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        super(gl, props);
        this.stubRemovedMethods("Buffer", "v6.0", [
            "layout",
            "setLayout",
            "getIndexedParameter"
        ]);
        this.target = props.target || (this.gl.webgl2 ? 36662 : 34962);
        this.initialize(props);
        Object.seal(this);
    }
    getElementCount() {
        let accessor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.accessor;
        return Math.round(this.byteLength / (0, _accessorDefault.default).getBytesPerElement(accessor));
    }
    getVertexCount() {
        let accessor = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.accessor;
        return Math.round(this.byteLength / (0, _accessorDefault.default).getBytesPerVertex(accessor));
    }
    initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if (ArrayBuffer.isView(props)) props = {
            data: props
        };
        if (Number.isFinite(props)) props = {
            byteLength: props
        };
        props = (0, _checkProps.checkProps)("Buffer", props, PROP_CHECKS_INITIALIZE);
        this.usage = props.usage || 35044;
        this.debugData = null;
        this.setAccessor(Object.assign({}, props, props.accessor));
        if (props.data) this._setData(props.data, props.offset, props.byteLength);
        else this._setByteLength(props.byteLength || 0);
        return this;
    }
    setProps(props) {
        props = (0, _checkProps.checkProps)("Buffer", props, PROP_CHECKS_SET_PROPS);
        if ("accessor" in props) this.setAccessor(props.accessor);
        return this;
    }
    setAccessor(accessor) {
        accessor = Object.assign({}, accessor);
        delete accessor.buffer;
        this.accessor = new (0, _accessorDefault.default)(accessor);
        return this;
    }
    reallocate(byteLength) {
        if (byteLength > this.byteLength) {
            this._setByteLength(byteLength);
            return true;
        }
        this.bytesUsed = byteLength;
        return false;
    }
    setData(props) {
        return this.initialize(props);
    }
    subData(props) {
        if (ArrayBuffer.isView(props)) props = {
            data: props
        };
        const { data , offset =0 , srcOffset =0  } = props;
        const byteLength = props.byteLength || props.length;
        (0, _assert.assert)(data);
        const target = this.gl.webgl2 ? 36663 : this.target;
        this.gl.bindBuffer(target, this.handle);
        if (srcOffset !== 0 || byteLength !== undefined) {
            (0, _gltools.assertWebGL2Context)(this.gl);
            this.gl.bufferSubData(this.target, offset, data, srcOffset, byteLength);
        } else this.gl.bufferSubData(target, offset, data);
        this.gl.bindBuffer(target, null);
        this.debugData = null;
        this._inferType(data);
        return this;
    }
    copyData(_ref) {
        let { sourceBuffer , readOffset =0 , writeOffset =0 , size  } = _ref;
        const { gl  } = this;
        (0, _gltools.assertWebGL2Context)(gl);
        gl.bindBuffer(36662, sourceBuffer.handle);
        gl.bindBuffer(36663, this.handle);
        gl.copyBufferSubData(36662, 36663, readOffset, writeOffset, size);
        gl.bindBuffer(36662, null);
        gl.bindBuffer(36663, null);
        this.debugData = null;
        return this;
    }
    getData() {
        let { dstData =null , srcByteOffset =0 , dstOffset =0 , length =0  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _gltools.assertWebGL2Context)(this.gl);
        const ArrayType = (0, _typedArrayUtils.getTypedArrayFromGLType)(this.accessor.type || 5126, {
            clamped: false
        });
        const sourceAvailableElementCount = this._getAvailableElementCount(srcByteOffset);
        const dstElementOffset = dstOffset;
        let dstAvailableElementCount;
        let dstElementCount;
        if (dstData) {
            dstElementCount = dstData.length;
            dstAvailableElementCount = dstElementCount - dstElementOffset;
        } else {
            dstAvailableElementCount = Math.min(sourceAvailableElementCount, length || sourceAvailableElementCount);
            dstElementCount = dstElementOffset + dstAvailableElementCount;
        }
        const copyElementCount = Math.min(sourceAvailableElementCount, dstAvailableElementCount);
        length = length || copyElementCount;
        (0, _assert.assert)(length <= copyElementCount);
        dstData = dstData || new ArrayType(dstElementCount);
        this.gl.bindBuffer(36662, this.handle);
        this.gl.getBufferSubData(36662, srcByteOffset, dstData, dstOffset, length);
        this.gl.bindBuffer(36662, null);
        return dstData;
    }
    bind() {
        let { target =this.target , index =this.accessor && this.accessor.index , offset =0 , size  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if (target === 35345 || target === 35982) {
            if (size !== undefined) this.gl.bindBufferRange(target, index, this.handle, offset, size);
            else {
                (0, _assert.assert)(offset === 0);
                this.gl.bindBufferBase(target, index, this.handle);
            }
        } else this.gl.bindBuffer(target, this.handle);
        return this;
    }
    unbind() {
        let { target =this.target , index =this.accessor && this.accessor.index  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const isIndexedBuffer = target === 35345 || target === 35982;
        if (isIndexedBuffer) this.gl.bindBufferBase(target, index, null);
        else this.gl.bindBuffer(target, null);
        return this;
    }
    getDebugData() {
        if (!this.debugData) {
            this.debugData = this.getData({
                length: Math.min(DEBUG_DATA_LENGTH, this.byteLength)
            });
            return {
                data: this.debugData,
                changed: true
            };
        }
        return {
            data: this.debugData,
            changed: false
        };
    }
    invalidateDebugData() {
        this.debugData = null;
    }
    _setData(data) {
        let offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
        let byteLength = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : data.byteLength + offset;
        (0, _assert.assert)(ArrayBuffer.isView(data));
        this._trackDeallocatedMemory();
        const target = this._getTarget();
        this.gl.bindBuffer(target, this.handle);
        this.gl.bufferData(target, byteLength, this.usage);
        this.gl.bufferSubData(target, offset, data);
        this.gl.bindBuffer(target, null);
        this.debugData = data.slice(0, DEBUG_DATA_LENGTH);
        this.bytesUsed = byteLength;
        this._trackAllocatedMemory(byteLength);
        const type = (0, _typedArrayUtils.getGLTypeFromTypedArray)(data);
        (0, _assert.assert)(type);
        this.setAccessor(new (0, _accessorDefault.default)(this.accessor, {
            type
        }));
        return this;
    }
    _setByteLength(byteLength) {
        let usage = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.usage;
        (0, _assert.assert)(byteLength >= 0);
        this._trackDeallocatedMemory();
        let data = byteLength;
        if (byteLength === 0) data = new Float32Array(0);
        const target = this._getTarget();
        this.gl.bindBuffer(target, this.handle);
        this.gl.bufferData(target, data, usage);
        this.gl.bindBuffer(target, null);
        this.usage = usage;
        this.debugData = null;
        this.bytesUsed = byteLength;
        this._trackAllocatedMemory(byteLength);
        return this;
    }
    _getTarget() {
        return this.gl.webgl2 ? 36663 : this.target;
    }
    _getAvailableElementCount(srcByteOffset) {
        const ArrayType = (0, _typedArrayUtils.getTypedArrayFromGLType)(this.accessor.type || 5126, {
            clamped: false
        });
        const sourceElementOffset = srcByteOffset / ArrayType.BYTES_PER_ELEMENT;
        return this.getElementCount() - sourceElementOffset;
    }
    _inferType(data) {
        if (!this.accessor.type) this.setAccessor(new (0, _accessorDefault.default)(this.accessor, {
            type: (0, _typedArrayUtils.getGLTypeFromTypedArray)(data)
        }));
    }
    _createHandle() {
        return this.gl.createBuffer();
    }
    _deleteHandle() {
        this.gl.deleteBuffer(this.handle);
        this._trackDeallocatedMemory();
    }
    _getParameter(pname) {
        this.gl.bindBuffer(this.target, this.handle);
        const value = this.gl.getBufferParameter(this.target, pname);
        this.gl.bindBuffer(this.target, null);
        return value;
    }
    get type() {
        (0, _gltools.log).deprecated("Buffer.type", "Buffer.accessor.type")();
        return this.accessor.type;
    }
    get bytes() {
        (0, _gltools.log).deprecated("Buffer.bytes", "Buffer.byteLength")();
        return this.byteLength;
    }
    setByteLength(byteLength) {
        (0, _gltools.log).deprecated("setByteLength", "reallocate")();
        return this.reallocate(byteLength);
    }
    updateAccessor(opts) {
        (0, _gltools.log).deprecated("updateAccessor(...)", "setAccessor(new Accessor(buffer.accessor, ...)")();
        this.accessor = new (0, _accessorDefault.default)(this.accessor, opts);
        return this;
    }
}
exports.default = Buffer;

},{"./resource":"10MWq","./accessor":"9zq2J","../webgl-utils/typed-array-utils":"cMpZm","@luma.gl/gltools":"aIkwg","../utils/assert":"hxAMc","../utils/check-props":"3YoVz","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9zq2J":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "DEFAULT_ACCESSOR_VALUES", ()=>DEFAULT_ACCESSOR_VALUES);
var _typedArrayUtils = require("../webgl-utils/typed-array-utils");
var _assert = require("../utils/assert");
var _checkProps = require("../utils/check-props");
const DEFAULT_ACCESSOR_VALUES = {
    offset: 0,
    stride: 0,
    type: 5126,
    size: 1,
    divisor: 0,
    normalized: false,
    integer: false
};
const PROP_CHECKS = {
    deprecatedProps: {
        instanced: "divisor",
        isInstanced: "divisor"
    }
};
class Accessor {
    static getBytesPerElement(accessor) {
        const ArrayType = (0, _typedArrayUtils.getTypedArrayFromGLType)(accessor.type || 5126);
        return ArrayType.BYTES_PER_ELEMENT;
    }
    static getBytesPerVertex(accessor) {
        (0, _assert.assert)(accessor.size);
        const ArrayType = (0, _typedArrayUtils.getTypedArrayFromGLType)(accessor.type || 5126);
        return ArrayType.BYTES_PER_ELEMENT * accessor.size;
    }
    static resolve() {
        for(var _len = arguments.length, accessors = new Array(_len), _key = 0; _key < _len; _key++)accessors[_key] = arguments[_key];
        return new Accessor(...[
            DEFAULT_ACCESSOR_VALUES,
            ...accessors
        ]);
    }
    constructor(){
        for(var _len2 = arguments.length, accessors = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++)accessors[_key2] = arguments[_key2];
        accessors.forEach((accessor)=>this._assign(accessor));
        Object.freeze(this);
    }
    toString() {
        return JSON.stringify(this);
    }
    get BYTES_PER_ELEMENT() {
        return Accessor.getBytesPerElement(this);
    }
    get BYTES_PER_VERTEX() {
        return Accessor.getBytesPerVertex(this);
    }
    _assign() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        props = (0, _checkProps.checkProps)("Accessor", props, PROP_CHECKS);
        if (props.type !== undefined) {
            this.type = props.type;
            if (props.type === 5124 || props.type === 5125) this.integer = true;
        }
        if (props.size !== undefined) this.size = props.size;
        if (props.offset !== undefined) this.offset = props.offset;
        if (props.stride !== undefined) this.stride = props.stride;
        if (props.normalized !== undefined) this.normalized = props.normalized;
        if (props.integer !== undefined) this.integer = props.integer;
        if (props.divisor !== undefined) this.divisor = props.divisor;
        if (props.buffer !== undefined) this.buffer = props.buffer;
        if (props.index !== undefined) {
            if (typeof props.index === "boolean") this.index = props.index ? 1 : 0;
            else this.index = props.index;
        }
        if (props.instanced !== undefined) this.divisor = props.instanced ? 1 : 0;
        if (props.isInstanced !== undefined) this.divisor = props.isInstanced ? 1 : 0;
        return this;
    }
}
exports.default = Accessor;

},{"../webgl-utils/typed-array-utils":"cMpZm","../utils/assert":"hxAMc","../utils/check-props":"3YoVz","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cMpZm":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getGLTypeFromTypedArray", ()=>getGLTypeFromTypedArray);
parcelHelpers.export(exports, "getTypedArrayFromGLType", ()=>getTypedArrayFromGLType);
parcelHelpers.export(exports, "flipRows", ()=>flipRows);
parcelHelpers.export(exports, "scalePixels", ()=>scalePixels);
const ERR_TYPE_DEDUCTION = "Failed to deduce GL constant from typed array";
function getGLTypeFromTypedArray(arrayOrType) {
    const type = ArrayBuffer.isView(arrayOrType) ? arrayOrType.constructor : arrayOrType;
    switch(type){
        case Float32Array:
            return 5126;
        case Uint16Array:
            return 5123;
        case Uint32Array:
            return 5125;
        case Uint8Array:
            return 5121;
        case Uint8ClampedArray:
            return 5121;
        case Int8Array:
            return 5120;
        case Int16Array:
            return 5122;
        case Int32Array:
            return 5124;
        default:
            throw new Error(ERR_TYPE_DEDUCTION);
    }
}
function getTypedArrayFromGLType(glType) {
    let { clamped =true  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    switch(glType){
        case 5126:
            return Float32Array;
        case 5123:
        case 33635:
        case 32819:
        case 32820:
            return Uint16Array;
        case 5125:
            return Uint32Array;
        case 5121:
            return clamped ? Uint8ClampedArray : Uint8Array;
        case 5120:
            return Int8Array;
        case 5122:
            return Int16Array;
        case 5124:
            return Int32Array;
        default:
            throw new Error("Failed to deduce typed array type from GL constant");
    }
}
function flipRows(_ref) {
    let { data , width , height , bytesPerPixel =4 , temp  } = _ref;
    const bytesPerRow = width * bytesPerPixel;
    temp = temp || new Uint8Array(bytesPerRow);
    for(let y = 0; y < height / 2; ++y){
        const topOffset = y * bytesPerRow;
        const bottomOffset = (height - y - 1) * bytesPerRow;
        temp.set(data.subarray(topOffset, topOffset + bytesPerRow));
        data.copyWithin(topOffset, bottomOffset, bottomOffset + bytesPerRow);
        data.set(temp, bottomOffset);
    }
}
function scalePixels(_ref2) {
    let { data , width , height  } = _ref2;
    const newWidth = Math.round(width / 2);
    const newHeight = Math.round(height / 2);
    const newData = new Uint8Array(newWidth * newHeight * 4);
    for(let y = 0; y < newHeight; y++){
        for(let x = 0; x < newWidth; x++)for(let c = 0; c < 4; c++)newData[(y * newWidth + x) * 4 + c] = data[(y * 2 * width + x * 2) * 4 + c];
    }
    return {
        data: newData,
        width: newWidth,
        height: newHeight
    };
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3YoVz":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "checkProps", ()=>checkProps);
var _gltools = require("@luma.gl/gltools");
function checkProps(className, props, propChecks) {
    const { removedProps ={} , deprecatedProps ={} , replacedProps ={}  } = propChecks;
    for(const propName in removedProps)if (propName in props) {
        const replacementProp = removedProps[propName];
        const replacement = replacementProp ? "".concat(className, ".").concat(removedProps[propName]) : "N/A";
        (0, _gltools.log).removed("".concat(className, ".").concat(propName), replacement)();
    }
    for(const propName1 in deprecatedProps)if (propName1 in props) {
        const replacementProp1 = deprecatedProps[propName1];
        (0, _gltools.log).deprecated("".concat(className, ".").concat(propName1), "".concat(className, ".").concat(replacementProp1))();
    }
    let newProps = null;
    for(const propName2 in replacedProps)if (propName2 in props) {
        const replacementProp2 = replacedProps[propName2];
        (0, _gltools.log).deprecated("".concat(className, ".").concat(propName2), "".concat(className, ".").concat(replacementProp2))();
        newProps = newProps || Object.assign({}, props);
        newProps[replacementProp2] = props[propName2];
        delete newProps[propName2];
    }
    return newProps || props;
}

},{"@luma.gl/gltools":"aIkwg","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ieSKa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "TEXTURE_FORMATS", ()=>TEXTURE_FORMATS);
parcelHelpers.export(exports, "DATA_FORMAT_CHANNELS", ()=>DATA_FORMAT_CHANNELS);
parcelHelpers.export(exports, "TYPE_SIZES", ()=>TYPE_SIZES);
parcelHelpers.export(exports, "isFormatSupported", ()=>isFormatSupported);
parcelHelpers.export(exports, "isLinearFilteringSupported", ()=>isLinearFilteringSupported);
var _gltools = require("@luma.gl/gltools");
const TEXTURE_FORMATS = {
    [6407]: {
        dataFormat: 6407,
        types: [
            5121,
            33635
        ]
    },
    [6408]: {
        dataFormat: 6408,
        types: [
            5121,
            32819,
            32820
        ]
    },
    [6406]: {
        dataFormat: 6406,
        types: [
            5121
        ]
    },
    [6409]: {
        dataFormat: 6409,
        types: [
            5121
        ]
    },
    [6410]: {
        dataFormat: 6410,
        types: [
            5121
        ]
    },
    [33326]: {
        dataFormat: 6403,
        types: [
            5126
        ],
        gl2: true
    },
    [33328]: {
        dataFormat: 33319,
        types: [
            5126
        ],
        gl2: true
    },
    [34837]: {
        dataFormat: 6407,
        types: [
            5126
        ],
        gl2: true
    },
    [34836]: {
        dataFormat: 6408,
        types: [
            5126
        ],
        gl2: true
    }
};
const DATA_FORMAT_CHANNELS = {
    [6403]: 1,
    [36244]: 1,
    [33319]: 2,
    [33320]: 2,
    [6407]: 3,
    [36248]: 3,
    [6408]: 4,
    [36249]: 4,
    [6402]: 1,
    [34041]: 1,
    [6406]: 1,
    [6409]: 1,
    [6410]: 2
};
const TYPE_SIZES = {
    [5126]: 4,
    [5125]: 4,
    [5124]: 4,
    [5123]: 2,
    [5122]: 2,
    [5131]: 2,
    [5120]: 1,
    [5121]: 1
};
function isFormatSupported(gl, format) {
    const info = TEXTURE_FORMATS[format];
    if (!info) return false;
    if (info.gl1 === undefined && info.gl2 === undefined) return true;
    const value = (0, _gltools.isWebGL2)(gl) ? info.gl2 || info.gl1 : info.gl1;
    return typeof value === "string" ? gl.getExtension(value) : value;
}
function isLinearFilteringSupported(gl, format) {
    const info = TEXTURE_FORMATS[format];
    switch(info && info.types[0]){
        case 5126:
            return gl.getExtension("OES_texture_float_linear");
        case 5131:
            return gl.getExtension("OES_texture_half_float_linear");
        default:
            return true;
    }
}

},{"@luma.gl/gltools":"aIkwg","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6JotM":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "setPathPrefix", ()=>setPathPrefix);
parcelHelpers.export(exports, "loadFile", ()=>loadFile);
parcelHelpers.export(exports, "loadImage", ()=>loadImage);
var _assert = require("../utils/assert");
let pathPrefix = "";
function setPathPrefix(prefix) {
    pathPrefix = prefix;
}
function loadFile(url) {
    let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _assert.assert)(typeof url === "string");
    url = pathPrefix + url;
    const dataType = options.dataType || "text";
    return fetch(url, options).then((res)=>res[dataType]());
}
function loadImage(url, opts) {
    (0, _assert.assert)(typeof url === "string");
    url = pathPrefix + url;
    return new Promise((resolve, reject)=>{
        try {
            const image = new Image();
            image.onload = ()=>resolve(image);
            image.onerror = ()=>reject(new Error("Could not load image ".concat(url, ".")));
            image.crossOrigin = opts && opts.crossOrigin || "anonymous";
            image.src = url;
        } catch (error) {
            reject(error);
        }
    });
}

},{"../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"e9dKT":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _texture = require("./texture");
var _textureDefault = parcelHelpers.interopDefault(_texture);
const FACES = [
    34069,
    34070,
    34071,
    34072,
    34073,
    34074
];
class TextureCube extends (0, _textureDefault.default) {
    get [Symbol.toStringTag]() {
        return "TextureCube";
    }
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        (0, _gltools.assertWebGLContext)(gl);
        super(gl, Object.assign({}, props, {
            target: 34067
        }));
        this.initialize(props);
        Object.seal(this);
    }
    initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { mipmaps =true , parameters ={}  } = props;
        this.opts = props;
        this.setCubeMapImageData(props).then(()=>{
            this.loaded = true;
            if (mipmaps) this.generateMipmap(props);
            this.setParameters(parameters);
        });
        return this;
    }
    subImage(_ref) {
        let { face , data , x =0 , y =0 , mipmapLevel =0  } = _ref;
        return this._subImage({
            target: face,
            data,
            x,
            y,
            mipmapLevel
        });
    }
    async setCubeMapImageData(_ref2) {
        let { width , height , pixels , data , border =0 , format =6408 , type =5121  } = _ref2;
        const { gl  } = this;
        const imageDataMap = pixels || data;
        const resolvedFaces = await Promise.all(FACES.map((face)=>{
            const facePixels = imageDataMap[face];
            return Promise.all(Array.isArray(facePixels) ? facePixels : [
                facePixels
            ]);
        }));
        this.bind();
        FACES.forEach((face, index)=>{
            if (resolvedFaces[index].length > 1 && this.opts.mipmaps !== false) (0, _gltools.log).warn("".concat(this.id, " has mipmap and multiple LODs."))();
            resolvedFaces[index].forEach((image, lodLevel)=>{
                if (width && height) gl.texImage2D(face, lodLevel, format, width, height, border, format, type, image);
                else gl.texImage2D(face, lodLevel, format, format, type, image);
            });
        });
        this.unbind();
    }
    setImageDataForFace(options) {
        const { face , width , height , pixels , data , border =0 , format =6408 , type =5121  } = options;
        const { gl  } = this;
        const imageData = pixels || data;
        this.bind();
        if (imageData instanceof Promise) imageData.then((resolvedImageData)=>this.setImageDataForFace(Object.assign({}, options, {
                face,
                data: resolvedImageData,
                pixels: resolvedImageData
            })));
        else if (this.width || this.height) gl.texImage2D(face, 0, format, width, height, border, format, type, imageData);
        else gl.texImage2D(face, 0, format, format, type, imageData);
        return this;
    }
}
exports.default = TextureCube;
TextureCube.FACES = FACES;

},{"@luma.gl/gltools":"aIkwg","./texture":"14YT4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lL9iV":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _texture = require("./texture");
var _textureDefault = parcelHelpers.interopDefault(_texture);
var _textureFormats = require("./texture-formats");
var _buffer = require("./buffer");
var _bufferDefault = parcelHelpers.interopDefault(_buffer);
class Texture3D extends (0, _textureDefault.default) {
    get [Symbol.toStringTag]() {
        return "Texture3D";
    }
    static isSupported(gl) {
        return (0, _gltools.isWebGL2)(gl);
    }
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        (0, _gltools.assertWebGL2Context)(gl);
        props = Object.assign({
            depth: 1
        }, props, {
            target: 32879,
            unpackFlipY: false
        });
        super(gl, props);
        this.initialize(props);
        Object.seal(this);
    }
    setImageData(_ref) {
        let { level =0 , dataFormat =6408 , width , height , depth =1 , border =0 , format , type =5121 , offset =0 , data , parameters ={}  } = _ref;
        this._trackDeallocatedMemory("Texture");
        this.gl.bindTexture(this.target, this.handle);
        (0, _gltools.withParameters)(this.gl, parameters, ()=>{
            if (ArrayBuffer.isView(data)) this.gl.texImage3D(this.target, level, dataFormat, width, height, depth, border, format, type, data);
            if (data instanceof (0, _bufferDefault.default)) {
                this.gl.bindBuffer(35052, data.handle);
                this.gl.texImage3D(this.target, level, dataFormat, width, height, depth, border, format, type, offset);
            }
        });
        if (data && data.byteLength) this._trackAllocatedMemory(data.byteLength, "Texture");
        else {
            const channels = (0, _textureFormats.DATA_FORMAT_CHANNELS)[this.dataFormat] || 4;
            const channelSize = (0, _textureFormats.TYPE_SIZES)[this.type] || 1;
            this._trackAllocatedMemory(this.width * this.height * this.depth * channels * channelSize, "Texture");
        }
        this.loaded = true;
        return this;
    }
}
exports.default = Texture3D;

},{"@luma.gl/gltools":"aIkwg","./texture":"14YT4","./texture-formats":"ieSKa","./buffer":"4AGCy","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8XBFw":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "FRAMEBUFFER_ATTACHMENT_PARAMETERS", ()=>FRAMEBUFFER_ATTACHMENT_PARAMETERS);
var _gltools = require("@luma.gl/gltools");
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
var _texture2D = require("./texture-2d");
var _texture2DDefault = parcelHelpers.interopDefault(_texture2D);
var _renderbuffer = require("./renderbuffer");
var _renderbufferDefault = parcelHelpers.interopDefault(_renderbuffer);
var _clear = require("./clear");
var _copyAndBlitJs = require("./copy-and-blit.js");
var _features = require("../features");
var _constantsToKeys = require("../webgl-utils/constants-to-keys");
var _assert = require("../utils/assert");
const ERR_MULTIPLE_RENDERTARGETS = "Multiple render targets not supported";
class Framebuffer extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "Framebuffer";
    }
    static isSupported(gl) {
        let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        const { colorBufferFloat , colorBufferHalfFloat  } = options;
        let supported = true;
        if (colorBufferFloat) supported = Boolean(gl.getExtension("EXT_color_buffer_float") || gl.getExtension("WEBGL_color_buffer_float") || gl.getExtension("OES_texture_float"));
        if (colorBufferHalfFloat) supported = supported && Boolean(gl.getExtension("EXT_color_buffer_float") || gl.getExtension("EXT_color_buffer_half_float"));
        return supported;
    }
    static getDefaultFramebuffer(gl) {
        gl.luma = gl.luma || {};
        gl.luma.defaultFramebuffer = gl.luma.defaultFramebuffer || new Framebuffer(gl, {
            id: "default-framebuffer",
            handle: null,
            attachments: {}
        });
        return gl.luma.defaultFramebuffer;
    }
    get MAX_COLOR_ATTACHMENTS() {
        const gl2 = (0, _gltools.assertWebGL2Context)(this.gl);
        return gl2.getParameter(gl2.MAX_COLOR_ATTACHMENTS);
    }
    get MAX_DRAW_BUFFERS() {
        const gl2 = (0, _gltools.assertWebGL2Context)(this.gl);
        return gl2.getParameter(gl2.MAX_DRAW_BUFFERS);
    }
    constructor(gl){
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        super(gl, opts);
        this.width = null;
        this.height = null;
        this.attachments = {};
        this.readBuffer = 36064;
        this.drawBuffers = [
            36064
        ];
        this.ownResources = [];
        this.initialize(opts);
        Object.seal(this);
    }
    get color() {
        return this.attachments[36064] || null;
    }
    get texture() {
        return this.attachments[36064] || null;
    }
    get depth() {
        return this.attachments[36096] || this.attachments[33306] || null;
    }
    get stencil() {
        return this.attachments[36128] || this.attachments[33306] || null;
    }
    initialize(_ref) {
        let { width =1 , height =1 , attachments =null , color =true , depth =true , stencil =false , check =true , readBuffer , drawBuffers  } = _ref;
        (0, _assert.assert)(width >= 0 && height >= 0, "Width and height need to be integers");
        this.width = width;
        this.height = height;
        if (attachments) for(const attachment in attachments){
            const target = attachments[attachment];
            const object = Array.isArray(target) ? target[0] : target;
            object.resize({
                width,
                height
            });
        }
        else attachments = this._createDefaultAttachments(color, depth, stencil, width, height);
        this.update({
            clearAttachments: true,
            attachments,
            readBuffer,
            drawBuffers
        });
        if (attachments && check) this.checkStatus();
    }
    delete() {
        for (const resource of this.ownResources)resource.delete();
        super.delete();
        return this;
    }
    update(_ref2) {
        let { attachments ={} , readBuffer , drawBuffers , clearAttachments =false , resizeAttachments =true  } = _ref2;
        this.attach(attachments, {
            clearAttachments,
            resizeAttachments
        });
        const { gl  } = this;
        const prevHandle = gl.bindFramebuffer(36160, this.handle);
        if (readBuffer) this._setReadBuffer(readBuffer);
        if (drawBuffers) this._setDrawBuffers(drawBuffers);
        gl.bindFramebuffer(36160, prevHandle || null);
        return this;
    }
    resize() {
        let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        let { width , height  } = options;
        if (this.handle === null) {
            (0, _assert.assert)(width === undefined && height === undefined);
            this.width = this.gl.drawingBufferWidth;
            this.height = this.gl.drawingBufferHeight;
            return this;
        }
        if (width === undefined) width = this.gl.drawingBufferWidth;
        if (height === undefined) height = this.gl.drawingBufferHeight;
        if (width !== this.width && height !== this.height) (0, _gltools.log).log(2, "Resizing framebuffer ".concat(this.id, " to ").concat(width, "x").concat(height))();
        for(const attachmentPoint in this.attachments)this.attachments[attachmentPoint].resize({
            width,
            height
        });
        this.width = width;
        this.height = height;
        return this;
    }
    attach(attachments) {
        let { clearAttachments =false , resizeAttachments =true  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        const newAttachments = {};
        if (clearAttachments) Object.keys(this.attachments).forEach((key)=>{
            newAttachments[key] = null;
        });
        Object.assign(newAttachments, attachments);
        const prevHandle = this.gl.bindFramebuffer(36160, this.handle);
        for(const key in newAttachments){
            (0, _assert.assert)(key !== undefined, "Misspelled framebuffer binding point?");
            const attachment = Number(key);
            const descriptor = newAttachments[attachment];
            let object = descriptor;
            if (!object) this._unattach(attachment);
            else if (object instanceof (0, _renderbufferDefault.default)) this._attachRenderbuffer({
                attachment,
                renderbuffer: object
            });
            else if (Array.isArray(descriptor)) {
                const [texture, layer = 0, level = 0] = descriptor;
                object = texture;
                this._attachTexture({
                    attachment,
                    texture,
                    layer,
                    level
                });
            } else this._attachTexture({
                attachment,
                texture: object,
                layer: 0,
                level: 0
            });
            if (resizeAttachments && object) object.resize({
                width: this.width,
                height: this.height
            });
        }
        this.gl.bindFramebuffer(36160, prevHandle || null);
        Object.assign(this.attachments, attachments);
        Object.keys(this.attachments).filter((key)=>!this.attachments[key]).forEach((key)=>{
            delete this.attachments[key];
        });
    }
    checkStatus() {
        const { gl  } = this;
        const status = this.getStatus();
        if (status !== 36053) throw new Error(_getFrameBufferStatus(status));
        return this;
    }
    getStatus() {
        const { gl  } = this;
        const prevHandle = gl.bindFramebuffer(36160, this.handle);
        const status = gl.checkFramebufferStatus(36160);
        gl.bindFramebuffer(36160, prevHandle || null);
        return status;
    }
    clear() {
        let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { color , depth , stencil , drawBuffers =[]  } = options;
        const prevHandle = this.gl.bindFramebuffer(36160, this.handle);
        if (color || depth || stencil) (0, _clear.clear)(this.gl, {
            color,
            depth,
            stencil
        });
        drawBuffers.forEach((value, drawBuffer)=>{
            (0, _clear.clearBuffer)(this.gl, {
                drawBuffer,
                value
            });
        });
        this.gl.bindFramebuffer(36160, prevHandle || null);
        return this;
    }
    readPixels() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _gltools.log).error("Framebuffer.readPixels() is no logner supported, use readPixelsToArray(framebuffer)")();
        return null;
    }
    readPixelsToBuffer() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _gltools.log).error("Framebuffer.readPixelsToBuffer()is no logner supported, use readPixelsToBuffer(framebuffer)")();
        return null;
    }
    copyToDataUrl() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _gltools.log).error("Framebuffer.copyToDataUrl() is no logner supported, use copyToDataUrl(framebuffer)")();
        return null;
    }
    copyToImage() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _gltools.log).error("Framebuffer.copyToImage() is no logner supported, use copyToImage(framebuffer)")();
        return null;
    }
    copyToTexture() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _gltools.log).error("Framebuffer.copyToTexture({...}) is no logner supported, use copyToTexture(source, target, opts})")();
        return null;
    }
    blit() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _gltools.log).error("Framebuffer.blit({...}) is no logner supported, use blit(source, target, opts)")();
        return null;
    }
    invalidate(_ref3) {
        let { attachments =[] , x =0 , y =0 , width , height  } = _ref3;
        const gl2 = (0, _gltools.assertWebGL2Context)(this.gl);
        const prevHandle = gl2.bindFramebuffer(36008, this.handle);
        const invalidateAll = x === 0 && y === 0 && width === undefined && height === undefined;
        if (invalidateAll) gl2.invalidateFramebuffer(36008, attachments);
        else gl2.invalidateFramebuffer(36008, attachments, x, y, width, height);
        gl2.bindFramebuffer(36008, prevHandle);
        return this;
    }
    getAttachmentParameter(attachment, pname, keys) {
        let value = this._getAttachmentParameterFallback(pname);
        if (value === null) {
            this.gl.bindFramebuffer(36160, this.handle);
            value = this.gl.getFramebufferAttachmentParameter(36160, attachment, pname);
            this.gl.bindFramebuffer(36160, null);
        }
        if (keys && value > 1000) value = (0, _constantsToKeys.getKey)(this.gl, value);
        return value;
    }
    getAttachmentParameters() {
        let attachment = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 36064;
        let keys = arguments.length > 1 ? arguments[1] : undefined;
        let parameters = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : this.constructor.ATTACHMENT_PARAMETERS || [];
        const values = {};
        for (const pname of parameters){
            const key = keys ? (0, _constantsToKeys.getKey)(this.gl, pname) : pname;
            values[key] = this.getAttachmentParameter(attachment, pname, keys);
        }
        return values;
    }
    getParameters() {
        let keys = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
        const attachments = Object.keys(this.attachments);
        const parameters = {};
        for (const attachmentName of attachments){
            const attachment = Number(attachmentName);
            const key = keys ? (0, _constantsToKeys.getKey)(this.gl, attachment) : attachment;
            parameters[key] = this.getAttachmentParameters(attachment, keys);
        }
        return parameters;
    }
    show() {
        if (typeof window !== "undefined") window.open((0, _copyAndBlitJs.copyToDataUrl)(this), "luma-debug-texture");
        return this;
    }
    log() {
        let logLevel = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
        let message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";
        if (logLevel > (0, _gltools.log).level || typeof window === "undefined") return this;
        message = message || "Framebuffer ".concat(this.id);
        const image = (0, _copyAndBlitJs.copyToDataUrl)(this, {
            targetMaxHeight: 100
        });
        (0, _gltools.log).image({
            logLevel,
            message,
            image
        }, message)();
        return this;
    }
    bind() {
        let { target =36160  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this.gl.bindFramebuffer(target, this.handle);
        return this;
    }
    unbind() {
        let { target =36160  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this.gl.bindFramebuffer(target, null);
        return this;
    }
    _createDefaultAttachments(color, depth, stencil, width, height) {
        let defaultAttachments = null;
        if (color) {
            defaultAttachments = defaultAttachments || {};
            defaultAttachments[36064] = new (0, _texture2DDefault.default)(this.gl, {
                id: "".concat(this.id, "-color0"),
                pixels: null,
                format: 6408,
                type: 5121,
                width,
                height,
                mipmaps: false,
                parameters: {
                    [10241]: 9729,
                    [10240]: 9729,
                    [10242]: 33071,
                    [10243]: 33071
                }
            });
            this.ownResources.push(defaultAttachments[36064]);
        }
        if (depth && stencil) {
            defaultAttachments = defaultAttachments || {};
            defaultAttachments[33306] = new (0, _renderbufferDefault.default)(this.gl, {
                id: "".concat(this.id, "-depth-stencil"),
                format: 35056,
                width,
                height: 111
            });
            this.ownResources.push(defaultAttachments[33306]);
        } else if (depth) {
            defaultAttachments = defaultAttachments || {};
            defaultAttachments[36096] = new (0, _renderbufferDefault.default)(this.gl, {
                id: "".concat(this.id, "-depth"),
                format: 33189,
                width,
                height
            });
            this.ownResources.push(defaultAttachments[36096]);
        } else if (stencil) (0, _assert.assert)(false);
        return defaultAttachments;
    }
    _unattach(attachment) {
        const oldAttachment = this.attachments[attachment];
        if (!oldAttachment) return;
        if (oldAttachment instanceof (0, _renderbufferDefault.default)) this.gl.framebufferRenderbuffer(36160, attachment, 36161, null);
        else this.gl.framebufferTexture2D(36160, attachment, 3553, null, 0);
        delete this.attachments[attachment];
    }
    _attachRenderbuffer(_ref4) {
        let { attachment =36064 , renderbuffer  } = _ref4;
        const { gl  } = this;
        gl.framebufferRenderbuffer(36160, attachment, 36161, renderbuffer.handle);
        this.attachments[attachment] = renderbuffer;
    }
    _attachTexture(_ref5) {
        let { attachment =36064 , texture , layer , level  } = _ref5;
        const { gl  } = this;
        gl.bindTexture(texture.target, texture.handle);
        switch(texture.target){
            case 35866:
            case 32879:
                const gl2 = (0, _gltools.assertWebGL2Context)(gl);
                gl2.framebufferTextureLayer(36160, attachment, texture.target, level, layer);
                break;
            case 34067:
                const face = mapIndexToCubeMapFace(layer);
                gl.framebufferTexture2D(36160, attachment, face, texture.handle, level);
                break;
            case 3553:
                gl.framebufferTexture2D(36160, attachment, 3553, texture.handle, level);
                break;
            default:
                (0, _assert.assert)(false, "Illegal texture type");
        }
        gl.bindTexture(texture.target, null);
        this.attachments[attachment] = texture;
    }
    _setReadBuffer(readBuffer) {
        const gl2 = (0, _gltools.getWebGL2Context)(this.gl);
        if (gl2) gl2.readBuffer(readBuffer);
        else (0, _assert.assert)(readBuffer === 36064 || readBuffer === 1029, ERR_MULTIPLE_RENDERTARGETS);
        this.readBuffer = readBuffer;
    }
    _setDrawBuffers(drawBuffers) {
        const { gl  } = this;
        const gl2 = (0, _gltools.assertWebGL2Context)(gl);
        if (gl2) gl2.drawBuffers(drawBuffers);
        else {
            const ext = gl.getExtension("WEBGL_draw_buffers");
            if (ext) ext.drawBuffersWEBGL(drawBuffers);
            else (0, _assert.assert)(drawBuffers.length === 1 && (drawBuffers[0] === 36064 || drawBuffers[0] === 1029), ERR_MULTIPLE_RENDERTARGETS);
        }
        this.drawBuffers = drawBuffers;
    }
    _getAttachmentParameterFallback(pname) {
        const caps = (0, _features.getFeatures)(this.gl);
        switch(pname){
            case 36052:
                return !caps.WEBGL2 ? 0 : null;
            case 33298:
            case 33299:
            case 33300:
            case 33301:
            case 33302:
            case 33303:
                return !caps.WEBGL2 ? 8 : null;
            case 33297:
                return !caps.WEBGL2 ? 5125 : null;
            case 33296:
                return !caps.WEBGL2 && !caps.EXT_sRGB ? 9729 : null;
            default:
                return null;
        }
    }
    _createHandle() {
        return this.gl.createFramebuffer();
    }
    _deleteHandle() {
        this.gl.deleteFramebuffer(this.handle);
    }
    _bindHandle(handle) {
        return this.gl.bindFramebuffer(36160, handle);
    }
}
exports.default = Framebuffer;
function mapIndexToCubeMapFace(layer) {
    return layer < 34069 ? layer + 34069 : layer;
}
function _getFrameBufferStatus(status) {
    const STATUS = Framebuffer.STATUS || {};
    return STATUS[status] || "Framebuffer error ".concat(status);
}
const FRAMEBUFFER_ATTACHMENT_PARAMETERS = [
    36049,
    36048,
    33296,
    33298,
    33299,
    33300,
    33301,
    33302,
    33303
];
Framebuffer.ATTACHMENT_PARAMETERS = FRAMEBUFFER_ATTACHMENT_PARAMETERS;

},{"@luma.gl/gltools":"aIkwg","./resource":"10MWq","./texture-2d":"fCSl3","./renderbuffer":"kY99Z","./clear":"ejQqu","./copy-and-blit.js":"iOt7e","../features":"cwvJv","../webgl-utils/constants-to-keys":"9tmTY","../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kY99Z":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
var _renderbufferFormats = require("./renderbuffer-formats");
var _renderbufferFormatsDefault = parcelHelpers.interopDefault(_renderbufferFormats);
var _gltools = require("@luma.gl/gltools");
var _assert = require("../utils/assert");
function isFormatSupported(gl, format, formats) {
    const info = formats[format];
    if (!info) return false;
    const value = (0, _gltools.isWebGL2)(gl) ? info.gl2 || info.gl1 : info.gl1;
    if (typeof value === "string") return gl.getExtension(value);
    return value;
}
class Renderbuffer extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "Renderbuffer";
    }
    static isSupported(gl) {
        let { format  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
            format: null
        };
        return !format || isFormatSupported(gl, format, (0, _renderbufferFormatsDefault.default));
    }
    static getSamplesForFormat(gl, _ref) {
        let { format  } = _ref;
        return gl.getInternalformatParameter(36161, format, 32937);
    }
    constructor(gl){
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        super(gl, opts);
        this.initialize(opts);
        Object.seal(this);
    }
    initialize(_ref2) {
        let { format , width =1 , height =1 , samples =0  } = _ref2;
        (0, _assert.assert)(format, "Needs format");
        this._trackDeallocatedMemory();
        this.gl.bindRenderbuffer(36161, this.handle);
        if (samples !== 0 && (0, _gltools.isWebGL2)(this.gl)) this.gl.renderbufferStorageMultisample(36161, samples, format, width, height);
        else this.gl.renderbufferStorage(36161, format, width, height);
        this.format = format;
        this.width = width;
        this.height = height;
        this.samples = samples;
        this._trackAllocatedMemory(this.width * this.height * (this.samples || 1) * (0, _renderbufferFormatsDefault.default)[this.format].bpp);
        return this;
    }
    resize(_ref3) {
        let { width , height  } = _ref3;
        if (width !== this.width || height !== this.height) return this.initialize({
            width,
            height,
            format: this.format,
            samples: this.samples
        });
        return this;
    }
    _createHandle() {
        return this.gl.createRenderbuffer();
    }
    _deleteHandle() {
        this.gl.deleteRenderbuffer(this.handle);
        this._trackDeallocatedMemory();
    }
    _bindHandle(handle) {
        this.gl.bindRenderbuffer(36161, handle);
    }
    _syncHandle(handle) {
        this.format = this.getParameter(36164);
        this.width = this.getParameter(36162);
        this.height = this.getParameter(36163);
        this.samples = this.getParameter(36011);
    }
    _getParameter(pname) {
        this.gl.bindRenderbuffer(36161, this.handle);
        const value = this.gl.getRenderbufferParameter(36161, pname);
        return value;
    }
}
exports.default = Renderbuffer;

},{"./resource":"10MWq","./renderbuffer-formats":"e2ovQ","@luma.gl/gltools":"aIkwg","../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"e2ovQ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
const EXT_FLOAT_WEBGL2 = "EXT_color_buffer_float";
exports.default = {
    [33189]: {
        bpp: 2
    },
    [33190]: {
        gl2: true,
        bpp: 3
    },
    [36012]: {
        gl2: true,
        bpp: 4
    },
    [36168]: {
        bpp: 1
    },
    [34041]: {
        bpp: 4
    },
    [35056]: {
        gl2: true,
        bpp: 4
    },
    [36013]: {
        gl2: true,
        bpp: 5
    },
    [32854]: {
        bpp: 2
    },
    [36194]: {
        bpp: 2
    },
    [32855]: {
        bpp: 2
    },
    [33321]: {
        gl2: true,
        bpp: 1
    },
    [33330]: {
        gl2: true,
        bpp: 1
    },
    [33329]: {
        gl2: true,
        bpp: 1
    },
    [33332]: {
        gl2: true,
        bpp: 2
    },
    [33331]: {
        gl2: true,
        bpp: 2
    },
    [33334]: {
        gl2: true,
        bpp: 4
    },
    [33333]: {
        gl2: true,
        bpp: 4
    },
    [33323]: {
        gl2: true,
        bpp: 2
    },
    [33336]: {
        gl2: true,
        bpp: 2
    },
    [33335]: {
        gl2: true,
        bpp: 2
    },
    [33338]: {
        gl2: true,
        bpp: 4
    },
    [33337]: {
        gl2: true,
        bpp: 4
    },
    [33340]: {
        gl2: true,
        bpp: 8
    },
    [33339]: {
        gl2: true,
        bpp: 8
    },
    [32849]: {
        gl2: true,
        bpp: 3
    },
    [32856]: {
        gl2: true,
        bpp: 4
    },
    [32857]: {
        gl2: true,
        bpp: 4
    },
    [36220]: {
        gl2: true,
        bpp: 4
    },
    [36238]: {
        gl2: true,
        bpp: 4
    },
    [36975]: {
        gl2: true,
        bpp: 4
    },
    [36214]: {
        gl2: true,
        bpp: 8
    },
    [36232]: {
        gl2: true,
        bpp: 8
    },
    [36226]: {
        gl2: true,
        bpp: 16
    },
    [36208]: {
        gl2: true,
        bpp: 16
    },
    [33325]: {
        gl2: EXT_FLOAT_WEBGL2,
        bpp: 2
    },
    [33327]: {
        gl2: EXT_FLOAT_WEBGL2,
        bpp: 4
    },
    [34842]: {
        gl2: EXT_FLOAT_WEBGL2,
        bpp: 8
    },
    [33326]: {
        gl2: EXT_FLOAT_WEBGL2,
        bpp: 4
    },
    [33328]: {
        gl2: EXT_FLOAT_WEBGL2,
        bpp: 8
    },
    [34836]: {
        gl2: EXT_FLOAT_WEBGL2,
        bpp: 16
    },
    [35898]: {
        gl2: EXT_FLOAT_WEBGL2,
        bpp: 4
    }
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ejQqu":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "clear", ()=>clear);
parcelHelpers.export(exports, "clearBuffer", ()=>clearBuffer);
var _gltools = require("@luma.gl/gltools");
var _assert = require("../utils/assert");
const GL_DEPTH_BUFFER_BIT = 0x00000100;
const GL_STENCIL_BUFFER_BIT = 0x00000400;
const GL_COLOR_BUFFER_BIT = 0x00004000;
const GL_COLOR = 0x1800;
const GL_DEPTH = 0x1801;
const GL_STENCIL = 0x1802;
const GL_DEPTH_STENCIL = 0x84f9;
const ERR_ARGUMENTS = "clear: bad arguments";
function clear(gl) {
    let { framebuffer =null , color =null , depth =null , stencil =null  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    const parameters = {};
    if (framebuffer) parameters.framebuffer = framebuffer;
    let clearFlags = 0;
    if (color) {
        clearFlags |= GL_COLOR_BUFFER_BIT;
        if (color !== true) parameters.clearColor = color;
    }
    if (depth) {
        clearFlags |= GL_DEPTH_BUFFER_BIT;
        if (depth !== true) parameters.clearDepth = depth;
    }
    if (stencil) {
        clearFlags |= GL_STENCIL_BUFFER_BIT;
        if (depth !== true) parameters.clearStencil = depth;
    }
    (0, _assert.assert)(clearFlags !== 0, ERR_ARGUMENTS);
    (0, _gltools.withParameters)(gl, parameters, ()=>{
        gl.clear(clearFlags);
    });
}
function clearBuffer(gl) {
    let { framebuffer =null , buffer =GL_COLOR , drawBuffer =0 , value =[
        0,
        0,
        0,
        0
    ]  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    (0, _gltools.assertWebGL2Context)(gl);
    (0, _gltools.withParameters)(gl, {
        framebuffer
    }, ()=>{
        switch(buffer){
            case GL_COLOR:
                switch(value.constructor){
                    case Int32Array:
                        gl.clearBufferiv(buffer, drawBuffer, value);
                        break;
                    case Uint32Array:
                        gl.clearBufferuiv(buffer, drawBuffer, value);
                        break;
                    case Float32Array:
                    default:
                        gl.clearBufferfv(buffer, drawBuffer, value);
                }
                break;
            case GL_DEPTH:
                gl.clearBufferfv(GL_DEPTH, 0, [
                    value
                ]);
                break;
            case GL_STENCIL:
                gl.clearBufferiv(GL_STENCIL, 0, [
                    value
                ]);
                break;
            case GL_DEPTH_STENCIL:
                const [depth, stencil] = value;
                gl.clearBufferfi(GL_DEPTH_STENCIL, 0, depth, stencil);
                break;
            default:
                (0, _assert.assert)(false, ERR_ARGUMENTS);
        }
    });
}

},{"@luma.gl/gltools":"aIkwg","../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iOt7e":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "readPixelsToArray", ()=>readPixelsToArray);
parcelHelpers.export(exports, "readPixelsToBuffer", ()=>readPixelsToBuffer);
parcelHelpers.export(exports, "copyToDataUrl", ()=>copyToDataUrl);
parcelHelpers.export(exports, "copyToImage", ()=>copyToImage);
parcelHelpers.export(exports, "copyToTexture", ()=>copyToTexture);
parcelHelpers.export(exports, "blit", ()=>blit);
var _buffer = require("./buffer");
var _bufferDefault = parcelHelpers.interopDefault(_buffer);
var _framebuffer = require("./framebuffer");
var _framebufferDefault = parcelHelpers.interopDefault(_framebuffer);
var _texture = require("./texture");
var _textureDefault = parcelHelpers.interopDefault(_texture);
var _gltools = require("@luma.gl/gltools");
var _typedArrayUtils = require("../webgl-utils/typed-array-utils");
var _formatUtils = require("../webgl-utils/format-utils");
var _textureUtils = require("../webgl-utils/texture-utils");
var _assert = require("../utils/assert");
function readPixelsToArray(source) {
    let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    const { sourceX =0 , sourceY =0 , sourceFormat =6408  } = options;
    let { sourceAttachment =36064 , target =null , sourceWidth , sourceHeight , sourceType  } = options;
    const { framebuffer , deleteFramebuffer  } = getFramebuffer(source);
    (0, _assert.assert)(framebuffer);
    const { gl , handle , attachments  } = framebuffer;
    sourceWidth = sourceWidth || framebuffer.width;
    sourceHeight = sourceHeight || framebuffer.height;
    if (sourceAttachment === 36064 && handle === null) sourceAttachment = 1028;
    (0, _assert.assert)(attachments[sourceAttachment]);
    sourceType = sourceType || attachments[sourceAttachment].type;
    target = getPixelArray(target, sourceType, sourceFormat, sourceWidth, sourceHeight);
    sourceType = sourceType || (0, _typedArrayUtils.getGLTypeFromTypedArray)(target);
    const prevHandle = gl.bindFramebuffer(36160, handle);
    gl.readPixels(sourceX, sourceY, sourceWidth, sourceHeight, sourceFormat, sourceType, target);
    gl.bindFramebuffer(36160, prevHandle || null);
    if (deleteFramebuffer) framebuffer.delete();
    return target;
}
function readPixelsToBuffer(source, _ref) {
    let { sourceX =0 , sourceY =0 , sourceFormat =6408 , target =null , targetByteOffset =0 , sourceWidth , sourceHeight , sourceType  } = _ref;
    const { framebuffer , deleteFramebuffer  } = getFramebuffer(source);
    (0, _assert.assert)(framebuffer);
    sourceWidth = sourceWidth || framebuffer.width;
    sourceHeight = sourceHeight || framebuffer.height;
    const gl2 = (0, _gltools.assertWebGL2Context)(framebuffer.gl);
    sourceType = sourceType || (target ? target.type : 5121);
    if (!target) {
        const components = (0, _formatUtils.glFormatToComponents)(sourceFormat);
        const byteCount = (0, _formatUtils.glTypeToBytes)(sourceType);
        const byteLength = targetByteOffset + sourceWidth * sourceHeight * components * byteCount;
        target = new (0, _bufferDefault.default)(gl2, {
            byteLength,
            accessor: {
                type: sourceType,
                size: components
            }
        });
    }
    target.bind({
        target: 35051
    });
    (0, _gltools.withParameters)(gl2, {
        framebuffer
    }, ()=>{
        gl2.readPixels(sourceX, sourceY, sourceWidth, sourceHeight, sourceFormat, sourceType, targetByteOffset);
    });
    target.unbind({
        target: 35051
    });
    if (deleteFramebuffer) framebuffer.delete();
    return target;
}
function copyToDataUrl(source) {
    let { sourceAttachment =36064 , targetMaxHeight =Number.MAX_SAFE_INTEGER  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    let data = readPixelsToArray(source, {
        sourceAttachment
    });
    let { width , height  } = source;
    while(height > targetMaxHeight)({ data , width , height  } = (0, _typedArrayUtils.scalePixels)({
        data,
        width,
        height
    }));
    (0, _typedArrayUtils.flipRows)({
        data,
        width,
        height
    });
    const canvas = document.createElement("canvas");
    canvas.width = width;
    canvas.height = height;
    const context = canvas.getContext("2d");
    const imageData = context.createImageData(width, height);
    imageData.data.set(data);
    context.putImageData(imageData, 0, 0);
    return canvas.toDataURL();
}
function copyToImage(source) {
    let { sourceAttachment =36064 , targetImage =null  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    const dataUrl = copyToDataUrl(source, {
        sourceAttachment
    });
    targetImage = targetImage || new Image();
    targetImage.src = dataUrl;
    return targetImage;
}
function copyToTexture(source, target) {
    let options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    const { sourceX =0 , sourceY =0 , targetMipmaplevel =0 , targetInternalFormat =6408  } = options;
    let { targetX , targetY , targetZ , width , height  } = options;
    const { framebuffer , deleteFramebuffer  } = getFramebuffer(source);
    (0, _assert.assert)(framebuffer);
    const { gl , handle  } = framebuffer;
    const isSubCopy = typeof targetX !== "undefined" || typeof targetY !== "undefined" || typeof targetZ !== "undefined";
    targetX = targetX || 0;
    targetY = targetY || 0;
    targetZ = targetZ || 0;
    const prevHandle = gl.bindFramebuffer(36160, handle);
    (0, _assert.assert)(target);
    let texture = null;
    if (target instanceof (0, _textureDefault.default)) {
        texture = target;
        width = Number.isFinite(width) ? width : texture.width;
        height = Number.isFinite(height) ? height : texture.height;
        texture.bind(0);
        target = texture.target;
    }
    if (!isSubCopy) gl.copyTexImage2D(target, targetMipmaplevel, targetInternalFormat, sourceX, sourceY, width, height, 0);
    else switch(target){
        case 3553:
        case 34067:
            gl.copyTexSubImage2D(target, targetMipmaplevel, targetX, targetY, sourceX, sourceY, width, height);
            break;
        case 35866:
        case 32879:
            const gl2 = (0, _gltools.assertWebGL2Context)(gl);
            gl2.copyTexSubImage3D(target, targetMipmaplevel, targetX, targetY, targetZ, sourceX, sourceY, width, height);
            break;
        default:
    }
    if (texture) texture.unbind();
    gl.bindFramebuffer(36160, prevHandle || null);
    if (deleteFramebuffer) framebuffer.delete();
    return texture;
}
function blit(source, target) {
    let options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    const { sourceX0 =0 , sourceY0 =0 , targetX0 =0 , targetY0 =0 , color =true , depth =false , stencil =false , filter =9728  } = options;
    let { sourceX1 , sourceY1 , targetX1 , targetY1 , sourceAttachment =36064 , mask =0  } = options;
    const { framebuffer: srcFramebuffer , deleteFramebuffer: deleteSrcFramebuffer  } = getFramebuffer(source);
    const { framebuffer: dstFramebuffer , deleteFramebuffer: deleteDstFramebuffer  } = getFramebuffer(target);
    (0, _assert.assert)(srcFramebuffer);
    (0, _assert.assert)(dstFramebuffer);
    const { gl , handle , width , height , readBuffer  } = dstFramebuffer;
    const gl2 = (0, _gltools.assertWebGL2Context)(gl);
    if (!srcFramebuffer.handle && sourceAttachment === 36064) sourceAttachment = 1028;
    if (color) mask |= 16384;
    if (depth) mask |= 256;
    if (stencil) mask |= 1024;
    if (deleteSrcFramebuffer || deleteDstFramebuffer) {
        if (mask & 1280) {
            mask = 16384;
            (0, _gltools.log).warn("Blitting from or into a Texture object, forcing mask to GL.COLOR_BUFFER_BIT")();
        }
    }
    (0, _assert.assert)(mask);
    sourceX1 = sourceX1 === undefined ? srcFramebuffer.width : sourceX1;
    sourceY1 = sourceY1 === undefined ? srcFramebuffer.height : sourceY1;
    targetX1 = targetX1 === undefined ? width : targetX1;
    targetY1 = targetY1 === undefined ? height : targetY1;
    const prevDrawHandle = gl.bindFramebuffer(36009, handle);
    const prevReadHandle = gl.bindFramebuffer(36008, srcFramebuffer.handle);
    gl2.readBuffer(sourceAttachment);
    gl2.blitFramebuffer(sourceX0, sourceY0, sourceX1, sourceY1, targetX0, targetY0, targetX1, targetY1, mask, filter);
    gl2.readBuffer(readBuffer);
    gl2.bindFramebuffer(36008, prevReadHandle || null);
    gl2.bindFramebuffer(36009, prevDrawHandle || null);
    if (deleteSrcFramebuffer) srcFramebuffer.delete();
    if (deleteDstFramebuffer) dstFramebuffer.delete();
    return dstFramebuffer;
}
function getFramebuffer(source) {
    if (!(source instanceof (0, _framebufferDefault.default))) return {
        framebuffer: (0, _textureUtils.toFramebuffer)(source),
        deleteFramebuffer: true
    };
    return {
        framebuffer: source,
        deleteFramebuffer: false
    };
}
function getPixelArray(pixelArray, type, format, width, height) {
    if (pixelArray) return pixelArray;
    type = type || 5121;
    const ArrayType = (0, _typedArrayUtils.getTypedArrayFromGLType)(type, {
        clamped: false
    });
    const components = (0, _formatUtils.glFormatToComponents)(format);
    return new ArrayType(width * height * components);
}

},{"./buffer":"4AGCy","./framebuffer":"8XBFw","./texture":"14YT4","@luma.gl/gltools":"aIkwg","../webgl-utils/typed-array-utils":"cMpZm","../webgl-utils/format-utils":"U94Kn","../webgl-utils/texture-utils":"9VLOZ","../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"U94Kn":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "glFormatToComponents", ()=>glFormatToComponents);
parcelHelpers.export(exports, "glTypeToBytes", ()=>glTypeToBytes);
var _assert = require("../utils/assert");
function glFormatToComponents(format) {
    switch(format){
        case 6406:
        case 33326:
        case 6403:
            return 1;
        case 33328:
        case 33319:
            return 2;
        case 6407:
        case 34837:
            return 3;
        case 6408:
        case 34836:
            return 4;
        default:
            (0, _assert.assert)(false);
            return 0;
    }
}
function glTypeToBytes(type) {
    switch(type){
        case 5121:
            return 1;
        case 33635:
        case 32819:
        case 32820:
            return 2;
        case 5126:
            return 4;
        default:
            (0, _assert.assert)(false);
            return 0;
    }
}

},{"../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cwvJv":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getContextInfo", ()=>(0, _limits.getContextInfo));
parcelHelpers.export(exports, "getGLContextInfo", ()=>(0, _limits.getGLContextInfo));
parcelHelpers.export(exports, "getContextLimits", ()=>(0, _limits.getContextLimits));
parcelHelpers.export(exports, "FEATURES", ()=>(0, _webglFeaturesTable.FEATURES));
parcelHelpers.export(exports, "hasFeature", ()=>(0, _features.hasFeature));
parcelHelpers.export(exports, "hasFeatures", ()=>(0, _features.hasFeatures));
parcelHelpers.export(exports, "getFeatures", ()=>(0, _features.getFeatures));
parcelHelpers.export(exports, "canCompileGLGSExtension", ()=>(0, _checkGlslExtensionDefault.default));
var _limits = require("./limits");
var _webglFeaturesTable = require("./webgl-features-table");
var _features = require("./features");
var _checkGlslExtension = require("./check-glsl-extension");
var _checkGlslExtensionDefault = parcelHelpers.interopDefault(_checkGlslExtension);

},{"./limits":false,"./webgl-features-table":"6TJ7X","./features":"k5Bgw","./check-glsl-extension":false,"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6TJ7X":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "FEATURES", ()=>FEATURES);
var _framebuffer = require("../classes/framebuffer");
var _framebufferDefault = parcelHelpers.interopDefault(_framebuffer);
var _texture2D = require("../classes/texture-2d");
var _texture2DDefault = parcelHelpers.interopDefault(_texture2D);
const FEATURES = {
    WEBGL2: "WEBGL2",
    VERTEX_ARRAY_OBJECT: "VERTEX_ARRAY_OBJECT",
    TIMER_QUERY: "TIMER_QUERY",
    INSTANCED_RENDERING: "INSTANCED_RENDERING",
    MULTIPLE_RENDER_TARGETS: "MULTIPLE_RENDER_TARGETS",
    ELEMENT_INDEX_UINT32: "ELEMENT_INDEX_UINT32",
    BLEND_EQUATION_MINMAX: "BLEND_EQUATION_MINMAX",
    FLOAT_BLEND: "FLOAT_BLEND",
    COLOR_ENCODING_SRGB: "COLOR_ENCODING_SRGB",
    TEXTURE_DEPTH: "TEXTURE_DEPTH",
    TEXTURE_FLOAT: "TEXTURE_FLOAT",
    TEXTURE_HALF_FLOAT: "TEXTURE_HALF_FLOAT",
    TEXTURE_FILTER_LINEAR_FLOAT: "TEXTURE_FILTER_LINEAR_FLOAT",
    TEXTURE_FILTER_LINEAR_HALF_FLOAT: "TEXTURE_FILTER_LINEAR_HALF_FLOAT",
    TEXTURE_FILTER_ANISOTROPIC: "TEXTURE_FILTER_ANISOTROPIC",
    COLOR_ATTACHMENT_RGBA32F: "COLOR_ATTACHMENT_RGBA32F",
    COLOR_ATTACHMENT_FLOAT: "COLOR_ATTACHMENT_FLOAT",
    COLOR_ATTACHMENT_HALF_FLOAT: "COLOR_ATTACHMENT_HALF_FLOAT",
    GLSL_FRAG_DATA: "GLSL_FRAG_DATA",
    GLSL_FRAG_DEPTH: "GLSL_FRAG_DEPTH",
    GLSL_DERIVATIVES: "GLSL_DERIVATIVES",
    GLSL_TEXTURE_LOD: "GLSL_TEXTURE_LOD"
};
function checkFloat32ColorAttachment(gl) {
    const testTexture = new (0, _texture2DDefault.default)(gl, {
        format: 6408,
        type: 5126,
        dataFormat: 6408
    });
    const testFb = new (0, _framebufferDefault.default)(gl, {
        id: "test-framebuffer",
        check: false,
        attachments: {
            [36064]: testTexture
        }
    });
    const status = testFb.getStatus();
    testTexture.delete();
    testFb.delete();
    return status === 36053;
}
exports.default = {
    [FEATURES.WEBGL2]: [
        false,
        true
    ],
    [FEATURES.VERTEX_ARRAY_OBJECT]: [
        "OES_vertex_array_object",
        true
    ],
    [FEATURES.TIMER_QUERY]: [
        "EXT_disjoint_timer_query",
        "EXT_disjoint_timer_query_webgl2"
    ],
    [FEATURES.INSTANCED_RENDERING]: [
        "ANGLE_instanced_arrays",
        true
    ],
    [FEATURES.MULTIPLE_RENDER_TARGETS]: [
        "WEBGL_draw_buffers",
        true
    ],
    [FEATURES.ELEMENT_INDEX_UINT32]: [
        "OES_element_index_uint",
        true
    ],
    [FEATURES.BLEND_EQUATION_MINMAX]: [
        "EXT_blend_minmax",
        true
    ],
    [FEATURES.FLOAT_BLEND]: [
        "EXT_float_blend"
    ],
    [FEATURES.COLOR_ENCODING_SRGB]: [
        "EXT_sRGB",
        true
    ],
    [FEATURES.TEXTURE_DEPTH]: [
        "WEBGL_depth_texture",
        true
    ],
    [FEATURES.TEXTURE_FLOAT]: [
        "OES_texture_float",
        true
    ],
    [FEATURES.TEXTURE_HALF_FLOAT]: [
        "OES_texture_half_float",
        true
    ],
    [FEATURES.TEXTURE_FILTER_LINEAR_FLOAT]: [
        "OES_texture_float_linear"
    ],
    [FEATURES.TEXTURE_FILTER_LINEAR_HALF_FLOAT]: [
        "OES_texture_half_float_linear"
    ],
    [FEATURES.TEXTURE_FILTER_ANISOTROPIC]: [
        "EXT_texture_filter_anisotropic"
    ],
    [FEATURES.COLOR_ATTACHMENT_RGBA32F]: [
        checkFloat32ColorAttachment,
        "EXT_color_buffer_float"
    ],
    [FEATURES.COLOR_ATTACHMENT_FLOAT]: [
        false,
        "EXT_color_buffer_float"
    ],
    [FEATURES.COLOR_ATTACHMENT_HALF_FLOAT]: [
        "EXT_color_buffer_half_float"
    ],
    [FEATURES.GLSL_FRAG_DATA]: [
        "WEBGL_draw_buffers",
        true
    ],
    [FEATURES.GLSL_FRAG_DEPTH]: [
        "EXT_frag_depth",
        true
    ],
    [FEATURES.GLSL_DERIVATIVES]: [
        "OES_standard_derivatives",
        true
    ],
    [FEATURES.GLSL_TEXTURE_LOD]: [
        "EXT_shader_texture_lod",
        true
    ]
};

},{"../classes/framebuffer":"8XBFw","../classes/texture-2d":"fCSl3","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"k5Bgw":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "hasFeature", ()=>hasFeature);
parcelHelpers.export(exports, "hasFeatures", ()=>hasFeatures);
parcelHelpers.export(exports, "getFeatures", ()=>getFeatures);
var _webglFeaturesTable = require("./webgl-features-table");
var _webglFeaturesTableDefault = parcelHelpers.interopDefault(_webglFeaturesTable);
var _gltools = require("@luma.gl/gltools");
var _assert = require("../utils/assert");
const LOG_UNSUPPORTED_FEATURE = 2;
function hasFeature(gl, feature) {
    return hasFeatures(gl, feature);
}
function hasFeatures(gl, features) {
    features = Array.isArray(features) ? features : [
        features
    ];
    return features.every((feature)=>{
        return isFeatureSupported(gl, feature);
    });
}
function getFeatures(gl) {
    gl.luma = gl.luma || {};
    gl.luma.caps = gl.luma.caps || {};
    for(const cap in 0, _webglFeaturesTableDefault.default)if (gl.luma.caps[cap] === undefined) gl.luma.caps[cap] = isFeatureSupported(gl, cap);
    return gl.luma.caps;
}
function isFeatureSupported(gl, cap) {
    gl.luma = gl.luma || {};
    gl.luma.caps = gl.luma.caps || {};
    if (gl.luma.caps[cap] === undefined) gl.luma.caps[cap] = queryFeature(gl, cap);
    if (!gl.luma.caps[cap]) (0, _gltools.log).log(LOG_UNSUPPORTED_FEATURE, "Feature: ".concat(cap, " not supported"))();
    return gl.luma.caps[cap];
}
function queryFeature(gl, cap) {
    const feature = (0, _webglFeaturesTableDefault.default)[cap];
    (0, _assert.assert)(feature, cap);
    let isSupported;
    const featureDefinition = (0, _gltools.isWebGL2)(gl) ? feature[1] || feature[0] : feature[0];
    if (typeof featureDefinition === "function") isSupported = featureDefinition(gl);
    else if (Array.isArray(featureDefinition)) {
        isSupported = true;
        for (const extension of featureDefinition)isSupported = isSupported && Boolean(gl.getExtension(extension));
    } else if (typeof featureDefinition === "string") isSupported = Boolean(gl.getExtension(featureDefinition));
    else if (typeof featureDefinition === "boolean") isSupported = featureDefinition;
    else (0, _assert.assert)(false);
    return isSupported;
}

},{"./webgl-features-table":"6TJ7X","@luma.gl/gltools":"aIkwg","../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"e1xCc":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Shader", ()=>Shader);
parcelHelpers.export(exports, "VertexShader", ()=>VertexShader);
parcelHelpers.export(exports, "FragmentShader", ()=>FragmentShader);
var _gltools = require("@luma.gl/gltools");
var _glslUtils = require("../glsl-utils");
var _assert = require("../utils/assert");
var _utils = require("../utils/utils");
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
const ERR_SOURCE = "Shader: GLSL source code must be a JavaScript string";
class Shader extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "Shader";
    }
    static getTypeName(shaderType) {
        switch(shaderType){
            case 35633:
                return "vertex-shader";
            case 35632:
                return "fragment-shader";
            default:
                (0, _assert.assert)(false);
                return "unknown";
        }
    }
    constructor(gl, props){
        (0, _gltools.assertWebGLContext)(gl);
        (0, _assert.assert)(typeof props.source === "string", ERR_SOURCE);
        const id = (0, _glslUtils.getShaderName)(props.source, null) || props.id || (0, _utils.uid)("unnamed ".concat(Shader.getTypeName(props.shaderType)));
        super(gl, {
            id
        });
        this.shaderType = props.shaderType;
        this.source = props.source;
        this.initialize(props);
    }
    initialize(_ref) {
        let { source  } = _ref;
        const shaderName = (0, _glslUtils.getShaderName)(source, null);
        if (shaderName) this.id = (0, _utils.uid)(shaderName);
        this._compile(source);
    }
    getParameter(pname) {
        return this.gl.getShaderParameter(this.handle, pname);
    }
    toString() {
        return "".concat(Shader.getTypeName(this.shaderType), ":").concat(this.id);
    }
    getName() {
        return (0, _glslUtils.getShaderName)(this.source) || "unnamed-shader";
    }
    getSource() {
        return this.gl.getShaderSource(this.handle);
    }
    getTranslatedSource() {
        const extension = this.gl.getExtension("WEBGL_debug_shaders");
        return extension ? extension.getTranslatedShaderSource(this.handle) : "No translated source available. WEBGL_debug_shaders not implemented";
    }
    _compile() {
        let source = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.source;
        if (!source.startsWith("#version ")) source = "#version 100\n".concat(source);
        this.source = source;
        this.gl.shaderSource(this.handle, this.source);
        this.gl.compileShader(this.handle);
        const compileStatus = this.getParameter(35713);
        if (!compileStatus) {
            const infoLog = this.gl.getShaderInfoLog(this.handle);
            const { shaderName , errors , warnings  } = (0, _glslUtils.parseGLSLCompilerError)(infoLog, this.source, this.shaderType, this.id);
            (0, _gltools.log).error("GLSL compilation errors in ".concat(shaderName, "\n").concat(errors))();
            (0, _gltools.log).warn("GLSL compilation warnings in ".concat(shaderName, "\n").concat(warnings))();
            throw new Error("GLSL compilation errors in ".concat(shaderName));
        }
    }
    _deleteHandle() {
        this.gl.deleteShader(this.handle);
    }
    _getOptsFromHandle() {
        return {
            type: this.getParameter(35663),
            source: this.getSource()
        };
    }
}
class VertexShader extends Shader {
    get [Symbol.toStringTag]() {
        return "VertexShader";
    }
    constructor(gl, props){
        if (typeof props === "string") props = {
            source: props
        };
        super(gl, Object.assign({}, props, {
            shaderType: 35633
        }));
    }
    _createHandle() {
        return this.gl.createShader(35633);
    }
}
class FragmentShader extends Shader {
    get [Symbol.toStringTag]() {
        return "FragmentShader";
    }
    constructor(gl, props){
        if (typeof props === "string") props = {
            source: props
        };
        super(gl, Object.assign({}, props, {
            shaderType: 35632
        }));
    }
    _createHandle() {
        return this.gl.createShader(35632);
    }
}

},{"@luma.gl/gltools":"aIkwg","../glsl-utils":"cAu2R","../utils/assert":"hxAMc","../utils/utils":"adQQr","./resource":"10MWq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cAu2R":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "formatGLSLCompilerError", ()=>(0, _formatGlslErrorDefault.default));
parcelHelpers.export(exports, "parseGLSLCompilerError", ()=>(0, _formatGlslError.parseGLSLCompilerError));
parcelHelpers.export(exports, "getShaderName", ()=>(0, _getShaderNameDefault.default));
parcelHelpers.export(exports, "getShaderVersion", ()=>(0, _getShaderVersionDefault.default));
parcelHelpers.export(exports, "getShaderTypeName", ()=>(0, _getShaderTypeNameDefault.default));
var _formatGlslError = require("./format-glsl-error");
var _formatGlslErrorDefault = parcelHelpers.interopDefault(_formatGlslError);
var _getShaderName = require("./get-shader-name");
var _getShaderNameDefault = parcelHelpers.interopDefault(_getShaderName);
var _getShaderVersion = require("./get-shader-version");
var _getShaderVersionDefault = parcelHelpers.interopDefault(_getShaderVersion);
var _getShaderTypeName = require("./get-shader-type-name");
var _getShaderTypeNameDefault = parcelHelpers.interopDefault(_getShaderTypeName);

},{"./format-glsl-error":"djBD8","./get-shader-name":"gXko9","./get-shader-version":"lG7lN","./get-shader-type-name":"gxK8b","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"djBD8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "parseGLSLCompilerError", ()=>parseGLSLCompilerError);
var _getShaderName = require("./get-shader-name");
var _getShaderNameDefault = parcelHelpers.interopDefault(_getShaderName);
var _getShaderTypeName = require("./get-shader-type-name");
var _getShaderTypeNameDefault = parcelHelpers.interopDefault(_getShaderTypeName);
function formatGLSLCompilerError(errLog, src, shaderType) {
    const { shaderName , errors , warnings  } = parseGLSLCompilerError(errLog, src, shaderType);
    return "GLSL compilation error in ".concat(shaderName, "\n\n").concat(errors, "\n").concat(warnings);
}
exports.default = formatGLSLCompilerError;
function parseGLSLCompilerError(errLog, src, shaderType, shaderName) {
    const errorStrings = errLog.split(/\r?\n/);
    const errors = {};
    const warnings = {};
    const name = shaderName || (0, _getShaderNameDefault.default)(src) || "(unnamed)";
    const shaderDescription = "".concat((0, _getShaderTypeNameDefault.default)(shaderType), " shader ").concat(name);
    for(let i = 0; i < errorStrings.length; i++){
        const errorString = errorStrings[i];
        if (errorString.length <= 1) continue;
        const segments = errorString.split(":");
        const type = segments[0];
        const line = parseInt(segments[2], 10);
        if (isNaN(line)) throw new Error("GLSL compilation error in ".concat(shaderDescription, ": ").concat(errLog));
        if (type !== "WARNING") errors[line] = errorString;
        else warnings[line] = errorString;
    }
    const lines = addLineNumbers(src);
    return {
        shaderName: shaderDescription,
        errors: formatErrors(errors, lines),
        warnings: formatErrors(warnings, lines)
    };
}
function formatErrors(errors, lines) {
    let message = "";
    for(let i = 0; i < lines.length; i++){
        const line = lines[i];
        if (!errors[i + 3] && !errors[i + 2] && !errors[i + 1]) continue;
        message += "".concat(line, "\n");
        if (errors[i + 1]) {
            const error = errors[i + 1];
            const segments = error.split(":", 3);
            const type = segments[0];
            const column = parseInt(segments[1], 10) || 0;
            const err = error.substring(segments.join(":").length + 1).trim();
            message += padLeft("^^^ ".concat(type, ": ").concat(err, "\n\n"), column);
        }
    }
    return message;
}
function addLineNumbers(string) {
    let start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
    let delim = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ": ";
    const lines = string.split(/\r?\n/);
    const maxDigits = String(lines.length + start - 1).length;
    return lines.map((line, i)=>{
        const lineNumber = String(i + start);
        const digits = lineNumber.length;
        const prefix = padLeft(lineNumber, maxDigits - digits);
        return prefix + delim + line;
    });
}
function padLeft(string, digits) {
    let result = "";
    for(let i = 0; i < digits; ++i)result += " ";
    return "".concat(result).concat(string);
}

},{"./get-shader-name":"gXko9","./get-shader-type-name":"gxK8b","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gXko9":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function getShaderName(shader) {
    let defaultName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "unnamed";
    const SHADER_NAME_REGEXP = /#define[\s*]SHADER_NAME[\s*]([A-Za-z0-9_-]+)[\s*]/;
    const match = shader.match(SHADER_NAME_REGEXP);
    return match ? match[1] : defaultName;
}
exports.default = getShaderName;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gxK8b":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
const GL_FRAGMENT_SHADER = 0x8b30;
const GL_VERTEX_SHADER = 0x8b31;
function getShaderTypeName(type) {
    switch(type){
        case GL_FRAGMENT_SHADER:
            return "fragment";
        case GL_VERTEX_SHADER:
            return "vertex";
        default:
            return "unknown type";
    }
}
exports.default = getShaderTypeName;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lG7lN":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function getShaderVersion(source) {
    let version = 100;
    const words = source.match(/[^\s]+/g);
    if (words.length >= 2 && words[0] === "#version") {
        const v = parseInt(words[1], 10);
        if (Number.isFinite(v)) version = v;
    }
    return version;
}
exports.default = getShaderVersion;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6vdQd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
var _texture = require("./texture");
var _textureDefault = parcelHelpers.interopDefault(_texture);
var _framebuffer = require("./framebuffer");
var _framebufferDefault = parcelHelpers.interopDefault(_framebuffer);
var _uniforms = require("./uniforms");
var _shader = require("./shader");
var _programConfiguration = require("./program-configuration");
var _programConfigurationDefault = parcelHelpers.interopDefault(_programConfiguration);
var _gltools = require("@luma.gl/gltools");
var _constantsToKeys = require("../webgl-utils/constants-to-keys");
var _attributeUtils = require("../webgl-utils/attribute-utils");
var _assert = require("../utils/assert");
var _utils = require("../utils/utils");
const LOG_PROGRAM_PERF_PRIORITY = 4;
const GL_SEPARATE_ATTRIBS = 0x8c8d;
const V6_DEPRECATED_METHODS = [
    "setVertexArray",
    "setAttributes",
    "setBuffers",
    "unsetBuffers",
    "use",
    "getUniformCount",
    "getUniformInfo",
    "getUniformLocation",
    "getUniformValue",
    "getVarying",
    "getFragDataLocation",
    "getAttachedShaders",
    "getAttributeCount",
    "getAttributeLocation",
    "getAttributeInfo"
];
class Program extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "Program";
    }
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        super(gl, props);
        this.stubRemovedMethods("Program", "v6.0", V6_DEPRECATED_METHODS);
        this._isCached = false;
        this.initialize(props);
        Object.seal(this);
        this._setId(props.id);
    }
    initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { hash , vs , fs , varyings , bufferMode =GL_SEPARATE_ATTRIBS  } = props;
        this.hash = hash || "";
        this.vs = typeof vs === "string" ? new (0, _shader.VertexShader)(this.gl, {
            id: "".concat(props.id, "-vs"),
            source: vs
        }) : vs;
        this.fs = typeof fs === "string" ? new (0, _shader.FragmentShader)(this.gl, {
            id: "".concat(props.id, "-fs"),
            source: fs
        }) : fs;
        (0, _assert.assert)(this.vs instanceof (0, _shader.VertexShader));
        (0, _assert.assert)(this.fs instanceof (0, _shader.FragmentShader));
        this.uniforms = {};
        this._textureUniforms = {};
        if (varyings && varyings.length > 0) {
            (0, _gltools.assertWebGL2Context)(this.gl);
            this.varyings = varyings;
            this.gl2.transformFeedbackVaryings(this.handle, varyings, bufferMode);
        }
        this._compileAndLink();
        this._readUniformLocationsFromLinkedProgram();
        this.configuration = new (0, _programConfigurationDefault.default)(this);
        return this.setProps(props);
    }
    delete() {
        let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if (this._isCached) return this;
        return super.delete(options);
    }
    setProps(props) {
        if ("uniforms" in props) this.setUniforms(props.uniforms);
        return this;
    }
    draw(_ref) {
        let { logPriority , drawMode =4 , vertexCount , offset =0 , start , end , isIndexed =false , indexType =5123 , instanceCount =0 , isInstanced =instanceCount > 0 , vertexArray =null , transformFeedback , framebuffer , parameters ={} , uniforms , samplers  } = _ref;
        if (uniforms || samplers) {
            (0, _gltools.log).deprecated("Program.draw({uniforms})", "Program.setUniforms(uniforms)")();
            this.setUniforms(uniforms || {});
        }
        if ((0, _gltools.log).priority >= logPriority) {
            const fb = framebuffer ? framebuffer.id : "default";
            const message = "mode=".concat((0, _constantsToKeys.getKey)(this.gl, drawMode), " verts=").concat(vertexCount, " ") + "instances=".concat(instanceCount, " indexType=").concat((0, _constantsToKeys.getKey)(this.gl, indexType), " ") + "isInstanced=".concat(isInstanced, " isIndexed=").concat(isIndexed, " ") + "Framebuffer=".concat(fb);
            (0, _gltools.log).log(logPriority, message)();
        }
        (0, _assert.assert)(vertexArray);
        this.gl.useProgram(this.handle);
        if (!this._areTexturesRenderable() || vertexCount === 0 || isInstanced && instanceCount === 0) return false;
        vertexArray.bindForDraw(vertexCount, instanceCount, ()=>{
            if (framebuffer !== undefined) parameters = Object.assign({}, parameters, {
                framebuffer
            });
            if (transformFeedback) {
                const primitiveMode = (0, _attributeUtils.getPrimitiveDrawMode)(drawMode);
                transformFeedback.begin(primitiveMode);
            }
            this._bindTextures();
            (0, _gltools.withParameters)(this.gl, parameters, ()=>{
                if (isIndexed && isInstanced) this.gl2.drawElementsInstanced(drawMode, vertexCount, indexType, offset, instanceCount);
                else if (isIndexed && (0, _gltools.isWebGL2)(this.gl) && !isNaN(start) && !isNaN(end)) this.gl2.drawRangeElements(drawMode, start, end, vertexCount, indexType, offset);
                else if (isIndexed) this.gl.drawElements(drawMode, vertexCount, indexType, offset);
                else if (isInstanced) this.gl2.drawArraysInstanced(drawMode, offset, vertexCount, instanceCount);
                else this.gl.drawArrays(drawMode, offset, vertexCount);
            });
            if (transformFeedback) transformFeedback.end();
        });
        return true;
    }
    setUniforms() {
        let uniforms = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if ((0, _gltools.log).priority >= 2) (0, _uniforms.checkUniformValues)(uniforms, this.id, this._uniformSetters);
        this.gl.useProgram(this.handle);
        for(const uniformName in uniforms){
            const uniform = uniforms[uniformName];
            const uniformSetter = this._uniformSetters[uniformName];
            if (uniformSetter) {
                let value = uniform;
                let textureUpdate = false;
                if (value instanceof (0, _framebufferDefault.default)) value = value.texture;
                if (value instanceof (0, _textureDefault.default)) {
                    textureUpdate = this.uniforms[uniformName] !== uniform;
                    if (textureUpdate) {
                        if (uniformSetter.textureIndex === undefined) uniformSetter.textureIndex = this._textureIndexCounter++;
                        const texture = value;
                        const { textureIndex  } = uniformSetter;
                        texture.bind(textureIndex);
                        value = textureIndex;
                        this._textureUniforms[uniformName] = texture;
                    } else value = uniformSetter.textureIndex;
                } else if (this._textureUniforms[uniformName]) delete this._textureUniforms[uniformName];
                if (uniformSetter(value) || textureUpdate) (0, _uniforms.copyUniform)(this.uniforms, uniformName, uniform);
            }
        }
        return this;
    }
    _areTexturesRenderable() {
        let texturesRenderable = true;
        for(const uniformName in this._textureUniforms){
            const texture = this._textureUniforms[uniformName];
            texture.update();
            texturesRenderable = texturesRenderable && texture.loaded;
        }
        return texturesRenderable;
    }
    _bindTextures() {
        for(const uniformName in this._textureUniforms){
            const textureIndex = this._uniformSetters[uniformName].textureIndex;
            this._textureUniforms[uniformName].bind(textureIndex);
        }
    }
    _createHandle() {
        return this.gl.createProgram();
    }
    _deleteHandle() {
        this.gl.deleteProgram(this.handle);
    }
    _getOptionsFromHandle(handle) {
        const shaderHandles = this.gl.getAttachedShaders(handle);
        const opts = {};
        for (const shaderHandle of shaderHandles){
            const type = this.gl.getShaderParameter(this.handle, 35663);
            switch(type){
                case 35633:
                    opts.vs = new (0, _shader.VertexShader)({
                        handle: shaderHandle
                    });
                    break;
                case 35632:
                    opts.fs = new (0, _shader.FragmentShader)({
                        handle: shaderHandle
                    });
                    break;
                default:
            }
        }
        return opts;
    }
    _getParameter(pname) {
        return this.gl.getProgramParameter(this.handle, pname);
    }
    _setId(id) {
        if (!id) {
            const programName = this._getName();
            this.id = (0, _utils.uid)(programName);
        }
    }
    _getName() {
        let programName = this.vs.getName() || this.fs.getName();
        programName = programName.replace(/shader/i, "");
        programName = programName ? "".concat(programName, "-program") : "program";
        return programName;
    }
    _compileAndLink() {
        const { gl  } = this;
        gl.attachShader(this.handle, this.vs.handle);
        gl.attachShader(this.handle, this.fs.handle);
        (0, _gltools.log).time(LOG_PROGRAM_PERF_PRIORITY, "linkProgram for ".concat(this._getName()))();
        gl.linkProgram(this.handle);
        (0, _gltools.log).timeEnd(LOG_PROGRAM_PERF_PRIORITY, "linkProgram for ".concat(this._getName()))();
        if (gl.debug || (0, _gltools.log).level > 0) {
            const linked = gl.getProgramParameter(this.handle, 35714);
            if (!linked) throw new Error("Error linking: ".concat(gl.getProgramInfoLog(this.handle)));
            gl.validateProgram(this.handle);
            const validated = gl.getProgramParameter(this.handle, 35715);
            if (!validated) throw new Error("Error validating: ".concat(gl.getProgramInfoLog(this.handle)));
        }
    }
    _readUniformLocationsFromLinkedProgram() {
        const { gl  } = this;
        this._uniformSetters = {};
        this._uniformCount = this._getParameter(35718);
        for(let i = 0; i < this._uniformCount; i++){
            const info = this.gl.getActiveUniform(this.handle, i);
            const { name  } = (0, _uniforms.parseUniformName)(info.name);
            let location = gl.getUniformLocation(this.handle, name);
            this._uniformSetters[name] = (0, _uniforms.getUniformSetter)(gl, location, info);
            if (info.size > 1) for(let l = 0; l < info.size; l++){
                location = gl.getUniformLocation(this.handle, "".concat(name, "[").concat(l, "]"));
                this._uniformSetters["".concat(name, "[").concat(l, "]")] = (0, _uniforms.getUniformSetter)(gl, location, info);
            }
        }
        this._textureIndexCounter = 0;
    }
    getActiveUniforms(uniformIndices, pname) {
        return this.gl2.getActiveUniforms(this.handle, uniformIndices, pname);
    }
    getUniformBlockIndex(blockName) {
        return this.gl2.getUniformBlockIndex(this.handle, blockName);
    }
    getActiveUniformBlockParameter(blockIndex, pname) {
        return this.gl2.getActiveUniformBlockParameter(this.handle, blockIndex, pname);
    }
    uniformBlockBinding(blockIndex, blockBinding) {
        this.gl2.uniformBlockBinding(this.handle, blockIndex, blockBinding);
    }
}
exports.default = Program;

},{"./resource":"10MWq","./texture":"14YT4","./framebuffer":"8XBFw","./uniforms":"3d3Rq","./shader":"e1xCc","./program-configuration":"aLkY8","@luma.gl/gltools":"aIkwg","../webgl-utils/constants-to-keys":"9tmTY","../webgl-utils/attribute-utils":"1qYrw","../utils/assert":"hxAMc","../utils/utils":"adQQr","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3d3Rq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getUniformSetter", ()=>getUniformSetter);
parcelHelpers.export(exports, "parseUniformName", ()=>parseUniformName);
parcelHelpers.export(exports, "checkUniformValues", ()=>checkUniformValues);
parcelHelpers.export(exports, "copyUniform", ()=>copyUniform);
var _gltools = require("@luma.gl/gltools");
var _framebuffer = require("./framebuffer");
var _framebufferDefault = parcelHelpers.interopDefault(_framebuffer);
var _renderbuffer = require("./renderbuffer");
var _renderbufferDefault = parcelHelpers.interopDefault(_renderbuffer);
var _texture = require("./texture");
var _textureDefault = parcelHelpers.interopDefault(_texture);
var _assert = require("../utils/assert");
const UNIFORM_SETTERS = {
    [5126]: getArraySetter.bind(null, "uniform1fv", toFloatArray, 1, setVectorUniform),
    [35664]: getArraySetter.bind(null, "uniform2fv", toFloatArray, 2, setVectorUniform),
    [35665]: getArraySetter.bind(null, "uniform3fv", toFloatArray, 3, setVectorUniform),
    [35666]: getArraySetter.bind(null, "uniform4fv", toFloatArray, 4, setVectorUniform),
    [5124]: getArraySetter.bind(null, "uniform1iv", toIntArray, 1, setVectorUniform),
    [35667]: getArraySetter.bind(null, "uniform2iv", toIntArray, 2, setVectorUniform),
    [35668]: getArraySetter.bind(null, "uniform3iv", toIntArray, 3, setVectorUniform),
    [35669]: getArraySetter.bind(null, "uniform4iv", toIntArray, 4, setVectorUniform),
    [35670]: getArraySetter.bind(null, "uniform1iv", toIntArray, 1, setVectorUniform),
    [35671]: getArraySetter.bind(null, "uniform2iv", toIntArray, 2, setVectorUniform),
    [35672]: getArraySetter.bind(null, "uniform3iv", toIntArray, 3, setVectorUniform),
    [35673]: getArraySetter.bind(null, "uniform4iv", toIntArray, 4, setVectorUniform),
    [35674]: getArraySetter.bind(null, "uniformMatrix2fv", toFloatArray, 4, setMatrixUniform),
    [35675]: getArraySetter.bind(null, "uniformMatrix3fv", toFloatArray, 9, setMatrixUniform),
    [35676]: getArraySetter.bind(null, "uniformMatrix4fv", toFloatArray, 16, setMatrixUniform),
    [35678]: getSamplerSetter,
    [35680]: getSamplerSetter,
    [5125]: getArraySetter.bind(null, "uniform1uiv", toUIntArray, 1, setVectorUniform),
    [36294]: getArraySetter.bind(null, "uniform2uiv", toUIntArray, 2, setVectorUniform),
    [36295]: getArraySetter.bind(null, "uniform3uiv", toUIntArray, 3, setVectorUniform),
    [36296]: getArraySetter.bind(null, "uniform4uiv", toUIntArray, 4, setVectorUniform),
    [35685]: getArraySetter.bind(null, "uniformMatrix2x3fv", toFloatArray, 6, setMatrixUniform),
    [35686]: getArraySetter.bind(null, "uniformMatrix2x4fv", toFloatArray, 8, setMatrixUniform),
    [35687]: getArraySetter.bind(null, "uniformMatrix3x2fv", toFloatArray, 6, setMatrixUniform),
    [35688]: getArraySetter.bind(null, "uniformMatrix3x4fv", toFloatArray, 12, setMatrixUniform),
    [35689]: getArraySetter.bind(null, "uniformMatrix4x2fv", toFloatArray, 8, setMatrixUniform),
    [35690]: getArraySetter.bind(null, "uniformMatrix4x3fv", toFloatArray, 12, setMatrixUniform),
    [35678]: getSamplerSetter,
    [35680]: getSamplerSetter,
    [35679]: getSamplerSetter,
    [35682]: getSamplerSetter,
    [36289]: getSamplerSetter,
    [36292]: getSamplerSetter,
    [36293]: getSamplerSetter,
    [36298]: getSamplerSetter,
    [36299]: getSamplerSetter,
    [36300]: getSamplerSetter,
    [36303]: getSamplerSetter,
    [36306]: getSamplerSetter,
    [36307]: getSamplerSetter,
    [36308]: getSamplerSetter,
    [36311]: getSamplerSetter
};
const FLOAT_ARRAY = {};
const INT_ARRAY = {};
const UINT_ARRAY = {};
const array1 = [
    0
];
function toTypedArray(value, uniformLength, Type, cache) {
    if (uniformLength === 1 && typeof value === "boolean") value = value ? 1 : 0;
    if (Number.isFinite(value)) {
        array1[0] = value;
        value = array1;
    }
    const length = value.length;
    if (length % uniformLength) (0, _gltools.log).warn("Uniform size should be multiples of ".concat(uniformLength), value)();
    if (value instanceof Type) return value;
    let result = cache[length];
    if (!result) {
        result = new Type(length);
        cache[length] = result;
    }
    for(let i = 0; i < length; i++)result[i] = value[i];
    return result;
}
function toFloatArray(value, uniformLength) {
    return toTypedArray(value, uniformLength, Float32Array, FLOAT_ARRAY);
}
function toIntArray(value, uniformLength) {
    return toTypedArray(value, uniformLength, Int32Array, INT_ARRAY);
}
function toUIntArray(value, uniformLength) {
    return toTypedArray(value, uniformLength, Uint32Array, UINT_ARRAY);
}
function getUniformSetter(gl, location, info) {
    const setter = UNIFORM_SETTERS[info.type];
    if (!setter) throw new Error("Unknown GLSL uniform type ".concat(info.type));
    return setter().bind(null, gl, location);
}
function parseUniformName(name) {
    if (name[name.length - 1] !== "]") return {
        name,
        length: 1,
        isArray: false
    };
    const UNIFORM_NAME_REGEXP = /([^[]*)(\[[0-9]+\])?/;
    const matches = name.match(UNIFORM_NAME_REGEXP);
    if (!matches || matches.length < 2) throw new Error("Failed to parse GLSL uniform name ".concat(name));
    return {
        name: matches[1],
        length: matches[2] || 1,
        isArray: Boolean(matches[2])
    };
}
function checkUniformValues(uniforms, source, uniformMap) {
    for(const uniformName in uniforms){
        const value = uniforms[uniformName];
        const shouldCheck = !uniformMap || Boolean(uniformMap[uniformName]);
        if (shouldCheck && !checkUniformValue(value)) {
            source = source ? "".concat(source, " ") : "";
            console.error("".concat(source, " Bad uniform ").concat(uniformName), value);
            throw new Error("".concat(source, " Bad uniform ").concat(uniformName));
        }
    }
    return true;
}
function checkUniformValue(value) {
    if (Array.isArray(value) || ArrayBuffer.isView(value)) return checkUniformArray(value);
    if (isFinite(value)) return true;
    else if (value === true || value === false) return true;
    else if (value instanceof (0, _textureDefault.default)) return true;
    else if (value instanceof (0, _renderbufferDefault.default)) return true;
    else if (value instanceof (0, _framebufferDefault.default)) return Boolean(value.texture);
    return false;
}
function copyUniform(uniforms, key, value) {
    if (Array.isArray(value) || ArrayBuffer.isView(value)) {
        if (uniforms[key]) {
            const dest = uniforms[key];
            for(let i = 0, len = value.length; i < len; ++i)dest[i] = value[i];
        } else uniforms[key] = value.slice();
    } else uniforms[key] = value;
}
function checkUniformArray(value) {
    if (value.length === 0) return false;
    const checkLength = Math.min(value.length, 16);
    for(let i = 0; i < checkLength; ++i){
        if (!Number.isFinite(value[i])) return false;
    }
    return true;
}
function getSamplerSetter() {
    let cache = null;
    return (gl, location, value)=>{
        const update = cache !== value;
        if (update) {
            gl.uniform1i(location, value);
            cache = value;
        }
        return update;
    };
}
function getArraySetter(functionName, toArray, size, uniformSetter) {
    let cache = null;
    let cacheLength = null;
    return (gl, location, value)=>{
        const arrayValue = toArray(value, size);
        const length = arrayValue.length;
        let update = false;
        if (cache === null) {
            cache = new Float32Array(length);
            cacheLength = length;
            update = true;
        } else {
            (0, _assert.assert)(cacheLength === length, "Uniform length cannot change.");
            for(let i = 0; i < length; ++i)if (arrayValue[i] !== cache[i]) {
                update = true;
                break;
            }
        }
        if (update) {
            uniformSetter(gl, functionName, location, arrayValue);
            cache.set(arrayValue);
        }
        return update;
    };
}
function setVectorUniform(gl, functionName, location, value) {
    gl[functionName](location, value);
}
function setMatrixUniform(gl, functionName, location, value) {
    gl[functionName](location, false, value);
}

},{"@luma.gl/gltools":"aIkwg","./framebuffer":"8XBFw","./renderbuffer":"kY99Z","./texture":"14YT4","../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aLkY8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _accessor = require("./accessor");
var _accessorDefault = parcelHelpers.interopDefault(_accessor);
var _gltools = require("@luma.gl/gltools");
var _attributeUtils = require("../webgl-utils/attribute-utils");
class ProgramConfiguration {
    constructor(program){
        this.id = program.id;
        this.attributeInfos = [];
        this.attributeInfosByName = {};
        this.attributeInfosByLocation = [];
        this.varyingInfos = [];
        this.varyingInfosByName = {};
        Object.seal(this);
        this._readAttributesFromProgram(program);
        this._readVaryingsFromProgram(program);
    }
    getAttributeInfo(locationOrName) {
        const location = Number(locationOrName);
        if (Number.isFinite(location)) return this.attributeInfosByLocation[location];
        return this.attributeInfosByName[locationOrName] || null;
    }
    getAttributeLocation(locationOrName) {
        const attributeInfo = this.getAttributeInfo(locationOrName);
        return attributeInfo ? attributeInfo.location : -1;
    }
    getAttributeAccessor(locationOrName) {
        const attributeInfo = this.getAttributeInfo(locationOrName);
        return attributeInfo ? attributeInfo.accessor : null;
    }
    getVaryingInfo(locationOrName) {
        const location = Number(locationOrName);
        if (Number.isFinite(location)) return this.varyingInfos[location];
        return this.varyingInfosByName[locationOrName] || null;
    }
    getVaryingIndex(locationOrName) {
        const varying = this.getVaryingInfo();
        return varying ? varying.location : -1;
    }
    getVaryingAccessor(locationOrName) {
        const varying = this.getVaryingInfo();
        return varying ? varying.accessor : null;
    }
    _readAttributesFromProgram(program) {
        const { gl  } = program;
        const count = gl.getProgramParameter(program.handle, 35721);
        for(let index = 0; index < count; index++){
            const { name , type , size  } = gl.getActiveAttrib(program.handle, index);
            const location = gl.getAttribLocation(program.handle, name);
            if (location >= 0) this._addAttribute(location, name, type, size);
        }
        this.attributeInfos.sort((a, b)=>a.location - b.location);
    }
    _readVaryingsFromProgram(program) {
        const { gl  } = program;
        if (!(0, _gltools.isWebGL2)(gl)) return;
        const count = gl.getProgramParameter(program.handle, 35971);
        for(let location = 0; location < count; location++){
            const { name , type , size  } = gl.getTransformFeedbackVarying(program.handle, location);
            this._addVarying(location, name, type, size);
        }
        this.varyingInfos.sort((a, b)=>a.location - b.location);
    }
    _addAttribute(location, name, compositeType, size) {
        const { type , components  } = (0, _attributeUtils.decomposeCompositeGLType)(compositeType);
        const accessor = {
            type,
            size: size * components
        };
        this._inferProperties(location, name, accessor);
        const attributeInfo = {
            location,
            name,
            accessor: new (0, _accessorDefault.default)(accessor)
        };
        this.attributeInfos.push(attributeInfo);
        this.attributeInfosByLocation[location] = attributeInfo;
        this.attributeInfosByName[attributeInfo.name] = attributeInfo;
    }
    _inferProperties(location, name, accessor) {
        if (/instance/i.test(name)) accessor.divisor = 1;
    }
    _addVarying(location, name, compositeType, size) {
        const { type , components  } = (0, _attributeUtils.decomposeCompositeGLType)(compositeType);
        const accessor = new (0, _accessorDefault.default)({
            type,
            size: size * components
        });
        const varying = {
            location,
            name,
            accessor
        };
        this.varyingInfos.push(varying);
        this.varyingInfosByName[varying.name] = varying;
    }
}
exports.default = ProgramConfiguration;

},{"./accessor":"9zq2J","@luma.gl/gltools":"aIkwg","../webgl-utils/attribute-utils":"1qYrw","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1qYrw":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getPrimitiveDrawMode", ()=>getPrimitiveDrawMode);
parcelHelpers.export(exports, "getPrimitiveCount", ()=>getPrimitiveCount);
parcelHelpers.export(exports, "getVertexCount", ()=>getVertexCount);
parcelHelpers.export(exports, "decomposeCompositeGLType", ()=>decomposeCompositeGLType);
parcelHelpers.export(exports, "getCompositeGLType", ()=>getCompositeGLType);
var _assert = require("../utils/assert");
const GL_BYTE = 0x1400;
const GL_UNSIGNED_BYTE = 0x1401;
const GL_SHORT = 0x1402;
const GL_UNSIGNED_SHORT = 0x1403;
const GL_POINTS = 0x0;
const GL_LINES = 0x1;
const GL_LINE_LOOP = 0x2;
const GL_LINE_STRIP = 0x3;
const GL_TRIANGLES = 0x4;
const GL_TRIANGLE_STRIP = 0x5;
const GL_TRIANGLE_FAN = 0x6;
const GL_FLOAT = 0x1406;
const GL_FLOAT_VEC2 = 0x8b50;
const GL_FLOAT_VEC3 = 0x8b51;
const GL_FLOAT_VEC4 = 0x8b52;
const GL_INT = 0x1404;
const GL_INT_VEC2 = 0x8b53;
const GL_INT_VEC3 = 0x8b54;
const GL_INT_VEC4 = 0x8b55;
const GL_UNSIGNED_INT = 0x1405;
const GL_UNSIGNED_INT_VEC2 = 0x8dc6;
const GL_UNSIGNED_INT_VEC3 = 0x8dc7;
const GL_UNSIGNED_INT_VEC4 = 0x8dc8;
const GL_BOOL = 0x8b56;
const GL_BOOL_VEC2 = 0x8b57;
const GL_BOOL_VEC3 = 0x8b58;
const GL_BOOL_VEC4 = 0x8b59;
const GL_FLOAT_MAT2 = 0x8b5a;
const GL_FLOAT_MAT3 = 0x8b5b;
const GL_FLOAT_MAT4 = 0x8b5c;
const GL_FLOAT_MAT2x3 = 0x8b65;
const GL_FLOAT_MAT2x4 = 0x8b66;
const GL_FLOAT_MAT3x2 = 0x8b67;
const GL_FLOAT_MAT3x4 = 0x8b68;
const GL_FLOAT_MAT4x2 = 0x8b69;
const GL_FLOAT_MAT4x3 = 0x8b6a;
const COMPOSITE_GL_TYPES = {
    [GL_FLOAT]: [
        GL_FLOAT,
        1,
        "float"
    ],
    [GL_FLOAT_VEC2]: [
        GL_FLOAT,
        2,
        "vec2"
    ],
    [GL_FLOAT_VEC3]: [
        GL_FLOAT,
        3,
        "vec3"
    ],
    [GL_FLOAT_VEC4]: [
        GL_FLOAT,
        4,
        "vec4"
    ],
    [GL_INT]: [
        GL_INT,
        1,
        "int"
    ],
    [GL_INT_VEC2]: [
        GL_INT,
        2,
        "ivec2"
    ],
    [GL_INT_VEC3]: [
        GL_INT,
        3,
        "ivec3"
    ],
    [GL_INT_VEC4]: [
        GL_INT,
        4,
        "ivec4"
    ],
    [GL_UNSIGNED_INT]: [
        GL_UNSIGNED_INT,
        1,
        "uint"
    ],
    [GL_UNSIGNED_INT_VEC2]: [
        GL_UNSIGNED_INT,
        2,
        "uvec2"
    ],
    [GL_UNSIGNED_INT_VEC3]: [
        GL_UNSIGNED_INT,
        3,
        "uvec3"
    ],
    [GL_UNSIGNED_INT_VEC4]: [
        GL_UNSIGNED_INT,
        4,
        "uvec4"
    ],
    [GL_BOOL]: [
        GL_FLOAT,
        1,
        "bool"
    ],
    [GL_BOOL_VEC2]: [
        GL_FLOAT,
        2,
        "bvec2"
    ],
    [GL_BOOL_VEC3]: [
        GL_FLOAT,
        3,
        "bvec3"
    ],
    [GL_BOOL_VEC4]: [
        GL_FLOAT,
        4,
        "bvec4"
    ],
    [GL_FLOAT_MAT2]: [
        GL_FLOAT,
        8,
        "mat2"
    ],
    [GL_FLOAT_MAT2x3]: [
        GL_FLOAT,
        8,
        "mat2x3"
    ],
    [GL_FLOAT_MAT2x4]: [
        GL_FLOAT,
        8,
        "mat2x4"
    ],
    [GL_FLOAT_MAT3]: [
        GL_FLOAT,
        12,
        "mat3"
    ],
    [GL_FLOAT_MAT3x2]: [
        GL_FLOAT,
        12,
        "mat3x2"
    ],
    [GL_FLOAT_MAT3x4]: [
        GL_FLOAT,
        12,
        "mat3x4"
    ],
    [GL_FLOAT_MAT4]: [
        GL_FLOAT,
        16,
        "mat4"
    ],
    [GL_FLOAT_MAT4x2]: [
        GL_FLOAT,
        16,
        "mat4x2"
    ],
    [GL_FLOAT_MAT4x3]: [
        GL_FLOAT,
        16,
        "mat4x3"
    ]
};
function getPrimitiveDrawMode(drawMode) {
    switch(drawMode){
        case GL_POINTS:
            return GL_POINTS;
        case GL_LINES:
            return GL_LINES;
        case GL_LINE_STRIP:
            return GL_LINES;
        case GL_LINE_LOOP:
            return GL_LINES;
        case GL_TRIANGLES:
            return GL_TRIANGLES;
        case GL_TRIANGLE_STRIP:
            return GL_TRIANGLES;
        case GL_TRIANGLE_FAN:
            return GL_TRIANGLES;
        default:
            (0, _assert.assert)(false);
            return 0;
    }
}
function getPrimitiveCount(_ref) {
    let { drawMode , vertexCount  } = _ref;
    switch(drawMode){
        case GL_POINTS:
        case GL_LINE_LOOP:
            return vertexCount;
        case GL_LINES:
            return vertexCount / 2;
        case GL_LINE_STRIP:
            return vertexCount - 1;
        case GL_TRIANGLES:
            return vertexCount / 3;
        case GL_TRIANGLE_STRIP:
        case GL_TRIANGLE_FAN:
            return vertexCount - 2;
        default:
            (0, _assert.assert)(false);
            return 0;
    }
}
function getVertexCount(_ref2) {
    let { drawMode , vertexCount  } = _ref2;
    const primitiveCount = getPrimitiveCount({
        drawMode,
        vertexCount
    });
    switch(getPrimitiveDrawMode(drawMode)){
        case GL_POINTS:
            return primitiveCount;
        case GL_LINES:
            return primitiveCount * 2;
        case GL_TRIANGLES:
            return primitiveCount * 3;
        default:
            (0, _assert.assert)(false);
            return 0;
    }
}
function decomposeCompositeGLType(compositeGLType) {
    const typeAndSize = COMPOSITE_GL_TYPES[compositeGLType];
    if (!typeAndSize) return null;
    const [type, components] = typeAndSize;
    return {
        type,
        components
    };
}
function getCompositeGLType(type, components) {
    switch(type){
        case GL_BYTE:
        case GL_UNSIGNED_BYTE:
        case GL_SHORT:
        case GL_UNSIGNED_SHORT:
            type = GL_FLOAT;
            break;
        default:
    }
    for(const glType in COMPOSITE_GL_TYPES){
        const [compType, compComponents, name] = COMPOSITE_GL_TYPES[glType];
        if (compType === type && compComponents === components) return {
            glType,
            name
        };
    }
    return null;
}

},{"../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aG7Qa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
var _features = require("../features");
var _gltools = require("@luma.gl/gltools");
var _assert = require("../utils/assert");
const GL_QUERY_RESULT = 0x8866;
const GL_QUERY_RESULT_AVAILABLE = 0x8867;
const GL_TIME_ELAPSED_EXT = 0x88bf;
const GL_GPU_DISJOINT_EXT = 0x8fbb;
const GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN = 0x8c88;
const GL_ANY_SAMPLES_PASSED = 0x8c2f;
const GL_ANY_SAMPLES_PASSED_CONSERVATIVE = 0x8d6a;
class Query extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "Query";
    }
    static isSupported(gl) {
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
        const webgl2 = (0, _gltools.isWebGL2)(gl);
        const hasTimerQuery = (0, _features.hasFeatures)(gl, (0, _features.FEATURES).TIMER_QUERY);
        let supported = webgl2 || hasTimerQuery;
        for (const key of opts)switch(key){
            case "queries":
                supported = supported && webgl2;
                break;
            case "timers":
                supported = supported && hasTimerQuery;
                break;
            default:
                (0, _assert.assert)(false);
        }
        return supported;
    }
    constructor(gl){
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        super(gl, opts);
        this.target = null;
        this._queryPending = false;
        this._pollingPromise = null;
        Object.seal(this);
    }
    beginTimeElapsedQuery() {
        return this.begin(GL_TIME_ELAPSED_EXT);
    }
    beginOcclusionQuery() {
        let { conservative =false  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return this.begin(conservative ? GL_ANY_SAMPLES_PASSED_CONSERVATIVE : GL_ANY_SAMPLES_PASSED);
    }
    beginTransformFeedbackQuery() {
        return this.begin(GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN);
    }
    begin(target) {
        if (this._queryPending) return this;
        this.target = target;
        this.gl2.beginQuery(this.target, this.handle);
        return this;
    }
    end() {
        if (this._queryPending) return this;
        if (this.target) {
            this.gl2.endQuery(this.target);
            this.target = null;
            this._queryPending = true;
        }
        return this;
    }
    isResultAvailable() {
        if (!this._queryPending) return false;
        const resultAvailable = this.gl2.getQueryParameter(this.handle, GL_QUERY_RESULT_AVAILABLE);
        if (resultAvailable) this._queryPending = false;
        return resultAvailable;
    }
    isTimerDisjoint() {
        return this.gl2.getParameter(GL_GPU_DISJOINT_EXT);
    }
    getResult() {
        return this.gl2.getQueryParameter(this.handle, GL_QUERY_RESULT);
    }
    getTimerMilliseconds() {
        return this.getResult() / 1e6;
    }
    createPoll() {
        let limit = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Number.POSITIVE_INFINITY;
        if (this._pollingPromise) return this._pollingPromise;
        let counter = 0;
        this._pollingPromise = new Promise((resolve, reject)=>{
            const poll = ()=>{
                if (this.isResultAvailable()) {
                    resolve(this.getResult());
                    this._pollingPromise = null;
                } else if (counter++ > limit) {
                    reject("Timed out");
                    this._pollingPromise = null;
                } else requestAnimationFrame(poll);
            };
            requestAnimationFrame(poll);
        });
        return this._pollingPromise;
    }
    _createHandle() {
        return Query.isSupported(this.gl) ? this.gl2.createQuery() : null;
    }
    _deleteHandle() {
        this.gl2.deleteQuery(this.handle);
    }
}
exports.default = Query;

},{"./resource":"10MWq","../features":"cwvJv","@luma.gl/gltools":"aIkwg","../utils/assert":"hxAMc","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3JXgK":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
var _buffer = require("./buffer");
var _bufferDefault = parcelHelpers.interopDefault(_buffer);
var _utils = require("../utils/utils");
class TransformFeedback extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "TransformFeedback";
    }
    static isSupported(gl) {
        return (0, _gltools.isWebGL2)(gl);
    }
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        (0, _gltools.assertWebGL2Context)(gl);
        super(gl, props);
        this.initialize(props);
        this.stubRemovedMethods("TransformFeedback", "v6.0", [
            "pause",
            "resume"
        ]);
        Object.seal(this);
    }
    initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this.buffers = {};
        this.unused = {};
        this.configuration = null;
        this.bindOnUse = true;
        if (!(0, _utils.isObjectEmpty)(this.buffers)) this.bind(()=>this._unbindBuffers());
        this.setProps(props);
        return this;
    }
    setProps(props) {
        if ("program" in props) this.configuration = props.program && props.program.configuration;
        if ("configuration" in props) this.configuration = props.configuration;
        if ("bindOnUse" in props) props = props.bindOnUse;
        if ("buffers" in props) this.setBuffers(props.buffers);
    }
    setBuffers() {
        let buffers = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this.bind(()=>{
            for(const bufferName in buffers)this.setBuffer(bufferName, buffers[bufferName]);
        });
        return this;
    }
    setBuffer(locationOrName, bufferOrParams) {
        const location = this._getVaryingIndex(locationOrName);
        const { buffer , byteSize , byteOffset  } = this._getBufferParams(bufferOrParams);
        if (location < 0) {
            this.unused[locationOrName] = buffer;
            (0, _gltools.log).warn("".concat(this.id, " unused varying buffer ").concat(locationOrName))();
            return this;
        }
        this.buffers[location] = bufferOrParams;
        if (!this.bindOnUse) this._bindBuffer(location, buffer, byteOffset, byteSize);
        return this;
    }
    begin() {
        let primitiveMode = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
        this.gl.bindTransformFeedback(36386, this.handle);
        this._bindBuffers();
        this.gl.beginTransformFeedback(primitiveMode);
        return this;
    }
    end() {
        this.gl.endTransformFeedback();
        this._unbindBuffers();
        this.gl.bindTransformFeedback(36386, null);
        return this;
    }
    _getBufferParams(bufferOrParams) {
        let byteOffset;
        let byteSize;
        let buffer;
        if (bufferOrParams instanceof (0, _bufferDefault.default) === false) {
            buffer = bufferOrParams.buffer;
            byteSize = bufferOrParams.byteSize;
            byteOffset = bufferOrParams.byteOffset;
        } else buffer = bufferOrParams;
        if (byteOffset !== undefined || byteSize !== undefined) {
            byteOffset = byteOffset || 0;
            byteSize = byteSize || buffer.byteLength - byteOffset;
        }
        return {
            buffer,
            byteOffset,
            byteSize
        };
    }
    _getVaryingInfo(locationOrName) {
        return this.configuration && this.configuration.getVaryingInfo(locationOrName);
    }
    _getVaryingIndex(locationOrName) {
        if (this.configuration) return this.configuration.getVaryingInfo(locationOrName).location;
        const location = Number(locationOrName);
        return Number.isFinite(location) ? location : -1;
    }
    _bindBuffers() {
        if (this.bindOnUse) for(const bufferIndex in this.buffers){
            const { buffer , byteSize , byteOffset  } = this._getBufferParams(this.buffers[bufferIndex]);
            this._bindBuffer(bufferIndex, buffer, byteOffset, byteSize);
        }
    }
    _unbindBuffers() {
        if (this.bindOnUse) for(const bufferIndex in this.buffers)this._bindBuffer(bufferIndex, null);
    }
    _bindBuffer(index, buffer) {
        let byteOffset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
        let byteSize = arguments.length > 3 ? arguments[3] : undefined;
        const handle = buffer && buffer.handle;
        if (!handle || byteSize === undefined) this.gl.bindBufferBase(35982, index, handle);
        else this.gl.bindBufferRange(35982, index, handle, byteOffset, byteSize);
        return this;
    }
    _createHandle() {
        return this.gl.createTransformFeedback();
    }
    _deleteHandle() {
        this.gl.deleteTransformFeedback(this.handle);
    }
    _bindHandle(handle) {
        this.gl.bindTransformFeedback(36386, this.handle);
    }
}
exports.default = TransformFeedback;

},{"@luma.gl/gltools":"aIkwg","./resource":"10MWq","./buffer":"4AGCy","../utils/utils":"adQQr","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eO1Wv":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
var _buffer = require("./buffer");
var _bufferDefault = parcelHelpers.interopDefault(_buffer);
var _gltools = require("@luma.gl/gltools");
var _arrayUtilsFlat = require("../utils/array-utils-flat");
var _assert = require("../utils/assert");
var _env = require("@probe.gl/env");
const ERR_ELEMENTS = "elements must be GL.ELEMENT_ARRAY_BUFFER";
class VertexArrayObject extends (0, _resourceDefault.default) {
    get [Symbol.toStringTag]() {
        return "VertexArrayObject";
    }
    static isSupported(gl) {
        let options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        if (options.constantAttributeZero) return (0, _gltools.isWebGL2)(gl) || (0, _env.getBrowser)() === "Chrome";
        return true;
    }
    static getDefaultArray(gl) {
        gl.luma = gl.luma || {};
        if (!gl.luma.defaultVertexArray) gl.luma.defaultVertexArray = new VertexArrayObject(gl, {
            handle: null,
            isDefaultArray: true
        });
        return gl.luma.defaultVertexArray;
    }
    static getMaxAttributes(gl) {
        VertexArrayObject.MAX_ATTRIBUTES = VertexArrayObject.MAX_ATTRIBUTES || gl.getParameter(34921);
        return VertexArrayObject.MAX_ATTRIBUTES;
    }
    static setConstant(gl, location, array) {
        switch(array.constructor){
            case Float32Array:
                VertexArrayObject._setConstantFloatArray(gl, location, array);
                break;
            case Int32Array:
                VertexArrayObject._setConstantIntArray(gl, location, array);
                break;
            case Uint32Array:
                VertexArrayObject._setConstantUintArray(gl, location, array);
                break;
            default:
                (0, _assert.assert)(false);
        }
    }
    constructor(gl){
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        const id = opts.id || opts.program && opts.program.id;
        super(gl, Object.assign({}, opts, {
            id
        }));
        this.buffer = null;
        this.bufferValue = null;
        this.isDefaultArray = opts.isDefaultArray || false;
        this.gl2 = gl;
        this.initialize(opts);
        Object.seal(this);
    }
    delete() {
        super.delete();
        if (this.buffer) this.buffer.delete();
        return this;
    }
    get MAX_ATTRIBUTES() {
        return VertexArrayObject.getMaxAttributes(this.gl);
    }
    initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        return this.setProps(props);
    }
    setProps(props) {
        return this;
    }
    setElementBuffer() {
        let elementBuffer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        (0, _assert.assert)(!elementBuffer || elementBuffer.target === 34963, ERR_ELEMENTS);
        this.bind(()=>{
            this.gl.bindBuffer(34963, elementBuffer ? elementBuffer.handle : null);
        });
        return this;
    }
    setBuffer(location, buffer, accessor) {
        if (buffer.target === 34963) return this.setElementBuffer(buffer, accessor);
        const { size , type , stride , offset , normalized , integer , divisor  } = accessor;
        const { gl , gl2  } = this;
        location = Number(location);
        this.bind(()=>{
            gl.bindBuffer(34962, buffer.handle);
            if (integer) {
                (0, _assert.assert)((0, _gltools.isWebGL2)(gl));
                gl2.vertexAttribIPointer(location, size, type, stride, offset);
            } else gl.vertexAttribPointer(location, size, type, normalized, stride, offset);
            gl.enableVertexAttribArray(location);
            gl2.vertexAttribDivisor(location, divisor || 0);
        });
        return this;
    }
    enable(location) {
        let enable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        const disablingAttributeZero = !enable && location === 0 && !VertexArrayObject.isSupported(this.gl, {
            constantAttributeZero: true
        });
        if (!disablingAttributeZero) {
            location = Number(location);
            this.bind(()=>enable ? this.gl.enableVertexAttribArray(location) : this.gl.disableVertexAttribArray(location));
        }
        return this;
    }
    getConstantBuffer(elementCount, value) {
        const constantValue = this._normalizeConstantArrayValue(value);
        const byteLength = constantValue.byteLength * elementCount;
        const length = constantValue.length * elementCount;
        let updateNeeded = !this.buffer;
        this.buffer = this.buffer || new (0, _bufferDefault.default)(this.gl, byteLength);
        updateNeeded = updateNeeded || this.buffer.reallocate(byteLength);
        updateNeeded = updateNeeded || !this._compareConstantArrayValues(constantValue, this.bufferValue);
        if (updateNeeded) {
            const typedArray = (0, _arrayUtilsFlat.getScratchArray)(value.constructor, length);
            (0, _arrayUtilsFlat.fillArray)({
                target: typedArray,
                source: constantValue,
                start: 0,
                count: length
            });
            this.buffer.subData(typedArray);
            this.bufferValue = value;
        }
        return this.buffer;
    }
    _normalizeConstantArrayValue(arrayValue) {
        if (Array.isArray(arrayValue)) return new Float32Array(arrayValue);
        return arrayValue;
    }
    _compareConstantArrayValues(v1, v2) {
        if (!v1 || !v2 || v1.length !== v2.length || v1.constructor !== v2.constructor) return false;
        for(let i = 0; i < v1.length; ++i){
            if (v1[i] !== v2[i]) return false;
        }
        return true;
    }
    static _setConstantFloatArray(gl, location, array) {
        switch(array.length){
            case 1:
                gl.vertexAttrib1fv(location, array);
                break;
            case 2:
                gl.vertexAttrib2fv(location, array);
                break;
            case 3:
                gl.vertexAttrib3fv(location, array);
                break;
            case 4:
                gl.vertexAttrib4fv(location, array);
                break;
            default:
                (0, _assert.assert)(false);
        }
    }
    static _setConstantIntArray(gl, location, array) {
        (0, _assert.assert)((0, _gltools.isWebGL2)(gl));
        switch(array.length){
            case 1:
                gl.vertexAttribI1iv(location, array);
                break;
            case 2:
                gl.vertexAttribI2iv(location, array);
                break;
            case 3:
                gl.vertexAttribI3iv(location, array);
                break;
            case 4:
                gl.vertexAttribI4iv(location, array);
                break;
            default:
                (0, _assert.assert)(false);
        }
    }
    static _setConstantUintArray(gl, location, array) {
        (0, _assert.assert)((0, _gltools.isWebGL2)(gl));
        switch(array.length){
            case 1:
                gl.vertexAttribI1uiv(location, array);
                break;
            case 2:
                gl.vertexAttribI2uiv(location, array);
                break;
            case 3:
                gl.vertexAttribI3uiv(location, array);
                break;
            case 4:
                gl.vertexAttribI4uiv(location, array);
                break;
            default:
                (0, _assert.assert)(false);
        }
    }
    _createHandle() {
        const gl2 = this.gl;
        return gl2.createVertexArray();
    }
    _deleteHandle(handle) {
        this.gl2.deleteVertexArray(handle);
        return [
            this.elements
        ];
    }
    _bindHandle(handle) {
        this.gl2.bindVertexArray(handle);
    }
    _getParameter(pname, _ref) {
        let { location  } = _ref;
        (0, _assert.assert)(Number.isFinite(location));
        return this.bind(()=>{
            switch(pname){
                case 34373:
                    return this.gl.getVertexAttribOffset(location, pname);
                default:
                    return this.gl.getVertexAttrib(location, pname);
            }
        });
    }
}
exports.default = VertexArrayObject;

},{"./resource":"10MWq","./buffer":"4AGCy","@luma.gl/gltools":"aIkwg","../utils/array-utils-flat":"eypio","../utils/assert":"hxAMc","@probe.gl/env":"6dzgb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eypio":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getScratchArrayBuffer", ()=>getScratchArrayBuffer);
parcelHelpers.export(exports, "getScratchArray", ()=>getScratchArray);
parcelHelpers.export(exports, "fillArray", ()=>fillArray);
let arrayBuffer = null;
function getScratchArrayBuffer(byteLength) {
    if (!arrayBuffer || arrayBuffer.byteLength < byteLength) arrayBuffer = new ArrayBuffer(byteLength);
    return arrayBuffer;
}
function getScratchArray(Type, length) {
    const scratchArrayBuffer = getScratchArrayBuffer(Type.BYTES_PER_ELEMENT * length);
    return new Type(scratchArrayBuffer, 0, length);
}
function fillArray(_ref) {
    let { target , source , start =0 , count =1  } = _ref;
    const length = source.length;
    const total = count * length;
    let copied = 0;
    for(let i = start; copied < length; copied++)target[i++] = source[copied];
    while(copied < total)if (copied < total - copied) {
        target.copyWithin(start + copied, start, start + copied);
        copied *= 2;
    } else {
        target.copyWithin(start + copied, start, start + total - copied);
        copied = total;
    }
    return target;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cSPWF":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _accessor = require("./accessor");
var _accessorDefault = parcelHelpers.interopDefault(_accessor);
var _buffer = require("./buffer");
var _bufferDefault = parcelHelpers.interopDefault(_buffer);
var _vertexArrayObject = require("./vertex-array-object");
var _vertexArrayObjectDefault = parcelHelpers.interopDefault(_vertexArrayObject);
var _assert = require("../utils/assert");
var _stubMethods = require("../utils/stub-methods");
const ERR_ATTRIBUTE_TYPE = "VertexArray: attributes must be Buffers or constants (i.e. typed array)";
const MULTI_LOCATION_ATTRIBUTE_REGEXP = /^(.+)__LOCATION_([0-9]+)$/;
const DEPRECATIONS_V6 = [
    "setBuffers",
    "setGeneric",
    "clearBindings",
    "setLocations",
    "setGenericValues",
    "setDivisor",
    "enable",
    "disable"
];
class VertexArray {
    constructor(gl){
        let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        const id = opts.id || opts.program && opts.program.id;
        this.id = id;
        this.gl = gl;
        this.configuration = null;
        this.elements = null;
        this.elementsAccessor = null;
        this.values = null;
        this.accessors = null;
        this.unused = null;
        this.drawParams = null;
        this.buffer = null;
        this.attributes = {};
        this.vertexArrayObject = new (0, _vertexArrayObjectDefault.default)(gl);
        (0, _stubMethods.stubRemovedMethods)(this, "VertexArray", "v6.0", DEPRECATIONS_V6);
        this.initialize(opts);
        Object.seal(this);
    }
    delete() {
        if (this.buffer) this.buffer.delete();
        this.vertexArrayObject.delete();
    }
    initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this.reset();
        this.configuration = null;
        this.bindOnUse = false;
        return this.setProps(props);
    }
    reset() {
        this.elements = null;
        this.elementsAccessor = null;
        const { MAX_ATTRIBUTES  } = this.vertexArrayObject;
        this.values = new Array(MAX_ATTRIBUTES).fill(null);
        this.accessors = new Array(MAX_ATTRIBUTES).fill(null);
        this.unused = {};
        this.drawParams = null;
        return this;
    }
    setProps(props) {
        if ("program" in props) this.configuration = props.program && props.program.configuration;
        if ("configuration" in props) this.configuration = props.configuration;
        if ("attributes" in props) this.setAttributes(props.attributes);
        if ("elements" in props) this.setElementBuffer(props.elements);
        if ("bindOnUse" in props) props = props.bindOnUse;
        return this;
    }
    clearDrawParams() {
        this.drawParams = null;
    }
    getDrawParams() {
        this.drawParams = this.drawParams || this._updateDrawParams();
        return this.drawParams;
    }
    setAttributes(attributes) {
        Object.assign(this.attributes, attributes);
        this.vertexArrayObject.bind(()=>{
            for(const locationOrName in attributes){
                const value = attributes[locationOrName];
                this._setAttribute(locationOrName, value);
            }
            this.gl.bindBuffer(34962, null);
        });
        return this;
    }
    setElementBuffer() {
        let elementBuffer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        let accessor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        this.elements = elementBuffer;
        this.elementsAccessor = accessor;
        this.clearDrawParams();
        this.vertexArrayObject.setElementBuffer(elementBuffer, accessor);
        return this;
    }
    setBuffer(locationOrName, buffer) {
        let appAccessor = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        if (buffer.target === 34963) return this.setElementBuffer(buffer, appAccessor);
        const { location , accessor  } = this._resolveLocationAndAccessor(locationOrName, buffer, buffer.accessor, appAccessor);
        if (location >= 0) {
            this.values[location] = buffer;
            this.accessors[location] = accessor;
            this.clearDrawParams();
            this.vertexArrayObject.setBuffer(location, buffer, accessor);
        }
        return this;
    }
    setConstant(locationOrName, arrayValue) {
        let appAccessor = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
        const { location , accessor  } = this._resolveLocationAndAccessor(locationOrName, arrayValue, Object.assign({
            size: arrayValue.length
        }, appAccessor));
        if (location >= 0) {
            arrayValue = this.vertexArrayObject._normalizeConstantArrayValue(arrayValue);
            this.values[location] = arrayValue;
            this.accessors[location] = accessor;
            this.clearDrawParams();
            this.vertexArrayObject.enable(location, false);
        }
        return this;
    }
    unbindBuffers() {
        this.vertexArrayObject.bind(()=>{
            if (this.elements) this.vertexArrayObject.setElementBuffer(null);
            this.buffer = this.buffer || new (0, _bufferDefault.default)(this.gl, {
                accessor: {
                    size: 4
                }
            });
            for(let location = 0; location < this.vertexArrayObject.MAX_ATTRIBUTES; location++)if (this.values[location] instanceof (0, _bufferDefault.default)) {
                this.gl.disableVertexAttribArray(location);
                this.gl.bindBuffer(34962, this.buffer.handle);
                this.gl.vertexAttribPointer(location, 1, 5126, false, 0, 0);
            }
        });
        return this;
    }
    bindBuffers() {
        this.vertexArrayObject.bind(()=>{
            if (this.elements) this.setElementBuffer(this.elements);
            for(let location = 0; location < this.vertexArrayObject.MAX_ATTRIBUTES; location++){
                const buffer = this.values[location];
                if (buffer instanceof (0, _bufferDefault.default)) this.setBuffer(location, buffer);
            }
        });
        return this;
    }
    bindForDraw(vertexCount, instanceCount, func) {
        let value;
        this.vertexArrayObject.bind(()=>{
            this._setConstantAttributes(vertexCount, instanceCount);
            value = func();
        });
        return value;
    }
    _resolveLocationAndAccessor(locationOrName, value, valueAccessor, appAccessor) {
        const INVALID_RESULT = {
            location: -1,
            accessor: null
        };
        const { location , name  } = this._getAttributeIndex(locationOrName);
        if (!Number.isFinite(location) || location < 0) {
            this.unused[locationOrName] = value;
            (0, _gltools.log).once(3, ()=>"unused value ".concat(locationOrName, " in ").concat(this.id))();
            return INVALID_RESULT;
        }
        const accessInfo = this._getAttributeInfo(name || location);
        if (!accessInfo) return INVALID_RESULT;
        const currentAccessor = this.accessors[location] || {};
        const accessor = (0, _accessorDefault.default).resolve(accessInfo.accessor, currentAccessor, valueAccessor, appAccessor);
        const { size , type  } = accessor;
        (0, _assert.assert)(Number.isFinite(size) && Number.isFinite(type));
        return {
            location,
            accessor
        };
    }
    _getAttributeInfo(attributeName) {
        return this.configuration && this.configuration.getAttributeInfo(attributeName);
    }
    _getAttributeIndex(locationOrName) {
        const location = Number(locationOrName);
        if (Number.isFinite(location)) return {
            location
        };
        const multiLocation = MULTI_LOCATION_ATTRIBUTE_REGEXP.exec(locationOrName);
        const name = multiLocation ? multiLocation[1] : locationOrName;
        const locationOffset = multiLocation ? Number(multiLocation[2]) : 0;
        if (this.configuration) return {
            location: this.configuration.getAttributeLocation(name) + locationOffset,
            name
        };
        return {
            location: -1
        };
    }
    _setAttribute(locationOrName, value) {
        if (value instanceof (0, _bufferDefault.default)) this.setBuffer(locationOrName, value);
        else if (Array.isArray(value) && value.length && value[0] instanceof (0, _bufferDefault.default)) {
            const buffer = value[0];
            const accessor = value[1];
            this.setBuffer(locationOrName, buffer, accessor);
        } else if (ArrayBuffer.isView(value) || Array.isArray(value)) {
            const constant = value;
            this.setConstant(locationOrName, constant);
        } else if (value.buffer instanceof (0, _bufferDefault.default)) {
            const accessor1 = value;
            this.setBuffer(locationOrName, accessor1.buffer, accessor1);
        } else throw new Error(ERR_ATTRIBUTE_TYPE);
    }
    _setConstantAttributes(vertexCount, instanceCount) {
        const elementCount = Math.max(vertexCount | 0, instanceCount | 0);
        let constant = this.values[0];
        if (ArrayBuffer.isView(constant)) this._setConstantAttributeZero(constant, elementCount);
        for(let location = 1; location < this.vertexArrayObject.MAX_ATTRIBUTES; location++){
            constant = this.values[location];
            if (ArrayBuffer.isView(constant)) this._setConstantAttribute(location, constant);
        }
    }
    _setConstantAttributeZero(constant, elementCount) {
        if ((0, _vertexArrayObjectDefault.default).isSupported(this.gl, {
            constantAttributeZero: true
        })) {
            this._setConstantAttribute(0, constant);
            return;
        }
        const buffer = this.vertexArrayObject.getConstantBuffer(elementCount, constant);
        this.vertexArrayObject.setBuffer(0, buffer, this.accessors[0]);
    }
    _setConstantAttribute(location, constant) {
        (0, _vertexArrayObjectDefault.default).setConstant(this.gl, location, constant);
    }
    _updateDrawParams() {
        const drawParams = {
            isIndexed: false,
            isInstanced: false,
            indexCount: Infinity,
            vertexCount: Infinity,
            instanceCount: Infinity
        };
        for(let location = 0; location < this.vertexArrayObject.MAX_ATTRIBUTES; location++)this._updateDrawParamsForLocation(drawParams, location);
        if (this.elements) {
            drawParams.elementCount = this.elements.getElementCount(this.elements.accessor);
            drawParams.isIndexed = true;
            drawParams.indexType = this.elementsAccessor.type || this.elements.accessor.type;
            drawParams.indexOffset = this.elementsAccessor.offset || 0;
        }
        if (drawParams.indexCount === Infinity) drawParams.indexCount = 0;
        if (drawParams.vertexCount === Infinity) drawParams.vertexCount = 0;
        if (drawParams.instanceCount === Infinity) drawParams.instanceCount = 0;
        return drawParams;
    }
    _updateDrawParamsForLocation(drawParams, location) {
        const value = this.values[location];
        const accessor = this.accessors[location];
        if (!value) return;
        const { divisor  } = accessor;
        const isInstanced = divisor > 0;
        drawParams.isInstanced = drawParams.isInstanced || isInstanced;
        if (value instanceof (0, _bufferDefault.default)) {
            const buffer = value;
            if (isInstanced) {
                const instanceCount = buffer.getVertexCount(accessor);
                drawParams.instanceCount = Math.min(drawParams.instanceCount, instanceCount);
            } else {
                const vertexCount = buffer.getVertexCount(accessor);
                drawParams.vertexCount = Math.min(drawParams.vertexCount, vertexCount);
            }
        }
    }
    setElements() {
        let elementBuffer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        let accessor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        (0, _gltools.log).deprecated("setElements", "setElementBuffer")();
        return this.setElementBuffer(elementBuffer, accessor);
    }
}
exports.default = VertexArray;

},{"@luma.gl/gltools":"aIkwg","./accessor":"9zq2J","./buffer":"4AGCy","./vertex-array-object":"eO1Wv","../utils/assert":"hxAMc","../utils/stub-methods":"cgiTF","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kT0ac":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getDebugTableForUniforms", ()=>getDebugTableForUniforms);
var _assert = require("../utils/assert");
var _formatValue = require("../utils/format-value");
function getDebugTableForUniforms(_ref) {
    let { header ="Uniforms" , program , uniforms , undefinedOnly =false  } = _ref;
    (0, _assert.assert)(program);
    const SHADER_MODULE_UNIFORM_REGEXP = ".*_.*";
    const PROJECT_MODULE_UNIFORM_REGEXP = ".*Matrix";
    const uniformLocations = program._uniformSetters;
    const table = {};
    const uniformNames = Object.keys(uniformLocations).sort();
    let count = 0;
    for (const uniformName of uniformNames){
        if (!uniformName.match(SHADER_MODULE_UNIFORM_REGEXP) && !uniformName.match(PROJECT_MODULE_UNIFORM_REGEXP)) {
            if (addUniformToTable({
                table,
                header,
                uniforms,
                uniformName,
                undefinedOnly
            })) count++;
        }
    }
    for (const uniformName1 of uniformNames){
        if (uniformName1.match(PROJECT_MODULE_UNIFORM_REGEXP)) {
            if (addUniformToTable({
                table,
                header,
                uniforms,
                uniformName: uniformName1,
                undefinedOnly
            })) count++;
        }
    }
    for (const uniformName2 of uniformNames){
        if (!table[uniformName2]) {
            if (addUniformToTable({
                table,
                header,
                uniforms,
                uniformName: uniformName2,
                undefinedOnly
            })) count++;
        }
    }
    let unusedCount = 0;
    const unusedTable = {};
    if (!undefinedOnly) for(const uniformName3 in uniforms){
        const uniform = uniforms[uniformName3];
        if (!table[uniformName3]) {
            unusedCount++;
            unusedTable[uniformName3] = {
                Type: "NOT USED: ".concat(uniform),
                [header]: (0, _formatValue.formatValue)(uniform)
            };
        }
    }
    return {
        table,
        count,
        unusedTable,
        unusedCount
    };
}
function addUniformToTable(_ref2) {
    let { table , header , uniforms , uniformName , undefinedOnly  } = _ref2;
    const value = uniforms[uniformName];
    const isDefined = isUniformDefined(value);
    if (!undefinedOnly || !isDefined) {
        table[uniformName] = {
            [header]: isDefined ? (0, _formatValue.formatValue)(value) : "N/A",
            "Uniform Type": isDefined ? value : "NOT PROVIDED"
        };
        return true;
    }
    return false;
}
function isUniformDefined(value) {
    return value !== undefined && value !== null;
}

},{"../utils/assert":"hxAMc","../utils/format-value":"ey7gh","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ey7gh":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "formatValue", ()=>formatValue);
function formatArrayValue(v, opts) {
    const { maxElts =16 , size =1  } = opts;
    let string = "[";
    for(let i = 0; i < v.length && i < maxElts; ++i){
        if (i > 0) string += ",".concat(i % size === 0 ? " " : "");
        string += formatValue(v[i], opts);
    }
    const terminator = v.length > maxElts ? "..." : "]";
    return "".concat(string).concat(terminator);
}
function formatValue(v) {
    let opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    const EPSILON = 1e-16;
    const { isInteger =false  } = opts;
    if (Array.isArray(v) || ArrayBuffer.isView(v)) return formatArrayValue(v, opts);
    if (!Number.isFinite(v)) return String(v);
    if (Math.abs(v) < EPSILON) return isInteger ? "0" : "0.";
    if (isInteger) return v.toFixed(0);
    if (Math.abs(v) > 100 && Math.abs(v) < 10000) return v.toFixed(0);
    const string = v.toPrecision(2);
    const decimal = string.indexOf(".0");
    return decimal === string.length - 2 ? string.slice(0, -1) : string;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"l39Jz":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getDebugTableForVertexArray", ()=>getDebugTableForVertexArray);
var _buffer = require("../classes/buffer");
var _bufferDefault = parcelHelpers.interopDefault(_buffer);
var _constantsToKeys = require("../webgl-utils/constants-to-keys");
var _attributeUtils = require("../webgl-utils/attribute-utils");
var _formatValue = require("../utils/format-value");
function getDebugTableForVertexArray(_ref) {
    let { vertexArray , header ="Attributes"  } = _ref;
    if (!vertexArray.configuration) return {};
    const table = {};
    if (vertexArray.elements) table.ELEMENT_ARRAY_BUFFER = getDebugTableRow(vertexArray, vertexArray.elements, null, header);
    const attributes = vertexArray.values;
    for(const attributeLocation in attributes){
        const info = vertexArray._getAttributeInfo(attributeLocation);
        if (info) {
            let rowHeader = "".concat(attributeLocation, ": ").concat(info.name);
            const accessor = vertexArray.accessors[info.location];
            if (accessor) rowHeader = "".concat(attributeLocation, ": ").concat(getGLSLDeclaration(info.name, accessor));
            table[rowHeader] = getDebugTableRow(vertexArray, attributes[attributeLocation], accessor, header);
        }
    }
    return table;
}
function getDebugTableRow(vertexArray, attribute, accessor, header) {
    const { gl  } = vertexArray;
    if (!attribute) return {
        [header]: "null",
        "Format ": "N/A"
    };
    let type = "NOT PROVIDED";
    let size = 1;
    let verts = 0;
    let bytes = 0;
    let isInteger;
    let marker;
    let value;
    if (accessor) {
        type = accessor.type;
        size = accessor.size;
        type = String(type).replace("Array", "");
        isInteger = type.indexOf("nt") !== -1;
    }
    if (attribute instanceof (0, _bufferDefault.default)) {
        const buffer = attribute;
        const { data , changed  } = buffer.getDebugData();
        marker = changed ? "*" : "";
        value = data;
        bytes = buffer.byteLength;
        verts = bytes / data.BYTES_PER_ELEMENT / size;
        let format;
        if (accessor) {
            const instanced = accessor.divisor > 0;
            format = "".concat(instanced ? "I " : "P ", " ").concat(verts, " (x").concat(size, "=").concat(bytes, " bytes ").concat((0, _constantsToKeys.getKey)(gl, type), ")");
        } else {
            isInteger = true;
            format = "".concat(bytes, " bytes");
        }
        return {
            [header]: "".concat(marker).concat((0, _formatValue.formatValue)(value, {
                size,
                isInteger
            })),
            "Format ": format
        };
    }
    value = attribute;
    size = attribute.length;
    type = String(attribute.constructor.name).replace("Array", "");
    isInteger = type.indexOf("nt") !== -1;
    return {
        [header]: "".concat((0, _formatValue.formatValue)(value, {
            size,
            isInteger
        }), " (constant)"),
        "Format ": "".concat(size, "x").concat(type, " (constant)")
    };
}
function getGLSLDeclaration(name, accessor) {
    const { type , size  } = accessor;
    const typeAndName = (0, _attributeUtils.getCompositeGLType)(type, size);
    return typeAndName ? "".concat(name, " (").concat(typeAndName.name, ")") : name;
}

},{"../classes/buffer":"4AGCy","../webgl-utils/constants-to-keys":"9tmTY","../webgl-utils/attribute-utils":"1qYrw","../utils/format-value":"ey7gh","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ltF5l":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getDebugTableForProgramConfiguration", ()=>getDebugTableForProgramConfiguration);
var _attributeUtils = require("../webgl-utils/attribute-utils");
function getDebugTableForProgramConfiguration(config) {
    const table = {};
    const header = "Accessors for ".concat(config.id);
    for (const attributeInfo of config.attributeInfos)if (attributeInfo) {
        const glslDeclaration = getGLSLDeclaration(attributeInfo);
        table["in ".concat(glslDeclaration)] = {
            [header]: JSON.stringify(attributeInfo.accessor)
        };
    }
    for (const varyingInfo of config.varyingInfos)if (varyingInfo) {
        const glslDeclaration1 = getGLSLDeclaration(varyingInfo);
        table["out ".concat(glslDeclaration1)] = {
            [header]: JSON.stringify(varyingInfo.accessor)
        };
    }
    return table;
}
function getGLSLDeclaration(attributeInfo) {
    const { type , size  } = attributeInfo.accessor;
    const typeAndName = (0, _attributeUtils.getCompositeGLType)(type, size);
    if (typeAndName) return "".concat(typeAndName.name, " ").concat(attributeInfo.name);
    return attributeInfo.name;
}

},{"../webgl-utils/attribute-utils":"1qYrw","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6iaDa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "AnimationLoop", ()=>(0, _animationLoopDefault.default));
parcelHelpers.export(exports, "Model", ()=>(0, _modelDefault.default));
parcelHelpers.export(exports, "ProgramManager", ()=>(0, _programManagerDefault.default));
parcelHelpers.export(exports, "Transform", ()=>(0, _transformDefault.default));
parcelHelpers.export(exports, "Geometry", ()=>(0, _geometryDefault.default));
parcelHelpers.export(exports, "ConeGeometry", ()=>(0, _coneGeometryDefault.default));
parcelHelpers.export(exports, "CubeGeometry", ()=>(0, _cubeGeometryDefault.default));
parcelHelpers.export(exports, "CylinderGeometry", ()=>(0, _cylinderGeometryDefault.default));
parcelHelpers.export(exports, "IcoSphereGeometry", ()=>(0, _icoSphereGeometryDefault.default));
parcelHelpers.export(exports, "PlaneGeometry", ()=>(0, _planeGeometryDefault.default));
parcelHelpers.export(exports, "SphereGeometry", ()=>(0, _sphereGeometryDefault.default));
parcelHelpers.export(exports, "TruncatedConeGeometry", ()=>(0, _truncatedConeGeometryDefault.default));
parcelHelpers.export(exports, "Timeline", ()=>(0, _timeline.Timeline));
parcelHelpers.export(exports, "KeyFrames", ()=>(0, _keyFrames.KeyFrames));
parcelHelpers.export(exports, "ClipSpace", ()=>(0, _clipSpaceDefault.default));
var _animationLoop = require("./lib/animation-loop");
var _animationLoopDefault = parcelHelpers.interopDefault(_animationLoop);
var _model = require("./lib/model");
var _modelDefault = parcelHelpers.interopDefault(_model);
var _programManager = require("./lib/program-manager");
var _programManagerDefault = parcelHelpers.interopDefault(_programManager);
var _transform = require("./transform/transform");
var _transformDefault = parcelHelpers.interopDefault(_transform);
var _geometry = require("./geometry/geometry");
var _geometryDefault = parcelHelpers.interopDefault(_geometry);
var _coneGeometry = require("./geometries/cone-geometry");
var _coneGeometryDefault = parcelHelpers.interopDefault(_coneGeometry);
var _cubeGeometry = require("./geometries/cube-geometry");
var _cubeGeometryDefault = parcelHelpers.interopDefault(_cubeGeometry);
var _cylinderGeometry = require("./geometries/cylinder-geometry");
var _cylinderGeometryDefault = parcelHelpers.interopDefault(_cylinderGeometry);
var _icoSphereGeometry = require("./geometries/ico-sphere-geometry");
var _icoSphereGeometryDefault = parcelHelpers.interopDefault(_icoSphereGeometry);
var _planeGeometry = require("./geometries/plane-geometry");
var _planeGeometryDefault = parcelHelpers.interopDefault(_planeGeometry);
var _sphereGeometry = require("./geometries/sphere-geometry");
var _sphereGeometryDefault = parcelHelpers.interopDefault(_sphereGeometry);
var _truncatedConeGeometry = require("./geometries/truncated-cone-geometry");
var _truncatedConeGeometryDefault = parcelHelpers.interopDefault(_truncatedConeGeometry);
var _timeline = require("./animation/timeline");
var _keyFrames = require("./animation/key-frames");
var _clipSpace = require("./utils/clip-space");
var _clipSpaceDefault = parcelHelpers.interopDefault(_clipSpace);

},{"./lib/animation-loop":"c4u8M","./lib/model":"c1vGg","./lib/program-manager":"aPLH2","./transform/transform":"5Chqs","./geometry/geometry":"9lmbo","./geometries/cone-geometry":"7HyPx","./geometries/cube-geometry":"RwRbY","./geometries/cylinder-geometry":"hLuK9","./geometries/ico-sphere-geometry":"5FcTo","./geometries/plane-geometry":"jbb8n","./geometries/sphere-geometry":"83dKB","./geometries/truncated-cone-geometry":"8pvLP","./animation/timeline":"zJQUs","./animation/key-frames":false,"./utils/clip-space":"6xK7h","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"c4u8M":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _webgl = require("@luma.gl/webgl");
var _env = require("@probe.gl/env");
const isPage = (0, _env.isBrowser)() && typeof document !== "undefined";
let statIdCounter = 0;
class AnimationLoop {
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { onCreateContext =(opts)=>(0, _gltools.createGLContext)(opts) , onAddHTML =null , onInitialize =()=>{} , onRender =()=>{} , onFinalize =()=>{} , onError , gl =null , glOptions ={} , debug =false , createFramebuffer =false , autoResizeViewport =true , autoResizeDrawingBuffer =true , stats =(0, _webgl.lumaStats).get("animation-loop-".concat(statIdCounter++))  } = props;
        let { useDevicePixels =true  } = props;
        if ("useDevicePixelRatio" in props) {
            (0, _webgl.log).deprecated("useDevicePixelRatio", "useDevicePixels")();
            useDevicePixels = props.useDevicePixelRatio;
        }
        this.props = {
            onCreateContext,
            onAddHTML,
            onInitialize,
            onRender,
            onFinalize,
            onError,
            gl,
            glOptions,
            debug,
            createFramebuffer
        };
        this.gl = gl;
        this.needsRedraw = null;
        this.timeline = null;
        this.stats = stats;
        this.cpuTime = this.stats.get("CPU Time");
        this.gpuTime = this.stats.get("GPU Time");
        this.frameRate = this.stats.get("Frame Rate");
        this._initialized = false;
        this._running = false;
        this._animationFrameId = null;
        this._nextFramePromise = null;
        this._resolveNextFrame = null;
        this._cpuStartTime = 0;
        this.setProps({
            autoResizeViewport,
            autoResizeDrawingBuffer,
            useDevicePixels
        });
        this.start = this.start.bind(this);
        this.stop = this.stop.bind(this);
        this._pageLoadPromise = null;
        this._onMousemove = this._onMousemove.bind(this);
        this._onMouseleave = this._onMouseleave.bind(this);
    }
    delete() {
        this.stop();
        this._setDisplay(null);
    }
    setNeedsRedraw(reason) {
        (0, _webgl.assert)(typeof reason === "string");
        this.needsRedraw = this.needsRedraw || reason;
        return this;
    }
    setProps(props) {
        if ("autoResizeViewport" in props) this.autoResizeViewport = props.autoResizeViewport;
        if ("autoResizeDrawingBuffer" in props) this.autoResizeDrawingBuffer = props.autoResizeDrawingBuffer;
        if ("useDevicePixels" in props) this.useDevicePixels = props.useDevicePixels;
        return this;
    }
    start() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if (this._running) return this;
        this._running = true;
        const startPromise = this._getPageLoadPromise().then(()=>{
            if (!this._running || this._initialized) return null;
            this._createWebGLContext(opts);
            this._createFramebuffer();
            this._startEventHandling();
            this._initializeCallbackData();
            this._updateCallbackData();
            this._resizeCanvasDrawingBuffer();
            this._resizeViewport();
            this._gpuTimeQuery = (0, _webgl.Query).isSupported(this.gl, [
                "timers"
            ]) ? new (0, _webgl.Query)(this.gl) : null;
            this._initialized = true;
            return this.onInitialize(this.animationProps);
        }).then((appContext)=>{
            if (this._running) {
                this._addCallbackData(appContext || {});
                if (appContext !== false) this._startLoop();
            }
        });
        if (this.props.onError) startPromise.catch(this.props.onError);
        return this;
    }
    redraw() {
        if (this.isContextLost()) return this;
        this._beginTimers();
        this._setupFrame();
        this._updateCallbackData();
        this._renderFrame(this.animationProps);
        this._clearNeedsRedraw();
        if (this.offScreen && this.gl.commit) this.gl.commit();
        if (this._resolveNextFrame) {
            this._resolveNextFrame(this);
            this._nextFramePromise = null;
            this._resolveNextFrame = null;
        }
        this._endTimers();
        return this;
    }
    stop() {
        if (this._running) {
            this._finalizeCallbackData();
            this._cancelAnimationFrame(this._animationFrameId);
            this._nextFramePromise = null;
            this._resolveNextFrame = null;
            this._animationFrameId = null;
            this._running = false;
        }
        return this;
    }
    attachTimeline(timeline) {
        this.timeline = timeline;
        return this.timeline;
    }
    detachTimeline() {
        this.timeline = null;
    }
    waitForRender() {
        this.setNeedsRedraw("waitForRender");
        if (!this._nextFramePromise) this._nextFramePromise = new Promise((resolve)=>{
            this._resolveNextFrame = resolve;
        });
        return this._nextFramePromise;
    }
    async toDataURL() {
        this.setNeedsRedraw("toDataURL");
        await this.waitForRender();
        return this.gl.canvas.toDataURL();
    }
    isContextLost() {
        return this.gl.isContextLost();
    }
    onCreateContext() {
        return this.props.onCreateContext(...arguments);
    }
    onInitialize() {
        return this.props.onInitialize(...arguments);
    }
    onRender() {
        return this.props.onRender(...arguments);
    }
    onFinalize() {
        return this.props.onFinalize(...arguments);
    }
    getHTMLControlValue(id) {
        let defaultValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
        const element = document.getElementById(id);
        return element ? Number(element.value) : defaultValue;
    }
    setViewParameters() {
        (0, _webgl.log).removed("AnimationLoop.setViewParameters", "AnimationLoop.setProps")();
        return this;
    }
    _startLoop() {
        const renderFrame = ()=>{
            if (!this._running) return;
            this.redraw();
            this._animationFrameId = this._requestAnimationFrame(renderFrame);
        };
        this._cancelAnimationFrame(this._animationFrameId);
        this._animationFrameId = this._requestAnimationFrame(renderFrame);
    }
    _getPageLoadPromise() {
        if (!this._pageLoadPromise) this._pageLoadPromise = isPage ? new Promise((resolve, reject)=>{
            if (isPage && document.readyState === "complete") {
                resolve(document);
                return;
            }
            window.addEventListener("load", ()=>{
                resolve(document);
            });
        }) : Promise.resolve({});
        return this._pageLoadPromise;
    }
    _setDisplay(display) {
        if (this.display) {
            this.display.delete();
            this.display.animationLoop = null;
        }
        if (display) display.animationLoop = this;
        this.display = display;
    }
    _cancelAnimationFrame(animationFrameId) {
        if (this.display && this.display.cancelAnimationFrame) return this.display.cancelAnimationFrame(animationFrameId);
        return (0, _webgl.cancelAnimationFrame)(animationFrameId);
    }
    _requestAnimationFrame(renderFrameCallback) {
        if (this._running) {
            if (this.display && this.display.requestAnimationFrame) return this.display.requestAnimationFrame(renderFrameCallback);
            return (0, _webgl.requestAnimationFrame)(renderFrameCallback);
        }
        return undefined;
    }
    _renderFrame() {
        if (this.display) {
            this.display._renderFrame(...arguments);
            return;
        }
        this.onRender(...arguments);
    }
    _clearNeedsRedraw() {
        this.needsRedraw = null;
    }
    _setupFrame() {
        this._resizeCanvasDrawingBuffer();
        this._resizeViewport();
        this._resizeFramebuffer();
    }
    _initializeCallbackData() {
        this.animationProps = {
            gl: this.gl,
            stop: this.stop,
            canvas: this.gl.canvas,
            framebuffer: this.framebuffer,
            useDevicePixels: this.useDevicePixels,
            needsRedraw: null,
            startTime: Date.now(),
            engineTime: 0,
            tick: 0,
            tock: 0,
            time: 0,
            _timeline: this.timeline,
            _loop: this,
            _animationLoop: this,
            _mousePosition: null
        };
    }
    _updateCallbackData() {
        const { width , height , aspect  } = this._getSizeAndAspect();
        if (width !== this.animationProps.width || height !== this.animationProps.height) this.setNeedsRedraw("drawing buffer resized");
        if (aspect !== this.animationProps.aspect) this.setNeedsRedraw("drawing buffer aspect changed");
        this.animationProps.width = width;
        this.animationProps.height = height;
        this.animationProps.aspect = aspect;
        this.animationProps.needsRedraw = this.needsRedraw;
        this.animationProps.engineTime = Date.now() - this.animationProps.startTime;
        if (this.timeline) this.timeline.update(this.animationProps.engineTime);
        this.animationProps.tick = Math.floor(this.animationProps.time / 1000 * 60);
        this.animationProps.tock++;
        this.animationProps.time = this.timeline ? this.timeline.getTime() : this.animationProps.engineTime;
        this.animationProps._offScreen = this.offScreen;
    }
    _finalizeCallbackData() {
        this.onFinalize(this.animationProps);
    }
    _addCallbackData(appContext) {
        if (typeof appContext === "object" && appContext !== null) this.animationProps = Object.assign({}, this.animationProps, appContext);
    }
    _createWebGLContext(opts) {
        this.offScreen = opts.canvas && typeof OffscreenCanvas !== "undefined" && opts.canvas instanceof OffscreenCanvas;
        opts = Object.assign({}, opts, this.props.glOptions);
        this.gl = this.props.gl ? (0, _gltools.instrumentGLContext)(this.props.gl, opts) : this.onCreateContext(opts);
        if (!(0, _gltools.isWebGL)(this.gl)) throw new Error("AnimationLoop.onCreateContext - illegal context returned");
        (0, _gltools.resetParameters)(this.gl);
        this._createInfoDiv();
    }
    _createInfoDiv() {
        if (this.gl.canvas && this.props.onAddHTML) {
            const wrapperDiv = document.createElement("div");
            document.body.appendChild(wrapperDiv);
            wrapperDiv.style.position = "relative";
            const div = document.createElement("div");
            div.style.position = "absolute";
            div.style.left = "10px";
            div.style.bottom = "10px";
            div.style.width = "300px";
            div.style.background = "white";
            wrapperDiv.appendChild(this.gl.canvas);
            wrapperDiv.appendChild(div);
            const html = this.props.onAddHTML(div);
            if (html) div.innerHTML = html;
        }
    }
    _getSizeAndAspect() {
        const width = this.gl.drawingBufferWidth;
        const height = this.gl.drawingBufferHeight;
        let aspect = 1;
        const { canvas  } = this.gl;
        if (canvas && canvas.clientHeight) aspect = canvas.clientWidth / canvas.clientHeight;
        else if (width > 0 && height > 0) aspect = width / height;
        return {
            width,
            height,
            aspect
        };
    }
    _resizeViewport() {
        if (this.autoResizeViewport) this.gl.viewport(0, 0, this.gl.drawingBufferWidth, this.gl.drawingBufferHeight);
    }
    _resizeCanvasDrawingBuffer() {
        if (this.autoResizeDrawingBuffer) (0, _gltools.resizeGLContext)(this.gl, {
            useDevicePixels: this.useDevicePixels
        });
    }
    _createFramebuffer() {
        if (this.props.createFramebuffer) this.framebuffer = new (0, _webgl.Framebuffer)(this.gl);
    }
    _resizeFramebuffer() {
        if (this.framebuffer) this.framebuffer.resize({
            width: this.gl.drawingBufferWidth,
            height: this.gl.drawingBufferHeight
        });
    }
    _beginTimers() {
        this.frameRate.timeEnd();
        this.frameRate.timeStart();
        if (this._gpuTimeQuery && this._gpuTimeQuery.isResultAvailable() && !this._gpuTimeQuery.isTimerDisjoint()) this.stats.get("GPU Time").addTime(this._gpuTimeQuery.getTimerMilliseconds());
        if (this._gpuTimeQuery) this._gpuTimeQuery.beginTimeElapsedQuery();
        this.cpuTime.timeStart();
    }
    _endTimers() {
        this.cpuTime.timeEnd();
        if (this._gpuTimeQuery) this._gpuTimeQuery.end();
    }
    _startEventHandling() {
        const { canvas  } = this.gl;
        if (canvas) {
            canvas.addEventListener("mousemove", this._onMousemove);
            canvas.addEventListener("mouseleave", this._onMouseleave);
        }
    }
    _onMousemove(e) {
        this.animationProps._mousePosition = [
            e.offsetX,
            e.offsetY
        ];
    }
    _onMouseleave(e) {
        this.animationProps._mousePosition = null;
    }
}
exports.default = AnimationLoop;

},{"@luma.gl/gltools":"aIkwg","@luma.gl/webgl":"4LrGo","@probe.gl/env":"6dzgb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"c1vGg":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _programManager = require("./program-manager");
var _programManagerDefault = parcelHelpers.interopDefault(_programManager);
var _webgl = require("@luma.gl/webgl");
var _modelUtils = require("./model-utils");
const LOG_DRAW_PRIORITY = 2;
const LOG_DRAW_TIMEOUT = 10000;
const ERR_MODEL_PARAMS = "Model needs drawMode and vertexCount";
const NOOP = ()=>{};
const DRAW_PARAMS = {};
class Model {
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        const { id =(0, _webgl.uid)("model")  } = props;
        (0, _webgl.assert)((0, _gltools.isWebGL)(gl));
        this.id = id;
        this.gl = gl;
        this.id = props.id || (0, _webgl.uid)("Model");
        this.lastLogTime = 0;
        this.animated = false;
        this.initialize(props);
    }
    initialize(props) {
        this.props = {};
        this.programManager = props.programManager || (0, _programManagerDefault.default).getDefaultProgramManager(this.gl);
        this._programManagerState = -1;
        this._managedProgram = false;
        const { program =null , vs , fs , modules , defines , inject , varyings , bufferMode , transpileToGLSL100  } = props;
        this.programProps = {
            program,
            vs,
            fs,
            modules,
            defines,
            inject,
            varyings,
            bufferMode,
            transpileToGLSL100
        };
        this.program = null;
        this.vertexArray = null;
        this._programDirty = true;
        this.userData = {};
        this.needsRedraw = true;
        this._attributes = {};
        this.attributes = {};
        this.uniforms = {};
        this.pickable = true;
        this._checkProgram();
        this.setUniforms(Object.assign({}, this.getModuleUniforms(props.moduleSettings)));
        this.drawMode = props.drawMode !== undefined ? props.drawMode : 4;
        this.vertexCount = props.vertexCount || 0;
        this.geometryBuffers = {};
        this.isInstanced = props.isInstanced || props.instanced || props.instanceCount > 0;
        this._setModelProps(props);
        this.geometry = {};
        (0, _webgl.assert)(this.drawMode !== undefined && Number.isFinite(this.vertexCount), ERR_MODEL_PARAMS);
    }
    setProps(props) {
        this._setModelProps(props);
    }
    delete() {
        for(const key in this._attributes)if (this._attributes[key] !== this.attributes[key]) this._attributes[key].delete();
        if (this._managedProgram) {
            this.programManager.release(this.program);
            this._managedProgram = false;
        }
        this.vertexArray.delete();
        this._deleteGeometryBuffers();
    }
    getDrawMode() {
        return this.drawMode;
    }
    getVertexCount() {
        return this.vertexCount;
    }
    getInstanceCount() {
        return this.instanceCount;
    }
    getAttributes() {
        return this.attributes;
    }
    getProgram() {
        return this.program;
    }
    setProgram(props) {
        const { program , vs , fs , modules , defines , inject , varyings , bufferMode , transpileToGLSL100  } = props;
        this.programProps = {
            program,
            vs,
            fs,
            modules,
            defines,
            inject,
            varyings,
            bufferMode,
            transpileToGLSL100
        };
        this._programDirty = true;
    }
    getUniforms() {
        return this.uniforms;
    }
    setDrawMode(drawMode) {
        this.drawMode = drawMode;
        return this;
    }
    setVertexCount(vertexCount) {
        (0, _webgl.assert)(Number.isFinite(vertexCount));
        this.vertexCount = vertexCount;
        return this;
    }
    setInstanceCount(instanceCount) {
        (0, _webgl.assert)(Number.isFinite(instanceCount));
        this.instanceCount = instanceCount;
        return this;
    }
    setGeometry(geometry) {
        this.drawMode = geometry.drawMode;
        this.vertexCount = geometry.getVertexCount();
        this._deleteGeometryBuffers();
        this.geometryBuffers = (0, _modelUtils.getBuffersFromGeometry)(this.gl, geometry);
        this.vertexArray.setAttributes(this.geometryBuffers);
        return this;
    }
    setAttributes() {
        let attributes = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if ((0, _webgl.isObjectEmpty)(attributes)) return this;
        const normalizedAttributes = {};
        for(const name in attributes){
            const attribute = attributes[name];
            normalizedAttributes[name] = attribute.getValue ? attribute.getValue() : attribute;
        }
        this.vertexArray.setAttributes(normalizedAttributes);
        return this;
    }
    setUniforms() {
        let uniforms = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        Object.assign(this.uniforms, uniforms);
        return this;
    }
    getModuleUniforms(opts) {
        this._checkProgram();
        const getUniforms = this.programManager.getUniforms(this.program);
        if (getUniforms) return getUniforms(opts);
        return {};
    }
    updateModuleSettings(opts) {
        const uniforms = this.getModuleUniforms(opts || {});
        return this.setUniforms(uniforms);
    }
    clear(opts) {
        (0, _webgl.clear)(this.program.gl, opts);
        return this;
    }
    draw() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this._checkProgram();
        const { moduleSettings =null , framebuffer , uniforms ={} , attributes ={} , transformFeedback =this.transformFeedback , parameters ={} , vertexArray =this.vertexArray  } = opts;
        this.setAttributes(attributes);
        this.updateModuleSettings(moduleSettings);
        this.setUniforms(uniforms);
        let logPriority;
        if ((0, _webgl.log).priority >= LOG_DRAW_PRIORITY) logPriority = this._logDrawCallStart(LOG_DRAW_PRIORITY);
        const drawParams = this.vertexArray.getDrawParams();
        const { isIndexed =drawParams.isIndexed , indexType =drawParams.indexType , indexOffset =drawParams.indexOffset , vertexArrayInstanced =drawParams.isInstanced  } = this.props;
        if (vertexArrayInstanced && !this.isInstanced) (0, _webgl.log).warn("Found instanced attributes on non-instanced model", this.id)();
        const { isInstanced , instanceCount  } = this;
        const { onBeforeRender =NOOP , onAfterRender =NOOP  } = this.props;
        onBeforeRender();
        this.program.setUniforms(this.uniforms);
        const didDraw = this.program.draw(Object.assign(DRAW_PARAMS, opts, {
            logPriority,
            uniforms: null,
            framebuffer,
            parameters,
            drawMode: this.getDrawMode(),
            vertexCount: this.getVertexCount(),
            vertexArray,
            transformFeedback,
            isIndexed,
            indexType,
            isInstanced,
            instanceCount,
            offset: isIndexed ? indexOffset : 0
        }));
        onAfterRender();
        if ((0, _webgl.log).priority >= LOG_DRAW_PRIORITY) this._logDrawCallEnd(logPriority, vertexArray, framebuffer);
        return didDraw;
    }
    transform() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { discard =true , feedbackBuffers , unbindModels =[]  } = opts;
        let { parameters  } = opts;
        if (feedbackBuffers) this._setFeedbackBuffers(feedbackBuffers);
        if (discard) parameters = Object.assign({}, parameters, {
            [35977]: discard
        });
        unbindModels.forEach((model)=>model.vertexArray.unbindBuffers());
        try {
            this.draw(Object.assign({}, opts, {
                parameters
            }));
        } finally{
            unbindModels.forEach((model)=>model.vertexArray.bindBuffers());
        }
        return this;
    }
    render() {
        let uniforms = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        (0, _webgl.log).warn("Model.render() is deprecated. Use Model.setUniforms() and Model.draw()")();
        return this.setUniforms(uniforms).draw();
    }
    _setModelProps(props) {
        Object.assign(this.props, props);
        if ("uniforms" in props) this.setUniforms(props.uniforms);
        if ("pickable" in props) this.pickable = props.pickable;
        if ("instanceCount" in props) this.instanceCount = props.instanceCount;
        if ("geometry" in props) this.setGeometry(props.geometry);
        if ("attributes" in props) this.setAttributes(props.attributes);
        if ("_feedbackBuffers" in props) this._setFeedbackBuffers(props._feedbackBuffers);
    }
    _checkProgram() {
        const needsUpdate = this._programDirty || this.programManager.stateHash !== this._programManagerState;
        if (!needsUpdate) return;
        let { program  } = this.programProps;
        if (program) this._managedProgram = false;
        else {
            const { vs , fs , modules , inject , defines , varyings , bufferMode , transpileToGLSL100  } = this.programProps;
            program = this.programManager.get({
                vs,
                fs,
                modules,
                inject,
                defines,
                varyings,
                bufferMode,
                transpileToGLSL100
            });
            if (this.program && this._managedProgram) this.programManager.release(this.program);
            this._programManagerState = this.programManager.stateHash;
            this._managedProgram = true;
        }
        (0, _webgl.assert)(program instanceof (0, _webgl.Program), "Model needs a program");
        this._programDirty = false;
        if (program === this.program) return;
        this.program = program;
        if (this.vertexArray) this.vertexArray.setProps({
            program: this.program,
            attributes: this.vertexArray.attributes
        });
        else this.vertexArray = new (0, _webgl.VertexArray)(this.gl, {
            program: this.program
        });
        this.setUniforms(Object.assign({}, this.getModuleUniforms()));
    }
    _deleteGeometryBuffers() {
        for(const name in this.geometryBuffers){
            const buffer = this.geometryBuffers[name][0] || this.geometryBuffers[name];
            if (buffer instanceof (0, _webgl.Buffer)) buffer.delete();
        }
    }
    _setAnimationProps(animationProps) {
        if (this.animated) (0, _webgl.assert)(animationProps, "Model.draw(): animated uniforms but no animationProps");
    }
    _setFeedbackBuffers() {
        let feedbackBuffers = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if ((0, _webgl.isObjectEmpty)(feedbackBuffers)) return this;
        const { gl  } = this.program;
        this.transformFeedback = this.transformFeedback || new (0, _webgl.TransformFeedback)(gl, {
            program: this.program
        });
        this.transformFeedback.setBuffers(feedbackBuffers);
        return this;
    }
    _logDrawCallStart(logLevel) {
        const logDrawTimeout = logLevel > 3 ? 0 : LOG_DRAW_TIMEOUT;
        if (Date.now() - this.lastLogTime < logDrawTimeout) return undefined;
        this.lastLogTime = Date.now();
        (0, _webgl.log).group(LOG_DRAW_PRIORITY, ">>> DRAWING MODEL ".concat(this.id), {
            collapsed: (0, _webgl.log).level <= 2
        })();
        return logLevel;
    }
    _logDrawCallEnd(logLevel, vertexArray, uniforms, framebuffer) {
        if (logLevel === undefined) return;
        const attributeTable = (0, _webgl.getDebugTableForVertexArray)({
            vertexArray,
            header: "".concat(this.id, " attributes"),
            attributes: this._attributes
        });
        const { table: uniformTable , unusedTable , unusedCount  } = (0, _webgl.getDebugTableForUniforms)({
            header: "".concat(this.id, " uniforms"),
            program: this.program,
            uniforms: Object.assign({}, this.program.uniforms, uniforms)
        });
        const { table: missingTable , count: missingCount  } = (0, _webgl.getDebugTableForUniforms)({
            header: "".concat(this.id, " uniforms"),
            program: this.program,
            uniforms: Object.assign({}, this.program.uniforms, uniforms),
            undefinedOnly: true
        });
        if (missingCount > 0) (0, _webgl.log).log("MISSING UNIFORMS", Object.keys(missingTable))();
        if (unusedCount > 0) (0, _webgl.log).log("UNUSED UNIFORMS", Object.keys(unusedTable))();
        const configTable = (0, _webgl.getDebugTableForProgramConfiguration)(this.vertexArray.configuration);
        (0, _webgl.log).table(logLevel, attributeTable)();
        (0, _webgl.log).table(logLevel, uniformTable)();
        (0, _webgl.log).table(logLevel + 1, configTable)();
        if (framebuffer) framebuffer.log({
            logLevel: LOG_DRAW_PRIORITY,
            message: "Rendered to ".concat(framebuffer.id)
        });
        (0, _webgl.log).groupEnd(LOG_DRAW_PRIORITY)();
    }
}
exports.default = Model;

},{"@luma.gl/gltools":"aIkwg","./program-manager":"aPLH2","@luma.gl/webgl":"4LrGo","./model-utils":"1lANB","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aPLH2":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _shadertools = require("@luma.gl/shadertools");
var _webgl = require("@luma.gl/webgl");
class ProgramManager {
    static getDefaultProgramManager(gl) {
        gl.luma = gl.luma || {};
        gl.luma.defaultProgramManager = gl.luma.defaultProgramManager || new ProgramManager(gl);
        return gl.luma.defaultProgramManager;
    }
    constructor(gl){
        this.gl = gl;
        this._programCache = {};
        this._getUniforms = {};
        this._registeredModules = {};
        this._hookFunctions = [];
        this._defaultModules = [];
        this._hashes = {};
        this._hashCounter = 0;
        this.stateHash = 0;
        this._useCounts = {};
    }
    addDefaultModule(module) {
        if (!this._defaultModules.find((m)=>m.name === module.name)) this._defaultModules.push(module);
        this.stateHash++;
    }
    removeDefaultModule(module) {
        const moduleName = typeof module === "string" ? module : module.name;
        this._defaultModules = this._defaultModules.filter((m)=>m.name !== moduleName);
        this.stateHash++;
    }
    addShaderHook(hook, opts) {
        if (opts) hook = Object.assign(opts, {
            hook
        });
        this._hookFunctions.push(hook);
        this.stateHash++;
    }
    get() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { vs ="" , fs ="" , defines ={} , inject ={} , varyings =[] , bufferMode =0x8c8d , transpileToGLSL100 =false  } = props;
        const modules = this._getModuleList(props.modules);
        const vsHash = this._getHash(vs);
        const fsHash = this._getHash(fs);
        const moduleHashes = modules.map((m)=>this._getHash(m.name)).sort();
        const varyingHashes = varyings.map((v)=>this._getHash(v));
        const defineKeys = Object.keys(defines).sort();
        const injectKeys = Object.keys(inject).sort();
        const defineHashes = [];
        const injectHashes = [];
        for (const key of defineKeys){
            defineHashes.push(this._getHash(key));
            defineHashes.push(this._getHash(defines[key]));
        }
        for (const key1 of injectKeys){
            injectHashes.push(this._getHash(key1));
            injectHashes.push(this._getHash(inject[key1]));
        }
        const hash = "".concat(vsHash, "/").concat(fsHash, "D").concat(defineHashes.join("/"), "M").concat(moduleHashes.join("/"), "I").concat(injectHashes.join("/"), "V").concat(varyingHashes.join("/"), "H").concat(this.stateHash, "B").concat(bufferMode).concat(transpileToGLSL100 ? "T" : "");
        if (!this._programCache[hash]) {
            const assembled = (0, _shadertools.assembleShaders)(this.gl, {
                vs,
                fs,
                modules,
                inject,
                defines,
                hookFunctions: this._hookFunctions,
                transpileToGLSL100
            });
            this._programCache[hash] = new (0, _webgl.Program)(this.gl, {
                hash,
                vs: assembled.vs,
                fs: assembled.fs,
                varyings,
                bufferMode
            });
            this._getUniforms[hash] = assembled.getUniforms || ((x)=>{});
            this._useCounts[hash] = 0;
        }
        this._useCounts[hash]++;
        return this._programCache[hash];
    }
    getUniforms(program) {
        return this._getUniforms[program.hash] || null;
    }
    release(program) {
        const hash = program.hash;
        this._useCounts[hash]--;
        if (this._useCounts[hash] === 0) {
            this._programCache[hash].delete();
            delete this._programCache[hash];
            delete this._getUniforms[hash];
            delete this._useCounts[hash];
        }
    }
    _getHash(key) {
        if (this._hashes[key] === undefined) this._hashes[key] = this._hashCounter++;
        return this._hashes[key];
    }
    _getModuleList() {
        let appModules = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
        const modules = new Array(this._defaultModules.length + appModules.length);
        const seen = {};
        let count = 0;
        for(let i = 0, len = this._defaultModules.length; i < len; ++i){
            const module = this._defaultModules[i];
            const name = module.name;
            modules[count++] = module;
            seen[name] = true;
        }
        for(let i1 = 0, len1 = appModules.length; i1 < len1; ++i1){
            const module1 = appModules[i1];
            const name1 = module1.name;
            if (!seen[name1]) {
                modules[count++] = module1;
                seen[name1] = true;
            }
        }
        modules.length = count;
        return modules;
    }
}
exports.default = ProgramManager;

},{"@luma.gl/shadertools":"gjHNu","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gjHNu":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assembleShaders", ()=>(0, _assembleShaders.assembleShaders));
parcelHelpers.export(exports, "combineInjects", ()=>(0, _injectShader.combineInjects));
parcelHelpers.export(exports, "normalizeShaderModule", ()=>(0, _shaderModule.normalizeShaderModule));
parcelHelpers.export(exports, "getQualifierDetails", ()=>(0, _shaderUtils.getQualifierDetails));
parcelHelpers.export(exports, "getPassthroughFS", ()=>(0, _shaderUtils.getPassthroughFS));
parcelHelpers.export(exports, "typeToChannelSuffix", ()=>(0, _shaderUtils.typeToChannelSuffix));
parcelHelpers.export(exports, "typeToChannelCount", ()=>(0, _shaderUtils.typeToChannelCount));
parcelHelpers.export(exports, "convertToVec4", ()=>(0, _shaderUtils.convertToVec4));
var _assembleShaders = require("./lib/assemble-shaders");
var _injectShader = require("./lib/inject-shader");
var _shaderModule = require("./lib/shader-module");
var _shaderUtils = require("./utils/shader-utils");
var _modules = require("./modules");
parcelHelpers.exportAll(_modules, exports);

},{"./lib/assemble-shaders":"iFj6Q","./lib/inject-shader":"fBD1u","./lib/shader-module":"amWJH","./utils/shader-utils":"eBJqf","./modules":"3CpjF","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iFj6Q":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assembleShaders", ()=>assembleShaders);
var _constants = require("./constants");
var _resolveModules = require("./resolve-modules");
var _platformDefines = require("./platform-defines");
var _injectShader = require("./inject-shader");
var _injectShaderDefault = parcelHelpers.interopDefault(_injectShader);
var _transpileShader = require("./transpile-shader");
var _transpileShaderDefault = parcelHelpers.interopDefault(_transpileShader);
var _utils = require("../utils");
const INJECT_SHADER_DECLARATIONS = "\n\n".concat((0, _injectShader.DECLARATION_INJECT_MARKER), "\n\n");
const SHADER_TYPE = {
    [(0, _constants.VERTEX_SHADER)]: "vertex",
    [(0, _constants.FRAGMENT_SHADER)]: "fragment"
};
const FRAGMENT_SHADER_PROLOGUE = "precision highp float;\n\n";
function assembleShaders(gl, opts) {
    const { vs , fs  } = opts;
    const modules = (0, _resolveModules.resolveModules)(opts.modules || []);
    return {
        gl,
        vs: assembleShader(gl, Object.assign({}, opts, {
            source: vs,
            type: (0, _constants.VERTEX_SHADER),
            modules
        })),
        fs: assembleShader(gl, Object.assign({}, opts, {
            source: fs,
            type: (0, _constants.FRAGMENT_SHADER),
            modules
        })),
        getUniforms: assembleGetUniforms(modules)
    };
}
function assembleShader(gl, _ref) {
    let { id , source , type , modules , defines ={} , hookFunctions =[] , inject ={} , transpileToGLSL100 =false , prologue =true , log  } = _ref;
    (0, _utils.assert)(typeof source === "string", "shader source must be a string");
    const isVertex = type === (0, _constants.VERTEX_SHADER);
    const sourceLines = source.split("\n");
    let glslVersion = 100;
    let versionLine = "";
    let coreSource = source;
    if (sourceLines[0].indexOf("#version ") === 0) {
        glslVersion = 300;
        versionLine = sourceLines[0];
        coreSource = sourceLines.slice(1).join("\n");
    } else versionLine = "#version ".concat(glslVersion);
    const allDefines = {};
    modules.forEach((module)=>{
        Object.assign(allDefines, module.getDefines());
    });
    Object.assign(allDefines, defines);
    let assembledSource = prologue ? "".concat(versionLine, "\n").concat(getShaderName({
        id,
        source,
        type
    }), "\n").concat(getShaderType({
        type
    }), "\n").concat((0, _platformDefines.getPlatformShaderDefines)(gl), "\n").concat((0, _platformDefines.getVersionDefines)(gl, glslVersion, !isVertex), "\n").concat(getApplicationDefines(allDefines), "\n").concat(isVertex ? "" : FRAGMENT_SHADER_PROLOGUE, "\n") : "".concat(versionLine, "\n");
    const hookFunctionMap = normalizeHookFunctions(hookFunctions);
    const hookInjections = {};
    const declInjections = {};
    const mainInjections = {};
    for(const key in inject){
        const injection = typeof inject[key] === "string" ? {
            injection: inject[key],
            order: 0
        } : inject[key];
        const match = key.match(/^(v|f)s:(#)?([\w-]+)$/);
        if (match) {
            const hash = match[2];
            const name = match[3];
            if (hash) {
                if (name === "decl") declInjections[key] = [
                    injection
                ];
                else mainInjections[key] = [
                    injection
                ];
            } else hookInjections[key] = [
                injection
            ];
        } else mainInjections[key] = [
            injection
        ];
    }
    for (const module of modules){
        if (log) module.checkDeprecations(coreSource, log);
        const moduleSource = module.getModuleSource(type, glslVersion);
        assembledSource += moduleSource;
        const injections = module.injections[type];
        for(const key1 in injections){
            const match1 = key1.match(/^(v|f)s:#([\w-]+)$/);
            if (match1) {
                const name1 = match1[2];
                const injectionType = name1 === "decl" ? declInjections : mainInjections;
                injectionType[key1] = injectionType[key1] || [];
                injectionType[key1].push(injections[key1]);
            } else {
                hookInjections[key1] = hookInjections[key1] || [];
                hookInjections[key1].push(injections[key1]);
            }
        }
    }
    assembledSource += INJECT_SHADER_DECLARATIONS;
    assembledSource = (0, _injectShaderDefault.default)(assembledSource, type, declInjections);
    assembledSource += getHookFunctions(hookFunctionMap[type], hookInjections);
    assembledSource += coreSource;
    assembledSource = (0, _injectShaderDefault.default)(assembledSource, type, mainInjections);
    assembledSource = (0, _transpileShaderDefault.default)(assembledSource, transpileToGLSL100 ? 100 : glslVersion, isVertex);
    return assembledSource;
}
function assembleGetUniforms(modules) {
    return function getUniforms(opts) {
        const uniforms = {};
        for (const module of modules){
            const moduleUniforms = module.getUniforms(opts, uniforms);
            Object.assign(uniforms, moduleUniforms);
        }
        return uniforms;
    };
}
function getShaderType(_ref2) {
    let { type  } = _ref2;
    return "\n#define SHADER_TYPE_".concat(SHADER_TYPE[type].toUpperCase(), "\n");
}
function getShaderName(_ref3) {
    let { id , source , type  } = _ref3;
    const injectShaderName = id && typeof id === "string" && source.indexOf("SHADER_NAME") === -1;
    return injectShaderName ? "\n#define SHADER_NAME ".concat(id, "_").concat(SHADER_TYPE[type], "\n\n") : "";
}
function getApplicationDefines() {
    let defines = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    let count = 0;
    let sourceText = "";
    for(const define in defines){
        if (count === 0) sourceText += "\n// APPLICATION DEFINES\n";
        count++;
        const value = defines[define];
        if (value || Number.isFinite(value)) sourceText += "#define ".concat(define.toUpperCase(), " ").concat(defines[define], "\n");
    }
    if (count === 0) sourceText += "\n";
    return sourceText;
}
function getHookFunctions(hookFunctions, hookInjections) {
    let result = "";
    for(const hookName in hookFunctions){
        const hookFunction = hookFunctions[hookName];
        result += "void ".concat(hookFunction.signature, " {\n");
        if (hookFunction.header) result += "  ".concat(hookFunction.header);
        if (hookInjections[hookName]) {
            const injections = hookInjections[hookName];
            injections.sort((a, b)=>a.order - b.order);
            for (const injection of injections)result += "  ".concat(injection.injection, "\n");
        }
        if (hookFunction.footer) result += "  ".concat(hookFunction.footer);
        result += "}\n";
    }
    return result;
}
function normalizeHookFunctions(hookFunctions) {
    const result = {
        vs: {},
        fs: {}
    };
    hookFunctions.forEach((hook)=>{
        let opts;
        if (typeof hook !== "string") {
            opts = hook;
            hook = opts.hook;
        } else opts = {};
        hook = hook.trim();
        const [stage, signature] = hook.split(":");
        const name = hook.replace(/\(.+/, "");
        result[stage][name] = Object.assign(opts, {
            signature
        });
    });
    return result;
}

},{"./constants":"E0wy7","./resolve-modules":"82iM1","./platform-defines":"vSIes","./inject-shader":"fBD1u","./transpile-shader":"4tz9F","../utils":"2SLR6","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"E0wy7":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "VERTEX_SHADER", ()=>VERTEX_SHADER);
parcelHelpers.export(exports, "FRAGMENT_SHADER", ()=>FRAGMENT_SHADER);
const VERTEX_SHADER = "vs";
const FRAGMENT_SHADER = "fs";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"82iM1":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "resolveModules", ()=>resolveModules);
parcelHelpers.export(exports, "TEST_EXPORTS", ()=>TEST_EXPORTS);
var _shaderModule = require("./shader-module");
var _shaderModuleDefault = parcelHelpers.interopDefault(_shaderModule);
var _utils = require("../utils");
function resolveModules(modules) {
    return getShaderDependencies(instantiateModules(modules));
}
function getShaderDependencies(modules) {
    const moduleMap = {};
    const moduleDepth = {};
    getDependencyGraph({
        modules,
        level: 0,
        moduleMap,
        moduleDepth
    });
    return Object.keys(moduleDepth).sort((a, b)=>moduleDepth[b] - moduleDepth[a]).map((name)=>moduleMap[name]);
}
function getDependencyGraph(_ref) {
    let { modules , level , moduleMap , moduleDepth  } = _ref;
    if (level >= 5) throw new Error("Possible loop in shader dependency graph");
    for (const module of modules){
        moduleMap[module.name] = module;
        if (moduleDepth[module.name] === undefined || moduleDepth[module.name] < level) moduleDepth[module.name] = level;
    }
    for (const module1 of modules)if (module1.dependencies) getDependencyGraph({
        modules: module1.dependencies,
        level: level + 1,
        moduleMap,
        moduleDepth
    });
}
function instantiateModules(modules, seen) {
    return modules.map((module)=>{
        if (module instanceof (0, _shaderModuleDefault.default)) return module;
        (0, _utils.assert)(typeof module !== "string", "Shader module use by name is deprecated. Import shader module '".concat(module, "' and use it directly."));
        (0, _utils.assert)(module.name, "shader module has no name");
        module = new (0, _shaderModuleDefault.default)(module);
        module.dependencies = instantiateModules(module.dependencies);
        return module;
    });
}
const TEST_EXPORTS = {
    getShaderDependencies,
    getDependencyGraph
};

},{"./shader-module":"amWJH","../utils":"2SLR6","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"amWJH":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "normalizeShaderModule", ()=>normalizeShaderModule);
var _utils = require("../utils");
var _propTypes = require("./filters/prop-types");
const VERTEX_SHADER = "vs";
const FRAGMENT_SHADER = "fs";
class ShaderModule {
    constructor(_ref){
        let { name , vs , fs , dependencies =[] , uniforms , getUniforms , deprecations =[] , defines ={} , inject ={} , vertexShader , fragmentShader  } = _ref;
        (0, _utils.assert)(typeof name === "string");
        this.name = name;
        this.vs = vs || vertexShader;
        this.fs = fs || fragmentShader;
        this.getModuleUniforms = getUniforms;
        this.dependencies = dependencies;
        this.deprecations = this._parseDeprecationDefinitions(deprecations);
        this.defines = defines;
        this.injections = normalizeInjections(inject);
        if (uniforms) this.uniforms = (0, _propTypes.parsePropTypes)(uniforms);
    }
    getModuleSource(type) {
        let moduleSource;
        switch(type){
            case VERTEX_SHADER:
                moduleSource = this.vs || "";
                break;
            case FRAGMENT_SHADER:
                moduleSource = this.fs || "";
                break;
            default:
                (0, _utils.assert)(false);
        }
        return "#define MODULE_".concat(this.name.toUpperCase().replace(/[^0-9a-z]/gi, "_"), "\n").concat(moduleSource, "// END MODULE_").concat(this.name, "\n\n");
    }
    getUniforms(opts, uniforms) {
        if (this.getModuleUniforms) return this.getModuleUniforms(opts, uniforms);
        if (this.uniforms) return this._defaultGetUniforms(opts);
        return {};
    }
    getDefines() {
        return this.defines;
    }
    checkDeprecations(shaderSource, log) {
        this.deprecations.forEach((def)=>{
            if (def.regex.test(shaderSource)) {
                if (def.deprecated) log.deprecated(def.old, def.new)();
                else log.removed(def.old, def.new)();
            }
        });
    }
    _parseDeprecationDefinitions(deprecations) {
        deprecations.forEach((def)=>{
            switch(def.type){
                case "function":
                    def.regex = new RegExp("\\b".concat(def.old, "\\("));
                    break;
                default:
                    def.regex = new RegExp("".concat(def.type, " ").concat(def.old, ";"));
            }
        });
        return deprecations;
    }
    _defaultGetUniforms() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const uniforms = {};
        const propTypes = this.uniforms;
        for(const key in propTypes){
            const propDef = propTypes[key];
            if (key in opts && !propDef.private) {
                if (propDef.validate) (0, _utils.assert)(propDef.validate(opts[key], propDef), "".concat(this.name, ": invalid ").concat(key));
                uniforms[key] = opts[key];
            } else uniforms[key] = propDef.value;
        }
        return uniforms;
    }
}
exports.default = ShaderModule;
function normalizeShaderModule(module) {
    if (!module.normalized) {
        module.normalized = true;
        if (module.uniforms && !module.getUniforms) {
            const shaderModule = new ShaderModule(module);
            module.getUniforms = shaderModule.getUniforms.bind(shaderModule);
        }
    }
    return module;
}
function normalizeInjections(injections) {
    const result = {
        vs: {},
        fs: {}
    };
    for(const hook in injections){
        let injection = injections[hook];
        const stage = hook.slice(0, 2);
        if (typeof injection === "string") injection = {
            order: 0,
            injection
        };
        result[stage][hook] = injection;
    }
    return result;
}

},{"../utils":"2SLR6","./filters/prop-types":"aKSBB","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2SLR6":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "assert", ()=>(0, _assertDefault.default));
var _assert = require("./assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);

},{"./assert":"62Lad","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"62Lad":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function assert(condition, message) {
    if (!condition) throw new Error(message || "shadertools: assertion failed.");
}
exports.default = assert;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aKSBB":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "parsePropTypes", ()=>parsePropTypes);
const TYPE_DEFINITIONS = {
    number: {
        validate (value, propType) {
            return Number.isFinite(value) && (!("max" in propType) || value <= propType.max) && (!("min" in propType) || value >= propType.min);
        }
    },
    array: {
        validate (value, propType) {
            return Array.isArray(value) || ArrayBuffer.isView(value);
        }
    }
};
function parsePropTypes(propDefs) {
    const propTypes = {};
    for(const propName in propDefs){
        const propDef = propDefs[propName];
        const propType = parsePropType(propDef);
        propTypes[propName] = propType;
    }
    return propTypes;
}
function parsePropType(propDef) {
    let type = getTypeOf(propDef);
    if (type === "object") {
        if (!propDef) return {
            type: "object",
            value: null
        };
        if ("type" in propDef) return Object.assign({}, propDef, TYPE_DEFINITIONS[propDef.type]);
        if (!("value" in propDef)) return {
            type: "object",
            value: propDef
        };
        type = getTypeOf(propDef.value);
        return Object.assign({
            type
        }, propDef, TYPE_DEFINITIONS[type]);
    }
    return Object.assign({
        type,
        value: propDef
    }, TYPE_DEFINITIONS[type]);
}
function getTypeOf(value) {
    if (Array.isArray(value) || ArrayBuffer.isView(value)) return "array";
    return typeof value;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"vSIes":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getPlatformShaderDefines", ()=>getPlatformShaderDefines);
parcelHelpers.export(exports, "getVersionDefines", ()=>getVersionDefines);
var _webglInfo = require("../utils/webgl-info");
function getPlatformShaderDefines(gl) {
    const debugInfo = (0, _webglInfo.getContextInfo)(gl);
    switch(debugInfo.gpuVendor.toLowerCase()){
        case "nvidia":
            return "#define NVIDIA_GPU\n// Nvidia optimizes away the calculation necessary for emulated fp64\n#define LUMA_FP64_CODE_ELIMINATION_WORKAROUND 1\n";
        case "intel":
            return "#define INTEL_GPU\n// Intel optimizes away the calculation necessary for emulated fp64\n#define LUMA_FP64_CODE_ELIMINATION_WORKAROUND 1\n// Intel's built-in 'tan' function doesn't have acceptable precision\n#define LUMA_FP32_TAN_PRECISION_WORKAROUND 1\n// Intel GPU doesn't have full 32 bits precision in same cases, causes overflow\n#define LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND 1\n";
        case "amd":
            return "#define AMD_GPU\n";
        default:
            return "#define DEFAULT_GPU\n// Prevent driver from optimizing away the calculation necessary for emulated fp64\n#define LUMA_FP64_CODE_ELIMINATION_WORKAROUND 1\n// Intel's built-in 'tan' function doesn't have acceptable precision\n#define LUMA_FP32_TAN_PRECISION_WORKAROUND 1\n// Intel GPU doesn't have full 32 bits precision in same cases, causes overflow\n#define LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND 1\n";
    }
}
function getVersionDefines(gl, glslVersion, isFragment) {
    let versionDefines = "#if (__VERSION__ > 120)\n\n# define FEATURE_GLSL_DERIVATIVES\n# define FEATURE_GLSL_DRAW_BUFFERS\n# define FEATURE_GLSL_FRAG_DEPTH\n# define FEATURE_GLSL_TEXTURE_LOD\n\n// DEPRECATED FLAGS, remove in v9\n# define FRAG_DEPTH\n# define DERIVATIVES\n# define DRAW_BUFFERS\n# define TEXTURE_LOD\n\n#endif // __VERSION\n";
    if ((0, _webglInfo.hasFeatures)(gl, (0, _webglInfo.FEATURES).GLSL_FRAG_DEPTH)) versionDefines += "\n// FRAG_DEPTH => gl_FragDepth is available\n#ifdef GL_EXT_frag_depth\n#extension GL_EXT_frag_depth : enable\n# define FEATURE_GLSL_FRAG_DEPTH\n# define FRAG_DEPTH\n# define gl_FragDepth gl_FragDepthEXT\n#endif\n";
    if ((0, _webglInfo.hasFeatures)(gl, (0, _webglInfo.FEATURES).GLSL_DERIVATIVES) && (0, _webglInfo.canCompileGLGSExtension)(gl, (0, _webglInfo.FEATURES).GLSL_DERIVATIVES)) versionDefines += "\n// DERIVATIVES => dxdF, dxdY and fwidth are available\n#ifdef GL_OES_standard_derivatives\n#extension GL_OES_standard_derivatives : enable\n# define FEATURE_GLSL_DERIVATIVES\n# define DERIVATIVES\n#endif\n";
    if ((0, _webglInfo.hasFeatures)(gl, (0, _webglInfo.FEATURES).GLSL_FRAG_DATA) && (0, _webglInfo.canCompileGLGSExtension)(gl, (0, _webglInfo.FEATURES).GLSL_FRAG_DATA, {
        behavior: "require"
    })) versionDefines += "\n// DRAW_BUFFERS => gl_FragData[] is available\n#ifdef GL_EXT_draw_buffers\n#extension GL_EXT_draw_buffers : require\n#define FEATURE_GLSL_DRAW_BUFFERS\n#define DRAW_BUFFERS\n#endif\n";
    if ((0, _webglInfo.hasFeatures)(gl, (0, _webglInfo.FEATURES).GLSL_TEXTURE_LOD)) versionDefines += "// TEXTURE_LOD => texture2DLod etc are available\n#ifdef GL_EXT_shader_texture_lod\n#extension GL_EXT_shader_texture_lod : enable\n\n# define FEATURE_GLSL_TEXTURE_LOD\n# define TEXTURE_LOD\n\n#endif\n";
    return versionDefines;
}

},{"../utils/webgl-info":"aPmad","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aPmad":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "FEATURES", ()=>FEATURES);
parcelHelpers.export(exports, "getContextInfo", ()=>getContextInfo);
parcelHelpers.export(exports, "canCompileGLGSExtension", ()=>canCompileGLGSExtension);
parcelHelpers.export(exports, "hasFeatures", ()=>hasFeatures);
var _isOldIe = require("./is-old-ie");
var _isOldIeDefault = parcelHelpers.interopDefault(_isOldIe);
var _assert = require("./assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
const GL_VENDOR = 0x1f00;
const GL_RENDERER = 0x1f01;
const GL_VERSION = 0x1f02;
const GL_SHADING_LANGUAGE_VERSION = 0x8b8c;
const WEBGL_FEATURES = {
    GLSL_FRAG_DATA: [
        "WEBGL_draw_buffers",
        true
    ],
    GLSL_FRAG_DEPTH: [
        "EXT_frag_depth",
        true
    ],
    GLSL_DERIVATIVES: [
        "OES_standard_derivatives",
        true
    ],
    GLSL_TEXTURE_LOD: [
        "EXT_shader_texture_lod",
        true
    ]
};
const FEATURES = {};
Object.keys(WEBGL_FEATURES).forEach((key)=>{
    FEATURES[key] = key;
});
function isWebGL2(gl) {
    if (typeof WebGL2RenderingContext !== "undefined" && gl instanceof WebGL2RenderingContext) return true;
    return Boolean(gl && gl._version === 2);
}
function getContextInfo(gl) {
    const info = gl.getExtension("WEBGL_debug_renderer_info");
    const vendor = gl.getParameter(info && info.UNMASKED_VENDOR_WEBGL || GL_VENDOR);
    const renderer = gl.getParameter(info && info.UNMASKED_RENDERER_WEBGL || GL_RENDERER);
    const gpuVendor = identifyGPUVendor(vendor, renderer);
    const gpuInfo = {
        gpuVendor,
        vendor,
        renderer,
        version: gl.getParameter(GL_VERSION),
        shadingLanguageVersion: gl.getParameter(GL_SHADING_LANGUAGE_VERSION)
    };
    return gpuInfo;
}
function identifyGPUVendor(vendor, renderer) {
    if (vendor.match(/NVIDIA/i) || renderer.match(/NVIDIA/i)) return "NVIDIA";
    if (vendor.match(/INTEL/i) || renderer.match(/INTEL/i)) return "INTEL";
    if (vendor.match(/AMD/i) || renderer.match(/AMD/i) || vendor.match(/ATI/i) || renderer.match(/ATI/i)) return "AMD";
    return "UNKNOWN GPU";
}
const compiledGlslExtensions = {};
function canCompileGLGSExtension(gl, cap) {
    let opts = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    const feature = WEBGL_FEATURES[cap];
    (0, _assertDefault.default)(feature, cap);
    if (!(0, _isOldIeDefault.default)(opts)) return true;
    if (cap in compiledGlslExtensions) return compiledGlslExtensions[cap];
    const extensionName = feature[0];
    const behavior = opts.behavior || "enable";
    const source = "#extension GL_".concat(extensionName, " : ").concat(behavior, "\nvoid main(void) {}");
    const shader = gl.createShader(35633);
    gl.shaderSource(shader, source);
    gl.compileShader(shader);
    const canCompile = gl.getShaderParameter(shader, 35713);
    gl.deleteShader(shader);
    compiledGlslExtensions[cap] = canCompile;
    return canCompile;
}
function getFeature(gl, cap) {
    const feature = WEBGL_FEATURES[cap];
    (0, _assertDefault.default)(feature, cap);
    const extensionName = isWebGL2(gl) ? feature[1] || feature[0] : feature[0];
    const value = typeof extensionName === "string" ? Boolean(gl.getExtension(extensionName)) : extensionName;
    (0, _assertDefault.default)(value === false || value === true);
    return value;
}
function hasFeatures(gl, features) {
    features = Array.isArray(features) ? features : [
        features
    ];
    return features.every((feature)=>getFeature(gl, feature));
}

},{"./is-old-ie":"aKZrr","./assert":"62Lad","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aKZrr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function isOldIE() {
    let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    const navigator = typeof window !== "undefined" ? window.navigator || {} : {};
    const userAgent = opts.userAgent || navigator.userAgent || "";
    const isMSIE = userAgent.indexOf("MSIE ") !== -1;
    const isTrident = userAgent.indexOf("Trident/") !== -1;
    return isMSIE || isTrident;
}
exports.default = isOldIE;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fBD1u":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "DECLARATION_INJECT_MARKER", ()=>DECLARATION_INJECT_MARKER);
parcelHelpers.export(exports, "combineInjects", ()=>combineInjects);
var _moduleInjectors = require("../modules/module-injectors");
var _constants = require("./constants");
var _utils = require("../utils");
const MODULE_INJECTORS = {
    [(0, _constants.VERTEX_SHADER)]: (0, _moduleInjectors.MODULE_INJECTORS_VS),
    [(0, _constants.FRAGMENT_SHADER)]: (0, _moduleInjectors.MODULE_INJECTORS_FS)
};
const DECLARATION_INJECT_MARKER = "__LUMA_INJECT_DECLARATIONS__";
const REGEX_START_OF_MAIN = /void\s+main\s*\([^)]*\)\s*\{\n?/;
const REGEX_END_OF_MAIN = /}\n?[^{}]*$/;
const fragments = [];
function injectShader(source, type, inject) {
    let injectStandardStubs = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
    const isVertex = type === (0, _constants.VERTEX_SHADER);
    for(const key in inject){
        const fragmentData = inject[key];
        fragmentData.sort((a, b)=>a.order - b.order);
        fragments.length = fragmentData.length;
        for(let i = 0, len = fragmentData.length; i < len; ++i)fragments[i] = fragmentData[i].injection;
        const fragmentString = "".concat(fragments.join("\n"), "\n");
        switch(key){
            case "vs:#decl":
                if (isVertex) source = source.replace(DECLARATION_INJECT_MARKER, fragmentString);
                break;
            case "vs:#main-start":
                if (isVertex) source = source.replace(REGEX_START_OF_MAIN, (match)=>match + fragmentString);
                break;
            case "vs:#main-end":
                if (isVertex) source = source.replace(REGEX_END_OF_MAIN, (match)=>fragmentString + match);
                break;
            case "fs:#decl":
                if (!isVertex) source = source.replace(DECLARATION_INJECT_MARKER, fragmentString);
                break;
            case "fs:#main-start":
                if (!isVertex) source = source.replace(REGEX_START_OF_MAIN, (match)=>match + fragmentString);
                break;
            case "fs:#main-end":
                if (!isVertex) source = source.replace(REGEX_END_OF_MAIN, (match)=>fragmentString + match);
                break;
            default:
                source = source.replace(key, (match)=>match + fragmentString);
        }
    }
    source = source.replace(DECLARATION_INJECT_MARKER, "");
    if (injectStandardStubs) source = source.replace(/\}\s*$/, (match)=>match + MODULE_INJECTORS[type]);
    return source;
}
exports.default = injectShader;
function combineInjects(injects) {
    const result = {};
    (0, _utils.assert)(Array.isArray(injects) && injects.length > 1);
    injects.forEach((inject)=>{
        for(const key in inject)result[key] = result[key] ? "".concat(result[key], "\n").concat(inject[key]) : inject[key];
    });
    return result;
}

},{"../modules/module-injectors":"eIpwo","./constants":"E0wy7","../utils":"2SLR6","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eIpwo":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "MODULE_INJECTORS_VS", ()=>MODULE_INJECTORS_VS);
parcelHelpers.export(exports, "MODULE_INJECTORS_FS", ()=>MODULE_INJECTORS_FS);
const MODULE_INJECTORS_VS = "#ifdef MODULE_LOGDEPTH\n  logdepth_adjustPosition(gl_Position);\n#endif\n";
const MODULE_INJECTORS_FS = "#ifdef MODULE_MATERIAL\n  gl_FragColor = material_filterColor(gl_FragColor);\n#endif\n\n#ifdef MODULE_LIGHTING\n  gl_FragColor = lighting_filterColor(gl_FragColor);\n#endif\n\n#ifdef MODULE_FOG\n  gl_FragColor = fog_filterColor(gl_FragColor);\n#endif\n\n#ifdef MODULE_PICKING\n  gl_FragColor = picking_filterHighlightColor(gl_FragColor);\n  gl_FragColor = picking_filterPickingColor(gl_FragColor);\n#endif\n\n#ifdef MODULE_LOGDEPTH\n  logdepth_setFragDepth();\n#endif\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4tz9F":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function testVariable(qualifier) {
    return new RegExp("\\b".concat(qualifier, "[ \\t]+(\\w+[ \\t]+\\w+(\\[\\w+\\])?;)"), "g");
}
const ES300_REPLACEMENTS = [
    [
        /^(#version[ \t]+(100|300[ \t]+es))?[ \t]*\n/,
        "#version 300 es\n"
    ],
    [
        /\btexture(2D|2DProj|Cube)Lod(EXT)?\(/g,
        "textureLod("
    ],
    [
        /\btexture(2D|2DProj|Cube)(EXT)?\(/g,
        "texture("
    ]
];
const ES300_VERTEX_REPLACEMENTS = [
    ...ES300_REPLACEMENTS,
    [
        testVariable("attribute"),
        "in $1"
    ],
    [
        testVariable("varying"),
        "out $1"
    ]
];
const ES300_FRAGMENT_REPLACEMENTS = [
    ...ES300_REPLACEMENTS,
    [
        testVariable("varying"),
        "in $1"
    ]
];
const ES100_REPLACEMENTS = [
    [
        /^#version[ \t]+300[ \t]+es/,
        "#version 100"
    ],
    [
        /\btexture(2D|2DProj|Cube)Lod\(/g,
        "texture$1LodEXT("
    ],
    [
        /\btexture\(/g,
        "texture2D("
    ],
    [
        /\btextureLod\(/g,
        "texture2DLodEXT("
    ]
];
const ES100_VERTEX_REPLACEMENTS = [
    ...ES100_REPLACEMENTS,
    [
        testVariable("in"),
        "attribute $1"
    ],
    [
        testVariable("out"),
        "varying $1"
    ]
];
const ES100_FRAGMENT_REPLACEMENTS = [
    ...ES100_REPLACEMENTS,
    [
        testVariable("in"),
        "varying $1"
    ]
];
const ES100_FRAGMENT_OUTPUT_NAME = "gl_FragColor";
const ES300_FRAGMENT_OUTPUT_REGEX = /\bout[ \t]+vec4[ \t]+(\w+)[ \t]*;\n?/;
const REGEX_START_OF_MAIN = /void\s+main\s*\([^)]*\)\s*\{\n?/;
function transpileShader(source, targetGLSLVersion, isVertex) {
    switch(targetGLSLVersion){
        case 300:
            return isVertex ? convertShader(source, ES300_VERTEX_REPLACEMENTS) : convertFragmentShaderTo300(source);
        case 100:
            return isVertex ? convertShader(source, ES100_VERTEX_REPLACEMENTS) : convertFragmentShaderTo100(source);
        default:
            throw new Error("unknown GLSL version ".concat(targetGLSLVersion));
    }
}
exports.default = transpileShader;
function convertShader(source, replacements) {
    for (const [pattern, replacement] of replacements)source = source.replace(pattern, replacement);
    return source;
}
function convertFragmentShaderTo300(source) {
    source = convertShader(source, ES300_FRAGMENT_REPLACEMENTS);
    const outputMatch = source.match(ES300_FRAGMENT_OUTPUT_REGEX);
    if (outputMatch) {
        const outputName = outputMatch[1];
        source = source.replace(new RegExp("\\b".concat(ES100_FRAGMENT_OUTPUT_NAME, "\\b"), "g"), outputName);
    } else {
        const outputName1 = "fragmentColor";
        source = source.replace(REGEX_START_OF_MAIN, (match)=>"out vec4 ".concat(outputName1, ";\n").concat(match)).replace(new RegExp("\\b".concat(ES100_FRAGMENT_OUTPUT_NAME, "\\b"), "g"), outputName1);
    }
    return source;
}
function convertFragmentShaderTo100(source) {
    source = convertShader(source, ES100_FRAGMENT_REPLACEMENTS);
    const outputMatch = source.match(ES300_FRAGMENT_OUTPUT_REGEX);
    if (outputMatch) {
        const outputName = outputMatch[1];
        source = source.replace(ES300_FRAGMENT_OUTPUT_REGEX, "").replace(new RegExp("\\b".concat(outputName, "\\b"), "g"), ES100_FRAGMENT_OUTPUT_NAME);
    }
    return source;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eBJqf":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getQualifierDetails", ()=>getQualifierDetails);
parcelHelpers.export(exports, "getPassthroughFS", ()=>getPassthroughFS);
parcelHelpers.export(exports, "typeToChannelSuffix", ()=>typeToChannelSuffix);
parcelHelpers.export(exports, "typeToChannelCount", ()=>typeToChannelCount);
parcelHelpers.export(exports, "convertToVec4", ()=>convertToVec4);
var _utils = require("../utils");
const FS100 = "void main() {gl_FragColor = vec4(0);}";
const FS_GLES = "out vec4 transform_output;\nvoid main() {\n  transform_output = vec4(0);\n}";
const FS300 = "#version 300 es\n".concat(FS_GLES);
function getQualifierDetails(line, qualifiers) {
    qualifiers = Array.isArray(qualifiers) ? qualifiers : [
        qualifiers
    ];
    const words = line.replace(/^\s+/, "").split(/\s+/);
    const [qualifier, type, definition] = words;
    if (!qualifiers.includes(qualifier) || !type || !definition) return null;
    const name = definition.split(";")[0];
    return {
        qualifier,
        type,
        name
    };
}
function getPassthroughFS() {
    let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    const { version =100 , input , inputType , output  } = options;
    if (!input) {
        if (version === 300) return FS300;
        else if (version > 300) return "#version ".concat(version, "\n").concat(FS_GLES);
        return FS100;
    }
    const outputValue = convertToVec4(input, inputType);
    if (version >= 300) return "#version ".concat(version, " ").concat(version === 300 ? "es" : "", "\nin ").concat(inputType, " ").concat(input, ";\nout vec4 ").concat(output, ";\nvoid main() {\n  ").concat(output, " = ").concat(outputValue, ";\n}");
    return "varying ".concat(inputType, " ").concat(input, ";\nvoid main() {\n  gl_FragColor = ").concat(outputValue, ";\n}");
}
function typeToChannelSuffix(type) {
    switch(type){
        case "float":
            return "x";
        case "vec2":
            return "xy";
        case "vec3":
            return "xyz";
        case "vec4":
            return "xyzw";
        default:
            (0, _utils.assert)(false);
            return null;
    }
}
function typeToChannelCount(type) {
    switch(type){
        case "float":
            return 1;
        case "vec2":
            return 2;
        case "vec3":
            return 3;
        case "vec4":
            return 4;
        default:
            (0, _utils.assert)(false);
            return null;
    }
}
function convertToVec4(variable, type) {
    switch(type){
        case "float":
            return "vec4(".concat(variable, ", 0.0, 0.0, 1.0)");
        case "vec2":
            return "vec4(".concat(variable, ", 0.0, 1.0)");
        case "vec3":
            return "vec4(".concat(variable, ", 1.0)");
        case "vec4":
            return variable;
        default:
            (0, _utils.assert)(false);
            return null;
    }
}

},{"../utils":"2SLR6","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3CpjF":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "random", ()=>(0, _random.random));
parcelHelpers.export(exports, "fp32", ()=>(0, _fp32.fp32));
parcelHelpers.export(exports, "fp64", ()=>(0, _fp64.fp64));
parcelHelpers.export(exports, "fp64arithmetic", ()=>(0, _fp64.fp64arithmetic));
parcelHelpers.export(exports, "project", ()=>(0, _project.project));
parcelHelpers.export(exports, "lights", ()=>(0, _lights.lights));
parcelHelpers.export(exports, "dirlight", ()=>(0, _dirlight.dirlight));
parcelHelpers.export(exports, "picking", ()=>(0, _picking.picking));
parcelHelpers.export(exports, "gouraudLighting", ()=>(0, _phongLighting.gouraudLighting));
parcelHelpers.export(exports, "phongLighting", ()=>(0, _phongLighting.phongLighting));
parcelHelpers.export(exports, "pbr", ()=>(0, _pbr.pbr));
parcelHelpers.export(exports, "tiltShift", ()=>(0, _tiltshift.tiltShift));
parcelHelpers.export(exports, "triangleBlur", ()=>(0, _triangleblur.triangleBlur));
parcelHelpers.export(exports, "zoomBlur", ()=>(0, _zoomblur.zoomBlur));
parcelHelpers.export(exports, "brightnessContrast", ()=>(0, _brightnesscontrast.brightnessContrast));
parcelHelpers.export(exports, "denoise", ()=>(0, _denoise.denoise));
parcelHelpers.export(exports, "hueSaturation", ()=>(0, _huesaturation.hueSaturation));
parcelHelpers.export(exports, "noise", ()=>(0, _noise.noise));
parcelHelpers.export(exports, "sepia", ()=>(0, _sepia.sepia));
parcelHelpers.export(exports, "vibrance", ()=>(0, _vibrance.vibrance));
parcelHelpers.export(exports, "vignette", ()=>(0, _vignette.vignette));
parcelHelpers.export(exports, "colorHalftone", ()=>(0, _colorhalftone.colorHalftone));
parcelHelpers.export(exports, "dotScreen", ()=>(0, _dotscreen.dotScreen));
parcelHelpers.export(exports, "edgeWork", ()=>(0, _edgework.edgeWork));
parcelHelpers.export(exports, "hexagonalPixelate", ()=>(0, _hexagonalpixelate.hexagonalPixelate));
parcelHelpers.export(exports, "ink", ()=>(0, _ink.ink));
parcelHelpers.export(exports, "magnify", ()=>(0, _magnify.magnify));
parcelHelpers.export(exports, "bulgePinch", ()=>(0, _bulgepinch.bulgePinch));
parcelHelpers.export(exports, "swirl", ()=>(0, _swirl.swirl));
parcelHelpers.export(exports, "_warp", ()=>(0, _warp.warp));
parcelHelpers.export(exports, "fxaa", ()=>(0, _fxaa.fxaa));
parcelHelpers.export(exports, "_transform", ()=>(0, _transform.transform));
var _random = require("./utils/random");
var _fp32 = require("./fp32/fp32");
var _fp64 = require("./fp64/fp64");
var _project = require("./project/project");
var _lights = require("./lights/lights");
var _dirlight = require("./dirlight/dirlight");
var _picking = require("./picking/picking");
var _phongLighting = require("./phong-lighting/phong-lighting");
var _pbr = require("./pbr/pbr");
var _tiltshift = require("./image-blur-filters/tiltshift");
var _triangleblur = require("./image-blur-filters/triangleblur");
var _zoomblur = require("./image-blur-filters/zoomblur");
var _brightnesscontrast = require("./image-adjust-filters/brightnesscontrast");
var _denoise = require("./image-adjust-filters/denoise");
var _huesaturation = require("./image-adjust-filters/huesaturation");
var _noise = require("./image-adjust-filters/noise");
var _sepia = require("./image-adjust-filters/sepia");
var _vibrance = require("./image-adjust-filters/vibrance");
var _vignette = require("./image-adjust-filters/vignette");
var _colorhalftone = require("./image-fun-filters/colorhalftone");
var _dotscreen = require("./image-fun-filters/dotscreen");
var _edgework = require("./image-fun-filters/edgework");
var _hexagonalpixelate = require("./image-fun-filters/hexagonalpixelate");
var _ink = require("./image-fun-filters/ink");
var _magnify = require("./image-fun-filters/magnify");
var _bulgepinch = require("./image-warp-filters/bulgepinch");
var _swirl = require("./image-warp-filters/swirl");
var _warp = require("./image-warp-filters/warp");
var _fxaa = require("./fxaa/fxaa");
var _transform = require("./transform/transform");

},{"./utils/random":"lhPZ4","./fp32/fp32":"cssvr","./fp64/fp64":"gtYy0","./project/project":"jONjt","./lights/lights":"2v2Vq","./dirlight/dirlight":"8Cm8q","./picking/picking":"jsGMU","./phong-lighting/phong-lighting":"3Xd78","./pbr/pbr":"f4RB5","./image-blur-filters/tiltshift":"2B8mr","./image-blur-filters/triangleblur":"ksAUs","./image-blur-filters/zoomblur":"2JrTC","./image-adjust-filters/brightnesscontrast":"ir07h","./image-adjust-filters/denoise":"4arBl","./image-adjust-filters/huesaturation":"5z1Vn","./image-adjust-filters/noise":"efiao","./image-adjust-filters/sepia":"krRgM","./image-adjust-filters/vibrance":"dqh9o","./image-adjust-filters/vignette":"9BTzl","./image-fun-filters/colorhalftone":"i1TAR","./image-fun-filters/dotscreen":"kcU0w","./image-fun-filters/edgework":"j4pQB","./image-fun-filters/hexagonalpixelate":"8KJrY","./image-fun-filters/ink":"jAVQk","./image-fun-filters/magnify":"03d3X","./image-warp-filters/bulgepinch":"ixaLj","./image-warp-filters/swirl":"lORrW","./image-warp-filters/warp":"eXtFG","./fxaa/fxaa":"51fcg","./transform/transform":"i8ZK9","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lhPZ4":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "random", ()=>random);
const fs = "float random(vec3 scale, float seed) {\n  return fract(sin(dot(gl_FragCoord.xyz + seed, scale)) * 43758.5453 + seed);\n}\n";
const random = {
    name: "random",
    fs
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cssvr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "fp32", ()=>fp32);
const fp32shader = "#ifdef LUMA_FP32_TAN_PRECISION_WORKAROUND\nconst float TWO_PI = 6.2831854820251465;\nconst float PI_2 = 1.5707963705062866;\nconst float PI_16 = 0.1963495463132858;\n\nconst float SIN_TABLE_0 = 0.19509032368659973;\nconst float SIN_TABLE_1 = 0.3826834261417389;\nconst float SIN_TABLE_2 = 0.5555702447891235;\nconst float SIN_TABLE_3 = 0.7071067690849304;\n\nconst float COS_TABLE_0 = 0.9807852506637573;\nconst float COS_TABLE_1 = 0.9238795042037964;\nconst float COS_TABLE_2 = 0.8314695954322815;\nconst float COS_TABLE_3 = 0.7071067690849304;\n\nconst float INVERSE_FACTORIAL_3 = 1.666666716337204e-01;\nconst float INVERSE_FACTORIAL_5 = 8.333333767950535e-03;\nconst float INVERSE_FACTORIAL_7 = 1.9841270113829523e-04;\nconst float INVERSE_FACTORIAL_9 = 2.75573188446287533e-06;\n\nfloat sin_taylor_fp32(float a) {\n  float r, s, t, x;\n\n  if (a == 0.0) {\n    return 0.0;\n  }\n\n  x = -a * a;\n  s = a;\n  r = a;\n\n  r = r * x;\n  t = r * INVERSE_FACTORIAL_3;\n  s = s + t;\n\n  r = r * x;\n  t = r * INVERSE_FACTORIAL_5;\n  s = s + t;\n\n  r = r * x;\n  t = r * INVERSE_FACTORIAL_7;\n  s = s + t;\n\n  r = r * x;\n  t = r * INVERSE_FACTORIAL_9;\n  s = s + t;\n\n  return s;\n}\n\nvoid sincos_taylor_fp32(float a, out float sin_t, out float cos_t) {\n  if (a == 0.0) {\n    sin_t = 0.0;\n    cos_t = 1.0;\n  }\n  sin_t = sin_taylor_fp32(a);\n  cos_t = sqrt(1.0 - sin_t * sin_t);\n}\n\nfloat tan_taylor_fp32(float a) {\n    float sin_a;\n    float cos_a;\n\n    if (a == 0.0) {\n        return 0.0;\n    }\n    float z = floor(a / TWO_PI);\n    float r = a - TWO_PI * z;\n\n    float t;\n    float q = floor(r / PI_2 + 0.5);\n    int j = int(q);\n\n    if (j < -2 || j > 2) {\n        return 1.0 / 0.0;\n    }\n\n    t = r - PI_2 * q;\n\n    q = floor(t / PI_16 + 0.5);\n    int k = int(q);\n    int abs_k = int(abs(float(k)));\n\n    if (abs_k > 4) {\n        return 1.0 / 0.0;\n    } else {\n        t = t - PI_16 * q;\n    }\n\n    float u = 0.0;\n    float v = 0.0;\n\n    float sin_t, cos_t;\n    float s, c;\n    sincos_taylor_fp32(t, sin_t, cos_t);\n\n    if (k == 0) {\n        s = sin_t;\n        c = cos_t;\n    } else {\n        if (abs(float(abs_k) - 1.0) < 0.5) {\n            u = COS_TABLE_0;\n            v = SIN_TABLE_0;\n        } else if (abs(float(abs_k) - 2.0) < 0.5) {\n            u = COS_TABLE_1;\n            v = SIN_TABLE_1;\n        } else if (abs(float(abs_k) - 3.0) < 0.5) {\n            u = COS_TABLE_2;\n            v = SIN_TABLE_2;\n        } else if (abs(float(abs_k) - 4.0) < 0.5) {\n            u = COS_TABLE_3;\n            v = SIN_TABLE_3;\n        }\n        if (k > 0) {\n            s = u * sin_t + v * cos_t;\n            c = u * cos_t - v * sin_t;\n        } else {\n            s = u * sin_t - v * cos_t;\n            c = u * cos_t + v * sin_t;\n        }\n    }\n\n    if (j == 0) {\n        sin_a = s;\n        cos_a = c;\n    } else if (j == 1) {\n        sin_a = c;\n        cos_a = -s;\n    } else if (j == -1) {\n        sin_a = -c;\n        cos_a = s;\n    } else {\n        sin_a = -s;\n        cos_a = -c;\n    }\n    return sin_a / cos_a;\n}\n#endif\n\nfloat tan_fp32(float a) {\n#ifdef LUMA_FP32_TAN_PRECISION_WORKAROUND\n  return tan_taylor_fp32(a);\n#else\n  return tan(a);\n#endif\n}\n";
const fp32 = {
    name: "fp32",
    vs: fp32shader,
    fs: null
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gtYy0":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "fp64ify", ()=>(0, _fp64Utils.fp64ify));
parcelHelpers.export(exports, "fp64LowPart", ()=>(0, _fp64Utils.fp64LowPart));
parcelHelpers.export(exports, "fp64ifyMatrix4", ()=>(0, _fp64Utils.fp64ifyMatrix4));
parcelHelpers.export(exports, "fp64arithmetic", ()=>fp64arithmetic);
parcelHelpers.export(exports, "fp64", ()=>fp64);
var _fp64Utils = require("./fp64-utils");
var _fp64ArithmeticGlsl = require("./fp64-arithmetic.glsl");
var _fp64ArithmeticGlslDefault = parcelHelpers.interopDefault(_fp64ArithmeticGlsl);
var _fp64FunctionsGlsl = require("./fp64-functions.glsl");
var _fp64FunctionsGlslDefault = parcelHelpers.interopDefault(_fp64FunctionsGlsl);
const CONST_UNIFORMS = {
    ONE: 1.0
};
function getUniforms() {
    return CONST_UNIFORMS;
}
const fp64arithmetic = {
    name: "fp64-arithmetic",
    vs: (0, _fp64ArithmeticGlslDefault.default),
    fs: null,
    getUniforms,
    fp64ify: (0, _fp64Utils.fp64ify),
    fp64LowPart: (0, _fp64Utils.fp64LowPart),
    fp64ifyMatrix4: (0, _fp64Utils.fp64ifyMatrix4)
};
const fp64 = {
    name: "fp64",
    vs: (0, _fp64FunctionsGlslDefault.default),
    fs: null,
    dependencies: [
        fp64arithmetic
    ],
    fp64ify: (0, _fp64Utils.fp64ify),
    fp64LowPart: (0, _fp64Utils.fp64LowPart),
    fp64ifyMatrix4: (0, _fp64Utils.fp64ifyMatrix4)
};

},{"./fp64-utils":"8Wlsv","./fp64-arithmetic.glsl":"04e6K","./fp64-functions.glsl":"cSr6b","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8Wlsv":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "fp64ify", ()=>fp64ify);
parcelHelpers.export(exports, "fp64LowPart", ()=>fp64LowPart);
parcelHelpers.export(exports, "fp64ifyMatrix4", ()=>fp64ifyMatrix4);
function fp64ify(a) {
    let out = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    let startIndex = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
    const hiPart = Math.fround(a);
    const loPart = a - hiPart;
    out[startIndex] = hiPart;
    out[startIndex + 1] = loPart;
    return out;
}
function fp64LowPart(a) {
    return a - Math.fround(a);
}
function fp64ifyMatrix4(matrix) {
    const matrixFP64 = new Float32Array(32);
    for(let i = 0; i < 4; ++i)for(let j = 0; j < 4; ++j){
        const index = i * 4 + j;
        fp64ify(matrix[j * 4 + i], matrixFP64, index * 2);
    }
    return matrixFP64;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"04e6K":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "uniform float ONE;\nvec2 split(float a) {\n  const float SPLIT = 4097.0;\n  float t = a * SPLIT;\n#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)\n  float a_hi = t * ONE - (t - a);\n  float a_lo = a * ONE - a_hi;\n#else\n  float a_hi = t - (t - a);\n  float a_lo = a - a_hi;\n#endif\n  return vec2(a_hi, a_lo);\n}\nvec2 split2(vec2 a) {\n  vec2 b = split(a.x);\n  b.y += a.y;\n  return b;\n}\nvec2 quickTwoSum(float a, float b) {\n#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)\n  float sum = (a + b) * ONE;\n  float err = b - (sum - a) * ONE;\n#else\n  float sum = a + b;\n  float err = b - (sum - a);\n#endif\n  return vec2(sum, err);\n}\nvec2 twoSum(float a, float b) {\n  float s = (a + b);\n#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)\n  float v = (s * ONE - a) * ONE;\n  float err = (a - (s - v) * ONE) * ONE * ONE * ONE + (b - v);\n#else\n  float v = s - a;\n  float err = (a - (s - v)) + (b - v);\n#endif\n  return vec2(s, err);\n}\n\nvec2 twoSub(float a, float b) {\n  float s = (a - b);\n#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)\n  float v = (s * ONE - a) * ONE;\n  float err = (a - (s - v) * ONE) * ONE * ONE * ONE - (b + v);\n#else\n  float v = s - a;\n  float err = (a - (s - v)) - (b + v);\n#endif\n  return vec2(s, err);\n}\n\nvec2 twoSqr(float a) {\n  float prod = a * a;\n  vec2 a_fp64 = split(a);\n#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)\n  float err = ((a_fp64.x * a_fp64.x - prod) * ONE + 2.0 * a_fp64.x *\n    a_fp64.y * ONE * ONE) + a_fp64.y * a_fp64.y * ONE * ONE * ONE;\n#else\n  float err = ((a_fp64.x * a_fp64.x - prod) + 2.0 * a_fp64.x * a_fp64.y) + a_fp64.y * a_fp64.y;\n#endif\n  return vec2(prod, err);\n}\n\nvec2 twoProd(float a, float b) {\n  float prod = a * b;\n  vec2 a_fp64 = split(a);\n  vec2 b_fp64 = split(b);\n  float err = ((a_fp64.x * b_fp64.x - prod) + a_fp64.x * b_fp64.y +\n    a_fp64.y * b_fp64.x) + a_fp64.y * b_fp64.y;\n  return vec2(prod, err);\n}\n\nvec2 sum_fp64(vec2 a, vec2 b) {\n  vec2 s, t;\n  s = twoSum(a.x, b.x);\n  t = twoSum(a.y, b.y);\n  s.y += t.x;\n  s = quickTwoSum(s.x, s.y);\n  s.y += t.y;\n  s = quickTwoSum(s.x, s.y);\n  return s;\n}\n\nvec2 sub_fp64(vec2 a, vec2 b) {\n  vec2 s, t;\n  s = twoSub(a.x, b.x);\n  t = twoSub(a.y, b.y);\n  s.y += t.x;\n  s = quickTwoSum(s.x, s.y);\n  s.y += t.y;\n  s = quickTwoSum(s.x, s.y);\n  return s;\n}\n\nvec2 mul_fp64(vec2 a, vec2 b) {\n  vec2 prod = twoProd(a.x, b.x);\n  prod.y += a.x * b.y;\n#if defined(LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND)\n  prod = split2(prod);\n#endif\n  prod = quickTwoSum(prod.x, prod.y);\n  prod.y += a.y * b.x;\n#if defined(LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND)\n  prod = split2(prod);\n#endif\n  prod = quickTwoSum(prod.x, prod.y);\n  return prod;\n}\n\nvec2 div_fp64(vec2 a, vec2 b) {\n  float xn = 1.0 / b.x;\n#if defined(LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND)\n  vec2 yn = mul_fp64(a, vec2(xn, 0));\n#else\n  vec2 yn = a * xn;\n#endif\n  float diff = (sub_fp64(a, mul_fp64(b, yn))).x;\n  vec2 prod = twoProd(xn, diff);\n  return sum_fp64(yn, prod);\n}\n\nvec2 sqrt_fp64(vec2 a) {\n  if (a.x == 0.0 && a.y == 0.0) return vec2(0.0, 0.0);\n  if (a.x < 0.0) return vec2(0.0 / 0.0, 0.0 / 0.0);\n\n  float x = 1.0 / sqrt(a.x);\n  float yn = a.x * x;\n#if defined(LUMA_FP64_CODE_ELIMINATION_WORKAROUND)\n  vec2 yn_sqr = twoSqr(yn) * ONE;\n#else\n  vec2 yn_sqr = twoSqr(yn);\n#endif\n  float diff = sub_fp64(a, yn_sqr).x;\n  vec2 prod = twoProd(x * 0.5, diff);\n#if defined(LUMA_FP64_HIGH_BITS_OVERFLOW_WORKAROUND)\n  return sum_fp64(split(yn), prod);\n#else\n  return sum_fp64(vec2(yn, 0.0), prod);\n#endif\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cSr6b":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "const vec2 E_FP64 = vec2(2.7182817459106445e+00, 8.254840366817007e-08);\nconst vec2 LOG2_FP64 = vec2(0.6931471824645996e+00, -1.9046542121259336e-09);\nconst vec2 PI_FP64 = vec2(3.1415927410125732, -8.742278012618954e-8);\nconst vec2 TWO_PI_FP64 = vec2(6.2831854820251465, -1.7484556025237907e-7);\nconst vec2 PI_2_FP64 = vec2(1.5707963705062866, -4.371139006309477e-8);\nconst vec2 PI_4_FP64 = vec2(0.7853981852531433, -2.1855695031547384e-8);\nconst vec2 PI_16_FP64 = vec2(0.19634954631328583, -5.463923757886846e-9);\nconst vec2 PI_16_2_FP64 = vec2(0.39269909262657166, -1.0927847515773692e-8);\nconst vec2 PI_16_3_FP64 = vec2(0.5890486240386963, -1.4906100798128818e-9);\nconst vec2 PI_180_FP64 = vec2(0.01745329238474369, 1.3519960498364902e-10);\n\nconst vec2 SIN_TABLE_0_FP64 = vec2(0.19509032368659973, -1.6704714833615242e-9);\nconst vec2 SIN_TABLE_1_FP64 = vec2(0.3826834261417389, 6.22335089017767e-9);\nconst vec2 SIN_TABLE_2_FP64 = vec2(0.5555702447891235, -1.1769521357507529e-8);\nconst vec2 SIN_TABLE_3_FP64 = vec2(0.7071067690849304, 1.2101617041793133e-8);\n\nconst vec2 COS_TABLE_0_FP64 = vec2(0.9807852506637573, 2.9739473106360492e-8);\nconst vec2 COS_TABLE_1_FP64 = vec2(0.9238795042037964, 2.8307490351764386e-8);\nconst vec2 COS_TABLE_2_FP64 = vec2(0.8314695954322815, 1.6870263741530778e-8);\nconst vec2 COS_TABLE_3_FP64 = vec2(0.7071067690849304, 1.2101617152815436e-8);\n\nconst vec2 INVERSE_FACTORIAL_3_FP64 = vec2(1.666666716337204e-01, -4.967053879312289e-09);\nconst vec2 INVERSE_FACTORIAL_4_FP64 = vec2(4.16666679084301e-02, -1.2417634698280722e-09);\nconst vec2 INVERSE_FACTORIAL_5_FP64 = vec2(8.333333767950535e-03, -4.34617203337595e-10);\nconst vec2 INVERSE_FACTORIAL_6_FP64 = vec2(1.3888889225199819e-03, -3.3631094437103215e-11);\nconst vec2 INVERSE_FACTORIAL_7_FP64 = vec2(1.9841270113829523e-04,  -2.725596874933456e-12);\nconst vec2 INVERSE_FACTORIAL_8_FP64 = vec2(2.4801587642286904e-05, -3.406996025904184e-13);\nconst vec2 INVERSE_FACTORIAL_9_FP64 = vec2(2.75573188446287533e-06, 3.7935713937038186e-14);\nconst vec2 INVERSE_FACTORIAL_10_FP64 = vec2(2.755731998149713e-07, -7.575112367869873e-15);\n\nfloat nint(float d) {\n    if (d == floor(d)) return d;\n    return floor(d + 0.5);\n}\n\nvec2 nint_fp64(vec2 a) {\n    float hi = nint(a.x);\n    float lo;\n    vec2 tmp;\n    if (hi == a.x) {\n        lo = nint(a.y);\n        tmp = quickTwoSum(hi, lo);\n    } else {\n        lo = 0.0;\n        if (abs(hi - a.x) == 0.5 && a.y < 0.0) {\n            hi -= 1.0;\n        }\n        tmp = vec2(hi, lo);\n    }\n    return tmp;\n}\n\nvec2 exp_fp64(vec2 a) {\n\n  const int k_power = 4;\n  const float k = 16.0;\n\n  const float inv_k = 1.0 / k;\n\n  if (a.x <= -88.0) return vec2(0.0, 0.0);\n  if (a.x >= 88.0) return vec2(1.0 / 0.0, 1.0 / 0.0);\n  if (a.x == 0.0 && a.y == 0.0) return vec2(1.0, 0.0);\n  if (a.x == 1.0 && a.y == 0.0) return E_FP64;\n\n  float m = floor(a.x / LOG2_FP64.x + 0.5);\n  vec2 r = sub_fp64(a, mul_fp64(LOG2_FP64, vec2(m, 0.0))) * inv_k;\n  vec2 s, t, p;\n\n  p = mul_fp64(r, r);\n  s = sum_fp64(r, p * 0.5);\n  p = mul_fp64(p, r);\n  t = mul_fp64(p, INVERSE_FACTORIAL_3_FP64);\n\n  s = sum_fp64(s, t);\n  p = mul_fp64(p, r);\n  t = mul_fp64(p, INVERSE_FACTORIAL_4_FP64);\n\n  s = sum_fp64(s, t);\n  p = mul_fp64(p, r);\n  t = mul_fp64(p, INVERSE_FACTORIAL_5_FP64);\n\n\n\n\n\n\n  s = sum_fp64(s, t);\n  for (int i = 0; i < k_power; i++) {\n    s = sum_fp64(s * 2.0, mul_fp64(s, s));\n  }\n\n#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)\n  s = sum_fp64(s, vec2(ONE, 0.0));\n#else\n  s = sum_fp64(s, vec2(1.0, 0.0));\n#endif\n\n  return s * pow(2.0, m);\n}\n\nvec2 log_fp64(vec2 a)\n{\n  if (a.x == 1.0 && a.y == 0.0) return vec2(0.0, 0.0);\n  if (a.x <= 0.0) return vec2(0.0 / 0.0, 0.0 / 0.0);\n  vec2 x = vec2(log(a.x), 0.0);\n  vec2 s;\n#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)\n  s = vec2(ONE, 0.0);\n#else\n  s = vec2(1.0, 0.0);\n#endif\n\n  x = sub_fp64(sum_fp64(x, mul_fp64(a, exp_fp64(-x))), s);\n  return x;\n}\n\nvec2 sin_taylor_fp64(vec2 a) {\n  vec2 r, s, t, x;\n\n  if (a.x == 0.0 && a.y == 0.0) {\n    return vec2(0.0, 0.0);\n  }\n\n  x = -mul_fp64(a, a);\n  s = a;\n  r = a;\n\n  r = mul_fp64(r, x);\n  t = mul_fp64(r, INVERSE_FACTORIAL_3_FP64);\n  s = sum_fp64(s, t);\n\n  r = mul_fp64(r, x);\n  t = mul_fp64(r, INVERSE_FACTORIAL_5_FP64);\n  s = sum_fp64(s, t);\n\n\n\n\n\n\n  return s;\n}\n\nvec2 cos_taylor_fp64(vec2 a) {\n  vec2 r, s, t, x;\n\n  if (a.x == 0.0 && a.y == 0.0) {\n    return vec2(1.0, 0.0);\n  }\n\n  x = -mul_fp64(a, a);\n  r = x;\n  s = sum_fp64(vec2(1.0, 0.0), r * 0.5);\n\n  r = mul_fp64(r, x);\n  t = mul_fp64(r, INVERSE_FACTORIAL_4_FP64);\n  s = sum_fp64(s, t);\n\n  r = mul_fp64(r, x);\n  t = mul_fp64(r, INVERSE_FACTORIAL_6_FP64);\n  s = sum_fp64(s, t);\n\n\n\n\n\n\n  return s;\n}\n\nvoid sincos_taylor_fp64(vec2 a, out vec2 sin_t, out vec2 cos_t) {\n  if (a.x == 0.0 && a.y == 0.0) {\n    sin_t = vec2(0.0, 0.0);\n    cos_t = vec2(1.0, 0.0);\n  }\n\n  sin_t = sin_taylor_fp64(a);\n  cos_t = sqrt_fp64(sub_fp64(vec2(1.0, 0.0), mul_fp64(sin_t, sin_t)));\n}\n\nvec2 sin_fp64(vec2 a) {\n    if (a.x == 0.0 && a.y == 0.0) {\n        return vec2(0.0, 0.0);\n    }\n    vec2 z = nint_fp64(div_fp64(a, TWO_PI_FP64));\n    vec2 r = sub_fp64(a, mul_fp64(TWO_PI_FP64, z));\n\n    vec2 t;\n    float q = floor(r.x / PI_2_FP64.x + 0.5);\n    int j = int(q);\n\n    if (j < -2 || j > 2) {\n        return vec2(0.0 / 0.0, 0.0 / 0.0);\n    }\n\n    t = sub_fp64(r, mul_fp64(PI_2_FP64, vec2(q, 0.0)));\n\n    q = floor(t.x / PI_16_FP64.x + 0.5);\n    int k = int(q);\n\n    if (k == 0) {\n        if (j == 0) {\n            return sin_taylor_fp64(t);\n        } else if (j == 1) {\n            return cos_taylor_fp64(t);\n        } else if (j == -1) {\n            return -cos_taylor_fp64(t);\n        } else {\n            return -sin_taylor_fp64(t);\n        }\n    }\n\n    int abs_k = int(abs(float(k)));\n\n    if (abs_k > 4) {\n        return vec2(0.0 / 0.0, 0.0 / 0.0);\n    } else {\n        t = sub_fp64(t, mul_fp64(PI_16_FP64, vec2(q, 0.0)));\n    }\n\n    vec2 u = vec2(0.0, 0.0);\n    vec2 v = vec2(0.0, 0.0);\n\n#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)\n    if (abs(float(abs_k) - 1.0) < 0.5) {\n        u = COS_TABLE_0_FP64;\n        v = SIN_TABLE_0_FP64;\n    } else if (abs(float(abs_k) - 2.0) < 0.5) {\n        u = COS_TABLE_1_FP64;\n        v = SIN_TABLE_1_FP64;\n    } else if (abs(float(abs_k) - 3.0) < 0.5) {\n        u = COS_TABLE_2_FP64;\n        v = SIN_TABLE_2_FP64;\n    } else if (abs(float(abs_k) - 4.0) < 0.5) {\n        u = COS_TABLE_3_FP64;\n        v = SIN_TABLE_3_FP64;\n    }\n#else\n    if (abs_k == 1) {\n        u = COS_TABLE_0_FP64;\n        v = SIN_TABLE_0_FP64;\n    } else if (abs_k == 2) {\n        u = COS_TABLE_1_FP64;\n        v = SIN_TABLE_1_FP64;\n    } else if (abs_k == 3) {\n        u = COS_TABLE_2_FP64;\n        v = SIN_TABLE_2_FP64;\n    } else if (abs_k == 4) {\n        u = COS_TABLE_3_FP64;\n        v = SIN_TABLE_3_FP64;\n    }\n#endif\n\n    vec2 sin_t, cos_t;\n    sincos_taylor_fp64(t, sin_t, cos_t);\n\n\n\n    vec2 result = vec2(0.0, 0.0);\n    if (j == 0) {\n        if (k > 0) {\n            result = sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));\n        } else {\n            result = sub_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));\n        }\n    } else if (j == 1) {\n        if (k > 0) {\n            result = sub_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));\n        } else {\n            result = sum_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));\n        }\n    } else if (j == -1) {\n        if (k > 0) {\n            result = sub_fp64(mul_fp64(v, sin_t), mul_fp64(u, cos_t));\n        } else {\n            result = -sum_fp64(mul_fp64(v, sin_t), mul_fp64(u, cos_t));\n        }\n    } else {\n        if (k > 0) {\n            result = -sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));\n        } else {\n            result = sub_fp64(mul_fp64(v, cos_t), mul_fp64(u, sin_t));\n        }\n    }\n\n    return result;\n}\n\nvec2 cos_fp64(vec2 a) {\n    if (a.x == 0.0 && a.y == 0.0) {\n        return vec2(1.0, 0.0);\n    }\n    vec2 z = nint_fp64(div_fp64(a, TWO_PI_FP64));\n    vec2 r = sub_fp64(a, mul_fp64(TWO_PI_FP64, z));\n\n    vec2 t;\n    float q = floor(r.x / PI_2_FP64.x + 0.5);\n    int j = int(q);\n\n    if (j < -2 || j > 2) {\n        return vec2(0.0 / 0.0, 0.0 / 0.0);\n    }\n\n    t = sub_fp64(r, mul_fp64(PI_2_FP64, vec2(q, 0.0)));\n\n    q = floor(t.x / PI_16_FP64.x + 0.5);\n    int k = int(q);\n\n    if (k == 0) {\n        if (j == 0) {\n            return cos_taylor_fp64(t);\n        } else if (j == 1) {\n            return -sin_taylor_fp64(t);\n        } else if (j == -1) {\n            return sin_taylor_fp64(t);\n        } else {\n            return -cos_taylor_fp64(t);\n        }\n    }\n\n    int abs_k = int(abs(float(k)));\n\n    if (abs_k > 4) {\n        return vec2(0.0 / 0.0, 0.0 / 0.0);\n    } else {\n        t = sub_fp64(t, mul_fp64(PI_16_FP64, vec2(q, 0.0)));\n    }\n\n    vec2 u = vec2(0.0, 0.0);\n    vec2 v = vec2(0.0, 0.0);\n\n#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)\n    if (abs(float(abs_k) - 1.0) < 0.5) {\n        u = COS_TABLE_0_FP64;\n        v = SIN_TABLE_0_FP64;\n    } else if (abs(float(abs_k) - 2.0) < 0.5) {\n        u = COS_TABLE_1_FP64;\n        v = SIN_TABLE_1_FP64;\n    } else if (abs(float(abs_k) - 3.0) < 0.5) {\n        u = COS_TABLE_2_FP64;\n        v = SIN_TABLE_2_FP64;\n    } else if (abs(float(abs_k) - 4.0) < 0.5) {\n        u = COS_TABLE_3_FP64;\n        v = SIN_TABLE_3_FP64;\n    }\n#else\n    if (abs_k == 1) {\n        u = COS_TABLE_0_FP64;\n        v = SIN_TABLE_0_FP64;\n    } else if (abs_k == 2) {\n        u = COS_TABLE_1_FP64;\n        v = SIN_TABLE_1_FP64;\n    } else if (abs_k == 3) {\n        u = COS_TABLE_2_FP64;\n        v = SIN_TABLE_2_FP64;\n    } else if (abs_k == 4) {\n        u = COS_TABLE_3_FP64;\n        v = SIN_TABLE_3_FP64;\n    }\n#endif\n\n    vec2 sin_t, cos_t;\n    sincos_taylor_fp64(t, sin_t, cos_t);\n\n    vec2 result = vec2(0.0, 0.0);\n    if (j == 0) {\n        if (k > 0) {\n            result = sub_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));\n        } else {\n            result = sum_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));\n        }\n    } else if (j == 1) {\n        if (k > 0) {\n            result = -sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));\n        } else {\n            result = sub_fp64(mul_fp64(v, cos_t), mul_fp64(u, sin_t));\n        }\n    } else if (j == -1) {\n        if (k > 0) {\n            result = sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));\n        } else {\n            result = sub_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));\n        }\n    } else {\n        if (k > 0) {\n            result = sub_fp64(mul_fp64(v, sin_t), mul_fp64(u, cos_t));\n        } else {\n            result = -sum_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));\n        }\n    }\n\n    return result;\n}\n\nvec2 tan_fp64(vec2 a) {\n    vec2 sin_a;\n    vec2 cos_a;\n\n    if (a.x == 0.0 && a.y == 0.0) {\n        return vec2(0.0, 0.0);\n    }\n    vec2 z = nint_fp64(div_fp64(a, TWO_PI_FP64));\n    vec2 r = sub_fp64(a, mul_fp64(TWO_PI_FP64, z));\n\n    vec2 t;\n    float q = floor(r.x / PI_2_FP64.x + 0.5);\n    int j = int(q);\n\n\n    if (j < -2 || j > 2) {\n        return vec2(0.0 / 0.0, 0.0 / 0.0);\n    }\n\n    t = sub_fp64(r, mul_fp64(PI_2_FP64, vec2(q, 0.0)));\n\n    q = floor(t.x / PI_16_FP64.x + 0.5);\n    int k = int(q);\n    int abs_k = int(abs(float(k)));\n\n    if (abs_k > 4) {\n        return vec2(0.0 / 0.0, 0.0 / 0.0);\n    } else {\n        t = sub_fp64(t, mul_fp64(PI_16_FP64, vec2(q, 0.0)));\n    }\n\n\n    vec2 u = vec2(0.0, 0.0);\n    vec2 v = vec2(0.0, 0.0);\n\n    vec2 sin_t, cos_t;\n    vec2 s, c;\n    sincos_taylor_fp64(t, sin_t, cos_t);\n\n    if (k == 0) {\n        s = sin_t;\n        c = cos_t;\n    } else {\n#if defined(NVIDIA_FP64_WORKAROUND) || defined(INTEL_FP64_WORKAROUND)\n        if (abs(float(abs_k) - 1.0) < 0.5) {\n            u = COS_TABLE_0_FP64;\n            v = SIN_TABLE_0_FP64;\n        } else if (abs(float(abs_k) - 2.0) < 0.5) {\n            u = COS_TABLE_1_FP64;\n            v = SIN_TABLE_1_FP64;\n        } else if (abs(float(abs_k) - 3.0) < 0.5) {\n            u = COS_TABLE_2_FP64;\n            v = SIN_TABLE_2_FP64;\n        } else if (abs(float(abs_k) - 4.0) < 0.5) {\n            u = COS_TABLE_3_FP64;\n            v = SIN_TABLE_3_FP64;\n        }\n#else\n        if (abs_k == 1) {\n            u = COS_TABLE_0_FP64;\n            v = SIN_TABLE_0_FP64;\n        } else if (abs_k == 2) {\n            u = COS_TABLE_1_FP64;\n            v = SIN_TABLE_1_FP64;\n        } else if (abs_k == 3) {\n            u = COS_TABLE_2_FP64;\n            v = SIN_TABLE_2_FP64;\n        } else if (abs_k == 4) {\n            u = COS_TABLE_3_FP64;\n            v = SIN_TABLE_3_FP64;\n        }\n#endif\n        if (k > 0) {\n            s = sum_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));\n            c = sub_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));\n        } else {\n            s = sub_fp64(mul_fp64(u, sin_t), mul_fp64(v, cos_t));\n            c = sum_fp64(mul_fp64(u, cos_t), mul_fp64(v, sin_t));\n        }\n    }\n\n    if (j == 0) {\n        sin_a = s;\n        cos_a = c;\n    } else if (j == 1) {\n        sin_a = c;\n        cos_a = -s;\n    } else if (j == -1) {\n        sin_a = -c;\n        cos_a = s;\n    } else {\n        sin_a = -s;\n        cos_a = -c;\n    }\n    return div_fp64(sin_a, cos_a);\n}\n\nvec2 radians_fp64(vec2 degree) {\n  return mul_fp64(degree, PI_180_FP64);\n}\n\nvec2 mix_fp64(vec2 a, vec2 b, float x) {\n  vec2 range = sub_fp64(b, a);\n  return sum_fp64(a, mul_fp64(range, vec2(x, 0.0)));\n}\n\nvoid vec2_sum_fp64(vec2 a[2], vec2 b[2], out vec2 out_val[2]) {\n    out_val[0] = sum_fp64(a[0], b[0]);\n    out_val[1] = sum_fp64(a[1], b[1]);\n}\n\nvoid vec2_sub_fp64(vec2 a[2], vec2 b[2], out vec2 out_val[2]) {\n    out_val[0] = sub_fp64(a[0], b[0]);\n    out_val[1] = sub_fp64(a[1], b[1]);\n}\n\nvoid vec2_mul_fp64(vec2 a[2], vec2 b[2], out vec2 out_val[2]) {\n    out_val[0] = mul_fp64(a[0], b[0]);\n    out_val[1] = mul_fp64(a[1], b[1]);\n}\n\nvoid vec2_div_fp64(vec2 a[2], vec2 b[2], out vec2 out_val[2]) {\n    out_val[0] = div_fp64(a[0], b[0]);\n    out_val[1] = div_fp64(a[1], b[1]);\n}\n\nvoid vec2_mix_fp64(vec2 x[2], vec2 y[2], float a, out vec2 out_val[2]) {\n  vec2 range[2];\n  vec2_sub_fp64(y, x, range);\n  vec2 portion[2];\n  portion[0] = range[0] * a;\n  portion[1] = range[1] * a;\n  vec2_sum_fp64(x, portion, out_val);\n}\n\nvec2 vec2_length_fp64(vec2 x[2]) {\n  return sqrt_fp64(sum_fp64(mul_fp64(x[0], x[0]), mul_fp64(x[1], x[1])));\n}\n\nvoid vec2_normalize_fp64(vec2 x[2], out vec2 out_val[2]) {\n  vec2 length = vec2_length_fp64(x);\n  vec2 length_vec2[2];\n  length_vec2[0] = length;\n  length_vec2[1] = length;\n\n  vec2_div_fp64(x, length_vec2, out_val);\n}\n\nvec2 vec2_distance_fp64(vec2 x[2], vec2 y[2]) {\n  vec2 diff[2];\n  vec2_sub_fp64(x, y, diff);\n  return vec2_length_fp64(diff);\n}\n\nvec2 vec2_dot_fp64(vec2 a[2], vec2 b[2]) {\n  vec2 v[2];\n\n  v[0] = mul_fp64(a[0], b[0]);\n  v[1] = mul_fp64(a[1], b[1]);\n\n  return sum_fp64(v[0], v[1]);\n}\nvoid vec3_sub_fp64(vec2 a[3], vec2 b[3], out vec2 out_val[3]) {\n  for (int i = 0; i < 3; i++) {\n    out_val[i] = sum_fp64(a[i], b[i]);\n  }\n}\n\nvoid vec3_sum_fp64(vec2 a[3], vec2 b[3], out vec2 out_val[3]) {\n  for (int i = 0; i < 3; i++) {\n    out_val[i] = sum_fp64(a[i], b[i]);\n  }\n}\n\nvec2 vec3_length_fp64(vec2 x[3]) {\n  return sqrt_fp64(sum_fp64(sum_fp64(mul_fp64(x[0], x[0]), mul_fp64(x[1], x[1])),\n    mul_fp64(x[2], x[2])));\n}\n\nvec2 vec3_distance_fp64(vec2 x[3], vec2 y[3]) {\n  vec2 diff[3];\n  vec3_sub_fp64(x, y, diff);\n  return vec3_length_fp64(diff);\n}\nvoid vec4_fp64(vec4 a, out vec2 out_val[4]) {\n  out_val[0].x = a[0];\n  out_val[0].y = 0.0;\n\n  out_val[1].x = a[1];\n  out_val[1].y = 0.0;\n\n  out_val[2].x = a[2];\n  out_val[2].y = 0.0;\n\n  out_val[3].x = a[3];\n  out_val[3].y = 0.0;\n}\n\nvoid vec4_scalar_mul_fp64(vec2 a[4], vec2 b, out vec2 out_val[4]) {\n  out_val[0] = mul_fp64(a[0], b);\n  out_val[1] = mul_fp64(a[1], b);\n  out_val[2] = mul_fp64(a[2], b);\n  out_val[3] = mul_fp64(a[3], b);\n}\n\nvoid vec4_sum_fp64(vec2 a[4], vec2 b[4], out vec2 out_val[4]) {\n  for (int i = 0; i < 4; i++) {\n    out_val[i] = sum_fp64(a[i], b[i]);\n  }\n}\n\nvoid vec4_dot_fp64(vec2 a[4], vec2 b[4], out vec2 out_val) {\n  vec2 v[4];\n\n  v[0] = mul_fp64(a[0], b[0]);\n  v[1] = mul_fp64(a[1], b[1]);\n  v[2] = mul_fp64(a[2], b[2]);\n  v[3] = mul_fp64(a[3], b[3]);\n\n  out_val = sum_fp64(sum_fp64(v[0], v[1]), sum_fp64(v[2], v[3]));\n}\n\nvoid mat4_vec4_mul_fp64(vec2 b[16], vec2 a[4], out vec2 out_val[4]) {\n  vec2 tmp[4];\n\n  for (int i = 0; i < 4; i++)\n  {\n    for (int j = 0; j < 4; j++)\n    {\n      tmp[j] = b[j + i * 4];\n    }\n    vec4_dot_fp64(a, tmp, out_val[i]);\n  }\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jONjt":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "project", ()=>project);
var _core = require("@math.gl/core");
const IDENTITY_MATRIX = [
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    1
];
const DEFAULT_MODULE_OPTIONS = {
    modelMatrix: IDENTITY_MATRIX,
    viewMatrix: IDENTITY_MATRIX,
    projectionMatrix: IDENTITY_MATRIX,
    cameraPositionWorld: [
        0,
        0,
        0
    ]
};
function getUniforms() {
    let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_MODULE_OPTIONS;
    let prevUniforms = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
    const uniforms = {};
    if (opts.modelMatrix !== undefined) uniforms.modelMatrix = opts.modelMatrix;
    if (opts.viewMatrix !== undefined) uniforms.viewMatrix = opts.viewMatrix;
    if (opts.projectionMatrix !== undefined) uniforms.projectionMatrix = opts.projectionMatrix;
    if (opts.cameraPositionWorld !== undefined) uniforms.cameraPositionWorld = opts.cameraPositionWorld;
    if (opts.projectionMatrix !== undefined || opts.viewMatrix !== undefined) uniforms.viewProjectionMatrix = new (0, _core.Matrix4)(opts.projectionMatrix).multiplyRight(opts.viewMatrix);
    return uniforms;
}
const common = "varying vec4 project_vPositionWorld;\nvarying vec3 project_vNormalWorld;\n\nvec4 project_getPosition_World() {\n  return project_vPositionWorld;\n}\n\nvec3 project_getNormal_World() {\n  return project_vNormalWorld;\n}\n";
const vs = "".concat(common, "\nuniform mat4 modelMatrix;\nuniform mat4 viewMatrix;\nuniform mat4 projectionMatrix;\nuniform mat4 viewProjectionMatrix;\nuniform vec3 cameraPositionWorld;\n\nstruct World {\n  vec3 position;\n  vec3 normal;\n};\n\nWorld world;\n\nvoid project_setPosition(vec4 position) {\n  project_vPositionWorld = position;\n}\n\nvoid project_setNormal(vec3 normal) {\n  project_vNormalWorld = normal;\n}\n\nvoid project_setPositionAndNormal_World(vec3 position, vec3 normal) {\n  world.position = position;\n  world.normal = normal;\n}\n\nvoid project_setPositionAndNormal_Model(vec3 position, vec3 normal) {\n  world.position = (modelMatrix * vec4(position, 1.)).xyz;\n  world.normal = mat3(modelMatrix) * normal;\n}\n\nvec4 project_model_to_clipspace(vec4 position) {\n  return viewProjectionMatrix * modelMatrix * position;\n}\n\nvec4 project_model_to_clipspace(vec3 position) {\n  return viewProjectionMatrix * modelMatrix * vec4(position, 1.);\n}\n\nvec4 project_world_to_clipspace(vec3 position) {\n  return viewProjectionMatrix * vec4(position, 1.);\n}\n\nvec4 project_view_to_clipspace(vec3 position) {\n  return projectionMatrix * vec4(position, 1.);\n}\n\nvec4 project_to_clipspace(vec3 position) {\n  return viewProjectionMatrix * vec4(position, 1.);\n}\n");
const fs = "\n".concat(common);
const project = {
    name: "project",
    getUniforms,
    vs,
    fs
};

},{"@math.gl/core":"9lgwD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9lgwD":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Vector2", ()=>(0, _vector2Default.default));
parcelHelpers.export(exports, "Vector3", ()=>(0, _vector3Default.default));
parcelHelpers.export(exports, "Vector4", ()=>(0, _vector4Default.default));
parcelHelpers.export(exports, "Matrix3", ()=>(0, _matrix3Default.default));
parcelHelpers.export(exports, "Matrix4", ()=>(0, _matrix4Default.default));
parcelHelpers.export(exports, "Quaternion", ()=>(0, _quaternionDefault.default));
parcelHelpers.export(exports, "SphericalCoordinates", ()=>(0, _sphericalCoordinatesDefault.default));
parcelHelpers.export(exports, "Pose", ()=>(0, _poseDefault.default));
parcelHelpers.export(exports, "Euler", ()=>(0, _eulerDefault.default));
parcelHelpers.export(exports, "_MathUtils", ()=>(0, _mathUtilsDefault.default));
parcelHelpers.export(exports, "assert", ()=>(0, _assertDefault.default));
parcelHelpers.export(exports, "config", ()=>(0, _common.config));
parcelHelpers.export(exports, "configure", ()=>(0, _common.configure));
parcelHelpers.export(exports, "formatValue", ()=>(0, _common.formatValue));
parcelHelpers.export(exports, "isArray", ()=>(0, _common.isArray));
parcelHelpers.export(exports, "clone", ()=>(0, _common.clone));
parcelHelpers.export(exports, "equals", ()=>(0, _common.equals));
parcelHelpers.export(exports, "exactEquals", ()=>(0, _common.exactEquals));
parcelHelpers.export(exports, "toRadians", ()=>(0, _common.toRadians));
parcelHelpers.export(exports, "toDegrees", ()=>(0, _common.toDegrees));
parcelHelpers.export(exports, "radians", ()=>(0, _common.radians));
parcelHelpers.export(exports, "degrees", ()=>(0, _common.degrees));
parcelHelpers.export(exports, "sin", ()=>(0, _common.sin));
parcelHelpers.export(exports, "cos", ()=>(0, _common.cos));
parcelHelpers.export(exports, "tan", ()=>(0, _common.tan));
parcelHelpers.export(exports, "asin", ()=>(0, _common.asin));
parcelHelpers.export(exports, "acos", ()=>(0, _common.acos));
parcelHelpers.export(exports, "atan", ()=>(0, _common.atan));
parcelHelpers.export(exports, "clamp", ()=>(0, _common.clamp));
parcelHelpers.export(exports, "lerp", ()=>(0, _common.lerp));
parcelHelpers.export(exports, "withEpsilon", ()=>(0, _common.withEpsilon));
parcelHelpers.export(exports, "_SphericalCoordinates", ()=>(0, _sphericalCoordinatesDefault.default));
parcelHelpers.export(exports, "_Pose", ()=>(0, _poseDefault.default));
parcelHelpers.export(exports, "_Euler", ()=>(0, _eulerDefault.default));
var _vector2 = require("./classes/vector2");
var _vector2Default = parcelHelpers.interopDefault(_vector2);
var _vector3 = require("./classes/vector3");
var _vector3Default = parcelHelpers.interopDefault(_vector3);
var _vector4 = require("./classes/vector4");
var _vector4Default = parcelHelpers.interopDefault(_vector4);
var _matrix3 = require("./classes/matrix3");
var _matrix3Default = parcelHelpers.interopDefault(_matrix3);
var _matrix4 = require("./classes/matrix4");
var _matrix4Default = parcelHelpers.interopDefault(_matrix4);
var _quaternion = require("./classes/quaternion");
var _quaternionDefault = parcelHelpers.interopDefault(_quaternion);
var _sphericalCoordinates = require("./classes/spherical-coordinates");
var _sphericalCoordinatesDefault = parcelHelpers.interopDefault(_sphericalCoordinates);
var _pose = require("./classes/pose");
var _poseDefault = parcelHelpers.interopDefault(_pose);
var _euler = require("./classes/euler");
var _eulerDefault = parcelHelpers.interopDefault(_euler);
var _mathUtils = require("./lib/math-utils");
var _mathUtilsDefault = parcelHelpers.interopDefault(_mathUtils);
var _assert = require("./lib/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _common = require("./lib/common");

},{"./classes/vector2":false,"./classes/vector3":"f9VgK","./classes/vector4":false,"./classes/matrix3":false,"./classes/matrix4":"6HeZ9","./classes/quaternion":false,"./classes/spherical-coordinates":false,"./classes/pose":false,"./classes/euler":false,"./lib/math-utils":false,"./lib/assert":"AxQEZ","./lib/common":"2Zxz7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"f9VgK":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _vector = require("./base/vector");
var _vectorDefault = parcelHelpers.interopDefault(_vector);
var _common = require("../lib/common");
var _validators = require("../lib/validators");
var _vec3 = require("gl-matrix/vec3");
var _glMatrixExtras = require("../lib/gl-matrix-extras");
const ORIGIN = [
    0,
    0,
    0
];
let ZERO;
class Vector3 extends (0, _vectorDefault.default) {
    static get ZERO() {
        if (!ZERO) {
            ZERO = new Vector3(0, 0, 0);
            Object.freeze(ZERO);
        }
        return ZERO;
    }
    constructor(x = 0, y = 0, z = 0){
        super(-0, -0, -0);
        if (arguments.length === 1 && (0, _common.isArray)(x)) this.copy(x);
        else {
            if ((0, _common.config).debug) {
                (0, _validators.checkNumber)(x);
                (0, _validators.checkNumber)(y);
                (0, _validators.checkNumber)(z);
            }
            this[0] = x;
            this[1] = y;
            this[2] = z;
        }
    }
    set(x, y, z) {
        this[0] = x;
        this[1] = y;
        this[2] = z;
        return this.check();
    }
    copy(array) {
        this[0] = array[0];
        this[1] = array[1];
        this[2] = array[2];
        return this.check();
    }
    fromObject(object) {
        if ((0, _common.config).debug) {
            (0, _validators.checkNumber)(object.x);
            (0, _validators.checkNumber)(object.y);
            (0, _validators.checkNumber)(object.z);
        }
        this[0] = object.x;
        this[1] = object.y;
        this[2] = object.z;
        return this.check();
    }
    toObject(object) {
        object.x = this[0];
        object.y = this[1];
        object.z = this[2];
        return object;
    }
    get ELEMENTS() {
        return 3;
    }
    get z() {
        return this[2];
    }
    set z(value) {
        this[2] = (0, _validators.checkNumber)(value);
    }
    angle(vector) {
        return _vec3.angle(this, vector);
    }
    cross(vector) {
        _vec3.cross(this, this, vector);
        return this.check();
    }
    rotateX({ radians , origin =ORIGIN  }) {
        _vec3.rotateX(this, this, origin, radians);
        return this.check();
    }
    rotateY({ radians , origin =ORIGIN  }) {
        _vec3.rotateY(this, this, origin, radians);
        return this.check();
    }
    rotateZ({ radians , origin =ORIGIN  }) {
        _vec3.rotateZ(this, this, origin, radians);
        return this.check();
    }
    transform(matrix4) {
        return this.transformAsPoint(matrix4);
    }
    transformAsPoint(matrix4) {
        _vec3.transformMat4(this, this, matrix4);
        return this.check();
    }
    transformAsVector(matrix4) {
        (0, _glMatrixExtras.vec3_transformMat4AsVector)(this, this, matrix4);
        return this.check();
    }
    transformByMatrix3(matrix3) {
        _vec3.transformMat3(this, this, matrix3);
        return this.check();
    }
    transformByMatrix2(matrix2) {
        (0, _glMatrixExtras.vec3_transformMat2)(this, this, matrix2);
        return this.check();
    }
    transformByQuaternion(quaternion) {
        _vec3.transformQuat(this, this, quaternion);
        return this.check();
    }
}
exports.default = Vector3;

},{"./base/vector":"5925P","../lib/common":"2Zxz7","../lib/validators":"s14oj","gl-matrix/vec3":"6mCNm","../lib/gl-matrix-extras":"6HqSa","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5925P":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _mathArray = require("./math-array");
var _mathArrayDefault = parcelHelpers.interopDefault(_mathArray);
var _validators = require("../../lib/validators");
var _assert = require("../../lib/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
class Vector extends (0, _mathArrayDefault.default) {
    get x() {
        return this[0];
    }
    set x(value) {
        this[0] = (0, _validators.checkNumber)(value);
    }
    get y() {
        return this[1];
    }
    set y(value) {
        this[1] = (0, _validators.checkNumber)(value);
    }
    len() {
        return Math.sqrt(this.lengthSquared());
    }
    magnitude() {
        return this.len();
    }
    lengthSquared() {
        let length = 0;
        for(let i = 0; i < this.ELEMENTS; ++i)length += this[i] * this[i];
        return length;
    }
    magnitudeSquared() {
        return this.lengthSquared();
    }
    distance(mathArray) {
        return Math.sqrt(this.distanceSquared(mathArray));
    }
    distanceSquared(mathArray) {
        let length = 0;
        for(let i = 0; i < this.ELEMENTS; ++i){
            const dist = this[i] - mathArray[i];
            length += dist * dist;
        }
        return (0, _validators.checkNumber)(length);
    }
    dot(mathArray) {
        let product = 0;
        for(let i = 0; i < this.ELEMENTS; ++i)product += this[i] * mathArray[i];
        return (0, _validators.checkNumber)(product);
    }
    normalize() {
        const length = this.magnitude();
        if (length !== 0) for(let i = 0; i < this.ELEMENTS; ++i)this[i] /= length;
        return this.check();
    }
    multiply(...vectors) {
        for (const vector of vectors)for(let i = 0; i < this.ELEMENTS; ++i)this[i] *= vector[i];
        return this.check();
    }
    divide(...vectors) {
        for (const vector of vectors)for(let i = 0; i < this.ELEMENTS; ++i)this[i] /= vector[i];
        return this.check();
    }
    lengthSq() {
        return this.lengthSquared();
    }
    distanceTo(vector) {
        return this.distance(vector);
    }
    distanceToSquared(vector) {
        return this.distanceSquared(vector);
    }
    getComponent(i) {
        (0, _assertDefault.default)(i >= 0 && i < this.ELEMENTS, "index is out of range");
        return (0, _validators.checkNumber)(this[i]);
    }
    setComponent(i, value) {
        (0, _assertDefault.default)(i >= 0 && i < this.ELEMENTS, "index is out of range");
        this[i] = value;
        return this.check();
    }
    addVectors(a, b) {
        return this.copy(a).add(b);
    }
    subVectors(a, b) {
        return this.copy(a).subtract(b);
    }
    multiplyVectors(a, b) {
        return this.copy(a).multiply(b);
    }
    addScaledVector(a, b) {
        return this.add(new this.constructor(a).multiplyScalar(b));
    }
}
exports.default = Vector;

},{"./math-array":"lJCLX","../../lib/validators":"s14oj","../../lib/assert":"AxQEZ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lJCLX":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _common = require("../../lib/common");
function _extendableBuiltin(cls) {
    function ExtendableBuiltin() {
        var instance = Reflect.construct(cls, Array.from(arguments));
        Object.setPrototypeOf(instance, Object.getPrototypeOf(this));
        return instance;
    }
    ExtendableBuiltin.prototype = Object.create(cls.prototype, {
        constructor: {
            value: cls,
            enumerable: false,
            writable: true,
            configurable: true
        }
    });
    if (Object.setPrototypeOf) Object.setPrototypeOf(ExtendableBuiltin, cls);
    else ExtendableBuiltin.__proto__ = cls;
    return ExtendableBuiltin;
}
class MathArray extends _extendableBuiltin(Array) {
    clone() {
        return new this.constructor().copy(this);
    }
    fromArray(array, offset = 0) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] = array[i + offset];
        return this.check();
    }
    toArray(targetArray = [], offset = 0) {
        for(let i = 0; i < this.ELEMENTS; ++i)targetArray[offset + i] = this[i];
        return targetArray;
    }
    from(arrayOrObject) {
        return Array.isArray(arrayOrObject) ? this.copy(arrayOrObject) : this.fromObject(arrayOrObject);
    }
    to(arrayOrObject) {
        if (arrayOrObject === this) return this;
        return (0, _common.isArray)(arrayOrObject) ? this.toArray(arrayOrObject) : this.toObject(arrayOrObject);
    }
    toTarget(target) {
        return target ? this.to(target) : this;
    }
    toFloat32Array() {
        return new Float32Array(this);
    }
    toString() {
        return this.formatString((0, _common.config));
    }
    formatString(opts) {
        let string = "";
        for(let i = 0; i < this.ELEMENTS; ++i)string += (i > 0 ? ", " : "") + (0, _common.formatValue)(this[i], opts);
        return "".concat(opts.printTypes ? this.constructor.name : "", "[").concat(string, "]");
    }
    equals(array) {
        if (!array || this.length !== array.length) return false;
        for(let i = 0; i < this.ELEMENTS; ++i){
            if (!(0, _common.equals)(this[i], array[i])) return false;
        }
        return true;
    }
    exactEquals(array) {
        if (!array || this.length !== array.length) return false;
        for(let i = 0; i < this.ELEMENTS; ++i){
            if (this[i] !== array[i]) return false;
        }
        return true;
    }
    negate() {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] = -this[i];
        return this.check();
    }
    lerp(a, b, t) {
        if (t === undefined) return this.lerp(this, a, b);
        for(let i = 0; i < this.ELEMENTS; ++i){
            const ai = a[i];
            this[i] = ai + t * (b[i] - ai);
        }
        return this.check();
    }
    min(vector) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] = Math.min(vector[i], this[i]);
        return this.check();
    }
    max(vector) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] = Math.max(vector[i], this[i]);
        return this.check();
    }
    clamp(minVector, maxVector) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] = Math.min(Math.max(this[i], minVector[i]), maxVector[i]);
        return this.check();
    }
    add(...vectors) {
        for (const vector of vectors)for(let i = 0; i < this.ELEMENTS; ++i)this[i] += vector[i];
        return this.check();
    }
    subtract(...vectors) {
        for (const vector of vectors)for(let i = 0; i < this.ELEMENTS; ++i)this[i] -= vector[i];
        return this.check();
    }
    scale(scale) {
        if (typeof scale === "number") for(let i = 0; i < this.ELEMENTS; ++i)this[i] *= scale;
        else for(let i1 = 0; i1 < this.ELEMENTS && i1 < scale.length; ++i1)this[i1] *= scale[i1];
        return this.check();
    }
    multiplyByScalar(scalar) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] *= scalar;
        return this.check();
    }
    check() {
        if ((0, _common.config).debug && !this.validate()) throw new Error("math.gl: ".concat(this.constructor.name, " some fields set to invalid numbers'"));
        return this;
    }
    validate() {
        let valid = this.length === this.ELEMENTS;
        for(let i = 0; i < this.ELEMENTS; ++i)valid = valid && Number.isFinite(this[i]);
        return valid;
    }
    sub(a) {
        return this.subtract(a);
    }
    setScalar(a) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] = a;
        return this.check();
    }
    addScalar(a) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] += a;
        return this.check();
    }
    subScalar(a) {
        return this.addScalar(-a);
    }
    multiplyScalar(scalar) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] *= scalar;
        return this.check();
    }
    divideScalar(a) {
        return this.multiplyByScalar(1 / a);
    }
    clampScalar(min, max) {
        for(let i = 0; i < this.ELEMENTS; ++i)this[i] = Math.min(Math.max(this[i], min), max);
        return this.check();
    }
    get elements() {
        return this;
    }
}
exports.default = MathArray;

},{"../../lib/common":"2Zxz7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2Zxz7":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "config", ()=>config);
parcelHelpers.export(exports, "configure", ()=>configure);
parcelHelpers.export(exports, "formatValue", ()=>formatValue);
parcelHelpers.export(exports, "isArray", ()=>isArray);
parcelHelpers.export(exports, "clone", ()=>clone);
parcelHelpers.export(exports, "toRadians", ()=>toRadians);
parcelHelpers.export(exports, "toDegrees", ()=>toDegrees);
parcelHelpers.export(exports, "radians", ()=>radians);
parcelHelpers.export(exports, "degrees", ()=>degrees);
parcelHelpers.export(exports, "sin", ()=>sin);
parcelHelpers.export(exports, "cos", ()=>cos);
parcelHelpers.export(exports, "tan", ()=>tan);
parcelHelpers.export(exports, "asin", ()=>asin);
parcelHelpers.export(exports, "acos", ()=>acos);
parcelHelpers.export(exports, "atan", ()=>atan);
parcelHelpers.export(exports, "clamp", ()=>clamp);
parcelHelpers.export(exports, "lerp", ()=>lerp);
parcelHelpers.export(exports, "equals", ()=>equals);
parcelHelpers.export(exports, "exactEquals", ()=>exactEquals);
parcelHelpers.export(exports, "withEpsilon", ()=>withEpsilon);
var _assert = require("./assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
const RADIANS_TO_DEGREES = 1 / Math.PI * 180;
const DEGREES_TO_RADIANS = 1 / 180 * Math.PI;
const config = {
    EPSILON: 1e-12,
    debug: false,
    precision: 4,
    printTypes: false,
    printDegrees: false,
    printRowMajor: true
};
function configure(options) {
    for(const key in options){
        (0, _assertDefault.default)(key in config);
        config[key] = options[key];
    }
    return config;
}
function formatValue(value, { precision =config.precision  } = {}) {
    value = round(value);
    return "".concat(parseFloat(value.toPrecision(precision)));
}
function isArray(value) {
    return Array.isArray(value) || ArrayBuffer.isView(value) && !(value instanceof DataView);
}
function clone(array) {
    return "clone" in array ? array.clone() : array.slice();
}
function toRadians(degrees) {
    return radians(degrees);
}
function toDegrees(radians) {
    return degrees(radians);
}
function radians(degrees, result) {
    return map(degrees, (degrees)=>degrees * DEGREES_TO_RADIANS, result);
}
function degrees(radians, result) {
    return map(radians, (radians)=>radians * RADIANS_TO_DEGREES, result);
}
function sin(radians, result) {
    return map(radians, (angle)=>Math.sin(angle), result);
}
function cos(radians, result) {
    return map(radians, (angle)=>Math.cos(angle), result);
}
function tan(radians, result) {
    return map(radians, (angle)=>Math.tan(angle), result);
}
function asin(radians, result) {
    return map(radians, (angle)=>Math.asin(angle), result);
}
function acos(radians, result) {
    return map(radians, (angle)=>Math.acos(angle), result);
}
function atan(radians, result) {
    return map(radians, (angle)=>Math.atan(angle), result);
}
function clamp(value, min, max) {
    return map(value, (value)=>Math.max(min, Math.min(max, value)));
}
function lerp(a, b, t) {
    if (isArray(a)) return a.map((ai, i)=>lerp(ai, b[i], t));
    return t * b + (1 - t) * a;
}
function equals(a, b, epsilon) {
    const oldEpsilon = config.EPSILON;
    if (epsilon) config.EPSILON = epsilon;
    try {
        if (a === b) return true;
        if (isArray(a) && isArray(b)) {
            if (a.length !== b.length) return false;
            for(let i = 0; i < a.length; ++i){
                if (!equals(a[i], b[i])) return false;
            }
            return true;
        }
        if (a && a.equals) return a.equals(b);
        if (b && b.equals) return b.equals(a);
        if (typeof a === "number" && typeof b === "number") return Math.abs(a - b) <= config.EPSILON * Math.max(1, Math.abs(a), Math.abs(b));
        return false;
    } finally{
        config.EPSILON = oldEpsilon;
    }
}
function exactEquals(a, b) {
    if (a === b) return true;
    if (a && typeof a === "object" && b && typeof b === "object") {
        if (a.constructor !== b.constructor) return false;
        if (a.exactEquals) return a.exactEquals(b);
    }
    if (isArray(a) && isArray(b)) {
        if (a.length !== b.length) return false;
        for(let i = 0; i < a.length; ++i){
            if (!exactEquals(a[i], b[i])) return false;
        }
        return true;
    }
    return false;
}
function withEpsilon(epsilon, func) {
    const oldPrecision = config.EPSILON;
    config.EPSILON = epsilon;
    let value;
    try {
        value = func();
    } finally{
        config.EPSILON = oldPrecision;
    }
    return value;
}
function round(value) {
    return Math.round(value / config.EPSILON) * config.EPSILON;
}
function duplicateArray(array) {
    return array.clone ? array.clone() : new Array(array.length);
}
function map(value, func, result) {
    if (isArray(value)) {
        const array = value;
        result = result || duplicateArray(array);
        for(let i = 0; i < result.length && i < array.length; ++i)result[i] = func(value[i], i, result);
        return result;
    }
    return func(value);
}

},{"./assert":"AxQEZ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"AxQEZ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function assert(condition, message) {
    if (!condition) throw new Error("math.gl assertion ".concat(message));
}
exports.default = assert;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"s14oj":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "validateVector", ()=>validateVector);
parcelHelpers.export(exports, "checkNumber", ()=>checkNumber);
parcelHelpers.export(exports, "checkVector", ()=>checkVector);
parcelHelpers.export(exports, "deprecated", ()=>deprecated);
var _common = require("./common");
function validateVector(v, length) {
    if (v.length !== length) return false;
    for(let i = 0; i < v.length; ++i){
        if (!Number.isFinite(v[i])) return false;
    }
    return true;
}
function checkNumber(value) {
    if (!Number.isFinite(value)) throw new Error("Invalid number ".concat(value));
    return value;
}
function checkVector(v, length, callerName = "") {
    if ((0, _common.config).debug && !validateVector(v, length)) throw new Error("math.gl: ".concat(callerName, " some fields set to invalid numbers'"));
    return v;
}
const map = {};
function deprecated(method, version) {
    if (!map[method]) {
        map[method] = true;
        console.warn("".concat(method, " has been removed in version ").concat(version, ", see upgrade guide for more information"));
    }
}

},{"./common":"2Zxz7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6mCNm":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
/**
 * 3 Dimensional Vector
 * @module vec3
 */ /**
 * Creates a new, empty vec3
 *
 * @returns {vec3} a new 3D vector
 */ parcelHelpers.export(exports, "create", ()=>create);
/**
 * Creates a new vec3 initialized with values from an existing vector
 *
 * @param {ReadonlyVec3} a vector to clone
 * @returns {vec3} a new 3D vector
 */ parcelHelpers.export(exports, "clone", ()=>clone);
/**
 * Calculates the length of a vec3
 *
 * @param {ReadonlyVec3} a vector to calculate length of
 * @returns {Number} length of a
 */ parcelHelpers.export(exports, "length", ()=>length);
/**
 * Creates a new vec3 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @returns {vec3} a new 3D vector
 */ parcelHelpers.export(exports, "fromValues", ()=>fromValues);
/**
 * Copy the values from one vec3 to another
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the source vector
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "copy", ()=>copy);
/**
 * Set the components of a vec3 to the given values
 *
 * @param {vec3} out the receiving vector
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "set", ()=>set);
/**
 * Adds two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "add", ()=>add);
/**
 * Subtracts vector b from vector a
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "subtract", ()=>subtract);
/**
 * Multiplies two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "multiply", ()=>multiply);
/**
 * Divides two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "divide", ()=>divide);
/**
 * Math.ceil the components of a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a vector to ceil
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "ceil", ()=>ceil);
/**
 * Math.floor the components of a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a vector to floor
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "floor", ()=>floor);
/**
 * Returns the minimum of two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "min", ()=>min);
/**
 * Returns the maximum of two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "max", ()=>max);
/**
 * Math.round the components of a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a vector to round
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "round", ()=>round);
/**
 * Scales a vec3 by a scalar number
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the vector to scale
 * @param {Number} b amount to scale the vector by
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "scale", ()=>scale);
/**
 * Adds two vec3's after scaling the second operand by a scalar value
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @param {Number} scale the amount to scale b by before adding
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "scaleAndAdd", ()=>scaleAndAdd);
/**
 * Calculates the euclidian distance between two vec3's
 *
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {Number} distance between a and b
 */ parcelHelpers.export(exports, "distance", ()=>distance);
/**
 * Calculates the squared euclidian distance between two vec3's
 *
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {Number} squared distance between a and b
 */ parcelHelpers.export(exports, "squaredDistance", ()=>squaredDistance);
/**
 * Calculates the squared length of a vec3
 *
 * @param {ReadonlyVec3} a vector to calculate squared length of
 * @returns {Number} squared length of a
 */ parcelHelpers.export(exports, "squaredLength", ()=>squaredLength);
/**
 * Negates the components of a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a vector to negate
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "negate", ()=>negate);
/**
 * Returns the inverse of the components of a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a vector to invert
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "inverse", ()=>inverse);
/**
 * Normalize a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a vector to normalize
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "normalize", ()=>normalize);
/**
 * Calculates the dot product of two vec3's
 *
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {Number} dot product of a and b
 */ parcelHelpers.export(exports, "dot", ()=>dot);
/**
 * Computes the cross product of two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "cross", ()=>cross);
/**
 * Performs a linear interpolation between two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "lerp", ()=>lerp);
/**
 * Performs a hermite interpolation with two control points
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @param {ReadonlyVec3} c the third operand
 * @param {ReadonlyVec3} d the fourth operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "hermite", ()=>hermite);
/**
 * Performs a bezier interpolation with two control points
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @param {ReadonlyVec3} c the third operand
 * @param {ReadonlyVec3} d the fourth operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "bezier", ()=>bezier);
/**
 * Generates a random vector with the given scale
 *
 * @param {vec3} out the receiving vector
 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "random", ()=>random);
/**
 * Transforms the vec3 with a mat4.
 * 4th vector component is implicitly '1'
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the vector to transform
 * @param {ReadonlyMat4} m matrix to transform with
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "transformMat4", ()=>transformMat4);
/**
 * Transforms the vec3 with a mat3.
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the vector to transform
 * @param {ReadonlyMat3} m the 3x3 matrix to transform with
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "transformMat3", ()=>transformMat3);
/**
 * Transforms the vec3 with a quat
 * Can also be used for dual quaternions. (Multiply it with the real part)
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the vector to transform
 * @param {ReadonlyQuat} q quaternion to transform with
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "transformQuat", ()=>transformQuat);
/**
 * Rotate a 3D vector around the x-axis
 * @param {vec3} out The receiving vec3
 * @param {ReadonlyVec3} a The vec3 point to rotate
 * @param {ReadonlyVec3} b The origin of the rotation
 * @param {Number} rad The angle of rotation in radians
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "rotateX", ()=>rotateX);
/**
 * Rotate a 3D vector around the y-axis
 * @param {vec3} out The receiving vec3
 * @param {ReadonlyVec3} a The vec3 point to rotate
 * @param {ReadonlyVec3} b The origin of the rotation
 * @param {Number} rad The angle of rotation in radians
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "rotateY", ()=>rotateY);
/**
 * Rotate a 3D vector around the z-axis
 * @param {vec3} out The receiving vec3
 * @param {ReadonlyVec3} a The vec3 point to rotate
 * @param {ReadonlyVec3} b The origin of the rotation
 * @param {Number} rad The angle of rotation in radians
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "rotateZ", ()=>rotateZ);
/**
 * Get the angle between two 3D vectors
 * @param {ReadonlyVec3} a The first operand
 * @param {ReadonlyVec3} b The second operand
 * @returns {Number} The angle in radians
 */ parcelHelpers.export(exports, "angle", ()=>angle);
/**
 * Set the components of a vec3 to zero
 *
 * @param {vec3} out the receiving vector
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "zero", ()=>zero);
/**
 * Returns a string representation of a vector
 *
 * @param {ReadonlyVec3} a vector to represent as a string
 * @returns {String} string representation of the vector
 */ parcelHelpers.export(exports, "str", ()=>str);
/**
 * Returns whether or not the vectors have exactly the same elements in the same position (when compared with ===)
 *
 * @param {ReadonlyVec3} a The first vector.
 * @param {ReadonlyVec3} b The second vector.
 * @returns {Boolean} True if the vectors are equal, false otherwise.
 */ parcelHelpers.export(exports, "exactEquals", ()=>exactEquals);
/**
 * Returns whether or not the vectors have approximately the same elements in the same position.
 *
 * @param {ReadonlyVec3} a The first vector.
 * @param {ReadonlyVec3} b The second vector.
 * @returns {Boolean} True if the vectors are equal, false otherwise.
 */ parcelHelpers.export(exports, "equals", ()=>equals);
parcelHelpers.export(exports, "sub", ()=>sub);
parcelHelpers.export(exports, "mul", ()=>mul);
parcelHelpers.export(exports, "div", ()=>div);
parcelHelpers.export(exports, "dist", ()=>dist);
parcelHelpers.export(exports, "sqrDist", ()=>sqrDist);
parcelHelpers.export(exports, "len", ()=>len);
parcelHelpers.export(exports, "sqrLen", ()=>sqrLen);
parcelHelpers.export(exports, "forEach", ()=>forEach);
var _commonJs = require("./common.js");
function create() {
    var out = new _commonJs.ARRAY_TYPE(3);
    if (_commonJs.ARRAY_TYPE != Float32Array) {
        out[0] = 0;
        out[1] = 0;
        out[2] = 0;
    }
    return out;
}
function clone(a) {
    var out = new _commonJs.ARRAY_TYPE(3);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    return out;
}
function length(a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    return Math.hypot(x, y, z);
}
function fromValues(x, y, z) {
    var out = new _commonJs.ARRAY_TYPE(3);
    out[0] = x;
    out[1] = y;
    out[2] = z;
    return out;
}
function copy(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    return out;
}
function set(out, x, y, z) {
    out[0] = x;
    out[1] = y;
    out[2] = z;
    return out;
}
function add(out, a, b) {
    out[0] = a[0] + b[0];
    out[1] = a[1] + b[1];
    out[2] = a[2] + b[2];
    return out;
}
function subtract(out, a, b) {
    out[0] = a[0] - b[0];
    out[1] = a[1] - b[1];
    out[2] = a[2] - b[2];
    return out;
}
function multiply(out, a, b) {
    out[0] = a[0] * b[0];
    out[1] = a[1] * b[1];
    out[2] = a[2] * b[2];
    return out;
}
function divide(out, a, b) {
    out[0] = a[0] / b[0];
    out[1] = a[1] / b[1];
    out[2] = a[2] / b[2];
    return out;
}
function ceil(out, a) {
    out[0] = Math.ceil(a[0]);
    out[1] = Math.ceil(a[1]);
    out[2] = Math.ceil(a[2]);
    return out;
}
function floor(out, a) {
    out[0] = Math.floor(a[0]);
    out[1] = Math.floor(a[1]);
    out[2] = Math.floor(a[2]);
    return out;
}
function min(out, a, b) {
    out[0] = Math.min(a[0], b[0]);
    out[1] = Math.min(a[1], b[1]);
    out[2] = Math.min(a[2], b[2]);
    return out;
}
function max(out, a, b) {
    out[0] = Math.max(a[0], b[0]);
    out[1] = Math.max(a[1], b[1]);
    out[2] = Math.max(a[2], b[2]);
    return out;
}
function round(out, a) {
    out[0] = Math.round(a[0]);
    out[1] = Math.round(a[1]);
    out[2] = Math.round(a[2]);
    return out;
}
function scale(out, a, b) {
    out[0] = a[0] * b;
    out[1] = a[1] * b;
    out[2] = a[2] * b;
    return out;
}
function scaleAndAdd(out, a, b, scale) {
    out[0] = a[0] + b[0] * scale;
    out[1] = a[1] + b[1] * scale;
    out[2] = a[2] + b[2] * scale;
    return out;
}
function distance(a, b) {
    var x = b[0] - a[0];
    var y = b[1] - a[1];
    var z = b[2] - a[2];
    return Math.hypot(x, y, z);
}
function squaredDistance(a, b) {
    var x = b[0] - a[0];
    var y = b[1] - a[1];
    var z = b[2] - a[2];
    return x * x + y * y + z * z;
}
function squaredLength(a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    return x * x + y * y + z * z;
}
function negate(out, a) {
    out[0] = -a[0];
    out[1] = -a[1];
    out[2] = -a[2];
    return out;
}
function inverse(out, a) {
    out[0] = 1.0 / a[0];
    out[1] = 1.0 / a[1];
    out[2] = 1.0 / a[2];
    return out;
}
function normalize(out, a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    var len = x * x + y * y + z * z;
    if (len > 0) //TODO: evaluate use of glm_invsqrt here?
    len = 1 / Math.sqrt(len);
    out[0] = a[0] * len;
    out[1] = a[1] * len;
    out[2] = a[2] * len;
    return out;
}
function dot(a, b) {
    return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
}
function cross(out, a, b) {
    var ax = a[0], ay = a[1], az = a[2];
    var bx = b[0], by = b[1], bz = b[2];
    out[0] = ay * bz - az * by;
    out[1] = az * bx - ax * bz;
    out[2] = ax * by - ay * bx;
    return out;
}
function lerp(out, a, b, t) {
    var ax = a[0];
    var ay = a[1];
    var az = a[2];
    out[0] = ax + t * (b[0] - ax);
    out[1] = ay + t * (b[1] - ay);
    out[2] = az + t * (b[2] - az);
    return out;
}
function hermite(out, a, b, c, d, t) {
    var factorTimes2 = t * t;
    var factor1 = factorTimes2 * (2 * t - 3) + 1;
    var factor2 = factorTimes2 * (t - 2) + t;
    var factor3 = factorTimes2 * (t - 1);
    var factor4 = factorTimes2 * (3 - 2 * t);
    out[0] = a[0] * factor1 + b[0] * factor2 + c[0] * factor3 + d[0] * factor4;
    out[1] = a[1] * factor1 + b[1] * factor2 + c[1] * factor3 + d[1] * factor4;
    out[2] = a[2] * factor1 + b[2] * factor2 + c[2] * factor3 + d[2] * factor4;
    return out;
}
function bezier(out, a, b, c, d, t) {
    var inverseFactor = 1 - t;
    var inverseFactorTimesTwo = inverseFactor * inverseFactor;
    var factorTimes2 = t * t;
    var factor1 = inverseFactorTimesTwo * inverseFactor;
    var factor2 = 3 * t * inverseFactorTimesTwo;
    var factor3 = 3 * factorTimes2 * inverseFactor;
    var factor4 = factorTimes2 * t;
    out[0] = a[0] * factor1 + b[0] * factor2 + c[0] * factor3 + d[0] * factor4;
    out[1] = a[1] * factor1 + b[1] * factor2 + c[1] * factor3 + d[1] * factor4;
    out[2] = a[2] * factor1 + b[2] * factor2 + c[2] * factor3 + d[2] * factor4;
    return out;
}
function random(out, scale) {
    scale = scale || 1.0;
    var r = _commonJs.RANDOM() * 2.0 * Math.PI;
    var z = _commonJs.RANDOM() * 2.0 - 1.0;
    var zScale = Math.sqrt(1.0 - z * z) * scale;
    out[0] = Math.cos(r) * zScale;
    out[1] = Math.sin(r) * zScale;
    out[2] = z * scale;
    return out;
}
function transformMat4(out, a, m) {
    var x = a[0], y = a[1], z = a[2];
    var w = m[3] * x + m[7] * y + m[11] * z + m[15];
    w = w || 1.0;
    out[0] = (m[0] * x + m[4] * y + m[8] * z + m[12]) / w;
    out[1] = (m[1] * x + m[5] * y + m[9] * z + m[13]) / w;
    out[2] = (m[2] * x + m[6] * y + m[10] * z + m[14]) / w;
    return out;
}
function transformMat3(out, a, m) {
    var x = a[0], y = a[1], z = a[2];
    out[0] = x * m[0] + y * m[3] + z * m[6];
    out[1] = x * m[1] + y * m[4] + z * m[7];
    out[2] = x * m[2] + y * m[5] + z * m[8];
    return out;
}
function transformQuat(out, a, q) {
    // benchmarks: https://jsperf.com/quaternion-transform-vec3-implementations-fixed
    var qx = q[0], qy = q[1], qz = q[2], qw = q[3];
    var x = a[0], y = a[1], z = a[2]; // var qvec = [qx, qy, qz];
    // var uv = vec3.cross([], qvec, a);
    var uvx = qy * z - qz * y, uvy = qz * x - qx * z, uvz = qx * y - qy * x; // var uuv = vec3.cross([], qvec, uv);
    var uuvx = qy * uvz - qz * uvy, uuvy = qz * uvx - qx * uvz, uuvz = qx * uvy - qy * uvx; // vec3.scale(uv, uv, 2 * w);
    var w2 = qw * 2;
    uvx *= w2;
    uvy *= w2;
    uvz *= w2; // vec3.scale(uuv, uuv, 2);
    uuvx *= 2;
    uuvy *= 2;
    uuvz *= 2; // return vec3.add(out, a, vec3.add(out, uv, uuv));
    out[0] = x + uvx + uuvx;
    out[1] = y + uvy + uuvy;
    out[2] = z + uvz + uuvz;
    return out;
}
function rotateX(out, a, b, rad) {
    var p = [], r = []; //Translate point to the origin
    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2]; //perform rotation
    r[0] = p[0];
    r[1] = p[1] * Math.cos(rad) - p[2] * Math.sin(rad);
    r[2] = p[1] * Math.sin(rad) + p[2] * Math.cos(rad); //translate to correct position
    out[0] = r[0] + b[0];
    out[1] = r[1] + b[1];
    out[2] = r[2] + b[2];
    return out;
}
function rotateY(out, a, b, rad) {
    var p = [], r = []; //Translate point to the origin
    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2]; //perform rotation
    r[0] = p[2] * Math.sin(rad) + p[0] * Math.cos(rad);
    r[1] = p[1];
    r[2] = p[2] * Math.cos(rad) - p[0] * Math.sin(rad); //translate to correct position
    out[0] = r[0] + b[0];
    out[1] = r[1] + b[1];
    out[2] = r[2] + b[2];
    return out;
}
function rotateZ(out, a, b, rad) {
    var p = [], r = []; //Translate point to the origin
    p[0] = a[0] - b[0];
    p[1] = a[1] - b[1];
    p[2] = a[2] - b[2]; //perform rotation
    r[0] = p[0] * Math.cos(rad) - p[1] * Math.sin(rad);
    r[1] = p[0] * Math.sin(rad) + p[1] * Math.cos(rad);
    r[2] = p[2]; //translate to correct position
    out[0] = r[0] + b[0];
    out[1] = r[1] + b[1];
    out[2] = r[2] + b[2];
    return out;
}
function angle(a, b) {
    var ax = a[0], ay = a[1], az = a[2], bx = b[0], by = b[1], bz = b[2], mag1 = Math.sqrt(ax * ax + ay * ay + az * az), mag2 = Math.sqrt(bx * bx + by * by + bz * bz), mag = mag1 * mag2, cosine = mag && dot(a, b) / mag;
    return Math.acos(Math.min(Math.max(cosine, -1), 1));
}
function zero(out) {
    out[0] = 0.0;
    out[1] = 0.0;
    out[2] = 0.0;
    return out;
}
function str(a) {
    return "vec3(" + a[0] + ", " + a[1] + ", " + a[2] + ")";
}
function exactEquals(a, b) {
    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2];
}
function equals(a, b) {
    var a0 = a[0], a1 = a[1], a2 = a[2];
    var b0 = b[0], b1 = b[1], b2 = b[2];
    return Math.abs(a0 - b0) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a0), Math.abs(b0)) && Math.abs(a1 - b1) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a1), Math.abs(b1)) && Math.abs(a2 - b2) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a2), Math.abs(b2));
}
var sub = subtract;
var mul = multiply;
var div = divide;
var dist = distance;
var sqrDist = squaredDistance;
var len = length;
var sqrLen = squaredLength;
var forEach = function() {
    var vec = create();
    return function(a, stride, offset, count, fn, arg) {
        var i, l;
        if (!stride) stride = 3;
        if (!offset) offset = 0;
        if (count) l = Math.min(count * stride + offset, a.length);
        else l = a.length;
        for(i = offset; i < l; i += stride){
            vec[0] = a[i];
            vec[1] = a[i + 1];
            vec[2] = a[i + 2];
            fn(vec, vec, arg);
            a[i] = vec[0];
            a[i + 1] = vec[1];
            a[i + 2] = vec[2];
        }
        return a;
    };
}();

},{"./common.js":"lYeTq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lYeTq":[function(require,module,exports) {
/**
 * Common utilities
 * @module glMatrix
 */ // Configuration Constants
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "EPSILON", ()=>EPSILON);
parcelHelpers.export(exports, "ARRAY_TYPE", ()=>ARRAY_TYPE);
parcelHelpers.export(exports, "RANDOM", ()=>RANDOM);
/**
 * Sets the type of array used when creating new vectors and matrices
 *
 * @param {Float32ArrayConstructor | ArrayConstructor} type Array type, such as Float32Array or Array
 */ parcelHelpers.export(exports, "setMatrixArrayType", ()=>setMatrixArrayType);
/**
 * Convert Degree To Radian
 *
 * @param {Number} a Angle in Degrees
 */ parcelHelpers.export(exports, "toRadian", ()=>toRadian);
/**
 * Tests whether or not the arguments have approximately the same value, within an absolute
 * or relative tolerance of glMatrix.EPSILON (an absolute tolerance is used for values less
 * than or equal to 1.0, and a relative tolerance is used for larger values)
 *
 * @param {Number} a The first number to test.
 * @param {Number} b The second number to test.
 * @returns {Boolean} True if the numbers are approximately equal, false otherwise.
 */ parcelHelpers.export(exports, "equals", ()=>equals);
var EPSILON = 0.000001;
var ARRAY_TYPE = typeof Float32Array !== "undefined" ? Float32Array : Array;
var RANDOM = Math.random;
function setMatrixArrayType(type) {
    ARRAY_TYPE = type;
}
var degree = Math.PI / 180;
function toRadian(a) {
    return a * degree;
}
function equals(a, b) {
    return Math.abs(a - b) <= EPSILON * Math.max(1.0, Math.abs(a), Math.abs(b));
}
if (!Math.hypot) Math.hypot = function() {
    var y = 0, i = arguments.length;
    while(i--)y += arguments[i] * arguments[i];
    return Math.sqrt(y);
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6HqSa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "vec2_transformMat4AsVector", ()=>vec2_transformMat4AsVector);
parcelHelpers.export(exports, "vec3_transformMat4AsVector", ()=>vec3_transformMat4AsVector);
parcelHelpers.export(exports, "vec3_transformMat2", ()=>vec3_transformMat2);
parcelHelpers.export(exports, "vec4_transformMat2", ()=>vec4_transformMat2);
parcelHelpers.export(exports, "vec4_transformMat3", ()=>vec4_transformMat3);
function vec2_transformMat4AsVector(out, a, m) {
    const x = a[0];
    const y = a[1];
    const w = m[3] * x + m[7] * y || 1.0;
    out[0] = (m[0] * x + m[4] * y) / w;
    out[1] = (m[1] * x + m[5] * y) / w;
    return out;
}
function vec3_transformMat4AsVector(out, a, m) {
    const x = a[0];
    const y = a[1];
    const z = a[2];
    const w = m[3] * x + m[7] * y + m[11] * z || 1.0;
    out[0] = (m[0] * x + m[4] * y + m[8] * z) / w;
    out[1] = (m[1] * x + m[5] * y + m[9] * z) / w;
    out[2] = (m[2] * x + m[6] * y + m[10] * z) / w;
    return out;
}
function vec3_transformMat2(out, a, m) {
    const x = a[0];
    const y = a[1];
    out[0] = m[0] * x + m[2] * y;
    out[1] = m[1] * x + m[3] * y;
    out[2] = a[2];
    return out;
}
function vec4_transformMat2(out, a, m) {
    const x = a[0];
    const y = a[1];
    out[0] = m[0] * x + m[2] * y;
    out[1] = m[1] * x + m[3] * y;
    out[2] = a[2];
    out[3] = a[3];
    return out;
}
function vec4_transformMat3(out, a, m) {
    const x = a[0];
    const y = a[1];
    const z = a[2];
    out[0] = m[0] * x + m[3] * y + m[6] * z;
    out[1] = m[1] * x + m[4] * y + m[7] * z;
    out[2] = m[2] * x + m[5] * y + m[8] * z;
    out[3] = a[3];
    return out;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6HeZ9":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _matrix = require("./base/matrix");
var _matrixDefault = parcelHelpers.interopDefault(_matrix);
var _validators = require("../lib/validators");
var _glMatrixExtras = require("../lib/gl-matrix-extras");
var _mat4 = require("gl-matrix/mat4");
var _vec2 = require("gl-matrix/vec2");
var _vec3 = require("gl-matrix/vec3");
var _vec4 = require("gl-matrix/vec4");
var INDICES;
(function(INDICES) {
    INDICES[INDICES["COL0ROW0"] = 0] = "COL0ROW0";
    INDICES[INDICES["COL0ROW1"] = 1] = "COL0ROW1";
    INDICES[INDICES["COL0ROW2"] = 2] = "COL0ROW2";
    INDICES[INDICES["COL0ROW3"] = 3] = "COL0ROW3";
    INDICES[INDICES["COL1ROW0"] = 4] = "COL1ROW0";
    INDICES[INDICES["COL1ROW1"] = 5] = "COL1ROW1";
    INDICES[INDICES["COL1ROW2"] = 6] = "COL1ROW2";
    INDICES[INDICES["COL1ROW3"] = 7] = "COL1ROW3";
    INDICES[INDICES["COL2ROW0"] = 8] = "COL2ROW0";
    INDICES[INDICES["COL2ROW1"] = 9] = "COL2ROW1";
    INDICES[INDICES["COL2ROW2"] = 10] = "COL2ROW2";
    INDICES[INDICES["COL2ROW3"] = 11] = "COL2ROW3";
    INDICES[INDICES["COL3ROW0"] = 12] = "COL3ROW0";
    INDICES[INDICES["COL3ROW1"] = 13] = "COL3ROW1";
    INDICES[INDICES["COL3ROW2"] = 14] = "COL3ROW2";
    INDICES[INDICES["COL3ROW3"] = 15] = "COL3ROW3";
})(INDICES || (INDICES = {}));
const DEFAULT_FOVY = 45 * Math.PI / 180;
const DEFAULT_ASPECT = 1;
const DEFAULT_NEAR = 0.1;
const DEFAULT_FAR = 500;
const IDENTITY_MATRIX = Object.freeze([
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    1
]);
class Matrix4 extends (0, _matrixDefault.default) {
    static get IDENTITY() {
        return getIdentityMatrix();
    }
    static get ZERO() {
        return getZeroMatrix();
    }
    get ELEMENTS() {
        return 16;
    }
    get RANK() {
        return 4;
    }
    get INDICES() {
        return INDICES;
    }
    constructor(array){
        super(-0, -0, -0, -0, -0, -0, -0, -0, -0, -0, -0, -0, -0, -0, -0, -0);
        if (arguments.length === 1 && Array.isArray(array)) this.copy(array);
        else this.identity();
    }
    copy(array) {
        this[0] = array[0];
        this[1] = array[1];
        this[2] = array[2];
        this[3] = array[3];
        this[4] = array[4];
        this[5] = array[5];
        this[6] = array[6];
        this[7] = array[7];
        this[8] = array[8];
        this[9] = array[9];
        this[10] = array[10];
        this[11] = array[11];
        this[12] = array[12];
        this[13] = array[13];
        this[14] = array[14];
        this[15] = array[15];
        return this.check();
    }
    set(m00, m10, m20, m30, m01, m11, m21, m31, m02, m12, m22, m32, m03, m13, m23, m33) {
        this[0] = m00;
        this[1] = m10;
        this[2] = m20;
        this[3] = m30;
        this[4] = m01;
        this[5] = m11;
        this[6] = m21;
        this[7] = m31;
        this[8] = m02;
        this[9] = m12;
        this[10] = m22;
        this[11] = m32;
        this[12] = m03;
        this[13] = m13;
        this[14] = m23;
        this[15] = m33;
        return this.check();
    }
    setRowMajor(m00, m01, m02, m03, m10, m11, m12, m13, m20, m21, m22, m23, m30, m31, m32, m33) {
        this[0] = m00;
        this[1] = m10;
        this[2] = m20;
        this[3] = m30;
        this[4] = m01;
        this[5] = m11;
        this[6] = m21;
        this[7] = m31;
        this[8] = m02;
        this[9] = m12;
        this[10] = m22;
        this[11] = m32;
        this[12] = m03;
        this[13] = m13;
        this[14] = m23;
        this[15] = m33;
        return this.check();
    }
    toRowMajor(result) {
        result[0] = this[0];
        result[1] = this[4];
        result[2] = this[8];
        result[3] = this[12];
        result[4] = this[1];
        result[5] = this[5];
        result[6] = this[9];
        result[7] = this[13];
        result[8] = this[2];
        result[9] = this[6];
        result[10] = this[10];
        result[11] = this[14];
        result[12] = this[3];
        result[13] = this[7];
        result[14] = this[11];
        result[15] = this[15];
        return result;
    }
    identity() {
        return this.copy(IDENTITY_MATRIX);
    }
    fromObject(object) {
        return this.check();
    }
    fromQuaternion(quaternion) {
        _mat4.fromQuat(this, quaternion);
        return this.check();
    }
    frustum(view) {
        const { left , right , bottom , top , near =DEFAULT_NEAR , far =DEFAULT_FAR  } = view;
        if (far === Infinity) computeInfinitePerspectiveOffCenter(this, left, right, bottom, top, near);
        else _mat4.frustum(this, left, right, bottom, top, near, far);
        return this.check();
    }
    lookAt(view) {
        const { eye , center =[
            0,
            0,
            0
        ] , up =[
            0,
            1,
            0
        ]  } = view;
        _mat4.lookAt(this, eye, center, up);
        return this.check();
    }
    ortho(view) {
        const { left , right , bottom , top , near =DEFAULT_NEAR , far =DEFAULT_FAR  } = view;
        _mat4.ortho(this, left, right, bottom, top, near, far);
        return this.check();
    }
    orthographic(view) {
        const { fovy =DEFAULT_FOVY , aspect =DEFAULT_ASPECT , focalDistance =1 , near =DEFAULT_NEAR , far =DEFAULT_FAR  } = view;
        checkRadians(fovy);
        const halfY = fovy / 2;
        const top = focalDistance * Math.tan(halfY);
        const right = top * aspect;
        return this.ortho({
            left: -right,
            right,
            bottom: -top,
            top,
            near,
            far
        });
    }
    perspective(view) {
        const { fovy =45 * Math.PI / 180 , aspect =1 , near =0.1 , far =500  } = view;
        checkRadians(fovy);
        _mat4.perspective(this, fovy, aspect, near, far);
        return this.check();
    }
    determinant() {
        return _mat4.determinant(this);
    }
    getScale(result = [
        -0,
        -0,
        -0
    ]) {
        result[0] = Math.sqrt(this[0] * this[0] + this[1] * this[1] + this[2] * this[2]);
        result[1] = Math.sqrt(this[4] * this[4] + this[5] * this[5] + this[6] * this[6]);
        result[2] = Math.sqrt(this[8] * this[8] + this[9] * this[9] + this[10] * this[10]);
        return result;
    }
    getTranslation(result = [
        -0,
        -0,
        -0
    ]) {
        result[0] = this[12];
        result[1] = this[13];
        result[2] = this[14];
        return result;
    }
    getRotation(result, scaleResult) {
        result = result || [
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0
        ];
        scaleResult = scaleResult || [
            -0,
            -0,
            -0
        ];
        const scale = this.getScale(scaleResult);
        const inverseScale0 = 1 / scale[0];
        const inverseScale1 = 1 / scale[1];
        const inverseScale2 = 1 / scale[2];
        result[0] = this[0] * inverseScale0;
        result[1] = this[1] * inverseScale1;
        result[2] = this[2] * inverseScale2;
        result[3] = 0;
        result[4] = this[4] * inverseScale0;
        result[5] = this[5] * inverseScale1;
        result[6] = this[6] * inverseScale2;
        result[7] = 0;
        result[8] = this[8] * inverseScale0;
        result[9] = this[9] * inverseScale1;
        result[10] = this[10] * inverseScale2;
        result[11] = 0;
        result[12] = 0;
        result[13] = 0;
        result[14] = 0;
        result[15] = 1;
        return result;
    }
    getRotationMatrix3(result, scaleResult) {
        result = result || [
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0,
            -0
        ];
        scaleResult = scaleResult || [
            -0,
            -0,
            -0
        ];
        const scale = this.getScale(scaleResult);
        const inverseScale0 = 1 / scale[0];
        const inverseScale1 = 1 / scale[1];
        const inverseScale2 = 1 / scale[2];
        result[0] = this[0] * inverseScale0;
        result[1] = this[1] * inverseScale1;
        result[2] = this[2] * inverseScale2;
        result[3] = this[4] * inverseScale0;
        result[4] = this[5] * inverseScale1;
        result[5] = this[6] * inverseScale2;
        result[6] = this[8] * inverseScale0;
        result[7] = this[9] * inverseScale1;
        result[8] = this[10] * inverseScale2;
        return result;
    }
    transpose() {
        _mat4.transpose(this, this);
        return this.check();
    }
    invert() {
        _mat4.invert(this, this);
        return this.check();
    }
    multiplyLeft(a) {
        _mat4.multiply(this, a, this);
        return this.check();
    }
    multiplyRight(a) {
        _mat4.multiply(this, this, a);
        return this.check();
    }
    rotateX(radians) {
        _mat4.rotateX(this, this, radians);
        return this.check();
    }
    rotateY(radians) {
        _mat4.rotateY(this, this, radians);
        return this.check();
    }
    rotateZ(radians) {
        _mat4.rotateZ(this, this, radians);
        return this.check();
    }
    rotateXYZ(angleXYZ) {
        return this.rotateX(angleXYZ[0]).rotateY(angleXYZ[1]).rotateZ(angleXYZ[2]);
    }
    rotateAxis(radians, axis) {
        _mat4.rotate(this, this, radians, axis);
        return this.check();
    }
    scale(factor) {
        _mat4.scale(this, this, Array.isArray(factor) ? factor : [
            factor,
            factor,
            factor
        ]);
        return this.check();
    }
    translate(vector) {
        _mat4.translate(this, this, vector);
        return this.check();
    }
    transform(vector, result) {
        if (vector.length === 4) {
            result = _vec4.transformMat4(result || [
                -0,
                -0,
                -0,
                -0
            ], vector, this);
            (0, _validators.checkVector)(result, 4);
            return result;
        }
        return this.transformAsPoint(vector, result);
    }
    transformAsPoint(vector, result) {
        const { length  } = vector;
        let out;
        switch(length){
            case 2:
                out = _vec2.transformMat4(result || [
                    -0,
                    -0
                ], vector, this);
                break;
            case 3:
                out = _vec3.transformMat4(result || [
                    -0,
                    -0,
                    -0
                ], vector, this);
                break;
            default:
                throw new Error("Illegal vector");
        }
        (0, _validators.checkVector)(out, vector.length);
        return out;
    }
    transformAsVector(vector, result) {
        let out;
        switch(vector.length){
            case 2:
                out = (0, _glMatrixExtras.vec2_transformMat4AsVector)(result || [
                    -0,
                    -0
                ], vector, this);
                break;
            case 3:
                out = (0, _glMatrixExtras.vec3_transformMat4AsVector)(result || [
                    -0,
                    -0,
                    -0
                ], vector, this);
                break;
            default:
                throw new Error("Illegal vector");
        }
        (0, _validators.checkVector)(out, vector.length);
        return out;
    }
    transformPoint(vector, result) {
        return this.transformAsPoint(vector, result);
    }
    transformVector(vector, result) {
        return this.transformAsPoint(vector, result);
    }
    transformDirection(vector, result) {
        return this.transformAsVector(vector, result);
    }
    makeRotationX(radians) {
        return this.identity().rotateX(radians);
    }
    makeTranslation(x, y, z) {
        return this.identity().translate([
            x,
            y,
            z
        ]);
    }
}
exports.default = Matrix4;
let ZERO;
let IDENTITY;
function getZeroMatrix() {
    if (!ZERO) {
        ZERO = new Matrix4([
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0,
            0
        ]);
        Object.freeze(ZERO);
    }
    return ZERO;
}
function getIdentityMatrix() {
    if (!IDENTITY) {
        IDENTITY = new Matrix4();
        Object.freeze(IDENTITY);
    }
    return IDENTITY;
}
function checkRadians(possiblyDegrees) {
    if (possiblyDegrees > Math.PI * 2) throw Error("expected radians");
}
function computeInfinitePerspectiveOffCenter(result, left, right, bottom, top, near) {
    const column0Row0 = 2 * near / (right - left);
    const column1Row1 = 2 * near / (top - bottom);
    const column2Row0 = (right + left) / (right - left);
    const column2Row1 = (top + bottom) / (top - bottom);
    const column2Row2 = -1;
    const column2Row3 = -1;
    const column3Row2 = -2 * near;
    result[0] = column0Row0;
    result[1] = 0;
    result[2] = 0;
    result[3] = 0;
    result[4] = 0;
    result[5] = column1Row1;
    result[6] = 0;
    result[7] = 0;
    result[8] = column2Row0;
    result[9] = column2Row1;
    result[10] = column2Row2;
    result[11] = column2Row3;
    result[12] = 0;
    result[13] = 0;
    result[14] = column3Row2;
    result[15] = 0;
    return result;
}

},{"./base/matrix":"6lVsd","../lib/validators":"s14oj","../lib/gl-matrix-extras":"6HqSa","gl-matrix/mat4":"eQTXr","gl-matrix/vec2":"5mYHR","gl-matrix/vec3":"6mCNm","gl-matrix/vec4":"lplGD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6lVsd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _mathArray = require("./math-array");
var _mathArrayDefault = parcelHelpers.interopDefault(_mathArray);
var _validators = require("../../lib/validators");
var _common = require("../../lib/common");
class Matrix extends (0, _mathArrayDefault.default) {
    toString() {
        let string = "[";
        if ((0, _common.config).printRowMajor) {
            string += "row-major:";
            for(let row = 0; row < this.RANK; ++row)for(let col = 0; col < this.RANK; ++col)string += " ".concat(this[col * this.RANK + row]);
        } else {
            string += "column-major:";
            for(let i = 0; i < this.ELEMENTS; ++i)string += " ".concat(this[i]);
        }
        string += "]";
        return string;
    }
    getElementIndex(row, col) {
        return col * this.RANK + row;
    }
    getElement(row, col) {
        return this[col * this.RANK + row];
    }
    setElement(row, col, value) {
        this[col * this.RANK + row] = (0, _validators.checkNumber)(value);
        return this;
    }
    getColumn(columnIndex, result = new Array(this.RANK).fill(-0)) {
        const firstIndex = columnIndex * this.RANK;
        for(let i = 0; i < this.RANK; ++i)result[i] = this[firstIndex + i];
        return result;
    }
    setColumn(columnIndex, columnVector) {
        const firstIndex = columnIndex * this.RANK;
        for(let i = 0; i < this.RANK; ++i)this[firstIndex + i] = columnVector[i];
        return this;
    }
}
exports.default = Matrix;

},{"./math-array":"lJCLX","../../lib/validators":"s14oj","../../lib/common":"2Zxz7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eQTXr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
/**
 * 4x4 Matrix<br>Format: column-major, when typed out it looks like row-major<br>The matrices are being post multiplied.
 * @module mat4
 */ /**
 * Creates a new identity mat4
 *
 * @returns {mat4} a new 4x4 matrix
 */ parcelHelpers.export(exports, "create", ()=>create);
/**
 * Creates a new mat4 initialized with values from an existing matrix
 *
 * @param {ReadonlyMat4} a matrix to clone
 * @returns {mat4} a new 4x4 matrix
 */ parcelHelpers.export(exports, "clone", ()=>clone);
/**
 * Copy the values from one mat4 to another
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the source matrix
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "copy", ()=>copy);
/**
 * Create a new mat4 with the given values
 *
 * @param {Number} m00 Component in column 0, row 0 position (index 0)
 * @param {Number} m01 Component in column 0, row 1 position (index 1)
 * @param {Number} m02 Component in column 0, row 2 position (index 2)
 * @param {Number} m03 Component in column 0, row 3 position (index 3)
 * @param {Number} m10 Component in column 1, row 0 position (index 4)
 * @param {Number} m11 Component in column 1, row 1 position (index 5)
 * @param {Number} m12 Component in column 1, row 2 position (index 6)
 * @param {Number} m13 Component in column 1, row 3 position (index 7)
 * @param {Number} m20 Component in column 2, row 0 position (index 8)
 * @param {Number} m21 Component in column 2, row 1 position (index 9)
 * @param {Number} m22 Component in column 2, row 2 position (index 10)
 * @param {Number} m23 Component in column 2, row 3 position (index 11)
 * @param {Number} m30 Component in column 3, row 0 position (index 12)
 * @param {Number} m31 Component in column 3, row 1 position (index 13)
 * @param {Number} m32 Component in column 3, row 2 position (index 14)
 * @param {Number} m33 Component in column 3, row 3 position (index 15)
 * @returns {mat4} A new mat4
 */ parcelHelpers.export(exports, "fromValues", ()=>fromValues);
/**
 * Set the components of a mat4 to the given values
 *
 * @param {mat4} out the receiving matrix
 * @param {Number} m00 Component in column 0, row 0 position (index 0)
 * @param {Number} m01 Component in column 0, row 1 position (index 1)
 * @param {Number} m02 Component in column 0, row 2 position (index 2)
 * @param {Number} m03 Component in column 0, row 3 position (index 3)
 * @param {Number} m10 Component in column 1, row 0 position (index 4)
 * @param {Number} m11 Component in column 1, row 1 position (index 5)
 * @param {Number} m12 Component in column 1, row 2 position (index 6)
 * @param {Number} m13 Component in column 1, row 3 position (index 7)
 * @param {Number} m20 Component in column 2, row 0 position (index 8)
 * @param {Number} m21 Component in column 2, row 1 position (index 9)
 * @param {Number} m22 Component in column 2, row 2 position (index 10)
 * @param {Number} m23 Component in column 2, row 3 position (index 11)
 * @param {Number} m30 Component in column 3, row 0 position (index 12)
 * @param {Number} m31 Component in column 3, row 1 position (index 13)
 * @param {Number} m32 Component in column 3, row 2 position (index 14)
 * @param {Number} m33 Component in column 3, row 3 position (index 15)
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "set", ()=>set);
/**
 * Set a mat4 to the identity matrix
 *
 * @param {mat4} out the receiving matrix
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "identity", ()=>identity);
/**
 * Transpose the values of a mat4
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the source matrix
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "transpose", ()=>transpose);
/**
 * Inverts a mat4
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the source matrix
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "invert", ()=>invert);
/**
 * Calculates the adjugate of a mat4
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the source matrix
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "adjoint", ()=>adjoint);
/**
 * Calculates the determinant of a mat4
 *
 * @param {ReadonlyMat4} a the source matrix
 * @returns {Number} determinant of a
 */ parcelHelpers.export(exports, "determinant", ()=>determinant);
/**
 * Multiplies two mat4s
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the first operand
 * @param {ReadonlyMat4} b the second operand
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "multiply", ()=>multiply);
/**
 * Translate a mat4 by the given vector
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the matrix to translate
 * @param {ReadonlyVec3} v vector to translate by
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "translate", ()=>translate);
/**
 * Scales the mat4 by the dimensions in the given vec3 not using vectorization
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the matrix to scale
 * @param {ReadonlyVec3} v the vec3 to scale the matrix by
 * @returns {mat4} out
 **/ parcelHelpers.export(exports, "scale", ()=>scale);
/**
 * Rotates a mat4 by the given angle around the given axis
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @param {ReadonlyVec3} axis the axis to rotate around
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "rotate", ()=>rotate);
/**
 * Rotates a matrix by the given angle around the X axis
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "rotateX", ()=>rotateX);
/**
 * Rotates a matrix by the given angle around the Y axis
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "rotateY", ()=>rotateY);
/**
 * Rotates a matrix by the given angle around the Z axis
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the matrix to rotate
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "rotateZ", ()=>rotateZ);
/**
 * Creates a matrix from a vector translation
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.translate(dest, dest, vec);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {ReadonlyVec3} v Translation vector
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromTranslation", ()=>fromTranslation);
/**
 * Creates a matrix from a vector scaling
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.scale(dest, dest, vec);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {ReadonlyVec3} v Scaling vector
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromScaling", ()=>fromScaling);
/**
 * Creates a matrix from a given angle around a given axis
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.rotate(dest, dest, rad, axis);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {Number} rad the angle to rotate the matrix by
 * @param {ReadonlyVec3} axis the axis to rotate around
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromRotation", ()=>fromRotation);
/**
 * Creates a matrix from the given angle around the X axis
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.rotateX(dest, dest, rad);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromXRotation", ()=>fromXRotation);
/**
 * Creates a matrix from the given angle around the Y axis
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.rotateY(dest, dest, rad);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromYRotation", ()=>fromYRotation);
/**
 * Creates a matrix from the given angle around the Z axis
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.rotateZ(dest, dest, rad);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {Number} rad the angle to rotate the matrix by
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromZRotation", ()=>fromZRotation);
/**
 * Creates a matrix from a quaternion rotation and vector translation
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.translate(dest, vec);
 *     let quatMat = mat4.create();
 *     quat4.toMat4(quat, quatMat);
 *     mat4.multiply(dest, quatMat);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {quat4} q Rotation quaternion
 * @param {ReadonlyVec3} v Translation vector
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromRotationTranslation", ()=>fromRotationTranslation);
/**
 * Creates a new mat4 from a dual quat.
 *
 * @param {mat4} out Matrix
 * @param {ReadonlyQuat2} a Dual Quaternion
 * @returns {mat4} mat4 receiving operation result
 */ parcelHelpers.export(exports, "fromQuat2", ()=>fromQuat2);
/**
 * Returns the translation vector component of a transformation
 *  matrix. If a matrix is built with fromRotationTranslation,
 *  the returned vector will be the same as the translation vector
 *  originally supplied.
 * @param  {vec3} out Vector to receive translation component
 * @param  {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {vec3} out
 */ parcelHelpers.export(exports, "getTranslation", ()=>getTranslation);
/**
 * Returns the scaling factor component of a transformation
 *  matrix. If a matrix is built with fromRotationTranslationScale
 *  with a normalized Quaternion paramter, the returned vector will be
 *  the same as the scaling vector
 *  originally supplied.
 * @param  {vec3} out Vector to receive scaling factor component
 * @param  {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {vec3} out
 */ parcelHelpers.export(exports, "getScaling", ()=>getScaling);
/**
 * Returns a quaternion representing the rotational component
 *  of a transformation matrix. If a matrix is built with
 *  fromRotationTranslation, the returned quaternion will be the
 *  same as the quaternion originally supplied.
 * @param {quat} out Quaternion to receive the rotation component
 * @param {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {quat} out
 */ parcelHelpers.export(exports, "getRotation", ()=>getRotation);
/**
 * Creates a matrix from a quaternion rotation, vector translation and vector scale
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.translate(dest, vec);
 *     let quatMat = mat4.create();
 *     quat4.toMat4(quat, quatMat);
 *     mat4.multiply(dest, quatMat);
 *     mat4.scale(dest, scale)
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {quat4} q Rotation quaternion
 * @param {ReadonlyVec3} v Translation vector
 * @param {ReadonlyVec3} s Scaling vector
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromRotationTranslationScale", ()=>fromRotationTranslationScale);
/**
 * Creates a matrix from a quaternion rotation, vector translation and vector scale, rotating and scaling around the given origin
 * This is equivalent to (but much faster than):
 *
 *     mat4.identity(dest);
 *     mat4.translate(dest, vec);
 *     mat4.translate(dest, origin);
 *     let quatMat = mat4.create();
 *     quat4.toMat4(quat, quatMat);
 *     mat4.multiply(dest, quatMat);
 *     mat4.scale(dest, scale)
 *     mat4.translate(dest, negativeOrigin);
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {quat4} q Rotation quaternion
 * @param {ReadonlyVec3} v Translation vector
 * @param {ReadonlyVec3} s Scaling vector
 * @param {ReadonlyVec3} o The origin vector around which to scale and rotate
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromRotationTranslationScaleOrigin", ()=>fromRotationTranslationScaleOrigin);
/**
 * Calculates a 4x4 matrix from the given quaternion
 *
 * @param {mat4} out mat4 receiving operation result
 * @param {ReadonlyQuat} q Quaternion to create matrix from
 *
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "fromQuat", ()=>fromQuat);
/**
 * Generates a frustum matrix with the given bounds
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {Number} left Left bound of the frustum
 * @param {Number} right Right bound of the frustum
 * @param {Number} bottom Bottom bound of the frustum
 * @param {Number} top Top bound of the frustum
 * @param {Number} near Near bound of the frustum
 * @param {Number} far Far bound of the frustum
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "frustum", ()=>frustum);
/**
 * Generates a perspective projection matrix with the given bounds.
 * The near/far clip planes correspond to a normalized device coordinate Z range of [-1, 1],
 * which matches WebGL/OpenGL's clip volume.
 * Passing null/undefined/no value for far will generate infinite projection matrix.
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {number} fovy Vertical field of view in radians
 * @param {number} aspect Aspect ratio. typically viewport width/height
 * @param {number} near Near bound of the frustum
 * @param {number} far Far bound of the frustum, can be null or Infinity
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "perspectiveNO", ()=>perspectiveNO);
parcelHelpers.export(exports, "perspective", ()=>perspective);
/**
 * Generates a perspective projection matrix suitable for WebGPU with the given bounds.
 * The near/far clip planes correspond to a normalized device coordinate Z range of [0, 1],
 * which matches WebGPU/Vulkan/DirectX/Metal's clip volume.
 * Passing null/undefined/no value for far will generate infinite projection matrix.
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {number} fovy Vertical field of view in radians
 * @param {number} aspect Aspect ratio. typically viewport width/height
 * @param {number} near Near bound of the frustum
 * @param {number} far Far bound of the frustum, can be null or Infinity
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "perspectiveZO", ()=>perspectiveZO);
/**
 * Generates a perspective projection matrix with the given field of view.
 * This is primarily useful for generating projection matrices to be used
 * with the still experiemental WebVR API.
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {Object} fov Object containing the following values: upDegrees, downDegrees, leftDegrees, rightDegrees
 * @param {number} near Near bound of the frustum
 * @param {number} far Far bound of the frustum
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "perspectiveFromFieldOfView", ()=>perspectiveFromFieldOfView);
/**
 * Generates a orthogonal projection matrix with the given bounds.
 * The near/far clip planes correspond to a normalized device coordinate Z range of [-1, 1],
 * which matches WebGL/OpenGL's clip volume.
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {number} left Left bound of the frustum
 * @param {number} right Right bound of the frustum
 * @param {number} bottom Bottom bound of the frustum
 * @param {number} top Top bound of the frustum
 * @param {number} near Near bound of the frustum
 * @param {number} far Far bound of the frustum
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "orthoNO", ()=>orthoNO);
parcelHelpers.export(exports, "ortho", ()=>ortho);
/**
 * Generates a orthogonal projection matrix with the given bounds.
 * The near/far clip planes correspond to a normalized device coordinate Z range of [0, 1],
 * which matches WebGPU/Vulkan/DirectX/Metal's clip volume.
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {number} left Left bound of the frustum
 * @param {number} right Right bound of the frustum
 * @param {number} bottom Bottom bound of the frustum
 * @param {number} top Top bound of the frustum
 * @param {number} near Near bound of the frustum
 * @param {number} far Far bound of the frustum
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "orthoZO", ()=>orthoZO);
/**
 * Generates a look-at matrix with the given eye position, focal point, and up axis.
 * If you want a matrix that actually makes an object look at another object, you should use targetTo instead.
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {ReadonlyVec3} eye Position of the viewer
 * @param {ReadonlyVec3} center Point the viewer is looking at
 * @param {ReadonlyVec3} up vec3 pointing up
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "lookAt", ()=>lookAt);
/**
 * Generates a matrix that makes something look at something else.
 *
 * @param {mat4} out mat4 frustum matrix will be written into
 * @param {ReadonlyVec3} eye Position of the viewer
 * @param {ReadonlyVec3} center Point the viewer is looking at
 * @param {ReadonlyVec3} up vec3 pointing up
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "targetTo", ()=>targetTo);
/**
 * Returns a string representation of a mat4
 *
 * @param {ReadonlyMat4} a matrix to represent as a string
 * @returns {String} string representation of the matrix
 */ parcelHelpers.export(exports, "str", ()=>str);
/**
 * Returns Frobenius norm of a mat4
 *
 * @param {ReadonlyMat4} a the matrix to calculate Frobenius norm of
 * @returns {Number} Frobenius norm
 */ parcelHelpers.export(exports, "frob", ()=>frob);
/**
 * Adds two mat4's
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the first operand
 * @param {ReadonlyMat4} b the second operand
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "add", ()=>add);
/**
 * Subtracts matrix b from matrix a
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the first operand
 * @param {ReadonlyMat4} b the second operand
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "subtract", ()=>subtract);
/**
 * Multiply each element of the matrix by a scalar.
 *
 * @param {mat4} out the receiving matrix
 * @param {ReadonlyMat4} a the matrix to scale
 * @param {Number} b amount to scale the matrix's elements by
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "multiplyScalar", ()=>multiplyScalar);
/**
 * Adds two mat4's after multiplying each element of the second operand by a scalar value.
 *
 * @param {mat4} out the receiving vector
 * @param {ReadonlyMat4} a the first operand
 * @param {ReadonlyMat4} b the second operand
 * @param {Number} scale the amount to scale b's elements by before adding
 * @returns {mat4} out
 */ parcelHelpers.export(exports, "multiplyScalarAndAdd", ()=>multiplyScalarAndAdd);
/**
 * Returns whether or not the matrices have exactly the same elements in the same position (when compared with ===)
 *
 * @param {ReadonlyMat4} a The first matrix.
 * @param {ReadonlyMat4} b The second matrix.
 * @returns {Boolean} True if the matrices are equal, false otherwise.
 */ parcelHelpers.export(exports, "exactEquals", ()=>exactEquals);
/**
 * Returns whether or not the matrices have approximately the same elements in the same position.
 *
 * @param {ReadonlyMat4} a The first matrix.
 * @param {ReadonlyMat4} b The second matrix.
 * @returns {Boolean} True if the matrices are equal, false otherwise.
 */ parcelHelpers.export(exports, "equals", ()=>equals);
parcelHelpers.export(exports, "mul", ()=>mul);
parcelHelpers.export(exports, "sub", ()=>sub);
var _commonJs = require("./common.js");
function create() {
    var out = new _commonJs.ARRAY_TYPE(16);
    if (_commonJs.ARRAY_TYPE != Float32Array) {
        out[1] = 0;
        out[2] = 0;
        out[3] = 0;
        out[4] = 0;
        out[6] = 0;
        out[7] = 0;
        out[8] = 0;
        out[9] = 0;
        out[11] = 0;
        out[12] = 0;
        out[13] = 0;
        out[14] = 0;
    }
    out[0] = 1;
    out[5] = 1;
    out[10] = 1;
    out[15] = 1;
    return out;
}
function clone(a) {
    var out = new _commonJs.ARRAY_TYPE(16);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    out[4] = a[4];
    out[5] = a[5];
    out[6] = a[6];
    out[7] = a[7];
    out[8] = a[8];
    out[9] = a[9];
    out[10] = a[10];
    out[11] = a[11];
    out[12] = a[12];
    out[13] = a[13];
    out[14] = a[14];
    out[15] = a[15];
    return out;
}
function copy(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    out[4] = a[4];
    out[5] = a[5];
    out[6] = a[6];
    out[7] = a[7];
    out[8] = a[8];
    out[9] = a[9];
    out[10] = a[10];
    out[11] = a[11];
    out[12] = a[12];
    out[13] = a[13];
    out[14] = a[14];
    out[15] = a[15];
    return out;
}
function fromValues(m00, m01, m02, m03, m10, m11, m12, m13, m20, m21, m22, m23, m30, m31, m32, m33) {
    var out = new _commonJs.ARRAY_TYPE(16);
    out[0] = m00;
    out[1] = m01;
    out[2] = m02;
    out[3] = m03;
    out[4] = m10;
    out[5] = m11;
    out[6] = m12;
    out[7] = m13;
    out[8] = m20;
    out[9] = m21;
    out[10] = m22;
    out[11] = m23;
    out[12] = m30;
    out[13] = m31;
    out[14] = m32;
    out[15] = m33;
    return out;
}
function set(out, m00, m01, m02, m03, m10, m11, m12, m13, m20, m21, m22, m23, m30, m31, m32, m33) {
    out[0] = m00;
    out[1] = m01;
    out[2] = m02;
    out[3] = m03;
    out[4] = m10;
    out[5] = m11;
    out[6] = m12;
    out[7] = m13;
    out[8] = m20;
    out[9] = m21;
    out[10] = m22;
    out[11] = m23;
    out[12] = m30;
    out[13] = m31;
    out[14] = m32;
    out[15] = m33;
    return out;
}
function identity(out) {
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = 1;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = 1;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
}
function transpose(out, a) {
    // If we are transposing ourselves we can skip a few steps but have to cache some values
    if (out === a) {
        var a01 = a[1], a02 = a[2], a03 = a[3];
        var a12 = a[6], a13 = a[7];
        var a23 = a[11];
        out[1] = a[4];
        out[2] = a[8];
        out[3] = a[12];
        out[4] = a01;
        out[6] = a[9];
        out[7] = a[13];
        out[8] = a02;
        out[9] = a12;
        out[11] = a[14];
        out[12] = a03;
        out[13] = a13;
        out[14] = a23;
    } else {
        out[0] = a[0];
        out[1] = a[4];
        out[2] = a[8];
        out[3] = a[12];
        out[4] = a[1];
        out[5] = a[5];
        out[6] = a[9];
        out[7] = a[13];
        out[8] = a[2];
        out[9] = a[6];
        out[10] = a[10];
        out[11] = a[14];
        out[12] = a[3];
        out[13] = a[7];
        out[14] = a[11];
        out[15] = a[15];
    }
    return out;
}
function invert(out, a) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3];
    var a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7];
    var a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11];
    var a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15];
    var b00 = a00 * a11 - a01 * a10;
    var b01 = a00 * a12 - a02 * a10;
    var b02 = a00 * a13 - a03 * a10;
    var b03 = a01 * a12 - a02 * a11;
    var b04 = a01 * a13 - a03 * a11;
    var b05 = a02 * a13 - a03 * a12;
    var b06 = a20 * a31 - a21 * a30;
    var b07 = a20 * a32 - a22 * a30;
    var b08 = a20 * a33 - a23 * a30;
    var b09 = a21 * a32 - a22 * a31;
    var b10 = a21 * a33 - a23 * a31;
    var b11 = a22 * a33 - a23 * a32; // Calculate the determinant
    var det = b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;
    if (!det) return null;
    det = 1.0 / det;
    out[0] = (a11 * b11 - a12 * b10 + a13 * b09) * det;
    out[1] = (a02 * b10 - a01 * b11 - a03 * b09) * det;
    out[2] = (a31 * b05 - a32 * b04 + a33 * b03) * det;
    out[3] = (a22 * b04 - a21 * b05 - a23 * b03) * det;
    out[4] = (a12 * b08 - a10 * b11 - a13 * b07) * det;
    out[5] = (a00 * b11 - a02 * b08 + a03 * b07) * det;
    out[6] = (a32 * b02 - a30 * b05 - a33 * b01) * det;
    out[7] = (a20 * b05 - a22 * b02 + a23 * b01) * det;
    out[8] = (a10 * b10 - a11 * b08 + a13 * b06) * det;
    out[9] = (a01 * b08 - a00 * b10 - a03 * b06) * det;
    out[10] = (a30 * b04 - a31 * b02 + a33 * b00) * det;
    out[11] = (a21 * b02 - a20 * b04 - a23 * b00) * det;
    out[12] = (a11 * b07 - a10 * b09 - a12 * b06) * det;
    out[13] = (a00 * b09 - a01 * b07 + a02 * b06) * det;
    out[14] = (a31 * b01 - a30 * b03 - a32 * b00) * det;
    out[15] = (a20 * b03 - a21 * b01 + a22 * b00) * det;
    return out;
}
function adjoint(out, a) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3];
    var a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7];
    var a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11];
    var a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15];
    out[0] = a11 * (a22 * a33 - a23 * a32) - a21 * (a12 * a33 - a13 * a32) + a31 * (a12 * a23 - a13 * a22);
    out[1] = -(a01 * (a22 * a33 - a23 * a32) - a21 * (a02 * a33 - a03 * a32) + a31 * (a02 * a23 - a03 * a22));
    out[2] = a01 * (a12 * a33 - a13 * a32) - a11 * (a02 * a33 - a03 * a32) + a31 * (a02 * a13 - a03 * a12);
    out[3] = -(a01 * (a12 * a23 - a13 * a22) - a11 * (a02 * a23 - a03 * a22) + a21 * (a02 * a13 - a03 * a12));
    out[4] = -(a10 * (a22 * a33 - a23 * a32) - a20 * (a12 * a33 - a13 * a32) + a30 * (a12 * a23 - a13 * a22));
    out[5] = a00 * (a22 * a33 - a23 * a32) - a20 * (a02 * a33 - a03 * a32) + a30 * (a02 * a23 - a03 * a22);
    out[6] = -(a00 * (a12 * a33 - a13 * a32) - a10 * (a02 * a33 - a03 * a32) + a30 * (a02 * a13 - a03 * a12));
    out[7] = a00 * (a12 * a23 - a13 * a22) - a10 * (a02 * a23 - a03 * a22) + a20 * (a02 * a13 - a03 * a12);
    out[8] = a10 * (a21 * a33 - a23 * a31) - a20 * (a11 * a33 - a13 * a31) + a30 * (a11 * a23 - a13 * a21);
    out[9] = -(a00 * (a21 * a33 - a23 * a31) - a20 * (a01 * a33 - a03 * a31) + a30 * (a01 * a23 - a03 * a21));
    out[10] = a00 * (a11 * a33 - a13 * a31) - a10 * (a01 * a33 - a03 * a31) + a30 * (a01 * a13 - a03 * a11);
    out[11] = -(a00 * (a11 * a23 - a13 * a21) - a10 * (a01 * a23 - a03 * a21) + a20 * (a01 * a13 - a03 * a11));
    out[12] = -(a10 * (a21 * a32 - a22 * a31) - a20 * (a11 * a32 - a12 * a31) + a30 * (a11 * a22 - a12 * a21));
    out[13] = a00 * (a21 * a32 - a22 * a31) - a20 * (a01 * a32 - a02 * a31) + a30 * (a01 * a22 - a02 * a21);
    out[14] = -(a00 * (a11 * a32 - a12 * a31) - a10 * (a01 * a32 - a02 * a31) + a30 * (a01 * a12 - a02 * a11));
    out[15] = a00 * (a11 * a22 - a12 * a21) - a10 * (a01 * a22 - a02 * a21) + a20 * (a01 * a12 - a02 * a11);
    return out;
}
function determinant(a) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3];
    var a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7];
    var a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11];
    var a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15];
    var b00 = a00 * a11 - a01 * a10;
    var b01 = a00 * a12 - a02 * a10;
    var b02 = a00 * a13 - a03 * a10;
    var b03 = a01 * a12 - a02 * a11;
    var b04 = a01 * a13 - a03 * a11;
    var b05 = a02 * a13 - a03 * a12;
    var b06 = a20 * a31 - a21 * a30;
    var b07 = a20 * a32 - a22 * a30;
    var b08 = a20 * a33 - a23 * a30;
    var b09 = a21 * a32 - a22 * a31;
    var b10 = a21 * a33 - a23 * a31;
    var b11 = a22 * a33 - a23 * a32; // Calculate the determinant
    return b00 * b11 - b01 * b10 + b02 * b09 + b03 * b08 - b04 * b07 + b05 * b06;
}
function multiply(out, a, b) {
    var a00 = a[0], a01 = a[1], a02 = a[2], a03 = a[3];
    var a10 = a[4], a11 = a[5], a12 = a[6], a13 = a[7];
    var a20 = a[8], a21 = a[9], a22 = a[10], a23 = a[11];
    var a30 = a[12], a31 = a[13], a32 = a[14], a33 = a[15]; // Cache only the current line of the second matrix
    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3];
    out[0] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
    out[1] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
    out[2] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
    out[3] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
    b0 = b[4];
    b1 = b[5];
    b2 = b[6];
    b3 = b[7];
    out[4] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
    out[5] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
    out[6] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
    out[7] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
    b0 = b[8];
    b1 = b[9];
    b2 = b[10];
    b3 = b[11];
    out[8] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
    out[9] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
    out[10] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
    out[11] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
    b0 = b[12];
    b1 = b[13];
    b2 = b[14];
    b3 = b[15];
    out[12] = b0 * a00 + b1 * a10 + b2 * a20 + b3 * a30;
    out[13] = b0 * a01 + b1 * a11 + b2 * a21 + b3 * a31;
    out[14] = b0 * a02 + b1 * a12 + b2 * a22 + b3 * a32;
    out[15] = b0 * a03 + b1 * a13 + b2 * a23 + b3 * a33;
    return out;
}
function translate(out, a, v) {
    var x = v[0], y = v[1], z = v[2];
    var a00, a01, a02, a03;
    var a10, a11, a12, a13;
    var a20, a21, a22, a23;
    if (a === out) {
        out[12] = a[0] * x + a[4] * y + a[8] * z + a[12];
        out[13] = a[1] * x + a[5] * y + a[9] * z + a[13];
        out[14] = a[2] * x + a[6] * y + a[10] * z + a[14];
        out[15] = a[3] * x + a[7] * y + a[11] * z + a[15];
    } else {
        a00 = a[0];
        a01 = a[1];
        a02 = a[2];
        a03 = a[3];
        a10 = a[4];
        a11 = a[5];
        a12 = a[6];
        a13 = a[7];
        a20 = a[8];
        a21 = a[9];
        a22 = a[10];
        a23 = a[11];
        out[0] = a00;
        out[1] = a01;
        out[2] = a02;
        out[3] = a03;
        out[4] = a10;
        out[5] = a11;
        out[6] = a12;
        out[7] = a13;
        out[8] = a20;
        out[9] = a21;
        out[10] = a22;
        out[11] = a23;
        out[12] = a00 * x + a10 * y + a20 * z + a[12];
        out[13] = a01 * x + a11 * y + a21 * z + a[13];
        out[14] = a02 * x + a12 * y + a22 * z + a[14];
        out[15] = a03 * x + a13 * y + a23 * z + a[15];
    }
    return out;
}
function scale(out, a, v) {
    var x = v[0], y = v[1], z = v[2];
    out[0] = a[0] * x;
    out[1] = a[1] * x;
    out[2] = a[2] * x;
    out[3] = a[3] * x;
    out[4] = a[4] * y;
    out[5] = a[5] * y;
    out[6] = a[6] * y;
    out[7] = a[7] * y;
    out[8] = a[8] * z;
    out[9] = a[9] * z;
    out[10] = a[10] * z;
    out[11] = a[11] * z;
    out[12] = a[12];
    out[13] = a[13];
    out[14] = a[14];
    out[15] = a[15];
    return out;
}
function rotate(out, a, rad, axis) {
    var x = axis[0], y = axis[1], z = axis[2];
    var len = Math.hypot(x, y, z);
    var s, c, t;
    var a00, a01, a02, a03;
    var a10, a11, a12, a13;
    var a20, a21, a22, a23;
    var b00, b01, b02;
    var b10, b11, b12;
    var b20, b21, b22;
    if (len < _commonJs.EPSILON) return null;
    len = 1 / len;
    x *= len;
    y *= len;
    z *= len;
    s = Math.sin(rad);
    c = Math.cos(rad);
    t = 1 - c;
    a00 = a[0];
    a01 = a[1];
    a02 = a[2];
    a03 = a[3];
    a10 = a[4];
    a11 = a[5];
    a12 = a[6];
    a13 = a[7];
    a20 = a[8];
    a21 = a[9];
    a22 = a[10];
    a23 = a[11]; // Construct the elements of the rotation matrix
    b00 = x * x * t + c;
    b01 = y * x * t + z * s;
    b02 = z * x * t - y * s;
    b10 = x * y * t - z * s;
    b11 = y * y * t + c;
    b12 = z * y * t + x * s;
    b20 = x * z * t + y * s;
    b21 = y * z * t - x * s;
    b22 = z * z * t + c; // Perform rotation-specific matrix multiplication
    out[0] = a00 * b00 + a10 * b01 + a20 * b02;
    out[1] = a01 * b00 + a11 * b01 + a21 * b02;
    out[2] = a02 * b00 + a12 * b01 + a22 * b02;
    out[3] = a03 * b00 + a13 * b01 + a23 * b02;
    out[4] = a00 * b10 + a10 * b11 + a20 * b12;
    out[5] = a01 * b10 + a11 * b11 + a21 * b12;
    out[6] = a02 * b10 + a12 * b11 + a22 * b12;
    out[7] = a03 * b10 + a13 * b11 + a23 * b12;
    out[8] = a00 * b20 + a10 * b21 + a20 * b22;
    out[9] = a01 * b20 + a11 * b21 + a21 * b22;
    out[10] = a02 * b20 + a12 * b21 + a22 * b22;
    out[11] = a03 * b20 + a13 * b21 + a23 * b22;
    if (a !== out) {
        // If the source and destination differ, copy the unchanged last row
        out[12] = a[12];
        out[13] = a[13];
        out[14] = a[14];
        out[15] = a[15];
    }
    return out;
}
function rotateX(out, a, rad) {
    var s = Math.sin(rad);
    var c = Math.cos(rad);
    var a10 = a[4];
    var a11 = a[5];
    var a12 = a[6];
    var a13 = a[7];
    var a20 = a[8];
    var a21 = a[9];
    var a22 = a[10];
    var a23 = a[11];
    if (a !== out) {
        // If the source and destination differ, copy the unchanged rows
        out[0] = a[0];
        out[1] = a[1];
        out[2] = a[2];
        out[3] = a[3];
        out[12] = a[12];
        out[13] = a[13];
        out[14] = a[14];
        out[15] = a[15];
    } // Perform axis-specific matrix multiplication
    out[4] = a10 * c + a20 * s;
    out[5] = a11 * c + a21 * s;
    out[6] = a12 * c + a22 * s;
    out[7] = a13 * c + a23 * s;
    out[8] = a20 * c - a10 * s;
    out[9] = a21 * c - a11 * s;
    out[10] = a22 * c - a12 * s;
    out[11] = a23 * c - a13 * s;
    return out;
}
function rotateY(out, a, rad) {
    var s = Math.sin(rad);
    var c = Math.cos(rad);
    var a00 = a[0];
    var a01 = a[1];
    var a02 = a[2];
    var a03 = a[3];
    var a20 = a[8];
    var a21 = a[9];
    var a22 = a[10];
    var a23 = a[11];
    if (a !== out) {
        // If the source and destination differ, copy the unchanged rows
        out[4] = a[4];
        out[5] = a[5];
        out[6] = a[6];
        out[7] = a[7];
        out[12] = a[12];
        out[13] = a[13];
        out[14] = a[14];
        out[15] = a[15];
    } // Perform axis-specific matrix multiplication
    out[0] = a00 * c - a20 * s;
    out[1] = a01 * c - a21 * s;
    out[2] = a02 * c - a22 * s;
    out[3] = a03 * c - a23 * s;
    out[8] = a00 * s + a20 * c;
    out[9] = a01 * s + a21 * c;
    out[10] = a02 * s + a22 * c;
    out[11] = a03 * s + a23 * c;
    return out;
}
function rotateZ(out, a, rad) {
    var s = Math.sin(rad);
    var c = Math.cos(rad);
    var a00 = a[0];
    var a01 = a[1];
    var a02 = a[2];
    var a03 = a[3];
    var a10 = a[4];
    var a11 = a[5];
    var a12 = a[6];
    var a13 = a[7];
    if (a !== out) {
        // If the source and destination differ, copy the unchanged last row
        out[8] = a[8];
        out[9] = a[9];
        out[10] = a[10];
        out[11] = a[11];
        out[12] = a[12];
        out[13] = a[13];
        out[14] = a[14];
        out[15] = a[15];
    } // Perform axis-specific matrix multiplication
    out[0] = a00 * c + a10 * s;
    out[1] = a01 * c + a11 * s;
    out[2] = a02 * c + a12 * s;
    out[3] = a03 * c + a13 * s;
    out[4] = a10 * c - a00 * s;
    out[5] = a11 * c - a01 * s;
    out[6] = a12 * c - a02 * s;
    out[7] = a13 * c - a03 * s;
    return out;
}
function fromTranslation(out, v) {
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = 1;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = 1;
    out[11] = 0;
    out[12] = v[0];
    out[13] = v[1];
    out[14] = v[2];
    out[15] = 1;
    return out;
}
function fromScaling(out, v) {
    out[0] = v[0];
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = v[1];
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = v[2];
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
}
function fromRotation(out, rad, axis) {
    var x = axis[0], y = axis[1], z = axis[2];
    var len = Math.hypot(x, y, z);
    var s, c, t;
    if (len < _commonJs.EPSILON) return null;
    len = 1 / len;
    x *= len;
    y *= len;
    z *= len;
    s = Math.sin(rad);
    c = Math.cos(rad);
    t = 1 - c; // Perform rotation-specific matrix multiplication
    out[0] = x * x * t + c;
    out[1] = y * x * t + z * s;
    out[2] = z * x * t - y * s;
    out[3] = 0;
    out[4] = x * y * t - z * s;
    out[5] = y * y * t + c;
    out[6] = z * y * t + x * s;
    out[7] = 0;
    out[8] = x * z * t + y * s;
    out[9] = y * z * t - x * s;
    out[10] = z * z * t + c;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
}
function fromXRotation(out, rad) {
    var s = Math.sin(rad);
    var c = Math.cos(rad); // Perform axis-specific matrix multiplication
    out[0] = 1;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = c;
    out[6] = s;
    out[7] = 0;
    out[8] = 0;
    out[9] = -s;
    out[10] = c;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
}
function fromYRotation(out, rad) {
    var s = Math.sin(rad);
    var c = Math.cos(rad); // Perform axis-specific matrix multiplication
    out[0] = c;
    out[1] = 0;
    out[2] = -s;
    out[3] = 0;
    out[4] = 0;
    out[5] = 1;
    out[6] = 0;
    out[7] = 0;
    out[8] = s;
    out[9] = 0;
    out[10] = c;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
}
function fromZRotation(out, rad) {
    var s = Math.sin(rad);
    var c = Math.cos(rad); // Perform axis-specific matrix multiplication
    out[0] = c;
    out[1] = s;
    out[2] = 0;
    out[3] = 0;
    out[4] = -s;
    out[5] = c;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = 1;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
}
function fromRotationTranslation(out, q, v) {
    // Quaternion math
    var x = q[0], y = q[1], z = q[2], w = q[3];
    var x2 = x + x;
    var y2 = y + y;
    var z2 = z + z;
    var xx = x * x2;
    var xy = x * y2;
    var xz = x * z2;
    var yy = y * y2;
    var yz = y * z2;
    var zz = z * z2;
    var wx = w * x2;
    var wy = w * y2;
    var wz = w * z2;
    out[0] = 1 - (yy + zz);
    out[1] = xy + wz;
    out[2] = xz - wy;
    out[3] = 0;
    out[4] = xy - wz;
    out[5] = 1 - (xx + zz);
    out[6] = yz + wx;
    out[7] = 0;
    out[8] = xz + wy;
    out[9] = yz - wx;
    out[10] = 1 - (xx + yy);
    out[11] = 0;
    out[12] = v[0];
    out[13] = v[1];
    out[14] = v[2];
    out[15] = 1;
    return out;
}
function fromQuat2(out, a) {
    var translation = new _commonJs.ARRAY_TYPE(3);
    var bx = -a[0], by = -a[1], bz = -a[2], bw = a[3], ax = a[4], ay = a[5], az = a[6], aw = a[7];
    var magnitude = bx * bx + by * by + bz * bz + bw * bw; //Only scale if it makes sense
    if (magnitude > 0) {
        translation[0] = (ax * bw + aw * bx + ay * bz - az * by) * 2 / magnitude;
        translation[1] = (ay * bw + aw * by + az * bx - ax * bz) * 2 / magnitude;
        translation[2] = (az * bw + aw * bz + ax * by - ay * bx) * 2 / magnitude;
    } else {
        translation[0] = (ax * bw + aw * bx + ay * bz - az * by) * 2;
        translation[1] = (ay * bw + aw * by + az * bx - ax * bz) * 2;
        translation[2] = (az * bw + aw * bz + ax * by - ay * bx) * 2;
    }
    fromRotationTranslation(out, a, translation);
    return out;
}
function getTranslation(out, mat) {
    out[0] = mat[12];
    out[1] = mat[13];
    out[2] = mat[14];
    return out;
}
function getScaling(out, mat) {
    var m11 = mat[0];
    var m12 = mat[1];
    var m13 = mat[2];
    var m21 = mat[4];
    var m22 = mat[5];
    var m23 = mat[6];
    var m31 = mat[8];
    var m32 = mat[9];
    var m33 = mat[10];
    out[0] = Math.hypot(m11, m12, m13);
    out[1] = Math.hypot(m21, m22, m23);
    out[2] = Math.hypot(m31, m32, m33);
    return out;
}
function getRotation(out, mat) {
    var scaling = new _commonJs.ARRAY_TYPE(3);
    getScaling(scaling, mat);
    var is1 = 1 / scaling[0];
    var is2 = 1 / scaling[1];
    var is3 = 1 / scaling[2];
    var sm11 = mat[0] * is1;
    var sm12 = mat[1] * is2;
    var sm13 = mat[2] * is3;
    var sm21 = mat[4] * is1;
    var sm22 = mat[5] * is2;
    var sm23 = mat[6] * is3;
    var sm31 = mat[8] * is1;
    var sm32 = mat[9] * is2;
    var sm33 = mat[10] * is3;
    var trace = sm11 + sm22 + sm33;
    var S = 0;
    if (trace > 0) {
        S = Math.sqrt(trace + 1.0) * 2;
        out[3] = 0.25 * S;
        out[0] = (sm23 - sm32) / S;
        out[1] = (sm31 - sm13) / S;
        out[2] = (sm12 - sm21) / S;
    } else if (sm11 > sm22 && sm11 > sm33) {
        S = Math.sqrt(1.0 + sm11 - sm22 - sm33) * 2;
        out[3] = (sm23 - sm32) / S;
        out[0] = 0.25 * S;
        out[1] = (sm12 + sm21) / S;
        out[2] = (sm31 + sm13) / S;
    } else if (sm22 > sm33) {
        S = Math.sqrt(1.0 + sm22 - sm11 - sm33) * 2;
        out[3] = (sm31 - sm13) / S;
        out[0] = (sm12 + sm21) / S;
        out[1] = 0.25 * S;
        out[2] = (sm23 + sm32) / S;
    } else {
        S = Math.sqrt(1.0 + sm33 - sm11 - sm22) * 2;
        out[3] = (sm12 - sm21) / S;
        out[0] = (sm31 + sm13) / S;
        out[1] = (sm23 + sm32) / S;
        out[2] = 0.25 * S;
    }
    return out;
}
function fromRotationTranslationScale(out, q, v, s) {
    // Quaternion math
    var x = q[0], y = q[1], z = q[2], w = q[3];
    var x2 = x + x;
    var y2 = y + y;
    var z2 = z + z;
    var xx = x * x2;
    var xy = x * y2;
    var xz = x * z2;
    var yy = y * y2;
    var yz = y * z2;
    var zz = z * z2;
    var wx = w * x2;
    var wy = w * y2;
    var wz = w * z2;
    var sx = s[0];
    var sy = s[1];
    var sz = s[2];
    out[0] = (1 - (yy + zz)) * sx;
    out[1] = (xy + wz) * sx;
    out[2] = (xz - wy) * sx;
    out[3] = 0;
    out[4] = (xy - wz) * sy;
    out[5] = (1 - (xx + zz)) * sy;
    out[6] = (yz + wx) * sy;
    out[7] = 0;
    out[8] = (xz + wy) * sz;
    out[9] = (yz - wx) * sz;
    out[10] = (1 - (xx + yy)) * sz;
    out[11] = 0;
    out[12] = v[0];
    out[13] = v[1];
    out[14] = v[2];
    out[15] = 1;
    return out;
}
function fromRotationTranslationScaleOrigin(out, q, v, s, o) {
    // Quaternion math
    var x = q[0], y = q[1], z = q[2], w = q[3];
    var x2 = x + x;
    var y2 = y + y;
    var z2 = z + z;
    var xx = x * x2;
    var xy = x * y2;
    var xz = x * z2;
    var yy = y * y2;
    var yz = y * z2;
    var zz = z * z2;
    var wx = w * x2;
    var wy = w * y2;
    var wz = w * z2;
    var sx = s[0];
    var sy = s[1];
    var sz = s[2];
    var ox = o[0];
    var oy = o[1];
    var oz = o[2];
    var out0 = (1 - (yy + zz)) * sx;
    var out1 = (xy + wz) * sx;
    var out2 = (xz - wy) * sx;
    var out4 = (xy - wz) * sy;
    var out5 = (1 - (xx + zz)) * sy;
    var out6 = (yz + wx) * sy;
    var out8 = (xz + wy) * sz;
    var out9 = (yz - wx) * sz;
    var out10 = (1 - (xx + yy)) * sz;
    out[0] = out0;
    out[1] = out1;
    out[2] = out2;
    out[3] = 0;
    out[4] = out4;
    out[5] = out5;
    out[6] = out6;
    out[7] = 0;
    out[8] = out8;
    out[9] = out9;
    out[10] = out10;
    out[11] = 0;
    out[12] = v[0] + ox - (out0 * ox + out4 * oy + out8 * oz);
    out[13] = v[1] + oy - (out1 * ox + out5 * oy + out9 * oz);
    out[14] = v[2] + oz - (out2 * ox + out6 * oy + out10 * oz);
    out[15] = 1;
    return out;
}
function fromQuat(out, q) {
    var x = q[0], y = q[1], z = q[2], w = q[3];
    var x2 = x + x;
    var y2 = y + y;
    var z2 = z + z;
    var xx = x * x2;
    var yx = y * x2;
    var yy = y * y2;
    var zx = z * x2;
    var zy = z * y2;
    var zz = z * z2;
    var wx = w * x2;
    var wy = w * y2;
    var wz = w * z2;
    out[0] = 1 - yy - zz;
    out[1] = yx + wz;
    out[2] = zx - wy;
    out[3] = 0;
    out[4] = yx - wz;
    out[5] = 1 - xx - zz;
    out[6] = zy + wx;
    out[7] = 0;
    out[8] = zx + wy;
    out[9] = zy - wx;
    out[10] = 1 - xx - yy;
    out[11] = 0;
    out[12] = 0;
    out[13] = 0;
    out[14] = 0;
    out[15] = 1;
    return out;
}
function frustum(out, left, right, bottom, top, near, far) {
    var rl = 1 / (right - left);
    var tb = 1 / (top - bottom);
    var nf = 1 / (near - far);
    out[0] = near * 2 * rl;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = near * 2 * tb;
    out[6] = 0;
    out[7] = 0;
    out[8] = (right + left) * rl;
    out[9] = (top + bottom) * tb;
    out[10] = (far + near) * nf;
    out[11] = -1;
    out[12] = 0;
    out[13] = 0;
    out[14] = far * near * 2 * nf;
    out[15] = 0;
    return out;
}
function perspectiveNO(out, fovy, aspect, near, far) {
    var f = 1.0 / Math.tan(fovy / 2), nf;
    out[0] = f / aspect;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = f;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[11] = -1;
    out[12] = 0;
    out[13] = 0;
    out[15] = 0;
    if (far != null && far !== Infinity) {
        nf = 1 / (near - far);
        out[10] = (far + near) * nf;
        out[14] = 2 * far * near * nf;
    } else {
        out[10] = -1;
        out[14] = -2 * near;
    }
    return out;
}
var perspective = perspectiveNO;
function perspectiveZO(out, fovy, aspect, near, far) {
    var f = 1.0 / Math.tan(fovy / 2), nf;
    out[0] = f / aspect;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = f;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[11] = -1;
    out[12] = 0;
    out[13] = 0;
    out[15] = 0;
    if (far != null && far !== Infinity) {
        nf = 1 / (near - far);
        out[10] = far * nf;
        out[14] = far * near * nf;
    } else {
        out[10] = -1;
        out[14] = -near;
    }
    return out;
}
function perspectiveFromFieldOfView(out, fov, near, far) {
    var upTan = Math.tan(fov.upDegrees * Math.PI / 180.0);
    var downTan = Math.tan(fov.downDegrees * Math.PI / 180.0);
    var leftTan = Math.tan(fov.leftDegrees * Math.PI / 180.0);
    var rightTan = Math.tan(fov.rightDegrees * Math.PI / 180.0);
    var xScale = 2.0 / (leftTan + rightTan);
    var yScale = 2.0 / (upTan + downTan);
    out[0] = xScale;
    out[1] = 0.0;
    out[2] = 0.0;
    out[3] = 0.0;
    out[4] = 0.0;
    out[5] = yScale;
    out[6] = 0.0;
    out[7] = 0.0;
    out[8] = -((leftTan - rightTan) * xScale * 0.5);
    out[9] = (upTan - downTan) * yScale * 0.5;
    out[10] = far / (near - far);
    out[11] = -1;
    out[12] = 0.0;
    out[13] = 0.0;
    out[14] = far * near / (near - far);
    out[15] = 0.0;
    return out;
}
function orthoNO(out, left, right, bottom, top, near, far) {
    var lr = 1 / (left - right);
    var bt = 1 / (bottom - top);
    var nf = 1 / (near - far);
    out[0] = -2 * lr;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = -2 * bt;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = 2 * nf;
    out[11] = 0;
    out[12] = (left + right) * lr;
    out[13] = (top + bottom) * bt;
    out[14] = (far + near) * nf;
    out[15] = 1;
    return out;
}
var ortho = orthoNO;
function orthoZO(out, left, right, bottom, top, near, far) {
    var lr = 1 / (left - right);
    var bt = 1 / (bottom - top);
    var nf = 1 / (near - far);
    out[0] = -2 * lr;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[4] = 0;
    out[5] = -2 * bt;
    out[6] = 0;
    out[7] = 0;
    out[8] = 0;
    out[9] = 0;
    out[10] = nf;
    out[11] = 0;
    out[12] = (left + right) * lr;
    out[13] = (top + bottom) * bt;
    out[14] = near * nf;
    out[15] = 1;
    return out;
}
function lookAt(out, eye, center, up) {
    var x0, x1, x2, y0, y1, y2, z0, z1, z2, len;
    var eyex = eye[0];
    var eyey = eye[1];
    var eyez = eye[2];
    var upx = up[0];
    var upy = up[1];
    var upz = up[2];
    var centerx = center[0];
    var centery = center[1];
    var centerz = center[2];
    if (Math.abs(eyex - centerx) < _commonJs.EPSILON && Math.abs(eyey - centery) < _commonJs.EPSILON && Math.abs(eyez - centerz) < _commonJs.EPSILON) return identity(out);
    z0 = eyex - centerx;
    z1 = eyey - centery;
    z2 = eyez - centerz;
    len = 1 / Math.hypot(z0, z1, z2);
    z0 *= len;
    z1 *= len;
    z2 *= len;
    x0 = upy * z2 - upz * z1;
    x1 = upz * z0 - upx * z2;
    x2 = upx * z1 - upy * z0;
    len = Math.hypot(x0, x1, x2);
    if (!len) {
        x0 = 0;
        x1 = 0;
        x2 = 0;
    } else {
        len = 1 / len;
        x0 *= len;
        x1 *= len;
        x2 *= len;
    }
    y0 = z1 * x2 - z2 * x1;
    y1 = z2 * x0 - z0 * x2;
    y2 = z0 * x1 - z1 * x0;
    len = Math.hypot(y0, y1, y2);
    if (!len) {
        y0 = 0;
        y1 = 0;
        y2 = 0;
    } else {
        len = 1 / len;
        y0 *= len;
        y1 *= len;
        y2 *= len;
    }
    out[0] = x0;
    out[1] = y0;
    out[2] = z0;
    out[3] = 0;
    out[4] = x1;
    out[5] = y1;
    out[6] = z1;
    out[7] = 0;
    out[8] = x2;
    out[9] = y2;
    out[10] = z2;
    out[11] = 0;
    out[12] = -(x0 * eyex + x1 * eyey + x2 * eyez);
    out[13] = -(y0 * eyex + y1 * eyey + y2 * eyez);
    out[14] = -(z0 * eyex + z1 * eyey + z2 * eyez);
    out[15] = 1;
    return out;
}
function targetTo(out, eye, target, up) {
    var eyex = eye[0], eyey = eye[1], eyez = eye[2], upx = up[0], upy = up[1], upz = up[2];
    var z0 = eyex - target[0], z1 = eyey - target[1], z2 = eyez - target[2];
    var len = z0 * z0 + z1 * z1 + z2 * z2;
    if (len > 0) {
        len = 1 / Math.sqrt(len);
        z0 *= len;
        z1 *= len;
        z2 *= len;
    }
    var x0 = upy * z2 - upz * z1, x1 = upz * z0 - upx * z2, x2 = upx * z1 - upy * z0;
    len = x0 * x0 + x1 * x1 + x2 * x2;
    if (len > 0) {
        len = 1 / Math.sqrt(len);
        x0 *= len;
        x1 *= len;
        x2 *= len;
    }
    out[0] = x0;
    out[1] = x1;
    out[2] = x2;
    out[3] = 0;
    out[4] = z1 * x2 - z2 * x1;
    out[5] = z2 * x0 - z0 * x2;
    out[6] = z0 * x1 - z1 * x0;
    out[7] = 0;
    out[8] = z0;
    out[9] = z1;
    out[10] = z2;
    out[11] = 0;
    out[12] = eyex;
    out[13] = eyey;
    out[14] = eyez;
    out[15] = 1;
    return out;
}
function str(a) {
    return "mat4(" + a[0] + ", " + a[1] + ", " + a[2] + ", " + a[3] + ", " + a[4] + ", " + a[5] + ", " + a[6] + ", " + a[7] + ", " + a[8] + ", " + a[9] + ", " + a[10] + ", " + a[11] + ", " + a[12] + ", " + a[13] + ", " + a[14] + ", " + a[15] + ")";
}
function frob(a) {
    return Math.hypot(a[0], a[1], a[2], a[3], a[4], a[5], a[6], a[7], a[8], a[9], a[10], a[11], a[12], a[13], a[14], a[15]);
}
function add(out, a, b) {
    out[0] = a[0] + b[0];
    out[1] = a[1] + b[1];
    out[2] = a[2] + b[2];
    out[3] = a[3] + b[3];
    out[4] = a[4] + b[4];
    out[5] = a[5] + b[5];
    out[6] = a[6] + b[6];
    out[7] = a[7] + b[7];
    out[8] = a[8] + b[8];
    out[9] = a[9] + b[9];
    out[10] = a[10] + b[10];
    out[11] = a[11] + b[11];
    out[12] = a[12] + b[12];
    out[13] = a[13] + b[13];
    out[14] = a[14] + b[14];
    out[15] = a[15] + b[15];
    return out;
}
function subtract(out, a, b) {
    out[0] = a[0] - b[0];
    out[1] = a[1] - b[1];
    out[2] = a[2] - b[2];
    out[3] = a[3] - b[3];
    out[4] = a[4] - b[4];
    out[5] = a[5] - b[5];
    out[6] = a[6] - b[6];
    out[7] = a[7] - b[7];
    out[8] = a[8] - b[8];
    out[9] = a[9] - b[9];
    out[10] = a[10] - b[10];
    out[11] = a[11] - b[11];
    out[12] = a[12] - b[12];
    out[13] = a[13] - b[13];
    out[14] = a[14] - b[14];
    out[15] = a[15] - b[15];
    return out;
}
function multiplyScalar(out, a, b) {
    out[0] = a[0] * b;
    out[1] = a[1] * b;
    out[2] = a[2] * b;
    out[3] = a[3] * b;
    out[4] = a[4] * b;
    out[5] = a[5] * b;
    out[6] = a[6] * b;
    out[7] = a[7] * b;
    out[8] = a[8] * b;
    out[9] = a[9] * b;
    out[10] = a[10] * b;
    out[11] = a[11] * b;
    out[12] = a[12] * b;
    out[13] = a[13] * b;
    out[14] = a[14] * b;
    out[15] = a[15] * b;
    return out;
}
function multiplyScalarAndAdd(out, a, b, scale) {
    out[0] = a[0] + b[0] * scale;
    out[1] = a[1] + b[1] * scale;
    out[2] = a[2] + b[2] * scale;
    out[3] = a[3] + b[3] * scale;
    out[4] = a[4] + b[4] * scale;
    out[5] = a[5] + b[5] * scale;
    out[6] = a[6] + b[6] * scale;
    out[7] = a[7] + b[7] * scale;
    out[8] = a[8] + b[8] * scale;
    out[9] = a[9] + b[9] * scale;
    out[10] = a[10] + b[10] * scale;
    out[11] = a[11] + b[11] * scale;
    out[12] = a[12] + b[12] * scale;
    out[13] = a[13] + b[13] * scale;
    out[14] = a[14] + b[14] * scale;
    out[15] = a[15] + b[15] * scale;
    return out;
}
function exactEquals(a, b) {
    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2] && a[3] === b[3] && a[4] === b[4] && a[5] === b[5] && a[6] === b[6] && a[7] === b[7] && a[8] === b[8] && a[9] === b[9] && a[10] === b[10] && a[11] === b[11] && a[12] === b[12] && a[13] === b[13] && a[14] === b[14] && a[15] === b[15];
}
function equals(a, b) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3];
    var a4 = a[4], a5 = a[5], a6 = a[6], a7 = a[7];
    var a8 = a[8], a9 = a[9], a10 = a[10], a11 = a[11];
    var a12 = a[12], a13 = a[13], a14 = a[14], a15 = a[15];
    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3];
    var b4 = b[4], b5 = b[5], b6 = b[6], b7 = b[7];
    var b8 = b[8], b9 = b[9], b10 = b[10], b11 = b[11];
    var b12 = b[12], b13 = b[13], b14 = b[14], b15 = b[15];
    return Math.abs(a0 - b0) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a0), Math.abs(b0)) && Math.abs(a1 - b1) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a1), Math.abs(b1)) && Math.abs(a2 - b2) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a2), Math.abs(b2)) && Math.abs(a3 - b3) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a3), Math.abs(b3)) && Math.abs(a4 - b4) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a4), Math.abs(b4)) && Math.abs(a5 - b5) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a5), Math.abs(b5)) && Math.abs(a6 - b6) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a6), Math.abs(b6)) && Math.abs(a7 - b7) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a7), Math.abs(b7)) && Math.abs(a8 - b8) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a8), Math.abs(b8)) && Math.abs(a9 - b9) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a9), Math.abs(b9)) && Math.abs(a10 - b10) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a10), Math.abs(b10)) && Math.abs(a11 - b11) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a11), Math.abs(b11)) && Math.abs(a12 - b12) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a12), Math.abs(b12)) && Math.abs(a13 - b13) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a13), Math.abs(b13)) && Math.abs(a14 - b14) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a14), Math.abs(b14)) && Math.abs(a15 - b15) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a15), Math.abs(b15));
}
var mul = multiply;
var sub = subtract;

},{"./common.js":"lYeTq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5mYHR":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
/**
 * 2 Dimensional Vector
 * @module vec2
 */ /**
 * Creates a new, empty vec2
 *
 * @returns {vec2} a new 2D vector
 */ parcelHelpers.export(exports, "create", ()=>create);
/**
 * Creates a new vec2 initialized with values from an existing vector
 *
 * @param {ReadonlyVec2} a vector to clone
 * @returns {vec2} a new 2D vector
 */ parcelHelpers.export(exports, "clone", ()=>clone);
/**
 * Creates a new vec2 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @returns {vec2} a new 2D vector
 */ parcelHelpers.export(exports, "fromValues", ()=>fromValues);
/**
 * Copy the values from one vec2 to another
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the source vector
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "copy", ()=>copy);
/**
 * Set the components of a vec2 to the given values
 *
 * @param {vec2} out the receiving vector
 * @param {Number} x X component
 * @param {Number} y Y component
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "set", ()=>set);
/**
 * Adds two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "add", ()=>add);
/**
 * Subtracts vector b from vector a
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "subtract", ()=>subtract);
/**
 * Multiplies two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "multiply", ()=>multiply);
/**
 * Divides two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "divide", ()=>divide);
/**
 * Math.ceil the components of a vec2
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a vector to ceil
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "ceil", ()=>ceil);
/**
 * Math.floor the components of a vec2
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a vector to floor
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "floor", ()=>floor);
/**
 * Returns the minimum of two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "min", ()=>min);
/**
 * Returns the maximum of two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "max", ()=>max);
/**
 * Math.round the components of a vec2
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a vector to round
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "round", ()=>round);
/**
 * Scales a vec2 by a scalar number
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the vector to scale
 * @param {Number} b amount to scale the vector by
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "scale", ()=>scale);
/**
 * Adds two vec2's after scaling the second operand by a scalar value
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @param {Number} scale the amount to scale b by before adding
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "scaleAndAdd", ()=>scaleAndAdd);
/**
 * Calculates the euclidian distance between two vec2's
 *
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {Number} distance between a and b
 */ parcelHelpers.export(exports, "distance", ()=>distance);
/**
 * Calculates the squared euclidian distance between two vec2's
 *
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {Number} squared distance between a and b
 */ parcelHelpers.export(exports, "squaredDistance", ()=>squaredDistance);
/**
 * Calculates the length of a vec2
 *
 * @param {ReadonlyVec2} a vector to calculate length of
 * @returns {Number} length of a
 */ parcelHelpers.export(exports, "length", ()=>length);
/**
 * Calculates the squared length of a vec2
 *
 * @param {ReadonlyVec2} a vector to calculate squared length of
 * @returns {Number} squared length of a
 */ parcelHelpers.export(exports, "squaredLength", ()=>squaredLength);
/**
 * Negates the components of a vec2
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a vector to negate
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "negate", ()=>negate);
/**
 * Returns the inverse of the components of a vec2
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a vector to invert
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "inverse", ()=>inverse);
/**
 * Normalize a vec2
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a vector to normalize
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "normalize", ()=>normalize);
/**
 * Calculates the dot product of two vec2's
 *
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {Number} dot product of a and b
 */ parcelHelpers.export(exports, "dot", ()=>dot);
/**
 * Computes the cross product of two vec2's
 * Note that the cross product must by definition produce a 3D vector
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @returns {vec3} out
 */ parcelHelpers.export(exports, "cross", ()=>cross);
/**
 * Performs a linear interpolation between two vec2's
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the first operand
 * @param {ReadonlyVec2} b the second operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "lerp", ()=>lerp);
/**
 * Generates a random vector with the given scale
 *
 * @param {vec2} out the receiving vector
 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "random", ()=>random);
/**
 * Transforms the vec2 with a mat2
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the vector to transform
 * @param {ReadonlyMat2} m matrix to transform with
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "transformMat2", ()=>transformMat2);
/**
 * Transforms the vec2 with a mat2d
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the vector to transform
 * @param {ReadonlyMat2d} m matrix to transform with
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "transformMat2d", ()=>transformMat2d);
/**
 * Transforms the vec2 with a mat3
 * 3rd vector component is implicitly '1'
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the vector to transform
 * @param {ReadonlyMat3} m matrix to transform with
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "transformMat3", ()=>transformMat3);
/**
 * Transforms the vec2 with a mat4
 * 3rd vector component is implicitly '0'
 * 4th vector component is implicitly '1'
 *
 * @param {vec2} out the receiving vector
 * @param {ReadonlyVec2} a the vector to transform
 * @param {ReadonlyMat4} m matrix to transform with
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "transformMat4", ()=>transformMat4);
/**
 * Rotate a 2D vector
 * @param {vec2} out The receiving vec2
 * @param {ReadonlyVec2} a The vec2 point to rotate
 * @param {ReadonlyVec2} b The origin of the rotation
 * @param {Number} rad The angle of rotation in radians
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "rotate", ()=>rotate);
/**
 * Get the angle between two 2D vectors
 * @param {ReadonlyVec2} a The first operand
 * @param {ReadonlyVec2} b The second operand
 * @returns {Number} The angle in radians
 */ parcelHelpers.export(exports, "angle", ()=>angle);
/**
 * Set the components of a vec2 to zero
 *
 * @param {vec2} out the receiving vector
 * @returns {vec2} out
 */ parcelHelpers.export(exports, "zero", ()=>zero);
/**
 * Returns a string representation of a vector
 *
 * @param {ReadonlyVec2} a vector to represent as a string
 * @returns {String} string representation of the vector
 */ parcelHelpers.export(exports, "str", ()=>str);
/**
 * Returns whether or not the vectors exactly have the same elements in the same position (when compared with ===)
 *
 * @param {ReadonlyVec2} a The first vector.
 * @param {ReadonlyVec2} b The second vector.
 * @returns {Boolean} True if the vectors are equal, false otherwise.
 */ parcelHelpers.export(exports, "exactEquals", ()=>exactEquals);
/**
 * Returns whether or not the vectors have approximately the same elements in the same position.
 *
 * @param {ReadonlyVec2} a The first vector.
 * @param {ReadonlyVec2} b The second vector.
 * @returns {Boolean} True if the vectors are equal, false otherwise.
 */ parcelHelpers.export(exports, "equals", ()=>equals);
parcelHelpers.export(exports, "len", ()=>len);
parcelHelpers.export(exports, "sub", ()=>sub);
parcelHelpers.export(exports, "mul", ()=>mul);
parcelHelpers.export(exports, "div", ()=>div);
parcelHelpers.export(exports, "dist", ()=>dist);
parcelHelpers.export(exports, "sqrDist", ()=>sqrDist);
parcelHelpers.export(exports, "sqrLen", ()=>sqrLen);
parcelHelpers.export(exports, "forEach", ()=>forEach);
var _commonJs = require("./common.js");
function create() {
    var out = new _commonJs.ARRAY_TYPE(2);
    if (_commonJs.ARRAY_TYPE != Float32Array) {
        out[0] = 0;
        out[1] = 0;
    }
    return out;
}
function clone(a) {
    var out = new _commonJs.ARRAY_TYPE(2);
    out[0] = a[0];
    out[1] = a[1];
    return out;
}
function fromValues(x, y) {
    var out = new _commonJs.ARRAY_TYPE(2);
    out[0] = x;
    out[1] = y;
    return out;
}
function copy(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    return out;
}
function set(out, x, y) {
    out[0] = x;
    out[1] = y;
    return out;
}
function add(out, a, b) {
    out[0] = a[0] + b[0];
    out[1] = a[1] + b[1];
    return out;
}
function subtract(out, a, b) {
    out[0] = a[0] - b[0];
    out[1] = a[1] - b[1];
    return out;
}
function multiply(out, a, b) {
    out[0] = a[0] * b[0];
    out[1] = a[1] * b[1];
    return out;
}
function divide(out, a, b) {
    out[0] = a[0] / b[0];
    out[1] = a[1] / b[1];
    return out;
}
function ceil(out, a) {
    out[0] = Math.ceil(a[0]);
    out[1] = Math.ceil(a[1]);
    return out;
}
function floor(out, a) {
    out[0] = Math.floor(a[0]);
    out[1] = Math.floor(a[1]);
    return out;
}
function min(out, a, b) {
    out[0] = Math.min(a[0], b[0]);
    out[1] = Math.min(a[1], b[1]);
    return out;
}
function max(out, a, b) {
    out[0] = Math.max(a[0], b[0]);
    out[1] = Math.max(a[1], b[1]);
    return out;
}
function round(out, a) {
    out[0] = Math.round(a[0]);
    out[1] = Math.round(a[1]);
    return out;
}
function scale(out, a, b) {
    out[0] = a[0] * b;
    out[1] = a[1] * b;
    return out;
}
function scaleAndAdd(out, a, b, scale) {
    out[0] = a[0] + b[0] * scale;
    out[1] = a[1] + b[1] * scale;
    return out;
}
function distance(a, b) {
    var x = b[0] - a[0], y = b[1] - a[1];
    return Math.hypot(x, y);
}
function squaredDistance(a, b) {
    var x = b[0] - a[0], y = b[1] - a[1];
    return x * x + y * y;
}
function length(a) {
    var x = a[0], y = a[1];
    return Math.hypot(x, y);
}
function squaredLength(a) {
    var x = a[0], y = a[1];
    return x * x + y * y;
}
function negate(out, a) {
    out[0] = -a[0];
    out[1] = -a[1];
    return out;
}
function inverse(out, a) {
    out[0] = 1.0 / a[0];
    out[1] = 1.0 / a[1];
    return out;
}
function normalize(out, a) {
    var x = a[0], y = a[1];
    var len = x * x + y * y;
    if (len > 0) //TODO: evaluate use of glm_invsqrt here?
    len = 1 / Math.sqrt(len);
    out[0] = a[0] * len;
    out[1] = a[1] * len;
    return out;
}
function dot(a, b) {
    return a[0] * b[0] + a[1] * b[1];
}
function cross(out, a, b) {
    var z = a[0] * b[1] - a[1] * b[0];
    out[0] = out[1] = 0;
    out[2] = z;
    return out;
}
function lerp(out, a, b, t) {
    var ax = a[0], ay = a[1];
    out[0] = ax + t * (b[0] - ax);
    out[1] = ay + t * (b[1] - ay);
    return out;
}
function random(out, scale) {
    scale = scale || 1.0;
    var r = _commonJs.RANDOM() * 2.0 * Math.PI;
    out[0] = Math.cos(r) * scale;
    out[1] = Math.sin(r) * scale;
    return out;
}
function transformMat2(out, a, m) {
    var x = a[0], y = a[1];
    out[0] = m[0] * x + m[2] * y;
    out[1] = m[1] * x + m[3] * y;
    return out;
}
function transformMat2d(out, a, m) {
    var x = a[0], y = a[1];
    out[0] = m[0] * x + m[2] * y + m[4];
    out[1] = m[1] * x + m[3] * y + m[5];
    return out;
}
function transformMat3(out, a, m) {
    var x = a[0], y = a[1];
    out[0] = m[0] * x + m[3] * y + m[6];
    out[1] = m[1] * x + m[4] * y + m[7];
    return out;
}
function transformMat4(out, a, m) {
    var x = a[0];
    var y = a[1];
    out[0] = m[0] * x + m[4] * y + m[12];
    out[1] = m[1] * x + m[5] * y + m[13];
    return out;
}
function rotate(out, a, b, rad) {
    //Translate point to the origin
    var p0 = a[0] - b[0], p1 = a[1] - b[1], sinC = Math.sin(rad), cosC = Math.cos(rad); //perform rotation and translate to correct position
    out[0] = p0 * cosC - p1 * sinC + b[0];
    out[1] = p0 * sinC + p1 * cosC + b[1];
    return out;
}
function angle(a, b) {
    var x1 = a[0], y1 = a[1], x2 = b[0], y2 = b[1], // mag is the product of the magnitudes of a and b
    mag = Math.sqrt(x1 * x1 + y1 * y1) * Math.sqrt(x2 * x2 + y2 * y2), // mag &&.. short circuits if mag == 0
    cosine = mag && (x1 * x2 + y1 * y2) / mag; // Math.min(Math.max(cosine, -1), 1) clamps the cosine between -1 and 1
    return Math.acos(Math.min(Math.max(cosine, -1), 1));
}
function zero(out) {
    out[0] = 0.0;
    out[1] = 0.0;
    return out;
}
function str(a) {
    return "vec2(" + a[0] + ", " + a[1] + ")";
}
function exactEquals(a, b) {
    return a[0] === b[0] && a[1] === b[1];
}
function equals(a, b) {
    var a0 = a[0], a1 = a[1];
    var b0 = b[0], b1 = b[1];
    return Math.abs(a0 - b0) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a0), Math.abs(b0)) && Math.abs(a1 - b1) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a1), Math.abs(b1));
}
var len = length;
var sub = subtract;
var mul = multiply;
var div = divide;
var dist = distance;
var sqrDist = squaredDistance;
var sqrLen = squaredLength;
var forEach = function() {
    var vec = create();
    return function(a, stride, offset, count, fn, arg) {
        var i, l;
        if (!stride) stride = 2;
        if (!offset) offset = 0;
        if (count) l = Math.min(count * stride + offset, a.length);
        else l = a.length;
        for(i = offset; i < l; i += stride){
            vec[0] = a[i];
            vec[1] = a[i + 1];
            fn(vec, vec, arg);
            a[i] = vec[0];
            a[i + 1] = vec[1];
        }
        return a;
    };
}();

},{"./common.js":"lYeTq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lplGD":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
/**
 * 4 Dimensional Vector
 * @module vec4
 */ /**
 * Creates a new, empty vec4
 *
 * @returns {vec4} a new 4D vector
 */ parcelHelpers.export(exports, "create", ()=>create);
/**
 * Creates a new vec4 initialized with values from an existing vector
 *
 * @param {ReadonlyVec4} a vector to clone
 * @returns {vec4} a new 4D vector
 */ parcelHelpers.export(exports, "clone", ()=>clone);
/**
 * Creates a new vec4 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @param {Number} w W component
 * @returns {vec4} a new 4D vector
 */ parcelHelpers.export(exports, "fromValues", ()=>fromValues);
/**
 * Copy the values from one vec4 to another
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the source vector
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "copy", ()=>copy);
/**
 * Set the components of a vec4 to the given values
 *
 * @param {vec4} out the receiving vector
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @param {Number} w W component
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "set", ()=>set);
/**
 * Adds two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "add", ()=>add);
/**
 * Subtracts vector b from vector a
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "subtract", ()=>subtract);
/**
 * Multiplies two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "multiply", ()=>multiply);
/**
 * Divides two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "divide", ()=>divide);
/**
 * Math.ceil the components of a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a vector to ceil
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "ceil", ()=>ceil);
/**
 * Math.floor the components of a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a vector to floor
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "floor", ()=>floor);
/**
 * Returns the minimum of two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "min", ()=>min);
/**
 * Returns the maximum of two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "max", ()=>max);
/**
 * Math.round the components of a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a vector to round
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "round", ()=>round);
/**
 * Scales a vec4 by a scalar number
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the vector to scale
 * @param {Number} b amount to scale the vector by
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "scale", ()=>scale);
/**
 * Adds two vec4's after scaling the second operand by a scalar value
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @param {Number} scale the amount to scale b by before adding
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "scaleAndAdd", ()=>scaleAndAdd);
/**
 * Calculates the euclidian distance between two vec4's
 *
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {Number} distance between a and b
 */ parcelHelpers.export(exports, "distance", ()=>distance);
/**
 * Calculates the squared euclidian distance between two vec4's
 *
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {Number} squared distance between a and b
 */ parcelHelpers.export(exports, "squaredDistance", ()=>squaredDistance);
/**
 * Calculates the length of a vec4
 *
 * @param {ReadonlyVec4} a vector to calculate length of
 * @returns {Number} length of a
 */ parcelHelpers.export(exports, "length", ()=>length);
/**
 * Calculates the squared length of a vec4
 *
 * @param {ReadonlyVec4} a vector to calculate squared length of
 * @returns {Number} squared length of a
 */ parcelHelpers.export(exports, "squaredLength", ()=>squaredLength);
/**
 * Negates the components of a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a vector to negate
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "negate", ()=>negate);
/**
 * Returns the inverse of the components of a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a vector to invert
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "inverse", ()=>inverse);
/**
 * Normalize a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a vector to normalize
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "normalize", ()=>normalize);
/**
 * Calculates the dot product of two vec4's
 *
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @returns {Number} dot product of a and b
 */ parcelHelpers.export(exports, "dot", ()=>dot);
/**
 * Returns the cross-product of three vectors in a 4-dimensional space
 *
 * @param {ReadonlyVec4} result the receiving vector
 * @param {ReadonlyVec4} U the first vector
 * @param {ReadonlyVec4} V the second vector
 * @param {ReadonlyVec4} W the third vector
 * @returns {vec4} result
 */ parcelHelpers.export(exports, "cross", ()=>cross);
/**
 * Performs a linear interpolation between two vec4's
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the first operand
 * @param {ReadonlyVec4} b the second operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "lerp", ()=>lerp);
/**
 * Generates a random vector with the given scale
 *
 * @param {vec4} out the receiving vector
 * @param {Number} [scale] Length of the resulting vector. If ommitted, a unit vector will be returned
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "random", ()=>random);
/**
 * Transforms the vec4 with a mat4.
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the vector to transform
 * @param {ReadonlyMat4} m matrix to transform with
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "transformMat4", ()=>transformMat4);
/**
 * Transforms the vec4 with a quat
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a the vector to transform
 * @param {ReadonlyQuat} q quaternion to transform with
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "transformQuat", ()=>transformQuat);
/**
 * Set the components of a vec4 to zero
 *
 * @param {vec4} out the receiving vector
 * @returns {vec4} out
 */ parcelHelpers.export(exports, "zero", ()=>zero);
/**
 * Returns a string representation of a vector
 *
 * @param {ReadonlyVec4} a vector to represent as a string
 * @returns {String} string representation of the vector
 */ parcelHelpers.export(exports, "str", ()=>str);
/**
 * Returns whether or not the vectors have exactly the same elements in the same position (when compared with ===)
 *
 * @param {ReadonlyVec4} a The first vector.
 * @param {ReadonlyVec4} b The second vector.
 * @returns {Boolean} True if the vectors are equal, false otherwise.
 */ parcelHelpers.export(exports, "exactEquals", ()=>exactEquals);
/**
 * Returns whether or not the vectors have approximately the same elements in the same position.
 *
 * @param {ReadonlyVec4} a The first vector.
 * @param {ReadonlyVec4} b The second vector.
 * @returns {Boolean} True if the vectors are equal, false otherwise.
 */ parcelHelpers.export(exports, "equals", ()=>equals);
parcelHelpers.export(exports, "sub", ()=>sub);
parcelHelpers.export(exports, "mul", ()=>mul);
parcelHelpers.export(exports, "div", ()=>div);
parcelHelpers.export(exports, "dist", ()=>dist);
parcelHelpers.export(exports, "sqrDist", ()=>sqrDist);
parcelHelpers.export(exports, "len", ()=>len);
parcelHelpers.export(exports, "sqrLen", ()=>sqrLen);
parcelHelpers.export(exports, "forEach", ()=>forEach);
var _commonJs = require("./common.js");
function create() {
    var out = new _commonJs.ARRAY_TYPE(4);
    if (_commonJs.ARRAY_TYPE != Float32Array) {
        out[0] = 0;
        out[1] = 0;
        out[2] = 0;
        out[3] = 0;
    }
    return out;
}
function clone(a) {
    var out = new _commonJs.ARRAY_TYPE(4);
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    return out;
}
function fromValues(x, y, z, w) {
    var out = new _commonJs.ARRAY_TYPE(4);
    out[0] = x;
    out[1] = y;
    out[2] = z;
    out[3] = w;
    return out;
}
function copy(out, a) {
    out[0] = a[0];
    out[1] = a[1];
    out[2] = a[2];
    out[3] = a[3];
    return out;
}
function set(out, x, y, z, w) {
    out[0] = x;
    out[1] = y;
    out[2] = z;
    out[3] = w;
    return out;
}
function add(out, a, b) {
    out[0] = a[0] + b[0];
    out[1] = a[1] + b[1];
    out[2] = a[2] + b[2];
    out[3] = a[3] + b[3];
    return out;
}
function subtract(out, a, b) {
    out[0] = a[0] - b[0];
    out[1] = a[1] - b[1];
    out[2] = a[2] - b[2];
    out[3] = a[3] - b[3];
    return out;
}
function multiply(out, a, b) {
    out[0] = a[0] * b[0];
    out[1] = a[1] * b[1];
    out[2] = a[2] * b[2];
    out[3] = a[3] * b[3];
    return out;
}
function divide(out, a, b) {
    out[0] = a[0] / b[0];
    out[1] = a[1] / b[1];
    out[2] = a[2] / b[2];
    out[3] = a[3] / b[3];
    return out;
}
function ceil(out, a) {
    out[0] = Math.ceil(a[0]);
    out[1] = Math.ceil(a[1]);
    out[2] = Math.ceil(a[2]);
    out[3] = Math.ceil(a[3]);
    return out;
}
function floor(out, a) {
    out[0] = Math.floor(a[0]);
    out[1] = Math.floor(a[1]);
    out[2] = Math.floor(a[2]);
    out[3] = Math.floor(a[3]);
    return out;
}
function min(out, a, b) {
    out[0] = Math.min(a[0], b[0]);
    out[1] = Math.min(a[1], b[1]);
    out[2] = Math.min(a[2], b[2]);
    out[3] = Math.min(a[3], b[3]);
    return out;
}
function max(out, a, b) {
    out[0] = Math.max(a[0], b[0]);
    out[1] = Math.max(a[1], b[1]);
    out[2] = Math.max(a[2], b[2]);
    out[3] = Math.max(a[3], b[3]);
    return out;
}
function round(out, a) {
    out[0] = Math.round(a[0]);
    out[1] = Math.round(a[1]);
    out[2] = Math.round(a[2]);
    out[3] = Math.round(a[3]);
    return out;
}
function scale(out, a, b) {
    out[0] = a[0] * b;
    out[1] = a[1] * b;
    out[2] = a[2] * b;
    out[3] = a[3] * b;
    return out;
}
function scaleAndAdd(out, a, b, scale) {
    out[0] = a[0] + b[0] * scale;
    out[1] = a[1] + b[1] * scale;
    out[2] = a[2] + b[2] * scale;
    out[3] = a[3] + b[3] * scale;
    return out;
}
function distance(a, b) {
    var x = b[0] - a[0];
    var y = b[1] - a[1];
    var z = b[2] - a[2];
    var w = b[3] - a[3];
    return Math.hypot(x, y, z, w);
}
function squaredDistance(a, b) {
    var x = b[0] - a[0];
    var y = b[1] - a[1];
    var z = b[2] - a[2];
    var w = b[3] - a[3];
    return x * x + y * y + z * z + w * w;
}
function length(a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    var w = a[3];
    return Math.hypot(x, y, z, w);
}
function squaredLength(a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    var w = a[3];
    return x * x + y * y + z * z + w * w;
}
function negate(out, a) {
    out[0] = -a[0];
    out[1] = -a[1];
    out[2] = -a[2];
    out[3] = -a[3];
    return out;
}
function inverse(out, a) {
    out[0] = 1.0 / a[0];
    out[1] = 1.0 / a[1];
    out[2] = 1.0 / a[2];
    out[3] = 1.0 / a[3];
    return out;
}
function normalize(out, a) {
    var x = a[0];
    var y = a[1];
    var z = a[2];
    var w = a[3];
    var len = x * x + y * y + z * z + w * w;
    if (len > 0) len = 1 / Math.sqrt(len);
    out[0] = x * len;
    out[1] = y * len;
    out[2] = z * len;
    out[3] = w * len;
    return out;
}
function dot(a, b) {
    return a[0] * b[0] + a[1] * b[1] + a[2] * b[2] + a[3] * b[3];
}
function cross(out, u, v, w) {
    var A = v[0] * w[1] - v[1] * w[0], B = v[0] * w[2] - v[2] * w[0], C = v[0] * w[3] - v[3] * w[0], D = v[1] * w[2] - v[2] * w[1], E = v[1] * w[3] - v[3] * w[1], F = v[2] * w[3] - v[3] * w[2];
    var G = u[0];
    var H = u[1];
    var I = u[2];
    var J = u[3];
    out[0] = H * F - I * E + J * D;
    out[1] = -(G * F) + I * C - J * B;
    out[2] = G * E - H * C + J * A;
    out[3] = -(G * D) + H * B - I * A;
    return out;
}
function lerp(out, a, b, t) {
    var ax = a[0];
    var ay = a[1];
    var az = a[2];
    var aw = a[3];
    out[0] = ax + t * (b[0] - ax);
    out[1] = ay + t * (b[1] - ay);
    out[2] = az + t * (b[2] - az);
    out[3] = aw + t * (b[3] - aw);
    return out;
}
function random(out, scale) {
    scale = scale || 1.0; // Marsaglia, George. Choosing a Point from the Surface of a
    // Sphere. Ann. Math. Statist. 43 (1972), no. 2, 645--646.
    // http://projecteuclid.org/euclid.aoms/1177692644;
    var v1, v2, v3, v4;
    var s1, s2;
    do {
        v1 = _commonJs.RANDOM() * 2 - 1;
        v2 = _commonJs.RANDOM() * 2 - 1;
        s1 = v1 * v1 + v2 * v2;
    }while (s1 >= 1);
    do {
        v3 = _commonJs.RANDOM() * 2 - 1;
        v4 = _commonJs.RANDOM() * 2 - 1;
        s2 = v3 * v3 + v4 * v4;
    }while (s2 >= 1);
    var d = Math.sqrt((1 - s1) / s2);
    out[0] = scale * v1;
    out[1] = scale * v2;
    out[2] = scale * v3 * d;
    out[3] = scale * v4 * d;
    return out;
}
function transformMat4(out, a, m) {
    var x = a[0], y = a[1], z = a[2], w = a[3];
    out[0] = m[0] * x + m[4] * y + m[8] * z + m[12] * w;
    out[1] = m[1] * x + m[5] * y + m[9] * z + m[13] * w;
    out[2] = m[2] * x + m[6] * y + m[10] * z + m[14] * w;
    out[3] = m[3] * x + m[7] * y + m[11] * z + m[15] * w;
    return out;
}
function transformQuat(out, a, q) {
    var x = a[0], y = a[1], z = a[2];
    var qx = q[0], qy = q[1], qz = q[2], qw = q[3]; // calculate quat * vec
    var ix = qw * x + qy * z - qz * y;
    var iy = qw * y + qz * x - qx * z;
    var iz = qw * z + qx * y - qy * x;
    var iw = -qx * x - qy * y - qz * z; // calculate result * inverse quat
    out[0] = ix * qw + iw * -qx + iy * -qz - iz * -qy;
    out[1] = iy * qw + iw * -qy + iz * -qx - ix * -qz;
    out[2] = iz * qw + iw * -qz + ix * -qy - iy * -qx;
    out[3] = a[3];
    return out;
}
function zero(out) {
    out[0] = 0.0;
    out[1] = 0.0;
    out[2] = 0.0;
    out[3] = 0.0;
    return out;
}
function str(a) {
    return "vec4(" + a[0] + ", " + a[1] + ", " + a[2] + ", " + a[3] + ")";
}
function exactEquals(a, b) {
    return a[0] === b[0] && a[1] === b[1] && a[2] === b[2] && a[3] === b[3];
}
function equals(a, b) {
    var a0 = a[0], a1 = a[1], a2 = a[2], a3 = a[3];
    var b0 = b[0], b1 = b[1], b2 = b[2], b3 = b[3];
    return Math.abs(a0 - b0) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a0), Math.abs(b0)) && Math.abs(a1 - b1) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a1), Math.abs(b1)) && Math.abs(a2 - b2) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a2), Math.abs(b2)) && Math.abs(a3 - b3) <= _commonJs.EPSILON * Math.max(1.0, Math.abs(a3), Math.abs(b3));
}
var sub = subtract;
var mul = multiply;
var div = divide;
var dist = distance;
var sqrDist = squaredDistance;
var len = length;
var sqrLen = squaredLength;
var forEach = function() {
    var vec = create();
    return function(a, stride, offset, count, fn, arg) {
        var i, l;
        if (!stride) stride = 4;
        if (!offset) offset = 0;
        if (count) l = Math.min(count * stride + offset, a.length);
        else l = a.length;
        for(i = offset; i < l; i += stride){
            vec[0] = a[i];
            vec[1] = a[i + 1];
            vec[2] = a[i + 2];
            vec[3] = a[i + 3];
            fn(vec, vec, arg);
            a[i] = vec[0];
            a[i + 1] = vec[1];
            a[i + 2] = vec[2];
            a[i + 3] = vec[3];
        }
        return a;
    };
}();

},{"./common.js":"lYeTq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2v2Vq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "lights", ()=>lights);
var _lightsGlsl = require("./lights.glsl");
var _lightsGlslDefault = parcelHelpers.interopDefault(_lightsGlsl);
const INITIAL_MODULE_OPTIONS = {
    lightSources: {}
};
function convertColor() {
    let { color =[
        0,
        0,
        0
    ] , intensity =1.0  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    return color.map((component)=>component * intensity / 255.0);
}
function getLightSourceUniforms(_ref) {
    let { ambientLight , pointLights =[] , directionalLights =[]  } = _ref;
    const lightSourceUniforms = {};
    if (ambientLight) lightSourceUniforms["lighting_uAmbientLight.color"] = convertColor(ambientLight);
    else lightSourceUniforms["lighting_uAmbientLight.color"] = [
        0,
        0,
        0
    ];
    pointLights.forEach((pointLight, index)=>{
        lightSourceUniforms["lighting_uPointLight[".concat(index, "].color")] = convertColor(pointLight);
        lightSourceUniforms["lighting_uPointLight[".concat(index, "].position")] = pointLight.position;
        lightSourceUniforms["lighting_uPointLight[".concat(index, "].attenuation")] = pointLight.attenuation || [
            1,
            0,
            0
        ];
    });
    lightSourceUniforms.lighting_uPointLightCount = pointLights.length;
    directionalLights.forEach((directionalLight, index)=>{
        lightSourceUniforms["lighting_uDirectionalLight[".concat(index, "].color")] = convertColor(directionalLight);
        lightSourceUniforms["lighting_uDirectionalLight[".concat(index, "].direction")] = directionalLight.direction;
    });
    lightSourceUniforms.lighting_uDirectionalLightCount = directionalLights.length;
    return lightSourceUniforms;
}
function getUniforms() {
    let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_MODULE_OPTIONS;
    if ("lightSources" in opts) {
        const { ambientLight , pointLights , directionalLights  } = opts.lightSources || {};
        const hasLights = ambientLight || pointLights && pointLights.length > 0 || directionalLights && directionalLights.length > 0;
        if (!hasLights) return {
            lighting_uEnabled: false
        };
        return Object.assign({}, getLightSourceUniforms({
            ambientLight,
            pointLights,
            directionalLights
        }), {
            lighting_uEnabled: true
        });
    }
    if ("lights" in opts) {
        const lightSources = {
            pointLights: [],
            directionalLights: []
        };
        for (const light of opts.lights || [])switch(light.type){
            case "ambient":
                lightSources.ambientLight = light;
                break;
            case "directional":
                lightSources.directionalLights.push(light);
                break;
            case "point":
                lightSources.pointLights.push(light);
                break;
            default:
        }
        return getUniforms({
            lightSources
        });
    }
    return {};
}
const lights = {
    name: "lights",
    vs: (0, _lightsGlslDefault.default),
    fs: (0, _lightsGlslDefault.default),
    getUniforms,
    defines: {
        MAX_LIGHTS: 3
    }
};

},{"./lights.glsl":"20n3F","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"20n3F":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "#if (defined(SHADER_TYPE_FRAGMENT) && defined(LIGHTING_FRAGMENT)) || (defined(SHADER_TYPE_VERTEX) && defined(LIGHTING_VERTEX))\n\nstruct AmbientLight {\n vec3 color;\n};\n\nstruct PointLight {\n vec3 color;\n vec3 position;\n vec3 attenuation;\n};\n\nstruct DirectionalLight {\n  vec3 color;\n  vec3 direction;\n};\n\nuniform AmbientLight lighting_uAmbientLight;\nuniform PointLight lighting_uPointLight[MAX_LIGHTS];\nuniform DirectionalLight lighting_uDirectionalLight[MAX_LIGHTS];\nuniform int lighting_uPointLightCount;\nuniform int lighting_uDirectionalLightCount;\n\nuniform bool lighting_uEnabled;\n\nfloat getPointLightAttenuation(PointLight pointLight, float distance) {\n  return pointLight.attenuation.x\n       + pointLight.attenuation.y * distance\n       + pointLight.attenuation.z * distance * distance;\n}\n\n#endif\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8Cm8q":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "dirlight", ()=>dirlight);
var _project = require("../project/project");
const DEFAULT_LIGHT_DIRECTION = new Float32Array([
    1,
    1,
    2
]);
const DEFAULT_MODULE_OPTIONS = {
    lightDirection: DEFAULT_LIGHT_DIRECTION
};
function getUniforms() {
    let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_MODULE_OPTIONS;
    const uniforms = {};
    if (opts.lightDirection) uniforms.dirlight_uLightDirection = opts.lightDirection;
    return uniforms;
}
const vs = null;
const fs = "uniform vec3 dirlight_uLightDirection;\nvec4 dirlight_filterColor(vec4 color) {\n  vec3 normal = project_getNormal_World();\n  float d = abs(dot(normalize(normal), normalize(dirlight_uLightDirection)));\n  return vec4(color.rgb * d, color.a);\n}\n";
const dirlight = {
    name: "dirlight",
    vs,
    fs,
    getUniforms,
    dependencies: [
        (0, _project.project)
    ]
};

},{"../project/project":"jONjt","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jsGMU":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "picking", ()=>picking);
const DEFAULT_HIGHLIGHT_COLOR = new Uint8Array([
    0,
    255,
    255,
    255
]);
const DEFAULT_MODULE_OPTIONS = {
    pickingSelectedColor: null,
    pickingHighlightColor: DEFAULT_HIGHLIGHT_COLOR,
    pickingActive: false,
    pickingAttribute: false
};
function getUniforms() {
    let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : DEFAULT_MODULE_OPTIONS;
    const uniforms = {};
    if (opts.pickingSelectedColor !== undefined) {
        if (!opts.pickingSelectedColor) uniforms.picking_uSelectedColorValid = 0;
        else {
            const selectedColor = opts.pickingSelectedColor.slice(0, 3);
            uniforms.picking_uSelectedColorValid = 1;
            uniforms.picking_uSelectedColor = selectedColor;
        }
    }
    if (opts.pickingHighlightColor) {
        const color = Array.from(opts.pickingHighlightColor, (x)=>x / 255);
        if (!Number.isFinite(color[3])) color[3] = 1;
        uniforms.picking_uHighlightColor = color;
    }
    if (opts.pickingActive !== undefined) {
        uniforms.picking_uActive = Boolean(opts.pickingActive);
        uniforms.picking_uAttribute = Boolean(opts.pickingAttribute);
    }
    return uniforms;
}
const vs = "uniform bool picking_uActive;\nuniform bool picking_uAttribute;\nuniform vec3 picking_uSelectedColor;\nuniform bool picking_uSelectedColorValid;\n\nout vec4 picking_vRGBcolor_Avalid;\n\nconst float COLOR_SCALE = 1. / 255.;\n\nbool picking_isColorValid(vec3 color) {\n  return dot(color, vec3(1.0)) > 0.001;\n}\n\nbool isVertexPicked(vec3 vertexColor) {\n  return\n    picking_uSelectedColorValid &&\n    !picking_isColorValid(abs(vertexColor - picking_uSelectedColor));\n}\n\nvoid picking_setPickingColor(vec3 pickingColor) {\n  if (picking_uActive) {\n    picking_vRGBcolor_Avalid.a = float(picking_isColorValid(pickingColor));\n\n    if (!picking_uAttribute) {\n      picking_vRGBcolor_Avalid.rgb = pickingColor * COLOR_SCALE;\n    }\n  } else {\n    picking_vRGBcolor_Avalid.a = float(isVertexPicked(pickingColor));\n  }\n}\n\nvoid picking_setPickingAttribute(float value) {\n  if (picking_uAttribute) {\n    picking_vRGBcolor_Avalid.r = value;\n  }\n}\nvoid picking_setPickingAttribute(vec2 value) {\n  if (picking_uAttribute) {\n    picking_vRGBcolor_Avalid.rg = value;\n  }\n}\nvoid picking_setPickingAttribute(vec3 value) {\n  if (picking_uAttribute) {\n    picking_vRGBcolor_Avalid.rgb = value;\n  }\n}\n";
const fs = "uniform bool picking_uActive;\nuniform vec3 picking_uSelectedColor;\nuniform vec4 picking_uHighlightColor;\n\nin vec4 picking_vRGBcolor_Avalid;\nvec4 picking_filterHighlightColor(vec4 color) {\n  if (picking_uActive) {\n    return color;\n  }\n  bool selected = bool(picking_vRGBcolor_Avalid.a);\n\n  if (selected) {\n    float highLightAlpha = picking_uHighlightColor.a;\n    float blendedAlpha = highLightAlpha + color.a * (1.0 - highLightAlpha);\n    float highLightRatio = highLightAlpha / blendedAlpha;\n\n    vec3 blendedRGB = mix(color.rgb, picking_uHighlightColor.rgb, highLightRatio);\n    return vec4(blendedRGB, blendedAlpha);\n  } else {\n    return color;\n  }\n}\nvec4 picking_filterPickingColor(vec4 color) {\n  if (picking_uActive) {\n    if (picking_vRGBcolor_Avalid.a == 0.0) {\n      discard;\n    }\n    return picking_vRGBcolor_Avalid;\n  }\n  return color;\n}\nvec4 picking_filterColor(vec4 color) {\n  vec4 highightColor = picking_filterHighlightColor(color);\n  return picking_filterPickingColor(highightColor);\n}\n\n";
const picking = {
    name: "picking",
    vs,
    fs,
    getUniforms
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3Xd78":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "gouraudLighting", ()=>gouraudLighting);
parcelHelpers.export(exports, "phongLighting", ()=>phongLighting);
var _lights = require("../lights/lights");
var _phongLightingGlsl = require("./phong-lighting.glsl");
var _phongLightingGlslDefault = parcelHelpers.interopDefault(_phongLightingGlsl);
const INITIAL_MODULE_OPTIONS = {};
function getMaterialUniforms(material) {
    const { ambient =0.35 , diffuse =0.6 , shininess =32 , specularColor =[
        30,
        30,
        30
    ]  } = material;
    return {
        lighting_uAmbient: ambient,
        lighting_uDiffuse: diffuse,
        lighting_uShininess: shininess,
        lighting_uSpecularColor: specularColor.map((x)=>x / 255)
    };
}
function getUniforms() {
    let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_MODULE_OPTIONS;
    if (!("material" in opts)) return {};
    const { material  } = opts;
    if (!material) return {
        lighting_uEnabled: false
    };
    return getMaterialUniforms(material);
}
const gouraudLighting = {
    name: "gouraud-lighting",
    dependencies: [
        (0, _lights.lights)
    ],
    vs: (0, _phongLightingGlslDefault.default),
    defines: {
        LIGHTING_VERTEX: 1
    },
    getUniforms
};
const phongLighting = {
    name: "phong-lighting",
    dependencies: [
        (0, _lights.lights)
    ],
    fs: (0, _phongLightingGlslDefault.default),
    defines: {
        LIGHTING_FRAGMENT: 1
    },
    getUniforms
};

},{"../lights/lights":"2v2Vq","./phong-lighting.glsl":"l7zoG","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"l7zoG":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "\nuniform float lighting_uAmbient;\nuniform float lighting_uDiffuse;\nuniform float lighting_uShininess;\nuniform vec3  lighting_uSpecularColor;\n\nvec3 lighting_getLightColor(vec3 surfaceColor, vec3 light_direction, vec3 view_direction, vec3 normal_worldspace, vec3 color) {\n    vec3 halfway_direction = normalize(light_direction + view_direction);\n    float lambertian = dot(light_direction, normal_worldspace);\n    float specular = 0.0;\n    if (lambertian > 0.0) {\n      float specular_angle = max(dot(normal_worldspace, halfway_direction), 0.0);\n      specular = pow(specular_angle, lighting_uShininess);\n    }\n    lambertian = max(lambertian, 0.0);\n    return (lambertian * lighting_uDiffuse * surfaceColor + specular * lighting_uSpecularColor) * color;\n}\n\nvec3 lighting_getLightColor(vec3 surfaceColor, vec3 cameraPosition, vec3 position_worldspace, vec3 normal_worldspace) {\n  vec3 lightColor = surfaceColor;\n\n  if (lighting_uEnabled) {\n    vec3 view_direction = normalize(cameraPosition - position_worldspace);\n    lightColor = lighting_uAmbient * surfaceColor * lighting_uAmbientLight.color;\n\n    for (int i = 0; i < MAX_LIGHTS; i++) {\n      if (i >= lighting_uPointLightCount) {\n        break;\n      }\n      PointLight pointLight = lighting_uPointLight[i];\n      vec3 light_position_worldspace = pointLight.position;\n      vec3 light_direction = normalize(light_position_worldspace - position_worldspace);\n      lightColor += lighting_getLightColor(surfaceColor, light_direction, view_direction, normal_worldspace, pointLight.color);\n    }\n\n    for (int i = 0; i < MAX_LIGHTS; i++) {\n      if (i >= lighting_uDirectionalLightCount) {\n        break;\n      }\n      DirectionalLight directionalLight = lighting_uDirectionalLight[i];\n      lightColor += lighting_getLightColor(surfaceColor, -directionalLight.direction, view_direction, normal_worldspace, directionalLight.color);\n    }\n  }\n  return lightColor;\n}\n\nvec3 lighting_getSpecularLightColor(vec3 cameraPosition, vec3 position_worldspace, vec3 normal_worldspace) {\n  vec3 lightColor = vec3(0, 0, 0);\n  vec3 surfaceColor = vec3(0, 0, 0);\n\n  if (lighting_uEnabled) {\n    vec3 view_direction = normalize(cameraPosition - position_worldspace);\n\n    for (int i = 0; i < MAX_LIGHTS; i++) {\n      if (i >= lighting_uPointLightCount) {\n        break;\n      }\n      PointLight pointLight = lighting_uPointLight[i];\n      vec3 light_position_worldspace = pointLight.position;\n      vec3 light_direction = normalize(light_position_worldspace - position_worldspace);\n      lightColor += lighting_getLightColor(surfaceColor, light_direction, view_direction, normal_worldspace, pointLight.color);\n    }\n\n    for (int i = 0; i < MAX_LIGHTS; i++) {\n      if (i >= lighting_uDirectionalLightCount) {\n        break;\n      }\n      DirectionalLight directionalLight = lighting_uDirectionalLight[i];\n      lightColor += lighting_getLightColor(surfaceColor, -directionalLight.direction, view_direction, normal_worldspace, directionalLight.color);\n    }\n  }\n  return lightColor;\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"f4RB5":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "pbr", ()=>pbr);
var _lights = require("../lights/lights");
var _pbrVertexGlsl = require("./pbr-vertex.glsl");
var _pbrVertexGlslDefault = parcelHelpers.interopDefault(_pbrVertexGlsl);
var _pbrFragmentGlsl = require("./pbr-fragment.glsl");
var _pbrFragmentGlslDefault = parcelHelpers.interopDefault(_pbrFragmentGlsl);
const pbr = {
    name: "pbr",
    vs: (0, _pbrVertexGlslDefault.default),
    fs: (0, _pbrFragmentGlslDefault.default),
    defines: {
        LIGHTING_FRAGMENT: 1
    },
    dependencies: [
        (0, _lights.lights)
    ]
};

},{"../lights/lights":"2v2Vq","./pbr-vertex.glsl":"lEqQy","./pbr-fragment.glsl":"9zo7e","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lEqQy":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "uniform mat4 u_MVPMatrix;\nuniform mat4 u_ModelMatrix;\nuniform mat4 u_NormalMatrix;\n\nvarying vec3 pbr_vPosition;\nvarying vec2 pbr_vUV;\n\n#ifdef HAS_NORMALS\n# ifdef HAS_TANGENTS\nvarying mat3 pbr_vTBN;\n# else\nvarying vec3 pbr_vNormal;\n# endif\n#endif\n\nvoid pbr_setPositionNormalTangentUV(vec4 position, vec4 normal, vec4 tangent, vec2 uv)\n{\n  vec4 pos = u_ModelMatrix * position;\n  pbr_vPosition = vec3(pos.xyz) / pos.w;\n\n#ifdef HAS_NORMALS\n#ifdef HAS_TANGENTS\n  vec3 normalW = normalize(vec3(u_NormalMatrix * vec4(normal.xyz, 0.0)));\n  vec3 tangentW = normalize(vec3(u_ModelMatrix * vec4(tangent.xyz, 0.0)));\n  vec3 bitangentW = cross(normalW, tangentW) * tangent.w;\n  pbr_vTBN = mat3(tangentW, bitangentW, normalW);\n#else\n  pbr_vNormal = normalize(vec3(u_ModelMatrix * vec4(normal.xyz, 0.0)));\n#endif\n#endif\n\n#ifdef HAS_UV\n  pbr_vUV = uv;\n#else\n  pbr_vUV = vec2(0.,0.);\n#endif\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9zo7e":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "#if defined(USE_TEX_LOD) && !defined(FEATURE_GLSL_TEXTURE_LOD)\n# error PBR fragment shader: Texture LOD is not available\n#endif\n\n#if !defined(HAS_TANGENTS) && !defined(FEATURE_GLSL_DERIVATIVES)\n# error PBR fragment shader: Derivatives are not available\n#endif\n\n\n#if (__VERSION__ < 300)\n  #define SMART_FOR(INIT, WEBGL1COND, WEBGL2COND, INCR) for (INIT; WEBGL1COND; INCR)\n#else\n  #define SMART_FOR(INIT, WEBGL1COND, WEBGL2COND, INCR) for (INIT; WEBGL2COND; INCR)\n#endif\n\nprecision highp float;\n\nuniform bool pbr_uUnlit;\n\n#ifdef USE_IBL\nuniform samplerCube u_DiffuseEnvSampler;\nuniform samplerCube u_SpecularEnvSampler;\nuniform sampler2D u_brdfLUT;\nuniform vec2 u_ScaleIBLAmbient;\n#endif\n\n#ifdef HAS_BASECOLORMAP\nuniform sampler2D u_BaseColorSampler;\n#endif\n#ifdef HAS_NORMALMAP\nuniform sampler2D u_NormalSampler;\nuniform float u_NormalScale;\n#endif\n#ifdef HAS_EMISSIVEMAP\nuniform sampler2D u_EmissiveSampler;\nuniform vec3 u_EmissiveFactor;\n#endif\n#ifdef HAS_METALROUGHNESSMAP\nuniform sampler2D u_MetallicRoughnessSampler;\n#endif\n#ifdef HAS_OCCLUSIONMAP\nuniform sampler2D u_OcclusionSampler;\nuniform float u_OcclusionStrength;\n#endif\n\n#ifdef ALPHA_CUTOFF\nuniform float u_AlphaCutoff;\n#endif\n\nuniform vec2 u_MetallicRoughnessValues;\nuniform vec4 u_BaseColorFactor;\n\nuniform vec3 u_Camera;\n#ifdef PBR_DEBUG\nuniform vec4 u_ScaleDiffBaseMR;\nuniform vec4 u_ScaleFGDSpec;\n#endif\n\nvarying vec3 pbr_vPosition;\n\nvarying vec2 pbr_vUV;\n\n#ifdef HAS_NORMALS\n#ifdef HAS_TANGENTS\nvarying mat3 pbr_vTBN;\n#else\nvarying vec3 pbr_vNormal;\n#endif\n#endif\n\n\nstruct PBRInfo\n{\n  float NdotL;\n  float NdotV;\n  float NdotH;\n  float LdotH;\n  float VdotH;\n  float perceptualRoughness;\n  float metalness;\n  vec3 reflectance0;\n  vec3 reflectance90;\n  float alphaRoughness;\n  vec3 diffuseColor;\n  vec3 specularColor;\n  vec3 n;\n  vec3 v;\n};\n\nconst float M_PI = 3.141592653589793;\nconst float c_MinRoughness = 0.04;\n\nvec4 SRGBtoLINEAR(vec4 srgbIn)\n{\n#ifdef MANUAL_SRGB\n#ifdef SRGB_FAST_APPROXIMATION\n  vec3 linOut = pow(srgbIn.xyz,vec3(2.2));\n#else\n  vec3 bLess = step(vec3(0.04045),srgbIn.xyz);\n  vec3 linOut = mix( srgbIn.xyz/vec3(12.92), pow((srgbIn.xyz+vec3(0.055))/vec3(1.055),vec3(2.4)), bLess );\n#endif\n  return vec4(linOut,srgbIn.w);;\n#else\n  return srgbIn;\n#endif\n}\n\nvec3 getNormal()\n{\n#ifndef HAS_TANGENTS\n  vec3 pos_dx = dFdx(pbr_vPosition);\n  vec3 pos_dy = dFdy(pbr_vPosition);\n  vec3 tex_dx = dFdx(vec3(pbr_vUV, 0.0));\n  vec3 tex_dy = dFdy(vec3(pbr_vUV, 0.0));\n  vec3 t = (tex_dy.t * pos_dx - tex_dx.t * pos_dy) / (tex_dx.s * tex_dy.t - tex_dy.s * tex_dx.t);\n\n#ifdef HAS_NORMALS\n  vec3 ng = normalize(pbr_vNormal);\n#else\n  vec3 ng = cross(pos_dx, pos_dy);\n#endif\n\n  t = normalize(t - ng * dot(ng, t));\n  vec3 b = normalize(cross(ng, t));\n  mat3 tbn = mat3(t, b, ng);\n#else\n  mat3 tbn = pbr_vTBN;\n#endif\n\n#ifdef HAS_NORMALMAP\n  vec3 n = texture2D(u_NormalSampler, pbr_vUV).rgb;\n  n = normalize(tbn * ((2.0 * n - 1.0) * vec3(u_NormalScale, u_NormalScale, 1.0)));\n#else\n  vec3 n = normalize(tbn[2].xyz);\n#endif\n\n  return n;\n}\n\n\n#ifdef USE_IBL\nvec3 getIBLContribution(PBRInfo pbrInputs, vec3 n, vec3 reflection)\n{\n  float mipCount = 9.0;\n  float lod = (pbrInputs.perceptualRoughness * mipCount);\n  vec3 brdf = SRGBtoLINEAR(texture2D(u_brdfLUT,\n    vec2(pbrInputs.NdotV, 1.0 - pbrInputs.perceptualRoughness))).rgb;\n  vec3 diffuseLight = SRGBtoLINEAR(textureCube(u_DiffuseEnvSampler, n)).rgb;\n\n#ifdef USE_TEX_LOD\n  vec3 specularLight = SRGBtoLINEAR(textureCubeLod(u_SpecularEnvSampler, reflection, lod)).rgb;\n#else\n  vec3 specularLight = SRGBtoLINEAR(textureCube(u_SpecularEnvSampler, reflection)).rgb;\n#endif\n\n  vec3 diffuse = diffuseLight * pbrInputs.diffuseColor;\n  vec3 specular = specularLight * (pbrInputs.specularColor * brdf.x + brdf.y);\n  diffuse *= u_ScaleIBLAmbient.x;\n  specular *= u_ScaleIBLAmbient.y;\n\n  return diffuse + specular;\n}\n#endif\n\n\nvec3 diffuse(PBRInfo pbrInputs)\n{\n  return pbrInputs.diffuseColor / M_PI;\n}\n\nvec3 specularReflection(PBRInfo pbrInputs)\n{\n  return pbrInputs.reflectance0 +\n    (pbrInputs.reflectance90 - pbrInputs.reflectance0) *\n    pow(clamp(1.0 - pbrInputs.VdotH, 0.0, 1.0), 5.0);\n}\n\n\n\nfloat geometricOcclusion(PBRInfo pbrInputs)\n{\n  float NdotL = pbrInputs.NdotL;\n  float NdotV = pbrInputs.NdotV;\n  float r = pbrInputs.alphaRoughness;\n\n  float attenuationL = 2.0 * NdotL / (NdotL + sqrt(r * r + (1.0 - r * r) * (NdotL * NdotL)));\n  float attenuationV = 2.0 * NdotV / (NdotV + sqrt(r * r + (1.0 - r * r) * (NdotV * NdotV)));\n  return attenuationL * attenuationV;\n}\n\n\n\n\n\nfloat microfacetDistribution(PBRInfo pbrInputs)\n{\n  float roughnessSq = pbrInputs.alphaRoughness * pbrInputs.alphaRoughness;\n  float f = (pbrInputs.NdotH * roughnessSq - pbrInputs.NdotH) * pbrInputs.NdotH + 1.0;\n  return roughnessSq / (M_PI * f * f);\n}\n\nvoid PBRInfo_setAmbientLight(inout PBRInfo pbrInputs) {\n  pbrInputs.NdotL = 1.0;\n  pbrInputs.NdotH = 0.0;\n  pbrInputs.LdotH = 0.0;\n  pbrInputs.VdotH = 1.0;\n}\n\nvoid PBRInfo_setDirectionalLight(inout PBRInfo pbrInputs, vec3 lightDirection) {\n  vec3 n = pbrInputs.n;\n  vec3 v = pbrInputs.v;\n  vec3 l = normalize(lightDirection);\n  vec3 h = normalize(l+v);\n\n  pbrInputs.NdotL = clamp(dot(n, l), 0.001, 1.0);\n  pbrInputs.NdotH = clamp(dot(n, h), 0.0, 1.0);\n  pbrInputs.LdotH = clamp(dot(l, h), 0.0, 1.0);\n  pbrInputs.VdotH = clamp(dot(v, h), 0.0, 1.0);\n}\n\nvoid PBRInfo_setPointLight(inout PBRInfo pbrInputs, PointLight pointLight) {\n  vec3 light_direction = normalize(pointLight.position - pbr_vPosition);\n  PBRInfo_setDirectionalLight(pbrInputs, light_direction);\n}\n\nvec3 calculateFinalColor(PBRInfo pbrInputs, vec3 lightColor) {\n  vec3 F = specularReflection(pbrInputs);\n  float G = geometricOcclusion(pbrInputs);\n  float D = microfacetDistribution(pbrInputs);\n  vec3 diffuseContrib = (1.0 - F) * diffuse(pbrInputs);\n  vec3 specContrib = F * G * D / (4.0 * pbrInputs.NdotL * pbrInputs.NdotV);\n  return pbrInputs.NdotL * lightColor * (diffuseContrib + specContrib);\n}\n\nvec4 pbr_filterColor(vec4 colorUnused)\n{\n#ifdef HAS_BASECOLORMAP\n  vec4 baseColor = SRGBtoLINEAR(texture2D(u_BaseColorSampler, pbr_vUV)) * u_BaseColorFactor;\n#else\n  vec4 baseColor = u_BaseColorFactor;\n#endif\n\n#ifdef ALPHA_CUTOFF\n  if (baseColor.a < u_AlphaCutoff) {\n    discard;\n  }\n#endif\n\n  vec3 color = vec3(0, 0, 0);\n\n  if(pbr_uUnlit){\n    color.rgb = baseColor.rgb;\n  }\n  else{\n\n\n    float perceptualRoughness = u_MetallicRoughnessValues.y;\n    float metallic = u_MetallicRoughnessValues.x;\n#ifdef HAS_METALROUGHNESSMAP\n\n    vec4 mrSample = texture2D(u_MetallicRoughnessSampler, pbr_vUV);\n    perceptualRoughness = mrSample.g * perceptualRoughness;\n    metallic = mrSample.b * metallic;\n#endif\n    perceptualRoughness = clamp(perceptualRoughness, c_MinRoughness, 1.0);\n    metallic = clamp(metallic, 0.0, 1.0);\n\n    float alphaRoughness = perceptualRoughness * perceptualRoughness;\n\n    vec3 f0 = vec3(0.04);\n    vec3 diffuseColor = baseColor.rgb * (vec3(1.0) - f0);\n    diffuseColor *= 1.0 - metallic;\n    vec3 specularColor = mix(f0, baseColor.rgb, metallic);\n    float reflectance = max(max(specularColor.r, specularColor.g), specularColor.b);\n\n\n\n    float reflectance90 = clamp(reflectance * 25.0, 0.0, 1.0);\n    vec3 specularEnvironmentR0 = specularColor.rgb;\n    vec3 specularEnvironmentR90 = vec3(1.0, 1.0, 1.0) * reflectance90;\n\n    vec3 n = getNormal();\n    vec3 v = normalize(u_Camera - pbr_vPosition);\n\n    float NdotV = clamp(abs(dot(n, v)), 0.001, 1.0);\n    vec3 reflection = -normalize(reflect(v, n));\n\n    PBRInfo pbrInputs = PBRInfo(\n      0.0,\n      NdotV,\n      0.0,\n      0.0,\n      0.0,\n      perceptualRoughness,\n      metallic,\n      specularEnvironmentR0,\n      specularEnvironmentR90,\n      alphaRoughness,\n      diffuseColor,\n      specularColor,\n      n,\n      v\n    );\n\n#ifdef USE_LIGHTS\n    PBRInfo_setAmbientLight(pbrInputs);\n    color += calculateFinalColor(pbrInputs, lighting_uAmbientLight.color);\n    SMART_FOR(int i = 0, i < MAX_LIGHTS, i < lighting_uDirectionalLightCount, i++) {\n      if (i < lighting_uDirectionalLightCount) {\n        PBRInfo_setDirectionalLight(pbrInputs, lighting_uDirectionalLight[i].direction);\n        color += calculateFinalColor(pbrInputs, lighting_uDirectionalLight[i].color);\n      }\n    }\n    SMART_FOR(int i = 0, i < MAX_LIGHTS, i < lighting_uPointLightCount, i++) {\n      if (i < lighting_uPointLightCount) {\n        PBRInfo_setPointLight(pbrInputs, lighting_uPointLight[i]);\n        float attenuation = getPointLightAttenuation(lighting_uPointLight[i], distance(lighting_uPointLight[i].position, pbr_vPosition));\n        color += calculateFinalColor(pbrInputs, lighting_uPointLight[i].color / attenuation);\n      }\n    }\n#endif\n#ifdef USE_IBL\n    color += getIBLContribution(pbrInputs, n, reflection);\n#endif\n#ifdef HAS_OCCLUSIONMAP\n    float ao = texture2D(u_OcclusionSampler, pbr_vUV).r;\n    color = mix(color, color * ao, u_OcclusionStrength);\n#endif\n\n#ifdef HAS_EMISSIVEMAP\n    vec3 emissive = SRGBtoLINEAR(texture2D(u_EmissiveSampler, pbr_vUV)).rgb * u_EmissiveFactor;\n    color += emissive;\n#endif\n\n#ifdef PBR_DEBUG\n\n\n\n\n\n    color = mix(color, baseColor.rgb, u_ScaleDiffBaseMR.y);\n    color = mix(color, vec3(metallic), u_ScaleDiffBaseMR.z);\n    color = mix(color, vec3(perceptualRoughness), u_ScaleDiffBaseMR.w);\n#endif\n\n  }\n\n  return vec4(pow(color,vec3(1.0/2.2)), baseColor.a);\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2B8mr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "tiltShift", ()=>tiltShift);
var _random = require("../utils/random");
const fs = "uniform float blurRadius;\nuniform float gradientRadius;\nuniform vec2 start;\nuniform vec2 end;\nuniform bool invert;\n\nvec2 tiltShift_getDelta(vec2 texSize) {\n  vec2 vector = normalize((end - start) * texSize);\n  return invert ? vec2(-vector.y, vector.x) : vector;\n}\n\nvec4 tiltShift_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  vec4 color = vec4(0.0);\n  float total = 0.0;\n  float offset = random(vec3(12.9898, 78.233, 151.7182), 0.0);\n\n  vec2 normal = normalize(vec2((start.y - end.y) * texSize.y, (end.x - start.x) * texSize.x));\n  float radius = smoothstep(0.0, 1.0,\n    abs(dot(texCoord * texSize - start * texSize, normal)) / gradientRadius) * blurRadius;\n\n  for (float t = -30.0; t <= 30.0; t++) {\n    float percent = (t + offset - 0.5) / 30.0;\n    float weight = 1.0 - abs(percent);\n    vec4 sample = texture2D(texture, texCoord + tiltShift_getDelta(texSize) / texSize * percent * radius);\n    sample.rgb *= sample.a;\n\n    color += sample * weight;\n    total += weight;\n  }\n\n  color = color / total;\n  color.rgb /= color.a + 0.00001;\n\n  return color;\n}\n";
const uniforms = {
    blurRadius: {
        value: 15,
        min: 0,
        max: 50
    },
    gradientRadius: {
        value: 200,
        min: 0,
        max: 400
    },
    start: [
        0,
        0
    ],
    end: [
        1,
        1
    ],
    invert: {
        value: false,
        private: true
    }
};
const tiltShift = {
    name: "tiltShift",
    uniforms,
    fs,
    dependencies: [
        (0, _random.random)
    ],
    passes: [
        {
            sampler: true,
            uniforms: {
                invert: false
            }
        },
        {
            sampler: true,
            uniforms: {
                invert: true
            }
        }
    ]
};

},{"../utils/random":"lhPZ4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ksAUs":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "triangleBlur", ()=>triangleBlur);
var _random = require("../utils/random");
const fs = "uniform float radius;\nuniform vec2 delta;\n\nvec4 triangleBlur_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  vec2 adjustedDelta = delta * radius / texSize;\n\n  vec4 color = vec4(0.0);\n  float total = 0.0;\n  float offset = random(vec3(12.9898, 78.233, 151.7182), 0.0);\n\n  for (float t = -30.0; t <= 30.0; t++) {\n    float percent = (t + offset - 0.5) / 30.0;\n    float weight = 1.0 - abs(percent);\n    vec4 sample = texture2D(texture, texCoord + adjustedDelta * percent);\n    sample.rgb *= sample.a;\n\n    color += sample * weight;\n    total += weight;\n  }\n\n  color = color / total;\n  color.rgb /= color.a + 0.00001;\n\n  return color;\n}\n";
const uniforms = {
    radius: {
        value: 20,
        min: 0,
        softMax: 100
    },
    delta: {
        value: [
            1,
            0
        ],
        private: true
    }
};
const triangleBlur = {
    name: "triangleBlur",
    uniforms,
    fs,
    dependencies: [
        (0, _random.random)
    ],
    passes: [
        {
            sampler: true,
            uniforms: {
                delta: [
                    1,
                    0
                ]
            }
        },
        {
            sampler: true,
            uniforms: {
                delta: [
                    0,
                    1
                ]
            }
        }
    ]
};

},{"../utils/random":"lhPZ4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2JrTC":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "zoomBlur", ()=>zoomBlur);
var _random = require("../utils/random");
const fs = "\nuniform vec2 center;\nuniform float strength;\n\nvec4 zoomBlur_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  vec4 color = vec4(0.0);\n  float total = 0.0;\n  vec2 toCenter = center * texSize - texCoord * texSize;\n  float offset = random(vec3(12.9898, 78.233, 151.7182), 0.0);\n\n  for (float t = 0.0; t <= 40.0; t++) {\n    float percent = (t + offset) / 40.0;\n    float weight = 4.0 * (percent - percent * percent);\n    vec4 sample = texture2D(texture, texCoord + toCenter * percent * strength / texSize);\n    sample.rgb *= sample.a;\n\n    color += sample * weight;\n    total += weight;\n  }\n\n  color = color / total;\n  color.rgb /= color.a + 0.00001;\n\n  return color;\n}\n";
const uniforms = {
    center: [
        0.5,
        0.5
    ],
    strength: {
        value: 0.3,
        min: 0,
        softMax: 1
    }
};
const zoomBlur = {
    name: "zoomBlur",
    uniforms,
    fs,
    dependencies: [
        (0, _random.random)
    ],
    passes: [
        {
            sampler: true
        }
    ]
};

},{"../utils/random":"lhPZ4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ir07h":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "brightnessContrast", ()=>brightnessContrast);
const fs = "uniform float brightness;\nuniform float contrast;\n\nvec4 brightnessContrast_filterColor(vec4 color) {\n  color.rgb += brightness;\n  if (contrast > 0.0) {\n    color.rgb = (color.rgb - 0.5) / (1.0 - contrast) + 0.5;\n  } else {\n    color.rgb = (color.rgb - 0.5) * (1.0 + contrast) + 0.5;\n  }\n  return color;\n}\n\nvec4 brightnessContrast_filterColor(vec4 color, vec2 texSize, vec2 texCoords) {\n  return brightnessContrast_filterColor(color);\n}\n";
const uniforms = {
    brightness: {
        value: 0,
        min: -1,
        max: 1
    },
    contrast: {
        value: 0,
        min: -1,
        max: 1
    }
};
const brightnessContrast = {
    name: "brightnessContrast",
    uniforms,
    fs,
    passes: [
        {
            filter: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4arBl":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "denoise", ()=>denoise);
const fs = "uniform float strength;\n\nvec4 denoise_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  float adjustedExponent = 3. + 200. * pow(1. - strength, 4.);\n\n  vec4 center = texture2D(texture, texCoord);\n  vec4 color = vec4(0.0);\n  float total = 0.0;\n  for (float x = -4.0; x <= 4.0; x += 1.0) {\n    for (float y = -4.0; y <= 4.0; y += 1.0) {\n      vec4 sample = texture2D(texture, texCoord + vec2(x, y) / texSize);\n      float weight = 1.0 - abs(dot(sample.rgb - center.rgb, vec3(0.25)));\n      weight = pow(weight, adjustedExponent);\n      color += sample * weight;\n      total += weight;\n    }\n  }\n\n  return color / total;\n}\n";
const uniforms = {
    strength: {
        value: 0.5,
        min: 0,
        max: 0.1,
        adjust: (strength)=>0.53 + 200 * Math.pow(1 - strength, 4)
    }
};
const denoise = {
    name: "denoise",
    uniforms,
    fs,
    passes: [
        {
            sampler: true
        },
        {
            sampler: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5z1Vn":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "hueSaturation", ()=>hueSaturation);
const fs = "uniform float hue;\nuniform float saturation;\n\nvec4 hueSaturation_filterColor(vec4 color) {\n  float angle = hue * 3.14159265;\n  float s = sin(angle), c = cos(angle);\n  vec3 weights = (vec3(2.0 * c, -sqrt(3.0) * s - c, sqrt(3.0) * s - c) + 1.0) / 3.0;\n  float len = length(color.rgb);\n  color.rgb = vec3(\n    dot(color.rgb, weights.xyz),\n    dot(color.rgb, weights.zxy),\n    dot(color.rgb, weights.yzx)\n  );\n  float average = (color.r + color.g + color.b) / 3.0;\n  if (saturation > 0.0) {\n    color.rgb += (average - color.rgb) * (1.0 - 1.0 / (1.001 - saturation));\n  } else {\n    color.rgb += (average - color.rgb) * (-saturation);\n  }\n\n  return color;\n}\n\nvec4 hueSaturation_filterColor(vec4 color, vec2 texSize, vec2 texCoord) {\n  return hueSaturation_filterColor(color);\n}\n";
const uniforms = {
    hue: {
        value: 0,
        min: -1,
        max: 1
    },
    saturation: {
        value: 0,
        min: -1,
        max: 1
    }
};
const hueSaturation = {
    name: "hueSaturation",
    uniforms,
    fs,
    passes: [
        {
            filter: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"efiao":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "noise", ()=>noise);
const fs = "uniform float amount;\n\nfloat rand(vec2 co) {\n  return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);\n}\n\nvec4 noise_filterColor(vec4 color, vec2 texCoord) {\n  float diff = (rand(texCoord) - 0.5) * amount;\n  color.r += diff;\n  color.g += diff;\n  color.b += diff;\n  return color;\n}\n\nvec4 noise_filterColor(vec4 color, vec2 texSize, vec2 texCoord) {\n  return noise_filterColor(color, texCoord);\n}\n";
const uniforms = {
    amount: {
        value: 0.5,
        min: 0,
        max: 1
    }
};
const noise = {
    name: "noise",
    uniforms,
    fs,
    passes: [
        {
            filter: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"krRgM":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "sepia", ()=>sepia);
const fs = "uniform float amount;\n\nvec4 sepia_filterColor(vec4 color) {\n  float r = color.r;\n  float g = color.g;\n  float b = color.b;\n\n  color.r =\n    min(1.0, (r * (1.0 - (0.607 * amount))) + (g * (0.769 * amount)) + (b * (0.189 * amount)));\n  color.g = min(1.0, (r * 0.349 * amount) + (g * (1.0 - (0.314 * amount))) + (b * 0.168 * amount));\n  color.b = min(1.0, (r * 0.272 * amount) + (g * 0.534 * amount) + (b * (1.0 - (0.869 * amount))));\n\n  return color;\n}\n\nvec4 sepia_filterColor(vec4 color, vec2 texSize, vec2 texCoord) {\n  return sepia_filterColor(color);\n}\n";
const uniforms = {
    amount: {
        value: 0.5,
        min: 0,
        max: 1
    }
};
const sepia = {
    name: "sepia",
    uniforms,
    fs,
    passes: [
        {
            filter: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dqh9o":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "vibrance", ()=>vibrance);
const fs = "uniform float amount;\n\nvec4 vibrance_filterColor(vec4 color) {\n  float average = (color.r + color.g + color.b) / 3.0;\n  float mx = max(color.r, max(color.g, color.b));\n  float amt = (mx - average) * (-amount * 3.0);\n  color.rgb = mix(color.rgb, vec3(mx), amt);\n  return color;\n}\n\nvec4 vibrance_filterColor(vec4 color, vec2 texSize, vec2 texCoord) {\n  return vibrance_filterColor(color);\n}\n";
const uniforms = {
    amount: {
        value: 0,
        min: -1,
        max: 1
    }
};
const vibrance = {
    name: "vibrance",
    uniforms,
    fs,
    passes: [
        {
            filter: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9BTzl":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "vignette", ()=>vignette);
const fs = "uniform float radius;\nuniform float amount;\n\nvec4 vignette_filterColor(vec4 color, vec2 texCoord) {\n  float dist = distance(texCoord, vec2(0.5, 0.5));\n  float ratio = smoothstep(0.8, radius * 0.799, dist * (amount + radius));\n  return color.rgba * ratio + (1.0 - ratio)*vec4(0.0, 0.0, 0.0, 1.0);\n}\n\nvec4 vignette_filterColor(vec4 color, vec2 texSize, vec2 texCoord) {\n  return vignette_filterColor(color, texCoord);\n}\n";
const uniforms = {
    radius: {
        value: 0.5,
        min: 0,
        max: 1
    },
    amount: {
        value: 0.5,
        min: 0,
        max: 1
    }
};
const vignette = {
    name: "vignette",
    fs,
    uniforms,
    passes: [
        {
            filter: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"i1TAR":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "colorHalftone", ()=>colorHalftone);
const fs = "uniform vec2 center;\nuniform float angle;\nuniform float size;\n\nfloat scale = 3.1514 / size;\n\nfloat pattern(float angle, vec2 texSize, vec2 texCoord) {\n  float s = sin(angle), c = cos(angle);\n  vec2 tex = texCoord * texSize - center * texSize;\n  vec2 point = vec2(\n	c * tex.x - s * tex.y,\n	s * tex.x + c * tex.y\n  ) * scale;\n  return (sin(point.x) * sin(point.y)) * 4.0;\n}\n\nvec4 colorHalftone_filterColor(vec4 color, vec2 texSize, vec2 texCoord) {\n  vec3 cmy = 1.0 - color.rgb;\n  float k = min(cmy.x, min(cmy.y, cmy.z));\n  cmy = (cmy - k) / (1.0 - k);\n  cmy = clamp(\n	cmy * 10.0 - 3.0 + vec3(\n    pattern(angle + 0.26179, texSize, texCoord),\n	  pattern(angle + 1.30899, texSize, texCoord),\n    pattern(angle, texSize, texCoord)\n  ),\n	0.0,\n	1.0\n  );\n  k = clamp(k * 10.0 - 5.0 + pattern(angle + 0.78539, texSize, texCoord), 0.0, 1.0);\n  return vec4(1.0 - cmy - k, color.a);\n}\n";
const uniforms = {
    center: [
        0.5,
        0.5
    ],
    angle: {
        value: 1.1,
        softMin: 0,
        softMax: Math.PI / 2
    },
    size: {
        value: 4,
        min: 1,
        softMin: 3,
        softMax: 20
    }
};
const colorHalftone = {
    name: "colorHalftone",
    uniforms,
    fs,
    passes: [
        {
            filter: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kcU0w":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "dotScreen", ()=>dotScreen);
const fs = "uniform vec2 center;\nuniform float angle;\nuniform float size;\n\nfloat pattern(vec2 texSize, vec2 texCoord) {\n  float scale = 3.1415 / size;\n\n  float s = sin(angle), c = cos(angle);\n  vec2 tex = texCoord * texSize - center * texSize;\n  vec2 point = vec2(\n    c * tex.x - s * tex.y,\n    s * tex.x + c * tex.y\n  ) * scale;\n  return (sin(point.x) * sin(point.y)) * 4.0;\n}\n\nvec4 dotScreen_filterColor(vec4 color, vec2 texSize, vec2 texCoord) {\n  float average = (color.r + color.g + color.b) / 3.0;\n  return vec4(vec3(average * 10.0 - 5.0 + pattern(texSize, texCoord)), color.a);\n}\n";
const uniforms = {
    center: [
        0.5,
        0.5
    ],
    angle: {
        value: 1.1,
        softMin: 0,
        softMax: Math.PI / 2
    },
    size: {
        value: 3,
        min: 1,
        softMin: 3,
        softMax: 20
    }
};
const dotScreen = {
    name: "dotScreen",
    uniforms,
    fs,
    passes: [
        {
            filter: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"j4pQB":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "edgeWork", ()=>edgeWork);
var _random = require("../utils/random");
const fs = "uniform float radius;\nuniform vec2 delta;\n\nvec4 edgeWork_sampleColor1(sampler2D source, vec2 texSize, vec2 texCoord) {\n  vec2 relativeDelta = radius * delta / texSize;\n\n  vec2 color = vec2(0.0);\n  vec2 total = vec2(0.0);\n  float offset = random(vec3(12.9898, 78.233, 151.7182), 0.0);\n\n  for (float t = -30.0; t <= 30.0; t++) {\n    float percent = (t + offset - 0.5) / 30.0;\n    float weight = 1.0 - abs(percent);\n    vec3 sampleColor = texture2D(source, texCoord + relativeDelta * percent).rgb;\n    float average = (sampleColor.r + sampleColor.g + sampleColor.b) / 3.0;\n    color.x += average * weight;\n    total.x += weight;\n    if (abs(t) < 15.0) {\n      weight = weight * 2.0 - 1.0;\n      color.y += average * weight;\n      total.y += weight;\n    }\n  }\n  return vec4(color / total, 0.0, 1.0);\n}\n\nvec4 edgeWork_sampleColor2(sampler2D source, vec2 texSize, vec2 texCoord) {\n  vec2 relativeDelta = radius * delta / texSize;\n\n  vec2 color = vec2(0.0);\n  vec2 total = vec2(0.0);\n  float offset = random(vec3(12.9898, 78.233, 151.7182), 0.0);\n\n  for (float t = -30.0; t <= 30.0; t++) {\n    float percent = (t + offset - 0.5) / 30.0;\n    float weight = 1.0 - abs(percent);\n    vec2 sampleColor = texture2D(source, texCoord + relativeDelta * percent).xy;\n    color.x += sampleColor.x * weight;\n    total.x += weight;\n    if (abs(t) < 15.0) {\n      weight = weight * 2.0 - 1.0;\n      color.y += sampleColor.y * weight;\n      total.y += weight;\n    }\n  }\n  float c = clamp(10000.0 * (color.y / total.y - color.x / total.x) + 0.5, 0.0, 1.0);\n  return vec4(c, c, c, 1.0);\n}\n";
const uniforms = {
    radius: {
        value: 2,
        min: 1,
        softMax: 50
    },
    delta: {
        value: [
            1,
            0
        ],
        private: true
    }
};
const edgeWork = {
    name: "edgeWork",
    uniforms,
    fs,
    dependencies: [
        (0, _random.random)
    ],
    passes: [
        {
            sampler: "edgeWork_sampleColor1",
            uniforms: {
                delta: [
                    1,
                    0
                ]
            }
        },
        {
            sampler: "edgeWork_sampleColor2",
            uniforms: {
                delta: [
                    0,
                    1
                ]
            }
        }
    ]
};

},{"../utils/random":"lhPZ4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8KJrY":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "hexagonalPixelate", ()=>hexagonalPixelate);
const fs = "uniform vec2 center;\nuniform float scale;\n\nvec4 hexagonalPixelate_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  vec2 tex = (texCoord * texSize - center * texSize) / scale;\n  tex.y /= 0.866025404;\n  tex.x -= tex.y * 0.5;\n\n  vec2 a;\n  if (tex.x + tex.y - floor(tex.x) - floor(tex.y) < 1.0) {\n    a = vec2(floor(tex.x), floor(tex.y));\n  }\n  else a = vec2(ceil(tex.x), ceil(tex.y));\n  vec2 b = vec2(ceil(tex.x), floor(tex.y));\n  vec2 c = vec2(floor(tex.x), ceil(tex.y));\n\n  vec3 TEX = vec3(tex.x, tex.y, 1.0 - tex.x - tex.y);\n  vec3 A = vec3(a.x, a.y, 1.0 - a.x - a.y);\n  vec3 B = vec3(b.x, b.y, 1.0 - b.x - b.y);\n  vec3 C = vec3(c.x, c.y, 1.0 - c.x - c.y);\n\n  float alen = length(TEX - A);\n  float blen = length(TEX - B);\n  float clen = length(TEX - C);\n\n  vec2 choice;\n  if (alen < blen) {\n    if (alen < clen) choice = a;\n    else choice = c;\n  } else {\n    if (blen < clen) choice = b;\n    else choice = c;\n  }\n\n  choice.x += choice.y * 0.5;\n  choice.y *= 0.866025404;\n  choice *= scale / texSize;\n\n  return texture2D(texture, choice + center);\n}\n";
const uniforms = {
    center: {
        value: [
            0.5,
            0.5
        ],
        hint: "screenspace"
    },
    scale: {
        value: 10,
        min: 1,
        softMin: 5,
        softMax: 50
    }
};
const hexagonalPixelate = {
    name: "hexagonalPixelate",
    uniforms,
    fs,
    passes: [
        {
            sampler: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jAVQk":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "ink", ()=>ink);
const fs = "uniform float strength;\n\nvec4 ink_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  vec2 dx = vec2(1.0 / texSize.x, 0.0);\n  vec2 dy = vec2(0.0, 1.0 / texSize.y);\n  vec4 color = texture2D(texture, texCoord);\n  float bigTotal = 0.0;\n  float smallTotal = 0.0;\n  vec3 bigAverage = vec3(0.0);\n  vec3 smallAverage = vec3(0.0);\n  for (float x = -2.0; x <= 2.0; x += 1.0) {\n    for (float y = -2.0; y <= 2.0; y += 1.0) {\n      vec3 sample = texture2D(texture, texCoord + dx * x + dy * y).rgb;\n      bigAverage += sample;\n      bigTotal += 1.0;\n      if (abs(x) + abs(y) < 2.0) {\n        smallAverage += sample;\n        smallTotal += 1.0;\n      }\n    }\n  }\n  vec3 edge = max(vec3(0.0), bigAverage / bigTotal - smallAverage / smallTotal);\n  float power = strength * strength * strength * strength * strength;\n  return vec4(color.rgb - dot(edge, edge) * power * 100000.0, color.a);\n}\n";
const uniforms = {
    strength: {
        value: 0.25,
        min: 0,
        softMax: 1
    }
};
const ink = {
    name: "ink",
    uniforms,
    fs,
    passes: [
        {
            sampler: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"03d3X":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "magnify", ()=>magnify);
const fs = "uniform vec2 screenXY;\nuniform float radiusPixels;\nuniform float zoom;\nuniform float borderWidthPixels;\nuniform vec4 borderColor;\n\nvec4 magnify_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  vec2 pos = vec2(screenXY.x, 1.0 - screenXY.y);\n  float dist = distance(texCoord * texSize, pos * texSize);\n  if (dist < radiusPixels) {\n    return texture2D(texture, (texCoord - pos) / zoom + pos);\n  }\n\n  if (dist <= radiusPixels + borderWidthPixels) {\n    return borderColor;\n  }\n  return texture2D(texture, texCoord);\n}\n";
const uniforms = {
    screenXY: [
        0,
        0
    ],
    radiusPixels: 200,
    zoom: 2.0,
    borderWidthPixels: 0.0,
    borderColor: [
        255,
        255,
        255,
        255
    ]
};
const magnify = {
    name: "magnify",
    uniforms,
    fs,
    passes: [
        {
            sampler: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ixaLj":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "bulgePinch", ()=>bulgePinch);
var _warp = require("./warp");
const fs = "uniform float radius;\nuniform float strength;\nuniform vec2 center;\n\nvec2 bulgePinch_warp(vec2 coord, vec2 texCenter) {\n  coord -= texCenter;\n  float distance = length(coord);\n  if (distance < radius) {\n    float percent = distance / radius;\n    if (strength > 0.0) {\n      coord *= mix(1.0, smoothstep(0.0, radius / distance, percent), strength * 0.75);\n    } else {\n      coord *= mix(1.0, pow(percent, 1.0 + strength * 0.75) * radius / distance, 1.0 - percent);\n    }\n  }\n  coord += texCenter;\n  return coord;\n}\n\nvec4 bulgePinch_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  vec2 coord = texCoord * texSize;\n  coord = bulgePinch_warp(coord, center * texSize);\n\n  return warp_sampleColor(texture, texSize, coord);\n}\n";
const uniforms = {
    center: [
        0.5,
        0.5
    ],
    radius: {
        value: 200,
        min: 1,
        softMax: 600
    },
    strength: {
        value: 0.5,
        min: -1,
        max: 1
    }
};
const bulgePinch = {
    name: "bulgePinch",
    fs,
    uniforms,
    dependencies: [
        (0, _warp.warp)
    ],
    passes: [
        {
            sampler: true
        }
    ]
};

},{"./warp":"eXtFG","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eXtFG":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "warp", ()=>warp);
const fs = "vec4 warp_sampleColor(sampler2D texture, vec2 texSize, vec2 coord) {\n  vec4 color = texture2D(texture, coord / texSize);\n  vec2 clampedCoord = clamp(coord, vec2(0.0), texSize);\n  if (coord != clampedCoord) {\n    color.a *= max(0.0, 1.0 - length(coord - clampedCoord));\n  }\n\n  return color;\n}\n";
const warp = {
    name: "warp",
    fs
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lORrW":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "swirl", ()=>swirl);
var _warp = require("./warp");
const fs = "uniform float radius;\nuniform float angle;\nuniform vec2 center;\n\nvec2 swirl_warp(vec2 coord, vec2 texCenter) {\n  coord -= texCenter;\n  float distance = length(coord);\n  if (distance < radius) {\n    float percent = (radius - distance) / radius;\n    float theta = percent * percent * angle;\n    float s = sin(theta);\n    float c = cos(theta);\n    coord = vec2(\n      coord.x * c - coord.y * s,\n      coord.x * s + coord.y * c\n    );\n  }\n  coord += texCenter;\n  return coord;\n}\n\nvec4 swirl_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n  vec2 coord = texCoord * texSize;\n  coord = swirl_warp(coord, center * texSize);\n\n  return warp_sampleColor(texture, texSize, coord);\n}\n";
const uniforms = {
    center: [
        0.5,
        0.5
    ],
    radius: {
        value: 200,
        min: 1,
        softMax: 600
    },
    angle: {
        value: 3,
        softMin: -25,
        softMax: 25
    }
};
const swirl = {
    name: "swirl",
    fs,
    uniforms,
    dependencies: [
        (0, _warp.warp)
    ],
    passes: [
        {
            sampler: true
        }
    ]
};

},{"./warp":"eXtFG","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"51fcg":[function(require,module,exports) {
/**
 * ORIGINAL LICENCE
 * @license
 * Copyright (c) 2014-2015, NVIDIA CORPORATION. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *  * Neither the name of NVIDIA CORPORATION nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS ''AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */ var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "fxaa", ()=>fxaa);
const fs = "\n#define FXAA_QUALITY_PRESET 29\n\n#if (FXAA_QUALITY_PRESET == 10)\n    #define FXAA_QUALITY_PS 3\n    #define FXAA_QUALITY_P0 1.5\n    #define FXAA_QUALITY_P1 3.0\n    #define FXAA_QUALITY_P2 12.0\n#endif\n#if (FXAA_QUALITY_PRESET == 11)\n    #define FXAA_QUALITY_PS 4\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 3.0\n    #define FXAA_QUALITY_P3 12.0\n#endif\n#if (FXAA_QUALITY_PRESET == 12)\n    #define FXAA_QUALITY_PS 5\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 4.0\n    #define FXAA_QUALITY_P4 12.0\n#endif\n#if (FXAA_QUALITY_PRESET == 13)\n    #define FXAA_QUALITY_PS 6\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 4.0\n    #define FXAA_QUALITY_P5 12.0\n#endif\n#if (FXAA_QUALITY_PRESET == 14)\n    #define FXAA_QUALITY_PS 7\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 4.0\n    #define FXAA_QUALITY_P6 12.0\n#endif\n#if (FXAA_QUALITY_PRESET == 15)\n    #define FXAA_QUALITY_PS 8\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 2.0\n    #define FXAA_QUALITY_P6 4.0\n    #define FXAA_QUALITY_P7 12.0\n#endif\n#if (FXAA_QUALITY_PRESET == 20)\n    #define FXAA_QUALITY_PS 3\n    #define FXAA_QUALITY_P0 1.5\n    #define FXAA_QUALITY_P1 2.0\n    #define FXAA_QUALITY_P2 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 21)\n    #define FXAA_QUALITY_PS 4\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 22)\n    #define FXAA_QUALITY_PS 5\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 23)\n    #define FXAA_QUALITY_PS 6\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 24)\n    #define FXAA_QUALITY_PS 7\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 3.0\n    #define FXAA_QUALITY_P6 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 25)\n    #define FXAA_QUALITY_PS 8\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 2.0\n    #define FXAA_QUALITY_P6 4.0\n    #define FXAA_QUALITY_P7 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 26)\n    #define FXAA_QUALITY_PS 9\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 2.0\n    #define FXAA_QUALITY_P6 2.0\n    #define FXAA_QUALITY_P7 4.0\n    #define FXAA_QUALITY_P8 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 27)\n    #define FXAA_QUALITY_PS 10\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 2.0\n    #define FXAA_QUALITY_P6 2.0\n    #define FXAA_QUALITY_P7 2.0\n    #define FXAA_QUALITY_P8 4.0\n    #define FXAA_QUALITY_P9 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 28)\n    #define FXAA_QUALITY_PS 11\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 2.0\n    #define FXAA_QUALITY_P6 2.0\n    #define FXAA_QUALITY_P7 2.0\n    #define FXAA_QUALITY_P8 2.0\n    #define FXAA_QUALITY_P9 4.0\n    #define FXAA_QUALITY_P10 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 29)\n    #define FXAA_QUALITY_PS 12\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.5\n    #define FXAA_QUALITY_P2 2.0\n    #define FXAA_QUALITY_P3 2.0\n    #define FXAA_QUALITY_P4 2.0\n    #define FXAA_QUALITY_P5 2.0\n    #define FXAA_QUALITY_P6 2.0\n    #define FXAA_QUALITY_P7 2.0\n    #define FXAA_QUALITY_P8 2.0\n    #define FXAA_QUALITY_P9 2.0\n    #define FXAA_QUALITY_P10 4.0\n    #define FXAA_QUALITY_P11 8.0\n#endif\n#if (FXAA_QUALITY_PRESET == 39)\n    #define FXAA_QUALITY_PS 12\n    #define FXAA_QUALITY_P0 1.0\n    #define FXAA_QUALITY_P1 1.0\n    #define FXAA_QUALITY_P2 1.0\n    #define FXAA_QUALITY_P3 1.0\n    #define FXAA_QUALITY_P4 1.0\n    #define FXAA_QUALITY_P5 1.5\n    #define FXAA_QUALITY_P6 2.0\n    #define FXAA_QUALITY_P7 2.0\n    #define FXAA_QUALITY_P8 2.0\n    #define FXAA_QUALITY_P9 2.0\n    #define FXAA_QUALITY_P10 4.0\n    #define FXAA_QUALITY_P11 8.0\n#endif\n\n#define FxaaBool bool\n#define FxaaFloat float\n#define FxaaFloat2 vec2\n#define FxaaFloat3 vec3\n#define FxaaFloat4 vec4\n#define FxaaHalf float\n#define FxaaHalf2 vec2\n#define FxaaHalf3 vec3\n#define FxaaHalf4 vec4\n#define FxaaInt2 vec2\n#define FxaaTex sampler2D\n\n#define FxaaSat(x) clamp(x, 0.0, 1.0)\n#define FxaaTexTop(t, p) texture2D(t, p)\n#define FxaaTexOff(t, p, o, r) texture2D(t, p + (o * r))\n\nFxaaFloat FxaaLuma_(FxaaFloat4 rgba) { return dot(rgba.rgb, vec3(0.2126, 0.7152, 0.0722)); }\n\nFxaaFloat4 FxaaPixelShader_(\n\n\n    FxaaFloat2 pos,\n\n\n\n\n    FxaaTex tex,\n\n\n\n\n    FxaaFloat2 fxaaQualityRcpFrame,\n\n\n\n\n\n\n\n\n\n\n    FxaaFloat fxaaQualitySubpix,\n\n\n\n\n\n\n\n\n\n    FxaaFloat fxaaQualityEdgeThreshold,\n\n\n\n\n\n\n\n\n\n\n\n\n\n    FxaaFloat fxaaQualityEdgeThresholdMin\n) {\n    FxaaFloat2 posM;\n    posM.x = pos.x;\n    posM.y = pos.y;\n    FxaaFloat4 rgbyM = FxaaTexTop(tex, posM);\n    #define lumaM rgbyM.y\n    FxaaFloat lumaS = FxaaLuma_(FxaaTexOff(tex, posM, FxaaInt2( 0, 1), fxaaQualityRcpFrame.xy));\n    FxaaFloat lumaE = FxaaLuma_(FxaaTexOff(tex, posM, FxaaInt2( 1, 0), fxaaQualityRcpFrame.xy));\n    FxaaFloat lumaN = FxaaLuma_(FxaaTexOff(tex, posM, FxaaInt2( 0,-1), fxaaQualityRcpFrame.xy));\n    FxaaFloat lumaW = FxaaLuma_(FxaaTexOff(tex, posM, FxaaInt2(-1, 0), fxaaQualityRcpFrame.xy));\n    FxaaFloat maxSM = max(lumaS, lumaM);\n    FxaaFloat minSM = min(lumaS, lumaM);\n    FxaaFloat maxESM = max(lumaE, maxSM);\n    FxaaFloat minESM = min(lumaE, minSM);\n    FxaaFloat maxWN = max(lumaN, lumaW);\n    FxaaFloat minWN = min(lumaN, lumaW);\n    FxaaFloat rangeMax = max(maxWN, maxESM);\n    FxaaFloat rangeMin = min(minWN, minESM);\n    FxaaFloat rangeMaxScaled = rangeMax * fxaaQualityEdgeThreshold;\n    FxaaFloat range = rangeMax - rangeMin;\n    FxaaFloat rangeMaxClamped = max(fxaaQualityEdgeThresholdMin, rangeMaxScaled);\n    FxaaBool earlyExit = range < rangeMaxClamped;\n    if(earlyExit)\n        return rgbyM;\n    FxaaFloat lumaNW = FxaaLuma_(FxaaTexOff(tex, posM, FxaaInt2(-1,-1), fxaaQualityRcpFrame.xy));\n    FxaaFloat lumaSE = FxaaLuma_(FxaaTexOff(tex, posM, FxaaInt2( 1, 1), fxaaQualityRcpFrame.xy));\n    FxaaFloat lumaNE = FxaaLuma_(FxaaTexOff(tex, posM, FxaaInt2( 1,-1), fxaaQualityRcpFrame.xy));\n    FxaaFloat lumaSW = FxaaLuma_(FxaaTexOff(tex, posM, FxaaInt2(-1, 1), fxaaQualityRcpFrame.xy));\n    FxaaFloat lumaNS = lumaN + lumaS;\n    FxaaFloat lumaWE = lumaW + lumaE;\n    FxaaFloat subpixRcpRange = 1.0/range;\n    FxaaFloat subpixNSWE = lumaNS + lumaWE;\n    FxaaFloat edgeHorz1 = (-2.0 * lumaM) + lumaNS;\n    FxaaFloat edgeVert1 = (-2.0 * lumaM) + lumaWE;\n    FxaaFloat lumaNESE = lumaNE + lumaSE;\n    FxaaFloat lumaNWNE = lumaNW + lumaNE;\n    FxaaFloat edgeHorz2 = (-2.0 * lumaE) + lumaNESE;\n    FxaaFloat edgeVert2 = (-2.0 * lumaN) + lumaNWNE;\n    FxaaFloat lumaNWSW = lumaNW + lumaSW;\n    FxaaFloat lumaSWSE = lumaSW + lumaSE;\n    FxaaFloat edgeHorz4 = (abs(edgeHorz1) * 2.0) + abs(edgeHorz2);\n    FxaaFloat edgeVert4 = (abs(edgeVert1) * 2.0) + abs(edgeVert2);\n    FxaaFloat edgeHorz3 = (-2.0 * lumaW) + lumaNWSW;\n    FxaaFloat edgeVert3 = (-2.0 * lumaS) + lumaSWSE;\n    FxaaFloat edgeHorz = abs(edgeHorz3) + edgeHorz4;\n    FxaaFloat edgeVert = abs(edgeVert3) + edgeVert4;\n    FxaaFloat subpixNWSWNESE = lumaNWSW + lumaNESE;\n    FxaaFloat lengthSign = fxaaQualityRcpFrame.x;\n    FxaaBool horzSpan = edgeHorz >= edgeVert;\n    FxaaFloat subpixA = subpixNSWE * 2.0 + subpixNWSWNESE;\n    if(!horzSpan) lumaN = lumaW;\n    if(!horzSpan) lumaS = lumaE;\n    if(horzSpan) lengthSign = fxaaQualityRcpFrame.y;\n    FxaaFloat subpixB = (subpixA * (1.0/12.0)) - lumaM;\n    FxaaFloat gradientN = lumaN - lumaM;\n    FxaaFloat gradientS = lumaS - lumaM;\n    FxaaFloat lumaNN = lumaN + lumaM;\n    FxaaFloat lumaSS = lumaS + lumaM;\n    FxaaBool pairN = abs(gradientN) >= abs(gradientS);\n    FxaaFloat gradient = max(abs(gradientN), abs(gradientS));\n    if(pairN) lengthSign = -lengthSign;\n    FxaaFloat subpixC = FxaaSat(abs(subpixB) * subpixRcpRange);\n    FxaaFloat2 posB;\n    posB.x = posM.x;\n    posB.y = posM.y;\n    FxaaFloat2 offNP;\n    offNP.x = (!horzSpan) ? 0.0 : fxaaQualityRcpFrame.x;\n    offNP.y = ( horzSpan) ? 0.0 : fxaaQualityRcpFrame.y;\n    if(!horzSpan) posB.x += lengthSign * 0.5;\n    if( horzSpan) posB.y += lengthSign * 0.5;\n    FxaaFloat2 posN;\n    posN.x = posB.x - offNP.x * FXAA_QUALITY_P0;\n    posN.y = posB.y - offNP.y * FXAA_QUALITY_P0;\n    FxaaFloat2 posP;\n    posP.x = posB.x + offNP.x * FXAA_QUALITY_P0;\n    posP.y = posB.y + offNP.y * FXAA_QUALITY_P0;\n    FxaaFloat subpixD = ((-2.0)*subpixC) + 3.0;\n    FxaaFloat lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN));\n    FxaaFloat subpixE = subpixC * subpixC;\n    FxaaFloat lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP));\n    if(!pairN) lumaNN = lumaSS;\n    FxaaFloat gradientScaled = gradient * 1.0/4.0;\n    FxaaFloat lumaMM = lumaM - lumaNN * 0.5;\n    FxaaFloat subpixF = subpixD * subpixE;\n    FxaaBool lumaMLTZero = lumaMM < 0.0;\n    lumaEndN -= lumaNN * 0.5;\n    lumaEndP -= lumaNN * 0.5;\n    FxaaBool doneN = abs(lumaEndN) >= gradientScaled;\n    FxaaBool doneP = abs(lumaEndP) >= gradientScaled;\n    if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P1;\n    if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P1;\n    FxaaBool doneNP = (!doneN) || (!doneP);\n    if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P1;\n    if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P1;\n    if(doneNP) {\n        if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n        if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n        if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n        if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n        doneN = abs(lumaEndN) >= gradientScaled;\n        doneP = abs(lumaEndP) >= gradientScaled;\n        if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P2;\n        if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P2;\n        doneNP = (!doneN) || (!doneP);\n        if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P2;\n        if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P2;\n        #if (FXAA_QUALITY_PS > 3)\n        if(doneNP) {\n            if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n            if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n            if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n            if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n            doneN = abs(lumaEndN) >= gradientScaled;\n            doneP = abs(lumaEndP) >= gradientScaled;\n            if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P3;\n            if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P3;\n            doneNP = (!doneN) || (!doneP);\n            if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P3;\n            if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P3;\n            #if (FXAA_QUALITY_PS > 4)\n            if(doneNP) {\n                if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n                if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n                if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n                if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n                doneN = abs(lumaEndN) >= gradientScaled;\n                doneP = abs(lumaEndP) >= gradientScaled;\n                if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P4;\n                if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P4;\n                doneNP = (!doneN) || (!doneP);\n                if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P4;\n                if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P4;\n                #if (FXAA_QUALITY_PS > 5)\n                if(doneNP) {\n                    if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n                    if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n                    if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n                    if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n                    doneN = abs(lumaEndN) >= gradientScaled;\n                    doneP = abs(lumaEndP) >= gradientScaled;\n                    if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P5;\n                    if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P5;\n                    doneNP = (!doneN) || (!doneP);\n                    if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P5;\n                    if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P5;\n                    #if (FXAA_QUALITY_PS > 6)\n                    if(doneNP) {\n                        if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n                        if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n                        if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n                        if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n                        doneN = abs(lumaEndN) >= gradientScaled;\n                        doneP = abs(lumaEndP) >= gradientScaled;\n                        if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P6;\n                        if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P6;\n                        doneNP = (!doneN) || (!doneP);\n                        if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P6;\n                        if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P6;\n                        #if (FXAA_QUALITY_PS > 7)\n                        if(doneNP) {\n                            if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n                            if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n                            if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n                            if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n                            doneN = abs(lumaEndN) >= gradientScaled;\n                            doneP = abs(lumaEndP) >= gradientScaled;\n                            if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P7;\n                            if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P7;\n                            doneNP = (!doneN) || (!doneP);\n                            if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P7;\n                            if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P7;\n    #if (FXAA_QUALITY_PS > 8)\n    if(doneNP) {\n        if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n        if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n        if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n        if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n        doneN = abs(lumaEndN) >= gradientScaled;\n        doneP = abs(lumaEndP) >= gradientScaled;\n        if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P8;\n        if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P8;\n        doneNP = (!doneN) || (!doneP);\n        if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P8;\n        if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P8;\n        #if (FXAA_QUALITY_PS > 9)\n        if(doneNP) {\n            if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n            if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n            if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n            if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n            doneN = abs(lumaEndN) >= gradientScaled;\n            doneP = abs(lumaEndP) >= gradientScaled;\n            if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P9;\n            if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P9;\n            doneNP = (!doneN) || (!doneP);\n            if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P9;\n            if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P9;\n            #if (FXAA_QUALITY_PS > 10)\n            if(doneNP) {\n                if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n                if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n                if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n                if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n                doneN = abs(lumaEndN) >= gradientScaled;\n                doneP = abs(lumaEndP) >= gradientScaled;\n                if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P10;\n                if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P10;\n                doneNP = (!doneN) || (!doneP);\n                if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P10;\n                if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P10;\n                #if (FXAA_QUALITY_PS > 11)\n                if(doneNP) {\n                    if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n                    if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n                    if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n                    if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n                    doneN = abs(lumaEndN) >= gradientScaled;\n                    doneP = abs(lumaEndP) >= gradientScaled;\n                    if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P11;\n                    if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P11;\n                    doneNP = (!doneN) || (!doneP);\n                    if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P11;\n                    if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P11;\n                    #if (FXAA_QUALITY_PS > 12)\n                    if(doneNP) {\n                        if(!doneN) lumaEndN = FxaaLuma_(FxaaTexTop(tex, posN.xy));\n                        if(!doneP) lumaEndP = FxaaLuma_(FxaaTexTop(tex, posP.xy));\n                        if(!doneN) lumaEndN = lumaEndN - lumaNN * 0.5;\n                        if(!doneP) lumaEndP = lumaEndP - lumaNN * 0.5;\n                        doneN = abs(lumaEndN) >= gradientScaled;\n                        doneP = abs(lumaEndP) >= gradientScaled;\n                        if(!doneN) posN.x -= offNP.x * FXAA_QUALITY_P12;\n                        if(!doneN) posN.y -= offNP.y * FXAA_QUALITY_P12;\n                        doneNP = (!doneN) || (!doneP);\n                        if(!doneP) posP.x += offNP.x * FXAA_QUALITY_P12;\n                        if(!doneP) posP.y += offNP.y * FXAA_QUALITY_P12;\n                    }\n                    #endif\n                }\n                #endif\n            }\n            #endif\n        }\n        #endif\n    }\n    #endif\n                        }\n                        #endif\n                    }\n                    #endif\n                }\n                #endif\n            }\n            #endif\n        }\n        #endif\n    }\n    FxaaFloat dstN = posM.x - posN.x;\n    FxaaFloat dstP = posP.x - posM.x;\n    if(!horzSpan) dstN = posM.y - posN.y;\n    if(!horzSpan) dstP = posP.y - posM.y;\n    FxaaBool goodSpanN = (lumaEndN < 0.0) != lumaMLTZero;\n    FxaaFloat spanLength = (dstP + dstN);\n    FxaaBool goodSpanP = (lumaEndP < 0.0) != lumaMLTZero;\n    FxaaFloat spanLengthRcp = 1.0/spanLength;\n    FxaaBool directionN = dstN < dstP;\n    FxaaFloat dst = min(dstN, dstP);\n    FxaaBool goodSpan = directionN ? goodSpanN : goodSpanP;\n    FxaaFloat subpixG = subpixF * subpixF;\n    FxaaFloat pixelOffset = (dst * (-spanLengthRcp)) + 0.5;\n    FxaaFloat subpixH = subpixG * fxaaQualitySubpix;\n    FxaaFloat pixelOffsetGood = goodSpan ? pixelOffset : 0.0;\n    FxaaFloat pixelOffsetSubpix = max(pixelOffsetGood, subpixH);\n    if(!horzSpan) posM.x += pixelOffsetSubpix * lengthSign;\n    if( horzSpan) posM.y += pixelOffsetSubpix * lengthSign;\n    return FxaaTexTop(tex, posM);\n}\n\nvec4 fxaa_sampleColor(sampler2D texture, vec2 texSize, vec2 texCoord) {\n    const float fxaa_QualitySubpix = 0.5;\n    const float fxaa_QualityEdgeThreshold = 0.125;\n    const float fxaa_QualityEdgeThresholdMin = 0.0833;\n\n    return FxaaPixelShader_(\n        texCoord,\n        texture,\n        vec2(1.0) / texSize,\n        fxaa_QualitySubpix,\n        fxaa_QualityEdgeThreshold,\n        fxaa_QualityEdgeThresholdMin\n    );\n}\n";
const fxaa = {
    name: "fxaa",
    uniforms: {},
    fs,
    passes: [
        {
            sampler: true
        }
    ]
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"i8ZK9":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "transform", ()=>transform);
const vs = "attribute float transform_elementID;\nvec2 transform_getPixelSizeHalf(vec2 size) {\n  return vec2(1.) / (2. * size);\n}\n\nvec2 transform_getPixelIndices(vec2 texSize, vec2 pixelSizeHalf) {\n  float yIndex = floor((transform_elementID / texSize[0]) + pixelSizeHalf[1]);\n  float xIndex = transform_elementID - (yIndex * texSize[0]);\n  return vec2(xIndex, yIndex);\n}\nvec2 transform_getTexCoord(vec2 size) {\n  vec2 pixelSizeHalf = transform_getPixelSizeHalf(size);\n  vec2 indices = transform_getPixelIndices(size, pixelSizeHalf);\n  vec2 coord = indices / size + pixelSizeHalf;\n  return coord;\n}\nvec2 transform_getPos(vec2 size) {\n  vec2 texCoord = transform_getTexCoord(size);\n  vec2 pos = (texCoord * (2.0, 2.0)) - (1., 1.);\n  return pos;\n}\nvec4 transform_getInput(sampler2D texSampler, vec2 size) {\n  vec2 texCoord = transform_getTexCoord(size);\n  vec4 textureColor = texture2D(texSampler, texCoord);\n  return textureColor;\n}\n";
const transform = {
    name: "transform",
    vs,
    fs: null
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1lANB":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getBuffersFromGeometry", ()=>getBuffersFromGeometry);
parcelHelpers.export(exports, "inferAttributeAccessor", ()=>inferAttributeAccessor);
var _webgl = require("@luma.gl/webgl");
const GLTF_TO_LUMA_ATTRIBUTE_MAP = {
    POSITION: "positions",
    NORMAL: "normals",
    COLOR_0: "colors",
    TEXCOORD_0: "texCoords",
    TEXCOORD_1: "texCoords1",
    TEXCOORD_2: "texCoords2"
};
function getBuffersFromGeometry(gl, geometry, options) {
    const buffers = {};
    let indices = geometry.indices;
    for(const name in geometry.attributes){
        const attribute = geometry.attributes[name];
        const remappedName = mapAttributeName(name, options);
        if (name === "indices") indices = attribute;
        else if (attribute.constant) buffers[remappedName] = attribute.value;
        else {
            const typedArray = attribute.value;
            const accessor = {
                ...attribute
            };
            delete accessor.value;
            buffers[remappedName] = [
                new (0, _webgl.Buffer)(gl, typedArray),
                accessor
            ];
            inferAttributeAccessor(name, accessor);
        }
    }
    if (indices) {
        const data = indices.value || indices;
        (0, _webgl.assert)(data instanceof Uint16Array || data instanceof Uint32Array, 'attribute array for "indices" must be of integer type');
        const accessor1 = {
            size: 1,
            isIndexed: indices.isIndexed === undefined ? true : indices.isIndexed
        };
        buffers.indices = [
            new (0, _webgl.Buffer)(gl, {
                data,
                target: 34963
            }),
            accessor1
        ];
    }
    return buffers;
}
function mapAttributeName(name, options) {
    const { attributeMap =GLTF_TO_LUMA_ATTRIBUTE_MAP  } = options || {};
    return attributeMap && attributeMap[name] || name;
}
function inferAttributeAccessor(attributeName, attribute) {
    let category;
    switch(attributeName){
        case "texCoords":
        case "texCoord1":
        case "texCoord2":
        case "texCoord3":
            category = "uvs";
            break;
        case "vertices":
        case "positions":
        case "normals":
        case "pickingColors":
            category = "vectors";
            break;
        default:
    }
    switch(category){
        case "vectors":
            attribute.size = attribute.size || 3;
            break;
        case "uvs":
            attribute.size = attribute.size || 2;
            break;
        default:
    }
    (0, _webgl.assert)(Number.isFinite(attribute.size), "attribute ".concat(attributeName, " needs size"));
}

},{"@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5Chqs":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _shadertools = require("@luma.gl/shadertools");
var _bufferTransform = require("./buffer-transform");
var _bufferTransformDefault = parcelHelpers.interopDefault(_bufferTransform);
var _textureTransform = require("./texture-transform");
var _textureTransformDefault = parcelHelpers.interopDefault(_textureTransform);
var _gltools = require("@luma.gl/gltools");
var _webgl = require("@luma.gl/webgl");
var _model = require("../lib/model");
var _modelDefault = parcelHelpers.interopDefault(_model);
class Transform {
    static isSupported(gl) {
        return (0, _gltools.isWebGL2)(gl);
    }
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        this.gl = gl;
        this.model = null;
        this.elementCount = 0;
        this.bufferTransform = null;
        this.textureTransform = null;
        this.elementIDBuffer = null;
        this._initialize(props);
        Object.seal(this);
    }
    delete() {
        const { model , bufferTransform , textureTransform  } = this;
        if (model) model.delete();
        if (bufferTransform) bufferTransform.delete();
        if (textureTransform) textureTransform.delete();
    }
    run() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { clearRenderTarget =true  } = opts;
        const updatedOpts = this._updateDrawOptions(opts);
        if (clearRenderTarget && updatedOpts.framebuffer) updatedOpts.framebuffer.clear({
            color: true
        });
        this.model.transform(updatedOpts);
    }
    swap() {
        let swapped = false;
        const resourceTransforms = [
            this.bufferTransform,
            this.textureTransform
        ].filter(Boolean);
        for (const resourceTransform of resourceTransforms)swapped = swapped || resourceTransform.swap();
        (0, _webgl.assert)(swapped, "Nothing to swap");
    }
    getBuffer() {
        let varyingName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        return this.bufferTransform && this.bufferTransform.getBuffer(varyingName);
    }
    getData() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const resourceTransforms = [
            this.bufferTransform,
            this.textureTransform
        ].filter(Boolean);
        for (const resourceTransform of resourceTransforms){
            const data = resourceTransform.getData(opts);
            if (data) return data;
        }
        return null;
    }
    getFramebuffer() {
        return this.textureTransform && this.textureTransform.getFramebuffer();
    }
    update() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        if ("elementCount" in opts) this.model.setVertexCount(opts.elementCount);
        const resourceTransforms = [
            this.bufferTransform,
            this.textureTransform
        ].filter(Boolean);
        for (const resourceTransform of resourceTransforms)resourceTransform.update(opts);
    }
    _initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { gl  } = this;
        this._buildResourceTransforms(gl, props);
        props = this._updateModelProps(props);
        this.model = new (0, _modelDefault.default)(gl, Object.assign({}, props, {
            fs: props.fs || (0, _shadertools.getPassthroughFS)({
                version: (0, _webgl.getShaderVersion)(props.vs)
            }),
            id: props.id || "transform-model",
            drawMode: props.drawMode || 0,
            vertexCount: props.elementCount
        }));
        this.bufferTransform && this.bufferTransform.setupResources({
            model: this.model
        });
    }
    _updateModelProps(props) {
        let updatedProps = Object.assign({}, props);
        const resourceTransforms = [
            this.bufferTransform,
            this.textureTransform
        ].filter(Boolean);
        for (const resourceTransform of resourceTransforms)updatedProps = resourceTransform.updateModelProps(updatedProps);
        return updatedProps;
    }
    _buildResourceTransforms(gl, props) {
        if (canCreateBufferTransform(props)) this.bufferTransform = new (0, _bufferTransformDefault.default)(gl, props);
        if (canCreateTextureTransform(props)) this.textureTransform = new (0, _textureTransformDefault.default)(gl, props);
        (0, _webgl.assert)(this.bufferTransform || this.textureTransform, "must provide source/feedback buffers or source/target textures");
    }
    _updateDrawOptions(opts) {
        let updatedOpts = Object.assign({}, opts);
        const resourceTransforms = [
            this.bufferTransform,
            this.textureTransform
        ].filter(Boolean);
        for (const resourceTransform of resourceTransforms)updatedOpts = Object.assign(updatedOpts, resourceTransform.getDrawOptions(updatedOpts));
        return updatedOpts;
    }
}
exports.default = Transform;
function canCreateBufferTransform(props) {
    if (!(0, _webgl.isObjectEmpty)(props.feedbackBuffers) || !(0, _webgl.isObjectEmpty)(props.feedbackMap) || props.varyings && props.varyings.length > 0) return true;
    return false;
}
function canCreateTextureTransform(props) {
    if (!(0, _webgl.isObjectEmpty)(props._sourceTextures) || props._targetTexture || props._targetTextureVarying) return true;
    return false;
}

},{"@luma.gl/shadertools":"gjHNu","./buffer-transform":"889sf","./texture-transform":"lE2iV","@luma.gl/gltools":"aIkwg","@luma.gl/webgl":"4LrGo","../lib/model":"c1vGg","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"889sf":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _gltools = require("@luma.gl/gltools");
var _webgl = require("@luma.gl/webgl");
class BufferTransform {
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        this.gl = gl;
        this.currentIndex = 0;
        this.feedbackMap = {};
        this.varyings = null;
        this.bindings = [];
        this.resources = {};
        this._initialize(props);
        Object.seal(this);
    }
    setupResources(opts) {
        for (const binding of this.bindings)this._setupTransformFeedback(binding, opts);
    }
    updateModelProps() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { varyings  } = this;
        if (varyings.length > 0) props = Object.assign({}, props, {
            varyings
        });
        return props;
    }
    getDrawOptions() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const binding = this.bindings[this.currentIndex];
        const { sourceBuffers , transformFeedback  } = binding;
        const attributes = Object.assign({}, sourceBuffers, opts.attributes);
        return {
            attributes,
            transformFeedback
        };
    }
    swap() {
        if (this.feedbackMap) {
            this.currentIndex = this._getNextIndex();
            return true;
        }
        return false;
    }
    update() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this._setupBuffers(opts);
    }
    getBuffer(varyingName) {
        const { feedbackBuffers  } = this.bindings[this.currentIndex];
        const bufferOrParams = varyingName ? feedbackBuffers[varyingName] : null;
        if (!bufferOrParams) return null;
        return bufferOrParams instanceof (0, _webgl.Buffer) ? bufferOrParams : bufferOrParams.buffer;
    }
    getData() {
        let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { varyingName  } = options;
        const buffer = this.getBuffer(varyingName);
        if (buffer) return buffer.getData();
        return null;
    }
    delete() {
        for(const name in this.resources)this.resources[name].delete();
    }
    _initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this._setupBuffers(props);
        this.varyings = props.varyings || Object.keys(this.bindings[this.currentIndex].feedbackBuffers);
        if (this.varyings.length > 0) (0, _webgl.assert)((0, _gltools.isWebGL2)(this.gl));
    }
    _getFeedbackBuffers(props) {
        const { sourceBuffers ={}  } = props;
        const feedbackBuffers = {};
        if (this.bindings[this.currentIndex]) Object.assign(feedbackBuffers, this.bindings[this.currentIndex].feedbackBuffers);
        if (this.feedbackMap) for(const sourceName in this.feedbackMap){
            const feedbackName = this.feedbackMap[sourceName];
            if (sourceName in sourceBuffers) feedbackBuffers[feedbackName] = sourceName;
        }
        Object.assign(feedbackBuffers, props.feedbackBuffers);
        for(const bufferName in feedbackBuffers){
            const bufferOrRef = feedbackBuffers[bufferName];
            if (typeof bufferOrRef === "string") {
                const sourceBuffer = sourceBuffers[bufferOrRef];
                const { byteLength , usage , accessor  } = sourceBuffer;
                feedbackBuffers[bufferName] = this._createNewBuffer(bufferName, {
                    byteLength,
                    usage,
                    accessor
                });
            }
        }
        return feedbackBuffers;
    }
    _setupBuffers() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { sourceBuffers =null  } = props;
        Object.assign(this.feedbackMap, props.feedbackMap);
        const feedbackBuffers = this._getFeedbackBuffers(props);
        this._updateBindings({
            sourceBuffers,
            feedbackBuffers
        });
    }
    _setupTransformFeedback(binding, _ref) {
        let { model  } = _ref;
        const { program  } = model;
        binding.transformFeedback = new (0, _webgl.TransformFeedback)(this.gl, {
            program,
            buffers: binding.feedbackBuffers
        });
    }
    _updateBindings(opts) {
        this.bindings[this.currentIndex] = this._updateBinding(this.bindings[this.currentIndex], opts);
        if (this.feedbackMap) {
            const { sourceBuffers , feedbackBuffers  } = this._swapBuffers(this.bindings[this.currentIndex]);
            const nextIndex = this._getNextIndex();
            this.bindings[nextIndex] = this._updateBinding(this.bindings[nextIndex], {
                sourceBuffers,
                feedbackBuffers
            });
        }
    }
    _updateBinding(binding, opts) {
        if (!binding) return {
            sourceBuffers: Object.assign({}, opts.sourceBuffers),
            feedbackBuffers: Object.assign({}, opts.feedbackBuffers)
        };
        Object.assign(binding.sourceBuffers, opts.sourceBuffers);
        Object.assign(binding.feedbackBuffers, opts.feedbackBuffers);
        if (binding.transformFeedback) binding.transformFeedback.setBuffers(binding.feedbackBuffers);
        return binding;
    }
    _swapBuffers(opts) {
        if (!this.feedbackMap) return null;
        const sourceBuffers = Object.assign({}, opts.sourceBuffers);
        const feedbackBuffers = Object.assign({}, opts.feedbackBuffers);
        for(const srcName in this.feedbackMap){
            const dstName = this.feedbackMap[srcName];
            sourceBuffers[srcName] = opts.feedbackBuffers[dstName];
            feedbackBuffers[dstName] = opts.sourceBuffers[srcName];
            (0, _webgl.assert)(feedbackBuffers[dstName] instanceof (0, _webgl.Buffer));
        }
        return {
            sourceBuffers,
            feedbackBuffers
        };
    }
    _createNewBuffer(name, opts) {
        const buffer = new (0, _webgl.Buffer)(this.gl, opts);
        if (this.resources[name]) this.resources[name].delete();
        this.resources[name] = buffer;
        return buffer;
    }
    _getNextIndex() {
        return (this.currentIndex + 1) % 2;
    }
}
exports.default = BufferTransform;

},{"@luma.gl/gltools":"aIkwg","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lE2iV":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _webgl = require("@luma.gl/webgl");
var _shadertools = require("@luma.gl/shadertools");
var _transformShaderUtils = require("./transform-shader-utils");
const SRC_TEX_PARAMETER_OVERRIDES = {
    [10241]: 9728,
    [10240]: 9728,
    [10242]: 33071,
    [10243]: 33071
};
const FS_OUTPUT_VARIABLE = "transform_output";
class TextureTransform {
    constructor(gl){
        let props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
        this.gl = gl;
        this.id = this.currentIndex = 0;
        this._swapTexture = null;
        this.targetTextureVarying = null;
        this.targetTextureType = null;
        this.samplerTextureMap = null;
        this.bindings = [];
        this.resources = {};
        this._initialize(props);
        Object.seal(this);
    }
    updateModelProps() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const updatedModelProps = this._processVertexShader(props);
        return Object.assign({}, props, updatedModelProps);
    }
    getDrawOptions() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { sourceBuffers , sourceTextures , framebuffer , targetTexture  } = this.bindings[this.currentIndex];
        const attributes = Object.assign({}, sourceBuffers, opts.attributes);
        const uniforms = Object.assign({}, opts.uniforms);
        const parameters = Object.assign({}, opts.parameters);
        let discard = opts.discard;
        if (this.hasSourceTextures || this.hasTargetTexture) {
            attributes.transform_elementID = this.elementIDBuffer;
            for(const sampler in this.samplerTextureMap){
                const textureName = this.samplerTextureMap[sampler];
                uniforms[sampler] = sourceTextures[textureName];
            }
            this._setSourceTextureParameters();
            const sizeUniforms = (0, _transformShaderUtils.getSizeUniforms)({
                sourceTextureMap: sourceTextures,
                targetTextureVarying: this.targetTextureVarying,
                targetTexture
            });
            Object.assign(uniforms, sizeUniforms);
        }
        if (this.hasTargetTexture) {
            discard = false;
            parameters.viewport = [
                0,
                0,
                framebuffer.width,
                framebuffer.height
            ];
        }
        return {
            attributes,
            framebuffer,
            uniforms,
            discard,
            parameters
        };
    }
    swap() {
        if (this._swapTexture) {
            this.currentIndex = this._getNextIndex();
            return true;
        }
        return false;
    }
    update() {
        let opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        this._setupTextures(opts);
    }
    getTargetTexture() {
        const { targetTexture  } = this.bindings[this.currentIndex];
        return targetTexture;
    }
    getData() {
        let { packed =false  } = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { framebuffer  } = this.bindings[this.currentIndex];
        const pixels = (0, _webgl.readPixelsToArray)(framebuffer);
        if (!packed) return pixels;
        const ArrayType = pixels.constructor;
        const channelCount = (0, _shadertools.typeToChannelCount)(this.targetTextureType);
        const packedPixels = new ArrayType(pixels.length * channelCount / 4);
        let packCount = 0;
        for(let i = 0; i < pixels.length; i += 4)for(let j = 0; j < channelCount; j++)packedPixels[packCount++] = pixels[i + j];
        return packedPixels;
    }
    getFramebuffer() {
        const currentResources = this.bindings[this.currentIndex];
        return currentResources.framebuffer;
    }
    delete() {
        if (this.ownTexture) this.ownTexture.delete();
        if (this.elementIDBuffer) this.elementIDBuffer.delete();
    }
    _initialize() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { _targetTextureVarying , _swapTexture  } = props;
        this._swapTexture = _swapTexture;
        this.targetTextureVarying = _targetTextureVarying;
        this.hasTargetTexture = _targetTextureVarying;
        this._setupTextures(props);
    }
    _createTargetTexture(props) {
        const { sourceTextures , textureOrReference  } = props;
        if (textureOrReference instanceof (0, _webgl.Texture2D)) return textureOrReference;
        const refTexture = sourceTextures[textureOrReference];
        if (!refTexture) return null;
        this._targetRefTexName = textureOrReference;
        return this._createNewTexture(refTexture);
    }
    _setupTextures() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { sourceBuffers , _sourceTextures ={} , _targetTexture  } = props;
        const targetTexture = this._createTargetTexture({
            sourceTextures: _sourceTextures,
            textureOrReference: _targetTexture
        });
        this.hasSourceTextures = this.hasSourceTextures || _sourceTextures && Object.keys(_sourceTextures).length > 0;
        this._updateBindings({
            sourceBuffers,
            sourceTextures: _sourceTextures,
            targetTexture
        });
        if ("elementCount" in props) this._updateElementIDBuffer(props.elementCount);
    }
    _updateElementIDBuffer(elementCount) {
        if (typeof elementCount !== "number" || this.elementCount >= elementCount) return;
        const elementIds = new Float32Array(elementCount);
        elementIds.forEach((_, index, array)=>{
            array[index] = index;
        });
        if (!this.elementIDBuffer) this.elementIDBuffer = new (0, _webgl.Buffer)(this.gl, {
            data: elementIds,
            accessor: {
                size: 1
            }
        });
        else this.elementIDBuffer.setData({
            data: elementIds
        });
        this.elementCount = elementCount;
    }
    _updateBindings(opts) {
        this.bindings[this.currentIndex] = this._updateBinding(this.bindings[this.currentIndex], opts);
        if (this._swapTexture) {
            const { sourceTextures , targetTexture  } = this._swapTextures(this.bindings[this.currentIndex]);
            const nextIndex = this._getNextIndex();
            this.bindings[nextIndex] = this._updateBinding(this.bindings[nextIndex], {
                sourceTextures,
                targetTexture
            });
        }
    }
    _updateBinding(binding, opts) {
        const { sourceBuffers , sourceTextures , targetTexture  } = opts;
        if (!binding) binding = {
            sourceBuffers: {},
            sourceTextures: {},
            targetTexture: null
        };
        Object.assign(binding.sourceTextures, sourceTextures);
        Object.assign(binding.sourceBuffers, sourceBuffers);
        if (targetTexture) {
            binding.targetTexture = targetTexture;
            const { width , height  } = targetTexture;
            const { framebuffer  } = binding;
            if (framebuffer) {
                framebuffer.update({
                    attachments: {
                        [36064]: targetTexture
                    },
                    resizeAttachments: false
                });
                framebuffer.resize({
                    width,
                    height
                });
            } else binding.framebuffer = new (0, _webgl.Framebuffer)(this.gl, {
                id: "transform-framebuffer",
                width,
                height,
                attachments: {
                    [36064]: targetTexture
                }
            });
        }
        return binding;
    }
    _setSourceTextureParameters() {
        const index = this.currentIndex;
        const { sourceTextures  } = this.bindings[index];
        for(const name in sourceTextures)sourceTextures[name].setParameters(SRC_TEX_PARAMETER_OVERRIDES);
    }
    _swapTextures(opts) {
        if (!this._swapTexture) return null;
        const sourceTextures = Object.assign({}, opts.sourceTextures);
        sourceTextures[this._swapTexture] = opts.targetTexture;
        const targetTexture = opts.sourceTextures[this._swapTexture];
        return {
            sourceTextures,
            targetTexture
        };
    }
    _createNewTexture(refTexture) {
        const texture = (0, _webgl.cloneTextureFrom)(refTexture, {
            parameters: {
                [10241]: 9728,
                [10240]: 9728,
                [10242]: 33071,
                [10243]: 33071
            },
            pixelStore: {
                [37440]: false
            }
        });
        if (this.ownTexture) this.ownTexture.delete();
        this.ownTexture = texture;
        return texture;
    }
    _getNextIndex() {
        return (this.currentIndex + 1) % 2;
    }
    _processVertexShader() {
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { sourceTextures , targetTexture  } = this.bindings[this.currentIndex];
        const { vs , uniforms , targetTextureType , inject , samplerTextureMap  } = (0, _transformShaderUtils.updateForTextures)({
            vs: props.vs,
            sourceTextureMap: sourceTextures,
            targetTextureVarying: this.targetTextureVarying,
            targetTexture
        });
        const combinedInject = (0, _shadertools.combineInjects)([
            props.inject || {},
            inject
        ]);
        this.targetTextureType = targetTextureType;
        this.samplerTextureMap = samplerTextureMap;
        const fs = props._fs || (0, _shadertools.getPassthroughFS)({
            version: (0, _webgl.getShaderVersion)(vs),
            input: this.targetTextureVarying,
            inputType: targetTextureType,
            output: FS_OUTPUT_VARIABLE
        });
        const modules = this.hasSourceTextures || this.targetTextureVarying ? [
            (0, _shadertools._transform)
        ].concat(props.modules || []) : props.modules;
        return {
            vs,
            fs,
            modules,
            uniforms,
            inject: combinedInject
        };
    }
}
exports.default = TextureTransform;

},{"@luma.gl/webgl":"4LrGo","@luma.gl/shadertools":"gjHNu","./transform-shader-utils":"5Yp0f","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5Yp0f":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "updateForTextures", ()=>updateForTextures);
parcelHelpers.export(exports, "getSizeUniforms", ()=>getSizeUniforms);
parcelHelpers.export(exports, "getVaryingType", ()=>getVaryingType);
parcelHelpers.export(exports, "processAttributeDefinition", ()=>processAttributeDefinition);
var _webgl = require("@luma.gl/webgl");
var _shadertools = require("@luma.gl/shadertools");
const SAMPLER_UNIFORM_PREFIX = "transform_uSampler_";
const SIZE_UNIFORM_PREFIX = "transform_uSize_";
const VS_POS_VARIABLE = "transform_position";
function updateForTextures(_ref) {
    let { vs , sourceTextureMap , targetTextureVarying , targetTexture  } = _ref;
    const texAttributeNames = Object.keys(sourceTextureMap);
    let sourceCount = texAttributeNames.length;
    let targetTextureType = null;
    const samplerTextureMap = {};
    let updatedVs = vs;
    let finalInject = {};
    if (sourceCount > 0 || targetTextureVarying) {
        const vsLines = updatedVs.split("\n");
        const updateVsLines = vsLines.slice();
        vsLines.forEach((line, index, lines)=>{
            if (sourceCount > 0) {
                const updated = processAttributeDefinition(line, sourceTextureMap);
                if (updated) {
                    const { updatedLine , inject  } = updated;
                    updateVsLines[index] = updatedLine;
                    finalInject = (0, _shadertools.combineInjects)([
                        finalInject,
                        inject
                    ]);
                    Object.assign(samplerTextureMap, updated.samplerTextureMap);
                    sourceCount--;
                }
            }
            if (targetTextureVarying && !targetTextureType) targetTextureType = getVaryingType(line, targetTextureVarying);
        });
        if (targetTextureVarying) {
            (0, _webgl.assert)(targetTexture);
            const sizeName = "".concat(SIZE_UNIFORM_PREFIX).concat(targetTextureVarying);
            const uniformDeclaration = "uniform vec2 ".concat(sizeName, ";\n");
            const posInstructions = "     vec2 ".concat(VS_POS_VARIABLE, " = transform_getPos(").concat(sizeName, ");\n     gl_Position = vec4(").concat(VS_POS_VARIABLE, ", 0, 1.);\n");
            const inject = {
                "vs:#decl": uniformDeclaration,
                "vs:#main-start": posInstructions
            };
            finalInject = (0, _shadertools.combineInjects)([
                finalInject,
                inject
            ]);
        }
        updatedVs = updateVsLines.join("\n");
    }
    return {
        vs: updatedVs,
        targetTextureType,
        inject: finalInject,
        samplerTextureMap
    };
}
function getSizeUniforms(_ref2) {
    let { sourceTextureMap , targetTextureVarying , targetTexture  } = _ref2;
    const uniforms = {};
    let width;
    let height;
    if (targetTextureVarying) {
        ({ width , height  } = targetTexture);
        uniforms["".concat(SIZE_UNIFORM_PREFIX).concat(targetTextureVarying)] = [
            width,
            height
        ];
    }
    for(const textureName in sourceTextureMap){
        ({ width , height  } = sourceTextureMap[textureName]);
        uniforms["".concat(SIZE_UNIFORM_PREFIX).concat(textureName)] = [
            width,
            height
        ];
    }
    return uniforms;
}
function getAttributeDefinition(line) {
    return (0, _shadertools.getQualifierDetails)(line, [
        "attribute",
        "in"
    ]);
}
function getSamplerDeclerations(textureName) {
    const samplerName = "".concat(SAMPLER_UNIFORM_PREFIX).concat(textureName);
    const sizeName = "".concat(SIZE_UNIFORM_PREFIX).concat(textureName);
    const uniformDeclerations = "  uniform sampler2D ".concat(samplerName, ";\n  uniform vec2 ").concat(sizeName, ";");
    return {
        samplerName,
        sizeName,
        uniformDeclerations
    };
}
function getVaryingType(line, varying) {
    const qualaiferDetails = (0, _shadertools.getQualifierDetails)(line, [
        "varying",
        "out"
    ]);
    if (!qualaiferDetails) return null;
    return qualaiferDetails.name === varying ? qualaiferDetails.type : null;
}
function processAttributeDefinition(line, textureMap) {
    const samplerTextureMap = {};
    const attributeData = getAttributeDefinition(line);
    if (!attributeData) return null;
    const { type , name  } = attributeData;
    if (name && textureMap[name]) {
        const updatedLine = "// ".concat(line, " => Replaced by Transform with a sampler");
        const { samplerName , sizeName , uniformDeclerations  } = getSamplerDeclerations(name);
        const channels = (0, _shadertools.typeToChannelSuffix)(type);
        const sampleInstruction = "  ".concat(type, " ").concat(name, " = transform_getInput(").concat(samplerName, ", ").concat(sizeName, ").").concat(channels, ";\n");
        samplerTextureMap[samplerName] = name;
        const inject = {
            "vs:#decl": uniformDeclerations,
            "vs:#main-start": sampleInstruction
        };
        return {
            updatedLine,
            inject,
            samplerTextureMap
        };
    }
    return null;
}

},{"@luma.gl/webgl":"4LrGo","@luma.gl/shadertools":"gjHNu","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9lmbo":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "DRAW_MODE", ()=>DRAW_MODE);
var _webgl = require("@luma.gl/webgl");
const DRAW_MODE = {
    POINTS: 0x0000,
    LINES: 0x0001,
    LINE_LOOP: 0x0002,
    LINE_STRIP: 0x0003,
    TRIANGLES: 0x0004,
    TRIANGLE_STRIP: 0x0005,
    TRIANGLE_FAN: 0x0006
};
class Geometry {
    static get DRAW_MODE() {
        return DRAW_MODE;
    }
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { id =(0, _webgl.uid)("geometry") , drawMode =DRAW_MODE.TRIANGLES , attributes ={} , indices =null , vertexCount =null  } = props;
        this.id = id;
        this.drawMode = drawMode | 0;
        this.attributes = {};
        this.userData = {};
        this._setAttributes(attributes, indices);
        this.vertexCount = vertexCount || this._calculateVertexCount(this.attributes, this.indices);
    }
    get mode() {
        return this.drawMode;
    }
    getVertexCount() {
        return this.vertexCount;
    }
    getAttributes() {
        return this.indices ? {
            indices: this.indices,
            ...this.attributes
        } : this.attributes;
    }
    _print(attributeName) {
        return "Geometry ".concat(this.id, " attribute ").concat(attributeName);
    }
    _setAttributes(attributes, indices) {
        if (indices) this.indices = ArrayBuffer.isView(indices) ? {
            value: indices,
            size: 1
        } : indices;
        for(const attributeName in attributes){
            let attribute = attributes[attributeName];
            attribute = ArrayBuffer.isView(attribute) ? {
                value: attribute
            } : attribute;
            (0, _webgl.assert)(ArrayBuffer.isView(attribute.value), "".concat(this._print(attributeName), ": must be typed array or object with value as typed array"));
            if ((attributeName === "POSITION" || attributeName === "positions") && !attribute.size) attribute.size = 3;
            if (attributeName === "indices") {
                (0, _webgl.assert)(!this.indices);
                this.indices = attribute;
            } else this.attributes[attributeName] = attribute;
        }
        if (this.indices && this.indices.isIndexed !== undefined) {
            this.indices = Object.assign({}, this.indices);
            delete this.indices.isIndexed;
        }
        return this;
    }
    _calculateVertexCount(attributes, indices) {
        if (indices) return indices.value.length;
        let vertexCount = Infinity;
        for(const attributeName in attributes){
            const attribute = attributes[attributeName];
            const { value , size , constant  } = attribute;
            if (!constant && value && size >= 1) vertexCount = Math.min(vertexCount, value.length / size);
        }
        (0, _webgl.assert)(Number.isFinite(vertexCount));
        return vertexCount;
    }
}
exports.default = Geometry;

},{"@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7HyPx":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _truncatedConeGeometry = require("./truncated-cone-geometry");
var _truncatedConeGeometryDefault = parcelHelpers.interopDefault(_truncatedConeGeometry);
var _webgl = require("@luma.gl/webgl");
class ConeGeometry extends (0, _truncatedConeGeometryDefault.default) {
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { id =(0, _webgl.uid)("cone-geometry") , radius =1 , cap =true  } = props;
        super({
            ...props,
            id,
            topRadius: 0,
            topCap: Boolean(cap),
            bottomCap: Boolean(cap),
            bottomRadius: radius
        });
    }
}
exports.default = ConeGeometry;

},{"./truncated-cone-geometry":"8pvLP","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8pvLP":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _geometry = require("../geometry/geometry");
var _geometryDefault = parcelHelpers.interopDefault(_geometry);
var _webgl = require("@luma.gl/webgl");
const INDEX_OFFSETS = {
    x: [
        2,
        0,
        1
    ],
    y: [
        0,
        1,
        2
    ],
    z: [
        1,
        2,
        0
    ]
};
class TruncatedConeGeometry extends (0, _geometryDefault.default) {
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { id =(0, _webgl.uid)("truncated-code-geometry")  } = props;
        const { indices , attributes  } = tesselateTruncatedCone(props);
        super({
            ...props,
            id,
            indices,
            attributes: {
                ...attributes,
                ...props.attributes
            }
        });
    }
}
exports.default = TruncatedConeGeometry;
function tesselateTruncatedCone(props) {
    const { bottomRadius =0 , topRadius =0 , height =1 , nradial =10 , nvertical =10 , verticalAxis ="y" , topCap =false , bottomCap =false  } = props;
    const extra = (topCap ? 2 : 0) + (bottomCap ? 2 : 0);
    const numVertices = (nradial + 1) * (nvertical + 1 + extra);
    const slant = Math.atan2(bottomRadius - topRadius, height);
    const msin = Math.sin;
    const mcos = Math.cos;
    const mpi = Math.PI;
    const cosSlant = mcos(slant);
    const sinSlant = msin(slant);
    const start = topCap ? -2 : 0;
    const end = nvertical + (bottomCap ? 2 : 0);
    const vertsAroundEdge = nradial + 1;
    const indices = new Uint16Array(nradial * (nvertical + extra) * 6);
    const indexOffset = INDEX_OFFSETS[verticalAxis];
    const positions = new Float32Array(numVertices * 3);
    const normals = new Float32Array(numVertices * 3);
    const texCoords = new Float32Array(numVertices * 2);
    let i3 = 0;
    let i2 = 0;
    for(let i = start; i <= end; i++){
        let v = i / nvertical;
        let y = height * v;
        let ringRadius;
        if (i < 0) {
            y = 0;
            v = 1;
            ringRadius = bottomRadius;
        } else if (i > nvertical) {
            y = height;
            v = 1;
            ringRadius = topRadius;
        } else ringRadius = bottomRadius + (topRadius - bottomRadius) * (i / nvertical);
        if (i === -2 || i === nvertical + 2) {
            ringRadius = 0;
            v = 0;
        }
        y -= height / 2;
        for(let j = 0; j < vertsAroundEdge; j++){
            const sin = msin(j * mpi * 2 / nradial);
            const cos = mcos(j * mpi * 2 / nradial);
            positions[i3 + indexOffset[0]] = sin * ringRadius;
            positions[i3 + indexOffset[1]] = y;
            positions[i3 + indexOffset[2]] = cos * ringRadius;
            normals[i3 + indexOffset[0]] = i < 0 || i > nvertical ? 0 : sin * cosSlant;
            normals[i3 + indexOffset[1]] = i < 0 ? -1 : i > nvertical ? 1 : sinSlant;
            normals[i3 + indexOffset[2]] = i < 0 || i > nvertical ? 0 : cos * cosSlant;
            texCoords[i2 + 0] = j / nradial;
            texCoords[i2 + 1] = v;
            i2 += 2;
            i3 += 3;
        }
    }
    for(let i1 = 0; i1 < nvertical + extra; i1++)for(let j1 = 0; j1 < nradial; j1++){
        const index = (i1 * nradial + j1) * 6;
        indices[index + 0] = vertsAroundEdge * (i1 + 0) + 0 + j1;
        indices[index + 1] = vertsAroundEdge * (i1 + 0) + 1 + j1;
        indices[index + 2] = vertsAroundEdge * (i1 + 1) + 1 + j1;
        indices[index + 3] = vertsAroundEdge * (i1 + 0) + 0 + j1;
        indices[index + 4] = vertsAroundEdge * (i1 + 1) + 1 + j1;
        indices[index + 5] = vertsAroundEdge * (i1 + 1) + 0 + j1;
    }
    return {
        indices,
        attributes: {
            POSITION: {
                size: 3,
                value: positions
            },
            NORMAL: {
                size: 3,
                value: normals
            },
            TEXCOORD_0: {
                size: 2,
                value: texCoords
            }
        }
    };
}

},{"../geometry/geometry":"9lmbo","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"RwRbY":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _geometry = require("../geometry/geometry");
var _geometryDefault = parcelHelpers.interopDefault(_geometry);
var _webgl = require("@luma.gl/webgl");
const CUBE_INDICES = new Uint16Array([
    0,
    1,
    2,
    0,
    2,
    3,
    4,
    5,
    6,
    4,
    6,
    7,
    8,
    9,
    10,
    8,
    10,
    11,
    12,
    13,
    14,
    12,
    14,
    15,
    16,
    17,
    18,
    16,
    18,
    19,
    20,
    21,
    22,
    20,
    22,
    23
]);
const CUBE_POSITIONS = new Float32Array([
    -1,
    -1,
    1,
    1,
    -1,
    1,
    1,
    1,
    1,
    -1,
    1,
    1,
    -1,
    -1,
    -1,
    -1,
    1,
    -1,
    1,
    1,
    -1,
    1,
    -1,
    -1,
    -1,
    1,
    -1,
    -1,
    1,
    1,
    1,
    1,
    1,
    1,
    1,
    -1,
    -1,
    -1,
    -1,
    1,
    -1,
    -1,
    1,
    -1,
    1,
    -1,
    -1,
    1,
    1,
    -1,
    -1,
    1,
    1,
    -1,
    1,
    1,
    1,
    1,
    -1,
    1,
    -1,
    -1,
    -1,
    -1,
    -1,
    1,
    -1,
    1,
    1,
    -1,
    1,
    -1
]);
const CUBE_NORMALS = new Float32Array([
    0,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    0,
    -1,
    0,
    0
]);
const CUBE_TEX_COORDS = new Float32Array([
    0,
    0,
    1,
    0,
    1,
    1,
    0,
    1,
    1,
    0,
    1,
    1,
    0,
    1,
    0,
    0,
    0,
    1,
    0,
    0,
    1,
    0,
    1,
    1,
    1,
    1,
    0,
    1,
    0,
    0,
    1,
    0,
    1,
    0,
    1,
    1,
    0,
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    1,
    1,
    0,
    1
]);
const ATTRIBUTES = {
    POSITION: {
        size: 3,
        value: new Float32Array(CUBE_POSITIONS)
    },
    NORMAL: {
        size: 3,
        value: new Float32Array(CUBE_NORMALS)
    },
    TEXCOORD_0: {
        size: 2,
        value: new Float32Array(CUBE_TEX_COORDS)
    }
};
class CubeGeometry extends (0, _geometryDefault.default) {
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { id =(0, _webgl.uid)("cube-geometry")  } = props;
        super({
            ...props,
            id,
            indices: {
                size: 1,
                value: new Uint16Array(CUBE_INDICES)
            },
            attributes: {
                ...ATTRIBUTES,
                ...props.attributes
            }
        });
    }
}
exports.default = CubeGeometry;

},{"../geometry/geometry":"9lmbo","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"hLuK9":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _truncatedConeGeometry = require("./truncated-cone-geometry");
var _truncatedConeGeometryDefault = parcelHelpers.interopDefault(_truncatedConeGeometry);
var _webgl = require("@luma.gl/webgl");
class CylinderGeometry extends (0, _truncatedConeGeometryDefault.default) {
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { id =(0, _webgl.uid)("cylinder-geometry") , radius =1  } = props;
        super({
            ...props,
            id,
            bottomRadius: radius,
            topRadius: radius
        });
    }
}
exports.default = CylinderGeometry;

},{"./truncated-cone-geometry":"8pvLP","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5FcTo":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _core = require("@math.gl/core");
var _geometry = require("../geometry/geometry");
var _geometryDefault = parcelHelpers.interopDefault(_geometry);
var _webgl = require("@luma.gl/webgl");
const ICO_POSITIONS = [
    -1,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    -1,
    0,
    0,
    1,
    0,
    -1,
    0,
    1,
    0,
    0
];
const ICO_INDICES = [
    3,
    4,
    5,
    3,
    5,
    1,
    3,
    1,
    0,
    3,
    0,
    4,
    4,
    0,
    2,
    4,
    2,
    5,
    2,
    0,
    1,
    5,
    2,
    1
];
class IcoSphereGeometry extends (0, _geometryDefault.default) {
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { id =(0, _webgl.uid)("ico-sphere-geometry")  } = props;
        const { indices , attributes  } = tesselateIcosaHedron(props);
        super({
            ...props,
            id,
            indices,
            attributes: {
                ...attributes,
                ...props.attributes
            }
        });
    }
}
exports.default = IcoSphereGeometry;
function tesselateIcosaHedron(props) {
    const { iterations =0  } = props;
    const PI = Math.PI;
    const PI2 = PI * 2;
    const positions = [
        ...ICO_POSITIONS
    ];
    let indices = [
        ...ICO_INDICES
    ];
    positions.push();
    indices.push();
    const getMiddlePoint = (()=>{
        const pointMemo = {};
        return (i1, i2)=>{
            i1 *= 3;
            i2 *= 3;
            const mini = i1 < i2 ? i1 : i2;
            const maxi = i1 > i2 ? i1 : i2;
            const key = "".concat(mini, "|").concat(maxi);
            if (key in pointMemo) return pointMemo[key];
            const x1 = positions[i1];
            const y1 = positions[i1 + 1];
            const z1 = positions[i1 + 2];
            const x2 = positions[i2];
            const y2 = positions[i2 + 1];
            const z2 = positions[i2 + 2];
            let xm = (x1 + x2) / 2;
            let ym = (y1 + y2) / 2;
            let zm = (z1 + z2) / 2;
            const len = Math.sqrt(xm * xm + ym * ym + zm * zm);
            xm /= len;
            ym /= len;
            zm /= len;
            positions.push(xm, ym, zm);
            return pointMemo[key] = positions.length / 3 - 1;
        };
    })();
    for(let i = 0; i < iterations; i++){
        const indices2 = [];
        for(let j = 0; j < indices.length; j += 3){
            const a = getMiddlePoint(indices[j + 0], indices[j + 1]);
            const b = getMiddlePoint(indices[j + 1], indices[j + 2]);
            const c = getMiddlePoint(indices[j + 2], indices[j + 0]);
            indices2.push(c, indices[j + 0], a, a, indices[j + 1], b, b, indices[j + 2], c, a, b, c);
        }
        indices = indices2;
    }
    const normals = new Array(positions.length);
    const texCoords = new Array(positions.length / 3 * 2);
    const l = indices.length;
    for(let i1 = l - 3; i1 >= 0; i1 -= 3){
        const i11 = indices[i1 + 0];
        const i2 = indices[i1 + 1];
        const i3 = indices[i1 + 2];
        const in1 = i11 * 3;
        const in2 = i2 * 3;
        const in3 = i3 * 3;
        const iu1 = i11 * 2;
        const iu2 = i2 * 2;
        const iu3 = i3 * 2;
        const x1 = positions[in1 + 0];
        const y1 = positions[in1 + 1];
        const z1 = positions[in1 + 2];
        const theta1 = Math.acos(z1 / Math.sqrt(x1 * x1 + y1 * y1 + z1 * z1));
        const phi1 = Math.atan2(y1, x1) + PI;
        const v1 = theta1 / PI;
        const u1 = 1 - phi1 / PI2;
        const x2 = positions[in2 + 0];
        const y2 = positions[in2 + 1];
        const z2 = positions[in2 + 2];
        const theta2 = Math.acos(z2 / Math.sqrt(x2 * x2 + y2 * y2 + z2 * z2));
        const phi2 = Math.atan2(y2, x2) + PI;
        const v2 = theta2 / PI;
        const u2 = 1 - phi2 / PI2;
        const x3 = positions[in3 + 0];
        const y3 = positions[in3 + 1];
        const z3 = positions[in3 + 2];
        const theta3 = Math.acos(z3 / Math.sqrt(x3 * x3 + y3 * y3 + z3 * z3));
        const phi3 = Math.atan2(y3, x3) + PI;
        const v3 = theta3 / PI;
        const u3 = 1 - phi3 / PI2;
        const vec1 = [
            x3 - x2,
            y3 - y2,
            z3 - z2
        ];
        const vec2 = [
            x1 - x2,
            y1 - y2,
            z1 - z2
        ];
        const normal = new (0, _core.Vector3)(vec1).cross(vec2).normalize();
        let newIndex;
        if ((u1 === 0 || u2 === 0 || u3 === 0) && (u1 === 0 || u1 > 0.5) && (u2 === 0 || u2 > 0.5) && (u3 === 0 || u3 > 0.5)) {
            positions.push(positions[in1 + 0], positions[in1 + 1], positions[in1 + 2]);
            newIndex = positions.length / 3 - 1;
            indices.push(newIndex);
            texCoords[newIndex * 2 + 0] = 1;
            texCoords[newIndex * 2 + 1] = v1;
            normals[newIndex * 3 + 0] = normal.x;
            normals[newIndex * 3 + 1] = normal.y;
            normals[newIndex * 3 + 2] = normal.z;
            positions.push(positions[in2 + 0], positions[in2 + 1], positions[in2 + 2]);
            newIndex = positions.length / 3 - 1;
            indices.push(newIndex);
            texCoords[newIndex * 2 + 0] = 1;
            texCoords[newIndex * 2 + 1] = v2;
            normals[newIndex * 3 + 0] = normal.x;
            normals[newIndex * 3 + 1] = normal.y;
            normals[newIndex * 3 + 2] = normal.z;
            positions.push(positions[in3 + 0], positions[in3 + 1], positions[in3 + 2]);
            newIndex = positions.length / 3 - 1;
            indices.push(newIndex);
            texCoords[newIndex * 2 + 0] = 1;
            texCoords[newIndex * 2 + 1] = v3;
            normals[newIndex * 3 + 0] = normal.x;
            normals[newIndex * 3 + 1] = normal.y;
            normals[newIndex * 3 + 2] = normal.z;
        }
        normals[in1 + 0] = normals[in2 + 0] = normals[in3 + 0] = normal.x;
        normals[in1 + 1] = normals[in2 + 1] = normals[in3 + 1] = normal.y;
        normals[in1 + 2] = normals[in2 + 2] = normals[in3 + 2] = normal.z;
        texCoords[iu1 + 0] = u1;
        texCoords[iu1 + 1] = v1;
        texCoords[iu2 + 0] = u2;
        texCoords[iu2 + 1] = v2;
        texCoords[iu3 + 0] = u3;
        texCoords[iu3 + 1] = v3;
    }
    return {
        indices: {
            size: 1,
            value: new Uint16Array(indices)
        },
        attributes: {
            POSITION: {
                size: 3,
                value: new Float32Array(positions)
            },
            NORMAL: {
                size: 3,
                value: new Float32Array(normals)
            },
            TEXCOORD_0: {
                size: 2,
                value: new Float32Array(texCoords)
            }
        }
    };
}

},{"@math.gl/core":"9lgwD","../geometry/geometry":"9lmbo","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jbb8n":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _geometry = require("../geometry/geometry");
var _geometryDefault = parcelHelpers.interopDefault(_geometry);
var _geometryUtils = require("../geometry/geometry-utils");
var _webgl = require("@luma.gl/webgl");
class PlaneGeometry extends (0, _geometryDefault.default) {
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { id =(0, _webgl.uid)("plane-geometry")  } = props;
        const { indices , attributes  } = tesselatePlane(props);
        super({
            ...props,
            id,
            indices,
            attributes: {
                ...attributes,
                ...props.attributes
            }
        });
    }
}
exports.default = PlaneGeometry;
function tesselatePlane(props) {
    const { type ="x,y" , offset =0 , flipCull =false , unpack =false  } = props;
    const coords = type.split(",");
    let c1len = props["".concat(coords[0], "len")] || 1;
    const c2len = props["".concat(coords[1], "len")] || 1;
    const subdivisions1 = props["n".concat(coords[0])] || 1;
    const subdivisions2 = props["n".concat(coords[1])] || 1;
    const numVertices = (subdivisions1 + 1) * (subdivisions2 + 1);
    const positions = new Float32Array(numVertices * 3);
    const normals = new Float32Array(numVertices * 3);
    const texCoords = new Float32Array(numVertices * 2);
    if (flipCull) c1len = -c1len;
    let i2 = 0;
    let i3 = 0;
    for(let z = 0; z <= subdivisions2; z++)for(let x = 0; x <= subdivisions1; x++){
        const u = x / subdivisions1;
        const v = z / subdivisions2;
        texCoords[i2 + 0] = flipCull ? 1 - u : u;
        texCoords[i2 + 1] = v;
        switch(type){
            case "x,y":
                positions[i3 + 0] = c1len * u - c1len * 0.5;
                positions[i3 + 1] = c2len * v - c2len * 0.5;
                positions[i3 + 2] = offset;
                normals[i3 + 0] = 0;
                normals[i3 + 1] = 0;
                normals[i3 + 2] = flipCull ? 1 : -1;
                break;
            case "x,z":
                positions[i3 + 0] = c1len * u - c1len * 0.5;
                positions[i3 + 1] = offset;
                positions[i3 + 2] = c2len * v - c2len * 0.5;
                normals[i3 + 0] = 0;
                normals[i3 + 1] = flipCull ? 1 : -1;
                normals[i3 + 2] = 0;
                break;
            case "y,z":
                positions[i3 + 0] = offset;
                positions[i3 + 1] = c1len * u - c1len * 0.5;
                positions[i3 + 2] = c2len * v - c2len * 0.5;
                normals[i3 + 0] = flipCull ? 1 : -1;
                normals[i3 + 1] = 0;
                normals[i3 + 2] = 0;
                break;
            default:
                throw new Error("PlaneGeometry: unknown type");
        }
        i2 += 2;
        i3 += 3;
    }
    const numVertsAcross = subdivisions1 + 1;
    const indices = new Uint16Array(subdivisions1 * subdivisions2 * 6);
    for(let z1 = 0; z1 < subdivisions2; z1++)for(let x1 = 0; x1 < subdivisions1; x1++){
        const index = (z1 * subdivisions1 + x1) * 6;
        indices[index + 0] = (z1 + 0) * numVertsAcross + x1;
        indices[index + 1] = (z1 + 1) * numVertsAcross + x1;
        indices[index + 2] = (z1 + 0) * numVertsAcross + x1 + 1;
        indices[index + 3] = (z1 + 1) * numVertsAcross + x1;
        indices[index + 4] = (z1 + 1) * numVertsAcross + x1 + 1;
        indices[index + 5] = (z1 + 0) * numVertsAcross + x1 + 1;
    }
    const geometry = {
        indices: {
            size: 1,
            value: indices
        },
        attributes: {
            POSITION: {
                size: 3,
                value: positions
            },
            NORMAL: {
                size: 3,
                value: normals
            },
            TEXCOORD_0: {
                size: 2,
                value: texCoords
            }
        }
    };
    return unpack ? (0, _geometryUtils.unpackIndexedGeometry)(geometry) : geometry;
}

},{"../geometry/geometry":"9lmbo","../geometry/geometry-utils":"3LOz5","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3LOz5":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "unpackIndexedGeometry", ()=>unpackIndexedGeometry);
function unpackIndexedGeometry(geometry) {
    const { indices , attributes  } = geometry;
    if (!indices) return geometry;
    const vertexCount = indices.value.length;
    const unpackedAttributes = {};
    for(const attributeName in attributes){
        const attribute = attributes[attributeName];
        const { constant , value , size  } = attribute;
        if (constant || !size) continue;
        const unpackedValue = new value.constructor(vertexCount * size);
        for(let x = 0; x < vertexCount; ++x){
            const index = indices.value[x];
            for(let i = 0; i < size; i++)unpackedValue[x * size + i] = value[index * size + i];
        }
        unpackedAttributes[attributeName] = {
            size,
            value: unpackedValue
        };
    }
    return {
        attributes: Object.assign({}, attributes, unpackedAttributes)
    };
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"83dKB":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _geometry = require("../geometry/geometry");
var _geometryDefault = parcelHelpers.interopDefault(_geometry);
var _webgl = require("@luma.gl/webgl");
class SphereGeometry extends (0, _geometryDefault.default) {
    constructor(){
        let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        const { id =(0, _webgl.uid)("sphere-geometry")  } = props;
        const { indices , attributes  } = tesselateSphere(props);
        super({
            ...props,
            id,
            indices,
            attributes: {
                ...attributes,
                ...props.attributes
            }
        });
    }
}
exports.default = SphereGeometry;
function tesselateSphere(props) {
    const { nlat =10 , nlong =10  } = props;
    let { radius =1  } = props;
    const startLat = 0;
    const endLat = Math.PI;
    const latRange = endLat - startLat;
    const startLong = 0;
    const endLong = 2 * Math.PI;
    const longRange = endLong - startLong;
    const numVertices = (nlat + 1) * (nlong + 1);
    if (typeof radius === "number") {
        const value = radius;
        radius = (n1, n2, n3, u, v)=>value;
    }
    const positions = new Float32Array(numVertices * 3);
    const normals = new Float32Array(numVertices * 3);
    const texCoords = new Float32Array(numVertices * 2);
    const IndexType = numVertices > 0xffff ? Uint32Array : Uint16Array;
    const indices = new IndexType(nlat * nlong * 6);
    for(let y = 0; y <= nlat; y++)for(let x = 0; x <= nlong; x++){
        const u = x / nlong;
        const v = y / nlat;
        const index = x + y * (nlong + 1);
        const i2 = index * 2;
        const i3 = index * 3;
        const theta = longRange * u;
        const phi = latRange * v;
        const sinTheta = Math.sin(theta);
        const cosTheta = Math.cos(theta);
        const sinPhi = Math.sin(phi);
        const cosPhi = Math.cos(phi);
        const ux = cosTheta * sinPhi;
        const uy = cosPhi;
        const uz = sinTheta * sinPhi;
        const r = radius(ux, uy, uz, u, v);
        positions[i3 + 0] = r * ux;
        positions[i3 + 1] = r * uy;
        positions[i3 + 2] = r * uz;
        normals[i3 + 0] = ux;
        normals[i3 + 1] = uy;
        normals[i3 + 2] = uz;
        texCoords[i2 + 0] = u;
        texCoords[i2 + 1] = 1 - v;
    }
    const numVertsAround = nlong + 1;
    for(let x1 = 0; x1 < nlong; x1++)for(let y1 = 0; y1 < nlat; y1++){
        const index1 = (x1 * nlat + y1) * 6;
        indices[index1 + 0] = y1 * numVertsAround + x1;
        indices[index1 + 1] = y1 * numVertsAround + x1 + 1;
        indices[index1 + 2] = (y1 + 1) * numVertsAround + x1;
        indices[index1 + 3] = (y1 + 1) * numVertsAround + x1;
        indices[index1 + 4] = y1 * numVertsAround + x1 + 1;
        indices[index1 + 5] = (y1 + 1) * numVertsAround + x1 + 1;
    }
    return {
        indices: {
            size: 1,
            value: indices
        },
        attributes: {
            POSITION: {
                size: 3,
                value: positions
            },
            NORMAL: {
                size: 3,
                value: normals
            },
            TEXCOORD_0: {
                size: 2,
                value: texCoords
            }
        }
    };
}

},{"../geometry/geometry":"9lmbo","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"zJQUs":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Timeline", ()=>Timeline);
let channelHandles = 1;
let animationHandles = 1;
class Timeline {
    constructor(){
        this.time = 0;
        this.channels = new Map();
        this.animations = new Map();
        this.playing = false;
        this.lastEngineTime = -1;
    }
    addChannel(props) {
        const { delay =0 , duration =Number.POSITIVE_INFINITY , rate =1 , repeat =1  } = props;
        const handle = channelHandles++;
        const channel = {
            time: 0,
            delay,
            duration,
            rate,
            repeat
        };
        this._setChannelTime(channel, this.time);
        this.channels.set(handle, channel);
        return handle;
    }
    removeChannel(handle) {
        this.channels.delete(handle);
        for (const [animationHandle, animation] of this.animations)if (animation.channel === handle) this.detachAnimation(animationHandle);
    }
    isFinished(handle) {
        const channel = this.channels.get(handle);
        if (channel === undefined) return false;
        return this.time >= channel.delay + channel.duration * channel.repeat;
    }
    getTime(handle) {
        if (handle === undefined) return this.time;
        const channel = this.channels.get(handle);
        if (channel === undefined) return -1;
        return channel.time;
    }
    setTime(time) {
        this.time = Math.max(0, time);
        const channels = this.channels.values();
        for (const channel of channels)this._setChannelTime(channel, this.time);
        const animations = this.animations.values();
        for (const animationData of animations){
            const { animation , channel: channel1  } = animationData;
            animation.setTime(this.getTime(channel1));
        }
    }
    play() {
        this.playing = true;
    }
    pause() {
        this.playing = false;
        this.lastEngineTime = -1;
    }
    reset() {
        this.setTime(0);
    }
    attachAnimation(animation, channelHandle) {
        const animationHandle = animationHandles++;
        this.animations.set(animationHandle, {
            animation,
            channel: channelHandle
        });
        animation.setTime(this.getTime(channelHandle));
        return animationHandle;
    }
    detachAnimation(handle) {
        this.animations.delete(handle);
    }
    update(engineTime) {
        if (this.playing) {
            if (this.lastEngineTime === -1) this.lastEngineTime = engineTime;
            this.setTime(this.time + (engineTime - this.lastEngineTime));
            this.lastEngineTime = engineTime;
        }
    }
    _setChannelTime(channel, time) {
        const offsetTime = time - channel.delay;
        const totalDuration = channel.duration * channel.repeat;
        if (offsetTime >= totalDuration) channel.time = channel.duration * channel.rate;
        else {
            channel.time = Math.max(0, offsetTime) % channel.duration;
            channel.time *= channel.rate;
        }
    }
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6xK7h":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _model = require("../lib/model");
var _modelDefault = parcelHelpers.interopDefault(_model);
var _geometry = require("../geometry/geometry");
var _geometryDefault = parcelHelpers.interopDefault(_geometry);
const CLIPSPACE_VERTEX_SHADER = "attribute vec2 aClipSpacePosition;\nattribute vec2 aTexCoord;\nattribute vec2 aCoordinate;\n\nvarying vec2 position;\nvarying vec2 coordinate;\nvarying vec2 uv;\n\nvoid main(void) {\n  gl_Position = vec4(aClipSpacePosition, 0., 1.);\n  position = aClipSpacePosition;\n  coordinate = aCoordinate;\n  uv = aTexCoord;\n}\n";
const POSITIONS = [
    -1,
    -1,
    1,
    -1,
    -1,
    1,
    1,
    1
];
class ClipSpace extends (0, _modelDefault.default) {
    constructor(gl, opts){
        const TEX_COORDS = POSITIONS.map((coord)=>coord === -1 ? 0 : coord);
        super(gl, Object.assign({}, opts, {
            vs: CLIPSPACE_VERTEX_SHADER,
            geometry: new (0, _geometryDefault.default)({
                drawMode: 5,
                vertexCount: 4,
                attributes: {
                    aClipSpacePosition: {
                        size: 2,
                        value: new Float32Array(POSITIONS)
                    },
                    aTexCoord: {
                        size: 2,
                        value: new Float32Array(TEX_COORDS)
                    },
                    aCoordinate: {
                        size: 2,
                        value: new Float32Array(TEX_COORDS)
                    }
                }
            })
        }));
        this.setVertexCount(4);
    }
}
exports.default = ClipSpace;

},{"../lib/model":"c1vGg","../geometry/geometry":"9lmbo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7sBNM":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _core = require("@luma.gl/core");
var _geometry = require("../misc/geometry");
var _geometryDefault = parcelHelpers.interopDefault(_geometry);
var _projectGlsl = require("./project.glsl");
var _projectGlslDefault = parcelHelpers.interopDefault(_projectGlsl);
var _viewportUniforms = require("./viewport-uniforms");
const INITIAL_MODULE_OPTIONS = {};
function getUniforms(opts = INITIAL_MODULE_OPTIONS) {
    if ("viewport" in opts) return (0, _viewportUniforms.getUniformsFromViewport)(opts);
    return {};
}
exports.default = {
    name: "project",
    dependencies: [
        (0, _core.fp32),
        (0, _geometryDefault.default)
    ],
    vs: (0, _projectGlslDefault.default),
    getUniforms
};

},{"@luma.gl/core":"9yA57","../misc/geometry":"5msQd","./project.glsl":"8eZ3H","./viewport-uniforms":"jPtIW","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5msQd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
const defines = "#define SMOOTH_EDGE_RADIUS 0.5";
const vs = "\n".concat(defines, "\n\nstruct VertexGeometry {\n  vec4 position;\n  vec3 worldPosition;\n  vec3 worldPositionAlt;\n  vec3 normal;\n  vec2 uv;\n  vec3 pickingColor;\n} geometry = VertexGeometry(\n  vec4(0.0, 0.0, 1.0, 0.0),\n  vec3(0.0),\n  vec3(0.0),\n  vec3(0.0),\n  vec2(0.0),\n  vec3(0.0)\n);\n");
const fs = "\n".concat(defines, "\n\nstruct FragmentGeometry {\n  vec2 uv;\n} geometry;\n\nfloat smoothedge(float edge, float x) {\n  return smoothstep(edge - SMOOTH_EDGE_RADIUS, edge + SMOOTH_EDGE_RADIUS, x);\n}\n");
exports.default = {
    name: "geometry",
    vs,
    fs
};

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8eZ3H":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _constants = require("../../lib/constants");
const COORDINATE_SYSTEM_GLSL_CONSTANTS = Object.keys((0, _constants.COORDINATE_SYSTEM)).map((key)=>"const int COORDINATE_SYSTEM_".concat(key, " = ").concat((0, _constants.COORDINATE_SYSTEM)[key], ";")).join("");
const PROJECTION_MODE_GLSL_CONSTANTS = Object.keys((0, _constants.PROJECTION_MODE)).map((key)=>"const int PROJECTION_MODE_".concat(key, " = ").concat((0, _constants.PROJECTION_MODE)[key], ";")).join("");
const UNIT_GLSL_CONSTANTS = Object.keys((0, _constants.UNIT)).map((key)=>"const int UNIT_".concat(key.toUpperCase(), " = ").concat((0, _constants.UNIT)[key], ";")).join("");
exports.default = "".concat(COORDINATE_SYSTEM_GLSL_CONSTANTS, "\n").concat(PROJECTION_MODE_GLSL_CONSTANTS, "\n").concat(UNIT_GLSL_CONSTANTS, '\n\nuniform int project_uCoordinateSystem;\nuniform int project_uProjectionMode;\nuniform float project_uScale;\nuniform bool project_uWrapLongitude;\nuniform vec3 project_uCommonUnitsPerMeter;\nuniform vec3 project_uCommonUnitsPerWorldUnit;\nuniform vec3 project_uCommonUnitsPerWorldUnit2;\nuniform vec4 project_uCenter;\nuniform mat4 project_uModelMatrix;\nuniform mat4 project_uViewProjectionMatrix;\nuniform vec2 project_uViewportSize;\nuniform float project_uDevicePixelRatio;\nuniform float project_uFocalDistance;\nuniform vec3 project_uCameraPosition;\nuniform vec3 project_uCoordinateOrigin;\nuniform vec3 project_uCommonOrigin;\nuniform bool project_uPseudoMeters;\n\nconst float TILE_SIZE = 512.0;\nconst float PI = 3.1415926536;\nconst float WORLD_SCALE = TILE_SIZE / (PI * 2.0);\nconst vec3 ZERO_64_LOW = vec3(0.0);\nconst float EARTH_RADIUS = 6370972.0; // meters\nconst float GLOBE_RADIUS = 256.0;\n\n// returns an adjustment factor for uCommonUnitsPerMeter\nfloat project_size_at_latitude(float lat) {\n  float y = clamp(lat, -89.9, 89.9);\n  return 1.0 / cos(radians(y));\n}\n\nfloat project_size() {\n  if (project_uProjectionMode == PROJECTION_MODE_WEB_MERCATOR &&\n    project_uCoordinateSystem == COORDINATE_SYSTEM_LNGLAT &&\n    project_uPseudoMeters == false) {\n\n    // uCommonUnitsPerMeter in low-zoom Web Mercator is non-linear\n    // Adjust by 1 / cos(latitude)\n    // If geometry.position (vertex in common space) is populated, use it\n    // Otherwise use geometry.worldPosition (anchor in world space)\n    \n    if (geometry.position.w == 0.0) {\n      return project_size_at_latitude(geometry.worldPosition.y);\n    }\n\n    // latitude from common y: 2.0 * (atan(exp(y / TILE_SIZE * 2.0 * PI - PI)) - PI / 4.0)\n    // Taylor series of 1 / cos(latitude)\n    // Max error < 0.003\n  \n    float y = geometry.position.y / TILE_SIZE * 2.0 - 1.0;\n    float y2 = y * y;\n    float y4 = y2 * y2;\n    float y6 = y4 * y2;\n    return 1.0 + 4.9348 * y2 + 4.0587 * y4 + 1.5642 * y6;\n  }\n  return 1.0;\n}\n\nfloat project_size_at_latitude(float meters, float lat) {\n  return meters * project_uCommonUnitsPerMeter.z * project_size_at_latitude(lat);\n}\n\n//\n// Scaling offsets - scales meters to "world distance"\n// Note the scalar version of project_size is for scaling the z component only\n//\nfloat project_size(float meters) {\n  return meters * project_uCommonUnitsPerMeter.z * project_size();\n}\n\nvec2 project_size(vec2 meters) {\n  return meters * project_uCommonUnitsPerMeter.xy * project_size();\n}\n\nvec3 project_size(vec3 meters) {\n  return meters * project_uCommonUnitsPerMeter * project_size();\n}\n\nvec4 project_size(vec4 meters) {\n  return vec4(meters.xyz * project_uCommonUnitsPerMeter, meters.w);\n}\n\n// Get rotation matrix that aligns the z axis with the given up vector\n// Find 3 unit vectors ux, uy, uz that are perpendicular to each other and uz == up\nmat3 project_get_orientation_matrix(vec3 up) {\n  vec3 uz = normalize(up);\n  // Tangent on XY plane\n  vec3 ux = abs(uz.z) == 1.0 ? vec3(1.0, 0.0, 0.0) : normalize(vec3(uz.y, -uz.x, 0));\n  vec3 uy = cross(uz, ux);\n  return mat3(ux, uy, uz);\n}\n\nbool project_needs_rotation(vec3 commonPosition, out mat3 transform) {\n  if (project_uProjectionMode == PROJECTION_MODE_GLOBE) {\n    transform = project_get_orientation_matrix(commonPosition);\n    return true;\n  }\n  return false;\n}\n\n//\n// Projecting normal - transform deltas from current coordinate system to\n// normals in the worldspace\n//\nvec3 project_normal(vec3 vector) {\n  // Apply model matrix\n  vec4 normal_modelspace = project_uModelMatrix * vec4(vector, 0.0);\n  vec3 n = normalize(normal_modelspace.xyz * project_uCommonUnitsPerMeter);\n  mat3 rotation;\n  if (project_needs_rotation(geometry.position.xyz, rotation)) {\n    n = rotation * n;\n  }\n  return n;\n}\n\nvec4 project_offset_(vec4 offset) {\n  float dy = offset.y;\n  vec3 commonUnitsPerWorldUnit = project_uCommonUnitsPerWorldUnit + project_uCommonUnitsPerWorldUnit2 * dy;\n  return vec4(offset.xyz * commonUnitsPerWorldUnit, offset.w);\n}\n\n//\n// Projecting positions - non-linear projection: lnglats => unit tile [0-1, 0-1]\n//\nvec2 project_mercator_(vec2 lnglat) {\n  float x = lnglat.x;\n  if (project_uWrapLongitude) {\n    x = mod(x + 180., 360.0) - 180.;\n  }\n  float y = clamp(lnglat.y, -89.9, 89.9);\n  return vec2(\n    radians(x) + PI,\n    PI + log(tan_fp32(PI * 0.25 + radians(y) * 0.5))\n  ) * WORLD_SCALE;\n}\n\nvec3 project_globe_(vec3 lnglatz) {\n  float lambda = radians(lnglatz.x);\n  float phi = radians(lnglatz.y);\n  float cosPhi = cos(phi);\n  float D = (lnglatz.z / EARTH_RADIUS + 1.0) * GLOBE_RADIUS;\n\n  return vec3(\n    sin(lambda) * cosPhi,\n    -cos(lambda) * cosPhi,\n    sin(phi)\n  ) * D;\n}\n\n//\n// Projects positions (defined by project_uCoordinateSystem) to common space (defined by project_uProjectionMode)\n//\nvec4 project_position(vec4 position, vec3 position64Low) {\n  vec4 position_world = project_uModelMatrix * position;\n\n  // Work around for a Mac+NVIDIA bug https://github.com/visgl/deck.gl/issues/4145\n  if (project_uProjectionMode == PROJECTION_MODE_WEB_MERCATOR) {\n    if (project_uCoordinateSystem == COORDINATE_SYSTEM_LNGLAT) {\n      return vec4(\n        project_mercator_(position_world.xy),\n        project_size_at_latitude(position_world.z, position_world.y),\n        position_world.w\n      );\n    }\n    if (project_uCoordinateSystem == COORDINATE_SYSTEM_CARTESIAN) {\n      position_world.xyz += project_uCoordinateOrigin;\n    }\n  }\n  if (project_uProjectionMode == PROJECTION_MODE_GLOBE) {\n    if (project_uCoordinateSystem == COORDINATE_SYSTEM_LNGLAT) {\n      return vec4(\n        project_globe_(position_world.xyz),\n        position_world.w\n      );\n    }\n  }\n  if (project_uProjectionMode == PROJECTION_MODE_WEB_MERCATOR_AUTO_OFFSET) {\n    if (project_uCoordinateSystem == COORDINATE_SYSTEM_LNGLAT) {\n      if (abs(position_world.y - project_uCoordinateOrigin.y) > 0.25) {\n        // Too far from the projection center for offset mode to be accurate\n        // Only use high parts\n        return vec4(\n          project_mercator_(position_world.xy) - project_uCommonOrigin.xy,\n          project_size(position_world.z),\n          position_world.w\n        );\n      }\n    }\n  }\n  if (project_uProjectionMode == PROJECTION_MODE_IDENTITY ||\n    (project_uProjectionMode == PROJECTION_MODE_WEB_MERCATOR_AUTO_OFFSET &&\n    (project_uCoordinateSystem == COORDINATE_SYSTEM_LNGLAT ||\n     project_uCoordinateSystem == COORDINATE_SYSTEM_CARTESIAN))) {\n    // Subtract high part of 64 bit value. Convert remainder to float32, preserving precision.\n    position_world.xyz -= project_uCoordinateOrigin;\n  }\n\n  // Translation is already added to the high parts\n  return project_offset_(position_world + project_uModelMatrix * vec4(position64Low, 0.0));\n}\n\nvec4 project_position(vec4 position) {\n  return project_position(position, ZERO_64_LOW);\n}\n\nvec3 project_position(vec3 position, vec3 position64Low) {\n  vec4 projected_position = project_position(vec4(position, 1.0), position64Low);\n  return projected_position.xyz;\n}\n\nvec3 project_position(vec3 position) {\n  vec4 projected_position = project_position(vec4(position, 1.0), ZERO_64_LOW);\n  return projected_position.xyz;\n}\n\nvec2 project_position(vec2 position) {\n  vec4 projected_position = project_position(vec4(position, 0.0, 1.0), ZERO_64_LOW);\n  return projected_position.xy;\n}\n\nvec4 project_common_position_to_clipspace(vec4 position, mat4 viewProjectionMatrix, vec4 center) {\n  return viewProjectionMatrix * position + center;\n}\n\n//\n// Projects from common space coordinates to clip space.\n// Uses project_uViewProjectionMatrix\n//\nvec4 project_common_position_to_clipspace(vec4 position) {\n  return project_common_position_to_clipspace(position, project_uViewProjectionMatrix, project_uCenter);\n}\n\n// Returns a clip space offset that corresponds to a given number of screen pixels\nvec2 project_pixel_size_to_clipspace(vec2 pixels) {\n  vec2 offset = pixels / project_uViewportSize * project_uDevicePixelRatio * 2.0;\n  return offset * project_uFocalDistance;\n}\n\nfloat project_size_to_pixel(float meters) {\n  return project_size(meters) * project_uScale;\n}\nfloat project_size_to_pixel(float size, int unit) {\n  if (unit == UNIT_METERS) return project_size_to_pixel(size);\n  if (unit == UNIT_COMMON) return size * project_uScale;\n  // UNIT_PIXELS\n  return size;\n}\nfloat project_pixel_size(float pixels) {\n  return pixels / project_uScale;\n}\nvec2 project_pixel_size(vec2 pixels) {\n  return pixels / project_uScale;\n}\n');

},{"../../lib/constants":"ksWme","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ksWme":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "COORDINATE_SYSTEM", ()=>COORDINATE_SYSTEM);
parcelHelpers.export(exports, "PROJECTION_MODE", ()=>PROJECTION_MODE);
parcelHelpers.export(exports, "UNIT", ()=>UNIT);
parcelHelpers.export(exports, "EVENTS", ()=>EVENTS);
parcelHelpers.export(exports, "OPERATION", ()=>OPERATION);
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
const COORDINATE_SYSTEM = {
    DEFAULT: -1,
    LNGLAT: 1,
    METER_OFFSETS: 2,
    LNGLAT_OFFSETS: 3,
    CARTESIAN: 0
};
Object.defineProperty(COORDINATE_SYSTEM, "IDENTITY", {
    get: ()=>{
        (0, _logDefault.default).deprecated("COORDINATE_SYSTEM.IDENTITY", "COORDINATE_SYSTEM.CARTESIAN")();
        return 0;
    }
});
const PROJECTION_MODE = {
    WEB_MERCATOR: 1,
    GLOBE: 2,
    WEB_MERCATOR_AUTO_OFFSET: 4,
    IDENTITY: 0
};
const UNIT = {
    common: 0,
    meters: 1,
    pixels: 2
};
const EVENTS = {
    click: {
        handler: "onClick"
    },
    panstart: {
        handler: "onDragStart"
    },
    panmove: {
        handler: "onDrag"
    },
    panend: {
        handler: "onDragEnd"
    }
};
const OPERATION = {
    DRAW: "draw",
    MASK: "mask"
};

},{"../utils/log":"iINk7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jPtIW":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getOffsetOrigin", ()=>getOffsetOrigin);
parcelHelpers.export(exports, "getUniformsFromViewport", ()=>getUniformsFromViewport);
var _mat4 = require("gl-matrix/mat4");
var _vec4 = require("gl-matrix/vec4");
var _constants = require("../../lib/constants");
var _memoize = require("../../utils/memoize");
var _memoizeDefault = parcelHelpers.interopDefault(_memoize);
const ZERO_VECTOR = [
    0,
    0,
    0,
    0
];
const VECTOR_TO_POINT_MATRIX = [
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    0
];
const IDENTITY_MATRIX = [
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    1
];
const DEFAULT_PIXELS_PER_UNIT2 = [
    0,
    0,
    0
];
const DEFAULT_COORDINATE_ORIGIN = [
    0,
    0,
    0
];
const getMemoizedViewportUniforms = (0, _memoizeDefault.default)(calculateViewportUniforms);
function getOffsetOrigin(viewport, coordinateSystem, coordinateOrigin = DEFAULT_COORDINATE_ORIGIN) {
    if (coordinateOrigin.length < 3) coordinateOrigin = [
        coordinateOrigin[0],
        coordinateOrigin[1],
        0
    ];
    let shaderCoordinateOrigin = coordinateOrigin;
    let geospatialOrigin;
    let offsetMode = true;
    if (coordinateSystem === (0, _constants.COORDINATE_SYSTEM).LNGLAT_OFFSETS || coordinateSystem === (0, _constants.COORDINATE_SYSTEM).METER_OFFSETS) geospatialOrigin = coordinateOrigin;
    else geospatialOrigin = viewport.isGeospatial ? [
        Math.fround(viewport.longitude),
        Math.fround(viewport.latitude),
        0
    ] : null;
    switch(viewport.projectionMode){
        case (0, _constants.PROJECTION_MODE).WEB_MERCATOR:
            if (coordinateSystem === (0, _constants.COORDINATE_SYSTEM).LNGLAT || coordinateSystem === (0, _constants.COORDINATE_SYSTEM).CARTESIAN) {
                geospatialOrigin = [
                    0,
                    0,
                    0
                ];
                offsetMode = false;
            }
            break;
        case (0, _constants.PROJECTION_MODE).WEB_MERCATOR_AUTO_OFFSET:
            if (coordinateSystem === (0, _constants.COORDINATE_SYSTEM).LNGLAT) shaderCoordinateOrigin = geospatialOrigin;
            else if (coordinateSystem === (0, _constants.COORDINATE_SYSTEM).CARTESIAN) {
                shaderCoordinateOrigin = [
                    Math.fround(viewport.center[0]),
                    Math.fround(viewport.center[1]),
                    0
                ];
                geospatialOrigin = viewport.unprojectPosition(shaderCoordinateOrigin);
                shaderCoordinateOrigin[0] -= coordinateOrigin[0];
                shaderCoordinateOrigin[1] -= coordinateOrigin[1];
                shaderCoordinateOrigin[2] -= coordinateOrigin[2];
            }
            break;
        case (0, _constants.PROJECTION_MODE).IDENTITY:
            shaderCoordinateOrigin = viewport.position.map(Math.fround);
            shaderCoordinateOrigin[2] = shaderCoordinateOrigin[2] || 0;
            break;
        case (0, _constants.PROJECTION_MODE).GLOBE:
            offsetMode = false;
            geospatialOrigin = null;
            break;
        default:
            offsetMode = false;
    }
    return {
        geospatialOrigin,
        shaderCoordinateOrigin,
        offsetMode
    };
}
function calculateMatrixAndOffset(viewport, coordinateSystem, coordinateOrigin) {
    const { viewMatrixUncentered , projectionMatrix  } = viewport;
    let { viewMatrix , viewProjectionMatrix  } = viewport;
    let projectionCenter = ZERO_VECTOR;
    let originCommon = ZERO_VECTOR;
    let cameraPosCommon = viewport.cameraPosition;
    const { geospatialOrigin , shaderCoordinateOrigin , offsetMode  } = getOffsetOrigin(viewport, coordinateSystem, coordinateOrigin);
    if (offsetMode) {
        originCommon = viewport.projectPosition(geospatialOrigin || shaderCoordinateOrigin);
        cameraPosCommon = [
            cameraPosCommon[0] - originCommon[0],
            cameraPosCommon[1] - originCommon[1],
            cameraPosCommon[2] - originCommon[2]
        ];
        originCommon[3] = 1;
        projectionCenter = _vec4.transformMat4([], originCommon, viewProjectionMatrix);
        viewMatrix = viewMatrixUncentered || viewMatrix;
        viewProjectionMatrix = _mat4.multiply([], projectionMatrix, viewMatrix);
        viewProjectionMatrix = _mat4.multiply([], viewProjectionMatrix, VECTOR_TO_POINT_MATRIX);
    }
    return {
        viewMatrix,
        viewProjectionMatrix,
        projectionCenter,
        originCommon,
        cameraPosCommon,
        shaderCoordinateOrigin,
        geospatialOrigin
    };
}
function getUniformsFromViewport({ viewport , devicePixelRatio =1 , modelMatrix =null , coordinateSystem =(0, _constants.COORDINATE_SYSTEM).DEFAULT , coordinateOrigin =DEFAULT_COORDINATE_ORIGIN , autoWrapLongitude =false  }) {
    if (coordinateSystem === (0, _constants.COORDINATE_SYSTEM).DEFAULT) coordinateSystem = viewport.isGeospatial ? (0, _constants.COORDINATE_SYSTEM).LNGLAT : (0, _constants.COORDINATE_SYSTEM).CARTESIAN;
    const uniforms = getMemoizedViewportUniforms({
        viewport,
        devicePixelRatio,
        coordinateSystem,
        coordinateOrigin
    });
    uniforms.project_uWrapLongitude = autoWrapLongitude;
    uniforms.project_uModelMatrix = modelMatrix || IDENTITY_MATRIX;
    return uniforms;
}
function calculateViewportUniforms({ viewport , devicePixelRatio , coordinateSystem , coordinateOrigin  }) {
    const { projectionCenter , viewProjectionMatrix , originCommon , cameraPosCommon , shaderCoordinateOrigin , geospatialOrigin  } = calculateMatrixAndOffset(viewport, coordinateSystem, coordinateOrigin);
    const distanceScales = viewport.getDistanceScales();
    const viewportSize = [
        viewport.width * devicePixelRatio,
        viewport.height * devicePixelRatio
    ];
    const focalDistance = _vec4.transformMat4([], [
        0,
        0,
        -viewport.focalDistance,
        1
    ], viewport.projectionMatrix)[3] || 1;
    const uniforms = {
        project_uCoordinateSystem: coordinateSystem,
        project_uProjectionMode: viewport.projectionMode,
        project_uCoordinateOrigin: shaderCoordinateOrigin,
        project_uCommonOrigin: originCommon.slice(0, 3),
        project_uCenter: projectionCenter,
        project_uPseudoMeters: Boolean(viewport._pseudoMeters),
        project_uViewportSize: viewportSize,
        project_uDevicePixelRatio: devicePixelRatio,
        project_uFocalDistance: focalDistance,
        project_uCommonUnitsPerMeter: distanceScales.unitsPerMeter,
        project_uCommonUnitsPerWorldUnit: distanceScales.unitsPerMeter,
        project_uCommonUnitsPerWorldUnit2: DEFAULT_PIXELS_PER_UNIT2,
        project_uScale: viewport.scale,
        project_uWrapLongitude: false,
        project_uViewProjectionMatrix: viewProjectionMatrix,
        project_uModelMatrix: IDENTITY_MATRIX,
        project_uCameraPosition: cameraPosCommon
    };
    if (geospatialOrigin) {
        const distanceScalesAtOrigin = viewport.getDistanceScales(geospatialOrigin);
        switch(coordinateSystem){
            case (0, _constants.COORDINATE_SYSTEM).METER_OFFSETS:
                uniforms.project_uCommonUnitsPerWorldUnit = distanceScalesAtOrigin.unitsPerMeter;
                uniforms.project_uCommonUnitsPerWorldUnit2 = distanceScalesAtOrigin.unitsPerMeter2;
                break;
            case (0, _constants.COORDINATE_SYSTEM).LNGLAT:
            case (0, _constants.COORDINATE_SYSTEM).LNGLAT_OFFSETS:
                if (!viewport._pseudoMeters) uniforms.project_uCommonUnitsPerMeter = distanceScalesAtOrigin.unitsPerMeter;
                uniforms.project_uCommonUnitsPerWorldUnit = distanceScalesAtOrigin.unitsPerDegree;
                uniforms.project_uCommonUnitsPerWorldUnit2 = distanceScalesAtOrigin.unitsPerDegree2;
                break;
            case (0, _constants.COORDINATE_SYSTEM).CARTESIAN:
                uniforms.project_uCommonUnitsPerWorldUnit = [
                    1,
                    1,
                    distanceScalesAtOrigin.unitsPerMeter[2]
                ];
                uniforms.project_uCommonUnitsPerWorldUnit2 = [
                    0,
                    0,
                    distanceScalesAtOrigin.unitsPerMeter2[2]
                ];
                break;
            default:
                break;
        }
    }
    return uniforms;
}

},{"gl-matrix/mat4":"eQTXr","gl-matrix/vec4":"lplGD","../../lib/constants":"ksWme","../../utils/memoize":"gjCnZ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gjCnZ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function isEqual(a, b) {
    if (a === b) return true;
    if (Array.isArray(a)) {
        const len = a.length;
        if (!b || b.length !== len) return false;
        for(let i = 0; i < len; i++){
            if (a[i] !== b[i]) return false;
        }
        return true;
    }
    return false;
}
function memoize(compute) {
    let cachedArgs = {};
    let cachedResult;
    return (args)=>{
        for(const key in args)if (!isEqual(args[key], cachedArgs[key])) {
            cachedResult = compute(args);
            cachedArgs = args;
            break;
        }
        return cachedResult;
    };
}
exports.default = memoize;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1FHtp":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _project = require("../project/project");
var _projectDefault = parcelHelpers.interopDefault(_project);
const vs = "\nvec4 project_position_to_clipspace(\n  vec3 position, vec3 position64Low, vec3 offset, out vec4 commonPosition\n) {\n  vec3 projectedPosition = project_position(position, position64Low);\n  mat3 rotation;\n  if (project_needs_rotation(projectedPosition, rotation)) {\n    // offset is specified as ENU\n    // when in globe projection, rotate offset so that the ground alighs with the surface of the globe\n    offset = rotation * offset;\n  }\n  commonPosition = vec4(projectedPosition + offset, 1.0);\n  return project_common_position_to_clipspace(commonPosition);\n}\n\nvec4 project_position_to_clipspace(\n  vec3 position, vec3 position64Low, vec3 offset\n) {\n  vec4 commonPosition;\n  return project_position_to_clipspace(position, position64Low, offset, commonPosition);\n}\n";
exports.default = {
    name: "project32",
    dependencies: [
        (0, _projectDefault.default)
    ],
    vs
};

},{"../project/project":"7sBNM","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3jgej":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _constants = require("../../lib/constants");
var _project = require("../project/project");
var _projectDefault = parcelHelpers.interopDefault(_project);
var _core = require("@math.gl/core");
var _memoize = require("../../utils/memoize");
var _memoizeDefault = parcelHelpers.interopDefault(_memoize);
var _webMercator = require("@math.gl/web-mercator");
const vs = "\nconst int max_lights = 2;\nuniform mat4 shadow_uViewProjectionMatrices[max_lights];\nuniform vec4 shadow_uProjectCenters[max_lights];\nuniform bool shadow_uDrawShadowMap;\nuniform bool shadow_uUseShadowMap;\nuniform int shadow_uLightId;\nuniform float shadow_uLightCount;\n\nvarying vec3 shadow_vPosition[max_lights];\n\nvec4 shadow_setVertexPosition(vec4 position_commonspace) {\n  if (shadow_uDrawShadowMap) {\n    return project_common_position_to_clipspace(position_commonspace, shadow_uViewProjectionMatrices[shadow_uLightId], shadow_uProjectCenters[shadow_uLightId]);\n  }\n  if (shadow_uUseShadowMap) {\n    for (int i = 0; i < max_lights; i++) {\n      if(i < int(shadow_uLightCount)) {\n        vec4 shadowMap_position = project_common_position_to_clipspace(position_commonspace, shadow_uViewProjectionMatrices[i], shadow_uProjectCenters[i]);\n        shadow_vPosition[i] = (shadowMap_position.xyz / shadowMap_position.w + 1.0) / 2.0;\n      }\n    }\n  }\n  return gl_Position;\n}\n";
const fs = "\nconst int max_lights = 2;\nuniform bool shadow_uDrawShadowMap;\nuniform bool shadow_uUseShadowMap;\nuniform sampler2D shadow_uShadowMap0;\nuniform sampler2D shadow_uShadowMap1;\nuniform vec4 shadow_uColor;\nuniform float shadow_uLightCount;\n\nvarying vec3 shadow_vPosition[max_lights];\n\nconst vec4 bitPackShift = vec4(1.0, 255.0, 65025.0, 16581375.0);\nconst vec4 bitUnpackShift = 1.0 / bitPackShift;\nconst vec4 bitMask = vec4(1.0 / 255.0, 1.0 / 255.0, 1.0 / 255.0,  0.0);\n\nfloat shadow_getShadowWeight(vec3 position, sampler2D shadowMap) {\n  vec4 rgbaDepth = texture2D(shadowMap, position.xy);\n\n  float z = dot(rgbaDepth, bitUnpackShift);\n  return smoothstep(0.001, 0.01, position.z - z);\n}\n\nvec4 shadow_filterShadowColor(vec4 color) {\n  if (shadow_uDrawShadowMap) {\n    vec4 rgbaDepth = fract(gl_FragCoord.z * bitPackShift);\n    rgbaDepth -= rgbaDepth.gbaa * bitMask;\n    return rgbaDepth;\n  }\n  if (shadow_uUseShadowMap) {\n    float shadowAlpha = 0.0;\n    shadowAlpha += shadow_getShadowWeight(shadow_vPosition[0], shadow_uShadowMap0);\n    if(shadow_uLightCount > 1.0) {\n      shadowAlpha += shadow_getShadowWeight(shadow_vPosition[1], shadow_uShadowMap1);\n    }\n    shadowAlpha *= shadow_uColor.a / shadow_uLightCount;\n    float blendedAlpha = shadowAlpha + color.a * (1.0 - shadowAlpha);\n\n    return vec4(\n      mix(color.rgb, shadow_uColor.rgb, shadowAlpha / blendedAlpha),\n      blendedAlpha\n    );\n  }\n  return color;\n}\n";
const getMemoizedViewportCenterPosition = (0, _memoizeDefault.default)(getViewportCenterPosition);
const getMemoizedViewProjectionMatrices = (0, _memoizeDefault.default)(getViewProjectionMatrices);
const DEFAULT_SHADOW_COLOR = [
    0,
    0,
    0,
    1.0
];
const VECTOR_TO_POINT_MATRIX = [
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    1,
    0,
    0,
    0,
    0,
    0
];
function screenToCommonSpace(xyz, pixelUnprojectionMatrix) {
    const [x, y, z] = xyz;
    const coord = (0, _webMercator.pixelsToWorld)([
        x,
        y,
        z
    ], pixelUnprojectionMatrix);
    if (Number.isFinite(z)) return coord;
    return [
        coord[0],
        coord[1],
        0
    ];
}
function getViewportCenterPosition({ viewport , center  }) {
    return new (0, _core.Matrix4)(viewport.viewProjectionMatrix).invert().transform(center);
}
function getViewProjectionMatrices({ viewport , shadowMatrices  }) {
    const projectionMatrices = [];
    const pixelUnprojectionMatrix = viewport.pixelUnprojectionMatrix;
    const farZ = viewport.isGeospatial ? undefined : 1;
    const corners = [
        [
            0,
            0,
            farZ
        ],
        [
            viewport.width,
            0,
            farZ
        ],
        [
            0,
            viewport.height,
            farZ
        ],
        [
            viewport.width,
            viewport.height,
            farZ
        ],
        [
            0,
            0,
            -1
        ],
        [
            viewport.width,
            0,
            -1
        ],
        [
            0,
            viewport.height,
            -1
        ],
        [
            viewport.width,
            viewport.height,
            -1
        ]
    ].map((pixel)=>screenToCommonSpace(pixel, pixelUnprojectionMatrix));
    for (const shadowMatrix of shadowMatrices){
        const viewMatrix = shadowMatrix.clone().translate(new (0, _core.Vector3)(viewport.center).negate());
        const positions = corners.map((corner)=>viewMatrix.transform(corner));
        const projectionMatrix = new (0, _core.Matrix4)().ortho({
            left: Math.min(...positions.map((position)=>position[0])),
            right: Math.max(...positions.map((position)=>position[0])),
            bottom: Math.min(...positions.map((position)=>position[1])),
            top: Math.max(...positions.map((position)=>position[1])),
            near: Math.min(...positions.map((position)=>-position[2])),
            far: Math.max(...positions.map((position)=>-position[2]))
        });
        projectionMatrices.push(projectionMatrix.multiplyRight(shadowMatrix));
    }
    return projectionMatrices;
}
function createShadowUniforms(opts, context) {
    const { shadowEnabled =true  } = opts;
    if (!shadowEnabled || !opts.shadowMatrices || !opts.shadowMatrices.length) return {
        shadow_uDrawShadowMap: false,
        shadow_uUseShadowMap: false
    };
    const uniforms = {
        shadow_uDrawShadowMap: Boolean(opts.drawToShadowMap),
        shadow_uUseShadowMap: opts.shadowMaps ? opts.shadowMaps.length > 0 : false,
        shadow_uColor: opts.shadowColor || DEFAULT_SHADOW_COLOR,
        shadow_uLightId: opts.shadowLightId || 0,
        shadow_uLightCount: opts.shadowMatrices.length
    };
    const center = getMemoizedViewportCenterPosition({
        viewport: opts.viewport,
        center: context.project_uCenter
    });
    const projectCenters = [];
    const viewProjectionMatrices = getMemoizedViewProjectionMatrices({
        shadowMatrices: opts.shadowMatrices,
        viewport: opts.viewport
    }).slice();
    for(let i = 0; i < opts.shadowMatrices.length; i++){
        const viewProjectionMatrix = viewProjectionMatrices[i];
        const viewProjectionMatrixCentered = viewProjectionMatrix.clone().translate(new (0, _core.Vector3)(opts.viewport.center).negate());
        if (context.project_uCoordinateSystem === (0, _constants.COORDINATE_SYSTEM).LNGLAT && context.project_uProjectionMode === (0, _constants.PROJECTION_MODE).WEB_MERCATOR) {
            viewProjectionMatrices[i] = viewProjectionMatrixCentered;
            projectCenters[i] = center;
        } else {
            viewProjectionMatrices[i] = viewProjectionMatrix.clone().multiplyRight(VECTOR_TO_POINT_MATRIX);
            projectCenters[i] = viewProjectionMatrixCentered.transform(center);
        }
    }
    for(let i1 = 0; i1 < viewProjectionMatrices.length; i1++){
        uniforms["shadow_uViewProjectionMatrices[".concat(i1, "]")] = viewProjectionMatrices[i1];
        uniforms["shadow_uProjectCenters[".concat(i1, "]")] = projectCenters[i1];
        if (opts.shadowMaps && opts.shadowMaps.length > 0) uniforms["shadow_uShadowMap".concat(i1)] = opts.shadowMaps[i1];
        else uniforms["shadow_uShadowMap".concat(i1)] = opts.dummyShadowMap;
    }
    return uniforms;
}
exports.default = {
    name: "shadow",
    dependencies: [
        (0, _projectDefault.default)
    ],
    vs,
    fs,
    inject: {
        "vs:DECKGL_FILTER_GL_POSITION": "\n    position = shadow_setVertexPosition(geometry.position);\n    ",
        "fs:DECKGL_FILTER_COLOR": "\n    color = shadow_filterShadowColor(color);\n    "
    },
    getUniforms: (opts = {}, context = {})=>{
        if ("viewport" in opts && (opts.drawToShadowMap || opts.shadowMaps && opts.shadowMaps.length > 0)) return createShadowUniforms(opts, context);
        return {};
    }
};

},{"../../lib/constants":"ksWme","../project/project":"7sBNM","@math.gl/core":"9lgwD","../../utils/memoize":"gjCnZ","@math.gl/web-mercator":"aEEkN","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aEEkN":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "default", ()=>(0, _webMercatorViewportDefault.default));
parcelHelpers.export(exports, "WebMercatorViewport", ()=>(0, _webMercatorViewportDefault.default));
parcelHelpers.export(exports, "getBounds", ()=>(0, _getBoundsDefault.default));
parcelHelpers.export(exports, "fitBounds", ()=>(0, _fitBoundsDefault.default));
parcelHelpers.export(exports, "normalizeViewportProps", ()=>(0, _normalizeViewportPropsDefault.default));
parcelHelpers.export(exports, "flyToViewport", ()=>(0, _flyToViewportDefault.default));
parcelHelpers.export(exports, "getFlyToDuration", ()=>(0, _flyToViewport.getFlyToDuration));
parcelHelpers.export(exports, "MAX_LATITUDE", ()=>(0, _webMercatorUtils.MAX_LATITUDE));
parcelHelpers.export(exports, "lngLatToWorld", ()=>(0, _webMercatorUtils.lngLatToWorld));
parcelHelpers.export(exports, "worldToLngLat", ()=>(0, _webMercatorUtils.worldToLngLat));
parcelHelpers.export(exports, "worldToPixels", ()=>(0, _webMercatorUtils.worldToPixels));
parcelHelpers.export(exports, "pixelsToWorld", ()=>(0, _webMercatorUtils.pixelsToWorld));
parcelHelpers.export(exports, "zoomToScale", ()=>(0, _webMercatorUtils.zoomToScale));
parcelHelpers.export(exports, "scaleToZoom", ()=>(0, _webMercatorUtils.scaleToZoom));
parcelHelpers.export(exports, "altitudeToFovy", ()=>(0, _webMercatorUtils.altitudeToFovy));
parcelHelpers.export(exports, "fovyToAltitude", ()=>(0, _webMercatorUtils.fovyToAltitude));
parcelHelpers.export(exports, "getMeterZoom", ()=>(0, _webMercatorUtils.getMeterZoom));
parcelHelpers.export(exports, "unitsPerMeter", ()=>(0, _webMercatorUtils.unitsPerMeter));
parcelHelpers.export(exports, "getDistanceScales", ()=>(0, _webMercatorUtils.getDistanceScales));
parcelHelpers.export(exports, "addMetersToLngLat", ()=>(0, _webMercatorUtils.addMetersToLngLat));
parcelHelpers.export(exports, "getViewMatrix", ()=>(0, _webMercatorUtils.getViewMatrix));
parcelHelpers.export(exports, "getProjectionMatrix", ()=>(0, _webMercatorUtils.getProjectionMatrix));
parcelHelpers.export(exports, "getProjectionParameters", ()=>(0, _webMercatorUtils.getProjectionParameters));
var _webMercatorViewport = require("./web-mercator-viewport");
var _webMercatorViewportDefault = parcelHelpers.interopDefault(_webMercatorViewport);
var _getBounds = require("./get-bounds");
var _getBoundsDefault = parcelHelpers.interopDefault(_getBounds);
var _fitBounds = require("./fit-bounds");
var _fitBoundsDefault = parcelHelpers.interopDefault(_fitBounds);
var _normalizeViewportProps = require("./normalize-viewport-props");
var _normalizeViewportPropsDefault = parcelHelpers.interopDefault(_normalizeViewportProps);
var _flyToViewport = require("./fly-to-viewport");
var _flyToViewportDefault = parcelHelpers.interopDefault(_flyToViewport);
var _webMercatorUtils = require("./web-mercator-utils");

},{"./web-mercator-viewport":"64T8I","./get-bounds":"3K9nD","./fit-bounds":"jx01L","./normalize-viewport-props":"3HcDa","./fly-to-viewport":"bjaYg","./web-mercator-utils":"7TbET","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"64T8I":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _mathUtils = require("./math-utils");
var _webMercatorUtils = require("./web-mercator-utils");
var _fitBounds = require("./fit-bounds");
var _fitBoundsDefault = parcelHelpers.interopDefault(_fitBounds);
var _getBounds = require("./get-bounds");
var _getBoundsDefault = parcelHelpers.interopDefault(_getBounds);
var _mat4 = require("gl-matrix/mat4");
var _vec2 = require("gl-matrix/vec2");
var _vec3 = require("gl-matrix/vec3");
class WebMercatorViewport {
    constructor(props = {
        width: 1,
        height: 1
    }){
        (0, _definePropertyDefault.default)(this, "latitude", void 0);
        (0, _definePropertyDefault.default)(this, "longitude", void 0);
        (0, _definePropertyDefault.default)(this, "zoom", void 0);
        (0, _definePropertyDefault.default)(this, "pitch", void 0);
        (0, _definePropertyDefault.default)(this, "bearing", void 0);
        (0, _definePropertyDefault.default)(this, "altitude", void 0);
        (0, _definePropertyDefault.default)(this, "fovy", void 0);
        (0, _definePropertyDefault.default)(this, "meterOffset", void 0);
        (0, _definePropertyDefault.default)(this, "center", void 0);
        (0, _definePropertyDefault.default)(this, "width", void 0);
        (0, _definePropertyDefault.default)(this, "height", void 0);
        (0, _definePropertyDefault.default)(this, "scale", void 0);
        (0, _definePropertyDefault.default)(this, "distanceScales", void 0);
        (0, _definePropertyDefault.default)(this, "viewMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "projectionMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "viewProjectionMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "pixelProjectionMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "pixelUnprojectionMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "equals", (viewport)=>{
            if (!(viewport instanceof WebMercatorViewport)) return false;
            return viewport.width === this.width && viewport.height === this.height && _mat4.equals(viewport.projectionMatrix, this.projectionMatrix) && _mat4.equals(viewport.viewMatrix, this.viewMatrix);
        });
        (0, _definePropertyDefault.default)(this, "project", (lngLatZ, options = {})=>{
            const { topLeft =true  } = options;
            const worldPosition = this.projectPosition(lngLatZ);
            const coord = (0, _webMercatorUtils.worldToPixels)(worldPosition, this.pixelProjectionMatrix);
            const [x, y] = coord;
            const y2 = topLeft ? y : this.height - y;
            return lngLatZ.length === 2 ? [
                x,
                y2
            ] : [
                x,
                y2,
                coord[2]
            ];
        });
        (0, _definePropertyDefault.default)(this, "unproject", (xyz, options = {})=>{
            const { topLeft =true , targetZ  } = options;
            const [x, y, z] = xyz;
            const y2 = topLeft ? y : this.height - y;
            const targetZWorld = targetZ && targetZ * this.distanceScales.unitsPerMeter[2];
            const coord = (0, _webMercatorUtils.pixelsToWorld)([
                x,
                y2,
                z
            ], this.pixelUnprojectionMatrix, targetZWorld);
            const [X, Y, Z] = this.unprojectPosition(coord);
            if (Number.isFinite(z)) return [
                X,
                Y,
                Z
            ];
            return Number.isFinite(targetZ) ? [
                X,
                Y,
                targetZ
            ] : [
                X,
                Y
            ];
        });
        (0, _definePropertyDefault.default)(this, "projectPosition", (xyz)=>{
            const [X, Y] = (0, _webMercatorUtils.lngLatToWorld)(xyz);
            const Z = (xyz[2] || 0) * this.distanceScales.unitsPerMeter[2];
            return [
                X,
                Y,
                Z
            ];
        });
        (0, _definePropertyDefault.default)(this, "unprojectPosition", (xyz)=>{
            const [X, Y] = (0, _webMercatorUtils.worldToLngLat)(xyz);
            const Z = (xyz[2] || 0) * this.distanceScales.metersPerUnit[2];
            return [
                X,
                Y,
                Z
            ];
        });
        let { width , height , altitude =null , fovy =null  } = props;
        const { latitude =0 , longitude =0 , zoom =0 , pitch =0 , bearing =0 , position =null , nearZMultiplier =0.02 , farZMultiplier =1.01  } = props;
        width = width || 1;
        height = height || 1;
        if (fovy === null && altitude === null) {
            altitude = (0, _webMercatorUtils.DEFAULT_ALTITUDE);
            fovy = (0, _webMercatorUtils.altitudeToFovy)(altitude);
        } else if (fovy === null) fovy = (0, _webMercatorUtils.altitudeToFovy)(altitude);
        else if (altitude === null) altitude = (0, _webMercatorUtils.fovyToAltitude)(fovy);
        const scale = (0, _webMercatorUtils.zoomToScale)(zoom);
        altitude = Math.max(0.75, altitude);
        const distanceScales = (0, _webMercatorUtils.getDistanceScales)({
            longitude,
            latitude
        });
        const center = (0, _webMercatorUtils.lngLatToWorld)([
            longitude,
            latitude
        ]);
        center.push(0);
        if (position) _vec3.add(center, center, _vec3.mul([], position, distanceScales.unitsPerMeter));
        this.projectionMatrix = (0, _webMercatorUtils.getProjectionMatrix)({
            width,
            height,
            scale,
            center,
            pitch,
            fovy,
            nearZMultiplier,
            farZMultiplier
        });
        this.viewMatrix = (0, _webMercatorUtils.getViewMatrix)({
            height,
            scale,
            center,
            pitch,
            bearing,
            altitude
        });
        this.width = width;
        this.height = height;
        this.scale = scale;
        this.latitude = latitude;
        this.longitude = longitude;
        this.zoom = zoom;
        this.pitch = pitch;
        this.bearing = bearing;
        this.altitude = altitude;
        this.fovy = fovy;
        this.center = center;
        this.meterOffset = position || [
            0,
            0,
            0
        ];
        this.distanceScales = distanceScales;
        this._initMatrices();
        Object.freeze(this);
    }
    _initMatrices() {
        const { width , height , projectionMatrix , viewMatrix  } = this;
        const vpm = (0, _mathUtils.createMat4)();
        _mat4.multiply(vpm, vpm, projectionMatrix);
        _mat4.multiply(vpm, vpm, viewMatrix);
        this.viewProjectionMatrix = vpm;
        const m = (0, _mathUtils.createMat4)();
        _mat4.scale(m, m, [
            width / 2,
            -height / 2,
            1
        ]);
        _mat4.translate(m, m, [
            1,
            -1,
            0
        ]);
        _mat4.multiply(m, m, vpm);
        const mInverse = _mat4.invert((0, _mathUtils.createMat4)(), m);
        if (!mInverse) throw new Error("Pixel project matrix not invertible");
        this.pixelProjectionMatrix = m;
        this.pixelUnprojectionMatrix = mInverse;
    }
    projectFlat(lngLat) {
        return (0, _webMercatorUtils.lngLatToWorld)(lngLat);
    }
    unprojectFlat(xy) {
        return (0, _webMercatorUtils.worldToLngLat)(xy);
    }
    getMapCenterByLngLatPosition({ lngLat , pos  }) {
        const fromLocation = (0, _webMercatorUtils.pixelsToWorld)(pos, this.pixelUnprojectionMatrix);
        const toLocation = (0, _webMercatorUtils.lngLatToWorld)(lngLat);
        const translate = _vec2.add([], toLocation, _vec2.negate([], fromLocation));
        const newCenter = _vec2.add([], this.center, translate);
        return (0, _webMercatorUtils.worldToLngLat)(newCenter);
    }
    fitBounds(bounds, options = {}) {
        const { width , height  } = this;
        const { longitude , latitude , zoom  } = (0, _fitBoundsDefault.default)(Object.assign({
            width,
            height,
            bounds
        }, options));
        return new WebMercatorViewport({
            width,
            height,
            longitude,
            latitude,
            zoom
        });
    }
    getBounds(options) {
        const corners = this.getBoundingRegion(options);
        const west = Math.min(...corners.map((p)=>p[0]));
        const east = Math.max(...corners.map((p)=>p[0]));
        const south = Math.min(...corners.map((p)=>p[1]));
        const north = Math.max(...corners.map((p)=>p[1]));
        return [
            [
                west,
                south
            ],
            [
                east,
                north
            ]
        ];
    }
    getBoundingRegion(options = {}) {
        return (0, _getBoundsDefault.default)(this, options.z || 0);
    }
    getLocationAtPoint({ lngLat , pos  }) {
        return this.getMapCenterByLngLatPosition({
            lngLat,
            pos
        });
    }
}
exports.default = WebMercatorViewport;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./math-utils":"h7JDj","./web-mercator-utils":"7TbET","./fit-bounds":"jx01L","./get-bounds":"3K9nD","gl-matrix/mat4":"eQTXr","gl-matrix/vec2":"5mYHR","gl-matrix/vec3":"6mCNm","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"h7JDj":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "createMat4", ()=>createMat4);
parcelHelpers.export(exports, "transformVector", ()=>transformVector);
parcelHelpers.export(exports, "mod", ()=>mod);
parcelHelpers.export(exports, "lerp", ()=>lerp);
parcelHelpers.export(exports, "clamp", ()=>clamp);
parcelHelpers.export(exports, "log2", ()=>log2);
var _vec4 = require("gl-matrix/vec4");
function createMat4() {
    return [
        1,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        1
    ];
}
function transformVector(matrix, vector) {
    const result = (0, _vec4.transformMat4)([], vector, matrix);
    (0, _vec4.scale)(result, result, 1 / result[3]);
    return result;
}
function mod(value, divisor) {
    const modulus = value % divisor;
    return modulus < 0 ? divisor + modulus : modulus;
}
function lerp(start, end, step) {
    return step * end + (1 - step) * start;
}
function clamp(x, min, max) {
    return x < min ? min : x > max ? max : x;
}
function ieLog2(x) {
    return Math.log(x) * Math.LOG2E;
}
const log2 = Math.log2 || ieLog2;

},{"gl-matrix/vec4":"lplGD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7TbET":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "MAX_LATITUDE", ()=>MAX_LATITUDE);
parcelHelpers.export(exports, "DEFAULT_ALTITUDE", ()=>DEFAULT_ALTITUDE);
parcelHelpers.export(exports, "zoomToScale", ()=>zoomToScale);
parcelHelpers.export(exports, "scaleToZoom", ()=>scaleToZoom);
parcelHelpers.export(exports, "lngLatToWorld", ()=>lngLatToWorld);
parcelHelpers.export(exports, "worldToLngLat", ()=>worldToLngLat);
parcelHelpers.export(exports, "getMeterZoom", ()=>getMeterZoom);
parcelHelpers.export(exports, "unitsPerMeter", ()=>unitsPerMeter);
parcelHelpers.export(exports, "getDistanceScales", ()=>getDistanceScales);
parcelHelpers.export(exports, "addMetersToLngLat", ()=>addMetersToLngLat);
parcelHelpers.export(exports, "getViewMatrix", ()=>getViewMatrix);
parcelHelpers.export(exports, "getProjectionParameters", ()=>getProjectionParameters);
parcelHelpers.export(exports, "getProjectionMatrix", ()=>getProjectionMatrix);
parcelHelpers.export(exports, "altitudeToFovy", ()=>altitudeToFovy);
parcelHelpers.export(exports, "fovyToAltitude", ()=>fovyToAltitude);
parcelHelpers.export(exports, "worldToPixels", ()=>worldToPixels);
parcelHelpers.export(exports, "pixelsToWorld", ()=>pixelsToWorld);
var _mathUtils = require("./math-utils");
var _mat4 = require("gl-matrix/mat4");
var _vec2 = require("gl-matrix/vec2");
var _vec3 = require("gl-matrix/vec3");
var _assert = require("./assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
const PI = Math.PI;
const PI_4 = PI / 4;
const DEGREES_TO_RADIANS = PI / 180;
const RADIANS_TO_DEGREES = 180 / PI;
const TILE_SIZE = 512;
const EARTH_CIRCUMFERENCE = 40.03e6;
const MAX_LATITUDE = 85.051129;
const DEFAULT_ALTITUDE = 1.5;
function zoomToScale(zoom) {
    return Math.pow(2, zoom);
}
function scaleToZoom(scale) {
    return (0, _mathUtils.log2)(scale);
}
function lngLatToWorld(lngLat) {
    const [lng, lat] = lngLat;
    (0, _assertDefault.default)(Number.isFinite(lng));
    (0, _assertDefault.default)(Number.isFinite(lat) && lat >= -90 && lat <= 90, "invalid latitude");
    const lambda2 = lng * DEGREES_TO_RADIANS;
    const phi2 = lat * DEGREES_TO_RADIANS;
    const x = TILE_SIZE * (lambda2 + PI) / (2 * PI);
    const y = TILE_SIZE * (PI + Math.log(Math.tan(PI_4 + phi2 * 0.5))) / (2 * PI);
    return [
        x,
        y
    ];
}
function worldToLngLat(xy) {
    const [x, y] = xy;
    const lambda2 = x / TILE_SIZE * (2 * PI) - PI;
    const phi2 = 2 * (Math.atan(Math.exp(y / TILE_SIZE * (2 * PI) - PI)) - PI_4);
    return [
        lambda2 * RADIANS_TO_DEGREES,
        phi2 * RADIANS_TO_DEGREES
    ];
}
function getMeterZoom(options) {
    const { latitude  } = options;
    (0, _assertDefault.default)(Number.isFinite(latitude));
    const latCosine = Math.cos(latitude * DEGREES_TO_RADIANS);
    return scaleToZoom(EARTH_CIRCUMFERENCE * latCosine) - 9;
}
function unitsPerMeter(latitude) {
    const latCosine = Math.cos(latitude * DEGREES_TO_RADIANS);
    return TILE_SIZE / EARTH_CIRCUMFERENCE / latCosine;
}
function getDistanceScales(options) {
    const { latitude , longitude , highPrecision =false  } = options;
    (0, _assertDefault.default)(Number.isFinite(latitude) && Number.isFinite(longitude));
    const worldSize = TILE_SIZE;
    const latCosine = Math.cos(latitude * DEGREES_TO_RADIANS);
    const unitsPerDegreeX = worldSize / 360;
    const unitsPerDegreeY = unitsPerDegreeX / latCosine;
    const altUnitsPerMeter = worldSize / EARTH_CIRCUMFERENCE / latCosine;
    const result = {
        unitsPerMeter: [
            altUnitsPerMeter,
            altUnitsPerMeter,
            altUnitsPerMeter
        ],
        metersPerUnit: [
            1 / altUnitsPerMeter,
            1 / altUnitsPerMeter,
            1 / altUnitsPerMeter
        ],
        unitsPerDegree: [
            unitsPerDegreeX,
            unitsPerDegreeY,
            altUnitsPerMeter
        ],
        degreesPerUnit: [
            1 / unitsPerDegreeX,
            1 / unitsPerDegreeY,
            1 / altUnitsPerMeter
        ]
    };
    if (highPrecision) {
        const latCosine2 = DEGREES_TO_RADIANS * Math.tan(latitude * DEGREES_TO_RADIANS) / latCosine;
        const unitsPerDegreeY2 = unitsPerDegreeX * latCosine2 / 2;
        const altUnitsPerDegree2 = worldSize / EARTH_CIRCUMFERENCE * latCosine2;
        const altUnitsPerMeter2 = altUnitsPerDegree2 / unitsPerDegreeY * altUnitsPerMeter;
        result.unitsPerDegree2 = [
            0,
            unitsPerDegreeY2,
            altUnitsPerDegree2
        ];
        result.unitsPerMeter2 = [
            altUnitsPerMeter2,
            0,
            altUnitsPerMeter2
        ];
    }
    return result;
}
function addMetersToLngLat(lngLatZ, xyz) {
    const [longitude, latitude, z0] = lngLatZ;
    const [x, y, z] = xyz;
    const { unitsPerMeter , unitsPerMeter2  } = getDistanceScales({
        longitude,
        latitude,
        highPrecision: true
    });
    const worldspace = lngLatToWorld(lngLatZ);
    worldspace[0] += x * (unitsPerMeter[0] + unitsPerMeter2[0] * y);
    worldspace[1] += y * (unitsPerMeter[1] + unitsPerMeter2[1] * y);
    const newLngLat = worldToLngLat(worldspace);
    const newZ = (z0 || 0) + (z || 0);
    return Number.isFinite(z0) || Number.isFinite(z) ? [
        newLngLat[0],
        newLngLat[1],
        newZ
    ] : newLngLat;
}
function getViewMatrix(options) {
    const { height , pitch , bearing , altitude , scale , center  } = options;
    const vm = (0, _mathUtils.createMat4)();
    _mat4.translate(vm, vm, [
        0,
        0,
        -altitude
    ]);
    _mat4.rotateX(vm, vm, -pitch * DEGREES_TO_RADIANS);
    _mat4.rotateZ(vm, vm, bearing * DEGREES_TO_RADIANS);
    const relativeScale = scale / height;
    _mat4.scale(vm, vm, [
        relativeScale,
        relativeScale,
        relativeScale
    ]);
    if (center) _mat4.translate(vm, vm, _vec3.negate([], center));
    return vm;
}
function getProjectionParameters(options) {
    const { width , height , altitude , pitch =0 , offset , center , scale , nearZMultiplier =1 , farZMultiplier =1  } = options;
    let { fovy =altitudeToFovy(DEFAULT_ALTITUDE)  } = options;
    if (altitude !== undefined) fovy = altitudeToFovy(altitude);
    const fovRadians = fovy * DEGREES_TO_RADIANS;
    const pitchRadians = pitch * DEGREES_TO_RADIANS;
    const focalDistance = fovyToAltitude(fovy);
    let cameraToSeaLevelDistance = focalDistance;
    if (center) cameraToSeaLevelDistance += center[2] * scale / Math.cos(pitchRadians) / height;
    const fovAboveCenter = fovRadians * (0.5 + (offset ? offset[1] : 0) / height);
    const topHalfSurfaceDistance = Math.sin(fovAboveCenter) * cameraToSeaLevelDistance / Math.sin((0, _mathUtils.clamp)(Math.PI / 2 - pitchRadians - fovAboveCenter, 0.01, Math.PI - 0.01));
    const furthestDistance = Math.sin(pitchRadians) * topHalfSurfaceDistance + cameraToSeaLevelDistance;
    const horizonDistance = cameraToSeaLevelDistance * 10;
    const farZ = Math.min(furthestDistance * farZMultiplier, horizonDistance);
    return {
        fov: fovRadians,
        aspect: width / height,
        focalDistance,
        near: nearZMultiplier,
        far: farZ
    };
}
function getProjectionMatrix(options) {
    const { fov , aspect , near , far  } = getProjectionParameters(options);
    const projectionMatrix = _mat4.perspective([], fov, aspect, near, far);
    return projectionMatrix;
}
function altitudeToFovy(altitude) {
    return 2 * Math.atan(0.5 / altitude) * RADIANS_TO_DEGREES;
}
function fovyToAltitude(fovy) {
    return 0.5 / Math.tan(0.5 * fovy * DEGREES_TO_RADIANS);
}
function worldToPixels(xyz, pixelProjectionMatrix) {
    const [x, y, z = 0] = xyz;
    (0, _assertDefault.default)(Number.isFinite(x) && Number.isFinite(y) && Number.isFinite(z));
    return (0, _mathUtils.transformVector)(pixelProjectionMatrix, [
        x,
        y,
        z,
        1
    ]);
}
function pixelsToWorld(xyz, pixelUnprojectionMatrix, targetZ = 0) {
    const [x, y, z] = xyz;
    (0, _assertDefault.default)(Number.isFinite(x) && Number.isFinite(y), "invalid pixel coordinate");
    if (Number.isFinite(z)) {
        const coord = (0, _mathUtils.transformVector)(pixelUnprojectionMatrix, [
            x,
            y,
            z,
            1
        ]);
        return coord;
    }
    const coord0 = (0, _mathUtils.transformVector)(pixelUnprojectionMatrix, [
        x,
        y,
        0,
        1
    ]);
    const coord1 = (0, _mathUtils.transformVector)(pixelUnprojectionMatrix, [
        x,
        y,
        1,
        1
    ]);
    const z0 = coord0[2];
    const z1 = coord1[2];
    const t = z0 === z1 ? 0 : ((targetZ || 0) - z0) / (z1 - z0);
    return _vec2.lerp([], coord0, coord1, t);
}

},{"./math-utils":"h7JDj","gl-matrix/mat4":"eQTXr","gl-matrix/vec2":"5mYHR","gl-matrix/vec3":"6mCNm","./assert":"22IhD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"22IhD":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function assert(condition, message) {
    if (!condition) throw new Error(message || "@math.gl/web-mercator: assertion failed.");
}
exports.default = assert;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jx01L":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _assert = require("./assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _mathUtils = require("./math-utils");
var _webMercatorUtils = require("./web-mercator-utils");
function fitBounds(options) {
    const { width , height , bounds , minExtent =0 , maxZoom =24 , offset =[
        0,
        0
    ]  } = options;
    const [[west, south], [east, north]] = bounds;
    const padding = getPaddingObject(options.padding);
    const nw = (0, _webMercatorUtils.lngLatToWorld)([
        west,
        (0, _mathUtils.clamp)(north, -(0, _webMercatorUtils.MAX_LATITUDE), (0, _webMercatorUtils.MAX_LATITUDE))
    ]);
    const se = (0, _webMercatorUtils.lngLatToWorld)([
        east,
        (0, _mathUtils.clamp)(south, -(0, _webMercatorUtils.MAX_LATITUDE), (0, _webMercatorUtils.MAX_LATITUDE))
    ]);
    const size = [
        Math.max(Math.abs(se[0] - nw[0]), minExtent),
        Math.max(Math.abs(se[1] - nw[1]), minExtent)
    ];
    const targetSize = [
        width - padding.left - padding.right - Math.abs(offset[0]) * 2,
        height - padding.top - padding.bottom - Math.abs(offset[1]) * 2
    ];
    (0, _assertDefault.default)(targetSize[0] > 0 && targetSize[1] > 0);
    const scaleX = targetSize[0] / size[0];
    const scaleY = targetSize[1] / size[1];
    const offsetX = (padding.right - padding.left) / 2 / scaleX;
    const offsetY = (padding.top - padding.bottom) / 2 / scaleY;
    const center = [
        (se[0] + nw[0]) / 2 + offsetX,
        (se[1] + nw[1]) / 2 + offsetY
    ];
    const centerLngLat = (0, _webMercatorUtils.worldToLngLat)(center);
    const zoom = Math.min(maxZoom, (0, _mathUtils.log2)(Math.abs(Math.min(scaleX, scaleY))));
    (0, _assertDefault.default)(Number.isFinite(zoom));
    return {
        longitude: centerLngLat[0],
        latitude: centerLngLat[1],
        zoom
    };
}
exports.default = fitBounds;
function getPaddingObject(padding = 0) {
    if (typeof padding === "number") return {
        top: padding,
        bottom: padding,
        left: padding,
        right: padding
    };
    (0, _assertDefault.default)(Number.isFinite(padding.top) && Number.isFinite(padding.bottom) && Number.isFinite(padding.left) && Number.isFinite(padding.right));
    return padding;
}

},{"./assert":"22IhD","./math-utils":"h7JDj","./web-mercator-utils":"7TbET","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3K9nD":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _webMercatorUtils = require("./web-mercator-utils");
var _vec2 = require("gl-matrix/vec2");
var _mathUtils = require("./math-utils");
const DEGREES_TO_RADIANS = Math.PI / 180;
function getBounds(viewport, z = 0) {
    const { width , height , unproject  } = viewport;
    const unprojectOps = {
        targetZ: z
    };
    const bottomLeft = unproject([
        0,
        height
    ], unprojectOps);
    const bottomRight = unproject([
        width,
        height
    ], unprojectOps);
    let topLeft;
    let topRight;
    const halfFov = viewport.fovy ? 0.5 * viewport.fovy * DEGREES_TO_RADIANS : Math.atan(0.5 / viewport.altitude);
    const angleToGround = (90 - viewport.pitch) * DEGREES_TO_RADIANS;
    if (halfFov > angleToGround - 0.01) {
        topLeft = unprojectOnFarPlane(viewport, 0, z);
        topRight = unprojectOnFarPlane(viewport, width, z);
    } else {
        topLeft = unproject([
            0,
            0
        ], unprojectOps);
        topRight = unproject([
            width,
            0
        ], unprojectOps);
    }
    return [
        bottomLeft,
        bottomRight,
        topRight,
        topLeft
    ];
}
exports.default = getBounds;
function unprojectOnFarPlane(viewport, x, targetZ) {
    const { pixelUnprojectionMatrix  } = viewport;
    const coord0 = (0, _mathUtils.transformVector)(pixelUnprojectionMatrix, [
        x,
        0,
        1,
        1
    ]);
    const coord1 = (0, _mathUtils.transformVector)(pixelUnprojectionMatrix, [
        x,
        viewport.height,
        1,
        1
    ]);
    const z = targetZ * viewport.distanceScales.unitsPerMeter[2];
    const t = (z - coord0[2]) / (coord1[2] - coord0[2]);
    const coord = _vec2.lerp([], coord0, coord1, t);
    const result = (0, _webMercatorUtils.worldToLngLat)(coord);
    result.push(targetZ);
    return result;
}

},{"./web-mercator-utils":"7TbET","gl-matrix/vec2":"5mYHR","./math-utils":"h7JDj","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3HcDa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _webMercatorUtils = require("./web-mercator-utils");
var _mathUtils = require("./math-utils");
const TILE_SIZE = 512;
function normalizeViewportProps(props) {
    const { width , height , pitch =0  } = props;
    let { longitude , latitude , zoom , bearing =0  } = props;
    if (longitude < -180 || longitude > 180) longitude = (0, _mathUtils.mod)(longitude + 180, 360) - 180;
    if (bearing < -180 || bearing > 180) bearing = (0, _mathUtils.mod)(bearing + 180, 360) - 180;
    const minZoom = (0, _mathUtils.log2)(height / TILE_SIZE);
    if (zoom <= minZoom) {
        zoom = minZoom;
        latitude = 0;
    } else {
        const halfHeightPixels = height / 2 / Math.pow(2, zoom);
        const minLatitude = (0, _webMercatorUtils.worldToLngLat)([
            0,
            halfHeightPixels
        ])[1];
        if (latitude < minLatitude) latitude = minLatitude;
        else {
            const maxLatitude = (0, _webMercatorUtils.worldToLngLat)([
                0,
                TILE_SIZE - halfHeightPixels
            ])[1];
            if (latitude > maxLatitude) latitude = maxLatitude;
        }
    }
    return {
        width,
        height,
        longitude,
        latitude,
        zoom,
        pitch,
        bearing
    };
}
exports.default = normalizeViewportProps;

},{"./web-mercator-utils":"7TbET","./math-utils":"h7JDj","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bjaYg":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getFlyToDuration", ()=>getFlyToDuration);
var _mathUtils = require("./math-utils");
var _webMercatorUtils = require("./web-mercator-utils");
var _vec2 = require("gl-matrix/vec2");
const EPSILON = 0.01;
const VIEWPORT_TRANSITION_PROPS = [
    "longitude",
    "latitude",
    "zoom"
];
const DEFAULT_OPTS = {
    curve: 1.414,
    speed: 1.2
};
function flyToViewport(startProps, endProps, t, options) {
    const { startZoom , startCenterXY , uDelta , w0 , u1 , S , rho , rho2 , r0  } = getFlyToTransitionParams(startProps, endProps, options);
    if (u1 < EPSILON) {
        const viewport = {};
        for (const key of VIEWPORT_TRANSITION_PROPS){
            const startValue = startProps[key];
            const endValue = endProps[key];
            viewport[key] = (0, _mathUtils.lerp)(startValue, endValue, t);
        }
        return viewport;
    }
    const s = t * S;
    const w = Math.cosh(r0) / Math.cosh(r0 + rho * s);
    const u = w0 * ((Math.cosh(r0) * Math.tanh(r0 + rho * s) - Math.sinh(r0)) / rho2) / u1;
    const scaleIncrement = 1 / w;
    const newZoom = startZoom + (0, _webMercatorUtils.scaleToZoom)(scaleIncrement);
    const newCenterWorld = _vec2.scale([], uDelta, u);
    _vec2.add(newCenterWorld, newCenterWorld, startCenterXY);
    const newCenter = (0, _webMercatorUtils.worldToLngLat)(newCenterWorld);
    return {
        longitude: newCenter[0],
        latitude: newCenter[1],
        zoom: newZoom
    };
}
exports.default = flyToViewport;
function getFlyToDuration(startProps, endProps, options) {
    const opts = {
        ...DEFAULT_OPTS,
        ...options
    };
    const { screenSpeed , speed , maxDuration  } = opts;
    const { S , rho  } = getFlyToTransitionParams(startProps, endProps, opts);
    const length = 1000 * S;
    let duration;
    if (Number.isFinite(screenSpeed)) duration = length / (screenSpeed / rho);
    else duration = length / speed;
    return Number.isFinite(maxDuration) && duration > maxDuration ? 0 : duration;
}
function getFlyToTransitionParams(startProps, endProps, opts) {
    opts = Object.assign({}, DEFAULT_OPTS, opts);
    const rho = opts.curve;
    const startZoom = startProps.zoom;
    const startCenter = [
        startProps.longitude,
        startProps.latitude
    ];
    const startScale = (0, _webMercatorUtils.zoomToScale)(startZoom);
    const endZoom = endProps.zoom;
    const endCenter = [
        endProps.longitude,
        endProps.latitude
    ];
    const scale = (0, _webMercatorUtils.zoomToScale)(endZoom - startZoom);
    const startCenterXY = (0, _webMercatorUtils.lngLatToWorld)(startCenter);
    const endCenterXY = (0, _webMercatorUtils.lngLatToWorld)(endCenter);
    const uDelta = _vec2.sub([], endCenterXY, startCenterXY);
    const w0 = Math.max(startProps.width, startProps.height);
    const w1 = w0 / scale;
    const u1 = _vec2.length(uDelta) * startScale;
    const _u1 = Math.max(u1, EPSILON);
    const rho2 = rho * rho;
    const b0 = (w1 * w1 - w0 * w0 + rho2 * rho2 * _u1 * _u1) / (2 * w0 * rho2 * _u1);
    const b1 = (w1 * w1 - w0 * w0 - rho2 * rho2 * _u1 * _u1) / (2 * w1 * rho2 * _u1);
    const r0 = Math.log(Math.sqrt(b0 * b0 + 1) - b0);
    const r1 = Math.log(Math.sqrt(b1 * b1 + 1) - b1);
    const S = (r1 - r0) / rho;
    return {
        startZoom,
        startCenterXY,
        uDelta,
        w0,
        u1,
        S,
        rho,
        rho2,
        r0,
        r1
    };
}

},{"./math-utils":"h7JDj","./web-mercator-utils":"7TbET","gl-matrix/vec2":"5mYHR","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1yRfV":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _core = require("@luma.gl/core");
exports.default = {
    inject: {
        "vs:DECKGL_FILTER_GL_POSITION": "\n    // for picking depth values\n    picking_setPickingAttribute(position.z / position.w);\n  ",
        "vs:DECKGL_FILTER_COLOR": "\n  picking_setPickingColor(geometry.pickingColor);\n  ",
        "fs:DECKGL_FILTER_COLOR": {
            order: 99,
            injection: "\n  // use highlight color if this fragment belongs to the selected object.\n  color = picking_filterHighlightColor(color);\n\n  // use picking color if rendering to picking FBO.\n  color = picking_filterPickingColor(color);\n    "
        }
    },
    ...(0, _core.picking)
};

},{"@luma.gl/core":"9yA57","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3N8o6":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _ambientLight = require("./ambient-light");
var _directionalLight = require("./directional-light");
var _core1 = require("@math.gl/core");
var _shadowPass = require("../../passes/shadow-pass");
var _shadowPassDefault = parcelHelpers.interopDefault(_shadowPass);
var _shadow = require("../../shaderlib/shadow/shadow");
var _shadowDefault = parcelHelpers.interopDefault(_shadow);
const DEFAULT_AMBIENT_LIGHT_PROPS = {
    color: [
        255,
        255,
        255
    ],
    intensity: 1.0
};
const DEFAULT_DIRECTIONAL_LIGHT_PROPS = [
    {
        color: [
            255,
            255,
            255
        ],
        intensity: 1.0,
        direction: [
            -1,
            3,
            -1
        ]
    },
    {
        color: [
            255,
            255,
            255
        ],
        intensity: 0.9,
        direction: [
            1,
            -8,
            -2.5
        ]
    }
];
const DEFAULT_SHADOW_COLOR = [
    0,
    0,
    0,
    200 / 255
];
class LightingEffect {
    constructor(props = {}){
        (0, _definePropertyDefault.default)(this, "id", "lighting-effect");
        (0, _definePropertyDefault.default)(this, "props", null);
        (0, _definePropertyDefault.default)(this, "shadowColor", DEFAULT_SHADOW_COLOR);
        (0, _definePropertyDefault.default)(this, "shadow", void 0);
        (0, _definePropertyDefault.default)(this, "ambientLight", null);
        (0, _definePropertyDefault.default)(this, "directionalLights", []);
        (0, _definePropertyDefault.default)(this, "pointLights", []);
        (0, _definePropertyDefault.default)(this, "shadowPasses", []);
        (0, _definePropertyDefault.default)(this, "shadowMaps", []);
        (0, _definePropertyDefault.default)(this, "dummyShadowMap", null);
        (0, _definePropertyDefault.default)(this, "programManager", void 0);
        (0, _definePropertyDefault.default)(this, "shadowMatrices", void 0);
        for(const key in props){
            const lightSource = props[key];
            switch(lightSource.type){
                case "ambient":
                    this.ambientLight = lightSource;
                    break;
                case "directional":
                    this.directionalLights.push(lightSource);
                    break;
                case "point":
                    this.pointLights.push(lightSource);
                    break;
                default:
            }
        }
        this._applyDefaultLights();
        this.shadow = this.directionalLights.some((light)=>light.shadow);
    }
    preRender(gl, { layers , layerFilter , viewports , onViewportActive , views  }) {
        if (!this.shadow) return;
        this.shadowMatrices = this._calculateMatrices();
        if (this.shadowPasses.length === 0) this._createShadowPasses(gl);
        if (!this.programManager) {
            this.programManager = (0, _core.ProgramManager).getDefaultProgramManager(gl);
            if (0, _shadowDefault.default) this.programManager.addDefaultModule((0, _shadowDefault.default));
        }
        if (!this.dummyShadowMap) this.dummyShadowMap = new (0, _core.Texture2D)(gl, {
            width: 1,
            height: 1
        });
        for(let i = 0; i < this.shadowPasses.length; i++){
            const shadowPass = this.shadowPasses[i];
            shadowPass.render({
                layers,
                layerFilter,
                viewports,
                onViewportActive,
                views,
                moduleParameters: {
                    shadowLightId: i,
                    dummyShadowMap: this.dummyShadowMap,
                    shadowMatrices: this.shadowMatrices
                }
            });
        }
    }
    getModuleParameters(layer) {
        const parameters = this.shadow ? {
            shadowMaps: this.shadowMaps,
            dummyShadowMap: this.dummyShadowMap,
            shadowColor: this.shadowColor,
            shadowMatrices: this.shadowMatrices
        } : {};
        parameters.lightSources = {
            ambientLight: this.ambientLight,
            directionalLights: this.directionalLights.map((directionalLight)=>directionalLight.getProjectedLight({
                    layer
                })),
            pointLights: this.pointLights.map((pointLight)=>pointLight.getProjectedLight({
                    layer
                }))
        };
        return parameters;
    }
    cleanup() {
        for (const shadowPass of this.shadowPasses)shadowPass.delete();
        this.shadowPasses.length = 0;
        this.shadowMaps.length = 0;
        if (this.dummyShadowMap) {
            this.dummyShadowMap.delete();
            this.dummyShadowMap = null;
        }
        if (this.shadow && this.programManager) {
            this.programManager.removeDefaultModule((0, _shadowDefault.default));
            this.programManager = null;
        }
    }
    _calculateMatrices() {
        const lightMatrices = [];
        for (const light of this.directionalLights){
            const viewMatrix = new (0, _core1.Matrix4)().lookAt({
                eye: new (0, _core1.Vector3)(light.direction).negate()
            });
            lightMatrices.push(viewMatrix);
        }
        return lightMatrices;
    }
    _createShadowPasses(gl) {
        for(let i = 0; i < this.directionalLights.length; i++){
            const shadowPass = new (0, _shadowPassDefault.default)(gl);
            this.shadowPasses[i] = shadowPass;
            this.shadowMaps[i] = shadowPass.shadowMap;
        }
    }
    _applyDefaultLights() {
        const { ambientLight , pointLights , directionalLights  } = this;
        if (!ambientLight && pointLights.length === 0 && directionalLights.length === 0) {
            this.ambientLight = new (0, _ambientLight.AmbientLight)(DEFAULT_AMBIENT_LIGHT_PROPS);
            this.directionalLights.push(new (0, _directionalLight.DirectionalLight)(DEFAULT_DIRECTIONAL_LIGHT_PROPS[0]), new (0, _directionalLight.DirectionalLight)(DEFAULT_DIRECTIONAL_LIGHT_PROPS[1]));
        }
    }
}
exports.default = LightingEffect;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","./ambient-light":"a1sv0","./directional-light":"jlZGq","@math.gl/core":"9lgwD","../../passes/shadow-pass":"eiXwU","../../shaderlib/shadow/shadow":"3jgej","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"a1sv0":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "AmbientLight", ()=>AmbientLight);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
const DEFAULT_LIGHT_COLOR = [
    255,
    255,
    255
];
const DEFAULT_LIGHT_INTENSITY = 1.0;
let idCount = 0;
class AmbientLight {
    constructor(props = {}){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "color", void 0);
        (0, _definePropertyDefault.default)(this, "intensity", void 0);
        (0, _definePropertyDefault.default)(this, "type", "ambient");
        const { color =DEFAULT_LIGHT_COLOR  } = props;
        const { intensity =DEFAULT_LIGHT_INTENSITY  } = props;
        this.id = props.id || "ambient-".concat(idCount++);
        this.color = color;
        this.intensity = intensity;
    }
}

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jlZGq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "DirectionalLight", ()=>DirectionalLight);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@math.gl/core");
const DEFAULT_LIGHT_COLOR = [
    255,
    255,
    255
];
const DEFAULT_LIGHT_INTENSITY = 1.0;
const DEFAULT_LIGHT_DIRECTION = [
    0.0,
    0.0,
    -1
];
let idCount = 0;
class DirectionalLight {
    constructor(props = {}){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "color", void 0);
        (0, _definePropertyDefault.default)(this, "intensity", void 0);
        (0, _definePropertyDefault.default)(this, "type", "directional");
        (0, _definePropertyDefault.default)(this, "direction", void 0);
        (0, _definePropertyDefault.default)(this, "shadow", void 0);
        const { color =DEFAULT_LIGHT_COLOR  } = props;
        const { intensity =DEFAULT_LIGHT_INTENSITY  } = props;
        const { direction =DEFAULT_LIGHT_DIRECTION  } = props;
        const { _shadow =false  } = props;
        this.id = props.id || "directional-".concat(idCount++);
        this.color = color;
        this.intensity = intensity;
        this.type = "directional";
        this.direction = new (0, _core.Vector3)(direction).normalize().toArray();
        this.shadow = _shadow;
    }
    getProjectedLight(opts) {
        return this;
    }
}

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@math.gl/core":"9lgwD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"eiXwU":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _layersPass = require("./layers-pass");
var _layersPassDefault = parcelHelpers.interopDefault(_layersPass);
var _core = require("@luma.gl/core");
class ShadowPass extends (0, _layersPassDefault.default) {
    constructor(gl, props){
        super(gl, props);
        (0, _definePropertyDefault.default)(this, "shadowMap", void 0);
        (0, _definePropertyDefault.default)(this, "depthBuffer", void 0);
        (0, _definePropertyDefault.default)(this, "fbo", void 0);
        this.shadowMap = new (0, _core.Texture2D)(gl, {
            width: 1,
            height: 1,
            parameters: {
                [10241]: 9729,
                [10240]: 9729,
                [10242]: 33071,
                [10243]: 33071
            }
        });
        this.depthBuffer = new (0, _core.Renderbuffer)(gl, {
            format: 33189,
            width: 1,
            height: 1
        });
        this.fbo = new (0, _core.Framebuffer)(gl, {
            id: "shadowmap",
            width: 1,
            height: 1,
            attachments: {
                [36064]: this.shadowMap,
                [36096]: this.depthBuffer
            }
        });
    }
    render(params) {
        const target = this.fbo;
        (0, _core.withParameters)(this.gl, {
            depthRange: [
                0,
                1
            ],
            depthTest: true,
            blend: false,
            clearColor: [
                1,
                1,
                1,
                1
            ]
        }, ()=>{
            const viewport = params.viewports[0];
            const pixelRatio = (0, _core.cssToDeviceRatio)(this.gl);
            const width = viewport.width * pixelRatio;
            const height = viewport.height * pixelRatio;
            if (width !== target.width || height !== target.height) target.resize({
                width,
                height
            });
            super.render({
                ...params,
                target,
                pass: "shadow"
            });
        });
    }
    shouldDrawLayer(layer) {
        return layer.props.shadowEnabled !== false;
    }
    getModuleParameters() {
        return {
            drawToShadowMap: true
        };
    }
    delete() {
        if (this.fbo) {
            this.fbo.delete();
            this.fbo = null;
        }
        if (this.shadowMap) {
            this.shadowMap.delete();
            this.shadowMap = null;
        }
        if (this.depthBuffer) {
            this.depthBuffer.delete();
            this.depthBuffer = null;
        }
    }
}
exports.default = ShadowPass;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./layers-pass":"bsyAy","@luma.gl/core":"9yA57","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bsyAy":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "layerIndexResolver", ()=>layerIndexResolver);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _pass = require("./pass");
var _passDefault = parcelHelpers.interopDefault(_pass);
var _core = require("@luma.gl/core");
class LayersPass extends (0, _passDefault.default) {
    constructor(...args){
        super(...args);
        (0, _definePropertyDefault.default)(this, "_lastRenderIndex", -1);
    }
    render(options) {
        const gl = this.gl;
        (0, _core.setParameters)(gl, {
            framebuffer: options.target
        });
        return this._drawLayers(options);
    }
    _drawLayers(options) {
        const { target , moduleParameters , viewports , views , onViewportActive , clearStack =true , clearCanvas =true  } = options;
        options.pass = options.pass || "unknown";
        const gl = this.gl;
        if (clearCanvas) clearGLCanvas(gl);
        if (clearStack) this._lastRenderIndex = -1;
        const renderStats = [];
        for (const viewport of viewports){
            const view = views && views[viewport.id];
            onViewportActive(viewport);
            const drawLayerParams = this._getDrawLayerParams(viewport, options);
            const subViewports = viewport.subViewports || [
                viewport
            ];
            for (const subViewport of subViewports){
                const stats = this._drawLayersInViewport(gl, {
                    target,
                    moduleParameters,
                    viewport: subViewport,
                    view,
                    pass: options.pass,
                    layers: options.layers
                }, drawLayerParams);
                renderStats.push(stats);
            }
        }
        return renderStats;
    }
    _getDrawLayerParams(viewport, { layers , pass , layerFilter , cullRect , effects , moduleParameters  }) {
        const drawLayerParams = [];
        const indexResolver = layerIndexResolver(this._lastRenderIndex + 1);
        const drawContext = {
            layer: layers[0],
            viewport,
            isPicking: pass.startsWith("picking"),
            renderPass: pass,
            cullRect
        };
        const layerFilterCache = {};
        for(let layerIndex = 0; layerIndex < layers.length; layerIndex++){
            const layer = layers[layerIndex];
            const shouldDrawLayer = this._shouldDrawLayer(layer, drawContext, layerFilter, layerFilterCache);
            const layerParam = {
                shouldDrawLayer
            };
            if (shouldDrawLayer) {
                layerParam.layerRenderIndex = indexResolver(layer, shouldDrawLayer);
                layerParam.moduleParameters = this._getModuleParameters(layer, effects, pass, moduleParameters);
                layerParam.layerParameters = this.getLayerParameters(layer, layerIndex, viewport);
            }
            drawLayerParams[layerIndex] = layerParam;
        }
        return drawLayerParams;
    }
    _drawLayersInViewport(gl, { layers , moduleParameters: globalModuleParameters , pass , target , viewport , view  }, drawLayerParams) {
        const glViewport = getGLViewport(gl, {
            moduleParameters: globalModuleParameters,
            target,
            viewport
        });
        if (view && view.props.clear) {
            const clearOpts = view.props.clear === true ? {
                color: true,
                depth: true
            } : view.props.clear;
            (0, _core.withParameters)(gl, {
                scissorTest: true,
                scissor: glViewport
            }, ()=>(0, _core.clear)(gl, clearOpts));
        }
        const renderStatus = {
            totalCount: layers.length,
            visibleCount: 0,
            compositeCount: 0,
            pickableCount: 0
        };
        (0, _core.setParameters)(gl, {
            viewport: glViewport
        });
        for(let layerIndex = 0; layerIndex < layers.length; layerIndex++){
            const layer = layers[layerIndex];
            const { shouldDrawLayer , layerRenderIndex , moduleParameters , layerParameters  } = drawLayerParams[layerIndex];
            if (shouldDrawLayer && layer.props.pickable) renderStatus.pickableCount++;
            if (layer.isComposite) renderStatus.compositeCount++;
            else if (shouldDrawLayer) {
                renderStatus.visibleCount++;
                this._lastRenderIndex = Math.max(this._lastRenderIndex, layerRenderIndex);
                moduleParameters.viewport = viewport;
                try {
                    layer._drawLayer({
                        moduleParameters,
                        uniforms: {
                            layerIndex: layerRenderIndex
                        },
                        parameters: layerParameters
                    });
                } catch (err) {
                    layer.raiseError(err, "drawing ".concat(layer, " to ").concat(pass));
                }
            }
        }
        return renderStatus;
    }
    shouldDrawLayer(layer) {
        return true;
    }
    getModuleParameters(layer, effects) {
        return null;
    }
    getLayerParameters(layer, layerIndex, viewport) {
        return layer.props.parameters;
    }
    _shouldDrawLayer(layer, drawContext, layerFilter, layerFilterCache) {
        const shouldDrawLayer = layer.props.visible && this.shouldDrawLayer(layer);
        if (!shouldDrawLayer) return false;
        drawContext.layer = layer;
        let parent = layer.parent;
        while(parent){
            if (!parent.props.visible || !parent.filterSubLayer(drawContext)) return false;
            drawContext.layer = parent;
            parent = parent.parent;
        }
        if (layerFilter) {
            const rootLayerId = drawContext.layer.id;
            if (!(rootLayerId in layerFilterCache)) layerFilterCache[rootLayerId] = layerFilter(drawContext);
            if (!layerFilterCache[rootLayerId]) return false;
        }
        layer.activateViewport(drawContext.viewport);
        return true;
    }
    _getModuleParameters(layer, effects, pass, overrides) {
        var _layer$internalState;
        const moduleParameters = Object.assign(Object.create(((_layer$internalState = layer.internalState) === null || _layer$internalState === void 0 ? void 0 : _layer$internalState.propsInTransition) || layer.props), {
            autoWrapLongitude: layer.wrapLongitude,
            viewport: layer.context.viewport,
            mousePosition: layer.context.mousePosition,
            pickingActive: 0,
            devicePixelRatio: (0, _core.cssToDeviceRatio)(this.gl)
        });
        if (effects) for (const effect of effects){
            var _effect$getModulePara;
            Object.assign(moduleParameters, (_effect$getModulePara = effect.getModuleParameters) === null || _effect$getModulePara === void 0 ? void 0 : _effect$getModulePara.call(effect, layer));
        }
        return Object.assign(moduleParameters, this.getModuleParameters(layer, effects), overrides);
    }
}
exports.default = LayersPass;
function layerIndexResolver(startIndex = 0, layerIndices = {}) {
    const resolvers = {};
    const resolveLayerIndex = (layer, isDrawn)=>{
        const indexOverride = layer.props._offset;
        const layerId = layer.id;
        const parentId = layer.parent && layer.parent.id;
        let index;
        if (parentId && !(parentId in layerIndices)) resolveLayerIndex(layer.parent, false);
        if (parentId in resolvers) {
            const resolver = resolvers[parentId] = resolvers[parentId] || layerIndexResolver(layerIndices[parentId], layerIndices);
            index = resolver(layer, isDrawn);
            resolvers[layerId] = resolver;
        } else if (Number.isFinite(indexOverride)) {
            index = indexOverride + (layerIndices[parentId] || 0);
            resolvers[layerId] = null;
        } else index = startIndex;
        if (isDrawn && index >= startIndex) startIndex = index + 1;
        layerIndices[layerId] = index;
        return index;
    };
    return resolveLayerIndex;
}
function getGLViewport(gl, { moduleParameters , target , viewport  }) {
    const useTarget = target && target.id !== "default-framebuffer";
    const pixelRatio = moduleParameters && moduleParameters.devicePixelRatio || (0, _core.cssToDeviceRatio)(gl);
    const height = useTarget ? target.height : gl.drawingBufferHeight;
    const dimensions = viewport;
    return [
        dimensions.x * pixelRatio,
        height - (dimensions.y + dimensions.height) * pixelRatio,
        dimensions.width * pixelRatio,
        dimensions.height * pixelRatio
    ];
}
function clearGLCanvas(gl) {
    const width = gl.drawingBufferWidth;
    const height = gl.drawingBufferHeight;
    (0, _core.setParameters)(gl, {
        viewport: [
            0,
            0,
            width,
            height
        ]
    });
    gl.clear(16640);
}

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./pass":"4nD1h","@luma.gl/core":"9yA57","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4nD1h":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
class Pass {
    constructor(gl, props = {
        id: "pass"
    }){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "gl", void 0);
        (0, _definePropertyDefault.default)(this, "props", void 0);
        const { id  } = props;
        this.id = id;
        this.gl = gl;
        this.props = {
            ...props
        };
    }
    setProps(props) {
        Object.assign(this.props, props);
    }
    render(params) {}
    cleanup() {}
}
exports.default = Pass;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"hGHXX":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _layerManager = require("./layer-manager");
var _layerManagerDefault = parcelHelpers.interopDefault(_layerManager);
var _viewManager = require("./view-manager");
var _viewManagerDefault = parcelHelpers.interopDefault(_viewManager);
var _mapView = require("../views/map-view");
var _mapViewDefault = parcelHelpers.interopDefault(_mapView);
var _effectManager = require("./effect-manager");
var _effectManagerDefault = parcelHelpers.interopDefault(_effectManager);
var _deckRenderer = require("./deck-renderer");
var _deckRendererDefault = parcelHelpers.interopDefault(_deckRenderer);
var _deckPicker = require("./deck-picker");
var _deckPickerDefault = parcelHelpers.interopDefault(_deckPicker);
var _tooltip = require("./tooltip");
var _tooltipDefault = parcelHelpers.interopDefault(_tooltip);
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _deepEqual = require("../utils/deep-equal");
var _typedArrayManager = require("../utils/typed-array-manager");
var _typedArrayManagerDefault = parcelHelpers.interopDefault(_typedArrayManager);
var _init = require("./init");
var _initDefault = parcelHelpers.interopDefault(_init);
var _env = require("@probe.gl/env");
var _core = require("@luma.gl/core");
var _stats = require("@probe.gl/stats");
var _mjolnirJs = require("mjolnir.js");
var _assert = require("../utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _constants = require("./constants");
function noop() {}
const getCursor = ({ isDragging  })=>isDragging ? "grabbing" : "grab";
const defaultProps = {
    id: "",
    width: "100%",
    height: "100%",
    style: null,
    viewState: null,
    initialViewState: null,
    pickingRadius: 0,
    layerFilter: null,
    glOptions: {},
    parameters: {},
    parent: null,
    gl: null,
    canvas: null,
    layers: [],
    effects: [],
    views: null,
    controller: null,
    useDevicePixels: true,
    touchAction: "none",
    eventRecognizerOptions: {},
    _framebuffer: null,
    _animate: false,
    _pickable: true,
    _typedArrayManagerProps: {},
    _customRender: null,
    onWebGLInitialized: noop,
    onResize: noop,
    onViewStateChange: noop,
    onInteractionStateChange: noop,
    onBeforeRender: noop,
    onAfterRender: noop,
    onLoad: noop,
    onError: (error)=>(0, _logDefault.default).error(error.message)(),
    onHover: null,
    onClick: null,
    onDragStart: null,
    onDrag: null,
    onDragEnd: null,
    _onMetrics: null,
    getCursor,
    getTooltip: null,
    debug: false,
    drawPickingColors: false
};
class Deck {
    constructor(props){
        (0, _definePropertyDefault.default)(this, "props", void 0);
        (0, _definePropertyDefault.default)(this, "width", 0);
        (0, _definePropertyDefault.default)(this, "height", 0);
        (0, _definePropertyDefault.default)(this, "userData", {});
        (0, _definePropertyDefault.default)(this, "canvas", null);
        (0, _definePropertyDefault.default)(this, "viewManager", null);
        (0, _definePropertyDefault.default)(this, "layerManager", null);
        (0, _definePropertyDefault.default)(this, "effectManager", null);
        (0, _definePropertyDefault.default)(this, "deckRenderer", null);
        (0, _definePropertyDefault.default)(this, "deckPicker", null);
        (0, _definePropertyDefault.default)(this, "eventManager", null);
        (0, _definePropertyDefault.default)(this, "tooltip", null);
        (0, _definePropertyDefault.default)(this, "metrics", void 0);
        (0, _definePropertyDefault.default)(this, "animationLoop", void 0);
        (0, _definePropertyDefault.default)(this, "stats", void 0);
        (0, _definePropertyDefault.default)(this, "viewState", void 0);
        (0, _definePropertyDefault.default)(this, "cursorState", void 0);
        (0, _definePropertyDefault.default)(this, "_needsRedraw", void 0);
        (0, _definePropertyDefault.default)(this, "_pickRequest", void 0);
        (0, _definePropertyDefault.default)(this, "_lastPointerDownInfo", null);
        (0, _definePropertyDefault.default)(this, "_metricsCounter", void 0);
        (0, _definePropertyDefault.default)(this, "_onPointerMove", (event)=>{
            const { _pickRequest  } = this;
            if (event.type === "pointerleave") {
                _pickRequest.x = -1;
                _pickRequest.y = -1;
                _pickRequest.radius = 0;
            } else if (event.leftButton || event.rightButton) return;
            else {
                const pos = event.offsetCenter;
                if (!pos) return;
                _pickRequest.x = pos.x;
                _pickRequest.y = pos.y;
                _pickRequest.radius = this.props.pickingRadius;
            }
            if (this.layerManager) this.layerManager.context.mousePosition = {
                x: _pickRequest.x,
                y: _pickRequest.y
            };
            _pickRequest.event = event;
        });
        (0, _definePropertyDefault.default)(this, "_onEvent", (event)=>{
            const eventOptions = (0, _constants.EVENTS)[event.type];
            const pos = event.offsetCenter;
            if (!eventOptions || !pos || !this.layerManager) return;
            const layers = this.layerManager.getLayers();
            const info = this.deckPicker.getLastPickedObject({
                x: pos.x,
                y: pos.y,
                layers,
                viewports: this.getViewports(pos)
            }, this._lastPointerDownInfo);
            const { layer  } = info;
            const layerHandler = layer && (layer[eventOptions.handler] || layer.props[eventOptions.handler]);
            const rootHandler = this.props[eventOptions.handler];
            let handled = false;
            if (layerHandler) handled = layerHandler.call(layer, info, event);
            if (!handled && rootHandler) rootHandler(info, event);
        });
        (0, _definePropertyDefault.default)(this, "_onPointerDown", (event)=>{
            const pos = event.offsetCenter;
            const pickedInfo = this._pick("pickObject", "pickObject Time", {
                x: pos.x,
                y: pos.y,
                radius: this.props.pickingRadius
            });
            this._lastPointerDownInfo = pickedInfo.result[0] || pickedInfo.emptyInfo;
        });
        this.props = {
            ...defaultProps,
            ...props
        };
        props = this.props;
        this._needsRedraw = "Initial render";
        this._pickRequest = {
            mode: "hover",
            x: -1,
            y: -1,
            radius: 0,
            event: null
        };
        this.cursorState = {
            isHovering: false,
            isDragging: false
        };
        if (props.viewState && props.initialViewState) (0, _logDefault.default).warn("View state tracking is disabled. Use either `initialViewState` for auto update or `viewState` for manual update.")();
        if ((0, _env.getBrowser)() === "IE") (0, _logDefault.default).warn("IE 11 is not supported")();
        this.viewState = props.initialViewState;
        if (!props.gl) {
            if (typeof document !== "undefined") this.canvas = this._createCanvas(props);
        }
        this.animationLoop = this._createAnimationLoop(props);
        this.stats = new (0, _stats.Stats)({
            id: "deck.gl"
        });
        this.metrics = {
            fps: 0,
            setPropsTime: 0,
            updateAttributesTime: 0,
            framesRedrawn: 0,
            pickTime: 0,
            pickCount: 0,
            gpuTime: 0,
            gpuTimePerFrame: 0,
            cpuTime: 0,
            cpuTimePerFrame: 0,
            bufferMemory: 0,
            textureMemory: 0,
            renderbufferMemory: 0,
            gpuMemory: 0
        };
        this._metricsCounter = 0;
        this.setProps(props);
        if (props._typedArrayManagerProps) (0, _typedArrayManagerDefault.default).setOptions(props._typedArrayManagerProps);
        this.animationLoop.start();
    }
    finalize() {
        var _this$layerManager, _this$viewManager, _this$effectManager, _this$deckRenderer, _this$deckPicker, _this$eventManager, _this$tooltip;
        this.animationLoop.stop();
        this.animationLoop = null;
        this._lastPointerDownInfo = null;
        (_this$layerManager = this.layerManager) === null || _this$layerManager === void 0 || _this$layerManager.finalize();
        this.layerManager = null;
        (_this$viewManager = this.viewManager) === null || _this$viewManager === void 0 || _this$viewManager.finalize();
        this.viewManager = null;
        (_this$effectManager = this.effectManager) === null || _this$effectManager === void 0 || _this$effectManager.finalize();
        this.effectManager = null;
        (_this$deckRenderer = this.deckRenderer) === null || _this$deckRenderer === void 0 || _this$deckRenderer.finalize();
        this.deckRenderer = null;
        (_this$deckPicker = this.deckPicker) === null || _this$deckPicker === void 0 || _this$deckPicker.finalize();
        this.deckPicker = null;
        (_this$eventManager = this.eventManager) === null || _this$eventManager === void 0 || _this$eventManager.destroy();
        this.eventManager = null;
        (_this$tooltip = this.tooltip) === null || _this$tooltip === void 0 || _this$tooltip.remove();
        this.tooltip = null;
        if (!this.props.canvas && !this.props.gl && this.canvas) {
            var _this$canvas$parentEl;
            (_this$canvas$parentEl = this.canvas.parentElement) === null || _this$canvas$parentEl === void 0 || _this$canvas$parentEl.removeChild(this.canvas);
            this.canvas = null;
        }
    }
    setProps(props) {
        this.stats.get("setProps Time").timeStart();
        if ("onLayerHover" in props) (0, _logDefault.default).removed("onLayerHover", "onHover")();
        if ("onLayerClick" in props) (0, _logDefault.default).removed("onLayerClick", "onClick")();
        if (props.initialViewState && !(0, _deepEqual.deepEqual)(this.props.initialViewState, props.initialViewState)) this.viewState = props.initialViewState;
        Object.assign(this.props, props);
        this._setCanvasSize(this.props);
        const resolvedProps = Object.create(this.props);
        Object.assign(resolvedProps, {
            views: this._getViews(),
            width: this.width,
            height: this.height,
            viewState: this._getViewState()
        });
        this.animationLoop.setProps(resolvedProps);
        if (this.layerManager) {
            this.viewManager.setProps(resolvedProps);
            this.layerManager.activateViewport(this.getViewports()[0]);
            this.layerManager.setProps(resolvedProps);
            this.effectManager.setProps(resolvedProps);
            this.deckRenderer.setProps(resolvedProps);
            this.deckPicker.setProps(resolvedProps);
        }
        this.stats.get("setProps Time").timeEnd();
    }
    needsRedraw(opts = {
        clearRedrawFlags: false
    }) {
        if (!this.layerManager) return false;
        if (this.props._animate) return "Deck._animate";
        let redraw = this._needsRedraw;
        if (opts.clearRedrawFlags) this._needsRedraw = false;
        const viewManagerNeedsRedraw = this.viewManager.needsRedraw(opts);
        const layerManagerNeedsRedraw = this.layerManager.needsRedraw(opts);
        const effectManagerNeedsRedraw = this.effectManager.needsRedraw(opts);
        const deckRendererNeedsRedraw = this.deckRenderer.needsRedraw(opts);
        redraw = redraw || viewManagerNeedsRedraw || layerManagerNeedsRedraw || effectManagerNeedsRedraw || deckRendererNeedsRedraw;
        return redraw;
    }
    redraw(reason) {
        if (!this.layerManager) return;
        let redrawReason = this.needsRedraw({
            clearRedrawFlags: true
        });
        redrawReason = reason || redrawReason;
        if (!redrawReason) return;
        this.stats.get("Redraw Count").incrementCount();
        if (this.props._customRender) this.props._customRender(redrawReason);
        else this._drawLayers(redrawReason);
    }
    get isInitialized() {
        return this.viewManager !== null;
    }
    getViews() {
        (0, _assertDefault.default)(this.viewManager);
        return this.viewManager.views;
    }
    getViewports(rect) {
        (0, _assertDefault.default)(this.viewManager);
        return this.viewManager.getViewports(rect);
    }
    pickObject(opts) {
        const infos = this._pick("pickObject", "pickObject Time", opts).result;
        return infos.length ? infos[0] : null;
    }
    pickMultipleObjects(opts) {
        opts.depth = opts.depth || 10;
        return this._pick("pickObject", "pickMultipleObjects Time", opts).result;
    }
    pickObjects(opts) {
        return this._pick("pickObjects", "pickObjects Time", opts);
    }
    _addResources(resources, forceUpdate = false) {
        for(const id in resources)this.layerManager.resourceManager.add({
            resourceId: id,
            data: resources[id],
            forceUpdate
        });
    }
    _removeResources(resourceIds) {
        for (const id of resourceIds)this.layerManager.resourceManager.remove(id);
    }
    _pick(method, statKey, opts) {
        (0, _assertDefault.default)(this.deckPicker);
        const { stats  } = this;
        stats.get("Pick Count").incrementCount();
        stats.get(statKey).timeStart();
        const infos = this.deckPicker[method]({
            layers: this.layerManager.getLayers(opts),
            views: this.viewManager.getViews(),
            viewports: this.getViewports(opts),
            onViewportActive: this.layerManager.activateViewport,
            effects: this.effectManager.getEffects(),
            ...opts
        });
        stats.get(statKey).timeEnd();
        return infos;
    }
    _createCanvas(props) {
        let canvas = props.canvas;
        if (typeof canvas === "string") {
            canvas = document.getElementById(canvas);
            (0, _assertDefault.default)(canvas);
        }
        if (!canvas) {
            canvas = document.createElement("canvas");
            canvas.id = props.id || "deckgl-overlay";
            const parent = props.parent || document.body;
            parent.appendChild(canvas);
        }
        Object.assign(canvas.style, props.style);
        return canvas;
    }
    _setCanvasSize(props) {
        if (!this.canvas) return;
        const { width , height  } = props;
        if (width || width === 0) {
            const cssWidth = Number.isFinite(width) ? "".concat(width, "px") : width;
            this.canvas.style.width = cssWidth;
        }
        if (height || height === 0) {
            var _props$style;
            const cssHeight = Number.isFinite(height) ? "".concat(height, "px") : height;
            this.canvas.style.position = ((_props$style = props.style) === null || _props$style === void 0 ? void 0 : _props$style.position) || "absolute";
            this.canvas.style.height = cssHeight;
        }
    }
    _updateCanvasSize() {
        const { canvas  } = this;
        if (!canvas) return;
        const newWidth = canvas.clientWidth || canvas.width;
        const newHeight = canvas.clientHeight || canvas.height;
        if (newWidth !== this.width || newHeight !== this.height) {
            var _this$viewManager2;
            this.width = newWidth;
            this.height = newHeight;
            (_this$viewManager2 = this.viewManager) === null || _this$viewManager2 === void 0 || _this$viewManager2.setProps({
                width: newWidth,
                height: newHeight
            });
            this.props.onResize({
                width: newWidth,
                height: newHeight
            });
        }
    }
    _createAnimationLoop(props) {
        const { width , height , gl , glOptions , debug , onError , onBeforeRender , onAfterRender , useDevicePixels  } = props;
        return new (0, _core.AnimationLoop)({
            width,
            height,
            useDevicePixels,
            autoResizeViewport: false,
            gl,
            onCreateContext: (opts)=>(0, _core.createGLContext)({
                    ...glOptions,
                    ...opts,
                    canvas: this.canvas,
                    debug,
                    onContextLost: ()=>this._onContextLost()
                }),
            onInitialize: (context)=>this._setGLContext(context.gl),
            onRender: this._onRenderFrame.bind(this),
            onBeforeRender,
            onAfterRender,
            onError
        });
    }
    _getViewState() {
        return this.props.viewState || this.viewState;
    }
    _getViews() {
        let views = this.props.views || [
            new (0, _mapViewDefault.default)({
                id: "default-view"
            })
        ];
        views = Array.isArray(views) ? views : [
            views
        ];
        if (views.length && this.props.controller) views[0].props.controller = this.props.controller;
        return views;
    }
    _onContextLost() {
        const { onError  } = this.props;
        if (this.animationLoop && onError) onError(new Error("WebGL context is lost"));
    }
    _pickAndCallback() {
        const { _pickRequest  } = this;
        if (_pickRequest.event) {
            const { result , emptyInfo  } = this._pick("pickObject", "pickObject Time", _pickRequest);
            this.cursorState.isHovering = result.length > 0;
            let pickedInfo = emptyInfo;
            let handled = false;
            for (const info of result){
                var _info$layer;
                pickedInfo = info;
                handled = ((_info$layer = info.layer) === null || _info$layer === void 0 ? void 0 : _info$layer.onHover(info, _pickRequest.event)) || handled;
            }
            if (!handled && this.props.onHover) this.props.onHover(pickedInfo, _pickRequest.event);
            if (this.props.getTooltip && this.tooltip) {
                const displayInfo = this.props.getTooltip(pickedInfo);
                this.tooltip.setTooltip(displayInfo, pickedInfo.x, pickedInfo.y);
            }
            _pickRequest.event = null;
        }
    }
    _updateCursor() {
        const container = this.props.parent || this.canvas;
        if (container) container.style.cursor = this.props.getCursor(this.cursorState);
    }
    _setGLContext(gl) {
        if (this.layerManager) return;
        if (!this.canvas) {
            this.canvas = gl.canvas;
            (0, _core.instrumentGLContext)(gl, {
                enable: true,
                copyState: true
            });
        }
        this.tooltip = new (0, _tooltipDefault.default)(this.canvas);
        (0, _core.setParameters)(gl, {
            blend: true,
            blendFunc: [
                770,
                771,
                1,
                771
            ],
            polygonOffsetFill: true,
            depthTest: true,
            depthFunc: 515
        });
        this.props.onWebGLInitialized(gl);
        const timeline = new (0, _core.Timeline)();
        timeline.play();
        this.animationLoop.attachTimeline(timeline);
        this.eventManager = new (0, _mjolnirJs.EventManager)(this.props.parent || gl.canvas, {
            touchAction: this.props.touchAction,
            recognizerOptions: this.props.eventRecognizerOptions,
            events: {
                pointerdown: this._onPointerDown,
                pointermove: this._onPointerMove,
                pointerleave: this._onPointerMove
            }
        });
        for(const eventType in 0, _constants.EVENTS)this.eventManager.on(eventType, this._onEvent);
        this.viewManager = new (0, _viewManagerDefault.default)({
            timeline,
            eventManager: this.eventManager,
            onViewStateChange: this._onViewStateChange.bind(this),
            onInteractionStateChange: this._onInteractionStateChange.bind(this),
            views: this._getViews(),
            viewState: this._getViewState(),
            width: this.width,
            height: this.height
        });
        const viewport = this.viewManager.getViewports()[0];
        this.layerManager = new (0, _layerManagerDefault.default)(gl, {
            deck: this,
            stats: this.stats,
            viewport,
            timeline
        });
        this.effectManager = new (0, _effectManagerDefault.default)();
        this.deckRenderer = new (0, _deckRendererDefault.default)(gl);
        this.deckPicker = new (0, _deckPickerDefault.default)(gl);
        this.setProps(this.props);
        this._updateCanvasSize();
        this.props.onLoad();
    }
    _drawLayers(redrawReason, renderOptions) {
        const { gl  } = this.layerManager.context;
        (0, _core.setParameters)(gl, this.props.parameters);
        this.props.onBeforeRender({
            gl
        });
        this.deckRenderer.renderLayers({
            target: this.props._framebuffer,
            layers: this.layerManager.getLayers(),
            viewports: this.viewManager.getViewports(),
            onViewportActive: this.layerManager.activateViewport,
            views: this.viewManager.getViews(),
            pass: "screen",
            redrawReason,
            effects: this.effectManager.getEffects(),
            ...renderOptions
        });
        this.props.onAfterRender({
            gl
        });
    }
    _onRenderFrame(animationProps) {
        this._getFrameStats();
        if (this._metricsCounter++ % 60 === 0) {
            this._getMetrics();
            this.stats.reset();
            (0, _logDefault.default).table(4, this.metrics)();
            if (this.props._onMetrics) this.props._onMetrics(this.metrics);
        }
        this._updateCanvasSize();
        this._updateCursor();
        if (this.tooltip.isVisible && this.viewManager.needsRedraw()) this.tooltip.setTooltip(null);
        this.layerManager.updateLayers();
        this._pickAndCallback();
        this.redraw();
        if (this.viewManager) this.viewManager.updateViewStates();
    }
    _onViewStateChange(params) {
        const viewState = this.props.onViewStateChange(params) || params.viewState;
        if (this.viewState) {
            this.viewState = {
                ...this.viewState,
                [params.viewId]: viewState
            };
            if (!this.props.viewState) {
                if (this.viewManager) this.viewManager.setProps({
                    viewState: this.viewState
                });
            }
        }
    }
    _onInteractionStateChange(interactionState) {
        this.cursorState.isDragging = interactionState.isDragging || false;
        this.props.onInteractionStateChange(interactionState);
    }
    _getFrameStats() {
        const { stats  } = this;
        stats.get("frameRate").timeEnd();
        stats.get("frameRate").timeStart();
        const animationLoopStats = this.animationLoop.stats;
        stats.get("GPU Time").addTime(animationLoopStats.get("GPU Time").lastTiming);
        stats.get("CPU Time").addTime(animationLoopStats.get("CPU Time").lastTiming);
    }
    _getMetrics() {
        const { metrics , stats  } = this;
        metrics.fps = stats.get("frameRate").getHz();
        metrics.setPropsTime = stats.get("setProps Time").time;
        metrics.updateAttributesTime = stats.get("Update Attributes").time;
        metrics.framesRedrawn = stats.get("Redraw Count").count;
        metrics.pickTime = stats.get("pickObject Time").time + stats.get("pickMultipleObjects Time").time + stats.get("pickObjects Time").time;
        metrics.pickCount = stats.get("Pick Count").count;
        metrics.gpuTime = stats.get("GPU Time").time;
        metrics.cpuTime = stats.get("CPU Time").time;
        metrics.gpuTimePerFrame = stats.get("GPU Time").getAverageTime();
        metrics.cpuTimePerFrame = stats.get("CPU Time").getAverageTime();
        const memoryStats = (0, _core.lumaStats).get("Memory Usage");
        metrics.bufferMemory = memoryStats.get("Buffer Memory").count;
        metrics.textureMemory = memoryStats.get("Texture Memory").count;
        metrics.renderbufferMemory = memoryStats.get("Renderbuffer Memory").count;
        metrics.gpuMemory = memoryStats.get("GPU Memory").count;
    }
}
exports.default = Deck;
(0, _definePropertyDefault.default)(Deck, "defaultProps", defaultProps);
(0, _definePropertyDefault.default)(Deck, "VERSION", (0, _initDefault.default).VERSION);

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./layer-manager":"7wYcl","./view-manager":"acsK1","../views/map-view":"aiwwz","./effect-manager":"5qaq3","./deck-renderer":"hXp5w","./deck-picker":"4UHmx","./tooltip":"coUDg","../utils/log":"iINk7","../utils/deep-equal":"cspiV","../utils/typed-array-manager":"kyraM","./init":"2jj5x","@probe.gl/env":"6dzgb","@luma.gl/core":"9yA57","@probe.gl/stats":"krQZu","mjolnir.js":"7FQzD","../utils/assert":"aysGh","./constants":"ksWme","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7wYcl":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _constants = require("../lifecycle/constants");
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _debug = require("../debug");
var _debugDefault = parcelHelpers.interopDefault(_debug);
var _flatten = require("../utils/flatten");
var _stats = require("@probe.gl/stats");
var _resourceManager = require("./resource/resource-manager");
var _resourceManagerDefault = parcelHelpers.interopDefault(_resourceManager);
var _viewport = require("../viewports/viewport");
var _viewportDefault = parcelHelpers.interopDefault(_viewport);
var _shaderlib = require("../shaderlib");
const TRACE_SET_LAYERS = "layerManager.setLayers";
const TRACE_ACTIVATE_VIEWPORT = "layerManager.activateViewport";
class LayerManager {
    constructor(gl, { deck , stats , viewport: _viewport , timeline  } = {}){
        (0, _definePropertyDefault.default)(this, "layers", void 0);
        (0, _definePropertyDefault.default)(this, "context", void 0);
        (0, _definePropertyDefault.default)(this, "resourceManager", void 0);
        (0, _definePropertyDefault.default)(this, "_lastRenderedLayers", []);
        (0, _definePropertyDefault.default)(this, "_needsRedraw", false);
        (0, _definePropertyDefault.default)(this, "_needsUpdate", false);
        (0, _definePropertyDefault.default)(this, "_nextLayers", null);
        (0, _definePropertyDefault.default)(this, "_debug", false);
        (0, _definePropertyDefault.default)(this, "activateViewport", (viewport)=>{
            (0, _debugDefault.default)(TRACE_ACTIVATE_VIEWPORT, this, viewport);
            if (viewport) this.context.viewport = viewport;
        });
        this.layers = [];
        this.resourceManager = new (0, _resourceManagerDefault.default)({
            gl,
            protocol: "deck://"
        });
        this.context = {
            mousePosition: null,
            userData: {},
            layerManager: this,
            gl,
            deck,
            programManager: gl && (0, _shaderlib.createProgramManager)(gl),
            stats: stats || new (0, _stats.Stats)({
                id: "deck.gl"
            }),
            viewport: _viewport || new (0, _viewportDefault.default)({
                id: "DEFAULT-INITIAL-VIEWPORT"
            }),
            timeline: timeline || new (0, _core.Timeline)(),
            resourceManager: this.resourceManager,
            onError: undefined
        };
        Object.seal(this);
    }
    finalize() {
        this.resourceManager.finalize();
        for (const layer of this.layers)this._finalizeLayer(layer);
    }
    needsRedraw(opts = {
        clearRedrawFlags: false
    }) {
        let redraw = this._needsRedraw;
        if (opts.clearRedrawFlags) this._needsRedraw = false;
        for (const layer of this.layers){
            const layerNeedsRedraw = layer.getNeedsRedraw(opts);
            redraw = redraw || layerNeedsRedraw;
        }
        return redraw;
    }
    needsUpdate() {
        if (this._nextLayers && this._nextLayers !== this._lastRenderedLayers) return "layers changed";
        return this._needsUpdate;
    }
    setNeedsRedraw(reason) {
        this._needsRedraw = this._needsRedraw || reason;
    }
    setNeedsUpdate(reason) {
        this._needsUpdate = this._needsUpdate || reason;
    }
    getLayers({ layerIds  } = {}) {
        return layerIds ? this.layers.filter((layer)=>layerIds.find((layerId)=>layer.id.indexOf(layerId) === 0)) : this.layers;
    }
    setProps(props) {
        if ("debug" in props) this._debug = props.debug;
        if ("userData" in props) this.context.userData = props.userData;
        if ("layers" in props) this._nextLayers = props.layers;
        if ("onError" in props) this.context.onError = props.onError;
    }
    setLayers(newLayers, reason) {
        (0, _debugDefault.default)(TRACE_SET_LAYERS, this, reason, newLayers);
        this._lastRenderedLayers = newLayers;
        const flatLayers = (0, _flatten.flatten)(newLayers, Boolean);
        for (const layer of flatLayers)layer.context = this.context;
        this._updateLayers(this.layers, flatLayers);
    }
    updateLayers() {
        const reason = this.needsUpdate();
        if (reason) {
            this.setNeedsRedraw("updating layers: ".concat(reason));
            this.setLayers(this._nextLayers || this._lastRenderedLayers, reason);
        }
        this._nextLayers = null;
    }
    _handleError(stage, error, layer) {
        layer.raiseError(error, "".concat(stage, " of ").concat(layer));
    }
    _updateLayers(oldLayers, newLayers) {
        const oldLayerMap = {};
        for (const oldLayer of oldLayers)if (oldLayerMap[oldLayer.id]) (0, _logDefault.default).warn("Multiple old layers with same id ".concat(oldLayer.id))();
        else oldLayerMap[oldLayer.id] = oldLayer;
        const generatedLayers = [];
        this._updateSublayersRecursively(newLayers, oldLayerMap, generatedLayers);
        this._finalizeOldLayers(oldLayerMap);
        let needsUpdate = false;
        for (const layer of generatedLayers)if (layer.hasUniformTransition()) {
            needsUpdate = "Uniform transition in ".concat(layer);
            break;
        }
        this._needsUpdate = needsUpdate;
        this.layers = generatedLayers;
    }
    _updateSublayersRecursively(newLayers, oldLayerMap, generatedLayers) {
        for (const newLayer of newLayers){
            newLayer.context = this.context;
            const oldLayer = oldLayerMap[newLayer.id];
            if (oldLayer === null) (0, _logDefault.default).warn("Multiple new layers with same id ".concat(newLayer.id))();
            oldLayerMap[newLayer.id] = null;
            let sublayers = null;
            try {
                if (this._debug && oldLayer !== newLayer) newLayer.validateProps();
                if (!oldLayer) this._initializeLayer(newLayer);
                else {
                    this._transferLayerState(oldLayer, newLayer);
                    this._updateLayer(newLayer);
                }
                generatedLayers.push(newLayer);
                sublayers = newLayer.isComposite ? newLayer.getSubLayers() : null;
            } catch (err) {
                this._handleError("matching", err, newLayer);
            }
            if (sublayers) this._updateSublayersRecursively(sublayers, oldLayerMap, generatedLayers);
        }
    }
    _finalizeOldLayers(oldLayerMap) {
        for(const layerId in oldLayerMap){
            const layer = oldLayerMap[layerId];
            if (layer) this._finalizeLayer(layer);
        }
    }
    _initializeLayer(layer) {
        try {
            layer._initialize();
            layer.lifecycle = (0, _constants.LIFECYCLE).INITIALIZED;
        } catch (err) {
            this._handleError("initialization", err, layer);
        }
    }
    _transferLayerState(oldLayer, newLayer) {
        newLayer._transferState(oldLayer);
        newLayer.lifecycle = (0, _constants.LIFECYCLE).MATCHED;
        if (newLayer !== oldLayer) oldLayer.lifecycle = (0, _constants.LIFECYCLE).AWAITING_GC;
    }
    _updateLayer(layer) {
        try {
            layer._update();
        } catch (err) {
            this._handleError("update", err, layer);
        }
    }
    _finalizeLayer(layer) {
        this._needsRedraw = this._needsRedraw || "finalized ".concat(layer);
        layer.lifecycle = (0, _constants.LIFECYCLE).AWAITING_FINALIZATION;
        try {
            layer._finalize();
            layer.lifecycle = (0, _constants.LIFECYCLE).FINALIZED;
        } catch (err) {
            this._handleError("finalization", err, layer);
        }
    }
}
exports.default = LayerManager;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","../lifecycle/constants":"99KhZ","../utils/log":"iINk7","../debug":"e6y6V","../utils/flatten":"bFfhb","@probe.gl/stats":"krQZu","./resource/resource-manager":"ecBlp","../viewports/viewport":"kxGGY","../shaderlib":"dQXUb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"99KhZ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "LIFECYCLE", ()=>LIFECYCLE);
parcelHelpers.export(exports, "COMPONENT_SYMBOL", ()=>COMPONENT_SYMBOL);
parcelHelpers.export(exports, "ASYNC_DEFAULTS_SYMBOL", ()=>ASYNC_DEFAULTS_SYMBOL);
parcelHelpers.export(exports, "ASYNC_ORIGINAL_SYMBOL", ()=>ASYNC_ORIGINAL_SYMBOL);
parcelHelpers.export(exports, "ASYNC_RESOLVED_SYMBOL", ()=>ASYNC_RESOLVED_SYMBOL);
const LIFECYCLE = {
    NO_STATE: "Awaiting state",
    MATCHED: "Matched. State transferred from previous layer",
    INITIALIZED: "Initialized",
    AWAITING_GC: "Discarded. Awaiting garbage collection",
    AWAITING_FINALIZATION: "No longer matched. Awaiting garbage collection",
    FINALIZED: "Finalized! Awaiting garbage collection"
};
const COMPONENT_SYMBOL = Symbol.for("component");
const ASYNC_DEFAULTS_SYMBOL = Symbol.for("asyncPropDefaults");
const ASYNC_ORIGINAL_SYMBOL = Symbol.for("asyncPropOriginal");
const ASYNC_RESOLVED_SYMBOL = Symbol.for("asyncPropResolved");

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bFfhb":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "flatten", ()=>flatten);
parcelHelpers.export(exports, "fillArray", ()=>fillArray);
function flatten(array, filter = ()=>true) {
    if (!Array.isArray(array)) return filter(array) ? [
        array
    ] : [];
    return flattenArray(array, filter, []);
}
function flattenArray(array, filter, result) {
    let index = -1;
    while(++index < array.length){
        const value = array[index];
        if (Array.isArray(value)) flattenArray(value, filter, result);
        else if (filter(value)) result.push(value);
    }
    return result;
}
function fillArray({ target , source , start =0 , count =1  }) {
    const length = source.length;
    const total = count * length;
    let copied = 0;
    for(let i = start; copied < length; copied++)target[i++] = source[copied];
    while(copied < total)if (copied < total - copied) {
        target.copyWithin(start + copied, start, start + copied);
        copied *= 2;
    } else {
        target.copyWithin(start + copied, start, start + total - copied);
        copied = total;
    }
    return target;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ecBlp":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _resource = require("./resource");
var _resourceDefault = parcelHelpers.interopDefault(_resource);
class ResourceManager {
    constructor({ gl , protocol  }){
        (0, _definePropertyDefault.default)(this, "protocol", void 0);
        (0, _definePropertyDefault.default)(this, "_context", void 0);
        (0, _definePropertyDefault.default)(this, "_resources", void 0);
        (0, _definePropertyDefault.default)(this, "_consumers", void 0);
        (0, _definePropertyDefault.default)(this, "_pruneRequest", void 0);
        this.protocol = protocol || "resource://";
        this._context = {
            gl,
            resourceManager: this
        };
        this._resources = {};
        this._consumers = {};
        this._pruneRequest = null;
    }
    contains(resourceId) {
        if (resourceId.startsWith(this.protocol)) return true;
        return resourceId in this._resources;
    }
    add({ resourceId , data , forceUpdate =false , persistent =true  }) {
        let res = this._resources[resourceId];
        if (res) res.setData(data, forceUpdate);
        else {
            res = new (0, _resourceDefault.default)(resourceId, data, this._context);
            this._resources[resourceId] = res;
        }
        res.persistent = persistent;
    }
    remove(resourceId) {
        const res = this._resources[resourceId];
        if (res) {
            res.delete();
            delete this._resources[resourceId];
        }
    }
    unsubscribe({ consumerId  }) {
        const consumer = this._consumers[consumerId];
        if (consumer) {
            for(const requestId in consumer){
                const request = consumer[requestId];
                const resource = this._resources[request.resourceId];
                if (resource) resource.unsubscribe(request);
            }
            delete this._consumers[consumerId];
            this.prune();
        }
    }
    subscribe({ resourceId , onChange , consumerId , requestId ="default"  }) {
        const { _resources: resources , protocol  } = this;
        if (resourceId.startsWith(protocol)) {
            resourceId = resourceId.replace(protocol, "");
            if (!resources[resourceId]) this.add({
                resourceId,
                data: null,
                persistent: false
            });
        }
        const res = resources[resourceId];
        this._track(consumerId, requestId, res, onChange);
        if (res) return res.getData();
        return undefined;
    }
    prune() {
        if (!this._pruneRequest) this._pruneRequest = setTimeout(()=>this._prune(), 0);
    }
    finalize() {
        for(const key in this._resources)this._resources[key].delete();
    }
    _track(consumerId, requestId, resource, onChange) {
        const consumers = this._consumers;
        const consumer = consumers[consumerId] = consumers[consumerId] || {};
        const request = consumer[requestId] || {};
        const oldResource = request.resourceId && this._resources[request.resourceId];
        if (oldResource) {
            oldResource.unsubscribe(request);
            this.prune();
        }
        if (resource) {
            consumer[requestId] = request;
            request.onChange = onChange;
            request.resourceId = resource.id;
            resource.subscribe(request);
        }
    }
    _prune() {
        this._pruneRequest = null;
        for (const key of Object.keys(this._resources)){
            const res = this._resources[key];
            if (!res.persistent && !res.inUse()) {
                res.delete();
                delete this._resources[key];
            }
        }
    }
}
exports.default = ResourceManager;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./resource":"fn7ui","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fn7ui":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@loaders.gl/core");
class Resource {
    constructor(id, data, context){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "context", void 0);
        (0, _definePropertyDefault.default)(this, "isLoaded", void 0);
        (0, _definePropertyDefault.default)(this, "persistent", void 0);
        (0, _definePropertyDefault.default)(this, "_loadCount", 0);
        (0, _definePropertyDefault.default)(this, "_subscribers", new Set());
        (0, _definePropertyDefault.default)(this, "_data", void 0);
        (0, _definePropertyDefault.default)(this, "_loader", void 0);
        (0, _definePropertyDefault.default)(this, "_error", void 0);
        (0, _definePropertyDefault.default)(this, "_content", void 0);
        this.id = id;
        this.context = context;
        this.setData(data);
    }
    subscribe(consumer) {
        this._subscribers.add(consumer);
    }
    unsubscribe(consumer) {
        this._subscribers.delete(consumer);
    }
    inUse() {
        return this._subscribers.size > 0;
    }
    delete() {}
    getData() {
        return this.isLoaded ? this._error ? Promise.reject(this._error) : this._content : this._loader.then(()=>this.getData());
    }
    setData(data, forceUpdate) {
        if (data === this._data && !forceUpdate) return;
        this._data = data;
        const loadCount = ++this._loadCount;
        let loader = data;
        if (typeof data === "string") loader = (0, _core.load)(data);
        if (loader instanceof Promise) {
            this.isLoaded = false;
            this._loader = loader.then((result)=>{
                if (this._loadCount === loadCount) {
                    this.isLoaded = true;
                    this._error = undefined;
                    this._content = result;
                }
            }).catch((error)=>{
                if (this._loadCount === loadCount) {
                    this.isLoaded = true;
                    this._error = error || true;
                }
            });
        } else {
            this.isLoaded = true;
            this._error = undefined;
            this._content = data;
        }
        for (const subscriber of this._subscribers)subscriber.onChange(this.getData());
    }
}
exports.default = Resource;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@loaders.gl/core":"aRzJb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kxGGY":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _mathUtils = require("../utils/math-utils");
var _core = require("@math.gl/core");
var _mat4 = require("gl-matrix/mat4");
var _webMercator = require("@math.gl/web-mercator");
var _constants = require("../lib/constants");
const DEGREES_TO_RADIANS = Math.PI / 180;
const IDENTITY = (0, _mathUtils.createMat4)();
const ZERO_VECTOR = [
    0,
    0,
    0
];
const DEFAULT_DISTANCE_SCALES = {
    unitsPerMeter: [
        1,
        1,
        1
    ],
    metersPerUnit: [
        1,
        1,
        1
    ]
};
function createProjectionMatrix({ width , height , orthographic , fovyRadians , focalDistance , padding , near , far  }) {
    const aspect = width / height;
    const matrix = orthographic ? new (0, _core.Matrix4)().orthographic({
        fovy: fovyRadians,
        aspect,
        focalDistance,
        near,
        far
    }) : new (0, _core.Matrix4)().perspective({
        fovy: fovyRadians,
        aspect,
        near,
        far
    });
    if (padding) {
        const { left =0 , right =0 , top =0 , bottom =0  } = padding;
        const offsetX = (0, _core.clamp)((left + width - right) / 2, 0, width) - width / 2;
        const offsetY = (0, _core.clamp)((top + height - bottom) / 2, 0, height) - height / 2;
        matrix[8] -= offsetX * 2 / width;
        matrix[9] += offsetY * 2 / height;
    }
    return matrix;
}
class Viewport {
    constructor(opts = {}){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "x", void 0);
        (0, _definePropertyDefault.default)(this, "y", void 0);
        (0, _definePropertyDefault.default)(this, "width", void 0);
        (0, _definePropertyDefault.default)(this, "height", void 0);
        (0, _definePropertyDefault.default)(this, "padding", void 0);
        (0, _definePropertyDefault.default)(this, "isGeospatial", void 0);
        (0, _definePropertyDefault.default)(this, "zoom", void 0);
        (0, _definePropertyDefault.default)(this, "focalDistance", void 0);
        (0, _definePropertyDefault.default)(this, "position", void 0);
        (0, _definePropertyDefault.default)(this, "modelMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "distanceScales", void 0);
        (0, _definePropertyDefault.default)(this, "scale", void 0);
        (0, _definePropertyDefault.default)(this, "center", void 0);
        (0, _definePropertyDefault.default)(this, "cameraPosition", void 0);
        (0, _definePropertyDefault.default)(this, "projectionMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "viewMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "viewMatrixUncentered", void 0);
        (0, _definePropertyDefault.default)(this, "viewMatrixInverse", void 0);
        (0, _definePropertyDefault.default)(this, "viewProjectionMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "pixelProjectionMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "pixelUnprojectionMatrix", void 0);
        (0, _definePropertyDefault.default)(this, "resolution", void 0);
        (0, _definePropertyDefault.default)(this, "_frustumPlanes", {});
        this.id = opts.id || this.constructor.displayName || "viewport";
        this.x = opts.x || 0;
        this.y = opts.y || 0;
        this.width = opts.width || 1;
        this.height = opts.height || 1;
        this.zoom = opts.zoom || 0;
        this.padding = opts.padding;
        this.distanceScales = opts.distanceScales || DEFAULT_DISTANCE_SCALES;
        this.focalDistance = opts.focalDistance || 1;
        this.position = opts.position || ZERO_VECTOR;
        this.modelMatrix = opts.modelMatrix || null;
        const { longitude , latitude  } = opts;
        this.isGeospatial = Number.isFinite(latitude) && Number.isFinite(longitude);
        this._initProps(opts);
        this._initMatrices(opts);
        this.equals = this.equals.bind(this);
        this.project = this.project.bind(this);
        this.unproject = this.unproject.bind(this);
        this.projectPosition = this.projectPosition.bind(this);
        this.unprojectPosition = this.unprojectPosition.bind(this);
        this.projectFlat = this.projectFlat.bind(this);
        this.unprojectFlat = this.unprojectFlat.bind(this);
    }
    get metersPerPixel() {
        return this.distanceScales.metersPerUnit[2] / this.scale;
    }
    get projectionMode() {
        if (this.isGeospatial) return this.zoom < 12 ? (0, _constants.PROJECTION_MODE).WEB_MERCATOR : (0, _constants.PROJECTION_MODE).WEB_MERCATOR_AUTO_OFFSET;
        return (0, _constants.PROJECTION_MODE).IDENTITY;
    }
    equals(viewport) {
        if (!(viewport instanceof Viewport)) return false;
        if (this === viewport) return true;
        return viewport.width === this.width && viewport.height === this.height && viewport.scale === this.scale && (0, _core.equals)(viewport.projectionMatrix, this.projectionMatrix) && (0, _core.equals)(viewport.viewMatrix, this.viewMatrix);
    }
    project(xyz, { topLeft =true  } = {}) {
        const worldPosition = this.projectPosition(xyz);
        const coord = (0, _webMercator.worldToPixels)(worldPosition, this.pixelProjectionMatrix);
        const [x, y] = coord;
        const y2 = topLeft ? y : this.height - y;
        return xyz.length === 2 ? [
            x,
            y2
        ] : [
            x,
            y2,
            coord[2]
        ];
    }
    unproject(xyz, { topLeft =true , targetZ  } = {}) {
        const [x, y, z] = xyz;
        const y2 = topLeft ? y : this.height - y;
        const targetZWorld = targetZ && targetZ * this.distanceScales.unitsPerMeter[2];
        const coord = (0, _webMercator.pixelsToWorld)([
            x,
            y2,
            z
        ], this.pixelUnprojectionMatrix, targetZWorld);
        const [X, Y, Z] = this.unprojectPosition(coord);
        if (Number.isFinite(z)) return [
            X,
            Y,
            Z
        ];
        return Number.isFinite(targetZ) ? [
            X,
            Y,
            targetZ
        ] : [
            X,
            Y
        ];
    }
    projectPosition(xyz) {
        const [X, Y] = this.projectFlat(xyz);
        const Z = (xyz[2] || 0) * this.distanceScales.unitsPerMeter[2];
        return [
            X,
            Y,
            Z
        ];
    }
    unprojectPosition(xyz) {
        const [X, Y] = this.unprojectFlat(xyz);
        const Z = (xyz[2] || 0) * this.distanceScales.metersPerUnit[2];
        return [
            X,
            Y,
            Z
        ];
    }
    projectFlat(xyz) {
        if (this.isGeospatial) {
            const result = (0, _webMercator.lngLatToWorld)(xyz);
            result[1] = (0, _core.clamp)(result[1], -318, 830);
            return result;
        }
        return xyz;
    }
    unprojectFlat(xyz) {
        if (this.isGeospatial) return (0, _webMercator.worldToLngLat)(xyz);
        return xyz;
    }
    getBounds(options = {}) {
        const unprojectOption = {
            targetZ: options.z || 0
        };
        const topLeft = this.unproject([
            0,
            0
        ], unprojectOption);
        const topRight = this.unproject([
            this.width,
            0
        ], unprojectOption);
        const bottomLeft = this.unproject([
            0,
            this.height
        ], unprojectOption);
        const bottomRight = this.unproject([
            this.width,
            this.height
        ], unprojectOption);
        return [
            Math.min(topLeft[0], topRight[0], bottomLeft[0], bottomRight[0]),
            Math.min(topLeft[1], topRight[1], bottomLeft[1], bottomRight[1]),
            Math.max(topLeft[0], topRight[0], bottomLeft[0], bottomRight[0]),
            Math.max(topLeft[1], topRight[1], bottomLeft[1], bottomRight[1])
        ];
    }
    getDistanceScales(coordinateOrigin) {
        if (coordinateOrigin) return (0, _webMercator.getDistanceScales)({
            longitude: coordinateOrigin[0],
            latitude: coordinateOrigin[1],
            highPrecision: true
        });
        return this.distanceScales;
    }
    containsPixel({ x , y , width =1 , height =1  }) {
        return x < this.x + this.width && this.x < x + width && y < this.y + this.height && this.y < y + height;
    }
    getFrustumPlanes() {
        if (this._frustumPlanes.near) return this._frustumPlanes;
        Object.assign(this._frustumPlanes, (0, _mathUtils.getFrustumPlanes)(this.viewProjectionMatrix));
        return this._frustumPlanes;
    }
    panByPosition(coords, pixel) {
        return null;
    }
    _initProps(opts) {
        const longitude = opts.longitude;
        const latitude = opts.latitude;
        if (this.isGeospatial) {
            if (!Number.isFinite(opts.zoom)) this.zoom = (0, _webMercator.getMeterZoom)({
                latitude
            }) + Math.log2(this.focalDistance);
            this.distanceScales = opts.distanceScales || (0, _webMercator.getDistanceScales)({
                latitude,
                longitude
            });
        }
        const scale = Math.pow(2, this.zoom);
        this.scale = scale;
        const { position , modelMatrix  } = opts;
        let meterOffset = ZERO_VECTOR;
        if (position) meterOffset = modelMatrix ? new (0, _core.Matrix4)(modelMatrix).transformAsVector(position, []) : position;
        if (this.isGeospatial) {
            const center = this.projectPosition([
                longitude,
                latitude,
                0
            ]);
            this.center = new (0, _core.Vector3)(meterOffset).scale(this.distanceScales.unitsPerMeter).add(center);
        } else this.center = this.projectPosition(meterOffset);
    }
    _initMatrices(opts) {
        const { viewMatrix =IDENTITY , projectionMatrix =null , orthographic =false , fovyRadians , fovy =75 , near =0.1 , far =1000 , padding =null , focalDistance =1  } = opts;
        this.viewMatrixUncentered = viewMatrix;
        this.viewMatrix = new (0, _core.Matrix4)().multiplyRight(viewMatrix).translate(new (0, _core.Vector3)(this.center).negate());
        this.projectionMatrix = projectionMatrix || createProjectionMatrix({
            width: this.width,
            height: this.height,
            orthographic,
            fovyRadians: fovyRadians || fovy * DEGREES_TO_RADIANS,
            focalDistance,
            padding,
            near,
            far
        });
        const vpm = (0, _mathUtils.createMat4)();
        _mat4.multiply(vpm, vpm, this.projectionMatrix);
        _mat4.multiply(vpm, vpm, this.viewMatrix);
        this.viewProjectionMatrix = vpm;
        this.viewMatrixInverse = _mat4.invert([], this.viewMatrix) || this.viewMatrix;
        this.cameraPosition = (0, _mathUtils.getCameraPosition)(this.viewMatrixInverse);
        const viewportMatrix = (0, _mathUtils.createMat4)();
        const pixelProjectionMatrix = (0, _mathUtils.createMat4)();
        _mat4.scale(viewportMatrix, viewportMatrix, [
            this.width / 2,
            -this.height / 2,
            1
        ]);
        _mat4.translate(viewportMatrix, viewportMatrix, [
            1,
            -1,
            0
        ]);
        _mat4.multiply(pixelProjectionMatrix, viewportMatrix, this.viewProjectionMatrix);
        this.pixelProjectionMatrix = pixelProjectionMatrix;
        this.pixelUnprojectionMatrix = _mat4.invert((0, _mathUtils.createMat4)(), this.pixelProjectionMatrix);
        if (!this.pixelUnprojectionMatrix) (0, _logDefault.default).warn("Pixel project matrix not invertible")();
    }
}
exports.default = Viewport;
(0, _definePropertyDefault.default)(Viewport, "displayName", "Viewport");

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../utils/log":"iINk7","../utils/math-utils":"1KANI","@math.gl/core":"9lgwD","gl-matrix/mat4":"eQTXr","@math.gl/web-mercator":"aEEkN","../lib/constants":"ksWme","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1KANI":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "createMat4", ()=>createMat4);
parcelHelpers.export(exports, "mod", ()=>mod);
parcelHelpers.export(exports, "getCameraPosition", ()=>getCameraPosition);
parcelHelpers.export(exports, "getFrustumPlanes", ()=>getFrustumPlanes);
parcelHelpers.export(exports, "fp64LowPart", ()=>fp64LowPart);
parcelHelpers.export(exports, "toDoublePrecisionArray", ()=>toDoublePrecisionArray);
var _typedArrayManager = require("./typed-array-manager");
var _typedArrayManagerDefault = parcelHelpers.interopDefault(_typedArrayManager);
var _core = require("@math.gl/core");
function createMat4() {
    return [
        1,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        1,
        0,
        0,
        0,
        0,
        1
    ];
}
function mod(value, divisor) {
    const modulus = value % divisor;
    return modulus < 0 ? divisor + modulus : modulus;
}
function getCameraPosition(viewMatrixInverse) {
    return [
        viewMatrixInverse[12],
        viewMatrixInverse[13],
        viewMatrixInverse[14]
    ];
}
function getFrustumPlanes(viewProjectionMatrix) {
    return {
        left: getFrustumPlane(viewProjectionMatrix[3] + viewProjectionMatrix[0], viewProjectionMatrix[7] + viewProjectionMatrix[4], viewProjectionMatrix[11] + viewProjectionMatrix[8], viewProjectionMatrix[15] + viewProjectionMatrix[12]),
        right: getFrustumPlane(viewProjectionMatrix[3] - viewProjectionMatrix[0], viewProjectionMatrix[7] - viewProjectionMatrix[4], viewProjectionMatrix[11] - viewProjectionMatrix[8], viewProjectionMatrix[15] - viewProjectionMatrix[12]),
        bottom: getFrustumPlane(viewProjectionMatrix[3] + viewProjectionMatrix[1], viewProjectionMatrix[7] + viewProjectionMatrix[5], viewProjectionMatrix[11] + viewProjectionMatrix[9], viewProjectionMatrix[15] + viewProjectionMatrix[13]),
        top: getFrustumPlane(viewProjectionMatrix[3] - viewProjectionMatrix[1], viewProjectionMatrix[7] - viewProjectionMatrix[5], viewProjectionMatrix[11] - viewProjectionMatrix[9], viewProjectionMatrix[15] - viewProjectionMatrix[13]),
        near: getFrustumPlane(viewProjectionMatrix[3] + viewProjectionMatrix[2], viewProjectionMatrix[7] + viewProjectionMatrix[6], viewProjectionMatrix[11] + viewProjectionMatrix[10], viewProjectionMatrix[15] + viewProjectionMatrix[14]),
        far: getFrustumPlane(viewProjectionMatrix[3] - viewProjectionMatrix[2], viewProjectionMatrix[7] - viewProjectionMatrix[6], viewProjectionMatrix[11] - viewProjectionMatrix[10], viewProjectionMatrix[15] - viewProjectionMatrix[14])
    };
}
const scratchVector = new (0, _core.Vector3)();
function getFrustumPlane(a, b, c, d) {
    scratchVector.set(a, b, c);
    const L = scratchVector.len();
    return {
        distance: d / L,
        normal: new (0, _core.Vector3)(-a / L, -b / L, -c / L)
    };
}
function fp64LowPart(x) {
    return x - Math.fround(x);
}
let scratchArray;
function toDoublePrecisionArray(typedArray, options) {
    const { size =1 , startIndex =0  } = options;
    const endIndex = options.endIndex !== undefined ? options.endIndex : typedArray.length;
    const count = (endIndex - startIndex) / size;
    scratchArray = (0, _typedArrayManagerDefault.default).allocate(scratchArray, count, {
        type: Float32Array,
        size: size * 2
    });
    let sourceIndex = startIndex;
    let targetIndex = 0;
    while(sourceIndex < endIndex){
        for(let j = 0; j < size; j++){
            const value = typedArray[sourceIndex++];
            scratchArray[targetIndex + j] = value;
            scratchArray[targetIndex + j + size] = fp64LowPart(value);
        }
        targetIndex += size * 2;
    }
    return scratchArray.subarray(0, count * size * 2);
}

},{"./typed-array-manager":"kyraM","@math.gl/core":"9lgwD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kyraM":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "TypedArrayManager", ()=>TypedArrayManager);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
class TypedArrayManager {
    constructor(options = {}){
        (0, _definePropertyDefault.default)(this, "_pool", []);
        (0, _definePropertyDefault.default)(this, "opts", {
            overAlloc: 2,
            poolSize: 100
        });
        this.setOptions(options);
    }
    setOptions(options) {
        Object.assign(this.opts, options);
    }
    allocate(typedArray, count, { size =1 , type , padding =0 , copy =false , initialize =false , maxCount  }) {
        const Type = type || typedArray && typedArray.constructor || Float32Array;
        const newSize = count * size + padding;
        if (ArrayBuffer.isView(typedArray)) {
            if (newSize <= typedArray.length) return typedArray;
            if (newSize * typedArray.BYTES_PER_ELEMENT <= typedArray.buffer.byteLength) return new Type(typedArray.buffer, 0, newSize);
        }
        let maxSize = Infinity;
        if (maxCount) maxSize = maxCount * size + padding;
        const newArray = this._allocate(Type, newSize, initialize, maxSize);
        if (typedArray && copy) newArray.set(typedArray);
        else if (!initialize) newArray.fill(0, 0, 4);
        this._release(typedArray);
        return newArray;
    }
    release(typedArray) {
        this._release(typedArray);
    }
    _allocate(Type, size, initialize, maxSize) {
        let sizeToAllocate = Math.max(Math.ceil(size * this.opts.overAlloc), 1);
        if (sizeToAllocate > maxSize) sizeToAllocate = maxSize;
        const pool = this._pool;
        const byteLength = Type.BYTES_PER_ELEMENT * sizeToAllocate;
        const i = pool.findIndex((b)=>b.byteLength >= byteLength);
        if (i >= 0) {
            const array = new Type(pool.splice(i, 1)[0], 0, sizeToAllocate);
            if (initialize) array.fill(0);
            return array;
        }
        return new Type(sizeToAllocate);
    }
    _release(typedArray) {
        if (!ArrayBuffer.isView(typedArray)) return;
        const pool = this._pool;
        const { buffer  } = typedArray;
        const { byteLength  } = buffer;
        const i = pool.findIndex((b)=>b.byteLength >= byteLength);
        if (i < 0) pool.push(buffer);
        else if (i > 0 || pool.length < this.opts.poolSize) pool.splice(i, 0, buffer);
        if (pool.length > this.opts.poolSize) pool.shift();
    }
}
exports.default = new TypedArrayManager();

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"acsK1":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _deepEqual = require("../utils/deep-equal");
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _flatten = require("../utils/flatten");
class ViewManager {
    constructor(props){
        (0, _definePropertyDefault.default)(this, "width", void 0);
        (0, _definePropertyDefault.default)(this, "height", void 0);
        (0, _definePropertyDefault.default)(this, "views", void 0);
        (0, _definePropertyDefault.default)(this, "viewState", void 0);
        (0, _definePropertyDefault.default)(this, "controllers", void 0);
        (0, _definePropertyDefault.default)(this, "timeline", void 0);
        (0, _definePropertyDefault.default)(this, "_viewports", void 0);
        (0, _definePropertyDefault.default)(this, "_viewportMap", void 0);
        (0, _definePropertyDefault.default)(this, "_isUpdating", void 0);
        (0, _definePropertyDefault.default)(this, "_needsRedraw", void 0);
        (0, _definePropertyDefault.default)(this, "_needsUpdate", void 0);
        (0, _definePropertyDefault.default)(this, "_eventManager", void 0);
        (0, _definePropertyDefault.default)(this, "_eventCallbacks", void 0);
        this.views = [];
        this.width = 100;
        this.height = 100;
        this.viewState = {};
        this.controllers = {};
        this.timeline = props.timeline;
        this._viewports = [];
        this._viewportMap = {};
        this._isUpdating = false;
        this._needsRedraw = "First render";
        this._needsUpdate = "Initialize";
        this._eventManager = props.eventManager;
        this._eventCallbacks = {
            onViewStateChange: props.onViewStateChange,
            onInteractionStateChange: props.onInteractionStateChange
        };
        Object.seal(this);
        this.setProps(props);
    }
    finalize() {
        for(const key in this.controllers){
            const controller = this.controllers[key];
            if (controller) controller.finalize();
        }
        this.controllers = {};
    }
    needsRedraw(opts = {
        clearRedrawFlags: false
    }) {
        const redraw = this._needsRedraw;
        if (opts.clearRedrawFlags) this._needsRedraw = false;
        return redraw;
    }
    setNeedsUpdate(reason) {
        this._needsUpdate = this._needsUpdate || reason;
        this._needsRedraw = this._needsRedraw || reason;
    }
    updateViewStates() {
        for(const viewId in this.controllers){
            const controller = this.controllers[viewId];
            if (controller) controller.updateTransition();
        }
    }
    getViewports(rect) {
        if (rect) return this._viewports.filter((viewport)=>viewport.containsPixel(rect));
        return this._viewports;
    }
    getViews() {
        const viewMap = {};
        this.views.forEach((view)=>{
            viewMap[view.id] = view;
        });
        return viewMap;
    }
    getView(viewId) {
        return this.views.find((view)=>view.id === viewId);
    }
    getViewState(viewOrViewId) {
        const view = typeof viewOrViewId === "string" ? this.getView(viewOrViewId) : viewOrViewId;
        const viewState = view && this.viewState[view.getViewStateId()] || this.viewState;
        return view ? view.filterViewState(viewState) : viewState;
    }
    getViewport(viewId) {
        return this._viewportMap[viewId];
    }
    unproject(xyz, opts) {
        const viewports = this.getViewports();
        const pixel = {
            x: xyz[0],
            y: xyz[1]
        };
        for(let i = viewports.length - 1; i >= 0; --i){
            const viewport = viewports[i];
            if (viewport.containsPixel(pixel)) {
                const p = xyz.slice();
                p[0] -= viewport.x;
                p[1] -= viewport.y;
                return viewport.unproject(p, opts);
            }
        }
        return null;
    }
    setProps(props) {
        if (props.views) this._setViews(props.views);
        if (props.viewState) this._setViewState(props.viewState);
        if ("width" in props || "height" in props) this._setSize(props.width, props.height);
        if (!this._isUpdating) this._update();
    }
    _update() {
        this._isUpdating = true;
        if (this._needsUpdate) {
            this._needsUpdate = false;
            this._rebuildViewports();
        }
        if (this._needsUpdate) {
            this._needsUpdate = false;
            this._rebuildViewports();
        }
        this._isUpdating = false;
    }
    _setSize(width, height) {
        if (width !== this.width || height !== this.height) {
            this.width = width;
            this.height = height;
            this.setNeedsUpdate("Size changed");
        }
    }
    _setViews(views) {
        views = (0, _flatten.flatten)(views, Boolean);
        const viewsChanged = this._diffViews(views, this.views);
        if (viewsChanged) this.setNeedsUpdate("views changed");
        this.views = views;
    }
    _setViewState(viewState) {
        if (viewState) {
            const viewStateChanged = !(0, _deepEqual.deepEqual)(viewState, this.viewState);
            if (viewStateChanged) this.setNeedsUpdate("viewState changed");
            this.viewState = viewState;
        } else (0, _logDefault.default).warn("missing `viewState` or `initialViewState`")();
    }
    _onViewStateChange(viewId, event) {
        if (this._eventCallbacks.onViewStateChange) this._eventCallbacks.onViewStateChange({
            ...event,
            viewId
        });
    }
    _createController(view, props) {
        const Controller = props.type;
        const controller = new Controller({
            timeline: this.timeline,
            eventManager: this._eventManager,
            onViewStateChange: this._onViewStateChange.bind(this, props.id),
            onStateChange: this._eventCallbacks.onInteractionStateChange,
            makeViewport: (viewState)=>{
                var _this$getView;
                return (_this$getView = this.getView(view.id)) === null || _this$getView === void 0 ? void 0 : _this$getView.makeViewport({
                    viewState,
                    width: this.width,
                    height: this.height
                });
            }
        });
        return controller;
    }
    _updateController(view, viewState, viewport, controller) {
        const controllerProps = view.controller;
        if (controllerProps) {
            const resolvedProps = {
                ...viewState,
                ...controllerProps,
                id: view.id,
                x: viewport.x,
                y: viewport.y,
                width: viewport.width,
                height: viewport.height
            };
            if (!controller) controller = this._createController(view, resolvedProps);
            if (controller) controller.setProps(resolvedProps);
            return controller;
        }
        return null;
    }
    _rebuildViewports() {
        const { views  } = this;
        const oldControllers = this.controllers;
        this._viewports = [];
        this.controllers = {};
        let invalidateControllers = false;
        for(let i = views.length; i--;){
            const view = views[i];
            const viewState = this.getViewState(view);
            const viewport = view.makeViewport({
                viewState,
                width: this.width,
                height: this.height
            });
            let oldController = oldControllers[view.id];
            const hasController = Boolean(view.controller);
            if (hasController && !oldController) invalidateControllers = true;
            if ((invalidateControllers || !hasController) && oldController) {
                oldController.finalize();
                oldController = null;
            }
            this.controllers[view.id] = this._updateController(view, viewState, viewport, oldController);
            this._viewports.unshift(viewport);
        }
        for(const id in oldControllers){
            const oldController1 = oldControllers[id];
            if (oldController1 && !this.controllers[id]) oldController1.finalize();
        }
        this._buildViewportMap();
    }
    _buildViewportMap() {
        this._viewportMap = {};
        this._viewports.forEach((viewport)=>{
            if (viewport.id) this._viewportMap[viewport.id] = this._viewportMap[viewport.id] || viewport;
        });
    }
    _diffViews(newViews, oldViews) {
        if (newViews.length !== oldViews.length) return true;
        return newViews.some((_, i)=>!newViews[i].equals(oldViews[i]));
    }
}
exports.default = ViewManager;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../utils/deep-equal":"cspiV","../utils/log":"iINk7","../utils/flatten":"bFfhb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cspiV":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "deepEqual", ()=>deepEqual);
function deepEqual(a, b) {
    if (a === b) return true;
    if (!a || !b) return false;
    for(const key in a){
        const aValue = a[key];
        const bValue = b[key];
        const equals = aValue === bValue || Array.isArray(aValue) && Array.isArray(bValue) && deepEqual(aValue, bValue);
        if (!equals) return false;
    }
    return true;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aiwwz":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _view = require("./view");
var _viewDefault = parcelHelpers.interopDefault(_view);
var _webMercatorViewport = require("../viewports/web-mercator-viewport");
var _webMercatorViewportDefault = parcelHelpers.interopDefault(_webMercatorViewport);
var _mapController = require("../controllers/map-controller");
var _mapControllerDefault = parcelHelpers.interopDefault(_mapController);
class MapView extends (0, _viewDefault.default) {
    get ViewportType() {
        return 0, _webMercatorViewportDefault.default;
    }
    get ControllerType() {
        return 0, _mapControllerDefault.default;
    }
}
exports.default = MapView;
(0, _definePropertyDefault.default)(MapView, "displayName", "MapView");

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./view":"iThAT","../viewports/web-mercator-viewport":"cVyIy","../controllers/map-controller":"8KSWr","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iThAT":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _viewport = require("../viewports/viewport");
var _viewportDefault = parcelHelpers.interopDefault(_viewport);
var _positions = require("../utils/positions");
var _deepEqual = require("../utils/deep-equal");
var _assert = require("../utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
class View {
    constructor(props){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "viewportInstance", void 0);
        (0, _definePropertyDefault.default)(this, "_x", void 0);
        (0, _definePropertyDefault.default)(this, "_y", void 0);
        (0, _definePropertyDefault.default)(this, "_width", void 0);
        (0, _definePropertyDefault.default)(this, "_height", void 0);
        (0, _definePropertyDefault.default)(this, "_padding", void 0);
        (0, _definePropertyDefault.default)(this, "props", void 0);
        const { id , x =0 , y =0 , width ="100%" , height ="100%" , padding =null , viewportInstance  } = props || {};
        (0, _assertDefault.default)(!viewportInstance || viewportInstance instanceof (0, _viewportDefault.default));
        this.viewportInstance = viewportInstance;
        this.id = id || this.constructor.displayName || "view";
        this.props = {
            ...props,
            id: this.id
        };
        this._x = (0, _positions.parsePosition)(x);
        this._y = (0, _positions.parsePosition)(y);
        this._width = (0, _positions.parsePosition)(width);
        this._height = (0, _positions.parsePosition)(height);
        this._padding = padding && {
            left: (0, _positions.parsePosition)(padding.left || 0),
            right: (0, _positions.parsePosition)(padding.right || 0),
            top: (0, _positions.parsePosition)(padding.top || 0),
            bottom: (0, _positions.parsePosition)(padding.bottom || 0)
        };
        this.equals = this.equals.bind(this);
        Object.seal(this);
    }
    equals(view) {
        if (this === view) return true;
        if (this.viewportInstance) return view.viewportInstance ? this.viewportInstance.equals(view.viewportInstance) : false;
        return this.ViewportType === view.ViewportType && (0, _deepEqual.deepEqual)(this.props, view.props);
    }
    makeViewport({ width , height , viewState  }) {
        if (this.viewportInstance) return this.viewportInstance;
        viewState = this.filterViewState(viewState);
        const viewportDimensions = this.getDimensions({
            width,
            height
        });
        return new this.ViewportType({
            ...viewState,
            ...this.props,
            ...viewportDimensions
        });
    }
    getViewStateId() {
        const { viewState  } = this.props;
        if (typeof viewState === "string") return viewState;
        return (viewState === null || viewState === void 0 ? void 0 : viewState.id) || this.id;
    }
    filterViewState(viewState) {
        if (this.props.viewState && typeof this.props.viewState === "object") {
            if (!this.props.viewState.id) return this.props.viewState;
            const newViewState = {
                ...viewState
            };
            for(const key in this.props.viewState)if (key !== "id") newViewState[key] = this.props.viewState[key];
            return newViewState;
        }
        return viewState;
    }
    getDimensions({ width , height  }) {
        const dimensions = {
            x: (0, _positions.getPosition)(this._x, width),
            y: (0, _positions.getPosition)(this._y, height),
            width: (0, _positions.getPosition)(this._width, width),
            height: (0, _positions.getPosition)(this._height, height)
        };
        if (this._padding) dimensions.padding = {
            left: (0, _positions.getPosition)(this._padding.left, width),
            top: (0, _positions.getPosition)(this._padding.top, height),
            right: (0, _positions.getPosition)(this._padding.right, width),
            bottom: (0, _positions.getPosition)(this._padding.bottom, height)
        };
        return dimensions;
    }
    get controller() {
        const opts = this.props.controller;
        if (!opts) return null;
        if (opts === true) return {
            type: this.ControllerType
        };
        if (typeof opts === "function") return {
            type: opts
        };
        return {
            type: this.ControllerType,
            ...opts
        };
    }
}
exports.default = View;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../viewports/viewport":"kxGGY","../utils/positions":"h7iJh","../utils/deep-equal":"cspiV","../utils/assert":"aysGh","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"h7iJh":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "parsePosition", ()=>parsePosition);
parcelHelpers.export(exports, "getPosition", ()=>getPosition);
const PERCENT_OR_PIXELS_REGEX = /([0-9]+\.?[0-9]*)(%|px)/;
function parsePosition(value) {
    switch(typeof value){
        case "number":
            return {
                position: value,
                relative: false
            };
        case "string":
            const match = PERCENT_OR_PIXELS_REGEX.exec(value);
            if (match && match.length >= 3) {
                const relative = match[2] === "%";
                const position = parseFloat(match[1]);
                return {
                    position: relative ? position / 100 : position,
                    relative
                };
            }
        default:
            throw new Error("Could not parse position string ".concat(value));
    }
}
function getPosition(position, extent) {
    return position.relative ? Math.round(position.position * extent) : position.position;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aysGh":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
function assert(condition, message) {
    if (!condition) throw new Error(message || "deck.gl: assertion failed.");
}
exports.default = assert;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cVyIy":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _viewport = require("./viewport");
var _viewportDefault = parcelHelpers.interopDefault(_viewport);
var _webMercator = require("@math.gl/web-mercator");
var _vec2 = require("gl-matrix/vec2");
var _core = require("@math.gl/core");
const TILE_SIZE = 512;
const EARTH_CIRCUMFERENCE = 40.03e6;
const DEGREES_TO_RADIANS = Math.PI / 180;
function unitsPerMeter(latitude) {
    const latCosine = Math.cos(latitude * DEGREES_TO_RADIANS);
    return TILE_SIZE / EARTH_CIRCUMFERENCE / latCosine;
}
class WebMercatorViewport extends (0, _viewportDefault.default) {
    constructor(opts = {}){
        const { latitude =0 , longitude =0 , zoom =0 , pitch =0 , bearing =0 , nearZMultiplier =0.1 , farZMultiplier =1.01 , orthographic =false , projectionMatrix , repeat =false , worldOffset =0 , legacyMeterSizes =false  } = opts;
        let { width , height , altitude =1.5  } = opts;
        const scale = Math.pow(2, zoom);
        width = width || 1;
        height = height || 1;
        let fovy;
        let projectionParameters = null;
        if (projectionMatrix) {
            altitude = projectionMatrix[5] / 2;
            fovy = (0, _webMercator.altitudeToFovy)(altitude);
        } else {
            if (opts.fovy) {
                fovy = opts.fovy;
                altitude = (0, _webMercator.fovyToAltitude)(fovy);
            } else fovy = (0, _webMercator.altitudeToFovy)(altitude);
            projectionParameters = (0, _webMercator.getProjectionParameters)({
                width,
                height,
                pitch,
                fovy,
                nearZMultiplier,
                farZMultiplier
            });
        }
        let viewMatrixUncentered = (0, _webMercator.getViewMatrix)({
            height,
            pitch,
            bearing,
            scale,
            altitude
        });
        if (worldOffset) {
            const viewOffset = new (0, _core.Matrix4)().translate([
                512 * worldOffset,
                0,
                0
            ]);
            viewMatrixUncentered = viewOffset.multiplyLeft(viewMatrixUncentered);
        }
        super({
            ...opts,
            width,
            height,
            viewMatrix: viewMatrixUncentered,
            longitude,
            latitude,
            zoom,
            ...projectionParameters,
            fovy,
            focalDistance: altitude
        });
        (0, _definePropertyDefault.default)(this, "longitude", void 0);
        (0, _definePropertyDefault.default)(this, "latitude", void 0);
        (0, _definePropertyDefault.default)(this, "pitch", void 0);
        (0, _definePropertyDefault.default)(this, "bearing", void 0);
        (0, _definePropertyDefault.default)(this, "altitude", void 0);
        (0, _definePropertyDefault.default)(this, "fovy", void 0);
        (0, _definePropertyDefault.default)(this, "orthographic", void 0);
        (0, _definePropertyDefault.default)(this, "_subViewports", void 0);
        (0, _definePropertyDefault.default)(this, "_pseudoMeters", void 0);
        this.latitude = latitude;
        this.longitude = longitude;
        this.zoom = zoom;
        this.pitch = pitch;
        this.bearing = bearing;
        this.altitude = altitude;
        this.fovy = fovy;
        this.orthographic = orthographic;
        this._subViewports = repeat ? [] : null;
        this._pseudoMeters = legacyMeterSizes;
        Object.freeze(this);
    }
    get subViewports() {
        if (this._subViewports && !this._subViewports.length) {
            const bounds = this.getBounds();
            const minOffset = Math.floor((bounds[0] + 180) / 360);
            const maxOffset = Math.ceil((bounds[2] - 180) / 360);
            for(let x = minOffset; x <= maxOffset; x++){
                const offsetViewport = x ? new WebMercatorViewport({
                    ...this,
                    worldOffset: x
                }) : this;
                this._subViewports.push(offsetViewport);
            }
        }
        return this._subViewports;
    }
    projectPosition(xyz) {
        if (this._pseudoMeters) return super.projectPosition(xyz);
        const [X, Y] = this.projectFlat(xyz);
        const Z = (xyz[2] || 0) * unitsPerMeter(xyz[1]);
        return [
            X,
            Y,
            Z
        ];
    }
    unprojectPosition(xyz) {
        if (this._pseudoMeters) return super.unprojectPosition(xyz);
        const [X, Y] = this.unprojectFlat(xyz);
        const Z = (xyz[2] || 0) / unitsPerMeter(Y);
        return [
            X,
            Y,
            Z
        ];
    }
    addMetersToLngLat(lngLatZ, xyz) {
        return (0, _webMercator.addMetersToLngLat)(lngLatZ, xyz);
    }
    panByPosition(coords, pixel) {
        const fromLocation = (0, _webMercator.pixelsToWorld)(pixel, this.pixelUnprojectionMatrix);
        const toLocation = this.projectFlat(coords);
        const translate = _vec2.add([], toLocation, _vec2.negate([], fromLocation));
        const newCenter = _vec2.add([], this.center, translate);
        const [longitude, latitude] = this.unprojectFlat(newCenter);
        return {
            longitude,
            latitude
        };
    }
    getBounds(options = {}) {
        const corners = (0, _webMercator.getBounds)(this, options.z || 0);
        return [
            Math.min(corners[0][0], corners[1][0], corners[2][0], corners[3][0]),
            Math.min(corners[0][1], corners[1][1], corners[2][1], corners[3][1]),
            Math.max(corners[0][0], corners[1][0], corners[2][0], corners[3][0]),
            Math.max(corners[0][1], corners[1][1], corners[2][1], corners[3][1])
        ];
    }
    fitBounds(bounds, options = {}) {
        const { width , height  } = this;
        const { longitude , latitude , zoom  } = (0, _webMercator.fitBounds)({
            width,
            height,
            bounds,
            ...options
        });
        return new WebMercatorViewport({
            width,
            height,
            longitude,
            latitude,
            zoom
        });
    }
}
exports.default = WebMercatorViewport;
(0, _definePropertyDefault.default)(WebMercatorViewport, "displayName", "WebMercatorViewport");

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./viewport":"kxGGY","@math.gl/web-mercator":"aEEkN","gl-matrix/vec2":"5mYHR","@math.gl/core":"9lgwD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8KSWr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "MapState", ()=>MapState);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@math.gl/core");
var _controller = require("./controller");
var _controllerDefault = parcelHelpers.interopDefault(_controller);
var _viewState = require("./view-state");
var _viewStateDefault = parcelHelpers.interopDefault(_viewState);
var _webMercator = require("@math.gl/web-mercator");
var _assert = require("../utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _linearInterpolator = require("../transitions/linear-interpolator");
var _linearInterpolatorDefault = parcelHelpers.interopDefault(_linearInterpolator);
const PITCH_MOUSE_THRESHOLD = 5;
const PITCH_ACCEL = 1.2;
class MapState extends (0, _viewStateDefault.default) {
    constructor(options){
        const { width , height , latitude , longitude , zoom , bearing =0 , pitch =0 , altitude =1.5 , position =[
            0,
            0,
            0
        ] , maxZoom =20 , minZoom =0 , maxPitch =60 , minPitch =0 , startPanLngLat , startZoomLngLat , startRotatePos , startBearing , startPitch , startZoom , normalize =true  } = options;
        (0, _assertDefault.default)(Number.isFinite(longitude));
        (0, _assertDefault.default)(Number.isFinite(latitude));
        (0, _assertDefault.default)(Number.isFinite(zoom));
        super({
            width,
            height,
            latitude,
            longitude,
            zoom,
            bearing,
            pitch,
            altitude,
            maxZoom,
            minZoom,
            maxPitch,
            minPitch,
            normalize,
            position
        }, {
            startPanLngLat,
            startZoomLngLat,
            startRotatePos,
            startBearing,
            startPitch,
            startZoom
        });
        (0, _definePropertyDefault.default)(this, "makeViewport", void 0);
        this.makeViewport = options.makeViewport;
    }
    panStart({ pos  }) {
        return this._getUpdatedState({
            startPanLngLat: this._unproject(pos)
        });
    }
    pan({ pos , startPos  }) {
        const startPanLngLat = this.getState().startPanLngLat || this._unproject(startPos);
        if (!startPanLngLat) return this;
        const viewport = this.makeViewport(this.getViewportProps());
        const newProps = viewport.panByPosition(startPanLngLat, pos);
        return this._getUpdatedState(newProps);
    }
    panEnd() {
        return this._getUpdatedState({
            startPanLngLat: null
        });
    }
    rotateStart({ pos  }) {
        return this._getUpdatedState({
            startRotatePos: pos,
            startBearing: this.getViewportProps().bearing,
            startPitch: this.getViewportProps().pitch
        });
    }
    rotate({ pos , deltaAngleX =0 , deltaAngleY =0  }) {
        const { startRotatePos , startBearing , startPitch  } = this.getState();
        if (!startRotatePos || startBearing === undefined || startPitch === undefined) return this;
        let newRotation;
        if (pos) newRotation = this._getNewRotation(pos, startRotatePos, startPitch, startBearing);
        else newRotation = {
            bearing: startBearing + deltaAngleX,
            pitch: startPitch + deltaAngleY
        };
        return this._getUpdatedState(newRotation);
    }
    rotateEnd() {
        return this._getUpdatedState({
            startBearing: null,
            startPitch: null
        });
    }
    zoomStart({ pos  }) {
        return this._getUpdatedState({
            startZoomLngLat: this._unproject(pos),
            startZoom: this.getViewportProps().zoom
        });
    }
    zoom({ pos , startPos , scale  }) {
        let { startZoom , startZoomLngLat  } = this.getState();
        if (!startZoomLngLat) {
            startZoom = this.getViewportProps().zoom;
            startZoomLngLat = this._unproject(startPos) || this._unproject(pos);
        }
        if (!startZoomLngLat) return this;
        const { maxZoom , minZoom  } = this.getViewportProps();
        let zoom = startZoom + Math.log2(scale);
        zoom = (0, _core.clamp)(zoom, minZoom, maxZoom);
        const zoomedViewport = this.makeViewport({
            ...this.getViewportProps(),
            zoom
        });
        return this._getUpdatedState({
            zoom,
            ...zoomedViewport.panByPosition(startZoomLngLat, pos)
        });
    }
    zoomEnd() {
        return this._getUpdatedState({
            startZoomLngLat: null,
            startZoom: null
        });
    }
    zoomIn(speed = 2) {
        return this._zoomFromCenter(speed);
    }
    zoomOut(speed = 2) {
        return this._zoomFromCenter(1 / speed);
    }
    moveLeft(speed = 100) {
        return this._panFromCenter([
            speed,
            0
        ]);
    }
    moveRight(speed = 100) {
        return this._panFromCenter([
            -speed,
            0
        ]);
    }
    moveUp(speed = 100) {
        return this._panFromCenter([
            0,
            speed
        ]);
    }
    moveDown(speed = 100) {
        return this._panFromCenter([
            0,
            -speed
        ]);
    }
    rotateLeft(speed = 15) {
        return this._getUpdatedState({
            bearing: this.getViewportProps().bearing - speed
        });
    }
    rotateRight(speed = 15) {
        return this._getUpdatedState({
            bearing: this.getViewportProps().bearing + speed
        });
    }
    rotateUp(speed = 10) {
        return this._getUpdatedState({
            pitch: this.getViewportProps().pitch + speed
        });
    }
    rotateDown(speed = 10) {
        return this._getUpdatedState({
            pitch: this.getViewportProps().pitch - speed
        });
    }
    shortestPathFrom(viewState) {
        const fromProps = viewState.getViewportProps();
        const props = {
            ...this.getViewportProps()
        };
        const { bearing , longitude  } = props;
        if (Math.abs(bearing - fromProps.bearing) > 180) props.bearing = bearing < 0 ? bearing + 360 : bearing - 360;
        if (Math.abs(longitude - fromProps.longitude) > 180) props.longitude = longitude < 0 ? longitude + 360 : longitude - 360;
        return props;
    }
    applyConstraints(props) {
        const { maxZoom , minZoom , zoom  } = props;
        props.zoom = (0, _core.clamp)(zoom, minZoom, maxZoom);
        const { maxPitch , minPitch , pitch  } = props;
        props.pitch = (0, _core.clamp)(pitch, minPitch, maxPitch);
        const { normalize =true  } = props;
        if (normalize) Object.assign(props, (0, _webMercator.normalizeViewportProps)(props));
        return props;
    }
    _zoomFromCenter(scale) {
        const { width , height  } = this.getViewportProps();
        return this.zoom({
            pos: [
                width / 2,
                height / 2
            ],
            scale
        });
    }
    _panFromCenter(offset) {
        const { width , height  } = this.getViewportProps();
        return this.pan({
            startPos: [
                width / 2,
                height / 2
            ],
            pos: [
                width / 2 + offset[0],
                height / 2 + offset[1]
            ]
        });
    }
    _getUpdatedState(newProps) {
        return new this.constructor({
            makeViewport: this.makeViewport,
            ...this.getViewportProps(),
            ...this.getState(),
            ...newProps
        });
    }
    _unproject(pos) {
        const viewport = this.makeViewport(this.getViewportProps());
        return pos && viewport.unproject(pos);
    }
    _getNewRotation(pos, startPos, startPitch, startBearing) {
        const deltaX = pos[0] - startPos[0];
        const deltaY = pos[1] - startPos[1];
        const centerY = pos[1];
        const startY = startPos[1];
        const { width , height  } = this.getViewportProps();
        const deltaScaleX = deltaX / width;
        let deltaScaleY = 0;
        if (deltaY > 0) {
            if (Math.abs(height - startY) > PITCH_MOUSE_THRESHOLD) deltaScaleY = deltaY / (startY - height) * PITCH_ACCEL;
        } else if (deltaY < 0) {
            if (startY > PITCH_MOUSE_THRESHOLD) deltaScaleY = 1 - centerY / startY;
        }
        deltaScaleY = (0, _core.clamp)(deltaScaleY, -1, 1);
        const { minPitch , maxPitch  } = this.getViewportProps();
        const bearing = startBearing + 180 * deltaScaleX;
        let pitch = startPitch;
        if (deltaScaleY > 0) pitch = startPitch + deltaScaleY * (maxPitch - startPitch);
        else if (deltaScaleY < 0) pitch = startPitch - deltaScaleY * (minPitch - startPitch);
        return {
            pitch,
            bearing
        };
    }
}
class MapController extends (0, _controllerDefault.default) {
    constructor(...args){
        super(...args);
        (0, _definePropertyDefault.default)(this, "ControllerState", MapState);
        (0, _definePropertyDefault.default)(this, "transition", {
            transitionDuration: 300,
            transitionInterpolator: new (0, _linearInterpolatorDefault.default)({
                transitionProps: {
                    compare: [
                        "longitude",
                        "latitude",
                        "zoom",
                        "bearing",
                        "pitch",
                        "position"
                    ],
                    required: [
                        "longitude",
                        "latitude",
                        "zoom"
                    ]
                }
            })
        });
        (0, _definePropertyDefault.default)(this, "dragMode", "pan");
    }
    setProps(props) {
        props.position = props.position || [
            0,
            0,
            0
        ];
        const oldProps = this.props;
        super.setProps(props);
        const dimensionChanged = !oldProps || oldProps.height !== props.height;
        if (dimensionChanged) this.updateViewport(new this.ControllerState({
            makeViewport: this.makeViewport,
            ...props,
            ...this.state
        }));
    }
}
exports.default = MapController;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@math.gl/core":"9lgwD","./controller":"4Hxmk","./view-state":"kDVkd","@math.gl/web-mercator":"aEEkN","../utils/assert":"aysGh","../transitions/linear-interpolator":"fCusj","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4Hxmk":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _transitionManager = require("./transition-manager");
var _transitionManagerDefault = parcelHelpers.interopDefault(_transitionManager);
var _linearInterpolator = require("../transitions/linear-interpolator");
var _linearInterpolatorDefault = parcelHelpers.interopDefault(_linearInterpolator);
const NO_TRANSITION_PROPS = {
    transitionDuration: 0
};
const DEFAULT_INERTIA = 300;
const INERTIA_EASING = (t)=>1 - (1 - t) * (1 - t);
const EVENT_TYPES = {
    WHEEL: [
        "wheel"
    ],
    PAN: [
        "panstart",
        "panmove",
        "panend"
    ],
    PINCH: [
        "pinchstart",
        "pinchmove",
        "pinchend"
    ],
    TRIPLE_PAN: [
        "tripanstart",
        "tripanmove",
        "tripanend"
    ],
    DOUBLE_TAP: [
        "doubletap"
    ],
    KEYBOARD: [
        "keydown"
    ]
};
const pinchEventWorkaround = {};
class Controller {
    constructor(opts){
        (0, _definePropertyDefault.default)(this, "props", void 0);
        (0, _definePropertyDefault.default)(this, "state", {});
        (0, _definePropertyDefault.default)(this, "transitionManager", void 0);
        (0, _definePropertyDefault.default)(this, "eventManager", void 0);
        (0, _definePropertyDefault.default)(this, "onViewStateChange", void 0);
        (0, _definePropertyDefault.default)(this, "onStateChange", void 0);
        (0, _definePropertyDefault.default)(this, "makeViewport", void 0);
        (0, _definePropertyDefault.default)(this, "_controllerState", void 0);
        (0, _definePropertyDefault.default)(this, "_events", {});
        (0, _definePropertyDefault.default)(this, "_interactionState", {
            isDragging: false
        });
        (0, _definePropertyDefault.default)(this, "_customEvents", []);
        (0, _definePropertyDefault.default)(this, "_eventStartBlocked", null);
        (0, _definePropertyDefault.default)(this, "_panMove", false);
        (0, _definePropertyDefault.default)(this, "invertPan", false);
        (0, _definePropertyDefault.default)(this, "dragMode", "rotate");
        (0, _definePropertyDefault.default)(this, "inertia", 0);
        (0, _definePropertyDefault.default)(this, "scrollZoom", true);
        (0, _definePropertyDefault.default)(this, "dragPan", true);
        (0, _definePropertyDefault.default)(this, "dragRotate", true);
        (0, _definePropertyDefault.default)(this, "doubleClickZoom", true);
        (0, _definePropertyDefault.default)(this, "touchZoom", true);
        (0, _definePropertyDefault.default)(this, "touchRotate", false);
        (0, _definePropertyDefault.default)(this, "keyboard", true);
        this.transitionManager = new (0, _transitionManagerDefault.default)({
            ...opts,
            getControllerState: (props)=>new this.ControllerState(props),
            onViewStateChange: this._onTransition.bind(this),
            onStateChange: this._setInteractionState.bind(this)
        });
        this.handleEvent = this.handleEvent.bind(this);
        this.eventManager = opts.eventManager;
        this.onViewStateChange = opts.onViewStateChange || (()=>{});
        this.onStateChange = opts.onStateChange || (()=>{});
        this.makeViewport = opts.makeViewport;
    }
    set events(customEvents) {
        this.toggleEvents(this._customEvents, false);
        this.toggleEvents(customEvents, true);
        this._customEvents = customEvents;
        if (this.props) this.setProps(this.props);
    }
    finalize() {
        for(const eventName in this._events)if (this._events[eventName]) {
            var _this$eventManager;
            (_this$eventManager = this.eventManager) === null || _this$eventManager === void 0 || _this$eventManager.off(eventName, this.handleEvent);
        }
        this.transitionManager.finalize();
    }
    handleEvent(event) {
        this._controllerState = undefined;
        const eventStartBlocked = this._eventStartBlocked;
        switch(event.type){
            case "panstart":
                return eventStartBlocked ? false : this._onPanStart(event);
            case "panmove":
                return this._onPan(event);
            case "panend":
                return this._onPanEnd(event);
            case "pinchstart":
                return eventStartBlocked ? false : this._onPinchStart(event);
            case "pinchmove":
                return this._onPinch(event);
            case "pinchend":
                return this._onPinchEnd(event);
            case "tripanstart":
                return eventStartBlocked ? false : this._onTriplePanStart(event);
            case "tripanmove":
                return this._onTriplePan(event);
            case "tripanend":
                return this._onTriplePanEnd(event);
            case "doubletap":
                return this._onDoubleTap(event);
            case "wheel":
                return this._onWheel(event);
            case "keydown":
                return this._onKeyDown(event);
            default:
                return false;
        }
    }
    get controllerState() {
        this._controllerState = this._controllerState || new this.ControllerState({
            makeViewport: this.makeViewport,
            ...this.props,
            ...this.state
        });
        return this._controllerState;
    }
    getCenter(event) {
        const { x , y  } = this.props;
        const { offsetCenter  } = event;
        return [
            offsetCenter.x - x,
            offsetCenter.y - y
        ];
    }
    isPointInBounds(pos, event) {
        const { width , height  } = this.props;
        if (event && event.handled) return false;
        const inside = pos[0] >= 0 && pos[0] <= width && pos[1] >= 0 && pos[1] <= height;
        if (inside && event) event.stopPropagation();
        return inside;
    }
    isFunctionKeyPressed(event) {
        const { srcEvent  } = event;
        return Boolean(srcEvent.metaKey || srcEvent.altKey || srcEvent.ctrlKey || srcEvent.shiftKey);
    }
    isDragging() {
        return this._interactionState.isDragging || false;
    }
    blockEvents(timeout) {
        const timer = setTimeout(()=>{
            if (this._eventStartBlocked === timer) this._eventStartBlocked = null;
        }, timeout);
        this._eventStartBlocked = timer;
    }
    setProps(props) {
        if (props.dragMode) this.dragMode = props.dragMode;
        this.props = props;
        if (!("transitionInterpolator" in props)) props.transitionInterpolator = this._getTransitionProps().transitionInterpolator;
        this.transitionManager.processViewStateChange(props);
        const { inertia  } = props;
        this.inertia = Number.isFinite(inertia) ? inertia : inertia === true ? DEFAULT_INERTIA : 0;
        const { scrollZoom =true , dragPan =true , dragRotate =true , doubleClickZoom =true , touchZoom =true , touchRotate =false , keyboard =true  } = props;
        const isInteractive = Boolean(this.onViewStateChange);
        this.toggleEvents(EVENT_TYPES.WHEEL, isInteractive && scrollZoom);
        this.toggleEvents(EVENT_TYPES.PAN, isInteractive && (dragPan || dragRotate));
        this.toggleEvents(EVENT_TYPES.PINCH, isInteractive && (touchZoom || touchRotate));
        this.toggleEvents(EVENT_TYPES.TRIPLE_PAN, isInteractive && touchRotate);
        this.toggleEvents(EVENT_TYPES.DOUBLE_TAP, isInteractive && doubleClickZoom);
        this.toggleEvents(EVENT_TYPES.KEYBOARD, isInteractive && keyboard);
        this.scrollZoom = scrollZoom;
        this.dragPan = dragPan;
        this.dragRotate = dragRotate;
        this.doubleClickZoom = doubleClickZoom;
        this.touchZoom = touchZoom;
        this.touchRotate = touchRotate;
        this.keyboard = keyboard;
    }
    updateTransition() {
        this.transitionManager.updateTransition();
    }
    toggleEvents(eventNames, enabled) {
        if (this.eventManager) eventNames.forEach((eventName)=>{
            if (this._events[eventName] !== enabled) {
                this._events[eventName] = enabled;
                if (enabled) this.eventManager.on(eventName, this.handleEvent);
                else this.eventManager.off(eventName, this.handleEvent);
            }
        });
    }
    updateViewport(newControllerState, extraProps = null, interactionState = {}) {
        const viewState = {
            ...newControllerState.getViewportProps(),
            ...extraProps
        };
        const changed = this.controllerState !== newControllerState;
        this.state = newControllerState.getState();
        this._setInteractionState(interactionState);
        if (changed) {
            const oldViewState = this.controllerState && this.controllerState.getViewportProps();
            if (this.onViewStateChange) this.onViewStateChange({
                viewState,
                interactionState: this._interactionState,
                oldViewState
            });
        }
    }
    _onTransition(params) {
        this.onViewStateChange({
            ...params,
            interactionState: this._interactionState
        });
    }
    _setInteractionState(newStates) {
        Object.assign(this._interactionState, newStates);
        this.onStateChange(this._interactionState);
    }
    _onPanStart(event) {
        const pos = this.getCenter(event);
        if (!this.isPointInBounds(pos, event)) return false;
        let alternateMode = this.isFunctionKeyPressed(event) || event.rightButton || false;
        if (this.invertPan || this.dragMode === "pan") alternateMode = !alternateMode;
        const newControllerState = this.controllerState[alternateMode ? "panStart" : "rotateStart"]({
            pos
        });
        this._panMove = alternateMode;
        this.updateViewport(newControllerState, NO_TRANSITION_PROPS, {
            isDragging: true
        });
        return true;
    }
    _onPan(event) {
        if (!this.isDragging()) return false;
        return this._panMove ? this._onPanMove(event) : this._onPanRotate(event);
    }
    _onPanEnd(event) {
        if (!this.isDragging()) return false;
        return this._panMove ? this._onPanMoveEnd(event) : this._onPanRotateEnd(event);
    }
    _onPanMove(event) {
        if (!this.dragPan) return false;
        const pos = this.getCenter(event);
        const newControllerState = this.controllerState.pan({
            pos
        });
        this.updateViewport(newControllerState, NO_TRANSITION_PROPS, {
            isDragging: true,
            isPanning: true
        });
        return true;
    }
    _onPanMoveEnd(event) {
        const { inertia  } = this;
        if (this.dragPan && inertia && event.velocity) {
            const pos = this.getCenter(event);
            const endPos = [
                pos[0] + event.velocityX * inertia / 2,
                pos[1] + event.velocityY * inertia / 2
            ];
            const newControllerState = this.controllerState.pan({
                pos: endPos
            }).panEnd();
            this.updateViewport(newControllerState, {
                ...this._getTransitionProps(),
                transitionDuration: inertia,
                transitionEasing: INERTIA_EASING
            }, {
                isDragging: false,
                isPanning: true
            });
        } else {
            const newControllerState1 = this.controllerState.panEnd();
            this.updateViewport(newControllerState1, null, {
                isDragging: false,
                isPanning: false
            });
        }
        return true;
    }
    _onPanRotate(event) {
        if (!this.dragRotate) return false;
        const pos = this.getCenter(event);
        const newControllerState = this.controllerState.rotate({
            pos
        });
        this.updateViewport(newControllerState, NO_TRANSITION_PROPS, {
            isDragging: true,
            isRotating: true
        });
        return true;
    }
    _onPanRotateEnd(event) {
        const { inertia  } = this;
        if (this.dragRotate && inertia && event.velocity) {
            const pos = this.getCenter(event);
            const endPos = [
                pos[0] + event.velocityX * inertia / 2,
                pos[1] + event.velocityY * inertia / 2
            ];
            const newControllerState = this.controllerState.rotate({
                pos: endPos
            }).rotateEnd();
            this.updateViewport(newControllerState, {
                ...this._getTransitionProps(),
                transitionDuration: inertia,
                transitionEasing: INERTIA_EASING
            }, {
                isDragging: false,
                isRotating: true
            });
        } else {
            const newControllerState1 = this.controllerState.rotateEnd();
            this.updateViewport(newControllerState1, null, {
                isDragging: false,
                isRotating: false
            });
        }
        return true;
    }
    _onWheel(event) {
        if (!this.scrollZoom) return false;
        event.srcEvent.preventDefault();
        const pos = this.getCenter(event);
        if (!this.isPointInBounds(pos, event)) return false;
        const { speed =0.01 , smooth =false  } = this.scrollZoom === true ? {} : this.scrollZoom;
        const { delta  } = event;
        let scale = 2 / (1 + Math.exp(-Math.abs(delta * speed)));
        if (delta < 0 && scale !== 0) scale = 1 / scale;
        const newControllerState = this.controllerState.zoom({
            pos,
            scale
        });
        this.updateViewport(newControllerState, {
            ...this._getTransitionProps({
                around: pos
            }),
            transitionDuration: smooth ? 250 : 1
        }, {
            isZooming: true,
            isPanning: true
        });
        return true;
    }
    _onTriplePanStart(event) {
        const pos = this.getCenter(event);
        if (!this.isPointInBounds(pos, event)) return false;
        const newControllerState = this.controllerState.rotateStart({
            pos
        });
        this.updateViewport(newControllerState, NO_TRANSITION_PROPS, {
            isDragging: true
        });
        return true;
    }
    _onTriplePan(event) {
        if (!this.touchRotate) return false;
        if (!this.isDragging()) return false;
        const pos = this.getCenter(event);
        pos[0] -= event.deltaX;
        const newControllerState = this.controllerState.rotate({
            pos
        });
        this.updateViewport(newControllerState, NO_TRANSITION_PROPS, {
            isDragging: true,
            isRotating: true
        });
        return true;
    }
    _onTriplePanEnd(event) {
        if (!this.isDragging()) return false;
        const { inertia  } = this;
        if (this.touchRotate && inertia && event.velocityY) {
            const pos = this.getCenter(event);
            const endPos = [
                pos[0],
                pos[1] += event.velocityY * inertia / 2
            ];
            const newControllerState = this.controllerState.rotate({
                pos: endPos
            });
            this.updateViewport(newControllerState, {
                ...this._getTransitionProps(),
                transitionDuration: inertia,
                transitionEasing: INERTIA_EASING
            }, {
                isDragging: false,
                isRotating: true
            });
            this.blockEvents(inertia);
        } else {
            const newControllerState1 = this.controllerState.rotateEnd();
            this.updateViewport(newControllerState1, null, {
                isDragging: false,
                isRotating: false
            });
        }
        return true;
    }
    _onPinchStart(event) {
        const pos = this.getCenter(event);
        if (!this.isPointInBounds(pos, event)) return false;
        const newControllerState = this.controllerState.zoomStart({
            pos
        }).rotateStart({
            pos
        });
        pinchEventWorkaround._startPinchRotation = event.rotation;
        pinchEventWorkaround._lastPinchEvent = event;
        this.updateViewport(newControllerState, NO_TRANSITION_PROPS, {
            isDragging: true
        });
        return true;
    }
    _onPinch(event) {
        if (!this.touchZoom && !this.touchRotate) return false;
        if (!this.isDragging()) return false;
        let newControllerState = this.controllerState;
        if (this.touchZoom) {
            const { scale  } = event;
            const pos = this.getCenter(event);
            newControllerState = newControllerState.zoom({
                pos,
                scale
            });
        }
        if (this.touchRotate) {
            const { rotation  } = event;
            newControllerState = newControllerState.rotate({
                deltaAngleX: pinchEventWorkaround._startPinchRotation - rotation
            });
        }
        this.updateViewport(newControllerState, NO_TRANSITION_PROPS, {
            isDragging: true,
            isPanning: this.touchZoom,
            isZooming: this.touchZoom,
            isRotating: this.touchRotate
        });
        pinchEventWorkaround._lastPinchEvent = event;
        return true;
    }
    _onPinchEnd(event) {
        if (!this.isDragging()) return false;
        const { inertia  } = this;
        const { _lastPinchEvent  } = pinchEventWorkaround;
        if (this.touchZoom && inertia && _lastPinchEvent && event.scale !== _lastPinchEvent.scale) {
            const pos = this.getCenter(event);
            let newControllerState = this.controllerState.rotateEnd();
            const z = Math.log2(event.scale);
            const velocityZ = (z - Math.log2(_lastPinchEvent.scale)) / (event.deltaTime - _lastPinchEvent.deltaTime);
            const endScale = Math.pow(2, z + velocityZ * inertia / 2);
            newControllerState = newControllerState.zoom({
                pos,
                scale: endScale
            }).zoomEnd();
            this.updateViewport(newControllerState, {
                ...this._getTransitionProps({
                    around: pos
                }),
                transitionDuration: inertia,
                transitionEasing: INERTIA_EASING
            }, {
                isDragging: false,
                isPanning: this.touchZoom,
                isZooming: this.touchZoom,
                isRotating: false
            });
            this.blockEvents(inertia);
        } else {
            const newControllerState1 = this.controllerState.zoomEnd().rotateEnd();
            this.updateViewport(newControllerState1, null, {
                isDragging: false,
                isPanning: false,
                isZooming: false,
                isRotating: false
            });
        }
        pinchEventWorkaround._startPinchRotation = null;
        pinchEventWorkaround._lastPinchEvent = null;
        return true;
    }
    _onDoubleTap(event) {
        if (!this.doubleClickZoom) return false;
        const pos = this.getCenter(event);
        if (!this.isPointInBounds(pos, event)) return false;
        const isZoomOut = this.isFunctionKeyPressed(event);
        const newControllerState = this.controllerState.zoom({
            pos,
            scale: isZoomOut ? 0.5 : 2
        });
        this.updateViewport(newControllerState, this._getTransitionProps({
            around: pos
        }), {
            isZooming: true,
            isPanning: true
        });
        this.blockEvents(100);
        return true;
    }
    _onKeyDown(event) {
        if (!this.keyboard) return false;
        const funcKey = this.isFunctionKeyPressed(event);
        const { zoomSpeed , moveSpeed , rotateSpeedX , rotateSpeedY  } = this.keyboard === true ? {} : this.keyboard;
        const { controllerState  } = this;
        let newControllerState;
        const interactionState = {};
        switch(event.srcEvent.code){
            case "Minus":
                newControllerState = funcKey ? controllerState.zoomOut(zoomSpeed).zoomOut(zoomSpeed) : controllerState.zoomOut(zoomSpeed);
                interactionState.isZooming = true;
                break;
            case "Equal":
                newControllerState = funcKey ? controllerState.zoomIn(zoomSpeed).zoomIn(zoomSpeed) : controllerState.zoomIn(zoomSpeed);
                interactionState.isZooming = true;
                break;
            case "ArrowLeft":
                if (funcKey) {
                    newControllerState = controllerState.rotateLeft(rotateSpeedX);
                    interactionState.isRotating = true;
                } else {
                    newControllerState = controllerState.moveLeft(moveSpeed);
                    interactionState.isPanning = true;
                }
                break;
            case "ArrowRight":
                if (funcKey) {
                    newControllerState = controllerState.rotateRight(rotateSpeedX);
                    interactionState.isRotating = true;
                } else {
                    newControllerState = controllerState.moveRight(moveSpeed);
                    interactionState.isPanning = true;
                }
                break;
            case "ArrowUp":
                if (funcKey) {
                    newControllerState = controllerState.rotateUp(rotateSpeedY);
                    interactionState.isRotating = true;
                } else {
                    newControllerState = controllerState.moveUp(moveSpeed);
                    interactionState.isPanning = true;
                }
                break;
            case "ArrowDown":
                if (funcKey) {
                    newControllerState = controllerState.rotateDown(rotateSpeedY);
                    interactionState.isRotating = true;
                } else {
                    newControllerState = controllerState.moveDown(moveSpeed);
                    interactionState.isPanning = true;
                }
                break;
            default:
                return false;
        }
        this.updateViewport(newControllerState, this._getTransitionProps(), interactionState);
        return true;
    }
    _getTransitionProps(opts) {
        const { transition  } = this;
        if (!transition || !transition.transitionInterpolator) return NO_TRANSITION_PROPS;
        return opts ? {
            ...transition,
            transitionInterpolator: new (0, _linearInterpolatorDefault.default)({
                ...opts,
                ...transition.transitionInterpolator.opts,
                makeViewport: this.controllerState.makeViewport
            })
        } : transition;
    }
}
exports.default = Controller;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./transition-manager":"e2pjH","../transitions/linear-interpolator":"fCusj","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"e2pjH":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "TRANSITION_EVENTS", ()=>TRANSITION_EVENTS);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _transition = require("../transitions/transition");
var _transitionDefault = parcelHelpers.interopDefault(_transition);
const noop = ()=>{};
const TRANSITION_EVENTS = {
    BREAK: 1,
    SNAP_TO_END: 2,
    IGNORE: 3
};
const DEFAULT_EASING = (t)=>t;
const DEFAULT_INTERRUPTION = TRANSITION_EVENTS.BREAK;
class TransitionManager {
    constructor(opts){
        (0, _definePropertyDefault.default)(this, "getControllerState", void 0);
        (0, _definePropertyDefault.default)(this, "props", void 0);
        (0, _definePropertyDefault.default)(this, "propsInTransition", void 0);
        (0, _definePropertyDefault.default)(this, "transition", void 0);
        (0, _definePropertyDefault.default)(this, "onViewStateChange", void 0);
        (0, _definePropertyDefault.default)(this, "onStateChange", void 0);
        (0, _definePropertyDefault.default)(this, "_onTransitionUpdate", (transition)=>{
            const { time , settings: { interpolator , startProps , endProps , duration , easing  }  } = transition;
            const t = easing(time / duration);
            const viewport = interpolator.interpolateProps(startProps, endProps, t);
            this.propsInTransition = this.getControllerState({
                ...this.props,
                ...viewport
            }).getViewportProps();
            this.onViewStateChange({
                viewState: this.propsInTransition,
                oldViewState: this.props
            });
        });
        this.getControllerState = opts.getControllerState;
        this.propsInTransition = null;
        this.transition = new (0, _transitionDefault.default)(opts.timeline);
        this.onViewStateChange = opts.onViewStateChange || noop;
        this.onStateChange = opts.onStateChange || noop;
    }
    finalize() {
        this.transition.cancel();
    }
    getViewportInTransition() {
        return this.propsInTransition;
    }
    processViewStateChange(nextProps) {
        let transitionTriggered = false;
        const currentProps = this.props;
        this.props = nextProps;
        if (!currentProps || this._shouldIgnoreViewportChange(currentProps, nextProps)) return false;
        if (this._isTransitionEnabled(nextProps)) {
            let startProps = currentProps;
            if (this.transition.inProgress) {
                const { interruption , endProps  } = this.transition.settings;
                startProps = {
                    ...currentProps,
                    ...interruption === TRANSITION_EVENTS.SNAP_TO_END ? endProps : this.propsInTransition || currentProps
                };
            }
            this._triggerTransition(startProps, nextProps);
            transitionTriggered = true;
        } else this.transition.cancel();
        return transitionTriggered;
    }
    updateTransition() {
        this.transition.update();
    }
    _isTransitionEnabled(props) {
        const { transitionDuration , transitionInterpolator  } = props;
        return (transitionDuration > 0 || transitionDuration === "auto") && Boolean(transitionInterpolator);
    }
    _isUpdateDueToCurrentTransition(props) {
        if (this.transition.inProgress && this.propsInTransition) return this.transition.settings.interpolator.arePropsEqual(props, this.propsInTransition);
        return false;
    }
    _shouldIgnoreViewportChange(currentProps, nextProps) {
        if (this.transition.inProgress) return this.transition.settings.interruption === TRANSITION_EVENTS.IGNORE || this._isUpdateDueToCurrentTransition(nextProps);
        if (this._isTransitionEnabled(nextProps)) return nextProps.transitionInterpolator.arePropsEqual(currentProps, nextProps);
        return true;
    }
    _triggerTransition(startProps, endProps) {
        const startViewstate = this.getControllerState(startProps);
        const endViewStateProps = this.getControllerState(endProps).shortestPathFrom(startViewstate);
        const transitionInterpolator = endProps.transitionInterpolator;
        const duration = transitionInterpolator.getDuration ? transitionInterpolator.getDuration(startProps, endProps) : endProps.transitionDuration;
        if (duration === 0) return;
        const initialProps = transitionInterpolator.initializeProps(startProps, endViewStateProps);
        this.propsInTransition = {};
        const transitionSettings = {
            duration,
            easing: endProps.transitionEasing || DEFAULT_EASING,
            interpolator: transitionInterpolator,
            interruption: endProps.transitionInterruption || DEFAULT_INTERRUPTION,
            startProps: initialProps.start,
            endProps: initialProps.end,
            onStart: endProps.onTransitionStart,
            onUpdate: this._onTransitionUpdate,
            onInterrupt: this._onTransitionEnd(endProps.onTransitionInterrupt),
            onEnd: this._onTransitionEnd(endProps.onTransitionEnd)
        };
        this.transition.start(transitionSettings);
        this.onStateChange({
            inTransition: true
        });
        this.updateTransition();
    }
    _onTransitionEnd(callback) {
        return (transition)=>{
            this.propsInTransition = null;
            this.onStateChange({
                inTransition: false,
                isZooming: false,
                isPanning: false,
                isRotating: false
            });
            callback === null || callback === void 0 || callback(transition);
        };
    }
}
exports.default = TransitionManager;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../transitions/transition":"kwq3Z","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kwq3Z":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
class Transition {
    constructor(timeline){
        (0, _definePropertyDefault.default)(this, "_inProgress", void 0);
        (0, _definePropertyDefault.default)(this, "_handle", void 0);
        (0, _definePropertyDefault.default)(this, "_timeline", void 0);
        (0, _definePropertyDefault.default)(this, "time", void 0);
        (0, _definePropertyDefault.default)(this, "settings", void 0);
        this._inProgress = false;
        this._handle = null;
        this._timeline = timeline;
        this.time = 0;
        this.settings = {
            duration: 0
        };
    }
    get inProgress() {
        return this._inProgress;
    }
    start(settings) {
        var _this$settings$onStar, _this$settings;
        this.cancel();
        this.settings = settings;
        this._inProgress = true;
        (_this$settings$onStar = (_this$settings = this.settings).onStart) === null || _this$settings$onStar === void 0 || _this$settings$onStar.call(_this$settings, this);
    }
    end() {
        if (this._inProgress) {
            var _this$settings$onEnd, _this$settings2;
            this._timeline.removeChannel(this._handle);
            this._handle = null;
            this._inProgress = false;
            (_this$settings$onEnd = (_this$settings2 = this.settings).onEnd) === null || _this$settings$onEnd === void 0 || _this$settings$onEnd.call(_this$settings2, this);
        }
    }
    cancel() {
        if (this._inProgress) {
            var _this$settings$onInte, _this$settings3;
            (_this$settings$onInte = (_this$settings3 = this.settings).onInterrupt) === null || _this$settings$onInte === void 0 || _this$settings$onInte.call(_this$settings3, this);
            this._timeline.removeChannel(this._handle);
            this._handle = null;
            this._inProgress = false;
        }
    }
    update() {
        var _this$settings$onUpda, _this$settings4;
        if (!this._inProgress) return false;
        if (this._handle === null) {
            const { _timeline: timeline , settings  } = this;
            this._handle = timeline.addChannel({
                delay: timeline.getTime(),
                duration: settings.duration
            });
        }
        this.time = this._timeline.getTime(this._handle);
        this._onUpdate();
        (_this$settings$onUpda = (_this$settings4 = this.settings).onUpdate) === null || _this$settings$onUpda === void 0 || _this$settings$onUpda.call(_this$settings4, this);
        if (this._timeline.isFinished(this._handle)) this.end();
        return true;
    }
    _onUpdate() {}
}
exports.default = Transition;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fCusj":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _transitionInterpolator = require("./transition-interpolator");
var _transitionInterpolatorDefault = parcelHelpers.interopDefault(_transitionInterpolator);
var _core = require("@math.gl/core");
const DEFAULT_PROPS = [
    "longitude",
    "latitude",
    "zoom",
    "bearing",
    "pitch"
];
const DEFAULT_REQUIRED_PROPS = [
    "longitude",
    "latitude",
    "zoom"
];
class LinearInterpolator extends (0, _transitionInterpolatorDefault.default) {
    constructor(opts = {}){
        const transitionProps = Array.isArray(opts) ? opts : opts.transitionProps;
        const normalizedOpts = Array.isArray(opts) ? {} : opts;
        normalizedOpts.transitionProps = Array.isArray(transitionProps) ? {
            compare: transitionProps,
            required: transitionProps
        } : transitionProps || {
            compare: DEFAULT_PROPS,
            required: DEFAULT_REQUIRED_PROPS
        };
        super(normalizedOpts.transitionProps);
        (0, _definePropertyDefault.default)(this, "opts", void 0);
        this.opts = normalizedOpts;
    }
    initializeProps(startProps, endProps) {
        const result = super.initializeProps(startProps, endProps);
        const { makeViewport , around  } = this.opts;
        if (makeViewport && around) {
            const startViewport = makeViewport(startProps);
            const endViewport = makeViewport(endProps);
            const aroundPosition = startViewport.unproject(around);
            result.start.around = around;
            Object.assign(result.end, {
                around: endViewport.project(aroundPosition),
                aroundPosition,
                width: endProps.width,
                height: endProps.height
            });
        }
        return result;
    }
    interpolateProps(startProps, endProps, t) {
        const propsInTransition = {};
        for (const key of this._propsToExtract)propsInTransition[key] = (0, _core.lerp)(startProps[key] || 0, endProps[key] || 0, t);
        if (endProps.aroundPosition && this.opts.makeViewport) {
            const viewport = this.opts.makeViewport({
                ...endProps,
                ...propsInTransition
            });
            Object.assign(propsInTransition, viewport.panByPosition(endProps.aroundPosition, (0, _core.lerp)(startProps.around, endProps.around, t)));
        }
        return propsInTransition;
    }
}
exports.default = LinearInterpolator;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./transition-interpolator":"3ldCS","@math.gl/core":"9lgwD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3ldCS":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@math.gl/core");
var _assert = require("../utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
class TransitionInterpolator {
    constructor(opts){
        (0, _definePropertyDefault.default)(this, "_propsToCompare", void 0);
        (0, _definePropertyDefault.default)(this, "_propsToExtract", void 0);
        (0, _definePropertyDefault.default)(this, "_requiredProps", void 0);
        const { compare , extract , required  } = opts;
        this._propsToCompare = compare;
        this._propsToExtract = extract || compare;
        this._requiredProps = required;
    }
    arePropsEqual(currentProps, nextProps) {
        for (const key of this._propsToCompare){
            if (!(key in currentProps) || !(key in nextProps) || !(0, _core.equals)(currentProps[key], nextProps[key])) return false;
        }
        return true;
    }
    initializeProps(startProps, endProps) {
        const startViewStateProps = {};
        const endViewStateProps = {};
        for (const key of this._propsToExtract)if (key in startProps || key in endProps) {
            startViewStateProps[key] = startProps[key];
            endViewStateProps[key] = endProps[key];
        }
        this._checkRequiredProps(startViewStateProps);
        this._checkRequiredProps(endViewStateProps);
        return {
            start: startViewStateProps,
            end: endViewStateProps
        };
    }
    getDuration(startProps, endProps) {
        return endProps.transitionDuration;
    }
    _checkRequiredProps(props) {
        if (!this._requiredProps) return;
        this._requiredProps.forEach((propName)=>{
            const value = props[propName];
            (0, _assertDefault.default)(Number.isFinite(value) || Array.isArray(value), "".concat(propName, " is required for transition"));
        });
    }
}
exports.default = TransitionInterpolator;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@math.gl/core":"9lgwD","../utils/assert":"aysGh","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kDVkd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
class ViewState {
    constructor(props, state){
        (0, _definePropertyDefault.default)(this, "_viewportProps", void 0);
        (0, _definePropertyDefault.default)(this, "_state", void 0);
        this._viewportProps = this.applyConstraints(props);
        this._state = state;
    }
    getViewportProps() {
        return this._viewportProps;
    }
    getState() {
        return this._state;
    }
}
exports.default = ViewState;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5qaq3":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _deepEqual = require("../utils/deep-equal");
var _lightingEffect = require("../effects/lighting/lighting-effect");
var _lightingEffectDefault = parcelHelpers.interopDefault(_lightingEffect);
var _maskEffect = require("../effects/mask/mask-effect");
var _maskEffectDefault = parcelHelpers.interopDefault(_maskEffect);
const DEFAULT_LIGHTING_EFFECT = new (0, _lightingEffectDefault.default)();
class EffectManager {
    constructor(){
        (0, _definePropertyDefault.default)(this, "effects", void 0);
        (0, _definePropertyDefault.default)(this, "_internalEffects", void 0);
        (0, _definePropertyDefault.default)(this, "_needsRedraw", void 0);
        this.effects = [];
        this._internalEffects = [];
        this._needsRedraw = "Initial render";
        this.setEffects();
    }
    setProps(props) {
        if ("effects" in props) {
            if (props.effects.length !== this.effects.length || !(0, _deepEqual.deepEqual)(props.effects, this.effects)) {
                this.setEffects(props.effects);
                this._needsRedraw = "effects changed";
            }
        }
    }
    needsRedraw(opts = {
        clearRedrawFlags: false
    }) {
        const redraw = this._needsRedraw;
        if (opts.clearRedrawFlags) this._needsRedraw = false;
        return redraw;
    }
    getEffects() {
        return this._internalEffects;
    }
    finalize() {
        this.cleanup();
    }
    setEffects(effects = []) {
        this.cleanup();
        this.effects = effects;
        this._internalEffects = effects.slice();
        this._internalEffects.push(new (0, _maskEffectDefault.default)());
        if (!effects.some((effect)=>effect instanceof (0, _lightingEffectDefault.default))) this._internalEffects.push(DEFAULT_LIGHTING_EFFECT);
    }
    cleanup() {
        for (const effect of this.effects)effect.cleanup();
        for (const effect1 of this._internalEffects)effect1.cleanup();
        this.effects.length = 0;
        this._internalEffects.length = 0;
    }
}
exports.default = EffectManager;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../utils/deep-equal":"cspiV","../effects/lighting/lighting-effect":"3N8o6","../effects/mask/mask-effect":"726Be","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"726Be":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _core1 = require("@math.gl/core");
var _maskPass = require("../../passes/mask-pass");
var _maskPassDefault = parcelHelpers.interopDefault(_maskPass);
var _constants = require("../../lib/constants");
var _utils = require("./utils");
var _log = require("../../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
class MaskEffect {
    constructor(){
        (0, _definePropertyDefault.default)(this, "id", "mask-effect");
        (0, _definePropertyDefault.default)(this, "props", null);
        (0, _definePropertyDefault.default)(this, "useInPicking", true);
        (0, _definePropertyDefault.default)(this, "dummyMaskMap", void 0);
        (0, _definePropertyDefault.default)(this, "channels", []);
        (0, _definePropertyDefault.default)(this, "masks", null);
        (0, _definePropertyDefault.default)(this, "maskPass", void 0);
        (0, _definePropertyDefault.default)(this, "maskMap", void 0);
        (0, _definePropertyDefault.default)(this, "lastViewport", void 0);
    }
    preRender(gl, { layers , layerFilter , viewports , onViewportActive , views  }) {
        if (!this.dummyMaskMap) this.dummyMaskMap = new (0, _core.Texture2D)(gl, {
            width: 1,
            height: 1
        });
        const maskLayers = layers.filter((l)=>l.props.visible && l.props.operation === (0, _constants.OPERATION).MASK);
        if (maskLayers.length === 0) {
            this.masks = null;
            this.channels.length = 0;
            return;
        }
        this.masks = {};
        if (!this.maskPass) {
            this.maskPass = new (0, _maskPassDefault.default)(gl, {
                id: "default-mask"
            });
            this.maskMap = this.maskPass.maskMap;
        }
        const channelMap = this._sortMaskChannels(maskLayers);
        const viewport = viewports[0];
        const viewportChanged = !this.lastViewport || !this.lastViewport.equals(viewport);
        for(const maskId in channelMap)this._renderChannel(channelMap[maskId], {
            layerFilter,
            onViewportActive,
            views,
            viewport,
            viewportChanged
        });
    }
    _renderChannel(channelInfo, { layerFilter , onViewportActive , views , viewport , viewportChanged  }) {
        const oldChannelInfo = this.channels[channelInfo.index];
        if (!oldChannelInfo) return;
        const maskChanged = channelInfo === oldChannelInfo || oldChannelInfo.layers.length !== channelInfo.layers.length || channelInfo.layerBounds.some((b, i)=>b !== oldChannelInfo.layerBounds[i]);
        channelInfo.bounds = oldChannelInfo.bounds;
        channelInfo.maskBounds = oldChannelInfo.maskBounds;
        this.channels[channelInfo.index] = channelInfo;
        if (maskChanged || viewportChanged) {
            this.lastViewport = viewport;
            channelInfo.bounds = (0, _utils.getMaskBounds)({
                layers: channelInfo.layers,
                viewport
            });
            if (maskChanged || !(0, _core1.equals)(channelInfo.bounds, oldChannelInfo.bounds)) {
                const { maskPass , maskMap  } = this;
                const maskViewport = (0, _utils.getMaskViewport)({
                    bounds: channelInfo.bounds,
                    viewport,
                    width: maskMap.width,
                    height: maskMap.height
                });
                channelInfo.maskBounds = maskViewport ? maskViewport.getBounds() : [
                    0,
                    0,
                    1,
                    1
                ];
                maskPass.render({
                    pass: "mask",
                    channel: channelInfo.index,
                    layers: channelInfo.layers,
                    layerFilter,
                    viewports: maskViewport ? [
                        maskViewport
                    ] : [],
                    onViewportActive,
                    views,
                    moduleParameters: {
                        devicePixelRatio: 1
                    }
                });
            }
        }
        this.masks[channelInfo.id] = {
            index: channelInfo.index,
            bounds: channelInfo.maskBounds,
            coordinateOrigin: channelInfo.coordinateOrigin,
            coordinateSystem: channelInfo.coordinateSystem
        };
    }
    _sortMaskChannels(maskLayers) {
        const channelMap = {};
        let channelCount = 0;
        for (const layer of maskLayers){
            const { id  } = layer.root;
            let channelInfo = channelMap[id];
            if (!channelInfo) {
                if (++channelCount > 4) {
                    (0, _logDefault.default).warn("Too many mask layers. The max supported is 4")();
                    continue;
                }
                channelInfo = {
                    id,
                    index: this.channels.findIndex((c)=>(c === null || c === void 0 ? void 0 : c.id) === id),
                    layers: [],
                    layerBounds: [],
                    coordinateOrigin: layer.root.props.coordinateOrigin,
                    coordinateSystem: layer.root.props.coordinateSystem
                };
                channelMap[id] = channelInfo;
            }
            channelInfo.layers.push(layer);
            channelInfo.layerBounds.push(layer.getBounds());
        }
        for(let i = 0; i < 4; i++){
            const channelInfo1 = this.channels[i];
            if (!channelInfo1 || !(channelInfo1.id in channelMap)) this.channels[i] = null;
        }
        for(const maskId in channelMap){
            const channelInfo2 = channelMap[maskId];
            if (channelInfo2.index < 0) {
                channelInfo2.index = this.channels.findIndex((c)=>!c);
                this.channels[channelInfo2.index] = channelInfo2;
            }
        }
        return channelMap;
    }
    getModuleParameters() {
        return {
            maskMap: this.masks ? this.maskMap : this.dummyMaskMap,
            maskChannels: this.masks
        };
    }
    cleanup() {
        if (this.dummyMaskMap) {
            this.dummyMaskMap.delete();
            this.dummyMaskMap = undefined;
        }
        if (this.maskPass) {
            this.maskPass.delete();
            this.maskPass = undefined;
            this.maskMap = undefined;
        }
        this.lastViewport = undefined;
        this.masks = null;
        this.channels.length = 0;
    }
}
exports.default = MaskEffect;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","@math.gl/core":"9lgwD","../../passes/mask-pass":"bwRDt","../../lib/constants":"ksWme","./utils":"gGVFa","../../utils/log":"iINk7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bwRDt":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _constants = require("../lib/constants");
var _layersPass = require("./layers-pass");
var _layersPassDefault = parcelHelpers.interopDefault(_layersPass);
class MaskPass extends (0, _layersPassDefault.default) {
    constructor(gl, props){
        super(gl, props);
        (0, _definePropertyDefault.default)(this, "maskMap", void 0);
        (0, _definePropertyDefault.default)(this, "fbo", void 0);
        const { mapSize =2048  } = props;
        this.maskMap = new (0, _core.Texture2D)(gl, {
            width: mapSize,
            height: mapSize,
            parameters: {
                [10241]: 9729,
                [10240]: 9729,
                [10242]: 33071,
                [10243]: 33071
            }
        });
        this.fbo = new (0, _core.Framebuffer)(gl, {
            id: "maskmap",
            width: mapSize,
            height: mapSize,
            attachments: {
                [36064]: this.maskMap
            }
        });
    }
    render(options) {
        const gl = this.gl;
        const colorMask = [
            false,
            false,
            false,
            false
        ];
        colorMask[options.channel] = true;
        return (0, _core.withParameters)(gl, {
            clearColor: [
                255,
                255,
                255,
                255
            ],
            blend: true,
            blendFunc: [
                0,
                1
            ],
            blendEquation: 32778,
            colorMask,
            depthTest: false
        }, ()=>super.render({
                ...options,
                target: this.fbo,
                pass: "mask"
            }));
    }
    shouldDrawLayer(layer) {
        return layer.props.operation === (0, _constants.OPERATION).MASK;
    }
    delete() {
        this.fbo.delete();
        this.maskMap.delete();
    }
}
exports.default = MaskPass;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","../lib/constants":"ksWme","./layers-pass":"bsyAy","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gGVFa":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getMaskBounds", ()=>getMaskBounds);
parcelHelpers.export(exports, "getMaskViewport", ()=>getMaskViewport);
var _orthographicView = require("../../views/orthographic-view");
var _orthographicViewDefault = parcelHelpers.interopDefault(_orthographicView);
var _webMercatorViewport = require("../../viewports/web-mercator-viewport");
var _webMercatorViewportDefault = parcelHelpers.interopDefault(_webMercatorViewport);
var _webMercator = require("@math.gl/web-mercator");
function getMaskBounds({ layers , viewport  }) {
    let bounds = null;
    for (const layer of layers){
        const subLayerBounds = layer.getBounds();
        if (subLayerBounds) {
            if (bounds) {
                bounds[0] = Math.min(bounds[0], subLayerBounds[0][0]);
                bounds[1] = Math.min(bounds[1], subLayerBounds[0][1]);
                bounds[2] = Math.max(bounds[2], subLayerBounds[1][0]);
                bounds[3] = Math.max(bounds[3], subLayerBounds[1][1]);
            } else bounds = [
                subLayerBounds[0][0],
                subLayerBounds[0][1],
                subLayerBounds[1][0],
                subLayerBounds[1][1]
            ];
        }
    }
    const viewportBounds = viewport.getBounds();
    if (!bounds) return viewportBounds;
    const paddedBounds = _doubleBounds(viewportBounds);
    if (bounds[2] - bounds[0] < paddedBounds[2] - paddedBounds[0] || bounds[3] - bounds[1] < paddedBounds[3] - paddedBounds[1]) return bounds;
    bounds[0] = Math.max(bounds[0], paddedBounds[0]);
    bounds[1] = Math.max(bounds[1], paddedBounds[1]);
    bounds[2] = Math.min(bounds[2], paddedBounds[2]);
    bounds[3] = Math.min(bounds[3], paddedBounds[3]);
    return bounds;
}
function getMaskViewport({ bounds , viewport , width , height  }) {
    if (bounds[2] <= bounds[0] || bounds[3] <= bounds[1]) return null;
    const padding = 1;
    width -= padding * 2;
    height -= padding * 2;
    if (viewport instanceof (0, _webMercatorViewportDefault.default)) {
        const { longitude , latitude , zoom  } = (0, _webMercator.fitBounds)({
            width,
            height,
            bounds: [
                [
                    bounds[0],
                    bounds[1]
                ],
                [
                    bounds[2],
                    bounds[3]
                ]
            ],
            maxZoom: 20
        });
        return new (0, _webMercatorViewportDefault.default)({
            longitude,
            latitude,
            zoom,
            x: padding,
            y: padding,
            width,
            height
        });
    }
    const center = [
        (bounds[0] + bounds[2]) / 2,
        (bounds[1] + bounds[3]) / 2,
        0
    ];
    const scale = Math.min(20, width / (bounds[2] - bounds[0]), height / (bounds[3] - bounds[1]));
    return new (0, _orthographicViewDefault.default)({
        x: padding,
        y: padding
    }).makeViewport({
        width,
        height,
        viewState: {
            target: center,
            zoom: Math.log2(scale)
        }
    });
}
function _doubleBounds(bounds) {
    const size = {
        x: bounds[2] - bounds[0],
        y: bounds[3] - bounds[1]
    };
    const center = {
        x: bounds[0] + 0.5 * size.x,
        y: bounds[1] + 0.5 * size.y
    };
    return [
        center.x - size.x,
        center.y - size.y,
        center.x + size.x,
        center.y + size.y
    ];
}

},{"../../views/orthographic-view":"kAGcQ","../../viewports/web-mercator-viewport":"cVyIy","@math.gl/web-mercator":"aEEkN","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kAGcQ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _view = require("./view");
var _viewDefault = parcelHelpers.interopDefault(_view);
var _orthographicViewport = require("../viewports/orthographic-viewport");
var _orthographicViewportDefault = parcelHelpers.interopDefault(_orthographicViewport);
var _orthographicController = require("../controllers/orthographic-controller");
var _orthographicControllerDefault = parcelHelpers.interopDefault(_orthographicController);
class OrthographicView extends (0, _viewDefault.default) {
    get ViewportType() {
        return 0, _orthographicViewportDefault.default;
    }
    get ControllerType() {
        return 0, _orthographicControllerDefault.default;
    }
}
exports.default = OrthographicView;
(0, _definePropertyDefault.default)(OrthographicView, "displayName", "OrthographicView");

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./view":"iThAT","../viewports/orthographic-viewport":"dwTyd","../controllers/orthographic-controller":"6YTVr","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dwTyd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _viewport = require("../viewports/viewport");
var _viewportDefault = parcelHelpers.interopDefault(_viewport);
var _core = require("@math.gl/core");
var _webMercator = require("@math.gl/web-mercator");
var _vec2 = require("gl-matrix/vec2");
const viewMatrix = new (0, _core.Matrix4)().lookAt({
    eye: [
        0,
        0,
        1
    ]
});
function getProjectionMatrix({ width , height , near , far , padding  }) {
    let left = -width / 2;
    let right = width / 2;
    let bottom = -height / 2;
    let top = height / 2;
    if (padding) {
        const { left: l = 0 , right: r = 0 , top: t = 0 , bottom: b = 0  } = padding;
        const offsetX = (0, _core.clamp)((l + width - r) / 2, 0, width) - width / 2;
        const offsetY = (0, _core.clamp)((t + height - b) / 2, 0, height) - height / 2;
        left -= offsetX;
        right -= offsetX;
        bottom += offsetY;
        top += offsetY;
    }
    return new (0, _core.Matrix4)().ortho({
        left,
        right,
        bottom,
        top,
        near,
        far
    });
}
class OrthographicViewport extends (0, _viewportDefault.default) {
    constructor(props){
        const { width , height , near =0.1 , far =1000 , zoom =0 , target =[
            0,
            0,
            0
        ] , padding =null , flipY =true  } = props;
        const zoomX = Array.isArray(zoom) ? zoom[0] : zoom;
        const zoomY = Array.isArray(zoom) ? zoom[1] : zoom;
        const zoom_ = Math.min(zoomX, zoomY);
        const scale = Math.pow(2, zoom_);
        let distanceScales;
        if (zoomX !== zoomY) {
            const scaleX = Math.pow(2, zoomX);
            const scaleY = Math.pow(2, zoomY);
            distanceScales = {
                unitsPerMeter: [
                    scaleX / scale,
                    scaleY / scale,
                    1
                ],
                metersPerUnit: [
                    scale / scaleX,
                    scale / scaleY,
                    1
                ]
            };
        }
        super({
            ...props,
            longitude: undefined,
            position: target,
            viewMatrix: viewMatrix.clone().scale([
                scale,
                scale * (flipY ? -1 : 1),
                scale
            ]),
            projectionMatrix: getProjectionMatrix({
                width: width || 1,
                height: height || 1,
                padding,
                near,
                far
            }),
            zoom: zoom_,
            distanceScales
        });
    }
    projectFlat([X, Y]) {
        const { unitsPerMeter  } = this.distanceScales;
        return [
            X * unitsPerMeter[0],
            Y * unitsPerMeter[1]
        ];
    }
    unprojectFlat([x, y]) {
        const { metersPerUnit  } = this.distanceScales;
        return [
            x * metersPerUnit[0],
            y * metersPerUnit[1]
        ];
    }
    panByPosition(coords, pixel) {
        const fromLocation = (0, _webMercator.pixelsToWorld)(pixel, this.pixelUnprojectionMatrix);
        const toLocation = this.projectFlat(coords);
        const translate = _vec2.add([], toLocation, _vec2.negate([], fromLocation));
        const newCenter = _vec2.add([], this.center, translate);
        return {
            target: this.unprojectFlat(newCenter)
        };
    }
}
exports.default = OrthographicViewport;

},{"../viewports/viewport":"kxGGY","@math.gl/core":"9lgwD","@math.gl/web-mercator":"aEEkN","gl-matrix/vec2":"5mYHR","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6YTVr":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@math.gl/core");
var _controller = require("./controller");
var _controllerDefault = parcelHelpers.interopDefault(_controller);
var _orbitController = require("./orbit-controller");
var _linearInterpolator = require("../transitions/linear-interpolator");
var _linearInterpolatorDefault = parcelHelpers.interopDefault(_linearInterpolator);
class OrthographicState extends (0, _orbitController.OrbitState) {
    constructor(props){
        super(props);
        (0, _definePropertyDefault.default)(this, "zoomAxis", void 0);
        this.zoomAxis = props.zoomAxis || "all";
    }
    _calculateNewZoom({ scale , startZoom  }) {
        const { maxZoom , minZoom  } = this.getViewportProps();
        if (startZoom === undefined) startZoom = this.getViewportProps().zoom;
        let deltaZoom = Math.log2(scale);
        if (Array.isArray(startZoom)) {
            let [newZoomX, newZoomY] = startZoom;
            switch(this.zoomAxis){
                case "X":
                    newZoomX = (0, _core.clamp)(newZoomX + deltaZoom, minZoom, maxZoom);
                    break;
                case "Y":
                    newZoomY = (0, _core.clamp)(newZoomY + deltaZoom, minZoom, maxZoom);
                    break;
                default:
                    let z = Math.min(newZoomX + deltaZoom, newZoomY + deltaZoom);
                    if (z < minZoom) deltaZoom += minZoom - z;
                    z = Math.max(newZoomX + deltaZoom, newZoomY + deltaZoom);
                    if (z > maxZoom) deltaZoom += maxZoom - z;
                    newZoomX += deltaZoom;
                    newZoomY += deltaZoom;
            }
            return [
                newZoomX,
                newZoomY
            ];
        }
        return (0, _core.clamp)(startZoom + deltaZoom, minZoom, maxZoom);
    }
}
class OrthographicController extends (0, _controllerDefault.default) {
    constructor(...args){
        super(...args);
        (0, _definePropertyDefault.default)(this, "ControllerState", OrthographicState);
        (0, _definePropertyDefault.default)(this, "transition", {
            transitionDuration: 300,
            transitionInterpolator: new (0, _linearInterpolatorDefault.default)([
                "target",
                "zoom"
            ])
        });
        (0, _definePropertyDefault.default)(this, "dragMode", "pan");
    }
    _onPanRotate() {
        return false;
    }
}
exports.default = OrthographicController;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@math.gl/core":"9lgwD","./controller":"4Hxmk","./orbit-controller":"2WwKU","../transitions/linear-interpolator":"fCusj","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2WwKU":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "OrbitState", ()=>OrbitState);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@math.gl/core");
var _controller = require("./controller");
var _controllerDefault = parcelHelpers.interopDefault(_controller);
var _viewState = require("./view-state");
var _viewStateDefault = parcelHelpers.interopDefault(_viewState);
var _mathUtils = require("../utils/math-utils");
var _linearInterpolator = require("../transitions/linear-interpolator");
var _linearInterpolatorDefault = parcelHelpers.interopDefault(_linearInterpolator);
class OrbitState extends (0, _viewStateDefault.default) {
    constructor(options){
        const { width , height , rotationX =0 , rotationOrbit =0 , target =[
            0,
            0,
            0
        ] , zoom =0 , minRotationX =-90 , maxRotationX =90 , minZoom =-Infinity , maxZoom =Infinity , startPanPosition , startRotatePos , startRotationX , startRotationOrbit , startZoomPosition , startZoom  } = options;
        super({
            width,
            height,
            rotationX,
            rotationOrbit,
            target,
            zoom,
            minRotationX,
            maxRotationX,
            minZoom,
            maxZoom
        }, {
            startPanPosition,
            startRotatePos,
            startRotationX,
            startRotationOrbit,
            startZoomPosition,
            startZoom
        });
        (0, _definePropertyDefault.default)(this, "makeViewport", void 0);
        this.makeViewport = options.makeViewport;
    }
    panStart({ pos  }) {
        return this._getUpdatedState({
            startPanPosition: this._unproject(pos)
        });
    }
    pan({ pos , startPosition  }) {
        const startPanPosition = this.getState().startPanPosition || startPosition;
        if (!startPanPosition) return this;
        const viewport = this.makeViewport(this.getViewportProps());
        const newProps = viewport.panByPosition(startPanPosition, pos);
        return this._getUpdatedState(newProps);
    }
    panEnd() {
        return this._getUpdatedState({
            startPanPosition: null
        });
    }
    rotateStart({ pos  }) {
        return this._getUpdatedState({
            startRotatePos: pos,
            startRotationX: this.getViewportProps().rotationX,
            startRotationOrbit: this.getViewportProps().rotationOrbit
        });
    }
    rotate({ pos , deltaAngleX =0 , deltaAngleY =0  }) {
        const { startRotatePos , startRotationX , startRotationOrbit  } = this.getState();
        const { width , height  } = this.getViewportProps();
        if (!startRotatePos || startRotationX === undefined || startRotationOrbit === undefined) return this;
        let newRotation;
        if (pos) {
            let deltaScaleX = (pos[0] - startRotatePos[0]) / width;
            const deltaScaleY = (pos[1] - startRotatePos[1]) / height;
            if (startRotationX < -90 || startRotationX > 90) deltaScaleX *= -1;
            newRotation = {
                rotationX: startRotationX + deltaScaleY * 180,
                rotationOrbit: startRotationOrbit + deltaScaleX * 180
            };
        } else newRotation = {
            rotationX: startRotationX + deltaAngleY,
            rotationOrbit: startRotationOrbit + deltaAngleX
        };
        return this._getUpdatedState(newRotation);
    }
    rotateEnd() {
        return this._getUpdatedState({
            startRotationX: null,
            startRotationOrbit: null
        });
    }
    shortestPathFrom(viewState) {
        const fromProps = viewState.getViewportProps();
        const props = {
            ...this.getViewportProps()
        };
        const { rotationOrbit  } = props;
        if (Math.abs(rotationOrbit - fromProps.rotationOrbit) > 180) props.rotationOrbit = rotationOrbit < 0 ? rotationOrbit + 360 : rotationOrbit - 360;
        return props;
    }
    zoomStart({ pos  }) {
        return this._getUpdatedState({
            startZoomPosition: this._unproject(pos),
            startZoom: this.getViewportProps().zoom
        });
    }
    zoom({ pos , startPos , scale  }) {
        let { startZoom , startZoomPosition  } = this.getState();
        if (!startZoomPosition) {
            startZoom = this.getViewportProps().zoom;
            startZoomPosition = this._unproject(startPos) || this._unproject(pos);
        }
        if (!startZoomPosition) return this;
        const newZoom = this._calculateNewZoom({
            scale,
            startZoom
        });
        const zoomedViewport = this.makeViewport({
            ...this.getViewportProps(),
            zoom: newZoom
        });
        return this._getUpdatedState({
            zoom: newZoom,
            ...zoomedViewport.panByPosition(startZoomPosition, pos)
        });
    }
    zoomEnd() {
        return this._getUpdatedState({
            startZoomPosition: null,
            startZoom: null
        });
    }
    zoomIn(speed = 2) {
        return this._getUpdatedState({
            zoom: this._calculateNewZoom({
                scale: speed
            })
        });
    }
    zoomOut(speed = 2) {
        return this._getUpdatedState({
            zoom: this._calculateNewZoom({
                scale: 1 / speed
            })
        });
    }
    moveLeft(speed = 50) {
        return this._panFromCenter([
            -speed,
            0
        ]);
    }
    moveRight(speed = 50) {
        return this._panFromCenter([
            speed,
            0
        ]);
    }
    moveUp(speed = 50) {
        return this._panFromCenter([
            0,
            -speed
        ]);
    }
    moveDown(speed = 50) {
        return this._panFromCenter([
            0,
            speed
        ]);
    }
    rotateLeft(speed = 15) {
        return this._getUpdatedState({
            rotationOrbit: this.getViewportProps().rotationOrbit - speed
        });
    }
    rotateRight(speed = 15) {
        return this._getUpdatedState({
            rotationOrbit: this.getViewportProps().rotationOrbit + speed
        });
    }
    rotateUp(speed = 10) {
        return this._getUpdatedState({
            rotationX: this.getViewportProps().rotationX - speed
        });
    }
    rotateDown(speed = 10) {
        return this._getUpdatedState({
            rotationX: this.getViewportProps().rotationX + speed
        });
    }
    _unproject(pos) {
        const viewport = this.makeViewport(this.getViewportProps());
        return pos && viewport.unproject(pos);
    }
    _calculateNewZoom({ scale , startZoom  }) {
        const { maxZoom , minZoom  } = this.getViewportProps();
        if (startZoom === undefined) startZoom = this.getViewportProps().zoom;
        const zoom = startZoom + Math.log2(scale);
        return (0, _core.clamp)(zoom, minZoom, maxZoom);
    }
    _panFromCenter(offset) {
        const { width , height , target  } = this.getViewportProps();
        return this.pan({
            startPosition: target,
            pos: [
                width / 2 + offset[0],
                height / 2 + offset[1]
            ]
        });
    }
    _getUpdatedState(newProps) {
        return new this.constructor({
            makeViewport: this.makeViewport,
            ...this.getViewportProps(),
            ...this.getState(),
            ...newProps
        });
    }
    applyConstraints(props) {
        const { maxZoom , minZoom , zoom , maxRotationX , minRotationX , rotationOrbit  } = props;
        props.zoom = Array.isArray(zoom) ? [
            (0, _core.clamp)(zoom[0], minZoom, maxZoom),
            (0, _core.clamp)(zoom[1], minZoom, maxZoom)
        ] : (0, _core.clamp)(zoom, minZoom, maxZoom);
        props.rotationX = (0, _core.clamp)(props.rotationX, minRotationX, maxRotationX);
        if (rotationOrbit < -180 || rotationOrbit > 180) props.rotationOrbit = (0, _mathUtils.mod)(rotationOrbit + 180, 360) - 180;
        return props;
    }
}
class OrbitController extends (0, _controllerDefault.default) {
    constructor(...args){
        super(...args);
        (0, _definePropertyDefault.default)(this, "ControllerState", OrbitState);
        (0, _definePropertyDefault.default)(this, "transition", {
            transitionDuration: 300,
            transitionInterpolator: new (0, _linearInterpolatorDefault.default)({
                transitionProps: {
                    compare: [
                        "target",
                        "zoom",
                        "rotationX",
                        "rotationOrbit"
                    ],
                    required: [
                        "target",
                        "zoom"
                    ]
                }
            })
        });
    }
}
exports.default = OrbitController;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@math.gl/core":"9lgwD","./controller":"4Hxmk","./view-state":"kDVkd","../utils/math-utils":"1KANI","../transitions/linear-interpolator":"fCusj","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"hXp5w":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _debug = require("../debug");
var _debugDefault = parcelHelpers.interopDefault(_debug);
var _drawLayersPass = require("../passes/draw-layers-pass");
var _drawLayersPassDefault = parcelHelpers.interopDefault(_drawLayersPass);
var _pickLayersPass = require("../passes/pick-layers-pass");
var _pickLayersPassDefault = parcelHelpers.interopDefault(_pickLayersPass);
var _core = require("@luma.gl/core");
const TRACE_RENDER_LAYERS = "deckRenderer.renderLayers";
class DeckRenderer {
    constructor(gl){
        this.gl = gl;
        this.layerFilter = null;
        this.drawPickingColors = false;
        this.drawLayersPass = new (0, _drawLayersPassDefault.default)(gl);
        this.pickLayersPass = new (0, _pickLayersPassDefault.default)(gl);
        this.renderCount = 0;
        this._needsRedraw = "Initial render";
        this.renderBuffers = [];
        this.lastPostProcessEffect = null;
    }
    setProps(props) {
        if ("layerFilter" in props && this.layerFilter !== props.layerFilter) {
            this.layerFilter = props.layerFilter;
            this._needsRedraw = "layerFilter changed";
        }
        if ("drawPickingColors" in props && this.drawPickingColors !== props.drawPickingColors) {
            this.drawPickingColors = props.drawPickingColors;
            this._needsRedraw = "drawPickingColors changed";
        }
    }
    renderLayers(opts) {
        const layerPass = this.drawPickingColors ? this.pickLayersPass : this.drawLayersPass;
        opts.layerFilter = opts.layerFilter || this.layerFilter;
        opts.effects = opts.effects || [];
        opts.target = opts.target || (0, _core.Framebuffer).getDefaultFramebuffer(this.gl);
        this._preRender(opts.effects, opts);
        const outputBuffer = this.lastPostProcessEffect ? this.renderBuffers[0] : opts.target;
        const renderStats = layerPass.render({
            ...opts,
            target: outputBuffer
        });
        this._postRender(opts.effects, opts);
        this.renderCount++;
        (0, _debugDefault.default)(TRACE_RENDER_LAYERS, this, renderStats, opts);
    }
    needsRedraw(opts = {
        clearRedrawFlags: false
    }) {
        const redraw = this._needsRedraw;
        if (opts.clearRedrawFlags) this._needsRedraw = false;
        return redraw;
    }
    finalize() {
        const { renderBuffers  } = this;
        for (const buffer of renderBuffers)buffer.delete();
        renderBuffers.length = 0;
    }
    _preRender(effects, opts) {
        let lastPostProcessEffect = null;
        for (const effect of effects){
            effect.preRender(this.gl, opts);
            if (effect.postRender) lastPostProcessEffect = effect;
        }
        if (lastPostProcessEffect) this._resizeRenderBuffers();
        this.lastPostProcessEffect = lastPostProcessEffect;
    }
    _resizeRenderBuffers() {
        const { renderBuffers  } = this;
        if (renderBuffers.length === 0) renderBuffers.push(new (0, _core.Framebuffer)(this.gl), new (0, _core.Framebuffer)(this.gl));
        for (const buffer of renderBuffers)buffer.resize();
    }
    _postRender(effects, opts) {
        const { renderBuffers  } = this;
        const params = {
            inputBuffer: renderBuffers[0],
            swapBuffer: renderBuffers[1],
            target: null
        };
        for (const effect of effects)if (effect.postRender) {
            if (effect === this.lastPostProcessEffect) {
                params.target = opts.target;
                effect.postRender(this.gl, params);
                break;
            }
            const buffer = effect.postRender(this.gl, params);
            params.inputBuffer = buffer;
            params.swapBuffer = buffer === renderBuffers[0] ? renderBuffers[1] : renderBuffers[0];
        }
    }
}
exports.default = DeckRenderer;

},{"../debug":"e6y6V","../passes/draw-layers-pass":"70x2q","../passes/pick-layers-pass":"8XnUR","@luma.gl/core":"9yA57","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"70x2q":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _constants = require("../lib/constants");
var _layersPass = require("./layers-pass");
var _layersPassDefault = parcelHelpers.interopDefault(_layersPass);
class DrawLayersPass extends (0, _layersPassDefault.default) {
    shouldDrawLayer(layer) {
        return layer.props.operation === (0, _constants.OPERATION).DRAW;
    }
}
exports.default = DrawLayersPass;

},{"../lib/constants":"ksWme","./layers-pass":"bsyAy","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8XnUR":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _layersPass = require("./layers-pass");
var _layersPassDefault = parcelHelpers.interopDefault(_layersPass);
var _core = require("@luma.gl/core");
var _constants = require("../lib/constants");
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
const PICKING_PARAMETERS = {
    blendFunc: [
        1,
        0,
        32771,
        0
    ],
    blendEquation: 32774
};
class PickLayersPass extends (0, _layersPassDefault.default) {
    constructor(...args){
        super(...args);
        (0, _definePropertyDefault.default)(this, "pickZ", void 0);
        (0, _definePropertyDefault.default)(this, "_colors", null);
    }
    render(props) {
        if (props.pickingFBO) return this._drawPickingBuffer(props);
        return super.render(props);
    }
    _drawPickingBuffer({ layers , layerFilter , views , viewports , onViewportActive , pickingFBO , deviceRect: { x , y , width , height  } , cullRect , effects , pass ="picking" , pickZ  }) {
        const gl = this.gl;
        this.pickZ = pickZ;
        const encodedColors = pickZ ? null : {
            byLayer: new Map(),
            byAlpha: []
        };
        this._colors = encodedColors;
        const renderStatus = (0, _core.withParameters)(gl, {
            scissorTest: true,
            scissor: [
                x,
                y,
                width,
                height
            ],
            clearColor: [
                0,
                0,
                0,
                0
            ],
            depthMask: true,
            depthTest: true,
            depthRange: [
                0,
                1
            ],
            colorMask: [
                true,
                true,
                true,
                true
            ],
            ...PICKING_PARAMETERS,
            blend: !pickZ
        }, ()=>super.render({
                target: pickingFBO,
                layers,
                layerFilter,
                views,
                viewports,
                onViewportActive,
                cullRect,
                effects: effects === null || effects === void 0 ? void 0 : effects.filter((e)=>e.useInPicking),
                pass
            }));
        this._colors = null;
        const decodePickingColor = encodedColors && decodeColor.bind(null, encodedColors);
        return {
            decodePickingColor,
            stats: renderStatus
        };
    }
    shouldDrawLayer(layer) {
        return layer.props.pickable && layer.props.operation === (0, _constants.OPERATION).DRAW;
    }
    getModuleParameters() {
        return {
            pickingActive: 1,
            pickingAttribute: this.pickZ,
            lightSources: {}
        };
    }
    getLayerParameters(layer, layerIndex, viewport) {
        const pickParameters = {
            ...layer.props.parameters
        };
        if (!this._colors) pickParameters.blend = false;
        else {
            Object.assign(pickParameters, PICKING_PARAMETERS);
            pickParameters.blend = true;
            pickParameters.blendColor = encodeColor(this._colors, layer, viewport);
        }
        return pickParameters;
    }
}
exports.default = PickLayersPass;
function encodeColor(encoded, layer, viewport) {
    const { byLayer , byAlpha  } = encoded;
    let a;
    let entry = byLayer.get(layer);
    if (entry) {
        entry.viewports.push(viewport);
        a = entry.a;
    } else {
        a = byLayer.size + 1;
        if (a <= 255) {
            entry = {
                a,
                layer,
                viewports: [
                    viewport
                ]
            };
            byLayer.set(layer, entry);
            byAlpha[a] = entry;
        } else {
            (0, _logDefault.default).warn("Too many pickable layers, only picking the first 255")();
            a = 0;
        }
    }
    return [
        0,
        0,
        0,
        a / 255
    ];
}
function decodeColor(encoded, pickedColor) {
    const entry = encoded.byAlpha[pickedColor[3]];
    return entry && {
        pickedLayer: entry.layer,
        pickedViewports: entry.viewports,
        pickedObjectIndex: entry.layer.decodePickingColor(pickedColor)
    };
}

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./layers-pass":"bsyAy","@luma.gl/core":"9yA57","../lib/constants":"ksWme","../utils/log":"iINk7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4UHmx":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _pickLayersPass = require("../passes/pick-layers-pass");
var _pickLayersPassDefault = parcelHelpers.interopDefault(_pickLayersPass);
var _queryObject = require("./picking/query-object");
var _pickInfo = require("./picking/pick-info");
class DeckPicker {
    constructor(gl){
        (0, _definePropertyDefault.default)(this, "gl", void 0);
        (0, _definePropertyDefault.default)(this, "pickingFBO", void 0);
        (0, _definePropertyDefault.default)(this, "depthFBO", void 0);
        (0, _definePropertyDefault.default)(this, "pickLayersPass", void 0);
        (0, _definePropertyDefault.default)(this, "layerFilter", void 0);
        (0, _definePropertyDefault.default)(this, "lastPickedInfo", void 0);
        (0, _definePropertyDefault.default)(this, "_pickable", true);
        this.gl = gl;
        this.pickLayersPass = new (0, _pickLayersPassDefault.default)(gl);
        this.lastPickedInfo = {
            index: -1,
            layerId: null,
            info: null
        };
    }
    setProps(props) {
        if ("layerFilter" in props) this.layerFilter = props.layerFilter;
        if ("_pickable" in props) this._pickable = props._pickable;
    }
    finalize() {
        if (this.pickingFBO) this.pickingFBO.delete();
        if (this.depthFBO) {
            this.depthFBO.color.delete();
            this.depthFBO.delete();
        }
    }
    pickObject(opts) {
        return this._pickClosestObject(opts);
    }
    pickObjects(opts) {
        return this._pickVisibleObjects(opts);
    }
    getLastPickedObject({ x , y , layers , viewports  }, lastPickedInfo = this.lastPickedInfo.info) {
        const lastPickedLayerId = lastPickedInfo && lastPickedInfo.layer && lastPickedInfo.layer.id;
        const lastPickedViewportId = lastPickedInfo && lastPickedInfo.viewport && lastPickedInfo.viewport.id;
        const layer = lastPickedLayerId ? layers.find((l)=>l.id === lastPickedLayerId) : null;
        const viewport = lastPickedViewportId && viewports.find((v)=>v.id === lastPickedViewportId) || viewports[0];
        const coordinate = viewport && viewport.unproject([
            x - viewport.x,
            y - viewport.y
        ]);
        const info = {
            x,
            y,
            viewport,
            coordinate,
            layer
        };
        return {
            ...lastPickedInfo,
            ...info
        };
    }
    _resizeBuffer() {
        var _this$pickingFBO, _this$depthFBO;
        const { gl  } = this;
        if (!this.pickingFBO) {
            this.pickingFBO = new (0, _core.Framebuffer)(gl);
            if ((0, _core.Framebuffer).isSupported(gl, {
                colorBufferFloat: true
            })) {
                const depthFBO = new (0, _core.Framebuffer)(gl);
                depthFBO.attach({
                    [36064]: new (0, _core.Texture2D)(gl, {
                        format: (0, _core.isWebGL2)(gl) ? 34836 : 6408,
                        type: 5126
                    })
                });
                this.depthFBO = depthFBO;
            }
        }
        (_this$pickingFBO = this.pickingFBO) === null || _this$pickingFBO === void 0 || _this$pickingFBO.resize({
            width: gl.canvas.width,
            height: gl.canvas.height
        });
        (_this$depthFBO = this.depthFBO) === null || _this$depthFBO === void 0 || _this$depthFBO.resize({
            width: gl.canvas.width,
            height: gl.canvas.height
        });
    }
    _getPickable(layers) {
        if (this._pickable === false) return null;
        const pickableLayers = layers.filter((layer)=>layer.isPickable() && !layer.isComposite);
        return pickableLayers.length ? pickableLayers : null;
    }
    _pickClosestObject({ layers , views , viewports , x , y , radius =0 , depth =1 , mode ="query" , unproject3D , onViewportActive , effects  }) {
        const pickableLayers = this._getPickable(layers);
        const pixelRatio = (0, _core.cssToDeviceRatio)(this.gl);
        if (!pickableLayers) return {
            result: [],
            emptyInfo: (0, _pickInfo.getEmptyPickingInfo)({
                viewports,
                x,
                y,
                pixelRatio
            })
        };
        this._resizeBuffer();
        const devicePixelRange = (0, _core.cssToDevicePixels)(this.gl, [
            x,
            y
        ], true);
        const devicePixel = [
            devicePixelRange.x + Math.floor(devicePixelRange.width / 2),
            devicePixelRange.y + Math.floor(devicePixelRange.height / 2)
        ];
        const deviceRadius = Math.round(radius * pixelRatio);
        const { width , height  } = this.pickingFBO;
        const deviceRect = this._getPickingRect({
            deviceX: devicePixel[0],
            deviceY: devicePixel[1],
            deviceRadius,
            deviceWidth: width,
            deviceHeight: height
        });
        const cullRect = {
            x: x - radius,
            y: y - radius,
            width: radius * 2 + 1,
            height: radius * 2 + 1
        };
        let infos;
        const result = [];
        const affectedLayers = new Set();
        for(let i = 0; i < depth; i++){
            let pickInfo;
            if (deviceRect) {
                const pickedResult = this._drawAndSample({
                    layers: pickableLayers,
                    views,
                    viewports,
                    onViewportActive,
                    deviceRect,
                    cullRect,
                    effects,
                    pass: "picking:".concat(mode)
                });
                pickInfo = (0, _queryObject.getClosestObject)({
                    ...pickedResult,
                    deviceX: devicePixel[0],
                    deviceY: devicePixel[1],
                    deviceRadius,
                    deviceRect
                });
            } else pickInfo = {
                pickedColor: null,
                pickedObjectIndex: -1
            };
            let z;
            if (pickInfo.pickedLayer && unproject3D && this.depthFBO) {
                const pickedResultPass2 = this._drawAndSample({
                    layers: [
                        pickInfo.pickedLayer
                    ],
                    views,
                    viewports,
                    onViewportActive,
                    deviceRect: {
                        x: pickInfo.pickedX,
                        y: pickInfo.pickedY,
                        width: 1,
                        height: 1
                    },
                    cullRect,
                    effects,
                    pass: "picking:".concat(mode, ":z")
                }, true);
                z = pickedResultPass2.pickedColors[0];
            }
            if (pickInfo.pickedLayer && i + 1 < depth) {
                affectedLayers.add(pickInfo.pickedLayer);
                pickInfo.pickedLayer.disablePickingIndex(pickInfo.pickedObjectIndex);
            }
            infos = (0, _pickInfo.processPickInfo)({
                pickInfo,
                lastPickedInfo: this.lastPickedInfo,
                mode,
                layers: pickableLayers,
                viewports,
                x,
                y,
                z,
                pixelRatio
            });
            for (const info of infos.values())if (info.layer) result.push(info);
            if (!pickInfo.pickedColor) break;
        }
        for (const layer of affectedLayers)layer.restorePickingColors();
        return {
            result,
            emptyInfo: infos.get(null)
        };
    }
    _pickVisibleObjects({ layers , views , viewports , x , y , width =1 , height =1 , mode ="query" , maxObjects =null , onViewportActive , effects  }) {
        const pickableLayers = this._getPickable(layers);
        if (!pickableLayers) return [];
        this._resizeBuffer();
        const pixelRatio = (0, _core.cssToDeviceRatio)(this.gl);
        const leftTop = (0, _core.cssToDevicePixels)(this.gl, [
            x,
            y
        ], true);
        const deviceLeft = leftTop.x;
        const deviceTop = leftTop.y + leftTop.height;
        const rightBottom = (0, _core.cssToDevicePixels)(this.gl, [
            x + width,
            y + height
        ], true);
        const deviceRight = rightBottom.x + rightBottom.width;
        const deviceBottom = rightBottom.y;
        const deviceRect = {
            x: deviceLeft,
            y: deviceBottom,
            width: deviceRight - deviceLeft,
            height: deviceTop - deviceBottom
        };
        const pickedResult = this._drawAndSample({
            layers: pickableLayers,
            views,
            viewports,
            onViewportActive,
            deviceRect,
            cullRect: {
                x,
                y,
                width,
                height
            },
            effects,
            pass: "picking:".concat(mode)
        });
        const pickInfos = (0, _queryObject.getUniqueObjects)(pickedResult);
        const uniqueInfos = new Map();
        const isMaxObjects = Number.isFinite(maxObjects);
        for(let i = 0; i < pickInfos.length; i++){
            if (isMaxObjects && maxObjects && uniqueInfos.size >= maxObjects) break;
            const pickInfo = pickInfos[i];
            let info = {
                color: pickInfo.pickedColor,
                layer: null,
                index: pickInfo.pickedObjectIndex,
                picked: true,
                x,
                y,
                pixelRatio
            };
            info = (0, _pickInfo.getLayerPickingInfo)({
                layer: pickInfo.pickedLayer,
                info,
                mode
            });
            if (!uniqueInfos.has(info.object)) uniqueInfos.set(info.object, info);
        }
        return Array.from(uniqueInfos.values());
    }
    _drawAndSample({ layers , views , viewports , onViewportActive , deviceRect , cullRect , effects , pass  }, pickZ = false) {
        const pickingFBO = pickZ ? this.depthFBO : this.pickingFBO;
        const { decodePickingColor  } = this.pickLayersPass.render({
            layers,
            layerFilter: this.layerFilter,
            views,
            viewports,
            onViewportActive,
            pickingFBO,
            deviceRect,
            cullRect,
            effects,
            pass,
            pickZ
        });
        const { x , y , width , height  } = deviceRect;
        const pickedColors = new (pickZ ? Float32Array : Uint8Array)(width * height * 4);
        (0, _core.readPixelsToArray)(pickingFBO, {
            sourceX: x,
            sourceY: y,
            sourceWidth: width,
            sourceHeight: height,
            target: pickedColors
        });
        return {
            pickedColors,
            decodePickingColor
        };
    }
    _getPickingRect({ deviceX , deviceY , deviceRadius , deviceWidth , deviceHeight  }) {
        const x = Math.max(0, deviceX - deviceRadius);
        const y = Math.max(0, deviceY - deviceRadius);
        const width = Math.min(deviceWidth, deviceX + deviceRadius + 1) - x;
        const height = Math.min(deviceHeight, deviceY + deviceRadius + 1) - y;
        if (width <= 0 || height <= 0) return null;
        return {
            x,
            y,
            width,
            height
        };
    }
}
exports.default = DeckPicker;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","../passes/pick-layers-pass":"8XnUR","./picking/query-object":"79Noq","./picking/pick-info":"1TflZ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"79Noq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getClosestObject", ()=>getClosestObject);
parcelHelpers.export(exports, "getUniqueObjects", ()=>getUniqueObjects);
var _log = require("../../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
const NO_PICKED_OBJECT = {
    pickedColor: null,
    pickedObjectIndex: -1
};
function getClosestObject({ pickedColors , decodePickingColor , deviceX , deviceY , deviceRadius , deviceRect  }) {
    const { x , y , width , height  } = deviceRect;
    let minSquareDistanceToCenter = deviceRadius * deviceRadius;
    let closestPixelIndex = -1;
    let i = 0;
    for(let row = 0; row < height; row++){
        const dy = row + y - deviceY;
        const dy2 = dy * dy;
        if (dy2 > minSquareDistanceToCenter) i += 4 * width;
        else for(let col = 0; col < width; col++){
            const pickedLayerIndex = pickedColors[i + 3] - 1;
            if (pickedLayerIndex >= 0) {
                const dx = col + x - deviceX;
                const d2 = dx * dx + dy2;
                if (d2 <= minSquareDistanceToCenter) {
                    minSquareDistanceToCenter = d2;
                    closestPixelIndex = i;
                }
            }
            i += 4;
        }
    }
    if (closestPixelIndex >= 0) {
        const pickedColor = pickedColors.slice(closestPixelIndex, closestPixelIndex + 4);
        const pickedObject = decodePickingColor(pickedColor);
        if (pickedObject) {
            const dy1 = Math.floor(closestPixelIndex / 4 / width);
            const dx1 = closestPixelIndex / 4 - dy1 * width;
            return {
                ...pickedObject,
                pickedColor,
                pickedX: x + dx1,
                pickedY: y + dy1
            };
        }
        (0, _logDefault.default).error("Picked non-existent layer. Is picking buffer corrupt?")();
    }
    return NO_PICKED_OBJECT;
}
function getUniqueObjects({ pickedColors , decodePickingColor  }) {
    const uniqueColors = new Map();
    if (pickedColors) for(let i = 0; i < pickedColors.length; i += 4){
        const pickedLayerIndex = pickedColors[i + 3] - 1;
        if (pickedLayerIndex >= 0) {
            const pickedColor = pickedColors.slice(i, i + 4);
            const colorKey = pickedColor.join(",");
            if (!uniqueColors.has(colorKey)) {
                const pickedObject = decodePickingColor(pickedColor);
                if (pickedObject) uniqueColors.set(colorKey, {
                    ...pickedObject,
                    color: pickedColor
                });
                else (0, _logDefault.default).error("Picked non-existent layer. Is picking buffer corrupt?")();
            }
        }
    }
    return Array.from(uniqueColors.values());
}

},{"../../utils/log":"iINk7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1TflZ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getEmptyPickingInfo", ()=>getEmptyPickingInfo);
parcelHelpers.export(exports, "processPickInfo", ()=>processPickInfo);
parcelHelpers.export(exports, "getLayerPickingInfo", ()=>getLayerPickingInfo);
function getEmptyPickingInfo({ pickInfo , viewports , pixelRatio , x , y , z  }) {
    let pickedViewport = viewports[0];
    if (viewports.length > 1) pickedViewport = getViewportFromCoordinates((pickInfo === null || pickInfo === void 0 ? void 0 : pickInfo.pickedViewports) || viewports, {
        x,
        y
    });
    let coordinate;
    if (pickedViewport) {
        const point = [
            x - pickedViewport.x,
            y - pickedViewport.y
        ];
        if (z !== undefined) point[2] = z;
        coordinate = pickedViewport.unproject(point);
    }
    return {
        color: null,
        layer: null,
        viewport: pickedViewport,
        index: -1,
        picked: false,
        x,
        y,
        pixel: [
            x,
            y
        ],
        coordinate,
        devicePixel: pickInfo && "pickedX" in pickInfo ? [
            pickInfo.pickedX,
            pickInfo.pickedY
        ] : undefined,
        pixelRatio
    };
}
function processPickInfo(opts) {
    const { pickInfo , lastPickedInfo , mode , layers  } = opts;
    const { pickedColor , pickedLayer , pickedObjectIndex  } = pickInfo;
    const affectedLayers = pickedLayer ? [
        pickedLayer
    ] : [];
    if (mode === "hover") {
        const lastPickedPixelIndex = lastPickedInfo.index;
        const lastPickedLayerId = lastPickedInfo.layerId;
        const pickedLayerId = pickedLayer ? pickedLayer.props.id : null;
        if (pickedLayerId !== lastPickedLayerId || pickedObjectIndex !== lastPickedPixelIndex) {
            if (pickedLayerId !== lastPickedLayerId) {
                const lastPickedLayer = layers.find((layer)=>layer.props.id === lastPickedLayerId);
                if (lastPickedLayer) affectedLayers.unshift(lastPickedLayer);
            }
            lastPickedInfo.layerId = pickedLayerId;
            lastPickedInfo.index = pickedObjectIndex;
            lastPickedInfo.info = null;
        }
    }
    const baseInfo = getEmptyPickingInfo(opts);
    const infos = new Map();
    infos.set(null, baseInfo);
    affectedLayers.forEach((layer)=>{
        let info = {
            ...baseInfo
        };
        if (layer === pickedLayer) {
            info.color = pickedColor;
            info.index = pickedObjectIndex;
            info.picked = true;
        }
        info = getLayerPickingInfo({
            layer,
            info,
            mode
        });
        const rootLayer = info.layer;
        if (layer === pickedLayer && mode === "hover") lastPickedInfo.info = info;
        infos.set(rootLayer.id, info);
        if (mode === "hover") rootLayer.updateAutoHighlight(info);
    });
    return infos;
}
function getLayerPickingInfo({ layer , info , mode  }) {
    while(layer && info){
        const sourceLayer = info.layer || null;
        info.sourceLayer = sourceLayer;
        info.layer = layer;
        info = layer.getPickingInfo({
            info,
            mode,
            sourceLayer
        });
        layer = layer.parent;
    }
    return info;
}
function getViewportFromCoordinates(viewports, pixel) {
    for(let i = viewports.length - 1; i >= 0; i--){
        const viewport = viewports[i];
        if (viewport.containsPixel(pixel)) return viewport;
    }
    return viewports[0];
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"coUDg":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
const defaultStyle = {
    zIndex: "1",
    position: "absolute",
    pointerEvents: "none",
    color: "#a0a7b4",
    backgroundColor: "#29323c",
    padding: "10px",
    top: "0",
    left: "0",
    display: "none"
};
class Tooltip {
    constructor(canvas){
        (0, _definePropertyDefault.default)(this, "el", null);
        (0, _definePropertyDefault.default)(this, "isVisible", false);
        const canvasParent = canvas.parentElement;
        if (canvasParent) {
            this.el = document.createElement("div");
            this.el.className = "deck-tooltip";
            Object.assign(this.el.style, defaultStyle);
            canvasParent.appendChild(this.el);
        }
    }
    setTooltip(displayInfo, x, y) {
        const el = this.el;
        if (!el) return;
        if (typeof displayInfo === "string") el.innerText = displayInfo;
        else if (!displayInfo) {
            this.isVisible = false;
            el.style.display = "none";
            return;
        } else {
            if (displayInfo.text) el.innerText = displayInfo.text;
            if (displayInfo.html) el.innerHTML = displayInfo.html;
            if (displayInfo.className) el.className = displayInfo.className;
            Object.assign(el.style, displayInfo.style);
        }
        this.isVisible = true;
        el.style.display = "block";
        el.style.transform = "translate(".concat(x, "px, ").concat(y, "px)");
    }
    remove() {
        if (this.el) {
            this.el.remove();
            this.el = null;
        }
    }
}
exports.default = Tooltip;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7FQzD":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "EventManager", ()=>(0, _eventManagerDefault.default));
var _eventManager = require("./event-manager");
var _eventManagerDefault = parcelHelpers.interopDefault(_eventManager);

},{"./event-manager":"hORE4","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"hORE4":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _hammer = require("./utils/hammer");
var _wheelInput = require("./inputs/wheel-input");
var _wheelInputDefault = parcelHelpers.interopDefault(_wheelInput);
var _moveInput = require("./inputs/move-input");
var _moveInputDefault = parcelHelpers.interopDefault(_moveInput);
var _keyInput = require("./inputs/key-input");
var _keyInputDefault = parcelHelpers.interopDefault(_keyInput);
var _contextmenuInput = require("./inputs/contextmenu-input");
var _contextmenuInputDefault = parcelHelpers.interopDefault(_contextmenuInput);
var _eventRegistrar = require("./utils/event-registrar");
var _eventRegistrarDefault = parcelHelpers.interopDefault(_eventRegistrar);
var _constants = require("./constants");
const DEFAULT_OPTIONS = {
    // event handlers
    events: null,
    // custom recognizers
    recognizers: null,
    recognizerOptions: {},
    Manager: // Manager class
    (0, _hammer.Manager),
    // allow browser default touch action
    // https://github.com/uber/react-map-gl/issues/506
    touchAction: "none",
    tabIndex: 0
};
class EventManager {
    constructor(element = null, options){
        /**
         * Handle basic events using the 'hammer.input' Hammer.js API:
         * Before running Recognizers, Hammer emits a 'hammer.input' event
         * with the basic event info. This function emits all basic events
         * aliased to the "class" of event received.
         * See constants.BASIC_EVENT_CLASSES basic event class definitions.
         */ this._onBasicInput = (event)=>{
            const { srcEvent  } = event;
            const alias = (0, _constants.BASIC_EVENT_ALIASES)[srcEvent.type];
            if (alias) // fire all events aliased to srcEvent.type
            this.manager.emit(alias, event);
        };
        /**
         * Handle events not supported by Hammer.js,
         * and pipe back out through same (Hammer) channel used by other events.
         */ this._onOtherEvent = (event)=>{
            // console.log('onotherevent', event.type, event)
            this.manager.emit(event.type, event);
        };
        this.options = {
            ...DEFAULT_OPTIONS,
            ...options
        };
        this.events = new Map();
        this.setElement(element);
        // Register all passed events.
        const { events  } = this.options;
        if (events) this.on(events);
    }
    getElement() {
        return this.element;
    }
    setElement(element) {
        if (this.element) // unregister all events
        this.destroy();
        this.element = element;
        if (!element) return;
        const { options  } = this;
        const ManagerClass = options.Manager;
        this.manager = new ManagerClass(element, {
            touchAction: options.touchAction,
            recognizers: options.recognizers || (0, _constants.RECOGNIZERS)
        }).on("hammer.input", this._onBasicInput);
        if (!options.recognizers) // Set default recognize withs
        // http://hammerjs.github.io/recognize-with/
        Object.keys((0, _constants.RECOGNIZER_COMPATIBLE_MAP)).forEach((name)=>{
            const recognizer = this.manager.get(name);
            if (recognizer) (0, _constants.RECOGNIZER_COMPATIBLE_MAP)[name].forEach((otherName)=>{
                recognizer.recognizeWith(otherName);
            });
        });
        // Set recognizer options
        for(const recognizerName in options.recognizerOptions){
            const recognizer = this.manager.get(recognizerName);
            if (recognizer) {
                const recognizerOption = options.recognizerOptions[recognizerName];
                // `enable` is managed by the event registrations
                delete recognizerOption.enable;
                recognizer.set(recognizerOption);
            }
        }
        // Handle events not handled by Hammer.js:
        // - mouse wheel
        // - pointer/touch/mouse move
        this.wheelInput = new (0, _wheelInputDefault.default)(element, this._onOtherEvent, {
            enable: false
        });
        this.moveInput = new (0, _moveInputDefault.default)(element, this._onOtherEvent, {
            enable: false
        });
        this.keyInput = new (0, _keyInputDefault.default)(element, this._onOtherEvent, {
            enable: false,
            tabIndex: options.tabIndex
        });
        this.contextmenuInput = new (0, _contextmenuInputDefault.default)(element, this._onOtherEvent, {
            enable: false
        });
        // Register all existing events
        for (const [eventAlias, eventRegistrar] of this.events)if (!eventRegistrar.isEmpty()) {
            // Enable recognizer for this event.
            this._toggleRecognizer(eventRegistrar.recognizerName, true);
            this.manager.on(eventAlias, eventRegistrar.handleEvent);
        }
    }
    // Tear down internal event management implementations.
    destroy() {
        if (this.element) {
            // wheelInput etc. are created in setElement() and therefore
            // cannot exist if there is no element
            this.wheelInput.destroy();
            this.moveInput.destroy();
            this.keyInput.destroy();
            this.contextmenuInput.destroy();
            this.manager.destroy();
            this.wheelInput = null;
            this.moveInput = null;
            this.keyInput = null;
            this.contextmenuInput = null;
            this.manager = null;
            this.element = null;
        }
    }
    /** Register an event handler function to be called on `event` */ on(event, handler, opts) {
        this._addEventHandler(event, handler, opts, false);
    }
    once(event, handler, opts) {
        this._addEventHandler(event, handler, opts, true);
    }
    watch(event, handler, opts) {
        this._addEventHandler(event, handler, opts, false, true);
    }
    off(event, handler) {
        this._removeEventHandler(event, handler);
    }
    /*
     * Enable/disable recognizer for the given event
     */ _toggleRecognizer(name, enabled) {
        const { manager  } = this;
        if (!manager) return;
        const recognizer = manager.get(name);
        // @ts-ignore
        if (recognizer && recognizer.options.enable !== enabled) {
            recognizer.set({
                enable: enabled
            });
            const fallbackRecognizers = (0, _constants.RECOGNIZER_FALLBACK_MAP)[name];
            if (fallbackRecognizers && !this.options.recognizers) // Set default require failures
            // http://hammerjs.github.io/require-failure/
            fallbackRecognizers.forEach((otherName)=>{
                const otherRecognizer = manager.get(otherName);
                if (enabled) {
                    // Wait for this recognizer to fail
                    otherRecognizer.requireFailure(name);
                    /**
                         * This seems to be a bug in hammerjs:
                         * requireFailure() adds both ways
                         * dropRequireFailure() only drops one way
                         * https://github.com/hammerjs/hammer.js/blob/master/src/recognizerjs/
                           recognizer-constructor.js#L136
                         */ recognizer.dropRequireFailure(otherName);
                } else // Do not wait for this recognizer to fail
                otherRecognizer.dropRequireFailure(name);
            });
        }
        this.wheelInput.enableEventType(name, enabled);
        this.moveInput.enableEventType(name, enabled);
        this.keyInput.enableEventType(name, enabled);
        this.contextmenuInput.enableEventType(name, enabled);
    }
    /**
     * Process the event registration for a single event + handler.
     */ _addEventHandler(event, handler, opts, once, passive) {
        if (typeof event !== "string") {
            // @ts-ignore
            opts = handler;
            // If `event` is a map, call `on()` for each entry.
            for(const eventName in event)this._addEventHandler(eventName, event[eventName], opts, once, passive);
            return;
        }
        const { manager , events  } = this;
        // Alias to a recognized gesture as necessary.
        const eventAlias = (0, _constants.GESTURE_EVENT_ALIASES)[event] || event;
        let eventRegistrar = events.get(eventAlias);
        if (!eventRegistrar) {
            eventRegistrar = new (0, _eventRegistrarDefault.default)(this);
            events.set(eventAlias, eventRegistrar);
            // Enable recognizer for this event.
            eventRegistrar.recognizerName = (0, _constants.EVENT_RECOGNIZER_MAP)[eventAlias] || eventAlias;
            // Listen to the event
            if (manager) manager.on(eventAlias, eventRegistrar.handleEvent);
        }
        eventRegistrar.add(event, handler, opts, once, passive);
        if (!eventRegistrar.isEmpty()) this._toggleRecognizer(eventRegistrar.recognizerName, true);
    }
    /**
     * Process the event deregistration for a single event + handler.
     */ _removeEventHandler(event, handler) {
        if (typeof event !== "string") {
            // If `event` is a map, call `off()` for each entry.
            for(const eventName in event)this._removeEventHandler(eventName, event[eventName]);
            return;
        }
        const { events  } = this;
        // Alias to a recognized gesture as necessary.
        const eventAlias = (0, _constants.GESTURE_EVENT_ALIASES)[event] || event;
        const eventRegistrar = events.get(eventAlias);
        if (!eventRegistrar) return;
        eventRegistrar.remove(event, handler);
        if (eventRegistrar.isEmpty()) {
            const { recognizerName  } = eventRegistrar;
            // Disable recognizer if no more handlers are attached to its events
            let isRecognizerUsed = false;
            for (const eh of events.values())if (eh.recognizerName === recognizerName && !eh.isEmpty()) {
                isRecognizerUsed = true;
                break;
            }
            if (!isRecognizerUsed) this._toggleRecognizer(recognizerName, false);
        }
    }
}
exports.default = EventManager;

},{"./utils/hammer":"bkxVq","./inputs/wheel-input":"h6n7R","./inputs/move-input":"aur3b","./inputs/key-input":"3xNpI","./inputs/contextmenu-input":"jijAn","./utils/event-registrar":"gnokD","./constants":"I9SHq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bkxVq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Manager", ()=>Manager);
var _hammerjs = require("hammerjs");
var _hammerOverrides = require("./hammer-overrides");
(0, _hammerOverrides.enhancePointerEventInput)(_hammerjs.PointerEventInput);
(0, _hammerOverrides.enhanceMouseInput)(_hammerjs.MouseInput);
const Manager = _hammerjs.Manager;
exports.default = _hammerjs;

},{"hammerjs":"lHwvQ","./hammer-overrides":"1PaGf","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lHwvQ":[function(require,module,exports) {
/*! Hammer.JS - v2.0.7 - 2016-04-22
 * http://hammerjs.github.io/
 *
 * Copyright (c) 2016 Jorik Tangelder;
 * Licensed under the MIT license */ (function(window1, document1, exportName, undefined) {
    "use strict";
    var VENDOR_PREFIXES = [
        "",
        "webkit",
        "Moz",
        "MS",
        "ms",
        "o"
    ];
    var TEST_ELEMENT = document1.createElement("div");
    var TYPE_FUNCTION = "function";
    var round = Math.round;
    var abs = Math.abs;
    var now = Date.now;
    /**
 * set a timeout with a given scope
 * @param {Function} fn
 * @param {Number} timeout
 * @param {Object} context
 * @returns {number}
 */ function setTimeoutContext(fn, timeout, context) {
        return setTimeout(bindFn(fn, context), timeout);
    }
    /**
 * if the argument is an array, we want to execute the fn on each entry
 * if it aint an array we don't want to do a thing.
 * this is used by all the methods that accept a single and array argument.
 * @param {*|Array} arg
 * @param {String} fn
 * @param {Object} [context]
 * @returns {Boolean}
 */ function invokeArrayArg(arg, fn, context) {
        if (Array.isArray(arg)) {
            each(arg, context[fn], context);
            return true;
        }
        return false;
    }
    /**
 * walk objects and arrays
 * @param {Object} obj
 * @param {Function} iterator
 * @param {Object} context
 */ function each(obj, iterator, context) {
        var i;
        if (!obj) return;
        if (obj.forEach) obj.forEach(iterator, context);
        else if (obj.length !== undefined) {
            i = 0;
            while(i < obj.length){
                iterator.call(context, obj[i], i, obj);
                i++;
            }
        } else for(i in obj)obj.hasOwnProperty(i) && iterator.call(context, obj[i], i, obj);
    }
    /**
 * wrap a method with a deprecation warning and stack trace
 * @param {Function} method
 * @param {String} name
 * @param {String} message
 * @returns {Function} A new function wrapping the supplied method.
 */ function deprecate(method, name, message) {
        var deprecationMessage = "DEPRECATED METHOD: " + name + "\n" + message + " AT \n";
        return function() {
            var e = new Error("get-stack-trace");
            var stack = e && e.stack ? e.stack.replace(/^[^\(]+?[\n$]/gm, "").replace(/^\s+at\s+/gm, "").replace(/^Object.<anonymous>\s*\(/gm, "{anonymous}()@") : "Unknown Stack Trace";
            var log = window1.console && (window1.console.warn || window1.console.log);
            if (log) log.call(window1.console, deprecationMessage, stack);
            return method.apply(this, arguments);
        };
    }
    /**
 * extend object.
 * means that properties in dest will be overwritten by the ones in src.
 * @param {Object} target
 * @param {...Object} objects_to_assign
 * @returns {Object} target
 */ var assign;
    if (typeof Object.assign !== "function") assign = function assign(target) {
        if (target === undefined || target === null) throw new TypeError("Cannot convert undefined or null to object");
        var output = Object(target);
        for(var index = 1; index < arguments.length; index++){
            var source = arguments[index];
            if (source !== undefined && source !== null) {
                for(var nextKey in source)if (source.hasOwnProperty(nextKey)) output[nextKey] = source[nextKey];
            }
        }
        return output;
    };
    else assign = Object.assign;
    /**
 * extend object.
 * means that properties in dest will be overwritten by the ones in src.
 * @param {Object} dest
 * @param {Object} src
 * @param {Boolean} [merge=false]
 * @returns {Object} dest
 */ var extend = deprecate(function extend(dest, src, merge) {
        var keys = Object.keys(src);
        var i = 0;
        while(i < keys.length){
            if (!merge || merge && dest[keys[i]] === undefined) dest[keys[i]] = src[keys[i]];
            i++;
        }
        return dest;
    }, "extend", "Use `assign`.");
    /**
 * merge the values from src in the dest.
 * means that properties that exist in dest will not be overwritten by src
 * @param {Object} dest
 * @param {Object} src
 * @returns {Object} dest
 */ var merge = deprecate(function merge(dest, src) {
        return extend(dest, src, true);
    }, "merge", "Use `assign`.");
    /**
 * simple class inheritance
 * @param {Function} child
 * @param {Function} base
 * @param {Object} [properties]
 */ function inherit(child, base, properties) {
        var baseP = base.prototype, childP;
        childP = child.prototype = Object.create(baseP);
        childP.constructor = child;
        childP._super = baseP;
        if (properties) assign(childP, properties);
    }
    /**
 * simple function bind
 * @param {Function} fn
 * @param {Object} context
 * @returns {Function}
 */ function bindFn(fn, context) {
        return function boundFn() {
            return fn.apply(context, arguments);
        };
    }
    /**
 * let a boolean value also be a function that must return a boolean
 * this first item in args will be used as the context
 * @param {Boolean|Function} val
 * @param {Array} [args]
 * @returns {Boolean}
 */ function boolOrFn(val, args) {
        if (typeof val == TYPE_FUNCTION) return val.apply(args ? args[0] || undefined : undefined, args);
        return val;
    }
    /**
 * use the val2 when val1 is undefined
 * @param {*} val1
 * @param {*} val2
 * @returns {*}
 */ function ifUndefined(val1, val2) {
        return val1 === undefined ? val2 : val1;
    }
    /**
 * addEventListener with multiple events at once
 * @param {EventTarget} target
 * @param {String} types
 * @param {Function} handler
 */ function addEventListeners(target, types, handler) {
        each(splitStr(types), function(type) {
            target.addEventListener(type, handler, false);
        });
    }
    /**
 * removeEventListener with multiple events at once
 * @param {EventTarget} target
 * @param {String} types
 * @param {Function} handler
 */ function removeEventListeners(target, types, handler) {
        each(splitStr(types), function(type) {
            target.removeEventListener(type, handler, false);
        });
    }
    /**
 * find if a node is in the given parent
 * @method hasParent
 * @param {HTMLElement} node
 * @param {HTMLElement} parent
 * @return {Boolean} found
 */ function hasParent(node, parent) {
        while(node){
            if (node == parent) return true;
            node = node.parentNode;
        }
        return false;
    }
    /**
 * small indexOf wrapper
 * @param {String} str
 * @param {String} find
 * @returns {Boolean} found
 */ function inStr(str, find) {
        return str.indexOf(find) > -1;
    }
    /**
 * split string on whitespace
 * @param {String} str
 * @returns {Array} words
 */ function splitStr(str) {
        return str.trim().split(/\s+/g);
    }
    /**
 * find if a array contains the object using indexOf or a simple polyFill
 * @param {Array} src
 * @param {String} find
 * @param {String} [findByKey]
 * @return {Boolean|Number} false when not found, or the index
 */ function inArray(src, find, findByKey) {
        if (src.indexOf && !findByKey) return src.indexOf(find);
        else {
            var i = 0;
            while(i < src.length){
                if (findByKey && src[i][findByKey] == find || !findByKey && src[i] === find) return i;
                i++;
            }
            return -1;
        }
    }
    /**
 * convert array-like objects to real arrays
 * @param {Object} obj
 * @returns {Array}
 */ function toArray(obj) {
        return Array.prototype.slice.call(obj, 0);
    }
    /**
 * unique array with objects based on a key (like 'id') or just by the array's value
 * @param {Array} src [{id:1},{id:2},{id:1}]
 * @param {String} [key]
 * @param {Boolean} [sort=False]
 * @returns {Array} [{id:1},{id:2}]
 */ function uniqueArray(src, key, sort) {
        var results = [];
        var values = [];
        var i = 0;
        while(i < src.length){
            var val = key ? src[i][key] : src[i];
            if (inArray(values, val) < 0) results.push(src[i]);
            values[i] = val;
            i++;
        }
        if (sort) {
            if (!key) results = results.sort();
            else results = results.sort(function sortUniqueArray(a, b) {
                return a[key] > b[key];
            });
        }
        return results;
    }
    /**
 * get the prefixed property
 * @param {Object} obj
 * @param {String} property
 * @returns {String|Undefined} prefixed
 */ function prefixed(obj, property) {
        var prefix, prop;
        var camelProp = property[0].toUpperCase() + property.slice(1);
        var i = 0;
        while(i < VENDOR_PREFIXES.length){
            prefix = VENDOR_PREFIXES[i];
            prop = prefix ? prefix + camelProp : property;
            if (prop in obj) return prop;
            i++;
        }
        return undefined;
    }
    /**
 * get a unique id
 * @returns {number} uniqueId
 */ var _uniqueId = 1;
    function uniqueId() {
        return _uniqueId++;
    }
    /**
 * get the window object of an element
 * @param {HTMLElement} element
 * @returns {DocumentView|Window}
 */ function getWindowForElement(element) {
        var doc = element.ownerDocument || element;
        return doc.defaultView || doc.parentWindow || window1;
    }
    var MOBILE_REGEX = /mobile|tablet|ip(ad|hone|od)|android/i;
    var SUPPORT_TOUCH = "ontouchstart" in window1;
    var SUPPORT_POINTER_EVENTS = prefixed(window1, "PointerEvent") !== undefined;
    var SUPPORT_ONLY_TOUCH = SUPPORT_TOUCH && MOBILE_REGEX.test(navigator.userAgent);
    var INPUT_TYPE_TOUCH = "touch";
    var INPUT_TYPE_PEN = "pen";
    var INPUT_TYPE_MOUSE = "mouse";
    var INPUT_TYPE_KINECT = "kinect";
    var COMPUTE_INTERVAL = 25;
    var INPUT_START = 1;
    var INPUT_MOVE = 2;
    var INPUT_END = 4;
    var INPUT_CANCEL = 8;
    var DIRECTION_NONE = 1;
    var DIRECTION_LEFT = 2;
    var DIRECTION_RIGHT = 4;
    var DIRECTION_UP = 8;
    var DIRECTION_DOWN = 16;
    var DIRECTION_HORIZONTAL = DIRECTION_LEFT | DIRECTION_RIGHT;
    var DIRECTION_VERTICAL = DIRECTION_UP | DIRECTION_DOWN;
    var DIRECTION_ALL = DIRECTION_HORIZONTAL | DIRECTION_VERTICAL;
    var PROPS_XY = [
        "x",
        "y"
    ];
    var PROPS_CLIENT_XY = [
        "clientX",
        "clientY"
    ];
    /**
 * create new input type manager
 * @param {Manager} manager
 * @param {Function} callback
 * @returns {Input}
 * @constructor
 */ function Input(manager, callback) {
        var self1 = this;
        this.manager = manager;
        this.callback = callback;
        this.element = manager.element;
        this.target = manager.options.inputTarget;
        // smaller wrapper around the handler, for the scope and the enabled state of the manager,
        // so when disabled the input events are completely bypassed.
        this.domHandler = function(ev) {
            if (boolOrFn(manager.options.enable, [
                manager
            ])) self1.handler(ev);
        };
        this.init();
    }
    Input.prototype = {
        /**
     * should handle the inputEvent data and trigger the callback
     * @virtual
     */ handler: function() {},
        /**
     * bind the events
     */ init: function() {
            this.evEl && addEventListeners(this.element, this.evEl, this.domHandler);
            this.evTarget && addEventListeners(this.target, this.evTarget, this.domHandler);
            this.evWin && addEventListeners(getWindowForElement(this.element), this.evWin, this.domHandler);
        },
        /**
     * unbind the events
     */ destroy: function() {
            this.evEl && removeEventListeners(this.element, this.evEl, this.domHandler);
            this.evTarget && removeEventListeners(this.target, this.evTarget, this.domHandler);
            this.evWin && removeEventListeners(getWindowForElement(this.element), this.evWin, this.domHandler);
        }
    };
    /**
 * create new input type manager
 * called by the Manager constructor
 * @param {Hammer} manager
 * @returns {Input}
 */ function createInputInstance(manager) {
        var Type;
        var inputClass = manager.options.inputClass;
        if (inputClass) Type = inputClass;
        else if (SUPPORT_POINTER_EVENTS) Type = PointerEventInput;
        else if (SUPPORT_ONLY_TOUCH) Type = TouchInput;
        else if (!SUPPORT_TOUCH) Type = MouseInput;
        else Type = TouchMouseInput;
        return new Type(manager, inputHandler);
    }
    /**
 * handle input events
 * @param {Manager} manager
 * @param {String} eventType
 * @param {Object} input
 */ function inputHandler(manager, eventType, input) {
        var pointersLen = input.pointers.length;
        var changedPointersLen = input.changedPointers.length;
        var isFirst = eventType & INPUT_START && pointersLen - changedPointersLen === 0;
        var isFinal = eventType & (INPUT_END | INPUT_CANCEL) && pointersLen - changedPointersLen === 0;
        input.isFirst = !!isFirst;
        input.isFinal = !!isFinal;
        if (isFirst) manager.session = {};
        // source event is the normalized value of the domEvents
        // like 'touchstart, mouseup, pointerdown'
        input.eventType = eventType;
        // compute scale, rotation etc
        computeInputData(manager, input);
        // emit secret event
        manager.emit("hammer.input", input);
        manager.recognize(input);
        manager.session.prevInput = input;
    }
    /**
 * extend the data with some usable properties like scale, rotate, velocity etc
 * @param {Object} manager
 * @param {Object} input
 */ function computeInputData(manager, input) {
        var session = manager.session;
        var pointers = input.pointers;
        var pointersLength = pointers.length;
        // store the first input to calculate the distance and direction
        if (!session.firstInput) session.firstInput = simpleCloneInputData(input);
        // to compute scale and rotation we need to store the multiple touches
        if (pointersLength > 1 && !session.firstMultiple) session.firstMultiple = simpleCloneInputData(input);
        else if (pointersLength === 1) session.firstMultiple = false;
        var firstInput = session.firstInput;
        var firstMultiple = session.firstMultiple;
        var offsetCenter = firstMultiple ? firstMultiple.center : firstInput.center;
        var center = input.center = getCenter(pointers);
        input.timeStamp = now();
        input.deltaTime = input.timeStamp - firstInput.timeStamp;
        input.angle = getAngle(offsetCenter, center);
        input.distance = getDistance(offsetCenter, center);
        computeDeltaXY(session, input);
        input.offsetDirection = getDirection(input.deltaX, input.deltaY);
        var overallVelocity = getVelocity(input.deltaTime, input.deltaX, input.deltaY);
        input.overallVelocityX = overallVelocity.x;
        input.overallVelocityY = overallVelocity.y;
        input.overallVelocity = abs(overallVelocity.x) > abs(overallVelocity.y) ? overallVelocity.x : overallVelocity.y;
        input.scale = firstMultiple ? getScale(firstMultiple.pointers, pointers) : 1;
        input.rotation = firstMultiple ? getRotation(firstMultiple.pointers, pointers) : 0;
        input.maxPointers = !session.prevInput ? input.pointers.length : input.pointers.length > session.prevInput.maxPointers ? input.pointers.length : session.prevInput.maxPointers;
        computeIntervalInputData(session, input);
        // find the correct target
        var target = manager.element;
        if (hasParent(input.srcEvent.target, target)) target = input.srcEvent.target;
        input.target = target;
    }
    function computeDeltaXY(session, input) {
        var center = input.center;
        var offset = session.offsetDelta || {};
        var prevDelta = session.prevDelta || {};
        var prevInput = session.prevInput || {};
        if (input.eventType === INPUT_START || prevInput.eventType === INPUT_END) {
            prevDelta = session.prevDelta = {
                x: prevInput.deltaX || 0,
                y: prevInput.deltaY || 0
            };
            offset = session.offsetDelta = {
                x: center.x,
                y: center.y
            };
        }
        input.deltaX = prevDelta.x + (center.x - offset.x);
        input.deltaY = prevDelta.y + (center.y - offset.y);
    }
    /**
 * velocity is calculated every x ms
 * @param {Object} session
 * @param {Object} input
 */ function computeIntervalInputData(session, input) {
        var last = session.lastInterval || input, deltaTime = input.timeStamp - last.timeStamp, velocity, velocityX, velocityY, direction;
        if (input.eventType != INPUT_CANCEL && (deltaTime > COMPUTE_INTERVAL || last.velocity === undefined)) {
            var deltaX = input.deltaX - last.deltaX;
            var deltaY = input.deltaY - last.deltaY;
            var v = getVelocity(deltaTime, deltaX, deltaY);
            velocityX = v.x;
            velocityY = v.y;
            velocity = abs(v.x) > abs(v.y) ? v.x : v.y;
            direction = getDirection(deltaX, deltaY);
            session.lastInterval = input;
        } else {
            // use latest velocity info if it doesn't overtake a minimum period
            velocity = last.velocity;
            velocityX = last.velocityX;
            velocityY = last.velocityY;
            direction = last.direction;
        }
        input.velocity = velocity;
        input.velocityX = velocityX;
        input.velocityY = velocityY;
        input.direction = direction;
    }
    /**
 * create a simple clone from the input used for storage of firstInput and firstMultiple
 * @param {Object} input
 * @returns {Object} clonedInputData
 */ function simpleCloneInputData(input) {
        // make a simple copy of the pointers because we will get a reference if we don't
        // we only need clientXY for the calculations
        var pointers = [];
        var i = 0;
        while(i < input.pointers.length){
            pointers[i] = {
                clientX: round(input.pointers[i].clientX),
                clientY: round(input.pointers[i].clientY)
            };
            i++;
        }
        return {
            timeStamp: now(),
            pointers: pointers,
            center: getCenter(pointers),
            deltaX: input.deltaX,
            deltaY: input.deltaY
        };
    }
    /**
 * get the center of all the pointers
 * @param {Array} pointers
 * @return {Object} center contains `x` and `y` properties
 */ function getCenter(pointers) {
        var pointersLength = pointers.length;
        // no need to loop when only one touch
        if (pointersLength === 1) return {
            x: round(pointers[0].clientX),
            y: round(pointers[0].clientY)
        };
        var x = 0, y = 0, i = 0;
        while(i < pointersLength){
            x += pointers[i].clientX;
            y += pointers[i].clientY;
            i++;
        }
        return {
            x: round(x / pointersLength),
            y: round(y / pointersLength)
        };
    }
    /**
 * calculate the velocity between two points. unit is in px per ms.
 * @param {Number} deltaTime
 * @param {Number} x
 * @param {Number} y
 * @return {Object} velocity `x` and `y`
 */ function getVelocity(deltaTime, x, y) {
        return {
            x: x / deltaTime || 0,
            y: y / deltaTime || 0
        };
    }
    /**
 * get the direction between two points
 * @param {Number} x
 * @param {Number} y
 * @return {Number} direction
 */ function getDirection(x, y) {
        if (x === y) return DIRECTION_NONE;
        if (abs(x) >= abs(y)) return x < 0 ? DIRECTION_LEFT : DIRECTION_RIGHT;
        return y < 0 ? DIRECTION_UP : DIRECTION_DOWN;
    }
    /**
 * calculate the absolute distance between two points
 * @param {Object} p1 {x, y}
 * @param {Object} p2 {x, y}
 * @param {Array} [props] containing x and y keys
 * @return {Number} distance
 */ function getDistance(p1, p2, props) {
        if (!props) props = PROPS_XY;
        var x = p2[props[0]] - p1[props[0]], y = p2[props[1]] - p1[props[1]];
        return Math.sqrt(x * x + y * y);
    }
    /**
 * calculate the angle between two coordinates
 * @param {Object} p1
 * @param {Object} p2
 * @param {Array} [props] containing x and y keys
 * @return {Number} angle
 */ function getAngle(p1, p2, props) {
        if (!props) props = PROPS_XY;
        var x = p2[props[0]] - p1[props[0]], y = p2[props[1]] - p1[props[1]];
        return Math.atan2(y, x) * 180 / Math.PI;
    }
    /**
 * calculate the rotation degrees between two pointersets
 * @param {Array} start array of pointers
 * @param {Array} end array of pointers
 * @return {Number} rotation
 */ function getRotation(start, end) {
        return getAngle(end[1], end[0], PROPS_CLIENT_XY) + getAngle(start[1], start[0], PROPS_CLIENT_XY);
    }
    /**
 * calculate the scale factor between two pointersets
 * no scale is 1, and goes down to 0 when pinched together, and bigger when pinched out
 * @param {Array} start array of pointers
 * @param {Array} end array of pointers
 * @return {Number} scale
 */ function getScale(start, end) {
        return getDistance(end[0], end[1], PROPS_CLIENT_XY) / getDistance(start[0], start[1], PROPS_CLIENT_XY);
    }
    var MOUSE_INPUT_MAP = {
        mousedown: INPUT_START,
        mousemove: INPUT_MOVE,
        mouseup: INPUT_END
    };
    var MOUSE_ELEMENT_EVENTS = "mousedown";
    var MOUSE_WINDOW_EVENTS = "mousemove mouseup";
    /**
 * Mouse events input
 * @constructor
 * @extends Input
 */ function MouseInput() {
        this.evEl = MOUSE_ELEMENT_EVENTS;
        this.evWin = MOUSE_WINDOW_EVENTS;
        this.pressed = false; // mousedown state
        Input.apply(this, arguments);
    }
    inherit(MouseInput, Input, {
        /**
     * handle mouse events
     * @param {Object} ev
     */ handler: function MEhandler(ev) {
            var eventType = MOUSE_INPUT_MAP[ev.type];
            // on start we want to have the left mouse button down
            if (eventType & INPUT_START && ev.button === 0) this.pressed = true;
            if (eventType & INPUT_MOVE && ev.which !== 1) eventType = INPUT_END;
            // mouse must be down
            if (!this.pressed) return;
            if (eventType & INPUT_END) this.pressed = false;
            this.callback(this.manager, eventType, {
                pointers: [
                    ev
                ],
                changedPointers: [
                    ev
                ],
                pointerType: INPUT_TYPE_MOUSE,
                srcEvent: ev
            });
        }
    });
    var POINTER_INPUT_MAP = {
        pointerdown: INPUT_START,
        pointermove: INPUT_MOVE,
        pointerup: INPUT_END,
        pointercancel: INPUT_CANCEL,
        pointerout: INPUT_CANCEL
    };
    // in IE10 the pointer types is defined as an enum
    var IE10_POINTER_TYPE_ENUM = {
        2: INPUT_TYPE_TOUCH,
        3: INPUT_TYPE_PEN,
        4: INPUT_TYPE_MOUSE,
        5: INPUT_TYPE_KINECT // see https://twitter.com/jacobrossi/status/480596438489890816
    };
    var POINTER_ELEMENT_EVENTS = "pointerdown";
    var POINTER_WINDOW_EVENTS = "pointermove pointerup pointercancel";
    // IE10 has prefixed support, and case-sensitive
    if (window1.MSPointerEvent && !window1.PointerEvent) {
        POINTER_ELEMENT_EVENTS = "MSPointerDown";
        POINTER_WINDOW_EVENTS = "MSPointerMove MSPointerUp MSPointerCancel";
    }
    /**
 * Pointer events input
 * @constructor
 * @extends Input
 */ function PointerEventInput() {
        this.evEl = POINTER_ELEMENT_EVENTS;
        this.evWin = POINTER_WINDOW_EVENTS;
        Input.apply(this, arguments);
        this.store = this.manager.session.pointerEvents = [];
    }
    inherit(PointerEventInput, Input, {
        /**
     * handle mouse events
     * @param {Object} ev
     */ handler: function PEhandler(ev) {
            var store = this.store;
            var removePointer = false;
            var eventTypeNormalized = ev.type.toLowerCase().replace("ms", "");
            var eventType = POINTER_INPUT_MAP[eventTypeNormalized];
            var pointerType = IE10_POINTER_TYPE_ENUM[ev.pointerType] || ev.pointerType;
            var isTouch = pointerType == INPUT_TYPE_TOUCH;
            // get index of the event in the store
            var storeIndex = inArray(store, ev.pointerId, "pointerId");
            // start and mouse must be down
            if (eventType & INPUT_START && (ev.button === 0 || isTouch)) {
                if (storeIndex < 0) {
                    store.push(ev);
                    storeIndex = store.length - 1;
                }
            } else if (eventType & (INPUT_END | INPUT_CANCEL)) removePointer = true;
            // it not found, so the pointer hasn't been down (so it's probably a hover)
            if (storeIndex < 0) return;
            // update the event in the store
            store[storeIndex] = ev;
            this.callback(this.manager, eventType, {
                pointers: store,
                changedPointers: [
                    ev
                ],
                pointerType: pointerType,
                srcEvent: ev
            });
            if (removePointer) // remove from the store
            store.splice(storeIndex, 1);
        }
    });
    var SINGLE_TOUCH_INPUT_MAP = {
        touchstart: INPUT_START,
        touchmove: INPUT_MOVE,
        touchend: INPUT_END,
        touchcancel: INPUT_CANCEL
    };
    var SINGLE_TOUCH_TARGET_EVENTS = "touchstart";
    var SINGLE_TOUCH_WINDOW_EVENTS = "touchstart touchmove touchend touchcancel";
    /**
 * Touch events input
 * @constructor
 * @extends Input
 */ function SingleTouchInput() {
        this.evTarget = SINGLE_TOUCH_TARGET_EVENTS;
        this.evWin = SINGLE_TOUCH_WINDOW_EVENTS;
        this.started = false;
        Input.apply(this, arguments);
    }
    inherit(SingleTouchInput, Input, {
        handler: function TEhandler(ev) {
            var type = SINGLE_TOUCH_INPUT_MAP[ev.type];
            // should we handle the touch events?
            if (type === INPUT_START) this.started = true;
            if (!this.started) return;
            var touches = normalizeSingleTouches.call(this, ev, type);
            // when done, reset the started state
            if (type & (INPUT_END | INPUT_CANCEL) && touches[0].length - touches[1].length === 0) this.started = false;
            this.callback(this.manager, type, {
                pointers: touches[0],
                changedPointers: touches[1],
                pointerType: INPUT_TYPE_TOUCH,
                srcEvent: ev
            });
        }
    });
    /**
 * @this {TouchInput}
 * @param {Object} ev
 * @param {Number} type flag
 * @returns {undefined|Array} [all, changed]
 */ function normalizeSingleTouches(ev, type) {
        var all = toArray(ev.touches);
        var changed = toArray(ev.changedTouches);
        if (type & (INPUT_END | INPUT_CANCEL)) all = uniqueArray(all.concat(changed), "identifier", true);
        return [
            all,
            changed
        ];
    }
    var TOUCH_INPUT_MAP = {
        touchstart: INPUT_START,
        touchmove: INPUT_MOVE,
        touchend: INPUT_END,
        touchcancel: INPUT_CANCEL
    };
    var TOUCH_TARGET_EVENTS = "touchstart touchmove touchend touchcancel";
    /**
 * Multi-user touch events input
 * @constructor
 * @extends Input
 */ function TouchInput() {
        this.evTarget = TOUCH_TARGET_EVENTS;
        this.targetIds = {};
        Input.apply(this, arguments);
    }
    inherit(TouchInput, Input, {
        handler: function MTEhandler(ev) {
            var type = TOUCH_INPUT_MAP[ev.type];
            var touches = getTouches.call(this, ev, type);
            if (!touches) return;
            this.callback(this.manager, type, {
                pointers: touches[0],
                changedPointers: touches[1],
                pointerType: INPUT_TYPE_TOUCH,
                srcEvent: ev
            });
        }
    });
    /**
 * @this {TouchInput}
 * @param {Object} ev
 * @param {Number} type flag
 * @returns {undefined|Array} [all, changed]
 */ function getTouches(ev, type) {
        var allTouches = toArray(ev.touches);
        var targetIds = this.targetIds;
        // when there is only one touch, the process can be simplified
        if (type & (INPUT_START | INPUT_MOVE) && allTouches.length === 1) {
            targetIds[allTouches[0].identifier] = true;
            return [
                allTouches,
                allTouches
            ];
        }
        var i, targetTouches, changedTouches = toArray(ev.changedTouches), changedTargetTouches = [], target = this.target;
        // get target touches from touches
        targetTouches = allTouches.filter(function(touch) {
            return hasParent(touch.target, target);
        });
        // collect touches
        if (type === INPUT_START) {
            i = 0;
            while(i < targetTouches.length){
                targetIds[targetTouches[i].identifier] = true;
                i++;
            }
        }
        // filter changed touches to only contain touches that exist in the collected target ids
        i = 0;
        while(i < changedTouches.length){
            if (targetIds[changedTouches[i].identifier]) changedTargetTouches.push(changedTouches[i]);
            // cleanup removed touches
            if (type & (INPUT_END | INPUT_CANCEL)) delete targetIds[changedTouches[i].identifier];
            i++;
        }
        if (!changedTargetTouches.length) return;
        return [
            // merge targetTouches with changedTargetTouches so it contains ALL touches, including 'end' and 'cancel'
            uniqueArray(targetTouches.concat(changedTargetTouches), "identifier", true),
            changedTargetTouches
        ];
    }
    /**
 * Combined touch and mouse input
 *
 * Touch has a higher priority then mouse, and while touching no mouse events are allowed.
 * This because touch devices also emit mouse events while doing a touch.
 *
 * @constructor
 * @extends Input
 */ var DEDUP_TIMEOUT = 2500;
    var DEDUP_DISTANCE = 25;
    function TouchMouseInput() {
        Input.apply(this, arguments);
        var handler = bindFn(this.handler, this);
        this.touch = new TouchInput(this.manager, handler);
        this.mouse = new MouseInput(this.manager, handler);
        this.primaryTouch = null;
        this.lastTouches = [];
    }
    inherit(TouchMouseInput, Input, {
        /**
     * handle mouse and touch events
     * @param {Hammer} manager
     * @param {String} inputEvent
     * @param {Object} inputData
     */ handler: function TMEhandler(manager, inputEvent, inputData) {
            var isTouch = inputData.pointerType == INPUT_TYPE_TOUCH, isMouse = inputData.pointerType == INPUT_TYPE_MOUSE;
            if (isMouse && inputData.sourceCapabilities && inputData.sourceCapabilities.firesTouchEvents) return;
            // when we're in a touch event, record touches to  de-dupe synthetic mouse event
            if (isTouch) recordTouches.call(this, inputEvent, inputData);
            else if (isMouse && isSyntheticEvent.call(this, inputData)) return;
            this.callback(manager, inputEvent, inputData);
        },
        /**
     * remove the event listeners
     */ destroy: function destroy() {
            this.touch.destroy();
            this.mouse.destroy();
        }
    });
    function recordTouches(eventType, eventData) {
        if (eventType & INPUT_START) {
            this.primaryTouch = eventData.changedPointers[0].identifier;
            setLastTouch.call(this, eventData);
        } else if (eventType & (INPUT_END | INPUT_CANCEL)) setLastTouch.call(this, eventData);
    }
    function setLastTouch(eventData) {
        var touch = eventData.changedPointers[0];
        if (touch.identifier === this.primaryTouch) {
            var lastTouch = {
                x: touch.clientX,
                y: touch.clientY
            };
            this.lastTouches.push(lastTouch);
            var lts = this.lastTouches;
            var removeLastTouch = function() {
                var i = lts.indexOf(lastTouch);
                if (i > -1) lts.splice(i, 1);
            };
            setTimeout(removeLastTouch, DEDUP_TIMEOUT);
        }
    }
    function isSyntheticEvent(eventData) {
        var x = eventData.srcEvent.clientX, y = eventData.srcEvent.clientY;
        for(var i = 0; i < this.lastTouches.length; i++){
            var t = this.lastTouches[i];
            var dx = Math.abs(x - t.x), dy = Math.abs(y - t.y);
            if (dx <= DEDUP_DISTANCE && dy <= DEDUP_DISTANCE) return true;
        }
        return false;
    }
    var PREFIXED_TOUCH_ACTION = prefixed(TEST_ELEMENT.style, "touchAction");
    var NATIVE_TOUCH_ACTION = PREFIXED_TOUCH_ACTION !== undefined;
    // magical touchAction value
    var TOUCH_ACTION_COMPUTE = "compute";
    var TOUCH_ACTION_AUTO = "auto";
    var TOUCH_ACTION_MANIPULATION = "manipulation"; // not implemented
    var TOUCH_ACTION_NONE = "none";
    var TOUCH_ACTION_PAN_X = "pan-x";
    var TOUCH_ACTION_PAN_Y = "pan-y";
    var TOUCH_ACTION_MAP = getTouchActionProps();
    /**
 * Touch Action
 * sets the touchAction property or uses the js alternative
 * @param {Manager} manager
 * @param {String} value
 * @constructor
 */ function TouchAction(manager, value) {
        this.manager = manager;
        this.set(value);
    }
    TouchAction.prototype = {
        /**
     * set the touchAction value on the element or enable the polyfill
     * @param {String} value
     */ set: function(value) {
            // find out the touch-action by the event handlers
            if (value == TOUCH_ACTION_COMPUTE) value = this.compute();
            if (NATIVE_TOUCH_ACTION && this.manager.element.style && TOUCH_ACTION_MAP[value]) this.manager.element.style[PREFIXED_TOUCH_ACTION] = value;
            this.actions = value.toLowerCase().trim();
        },
        /**
     * just re-set the touchAction value
     */ update: function() {
            this.set(this.manager.options.touchAction);
        },
        /**
     * compute the value for the touchAction property based on the recognizer's settings
     * @returns {String} value
     */ compute: function() {
            var actions = [];
            each(this.manager.recognizers, function(recognizer) {
                if (boolOrFn(recognizer.options.enable, [
                    recognizer
                ])) actions = actions.concat(recognizer.getTouchAction());
            });
            return cleanTouchActions(actions.join(" "));
        },
        /**
     * this method is called on each input cycle and provides the preventing of the browser behavior
     * @param {Object} input
     */ preventDefaults: function(input) {
            var srcEvent = input.srcEvent;
            var direction = input.offsetDirection;
            // if the touch action did prevented once this session
            if (this.manager.session.prevented) {
                srcEvent.preventDefault();
                return;
            }
            var actions = this.actions;
            var hasNone = inStr(actions, TOUCH_ACTION_NONE) && !TOUCH_ACTION_MAP[TOUCH_ACTION_NONE];
            var hasPanY = inStr(actions, TOUCH_ACTION_PAN_Y) && !TOUCH_ACTION_MAP[TOUCH_ACTION_PAN_Y];
            var hasPanX = inStr(actions, TOUCH_ACTION_PAN_X) && !TOUCH_ACTION_MAP[TOUCH_ACTION_PAN_X];
            if (hasNone) {
                //do not prevent defaults if this is a tap gesture
                var isTapPointer = input.pointers.length === 1;
                var isTapMovement = input.distance < 2;
                var isTapTouchTime = input.deltaTime < 250;
                if (isTapPointer && isTapMovement && isTapTouchTime) return;
            }
            if (hasPanX && hasPanY) // `pan-x pan-y` means browser handles all scrolling/panning, do not prevent
            return;
            if (hasNone || hasPanY && direction & DIRECTION_HORIZONTAL || hasPanX && direction & DIRECTION_VERTICAL) return this.preventSrc(srcEvent);
        },
        /**
     * call preventDefault to prevent the browser's default behavior (scrolling in most cases)
     * @param {Object} srcEvent
     */ preventSrc: function(srcEvent) {
            this.manager.session.prevented = true;
            srcEvent.preventDefault();
        }
    };
    /**
 * when the touchActions are collected they are not a valid value, so we need to clean things up. *
 * @param {String} actions
 * @returns {*}
 */ function cleanTouchActions(actions) {
        // none
        if (inStr(actions, TOUCH_ACTION_NONE)) return TOUCH_ACTION_NONE;
        var hasPanX = inStr(actions, TOUCH_ACTION_PAN_X);
        var hasPanY = inStr(actions, TOUCH_ACTION_PAN_Y);
        // if both pan-x and pan-y are set (different recognizers
        // for different directions, e.g. horizontal pan but vertical swipe?)
        // we need none (as otherwise with pan-x pan-y combined none of these
        // recognizers will work, since the browser would handle all panning
        if (hasPanX && hasPanY) return TOUCH_ACTION_NONE;
        // pan-x OR pan-y
        if (hasPanX || hasPanY) return hasPanX ? TOUCH_ACTION_PAN_X : TOUCH_ACTION_PAN_Y;
        // manipulation
        if (inStr(actions, TOUCH_ACTION_MANIPULATION)) return TOUCH_ACTION_MANIPULATION;
        return TOUCH_ACTION_AUTO;
    }
    function getTouchActionProps() {
        if (!NATIVE_TOUCH_ACTION) return false;
        var touchMap = {};
        var cssSupports = window1.CSS && window1.CSS.supports;
        [
            "auto",
            "manipulation",
            "pan-y",
            "pan-x",
            "pan-x pan-y",
            "none"
        ].forEach(function(val) {
            // If css.supports is not supported but there is native touch-action assume it supports
            // all values. This is the case for IE 10 and 11.
            touchMap[val] = cssSupports ? window1.CSS.supports("touch-action", val) : true;
        });
        return touchMap;
    }
    /**
 * Recognizer flow explained; *
 * All recognizers have the initial state of POSSIBLE when a input session starts.
 * The definition of a input session is from the first input until the last input, with all it's movement in it. *
 * Example session for mouse-input: mousedown -> mousemove -> mouseup
 *
 * On each recognizing cycle (see Manager.recognize) the .recognize() method is executed
 * which determines with state it should be.
 *
 * If the recognizer has the state FAILED, CANCELLED or RECOGNIZED (equals ENDED), it is reset to
 * POSSIBLE to give it another change on the next cycle.
 *
 *               Possible
 *                  |
 *            +-----+---------------+
 *            |                     |
 *      +-----+-----+               |
 *      |           |               |
 *   Failed      Cancelled          |
 *                          +-------+------+
 *                          |              |
 *                      Recognized       Began
 *                                         |
 *                                      Changed
 *                                         |
 *                                  Ended/Recognized
 */ var STATE_POSSIBLE = 1;
    var STATE_BEGAN = 2;
    var STATE_CHANGED = 4;
    var STATE_ENDED = 8;
    var STATE_RECOGNIZED = STATE_ENDED;
    var STATE_CANCELLED = 16;
    var STATE_FAILED = 32;
    /**
 * Recognizer
 * Every recognizer needs to extend from this class.
 * @constructor
 * @param {Object} options
 */ function Recognizer(options) {
        this.options = assign({}, this.defaults, options || {});
        this.id = uniqueId();
        this.manager = null;
        // default is enable true
        this.options.enable = ifUndefined(this.options.enable, true);
        this.state = STATE_POSSIBLE;
        this.simultaneous = {};
        this.requireFail = [];
    }
    Recognizer.prototype = {
        /**
     * @virtual
     * @type {Object}
     */ defaults: {},
        /**
     * set options
     * @param {Object} options
     * @return {Recognizer}
     */ set: function(options) {
            assign(this.options, options);
            // also update the touchAction, in case something changed about the directions/enabled state
            this.manager && this.manager.touchAction.update();
            return this;
        },
        /**
     * recognize simultaneous with an other recognizer.
     * @param {Recognizer} otherRecognizer
     * @returns {Recognizer} this
     */ recognizeWith: function(otherRecognizer) {
            if (invokeArrayArg(otherRecognizer, "recognizeWith", this)) return this;
            var simultaneous = this.simultaneous;
            otherRecognizer = getRecognizerByNameIfManager(otherRecognizer, this);
            if (!simultaneous[otherRecognizer.id]) {
                simultaneous[otherRecognizer.id] = otherRecognizer;
                otherRecognizer.recognizeWith(this);
            }
            return this;
        },
        /**
     * drop the simultaneous link. it doesnt remove the link on the other recognizer.
     * @param {Recognizer} otherRecognizer
     * @returns {Recognizer} this
     */ dropRecognizeWith: function(otherRecognizer) {
            if (invokeArrayArg(otherRecognizer, "dropRecognizeWith", this)) return this;
            otherRecognizer = getRecognizerByNameIfManager(otherRecognizer, this);
            delete this.simultaneous[otherRecognizer.id];
            return this;
        },
        /**
     * recognizer can only run when an other is failing
     * @param {Recognizer} otherRecognizer
     * @returns {Recognizer} this
     */ requireFailure: function(otherRecognizer) {
            if (invokeArrayArg(otherRecognizer, "requireFailure", this)) return this;
            var requireFail = this.requireFail;
            otherRecognizer = getRecognizerByNameIfManager(otherRecognizer, this);
            if (inArray(requireFail, otherRecognizer) === -1) {
                requireFail.push(otherRecognizer);
                otherRecognizer.requireFailure(this);
            }
            return this;
        },
        /**
     * drop the requireFailure link. it does not remove the link on the other recognizer.
     * @param {Recognizer} otherRecognizer
     * @returns {Recognizer} this
     */ dropRequireFailure: function(otherRecognizer) {
            if (invokeArrayArg(otherRecognizer, "dropRequireFailure", this)) return this;
            otherRecognizer = getRecognizerByNameIfManager(otherRecognizer, this);
            var index = inArray(this.requireFail, otherRecognizer);
            if (index > -1) this.requireFail.splice(index, 1);
            return this;
        },
        /**
     * has require failures boolean
     * @returns {boolean}
     */ hasRequireFailures: function() {
            return this.requireFail.length > 0;
        },
        /**
     * if the recognizer can recognize simultaneous with an other recognizer
     * @param {Recognizer} otherRecognizer
     * @returns {Boolean}
     */ canRecognizeWith: function(otherRecognizer) {
            return !!this.simultaneous[otherRecognizer.id];
        },
        /**
     * You should use `tryEmit` instead of `emit` directly to check
     * that all the needed recognizers has failed before emitting.
     * @param {Object} input
     */ emit: function(input) {
            var self1 = this;
            var state = this.state;
            function emit(event) {
                self1.manager.emit(event, input);
            }
            // 'panstart' and 'panmove'
            if (state < STATE_ENDED) emit(self1.options.event + stateStr(state));
            emit(self1.options.event); // simple 'eventName' events
            if (input.additionalEvent) emit(input.additionalEvent);
            // panend and pancancel
            if (state >= STATE_ENDED) emit(self1.options.event + stateStr(state));
        },
        /**
     * Check that all the require failure recognizers has failed,
     * if true, it emits a gesture event,
     * otherwise, setup the state to FAILED.
     * @param {Object} input
     */ tryEmit: function(input) {
            if (this.canEmit()) return this.emit(input);
            // it's failing anyway
            this.state = STATE_FAILED;
        },
        /**
     * can we emit?
     * @returns {boolean}
     */ canEmit: function() {
            var i = 0;
            while(i < this.requireFail.length){
                if (!(this.requireFail[i].state & (STATE_FAILED | STATE_POSSIBLE))) return false;
                i++;
            }
            return true;
        },
        /**
     * update the recognizer
     * @param {Object} inputData
     */ recognize: function(inputData) {
            // make a new copy of the inputData
            // so we can change the inputData without messing up the other recognizers
            var inputDataClone = assign({}, inputData);
            // is is enabled and allow recognizing?
            if (!boolOrFn(this.options.enable, [
                this,
                inputDataClone
            ])) {
                this.reset();
                this.state = STATE_FAILED;
                return;
            }
            // reset when we've reached the end
            if (this.state & (STATE_RECOGNIZED | STATE_CANCELLED | STATE_FAILED)) this.state = STATE_POSSIBLE;
            this.state = this.process(inputDataClone);
            // the recognizer has recognized a gesture
            // so trigger an event
            if (this.state & (STATE_BEGAN | STATE_CHANGED | STATE_ENDED | STATE_CANCELLED)) this.tryEmit(inputDataClone);
        },
        /**
     * return the state of the recognizer
     * the actual recognizing happens in this method
     * @virtual
     * @param {Object} inputData
     * @returns {Const} STATE
     */ process: function(inputData) {},
        /**
     * return the preferred touch-action
     * @virtual
     * @returns {Array}
     */ getTouchAction: function() {},
        /**
     * called when the gesture isn't allowed to recognize
     * like when another is being recognized or it is disabled
     * @virtual
     */ reset: function() {}
    };
    /**
 * get a usable string, used as event postfix
 * @param {Const} state
 * @returns {String} state
 */ function stateStr(state) {
        if (state & STATE_CANCELLED) return "cancel";
        else if (state & STATE_ENDED) return "end";
        else if (state & STATE_CHANGED) return "move";
        else if (state & STATE_BEGAN) return "start";
        return "";
    }
    /**
 * direction cons to string
 * @param {Const} direction
 * @returns {String}
 */ function directionStr(direction) {
        if (direction == DIRECTION_DOWN) return "down";
        else if (direction == DIRECTION_UP) return "up";
        else if (direction == DIRECTION_LEFT) return "left";
        else if (direction == DIRECTION_RIGHT) return "right";
        return "";
    }
    /**
 * get a recognizer by name if it is bound to a manager
 * @param {Recognizer|String} otherRecognizer
 * @param {Recognizer} recognizer
 * @returns {Recognizer}
 */ function getRecognizerByNameIfManager(otherRecognizer, recognizer) {
        var manager = recognizer.manager;
        if (manager) return manager.get(otherRecognizer);
        return otherRecognizer;
    }
    /**
 * This recognizer is just used as a base for the simple attribute recognizers.
 * @constructor
 * @extends Recognizer
 */ function AttrRecognizer() {
        Recognizer.apply(this, arguments);
    }
    inherit(AttrRecognizer, Recognizer, {
        /**
     * @namespace
     * @memberof AttrRecognizer
     */ defaults: {
            /**
         * @type {Number}
         * @default 1
         */ pointers: 1
        },
        /**
     * Used to check if it the recognizer receives valid input, like input.distance > 10.
     * @memberof AttrRecognizer
     * @param {Object} input
     * @returns {Boolean} recognized
     */ attrTest: function(input) {
            var optionPointers = this.options.pointers;
            return optionPointers === 0 || input.pointers.length === optionPointers;
        },
        /**
     * Process the input and return the state for the recognizer
     * @memberof AttrRecognizer
     * @param {Object} input
     * @returns {*} State
     */ process: function(input) {
            var state = this.state;
            var eventType = input.eventType;
            var isRecognized = state & (STATE_BEGAN | STATE_CHANGED);
            var isValid = this.attrTest(input);
            // on cancel input and we've recognized before, return STATE_CANCELLED
            if (isRecognized && (eventType & INPUT_CANCEL || !isValid)) return state | STATE_CANCELLED;
            else if (isRecognized || isValid) {
                if (eventType & INPUT_END) return state | STATE_ENDED;
                else if (!(state & STATE_BEGAN)) return STATE_BEGAN;
                return state | STATE_CHANGED;
            }
            return STATE_FAILED;
        }
    });
    /**
 * Pan
 * Recognized when the pointer is down and moved in the allowed direction.
 * @constructor
 * @extends AttrRecognizer
 */ function PanRecognizer() {
        AttrRecognizer.apply(this, arguments);
        this.pX = null;
        this.pY = null;
    }
    inherit(PanRecognizer, AttrRecognizer, {
        /**
     * @namespace
     * @memberof PanRecognizer
     */ defaults: {
            event: "pan",
            threshold: 10,
            pointers: 1,
            direction: DIRECTION_ALL
        },
        getTouchAction: function() {
            var direction = this.options.direction;
            var actions = [];
            if (direction & DIRECTION_HORIZONTAL) actions.push(TOUCH_ACTION_PAN_Y);
            if (direction & DIRECTION_VERTICAL) actions.push(TOUCH_ACTION_PAN_X);
            return actions;
        },
        directionTest: function(input) {
            var options = this.options;
            var hasMoved = true;
            var distance = input.distance;
            var direction = input.direction;
            var x = input.deltaX;
            var y = input.deltaY;
            // lock to axis?
            if (!(direction & options.direction)) {
                if (options.direction & DIRECTION_HORIZONTAL) {
                    direction = x === 0 ? DIRECTION_NONE : x < 0 ? DIRECTION_LEFT : DIRECTION_RIGHT;
                    hasMoved = x != this.pX;
                    distance = Math.abs(input.deltaX);
                } else {
                    direction = y === 0 ? DIRECTION_NONE : y < 0 ? DIRECTION_UP : DIRECTION_DOWN;
                    hasMoved = y != this.pY;
                    distance = Math.abs(input.deltaY);
                }
            }
            input.direction = direction;
            return hasMoved && distance > options.threshold && direction & options.direction;
        },
        attrTest: function(input) {
            return AttrRecognizer.prototype.attrTest.call(this, input) && (this.state & STATE_BEGAN || !(this.state & STATE_BEGAN) && this.directionTest(input));
        },
        emit: function(input) {
            this.pX = input.deltaX;
            this.pY = input.deltaY;
            var direction = directionStr(input.direction);
            if (direction) input.additionalEvent = this.options.event + direction;
            this._super.emit.call(this, input);
        }
    });
    /**
 * Pinch
 * Recognized when two or more pointers are moving toward (zoom-in) or away from each other (zoom-out).
 * @constructor
 * @extends AttrRecognizer
 */ function PinchRecognizer() {
        AttrRecognizer.apply(this, arguments);
    }
    inherit(PinchRecognizer, AttrRecognizer, {
        /**
     * @namespace
     * @memberof PinchRecognizer
     */ defaults: {
            event: "pinch",
            threshold: 0,
            pointers: 2
        },
        getTouchAction: function() {
            return [
                TOUCH_ACTION_NONE
            ];
        },
        attrTest: function(input) {
            return this._super.attrTest.call(this, input) && (Math.abs(input.scale - 1) > this.options.threshold || this.state & STATE_BEGAN);
        },
        emit: function(input) {
            if (input.scale !== 1) {
                var inOut = input.scale < 1 ? "in" : "out";
                input.additionalEvent = this.options.event + inOut;
            }
            this._super.emit.call(this, input);
        }
    });
    /**
 * Press
 * Recognized when the pointer is down for x ms without any movement.
 * @constructor
 * @extends Recognizer
 */ function PressRecognizer() {
        Recognizer.apply(this, arguments);
        this._timer = null;
        this._input = null;
    }
    inherit(PressRecognizer, Recognizer, {
        /**
     * @namespace
     * @memberof PressRecognizer
     */ defaults: {
            event: "press",
            pointers: 1,
            time: 251,
            threshold: 9 // a minimal movement is ok, but keep it low
        },
        getTouchAction: function() {
            return [
                TOUCH_ACTION_AUTO
            ];
        },
        process: function(input) {
            var options = this.options;
            var validPointers = input.pointers.length === options.pointers;
            var validMovement = input.distance < options.threshold;
            var validTime = input.deltaTime > options.time;
            this._input = input;
            // we only allow little movement
            // and we've reached an end event, so a tap is possible
            if (!validMovement || !validPointers || input.eventType & (INPUT_END | INPUT_CANCEL) && !validTime) this.reset();
            else if (input.eventType & INPUT_START) {
                this.reset();
                this._timer = setTimeoutContext(function() {
                    this.state = STATE_RECOGNIZED;
                    this.tryEmit();
                }, options.time, this);
            } else if (input.eventType & INPUT_END) return STATE_RECOGNIZED;
            return STATE_FAILED;
        },
        reset: function() {
            clearTimeout(this._timer);
        },
        emit: function(input) {
            if (this.state !== STATE_RECOGNIZED) return;
            if (input && input.eventType & INPUT_END) this.manager.emit(this.options.event + "up", input);
            else {
                this._input.timeStamp = now();
                this.manager.emit(this.options.event, this._input);
            }
        }
    });
    /**
 * Rotate
 * Recognized when two or more pointer are moving in a circular motion.
 * @constructor
 * @extends AttrRecognizer
 */ function RotateRecognizer() {
        AttrRecognizer.apply(this, arguments);
    }
    inherit(RotateRecognizer, AttrRecognizer, {
        /**
     * @namespace
     * @memberof RotateRecognizer
     */ defaults: {
            event: "rotate",
            threshold: 0,
            pointers: 2
        },
        getTouchAction: function() {
            return [
                TOUCH_ACTION_NONE
            ];
        },
        attrTest: function(input) {
            return this._super.attrTest.call(this, input) && (Math.abs(input.rotation) > this.options.threshold || this.state & STATE_BEGAN);
        }
    });
    /**
 * Swipe
 * Recognized when the pointer is moving fast (velocity), with enough distance in the allowed direction.
 * @constructor
 * @extends AttrRecognizer
 */ function SwipeRecognizer() {
        AttrRecognizer.apply(this, arguments);
    }
    inherit(SwipeRecognizer, AttrRecognizer, {
        /**
     * @namespace
     * @memberof SwipeRecognizer
     */ defaults: {
            event: "swipe",
            threshold: 10,
            velocity: 0.3,
            direction: DIRECTION_HORIZONTAL | DIRECTION_VERTICAL,
            pointers: 1
        },
        getTouchAction: function() {
            return PanRecognizer.prototype.getTouchAction.call(this);
        },
        attrTest: function(input) {
            var direction = this.options.direction;
            var velocity;
            if (direction & (DIRECTION_HORIZONTAL | DIRECTION_VERTICAL)) velocity = input.overallVelocity;
            else if (direction & DIRECTION_HORIZONTAL) velocity = input.overallVelocityX;
            else if (direction & DIRECTION_VERTICAL) velocity = input.overallVelocityY;
            return this._super.attrTest.call(this, input) && direction & input.offsetDirection && input.distance > this.options.threshold && input.maxPointers == this.options.pointers && abs(velocity) > this.options.velocity && input.eventType & INPUT_END;
        },
        emit: function(input) {
            var direction = directionStr(input.offsetDirection);
            if (direction) this.manager.emit(this.options.event + direction, input);
            this.manager.emit(this.options.event, input);
        }
    });
    /**
 * A tap is ecognized when the pointer is doing a small tap/click. Multiple taps are recognized if they occur
 * between the given interval and position. The delay option can be used to recognize multi-taps without firing
 * a single tap.
 *
 * The eventData from the emitted event contains the property `tapCount`, which contains the amount of
 * multi-taps being recognized.
 * @constructor
 * @extends Recognizer
 */ function TapRecognizer() {
        Recognizer.apply(this, arguments);
        // previous time and center,
        // used for tap counting
        this.pTime = false;
        this.pCenter = false;
        this._timer = null;
        this._input = null;
        this.count = 0;
    }
    inherit(TapRecognizer, Recognizer, {
        /**
     * @namespace
     * @memberof PinchRecognizer
     */ defaults: {
            event: "tap",
            pointers: 1,
            taps: 1,
            interval: 300,
            time: 250,
            threshold: 9,
            posThreshold: 10 // a multi-tap can be a bit off the initial position
        },
        getTouchAction: function() {
            return [
                TOUCH_ACTION_MANIPULATION
            ];
        },
        process: function(input) {
            var options = this.options;
            var validPointers = input.pointers.length === options.pointers;
            var validMovement = input.distance < options.threshold;
            var validTouchTime = input.deltaTime < options.time;
            this.reset();
            if (input.eventType & INPUT_START && this.count === 0) return this.failTimeout();
            // we only allow little movement
            // and we've reached an end event, so a tap is possible
            if (validMovement && validTouchTime && validPointers) {
                if (input.eventType != INPUT_END) return this.failTimeout();
                var validInterval = this.pTime ? input.timeStamp - this.pTime < options.interval : true;
                var validMultiTap = !this.pCenter || getDistance(this.pCenter, input.center) < options.posThreshold;
                this.pTime = input.timeStamp;
                this.pCenter = input.center;
                if (!validMultiTap || !validInterval) this.count = 1;
                else this.count += 1;
                this._input = input;
                // if tap count matches we have recognized it,
                // else it has began recognizing...
                var tapCount = this.count % options.taps;
                if (tapCount === 0) {
                    // no failing requirements, immediately trigger the tap event
                    // or wait as long as the multitap interval to trigger
                    if (!this.hasRequireFailures()) return STATE_RECOGNIZED;
                    else {
                        this._timer = setTimeoutContext(function() {
                            this.state = STATE_RECOGNIZED;
                            this.tryEmit();
                        }, options.interval, this);
                        return STATE_BEGAN;
                    }
                }
            }
            return STATE_FAILED;
        },
        failTimeout: function() {
            this._timer = setTimeoutContext(function() {
                this.state = STATE_FAILED;
            }, this.options.interval, this);
            return STATE_FAILED;
        },
        reset: function() {
            clearTimeout(this._timer);
        },
        emit: function() {
            if (this.state == STATE_RECOGNIZED) {
                this._input.tapCount = this.count;
                this.manager.emit(this.options.event, this._input);
            }
        }
    });
    /**
 * Simple way to create a manager with a default set of recognizers.
 * @param {HTMLElement} element
 * @param {Object} [options]
 * @constructor
 */ function Hammer(element, options) {
        options = options || {};
        options.recognizers = ifUndefined(options.recognizers, Hammer.defaults.preset);
        return new Manager(element, options);
    }
    /**
 * @const {string}
 */ Hammer.VERSION = "2.0.7";
    /**
 * default settings
 * @namespace
 */ Hammer.defaults = {
        /**
     * set if DOM events are being triggered.
     * But this is slower and unused by simple implementations, so disabled by default.
     * @type {Boolean}
     * @default false
     */ domEvents: false,
        /**
     * The value for the touchAction property/fallback.
     * When set to `compute` it will magically set the correct value based on the added recognizers.
     * @type {String}
     * @default compute
     */ touchAction: TOUCH_ACTION_COMPUTE,
        /**
     * @type {Boolean}
     * @default true
     */ enable: true,
        /**
     * EXPERIMENTAL FEATURE -- can be removed/changed
     * Change the parent input target element.
     * If Null, then it is being set the to main element.
     * @type {Null|EventTarget}
     * @default null
     */ inputTarget: null,
        /**
     * force an input class
     * @type {Null|Function}
     * @default null
     */ inputClass: null,
        /**
     * Default recognizer setup when calling `Hammer()`
     * When creating a new Manager these will be skipped.
     * @type {Array}
     */ preset: [
            // RecognizerClass, options, [recognizeWith, ...], [requireFailure, ...]
            [
                RotateRecognizer,
                {
                    enable: false
                }
            ],
            [
                PinchRecognizer,
                {
                    enable: false
                },
                [
                    "rotate"
                ]
            ],
            [
                SwipeRecognizer,
                {
                    direction: DIRECTION_HORIZONTAL
                }
            ],
            [
                PanRecognizer,
                {
                    direction: DIRECTION_HORIZONTAL
                },
                [
                    "swipe"
                ]
            ],
            [
                TapRecognizer
            ],
            [
                TapRecognizer,
                {
                    event: "doubletap",
                    taps: 2
                },
                [
                    "tap"
                ]
            ],
            [
                PressRecognizer
            ]
        ],
        /**
     * Some CSS properties can be used to improve the working of Hammer.
     * Add them to this method and they will be set when creating a new Manager.
     * @namespace
     */ cssProps: {
            /**
         * Disables text selection to improve the dragging gesture. Mainly for desktop browsers.
         * @type {String}
         * @default 'none'
         */ userSelect: "none",
            /**
         * Disable the Windows Phone grippers when pressing an element.
         * @type {String}
         * @default 'none'
         */ touchSelect: "none",
            /**
         * Disables the default callout shown when you touch and hold a touch target.
         * On iOS, when you touch and hold a touch target such as a link, Safari displays
         * a callout containing information about the link. This property allows you to disable that callout.
         * @type {String}
         * @default 'none'
         */ touchCallout: "none",
            /**
         * Specifies whether zooming is enabled. Used by IE10>
         * @type {String}
         * @default 'none'
         */ contentZooming: "none",
            /**
         * Specifies that an entire element should be draggable instead of its contents. Mainly for desktop browsers.
         * @type {String}
         * @default 'none'
         */ userDrag: "none",
            /**
         * Overrides the highlight color shown when the user taps a link or a JavaScript
         * clickable element in iOS. This property obeys the alpha value, if specified.
         * @type {String}
         * @default 'rgba(0,0,0,0)'
         */ tapHighlightColor: "rgba(0,0,0,0)"
        }
    };
    var STOP = 1;
    var FORCED_STOP = 2;
    /**
 * Manager
 * @param {HTMLElement} element
 * @param {Object} [options]
 * @constructor
 */ function Manager(element, options) {
        this.options = assign({}, Hammer.defaults, options || {});
        this.options.inputTarget = this.options.inputTarget || element;
        this.handlers = {};
        this.session = {};
        this.recognizers = [];
        this.oldCssProps = {};
        this.element = element;
        this.input = createInputInstance(this);
        this.touchAction = new TouchAction(this, this.options.touchAction);
        toggleCssProps(this, true);
        each(this.options.recognizers, function(item) {
            var recognizer = this.add(new item[0](item[1]));
            item[2] && recognizer.recognizeWith(item[2]);
            item[3] && recognizer.requireFailure(item[3]);
        }, this);
    }
    Manager.prototype = {
        /**
     * set options
     * @param {Object} options
     * @returns {Manager}
     */ set: function(options) {
            assign(this.options, options);
            // Options that need a little more setup
            if (options.touchAction) this.touchAction.update();
            if (options.inputTarget) {
                // Clean up existing event listeners and reinitialize
                this.input.destroy();
                this.input.target = options.inputTarget;
                this.input.init();
            }
            return this;
        },
        /**
     * stop recognizing for this session.
     * This session will be discarded, when a new [input]start event is fired.
     * When forced, the recognizer cycle is stopped immediately.
     * @param {Boolean} [force]
     */ stop: function(force) {
            this.session.stopped = force ? FORCED_STOP : STOP;
        },
        /**
     * run the recognizers!
     * called by the inputHandler function on every movement of the pointers (touches)
     * it walks through all the recognizers and tries to detect the gesture that is being made
     * @param {Object} inputData
     */ recognize: function(inputData) {
            var session = this.session;
            if (session.stopped) return;
            // run the touch-action polyfill
            this.touchAction.preventDefaults(inputData);
            var recognizer;
            var recognizers = this.recognizers;
            // this holds the recognizer that is being recognized.
            // so the recognizer's state needs to be BEGAN, CHANGED, ENDED or RECOGNIZED
            // if no recognizer is detecting a thing, it is set to `null`
            var curRecognizer = session.curRecognizer;
            // reset when the last recognizer is recognized
            // or when we're in a new session
            if (!curRecognizer || curRecognizer && curRecognizer.state & STATE_RECOGNIZED) curRecognizer = session.curRecognizer = null;
            var i = 0;
            while(i < recognizers.length){
                recognizer = recognizers[i];
                // find out if we are allowed try to recognize the input for this one.
                // 1.   allow if the session is NOT forced stopped (see the .stop() method)
                // 2.   allow if we still haven't recognized a gesture in this session, or the this recognizer is the one
                //      that is being recognized.
                // 3.   allow if the recognizer is allowed to run simultaneous with the current recognized recognizer.
                //      this can be setup with the `recognizeWith()` method on the recognizer.
                if (session.stopped !== FORCED_STOP && (!curRecognizer || recognizer == curRecognizer || // 2
                recognizer.canRecognizeWith(curRecognizer))) recognizer.recognize(inputData);
                else recognizer.reset();
                // if the recognizer has been recognizing the input as a valid gesture, we want to store this one as the
                // current active recognizer. but only if we don't already have an active recognizer
                if (!curRecognizer && recognizer.state & (STATE_BEGAN | STATE_CHANGED | STATE_ENDED)) curRecognizer = session.curRecognizer = recognizer;
                i++;
            }
        },
        /**
     * get a recognizer by its event name.
     * @param {Recognizer|String} recognizer
     * @returns {Recognizer|Null}
     */ get: function(recognizer) {
            if (recognizer instanceof Recognizer) return recognizer;
            var recognizers = this.recognizers;
            for(var i = 0; i < recognizers.length; i++){
                if (recognizers[i].options.event == recognizer) return recognizers[i];
            }
            return null;
        },
        /**
     * add a recognizer to the manager
     * existing recognizers with the same event name will be removed
     * @param {Recognizer} recognizer
     * @returns {Recognizer|Manager}
     */ add: function(recognizer) {
            if (invokeArrayArg(recognizer, "add", this)) return this;
            // remove existing
            var existing = this.get(recognizer.options.event);
            if (existing) this.remove(existing);
            this.recognizers.push(recognizer);
            recognizer.manager = this;
            this.touchAction.update();
            return recognizer;
        },
        /**
     * remove a recognizer by name or instance
     * @param {Recognizer|String} recognizer
     * @returns {Manager}
     */ remove: function(recognizer) {
            if (invokeArrayArg(recognizer, "remove", this)) return this;
            recognizer = this.get(recognizer);
            // let's make sure this recognizer exists
            if (recognizer) {
                var recognizers = this.recognizers;
                var index = inArray(recognizers, recognizer);
                if (index !== -1) {
                    recognizers.splice(index, 1);
                    this.touchAction.update();
                }
            }
            return this;
        },
        /**
     * bind event
     * @param {String} events
     * @param {Function} handler
     * @returns {EventEmitter} this
     */ on: function(events, handler) {
            if (events === undefined) return;
            if (handler === undefined) return;
            var handlers = this.handlers;
            each(splitStr(events), function(event) {
                handlers[event] = handlers[event] || [];
                handlers[event].push(handler);
            });
            return this;
        },
        /**
     * unbind event, leave emit blank to remove all handlers
     * @param {String} events
     * @param {Function} [handler]
     * @returns {EventEmitter} this
     */ off: function(events, handler) {
            if (events === undefined) return;
            var handlers = this.handlers;
            each(splitStr(events), function(event) {
                if (!handler) delete handlers[event];
                else handlers[event] && handlers[event].splice(inArray(handlers[event], handler), 1);
            });
            return this;
        },
        /**
     * emit event to the listeners
     * @param {String} event
     * @param {Object} data
     */ emit: function(event, data) {
            // we also want to trigger dom events
            if (this.options.domEvents) triggerDomEvent(event, data);
            // no handlers, so skip it all
            var handlers = this.handlers[event] && this.handlers[event].slice();
            if (!handlers || !handlers.length) return;
            data.type = event;
            data.preventDefault = function() {
                data.srcEvent.preventDefault();
            };
            var i = 0;
            while(i < handlers.length){
                handlers[i](data);
                i++;
            }
        },
        /**
     * destroy the manager and unbinds all events
     * it doesn't unbind dom events, that is the user own responsibility
     */ destroy: function() {
            this.element && toggleCssProps(this, false);
            this.handlers = {};
            this.session = {};
            this.input.destroy();
            this.element = null;
        }
    };
    /**
 * add/remove the css properties as defined in manager.options.cssProps
 * @param {Manager} manager
 * @param {Boolean} add
 */ function toggleCssProps(manager, add) {
        var element = manager.element;
        if (!element.style) return;
        var prop;
        each(manager.options.cssProps, function(value, name) {
            prop = prefixed(element.style, name);
            if (add) {
                manager.oldCssProps[prop] = element.style[prop];
                element.style[prop] = value;
            } else element.style[prop] = manager.oldCssProps[prop] || "";
        });
        if (!add) manager.oldCssProps = {};
    }
    /**
 * trigger dom event
 * @param {String} event
 * @param {Object} data
 */ function triggerDomEvent(event, data) {
        var gestureEvent = document1.createEvent("Event");
        gestureEvent.initEvent(event, true, true);
        gestureEvent.gesture = data;
        data.target.dispatchEvent(gestureEvent);
    }
    assign(Hammer, {
        INPUT_START: INPUT_START,
        INPUT_MOVE: INPUT_MOVE,
        INPUT_END: INPUT_END,
        INPUT_CANCEL: INPUT_CANCEL,
        STATE_POSSIBLE: STATE_POSSIBLE,
        STATE_BEGAN: STATE_BEGAN,
        STATE_CHANGED: STATE_CHANGED,
        STATE_ENDED: STATE_ENDED,
        STATE_RECOGNIZED: STATE_RECOGNIZED,
        STATE_CANCELLED: STATE_CANCELLED,
        STATE_FAILED: STATE_FAILED,
        DIRECTION_NONE: DIRECTION_NONE,
        DIRECTION_LEFT: DIRECTION_LEFT,
        DIRECTION_RIGHT: DIRECTION_RIGHT,
        DIRECTION_UP: DIRECTION_UP,
        DIRECTION_DOWN: DIRECTION_DOWN,
        DIRECTION_HORIZONTAL: DIRECTION_HORIZONTAL,
        DIRECTION_VERTICAL: DIRECTION_VERTICAL,
        DIRECTION_ALL: DIRECTION_ALL,
        Manager: Manager,
        Input: Input,
        TouchAction: TouchAction,
        TouchInput: TouchInput,
        MouseInput: MouseInput,
        PointerEventInput: PointerEventInput,
        TouchMouseInput: TouchMouseInput,
        SingleTouchInput: SingleTouchInput,
        Recognizer: Recognizer,
        AttrRecognizer: AttrRecognizer,
        Tap: TapRecognizer,
        Pan: PanRecognizer,
        Swipe: SwipeRecognizer,
        Pinch: PinchRecognizer,
        Rotate: RotateRecognizer,
        Press: PressRecognizer,
        on: addEventListeners,
        off: removeEventListeners,
        each: each,
        merge: merge,
        extend: extend,
        assign: assign,
        inherit: inherit,
        bindFn: bindFn,
        prefixed: prefixed
    });
    // this prevents errors when Hammer is loaded in the presence of an AMD
    //  style loader but by script tag, not by the loader.
    var freeGlobal = typeof window1 !== "undefined" ? window1 : typeof self !== "undefined" ? self : {}; // jshint ignore:line
    freeGlobal.Hammer = Hammer;
    if (typeof define === "function" && define.amd) define(function() {
        return Hammer;
    });
    else if (module.exports) module.exports = Hammer;
    else window1[exportName] = Hammer;
})(window, document, "Hammer");

},{}],"1PaGf":[function(require,module,exports) {
/**
 * This file contains overrides the default
 * hammer.js functions to add our own utility
 */ /* eslint-disable */ /* Hammer.js constants */ var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
/* eslint-disable no-invalid-this */ parcelHelpers.export(exports, "enhancePointerEventInput", ()=>enhancePointerEventInput);
// overrides MouseInput.handler to accept right mouse button
parcelHelpers.export(exports, "enhanceMouseInput", ()=>enhanceMouseInput);
const INPUT_START = 1;
const INPUT_MOVE = 2;
const INPUT_END = 4;
const MOUSE_INPUT_MAP = {
    mousedown: INPUT_START,
    mousemove: INPUT_MOVE,
    mouseup: INPUT_END
};
/**
 * Helper function that returns true if any element in an array meets given criteria.
 * Because older browsers do not support `Array.prototype.some`
 * @params array {Array}
 * @params predict {Function}
 */ function some(array, predict) {
    for(let i = 0; i < array.length; i++){
        if (predict(array[i])) return true;
    }
    return false;
}
function enhancePointerEventInput(PointerEventInput) {
    const oldHandler = PointerEventInput.prototype.handler;
    // overrides PointerEventInput.handler to accept right mouse button
    PointerEventInput.prototype.handler = function handler(ev) {
        const store = this.store;
        // Allow non-left mouse buttons through
        if (ev.button > 0 && ev.type === "pointerdown") {
            if (!some(store, (e)=>e.pointerId === ev.pointerId)) store.push(ev);
        }
        oldHandler.call(this, ev);
    };
}
function enhanceMouseInput(MouseInput) {
    MouseInput.prototype.handler = function handler(ev) {
        let eventType = MOUSE_INPUT_MAP[ev.type];
        // on start we want to have the mouse button down
        if (eventType & INPUT_START && ev.button >= 0) this.pressed = true;
        if (eventType & INPUT_MOVE && ev.which === 0) eventType = INPUT_END;
        // mouse must be down
        if (!this.pressed) return;
        if (eventType & INPUT_END) this.pressed = false;
        this.callback(this.manager, eventType, {
            pointers: [
                ev
            ],
            changedPointers: [
                ev
            ],
            pointerType: "mouse",
            srcEvent: ev
        });
    };
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"h6n7R":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _input = require("./input");
var _inputDefault = parcelHelpers.interopDefault(_input);
var _constants = require("../constants");
var _globals = require("../utils/globals");
const firefox = (0, _globals.userAgent).indexOf("firefox") !== -1;
const { WHEEL_EVENTS  } = (0, _constants.INPUT_EVENT_TYPES);
const EVENT_TYPE = "wheel";
// Constants for normalizing input delta
const WHEEL_DELTA_MAGIC_SCALER = 4.000244140625;
const WHEEL_DELTA_PER_LINE = 40;
// Slow down zoom if shift key is held for more precise zooming
const SHIFT_MULTIPLIER = 0.25;
class WheelInput extends (0, _inputDefault.default) {
    constructor(element, callback, options){
        super(element, callback, options);
        /* eslint-disable complexity, max-statements */ this.handleEvent = (event)=>{
            if (!this.options.enable) return;
            let value = event.deltaY;
            if ((0, _globals.window).WheelEvent) {
                // Firefox doubles the values on retina screens...
                if (firefox && event.deltaMode === (0, _globals.window).WheelEvent.DOM_DELTA_PIXEL) value /= (0, _globals.window).devicePixelRatio;
                if (event.deltaMode === (0, _globals.window).WheelEvent.DOM_DELTA_LINE) value *= WHEEL_DELTA_PER_LINE;
            }
            if (value !== 0 && value % WHEEL_DELTA_MAGIC_SCALER === 0) // This one is definitely a mouse wheel event.
            // Normalize this value to match trackpad.
            value = Math.floor(value / WHEEL_DELTA_MAGIC_SCALER);
            if (event.shiftKey && value) value = value * SHIFT_MULTIPLIER;
            this.callback({
                type: EVENT_TYPE,
                center: {
                    x: event.clientX,
                    y: event.clientY
                },
                delta: -value,
                srcEvent: event,
                pointerType: "mouse",
                target: event.target
            });
        };
        this.events = (this.options.events || []).concat(WHEEL_EVENTS);
        this.events.forEach((event)=>element.addEventListener(event, this.handleEvent, (0, _globals.passiveSupported) ? {
                passive: false
            } : false));
    }
    destroy() {
        this.events.forEach((event)=>this.element.removeEventListener(event, this.handleEvent));
    }
    /**
     * Enable this input (begin processing events)
     * if the specified event type is among those handled by this input.
     */ enableEventType(eventType, enabled) {
        if (eventType === EVENT_TYPE) this.options.enable = enabled;
    }
}
exports.default = WheelInput;

},{"./input":"7NgHj","../constants":"I9SHq","../utils/globals":"gxzIt","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7NgHj":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
class Input {
    constructor(element, callback, options){
        this.element = element;
        this.callback = callback;
        this.options = {
            enable: true,
            ...options
        };
    }
}
exports.default = Input;

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"I9SHq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "RECOGNIZERS", ()=>RECOGNIZERS);
parcelHelpers.export(exports, "RECOGNIZER_COMPATIBLE_MAP", ()=>RECOGNIZER_COMPATIBLE_MAP);
parcelHelpers.export(exports, "RECOGNIZER_FALLBACK_MAP", ()=>RECOGNIZER_FALLBACK_MAP);
parcelHelpers.export(exports, "BASIC_EVENT_ALIASES", ()=>BASIC_EVENT_ALIASES);
parcelHelpers.export(exports, "INPUT_EVENT_TYPES", ()=>INPUT_EVENT_TYPES);
parcelHelpers.export(exports, "EVENT_RECOGNIZER_MAP", ()=>EVENT_RECOGNIZER_MAP);
parcelHelpers.export(exports, "GESTURE_EVENT_ALIASES", ()=>GESTURE_EVENT_ALIASES);
var _hammer = require("./utils/hammer");
var _hammerDefault = parcelHelpers.interopDefault(_hammer);
const RECOGNIZERS = (0, _hammerDefault.default) ? [
    [
        (0, _hammerDefault.default).Pan,
        {
            event: "tripan",
            pointers: 3,
            threshold: 0,
            enable: false
        }
    ],
    [
        (0, _hammerDefault.default).Rotate,
        {
            enable: false
        }
    ],
    [
        (0, _hammerDefault.default).Pinch,
        {
            enable: false
        }
    ],
    [
        (0, _hammerDefault.default).Swipe,
        {
            enable: false
        }
    ],
    [
        (0, _hammerDefault.default).Pan,
        {
            threshold: 0,
            enable: false
        }
    ],
    [
        (0, _hammerDefault.default).Press,
        {
            enable: false
        }
    ],
    [
        (0, _hammerDefault.default).Tap,
        {
            event: "doubletap",
            taps: 2,
            enable: false
        }
    ],
    // TODO - rename to 'tap' and 'singletap' in the next major release
    [
        (0, _hammerDefault.default).Tap,
        {
            event: "anytap",
            enable: false
        }
    ],
    [
        (0, _hammerDefault.default).Tap,
        {
            enable: false
        }
    ]
] : null;
const RECOGNIZER_COMPATIBLE_MAP = {
    tripan: [
        "rotate",
        "pinch",
        "pan"
    ],
    rotate: [
        "pinch"
    ],
    pinch: [
        "pan"
    ],
    pan: [
        "press",
        "doubletap",
        "anytap",
        "tap"
    ],
    doubletap: [
        "anytap"
    ],
    anytap: [
        "tap"
    ]
};
const RECOGNIZER_FALLBACK_MAP = {
    doubletap: [
        "tap"
    ]
};
const BASIC_EVENT_ALIASES = {
    pointerdown: "pointerdown",
    pointermove: "pointermove",
    pointerup: "pointerup",
    touchstart: "pointerdown",
    touchmove: "pointermove",
    touchend: "pointerup",
    mousedown: "pointerdown",
    mousemove: "pointermove",
    mouseup: "pointerup"
};
const INPUT_EVENT_TYPES = {
    KEY_EVENTS: [
        "keydown",
        "keyup"
    ],
    MOUSE_EVENTS: [
        "mousedown",
        "mousemove",
        "mouseup",
        "mouseover",
        "mouseout",
        "mouseleave"
    ],
    WHEEL_EVENTS: [
        // Chrome, Safari
        "wheel",
        // IE
        "mousewheel"
    ]
};
const EVENT_RECOGNIZER_MAP = {
    tap: "tap",
    anytap: "anytap",
    doubletap: "doubletap",
    press: "press",
    pinch: "pinch",
    pinchin: "pinch",
    pinchout: "pinch",
    pinchstart: "pinch",
    pinchmove: "pinch",
    pinchend: "pinch",
    pinchcancel: "pinch",
    rotate: "rotate",
    rotatestart: "rotate",
    rotatemove: "rotate",
    rotateend: "rotate",
    rotatecancel: "rotate",
    tripan: "tripan",
    tripanstart: "tripan",
    tripanmove: "tripan",
    tripanup: "tripan",
    tripandown: "tripan",
    tripanleft: "tripan",
    tripanright: "tripan",
    tripanend: "tripan",
    tripancancel: "tripan",
    pan: "pan",
    panstart: "pan",
    panmove: "pan",
    panup: "pan",
    pandown: "pan",
    panleft: "pan",
    panright: "pan",
    panend: "pan",
    pancancel: "pan",
    swipe: "swipe",
    swipeleft: "swipe",
    swiperight: "swipe",
    swipeup: "swipe",
    swipedown: "swipe"
};
const GESTURE_EVENT_ALIASES = {
    click: "tap",
    anyclick: "anytap",
    dblclick: "doubletap",
    mousedown: "pointerdown",
    mousemove: "pointermove",
    mouseup: "pointerup",
    mouseover: "pointerover",
    mouseout: "pointerout",
    mouseleave: "pointerleave"
};

},{"./utils/hammer":"bkxVq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gxzIt":[function(require,module,exports) {
// Purpose: include this in your module to avoids adding dependencies on
// micro modules like 'global'
/* global window, global, document, navigator */ var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "userAgent", ()=>userAgent);
parcelHelpers.export(exports, "window", ()=>window_);
parcelHelpers.export(exports, "global", ()=>global_);
parcelHelpers.export(exports, "document", ()=>document_);
parcelHelpers.export(exports, "passiveSupported", ()=>passiveSupported);
var global = arguments[3];
const userAgent = typeof navigator !== "undefined" && navigator.userAgent ? navigator.userAgent.toLowerCase() : "";
const window_ = typeof window !== "undefined" ? window : global;
const global_ = typeof global !== "undefined" ? global : window;
const document_ = typeof document !== "undefined" ? document : {};
/*
 * Detect whether passive option is supported by the current browser.
 * https://developer.mozilla.org/en-US/docs/Web/API/EventTarget/addEventListener
   #Safely_detecting_option_support
 */ let passiveSupported = false;
/* eslint-disable accessor-pairs, no-empty */ try {
    const options = {
        // This function will be called when the browser
        // attempts to access the passive property.
        get passive () {
            passiveSupported = true;
            return true;
        }
    };
    window_.addEventListener("test", null, options);
    window_.removeEventListener("test", null);
} catch (err) {
    passiveSupported = false;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"aur3b":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _input = require("./input");
var _inputDefault = parcelHelpers.interopDefault(_input);
var _constants = require("../constants");
const { MOUSE_EVENTS  } = (0, _constants.INPUT_EVENT_TYPES);
const MOVE_EVENT_TYPE = "pointermove";
const OVER_EVENT_TYPE = "pointerover";
const OUT_EVENT_TYPE = "pointerout";
const ENTER_EVENT_TYPE = "pointerenter";
const LEAVE_EVENT_TYPE = "pointerleave";
class MoveInput extends (0, _inputDefault.default) {
    constructor(element, callback, options){
        super(element, callback, options);
        this.handleEvent = (event)=>{
            this.handleOverEvent(event);
            this.handleOutEvent(event);
            this.handleEnterEvent(event);
            this.handleLeaveEvent(event);
            this.handleMoveEvent(event);
        };
        this.pressed = false;
        const { enable  } = this.options;
        this.enableMoveEvent = enable;
        this.enableLeaveEvent = enable;
        this.enableEnterEvent = enable;
        this.enableOutEvent = enable;
        this.enableOverEvent = enable;
        this.events = (this.options.events || []).concat(MOUSE_EVENTS);
        this.events.forEach((event)=>element.addEventListener(event, this.handleEvent));
    }
    destroy() {
        this.events.forEach((event)=>this.element.removeEventListener(event, this.handleEvent));
    }
    /**
     * Enable this input (begin processing events)
     * if the specified event type is among those handled by this input.
     */ enableEventType(eventType, enabled) {
        if (eventType === MOVE_EVENT_TYPE) this.enableMoveEvent = enabled;
        if (eventType === OVER_EVENT_TYPE) this.enableOverEvent = enabled;
        if (eventType === OUT_EVENT_TYPE) this.enableOutEvent = enabled;
        if (eventType === ENTER_EVENT_TYPE) this.enableEnterEvent = enabled;
        if (eventType === LEAVE_EVENT_TYPE) this.enableLeaveEvent = enabled;
    }
    handleOverEvent(event) {
        if (this.enableOverEvent) {
            if (event.type === "mouseover") this._emit(OVER_EVENT_TYPE, event);
        }
    }
    handleOutEvent(event) {
        if (this.enableOutEvent) {
            if (event.type === "mouseout") this._emit(OUT_EVENT_TYPE, event);
        }
    }
    handleEnterEvent(event) {
        if (this.enableEnterEvent) {
            if (event.type === "mouseenter") this._emit(ENTER_EVENT_TYPE, event);
        }
    }
    handleLeaveEvent(event) {
        if (this.enableLeaveEvent) {
            if (event.type === "mouseleave") this._emit(LEAVE_EVENT_TYPE, event);
        }
    }
    handleMoveEvent(event) {
        if (this.enableMoveEvent) switch(event.type){
            case "mousedown":
                if (event.button >= 0) // Button is down
                this.pressed = true;
                break;
            case "mousemove":
                // Move events use `which` to track the button being pressed
                if (event.which === 0) // Button is not down
                this.pressed = false;
                if (!this.pressed) // Drag events are emitted by hammer already
                // we just need to emit the move event on hover
                this._emit(MOVE_EVENT_TYPE, event);
                break;
            case "mouseup":
                this.pressed = false;
                break;
            default:
        }
    }
    _emit(type, event) {
        this.callback({
            type,
            center: {
                x: event.clientX,
                y: event.clientY
            },
            srcEvent: event,
            pointerType: "mouse",
            target: event.target
        });
    }
}
exports.default = MoveInput;

},{"./input":"7NgHj","../constants":"I9SHq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3xNpI":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _input = require("./input");
var _inputDefault = parcelHelpers.interopDefault(_input);
var _constants = require("../constants");
const { KEY_EVENTS  } = (0, _constants.INPUT_EVENT_TYPES);
const DOWN_EVENT_TYPE = "keydown";
const UP_EVENT_TYPE = "keyup";
class KeyInput extends (0, _inputDefault.default) {
    constructor(element, callback, options){
        super(element, callback, options);
        this.handleEvent = (event)=>{
            // Ignore if focused on text input
            const targetElement = event.target || event.srcElement;
            if (targetElement.tagName === "INPUT" && targetElement.type === "text" || targetElement.tagName === "TEXTAREA") return;
            if (this.enableDownEvent && event.type === "keydown") this.callback({
                type: DOWN_EVENT_TYPE,
                srcEvent: event,
                key: event.key,
                target: event.target
            });
            if (this.enableUpEvent && event.type === "keyup") this.callback({
                type: UP_EVENT_TYPE,
                srcEvent: event,
                key: event.key,
                target: event.target
            });
        };
        this.enableDownEvent = this.options.enable;
        this.enableUpEvent = this.options.enable;
        this.events = (this.options.events || []).concat(KEY_EVENTS);
        element.tabIndex = this.options.tabIndex || 0;
        element.style.outline = "none";
        this.events.forEach((event)=>element.addEventListener(event, this.handleEvent));
    }
    destroy() {
        this.events.forEach((event)=>this.element.removeEventListener(event, this.handleEvent));
    }
    /**
     * Enable this input (begin processing events)
     * if the specified event type is among those handled by this input.
     */ enableEventType(eventType, enabled) {
        if (eventType === DOWN_EVENT_TYPE) this.enableDownEvent = enabled;
        if (eventType === UP_EVENT_TYPE) this.enableUpEvent = enabled;
    }
}
exports.default = KeyInput;

},{"./input":"7NgHj","../constants":"I9SHq","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jijAn":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _input = require("./input");
var _inputDefault = parcelHelpers.interopDefault(_input);
const EVENT_TYPE = "contextmenu";
class ContextmenuInput extends (0, _inputDefault.default) {
    constructor(element, callback, options){
        super(element, callback, options);
        this.handleEvent = (event)=>{
            if (!this.options.enable) return;
            this.callback({
                type: EVENT_TYPE,
                center: {
                    x: event.clientX,
                    y: event.clientY
                },
                srcEvent: event,
                pointerType: "mouse",
                target: event.target
            });
        };
        element.addEventListener("contextmenu", this.handleEvent);
    }
    destroy() {
        this.element.removeEventListener("contextmenu", this.handleEvent);
    }
    /**
     * Enable this input (begin processing events)
     * if the specified event type is among those handled by this input.
     */ enableEventType(eventType, enabled) {
        if (eventType === EVENT_TYPE) this.options.enable = enabled;
    }
}
exports.default = ContextmenuInput;

},{"./input":"7NgHj","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gnokD":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _eventUtils = require("./event-utils");
const DEFAULT_OPTIONS = {
    srcElement: "root",
    priority: 0
};
class EventRegistrar {
    constructor(eventManager){
        /**
         * Handles hammerjs event
         */ this.handleEvent = (event)=>{
            if (this.isEmpty()) return;
            const mjolnirEvent = this._normalizeEvent(event);
            let target = event.srcEvent.target;
            while(target && target !== mjolnirEvent.rootElement){
                this._emit(mjolnirEvent, target);
                if (mjolnirEvent.handled) return;
                target = target.parentNode;
            }
            this._emit(mjolnirEvent, "root");
        };
        this.eventManager = eventManager;
        this.handlers = [];
        // Element -> handler map
        this.handlersByElement = new Map();
        this._active = false;
    }
    // Returns true if there are no non-passive handlers
    isEmpty() {
        return !this._active;
    }
    add(type, handler, options, once = false, passive = false) {
        const { handlers , handlersByElement  } = this;
        let opts = DEFAULT_OPTIONS;
        if (typeof options === "string" || options && options.addEventListener) // is DOM element, backward compatibility
        // @ts-ignore
        opts = {
            ...DEFAULT_OPTIONS,
            srcElement: options
        };
        else if (options) opts = {
            ...DEFAULT_OPTIONS,
            ...options
        };
        let entries = handlersByElement.get(opts.srcElement);
        if (!entries) {
            entries = [];
            handlersByElement.set(opts.srcElement, entries);
        }
        const entry = {
            type,
            handler,
            srcElement: opts.srcElement,
            priority: opts.priority
        };
        if (once) entry.once = true;
        if (passive) entry.passive = true;
        handlers.push(entry);
        this._active = this._active || !entry.passive;
        // Sort handlers by descending priority
        // Handlers with the same priority are excuted in the order of registration
        let insertPosition = entries.length - 1;
        while(insertPosition >= 0){
            if (entries[insertPosition].priority >= entry.priority) break;
            insertPosition--;
        }
        entries.splice(insertPosition + 1, 0, entry);
    }
    remove(type, handler) {
        const { handlers , handlersByElement  } = this;
        for(let i = handlers.length - 1; i >= 0; i--){
            const entry = handlers[i];
            if (entry.type === type && entry.handler === handler) {
                handlers.splice(i, 1);
                const entries = handlersByElement.get(entry.srcElement);
                entries.splice(entries.indexOf(entry), 1);
                if (entries.length === 0) handlersByElement.delete(entry.srcElement);
            }
        }
        this._active = handlers.some((entry)=>!entry.passive);
    }
    /**
     * Invoke handlers on a particular element
     */ _emit(event, srcElement) {
        const entries = this.handlersByElement.get(srcElement);
        if (entries) {
            let immediatePropagationStopped = false;
            // Prevents the current event from bubbling up
            const stopPropagation = ()=>{
                event.handled = true;
            };
            // Prevent any remaining listeners from being called
            const stopImmediatePropagation = ()=>{
                event.handled = true;
                immediatePropagationStopped = true;
            };
            const entriesToRemove = [];
            for(let i = 0; i < entries.length; i++){
                const { type , handler , once  } = entries[i];
                handler({
                    ...event,
                    // @ts-ignore
                    type,
                    stopPropagation,
                    stopImmediatePropagation
                });
                if (once) entriesToRemove.push(entries[i]);
                if (immediatePropagationStopped) break;
            }
            for(let i1 = 0; i1 < entriesToRemove.length; i1++){
                const { type: type1 , handler: handler1  } = entriesToRemove[i1];
                this.remove(type1, handler1);
            }
        }
    }
    /**
     * Normalizes hammerjs and custom events to have predictable fields.
     */ _normalizeEvent(event) {
        const rootElement = this.eventManager.getElement();
        return {
            ...event,
            ...(0, _eventUtils.whichButtons)(event),
            ...(0, _eventUtils.getOffsetPosition)(event, rootElement),
            preventDefault: ()=>{
                event.srcEvent.preventDefault();
            },
            stopImmediatePropagation: null,
            stopPropagation: null,
            handled: false,
            rootElement
        };
    }
}
exports.default = EventRegistrar;

},{"./event-utils":"9WSjU","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9WSjU":[function(require,module,exports) {
/* Constants */ var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
/**
 * Extract the involved mouse button
 */ parcelHelpers.export(exports, "whichButtons", ()=>whichButtons);
/**
 * Calculate event position relative to the root element
 */ parcelHelpers.export(exports, "getOffsetPosition", ()=>getOffsetPosition);
const DOWN_EVENT = 1;
const MOVE_EVENT = 2;
const UP_EVENT = 4;
const MOUSE_EVENTS = {
    pointerdown: DOWN_EVENT,
    pointermove: MOVE_EVENT,
    pointerup: UP_EVENT,
    mousedown: DOWN_EVENT,
    mousemove: MOVE_EVENT,
    mouseup: UP_EVENT
};
// MouseEvent.which https://developer.mozilla.org/en-US/docs/Web/API/MouseEvent/which
const MOUSE_EVENT_WHICH_LEFT = 1;
const MOUSE_EVENT_WHICH_MIDDLE = 2;
const MOUSE_EVENT_WHICH_RIGHT = 3;
// MouseEvent.button https://developer.mozilla.org/en-US/docs/Web/API/MouseEvent/button
const MOUSE_EVENT_BUTTON_LEFT = 0;
const MOUSE_EVENT_BUTTON_MIDDLE = 1;
const MOUSE_EVENT_BUTTON_RIGHT = 2;
// MouseEvent.buttons https://developer.mozilla.org/en-US/docs/Web/API/MouseEvent/buttons
const MOUSE_EVENT_BUTTONS_LEFT_MASK = 1;
const MOUSE_EVENT_BUTTONS_RIGHT_MASK = 2;
const MOUSE_EVENT_BUTTONS_MIDDLE_MASK = 4;
function whichButtons(event) {
    const eventType = MOUSE_EVENTS[event.srcEvent.type];
    if (!eventType) // Not a mouse evet
    return null;
    const { buttons , button , which  } = event.srcEvent;
    let leftButton = false;
    let middleButton = false;
    let rightButton = false;
    if (// button is up, need to find out which one was pressed before
    eventType === UP_EVENT || // moving but does not support `buttons` API
    eventType === MOVE_EVENT && !Number.isFinite(buttons)) {
        leftButton = which === MOUSE_EVENT_WHICH_LEFT;
        middleButton = which === MOUSE_EVENT_WHICH_MIDDLE;
        rightButton = which === MOUSE_EVENT_WHICH_RIGHT;
    } else if (eventType === MOVE_EVENT) {
        leftButton = Boolean(buttons & MOUSE_EVENT_BUTTONS_LEFT_MASK);
        middleButton = Boolean(buttons & MOUSE_EVENT_BUTTONS_MIDDLE_MASK);
        rightButton = Boolean(buttons & MOUSE_EVENT_BUTTONS_RIGHT_MASK);
    } else if (eventType === DOWN_EVENT) {
        leftButton = button === MOUSE_EVENT_BUTTON_LEFT;
        middleButton = button === MOUSE_EVENT_BUTTON_MIDDLE;
        rightButton = button === MOUSE_EVENT_BUTTON_RIGHT;
    }
    return {
        leftButton,
        middleButton,
        rightButton
    };
}
function getOffsetPosition(event, rootElement) {
    const center = event.center;
    // `center` is a hammer.js event property
    if (!center) // Not a gestural event
    return null;
    const rect = rootElement.getBoundingClientRect();
    // Fix scale for map affected by a CSS transform.
    // See https://stackoverflow.com/a/26893663/3528533
    const scaleX = rect.width / rootElement.offsetWidth || 1;
    const scaleY = rect.height / rootElement.offsetHeight || 1;
    // Calculate center relative to the root element
    const offsetCenter = {
        x: (center.x - rect.left - rootElement.clientLeft) / scaleX,
        y: (center.y - rect.top - rootElement.clientTop) / scaleY
    };
    return {
        center,
        offsetCenter
    };
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5oF21":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _attribute = require("./attribute");
var _attributeDefault = parcelHelpers.interopDefault(_attribute);
var _log = require("../../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _debug = require("../../debug");
var _debugDefault = parcelHelpers.interopDefault(_debug);
var _attributeTransitionManager = require("./attribute-transition-manager");
var _attributeTransitionManagerDefault = parcelHelpers.interopDefault(_attributeTransitionManager);
const TRACE_INVALIDATE = "attributeManager.invalidate";
const TRACE_UPDATE_START = "attributeManager.updateStart";
const TRACE_UPDATE_END = "attributeManager.updateEnd";
const TRACE_ATTRIBUTE_UPDATE_START = "attribute.updateStart";
const TRACE_ATTRIBUTE_ALLOCATE = "attribute.allocate";
const TRACE_ATTRIBUTE_UPDATE_END = "attribute.updateEnd";
class AttributeManager {
    constructor(gl, { id ="attribute-manager" , stats , timeline  } = {}){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "gl", void 0);
        (0, _definePropertyDefault.default)(this, "attributes", void 0);
        (0, _definePropertyDefault.default)(this, "updateTriggers", void 0);
        (0, _definePropertyDefault.default)(this, "needsRedraw", void 0);
        (0, _definePropertyDefault.default)(this, "userData", void 0);
        (0, _definePropertyDefault.default)(this, "stats", void 0);
        (0, _definePropertyDefault.default)(this, "attributeTransitionManager", void 0);
        this.id = id;
        this.gl = gl;
        this.attributes = {};
        this.updateTriggers = {};
        this.needsRedraw = true;
        this.userData = {};
        this.stats = stats;
        this.attributeTransitionManager = new (0, _attributeTransitionManagerDefault.default)(gl, {
            id: "".concat(id, "-transitions"),
            timeline
        });
        Object.seal(this);
    }
    finalize() {
        for(const attributeName in this.attributes)this.attributes[attributeName].delete();
        this.attributeTransitionManager.finalize();
    }
    getNeedsRedraw(opts = {
        clearRedrawFlags: false
    }) {
        const redraw = this.needsRedraw;
        this.needsRedraw = this.needsRedraw && !opts.clearRedrawFlags;
        return redraw && this.id;
    }
    setNeedsRedraw() {
        this.needsRedraw = true;
    }
    add(attributes) {
        this._add(attributes);
    }
    addInstanced(attributes) {
        this._add(attributes, {
            instanced: 1
        });
    }
    remove(attributeNameArray) {
        for (const name of attributeNameArray)if (this.attributes[name] !== undefined) {
            this.attributes[name].delete();
            delete this.attributes[name];
        }
    }
    invalidate(triggerName, dataRange) {
        const invalidatedAttributes = this._invalidateTrigger(triggerName, dataRange);
        (0, _debugDefault.default)(TRACE_INVALIDATE, this, triggerName, invalidatedAttributes);
    }
    invalidateAll(dataRange) {
        for(const attributeName in this.attributes)this.attributes[attributeName].setNeedsUpdate(attributeName, dataRange);
        (0, _debugDefault.default)(TRACE_INVALIDATE, this, "all");
    }
    update({ data , numInstances , startIndices =null , transitions , props ={} , buffers ={} , context ={}  }) {
        let updated = false;
        (0, _debugDefault.default)(TRACE_UPDATE_START, this);
        if (this.stats) this.stats.get("Update Attributes").timeStart();
        for(const attributeName in this.attributes){
            const attribute = this.attributes[attributeName];
            const accessorName = attribute.settings.accessor;
            attribute.startIndices = startIndices;
            attribute.numInstances = numInstances;
            if (props[attributeName]) (0, _logDefault.default).removed("props.".concat(attributeName), "data.attributes.".concat(attributeName))();
            if (attribute.setExternalBuffer(buffers[attributeName])) ;
            else if (attribute.setBinaryValue(typeof accessorName === "string" ? buffers[accessorName] : undefined, data.startIndices)) ;
            else if (typeof accessorName === "string" && !buffers[accessorName] && attribute.setConstantValue(props[accessorName])) ;
            else if (attribute.needsUpdate()) {
                updated = true;
                this._updateAttribute({
                    attribute,
                    numInstances,
                    data,
                    props,
                    context
                });
            }
            this.needsRedraw = this.needsRedraw || attribute.needsRedraw();
        }
        if (updated) (0, _debugDefault.default)(TRACE_UPDATE_END, this, numInstances);
        if (this.stats) this.stats.get("Update Attributes").timeEnd();
        this.attributeTransitionManager.update({
            attributes: this.attributes,
            numInstances,
            transitions
        });
    }
    updateTransition() {
        const { attributeTransitionManager  } = this;
        const transitionUpdated = attributeTransitionManager.run();
        this.needsRedraw = this.needsRedraw || transitionUpdated;
        return transitionUpdated;
    }
    getAttributes() {
        return this.attributes;
    }
    getChangedAttributes(opts = {
        clearChangedFlags: false
    }) {
        const { attributes , attributeTransitionManager  } = this;
        const changedAttributes = {
            ...attributeTransitionManager.getAttributes()
        };
        for(const attributeName in attributes){
            const attribute = attributes[attributeName];
            if (attribute.needsRedraw(opts) && !attributeTransitionManager.hasAttribute(attributeName)) changedAttributes[attributeName] = attribute;
        }
        return changedAttributes;
    }
    getShaderAttributes(attributes, excludeAttributes = {}) {
        if (!attributes) attributes = this.getAttributes();
        const shaderAttributes = {};
        for(const attributeName in attributes)if (!excludeAttributes[attributeName]) Object.assign(shaderAttributes, attributes[attributeName].getShaderAttributes());
        return shaderAttributes;
    }
    _add(attributes, extraProps = {}) {
        for(const attributeName in attributes){
            const attribute = attributes[attributeName];
            this.attributes[attributeName] = this._createAttribute(attributeName, attribute, extraProps);
        }
        this._mapUpdateTriggersToAttributes();
    }
    _createAttribute(name, attribute, extraProps) {
        const props = {
            ...attribute,
            id: name,
            size: attribute.isIndexed && 1 || attribute.size || 1,
            divisor: extraProps.instanced ? 1 : attribute.divisor || 0
        };
        return new (0, _attributeDefault.default)(this.gl, props);
    }
    _mapUpdateTriggersToAttributes() {
        const triggers = {};
        for(const attributeName in this.attributes){
            const attribute = this.attributes[attributeName];
            attribute.getUpdateTriggers().forEach((triggerName)=>{
                if (!triggers[triggerName]) triggers[triggerName] = [];
                triggers[triggerName].push(attributeName);
            });
        }
        this.updateTriggers = triggers;
    }
    _invalidateTrigger(triggerName, dataRange) {
        const { attributes , updateTriggers  } = this;
        const invalidatedAttributes = updateTriggers[triggerName];
        if (invalidatedAttributes) invalidatedAttributes.forEach((name)=>{
            const attribute = attributes[name];
            if (attribute) attribute.setNeedsUpdate(attribute.id, dataRange);
        });
        return invalidatedAttributes;
    }
    _updateAttribute(opts) {
        const { attribute , numInstances  } = opts;
        (0, _debugDefault.default)(TRACE_ATTRIBUTE_UPDATE_START, attribute);
        if (attribute.constant) {
            attribute.setConstantValue(attribute.value);
            return;
        }
        if (attribute.allocate(numInstances)) (0, _debugDefault.default)(TRACE_ATTRIBUTE_ALLOCATE, attribute, numInstances);
        const updated = attribute.updateBuffer(opts);
        if (updated) {
            this.needsRedraw = true;
            (0, _debugDefault.default)(TRACE_ATTRIBUTE_UPDATE_END, attribute, numInstances);
        }
    }
}
exports.default = AttributeManager;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./attribute":"ldooi","../../utils/log":"iINk7","../../debug":"e6y6V","./attribute-transition-manager":"uEGIh","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"ldooi":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _dataColumn = require("./data-column");
var _dataColumnDefault = parcelHelpers.interopDefault(_dataColumn);
var _assert = require("../../utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _iterableUtils = require("../../utils/iterable-utils");
var _flatten = require("../../utils/flatten");
var _range = require("../../utils/range");
var _attributeTransitionUtils = require("./attribute-transition-utils");
class Attribute extends (0, _dataColumnDefault.default) {
    constructor(gl, opts){
        super(gl, opts, {
            startIndices: null,
            lastExternalBuffer: null,
            binaryValue: null,
            binaryAccessor: null,
            needsUpdate: true,
            needsRedraw: false,
            updateRanges: _range.FULL
        });
        (0, _definePropertyDefault.default)(this, "constant", false);
        this.settings.update = opts.update || (opts.accessor ? this._autoUpdater : undefined);
        Object.seal(this.settings);
        Object.seal(this.state);
        this._validateAttributeUpdaters();
    }
    get startIndices() {
        return this.state.startIndices;
    }
    set startIndices(layout) {
        this.state.startIndices = layout;
    }
    needsUpdate() {
        return this.state.needsUpdate;
    }
    needsRedraw({ clearChangedFlags =false  } = {}) {
        const needsRedraw = this.state.needsRedraw;
        this.state.needsRedraw = needsRedraw && !clearChangedFlags;
        return needsRedraw;
    }
    getUpdateTriggers() {
        const { accessor  } = this.settings;
        return [
            this.id
        ].concat(typeof accessor !== "function" && accessor || []);
    }
    supportsTransition() {
        return Boolean(this.settings.transition);
    }
    getTransitionSetting(opts) {
        if (!opts || !this.supportsTransition()) return null;
        const { accessor  } = this.settings;
        const layerSettings = this.settings.transition;
        const userSettings = Array.isArray(accessor) ? opts[accessor.find((a)=>opts[a])] : opts[accessor];
        return (0, _attributeTransitionUtils.normalizeTransitionSettings)(userSettings, layerSettings);
    }
    setNeedsUpdate(reason = this.id, dataRange) {
        this.state.needsUpdate = this.state.needsUpdate || reason;
        this.setNeedsRedraw(reason);
        if (dataRange) {
            const { startRow =0 , endRow =Infinity  } = dataRange;
            this.state.updateRanges = _range.add(this.state.updateRanges, [
                startRow,
                endRow
            ]);
        } else this.state.updateRanges = _range.FULL;
    }
    clearNeedsUpdate() {
        this.state.needsUpdate = false;
        this.state.updateRanges = _range.EMPTY;
    }
    setNeedsRedraw(reason = this.id) {
        this.state.needsRedraw = this.state.needsRedraw || reason;
    }
    allocate(numInstances) {
        const { state , settings  } = this;
        if (settings.noAlloc) return false;
        if (settings.update) {
            super.allocate(numInstances, state.updateRanges !== _range.FULL);
            return true;
        }
        return false;
    }
    updateBuffer({ numInstances , data , props , context  }) {
        if (!this.needsUpdate()) return false;
        const { state: { updateRanges  } , settings: { update , noAlloc  }  } = this;
        let updated = true;
        if (update) {
            for (const [startRow, endRow] of updateRanges)update.call(context, this, {
                data,
                startRow,
                endRow,
                props,
                numInstances
            });
            if (!this.value) ;
            else if (this.constant || this.buffer.byteLength < this.value.byteLength + this.byteOffset) {
                this.setData({
                    value: this.value,
                    constant: this.constant
                });
                this.constant = false;
            } else for (const [startRow1, endRow1] of updateRanges){
                const startOffset = Number.isFinite(startRow1) ? this.getVertexOffset(startRow1) : 0;
                const endOffset = Number.isFinite(endRow1) ? this.getVertexOffset(endRow1) : noAlloc || !Number.isFinite(numInstances) ? this.value.length : numInstances * this.size;
                super.updateSubBuffer({
                    startOffset,
                    endOffset
                });
            }
            this._checkAttributeArray();
        } else updated = false;
        this.clearNeedsUpdate();
        this.setNeedsRedraw();
        return updated;
    }
    setConstantValue(value) {
        if (value === undefined || typeof value === "function") return false;
        const hasChanged = this.setData({
            constant: true,
            value
        });
        if (hasChanged) this.setNeedsRedraw();
        this.clearNeedsUpdate();
        return true;
    }
    setExternalBuffer(buffer) {
        const { state  } = this;
        if (!buffer) {
            state.lastExternalBuffer = null;
            return false;
        }
        this.clearNeedsUpdate();
        if (state.lastExternalBuffer === buffer) return true;
        state.lastExternalBuffer = buffer;
        this.setNeedsRedraw();
        this.setData(buffer);
        return true;
    }
    setBinaryValue(buffer, startIndices = null) {
        const { state , settings  } = this;
        if (!buffer) {
            state.binaryValue = null;
            state.binaryAccessor = null;
            return false;
        }
        if (settings.noAlloc) return false;
        if (state.binaryValue === buffer) {
            this.clearNeedsUpdate();
            return true;
        }
        state.binaryValue = buffer;
        this.setNeedsRedraw();
        const needsUpdate = settings.transform || startIndices !== this.startIndices;
        if (needsUpdate) {
            if (ArrayBuffer.isView(buffer)) buffer = {
                value: buffer
            };
            const binaryValue = buffer;
            (0, _assertDefault.default)(ArrayBuffer.isView(binaryValue.value), "invalid ".concat(settings.accessor));
            const needsNormalize = Boolean(binaryValue.size) && binaryValue.size !== this.size;
            state.binaryAccessor = (0, _iterableUtils.getAccessorFromBuffer)(binaryValue.value, {
                size: binaryValue.size || this.size,
                stride: binaryValue.stride,
                offset: binaryValue.offset,
                startIndices: startIndices,
                nested: needsNormalize
            });
            return false;
        }
        this.clearNeedsUpdate();
        this.setData(buffer);
        return true;
    }
    getVertexOffset(row) {
        const { startIndices  } = this;
        const vertexIndex = startIndices ? startIndices[row] : row;
        return vertexIndex * this.size;
    }
    getShaderAttributes() {
        const shaderAttributeDefs = this.settings.shaderAttributes || {
            [this.id]: null
        };
        const shaderAttributes = {};
        for(const shaderAttributeName in shaderAttributeDefs)Object.assign(shaderAttributes, super.getShaderAttributes(shaderAttributeName, shaderAttributeDefs[shaderAttributeName]));
        return shaderAttributes;
    }
    _autoUpdater(attribute, { data , startRow , endRow , props , numInstances  }) {
        if (attribute.constant) return;
        const { settings , state , value , size , startIndices  } = attribute;
        const { accessor , transform  } = settings;
        const accessorFunc = state.binaryAccessor || (typeof accessor === "function" ? accessor : props[accessor]);
        (0, _assertDefault.default)(typeof accessorFunc === "function", 'accessor "'.concat(accessor, '" is not a function'));
        let i = attribute.getVertexOffset(startRow);
        const { iterable , objectInfo  } = (0, _iterableUtils.createIterable)(data, startRow, endRow);
        for (const object of iterable){
            objectInfo.index++;
            let objectValue = accessorFunc(object, objectInfo);
            if (transform) objectValue = transform.call(this, objectValue);
            if (startIndices) {
                const numVertices = (objectInfo.index < startIndices.length - 1 ? startIndices[objectInfo.index + 1] : numInstances) - startIndices[objectInfo.index];
                if (objectValue && Array.isArray(objectValue[0])) {
                    let startIndex = i;
                    for (const item of objectValue){
                        attribute._normalizeValue(item, value, startIndex);
                        startIndex += size;
                    }
                } else if (objectValue && objectValue.length > size) value.set(objectValue, i);
                else {
                    attribute._normalizeValue(objectValue, objectInfo.target, 0);
                    (0, _flatten.fillArray)({
                        target: value,
                        source: objectInfo.target,
                        start: i,
                        count: numVertices
                    });
                }
                i += numVertices * size;
            } else {
                attribute._normalizeValue(objectValue, value, i);
                i += size;
            }
        }
    }
    _validateAttributeUpdaters() {
        const { settings  } = this;
        const hasUpdater = settings.noAlloc || typeof settings.update === "function";
        if (!hasUpdater) throw new Error("Attribute ".concat(this.id, " missing update or accessor"));
    }
    _checkAttributeArray() {
        const { value  } = this;
        const limit = Math.min(4, this.size);
        if (value && value.length >= limit) {
            let valid = true;
            switch(limit){
                case 4:
                    valid = valid && Number.isFinite(value[3]);
                case 3:
                    valid = valid && Number.isFinite(value[2]);
                case 2:
                    valid = valid && Number.isFinite(value[1]);
                case 1:
                    valid = valid && Number.isFinite(value[0]);
                    break;
                default:
                    valid = false;
            }
            if (!valid) throw new Error("Illegal attribute generated for ".concat(this.id));
        }
    }
}
exports.default = Attribute;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./data-column":"iRksn","../../utils/assert":"aysGh","../../utils/iterable-utils":"6frHT","../../utils/flatten":"bFfhb","../../utils/range":"cSlI2","./attribute-transition-utils":"1Dphv","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iRksn":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _shaderAttribute = require("./shader-attribute");
var _shaderAttributeDefault = parcelHelpers.interopDefault(_shaderAttribute);
var _glUtils = require("./gl-utils");
var _typedArrayManager = require("../../utils/typed-array-manager");
var _typedArrayManagerDefault = parcelHelpers.interopDefault(_typedArrayManager);
var _mathUtils = require("../../utils/math-utils");
var _log = require("../../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
function getStride(accessor) {
    return accessor.stride || accessor.size * accessor.bytesPerElement;
}
function resolveShaderAttribute(baseAccessor, shaderAttributeOptions) {
    if (shaderAttributeOptions.offset) (0, _logDefault.default).removed("shaderAttribute.offset", "vertexOffset, elementOffset")();
    const stride = getStride(baseAccessor);
    const vertexOffset = shaderAttributeOptions.vertexOffset !== undefined ? shaderAttributeOptions.vertexOffset : baseAccessor.vertexOffset || 0;
    const elementOffset = shaderAttributeOptions.elementOffset || 0;
    const offset = vertexOffset * stride + elementOffset * baseAccessor.bytesPerElement + (baseAccessor.offset || 0);
    return {
        ...shaderAttributeOptions,
        offset,
        stride
    };
}
function resolveDoublePrecisionShaderAttributes(baseAccessor, shaderAttributeOptions) {
    const resolvedOptions = resolveShaderAttribute(baseAccessor, shaderAttributeOptions);
    return {
        high: resolvedOptions,
        low: {
            ...resolvedOptions,
            offset: resolvedOptions.offset + baseAccessor.size * 4
        }
    };
}
class DataColumn {
    constructor(gl, opts, state){
        (0, _definePropertyDefault.default)(this, "gl", void 0);
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "size", void 0);
        (0, _definePropertyDefault.default)(this, "settings", void 0);
        (0, _definePropertyDefault.default)(this, "value", void 0);
        (0, _definePropertyDefault.default)(this, "doublePrecision", void 0);
        (0, _definePropertyDefault.default)(this, "_buffer", void 0);
        (0, _definePropertyDefault.default)(this, "state", void 0);
        this.gl = gl;
        this.id = opts.id || "";
        this.size = opts.size || 1;
        const logicalType = opts.logicalType || opts.type;
        const doublePrecision = logicalType === 5130;
        let { defaultValue  } = opts;
        defaultValue = Number.isFinite(defaultValue) ? [
            defaultValue
        ] : defaultValue || new Array(this.size).fill(0);
        let bufferType;
        if (doublePrecision) bufferType = 5126;
        else if (!logicalType && opts.isIndexed) bufferType = gl && (0, _core.hasFeature)(gl, (0, _core.FEATURES).ELEMENT_INDEX_UINT32) ? 5125 : 5123;
        else bufferType = logicalType || 5126;
        let defaultType = (0, _glUtils.glArrayFromType)(logicalType || bufferType || 5126);
        this.doublePrecision = doublePrecision;
        if (doublePrecision && opts.fp64 === false) defaultType = Float32Array;
        this.value = null;
        this.settings = {
            ...opts,
            defaultType,
            defaultValue: defaultValue,
            logicalType,
            type: bufferType,
            size: this.size,
            bytesPerElement: defaultType.BYTES_PER_ELEMENT
        };
        this.state = {
            ...state,
            externalBuffer: null,
            bufferAccessor: this.settings,
            allocatedValue: null,
            numInstances: 0,
            bounds: null,
            constant: false
        };
        this._buffer = null;
    }
    get isConstant() {
        return this.state.constant;
    }
    get buffer() {
        if (!this._buffer) {
            const { isIndexed , type  } = this.settings;
            this._buffer = new (0, _core.Buffer)(this.gl, {
                id: this.id,
                target: isIndexed ? 34963 : 34962,
                accessor: {
                    type
                }
            });
        }
        return this._buffer;
    }
    get byteOffset() {
        const accessor = this.getAccessor();
        if (accessor.vertexOffset) return accessor.vertexOffset * getStride(accessor);
        return 0;
    }
    get numInstances() {
        return this.state.numInstances;
    }
    set numInstances(n) {
        this.state.numInstances = n;
    }
    delete() {
        if (this._buffer) {
            this._buffer.delete();
            this._buffer = null;
        }
        (0, _typedArrayManagerDefault.default).release(this.state.allocatedValue);
    }
    getShaderAttributes(id, options) {
        if (this.doublePrecision) {
            const shaderAttributes = {};
            const isBuffer64Bit = this.value instanceof Float64Array;
            const doubleShaderAttributeDefs = resolveDoublePrecisionShaderAttributes(this.getAccessor(), options || {});
            shaderAttributes[id] = new (0, _shaderAttributeDefault.default)(this, doubleShaderAttributeDefs.high);
            shaderAttributes["".concat(id, "64Low")] = isBuffer64Bit ? new (0, _shaderAttributeDefault.default)(this, doubleShaderAttributeDefs.low) : new Float32Array(this.size);
            return shaderAttributes;
        }
        if (options) {
            const shaderAttributeDef = resolveShaderAttribute(this.getAccessor(), options);
            return {
                [id]: new (0, _shaderAttributeDefault.default)(this, shaderAttributeDef)
            };
        }
        return {
            [id]: this
        };
    }
    getBuffer() {
        if (this.state.constant) return null;
        return this.state.externalBuffer || this._buffer;
    }
    getValue() {
        if (this.state.constant) return this.value;
        return [
            this.getBuffer(),
            this.getAccessor()
        ];
    }
    getAccessor() {
        return this.state.bufferAccessor;
    }
    getBounds() {
        if (this.state.bounds) return this.state.bounds;
        let result = null;
        if (this.state.constant && this.value) {
            const min = Array.from(this.value);
            result = [
                min,
                min
            ];
        } else {
            const { value , numInstances , size  } = this;
            const len = numInstances * size;
            if (value && len && value.length >= len) {
                const min1 = new Array(size).fill(Infinity);
                const max = new Array(size).fill(-Infinity);
                for(let i = 0; i < len;)for(let j = 0; j < size; j++){
                    const v = value[i++];
                    if (v < min1[j]) min1[j] = v;
                    if (v > max[j]) max[j] = v;
                }
                result = [
                    min1,
                    max
                ];
            }
        }
        this.state.bounds = result;
        return result;
    }
    setData(data) {
        const { state  } = this;
        let opts;
        if (ArrayBuffer.isView(data)) opts = {
            value: data
        };
        else if (data instanceof (0, _core.Buffer)) opts = {
            buffer: data
        };
        else opts = data;
        const accessor = {
            ...this.settings,
            ...opts
        };
        state.bufferAccessor = accessor;
        state.bounds = null;
        if (opts.constant) {
            let value = opts.value;
            value = this._normalizeValue(value, [], 0);
            if (this.settings.normalized) value = this.normalizeConstant(value);
            const hasChanged = !state.constant || !this._areValuesEqual(value, this.value);
            if (!hasChanged) return false;
            state.externalBuffer = null;
            state.constant = true;
            this.value = value;
        } else if (opts.buffer) {
            const buffer = opts.buffer;
            state.externalBuffer = buffer;
            state.constant = false;
            this.value = opts.value || null;
            const isBuffer64Bit = opts.value instanceof Float64Array;
            accessor.type = opts.type || buffer.accessor.type;
            accessor.bytesPerElement = buffer.accessor.BYTES_PER_ELEMENT * (isBuffer64Bit ? 2 : 1);
            accessor.stride = getStride(accessor);
        } else if (opts.value) {
            this._checkExternalBuffer(opts);
            let value1 = opts.value;
            state.externalBuffer = null;
            state.constant = false;
            this.value = value1;
            accessor.bytesPerElement = value1.BYTES_PER_ELEMENT;
            accessor.stride = getStride(accessor);
            const { buffer: buffer1 , byteOffset  } = this;
            if (this.doublePrecision && value1 instanceof Float64Array) value1 = (0, _mathUtils.toDoublePrecisionArray)(value1, accessor);
            const requiredBufferSize = value1.byteLength + byteOffset + accessor.stride * 2;
            if (buffer1.byteLength < requiredBufferSize) buffer1.reallocate(requiredBufferSize);
            buffer1.setAccessor(null);
            buffer1.subData({
                data: value1,
                offset: byteOffset
            });
            accessor.type = opts.type || buffer1.accessor.type;
        }
        return true;
    }
    updateSubBuffer(opts = {}) {
        this.state.bounds = null;
        const value = this.value;
        const { startOffset =0 , endOffset  } = opts;
        this.buffer.subData({
            data: this.doublePrecision && value instanceof Float64Array ? (0, _mathUtils.toDoublePrecisionArray)(value, {
                size: this.size,
                startIndex: startOffset,
                endIndex: endOffset
            }) : value.subarray(startOffset, endOffset),
            offset: startOffset * value.BYTES_PER_ELEMENT + this.byteOffset
        });
    }
    allocate(numInstances, copy = false) {
        const { state  } = this;
        const oldValue = state.allocatedValue;
        const value = (0, _typedArrayManagerDefault.default).allocate(oldValue, numInstances + 1, {
            size: this.size,
            type: this.settings.defaultType,
            copy
        });
        this.value = value;
        const { buffer , byteOffset  } = this;
        if (buffer.byteLength < value.byteLength + byteOffset) {
            buffer.reallocate(value.byteLength + byteOffset);
            if (copy && oldValue) buffer.subData({
                data: oldValue instanceof Float64Array ? (0, _mathUtils.toDoublePrecisionArray)(oldValue, this) : oldValue,
                offset: byteOffset
            });
        }
        state.allocatedValue = value;
        state.constant = false;
        state.externalBuffer = null;
        state.bufferAccessor = this.settings;
        return true;
    }
    _checkExternalBuffer(opts) {
        const { value  } = opts;
        if (!ArrayBuffer.isView(value)) throw new Error("Attribute ".concat(this.id, " value is not TypedArray"));
        const ArrayType = this.settings.defaultType;
        let illegalArrayType = false;
        if (this.doublePrecision) illegalArrayType = value.BYTES_PER_ELEMENT < 4;
        if (illegalArrayType) throw new Error("Attribute ".concat(this.id, " does not support ").concat(value.constructor.name));
        if (!(value instanceof ArrayType) && this.settings.normalized && !("normalized" in opts)) (0, _logDefault.default).warn("Attribute ".concat(this.id, " is normalized"))();
    }
    normalizeConstant(value) {
        switch(this.settings.type){
            case 5120:
                return new Float32Array(value).map((x)=>(x + 128) / 255 * 2 - 1);
            case 5122:
                return new Float32Array(value).map((x)=>(x + 32768) / 65535 * 2 - 1);
            case 5121:
                return new Float32Array(value).map((x)=>x / 255);
            case 5123:
                return new Float32Array(value).map((x)=>x / 65535);
            default:
                return value;
        }
    }
    _normalizeValue(value, out, start) {
        const { defaultValue , size  } = this.settings;
        if (Number.isFinite(value)) {
            out[start] = value;
            return out;
        }
        if (!value) {
            out[start] = defaultValue[0];
            return out;
        }
        switch(size){
            case 4:
                out[start + 3] = Number.isFinite(value[3]) ? value[3] : defaultValue[3];
            case 3:
                out[start + 2] = Number.isFinite(value[2]) ? value[2] : defaultValue[2];
            case 2:
                out[start + 1] = Number.isFinite(value[1]) ? value[1] : defaultValue[1];
            case 1:
                out[start + 0] = Number.isFinite(value[0]) ? value[0] : defaultValue[0];
                break;
            default:
                let i = size;
                while(--i >= 0)out[start + i] = Number.isFinite(value[i]) ? value[i] : defaultValue[i];
        }
        return out;
    }
    _areValuesEqual(value1, value2) {
        if (!value1 || !value2) return false;
        const { size  } = this;
        for(let i = 0; i < size; i++){
            if (value1[i] !== value2[i]) return false;
        }
        return true;
    }
}
exports.default = DataColumn;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","./shader-attribute":"h7Y0u","./gl-utils":"a9gZN","../../utils/typed-array-manager":"kyraM","../../utils/math-utils":"1KANI","../../utils/log":"iINk7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"h7Y0u":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
class ShaderAttribute {
    constructor(dataColumn, opts){
        (0, _definePropertyDefault.default)(this, "opts", void 0);
        (0, _definePropertyDefault.default)(this, "source", void 0);
        this.opts = opts;
        this.source = dataColumn;
    }
    get value() {
        return this.source.value;
    }
    getValue() {
        const buffer = this.source.getBuffer();
        const accessor = this.getAccessor();
        if (buffer) return [
            buffer,
            accessor
        ];
        const { value  } = this.source;
        const { size  } = accessor;
        let constantValue = value;
        if (value && value.length !== size) {
            constantValue = new Float32Array(size);
            const index = accessor.elementOffset || 0;
            for(let i = 0; i < size; ++i)constantValue[i] = value[index + i];
        }
        return constantValue;
    }
    getAccessor() {
        return {
            ...this.source.getAccessor(),
            ...this.opts
        };
    }
}
exports.default = ShaderAttribute;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"a9gZN":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "glArrayFromType", ()=>glArrayFromType);
function glArrayFromType(glType) {
    switch(glType){
        case 5126:
            return Float32Array;
        case 5130:
            return Float64Array;
        case 5123:
        case 33635:
        case 32819:
        case 32820:
            return Uint16Array;
        case 5125:
            return Uint32Array;
        case 5121:
            return Uint8ClampedArray;
        case 5120:
            return Int8Array;
        case 5122:
            return Int16Array;
        case 5124:
            return Int32Array;
        default:
            throw new Error("Unknown GL type");
    }
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6frHT":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "createIterable", ()=>createIterable);
parcelHelpers.export(exports, "isAsyncIterable", ()=>isAsyncIterable);
parcelHelpers.export(exports, "getAccessorFromBuffer", ()=>getAccessorFromBuffer);
const EMPTY_ARRAY = [];
const placeholderArray = [];
function createIterable(data, startRow = 0, endRow = Infinity) {
    let iterable = EMPTY_ARRAY;
    const objectInfo = {
        index: -1,
        data,
        target: []
    };
    if (!data) iterable = EMPTY_ARRAY;
    else if (typeof data[Symbol.iterator] === "function") iterable = data;
    else if (data.length > 0) {
        placeholderArray.length = data.length;
        iterable = placeholderArray;
    }
    if (startRow > 0 || Number.isFinite(endRow)) {
        iterable = (Array.isArray(iterable) ? iterable : Array.from(iterable)).slice(startRow, endRow);
        objectInfo.index = startRow - 1;
    }
    return {
        iterable,
        objectInfo
    };
}
function isAsyncIterable(data) {
    return data && data[Symbol.asyncIterator];
}
function getAccessorFromBuffer(typedArray, options) {
    const { size , stride , offset , startIndices , nested  } = options;
    const bytesPerElement = typedArray.BYTES_PER_ELEMENT;
    const elementStride = stride ? stride / bytesPerElement : size;
    const elementOffset = offset ? offset / bytesPerElement : 0;
    const vertexCount = Math.floor((typedArray.length - elementOffset) / elementStride);
    return (_, { index , target  })=>{
        if (!startIndices) {
            const sourceIndex = index * elementStride + elementOffset;
            for(let j = 0; j < size; j++)target[j] = typedArray[sourceIndex + j];
            return target;
        }
        const startIndex = startIndices[index];
        const endIndex = startIndices[index + 1] || vertexCount;
        let result;
        if (nested) {
            result = new Array(endIndex - startIndex);
            for(let i = startIndex; i < endIndex; i++){
                const sourceIndex1 = i * elementStride + elementOffset;
                target = new Array(size);
                for(let j1 = 0; j1 < size; j1++)target[j1] = typedArray[sourceIndex1 + j1];
                result[i - startIndex] = target;
            }
        } else if (elementStride === size) result = typedArray.subarray(startIndex * size + elementOffset, endIndex * size + elementOffset);
        else {
            result = new typedArray.constructor((endIndex - startIndex) * size);
            let targetIndex = 0;
            for(let i1 = startIndex; i1 < endIndex; i1++){
                const sourceIndex2 = i1 * elementStride + elementOffset;
                for(let j2 = 0; j2 < size; j2++)result[targetIndex++] = typedArray[sourceIndex2 + j2];
            }
        }
        return result;
    };
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"cSlI2":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "EMPTY", ()=>EMPTY);
parcelHelpers.export(exports, "FULL", ()=>FULL);
parcelHelpers.export(exports, "add", ()=>add);
const EMPTY = [];
const FULL = [
    [
        0,
        Infinity
    ]
];
function add(rangeList, range) {
    if (rangeList === FULL) return rangeList;
    if (range[0] < 0) range[0] = 0;
    if (range[0] >= range[1]) return rangeList;
    const newRangeList = [];
    const len = rangeList.length;
    let insertPosition = 0;
    for(let i = 0; i < len; i++){
        const range0 = rangeList[i];
        if (range0[1] < range[0]) {
            newRangeList.push(range0);
            insertPosition = i + 1;
        } else if (range0[0] > range[1]) newRangeList.push(range0);
        else range = [
            Math.min(range0[0], range[0]),
            Math.max(range0[1], range[1])
        ];
    }
    newRangeList.splice(insertPosition, 0, range);
    return newRangeList;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1Dphv":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "normalizeTransitionSettings", ()=>normalizeTransitionSettings);
parcelHelpers.export(exports, "getSourceBufferAttribute", ()=>getSourceBufferAttribute);
parcelHelpers.export(exports, "getAttributeTypeFromSize", ()=>getAttributeTypeFromSize);
parcelHelpers.export(exports, "cycleBuffers", ()=>cycleBuffers);
parcelHelpers.export(exports, "getAttributeBufferLength", ()=>getAttributeBufferLength);
parcelHelpers.export(exports, "padBuffer", ()=>padBuffer);
var _arrayUtils = require("../../utils/array-utils");
const DEFAULT_TRANSITION_SETTINGS = {
    interpolation: {
        duration: 0,
        easing: (t)=>t
    },
    spring: {
        stiffness: 0.05,
        damping: 0.5
    }
};
function normalizeTransitionSettings(userSettings, layerSettings) {
    if (!userSettings) return null;
    if (Number.isFinite(userSettings)) userSettings = {
        type: "interpolation",
        duration: userSettings
    };
    const type = userSettings.type || "interpolation";
    return {
        ...DEFAULT_TRANSITION_SETTINGS[type],
        ...layerSettings,
        ...userSettings,
        type
    };
}
function getSourceBufferAttribute(gl, attribute) {
    const buffer = attribute.getBuffer();
    if (buffer) return [
        buffer,
        {
            divisor: 0,
            size: attribute.size,
            normalized: attribute.settings.normalized
        }
    ];
    return attribute.value;
}
function getAttributeTypeFromSize(size) {
    switch(size){
        case 1:
            return "float";
        case 2:
            return "vec2";
        case 3:
            return "vec3";
        case 4:
            return "vec4";
        default:
            throw new Error('No defined attribute type for size "'.concat(size, '"'));
    }
}
function cycleBuffers(buffers) {
    buffers.push(buffers.shift());
}
function getAttributeBufferLength(attribute, numInstances) {
    const { doublePrecision , settings , value , size  } = attribute;
    const multiplier = doublePrecision && value instanceof Float64Array ? 2 : 1;
    return (settings.noAlloc ? value.length : numInstances * size) * multiplier;
}
function padBuffer({ buffer , numInstances , attribute , fromLength , fromStartIndices , getData =(x)=>x  }) {
    const precisionMultiplier = attribute.doublePrecision && attribute.value instanceof Float64Array ? 2 : 1;
    const size = attribute.size * precisionMultiplier;
    const byteOffset = attribute.byteOffset;
    const toStartIndices = attribute.startIndices;
    const hasStartIndices = fromStartIndices && toStartIndices;
    const toLength = getAttributeBufferLength(attribute, numInstances);
    const isConstant = attribute.isConstant;
    if (!hasStartIndices && fromLength >= toLength) return;
    const toData = isConstant ? attribute.value : attribute.getBuffer().getData({
        srcByteOffset: byteOffset
    });
    if (attribute.settings.normalized && !isConstant) {
        const getter = getData;
        getData = (value, chunk)=>attribute.normalizeConstant(getter(value, chunk));
    }
    const getMissingData = isConstant ? (i, chunk)=>getData(toData, chunk) : (i, chunk)=>getData(toData.subarray(i, i + size), chunk);
    const source = buffer.getData({
        length: fromLength
    });
    const data = new Float32Array(toLength);
    (0, _arrayUtils.padArray)({
        source,
        target: data,
        sourceStartIndices: fromStartIndices,
        targetStartIndices: toStartIndices,
        size,
        getData: getMissingData
    });
    if (buffer.byteLength < data.byteLength + byteOffset) buffer.reallocate(data.byteLength + byteOffset);
    buffer.subData({
        data,
        offset: byteOffset
    });
}

},{"../../utils/array-utils":"7fXjG","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7fXjG":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "padArray", ()=>padArray);
function padArrayChunk(options) {
    const { source , target , start =0 , size , getData  } = options;
    const end = options.end || target.length;
    const sourceLength = source.length;
    const targetLength = end - start;
    if (sourceLength > targetLength) {
        target.set(source.subarray(0, targetLength), start);
        return;
    }
    target.set(source, start);
    if (!getData) return;
    let i = sourceLength;
    while(i < targetLength){
        const datum = getData(i, source);
        for(let j = 0; j < size; j++){
            target[start + i] = datum[j] || 0;
            i++;
        }
    }
}
function padArray({ source , target , size , getData , sourceStartIndices , targetStartIndices  }) {
    if (!Array.isArray(targetStartIndices)) {
        padArrayChunk({
            source,
            target,
            size,
            getData
        });
        return target;
    }
    let sourceIndex = 0;
    let targetIndex = 0;
    const getChunkData = getData && ((i, chunk)=>getData(i + targetIndex, chunk));
    const n = Math.min(sourceStartIndices.length, targetStartIndices.length);
    for(let i = 1; i < n; i++){
        const nextSourceIndex = sourceStartIndices[i] * size;
        const nextTargetIndex = targetStartIndices[i] * size;
        padArrayChunk({
            source: source.subarray(sourceIndex, nextSourceIndex),
            target,
            start: targetIndex,
            end: nextTargetIndex,
            size,
            getData: getChunkData
        });
        sourceIndex = nextSourceIndex;
        targetIndex = nextTargetIndex;
    }
    if (targetIndex < target.length) padArrayChunk({
        source: [],
        target,
        start: targetIndex,
        size,
        getData: getChunkData
    });
    return target;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"uEGIh":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _gpuInterpolationTransition = require("../../transitions/gpu-interpolation-transition");
var _gpuInterpolationTransitionDefault = parcelHelpers.interopDefault(_gpuInterpolationTransition);
var _gpuSpringTransition = require("../../transitions/gpu-spring-transition");
var _gpuSpringTransitionDefault = parcelHelpers.interopDefault(_gpuSpringTransition);
var _log = require("../../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
const TRANSITION_TYPES = {
    interpolation: (0, _gpuInterpolationTransitionDefault.default),
    spring: (0, _gpuSpringTransitionDefault.default)
};
class AttributeTransitionManager {
    constructor(gl, { id , timeline  }){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "isSupported", void 0);
        (0, _definePropertyDefault.default)(this, "gl", void 0);
        (0, _definePropertyDefault.default)(this, "timeline", void 0);
        (0, _definePropertyDefault.default)(this, "transitions", void 0);
        (0, _definePropertyDefault.default)(this, "needsRedraw", void 0);
        (0, _definePropertyDefault.default)(this, "numInstances", void 0);
        this.id = id;
        this.gl = gl;
        this.timeline = timeline;
        this.transitions = {};
        this.needsRedraw = false;
        this.numInstances = 1;
        this.isSupported = (0, _core.Transform).isSupported(gl);
    }
    finalize() {
        for(const attributeName in this.transitions)this._removeTransition(attributeName);
    }
    update({ attributes , transitions , numInstances  }) {
        this.numInstances = numInstances || 1;
        for(const attributeName in attributes){
            const attribute = attributes[attributeName];
            const settings = attribute.getTransitionSetting(transitions);
            if (!settings) continue;
            this._updateAttribute(attributeName, attribute, settings);
        }
        for(const attributeName1 in this.transitions){
            const attribute1 = attributes[attributeName1];
            if (!attribute1 || !attribute1.getTransitionSetting(transitions)) this._removeTransition(attributeName1);
        }
    }
    hasAttribute(attributeName) {
        const transition = this.transitions[attributeName];
        return transition && transition.inProgress;
    }
    getAttributes() {
        const animatedAttributes = {};
        for(const attributeName in this.transitions){
            const transition = this.transitions[attributeName];
            if (transition.inProgress) animatedAttributes[attributeName] = transition.attributeInTransition;
        }
        return animatedAttributes;
    }
    run() {
        if (!this.isSupported || this.numInstances === 0) return false;
        for(const attributeName in this.transitions){
            const updated = this.transitions[attributeName].update();
            if (updated) this.needsRedraw = true;
        }
        const needsRedraw = this.needsRedraw;
        this.needsRedraw = false;
        return needsRedraw;
    }
    _removeTransition(attributeName) {
        this.transitions[attributeName].cancel();
        delete this.transitions[attributeName];
    }
    _updateAttribute(attributeName, attribute, settings) {
        const transition = this.transitions[attributeName];
        let isNew = !transition || transition.type !== settings.type;
        if (isNew) {
            if (!this.isSupported) {
                (0, _logDefault.default).warn("WebGL2 not supported by this browser. Transition for ".concat(attributeName, " is disabled."))();
                return;
            }
            if (transition) this._removeTransition(attributeName);
            const TransitionType = TRANSITION_TYPES[settings.type];
            if (TransitionType) this.transitions[attributeName] = new TransitionType({
                attribute,
                timeline: this.timeline,
                gl: this.gl
            });
            else {
                (0, _logDefault.default).error("unsupported transition type '".concat(settings.type, "'"))();
                isNew = false;
            }
        }
        if (isNew || attribute.needsRedraw()) {
            this.needsRedraw = true;
            this.transitions[attributeName].start(settings, this.numInstances);
        }
    }
}
exports.default = AttributeTransitionManager;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","../../transitions/gpu-interpolation-transition":"4FAYQ","../../transitions/gpu-spring-transition":"fbBr2","../../utils/log":"iINk7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4FAYQ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _attribute = require("../lib/attribute/attribute");
var _attributeDefault = parcelHelpers.interopDefault(_attribute);
var _attributeTransitionUtils = require("../lib/attribute/attribute-transition-utils");
var _transition = require("./transition");
var _transitionDefault = parcelHelpers.interopDefault(_transition);
class GPUInterpolationTransition {
    constructor({ gl , attribute , timeline  }){
        (0, _definePropertyDefault.default)(this, "gl", void 0);
        (0, _definePropertyDefault.default)(this, "type", "interpolation");
        (0, _definePropertyDefault.default)(this, "attributeInTransition", void 0);
        (0, _definePropertyDefault.default)(this, "settings", void 0);
        (0, _definePropertyDefault.default)(this, "attribute", void 0);
        (0, _definePropertyDefault.default)(this, "transition", void 0);
        (0, _definePropertyDefault.default)(this, "currentStartIndices", void 0);
        (0, _definePropertyDefault.default)(this, "currentLength", void 0);
        (0, _definePropertyDefault.default)(this, "transform", void 0);
        (0, _definePropertyDefault.default)(this, "buffers", void 0);
        this.gl = gl;
        this.transition = new (0, _transitionDefault.default)(timeline);
        this.attribute = attribute;
        this.attributeInTransition = new (0, _attributeDefault.default)(gl, attribute.settings);
        this.currentStartIndices = attribute.startIndices;
        this.currentLength = 0;
        this.transform = getTransform(gl, attribute);
        const bufferOpts = {
            byteLength: 0,
            usage: 35050
        };
        this.buffers = [
            new (0, _core.Buffer)(gl, bufferOpts),
            new (0, _core.Buffer)(gl, bufferOpts)
        ];
    }
    get inProgress() {
        return this.transition.inProgress;
    }
    start(transitionSettings, numInstances) {
        if (transitionSettings.duration <= 0) {
            this.transition.cancel();
            return;
        }
        this.settings = transitionSettings;
        const { gl , buffers , attribute  } = this;
        (0, _attributeTransitionUtils.cycleBuffers)(buffers);
        const padBufferOpts = {
            numInstances,
            attribute,
            fromLength: this.currentLength,
            fromStartIndices: this.currentStartIndices,
            getData: transitionSettings.enter
        };
        for (const buffer of buffers)(0, _attributeTransitionUtils.padBuffer)({
            buffer,
            ...padBufferOpts
        });
        this.currentStartIndices = attribute.startIndices;
        this.currentLength = (0, _attributeTransitionUtils.getAttributeBufferLength)(attribute, numInstances);
        this.attributeInTransition.setData({
            buffer: buffers[1],
            value: attribute.value
        });
        this.transition.start(transitionSettings);
        this.transform.update({
            elementCount: Math.floor(this.currentLength / attribute.size),
            sourceBuffers: {
                aFrom: buffers[0],
                aTo: (0, _attributeTransitionUtils.getSourceBufferAttribute)(gl, attribute)
            },
            feedbackBuffers: {
                vCurrent: buffers[1]
            }
        });
    }
    update() {
        const updated = this.transition.update();
        if (updated) {
            const { duration , easing  } = this.settings;
            const { time  } = this.transition;
            let t = time / duration;
            if (easing) t = easing(t);
            this.transform.run({
                uniforms: {
                    time: t
                }
            });
        }
        return updated;
    }
    cancel() {
        this.transition.cancel();
        this.transform.delete();
        for (const buffer of this.buffers)buffer.delete();
        this.buffers.length = 0;
    }
}
exports.default = GPUInterpolationTransition;
const vs = "\n#define SHADER_NAME interpolation-transition-vertex-shader\n\nuniform float time;\nattribute ATTRIBUTE_TYPE aFrom;\nattribute ATTRIBUTE_TYPE aTo;\nvarying ATTRIBUTE_TYPE vCurrent;\n\nvoid main(void) {\n  vCurrent = mix(aFrom, aTo, time);\n  gl_Position = vec4(0.0);\n}\n";
function getTransform(gl, attribute) {
    const attributeType = (0, _attributeTransitionUtils.getAttributeTypeFromSize)(attribute.size);
    return new (0, _core.Transform)(gl, {
        vs,
        defines: {
            ATTRIBUTE_TYPE: attributeType
        },
        varyings: [
            "vCurrent"
        ]
    });
}

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","../lib/attribute/attribute":"ldooi","../lib/attribute/attribute-transition-utils":"1Dphv","./transition":"kwq3Z","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fbBr2":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@luma.gl/core");
var _attributeTransitionUtils = require("../lib/attribute/attribute-transition-utils");
var _attribute = require("../lib/attribute/attribute");
var _attributeDefault = parcelHelpers.interopDefault(_attribute);
var _transition = require("./transition");
var _transitionDefault = parcelHelpers.interopDefault(_transition);
class GPUSpringTransition {
    constructor({ gl , attribute , timeline  }){
        (0, _definePropertyDefault.default)(this, "gl", void 0);
        (0, _definePropertyDefault.default)(this, "type", "spring");
        (0, _definePropertyDefault.default)(this, "attributeInTransition", void 0);
        (0, _definePropertyDefault.default)(this, "settings", void 0);
        (0, _definePropertyDefault.default)(this, "attribute", void 0);
        (0, _definePropertyDefault.default)(this, "transition", void 0);
        (0, _definePropertyDefault.default)(this, "currentStartIndices", void 0);
        (0, _definePropertyDefault.default)(this, "currentLength", void 0);
        (0, _definePropertyDefault.default)(this, "texture", void 0);
        (0, _definePropertyDefault.default)(this, "framebuffer", void 0);
        (0, _definePropertyDefault.default)(this, "transform", void 0);
        (0, _definePropertyDefault.default)(this, "buffers", void 0);
        this.gl = gl;
        this.type = "spring";
        this.transition = new (0, _transitionDefault.default)(timeline);
        this.attribute = attribute;
        this.attributeInTransition = new (0, _attributeDefault.default)(gl, {
            ...attribute.settings,
            normalized: false
        });
        this.currentStartIndices = attribute.startIndices;
        this.currentLength = 0;
        this.texture = getTexture(gl);
        this.framebuffer = getFramebuffer(gl, this.texture);
        this.transform = getTransform(gl, attribute, this.framebuffer);
        const bufferOpts = {
            byteLength: 0,
            usage: 35050
        };
        this.buffers = [
            new (0, _core.Buffer)(gl, bufferOpts),
            new (0, _core.Buffer)(gl, bufferOpts),
            new (0, _core.Buffer)(gl, bufferOpts)
        ];
    }
    get inProgress() {
        return this.transition.inProgress;
    }
    start(transitionSettings, numInstances) {
        const { gl , buffers , attribute  } = this;
        const padBufferOpts = {
            numInstances,
            attribute,
            fromLength: this.currentLength,
            fromStartIndices: this.currentStartIndices,
            getData: transitionSettings.enter
        };
        for (const buffer of buffers)(0, _attributeTransitionUtils.padBuffer)({
            buffer,
            ...padBufferOpts
        });
        this.settings = transitionSettings;
        this.currentStartIndices = attribute.startIndices;
        this.currentLength = (0, _attributeTransitionUtils.getAttributeBufferLength)(attribute, numInstances);
        this.attributeInTransition.setData({
            buffer: buffers[1],
            value: attribute.value
        });
        this.transition.start({
            ...transitionSettings,
            duration: Infinity
        });
        this.transform.update({
            elementCount: Math.floor(this.currentLength / attribute.size),
            sourceBuffers: {
                aTo: (0, _attributeTransitionUtils.getSourceBufferAttribute)(gl, attribute)
            }
        });
    }
    update() {
        const { buffers , transform , framebuffer , transition  } = this;
        const updated = transition.update();
        if (!updated) return false;
        const settings = this.settings;
        transform.update({
            sourceBuffers: {
                aPrev: buffers[0],
                aCur: buffers[1]
            },
            feedbackBuffers: {
                vNext: buffers[2]
            }
        });
        transform.run({
            framebuffer,
            discard: false,
            clearRenderTarget: true,
            uniforms: {
                stiffness: settings.stiffness,
                damping: settings.damping
            },
            parameters: {
                depthTest: false,
                blend: true,
                viewport: [
                    0,
                    0,
                    1,
                    1
                ],
                blendFunc: [
                    1,
                    1
                ],
                blendEquation: [
                    32776,
                    32776
                ]
            }
        });
        (0, _attributeTransitionUtils.cycleBuffers)(buffers);
        this.attributeInTransition.setData({
            buffer: buffers[1],
            value: this.attribute.value
        });
        const isTransitioning = (0, _core.readPixelsToArray)(framebuffer)[0] > 0;
        if (!isTransitioning) transition.end();
        return true;
    }
    cancel() {
        this.transition.cancel();
        this.transform.delete();
        for (const buffer of this.buffers)buffer.delete();
        this.buffers.length = 0;
        this.texture.delete();
        this.framebuffer.delete();
    }
}
exports.default = GPUSpringTransition;
function getTransform(gl, attribute, framebuffer) {
    const attributeType = (0, _attributeTransitionUtils.getAttributeTypeFromSize)(attribute.size);
    return new (0, _core.Transform)(gl, {
        framebuffer,
        vs: "\n#define SHADER_NAME spring-transition-vertex-shader\n\n#define EPSILON 0.00001\n\nuniform float stiffness;\nuniform float damping;\nattribute ATTRIBUTE_TYPE aPrev;\nattribute ATTRIBUTE_TYPE aCur;\nattribute ATTRIBUTE_TYPE aTo;\nvarying ATTRIBUTE_TYPE vNext;\nvarying float vIsTransitioningFlag;\n\nATTRIBUTE_TYPE getNextValue(ATTRIBUTE_TYPE cur, ATTRIBUTE_TYPE prev, ATTRIBUTE_TYPE dest) {\n  ATTRIBUTE_TYPE velocity = cur - prev;\n  ATTRIBUTE_TYPE delta = dest - cur;\n  ATTRIBUTE_TYPE spring = delta * stiffness;\n  ATTRIBUTE_TYPE damper = velocity * -1.0 * damping;\n  return spring + damper + velocity + cur;\n}\n\nvoid main(void) {\n  bool isTransitioning = length(aCur - aPrev) > EPSILON || length(aTo - aCur) > EPSILON;\n  vIsTransitioningFlag = isTransitioning ? 1.0 : 0.0;\n\n  vNext = getNextValue(aCur, aPrev, aTo);\n  gl_Position = vec4(0, 0, 0, 1);\n  gl_PointSize = 100.0;\n}\n",
        fs: "\n#define SHADER_NAME spring-transition-is-transitioning-fragment-shader\n\nvarying float vIsTransitioningFlag;\n\nvoid main(void) {\n  if (vIsTransitioningFlag == 0.0) {\n    discard;\n  }\n  gl_FragColor = vec4(1.0);\n}",
        defines: {
            ATTRIBUTE_TYPE: attributeType
        },
        varyings: [
            "vNext"
        ]
    });
}
function getTexture(gl) {
    return new (0, _core.Texture2D)(gl, {
        data: new Uint8Array(4),
        format: 6408,
        type: 5121,
        border: 0,
        mipmaps: false,
        dataFormat: 6408,
        width: 1,
        height: 1
    });
}
function getFramebuffer(gl, texture) {
    return new (0, _core.Framebuffer)(gl, {
        id: "spring-transition-is-transitioning-framebuffer",
        width: 1,
        height: 1,
        attachments: {
            [36064]: texture
        }
    });
}

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@luma.gl/core":"9yA57","../lib/attribute/attribute-transition-utils":"1Dphv","../lib/attribute/attribute":"ldooi","./transition":"kwq3Z","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kUVcd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _constants = require("./constants");
var _attributeManager = require("./attribute/attribute-manager");
var _attributeManagerDefault = parcelHelpers.interopDefault(_attributeManager);
var _uniformTransitionManager = require("./uniform-transition-manager");
var _uniformTransitionManagerDefault = parcelHelpers.interopDefault(_uniformTransitionManager);
var _props = require("../lifecycle/props");
var _constants1 = require("../lifecycle/constants");
var _count = require("../utils/count");
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _debug = require("../debug");
var _debugDefault = parcelHelpers.interopDefault(_debug);
var _core = require("@luma.gl/core");
var _assert = require("../utils/assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _memoize = require("../utils/memoize");
var _memoizeDefault = parcelHelpers.interopDefault(_memoize);
var _shader = require("../utils/shader");
var _projectFunctions = require("../shaderlib/project/project-functions");
var _typedArrayManager = require("../utils/typed-array-manager");
var _typedArrayManagerDefault = parcelHelpers.interopDefault(_typedArrayManager);
var _component = require("../lifecycle/component");
var _componentDefault = parcelHelpers.interopDefault(_component);
var _layerState = require("./layer-state");
var _layerStateDefault = parcelHelpers.interopDefault(_layerState);
var _webMercator = require("@math.gl/web-mercator");
var _core1 = require("@loaders.gl/core");
const TRACE_CHANGE_FLAG = "layer.changeFlag";
const TRACE_INITIALIZE = "layer.initialize";
const TRACE_UPDATE = "layer.update";
const TRACE_FINALIZE = "layer.finalize";
const TRACE_MATCHED = "layer.matched";
const MAX_PICKING_COLOR_CACHE_SIZE = 2 ** 24 - 1;
const EMPTY_ARRAY = Object.freeze([]);
const areViewportsEqual = (0, _memoizeDefault.default)(({ oldViewport , viewport  })=>{
    return oldViewport.equals(viewport);
});
let pickingColorCache = new Uint8ClampedArray(0);
const defaultProps = {
    data: {
        type: "data",
        value: EMPTY_ARRAY,
        async: true
    },
    dataComparator: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    _dataDiff: {
        type: "function",
        value: (data)=>data && data.__diff,
        compare: false,
        optional: true
    },
    dataTransform: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    onDataLoad: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    onError: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    fetch: {
        type: "function",
        value: (url, { propName , layer , loaders , loadOptions , signal  })=>{
            const { resourceManager  } = layer.context;
            loadOptions = loadOptions || layer.getLoadOptions();
            loaders = loaders || layer.props.loaders;
            if (signal) {
                var _loadOptions;
                loadOptions = {
                    ...loadOptions,
                    fetch: {
                        ...(_loadOptions = loadOptions) === null || _loadOptions === void 0 ? void 0 : _loadOptions.fetch,
                        signal
                    }
                };
            }
            let inResourceManager = resourceManager.contains(url);
            if (!inResourceManager && !loadOptions) {
                resourceManager.add({
                    resourceId: url,
                    data: (0, _core1.load)(url, loaders),
                    persistent: false
                });
                inResourceManager = true;
            }
            if (inResourceManager) return resourceManager.subscribe({
                resourceId: url,
                onChange: (data)=>{
                    var _layer$internalState;
                    return (_layer$internalState = layer.internalState) === null || _layer$internalState === void 0 ? void 0 : _layer$internalState.reloadAsyncProp(propName, data);
                },
                consumerId: layer.id,
                requestId: propName
            });
            return (0, _core1.load)(url, loaders, loadOptions);
        },
        compare: false
    },
    updateTriggers: {},
    visible: true,
    pickable: false,
    opacity: {
        type: "number",
        min: 0,
        max: 1,
        value: 1
    },
    operation: (0, _constants.OPERATION).DRAW,
    onHover: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    onClick: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    onDragStart: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    onDrag: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    onDragEnd: {
        type: "function",
        value: null,
        compare: false,
        optional: true
    },
    coordinateSystem: (0, _constants.COORDINATE_SYSTEM).DEFAULT,
    coordinateOrigin: {
        type: "array",
        value: [
            0,
            0,
            0
        ],
        compare: true
    },
    modelMatrix: {
        type: "array",
        value: null,
        compare: true,
        optional: true
    },
    wrapLongitude: false,
    positionFormat: "XYZ",
    colorFormat: "RGBA",
    parameters: {
        type: "object",
        value: {},
        optional: true,
        compare: true
    },
    transitions: null,
    extensions: [],
    loaders: {
        type: "array",
        value: [],
        optional: true,
        compare: true
    },
    getPolygonOffset: {
        type: "function",
        value: ({ layerIndex  })=>[
                0,
                -layerIndex * 100
            ],
        compare: false
    },
    highlightedObjectIndex: null,
    autoHighlight: false,
    highlightColor: {
        type: "accessor",
        value: [
            0,
            0,
            128,
            128
        ]
    }
};
class Layer extends (0, _componentDefault.default) {
    constructor(...args){
        super(...args);
        (0, _definePropertyDefault.default)(this, "internalState", null);
        (0, _definePropertyDefault.default)(this, "lifecycle", (0, _constants1.LIFECYCLE).NO_STATE);
        (0, _definePropertyDefault.default)(this, "context", void 0);
        (0, _definePropertyDefault.default)(this, "state", void 0);
        (0, _definePropertyDefault.default)(this, "parent", null);
    }
    get root() {
        let layer = this;
        while(layer.parent)layer = layer.parent;
        return layer;
    }
    toString() {
        const className = this.constructor.layerName || this.constructor.name;
        return "".concat(className, "({id: '").concat(this.props.id, "'})");
    }
    project(xyz) {
        (0, _assertDefault.default)(this.internalState);
        const viewport = this.internalState.viewport || this.context.viewport;
        const worldPosition = (0, _projectFunctions.getWorldPosition)(xyz, {
            viewport,
            modelMatrix: this.props.modelMatrix,
            coordinateOrigin: this.props.coordinateOrigin,
            coordinateSystem: this.props.coordinateSystem
        });
        const [x, y, z] = (0, _webMercator.worldToPixels)(worldPosition, viewport.pixelProjectionMatrix);
        return xyz.length === 2 ? [
            x,
            y
        ] : [
            x,
            y,
            z
        ];
    }
    unproject(xy) {
        (0, _assertDefault.default)(this.internalState);
        const viewport = this.internalState.viewport || this.context.viewport;
        return viewport.unproject(xy);
    }
    projectPosition(xyz, params) {
        (0, _assertDefault.default)(this.internalState);
        const viewport = this.internalState.viewport || this.context.viewport;
        return (0, _projectFunctions.projectPosition)(xyz, {
            viewport,
            modelMatrix: this.props.modelMatrix,
            coordinateOrigin: this.props.coordinateOrigin,
            coordinateSystem: this.props.coordinateSystem,
            ...params
        });
    }
    get isComposite() {
        return false;
    }
    setState(partialState) {
        this.setChangeFlags({
            stateChanged: true
        });
        Object.assign(this.state, partialState);
        this.setNeedsRedraw();
    }
    setNeedsRedraw() {
        if (this.internalState) this.internalState.needsRedraw = true;
    }
    setNeedsUpdate() {
        if (this.internalState) {
            this.context.layerManager.setNeedsUpdate(String(this));
            this.internalState.needsUpdate = true;
        }
    }
    get isLoaded() {
        return this.internalState ? !this.internalState.isAsyncPropLoading() : false;
    }
    get wrapLongitude() {
        return this.props.wrapLongitude;
    }
    isPickable() {
        return this.props.pickable && this.props.visible;
    }
    getModels() {
        return this.state && (this.state.models || this.state.model && [
            this.state.model
        ]) || [];
    }
    setModuleParameters(moduleParameters) {
        for (const model of this.getModels())model.updateModuleSettings(moduleParameters);
    }
    getAttributeManager() {
        return this.internalState && this.internalState.attributeManager;
    }
    getCurrentLayer() {
        return this.internalState && this.internalState.layer;
    }
    getLoadOptions() {
        return this.props.loadOptions;
    }
    use64bitPositions() {
        const { coordinateSystem  } = this.props;
        return coordinateSystem === (0, _constants.COORDINATE_SYSTEM).DEFAULT || coordinateSystem === (0, _constants.COORDINATE_SYSTEM).LNGLAT || coordinateSystem === (0, _constants.COORDINATE_SYSTEM).CARTESIAN;
    }
    onHover(info, pickingEvent) {
        if (this.props.onHover) return this.props.onHover(info, pickingEvent) || false;
        return false;
    }
    onClick(info, pickingEvent) {
        if (this.props.onClick) return this.props.onClick(info, pickingEvent) || false;
        return false;
    }
    nullPickingColor() {
        return [
            0,
            0,
            0
        ];
    }
    encodePickingColor(i, target = []) {
        target[0] = i + 1 & 255;
        target[1] = i + 1 >> 8 & 255;
        target[2] = i + 1 >> 8 >> 8 & 255;
        return target;
    }
    decodePickingColor(color) {
        (0, _assertDefault.default)(color instanceof Uint8Array);
        const [i1, i2, i3] = color;
        const index = i1 + i2 * 256 + i3 * 65536 - 1;
        return index;
    }
    getNumInstances() {
        if (Number.isFinite(this.props.numInstances)) return this.props.numInstances;
        if (this.state && this.state.numInstances !== undefined) return this.state.numInstances;
        return (0, _count.count)(this.props.data);
    }
    getStartIndices() {
        if (this.props.startIndices) return this.props.startIndices;
        if (this.state && this.state.startIndices) return this.state.startIndices;
        return null;
    }
    getBounds() {
        var _ref;
        const attributeManager = this.getAttributeManager();
        if (!attributeManager) return null;
        const { positions , instancePositions  } = attributeManager.attributes;
        return (_ref = positions || instancePositions) === null || _ref === void 0 ? void 0 : _ref.getBounds();
    }
    getShaders(shaders) {
        for (const extension of this.props.extensions)shaders = (0, _shader.mergeShaders)(shaders, extension.getShaders.call(this, extension));
        return shaders;
    }
    shouldUpdateState(params) {
        return params.changeFlags.propsOrDataChanged;
    }
    updateState(params) {
        const attributeManager = this.getAttributeManager();
        const { dataChanged  } = params.changeFlags;
        if (dataChanged && attributeManager) {
            if (Array.isArray(dataChanged)) for (const dataRange of dataChanged)attributeManager.invalidateAll(dataRange);
            else attributeManager.invalidateAll();
        }
        const { props , oldProps  } = params;
        const neededPickingBuffer = Number.isInteger(oldProps.highlightedObjectIndex) || oldProps.pickable;
        const needPickingBuffer = Number.isInteger(props.highlightedObjectIndex) || props.pickable;
        if (neededPickingBuffer !== needPickingBuffer && attributeManager) {
            const { pickingColors , instancePickingColors  } = attributeManager.attributes;
            const pickingColorsAttribute = pickingColors || instancePickingColors;
            if (pickingColorsAttribute) {
                if (needPickingBuffer && pickingColorsAttribute.constant) {
                    pickingColorsAttribute.constant = false;
                    attributeManager.invalidate(pickingColorsAttribute.id);
                }
                if (!pickingColorsAttribute.value && !needPickingBuffer) {
                    pickingColorsAttribute.constant = true;
                    pickingColorsAttribute.value = [
                        0,
                        0,
                        0
                    ];
                }
            }
        }
    }
    finalizeState(context) {
        for (const model of this.getModels())model.delete();
        const attributeManager = this.getAttributeManager();
        if (attributeManager) attributeManager.finalize();
        if (this.context) this.context.resourceManager.unsubscribe({
            consumerId: this.id
        });
        if (this.internalState) {
            this.internalState.uniformTransitions.clear();
            this.internalState.finalize();
        }
    }
    draw(opts) {
        for (const model of this.getModels())model.draw(opts);
    }
    getPickingInfo({ info , mode , sourceLayer  }) {
        const { index  } = info;
        if (index >= 0) {
            if (Array.isArray(this.props.data)) info.object = this.props.data[index];
        }
        return info;
    }
    raiseError(error, message) {
        var _this$props$onError, _this$props;
        if (message) error.message = "".concat(message, ": ").concat(error.message);
        if (!((_this$props$onError = (_this$props = this.props).onError) !== null && _this$props$onError !== void 0 && _this$props$onError.call(_this$props, error))) {
            var _this$context, _this$context$onError;
            (_this$context = this.context) === null || _this$context === void 0 || (_this$context$onError = _this$context.onError) === null || _this$context$onError === void 0 || _this$context$onError.call(_this$context, error, this);
        }
    }
    getNeedsRedraw(opts = {
        clearRedrawFlags: false
    }) {
        return this._getNeedsRedraw(opts);
    }
    needsUpdate() {
        if (!this.internalState) return false;
        return this.internalState.needsUpdate || this.hasUniformTransition() || this.shouldUpdateState(this._getUpdateParams());
    }
    hasUniformTransition() {
        var _this$internalState;
        return ((_this$internalState = this.internalState) === null || _this$internalState === void 0 ? void 0 : _this$internalState.uniformTransitions.active) || false;
    }
    activateViewport(viewport) {
        if (!this.internalState) return;
        const oldViewport = this.internalState.viewport;
        this.internalState.viewport = viewport;
        if (!oldViewport || !areViewportsEqual({
            oldViewport,
            viewport
        })) {
            this.setChangeFlags({
                viewportChanged: true
            });
            if (this.isComposite) {
                if (this.needsUpdate()) this.setNeedsUpdate();
            } else this._update();
        }
    }
    invalidateAttribute(name = "all") {
        const attributeManager = this.getAttributeManager();
        if (!attributeManager) return;
        if (name === "all") attributeManager.invalidateAll();
        else attributeManager.invalidate(name);
    }
    updateAttributes(changedAttributes) {
        for (const model of this.getModels())this._setModelAttributes(model, changedAttributes);
    }
    _updateAttributes() {
        const attributeManager = this.getAttributeManager();
        if (!attributeManager) return;
        const props = this.props;
        const numInstances = this.getNumInstances();
        const startIndices = this.getStartIndices();
        attributeManager.update({
            data: props.data,
            numInstances,
            startIndices,
            props,
            transitions: props.transitions,
            buffers: props.data.attributes,
            context: this
        });
        const changedAttributes = attributeManager.getChangedAttributes({
            clearChangedFlags: true
        });
        this.updateAttributes(changedAttributes);
    }
    _updateAttributeTransition() {
        const attributeManager = this.getAttributeManager();
        if (attributeManager) attributeManager.updateTransition();
    }
    _updateUniformTransition() {
        const { uniformTransitions  } = this.internalState;
        if (uniformTransitions.active) {
            const propsInTransition = uniformTransitions.update();
            const props = Object.create(this.props);
            for(const key in propsInTransition)Object.defineProperty(props, key, {
                value: propsInTransition[key]
            });
            return props;
        }
        return this.props;
    }
    calculateInstancePickingColors(attribute, { numInstances  }) {
        if (attribute.constant) return;
        const cacheSize = Math.floor(pickingColorCache.length / 3);
        this.internalState.usesPickingColorCache = true;
        if (cacheSize < numInstances) {
            if (numInstances > MAX_PICKING_COLOR_CACHE_SIZE) (0, _logDefault.default).warn("Layer has too many data objects. Picking might not be able to distinguish all objects.")();
            pickingColorCache = (0, _typedArrayManagerDefault.default).allocate(pickingColorCache, numInstances, {
                size: 3,
                copy: true,
                maxCount: Math.max(numInstances, MAX_PICKING_COLOR_CACHE_SIZE)
            });
            const newCacheSize = Math.floor(pickingColorCache.length / 3);
            const pickingColor = [];
            for(let i = cacheSize; i < newCacheSize; i++){
                this.encodePickingColor(i, pickingColor);
                pickingColorCache[i * 3 + 0] = pickingColor[0];
                pickingColorCache[i * 3 + 1] = pickingColor[1];
                pickingColorCache[i * 3 + 2] = pickingColor[2];
            }
        }
        attribute.value = pickingColorCache.subarray(0, numInstances * 3);
    }
    _setModelAttributes(model, changedAttributes) {
        const attributeManager = this.getAttributeManager();
        const excludeAttributes = model.userData.excludeAttributes || {};
        const shaderAttributes = attributeManager.getShaderAttributes(changedAttributes, excludeAttributes);
        model.setAttributes(shaderAttributes);
    }
    disablePickingIndex(objectIndex) {
        this._disablePickingIndex(objectIndex);
    }
    _disablePickingIndex(objectIndex) {
        const { pickingColors , instancePickingColors  } = this.getAttributeManager().attributes;
        const colors = pickingColors || instancePickingColors;
        if (!colors) return;
        const start = colors.getVertexOffset(objectIndex);
        const end = colors.getVertexOffset(objectIndex + 1);
        colors.buffer.subData({
            data: new Uint8Array(end - start),
            offset: start
        });
    }
    restorePickingColors() {
        const { pickingColors , instancePickingColors  } = this.getAttributeManager().attributes;
        const colors = pickingColors || instancePickingColors;
        if (!colors) return;
        if (this.internalState.usesPickingColorCache && colors.value.buffer !== pickingColorCache.buffer) colors.value = pickingColorCache.subarray(0, colors.value.length);
        colors.updateSubBuffer({
            startOffset: 0
        });
    }
    _initialize() {
        (0, _assertDefault.default)(!this.internalState);
        (0, _assertDefault.default)(Number.isFinite(this.props.coordinateSystem));
        (0, _debugDefault.default)(TRACE_INITIALIZE, this);
        const attributeManager = this._getAttributeManager();
        if (attributeManager) attributeManager.addInstanced({
            instancePickingColors: {
                type: 5121,
                size: 3,
                noAlloc: true,
                update: this.calculateInstancePickingColors
            }
        });
        this.internalState = new (0, _layerStateDefault.default)({
            attributeManager,
            layer: this
        });
        this._clearChangeFlags();
        this.state = {};
        Object.defineProperty(this.state, "attributeManager", {
            get: ()=>{
                (0, _logDefault.default).deprecated("layer.state.attributeManager", "layer.getAttributeManager()")();
                return attributeManager;
            }
        });
        this.internalState.layer = this;
        this.internalState.uniformTransitions = new (0, _uniformTransitionManagerDefault.default)(this.context.timeline);
        this.internalState.onAsyncPropUpdated = this._onAsyncPropUpdated.bind(this);
        this.internalState.setAsyncProps(this.props);
        this.initializeState(this.context);
        for (const extension of this.props.extensions)extension.initializeState.call(this, this.context, extension);
        this.setChangeFlags({
            dataChanged: "init",
            propsChanged: "init",
            viewportChanged: true,
            extensionsChanged: true
        });
        this._update();
    }
    _transferState(oldLayer) {
        (0, _debugDefault.default)(TRACE_MATCHED, this, this === oldLayer);
        const { state , internalState  } = oldLayer;
        if (this === oldLayer) return;
        this.internalState = internalState;
        this.internalState.layer = this;
        this.state = state;
        this.internalState.setAsyncProps(this.props);
        this._diffProps(this.props, this.internalState.getOldProps());
    }
    _update() {
        const stateNeedsUpdate = this.needsUpdate();
        (0, _debugDefault.default)(TRACE_UPDATE, this, stateNeedsUpdate);
        if (!stateNeedsUpdate) return;
        const currentProps = this.props;
        const context = this.context;
        const internalState = this.internalState;
        const currentViewport = context.viewport;
        const propsInTransition = this._updateUniformTransition();
        internalState.propsInTransition = propsInTransition;
        context.viewport = internalState.viewport || currentViewport;
        this.props = propsInTransition;
        try {
            const updateParams = this._getUpdateParams();
            const oldModels = this.getModels();
            if (context.gl) this.updateState(updateParams);
            else try {
                this.updateState(updateParams);
            } catch (error) {}
            for (const extension of this.props.extensions)extension.updateState.call(this, updateParams, extension);
            const modelChanged = this.getModels()[0] !== oldModels[0];
            this._postUpdate(updateParams, modelChanged);
        } finally{
            context.viewport = currentViewport;
            this.props = currentProps;
            this._clearChangeFlags();
            internalState.needsUpdate = false;
            internalState.resetOldProps();
        }
    }
    _finalize() {
        (0, _debugDefault.default)(TRACE_FINALIZE, this);
        this.finalizeState(this.context);
        for (const extension of this.props.extensions)extension.finalizeState.call(this, extension);
    }
    _drawLayer({ moduleParameters =null , uniforms ={} , parameters ={}  }) {
        this._updateAttributeTransition();
        const currentProps = this.props;
        const context = this.context;
        this.props = this.internalState.propsInTransition || currentProps;
        const opacity = this.props.opacity;
        uniforms.opacity = Math.pow(opacity, 1 / 2.2);
        try {
            if (moduleParameters) this.setModuleParameters(moduleParameters);
            const { getPolygonOffset  } = this.props;
            const offsets = getPolygonOffset && getPolygonOffset(uniforms) || [
                0,
                0
            ];
            (0, _core.setParameters)(context.gl, {
                polygonOffset: offsets
            });
            (0, _core.withParameters)(context.gl, parameters, ()=>{
                const opts = {
                    moduleParameters,
                    uniforms,
                    parameters,
                    context
                };
                for (const extension of this.props.extensions)extension.draw.call(this, opts, extension);
                this.draw(opts);
            });
        } finally{
            this.props = currentProps;
        }
    }
    getChangeFlags() {
        var _this$internalState2;
        return (_this$internalState2 = this.internalState) === null || _this$internalState2 === void 0 ? void 0 : _this$internalState2.changeFlags;
    }
    setChangeFlags(flags) {
        if (!this.internalState) return;
        const { changeFlags  } = this.internalState;
        for(const key in flags)if (flags[key]) {
            let flagChanged = false;
            switch(key){
                case "dataChanged":
                    const dataChangedReason = flags[key];
                    const prevDataChangedReason = changeFlags[key];
                    if (dataChangedReason && Array.isArray(prevDataChangedReason)) {
                        changeFlags.dataChanged = Array.isArray(dataChangedReason) ? prevDataChangedReason.concat(dataChangedReason) : dataChangedReason;
                        flagChanged = true;
                    }
                default:
                    if (!changeFlags[key]) {
                        changeFlags[key] = flags[key];
                        flagChanged = true;
                    }
            }
            if (flagChanged) (0, _debugDefault.default)(TRACE_CHANGE_FLAG, this, key, flags);
        }
        const propsOrDataChanged = Boolean(changeFlags.dataChanged || changeFlags.updateTriggersChanged || changeFlags.propsChanged || changeFlags.extensionsChanged);
        changeFlags.propsOrDataChanged = propsOrDataChanged;
        changeFlags.somethingChanged = propsOrDataChanged || changeFlags.viewportChanged || changeFlags.stateChanged;
    }
    _clearChangeFlags() {
        this.internalState.changeFlags = {
            dataChanged: false,
            propsChanged: false,
            updateTriggersChanged: false,
            viewportChanged: false,
            stateChanged: false,
            extensionsChanged: false,
            propsOrDataChanged: false,
            somethingChanged: false
        };
    }
    _diffProps(newProps, oldProps) {
        const changeFlags = (0, _props.diffProps)(newProps, oldProps);
        if (changeFlags.updateTriggersChanged) {
            for(const key in changeFlags.updateTriggersChanged)if (changeFlags.updateTriggersChanged[key]) this.invalidateAttribute(key);
        }
        if (changeFlags.transitionsChanged) for(const key1 in changeFlags.transitionsChanged){
            var _newProps$transitions;
            this.internalState.uniformTransitions.add(key1, oldProps[key1], newProps[key1], (_newProps$transitions = newProps.transitions) === null || _newProps$transitions === void 0 ? void 0 : _newProps$transitions[key1]);
        }
        return this.setChangeFlags(changeFlags);
    }
    validateProps() {
        (0, _props.validateProps)(this.props);
    }
    updateAutoHighlight(info) {
        if (this.props.autoHighlight && !Number.isInteger(this.props.highlightedObjectIndex)) this._updateAutoHighlight(info);
    }
    _updateAutoHighlight(info) {
        const pickingModuleParameters = {
            pickingSelectedColor: info.picked ? info.color : null
        };
        const { highlightColor  } = this.props;
        if (info.picked && typeof highlightColor === "function") pickingModuleParameters.pickingHighlightColor = highlightColor(info);
        this.setModuleParameters(pickingModuleParameters);
        this.setNeedsRedraw();
    }
    _getAttributeManager() {
        const context = this.context;
        return new (0, _attributeManagerDefault.default)(context.gl, {
            id: this.props.id,
            stats: context.stats,
            timeline: context.timeline
        });
    }
    _postUpdate(updateParams, forceUpdate) {
        const { props , oldProps  } = updateParams;
        this.setNeedsRedraw();
        this._updateAttributes();
        const { model  } = this.state;
        model === null || model === void 0 || model.setInstanceCount(this.getNumInstances());
        const { autoHighlight , highlightedObjectIndex , highlightColor  } = props;
        if (forceUpdate || oldProps.autoHighlight !== autoHighlight || oldProps.highlightedObjectIndex !== highlightedObjectIndex || oldProps.highlightColor !== highlightColor) {
            const parameters = {};
            if (!autoHighlight) parameters.pickingSelectedColor = null;
            if (Array.isArray(highlightColor)) parameters.pickingHighlightColor = highlightColor;
            if (Number.isInteger(highlightedObjectIndex)) parameters.pickingSelectedColor = Number.isFinite(highlightedObjectIndex) && highlightedObjectIndex >= 0 ? this.encodePickingColor(highlightedObjectIndex) : null;
            this.setModuleParameters(parameters);
        }
    }
    _getUpdateParams() {
        return {
            props: this.props,
            oldProps: this.internalState.getOldProps(),
            context: this.context,
            changeFlags: this.internalState.changeFlags
        };
    }
    _getNeedsRedraw(opts) {
        if (!this.internalState) return false;
        let redraw = false;
        redraw = redraw || this.internalState.needsRedraw && this.id;
        this.internalState.needsRedraw = this.internalState.needsRedraw && !opts.clearRedrawFlags;
        const attributeManager = this.getAttributeManager();
        const attributeManagerNeedsRedraw = attributeManager ? attributeManager.getNeedsRedraw(opts) : false;
        redraw = redraw || attributeManagerNeedsRedraw;
        return redraw;
    }
    _onAsyncPropUpdated() {
        this._diffProps(this.props, this.internalState.getOldProps());
        this.setNeedsUpdate();
    }
}
exports.default = Layer;
(0, _definePropertyDefault.default)(Layer, "defaultProps", defaultProps);
(0, _definePropertyDefault.default)(Layer, "layerName", "Layer");

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./constants":"ksWme","./attribute/attribute-manager":"5oF21","./uniform-transition-manager":"bjNoY","../lifecycle/props":"8bMWn","../lifecycle/constants":"99KhZ","../utils/count":"66RBf","../utils/log":"iINk7","../debug":"e6y6V","@luma.gl/core":"9yA57","../utils/assert":"aysGh","../utils/memoize":"gjCnZ","../utils/shader":"4B3So","../shaderlib/project/project-functions":"8KMOU","../utils/typed-array-manager":"kyraM","../lifecycle/component":"2mVN7","./layer-state":"7fPJ1","@math.gl/web-mercator":"aEEkN","@loaders.gl/core":"aRzJb","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bjNoY":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _attributeTransitionUtils = require("./attribute/attribute-transition-utils");
var _cpuInterpolationTransition = require("../transitions/cpu-interpolation-transition");
var _cpuInterpolationTransitionDefault = parcelHelpers.interopDefault(_cpuInterpolationTransition);
var _cpuSpringTransition = require("../transitions/cpu-spring-transition");
var _cpuSpringTransitionDefault = parcelHelpers.interopDefault(_cpuSpringTransition);
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
const TRANSITION_TYPES = {
    interpolation: (0, _cpuInterpolationTransitionDefault.default),
    spring: (0, _cpuSpringTransitionDefault.default)
};
class UniformTransitionManager {
    constructor(timeline){
        this.transitions = new Map();
        this.timeline = timeline;
    }
    get active() {
        return this.transitions.size > 0;
    }
    add(key, fromValue, toValue, settings) {
        const { transitions  } = this;
        if (transitions.has(key)) {
            const transition = transitions.get(key);
            const { value =transition.settings.fromValue  } = transition;
            fromValue = value;
            this.remove(key);
        }
        settings = (0, _attributeTransitionUtils.normalizeTransitionSettings)(settings);
        if (!settings) return;
        const TransitionType = TRANSITION_TYPES[settings.type];
        if (!TransitionType) {
            (0, _logDefault.default).error("unsupported transition type '".concat(settings.type, "'"))();
            return;
        }
        const transition1 = new TransitionType(this.timeline);
        transition1.start({
            ...settings,
            fromValue,
            toValue
        });
        transitions.set(key, transition1);
    }
    remove(key) {
        const { transitions  } = this;
        if (transitions.has(key)) {
            transitions.get(key).cancel();
            transitions.delete(key);
        }
    }
    update() {
        const propsInTransition = {};
        for (const [key, transition] of this.transitions){
            transition.update();
            propsInTransition[key] = transition.value;
            if (!transition.inProgress) this.remove(key);
        }
        return propsInTransition;
    }
    clear() {
        for (const key of this.transitions.keys())this.remove(key);
    }
}
exports.default = UniformTransitionManager;

},{"./attribute/attribute-transition-utils":"1Dphv","../transitions/cpu-interpolation-transition":"koxl7","../transitions/cpu-spring-transition":"2PGV8","../utils/log":"iINk7","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"koxl7":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _core = require("@math.gl/core");
var _transition = require("./transition");
var _transitionDefault = parcelHelpers.interopDefault(_transition);
class CPUInterpolationTransition extends (0, _transitionDefault.default) {
    get value() {
        return this._value;
    }
    _onUpdate() {
        const { time , settings: { fromValue , toValue , duration , easing  }  } = this;
        const t = easing(time / duration);
        this._value = (0, _core.lerp)(fromValue, toValue, t);
    }
}
exports.default = CPUInterpolationTransition;

},{"@math.gl/core":"9lgwD","./transition":"kwq3Z","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2PGV8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _transition = require("./transition");
var _transitionDefault = parcelHelpers.interopDefault(_transition);
const EPSILON = 1e-5;
function updateSpringElement(prev, cur, dest, damping, stiffness) {
    const velocity = cur - prev;
    const delta = dest - cur;
    const spring = delta * stiffness;
    const damper = -velocity * damping;
    return spring + damper + velocity + cur;
}
function updateSpring(prev, cur, dest, damping, stiffness) {
    if (Array.isArray(dest)) {
        const next = [];
        for(let i = 0; i < dest.length; i++)next[i] = updateSpringElement(prev[i], cur[i], dest[i], damping, stiffness);
        return next;
    }
    return updateSpringElement(prev, cur, dest, damping, stiffness);
}
function distance(value1, value2) {
    if (Array.isArray(value1)) {
        let distanceSquare = 0;
        for(let i = 0; i < value1.length; i++){
            const d = value1[i] - value2[i];
            distanceSquare += d * d;
        }
        return Math.sqrt(distanceSquare);
    }
    return Math.abs(value1 - value2);
}
class CPUSpringTransition extends (0, _transitionDefault.default) {
    get value() {
        return this._currValue;
    }
    _onUpdate() {
        const { fromValue , toValue , damping , stiffness  } = this.settings;
        const { _prevValue =fromValue , _currValue =fromValue  } = this;
        let nextValue = updateSpring(_prevValue, _currValue, toValue, damping, stiffness);
        const delta = distance(nextValue, toValue);
        const velocity = distance(nextValue, _currValue);
        if (delta < EPSILON && velocity < EPSILON) {
            nextValue = toValue;
            this.end();
        }
        this._prevValue = _currValue;
        this._currValue = nextValue;
    }
}
exports.default = CPUSpringTransition;

},{"./transition":"kwq3Z","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8bMWn":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "validateProps", ()=>validateProps);
parcelHelpers.export(exports, "diffProps", ()=>diffProps);
parcelHelpers.export(exports, "compareProps", ()=>compareProps);
var _constants = require("./constants");
function validateProps(props) {
    const propTypes = getPropTypes(props);
    for(const propName in propTypes){
        const propType = propTypes[propName];
        const { validate  } = propType;
        if (validate && !validate(props[propName], propType)) throw new Error("Invalid prop ".concat(propName, ": ").concat(props[propName]));
    }
}
function diffProps(props, oldProps) {
    const propsChangedReason = compareProps({
        newProps: props,
        oldProps,
        propTypes: getPropTypes(props),
        ignoreProps: {
            data: null,
            updateTriggers: null,
            extensions: null,
            transitions: null
        }
    });
    const dataChangedReason = diffDataProps(props, oldProps);
    let updateTriggersChangedReason = false;
    if (!dataChangedReason) updateTriggersChangedReason = diffUpdateTriggers(props, oldProps);
    return {
        dataChanged: dataChangedReason,
        propsChanged: propsChangedReason,
        updateTriggersChanged: updateTriggersChangedReason,
        extensionsChanged: diffExtensions(props, oldProps),
        transitionsChanged: diffTransitions(props, oldProps)
    };
}
function diffTransitions(props, oldProps) {
    if (!props.transitions) return false;
    const result = {};
    const propTypes = getPropTypes(props);
    let changed = false;
    for(const key in props.transitions){
        const propType = propTypes[key];
        const type = propType && propType.type;
        const isTransitionable = type === "number" || type === "color" || type === "array";
        if (isTransitionable && comparePropValues(props[key], oldProps[key], propType)) {
            result[key] = true;
            changed = true;
        }
    }
    return changed ? result : false;
}
function compareProps({ newProps , oldProps , ignoreProps ={} , propTypes ={} , triggerName ="props"  }) {
    if (oldProps === newProps) return false;
    if (typeof newProps !== "object" || newProps === null) return "".concat(triggerName, " changed shallowly");
    if (typeof oldProps !== "object" || oldProps === null) return "".concat(triggerName, " changed shallowly");
    for (const key of Object.keys(newProps))if (!(key in ignoreProps)) {
        if (!(key in oldProps)) return "".concat(triggerName, ".").concat(key, " added");
        const changed = comparePropValues(newProps[key], oldProps[key], propTypes[key]);
        if (changed) return "".concat(triggerName, ".").concat(key, " ").concat(changed);
    }
    for (const key1 of Object.keys(oldProps))if (!(key1 in ignoreProps)) {
        if (!(key1 in newProps)) return "".concat(triggerName, ".").concat(key1, " dropped");
        if (!Object.hasOwnProperty.call(newProps, key1)) {
            const changed1 = comparePropValues(newProps[key1], oldProps[key1], propTypes[key1]);
            if (changed1) return "".concat(triggerName, ".").concat(key1, " ").concat(changed1);
        }
    }
    return false;
}
function comparePropValues(newProp, oldProp, propType) {
    let equal = propType && propType.equal;
    if (equal && !equal(newProp, oldProp, propType)) return "changed deeply";
    if (!equal) {
        equal = newProp && oldProp && newProp.equals;
        if (equal && !equal.call(newProp, oldProp)) return "changed deeply";
    }
    if (!equal && oldProp !== newProp) return "changed shallowly";
    return null;
}
function diffDataProps(props, oldProps) {
    if (oldProps === null) return "oldProps is null, initial diff";
    let dataChanged = false;
    const { dataComparator , _dataDiff  } = props;
    if (dataComparator) {
        if (!dataComparator(props.data, oldProps.data)) dataChanged = "Data comparator detected a change";
    } else if (props.data !== oldProps.data) dataChanged = "A new data container was supplied";
    if (dataChanged && _dataDiff) dataChanged = _dataDiff(props.data, oldProps.data) || dataChanged;
    return dataChanged;
}
function diffUpdateTriggers(props, oldProps) {
    if (oldProps === null) return {
        all: true
    };
    if ("all" in props.updateTriggers) {
        const diffReason = diffUpdateTrigger(props, oldProps, "all");
        if (diffReason) return {
            all: true
        };
    }
    const reason = {};
    let changed = false;
    for(const triggerName in props.updateTriggers)if (triggerName !== "all") {
        const diffReason1 = diffUpdateTrigger(props, oldProps, triggerName);
        if (diffReason1) {
            reason[triggerName] = true;
            changed = true;
        }
    }
    return changed ? reason : false;
}
function diffExtensions(props, oldProps) {
    if (oldProps === null) return true;
    const oldExtensions = oldProps.extensions;
    const { extensions  } = props;
    if (extensions === oldExtensions) return false;
    if (!oldExtensions || !extensions) return true;
    if (extensions.length !== oldExtensions.length) return true;
    for(let i = 0; i < extensions.length; i++){
        if (!extensions[i].equals(oldExtensions[i])) return true;
    }
    return false;
}
function diffUpdateTrigger(props, oldProps, triggerName) {
    let newTriggers = props.updateTriggers[triggerName];
    newTriggers = newTriggers === undefined || newTriggers === null ? {} : newTriggers;
    let oldTriggers = oldProps.updateTriggers[triggerName];
    oldTriggers = oldTriggers === undefined || oldTriggers === null ? {} : oldTriggers;
    const diffReason = compareProps({
        oldProps: oldTriggers,
        newProps: newTriggers,
        triggerName
    });
    return diffReason;
}
function getPropTypes(props) {
    const layer = props[0, _constants.COMPONENT_SYMBOL];
    const LayerType = layer && layer.constructor;
    return LayerType ? LayerType._propTypes : {};
}

},{"./constants":"99KhZ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"66RBf":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "count", ()=>count);
const ERR_NOT_OBJECT = "count(): argument not an object";
const ERR_NOT_CONTAINER = "count(): argument not a container";
function count(container) {
    if (!isObject(container)) throw new Error(ERR_NOT_OBJECT);
    if (typeof container.count === "function") return container.count();
    if (Number.isFinite(container.size)) return container.size;
    if (Number.isFinite(container.length)) return container.length;
    if (isPlainObject(container)) return Object.keys(container).length;
    throw new Error(ERR_NOT_CONTAINER);
}
function isPlainObject(value) {
    return value !== null && typeof value === "object" && value.constructor === Object;
}
function isObject(value) {
    return value !== null && typeof value === "object";
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"4B3So":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "mergeShaders", ()=>mergeShaders);
function mergeShaders(target, source) {
    if (!source) return target;
    const result = {
        ...target,
        ...source
    };
    if ("defines" in source) result.defines = {
        ...target.defines,
        ...source.defines
    };
    if ("modules" in source) {
        result.modules = (target.modules || []).concat(source.modules);
        if (source.modules.some((module)=>module.name === "project64")) {
            const index = result.modules.findIndex((module)=>module.name === "project32");
            if (index >= 0) result.modules.splice(index, 1);
        }
    }
    if ("inject" in source) {
        if (!target.inject) result.inject = source.inject;
        else {
            const mergedInjection = {
                ...target.inject
            };
            for(const key in source.inject)mergedInjection[key] = (mergedInjection[key] || "") + source.inject[key];
            result.inject = mergedInjection;
        }
    }
    return result;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"8KMOU":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getWorldPosition", ()=>getWorldPosition);
parcelHelpers.export(exports, "projectPosition", ()=>projectPosition);
var _constants = require("../../lib/constants");
var _viewportUniforms = require("./viewport-uniforms");
var _webMercatorViewport = require("../../viewports/web-mercator-viewport");
var _webMercatorViewportDefault = parcelHelpers.interopDefault(_webMercatorViewport);
var _vec4 = require("gl-matrix/vec4");
var _vec3 = require("gl-matrix/vec3");
var _webMercator = require("@math.gl/web-mercator");
function lngLatZToWorldPosition(lngLatZ, viewport, offsetMode = false) {
    const p = viewport.projectPosition(lngLatZ);
    if (offsetMode && viewport instanceof (0, _webMercatorViewportDefault.default)) {
        const [longitude, latitude, z = 0] = lngLatZ;
        const distanceScales = viewport.getDistanceScales([
            longitude,
            latitude
        ]);
        p[2] = z * distanceScales.unitsPerMeter[2];
    }
    return p;
}
function normalizeParameters(opts) {
    const { viewport , modelMatrix , coordinateOrigin  } = opts;
    let { coordinateSystem , fromCoordinateSystem , fromCoordinateOrigin  } = opts;
    if (coordinateSystem === (0, _constants.COORDINATE_SYSTEM).DEFAULT) coordinateSystem = viewport.isGeospatial ? (0, _constants.COORDINATE_SYSTEM).LNGLAT : (0, _constants.COORDINATE_SYSTEM).CARTESIAN;
    if (fromCoordinateSystem === undefined) fromCoordinateSystem = coordinateSystem;
    if (fromCoordinateOrigin === undefined) fromCoordinateOrigin = coordinateOrigin;
    return {
        viewport,
        coordinateSystem,
        coordinateOrigin,
        modelMatrix,
        fromCoordinateSystem,
        fromCoordinateOrigin
    };
}
function getWorldPosition(position, { viewport , modelMatrix , coordinateSystem , coordinateOrigin , offsetMode  }) {
    let [x, y, z = 0] = position;
    if (modelMatrix) [x, y, z] = _vec4.transformMat4([], [
        x,
        y,
        z,
        1.0
    ], modelMatrix);
    switch(coordinateSystem){
        case (0, _constants.COORDINATE_SYSTEM).LNGLAT:
            return lngLatZToWorldPosition([
                x,
                y,
                z
            ], viewport, offsetMode);
        case (0, _constants.COORDINATE_SYSTEM).LNGLAT_OFFSETS:
            return lngLatZToWorldPosition([
                x + coordinateOrigin[0],
                y + coordinateOrigin[1],
                z + (coordinateOrigin[2] || 0)
            ], viewport, offsetMode);
        case (0, _constants.COORDINATE_SYSTEM).METER_OFFSETS:
            return lngLatZToWorldPosition((0, _webMercator.addMetersToLngLat)(coordinateOrigin, [
                x,
                y,
                z
            ]), viewport, offsetMode);
        case (0, _constants.COORDINATE_SYSTEM).CARTESIAN:
        default:
            return viewport.isGeospatial ? [
                x + coordinateOrigin[0],
                y + coordinateOrigin[1],
                z + coordinateOrigin[2]
            ] : viewport.projectPosition([
                x,
                y,
                z
            ]);
    }
}
function projectPosition(position, params) {
    const { viewport , coordinateSystem , coordinateOrigin , modelMatrix , fromCoordinateSystem , fromCoordinateOrigin  } = normalizeParameters(params);
    const { geospatialOrigin , shaderCoordinateOrigin , offsetMode  } = (0, _viewportUniforms.getOffsetOrigin)(viewport, coordinateSystem, coordinateOrigin);
    const worldPosition = getWorldPosition(position, {
        viewport,
        modelMatrix,
        coordinateSystem: fromCoordinateSystem,
        coordinateOrigin: fromCoordinateOrigin,
        offsetMode
    });
    if (offsetMode) {
        const positionCommonSpace = viewport.projectPosition(geospatialOrigin || shaderCoordinateOrigin);
        _vec3.sub(worldPosition, worldPosition, positionCommonSpace);
    }
    return worldPosition;
}

},{"../../lib/constants":"ksWme","./viewport-uniforms":"jPtIW","../../viewports/web-mercator-viewport":"cVyIy","gl-matrix/vec4":"lplGD","gl-matrix/vec3":"6mCNm","@math.gl/web-mercator":"aEEkN","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2mVN7":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _constants = require("./constants");
var _createProps = require("./create-props");
let counter = 0;
class Component {
    constructor(...propObjects){
        (0, _definePropertyDefault.default)(this, "id", void 0);
        (0, _definePropertyDefault.default)(this, "props", void 0);
        (0, _definePropertyDefault.default)(this, "count", void 0);
        this.props = (0, _createProps.createProps)(this, propObjects);
        this.id = this.props.id;
        this.count = counter++;
    }
    clone(newProps) {
        const { props  } = this;
        const asyncProps = {};
        for(const key in props[0, _constants.ASYNC_DEFAULTS_SYMBOL]){
            if (key in props[0, _constants.ASYNC_RESOLVED_SYMBOL]) asyncProps[key] = props[0, _constants.ASYNC_RESOLVED_SYMBOL][key];
            else if (key in props[0, _constants.ASYNC_ORIGINAL_SYMBOL]) asyncProps[key] = props[0, _constants.ASYNC_ORIGINAL_SYMBOL][key];
        }
        return new this.constructor({
            ...props,
            ...asyncProps,
            ...newProps
        });
    }
}
exports.default = Component;
(0, _definePropertyDefault.default)(Component, "componentName", "Component");
(0, _definePropertyDefault.default)(Component, "defaultProps", {});

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./constants":"99KhZ","./create-props":"93k5q","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"93k5q":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "createProps", ()=>createProps);
var _log = require("../utils/log");
var _logDefault = parcelHelpers.interopDefault(_log);
var _iterableUtils = require("../utils/iterable-utils");
var _propTypes = require("./prop-types");
var _constants = require("./constants");
function createProps(component, propObjects) {
    const propsPrototype = getPropsPrototype(component.constructor);
    const propsInstance = Object.create(propsPrototype);
    propsInstance[0, _constants.COMPONENT_SYMBOL] = component;
    propsInstance[0, _constants.ASYNC_ORIGINAL_SYMBOL] = {};
    propsInstance[0, _constants.ASYNC_RESOLVED_SYMBOL] = {};
    for(let i = 0; i < propObjects.length; ++i){
        const props = propObjects[i];
        for(const key in props)propsInstance[key] = props[key];
    }
    Object.freeze(propsInstance);
    return propsInstance;
}
function getPropsPrototype(componentClass) {
    const defaultProps = getOwnProperty(componentClass, "_mergedDefaultProps");
    if (!defaultProps) {
        createPropsPrototypeAndTypes(componentClass);
        return componentClass._mergedDefaultProps;
    }
    return defaultProps;
}
function createPropsPrototypeAndTypes(componentClass) {
    const parent = componentClass.prototype;
    if (!parent) return;
    const parentClass = Object.getPrototypeOf(componentClass);
    const parentDefaultProps = getPropsPrototype(parentClass);
    const componentDefaultProps = getOwnProperty(componentClass, "defaultProps") || {};
    const componentPropDefs = (0, _propTypes.parsePropTypes)(componentDefaultProps);
    const defaultProps = createPropsPrototype(componentPropDefs.defaultProps, parentDefaultProps, componentClass);
    const propTypes = {
        ...parentClass._propTypes,
        ...componentPropDefs.propTypes
    };
    addAsyncPropsToPropPrototype(defaultProps, propTypes);
    const deprecatedProps = {
        ...parentClass._deprecatedProps,
        ...componentPropDefs.deprecatedProps
    };
    addDeprecatedPropsToPropPrototype(defaultProps, deprecatedProps);
    componentClass._mergedDefaultProps = defaultProps;
    componentClass._propTypes = propTypes;
    componentClass._deprecatedProps = deprecatedProps;
}
function createPropsPrototype(props, parentProps, componentClass) {
    const defaultProps = Object.create(null);
    Object.assign(defaultProps, parentProps, props);
    const id = getComponentName(componentClass);
    delete props.id;
    Object.defineProperties(defaultProps, {
        id: {
            writable: true,
            value: id
        }
    });
    return defaultProps;
}
function addDeprecatedPropsToPropPrototype(defaultProps, deprecatedProps) {
    for(const propName in deprecatedProps)Object.defineProperty(defaultProps, propName, {
        enumerable: false,
        set (newValue) {
            const nameStr = "".concat(this.id, ": ").concat(propName);
            for (const newPropName of deprecatedProps[propName])if (!hasOwnProperty(this, newPropName)) this[newPropName] = newValue;
            (0, _logDefault.default).deprecated(nameStr, deprecatedProps[propName].join("/"))();
        }
    });
}
function addAsyncPropsToPropPrototype(defaultProps, propTypes) {
    const defaultValues = {};
    const descriptors = {};
    for(const propName in propTypes){
        const propType = propTypes[propName];
        const { name , value  } = propType;
        if (propType.async) {
            defaultValues[name] = value;
            descriptors[name] = getDescriptorForAsyncProp(name);
        }
    }
    defaultProps[0, _constants.ASYNC_DEFAULTS_SYMBOL] = defaultValues;
    defaultProps[0, _constants.ASYNC_ORIGINAL_SYMBOL] = {};
    Object.defineProperties(defaultProps, descriptors);
}
function getDescriptorForAsyncProp(name) {
    return {
        enumerable: true,
        set (newValue) {
            if (typeof newValue === "string" || newValue instanceof Promise || (0, _iterableUtils.isAsyncIterable)(newValue)) this[0, _constants.ASYNC_ORIGINAL_SYMBOL][name] = newValue;
            else this[0, _constants.ASYNC_RESOLVED_SYMBOL][name] = newValue;
        },
        get () {
            if (this[0, _constants.ASYNC_RESOLVED_SYMBOL]) {
                if (name in this[0, _constants.ASYNC_RESOLVED_SYMBOL]) {
                    const value = this[0, _constants.ASYNC_RESOLVED_SYMBOL][name];
                    return value || this[0, _constants.ASYNC_DEFAULTS_SYMBOL][name];
                }
                if (name in this[0, _constants.ASYNC_ORIGINAL_SYMBOL]) {
                    const state = this[0, _constants.COMPONENT_SYMBOL] && this[0, _constants.COMPONENT_SYMBOL].internalState;
                    if (state && state.hasAsyncProp(name)) return state.getAsyncProp(name) || this[0, _constants.ASYNC_DEFAULTS_SYMBOL][name];
                }
            }
            return this[0, _constants.ASYNC_DEFAULTS_SYMBOL][name];
        }
    };
}
function hasOwnProperty(object, prop) {
    return Object.prototype.hasOwnProperty.call(object, prop);
}
function getOwnProperty(object, prop) {
    return hasOwnProperty(object, prop) && object[prop];
}
function getComponentName(componentClass) {
    const componentName = getOwnProperty(componentClass, "layerName") || getOwnProperty(componentClass, "componentName");
    if (!componentName) (0, _logDefault.default).once(0, "".concat(componentClass.name, ".componentName not specified"))();
    return componentName || componentClass.name;
}

},{"../utils/log":"iINk7","../utils/iterable-utils":"6frHT","./prop-types":"dmBpY","./constants":"99KhZ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dmBpY":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "parsePropTypes", ()=>parsePropTypes);
var _texture = require("../utils/texture");
var _deepEqual = require("../utils/deep-equal");
const TYPE_DEFINITIONS = {
    boolean: {
        validate (value, propType) {
            return true;
        },
        equal (value1, value2, propType) {
            return Boolean(value1) === Boolean(value2);
        }
    },
    number: {
        validate (value, propType) {
            return Number.isFinite(value) && (!("max" in propType) || value <= propType.max) && (!("min" in propType) || value >= propType.min);
        }
    },
    color: {
        validate (value, propType) {
            return propType.optional && !value || isArray(value) && (value.length === 3 || value.length === 4);
        },
        equal (value1, value2, propType) {
            return arrayEqual(value1, value2);
        }
    },
    accessor: {
        validate (value, propType) {
            const valueType = getTypeOf(value);
            return valueType === "function" || valueType === getTypeOf(propType.value);
        },
        equal (value1, value2, propType) {
            if (typeof value2 === "function") return true;
            return arrayEqual(value1, value2);
        }
    },
    array: {
        validate (value, propType) {
            return propType.optional && !value || isArray(value);
        },
        equal (value1, value2, propType) {
            return propType.compare ? arrayEqual(value1, value2) : value1 === value2;
        }
    },
    object: {
        equal (value1, value2, propType) {
            return propType.compare ? (0, _deepEqual.deepEqual)(value1, value2) : value1 === value2;
        }
    },
    function: {
        validate (value, propType) {
            return propType.optional && !value || typeof value === "function";
        },
        equal (value1, value2, propType) {
            return !propType.compare || value1 === value2;
        }
    },
    data: {
        transform: (value, propType, component)=>{
            const { dataTransform  } = component.props;
            return dataTransform && value ? dataTransform(value) : value;
        }
    },
    image: {
        transform: (value, propType, component)=>{
            return (0, _texture.createTexture)(component, value);
        },
        release: (value)=>{
            (0, _texture.destroyTexture)(value);
        }
    }
};
function arrayEqual(array1, array2) {
    if (array1 === array2) return true;
    if (!isArray(array1) || !isArray(array2)) return false;
    const len = array1.length;
    if (len !== array2.length) return false;
    for(let i = 0; i < len; i++){
        if (array1[i] !== array2[i]) return false;
    }
    return true;
}
function parsePropTypes(propDefs) {
    const propTypes = {};
    const defaultProps = {};
    const deprecatedProps = {};
    for (const [propName, propDef] of Object.entries(propDefs)){
        const deprecated = propDef === null || propDef === void 0 ? void 0 : propDef.deprecatedFor;
        if (deprecated) deprecatedProps[propName] = Array.isArray(deprecated) ? deprecated : [
            deprecated
        ];
        else {
            const propType = parsePropType(propName, propDef);
            propTypes[propName] = propType;
            defaultProps[propName] = propType.value;
        }
    }
    return {
        propTypes,
        defaultProps,
        deprecatedProps
    };
}
function parsePropType(name, propDef) {
    switch(getTypeOf(propDef)){
        case "object":
            return normalizePropDefinition(name, propDef);
        case "array":
            return normalizePropDefinition(name, {
                type: "array",
                value: propDef,
                compare: false
            });
        case "boolean":
            return normalizePropDefinition(name, {
                type: "boolean",
                value: propDef
            });
        case "number":
            return normalizePropDefinition(name, {
                type: "number",
                value: propDef
            });
        case "function":
            return normalizePropDefinition(name, {
                type: "function",
                value: propDef,
                compare: true
            });
        default:
            return {
                name,
                type: "unknown",
                value: propDef
            };
    }
}
function normalizePropDefinition(name, propDef) {
    if (!("type" in propDef)) {
        if (!("value" in propDef)) return {
            name,
            type: "object",
            value: propDef
        };
        return {
            name,
            type: getTypeOf(propDef.value),
            ...propDef
        };
    }
    return {
        name,
        ...TYPE_DEFINITIONS[propDef.type],
        ...propDef
    };
}
function isArray(value) {
    return Array.isArray(value) || ArrayBuffer.isView(value);
}
function getTypeOf(value) {
    if (isArray(value)) return "array";
    if (value === null) return "null";
    return typeof value;
}

},{"../utils/texture":"gf7Q9","../utils/deep-equal":"cspiV","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gf7Q9":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "createTexture", ()=>createTexture);
parcelHelpers.export(exports, "destroyTexture", ()=>destroyTexture);
var _core = require("@luma.gl/core");
const DEFAULT_TEXTURE_PARAMETERS = {
    [10241]: 9987,
    [10240]: 9729,
    [10242]: 33071,
    [10243]: 33071
};
const internalTextures = {};
function createTexture(layer, image) {
    const gl = layer.context && layer.context.gl;
    if (!gl || !image) return null;
    if (image instanceof (0, _core.Texture2D)) return image;
    else if (image.constructor && image.constructor.name !== "Object") image = {
        data: image
    };
    let specialTextureParameters = null;
    if (image.compressed) specialTextureParameters = {
        [10241]: image.data.length > 1 ? 9985 : 9729
    };
    const texture = new (0, _core.Texture2D)(gl, {
        ...image,
        parameters: {
            ...DEFAULT_TEXTURE_PARAMETERS,
            ...specialTextureParameters,
            ...layer.props.textureParameters
        }
    });
    internalTextures[texture.id] = true;
    return texture;
}
function destroyTexture(texture) {
    if (!texture || !(texture instanceof (0, _core.Texture2D))) return;
    if (internalTextures[texture.id]) {
        texture.delete();
        delete internalTextures[texture.id];
    }
}

},{"@luma.gl/core":"9yA57","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"7fPJ1":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _componentState = require("../lifecycle/component-state");
var _componentStateDefault = parcelHelpers.interopDefault(_componentState);
class LayerState extends (0, _componentStateDefault.default) {
    constructor({ attributeManager , layer  }){
        super(layer);
        (0, _definePropertyDefault.default)(this, "attributeManager", void 0);
        (0, _definePropertyDefault.default)(this, "needsRedraw", void 0);
        (0, _definePropertyDefault.default)(this, "needsUpdate", void 0);
        (0, _definePropertyDefault.default)(this, "subLayers", void 0);
        (0, _definePropertyDefault.default)(this, "usesPickingColorCache", void 0);
        (0, _definePropertyDefault.default)(this, "changeFlags", void 0);
        (0, _definePropertyDefault.default)(this, "viewport", void 0);
        (0, _definePropertyDefault.default)(this, "uniformTransitions", void 0);
        (0, _definePropertyDefault.default)(this, "propsInTransition", void 0);
        this.attributeManager = attributeManager;
        this.needsRedraw = true;
        this.needsUpdate = true;
        this.subLayers = null;
        this.usesPickingColorCache = false;
    }
    get layer() {
        return this.component;
    }
    set layer(layer) {
        this.component = layer;
    }
    _fetch(propName, url) {
        const fetch = this.component.props.fetch;
        if (fetch) return fetch(url, {
            propName,
            layer: this.layer
        });
        return super._fetch(propName, url);
    }
    _onResolve(propName, value) {
        const onDataLoad = this.component.props.onDataLoad;
        if (propName === "data" && onDataLoad) onDataLoad(value, {
            propName,
            layer: this.layer
        });
    }
    _onError(propName, error) {
        this.layer.raiseError(error, "loading ".concat(propName, " of ").concat(this.layer));
    }
}
exports.default = LayerState;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../lifecycle/component-state":"1mg7Z","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1mg7Z":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _iterableUtils = require("../utils/iterable-utils");
var _constants = require("./constants");
const EMPTY_PROPS = Object.freeze({});
class ComponentState {
    constructor(component){
        (0, _definePropertyDefault.default)(this, "component", void 0);
        (0, _definePropertyDefault.default)(this, "onAsyncPropUpdated", void 0);
        (0, _definePropertyDefault.default)(this, "asyncProps", void 0);
        (0, _definePropertyDefault.default)(this, "oldProps", void 0);
        (0, _definePropertyDefault.default)(this, "oldAsyncProps", void 0);
        this.component = component;
        this.asyncProps = {};
        this.onAsyncPropUpdated = ()=>{};
        this.oldProps = null;
        this.oldAsyncProps = null;
    }
    finalize() {
        for(const propName in this.asyncProps){
            const asyncProp = this.asyncProps[propName];
            if (asyncProp && asyncProp.type && asyncProp.type.release) asyncProp.type.release(asyncProp.resolvedValue, asyncProp.type, this.component);
        }
    }
    getOldProps() {
        return this.oldAsyncProps || this.oldProps || EMPTY_PROPS;
    }
    resetOldProps() {
        this.oldAsyncProps = null;
        this.oldProps = this.component.props;
    }
    hasAsyncProp(propName) {
        return propName in this.asyncProps;
    }
    getAsyncProp(propName) {
        const asyncProp = this.asyncProps[propName];
        return asyncProp && asyncProp.resolvedValue;
    }
    isAsyncPropLoading(propName) {
        if (propName) {
            const asyncProp = this.asyncProps[propName];
            return Boolean(asyncProp && asyncProp.pendingLoadCount > 0 && asyncProp.pendingLoadCount !== asyncProp.resolvedLoadCount);
        }
        for(const key in this.asyncProps){
            if (this.isAsyncPropLoading(key)) return true;
        }
        return false;
    }
    reloadAsyncProp(propName, value) {
        this._watchPromise(propName, Promise.resolve(value));
    }
    setAsyncProps(props) {
        const resolvedValues = props[0, _constants.ASYNC_RESOLVED_SYMBOL] || {};
        const originalValues = props[0, _constants.ASYNC_ORIGINAL_SYMBOL] || props;
        const defaultValues = props[0, _constants.ASYNC_DEFAULTS_SYMBOL] || {};
        for(const propName in resolvedValues){
            const value = resolvedValues[propName];
            this._createAsyncPropData(propName, defaultValues[propName]);
            this._updateAsyncProp(propName, value);
            resolvedValues[propName] = this.getAsyncProp(propName);
        }
        for(const propName1 in originalValues){
            const value1 = originalValues[propName1];
            this._createAsyncPropData(propName1, defaultValues[propName1]);
            this._updateAsyncProp(propName1, value1);
        }
    }
    _fetch(propName, url) {
        return null;
    }
    _onResolve(propName, value) {}
    _onError(propName, error) {}
    _updateAsyncProp(propName, value) {
        if (!this._didAsyncInputValueChange(propName, value)) return;
        if (typeof value === "string") value = this._fetch(propName, value);
        if (value instanceof Promise) {
            this._watchPromise(propName, value);
            return;
        }
        if ((0, _iterableUtils.isAsyncIterable)(value)) {
            this._resolveAsyncIterable(propName, value);
            return;
        }
        this._setPropValue(propName, value);
    }
    _freezeAsyncOldProps() {
        if (!this.oldAsyncProps && this.oldProps) {
            this.oldAsyncProps = Object.create(this.oldProps);
            for(const propName in this.asyncProps)Object.defineProperty(this.oldAsyncProps, propName, {
                enumerable: true,
                value: this.oldProps[propName]
            });
        }
    }
    _didAsyncInputValueChange(propName, value) {
        const asyncProp = this.asyncProps[propName];
        if (value === asyncProp.resolvedValue || value === asyncProp.lastValue) return false;
        asyncProp.lastValue = value;
        return true;
    }
    _setPropValue(propName, value) {
        this._freezeAsyncOldProps();
        const asyncProp = this.asyncProps[propName];
        if (asyncProp) {
            value = this._postProcessValue(asyncProp, value);
            asyncProp.resolvedValue = value;
            asyncProp.pendingLoadCount++;
            asyncProp.resolvedLoadCount = asyncProp.pendingLoadCount;
        }
    }
    _setAsyncPropValue(propName, value, loadCount) {
        const asyncProp = this.asyncProps[propName];
        if (asyncProp && loadCount >= asyncProp.resolvedLoadCount && value !== undefined) {
            this._freezeAsyncOldProps();
            asyncProp.resolvedValue = value;
            asyncProp.resolvedLoadCount = loadCount;
            this.onAsyncPropUpdated(propName, value);
        }
    }
    _watchPromise(propName, promise) {
        const asyncProp = this.asyncProps[propName];
        if (asyncProp) {
            asyncProp.pendingLoadCount++;
            const loadCount = asyncProp.pendingLoadCount;
            promise.then((data)=>{
                data = this._postProcessValue(asyncProp, data);
                this._setAsyncPropValue(propName, data, loadCount);
                this._onResolve(propName, data);
            }).catch((error)=>{
                this._onError(propName, error);
            });
        }
    }
    async _resolveAsyncIterable(propName, iterable) {
        if (propName !== "data") {
            this._setPropValue(propName, iterable);
            return;
        }
        const asyncProp = this.asyncProps[propName];
        if (!asyncProp) return;
        asyncProp.pendingLoadCount++;
        const loadCount = asyncProp.pendingLoadCount;
        let data = [];
        let count = 0;
        for await (const chunk of iterable){
            const { dataTransform  } = this.component.props;
            if (dataTransform) data = dataTransform(chunk, data);
            else data = data.concat(chunk);
            Object.defineProperty(data, "__diff", {
                enumerable: false,
                value: [
                    {
                        startRow: count,
                        endRow: data.length
                    }
                ]
            });
            count = data.length;
            this._setAsyncPropValue(propName, data, loadCount);
        }
        this._onResolve(propName, data);
    }
    _postProcessValue(asyncProp, value) {
        const propType = asyncProp.type;
        if (propType) {
            if (propType.release) propType.release(asyncProp.resolvedValue, propType, this.component);
            if (propType.transform) return propType.transform(value, propType, this.component);
        }
        return value;
    }
    _createAsyncPropData(propName, defaultValue) {
        const asyncProp = this.asyncProps[propName];
        if (!asyncProp) {
            const propTypes = this.component && this.component.constructor._propTypes;
            this.asyncProps[propName] = {
                type: propTypes && propTypes[propName],
                lastValue: null,
                resolvedValue: defaultValue,
                pendingLoadCount: 0,
                resolvedLoadCount: 0
            };
        }
    }
}
exports.default = ComponentState;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","../utils/iterable-utils":"6frHT","./constants":"99KhZ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lmfmq":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _iterableUtils = require("./iterable-utils");
var _typedArrayManager = require("./typed-array-manager");
var _typedArrayManagerDefault = parcelHelpers.interopDefault(_typedArrayManager);
var _assert = require("./assert");
var _assertDefault = parcelHelpers.interopDefault(_assert);
var _webgl = require("@luma.gl/webgl");
class Tesselator {
    constructor(opts){
        (0, _definePropertyDefault.default)(this, "opts", void 0);
        (0, _definePropertyDefault.default)(this, "typedArrayManager", void 0);
        (0, _definePropertyDefault.default)(this, "indexStarts", [
            0
        ]);
        (0, _definePropertyDefault.default)(this, "vertexStarts", [
            0
        ]);
        (0, _definePropertyDefault.default)(this, "vertexCount", 0);
        (0, _definePropertyDefault.default)(this, "instanceCount", 0);
        (0, _definePropertyDefault.default)(this, "attributes", void 0);
        (0, _definePropertyDefault.default)(this, "_attributeDefs", void 0);
        (0, _definePropertyDefault.default)(this, "data", void 0);
        (0, _definePropertyDefault.default)(this, "getGeometry", void 0);
        (0, _definePropertyDefault.default)(this, "geometryBuffer", void 0);
        (0, _definePropertyDefault.default)(this, "buffers", void 0);
        (0, _definePropertyDefault.default)(this, "positionSize", void 0);
        (0, _definePropertyDefault.default)(this, "normalize", void 0);
        const { attributes ={}  } = opts;
        this.typedArrayManager = (0, _typedArrayManagerDefault.default);
        this.attributes = {};
        this._attributeDefs = attributes;
        this.opts = opts;
        this.updateGeometry(opts);
    }
    updateGeometry(opts) {
        Object.assign(this.opts, opts);
        const { data , buffers ={} , getGeometry , geometryBuffer , positionFormat , dataChanged , normalize =true  } = this.opts;
        this.data = data;
        this.getGeometry = getGeometry;
        this.positionSize = geometryBuffer && geometryBuffer.size || (positionFormat === "XY" ? 2 : 3);
        this.buffers = buffers;
        this.normalize = normalize;
        if (geometryBuffer) {
            (0, _assertDefault.default)(data.startIndices);
            this.getGeometry = this.getGeometryFromBuffer(geometryBuffer);
            if (!normalize) buffers.positions = geometryBuffer;
        }
        this.geometryBuffer = buffers.positions;
        if (Array.isArray(dataChanged)) for (const dataRange of dataChanged)this._rebuildGeometry(dataRange);
        else this._rebuildGeometry();
    }
    updatePartialGeometry({ startRow , endRow  }) {
        this._rebuildGeometry({
            startRow,
            endRow
        });
    }
    getGeometryFromBuffer(geometryBuffer) {
        const value = geometryBuffer.value || geometryBuffer;
        if (!ArrayBuffer.isView(value)) return null;
        return (0, _iterableUtils.getAccessorFromBuffer)(value, {
            size: this.positionSize,
            offset: geometryBuffer.offset,
            stride: geometryBuffer.stride,
            startIndices: this.data.startIndices
        });
    }
    _allocate(instanceCount, copy) {
        const { attributes , buffers , _attributeDefs , typedArrayManager  } = this;
        for(const name in _attributeDefs)if (name in buffers) {
            typedArrayManager.release(attributes[name]);
            attributes[name] = null;
        } else {
            const def = _attributeDefs[name];
            def.copy = copy;
            attributes[name] = typedArrayManager.allocate(attributes[name], instanceCount, def);
        }
    }
    _forEachGeometry(visitor, startRow, endRow) {
        const { data , getGeometry  } = this;
        const { iterable , objectInfo  } = (0, _iterableUtils.createIterable)(data, startRow, endRow);
        for (const object of iterable){
            objectInfo.index++;
            const geometry = getGeometry ? getGeometry(object, objectInfo) : null;
            visitor(geometry, objectInfo.index);
        }
    }
    _rebuildGeometry(dataRange) {
        if (!this.data) return;
        let { indexStarts , vertexStarts , instanceCount  } = this;
        const { data , geometryBuffer  } = this;
        const { startRow =0 , endRow =Infinity  } = dataRange || {};
        const normalizedData = {};
        if (!dataRange) {
            indexStarts = [
                0
            ];
            vertexStarts = [
                0
            ];
        }
        if (this.normalize || !geometryBuffer) {
            this._forEachGeometry((geometry, dataIndex)=>{
                const normalizedGeometry = geometry && this.normalizeGeometry(geometry);
                normalizedData[dataIndex] = normalizedGeometry;
                vertexStarts[dataIndex + 1] = vertexStarts[dataIndex] + (normalizedGeometry ? this.getGeometrySize(normalizedGeometry) : 0);
            }, startRow, endRow);
            instanceCount = vertexStarts[vertexStarts.length - 1];
        } else {
            vertexStarts = data.startIndices;
            instanceCount = vertexStarts[data.length] || 0;
            if (ArrayBuffer.isView(geometryBuffer)) instanceCount = instanceCount || geometryBuffer.length / this.positionSize;
            else if (geometryBuffer instanceof (0, _webgl.Buffer)) {
                const byteStride = geometryBuffer.accessor.stride || this.positionSize * 4;
                instanceCount = instanceCount || geometryBuffer.byteLength / byteStride;
            } else if (geometryBuffer.buffer) {
                const byteStride1 = geometryBuffer.stride || this.positionSize * 4;
                instanceCount = instanceCount || geometryBuffer.buffer.byteLength / byteStride1;
            } else if (geometryBuffer.value) {
                const bufferValue = geometryBuffer.value;
                const elementStride = geometryBuffer.stride / bufferValue.BYTES_PER_ELEMENT || this.positionSize;
                instanceCount = instanceCount || bufferValue.length / elementStride;
            }
        }
        this._allocate(instanceCount, Boolean(dataRange));
        this.indexStarts = indexStarts;
        this.vertexStarts = vertexStarts;
        this.instanceCount = instanceCount;
        const context = {};
        this._forEachGeometry((geometry, dataIndex)=>{
            const normalizedGeometry = normalizedData[dataIndex] || geometry;
            context.vertexStart = vertexStarts[dataIndex];
            context.indexStart = indexStarts[dataIndex];
            const vertexEnd = dataIndex < vertexStarts.length - 1 ? vertexStarts[dataIndex + 1] : instanceCount;
            context.geometrySize = vertexEnd - vertexStarts[dataIndex];
            context.geometryIndex = dataIndex;
            this.updateGeometryAttributes(normalizedGeometry, context);
        }, startRow, endRow);
        this.vertexCount = indexStarts[indexStarts.length - 1];
    }
}
exports.default = Tesselator;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","./iterable-utils":"6frHT","./typed-array-manager":"kyraM","./assert":"aysGh","@luma.gl/webgl":"4LrGo","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2mJad":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@deck.gl/core");
var _core1 = require("@luma.gl/core");
var _polygonTesselator = require("./polygon-tesselator");
var _polygonTesselatorDefault = parcelHelpers.interopDefault(_polygonTesselator);
var _solidPolygonLayerVertexTopGlsl = require("./solid-polygon-layer-vertex-top.glsl");
var _solidPolygonLayerVertexTopGlslDefault = parcelHelpers.interopDefault(_solidPolygonLayerVertexTopGlsl);
var _solidPolygonLayerVertexSideGlsl = require("./solid-polygon-layer-vertex-side.glsl");
var _solidPolygonLayerVertexSideGlslDefault = parcelHelpers.interopDefault(_solidPolygonLayerVertexSideGlsl);
var _solidPolygonLayerFragmentGlsl = require("./solid-polygon-layer-fragment.glsl");
var _solidPolygonLayerFragmentGlslDefault = parcelHelpers.interopDefault(_solidPolygonLayerFragmentGlsl);
const DEFAULT_COLOR = [
    0,
    0,
    0,
    255
];
const defaultProps = {
    filled: true,
    extruded: false,
    wireframe: false,
    _normalize: true,
    _windingOrder: "CW",
    elevationScale: {
        type: "number",
        min: 0,
        value: 1
    },
    getPolygon: {
        type: "accessor",
        value: (f)=>f.polygon
    },
    getElevation: {
        type: "accessor",
        value: 1000
    },
    getFillColor: {
        type: "accessor",
        value: DEFAULT_COLOR
    },
    getLineColor: {
        type: "accessor",
        value: DEFAULT_COLOR
    },
    material: true
};
const ATTRIBUTE_TRANSITION = {
    enter: (value, chunk)=>{
        return chunk.length ? chunk.subarray(chunk.length - value.length) : value;
    }
};
class SolidPolygonLayer extends (0, _core.Layer) {
    constructor(...args){
        super(...args);
        (0, _definePropertyDefault.default)(this, "state", void 0);
    }
    getShaders(type) {
        return super.getShaders({
            vs: type === "top" ? (0, _solidPolygonLayerVertexTopGlslDefault.default) : (0, _solidPolygonLayerVertexSideGlslDefault.default),
            fs: (0, _solidPolygonLayerFragmentGlslDefault.default),
            defines: {
                RING_WINDING_ORDER_CW: !this.props._normalize && this.props._windingOrder === "CCW" ? 0 : 1
            },
            modules: [
                (0, _core.project32),
                (0, _core.gouraudLighting),
                (0, _core.picking)
            ]
        });
    }
    get wrapLongitude() {
        return false;
    }
    initializeState() {
        const { gl , viewport  } = this.context;
        let { coordinateSystem  } = this.props;
        if (viewport.isGeospatial && coordinateSystem === (0, _core.COORDINATE_SYSTEM).DEFAULT) coordinateSystem = (0, _core.COORDINATE_SYSTEM).LNGLAT;
        this.setState({
            numInstances: 0,
            polygonTesselator: new (0, _polygonTesselatorDefault.default)({
                preproject: coordinateSystem === (0, _core.COORDINATE_SYSTEM).LNGLAT && viewport.projectFlat.bind(viewport),
                fp64: this.use64bitPositions(),
                IndexType: !gl || (0, _core1.hasFeatures)(gl, (0, _core1.FEATURES).ELEMENT_INDEX_UINT32) ? Uint32Array : Uint16Array
            })
        });
        const attributeManager = this.getAttributeManager();
        const noAlloc = true;
        attributeManager.remove([
            "instancePickingColors"
        ]);
        attributeManager.add({
            indices: {
                size: 1,
                isIndexed: true,
                update: this.calculateIndices,
                noAlloc
            },
            positions: {
                size: 3,
                type: 5130,
                fp64: this.use64bitPositions(),
                transition: ATTRIBUTE_TRANSITION,
                accessor: "getPolygon",
                update: this.calculatePositions,
                noAlloc,
                shaderAttributes: {
                    positions: {
                        vertexOffset: 0,
                        divisor: 0
                    },
                    instancePositions: {
                        vertexOffset: 0,
                        divisor: 1
                    },
                    nextPositions: {
                        vertexOffset: 1,
                        divisor: 1
                    }
                }
            },
            vertexValid: {
                size: 1,
                divisor: 1,
                type: 5121,
                update: this.calculateVertexValid,
                noAlloc
            },
            elevations: {
                size: 1,
                transition: ATTRIBUTE_TRANSITION,
                accessor: "getElevation",
                shaderAttributes: {
                    elevations: {
                        divisor: 0
                    },
                    instanceElevations: {
                        divisor: 1
                    }
                }
            },
            fillColors: {
                size: this.props.colorFormat.length,
                type: 5121,
                normalized: true,
                transition: ATTRIBUTE_TRANSITION,
                accessor: "getFillColor",
                defaultValue: DEFAULT_COLOR,
                shaderAttributes: {
                    fillColors: {
                        divisor: 0
                    },
                    instanceFillColors: {
                        divisor: 1
                    }
                }
            },
            lineColors: {
                size: this.props.colorFormat.length,
                type: 5121,
                normalized: true,
                transition: ATTRIBUTE_TRANSITION,
                accessor: "getLineColor",
                defaultValue: DEFAULT_COLOR,
                shaderAttributes: {
                    lineColors: {
                        divisor: 0
                    },
                    instanceLineColors: {
                        divisor: 1
                    }
                }
            },
            pickingColors: {
                size: 3,
                type: 5121,
                accessor: (object, { index , target: value  })=>this.encodePickingColor(object && object.__source ? object.__source.index : index, value),
                shaderAttributes: {
                    pickingColors: {
                        divisor: 0
                    },
                    instancePickingColors: {
                        divisor: 1
                    }
                }
            }
        });
    }
    getPickingInfo(params) {
        const info = super.getPickingInfo(params);
        const { index  } = info;
        const { data  } = this.props;
        if (data[0] && data[0].__source) info.object = data.find((d)=>d.__source.index === index);
        return info;
    }
    disablePickingIndex(objectIndex) {
        const { data  } = this.props;
        if (data[0] && data[0].__source) {
            for(let i = 0; i < data.length; i++)if (data[i].__source.index === objectIndex) this._disablePickingIndex(i);
        } else this._disablePickingIndex(objectIndex);
    }
    draw({ uniforms  }) {
        const { extruded , filled , wireframe , elevationScale  } = this.props;
        const { topModel , sideModel , polygonTesselator  } = this.state;
        const renderUniforms = {
            ...uniforms,
            extruded: Boolean(extruded),
            elevationScale
        };
        if (sideModel) {
            sideModel.setInstanceCount(polygonTesselator.instanceCount - 1);
            sideModel.setUniforms(renderUniforms);
            if (wireframe) {
                sideModel.setDrawMode(3);
                sideModel.setUniforms({
                    isWireframe: true
                }).draw();
            }
            if (filled) {
                sideModel.setDrawMode(6);
                sideModel.setUniforms({
                    isWireframe: false
                }).draw();
            }
        }
        if (topModel) {
            topModel.setVertexCount(polygonTesselator.vertexCount);
            topModel.setUniforms(renderUniforms).draw();
        }
    }
    updateState(updateParams) {
        super.updateState(updateParams);
        this.updateGeometry(updateParams);
        const { props , oldProps , changeFlags  } = updateParams;
        const attributeManager = this.getAttributeManager();
        const regenerateModels = changeFlags.extensionsChanged || props.filled !== oldProps.filled || props.extruded !== oldProps.extruded;
        if (regenerateModels) {
            var _this$state$models;
            (_this$state$models = this.state.models) === null || _this$state$models === void 0 || _this$state$models.forEach((model)=>model.delete());
            this.setState(this._getModels(this.context.gl));
            attributeManager.invalidateAll();
        }
    }
    updateGeometry({ props , oldProps , changeFlags  }) {
        const geometryConfigChanged = changeFlags.dataChanged || changeFlags.updateTriggersChanged && (changeFlags.updateTriggersChanged.all || changeFlags.updateTriggersChanged.getPolygon);
        if (geometryConfigChanged) {
            const { polygonTesselator  } = this.state;
            const buffers = props.data.attributes || {};
            polygonTesselator.updateGeometry({
                data: props.data,
                normalize: props._normalize,
                geometryBuffer: buffers.getPolygon,
                buffers,
                getGeometry: props.getPolygon,
                positionFormat: props.positionFormat,
                wrapLongitude: props.wrapLongitude,
                resolution: this.context.viewport.resolution,
                fp64: this.use64bitPositions(),
                dataChanged: changeFlags.dataChanged
            });
            this.setState({
                numInstances: polygonTesselator.instanceCount,
                startIndices: polygonTesselator.vertexStarts
            });
            if (!changeFlags.dataChanged) this.getAttributeManager().invalidateAll();
        }
    }
    _getModels(gl) {
        const { id , filled , extruded  } = this.props;
        let topModel;
        let sideModel;
        if (filled) {
            const shaders = this.getShaders("top");
            shaders.defines.NON_INSTANCED_MODEL = 1;
            topModel = new (0, _core1.Model)(gl, {
                ...shaders,
                id: "".concat(id, "-top"),
                drawMode: 4,
                attributes: {
                    vertexPositions: new Float32Array([
                        0,
                        1
                    ])
                },
                uniforms: {
                    isWireframe: false,
                    isSideVertex: false
                },
                vertexCount: 0,
                isIndexed: true
            });
        }
        if (extruded) {
            sideModel = new (0, _core1.Model)(gl, {
                ...this.getShaders("side"),
                id: "".concat(id, "-side"),
                geometry: new (0, _core1.Geometry)({
                    drawMode: 1,
                    vertexCount: 4,
                    attributes: {
                        vertexPositions: {
                            size: 2,
                            value: new Float32Array([
                                1,
                                0,
                                0,
                                0,
                                0,
                                1,
                                1,
                                1
                            ])
                        }
                    }
                }),
                instanceCount: 0,
                isInstanced: 1
            });
            sideModel.userData.excludeAttributes = {
                indices: true
            };
        }
        return {
            models: [
                sideModel,
                topModel
            ].filter(Boolean),
            topModel,
            sideModel
        };
    }
    calculateIndices(attribute) {
        const { polygonTesselator  } = this.state;
        attribute.startIndices = polygonTesselator.indexStarts;
        attribute.value = polygonTesselator.get("indices");
    }
    calculatePositions(attribute) {
        const { polygonTesselator  } = this.state;
        attribute.startIndices = polygonTesselator.vertexStarts;
        attribute.value = polygonTesselator.get("positions");
    }
    calculateVertexValid(attribute) {
        attribute.value = this.state.polygonTesselator.get("vertexValid");
    }
}
exports.default = SolidPolygonLayer;
(0, _definePropertyDefault.default)(SolidPolygonLayer, "defaultProps", defaultProps);
(0, _definePropertyDefault.default)(SolidPolygonLayer, "layerName", "SolidPolygonLayer");

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@deck.gl/core":"iErGJ","@luma.gl/core":"9yA57","./polygon-tesselator":"gUFxS","./solid-polygon-layer-vertex-top.glsl":"iRSN8","./solid-polygon-layer-vertex-side.glsl":"floZw","./solid-polygon-layer-fragment.glsl":"bDvSI","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"gUFxS":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _polygon = require("./polygon");
var _core = require("@deck.gl/core");
var _polygon1 = require("@math.gl/polygon");
class PolygonTesselator extends (0, _core.Tesselator) {
    constructor(opts){
        const { fp64 , IndexType =Uint32Array  } = opts;
        super({
            ...opts,
            attributes: {
                positions: {
                    size: 3,
                    type: fp64 ? Float64Array : Float32Array
                },
                vertexValid: {
                    type: Uint8ClampedArray,
                    size: 1
                },
                indices: {
                    type: IndexType,
                    size: 1
                }
            }
        });
    }
    get(attributeName) {
        const { attributes  } = this;
        if (attributeName === "indices") return attributes.indices && attributes.indices.subarray(0, this.vertexCount);
        return attributes[attributeName];
    }
    updateGeometry(opts) {
        super.updateGeometry(opts);
        const externalIndices = this.buffers.indices;
        if (externalIndices) this.vertexCount = (externalIndices.value || externalIndices).length;
        else if (this.data && !this.getGeometry) throw new Error("missing indices buffer");
    }
    normalizeGeometry(polygon) {
        if (this.normalize) {
            const normalizedPolygon = _polygon.normalize(polygon, this.positionSize);
            if (this.opts.resolution) return (0, _polygon1.cutPolygonByGrid)(_polygon.getPositions(normalizedPolygon), _polygon.getHoleIndices(normalizedPolygon), {
                size: this.positionSize,
                gridResolution: this.opts.resolution,
                edgeTypes: true
            });
            if (this.opts.wrapLongitude) return (0, _polygon1.cutPolygonByMercatorBounds)(_polygon.getPositions(normalizedPolygon), _polygon.getHoleIndices(normalizedPolygon), {
                size: this.positionSize,
                maxLatitude: 86,
                edgeTypes: true
            });
            return normalizedPolygon;
        }
        return polygon;
    }
    getGeometrySize(polygon) {
        if (isCut(polygon)) {
            let size = 0;
            for (const subPolygon of polygon)size += this.getGeometrySize(subPolygon);
            return size;
        }
        return _polygon.getPositions(polygon).length / this.positionSize;
    }
    getGeometryFromBuffer(buffer) {
        if (this.normalize || !this.buffers.indices) return super.getGeometryFromBuffer(buffer);
        return null;
    }
    updateGeometryAttributes(polygon, context) {
        if (polygon && isCut(polygon)) for (const subPolygon of polygon){
            const geometrySize = this.getGeometrySize(subPolygon);
            context.geometrySize = geometrySize;
            this.updateGeometryAttributes(subPolygon, context);
            context.vertexStart += geometrySize;
            context.indexStart = this.indexStarts[context.geometryIndex + 1];
        }
        else {
            this._updateIndices(polygon, context);
            this._updatePositions(polygon, context);
            this._updateVertexValid(polygon, context);
        }
    }
    _updateIndices(polygon, { geometryIndex , vertexStart: offset , indexStart  }) {
        const { attributes , indexStarts , typedArrayManager  } = this;
        let target = attributes.indices;
        if (!target || !polygon) return;
        let i = indexStart;
        const indices = _polygon.getSurfaceIndices(polygon, this.positionSize, this.opts.preproject);
        target = typedArrayManager.allocate(target, indexStart + indices.length, {
            copy: true
        });
        for(let j = 0; j < indices.length; j++)target[i++] = indices[j] + offset;
        indexStarts[geometryIndex + 1] = indexStart + indices.length;
        attributes.indices = target;
    }
    _updatePositions(polygon, { vertexStart , geometrySize  }) {
        const { attributes: { positions  } , positionSize  } = this;
        if (!positions || !polygon) return;
        const polygonPositions = _polygon.getPositions(polygon);
        for(let i = vertexStart, j = 0; j < geometrySize; i++, j++){
            const x = polygonPositions[j * positionSize];
            const y = polygonPositions[j * positionSize + 1];
            const z = positionSize > 2 ? polygonPositions[j * positionSize + 2] : 0;
            positions[i * 3] = x;
            positions[i * 3 + 1] = y;
            positions[i * 3 + 2] = z;
        }
    }
    _updateVertexValid(polygon, { vertexStart , geometrySize  }) {
        const { positionSize  } = this;
        const vertexValid = this.attributes.vertexValid;
        const holeIndices = polygon && _polygon.getHoleIndices(polygon);
        if (polygon && polygon.edgeTypes) vertexValid.set(polygon.edgeTypes, vertexStart);
        else vertexValid.fill(1, vertexStart, vertexStart + geometrySize);
        if (holeIndices) for(let j = 0; j < holeIndices.length; j++)vertexValid[vertexStart + holeIndices[j] / positionSize - 1] = 0;
        vertexValid[vertexStart + geometrySize - 1] = 0;
    }
}
exports.default = PolygonTesselator;
function isCut(polygon) {
    return Array.isArray(polygon) && polygon.length > 0 && !Number.isFinite(polygon[0]);
}

},{"./polygon":"6YguP","@deck.gl/core":"iErGJ","@math.gl/polygon":"88Ubl","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"6YguP":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "getPositions", ()=>getPositions);
parcelHelpers.export(exports, "getHoleIndices", ()=>getHoleIndices);
parcelHelpers.export(exports, "normalize", ()=>normalize);
parcelHelpers.export(exports, "getSurfaceIndices", ()=>getSurfaceIndices);
var _earcut = require("earcut");
var _earcutDefault = parcelHelpers.interopDefault(_earcut);
var _polygon = require("@math.gl/polygon");
const OUTER_POLYGON_WINDING = (0, _polygon.WINDING).CLOCKWISE;
const HOLE_POLYGON_WINDING = (0, _polygon.WINDING).COUNTER_CLOCKWISE;
const windingOptions = {
    isClosed: true
};
function validate(polygon) {
    polygon = polygon && polygon.positions || polygon;
    if (!Array.isArray(polygon) && !ArrayBuffer.isView(polygon)) throw new Error("invalid polygon");
}
function getPositions(polygon) {
    return "positions" in polygon ? polygon.positions : polygon;
}
function getHoleIndices(polygon) {
    return "holeIndices" in polygon ? polygon.holeIndices : null;
}
function isNested(polygon) {
    return Array.isArray(polygon[0]);
}
function isSimple(polygon) {
    return polygon.length >= 1 && polygon[0].length >= 2 && Number.isFinite(polygon[0][0]);
}
function isNestedRingClosed(simplePolygon) {
    const p0 = simplePolygon[0];
    const p1 = simplePolygon[simplePolygon.length - 1];
    return p0[0] === p1[0] && p0[1] === p1[1] && p0[2] === p1[2];
}
function isFlatRingClosed(positions, size, startIndex, endIndex) {
    for(let i = 0; i < size; i++){
        if (positions[startIndex + i] !== positions[endIndex - size + i]) return false;
    }
    return true;
}
function copyNestedRing(target, targetStartIndex, simplePolygon, size, windingDirection) {
    let targetIndex = targetStartIndex;
    const len = simplePolygon.length;
    for(let i = 0; i < len; i++)for(let j = 0; j < size; j++)target[targetIndex++] = simplePolygon[i][j] || 0;
    if (!isNestedRingClosed(simplePolygon)) for(let j1 = 0; j1 < size; j1++)target[targetIndex++] = simplePolygon[0][j1] || 0;
    windingOptions.start = targetStartIndex;
    windingOptions.end = targetIndex;
    windingOptions.size = size;
    (0, _polygon.modifyPolygonWindingDirection)(target, windingDirection, windingOptions);
    return targetIndex;
}
function copyFlatRing(target, targetStartIndex, positions, size, srcStartIndex = 0, srcEndIndex, windingDirection) {
    srcEndIndex = srcEndIndex || positions.length;
    const srcLength = srcEndIndex - srcStartIndex;
    if (srcLength <= 0) return targetStartIndex;
    let targetIndex = targetStartIndex;
    for(let i = 0; i < srcLength; i++)target[targetIndex++] = positions[srcStartIndex + i];
    if (!isFlatRingClosed(positions, size, srcStartIndex, srcEndIndex)) for(let i1 = 0; i1 < size; i1++)target[targetIndex++] = positions[srcStartIndex + i1];
    windingOptions.start = targetStartIndex;
    windingOptions.end = targetIndex;
    windingOptions.size = size;
    (0, _polygon.modifyPolygonWindingDirection)(target, windingDirection, windingOptions);
    return targetIndex;
}
function normalize(polygon, positionSize) {
    validate(polygon);
    const positions = [];
    const holeIndices = [];
    if ("positions" in polygon) {
        const { positions: srcPositions , holeIndices: srcHoleIndices  } = polygon;
        if (srcHoleIndices) {
            let targetIndex = 0;
            for(let i = 0; i <= srcHoleIndices.length; i++){
                targetIndex = copyFlatRing(positions, targetIndex, srcPositions, positionSize, srcHoleIndices[i - 1], srcHoleIndices[i], i === 0 ? OUTER_POLYGON_WINDING : HOLE_POLYGON_WINDING);
                holeIndices.push(targetIndex);
            }
            holeIndices.pop();
            return {
                positions,
                holeIndices
            };
        }
        polygon = srcPositions;
    }
    if (!isNested(polygon)) {
        copyFlatRing(positions, 0, polygon, positionSize, 0, positions.length, OUTER_POLYGON_WINDING);
        return positions;
    }
    if (!isSimple(polygon)) {
        let targetIndex1 = 0;
        for (const [polygonIndex, simplePolygon] of polygon.entries()){
            targetIndex1 = copyNestedRing(positions, targetIndex1, simplePolygon, positionSize, polygonIndex === 0 ? OUTER_POLYGON_WINDING : HOLE_POLYGON_WINDING);
            holeIndices.push(targetIndex1);
        }
        holeIndices.pop();
        return {
            positions,
            holeIndices
        };
    }
    copyNestedRing(positions, 0, polygon, positionSize, OUTER_POLYGON_WINDING);
    return positions;
}
function getSurfaceIndices(polygon, positionSize, preproject) {
    let holeIndices = getHoleIndices(polygon);
    if (holeIndices) holeIndices = holeIndices.map((positionIndex)=>positionIndex / positionSize);
    let positions = getPositions(polygon);
    if (preproject) {
        const n = positions.length;
        positions = positions.slice();
        const p = [];
        for(let i = 0; i < n; i += positionSize){
            p[0] = positions[i];
            p[1] = positions[i + 1];
            const xy = preproject(p);
            positions[i] = xy[0];
            positions[i + 1] = xy[1];
        }
    }
    return (0, _earcutDefault.default)(positions, holeIndices, positionSize);
}

},{"earcut":"dBYod","@math.gl/polygon":"88Ubl","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"dBYod":[function(require,module,exports) {
"use strict";
module.exports = earcut;
module.exports.default = earcut;
function earcut(data, holeIndices, dim) {
    dim = dim || 2;
    var hasHoles = holeIndices && holeIndices.length, outerLen = hasHoles ? holeIndices[0] * dim : data.length, outerNode = linkedList(data, 0, outerLen, dim, true), triangles = [];
    if (!outerNode || outerNode.next === outerNode.prev) return triangles;
    var minX, minY, maxX, maxY, x, y, invSize;
    if (hasHoles) outerNode = eliminateHoles(data, holeIndices, outerNode, dim);
    // if the shape is not too simple, we'll use z-order curve hash later; calculate polygon bbox
    if (data.length > 80 * dim) {
        minX = maxX = data[0];
        minY = maxY = data[1];
        for(var i = dim; i < outerLen; i += dim){
            x = data[i];
            y = data[i + 1];
            if (x < minX) minX = x;
            if (y < minY) minY = y;
            if (x > maxX) maxX = x;
            if (y > maxY) maxY = y;
        }
        // minX, minY and invSize are later used to transform coords into integers for z-order calculation
        invSize = Math.max(maxX - minX, maxY - minY);
        invSize = invSize !== 0 ? 32767 / invSize : 0;
    }
    earcutLinked(outerNode, triangles, dim, minX, minY, invSize, 0);
    return triangles;
}
// create a circular doubly linked list from polygon points in the specified winding order
function linkedList(data, start, end, dim, clockwise) {
    var i, last;
    if (clockwise === signedArea(data, start, end, dim) > 0) for(i = start; i < end; i += dim)last = insertNode(i, data[i], data[i + 1], last);
    else for(i = end - dim; i >= start; i -= dim)last = insertNode(i, data[i], data[i + 1], last);
    if (last && equals(last, last.next)) {
        removeNode(last);
        last = last.next;
    }
    return last;
}
// eliminate colinear or duplicate points
function filterPoints(start, end) {
    if (!start) return start;
    if (!end) end = start;
    var p = start, again;
    do {
        again = false;
        if (!p.steiner && (equals(p, p.next) || area(p.prev, p, p.next) === 0)) {
            removeNode(p);
            p = end = p.prev;
            if (p === p.next) break;
            again = true;
        } else p = p.next;
    }while (again || p !== end);
    return end;
}
// main ear slicing loop which triangulates a polygon (given as a linked list)
function earcutLinked(ear, triangles, dim, minX, minY, invSize, pass) {
    if (!ear) return;
    // interlink polygon nodes in z-order
    if (!pass && invSize) indexCurve(ear, minX, minY, invSize);
    var stop = ear, prev, next;
    // iterate through ears, slicing them one by one
    while(ear.prev !== ear.next){
        prev = ear.prev;
        next = ear.next;
        if (invSize ? isEarHashed(ear, minX, minY, invSize) : isEar(ear)) {
            // cut off the triangle
            triangles.push(prev.i / dim | 0);
            triangles.push(ear.i / dim | 0);
            triangles.push(next.i / dim | 0);
            removeNode(ear);
            // skipping the next vertex leads to less sliver triangles
            ear = next.next;
            stop = next.next;
            continue;
        }
        ear = next;
        // if we looped through the whole remaining polygon and can't find any more ears
        if (ear === stop) {
            // try filtering points and slicing again
            if (!pass) earcutLinked(filterPoints(ear), triangles, dim, minX, minY, invSize, 1);
            else if (pass === 1) {
                ear = cureLocalIntersections(filterPoints(ear), triangles, dim);
                earcutLinked(ear, triangles, dim, minX, minY, invSize, 2);
            // as a last resort, try splitting the remaining polygon into two
            } else if (pass === 2) splitEarcut(ear, triangles, dim, minX, minY, invSize);
            break;
        }
    }
}
// check whether a polygon node forms a valid ear with adjacent nodes
function isEar(ear) {
    var a = ear.prev, b = ear, c = ear.next;
    if (area(a, b, c) >= 0) return false; // reflex, can't be an ear
    // now make sure we don't have other points inside the potential ear
    var ax = a.x, bx = b.x, cx = c.x, ay = a.y, by = b.y, cy = c.y;
    // triangle bbox; min & max are calculated like this for speed
    var x0 = ax < bx ? ax < cx ? ax : cx : bx < cx ? bx : cx, y0 = ay < by ? ay < cy ? ay : cy : by < cy ? by : cy, x1 = ax > bx ? ax > cx ? ax : cx : bx > cx ? bx : cx, y1 = ay > by ? ay > cy ? ay : cy : by > cy ? by : cy;
    var p = c.next;
    while(p !== a){
        if (p.x >= x0 && p.x <= x1 && p.y >= y0 && p.y <= y1 && pointInTriangle(ax, ay, bx, by, cx, cy, p.x, p.y) && area(p.prev, p, p.next) >= 0) return false;
        p = p.next;
    }
    return true;
}
function isEarHashed(ear, minX, minY, invSize) {
    var a = ear.prev, b = ear, c = ear.next;
    if (area(a, b, c) >= 0) return false; // reflex, can't be an ear
    var ax = a.x, bx = b.x, cx = c.x, ay = a.y, by = b.y, cy = c.y;
    // triangle bbox; min & max are calculated like this for speed
    var x0 = ax < bx ? ax < cx ? ax : cx : bx < cx ? bx : cx, y0 = ay < by ? ay < cy ? ay : cy : by < cy ? by : cy, x1 = ax > bx ? ax > cx ? ax : cx : bx > cx ? bx : cx, y1 = ay > by ? ay > cy ? ay : cy : by > cy ? by : cy;
    // z-order range for the current triangle bbox;
    var minZ = zOrder(x0, y0, minX, minY, invSize), maxZ = zOrder(x1, y1, minX, minY, invSize);
    var p = ear.prevZ, n = ear.nextZ;
    // look for points inside the triangle in both directions
    while(p && p.z >= minZ && n && n.z <= maxZ){
        if (p.x >= x0 && p.x <= x1 && p.y >= y0 && p.y <= y1 && p !== a && p !== c && pointInTriangle(ax, ay, bx, by, cx, cy, p.x, p.y) && area(p.prev, p, p.next) >= 0) return false;
        p = p.prevZ;
        if (n.x >= x0 && n.x <= x1 && n.y >= y0 && n.y <= y1 && n !== a && n !== c && pointInTriangle(ax, ay, bx, by, cx, cy, n.x, n.y) && area(n.prev, n, n.next) >= 0) return false;
        n = n.nextZ;
    }
    // look for remaining points in decreasing z-order
    while(p && p.z >= minZ){
        if (p.x >= x0 && p.x <= x1 && p.y >= y0 && p.y <= y1 && p !== a && p !== c && pointInTriangle(ax, ay, bx, by, cx, cy, p.x, p.y) && area(p.prev, p, p.next) >= 0) return false;
        p = p.prevZ;
    }
    // look for remaining points in increasing z-order
    while(n && n.z <= maxZ){
        if (n.x >= x0 && n.x <= x1 && n.y >= y0 && n.y <= y1 && n !== a && n !== c && pointInTriangle(ax, ay, bx, by, cx, cy, n.x, n.y) && area(n.prev, n, n.next) >= 0) return false;
        n = n.nextZ;
    }
    return true;
}
// go through all polygon nodes and cure small local self-intersections
function cureLocalIntersections(start, triangles, dim) {
    var p = start;
    do {
        var a = p.prev, b = p.next.next;
        if (!equals(a, b) && intersects(a, p, p.next, b) && locallyInside(a, b) && locallyInside(b, a)) {
            triangles.push(a.i / dim | 0);
            triangles.push(p.i / dim | 0);
            triangles.push(b.i / dim | 0);
            // remove two nodes involved
            removeNode(p);
            removeNode(p.next);
            p = start = b;
        }
        p = p.next;
    }while (p !== start);
    return filterPoints(p);
}
// try splitting polygon into two and triangulate them independently
function splitEarcut(start, triangles, dim, minX, minY, invSize) {
    // look for a valid diagonal that divides the polygon into two
    var a = start;
    do {
        var b = a.next.next;
        while(b !== a.prev){
            if (a.i !== b.i && isValidDiagonal(a, b)) {
                // split the polygon in two by the diagonal
                var c = splitPolygon(a, b);
                // filter colinear points around the cuts
                a = filterPoints(a, a.next);
                c = filterPoints(c, c.next);
                // run earcut on each half
                earcutLinked(a, triangles, dim, minX, minY, invSize, 0);
                earcutLinked(c, triangles, dim, minX, minY, invSize, 0);
                return;
            }
            b = b.next;
        }
        a = a.next;
    }while (a !== start);
}
// link every hole into the outer loop, producing a single-ring polygon without holes
function eliminateHoles(data, holeIndices, outerNode, dim) {
    var queue = [], i, len, start, end, list;
    for(i = 0, len = holeIndices.length; i < len; i++){
        start = holeIndices[i] * dim;
        end = i < len - 1 ? holeIndices[i + 1] * dim : data.length;
        list = linkedList(data, start, end, dim, false);
        if (list === list.next) list.steiner = true;
        queue.push(getLeftmost(list));
    }
    queue.sort(compareX);
    // process holes from left to right
    for(i = 0; i < queue.length; i++)outerNode = eliminateHole(queue[i], outerNode);
    return outerNode;
}
function compareX(a, b) {
    return a.x - b.x;
}
// find a bridge between vertices that connects hole with an outer ring and and link it
function eliminateHole(hole, outerNode) {
    var bridge = findHoleBridge(hole, outerNode);
    if (!bridge) return outerNode;
    var bridgeReverse = splitPolygon(bridge, hole);
    // filter collinear points around the cuts
    filterPoints(bridgeReverse, bridgeReverse.next);
    return filterPoints(bridge, bridge.next);
}
// David Eberly's algorithm for finding a bridge between hole and outer polygon
function findHoleBridge(hole, outerNode) {
    var p = outerNode, hx = hole.x, hy = hole.y, qx = -Infinity, m;
    // find a segment intersected by a ray from the hole's leftmost point to the left;
    // segment's endpoint with lesser x will be potential connection point
    do {
        if (hy <= p.y && hy >= p.next.y && p.next.y !== p.y) {
            var x = p.x + (hy - p.y) * (p.next.x - p.x) / (p.next.y - p.y);
            if (x <= hx && x > qx) {
                qx = x;
                m = p.x < p.next.x ? p : p.next;
                if (x === hx) return m; // hole touches outer segment; pick leftmost endpoint
            }
        }
        p = p.next;
    }while (p !== outerNode);
    if (!m) return null;
    // look for points inside the triangle of hole point, segment intersection and endpoint;
    // if there are no points found, we have a valid connection;
    // otherwise choose the point of the minimum angle with the ray as connection point
    var stop = m, mx = m.x, my = m.y, tanMin = Infinity, tan;
    p = m;
    do {
        if (hx >= p.x && p.x >= mx && hx !== p.x && pointInTriangle(hy < my ? hx : qx, hy, mx, my, hy < my ? qx : hx, hy, p.x, p.y)) {
            tan = Math.abs(hy - p.y) / (hx - p.x); // tangential
            if (locallyInside(p, hole) && (tan < tanMin || tan === tanMin && (p.x > m.x || p.x === m.x && sectorContainsSector(m, p)))) {
                m = p;
                tanMin = tan;
            }
        }
        p = p.next;
    }while (p !== stop);
    return m;
}
// whether sector in vertex m contains sector in vertex p in the same coordinates
function sectorContainsSector(m, p) {
    return area(m.prev, m, p.prev) < 0 && area(p.next, m, m.next) < 0;
}
// interlink polygon nodes in z-order
function indexCurve(start, minX, minY, invSize) {
    var p = start;
    do {
        if (p.z === 0) p.z = zOrder(p.x, p.y, minX, minY, invSize);
        p.prevZ = p.prev;
        p.nextZ = p.next;
        p = p.next;
    }while (p !== start);
    p.prevZ.nextZ = null;
    p.prevZ = null;
    sortLinked(p);
}
// Simon Tatham's linked list merge sort algorithm
// http://www.chiark.greenend.org.uk/~sgtatham/algorithms/listsort.html
function sortLinked(list) {
    var i, p, q, e, tail, numMerges, pSize, qSize, inSize = 1;
    do {
        p = list;
        list = null;
        tail = null;
        numMerges = 0;
        while(p){
            numMerges++;
            q = p;
            pSize = 0;
            for(i = 0; i < inSize; i++){
                pSize++;
                q = q.nextZ;
                if (!q) break;
            }
            qSize = inSize;
            while(pSize > 0 || qSize > 0 && q){
                if (pSize !== 0 && (qSize === 0 || !q || p.z <= q.z)) {
                    e = p;
                    p = p.nextZ;
                    pSize--;
                } else {
                    e = q;
                    q = q.nextZ;
                    qSize--;
                }
                if (tail) tail.nextZ = e;
                else list = e;
                e.prevZ = tail;
                tail = e;
            }
            p = q;
        }
        tail.nextZ = null;
        inSize *= 2;
    }while (numMerges > 1);
    return list;
}
// z-order of a point given coords and inverse of the longer side of data bbox
function zOrder(x, y, minX, minY, invSize) {
    // coords are transformed into non-negative 15-bit integer range
    x = (x - minX) * invSize | 0;
    y = (y - minY) * invSize | 0;
    x = (x | x << 8) & 0x00FF00FF;
    x = (x | x << 4) & 0x0F0F0F0F;
    x = (x | x << 2) & 0x33333333;
    x = (x | x << 1) & 0x55555555;
    y = (y | y << 8) & 0x00FF00FF;
    y = (y | y << 4) & 0x0F0F0F0F;
    y = (y | y << 2) & 0x33333333;
    y = (y | y << 1) & 0x55555555;
    return x | y << 1;
}
// find the leftmost node of a polygon ring
function getLeftmost(start) {
    var p = start, leftmost = start;
    do {
        if (p.x < leftmost.x || p.x === leftmost.x && p.y < leftmost.y) leftmost = p;
        p = p.next;
    }while (p !== start);
    return leftmost;
}
// check if a point lies within a convex triangle
function pointInTriangle(ax, ay, bx, by, cx, cy, px, py) {
    return (cx - px) * (ay - py) >= (ax - px) * (cy - py) && (ax - px) * (by - py) >= (bx - px) * (ay - py) && (bx - px) * (cy - py) >= (cx - px) * (by - py);
}
// check if a diagonal between two polygon nodes is valid (lies in polygon interior)
function isValidDiagonal(a, b) {
    return a.next.i !== b.i && a.prev.i !== b.i && !intersectsPolygon(a, b) && // dones't intersect other edges
    (locallyInside(a, b) && locallyInside(b, a) && middleInside(a, b) && // locally visible
    (area(a.prev, a, b.prev) || area(a, b.prev, b)) || // does not create opposite-facing sectors
    equals(a, b) && area(a.prev, a, a.next) > 0 && area(b.prev, b, b.next) > 0); // special zero-length case
}
// signed area of a triangle
function area(p, q, r) {
    return (q.y - p.y) * (r.x - q.x) - (q.x - p.x) * (r.y - q.y);
}
// check if two points are equal
function equals(p1, p2) {
    return p1.x === p2.x && p1.y === p2.y;
}
// check if two segments intersect
function intersects(p1, q1, p2, q2) {
    var o1 = sign(area(p1, q1, p2));
    var o2 = sign(area(p1, q1, q2));
    var o3 = sign(area(p2, q2, p1));
    var o4 = sign(area(p2, q2, q1));
    if (o1 !== o2 && o3 !== o4) return true; // general case
    if (o1 === 0 && onSegment(p1, p2, q1)) return true; // p1, q1 and p2 are collinear and p2 lies on p1q1
    if (o2 === 0 && onSegment(p1, q2, q1)) return true; // p1, q1 and q2 are collinear and q2 lies on p1q1
    if (o3 === 0 && onSegment(p2, p1, q2)) return true; // p2, q2 and p1 are collinear and p1 lies on p2q2
    if (o4 === 0 && onSegment(p2, q1, q2)) return true; // p2, q2 and q1 are collinear and q1 lies on p2q2
    return false;
}
// for collinear points p, q, r, check if point q lies on segment pr
function onSegment(p, q, r) {
    return q.x <= Math.max(p.x, r.x) && q.x >= Math.min(p.x, r.x) && q.y <= Math.max(p.y, r.y) && q.y >= Math.min(p.y, r.y);
}
function sign(num) {
    return num > 0 ? 1 : num < 0 ? -1 : 0;
}
// check if a polygon diagonal intersects any polygon segments
function intersectsPolygon(a, b) {
    var p = a;
    do {
        if (p.i !== a.i && p.next.i !== a.i && p.i !== b.i && p.next.i !== b.i && intersects(p, p.next, a, b)) return true;
        p = p.next;
    }while (p !== a);
    return false;
}
// check if a polygon diagonal is locally inside the polygon
function locallyInside(a, b) {
    return area(a.prev, a, a.next) < 0 ? area(a, b, a.next) >= 0 && area(a, a.prev, b) >= 0 : area(a, b, a.prev) < 0 || area(a, a.next, b) < 0;
}
// check if the middle point of a polygon diagonal is inside the polygon
function middleInside(a, b) {
    var p = a, inside = false, px = (a.x + b.x) / 2, py = (a.y + b.y) / 2;
    do {
        if (p.y > py !== p.next.y > py && p.next.y !== p.y && px < (p.next.x - p.x) * (py - p.y) / (p.next.y - p.y) + p.x) inside = !inside;
        p = p.next;
    }while (p !== a);
    return inside;
}
// link two polygon vertices with a bridge; if the vertices belong to the same ring, it splits polygon into two;
// if one belongs to the outer ring and another to a hole, it merges it into a single ring
function splitPolygon(a, b) {
    var a2 = new Node(a.i, a.x, a.y), b2 = new Node(b.i, b.x, b.y), an = a.next, bp = b.prev;
    a.next = b;
    b.prev = a;
    a2.next = an;
    an.prev = a2;
    b2.next = a2;
    a2.prev = b2;
    bp.next = b2;
    b2.prev = bp;
    return b2;
}
// create a node and optionally link it with previous one (in a circular doubly linked list)
function insertNode(i, x, y, last) {
    var p = new Node(i, x, y);
    if (!last) {
        p.prev = p;
        p.next = p;
    } else {
        p.next = last.next;
        p.prev = last;
        last.next.prev = p;
        last.next = p;
    }
    return p;
}
function removeNode(p) {
    p.next.prev = p.prev;
    p.prev.next = p.next;
    if (p.prevZ) p.prevZ.nextZ = p.nextZ;
    if (p.nextZ) p.nextZ.prevZ = p.prevZ;
}
function Node(i, x, y) {
    // vertex index in coordinates array
    this.i = i;
    // vertex coordinates
    this.x = x;
    this.y = y;
    // previous and next vertex nodes in a polygon ring
    this.prev = null;
    this.next = null;
    // z-order curve value
    this.z = 0;
    // previous and next nodes in z-order
    this.prevZ = null;
    this.nextZ = null;
    // indicates whether this is a steiner point
    this.steiner = false;
}
// return a percentage difference between the polygon area and its triangulation area;
// used to verify correctness of triangulation
earcut.deviation = function(data, holeIndices, dim, triangles) {
    var hasHoles = holeIndices && holeIndices.length;
    var outerLen = hasHoles ? holeIndices[0] * dim : data.length;
    var polygonArea = Math.abs(signedArea(data, 0, outerLen, dim));
    if (hasHoles) for(var i = 0, len = holeIndices.length; i < len; i++){
        var start = holeIndices[i] * dim;
        var end = i < len - 1 ? holeIndices[i + 1] * dim : data.length;
        polygonArea -= Math.abs(signedArea(data, start, end, dim));
    }
    var trianglesArea = 0;
    for(i = 0; i < triangles.length; i += 3){
        var a = triangles[i] * dim;
        var b = triangles[i + 1] * dim;
        var c = triangles[i + 2] * dim;
        trianglesArea += Math.abs((data[a] - data[c]) * (data[b + 1] - data[a + 1]) - (data[a] - data[b]) * (data[c + 1] - data[a + 1]));
    }
    return polygonArea === 0 && trianglesArea === 0 ? 0 : Math.abs((trianglesArea - polygonArea) / polygonArea);
};
function signedArea(data, start, end, dim) {
    var sum = 0;
    for(var i = start, j = end - dim; i < end; i += dim){
        sum += (data[j] - data[i]) * (data[i + 1] + data[j + 1]);
        j = i;
    }
    return sum;
}
// turn a polygon in a multi-dimensional array form (e.g. as in GeoJSON) into a form Earcut accepts
earcut.flatten = function(data) {
    var dim = data[0][0].length, result = {
        vertices: [],
        holes: [],
        dimensions: dim
    }, holeIndex = 0;
    for(var i = 0; i < data.length; i++){
        for(var j = 0; j < data[i].length; j++)for(var d = 0; d < dim; d++)result.vertices.push(data[i][j][d]);
        if (i > 0) {
            holeIndex += data[i - 1].length;
            result.holes.push(holeIndex);
        }
    }
    return result;
};

},{}],"88Ubl":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "Polygon", ()=>(0, _polygonDefault.default));
parcelHelpers.export(exports, "getPolygonSignedArea", ()=>(0, _polygonUtils.getPolygonSignedArea));
parcelHelpers.export(exports, "getPolygonWindingDirection", ()=>(0, _polygonUtils.getPolygonWindingDirection));
parcelHelpers.export(exports, "forEachSegmentInPolygon", ()=>(0, _polygonUtils.forEachSegmentInPolygon));
parcelHelpers.export(exports, "modifyPolygonWindingDirection", ()=>(0, _polygonUtils.modifyPolygonWindingDirection));
parcelHelpers.export(exports, "WINDING", ()=>(0, _polygonUtils.WINDING));
parcelHelpers.export(exports, "earcut", ()=>(0, _earcut.earcut));
parcelHelpers.export(exports, "clipPolygon", ()=>(0, _lineclip.clipPolygon));
parcelHelpers.export(exports, "clipPolyline", ()=>(0, _lineclip.clipPolyline));
parcelHelpers.export(exports, "cutPolygonByGrid", ()=>(0, _cutByGrid.cutPolygonByGrid));
parcelHelpers.export(exports, "cutPolylineByGrid", ()=>(0, _cutByGrid.cutPolylineByGrid));
parcelHelpers.export(exports, "cutPolylineByMercatorBounds", ()=>(0, _cutByMercatorBounds.cutPolylineByMercatorBounds));
parcelHelpers.export(exports, "cutPolygonByMercatorBounds", ()=>(0, _cutByMercatorBounds.cutPolygonByMercatorBounds));
parcelHelpers.export(exports, "_Polygon", ()=>(0, _polygonDefault.default));
var _polygon = require("./polygon");
var _polygonDefault = parcelHelpers.interopDefault(_polygon);
var _polygonUtils = require("./polygon-utils");
var _earcut = require("./earcut");
var _lineclip = require("./lineclip");
var _cutByGrid = require("./cut-by-grid");
var _cutByMercatorBounds = require("./cut-by-mercator-bounds");

},{"./polygon":"lKuaA","./polygon-utils":"grzep","./earcut":"fUVwE","./lineclip":"20F7m","./cut-by-grid":"9XQwf","./cut-by-mercator-bounds":"jAokH","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"lKuaA":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@math.gl/core");
var _polygonUtils = require("./polygon-utils");
class Polygon {
    constructor(points, options = {}){
        (0, _definePropertyDefault.default)(this, "points", void 0);
        (0, _definePropertyDefault.default)(this, "isFlatArray", void 0);
        (0, _definePropertyDefault.default)(this, "options", void 0);
        this.points = points;
        this.isFlatArray = !(0, _core.isArray)(points[0]);
        this.options = {
            start: options.start || 0,
            end: options.end || points.length,
            size: options.size || 2,
            isClosed: options.isClosed
        };
        Object.freeze(this);
    }
    getSignedArea() {
        if (this.isFlatArray) return (0, _polygonUtils.getPolygonSignedArea)(this.points, this.options);
        return (0, _polygonUtils.getPolygonSignedAreaPoints)(this.points, this.options);
    }
    getArea() {
        return Math.abs(this.getSignedArea());
    }
    getWindingDirection() {
        return Math.sign(this.getSignedArea());
    }
    forEachSegment(visitor) {
        if (this.isFlatArray) (0, _polygonUtils.forEachSegmentInPolygon)(this.points, (x1, y1, x2, y2, i1, i2)=>{
            visitor([
                x1,
                y1
            ], [
                x2,
                y2
            ], i1, i2);
        }, this.options);
        else (0, _polygonUtils.forEachSegmentInPolygonPoints)(this.points, visitor, this.options);
    }
    modifyWindingDirection(direction) {
        if (this.isFlatArray) return (0, _polygonUtils.modifyPolygonWindingDirection)(this.points, direction, this.options);
        return (0, _polygonUtils.modifyPolygonWindingDirectionPoints)(this.points, direction, this.options);
    }
}
exports.default = Polygon;

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@math.gl/core":"9lgwD","./polygon-utils":"grzep","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"grzep":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "WINDING", ()=>WINDING);
parcelHelpers.export(exports, "modifyPolygonWindingDirection", ()=>modifyPolygonWindingDirection);
parcelHelpers.export(exports, "getPolygonWindingDirection", ()=>getPolygonWindingDirection);
parcelHelpers.export(exports, "getPolygonSignedArea", ()=>getPolygonSignedArea);
parcelHelpers.export(exports, "forEachSegmentInPolygon", ()=>forEachSegmentInPolygon);
parcelHelpers.export(exports, "modifyPolygonWindingDirectionPoints", ()=>modifyPolygonWindingDirectionPoints);
parcelHelpers.export(exports, "getPolygonWindingDirectionPoints", ()=>getPolygonWindingDirectionPoints);
parcelHelpers.export(exports, "getPolygonSignedAreaPoints", ()=>getPolygonSignedAreaPoints);
parcelHelpers.export(exports, "forEachSegmentInPolygonPoints", ()=>forEachSegmentInPolygonPoints);
var _core = require("@math.gl/core");
const WINDING = {
    CLOCKWISE: 1,
    COUNTER_CLOCKWISE: -1
};
function modifyPolygonWindingDirection(points, direction, options = {}) {
    const windingDirection = getPolygonWindingDirection(points, options);
    if (windingDirection !== direction) {
        reversePolygon(points, options);
        return true;
    }
    return false;
}
function getPolygonWindingDirection(points, options = {}) {
    return Math.sign(getPolygonSignedArea(points, options));
}
function getPolygonSignedArea(points, options = {}) {
    const { start =0 , end =points.length  } = options;
    const dim = options.size || 2;
    let area = 0;
    for(let i = start, j = end - dim; i < end; i += dim){
        area += (points[i] - points[j]) * (points[i + 1] + points[j + 1]);
        j = i;
    }
    return area / 2;
}
function forEachSegmentInPolygon(points, visitor, options = {}) {
    const { start =0 , end =points.length , size =2 , isClosed  } = options;
    const numPoints = (end - start) / size;
    for(let i = 0; i < numPoints - 1; ++i)visitor(points[start + i * size], points[start + i * size + 1], points[start + (i + 1) * size], points[start + (i + 1) * size + 1], i, i + 1);
    const endPointIndex = start + (numPoints - 1) * size;
    const isClosedEx = isClosed || (0, _core.equals)(points[start], points[endPointIndex]) && (0, _core.equals)(points[start + 1], points[endPointIndex + 1]);
    if (!isClosedEx) visitor(points[endPointIndex], points[endPointIndex + 1], points[start], points[start + 1], numPoints - 1, 0);
}
function reversePolygon(points, options) {
    const { start =0 , end =points.length , size =2  } = options;
    const numPoints = (end - start) / size;
    const numSwaps = Math.floor(numPoints / 2);
    for(let i = 0; i < numSwaps; ++i){
        const b1 = start + i * size;
        const b2 = start + (numPoints - 1 - i) * size;
        for(let j = 0; j < size; ++j){
            const tmp = points[b1 + j];
            points[b1 + j] = points[b2 + j];
            points[b2 + j] = tmp;
        }
    }
}
function modifyPolygonWindingDirectionPoints(points, direction, options = {}) {
    const currentDirection = getPolygonWindingDirectionPoints(points, options);
    if (currentDirection !== direction) {
        points.reverse();
        return true;
    }
    return false;
}
function getPolygonWindingDirectionPoints(points, options = {}) {
    return Math.sign(getPolygonSignedAreaPoints(points, options));
}
function getPolygonSignedAreaPoints(points, options = {}) {
    const { start =0 , end =points.length  } = options;
    let area = 0;
    for(let i = start, j = end - 1; i < end; ++i){
        area += (points[i][0] - points[j][0]) * (points[i][1] + points[j][1]);
        j = i;
    }
    return area / 2;
}
function forEachSegmentInPolygonPoints(points, visitor, options = {}) {
    const { start =0 , end =points.length , isClosed  } = options;
    for(let i = start; i < end - 1; ++i)visitor(points[i], points[i + 1], i, i + 1);
    const isClosedEx = isClosed || (0, _core.equals)(points[end - 1], points[0]);
    if (!isClosedEx) visitor(points[end - 1], points[0], end - 1, 0);
}

},{"@math.gl/core":"9lgwD","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"fUVwE":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "earcut", ()=>earcut);
var _polygonUtils = require("./polygon-utils");
function earcut(positions, holeIndices, dim = 2, areas) {
    const hasHoles = holeIndices && holeIndices.length;
    const outerLen = hasHoles ? holeIndices[0] * dim : positions.length;
    let outerNode = linkedList(positions, 0, outerLen, dim, true, areas && areas[0]);
    const triangles = [];
    if (!outerNode || outerNode.next === outerNode.prev) return triangles;
    let invSize;
    let maxX;
    let maxY;
    let minX;
    let minY;
    let x;
    let y;
    if (hasHoles) outerNode = eliminateHoles(positions, holeIndices, outerNode, dim, areas);
    if (positions.length > 80 * dim) {
        minX = maxX = positions[0];
        minY = maxY = positions[1];
        for(let i = dim; i < outerLen; i += dim){
            x = positions[i];
            y = positions[i + 1];
            if (x < minX) minX = x;
            if (y < minY) minY = y;
            if (x > maxX) maxX = x;
            if (y > maxY) maxY = y;
        }
        invSize = Math.max(maxX - minX, maxY - minY);
        invSize = invSize !== 0 ? 1 / invSize : 0;
    }
    earcutLinked(outerNode, triangles, dim, minX, minY, invSize);
    return triangles;
}
function linkedList(data, start, end, dim, clockwise, area) {
    let i;
    let last;
    if (area === undefined) area = (0, _polygonUtils.getPolygonSignedArea)(data, {
        start,
        end,
        size: dim
    });
    if (clockwise === area < 0) for(i = start; i < end; i += dim)last = insertNode(i, data[i], data[i + 1], last);
    else for(i = end - dim; i >= start; i -= dim)last = insertNode(i, data[i], data[i + 1], last);
    if (last && equals(last, last.next)) {
        removeNode(last);
        last = last.next;
    }
    return last;
}
function filterPoints(start, end) {
    if (!start) return start;
    if (!end) end = start;
    let p = start;
    let again;
    do {
        again = false;
        if (!p.steiner && (equals(p, p.next) || area(p.prev, p, p.next) === 0)) {
            removeNode(p);
            p = end = p.prev;
            if (p === p.next) break;
            again = true;
        } else p = p.next;
    }while (again || p !== end);
    return end;
}
function earcutLinked(ear, triangles, dim, minX, minY, invSize, pass) {
    if (!ear) return;
    if (!pass && invSize) indexCurve(ear, minX, minY, invSize);
    let stop = ear;
    let prev;
    let next;
    while(ear.prev !== ear.next){
        prev = ear.prev;
        next = ear.next;
        if (invSize ? isEarHashed(ear, minX, minY, invSize) : isEar(ear)) {
            triangles.push(prev.i / dim);
            triangles.push(ear.i / dim);
            triangles.push(next.i / dim);
            removeNode(ear);
            ear = next.next;
            stop = next.next;
            continue;
        }
        ear = next;
        if (ear === stop) {
            if (!pass) earcutLinked(filterPoints(ear), triangles, dim, minX, minY, invSize, 1);
            else if (pass === 1) {
                ear = cureLocalIntersections(filterPoints(ear), triangles, dim);
                earcutLinked(ear, triangles, dim, minX, minY, invSize, 2);
            } else if (pass === 2) splitEarcut(ear, triangles, dim, minX, minY, invSize);
            break;
        }
    }
}
function isEar(ear) {
    const a = ear.prev;
    const b = ear;
    const c = ear.next;
    if (area(a, b, c) >= 0) return false;
    let p = ear.next.next;
    while(p !== ear.prev){
        if (pointInTriangle(a.x, a.y, b.x, b.y, c.x, c.y, p.x, p.y) && area(p.prev, p, p.next) >= 0) return false;
        p = p.next;
    }
    return true;
}
function isEarHashed(ear, minX, minY, invSize) {
    const a = ear.prev;
    const b = ear;
    const c = ear.next;
    if (area(a, b, c) >= 0) return false;
    const minTX = a.x < b.x ? a.x < c.x ? a.x : c.x : b.x < c.x ? b.x : c.x;
    const minTY = a.y < b.y ? a.y < c.y ? a.y : c.y : b.y < c.y ? b.y : c.y;
    const maxTX = a.x > b.x ? a.x > c.x ? a.x : c.x : b.x > c.x ? b.x : c.x;
    const maxTY = a.y > b.y ? a.y > c.y ? a.y : c.y : b.y > c.y ? b.y : c.y;
    const minZ = zOrder(minTX, minTY, minX, minY, invSize);
    const maxZ = zOrder(maxTX, maxTY, minX, minY, invSize);
    let p = ear.prevZ;
    let n = ear.nextZ;
    while(p && p.z >= minZ && n && n.z <= maxZ){
        if (p !== ear.prev && p !== ear.next && pointInTriangle(a.x, a.y, b.x, b.y, c.x, c.y, p.x, p.y) && area(p.prev, p, p.next) >= 0) return false;
        p = p.prevZ;
        if (n !== ear.prev && n !== ear.next && pointInTriangle(a.x, a.y, b.x, b.y, c.x, c.y, n.x, n.y) && area(n.prev, n, n.next) >= 0) return false;
        n = n.nextZ;
    }
    while(p && p.z >= minZ){
        if (p !== ear.prev && p !== ear.next && pointInTriangle(a.x, a.y, b.x, b.y, c.x, c.y, p.x, p.y) && area(p.prev, p, p.next) >= 0) return false;
        p = p.prevZ;
    }
    while(n && n.z <= maxZ){
        if (n !== ear.prev && n !== ear.next && pointInTriangle(a.x, a.y, b.x, b.y, c.x, c.y, n.x, n.y) && area(n.prev, n, n.next) >= 0) return false;
        n = n.nextZ;
    }
    return true;
}
function cureLocalIntersections(start, triangles, dim) {
    let p = start;
    do {
        const a = p.prev;
        const b = p.next.next;
        if (!equals(a, b) && intersects(a, p, p.next, b) && locallyInside(a, b) && locallyInside(b, a)) {
            triangles.push(a.i / dim);
            triangles.push(p.i / dim);
            triangles.push(b.i / dim);
            removeNode(p);
            removeNode(p.next);
            p = start = b;
        }
        p = p.next;
    }while (p !== start);
    return filterPoints(p);
}
function splitEarcut(start, triangles, dim, minX, minY, invSize) {
    let a = start;
    do {
        let b = a.next.next;
        while(b !== a.prev){
            if (a.i !== b.i && isValidDiagonal(a, b)) {
                let c = splitPolygon(a, b);
                a = filterPoints(a, a.next);
                c = filterPoints(c, c.next);
                earcutLinked(a, triangles, dim, minX, minY, invSize);
                earcutLinked(c, triangles, dim, minX, minY, invSize);
                return;
            }
            b = b.next;
        }
        a = a.next;
    }while (a !== start);
}
function eliminateHoles(data, holeIndices, outerNode, dim, areas) {
    const queue = [];
    let i;
    let len;
    let start;
    let end;
    let list;
    for(i = 0, len = holeIndices.length; i < len; i++){
        start = holeIndices[i] * dim;
        end = i < len - 1 ? holeIndices[i + 1] * dim : data.length;
        list = linkedList(data, start, end, dim, false, areas && areas[i + 1]);
        if (list === list.next) list.steiner = true;
        queue.push(getLeftmost(list));
    }
    queue.sort(compareX);
    for(i = 0; i < queue.length; i++){
        eliminateHole(queue[i], outerNode);
        outerNode = filterPoints(outerNode, outerNode.next);
    }
    return outerNode;
}
function compareX(a, b) {
    return a.x - b.x;
}
function eliminateHole(hole, outerNode) {
    outerNode = findHoleBridge(hole, outerNode);
    if (outerNode) {
        const b = splitPolygon(outerNode, hole);
        filterPoints(outerNode, outerNode.next);
        filterPoints(b, b.next);
    }
}
function findHoleBridge(hole, outerNode) {
    let p = outerNode;
    const hx = hole.x;
    const hy = hole.y;
    let qx = -Infinity;
    let m;
    do {
        if (hy <= p.y && hy >= p.next.y && p.next.y !== p.y) {
            const x = p.x + (hy - p.y) * (p.next.x - p.x) / (p.next.y - p.y);
            if (x <= hx && x > qx) {
                qx = x;
                if (x === hx) {
                    if (hy === p.y) return p;
                    if (hy === p.next.y) return p.next;
                }
                m = p.x < p.next.x ? p : p.next;
            }
        }
        p = p.next;
    }while (p !== outerNode);
    if (!m) return null;
    if (hx === qx) return m;
    const stop = m;
    const mx = m.x;
    const my = m.y;
    let tanMin = Infinity;
    let tan;
    p = m;
    do {
        if (hx >= p.x && p.x >= mx && hx !== p.x && pointInTriangle(hy < my ? hx : qx, hy, mx, my, hy < my ? qx : hx, hy, p.x, p.y)) {
            tan = Math.abs(hy - p.y) / (hx - p.x);
            if (locallyInside(p, hole) && (tan < tanMin || tan === tanMin && (p.x > m.x || p.x === m.x && sectorContainsSector(m, p)))) {
                m = p;
                tanMin = tan;
            }
        }
        p = p.next;
    }while (p !== stop);
    return m;
}
function sectorContainsSector(m, p) {
    return area(m.prev, m, p.prev) < 0 && area(p.next, m, m.next) < 0;
}
function indexCurve(start, minX, minY, invSize) {
    let p = start;
    do {
        if (p.z === null) p.z = zOrder(p.x, p.y, minX, minY, invSize);
        p.prevZ = p.prev;
        p.nextZ = p.next;
        p = p.next;
    }while (p !== start);
    p.prevZ.nextZ = null;
    p.prevZ = null;
    sortLinked(p);
}
function sortLinked(list) {
    let e;
    let i;
    let inSize = 1;
    let numMerges;
    let p;
    let pSize;
    let q;
    let qSize;
    let tail;
    do {
        p = list;
        list = null;
        tail = null;
        numMerges = 0;
        while(p){
            numMerges++;
            q = p;
            pSize = 0;
            for(i = 0; i < inSize; i++){
                pSize++;
                q = q.nextZ;
                if (!q) break;
            }
            qSize = inSize;
            while(pSize > 0 || qSize > 0 && q){
                if (pSize !== 0 && (qSize === 0 || !q || p.z <= q.z)) {
                    e = p;
                    p = p.nextZ;
                    pSize--;
                } else {
                    e = q;
                    q = q.nextZ;
                    qSize--;
                }
                if (tail) tail.nextZ = e;
                else list = e;
                e.prevZ = tail;
                tail = e;
            }
            p = q;
        }
        tail.nextZ = null;
        inSize *= 2;
    }while (numMerges > 1);
    return list;
}
function zOrder(x, y, minX, minY, invSize) {
    x = 32767 * (x - minX) * invSize;
    y = 32767 * (y - minY) * invSize;
    x = (x | x << 8) & 0x00ff00ff;
    x = (x | x << 4) & 0x0f0f0f0f;
    x = (x | x << 2) & 0x33333333;
    x = (x | x << 1) & 0x55555555;
    y = (y | y << 8) & 0x00ff00ff;
    y = (y | y << 4) & 0x0f0f0f0f;
    y = (y | y << 2) & 0x33333333;
    y = (y | y << 1) & 0x55555555;
    return x | y << 1;
}
function getLeftmost(start) {
    let p = start;
    let leftmost = start;
    do {
        if (p.x < leftmost.x || p.x === leftmost.x && p.y < leftmost.y) leftmost = p;
        p = p.next;
    }while (p !== start);
    return leftmost;
}
function pointInTriangle(ax, ay, bx, by, cx, cy, px, py) {
    return (cx - px) * (ay - py) - (ax - px) * (cy - py) >= 0 && (ax - px) * (by - py) - (bx - px) * (ay - py) >= 0 && (bx - px) * (cy - py) - (cx - px) * (by - py) >= 0;
}
function isValidDiagonal(a, b) {
    return a.next.i !== b.i && a.prev.i !== b.i && !intersectsPolygon(a, b) && (locallyInside(a, b) && locallyInside(b, a) && middleInside(a, b) && (area(a.prev, a, b.prev) || area(a, b.prev, b)) || equals(a, b) && area(a.prev, a, a.next) > 0 && area(b.prev, b, b.next) > 0);
}
function area(p, q, r) {
    return (q.y - p.y) * (r.x - q.x) - (q.x - p.x) * (r.y - q.y);
}
function equals(p1, p2) {
    return p1.x === p2.x && p1.y === p2.y;
}
function intersects(p1, q1, p2, q2) {
    const o1 = sign(area(p1, q1, p2));
    const o2 = sign(area(p1, q1, q2));
    const o3 = sign(area(p2, q2, p1));
    const o4 = sign(area(p2, q2, q1));
    if (o1 !== o2 && o3 !== o4) return true;
    if (o1 === 0 && onSegment(p1, p2, q1)) return true;
    if (o2 === 0 && onSegment(p1, q2, q1)) return true;
    if (o3 === 0 && onSegment(p2, p1, q2)) return true;
    if (o4 === 0 && onSegment(p2, q1, q2)) return true;
    return false;
}
function onSegment(p, q, r) {
    return q.x <= Math.max(p.x, r.x) && q.x >= Math.min(p.x, r.x) && q.y <= Math.max(p.y, r.y) && q.y >= Math.min(p.y, r.y);
}
function sign(num) {
    return num > 0 ? 1 : num < 0 ? -1 : 0;
}
function intersectsPolygon(a, b) {
    let p = a;
    do {
        if (p.i !== a.i && p.next.i !== a.i && p.i !== b.i && p.next.i !== b.i && intersects(p, p.next, a, b)) return true;
        p = p.next;
    }while (p !== a);
    return false;
}
function locallyInside(a, b) {
    return area(a.prev, a, a.next) < 0 ? area(a, b, a.next) >= 0 && area(a, a.prev, b) >= 0 : area(a, b, a.prev) < 0 || area(a, a.next, b) < 0;
}
function middleInside(a, b) {
    let p = a;
    let inside = false;
    const px = (a.x + b.x) / 2;
    const py = (a.y + b.y) / 2;
    do {
        if (p.y > py !== p.next.y > py && p.next.y !== p.y && px < (p.next.x - p.x) * (py - p.y) / (p.next.y - p.y) + p.x) inside = !inside;
        p = p.next;
    }while (p !== a);
    return inside;
}
function splitPolygon(a, b) {
    const a2 = new Node(a.i, a.x, a.y);
    const b2 = new Node(b.i, b.x, b.y);
    const an = a.next;
    const bp = b.prev;
    a.next = b;
    b.prev = a;
    a2.next = an;
    an.prev = a2;
    b2.next = a2;
    a2.prev = b2;
    bp.next = b2;
    b2.prev = bp;
    return b2;
}
function insertNode(i, x, y, last) {
    const p = new Node(i, x, y);
    if (!last) {
        p.prev = p;
        p.next = p;
    } else {
        p.next = last.next;
        p.prev = last;
        last.next.prev = p;
        last.next = p;
    }
    return p;
}
function removeNode(p) {
    p.next.prev = p.prev;
    p.prev.next = p.next;
    if (p.prevZ) p.prevZ.nextZ = p.nextZ;
    if (p.nextZ) p.nextZ.prevZ = p.prevZ;
}
function Node(i, x, y) {
    this.i = i;
    this.x = x;
    this.y = y;
    this.prev = null;
    this.next = null;
    this.z = null;
    this.prevZ = null;
    this.nextZ = null;
    this.steiner = false;
}

},{"./polygon-utils":"grzep","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"20F7m":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "clipPolyline", ()=>clipPolyline);
parcelHelpers.export(exports, "clipPolygon", ()=>clipPolygon);
parcelHelpers.export(exports, "intersect", ()=>intersect);
parcelHelpers.export(exports, "bitCode", ()=>bitCode);
var _utils = require("./utils");
function clipPolyline(positions, bbox, options) {
    const { size =2 , startIndex =0 , endIndex =positions.length  } = options || {};
    const numPoints = (endIndex - startIndex) / size;
    const result = [];
    let part = [];
    let a;
    let b;
    let codeA = -1;
    let codeB;
    let lastCode;
    for(let i = 1; i < numPoints; i++){
        a = (0, _utils.getPointAtIndex)(positions, i - 1, size, startIndex, a);
        b = (0, _utils.getPointAtIndex)(positions, i, size, startIndex, b);
        if (codeA < 0) codeA = bitCode(a, bbox);
        codeB = lastCode = bitCode(b, bbox);
        while(true){
            if (!(codeA | codeB)) {
                (0, _utils.push)(part, a);
                if (codeB !== lastCode) {
                    (0, _utils.push)(part, b);
                    if (i < numPoints - 1) {
                        result.push(part);
                        part = [];
                    }
                } else if (i === numPoints - 1) (0, _utils.push)(part, b);
                break;
            } else if (codeA & codeB) break;
            else if (codeA) {
                intersect(a, b, codeA, bbox, a);
                codeA = bitCode(a, bbox);
            } else {
                intersect(a, b, codeB, bbox, b);
                codeB = bitCode(b, bbox);
            }
        }
        codeA = lastCode;
    }
    if (part.length) result.push(part);
    return result;
}
function clipPolygon(positions, bbox, options) {
    const { size =2 , endIndex =positions.length  } = options || {};
    let { startIndex =0  } = options || {};
    let numPoints = (endIndex - startIndex) / size;
    let result;
    let p;
    let prev;
    let inside;
    let prevInside;
    for(let edge = 1; edge <= 8; edge *= 2){
        result = [];
        prev = (0, _utils.getPointAtIndex)(positions, numPoints - 1, size, startIndex, prev);
        prevInside = !(bitCode(prev, bbox) & edge);
        for(let i = 0; i < numPoints; i++){
            p = (0, _utils.getPointAtIndex)(positions, i, size, startIndex, p);
            inside = !(bitCode(p, bbox) & edge);
            if (inside !== prevInside) (0, _utils.push)(result, intersect(prev, p, edge, bbox));
            if (inside) (0, _utils.push)(result, p);
            (0, _utils.copy)(prev, p);
            prevInside = inside;
        }
        positions = result;
        startIndex = 0;
        numPoints = result.length / size;
        if (!numPoints) break;
    }
    return result;
}
function intersect(a, b, edge, bbox, out = []) {
    let t;
    let snap;
    if (edge & 8) {
        t = (bbox[3] - a[1]) / (b[1] - a[1]);
        snap = 3;
    } else if (edge & 4) {
        t = (bbox[1] - a[1]) / (b[1] - a[1]);
        snap = 1;
    } else if (edge & 2) {
        t = (bbox[2] - a[0]) / (b[0] - a[0]);
        snap = 2;
    } else if (edge & 1) {
        t = (bbox[0] - a[0]) / (b[0] - a[0]);
        snap = 0;
    } else return null;
    for(let i = 0; i < a.length; i++)out[i] = (snap & 1) === i ? bbox[snap] : t * (b[i] - a[i]) + a[i];
    return out;
}
function bitCode(p, bbox) {
    let code = 0;
    if (p[0] < bbox[0]) code |= 1;
    else if (p[0] > bbox[2]) code |= 2;
    if (p[1] < bbox[1]) code |= 4;
    else if (p[1] > bbox[3]) code |= 8;
    return code;
}

},{"./utils":"2C9IL","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2C9IL":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "push", ()=>push);
parcelHelpers.export(exports, "copy", ()=>copy);
parcelHelpers.export(exports, "getPointAtIndex", ()=>getPointAtIndex);
function push(target, source) {
    const size = source.length;
    const startIndex = target.length;
    if (startIndex > 0) {
        let isDuplicate = true;
        for(let i = 0; i < size; i++)if (target[startIndex - size + i] !== source[i]) {
            isDuplicate = false;
            break;
        }
        if (isDuplicate) return false;
    }
    for(let i1 = 0; i1 < size; i1++)target[startIndex + i1] = source[i1];
    return true;
}
function copy(target, source) {
    const size = source.length;
    for(let i = 0; i < size; i++)target[i] = source[i];
}
function getPointAtIndex(positions, index, size, offset, out = []) {
    const startI = offset + index * size;
    for(let i = 0; i < size; i++)out[i] = positions[startI + i];
    return out;
}

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9XQwf":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "cutPolylineByGrid", ()=>cutPolylineByGrid);
parcelHelpers.export(exports, "cutPolygonByGrid", ()=>cutPolygonByGrid);
var _lineclip = require("./lineclip");
var _utils = require("./utils");
function cutPolylineByGrid(positions, options) {
    const { size =2 , broken =false , gridResolution =10 , gridOffset =[
        0,
        0
    ] , startIndex =0 , endIndex =positions.length  } = options || {};
    const numPoints = (endIndex - startIndex) / size;
    let part = [];
    const result = [
        part
    ];
    const a = (0, _utils.getPointAtIndex)(positions, 0, size, startIndex);
    let b;
    let codeB;
    const cell = getGridCell(a, gridResolution, gridOffset, []);
    const scratchPoint = [];
    (0, _utils.push)(part, a);
    for(let i = 1; i < numPoints; i++){
        b = (0, _utils.getPointAtIndex)(positions, i, size, startIndex, b);
        codeB = (0, _lineclip.bitCode)(b, cell);
        while(codeB){
            (0, _lineclip.intersect)(a, b, codeB, cell, scratchPoint);
            const codeAlt = (0, _lineclip.bitCode)(scratchPoint, cell);
            if (codeAlt) {
                (0, _lineclip.intersect)(a, scratchPoint, codeAlt, cell, scratchPoint);
                codeB = codeAlt;
            }
            (0, _utils.push)(part, scratchPoint);
            (0, _utils.copy)(a, scratchPoint);
            moveToNeighborCell(cell, gridResolution, codeB);
            if (broken && part.length > size) {
                part = [];
                result.push(part);
                (0, _utils.push)(part, a);
            }
            codeB = (0, _lineclip.bitCode)(b, cell);
        }
        (0, _utils.push)(part, b);
        (0, _utils.copy)(a, b);
    }
    return broken ? result : result[0];
}
const TYPE_INSIDE = 0;
const TYPE_BORDER = 1;
function concatInPlace(arr1, arr2) {
    for(let i = 0; i < arr2.length; i++)arr1.push(arr2[i]);
    return arr1;
}
function cutPolygonByGrid(positions, holeIndices = null, options) {
    if (!positions.length) return [];
    const { size =2 , gridResolution =10 , gridOffset =[
        0,
        0
    ] , edgeTypes =false  } = options || {};
    const result = [];
    const queue = [
        {
            pos: positions,
            types: edgeTypes ? new Array(positions.length / size).fill(TYPE_BORDER) : null,
            holes: holeIndices || []
        }
    ];
    const bbox = [
        [],
        []
    ];
    let cell = [];
    while(queue.length){
        const { pos , types , holes  } = queue.shift();
        getBoundingBox(pos, size, holes[0] || pos.length, bbox);
        cell = getGridCell(bbox[0], gridResolution, gridOffset, cell);
        const code = (0, _lineclip.bitCode)(bbox[1], cell);
        if (code) {
            let parts = bisectPolygon(pos, types, size, 0, holes[0] || pos.length, cell, code);
            const polygonLow = {
                pos: parts[0].pos,
                types: parts[0].types,
                holes: []
            };
            const polygonHigh = {
                pos: parts[1].pos,
                types: parts[1].types,
                holes: []
            };
            queue.push(polygonLow, polygonHigh);
            for(let i = 0; i < holes.length; i++){
                parts = bisectPolygon(pos, types, size, holes[i], holes[i + 1] || pos.length, cell, code);
                if (parts[0]) {
                    polygonLow.holes.push(polygonLow.pos.length);
                    polygonLow.pos = concatInPlace(polygonLow.pos, parts[0].pos);
                    if (edgeTypes) polygonLow.types = concatInPlace(polygonLow.types, parts[0].types);
                }
                if (parts[1]) {
                    polygonHigh.holes.push(polygonHigh.pos.length);
                    polygonHigh.pos = concatInPlace(polygonHigh.pos, parts[1].pos);
                    if (edgeTypes) polygonHigh.types = concatInPlace(polygonHigh.types, parts[1].types);
                }
            }
        } else {
            const polygon = {
                positions: pos
            };
            if (edgeTypes) polygon.edgeTypes = types;
            if (holes.length) polygon.holeIndices = holes;
            result.push(polygon);
        }
    }
    return result;
}
function bisectPolygon(positions, edgeTypes, size, startIndex, endIndex, bbox, edge) {
    const numPoints = (endIndex - startIndex) / size;
    const resultLow = [];
    const resultHigh = [];
    const typesLow = [];
    const typesHigh = [];
    const scratchPoint = [];
    let p;
    let side;
    let type;
    const prev = (0, _utils.getPointAtIndex)(positions, numPoints - 1, size, startIndex);
    let prevSide = Math.sign(edge & 8 ? prev[1] - bbox[3] : prev[0] - bbox[2]);
    let prevType = edgeTypes && edgeTypes[numPoints - 1];
    let lowPointCount = 0;
    let highPointCount = 0;
    for(let i = 0; i < numPoints; i++){
        p = (0, _utils.getPointAtIndex)(positions, i, size, startIndex, p);
        side = Math.sign(edge & 8 ? p[1] - bbox[3] : p[0] - bbox[2]);
        type = edgeTypes && edgeTypes[startIndex / size + i];
        if (side && prevSide && prevSide !== side) {
            (0, _lineclip.intersect)(prev, p, edge, bbox, scratchPoint);
            (0, _utils.push)(resultLow, scratchPoint) && typesLow.push(prevType);
            (0, _utils.push)(resultHigh, scratchPoint) && typesHigh.push(prevType);
        }
        if (side <= 0) {
            (0, _utils.push)(resultLow, p) && typesLow.push(type);
            lowPointCount -= side;
        } else if (typesLow.length) typesLow[typesLow.length - 1] = TYPE_INSIDE;
        if (side >= 0) {
            (0, _utils.push)(resultHigh, p) && typesHigh.push(type);
            highPointCount += side;
        } else if (typesHigh.length) typesHigh[typesHigh.length - 1] = TYPE_INSIDE;
        (0, _utils.copy)(prev, p);
        prevSide = side;
        prevType = type;
    }
    return [
        lowPointCount ? {
            pos: resultLow,
            types: edgeTypes && typesLow
        } : null,
        highPointCount ? {
            pos: resultHigh,
            types: edgeTypes && typesHigh
        } : null
    ];
}
function getGridCell(p, gridResolution, gridOffset, out) {
    const left = Math.floor((p[0] - gridOffset[0]) / gridResolution) * gridResolution + gridOffset[0];
    const bottom = Math.floor((p[1] - gridOffset[1]) / gridResolution) * gridResolution + gridOffset[1];
    out[0] = left;
    out[1] = bottom;
    out[2] = left + gridResolution;
    out[3] = bottom + gridResolution;
    return out;
}
function moveToNeighborCell(cell, gridResolution, edge) {
    if (edge & 8) {
        cell[1] += gridResolution;
        cell[3] += gridResolution;
    } else if (edge & 4) {
        cell[1] -= gridResolution;
        cell[3] -= gridResolution;
    } else if (edge & 2) {
        cell[0] += gridResolution;
        cell[2] += gridResolution;
    } else if (edge & 1) {
        cell[0] -= gridResolution;
        cell[2] -= gridResolution;
    }
}
function getBoundingBox(positions, size, endIndex, out) {
    let minX = Infinity;
    let maxX = -Infinity;
    let minY = Infinity;
    let maxY = -Infinity;
    for(let i = 0; i < endIndex; i += size){
        const x = positions[i];
        const y = positions[i + 1];
        minX = x < minX ? x : minX;
        maxX = x > maxX ? x : maxX;
        minY = y < minY ? y : minY;
        maxY = y > maxY ? y : maxY;
    }
    out[0][0] = minX;
    out[0][1] = minY;
    out[1][0] = maxX;
    out[1][1] = maxY;
    return out;
}

},{"./lineclip":"20F7m","./utils":"2C9IL","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jAokH":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "cutPolylineByMercatorBounds", ()=>cutPolylineByMercatorBounds);
parcelHelpers.export(exports, "cutPolygonByMercatorBounds", ()=>cutPolygonByMercatorBounds);
var _cutByGrid = require("./cut-by-grid");
var _utils = require("./utils");
const DEFAULT_MAX_LATITUDE = 85.051129;
function cutPolylineByMercatorBounds(positions, options) {
    const { size =2 , startIndex =0 , endIndex =positions.length , normalize =true  } = options || {};
    const newPositions = positions.slice(startIndex, endIndex);
    wrapLongitudesForShortestPath(newPositions, size, 0, endIndex - startIndex);
    const parts = (0, _cutByGrid.cutPolylineByGrid)(newPositions, {
        size,
        broken: true,
        gridResolution: 360,
        gridOffset: [
            -180,
            -180
        ]
    });
    if (normalize) for (const part of parts)shiftLongitudesIntoRange(part, size);
    return parts;
}
function cutPolygonByMercatorBounds(positions, holeIndices = null, options) {
    const { size =2 , normalize =true , edgeTypes =false  } = options || {};
    holeIndices = holeIndices || [];
    const newPositions = [];
    const newHoleIndices = [];
    let srcStartIndex = 0;
    let targetIndex = 0;
    for(let ringIndex = 0; ringIndex <= holeIndices.length; ringIndex++){
        const srcEndIndex = holeIndices[ringIndex] || positions.length;
        const targetStartIndex = targetIndex;
        const splitIndex = findSplitIndex(positions, size, srcStartIndex, srcEndIndex);
        for(let i = splitIndex; i < srcEndIndex; i++)newPositions[targetIndex++] = positions[i];
        for(let i1 = srcStartIndex; i1 < splitIndex; i1++)newPositions[targetIndex++] = positions[i1];
        wrapLongitudesForShortestPath(newPositions, size, targetStartIndex, targetIndex);
        insertPoleVertices(newPositions, size, targetStartIndex, targetIndex, options === null || options === void 0 ? void 0 : options.maxLatitude);
        srcStartIndex = srcEndIndex;
        newHoleIndices[ringIndex] = targetIndex;
    }
    newHoleIndices.pop();
    const parts = (0, _cutByGrid.cutPolygonByGrid)(newPositions, newHoleIndices, {
        size,
        gridResolution: 360,
        gridOffset: [
            -180,
            -180
        ],
        edgeTypes
    });
    if (normalize) for (const part of parts)shiftLongitudesIntoRange(part.positions, size);
    return parts;
}
function findSplitIndex(positions, size, startIndex, endIndex) {
    let maxLat = -1;
    let pointIndex = -1;
    for(let i = startIndex + 1; i < endIndex; i += size){
        const lat = Math.abs(positions[i]);
        if (lat > maxLat) {
            maxLat = lat;
            pointIndex = i - 1;
        }
    }
    return pointIndex;
}
function insertPoleVertices(positions, size, startIndex, endIndex, maxLatitude = DEFAULT_MAX_LATITUDE) {
    const firstLng = positions[startIndex];
    const lastLng = positions[endIndex - size];
    if (Math.abs(firstLng - lastLng) > 180) {
        const p = (0, _utils.getPointAtIndex)(positions, 0, size, startIndex);
        p[0] += Math.round((lastLng - firstLng) / 360) * 360;
        (0, _utils.push)(positions, p);
        p[1] = Math.sign(p[1]) * maxLatitude;
        (0, _utils.push)(positions, p);
        p[0] = firstLng;
        (0, _utils.push)(positions, p);
    }
}
function wrapLongitudesForShortestPath(positions, size, startIndex, endIndex) {
    let prevLng = positions[0];
    let lng;
    for(let i = startIndex; i < endIndex; i += size){
        lng = positions[i];
        const delta = lng - prevLng;
        if (delta > 180 || delta < -180) lng -= Math.round(delta / 360) * 360;
        positions[i] = prevLng = lng;
    }
}
function shiftLongitudesIntoRange(positions, size) {
    let refLng;
    const pointCount = positions.length / size;
    for(let i = 0; i < pointCount; i++){
        refLng = positions[i * size];
        if ((refLng + 180) % 360 !== 0) break;
    }
    const delta = -Math.round(refLng / 360) * 360;
    if (delta === 0) return;
    for(let i1 = 0; i1 < pointCount; i1++)positions[i1 * size] += delta;
}

},{"./cut-by-grid":"9XQwf","./utils":"2C9IL","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"iRSN8":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _solidPolygonLayerVertexMainGlsl = require("./solid-polygon-layer-vertex-main.glsl");
var _solidPolygonLayerVertexMainGlslDefault = parcelHelpers.interopDefault(_solidPolygonLayerVertexMainGlsl);
exports.default = "#define SHADER_NAME solid-polygon-layer-vertex-shader\n\nattribute vec3 positions;\nattribute vec3 positions64Low;\nattribute float elevations;\nattribute vec4 fillColors;\nattribute vec4 lineColors;\nattribute vec3 pickingColors;\n\n".concat((0, _solidPolygonLayerVertexMainGlslDefault.default), "\n\nvoid main(void) {\n  PolygonProps props;\n\n  props.positions = positions;\n  props.positions64Low = positions64Low;\n  props.elevations = elevations;\n  props.fillColors = fillColors;\n  props.lineColors = lineColors;\n  props.pickingColors = pickingColors;\n\n  calculatePosition(props);\n}\n");

},{"./solid-polygon-layer-vertex-main.glsl":"jSCvJ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"jSCvJ":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "\nattribute vec2 vertexPositions;\nattribute float vertexValid;\n\nuniform bool extruded;\nuniform bool isWireframe;\nuniform float elevationScale;\nuniform float opacity;\n\nvarying vec4 vColor;\n\nstruct PolygonProps {\n  vec4 fillColors;\n  vec4 lineColors;\n  vec3 positions;\n  vec3 nextPositions;\n  vec3 pickingColors;\n  vec3 positions64Low;\n  vec3 nextPositions64Low;\n  float elevations;\n};\n\nvec3 project_offset_normal(vec3 vector) {\n  if (project_uCoordinateSystem == COORDINATE_SYSTEM_LNGLAT ||\n    project_uCoordinateSystem == COORDINATE_SYSTEM_LNGLAT_OFFSETS) {\n    // normals generated by the polygon tesselator are in lnglat offsets instead of meters\n    return normalize(vector * project_uCommonUnitsPerWorldUnit);\n  }\n  return project_normal(vector);\n}\n\nvoid calculatePosition(PolygonProps props) {\n#ifdef IS_SIDE_VERTEX\n  if(vertexValid < 0.5){\n    gl_Position = vec4(0.);\n    return;\n  }\n#endif\n\n  vec3 pos;\n  vec3 pos64Low;\n  vec3 normal;\n  vec4 colors = isWireframe ? props.lineColors : props.fillColors;\n\n  geometry.worldPosition = props.positions;\n  geometry.worldPositionAlt = props.nextPositions;\n  geometry.pickingColor = props.pickingColors;\n\n#ifdef IS_SIDE_VERTEX\n  pos = mix(props.positions, props.nextPositions, vertexPositions.x);\n  pos64Low = mix(props.positions64Low, props.nextPositions64Low, vertexPositions.x);\n#else\n  pos = props.positions;\n  pos64Low = props.positions64Low;\n#endif\n\n  if (extruded) {\n    pos.z += props.elevations * vertexPositions.y * elevationScale;\n  }\n  gl_Position = project_position_to_clipspace(pos, pos64Low, vec3(0.), geometry.position);\n\n  DECKGL_FILTER_GL_POSITION(gl_Position, geometry);\n\n  if (extruded) {\n  #ifdef IS_SIDE_VERTEX\n    normal = vec3(\n      props.positions.y - props.nextPositions.y + (props.positions64Low.y - props.nextPositions64Low.y),\n      props.nextPositions.x - props.positions.x + (props.nextPositions64Low.x - props.positions64Low.x),\n      0.0);\n    normal = project_offset_normal(normal);\n  #else\n    normal = project_normal(vec3(0.0, 0.0, 1.0));\n  #endif\n    geometry.normal = normal;\n    vec3 lightColor = lighting_getLightColor(colors.rgb, project_uCameraPosition, geometry.position.xyz, normal);\n    vColor = vec4(lightColor, colors.a * opacity);\n  } else {\n    vColor = vec4(colors.rgb, colors.a * opacity);\n  }\n  DECKGL_FILTER_COLOR(vColor, geometry);\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"floZw":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _solidPolygonLayerVertexMainGlsl = require("./solid-polygon-layer-vertex-main.glsl");
var _solidPolygonLayerVertexMainGlslDefault = parcelHelpers.interopDefault(_solidPolygonLayerVertexMainGlsl);
exports.default = "#define SHADER_NAME solid-polygon-layer-vertex-shader-side\n#define IS_SIDE_VERTEX\n\n\nattribute vec3 instancePositions;\nattribute vec3 nextPositions;\nattribute vec3 instancePositions64Low;\nattribute vec3 nextPositions64Low;\nattribute float instanceElevations;\nattribute vec4 instanceFillColors;\nattribute vec4 instanceLineColors;\nattribute vec3 instancePickingColors;\n\n".concat((0, _solidPolygonLayerVertexMainGlslDefault.default), "\n\nvoid main(void) {\n  PolygonProps props;\n\n  #if RING_WINDING_ORDER_CW == 1\n    props.positions = instancePositions;\n    props.positions64Low = instancePositions64Low;\n    props.nextPositions = nextPositions;\n    props.nextPositions64Low = nextPositions64Low;\n  #else\n    props.positions = nextPositions;\n    props.positions64Low = nextPositions64Low;\n    props.nextPositions = instancePositions;\n    props.nextPositions64Low = instancePositions64Low;\n  #endif\n  props.elevations = instanceElevations;\n  props.fillColors = instanceFillColors;\n  props.lineColors = instanceLineColors;\n  props.pickingColors = instancePickingColors;\n\n  calculatePosition(props);\n}\n");

},{"./solid-polygon-layer-vertex-main.glsl":"jSCvJ","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"bDvSI":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "#define SHADER_NAME solid-polygon-layer-fragment-shader\n\nprecision highp float;\n\nvarying vec4 vColor;\n\nvoid main(void) {\n  gl_FragColor = vColor;\n\n  DECKGL_FILTER_COLOR(gl_FragColor, geometry);\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"kUQVe":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _defineProperty = require("@babel/runtime/helpers/esm/defineProperty");
var _definePropertyDefault = parcelHelpers.interopDefault(_defineProperty);
var _core = require("@deck.gl/core");
var _core1 = require("@luma.gl/core");
var _pathTesselator = require("./path-tesselator");
var _pathTesselatorDefault = parcelHelpers.interopDefault(_pathTesselator);
var _pathLayerVertexGlsl = require("./path-layer-vertex.glsl");
var _pathLayerVertexGlslDefault = parcelHelpers.interopDefault(_pathLayerVertexGlsl);
var _pathLayerFragmentGlsl = require("./path-layer-fragment.glsl");
var _pathLayerFragmentGlslDefault = parcelHelpers.interopDefault(_pathLayerFragmentGlsl);
const DEFAULT_COLOR = [
    0,
    0,
    0,
    255
];
const defaultProps = {
    widthUnits: "meters",
    widthScale: {
        type: "number",
        min: 0,
        value: 1
    },
    widthMinPixels: {
        type: "number",
        min: 0,
        value: 0
    },
    widthMaxPixels: {
        type: "number",
        min: 0,
        value: Number.MAX_SAFE_INTEGER
    },
    jointRounded: false,
    capRounded: false,
    miterLimit: {
        type: "number",
        min: 0,
        value: 4
    },
    billboard: false,
    _pathType: null,
    getPath: {
        type: "accessor",
        value: (object)=>object.path
    },
    getColor: {
        type: "accessor",
        value: DEFAULT_COLOR
    },
    getWidth: {
        type: "accessor",
        value: 1
    },
    rounded: {
        deprecatedFor: [
            "jointRounded",
            "capRounded"
        ]
    }
};
const ATTRIBUTE_TRANSITION = {
    enter: (value, chunk)=>{
        return chunk.length ? chunk.subarray(chunk.length - value.length) : value;
    }
};
class PathLayer extends (0, _core.Layer) {
    constructor(...args){
        super(...args);
        (0, _definePropertyDefault.default)(this, "state", void 0);
    }
    getShaders() {
        return super.getShaders({
            vs: (0, _pathLayerVertexGlslDefault.default),
            fs: (0, _pathLayerFragmentGlslDefault.default),
            modules: [
                (0, _core.project32),
                (0, _core.picking)
            ]
        });
    }
    get wrapLongitude() {
        return false;
    }
    initializeState() {
        const noAlloc = true;
        const attributeManager = this.getAttributeManager();
        attributeManager.addInstanced({
            positions: {
                size: 3,
                vertexOffset: 1,
                type: 5130,
                fp64: this.use64bitPositions(),
                transition: ATTRIBUTE_TRANSITION,
                accessor: "getPath",
                update: this.calculatePositions,
                noAlloc,
                shaderAttributes: {
                    instanceLeftPositions: {
                        vertexOffset: 0
                    },
                    instanceStartPositions: {
                        vertexOffset: 1
                    },
                    instanceEndPositions: {
                        vertexOffset: 2
                    },
                    instanceRightPositions: {
                        vertexOffset: 3
                    }
                }
            },
            instanceTypes: {
                size: 1,
                type: 5121,
                update: this.calculateSegmentTypes,
                noAlloc
            },
            instanceStrokeWidths: {
                size: 1,
                accessor: "getWidth",
                transition: ATTRIBUTE_TRANSITION,
                defaultValue: 1
            },
            instanceColors: {
                size: this.props.colorFormat.length,
                type: 5121,
                normalized: true,
                accessor: "getColor",
                transition: ATTRIBUTE_TRANSITION,
                defaultValue: DEFAULT_COLOR
            },
            instancePickingColors: {
                size: 3,
                type: 5121,
                accessor: (object, { index , target: value  })=>this.encodePickingColor(object && object.__source ? object.__source.index : index, value)
            }
        });
        this.setState({
            pathTesselator: new (0, _pathTesselatorDefault.default)({
                fp64: this.use64bitPositions()
            })
        });
    }
    updateState(params) {
        super.updateState(params);
        const { props , changeFlags  } = params;
        const attributeManager = this.getAttributeManager();
        const geometryChanged = changeFlags.dataChanged || changeFlags.updateTriggersChanged && (changeFlags.updateTriggersChanged.all || changeFlags.updateTriggersChanged.getPath);
        if (geometryChanged) {
            const { pathTesselator  } = this.state;
            const buffers = props.data.attributes || {};
            pathTesselator.updateGeometry({
                data: props.data,
                geometryBuffer: buffers.getPath,
                buffers,
                normalize: !props._pathType,
                loop: props._pathType === "loop",
                getGeometry: props.getPath,
                positionFormat: props.positionFormat,
                wrapLongitude: props.wrapLongitude,
                resolution: this.context.viewport.resolution,
                dataChanged: changeFlags.dataChanged
            });
            this.setState({
                numInstances: pathTesselator.instanceCount,
                startIndices: pathTesselator.vertexStarts
            });
            if (!changeFlags.dataChanged) attributeManager.invalidateAll();
        }
        if (changeFlags.extensionsChanged) {
            var _this$state$model;
            const { gl  } = this.context;
            (_this$state$model = this.state.model) === null || _this$state$model === void 0 || _this$state$model.delete();
            this.state.model = this._getModel(gl);
            attributeManager.invalidateAll();
        }
    }
    getPickingInfo(params) {
        const info = super.getPickingInfo(params);
        const { index  } = info;
        const { data  } = this.props;
        if (data[0] && data[0].__source) info.object = data.find((d)=>d.__source.index === index);
        return info;
    }
    disablePickingIndex(objectIndex) {
        const { data  } = this.props;
        if (data[0] && data[0].__source) {
            for(let i = 0; i < data.length; i++)if (data[i].__source.index === objectIndex) this._disablePickingIndex(i);
        } else this._disablePickingIndex(objectIndex);
    }
    draw({ uniforms  }) {
        const { jointRounded , capRounded , billboard , miterLimit , widthUnits , widthScale , widthMinPixels , widthMaxPixels  } = this.props;
        this.state.model.setUniforms(uniforms).setUniforms({
            jointType: Number(jointRounded),
            capType: Number(capRounded),
            billboard,
            widthUnits: (0, _core.UNIT)[widthUnits],
            widthScale,
            miterLimit,
            widthMinPixels,
            widthMaxPixels
        }).draw();
    }
    _getModel(gl) {
        const SEGMENT_INDICES = [
            0,
            1,
            2,
            1,
            4,
            2,
            1,
            3,
            4,
            3,
            5,
            4
        ];
        const SEGMENT_POSITIONS = [
            0,
            0,
            0,
            -1,
            0,
            1,
            1,
            -1,
            1,
            1,
            1,
            0
        ];
        return new (0, _core1.Model)(gl, {
            ...this.getShaders(),
            id: this.props.id,
            geometry: new (0, _core1.Geometry)({
                drawMode: 4,
                attributes: {
                    indices: new Uint16Array(SEGMENT_INDICES),
                    positions: {
                        value: new Float32Array(SEGMENT_POSITIONS),
                        size: 2
                    }
                }
            }),
            isInstanced: true
        });
    }
    calculatePositions(attribute) {
        const { pathTesselator  } = this.state;
        attribute.startIndices = pathTesselator.vertexStarts;
        attribute.value = pathTesselator.get("positions");
    }
    calculateSegmentTypes(attribute) {
        const { pathTesselator  } = this.state;
        attribute.startIndices = pathTesselator.vertexStarts;
        attribute.value = pathTesselator.get("segmentTypes");
    }
}
exports.default = PathLayer;
(0, _definePropertyDefault.default)(PathLayer, "defaultProps", defaultProps);
(0, _definePropertyDefault.default)(PathLayer, "layerName", "PathLayer");

},{"@babel/runtime/helpers/esm/defineProperty":"hbmCA","@deck.gl/core":"iErGJ","@luma.gl/core":"9yA57","./path-tesselator":"3tg1k","./path-layer-vertex.glsl":"1P1Jk","./path-layer-fragment.glsl":"3cy8K","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3tg1k":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
var _core = require("@deck.gl/core");
var _path = require("./path");
const START_CAP = 1;
const END_CAP = 2;
const INVALID = 4;
class PathTesselator extends (0, _core.Tesselator) {
    constructor(opts){
        super({
            ...opts,
            attributes: {
                positions: {
                    size: 3,
                    padding: 18,
                    initialize: true,
                    type: opts.fp64 ? Float64Array : Float32Array
                },
                segmentTypes: {
                    size: 1,
                    type: Uint8ClampedArray
                }
            }
        });
    }
    get(attributeName) {
        return this.attributes[attributeName];
    }
    getGeometryFromBuffer(buffer) {
        if (this.normalize) return super.getGeometryFromBuffer(buffer);
        return null;
    }
    normalizeGeometry(path) {
        if (this.normalize) return (0, _path.normalizePath)(path, this.positionSize, this.opts.resolution, this.opts.wrapLongitude);
        return path;
    }
    getGeometrySize(path) {
        if (isCut(path)) {
            let size = 0;
            for (const subPath of path)size += this.getGeometrySize(subPath);
            return size;
        }
        const numPoints = this.getPathLength(path);
        if (numPoints < 2) return 0;
        if (this.isClosed(path)) return numPoints < 3 ? 0 : numPoints + 2;
        return numPoints;
    }
    updateGeometryAttributes(path, context) {
        if (context.geometrySize === 0) return;
        if (path && isCut(path)) for (const subPath of path){
            const geometrySize = this.getGeometrySize(subPath);
            context.geometrySize = geometrySize;
            this.updateGeometryAttributes(subPath, context);
            context.vertexStart += geometrySize;
        }
        else {
            this._updateSegmentTypes(path, context);
            this._updatePositions(path, context);
        }
    }
    _updateSegmentTypes(path, context) {
        const segmentTypes = this.attributes.segmentTypes;
        const isPathClosed = path ? this.isClosed(path) : false;
        const { vertexStart , geometrySize  } = context;
        segmentTypes.fill(0, vertexStart, vertexStart + geometrySize);
        if (isPathClosed) {
            segmentTypes[vertexStart] = INVALID;
            segmentTypes[vertexStart + geometrySize - 2] = INVALID;
        } else {
            segmentTypes[vertexStart] += START_CAP;
            segmentTypes[vertexStart + geometrySize - 2] += END_CAP;
        }
        segmentTypes[vertexStart + geometrySize - 1] = INVALID;
    }
    _updatePositions(path, context) {
        const { positions  } = this.attributes;
        if (!positions || !path) return;
        const { vertexStart , geometrySize  } = context;
        const p = new Array(3);
        for(let i = vertexStart, ptIndex = 0; ptIndex < geometrySize; i++, ptIndex++){
            this.getPointOnPath(path, ptIndex, p);
            positions[i * 3] = p[0];
            positions[i * 3 + 1] = p[1];
            positions[i * 3 + 2] = p[2];
        }
    }
    getPathLength(path) {
        return path.length / this.positionSize;
    }
    getPointOnPath(path, index, target = []) {
        const { positionSize  } = this;
        if (index * positionSize >= path.length) index += 1 - path.length / positionSize;
        const i = index * positionSize;
        target[0] = path[i];
        target[1] = path[i + 1];
        target[2] = positionSize === 3 && path[i + 2] || 0;
        return target;
    }
    isClosed(path) {
        if (!this.normalize) return Boolean(this.opts.loop);
        const { positionSize  } = this;
        const lastPointIndex = path.length - positionSize;
        return path[0] === path[lastPointIndex] && path[1] === path[lastPointIndex + 1] && (positionSize === 2 || path[2] === path[lastPointIndex + 2]);
    }
}
exports.default = PathTesselator;
function isCut(path) {
    return Array.isArray(path[0]);
}

},{"@deck.gl/core":"iErGJ","./path":"2WnCd","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"2WnCd":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "normalizePath", ()=>normalizePath);
var _polygon = require("@math.gl/polygon");
function normalizePath(path, size, gridResolution, wrapLongitude) {
    let flatPath;
    if (Array.isArray(path[0])) {
        const length = path.length * size;
        flatPath = new Array(length);
        for(let i = 0; i < path.length; i++)for(let j = 0; j < size; j++)flatPath[i * size + j] = path[i][j] || 0;
    } else flatPath = path;
    if (gridResolution) return (0, _polygon.cutPolylineByGrid)(flatPath, {
        size,
        gridResolution
    });
    if (wrapLongitude) return (0, _polygon.cutPolylineByMercatorBounds)(flatPath, {
        size
    });
    return flatPath;
}

},{"@math.gl/polygon":"88Ubl","@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"1P1Jk":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "#define SHADER_NAME path-layer-vertex-shader\n\nattribute vec2 positions;\n\nattribute float instanceTypes;\nattribute vec3 instanceStartPositions;\nattribute vec3 instanceEndPositions;\nattribute vec3 instanceLeftPositions;\nattribute vec3 instanceRightPositions;\nattribute vec3 instanceLeftPositions64Low;\nattribute vec3 instanceStartPositions64Low;\nattribute vec3 instanceEndPositions64Low;\nattribute vec3 instanceRightPositions64Low;\nattribute float instanceStrokeWidths;\nattribute vec4 instanceColors;\nattribute vec3 instancePickingColors;\n\nuniform float widthScale;\nuniform float widthMinPixels;\nuniform float widthMaxPixels;\nuniform float jointType;\nuniform float capType;\nuniform float miterLimit;\nuniform bool billboard;\nuniform int widthUnits;\n\nuniform float opacity;\n\nvarying vec4 vColor;\nvarying vec2 vCornerOffset;\nvarying float vMiterLength;\nvarying vec2 vPathPosition;\nvarying float vPathLength;\nvarying float vJointType;\n\nconst float EPSILON = 0.001;\nconst vec3 ZERO_OFFSET = vec3(0.0);\n\nfloat flipIfTrue(bool flag) {\n  return -(float(flag) * 2. - 1.);\n}\n\n// calculate line join positions\nvec3 lineJoin(\n  vec3 prevPoint, vec3 currPoint, vec3 nextPoint,\n  vec2 width\n) {\n  bool isEnd = positions.x > 0.0;\n  // side of the segment - -1: left, 0: center, 1: right\n  float sideOfPath = positions.y;\n  float isJoint = float(sideOfPath == 0.0);\n\n  vec3 deltaA3 = (currPoint - prevPoint);\n  vec3 deltaB3 = (nextPoint - currPoint);\n\n  mat3 rotationMatrix;\n  bool needsRotation = !billboard && project_needs_rotation(currPoint, rotationMatrix);\n  if (needsRotation) {\n    deltaA3 = deltaA3 * rotationMatrix;\n    deltaB3 = deltaB3 * rotationMatrix;\n  }\n  vec2 deltaA = deltaA3.xy / width;\n  vec2 deltaB = deltaB3.xy / width;\n\n  float lenA = length(deltaA);\n  float lenB = length(deltaB);\n\n  vec2 dirA = lenA > 0. ? normalize(deltaA) : vec2(0.0, 0.0);\n  vec2 dirB = lenB > 0. ? normalize(deltaB) : vec2(0.0, 0.0);\n\n  vec2 perpA = vec2(-dirA.y, dirA.x);\n  vec2 perpB = vec2(-dirB.y, dirB.x);\n\n  // tangent of the corner\n  vec2 tangent = dirA + dirB;\n  tangent = length(tangent) > 0. ? normalize(tangent) : perpA;\n  // direction of the corner\n  vec2 miterVec = vec2(-tangent.y, tangent.x);\n  // direction of the segment\n  vec2 dir = isEnd ? dirA : dirB;\n  // direction of the extrusion\n  vec2 perp = isEnd ? perpA : perpB;\n  // length of the segment\n  float L = isEnd ? lenA : lenB;\n\n  // A = angle of the corner\n  float sinHalfA = abs(dot(miterVec, perp));\n  float cosHalfA = abs(dot(dirA, miterVec));\n\n  // -1: right, 1: left\n  float turnDirection = flipIfTrue(dirA.x * dirB.y >= dirA.y * dirB.x);\n\n  // relative position to the corner:\n  // -1: inside (smaller side of the angle)\n  // 0: center\n  // 1: outside (bigger side of the angle)\n  float cornerPosition = sideOfPath * turnDirection;\n\n  float miterSize = 1.0 / max(sinHalfA, EPSILON);\n  // trim if inside corner extends further than the line segment\n  miterSize = mix(\n    min(miterSize, max(lenA, lenB) / max(cosHalfA, EPSILON)),\n    miterSize,\n    step(0.0, cornerPosition)\n  );\n\n  vec2 offsetVec = mix(miterVec * miterSize, perp, step(0.5, cornerPosition))\n    * (sideOfPath + isJoint * turnDirection);\n\n  // special treatment for start cap and end cap\n  bool isStartCap = lenA == 0.0 || (!isEnd && (instanceTypes == 1.0 || instanceTypes == 3.0));\n  bool isEndCap = lenB == 0.0 || (isEnd && (instanceTypes == 2.0 || instanceTypes == 3.0));\n  bool isCap = isStartCap || isEndCap;\n\n  // extend out a triangle to envelope the round cap\n  if (isCap) {\n    offsetVec = mix(perp * sideOfPath, dir * capType * 4.0 * flipIfTrue(isStartCap), isJoint);\n    vJointType = capType;\n  } else {\n    vJointType = jointType;\n  }\n\n  // Generate variables for fragment shader\n  vPathLength = L;\n  vCornerOffset = offsetVec;\n  vMiterLength = dot(vCornerOffset, miterVec * turnDirection);\n  vMiterLength = isCap ? isJoint : vMiterLength;\n\n  vec2 offsetFromStartOfPath = vCornerOffset + deltaA * float(isEnd);\n  vPathPosition = vec2(\n    dot(offsetFromStartOfPath, perp),\n    dot(offsetFromStartOfPath, dir)\n  );\n  geometry.uv = vPathPosition;\n\n  float isValid = step(instanceTypes, 3.5);\n  vec3 offset = vec3(offsetVec * width * isValid, 0.0);\n\n  if (needsRotation) {\n    offset = rotationMatrix * offset;\n  }\n  return currPoint + offset;\n}\n\n// In clipspace extrusion, if a line extends behind the camera, clip it to avoid visual artifacts\nvoid clipLine(inout vec4 position, vec4 refPosition) {\n  if (position.w < EPSILON) {\n    float r = (EPSILON - refPosition.w) / (position.w - refPosition.w);\n    position = refPosition + (position - refPosition) * r;\n  }\n}\n\nvoid main() {\n  geometry.pickingColor = instancePickingColors;\n\n  vColor = vec4(instanceColors.rgb, instanceColors.a * opacity);\n\n  float isEnd = positions.x;\n\n  vec3 prevPosition = mix(instanceLeftPositions, instanceStartPositions, isEnd);\n  vec3 prevPosition64Low = mix(instanceLeftPositions64Low, instanceStartPositions64Low, isEnd);\n\n  vec3 currPosition = mix(instanceStartPositions, instanceEndPositions, isEnd);\n  vec3 currPosition64Low = mix(instanceStartPositions64Low, instanceEndPositions64Low, isEnd);\n\n  vec3 nextPosition = mix(instanceEndPositions, instanceRightPositions, isEnd);\n  vec3 nextPosition64Low = mix(instanceEndPositions64Low, instanceRightPositions64Low, isEnd);\n\n  geometry.worldPosition = currPosition;\n  vec2 widthPixels = vec2(clamp(\n    project_size_to_pixel(instanceStrokeWidths * widthScale, widthUnits),\n    widthMinPixels, widthMaxPixels) / 2.0);\n  vec3 width;\n\n  if (billboard) {\n    // Extrude in clipspace\n    vec4 prevPositionScreen = project_position_to_clipspace(prevPosition, prevPosition64Low, ZERO_OFFSET);\n    vec4 currPositionScreen = project_position_to_clipspace(currPosition, currPosition64Low, ZERO_OFFSET, geometry.position);\n    vec4 nextPositionScreen = project_position_to_clipspace(nextPosition, nextPosition64Low, ZERO_OFFSET);\n\n    clipLine(prevPositionScreen, currPositionScreen);\n    clipLine(nextPositionScreen, currPositionScreen);\n    clipLine(currPositionScreen, mix(nextPositionScreen, prevPositionScreen, isEnd));\n\n    width = vec3(widthPixels, 0.0);\n    DECKGL_FILTER_SIZE(width, geometry);\n\n    vec3 pos = lineJoin(\n      prevPositionScreen.xyz / prevPositionScreen.w,\n      currPositionScreen.xyz / currPositionScreen.w,\n      nextPositionScreen.xyz / nextPositionScreen.w,\n      project_pixel_size_to_clipspace(width.xy)\n    );\n\n    gl_Position = vec4(pos * currPositionScreen.w, currPositionScreen.w);\n  } else {\n    // Extrude in commonspace\n    prevPosition = project_position(prevPosition, prevPosition64Low);\n    currPosition = project_position(currPosition, currPosition64Low);\n    nextPosition = project_position(nextPosition, nextPosition64Low);\n\n    width = vec3(project_pixel_size(widthPixels), 0.0);\n    DECKGL_FILTER_SIZE(width, geometry);\n\n    vec4 pos = vec4(\n      lineJoin(prevPosition, currPosition, nextPosition, width.xy),\n      1.0);\n    geometry.position = pos;\n    gl_Position = project_common_position_to_clipspace(pos);\n  }\n  DECKGL_FILTER_GL_POSITION(gl_Position, geometry);\n  DECKGL_FILTER_COLOR(vColor, geometry);\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"3cy8K":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
exports.default = "#define SHADER_NAME path-layer-fragment-shader\n\nprecision highp float;\n\nuniform float miterLimit;\n\nvarying vec4 vColor;\nvarying vec2 vCornerOffset;\nvarying float vMiterLength;\n/*\n * vPathPosition represents the relative coordinates of the current fragment on the path segment.\n * vPathPosition.x - position along the width of the path, between [-1, 1]. 0 is the center line.\n * vPathPosition.y - position along the length of the path, between [0, L / width].\n */\nvarying vec2 vPathPosition;\nvarying float vPathLength;\nvarying float vJointType;\n\nvoid main(void) {\n  geometry.uv = vPathPosition;\n\n  if (vPathPosition.y < 0.0 || vPathPosition.y > vPathLength) {\n    // if joint is rounded, test distance from the corner\n    if (vJointType > 0.5 && length(vCornerOffset) > 1.0) {\n      discard;\n    }\n    // trim miter\n    if (vJointType < 0.5 && vMiterLength > miterLimit + 1.0) {\n      discard;\n    }\n  }\n  gl_FragColor = vColor;\n\n  DECKGL_FILTER_COLOR(gl_FragColor, geometry);\n}\n";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"5MP3O":[function(require,module,exports) {
var parcelHelpers = require("@parcel/transformer-js/src/esmodule-helpers.js");
parcelHelpers.defineInteropFlag(exports);
parcelHelpers.export(exports, "MAPBOX_ACCESS_TOKEN", ()=>MAPBOX_ACCESS_TOKEN);
parcelHelpers.export(exports, "ARCGIS_API_KEY", ()=>ARCGIS_API_KEY);
const MAPBOX_ACCESS_TOKEN = "pk.eyJ1IjoiY2hlZWF1biIsImEiOiJjam9weHRuMW4xdXczM3FteTR1OGt3OWxhIn0.I9fgZVxvN_wSJb8soniwpQ";
const ARCGIS_API_KEY = "AAPKabd75694252a4a1885ed1e9daf2c021bnzUEoNoYQafflN6M1AZWT0hk_dHkyPleyOdjBVDSwDoCnX01cNV39nTBWanJHXh-";

},{"@parcel/transformer-js/src/esmodule-helpers.js":"gkKU3"}],"9h2Tj":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("eY1NC") + "../routes.5fea923c.json" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}],"lgJ39":[function(require,module,exports) {
"use strict";
var bundleURL = {};
function getBundleURLCached(id) {
    var value = bundleURL[id];
    if (!value) {
        value = getBundleURL();
        bundleURL[id] = value;
    }
    return value;
}
function getBundleURL() {
    try {
        throw new Error();
    } catch (err) {
        var matches = ("" + err.stack).match(/(https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/[^)\n]+/g);
        if (matches) // The first two stack frames will be this function and getBundleURLCached.
        // Use the 3rd one, which will be a runtime in the original bundle.
        return getBaseURL(matches[2]);
    }
    return "/";
}
function getBaseURL(url) {
    return ("" + url).replace(/^((?:https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/.+)\/[^/]+$/, "$1") + "/";
} // TODO: Replace uses with `new URL(url).origin` when ie11 is no longer supported.
function getOrigin(url) {
    var matches = ("" + url).match(/(https?|file|ftp|(chrome|moz|safari-web)-extension):\/\/[^/]+/);
    if (!matches) throw new Error("Origin not found");
    return matches[0];
}
exports.getBundleURL = getBundleURLCached;
exports.getBaseURL = getBaseURL;
exports.getOrigin = getOrigin;

},{}],"6ctOZ":[function(require,module,exports) {
module.exports = require("./helpers/bundle-url").getBundleURL("eY1NC") + "../stops.3d.0ab2483a.json" + "?" + Date.now();

},{"./helpers/bundle-url":"lgJ39"}]},["gHhew","bHhB8"], "bHhB8", "parcelRequireda9d")

//# sourceMappingURL=index.bc01c452.js.map
